#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 7817
#define LARGE_STATE_COUNT 3941
#define SYMBOL_COUNT 524
#define ALIAS_COUNT 3
#define TOKEN_COUNT 218
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 26
#define MAX_ALIAS_SEQUENCE_LENGTH 15
#define PRODUCTION_ID_COUNT 201

enum ts_symbol_identifiers {
  sym__identifier_token = 1,
  anon_sym_extern = 2,
  anon_sym_alias = 3,
  anon_sym_SEMI = 4,
  anon_sym_global = 5,
  anon_sym_using = 6,
  anon_sym_unsafe = 7,
  anon_sym_EQ = 8,
  anon_sym_static = 9,
  anon_sym_LBRACK = 10,
  anon_sym_assembly = 11,
  anon_sym_module = 12,
  anon_sym_COLON = 13,
  anon_sym_COMMA = 14,
  anon_sym_RBRACK = 15,
  anon_sym_LPAREN = 16,
  anon_sym_RPAREN = 17,
  anon_sym_field = 18,
  anon_sym_event = 19,
  anon_sym_method = 20,
  anon_sym_param = 21,
  anon_sym_property = 22,
  anon_sym_return = 23,
  anon_sym_type = 24,
  anon_sym_typevar = 25,
  anon_sym_namespace = 26,
  anon_sym_class = 27,
  anon_sym_ref = 28,
  anon_sym_struct = 29,
  anon_sym_enum = 30,
  anon_sym_LBRACE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_interface = 33,
  anon_sym_delegate = 34,
  anon_sym_record = 35,
  anon_sym_abstract = 36,
  anon_sym_async = 37,
  anon_sym_const = 38,
  anon_sym_file = 39,
  anon_sym_fixed = 40,
  anon_sym_internal = 41,
  anon_sym_new = 42,
  anon_sym_override = 43,
  anon_sym_partial = 44,
  anon_sym_private = 45,
  anon_sym_protected = 46,
  anon_sym_public = 47,
  anon_sym_readonly = 48,
  anon_sym_required = 49,
  anon_sym_sealed = 50,
  anon_sym_virtual = 51,
  anon_sym_volatile = 52,
  anon_sym_LT = 53,
  anon_sym_GT = 54,
  anon_sym_in = 55,
  anon_sym_out = 56,
  anon_sym_where = 57,
  anon_sym_QMARK = 58,
  anon_sym_notnull = 59,
  anon_sym_unmanaged = 60,
  anon_sym_operator = 61,
  anon_sym_checked = 62,
  anon_sym_BANG = 63,
  anon_sym_TILDE = 64,
  anon_sym_PLUS_PLUS = 65,
  anon_sym_DASH_DASH = 66,
  anon_sym_true = 67,
  anon_sym_false = 68,
  anon_sym_PLUS = 69,
  anon_sym_DASH = 70,
  anon_sym_STAR = 71,
  anon_sym_SLASH = 72,
  anon_sym_PERCENT = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_AMP = 76,
  anon_sym_LT_LT = 77,
  anon_sym_GT_GT = 78,
  anon_sym_GT_GT_GT = 79,
  anon_sym_EQ_EQ = 80,
  anon_sym_BANG_EQ = 81,
  anon_sym_GT_EQ = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_implicit = 84,
  anon_sym_explicit = 85,
  anon_sym_get = 86,
  anon_sym_set = 87,
  anon_sym_add = 88,
  anon_sym_remove = 89,
  anon_sym_init = 90,
  anon_sym_this = 91,
  anon_sym_DOT = 92,
  anon_sym_scoped = 93,
  anon_sym_params = 94,
  anon_sym_base = 95,
  anon_sym_EQ_GT = 96,
  anon_sym_COLON_COLON = 97,
  anon_sym_var = 98,
  anon_sym_managed = 99,
  anon_sym_Cdecl = 100,
  anon_sym_Stdcall = 101,
  anon_sym_Thiscall = 102,
  anon_sym_Fastcall = 103,
  sym_predefined_type = 104,
  anon_sym_break = 105,
  anon_sym_unchecked = 106,
  anon_sym_continue = 107,
  anon_sym_do = 108,
  anon_sym_while = 109,
  anon_sym_for = 110,
  anon_sym_lock = 111,
  anon_sym_yield = 112,
  anon_sym_switch = 113,
  anon_sym_case = 114,
  anon_sym_default = 115,
  anon_sym_throw = 116,
  anon_sym_try = 117,
  anon_sym_catch = 118,
  anon_sym_when = 119,
  anon_sym_finally = 120,
  anon_sym_await = 121,
  anon_sym_foreach = 122,
  anon_sym_goto = 123,
  anon_sym_if = 124,
  anon_sym_else = 125,
  sym_discard = 126,
  anon_sym_DOT_DOT = 127,
  anon_sym_not = 128,
  anon_sym_and = 129,
  anon_sym_or = 130,
  anon_sym_PLUS_EQ = 131,
  anon_sym_DASH_EQ = 132,
  anon_sym_STAR_EQ = 133,
  anon_sym_SLASH_EQ = 134,
  anon_sym_PERCENT_EQ = 135,
  anon_sym_AMP_EQ = 136,
  anon_sym_CARET_EQ = 137,
  anon_sym_PIPE_EQ = 138,
  anon_sym_LT_LT_EQ = 139,
  anon_sym_GT_GT_EQ = 140,
  anon_sym_GT_GT_GT_EQ = 141,
  anon_sym_QMARK_QMARK_EQ = 142,
  anon_sym_AMP_AMP = 143,
  anon_sym_PIPE_PIPE = 144,
  anon_sym_QMARK_QMARK = 145,
  anon_sym_from = 146,
  anon_sym_into = 147,
  anon_sym_join = 148,
  anon_sym_on = 149,
  anon_sym_equals = 150,
  anon_sym_let = 151,
  anon_sym_orderby = 152,
  anon_sym_ascending = 153,
  anon_sym_descending = 154,
  anon_sym_group = 155,
  anon_sym_by = 156,
  anon_sym_select = 157,
  anon_sym_as = 158,
  anon_sym_is = 159,
  aux_sym_interpolation_format_clause_token1 = 160,
  anon_sym_DASH_GT = 161,
  anon_sym_stackalloc = 162,
  anon_sym_with = 163,
  anon_sym_sizeof = 164,
  anon_sym_typeof = 165,
  anon_sym___makeref = 166,
  anon_sym___reftype = 167,
  anon_sym___refvalue = 168,
  sym_null_literal = 169,
  anon_sym_SQUOTE = 170,
  sym_character_literal_content = 171,
  sym_integer_literal = 172,
  sym_real_literal = 173,
  anon_sym_DQUOTE = 174,
  aux_sym_string_literal_content_token1 = 175,
  aux_sym_string_literal_content_token2 = 176,
  sym_escape_sequence = 177,
  sym_string_literal_encoding = 178,
  sym_verbatim_string_literal = 179,
  aux_sym_raw_string_literal_token1 = 180,
  aux_sym_preproc_if_token1 = 181,
  aux_sym_preproc_if_token2 = 182,
  aux_sym_preproc_if_token3 = 183,
  aux_sym_preproc_else_token1 = 184,
  aux_sym_preproc_elif_token1 = 185,
  sym_preproc_arg = 186,
  aux_sym_preproc_region_token1 = 187,
  aux_sym_preproc_endregion_token1 = 188,
  aux_sym_preproc_line_token1 = 189,
  anon_sym_hidden = 190,
  aux_sym_preproc_pragma_token1 = 191,
  anon_sym_warning = 192,
  anon_sym_disable = 193,
  anon_sym_restore = 194,
  anon_sym_checksum = 195,
  aux_sym_preproc_nullable_token1 = 196,
  anon_sym_enable = 197,
  anon_sym_annotations = 198,
  anon_sym_warnings = 199,
  aux_sym_preproc_error_token1 = 200,
  aux_sym_preproc_warning_token1 = 201,
  aux_sym_preproc_define_token1 = 202,
  aux_sym_preproc_undef_token1 = 203,
  sym_shebang_directive = 204,
  sym_comment = 205,
  sym__optional_semi = 206,
  sym_interpolation_regular_start = 207,
  sym_interpolation_verbatim_start = 208,
  sym_interpolation_raw_start = 209,
  sym_interpolation_start_quote = 210,
  sym_interpolation_end_quote = 211,
  sym_interpolation_open_brace = 212,
  sym_interpolation_close_brace = 213,
  sym_interpolation_string_content = 214,
  sym_raw_string_start = 215,
  sym_raw_string_end = 216,
  sym_raw_string_content = 217,
  sym_compilation_unit = 218,
  sym__top_level_item = 219,
  sym_global_statement = 220,
  sym_extern_alias_directive = 221,
  sym_using_directive = 222,
  sym_global_attribute = 223,
  sym_attribute = 224,
  sym_attribute_argument_list = 225,
  sym_attribute_argument = 226,
  sym_attribute_list = 227,
  sym__attribute_list = 228,
  sym_attribute_target_specifier = 229,
  sym_namespace_declaration = 230,
  sym_file_scoped_namespace_declaration = 231,
  sym_type_declaration = 232,
  sym_class_declaration = 233,
  sym__class_declaration_initializer = 234,
  sym_struct_declaration = 235,
  sym__struct_declaration_initializer = 236,
  sym_enum_declaration = 237,
  sym__enum_declaration_initializer = 238,
  sym_enum_member_declaration_list = 239,
  sym_enum_member_declaration = 240,
  sym_interface_declaration = 241,
  sym__interface_declaration_initializer = 242,
  sym_delegate_declaration = 243,
  sym__delegate_declaration_initializer = 244,
  sym_record_declaration = 245,
  sym__record_declaration_initializer = 246,
  sym_record_base = 247,
  sym__declaration_list_body = 248,
  sym_primary_constructor_base_type = 249,
  sym_modifier = 250,
  sym_type_parameter_list = 251,
  sym_type_parameter = 252,
  sym_base_list = 253,
  sym_type_parameter_constraints_clause = 254,
  sym_type_parameter_constraint = 255,
  sym_constructor_constraint = 256,
  sym_operator_declaration = 257,
  sym_conversion_operator_declaration = 258,
  sym_declaration_list = 259,
  sym_declaration = 260,
  sym_field_declaration = 261,
  sym_constructor_declaration = 262,
  sym__constructor_declaration_initializer = 263,
  sym_destructor_declaration = 264,
  sym_method_declaration = 265,
  sym_event_declaration = 266,
  sym_event_field_declaration = 267,
  sym_accessor_list = 268,
  sym_accessor_declaration = 269,
  sym_indexer_declaration = 270,
  sym_bracketed_parameter_list = 271,
  sym_property_declaration = 272,
  sym_explicit_interface_specifier = 273,
  sym_parameter_list = 274,
  sym_parameter = 275,
  sym__parameter_array = 276,
  sym_constructor_initializer = 277,
  sym_argument_list = 278,
  sym_tuple_pattern = 279,
  sym_argument = 280,
  sym_block = 281,
  sym_arrow_expression_clause = 282,
  sym__function_body = 283,
  sym_variable_declaration = 284,
  sym_using_variable_declaration = 285,
  sym_variable_declarator = 286,
  sym_using_variable_declarator = 287,
  sym_bracketed_argument_list = 288,
  sym__name = 289,
  sym_alias_qualified_name = 290,
  sym__simple_name = 291,
  sym_qualified_name = 292,
  sym_generic_name = 293,
  sym_type_argument_list = 294,
  sym_type = 295,
  sym_implicit_type = 296,
  sym_array_type = 297,
  sym__array_base_type = 298,
  sym_array_rank_specifier = 299,
  sym_nullable_type = 300,
  sym_pointer_type = 301,
  sym__pointer_base_type = 302,
  sym_function_pointer_type = 303,
  sym_calling_convention = 304,
  sym_function_pointer_parameter = 305,
  sym_ref_type = 306,
  sym__ref_base_type = 307,
  sym_scoped_type = 308,
  sym__scoped_base_type = 309,
  sym_tuple_type = 310,
  sym_tuple_element = 311,
  sym_statement = 312,
  sym_break_statement = 313,
  sym_checked_statement = 314,
  sym_continue_statement = 315,
  sym_do_statement = 316,
  sym_empty_statement = 317,
  sym_expression_statement = 318,
  sym_fixed_statement = 319,
  sym_for_statement = 320,
  sym__for_statement_conditions = 321,
  sym_return_statement = 322,
  sym_lock_statement = 323,
  sym_yield_statement = 324,
  sym_switch_statement = 325,
  sym_switch_body = 326,
  sym_switch_section = 327,
  sym_throw_statement = 328,
  sym_try_statement = 329,
  sym_catch_clause = 330,
  sym_catch_declaration = 331,
  sym_catch_filter_clause = 332,
  sym_finally_clause = 333,
  sym_unsafe_statement = 334,
  sym_using_statement = 335,
  sym_foreach_statement = 336,
  sym__foreach_statement_initializer = 337,
  sym_goto_statement = 338,
  sym_labeled_statement = 339,
  sym_if_statement = 340,
  sym_while_statement = 341,
  sym_local_declaration_statement = 342,
  sym_local_function_statement = 343,
  sym__local_function_declaration = 344,
  sym_pattern = 345,
  sym_constant_pattern = 346,
  sym_parenthesized_pattern = 347,
  sym_var_pattern = 348,
  sym_type_pattern = 349,
  sym_list_pattern = 350,
  sym_recursive_pattern = 351,
  sym_positional_pattern_clause = 352,
  sym_property_pattern_clause = 353,
  sym_subpattern = 354,
  sym_relational_pattern = 355,
  sym_negated_pattern = 356,
  sym_and_pattern = 357,
  sym_or_pattern = 358,
  sym_declaration_pattern = 359,
  sym__variable_designation = 360,
  sym_parenthesized_variable_designation = 361,
  sym_expression = 362,
  sym_non_lvalue_expression = 363,
  sym_lvalue_expression = 364,
  sym__expression_statement_expression = 365,
  sym_assignment_expression = 366,
  sym_binary_expression = 367,
  sym_postfix_unary_expression = 368,
  sym_prefix_unary_expression = 369,
  sym__pointer_indirection_expression = 370,
  sym_query_expression = 371,
  sym_from_clause = 372,
  sym__query_body = 373,
  sym__query_clause = 374,
  sym_join_clause = 375,
  sym__join_header = 376,
  sym__join_body = 377,
  sym_join_into_clause = 378,
  sym_let_clause = 379,
  sym_order_by_clause = 380,
  sym__ordering = 381,
  sym_where_clause = 382,
  sym__select_or_group_clause = 383,
  sym_group_clause = 384,
  sym_select_clause = 385,
  sym_conditional_expression = 386,
  sym_conditional_access_expression = 387,
  sym_as_expression = 388,
  sym_is_expression = 389,
  sym_is_pattern_expression = 390,
  sym_cast_expression = 391,
  sym_checked_expression = 392,
  sym_invocation_expression = 393,
  sym_switch_expression = 394,
  sym__switch_expression_body = 395,
  sym_switch_expression_arm = 396,
  sym_when_clause = 397,
  sym_await_expression = 398,
  sym_throw_expression = 399,
  sym_element_access_expression = 400,
  sym_interpolated_string_expression = 401,
  sym__interpolated_string_content = 402,
  sym__interpolated_verbatim_string_content = 403,
  sym__interpolated_raw_string_content = 404,
  sym_interpolation = 405,
  sym_interpolation_alignment_clause = 406,
  sym_interpolation_format_clause = 407,
  sym_member_access_expression = 408,
  sym_member_binding_expression = 409,
  sym_object_creation_expression = 410,
  sym_parenthesized_expression = 411,
  sym__parenthesized_lvalue_expression = 412,
  sym_lambda_expression = 413,
  sym__lambda_expression_init = 414,
  sym__lambda_parameters = 415,
  sym_array_creation_expression = 416,
  sym_anonymous_method_expression = 417,
  sym_anonymous_object_creation_expression = 418,
  sym__anonymous_object_member_declarator = 419,
  sym_implicit_array_creation_expression = 420,
  sym_implicit_object_creation_expression = 421,
  sym_implicit_stackalloc_expression = 422,
  sym_initializer_expression = 423,
  sym_declaration_expression = 424,
  sym_default_expression = 425,
  sym_with_expression = 426,
  sym__with_body = 427,
  sym_with_initializer = 428,
  sym_sizeof_expression = 429,
  sym_typeof_expression = 430,
  sym_makeref_expression = 431,
  sym_ref_expression = 432,
  sym_reftype_expression = 433,
  sym_refvalue_expression = 434,
  sym_stackalloc_expression = 435,
  sym_range_expression = 436,
  sym_tuple_expression = 437,
  sym_literal = 438,
  sym_character_literal = 439,
  sym_string_literal = 440,
  sym_string_literal_content = 441,
  sym_raw_string_literal = 442,
  sym_boolean_literal = 443,
  sym_identifier = 444,
  sym__reserved_identifier = 445,
  sym_preproc_if = 446,
  sym_preproc_else = 447,
  sym_preproc_elif = 448,
  sym_preproc_if_in_top_level = 449,
  sym_preproc_else_in_top_level = 450,
  sym_preproc_elif_in_top_level = 451,
  sym_preproc_if_in_expression = 452,
  sym_preproc_else_in_expression = 453,
  sym_preproc_elif_in_expression = 454,
  sym_preproc_if_in_enum_member_declaration = 455,
  sym_preproc_else_in_enum_member_declaration = 456,
  sym_preproc_elif_in_enum_member_declaration = 457,
  sym_preproc_if_in_attribute_list = 458,
  sym_preproc_else_in_attribute_list = 459,
  sym_preproc_elif_in_attribute_list = 460,
  sym__preproc_expression = 461,
  sym_preproc_parenthesized_expression = 462,
  sym_preproc_unary_expression = 463,
  sym_preproc_binary_expression = 464,
  sym_preproc_region = 465,
  sym_preproc_endregion = 466,
  sym_preproc_line = 467,
  sym_preproc_pragma = 468,
  sym_preproc_nullable = 469,
  sym_preproc_error = 470,
  sym_preproc_warning = 471,
  sym_preproc_define = 472,
  sym_preproc_undef = 473,
  aux_sym_compilation_unit_repeat1 = 474,
  aux_sym_using_directive_repeat1 = 475,
  aux_sym_global_attribute_repeat1 = 476,
  aux_sym_attribute_argument_list_repeat1 = 477,
  aux_sym__class_declaration_initializer_repeat1 = 478,
  aux_sym__class_declaration_initializer_repeat2 = 479,
  aux_sym__class_declaration_initializer_repeat3 = 480,
  aux_sym__class_declaration_initializer_repeat4 = 481,
  aux_sym_enum_member_declaration_list_repeat1 = 482,
  aux_sym__record_declaration_initializer_repeat1 = 483,
  aux_sym_record_base_repeat1 = 484,
  aux_sym_type_parameter_list_repeat1 = 485,
  aux_sym_base_list_repeat1 = 486,
  aux_sym_type_parameter_constraints_clause_repeat1 = 487,
  aux_sym_conversion_operator_declaration_repeat1 = 488,
  aux_sym_declaration_list_repeat1 = 489,
  aux_sym_accessor_list_repeat1 = 490,
  aux_sym_bracketed_parameter_list_repeat1 = 491,
  aux_sym__parameter_type_with_modifiers_repeat1 = 492,
  aux_sym_argument_list_repeat1 = 493,
  aux_sym_tuple_pattern_repeat1 = 494,
  aux_sym_block_repeat1 = 495,
  aux_sym_variable_declaration_repeat1 = 496,
  aux_sym_using_variable_declaration_repeat1 = 497,
  aux_sym_type_argument_list_repeat1 = 498,
  aux_sym_type_argument_list_repeat2 = 499,
  aux_sym_array_rank_specifier_repeat1 = 500,
  aux_sym_function_pointer_type_repeat1 = 501,
  aux_sym_calling_convention_repeat1 = 502,
  aux_sym_tuple_type_repeat1 = 503,
  aux_sym__for_statement_conditions_repeat1 = 504,
  aux_sym_switch_body_repeat1 = 505,
  aux_sym_try_statement_repeat1 = 506,
  aux_sym_catch_clause_repeat1 = 507,
  aux_sym_list_pattern_repeat1 = 508,
  aux_sym_positional_pattern_clause_repeat1 = 509,
  aux_sym_parenthesized_variable_designation_repeat1 = 510,
  aux_sym__query_body_repeat1 = 511,
  aux_sym__query_body_repeat2 = 512,
  aux_sym_order_by_clause_repeat1 = 513,
  aux_sym__switch_expression_body_repeat1 = 514,
  aux_sym_interpolated_string_expression_repeat1 = 515,
  aux_sym_interpolated_string_expression_repeat2 = 516,
  aux_sym_interpolated_string_expression_repeat3 = 517,
  aux_sym__lambda_expression_init_repeat1 = 518,
  aux_sym_anonymous_object_creation_expression_repeat1 = 519,
  aux_sym__with_body_repeat1 = 520,
  aux_sym_string_literal_repeat1 = 521,
  aux_sym_preproc_if_in_top_level_repeat1 = 522,
  aux_sym_preproc_pragma_repeat1 = 523,
  alias_sym_element_binding_expression = 524,
  alias_sym_implicit_parameter = 525,
  alias_sym_interpolation_quote = 526,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier_token] = "_identifier_token",
  [anon_sym_extern] = "extern",
  [anon_sym_alias] = "alias",
  [anon_sym_SEMI] = ";",
  [anon_sym_global] = "global",
  [anon_sym_using] = "using",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_LBRACK] = "[",
  [anon_sym_assembly] = "assembly",
  [anon_sym_module] = "module",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_field] = "field",
  [anon_sym_event] = "event",
  [anon_sym_method] = "method",
  [anon_sym_param] = "param",
  [anon_sym_property] = "property",
  [anon_sym_return] = "return",
  [anon_sym_type] = "type",
  [anon_sym_typevar] = "typevar",
  [anon_sym_namespace] = "namespace",
  [anon_sym_class] = "class",
  [anon_sym_ref] = "ref",
  [anon_sym_struct] = "struct",
  [anon_sym_enum] = "enum",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_delegate] = "delegate",
  [anon_sym_record] = "record",
  [anon_sym_abstract] = "abstract",
  [anon_sym_async] = "async",
  [anon_sym_const] = "const",
  [anon_sym_file] = "file",
  [anon_sym_fixed] = "fixed",
  [anon_sym_internal] = "internal",
  [anon_sym_new] = "new",
  [anon_sym_override] = "override",
  [anon_sym_partial] = "partial",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_public] = "public",
  [anon_sym_readonly] = "readonly",
  [anon_sym_required] = "required",
  [anon_sym_sealed] = "sealed",
  [anon_sym_virtual] = "virtual",
  [anon_sym_volatile] = "volatile",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_where] = "where",
  [anon_sym_QMARK] = "\?",
  [anon_sym_notnull] = "notnull",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_operator] = "operator",
  [anon_sym_checked] = "checked",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_implicit] = "implicit",
  [anon_sym_explicit] = "explicit",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_add] = "add",
  [anon_sym_remove] = "remove",
  [anon_sym_init] = "init",
  [anon_sym_this] = "this",
  [anon_sym_DOT] = ".",
  [anon_sym_scoped] = "scoped",
  [anon_sym_params] = "params",
  [anon_sym_base] = "base",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_var] = "var",
  [anon_sym_managed] = "managed",
  [anon_sym_Cdecl] = "Cdecl",
  [anon_sym_Stdcall] = "Stdcall",
  [anon_sym_Thiscall] = "Thiscall",
  [anon_sym_Fastcall] = "Fastcall",
  [sym_predefined_type] = "predefined_type",
  [anon_sym_break] = "break",
  [anon_sym_unchecked] = "unchecked",
  [anon_sym_continue] = "continue",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [anon_sym_lock] = "lock",
  [anon_sym_yield] = "yield",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_when] = "when",
  [anon_sym_finally] = "finally",
  [anon_sym_await] = "await",
  [anon_sym_foreach] = "foreach",
  [anon_sym_goto] = "goto",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [sym_discard] = "discard",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_from] = "from",
  [anon_sym_into] = "into",
  [anon_sym_join] = "join",
  [anon_sym_on] = "on",
  [anon_sym_equals] = "equals",
  [anon_sym_let] = "let",
  [anon_sym_orderby] = "orderby",
  [anon_sym_ascending] = "ascending",
  [anon_sym_descending] = "descending",
  [anon_sym_group] = "group",
  [anon_sym_by] = "by",
  [anon_sym_select] = "select",
  [anon_sym_as] = "as",
  [anon_sym_is] = "is",
  [aux_sym_interpolation_format_clause_token1] = "interpolation_format_clause_token1",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_stackalloc] = "stackalloc",
  [anon_sym_with] = "with",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_typeof] = "typeof",
  [anon_sym___makeref] = "__makeref",
  [anon_sym___reftype] = "__reftype",
  [anon_sym___refvalue] = "__refvalue",
  [sym_null_literal] = "null_literal",
  [anon_sym_SQUOTE] = "'",
  [sym_character_literal_content] = "character_literal_content",
  [sym_integer_literal] = "integer_literal",
  [sym_real_literal] = "real_literal",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_content_token1] = "string_literal_content_token1",
  [aux_sym_string_literal_content_token2] = "string_literal_content_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_string_literal_encoding] = "string_literal_encoding",
  [sym_verbatim_string_literal] = "verbatim_string_literal",
  [aux_sym_raw_string_literal_token1] = "raw_string_literal_token1",
  [aux_sym_preproc_if_token1] = "#if",
  [aux_sym_preproc_if_token2] = "preproc_if_token2",
  [aux_sym_preproc_if_token3] = "#endif",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [sym_preproc_arg] = "preproc_arg",
  [aux_sym_preproc_region_token1] = "#region",
  [aux_sym_preproc_endregion_token1] = "#endregion",
  [aux_sym_preproc_line_token1] = "#line",
  [anon_sym_hidden] = "hidden",
  [aux_sym_preproc_pragma_token1] = "#pragma",
  [anon_sym_warning] = "warning",
  [anon_sym_disable] = "disable",
  [anon_sym_restore] = "restore",
  [anon_sym_checksum] = "checksum",
  [aux_sym_preproc_nullable_token1] = "#nullable",
  [anon_sym_enable] = "enable",
  [anon_sym_annotations] = "annotations",
  [anon_sym_warnings] = "warnings",
  [aux_sym_preproc_error_token1] = "#error",
  [aux_sym_preproc_warning_token1] = "#warning",
  [aux_sym_preproc_define_token1] = "#define",
  [aux_sym_preproc_undef_token1] = "#undef",
  [sym_shebang_directive] = "shebang_directive",
  [sym_comment] = "comment",
  [sym__optional_semi] = "_optional_semi",
  [sym_interpolation_regular_start] = "interpolation_start",
  [sym_interpolation_verbatim_start] = "interpolation_start",
  [sym_interpolation_raw_start] = "interpolation_start",
  [sym_interpolation_start_quote] = "\"",
  [sym_interpolation_end_quote] = "\"",
  [sym_interpolation_open_brace] = "interpolation_brace",
  [sym_interpolation_close_brace] = "interpolation_brace",
  [sym_interpolation_string_content] = "string_content",
  [sym_raw_string_start] = "raw_string_start",
  [sym_raw_string_end] = "raw_string_end",
  [sym_raw_string_content] = "raw_string_content",
  [sym_compilation_unit] = "compilation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym_global_statement] = "global_statement",
  [sym_extern_alias_directive] = "extern_alias_directive",
  [sym_using_directive] = "using_directive",
  [sym_global_attribute] = "global_attribute",
  [sym_attribute] = "attribute",
  [sym_attribute_argument_list] = "attribute_argument_list",
  [sym_attribute_argument] = "attribute_argument",
  [sym_attribute_list] = "attribute_list",
  [sym__attribute_list] = "_attribute_list",
  [sym_attribute_target_specifier] = "attribute_target_specifier",
  [sym_namespace_declaration] = "namespace_declaration",
  [sym_file_scoped_namespace_declaration] = "file_scoped_namespace_declaration",
  [sym_type_declaration] = "type_declaration",
  [sym_class_declaration] = "class_declaration",
  [sym__class_declaration_initializer] = "_class_declaration_initializer",
  [sym_struct_declaration] = "struct_declaration",
  [sym__struct_declaration_initializer] = "_struct_declaration_initializer",
  [sym_enum_declaration] = "enum_declaration",
  [sym__enum_declaration_initializer] = "_enum_declaration_initializer",
  [sym_enum_member_declaration_list] = "enum_member_declaration_list",
  [sym_enum_member_declaration] = "enum_member_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym__interface_declaration_initializer] = "_interface_declaration_initializer",
  [sym_delegate_declaration] = "delegate_declaration",
  [sym__delegate_declaration_initializer] = "_delegate_declaration_initializer",
  [sym_record_declaration] = "record_declaration",
  [sym__record_declaration_initializer] = "_record_declaration_initializer",
  [sym_record_base] = "base_list",
  [sym__declaration_list_body] = "_declaration_list_body",
  [sym_primary_constructor_base_type] = "primary_constructor_base_type",
  [sym_modifier] = "modifier",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter] = "type_parameter",
  [sym_base_list] = "base_list",
  [sym_type_parameter_constraints_clause] = "type_parameter_constraints_clause",
  [sym_type_parameter_constraint] = "type_parameter_constraint",
  [sym_constructor_constraint] = "constructor_constraint",
  [sym_operator_declaration] = "operator_declaration",
  [sym_conversion_operator_declaration] = "conversion_operator_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_declaration] = "declaration",
  [sym_field_declaration] = "field_declaration",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym__constructor_declaration_initializer] = "_constructor_declaration_initializer",
  [sym_destructor_declaration] = "destructor_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_event_declaration] = "event_declaration",
  [sym_event_field_declaration] = "event_field_declaration",
  [sym_accessor_list] = "accessor_list",
  [sym_accessor_declaration] = "accessor_declaration",
  [sym_indexer_declaration] = "indexer_declaration",
  [sym_bracketed_parameter_list] = "bracketed_parameter_list",
  [sym_property_declaration] = "property_declaration",
  [sym_explicit_interface_specifier] = "explicit_interface_specifier",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter] = "parameter",
  [sym__parameter_array] = "_parameter_array",
  [sym_constructor_initializer] = "constructor_initializer",
  [sym_argument_list] = "argument_list",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_argument] = "argument",
  [sym_block] = "block",
  [sym_arrow_expression_clause] = "arrow_expression_clause",
  [sym__function_body] = "_function_body",
  [sym_variable_declaration] = "variable_declaration",
  [sym_using_variable_declaration] = "variable_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_using_variable_declarator] = "variable_declarator",
  [sym_bracketed_argument_list] = "bracketed_argument_list",
  [sym__name] = "_name",
  [sym_alias_qualified_name] = "alias_qualified_name",
  [sym__simple_name] = "_simple_name",
  [sym_qualified_name] = "qualified_name",
  [sym_generic_name] = "generic_name",
  [sym_type_argument_list] = "type_argument_list",
  [sym_type] = "type",
  [sym_implicit_type] = "implicit_type",
  [sym_array_type] = "array_type",
  [sym__array_base_type] = "_array_base_type",
  [sym_array_rank_specifier] = "array_rank_specifier",
  [sym_nullable_type] = "nullable_type",
  [sym_pointer_type] = "pointer_type",
  [sym__pointer_base_type] = "_pointer_base_type",
  [sym_function_pointer_type] = "function_pointer_type",
  [sym_calling_convention] = "calling_convention",
  [sym_function_pointer_parameter] = "function_pointer_parameter",
  [sym_ref_type] = "ref_type",
  [sym__ref_base_type] = "_ref_base_type",
  [sym_scoped_type] = "scoped_type",
  [sym__scoped_base_type] = "_scoped_base_type",
  [sym_tuple_type] = "tuple_type",
  [sym_tuple_element] = "tuple_element",
  [sym_statement] = "statement",
  [sym_break_statement] = "break_statement",
  [sym_checked_statement] = "checked_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_do_statement] = "do_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_fixed_statement] = "fixed_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_conditions] = "_for_statement_conditions",
  [sym_return_statement] = "return_statement",
  [sym_lock_statement] = "lock_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_section] = "switch_section",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_declaration] = "catch_declaration",
  [sym_catch_filter_clause] = "catch_filter_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_unsafe_statement] = "unsafe_statement",
  [sym_using_statement] = "using_statement",
  [sym_foreach_statement] = "foreach_statement",
  [sym__foreach_statement_initializer] = "_foreach_statement_initializer",
  [sym_goto_statement] = "goto_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_local_declaration_statement] = "local_declaration_statement",
  [sym_local_function_statement] = "local_function_statement",
  [sym__local_function_declaration] = "_local_function_declaration",
  [sym_pattern] = "pattern",
  [sym_constant_pattern] = "constant_pattern",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym_var_pattern] = "var_pattern",
  [sym_type_pattern] = "type_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_recursive_pattern] = "recursive_pattern",
  [sym_positional_pattern_clause] = "positional_pattern_clause",
  [sym_property_pattern_clause] = "property_pattern_clause",
  [sym_subpattern] = "subpattern",
  [sym_relational_pattern] = "relational_pattern",
  [sym_negated_pattern] = "negated_pattern",
  [sym_and_pattern] = "and_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym_declaration_pattern] = "declaration_pattern",
  [sym__variable_designation] = "_variable_designation",
  [sym_parenthesized_variable_designation] = "parenthesized_variable_designation",
  [sym_expression] = "expression",
  [sym_non_lvalue_expression] = "non_lvalue_expression",
  [sym_lvalue_expression] = "lvalue_expression",
  [sym__expression_statement_expression] = "_expression_statement_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_postfix_unary_expression] = "postfix_unary_expression",
  [sym_prefix_unary_expression] = "prefix_unary_expression",
  [sym__pointer_indirection_expression] = "prefix_unary_expression",
  [sym_query_expression] = "query_expression",
  [sym_from_clause] = "from_clause",
  [sym__query_body] = "_query_body",
  [sym__query_clause] = "_query_clause",
  [sym_join_clause] = "join_clause",
  [sym__join_header] = "_join_header",
  [sym__join_body] = "_join_body",
  [sym_join_into_clause] = "join_into_clause",
  [sym_let_clause] = "let_clause",
  [sym_order_by_clause] = "order_by_clause",
  [sym__ordering] = "_ordering",
  [sym_where_clause] = "where_clause",
  [sym__select_or_group_clause] = "_select_or_group_clause",
  [sym_group_clause] = "group_clause",
  [sym_select_clause] = "select_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_conditional_access_expression] = "conditional_access_expression",
  [sym_as_expression] = "as_expression",
  [sym_is_expression] = "is_expression",
  [sym_is_pattern_expression] = "is_pattern_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_checked_expression] = "checked_expression",
  [sym_invocation_expression] = "invocation_expression",
  [sym_switch_expression] = "switch_expression",
  [sym__switch_expression_body] = "_switch_expression_body",
  [sym_switch_expression_arm] = "switch_expression_arm",
  [sym_when_clause] = "when_clause",
  [sym_await_expression] = "await_expression",
  [sym_throw_expression] = "throw_expression",
  [sym_element_access_expression] = "element_access_expression",
  [sym_interpolated_string_expression] = "interpolated_string_expression",
  [sym__interpolated_string_content] = "_interpolated_string_content",
  [sym__interpolated_verbatim_string_content] = "_interpolated_verbatim_string_content",
  [sym__interpolated_raw_string_content] = "_interpolated_raw_string_content",
  [sym_interpolation] = "interpolation",
  [sym_interpolation_alignment_clause] = "interpolation_alignment_clause",
  [sym_interpolation_format_clause] = "interpolation_format_clause",
  [sym_member_access_expression] = "member_access_expression",
  [sym_member_binding_expression] = "member_binding_expression",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__parenthesized_lvalue_expression] = "parenthesized_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym__lambda_expression_init] = "_lambda_expression_init",
  [sym__lambda_parameters] = "_lambda_parameters",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_anonymous_method_expression] = "anonymous_method_expression",
  [sym_anonymous_object_creation_expression] = "anonymous_object_creation_expression",
  [sym__anonymous_object_member_declarator] = "_anonymous_object_member_declarator",
  [sym_implicit_array_creation_expression] = "implicit_array_creation_expression",
  [sym_implicit_object_creation_expression] = "implicit_object_creation_expression",
  [sym_implicit_stackalloc_expression] = "implicit_stackalloc_expression",
  [sym_initializer_expression] = "initializer_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_default_expression] = "default_expression",
  [sym_with_expression] = "with_expression",
  [sym__with_body] = "_with_body",
  [sym_with_initializer] = "with_initializer",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_typeof_expression] = "typeof_expression",
  [sym_makeref_expression] = "makeref_expression",
  [sym_ref_expression] = "ref_expression",
  [sym_reftype_expression] = "reftype_expression",
  [sym_refvalue_expression] = "refvalue_expression",
  [sym_stackalloc_expression] = "stackalloc_expression",
  [sym_range_expression] = "range_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_literal] = "literal",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_string_literal_content] = "string_literal_content",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_identifier] = "identifier",
  [sym__reserved_identifier] = "_reserved_identifier",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_top_level] = "preproc_if",
  [sym_preproc_else_in_top_level] = "preproc_else",
  [sym_preproc_elif_in_top_level] = "preproc_elif",
  [sym_preproc_if_in_expression] = "preproc_if",
  [sym_preproc_else_in_expression] = "preproc_else",
  [sym_preproc_elif_in_expression] = "preproc_elif",
  [sym_preproc_if_in_enum_member_declaration] = "preproc_if",
  [sym_preproc_else_in_enum_member_declaration] = "preproc_else",
  [sym_preproc_elif_in_enum_member_declaration] = "preproc_elif",
  [sym_preproc_if_in_attribute_list] = "preproc_if_in_attribute_list",
  [sym_preproc_else_in_attribute_list] = "preproc_else",
  [sym_preproc_elif_in_attribute_list] = "preproc_elif",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_preproc_region] = "preproc_region",
  [sym_preproc_endregion] = "preproc_endregion",
  [sym_preproc_line] = "preproc_line",
  [sym_preproc_pragma] = "preproc_pragma",
  [sym_preproc_nullable] = "preproc_nullable",
  [sym_preproc_error] = "preproc_error",
  [sym_preproc_warning] = "preproc_warning",
  [sym_preproc_define] = "preproc_define",
  [sym_preproc_undef] = "preproc_undef",
  [aux_sym_compilation_unit_repeat1] = "compilation_unit_repeat1",
  [aux_sym_using_directive_repeat1] = "using_directive_repeat1",
  [aux_sym_global_attribute_repeat1] = "global_attribute_repeat1",
  [aux_sym_attribute_argument_list_repeat1] = "attribute_argument_list_repeat1",
  [aux_sym__class_declaration_initializer_repeat1] = "_class_declaration_initializer_repeat1",
  [aux_sym__class_declaration_initializer_repeat2] = "_class_declaration_initializer_repeat2",
  [aux_sym__class_declaration_initializer_repeat3] = "_class_declaration_initializer_repeat3",
  [aux_sym__class_declaration_initializer_repeat4] = "_class_declaration_initializer_repeat4",
  [aux_sym_enum_member_declaration_list_repeat1] = "enum_member_declaration_list_repeat1",
  [aux_sym__record_declaration_initializer_repeat1] = "_record_declaration_initializer_repeat1",
  [aux_sym_record_base_repeat1] = "record_base_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_base_list_repeat1] = "base_list_repeat1",
  [aux_sym_type_parameter_constraints_clause_repeat1] = "type_parameter_constraints_clause_repeat1",
  [aux_sym_conversion_operator_declaration_repeat1] = "conversion_operator_declaration_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_accessor_list_repeat1] = "accessor_list_repeat1",
  [aux_sym_bracketed_parameter_list_repeat1] = "bracketed_parameter_list_repeat1",
  [aux_sym__parameter_type_with_modifiers_repeat1] = "_parameter_type_with_modifiers_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_using_variable_declaration_repeat1] = "using_variable_declaration_repeat1",
  [aux_sym_type_argument_list_repeat1] = "type_argument_list_repeat1",
  [aux_sym_type_argument_list_repeat2] = "type_argument_list_repeat2",
  [aux_sym_array_rank_specifier_repeat1] = "array_rank_specifier_repeat1",
  [aux_sym_function_pointer_type_repeat1] = "function_pointer_type_repeat1",
  [aux_sym_calling_convention_repeat1] = "calling_convention_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym__for_statement_conditions_repeat1] = "_for_statement_conditions_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_catch_clause_repeat1] = "catch_clause_repeat1",
  [aux_sym_list_pattern_repeat1] = "list_pattern_repeat1",
  [aux_sym_positional_pattern_clause_repeat1] = "positional_pattern_clause_repeat1",
  [aux_sym_parenthesized_variable_designation_repeat1] = "parenthesized_variable_designation_repeat1",
  [aux_sym__query_body_repeat1] = "_query_body_repeat1",
  [aux_sym__query_body_repeat2] = "_query_body_repeat2",
  [aux_sym_order_by_clause_repeat1] = "order_by_clause_repeat1",
  [aux_sym__switch_expression_body_repeat1] = "_switch_expression_body_repeat1",
  [aux_sym_interpolated_string_expression_repeat1] = "interpolated_string_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat2] = "interpolated_string_expression_repeat2",
  [aux_sym_interpolated_string_expression_repeat3] = "interpolated_string_expression_repeat3",
  [aux_sym__lambda_expression_init_repeat1] = "_lambda_expression_init_repeat1",
  [aux_sym_anonymous_object_creation_expression_repeat1] = "anonymous_object_creation_expression_repeat1",
  [aux_sym__with_body_repeat1] = "_with_body_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_preproc_if_in_top_level_repeat1] = "preproc_if_in_top_level_repeat1",
  [aux_sym_preproc_pragma_repeat1] = "preproc_pragma_repeat1",
  [alias_sym_element_binding_expression] = "element_binding_expression",
  [alias_sym_implicit_parameter] = "implicit_parameter",
  [alias_sym_interpolation_quote] = "interpolation_quote",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier_token] = sym__identifier_token,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_method] = anon_sym_method,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typevar] = anon_sym_typevar,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_file] = anon_sym_file,
  [anon_sym_fixed] = anon_sym_fixed,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_partial] = anon_sym_partial,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_notnull] = anon_sym_notnull,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_checked] = anon_sym_checked,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_implicit] = anon_sym_implicit,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_remove] = anon_sym_remove,
  [anon_sym_init] = anon_sym_init,
  [anon_sym_this] = anon_sym_this,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_scoped] = anon_sym_scoped,
  [anon_sym_params] = anon_sym_params,
  [anon_sym_base] = anon_sym_base,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_managed] = anon_sym_managed,
  [anon_sym_Cdecl] = anon_sym_Cdecl,
  [anon_sym_Stdcall] = anon_sym_Stdcall,
  [anon_sym_Thiscall] = anon_sym_Thiscall,
  [anon_sym_Fastcall] = anon_sym_Fastcall,
  [sym_predefined_type] = sym_predefined_type,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_unchecked] = anon_sym_unchecked,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_lock] = anon_sym_lock,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [sym_discard] = sym_discard,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_into] = anon_sym_into,
  [anon_sym_join] = anon_sym_join,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_equals] = anon_sym_equals,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_orderby] = anon_sym_orderby,
  [anon_sym_ascending] = anon_sym_ascending,
  [anon_sym_descending] = anon_sym_descending,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_by] = anon_sym_by,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_is] = anon_sym_is,
  [aux_sym_interpolation_format_clause_token1] = aux_sym_interpolation_format_clause_token1,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_stackalloc] = anon_sym_stackalloc,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym___makeref] = anon_sym___makeref,
  [anon_sym___reftype] = anon_sym___reftype,
  [anon_sym___refvalue] = anon_sym___refvalue,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_character_literal_content] = sym_character_literal_content,
  [sym_integer_literal] = sym_integer_literal,
  [sym_real_literal] = sym_real_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_content_token1] = aux_sym_string_literal_content_token1,
  [aux_sym_string_literal_content_token2] = aux_sym_string_literal_content_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_string_literal_encoding] = sym_string_literal_encoding,
  [sym_verbatim_string_literal] = sym_verbatim_string_literal,
  [aux_sym_raw_string_literal_token1] = aux_sym_raw_string_literal_token1,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_if_token3] = aux_sym_preproc_if_token3,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [sym_preproc_arg] = sym_preproc_arg,
  [aux_sym_preproc_region_token1] = aux_sym_preproc_region_token1,
  [aux_sym_preproc_endregion_token1] = aux_sym_preproc_endregion_token1,
  [aux_sym_preproc_line_token1] = aux_sym_preproc_line_token1,
  [anon_sym_hidden] = anon_sym_hidden,
  [aux_sym_preproc_pragma_token1] = aux_sym_preproc_pragma_token1,
  [anon_sym_warning] = anon_sym_warning,
  [anon_sym_disable] = anon_sym_disable,
  [anon_sym_restore] = anon_sym_restore,
  [anon_sym_checksum] = anon_sym_checksum,
  [aux_sym_preproc_nullable_token1] = aux_sym_preproc_nullable_token1,
  [anon_sym_enable] = anon_sym_enable,
  [anon_sym_annotations] = anon_sym_annotations,
  [anon_sym_warnings] = anon_sym_warnings,
  [aux_sym_preproc_error_token1] = aux_sym_preproc_error_token1,
  [aux_sym_preproc_warning_token1] = aux_sym_preproc_warning_token1,
  [aux_sym_preproc_define_token1] = aux_sym_preproc_define_token1,
  [aux_sym_preproc_undef_token1] = aux_sym_preproc_undef_token1,
  [sym_shebang_directive] = sym_shebang_directive,
  [sym_comment] = sym_comment,
  [sym__optional_semi] = sym__optional_semi,
  [sym_interpolation_regular_start] = sym_interpolation_regular_start,
  [sym_interpolation_verbatim_start] = sym_interpolation_regular_start,
  [sym_interpolation_raw_start] = sym_interpolation_regular_start,
  [sym_interpolation_start_quote] = anon_sym_DQUOTE,
  [sym_interpolation_end_quote] = anon_sym_DQUOTE,
  [sym_interpolation_open_brace] = sym_interpolation_open_brace,
  [sym_interpolation_close_brace] = sym_interpolation_open_brace,
  [sym_interpolation_string_content] = sym_interpolation_string_content,
  [sym_raw_string_start] = sym_raw_string_start,
  [sym_raw_string_end] = sym_raw_string_end,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_compilation_unit] = sym_compilation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym_global_statement] = sym_global_statement,
  [sym_extern_alias_directive] = sym_extern_alias_directive,
  [sym_using_directive] = sym_using_directive,
  [sym_global_attribute] = sym_global_attribute,
  [sym_attribute] = sym_attribute,
  [sym_attribute_argument_list] = sym_attribute_argument_list,
  [sym_attribute_argument] = sym_attribute_argument,
  [sym_attribute_list] = sym_attribute_list,
  [sym__attribute_list] = sym__attribute_list,
  [sym_attribute_target_specifier] = sym_attribute_target_specifier,
  [sym_namespace_declaration] = sym_namespace_declaration,
  [sym_file_scoped_namespace_declaration] = sym_file_scoped_namespace_declaration,
  [sym_type_declaration] = sym_type_declaration,
  [sym_class_declaration] = sym_class_declaration,
  [sym__class_declaration_initializer] = sym__class_declaration_initializer,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym__struct_declaration_initializer] = sym__struct_declaration_initializer,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym__enum_declaration_initializer] = sym__enum_declaration_initializer,
  [sym_enum_member_declaration_list] = sym_enum_member_declaration_list,
  [sym_enum_member_declaration] = sym_enum_member_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym__interface_declaration_initializer] = sym__interface_declaration_initializer,
  [sym_delegate_declaration] = sym_delegate_declaration,
  [sym__delegate_declaration_initializer] = sym__delegate_declaration_initializer,
  [sym_record_declaration] = sym_record_declaration,
  [sym__record_declaration_initializer] = sym__record_declaration_initializer,
  [sym_record_base] = sym_base_list,
  [sym__declaration_list_body] = sym__declaration_list_body,
  [sym_primary_constructor_base_type] = sym_primary_constructor_base_type,
  [sym_modifier] = sym_modifier,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_type_parameter] = sym_type_parameter,
  [sym_base_list] = sym_base_list,
  [sym_type_parameter_constraints_clause] = sym_type_parameter_constraints_clause,
  [sym_type_parameter_constraint] = sym_type_parameter_constraint,
  [sym_constructor_constraint] = sym_constructor_constraint,
  [sym_operator_declaration] = sym_operator_declaration,
  [sym_conversion_operator_declaration] = sym_conversion_operator_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_declaration] = sym_declaration,
  [sym_field_declaration] = sym_field_declaration,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym__constructor_declaration_initializer] = sym__constructor_declaration_initializer,
  [sym_destructor_declaration] = sym_destructor_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_event_declaration] = sym_event_declaration,
  [sym_event_field_declaration] = sym_event_field_declaration,
  [sym_accessor_list] = sym_accessor_list,
  [sym_accessor_declaration] = sym_accessor_declaration,
  [sym_indexer_declaration] = sym_indexer_declaration,
  [sym_bracketed_parameter_list] = sym_bracketed_parameter_list,
  [sym_property_declaration] = sym_property_declaration,
  [sym_explicit_interface_specifier] = sym_explicit_interface_specifier,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter] = sym_parameter,
  [sym__parameter_array] = sym__parameter_array,
  [sym_constructor_initializer] = sym_constructor_initializer,
  [sym_argument_list] = sym_argument_list,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_argument] = sym_argument,
  [sym_block] = sym_block,
  [sym_arrow_expression_clause] = sym_arrow_expression_clause,
  [sym__function_body] = sym__function_body,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_using_variable_declaration] = sym_variable_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_using_variable_declarator] = sym_variable_declarator,
  [sym_bracketed_argument_list] = sym_bracketed_argument_list,
  [sym__name] = sym__name,
  [sym_alias_qualified_name] = sym_alias_qualified_name,
  [sym__simple_name] = sym__simple_name,
  [sym_qualified_name] = sym_qualified_name,
  [sym_generic_name] = sym_generic_name,
  [sym_type_argument_list] = sym_type_argument_list,
  [sym_type] = sym_type,
  [sym_implicit_type] = sym_implicit_type,
  [sym_array_type] = sym_array_type,
  [sym__array_base_type] = sym__array_base_type,
  [sym_array_rank_specifier] = sym_array_rank_specifier,
  [sym_nullable_type] = sym_nullable_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym__pointer_base_type] = sym__pointer_base_type,
  [sym_function_pointer_type] = sym_function_pointer_type,
  [sym_calling_convention] = sym_calling_convention,
  [sym_function_pointer_parameter] = sym_function_pointer_parameter,
  [sym_ref_type] = sym_ref_type,
  [sym__ref_base_type] = sym__ref_base_type,
  [sym_scoped_type] = sym_scoped_type,
  [sym__scoped_base_type] = sym__scoped_base_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_tuple_element] = sym_tuple_element,
  [sym_statement] = sym_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_checked_statement] = sym_checked_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_fixed_statement] = sym_fixed_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_conditions] = sym__for_statement_conditions,
  [sym_return_statement] = sym_return_statement,
  [sym_lock_statement] = sym_lock_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_section] = sym_switch_section,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_declaration] = sym_catch_declaration,
  [sym_catch_filter_clause] = sym_catch_filter_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_unsafe_statement] = sym_unsafe_statement,
  [sym_using_statement] = sym_using_statement,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym__foreach_statement_initializer] = sym__foreach_statement_initializer,
  [sym_goto_statement] = sym_goto_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_local_declaration_statement] = sym_local_declaration_statement,
  [sym_local_function_statement] = sym_local_function_statement,
  [sym__local_function_declaration] = sym__local_function_declaration,
  [sym_pattern] = sym_pattern,
  [sym_constant_pattern] = sym_constant_pattern,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym_var_pattern] = sym_var_pattern,
  [sym_type_pattern] = sym_type_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_recursive_pattern] = sym_recursive_pattern,
  [sym_positional_pattern_clause] = sym_positional_pattern_clause,
  [sym_property_pattern_clause] = sym_property_pattern_clause,
  [sym_subpattern] = sym_subpattern,
  [sym_relational_pattern] = sym_relational_pattern,
  [sym_negated_pattern] = sym_negated_pattern,
  [sym_and_pattern] = sym_and_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym_declaration_pattern] = sym_declaration_pattern,
  [sym__variable_designation] = sym__variable_designation,
  [sym_parenthesized_variable_designation] = sym_parenthesized_variable_designation,
  [sym_expression] = sym_expression,
  [sym_non_lvalue_expression] = sym_non_lvalue_expression,
  [sym_lvalue_expression] = sym_lvalue_expression,
  [sym__expression_statement_expression] = sym__expression_statement_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_postfix_unary_expression] = sym_postfix_unary_expression,
  [sym_prefix_unary_expression] = sym_prefix_unary_expression,
  [sym__pointer_indirection_expression] = sym_prefix_unary_expression,
  [sym_query_expression] = sym_query_expression,
  [sym_from_clause] = sym_from_clause,
  [sym__query_body] = sym__query_body,
  [sym__query_clause] = sym__query_clause,
  [sym_join_clause] = sym_join_clause,
  [sym__join_header] = sym__join_header,
  [sym__join_body] = sym__join_body,
  [sym_join_into_clause] = sym_join_into_clause,
  [sym_let_clause] = sym_let_clause,
  [sym_order_by_clause] = sym_order_by_clause,
  [sym__ordering] = sym__ordering,
  [sym_where_clause] = sym_where_clause,
  [sym__select_or_group_clause] = sym__select_or_group_clause,
  [sym_group_clause] = sym_group_clause,
  [sym_select_clause] = sym_select_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_conditional_access_expression] = sym_conditional_access_expression,
  [sym_as_expression] = sym_as_expression,
  [sym_is_expression] = sym_is_expression,
  [sym_is_pattern_expression] = sym_is_pattern_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_checked_expression] = sym_checked_expression,
  [sym_invocation_expression] = sym_invocation_expression,
  [sym_switch_expression] = sym_switch_expression,
  [sym__switch_expression_body] = sym__switch_expression_body,
  [sym_switch_expression_arm] = sym_switch_expression_arm,
  [sym_when_clause] = sym_when_clause,
  [sym_await_expression] = sym_await_expression,
  [sym_throw_expression] = sym_throw_expression,
  [sym_element_access_expression] = sym_element_access_expression,
  [sym_interpolated_string_expression] = sym_interpolated_string_expression,
  [sym__interpolated_string_content] = sym__interpolated_string_content,
  [sym__interpolated_verbatim_string_content] = sym__interpolated_verbatim_string_content,
  [sym__interpolated_raw_string_content] = sym__interpolated_raw_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym_interpolation_alignment_clause] = sym_interpolation_alignment_clause,
  [sym_interpolation_format_clause] = sym_interpolation_format_clause,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_member_binding_expression] = sym_member_binding_expression,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__parenthesized_lvalue_expression] = sym_parenthesized_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym__lambda_expression_init] = sym__lambda_expression_init,
  [sym__lambda_parameters] = sym__lambda_parameters,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_anonymous_method_expression] = sym_anonymous_method_expression,
  [sym_anonymous_object_creation_expression] = sym_anonymous_object_creation_expression,
  [sym__anonymous_object_member_declarator] = sym__anonymous_object_member_declarator,
  [sym_implicit_array_creation_expression] = sym_implicit_array_creation_expression,
  [sym_implicit_object_creation_expression] = sym_implicit_object_creation_expression,
  [sym_implicit_stackalloc_expression] = sym_implicit_stackalloc_expression,
  [sym_initializer_expression] = sym_initializer_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_default_expression] = sym_default_expression,
  [sym_with_expression] = sym_with_expression,
  [sym__with_body] = sym__with_body,
  [sym_with_initializer] = sym_with_initializer,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_typeof_expression] = sym_typeof_expression,
  [sym_makeref_expression] = sym_makeref_expression,
  [sym_ref_expression] = sym_ref_expression,
  [sym_reftype_expression] = sym_reftype_expression,
  [sym_refvalue_expression] = sym_refvalue_expression,
  [sym_stackalloc_expression] = sym_stackalloc_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_literal] = sym_literal,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_string_literal_content] = sym_string_literal_content,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_identifier] = sym_identifier,
  [sym__reserved_identifier] = sym__reserved_identifier,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_if_in_top_level] = sym_preproc_if,
  [sym_preproc_else_in_top_level] = sym_preproc_else,
  [sym_preproc_elif_in_top_level] = sym_preproc_elif,
  [sym_preproc_if_in_expression] = sym_preproc_if,
  [sym_preproc_else_in_expression] = sym_preproc_else,
  [sym_preproc_elif_in_expression] = sym_preproc_elif,
  [sym_preproc_if_in_enum_member_declaration] = sym_preproc_if,
  [sym_preproc_else_in_enum_member_declaration] = sym_preproc_else,
  [sym_preproc_elif_in_enum_member_declaration] = sym_preproc_elif,
  [sym_preproc_if_in_attribute_list] = sym_preproc_if_in_attribute_list,
  [sym_preproc_else_in_attribute_list] = sym_preproc_else,
  [sym_preproc_elif_in_attribute_list] = sym_preproc_elif,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_unary_expression] = sym_preproc_unary_expression,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_preproc_region] = sym_preproc_region,
  [sym_preproc_endregion] = sym_preproc_endregion,
  [sym_preproc_line] = sym_preproc_line,
  [sym_preproc_pragma] = sym_preproc_pragma,
  [sym_preproc_nullable] = sym_preproc_nullable,
  [sym_preproc_error] = sym_preproc_error,
  [sym_preproc_warning] = sym_preproc_warning,
  [sym_preproc_define] = sym_preproc_define,
  [sym_preproc_undef] = sym_preproc_undef,
  [aux_sym_compilation_unit_repeat1] = aux_sym_compilation_unit_repeat1,
  [aux_sym_using_directive_repeat1] = aux_sym_using_directive_repeat1,
  [aux_sym_global_attribute_repeat1] = aux_sym_global_attribute_repeat1,
  [aux_sym_attribute_argument_list_repeat1] = aux_sym_attribute_argument_list_repeat1,
  [aux_sym__class_declaration_initializer_repeat1] = aux_sym__class_declaration_initializer_repeat1,
  [aux_sym__class_declaration_initializer_repeat2] = aux_sym__class_declaration_initializer_repeat2,
  [aux_sym__class_declaration_initializer_repeat3] = aux_sym__class_declaration_initializer_repeat3,
  [aux_sym__class_declaration_initializer_repeat4] = aux_sym__class_declaration_initializer_repeat4,
  [aux_sym_enum_member_declaration_list_repeat1] = aux_sym_enum_member_declaration_list_repeat1,
  [aux_sym__record_declaration_initializer_repeat1] = aux_sym__record_declaration_initializer_repeat1,
  [aux_sym_record_base_repeat1] = aux_sym_record_base_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_base_list_repeat1] = aux_sym_base_list_repeat1,
  [aux_sym_type_parameter_constraints_clause_repeat1] = aux_sym_type_parameter_constraints_clause_repeat1,
  [aux_sym_conversion_operator_declaration_repeat1] = aux_sym_conversion_operator_declaration_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_accessor_list_repeat1] = aux_sym_accessor_list_repeat1,
  [aux_sym_bracketed_parameter_list_repeat1] = aux_sym_bracketed_parameter_list_repeat1,
  [aux_sym__parameter_type_with_modifiers_repeat1] = aux_sym__parameter_type_with_modifiers_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_using_variable_declaration_repeat1] = aux_sym_using_variable_declaration_repeat1,
  [aux_sym_type_argument_list_repeat1] = aux_sym_type_argument_list_repeat1,
  [aux_sym_type_argument_list_repeat2] = aux_sym_type_argument_list_repeat2,
  [aux_sym_array_rank_specifier_repeat1] = aux_sym_array_rank_specifier_repeat1,
  [aux_sym_function_pointer_type_repeat1] = aux_sym_function_pointer_type_repeat1,
  [aux_sym_calling_convention_repeat1] = aux_sym_calling_convention_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym__for_statement_conditions_repeat1] = aux_sym__for_statement_conditions_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_catch_clause_repeat1] = aux_sym_catch_clause_repeat1,
  [aux_sym_list_pattern_repeat1] = aux_sym_list_pattern_repeat1,
  [aux_sym_positional_pattern_clause_repeat1] = aux_sym_positional_pattern_clause_repeat1,
  [aux_sym_parenthesized_variable_designation_repeat1] = aux_sym_parenthesized_variable_designation_repeat1,
  [aux_sym__query_body_repeat1] = aux_sym__query_body_repeat1,
  [aux_sym__query_body_repeat2] = aux_sym__query_body_repeat2,
  [aux_sym_order_by_clause_repeat1] = aux_sym_order_by_clause_repeat1,
  [aux_sym__switch_expression_body_repeat1] = aux_sym__switch_expression_body_repeat1,
  [aux_sym_interpolated_string_expression_repeat1] = aux_sym_interpolated_string_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat2] = aux_sym_interpolated_string_expression_repeat2,
  [aux_sym_interpolated_string_expression_repeat3] = aux_sym_interpolated_string_expression_repeat3,
  [aux_sym__lambda_expression_init_repeat1] = aux_sym__lambda_expression_init_repeat1,
  [aux_sym_anonymous_object_creation_expression_repeat1] = aux_sym_anonymous_object_creation_expression_repeat1,
  [aux_sym__with_body_repeat1] = aux_sym__with_body_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_preproc_if_in_top_level_repeat1] = aux_sym_preproc_if_in_top_level_repeat1,
  [aux_sym_preproc_pragma_repeat1] = aux_sym_preproc_pragma_repeat1,
  [alias_sym_element_binding_expression] = alias_sym_element_binding_expression,
  [alias_sym_implicit_parameter] = alias_sym_implicit_parameter,
  [alias_sym_interpolation_quote] = alias_sym_interpolation_quote,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_token] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_method] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typevar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_file] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partial] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_init] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_scoped] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_params] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_managed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Fastcall] = {
    .visible = true,
    .named = false,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unchecked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [sym_discard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_into] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_join] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equals] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orderby] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ascending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_descending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpolation_format_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stackalloc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___makeref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___reftype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___refvalue] = {
    .visible = true,
    .named = false,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_character_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_real_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_content_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal_encoding] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_raw_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_region_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_endregion_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_line_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_pragma_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warning] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checksum] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_nullable_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_annotations] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warnings] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_error_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_warning_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_define_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_undef_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__optional_semi] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation_regular_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_verbatim_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_raw_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_start_quote] = {
    .visible = true,
    .named = false,
  },
  [sym_interpolation_end_quote] = {
    .visible = true,
    .named = false,
  },
  [sym_interpolation_open_brace] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_close_brace] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_compilation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_alias_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_global_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_list] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute_target_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_file_scoped_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_member_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__interface_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_delegate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__delegate_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__record_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_record_base] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_list_body] = {
    .visible = false,
    .named = true,
  },
  [sym_primary_constructor_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_base_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraints_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_conversion_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_declaration_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_event_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_list] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_indexer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_interface_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_array] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_expression_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_using_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_using_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_alias_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_name] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_implicit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym__array_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_array_rank_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_nullable_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym__ref_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_type] = {
    .visible = true,
    .named = true,
  },
  [sym__scoped_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_element] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fixed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_conditions] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_lock_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_section] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_filter_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__foreach_statement_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__local_function_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_constant_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_var_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_type_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_recursive_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_property_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_subpattern] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_and_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_designation] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_variable_designation] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_non_lvalue_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_lvalue_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_statement_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_indirection_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_query_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_from_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__query_body] = {
    .visible = false,
    .named = true,
  },
  [sym__query_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_join_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__join_header] = {
    .visible = false,
    .named = true,
  },
  [sym__join_body] = {
    .visible = false,
    .named = true,
  },
  [sym_join_into_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_let_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_order_by_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__ordering] = {
    .visible = false,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__select_or_group_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_select_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_pattern_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_invocation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__switch_expression_body] = {
    .visible = false,
    .named = true,
  },
  [sym_switch_expression_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_when_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_element_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_string_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_verbatim_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_raw_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_alignment_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_format_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__parenthesized_lvalue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_expression_init] = {
    .visible = false,
    .named = true,
  },
  [sym__lambda_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_method_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__anonymous_object_member_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_implicit_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_stackalloc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__with_body] = {
    .visible = false,
    .named = true,
  },
  [sym_with_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_makeref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reftype_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_refvalue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_stackalloc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_region] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_endregion] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_line] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_nullable] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_error] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_warning] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_define] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_undef] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_compilation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_using_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_initializer_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_initializer_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_initializer_repeat4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_member_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_declaration_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_constraints_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_conversion_operator_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_accessor_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bracketed_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_type_with_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_using_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_rank_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_pointer_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_convention_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__for_statement_conditions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_positional_pattern_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_variable_designation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_order_by_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__switch_expression_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__lambda_expression_init_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_object_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__with_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_top_level_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_pragma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_element_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_implicit_parameter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_interpolation_quote] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_accessors = 1,
  field_alias = 2,
  field_alternative = 3,
  field_argument = 4,
  field_arguments = 5,
  field_body = 6,
  field_condition = 7,
  field_consequence = 8,
  field_content = 9,
  field_expression = 10,
  field_function = 11,
  field_initializer = 12,
  field_left = 13,
  field_name = 14,
  field_operator = 15,
  field_parameters = 16,
  field_pattern = 17,
  field_qualifier = 18,
  field_rank = 19,
  field_returns = 20,
  field_right = 21,
  field_subscript = 22,
  field_type = 23,
  field_type_parameters = 24,
  field_update = 25,
  field_value = 26,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_accessors] = "accessors",
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_expression] = "expression",
  [field_function] = "function",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_qualifier] = "qualifier",
  [field_rank] = "rank",
  [field_returns] = "returns",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 1},
  [10] = {.index = 6, .length = 2},
  [11] = {.index = 8, .length = 1},
  [12] = {.index = 9, .length = 3},
  [13] = {.index = 12, .length = 4},
  [14] = {.index = 16, .length = 2},
  [15] = {.index = 18, .length = 2},
  [16] = {.index = 20, .length = 4},
  [17] = {.index = 24, .length = 1},
  [18] = {.index = 25, .length = 5},
  [19] = {.index = 30, .length = 2},
  [20] = {.index = 32, .length = 2},
  [21] = {.index = 34, .length = 1},
  [22] = {.index = 35, .length = 1},
  [24] = {.index = 36, .length = 2},
  [25] = {.index = 38, .length = 2},
  [26] = {.index = 40, .length = 1},
  [27] = {.index = 41, .length = 1},
  [28] = {.index = 42, .length = 2},
  [29] = {.index = 44, .length = 2},
  [30] = {.index = 46, .length = 2},
  [31] = {.index = 48, .length = 2},
  [32] = {.index = 50, .length = 4},
  [33] = {.index = 54, .length = 2},
  [34] = {.index = 56, .length = 2},
  [35] = {.index = 58, .length = 2},
  [36] = {.index = 60, .length = 2},
  [37] = {.index = 62, .length = 3},
  [38] = {.index = 65, .length = 5},
  [39] = {.index = 70, .length = 3},
  [40] = {.index = 73, .length = 1},
  [41] = {.index = 73, .length = 1},
  [42] = {.index = 74, .length = 2},
  [43] = {.index = 76, .length = 3},
  [44] = {.index = 79, .length = 2},
  [45] = {.index = 81, .length = 2},
  [46] = {.index = 83, .length = 1},
  [48] = {.index = 84, .length = 2},
  [49] = {.index = 86, .length = 2},
  [50] = {.index = 88, .length = 4},
  [51] = {.index = 92, .length = 4},
  [52] = {.index = 96, .length = 2},
  [53] = {.index = 98, .length = 2},
  [54] = {.index = 100, .length = 3},
  [55] = {.index = 103, .length = 3},
  [56] = {.index = 106, .length = 1},
  [57] = {.index = 107, .length = 3},
  [58] = {.index = 110, .length = 2},
  [59] = {.index = 112, .length = 4},
  [60] = {.index = 116, .length = 1},
  [61] = {.index = 117, .length = 2},
  [62] = {.index = 119, .length = 1},
  [63] = {.index = 120, .length = 1},
  [64] = {.index = 121, .length = 2},
  [65] = {.index = 123, .length = 2},
  [66] = {.index = 125, .length = 1},
  [67] = {.index = 126, .length = 2},
  [68] = {.index = 128, .length = 1},
  [69] = {.index = 129, .length = 4},
  [70] = {.index = 133, .length = 2},
  [71] = {.index = 135, .length = 2},
  [72] = {.index = 137, .length = 1},
  [73] = {.index = 138, .length = 2},
  [74] = {.index = 140, .length = 2},
  [75] = {.index = 142, .length = 3},
  [76] = {.index = 145, .length = 2},
  [77] = {.index = 147, .length = 2},
  [78] = {.index = 149, .length = 1},
  [79] = {.index = 150, .length = 2},
  [80] = {.index = 152, .length = 2},
  [81] = {.index = 154, .length = 3},
  [82] = {.index = 157, .length = 2},
  [83] = {.index = 159, .length = 3},
  [84] = {.index = 162, .length = 1},
  [85] = {.index = 163, .length = 2},
  [86] = {.index = 165, .length = 1},
  [87] = {.index = 166, .length = 1},
  [88] = {.index = 167, .length = 1},
  [89] = {.index = 168, .length = 1},
  [90] = {.index = 169, .length = 1},
  [91] = {.index = 170, .length = 2},
  [92] = {.index = 172, .length = 2},
  [93] = {.index = 174, .length = 2},
  [94] = {.index = 176, .length = 3},
  [95] = {.index = 179, .length = 3},
  [96] = {.index = 182, .length = 3},
  [97] = {.index = 185, .length = 3},
  [98] = {.index = 188, .length = 4},
  [99] = {.index = 192, .length = 3},
  [100] = {.index = 195, .length = 2},
  [101] = {.index = 197, .length = 2},
  [102] = {.index = 199, .length = 1},
  [103] = {.index = 200, .length = 2},
  [104] = {.index = 202, .length = 4},
  [105] = {.index = 206, .length = 3},
  [106] = {.index = 209, .length = 1},
  [107] = {.index = 210, .length = 2},
  [108] = {.index = 212, .length = 2},
  [109] = {.index = 214, .length = 2},
  [110] = {.index = 216, .length = 2},
  [111] = {.index = 218, .length = 2},
  [112] = {.index = 220, .length = 2},
  [113] = {.index = 222, .length = 2},
  [114] = {.index = 224, .length = 3},
  [115] = {.index = 227, .length = 3},
  [116] = {.index = 230, .length = 3},
  [117] = {.index = 233, .length = 2},
  [118] = {.index = 235, .length = 3},
  [119] = {.index = 238, .length = 3},
  [120] = {.index = 241, .length = 4},
  [121] = {.index = 245, .length = 3},
  [122] = {.index = 248, .length = 3},
  [123] = {.index = 251, .length = 4},
  [124] = {.index = 255, .length = 3},
  [125] = {.index = 258, .length = 2},
  [126] = {.index = 260, .length = 5},
  [127] = {.index = 265, .length = 4},
  [128] = {.index = 269, .length = 3},
  [129] = {.index = 272, .length = 3},
  [130] = {.index = 275, .length = 4},
  [131] = {.index = 279, .length = 3},
  [132] = {.index = 282, .length = 1},
  [133] = {.index = 283, .length = 2},
  [134] = {.index = 285, .length = 4},
  [135] = {.index = 289, .length = 3},
  [136] = {.index = 292, .length = 3},
  [137] = {.index = 295, .length = 3},
  [138] = {.index = 298, .length = 3},
  [139] = {.index = 301, .length = 3},
  [140] = {.index = 304, .length = 3},
  [141] = {.index = 307, .length = 4},
  [142] = {.index = 311, .length = 3},
  [143] = {.index = 314, .length = 5},
  [144] = {.index = 319, .length = 4},
  [145] = {.index = 323, .length = 2},
  [146] = {.index = 325, .length = 5},
  [147] = {.index = 330, .length = 4},
  [148] = {.index = 334, .length = 3},
  [149] = {.index = 337, .length = 2},
  [150] = {.index = 339, .length = 3},
  [151] = {.index = 342, .length = 3},
  [152] = {.index = 345, .length = 4},
  [153] = {.index = 349, .length = 3},
  [154] = {.index = 352, .length = 3},
  [155] = {.index = 355, .length = 4},
  [156] = {.index = 359, .length = 3},
  [157] = {.index = 362, .length = 5},
  [158] = {.index = 367, .length = 4},
  [159] = {.index = 371, .length = 2},
  [160] = {.index = 373, .length = 3},
  [161] = {.index = 376, .length = 3},
  [162] = {.index = 379, .length = 4},
  [163] = {.index = 383, .length = 3},
  [164] = {.index = 386, .length = 1},
  [165] = {.index = 387, .length = 4},
  [166] = {.index = 391, .length = 4},
  [167] = {.index = 395, .length = 4},
  [168] = {.index = 399, .length = 4},
  [169] = {.index = 403, .length = 5},
  [170] = {.index = 408, .length = 4},
  [171] = {.index = 412, .length = 2},
  [172] = {.index = 414, .length = 4},
  [173] = {.index = 418, .length = 3},
  [174] = {.index = 421, .length = 5},
  [175] = {.index = 426, .length = 4},
  [176] = {.index = 430, .length = 5},
  [177] = {.index = 435, .length = 4},
  [178] = {.index = 439, .length = 2},
  [179] = {.index = 441, .length = 3},
  [180] = {.index = 444, .length = 3},
  [181] = {.index = 447, .length = 4},
  [182] = {.index = 451, .length = 3},
  [183] = {.index = 454, .length = 3},
  [184] = {.index = 457, .length = 4},
  [185] = {.index = 461, .length = 3},
  [186] = {.index = 464, .length = 5},
  [187] = {.index = 469, .length = 4},
  [188] = {.index = 473, .length = 5},
  [189] = {.index = 478, .length = 4},
  [190] = {.index = 482, .length = 5},
  [191] = {.index = 487, .length = 4},
  [192] = {.index = 491, .length = 4},
  [193] = {.index = 495, .length = 3},
  [194] = {.index = 498, .length = 5},
  [195] = {.index = 503, .length = 4},
  [196] = {.index = 507, .length = 5},
  [197] = {.index = 512, .length = 4},
  [198] = {.index = 516, .length = 4},
  [199] = {.index = 520, .length = 5},
  [200] = {.index = 525, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_parameters, 0},
  [1] =
    {field_name, 0},
  [2] =
    {field_type, 0},
  [3] =
    {field_name, 1},
  [4] =
    {field_type, 1},
  [5] =
    {field_body, 1},
  [6] =
    {field_body, 1, .inherited = true},
    {field_name, 0, .inherited = true},
  [8] =
    {field_name, 0, .inherited = true},
  [9] =
    {field_body, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [12] =
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [16] =
    {field_parameters, 1},
    {field_type, 0},
  [18] =
    {field_rank, 1},
    {field_type, 0},
  [20] =
    {field_body, 1},
    {field_left, 0, .inherited = true},
    {field_right, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [24] =
    {field_body, 0},
  [25] =
    {field_body, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [30] =
    {field_arguments, 1},
    {field_function, 0},
  [32] =
    {field_expression, 0},
    {field_subscript, 1},
  [34] =
    {field_parameters, 1},
  [35] =
    {field_content, 1},
  [36] =
    {field_name, 1},
    {field_type, 0},
  [38] =
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [40] =
    {field_name, 2},
  [41] =
    {field_type, 2},
  [42] =
    {field_name, 1},
    {field_type_parameters, 2},
  [44] =
    {field_arguments, 2},
    {field_type, 1},
  [46] =
    {field_initializer, 2},
    {field_type, 1},
  [48] =
    {field_expression, 0},
    {field_name, 2},
  [50] =
    {field_body, 2},
    {field_condition, 1, .inherited = true},
    {field_initializer, 1, .inherited = true},
    {field_update, 1, .inherited = true},
  [54] =
    {field_body, 2},
    {field_value, 1},
  [56] =
    {field_argument, 1},
    {field_operator, 0},
  [58] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
  [60] =
    {field_name, 2},
    {field_qualifier, 0},
  [62] =
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [65] =
    {field_body, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [70] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [73] =
    {field_condition, 0},
  [74] =
    {field_expression, 0},
    {field_pattern, 2},
  [76] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [79] =
    {field_alias, 0},
    {field_name, 2},
  [81] =
    {field_parameters, 2},
    {field_type, 1},
  [83] =
    {field_parameters, 2},
  [84] =
    {field_name, 2},
    {field_type, 1},
  [86] =
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [88] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [92] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [96] =
    {field_type, 1},
    {field_value, 3},
  [98] =
    {field_body, 2},
    {field_name, 1},
  [100] =
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [103] =
    {field_arguments, 2},
    {field_initializer, 3},
    {field_type, 1},
  [106] =
    {field_condition, 1},
  [107] =
    {field_body, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [110] =
    {field_name, 0},
    {field_parameters, 1},
  [112] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [116] =
    {field_name, 1, .inherited = true},
  [117] =
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [119] =
    {field_type, 1, .inherited = true},
  [120] =
    {field_name, 3},
  [121] =
    {field_name, 2},
    {field_type_parameters, 3},
  [123] =
    {field_parameters, 3},
    {field_type, 2},
  [125] =
    {field_body, 4},
  [126] =
    {field_name, 3},
    {field_type, 2},
  [128] =
    {field_returns, 3},
  [129] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [133] =
    {field_body, 4},
    {field_condition, 2},
  [135] =
    {field_body, 4},
    {field_value, 2},
  [137] =
    {field_body, 2},
  [138] =
    {field_condition, 2},
    {field_consequence, 4},
  [140] =
    {field_alternative, 3},
    {field_condition, 1},
  [142] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
  [145] =
    {field_name, 1},
    {field_parameters, 2},
  [147] =
    {field_name, 0},
    {field_value, 2},
  [149] =
    {field_name, 2, .inherited = true},
  [150] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [152] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [154] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [157] =
    {field_name, 2, .inherited = true},
    {field_type, 0},
  [159] =
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [162] =
    {field_name, 4},
  [163] =
    {field_name, 3},
    {field_type_parameters, 4},
  [165] =
    {field_returns, 4},
  [166] =
    {field_update, 3},
  [167] =
    {field_condition, 2},
  [168] =
    {field_initializer, 1},
  [169] =
    {field_body, 5},
  [170] =
    {field_left, 2},
    {field_right, 4},
  [172] =
    {field_type, 4},
    {field_value, 2},
  [174] =
    {field_alternative, 4},
    {field_condition, 1},
  [176] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
  [179] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [182] =
    {field_accessors, 3},
    {field_parameters, 2},
    {field_type, 0},
  [185] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
  [188] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_returns, 0},
  [192] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 2},
  [195] =
    {field_name, 2},
    {field_parameters, 3},
  [197] =
    {field_name, 1},
    {field_value, 3},
  [199] =
    {field_name, 3, .inherited = true},
  [200] =
    {field_name, 3, .inherited = true},
    {field_type, 0},
  [202] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [206] =
    {field_name, 4},
    {field_parameters, 5},
    {field_type, 3},
  [209] =
    {field_returns, 5},
  [210] =
    {field_body, 1},
    {field_condition, 4},
  [212] =
    {field_update, 3},
    {field_update, 4},
  [214] =
    {field_condition, 2},
    {field_update, 4},
  [216] =
    {field_initializer, 1},
    {field_update, 4},
  [218] =
    {field_condition, 3},
    {field_initializer, 1},
  [220] =
    {field_initializer, 1},
    {field_initializer, 2},
  [222] =
    {field_left, 3},
    {field_right, 5},
  [224] =
    {field_left, 3},
    {field_right, 5},
    {field_type, 2},
  [227] =
    {field_alternative, 6},
    {field_condition, 2},
    {field_consequence, 4},
  [230] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [233] =
    {field_name, 3},
    {field_type, 1},
  [235] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
  [238] =
    {field_body, 4, .inherited = true},
    {field_parameters, 3},
    {field_type, 2},
  [241] =
    {field_body, 4, .inherited = true},
    {field_operator, 2},
    {field_parameters, 3},
    {field_type, 0},
  [245] =
    {field_parameters, 2},
    {field_type, 0},
    {field_value, 3},
  [248] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 0},
  [251] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 0},
  [255] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 3},
  [258] =
    {field_body, 1, .inherited = true},
    {field_name, 0},
  [260] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_returns, 0},
    {field_type_parameters, 2},
  [265] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_returns, 0},
  [269] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
  [272] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 1},
  [275] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 1},
  [279] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 3},
  [282] =
    {field_name, 4, .inherited = true},
  [283] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
  [285] =
    {field_name, 4},
    {field_parameters, 6},
    {field_type, 3},
    {field_type_parameters, 5},
  [289] =
    {field_condition, 2},
    {field_update, 4},
    {field_update, 5},
  [292] =
    {field_initializer, 1},
    {field_update, 4},
    {field_update, 5},
  [295] =
    {field_condition, 3},
    {field_initializer, 1},
    {field_update, 5},
  [298] =
    {field_initializer, 1},
    {field_initializer, 2},
    {field_update, 5},
  [301] =
    {field_condition, 4},
    {field_initializer, 1},
    {field_initializer, 2},
  [304] =
    {field_left, 4},
    {field_right, 6},
    {field_type, 3},
  [307] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 0},
  [311] =
    {field_parameters, 3},
    {field_type, 0},
    {field_value, 4},
  [314] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 0},
    {field_type_parameters, 3},
  [319] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 0},
  [323] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
  [325] =
    {field_body, 5, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_returns, 0},
    {field_type_parameters, 2},
  [330] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
    {field_value, 4},
  [334] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
  [337] =
    {field_name, 4},
    {field_type, 2},
  [339] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
  [342] =
    {field_body, 5, .inherited = true},
    {field_parameters, 4},
    {field_type, 3},
  [345] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 1},
  [349] =
    {field_parameters, 3},
    {field_type, 1},
    {field_value, 4},
  [352] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 1},
  [355] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 1},
  [359] =
    {field_name, 3},
    {field_type, 1},
    {field_value, 4},
  [362] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 1},
    {field_type_parameters, 3},
  [367] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 1},
  [371] =
    {field_name, 4},
    {field_type, 3},
  [373] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 3},
  [376] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 2},
  [379] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 2},
  [383] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 4},
  [386] =
    {field_name, 5, .inherited = true},
  [387] =
    {field_condition, 3},
    {field_initializer, 1},
    {field_update, 5},
    {field_update, 6},
  [391] =
    {field_initializer, 1},
    {field_initializer, 2},
    {field_update, 5},
    {field_update, 6},
  [395] =
    {field_condition, 4},
    {field_initializer, 1},
    {field_initializer, 2},
    {field_update, 6},
  [399] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 0},
  [403] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 0},
    {field_type_parameters, 3},
  [408] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
    {field_value, 5},
  [412] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
  [414] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 1},
  [418] =
    {field_parameters, 4},
    {field_type, 1},
    {field_value, 5},
  [421] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 1},
    {field_type_parameters, 4},
  [426] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 1},
  [430] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 1},
    {field_type_parameters, 3},
  [435] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
    {field_value, 5},
  [439] =
    {field_name, 5},
    {field_type, 3},
  [441] =
    {field_accessors, 6},
    {field_name, 5},
    {field_type, 3},
  [444] =
    {field_body, 6, .inherited = true},
    {field_parameters, 5},
    {field_type, 4},
  [447] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 2},
  [451] =
    {field_parameters, 4},
    {field_type, 2},
    {field_value, 5},
  [454] =
    {field_accessors, 6},
    {field_parameters, 5},
    {field_type, 2},
  [457] =
    {field_body, 6, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_returns, 2},
  [461] =
    {field_name, 4},
    {field_type, 2},
    {field_value, 5},
  [464] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 2},
    {field_type_parameters, 4},
  [469] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 2},
  [473] =
    {field_condition, 4},
    {field_initializer, 1},
    {field_initializer, 2},
    {field_update, 6},
    {field_update, 7},
  [478] =
    {field_body, 7, .inherited = true},
    {field_operator, 5},
    {field_parameters, 6},
    {field_type, 1},
  [482] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 1},
    {field_type_parameters, 4},
  [487] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
    {field_value, 6},
  [491] =
    {field_body, 7, .inherited = true},
    {field_operator, 5},
    {field_parameters, 6},
    {field_type, 2},
  [495] =
    {field_parameters, 5},
    {field_type, 2},
    {field_value, 6},
  [498] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_returns, 2},
    {field_type_parameters, 5},
  [503] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_returns, 2},
  [507] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 2},
    {field_type_parameters, 4},
  [512] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
    {field_value, 6},
  [516] =
    {field_body, 8, .inherited = true},
    {field_operator, 6},
    {field_parameters, 7},
    {field_type, 2},
  [520] =
    {field_body, 8, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_returns, 2},
    {field_type_parameters, 5},
  [525] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
    {field_value, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_modifier,
  },
  [2] = {
    [0] = alias_sym_element_binding_expression,
  },
  [4] = {
    [0] = alias_sym_implicit_parameter,
  },
  [23] = {
    [1] = alias_sym_interpolation_quote,
    [2] = alias_sym_interpolation_quote,
  },
  [40] = {
    [2] = alias_sym_element_binding_expression,
  },
  [47] = {
    [1] = alias_sym_interpolation_quote,
    [3] = alias_sym_interpolation_quote,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_bracketed_argument_list, 2,
    sym_bracketed_argument_list,
    alias_sym_element_binding_expression,
  sym_identifier, 2,
    sym_identifier,
    alias_sym_implicit_parameter,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 9,
  [10] = 10,
  [11] = 10,
  [12] = 10,
  [13] = 13,
  [14] = 10,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 25,
  [27] = 25,
  [28] = 28,
  [29] = 29,
  [30] = 25,
  [31] = 31,
  [32] = 25,
  [33] = 25,
  [34] = 25,
  [35] = 25,
  [36] = 25,
  [37] = 37,
  [38] = 38,
  [39] = 25,
  [40] = 40,
  [41] = 41,
  [42] = 41,
  [43] = 40,
  [44] = 41,
  [45] = 40,
  [46] = 41,
  [47] = 40,
  [48] = 41,
  [49] = 40,
  [50] = 41,
  [51] = 40,
  [52] = 41,
  [53] = 40,
  [54] = 41,
  [55] = 40,
  [56] = 41,
  [57] = 40,
  [58] = 41,
  [59] = 40,
  [60] = 41,
  [61] = 40,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 64,
  [66] = 63,
  [67] = 67,
  [68] = 68,
  [69] = 68,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 63,
  [74] = 71,
  [75] = 72,
  [76] = 76,
  [77] = 67,
  [78] = 78,
  [79] = 76,
  [80] = 67,
  [81] = 62,
  [82] = 82,
  [83] = 70,
  [84] = 78,
  [85] = 64,
  [86] = 82,
  [87] = 63,
  [88] = 62,
  [89] = 62,
  [90] = 68,
  [91] = 70,
  [92] = 68,
  [93] = 71,
  [94] = 72,
  [95] = 70,
  [96] = 76,
  [97] = 67,
  [98] = 78,
  [99] = 64,
  [100] = 71,
  [101] = 72,
  [102] = 82,
  [103] = 76,
  [104] = 82,
  [105] = 78,
  [106] = 106,
  [107] = 106,
  [108] = 106,
  [109] = 106,
  [110] = 106,
  [111] = 106,
  [112] = 106,
  [113] = 106,
  [114] = 114,
  [115] = 115,
  [116] = 115,
  [117] = 115,
  [118] = 115,
  [119] = 115,
  [120] = 115,
  [121] = 115,
  [122] = 115,
  [123] = 115,
  [124] = 115,
  [125] = 115,
  [126] = 115,
  [127] = 115,
  [128] = 115,
  [129] = 115,
  [130] = 115,
  [131] = 131,
  [132] = 115,
  [133] = 115,
  [134] = 115,
  [135] = 115,
  [136] = 115,
  [137] = 115,
  [138] = 138,
  [139] = 115,
  [140] = 115,
  [141] = 115,
  [142] = 115,
  [143] = 115,
  [144] = 115,
  [145] = 115,
  [146] = 115,
  [147] = 147,
  [148] = 147,
  [149] = 138,
  [150] = 131,
  [151] = 138,
  [152] = 131,
  [153] = 131,
  [154] = 138,
  [155] = 131,
  [156] = 138,
  [157] = 131,
  [158] = 138,
  [159] = 138,
  [160] = 131,
  [161] = 131,
  [162] = 138,
  [163] = 138,
  [164] = 131,
  [165] = 131,
  [166] = 138,
  [167] = 131,
  [168] = 131,
  [169] = 138,
  [170] = 138,
  [171] = 171,
  [172] = 138,
  [173] = 138,
  [174] = 131,
  [175] = 138,
  [176] = 131,
  [177] = 171,
  [178] = 131,
  [179] = 138,
  [180] = 138,
  [181] = 131,
  [182] = 138,
  [183] = 131,
  [184] = 138,
  [185] = 131,
  [186] = 138,
  [187] = 131,
  [188] = 138,
  [189] = 131,
  [190] = 131,
  [191] = 138,
  [192] = 131,
  [193] = 138,
  [194] = 171,
  [195] = 138,
  [196] = 131,
  [197] = 138,
  [198] = 138,
  [199] = 171,
  [200] = 171,
  [201] = 171,
  [202] = 171,
  [203] = 131,
  [204] = 131,
  [205] = 138,
  [206] = 131,
  [207] = 171,
  [208] = 131,
  [209] = 138,
  [210] = 131,
  [211] = 138,
  [212] = 131,
  [213] = 138,
  [214] = 131,
  [215] = 138,
  [216] = 138,
  [217] = 217,
  [218] = 131,
  [219] = 131,
  [220] = 138,
  [221] = 131,
  [222] = 138,
  [223] = 138,
  [224] = 131,
  [225] = 131,
  [226] = 226,
  [227] = 138,
  [228] = 228,
  [229] = 229,
  [230] = 226,
  [231] = 231,
  [232] = 131,
  [233] = 138,
  [234] = 229,
  [235] = 228,
  [236] = 228,
  [237] = 131,
  [238] = 229,
  [239] = 226,
  [240] = 138,
  [241] = 226,
  [242] = 242,
  [243] = 229,
  [244] = 138,
  [245] = 131,
  [246] = 228,
  [247] = 247,
  [248] = 228,
  [249] = 131,
  [250] = 228,
  [251] = 131,
  [252] = 138,
  [253] = 131,
  [254] = 138,
  [255] = 138,
  [256] = 231,
  [257] = 131,
  [258] = 258,
  [259] = 138,
  [260] = 131,
  [261] = 138,
  [262] = 262,
  [263] = 131,
  [264] = 131,
  [265] = 262,
  [266] = 131,
  [267] = 131,
  [268] = 131,
  [269] = 138,
  [270] = 138,
  [271] = 138,
  [272] = 262,
  [273] = 273,
  [274] = 258,
  [275] = 138,
  [276] = 258,
  [277] = 277,
  [278] = 262,
  [279] = 131,
  [280] = 138,
  [281] = 262,
  [282] = 138,
  [283] = 262,
  [284] = 258,
  [285] = 273,
  [286] = 258,
  [287] = 277,
  [288] = 258,
  [289] = 131,
  [290] = 290,
  [291] = 291,
  [292] = 290,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 291,
  [297] = 291,
  [298] = 290,
  [299] = 295,
  [300] = 290,
  [301] = 295,
  [302] = 290,
  [303] = 290,
  [304] = 291,
  [305] = 290,
  [306] = 294,
  [307] = 295,
  [308] = 295,
  [309] = 295,
  [310] = 290,
  [311] = 291,
  [312] = 295,
  [313] = 295,
  [314] = 314,
  [315] = 314,
  [316] = 316,
  [317] = 314,
  [318] = 314,
  [319] = 319,
  [320] = 320,
  [321] = 316,
  [322] = 314,
  [323] = 320,
  [324] = 314,
  [325] = 316,
  [326] = 316,
  [327] = 314,
  [328] = 319,
  [329] = 319,
  [330] = 320,
  [331] = 316,
  [332] = 332,
  [333] = 316,
  [334] = 314,
  [335] = 319,
  [336] = 320,
  [337] = 316,
  [338] = 314,
  [339] = 319,
  [340] = 320,
  [341] = 314,
  [342] = 316,
  [343] = 319,
  [344] = 320,
  [345] = 319,
  [346] = 316,
  [347] = 314,
  [348] = 316,
  [349] = 320,
  [350] = 320,
  [351] = 319,
  [352] = 320,
  [353] = 314,
  [354] = 314,
  [355] = 316,
  [356] = 319,
  [357] = 316,
  [358] = 319,
  [359] = 319,
  [360] = 320,
  [361] = 314,
  [362] = 316,
  [363] = 319,
  [364] = 316,
  [365] = 316,
  [366] = 320,
  [367] = 316,
  [368] = 316,
  [369] = 314,
  [370] = 316,
  [371] = 316,
  [372] = 319,
  [373] = 316,
  [374] = 316,
  [375] = 320,
  [376] = 316,
  [377] = 316,
  [378] = 320,
  [379] = 316,
  [380] = 316,
  [381] = 320,
  [382] = 316,
  [383] = 316,
  [384] = 316,
  [385] = 319,
  [386] = 314,
  [387] = 319,
  [388] = 320,
  [389] = 389,
  [390] = 314,
  [391] = 319,
  [392] = 319,
  [393] = 314,
  [394] = 319,
  [395] = 320,
  [396] = 320,
  [397] = 316,
  [398] = 316,
  [399] = 316,
  [400] = 320,
  [401] = 314,
  [402] = 389,
  [403] = 314,
  [404] = 319,
  [405] = 320,
  [406] = 319,
  [407] = 320,
  [408] = 316,
  [409] = 316,
  [410] = 316,
  [411] = 314,
  [412] = 319,
  [413] = 314,
  [414] = 319,
  [415] = 320,
  [416] = 320,
  [417] = 316,
  [418] = 316,
  [419] = 316,
  [420] = 319,
  [421] = 316,
  [422] = 314,
  [423] = 320,
  [424] = 314,
  [425] = 425,
  [426] = 314,
  [427] = 319,
  [428] = 320,
  [429] = 314,
  [430] = 319,
  [431] = 316,
  [432] = 316,
  [433] = 314,
  [434] = 319,
  [435] = 320,
  [436] = 316,
  [437] = 316,
  [438] = 320,
  [439] = 316,
  [440] = 319,
  [441] = 316,
  [442] = 320,
  [443] = 316,
  [444] = 314,
  [445] = 314,
  [446] = 319,
  [447] = 314,
  [448] = 319,
  [449] = 320,
  [450] = 316,
  [451] = 319,
  [452] = 320,
  [453] = 320,
  [454] = 316,
  [455] = 316,
  [456] = 456,
  [457] = 456,
  [458] = 458,
  [459] = 458,
  [460] = 458,
  [461] = 458,
  [462] = 458,
  [463] = 458,
  [464] = 458,
  [465] = 465,
  [466] = 465,
  [467] = 465,
  [468] = 465,
  [469] = 469,
  [470] = 465,
  [471] = 465,
  [472] = 465,
  [473] = 465,
  [474] = 465,
  [475] = 465,
  [476] = 465,
  [477] = 465,
  [478] = 465,
  [479] = 465,
  [480] = 465,
  [481] = 465,
  [482] = 465,
  [483] = 465,
  [484] = 465,
  [485] = 465,
  [486] = 465,
  [487] = 465,
  [488] = 465,
  [489] = 465,
  [490] = 465,
  [491] = 465,
  [492] = 465,
  [493] = 465,
  [494] = 465,
  [495] = 465,
  [496] = 465,
  [497] = 465,
  [498] = 465,
  [499] = 465,
  [500] = 465,
  [501] = 465,
  [502] = 465,
  [503] = 465,
  [504] = 465,
  [505] = 465,
  [506] = 465,
  [507] = 465,
  [508] = 465,
  [509] = 465,
  [510] = 465,
  [511] = 465,
  [512] = 465,
  [513] = 465,
  [514] = 465,
  [515] = 465,
  [516] = 465,
  [517] = 465,
  [518] = 465,
  [519] = 465,
  [520] = 465,
  [521] = 465,
  [522] = 465,
  [523] = 465,
  [524] = 524,
  [525] = 525,
  [526] = 525,
  [527] = 525,
  [528] = 525,
  [529] = 525,
  [530] = 525,
  [531] = 525,
  [532] = 525,
  [533] = 525,
  [534] = 525,
  [535] = 535,
  [536] = 535,
  [537] = 535,
  [538] = 535,
  [539] = 535,
  [540] = 535,
  [541] = 535,
  [542] = 542,
  [543] = 543,
  [544] = 543,
  [545] = 543,
  [546] = 546,
  [547] = 546,
  [548] = 542,
  [549] = 549,
  [550] = 542,
  [551] = 543,
  [552] = 546,
  [553] = 546,
  [554] = 542,
  [555] = 543,
  [556] = 542,
  [557] = 546,
  [558] = 546,
  [559] = 543,
  [560] = 560,
  [561] = 560,
  [562] = 562,
  [563] = 560,
  [564] = 564,
  [565] = 565,
  [566] = 560,
  [567] = 562,
  [568] = 564,
  [569] = 562,
  [570] = 570,
  [571] = 565,
  [572] = 562,
  [573] = 560,
  [574] = 560,
  [575] = 575,
  [576] = 576,
  [577] = 575,
  [578] = 576,
  [579] = 575,
  [580] = 576,
  [581] = 576,
  [582] = 576,
  [583] = 583,
  [584] = 576,
  [585] = 575,
  [586] = 576,
  [587] = 575,
  [588] = 588,
  [589] = 576,
  [590] = 575,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 593,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 598,
  [600] = 600,
  [601] = 598,
  [602] = 591,
  [603] = 603,
  [604] = 600,
  [605] = 595,
  [606] = 606,
  [607] = 597,
  [608] = 598,
  [609] = 598,
  [610] = 595,
  [611] = 598,
  [612] = 598,
  [613] = 598,
  [614] = 598,
  [615] = 598,
  [616] = 592,
  [617] = 600,
  [618] = 598,
  [619] = 591,
  [620] = 593,
  [621] = 597,
  [622] = 598,
  [623] = 598,
  [624] = 598,
  [625] = 598,
  [626] = 598,
  [627] = 598,
  [628] = 600,
  [629] = 591,
  [630] = 598,
  [631] = 598,
  [632] = 598,
  [633] = 598,
  [634] = 598,
  [635] = 598,
  [636] = 595,
  [637] = 637,
  [638] = 593,
  [639] = 598,
  [640] = 598,
  [641] = 598,
  [642] = 593,
  [643] = 596,
  [644] = 598,
  [645] = 598,
  [646] = 598,
  [647] = 598,
  [648] = 648,
  [649] = 598,
  [650] = 598,
  [651] = 592,
  [652] = 598,
  [653] = 595,
  [654] = 597,
  [655] = 598,
  [656] = 597,
  [657] = 598,
  [658] = 598,
  [659] = 598,
  [660] = 595,
  [661] = 598,
  [662] = 662,
  [663] = 597,
  [664] = 598,
  [665] = 598,
  [666] = 598,
  [667] = 592,
  [668] = 598,
  [669] = 598,
  [670] = 598,
  [671] = 596,
  [672] = 598,
  [673] = 648,
  [674] = 598,
  [675] = 596,
  [676] = 593,
  [677] = 598,
  [678] = 598,
  [679] = 598,
  [680] = 598,
  [681] = 681,
  [682] = 682,
  [683] = 681,
  [684] = 682,
  [685] = 685,
  [686] = 681,
  [687] = 682,
  [688] = 682,
  [689] = 681,
  [690] = 681,
  [691] = 691,
  [692] = 682,
  [693] = 682,
  [694] = 682,
  [695] = 681,
  [696] = 682,
  [697] = 697,
  [698] = 682,
  [699] = 699,
  [700] = 682,
  [701] = 701,
  [702] = 682,
  [703] = 682,
  [704] = 682,
  [705] = 705,
  [706] = 706,
  [707] = 682,
  [708] = 682,
  [709] = 681,
  [710] = 682,
  [711] = 711,
  [712] = 681,
  [713] = 682,
  [714] = 714,
  [715] = 681,
  [716] = 705,
  [717] = 682,
  [718] = 682,
  [719] = 681,
  [720] = 720,
  [721] = 681,
  [722] = 691,
  [723] = 682,
  [724] = 681,
  [725] = 711,
  [726] = 682,
  [727] = 714,
  [728] = 682,
  [729] = 691,
  [730] = 681,
  [731] = 681,
  [732] = 681,
  [733] = 681,
  [734] = 681,
  [735] = 682,
  [736] = 682,
  [737] = 682,
  [738] = 682,
  [739] = 681,
  [740] = 681,
  [741] = 681,
  [742] = 682,
  [743] = 705,
  [744] = 681,
  [745] = 681,
  [746] = 705,
  [747] = 681,
  [748] = 682,
  [749] = 682,
  [750] = 720,
  [751] = 682,
  [752] = 752,
  [753] = 682,
  [754] = 682,
  [755] = 681,
  [756] = 756,
  [757] = 682,
  [758] = 720,
  [759] = 681,
  [760] = 681,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 682,
  [765] = 705,
  [766] = 682,
  [767] = 767,
  [768] = 681,
  [769] = 769,
  [770] = 681,
  [771] = 681,
  [772] = 682,
  [773] = 682,
  [774] = 681,
  [775] = 681,
  [776] = 776,
  [777] = 682,
  [778] = 705,
  [779] = 714,
  [780] = 681,
  [781] = 682,
  [782] = 714,
  [783] = 681,
  [784] = 682,
  [785] = 682,
  [786] = 682,
  [787] = 682,
  [788] = 682,
  [789] = 682,
  [790] = 720,
  [791] = 681,
  [792] = 682,
  [793] = 681,
  [794] = 682,
  [795] = 681,
  [796] = 681,
  [797] = 681,
  [798] = 682,
  [799] = 682,
  [800] = 682,
  [801] = 682,
  [802] = 682,
  [803] = 682,
  [804] = 711,
  [805] = 805,
  [806] = 720,
  [807] = 681,
  [808] = 681,
  [809] = 809,
  [810] = 681,
  [811] = 682,
  [812] = 681,
  [813] = 682,
  [814] = 681,
  [815] = 682,
  [816] = 682,
  [817] = 681,
  [818] = 711,
  [819] = 682,
  [820] = 820,
  [821] = 682,
  [822] = 682,
  [823] = 682,
  [824] = 720,
  [825] = 681,
  [826] = 681,
  [827] = 682,
  [828] = 682,
  [829] = 681,
  [830] = 681,
  [831] = 681,
  [832] = 682,
  [833] = 682,
  [834] = 691,
  [835] = 711,
  [836] = 681,
  [837] = 837,
  [838] = 682,
  [839] = 682,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 840,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 848,
  [860] = 841,
  [861] = 842,
  [862] = 840,
  [863] = 841,
  [864] = 845,
  [865] = 846,
  [866] = 847,
  [867] = 842,
  [868] = 849,
  [869] = 850,
  [870] = 851,
  [871] = 852,
  [872] = 853,
  [873] = 854,
  [874] = 855,
  [875] = 856,
  [876] = 857,
  [877] = 858,
  [878] = 840,
  [879] = 848,
  [880] = 841,
  [881] = 842,
  [882] = 840,
  [883] = 845,
  [884] = 884,
  [885] = 847,
  [886] = 886,
  [887] = 849,
  [888] = 850,
  [889] = 851,
  [890] = 852,
  [891] = 853,
  [892] = 854,
  [893] = 855,
  [894] = 856,
  [895] = 857,
  [896] = 858,
  [897] = 848,
  [898] = 841,
  [899] = 842,
  [900] = 840,
  [901] = 845,
  [902] = 902,
  [903] = 847,
  [904] = 904,
  [905] = 849,
  [906] = 906,
  [907] = 907,
  [908] = 850,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 849,
  [914] = 850,
  [915] = 915,
  [916] = 916,
  [917] = 851,
  [918] = 852,
  [919] = 853,
  [920] = 854,
  [921] = 855,
  [922] = 856,
  [923] = 857,
  [924] = 858,
  [925] = 848,
  [926] = 841,
  [927] = 842,
  [928] = 840,
  [929] = 907,
  [930] = 845,
  [931] = 846,
  [932] = 932,
  [933] = 933,
  [934] = 847,
  [935] = 935,
  [936] = 936,
  [937] = 910,
  [938] = 911,
  [939] = 851,
  [940] = 852,
  [941] = 853,
  [942] = 854,
  [943] = 855,
  [944] = 856,
  [945] = 857,
  [946] = 858,
  [947] = 848,
  [948] = 841,
  [949] = 842,
  [950] = 845,
  [951] = 845,
  [952] = 849,
  [953] = 850,
  [954] = 954,
  [955] = 849,
  [956] = 840,
  [957] = 850,
  [958] = 846,
  [959] = 847,
  [960] = 851,
  [961] = 852,
  [962] = 853,
  [963] = 854,
  [964] = 855,
  [965] = 856,
  [966] = 857,
  [967] = 858,
  [968] = 848,
  [969] = 841,
  [970] = 842,
  [971] = 845,
  [972] = 849,
  [973] = 850,
  [974] = 840,
  [975] = 847,
  [976] = 849,
  [977] = 850,
  [978] = 851,
  [979] = 852,
  [980] = 853,
  [981] = 854,
  [982] = 855,
  [983] = 856,
  [984] = 857,
  [985] = 858,
  [986] = 848,
  [987] = 841,
  [988] = 842,
  [989] = 840,
  [990] = 845,
  [991] = 847,
  [992] = 910,
  [993] = 911,
  [994] = 851,
  [995] = 852,
  [996] = 853,
  [997] = 854,
  [998] = 855,
  [999] = 849,
  [1000] = 850,
  [1001] = 856,
  [1002] = 857,
  [1003] = 858,
  [1004] = 848,
  [1005] = 841,
  [1006] = 842,
  [1007] = 840,
  [1008] = 851,
  [1009] = 852,
  [1010] = 853,
  [1011] = 854,
  [1012] = 855,
  [1013] = 856,
  [1014] = 857,
  [1015] = 858,
  [1016] = 907,
  [1017] = 848,
  [1018] = 841,
  [1019] = 842,
  [1020] = 840,
  [1021] = 907,
  [1022] = 845,
  [1023] = 845,
  [1024] = 846,
  [1025] = 847,
  [1026] = 936,
  [1027] = 846,
  [1028] = 851,
  [1029] = 852,
  [1030] = 853,
  [1031] = 854,
  [1032] = 855,
  [1033] = 856,
  [1034] = 857,
  [1035] = 858,
  [1036] = 848,
  [1037] = 841,
  [1038] = 842,
  [1039] = 845,
  [1040] = 849,
  [1041] = 850,
  [1042] = 840,
  [1043] = 846,
  [1044] = 847,
  [1045] = 851,
  [1046] = 852,
  [1047] = 853,
  [1048] = 854,
  [1049] = 855,
  [1050] = 856,
  [1051] = 857,
  [1052] = 858,
  [1053] = 848,
  [1054] = 841,
  [1055] = 842,
  [1056] = 845,
  [1057] = 849,
  [1058] = 850,
  [1059] = 840,
  [1060] = 847,
  [1061] = 849,
  [1062] = 850,
  [1063] = 851,
  [1064] = 852,
  [1065] = 853,
  [1066] = 854,
  [1067] = 855,
  [1068] = 856,
  [1069] = 857,
  [1070] = 858,
  [1071] = 848,
  [1072] = 841,
  [1073] = 842,
  [1074] = 840,
  [1075] = 845,
  [1076] = 847,
  [1077] = 847,
  [1078] = 910,
  [1079] = 911,
  [1080] = 1080,
  [1081] = 936,
  [1082] = 849,
  [1083] = 850,
  [1084] = 851,
  [1085] = 852,
  [1086] = 853,
  [1087] = 854,
  [1088] = 855,
  [1089] = 856,
  [1090] = 857,
  [1091] = 858,
  [1092] = 848,
  [1093] = 841,
  [1094] = 842,
  [1095] = 840,
  [1096] = 907,
  [1097] = 845,
  [1098] = 846,
  [1099] = 1099,
  [1100] = 847,
  [1101] = 849,
  [1102] = 936,
  [1103] = 850,
  [1104] = 851,
  [1105] = 852,
  [1106] = 853,
  [1107] = 854,
  [1108] = 855,
  [1109] = 856,
  [1110] = 857,
  [1111] = 858,
  [1112] = 848,
  [1113] = 841,
  [1114] = 842,
  [1115] = 845,
  [1116] = 849,
  [1117] = 850,
  [1118] = 840,
  [1119] = 846,
  [1120] = 847,
  [1121] = 851,
  [1122] = 852,
  [1123] = 853,
  [1124] = 854,
  [1125] = 855,
  [1126] = 856,
  [1127] = 857,
  [1128] = 858,
  [1129] = 848,
  [1130] = 841,
  [1131] = 842,
  [1132] = 845,
  [1133] = 849,
  [1134] = 850,
  [1135] = 851,
  [1136] = 852,
  [1137] = 853,
  [1138] = 854,
  [1139] = 847,
  [1140] = 855,
  [1141] = 849,
  [1142] = 850,
  [1143] = 851,
  [1144] = 852,
  [1145] = 853,
  [1146] = 854,
  [1147] = 855,
  [1148] = 856,
  [1149] = 857,
  [1150] = 858,
  [1151] = 856,
  [1152] = 848,
  [1153] = 841,
  [1154] = 842,
  [1155] = 840,
  [1156] = 857,
  [1157] = 845,
  [1158] = 858,
  [1159] = 847,
  [1160] = 848,
  [1161] = 841,
  [1162] = 842,
  [1163] = 910,
  [1164] = 911,
  [1165] = 840,
  [1166] = 849,
  [1167] = 850,
  [1168] = 845,
  [1169] = 851,
  [1170] = 852,
  [1171] = 853,
  [1172] = 854,
  [1173] = 855,
  [1174] = 856,
  [1175] = 857,
  [1176] = 858,
  [1177] = 846,
  [1178] = 848,
  [1179] = 841,
  [1180] = 842,
  [1181] = 840,
  [1182] = 907,
  [1183] = 1183,
  [1184] = 845,
  [1185] = 1185,
  [1186] = 846,
  [1187] = 1187,
  [1188] = 847,
  [1189] = 847,
  [1190] = 936,
  [1191] = 851,
  [1192] = 852,
  [1193] = 853,
  [1194] = 854,
  [1195] = 855,
  [1196] = 856,
  [1197] = 857,
  [1198] = 858,
  [1199] = 848,
  [1200] = 841,
  [1201] = 842,
  [1202] = 845,
  [1203] = 846,
  [1204] = 849,
  [1205] = 850,
  [1206] = 840,
  [1207] = 846,
  [1208] = 847,
  [1209] = 851,
  [1210] = 852,
  [1211] = 853,
  [1212] = 854,
  [1213] = 855,
  [1214] = 856,
  [1215] = 857,
  [1216] = 858,
  [1217] = 848,
  [1218] = 841,
  [1219] = 842,
  [1220] = 845,
  [1221] = 849,
  [1222] = 850,
  [1223] = 1223,
  [1224] = 840,
  [1225] = 847,
  [1226] = 849,
  [1227] = 849,
  [1228] = 850,
  [1229] = 851,
  [1230] = 852,
  [1231] = 853,
  [1232] = 854,
  [1233] = 855,
  [1234] = 856,
  [1235] = 857,
  [1236] = 858,
  [1237] = 850,
  [1238] = 848,
  [1239] = 841,
  [1240] = 842,
  [1241] = 840,
  [1242] = 845,
  [1243] = 847,
  [1244] = 910,
  [1245] = 911,
  [1246] = 849,
  [1247] = 850,
  [1248] = 851,
  [1249] = 852,
  [1250] = 853,
  [1251] = 854,
  [1252] = 855,
  [1253] = 856,
  [1254] = 857,
  [1255] = 858,
  [1256] = 848,
  [1257] = 841,
  [1258] = 842,
  [1259] = 851,
  [1260] = 840,
  [1261] = 907,
  [1262] = 852,
  [1263] = 845,
  [1264] = 853,
  [1265] = 846,
  [1266] = 854,
  [1267] = 847,
  [1268] = 855,
  [1269] = 856,
  [1270] = 936,
  [1271] = 857,
  [1272] = 851,
  [1273] = 852,
  [1274] = 853,
  [1275] = 854,
  [1276] = 855,
  [1277] = 856,
  [1278] = 857,
  [1279] = 858,
  [1280] = 848,
  [1281] = 841,
  [1282] = 842,
  [1283] = 858,
  [1284] = 845,
  [1285] = 849,
  [1286] = 850,
  [1287] = 848,
  [1288] = 840,
  [1289] = 841,
  [1290] = 846,
  [1291] = 847,
  [1292] = 851,
  [1293] = 852,
  [1294] = 853,
  [1295] = 854,
  [1296] = 855,
  [1297] = 856,
  [1298] = 857,
  [1299] = 858,
  [1300] = 848,
  [1301] = 841,
  [1302] = 842,
  [1303] = 845,
  [1304] = 842,
  [1305] = 849,
  [1306] = 850,
  [1307] = 840,
  [1308] = 840,
  [1309] = 847,
  [1310] = 849,
  [1311] = 850,
  [1312] = 851,
  [1313] = 852,
  [1314] = 853,
  [1315] = 854,
  [1316] = 855,
  [1317] = 856,
  [1318] = 857,
  [1319] = 858,
  [1320] = 848,
  [1321] = 841,
  [1322] = 842,
  [1323] = 840,
  [1324] = 845,
  [1325] = 847,
  [1326] = 845,
  [1327] = 910,
  [1328] = 911,
  [1329] = 849,
  [1330] = 850,
  [1331] = 851,
  [1332] = 852,
  [1333] = 853,
  [1334] = 854,
  [1335] = 855,
  [1336] = 856,
  [1337] = 857,
  [1338] = 858,
  [1339] = 848,
  [1340] = 841,
  [1341] = 842,
  [1342] = 840,
  [1343] = 907,
  [1344] = 845,
  [1345] = 846,
  [1346] = 846,
  [1347] = 847,
  [1348] = 936,
  [1349] = 851,
  [1350] = 852,
  [1351] = 853,
  [1352] = 854,
  [1353] = 855,
  [1354] = 856,
  [1355] = 857,
  [1356] = 858,
  [1357] = 848,
  [1358] = 841,
  [1359] = 842,
  [1360] = 845,
  [1361] = 846,
  [1362] = 849,
  [1363] = 850,
  [1364] = 840,
  [1365] = 847,
  [1366] = 1366,
  [1367] = 849,
  [1368] = 850,
  [1369] = 851,
  [1370] = 852,
  [1371] = 853,
  [1372] = 854,
  [1373] = 855,
  [1374] = 856,
  [1375] = 857,
  [1376] = 858,
  [1377] = 1377,
  [1378] = 848,
  [1379] = 841,
  [1380] = 842,
  [1381] = 840,
  [1382] = 845,
  [1383] = 847,
  [1384] = 910,
  [1385] = 911,
  [1386] = 849,
  [1387] = 850,
  [1388] = 851,
  [1389] = 852,
  [1390] = 853,
  [1391] = 854,
  [1392] = 855,
  [1393] = 856,
  [1394] = 857,
  [1395] = 858,
  [1396] = 848,
  [1397] = 841,
  [1398] = 842,
  [1399] = 847,
  [1400] = 840,
  [1401] = 907,
  [1402] = 1402,
  [1403] = 845,
  [1404] = 1404,
  [1405] = 846,
  [1406] = 847,
  [1407] = 936,
  [1408] = 851,
  [1409] = 852,
  [1410] = 853,
  [1411] = 855,
  [1412] = 856,
  [1413] = 857,
  [1414] = 858,
  [1415] = 848,
  [1416] = 841,
  [1417] = 842,
  [1418] = 845,
  [1419] = 849,
  [1420] = 850,
  [1421] = 840,
  [1422] = 847,
  [1423] = 910,
  [1424] = 911,
  [1425] = 849,
  [1426] = 850,
  [1427] = 851,
  [1428] = 852,
  [1429] = 853,
  [1430] = 854,
  [1431] = 855,
  [1432] = 856,
  [1433] = 857,
  [1434] = 858,
  [1435] = 848,
  [1436] = 841,
  [1437] = 842,
  [1438] = 840,
  [1439] = 907,
  [1440] = 845,
  [1441] = 846,
  [1442] = 847,
  [1443] = 936,
  [1444] = 851,
  [1445] = 852,
  [1446] = 853,
  [1447] = 854,
  [1448] = 855,
  [1449] = 856,
  [1450] = 857,
  [1451] = 858,
  [1452] = 848,
  [1453] = 841,
  [1454] = 842,
  [1455] = 845,
  [1456] = 849,
  [1457] = 850,
  [1458] = 840,
  [1459] = 847,
  [1460] = 849,
  [1461] = 910,
  [1462] = 911,
  [1463] = 850,
  [1464] = 1464,
  [1465] = 907,
  [1466] = 851,
  [1467] = 936,
  [1468] = 852,
  [1469] = 853,
  [1470] = 910,
  [1471] = 911,
  [1472] = 854,
  [1473] = 907,
  [1474] = 855,
  [1475] = 936,
  [1476] = 856,
  [1477] = 857,
  [1478] = 910,
  [1479] = 911,
  [1480] = 858,
  [1481] = 907,
  [1482] = 1482,
  [1483] = 936,
  [1484] = 848,
  [1485] = 841,
  [1486] = 910,
  [1487] = 911,
  [1488] = 842,
  [1489] = 907,
  [1490] = 1490,
  [1491] = 936,
  [1492] = 840,
  [1493] = 910,
  [1494] = 911,
  [1495] = 907,
  [1496] = 845,
  [1497] = 936,
  [1498] = 846,
  [1499] = 910,
  [1500] = 911,
  [1501] = 907,
  [1502] = 936,
  [1503] = 910,
  [1504] = 911,
  [1505] = 910,
  [1506] = 911,
  [1507] = 910,
  [1508] = 911,
  [1509] = 910,
  [1510] = 911,
  [1511] = 910,
  [1512] = 911,
  [1513] = 910,
  [1514] = 911,
  [1515] = 910,
  [1516] = 911,
  [1517] = 910,
  [1518] = 911,
  [1519] = 910,
  [1520] = 911,
  [1521] = 910,
  [1522] = 911,
  [1523] = 910,
  [1524] = 911,
  [1525] = 910,
  [1526] = 911,
  [1527] = 910,
  [1528] = 911,
  [1529] = 910,
  [1530] = 911,
  [1531] = 910,
  [1532] = 911,
  [1533] = 910,
  [1534] = 911,
  [1535] = 910,
  [1536] = 911,
  [1537] = 910,
  [1538] = 911,
  [1539] = 910,
  [1540] = 911,
  [1541] = 910,
  [1542] = 847,
  [1543] = 910,
  [1544] = 911,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1187,
  [1548] = 1223,
  [1549] = 1366,
  [1550] = 1377,
  [1551] = 1546,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 849,
  [1555] = 906,
  [1556] = 850,
  [1557] = 851,
  [1558] = 852,
  [1559] = 846,
  [1560] = 853,
  [1561] = 854,
  [1562] = 855,
  [1563] = 856,
  [1564] = 857,
  [1565] = 858,
  [1566] = 849,
  [1567] = 850,
  [1568] = 851,
  [1569] = 852,
  [1570] = 853,
  [1571] = 854,
  [1572] = 855,
  [1573] = 856,
  [1574] = 857,
  [1575] = 858,
  [1576] = 848,
  [1577] = 841,
  [1578] = 842,
  [1579] = 840,
  [1580] = 848,
  [1581] = 845,
  [1582] = 847,
  [1583] = 849,
  [1584] = 850,
  [1585] = 851,
  [1586] = 852,
  [1587] = 853,
  [1588] = 854,
  [1589] = 855,
  [1590] = 856,
  [1591] = 857,
  [1592] = 858,
  [1593] = 841,
  [1594] = 848,
  [1595] = 841,
  [1596] = 842,
  [1597] = 840,
  [1598] = 842,
  [1599] = 845,
  [1600] = 840,
  [1601] = 847,
  [1602] = 1552,
  [1603] = 845,
  [1604] = 851,
  [1605] = 852,
  [1606] = 853,
  [1607] = 854,
  [1608] = 855,
  [1609] = 856,
  [1610] = 857,
  [1611] = 858,
  [1612] = 848,
  [1613] = 841,
  [1614] = 842,
  [1615] = 845,
  [1616] = 849,
  [1617] = 850,
  [1618] = 846,
  [1619] = 840,
  [1620] = 847,
  [1621] = 847,
  [1622] = 849,
  [1623] = 850,
  [1624] = 851,
  [1625] = 852,
  [1626] = 853,
  [1627] = 854,
  [1628] = 855,
  [1629] = 856,
  [1630] = 857,
  [1631] = 858,
  [1632] = 848,
  [1633] = 841,
  [1634] = 842,
  [1635] = 840,
  [1636] = 845,
  [1637] = 847,
  [1638] = 849,
  [1639] = 850,
  [1640] = 849,
  [1641] = 840,
  [1642] = 850,
  [1643] = 847,
  [1644] = 851,
  [1645] = 852,
  [1646] = 853,
  [1647] = 854,
  [1648] = 855,
  [1649] = 856,
  [1650] = 857,
  [1651] = 858,
  [1652] = 848,
  [1653] = 841,
  [1654] = 842,
  [1655] = 845,
  [1656] = 849,
  [1657] = 850,
  [1658] = 1658,
  [1659] = 851,
  [1660] = 840,
  [1661] = 852,
  [1662] = 847,
  [1663] = 851,
  [1664] = 852,
  [1665] = 853,
  [1666] = 854,
  [1667] = 855,
  [1668] = 856,
  [1669] = 857,
  [1670] = 858,
  [1671] = 848,
  [1672] = 841,
  [1673] = 842,
  [1674] = 845,
  [1675] = 853,
  [1676] = 849,
  [1677] = 850,
  [1678] = 854,
  [1679] = 840,
  [1680] = 910,
  [1681] = 855,
  [1682] = 907,
  [1683] = 856,
  [1684] = 857,
  [1685] = 858,
  [1686] = 936,
  [1687] = 910,
  [1688] = 848,
  [1689] = 910,
  [1690] = 841,
  [1691] = 842,
  [1692] = 840,
  [1693] = 1553,
  [1694] = 910,
  [1695] = 910,
  [1696] = 845,
  [1697] = 1697,
  [1698] = 1187,
  [1699] = 1223,
  [1700] = 1366,
  [1701] = 1377,
  [1702] = 1546,
  [1703] = 1552,
  [1704] = 1553,
  [1705] = 847,
  [1706] = 1706,
  [1707] = 910,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 847,
  [1712] = 910,
  [1713] = 1187,
  [1714] = 1223,
  [1715] = 1366,
  [1716] = 1377,
  [1717] = 1546,
  [1718] = 1552,
  [1719] = 1553,
  [1720] = 1187,
  [1721] = 1552,
  [1722] = 1553,
  [1723] = 1723,
  [1724] = 1187,
  [1725] = 1552,
  [1726] = 1553,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 910,
  [1730] = 911,
  [1731] = 936,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 849,
  [1735] = 850,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 851,
  [1739] = 852,
  [1740] = 853,
  [1741] = 854,
  [1742] = 855,
  [1743] = 856,
  [1744] = 857,
  [1745] = 858,
  [1746] = 911,
  [1747] = 848,
  [1748] = 841,
  [1749] = 842,
  [1750] = 840,
  [1751] = 907,
  [1752] = 845,
  [1753] = 1753,
  [1754] = 851,
  [1755] = 1183,
  [1756] = 852,
  [1757] = 853,
  [1758] = 854,
  [1759] = 855,
  [1760] = 856,
  [1761] = 857,
  [1762] = 858,
  [1763] = 1185,
  [1764] = 848,
  [1765] = 841,
  [1766] = 842,
  [1767] = 906,
  [1768] = 907,
  [1769] = 1769,
  [1770] = 845,
  [1771] = 1490,
  [1772] = 847,
  [1773] = 936,
  [1774] = 910,
  [1775] = 907,
  [1776] = 936,
  [1777] = 846,
  [1778] = 849,
  [1779] = 850,
  [1780] = 1780,
  [1781] = 840,
  [1782] = 1782,
  [1783] = 846,
  [1784] = 847,
  [1785] = 851,
  [1786] = 852,
  [1787] = 853,
  [1788] = 854,
  [1789] = 855,
  [1790] = 856,
  [1791] = 857,
  [1792] = 858,
  [1793] = 848,
  [1794] = 841,
  [1795] = 842,
  [1796] = 845,
  [1797] = 849,
  [1798] = 850,
  [1799] = 851,
  [1800] = 852,
  [1801] = 853,
  [1802] = 854,
  [1803] = 855,
  [1804] = 856,
  [1805] = 857,
  [1806] = 858,
  [1807] = 1545,
  [1808] = 848,
  [1809] = 841,
  [1810] = 842,
  [1811] = 840,
  [1812] = 845,
  [1813] = 1708,
  [1814] = 847,
  [1815] = 1709,
  [1816] = 1710,
  [1817] = 847,
  [1818] = 851,
  [1819] = 910,
  [1820] = 936,
  [1821] = 1821,
  [1822] = 907,
  [1823] = 936,
  [1824] = 849,
  [1825] = 850,
  [1826] = 1826,
  [1827] = 840,
  [1828] = 1821,
  [1829] = 847,
  [1830] = 851,
  [1831] = 852,
  [1832] = 853,
  [1833] = 854,
  [1834] = 855,
  [1835] = 856,
  [1836] = 857,
  [1837] = 858,
  [1838] = 848,
  [1839] = 841,
  [1840] = 842,
  [1841] = 845,
  [1842] = 1842,
  [1843] = 1826,
  [1844] = 852,
  [1845] = 907,
  [1846] = 936,
  [1847] = 853,
  [1848] = 910,
  [1849] = 910,
  [1850] = 910,
  [1851] = 906,
  [1852] = 854,
  [1853] = 910,
  [1854] = 911,
  [1855] = 855,
  [1856] = 856,
  [1857] = 851,
  [1858] = 852,
  [1859] = 853,
  [1860] = 854,
  [1861] = 906,
  [1862] = 855,
  [1863] = 1490,
  [1864] = 856,
  [1865] = 857,
  [1866] = 858,
  [1867] = 848,
  [1868] = 841,
  [1869] = 906,
  [1870] = 842,
  [1871] = 1490,
  [1872] = 857,
  [1873] = 845,
  [1874] = 906,
  [1875] = 858,
  [1876] = 849,
  [1877] = 850,
  [1878] = 906,
  [1879] = 906,
  [1880] = 1880,
  [1881] = 840,
  [1882] = 1882,
  [1883] = 906,
  [1884] = 846,
  [1885] = 847,
  [1886] = 906,
  [1887] = 906,
  [1888] = 849,
  [1889] = 906,
  [1890] = 850,
  [1891] = 906,
  [1892] = 851,
  [1893] = 906,
  [1894] = 906,
  [1895] = 906,
  [1896] = 906,
  [1897] = 906,
  [1898] = 906,
  [1899] = 906,
  [1900] = 852,
  [1901] = 1706,
  [1902] = 853,
  [1903] = 854,
  [1904] = 855,
  [1905] = 856,
  [1906] = 1706,
  [1907] = 1706,
  [1908] = 1706,
  [1909] = 1706,
  [1910] = 857,
  [1911] = 858,
  [1912] = 906,
  [1913] = 848,
  [1914] = 854,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1916,
  [1918] = 1915,
  [1919] = 1915,
  [1920] = 1916,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1928,
  [1936] = 1932,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1934,
  [1940] = 1940,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1945,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1941,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1938,
  [1957] = 1937,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1942,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1983,
  [1984] = 1940,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 1985,
  [2020] = 1948,
  [2021] = 1983,
  [2022] = 1976,
  [2023] = 1943,
  [2024] = 1965,
  [2025] = 1993,
  [2026] = 1962,
  [2027] = 1974,
  [2028] = 1989,
  [2029] = 1954,
  [2030] = 1949,
  [2031] = 1986,
  [2032] = 1972,
  [2033] = 1992,
  [2034] = 1928,
  [2035] = 1979,
  [2036] = 1970,
  [2037] = 1971,
  [2038] = 1991,
  [2039] = 1950,
  [2040] = 1961,
  [2041] = 2041,
  [2042] = 1959,
  [2043] = 1987,
  [2044] = 1951,
  [2045] = 1945,
  [2046] = 1958,
  [2047] = 1952,
  [2048] = 1946,
  [2049] = 1977,
  [2050] = 1967,
  [2051] = 1978,
  [2052] = 1932,
  [2053] = 1960,
  [2054] = 1969,
  [2055] = 1966,
  [2056] = 1964,
  [2057] = 1973,
  [2058] = 1944,
  [2059] = 1988,
  [2060] = 1947,
  [2061] = 1990,
  [2062] = 1955,
  [2063] = 1981,
  [2064] = 1963,
  [2065] = 1982,
  [2066] = 1968,
  [2067] = 1980,
  [2068] = 2002,
  [2069] = 1995,
  [2070] = 1994,
  [2071] = 2012,
  [2072] = 2006,
  [2073] = 2018,
  [2074] = 1997,
  [2075] = 2075,
  [2076] = 2009,
  [2077] = 2007,
  [2078] = 2078,
  [2079] = 2010,
  [2080] = 2080,
  [2081] = 1996,
  [2082] = 2001,
  [2083] = 1934,
  [2084] = 1998,
  [2085] = 2008,
  [2086] = 2005,
  [2087] = 2004,
  [2088] = 2003,
  [2089] = 2014,
  [2090] = 2016,
  [2091] = 1999,
  [2092] = 2013,
  [2093] = 2093,
  [2094] = 2000,
  [2095] = 2015,
  [2096] = 1938,
  [2097] = 1940,
  [2098] = 1942,
  [2099] = 1941,
  [2100] = 1937,
  [2101] = 2101,
  [2102] = 1990,
  [2103] = 1958,
  [2104] = 1977,
  [2105] = 1943,
  [2106] = 1981,
  [2107] = 1965,
  [2108] = 1982,
  [2109] = 1985,
  [2110] = 1978,
  [2111] = 1983,
  [2112] = 1992,
  [2113] = 1962,
  [2114] = 1951,
  [2115] = 1947,
  [2116] = 1970,
  [2117] = 1986,
  [2118] = 1963,
  [2119] = 1945,
  [2120] = 1971,
  [2121] = 1952,
  [2122] = 1967,
  [2123] = 1946,
  [2124] = 1959,
  [2125] = 1960,
  [2126] = 1954,
  [2127] = 1989,
  [2128] = 1979,
  [2129] = 1991,
  [2130] = 1987,
  [2131] = 1964,
  [2132] = 1944,
  [2133] = 1988,
  [2134] = 1966,
  [2135] = 1948,
  [2136] = 1976,
  [2137] = 1949,
  [2138] = 1980,
  [2139] = 1968,
  [2140] = 1950,
  [2141] = 1961,
  [2142] = 1974,
  [2143] = 1955,
  [2144] = 1993,
  [2145] = 1972,
  [2146] = 1973,
  [2147] = 1969,
  [2148] = 2101,
  [2149] = 2149,
  [2150] = 2041,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2173,
  [2176] = 2173,
  [2177] = 2173,
  [2178] = 2178,
  [2179] = 2173,
  [2180] = 2178,
  [2181] = 2173,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2173,
  [2189] = 2189,
  [2190] = 2173,
  [2191] = 2191,
  [2192] = 2191,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2195,
  [2197] = 2195,
  [2198] = 2198,
  [2199] = 2198,
  [2200] = 2195,
  [2201] = 2201,
  [2202] = 2178,
  [2203] = 2194,
  [2204] = 2195,
  [2205] = 2201,
  [2206] = 2195,
  [2207] = 2207,
  [2208] = 2178,
  [2209] = 2173,
  [2210] = 1916,
  [2211] = 2173,
  [2212] = 2201,
  [2213] = 2173,
  [2214] = 2178,
  [2215] = 2215,
  [2216] = 2194,
  [2217] = 2191,
  [2218] = 2218,
  [2219] = 2178,
  [2220] = 2178,
  [2221] = 2201,
  [2222] = 2222,
  [2223] = 2195,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2178,
  [2227] = 2178,
  [2228] = 2178,
  [2229] = 2191,
  [2230] = 2178,
  [2231] = 2173,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2194,
  [2235] = 2235,
  [2236] = 2178,
  [2237] = 2224,
  [2238] = 2198,
  [2239] = 2194,
  [2240] = 2173,
  [2241] = 2198,
  [2242] = 2242,
  [2243] = 2183,
  [2244] = 2182,
  [2245] = 2201,
  [2246] = 2246,
  [2247] = 2195,
  [2248] = 2242,
  [2249] = 2246,
  [2250] = 2242,
  [2251] = 2201,
  [2252] = 2183,
  [2253] = 2242,
  [2254] = 2182,
  [2255] = 2191,
  [2256] = 2191,
  [2257] = 2257,
  [2258] = 2193,
  [2259] = 2201,
  [2260] = 2198,
  [2261] = 2195,
  [2262] = 2201,
  [2263] = 2201,
  [2264] = 2195,
  [2265] = 2195,
  [2266] = 2195,
  [2267] = 2195,
  [2268] = 2191,
  [2269] = 2269,
  [2270] = 2194,
  [2271] = 2191,
  [2272] = 2187,
  [2273] = 2184,
  [2274] = 2189,
  [2275] = 2185,
  [2276] = 2186,
  [2277] = 2257,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2198,
  [2281] = 2183,
  [2282] = 2182,
  [2283] = 2283,
  [2284] = 2201,
  [2285] = 2195,
  [2286] = 2198,
  [2287] = 2269,
  [2288] = 2195,
  [2289] = 2289,
  [2290] = 2173,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2195,
  [2295] = 2295,
  [2296] = 2278,
  [2297] = 2194,
  [2298] = 2298,
  [2299] = 2198,
  [2300] = 2198,
  [2301] = 2194,
  [2302] = 2279,
  [2303] = 2195,
  [2304] = 2198,
  [2305] = 2198,
  [2306] = 2194,
  [2307] = 2307,
  [2308] = 2195,
  [2309] = 2257,
  [2310] = 2310,
  [2311] = 2195,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2173,
  [2316] = 2201,
  [2317] = 2195,
  [2318] = 2201,
  [2319] = 2198,
  [2320] = 2195,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2257,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2201,
  [2327] = 2198,
  [2328] = 2195,
  [2329] = 2195,
  [2330] = 2198,
  [2331] = 2283,
  [2332] = 2312,
  [2333] = 2173,
  [2334] = 2334,
  [2335] = 2314,
  [2336] = 2195,
  [2337] = 2337,
  [2338] = 2313,
  [2339] = 2198,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2325,
  [2344] = 2344,
  [2345] = 2195,
  [2346] = 2195,
  [2347] = 2321,
  [2348] = 2201,
  [2349] = 2349,
  [2350] = 2195,
  [2351] = 2310,
  [2352] = 2195,
  [2353] = 2195,
  [2354] = 2198,
  [2355] = 2198,
  [2356] = 2173,
  [2357] = 2198,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2195,
  [2361] = 2198,
  [2362] = 2195,
  [2363] = 2201,
  [2364] = 2269,
  [2365] = 2324,
  [2366] = 2195,
  [2367] = 2322,
  [2368] = 2198,
  [2369] = 2198,
  [2370] = 2269,
  [2371] = 2371,
  [2372] = 2173,
  [2373] = 2183,
  [2374] = 2182,
  [2375] = 2195,
  [2376] = 2201,
  [2377] = 2194,
  [2378] = 2173,
  [2379] = 2379,
  [2380] = 2193,
  [2381] = 2201,
  [2382] = 2382,
  [2383] = 2195,
  [2384] = 2371,
  [2385] = 2173,
  [2386] = 2195,
  [2387] = 2195,
  [2388] = 2195,
  [2389] = 2201,
  [2390] = 2246,
  [2391] = 2201,
  [2392] = 2201,
  [2393] = 2393,
  [2394] = 2173,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2201,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2195,
  [2401] = 2201,
  [2402] = 2193,
  [2403] = 2403,
  [2404] = 2195,
  [2405] = 2405,
  [2406] = 2195,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2201,
  [2410] = 2186,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2195,
  [2415] = 2415,
  [2416] = 2242,
  [2417] = 2173,
  [2418] = 2187,
  [2419] = 2184,
  [2420] = 2246,
  [2421] = 2421,
  [2422] = 2242,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2201,
  [2427] = 2415,
  [2428] = 2428,
  [2429] = 2242,
  [2430] = 2201,
  [2431] = 2185,
  [2432] = 2189,
  [2433] = 2173,
  [2434] = 2242,
  [2435] = 2195,
  [2436] = 2182,
  [2437] = 2437,
  [2438] = 2438,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2173,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 2173,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2445,
  [2448] = 2448,
  [2449] = 2445,
  [2450] = 2450,
  [2451] = 2173,
  [2452] = 2452,
  [2453] = 2184,
  [2454] = 2189,
  [2455] = 2185,
  [2456] = 2186,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2173,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 2173,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2173,
  [2467] = 2183,
  [2468] = 2173,
  [2469] = 2469,
  [2470] = 2173,
  [2471] = 2471,
  [2472] = 2187,
  [2473] = 2242,
  [2474] = 2443,
  [2475] = 2242,
  [2476] = 2242,
  [2477] = 2471,
  [2478] = 2242,
  [2479] = 2463,
  [2480] = 2242,
  [2481] = 2246,
  [2482] = 2242,
  [2483] = 2242,
  [2484] = 2246,
  [2485] = 2246,
  [2486] = 2242,
  [2487] = 2452,
  [2488] = 2246,
  [2489] = 2246,
  [2490] = 2242,
  [2491] = 2439,
  [2492] = 2437,
  [2493] = 2246,
  [2494] = 2246,
  [2495] = 2458,
  [2496] = 2242,
  [2497] = 2246,
  [2498] = 2242,
  [2499] = 2242,
  [2500] = 2469,
  [2501] = 2242,
  [2502] = 2242,
  [2503] = 2457,
  [2504] = 2246,
  [2505] = 2242,
  [2506] = 2242,
  [2507] = 2242,
  [2508] = 2246,
  [2509] = 2242,
  [2510] = 2510,
  [2511] = 2242,
  [2512] = 2173,
  [2513] = 2173,
  [2514] = 2246,
  [2515] = 2173,
  [2516] = 2278,
  [2517] = 2279,
  [2518] = 2242,
  [2519] = 2242,
  [2520] = 2173,
  [2521] = 2242,
  [2522] = 2246,
  [2523] = 2246,
  [2524] = 2242,
  [2525] = 2246,
  [2526] = 2242,
  [2527] = 2278,
  [2528] = 2242,
  [2529] = 2279,
  [2530] = 2242,
  [2531] = 2242,
  [2532] = 2510,
  [2533] = 2242,
  [2534] = 2246,
  [2535] = 2242,
  [2536] = 2242,
  [2537] = 2246,
  [2538] = 2173,
  [2539] = 2173,
  [2540] = 2246,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2279,
  [2544] = 2295,
  [2545] = 2541,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2546,
  [2549] = 2549,
  [2550] = 2549,
  [2551] = 2542,
  [2552] = 2379,
  [2553] = 2235,
  [2554] = 2541,
  [2555] = 2547,
  [2556] = 2546,
  [2557] = 2549,
  [2558] = 2547,
  [2559] = 2278,
  [2560] = 2279,
  [2561] = 2546,
  [2562] = 2379,
  [2563] = 2542,
  [2564] = 2549,
  [2565] = 2542,
  [2566] = 2541,
  [2567] = 2547,
  [2568] = 2278,
  [2569] = 2314,
  [2570] = 2322,
  [2571] = 2324,
  [2572] = 2325,
  [2573] = 2279,
  [2574] = 2278,
  [2575] = 2279,
  [2576] = 2382,
  [2577] = 2278,
  [2578] = 2278,
  [2579] = 2321,
  [2580] = 2312,
  [2581] = 2581,
  [2582] = 2279,
  [2583] = 2321,
  [2584] = 2322,
  [2585] = 2324,
  [2586] = 2325,
  [2587] = 2313,
  [2588] = 2310,
  [2589] = 2278,
  [2590] = 2278,
  [2591] = 2279,
  [2592] = 2235,
  [2593] = 2442,
  [2594] = 2278,
  [2595] = 2279,
  [2596] = 2278,
  [2597] = 2279,
  [2598] = 2279,
  [2599] = 2193,
  [2600] = 2278,
  [2601] = 2279,
  [2602] = 2382,
  [2603] = 2460,
  [2604] = 2183,
  [2605] = 1968,
  [2606] = 2322,
  [2607] = 2324,
  [2608] = 2325,
  [2609] = 2321,
  [2610] = 2278,
  [2611] = 2322,
  [2612] = 2324,
  [2613] = 2325,
  [2614] = 1970,
  [2615] = 2279,
  [2616] = 2182,
  [2617] = 1966,
  [2618] = 2278,
  [2619] = 2278,
  [2620] = 2279,
  [2621] = 2279,
  [2622] = 2321,
  [2623] = 2186,
  [2624] = 2325,
  [2625] = 2458,
  [2626] = 2187,
  [2627] = 2184,
  [2628] = 2324,
  [2629] = 2629,
  [2630] = 2310,
  [2631] = 2439,
  [2632] = 2324,
  [2633] = 2189,
  [2634] = 2193,
  [2635] = 2450,
  [2636] = 2185,
  [2637] = 2445,
  [2638] = 2438,
  [2639] = 2639,
  [2640] = 2312,
  [2641] = 2438,
  [2642] = 2325,
  [2643] = 2448,
  [2644] = 2412,
  [2645] = 2465,
  [2646] = 2437,
  [2647] = 2183,
  [2648] = 2463,
  [2649] = 2649,
  [2650] = 2445,
  [2651] = 2651,
  [2652] = 2182,
  [2653] = 2443,
  [2654] = 2321,
  [2655] = 2469,
  [2656] = 2408,
  [2657] = 2194,
  [2658] = 2310,
  [2659] = 2313,
  [2660] = 2183,
  [2661] = 2312,
  [2662] = 2182,
  [2663] = 2663,
  [2664] = 2471,
  [2665] = 2182,
  [2666] = 2313,
  [2667] = 2314,
  [2668] = 2322,
  [2669] = 2669,
  [2670] = 2452,
  [2671] = 2314,
  [2672] = 2321,
  [2673] = 2193,
  [2674] = 2674,
  [2675] = 2322,
  [2676] = 2321,
  [2677] = 2457,
  [2678] = 2678,
  [2679] = 2322,
  [2680] = 2445,
  [2681] = 2324,
  [2682] = 2183,
  [2683] = 2325,
  [2684] = 2684,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2688,
  [2689] = 2689,
  [2690] = 2001,
  [2691] = 2321,
  [2692] = 2189,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2695,
  [2696] = 2696,
  [2697] = 2310,
  [2698] = 2322,
  [2699] = 2324,
  [2700] = 2185,
  [2701] = 2341,
  [2702] = 2004,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2325,
  [2706] = 2186,
  [2707] = 2358,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2359,
  [2711] = 2457,
  [2712] = 2458,
  [2713] = 2445,
  [2714] = 2428,
  [2715] = 2398,
  [2716] = 2411,
  [2717] = 2413,
  [2718] = 2629,
  [2719] = 2450,
  [2720] = 2463,
  [2721] = 2421,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2469,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2471,
  [2728] = 2452,
  [2729] = 1942,
  [2730] = 2014,
  [2731] = 2015,
  [2732] = 2396,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2403,
  [2738] = 2407,
  [2739] = 2437,
  [2740] = 2740,
  [2741] = 2423,
  [2742] = 2424,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2439,
  [2746] = 2425,
  [2747] = 2312,
  [2748] = 2395,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 1995,
  [2753] = 2313,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2405,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2762,
  [2763] = 1996,
  [2764] = 2314,
  [2765] = 1998,
  [2766] = 2013,
  [2767] = 2443,
  [2768] = 2000,
  [2769] = 2003,
  [2770] = 2005,
  [2771] = 2321,
  [2772] = 2006,
  [2773] = 2018,
  [2774] = 2322,
  [2775] = 2324,
  [2776] = 2776,
  [2777] = 2325,
  [2778] = 2445,
  [2779] = 2779,
  [2780] = 2780,
  [2781] = 2781,
  [2782] = 2312,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2790,
  [2791] = 2791,
  [2792] = 2792,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2795,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 2310,
  [2799] = 2799,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2313,
  [2803] = 2803,
  [2804] = 2804,
  [2805] = 2465,
  [2806] = 2314,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2187,
  [2810] = 2184,
  [2811] = 2415,
  [2812] = 2812,
  [2813] = 2189,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2185,
  [2817] = 2186,
  [2818] = 2818,
  [2819] = 2819,
  [2820] = 2321,
  [2821] = 2322,
  [2822] = 2822,
  [2823] = 2823,
  [2824] = 2324,
  [2825] = 2325,
  [2826] = 1999,
  [2827] = 2827,
  [2828] = 2828,
  [2829] = 2445,
  [2830] = 2321,
  [2831] = 2322,
  [2832] = 2832,
  [2833] = 2833,
  [2834] = 2324,
  [2835] = 2325,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2101,
  [2839] = 2839,
  [2840] = 2415,
  [2841] = 2321,
  [2842] = 2842,
  [2843] = 2322,
  [2844] = 2324,
  [2845] = 2325,
  [2846] = 2183,
  [2847] = 2187,
  [2848] = 2337,
  [2849] = 2182,
  [2850] = 2002,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2853,
  [2854] = 2007,
  [2855] = 2448,
  [2856] = 2340,
  [2857] = 2342,
  [2858] = 2321,
  [2859] = 2344,
  [2860] = 2010,
  [2861] = 2322,
  [2862] = 2324,
  [2863] = 2325,
  [2864] = 2864,
  [2865] = 2334,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2869,
  [2870] = 2184,
  [2871] = 2399,
  [2872] = 1937,
  [2873] = 2321,
  [2874] = 2322,
  [2875] = 2324,
  [2876] = 2325,
  [2877] = 2349,
  [2878] = 2321,
  [2879] = 2322,
  [2880] = 2324,
  [2881] = 2325,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2886,
  [2887] = 2442,
  [2888] = 2888,
  [2889] = 2461,
  [2890] = 2464,
  [2891] = 2460,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2440,
  [2895] = 2446,
  [2896] = 2445,
  [2897] = 2415,
  [2898] = 2408,
  [2899] = 2445,
  [2900] = 2900,
  [2901] = 2445,
  [2902] = 2902,
  [2903] = 2412,
  [2904] = 2445,
  [2905] = 2445,
  [2906] = 2445,
  [2907] = 2907,
  [2908] = 2445,
  [2909] = 2445,
  [2910] = 2445,
  [2911] = 1937,
  [2912] = 2439,
  [2913] = 2913,
  [2914] = 2437,
  [2915] = 2915,
  [2916] = 2460,
  [2917] = 2471,
  [2918] = 2442,
  [2919] = 2919,
  [2920] = 2445,
  [2921] = 2921,
  [2922] = 2922,
  [2923] = 2445,
  [2924] = 2415,
  [2925] = 2925,
  [2926] = 2926,
  [2927] = 1942,
  [2928] = 2928,
  [2929] = 2445,
  [2930] = 2930,
  [2931] = 2445,
  [2932] = 2445,
  [2933] = 2443,
  [2934] = 2469,
  [2935] = 2193,
  [2936] = 2438,
  [2937] = 2458,
  [2938] = 2629,
  [2939] = 2939,
  [2940] = 2940,
  [2941] = 2941,
  [2942] = 2942,
  [2943] = 2943,
  [2944] = 2457,
  [2945] = 2452,
  [2946] = 2194,
  [2947] = 2947,
  [2948] = 2463,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2183,
  [2952] = 2182,
  [2953] = 2465,
  [2954] = 2341,
  [2955] = 2947,
  [2956] = 2956,
  [2957] = 2407,
  [2958] = 2958,
  [2959] = 2189,
  [2960] = 2888,
  [2961] = 2399,
  [2962] = 2396,
  [2963] = 2425,
  [2964] = 2187,
  [2965] = 2342,
  [2966] = 2337,
  [2967] = 2344,
  [2968] = 2349,
  [2969] = 2949,
  [2970] = 2939,
  [2971] = 2971,
  [2972] = 2421,
  [2973] = 2334,
  [2974] = 2424,
  [2975] = 2975,
  [2976] = 2186,
  [2977] = 2943,
  [2978] = 2358,
  [2979] = 2398,
  [2980] = 2182,
  [2981] = 2359,
  [2982] = 2194,
  [2983] = 2411,
  [2984] = 2984,
  [2985] = 2985,
  [2986] = 2185,
  [2987] = 2413,
  [2988] = 2382,
  [2989] = 2183,
  [2990] = 2403,
  [2991] = 2184,
  [2992] = 2428,
  [2993] = 2993,
  [2994] = 2340,
  [2995] = 2193,
  [2996] = 2423,
  [2997] = 2997,
  [2998] = 2998,
  [2999] = 2421,
  [3000] = 2334,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 3006,
  [3007] = 3007,
  [3008] = 3008,
  [3009] = 2423,
  [3010] = 3010,
  [3011] = 3011,
  [3012] = 3012,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 2340,
  [3017] = 3017,
  [3018] = 2341,
  [3019] = 2407,
  [3020] = 3020,
  [3021] = 3021,
  [3022] = 3022,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 2342,
  [3026] = 2344,
  [3027] = 2184,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 1915,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 2189,
  [3036] = 1937,
  [3037] = 1942,
  [3038] = 3038,
  [3039] = 2425,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 2399,
  [3043] = 3043,
  [3044] = 2185,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3047,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 3053,
  [3054] = 2403,
  [3055] = 2424,
  [3056] = 2358,
  [3057] = 2186,
  [3058] = 3058,
  [3059] = 3059,
  [3060] = 2101,
  [3061] = 3061,
  [3062] = 2349,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 2428,
  [3073] = 2359,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3076,
  [3077] = 2396,
  [3078] = 3078,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 3081,
  [3082] = 2337,
  [3083] = 3083,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3087,
  [3088] = 2398,
  [3089] = 3089,
  [3090] = 2411,
  [3091] = 3091,
  [3092] = 3092,
  [3093] = 2413,
  [3094] = 2947,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 2187,
  [3103] = 2947,
  [3104] = 3097,
  [3105] = 3099,
  [3106] = 3100,
  [3107] = 3101,
  [3108] = 3028,
  [3109] = 3050,
  [3110] = 3008,
  [3111] = 3021,
  [3112] = 3068,
  [3113] = 3076,
  [3114] = 2998,
  [3115] = 3022,
  [3116] = 3071,
  [3117] = 3064,
  [3118] = 2629,
  [3119] = 3017,
  [3120] = 3070,
  [3121] = 3049,
  [3122] = 3010,
  [3123] = 3024,
  [3124] = 3075,
  [3125] = 3051,
  [3126] = 3063,
  [3127] = 2448,
  [3128] = 3128,
  [3129] = 3015,
  [3130] = 3032,
  [3131] = 2450,
  [3132] = 3046,
  [3133] = 3058,
  [3134] = 3020,
  [3135] = 3092,
  [3136] = 3136,
  [3137] = 3004,
  [3138] = 1915,
  [3139] = 3095,
  [3140] = 2947,
  [3141] = 2947,
  [3142] = 3033,
  [3143] = 3003,
  [3144] = 3002,
  [3145] = 3086,
  [3146] = 3048,
  [3147] = 3091,
  [3148] = 3043,
  [3149] = 3041,
  [3150] = 3014,
  [3151] = 3059,
  [3152] = 3096,
  [3153] = 3098,
  [3154] = 3052,
  [3155] = 3087,
  [3156] = 3083,
  [3157] = 3157,
  [3158] = 2947,
  [3159] = 2101,
  [3160] = 3160,
  [3161] = 2947,
  [3162] = 2629,
  [3163] = 2947,
  [3164] = 2443,
  [3165] = 2382,
  [3166] = 3166,
  [3167] = 3167,
  [3168] = 2915,
  [3169] = 2943,
  [3170] = 2902,
  [3171] = 2182,
  [3172] = 2939,
  [3173] = 2942,
  [3174] = 2194,
  [3175] = 2183,
  [3176] = 2915,
  [3177] = 2940,
  [3178] = 2947,
  [3179] = 2949,
  [3180] = 3180,
  [3181] = 2193,
  [3182] = 2193,
  [3183] = 3180,
  [3184] = 2950,
  [3185] = 2947,
  [3186] = 2629,
  [3187] = 2956,
  [3188] = 2947,
  [3189] = 2407,
  [3190] = 2450,
  [3191] = 2471,
  [3192] = 2182,
  [3193] = 2984,
  [3194] = 2382,
  [3195] = 2349,
  [3196] = 2396,
  [3197] = 2452,
  [3198] = 2958,
  [3199] = 2971,
  [3200] = 2947,
  [3201] = 2465,
  [3202] = 2985,
  [3203] = 2902,
  [3204] = 2428,
  [3205] = 2187,
  [3206] = 2184,
  [3207] = 2193,
  [3208] = 2187,
  [3209] = 2993,
  [3210] = 2189,
  [3211] = 2101,
  [3212] = 2629,
  [3213] = 2185,
  [3214] = 2189,
  [3215] = 2186,
  [3216] = 2939,
  [3217] = 2403,
  [3218] = 2984,
  [3219] = 2463,
  [3220] = 2448,
  [3221] = 2958,
  [3222] = 2942,
  [3223] = 2340,
  [3224] = 2439,
  [3225] = 2423,
  [3226] = 2457,
  [3227] = 2943,
  [3228] = 2342,
  [3229] = 2437,
  [3230] = 2629,
  [3231] = 2421,
  [3232] = 2424,
  [3233] = 2337,
  [3234] = 2398,
  [3235] = 2993,
  [3236] = 2185,
  [3237] = 2341,
  [3238] = 2411,
  [3239] = 2183,
  [3240] = 2425,
  [3241] = 2182,
  [3242] = 2413,
  [3243] = 2186,
  [3244] = 2358,
  [3245] = 2359,
  [3246] = 2438,
  [3247] = 2183,
  [3248] = 2940,
  [3249] = 2443,
  [3250] = 2947,
  [3251] = 2182,
  [3252] = 2947,
  [3253] = 2458,
  [3254] = 2971,
  [3255] = 2469,
  [3256] = 2194,
  [3257] = 2985,
  [3258] = 2334,
  [3259] = 2949,
  [3260] = 2184,
  [3261] = 2975,
  [3262] = 2950,
  [3263] = 2399,
  [3264] = 2183,
  [3265] = 2344,
  [3266] = 2185,
  [3267] = 3021,
  [3268] = 3268,
  [3269] = 2956,
  [3270] = 2382,
  [3271] = 2340,
  [3272] = 3272,
  [3273] = 2342,
  [3274] = 3066,
  [3275] = 3068,
  [3276] = 3067,
  [3277] = 3091,
  [3278] = 3046,
  [3279] = 2358,
  [3280] = 3280,
  [3281] = 3281,
  [3282] = 3282,
  [3283] = 3043,
  [3284] = 3284,
  [3285] = 2344,
  [3286] = 3286,
  [3287] = 3014,
  [3288] = 2421,
  [3289] = 3083,
  [3290] = 3023,
  [3291] = 3079,
  [3292] = 3087,
  [3293] = 3293,
  [3294] = 3051,
  [3295] = 3295,
  [3296] = 3041,
  [3297] = 3297,
  [3298] = 3298,
  [3299] = 3007,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 3048,
  [3303] = 3303,
  [3304] = 2334,
  [3305] = 2975,
  [3306] = 2359,
  [3307] = 3307,
  [3308] = 3049,
  [3309] = 3309,
  [3310] = 3284,
  [3311] = 3050,
  [3312] = 3312,
  [3313] = 3312,
  [3314] = 1915,
  [3315] = 3095,
  [3316] = 3061,
  [3317] = 3096,
  [3318] = 3052,
  [3319] = 3098,
  [3320] = 3033,
  [3321] = 3099,
  [3322] = 2341,
  [3323] = 3024,
  [3324] = 3058,
  [3325] = 3064,
  [3326] = 3100,
  [3327] = 3059,
  [3328] = 3101,
  [3329] = 2947,
  [3330] = 3063,
  [3331] = 3331,
  [3332] = 3076,
  [3333] = 3333,
  [3334] = 2998,
  [3335] = 3006,
  [3336] = 3007,
  [3337] = 3023,
  [3338] = 2424,
  [3339] = 2428,
  [3340] = 3047,
  [3341] = 3341,
  [3342] = 3005,
  [3343] = 3070,
  [3344] = 2337,
  [3345] = 3078,
  [3346] = 3071,
  [3347] = 2187,
  [3348] = 3348,
  [3349] = 2184,
  [3350] = 1937,
  [3351] = 1942,
  [3352] = 3011,
  [3353] = 2947,
  [3354] = 3013,
  [3355] = 2398,
  [3356] = 3001,
  [3357] = 3002,
  [3358] = 3008,
  [3359] = 2947,
  [3360] = 2399,
  [3361] = 3015,
  [3362] = 3020,
  [3363] = 2411,
  [3364] = 3075,
  [3365] = 2349,
  [3366] = 2413,
  [3367] = 3367,
  [3368] = 3022,
  [3369] = 3089,
  [3370] = 3017,
  [3371] = 2396,
  [3372] = 3081,
  [3373] = 2189,
  [3374] = 3065,
  [3375] = 3069,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3074,
  [3379] = 2947,
  [3380] = 2425,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3010,
  [3385] = 2403,
  [3386] = 2407,
  [3387] = 3092,
  [3388] = 3097,
  [3389] = 3086,
  [3390] = 2423,
  [3391] = 3391,
  [3392] = 3003,
  [3393] = 3032,
  [3394] = 3084,
  [3395] = 3085,
  [3396] = 3396,
  [3397] = 3028,
  [3398] = 2186,
  [3399] = 3004,
  [3400] = 3048,
  [3401] = 3298,
  [3402] = 3295,
  [3403] = 3297,
  [3404] = 3078,
  [3405] = 3089,
  [3406] = 3069,
  [3407] = 3064,
  [3408] = 3382,
  [3409] = 3383,
  [3410] = 3074,
  [3411] = 3070,
  [3412] = 3071,
  [3413] = 3075,
  [3414] = 1966,
  [3415] = 1968,
  [3416] = 3083,
  [3417] = 3087,
  [3418] = 3095,
  [3419] = 3096,
  [3420] = 3098,
  [3421] = 3099,
  [3422] = 3100,
  [3423] = 3101,
  [3424] = 3063,
  [3425] = 1970,
  [3426] = 3002,
  [3427] = 3015,
  [3428] = 3020,
  [3429] = 3367,
  [3430] = 3430,
  [3431] = 3092,
  [3432] = 3097,
  [3433] = 3003,
  [3434] = 3028,
  [3435] = 3032,
  [3436] = 3041,
  [3437] = 3046,
  [3438] = 3051,
  [3439] = 3068,
  [3440] = 3076,
  [3441] = 2998,
  [3442] = 3086,
  [3443] = 3091,
  [3444] = 3005,
  [3445] = 3004,
  [3446] = 3008,
  [3447] = 3010,
  [3448] = 3014,
  [3449] = 3017,
  [3450] = 3021,
  [3451] = 3022,
  [3452] = 3024,
  [3453] = 3453,
  [3454] = 3033,
  [3455] = 3043,
  [3456] = 3049,
  [3457] = 3050,
  [3458] = 3052,
  [3459] = 3058,
  [3460] = 3059,
  [3461] = 2947,
  [3462] = 3462,
  [3463] = 3463,
  [3464] = 2174,
  [3465] = 3465,
  [3466] = 3466,
  [3467] = 3011,
  [3468] = 3067,
  [3469] = 3013,
  [3470] = 3300,
  [3471] = 3471,
  [3472] = 2947,
  [3473] = 3473,
  [3474] = 3471,
  [3475] = 3303,
  [3476] = 3453,
  [3477] = 3466,
  [3478] = 3465,
  [3479] = 3084,
  [3480] = 2947,
  [3481] = 2101,
  [3482] = 2450,
  [3483] = 2448,
  [3484] = 3484,
  [3485] = 3085,
  [3486] = 3486,
  [3487] = 3473,
  [3488] = 3081,
  [3489] = 3471,
  [3490] = 3453,
  [3491] = 3466,
  [3492] = 3465,
  [3493] = 3376,
  [3494] = 2947,
  [3495] = 3473,
  [3496] = 1937,
  [3497] = 1942,
  [3498] = 3471,
  [3499] = 3453,
  [3500] = 3466,
  [3501] = 3465,
  [3502] = 3281,
  [3503] = 3307,
  [3504] = 3006,
  [3505] = 3473,
  [3506] = 3471,
  [3507] = 3453,
  [3508] = 3466,
  [3509] = 3465,
  [3510] = 2947,
  [3511] = 2947,
  [3512] = 3473,
  [3513] = 3471,
  [3514] = 3453,
  [3515] = 3466,
  [3516] = 3465,
  [3517] = 2947,
  [3518] = 3061,
  [3519] = 3471,
  [3520] = 3453,
  [3521] = 3466,
  [3522] = 3465,
  [3523] = 2947,
  [3524] = 2947,
  [3525] = 3471,
  [3526] = 3453,
  [3527] = 3466,
  [3528] = 3465,
  [3529] = 2947,
  [3530] = 3301,
  [3531] = 1915,
  [3532] = 2629,
  [3533] = 3391,
  [3534] = 3268,
  [3535] = 3280,
  [3536] = 3282,
  [3537] = 1937,
  [3538] = 1942,
  [3539] = 3539,
  [3540] = 2956,
  [3541] = 2915,
  [3542] = 2174,
  [3543] = 3065,
  [3544] = 3544,
  [3545] = 3381,
  [3546] = 3396,
  [3547] = 3341,
  [3548] = 3377,
  [3549] = 3309,
  [3550] = 3473,
  [3551] = 3551,
  [3552] = 3293,
  [3553] = 3066,
  [3554] = 3286,
  [3555] = 3331,
  [3556] = 3556,
  [3557] = 2947,
  [3558] = 3128,
  [3559] = 2947,
  [3560] = 2947,
  [3561] = 2173,
  [3562] = 3562,
  [3563] = 2940,
  [3564] = 2950,
  [3565] = 2913,
  [3566] = 3029,
  [3567] = 3567,
  [3568] = 2947,
  [3569] = 3045,
  [3570] = 3038,
  [3571] = 3031,
  [3572] = 2947,
  [3573] = 3573,
  [3574] = 2922,
  [3575] = 2947,
  [3576] = 3576,
  [3577] = 3034,
  [3578] = 2947,
  [3579] = 2942,
  [3580] = 2926,
  [3581] = 2947,
  [3582] = 2947,
  [3583] = 2915,
  [3584] = 2450,
  [3585] = 3585,
  [3586] = 2448,
  [3587] = 3587,
  [3588] = 2919,
  [3589] = 3080,
  [3590] = 2947,
  [3591] = 3591,
  [3592] = 3591,
  [3593] = 3593,
  [3594] = 3594,
  [3595] = 3595,
  [3596] = 3596,
  [3597] = 2942,
  [3598] = 3598,
  [3599] = 3591,
  [3600] = 3180,
  [3601] = 2919,
  [3602] = 3591,
  [3603] = 3598,
  [3604] = 3031,
  [3605] = 3128,
  [3606] = 3034,
  [3607] = 2943,
  [3608] = 3598,
  [3609] = 3180,
  [3610] = 2956,
  [3611] = 3598,
  [3612] = 3080,
  [3613] = 3591,
  [3614] = 2922,
  [3615] = 3615,
  [3616] = 2939,
  [3617] = 3029,
  [3618] = 3598,
  [3619] = 3598,
  [3620] = 3598,
  [3621] = 3598,
  [3622] = 3598,
  [3623] = 3591,
  [3624] = 3598,
  [3625] = 3625,
  [3626] = 2947,
  [3627] = 3598,
  [3628] = 3598,
  [3629] = 3598,
  [3630] = 2940,
  [3631] = 3598,
  [3632] = 3598,
  [3633] = 3573,
  [3634] = 2947,
  [3635] = 3591,
  [3636] = 3591,
  [3637] = 3038,
  [3638] = 2947,
  [3639] = 3639,
  [3640] = 3180,
  [3641] = 2947,
  [3642] = 3598,
  [3643] = 3573,
  [3644] = 3591,
  [3645] = 3045,
  [3646] = 3598,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 3649,
  [3650] = 3650,
  [3651] = 2913,
  [3652] = 3598,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3598,
  [3657] = 3657,
  [3658] = 3573,
  [3659] = 3659,
  [3660] = 3598,
  [3661] = 3661,
  [3662] = 3662,
  [3663] = 3598,
  [3664] = 3664,
  [3665] = 3591,
  [3666] = 3573,
  [3667] = 3667,
  [3668] = 3668,
  [3669] = 3598,
  [3670] = 3591,
  [3671] = 3598,
  [3672] = 3573,
  [3673] = 2949,
  [3674] = 3591,
  [3675] = 3598,
  [3676] = 3598,
  [3677] = 3180,
  [3678] = 3573,
  [3679] = 2926,
  [3680] = 2950,
  [3681] = 3591,
  [3682] = 3682,
  [3683] = 3598,
  [3684] = 3684,
  [3685] = 3684,
  [3686] = 2947,
  [3687] = 3598,
  [3688] = 3591,
  [3689] = 3596,
  [3690] = 3664,
  [3691] = 3668,
  [3692] = 2984,
  [3693] = 3649,
  [3694] = 3625,
  [3695] = 3650,
  [3696] = 3615,
  [3697] = 3697,
  [3698] = 3698,
  [3699] = 3699,
  [3700] = 3700,
  [3701] = 3701,
  [3702] = 3702,
  [3703] = 2958,
  [3704] = 3639,
  [3705] = 2183,
  [3706] = 3648,
  [3707] = 2993,
  [3708] = 2985,
  [3709] = 2947,
  [3710] = 3682,
  [3711] = 2971,
  [3712] = 2975,
  [3713] = 3647,
  [3714] = 2947,
  [3715] = 3593,
  [3716] = 3594,
  [3717] = 3595,
  [3718] = 3718,
  [3719] = 2947,
  [3720] = 2947,
  [3721] = 3721,
  [3722] = 3653,
  [3723] = 2947,
  [3724] = 3724,
  [3725] = 3167,
  [3726] = 3654,
  [3727] = 3657,
  [3728] = 2182,
  [3729] = 3309,
  [3730] = 3730,
  [3731] = 2947,
  [3732] = 3661,
  [3733] = 3662,
  [3734] = 3166,
  [3735] = 2998,
  [3736] = 3736,
  [3737] = 3615,
  [3738] = 3736,
  [3739] = 2173,
  [3740] = 3166,
  [3741] = 3593,
  [3742] = 3594,
  [3743] = 3595,
  [3744] = 3744,
  [3745] = 3596,
  [3746] = 3087,
  [3747] = 1942,
  [3748] = 3736,
  [3749] = 3736,
  [3750] = 3736,
  [3751] = 3751,
  [3752] = 3736,
  [3753] = 3736,
  [3754] = 3754,
  [3755] = 3754,
  [3756] = 3089,
  [3757] = 3014,
  [3758] = 3736,
  [3759] = 3312,
  [3760] = 3043,
  [3761] = 3625,
  [3762] = 3615,
  [3763] = 3736,
  [3764] = 3048,
  [3765] = 3659,
  [3766] = 3095,
  [3767] = 3049,
  [3768] = 3050,
  [3769] = 3017,
  [3770] = 3024,
  [3771] = 3682,
  [3772] = 3006,
  [3773] = 3007,
  [3774] = 3736,
  [3775] = 3096,
  [3776] = 3098,
  [3777] = 3099,
  [3778] = 3367,
  [3779] = 3779,
  [3780] = 3052,
  [3781] = 3047,
  [3782] = 3100,
  [3783] = 3075,
  [3784] = 3101,
  [3785] = 3298,
  [3786] = 3786,
  [3787] = 2382,
  [3788] = 3648,
  [3789] = 3736,
  [3790] = 3736,
  [3791] = 3067,
  [3792] = 3736,
  [3793] = 3793,
  [3794] = 3023,
  [3795] = 3649,
  [3796] = 3796,
  [3797] = 3058,
  [3798] = 3736,
  [3799] = 3647,
  [3800] = 3081,
  [3801] = 3653,
  [3802] = 3381,
  [3803] = 3396,
  [3804] = 3593,
  [3805] = 3341,
  [3806] = 3594,
  [3807] = 3595,
  [3808] = 3653,
  [3809] = 3654,
  [3810] = 3657,
  [3811] = 3596,
  [3812] = 3661,
  [3813] = 3682,
  [3814] = 3662,
  [3815] = 3664,
  [3816] = 3668,
  [3817] = 3377,
  [3818] = 3654,
  [3819] = 3367,
  [3820] = 3286,
  [3821] = 3331,
  [3822] = 3648,
  [3823] = 3649,
  [3824] = 3063,
  [3825] = 3333,
  [3826] = 3650,
  [3827] = 3376,
  [3828] = 3751,
  [3829] = 3281,
  [3830] = 3301,
  [3831] = 3754,
  [3832] = 3391,
  [3833] = 3268,
  [3834] = 3280,
  [3835] = 3059,
  [3836] = 3282,
  [3837] = 3837,
  [3838] = 3736,
  [3839] = 3650,
  [3840] = 3736,
  [3841] = 3002,
  [3842] = 3293,
  [3843] = 3625,
  [3844] = 3295,
  [3845] = 3297,
  [3846] = 3300,
  [3847] = 3066,
  [3848] = 3307,
  [3849] = 3657,
  [3850] = 3661,
  [3851] = 3751,
  [3852] = 3662,
  [3853] = 3736,
  [3854] = 3754,
  [3855] = 3664,
  [3856] = 3668,
  [3857] = 3736,
  [3858] = 3647,
  [3859] = 3061,
  [3860] = 3754,
  [3861] = 3736,
  [3862] = 3015,
  [3863] = 3863,
  [3864] = 3751,
  [3865] = 3754,
  [3866] = 3736,
  [3867] = 3736,
  [3868] = 3020,
  [3869] = 3754,
  [3870] = 3736,
  [3871] = 3736,
  [3872] = 3754,
  [3873] = 3021,
  [3874] = 3736,
  [3875] = 3875,
  [3876] = 3070,
  [3877] = 3083,
  [3878] = 3736,
  [3879] = 3071,
  [3880] = 3092,
  [3881] = 3655,
  [3882] = 3882,
  [3883] = 3736,
  [3884] = 3001,
  [3885] = 3033,
  [3886] = 3659,
  [3887] = 3079,
  [3888] = 3888,
  [3889] = 3736,
  [3890] = 3736,
  [3891] = 3097,
  [3892] = 3312,
  [3893] = 3736,
  [3894] = 3736,
  [3895] = 3736,
  [3896] = 3736,
  [3897] = 3003,
  [3898] = 3005,
  [3899] = 3011,
  [3900] = 1937,
  [3901] = 3013,
  [3902] = 3167,
  [3903] = 3736,
  [3904] = 3736,
  [3905] = 2173,
  [3906] = 3064,
  [3907] = 3078,
  [3908] = 3084,
  [3909] = 3028,
  [3910] = 3736,
  [3911] = 3736,
  [3912] = 3032,
  [3913] = 3022,
  [3914] = 3736,
  [3915] = 3041,
  [3916] = 3046,
  [3917] = 3051,
  [3918] = 3085,
  [3919] = 3736,
  [3920] = 3382,
  [3921] = 3383,
  [3922] = 3065,
  [3923] = 3655,
  [3924] = 3068,
  [3925] = 3069,
  [3926] = 3074,
  [3927] = 3076,
  [3928] = 3736,
  [3929] = 3086,
  [3930] = 3312,
  [3931] = 3091,
  [3932] = 1915,
  [3933] = 3004,
  [3934] = 3639,
  [3935] = 3008,
  [3936] = 3936,
  [3937] = 3736,
  [3938] = 3312,
  [3939] = 3010,
  [3940] = 3303,
  [3941] = 3941,
  [3942] = 3942,
  [3943] = 3943,
  [3944] = 3779,
  [3945] = 3941,
  [3946] = 3941,
  [3947] = 2173,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3948,
  [3951] = 3951,
  [3952] = 3647,
  [3953] = 3648,
  [3954] = 3948,
  [3955] = 3649,
  [3956] = 3650,
  [3957] = 3949,
  [3958] = 3949,
  [3959] = 3653,
  [3960] = 3655,
  [3961] = 3948,
  [3962] = 3659,
  [3963] = 3625,
  [3964] = 3654,
  [3965] = 3949,
  [3966] = 3657,
  [3967] = 3661,
  [3968] = 3949,
  [3969] = 3662,
  [3970] = 3664,
  [3971] = 3949,
  [3972] = 3668,
  [3973] = 3948,
  [3974] = 3974,
  [3975] = 3975,
  [3976] = 3367,
  [3977] = 3949,
  [3978] = 3648,
  [3979] = 3649,
  [3980] = 3949,
  [3981] = 3948,
  [3982] = 3948,
  [3983] = 3949,
  [3984] = 3699,
  [3985] = 3948,
  [3986] = 3698,
  [3987] = 3948,
  [3988] = 3948,
  [3989] = 3949,
  [3990] = 3615,
  [3991] = 3650,
  [3992] = 3992,
  [3993] = 3992,
  [3994] = 3949,
  [3995] = 3948,
  [3996] = 3700,
  [3997] = 3997,
  [3998] = 3948,
  [3999] = 3992,
  [4000] = 3625,
  [4001] = 3943,
  [4002] = 3942,
  [4003] = 3949,
  [4004] = 3948,
  [4005] = 3698,
  [4006] = 4006,
  [4007] = 3997,
  [4008] = 3949,
  [4009] = 3942,
  [4010] = 3974,
  [4011] = 3948,
  [4012] = 3949,
  [4013] = 4006,
  [4014] = 3949,
  [4015] = 4015,
  [4016] = 3949,
  [4017] = 4006,
  [4018] = 3948,
  [4019] = 3941,
  [4020] = 3949,
  [4021] = 3949,
  [4022] = 4022,
  [4023] = 3975,
  [4024] = 3949,
  [4025] = 4025,
  [4026] = 3949,
  [4027] = 3949,
  [4028] = 2193,
  [4029] = 3948,
  [4030] = 4015,
  [4031] = 3949,
  [4032] = 4032,
  [4033] = 3948,
  [4034] = 3593,
  [4035] = 3949,
  [4036] = 3949,
  [4037] = 3594,
  [4038] = 3595,
  [4039] = 3653,
  [4040] = 3654,
  [4041] = 3657,
  [4042] = 3596,
  [4043] = 3661,
  [4044] = 3941,
  [4045] = 3662,
  [4046] = 3664,
  [4047] = 3668,
  [4048] = 3949,
  [4049] = 3682,
  [4050] = 3639,
  [4051] = 3949,
  [4052] = 3997,
  [4053] = 3942,
  [4054] = 3949,
  [4055] = 3975,
  [4056] = 4015,
  [4057] = 3949,
  [4058] = 3593,
  [4059] = 3594,
  [4060] = 3595,
  [4061] = 3596,
  [4062] = 3699,
  [4063] = 3700,
  [4064] = 3949,
  [4065] = 3949,
  [4066] = 3948,
  [4067] = 3992,
  [4068] = 3615,
  [4069] = 3863,
  [4070] = 3948,
  [4071] = 3997,
  [4072] = 3942,
  [4073] = 3949,
  [4074] = 3949,
  [4075] = 3949,
  [4076] = 3948,
  [4077] = 3948,
  [4078] = 3949,
  [4079] = 3943,
  [4080] = 3948,
  [4081] = 3949,
  [4082] = 3948,
  [4083] = 3948,
  [4084] = 3941,
  [4085] = 3701,
  [4086] = 2915,
  [4087] = 3702,
  [4088] = 3949,
  [4089] = 3949,
  [4090] = 3949,
  [4091] = 3701,
  [4092] = 3948,
  [4093] = 3702,
  [4094] = 2956,
  [4095] = 3974,
  [4096] = 3682,
  [4097] = 3948,
  [4098] = 2194,
  [4099] = 3949,
  [4100] = 3992,
  [4101] = 3647,
  [4102] = 3997,
  [4103] = 3949,
  [4104] = 3655,
  [4105] = 3664,
  [4106] = 3668,
  [4107] = 2450,
  [4108] = 2448,
  [4109] = 3594,
  [4110] = 3668,
  [4111] = 3625,
  [4112] = 2403,
  [4113] = 3595,
  [4114] = 3653,
  [4115] = 3654,
  [4116] = 2940,
  [4117] = 3615,
  [4118] = 3367,
  [4119] = 3615,
  [4120] = 3661,
  [4121] = 3659,
  [4122] = 3653,
  [4123] = 2428,
  [4124] = 3654,
  [4125] = 3657,
  [4126] = 2186,
  [4127] = 2184,
  [4128] = 3657,
  [4129] = 2173,
  [4130] = 2189,
  [4131] = 3596,
  [4132] = 2173,
  [4133] = 3661,
  [4134] = 2942,
  [4135] = 2187,
  [4136] = 2950,
  [4137] = 3647,
  [4138] = 3682,
  [4139] = 3309,
  [4140] = 3662,
  [4141] = 3682,
  [4142] = 3664,
  [4143] = 3625,
  [4144] = 2382,
  [4145] = 3648,
  [4146] = 3649,
  [4147] = 3699,
  [4148] = 3700,
  [4149] = 3701,
  [4150] = 3702,
  [4151] = 3639,
  [4152] = 3779,
  [4153] = 3650,
  [4154] = 3593,
  [4155] = 3698,
  [4156] = 3593,
  [4157] = 3594,
  [4158] = 3648,
  [4159] = 3595,
  [4160] = 3596,
  [4161] = 3863,
  [4162] = 2185,
  [4163] = 3649,
  [4164] = 3662,
  [4165] = 3650,
  [4166] = 3647,
  [4167] = 3779,
  [4168] = 3280,
  [4169] = 3625,
  [4170] = 3282,
  [4171] = 3281,
  [4172] = 3615,
  [4173] = 3647,
  [4174] = 3367,
  [4175] = 3701,
  [4176] = 3702,
  [4177] = 3863,
  [4178] = 3682,
  [4179] = 3300,
  [4180] = 3661,
  [4181] = 3698,
  [4182] = 3648,
  [4183] = 3662,
  [4184] = 3664,
  [4185] = 3649,
  [4186] = 3293,
  [4187] = 3668,
  [4188] = 2173,
  [4189] = 3297,
  [4190] = 4190,
  [4191] = 2407,
  [4192] = 3596,
  [4193] = 3376,
  [4194] = 3657,
  [4195] = 3593,
  [4196] = 3699,
  [4197] = 3700,
  [4198] = 3650,
  [4199] = 3594,
  [4200] = 3303,
  [4201] = 3381,
  [4202] = 3382,
  [4203] = 3396,
  [4204] = 3595,
  [4205] = 3341,
  [4206] = 3377,
  [4207] = 3383,
  [4208] = 3653,
  [4209] = 3286,
  [4210] = 3331,
  [4211] = 3367,
  [4212] = 3301,
  [4213] = 3298,
  [4214] = 3659,
  [4215] = 3307,
  [4216] = 3295,
  [4217] = 3391,
  [4218] = 3654,
  [4219] = 3268,
  [4220] = 3655,
  [4221] = 3596,
  [4222] = 4222,
  [4223] = 3625,
  [4224] = 3653,
  [4225] = 3648,
  [4226] = 3668,
  [4227] = 3615,
  [4228] = 3595,
  [4229] = 3648,
  [4230] = 3649,
  [4231] = 3647,
  [4232] = 3654,
  [4233] = 3657,
  [4234] = 4234,
  [4235] = 3615,
  [4236] = 3863,
  [4237] = 4237,
  [4238] = 3593,
  [4239] = 3650,
  [4240] = 3596,
  [4241] = 3594,
  [4242] = 3661,
  [4243] = 4243,
  [4244] = 3662,
  [4245] = 3653,
  [4246] = 3664,
  [4247] = 3654,
  [4248] = 3647,
  [4249] = 2915,
  [4250] = 3668,
  [4251] = 2423,
  [4252] = 4252,
  [4253] = 3682,
  [4254] = 3593,
  [4255] = 3648,
  [4256] = 3367,
  [4257] = 3657,
  [4258] = 3649,
  [4259] = 3698,
  [4260] = 3664,
  [4261] = 3596,
  [4262] = 3661,
  [4263] = 3662,
  [4264] = 3664,
  [4265] = 3668,
  [4266] = 3625,
  [4267] = 3699,
  [4268] = 3700,
  [4269] = 3649,
  [4270] = 3647,
  [4271] = 3594,
  [4272] = 3779,
  [4273] = 3655,
  [4274] = 3639,
  [4275] = 3594,
  [4276] = 3595,
  [4277] = 3650,
  [4278] = 3382,
  [4279] = 3595,
  [4280] = 3701,
  [4281] = 3650,
  [4282] = 3659,
  [4283] = 3702,
  [4284] = 3661,
  [4285] = 3625,
  [4286] = 3639,
  [4287] = 3615,
  [4288] = 3653,
  [4289] = 3682,
  [4290] = 3662,
  [4291] = 3682,
  [4292] = 3657,
  [4293] = 2382,
  [4294] = 3593,
  [4295] = 3654,
  [4296] = 3383,
  [4297] = 2194,
  [4298] = 3661,
  [4299] = 3648,
  [4300] = 4300,
  [4301] = 3593,
  [4302] = 3615,
  [4303] = 4300,
  [4304] = 3650,
  [4305] = 3593,
  [4306] = 2173,
  [4307] = 3661,
  [4308] = 3662,
  [4309] = 3650,
  [4310] = 3595,
  [4311] = 3625,
  [4312] = 3615,
  [4313] = 3664,
  [4314] = 3647,
  [4315] = 3657,
  [4316] = 2183,
  [4317] = 3668,
  [4318] = 2182,
  [4319] = 2173,
  [4320] = 3625,
  [4321] = 3653,
  [4322] = 3594,
  [4323] = 2943,
  [4324] = 3639,
  [4325] = 3653,
  [4326] = 3650,
  [4327] = 3654,
  [4328] = 3596,
  [4329] = 3682,
  [4330] = 3657,
  [4331] = 3648,
  [4332] = 3649,
  [4333] = 4300,
  [4334] = 2421,
  [4335] = 3661,
  [4336] = 3682,
  [4337] = 2396,
  [4338] = 3594,
  [4339] = 3654,
  [4340] = 3593,
  [4341] = 3594,
  [4342] = 3639,
  [4343] = 4300,
  [4344] = 3595,
  [4345] = 3657,
  [4346] = 3596,
  [4347] = 3682,
  [4348] = 2425,
  [4349] = 3662,
  [4350] = 3595,
  [4351] = 3649,
  [4352] = 3664,
  [4353] = 2939,
  [4354] = 3668,
  [4355] = 2411,
  [4356] = 3653,
  [4357] = 3659,
  [4358] = 4300,
  [4359] = 3654,
  [4360] = 2413,
  [4361] = 3647,
  [4362] = 2942,
  [4363] = 2950,
  [4364] = 3698,
  [4365] = 3699,
  [4366] = 3700,
  [4367] = 3701,
  [4368] = 3702,
  [4369] = 3625,
  [4370] = 2940,
  [4371] = 3596,
  [4372] = 3639,
  [4373] = 3615,
  [4374] = 2194,
  [4375] = 3662,
  [4376] = 3664,
  [4377] = 2956,
  [4378] = 2956,
  [4379] = 3668,
  [4380] = 4300,
  [4381] = 3648,
  [4382] = 2193,
  [4383] = 3649,
  [4384] = 3647,
  [4385] = 2424,
  [4386] = 3655,
  [4387] = 2183,
  [4388] = 2182,
  [4389] = 2949,
  [4390] = 3661,
  [4391] = 3668,
  [4392] = 3668,
  [4393] = 3659,
  [4394] = 3647,
  [4395] = 2971,
  [4396] = 3657,
  [4397] = 3662,
  [4398] = 2428,
  [4399] = 2984,
  [4400] = 3662,
  [4401] = 2184,
  [4402] = 3779,
  [4403] = 2993,
  [4404] = 2359,
  [4405] = 2396,
  [4406] = 3367,
  [4407] = 2337,
  [4408] = 3649,
  [4409] = 2344,
  [4410] = 3668,
  [4411] = 3655,
  [4412] = 3659,
  [4413] = 3650,
  [4414] = 2450,
  [4415] = 2193,
  [4416] = 3682,
  [4417] = 2985,
  [4418] = 3648,
  [4419] = 2187,
  [4420] = 3649,
  [4421] = 3648,
  [4422] = 4422,
  [4423] = 3653,
  [4424] = 3654,
  [4425] = 3657,
  [4426] = 3661,
  [4427] = 3650,
  [4428] = 3662,
  [4429] = 3664,
  [4430] = 3664,
  [4431] = 3649,
  [4432] = 3668,
  [4433] = 3625,
  [4434] = 3639,
  [4435] = 2382,
  [4436] = 3655,
  [4437] = 3382,
  [4438] = 3383,
  [4439] = 2902,
  [4440] = 3650,
  [4441] = 2334,
  [4442] = 2189,
  [4443] = 3647,
  [4444] = 3647,
  [4445] = 3309,
  [4446] = 3595,
  [4447] = 2358,
  [4448] = 2403,
  [4449] = 4449,
  [4450] = 2421,
  [4451] = 3625,
  [4452] = 3659,
  [4453] = 4453,
  [4454] = 4453,
  [4455] = 3647,
  [4456] = 3615,
  [4457] = 4457,
  [4458] = 3593,
  [4459] = 2407,
  [4460] = 3639,
  [4461] = 3863,
  [4462] = 3639,
  [4463] = 3615,
  [4464] = 3650,
  [4465] = 2341,
  [4466] = 2423,
  [4467] = 3593,
  [4468] = 3594,
  [4469] = 3595,
  [4470] = 4422,
  [4471] = 3653,
  [4472] = 4422,
  [4473] = 3661,
  [4474] = 3648,
  [4475] = 3664,
  [4476] = 3648,
  [4477] = 4453,
  [4478] = 2958,
  [4479] = 3593,
  [4480] = 3594,
  [4481] = 2246,
  [4482] = 3596,
  [4483] = 2185,
  [4484] = 2398,
  [4485] = 3682,
  [4486] = 3649,
  [4487] = 4422,
  [4488] = 4488,
  [4489] = 3625,
  [4490] = 4453,
  [4491] = 4491,
  [4492] = 3615,
  [4493] = 3594,
  [4494] = 3595,
  [4495] = 2173,
  [4496] = 3682,
  [4497] = 2450,
  [4498] = 2399,
  [4499] = 3595,
  [4500] = 3653,
  [4501] = 3654,
  [4502] = 3653,
  [4503] = 2424,
  [4504] = 3682,
  [4505] = 3367,
  [4506] = 2340,
  [4507] = 3662,
  [4508] = 2342,
  [4509] = 3596,
  [4510] = 3654,
  [4511] = 3664,
  [4512] = 4453,
  [4513] = 3654,
  [4514] = 3655,
  [4515] = 2186,
  [4516] = 3657,
  [4517] = 4422,
  [4518] = 3657,
  [4519] = 2411,
  [4520] = 2413,
  [4521] = 3779,
  [4522] = 3698,
  [4523] = 3699,
  [4524] = 3700,
  [4525] = 3701,
  [4526] = 3702,
  [4527] = 2448,
  [4528] = 3661,
  [4529] = 3593,
  [4530] = 2398,
  [4531] = 3625,
  [4532] = 3594,
  [4533] = 3615,
  [4534] = 3596,
  [4535] = 3596,
  [4536] = 2975,
  [4537] = 2425,
  [4538] = 2349,
  [4539] = 2173,
  [4540] = 2382,
  [4541] = 4453,
  [4542] = 3863,
  [4543] = 3595,
  [4544] = 3647,
  [4545] = 3653,
  [4546] = 3654,
  [4547] = 3657,
  [4548] = 3661,
  [4549] = 3682,
  [4550] = 3662,
  [4551] = 3664,
  [4552] = 3668,
  [4553] = 3648,
  [4554] = 3649,
  [4555] = 3650,
  [4556] = 3625,
  [4557] = 3653,
  [4558] = 3654,
  [4559] = 3657,
  [4560] = 3661,
  [4561] = 3662,
  [4562] = 3664,
  [4563] = 3668,
  [4564] = 4564,
  [4565] = 3367,
  [4566] = 3382,
  [4567] = 3383,
  [4568] = 3648,
  [4569] = 4569,
  [4570] = 3593,
  [4571] = 3594,
  [4572] = 3596,
  [4573] = 1937,
  [4574] = 3593,
  [4575] = 3594,
  [4576] = 3653,
  [4577] = 3654,
  [4578] = 3657,
  [4579] = 3596,
  [4580] = 3661,
  [4581] = 3662,
  [4582] = 3664,
  [4583] = 3668,
  [4584] = 3647,
  [4585] = 3682,
  [4586] = 3648,
  [4587] = 3649,
  [4588] = 3650,
  [4589] = 3625,
  [4590] = 3682,
  [4591] = 1915,
  [4592] = 2913,
  [4593] = 2415,
  [4594] = 1942,
  [4595] = 2382,
  [4596] = 2926,
  [4597] = 4597,
  [4598] = 3367,
  [4599] = 3382,
  [4600] = 3593,
  [4601] = 3594,
  [4602] = 3596,
  [4603] = 3682,
  [4604] = 3383,
  [4605] = 4605,
  [4606] = 3779,
  [4607] = 2399,
  [4608] = 3593,
  [4609] = 3594,
  [4610] = 3595,
  [4611] = 3653,
  [4612] = 3654,
  [4613] = 3657,
  [4614] = 3596,
  [4615] = 3661,
  [4616] = 3682,
  [4617] = 3662,
  [4618] = 3664,
  [4619] = 3668,
  [4620] = 3649,
  [4621] = 3650,
  [4622] = 2919,
  [4623] = 3647,
  [4624] = 3593,
  [4625] = 3594,
  [4626] = 3596,
  [4627] = 3682,
  [4628] = 2922,
  [4629] = 3064,
  [4630] = 3066,
  [4631] = 3067,
  [4632] = 3070,
  [4633] = 3071,
  [4634] = 3593,
  [4635] = 3594,
  [4636] = 3596,
  [4637] = 3682,
  [4638] = 3075,
  [4639] = 3078,
  [4640] = 3081,
  [4641] = 3083,
  [4642] = 3001,
  [4643] = 3084,
  [4644] = 3085,
  [4645] = 3087,
  [4646] = 3089,
  [4647] = 3095,
  [4648] = 3096,
  [4649] = 3098,
  [4650] = 3099,
  [4651] = 3100,
  [4652] = 3101,
  [4653] = 3063,
  [4654] = 3002,
  [4655] = 3015,
  [4656] = 3020,
  [4657] = 3092,
  [4658] = 3655,
  [4659] = 3097,
  [4660] = 3003,
  [4661] = 3005,
  [4662] = 3011,
  [4663] = 3013,
  [4664] = 4664,
  [4665] = 3028,
  [4666] = 3032,
  [4667] = 3041,
  [4668] = 3046,
  [4669] = 3051,
  [4670] = 3065,
  [4671] = 3068,
  [4672] = 3069,
  [4673] = 3074,
  [4674] = 3076,
  [4675] = 2998,
  [4676] = 3625,
  [4677] = 3615,
  [4678] = 3647,
  [4679] = 3086,
  [4680] = 3091,
  [4681] = 3593,
  [4682] = 3648,
  [4683] = 3699,
  [4684] = 3700,
  [4685] = 3594,
  [4686] = 3595,
  [4687] = 3653,
  [4688] = 3654,
  [4689] = 3657,
  [4690] = 3596,
  [4691] = 3661,
  [4692] = 3701,
  [4693] = 3702,
  [4694] = 3682,
  [4695] = 3662,
  [4696] = 3664,
  [4697] = 3668,
  [4698] = 3649,
  [4699] = 3625,
  [4700] = 3615,
  [4701] = 3004,
  [4702] = 3008,
  [4703] = 3010,
  [4704] = 3014,
  [4705] = 3367,
  [4706] = 3779,
  [4707] = 3017,
  [4708] = 3650,
  [4709] = 3625,
  [4710] = 3021,
  [4711] = 3022,
  [4712] = 3024,
  [4713] = 3033,
  [4714] = 3659,
  [4715] = 3079,
  [4716] = 3043,
  [4717] = 3863,
  [4718] = 3048,
  [4719] = 3049,
  [4720] = 3050,
  [4721] = 3052,
  [4722] = 3047,
  [4723] = 3058,
  [4724] = 3059,
  [4725] = 3061,
  [4726] = 3595,
  [4727] = 3647,
  [4728] = 3648,
  [4729] = 3647,
  [4730] = 3648,
  [4731] = 3649,
  [4732] = 3650,
  [4733] = 3625,
  [4734] = 3863,
  [4735] = 3307,
  [4736] = 3615,
  [4737] = 3647,
  [4738] = 3682,
  [4739] = 3639,
  [4740] = 3648,
  [4741] = 3655,
  [4742] = 3649,
  [4743] = 3650,
  [4744] = 3659,
  [4745] = 3639,
  [4746] = 3615,
  [4747] = 3647,
  [4748] = 3653,
  [4749] = 3654,
  [4750] = 3657,
  [4751] = 3661,
  [4752] = 3662,
  [4753] = 3664,
  [4754] = 3668,
  [4755] = 3648,
  [4756] = 3649,
  [4757] = 3650,
  [4758] = 3625,
  [4759] = 3593,
  [4760] = 3594,
  [4761] = 3595,
  [4762] = 3596,
  [4763] = 3006,
  [4764] = 3007,
  [4765] = 3639,
  [4766] = 3298,
  [4767] = 3655,
  [4768] = 3639,
  [4769] = 3659,
  [4770] = 3595,
  [4771] = 3647,
  [4772] = 3653,
  [4773] = 3654,
  [4774] = 3657,
  [4775] = 3661,
  [4776] = 3662,
  [4777] = 3664,
  [4778] = 3668,
  [4779] = 3648,
  [4780] = 3649,
  [4781] = 3650,
  [4782] = 3625,
  [4783] = 3639,
  [4784] = 3647,
  [4785] = 3653,
  [4786] = 3654,
  [4787] = 3657,
  [4788] = 3595,
  [4789] = 3661,
  [4790] = 3655,
  [4791] = 3639,
  [4792] = 3659,
  [4793] = 3662,
  [4794] = 3615,
  [4795] = 3664,
  [4796] = 3615,
  [4797] = 3595,
  [4798] = 3668,
  [4799] = 3648,
  [4800] = 3649,
  [4801] = 3650,
  [4802] = 3863,
  [4803] = 3367,
  [4804] = 3779,
  [4805] = 3655,
  [4806] = 3659,
  [4807] = 3615,
  [4808] = 3595,
  [4809] = 3625,
  [4810] = 3615,
  [4811] = 3615,
  [4812] = 3615,
  [4813] = 3023,
  [4814] = 3381,
  [4815] = 3396,
  [4816] = 3341,
  [4817] = 3377,
  [4818] = 3286,
  [4819] = 3331,
  [4820] = 3698,
  [4821] = 3698,
  [4822] = 3699,
  [4823] = 3700,
  [4824] = 3701,
  [4825] = 3702,
  [4826] = 3593,
  [4827] = 3594,
  [4828] = 3595,
  [4829] = 3653,
  [4830] = 3654,
  [4831] = 3657,
  [4832] = 3596,
  [4833] = 3661,
  [4834] = 3682,
  [4835] = 3662,
  [4836] = 3664,
  [4837] = 3668,
  [4838] = 3647,
  [4839] = 3593,
  [4840] = 3594,
  [4841] = 3595,
  [4842] = 3653,
  [4843] = 3654,
  [4844] = 3657,
  [4845] = 3596,
  [4846] = 3661,
  [4847] = 3682,
  [4848] = 3662,
  [4849] = 3664,
  [4850] = 3668,
  [4851] = 3648,
  [4852] = 3649,
  [4853] = 3650,
  [4854] = 3625,
  [4855] = 3649,
  [4856] = 3376,
  [4857] = 3281,
  [4858] = 3301,
  [4859] = 3650,
  [4860] = 3391,
  [4861] = 3268,
  [4862] = 3280,
  [4863] = 3698,
  [4864] = 3699,
  [4865] = 3700,
  [4866] = 3701,
  [4867] = 3702,
  [4868] = 3282,
  [4869] = 3293,
  [4870] = 3295,
  [4871] = 3297,
  [4872] = 3593,
  [4873] = 3594,
  [4874] = 3653,
  [4875] = 3654,
  [4876] = 3657,
  [4877] = 3596,
  [4878] = 3661,
  [4879] = 3662,
  [4880] = 3664,
  [4881] = 3668,
  [4882] = 3300,
  [4883] = 3303,
  [4884] = 3655,
  [4885] = 3639,
  [4886] = 3659,
  [4887] = 3615,
  [4888] = 3625,
  [4889] = 3596,
  [4890] = 3625,
  [4891] = 4891,
  [4892] = 4892,
  [4893] = 3593,
  [4894] = 3594,
  [4895] = 3595,
  [4896] = 3653,
  [4897] = 3654,
  [4898] = 3657,
  [4899] = 3596,
  [4900] = 3661,
  [4901] = 4901,
  [4902] = 4902,
  [4903] = 3662,
  [4904] = 4904,
  [4905] = 3593,
  [4906] = 3594,
  [4907] = 3653,
  [4908] = 3654,
  [4909] = 3657,
  [4910] = 3596,
  [4911] = 3661,
  [4912] = 3662,
  [4913] = 3664,
  [4914] = 3668,
  [4915] = 3664,
  [4916] = 3647,
  [4917] = 3682,
  [4918] = 3648,
  [4919] = 3649,
  [4920] = 3650,
  [4921] = 3625,
  [4922] = 3668,
  [4923] = 4902,
  [4924] = 4902,
  [4925] = 4902,
  [4926] = 4902,
  [4927] = 4902,
  [4928] = 4928,
  [4929] = 3699,
  [4930] = 3700,
  [4931] = 4902,
  [4932] = 3654,
  [4933] = 3657,
  [4934] = 4891,
  [4935] = 3596,
  [4936] = 3661,
  [4937] = 4564,
  [4938] = 4938,
  [4939] = 3647,
  [4940] = 4901,
  [4941] = 4891,
  [4942] = 3682,
  [4943] = 3593,
  [4944] = 2956,
  [4945] = 4902,
  [4946] = 4946,
  [4947] = 3594,
  [4948] = 3682,
  [4949] = 3648,
  [4950] = 3650,
  [4951] = 2450,
  [4952] = 2448,
  [4953] = 3648,
  [4954] = 3593,
  [4955] = 3594,
  [4956] = 3653,
  [4957] = 3654,
  [4958] = 3657,
  [4959] = 4901,
  [4960] = 3661,
  [4961] = 3662,
  [4962] = 3664,
  [4963] = 3668,
  [4964] = 3649,
  [4965] = 3701,
  [4966] = 3702,
  [4967] = 3662,
  [4968] = 4902,
  [4969] = 4891,
  [4970] = 3625,
  [4971] = 4901,
  [4972] = 4972,
  [4973] = 4973,
  [4974] = 3647,
  [4975] = 4901,
  [4976] = 4902,
  [4977] = 3682,
  [4978] = 3648,
  [4979] = 3649,
  [4980] = 3650,
  [4981] = 3625,
  [4982] = 3593,
  [4983] = 4983,
  [4984] = 3594,
  [4985] = 3653,
  [4986] = 3654,
  [4987] = 3657,
  [4988] = 3596,
  [4989] = 3661,
  [4990] = 3662,
  [4991] = 3664,
  [4992] = 3668,
  [4993] = 4993,
  [4994] = 3593,
  [4995] = 4995,
  [4996] = 3647,
  [4997] = 4997,
  [4998] = 4998,
  [4999] = 3648,
  [5000] = 4902,
  [5001] = 3594,
  [5002] = 3779,
  [5003] = 3647,
  [5004] = 3682,
  [5005] = 3648,
  [5006] = 3649,
  [5007] = 3650,
  [5008] = 3625,
  [5009] = 3595,
  [5010] = 3653,
  [5011] = 4902,
  [5012] = 3654,
  [5013] = 3657,
  [5014] = 3596,
  [5015] = 3661,
  [5016] = 3682,
  [5017] = 3662,
  [5018] = 3615,
  [5019] = 3863,
  [5020] = 3664,
  [5021] = 3863,
  [5022] = 3625,
  [5023] = 3668,
  [5024] = 3649,
  [5025] = 3615,
  [5026] = 4902,
  [5027] = 4891,
  [5028] = 3309,
  [5029] = 4901,
  [5030] = 3367,
  [5031] = 3650,
  [5032] = 3649,
  [5033] = 3664,
  [5034] = 3650,
  [5035] = 4902,
  [5036] = 3639,
  [5037] = 4902,
  [5038] = 4938,
  [5039] = 3593,
  [5040] = 3594,
  [5041] = 3653,
  [5042] = 3654,
  [5043] = 3657,
  [5044] = 3596,
  [5045] = 3661,
  [5046] = 3662,
  [5047] = 4902,
  [5048] = 3639,
  [5049] = 3664,
  [5050] = 3595,
  [5051] = 3668,
  [5052] = 3615,
  [5053] = 3779,
  [5054] = 5054,
  [5055] = 4902,
  [5056] = 3639,
  [5057] = 3595,
  [5058] = 3615,
  [5059] = 4902,
  [5060] = 3595,
  [5061] = 3615,
  [5062] = 4902,
  [5063] = 3639,
  [5064] = 3595,
  [5065] = 3615,
  [5066] = 4902,
  [5067] = 3639,
  [5068] = 3595,
  [5069] = 3615,
  [5070] = 3639,
  [5071] = 4891,
  [5072] = 3779,
  [5073] = 3647,
  [5074] = 3682,
  [5075] = 3648,
  [5076] = 3649,
  [5077] = 4902,
  [5078] = 3595,
  [5079] = 3650,
  [5080] = 3625,
  [5081] = 3615,
  [5082] = 4901,
  [5083] = 3863,
  [5084] = 5084,
  [5085] = 4901,
  [5086] = 5086,
  [5087] = 5087,
  [5088] = 4902,
  [5089] = 5089,
  [5090] = 3593,
  [5091] = 3594,
  [5092] = 3653,
  [5093] = 3654,
  [5094] = 3657,
  [5095] = 3596,
  [5096] = 3661,
  [5097] = 3662,
  [5098] = 3664,
  [5099] = 3668,
  [5100] = 3647,
  [5101] = 3682,
  [5102] = 3648,
  [5103] = 3649,
  [5104] = 3650,
  [5105] = 3625,
  [5106] = 5106,
  [5107] = 4902,
  [5108] = 4902,
  [5109] = 5109,
  [5110] = 3668,
  [5111] = 3647,
  [5112] = 3595,
  [5113] = 3625,
  [5114] = 5114,
  [5115] = 3615,
  [5116] = 3698,
  [5117] = 3699,
  [5118] = 3700,
  [5119] = 3701,
  [5120] = 3702,
  [5121] = 3698,
  [5122] = 3699,
  [5123] = 3700,
  [5124] = 3701,
  [5125] = 3702,
  [5126] = 3698,
  [5127] = 3699,
  [5128] = 3700,
  [5129] = 3701,
  [5130] = 3702,
  [5131] = 5131,
  [5132] = 5132,
  [5133] = 3698,
  [5134] = 3699,
  [5135] = 3700,
  [5136] = 3701,
  [5137] = 3702,
  [5138] = 4902,
  [5139] = 3593,
  [5140] = 3594,
  [5141] = 3653,
  [5142] = 3654,
  [5143] = 3657,
  [5144] = 3596,
  [5145] = 3661,
  [5146] = 3662,
  [5147] = 3664,
  [5148] = 3668,
  [5149] = 5149,
  [5150] = 3653,
  [5151] = 3647,
  [5152] = 3698,
  [5153] = 3682,
  [5154] = 3699,
  [5155] = 3700,
  [5156] = 3648,
  [5157] = 3701,
  [5158] = 3702,
  [5159] = 3649,
  [5160] = 3698,
  [5161] = 3650,
  [5162] = 4902,
  [5163] = 5163,
  [5164] = 5164,
  [5165] = 5165,
  [5166] = 5166,
  [5167] = 2278,
  [5168] = 5168,
  [5169] = 2448,
  [5170] = 5170,
  [5171] = 5171,
  [5172] = 4972,
  [5173] = 4973,
  [5174] = 5174,
  [5175] = 3655,
  [5176] = 5176,
  [5177] = 3863,
  [5178] = 5178,
  [5179] = 5179,
  [5180] = 3659,
  [5181] = 3863,
  [5182] = 5182,
  [5183] = 3625,
  [5184] = 3615,
  [5185] = 3863,
  [5186] = 3653,
  [5187] = 2450,
  [5188] = 3367,
  [5189] = 3650,
  [5190] = 3863,
  [5191] = 3682,
  [5192] = 3647,
  [5193] = 5193,
  [5194] = 3682,
  [5195] = 3648,
  [5196] = 5179,
  [5197] = 3615,
  [5198] = 3649,
  [5199] = 3654,
  [5200] = 3650,
  [5201] = 5182,
  [5202] = 5165,
  [5203] = 3593,
  [5204] = 3593,
  [5205] = 3594,
  [5206] = 3779,
  [5207] = 3595,
  [5208] = 3653,
  [5209] = 3654,
  [5210] = 5210,
  [5211] = 3657,
  [5212] = 5212,
  [5213] = 5213,
  [5214] = 3594,
  [5215] = 5215,
  [5216] = 3595,
  [5217] = 3596,
  [5218] = 3367,
  [5219] = 3367,
  [5220] = 5220,
  [5221] = 5221,
  [5222] = 2445,
  [5223] = 5223,
  [5224] = 3596,
  [5225] = 3661,
  [5226] = 3662,
  [5227] = 5174,
  [5228] = 2279,
  [5229] = 5213,
  [5230] = 5230,
  [5231] = 3647,
  [5232] = 3682,
  [5233] = 3648,
  [5234] = 5234,
  [5235] = 3657,
  [5236] = 3649,
  [5237] = 3596,
  [5238] = 3661,
  [5239] = 3650,
  [5240] = 3647,
  [5241] = 3593,
  [5242] = 3594,
  [5243] = 3595,
  [5244] = 3653,
  [5245] = 3654,
  [5246] = 3657,
  [5247] = 3596,
  [5248] = 3661,
  [5249] = 3662,
  [5250] = 3664,
  [5251] = 3668,
  [5252] = 3664,
  [5253] = 3662,
  [5254] = 3664,
  [5255] = 3655,
  [5256] = 5256,
  [5257] = 3668,
  [5258] = 2448,
  [5259] = 5166,
  [5260] = 5260,
  [5261] = 3682,
  [5262] = 3648,
  [5263] = 3863,
  [5264] = 3668,
  [5265] = 5265,
  [5266] = 5221,
  [5267] = 3649,
  [5268] = 3650,
  [5269] = 5269,
  [5270] = 3779,
  [5271] = 5109,
  [5272] = 3593,
  [5273] = 2246,
  [5274] = 3594,
  [5275] = 3779,
  [5276] = 3595,
  [5277] = 4938,
  [5278] = 3649,
  [5279] = 2445,
  [5280] = 3653,
  [5281] = 3863,
  [5282] = 5213,
  [5283] = 3367,
  [5284] = 3654,
  [5285] = 2246,
  [5286] = 3625,
  [5287] = 5287,
  [5288] = 2310,
  [5289] = 5289,
  [5290] = 3657,
  [5291] = 2183,
  [5292] = 5220,
  [5293] = 5221,
  [5294] = 2182,
  [5295] = 5174,
  [5296] = 5296,
  [5297] = 5297,
  [5298] = 3596,
  [5299] = 5220,
  [5300] = 5221,
  [5301] = 5174,
  [5302] = 3863,
  [5303] = 3661,
  [5304] = 3367,
  [5305] = 5305,
  [5306] = 5306,
  [5307] = 3662,
  [5308] = 5220,
  [5309] = 5221,
  [5310] = 5174,
  [5311] = 5213,
  [5312] = 3655,
  [5313] = 5313,
  [5314] = 5314,
  [5315] = 5313,
  [5316] = 5221,
  [5317] = 5314,
  [5318] = 3659,
  [5319] = 5319,
  [5320] = 5319,
  [5321] = 3625,
  [5322] = 3615,
  [5323] = 3647,
  [5324] = 2312,
  [5325] = 5325,
  [5326] = 3779,
  [5327] = 3659,
  [5328] = 3664,
  [5329] = 2313,
  [5330] = 2314,
  [5331] = 3668,
  [5332] = 5220,
  [5333] = 3647,
  [5334] = 3682,
  [5335] = 5335,
  [5336] = 3648,
  [5337] = 3649,
  [5338] = 3650,
  [5339] = 3593,
  [5340] = 3653,
  [5341] = 3654,
  [5342] = 3657,
  [5343] = 3655,
  [5344] = 5220,
  [5345] = 3594,
  [5346] = 5221,
  [5347] = 3661,
  [5348] = 4928,
  [5349] = 3655,
  [5350] = 3659,
  [5351] = 3779,
  [5352] = 3662,
  [5353] = 3625,
  [5354] = 3615,
  [5355] = 3659,
  [5356] = 3779,
  [5357] = 3664,
  [5358] = 3668,
  [5359] = 3625,
  [5360] = 3615,
  [5361] = 3595,
  [5362] = 3382,
  [5363] = 3779,
  [5364] = 3383,
  [5365] = 3648,
  [5366] = 5221,
  [5367] = 5221,
  [5368] = 5221,
  [5369] = 5163,
  [5370] = 5171,
  [5371] = 5371,
  [5372] = 5372,
  [5373] = 5234,
  [5374] = 5374,
  [5375] = 5375,
  [5376] = 5374,
  [5377] = 5377,
  [5378] = 5378,
  [5379] = 5379,
  [5380] = 5380,
  [5381] = 5371,
  [5382] = 5374,
  [5383] = 5383,
  [5384] = 5384,
  [5385] = 5385,
  [5386] = 5374,
  [5387] = 5374,
  [5388] = 5374,
  [5389] = 5389,
  [5390] = 5390,
  [5391] = 5374,
  [5392] = 5374,
  [5393] = 5374,
  [5394] = 5374,
  [5395] = 5374,
  [5396] = 5374,
  [5397] = 5374,
  [5398] = 5374,
  [5399] = 5374,
  [5400] = 5374,
  [5401] = 5374,
  [5402] = 5374,
  [5403] = 5403,
  [5404] = 5378,
  [5405] = 3038,
  [5406] = 3045,
  [5407] = 5407,
  [5408] = 5408,
  [5409] = 5377,
  [5410] = 5374,
  [5411] = 5383,
  [5412] = 5384,
  [5413] = 5385,
  [5414] = 5389,
  [5415] = 5374,
  [5416] = 3653,
  [5417] = 3654,
  [5418] = 3657,
  [5419] = 3661,
  [5420] = 3662,
  [5421] = 3664,
  [5422] = 3668,
  [5423] = 5149,
  [5424] = 5424,
  [5425] = 5425,
  [5426] = 3649,
  [5427] = 5374,
  [5428] = 3647,
  [5429] = 5407,
  [5430] = 5385,
  [5431] = 5431,
  [5432] = 5389,
  [5433] = 5433,
  [5434] = 3650,
  [5435] = 5378,
  [5436] = 3593,
  [5437] = 5437,
  [5438] = 3367,
  [5439] = 2888,
  [5440] = 5425,
  [5441] = 5403,
  [5442] = 5374,
  [5443] = 3594,
  [5444] = 3595,
  [5445] = 3653,
  [5446] = 3654,
  [5447] = 5447,
  [5448] = 3657,
  [5449] = 3596,
  [5450] = 5374,
  [5451] = 3661,
  [5452] = 5379,
  [5453] = 3682,
  [5454] = 3662,
  [5455] = 3664,
  [5456] = 3668,
  [5457] = 5457,
  [5458] = 5458,
  [5459] = 3648,
  [5460] = 3649,
  [5461] = 3648,
  [5462] = 2382,
  [5463] = 4564,
  [5464] = 3647,
  [5465] = 5374,
  [5466] = 3648,
  [5467] = 5437,
  [5468] = 3863,
  [5469] = 5407,
  [5470] = 3650,
  [5471] = 5408,
  [5472] = 3863,
  [5473] = 5473,
  [5474] = 5474,
  [5475] = 5377,
  [5476] = 5374,
  [5477] = 5371,
  [5478] = 5425,
  [5479] = 5447,
  [5480] = 3647,
  [5481] = 5374,
  [5482] = 3648,
  [5483] = 4564,
  [5484] = 5374,
  [5485] = 5374,
  [5486] = 5374,
  [5487] = 5374,
  [5488] = 5378,
  [5489] = 3367,
  [5490] = 5425,
  [5491] = 5491,
  [5492] = 3031,
  [5493] = 3779,
  [5494] = 5494,
  [5495] = 3034,
  [5496] = 3863,
  [5497] = 5431,
  [5498] = 5498,
  [5499] = 5499,
  [5500] = 5500,
  [5501] = 5383,
  [5502] = 5390,
  [5503] = 5384,
  [5504] = 5504,
  [5505] = 3080,
  [5506] = 5385,
  [5507] = 5389,
  [5508] = 3029,
  [5509] = 5509,
  [5510] = 5374,
  [5511] = 3367,
  [5512] = 5425,
  [5513] = 3699,
  [5514] = 3700,
  [5515] = 5390,
  [5516] = 3779,
  [5517] = 3701,
  [5518] = 3702,
  [5519] = 5431,
  [5520] = 2892,
  [5521] = 3593,
  [5522] = 5374,
  [5523] = 3594,
  [5524] = 3595,
  [5525] = 3653,
  [5526] = 3654,
  [5527] = 3657,
  [5528] = 3596,
  [5529] = 3661,
  [5530] = 3682,
  [5531] = 3662,
  [5532] = 3664,
  [5533] = 3668,
  [5534] = 3649,
  [5535] = 3625,
  [5536] = 3615,
  [5537] = 5374,
  [5538] = 3367,
  [5539] = 5425,
  [5540] = 3650,
  [5541] = 3779,
  [5542] = 5542,
  [5543] = 5379,
  [5544] = 5544,
  [5545] = 3625,
  [5546] = 3615,
  [5547] = 5374,
  [5548] = 5425,
  [5549] = 3863,
  [5550] = 5458,
  [5551] = 5374,
  [5552] = 5552,
  [5553] = 5447,
  [5554] = 3698,
  [5555] = 5374,
  [5556] = 3367,
  [5557] = 5425,
  [5558] = 5431,
  [5559] = 5374,
  [5560] = 5560,
  [5561] = 5561,
  [5562] = 3625,
  [5563] = 3615,
  [5564] = 5374,
  [5565] = 3367,
  [5566] = 5425,
  [5567] = 3779,
  [5568] = 5568,
  [5569] = 3625,
  [5570] = 3615,
  [5571] = 5374,
  [5572] = 5425,
  [5573] = 3625,
  [5574] = 3615,
  [5575] = 5374,
  [5576] = 5425,
  [5577] = 3593,
  [5578] = 5374,
  [5579] = 3594,
  [5580] = 5425,
  [5581] = 3595,
  [5582] = 5425,
  [5583] = 5425,
  [5584] = 3653,
  [5585] = 5425,
  [5586] = 5425,
  [5587] = 5425,
  [5588] = 5425,
  [5589] = 5378,
  [5590] = 5379,
  [5591] = 5591,
  [5592] = 3654,
  [5593] = 4564,
  [5594] = 3657,
  [5595] = 3596,
  [5596] = 5390,
  [5597] = 3661,
  [5598] = 3682,
  [5599] = 3662,
  [5600] = 3664,
  [5601] = 3625,
  [5602] = 3668,
  [5603] = 5603,
  [5604] = 3649,
  [5605] = 5509,
  [5606] = 3593,
  [5607] = 3594,
  [5608] = 3595,
  [5609] = 3596,
  [5610] = 3682,
  [5611] = 3650,
  [5612] = 5403,
  [5613] = 3647,
  [5614] = 5614,
  [5615] = 5407,
  [5616] = 5408,
  [5617] = 5377,
  [5618] = 5371,
  [5619] = 5383,
  [5620] = 5384,
  [5621] = 5385,
  [5622] = 5389,
  [5623] = 5403,
  [5624] = 5624,
  [5625] = 2194,
  [5626] = 3647,
  [5627] = 5374,
  [5628] = 3647,
  [5629] = 5629,
  [5630] = 5407,
  [5631] = 5385,
  [5632] = 5389,
  [5633] = 5407,
  [5634] = 3593,
  [5635] = 5374,
  [5636] = 3594,
  [5637] = 3595,
  [5638] = 3653,
  [5639] = 3654,
  [5640] = 3657,
  [5641] = 3596,
  [5642] = 3661,
  [5643] = 3593,
  [5644] = 3648,
  [5645] = 5374,
  [5646] = 5425,
  [5647] = 3594,
  [5648] = 5447,
  [5649] = 3595,
  [5650] = 5374,
  [5651] = 3653,
  [5652] = 3654,
  [5653] = 5374,
  [5654] = 3657,
  [5655] = 5374,
  [5656] = 3596,
  [5657] = 5425,
  [5658] = 3661,
  [5659] = 3699,
  [5660] = 3700,
  [5661] = 3701,
  [5662] = 3702,
  [5663] = 5425,
  [5664] = 3682,
  [5665] = 3662,
  [5666] = 3664,
  [5667] = 3668,
  [5668] = 5509,
  [5669] = 3649,
  [5670] = 3682,
  [5671] = 3863,
  [5672] = 3699,
  [5673] = 3700,
  [5674] = 3701,
  [5675] = 3702,
  [5676] = 3650,
  [5677] = 3698,
  [5678] = 5509,
  [5679] = 3662,
  [5680] = 3664,
  [5681] = 3699,
  [5682] = 3700,
  [5683] = 3701,
  [5684] = 3702,
  [5685] = 3668,
  [5686] = 3648,
  [5687] = 3698,
  [5688] = 3649,
  [5689] = 5509,
  [5690] = 5408,
  [5691] = 3779,
  [5692] = 3698,
  [5693] = 5509,
  [5694] = 3650,
  [5695] = 3863,
  [5696] = 3698,
  [5697] = 5697,
  [5698] = 5374,
  [5699] = 3615,
  [5700] = 5374,
  [5701] = 5425,
  [5702] = 3699,
  [5703] = 3700,
  [5704] = 3701,
  [5705] = 3702,
  [5706] = 5374,
  [5707] = 2445,
  [5708] = 3779,
  [5709] = 5709,
  [5710] = 5709,
  [5711] = 5709,
  [5712] = 5709,
  [5713] = 5709,
  [5714] = 5709,
  [5715] = 5709,
  [5716] = 5709,
  [5717] = 2278,
  [5718] = 5709,
  [5719] = 2325,
  [5720] = 5709,
  [5721] = 5709,
  [5722] = 2445,
  [5723] = 5709,
  [5724] = 5709,
  [5725] = 5709,
  [5726] = 5709,
  [5727] = 5727,
  [5728] = 5709,
  [5729] = 5709,
  [5730] = 5709,
  [5731] = 5731,
  [5732] = 2445,
  [5733] = 5709,
  [5734] = 1915,
  [5735] = 5709,
  [5736] = 5709,
  [5737] = 2445,
  [5738] = 5709,
  [5739] = 5709,
  [5740] = 5709,
  [5741] = 2322,
  [5742] = 5742,
  [5743] = 5709,
  [5744] = 2279,
  [5745] = 2324,
  [5746] = 5709,
  [5747] = 5709,
  [5748] = 5709,
  [5749] = 2445,
  [5750] = 5709,
  [5751] = 5709,
  [5752] = 2445,
  [5753] = 2445,
  [5754] = 2445,
  [5755] = 5709,
  [5756] = 5709,
  [5757] = 2321,
  [5758] = 5709,
  [5759] = 2445,
  [5760] = 5760,
  [5761] = 2445,
  [5762] = 5762,
  [5763] = 5234,
  [5764] = 5764,
  [5765] = 5765,
  [5766] = 5766,
  [5767] = 2445,
  [5768] = 5234,
  [5769] = 5769,
  [5770] = 5770,
  [5771] = 5771,
  [5772] = 5772,
  [5773] = 5773,
  [5774] = 2445,
  [5775] = 5775,
  [5776] = 5776,
  [5777] = 5777,
  [5778] = 5778,
  [5779] = 5779,
  [5780] = 5780,
  [5781] = 2382,
  [5782] = 5782,
  [5783] = 5783,
  [5784] = 5784,
  [5785] = 2450,
  [5786] = 5786,
  [5787] = 5786,
  [5788] = 5782,
  [5789] = 5789,
  [5790] = 5783,
  [5791] = 5791,
  [5792] = 5784,
  [5793] = 2322,
  [5794] = 5794,
  [5795] = 2321,
  [5796] = 2324,
  [5797] = 5797,
  [5798] = 2325,
  [5799] = 5799,
  [5800] = 5765,
  [5801] = 5784,
  [5802] = 5802,
  [5803] = 5803,
  [5804] = 2283,
  [5805] = 5786,
  [5806] = 5783,
  [5807] = 5791,
  [5808] = 5808,
  [5809] = 5809,
  [5810] = 2997,
  [5811] = 5811,
  [5812] = 5809,
  [5813] = 5811,
  [5814] = 5808,
  [5815] = 5811,
  [5816] = 5816,
  [5817] = 5817,
  [5818] = 5809,
  [5819] = 5808,
  [5820] = 5809,
  [5821] = 2191,
  [5822] = 5809,
  [5823] = 5808,
  [5824] = 5811,
  [5825] = 5808,
  [5826] = 5433,
  [5827] = 5827,
  [5828] = 5817,
  [5829] = 5816,
  [5830] = 5811,
  [5831] = 5831,
  [5832] = 5831,
  [5833] = 5831,
  [5834] = 5834,
  [5835] = 5835,
  [5836] = 5831,
  [5837] = 5837,
  [5838] = 5838,
  [5839] = 5837,
  [5840] = 5831,
  [5841] = 5841,
  [5842] = 2902,
  [5843] = 5843,
  [5844] = 5835,
  [5845] = 5845,
  [5846] = 5846,
  [5847] = 5847,
  [5848] = 5847,
  [5849] = 5849,
  [5850] = 5847,
  [5851] = 5851,
  [5852] = 5852,
  [5853] = 5847,
  [5854] = 5847,
  [5855] = 5847,
  [5856] = 5847,
  [5857] = 2926,
  [5858] = 5847,
  [5859] = 5849,
  [5860] = 5860,
  [5861] = 5861,
  [5862] = 5847,
  [5863] = 5863,
  [5864] = 5847,
  [5865] = 5847,
  [5866] = 5847,
  [5867] = 5847,
  [5868] = 5847,
  [5869] = 5849,
  [5870] = 5847,
  [5871] = 5847,
  [5872] = 5847,
  [5873] = 5847,
  [5874] = 5846,
  [5875] = 5847,
  [5876] = 5847,
  [5877] = 5847,
  [5878] = 2892,
  [5879] = 5847,
  [5880] = 5847,
  [5881] = 2888,
  [5882] = 5847,
  [5883] = 5847,
  [5884] = 5847,
  [5885] = 2919,
  [5886] = 5847,
  [5887] = 5887,
  [5888] = 5847,
  [5889] = 5847,
  [5890] = 5847,
  [5891] = 5891,
  [5892] = 5847,
  [5893] = 5847,
  [5894] = 5849,
  [5895] = 5847,
  [5896] = 5847,
  [5897] = 5847,
  [5898] = 5847,
  [5899] = 5899,
  [5900] = 5847,
  [5901] = 5849,
  [5902] = 5847,
  [5903] = 5847,
  [5904] = 5847,
  [5905] = 5847,
  [5906] = 2913,
  [5907] = 2448,
  [5908] = 5847,
  [5909] = 2922,
  [5910] = 5847,
  [5911] = 5847,
  [5912] = 5847,
  [5913] = 5847,
  [5914] = 5847,
  [5915] = 5847,
  [5916] = 5847,
  [5917] = 5847,
  [5918] = 2445,
  [5919] = 5919,
  [5920] = 2445,
  [5921] = 5921,
  [5922] = 2445,
  [5923] = 2445,
  [5924] = 2445,
  [5925] = 2415,
  [5926] = 2445,
  [5927] = 2445,
  [5928] = 2445,
  [5929] = 2445,
  [5930] = 5930,
  [5931] = 2445,
  [5932] = 2445,
  [5933] = 2445,
  [5934] = 2445,
  [5935] = 2445,
  [5936] = 2445,
  [5937] = 2445,
  [5938] = 5938,
  [5939] = 5939,
  [5940] = 2445,
  [5941] = 2445,
  [5942] = 2415,
  [5943] = 2445,
  [5944] = 5944,
  [5945] = 5945,
  [5946] = 2445,
  [5947] = 5947,
  [5948] = 5791,
  [5949] = 2445,
  [5950] = 2445,
  [5951] = 5951,
  [5952] = 2415,
  [5953] = 5945,
  [5954] = 2445,
  [5955] = 2415,
  [5956] = 2445,
  [5957] = 2445,
  [5958] = 5958,
  [5959] = 5959,
  [5960] = 5960,
  [5961] = 5961,
  [5962] = 5962,
  [5963] = 5963,
  [5964] = 5964,
  [5965] = 5961,
  [5966] = 5961,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 5969,
  [5970] = 5970,
  [5971] = 5961,
  [5972] = 5962,
  [5973] = 5973,
  [5974] = 5974,
  [5975] = 5969,
  [5976] = 5961,
  [5977] = 5961,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5980,
  [5981] = 5981,
  [5982] = 5982,
  [5983] = 3038,
  [5984] = 3045,
  [5985] = 5982,
  [5986] = 5979,
  [5987] = 5987,
  [5988] = 5988,
  [5989] = 5988,
  [5990] = 5982,
  [5991] = 5987,
  [5992] = 5979,
  [5993] = 5979,
  [5994] = 5987,
  [5995] = 5995,
  [5996] = 5987,
  [5997] = 5997,
  [5998] = 5982,
  [5999] = 5982,
  [6000] = 5987,
  [6001] = 5987,
  [6002] = 6002,
  [6003] = 5979,
  [6004] = 5987,
  [6005] = 5987,
  [6006] = 5987,
  [6007] = 5987,
  [6008] = 5979,
  [6009] = 5987,
  [6010] = 6010,
  [6011] = 5995,
  [6012] = 5982,
  [6013] = 5982,
  [6014] = 5979,
  [6015] = 5995,
  [6016] = 5987,
  [6017] = 5979,
  [6018] = 5982,
  [6019] = 5987,
  [6020] = 6020,
  [6021] = 5979,
  [6022] = 5987,
  [6023] = 5987,
  [6024] = 5987,
  [6025] = 5995,
  [6026] = 5987,
  [6027] = 6027,
  [6028] = 5987,
  [6029] = 5987,
  [6030] = 3031,
  [6031] = 5987,
  [6032] = 5982,
  [6033] = 5979,
  [6034] = 5995,
  [6035] = 5987,
  [6036] = 5980,
  [6037] = 5979,
  [6038] = 5987,
  [6039] = 3034,
  [6040] = 6040,
  [6041] = 5987,
  [6042] = 5995,
  [6043] = 5987,
  [6044] = 5987,
  [6045] = 6045,
  [6046] = 5995,
  [6047] = 5987,
  [6048] = 6048,
  [6049] = 5988,
  [6050] = 5987,
  [6051] = 5987,
  [6052] = 5987,
  [6053] = 5995,
  [6054] = 6048,
  [6055] = 6055,
  [6056] = 5982,
  [6057] = 5987,
  [6058] = 5987,
  [6059] = 5987,
  [6060] = 6048,
  [6061] = 5987,
  [6062] = 5982,
  [6063] = 5980,
  [6064] = 6064,
  [6065] = 5987,
  [6066] = 5987,
  [6067] = 5978,
  [6068] = 5987,
  [6069] = 5987,
  [6070] = 5979,
  [6071] = 5980,
  [6072] = 6072,
  [6073] = 5979,
  [6074] = 5987,
  [6075] = 5982,
  [6076] = 3080,
  [6077] = 5987,
  [6078] = 6078,
  [6079] = 5979,
  [6080] = 6048,
  [6081] = 5980,
  [6082] = 5987,
  [6083] = 5987,
  [6084] = 5988,
  [6085] = 3029,
  [6086] = 6048,
  [6087] = 5987,
  [6088] = 5987,
  [6089] = 5987,
  [6090] = 5982,
  [6091] = 5979,
  [6092] = 6048,
  [6093] = 6093,
  [6094] = 5995,
  [6095] = 5987,
  [6096] = 5982,
  [6097] = 5982,
  [6098] = 5987,
  [6099] = 5988,
  [6100] = 6100,
  [6101] = 5987,
  [6102] = 5982,
  [6103] = 5980,
  [6104] = 5987,
  [6105] = 5987,
  [6106] = 5982,
  [6107] = 5979,
  [6108] = 5987,
  [6109] = 5987,
  [6110] = 5979,
  [6111] = 5987,
  [6112] = 5987,
  [6113] = 5978,
  [6114] = 5987,
  [6115] = 5987,
  [6116] = 5987,
  [6117] = 5987,
  [6118] = 2997,
  [6119] = 6119,
  [6120] = 6120,
  [6121] = 6121,
  [6122] = 6122,
  [6123] = 6123,
  [6124] = 6124,
  [6125] = 6125,
  [6126] = 6126,
  [6127] = 6126,
  [6128] = 6128,
  [6129] = 6129,
  [6130] = 6126,
  [6131] = 6131,
  [6132] = 6126,
  [6133] = 6133,
  [6134] = 6126,
  [6135] = 6135,
  [6136] = 6126,
  [6137] = 6137,
  [6138] = 6126,
  [6139] = 6139,
  [6140] = 6126,
  [6141] = 6126,
  [6142] = 6142,
  [6143] = 6126,
  [6144] = 6144,
  [6145] = 6126,
  [6146] = 6126,
  [6147] = 6126,
  [6148] = 6126,
  [6149] = 6149,
  [6150] = 6150,
  [6151] = 6126,
  [6152] = 6126,
  [6153] = 6126,
  [6154] = 6154,
  [6155] = 6149,
  [6156] = 6156,
  [6157] = 6157,
  [6158] = 6158,
  [6159] = 6126,
  [6160] = 6126,
  [6161] = 6161,
  [6162] = 6162,
  [6163] = 6163,
  [6164] = 6164,
  [6165] = 6165,
  [6166] = 6166,
  [6167] = 6167,
  [6168] = 6168,
  [6169] = 6169,
  [6170] = 6170,
  [6171] = 6171,
  [6172] = 6172,
  [6173] = 6173,
  [6174] = 6126,
  [6175] = 6175,
  [6176] = 6176,
  [6177] = 6177,
  [6178] = 6126,
  [6179] = 6179,
  [6180] = 6180,
  [6181] = 6181,
  [6182] = 6182,
  [6183] = 6126,
  [6184] = 6184,
  [6185] = 6185,
  [6186] = 6186,
  [6187] = 6187,
  [6188] = 6188,
  [6189] = 6189,
  [6190] = 6190,
  [6191] = 6191,
  [6192] = 6192,
  [6193] = 6193,
  [6194] = 6194,
  [6195] = 6195,
  [6196] = 6196,
  [6197] = 6197,
  [6198] = 6198,
  [6199] = 6199,
  [6200] = 6199,
  [6201] = 6199,
  [6202] = 6199,
  [6203] = 6199,
  [6204] = 6199,
  [6205] = 6199,
  [6206] = 6199,
  [6207] = 6199,
  [6208] = 6199,
  [6209] = 6199,
  [6210] = 6199,
  [6211] = 6199,
  [6212] = 6199,
  [6213] = 6199,
  [6214] = 6199,
  [6215] = 6199,
  [6216] = 6199,
  [6217] = 6199,
  [6218] = 6199,
  [6219] = 6199,
  [6220] = 6199,
  [6221] = 6199,
  [6222] = 6199,
  [6223] = 6199,
  [6224] = 6199,
  [6225] = 6199,
  [6226] = 6199,
  [6227] = 6199,
  [6228] = 6199,
  [6229] = 6199,
  [6230] = 6199,
  [6231] = 6199,
  [6232] = 6199,
  [6233] = 6199,
  [6234] = 6199,
  [6235] = 6199,
  [6236] = 6199,
  [6237] = 6199,
  [6238] = 6199,
  [6239] = 6239,
  [6240] = 6240,
  [6241] = 6241,
  [6242] = 6239,
  [6243] = 6239,
  [6244] = 6240,
  [6245] = 6239,
  [6246] = 6239,
  [6247] = 6239,
  [6248] = 6240,
  [6249] = 6240,
  [6250] = 6239,
  [6251] = 6240,
  [6252] = 6241,
  [6253] = 6239,
  [6254] = 6239,
  [6255] = 6241,
  [6256] = 6241,
  [6257] = 6240,
  [6258] = 6239,
  [6259] = 6241,
  [6260] = 6241,
  [6261] = 6240,
  [6262] = 6239,
  [6263] = 6241,
  [6264] = 6239,
  [6265] = 6239,
  [6266] = 6239,
  [6267] = 6240,
  [6268] = 6239,
  [6269] = 6239,
  [6270] = 6241,
  [6271] = 6241,
  [6272] = 6240,
  [6273] = 6241,
  [6274] = 6240,
  [6275] = 6241,
  [6276] = 6241,
  [6277] = 6241,
  [6278] = 6239,
  [6279] = 6240,
  [6280] = 6240,
  [6281] = 6240,
  [6282] = 6239,
  [6283] = 6241,
  [6284] = 6240,
  [6285] = 6241,
  [6286] = 6240,
  [6287] = 6240,
  [6288] = 6241,
  [6289] = 6239,
  [6290] = 6241,
  [6291] = 6239,
  [6292] = 6239,
  [6293] = 6239,
  [6294] = 6240,
  [6295] = 6241,
  [6296] = 6241,
  [6297] = 6240,
  [6298] = 6241,
  [6299] = 6240,
  [6300] = 6241,
  [6301] = 6240,
  [6302] = 6240,
  [6303] = 6240,
  [6304] = 6241,
  [6305] = 6305,
  [6306] = 6306,
  [6307] = 6307,
  [6308] = 6308,
  [6309] = 2382,
  [6310] = 6310,
  [6311] = 6311,
  [6312] = 6312,
  [6313] = 6313,
  [6314] = 6314,
  [6315] = 6315,
  [6316] = 6316,
  [6317] = 6317,
  [6318] = 6318,
  [6319] = 6319,
  [6320] = 6320,
  [6321] = 6321,
  [6322] = 6322,
  [6323] = 6323,
  [6324] = 6324,
  [6325] = 2193,
  [6326] = 6326,
  [6327] = 6327,
  [6328] = 6328,
  [6329] = 6329,
  [6330] = 6330,
  [6331] = 6331,
  [6332] = 6332,
  [6333] = 2194,
  [6334] = 6334,
  [6335] = 6335,
  [6336] = 2450,
  [6337] = 6337,
  [6338] = 6338,
  [6339] = 6339,
  [6340] = 2382,
  [6341] = 6341,
  [6342] = 2193,
  [6343] = 6343,
  [6344] = 6344,
  [6345] = 6345,
  [6346] = 6346,
  [6347] = 6347,
  [6348] = 6348,
  [6349] = 6349,
  [6350] = 6350,
  [6351] = 6351,
  [6352] = 6352,
  [6353] = 6353,
  [6354] = 6354,
  [6355] = 6355,
  [6356] = 6356,
  [6357] = 6357,
  [6358] = 6358,
  [6359] = 6359,
  [6360] = 6360,
  [6361] = 6361,
  [6362] = 6353,
  [6363] = 6353,
  [6364] = 6359,
  [6365] = 6365,
  [6366] = 6359,
  [6367] = 6367,
  [6368] = 6368,
  [6369] = 6369,
  [6370] = 6370,
  [6371] = 6371,
  [6372] = 6372,
  [6373] = 6373,
  [6374] = 6359,
  [6375] = 6353,
  [6376] = 6376,
  [6377] = 6377,
  [6378] = 6378,
  [6379] = 6379,
  [6380] = 6380,
  [6381] = 6381,
  [6382] = 6382,
  [6383] = 6383,
  [6384] = 6384,
  [6385] = 6385,
  [6386] = 6386,
  [6387] = 6387,
  [6388] = 6388,
  [6389] = 2448,
  [6390] = 6390,
  [6391] = 6391,
  [6392] = 6392,
  [6393] = 6393,
  [6394] = 6394,
  [6395] = 6395,
  [6396] = 6396,
  [6397] = 6397,
  [6398] = 6398,
  [6399] = 6399,
  [6400] = 6400,
  [6401] = 6401,
  [6402] = 6402,
  [6403] = 6403,
  [6404] = 6404,
  [6405] = 6405,
  [6406] = 6406,
  [6407] = 6405,
  [6408] = 6408,
  [6409] = 6408,
  [6410] = 1932,
  [6411] = 6401,
  [6412] = 6398,
  [6413] = 6413,
  [6414] = 6414,
  [6415] = 6345,
  [6416] = 6403,
  [6417] = 6408,
  [6418] = 6401,
  [6419] = 6398,
  [6420] = 6420,
  [6421] = 6403,
  [6422] = 6398,
  [6423] = 6405,
  [6424] = 6424,
  [6425] = 6403,
  [6426] = 6426,
  [6427] = 6427,
  [6428] = 6428,
  [6429] = 6401,
  [6430] = 6430,
  [6431] = 6401,
  [6432] = 6405,
  [6433] = 6408,
  [6434] = 6434,
  [6435] = 6408,
  [6436] = 6405,
  [6437] = 6437,
  [6438] = 1928,
  [6439] = 6439,
  [6440] = 6393,
  [6441] = 6441,
  [6442] = 6442,
  [6443] = 6443,
  [6444] = 6444,
  [6445] = 6439,
  [6446] = 6446,
  [6447] = 6447,
  [6448] = 6448,
  [6449] = 6449,
  [6450] = 6450,
  [6451] = 6451,
  [6452] = 6452,
  [6453] = 6453,
  [6454] = 6454,
  [6455] = 6455,
  [6456] = 6456,
  [6457] = 6457,
  [6458] = 6458,
  [6459] = 6459,
  [6460] = 6460,
  [6461] = 6450,
  [6462] = 6462,
  [6463] = 6463,
  [6464] = 6441,
  [6465] = 6458,
  [6466] = 6450,
  [6467] = 6467,
  [6468] = 6468,
  [6469] = 6469,
  [6470] = 6470,
  [6471] = 6471,
  [6472] = 6472,
  [6473] = 6441,
  [6474] = 6443,
  [6475] = 6441,
  [6476] = 6443,
  [6477] = 6477,
  [6478] = 6439,
  [6479] = 6479,
  [6480] = 6443,
  [6481] = 6481,
  [6482] = 6441,
  [6483] = 2182,
  [6484] = 6484,
  [6485] = 6485,
  [6486] = 6486,
  [6487] = 6487,
  [6488] = 6488,
  [6489] = 6462,
  [6490] = 6490,
  [6491] = 6462,
  [6492] = 6467,
  [6493] = 6493,
  [6494] = 6458,
  [6495] = 6450,
  [6496] = 6441,
  [6497] = 6458,
  [6498] = 6450,
  [6499] = 6443,
  [6500] = 6439,
  [6501] = 6501,
  [6502] = 5782,
  [6503] = 6467,
  [6504] = 6504,
  [6505] = 2450,
  [6506] = 6506,
  [6507] = 6462,
  [6508] = 6462,
  [6509] = 6509,
  [6510] = 6510,
  [6511] = 6511,
  [6512] = 6512,
  [6513] = 6513,
  [6514] = 6458,
  [6515] = 6515,
  [6516] = 6516,
  [6517] = 6462,
  [6518] = 6518,
  [6519] = 2183,
  [6520] = 1934,
  [6521] = 6345,
  [6522] = 6439,
  [6523] = 6523,
  [6524] = 6524,
  [6525] = 6525,
  [6526] = 6526,
  [6527] = 6527,
  [6528] = 6528,
  [6529] = 6529,
  [6530] = 6530,
  [6531] = 6531,
  [6532] = 6532,
  [6533] = 6533,
  [6534] = 6534,
  [6535] = 6535,
  [6536] = 6536,
  [6537] = 6537,
  [6538] = 6530,
  [6539] = 6539,
  [6540] = 6540,
  [6541] = 6541,
  [6542] = 6542,
  [6543] = 6543,
  [6544] = 6528,
  [6545] = 6545,
  [6546] = 6546,
  [6547] = 6547,
  [6548] = 6548,
  [6549] = 6549,
  [6550] = 6550,
  [6551] = 6551,
  [6552] = 6552,
  [6553] = 6530,
  [6554] = 6531,
  [6555] = 6539,
  [6556] = 6556,
  [6557] = 6557,
  [6558] = 6558,
  [6559] = 6559,
  [6560] = 3863,
  [6561] = 6561,
  [6562] = 6562,
  [6563] = 6563,
  [6564] = 6564,
  [6565] = 6565,
  [6566] = 6531,
  [6567] = 6567,
  [6568] = 6568,
  [6569] = 6569,
  [6570] = 6570,
  [6571] = 6571,
  [6572] = 6549,
  [6573] = 6573,
  [6574] = 6549,
  [6575] = 6575,
  [6576] = 6576,
  [6577] = 6577,
  [6578] = 6578,
  [6579] = 6579,
  [6580] = 6528,
  [6581] = 6565,
  [6582] = 6582,
  [6583] = 6583,
  [6584] = 6583,
  [6585] = 6565,
  [6586] = 6583,
  [6587] = 6587,
  [6588] = 6588,
  [6589] = 6589,
  [6590] = 6590,
  [6591] = 3061,
  [6592] = 6592,
  [6593] = 6593,
  [6594] = 6594,
  [6595] = 6583,
  [6596] = 6596,
  [6597] = 6527,
  [6598] = 6527,
  [6599] = 6575,
  [6600] = 6530,
  [6601] = 6596,
  [6602] = 6602,
  [6603] = 6603,
  [6604] = 6530,
  [6605] = 3006,
  [6606] = 6606,
  [6607] = 6607,
  [6608] = 6608,
  [6609] = 6609,
  [6610] = 6610,
  [6611] = 6611,
  [6612] = 6531,
  [6613] = 6541,
  [6614] = 6527,
  [6615] = 6531,
  [6616] = 6616,
  [6617] = 6617,
  [6618] = 6602,
  [6619] = 6619,
  [6620] = 6527,
  [6621] = 6539,
  [6622] = 6622,
  [6623] = 6623,
  [6624] = 6624,
  [6625] = 6625,
  [6626] = 6565,
  [6627] = 6539,
  [6628] = 6577,
  [6629] = 6629,
  [6630] = 6630,
  [6631] = 6631,
  [6632] = 2413,
  [6633] = 6633,
  [6634] = 6603,
  [6635] = 6531,
  [6636] = 6636,
  [6637] = 6539,
  [6638] = 6565,
  [6639] = 6531,
  [6640] = 6640,
  [6641] = 6528,
  [6642] = 6583,
  [6643] = 6643,
  [6644] = 6549,
  [6645] = 6583,
  [6646] = 6565,
  [6647] = 6565,
  [6648] = 6548,
  [6649] = 3779,
  [6650] = 6650,
  [6651] = 6651,
  [6652] = 6652,
  [6653] = 6396,
  [6654] = 6397,
  [6655] = 6655,
  [6656] = 6577,
  [6657] = 6531,
  [6658] = 6658,
  [6659] = 6394,
  [6660] = 6395,
  [6661] = 6531,
  [6662] = 6662,
  [6663] = 6533,
  [6664] = 6664,
  [6665] = 6531,
  [6666] = 6666,
  [6667] = 6667,
  [6668] = 6668,
  [6669] = 6577,
  [6670] = 6670,
  [6671] = 6528,
  [6672] = 6672,
  [6673] = 6673,
  [6674] = 6674,
  [6675] = 6675,
  [6676] = 6676,
  [6677] = 6587,
  [6678] = 6678,
  [6679] = 6583,
  [6680] = 6565,
  [6681] = 6681,
  [6682] = 6682,
  [6683] = 6683,
  [6684] = 6684,
  [6685] = 6536,
  [6686] = 6686,
  [6687] = 6530,
  [6688] = 6688,
  [6689] = 6689,
  [6690] = 6527,
  [6691] = 3779,
  [6692] = 6692,
  [6693] = 6693,
  [6694] = 6694,
  [6695] = 6695,
  [6696] = 2344,
  [6697] = 6697,
  [6698] = 2398,
  [6699] = 6699,
  [6700] = 6700,
  [6701] = 6701,
  [6702] = 6702,
  [6703] = 6703,
  [6704] = 6704,
  [6705] = 6693,
  [6706] = 6706,
  [6707] = 6707,
  [6708] = 3779,
  [6709] = 6709,
  [6710] = 6710,
  [6711] = 6699,
  [6712] = 6712,
  [6713] = 6713,
  [6714] = 6714,
  [6715] = 6715,
  [6716] = 1938,
  [6717] = 6717,
  [6718] = 6718,
  [6719] = 6719,
  [6720] = 6720,
  [6721] = 6699,
  [6722] = 2358,
  [6723] = 3779,
  [6724] = 6699,
  [6725] = 6394,
  [6726] = 6726,
  [6727] = 6699,
  [6728] = 6395,
  [6729] = 6729,
  [6730] = 6700,
  [6731] = 6717,
  [6732] = 6729,
  [6733] = 6733,
  [6734] = 3863,
  [6735] = 6707,
  [6736] = 6736,
  [6737] = 6737,
  [6738] = 6738,
  [6739] = 6729,
  [6740] = 6692,
  [6741] = 6693,
  [6742] = 6742,
  [6743] = 2359,
  [6744] = 3863,
  [6745] = 6736,
  [6746] = 6707,
  [6747] = 6736,
  [6748] = 6729,
  [6749] = 6729,
  [6750] = 6750,
  [6751] = 6751,
  [6752] = 6752,
  [6753] = 6753,
  [6754] = 6754,
  [6755] = 6729,
  [6756] = 2341,
  [6757] = 6692,
  [6758] = 6758,
  [6759] = 6729,
  [6760] = 6760,
  [6761] = 6761,
  [6762] = 6729,
  [6763] = 6763,
  [6764] = 6764,
  [6765] = 6765,
  [6766] = 6697,
  [6767] = 6767,
  [6768] = 6768,
  [6769] = 6769,
  [6770] = 6770,
  [6771] = 6720,
  [6772] = 6772,
  [6773] = 6773,
  [6774] = 6774,
  [6775] = 6775,
  [6776] = 6776,
  [6777] = 6777,
  [6778] = 6778,
  [6779] = 6720,
  [6780] = 6396,
  [6781] = 2334,
  [6782] = 6782,
  [6783] = 6783,
  [6784] = 6784,
  [6785] = 6785,
  [6786] = 1940,
  [6787] = 6787,
  [6788] = 3863,
  [6789] = 6774,
  [6790] = 6790,
  [6791] = 1941,
  [6792] = 6792,
  [6793] = 6397,
  [6794] = 6700,
  [6795] = 6795,
  [6796] = 6796,
  [6797] = 6797,
  [6798] = 6798,
  [6799] = 6799,
  [6800] = 6800,
  [6801] = 6801,
  [6802] = 6802,
  [6803] = 6799,
  [6804] = 6804,
  [6805] = 6805,
  [6806] = 6806,
  [6807] = 6776,
  [6808] = 6808,
  [6809] = 6809,
  [6810] = 6810,
  [6811] = 6811,
  [6812] = 6812,
  [6813] = 6813,
  [6814] = 6814,
  [6815] = 6815,
  [6816] = 6816,
  [6817] = 6817,
  [6818] = 6818,
  [6819] = 6819,
  [6820] = 6820,
  [6821] = 6821,
  [6822] = 6822,
  [6823] = 6823,
  [6824] = 6799,
  [6825] = 6825,
  [6826] = 6826,
  [6827] = 6827,
  [6828] = 6800,
  [6829] = 6801,
  [6830] = 6822,
  [6831] = 6831,
  [6832] = 6832,
  [6833] = 6833,
  [6834] = 6834,
  [6835] = 6800,
  [6836] = 6836,
  [6837] = 6801,
  [6838] = 6838,
  [6839] = 6839,
  [6840] = 6839,
  [6841] = 6822,
  [6842] = 6842,
  [6843] = 6843,
  [6844] = 6844,
  [6845] = 6836,
  [6846] = 6846,
  [6847] = 6847,
  [6848] = 6848,
  [6849] = 6836,
  [6850] = 6850,
  [6851] = 6851,
  [6852] = 6852,
  [6853] = 6853,
  [6854] = 6839,
  [6855] = 6855,
  [6856] = 6856,
  [6857] = 6857,
  [6858] = 6858,
  [6859] = 6859,
  [6860] = 6860,
  [6861] = 6861,
  [6862] = 6813,
  [6863] = 6844,
  [6864] = 6864,
  [6865] = 6800,
  [6866] = 6866,
  [6867] = 6801,
  [6868] = 6868,
  [6869] = 6869,
  [6870] = 6825,
  [6871] = 6805,
  [6872] = 6872,
  [6873] = 6873,
  [6874] = 6800,
  [6875] = 6875,
  [6876] = 6853,
  [6877] = 6801,
  [6878] = 6878,
  [6879] = 6879,
  [6880] = 6802,
  [6881] = 6881,
  [6882] = 6813,
  [6883] = 6805,
  [6884] = 6808,
  [6885] = 6810,
  [6886] = 6808,
  [6887] = 6827,
  [6888] = 6810,
  [6889] = 6860,
  [6890] = 6890,
  [6891] = 6813,
  [6892] = 6892,
  [6893] = 6893,
  [6894] = 6802,
  [6895] = 6825,
  [6896] = 6839,
  [6897] = 6846,
  [6898] = 6822,
  [6899] = 6800,
  [6900] = 6801,
  [6901] = 6836,
  [6902] = 6808,
  [6903] = 6903,
  [6904] = 6827,
  [6905] = 6822,
  [6906] = 6818,
  [6907] = 6827,
  [6908] = 6813,
  [6909] = 6858,
  [6910] = 6847,
  [6911] = 6911,
  [6912] = 6825,
  [6913] = 6810,
  [6914] = 2448,
  [6915] = 6915,
  [6916] = 6844,
  [6917] = 6836,
  [6918] = 6918,
  [6919] = 6844,
  [6920] = 6920,
  [6921] = 6921,
  [6922] = 6922,
  [6923] = 6812,
  [6924] = 6836,
  [6925] = 6925,
  [6926] = 6926,
  [6927] = 6927,
  [6928] = 6875,
  [6929] = 6929,
  [6930] = 6911,
  [6931] = 6879,
  [6932] = 6860,
  [6933] = 6933,
  [6934] = 6934,
  [6935] = 6813,
  [6936] = 6936,
  [6937] = 6853,
  [6938] = 6825,
  [6939] = 6839,
  [6940] = 6855,
  [6941] = 6856,
  [6942] = 6942,
  [6943] = 6943,
  [6944] = 6836,
  [6945] = 6868,
  [6946] = 6853,
  [6947] = 6796,
  [6948] = 6800,
  [6949] = 6801,
  [6950] = 6800,
  [6951] = 6836,
  [6952] = 6839,
  [6953] = 6918,
  [6954] = 6954,
  [6955] = 6855,
  [6956] = 6801,
  [6957] = 6817,
  [6958] = 6802,
  [6959] = 6959,
  [6960] = 6856,
  [6961] = 6815,
  [6962] = 6817,
  [6963] = 6963,
  [6964] = 6868,
  [6965] = 6965,
  [6966] = 6966,
  [6967] = 6846,
  [6968] = 6868,
  [6969] = 6847,
  [6970] = 6911,
  [6971] = 6934,
  [6972] = 6972,
  [6973] = 6875,
  [6974] = 6966,
  [6975] = 6975,
  [6976] = 6860,
  [6977] = 6802,
  [6978] = 6805,
  [6979] = 6800,
  [6980] = 6801,
  [6981] = 6911,
  [6982] = 6812,
  [6983] = 6954,
  [6984] = 6836,
  [6985] = 6934,
  [6986] = 6855,
  [6987] = 6942,
  [6988] = 6934,
  [6989] = 6942,
  [6990] = 6990,
  [6991] = 6875,
  [6992] = 6802,
  [6993] = 6846,
  [6994] = 6847,
  [6995] = 6911,
  [6996] = 6875,
  [6997] = 6860,
  [6998] = 6802,
  [6999] = 6911,
  [7000] = 6934,
  [7001] = 6942,
  [7002] = 6942,
  [7003] = 6815,
  [7004] = 6800,
  [7005] = 6801,
  [7006] = 6799,
  [7007] = 6836,
  [7008] = 7008,
  [7009] = 6817,
  [7010] = 6879,
  [7011] = 6942,
  [7012] = 7012,
  [7013] = 6799,
  [7014] = 6800,
  [7015] = 6801,
  [7016] = 7016,
  [7017] = 6836,
  [7018] = 6800,
  [7019] = 6801,
  [7020] = 7020,
  [7021] = 6856,
  [7022] = 6800,
  [7023] = 6801,
  [7024] = 6799,
  [7025] = 6810,
  [7026] = 6800,
  [7027] = 6801,
  [7028] = 6836,
  [7029] = 6822,
  [7030] = 6805,
  [7031] = 6808,
  [7032] = 6810,
  [7033] = 6822,
  [7034] = 7034,
  [7035] = 6827,
  [7036] = 6827,
  [7037] = 6846,
  [7038] = 7038,
  [7039] = 6825,
  [7040] = 7040,
  [7041] = 6815,
  [7042] = 6844,
  [7043] = 6847,
  [7044] = 6817,
  [7045] = 6836,
  [7046] = 6844,
  [7047] = 7047,
  [7048] = 6853,
  [7049] = 6836,
  [7050] = 6873,
  [7051] = 6839,
  [7052] = 6856,
  [7053] = 7053,
  [7054] = 7054,
  [7055] = 7055,
  [7056] = 7056,
  [7057] = 6853,
  [7058] = 6839,
  [7059] = 6855,
  [7060] = 7060,
  [7061] = 6856,
  [7062] = 7062,
  [7063] = 7063,
  [7064] = 7064,
  [7065] = 7065,
  [7066] = 6773,
  [7067] = 6868,
  [7068] = 7068,
  [7069] = 7069,
  [7070] = 7070,
  [7071] = 7071,
  [7072] = 7072,
  [7073] = 7073,
  [7074] = 7074,
  [7075] = 6761,
  [7076] = 6869,
  [7077] = 7077,
  [7078] = 6799,
  [7079] = 7079,
  [7080] = 6875,
  [7081] = 7081,
  [7082] = 7082,
  [7083] = 7083,
  [7084] = 7084,
  [7085] = 6812,
  [7086] = 7086,
  [7087] = 6929,
  [7088] = 7088,
  [7089] = 7089,
  [7090] = 6816,
  [7091] = 6802,
  [7092] = 6815,
  [7093] = 7093,
  [7094] = 7062,
  [7095] = 6817,
  [7096] = 6799,
  [7097] = 7097,
  [7098] = 7098,
  [7099] = 6822,
  [7100] = 7100,
  [7101] = 7101,
  [7102] = 7063,
  [7103] = 7103,
  [7104] = 7064,
  [7105] = 7105,
  [7106] = 7106,
  [7107] = 7107,
  [7108] = 1948,
  [7109] = 7109,
  [7110] = 1949,
  [7111] = 1959,
  [7112] = 7112,
  [7113] = 7113,
  [7114] = 7114,
  [7115] = 7115,
  [7116] = 7116,
  [7117] = 7117,
  [7118] = 7112,
  [7119] = 7119,
  [7120] = 7120,
  [7121] = 7121,
  [7122] = 7122,
  [7123] = 7123,
  [7124] = 7124,
  [7125] = 1950,
  [7126] = 7123,
  [7127] = 7127,
  [7128] = 7112,
  [7129] = 7129,
  [7130] = 1961,
  [7131] = 7131,
  [7132] = 7132,
  [7133] = 7133,
  [7134] = 7123,
  [7135] = 7135,
  [7136] = 7106,
  [7137] = 7137,
  [7138] = 1960,
  [7139] = 2993,
  [7140] = 1978,
  [7141] = 7141,
  [7142] = 7142,
  [7143] = 7135,
  [7144] = 7144,
  [7145] = 7106,
  [7146] = 7146,
  [7147] = 7147,
  [7148] = 1974,
  [7149] = 7149,
  [7150] = 7150,
  [7151] = 7151,
  [7152] = 7152,
  [7153] = 7144,
  [7154] = 7137,
  [7155] = 7155,
  [7156] = 7156,
  [7157] = 7157,
  [7158] = 7158,
  [7159] = 7159,
  [7160] = 7150,
  [7161] = 7129,
  [7162] = 7158,
  [7163] = 1986,
  [7164] = 7164,
  [7165] = 7165,
  [7166] = 7166,
  [7167] = 7137,
  [7168] = 7135,
  [7169] = 7106,
  [7170] = 7135,
  [7171] = 7171,
  [7172] = 7172,
  [7173] = 7173,
  [7174] = 7174,
  [7175] = 7150,
  [7176] = 7123,
  [7177] = 1989,
  [7178] = 7178,
  [7179] = 7179,
  [7180] = 7180,
  [7181] = 1992,
  [7182] = 7109,
  [7183] = 7183,
  [7184] = 7135,
  [7185] = 7150,
  [7186] = 1954,
  [7187] = 7187,
  [7188] = 7112,
  [7189] = 7189,
  [7190] = 7132,
  [7191] = 2340,
  [7192] = 7192,
  [7193] = 7193,
  [7194] = 1993,
  [7195] = 7132,
  [7196] = 7196,
  [7197] = 7197,
  [7198] = 7198,
  [7199] = 7149,
  [7200] = 1972,
  [7201] = 7172,
  [7202] = 7172,
  [7203] = 7150,
  [7204] = 1991,
  [7205] = 7144,
  [7206] = 7152,
  [7207] = 7207,
  [7208] = 7112,
  [7209] = 7209,
  [7210] = 7132,
  [7211] = 7137,
  [7212] = 7172,
  [7213] = 7173,
  [7214] = 7149,
  [7215] = 7129,
  [7216] = 7216,
  [7217] = 7217,
  [7218] = 7144,
  [7219] = 1955,
  [7220] = 7158,
  [7221] = 7209,
  [7222] = 1973,
  [7223] = 1990,
  [7224] = 7224,
  [7225] = 1985,
  [7226] = 7226,
  [7227] = 7135,
  [7228] = 7228,
  [7229] = 7229,
  [7230] = 7230,
  [7231] = 7231,
  [7232] = 7137,
  [7233] = 7197,
  [7234] = 7137,
  [7235] = 7235,
  [7236] = 7236,
  [7237] = 1951,
  [7238] = 1958,
  [7239] = 7137,
  [7240] = 7123,
  [7241] = 7172,
  [7242] = 1976,
  [7243] = 7132,
  [7244] = 7244,
  [7245] = 7132,
  [7246] = 7246,
  [7247] = 7247,
  [7248] = 7248,
  [7249] = 7249,
  [7250] = 7250,
  [7251] = 2984,
  [7252] = 7172,
  [7253] = 7178,
  [7254] = 7144,
  [7255] = 7109,
  [7256] = 7178,
  [7257] = 7257,
  [7258] = 1945,
  [7259] = 1946,
  [7260] = 1987,
  [7261] = 7261,
  [7262] = 7247,
  [7263] = 7132,
  [7264] = 1964,
  [7265] = 2349,
  [7266] = 7266,
  [7267] = 7267,
  [7268] = 7247,
  [7269] = 1947,
  [7270] = 1962,
  [7271] = 7271,
  [7272] = 7272,
  [7273] = 1977,
  [7274] = 7274,
  [7275] = 7275,
  [7276] = 7150,
  [7277] = 7109,
  [7278] = 7278,
  [7279] = 7197,
  [7280] = 7280,
  [7281] = 7281,
  [7282] = 7197,
  [7283] = 7283,
  [7284] = 7149,
  [7285] = 1952,
  [7286] = 7132,
  [7287] = 1963,
  [7288] = 1943,
  [7289] = 7137,
  [7290] = 7290,
  [7291] = 7123,
  [7292] = 1944,
  [7293] = 1965,
  [7294] = 7294,
  [7295] = 7295,
  [7296] = 7144,
  [7297] = 7178,
  [7298] = 1967,
  [7299] = 1988,
  [7300] = 7300,
  [7301] = 7152,
  [7302] = 7302,
  [7303] = 1969,
  [7304] = 7304,
  [7305] = 7129,
  [7306] = 7129,
  [7307] = 7247,
  [7308] = 7308,
  [7309] = 7309,
  [7310] = 7310,
  [7311] = 7209,
  [7312] = 7312,
  [7313] = 7129,
  [7314] = 7314,
  [7315] = 7315,
  [7316] = 7158,
  [7317] = 7317,
  [7318] = 1979,
  [7319] = 7319,
  [7320] = 7320,
  [7321] = 7321,
  [7322] = 1980,
  [7323] = 7209,
  [7324] = 7112,
  [7325] = 7173,
  [7326] = 7247,
  [7327] = 7327,
  [7328] = 7328,
  [7329] = 1981,
  [7330] = 1982,
  [7331] = 2337,
  [7332] = 1971,
  [7333] = 7333,
  [7334] = 7334,
  [7335] = 7335,
  [7336] = 7336,
  [7337] = 7106,
  [7338] = 1983,
  [7339] = 7339,
  [7340] = 7340,
  [7341] = 7247,
  [7342] = 7342,
  [7343] = 2342,
  [7344] = 7344,
  [7345] = 7345,
  [7346] = 7346,
  [7347] = 7347,
  [7348] = 7348,
  [7349] = 7349,
  [7350] = 7350,
  [7351] = 7351,
  [7352] = 7352,
  [7353] = 7353,
  [7354] = 7354,
  [7355] = 7355,
  [7356] = 7356,
  [7357] = 7357,
  [7358] = 7358,
  [7359] = 7359,
  [7360] = 7360,
  [7361] = 7352,
  [7362] = 7362,
  [7363] = 7363,
  [7364] = 3007,
  [7365] = 7365,
  [7366] = 7358,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7369,
  [7370] = 7370,
  [7371] = 7371,
  [7372] = 7372,
  [7373] = 7373,
  [7374] = 7356,
  [7375] = 7375,
  [7376] = 7376,
  [7377] = 7377,
  [7378] = 7378,
  [7379] = 7379,
  [7380] = 7380,
  [7381] = 7381,
  [7382] = 7373,
  [7383] = 7370,
  [7384] = 7384,
  [7385] = 7385,
  [7386] = 7356,
  [7387] = 7359,
  [7388] = 7388,
  [7389] = 7345,
  [7390] = 7390,
  [7391] = 7352,
  [7392] = 7392,
  [7393] = 7393,
  [7394] = 7380,
  [7395] = 7357,
  [7396] = 7396,
  [7397] = 7397,
  [7398] = 7357,
  [7399] = 7399,
  [7400] = 7400,
  [7401] = 7401,
  [7402] = 7402,
  [7403] = 7352,
  [7404] = 7404,
  [7405] = 7405,
  [7406] = 7406,
  [7407] = 7407,
  [7408] = 7408,
  [7409] = 7399,
  [7410] = 7352,
  [7411] = 7381,
  [7412] = 7352,
  [7413] = 7413,
  [7414] = 7414,
  [7415] = 7415,
  [7416] = 7401,
  [7417] = 7417,
  [7418] = 7418,
  [7419] = 7356,
  [7420] = 7420,
  [7421] = 7381,
  [7422] = 7352,
  [7423] = 7373,
  [7424] = 7424,
  [7425] = 7373,
  [7426] = 7426,
  [7427] = 7352,
  [7428] = 7420,
  [7429] = 7429,
  [7430] = 7352,
  [7431] = 7373,
  [7432] = 7388,
  [7433] = 7397,
  [7434] = 7434,
  [7435] = 7400,
  [7436] = 7380,
  [7437] = 7397,
  [7438] = 7438,
  [7439] = 7417,
  [7440] = 7345,
  [7441] = 7392,
  [7442] = 7359,
  [7443] = 7443,
  [7444] = 7444,
  [7445] = 7400,
  [7446] = 7417,
  [7447] = 7447,
  [7448] = 7359,
  [7449] = 7449,
  [7450] = 7408,
  [7451] = 7447,
  [7452] = 7452,
  [7453] = 7453,
  [7454] = 7454,
  [7455] = 7352,
  [7456] = 7408,
  [7457] = 7457,
  [7458] = 7426,
  [7459] = 7459,
  [7460] = 7460,
  [7461] = 7402,
  [7462] = 7462,
  [7463] = 7404,
  [7464] = 7464,
  [7465] = 7465,
  [7466] = 7466,
  [7467] = 7390,
  [7468] = 7402,
  [7469] = 7420,
  [7470] = 7352,
  [7471] = 7471,
  [7472] = 7472,
  [7473] = 7473,
  [7474] = 7474,
  [7475] = 7475,
  [7476] = 7476,
  [7477] = 7365,
  [7478] = 7478,
  [7479] = 7352,
  [7480] = 7370,
  [7481] = 7377,
  [7482] = 7400,
  [7483] = 7352,
  [7484] = 7417,
  [7485] = 7485,
  [7486] = 7486,
  [7487] = 7399,
  [7488] = 7488,
  [7489] = 7489,
  [7490] = 7490,
  [7491] = 7491,
  [7492] = 7492,
  [7493] = 7485,
  [7494] = 7359,
  [7495] = 7359,
  [7496] = 7471,
  [7497] = 7497,
  [7498] = 7491,
  [7499] = 7381,
  [7500] = 7500,
  [7501] = 7501,
  [7502] = 7408,
  [7503] = 7503,
  [7504] = 7352,
  [7505] = 7505,
  [7506] = 7370,
  [7507] = 7363,
  [7508] = 7475,
  [7509] = 7509,
  [7510] = 7510,
  [7511] = 7365,
  [7512] = 7390,
  [7513] = 7381,
  [7514] = 7514,
  [7515] = 7515,
  [7516] = 7354,
  [7517] = 7359,
  [7518] = 7381,
  [7519] = 7390,
  [7520] = 7520,
  [7521] = 7420,
  [7522] = 7404,
  [7523] = 7523,
  [7524] = 7471,
  [7525] = 7525,
  [7526] = 7380,
  [7527] = 7527,
  [7528] = 7370,
  [7529] = 7476,
  [7530] = 7365,
  [7531] = 7485,
  [7532] = 7532,
  [7533] = 7363,
  [7534] = 7534,
  [7535] = 7354,
  [7536] = 7373,
  [7537] = 7397,
  [7538] = 7538,
  [7539] = 7352,
  [7540] = 7352,
  [7541] = 7402,
  [7542] = 7542,
  [7543] = 7352,
  [7544] = 7544,
  [7545] = 7545,
  [7546] = 7352,
  [7547] = 7358,
  [7548] = 7490,
  [7549] = 7549,
  [7550] = 7399,
  [7551] = 7475,
  [7552] = 7426,
  [7553] = 7352,
  [7554] = 7352,
  [7555] = 7555,
  [7556] = 7352,
  [7557] = 7557,
  [7558] = 7381,
  [7559] = 7352,
  [7560] = 7392,
  [7561] = 7380,
  [7562] = 7402,
  [7563] = 7399,
  [7564] = 7525,
  [7565] = 7509,
  [7566] = 7345,
  [7567] = 7567,
  [7568] = 7344,
  [7569] = 7527,
  [7570] = 7352,
  [7571] = 7571,
  [7572] = 7472,
  [7573] = 7573,
  [7574] = 7574,
  [7575] = 7426,
  [7576] = 7404,
  [7577] = 7352,
  [7578] = 7359,
  [7579] = 7557,
  [7580] = 7401,
  [7581] = 7490,
  [7582] = 7381,
  [7583] = 7583,
  [7584] = 7380,
  [7585] = 7585,
  [7586] = 7573,
  [7587] = 7587,
  [7588] = 7588,
  [7589] = 7589,
  [7590] = 7549,
  [7591] = 7465,
  [7592] = 7592,
  [7593] = 7593,
  [7594] = 7426,
  [7595] = 7404,
  [7596] = 7397,
  [7597] = 7402,
  [7598] = 7475,
  [7599] = 7352,
  [7600] = 7352,
  [7601] = 7372,
  [7602] = 7602,
  [7603] = 7375,
  [7604] = 7604,
  [7605] = 7352,
  [7606] = 7384,
  [7607] = 7426,
  [7608] = 7608,
  [7609] = 7357,
  [7610] = 7363,
  [7611] = 7611,
  [7612] = 7612,
  [7613] = 7491,
  [7614] = 7377,
  [7615] = 7352,
  [7616] = 7525,
  [7617] = 7471,
  [7618] = 7618,
  [7619] = 7585,
  [7620] = 7573,
  [7621] = 7587,
  [7622] = 7588,
  [7623] = 7589,
  [7624] = 7549,
  [7625] = 7465,
  [7626] = 7388,
  [7627] = 7593,
  [7628] = 7628,
  [7629] = 7352,
  [7630] = 7352,
  [7631] = 7490,
  [7632] = 7426,
  [7633] = 7352,
  [7634] = 7527,
  [7635] = 7472,
  [7636] = 7375,
  [7637] = 7354,
  [7638] = 7557,
  [7639] = 7390,
  [7640] = 7399,
  [7641] = 7641,
  [7642] = 7476,
  [7643] = 7593,
  [7644] = 7644,
  [7645] = 7525,
  [7646] = 7646,
  [7647] = 7352,
  [7648] = 7588,
  [7649] = 7589,
  [7650] = 7549,
  [7651] = 7465,
  [7652] = 7491,
  [7653] = 7593,
  [7654] = 7654,
  [7655] = 7655,
  [7656] = 7365,
  [7657] = 7657,
  [7658] = 7459,
  [7659] = 7527,
  [7660] = 7660,
  [7661] = 7375,
  [7662] = 7404,
  [7663] = 7485,
  [7664] = 7459,
  [7665] = 7415,
  [7666] = 7476,
  [7667] = 7354,
  [7668] = 7352,
  [7669] = 7365,
  [7670] = 7549,
  [7671] = 7465,
  [7672] = 7593,
  [7673] = 7673,
  [7674] = 7400,
  [7675] = 7393,
  [7676] = 7588,
  [7677] = 7567,
  [7678] = 7375,
  [7679] = 7679,
  [7680] = 7404,
  [7681] = 7492,
  [7682] = 7352,
  [7683] = 7377,
  [7684] = 7684,
  [7685] = 7352,
  [7686] = 7358,
  [7687] = 7363,
  [7688] = 7417,
  [7689] = 7689,
  [7690] = 7420,
  [7691] = 7375,
  [7692] = 7692,
  [7693] = 7492,
  [7694] = 7375,
  [7695] = 7695,
  [7696] = 7696,
  [7697] = 7492,
  [7698] = 7618,
  [7699] = 7699,
  [7700] = 7352,
  [7701] = 7401,
  [7702] = 7352,
  [7703] = 7375,
  [7704] = 7464,
  [7705] = 7372,
  [7706] = 7352,
  [7707] = 7355,
  [7708] = 7349,
  [7709] = 7709,
  [7710] = 7710,
  [7711] = 7492,
  [7712] = 7345,
  [7713] = 7509,
  [7714] = 7714,
  [7715] = 7426,
  [7716] = 7377,
  [7717] = 7557,
  [7718] = 7352,
  [7719] = 7719,
  [7720] = 7363,
  [7721] = 7377,
  [7722] = 7722,
  [7723] = 7393,
  [7724] = 7354,
  [7725] = 7725,
  [7726] = 7352,
  [7727] = 7352,
  [7728] = 7344,
  [7729] = 3023,
  [7730] = 7730,
  [7731] = 7393,
  [7732] = 7589,
  [7733] = 7733,
  [7734] = 7734,
  [7735] = 7489,
  [7736] = 7459,
  [7737] = 7737,
  [7738] = 7738,
  [7739] = 7352,
  [7740] = 7740,
  [7741] = 7741,
  [7742] = 7742,
  [7743] = 7384,
  [7744] = 7490,
  [7745] = 7745,
  [7746] = 7392,
  [7747] = 7747,
  [7748] = 7352,
  [7749] = 7492,
  [7750] = 7585,
  [7751] = 7464,
  [7752] = 7404,
  [7753] = 7753,
  [7754] = 7355,
  [7755] = 7388,
  [7756] = 7587,
  [7757] = 7352,
  [7758] = 7485,
  [7759] = 7415,
  [7760] = 7393,
  [7761] = 7352,
  [7762] = 7762,
  [7763] = 7585,
  [7764] = 7573,
  [7765] = 7587,
  [7766] = 7766,
  [7767] = 7767,
  [7768] = 7344,
  [7769] = 7352,
  [7770] = 7770,
  [7771] = 7618,
  [7772] = 7489,
  [7773] = 7344,
  [7774] = 7588,
  [7775] = 7589,
  [7776] = 7489,
  [7777] = 7352,
  [7778] = 7549,
  [7779] = 7465,
  [7780] = 7344,
  [7781] = 7352,
  [7782] = 7344,
  [7783] = 7344,
  [7784] = 7471,
  [7785] = 7738,
  [7786] = 7657,
  [7787] = 7352,
  [7788] = 7346,
  [7789] = 7789,
  [7790] = 7738,
  [7791] = 7657,
  [7792] = 7738,
  [7793] = 7657,
  [7794] = 7738,
  [7795] = 7738,
  [7796] = 7593,
  [7797] = 7797,
  [7798] = 7352,
  [7799] = 7799,
  [7800] = 7800,
  [7801] = 7801,
  [7802] = 7802,
  [7803] = 7803,
  [7804] = 7804,
  [7805] = 7805,
  [7806] = 7806,
  [7807] = 7807,
  [7808] = 7808,
  [7809] = 7809,
  [7810] = 7810,
  [7811] = 7811,
  [7812] = 7812,
  [7813] = 7813,
  [7814] = 7814,
  [7815] = 7815,
  [7816] = 7816,
};

static TSCharacterRange sym__identifier_token_character_set_2[] = {
  {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6},
  {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377},
  {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f},
  {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f},
  {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824},
  {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d},
  {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a},
  {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd},
  {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33},
  {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0},
  {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61},
  {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde},
  {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56},
  {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30},
  {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0},
  {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c},
  {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070},
  {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731},
  {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8},
  {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16},
  {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23},
  {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6},
  {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c},
  {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128},
  {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3},
  {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae},
  {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029},
  {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e},
  {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b},
  {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3},
  {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7},
  {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4},
  {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf},
  {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4},
  {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2},
  {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d},
  {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d},
  {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375},
  {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527},
  {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9},
  {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805},
  {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2},
  {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17},
  {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075},
  {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2},
  {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288},
  {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330},
  {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461},
  {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa},
  {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913},
  {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3},
  {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08},
  {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65},
  {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0},
  {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38},
  {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f},
  {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08},
  {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167},
  {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f},
  {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a},
  {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5},
  {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788},
  {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe},
  {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27},
  {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b},
  {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f},
  {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89},
  {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1},
  {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym__identifier_token_character_set_3[] = {
  {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7},
  {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee},
  {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3},
  {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa},
  {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963},
  {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc},
  {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36},
  {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48},
  {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9},
  {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3},
  {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f},
  {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca},
  {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049},
  {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715},
  {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd},
  {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe},
  {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152},
  {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d},
  {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22},
  {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47},
  {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b},
  {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c},
  {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
  {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(133);
      ADVANCE_MAP(
        '!', 158,
        '"', 275,
        '#', 9,
        '%', 173,
        '&', 181,
        '\'', 259,
        '(', 142,
        ')', 143,
        '*', 169,
        '+', 163,
        ',', 140,
        '-', 165,
        '.', 194,
        '/', 171,
        '0', 264,
        ':', 139,
        ';', 134,
        '<', 147,
        '=', 135,
        '>', 152,
        '?', 155,
        '@', 12,
        '[', 137,
        '\\', 30,
        ']', 141,
        '^', 175,
        '{', 144,
        '|', 177,
        '}', 145,
        '~', 159,
        'U', 333,
        'u', 333,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(130);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 336,
        '!', 25,
        '"', 275,
        '#', 49,
        '&', 19,
        ',', 140,
        '/', 20,
        '0', 268,
        '=', 26,
        '@', 35,
        '\\', 31,
        '|', 99,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(269);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(11);
      if (lookahead == '"') ADVANCE(275);
      if (lookahead == '#') ADVANCE(286);
      if (lookahead == '/') ADVANCE(278);
      if (lookahead == '\\') ADVANCE(32);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(277);
      if (lookahead != 0) ADVANCE(319);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '#') ADVANCE(355);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(343);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 158,
        '"', 275,
        '#', 47,
        '%', 173,
        '&', 181,
        '(', 142,
        ')', 143,
        '*', 169,
        '+', 163,
        ',', 140,
        '-', 165,
        '.', 193,
        '/', 171,
        '0', 268,
        ':', 139,
        ';', 134,
        '<', 147,
        '=', 135,
        '>', 152,
        '?', 155,
        '@', 35,
        '[', 137,
        '\\', 31,
        ']', 141,
        '^', 175,
        '{', 144,
        '|', 177,
        '}', 145,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(269);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 158,
        '#', 47,
        '%', 173,
        '&', 181,
        '(', 142,
        ')', 143,
        '*', 169,
        '+', 163,
        ',', 140,
        '-', 165,
        '.', 193,
        '/', 171,
        ':', 138,
        ';', 134,
        '<', 147,
        '=', 135,
        '>', 152,
        '?', 155,
        '@', 35,
        '[', 137,
        '\\', 31,
        ']', 141,
        '^', 175,
        '{', 144,
        '|', 177,
        '}', 145,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(5);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 158,
        '#', 47,
        '%', 172,
        '&', 180,
        '(', 142,
        ')', 143,
        '*', 168,
        '+', 162,
        ',', 140,
        '-', 166,
        '.', 193,
        '/', 170,
        ':', 139,
        ';', 134,
        '<', 148,
        '=', 27,
        '>', 153,
        '?', 156,
        '@', 35,
        '[', 137,
        '\\', 31,
        ']', 141,
        '^', 174,
        '{', 144,
        '|', 178,
        '}', 145,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(6);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 158,
        '#', 47,
        '%', 172,
        '&', 180,
        '(', 142,
        ')', 143,
        '*', 168,
        '+', 162,
        ',', 140,
        '-', 166,
        '.', 193,
        '/', 170,
        ':', 138,
        ';', 134,
        '<', 148,
        '=', 27,
        '>', 153,
        '?', 156,
        '@', 35,
        '[', 137,
        '\\', 31,
        ']', 141,
        '^', 174,
        '|', 178,
        '}', 145,
        'U', 333,
        'u', 333,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(7);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 158,
        '#', 49,
        '%', 172,
        '&', 179,
        '*', 168,
        '+', 162,
        '-', 164,
        '/', 170,
        '<', 148,
        '=', 26,
        '>', 153,
        '@', 35,
        '\\', 31,
        '^', 174,
        '|', 176,
        '~', 159,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(8);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 408,
        'd', 58,
        'e', 77,
        'i', 61,
        'l', 70,
        'n', 98,
        'p', 95,
        'r', 53,
        'u', 84,
        'w', 44,
        '\t', 46,
        ' ', 46,
      );
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 157,
        '#', 48,
        '\'', 259,
        '(', 142,
        ')', 143,
        '*', 168,
        ',', 140,
        '-', 167,
        '.', 192,
        '/', 20,
        '0', 268,
        ':', 139,
        ';', 134,
        '<', 146,
        '=', 136,
        '>', 150,
        '?', 154,
        '@', 35,
        '[', 137,
        '\\', 31,
        ']', 141,
        '{', 144,
        '}', 145,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(269);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(275);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '\\') ADVANCE(34);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(11);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(31);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(331);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '#') ADVANCE(355);
      if (lookahead == '/') ADVANCE(347);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(344);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(262);
      if (lookahead == '/') ADVANCE(261);
      if (lookahead == '\\') ADVANCE(34);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(260);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(260);
      END_STATE();
    case 16:
      if (lookahead == '#') ADVANCE(223);
      if (lookahead == '/') ADVANCE(215);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '#', 49,
        '(', 142,
        ')', 143,
        '*', 168,
        ',', 140,
        '-', 28,
        '.', 192,
        '/', 20,
        ':', 138,
        ';', 134,
        '<', 146,
        '=', 29,
        '>', 150,
        '?', 154,
        '@', 35,
        '[', 137,
        '\\', 31,
        ']', 141,
        '{', 144,
        '}', 145,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(17);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '\\') ADVANCE(34);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(18);
      END_STATE();
    case 19:
      if (lookahead == '&') ADVANCE(210);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(413);
      END_STATE();
    case 21:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(409);
      if (lookahead != 0) ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead != 0) ADVANCE(22);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead != 0) ADVANCE(342);
      END_STATE();
    case 24:
      if (lookahead == '8') ADVANCE(330);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(188);
      END_STATE();
    case 27:
      if (lookahead == '=') ADVANCE(188);
      if (lookahead == '>') ADVANCE(195);
      END_STATE();
    case 28:
      if (lookahead == '>') ADVANCE(258);
      END_STATE();
    case 29:
      if (lookahead == '>') ADVANCE(195);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        'U', 324,
        'u', 322,
        'x', 321,
        '"', 326,
        '\'', 326,
        '0', 326,
        '?', 326,
        '\\', 326,
        'a', 326,
        'b', 326,
        'e', 326,
        'f', 326,
        'n', 326,
        'r', 326,
        't', 326,
        'v', 326,
      );
      if (lookahead != 0) ADVANCE(320);
      END_STATE();
    case 31:
      if (lookahead == 'U') ADVANCE(127);
      if (lookahead == 'u') ADVANCE(115);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        'U', 325,
        'u', 323,
        'x', 321,
        '"', 326,
        '\'', 326,
        '0', 326,
        '?', 326,
        '\\', 326,
        'a', 326,
        'b', 326,
        'e', 326,
        'f', 326,
        'n', 326,
        'r', 326,
        't', 326,
        'v', 326,
      );
      if (lookahead != 0) ADVANCE(320);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        'U', 126,
        'u', 114,
        'x', 107,
        '"', 326,
        '\'', 326,
        '0', 326,
        '?', 326,
        '\\', 326,
        'a', 326,
        'b', 326,
        'e', 326,
        'f', 326,
        'n', 326,
        'r', 326,
        't', 326,
        'v', 326,
      );
      END_STATE();
    case 34:
      ADVANCE_MAP(
        'U', 128,
        'u', 116,
        'x', 107,
        '"', 326,
        '\'', 326,
        '0', 326,
        '?', 326,
        '\\', 326,
        'a', 326,
        'b', 326,
        'e', 326,
        'f', 326,
        'n', 326,
        'r', 326,
        't', 326,
        'v', 326,
      );
      END_STATE();
    case 35:
      if (lookahead == '\\') ADVANCE(31);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 36:
      if (lookahead == '_') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 37:
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(266);
      END_STATE();
    case 38:
      if (lookahead == '_') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(267);
      END_STATE();
    case 39:
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(269);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(402);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(96);
      END_STATE();
    case 45:
      if (lookahead == 'b') ADVANCE(80);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        'd', 58,
        'e', 77,
        'i', 61,
        'l', 70,
        'n', 98,
        'p', 95,
        'r', 53,
        'u', 84,
        'w', 44,
        '\t', 46,
        ' ', 46,
      );
      END_STATE();
    case 47:
      ADVANCE_MAP(
        'd', 58,
        'e', 77,
        'l', 70,
        'n', 98,
        'p', 95,
        'r', 53,
        'u', 84,
        'w', 44,
        '\t', 47,
        ' ', 47,
      );
      END_STATE();
    case 48:
      ADVANCE_MAP(
        'd', 58,
        'e', 85,
        'i', 61,
        'l', 70,
        'n', 98,
        'p', 95,
        'r', 53,
        'u', 84,
        'w', 44,
        '\t', 48,
        ' ', 48,
      );
      END_STATE();
    case 49:
      ADVANCE_MAP(
        'd', 58,
        'e', 85,
        'l', 70,
        'n', 98,
        'p', 95,
        'r', 53,
        'u', 84,
        'w', 44,
        '\t', 49,
        ' ', 49,
      );
      END_STATE();
    case 50:
      if (lookahead == 'd') ADVANCE(73);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(97);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(59);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(68);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(339);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(401);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(406);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(403);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 61:
      if (lookahead == 'f') ADVANCE(335);
      END_STATE();
    case 62:
      if (lookahead == 'f') ADVANCE(340);
      END_STATE();
    case 63:
      if (lookahead == 'f') ADVANCE(338);
      END_STATE();
    case 64:
      if (lookahead == 'f') ADVANCE(407);
      END_STATE();
    case 65:
      if (lookahead == 'f') ADVANCE(75);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(81);
      END_STATE();
    case 67:
      if (lookahead == 'g') ADVANCE(405);
      END_STATE();
    case 68:
      if (lookahead == 'g') ADVANCE(71);
      END_STATE();
    case 69:
      if (lookahead == 'g') ADVANCE(76);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(87);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(72);
      if (lookahead == 'n') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(57);
      END_STATE();
    case 81:
      if (lookahead == 'm') ADVANCE(42);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(399);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(400);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(67);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 88:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 89:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(94);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(90);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(404);
      END_STATE();
    case 95:
      if (lookahead == 'r') ADVANCE(43);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 98:
      if (lookahead == 'u') ADVANCE(78);
      END_STATE();
    case 99:
      if (lookahead == '|') ADVANCE(211);
      END_STATE();
    case 100:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(274);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(274);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(334);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 106:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 107:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(105);
      END_STATE();
    case 108:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(106);
      END_STATE();
    case 109:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(103);
      END_STATE();
    case 110:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 111:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 112:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(109);
      END_STATE();
    case 113:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(110);
      END_STATE();
    case 114:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(111);
      END_STATE();
    case 115:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(112);
      END_STATE();
    case 116:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(113);
      END_STATE();
    case 117:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(115);
      END_STATE();
    case 118:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(114);
      END_STATE();
    case 119:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(116);
      END_STATE();
    case 120:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 121:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(117);
      END_STATE();
    case 122:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      END_STATE();
    case 123:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 124:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 125:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(122);
      END_STATE();
    case 126:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 127:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(124);
      END_STATE();
    case 128:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(125);
      END_STATE();
    case 129:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(397);
      END_STATE();
    case 130:
      if (eof) ADVANCE(133);
      ADVANCE_MAP(
        '!', 158,
        '"', 275,
        '#', 9,
        '%', 173,
        '&', 181,
        '\'', 259,
        '(', 142,
        ')', 143,
        '*', 169,
        '+', 163,
        ',', 140,
        '-', 165,
        '.', 194,
        '/', 171,
        '0', 264,
        ':', 139,
        ';', 134,
        '<', 147,
        '=', 135,
        '>', 152,
        '?', 155,
        '@', 12,
        '[', 137,
        '\\', 33,
        ']', 141,
        '^', 175,
        '{', 144,
        '|', 177,
        '}', 145,
        '~', 159,
        'U', 333,
        'u', 333,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(130);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 131:
      if (eof) ADVANCE(133);
      ADVANCE_MAP(
        '!', 158,
        '"', 275,
        '#', 46,
        '%', 172,
        '&', 180,
        '\'', 259,
        '(', 142,
        ')', 143,
        '*', 168,
        '+', 162,
        ',', 140,
        '-', 166,
        '.', 194,
        '/', 170,
        '0', 264,
        ':', 138,
        ';', 134,
        '<', 148,
        '=', 27,
        '>', 153,
        '?', 156,
        '@', 12,
        '[', 137,
        '\\', 31,
        ']', 141,
        '^', 174,
        '{', 144,
        '|', 178,
        '}', 145,
        '~', 159,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(131);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 132:
      if (eof) ADVANCE(133);
      ADVANCE_MAP(
        '!', 157,
        '"', 275,
        '#', 9,
        '&', 179,
        '\'', 259,
        '(', 142,
        ')', 143,
        '*', 168,
        '+', 162,
        ',', 140,
        '-', 166,
        '.', 194,
        '/', 20,
        '0', 264,
        ':', 139,
        ';', 134,
        '<', 149,
        '=', 136,
        '>', 151,
        '?', 154,
        '@', 12,
        '[', 137,
        '\\', 31,
        ']', 141,
        '^', 174,
        '{', 144,
        '}', 145,
        '~', 159,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(132);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (set_contains(sym__identifier_token_character_set_2, 669, lookahead)) ADVANCE(334);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(188);
      if (lookahead == '>') ADVANCE(195);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(195);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(196);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(183);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(182);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(190);
      if (lookahead == '>') ADVANCE(184);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(190);
      if (lookahead == '>') ADVANCE(185);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(213);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(212);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(160);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(160);
      if (lookahead == '=') ADVANCE(198);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(161);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(161);
      if (lookahead == '=') ADVANCE(199);
      if (lookahead == '>') ADVANCE(258);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(161);
      if (lookahead == '>') ADVANCE(258);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(258);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(200);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(413);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(413);
      if (lookahead == '=') ADVANCE(201);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(202);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(204);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '|') ADVANCE(211);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(211);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(210);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(210);
      if (lookahead == '=') ADVANCE(203);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(206);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '>') ADVANCE(187);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(208);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(197);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '#') ADVANCE(223);
      if (lookahead == '/') ADVANCE(215);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead == '/') ADVANCE(257);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(22);
      if (lookahead != 0) ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(22);
      if (lookahead != 0) ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(233);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'b') ADVANCE(239);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      ADVANCE_MAP(
        'd', 227,
        'e', 243,
        'l', 235,
        'n', 255,
        'p', 253,
        'r', 228,
        'u', 244,
        'w', 221,
        '\t', 223,
        ' ', 223,
      );
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'd') ADVANCE(229);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(230);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'f') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'f') ADVANCE(235);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(236);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(246);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'm') ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(224);
      if (lookahead == 'r') ADVANCE(251);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(237);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'o') ADVANCE(242);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'o') ADVANCE(250);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(249);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(220);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(247);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'u') ADVANCE(238);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(257);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(413);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(257);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_character_literal_content);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_character_literal_content);
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(413);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_character_literal_content);
      ADVANCE_MAP(
        'd', 58,
        'e', 85,
        'l', 70,
        'n', 98,
        'p', 95,
        'r', 53,
        'u', 84,
        'w', 44,
        '\t', 49,
        ' ', 49,
      );
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '.', 101,
        '_', 36,
        'B', 37,
        'b', 37,
        'E', 100,
        'e', 100,
        'L', 271,
        'l', 271,
        'U', 270,
        'u', 270,
        'X', 38,
        'x', 38,
        'D', 272,
        'F', 272,
        'M', 272,
        'd', 272,
        'f', 272,
        'm', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '.', 101,
        '_', 36,
        'E', 100,
        'e', 100,
        'L', 271,
        'l', 271,
        'U', 270,
        'u', 270,
        'D', 272,
        'F', 272,
        'M', 272,
        'd', 272,
        'f', 272,
        'm', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(271);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(270);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(266);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(271);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(270);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '_', 40,
        'B', 37,
        'b', 37,
        'L', 271,
        'l', 271,
        'U', 270,
        'u', 270,
        'X', 38,
        'x', 38,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(269);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(271);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(270);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(269);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(263);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_real_literal);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_real_literal);
      ADVANCE_MAP(
        '_', 39,
        'E', 100,
        'e', 100,
        'D', 272,
        'F', 272,
        'M', 272,
        'd', 272,
        'f', 272,
        'm', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'M' ||
          lookahead == 'd' ||
          lookahead == 'f' ||
          lookahead == 'm') ADVANCE(272);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '\r') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(276);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '#') ADVANCE(286);
      if (lookahead == '/') ADVANCE(278);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(277);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(280);
      if (lookahead == '/') ADVANCE(276);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(279);
      if (lookahead == '/') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(279);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(285);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(296);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(317);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'b') ADVANCE(302);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      ADVANCE_MAP(
        'd', 290,
        'e', 306,
        'l', 298,
        'n', 318,
        'p', 316,
        'r', 291,
        'u', 307,
        'w', 284,
        '\t', 286,
        ' ', 286,
      );
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'd') ADVANCE(315);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'd') ADVANCE(292);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(294);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(297);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(293);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'f') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'f') ADVANCE(298);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(304);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(299);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(308);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(311);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(309);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(303);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'm') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(287);
      if (lookahead == 'r') ADVANCE(314);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(288);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(295);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(300);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'o') ADVANCE(305);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'o') ADVANCE(313);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(312);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(310);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'u') ADVANCE(301);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(319);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(105);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(111);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(113);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(125);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(31);
      if (set_contains(sym__identifier_token_character_set_3, 777, lookahead)) ADVANCE(334);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token1);
      if (lookahead == '\\') ADVANCE(31);
      if (set_contains(sym__identifier_token_character_set_3, 777, lookahead)) ADVANCE(334);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym__identifier_token);
      if (lookahead == '8') ADVANCE(332);
      if (lookahead == '\\') ADVANCE(31);
      if (set_contains(sym__identifier_token_character_set_3, 777, lookahead)) ADVANCE(334);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym__identifier_token);
      if (lookahead == '\\') ADVANCE(31);
      if (set_contains(sym__identifier_token_character_set_3, 777, lookahead)) ADVANCE(334);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (lookahead == '\n') ADVANCE(336);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(343);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_preproc_if_token3);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(22);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '/') ADVANCE(409);
      if (lookahead == '\\') ADVANCE(346);
      if (lookahead != 0) ADVANCE(342);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(22);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(346);
      if (lookahead != 0) ADVANCE(342);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '#') ADVANCE(355);
      if (lookahead == '/') ADVANCE(348);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(343);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(343);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(14);
      if (lookahead == '#') ADVANCE(355);
      if (lookahead == '/') ADVANCE(348);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(344);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(344);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(398);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(349);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(346);
      if (lookahead != 0) ADVANCE(342);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(342);
      if (lookahead == '/') ADVANCE(410);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(342);
      if (lookahead == '/') ADVANCE(412);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(346);
      if (lookahead != 0) ADVANCE(342);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'a') ADVANCE(402);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'a') ADVANCE(354);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'a') ADVANCE(368);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'a') ADVANCE(394);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'b') ADVANCE(378);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_preproc_arg);
      ADVANCE_MAP(
        '/', 129,
        '\\', 345,
        'd', 361,
        'e', 382,
        'l', 371,
        'n', 396,
        'p', 393,
        'r', 362,
        'u', 383,
        'w', 353,
        '\t', 355,
        ' ', 355,
      );
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'd') ADVANCE(395);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'd') ADVANCE(363);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(401);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(406);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(403);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(366);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(369);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(365);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'e') ADVANCE(370);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'f') ADVANCE(407);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'f') ADVANCE(374);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'g') ADVANCE(405);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'g') ADVANCE(379);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'g') ADVANCE(372);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'g') ADVANCE(375);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'i') ADVANCE(388);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'i') ADVANCE(385);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'i') ADVANCE(386);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'i') ADVANCE(390);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'l') ADVANCE(377);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'l') ADVANCE(351);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'l') ADVANCE(360);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'm') ADVANCE(350);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(399);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(400);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(356);
      if (lookahead == 'r') ADVANCE(392);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(357);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(358);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(359);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(373);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'o') ADVANCE(380);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'o') ADVANCE(391);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'o') ADVANCE(381);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'r') ADVANCE(404);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'r') ADVANCE(389);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'r') ADVANCE(352);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'r') ADVANCE(387);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'r') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == 'u') ADVANCE(376);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead != 0) ADVANCE(397);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_preproc_region_token1);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_preproc_endregion_token1);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_preproc_pragma_token1);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_preproc_nullable_token1);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_preproc_error_token1);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_preproc_warning_token1);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_preproc_define_token1);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_preproc_undef_token1);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_shebang_directive);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(408);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(413);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(411);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(410);
      if (lookahead == '\\') ADVANCE(411);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(411);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(412);
      if (lookahead == '\\') ADVANCE(411);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(411);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(413);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'C', 1,
        'F', 2,
        'S', 3,
        'T', 4,
        'U', 5,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'j', 16,
        'l', 17,
        'm', 18,
        'n', 19,
        'o', 20,
        'p', 21,
        'r', 22,
        's', 23,
        't', 24,
        'u', 25,
        'v', 26,
        'w', 27,
        'y', 28,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(29);
      END_STATE();
    case 1:
      if (lookahead == 'd') ADVANCE(30);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 3:
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == '8') ADVANCE(34);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(sym_discard);
      if (lookahead == '_') ADVANCE(35);
      END_STATE();
    case 7:
      if (lookahead == 'b') ADVANCE(36);
      if (lookahead == 'd') ADVANCE(37);
      if (lookahead == 'l') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      if (lookahead == 's') ADVANCE(40);
      if (lookahead == 'w') ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(44);
      if (lookahead == 'y') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'h') ADVANCE(47);
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'i') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(54);
      if (lookahead == 'q') ADVANCE(55);
      if (lookahead == 'v') ADVANCE(56);
      if (lookahead == 'x') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'i') ADVANCE(59);
      if (lookahead == 'l') ADVANCE(60);
      if (lookahead == 'o') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(63);
      if (lookahead == 'l') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 14:
      if (lookahead == 'i') ADVANCE(67);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(68);
      if (lookahead == 'm') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(70);
      if (lookahead == 's') ADVANCE(71);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(73);
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(78);
      if (lookahead == 'e') ADVANCE(79);
      if (lookahead == 'i') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 20:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == 'p') ADVANCE(85);
      if (lookahead == 'r') ADVANCE(86);
      if (lookahead == 'u') ADVANCE(87);
      if (lookahead == 'v') ADVANCE(88);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(89);
      if (lookahead == 'r') ADVANCE(90);
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 23:
      if (lookahead == 'b') ADVANCE(93);
      if (lookahead == 'c') ADVANCE(94);
      if (lookahead == 'e') ADVANCE(95);
      if (lookahead == 'h') ADVANCE(96);
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      if (lookahead == 'w') ADVANCE(99);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(100);
      if (lookahead == 'r') ADVANCE(101);
      if (lookahead == 'y') ADVANCE(102);
      END_STATE();
    case 25:
      if (lookahead == '8') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'n') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(107);
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'h') ADVANCE(111);
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 28:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'C', 1,
        'F', 2,
        'S', 3,
        'T', 4,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'j', 16,
        'l', 17,
        'm', 18,
        'n', 19,
        'o', 20,
        'p', 21,
        'r', 22,
        's', 23,
        't', 24,
        'u', 114,
        'v', 26,
        'w', 27,
        'y', 28,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(29);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(117);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_string_literal_encoding);
      END_STATE();
    case 35:
      if (lookahead == 'm') ADVANCE(119);
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 36:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 37:
      if (lookahead == 'd') ADVANCE(122);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(123);
      END_STATE();
    case 39:
      if (lookahead == 'd') ADVANCE(124);
      if (lookahead == 'n') ADVANCE(125);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'c') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 'y') ADVANCE(128);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(131);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_by);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(136);
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(140);
      if (lookahead == 'f') ADVANCE(141);
      if (lookahead == 'l') ADVANCE(142);
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 51:
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 57:
      if (lookahead == 'p') ADVANCE(151);
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 58:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(154);
      if (lookahead == 'l') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(156);
      if (lookahead == 'x') ADVANCE(157);
      END_STATE();
    case 60:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(160);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 67:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 69:
      if (lookahead == 'p') ADVANCE(166);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(171);
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(173);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(176);
      END_STATE();
    case 79:
      if (lookahead == 'w') ADVANCE(177);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(180);
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 83:
      if (lookahead == 'j') ADVANCE(182);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(188);
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 91:
      if (lookahead == 'b') ADVANCE(190);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(191);
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'f') ADVANCE(193);
      if (lookahead == 'm') ADVANCE(194);
      if (lookahead == 'q') ADVANCE(195);
      if (lookahead == 's') ADVANCE(196);
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 93:
      if (lookahead == 'y') ADVANCE(198);
      END_STATE();
    case 94:
      if (lookahead == 'o') ADVANCE(199);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(200);
      if (lookahead == 'l') ADVANCE(201);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 97:
      if (lookahead == 'z') ADVANCE(204);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(205);
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(208);
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(210);
      if (lookahead == 'y') ADVANCE(211);
      END_STATE();
    case 102:
      if (lookahead == 'p') ADVANCE(212);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(215);
      if (lookahead == 'm') ADVANCE(216);
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(218);
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 108:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 109:
      if (lookahead == 'i') ADVANCE(222);
      if (lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(225);
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'n') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 115:
      if (lookahead == 'c') ADVANCE(229);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(237);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 137:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(248);
      END_STATE();
    case 139:
      if (lookahead == 's') ADVANCE(249);
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(251);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 143:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 145:
      if (lookahead == 'b') ADVANCE(256);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 147:
      if (lookahead == 'b') ADVANCE(258);
      END_STATE();
    case 148:
      if (lookahead == 'm') ADVANCE(259);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 151:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 153:
      if (lookahead == 's') ADVANCE(264);
      END_STATE();
    case 154:
      if (lookahead == 'l') ADVANCE(265);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(267);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(270);
      END_STATE();
    case 160:
      if (lookahead == 'm') ADVANCE(271);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 162:
      if (lookahead == 'b') ADVANCE(272);
      END_STATE();
    case 163:
      if (lookahead == 'o') ADVANCE(273);
      END_STATE();
    case 164:
      if (lookahead == 'u') ADVANCE(274);
      END_STATE();
    case 165:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 166:
      if (lookahead == 'l') ADVANCE(276);
      END_STATE();
    case 167:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_predefined_type);
      if (lookahead == 'e') ADVANCE(278);
      if (lookahead == 'o') ADVANCE(279);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 171:
      if (lookahead == 'k') ADVANCE(281);
      END_STATE();
    case 172:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 173:
      if (lookahead == 'a') ADVANCE(282);
      END_STATE();
    case 174:
      if (lookahead == 'h') ADVANCE(283);
      END_STATE();
    case 175:
      if (lookahead == 'u') ADVANCE(284);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(287);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(288);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 186:
      if (lookahead == 'r') ADVANCE(292);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 't') ADVANCE(294);
      END_STATE();
    case 188:
      if (lookahead == 'v') ADVANCE(295);
      END_STATE();
    case 189:
      if (lookahead == 'p') ADVANCE(296);
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(298);
      END_STATE();
    case 191:
      if (lookahead == 'd') ADVANCE(299);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(300);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 194:
      if (lookahead == 'o') ADVANCE(301);
      END_STATE();
    case 195:
      if (lookahead == 'u') ADVANCE(302);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(303);
      END_STATE();
    case 197:
      if (lookahead == 'u') ADVANCE(304);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 199:
      if (lookahead == 'p') ADVANCE(306);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(309);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 205:
      if (lookahead == 'c') ADVANCE(311);
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(313);
      if (lookahead == 'u') ADVANCE(314);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(316);
      END_STATE();
    case 209:
      if (lookahead == 'o') ADVANCE(317);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 215:
      if (lookahead == 'h') ADVANCE(321);
      END_STATE();
    case 216:
      if (lookahead == 'a') ADVANCE(322);
      END_STATE();
    case 217:
      if (lookahead == 'a') ADVANCE(323);
      END_STATE();
    case 218:
      if (lookahead == 'o') ADVANCE(324);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 222:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 223:
      if (lookahead == 'a') ADVANCE(327);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(328);
      END_STATE();
    case 225:
      if (lookahead == 'n') ADVANCE(329);
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 226:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 227:
      if (lookahead == 'h') ADVANCE(332);
      END_STATE();
    case 228:
      if (lookahead == 'l') ADVANCE(333);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 231:
      if (lookahead == 'a') ADVANCE(336);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(337);
      END_STATE();
    case 233:
      if (lookahead == 'k') ADVANCE(338);
      END_STATE();
    case 234:
      if (lookahead == 'f') ADVANCE(339);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(340);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(341);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 238:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 239:
      if (lookahead == 'm') ADVANCE(344);
      END_STATE();
    case 240:
      if (lookahead == 'c') ADVANCE(345);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(346);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_base);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_predefined_type);
      END_STATE();
    case 244:
      if (lookahead == 'k') ADVANCE(347);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 246:
      if (lookahead == 'h') ADVANCE(348);
      END_STATE();
    case 247:
      if (lookahead == 'k') ADVANCE(349);
      END_STATE();
    case 248:
      if (lookahead == 's') ADVANCE(350);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(351);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 251:
      if (lookahead == 'm') ADVANCE(353);
      END_STATE();
    case 252:
      if (lookahead == 'u') ADVANCE(354);
      END_STATE();
    case 253:
      if (lookahead == 'g') ADVANCE(355);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 255:
      if (lookahead == 'b') ADVANCE(357);
      END_STATE();
    case 256:
      if (lookahead == 'l') ADVANCE(358);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 258:
      if (lookahead == 'l') ADVANCE(359);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 260:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 262:
      if (lookahead == 'i') ADVANCE(362);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(363);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 265:
      if (lookahead == 'd') ADVANCE(365);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_file);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(366);
      END_STATE();
    case 268:
      if (lookahead == 'd') ADVANCE(367);
      END_STATE();
    case 269:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(368);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 272:
      if (lookahead == 'a') ADVANCE(369);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 274:
      if (lookahead == 'p') ADVANCE(370);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 276:
      if (lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_init);
      END_STATE();
    case 278:
      if (lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_into);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_join);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 282:
      if (lookahead == 'g') ADVANCE(374);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(375);
      END_STATE();
    case 284:
      if (lookahead == 'l') ADVANCE(376);
      END_STATE();
    case 285:
      if (lookahead == 's') ADVANCE(377);
      END_STATE();
    case 286:
      if (lookahead == 'u') ADVANCE(378);
      END_STATE();
    case 287:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 289:
      if (lookahead == 'c') ADVANCE(379);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(380);
      END_STATE();
    case 291:
      if (lookahead == 'r') ADVANCE(381);
      END_STATE();
    case 292:
      if (lookahead == 'r') ADVANCE(382);
      END_STATE();
    case 293:
      if (lookahead == 'm') ADVANCE(383);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(384);
      END_STATE();
    case 295:
      if (lookahead == 'a') ADVANCE(385);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(387);
      END_STATE();
    case 298:
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 299:
      if (lookahead == 'o') ADVANCE(389);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 301:
      if (lookahead == 'v') ADVANCE(391);
      END_STATE();
    case 302:
      if (lookahead == 'i') ADVANCE(392);
      END_STATE();
    case 303:
      if (lookahead == 'o') ADVANCE(393);
      END_STATE();
    case 304:
      if (lookahead == 'r') ADVANCE(394);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 308:
      if (lookahead == 'c') ADVANCE(397);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 310:
      if (lookahead == 'o') ADVANCE(398);
      END_STATE();
    case 311:
      if (lookahead == 'k') ADVANCE(399);
      END_STATE();
    case 312:
      if (lookahead == 'i') ADVANCE(400);
      END_STATE();
    case 313:
      if (lookahead == 'n') ADVANCE(401);
      END_STATE();
    case 314:
      if (lookahead == 'c') ADVANCE(402);
      END_STATE();
    case 315:
      if (lookahead == 'c') ADVANCE(403);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 317:
      if (lookahead == 'w') ADVANCE(404);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(405);
      if (lookahead == 'v') ADVANCE(406);
      END_STATE();
    case 320:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 322:
      if (lookahead == 'n') ADVANCE(408);
      END_STATE();
    case 323:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 324:
      if (lookahead == 'r') ADVANCE(410);
      END_STATE();
    case 325:
      if (lookahead == 'g') ADVANCE(411);
      END_STATE();
    case 326:
      if (lookahead == 'u') ADVANCE(412);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(413);
      END_STATE();
    case 328:
      if (lookahead == 'i') ADVANCE(414);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(415);
      END_STATE();
    case 331:
      if (lookahead == 'e') ADVANCE(416);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 333:
      if (lookahead == 'd') ADVANCE(417);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_Cdecl);
      END_STATE();
    case 335:
      if (lookahead == 'a') ADVANCE(418);
      END_STATE();
    case 336:
      if (lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 337:
      if (lookahead == 'a') ADVANCE(420);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(422);
      if (lookahead == 'v') ADVANCE(423);
      END_STATE();
    case 340:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 342:
      if (lookahead == 'a') ADVANCE(425);
      END_STATE();
    case 343:
      if (lookahead == 'd') ADVANCE(426);
      END_STATE();
    case 344:
      if (lookahead == 'b') ADVANCE(427);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(428);
      if (lookahead == 's') ADVANCE(429);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 352:
      if (lookahead == 'n') ADVANCE(430);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(431);
      END_STATE();
    case 354:
      if (lookahead == 'l') ADVANCE(432);
      END_STATE();
    case 355:
      if (lookahead == 'a') ADVANCE(433);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(434);
      END_STATE();
    case 357:
      if (lookahead == 'l') ADVANCE(435);
      END_STATE();
    case 358:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(436);
      END_STATE();
    case 360:
      if (lookahead == 's') ADVANCE(437);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 362:
      if (lookahead == 'c') ADVANCE(438);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(439);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 366:
      if (lookahead == 'l') ADVANCE(440);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_fixed);
      END_STATE();
    case 368:
      if (lookahead == 'c') ADVANCE(441);
      END_STATE();
    case 369:
      if (lookahead == 'l') ADVANCE(442);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 371:
      if (lookahead == 'n') ADVANCE(443);
      END_STATE();
    case 372:
      if (lookahead == 'c') ADVANCE(444);
      END_STATE();
    case 373:
      if (lookahead == 'f') ADVANCE(445);
      if (lookahead == 'n') ADVANCE(446);
      END_STATE();
    case 374:
      if (lookahead == 'e') ADVANCE(447);
      END_STATE();
    case 375:
      if (lookahead == 'd') ADVANCE(448);
      END_STATE();
    case 376:
      if (lookahead == 'e') ADVANCE(449);
      END_STATE();
    case 377:
      if (lookahead == 'p') ADVANCE(450);
      END_STATE();
    case 378:
      if (lookahead == 'l') ADVANCE(451);
      END_STATE();
    case 379:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 380:
      if (lookahead == 't') ADVANCE(452);
      END_STATE();
    case 381:
      if (lookahead == 'b') ADVANCE(453);
      END_STATE();
    case 382:
      if (lookahead == 'i') ADVANCE(454);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_param);
      if (lookahead == 's') ADVANCE(455);
      END_STATE();
    case 384:
      if (lookahead == 'a') ADVANCE(456);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(457);
      END_STATE();
    case 386:
      if (lookahead == 'r') ADVANCE(458);
      END_STATE();
    case 387:
      if (lookahead == 'c') ADVANCE(459);
      END_STATE();
    case 388:
      if (lookahead == 'c') ADVANCE(460);
      END_STATE();
    case 389:
      if (lookahead == 'n') ADVANCE(461);
      END_STATE();
    case 390:
      if (lookahead == 'd') ADVANCE(462);
      END_STATE();
    case 391:
      if (lookahead == 'e') ADVANCE(463);
      END_STATE();
    case 392:
      if (lookahead == 'r') ADVANCE(464);
      END_STATE();
    case 393:
      if (lookahead == 'r') ADVANCE(465);
      END_STATE();
    case 394:
      if (lookahead == 'n') ADVANCE(466);
      END_STATE();
    case 395:
      if (lookahead == 'd') ADVANCE(467);
      END_STATE();
    case 396:
      if (lookahead == 'd') ADVANCE(468);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(469);
      END_STATE();
    case 398:
      if (lookahead == 'f') ADVANCE(470);
      END_STATE();
    case 399:
      if (lookahead == 'a') ADVANCE(471);
      END_STATE();
    case 400:
      if (lookahead == 'c') ADVANCE(472);
      END_STATE();
    case 401:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 402:
      if (lookahead == 't') ADVANCE(473);
      END_STATE();
    case 403:
      if (lookahead == 'h') ADVANCE(474);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 405:
      if (lookahead == 'f') ADVANCE(475);
      END_STATE();
    case 406:
      if (lookahead == 'a') ADVANCE(476);
      END_STATE();
    case 407:
      if (lookahead == 'c') ADVANCE(477);
      END_STATE();
    case 408:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 409:
      if (lookahead == 'e') ADVANCE(479);
      END_STATE();
    case 410:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 412:
      if (lookahead == 'a') ADVANCE(480);
      END_STATE();
    case 413:
      if (lookahead == 'i') ADVANCE(481);
      END_STATE();
    case 414:
      if (lookahead == 'n') ADVANCE(482);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 418:
      if (lookahead == 'l') ADVANCE(483);
      END_STATE();
    case 419:
      if (lookahead == 'l') ADVANCE(484);
      END_STATE();
    case 420:
      if (lookahead == 'l') ADVANCE(485);
      END_STATE();
    case 421:
      if (lookahead == 'r') ADVANCE(486);
      END_STATE();
    case 422:
      if (lookahead == 'y') ADVANCE(487);
      END_STATE();
    case 423:
      if (lookahead == 'a') ADVANCE(488);
      END_STATE();
    case 424:
      if (lookahead == 'c') ADVANCE(489);
      END_STATE();
    case 425:
      if (lookahead == 't') ADVANCE(490);
      END_STATE();
    case 426:
      if (lookahead == 'i') ADVANCE(491);
      END_STATE();
    case 427:
      if (lookahead == 'l') ADVANCE(492);
      END_STATE();
    case 428:
      if (lookahead == 'd') ADVANCE(493);
      END_STATE();
    case 429:
      if (lookahead == 'u') ADVANCE(494);
      END_STATE();
    case 430:
      if (lookahead == 'u') ADVANCE(495);
      END_STATE();
    case 431:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 432:
      if (lookahead == 't') ADVANCE(496);
      END_STATE();
    case 433:
      if (lookahead == 't') ADVANCE(497);
      END_STATE();
    case 434:
      if (lookahead == 'd') ADVANCE(498);
      END_STATE();
    case 435:
      if (lookahead == 'e') ADVANCE(499);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_enable);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_equals);
      END_STATE();
    case 438:
      if (lookahead == 'i') ADVANCE(500);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 440:
      if (lookahead == 'y') ADVANCE(501);
      END_STATE();
    case 441:
      if (lookahead == 'h') ADVANCE(502);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 444:
      if (lookahead == 'i') ADVANCE(503);
      END_STATE();
    case 445:
      if (lookahead == 'a') ADVANCE(504);
      END_STATE();
    case 446:
      if (lookahead == 'a') ADVANCE(505);
      END_STATE();
    case 447:
      if (lookahead == 'd') ADVANCE(506);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_method);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 450:
      if (lookahead == 'a') ADVANCE(507);
      END_STATE();
    case 451:
      if (lookahead == 'l') ADVANCE(508);
      END_STATE();
    case 452:
      if (lookahead == 'o') ADVANCE(509);
      END_STATE();
    case 453:
      if (lookahead == 'y') ADVANCE(510);
      END_STATE();
    case 454:
      if (lookahead == 'd') ADVANCE(511);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_params);
      END_STATE();
    case 456:
      if (lookahead == 'l') ADVANCE(512);
      END_STATE();
    case 457:
      if (lookahead == 'e') ADVANCE(513);
      END_STATE();
    case 458:
      if (lookahead == 't') ADVANCE(514);
      END_STATE();
    case 459:
      if (lookahead == 't') ADVANCE(515);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 461:
      if (lookahead == 'l') ADVANCE(516);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(517);
      END_STATE();
    case 465:
      if (lookahead == 'e') ADVANCE(518);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_scoped);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 471:
      if (lookahead == 'l') ADVANCE(519);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 476:
      if (lookahead == 'r') ADVANCE(520);
      END_STATE();
    case 477:
      if (lookahead == 'k') ADVANCE(521);
      END_STATE();
    case 478:
      if (lookahead == 'g') ADVANCE(522);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 480:
      if (lookahead == 'l') ADVANCE(523);
      END_STATE();
    case 481:
      if (lookahead == 'l') ADVANCE(524);
      END_STATE();
    case 482:
      if (lookahead == 'g') ADVANCE(525);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(526);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_Stdcall);
      END_STATE();
    case 485:
      if (lookahead == 'l') ADVANCE(527);
      END_STATE();
    case 486:
      if (lookahead == 'e') ADVANCE(528);
      END_STATE();
    case 487:
      if (lookahead == 'p') ADVANCE(529);
      END_STATE();
    case 488:
      if (lookahead == 'l') ADVANCE(530);
      END_STATE();
    case 489:
      if (lookahead == 't') ADVANCE(531);
      END_STATE();
    case 490:
      if (lookahead == 'i') ADVANCE(532);
      END_STATE();
    case 491:
      if (lookahead == 'n') ADVANCE(533);
      END_STATE();
    case 492:
      if (lookahead == 'y') ADVANCE(534);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_checked);
      END_STATE();
    case 494:
      if (lookahead == 'm') ADVANCE(535);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(536);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(537);
      END_STATE();
    case 498:
      if (lookahead == 'i') ADVANCE(538);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_disable);
      END_STATE();
    case 500:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 503:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 504:
      if (lookahead == 'c') ADVANCE(541);
      END_STATE();
    case 505:
      if (lookahead == 'l') ADVANCE(542);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_managed);
      END_STATE();
    case 507:
      if (lookahead == 'c') ADVANCE(543);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_notnull);
      END_STATE();
    case 509:
      if (lookahead == 'r') ADVANCE(544);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_orderby);
      END_STATE();
    case 511:
      if (lookahead == 'e') ADVANCE(545);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_partial);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 514:
      if (lookahead == 'y') ADVANCE(546);
      END_STATE();
    case 515:
      if (lookahead == 'e') ADVANCE(547);
      END_STATE();
    case 516:
      if (lookahead == 'y') ADVANCE(548);
      END_STATE();
    case 517:
      if (lookahead == 'd') ADVANCE(549);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_restore);
      END_STATE();
    case 519:
      if (lookahead == 'l') ADVANCE(550);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_typevar);
      END_STATE();
    case 521:
      if (lookahead == 'e') ADVANCE(551);
      END_STATE();
    case 522:
      if (lookahead == 'e') ADVANCE(552);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 524:
      if (lookahead == 'e') ADVANCE(553);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_warning);
      if (lookahead == 's') ADVANCE(554);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_Fastcall);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_Thiscall);
      END_STATE();
    case 528:
      if (lookahead == 'f') ADVANCE(555);
      END_STATE();
    case 529:
      if (lookahead == 'e') ADVANCE(556);
      END_STATE();
    case 530:
      if (lookahead == 'u') ADVANCE(557);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 532:
      if (lookahead == 'o') ADVANCE(558);
      END_STATE();
    case 533:
      if (lookahead == 'g') ADVANCE(559);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_checksum);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 538:
      if (lookahead == 'n') ADVANCE(560);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_implicit);
      END_STATE();
    case 541:
      if (lookahead == 'e') ADVANCE(561);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 543:
      if (lookahead == 'e') ADVANCE(562);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 547:
      if (lookahead == 'd') ADVANCE(563);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 550:
      if (lookahead == 'o') ADVANCE(564);
      END_STATE();
    case 551:
      if (lookahead == 'd') ADVANCE(565);
      END_STATE();
    case 552:
      if (lookahead == 'd') ADVANCE(566);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_warnings);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym___makeref);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym___reftype);
      END_STATE();
    case 557:
      if (lookahead == 'e') ADVANCE(567);
      END_STATE();
    case 558:
      if (lookahead == 'n') ADVANCE(568);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_ascending);
      END_STATE();
    case 560:
      if (lookahead == 'g') ADVANCE(569);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 564:
      if (lookahead == 'c') ADVANCE(570);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_unchecked);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym___refvalue);
      END_STATE();
    case 568:
      if (lookahead == 's') ADVANCE(571);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_descending);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_stackalloc);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_annotations);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 132, .external_lex_state = 2},
  [2] = {.lex_state = 132, .external_lex_state = 2},
  [3] = {.lex_state = 132, .external_lex_state = 2},
  [4] = {.lex_state = 132, .external_lex_state = 2},
  [5] = {.lex_state = 132, .external_lex_state = 2},
  [6] = {.lex_state = 132, .external_lex_state = 2},
  [7] = {.lex_state = 132, .external_lex_state = 2},
  [8] = {.lex_state = 132, .external_lex_state = 2},
  [9] = {.lex_state = 132, .external_lex_state = 2},
  [10] = {.lex_state = 132, .external_lex_state = 2},
  [11] = {.lex_state = 132, .external_lex_state = 2},
  [12] = {.lex_state = 132, .external_lex_state = 2},
  [13] = {.lex_state = 132, .external_lex_state = 2},
  [14] = {.lex_state = 132, .external_lex_state = 2},
  [15] = {.lex_state = 132, .external_lex_state = 2},
  [16] = {.lex_state = 132, .external_lex_state = 2},
  [17] = {.lex_state = 132, .external_lex_state = 2},
  [18] = {.lex_state = 132, .external_lex_state = 2},
  [19] = {.lex_state = 132, .external_lex_state = 2},
  [20] = {.lex_state = 132, .external_lex_state = 2},
  [21] = {.lex_state = 132, .external_lex_state = 2},
  [22] = {.lex_state = 132, .external_lex_state = 2},
  [23] = {.lex_state = 132, .external_lex_state = 2},
  [24] = {.lex_state = 132, .external_lex_state = 2},
  [25] = {.lex_state = 132, .external_lex_state = 2},
  [26] = {.lex_state = 132, .external_lex_state = 2},
  [27] = {.lex_state = 132, .external_lex_state = 2},
  [28] = {.lex_state = 132, .external_lex_state = 2},
  [29] = {.lex_state = 132, .external_lex_state = 2},
  [30] = {.lex_state = 132, .external_lex_state = 2},
  [31] = {.lex_state = 132, .external_lex_state = 2},
  [32] = {.lex_state = 132, .external_lex_state = 2},
  [33] = {.lex_state = 132, .external_lex_state = 2},
  [34] = {.lex_state = 132, .external_lex_state = 2},
  [35] = {.lex_state = 132, .external_lex_state = 2},
  [36] = {.lex_state = 132, .external_lex_state = 2},
  [37] = {.lex_state = 132, .external_lex_state = 2},
  [38] = {.lex_state = 132, .external_lex_state = 2},
  [39] = {.lex_state = 132, .external_lex_state = 2},
  [40] = {.lex_state = 132, .external_lex_state = 2},
  [41] = {.lex_state = 132, .external_lex_state = 2},
  [42] = {.lex_state = 132, .external_lex_state = 2},
  [43] = {.lex_state = 132, .external_lex_state = 2},
  [44] = {.lex_state = 132, .external_lex_state = 2},
  [45] = {.lex_state = 132, .external_lex_state = 2},
  [46] = {.lex_state = 132, .external_lex_state = 2},
  [47] = {.lex_state = 132, .external_lex_state = 2},
  [48] = {.lex_state = 132, .external_lex_state = 2},
  [49] = {.lex_state = 132, .external_lex_state = 2},
  [50] = {.lex_state = 132, .external_lex_state = 2},
  [51] = {.lex_state = 132, .external_lex_state = 2},
  [52] = {.lex_state = 132, .external_lex_state = 2},
  [53] = {.lex_state = 132, .external_lex_state = 2},
  [54] = {.lex_state = 132, .external_lex_state = 2},
  [55] = {.lex_state = 132, .external_lex_state = 2},
  [56] = {.lex_state = 132, .external_lex_state = 2},
  [57] = {.lex_state = 132, .external_lex_state = 2},
  [58] = {.lex_state = 132, .external_lex_state = 2},
  [59] = {.lex_state = 132, .external_lex_state = 2},
  [60] = {.lex_state = 132, .external_lex_state = 2},
  [61] = {.lex_state = 132, .external_lex_state = 2},
  [62] = {.lex_state = 132, .external_lex_state = 2},
  [63] = {.lex_state = 132, .external_lex_state = 2},
  [64] = {.lex_state = 132, .external_lex_state = 2},
  [65] = {.lex_state = 132, .external_lex_state = 2},
  [66] = {.lex_state = 132, .external_lex_state = 2},
  [67] = {.lex_state = 132, .external_lex_state = 2},
  [68] = {.lex_state = 132, .external_lex_state = 2},
  [69] = {.lex_state = 132, .external_lex_state = 2},
  [70] = {.lex_state = 132, .external_lex_state = 2},
  [71] = {.lex_state = 132, .external_lex_state = 2},
  [72] = {.lex_state = 132, .external_lex_state = 2},
  [73] = {.lex_state = 132, .external_lex_state = 2},
  [74] = {.lex_state = 132, .external_lex_state = 2},
  [75] = {.lex_state = 132, .external_lex_state = 2},
  [76] = {.lex_state = 132, .external_lex_state = 2},
  [77] = {.lex_state = 132, .external_lex_state = 2},
  [78] = {.lex_state = 132, .external_lex_state = 2},
  [79] = {.lex_state = 132, .external_lex_state = 2},
  [80] = {.lex_state = 132, .external_lex_state = 2},
  [81] = {.lex_state = 132, .external_lex_state = 2},
  [82] = {.lex_state = 132, .external_lex_state = 2},
  [83] = {.lex_state = 132, .external_lex_state = 2},
  [84] = {.lex_state = 132, .external_lex_state = 2},
  [85] = {.lex_state = 132, .external_lex_state = 2},
  [86] = {.lex_state = 132, .external_lex_state = 2},
  [87] = {.lex_state = 132, .external_lex_state = 2},
  [88] = {.lex_state = 132, .external_lex_state = 2},
  [89] = {.lex_state = 132, .external_lex_state = 2},
  [90] = {.lex_state = 132, .external_lex_state = 2},
  [91] = {.lex_state = 132, .external_lex_state = 2},
  [92] = {.lex_state = 132, .external_lex_state = 2},
  [93] = {.lex_state = 132, .external_lex_state = 2},
  [94] = {.lex_state = 132, .external_lex_state = 2},
  [95] = {.lex_state = 132, .external_lex_state = 2},
  [96] = {.lex_state = 132, .external_lex_state = 2},
  [97] = {.lex_state = 132, .external_lex_state = 2},
  [98] = {.lex_state = 132, .external_lex_state = 2},
  [99] = {.lex_state = 132, .external_lex_state = 2},
  [100] = {.lex_state = 132, .external_lex_state = 2},
  [101] = {.lex_state = 132, .external_lex_state = 2},
  [102] = {.lex_state = 132, .external_lex_state = 2},
  [103] = {.lex_state = 132, .external_lex_state = 2},
  [104] = {.lex_state = 132, .external_lex_state = 2},
  [105] = {.lex_state = 132, .external_lex_state = 2},
  [106] = {.lex_state = 132, .external_lex_state = 2},
  [107] = {.lex_state = 132, .external_lex_state = 2},
  [108] = {.lex_state = 132, .external_lex_state = 2},
  [109] = {.lex_state = 132, .external_lex_state = 2},
  [110] = {.lex_state = 132, .external_lex_state = 2},
  [111] = {.lex_state = 132, .external_lex_state = 2},
  [112] = {.lex_state = 132, .external_lex_state = 2},
  [113] = {.lex_state = 132, .external_lex_state = 2},
  [114] = {.lex_state = 132, .external_lex_state = 2},
  [115] = {.lex_state = 132, .external_lex_state = 2},
  [116] = {.lex_state = 132, .external_lex_state = 2},
  [117] = {.lex_state = 132, .external_lex_state = 2},
  [118] = {.lex_state = 132, .external_lex_state = 2},
  [119] = {.lex_state = 132, .external_lex_state = 2},
  [120] = {.lex_state = 132, .external_lex_state = 2},
  [121] = {.lex_state = 132, .external_lex_state = 2},
  [122] = {.lex_state = 132, .external_lex_state = 2},
  [123] = {.lex_state = 132, .external_lex_state = 2},
  [124] = {.lex_state = 132, .external_lex_state = 2},
  [125] = {.lex_state = 132, .external_lex_state = 2},
  [126] = {.lex_state = 132, .external_lex_state = 2},
  [127] = {.lex_state = 132, .external_lex_state = 2},
  [128] = {.lex_state = 132, .external_lex_state = 2},
  [129] = {.lex_state = 132, .external_lex_state = 2},
  [130] = {.lex_state = 132, .external_lex_state = 2},
  [131] = {.lex_state = 131, .external_lex_state = 2},
  [132] = {.lex_state = 132, .external_lex_state = 2},
  [133] = {.lex_state = 132, .external_lex_state = 2},
  [134] = {.lex_state = 132, .external_lex_state = 2},
  [135] = {.lex_state = 132, .external_lex_state = 2},
  [136] = {.lex_state = 132, .external_lex_state = 2},
  [137] = {.lex_state = 132, .external_lex_state = 2},
  [138] = {.lex_state = 131, .external_lex_state = 2},
  [139] = {.lex_state = 132, .external_lex_state = 2},
  [140] = {.lex_state = 132, .external_lex_state = 2},
  [141] = {.lex_state = 132, .external_lex_state = 2},
  [142] = {.lex_state = 132, .external_lex_state = 2},
  [143] = {.lex_state = 132, .external_lex_state = 2},
  [144] = {.lex_state = 132, .external_lex_state = 2},
  [145] = {.lex_state = 132, .external_lex_state = 2},
  [146] = {.lex_state = 132, .external_lex_state = 2},
  [147] = {.lex_state = 132, .external_lex_state = 2},
  [148] = {.lex_state = 132, .external_lex_state = 2},
  [149] = {.lex_state = 131, .external_lex_state = 2},
  [150] = {.lex_state = 131, .external_lex_state = 2},
  [151] = {.lex_state = 131, .external_lex_state = 2},
  [152] = {.lex_state = 131, .external_lex_state = 2},
  [153] = {.lex_state = 131, .external_lex_state = 2},
  [154] = {.lex_state = 131, .external_lex_state = 2},
  [155] = {.lex_state = 131, .external_lex_state = 2},
  [156] = {.lex_state = 131, .external_lex_state = 2},
  [157] = {.lex_state = 131, .external_lex_state = 2},
  [158] = {.lex_state = 131, .external_lex_state = 2},
  [159] = {.lex_state = 131, .external_lex_state = 3},
  [160] = {.lex_state = 131, .external_lex_state = 3},
  [161] = {.lex_state = 131, .external_lex_state = 3},
  [162] = {.lex_state = 131, .external_lex_state = 3},
  [163] = {.lex_state = 131, .external_lex_state = 2},
  [164] = {.lex_state = 131, .external_lex_state = 2},
  [165] = {.lex_state = 131, .external_lex_state = 2},
  [166] = {.lex_state = 131, .external_lex_state = 2},
  [167] = {.lex_state = 131, .external_lex_state = 2},
  [168] = {.lex_state = 131, .external_lex_state = 2},
  [169] = {.lex_state = 131, .external_lex_state = 2},
  [170] = {.lex_state = 131, .external_lex_state = 2},
  [171] = {.lex_state = 131, .external_lex_state = 2},
  [172] = {.lex_state = 131, .external_lex_state = 3},
  [173] = {.lex_state = 131, .external_lex_state = 2},
  [174] = {.lex_state = 131, .external_lex_state = 2},
  [175] = {.lex_state = 131, .external_lex_state = 2},
  [176] = {.lex_state = 131, .external_lex_state = 2},
  [177] = {.lex_state = 131, .external_lex_state = 2},
  [178] = {.lex_state = 131, .external_lex_state = 2},
  [179] = {.lex_state = 131, .external_lex_state = 2},
  [180] = {.lex_state = 131, .external_lex_state = 2},
  [181] = {.lex_state = 131, .external_lex_state = 2},
  [182] = {.lex_state = 131, .external_lex_state = 2},
  [183] = {.lex_state = 131, .external_lex_state = 2},
  [184] = {.lex_state = 131, .external_lex_state = 2},
  [185] = {.lex_state = 131, .external_lex_state = 3},
  [186] = {.lex_state = 131, .external_lex_state = 3},
  [187] = {.lex_state = 131, .external_lex_state = 2},
  [188] = {.lex_state = 131, .external_lex_state = 2},
  [189] = {.lex_state = 131, .external_lex_state = 2},
  [190] = {.lex_state = 131, .external_lex_state = 2},
  [191] = {.lex_state = 131, .external_lex_state = 2},
  [192] = {.lex_state = 131, .external_lex_state = 2},
  [193] = {.lex_state = 131, .external_lex_state = 2},
  [194] = {.lex_state = 131, .external_lex_state = 2},
  [195] = {.lex_state = 131, .external_lex_state = 2},
  [196] = {.lex_state = 131, .external_lex_state = 2},
  [197] = {.lex_state = 131, .external_lex_state = 2},
  [198] = {.lex_state = 131, .external_lex_state = 2},
  [199] = {.lex_state = 131, .external_lex_state = 2},
  [200] = {.lex_state = 131, .external_lex_state = 2},
  [201] = {.lex_state = 131, .external_lex_state = 2},
  [202] = {.lex_state = 131, .external_lex_state = 2},
  [203] = {.lex_state = 131, .external_lex_state = 2},
  [204] = {.lex_state = 131, .external_lex_state = 2},
  [205] = {.lex_state = 131, .external_lex_state = 2},
  [206] = {.lex_state = 131, .external_lex_state = 2},
  [207] = {.lex_state = 131, .external_lex_state = 2},
  [208] = {.lex_state = 131, .external_lex_state = 3},
  [209] = {.lex_state = 131, .external_lex_state = 2},
  [210] = {.lex_state = 131, .external_lex_state = 2},
  [211] = {.lex_state = 131, .external_lex_state = 2},
  [212] = {.lex_state = 131, .external_lex_state = 2},
  [213] = {.lex_state = 131, .external_lex_state = 2},
  [214] = {.lex_state = 131, .external_lex_state = 2},
  [215] = {.lex_state = 131, .external_lex_state = 2},
  [216] = {.lex_state = 131, .external_lex_state = 2},
  [217] = {.lex_state = 131, .external_lex_state = 2},
  [218] = {.lex_state = 131, .external_lex_state = 2},
  [219] = {.lex_state = 131, .external_lex_state = 2},
  [220] = {.lex_state = 131, .external_lex_state = 2},
  [221] = {.lex_state = 131, .external_lex_state = 2},
  [222] = {.lex_state = 131, .external_lex_state = 2},
  [223] = {.lex_state = 131, .external_lex_state = 2},
  [224] = {.lex_state = 131, .external_lex_state = 2},
  [225] = {.lex_state = 131, .external_lex_state = 2},
  [226] = {.lex_state = 132, .external_lex_state = 2},
  [227] = {.lex_state = 131, .external_lex_state = 2},
  [228] = {.lex_state = 132, .external_lex_state = 2},
  [229] = {.lex_state = 131, .external_lex_state = 2},
  [230] = {.lex_state = 132, .external_lex_state = 2},
  [231] = {.lex_state = 132, .external_lex_state = 2},
  [232] = {.lex_state = 131, .external_lex_state = 2},
  [233] = {.lex_state = 131, .external_lex_state = 2},
  [234] = {.lex_state = 131, .external_lex_state = 2},
  [235] = {.lex_state = 132, .external_lex_state = 2},
  [236] = {.lex_state = 132, .external_lex_state = 2},
  [237] = {.lex_state = 131, .external_lex_state = 2},
  [238] = {.lex_state = 131, .external_lex_state = 2},
  [239] = {.lex_state = 132, .external_lex_state = 2},
  [240] = {.lex_state = 131, .external_lex_state = 2},
  [241] = {.lex_state = 132, .external_lex_state = 2},
  [242] = {.lex_state = 131, .external_lex_state = 2},
  [243] = {.lex_state = 131, .external_lex_state = 2},
  [244] = {.lex_state = 131, .external_lex_state = 2},
  [245] = {.lex_state = 131, .external_lex_state = 2},
  [246] = {.lex_state = 132, .external_lex_state = 2},
  [247] = {.lex_state = 132, .external_lex_state = 2},
  [248] = {.lex_state = 132, .external_lex_state = 2},
  [249] = {.lex_state = 131, .external_lex_state = 2},
  [250] = {.lex_state = 132, .external_lex_state = 2},
  [251] = {.lex_state = 131, .external_lex_state = 2},
  [252] = {.lex_state = 131, .external_lex_state = 2},
  [253] = {.lex_state = 131, .external_lex_state = 2},
  [254] = {.lex_state = 131, .external_lex_state = 2},
  [255] = {.lex_state = 131, .external_lex_state = 2},
  [256] = {.lex_state = 132, .external_lex_state = 2},
  [257] = {.lex_state = 131, .external_lex_state = 2},
  [258] = {.lex_state = 132, .external_lex_state = 2},
  [259] = {.lex_state = 131, .external_lex_state = 2},
  [260] = {.lex_state = 131, .external_lex_state = 2},
  [261] = {.lex_state = 131, .external_lex_state = 2},
  [262] = {.lex_state = 132, .external_lex_state = 2},
  [263] = {.lex_state = 131, .external_lex_state = 2},
  [264] = {.lex_state = 131, .external_lex_state = 2},
  [265] = {.lex_state = 132, .external_lex_state = 2},
  [266] = {.lex_state = 131, .external_lex_state = 2},
  [267] = {.lex_state = 131, .external_lex_state = 2},
  [268] = {.lex_state = 131, .external_lex_state = 2},
  [269] = {.lex_state = 131, .external_lex_state = 2},
  [270] = {.lex_state = 131, .external_lex_state = 2},
  [271] = {.lex_state = 131, .external_lex_state = 2},
  [272] = {.lex_state = 132, .external_lex_state = 2},
  [273] = {.lex_state = 132, .external_lex_state = 2},
  [274] = {.lex_state = 132, .external_lex_state = 2},
  [275] = {.lex_state = 131, .external_lex_state = 2},
  [276] = {.lex_state = 132, .external_lex_state = 2},
  [277] = {.lex_state = 132, .external_lex_state = 2},
  [278] = {.lex_state = 132, .external_lex_state = 2},
  [279] = {.lex_state = 131, .external_lex_state = 2},
  [280] = {.lex_state = 131, .external_lex_state = 2},
  [281] = {.lex_state = 132, .external_lex_state = 2},
  [282] = {.lex_state = 131, .external_lex_state = 2},
  [283] = {.lex_state = 132, .external_lex_state = 2},
  [284] = {.lex_state = 132, .external_lex_state = 2},
  [285] = {.lex_state = 132, .external_lex_state = 2},
  [286] = {.lex_state = 132, .external_lex_state = 2},
  [287] = {.lex_state = 132, .external_lex_state = 2},
  [288] = {.lex_state = 132, .external_lex_state = 2},
  [289] = {.lex_state = 131, .external_lex_state = 2},
  [290] = {.lex_state = 132, .external_lex_state = 2},
  [291] = {.lex_state = 132, .external_lex_state = 2},
  [292] = {.lex_state = 132, .external_lex_state = 2},
  [293] = {.lex_state = 132, .external_lex_state = 2},
  [294] = {.lex_state = 132, .external_lex_state = 2},
  [295] = {.lex_state = 132, .external_lex_state = 2},
  [296] = {.lex_state = 132, .external_lex_state = 2},
  [297] = {.lex_state = 132, .external_lex_state = 2},
  [298] = {.lex_state = 132, .external_lex_state = 2},
  [299] = {.lex_state = 132, .external_lex_state = 2},
  [300] = {.lex_state = 132, .external_lex_state = 2},
  [301] = {.lex_state = 132, .external_lex_state = 2},
  [302] = {.lex_state = 132, .external_lex_state = 2},
  [303] = {.lex_state = 132, .external_lex_state = 2},
  [304] = {.lex_state = 132, .external_lex_state = 2},
  [305] = {.lex_state = 132, .external_lex_state = 2},
  [306] = {.lex_state = 132, .external_lex_state = 2},
  [307] = {.lex_state = 132, .external_lex_state = 2},
  [308] = {.lex_state = 132, .external_lex_state = 2},
  [309] = {.lex_state = 132, .external_lex_state = 2},
  [310] = {.lex_state = 132, .external_lex_state = 2},
  [311] = {.lex_state = 132, .external_lex_state = 2},
  [312] = {.lex_state = 132, .external_lex_state = 2},
  [313] = {.lex_state = 132, .external_lex_state = 2},
  [314] = {.lex_state = 132, .external_lex_state = 2},
  [315] = {.lex_state = 132, .external_lex_state = 2},
  [316] = {.lex_state = 132, .external_lex_state = 2},
  [317] = {.lex_state = 132, .external_lex_state = 2},
  [318] = {.lex_state = 132, .external_lex_state = 2},
  [319] = {.lex_state = 132, .external_lex_state = 2},
  [320] = {.lex_state = 132, .external_lex_state = 2},
  [321] = {.lex_state = 132, .external_lex_state = 2},
  [322] = {.lex_state = 132, .external_lex_state = 2},
  [323] = {.lex_state = 132, .external_lex_state = 2},
  [324] = {.lex_state = 132, .external_lex_state = 2},
  [325] = {.lex_state = 132, .external_lex_state = 2},
  [326] = {.lex_state = 132, .external_lex_state = 2},
  [327] = {.lex_state = 132, .external_lex_state = 2},
  [328] = {.lex_state = 132, .external_lex_state = 2},
  [329] = {.lex_state = 132, .external_lex_state = 2},
  [330] = {.lex_state = 132, .external_lex_state = 2},
  [331] = {.lex_state = 132, .external_lex_state = 2},
  [332] = {.lex_state = 132, .external_lex_state = 2},
  [333] = {.lex_state = 132, .external_lex_state = 2},
  [334] = {.lex_state = 132, .external_lex_state = 2},
  [335] = {.lex_state = 132, .external_lex_state = 2},
  [336] = {.lex_state = 132, .external_lex_state = 2},
  [337] = {.lex_state = 132, .external_lex_state = 2},
  [338] = {.lex_state = 132, .external_lex_state = 2},
  [339] = {.lex_state = 132, .external_lex_state = 2},
  [340] = {.lex_state = 132, .external_lex_state = 2},
  [341] = {.lex_state = 132, .external_lex_state = 2},
  [342] = {.lex_state = 132, .external_lex_state = 2},
  [343] = {.lex_state = 132, .external_lex_state = 2},
  [344] = {.lex_state = 132, .external_lex_state = 2},
  [345] = {.lex_state = 132, .external_lex_state = 2},
  [346] = {.lex_state = 132, .external_lex_state = 2},
  [347] = {.lex_state = 132, .external_lex_state = 2},
  [348] = {.lex_state = 132, .external_lex_state = 2},
  [349] = {.lex_state = 132, .external_lex_state = 2},
  [350] = {.lex_state = 132, .external_lex_state = 2},
  [351] = {.lex_state = 132, .external_lex_state = 2},
  [352] = {.lex_state = 132, .external_lex_state = 2},
  [353] = {.lex_state = 132, .external_lex_state = 2},
  [354] = {.lex_state = 132, .external_lex_state = 2},
  [355] = {.lex_state = 132, .external_lex_state = 2},
  [356] = {.lex_state = 132, .external_lex_state = 2},
  [357] = {.lex_state = 132, .external_lex_state = 2},
  [358] = {.lex_state = 132, .external_lex_state = 2},
  [359] = {.lex_state = 132, .external_lex_state = 2},
  [360] = {.lex_state = 132, .external_lex_state = 2},
  [361] = {.lex_state = 132, .external_lex_state = 2},
  [362] = {.lex_state = 132, .external_lex_state = 2},
  [363] = {.lex_state = 132, .external_lex_state = 2},
  [364] = {.lex_state = 132, .external_lex_state = 2},
  [365] = {.lex_state = 132, .external_lex_state = 2},
  [366] = {.lex_state = 132, .external_lex_state = 2},
  [367] = {.lex_state = 132, .external_lex_state = 2},
  [368] = {.lex_state = 132, .external_lex_state = 2},
  [369] = {.lex_state = 132, .external_lex_state = 2},
  [370] = {.lex_state = 132, .external_lex_state = 2},
  [371] = {.lex_state = 132, .external_lex_state = 2},
  [372] = {.lex_state = 132, .external_lex_state = 2},
  [373] = {.lex_state = 132, .external_lex_state = 2},
  [374] = {.lex_state = 132, .external_lex_state = 2},
  [375] = {.lex_state = 132, .external_lex_state = 2},
  [376] = {.lex_state = 132, .external_lex_state = 2},
  [377] = {.lex_state = 132, .external_lex_state = 2},
  [378] = {.lex_state = 132, .external_lex_state = 2},
  [379] = {.lex_state = 132, .external_lex_state = 2},
  [380] = {.lex_state = 132, .external_lex_state = 2},
  [381] = {.lex_state = 132, .external_lex_state = 2},
  [382] = {.lex_state = 132, .external_lex_state = 2},
  [383] = {.lex_state = 132, .external_lex_state = 2},
  [384] = {.lex_state = 132, .external_lex_state = 2},
  [385] = {.lex_state = 132, .external_lex_state = 2},
  [386] = {.lex_state = 132, .external_lex_state = 2},
  [387] = {.lex_state = 132, .external_lex_state = 2},
  [388] = {.lex_state = 132, .external_lex_state = 2},
  [389] = {.lex_state = 132, .external_lex_state = 2},
  [390] = {.lex_state = 132, .external_lex_state = 2},
  [391] = {.lex_state = 132, .external_lex_state = 2},
  [392] = {.lex_state = 132, .external_lex_state = 2},
  [393] = {.lex_state = 132, .external_lex_state = 2},
  [394] = {.lex_state = 132, .external_lex_state = 2},
  [395] = {.lex_state = 132, .external_lex_state = 2},
  [396] = {.lex_state = 132, .external_lex_state = 2},
  [397] = {.lex_state = 132, .external_lex_state = 2},
  [398] = {.lex_state = 132, .external_lex_state = 2},
  [399] = {.lex_state = 132, .external_lex_state = 2},
  [400] = {.lex_state = 132, .external_lex_state = 2},
  [401] = {.lex_state = 132, .external_lex_state = 2},
  [402] = {.lex_state = 132, .external_lex_state = 2},
  [403] = {.lex_state = 132, .external_lex_state = 2},
  [404] = {.lex_state = 132, .external_lex_state = 2},
  [405] = {.lex_state = 132, .external_lex_state = 2},
  [406] = {.lex_state = 132, .external_lex_state = 2},
  [407] = {.lex_state = 132, .external_lex_state = 2},
  [408] = {.lex_state = 132, .external_lex_state = 2},
  [409] = {.lex_state = 132, .external_lex_state = 2},
  [410] = {.lex_state = 132, .external_lex_state = 2},
  [411] = {.lex_state = 132, .external_lex_state = 2},
  [412] = {.lex_state = 132, .external_lex_state = 2},
  [413] = {.lex_state = 132, .external_lex_state = 2},
  [414] = {.lex_state = 132, .external_lex_state = 2},
  [415] = {.lex_state = 132, .external_lex_state = 2},
  [416] = {.lex_state = 132, .external_lex_state = 2},
  [417] = {.lex_state = 132, .external_lex_state = 2},
  [418] = {.lex_state = 132, .external_lex_state = 2},
  [419] = {.lex_state = 132, .external_lex_state = 2},
  [420] = {.lex_state = 132, .external_lex_state = 2},
  [421] = {.lex_state = 132, .external_lex_state = 2},
  [422] = {.lex_state = 132, .external_lex_state = 2},
  [423] = {.lex_state = 132, .external_lex_state = 2},
  [424] = {.lex_state = 132, .external_lex_state = 2},
  [425] = {.lex_state = 132, .external_lex_state = 2},
  [426] = {.lex_state = 132, .external_lex_state = 2},
  [427] = {.lex_state = 132, .external_lex_state = 2},
  [428] = {.lex_state = 132, .external_lex_state = 2},
  [429] = {.lex_state = 132, .external_lex_state = 2},
  [430] = {.lex_state = 132, .external_lex_state = 2},
  [431] = {.lex_state = 132, .external_lex_state = 2},
  [432] = {.lex_state = 132, .external_lex_state = 2},
  [433] = {.lex_state = 132, .external_lex_state = 2},
  [434] = {.lex_state = 132, .external_lex_state = 2},
  [435] = {.lex_state = 132, .external_lex_state = 2},
  [436] = {.lex_state = 132, .external_lex_state = 2},
  [437] = {.lex_state = 132, .external_lex_state = 2},
  [438] = {.lex_state = 132, .external_lex_state = 2},
  [439] = {.lex_state = 132, .external_lex_state = 2},
  [440] = {.lex_state = 132, .external_lex_state = 2},
  [441] = {.lex_state = 132, .external_lex_state = 2},
  [442] = {.lex_state = 132, .external_lex_state = 2},
  [443] = {.lex_state = 132, .external_lex_state = 2},
  [444] = {.lex_state = 132, .external_lex_state = 2},
  [445] = {.lex_state = 132, .external_lex_state = 2},
  [446] = {.lex_state = 132, .external_lex_state = 2},
  [447] = {.lex_state = 132, .external_lex_state = 2},
  [448] = {.lex_state = 132, .external_lex_state = 2},
  [449] = {.lex_state = 132, .external_lex_state = 2},
  [450] = {.lex_state = 132, .external_lex_state = 2},
  [451] = {.lex_state = 132, .external_lex_state = 2},
  [452] = {.lex_state = 132, .external_lex_state = 2},
  [453] = {.lex_state = 132, .external_lex_state = 2},
  [454] = {.lex_state = 132, .external_lex_state = 2},
  [455] = {.lex_state = 132, .external_lex_state = 2},
  [456] = {.lex_state = 132, .external_lex_state = 2},
  [457] = {.lex_state = 132, .external_lex_state = 2},
  [458] = {.lex_state = 132, .external_lex_state = 2},
  [459] = {.lex_state = 132, .external_lex_state = 2},
  [460] = {.lex_state = 132, .external_lex_state = 2},
  [461] = {.lex_state = 132, .external_lex_state = 2},
  [462] = {.lex_state = 132, .external_lex_state = 2},
  [463] = {.lex_state = 132, .external_lex_state = 2},
  [464] = {.lex_state = 132, .external_lex_state = 2},
  [465] = {.lex_state = 132, .external_lex_state = 2},
  [466] = {.lex_state = 132, .external_lex_state = 2},
  [467] = {.lex_state = 132, .external_lex_state = 2},
  [468] = {.lex_state = 132, .external_lex_state = 2},
  [469] = {.lex_state = 132, .external_lex_state = 2},
  [470] = {.lex_state = 132, .external_lex_state = 2},
  [471] = {.lex_state = 132, .external_lex_state = 2},
  [472] = {.lex_state = 132, .external_lex_state = 2},
  [473] = {.lex_state = 132, .external_lex_state = 2},
  [474] = {.lex_state = 132, .external_lex_state = 2},
  [475] = {.lex_state = 132, .external_lex_state = 2},
  [476] = {.lex_state = 132, .external_lex_state = 2},
  [477] = {.lex_state = 132, .external_lex_state = 2},
  [478] = {.lex_state = 132, .external_lex_state = 2},
  [479] = {.lex_state = 132, .external_lex_state = 2},
  [480] = {.lex_state = 132, .external_lex_state = 2},
  [481] = {.lex_state = 132, .external_lex_state = 2},
  [482] = {.lex_state = 132, .external_lex_state = 2},
  [483] = {.lex_state = 132, .external_lex_state = 2},
  [484] = {.lex_state = 132, .external_lex_state = 2},
  [485] = {.lex_state = 132, .external_lex_state = 2},
  [486] = {.lex_state = 132, .external_lex_state = 2},
  [487] = {.lex_state = 132, .external_lex_state = 2},
  [488] = {.lex_state = 132, .external_lex_state = 2},
  [489] = {.lex_state = 132, .external_lex_state = 2},
  [490] = {.lex_state = 132, .external_lex_state = 2},
  [491] = {.lex_state = 132, .external_lex_state = 2},
  [492] = {.lex_state = 132, .external_lex_state = 2},
  [493] = {.lex_state = 132, .external_lex_state = 2},
  [494] = {.lex_state = 132, .external_lex_state = 2},
  [495] = {.lex_state = 132, .external_lex_state = 2},
  [496] = {.lex_state = 132, .external_lex_state = 2},
  [497] = {.lex_state = 132, .external_lex_state = 2},
  [498] = {.lex_state = 132, .external_lex_state = 2},
  [499] = {.lex_state = 132, .external_lex_state = 2},
  [500] = {.lex_state = 132, .external_lex_state = 2},
  [501] = {.lex_state = 132, .external_lex_state = 2},
  [502] = {.lex_state = 132, .external_lex_state = 2},
  [503] = {.lex_state = 132, .external_lex_state = 2},
  [504] = {.lex_state = 132, .external_lex_state = 2},
  [505] = {.lex_state = 132, .external_lex_state = 2},
  [506] = {.lex_state = 132, .external_lex_state = 2},
  [507] = {.lex_state = 132, .external_lex_state = 2},
  [508] = {.lex_state = 132, .external_lex_state = 2},
  [509] = {.lex_state = 132, .external_lex_state = 2},
  [510] = {.lex_state = 132, .external_lex_state = 2},
  [511] = {.lex_state = 132, .external_lex_state = 2},
  [512] = {.lex_state = 132, .external_lex_state = 2},
  [513] = {.lex_state = 132, .external_lex_state = 2},
  [514] = {.lex_state = 132, .external_lex_state = 2},
  [515] = {.lex_state = 132, .external_lex_state = 2},
  [516] = {.lex_state = 132, .external_lex_state = 2},
  [517] = {.lex_state = 132, .external_lex_state = 2},
  [518] = {.lex_state = 132, .external_lex_state = 2},
  [519] = {.lex_state = 132, .external_lex_state = 2},
  [520] = {.lex_state = 132, .external_lex_state = 2},
  [521] = {.lex_state = 132, .external_lex_state = 2},
  [522] = {.lex_state = 132, .external_lex_state = 2},
  [523] = {.lex_state = 132, .external_lex_state = 2},
  [524] = {.lex_state = 132, .external_lex_state = 2},
  [525] = {.lex_state = 132, .external_lex_state = 2},
  [526] = {.lex_state = 132, .external_lex_state = 2},
  [527] = {.lex_state = 132, .external_lex_state = 2},
  [528] = {.lex_state = 132, .external_lex_state = 2},
  [529] = {.lex_state = 132, .external_lex_state = 2},
  [530] = {.lex_state = 132, .external_lex_state = 2},
  [531] = {.lex_state = 132, .external_lex_state = 2},
  [532] = {.lex_state = 132, .external_lex_state = 2},
  [533] = {.lex_state = 132, .external_lex_state = 2},
  [534] = {.lex_state = 132, .external_lex_state = 2},
  [535] = {.lex_state = 132, .external_lex_state = 2},
  [536] = {.lex_state = 132, .external_lex_state = 2},
  [537] = {.lex_state = 132, .external_lex_state = 2},
  [538] = {.lex_state = 132, .external_lex_state = 2},
  [539] = {.lex_state = 132, .external_lex_state = 2},
  [540] = {.lex_state = 132, .external_lex_state = 2},
  [541] = {.lex_state = 132, .external_lex_state = 2},
  [542] = {.lex_state = 132, .external_lex_state = 2},
  [543] = {.lex_state = 132, .external_lex_state = 2},
  [544] = {.lex_state = 132, .external_lex_state = 2},
  [545] = {.lex_state = 132, .external_lex_state = 2},
  [546] = {.lex_state = 132, .external_lex_state = 2},
  [547] = {.lex_state = 132, .external_lex_state = 2},
  [548] = {.lex_state = 132, .external_lex_state = 2},
  [549] = {.lex_state = 132, .external_lex_state = 2},
  [550] = {.lex_state = 132, .external_lex_state = 2},
  [551] = {.lex_state = 132, .external_lex_state = 2},
  [552] = {.lex_state = 132, .external_lex_state = 2},
  [553] = {.lex_state = 132, .external_lex_state = 2},
  [554] = {.lex_state = 132, .external_lex_state = 2},
  [555] = {.lex_state = 132, .external_lex_state = 2},
  [556] = {.lex_state = 132, .external_lex_state = 2},
  [557] = {.lex_state = 132, .external_lex_state = 2},
  [558] = {.lex_state = 132, .external_lex_state = 2},
  [559] = {.lex_state = 132, .external_lex_state = 2},
  [560] = {.lex_state = 132, .external_lex_state = 2},
  [561] = {.lex_state = 132, .external_lex_state = 2},
  [562] = {.lex_state = 132, .external_lex_state = 2},
  [563] = {.lex_state = 132, .external_lex_state = 2},
  [564] = {.lex_state = 132, .external_lex_state = 2},
  [565] = {.lex_state = 132, .external_lex_state = 2},
  [566] = {.lex_state = 132, .external_lex_state = 2},
  [567] = {.lex_state = 132, .external_lex_state = 2},
  [568] = {.lex_state = 132, .external_lex_state = 2},
  [569] = {.lex_state = 132, .external_lex_state = 2},
  [570] = {.lex_state = 132, .external_lex_state = 2},
  [571] = {.lex_state = 132, .external_lex_state = 2},
  [572] = {.lex_state = 132, .external_lex_state = 2},
  [573] = {.lex_state = 132, .external_lex_state = 2},
  [574] = {.lex_state = 132, .external_lex_state = 2},
  [575] = {.lex_state = 132, .external_lex_state = 2},
  [576] = {.lex_state = 132, .external_lex_state = 2},
  [577] = {.lex_state = 132, .external_lex_state = 2},
  [578] = {.lex_state = 132, .external_lex_state = 2},
  [579] = {.lex_state = 132, .external_lex_state = 2},
  [580] = {.lex_state = 132, .external_lex_state = 2},
  [581] = {.lex_state = 132, .external_lex_state = 2},
  [582] = {.lex_state = 132, .external_lex_state = 2},
  [583] = {.lex_state = 132, .external_lex_state = 2},
  [584] = {.lex_state = 132, .external_lex_state = 2},
  [585] = {.lex_state = 132, .external_lex_state = 2},
  [586] = {.lex_state = 132, .external_lex_state = 2},
  [587] = {.lex_state = 132, .external_lex_state = 2},
  [588] = {.lex_state = 132, .external_lex_state = 2},
  [589] = {.lex_state = 132, .external_lex_state = 2},
  [590] = {.lex_state = 132, .external_lex_state = 2},
  [591] = {.lex_state = 132, .external_lex_state = 2},
  [592] = {.lex_state = 132, .external_lex_state = 2},
  [593] = {.lex_state = 132, .external_lex_state = 2},
  [594] = {.lex_state = 132, .external_lex_state = 2},
  [595] = {.lex_state = 132, .external_lex_state = 2},
  [596] = {.lex_state = 132, .external_lex_state = 2},
  [597] = {.lex_state = 132, .external_lex_state = 2},
  [598] = {.lex_state = 132, .external_lex_state = 2},
  [599] = {.lex_state = 132, .external_lex_state = 2},
  [600] = {.lex_state = 132, .external_lex_state = 2},
  [601] = {.lex_state = 132, .external_lex_state = 2},
  [602] = {.lex_state = 132, .external_lex_state = 2},
  [603] = {.lex_state = 132, .external_lex_state = 2},
  [604] = {.lex_state = 132, .external_lex_state = 2},
  [605] = {.lex_state = 132, .external_lex_state = 2},
  [606] = {.lex_state = 132, .external_lex_state = 2},
  [607] = {.lex_state = 132, .external_lex_state = 2},
  [608] = {.lex_state = 132, .external_lex_state = 2},
  [609] = {.lex_state = 132, .external_lex_state = 2},
  [610] = {.lex_state = 132, .external_lex_state = 2},
  [611] = {.lex_state = 132, .external_lex_state = 2},
  [612] = {.lex_state = 132, .external_lex_state = 2},
  [613] = {.lex_state = 132, .external_lex_state = 2},
  [614] = {.lex_state = 132, .external_lex_state = 2},
  [615] = {.lex_state = 132, .external_lex_state = 2},
  [616] = {.lex_state = 132, .external_lex_state = 2},
  [617] = {.lex_state = 132, .external_lex_state = 2},
  [618] = {.lex_state = 132, .external_lex_state = 2},
  [619] = {.lex_state = 132, .external_lex_state = 2},
  [620] = {.lex_state = 132, .external_lex_state = 2},
  [621] = {.lex_state = 132, .external_lex_state = 2},
  [622] = {.lex_state = 132, .external_lex_state = 2},
  [623] = {.lex_state = 132, .external_lex_state = 2},
  [624] = {.lex_state = 132, .external_lex_state = 2},
  [625] = {.lex_state = 132, .external_lex_state = 2},
  [626] = {.lex_state = 132, .external_lex_state = 2},
  [627] = {.lex_state = 132, .external_lex_state = 2},
  [628] = {.lex_state = 132, .external_lex_state = 2},
  [629] = {.lex_state = 132, .external_lex_state = 2},
  [630] = {.lex_state = 132, .external_lex_state = 2},
  [631] = {.lex_state = 132, .external_lex_state = 2},
  [632] = {.lex_state = 132, .external_lex_state = 2},
  [633] = {.lex_state = 132, .external_lex_state = 2},
  [634] = {.lex_state = 132, .external_lex_state = 2},
  [635] = {.lex_state = 132, .external_lex_state = 2},
  [636] = {.lex_state = 132, .external_lex_state = 2},
  [637] = {.lex_state = 132, .external_lex_state = 2},
  [638] = {.lex_state = 132, .external_lex_state = 2},
  [639] = {.lex_state = 132, .external_lex_state = 2},
  [640] = {.lex_state = 132, .external_lex_state = 2},
  [641] = {.lex_state = 132, .external_lex_state = 2},
  [642] = {.lex_state = 132, .external_lex_state = 2},
  [643] = {.lex_state = 132, .external_lex_state = 2},
  [644] = {.lex_state = 132, .external_lex_state = 2},
  [645] = {.lex_state = 132, .external_lex_state = 2},
  [646] = {.lex_state = 132, .external_lex_state = 2},
  [647] = {.lex_state = 132, .external_lex_state = 2},
  [648] = {.lex_state = 132, .external_lex_state = 2},
  [649] = {.lex_state = 132, .external_lex_state = 2},
  [650] = {.lex_state = 132, .external_lex_state = 2},
  [651] = {.lex_state = 132, .external_lex_state = 2},
  [652] = {.lex_state = 132, .external_lex_state = 2},
  [653] = {.lex_state = 132, .external_lex_state = 2},
  [654] = {.lex_state = 132, .external_lex_state = 2},
  [655] = {.lex_state = 132, .external_lex_state = 2},
  [656] = {.lex_state = 132, .external_lex_state = 2},
  [657] = {.lex_state = 132, .external_lex_state = 2},
  [658] = {.lex_state = 132, .external_lex_state = 2},
  [659] = {.lex_state = 132, .external_lex_state = 2},
  [660] = {.lex_state = 132, .external_lex_state = 2},
  [661] = {.lex_state = 132, .external_lex_state = 2},
  [662] = {.lex_state = 132, .external_lex_state = 2},
  [663] = {.lex_state = 132, .external_lex_state = 2},
  [664] = {.lex_state = 132, .external_lex_state = 2},
  [665] = {.lex_state = 132, .external_lex_state = 2},
  [666] = {.lex_state = 132, .external_lex_state = 2},
  [667] = {.lex_state = 132, .external_lex_state = 2},
  [668] = {.lex_state = 132, .external_lex_state = 2},
  [669] = {.lex_state = 132, .external_lex_state = 2},
  [670] = {.lex_state = 132, .external_lex_state = 2},
  [671] = {.lex_state = 132, .external_lex_state = 2},
  [672] = {.lex_state = 132, .external_lex_state = 2},
  [673] = {.lex_state = 132, .external_lex_state = 2},
  [674] = {.lex_state = 132, .external_lex_state = 2},
  [675] = {.lex_state = 132, .external_lex_state = 2},
  [676] = {.lex_state = 132, .external_lex_state = 2},
  [677] = {.lex_state = 132, .external_lex_state = 2},
  [678] = {.lex_state = 132, .external_lex_state = 2},
  [679] = {.lex_state = 132, .external_lex_state = 2},
  [680] = {.lex_state = 132, .external_lex_state = 2},
  [681] = {.lex_state = 132, .external_lex_state = 2},
  [682] = {.lex_state = 132, .external_lex_state = 2},
  [683] = {.lex_state = 132, .external_lex_state = 2},
  [684] = {.lex_state = 132, .external_lex_state = 2},
  [685] = {.lex_state = 132, .external_lex_state = 2},
  [686] = {.lex_state = 132, .external_lex_state = 2},
  [687] = {.lex_state = 132, .external_lex_state = 2},
  [688] = {.lex_state = 132, .external_lex_state = 2},
  [689] = {.lex_state = 132, .external_lex_state = 2},
  [690] = {.lex_state = 132, .external_lex_state = 2},
  [691] = {.lex_state = 132, .external_lex_state = 2},
  [692] = {.lex_state = 132, .external_lex_state = 2},
  [693] = {.lex_state = 132, .external_lex_state = 2},
  [694] = {.lex_state = 132, .external_lex_state = 2},
  [695] = {.lex_state = 132, .external_lex_state = 2},
  [696] = {.lex_state = 132, .external_lex_state = 2},
  [697] = {.lex_state = 132, .external_lex_state = 2},
  [698] = {.lex_state = 132, .external_lex_state = 2},
  [699] = {.lex_state = 132, .external_lex_state = 2},
  [700] = {.lex_state = 132, .external_lex_state = 2},
  [701] = {.lex_state = 132, .external_lex_state = 2},
  [702] = {.lex_state = 132, .external_lex_state = 2},
  [703] = {.lex_state = 132, .external_lex_state = 2},
  [704] = {.lex_state = 132, .external_lex_state = 2},
  [705] = {.lex_state = 132, .external_lex_state = 2},
  [706] = {.lex_state = 132, .external_lex_state = 2},
  [707] = {.lex_state = 132, .external_lex_state = 2},
  [708] = {.lex_state = 132, .external_lex_state = 2},
  [709] = {.lex_state = 132, .external_lex_state = 2},
  [710] = {.lex_state = 132, .external_lex_state = 2},
  [711] = {.lex_state = 132, .external_lex_state = 2},
  [712] = {.lex_state = 132, .external_lex_state = 2},
  [713] = {.lex_state = 132, .external_lex_state = 2},
  [714] = {.lex_state = 132, .external_lex_state = 2},
  [715] = {.lex_state = 132, .external_lex_state = 2},
  [716] = {.lex_state = 132, .external_lex_state = 2},
  [717] = {.lex_state = 132, .external_lex_state = 2},
  [718] = {.lex_state = 132, .external_lex_state = 2},
  [719] = {.lex_state = 132, .external_lex_state = 2},
  [720] = {.lex_state = 132, .external_lex_state = 2},
  [721] = {.lex_state = 132, .external_lex_state = 2},
  [722] = {.lex_state = 132, .external_lex_state = 2},
  [723] = {.lex_state = 132, .external_lex_state = 2},
  [724] = {.lex_state = 132, .external_lex_state = 2},
  [725] = {.lex_state = 132, .external_lex_state = 2},
  [726] = {.lex_state = 132, .external_lex_state = 2},
  [727] = {.lex_state = 132, .external_lex_state = 2},
  [728] = {.lex_state = 132, .external_lex_state = 2},
  [729] = {.lex_state = 132, .external_lex_state = 2},
  [730] = {.lex_state = 132, .external_lex_state = 2},
  [731] = {.lex_state = 132, .external_lex_state = 2},
  [732] = {.lex_state = 132, .external_lex_state = 2},
  [733] = {.lex_state = 132, .external_lex_state = 2},
  [734] = {.lex_state = 132, .external_lex_state = 2},
  [735] = {.lex_state = 132, .external_lex_state = 2},
  [736] = {.lex_state = 132, .external_lex_state = 2},
  [737] = {.lex_state = 132, .external_lex_state = 2},
  [738] = {.lex_state = 132, .external_lex_state = 2},
  [739] = {.lex_state = 132, .external_lex_state = 2},
  [740] = {.lex_state = 132, .external_lex_state = 2},
  [741] = {.lex_state = 132, .external_lex_state = 2},
  [742] = {.lex_state = 132, .external_lex_state = 2},
  [743] = {.lex_state = 132, .external_lex_state = 2},
  [744] = {.lex_state = 132, .external_lex_state = 2},
  [745] = {.lex_state = 132, .external_lex_state = 2},
  [746] = {.lex_state = 132, .external_lex_state = 2},
  [747] = {.lex_state = 132, .external_lex_state = 2},
  [748] = {.lex_state = 132, .external_lex_state = 2},
  [749] = {.lex_state = 132, .external_lex_state = 2},
  [750] = {.lex_state = 132, .external_lex_state = 2},
  [751] = {.lex_state = 132, .external_lex_state = 2},
  [752] = {.lex_state = 132, .external_lex_state = 2},
  [753] = {.lex_state = 132, .external_lex_state = 2},
  [754] = {.lex_state = 132, .external_lex_state = 2},
  [755] = {.lex_state = 132, .external_lex_state = 2},
  [756] = {.lex_state = 132, .external_lex_state = 2},
  [757] = {.lex_state = 132, .external_lex_state = 2},
  [758] = {.lex_state = 132, .external_lex_state = 2},
  [759] = {.lex_state = 132, .external_lex_state = 2},
  [760] = {.lex_state = 132, .external_lex_state = 2},
  [761] = {.lex_state = 132, .external_lex_state = 2},
  [762] = {.lex_state = 132, .external_lex_state = 2},
  [763] = {.lex_state = 132, .external_lex_state = 2},
  [764] = {.lex_state = 132, .external_lex_state = 2},
  [765] = {.lex_state = 132, .external_lex_state = 2},
  [766] = {.lex_state = 132, .external_lex_state = 2},
  [767] = {.lex_state = 132, .external_lex_state = 2},
  [768] = {.lex_state = 132, .external_lex_state = 2},
  [769] = {.lex_state = 132, .external_lex_state = 2},
  [770] = {.lex_state = 132, .external_lex_state = 2},
  [771] = {.lex_state = 132, .external_lex_state = 2},
  [772] = {.lex_state = 132, .external_lex_state = 2},
  [773] = {.lex_state = 132, .external_lex_state = 2},
  [774] = {.lex_state = 132, .external_lex_state = 2},
  [775] = {.lex_state = 132, .external_lex_state = 2},
  [776] = {.lex_state = 132, .external_lex_state = 2},
  [777] = {.lex_state = 132, .external_lex_state = 2},
  [778] = {.lex_state = 132, .external_lex_state = 2},
  [779] = {.lex_state = 132, .external_lex_state = 2},
  [780] = {.lex_state = 132, .external_lex_state = 2},
  [781] = {.lex_state = 132, .external_lex_state = 2},
  [782] = {.lex_state = 132, .external_lex_state = 2},
  [783] = {.lex_state = 132, .external_lex_state = 2},
  [784] = {.lex_state = 132, .external_lex_state = 2},
  [785] = {.lex_state = 132, .external_lex_state = 2},
  [786] = {.lex_state = 132, .external_lex_state = 2},
  [787] = {.lex_state = 132, .external_lex_state = 2},
  [788] = {.lex_state = 132, .external_lex_state = 2},
  [789] = {.lex_state = 132, .external_lex_state = 2},
  [790] = {.lex_state = 132, .external_lex_state = 2},
  [791] = {.lex_state = 132, .external_lex_state = 2},
  [792] = {.lex_state = 132, .external_lex_state = 2},
  [793] = {.lex_state = 132, .external_lex_state = 2},
  [794] = {.lex_state = 132, .external_lex_state = 2},
  [795] = {.lex_state = 132, .external_lex_state = 2},
  [796] = {.lex_state = 132, .external_lex_state = 2},
  [797] = {.lex_state = 132, .external_lex_state = 2},
  [798] = {.lex_state = 132, .external_lex_state = 2},
  [799] = {.lex_state = 132, .external_lex_state = 2},
  [800] = {.lex_state = 132, .external_lex_state = 2},
  [801] = {.lex_state = 132, .external_lex_state = 2},
  [802] = {.lex_state = 132, .external_lex_state = 2},
  [803] = {.lex_state = 132, .external_lex_state = 2},
  [804] = {.lex_state = 132, .external_lex_state = 2},
  [805] = {.lex_state = 132, .external_lex_state = 2},
  [806] = {.lex_state = 132, .external_lex_state = 2},
  [807] = {.lex_state = 132, .external_lex_state = 2},
  [808] = {.lex_state = 132, .external_lex_state = 2},
  [809] = {.lex_state = 132, .external_lex_state = 2},
  [810] = {.lex_state = 132, .external_lex_state = 2},
  [811] = {.lex_state = 132, .external_lex_state = 2},
  [812] = {.lex_state = 132, .external_lex_state = 2},
  [813] = {.lex_state = 132, .external_lex_state = 2},
  [814] = {.lex_state = 132, .external_lex_state = 2},
  [815] = {.lex_state = 132, .external_lex_state = 2},
  [816] = {.lex_state = 132, .external_lex_state = 2},
  [817] = {.lex_state = 132, .external_lex_state = 2},
  [818] = {.lex_state = 132, .external_lex_state = 2},
  [819] = {.lex_state = 132, .external_lex_state = 2},
  [820] = {.lex_state = 132, .external_lex_state = 2},
  [821] = {.lex_state = 132, .external_lex_state = 2},
  [822] = {.lex_state = 132, .external_lex_state = 2},
  [823] = {.lex_state = 132, .external_lex_state = 2},
  [824] = {.lex_state = 132, .external_lex_state = 2},
  [825] = {.lex_state = 132, .external_lex_state = 2},
  [826] = {.lex_state = 132, .external_lex_state = 2},
  [827] = {.lex_state = 132, .external_lex_state = 2},
  [828] = {.lex_state = 132, .external_lex_state = 2},
  [829] = {.lex_state = 132, .external_lex_state = 2},
  [830] = {.lex_state = 132, .external_lex_state = 2},
  [831] = {.lex_state = 132, .external_lex_state = 2},
  [832] = {.lex_state = 132, .external_lex_state = 2},
  [833] = {.lex_state = 132, .external_lex_state = 2},
  [834] = {.lex_state = 132, .external_lex_state = 2},
  [835] = {.lex_state = 132, .external_lex_state = 2},
  [836] = {.lex_state = 132, .external_lex_state = 2},
  [837] = {.lex_state = 132, .external_lex_state = 2},
  [838] = {.lex_state = 132, .external_lex_state = 2},
  [839] = {.lex_state = 132, .external_lex_state = 2},
  [840] = {.lex_state = 132, .external_lex_state = 2},
  [841] = {.lex_state = 132, .external_lex_state = 2},
  [842] = {.lex_state = 132, .external_lex_state = 2},
  [843] = {.lex_state = 132, .external_lex_state = 2},
  [844] = {.lex_state = 132, .external_lex_state = 2},
  [845] = {.lex_state = 132, .external_lex_state = 2},
  [846] = {.lex_state = 132, .external_lex_state = 2},
  [847] = {.lex_state = 132, .external_lex_state = 2},
  [848] = {.lex_state = 132, .external_lex_state = 2},
  [849] = {.lex_state = 132, .external_lex_state = 2},
  [850] = {.lex_state = 132, .external_lex_state = 2},
  [851] = {.lex_state = 132, .external_lex_state = 2},
  [852] = {.lex_state = 132, .external_lex_state = 2},
  [853] = {.lex_state = 132, .external_lex_state = 2},
  [854] = {.lex_state = 132, .external_lex_state = 2},
  [855] = {.lex_state = 132, .external_lex_state = 2},
  [856] = {.lex_state = 132, .external_lex_state = 2},
  [857] = {.lex_state = 132, .external_lex_state = 2},
  [858] = {.lex_state = 132, .external_lex_state = 2},
  [859] = {.lex_state = 132, .external_lex_state = 2},
  [860] = {.lex_state = 132, .external_lex_state = 2},
  [861] = {.lex_state = 132, .external_lex_state = 2},
  [862] = {.lex_state = 132, .external_lex_state = 2},
  [863] = {.lex_state = 132, .external_lex_state = 2},
  [864] = {.lex_state = 132, .external_lex_state = 2},
  [865] = {.lex_state = 132, .external_lex_state = 2},
  [866] = {.lex_state = 132, .external_lex_state = 2},
  [867] = {.lex_state = 132, .external_lex_state = 2},
  [868] = {.lex_state = 132, .external_lex_state = 2},
  [869] = {.lex_state = 132, .external_lex_state = 2},
  [870] = {.lex_state = 132, .external_lex_state = 2},
  [871] = {.lex_state = 132, .external_lex_state = 2},
  [872] = {.lex_state = 132, .external_lex_state = 2},
  [873] = {.lex_state = 132, .external_lex_state = 2},
  [874] = {.lex_state = 132, .external_lex_state = 2},
  [875] = {.lex_state = 132, .external_lex_state = 2},
  [876] = {.lex_state = 132, .external_lex_state = 2},
  [877] = {.lex_state = 132, .external_lex_state = 2},
  [878] = {.lex_state = 132, .external_lex_state = 2},
  [879] = {.lex_state = 132, .external_lex_state = 2},
  [880] = {.lex_state = 132, .external_lex_state = 2},
  [881] = {.lex_state = 132, .external_lex_state = 2},
  [882] = {.lex_state = 132, .external_lex_state = 2},
  [883] = {.lex_state = 132, .external_lex_state = 2},
  [884] = {.lex_state = 132, .external_lex_state = 2},
  [885] = {.lex_state = 132, .external_lex_state = 2},
  [886] = {.lex_state = 132, .external_lex_state = 2},
  [887] = {.lex_state = 132, .external_lex_state = 2},
  [888] = {.lex_state = 132, .external_lex_state = 2},
  [889] = {.lex_state = 132, .external_lex_state = 2},
  [890] = {.lex_state = 132, .external_lex_state = 2},
  [891] = {.lex_state = 132, .external_lex_state = 2},
  [892] = {.lex_state = 132, .external_lex_state = 2},
  [893] = {.lex_state = 132, .external_lex_state = 2},
  [894] = {.lex_state = 132, .external_lex_state = 2},
  [895] = {.lex_state = 132, .external_lex_state = 2},
  [896] = {.lex_state = 132, .external_lex_state = 2},
  [897] = {.lex_state = 132, .external_lex_state = 2},
  [898] = {.lex_state = 132, .external_lex_state = 2},
  [899] = {.lex_state = 132, .external_lex_state = 2},
  [900] = {.lex_state = 132, .external_lex_state = 2},
  [901] = {.lex_state = 132, .external_lex_state = 2},
  [902] = {.lex_state = 132, .external_lex_state = 2},
  [903] = {.lex_state = 132, .external_lex_state = 2},
  [904] = {.lex_state = 132, .external_lex_state = 2},
  [905] = {.lex_state = 132, .external_lex_state = 2},
  [906] = {.lex_state = 132, .external_lex_state = 2},
  [907] = {.lex_state = 132, .external_lex_state = 2},
  [908] = {.lex_state = 132, .external_lex_state = 2},
  [909] = {.lex_state = 132, .external_lex_state = 2},
  [910] = {.lex_state = 132, .external_lex_state = 2},
  [911] = {.lex_state = 132, .external_lex_state = 2},
  [912] = {.lex_state = 132, .external_lex_state = 2},
  [913] = {.lex_state = 132, .external_lex_state = 2},
  [914] = {.lex_state = 132, .external_lex_state = 2},
  [915] = {.lex_state = 132, .external_lex_state = 2},
  [916] = {.lex_state = 132, .external_lex_state = 2},
  [917] = {.lex_state = 132, .external_lex_state = 2},
  [918] = {.lex_state = 132, .external_lex_state = 2},
  [919] = {.lex_state = 132, .external_lex_state = 2},
  [920] = {.lex_state = 132, .external_lex_state = 2},
  [921] = {.lex_state = 132, .external_lex_state = 2},
  [922] = {.lex_state = 132, .external_lex_state = 2},
  [923] = {.lex_state = 132, .external_lex_state = 2},
  [924] = {.lex_state = 132, .external_lex_state = 2},
  [925] = {.lex_state = 132, .external_lex_state = 2},
  [926] = {.lex_state = 132, .external_lex_state = 2},
  [927] = {.lex_state = 132, .external_lex_state = 2},
  [928] = {.lex_state = 132, .external_lex_state = 2},
  [929] = {.lex_state = 132, .external_lex_state = 2},
  [930] = {.lex_state = 132, .external_lex_state = 2},
  [931] = {.lex_state = 132, .external_lex_state = 2},
  [932] = {.lex_state = 132, .external_lex_state = 2},
  [933] = {.lex_state = 132, .external_lex_state = 2},
  [934] = {.lex_state = 132, .external_lex_state = 2},
  [935] = {.lex_state = 132, .external_lex_state = 2},
  [936] = {.lex_state = 132, .external_lex_state = 2},
  [937] = {.lex_state = 132, .external_lex_state = 2},
  [938] = {.lex_state = 132, .external_lex_state = 2},
  [939] = {.lex_state = 132, .external_lex_state = 2},
  [940] = {.lex_state = 132, .external_lex_state = 2},
  [941] = {.lex_state = 132, .external_lex_state = 2},
  [942] = {.lex_state = 132, .external_lex_state = 2},
  [943] = {.lex_state = 132, .external_lex_state = 2},
  [944] = {.lex_state = 132, .external_lex_state = 2},
  [945] = {.lex_state = 132, .external_lex_state = 2},
  [946] = {.lex_state = 132, .external_lex_state = 2},
  [947] = {.lex_state = 132, .external_lex_state = 2},
  [948] = {.lex_state = 132, .external_lex_state = 2},
  [949] = {.lex_state = 132, .external_lex_state = 2},
  [950] = {.lex_state = 132, .external_lex_state = 2},
  [951] = {.lex_state = 132, .external_lex_state = 2},
  [952] = {.lex_state = 132, .external_lex_state = 2},
  [953] = {.lex_state = 132, .external_lex_state = 2},
  [954] = {.lex_state = 132, .external_lex_state = 2},
  [955] = {.lex_state = 132, .external_lex_state = 2},
  [956] = {.lex_state = 132, .external_lex_state = 2},
  [957] = {.lex_state = 132, .external_lex_state = 2},
  [958] = {.lex_state = 132, .external_lex_state = 2},
  [959] = {.lex_state = 132, .external_lex_state = 2},
  [960] = {.lex_state = 132, .external_lex_state = 2},
  [961] = {.lex_state = 132, .external_lex_state = 2},
  [962] = {.lex_state = 132, .external_lex_state = 2},
  [963] = {.lex_state = 132, .external_lex_state = 2},
  [964] = {.lex_state = 132, .external_lex_state = 2},
  [965] = {.lex_state = 132, .external_lex_state = 2},
  [966] = {.lex_state = 132, .external_lex_state = 2},
  [967] = {.lex_state = 132, .external_lex_state = 2},
  [968] = {.lex_state = 132, .external_lex_state = 2},
  [969] = {.lex_state = 132, .external_lex_state = 2},
  [970] = {.lex_state = 132, .external_lex_state = 2},
  [971] = {.lex_state = 132, .external_lex_state = 2},
  [972] = {.lex_state = 132, .external_lex_state = 2},
  [973] = {.lex_state = 132, .external_lex_state = 2},
  [974] = {.lex_state = 132, .external_lex_state = 2},
  [975] = {.lex_state = 132, .external_lex_state = 2},
  [976] = {.lex_state = 132, .external_lex_state = 2},
  [977] = {.lex_state = 132, .external_lex_state = 2},
  [978] = {.lex_state = 132, .external_lex_state = 2},
  [979] = {.lex_state = 132, .external_lex_state = 2},
  [980] = {.lex_state = 132, .external_lex_state = 2},
  [981] = {.lex_state = 132, .external_lex_state = 2},
  [982] = {.lex_state = 132, .external_lex_state = 2},
  [983] = {.lex_state = 132, .external_lex_state = 2},
  [984] = {.lex_state = 132, .external_lex_state = 2},
  [985] = {.lex_state = 132, .external_lex_state = 2},
  [986] = {.lex_state = 132, .external_lex_state = 2},
  [987] = {.lex_state = 132, .external_lex_state = 2},
  [988] = {.lex_state = 132, .external_lex_state = 2},
  [989] = {.lex_state = 132, .external_lex_state = 2},
  [990] = {.lex_state = 132, .external_lex_state = 2},
  [991] = {.lex_state = 132, .external_lex_state = 2},
  [992] = {.lex_state = 132, .external_lex_state = 2},
  [993] = {.lex_state = 132, .external_lex_state = 2},
  [994] = {.lex_state = 132, .external_lex_state = 2},
  [995] = {.lex_state = 132, .external_lex_state = 2},
  [996] = {.lex_state = 132, .external_lex_state = 2},
  [997] = {.lex_state = 132, .external_lex_state = 2},
  [998] = {.lex_state = 132, .external_lex_state = 2},
  [999] = {.lex_state = 132, .external_lex_state = 2},
  [1000] = {.lex_state = 132, .external_lex_state = 2},
  [1001] = {.lex_state = 132, .external_lex_state = 2},
  [1002] = {.lex_state = 132, .external_lex_state = 2},
  [1003] = {.lex_state = 132, .external_lex_state = 2},
  [1004] = {.lex_state = 132, .external_lex_state = 2},
  [1005] = {.lex_state = 132, .external_lex_state = 2},
  [1006] = {.lex_state = 132, .external_lex_state = 2},
  [1007] = {.lex_state = 132, .external_lex_state = 2},
  [1008] = {.lex_state = 132, .external_lex_state = 2},
  [1009] = {.lex_state = 132, .external_lex_state = 2},
  [1010] = {.lex_state = 132, .external_lex_state = 2},
  [1011] = {.lex_state = 132, .external_lex_state = 2},
  [1012] = {.lex_state = 132, .external_lex_state = 2},
  [1013] = {.lex_state = 132, .external_lex_state = 2},
  [1014] = {.lex_state = 132, .external_lex_state = 2},
  [1015] = {.lex_state = 132, .external_lex_state = 2},
  [1016] = {.lex_state = 132, .external_lex_state = 2},
  [1017] = {.lex_state = 132, .external_lex_state = 2},
  [1018] = {.lex_state = 132, .external_lex_state = 2},
  [1019] = {.lex_state = 132, .external_lex_state = 2},
  [1020] = {.lex_state = 132, .external_lex_state = 2},
  [1021] = {.lex_state = 132, .external_lex_state = 2},
  [1022] = {.lex_state = 132, .external_lex_state = 2},
  [1023] = {.lex_state = 132, .external_lex_state = 2},
  [1024] = {.lex_state = 132, .external_lex_state = 2},
  [1025] = {.lex_state = 132, .external_lex_state = 2},
  [1026] = {.lex_state = 132, .external_lex_state = 2},
  [1027] = {.lex_state = 132, .external_lex_state = 2},
  [1028] = {.lex_state = 132, .external_lex_state = 2},
  [1029] = {.lex_state = 132, .external_lex_state = 2},
  [1030] = {.lex_state = 132, .external_lex_state = 2},
  [1031] = {.lex_state = 132, .external_lex_state = 2},
  [1032] = {.lex_state = 132, .external_lex_state = 2},
  [1033] = {.lex_state = 132, .external_lex_state = 2},
  [1034] = {.lex_state = 132, .external_lex_state = 2},
  [1035] = {.lex_state = 132, .external_lex_state = 2},
  [1036] = {.lex_state = 132, .external_lex_state = 2},
  [1037] = {.lex_state = 132, .external_lex_state = 2},
  [1038] = {.lex_state = 132, .external_lex_state = 2},
  [1039] = {.lex_state = 132, .external_lex_state = 2},
  [1040] = {.lex_state = 132, .external_lex_state = 2},
  [1041] = {.lex_state = 132, .external_lex_state = 2},
  [1042] = {.lex_state = 132, .external_lex_state = 2},
  [1043] = {.lex_state = 132, .external_lex_state = 2},
  [1044] = {.lex_state = 132, .external_lex_state = 2},
  [1045] = {.lex_state = 132, .external_lex_state = 2},
  [1046] = {.lex_state = 132, .external_lex_state = 2},
  [1047] = {.lex_state = 132, .external_lex_state = 2},
  [1048] = {.lex_state = 132, .external_lex_state = 2},
  [1049] = {.lex_state = 132, .external_lex_state = 2},
  [1050] = {.lex_state = 132, .external_lex_state = 2},
  [1051] = {.lex_state = 132, .external_lex_state = 2},
  [1052] = {.lex_state = 132, .external_lex_state = 2},
  [1053] = {.lex_state = 132, .external_lex_state = 2},
  [1054] = {.lex_state = 132, .external_lex_state = 2},
  [1055] = {.lex_state = 132, .external_lex_state = 2},
  [1056] = {.lex_state = 132, .external_lex_state = 2},
  [1057] = {.lex_state = 132, .external_lex_state = 2},
  [1058] = {.lex_state = 132, .external_lex_state = 2},
  [1059] = {.lex_state = 132, .external_lex_state = 2},
  [1060] = {.lex_state = 132, .external_lex_state = 2},
  [1061] = {.lex_state = 132, .external_lex_state = 2},
  [1062] = {.lex_state = 132, .external_lex_state = 2},
  [1063] = {.lex_state = 132, .external_lex_state = 2},
  [1064] = {.lex_state = 132, .external_lex_state = 2},
  [1065] = {.lex_state = 132, .external_lex_state = 2},
  [1066] = {.lex_state = 132, .external_lex_state = 2},
  [1067] = {.lex_state = 132, .external_lex_state = 2},
  [1068] = {.lex_state = 132, .external_lex_state = 2},
  [1069] = {.lex_state = 132, .external_lex_state = 2},
  [1070] = {.lex_state = 132, .external_lex_state = 2},
  [1071] = {.lex_state = 132, .external_lex_state = 2},
  [1072] = {.lex_state = 132, .external_lex_state = 2},
  [1073] = {.lex_state = 132, .external_lex_state = 2},
  [1074] = {.lex_state = 132, .external_lex_state = 2},
  [1075] = {.lex_state = 132, .external_lex_state = 2},
  [1076] = {.lex_state = 132, .external_lex_state = 2},
  [1077] = {.lex_state = 132, .external_lex_state = 2},
  [1078] = {.lex_state = 132, .external_lex_state = 2},
  [1079] = {.lex_state = 132, .external_lex_state = 2},
  [1080] = {.lex_state = 132, .external_lex_state = 2},
  [1081] = {.lex_state = 132, .external_lex_state = 2},
  [1082] = {.lex_state = 132, .external_lex_state = 2},
  [1083] = {.lex_state = 132, .external_lex_state = 2},
  [1084] = {.lex_state = 132, .external_lex_state = 2},
  [1085] = {.lex_state = 132, .external_lex_state = 2},
  [1086] = {.lex_state = 132, .external_lex_state = 2},
  [1087] = {.lex_state = 132, .external_lex_state = 2},
  [1088] = {.lex_state = 132, .external_lex_state = 2},
  [1089] = {.lex_state = 132, .external_lex_state = 2},
  [1090] = {.lex_state = 132, .external_lex_state = 2},
  [1091] = {.lex_state = 132, .external_lex_state = 2},
  [1092] = {.lex_state = 132, .external_lex_state = 2},
  [1093] = {.lex_state = 132, .external_lex_state = 2},
  [1094] = {.lex_state = 132, .external_lex_state = 2},
  [1095] = {.lex_state = 132, .external_lex_state = 2},
  [1096] = {.lex_state = 132, .external_lex_state = 2},
  [1097] = {.lex_state = 132, .external_lex_state = 2},
  [1098] = {.lex_state = 132, .external_lex_state = 2},
  [1099] = {.lex_state = 132, .external_lex_state = 2},
  [1100] = {.lex_state = 132, .external_lex_state = 2},
  [1101] = {.lex_state = 132, .external_lex_state = 2},
  [1102] = {.lex_state = 132, .external_lex_state = 2},
  [1103] = {.lex_state = 132, .external_lex_state = 2},
  [1104] = {.lex_state = 132, .external_lex_state = 2},
  [1105] = {.lex_state = 132, .external_lex_state = 2},
  [1106] = {.lex_state = 132, .external_lex_state = 2},
  [1107] = {.lex_state = 132, .external_lex_state = 2},
  [1108] = {.lex_state = 132, .external_lex_state = 2},
  [1109] = {.lex_state = 132, .external_lex_state = 2},
  [1110] = {.lex_state = 132, .external_lex_state = 2},
  [1111] = {.lex_state = 132, .external_lex_state = 2},
  [1112] = {.lex_state = 132, .external_lex_state = 2},
  [1113] = {.lex_state = 132, .external_lex_state = 2},
  [1114] = {.lex_state = 132, .external_lex_state = 2},
  [1115] = {.lex_state = 132, .external_lex_state = 2},
  [1116] = {.lex_state = 132, .external_lex_state = 2},
  [1117] = {.lex_state = 132, .external_lex_state = 2},
  [1118] = {.lex_state = 132, .external_lex_state = 2},
  [1119] = {.lex_state = 132, .external_lex_state = 2},
  [1120] = {.lex_state = 132, .external_lex_state = 2},
  [1121] = {.lex_state = 132, .external_lex_state = 2},
  [1122] = {.lex_state = 132, .external_lex_state = 2},
  [1123] = {.lex_state = 132, .external_lex_state = 2},
  [1124] = {.lex_state = 132, .external_lex_state = 2},
  [1125] = {.lex_state = 132, .external_lex_state = 2},
  [1126] = {.lex_state = 132, .external_lex_state = 2},
  [1127] = {.lex_state = 132, .external_lex_state = 2},
  [1128] = {.lex_state = 132, .external_lex_state = 2},
  [1129] = {.lex_state = 132, .external_lex_state = 2},
  [1130] = {.lex_state = 132, .external_lex_state = 2},
  [1131] = {.lex_state = 132, .external_lex_state = 2},
  [1132] = {.lex_state = 132, .external_lex_state = 2},
  [1133] = {.lex_state = 132, .external_lex_state = 2},
  [1134] = {.lex_state = 132, .external_lex_state = 2},
  [1135] = {.lex_state = 132, .external_lex_state = 2},
  [1136] = {.lex_state = 132, .external_lex_state = 2},
  [1137] = {.lex_state = 132, .external_lex_state = 2},
  [1138] = {.lex_state = 132, .external_lex_state = 2},
  [1139] = {.lex_state = 132, .external_lex_state = 2},
  [1140] = {.lex_state = 132, .external_lex_state = 2},
  [1141] = {.lex_state = 132, .external_lex_state = 2},
  [1142] = {.lex_state = 132, .external_lex_state = 2},
  [1143] = {.lex_state = 132, .external_lex_state = 2},
  [1144] = {.lex_state = 132, .external_lex_state = 2},
  [1145] = {.lex_state = 132, .external_lex_state = 2},
  [1146] = {.lex_state = 132, .external_lex_state = 2},
  [1147] = {.lex_state = 132, .external_lex_state = 2},
  [1148] = {.lex_state = 132, .external_lex_state = 2},
  [1149] = {.lex_state = 132, .external_lex_state = 2},
  [1150] = {.lex_state = 132, .external_lex_state = 2},
  [1151] = {.lex_state = 132, .external_lex_state = 2},
  [1152] = {.lex_state = 132, .external_lex_state = 2},
  [1153] = {.lex_state = 132, .external_lex_state = 2},
  [1154] = {.lex_state = 132, .external_lex_state = 2},
  [1155] = {.lex_state = 132, .external_lex_state = 2},
  [1156] = {.lex_state = 132, .external_lex_state = 2},
  [1157] = {.lex_state = 132, .external_lex_state = 2},
  [1158] = {.lex_state = 132, .external_lex_state = 2},
  [1159] = {.lex_state = 132, .external_lex_state = 2},
  [1160] = {.lex_state = 132, .external_lex_state = 2},
  [1161] = {.lex_state = 132, .external_lex_state = 2},
  [1162] = {.lex_state = 132, .external_lex_state = 2},
  [1163] = {.lex_state = 132, .external_lex_state = 2},
  [1164] = {.lex_state = 132, .external_lex_state = 2},
  [1165] = {.lex_state = 132, .external_lex_state = 2},
  [1166] = {.lex_state = 132, .external_lex_state = 2},
  [1167] = {.lex_state = 132, .external_lex_state = 2},
  [1168] = {.lex_state = 132, .external_lex_state = 2},
  [1169] = {.lex_state = 132, .external_lex_state = 2},
  [1170] = {.lex_state = 132, .external_lex_state = 2},
  [1171] = {.lex_state = 132, .external_lex_state = 2},
  [1172] = {.lex_state = 132, .external_lex_state = 2},
  [1173] = {.lex_state = 132, .external_lex_state = 2},
  [1174] = {.lex_state = 132, .external_lex_state = 2},
  [1175] = {.lex_state = 132, .external_lex_state = 2},
  [1176] = {.lex_state = 132, .external_lex_state = 2},
  [1177] = {.lex_state = 132, .external_lex_state = 2},
  [1178] = {.lex_state = 132, .external_lex_state = 2},
  [1179] = {.lex_state = 132, .external_lex_state = 2},
  [1180] = {.lex_state = 132, .external_lex_state = 2},
  [1181] = {.lex_state = 132, .external_lex_state = 2},
  [1182] = {.lex_state = 132, .external_lex_state = 2},
  [1183] = {.lex_state = 132, .external_lex_state = 2},
  [1184] = {.lex_state = 132, .external_lex_state = 2},
  [1185] = {.lex_state = 132, .external_lex_state = 2},
  [1186] = {.lex_state = 132, .external_lex_state = 2},
  [1187] = {.lex_state = 132, .external_lex_state = 2},
  [1188] = {.lex_state = 132, .external_lex_state = 2},
  [1189] = {.lex_state = 132, .external_lex_state = 2},
  [1190] = {.lex_state = 132, .external_lex_state = 2},
  [1191] = {.lex_state = 132, .external_lex_state = 2},
  [1192] = {.lex_state = 132, .external_lex_state = 2},
  [1193] = {.lex_state = 132, .external_lex_state = 2},
  [1194] = {.lex_state = 132, .external_lex_state = 2},
  [1195] = {.lex_state = 132, .external_lex_state = 2},
  [1196] = {.lex_state = 132, .external_lex_state = 2},
  [1197] = {.lex_state = 132, .external_lex_state = 2},
  [1198] = {.lex_state = 132, .external_lex_state = 2},
  [1199] = {.lex_state = 132, .external_lex_state = 2},
  [1200] = {.lex_state = 132, .external_lex_state = 2},
  [1201] = {.lex_state = 132, .external_lex_state = 2},
  [1202] = {.lex_state = 132, .external_lex_state = 2},
  [1203] = {.lex_state = 132, .external_lex_state = 2},
  [1204] = {.lex_state = 132, .external_lex_state = 2},
  [1205] = {.lex_state = 132, .external_lex_state = 2},
  [1206] = {.lex_state = 132, .external_lex_state = 2},
  [1207] = {.lex_state = 132, .external_lex_state = 2},
  [1208] = {.lex_state = 132, .external_lex_state = 2},
  [1209] = {.lex_state = 132, .external_lex_state = 2},
  [1210] = {.lex_state = 132, .external_lex_state = 2},
  [1211] = {.lex_state = 132, .external_lex_state = 2},
  [1212] = {.lex_state = 132, .external_lex_state = 2},
  [1213] = {.lex_state = 132, .external_lex_state = 2},
  [1214] = {.lex_state = 132, .external_lex_state = 2},
  [1215] = {.lex_state = 132, .external_lex_state = 2},
  [1216] = {.lex_state = 132, .external_lex_state = 2},
  [1217] = {.lex_state = 132, .external_lex_state = 2},
  [1218] = {.lex_state = 132, .external_lex_state = 2},
  [1219] = {.lex_state = 132, .external_lex_state = 2},
  [1220] = {.lex_state = 132, .external_lex_state = 2},
  [1221] = {.lex_state = 132, .external_lex_state = 2},
  [1222] = {.lex_state = 132, .external_lex_state = 2},
  [1223] = {.lex_state = 132, .external_lex_state = 2},
  [1224] = {.lex_state = 132, .external_lex_state = 2},
  [1225] = {.lex_state = 132, .external_lex_state = 2},
  [1226] = {.lex_state = 132, .external_lex_state = 2},
  [1227] = {.lex_state = 132, .external_lex_state = 2},
  [1228] = {.lex_state = 132, .external_lex_state = 2},
  [1229] = {.lex_state = 132, .external_lex_state = 2},
  [1230] = {.lex_state = 132, .external_lex_state = 2},
  [1231] = {.lex_state = 132, .external_lex_state = 2},
  [1232] = {.lex_state = 132, .external_lex_state = 2},
  [1233] = {.lex_state = 132, .external_lex_state = 2},
  [1234] = {.lex_state = 132, .external_lex_state = 2},
  [1235] = {.lex_state = 132, .external_lex_state = 2},
  [1236] = {.lex_state = 132, .external_lex_state = 2},
  [1237] = {.lex_state = 132, .external_lex_state = 2},
  [1238] = {.lex_state = 132, .external_lex_state = 2},
  [1239] = {.lex_state = 132, .external_lex_state = 2},
  [1240] = {.lex_state = 132, .external_lex_state = 2},
  [1241] = {.lex_state = 132, .external_lex_state = 2},
  [1242] = {.lex_state = 132, .external_lex_state = 2},
  [1243] = {.lex_state = 132, .external_lex_state = 2},
  [1244] = {.lex_state = 132, .external_lex_state = 2},
  [1245] = {.lex_state = 132, .external_lex_state = 2},
  [1246] = {.lex_state = 132, .external_lex_state = 2},
  [1247] = {.lex_state = 132, .external_lex_state = 2},
  [1248] = {.lex_state = 132, .external_lex_state = 2},
  [1249] = {.lex_state = 132, .external_lex_state = 2},
  [1250] = {.lex_state = 132, .external_lex_state = 2},
  [1251] = {.lex_state = 132, .external_lex_state = 2},
  [1252] = {.lex_state = 132, .external_lex_state = 2},
  [1253] = {.lex_state = 132, .external_lex_state = 2},
  [1254] = {.lex_state = 132, .external_lex_state = 2},
  [1255] = {.lex_state = 132, .external_lex_state = 2},
  [1256] = {.lex_state = 132, .external_lex_state = 2},
  [1257] = {.lex_state = 132, .external_lex_state = 2},
  [1258] = {.lex_state = 132, .external_lex_state = 2},
  [1259] = {.lex_state = 132, .external_lex_state = 2},
  [1260] = {.lex_state = 132, .external_lex_state = 2},
  [1261] = {.lex_state = 132, .external_lex_state = 2},
  [1262] = {.lex_state = 132, .external_lex_state = 2},
  [1263] = {.lex_state = 132, .external_lex_state = 2},
  [1264] = {.lex_state = 132, .external_lex_state = 2},
  [1265] = {.lex_state = 132, .external_lex_state = 2},
  [1266] = {.lex_state = 132, .external_lex_state = 2},
  [1267] = {.lex_state = 132, .external_lex_state = 2},
  [1268] = {.lex_state = 132, .external_lex_state = 2},
  [1269] = {.lex_state = 132, .external_lex_state = 2},
  [1270] = {.lex_state = 132, .external_lex_state = 2},
  [1271] = {.lex_state = 132, .external_lex_state = 2},
  [1272] = {.lex_state = 132, .external_lex_state = 2},
  [1273] = {.lex_state = 132, .external_lex_state = 2},
  [1274] = {.lex_state = 132, .external_lex_state = 2},
  [1275] = {.lex_state = 132, .external_lex_state = 2},
  [1276] = {.lex_state = 132, .external_lex_state = 2},
  [1277] = {.lex_state = 132, .external_lex_state = 2},
  [1278] = {.lex_state = 132, .external_lex_state = 2},
  [1279] = {.lex_state = 132, .external_lex_state = 2},
  [1280] = {.lex_state = 132, .external_lex_state = 2},
  [1281] = {.lex_state = 132, .external_lex_state = 2},
  [1282] = {.lex_state = 132, .external_lex_state = 2},
  [1283] = {.lex_state = 132, .external_lex_state = 2},
  [1284] = {.lex_state = 132, .external_lex_state = 2},
  [1285] = {.lex_state = 132, .external_lex_state = 2},
  [1286] = {.lex_state = 132, .external_lex_state = 2},
  [1287] = {.lex_state = 132, .external_lex_state = 2},
  [1288] = {.lex_state = 132, .external_lex_state = 2},
  [1289] = {.lex_state = 132, .external_lex_state = 2},
  [1290] = {.lex_state = 132, .external_lex_state = 2},
  [1291] = {.lex_state = 132, .external_lex_state = 2},
  [1292] = {.lex_state = 132, .external_lex_state = 2},
  [1293] = {.lex_state = 132, .external_lex_state = 2},
  [1294] = {.lex_state = 132, .external_lex_state = 2},
  [1295] = {.lex_state = 132, .external_lex_state = 2},
  [1296] = {.lex_state = 132, .external_lex_state = 2},
  [1297] = {.lex_state = 132, .external_lex_state = 2},
  [1298] = {.lex_state = 132, .external_lex_state = 2},
  [1299] = {.lex_state = 132, .external_lex_state = 2},
  [1300] = {.lex_state = 132, .external_lex_state = 2},
  [1301] = {.lex_state = 132, .external_lex_state = 2},
  [1302] = {.lex_state = 132, .external_lex_state = 2},
  [1303] = {.lex_state = 132, .external_lex_state = 2},
  [1304] = {.lex_state = 132, .external_lex_state = 2},
  [1305] = {.lex_state = 132, .external_lex_state = 2},
  [1306] = {.lex_state = 132, .external_lex_state = 2},
  [1307] = {.lex_state = 132, .external_lex_state = 2},
  [1308] = {.lex_state = 132, .external_lex_state = 2},
  [1309] = {.lex_state = 132, .external_lex_state = 2},
  [1310] = {.lex_state = 132, .external_lex_state = 2},
  [1311] = {.lex_state = 132, .external_lex_state = 2},
  [1312] = {.lex_state = 132, .external_lex_state = 2},
  [1313] = {.lex_state = 132, .external_lex_state = 2},
  [1314] = {.lex_state = 132, .external_lex_state = 2},
  [1315] = {.lex_state = 132, .external_lex_state = 2},
  [1316] = {.lex_state = 132, .external_lex_state = 2},
  [1317] = {.lex_state = 132, .external_lex_state = 2},
  [1318] = {.lex_state = 132, .external_lex_state = 2},
  [1319] = {.lex_state = 132, .external_lex_state = 2},
  [1320] = {.lex_state = 132, .external_lex_state = 2},
  [1321] = {.lex_state = 132, .external_lex_state = 2},
  [1322] = {.lex_state = 132, .external_lex_state = 2},
  [1323] = {.lex_state = 132, .external_lex_state = 2},
  [1324] = {.lex_state = 132, .external_lex_state = 2},
  [1325] = {.lex_state = 132, .external_lex_state = 2},
  [1326] = {.lex_state = 132, .external_lex_state = 2},
  [1327] = {.lex_state = 132, .external_lex_state = 2},
  [1328] = {.lex_state = 132, .external_lex_state = 2},
  [1329] = {.lex_state = 132, .external_lex_state = 2},
  [1330] = {.lex_state = 132, .external_lex_state = 2},
  [1331] = {.lex_state = 132, .external_lex_state = 2},
  [1332] = {.lex_state = 132, .external_lex_state = 2},
  [1333] = {.lex_state = 132, .external_lex_state = 2},
  [1334] = {.lex_state = 132, .external_lex_state = 2},
  [1335] = {.lex_state = 132, .external_lex_state = 2},
  [1336] = {.lex_state = 132, .external_lex_state = 2},
  [1337] = {.lex_state = 132, .external_lex_state = 2},
  [1338] = {.lex_state = 132, .external_lex_state = 2},
  [1339] = {.lex_state = 132, .external_lex_state = 2},
  [1340] = {.lex_state = 132, .external_lex_state = 2},
  [1341] = {.lex_state = 132, .external_lex_state = 2},
  [1342] = {.lex_state = 132, .external_lex_state = 2},
  [1343] = {.lex_state = 132, .external_lex_state = 2},
  [1344] = {.lex_state = 132, .external_lex_state = 2},
  [1345] = {.lex_state = 132, .external_lex_state = 2},
  [1346] = {.lex_state = 132, .external_lex_state = 2},
  [1347] = {.lex_state = 132, .external_lex_state = 2},
  [1348] = {.lex_state = 132, .external_lex_state = 2},
  [1349] = {.lex_state = 132, .external_lex_state = 2},
  [1350] = {.lex_state = 132, .external_lex_state = 2},
  [1351] = {.lex_state = 132, .external_lex_state = 2},
  [1352] = {.lex_state = 132, .external_lex_state = 2},
  [1353] = {.lex_state = 132, .external_lex_state = 2},
  [1354] = {.lex_state = 132, .external_lex_state = 2},
  [1355] = {.lex_state = 132, .external_lex_state = 2},
  [1356] = {.lex_state = 132, .external_lex_state = 2},
  [1357] = {.lex_state = 132, .external_lex_state = 2},
  [1358] = {.lex_state = 132, .external_lex_state = 2},
  [1359] = {.lex_state = 132, .external_lex_state = 2},
  [1360] = {.lex_state = 132, .external_lex_state = 2},
  [1361] = {.lex_state = 132, .external_lex_state = 2},
  [1362] = {.lex_state = 132, .external_lex_state = 2},
  [1363] = {.lex_state = 132, .external_lex_state = 2},
  [1364] = {.lex_state = 132, .external_lex_state = 2},
  [1365] = {.lex_state = 132, .external_lex_state = 2},
  [1366] = {.lex_state = 132, .external_lex_state = 2},
  [1367] = {.lex_state = 132, .external_lex_state = 2},
  [1368] = {.lex_state = 132, .external_lex_state = 2},
  [1369] = {.lex_state = 132, .external_lex_state = 2},
  [1370] = {.lex_state = 132, .external_lex_state = 2},
  [1371] = {.lex_state = 132, .external_lex_state = 2},
  [1372] = {.lex_state = 132, .external_lex_state = 2},
  [1373] = {.lex_state = 132, .external_lex_state = 2},
  [1374] = {.lex_state = 132, .external_lex_state = 2},
  [1375] = {.lex_state = 132, .external_lex_state = 2},
  [1376] = {.lex_state = 132, .external_lex_state = 2},
  [1377] = {.lex_state = 132, .external_lex_state = 2},
  [1378] = {.lex_state = 132, .external_lex_state = 2},
  [1379] = {.lex_state = 132, .external_lex_state = 2},
  [1380] = {.lex_state = 132, .external_lex_state = 2},
  [1381] = {.lex_state = 132, .external_lex_state = 2},
  [1382] = {.lex_state = 132, .external_lex_state = 2},
  [1383] = {.lex_state = 132, .external_lex_state = 2},
  [1384] = {.lex_state = 132, .external_lex_state = 2},
  [1385] = {.lex_state = 132, .external_lex_state = 2},
  [1386] = {.lex_state = 132, .external_lex_state = 2},
  [1387] = {.lex_state = 132, .external_lex_state = 2},
  [1388] = {.lex_state = 132, .external_lex_state = 2},
  [1389] = {.lex_state = 132, .external_lex_state = 2},
  [1390] = {.lex_state = 132, .external_lex_state = 2},
  [1391] = {.lex_state = 132, .external_lex_state = 2},
  [1392] = {.lex_state = 132, .external_lex_state = 2},
  [1393] = {.lex_state = 132, .external_lex_state = 2},
  [1394] = {.lex_state = 132, .external_lex_state = 2},
  [1395] = {.lex_state = 132, .external_lex_state = 2},
  [1396] = {.lex_state = 132, .external_lex_state = 2},
  [1397] = {.lex_state = 132, .external_lex_state = 2},
  [1398] = {.lex_state = 132, .external_lex_state = 2},
  [1399] = {.lex_state = 132, .external_lex_state = 2},
  [1400] = {.lex_state = 132, .external_lex_state = 2},
  [1401] = {.lex_state = 132, .external_lex_state = 2},
  [1402] = {.lex_state = 132, .external_lex_state = 2},
  [1403] = {.lex_state = 132, .external_lex_state = 2},
  [1404] = {.lex_state = 132, .external_lex_state = 2},
  [1405] = {.lex_state = 132, .external_lex_state = 2},
  [1406] = {.lex_state = 132, .external_lex_state = 2},
  [1407] = {.lex_state = 132, .external_lex_state = 2},
  [1408] = {.lex_state = 132, .external_lex_state = 2},
  [1409] = {.lex_state = 132, .external_lex_state = 2},
  [1410] = {.lex_state = 132, .external_lex_state = 2},
  [1411] = {.lex_state = 132, .external_lex_state = 2},
  [1412] = {.lex_state = 132, .external_lex_state = 2},
  [1413] = {.lex_state = 132, .external_lex_state = 2},
  [1414] = {.lex_state = 132, .external_lex_state = 2},
  [1415] = {.lex_state = 132, .external_lex_state = 2},
  [1416] = {.lex_state = 132, .external_lex_state = 2},
  [1417] = {.lex_state = 132, .external_lex_state = 2},
  [1418] = {.lex_state = 132, .external_lex_state = 2},
  [1419] = {.lex_state = 132, .external_lex_state = 2},
  [1420] = {.lex_state = 132, .external_lex_state = 2},
  [1421] = {.lex_state = 132, .external_lex_state = 2},
  [1422] = {.lex_state = 132, .external_lex_state = 2},
  [1423] = {.lex_state = 132, .external_lex_state = 2},
  [1424] = {.lex_state = 132, .external_lex_state = 2},
  [1425] = {.lex_state = 132, .external_lex_state = 2},
  [1426] = {.lex_state = 132, .external_lex_state = 2},
  [1427] = {.lex_state = 132, .external_lex_state = 2},
  [1428] = {.lex_state = 132, .external_lex_state = 2},
  [1429] = {.lex_state = 132, .external_lex_state = 2},
  [1430] = {.lex_state = 132, .external_lex_state = 2},
  [1431] = {.lex_state = 132, .external_lex_state = 2},
  [1432] = {.lex_state = 132, .external_lex_state = 2},
  [1433] = {.lex_state = 132, .external_lex_state = 2},
  [1434] = {.lex_state = 132, .external_lex_state = 2},
  [1435] = {.lex_state = 132, .external_lex_state = 2},
  [1436] = {.lex_state = 132, .external_lex_state = 2},
  [1437] = {.lex_state = 132, .external_lex_state = 2},
  [1438] = {.lex_state = 132, .external_lex_state = 2},
  [1439] = {.lex_state = 132, .external_lex_state = 2},
  [1440] = {.lex_state = 132, .external_lex_state = 2},
  [1441] = {.lex_state = 132, .external_lex_state = 2},
  [1442] = {.lex_state = 132, .external_lex_state = 2},
  [1443] = {.lex_state = 132, .external_lex_state = 2},
  [1444] = {.lex_state = 132, .external_lex_state = 2},
  [1445] = {.lex_state = 132, .external_lex_state = 2},
  [1446] = {.lex_state = 132, .external_lex_state = 2},
  [1447] = {.lex_state = 132, .external_lex_state = 2},
  [1448] = {.lex_state = 132, .external_lex_state = 2},
  [1449] = {.lex_state = 132, .external_lex_state = 2},
  [1450] = {.lex_state = 132, .external_lex_state = 2},
  [1451] = {.lex_state = 132, .external_lex_state = 2},
  [1452] = {.lex_state = 132, .external_lex_state = 2},
  [1453] = {.lex_state = 132, .external_lex_state = 2},
  [1454] = {.lex_state = 132, .external_lex_state = 2},
  [1455] = {.lex_state = 132, .external_lex_state = 2},
  [1456] = {.lex_state = 132, .external_lex_state = 2},
  [1457] = {.lex_state = 132, .external_lex_state = 2},
  [1458] = {.lex_state = 132, .external_lex_state = 2},
  [1459] = {.lex_state = 132, .external_lex_state = 2},
  [1460] = {.lex_state = 132, .external_lex_state = 2},
  [1461] = {.lex_state = 132, .external_lex_state = 2},
  [1462] = {.lex_state = 132, .external_lex_state = 2},
  [1463] = {.lex_state = 132, .external_lex_state = 2},
  [1464] = {.lex_state = 132, .external_lex_state = 2},
  [1465] = {.lex_state = 132, .external_lex_state = 2},
  [1466] = {.lex_state = 132, .external_lex_state = 2},
  [1467] = {.lex_state = 132, .external_lex_state = 2},
  [1468] = {.lex_state = 132, .external_lex_state = 2},
  [1469] = {.lex_state = 132, .external_lex_state = 2},
  [1470] = {.lex_state = 132, .external_lex_state = 2},
  [1471] = {.lex_state = 132, .external_lex_state = 2},
  [1472] = {.lex_state = 132, .external_lex_state = 2},
  [1473] = {.lex_state = 132, .external_lex_state = 2},
  [1474] = {.lex_state = 132, .external_lex_state = 2},
  [1475] = {.lex_state = 132, .external_lex_state = 2},
  [1476] = {.lex_state = 132, .external_lex_state = 2},
  [1477] = {.lex_state = 132, .external_lex_state = 2},
  [1478] = {.lex_state = 132, .external_lex_state = 2},
  [1479] = {.lex_state = 132, .external_lex_state = 2},
  [1480] = {.lex_state = 132, .external_lex_state = 2},
  [1481] = {.lex_state = 132, .external_lex_state = 2},
  [1482] = {.lex_state = 132, .external_lex_state = 2},
  [1483] = {.lex_state = 132, .external_lex_state = 2},
  [1484] = {.lex_state = 132, .external_lex_state = 2},
  [1485] = {.lex_state = 132, .external_lex_state = 2},
  [1486] = {.lex_state = 132, .external_lex_state = 2},
  [1487] = {.lex_state = 132, .external_lex_state = 2},
  [1488] = {.lex_state = 132, .external_lex_state = 2},
  [1489] = {.lex_state = 132, .external_lex_state = 2},
  [1490] = {.lex_state = 132, .external_lex_state = 2},
  [1491] = {.lex_state = 132, .external_lex_state = 2},
  [1492] = {.lex_state = 132, .external_lex_state = 2},
  [1493] = {.lex_state = 132, .external_lex_state = 2},
  [1494] = {.lex_state = 132, .external_lex_state = 2},
  [1495] = {.lex_state = 132, .external_lex_state = 2},
  [1496] = {.lex_state = 132, .external_lex_state = 2},
  [1497] = {.lex_state = 132, .external_lex_state = 2},
  [1498] = {.lex_state = 132, .external_lex_state = 2},
  [1499] = {.lex_state = 132, .external_lex_state = 2},
  [1500] = {.lex_state = 132, .external_lex_state = 2},
  [1501] = {.lex_state = 132, .external_lex_state = 2},
  [1502] = {.lex_state = 132, .external_lex_state = 2},
  [1503] = {.lex_state = 132, .external_lex_state = 2},
  [1504] = {.lex_state = 132, .external_lex_state = 2},
  [1505] = {.lex_state = 132, .external_lex_state = 2},
  [1506] = {.lex_state = 132, .external_lex_state = 2},
  [1507] = {.lex_state = 132, .external_lex_state = 2},
  [1508] = {.lex_state = 132, .external_lex_state = 2},
  [1509] = {.lex_state = 132, .external_lex_state = 2},
  [1510] = {.lex_state = 132, .external_lex_state = 2},
  [1511] = {.lex_state = 132, .external_lex_state = 2},
  [1512] = {.lex_state = 132, .external_lex_state = 2},
  [1513] = {.lex_state = 132, .external_lex_state = 2},
  [1514] = {.lex_state = 132, .external_lex_state = 2},
  [1515] = {.lex_state = 132, .external_lex_state = 2},
  [1516] = {.lex_state = 132, .external_lex_state = 2},
  [1517] = {.lex_state = 132, .external_lex_state = 2},
  [1518] = {.lex_state = 132, .external_lex_state = 2},
  [1519] = {.lex_state = 132, .external_lex_state = 2},
  [1520] = {.lex_state = 132, .external_lex_state = 2},
  [1521] = {.lex_state = 132, .external_lex_state = 2},
  [1522] = {.lex_state = 132, .external_lex_state = 2},
  [1523] = {.lex_state = 132, .external_lex_state = 2},
  [1524] = {.lex_state = 132, .external_lex_state = 2},
  [1525] = {.lex_state = 132, .external_lex_state = 2},
  [1526] = {.lex_state = 132, .external_lex_state = 2},
  [1527] = {.lex_state = 132, .external_lex_state = 2},
  [1528] = {.lex_state = 132, .external_lex_state = 2},
  [1529] = {.lex_state = 132, .external_lex_state = 2},
  [1530] = {.lex_state = 132, .external_lex_state = 2},
  [1531] = {.lex_state = 132, .external_lex_state = 2},
  [1532] = {.lex_state = 132, .external_lex_state = 2},
  [1533] = {.lex_state = 132, .external_lex_state = 2},
  [1534] = {.lex_state = 132, .external_lex_state = 2},
  [1535] = {.lex_state = 132, .external_lex_state = 2},
  [1536] = {.lex_state = 132, .external_lex_state = 2},
  [1537] = {.lex_state = 132, .external_lex_state = 2},
  [1538] = {.lex_state = 132, .external_lex_state = 2},
  [1539] = {.lex_state = 132, .external_lex_state = 2},
  [1540] = {.lex_state = 132, .external_lex_state = 2},
  [1541] = {.lex_state = 132, .external_lex_state = 2},
  [1542] = {.lex_state = 132, .external_lex_state = 2},
  [1543] = {.lex_state = 132, .external_lex_state = 2},
  [1544] = {.lex_state = 132, .external_lex_state = 2},
  [1545] = {.lex_state = 132, .external_lex_state = 2},
  [1546] = {.lex_state = 132, .external_lex_state = 2},
  [1547] = {.lex_state = 132, .external_lex_state = 2},
  [1548] = {.lex_state = 132, .external_lex_state = 2},
  [1549] = {.lex_state = 132, .external_lex_state = 2},
  [1550] = {.lex_state = 132, .external_lex_state = 2},
  [1551] = {.lex_state = 132, .external_lex_state = 2},
  [1552] = {.lex_state = 132, .external_lex_state = 2},
  [1553] = {.lex_state = 132, .external_lex_state = 2},
  [1554] = {.lex_state = 132, .external_lex_state = 2},
  [1555] = {.lex_state = 132, .external_lex_state = 2},
  [1556] = {.lex_state = 132, .external_lex_state = 2},
  [1557] = {.lex_state = 132, .external_lex_state = 2},
  [1558] = {.lex_state = 132, .external_lex_state = 2},
  [1559] = {.lex_state = 132, .external_lex_state = 2},
  [1560] = {.lex_state = 132, .external_lex_state = 2},
  [1561] = {.lex_state = 132, .external_lex_state = 2},
  [1562] = {.lex_state = 132, .external_lex_state = 2},
  [1563] = {.lex_state = 132, .external_lex_state = 2},
  [1564] = {.lex_state = 132, .external_lex_state = 2},
  [1565] = {.lex_state = 132, .external_lex_state = 2},
  [1566] = {.lex_state = 132, .external_lex_state = 2},
  [1567] = {.lex_state = 132, .external_lex_state = 2},
  [1568] = {.lex_state = 132, .external_lex_state = 2},
  [1569] = {.lex_state = 132, .external_lex_state = 2},
  [1570] = {.lex_state = 132, .external_lex_state = 2},
  [1571] = {.lex_state = 132, .external_lex_state = 2},
  [1572] = {.lex_state = 132, .external_lex_state = 2},
  [1573] = {.lex_state = 132, .external_lex_state = 2},
  [1574] = {.lex_state = 132, .external_lex_state = 2},
  [1575] = {.lex_state = 132, .external_lex_state = 2},
  [1576] = {.lex_state = 132, .external_lex_state = 2},
  [1577] = {.lex_state = 132, .external_lex_state = 2},
  [1578] = {.lex_state = 132, .external_lex_state = 2},
  [1579] = {.lex_state = 132, .external_lex_state = 2},
  [1580] = {.lex_state = 132, .external_lex_state = 2},
  [1581] = {.lex_state = 132, .external_lex_state = 2},
  [1582] = {.lex_state = 132, .external_lex_state = 2},
  [1583] = {.lex_state = 132, .external_lex_state = 2},
  [1584] = {.lex_state = 132, .external_lex_state = 2},
  [1585] = {.lex_state = 132, .external_lex_state = 2},
  [1586] = {.lex_state = 132, .external_lex_state = 2},
  [1587] = {.lex_state = 132, .external_lex_state = 2},
  [1588] = {.lex_state = 132, .external_lex_state = 2},
  [1589] = {.lex_state = 132, .external_lex_state = 2},
  [1590] = {.lex_state = 132, .external_lex_state = 2},
  [1591] = {.lex_state = 132, .external_lex_state = 2},
  [1592] = {.lex_state = 132, .external_lex_state = 2},
  [1593] = {.lex_state = 132, .external_lex_state = 2},
  [1594] = {.lex_state = 132, .external_lex_state = 2},
  [1595] = {.lex_state = 132, .external_lex_state = 2},
  [1596] = {.lex_state = 132, .external_lex_state = 2},
  [1597] = {.lex_state = 132, .external_lex_state = 2},
  [1598] = {.lex_state = 132, .external_lex_state = 2},
  [1599] = {.lex_state = 132, .external_lex_state = 2},
  [1600] = {.lex_state = 132, .external_lex_state = 2},
  [1601] = {.lex_state = 132, .external_lex_state = 2},
  [1602] = {.lex_state = 132, .external_lex_state = 2},
  [1603] = {.lex_state = 132, .external_lex_state = 2},
  [1604] = {.lex_state = 132, .external_lex_state = 2},
  [1605] = {.lex_state = 132, .external_lex_state = 2},
  [1606] = {.lex_state = 132, .external_lex_state = 2},
  [1607] = {.lex_state = 132, .external_lex_state = 2},
  [1608] = {.lex_state = 132, .external_lex_state = 2},
  [1609] = {.lex_state = 132, .external_lex_state = 2},
  [1610] = {.lex_state = 132, .external_lex_state = 2},
  [1611] = {.lex_state = 132, .external_lex_state = 2},
  [1612] = {.lex_state = 132, .external_lex_state = 2},
  [1613] = {.lex_state = 132, .external_lex_state = 2},
  [1614] = {.lex_state = 132, .external_lex_state = 2},
  [1615] = {.lex_state = 132, .external_lex_state = 2},
  [1616] = {.lex_state = 132, .external_lex_state = 2},
  [1617] = {.lex_state = 132, .external_lex_state = 2},
  [1618] = {.lex_state = 132, .external_lex_state = 2},
  [1619] = {.lex_state = 132, .external_lex_state = 2},
  [1620] = {.lex_state = 132, .external_lex_state = 2},
  [1621] = {.lex_state = 132, .external_lex_state = 2},
  [1622] = {.lex_state = 132, .external_lex_state = 2},
  [1623] = {.lex_state = 132, .external_lex_state = 2},
  [1624] = {.lex_state = 132, .external_lex_state = 2},
  [1625] = {.lex_state = 132, .external_lex_state = 2},
  [1626] = {.lex_state = 132, .external_lex_state = 2},
  [1627] = {.lex_state = 132, .external_lex_state = 2},
  [1628] = {.lex_state = 132, .external_lex_state = 2},
  [1629] = {.lex_state = 132, .external_lex_state = 2},
  [1630] = {.lex_state = 132, .external_lex_state = 2},
  [1631] = {.lex_state = 132, .external_lex_state = 2},
  [1632] = {.lex_state = 132, .external_lex_state = 2},
  [1633] = {.lex_state = 132, .external_lex_state = 2},
  [1634] = {.lex_state = 132, .external_lex_state = 2},
  [1635] = {.lex_state = 132, .external_lex_state = 2},
  [1636] = {.lex_state = 132, .external_lex_state = 2},
  [1637] = {.lex_state = 132, .external_lex_state = 2},
  [1638] = {.lex_state = 132, .external_lex_state = 2},
  [1639] = {.lex_state = 132, .external_lex_state = 2},
  [1640] = {.lex_state = 132, .external_lex_state = 2},
  [1641] = {.lex_state = 132, .external_lex_state = 2},
  [1642] = {.lex_state = 132, .external_lex_state = 2},
  [1643] = {.lex_state = 132, .external_lex_state = 2},
  [1644] = {.lex_state = 132, .external_lex_state = 2},
  [1645] = {.lex_state = 132, .external_lex_state = 2},
  [1646] = {.lex_state = 132, .external_lex_state = 2},
  [1647] = {.lex_state = 132, .external_lex_state = 2},
  [1648] = {.lex_state = 132, .external_lex_state = 2},
  [1649] = {.lex_state = 132, .external_lex_state = 2},
  [1650] = {.lex_state = 132, .external_lex_state = 2},
  [1651] = {.lex_state = 132, .external_lex_state = 2},
  [1652] = {.lex_state = 132, .external_lex_state = 2},
  [1653] = {.lex_state = 132, .external_lex_state = 2},
  [1654] = {.lex_state = 132, .external_lex_state = 2},
  [1655] = {.lex_state = 132, .external_lex_state = 2},
  [1656] = {.lex_state = 132, .external_lex_state = 2},
  [1657] = {.lex_state = 132, .external_lex_state = 2},
  [1658] = {.lex_state = 132, .external_lex_state = 2},
  [1659] = {.lex_state = 132, .external_lex_state = 2},
  [1660] = {.lex_state = 132, .external_lex_state = 2},
  [1661] = {.lex_state = 132, .external_lex_state = 2},
  [1662] = {.lex_state = 132, .external_lex_state = 2},
  [1663] = {.lex_state = 132, .external_lex_state = 2},
  [1664] = {.lex_state = 132, .external_lex_state = 2},
  [1665] = {.lex_state = 132, .external_lex_state = 2},
  [1666] = {.lex_state = 132, .external_lex_state = 2},
  [1667] = {.lex_state = 132, .external_lex_state = 2},
  [1668] = {.lex_state = 132, .external_lex_state = 2},
  [1669] = {.lex_state = 132, .external_lex_state = 2},
  [1670] = {.lex_state = 132, .external_lex_state = 2},
  [1671] = {.lex_state = 132, .external_lex_state = 2},
  [1672] = {.lex_state = 132, .external_lex_state = 2},
  [1673] = {.lex_state = 132, .external_lex_state = 2},
  [1674] = {.lex_state = 132, .external_lex_state = 2},
  [1675] = {.lex_state = 132, .external_lex_state = 2},
  [1676] = {.lex_state = 132, .external_lex_state = 2},
  [1677] = {.lex_state = 132, .external_lex_state = 2},
  [1678] = {.lex_state = 132, .external_lex_state = 2},
  [1679] = {.lex_state = 132, .external_lex_state = 2},
  [1680] = {.lex_state = 132, .external_lex_state = 2},
  [1681] = {.lex_state = 132, .external_lex_state = 2},
  [1682] = {.lex_state = 132, .external_lex_state = 2},
  [1683] = {.lex_state = 132, .external_lex_state = 2},
  [1684] = {.lex_state = 132, .external_lex_state = 2},
  [1685] = {.lex_state = 132, .external_lex_state = 2},
  [1686] = {.lex_state = 132, .external_lex_state = 2},
  [1687] = {.lex_state = 132, .external_lex_state = 2},
  [1688] = {.lex_state = 132, .external_lex_state = 2},
  [1689] = {.lex_state = 132, .external_lex_state = 2},
  [1690] = {.lex_state = 132, .external_lex_state = 2},
  [1691] = {.lex_state = 132, .external_lex_state = 2},
  [1692] = {.lex_state = 132, .external_lex_state = 2},
  [1693] = {.lex_state = 132, .external_lex_state = 2},
  [1694] = {.lex_state = 132, .external_lex_state = 2},
  [1695] = {.lex_state = 132, .external_lex_state = 2},
  [1696] = {.lex_state = 132, .external_lex_state = 2},
  [1697] = {.lex_state = 132, .external_lex_state = 2},
  [1698] = {.lex_state = 132, .external_lex_state = 2},
  [1699] = {.lex_state = 132, .external_lex_state = 2},
  [1700] = {.lex_state = 132, .external_lex_state = 2},
  [1701] = {.lex_state = 132, .external_lex_state = 2},
  [1702] = {.lex_state = 132, .external_lex_state = 2},
  [1703] = {.lex_state = 132, .external_lex_state = 2},
  [1704] = {.lex_state = 132, .external_lex_state = 2},
  [1705] = {.lex_state = 132, .external_lex_state = 2},
  [1706] = {.lex_state = 132, .external_lex_state = 2},
  [1707] = {.lex_state = 132, .external_lex_state = 2},
  [1708] = {.lex_state = 132, .external_lex_state = 2},
  [1709] = {.lex_state = 132, .external_lex_state = 2},
  [1710] = {.lex_state = 132, .external_lex_state = 2},
  [1711] = {.lex_state = 132, .external_lex_state = 2},
  [1712] = {.lex_state = 132, .external_lex_state = 2},
  [1713] = {.lex_state = 132, .external_lex_state = 2},
  [1714] = {.lex_state = 132, .external_lex_state = 2},
  [1715] = {.lex_state = 132, .external_lex_state = 2},
  [1716] = {.lex_state = 132, .external_lex_state = 2},
  [1717] = {.lex_state = 132, .external_lex_state = 2},
  [1718] = {.lex_state = 132, .external_lex_state = 2},
  [1719] = {.lex_state = 132, .external_lex_state = 2},
  [1720] = {.lex_state = 132, .external_lex_state = 2},
  [1721] = {.lex_state = 132, .external_lex_state = 2},
  [1722] = {.lex_state = 132, .external_lex_state = 2},
  [1723] = {.lex_state = 132, .external_lex_state = 2},
  [1724] = {.lex_state = 132, .external_lex_state = 2},
  [1725] = {.lex_state = 132, .external_lex_state = 2},
  [1726] = {.lex_state = 132, .external_lex_state = 2},
  [1727] = {.lex_state = 132, .external_lex_state = 2},
  [1728] = {.lex_state = 132, .external_lex_state = 2},
  [1729] = {.lex_state = 132, .external_lex_state = 2},
  [1730] = {.lex_state = 132, .external_lex_state = 2},
  [1731] = {.lex_state = 132, .external_lex_state = 2},
  [1732] = {.lex_state = 132, .external_lex_state = 2},
  [1733] = {.lex_state = 132, .external_lex_state = 2},
  [1734] = {.lex_state = 132, .external_lex_state = 2},
  [1735] = {.lex_state = 132, .external_lex_state = 2},
  [1736] = {.lex_state = 132, .external_lex_state = 2},
  [1737] = {.lex_state = 132, .external_lex_state = 2},
  [1738] = {.lex_state = 132, .external_lex_state = 2},
  [1739] = {.lex_state = 132, .external_lex_state = 2},
  [1740] = {.lex_state = 132, .external_lex_state = 2},
  [1741] = {.lex_state = 132, .external_lex_state = 2},
  [1742] = {.lex_state = 132, .external_lex_state = 2},
  [1743] = {.lex_state = 132, .external_lex_state = 2},
  [1744] = {.lex_state = 132, .external_lex_state = 2},
  [1745] = {.lex_state = 132, .external_lex_state = 2},
  [1746] = {.lex_state = 132, .external_lex_state = 2},
  [1747] = {.lex_state = 132, .external_lex_state = 2},
  [1748] = {.lex_state = 132, .external_lex_state = 2},
  [1749] = {.lex_state = 132, .external_lex_state = 2},
  [1750] = {.lex_state = 132, .external_lex_state = 2},
  [1751] = {.lex_state = 132, .external_lex_state = 2},
  [1752] = {.lex_state = 132, .external_lex_state = 2},
  [1753] = {.lex_state = 132, .external_lex_state = 2},
  [1754] = {.lex_state = 132, .external_lex_state = 2},
  [1755] = {.lex_state = 132, .external_lex_state = 2},
  [1756] = {.lex_state = 132, .external_lex_state = 2},
  [1757] = {.lex_state = 132, .external_lex_state = 2},
  [1758] = {.lex_state = 132, .external_lex_state = 2},
  [1759] = {.lex_state = 132, .external_lex_state = 2},
  [1760] = {.lex_state = 132, .external_lex_state = 2},
  [1761] = {.lex_state = 132, .external_lex_state = 2},
  [1762] = {.lex_state = 132, .external_lex_state = 2},
  [1763] = {.lex_state = 132, .external_lex_state = 2},
  [1764] = {.lex_state = 132, .external_lex_state = 2},
  [1765] = {.lex_state = 132, .external_lex_state = 2},
  [1766] = {.lex_state = 132, .external_lex_state = 2},
  [1767] = {.lex_state = 132, .external_lex_state = 2},
  [1768] = {.lex_state = 132, .external_lex_state = 2},
  [1769] = {.lex_state = 132, .external_lex_state = 2},
  [1770] = {.lex_state = 132, .external_lex_state = 2},
  [1771] = {.lex_state = 132, .external_lex_state = 2},
  [1772] = {.lex_state = 132, .external_lex_state = 2},
  [1773] = {.lex_state = 132, .external_lex_state = 2},
  [1774] = {.lex_state = 132, .external_lex_state = 2},
  [1775] = {.lex_state = 132, .external_lex_state = 2},
  [1776] = {.lex_state = 132, .external_lex_state = 2},
  [1777] = {.lex_state = 132, .external_lex_state = 2},
  [1778] = {.lex_state = 132, .external_lex_state = 2},
  [1779] = {.lex_state = 132, .external_lex_state = 2},
  [1780] = {.lex_state = 132, .external_lex_state = 2},
  [1781] = {.lex_state = 132, .external_lex_state = 2},
  [1782] = {.lex_state = 132, .external_lex_state = 2},
  [1783] = {.lex_state = 132, .external_lex_state = 2},
  [1784] = {.lex_state = 132, .external_lex_state = 2},
  [1785] = {.lex_state = 132, .external_lex_state = 2},
  [1786] = {.lex_state = 132, .external_lex_state = 2},
  [1787] = {.lex_state = 132, .external_lex_state = 2},
  [1788] = {.lex_state = 132, .external_lex_state = 2},
  [1789] = {.lex_state = 132, .external_lex_state = 2},
  [1790] = {.lex_state = 132, .external_lex_state = 2},
  [1791] = {.lex_state = 132, .external_lex_state = 2},
  [1792] = {.lex_state = 132, .external_lex_state = 2},
  [1793] = {.lex_state = 132, .external_lex_state = 2},
  [1794] = {.lex_state = 132, .external_lex_state = 2},
  [1795] = {.lex_state = 132, .external_lex_state = 2},
  [1796] = {.lex_state = 132, .external_lex_state = 2},
  [1797] = {.lex_state = 132, .external_lex_state = 2},
  [1798] = {.lex_state = 132, .external_lex_state = 2},
  [1799] = {.lex_state = 132, .external_lex_state = 2},
  [1800] = {.lex_state = 132, .external_lex_state = 2},
  [1801] = {.lex_state = 132, .external_lex_state = 2},
  [1802] = {.lex_state = 132, .external_lex_state = 2},
  [1803] = {.lex_state = 132, .external_lex_state = 2},
  [1804] = {.lex_state = 132, .external_lex_state = 2},
  [1805] = {.lex_state = 132, .external_lex_state = 2},
  [1806] = {.lex_state = 132, .external_lex_state = 2},
  [1807] = {.lex_state = 132, .external_lex_state = 2},
  [1808] = {.lex_state = 132, .external_lex_state = 2},
  [1809] = {.lex_state = 132, .external_lex_state = 2},
  [1810] = {.lex_state = 132, .external_lex_state = 2},
  [1811] = {.lex_state = 132, .external_lex_state = 2},
  [1812] = {.lex_state = 132, .external_lex_state = 2},
  [1813] = {.lex_state = 132, .external_lex_state = 2},
  [1814] = {.lex_state = 132, .external_lex_state = 2},
  [1815] = {.lex_state = 132, .external_lex_state = 2},
  [1816] = {.lex_state = 132, .external_lex_state = 2},
  [1817] = {.lex_state = 132, .external_lex_state = 2},
  [1818] = {.lex_state = 132, .external_lex_state = 2},
  [1819] = {.lex_state = 132, .external_lex_state = 2},
  [1820] = {.lex_state = 132, .external_lex_state = 2},
  [1821] = {.lex_state = 132, .external_lex_state = 2},
  [1822] = {.lex_state = 132, .external_lex_state = 2},
  [1823] = {.lex_state = 132, .external_lex_state = 2},
  [1824] = {.lex_state = 132, .external_lex_state = 2},
  [1825] = {.lex_state = 132, .external_lex_state = 2},
  [1826] = {.lex_state = 132, .external_lex_state = 2},
  [1827] = {.lex_state = 132, .external_lex_state = 2},
  [1828] = {.lex_state = 132, .external_lex_state = 2},
  [1829] = {.lex_state = 132, .external_lex_state = 2},
  [1830] = {.lex_state = 132, .external_lex_state = 2},
  [1831] = {.lex_state = 132, .external_lex_state = 2},
  [1832] = {.lex_state = 132, .external_lex_state = 2},
  [1833] = {.lex_state = 132, .external_lex_state = 2},
  [1834] = {.lex_state = 132, .external_lex_state = 2},
  [1835] = {.lex_state = 132, .external_lex_state = 2},
  [1836] = {.lex_state = 132, .external_lex_state = 2},
  [1837] = {.lex_state = 132, .external_lex_state = 2},
  [1838] = {.lex_state = 132, .external_lex_state = 2},
  [1839] = {.lex_state = 132, .external_lex_state = 2},
  [1840] = {.lex_state = 132, .external_lex_state = 2},
  [1841] = {.lex_state = 132, .external_lex_state = 2},
  [1842] = {.lex_state = 132, .external_lex_state = 2},
  [1843] = {.lex_state = 132, .external_lex_state = 2},
  [1844] = {.lex_state = 132, .external_lex_state = 2},
  [1845] = {.lex_state = 132, .external_lex_state = 2},
  [1846] = {.lex_state = 132, .external_lex_state = 2},
  [1847] = {.lex_state = 132, .external_lex_state = 2},
  [1848] = {.lex_state = 132, .external_lex_state = 2},
  [1849] = {.lex_state = 132, .external_lex_state = 2},
  [1850] = {.lex_state = 132, .external_lex_state = 2},
  [1851] = {.lex_state = 132, .external_lex_state = 2},
  [1852] = {.lex_state = 132, .external_lex_state = 2},
  [1853] = {.lex_state = 132, .external_lex_state = 2},
  [1854] = {.lex_state = 132, .external_lex_state = 2},
  [1855] = {.lex_state = 132, .external_lex_state = 2},
  [1856] = {.lex_state = 132, .external_lex_state = 2},
  [1857] = {.lex_state = 132, .external_lex_state = 2},
  [1858] = {.lex_state = 132, .external_lex_state = 2},
  [1859] = {.lex_state = 132, .external_lex_state = 2},
  [1860] = {.lex_state = 132, .external_lex_state = 2},
  [1861] = {.lex_state = 132, .external_lex_state = 2},
  [1862] = {.lex_state = 132, .external_lex_state = 2},
  [1863] = {.lex_state = 132, .external_lex_state = 2},
  [1864] = {.lex_state = 132, .external_lex_state = 2},
  [1865] = {.lex_state = 132, .external_lex_state = 2},
  [1866] = {.lex_state = 132, .external_lex_state = 2},
  [1867] = {.lex_state = 132, .external_lex_state = 2},
  [1868] = {.lex_state = 132, .external_lex_state = 2},
  [1869] = {.lex_state = 132, .external_lex_state = 2},
  [1870] = {.lex_state = 132, .external_lex_state = 2},
  [1871] = {.lex_state = 132, .external_lex_state = 2},
  [1872] = {.lex_state = 132, .external_lex_state = 2},
  [1873] = {.lex_state = 132, .external_lex_state = 2},
  [1874] = {.lex_state = 132, .external_lex_state = 2},
  [1875] = {.lex_state = 132, .external_lex_state = 2},
  [1876] = {.lex_state = 132, .external_lex_state = 2},
  [1877] = {.lex_state = 132, .external_lex_state = 2},
  [1878] = {.lex_state = 132, .external_lex_state = 2},
  [1879] = {.lex_state = 132, .external_lex_state = 2},
  [1880] = {.lex_state = 132, .external_lex_state = 2},
  [1881] = {.lex_state = 132, .external_lex_state = 2},
  [1882] = {.lex_state = 132, .external_lex_state = 2},
  [1883] = {.lex_state = 132, .external_lex_state = 2},
  [1884] = {.lex_state = 132, .external_lex_state = 2},
  [1885] = {.lex_state = 132, .external_lex_state = 2},
  [1886] = {.lex_state = 132, .external_lex_state = 2},
  [1887] = {.lex_state = 132, .external_lex_state = 2},
  [1888] = {.lex_state = 132, .external_lex_state = 2},
  [1889] = {.lex_state = 132, .external_lex_state = 2},
  [1890] = {.lex_state = 132, .external_lex_state = 2},
  [1891] = {.lex_state = 132, .external_lex_state = 2},
  [1892] = {.lex_state = 132, .external_lex_state = 2},
  [1893] = {.lex_state = 132, .external_lex_state = 2},
  [1894] = {.lex_state = 132, .external_lex_state = 2},
  [1895] = {.lex_state = 132, .external_lex_state = 2},
  [1896] = {.lex_state = 132, .external_lex_state = 2},
  [1897] = {.lex_state = 132, .external_lex_state = 2},
  [1898] = {.lex_state = 132, .external_lex_state = 2},
  [1899] = {.lex_state = 132, .external_lex_state = 2},
  [1900] = {.lex_state = 132, .external_lex_state = 2},
  [1901] = {.lex_state = 132, .external_lex_state = 2},
  [1902] = {.lex_state = 132, .external_lex_state = 2},
  [1903] = {.lex_state = 132, .external_lex_state = 2},
  [1904] = {.lex_state = 132, .external_lex_state = 2},
  [1905] = {.lex_state = 132, .external_lex_state = 2},
  [1906] = {.lex_state = 132, .external_lex_state = 2},
  [1907] = {.lex_state = 132, .external_lex_state = 2},
  [1908] = {.lex_state = 132, .external_lex_state = 2},
  [1909] = {.lex_state = 132, .external_lex_state = 2},
  [1910] = {.lex_state = 132, .external_lex_state = 2},
  [1911] = {.lex_state = 132, .external_lex_state = 2},
  [1912] = {.lex_state = 132, .external_lex_state = 2},
  [1913] = {.lex_state = 132, .external_lex_state = 2},
  [1914] = {.lex_state = 132, .external_lex_state = 2},
  [1915] = {.lex_state = 131, .external_lex_state = 2},
  [1916] = {.lex_state = 131, .external_lex_state = 2},
  [1917] = {.lex_state = 131, .external_lex_state = 2},
  [1918] = {.lex_state = 131, .external_lex_state = 2},
  [1919] = {.lex_state = 131, .external_lex_state = 2},
  [1920] = {.lex_state = 131, .external_lex_state = 2},
  [1921] = {.lex_state = 132},
  [1922] = {.lex_state = 132},
  [1923] = {.lex_state = 132},
  [1924] = {.lex_state = 132},
  [1925] = {.lex_state = 132},
  [1926] = {.lex_state = 132},
  [1927] = {.lex_state = 132},
  [1928] = {.lex_state = 132, .external_lex_state = 2},
  [1929] = {.lex_state = 132},
  [1930] = {.lex_state = 132},
  [1931] = {.lex_state = 132},
  [1932] = {.lex_state = 132, .external_lex_state = 2},
  [1933] = {.lex_state = 132},
  [1934] = {.lex_state = 132, .external_lex_state = 2},
  [1935] = {.lex_state = 132, .external_lex_state = 2},
  [1936] = {.lex_state = 132, .external_lex_state = 2},
  [1937] = {.lex_state = 132, .external_lex_state = 2},
  [1938] = {.lex_state = 132, .external_lex_state = 2},
  [1939] = {.lex_state = 132, .external_lex_state = 2},
  [1940] = {.lex_state = 132, .external_lex_state = 2},
  [1941] = {.lex_state = 132, .external_lex_state = 2},
  [1942] = {.lex_state = 132, .external_lex_state = 2},
  [1943] = {.lex_state = 132, .external_lex_state = 2},
  [1944] = {.lex_state = 132, .external_lex_state = 2},
  [1945] = {.lex_state = 132, .external_lex_state = 2},
  [1946] = {.lex_state = 132, .external_lex_state = 2},
  [1947] = {.lex_state = 132, .external_lex_state = 2},
  [1948] = {.lex_state = 132, .external_lex_state = 2},
  [1949] = {.lex_state = 132, .external_lex_state = 2},
  [1950] = {.lex_state = 132, .external_lex_state = 2},
  [1951] = {.lex_state = 132, .external_lex_state = 2},
  [1952] = {.lex_state = 132, .external_lex_state = 2},
  [1953] = {.lex_state = 132, .external_lex_state = 2},
  [1954] = {.lex_state = 132, .external_lex_state = 2},
  [1955] = {.lex_state = 132, .external_lex_state = 2},
  [1956] = {.lex_state = 132, .external_lex_state = 2},
  [1957] = {.lex_state = 132, .external_lex_state = 2},
  [1958] = {.lex_state = 132, .external_lex_state = 2},
  [1959] = {.lex_state = 132, .external_lex_state = 2},
  [1960] = {.lex_state = 132, .external_lex_state = 2},
  [1961] = {.lex_state = 132, .external_lex_state = 2},
  [1962] = {.lex_state = 132, .external_lex_state = 2},
  [1963] = {.lex_state = 132, .external_lex_state = 2},
  [1964] = {.lex_state = 132, .external_lex_state = 2},
  [1965] = {.lex_state = 132, .external_lex_state = 2},
  [1966] = {.lex_state = 132, .external_lex_state = 2},
  [1967] = {.lex_state = 132, .external_lex_state = 2},
  [1968] = {.lex_state = 132, .external_lex_state = 2},
  [1969] = {.lex_state = 132, .external_lex_state = 2},
  [1970] = {.lex_state = 132, .external_lex_state = 2},
  [1971] = {.lex_state = 132, .external_lex_state = 2},
  [1972] = {.lex_state = 132, .external_lex_state = 2},
  [1973] = {.lex_state = 132, .external_lex_state = 2},
  [1974] = {.lex_state = 132, .external_lex_state = 2},
  [1975] = {.lex_state = 132, .external_lex_state = 2},
  [1976] = {.lex_state = 132, .external_lex_state = 2},
  [1977] = {.lex_state = 132, .external_lex_state = 2},
  [1978] = {.lex_state = 132, .external_lex_state = 2},
  [1979] = {.lex_state = 132, .external_lex_state = 2},
  [1980] = {.lex_state = 132, .external_lex_state = 2},
  [1981] = {.lex_state = 132, .external_lex_state = 2},
  [1982] = {.lex_state = 132, .external_lex_state = 2},
  [1983] = {.lex_state = 132, .external_lex_state = 2},
  [1984] = {.lex_state = 132, .external_lex_state = 2},
  [1985] = {.lex_state = 132, .external_lex_state = 2},
  [1986] = {.lex_state = 132, .external_lex_state = 2},
  [1987] = {.lex_state = 132, .external_lex_state = 2},
  [1988] = {.lex_state = 132, .external_lex_state = 2},
  [1989] = {.lex_state = 132, .external_lex_state = 2},
  [1990] = {.lex_state = 132, .external_lex_state = 2},
  [1991] = {.lex_state = 132, .external_lex_state = 2},
  [1992] = {.lex_state = 132, .external_lex_state = 2},
  [1993] = {.lex_state = 132, .external_lex_state = 2},
  [1994] = {.lex_state = 132, .external_lex_state = 2},
  [1995] = {.lex_state = 132, .external_lex_state = 2},
  [1996] = {.lex_state = 132, .external_lex_state = 2},
  [1997] = {.lex_state = 132, .external_lex_state = 2},
  [1998] = {.lex_state = 132, .external_lex_state = 2},
  [1999] = {.lex_state = 132, .external_lex_state = 2},
  [2000] = {.lex_state = 132, .external_lex_state = 2},
  [2001] = {.lex_state = 132, .external_lex_state = 2},
  [2002] = {.lex_state = 132, .external_lex_state = 2},
  [2003] = {.lex_state = 132, .external_lex_state = 2},
  [2004] = {.lex_state = 132, .external_lex_state = 2},
  [2005] = {.lex_state = 132, .external_lex_state = 2},
  [2006] = {.lex_state = 132, .external_lex_state = 2},
  [2007] = {.lex_state = 132, .external_lex_state = 2},
  [2008] = {.lex_state = 132, .external_lex_state = 2},
  [2009] = {.lex_state = 132, .external_lex_state = 2},
  [2010] = {.lex_state = 132, .external_lex_state = 2},
  [2011] = {.lex_state = 132, .external_lex_state = 2},
  [2012] = {.lex_state = 132, .external_lex_state = 2},
  [2013] = {.lex_state = 132, .external_lex_state = 2},
  [2014] = {.lex_state = 132, .external_lex_state = 2},
  [2015] = {.lex_state = 132, .external_lex_state = 2},
  [2016] = {.lex_state = 132, .external_lex_state = 2},
  [2017] = {.lex_state = 132, .external_lex_state = 2},
  [2018] = {.lex_state = 132, .external_lex_state = 2},
  [2019] = {.lex_state = 132, .external_lex_state = 2},
  [2020] = {.lex_state = 132, .external_lex_state = 2},
  [2021] = {.lex_state = 132, .external_lex_state = 2},
  [2022] = {.lex_state = 132, .external_lex_state = 2},
  [2023] = {.lex_state = 132, .external_lex_state = 2},
  [2024] = {.lex_state = 132, .external_lex_state = 2},
  [2025] = {.lex_state = 132, .external_lex_state = 2},
  [2026] = {.lex_state = 132, .external_lex_state = 2},
  [2027] = {.lex_state = 132, .external_lex_state = 2},
  [2028] = {.lex_state = 132, .external_lex_state = 2},
  [2029] = {.lex_state = 132, .external_lex_state = 2},
  [2030] = {.lex_state = 132, .external_lex_state = 2},
  [2031] = {.lex_state = 132, .external_lex_state = 2},
  [2032] = {.lex_state = 132, .external_lex_state = 2},
  [2033] = {.lex_state = 132, .external_lex_state = 2},
  [2034] = {.lex_state = 132, .external_lex_state = 2},
  [2035] = {.lex_state = 132, .external_lex_state = 2},
  [2036] = {.lex_state = 132, .external_lex_state = 2},
  [2037] = {.lex_state = 132, .external_lex_state = 2},
  [2038] = {.lex_state = 132, .external_lex_state = 2},
  [2039] = {.lex_state = 132, .external_lex_state = 2},
  [2040] = {.lex_state = 132, .external_lex_state = 2},
  [2041] = {.lex_state = 4},
  [2042] = {.lex_state = 132, .external_lex_state = 2},
  [2043] = {.lex_state = 132, .external_lex_state = 2},
  [2044] = {.lex_state = 132, .external_lex_state = 2},
  [2045] = {.lex_state = 132, .external_lex_state = 2},
  [2046] = {.lex_state = 132, .external_lex_state = 2},
  [2047] = {.lex_state = 132, .external_lex_state = 2},
  [2048] = {.lex_state = 132, .external_lex_state = 2},
  [2049] = {.lex_state = 132, .external_lex_state = 2},
  [2050] = {.lex_state = 132, .external_lex_state = 2},
  [2051] = {.lex_state = 132, .external_lex_state = 2},
  [2052] = {.lex_state = 132, .external_lex_state = 2},
  [2053] = {.lex_state = 132, .external_lex_state = 2},
  [2054] = {.lex_state = 132, .external_lex_state = 2},
  [2055] = {.lex_state = 132, .external_lex_state = 2},
  [2056] = {.lex_state = 132, .external_lex_state = 2},
  [2057] = {.lex_state = 132, .external_lex_state = 2},
  [2058] = {.lex_state = 132, .external_lex_state = 2},
  [2059] = {.lex_state = 132, .external_lex_state = 2},
  [2060] = {.lex_state = 132, .external_lex_state = 2},
  [2061] = {.lex_state = 132, .external_lex_state = 2},
  [2062] = {.lex_state = 132, .external_lex_state = 2},
  [2063] = {.lex_state = 132, .external_lex_state = 2},
  [2064] = {.lex_state = 132, .external_lex_state = 2},
  [2065] = {.lex_state = 132, .external_lex_state = 2},
  [2066] = {.lex_state = 132, .external_lex_state = 2},
  [2067] = {.lex_state = 132, .external_lex_state = 2},
  [2068] = {.lex_state = 132, .external_lex_state = 2},
  [2069] = {.lex_state = 132, .external_lex_state = 2},
  [2070] = {.lex_state = 132, .external_lex_state = 2},
  [2071] = {.lex_state = 132, .external_lex_state = 2},
  [2072] = {.lex_state = 132, .external_lex_state = 2},
  [2073] = {.lex_state = 132, .external_lex_state = 2},
  [2074] = {.lex_state = 132, .external_lex_state = 2},
  [2075] = {.lex_state = 132, .external_lex_state = 2},
  [2076] = {.lex_state = 132, .external_lex_state = 2},
  [2077] = {.lex_state = 132, .external_lex_state = 2},
  [2078] = {.lex_state = 132, .external_lex_state = 2},
  [2079] = {.lex_state = 132, .external_lex_state = 2},
  [2080] = {.lex_state = 132, .external_lex_state = 2},
  [2081] = {.lex_state = 132, .external_lex_state = 2},
  [2082] = {.lex_state = 132, .external_lex_state = 2},
  [2083] = {.lex_state = 132, .external_lex_state = 2},
  [2084] = {.lex_state = 132, .external_lex_state = 2},
  [2085] = {.lex_state = 132, .external_lex_state = 2},
  [2086] = {.lex_state = 132, .external_lex_state = 2},
  [2087] = {.lex_state = 132, .external_lex_state = 2},
  [2088] = {.lex_state = 132, .external_lex_state = 2},
  [2089] = {.lex_state = 132, .external_lex_state = 2},
  [2090] = {.lex_state = 132, .external_lex_state = 2},
  [2091] = {.lex_state = 132, .external_lex_state = 2},
  [2092] = {.lex_state = 132, .external_lex_state = 2},
  [2093] = {.lex_state = 132, .external_lex_state = 2},
  [2094] = {.lex_state = 132, .external_lex_state = 2},
  [2095] = {.lex_state = 132, .external_lex_state = 2},
  [2096] = {.lex_state = 132, .external_lex_state = 2},
  [2097] = {.lex_state = 132, .external_lex_state = 2},
  [2098] = {.lex_state = 132, .external_lex_state = 2},
  [2099] = {.lex_state = 132, .external_lex_state = 2},
  [2100] = {.lex_state = 132, .external_lex_state = 2},
  [2101] = {.lex_state = 4},
  [2102] = {.lex_state = 132, .external_lex_state = 2},
  [2103] = {.lex_state = 132, .external_lex_state = 2},
  [2104] = {.lex_state = 132, .external_lex_state = 2},
  [2105] = {.lex_state = 132, .external_lex_state = 2},
  [2106] = {.lex_state = 132, .external_lex_state = 2},
  [2107] = {.lex_state = 132, .external_lex_state = 2},
  [2108] = {.lex_state = 132, .external_lex_state = 2},
  [2109] = {.lex_state = 132, .external_lex_state = 2},
  [2110] = {.lex_state = 132, .external_lex_state = 2},
  [2111] = {.lex_state = 132, .external_lex_state = 2},
  [2112] = {.lex_state = 132, .external_lex_state = 2},
  [2113] = {.lex_state = 132, .external_lex_state = 2},
  [2114] = {.lex_state = 132, .external_lex_state = 2},
  [2115] = {.lex_state = 132, .external_lex_state = 2},
  [2116] = {.lex_state = 132, .external_lex_state = 2},
  [2117] = {.lex_state = 132, .external_lex_state = 2},
  [2118] = {.lex_state = 132, .external_lex_state = 2},
  [2119] = {.lex_state = 132, .external_lex_state = 2},
  [2120] = {.lex_state = 132, .external_lex_state = 2},
  [2121] = {.lex_state = 132, .external_lex_state = 2},
  [2122] = {.lex_state = 132, .external_lex_state = 2},
  [2123] = {.lex_state = 132, .external_lex_state = 2},
  [2124] = {.lex_state = 132, .external_lex_state = 2},
  [2125] = {.lex_state = 132, .external_lex_state = 2},
  [2126] = {.lex_state = 132, .external_lex_state = 2},
  [2127] = {.lex_state = 132, .external_lex_state = 2},
  [2128] = {.lex_state = 132, .external_lex_state = 2},
  [2129] = {.lex_state = 132, .external_lex_state = 2},
  [2130] = {.lex_state = 132, .external_lex_state = 2},
  [2131] = {.lex_state = 132, .external_lex_state = 2},
  [2132] = {.lex_state = 132, .external_lex_state = 2},
  [2133] = {.lex_state = 132, .external_lex_state = 2},
  [2134] = {.lex_state = 132, .external_lex_state = 2},
  [2135] = {.lex_state = 132, .external_lex_state = 2},
  [2136] = {.lex_state = 132, .external_lex_state = 2},
  [2137] = {.lex_state = 132, .external_lex_state = 2},
  [2138] = {.lex_state = 132, .external_lex_state = 2},
  [2139] = {.lex_state = 132, .external_lex_state = 2},
  [2140] = {.lex_state = 132, .external_lex_state = 2},
  [2141] = {.lex_state = 132, .external_lex_state = 2},
  [2142] = {.lex_state = 132, .external_lex_state = 2},
  [2143] = {.lex_state = 132, .external_lex_state = 2},
  [2144] = {.lex_state = 132, .external_lex_state = 2},
  [2145] = {.lex_state = 132, .external_lex_state = 2},
  [2146] = {.lex_state = 132, .external_lex_state = 2},
  [2147] = {.lex_state = 132, .external_lex_state = 2},
  [2148] = {.lex_state = 4},
  [2149] = {.lex_state = 132, .external_lex_state = 2},
  [2150] = {.lex_state = 4, .external_lex_state = 4},
  [2151] = {.lex_state = 132, .external_lex_state = 2},
  [2152] = {.lex_state = 132, .external_lex_state = 2},
  [2153] = {.lex_state = 132, .external_lex_state = 2},
  [2154] = {.lex_state = 132, .external_lex_state = 2},
  [2155] = {.lex_state = 132, .external_lex_state = 2},
  [2156] = {.lex_state = 132, .external_lex_state = 2},
  [2157] = {.lex_state = 132, .external_lex_state = 2},
  [2158] = {.lex_state = 132, .external_lex_state = 2},
  [2159] = {.lex_state = 132, .external_lex_state = 2},
  [2160] = {.lex_state = 132, .external_lex_state = 2},
  [2161] = {.lex_state = 132, .external_lex_state = 2},
  [2162] = {.lex_state = 132, .external_lex_state = 2},
  [2163] = {.lex_state = 132, .external_lex_state = 2},
  [2164] = {.lex_state = 132, .external_lex_state = 2},
  [2165] = {.lex_state = 132, .external_lex_state = 2},
  [2166] = {.lex_state = 132, .external_lex_state = 2},
  [2167] = {.lex_state = 132, .external_lex_state = 2},
  [2168] = {.lex_state = 132, .external_lex_state = 2},
  [2169] = {.lex_state = 132, .external_lex_state = 2},
  [2170] = {.lex_state = 132, .external_lex_state = 2},
  [2171] = {.lex_state = 132, .external_lex_state = 2},
  [2172] = {.lex_state = 132, .external_lex_state = 2},
  [2173] = {.lex_state = 4},
  [2174] = {.lex_state = 4},
  [2175] = {.lex_state = 4},
  [2176] = {.lex_state = 4},
  [2177] = {.lex_state = 4},
  [2178] = {.lex_state = 4},
  [2179] = {.lex_state = 4, .external_lex_state = 4},
  [2180] = {.lex_state = 4},
  [2181] = {.lex_state = 4},
  [2182] = {.lex_state = 4},
  [2183] = {.lex_state = 4},
  [2184] = {.lex_state = 5},
  [2185] = {.lex_state = 5},
  [2186] = {.lex_state = 5},
  [2187] = {.lex_state = 5},
  [2188] = {.lex_state = 4},
  [2189] = {.lex_state = 5},
  [2190] = {.lex_state = 4, .external_lex_state = 4},
  [2191] = {.lex_state = 4},
  [2192] = {.lex_state = 4},
  [2193] = {.lex_state = 5},
  [2194] = {.lex_state = 4},
  [2195] = {.lex_state = 5},
  [2196] = {.lex_state = 5},
  [2197] = {.lex_state = 5},
  [2198] = {.lex_state = 5},
  [2199] = {.lex_state = 5},
  [2200] = {.lex_state = 5},
  [2201] = {.lex_state = 5},
  [2202] = {.lex_state = 4},
  [2203] = {.lex_state = 4},
  [2204] = {.lex_state = 5},
  [2205] = {.lex_state = 5},
  [2206] = {.lex_state = 5},
  [2207] = {.lex_state = 132},
  [2208] = {.lex_state = 4, .external_lex_state = 4},
  [2209] = {.lex_state = 6},
  [2210] = {.lex_state = 131},
  [2211] = {.lex_state = 6},
  [2212] = {.lex_state = 5},
  [2213] = {.lex_state = 6},
  [2214] = {.lex_state = 4},
  [2215] = {.lex_state = 4},
  [2216] = {.lex_state = 4},
  [2217] = {.lex_state = 4},
  [2218] = {.lex_state = 132},
  [2219] = {.lex_state = 4},
  [2220] = {.lex_state = 4},
  [2221] = {.lex_state = 5},
  [2222] = {.lex_state = 4},
  [2223] = {.lex_state = 5},
  [2224] = {.lex_state = 4},
  [2225] = {.lex_state = 5},
  [2226] = {.lex_state = 4},
  [2227] = {.lex_state = 4},
  [2228] = {.lex_state = 4},
  [2229] = {.lex_state = 4, .external_lex_state = 4},
  [2230] = {.lex_state = 4},
  [2231] = {.lex_state = 6},
  [2232] = {.lex_state = 4},
  [2233] = {.lex_state = 4},
  [2234] = {.lex_state = 4},
  [2235] = {.lex_state = 131},
  [2236] = {.lex_state = 4},
  [2237] = {.lex_state = 4},
  [2238] = {.lex_state = 5},
  [2239] = {.lex_state = 4, .external_lex_state = 4},
  [2240] = {.lex_state = 6},
  [2241] = {.lex_state = 5},
  [2242] = {.lex_state = 131},
  [2243] = {.lex_state = 4, .external_lex_state = 4},
  [2244] = {.lex_state = 4, .external_lex_state = 4},
  [2245] = {.lex_state = 5},
  [2246] = {.lex_state = 131},
  [2247] = {.lex_state = 5},
  [2248] = {.lex_state = 131},
  [2249] = {.lex_state = 131},
  [2250] = {.lex_state = 131},
  [2251] = {.lex_state = 5},
  [2252] = {.lex_state = 5},
  [2253] = {.lex_state = 131},
  [2254] = {.lex_state = 5},
  [2255] = {.lex_state = 4, .external_lex_state = 4},
  [2256] = {.lex_state = 4},
  [2257] = {.lex_state = 4},
  [2258] = {.lex_state = 5, .external_lex_state = 4},
  [2259] = {.lex_state = 5},
  [2260] = {.lex_state = 5, .external_lex_state = 4},
  [2261] = {.lex_state = 5, .external_lex_state = 4},
  [2262] = {.lex_state = 5},
  [2263] = {.lex_state = 5},
  [2264] = {.lex_state = 5, .external_lex_state = 4},
  [2265] = {.lex_state = 5},
  [2266] = {.lex_state = 5},
  [2267] = {.lex_state = 5},
  [2268] = {.lex_state = 4},
  [2269] = {.lex_state = 4},
  [2270] = {.lex_state = 4, .external_lex_state = 4},
  [2271] = {.lex_state = 4},
  [2272] = {.lex_state = 5, .external_lex_state = 4},
  [2273] = {.lex_state = 5, .external_lex_state = 4},
  [2274] = {.lex_state = 5, .external_lex_state = 4},
  [2275] = {.lex_state = 5, .external_lex_state = 4},
  [2276] = {.lex_state = 5, .external_lex_state = 4},
  [2277] = {.lex_state = 4},
  [2278] = {.lex_state = 131},
  [2279] = {.lex_state = 131},
  [2280] = {.lex_state = 5, .external_lex_state = 4},
  [2281] = {.lex_state = 5, .external_lex_state = 4},
  [2282] = {.lex_state = 5, .external_lex_state = 4},
  [2283] = {.lex_state = 4},
  [2284] = {.lex_state = 5, .external_lex_state = 4},
  [2285] = {.lex_state = 5, .external_lex_state = 4},
  [2286] = {.lex_state = 4},
  [2287] = {.lex_state = 4},
  [2288] = {.lex_state = 5},
  [2289] = {.lex_state = 132},
  [2290] = {.lex_state = 6},
  [2291] = {.lex_state = 132},
  [2292] = {.lex_state = 4},
  [2293] = {.lex_state = 4},
  [2294] = {.lex_state = 5},
  [2295] = {.lex_state = 131},
  [2296] = {.lex_state = 131},
  [2297] = {.lex_state = 4},
  [2298] = {.lex_state = 132},
  [2299] = {.lex_state = 5},
  [2300] = {.lex_state = 5},
  [2301] = {.lex_state = 4},
  [2302] = {.lex_state = 131},
  [2303] = {.lex_state = 5},
  [2304] = {.lex_state = 5},
  [2305] = {.lex_state = 5},
  [2306] = {.lex_state = 4},
  [2307] = {.lex_state = 4},
  [2308] = {.lex_state = 4},
  [2309] = {.lex_state = 4},
  [2310] = {.lex_state = 131},
  [2311] = {.lex_state = 5, .external_lex_state = 4},
  [2312] = {.lex_state = 131},
  [2313] = {.lex_state = 131},
  [2314] = {.lex_state = 131},
  [2315] = {.lex_state = 6, .external_lex_state = 4},
  [2316] = {.lex_state = 5},
  [2317] = {.lex_state = 5},
  [2318] = {.lex_state = 5, .external_lex_state = 4},
  [2319] = {.lex_state = 4},
  [2320] = {.lex_state = 5, .external_lex_state = 4},
  [2321] = {.lex_state = 131},
  [2322] = {.lex_state = 131},
  [2323] = {.lex_state = 4},
  [2324] = {.lex_state = 131},
  [2325] = {.lex_state = 131},
  [2326] = {.lex_state = 5, .external_lex_state = 4},
  [2327] = {.lex_state = 4},
  [2328] = {.lex_state = 4},
  [2329] = {.lex_state = 4},
  [2330] = {.lex_state = 4},
  [2331] = {.lex_state = 4},
  [2332] = {.lex_state = 131},
  [2333] = {.lex_state = 6, .external_lex_state = 4},
  [2334] = {.lex_state = 131},
  [2335] = {.lex_state = 131},
  [2336] = {.lex_state = 4},
  [2337] = {.lex_state = 131},
  [2338] = {.lex_state = 131},
  [2339] = {.lex_state = 4},
  [2340] = {.lex_state = 131},
  [2341] = {.lex_state = 131},
  [2342] = {.lex_state = 131},
  [2343] = {.lex_state = 131},
  [2344] = {.lex_state = 131},
  [2345] = {.lex_state = 4},
  [2346] = {.lex_state = 4},
  [2347] = {.lex_state = 131},
  [2348] = {.lex_state = 5},
  [2349] = {.lex_state = 131},
  [2350] = {.lex_state = 4},
  [2351] = {.lex_state = 131},
  [2352] = {.lex_state = 5},
  [2353] = {.lex_state = 4},
  [2354] = {.lex_state = 4},
  [2355] = {.lex_state = 4},
  [2356] = {.lex_state = 6, .external_lex_state = 4},
  [2357] = {.lex_state = 4},
  [2358] = {.lex_state = 131},
  [2359] = {.lex_state = 131},
  [2360] = {.lex_state = 4},
  [2361] = {.lex_state = 4},
  [2362] = {.lex_state = 5},
  [2363] = {.lex_state = 5},
  [2364] = {.lex_state = 4},
  [2365] = {.lex_state = 131},
  [2366] = {.lex_state = 4},
  [2367] = {.lex_state = 131},
  [2368] = {.lex_state = 4},
  [2369] = {.lex_state = 4},
  [2370] = {.lex_state = 4},
  [2371] = {.lex_state = 132},
  [2372] = {.lex_state = 6},
  [2373] = {.lex_state = 6},
  [2374] = {.lex_state = 6},
  [2375] = {.lex_state = 4},
  [2376] = {.lex_state = 4},
  [2377] = {.lex_state = 6},
  [2378] = {.lex_state = 6},
  [2379] = {.lex_state = 132},
  [2380] = {.lex_state = 131},
  [2381] = {.lex_state = 4},
  [2382] = {.lex_state = 6},
  [2383] = {.lex_state = 4},
  [2384] = {.lex_state = 132},
  [2385] = {.lex_state = 6},
  [2386] = {.lex_state = 4},
  [2387] = {.lex_state = 4},
  [2388] = {.lex_state = 4},
  [2389] = {.lex_state = 4},
  [2390] = {.lex_state = 131, .external_lex_state = 4},
  [2391] = {.lex_state = 4},
  [2392] = {.lex_state = 4},
  [2393] = {.lex_state = 132},
  [2394] = {.lex_state = 6},
  [2395] = {.lex_state = 131},
  [2396] = {.lex_state = 131},
  [2397] = {.lex_state = 4},
  [2398] = {.lex_state = 131},
  [2399] = {.lex_state = 131},
  [2400] = {.lex_state = 4},
  [2401] = {.lex_state = 4},
  [2402] = {.lex_state = 5},
  [2403] = {.lex_state = 131},
  [2404] = {.lex_state = 4},
  [2405] = {.lex_state = 131},
  [2406] = {.lex_state = 4},
  [2407] = {.lex_state = 131},
  [2408] = {.lex_state = 131},
  [2409] = {.lex_state = 4},
  [2410] = {.lex_state = 131},
  [2411] = {.lex_state = 131},
  [2412] = {.lex_state = 131},
  [2413] = {.lex_state = 131},
  [2414] = {.lex_state = 4},
  [2415] = {.lex_state = 131},
  [2416] = {.lex_state = 131, .external_lex_state = 4},
  [2417] = {.lex_state = 6},
  [2418] = {.lex_state = 131},
  [2419] = {.lex_state = 131},
  [2420] = {.lex_state = 131, .external_lex_state = 4},
  [2421] = {.lex_state = 131},
  [2422] = {.lex_state = 131, .external_lex_state = 4},
  [2423] = {.lex_state = 131},
  [2424] = {.lex_state = 131},
  [2425] = {.lex_state = 131},
  [2426] = {.lex_state = 4},
  [2427] = {.lex_state = 131},
  [2428] = {.lex_state = 131},
  [2429] = {.lex_state = 131, .external_lex_state = 4},
  [2430] = {.lex_state = 4},
  [2431] = {.lex_state = 131},
  [2432] = {.lex_state = 131},
  [2433] = {.lex_state = 6},
  [2434] = {.lex_state = 131, .external_lex_state = 4},
  [2435] = {.lex_state = 4},
  [2436] = {.lex_state = 5},
  [2437] = {.lex_state = 5},
  [2438] = {.lex_state = 5},
  [2439] = {.lex_state = 5},
  [2440] = {.lex_state = 131},
  [2441] = {.lex_state = 6},
  [2442] = {.lex_state = 131},
  [2443] = {.lex_state = 5},
  [2444] = {.lex_state = 6},
  [2445] = {.lex_state = 131},
  [2446] = {.lex_state = 131},
  [2447] = {.lex_state = 131},
  [2448] = {.lex_state = 131},
  [2449] = {.lex_state = 131},
  [2450] = {.lex_state = 131},
  [2451] = {.lex_state = 6},
  [2452] = {.lex_state = 5},
  [2453] = {.lex_state = 5},
  [2454] = {.lex_state = 5},
  [2455] = {.lex_state = 5},
  [2456] = {.lex_state = 5},
  [2457] = {.lex_state = 5},
  [2458] = {.lex_state = 5},
  [2459] = {.lex_state = 6},
  [2460] = {.lex_state = 131},
  [2461] = {.lex_state = 131},
  [2462] = {.lex_state = 6},
  [2463] = {.lex_state = 5},
  [2464] = {.lex_state = 131},
  [2465] = {.lex_state = 5},
  [2466] = {.lex_state = 6},
  [2467] = {.lex_state = 5},
  [2468] = {.lex_state = 6},
  [2469] = {.lex_state = 5},
  [2470] = {.lex_state = 6},
  [2471] = {.lex_state = 5},
  [2472] = {.lex_state = 5},
  [2473] = {.lex_state = 131},
  [2474] = {.lex_state = 5},
  [2475] = {.lex_state = 131},
  [2476] = {.lex_state = 131},
  [2477] = {.lex_state = 5},
  [2478] = {.lex_state = 131},
  [2479] = {.lex_state = 5},
  [2480] = {.lex_state = 131},
  [2481] = {.lex_state = 131},
  [2482] = {.lex_state = 131},
  [2483] = {.lex_state = 131},
  [2484] = {.lex_state = 131},
  [2485] = {.lex_state = 131},
  [2486] = {.lex_state = 131},
  [2487] = {.lex_state = 5},
  [2488] = {.lex_state = 131},
  [2489] = {.lex_state = 131},
  [2490] = {.lex_state = 131},
  [2491] = {.lex_state = 5},
  [2492] = {.lex_state = 5},
  [2493] = {.lex_state = 131},
  [2494] = {.lex_state = 131},
  [2495] = {.lex_state = 5},
  [2496] = {.lex_state = 131},
  [2497] = {.lex_state = 131},
  [2498] = {.lex_state = 131},
  [2499] = {.lex_state = 131},
  [2500] = {.lex_state = 5},
  [2501] = {.lex_state = 131},
  [2502] = {.lex_state = 131},
  [2503] = {.lex_state = 5},
  [2504] = {.lex_state = 131},
  [2505] = {.lex_state = 131},
  [2506] = {.lex_state = 131},
  [2507] = {.lex_state = 131},
  [2508] = {.lex_state = 131},
  [2509] = {.lex_state = 131},
  [2510] = {.lex_state = 132},
  [2511] = {.lex_state = 131},
  [2512] = {.lex_state = 6},
  [2513] = {.lex_state = 6},
  [2514] = {.lex_state = 131},
  [2515] = {.lex_state = 6},
  [2516] = {.lex_state = 131, .external_lex_state = 4},
  [2517] = {.lex_state = 131, .external_lex_state = 4},
  [2518] = {.lex_state = 131},
  [2519] = {.lex_state = 131},
  [2520] = {.lex_state = 6},
  [2521] = {.lex_state = 131},
  [2522] = {.lex_state = 131},
  [2523] = {.lex_state = 131},
  [2524] = {.lex_state = 131},
  [2525] = {.lex_state = 131},
  [2526] = {.lex_state = 131},
  [2527] = {.lex_state = 131, .external_lex_state = 4},
  [2528] = {.lex_state = 131},
  [2529] = {.lex_state = 131, .external_lex_state = 4},
  [2530] = {.lex_state = 131},
  [2531] = {.lex_state = 131},
  [2532] = {.lex_state = 132},
  [2533] = {.lex_state = 131},
  [2534] = {.lex_state = 131},
  [2535] = {.lex_state = 131},
  [2536] = {.lex_state = 131},
  [2537] = {.lex_state = 131},
  [2538] = {.lex_state = 6},
  [2539] = {.lex_state = 6},
  [2540] = {.lex_state = 131},
  [2541] = {.lex_state = 132},
  [2542] = {.lex_state = 132},
  [2543] = {.lex_state = 131},
  [2544] = {.lex_state = 131, .external_lex_state = 4},
  [2545] = {.lex_state = 132},
  [2546] = {.lex_state = 132},
  [2547] = {.lex_state = 132},
  [2548] = {.lex_state = 132},
  [2549] = {.lex_state = 132},
  [2550] = {.lex_state = 132},
  [2551] = {.lex_state = 132},
  [2552] = {.lex_state = 132},
  [2553] = {.lex_state = 131, .external_lex_state = 4},
  [2554] = {.lex_state = 132},
  [2555] = {.lex_state = 132},
  [2556] = {.lex_state = 132},
  [2557] = {.lex_state = 132},
  [2558] = {.lex_state = 132},
  [2559] = {.lex_state = 131},
  [2560] = {.lex_state = 131},
  [2561] = {.lex_state = 132},
  [2562] = {.lex_state = 132},
  [2563] = {.lex_state = 132},
  [2564] = {.lex_state = 132},
  [2565] = {.lex_state = 132},
  [2566] = {.lex_state = 132},
  [2567] = {.lex_state = 132},
  [2568] = {.lex_state = 131},
  [2569] = {.lex_state = 131, .external_lex_state = 4},
  [2570] = {.lex_state = 131, .external_lex_state = 4},
  [2571] = {.lex_state = 131, .external_lex_state = 4},
  [2572] = {.lex_state = 131, .external_lex_state = 4},
  [2573] = {.lex_state = 131},
  [2574] = {.lex_state = 131},
  [2575] = {.lex_state = 131},
  [2576] = {.lex_state = 6},
  [2577] = {.lex_state = 131},
  [2578] = {.lex_state = 131},
  [2579] = {.lex_state = 131, .external_lex_state = 4},
  [2580] = {.lex_state = 131, .external_lex_state = 4},
  [2581] = {.lex_state = 132},
  [2582] = {.lex_state = 131},
  [2583] = {.lex_state = 131, .external_lex_state = 4},
  [2584] = {.lex_state = 131, .external_lex_state = 4},
  [2585] = {.lex_state = 131, .external_lex_state = 4},
  [2586] = {.lex_state = 131, .external_lex_state = 4},
  [2587] = {.lex_state = 131, .external_lex_state = 4},
  [2588] = {.lex_state = 131, .external_lex_state = 4},
  [2589] = {.lex_state = 131},
  [2590] = {.lex_state = 131},
  [2591] = {.lex_state = 131},
  [2592] = {.lex_state = 131},
  [2593] = {.lex_state = 131},
  [2594] = {.lex_state = 131},
  [2595] = {.lex_state = 131},
  [2596] = {.lex_state = 131},
  [2597] = {.lex_state = 131},
  [2598] = {.lex_state = 131},
  [2599] = {.lex_state = 5},
  [2600] = {.lex_state = 131},
  [2601] = {.lex_state = 131},
  [2602] = {.lex_state = 6, .external_lex_state = 4},
  [2603] = {.lex_state = 131},
  [2604] = {.lex_state = 5},
  [2605] = {.lex_state = 132},
  [2606] = {.lex_state = 131},
  [2607] = {.lex_state = 131},
  [2608] = {.lex_state = 131},
  [2609] = {.lex_state = 131},
  [2610] = {.lex_state = 131},
  [2611] = {.lex_state = 131},
  [2612] = {.lex_state = 131},
  [2613] = {.lex_state = 131},
  [2614] = {.lex_state = 132},
  [2615] = {.lex_state = 131},
  [2616] = {.lex_state = 5},
  [2617] = {.lex_state = 132},
  [2618] = {.lex_state = 131},
  [2619] = {.lex_state = 131},
  [2620] = {.lex_state = 131},
  [2621] = {.lex_state = 131},
  [2622] = {.lex_state = 131},
  [2623] = {.lex_state = 5},
  [2624] = {.lex_state = 131},
  [2625] = {.lex_state = 5},
  [2626] = {.lex_state = 5},
  [2627] = {.lex_state = 5},
  [2628] = {.lex_state = 131},
  [2629] = {.lex_state = 5},
  [2630] = {.lex_state = 131},
  [2631] = {.lex_state = 5},
  [2632] = {.lex_state = 131},
  [2633] = {.lex_state = 5},
  [2634] = {.lex_state = 5},
  [2635] = {.lex_state = 131},
  [2636] = {.lex_state = 5},
  [2637] = {.lex_state = 131},
  [2638] = {.lex_state = 5},
  [2639] = {.lex_state = 132},
  [2640] = {.lex_state = 131},
  [2641] = {.lex_state = 5},
  [2642] = {.lex_state = 131},
  [2643] = {.lex_state = 131},
  [2644] = {.lex_state = 131, .external_lex_state = 4},
  [2645] = {.lex_state = 5},
  [2646] = {.lex_state = 5},
  [2647] = {.lex_state = 6, .external_lex_state = 4},
  [2648] = {.lex_state = 5},
  [2649] = {.lex_state = 132},
  [2650] = {.lex_state = 131},
  [2651] = {.lex_state = 132},
  [2652] = {.lex_state = 6, .external_lex_state = 4},
  [2653] = {.lex_state = 5},
  [2654] = {.lex_state = 131},
  [2655] = {.lex_state = 5},
  [2656] = {.lex_state = 131, .external_lex_state = 4},
  [2657] = {.lex_state = 6, .external_lex_state = 4},
  [2658] = {.lex_state = 131},
  [2659] = {.lex_state = 131},
  [2660] = {.lex_state = 131},
  [2661] = {.lex_state = 131},
  [2662] = {.lex_state = 131},
  [2663] = {.lex_state = 132},
  [2664] = {.lex_state = 5},
  [2665] = {.lex_state = 5},
  [2666] = {.lex_state = 131},
  [2667] = {.lex_state = 131},
  [2668] = {.lex_state = 131},
  [2669] = {.lex_state = 132},
  [2670] = {.lex_state = 5},
  [2671] = {.lex_state = 131},
  [2672] = {.lex_state = 131},
  [2673] = {.lex_state = 131, .external_lex_state = 4},
  [2674] = {.lex_state = 132},
  [2675] = {.lex_state = 131},
  [2676] = {.lex_state = 131},
  [2677] = {.lex_state = 5},
  [2678] = {.lex_state = 132},
  [2679] = {.lex_state = 131},
  [2680] = {.lex_state = 131},
  [2681] = {.lex_state = 131},
  [2682] = {.lex_state = 5},
  [2683] = {.lex_state = 131},
  [2684] = {.lex_state = 132},
  [2685] = {.lex_state = 132},
  [2686] = {.lex_state = 132},
  [2687] = {.lex_state = 132},
  [2688] = {.lex_state = 132},
  [2689] = {.lex_state = 132},
  [2690] = {.lex_state = 132},
  [2691] = {.lex_state = 131},
  [2692] = {.lex_state = 5},
  [2693] = {.lex_state = 132},
  [2694] = {.lex_state = 132},
  [2695] = {.lex_state = 132},
  [2696] = {.lex_state = 132},
  [2697] = {.lex_state = 131},
  [2698] = {.lex_state = 131},
  [2699] = {.lex_state = 131},
  [2700] = {.lex_state = 5},
  [2701] = {.lex_state = 131, .external_lex_state = 4},
  [2702] = {.lex_state = 132},
  [2703] = {.lex_state = 132},
  [2704] = {.lex_state = 132},
  [2705] = {.lex_state = 131},
  [2706] = {.lex_state = 5},
  [2707] = {.lex_state = 131, .external_lex_state = 4},
  [2708] = {.lex_state = 132},
  [2709] = {.lex_state = 132},
  [2710] = {.lex_state = 131, .external_lex_state = 4},
  [2711] = {.lex_state = 5},
  [2712] = {.lex_state = 5},
  [2713] = {.lex_state = 131, .external_lex_state = 4},
  [2714] = {.lex_state = 131, .external_lex_state = 4},
  [2715] = {.lex_state = 131, .external_lex_state = 4},
  [2716] = {.lex_state = 131, .external_lex_state = 4},
  [2717] = {.lex_state = 131, .external_lex_state = 4},
  [2718] = {.lex_state = 5},
  [2719] = {.lex_state = 131, .external_lex_state = 4},
  [2720] = {.lex_state = 5},
  [2721] = {.lex_state = 131, .external_lex_state = 4},
  [2722] = {.lex_state = 132},
  [2723] = {.lex_state = 132},
  [2724] = {.lex_state = 5},
  [2725] = {.lex_state = 132},
  [2726] = {.lex_state = 132},
  [2727] = {.lex_state = 5},
  [2728] = {.lex_state = 5},
  [2729] = {.lex_state = 132},
  [2730] = {.lex_state = 132},
  [2731] = {.lex_state = 132},
  [2732] = {.lex_state = 131, .external_lex_state = 4},
  [2733] = {.lex_state = 132},
  [2734] = {.lex_state = 132},
  [2735] = {.lex_state = 132},
  [2736] = {.lex_state = 132},
  [2737] = {.lex_state = 131, .external_lex_state = 4},
  [2738] = {.lex_state = 131, .external_lex_state = 4},
  [2739] = {.lex_state = 5},
  [2740] = {.lex_state = 132},
  [2741] = {.lex_state = 131, .external_lex_state = 4},
  [2742] = {.lex_state = 131, .external_lex_state = 4},
  [2743] = {.lex_state = 132},
  [2744] = {.lex_state = 132},
  [2745] = {.lex_state = 5},
  [2746] = {.lex_state = 131, .external_lex_state = 4},
  [2747] = {.lex_state = 131},
  [2748] = {.lex_state = 131, .external_lex_state = 4},
  [2749] = {.lex_state = 132},
  [2750] = {.lex_state = 132},
  [2751] = {.lex_state = 132},
  [2752] = {.lex_state = 132},
  [2753] = {.lex_state = 131},
  [2754] = {.lex_state = 132},
  [2755] = {.lex_state = 132},
  [2756] = {.lex_state = 132},
  [2757] = {.lex_state = 132},
  [2758] = {.lex_state = 132},
  [2759] = {.lex_state = 131, .external_lex_state = 4},
  [2760] = {.lex_state = 132},
  [2761] = {.lex_state = 132},
  [2762] = {.lex_state = 132},
  [2763] = {.lex_state = 132},
  [2764] = {.lex_state = 131},
  [2765] = {.lex_state = 132},
  [2766] = {.lex_state = 132},
  [2767] = {.lex_state = 5},
  [2768] = {.lex_state = 132},
  [2769] = {.lex_state = 132},
  [2770] = {.lex_state = 132},
  [2771] = {.lex_state = 131},
  [2772] = {.lex_state = 132},
  [2773] = {.lex_state = 132},
  [2774] = {.lex_state = 131},
  [2775] = {.lex_state = 131},
  [2776] = {.lex_state = 132},
  [2777] = {.lex_state = 131},
  [2778] = {.lex_state = 131, .external_lex_state = 4},
  [2779] = {.lex_state = 132},
  [2780] = {.lex_state = 132},
  [2781] = {.lex_state = 132},
  [2782] = {.lex_state = 131},
  [2783] = {.lex_state = 132},
  [2784] = {.lex_state = 132},
  [2785] = {.lex_state = 132},
  [2786] = {.lex_state = 132},
  [2787] = {.lex_state = 132},
  [2788] = {.lex_state = 132},
  [2789] = {.lex_state = 132},
  [2790] = {.lex_state = 132},
  [2791] = {.lex_state = 132},
  [2792] = {.lex_state = 132},
  [2793] = {.lex_state = 132},
  [2794] = {.lex_state = 132},
  [2795] = {.lex_state = 132},
  [2796] = {.lex_state = 132},
  [2797] = {.lex_state = 132},
  [2798] = {.lex_state = 131},
  [2799] = {.lex_state = 132},
  [2800] = {.lex_state = 132},
  [2801] = {.lex_state = 132},
  [2802] = {.lex_state = 131},
  [2803] = {.lex_state = 132},
  [2804] = {.lex_state = 132},
  [2805] = {.lex_state = 5},
  [2806] = {.lex_state = 131},
  [2807] = {.lex_state = 132},
  [2808] = {.lex_state = 132},
  [2809] = {.lex_state = 131, .external_lex_state = 4},
  [2810] = {.lex_state = 131, .external_lex_state = 4},
  [2811] = {.lex_state = 131, .external_lex_state = 4},
  [2812] = {.lex_state = 132},
  [2813] = {.lex_state = 131, .external_lex_state = 4},
  [2814] = {.lex_state = 132},
  [2815] = {.lex_state = 132},
  [2816] = {.lex_state = 131, .external_lex_state = 4},
  [2817] = {.lex_state = 131, .external_lex_state = 4},
  [2818] = {.lex_state = 132},
  [2819] = {.lex_state = 132},
  [2820] = {.lex_state = 131},
  [2821] = {.lex_state = 131},
  [2822] = {.lex_state = 132},
  [2823] = {.lex_state = 132},
  [2824] = {.lex_state = 131},
  [2825] = {.lex_state = 131},
  [2826] = {.lex_state = 132},
  [2827] = {.lex_state = 132},
  [2828] = {.lex_state = 132},
  [2829] = {.lex_state = 131, .external_lex_state = 4},
  [2830] = {.lex_state = 131},
  [2831] = {.lex_state = 131},
  [2832] = {.lex_state = 132},
  [2833] = {.lex_state = 132},
  [2834] = {.lex_state = 131},
  [2835] = {.lex_state = 131},
  [2836] = {.lex_state = 132},
  [2837] = {.lex_state = 132},
  [2838] = {.lex_state = 132},
  [2839] = {.lex_state = 132},
  [2840] = {.lex_state = 131, .external_lex_state = 4},
  [2841] = {.lex_state = 131},
  [2842] = {.lex_state = 132},
  [2843] = {.lex_state = 131},
  [2844] = {.lex_state = 131},
  [2845] = {.lex_state = 131},
  [2846] = {.lex_state = 131, .external_lex_state = 4},
  [2847] = {.lex_state = 5},
  [2848] = {.lex_state = 131, .external_lex_state = 4},
  [2849] = {.lex_state = 131, .external_lex_state = 4},
  [2850] = {.lex_state = 132},
  [2851] = {.lex_state = 132},
  [2852] = {.lex_state = 132},
  [2853] = {.lex_state = 132},
  [2854] = {.lex_state = 132},
  [2855] = {.lex_state = 131, .external_lex_state = 4},
  [2856] = {.lex_state = 131, .external_lex_state = 4},
  [2857] = {.lex_state = 131, .external_lex_state = 4},
  [2858] = {.lex_state = 131},
  [2859] = {.lex_state = 131, .external_lex_state = 4},
  [2860] = {.lex_state = 132},
  [2861] = {.lex_state = 131},
  [2862] = {.lex_state = 131},
  [2863] = {.lex_state = 131},
  [2864] = {.lex_state = 132},
  [2865] = {.lex_state = 131, .external_lex_state = 4},
  [2866] = {.lex_state = 132},
  [2867] = {.lex_state = 132},
  [2868] = {.lex_state = 132},
  [2869] = {.lex_state = 132},
  [2870] = {.lex_state = 5},
  [2871] = {.lex_state = 131, .external_lex_state = 4},
  [2872] = {.lex_state = 132},
  [2873] = {.lex_state = 131},
  [2874] = {.lex_state = 131},
  [2875] = {.lex_state = 131},
  [2876] = {.lex_state = 131},
  [2877] = {.lex_state = 131, .external_lex_state = 4},
  [2878] = {.lex_state = 131},
  [2879] = {.lex_state = 131},
  [2880] = {.lex_state = 131},
  [2881] = {.lex_state = 131},
  [2882] = {.lex_state = 132},
  [2883] = {.lex_state = 132},
  [2884] = {.lex_state = 132},
  [2885] = {.lex_state = 132},
  [2886] = {.lex_state = 132},
  [2887] = {.lex_state = 131, .external_lex_state = 4},
  [2888] = {.lex_state = 132},
  [2889] = {.lex_state = 131, .external_lex_state = 4},
  [2890] = {.lex_state = 131, .external_lex_state = 4},
  [2891] = {.lex_state = 131, .external_lex_state = 4},
  [2892] = {.lex_state = 132},
  [2893] = {.lex_state = 132},
  [2894] = {.lex_state = 131, .external_lex_state = 4},
  [2895] = {.lex_state = 131, .external_lex_state = 4},
  [2896] = {.lex_state = 131},
  [2897] = {.lex_state = 131},
  [2898] = {.lex_state = 131},
  [2899] = {.lex_state = 131},
  [2900] = {.lex_state = 132},
  [2901] = {.lex_state = 131},
  [2902] = {.lex_state = 132},
  [2903] = {.lex_state = 131},
  [2904] = {.lex_state = 131},
  [2905] = {.lex_state = 131},
  [2906] = {.lex_state = 131},
  [2907] = {.lex_state = 132},
  [2908] = {.lex_state = 131},
  [2909] = {.lex_state = 131},
  [2910] = {.lex_state = 131},
  [2911] = {.lex_state = 131},
  [2912] = {.lex_state = 5},
  [2913] = {.lex_state = 132},
  [2914] = {.lex_state = 5},
  [2915] = {.lex_state = 131},
  [2916] = {.lex_state = 131},
  [2917] = {.lex_state = 5},
  [2918] = {.lex_state = 131},
  [2919] = {.lex_state = 132},
  [2920] = {.lex_state = 131},
  [2921] = {.lex_state = 132},
  [2922] = {.lex_state = 132},
  [2923] = {.lex_state = 131},
  [2924] = {.lex_state = 131},
  [2925] = {.lex_state = 132},
  [2926] = {.lex_state = 132},
  [2927] = {.lex_state = 131},
  [2928] = {.lex_state = 132},
  [2929] = {.lex_state = 131},
  [2930] = {.lex_state = 132},
  [2931] = {.lex_state = 131},
  [2932] = {.lex_state = 131},
  [2933] = {.lex_state = 5},
  [2934] = {.lex_state = 4},
  [2935] = {.lex_state = 131},
  [2936] = {.lex_state = 4},
  [2937] = {.lex_state = 4},
  [2938] = {.lex_state = 4},
  [2939] = {.lex_state = 131},
  [2940] = {.lex_state = 131},
  [2941] = {.lex_state = 132},
  [2942] = {.lex_state = 131},
  [2943] = {.lex_state = 131},
  [2944] = {.lex_state = 4},
  [2945] = {.lex_state = 4},
  [2946] = {.lex_state = 6},
  [2947] = {.lex_state = 4},
  [2948] = {.lex_state = 4},
  [2949] = {.lex_state = 131},
  [2950] = {.lex_state = 131},
  [2951] = {.lex_state = 6},
  [2952] = {.lex_state = 6},
  [2953] = {.lex_state = 4},
  [2954] = {.lex_state = 131},
  [2955] = {.lex_state = 4},
  [2956] = {.lex_state = 131},
  [2957] = {.lex_state = 131},
  [2958] = {.lex_state = 131},
  [2959] = {.lex_state = 131},
  [2960] = {.lex_state = 132},
  [2961] = {.lex_state = 131},
  [2962] = {.lex_state = 131},
  [2963] = {.lex_state = 131},
  [2964] = {.lex_state = 131},
  [2965] = {.lex_state = 131},
  [2966] = {.lex_state = 131},
  [2967] = {.lex_state = 131},
  [2968] = {.lex_state = 131},
  [2969] = {.lex_state = 131},
  [2970] = {.lex_state = 131},
  [2971] = {.lex_state = 131},
  [2972] = {.lex_state = 131},
  [2973] = {.lex_state = 131},
  [2974] = {.lex_state = 131},
  [2975] = {.lex_state = 7},
  [2976] = {.lex_state = 131},
  [2977] = {.lex_state = 131},
  [2978] = {.lex_state = 131},
  [2979] = {.lex_state = 131},
  [2980] = {.lex_state = 6},
  [2981] = {.lex_state = 131},
  [2982] = {.lex_state = 6},
  [2983] = {.lex_state = 131},
  [2984] = {.lex_state = 131},
  [2985] = {.lex_state = 131},
  [2986] = {.lex_state = 131},
  [2987] = {.lex_state = 131},
  [2988] = {.lex_state = 6},
  [2989] = {.lex_state = 6},
  [2990] = {.lex_state = 131},
  [2991] = {.lex_state = 131},
  [2992] = {.lex_state = 131},
  [2993] = {.lex_state = 131},
  [2994] = {.lex_state = 131},
  [2995] = {.lex_state = 131},
  [2996] = {.lex_state = 131},
  [2997] = {.lex_state = 132},
  [2998] = {.lex_state = 131},
  [2999] = {.lex_state = 131},
  [3000] = {.lex_state = 131},
  [3001] = {.lex_state = 131},
  [3002] = {.lex_state = 131},
  [3003] = {.lex_state = 131},
  [3004] = {.lex_state = 131},
  [3005] = {.lex_state = 131},
  [3006] = {.lex_state = 131},
  [3007] = {.lex_state = 131},
  [3008] = {.lex_state = 131},
  [3009] = {.lex_state = 131},
  [3010] = {.lex_state = 131},
  [3011] = {.lex_state = 131},
  [3012] = {.lex_state = 132},
  [3013] = {.lex_state = 131},
  [3014] = {.lex_state = 131},
  [3015] = {.lex_state = 131},
  [3016] = {.lex_state = 131},
  [3017] = {.lex_state = 131},
  [3018] = {.lex_state = 131},
  [3019] = {.lex_state = 131},
  [3020] = {.lex_state = 131},
  [3021] = {.lex_state = 131},
  [3022] = {.lex_state = 131},
  [3023] = {.lex_state = 131},
  [3024] = {.lex_state = 131},
  [3025] = {.lex_state = 131},
  [3026] = {.lex_state = 131},
  [3027] = {.lex_state = 131},
  [3028] = {.lex_state = 131},
  [3029] = {.lex_state = 132},
  [3030] = {.lex_state = 131},
  [3031] = {.lex_state = 132},
  [3032] = {.lex_state = 131},
  [3033] = {.lex_state = 131},
  [3034] = {.lex_state = 132},
  [3035] = {.lex_state = 131},
  [3036] = {.lex_state = 131},
  [3037] = {.lex_state = 131},
  [3038] = {.lex_state = 132},
  [3039] = {.lex_state = 131},
  [3040] = {.lex_state = 10},
  [3041] = {.lex_state = 131},
  [3042] = {.lex_state = 131},
  [3043] = {.lex_state = 131},
  [3044] = {.lex_state = 131},
  [3045] = {.lex_state = 132},
  [3046] = {.lex_state = 131},
  [3047] = {.lex_state = 131},
  [3048] = {.lex_state = 131},
  [3049] = {.lex_state = 131},
  [3050] = {.lex_state = 131},
  [3051] = {.lex_state = 131},
  [3052] = {.lex_state = 131},
  [3053] = {.lex_state = 132},
  [3054] = {.lex_state = 131},
  [3055] = {.lex_state = 131},
  [3056] = {.lex_state = 131},
  [3057] = {.lex_state = 131},
  [3058] = {.lex_state = 131},
  [3059] = {.lex_state = 131},
  [3060] = {.lex_state = 132},
  [3061] = {.lex_state = 131},
  [3062] = {.lex_state = 131},
  [3063] = {.lex_state = 131},
  [3064] = {.lex_state = 131},
  [3065] = {.lex_state = 131},
  [3066] = {.lex_state = 131},
  [3067] = {.lex_state = 131},
  [3068] = {.lex_state = 131},
  [3069] = {.lex_state = 131},
  [3070] = {.lex_state = 131},
  [3071] = {.lex_state = 131},
  [3072] = {.lex_state = 131},
  [3073] = {.lex_state = 131},
  [3074] = {.lex_state = 131},
  [3075] = {.lex_state = 131},
  [3076] = {.lex_state = 131},
  [3077] = {.lex_state = 131},
  [3078] = {.lex_state = 131},
  [3079] = {.lex_state = 131},
  [3080] = {.lex_state = 132},
  [3081] = {.lex_state = 131},
  [3082] = {.lex_state = 131},
  [3083] = {.lex_state = 131},
  [3084] = {.lex_state = 131},
  [3085] = {.lex_state = 131},
  [3086] = {.lex_state = 131},
  [3087] = {.lex_state = 131},
  [3088] = {.lex_state = 131},
  [3089] = {.lex_state = 131},
  [3090] = {.lex_state = 131},
  [3091] = {.lex_state = 131},
  [3092] = {.lex_state = 131},
  [3093] = {.lex_state = 131},
  [3094] = {.lex_state = 4},
  [3095] = {.lex_state = 131},
  [3096] = {.lex_state = 131},
  [3097] = {.lex_state = 131},
  [3098] = {.lex_state = 131},
  [3099] = {.lex_state = 131},
  [3100] = {.lex_state = 131},
  [3101] = {.lex_state = 131},
  [3102] = {.lex_state = 131},
  [3103] = {.lex_state = 4},
  [3104] = {.lex_state = 131},
  [3105] = {.lex_state = 131},
  [3106] = {.lex_state = 131},
  [3107] = {.lex_state = 131},
  [3108] = {.lex_state = 131},
  [3109] = {.lex_state = 131},
  [3110] = {.lex_state = 131},
  [3111] = {.lex_state = 131},
  [3112] = {.lex_state = 131},
  [3113] = {.lex_state = 131},
  [3114] = {.lex_state = 131},
  [3115] = {.lex_state = 131},
  [3116] = {.lex_state = 131},
  [3117] = {.lex_state = 131},
  [3118] = {.lex_state = 4},
  [3119] = {.lex_state = 131},
  [3120] = {.lex_state = 131},
  [3121] = {.lex_state = 131},
  [3122] = {.lex_state = 131},
  [3123] = {.lex_state = 131},
  [3124] = {.lex_state = 131},
  [3125] = {.lex_state = 131},
  [3126] = {.lex_state = 131},
  [3127] = {.lex_state = 131},
  [3128] = {.lex_state = 132},
  [3129] = {.lex_state = 131},
  [3130] = {.lex_state = 131},
  [3131] = {.lex_state = 131},
  [3132] = {.lex_state = 131},
  [3133] = {.lex_state = 131},
  [3134] = {.lex_state = 131},
  [3135] = {.lex_state = 131},
  [3136] = {.lex_state = 132},
  [3137] = {.lex_state = 131},
  [3138] = {.lex_state = 131},
  [3139] = {.lex_state = 131},
  [3140] = {.lex_state = 4},
  [3141] = {.lex_state = 4},
  [3142] = {.lex_state = 131},
  [3143] = {.lex_state = 131},
  [3144] = {.lex_state = 131},
  [3145] = {.lex_state = 131},
  [3146] = {.lex_state = 131},
  [3147] = {.lex_state = 131},
  [3148] = {.lex_state = 131},
  [3149] = {.lex_state = 131},
  [3150] = {.lex_state = 131},
  [3151] = {.lex_state = 131},
  [3152] = {.lex_state = 131},
  [3153] = {.lex_state = 131},
  [3154] = {.lex_state = 131},
  [3155] = {.lex_state = 131},
  [3156] = {.lex_state = 131},
  [3157] = {.lex_state = 132},
  [3158] = {.lex_state = 4},
  [3159] = {.lex_state = 132},
  [3160] = {.lex_state = 132},
  [3161] = {.lex_state = 4},
  [3162] = {.lex_state = 5},
  [3163] = {.lex_state = 4},
  [3164] = {.lex_state = 5},
  [3165] = {.lex_state = 6},
  [3166] = {.lex_state = 132},
  [3167] = {.lex_state = 132},
  [3168] = {.lex_state = 131},
  [3169] = {.lex_state = 131},
  [3170] = {.lex_state = 132},
  [3171] = {.lex_state = 6},
  [3172] = {.lex_state = 131},
  [3173] = {.lex_state = 131},
  [3174] = {.lex_state = 6},
  [3175] = {.lex_state = 6},
  [3176] = {.lex_state = 131},
  [3177] = {.lex_state = 131},
  [3178] = {.lex_state = 4},
  [3179] = {.lex_state = 131},
  [3180] = {.lex_state = 132},
  [3181] = {.lex_state = 5, .external_lex_state = 4},
  [3182] = {.lex_state = 131},
  [3183] = {.lex_state = 132},
  [3184] = {.lex_state = 131},
  [3185] = {.lex_state = 5},
  [3186] = {.lex_state = 5},
  [3187] = {.lex_state = 131},
  [3188] = {.lex_state = 4},
  [3189] = {.lex_state = 131},
  [3190] = {.lex_state = 131},
  [3191] = {.lex_state = 5, .external_lex_state = 4},
  [3192] = {.lex_state = 6},
  [3193] = {.lex_state = 131},
  [3194] = {.lex_state = 6},
  [3195] = {.lex_state = 131},
  [3196] = {.lex_state = 131},
  [3197] = {.lex_state = 5, .external_lex_state = 4},
  [3198] = {.lex_state = 131},
  [3199] = {.lex_state = 131},
  [3200] = {.lex_state = 5},
  [3201] = {.lex_state = 5, .external_lex_state = 4},
  [3202] = {.lex_state = 131},
  [3203] = {.lex_state = 132},
  [3204] = {.lex_state = 131},
  [3205] = {.lex_state = 131},
  [3206] = {.lex_state = 131},
  [3207] = {.lex_state = 131},
  [3208] = {.lex_state = 5, .external_lex_state = 4},
  [3209] = {.lex_state = 131},
  [3210] = {.lex_state = 131},
  [3211] = {.lex_state = 132},
  [3212] = {.lex_state = 5},
  [3213] = {.lex_state = 131},
  [3214] = {.lex_state = 5, .external_lex_state = 4},
  [3215] = {.lex_state = 131},
  [3216] = {.lex_state = 131},
  [3217] = {.lex_state = 131},
  [3218] = {.lex_state = 131},
  [3219] = {.lex_state = 5, .external_lex_state = 4},
  [3220] = {.lex_state = 131},
  [3221] = {.lex_state = 131},
  [3222] = {.lex_state = 131},
  [3223] = {.lex_state = 131},
  [3224] = {.lex_state = 5, .external_lex_state = 4},
  [3225] = {.lex_state = 131},
  [3226] = {.lex_state = 5, .external_lex_state = 4},
  [3227] = {.lex_state = 131},
  [3228] = {.lex_state = 131},
  [3229] = {.lex_state = 5, .external_lex_state = 4},
  [3230] = {.lex_state = 5, .external_lex_state = 4},
  [3231] = {.lex_state = 131},
  [3232] = {.lex_state = 131},
  [3233] = {.lex_state = 131},
  [3234] = {.lex_state = 131},
  [3235] = {.lex_state = 131},
  [3236] = {.lex_state = 5, .external_lex_state = 4},
  [3237] = {.lex_state = 131},
  [3238] = {.lex_state = 131},
  [3239] = {.lex_state = 131},
  [3240] = {.lex_state = 131},
  [3241] = {.lex_state = 131},
  [3242] = {.lex_state = 131},
  [3243] = {.lex_state = 5, .external_lex_state = 4},
  [3244] = {.lex_state = 131},
  [3245] = {.lex_state = 131},
  [3246] = {.lex_state = 5, .external_lex_state = 4},
  [3247] = {.lex_state = 5, .external_lex_state = 4},
  [3248] = {.lex_state = 131},
  [3249] = {.lex_state = 5, .external_lex_state = 4},
  [3250] = {.lex_state = 4},
  [3251] = {.lex_state = 5, .external_lex_state = 4},
  [3252] = {.lex_state = 5, .external_lex_state = 4},
  [3253] = {.lex_state = 5, .external_lex_state = 4},
  [3254] = {.lex_state = 131},
  [3255] = {.lex_state = 5, .external_lex_state = 4},
  [3256] = {.lex_state = 6},
  [3257] = {.lex_state = 131},
  [3258] = {.lex_state = 131},
  [3259] = {.lex_state = 131},
  [3260] = {.lex_state = 5, .external_lex_state = 4},
  [3261] = {.lex_state = 7},
  [3262] = {.lex_state = 131},
  [3263] = {.lex_state = 131},
  [3264] = {.lex_state = 6},
  [3265] = {.lex_state = 131},
  [3266] = {.lex_state = 131},
  [3267] = {.lex_state = 131},
  [3268] = {.lex_state = 131},
  [3269] = {.lex_state = 131},
  [3270] = {.lex_state = 6},
  [3271] = {.lex_state = 131},
  [3272] = {.lex_state = 132},
  [3273] = {.lex_state = 131},
  [3274] = {.lex_state = 131},
  [3275] = {.lex_state = 131},
  [3276] = {.lex_state = 131},
  [3277] = {.lex_state = 131},
  [3278] = {.lex_state = 131},
  [3279] = {.lex_state = 131},
  [3280] = {.lex_state = 131},
  [3281] = {.lex_state = 131},
  [3282] = {.lex_state = 131},
  [3283] = {.lex_state = 131},
  [3284] = {.lex_state = 132},
  [3285] = {.lex_state = 131},
  [3286] = {.lex_state = 131},
  [3287] = {.lex_state = 131},
  [3288] = {.lex_state = 131},
  [3289] = {.lex_state = 131},
  [3290] = {.lex_state = 131},
  [3291] = {.lex_state = 131},
  [3292] = {.lex_state = 131},
  [3293] = {.lex_state = 131},
  [3294] = {.lex_state = 131},
  [3295] = {.lex_state = 131},
  [3296] = {.lex_state = 131},
  [3297] = {.lex_state = 131},
  [3298] = {.lex_state = 131},
  [3299] = {.lex_state = 131},
  [3300] = {.lex_state = 131},
  [3301] = {.lex_state = 131},
  [3302] = {.lex_state = 131},
  [3303] = {.lex_state = 131},
  [3304] = {.lex_state = 131},
  [3305] = {.lex_state = 7},
  [3306] = {.lex_state = 131},
  [3307] = {.lex_state = 131},
  [3308] = {.lex_state = 131},
  [3309] = {.lex_state = 131},
  [3310] = {.lex_state = 132},
  [3311] = {.lex_state = 131},
  [3312] = {.lex_state = 132},
  [3313] = {.lex_state = 132},
  [3314] = {.lex_state = 131},
  [3315] = {.lex_state = 131},
  [3316] = {.lex_state = 131},
  [3317] = {.lex_state = 131},
  [3318] = {.lex_state = 131},
  [3319] = {.lex_state = 131},
  [3320] = {.lex_state = 131},
  [3321] = {.lex_state = 131},
  [3322] = {.lex_state = 131},
  [3323] = {.lex_state = 131},
  [3324] = {.lex_state = 131},
  [3325] = {.lex_state = 131},
  [3326] = {.lex_state = 131},
  [3327] = {.lex_state = 131},
  [3328] = {.lex_state = 131},
  [3329] = {.lex_state = 4},
  [3330] = {.lex_state = 131},
  [3331] = {.lex_state = 131},
  [3332] = {.lex_state = 131},
  [3333] = {.lex_state = 132},
  [3334] = {.lex_state = 131},
  [3335] = {.lex_state = 131},
  [3336] = {.lex_state = 131},
  [3337] = {.lex_state = 131},
  [3338] = {.lex_state = 131},
  [3339] = {.lex_state = 131},
  [3340] = {.lex_state = 131},
  [3341] = {.lex_state = 131},
  [3342] = {.lex_state = 131},
  [3343] = {.lex_state = 131},
  [3344] = {.lex_state = 131},
  [3345] = {.lex_state = 131},
  [3346] = {.lex_state = 131},
  [3347] = {.lex_state = 131},
  [3348] = {.lex_state = 132},
  [3349] = {.lex_state = 131},
  [3350] = {.lex_state = 131},
  [3351] = {.lex_state = 131},
  [3352] = {.lex_state = 131},
  [3353] = {.lex_state = 5, .external_lex_state = 4},
  [3354] = {.lex_state = 131},
  [3355] = {.lex_state = 131},
  [3356] = {.lex_state = 131},
  [3357] = {.lex_state = 131},
  [3358] = {.lex_state = 131},
  [3359] = {.lex_state = 5},
  [3360] = {.lex_state = 131},
  [3361] = {.lex_state = 131},
  [3362] = {.lex_state = 131},
  [3363] = {.lex_state = 131},
  [3364] = {.lex_state = 131},
  [3365] = {.lex_state = 131},
  [3366] = {.lex_state = 131},
  [3367] = {.lex_state = 131},
  [3368] = {.lex_state = 131},
  [3369] = {.lex_state = 131},
  [3370] = {.lex_state = 131},
  [3371] = {.lex_state = 131},
  [3372] = {.lex_state = 131},
  [3373] = {.lex_state = 131},
  [3374] = {.lex_state = 131},
  [3375] = {.lex_state = 131},
  [3376] = {.lex_state = 131},
  [3377] = {.lex_state = 131},
  [3378] = {.lex_state = 131},
  [3379] = {.lex_state = 5},
  [3380] = {.lex_state = 131},
  [3381] = {.lex_state = 131},
  [3382] = {.lex_state = 131},
  [3383] = {.lex_state = 131},
  [3384] = {.lex_state = 131},
  [3385] = {.lex_state = 131},
  [3386] = {.lex_state = 131},
  [3387] = {.lex_state = 131},
  [3388] = {.lex_state = 131},
  [3389] = {.lex_state = 131},
  [3390] = {.lex_state = 131},
  [3391] = {.lex_state = 131},
  [3392] = {.lex_state = 131},
  [3393] = {.lex_state = 131},
  [3394] = {.lex_state = 131},
  [3395] = {.lex_state = 131},
  [3396] = {.lex_state = 131},
  [3397] = {.lex_state = 131},
  [3398] = {.lex_state = 131},
  [3399] = {.lex_state = 131},
  [3400] = {.lex_state = 131},
  [3401] = {.lex_state = 131},
  [3402] = {.lex_state = 131},
  [3403] = {.lex_state = 131},
  [3404] = {.lex_state = 131},
  [3405] = {.lex_state = 131},
  [3406] = {.lex_state = 131},
  [3407] = {.lex_state = 131},
  [3408] = {.lex_state = 131},
  [3409] = {.lex_state = 131},
  [3410] = {.lex_state = 131},
  [3411] = {.lex_state = 131},
  [3412] = {.lex_state = 131},
  [3413] = {.lex_state = 131},
  [3414] = {.lex_state = 132},
  [3415] = {.lex_state = 132},
  [3416] = {.lex_state = 131},
  [3417] = {.lex_state = 131},
  [3418] = {.lex_state = 131},
  [3419] = {.lex_state = 131},
  [3420] = {.lex_state = 131},
  [3421] = {.lex_state = 131},
  [3422] = {.lex_state = 131},
  [3423] = {.lex_state = 131},
  [3424] = {.lex_state = 131},
  [3425] = {.lex_state = 132},
  [3426] = {.lex_state = 131},
  [3427] = {.lex_state = 131},
  [3428] = {.lex_state = 131},
  [3429] = {.lex_state = 131},
  [3430] = {.lex_state = 132},
  [3431] = {.lex_state = 131},
  [3432] = {.lex_state = 131},
  [3433] = {.lex_state = 131},
  [3434] = {.lex_state = 131},
  [3435] = {.lex_state = 131},
  [3436] = {.lex_state = 131},
  [3437] = {.lex_state = 131},
  [3438] = {.lex_state = 131},
  [3439] = {.lex_state = 131},
  [3440] = {.lex_state = 131},
  [3441] = {.lex_state = 131},
  [3442] = {.lex_state = 131},
  [3443] = {.lex_state = 131},
  [3444] = {.lex_state = 131},
  [3445] = {.lex_state = 131},
  [3446] = {.lex_state = 131},
  [3447] = {.lex_state = 131},
  [3448] = {.lex_state = 131},
  [3449] = {.lex_state = 131},
  [3450] = {.lex_state = 131},
  [3451] = {.lex_state = 131},
  [3452] = {.lex_state = 131},
  [3453] = {.lex_state = 132},
  [3454] = {.lex_state = 131},
  [3455] = {.lex_state = 131},
  [3456] = {.lex_state = 131},
  [3457] = {.lex_state = 131},
  [3458] = {.lex_state = 131},
  [3459] = {.lex_state = 131},
  [3460] = {.lex_state = 131},
  [3461] = {.lex_state = 4},
  [3462] = {.lex_state = 132},
  [3463] = {.lex_state = 132},
  [3464] = {.lex_state = 132},
  [3465] = {.lex_state = 132},
  [3466] = {.lex_state = 132},
  [3467] = {.lex_state = 131},
  [3468] = {.lex_state = 131},
  [3469] = {.lex_state = 131},
  [3470] = {.lex_state = 131},
  [3471] = {.lex_state = 132},
  [3472] = {.lex_state = 4},
  [3473] = {.lex_state = 132},
  [3474] = {.lex_state = 132},
  [3475] = {.lex_state = 131},
  [3476] = {.lex_state = 132},
  [3477] = {.lex_state = 132},
  [3478] = {.lex_state = 132},
  [3479] = {.lex_state = 131},
  [3480] = {.lex_state = 5, .external_lex_state = 4},
  [3481] = {.lex_state = 132},
  [3482] = {.lex_state = 131},
  [3483] = {.lex_state = 131},
  [3484] = {.lex_state = 132},
  [3485] = {.lex_state = 131},
  [3486] = {.lex_state = 132},
  [3487] = {.lex_state = 132},
  [3488] = {.lex_state = 131},
  [3489] = {.lex_state = 132},
  [3490] = {.lex_state = 132},
  [3491] = {.lex_state = 132},
  [3492] = {.lex_state = 132},
  [3493] = {.lex_state = 131},
  [3494] = {.lex_state = 4},
  [3495] = {.lex_state = 132},
  [3496] = {.lex_state = 132},
  [3497] = {.lex_state = 132},
  [3498] = {.lex_state = 132},
  [3499] = {.lex_state = 132},
  [3500] = {.lex_state = 132},
  [3501] = {.lex_state = 132},
  [3502] = {.lex_state = 131},
  [3503] = {.lex_state = 131},
  [3504] = {.lex_state = 131},
  [3505] = {.lex_state = 132},
  [3506] = {.lex_state = 132},
  [3507] = {.lex_state = 132},
  [3508] = {.lex_state = 132},
  [3509] = {.lex_state = 132},
  [3510] = {.lex_state = 5},
  [3511] = {.lex_state = 4},
  [3512] = {.lex_state = 132},
  [3513] = {.lex_state = 132},
  [3514] = {.lex_state = 132},
  [3515] = {.lex_state = 132},
  [3516] = {.lex_state = 132},
  [3517] = {.lex_state = 4},
  [3518] = {.lex_state = 131},
  [3519] = {.lex_state = 132},
  [3520] = {.lex_state = 132},
  [3521] = {.lex_state = 132},
  [3522] = {.lex_state = 132},
  [3523] = {.lex_state = 4},
  [3524] = {.lex_state = 5},
  [3525] = {.lex_state = 132},
  [3526] = {.lex_state = 132},
  [3527] = {.lex_state = 132},
  [3528] = {.lex_state = 132},
  [3529] = {.lex_state = 4},
  [3530] = {.lex_state = 131},
  [3531] = {.lex_state = 131},
  [3532] = {.lex_state = 5},
  [3533] = {.lex_state = 131},
  [3534] = {.lex_state = 131},
  [3535] = {.lex_state = 131},
  [3536] = {.lex_state = 131},
  [3537] = {.lex_state = 131},
  [3538] = {.lex_state = 131},
  [3539] = {.lex_state = 132},
  [3540] = {.lex_state = 131},
  [3541] = {.lex_state = 131},
  [3542] = {.lex_state = 132},
  [3543] = {.lex_state = 131},
  [3544] = {.lex_state = 132},
  [3545] = {.lex_state = 131},
  [3546] = {.lex_state = 131},
  [3547] = {.lex_state = 131},
  [3548] = {.lex_state = 131},
  [3549] = {.lex_state = 131},
  [3550] = {.lex_state = 132},
  [3551] = {.lex_state = 132},
  [3552] = {.lex_state = 131},
  [3553] = {.lex_state = 131},
  [3554] = {.lex_state = 131},
  [3555] = {.lex_state = 131},
  [3556] = {.lex_state = 132},
  [3557] = {.lex_state = 4},
  [3558] = {.lex_state = 132},
  [3559] = {.lex_state = 4},
  [3560] = {.lex_state = 4},
  [3561] = {.lex_state = 132},
  [3562] = {.lex_state = 132},
  [3563] = {.lex_state = 131},
  [3564] = {.lex_state = 131},
  [3565] = {.lex_state = 132},
  [3566] = {.lex_state = 132},
  [3567] = {.lex_state = 132},
  [3568] = {.lex_state = 4},
  [3569] = {.lex_state = 132},
  [3570] = {.lex_state = 132},
  [3571] = {.lex_state = 132},
  [3572] = {.lex_state = 4},
  [3573] = {.lex_state = 5},
  [3574] = {.lex_state = 132},
  [3575] = {.lex_state = 5},
  [3576] = {.lex_state = 132},
  [3577] = {.lex_state = 132},
  [3578] = {.lex_state = 4},
  [3579] = {.lex_state = 131},
  [3580] = {.lex_state = 132},
  [3581] = {.lex_state = 5, .external_lex_state = 4},
  [3582] = {.lex_state = 4},
  [3583] = {.lex_state = 131},
  [3584] = {.lex_state = 131},
  [3585] = {.lex_state = 132},
  [3586] = {.lex_state = 131},
  [3587] = {.lex_state = 132},
  [3588] = {.lex_state = 132},
  [3589] = {.lex_state = 132},
  [3590] = {.lex_state = 4},
  [3591] = {.lex_state = 10},
  [3592] = {.lex_state = 10},
  [3593] = {.lex_state = 131},
  [3594] = {.lex_state = 131},
  [3595] = {.lex_state = 131},
  [3596] = {.lex_state = 131},
  [3597] = {.lex_state = 131},
  [3598] = {.lex_state = 132},
  [3599] = {.lex_state = 10},
  [3600] = {.lex_state = 132},
  [3601] = {.lex_state = 132},
  [3602] = {.lex_state = 10},
  [3603] = {.lex_state = 132},
  [3604] = {.lex_state = 132},
  [3605] = {.lex_state = 132},
  [3606] = {.lex_state = 132},
  [3607] = {.lex_state = 131},
  [3608] = {.lex_state = 132},
  [3609] = {.lex_state = 132},
  [3610] = {.lex_state = 131},
  [3611] = {.lex_state = 132},
  [3612] = {.lex_state = 132},
  [3613] = {.lex_state = 10},
  [3614] = {.lex_state = 132},
  [3615] = {.lex_state = 131},
  [3616] = {.lex_state = 131},
  [3617] = {.lex_state = 132},
  [3618] = {.lex_state = 132},
  [3619] = {.lex_state = 132},
  [3620] = {.lex_state = 132},
  [3621] = {.lex_state = 132},
  [3622] = {.lex_state = 132},
  [3623] = {.lex_state = 10},
  [3624] = {.lex_state = 132},
  [3625] = {.lex_state = 131},
  [3626] = {.lex_state = 4},
  [3627] = {.lex_state = 132},
  [3628] = {.lex_state = 132},
  [3629] = {.lex_state = 132},
  [3630] = {.lex_state = 131},
  [3631] = {.lex_state = 132},
  [3632] = {.lex_state = 132},
  [3633] = {.lex_state = 4},
  [3634] = {.lex_state = 4},
  [3635] = {.lex_state = 10},
  [3636] = {.lex_state = 10},
  [3637] = {.lex_state = 132},
  [3638] = {.lex_state = 4},
  [3639] = {.lex_state = 131},
  [3640] = {.lex_state = 132},
  [3641] = {.lex_state = 4},
  [3642] = {.lex_state = 132},
  [3643] = {.lex_state = 4},
  [3644] = {.lex_state = 10},
  [3645] = {.lex_state = 132},
  [3646] = {.lex_state = 132},
  [3647] = {.lex_state = 131},
  [3648] = {.lex_state = 131},
  [3649] = {.lex_state = 131},
  [3650] = {.lex_state = 131},
  [3651] = {.lex_state = 132},
  [3652] = {.lex_state = 132},
  [3653] = {.lex_state = 131},
  [3654] = {.lex_state = 131},
  [3655] = {.lex_state = 131},
  [3656] = {.lex_state = 132},
  [3657] = {.lex_state = 131},
  [3658] = {.lex_state = 4},
  [3659] = {.lex_state = 131},
  [3660] = {.lex_state = 132},
  [3661] = {.lex_state = 131},
  [3662] = {.lex_state = 131},
  [3663] = {.lex_state = 132},
  [3664] = {.lex_state = 131},
  [3665] = {.lex_state = 10},
  [3666] = {.lex_state = 4},
  [3667] = {.lex_state = 132},
  [3668] = {.lex_state = 131},
  [3669] = {.lex_state = 132},
  [3670] = {.lex_state = 10},
  [3671] = {.lex_state = 132},
  [3672] = {.lex_state = 4},
  [3673] = {.lex_state = 131},
  [3674] = {.lex_state = 10},
  [3675] = {.lex_state = 132},
  [3676] = {.lex_state = 132},
  [3677] = {.lex_state = 132},
  [3678] = {.lex_state = 4},
  [3679] = {.lex_state = 132},
  [3680] = {.lex_state = 131},
  [3681] = {.lex_state = 10},
  [3682] = {.lex_state = 131},
  [3683] = {.lex_state = 132},
  [3684] = {.lex_state = 132},
  [3685] = {.lex_state = 132},
  [3686] = {.lex_state = 4},
  [3687] = {.lex_state = 132},
  [3688] = {.lex_state = 10},
  [3689] = {.lex_state = 131},
  [3690] = {.lex_state = 131},
  [3691] = {.lex_state = 131},
  [3692] = {.lex_state = 131},
  [3693] = {.lex_state = 131},
  [3694] = {.lex_state = 131},
  [3695] = {.lex_state = 131},
  [3696] = {.lex_state = 131},
  [3697] = {.lex_state = 132},
  [3698] = {.lex_state = 131},
  [3699] = {.lex_state = 131},
  [3700] = {.lex_state = 131},
  [3701] = {.lex_state = 131},
  [3702] = {.lex_state = 131},
  [3703] = {.lex_state = 131},
  [3704] = {.lex_state = 131},
  [3705] = {.lex_state = 10},
  [3706] = {.lex_state = 131},
  [3707] = {.lex_state = 131},
  [3708] = {.lex_state = 131},
  [3709] = {.lex_state = 4},
  [3710] = {.lex_state = 131},
  [3711] = {.lex_state = 131},
  [3712] = {.lex_state = 7},
  [3713] = {.lex_state = 131},
  [3714] = {.lex_state = 4},
  [3715] = {.lex_state = 131},
  [3716] = {.lex_state = 131},
  [3717] = {.lex_state = 131},
  [3718] = {.lex_state = 132},
  [3719] = {.lex_state = 5},
  [3720] = {.lex_state = 4},
  [3721] = {.lex_state = 132},
  [3722] = {.lex_state = 131},
  [3723] = {.lex_state = 4},
  [3724] = {.lex_state = 132},
  [3725] = {.lex_state = 132},
  [3726] = {.lex_state = 131},
  [3727] = {.lex_state = 131},
  [3728] = {.lex_state = 10},
  [3729] = {.lex_state = 131},
  [3730] = {.lex_state = 132},
  [3731] = {.lex_state = 4},
  [3732] = {.lex_state = 131},
  [3733] = {.lex_state = 131},
  [3734] = {.lex_state = 132},
  [3735] = {.lex_state = 131},
  [3736] = {.lex_state = 132},
  [3737] = {.lex_state = 131},
  [3738] = {.lex_state = 132},
  [3739] = {.lex_state = 132},
  [3740] = {.lex_state = 132},
  [3741] = {.lex_state = 131},
  [3742] = {.lex_state = 131},
  [3743] = {.lex_state = 131},
  [3744] = {.lex_state = 132},
  [3745] = {.lex_state = 131},
  [3746] = {.lex_state = 131},
  [3747] = {.lex_state = 131},
  [3748] = {.lex_state = 132},
  [3749] = {.lex_state = 132},
  [3750] = {.lex_state = 132},
  [3751] = {.lex_state = 132},
  [3752] = {.lex_state = 132},
  [3753] = {.lex_state = 132},
  [3754] = {.lex_state = 132},
  [3755] = {.lex_state = 132},
  [3756] = {.lex_state = 131},
  [3757] = {.lex_state = 131},
  [3758] = {.lex_state = 132},
  [3759] = {.lex_state = 132},
  [3760] = {.lex_state = 131},
  [3761] = {.lex_state = 131},
  [3762] = {.lex_state = 131},
  [3763] = {.lex_state = 132},
  [3764] = {.lex_state = 131},
  [3765] = {.lex_state = 131},
  [3766] = {.lex_state = 131},
  [3767] = {.lex_state = 131},
  [3768] = {.lex_state = 131},
  [3769] = {.lex_state = 131},
  [3770] = {.lex_state = 131},
  [3771] = {.lex_state = 131},
  [3772] = {.lex_state = 131},
  [3773] = {.lex_state = 131},
  [3774] = {.lex_state = 132},
  [3775] = {.lex_state = 131},
  [3776] = {.lex_state = 131},
  [3777] = {.lex_state = 131},
  [3778] = {.lex_state = 131},
  [3779] = {.lex_state = 131},
  [3780] = {.lex_state = 131},
  [3781] = {.lex_state = 131},
  [3782] = {.lex_state = 131},
  [3783] = {.lex_state = 131},
  [3784] = {.lex_state = 131},
  [3785] = {.lex_state = 131},
  [3786] = {.lex_state = 132},
  [3787] = {.lex_state = 6},
  [3788] = {.lex_state = 131},
  [3789] = {.lex_state = 132},
  [3790] = {.lex_state = 132},
  [3791] = {.lex_state = 131},
  [3792] = {.lex_state = 132},
  [3793] = {.lex_state = 132},
  [3794] = {.lex_state = 131},
  [3795] = {.lex_state = 131},
  [3796] = {.lex_state = 132},
  [3797] = {.lex_state = 131},
  [3798] = {.lex_state = 132},
  [3799] = {.lex_state = 131},
  [3800] = {.lex_state = 131},
  [3801] = {.lex_state = 131},
  [3802] = {.lex_state = 131},
  [3803] = {.lex_state = 131},
  [3804] = {.lex_state = 131},
  [3805] = {.lex_state = 131},
  [3806] = {.lex_state = 131},
  [3807] = {.lex_state = 131},
  [3808] = {.lex_state = 131},
  [3809] = {.lex_state = 131},
  [3810] = {.lex_state = 131},
  [3811] = {.lex_state = 131},
  [3812] = {.lex_state = 131},
  [3813] = {.lex_state = 131},
  [3814] = {.lex_state = 131},
  [3815] = {.lex_state = 131},
  [3816] = {.lex_state = 131},
  [3817] = {.lex_state = 131},
  [3818] = {.lex_state = 131},
  [3819] = {.lex_state = 131},
  [3820] = {.lex_state = 131},
  [3821] = {.lex_state = 131},
  [3822] = {.lex_state = 131},
  [3823] = {.lex_state = 131},
  [3824] = {.lex_state = 131},
  [3825] = {.lex_state = 132},
  [3826] = {.lex_state = 131},
  [3827] = {.lex_state = 131},
  [3828] = {.lex_state = 132},
  [3829] = {.lex_state = 131},
  [3830] = {.lex_state = 131},
  [3831] = {.lex_state = 132},
  [3832] = {.lex_state = 131},
  [3833] = {.lex_state = 131},
  [3834] = {.lex_state = 131},
  [3835] = {.lex_state = 131},
  [3836] = {.lex_state = 131},
  [3837] = {.lex_state = 132},
  [3838] = {.lex_state = 132},
  [3839] = {.lex_state = 131},
  [3840] = {.lex_state = 132},
  [3841] = {.lex_state = 131},
  [3842] = {.lex_state = 131},
  [3843] = {.lex_state = 131},
  [3844] = {.lex_state = 131},
  [3845] = {.lex_state = 131},
  [3846] = {.lex_state = 131},
  [3847] = {.lex_state = 131},
  [3848] = {.lex_state = 131},
  [3849] = {.lex_state = 131},
  [3850] = {.lex_state = 131},
  [3851] = {.lex_state = 132},
  [3852] = {.lex_state = 131},
  [3853] = {.lex_state = 132},
  [3854] = {.lex_state = 132},
  [3855] = {.lex_state = 131},
  [3856] = {.lex_state = 131},
  [3857] = {.lex_state = 132},
  [3858] = {.lex_state = 131},
  [3859] = {.lex_state = 131},
  [3860] = {.lex_state = 132},
  [3861] = {.lex_state = 132},
  [3862] = {.lex_state = 131},
  [3863] = {.lex_state = 131},
  [3864] = {.lex_state = 132},
  [3865] = {.lex_state = 132},
  [3866] = {.lex_state = 132},
  [3867] = {.lex_state = 132},
  [3868] = {.lex_state = 131},
  [3869] = {.lex_state = 132},
  [3870] = {.lex_state = 132},
  [3871] = {.lex_state = 132},
  [3872] = {.lex_state = 132},
  [3873] = {.lex_state = 131},
  [3874] = {.lex_state = 132},
  [3875] = {.lex_state = 132},
  [3876] = {.lex_state = 131},
  [3877] = {.lex_state = 131},
  [3878] = {.lex_state = 132},
  [3879] = {.lex_state = 131},
  [3880] = {.lex_state = 131},
  [3881] = {.lex_state = 131},
  [3882] = {.lex_state = 132},
  [3883] = {.lex_state = 132},
  [3884] = {.lex_state = 131},
  [3885] = {.lex_state = 131},
  [3886] = {.lex_state = 131},
  [3887] = {.lex_state = 131},
  [3888] = {.lex_state = 132},
  [3889] = {.lex_state = 132},
  [3890] = {.lex_state = 132},
  [3891] = {.lex_state = 131},
  [3892] = {.lex_state = 132},
  [3893] = {.lex_state = 132},
  [3894] = {.lex_state = 132},
  [3895] = {.lex_state = 132},
  [3896] = {.lex_state = 132},
  [3897] = {.lex_state = 131},
  [3898] = {.lex_state = 131},
  [3899] = {.lex_state = 131},
  [3900] = {.lex_state = 131},
  [3901] = {.lex_state = 131},
  [3902] = {.lex_state = 132},
  [3903] = {.lex_state = 132},
  [3904] = {.lex_state = 132},
  [3905] = {.lex_state = 132},
  [3906] = {.lex_state = 131},
  [3907] = {.lex_state = 131},
  [3908] = {.lex_state = 131},
  [3909] = {.lex_state = 131},
  [3910] = {.lex_state = 132},
  [3911] = {.lex_state = 132},
  [3912] = {.lex_state = 131},
  [3913] = {.lex_state = 131},
  [3914] = {.lex_state = 132},
  [3915] = {.lex_state = 131},
  [3916] = {.lex_state = 131},
  [3917] = {.lex_state = 131},
  [3918] = {.lex_state = 131},
  [3919] = {.lex_state = 132},
  [3920] = {.lex_state = 131},
  [3921] = {.lex_state = 131},
  [3922] = {.lex_state = 131},
  [3923] = {.lex_state = 131},
  [3924] = {.lex_state = 131},
  [3925] = {.lex_state = 131},
  [3926] = {.lex_state = 131},
  [3927] = {.lex_state = 131},
  [3928] = {.lex_state = 132},
  [3929] = {.lex_state = 131},
  [3930] = {.lex_state = 132},
  [3931] = {.lex_state = 131},
  [3932] = {.lex_state = 131},
  [3933] = {.lex_state = 131},
  [3934] = {.lex_state = 131},
  [3935] = {.lex_state = 131},
  [3936] = {.lex_state = 132},
  [3937] = {.lex_state = 132},
  [3938] = {.lex_state = 132},
  [3939] = {.lex_state = 131},
  [3940] = {.lex_state = 131},
  [3941] = {.lex_state = 132},
  [3942] = {.lex_state = 132},
  [3943] = {.lex_state = 132},
  [3944] = {.lex_state = 131},
  [3945] = {.lex_state = 132},
  [3946] = {.lex_state = 132},
  [3947] = {.lex_state = 132},
  [3948] = {.lex_state = 132},
  [3949] = {.lex_state = 132},
  [3950] = {.lex_state = 132},
  [3951] = {.lex_state = 132},
  [3952] = {.lex_state = 131},
  [3953] = {.lex_state = 131},
  [3954] = {.lex_state = 132},
  [3955] = {.lex_state = 131},
  [3956] = {.lex_state = 131},
  [3957] = {.lex_state = 132},
  [3958] = {.lex_state = 132},
  [3959] = {.lex_state = 131},
  [3960] = {.lex_state = 131},
  [3961] = {.lex_state = 132},
  [3962] = {.lex_state = 131},
  [3963] = {.lex_state = 131},
  [3964] = {.lex_state = 131},
  [3965] = {.lex_state = 132},
  [3966] = {.lex_state = 131},
  [3967] = {.lex_state = 131},
  [3968] = {.lex_state = 132},
  [3969] = {.lex_state = 131},
  [3970] = {.lex_state = 131},
  [3971] = {.lex_state = 132},
  [3972] = {.lex_state = 131},
  [3973] = {.lex_state = 132},
  [3974] = {.lex_state = 132},
  [3975] = {.lex_state = 132},
  [3976] = {.lex_state = 131},
  [3977] = {.lex_state = 132},
  [3978] = {.lex_state = 131},
  [3979] = {.lex_state = 131},
  [3980] = {.lex_state = 132},
  [3981] = {.lex_state = 132},
  [3982] = {.lex_state = 132},
  [3983] = {.lex_state = 132},
  [3984] = {.lex_state = 131},
  [3985] = {.lex_state = 132},
  [3986] = {.lex_state = 131},
  [3987] = {.lex_state = 132},
  [3988] = {.lex_state = 132},
  [3989] = {.lex_state = 132},
  [3990] = {.lex_state = 131},
  [3991] = {.lex_state = 131},
  [3992] = {.lex_state = 132},
  [3993] = {.lex_state = 132},
  [3994] = {.lex_state = 132},
  [3995] = {.lex_state = 132},
  [3996] = {.lex_state = 131},
  [3997] = {.lex_state = 132},
  [3998] = {.lex_state = 132},
  [3999] = {.lex_state = 132},
  [4000] = {.lex_state = 131},
  [4001] = {.lex_state = 132},
  [4002] = {.lex_state = 132},
  [4003] = {.lex_state = 132},
  [4004] = {.lex_state = 132},
  [4005] = {.lex_state = 131},
  [4006] = {.lex_state = 132},
  [4007] = {.lex_state = 132},
  [4008] = {.lex_state = 132},
  [4009] = {.lex_state = 132},
  [4010] = {.lex_state = 132},
  [4011] = {.lex_state = 132},
  [4012] = {.lex_state = 132},
  [4013] = {.lex_state = 132},
  [4014] = {.lex_state = 132},
  [4015] = {.lex_state = 132},
  [4016] = {.lex_state = 132},
  [4017] = {.lex_state = 132},
  [4018] = {.lex_state = 132},
  [4019] = {.lex_state = 132},
  [4020] = {.lex_state = 132},
  [4021] = {.lex_state = 132},
  [4022] = {.lex_state = 132},
  [4023] = {.lex_state = 132},
  [4024] = {.lex_state = 132},
  [4025] = {.lex_state = 131},
  [4026] = {.lex_state = 132},
  [4027] = {.lex_state = 132},
  [4028] = {.lex_state = 17},
  [4029] = {.lex_state = 132},
  [4030] = {.lex_state = 132},
  [4031] = {.lex_state = 132},
  [4032] = {.lex_state = 132},
  [4033] = {.lex_state = 132},
  [4034] = {.lex_state = 131},
  [4035] = {.lex_state = 132},
  [4036] = {.lex_state = 132},
  [4037] = {.lex_state = 131},
  [4038] = {.lex_state = 131},
  [4039] = {.lex_state = 131},
  [4040] = {.lex_state = 131},
  [4041] = {.lex_state = 131},
  [4042] = {.lex_state = 131},
  [4043] = {.lex_state = 131},
  [4044] = {.lex_state = 132},
  [4045] = {.lex_state = 131},
  [4046] = {.lex_state = 131},
  [4047] = {.lex_state = 131},
  [4048] = {.lex_state = 132},
  [4049] = {.lex_state = 131},
  [4050] = {.lex_state = 131},
  [4051] = {.lex_state = 132},
  [4052] = {.lex_state = 132},
  [4053] = {.lex_state = 132},
  [4054] = {.lex_state = 132},
  [4055] = {.lex_state = 132},
  [4056] = {.lex_state = 132},
  [4057] = {.lex_state = 132},
  [4058] = {.lex_state = 131},
  [4059] = {.lex_state = 131},
  [4060] = {.lex_state = 131},
  [4061] = {.lex_state = 131},
  [4062] = {.lex_state = 131},
  [4063] = {.lex_state = 131},
  [4064] = {.lex_state = 132},
  [4065] = {.lex_state = 132},
  [4066] = {.lex_state = 132},
  [4067] = {.lex_state = 132},
  [4068] = {.lex_state = 131},
  [4069] = {.lex_state = 131},
  [4070] = {.lex_state = 132},
  [4071] = {.lex_state = 132},
  [4072] = {.lex_state = 132},
  [4073] = {.lex_state = 132},
  [4074] = {.lex_state = 132},
  [4075] = {.lex_state = 132},
  [4076] = {.lex_state = 132},
  [4077] = {.lex_state = 132},
  [4078] = {.lex_state = 132},
  [4079] = {.lex_state = 132},
  [4080] = {.lex_state = 132},
  [4081] = {.lex_state = 132},
  [4082] = {.lex_state = 132},
  [4083] = {.lex_state = 132},
  [4084] = {.lex_state = 132},
  [4085] = {.lex_state = 131},
  [4086] = {.lex_state = 131},
  [4087] = {.lex_state = 131},
  [4088] = {.lex_state = 132},
  [4089] = {.lex_state = 132},
  [4090] = {.lex_state = 132},
  [4091] = {.lex_state = 131},
  [4092] = {.lex_state = 132},
  [4093] = {.lex_state = 131},
  [4094] = {.lex_state = 131},
  [4095] = {.lex_state = 132},
  [4096] = {.lex_state = 131},
  [4097] = {.lex_state = 132},
  [4098] = {.lex_state = 10},
  [4099] = {.lex_state = 132},
  [4100] = {.lex_state = 132},
  [4101] = {.lex_state = 131},
  [4102] = {.lex_state = 132},
  [4103] = {.lex_state = 132},
  [4104] = {.lex_state = 131},
  [4105] = {.lex_state = 131},
  [4106] = {.lex_state = 131},
  [4107] = {.lex_state = 131},
  [4108] = {.lex_state = 131},
  [4109] = {.lex_state = 131},
  [4110] = {.lex_state = 131},
  [4111] = {.lex_state = 131},
  [4112] = {.lex_state = 17},
  [4113] = {.lex_state = 131},
  [4114] = {.lex_state = 131},
  [4115] = {.lex_state = 131},
  [4116] = {.lex_state = 131},
  [4117] = {.lex_state = 131},
  [4118] = {.lex_state = 131},
  [4119] = {.lex_state = 131},
  [4120] = {.lex_state = 131},
  [4121] = {.lex_state = 131},
  [4122] = {.lex_state = 131},
  [4123] = {.lex_state = 17},
  [4124] = {.lex_state = 131},
  [4125] = {.lex_state = 131},
  [4126] = {.lex_state = 17},
  [4127] = {.lex_state = 17},
  [4128] = {.lex_state = 131},
  [4129] = {.lex_state = 132},
  [4130] = {.lex_state = 17},
  [4131] = {.lex_state = 131},
  [4132] = {.lex_state = 132},
  [4133] = {.lex_state = 131},
  [4134] = {.lex_state = 131},
  [4135] = {.lex_state = 17},
  [4136] = {.lex_state = 131},
  [4137] = {.lex_state = 131},
  [4138] = {.lex_state = 131},
  [4139] = {.lex_state = 131},
  [4140] = {.lex_state = 131},
  [4141] = {.lex_state = 131},
  [4142] = {.lex_state = 131},
  [4143] = {.lex_state = 131},
  [4144] = {.lex_state = 10},
  [4145] = {.lex_state = 131},
  [4146] = {.lex_state = 131},
  [4147] = {.lex_state = 131},
  [4148] = {.lex_state = 131},
  [4149] = {.lex_state = 131},
  [4150] = {.lex_state = 131},
  [4151] = {.lex_state = 131},
  [4152] = {.lex_state = 131},
  [4153] = {.lex_state = 131},
  [4154] = {.lex_state = 131},
  [4155] = {.lex_state = 131},
  [4156] = {.lex_state = 131},
  [4157] = {.lex_state = 131},
  [4158] = {.lex_state = 131},
  [4159] = {.lex_state = 131},
  [4160] = {.lex_state = 131},
  [4161] = {.lex_state = 131},
  [4162] = {.lex_state = 17},
  [4163] = {.lex_state = 131},
  [4164] = {.lex_state = 131},
  [4165] = {.lex_state = 131},
  [4166] = {.lex_state = 131},
  [4167] = {.lex_state = 131},
  [4168] = {.lex_state = 131},
  [4169] = {.lex_state = 131},
  [4170] = {.lex_state = 131},
  [4171] = {.lex_state = 131},
  [4172] = {.lex_state = 131},
  [4173] = {.lex_state = 131},
  [4174] = {.lex_state = 131},
  [4175] = {.lex_state = 131},
  [4176] = {.lex_state = 131},
  [4177] = {.lex_state = 131},
  [4178] = {.lex_state = 131},
  [4179] = {.lex_state = 131},
  [4180] = {.lex_state = 131},
  [4181] = {.lex_state = 131},
  [4182] = {.lex_state = 131},
  [4183] = {.lex_state = 131},
  [4184] = {.lex_state = 131},
  [4185] = {.lex_state = 131},
  [4186] = {.lex_state = 131},
  [4187] = {.lex_state = 131},
  [4188] = {.lex_state = 132},
  [4189] = {.lex_state = 131},
  [4190] = {.lex_state = 131},
  [4191] = {.lex_state = 17},
  [4192] = {.lex_state = 131},
  [4193] = {.lex_state = 131},
  [4194] = {.lex_state = 131},
  [4195] = {.lex_state = 131},
  [4196] = {.lex_state = 131},
  [4197] = {.lex_state = 131},
  [4198] = {.lex_state = 131},
  [4199] = {.lex_state = 131},
  [4200] = {.lex_state = 131},
  [4201] = {.lex_state = 131},
  [4202] = {.lex_state = 131},
  [4203] = {.lex_state = 131},
  [4204] = {.lex_state = 131},
  [4205] = {.lex_state = 131},
  [4206] = {.lex_state = 131},
  [4207] = {.lex_state = 131},
  [4208] = {.lex_state = 131},
  [4209] = {.lex_state = 131},
  [4210] = {.lex_state = 131},
  [4211] = {.lex_state = 131},
  [4212] = {.lex_state = 131},
  [4213] = {.lex_state = 131},
  [4214] = {.lex_state = 131},
  [4215] = {.lex_state = 131},
  [4216] = {.lex_state = 131},
  [4217] = {.lex_state = 131},
  [4218] = {.lex_state = 131},
  [4219] = {.lex_state = 131},
  [4220] = {.lex_state = 131},
  [4221] = {.lex_state = 131},
  [4222] = {.lex_state = 132},
  [4223] = {.lex_state = 131},
  [4224] = {.lex_state = 131},
  [4225] = {.lex_state = 131},
  [4226] = {.lex_state = 131},
  [4227] = {.lex_state = 131},
  [4228] = {.lex_state = 131},
  [4229] = {.lex_state = 131},
  [4230] = {.lex_state = 131},
  [4231] = {.lex_state = 131},
  [4232] = {.lex_state = 131},
  [4233] = {.lex_state = 131},
  [4234] = {.lex_state = 131},
  [4235] = {.lex_state = 131},
  [4236] = {.lex_state = 131},
  [4237] = {.lex_state = 131},
  [4238] = {.lex_state = 131},
  [4239] = {.lex_state = 131},
  [4240] = {.lex_state = 131},
  [4241] = {.lex_state = 131},
  [4242] = {.lex_state = 131},
  [4243] = {.lex_state = 131},
  [4244] = {.lex_state = 131},
  [4245] = {.lex_state = 131},
  [4246] = {.lex_state = 131},
  [4247] = {.lex_state = 131},
  [4248] = {.lex_state = 131},
  [4249] = {.lex_state = 131, .external_lex_state = 4},
  [4250] = {.lex_state = 131},
  [4251] = {.lex_state = 17},
  [4252] = {.lex_state = 131},
  [4253] = {.lex_state = 131},
  [4254] = {.lex_state = 131},
  [4255] = {.lex_state = 131},
  [4256] = {.lex_state = 131},
  [4257] = {.lex_state = 131},
  [4258] = {.lex_state = 131},
  [4259] = {.lex_state = 131},
  [4260] = {.lex_state = 131},
  [4261] = {.lex_state = 131},
  [4262] = {.lex_state = 131},
  [4263] = {.lex_state = 131},
  [4264] = {.lex_state = 131},
  [4265] = {.lex_state = 131},
  [4266] = {.lex_state = 131},
  [4267] = {.lex_state = 131},
  [4268] = {.lex_state = 131},
  [4269] = {.lex_state = 131},
  [4270] = {.lex_state = 131},
  [4271] = {.lex_state = 131},
  [4272] = {.lex_state = 131},
  [4273] = {.lex_state = 131},
  [4274] = {.lex_state = 131},
  [4275] = {.lex_state = 131},
  [4276] = {.lex_state = 131},
  [4277] = {.lex_state = 131},
  [4278] = {.lex_state = 131},
  [4279] = {.lex_state = 131},
  [4280] = {.lex_state = 131},
  [4281] = {.lex_state = 131},
  [4282] = {.lex_state = 131},
  [4283] = {.lex_state = 131},
  [4284] = {.lex_state = 131},
  [4285] = {.lex_state = 131},
  [4286] = {.lex_state = 131},
  [4287] = {.lex_state = 131},
  [4288] = {.lex_state = 131},
  [4289] = {.lex_state = 131},
  [4290] = {.lex_state = 131},
  [4291] = {.lex_state = 131},
  [4292] = {.lex_state = 131},
  [4293] = {.lex_state = 6, .external_lex_state = 4},
  [4294] = {.lex_state = 131},
  [4295] = {.lex_state = 131},
  [4296] = {.lex_state = 131},
  [4297] = {.lex_state = 10},
  [4298] = {.lex_state = 131, .external_lex_state = 4},
  [4299] = {.lex_state = 131, .external_lex_state = 4},
  [4300] = {.lex_state = 132},
  [4301] = {.lex_state = 131},
  [4302] = {.lex_state = 131},
  [4303] = {.lex_state = 132},
  [4304] = {.lex_state = 131},
  [4305] = {.lex_state = 131},
  [4306] = {.lex_state = 10},
  [4307] = {.lex_state = 131},
  [4308] = {.lex_state = 131},
  [4309] = {.lex_state = 131, .external_lex_state = 4},
  [4310] = {.lex_state = 131},
  [4311] = {.lex_state = 131, .external_lex_state = 4},
  [4312] = {.lex_state = 131},
  [4313] = {.lex_state = 131},
  [4314] = {.lex_state = 131},
  [4315] = {.lex_state = 131},
  [4316] = {.lex_state = 131, .external_lex_state = 4},
  [4317] = {.lex_state = 131},
  [4318] = {.lex_state = 131, .external_lex_state = 4},
  [4319] = {.lex_state = 10},
  [4320] = {.lex_state = 131},
  [4321] = {.lex_state = 131, .external_lex_state = 4},
  [4322] = {.lex_state = 131},
  [4323] = {.lex_state = 131, .external_lex_state = 4},
  [4324] = {.lex_state = 131, .external_lex_state = 4},
  [4325] = {.lex_state = 131},
  [4326] = {.lex_state = 131},
  [4327] = {.lex_state = 131, .external_lex_state = 4},
  [4328] = {.lex_state = 131},
  [4329] = {.lex_state = 131, .external_lex_state = 4},
  [4330] = {.lex_state = 131, .external_lex_state = 4},
  [4331] = {.lex_state = 131},
  [4332] = {.lex_state = 131},
  [4333] = {.lex_state = 132},
  [4334] = {.lex_state = 17},
  [4335] = {.lex_state = 131},
  [4336] = {.lex_state = 131},
  [4337] = {.lex_state = 17},
  [4338] = {.lex_state = 131},
  [4339] = {.lex_state = 131},
  [4340] = {.lex_state = 131, .external_lex_state = 4},
  [4341] = {.lex_state = 131, .external_lex_state = 4},
  [4342] = {.lex_state = 131},
  [4343] = {.lex_state = 132},
  [4344] = {.lex_state = 131, .external_lex_state = 4},
  [4345] = {.lex_state = 131},
  [4346] = {.lex_state = 131, .external_lex_state = 4},
  [4347] = {.lex_state = 131},
  [4348] = {.lex_state = 17},
  [4349] = {.lex_state = 131},
  [4350] = {.lex_state = 131},
  [4351] = {.lex_state = 131, .external_lex_state = 4},
  [4352] = {.lex_state = 131},
  [4353] = {.lex_state = 131, .external_lex_state = 4},
  [4354] = {.lex_state = 131},
  [4355] = {.lex_state = 17},
  [4356] = {.lex_state = 131},
  [4357] = {.lex_state = 131, .external_lex_state = 4},
  [4358] = {.lex_state = 132},
  [4359] = {.lex_state = 131},
  [4360] = {.lex_state = 17},
  [4361] = {.lex_state = 131},
  [4362] = {.lex_state = 131, .external_lex_state = 4},
  [4363] = {.lex_state = 131, .external_lex_state = 4},
  [4364] = {.lex_state = 131},
  [4365] = {.lex_state = 131},
  [4366] = {.lex_state = 131},
  [4367] = {.lex_state = 131},
  [4368] = {.lex_state = 131},
  [4369] = {.lex_state = 131},
  [4370] = {.lex_state = 131, .external_lex_state = 4},
  [4371] = {.lex_state = 131},
  [4372] = {.lex_state = 131},
  [4373] = {.lex_state = 131, .external_lex_state = 4},
  [4374] = {.lex_state = 6, .external_lex_state = 4},
  [4375] = {.lex_state = 131, .external_lex_state = 4},
  [4376] = {.lex_state = 131, .external_lex_state = 4},
  [4377] = {.lex_state = 131},
  [4378] = {.lex_state = 131, .external_lex_state = 4},
  [4379] = {.lex_state = 131, .external_lex_state = 4},
  [4380] = {.lex_state = 132},
  [4381] = {.lex_state = 131},
  [4382] = {.lex_state = 131, .external_lex_state = 4},
  [4383] = {.lex_state = 131},
  [4384] = {.lex_state = 131, .external_lex_state = 4},
  [4385] = {.lex_state = 17},
  [4386] = {.lex_state = 131, .external_lex_state = 4},
  [4387] = {.lex_state = 6, .external_lex_state = 4},
  [4388] = {.lex_state = 6, .external_lex_state = 4},
  [4389] = {.lex_state = 131, .external_lex_state = 4},
  [4390] = {.lex_state = 131, .external_lex_state = 4},
  [4391] = {.lex_state = 131, .external_lex_state = 4},
  [4392] = {.lex_state = 131},
  [4393] = {.lex_state = 131},
  [4394] = {.lex_state = 131},
  [4395] = {.lex_state = 131, .external_lex_state = 4},
  [4396] = {.lex_state = 131, .external_lex_state = 4},
  [4397] = {.lex_state = 131},
  [4398] = {.lex_state = 131, .external_lex_state = 4},
  [4399] = {.lex_state = 131, .external_lex_state = 4},
  [4400] = {.lex_state = 131},
  [4401] = {.lex_state = 131, .external_lex_state = 4},
  [4402] = {.lex_state = 131},
  [4403] = {.lex_state = 131, .external_lex_state = 4},
  [4404] = {.lex_state = 131, .external_lex_state = 4},
  [4405] = {.lex_state = 131, .external_lex_state = 4},
  [4406] = {.lex_state = 131},
  [4407] = {.lex_state = 131, .external_lex_state = 4},
  [4408] = {.lex_state = 131},
  [4409] = {.lex_state = 131, .external_lex_state = 4},
  [4410] = {.lex_state = 131},
  [4411] = {.lex_state = 131},
  [4412] = {.lex_state = 131},
  [4413] = {.lex_state = 131},
  [4414] = {.lex_state = 132},
  [4415] = {.lex_state = 131},
  [4416] = {.lex_state = 131},
  [4417] = {.lex_state = 131, .external_lex_state = 4},
  [4418] = {.lex_state = 131},
  [4419] = {.lex_state = 131, .external_lex_state = 4},
  [4420] = {.lex_state = 131},
  [4421] = {.lex_state = 131, .external_lex_state = 4},
  [4422] = {.lex_state = 132},
  [4423] = {.lex_state = 131},
  [4424] = {.lex_state = 131},
  [4425] = {.lex_state = 131},
  [4426] = {.lex_state = 131},
  [4427] = {.lex_state = 131, .external_lex_state = 4},
  [4428] = {.lex_state = 131},
  [4429] = {.lex_state = 131},
  [4430] = {.lex_state = 131},
  [4431] = {.lex_state = 131},
  [4432] = {.lex_state = 131},
  [4433] = {.lex_state = 131},
  [4434] = {.lex_state = 131},
  [4435] = {.lex_state = 6},
  [4436] = {.lex_state = 131},
  [4437] = {.lex_state = 131},
  [4438] = {.lex_state = 131},
  [4439] = {.lex_state = 132},
  [4440] = {.lex_state = 131},
  [4441] = {.lex_state = 131, .external_lex_state = 4},
  [4442] = {.lex_state = 131, .external_lex_state = 4},
  [4443] = {.lex_state = 131},
  [4444] = {.lex_state = 131, .external_lex_state = 4},
  [4445] = {.lex_state = 131, .external_lex_state = 4},
  [4446] = {.lex_state = 131},
  [4447] = {.lex_state = 131, .external_lex_state = 4},
  [4448] = {.lex_state = 131, .external_lex_state = 4},
  [4449] = {.lex_state = 132},
  [4450] = {.lex_state = 131, .external_lex_state = 4},
  [4451] = {.lex_state = 131},
  [4452] = {.lex_state = 131},
  [4453] = {.lex_state = 131},
  [4454] = {.lex_state = 131},
  [4455] = {.lex_state = 131},
  [4456] = {.lex_state = 131, .external_lex_state = 4},
  [4457] = {.lex_state = 131},
  [4458] = {.lex_state = 131},
  [4459] = {.lex_state = 131, .external_lex_state = 4},
  [4460] = {.lex_state = 131, .external_lex_state = 4},
  [4461] = {.lex_state = 131},
  [4462] = {.lex_state = 131},
  [4463] = {.lex_state = 131},
  [4464] = {.lex_state = 131},
  [4465] = {.lex_state = 131, .external_lex_state = 4},
  [4466] = {.lex_state = 131, .external_lex_state = 4},
  [4467] = {.lex_state = 131, .external_lex_state = 4},
  [4468] = {.lex_state = 131, .external_lex_state = 4},
  [4469] = {.lex_state = 131, .external_lex_state = 4},
  [4470] = {.lex_state = 132},
  [4471] = {.lex_state = 131, .external_lex_state = 4},
  [4472] = {.lex_state = 132},
  [4473] = {.lex_state = 131},
  [4474] = {.lex_state = 131},
  [4475] = {.lex_state = 131},
  [4476] = {.lex_state = 131},
  [4477] = {.lex_state = 131},
  [4478] = {.lex_state = 131, .external_lex_state = 4},
  [4479] = {.lex_state = 131},
  [4480] = {.lex_state = 131},
  [4481] = {.lex_state = 132},
  [4482] = {.lex_state = 131, .external_lex_state = 4},
  [4483] = {.lex_state = 131, .external_lex_state = 4},
  [4484] = {.lex_state = 131, .external_lex_state = 4},
  [4485] = {.lex_state = 131},
  [4486] = {.lex_state = 131, .external_lex_state = 4},
  [4487] = {.lex_state = 132},
  [4488] = {.lex_state = 131, .external_lex_state = 4},
  [4489] = {.lex_state = 131, .external_lex_state = 4},
  [4490] = {.lex_state = 131},
  [4491] = {.lex_state = 132},
  [4492] = {.lex_state = 131},
  [4493] = {.lex_state = 131},
  [4494] = {.lex_state = 131},
  [4495] = {.lex_state = 132},
  [4496] = {.lex_state = 131, .external_lex_state = 4},
  [4497] = {.lex_state = 131, .external_lex_state = 4},
  [4498] = {.lex_state = 131, .external_lex_state = 4},
  [4499] = {.lex_state = 131},
  [4500] = {.lex_state = 131},
  [4501] = {.lex_state = 131, .external_lex_state = 4},
  [4502] = {.lex_state = 131},
  [4503] = {.lex_state = 131, .external_lex_state = 4},
  [4504] = {.lex_state = 131},
  [4505] = {.lex_state = 131},
  [4506] = {.lex_state = 131, .external_lex_state = 4},
  [4507] = {.lex_state = 131, .external_lex_state = 4},
  [4508] = {.lex_state = 131, .external_lex_state = 4},
  [4509] = {.lex_state = 131},
  [4510] = {.lex_state = 131},
  [4511] = {.lex_state = 131, .external_lex_state = 4},
  [4512] = {.lex_state = 131},
  [4513] = {.lex_state = 131},
  [4514] = {.lex_state = 131},
  [4515] = {.lex_state = 131, .external_lex_state = 4},
  [4516] = {.lex_state = 131},
  [4517] = {.lex_state = 132},
  [4518] = {.lex_state = 131},
  [4519] = {.lex_state = 131, .external_lex_state = 4},
  [4520] = {.lex_state = 131, .external_lex_state = 4},
  [4521] = {.lex_state = 131},
  [4522] = {.lex_state = 131, .external_lex_state = 4},
  [4523] = {.lex_state = 131, .external_lex_state = 4},
  [4524] = {.lex_state = 131, .external_lex_state = 4},
  [4525] = {.lex_state = 131, .external_lex_state = 4},
  [4526] = {.lex_state = 131, .external_lex_state = 4},
  [4527] = {.lex_state = 131, .external_lex_state = 4},
  [4528] = {.lex_state = 131},
  [4529] = {.lex_state = 131},
  [4530] = {.lex_state = 17},
  [4531] = {.lex_state = 131},
  [4532] = {.lex_state = 131},
  [4533] = {.lex_state = 131},
  [4534] = {.lex_state = 131},
  [4535] = {.lex_state = 131},
  [4536] = {.lex_state = 7, .external_lex_state = 4},
  [4537] = {.lex_state = 131, .external_lex_state = 4},
  [4538] = {.lex_state = 131, .external_lex_state = 4},
  [4539] = {.lex_state = 132},
  [4540] = {.lex_state = 132},
  [4541] = {.lex_state = 131},
  [4542] = {.lex_state = 131},
  [4543] = {.lex_state = 131},
  [4544] = {.lex_state = 131},
  [4545] = {.lex_state = 131, .external_lex_state = 4},
  [4546] = {.lex_state = 131, .external_lex_state = 4},
  [4547] = {.lex_state = 131, .external_lex_state = 4},
  [4548] = {.lex_state = 131, .external_lex_state = 4},
  [4549] = {.lex_state = 131},
  [4550] = {.lex_state = 131, .external_lex_state = 4},
  [4551] = {.lex_state = 131, .external_lex_state = 4},
  [4552] = {.lex_state = 131, .external_lex_state = 4},
  [4553] = {.lex_state = 131},
  [4554] = {.lex_state = 131},
  [4555] = {.lex_state = 131},
  [4556] = {.lex_state = 131},
  [4557] = {.lex_state = 131},
  [4558] = {.lex_state = 131},
  [4559] = {.lex_state = 131},
  [4560] = {.lex_state = 131},
  [4561] = {.lex_state = 131},
  [4562] = {.lex_state = 131},
  [4563] = {.lex_state = 131},
  [4564] = {.lex_state = 131},
  [4565] = {.lex_state = 131},
  [4566] = {.lex_state = 131, .external_lex_state = 4},
  [4567] = {.lex_state = 131, .external_lex_state = 4},
  [4568] = {.lex_state = 131},
  [4569] = {.lex_state = 132},
  [4570] = {.lex_state = 131},
  [4571] = {.lex_state = 131},
  [4572] = {.lex_state = 131},
  [4573] = {.lex_state = 131, .external_lex_state = 4},
  [4574] = {.lex_state = 131},
  [4575] = {.lex_state = 131},
  [4576] = {.lex_state = 131},
  [4577] = {.lex_state = 131},
  [4578] = {.lex_state = 131},
  [4579] = {.lex_state = 131},
  [4580] = {.lex_state = 131},
  [4581] = {.lex_state = 131},
  [4582] = {.lex_state = 131},
  [4583] = {.lex_state = 131},
  [4584] = {.lex_state = 131},
  [4585] = {.lex_state = 131},
  [4586] = {.lex_state = 131},
  [4587] = {.lex_state = 131},
  [4588] = {.lex_state = 131},
  [4589] = {.lex_state = 131},
  [4590] = {.lex_state = 131},
  [4591] = {.lex_state = 131, .external_lex_state = 4},
  [4592] = {.lex_state = 132},
  [4593] = {.lex_state = 17},
  [4594] = {.lex_state = 131, .external_lex_state = 4},
  [4595] = {.lex_state = 6},
  [4596] = {.lex_state = 132},
  [4597] = {.lex_state = 132},
  [4598] = {.lex_state = 131, .external_lex_state = 4},
  [4599] = {.lex_state = 131},
  [4600] = {.lex_state = 131},
  [4601] = {.lex_state = 131},
  [4602] = {.lex_state = 131},
  [4603] = {.lex_state = 131},
  [4604] = {.lex_state = 131},
  [4605] = {.lex_state = 131},
  [4606] = {.lex_state = 131},
  [4607] = {.lex_state = 17},
  [4608] = {.lex_state = 131},
  [4609] = {.lex_state = 131},
  [4610] = {.lex_state = 131},
  [4611] = {.lex_state = 131},
  [4612] = {.lex_state = 131},
  [4613] = {.lex_state = 131},
  [4614] = {.lex_state = 131},
  [4615] = {.lex_state = 131},
  [4616] = {.lex_state = 131},
  [4617] = {.lex_state = 131},
  [4618] = {.lex_state = 131},
  [4619] = {.lex_state = 131},
  [4620] = {.lex_state = 131},
  [4621] = {.lex_state = 131},
  [4622] = {.lex_state = 132},
  [4623] = {.lex_state = 131},
  [4624] = {.lex_state = 131},
  [4625] = {.lex_state = 131},
  [4626] = {.lex_state = 131},
  [4627] = {.lex_state = 131},
  [4628] = {.lex_state = 132},
  [4629] = {.lex_state = 131, .external_lex_state = 4},
  [4630] = {.lex_state = 131, .external_lex_state = 4},
  [4631] = {.lex_state = 131, .external_lex_state = 4},
  [4632] = {.lex_state = 131, .external_lex_state = 4},
  [4633] = {.lex_state = 131, .external_lex_state = 4},
  [4634] = {.lex_state = 131},
  [4635] = {.lex_state = 131},
  [4636] = {.lex_state = 131},
  [4637] = {.lex_state = 131},
  [4638] = {.lex_state = 131, .external_lex_state = 4},
  [4639] = {.lex_state = 131, .external_lex_state = 4},
  [4640] = {.lex_state = 131, .external_lex_state = 4},
  [4641] = {.lex_state = 131, .external_lex_state = 4},
  [4642] = {.lex_state = 131, .external_lex_state = 4},
  [4643] = {.lex_state = 131, .external_lex_state = 4},
  [4644] = {.lex_state = 131, .external_lex_state = 4},
  [4645] = {.lex_state = 131, .external_lex_state = 4},
  [4646] = {.lex_state = 131, .external_lex_state = 4},
  [4647] = {.lex_state = 131, .external_lex_state = 4},
  [4648] = {.lex_state = 131, .external_lex_state = 4},
  [4649] = {.lex_state = 131, .external_lex_state = 4},
  [4650] = {.lex_state = 131, .external_lex_state = 4},
  [4651] = {.lex_state = 131, .external_lex_state = 4},
  [4652] = {.lex_state = 131, .external_lex_state = 4},
  [4653] = {.lex_state = 131, .external_lex_state = 4},
  [4654] = {.lex_state = 131, .external_lex_state = 4},
  [4655] = {.lex_state = 131, .external_lex_state = 4},
  [4656] = {.lex_state = 131, .external_lex_state = 4},
  [4657] = {.lex_state = 131, .external_lex_state = 4},
  [4658] = {.lex_state = 131, .external_lex_state = 4},
  [4659] = {.lex_state = 131, .external_lex_state = 4},
  [4660] = {.lex_state = 131, .external_lex_state = 4},
  [4661] = {.lex_state = 131, .external_lex_state = 4},
  [4662] = {.lex_state = 131, .external_lex_state = 4},
  [4663] = {.lex_state = 131, .external_lex_state = 4},
  [4664] = {.lex_state = 132},
  [4665] = {.lex_state = 131, .external_lex_state = 4},
  [4666] = {.lex_state = 131, .external_lex_state = 4},
  [4667] = {.lex_state = 131, .external_lex_state = 4},
  [4668] = {.lex_state = 131, .external_lex_state = 4},
  [4669] = {.lex_state = 131, .external_lex_state = 4},
  [4670] = {.lex_state = 131, .external_lex_state = 4},
  [4671] = {.lex_state = 131, .external_lex_state = 4},
  [4672] = {.lex_state = 131, .external_lex_state = 4},
  [4673] = {.lex_state = 131, .external_lex_state = 4},
  [4674] = {.lex_state = 131, .external_lex_state = 4},
  [4675] = {.lex_state = 131, .external_lex_state = 4},
  [4676] = {.lex_state = 131},
  [4677] = {.lex_state = 131},
  [4678] = {.lex_state = 131},
  [4679] = {.lex_state = 131, .external_lex_state = 4},
  [4680] = {.lex_state = 131, .external_lex_state = 4},
  [4681] = {.lex_state = 131},
  [4682] = {.lex_state = 131},
  [4683] = {.lex_state = 131},
  [4684] = {.lex_state = 131},
  [4685] = {.lex_state = 131},
  [4686] = {.lex_state = 131},
  [4687] = {.lex_state = 131},
  [4688] = {.lex_state = 131},
  [4689] = {.lex_state = 131},
  [4690] = {.lex_state = 131},
  [4691] = {.lex_state = 131},
  [4692] = {.lex_state = 131},
  [4693] = {.lex_state = 131},
  [4694] = {.lex_state = 131},
  [4695] = {.lex_state = 131},
  [4696] = {.lex_state = 131},
  [4697] = {.lex_state = 131},
  [4698] = {.lex_state = 131},
  [4699] = {.lex_state = 131, .external_lex_state = 4},
  [4700] = {.lex_state = 131, .external_lex_state = 4},
  [4701] = {.lex_state = 131, .external_lex_state = 4},
  [4702] = {.lex_state = 131, .external_lex_state = 4},
  [4703] = {.lex_state = 131, .external_lex_state = 4},
  [4704] = {.lex_state = 131, .external_lex_state = 4},
  [4705] = {.lex_state = 131, .external_lex_state = 4},
  [4706] = {.lex_state = 131, .external_lex_state = 4},
  [4707] = {.lex_state = 131, .external_lex_state = 4},
  [4708] = {.lex_state = 131},
  [4709] = {.lex_state = 131},
  [4710] = {.lex_state = 131, .external_lex_state = 4},
  [4711] = {.lex_state = 131, .external_lex_state = 4},
  [4712] = {.lex_state = 131, .external_lex_state = 4},
  [4713] = {.lex_state = 131, .external_lex_state = 4},
  [4714] = {.lex_state = 131, .external_lex_state = 4},
  [4715] = {.lex_state = 131, .external_lex_state = 4},
  [4716] = {.lex_state = 131, .external_lex_state = 4},
  [4717] = {.lex_state = 131},
  [4718] = {.lex_state = 131, .external_lex_state = 4},
  [4719] = {.lex_state = 131, .external_lex_state = 4},
  [4720] = {.lex_state = 131, .external_lex_state = 4},
  [4721] = {.lex_state = 131, .external_lex_state = 4},
  [4722] = {.lex_state = 131, .external_lex_state = 4},
  [4723] = {.lex_state = 131, .external_lex_state = 4},
  [4724] = {.lex_state = 131, .external_lex_state = 4},
  [4725] = {.lex_state = 131, .external_lex_state = 4},
  [4726] = {.lex_state = 131},
  [4727] = {.lex_state = 131},
  [4728] = {.lex_state = 131},
  [4729] = {.lex_state = 131},
  [4730] = {.lex_state = 131},
  [4731] = {.lex_state = 131},
  [4732] = {.lex_state = 131},
  [4733] = {.lex_state = 131},
  [4734] = {.lex_state = 131},
  [4735] = {.lex_state = 131, .external_lex_state = 4},
  [4736] = {.lex_state = 131},
  [4737] = {.lex_state = 131, .external_lex_state = 4},
  [4738] = {.lex_state = 131, .external_lex_state = 4},
  [4739] = {.lex_state = 131},
  [4740] = {.lex_state = 131, .external_lex_state = 4},
  [4741] = {.lex_state = 131},
  [4742] = {.lex_state = 131, .external_lex_state = 4},
  [4743] = {.lex_state = 131, .external_lex_state = 4},
  [4744] = {.lex_state = 131},
  [4745] = {.lex_state = 131},
  [4746] = {.lex_state = 131},
  [4747] = {.lex_state = 131},
  [4748] = {.lex_state = 131},
  [4749] = {.lex_state = 131},
  [4750] = {.lex_state = 131},
  [4751] = {.lex_state = 131},
  [4752] = {.lex_state = 131},
  [4753] = {.lex_state = 131},
  [4754] = {.lex_state = 131},
  [4755] = {.lex_state = 131},
  [4756] = {.lex_state = 131},
  [4757] = {.lex_state = 131},
  [4758] = {.lex_state = 131},
  [4759] = {.lex_state = 131, .external_lex_state = 4},
  [4760] = {.lex_state = 131, .external_lex_state = 4},
  [4761] = {.lex_state = 131, .external_lex_state = 4},
  [4762] = {.lex_state = 131, .external_lex_state = 4},
  [4763] = {.lex_state = 131, .external_lex_state = 4},
  [4764] = {.lex_state = 131, .external_lex_state = 4},
  [4765] = {.lex_state = 131},
  [4766] = {.lex_state = 131, .external_lex_state = 4},
  [4767] = {.lex_state = 131},
  [4768] = {.lex_state = 131},
  [4769] = {.lex_state = 131},
  [4770] = {.lex_state = 131},
  [4771] = {.lex_state = 131},
  [4772] = {.lex_state = 131},
  [4773] = {.lex_state = 131},
  [4774] = {.lex_state = 131},
  [4775] = {.lex_state = 131},
  [4776] = {.lex_state = 131},
  [4777] = {.lex_state = 131},
  [4778] = {.lex_state = 131},
  [4779] = {.lex_state = 131},
  [4780] = {.lex_state = 131},
  [4781] = {.lex_state = 131},
  [4782] = {.lex_state = 131},
  [4783] = {.lex_state = 131},
  [4784] = {.lex_state = 131},
  [4785] = {.lex_state = 131},
  [4786] = {.lex_state = 131},
  [4787] = {.lex_state = 131},
  [4788] = {.lex_state = 131},
  [4789] = {.lex_state = 131},
  [4790] = {.lex_state = 131},
  [4791] = {.lex_state = 131},
  [4792] = {.lex_state = 131},
  [4793] = {.lex_state = 131},
  [4794] = {.lex_state = 131},
  [4795] = {.lex_state = 131},
  [4796] = {.lex_state = 131},
  [4797] = {.lex_state = 131},
  [4798] = {.lex_state = 131},
  [4799] = {.lex_state = 131},
  [4800] = {.lex_state = 131},
  [4801] = {.lex_state = 131},
  [4802] = {.lex_state = 131, .external_lex_state = 4},
  [4803] = {.lex_state = 131},
  [4804] = {.lex_state = 131},
  [4805] = {.lex_state = 131},
  [4806] = {.lex_state = 131},
  [4807] = {.lex_state = 131},
  [4808] = {.lex_state = 131},
  [4809] = {.lex_state = 131},
  [4810] = {.lex_state = 131},
  [4811] = {.lex_state = 131},
  [4812] = {.lex_state = 131},
  [4813] = {.lex_state = 131, .external_lex_state = 4},
  [4814] = {.lex_state = 131, .external_lex_state = 4},
  [4815] = {.lex_state = 131, .external_lex_state = 4},
  [4816] = {.lex_state = 131, .external_lex_state = 4},
  [4817] = {.lex_state = 131, .external_lex_state = 4},
  [4818] = {.lex_state = 131, .external_lex_state = 4},
  [4819] = {.lex_state = 131, .external_lex_state = 4},
  [4820] = {.lex_state = 131},
  [4821] = {.lex_state = 131},
  [4822] = {.lex_state = 131},
  [4823] = {.lex_state = 131},
  [4824] = {.lex_state = 131},
  [4825] = {.lex_state = 131},
  [4826] = {.lex_state = 131},
  [4827] = {.lex_state = 131},
  [4828] = {.lex_state = 131},
  [4829] = {.lex_state = 131},
  [4830] = {.lex_state = 131},
  [4831] = {.lex_state = 131},
  [4832] = {.lex_state = 131},
  [4833] = {.lex_state = 131},
  [4834] = {.lex_state = 131},
  [4835] = {.lex_state = 131},
  [4836] = {.lex_state = 131},
  [4837] = {.lex_state = 131},
  [4838] = {.lex_state = 131},
  [4839] = {.lex_state = 131},
  [4840] = {.lex_state = 131},
  [4841] = {.lex_state = 131},
  [4842] = {.lex_state = 131},
  [4843] = {.lex_state = 131},
  [4844] = {.lex_state = 131},
  [4845] = {.lex_state = 131},
  [4846] = {.lex_state = 131},
  [4847] = {.lex_state = 131},
  [4848] = {.lex_state = 131},
  [4849] = {.lex_state = 131},
  [4850] = {.lex_state = 131},
  [4851] = {.lex_state = 131},
  [4852] = {.lex_state = 131},
  [4853] = {.lex_state = 131},
  [4854] = {.lex_state = 131},
  [4855] = {.lex_state = 131},
  [4856] = {.lex_state = 131, .external_lex_state = 4},
  [4857] = {.lex_state = 131, .external_lex_state = 4},
  [4858] = {.lex_state = 131, .external_lex_state = 4},
  [4859] = {.lex_state = 131},
  [4860] = {.lex_state = 131, .external_lex_state = 4},
  [4861] = {.lex_state = 131, .external_lex_state = 4},
  [4862] = {.lex_state = 131, .external_lex_state = 4},
  [4863] = {.lex_state = 131},
  [4864] = {.lex_state = 131},
  [4865] = {.lex_state = 131},
  [4866] = {.lex_state = 131},
  [4867] = {.lex_state = 131},
  [4868] = {.lex_state = 131, .external_lex_state = 4},
  [4869] = {.lex_state = 131, .external_lex_state = 4},
  [4870] = {.lex_state = 131, .external_lex_state = 4},
  [4871] = {.lex_state = 131, .external_lex_state = 4},
  [4872] = {.lex_state = 131},
  [4873] = {.lex_state = 131},
  [4874] = {.lex_state = 131},
  [4875] = {.lex_state = 131},
  [4876] = {.lex_state = 131},
  [4877] = {.lex_state = 131},
  [4878] = {.lex_state = 131},
  [4879] = {.lex_state = 131},
  [4880] = {.lex_state = 131},
  [4881] = {.lex_state = 131},
  [4882] = {.lex_state = 131, .external_lex_state = 4},
  [4883] = {.lex_state = 131, .external_lex_state = 4},
  [4884] = {.lex_state = 131},
  [4885] = {.lex_state = 131},
  [4886] = {.lex_state = 131},
  [4887] = {.lex_state = 131},
  [4888] = {.lex_state = 131},
  [4889] = {.lex_state = 131},
  [4890] = {.lex_state = 131},
  [4891] = {.lex_state = 131},
  [4892] = {.lex_state = 131},
  [4893] = {.lex_state = 131, .external_lex_state = 4},
  [4894] = {.lex_state = 131, .external_lex_state = 4},
  [4895] = {.lex_state = 131, .external_lex_state = 4},
  [4896] = {.lex_state = 131, .external_lex_state = 4},
  [4897] = {.lex_state = 131, .external_lex_state = 4},
  [4898] = {.lex_state = 131, .external_lex_state = 4},
  [4899] = {.lex_state = 131, .external_lex_state = 4},
  [4900] = {.lex_state = 131, .external_lex_state = 4},
  [4901] = {.lex_state = 131},
  [4902] = {.lex_state = 132},
  [4903] = {.lex_state = 131, .external_lex_state = 4},
  [4904] = {.lex_state = 132},
  [4905] = {.lex_state = 131},
  [4906] = {.lex_state = 131},
  [4907] = {.lex_state = 131},
  [4908] = {.lex_state = 131},
  [4909] = {.lex_state = 131},
  [4910] = {.lex_state = 131},
  [4911] = {.lex_state = 131},
  [4912] = {.lex_state = 131},
  [4913] = {.lex_state = 131},
  [4914] = {.lex_state = 131},
  [4915] = {.lex_state = 131, .external_lex_state = 4},
  [4916] = {.lex_state = 131},
  [4917] = {.lex_state = 131},
  [4918] = {.lex_state = 131},
  [4919] = {.lex_state = 131},
  [4920] = {.lex_state = 131},
  [4921] = {.lex_state = 131},
  [4922] = {.lex_state = 131, .external_lex_state = 4},
  [4923] = {.lex_state = 132},
  [4924] = {.lex_state = 132},
  [4925] = {.lex_state = 132},
  [4926] = {.lex_state = 132},
  [4927] = {.lex_state = 132},
  [4928] = {.lex_state = 131},
  [4929] = {.lex_state = 131, .external_lex_state = 4},
  [4930] = {.lex_state = 131, .external_lex_state = 4},
  [4931] = {.lex_state = 132},
  [4932] = {.lex_state = 131},
  [4933] = {.lex_state = 131},
  [4934] = {.lex_state = 131},
  [4935] = {.lex_state = 131},
  [4936] = {.lex_state = 131},
  [4937] = {.lex_state = 131},
  [4938] = {.lex_state = 131},
  [4939] = {.lex_state = 131},
  [4940] = {.lex_state = 131},
  [4941] = {.lex_state = 131},
  [4942] = {.lex_state = 131, .external_lex_state = 4},
  [4943] = {.lex_state = 131},
  [4944] = {.lex_state = 131},
  [4945] = {.lex_state = 132},
  [4946] = {.lex_state = 131},
  [4947] = {.lex_state = 131},
  [4948] = {.lex_state = 131},
  [4949] = {.lex_state = 131, .external_lex_state = 4},
  [4950] = {.lex_state = 131},
  [4951] = {.lex_state = 131},
  [4952] = {.lex_state = 131},
  [4953] = {.lex_state = 131},
  [4954] = {.lex_state = 131},
  [4955] = {.lex_state = 131},
  [4956] = {.lex_state = 131},
  [4957] = {.lex_state = 131},
  [4958] = {.lex_state = 131},
  [4959] = {.lex_state = 131},
  [4960] = {.lex_state = 131},
  [4961] = {.lex_state = 131},
  [4962] = {.lex_state = 131},
  [4963] = {.lex_state = 131},
  [4964] = {.lex_state = 131, .external_lex_state = 4},
  [4965] = {.lex_state = 131, .external_lex_state = 4},
  [4966] = {.lex_state = 131, .external_lex_state = 4},
  [4967] = {.lex_state = 131},
  [4968] = {.lex_state = 132},
  [4969] = {.lex_state = 131},
  [4970] = {.lex_state = 131},
  [4971] = {.lex_state = 131},
  [4972] = {.lex_state = 131},
  [4973] = {.lex_state = 131},
  [4974] = {.lex_state = 131},
  [4975] = {.lex_state = 131},
  [4976] = {.lex_state = 132},
  [4977] = {.lex_state = 131},
  [4978] = {.lex_state = 131},
  [4979] = {.lex_state = 131},
  [4980] = {.lex_state = 131},
  [4981] = {.lex_state = 131},
  [4982] = {.lex_state = 131},
  [4983] = {.lex_state = 132},
  [4984] = {.lex_state = 131},
  [4985] = {.lex_state = 131},
  [4986] = {.lex_state = 131},
  [4987] = {.lex_state = 131},
  [4988] = {.lex_state = 131},
  [4989] = {.lex_state = 131},
  [4990] = {.lex_state = 131},
  [4991] = {.lex_state = 131},
  [4992] = {.lex_state = 131},
  [4993] = {.lex_state = 131},
  [4994] = {.lex_state = 131},
  [4995] = {.lex_state = 131},
  [4996] = {.lex_state = 131},
  [4997] = {.lex_state = 131},
  [4998] = {.lex_state = 131},
  [4999] = {.lex_state = 131},
  [5000] = {.lex_state = 132},
  [5001] = {.lex_state = 131},
  [5002] = {.lex_state = 131},
  [5003] = {.lex_state = 131},
  [5004] = {.lex_state = 131},
  [5005] = {.lex_state = 131},
  [5006] = {.lex_state = 131},
  [5007] = {.lex_state = 131},
  [5008] = {.lex_state = 131},
  [5009] = {.lex_state = 131},
  [5010] = {.lex_state = 131},
  [5011] = {.lex_state = 132},
  [5012] = {.lex_state = 131},
  [5013] = {.lex_state = 131},
  [5014] = {.lex_state = 131},
  [5015] = {.lex_state = 131},
  [5016] = {.lex_state = 131},
  [5017] = {.lex_state = 131},
  [5018] = {.lex_state = 131},
  [5019] = {.lex_state = 131},
  [5020] = {.lex_state = 131},
  [5021] = {.lex_state = 131, .external_lex_state = 4},
  [5022] = {.lex_state = 131},
  [5023] = {.lex_state = 131},
  [5024] = {.lex_state = 131},
  [5025] = {.lex_state = 131},
  [5026] = {.lex_state = 132},
  [5027] = {.lex_state = 131},
  [5028] = {.lex_state = 131},
  [5029] = {.lex_state = 131},
  [5030] = {.lex_state = 131, .external_lex_state = 4},
  [5031] = {.lex_state = 131},
  [5032] = {.lex_state = 131},
  [5033] = {.lex_state = 131},
  [5034] = {.lex_state = 131, .external_lex_state = 4},
  [5035] = {.lex_state = 132},
  [5036] = {.lex_state = 131},
  [5037] = {.lex_state = 132},
  [5038] = {.lex_state = 131},
  [5039] = {.lex_state = 131},
  [5040] = {.lex_state = 131},
  [5041] = {.lex_state = 131},
  [5042] = {.lex_state = 131},
  [5043] = {.lex_state = 131},
  [5044] = {.lex_state = 131},
  [5045] = {.lex_state = 131},
  [5046] = {.lex_state = 131},
  [5047] = {.lex_state = 132},
  [5048] = {.lex_state = 131},
  [5049] = {.lex_state = 131},
  [5050] = {.lex_state = 131},
  [5051] = {.lex_state = 131},
  [5052] = {.lex_state = 131},
  [5053] = {.lex_state = 131},
  [5054] = {.lex_state = 131},
  [5055] = {.lex_state = 132},
  [5056] = {.lex_state = 131},
  [5057] = {.lex_state = 131},
  [5058] = {.lex_state = 131},
  [5059] = {.lex_state = 132},
  [5060] = {.lex_state = 131},
  [5061] = {.lex_state = 131},
  [5062] = {.lex_state = 132},
  [5063] = {.lex_state = 131},
  [5064] = {.lex_state = 131},
  [5065] = {.lex_state = 131},
  [5066] = {.lex_state = 132},
  [5067] = {.lex_state = 131},
  [5068] = {.lex_state = 131},
  [5069] = {.lex_state = 131},
  [5070] = {.lex_state = 131},
  [5071] = {.lex_state = 131},
  [5072] = {.lex_state = 131, .external_lex_state = 4},
  [5073] = {.lex_state = 131},
  [5074] = {.lex_state = 131},
  [5075] = {.lex_state = 131},
  [5076] = {.lex_state = 131},
  [5077] = {.lex_state = 132},
  [5078] = {.lex_state = 131},
  [5079] = {.lex_state = 131},
  [5080] = {.lex_state = 131},
  [5081] = {.lex_state = 131},
  [5082] = {.lex_state = 131},
  [5083] = {.lex_state = 131},
  [5084] = {.lex_state = 131},
  [5085] = {.lex_state = 131},
  [5086] = {.lex_state = 131},
  [5087] = {.lex_state = 131},
  [5088] = {.lex_state = 132},
  [5089] = {.lex_state = 131},
  [5090] = {.lex_state = 131},
  [5091] = {.lex_state = 131},
  [5092] = {.lex_state = 131},
  [5093] = {.lex_state = 131},
  [5094] = {.lex_state = 131},
  [5095] = {.lex_state = 131},
  [5096] = {.lex_state = 131},
  [5097] = {.lex_state = 131},
  [5098] = {.lex_state = 131},
  [5099] = {.lex_state = 131},
  [5100] = {.lex_state = 131},
  [5101] = {.lex_state = 131},
  [5102] = {.lex_state = 131},
  [5103] = {.lex_state = 131},
  [5104] = {.lex_state = 131},
  [5105] = {.lex_state = 131},
  [5106] = {.lex_state = 131},
  [5107] = {.lex_state = 132},
  [5108] = {.lex_state = 132},
  [5109] = {.lex_state = 131},
  [5110] = {.lex_state = 131},
  [5111] = {.lex_state = 131, .external_lex_state = 4},
  [5112] = {.lex_state = 131},
  [5113] = {.lex_state = 131, .external_lex_state = 4},
  [5114] = {.lex_state = 131},
  [5115] = {.lex_state = 131, .external_lex_state = 4},
  [5116] = {.lex_state = 131},
  [5117] = {.lex_state = 131},
  [5118] = {.lex_state = 131},
  [5119] = {.lex_state = 131},
  [5120] = {.lex_state = 131},
  [5121] = {.lex_state = 131},
  [5122] = {.lex_state = 131},
  [5123] = {.lex_state = 131},
  [5124] = {.lex_state = 131},
  [5125] = {.lex_state = 131},
  [5126] = {.lex_state = 131},
  [5127] = {.lex_state = 131},
  [5128] = {.lex_state = 131},
  [5129] = {.lex_state = 131},
  [5130] = {.lex_state = 131},
  [5131] = {.lex_state = 131},
  [5132] = {.lex_state = 131},
  [5133] = {.lex_state = 131},
  [5134] = {.lex_state = 131},
  [5135] = {.lex_state = 131},
  [5136] = {.lex_state = 131},
  [5137] = {.lex_state = 131},
  [5138] = {.lex_state = 132},
  [5139] = {.lex_state = 131},
  [5140] = {.lex_state = 131},
  [5141] = {.lex_state = 131},
  [5142] = {.lex_state = 131},
  [5143] = {.lex_state = 131},
  [5144] = {.lex_state = 131},
  [5145] = {.lex_state = 131},
  [5146] = {.lex_state = 131},
  [5147] = {.lex_state = 131},
  [5148] = {.lex_state = 131},
  [5149] = {.lex_state = 131},
  [5150] = {.lex_state = 131},
  [5151] = {.lex_state = 131},
  [5152] = {.lex_state = 131},
  [5153] = {.lex_state = 131},
  [5154] = {.lex_state = 131},
  [5155] = {.lex_state = 131},
  [5156] = {.lex_state = 131},
  [5157] = {.lex_state = 131},
  [5158] = {.lex_state = 131},
  [5159] = {.lex_state = 131},
  [5160] = {.lex_state = 131, .external_lex_state = 4},
  [5161] = {.lex_state = 131},
  [5162] = {.lex_state = 132},
  [5163] = {.lex_state = 10},
  [5164] = {.lex_state = 10},
  [5165] = {.lex_state = 131},
  [5166] = {.lex_state = 131},
  [5167] = {.lex_state = 132},
  [5168] = {.lex_state = 10},
  [5169] = {.lex_state = 132},
  [5170] = {.lex_state = 131},
  [5171] = {.lex_state = 10},
  [5172] = {.lex_state = 131},
  [5173] = {.lex_state = 131},
  [5174] = {.lex_state = 10},
  [5175] = {.lex_state = 131},
  [5176] = {.lex_state = 131},
  [5177] = {.lex_state = 131},
  [5178] = {.lex_state = 10},
  [5179] = {.lex_state = 131},
  [5180] = {.lex_state = 131},
  [5181] = {.lex_state = 131},
  [5182] = {.lex_state = 131},
  [5183] = {.lex_state = 131},
  [5184] = {.lex_state = 131},
  [5185] = {.lex_state = 131},
  [5186] = {.lex_state = 131},
  [5187] = {.lex_state = 131},
  [5188] = {.lex_state = 131},
  [5189] = {.lex_state = 131},
  [5190] = {.lex_state = 131},
  [5191] = {.lex_state = 131},
  [5192] = {.lex_state = 131},
  [5193] = {.lex_state = 10},
  [5194] = {.lex_state = 131},
  [5195] = {.lex_state = 131},
  [5196] = {.lex_state = 131},
  [5197] = {.lex_state = 131},
  [5198] = {.lex_state = 131},
  [5199] = {.lex_state = 131},
  [5200] = {.lex_state = 131},
  [5201] = {.lex_state = 131},
  [5202] = {.lex_state = 131},
  [5203] = {.lex_state = 131},
  [5204] = {.lex_state = 131},
  [5205] = {.lex_state = 131},
  [5206] = {.lex_state = 131},
  [5207] = {.lex_state = 131},
  [5208] = {.lex_state = 131},
  [5209] = {.lex_state = 131},
  [5210] = {.lex_state = 131, .external_lex_state = 4},
  [5211] = {.lex_state = 131},
  [5212] = {.lex_state = 131},
  [5213] = {.lex_state = 131},
  [5214] = {.lex_state = 131},
  [5215] = {.lex_state = 131},
  [5216] = {.lex_state = 131},
  [5217] = {.lex_state = 131},
  [5218] = {.lex_state = 131},
  [5219] = {.lex_state = 131},
  [5220] = {.lex_state = 10},
  [5221] = {.lex_state = 10},
  [5222] = {.lex_state = 132},
  [5223] = {.lex_state = 131},
  [5224] = {.lex_state = 131},
  [5225] = {.lex_state = 131},
  [5226] = {.lex_state = 131},
  [5227] = {.lex_state = 10},
  [5228] = {.lex_state = 132},
  [5229] = {.lex_state = 131},
  [5230] = {.lex_state = 131},
  [5231] = {.lex_state = 131},
  [5232] = {.lex_state = 131},
  [5233] = {.lex_state = 131},
  [5234] = {.lex_state = 131},
  [5235] = {.lex_state = 131},
  [5236] = {.lex_state = 131},
  [5237] = {.lex_state = 131},
  [5238] = {.lex_state = 131},
  [5239] = {.lex_state = 131},
  [5240] = {.lex_state = 131},
  [5241] = {.lex_state = 131},
  [5242] = {.lex_state = 131},
  [5243] = {.lex_state = 131},
  [5244] = {.lex_state = 131},
  [5245] = {.lex_state = 131},
  [5246] = {.lex_state = 131},
  [5247] = {.lex_state = 131},
  [5248] = {.lex_state = 131},
  [5249] = {.lex_state = 131},
  [5250] = {.lex_state = 131},
  [5251] = {.lex_state = 131},
  [5252] = {.lex_state = 131},
  [5253] = {.lex_state = 131},
  [5254] = {.lex_state = 131},
  [5255] = {.lex_state = 131},
  [5256] = {.lex_state = 10},
  [5257] = {.lex_state = 131},
  [5258] = {.lex_state = 131},
  [5259] = {.lex_state = 131},
  [5260] = {.lex_state = 131},
  [5261] = {.lex_state = 131},
  [5262] = {.lex_state = 131},
  [5263] = {.lex_state = 131},
  [5264] = {.lex_state = 131},
  [5265] = {.lex_state = 132},
  [5266] = {.lex_state = 10},
  [5267] = {.lex_state = 131},
  [5268] = {.lex_state = 131},
  [5269] = {.lex_state = 10},
  [5270] = {.lex_state = 131},
  [5271] = {.lex_state = 131},
  [5272] = {.lex_state = 131},
  [5273] = {.lex_state = 132},
  [5274] = {.lex_state = 131},
  [5275] = {.lex_state = 131},
  [5276] = {.lex_state = 131},
  [5277] = {.lex_state = 131},
  [5278] = {.lex_state = 131},
  [5279] = {.lex_state = 132},
  [5280] = {.lex_state = 131},
  [5281] = {.lex_state = 131},
  [5282] = {.lex_state = 131},
  [5283] = {.lex_state = 131},
  [5284] = {.lex_state = 131},
  [5285] = {.lex_state = 131},
  [5286] = {.lex_state = 131},
  [5287] = {.lex_state = 131},
  [5288] = {.lex_state = 131},
  [5289] = {.lex_state = 10},
  [5290] = {.lex_state = 131},
  [5291] = {.lex_state = 17},
  [5292] = {.lex_state = 10},
  [5293] = {.lex_state = 10},
  [5294] = {.lex_state = 17},
  [5295] = {.lex_state = 10},
  [5296] = {.lex_state = 10},
  [5297] = {.lex_state = 10},
  [5298] = {.lex_state = 131},
  [5299] = {.lex_state = 10},
  [5300] = {.lex_state = 10},
  [5301] = {.lex_state = 10},
  [5302] = {.lex_state = 131},
  [5303] = {.lex_state = 131},
  [5304] = {.lex_state = 131},
  [5305] = {.lex_state = 131},
  [5306] = {.lex_state = 10},
  [5307] = {.lex_state = 131},
  [5308] = {.lex_state = 10},
  [5309] = {.lex_state = 10},
  [5310] = {.lex_state = 10},
  [5311] = {.lex_state = 131},
  [5312] = {.lex_state = 131},
  [5313] = {.lex_state = 10},
  [5314] = {.lex_state = 10},
  [5315] = {.lex_state = 10},
  [5316] = {.lex_state = 10},
  [5317] = {.lex_state = 10},
  [5318] = {.lex_state = 131},
  [5319] = {.lex_state = 10},
  [5320] = {.lex_state = 10},
  [5321] = {.lex_state = 131},
  [5322] = {.lex_state = 131},
  [5323] = {.lex_state = 131},
  [5324] = {.lex_state = 131},
  [5325] = {.lex_state = 10},
  [5326] = {.lex_state = 131},
  [5327] = {.lex_state = 131},
  [5328] = {.lex_state = 131},
  [5329] = {.lex_state = 131},
  [5330] = {.lex_state = 131},
  [5331] = {.lex_state = 131},
  [5332] = {.lex_state = 10},
  [5333] = {.lex_state = 131},
  [5334] = {.lex_state = 131},
  [5335] = {.lex_state = 131},
  [5336] = {.lex_state = 131},
  [5337] = {.lex_state = 131},
  [5338] = {.lex_state = 131},
  [5339] = {.lex_state = 131},
  [5340] = {.lex_state = 131},
  [5341] = {.lex_state = 131},
  [5342] = {.lex_state = 131},
  [5343] = {.lex_state = 131},
  [5344] = {.lex_state = 10},
  [5345] = {.lex_state = 131},
  [5346] = {.lex_state = 10},
  [5347] = {.lex_state = 131},
  [5348] = {.lex_state = 131},
  [5349] = {.lex_state = 131},
  [5350] = {.lex_state = 131},
  [5351] = {.lex_state = 131},
  [5352] = {.lex_state = 131},
  [5353] = {.lex_state = 131},
  [5354] = {.lex_state = 131},
  [5355] = {.lex_state = 131},
  [5356] = {.lex_state = 131},
  [5357] = {.lex_state = 131},
  [5358] = {.lex_state = 131},
  [5359] = {.lex_state = 131},
  [5360] = {.lex_state = 131},
  [5361] = {.lex_state = 131},
  [5362] = {.lex_state = 131},
  [5363] = {.lex_state = 131},
  [5364] = {.lex_state = 131},
  [5365] = {.lex_state = 131},
  [5366] = {.lex_state = 10},
  [5367] = {.lex_state = 10},
  [5368] = {.lex_state = 10},
  [5369] = {.lex_state = 10},
  [5370] = {.lex_state = 10},
  [5371] = {.lex_state = 131},
  [5372] = {.lex_state = 132},
  [5373] = {.lex_state = 131},
  [5374] = {.lex_state = 131},
  [5375] = {.lex_state = 131},
  [5376] = {.lex_state = 131},
  [5377] = {.lex_state = 131},
  [5378] = {.lex_state = 131},
  [5379] = {.lex_state = 131},
  [5380] = {.lex_state = 132},
  [5381] = {.lex_state = 131},
  [5382] = {.lex_state = 131},
  [5383] = {.lex_state = 131},
  [5384] = {.lex_state = 131},
  [5385] = {.lex_state = 131},
  [5386] = {.lex_state = 131},
  [5387] = {.lex_state = 131},
  [5388] = {.lex_state = 131},
  [5389] = {.lex_state = 131},
  [5390] = {.lex_state = 131},
  [5391] = {.lex_state = 131},
  [5392] = {.lex_state = 131},
  [5393] = {.lex_state = 131},
  [5394] = {.lex_state = 131},
  [5395] = {.lex_state = 131},
  [5396] = {.lex_state = 131},
  [5397] = {.lex_state = 131},
  [5398] = {.lex_state = 131},
  [5399] = {.lex_state = 131},
  [5400] = {.lex_state = 131},
  [5401] = {.lex_state = 131},
  [5402] = {.lex_state = 131},
  [5403] = {.lex_state = 131},
  [5404] = {.lex_state = 131},
  [5405] = {.lex_state = 132},
  [5406] = {.lex_state = 132},
  [5407] = {.lex_state = 131},
  [5408] = {.lex_state = 131},
  [5409] = {.lex_state = 131},
  [5410] = {.lex_state = 131},
  [5411] = {.lex_state = 131},
  [5412] = {.lex_state = 131},
  [5413] = {.lex_state = 131},
  [5414] = {.lex_state = 131},
  [5415] = {.lex_state = 131},
  [5416] = {.lex_state = 131},
  [5417] = {.lex_state = 131},
  [5418] = {.lex_state = 131},
  [5419] = {.lex_state = 131},
  [5420] = {.lex_state = 131},
  [5421] = {.lex_state = 131},
  [5422] = {.lex_state = 131},
  [5423] = {.lex_state = 131},
  [5424] = {.lex_state = 131},
  [5425] = {.lex_state = 131},
  [5426] = {.lex_state = 131},
  [5427] = {.lex_state = 131},
  [5428] = {.lex_state = 131},
  [5429] = {.lex_state = 131},
  [5430] = {.lex_state = 131},
  [5431] = {.lex_state = 131},
  [5432] = {.lex_state = 131},
  [5433] = {.lex_state = 132},
  [5434] = {.lex_state = 131},
  [5435] = {.lex_state = 131},
  [5436] = {.lex_state = 131},
  [5437] = {.lex_state = 131},
  [5438] = {.lex_state = 131},
  [5439] = {.lex_state = 132},
  [5440] = {.lex_state = 131},
  [5441] = {.lex_state = 131},
  [5442] = {.lex_state = 131},
  [5443] = {.lex_state = 131},
  [5444] = {.lex_state = 131},
  [5445] = {.lex_state = 131},
  [5446] = {.lex_state = 131},
  [5447] = {.lex_state = 131},
  [5448] = {.lex_state = 131},
  [5449] = {.lex_state = 131},
  [5450] = {.lex_state = 131},
  [5451] = {.lex_state = 131},
  [5452] = {.lex_state = 131},
  [5453] = {.lex_state = 131},
  [5454] = {.lex_state = 131},
  [5455] = {.lex_state = 131},
  [5456] = {.lex_state = 131},
  [5457] = {.lex_state = 131},
  [5458] = {.lex_state = 131},
  [5459] = {.lex_state = 131},
  [5460] = {.lex_state = 131},
  [5461] = {.lex_state = 131},
  [5462] = {.lex_state = 132},
  [5463] = {.lex_state = 131},
  [5464] = {.lex_state = 131},
  [5465] = {.lex_state = 131},
  [5466] = {.lex_state = 131},
  [5467] = {.lex_state = 131},
  [5468] = {.lex_state = 131},
  [5469] = {.lex_state = 131},
  [5470] = {.lex_state = 131},
  [5471] = {.lex_state = 131},
  [5472] = {.lex_state = 131},
  [5473] = {.lex_state = 131},
  [5474] = {.lex_state = 131},
  [5475] = {.lex_state = 131},
  [5476] = {.lex_state = 131},
  [5477] = {.lex_state = 131},
  [5478] = {.lex_state = 131},
  [5479] = {.lex_state = 131},
  [5480] = {.lex_state = 131},
  [5481] = {.lex_state = 131},
  [5482] = {.lex_state = 131},
  [5483] = {.lex_state = 131},
  [5484] = {.lex_state = 131},
  [5485] = {.lex_state = 131},
  [5486] = {.lex_state = 131},
  [5487] = {.lex_state = 131},
  [5488] = {.lex_state = 131},
  [5489] = {.lex_state = 131},
  [5490] = {.lex_state = 131},
  [5491] = {.lex_state = 131},
  [5492] = {.lex_state = 132},
  [5493] = {.lex_state = 131},
  [5494] = {.lex_state = 131},
  [5495] = {.lex_state = 132},
  [5496] = {.lex_state = 131},
  [5497] = {.lex_state = 131},
  [5498] = {.lex_state = 131},
  [5499] = {.lex_state = 131},
  [5500] = {.lex_state = 131},
  [5501] = {.lex_state = 131},
  [5502] = {.lex_state = 131},
  [5503] = {.lex_state = 131},
  [5504] = {.lex_state = 131},
  [5505] = {.lex_state = 132},
  [5506] = {.lex_state = 131},
  [5507] = {.lex_state = 131},
  [5508] = {.lex_state = 132},
  [5509] = {.lex_state = 131},
  [5510] = {.lex_state = 131},
  [5511] = {.lex_state = 131},
  [5512] = {.lex_state = 131},
  [5513] = {.lex_state = 131},
  [5514] = {.lex_state = 131},
  [5515] = {.lex_state = 131},
  [5516] = {.lex_state = 131},
  [5517] = {.lex_state = 131},
  [5518] = {.lex_state = 131},
  [5519] = {.lex_state = 131},
  [5520] = {.lex_state = 132},
  [5521] = {.lex_state = 131},
  [5522] = {.lex_state = 131},
  [5523] = {.lex_state = 131},
  [5524] = {.lex_state = 131},
  [5525] = {.lex_state = 131},
  [5526] = {.lex_state = 131},
  [5527] = {.lex_state = 131},
  [5528] = {.lex_state = 131},
  [5529] = {.lex_state = 131},
  [5530] = {.lex_state = 131},
  [5531] = {.lex_state = 131},
  [5532] = {.lex_state = 131},
  [5533] = {.lex_state = 131},
  [5534] = {.lex_state = 131},
  [5535] = {.lex_state = 131},
  [5536] = {.lex_state = 131},
  [5537] = {.lex_state = 131},
  [5538] = {.lex_state = 131},
  [5539] = {.lex_state = 131},
  [5540] = {.lex_state = 131},
  [5541] = {.lex_state = 131},
  [5542] = {.lex_state = 131},
  [5543] = {.lex_state = 131},
  [5544] = {.lex_state = 131},
  [5545] = {.lex_state = 131},
  [5546] = {.lex_state = 131},
  [5547] = {.lex_state = 131},
  [5548] = {.lex_state = 131},
  [5549] = {.lex_state = 131},
  [5550] = {.lex_state = 131},
  [5551] = {.lex_state = 131},
  [5552] = {.lex_state = 131},
  [5553] = {.lex_state = 131},
  [5554] = {.lex_state = 131},
  [5555] = {.lex_state = 131},
  [5556] = {.lex_state = 131},
  [5557] = {.lex_state = 131},
  [5558] = {.lex_state = 131},
  [5559] = {.lex_state = 131},
  [5560] = {.lex_state = 131},
  [5561] = {.lex_state = 131},
  [5562] = {.lex_state = 131},
  [5563] = {.lex_state = 131},
  [5564] = {.lex_state = 131},
  [5565] = {.lex_state = 131},
  [5566] = {.lex_state = 131},
  [5567] = {.lex_state = 131},
  [5568] = {.lex_state = 131},
  [5569] = {.lex_state = 131},
  [5570] = {.lex_state = 131},
  [5571] = {.lex_state = 131},
  [5572] = {.lex_state = 131},
  [5573] = {.lex_state = 131},
  [5574] = {.lex_state = 131},
  [5575] = {.lex_state = 131},
  [5576] = {.lex_state = 131},
  [5577] = {.lex_state = 131},
  [5578] = {.lex_state = 131},
  [5579] = {.lex_state = 131},
  [5580] = {.lex_state = 131},
  [5581] = {.lex_state = 131},
  [5582] = {.lex_state = 131},
  [5583] = {.lex_state = 131},
  [5584] = {.lex_state = 131},
  [5585] = {.lex_state = 131},
  [5586] = {.lex_state = 131},
  [5587] = {.lex_state = 131},
  [5588] = {.lex_state = 131},
  [5589] = {.lex_state = 131},
  [5590] = {.lex_state = 131},
  [5591] = {.lex_state = 132},
  [5592] = {.lex_state = 131},
  [5593] = {.lex_state = 131},
  [5594] = {.lex_state = 131},
  [5595] = {.lex_state = 131},
  [5596] = {.lex_state = 131},
  [5597] = {.lex_state = 131},
  [5598] = {.lex_state = 131},
  [5599] = {.lex_state = 131},
  [5600] = {.lex_state = 131},
  [5601] = {.lex_state = 131},
  [5602] = {.lex_state = 131},
  [5603] = {.lex_state = 131},
  [5604] = {.lex_state = 131},
  [5605] = {.lex_state = 131},
  [5606] = {.lex_state = 131},
  [5607] = {.lex_state = 131},
  [5608] = {.lex_state = 131},
  [5609] = {.lex_state = 131},
  [5610] = {.lex_state = 131},
  [5611] = {.lex_state = 131},
  [5612] = {.lex_state = 131},
  [5613] = {.lex_state = 131},
  [5614] = {.lex_state = 131},
  [5615] = {.lex_state = 131},
  [5616] = {.lex_state = 131},
  [5617] = {.lex_state = 131},
  [5618] = {.lex_state = 131},
  [5619] = {.lex_state = 131},
  [5620] = {.lex_state = 131},
  [5621] = {.lex_state = 131},
  [5622] = {.lex_state = 131},
  [5623] = {.lex_state = 131},
  [5624] = {.lex_state = 131},
  [5625] = {.lex_state = 132},
  [5626] = {.lex_state = 131},
  [5627] = {.lex_state = 131},
  [5628] = {.lex_state = 131},
  [5629] = {.lex_state = 131},
  [5630] = {.lex_state = 131},
  [5631] = {.lex_state = 131},
  [5632] = {.lex_state = 131},
  [5633] = {.lex_state = 131},
  [5634] = {.lex_state = 131},
  [5635] = {.lex_state = 131},
  [5636] = {.lex_state = 131},
  [5637] = {.lex_state = 131},
  [5638] = {.lex_state = 131},
  [5639] = {.lex_state = 131},
  [5640] = {.lex_state = 131},
  [5641] = {.lex_state = 131},
  [5642] = {.lex_state = 131},
  [5643] = {.lex_state = 131},
  [5644] = {.lex_state = 131},
  [5645] = {.lex_state = 131},
  [5646] = {.lex_state = 131},
  [5647] = {.lex_state = 131},
  [5648] = {.lex_state = 131},
  [5649] = {.lex_state = 131},
  [5650] = {.lex_state = 131},
  [5651] = {.lex_state = 131},
  [5652] = {.lex_state = 131},
  [5653] = {.lex_state = 131},
  [5654] = {.lex_state = 131},
  [5655] = {.lex_state = 131},
  [5656] = {.lex_state = 131},
  [5657] = {.lex_state = 131},
  [5658] = {.lex_state = 131},
  [5659] = {.lex_state = 131},
  [5660] = {.lex_state = 131},
  [5661] = {.lex_state = 131},
  [5662] = {.lex_state = 131},
  [5663] = {.lex_state = 131},
  [5664] = {.lex_state = 131},
  [5665] = {.lex_state = 131},
  [5666] = {.lex_state = 131},
  [5667] = {.lex_state = 131},
  [5668] = {.lex_state = 131},
  [5669] = {.lex_state = 131},
  [5670] = {.lex_state = 131},
  [5671] = {.lex_state = 131},
  [5672] = {.lex_state = 131},
  [5673] = {.lex_state = 131},
  [5674] = {.lex_state = 131},
  [5675] = {.lex_state = 131},
  [5676] = {.lex_state = 131},
  [5677] = {.lex_state = 131},
  [5678] = {.lex_state = 131},
  [5679] = {.lex_state = 131},
  [5680] = {.lex_state = 131},
  [5681] = {.lex_state = 131},
  [5682] = {.lex_state = 131},
  [5683] = {.lex_state = 131},
  [5684] = {.lex_state = 131},
  [5685] = {.lex_state = 131},
  [5686] = {.lex_state = 131},
  [5687] = {.lex_state = 131},
  [5688] = {.lex_state = 131},
  [5689] = {.lex_state = 131},
  [5690] = {.lex_state = 131},
  [5691] = {.lex_state = 131},
  [5692] = {.lex_state = 131},
  [5693] = {.lex_state = 131},
  [5694] = {.lex_state = 131},
  [5695] = {.lex_state = 131},
  [5696] = {.lex_state = 131},
  [5697] = {.lex_state = 131},
  [5698] = {.lex_state = 131},
  [5699] = {.lex_state = 131},
  [5700] = {.lex_state = 131},
  [5701] = {.lex_state = 131},
  [5702] = {.lex_state = 131},
  [5703] = {.lex_state = 131},
  [5704] = {.lex_state = 131},
  [5705] = {.lex_state = 131},
  [5706] = {.lex_state = 131},
  [5707] = {.lex_state = 132},
  [5708] = {.lex_state = 131},
  [5709] = {.lex_state = 131},
  [5710] = {.lex_state = 131},
  [5711] = {.lex_state = 131},
  [5712] = {.lex_state = 131},
  [5713] = {.lex_state = 131},
  [5714] = {.lex_state = 131},
  [5715] = {.lex_state = 131},
  [5716] = {.lex_state = 131},
  [5717] = {.lex_state = 131},
  [5718] = {.lex_state = 131},
  [5719] = {.lex_state = 132},
  [5720] = {.lex_state = 131},
  [5721] = {.lex_state = 131},
  [5722] = {.lex_state = 132},
  [5723] = {.lex_state = 131},
  [5724] = {.lex_state = 131},
  [5725] = {.lex_state = 131},
  [5726] = {.lex_state = 131},
  [5727] = {.lex_state = 132},
  [5728] = {.lex_state = 131},
  [5729] = {.lex_state = 131},
  [5730] = {.lex_state = 131},
  [5731] = {.lex_state = 132},
  [5732] = {.lex_state = 132},
  [5733] = {.lex_state = 131},
  [5734] = {.lex_state = 131},
  [5735] = {.lex_state = 131},
  [5736] = {.lex_state = 131},
  [5737] = {.lex_state = 132},
  [5738] = {.lex_state = 131},
  [5739] = {.lex_state = 131},
  [5740] = {.lex_state = 131},
  [5741] = {.lex_state = 132},
  [5742] = {.lex_state = 132},
  [5743] = {.lex_state = 131},
  [5744] = {.lex_state = 131},
  [5745] = {.lex_state = 132},
  [5746] = {.lex_state = 131},
  [5747] = {.lex_state = 131},
  [5748] = {.lex_state = 131},
  [5749] = {.lex_state = 132},
  [5750] = {.lex_state = 131},
  [5751] = {.lex_state = 131},
  [5752] = {.lex_state = 132},
  [5753] = {.lex_state = 132},
  [5754] = {.lex_state = 132},
  [5755] = {.lex_state = 131},
  [5756] = {.lex_state = 131},
  [5757] = {.lex_state = 132},
  [5758] = {.lex_state = 131},
  [5759] = {.lex_state = 17},
  [5760] = {.lex_state = 132},
  [5761] = {.lex_state = 17},
  [5762] = {.lex_state = 132},
  [5763] = {.lex_state = 131},
  [5764] = {.lex_state = 132},
  [5765] = {.lex_state = 132},
  [5766] = {.lex_state = 132},
  [5767] = {.lex_state = 132},
  [5768] = {.lex_state = 131},
  [5769] = {.lex_state = 132},
  [5770] = {.lex_state = 132},
  [5771] = {.lex_state = 132},
  [5772] = {.lex_state = 132},
  [5773] = {.lex_state = 132},
  [5774] = {.lex_state = 17},
  [5775] = {.lex_state = 132},
  [5776] = {.lex_state = 132},
  [5777] = {.lex_state = 132},
  [5778] = {.lex_state = 132},
  [5779] = {.lex_state = 132},
  [5780] = {.lex_state = 132},
  [5781] = {.lex_state = 132},
  [5782] = {.lex_state = 132},
  [5783] = {.lex_state = 132},
  [5784] = {.lex_state = 132},
  [5785] = {.lex_state = 17},
  [5786] = {.lex_state = 132},
  [5787] = {.lex_state = 132},
  [5788] = {.lex_state = 132},
  [5789] = {.lex_state = 132},
  [5790] = {.lex_state = 132},
  [5791] = {.lex_state = 132},
  [5792] = {.lex_state = 132},
  [5793] = {.lex_state = 131},
  [5794] = {.lex_state = 132},
  [5795] = {.lex_state = 131},
  [5796] = {.lex_state = 131},
  [5797] = {.lex_state = 132},
  [5798] = {.lex_state = 131},
  [5799] = {.lex_state = 132},
  [5800] = {.lex_state = 132},
  [5801] = {.lex_state = 132},
  [5802] = {.lex_state = 132},
  [5803] = {.lex_state = 132},
  [5804] = {.lex_state = 132},
  [5805] = {.lex_state = 132},
  [5806] = {.lex_state = 132},
  [5807] = {.lex_state = 132},
  [5808] = {.lex_state = 132},
  [5809] = {.lex_state = 132},
  [5810] = {.lex_state = 132},
  [5811] = {.lex_state = 132},
  [5812] = {.lex_state = 132},
  [5813] = {.lex_state = 132},
  [5814] = {.lex_state = 132},
  [5815] = {.lex_state = 132},
  [5816] = {.lex_state = 132},
  [5817] = {.lex_state = 132},
  [5818] = {.lex_state = 132},
  [5819] = {.lex_state = 132},
  [5820] = {.lex_state = 132},
  [5821] = {.lex_state = 132},
  [5822] = {.lex_state = 132},
  [5823] = {.lex_state = 132},
  [5824] = {.lex_state = 132},
  [5825] = {.lex_state = 132},
  [5826] = {.lex_state = 132},
  [5827] = {.lex_state = 132},
  [5828] = {.lex_state = 132},
  [5829] = {.lex_state = 132},
  [5830] = {.lex_state = 132},
  [5831] = {.lex_state = 132},
  [5832] = {.lex_state = 132},
  [5833] = {.lex_state = 132},
  [5834] = {.lex_state = 132},
  [5835] = {.lex_state = 132},
  [5836] = {.lex_state = 132},
  [5837] = {.lex_state = 132},
  [5838] = {.lex_state = 132},
  [5839] = {.lex_state = 132},
  [5840] = {.lex_state = 132},
  [5841] = {.lex_state = 132},
  [5842] = {.lex_state = 132},
  [5843] = {.lex_state = 132},
  [5844] = {.lex_state = 132},
  [5845] = {.lex_state = 132},
  [5846] = {.lex_state = 132},
  [5847] = {.lex_state = 132},
  [5848] = {.lex_state = 132},
  [5849] = {.lex_state = 132},
  [5850] = {.lex_state = 132},
  [5851] = {.lex_state = 132},
  [5852] = {.lex_state = 132},
  [5853] = {.lex_state = 132},
  [5854] = {.lex_state = 132},
  [5855] = {.lex_state = 132},
  [5856] = {.lex_state = 132},
  [5857] = {.lex_state = 132},
  [5858] = {.lex_state = 132},
  [5859] = {.lex_state = 132},
  [5860] = {.lex_state = 132},
  [5861] = {.lex_state = 132},
  [5862] = {.lex_state = 132},
  [5863] = {.lex_state = 132},
  [5864] = {.lex_state = 132},
  [5865] = {.lex_state = 132},
  [5866] = {.lex_state = 132},
  [5867] = {.lex_state = 132},
  [5868] = {.lex_state = 132},
  [5869] = {.lex_state = 132},
  [5870] = {.lex_state = 132},
  [5871] = {.lex_state = 132},
  [5872] = {.lex_state = 132},
  [5873] = {.lex_state = 132},
  [5874] = {.lex_state = 132},
  [5875] = {.lex_state = 132},
  [5876] = {.lex_state = 132},
  [5877] = {.lex_state = 132},
  [5878] = {.lex_state = 132},
  [5879] = {.lex_state = 132},
  [5880] = {.lex_state = 132},
  [5881] = {.lex_state = 132},
  [5882] = {.lex_state = 132},
  [5883] = {.lex_state = 132},
  [5884] = {.lex_state = 132},
  [5885] = {.lex_state = 132},
  [5886] = {.lex_state = 132},
  [5887] = {.lex_state = 132},
  [5888] = {.lex_state = 132},
  [5889] = {.lex_state = 132},
  [5890] = {.lex_state = 132},
  [5891] = {.lex_state = 132},
  [5892] = {.lex_state = 132},
  [5893] = {.lex_state = 132},
  [5894] = {.lex_state = 132},
  [5895] = {.lex_state = 132},
  [5896] = {.lex_state = 132},
  [5897] = {.lex_state = 132},
  [5898] = {.lex_state = 132},
  [5899] = {.lex_state = 132},
  [5900] = {.lex_state = 132},
  [5901] = {.lex_state = 132},
  [5902] = {.lex_state = 132},
  [5903] = {.lex_state = 132},
  [5904] = {.lex_state = 132},
  [5905] = {.lex_state = 132},
  [5906] = {.lex_state = 132},
  [5907] = {.lex_state = 131},
  [5908] = {.lex_state = 132},
  [5909] = {.lex_state = 132},
  [5910] = {.lex_state = 132},
  [5911] = {.lex_state = 132},
  [5912] = {.lex_state = 132},
  [5913] = {.lex_state = 132},
  [5914] = {.lex_state = 132},
  [5915] = {.lex_state = 132},
  [5916] = {.lex_state = 132},
  [5917] = {.lex_state = 132},
  [5918] = {.lex_state = 132},
  [5919] = {.lex_state = 132},
  [5920] = {.lex_state = 132},
  [5921] = {.lex_state = 132},
  [5922] = {.lex_state = 132},
  [5923] = {.lex_state = 132},
  [5924] = {.lex_state = 132},
  [5925] = {.lex_state = 132},
  [5926] = {.lex_state = 132},
  [5927] = {.lex_state = 132},
  [5928] = {.lex_state = 132},
  [5929] = {.lex_state = 132},
  [5930] = {.lex_state = 132},
  [5931] = {.lex_state = 132},
  [5932] = {.lex_state = 132},
  [5933] = {.lex_state = 132},
  [5934] = {.lex_state = 132},
  [5935] = {.lex_state = 132},
  [5936] = {.lex_state = 132},
  [5937] = {.lex_state = 132},
  [5938] = {.lex_state = 132},
  [5939] = {.lex_state = 132},
  [5940] = {.lex_state = 132},
  [5941] = {.lex_state = 132},
  [5942] = {.lex_state = 132},
  [5943] = {.lex_state = 132},
  [5944] = {.lex_state = 132},
  [5945] = {.lex_state = 132},
  [5946] = {.lex_state = 132},
  [5947] = {.lex_state = 132},
  [5948] = {.lex_state = 132},
  [5949] = {.lex_state = 132},
  [5950] = {.lex_state = 132},
  [5951] = {.lex_state = 132},
  [5952] = {.lex_state = 132},
  [5953] = {.lex_state = 132},
  [5954] = {.lex_state = 132},
  [5955] = {.lex_state = 132},
  [5956] = {.lex_state = 132},
  [5957] = {.lex_state = 132},
  [5958] = {.lex_state = 132},
  [5959] = {.lex_state = 132},
  [5960] = {.lex_state = 132},
  [5961] = {.lex_state = 132},
  [5962] = {.lex_state = 132},
  [5963] = {.lex_state = 132},
  [5964] = {.lex_state = 132},
  [5965] = {.lex_state = 132},
  [5966] = {.lex_state = 132},
  [5967] = {.lex_state = 132},
  [5968] = {.lex_state = 132},
  [5969] = {.lex_state = 132},
  [5970] = {.lex_state = 132},
  [5971] = {.lex_state = 132},
  [5972] = {.lex_state = 132},
  [5973] = {.lex_state = 132},
  [5974] = {.lex_state = 132},
  [5975] = {.lex_state = 132},
  [5976] = {.lex_state = 132},
  [5977] = {.lex_state = 132},
  [5978] = {.lex_state = 132},
  [5979] = {.lex_state = 132},
  [5980] = {.lex_state = 132},
  [5981] = {.lex_state = 132},
  [5982] = {.lex_state = 132},
  [5983] = {.lex_state = 132},
  [5984] = {.lex_state = 132},
  [5985] = {.lex_state = 132},
  [5986] = {.lex_state = 132},
  [5987] = {.lex_state = 132},
  [5988] = {.lex_state = 132},
  [5989] = {.lex_state = 132},
  [5990] = {.lex_state = 132},
  [5991] = {.lex_state = 132},
  [5992] = {.lex_state = 132},
  [5993] = {.lex_state = 132},
  [5994] = {.lex_state = 132},
  [5995] = {.lex_state = 132},
  [5996] = {.lex_state = 132},
  [5997] = {.lex_state = 132},
  [5998] = {.lex_state = 132},
  [5999] = {.lex_state = 132},
  [6000] = {.lex_state = 132},
  [6001] = {.lex_state = 132},
  [6002] = {.lex_state = 132},
  [6003] = {.lex_state = 132},
  [6004] = {.lex_state = 132},
  [6005] = {.lex_state = 132},
  [6006] = {.lex_state = 132},
  [6007] = {.lex_state = 132},
  [6008] = {.lex_state = 132},
  [6009] = {.lex_state = 132},
  [6010] = {.lex_state = 1},
  [6011] = {.lex_state = 132},
  [6012] = {.lex_state = 132},
  [6013] = {.lex_state = 132},
  [6014] = {.lex_state = 132},
  [6015] = {.lex_state = 132},
  [6016] = {.lex_state = 132},
  [6017] = {.lex_state = 132},
  [6018] = {.lex_state = 132},
  [6019] = {.lex_state = 132},
  [6020] = {.lex_state = 132},
  [6021] = {.lex_state = 132},
  [6022] = {.lex_state = 132},
  [6023] = {.lex_state = 132},
  [6024] = {.lex_state = 132},
  [6025] = {.lex_state = 132},
  [6026] = {.lex_state = 132},
  [6027] = {.lex_state = 132},
  [6028] = {.lex_state = 132},
  [6029] = {.lex_state = 132},
  [6030] = {.lex_state = 132},
  [6031] = {.lex_state = 132},
  [6032] = {.lex_state = 132},
  [6033] = {.lex_state = 132},
  [6034] = {.lex_state = 132},
  [6035] = {.lex_state = 132},
  [6036] = {.lex_state = 132},
  [6037] = {.lex_state = 132},
  [6038] = {.lex_state = 132},
  [6039] = {.lex_state = 132},
  [6040] = {.lex_state = 132},
  [6041] = {.lex_state = 132},
  [6042] = {.lex_state = 132},
  [6043] = {.lex_state = 132},
  [6044] = {.lex_state = 132},
  [6045] = {.lex_state = 132},
  [6046] = {.lex_state = 132},
  [6047] = {.lex_state = 132},
  [6048] = {.lex_state = 132},
  [6049] = {.lex_state = 132},
  [6050] = {.lex_state = 132},
  [6051] = {.lex_state = 132},
  [6052] = {.lex_state = 132},
  [6053] = {.lex_state = 132},
  [6054] = {.lex_state = 132},
  [6055] = {.lex_state = 132},
  [6056] = {.lex_state = 132},
  [6057] = {.lex_state = 132},
  [6058] = {.lex_state = 132},
  [6059] = {.lex_state = 132},
  [6060] = {.lex_state = 132},
  [6061] = {.lex_state = 132},
  [6062] = {.lex_state = 132},
  [6063] = {.lex_state = 132},
  [6064] = {.lex_state = 132},
  [6065] = {.lex_state = 132},
  [6066] = {.lex_state = 132},
  [6067] = {.lex_state = 132},
  [6068] = {.lex_state = 132},
  [6069] = {.lex_state = 132},
  [6070] = {.lex_state = 132},
  [6071] = {.lex_state = 132},
  [6072] = {.lex_state = 132},
  [6073] = {.lex_state = 132},
  [6074] = {.lex_state = 132},
  [6075] = {.lex_state = 132},
  [6076] = {.lex_state = 132},
  [6077] = {.lex_state = 132},
  [6078] = {.lex_state = 132},
  [6079] = {.lex_state = 132},
  [6080] = {.lex_state = 132},
  [6081] = {.lex_state = 132},
  [6082] = {.lex_state = 132},
  [6083] = {.lex_state = 132},
  [6084] = {.lex_state = 132},
  [6085] = {.lex_state = 132},
  [6086] = {.lex_state = 132},
  [6087] = {.lex_state = 132},
  [6088] = {.lex_state = 132},
  [6089] = {.lex_state = 132},
  [6090] = {.lex_state = 132},
  [6091] = {.lex_state = 132},
  [6092] = {.lex_state = 132},
  [6093] = {.lex_state = 132},
  [6094] = {.lex_state = 132},
  [6095] = {.lex_state = 132},
  [6096] = {.lex_state = 132},
  [6097] = {.lex_state = 132},
  [6098] = {.lex_state = 132},
  [6099] = {.lex_state = 132},
  [6100] = {.lex_state = 132},
  [6101] = {.lex_state = 132},
  [6102] = {.lex_state = 132},
  [6103] = {.lex_state = 132},
  [6104] = {.lex_state = 132},
  [6105] = {.lex_state = 132},
  [6106] = {.lex_state = 132},
  [6107] = {.lex_state = 132},
  [6108] = {.lex_state = 132},
  [6109] = {.lex_state = 132},
  [6110] = {.lex_state = 132},
  [6111] = {.lex_state = 132},
  [6112] = {.lex_state = 132},
  [6113] = {.lex_state = 132},
  [6114] = {.lex_state = 132},
  [6115] = {.lex_state = 132},
  [6116] = {.lex_state = 132},
  [6117] = {.lex_state = 132},
  [6118] = {.lex_state = 132},
  [6119] = {.lex_state = 132},
  [6120] = {.lex_state = 132},
  [6121] = {.lex_state = 132},
  [6122] = {.lex_state = 132},
  [6123] = {.lex_state = 132},
  [6124] = {.lex_state = 4},
  [6125] = {.lex_state = 132},
  [6126] = {.lex_state = 132},
  [6127] = {.lex_state = 132},
  [6128] = {.lex_state = 132},
  [6129] = {.lex_state = 132},
  [6130] = {.lex_state = 132},
  [6131] = {.lex_state = 132},
  [6132] = {.lex_state = 132},
  [6133] = {.lex_state = 132},
  [6134] = {.lex_state = 132},
  [6135] = {.lex_state = 132},
  [6136] = {.lex_state = 132},
  [6137] = {.lex_state = 132},
  [6138] = {.lex_state = 132},
  [6139] = {.lex_state = 132},
  [6140] = {.lex_state = 132},
  [6141] = {.lex_state = 132},
  [6142] = {.lex_state = 132},
  [6143] = {.lex_state = 132},
  [6144] = {.lex_state = 132},
  [6145] = {.lex_state = 132},
  [6146] = {.lex_state = 132},
  [6147] = {.lex_state = 132},
  [6148] = {.lex_state = 132},
  [6149] = {.lex_state = 132},
  [6150] = {.lex_state = 132},
  [6151] = {.lex_state = 132},
  [6152] = {.lex_state = 132},
  [6153] = {.lex_state = 132},
  [6154] = {.lex_state = 132},
  [6155] = {.lex_state = 132},
  [6156] = {.lex_state = 132},
  [6157] = {.lex_state = 132},
  [6158] = {.lex_state = 132},
  [6159] = {.lex_state = 132},
  [6160] = {.lex_state = 132},
  [6161] = {.lex_state = 132},
  [6162] = {.lex_state = 132},
  [6163] = {.lex_state = 132},
  [6164] = {.lex_state = 132},
  [6165] = {.lex_state = 132},
  [6166] = {.lex_state = 132},
  [6167] = {.lex_state = 132},
  [6168] = {.lex_state = 132},
  [6169] = {.lex_state = 132},
  [6170] = {.lex_state = 132},
  [6171] = {.lex_state = 132},
  [6172] = {.lex_state = 132},
  [6173] = {.lex_state = 132},
  [6174] = {.lex_state = 132},
  [6175] = {.lex_state = 132},
  [6176] = {.lex_state = 132},
  [6177] = {.lex_state = 132},
  [6178] = {.lex_state = 132},
  [6179] = {.lex_state = 132},
  [6180] = {.lex_state = 132},
  [6181] = {.lex_state = 132},
  [6182] = {.lex_state = 132},
  [6183] = {.lex_state = 132},
  [6184] = {.lex_state = 132},
  [6185] = {.lex_state = 132},
  [6186] = {.lex_state = 8},
  [6187] = {.lex_state = 8},
  [6188] = {.lex_state = 8},
  [6189] = {.lex_state = 8},
  [6190] = {.lex_state = 8},
  [6191] = {.lex_state = 8},
  [6192] = {.lex_state = 8},
  [6193] = {.lex_state = 8},
  [6194] = {.lex_state = 8},
  [6195] = {.lex_state = 8},
  [6196] = {.lex_state = 132},
  [6197] = {.lex_state = 8},
  [6198] = {.lex_state = 8},
  [6199] = {.lex_state = 132},
  [6200] = {.lex_state = 132},
  [6201] = {.lex_state = 132},
  [6202] = {.lex_state = 132},
  [6203] = {.lex_state = 132},
  [6204] = {.lex_state = 132},
  [6205] = {.lex_state = 132},
  [6206] = {.lex_state = 132},
  [6207] = {.lex_state = 132},
  [6208] = {.lex_state = 132},
  [6209] = {.lex_state = 132},
  [6210] = {.lex_state = 132},
  [6211] = {.lex_state = 132},
  [6212] = {.lex_state = 132},
  [6213] = {.lex_state = 132},
  [6214] = {.lex_state = 132},
  [6215] = {.lex_state = 132},
  [6216] = {.lex_state = 132},
  [6217] = {.lex_state = 132},
  [6218] = {.lex_state = 132},
  [6219] = {.lex_state = 132},
  [6220] = {.lex_state = 132},
  [6221] = {.lex_state = 132},
  [6222] = {.lex_state = 132},
  [6223] = {.lex_state = 132},
  [6224] = {.lex_state = 132},
  [6225] = {.lex_state = 132},
  [6226] = {.lex_state = 132},
  [6227] = {.lex_state = 132},
  [6228] = {.lex_state = 132},
  [6229] = {.lex_state = 132},
  [6230] = {.lex_state = 132},
  [6231] = {.lex_state = 132},
  [6232] = {.lex_state = 132},
  [6233] = {.lex_state = 132},
  [6234] = {.lex_state = 132},
  [6235] = {.lex_state = 132},
  [6236] = {.lex_state = 132},
  [6237] = {.lex_state = 132},
  [6238] = {.lex_state = 132},
  [6239] = {.lex_state = 132},
  [6240] = {.lex_state = 132},
  [6241] = {.lex_state = 132},
  [6242] = {.lex_state = 132},
  [6243] = {.lex_state = 132},
  [6244] = {.lex_state = 132},
  [6245] = {.lex_state = 132},
  [6246] = {.lex_state = 132},
  [6247] = {.lex_state = 132},
  [6248] = {.lex_state = 132},
  [6249] = {.lex_state = 132},
  [6250] = {.lex_state = 132},
  [6251] = {.lex_state = 132},
  [6252] = {.lex_state = 132},
  [6253] = {.lex_state = 132},
  [6254] = {.lex_state = 132},
  [6255] = {.lex_state = 132},
  [6256] = {.lex_state = 132},
  [6257] = {.lex_state = 132},
  [6258] = {.lex_state = 132},
  [6259] = {.lex_state = 132},
  [6260] = {.lex_state = 132},
  [6261] = {.lex_state = 132},
  [6262] = {.lex_state = 132},
  [6263] = {.lex_state = 132},
  [6264] = {.lex_state = 132},
  [6265] = {.lex_state = 132},
  [6266] = {.lex_state = 132},
  [6267] = {.lex_state = 132},
  [6268] = {.lex_state = 132},
  [6269] = {.lex_state = 132},
  [6270] = {.lex_state = 132},
  [6271] = {.lex_state = 132},
  [6272] = {.lex_state = 132},
  [6273] = {.lex_state = 132},
  [6274] = {.lex_state = 132},
  [6275] = {.lex_state = 132},
  [6276] = {.lex_state = 132},
  [6277] = {.lex_state = 132},
  [6278] = {.lex_state = 132},
  [6279] = {.lex_state = 132},
  [6280] = {.lex_state = 132},
  [6281] = {.lex_state = 132},
  [6282] = {.lex_state = 132},
  [6283] = {.lex_state = 132},
  [6284] = {.lex_state = 132},
  [6285] = {.lex_state = 132},
  [6286] = {.lex_state = 132},
  [6287] = {.lex_state = 132},
  [6288] = {.lex_state = 132},
  [6289] = {.lex_state = 132},
  [6290] = {.lex_state = 132},
  [6291] = {.lex_state = 132},
  [6292] = {.lex_state = 132},
  [6293] = {.lex_state = 132},
  [6294] = {.lex_state = 132},
  [6295] = {.lex_state = 132},
  [6296] = {.lex_state = 132},
  [6297] = {.lex_state = 132},
  [6298] = {.lex_state = 132},
  [6299] = {.lex_state = 132},
  [6300] = {.lex_state = 132},
  [6301] = {.lex_state = 132},
  [6302] = {.lex_state = 132},
  [6303] = {.lex_state = 132},
  [6304] = {.lex_state = 132},
  [6305] = {.lex_state = 0},
  [6306] = {.lex_state = 0},
  [6307] = {.lex_state = 0},
  [6308] = {.lex_state = 132},
  [6309] = {.lex_state = 132},
  [6310] = {.lex_state = 131},
  [6311] = {.lex_state = 131},
  [6312] = {.lex_state = 131},
  [6313] = {.lex_state = 131},
  [6314] = {.lex_state = 131},
  [6315] = {.lex_state = 131},
  [6316] = {.lex_state = 131},
  [6317] = {.lex_state = 131},
  [6318] = {.lex_state = 131},
  [6319] = {.lex_state = 131},
  [6320] = {.lex_state = 131},
  [6321] = {.lex_state = 131},
  [6322] = {.lex_state = 131},
  [6323] = {.lex_state = 131},
  [6324] = {.lex_state = 131},
  [6325] = {.lex_state = 17},
  [6326] = {.lex_state = 131},
  [6327] = {.lex_state = 131},
  [6328] = {.lex_state = 131},
  [6329] = {.lex_state = 131},
  [6330] = {.lex_state = 131},
  [6331] = {.lex_state = 131},
  [6332] = {.lex_state = 131},
  [6333] = {.lex_state = 132},
  [6334] = {.lex_state = 0},
  [6335] = {.lex_state = 132},
  [6336] = {.lex_state = 17},
  [6337] = {.lex_state = 0},
  [6338] = {.lex_state = 0},
  [6339] = {.lex_state = 131},
  [6340] = {.lex_state = 132},
  [6341] = {.lex_state = 0},
  [6342] = {.lex_state = 131},
  [6343] = {.lex_state = 132},
  [6344] = {.lex_state = 132},
  [6345] = {.lex_state = 131},
  [6346] = {.lex_state = 132},
  [6347] = {.lex_state = 131},
  [6348] = {.lex_state = 131},
  [6349] = {.lex_state = 132},
  [6350] = {.lex_state = 132},
  [6351] = {.lex_state = 132},
  [6352] = {.lex_state = 132},
  [6353] = {.lex_state = 132},
  [6354] = {.lex_state = 132},
  [6355] = {.lex_state = 132},
  [6356] = {.lex_state = 10},
  [6357] = {.lex_state = 132},
  [6358] = {.lex_state = 132},
  [6359] = {.lex_state = 132},
  [6360] = {.lex_state = 132},
  [6361] = {.lex_state = 131},
  [6362] = {.lex_state = 132},
  [6363] = {.lex_state = 132},
  [6364] = {.lex_state = 132},
  [6365] = {.lex_state = 132},
  [6366] = {.lex_state = 132},
  [6367] = {.lex_state = 132},
  [6368] = {.lex_state = 132},
  [6369] = {.lex_state = 132},
  [6370] = {.lex_state = 132},
  [6371] = {.lex_state = 132},
  [6372] = {.lex_state = 131},
  [6373] = {.lex_state = 132},
  [6374] = {.lex_state = 132},
  [6375] = {.lex_state = 132},
  [6376] = {.lex_state = 132},
  [6377] = {.lex_state = 132},
  [6378] = {.lex_state = 0},
  [6379] = {.lex_state = 132},
  [6380] = {.lex_state = 132},
  [6381] = {.lex_state = 132},
  [6382] = {.lex_state = 132},
  [6383] = {.lex_state = 132},
  [6384] = {.lex_state = 132},
  [6385] = {.lex_state = 132},
  [6386] = {.lex_state = 132},
  [6387] = {.lex_state = 0},
  [6388] = {.lex_state = 132},
  [6389] = {.lex_state = 131},
  [6390] = {.lex_state = 0},
  [6391] = {.lex_state = 132},
  [6392] = {.lex_state = 0},
  [6393] = {.lex_state = 131},
  [6394] = {.lex_state = 131},
  [6395] = {.lex_state = 131},
  [6396] = {.lex_state = 131},
  [6397] = {.lex_state = 131},
  [6398] = {.lex_state = 132},
  [6399] = {.lex_state = 132},
  [6400] = {.lex_state = 131},
  [6401] = {.lex_state = 0},
  [6402] = {.lex_state = 131},
  [6403] = {.lex_state = 132},
  [6404] = {.lex_state = 132},
  [6405] = {.lex_state = 18, .external_lex_state = 5},
  [6406] = {.lex_state = 131},
  [6407] = {.lex_state = 18, .external_lex_state = 5},
  [6408] = {.lex_state = 18, .external_lex_state = 5},
  [6409] = {.lex_state = 18, .external_lex_state = 5},
  [6410] = {.lex_state = 132},
  [6411] = {.lex_state = 0},
  [6412] = {.lex_state = 132},
  [6413] = {.lex_state = 132},
  [6414] = {.lex_state = 131},
  [6415] = {.lex_state = 132},
  [6416] = {.lex_state = 132},
  [6417] = {.lex_state = 18, .external_lex_state = 5},
  [6418] = {.lex_state = 0},
  [6419] = {.lex_state = 132},
  [6420] = {.lex_state = 131},
  [6421] = {.lex_state = 132},
  [6422] = {.lex_state = 132},
  [6423] = {.lex_state = 18, .external_lex_state = 5},
  [6424] = {.lex_state = 131},
  [6425] = {.lex_state = 132},
  [6426] = {.lex_state = 131},
  [6427] = {.lex_state = 132},
  [6428] = {.lex_state = 0},
  [6429] = {.lex_state = 0},
  [6430] = {.lex_state = 131},
  [6431] = {.lex_state = 0},
  [6432] = {.lex_state = 18, .external_lex_state = 5},
  [6433] = {.lex_state = 18, .external_lex_state = 5},
  [6434] = {.lex_state = 18, .external_lex_state = 5},
  [6435] = {.lex_state = 18, .external_lex_state = 5},
  [6436] = {.lex_state = 18, .external_lex_state = 5},
  [6437] = {.lex_state = 131},
  [6438] = {.lex_state = 132},
  [6439] = {.lex_state = 0, .external_lex_state = 5},
  [6440] = {.lex_state = 132},
  [6441] = {.lex_state = 2},
  [6442] = {.lex_state = 0},
  [6443] = {.lex_state = 0, .external_lex_state = 5},
  [6444] = {.lex_state = 131},
  [6445] = {.lex_state = 0, .external_lex_state = 5},
  [6446] = {.lex_state = 132},
  [6447] = {.lex_state = 132},
  [6448] = {.lex_state = 0},
  [6449] = {.lex_state = 131},
  [6450] = {.lex_state = 0, .external_lex_state = 5},
  [6451] = {.lex_state = 0},
  [6452] = {.lex_state = 0},
  [6453] = {.lex_state = 0},
  [6454] = {.lex_state = 0},
  [6455] = {.lex_state = 132},
  [6456] = {.lex_state = 0},
  [6457] = {.lex_state = 2},
  [6458] = {.lex_state = 0, .external_lex_state = 5},
  [6459] = {.lex_state = 0},
  [6460] = {.lex_state = 0},
  [6461] = {.lex_state = 0, .external_lex_state = 5},
  [6462] = {.lex_state = 2},
  [6463] = {.lex_state = 10},
  [6464] = {.lex_state = 2},
  [6465] = {.lex_state = 0, .external_lex_state = 5},
  [6466] = {.lex_state = 0, .external_lex_state = 5},
  [6467] = {.lex_state = 0},
  [6468] = {.lex_state = 132},
  [6469] = {.lex_state = 131},
  [6470] = {.lex_state = 131},
  [6471] = {.lex_state = 0},
  [6472] = {.lex_state = 132},
  [6473] = {.lex_state = 2},
  [6474] = {.lex_state = 0, .external_lex_state = 5},
  [6475] = {.lex_state = 2},
  [6476] = {.lex_state = 0, .external_lex_state = 5},
  [6477] = {.lex_state = 0},
  [6478] = {.lex_state = 0, .external_lex_state = 5},
  [6479] = {.lex_state = 0},
  [6480] = {.lex_state = 0, .external_lex_state = 5},
  [6481] = {.lex_state = 132},
  [6482] = {.lex_state = 2},
  [6483] = {.lex_state = 1},
  [6484] = {.lex_state = 132},
  [6485] = {.lex_state = 0},
  [6486] = {.lex_state = 0},
  [6487] = {.lex_state = 0},
  [6488] = {.lex_state = 0},
  [6489] = {.lex_state = 2},
  [6490] = {.lex_state = 132},
  [6491] = {.lex_state = 2},
  [6492] = {.lex_state = 0},
  [6493] = {.lex_state = 132},
  [6494] = {.lex_state = 0, .external_lex_state = 5},
  [6495] = {.lex_state = 0, .external_lex_state = 5},
  [6496] = {.lex_state = 2},
  [6497] = {.lex_state = 0, .external_lex_state = 5},
  [6498] = {.lex_state = 0, .external_lex_state = 5},
  [6499] = {.lex_state = 0, .external_lex_state = 5},
  [6500] = {.lex_state = 0, .external_lex_state = 5},
  [6501] = {.lex_state = 0},
  [6502] = {.lex_state = 0},
  [6503] = {.lex_state = 0},
  [6504] = {.lex_state = 0},
  [6505] = {.lex_state = 10},
  [6506] = {.lex_state = 0},
  [6507] = {.lex_state = 2},
  [6508] = {.lex_state = 2},
  [6509] = {.lex_state = 0, .external_lex_state = 5},
  [6510] = {.lex_state = 132},
  [6511] = {.lex_state = 132},
  [6512] = {.lex_state = 132},
  [6513] = {.lex_state = 132},
  [6514] = {.lex_state = 0, .external_lex_state = 5},
  [6515] = {.lex_state = 0, .external_lex_state = 5},
  [6516] = {.lex_state = 132},
  [6517] = {.lex_state = 2},
  [6518] = {.lex_state = 0},
  [6519] = {.lex_state = 1},
  [6520] = {.lex_state = 132},
  [6521] = {.lex_state = 0},
  [6522] = {.lex_state = 0, .external_lex_state = 5},
  [6523] = {.lex_state = 132},
  [6524] = {.lex_state = 132},
  [6525] = {.lex_state = 132},
  [6526] = {.lex_state = 132},
  [6527] = {.lex_state = 132},
  [6528] = {.lex_state = 0},
  [6529] = {.lex_state = 0},
  [6530] = {.lex_state = 1},
  [6531] = {.lex_state = 1},
  [6532] = {.lex_state = 132},
  [6533] = {.lex_state = 0},
  [6534] = {.lex_state = 132},
  [6535] = {.lex_state = 132},
  [6536] = {.lex_state = 0},
  [6537] = {.lex_state = 132},
  [6538] = {.lex_state = 1},
  [6539] = {.lex_state = 1},
  [6540] = {.lex_state = 132},
  [6541] = {.lex_state = 1},
  [6542] = {.lex_state = 10},
  [6543] = {.lex_state = 132},
  [6544] = {.lex_state = 0},
  [6545] = {.lex_state = 1},
  [6546] = {.lex_state = 132},
  [6547] = {.lex_state = 131},
  [6548] = {.lex_state = 0},
  [6549] = {.lex_state = 132},
  [6550] = {.lex_state = 132},
  [6551] = {.lex_state = 132},
  [6552] = {.lex_state = 132},
  [6553] = {.lex_state = 1},
  [6554] = {.lex_state = 1},
  [6555] = {.lex_state = 1},
  [6556] = {.lex_state = 131},
  [6557] = {.lex_state = 132},
  [6558] = {.lex_state = 132},
  [6559] = {.lex_state = 132},
  [6560] = {.lex_state = 132},
  [6561] = {.lex_state = 132},
  [6562] = {.lex_state = 132},
  [6563] = {.lex_state = 0},
  [6564] = {.lex_state = 132},
  [6565] = {.lex_state = 132},
  [6566] = {.lex_state = 1},
  [6567] = {.lex_state = 132},
  [6568] = {.lex_state = 1},
  [6569] = {.lex_state = 132},
  [6570] = {.lex_state = 1},
  [6571] = {.lex_state = 132},
  [6572] = {.lex_state = 132},
  [6573] = {.lex_state = 0},
  [6574] = {.lex_state = 132},
  [6575] = {.lex_state = 0},
  [6576] = {.lex_state = 1},
  [6577] = {.lex_state = 132},
  [6578] = {.lex_state = 132},
  [6579] = {.lex_state = 132},
  [6580] = {.lex_state = 0},
  [6581] = {.lex_state = 132},
  [6582] = {.lex_state = 132},
  [6583] = {.lex_state = 132},
  [6584] = {.lex_state = 132},
  [6585] = {.lex_state = 132},
  [6586] = {.lex_state = 132},
  [6587] = {.lex_state = 0},
  [6588] = {.lex_state = 132},
  [6589] = {.lex_state = 132},
  [6590] = {.lex_state = 132},
  [6591] = {.lex_state = 1},
  [6592] = {.lex_state = 132},
  [6593] = {.lex_state = 132},
  [6594] = {.lex_state = 132},
  [6595] = {.lex_state = 132},
  [6596] = {.lex_state = 0},
  [6597] = {.lex_state = 132},
  [6598] = {.lex_state = 132},
  [6599] = {.lex_state = 1},
  [6600] = {.lex_state = 1},
  [6601] = {.lex_state = 1},
  [6602] = {.lex_state = 1},
  [6603] = {.lex_state = 1},
  [6604] = {.lex_state = 1},
  [6605] = {.lex_state = 1},
  [6606] = {.lex_state = 132},
  [6607] = {.lex_state = 132},
  [6608] = {.lex_state = 132},
  [6609] = {.lex_state = 132},
  [6610] = {.lex_state = 132},
  [6611] = {.lex_state = 132},
  [6612] = {.lex_state = 1},
  [6613] = {.lex_state = 0},
  [6614] = {.lex_state = 132},
  [6615] = {.lex_state = 1},
  [6616] = {.lex_state = 132},
  [6617] = {.lex_state = 132},
  [6618] = {.lex_state = 0},
  [6619] = {.lex_state = 132},
  [6620] = {.lex_state = 132},
  [6621] = {.lex_state = 1},
  [6622] = {.lex_state = 132},
  [6623] = {.lex_state = 132},
  [6624] = {.lex_state = 132},
  [6625] = {.lex_state = 1},
  [6626] = {.lex_state = 132},
  [6627] = {.lex_state = 1},
  [6628] = {.lex_state = 132},
  [6629] = {.lex_state = 132},
  [6630] = {.lex_state = 0},
  [6631] = {.lex_state = 132},
  [6632] = {.lex_state = 10},
  [6633] = {.lex_state = 132},
  [6634] = {.lex_state = 0},
  [6635] = {.lex_state = 1},
  [6636] = {.lex_state = 132},
  [6637] = {.lex_state = 1},
  [6638] = {.lex_state = 132},
  [6639] = {.lex_state = 1},
  [6640] = {.lex_state = 131},
  [6641] = {.lex_state = 0},
  [6642] = {.lex_state = 132},
  [6643] = {.lex_state = 132},
  [6644] = {.lex_state = 132},
  [6645] = {.lex_state = 132},
  [6646] = {.lex_state = 132},
  [6647] = {.lex_state = 132},
  [6648] = {.lex_state = 1},
  [6649] = {.lex_state = 132},
  [6650] = {.lex_state = 132},
  [6651] = {.lex_state = 132},
  [6652] = {.lex_state = 132},
  [6653] = {.lex_state = 132},
  [6654] = {.lex_state = 132},
  [6655] = {.lex_state = 1},
  [6656] = {.lex_state = 132},
  [6657] = {.lex_state = 1},
  [6658] = {.lex_state = 131},
  [6659] = {.lex_state = 132},
  [6660] = {.lex_state = 132},
  [6661] = {.lex_state = 1},
  [6662] = {.lex_state = 1},
  [6663] = {.lex_state = 0},
  [6664] = {.lex_state = 132},
  [6665] = {.lex_state = 1},
  [6666] = {.lex_state = 132},
  [6667] = {.lex_state = 132},
  [6668] = {.lex_state = 132},
  [6669] = {.lex_state = 132},
  [6670] = {.lex_state = 1},
  [6671] = {.lex_state = 0},
  [6672] = {.lex_state = 1},
  [6673] = {.lex_state = 132},
  [6674] = {.lex_state = 1},
  [6675] = {.lex_state = 132},
  [6676] = {.lex_state = 1},
  [6677] = {.lex_state = 0},
  [6678] = {.lex_state = 132},
  [6679] = {.lex_state = 132},
  [6680] = {.lex_state = 132},
  [6681] = {.lex_state = 0},
  [6682] = {.lex_state = 132},
  [6683] = {.lex_state = 132},
  [6684] = {.lex_state = 132},
  [6685] = {.lex_state = 0},
  [6686] = {.lex_state = 132},
  [6687] = {.lex_state = 1},
  [6688] = {.lex_state = 132},
  [6689] = {.lex_state = 132},
  [6690] = {.lex_state = 132},
  [6691] = {.lex_state = 132},
  [6692] = {.lex_state = 132},
  [6693] = {.lex_state = 0},
  [6694] = {.lex_state = 132},
  [6695] = {.lex_state = 0},
  [6696] = {.lex_state = 10},
  [6697] = {.lex_state = 132},
  [6698] = {.lex_state = 10},
  [6699] = {.lex_state = 132},
  [6700] = {.lex_state = 0},
  [6701] = {.lex_state = 132},
  [6702] = {.lex_state = 0},
  [6703] = {.lex_state = 132},
  [6704] = {.lex_state = 132},
  [6705] = {.lex_state = 0},
  [6706] = {.lex_state = 132},
  [6707] = {.lex_state = 0},
  [6708] = {.lex_state = 131},
  [6709] = {.lex_state = 18, .external_lex_state = 5},
  [6710] = {.lex_state = 0},
  [6711] = {.lex_state = 132},
  [6712] = {.lex_state = 18, .external_lex_state = 5},
  [6713] = {.lex_state = 0},
  [6714] = {.lex_state = 0},
  [6715] = {.lex_state = 0},
  [6716] = {.lex_state = 132},
  [6717] = {.lex_state = 0},
  [6718] = {.lex_state = 0},
  [6719] = {.lex_state = 132},
  [6720] = {.lex_state = 132},
  [6721] = {.lex_state = 132},
  [6722] = {.lex_state = 10},
  [6723] = {.lex_state = 132},
  [6724] = {.lex_state = 132},
  [6725] = {.lex_state = 0},
  [6726] = {.lex_state = 10},
  [6727] = {.lex_state = 132},
  [6728] = {.lex_state = 0},
  [6729] = {.lex_state = 132},
  [6730] = {.lex_state = 0},
  [6731] = {.lex_state = 0},
  [6732] = {.lex_state = 132},
  [6733] = {.lex_state = 131},
  [6734] = {.lex_state = 132},
  [6735] = {.lex_state = 0},
  [6736] = {.lex_state = 0},
  [6737] = {.lex_state = 131},
  [6738] = {.lex_state = 18, .external_lex_state = 5},
  [6739] = {.lex_state = 132},
  [6740] = {.lex_state = 132},
  [6741] = {.lex_state = 0},
  [6742] = {.lex_state = 0},
  [6743] = {.lex_state = 10},
  [6744] = {.lex_state = 131},
  [6745] = {.lex_state = 0},
  [6746] = {.lex_state = 0},
  [6747] = {.lex_state = 0},
  [6748] = {.lex_state = 132},
  [6749] = {.lex_state = 132},
  [6750] = {.lex_state = 0},
  [6751] = {.lex_state = 0},
  [6752] = {.lex_state = 10},
  [6753] = {.lex_state = 0},
  [6754] = {.lex_state = 18, .external_lex_state = 5},
  [6755] = {.lex_state = 132},
  [6756] = {.lex_state = 10},
  [6757] = {.lex_state = 132},
  [6758] = {.lex_state = 0},
  [6759] = {.lex_state = 132},
  [6760] = {.lex_state = 10},
  [6761] = {.lex_state = 0},
  [6762] = {.lex_state = 132},
  [6763] = {.lex_state = 2},
  [6764] = {.lex_state = 132},
  [6765] = {.lex_state = 4},
  [6766] = {.lex_state = 132},
  [6767] = {.lex_state = 0},
  [6768] = {.lex_state = 132},
  [6769] = {.lex_state = 2},
  [6770] = {.lex_state = 2},
  [6771] = {.lex_state = 132},
  [6772] = {.lex_state = 0},
  [6773] = {.lex_state = 0},
  [6774] = {.lex_state = 132},
  [6775] = {.lex_state = 131},
  [6776] = {.lex_state = 0},
  [6777] = {.lex_state = 18, .external_lex_state = 5},
  [6778] = {.lex_state = 0},
  [6779] = {.lex_state = 132},
  [6780] = {.lex_state = 0},
  [6781] = {.lex_state = 10},
  [6782] = {.lex_state = 0},
  [6783] = {.lex_state = 132},
  [6784] = {.lex_state = 132},
  [6785] = {.lex_state = 0},
  [6786] = {.lex_state = 132},
  [6787] = {.lex_state = 132},
  [6788] = {.lex_state = 132},
  [6789] = {.lex_state = 132},
  [6790] = {.lex_state = 132},
  [6791] = {.lex_state = 132},
  [6792] = {.lex_state = 132},
  [6793] = {.lex_state = 0},
  [6794] = {.lex_state = 0},
  [6795] = {.lex_state = 0},
  [6796] = {.lex_state = 0},
  [6797] = {.lex_state = 0},
  [6798] = {.lex_state = 0},
  [6799] = {.lex_state = 0},
  [6800] = {.lex_state = 10},
  [6801] = {.lex_state = 10},
  [6802] = {.lex_state = 0},
  [6803] = {.lex_state = 0},
  [6804] = {.lex_state = 0},
  [6805] = {.lex_state = 0},
  [6806] = {.lex_state = 1},
  [6807] = {.lex_state = 0},
  [6808] = {.lex_state = 0},
  [6809] = {.lex_state = 0},
  [6810] = {.lex_state = 0},
  [6811] = {.lex_state = 10},
  [6812] = {.lex_state = 0},
  [6813] = {.lex_state = 0},
  [6814] = {.lex_state = 0},
  [6815] = {.lex_state = 0},
  [6816] = {.lex_state = 0},
  [6817] = {.lex_state = 0},
  [6818] = {.lex_state = 0},
  [6819] = {.lex_state = 0},
  [6820] = {.lex_state = 0},
  [6821] = {.lex_state = 0},
  [6822] = {.lex_state = 0},
  [6823] = {.lex_state = 0},
  [6824] = {.lex_state = 0},
  [6825] = {.lex_state = 0},
  [6826] = {.lex_state = 0},
  [6827] = {.lex_state = 0},
  [6828] = {.lex_state = 10},
  [6829] = {.lex_state = 10},
  [6830] = {.lex_state = 0},
  [6831] = {.lex_state = 1},
  [6832] = {.lex_state = 0},
  [6833] = {.lex_state = 0},
  [6834] = {.lex_state = 132},
  [6835] = {.lex_state = 10},
  [6836] = {.lex_state = 10},
  [6837] = {.lex_state = 10},
  [6838] = {.lex_state = 0},
  [6839] = {.lex_state = 0},
  [6840] = {.lex_state = 0},
  [6841] = {.lex_state = 0},
  [6842] = {.lex_state = 0},
  [6843] = {.lex_state = 10},
  [6844] = {.lex_state = 0},
  [6845] = {.lex_state = 10},
  [6846] = {.lex_state = 0},
  [6847] = {.lex_state = 0},
  [6848] = {.lex_state = 0},
  [6849] = {.lex_state = 10},
  [6850] = {.lex_state = 132},
  [6851] = {.lex_state = 132},
  [6852] = {.lex_state = 0},
  [6853] = {.lex_state = 0},
  [6854] = {.lex_state = 0},
  [6855] = {.lex_state = 0},
  [6856] = {.lex_state = 0},
  [6857] = {.lex_state = 0},
  [6858] = {.lex_state = 0},
  [6859] = {.lex_state = 0},
  [6860] = {.lex_state = 0},
  [6861] = {.lex_state = 0},
  [6862] = {.lex_state = 0},
  [6863] = {.lex_state = 0},
  [6864] = {.lex_state = 0},
  [6865] = {.lex_state = 10},
  [6866] = {.lex_state = 0},
  [6867] = {.lex_state = 10},
  [6868] = {.lex_state = 0},
  [6869] = {.lex_state = 0},
  [6870] = {.lex_state = 0},
  [6871] = {.lex_state = 0},
  [6872] = {.lex_state = 0},
  [6873] = {.lex_state = 0},
  [6874] = {.lex_state = 10},
  [6875] = {.lex_state = 0},
  [6876] = {.lex_state = 0},
  [6877] = {.lex_state = 10},
  [6878] = {.lex_state = 0},
  [6879] = {.lex_state = 0},
  [6880] = {.lex_state = 0},
  [6881] = {.lex_state = 0},
  [6882] = {.lex_state = 0},
  [6883] = {.lex_state = 0},
  [6884] = {.lex_state = 0},
  [6885] = {.lex_state = 0},
  [6886] = {.lex_state = 0},
  [6887] = {.lex_state = 0},
  [6888] = {.lex_state = 0},
  [6889] = {.lex_state = 0},
  [6890] = {.lex_state = 0},
  [6891] = {.lex_state = 0},
  [6892] = {.lex_state = 132},
  [6893] = {.lex_state = 0},
  [6894] = {.lex_state = 0},
  [6895] = {.lex_state = 0},
  [6896] = {.lex_state = 0},
  [6897] = {.lex_state = 0},
  [6898] = {.lex_state = 0},
  [6899] = {.lex_state = 10},
  [6900] = {.lex_state = 10},
  [6901] = {.lex_state = 10},
  [6902] = {.lex_state = 0},
  [6903] = {.lex_state = 0},
  [6904] = {.lex_state = 0},
  [6905] = {.lex_state = 0},
  [6906] = {.lex_state = 0},
  [6907] = {.lex_state = 0},
  [6908] = {.lex_state = 0},
  [6909] = {.lex_state = 0},
  [6910] = {.lex_state = 0},
  [6911] = {.lex_state = 0},
  [6912] = {.lex_state = 0},
  [6913] = {.lex_state = 0},
  [6914] = {.lex_state = 10},
  [6915] = {.lex_state = 10},
  [6916] = {.lex_state = 0},
  [6917] = {.lex_state = 10},
  [6918] = {.lex_state = 0},
  [6919] = {.lex_state = 0},
  [6920] = {.lex_state = 0},
  [6921] = {.lex_state = 0},
  [6922] = {.lex_state = 0},
  [6923] = {.lex_state = 0},
  [6924] = {.lex_state = 10},
  [6925] = {.lex_state = 132},
  [6926] = {.lex_state = 0},
  [6927] = {.lex_state = 0},
  [6928] = {.lex_state = 0},
  [6929] = {.lex_state = 0},
  [6930] = {.lex_state = 0},
  [6931] = {.lex_state = 0},
  [6932] = {.lex_state = 0},
  [6933] = {.lex_state = 0},
  [6934] = {.lex_state = 0},
  [6935] = {.lex_state = 0},
  [6936] = {.lex_state = 132},
  [6937] = {.lex_state = 0},
  [6938] = {.lex_state = 0},
  [6939] = {.lex_state = 0},
  [6940] = {.lex_state = 0},
  [6941] = {.lex_state = 0},
  [6942] = {.lex_state = 0},
  [6943] = {.lex_state = 0},
  [6944] = {.lex_state = 10},
  [6945] = {.lex_state = 0},
  [6946] = {.lex_state = 0},
  [6947] = {.lex_state = 0},
  [6948] = {.lex_state = 10},
  [6949] = {.lex_state = 10},
  [6950] = {.lex_state = 10},
  [6951] = {.lex_state = 10},
  [6952] = {.lex_state = 0},
  [6953] = {.lex_state = 0},
  [6954] = {.lex_state = 0},
  [6955] = {.lex_state = 0},
  [6956] = {.lex_state = 10},
  [6957] = {.lex_state = 0},
  [6958] = {.lex_state = 0},
  [6959] = {.lex_state = 0},
  [6960] = {.lex_state = 0},
  [6961] = {.lex_state = 0},
  [6962] = {.lex_state = 0},
  [6963] = {.lex_state = 0},
  [6964] = {.lex_state = 0},
  [6965] = {.lex_state = 0},
  [6966] = {.lex_state = 0},
  [6967] = {.lex_state = 0},
  [6968] = {.lex_state = 0},
  [6969] = {.lex_state = 0},
  [6970] = {.lex_state = 0},
  [6971] = {.lex_state = 0},
  [6972] = {.lex_state = 0},
  [6973] = {.lex_state = 0},
  [6974] = {.lex_state = 0},
  [6975] = {.lex_state = 0},
  [6976] = {.lex_state = 0},
  [6977] = {.lex_state = 0},
  [6978] = {.lex_state = 0},
  [6979] = {.lex_state = 10},
  [6980] = {.lex_state = 10},
  [6981] = {.lex_state = 0},
  [6982] = {.lex_state = 0},
  [6983] = {.lex_state = 0},
  [6984] = {.lex_state = 10},
  [6985] = {.lex_state = 0},
  [6986] = {.lex_state = 0},
  [6987] = {.lex_state = 0},
  [6988] = {.lex_state = 0},
  [6989] = {.lex_state = 0},
  [6990] = {.lex_state = 4},
  [6991] = {.lex_state = 0},
  [6992] = {.lex_state = 0},
  [6993] = {.lex_state = 0},
  [6994] = {.lex_state = 0},
  [6995] = {.lex_state = 0},
  [6996] = {.lex_state = 0},
  [6997] = {.lex_state = 0},
  [6998] = {.lex_state = 0},
  [6999] = {.lex_state = 0},
  [7000] = {.lex_state = 0},
  [7001] = {.lex_state = 0},
  [7002] = {.lex_state = 0},
  [7003] = {.lex_state = 0},
  [7004] = {.lex_state = 10},
  [7005] = {.lex_state = 10},
  [7006] = {.lex_state = 0},
  [7007] = {.lex_state = 10},
  [7008] = {.lex_state = 132},
  [7009] = {.lex_state = 0},
  [7010] = {.lex_state = 0},
  [7011] = {.lex_state = 0},
  [7012] = {.lex_state = 0},
  [7013] = {.lex_state = 0},
  [7014] = {.lex_state = 10},
  [7015] = {.lex_state = 10},
  [7016] = {.lex_state = 1},
  [7017] = {.lex_state = 10},
  [7018] = {.lex_state = 10},
  [7019] = {.lex_state = 10},
  [7020] = {.lex_state = 0},
  [7021] = {.lex_state = 0},
  [7022] = {.lex_state = 10},
  [7023] = {.lex_state = 10},
  [7024] = {.lex_state = 0},
  [7025] = {.lex_state = 0},
  [7026] = {.lex_state = 10},
  [7027] = {.lex_state = 10},
  [7028] = {.lex_state = 10},
  [7029] = {.lex_state = 0},
  [7030] = {.lex_state = 0},
  [7031] = {.lex_state = 0},
  [7032] = {.lex_state = 0},
  [7033] = {.lex_state = 0},
  [7034] = {.lex_state = 0},
  [7035] = {.lex_state = 0},
  [7036] = {.lex_state = 0},
  [7037] = {.lex_state = 0},
  [7038] = {.lex_state = 131, .external_lex_state = 4},
  [7039] = {.lex_state = 0},
  [7040] = {.lex_state = 0},
  [7041] = {.lex_state = 0},
  [7042] = {.lex_state = 0},
  [7043] = {.lex_state = 0},
  [7044] = {.lex_state = 0},
  [7045] = {.lex_state = 10},
  [7046] = {.lex_state = 0},
  [7047] = {.lex_state = 0, .external_lex_state = 5},
  [7048] = {.lex_state = 0},
  [7049] = {.lex_state = 10},
  [7050] = {.lex_state = 0},
  [7051] = {.lex_state = 0},
  [7052] = {.lex_state = 0},
  [7053] = {.lex_state = 0},
  [7054] = {.lex_state = 10},
  [7055] = {.lex_state = 0},
  [7056] = {.lex_state = 0},
  [7057] = {.lex_state = 0},
  [7058] = {.lex_state = 0},
  [7059] = {.lex_state = 0},
  [7060] = {.lex_state = 1},
  [7061] = {.lex_state = 0},
  [7062] = {.lex_state = 0},
  [7063] = {.lex_state = 0},
  [7064] = {.lex_state = 0},
  [7065] = {.lex_state = 0},
  [7066] = {.lex_state = 0},
  [7067] = {.lex_state = 0},
  [7068] = {.lex_state = 0},
  [7069] = {.lex_state = 0},
  [7070] = {.lex_state = 0},
  [7071] = {.lex_state = 0, .external_lex_state = 5},
  [7072] = {.lex_state = 0},
  [7073] = {.lex_state = 0},
  [7074] = {.lex_state = 0},
  [7075] = {.lex_state = 0},
  [7076] = {.lex_state = 0},
  [7077] = {.lex_state = 0, .external_lex_state = 5},
  [7078] = {.lex_state = 0},
  [7079] = {.lex_state = 0},
  [7080] = {.lex_state = 0},
  [7081] = {.lex_state = 132},
  [7082] = {.lex_state = 0},
  [7083] = {.lex_state = 132},
  [7084] = {.lex_state = 0},
  [7085] = {.lex_state = 0},
  [7086] = {.lex_state = 0},
  [7087] = {.lex_state = 0},
  [7088] = {.lex_state = 0},
  [7089] = {.lex_state = 1},
  [7090] = {.lex_state = 0},
  [7091] = {.lex_state = 0},
  [7092] = {.lex_state = 0},
  [7093] = {.lex_state = 0},
  [7094] = {.lex_state = 0},
  [7095] = {.lex_state = 0},
  [7096] = {.lex_state = 0},
  [7097] = {.lex_state = 0, .external_lex_state = 5},
  [7098] = {.lex_state = 0},
  [7099] = {.lex_state = 0},
  [7100] = {.lex_state = 0},
  [7101] = {.lex_state = 10},
  [7102] = {.lex_state = 0},
  [7103] = {.lex_state = 0},
  [7104] = {.lex_state = 0},
  [7105] = {.lex_state = 0},
  [7106] = {.lex_state = 0},
  [7107] = {.lex_state = 0},
  [7108] = {.lex_state = 132},
  [7109] = {.lex_state = 0},
  [7110] = {.lex_state = 132},
  [7111] = {.lex_state = 132},
  [7112] = {.lex_state = 0},
  [7113] = {.lex_state = 0},
  [7114] = {.lex_state = 0},
  [7115] = {.lex_state = 132},
  [7116] = {.lex_state = 0},
  [7117] = {.lex_state = 0},
  [7118] = {.lex_state = 0},
  [7119] = {.lex_state = 132},
  [7120] = {.lex_state = 0},
  [7121] = {.lex_state = 0},
  [7122] = {.lex_state = 10},
  [7123] = {.lex_state = 0},
  [7124] = {.lex_state = 0},
  [7125] = {.lex_state = 132},
  [7126] = {.lex_state = 0},
  [7127] = {.lex_state = 3},
  [7128] = {.lex_state = 0},
  [7129] = {.lex_state = 15},
  [7130] = {.lex_state = 132},
  [7131] = {.lex_state = 132},
  [7132] = {.lex_state = 0},
  [7133] = {.lex_state = 0},
  [7134] = {.lex_state = 0},
  [7135] = {.lex_state = 0},
  [7136] = {.lex_state = 0},
  [7137] = {.lex_state = 0},
  [7138] = {.lex_state = 132},
  [7139] = {.lex_state = 1},
  [7140] = {.lex_state = 132},
  [7141] = {.lex_state = 132},
  [7142] = {.lex_state = 0},
  [7143] = {.lex_state = 0},
  [7144] = {.lex_state = 0},
  [7145] = {.lex_state = 0},
  [7146] = {.lex_state = 0},
  [7147] = {.lex_state = 10},
  [7148] = {.lex_state = 132},
  [7149] = {.lex_state = 0},
  [7150] = {.lex_state = 0},
  [7151] = {.lex_state = 0},
  [7152] = {.lex_state = 0},
  [7153] = {.lex_state = 0},
  [7154] = {.lex_state = 0},
  [7155] = {.lex_state = 0},
  [7156] = {.lex_state = 0},
  [7157] = {.lex_state = 132},
  [7158] = {.lex_state = 0},
  [7159] = {.lex_state = 0},
  [7160] = {.lex_state = 0},
  [7161] = {.lex_state = 15},
  [7162] = {.lex_state = 0},
  [7163] = {.lex_state = 132},
  [7164] = {.lex_state = 0},
  [7165] = {.lex_state = 0},
  [7166] = {.lex_state = 132},
  [7167] = {.lex_state = 0},
  [7168] = {.lex_state = 0},
  [7169] = {.lex_state = 0},
  [7170] = {.lex_state = 0},
  [7171] = {.lex_state = 0},
  [7172] = {.lex_state = 0},
  [7173] = {.lex_state = 0},
  [7174] = {.lex_state = 0},
  [7175] = {.lex_state = 0},
  [7176] = {.lex_state = 0},
  [7177] = {.lex_state = 132},
  [7178] = {.lex_state = 0},
  [7179] = {.lex_state = 0},
  [7180] = {.lex_state = 10},
  [7181] = {.lex_state = 132},
  [7182] = {.lex_state = 0},
  [7183] = {.lex_state = 0},
  [7184] = {.lex_state = 0},
  [7185] = {.lex_state = 0},
  [7186] = {.lex_state = 132},
  [7187] = {.lex_state = 0},
  [7188] = {.lex_state = 0},
  [7189] = {.lex_state = 0},
  [7190] = {.lex_state = 0},
  [7191] = {.lex_state = 10},
  [7192] = {.lex_state = 0},
  [7193] = {.lex_state = 0},
  [7194] = {.lex_state = 132},
  [7195] = {.lex_state = 0},
  [7196] = {.lex_state = 0},
  [7197] = {.lex_state = 0},
  [7198] = {.lex_state = 0},
  [7199] = {.lex_state = 0},
  [7200] = {.lex_state = 132},
  [7201] = {.lex_state = 0},
  [7202] = {.lex_state = 0},
  [7203] = {.lex_state = 0},
  [7204] = {.lex_state = 132},
  [7205] = {.lex_state = 0},
  [7206] = {.lex_state = 0},
  [7207] = {.lex_state = 132},
  [7208] = {.lex_state = 0},
  [7209] = {.lex_state = 0},
  [7210] = {.lex_state = 0},
  [7211] = {.lex_state = 0},
  [7212] = {.lex_state = 0},
  [7213] = {.lex_state = 0},
  [7214] = {.lex_state = 0},
  [7215] = {.lex_state = 15},
  [7216] = {.lex_state = 0},
  [7217] = {.lex_state = 0},
  [7218] = {.lex_state = 0},
  [7219] = {.lex_state = 132},
  [7220] = {.lex_state = 0},
  [7221] = {.lex_state = 0},
  [7222] = {.lex_state = 132},
  [7223] = {.lex_state = 132},
  [7224] = {.lex_state = 0},
  [7225] = {.lex_state = 132},
  [7226] = {.lex_state = 10},
  [7227] = {.lex_state = 0},
  [7228] = {.lex_state = 132},
  [7229] = {.lex_state = 0},
  [7230] = {.lex_state = 0},
  [7231] = {.lex_state = 0},
  [7232] = {.lex_state = 0},
  [7233] = {.lex_state = 0},
  [7234] = {.lex_state = 0},
  [7235] = {.lex_state = 0},
  [7236] = {.lex_state = 0},
  [7237] = {.lex_state = 132},
  [7238] = {.lex_state = 132},
  [7239] = {.lex_state = 0},
  [7240] = {.lex_state = 0},
  [7241] = {.lex_state = 0},
  [7242] = {.lex_state = 132},
  [7243] = {.lex_state = 0},
  [7244] = {.lex_state = 0},
  [7245] = {.lex_state = 0},
  [7246] = {.lex_state = 0},
  [7247] = {.lex_state = 0},
  [7248] = {.lex_state = 132},
  [7249] = {.lex_state = 0},
  [7250] = {.lex_state = 10},
  [7251] = {.lex_state = 1},
  [7252] = {.lex_state = 0},
  [7253] = {.lex_state = 0},
  [7254] = {.lex_state = 0},
  [7255] = {.lex_state = 0},
  [7256] = {.lex_state = 0},
  [7257] = {.lex_state = 132},
  [7258] = {.lex_state = 132},
  [7259] = {.lex_state = 132},
  [7260] = {.lex_state = 132},
  [7261] = {.lex_state = 0},
  [7262] = {.lex_state = 0},
  [7263] = {.lex_state = 0},
  [7264] = {.lex_state = 132},
  [7265] = {.lex_state = 10},
  [7266] = {.lex_state = 0},
  [7267] = {.lex_state = 0},
  [7268] = {.lex_state = 0},
  [7269] = {.lex_state = 132},
  [7270] = {.lex_state = 132},
  [7271] = {.lex_state = 0},
  [7272] = {.lex_state = 0},
  [7273] = {.lex_state = 132},
  [7274] = {.lex_state = 0},
  [7275] = {.lex_state = 0},
  [7276] = {.lex_state = 0},
  [7277] = {.lex_state = 0},
  [7278] = {.lex_state = 0},
  [7279] = {.lex_state = 0},
  [7280] = {.lex_state = 0},
  [7281] = {.lex_state = 132},
  [7282] = {.lex_state = 0},
  [7283] = {.lex_state = 0},
  [7284] = {.lex_state = 0},
  [7285] = {.lex_state = 132},
  [7286] = {.lex_state = 0},
  [7287] = {.lex_state = 132},
  [7288] = {.lex_state = 132},
  [7289] = {.lex_state = 0},
  [7290] = {.lex_state = 0},
  [7291] = {.lex_state = 0},
  [7292] = {.lex_state = 132},
  [7293] = {.lex_state = 132},
  [7294] = {.lex_state = 0},
  [7295] = {.lex_state = 0},
  [7296] = {.lex_state = 0},
  [7297] = {.lex_state = 0},
  [7298] = {.lex_state = 132},
  [7299] = {.lex_state = 132},
  [7300] = {.lex_state = 0},
  [7301] = {.lex_state = 0},
  [7302] = {.lex_state = 0},
  [7303] = {.lex_state = 132},
  [7304] = {.lex_state = 132},
  [7305] = {.lex_state = 15},
  [7306] = {.lex_state = 15},
  [7307] = {.lex_state = 0},
  [7308] = {.lex_state = 0},
  [7309] = {.lex_state = 0},
  [7310] = {.lex_state = 1},
  [7311] = {.lex_state = 0},
  [7312] = {.lex_state = 0},
  [7313] = {.lex_state = 15},
  [7314] = {.lex_state = 0},
  [7315] = {.lex_state = 0},
  [7316] = {.lex_state = 0},
  [7317] = {.lex_state = 0},
  [7318] = {.lex_state = 132},
  [7319] = {.lex_state = 0},
  [7320] = {.lex_state = 0},
  [7321] = {.lex_state = 0},
  [7322] = {.lex_state = 132},
  [7323] = {.lex_state = 0},
  [7324] = {.lex_state = 0},
  [7325] = {.lex_state = 0},
  [7326] = {.lex_state = 0},
  [7327] = {.lex_state = 132},
  [7328] = {.lex_state = 3},
  [7329] = {.lex_state = 132},
  [7330] = {.lex_state = 132},
  [7331] = {.lex_state = 10},
  [7332] = {.lex_state = 132},
  [7333] = {.lex_state = 0},
  [7334] = {.lex_state = 0},
  [7335] = {.lex_state = 0},
  [7336] = {.lex_state = 10},
  [7337] = {.lex_state = 0},
  [7338] = {.lex_state = 132},
  [7339] = {.lex_state = 0},
  [7340] = {.lex_state = 0},
  [7341] = {.lex_state = 0},
  [7342] = {.lex_state = 0},
  [7343] = {.lex_state = 10},
  [7344] = {.lex_state = 132},
  [7345] = {.lex_state = 0},
  [7346] = {.lex_state = 131},
  [7347] = {.lex_state = 0},
  [7348] = {.lex_state = 132},
  [7349] = {.lex_state = 0},
  [7350] = {.lex_state = 131},
  [7351] = {.lex_state = 132},
  [7352] = {.lex_state = 0},
  [7353] = {.lex_state = 0},
  [7354] = {.lex_state = 0},
  [7355] = {.lex_state = 0, .external_lex_state = 6},
  [7356] = {.lex_state = 0},
  [7357] = {.lex_state = 0},
  [7358] = {.lex_state = 0},
  [7359] = {.lex_state = 10},
  [7360] = {.lex_state = 0},
  [7361] = {.lex_state = 0},
  [7362] = {.lex_state = 0, .external_lex_state = 6},
  [7363] = {.lex_state = 0},
  [7364] = {.lex_state = 1},
  [7365] = {.lex_state = 0},
  [7366] = {.lex_state = 0},
  [7367] = {.lex_state = 0},
  [7368] = {.lex_state = 0},
  [7369] = {.lex_state = 0},
  [7370] = {.lex_state = 0, .external_lex_state = 7},
  [7371] = {.lex_state = 1},
  [7372] = {.lex_state = 0},
  [7373] = {.lex_state = 0},
  [7374] = {.lex_state = 0},
  [7375] = {.lex_state = 0},
  [7376] = {.lex_state = 0},
  [7377] = {.lex_state = 0},
  [7378] = {.lex_state = 14},
  [7379] = {.lex_state = 0},
  [7380] = {.lex_state = 0},
  [7381] = {.lex_state = 10},
  [7382] = {.lex_state = 0},
  [7383] = {.lex_state = 0, .external_lex_state = 7},
  [7384] = {.lex_state = 0},
  [7385] = {.lex_state = 0},
  [7386] = {.lex_state = 0},
  [7387] = {.lex_state = 10},
  [7388] = {.lex_state = 0},
  [7389] = {.lex_state = 0},
  [7390] = {.lex_state = 0, .external_lex_state = 8},
  [7391] = {.lex_state = 0},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 0},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 0},
  [7396] = {.lex_state = 0},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 0},
  [7399] = {.lex_state = 0},
  [7400] = {.lex_state = 0},
  [7401] = {.lex_state = 0},
  [7402] = {.lex_state = 0},
  [7403] = {.lex_state = 0},
  [7404] = {.lex_state = 132},
  [7405] = {.lex_state = 0},
  [7406] = {.lex_state = 0},
  [7407] = {.lex_state = 0},
  [7408] = {.lex_state = 0},
  [7409] = {.lex_state = 0},
  [7410] = {.lex_state = 0},
  [7411] = {.lex_state = 10},
  [7412] = {.lex_state = 0},
  [7413] = {.lex_state = 0},
  [7414] = {.lex_state = 0, .external_lex_state = 6},
  [7415] = {.lex_state = 0, .external_lex_state = 6},
  [7416] = {.lex_state = 0},
  [7417] = {.lex_state = 0},
  [7418] = {.lex_state = 14},
  [7419] = {.lex_state = 0},
  [7420] = {.lex_state = 0, .external_lex_state = 8},
  [7421] = {.lex_state = 10},
  [7422] = {.lex_state = 0},
  [7423] = {.lex_state = 0},
  [7424] = {.lex_state = 0},
  [7425] = {.lex_state = 0},
  [7426] = {.lex_state = 10},
  [7427] = {.lex_state = 0},
  [7428] = {.lex_state = 0, .external_lex_state = 8},
  [7429] = {.lex_state = 0},
  [7430] = {.lex_state = 0},
  [7431] = {.lex_state = 0},
  [7432] = {.lex_state = 0},
  [7433] = {.lex_state = 0},
  [7434] = {.lex_state = 1},
  [7435] = {.lex_state = 0},
  [7436] = {.lex_state = 0},
  [7437] = {.lex_state = 0},
  [7438] = {.lex_state = 0},
  [7439] = {.lex_state = 0},
  [7440] = {.lex_state = 0},
  [7441] = {.lex_state = 0},
  [7442] = {.lex_state = 10},
  [7443] = {.lex_state = 131},
  [7444] = {.lex_state = 131},
  [7445] = {.lex_state = 0},
  [7446] = {.lex_state = 0},
  [7447] = {.lex_state = 0},
  [7448] = {.lex_state = 10},
  [7449] = {.lex_state = 0},
  [7450] = {.lex_state = 0},
  [7451] = {.lex_state = 0},
  [7452] = {.lex_state = 1},
  [7453] = {.lex_state = 0},
  [7454] = {.lex_state = 0},
  [7455] = {.lex_state = 0},
  [7456] = {.lex_state = 0},
  [7457] = {.lex_state = 1},
  [7458] = {.lex_state = 10},
  [7459] = {.lex_state = 0},
  [7460] = {.lex_state = 1},
  [7461] = {.lex_state = 0},
  [7462] = {.lex_state = 0},
  [7463] = {.lex_state = 132},
  [7464] = {.lex_state = 0, .external_lex_state = 6},
  [7465] = {.lex_state = 0},
  [7466] = {.lex_state = 1},
  [7467] = {.lex_state = 0, .external_lex_state = 8},
  [7468] = {.lex_state = 0},
  [7469] = {.lex_state = 0, .external_lex_state = 8},
  [7470] = {.lex_state = 0},
  [7471] = {.lex_state = 0, .external_lex_state = 8},
  [7472] = {.lex_state = 0},
  [7473] = {.lex_state = 1},
  [7474] = {.lex_state = 1},
  [7475] = {.lex_state = 0},
  [7476] = {.lex_state = 0},
  [7477] = {.lex_state = 0},
  [7478] = {.lex_state = 0},
  [7479] = {.lex_state = 0},
  [7480] = {.lex_state = 0, .external_lex_state = 7},
  [7481] = {.lex_state = 0},
  [7482] = {.lex_state = 0},
  [7483] = {.lex_state = 0},
  [7484] = {.lex_state = 0},
  [7485] = {.lex_state = 0},
  [7486] = {.lex_state = 0},
  [7487] = {.lex_state = 0},
  [7488] = {.lex_state = 0},
  [7489] = {.lex_state = 0},
  [7490] = {.lex_state = 0, .external_lex_state = 9},
  [7491] = {.lex_state = 0},
  [7492] = {.lex_state = 0},
  [7493] = {.lex_state = 0},
  [7494] = {.lex_state = 10},
  [7495] = {.lex_state = 10},
  [7496] = {.lex_state = 0, .external_lex_state = 8},
  [7497] = {.lex_state = 0},
  [7498] = {.lex_state = 0},
  [7499] = {.lex_state = 10},
  [7500] = {.lex_state = 0},
  [7501] = {.lex_state = 0},
  [7502] = {.lex_state = 0},
  [7503] = {.lex_state = 1},
  [7504] = {.lex_state = 0},
  [7505] = {.lex_state = 0},
  [7506] = {.lex_state = 0, .external_lex_state = 7},
  [7507] = {.lex_state = 0},
  [7508] = {.lex_state = 0},
  [7509] = {.lex_state = 0},
  [7510] = {.lex_state = 0, .external_lex_state = 6},
  [7511] = {.lex_state = 0},
  [7512] = {.lex_state = 0, .external_lex_state = 8},
  [7513] = {.lex_state = 10},
  [7514] = {.lex_state = 0},
  [7515] = {.lex_state = 0},
  [7516] = {.lex_state = 0},
  [7517] = {.lex_state = 10},
  [7518] = {.lex_state = 10},
  [7519] = {.lex_state = 0, .external_lex_state = 8},
  [7520] = {.lex_state = 4},
  [7521] = {.lex_state = 0, .external_lex_state = 8},
  [7522] = {.lex_state = 132},
  [7523] = {.lex_state = 16},
  [7524] = {.lex_state = 0, .external_lex_state = 8},
  [7525] = {.lex_state = 0},
  [7526] = {.lex_state = 0},
  [7527] = {.lex_state = 0},
  [7528] = {.lex_state = 0, .external_lex_state = 7},
  [7529] = {.lex_state = 0},
  [7530] = {.lex_state = 0},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 0},
  [7533] = {.lex_state = 0},
  [7534] = {.lex_state = 0},
  [7535] = {.lex_state = 0},
  [7536] = {.lex_state = 0},
  [7537] = {.lex_state = 0},
  [7538] = {.lex_state = 0},
  [7539] = {.lex_state = 0},
  [7540] = {.lex_state = 0},
  [7541] = {.lex_state = 0},
  [7542] = {.lex_state = 0},
  [7543] = {.lex_state = 0},
  [7544] = {.lex_state = 0, .external_lex_state = 4},
  [7545] = {.lex_state = 14},
  [7546] = {.lex_state = 0},
  [7547] = {.lex_state = 0},
  [7548] = {.lex_state = 0, .external_lex_state = 9},
  [7549] = {.lex_state = 0},
  [7550] = {.lex_state = 0},
  [7551] = {.lex_state = 0},
  [7552] = {.lex_state = 10},
  [7553] = {.lex_state = 0},
  [7554] = {.lex_state = 0},
  [7555] = {.lex_state = 0},
  [7556] = {.lex_state = 0},
  [7557] = {.lex_state = 0},
  [7558] = {.lex_state = 10},
  [7559] = {.lex_state = 0},
  [7560] = {.lex_state = 0},
  [7561] = {.lex_state = 0},
  [7562] = {.lex_state = 0},
  [7563] = {.lex_state = 0},
  [7564] = {.lex_state = 0},
  [7565] = {.lex_state = 0},
  [7566] = {.lex_state = 0},
  [7567] = {.lex_state = 0},
  [7568] = {.lex_state = 132},
  [7569] = {.lex_state = 0},
  [7570] = {.lex_state = 0},
  [7571] = {.lex_state = 0},
  [7572] = {.lex_state = 0},
  [7573] = {.lex_state = 0},
  [7574] = {.lex_state = 1},
  [7575] = {.lex_state = 10},
  [7576] = {.lex_state = 132},
  [7577] = {.lex_state = 0},
  [7578] = {.lex_state = 10},
  [7579] = {.lex_state = 0},
  [7580] = {.lex_state = 0},
  [7581] = {.lex_state = 0, .external_lex_state = 9},
  [7582] = {.lex_state = 10},
  [7583] = {.lex_state = 0},
  [7584] = {.lex_state = 0},
  [7585] = {.lex_state = 0},
  [7586] = {.lex_state = 0},
  [7587] = {.lex_state = 0},
  [7588] = {.lex_state = 0},
  [7589] = {.lex_state = 0},
  [7590] = {.lex_state = 0},
  [7591] = {.lex_state = 0},
  [7592] = {.lex_state = 0},
  [7593] = {.lex_state = 0},
  [7594] = {.lex_state = 10},
  [7595] = {.lex_state = 132},
  [7596] = {.lex_state = 0},
  [7597] = {.lex_state = 0},
  [7598] = {.lex_state = 0},
  [7599] = {.lex_state = 0},
  [7600] = {.lex_state = 0},
  [7601] = {.lex_state = 0},
  [7602] = {.lex_state = 0},
  [7603] = {.lex_state = 0},
  [7604] = {.lex_state = 0},
  [7605] = {.lex_state = 0},
  [7606] = {.lex_state = 0},
  [7607] = {.lex_state = 10},
  [7608] = {.lex_state = 4},
  [7609] = {.lex_state = 0},
  [7610] = {.lex_state = 0},
  [7611] = {.lex_state = 0},
  [7612] = {.lex_state = 132},
  [7613] = {.lex_state = 0},
  [7614] = {.lex_state = 0},
  [7615] = {.lex_state = 0},
  [7616] = {.lex_state = 0},
  [7617] = {.lex_state = 0, .external_lex_state = 8},
  [7618] = {.lex_state = 0},
  [7619] = {.lex_state = 0},
  [7620] = {.lex_state = 0},
  [7621] = {.lex_state = 0},
  [7622] = {.lex_state = 0},
  [7623] = {.lex_state = 0},
  [7624] = {.lex_state = 0},
  [7625] = {.lex_state = 0},
  [7626] = {.lex_state = 0},
  [7627] = {.lex_state = 0},
  [7628] = {.lex_state = 0},
  [7629] = {.lex_state = 0},
  [7630] = {.lex_state = 0},
  [7631] = {.lex_state = 0, .external_lex_state = 9},
  [7632] = {.lex_state = 10},
  [7633] = {.lex_state = 0},
  [7634] = {.lex_state = 0},
  [7635] = {.lex_state = 0},
  [7636] = {.lex_state = 0},
  [7637] = {.lex_state = 0},
  [7638] = {.lex_state = 0},
  [7639] = {.lex_state = 0, .external_lex_state = 8},
  [7640] = {.lex_state = 0},
  [7641] = {.lex_state = 0},
  [7642] = {.lex_state = 0},
  [7643] = {.lex_state = 0},
  [7644] = {.lex_state = 0, .external_lex_state = 6},
  [7645] = {.lex_state = 0},
  [7646] = {.lex_state = 0},
  [7647] = {.lex_state = 0},
  [7648] = {.lex_state = 0},
  [7649] = {.lex_state = 0},
  [7650] = {.lex_state = 0},
  [7651] = {.lex_state = 0},
  [7652] = {.lex_state = 0},
  [7653] = {.lex_state = 0},
  [7654] = {.lex_state = 1},
  [7655] = {.lex_state = 0},
  [7656] = {.lex_state = 0},
  [7657] = {.lex_state = 132},
  [7658] = {.lex_state = 0},
  [7659] = {.lex_state = 0},
  [7660] = {.lex_state = 0},
  [7661] = {.lex_state = 0},
  [7662] = {.lex_state = 132},
  [7663] = {.lex_state = 0},
  [7664] = {.lex_state = 0},
  [7665] = {.lex_state = 0, .external_lex_state = 6},
  [7666] = {.lex_state = 0},
  [7667] = {.lex_state = 0},
  [7668] = {.lex_state = 0},
  [7669] = {.lex_state = 0},
  [7670] = {.lex_state = 0},
  [7671] = {.lex_state = 0},
  [7672] = {.lex_state = 0},
  [7673] = {.lex_state = 0, .external_lex_state = 6},
  [7674] = {.lex_state = 0},
  [7675] = {.lex_state = 0},
  [7676] = {.lex_state = 0},
  [7677] = {.lex_state = 0},
  [7678] = {.lex_state = 0},
  [7679] = {.lex_state = 0, .external_lex_state = 6},
  [7680] = {.lex_state = 132},
  [7681] = {.lex_state = 0},
  [7682] = {.lex_state = 0},
  [7683] = {.lex_state = 0},
  [7684] = {.lex_state = 0},
  [7685] = {.lex_state = 0},
  [7686] = {.lex_state = 0},
  [7687] = {.lex_state = 0},
  [7688] = {.lex_state = 0},
  [7689] = {.lex_state = 0},
  [7690] = {.lex_state = 0, .external_lex_state = 8},
  [7691] = {.lex_state = 0},
  [7692] = {.lex_state = 131},
  [7693] = {.lex_state = 0},
  [7694] = {.lex_state = 0},
  [7695] = {.lex_state = 4},
  [7696] = {.lex_state = 0},
  [7697] = {.lex_state = 0},
  [7698] = {.lex_state = 0},
  [7699] = {.lex_state = 0},
  [7700] = {.lex_state = 0},
  [7701] = {.lex_state = 0},
  [7702] = {.lex_state = 0},
  [7703] = {.lex_state = 0},
  [7704] = {.lex_state = 0, .external_lex_state = 6},
  [7705] = {.lex_state = 0},
  [7706] = {.lex_state = 0},
  [7707] = {.lex_state = 0, .external_lex_state = 6},
  [7708] = {.lex_state = 0},
  [7709] = {.lex_state = 0},
  [7710] = {.lex_state = 0},
  [7711] = {.lex_state = 0},
  [7712] = {.lex_state = 0},
  [7713] = {.lex_state = 0},
  [7714] = {.lex_state = 0},
  [7715] = {.lex_state = 10},
  [7716] = {.lex_state = 0},
  [7717] = {.lex_state = 0},
  [7718] = {.lex_state = 0},
  [7719] = {.lex_state = 0},
  [7720] = {.lex_state = 0},
  [7721] = {.lex_state = 0},
  [7722] = {.lex_state = 10},
  [7723] = {.lex_state = 0},
  [7724] = {.lex_state = 0},
  [7725] = {.lex_state = 0},
  [7726] = {.lex_state = 0},
  [7727] = {.lex_state = 0},
  [7728] = {.lex_state = 132},
  [7729] = {.lex_state = 1},
  [7730] = {.lex_state = 0},
  [7731] = {.lex_state = 0},
  [7732] = {.lex_state = 0},
  [7733] = {.lex_state = 0},
  [7734] = {.lex_state = 0, .external_lex_state = 4},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 0},
  [7737] = {.lex_state = 0},
  [7738] = {.lex_state = 0},
  [7739] = {.lex_state = 0},
  [7740] = {.lex_state = 4},
  [7741] = {.lex_state = 0},
  [7742] = {.lex_state = 0},
  [7743] = {.lex_state = 0},
  [7744] = {.lex_state = 0, .external_lex_state = 9},
  [7745] = {.lex_state = 14},
  [7746] = {.lex_state = 0},
  [7747] = {.lex_state = 0},
  [7748] = {.lex_state = 0},
  [7749] = {.lex_state = 0},
  [7750] = {.lex_state = 0},
  [7751] = {.lex_state = 0, .external_lex_state = 6},
  [7752] = {.lex_state = 132},
  [7753] = {.lex_state = 0, .external_lex_state = 4},
  [7754] = {.lex_state = 0, .external_lex_state = 6},
  [7755] = {.lex_state = 0},
  [7756] = {.lex_state = 0},
  [7757] = {.lex_state = 0},
  [7758] = {.lex_state = 0},
  [7759] = {.lex_state = 0, .external_lex_state = 6},
  [7760] = {.lex_state = 0},
  [7761] = {.lex_state = 0},
  [7762] = {.lex_state = 0},
  [7763] = {.lex_state = 0},
  [7764] = {.lex_state = 0},
  [7765] = {.lex_state = 0},
  [7766] = {.lex_state = 132},
  [7767] = {.lex_state = 0},
  [7768] = {.lex_state = 132},
  [7769] = {.lex_state = 0},
  [7770] = {.lex_state = 0},
  [7771] = {.lex_state = 0},
  [7772] = {.lex_state = 0},
  [7773] = {.lex_state = 132},
  [7774] = {.lex_state = 0},
  [7775] = {.lex_state = 0},
  [7776] = {.lex_state = 0},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 0},
  [7779] = {.lex_state = 0},
  [7780] = {.lex_state = 132},
  [7781] = {.lex_state = 0},
  [7782] = {.lex_state = 132},
  [7783] = {.lex_state = 132},
  [7784] = {.lex_state = 0, .external_lex_state = 8},
  [7785] = {.lex_state = 0},
  [7786] = {.lex_state = 132},
  [7787] = {.lex_state = 0},
  [7788] = {.lex_state = 131},
  [7789] = {.lex_state = 1},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 132},
  [7792] = {.lex_state = 0},
  [7793] = {.lex_state = 132},
  [7794] = {.lex_state = 0},
  [7795] = {.lex_state = 0},
  [7796] = {.lex_state = 0},
  [7797] = {.lex_state = 0},
  [7798] = {.lex_state = 0},
  [7799] = {.lex_state = 0},
  [7800] = {(TSStateId)(-1)},
  [7801] = {(TSStateId)(-1)},
  [7802] = {(TSStateId)(-1)},
  [7803] = {(TSStateId)(-1)},
  [7804] = {(TSStateId)(-1)},
  [7805] = {(TSStateId)(-1)},
  [7806] = {(TSStateId)(-1)},
  [7807] = {(TSStateId)(-1)},
  [7808] = {(TSStateId)(-1)},
  [7809] = {(TSStateId)(-1)},
  [7810] = {(TSStateId)(-1)},
  [7811] = {(TSStateId)(-1)},
  [7812] = {(TSStateId)(-1)},
  [7813] = {(TSStateId)(-1)},
  [7814] = {(TSStateId)(-1)},
  [7815] = {(TSStateId)(-1)},
  [7816] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_preproc_region] = STATE(0),
    [sym_preproc_endregion] = STATE(0),
    [sym_preproc_line] = STATE(0),
    [sym_preproc_pragma] = STATE(0),
    [sym_preproc_nullable] = STATE(0),
    [sym_preproc_error] = STATE(0),
    [sym_preproc_warning] = STATE(0),
    [sym_preproc_define] = STATE(0),
    [sym_preproc_undef] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier_token] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_method] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typevar] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_file] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_partial] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_notnull] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_checked] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_implicit] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_init] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_scoped] = ACTIONS(1),
    [anon_sym_params] = ACTIONS(1),
    [anon_sym_base] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_managed] = ACTIONS(1),
    [anon_sym_Cdecl] = ACTIONS(1),
    [anon_sym_Stdcall] = ACTIONS(1),
    [anon_sym_Thiscall] = ACTIONS(1),
    [anon_sym_Fastcall] = ACTIONS(1),
    [sym_predefined_type] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_unchecked] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [sym_discard] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_into] = ACTIONS(1),
    [anon_sym_join] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_equals] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_orderby] = ACTIONS(1),
    [anon_sym_ascending] = ACTIONS(1),
    [anon_sym_descending] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_stackalloc] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym___makeref] = ACTIONS(1),
    [anon_sym___reftype] = ACTIONS(1),
    [anon_sym___refvalue] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [sym_real_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_string_literal_content_token2] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_string_literal_encoding] = ACTIONS(1),
    [sym_verbatim_string_literal] = ACTIONS(1),
    [aux_sym_raw_string_literal_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token3] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [anon_sym_hidden] = ACTIONS(1),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [anon_sym_warning] = ACTIONS(1),
    [anon_sym_disable] = ACTIONS(1),
    [anon_sym_restore] = ACTIONS(1),
    [anon_sym_checksum] = ACTIONS(1),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [anon_sym_enable] = ACTIONS(1),
    [anon_sym_annotations] = ACTIONS(1),
    [anon_sym_warnings] = ACTIONS(1),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_shebang_directive] = ACTIONS(1),
    [sym_comment] = ACTIONS(21),
    [sym__optional_semi] = ACTIONS(1),
    [sym_interpolation_regular_start] = ACTIONS(1),
    [sym_interpolation_verbatim_start] = ACTIONS(1),
    [sym_interpolation_raw_start] = ACTIONS(1),
    [sym_interpolation_start_quote] = ACTIONS(1),
    [sym_interpolation_end_quote] = ACTIONS(1),
    [sym_interpolation_open_brace] = ACTIONS(1),
    [sym_interpolation_close_brace] = ACTIONS(1),
    [sym_interpolation_string_content] = ACTIONS(1),
    [sym_raw_string_start] = ACTIONS(1),
    [sym_raw_string_end] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_compilation_unit] = STATE(7696),
    [sym__top_level_item] = STATE(2075),
    [sym_global_statement] = STATE(2093),
    [sym_extern_alias_directive] = STATE(2093),
    [sym_using_directive] = STATE(2093),
    [sym_global_attribute] = STATE(2093),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2093),
    [sym_file_scoped_namespace_declaration] = STATE(2093),
    [sym_type_declaration] = STATE(2093),
    [sym_class_declaration] = STATE(2074),
    [sym__class_declaration_initializer] = STATE(6700),
    [sym_struct_declaration] = STATE(2074),
    [sym__struct_declaration_initializer] = STATE(6707),
    [sym_enum_declaration] = STATE(2074),
    [sym__enum_declaration_initializer] = STATE(6879),
    [sym_interface_declaration] = STATE(2074),
    [sym__interface_declaration_initializer] = STATE(6745),
    [sym_delegate_declaration] = STATE(2074),
    [sym__delegate_declaration_initializer] = STATE(6757),
    [sym_record_declaration] = STATE(2074),
    [sym__record_declaration_initializer] = STATE(6705),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2078),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2080),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1),
    [sym_preproc_endregion] = STATE(1),
    [sym_preproc_line] = STATE(1),
    [sym_preproc_pragma] = STATE(1),
    [sym_preproc_nullable] = STATE(1),
    [sym_preproc_error] = STATE(1),
    [sym_preproc_warning] = STATE(1),
    [sym_preproc_define] = STATE(1),
    [sym_preproc_undef] = STATE(1),
    [aux_sym_compilation_unit_repeat1] = STATE(16),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2371),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [ts_builtin_sym_end] = ACTIONS(23),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym_using] = ACTIONS(35),
    [anon_sym_unsafe] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_namespace] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(69),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(147),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_shebang_directive] = ACTIONS(149),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [2] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2960),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7529),
    [sym_preproc_elif_in_top_level] = STATE(7529),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7531),
    [sym_preproc_elif_in_attribute_list] = STATE(7531),
    [sym_preproc_region] = STATE(2),
    [sym_preproc_endregion] = STATE(2),
    [sym_preproc_line] = STATE(2),
    [sym_preproc_pragma] = STATE(2),
    [sym_preproc_nullable] = STATE(2),
    [sym_preproc_error] = STATE(2),
    [sym_preproc_warning] = STATE(2),
    [sym_preproc_define] = STATE(2),
    [sym_preproc_undef] = STATE(2),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(12),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(209),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [3] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2892),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4457),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7762),
    [sym_preproc_elif_in_top_level] = STATE(7762),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7767),
    [sym_preproc_elif_in_expression] = STATE(7767),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7770),
    [sym_preproc_elif_in_attribute_list] = STATE(7770),
    [sym_preproc_region] = STATE(3),
    [sym_preproc_endregion] = STATE(3),
    [sym_preproc_line] = STATE(3),
    [sym_preproc_pragma] = STATE(3),
    [sym_preproc_nullable] = STATE(3),
    [sym_preproc_error] = STATE(3),
    [sym_preproc_warning] = STATE(3),
    [sym_preproc_define] = STATE(3),
    [sym_preproc_undef] = STATE(3),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(9),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(215),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [4] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2888),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7476),
    [sym_preproc_elif_in_top_level] = STATE(7476),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7493),
    [sym_preproc_elif_in_attribute_list] = STATE(7493),
    [sym_preproc_region] = STATE(4),
    [sym_preproc_endregion] = STATE(4),
    [sym_preproc_line] = STATE(4),
    [sym_preproc_pragma] = STATE(4),
    [sym_preproc_nullable] = STATE(4),
    [sym_preproc_error] = STATE(4),
    [sym_preproc_warning] = STATE(4),
    [sym_preproc_define] = STATE(4),
    [sym_preproc_undef] = STATE(4),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(11),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(217),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [5] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2888),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7666),
    [sym_preproc_elif_in_top_level] = STATE(7666),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7493),
    [sym_preproc_elif_in_attribute_list] = STATE(7493),
    [sym_preproc_region] = STATE(5),
    [sym_preproc_endregion] = STATE(5),
    [sym_preproc_line] = STATE(5),
    [sym_preproc_pragma] = STATE(5),
    [sym_preproc_nullable] = STATE(5),
    [sym_preproc_error] = STATE(5),
    [sym_preproc_warning] = STATE(5),
    [sym_preproc_define] = STATE(5),
    [sym_preproc_undef] = STATE(5),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(14),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(219),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [6] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2960),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7642),
    [sym_preproc_elif_in_top_level] = STATE(7642),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7531),
    [sym_preproc_elif_in_attribute_list] = STATE(7531),
    [sym_preproc_region] = STATE(6),
    [sym_preproc_endregion] = STATE(6),
    [sym_preproc_line] = STATE(6),
    [sym_preproc_pragma] = STATE(6),
    [sym_preproc_nullable] = STATE(6),
    [sym_preproc_error] = STATE(6),
    [sym_preproc_warning] = STATE(6),
    [sym_preproc_define] = STATE(6),
    [sym_preproc_undef] = STATE(6),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(10),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(221),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [7] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2960),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7666),
    [sym_preproc_elif_in_top_level] = STATE(7666),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7531),
    [sym_preproc_elif_in_attribute_list] = STATE(7531),
    [sym_preproc_region] = STATE(7),
    [sym_preproc_endregion] = STATE(7),
    [sym_preproc_line] = STATE(7),
    [sym_preproc_pragma] = STATE(7),
    [sym_preproc_nullable] = STATE(7),
    [sym_preproc_error] = STATE(7),
    [sym_preproc_warning] = STATE(7),
    [sym_preproc_define] = STATE(7),
    [sym_preproc_undef] = STATE(7),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(14),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(219),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [8] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2960),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7476),
    [sym_preproc_elif_in_top_level] = STATE(7476),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7531),
    [sym_preproc_elif_in_attribute_list] = STATE(7531),
    [sym_preproc_region] = STATE(8),
    [sym_preproc_endregion] = STATE(8),
    [sym_preproc_line] = STATE(8),
    [sym_preproc_pragma] = STATE(8),
    [sym_preproc_nullable] = STATE(8),
    [sym_preproc_error] = STATE(8),
    [sym_preproc_warning] = STATE(8),
    [sym_preproc_define] = STATE(8),
    [sym_preproc_undef] = STATE(8),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(11),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(217),
    [aux_sym_preproc_else_token1] = ACTIONS(211),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [9] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7660),
    [sym_preproc_elif_in_top_level] = STATE(7660),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(9),
    [sym_preproc_endregion] = STATE(9),
    [sym_preproc_line] = STATE(9),
    [sym_preproc_pragma] = STATE(9),
    [sym_preproc_nullable] = STATE(9),
    [sym_preproc_error] = STATE(9),
    [sym_preproc_warning] = STATE(9),
    [sym_preproc_define] = STATE(9),
    [sym_preproc_undef] = STATE(9),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(223),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [10] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7551),
    [sym_preproc_elif_in_top_level] = STATE(7551),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(10),
    [sym_preproc_endregion] = STATE(10),
    [sym_preproc_line] = STATE(10),
    [sym_preproc_pragma] = STATE(10),
    [sym_preproc_nullable] = STATE(10),
    [sym_preproc_error] = STATE(10),
    [sym_preproc_warning] = STATE(10),
    [sym_preproc_define] = STATE(10),
    [sym_preproc_undef] = STATE(10),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(229),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [11] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7508),
    [sym_preproc_elif_in_top_level] = STATE(7508),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(11),
    [sym_preproc_endregion] = STATE(11),
    [sym_preproc_line] = STATE(11),
    [sym_preproc_pragma] = STATE(11),
    [sym_preproc_nullable] = STATE(11),
    [sym_preproc_error] = STATE(11),
    [sym_preproc_warning] = STATE(11),
    [sym_preproc_define] = STATE(11),
    [sym_preproc_undef] = STATE(11),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(231),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [12] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7598),
    [sym_preproc_elif_in_top_level] = STATE(7598),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(12),
    [sym_preproc_endregion] = STATE(12),
    [sym_preproc_line] = STATE(12),
    [sym_preproc_pragma] = STATE(12),
    [sym_preproc_nullable] = STATE(12),
    [sym_preproc_error] = STATE(12),
    [sym_preproc_warning] = STATE(12),
    [sym_preproc_define] = STATE(12),
    [sym_preproc_undef] = STATE(12),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(233),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [13] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7762),
    [sym_preproc_elif_in_top_level] = STATE(7762),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(13),
    [sym_preproc_endregion] = STATE(13),
    [sym_preproc_line] = STATE(13),
    [sym_preproc_pragma] = STATE(13),
    [sym_preproc_nullable] = STATE(13),
    [sym_preproc_error] = STATE(13),
    [sym_preproc_warning] = STATE(13),
    [sym_preproc_define] = STATE(13),
    [sym_preproc_undef] = STATE(13),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(9),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(215),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [14] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_else_in_top_level] = STATE(7475),
    [sym_preproc_elif_in_top_level] = STATE(7475),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(14),
    [sym_preproc_endregion] = STATE(14),
    [sym_preproc_line] = STATE(14),
    [sym_preproc_pragma] = STATE(14),
    [sym_preproc_nullable] = STATE(14),
    [sym_preproc_error] = STATE(14),
    [sym_preproc_warning] = STATE(14),
    [sym_preproc_define] = STATE(14),
    [sym_preproc_undef] = STATE(14),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(235),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [15] = {
    [sym__top_level_item] = STATE(2075),
    [sym_global_statement] = STATE(2093),
    [sym_extern_alias_directive] = STATE(2093),
    [sym_using_directive] = STATE(2093),
    [sym_global_attribute] = STATE(2093),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2093),
    [sym_file_scoped_namespace_declaration] = STATE(2093),
    [sym_type_declaration] = STATE(2093),
    [sym_class_declaration] = STATE(2074),
    [sym__class_declaration_initializer] = STATE(6700),
    [sym_struct_declaration] = STATE(2074),
    [sym__struct_declaration_initializer] = STATE(6707),
    [sym_enum_declaration] = STATE(2074),
    [sym__enum_declaration_initializer] = STATE(6879),
    [sym_interface_declaration] = STATE(2074),
    [sym__interface_declaration_initializer] = STATE(6745),
    [sym_delegate_declaration] = STATE(2074),
    [sym__delegate_declaration_initializer] = STATE(6757),
    [sym_record_declaration] = STATE(2074),
    [sym__record_declaration_initializer] = STATE(6705),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2078),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2080),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(15),
    [sym_preproc_endregion] = STATE(15),
    [sym_preproc_line] = STATE(15),
    [sym_preproc_pragma] = STATE(15),
    [sym_preproc_nullable] = STATE(15),
    [sym_preproc_error] = STATE(15),
    [sym_preproc_warning] = STATE(15),
    [sym_preproc_define] = STATE(15),
    [sym_preproc_undef] = STATE(15),
    [aux_sym_compilation_unit_repeat1] = STATE(17),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2371),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym_using] = ACTIONS(35),
    [anon_sym_unsafe] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_namespace] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(69),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(147),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [16] = {
    [sym__top_level_item] = STATE(2075),
    [sym_global_statement] = STATE(2093),
    [sym_extern_alias_directive] = STATE(2093),
    [sym_using_directive] = STATE(2093),
    [sym_global_attribute] = STATE(2093),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2093),
    [sym_file_scoped_namespace_declaration] = STATE(2093),
    [sym_type_declaration] = STATE(2093),
    [sym_class_declaration] = STATE(2074),
    [sym__class_declaration_initializer] = STATE(6700),
    [sym_struct_declaration] = STATE(2074),
    [sym__struct_declaration_initializer] = STATE(6707),
    [sym_enum_declaration] = STATE(2074),
    [sym__enum_declaration_initializer] = STATE(6879),
    [sym_interface_declaration] = STATE(2074),
    [sym__interface_declaration_initializer] = STATE(6745),
    [sym_delegate_declaration] = STATE(2074),
    [sym__delegate_declaration_initializer] = STATE(6757),
    [sym_record_declaration] = STATE(2074),
    [sym__record_declaration_initializer] = STATE(6705),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2078),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2080),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(16),
    [sym_preproc_endregion] = STATE(16),
    [sym_preproc_line] = STATE(16),
    [sym_preproc_pragma] = STATE(16),
    [sym_preproc_nullable] = STATE(16),
    [sym_preproc_error] = STATE(16),
    [sym_preproc_warning] = STATE(16),
    [sym_preproc_define] = STATE(16),
    [sym_preproc_undef] = STATE(16),
    [aux_sym_compilation_unit_repeat1] = STATE(18),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2371),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym_using] = ACTIONS(35),
    [anon_sym_unsafe] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_namespace] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(69),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(147),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [17] = {
    [sym__top_level_item] = STATE(2075),
    [sym_global_statement] = STATE(2093),
    [sym_extern_alias_directive] = STATE(2093),
    [sym_using_directive] = STATE(2093),
    [sym_global_attribute] = STATE(2093),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2093),
    [sym_file_scoped_namespace_declaration] = STATE(2093),
    [sym_type_declaration] = STATE(2093),
    [sym_class_declaration] = STATE(2074),
    [sym__class_declaration_initializer] = STATE(6700),
    [sym_struct_declaration] = STATE(2074),
    [sym__struct_declaration_initializer] = STATE(6707),
    [sym_enum_declaration] = STATE(2074),
    [sym__enum_declaration_initializer] = STATE(6879),
    [sym_interface_declaration] = STATE(2074),
    [sym__interface_declaration_initializer] = STATE(6745),
    [sym_delegate_declaration] = STATE(2074),
    [sym__delegate_declaration_initializer] = STATE(6757),
    [sym_record_declaration] = STATE(2074),
    [sym__record_declaration_initializer] = STATE(6705),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2078),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2080),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(17),
    [sym_preproc_endregion] = STATE(17),
    [sym_preproc_line] = STATE(17),
    [sym_preproc_pragma] = STATE(17),
    [sym_preproc_nullable] = STATE(17),
    [sym_preproc_error] = STATE(17),
    [sym_preproc_warning] = STATE(17),
    [sym_preproc_define] = STATE(17),
    [sym_preproc_undef] = STATE(17),
    [aux_sym_compilation_unit_repeat1] = STATE(18),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2371),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [ts_builtin_sym_end] = ACTIONS(239),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(27),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym_using] = ACTIONS(35),
    [anon_sym_unsafe] = ACTIONS(37),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_namespace] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(69),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(147),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [18] = {
    [sym__top_level_item] = STATE(2075),
    [sym_global_statement] = STATE(2093),
    [sym_extern_alias_directive] = STATE(2093),
    [sym_using_directive] = STATE(2093),
    [sym_global_attribute] = STATE(2093),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2093),
    [sym_file_scoped_namespace_declaration] = STATE(2093),
    [sym_type_declaration] = STATE(2093),
    [sym_class_declaration] = STATE(2074),
    [sym__class_declaration_initializer] = STATE(6700),
    [sym_struct_declaration] = STATE(2074),
    [sym__struct_declaration_initializer] = STATE(6707),
    [sym_enum_declaration] = STATE(2074),
    [sym__enum_declaration_initializer] = STATE(6879),
    [sym_interface_declaration] = STATE(2074),
    [sym__interface_declaration_initializer] = STATE(6745),
    [sym_delegate_declaration] = STATE(2074),
    [sym__delegate_declaration_initializer] = STATE(6757),
    [sym_record_declaration] = STATE(2074),
    [sym__record_declaration_initializer] = STATE(6705),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2078),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2080),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(18),
    [sym_preproc_endregion] = STATE(18),
    [sym_preproc_line] = STATE(18),
    [sym_preproc_pragma] = STATE(18),
    [sym_preproc_nullable] = STATE(18),
    [sym_preproc_error] = STATE(18),
    [sym_preproc_warning] = STATE(18),
    [sym_preproc_define] = STATE(18),
    [sym_preproc_undef] = STATE(18),
    [aux_sym_compilation_unit_repeat1] = STATE(18),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2371),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [ts_builtin_sym_end] = ACTIONS(241),
    [sym__identifier_token] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(246),
    [anon_sym_alias] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_global] = ACTIONS(255),
    [anon_sym_using] = ACTIONS(258),
    [anon_sym_unsafe] = ACTIONS(261),
    [anon_sym_static] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(270),
    [anon_sym_return] = ACTIONS(273),
    [anon_sym_namespace] = ACTIONS(276),
    [anon_sym_class] = ACTIONS(279),
    [anon_sym_ref] = ACTIONS(282),
    [anon_sym_struct] = ACTIONS(285),
    [anon_sym_enum] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_interface] = ACTIONS(294),
    [anon_sym_delegate] = ACTIONS(297),
    [anon_sym_record] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(303),
    [anon_sym_async] = ACTIONS(264),
    [anon_sym_const] = ACTIONS(303),
    [anon_sym_file] = ACTIONS(306),
    [anon_sym_fixed] = ACTIONS(309),
    [anon_sym_internal] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(312),
    [anon_sym_override] = ACTIONS(303),
    [anon_sym_partial] = ACTIONS(303),
    [anon_sym_private] = ACTIONS(303),
    [anon_sym_protected] = ACTIONS(303),
    [anon_sym_public] = ACTIONS(303),
    [anon_sym_readonly] = ACTIONS(303),
    [anon_sym_required] = ACTIONS(303),
    [anon_sym_sealed] = ACTIONS(303),
    [anon_sym_virtual] = ACTIONS(303),
    [anon_sym_volatile] = ACTIONS(303),
    [anon_sym_where] = ACTIONS(249),
    [anon_sym_notnull] = ACTIONS(249),
    [anon_sym_unmanaged] = ACTIONS(249),
    [anon_sym_checked] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(318),
    [anon_sym_TILDE] = ACTIONS(318),
    [anon_sym_PLUS_PLUS] = ACTIONS(318),
    [anon_sym_DASH_DASH] = ACTIONS(318),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_STAR] = ACTIONS(327),
    [anon_sym_CARET] = ACTIONS(318),
    [anon_sym_AMP] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(330),
    [anon_sym_scoped] = ACTIONS(333),
    [anon_sym_base] = ACTIONS(336),
    [anon_sym_var] = ACTIONS(339),
    [sym_predefined_type] = ACTIONS(342),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_unchecked] = ACTIONS(315),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(351),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_for] = ACTIONS(357),
    [anon_sym_lock] = ACTIONS(360),
    [anon_sym_yield] = ACTIONS(363),
    [anon_sym_switch] = ACTIONS(366),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(375),
    [anon_sym_when] = ACTIONS(249),
    [anon_sym_await] = ACTIONS(378),
    [anon_sym_foreach] = ACTIONS(381),
    [anon_sym_goto] = ACTIONS(384),
    [anon_sym_if] = ACTIONS(387),
    [anon_sym_DOT_DOT] = ACTIONS(390),
    [anon_sym_from] = ACTIONS(393),
    [anon_sym_into] = ACTIONS(249),
    [anon_sym_join] = ACTIONS(249),
    [anon_sym_on] = ACTIONS(249),
    [anon_sym_equals] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_orderby] = ACTIONS(249),
    [anon_sym_ascending] = ACTIONS(249),
    [anon_sym_descending] = ACTIONS(249),
    [anon_sym_group] = ACTIONS(249),
    [anon_sym_by] = ACTIONS(249),
    [anon_sym_select] = ACTIONS(249),
    [anon_sym_stackalloc] = ACTIONS(396),
    [anon_sym_sizeof] = ACTIONS(399),
    [anon_sym_typeof] = ACTIONS(402),
    [anon_sym___makeref] = ACTIONS(405),
    [anon_sym___reftype] = ACTIONS(408),
    [anon_sym___refvalue] = ACTIONS(411),
    [sym_null_literal] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(417),
    [sym_integer_literal] = ACTIONS(414),
    [sym_real_literal] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_verbatim_string_literal] = ACTIONS(420),
    [aux_sym_preproc_if_token1] = ACTIONS(426),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(429),
    [sym_interpolation_verbatim_start] = ACTIONS(432),
    [sym_interpolation_raw_start] = ACTIONS(435),
    [sym_raw_string_start] = ACTIONS(438),
  },
  [19] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(19),
    [sym_preproc_endregion] = STATE(19),
    [sym_preproc_line] = STATE(19),
    [sym_preproc_pragma] = STATE(19),
    [sym_preproc_nullable] = STATE(19),
    [sym_preproc_error] = STATE(19),
    [sym_preproc_warning] = STATE(19),
    [sym_preproc_define] = STATE(19),
    [sym_preproc_undef] = STATE(19),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(441),
    [anon_sym_extern] = ACTIONS(444),
    [anon_sym_alias] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_global] = ACTIONS(453),
    [anon_sym_using] = ACTIONS(456),
    [anon_sym_unsafe] = ACTIONS(459),
    [anon_sym_static] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(474),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_ref] = ACTIONS(480),
    [anon_sym_struct] = ACTIONS(483),
    [anon_sym_enum] = ACTIONS(486),
    [anon_sym_LBRACE] = ACTIONS(489),
    [anon_sym_interface] = ACTIONS(492),
    [anon_sym_delegate] = ACTIONS(495),
    [anon_sym_record] = ACTIONS(498),
    [anon_sym_abstract] = ACTIONS(501),
    [anon_sym_async] = ACTIONS(462),
    [anon_sym_const] = ACTIONS(501),
    [anon_sym_file] = ACTIONS(504),
    [anon_sym_fixed] = ACTIONS(507),
    [anon_sym_internal] = ACTIONS(501),
    [anon_sym_new] = ACTIONS(510),
    [anon_sym_override] = ACTIONS(501),
    [anon_sym_partial] = ACTIONS(501),
    [anon_sym_private] = ACTIONS(501),
    [anon_sym_protected] = ACTIONS(501),
    [anon_sym_public] = ACTIONS(501),
    [anon_sym_readonly] = ACTIONS(501),
    [anon_sym_required] = ACTIONS(501),
    [anon_sym_sealed] = ACTIONS(501),
    [anon_sym_virtual] = ACTIONS(501),
    [anon_sym_volatile] = ACTIONS(501),
    [anon_sym_where] = ACTIONS(447),
    [anon_sym_notnull] = ACTIONS(447),
    [anon_sym_unmanaged] = ACTIONS(447),
    [anon_sym_checked] = ACTIONS(513),
    [anon_sym_BANG] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_true] = ACTIONS(519),
    [anon_sym_false] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_this] = ACTIONS(528),
    [anon_sym_scoped] = ACTIONS(531),
    [anon_sym_base] = ACTIONS(534),
    [anon_sym_var] = ACTIONS(537),
    [sym_predefined_type] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(543),
    [anon_sym_unchecked] = ACTIONS(513),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_do] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(555),
    [anon_sym_lock] = ACTIONS(558),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_throw] = ACTIONS(570),
    [anon_sym_try] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(447),
    [anon_sym_await] = ACTIONS(576),
    [anon_sym_foreach] = ACTIONS(579),
    [anon_sym_goto] = ACTIONS(582),
    [anon_sym_if] = ACTIONS(585),
    [anon_sym_DOT_DOT] = ACTIONS(588),
    [anon_sym_from] = ACTIONS(591),
    [anon_sym_into] = ACTIONS(447),
    [anon_sym_join] = ACTIONS(447),
    [anon_sym_on] = ACTIONS(447),
    [anon_sym_equals] = ACTIONS(447),
    [anon_sym_let] = ACTIONS(447),
    [anon_sym_orderby] = ACTIONS(447),
    [anon_sym_ascending] = ACTIONS(447),
    [anon_sym_descending] = ACTIONS(447),
    [anon_sym_group] = ACTIONS(447),
    [anon_sym_by] = ACTIONS(447),
    [anon_sym_select] = ACTIONS(447),
    [anon_sym_stackalloc] = ACTIONS(594),
    [anon_sym_sizeof] = ACTIONS(597),
    [anon_sym_typeof] = ACTIONS(600),
    [anon_sym___makeref] = ACTIONS(603),
    [anon_sym___reftype] = ACTIONS(606),
    [anon_sym___refvalue] = ACTIONS(609),
    [sym_null_literal] = ACTIONS(612),
    [anon_sym_SQUOTE] = ACTIONS(615),
    [sym_integer_literal] = ACTIONS(612),
    [sym_real_literal] = ACTIONS(618),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_verbatim_string_literal] = ACTIONS(618),
    [aux_sym_preproc_if_token1] = ACTIONS(624),
    [aux_sym_preproc_if_token3] = ACTIONS(627),
    [aux_sym_preproc_else_token1] = ACTIONS(627),
    [aux_sym_preproc_elif_token1] = ACTIONS(627),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(629),
    [sym_interpolation_verbatim_start] = ACTIONS(632),
    [sym_interpolation_raw_start] = ACTIONS(635),
    [sym_raw_string_start] = ACTIONS(638),
  },
  [20] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(20),
    [sym_preproc_endregion] = STATE(20),
    [sym_preproc_line] = STATE(20),
    [sym_preproc_pragma] = STATE(20),
    [sym_preproc_nullable] = STATE(20),
    [sym_preproc_error] = STATE(20),
    [sym_preproc_warning] = STATE(20),
    [sym_preproc_define] = STATE(20),
    [sym_preproc_undef] = STATE(20),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [21] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(2997),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5624),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(21),
    [sym_preproc_endregion] = STATE(21),
    [sym_preproc_line] = STATE(21),
    [sym_preproc_pragma] = STATE(21),
    [sym_preproc_nullable] = STATE(21),
    [sym_preproc_error] = STATE(21),
    [sym_preproc_warning] = STATE(21),
    [sym_preproc_define] = STATE(21),
    [sym_preproc_undef] = STATE(21),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(20),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [22] = {
    [sym_extern_alias_directive] = STATE(2017),
    [sym_using_directive] = STATE(2017),
    [sym_global_attribute] = STATE(2017),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2017),
    [sym_file_scoped_namespace_declaration] = STATE(2017),
    [sym_type_declaration] = STATE(2017),
    [sym_class_declaration] = STATE(1997),
    [sym__class_declaration_initializer] = STATE(6730),
    [sym_struct_declaration] = STATE(1997),
    [sym__struct_declaration_initializer] = STATE(6735),
    [sym_enum_declaration] = STATE(1997),
    [sym__enum_declaration_initializer] = STATE(6931),
    [sym_interface_declaration] = STATE(1997),
    [sym__interface_declaration_initializer] = STATE(6736),
    [sym_delegate_declaration] = STATE(1997),
    [sym__delegate_declaration_initializer] = STATE(6740),
    [sym_record_declaration] = STATE(1997),
    [sym__record_declaration_initializer] = STATE(6741),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2017),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2011),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(22),
    [sym_preproc_endregion] = STATE(22),
    [sym_preproc_line] = STATE(22),
    [sym_preproc_pragma] = STATE(22),
    [sym_preproc_nullable] = STATE(22),
    [sym_preproc_error] = STATE(22),
    [sym_preproc_warning] = STATE(22),
    [sym_preproc_define] = STATE(22),
    [sym_preproc_undef] = STATE(22),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2384),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(20),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(159),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(165),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(67),
    [anon_sym_fixed] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(71),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token3] = ACTIONS(643),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [23] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(23),
    [sym_preproc_endregion] = STATE(23),
    [sym_preproc_line] = STATE(23),
    [sym_preproc_pragma] = STATE(23),
    [sym_preproc_nullable] = STATE(23),
    [sym_preproc_error] = STATE(23),
    [sym_preproc_warning] = STATE(23),
    [sym_preproc_define] = STATE(23),
    [sym_preproc_undef] = STATE(23),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(691),
    [anon_sym_default] = ACTIONS(691),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [24] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(24),
    [sym_preproc_endregion] = STATE(24),
    [sym_preproc_line] = STATE(24),
    [sym_preproc_pragma] = STATE(24),
    [sym_preproc_nullable] = STATE(24),
    [sym_preproc_error] = STATE(24),
    [sym_preproc_warning] = STATE(24),
    [sym_preproc_define] = STATE(24),
    [sym_preproc_undef] = STATE(24),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(29),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(707),
    [anon_sym_default] = ACTIONS(707),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [25] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(25),
    [sym_preproc_endregion] = STATE(25),
    [sym_preproc_line] = STATE(25),
    [sym_preproc_pragma] = STATE(25),
    [sym_preproc_nullable] = STATE(25),
    [sym_preproc_error] = STATE(25),
    [sym_preproc_warning] = STATE(25),
    [sym_preproc_define] = STATE(25),
    [sym_preproc_undef] = STATE(25),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(44),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [26] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(26),
    [sym_preproc_endregion] = STATE(26),
    [sym_preproc_line] = STATE(26),
    [sym_preproc_pragma] = STATE(26),
    [sym_preproc_nullable] = STATE(26),
    [sym_preproc_error] = STATE(26),
    [sym_preproc_warning] = STATE(26),
    [sym_preproc_define] = STATE(26),
    [sym_preproc_undef] = STATE(26),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(46),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [27] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(27),
    [sym_preproc_endregion] = STATE(27),
    [sym_preproc_line] = STATE(27),
    [sym_preproc_pragma] = STATE(27),
    [sym_preproc_nullable] = STATE(27),
    [sym_preproc_error] = STATE(27),
    [sym_preproc_warning] = STATE(27),
    [sym_preproc_define] = STATE(27),
    [sym_preproc_undef] = STATE(27),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(46),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [28] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(28),
    [sym_preproc_endregion] = STATE(28),
    [sym_preproc_line] = STATE(28),
    [sym_preproc_pragma] = STATE(28),
    [sym_preproc_nullable] = STATE(28),
    [sym_preproc_error] = STATE(28),
    [sym_preproc_warning] = STATE(28),
    [sym_preproc_define] = STATE(28),
    [sym_preproc_undef] = STATE(28),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(37),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(735),
    [anon_sym_default] = ACTIONS(735),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [29] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(29),
    [sym_preproc_endregion] = STATE(29),
    [sym_preproc_line] = STATE(29),
    [sym_preproc_pragma] = STATE(29),
    [sym_preproc_nullable] = STATE(29),
    [sym_preproc_error] = STATE(29),
    [sym_preproc_warning] = STATE(29),
    [sym_preproc_define] = STATE(29),
    [sym_preproc_undef] = STATE(29),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(735),
    [anon_sym_default] = ACTIONS(735),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [30] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(30),
    [sym_preproc_endregion] = STATE(30),
    [sym_preproc_line] = STATE(30),
    [sym_preproc_pragma] = STATE(30),
    [sym_preproc_nullable] = STATE(30),
    [sym_preproc_error] = STATE(30),
    [sym_preproc_warning] = STATE(30),
    [sym_preproc_define] = STATE(30),
    [sym_preproc_undef] = STATE(30),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(48),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [31] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(31),
    [sym_preproc_endregion] = STATE(31),
    [sym_preproc_line] = STATE(31),
    [sym_preproc_pragma] = STATE(31),
    [sym_preproc_nullable] = STATE(31),
    [sym_preproc_error] = STATE(31),
    [sym_preproc_warning] = STATE(31),
    [sym_preproc_define] = STATE(31),
    [sym_preproc_undef] = STATE(31),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(739),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_alias] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_global] = ACTIONS(745),
    [anon_sym_using] = ACTIONS(751),
    [anon_sym_unsafe] = ACTIONS(754),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_LPAREN] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(766),
    [anon_sym_ref] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_RBRACE] = ACTIONS(775),
    [anon_sym_delegate] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(757),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_file] = ACTIONS(780),
    [anon_sym_fixed] = ACTIONS(783),
    [anon_sym_internal] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_override] = ACTIONS(742),
    [anon_sym_partial] = ACTIONS(742),
    [anon_sym_private] = ACTIONS(742),
    [anon_sym_protected] = ACTIONS(742),
    [anon_sym_public] = ACTIONS(742),
    [anon_sym_readonly] = ACTIONS(742),
    [anon_sym_required] = ACTIONS(742),
    [anon_sym_sealed] = ACTIONS(742),
    [anon_sym_virtual] = ACTIONS(742),
    [anon_sym_volatile] = ACTIONS(742),
    [anon_sym_where] = ACTIONS(745),
    [anon_sym_notnull] = ACTIONS(745),
    [anon_sym_unmanaged] = ACTIONS(745),
    [anon_sym_checked] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_true] = ACTIONS(795),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_this] = ACTIONS(804),
    [anon_sym_scoped] = ACTIONS(807),
    [anon_sym_base] = ACTIONS(810),
    [anon_sym_var] = ACTIONS(813),
    [sym_predefined_type] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(819),
    [anon_sym_unchecked] = ACTIONS(789),
    [anon_sym_continue] = ACTIONS(822),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_while] = ACTIONS(828),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_lock] = ACTIONS(834),
    [anon_sym_yield] = ACTIONS(837),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(843),
    [anon_sym_default] = ACTIONS(845),
    [anon_sym_throw] = ACTIONS(848),
    [anon_sym_try] = ACTIONS(851),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(854),
    [anon_sym_foreach] = ACTIONS(857),
    [anon_sym_goto] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_DOT_DOT] = ACTIONS(866),
    [anon_sym_from] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(745),
    [anon_sym_join] = ACTIONS(745),
    [anon_sym_on] = ACTIONS(745),
    [anon_sym_equals] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_orderby] = ACTIONS(745),
    [anon_sym_ascending] = ACTIONS(745),
    [anon_sym_descending] = ACTIONS(745),
    [anon_sym_group] = ACTIONS(745),
    [anon_sym_by] = ACTIONS(745),
    [anon_sym_select] = ACTIONS(745),
    [anon_sym_stackalloc] = ACTIONS(872),
    [anon_sym_sizeof] = ACTIONS(875),
    [anon_sym_typeof] = ACTIONS(878),
    [anon_sym___makeref] = ACTIONS(881),
    [anon_sym___reftype] = ACTIONS(884),
    [anon_sym___refvalue] = ACTIONS(887),
    [sym_null_literal] = ACTIONS(890),
    [anon_sym_SQUOTE] = ACTIONS(893),
    [sym_integer_literal] = ACTIONS(890),
    [sym_real_literal] = ACTIONS(896),
    [anon_sym_DQUOTE] = ACTIONS(899),
    [sym_verbatim_string_literal] = ACTIONS(896),
    [aux_sym_preproc_if_token1] = ACTIONS(902),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(905),
    [sym_interpolation_verbatim_start] = ACTIONS(908),
    [sym_interpolation_raw_start] = ACTIONS(911),
    [sym_raw_string_start] = ACTIONS(914),
  },
  [32] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(4934),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(32),
    [sym_preproc_endregion] = STATE(32),
    [sym_preproc_line] = STATE(32),
    [sym_preproc_pragma] = STATE(32),
    [sym_preproc_nullable] = STATE(32),
    [sym_preproc_error] = STATE(32),
    [sym_preproc_warning] = STATE(32),
    [sym_preproc_define] = STATE(32),
    [sym_preproc_undef] = STATE(32),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(52),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [33] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5071),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(33),
    [sym_preproc_endregion] = STATE(33),
    [sym_preproc_line] = STATE(33),
    [sym_preproc_pragma] = STATE(33),
    [sym_preproc_nullable] = STATE(33),
    [sym_preproc_error] = STATE(33),
    [sym_preproc_warning] = STATE(33),
    [sym_preproc_define] = STATE(33),
    [sym_preproc_undef] = STATE(33),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(54),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [34] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(4941),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(34),
    [sym_preproc_endregion] = STATE(34),
    [sym_preproc_line] = STATE(34),
    [sym_preproc_pragma] = STATE(34),
    [sym_preproc_nullable] = STATE(34),
    [sym_preproc_error] = STATE(34),
    [sym_preproc_warning] = STATE(34),
    [sym_preproc_define] = STATE(34),
    [sym_preproc_undef] = STATE(34),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(56),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [35] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(4891),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(35),
    [sym_preproc_endregion] = STATE(35),
    [sym_preproc_line] = STATE(35),
    [sym_preproc_pragma] = STATE(35),
    [sym_preproc_nullable] = STATE(35),
    [sym_preproc_error] = STATE(35),
    [sym_preproc_warning] = STATE(35),
    [sym_preproc_define] = STATE(35),
    [sym_preproc_undef] = STATE(35),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(58),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [36] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(4969),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(36),
    [sym_preproc_endregion] = STATE(36),
    [sym_preproc_line] = STATE(36),
    [sym_preproc_pragma] = STATE(36),
    [sym_preproc_nullable] = STATE(36),
    [sym_preproc_error] = STATE(36),
    [sym_preproc_warning] = STATE(36),
    [sym_preproc_define] = STATE(36),
    [sym_preproc_undef] = STATE(36),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(41),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(933),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [37] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(37),
    [sym_preproc_endregion] = STATE(37),
    [sym_preproc_line] = STATE(37),
    [sym_preproc_pragma] = STATE(37),
    [sym_preproc_nullable] = STATE(37),
    [sym_preproc_error] = STATE(37),
    [sym_preproc_warning] = STATE(37),
    [sym_preproc_define] = STATE(37),
    [sym_preproc_undef] = STATE(37),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(939),
    [anon_sym_default] = ACTIONS(939),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [38] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(38),
    [sym_preproc_endregion] = STATE(38),
    [sym_preproc_line] = STATE(38),
    [sym_preproc_pragma] = STATE(38),
    [sym_preproc_nullable] = STATE(38),
    [sym_preproc_error] = STATE(38),
    [sym_preproc_warning] = STATE(38),
    [sym_preproc_define] = STATE(38),
    [sym_preproc_undef] = STATE(38),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(23),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(939),
    [anon_sym_default] = ACTIONS(939),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [39] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(39),
    [sym_preproc_endregion] = STATE(39),
    [sym_preproc_line] = STATE(39),
    [sym_preproc_pragma] = STATE(39),
    [sym_preproc_nullable] = STATE(39),
    [sym_preproc_error] = STATE(39),
    [sym_preproc_warning] = STATE(39),
    [sym_preproc_define] = STATE(39),
    [sym_preproc_undef] = STATE(39),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(42),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(723),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(725),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [40] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(40),
    [sym_preproc_endregion] = STATE(40),
    [sym_preproc_line] = STATE(40),
    [sym_preproc_pragma] = STATE(40),
    [sym_preproc_nullable] = STATE(40),
    [sym_preproc_error] = STATE(40),
    [sym_preproc_warning] = STATE(40),
    [sym_preproc_define] = STATE(40),
    [sym_preproc_undef] = STATE(40),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(42),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [41] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(41),
    [sym_preproc_endregion] = STATE(41),
    [sym_preproc_line] = STATE(41),
    [sym_preproc_pragma] = STATE(41),
    [sym_preproc_nullable] = STATE(41),
    [sym_preproc_error] = STATE(41),
    [sym_preproc_warning] = STATE(41),
    [sym_preproc_define] = STATE(41),
    [sym_preproc_undef] = STATE(41),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [42] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(42),
    [sym_preproc_endregion] = STATE(42),
    [sym_preproc_line] = STATE(42),
    [sym_preproc_pragma] = STATE(42),
    [sym_preproc_nullable] = STATE(42),
    [sym_preproc_error] = STATE(42),
    [sym_preproc_warning] = STATE(42),
    [sym_preproc_define] = STATE(42),
    [sym_preproc_undef] = STATE(42),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [43] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(43),
    [sym_preproc_endregion] = STATE(43),
    [sym_preproc_line] = STATE(43),
    [sym_preproc_pragma] = STATE(43),
    [sym_preproc_nullable] = STATE(43),
    [sym_preproc_error] = STATE(43),
    [sym_preproc_warning] = STATE(43),
    [sym_preproc_define] = STATE(43),
    [sym_preproc_undef] = STATE(43),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(46),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [44] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(44),
    [sym_preproc_endregion] = STATE(44),
    [sym_preproc_line] = STATE(44),
    [sym_preproc_pragma] = STATE(44),
    [sym_preproc_nullable] = STATE(44),
    [sym_preproc_error] = STATE(44),
    [sym_preproc_warning] = STATE(44),
    [sym_preproc_define] = STATE(44),
    [sym_preproc_undef] = STATE(44),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [45] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(45),
    [sym_preproc_endregion] = STATE(45),
    [sym_preproc_line] = STATE(45),
    [sym_preproc_pragma] = STATE(45),
    [sym_preproc_nullable] = STATE(45),
    [sym_preproc_error] = STATE(45),
    [sym_preproc_warning] = STATE(45),
    [sym_preproc_define] = STATE(45),
    [sym_preproc_undef] = STATE(45),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(44),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [46] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(46),
    [sym_preproc_endregion] = STATE(46),
    [sym_preproc_line] = STATE(46),
    [sym_preproc_pragma] = STATE(46),
    [sym_preproc_nullable] = STATE(46),
    [sym_preproc_error] = STATE(46),
    [sym_preproc_warning] = STATE(46),
    [sym_preproc_define] = STATE(46),
    [sym_preproc_undef] = STATE(46),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [47] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(47),
    [sym_preproc_endregion] = STATE(47),
    [sym_preproc_line] = STATE(47),
    [sym_preproc_pragma] = STATE(47),
    [sym_preproc_nullable] = STATE(47),
    [sym_preproc_error] = STATE(47),
    [sym_preproc_warning] = STATE(47),
    [sym_preproc_define] = STATE(47),
    [sym_preproc_undef] = STATE(47),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(50),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [48] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(48),
    [sym_preproc_endregion] = STATE(48),
    [sym_preproc_line] = STATE(48),
    [sym_preproc_pragma] = STATE(48),
    [sym_preproc_nullable] = STATE(48),
    [sym_preproc_error] = STATE(48),
    [sym_preproc_warning] = STATE(48),
    [sym_preproc_define] = STATE(48),
    [sym_preproc_undef] = STATE(48),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [49] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(49),
    [sym_preproc_endregion] = STATE(49),
    [sym_preproc_line] = STATE(49),
    [sym_preproc_pragma] = STATE(49),
    [sym_preproc_nullable] = STATE(49),
    [sym_preproc_error] = STATE(49),
    [sym_preproc_warning] = STATE(49),
    [sym_preproc_define] = STATE(49),
    [sym_preproc_undef] = STATE(49),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(52),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [50] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(50),
    [sym_preproc_endregion] = STATE(50),
    [sym_preproc_line] = STATE(50),
    [sym_preproc_pragma] = STATE(50),
    [sym_preproc_nullable] = STATE(50),
    [sym_preproc_error] = STATE(50),
    [sym_preproc_warning] = STATE(50),
    [sym_preproc_define] = STATE(50),
    [sym_preproc_undef] = STATE(50),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [51] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(51),
    [sym_preproc_endregion] = STATE(51),
    [sym_preproc_line] = STATE(51),
    [sym_preproc_pragma] = STATE(51),
    [sym_preproc_nullable] = STATE(51),
    [sym_preproc_error] = STATE(51),
    [sym_preproc_warning] = STATE(51),
    [sym_preproc_define] = STATE(51),
    [sym_preproc_undef] = STATE(51),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(54),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [52] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(52),
    [sym_preproc_endregion] = STATE(52),
    [sym_preproc_line] = STATE(52),
    [sym_preproc_pragma] = STATE(52),
    [sym_preproc_nullable] = STATE(52),
    [sym_preproc_error] = STATE(52),
    [sym_preproc_warning] = STATE(52),
    [sym_preproc_define] = STATE(52),
    [sym_preproc_undef] = STATE(52),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [53] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(53),
    [sym_preproc_endregion] = STATE(53),
    [sym_preproc_line] = STATE(53),
    [sym_preproc_pragma] = STATE(53),
    [sym_preproc_nullable] = STATE(53),
    [sym_preproc_error] = STATE(53),
    [sym_preproc_warning] = STATE(53),
    [sym_preproc_define] = STATE(53),
    [sym_preproc_undef] = STATE(53),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(56),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [54] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(54),
    [sym_preproc_endregion] = STATE(54),
    [sym_preproc_line] = STATE(54),
    [sym_preproc_pragma] = STATE(54),
    [sym_preproc_nullable] = STATE(54),
    [sym_preproc_error] = STATE(54),
    [sym_preproc_warning] = STATE(54),
    [sym_preproc_define] = STATE(54),
    [sym_preproc_undef] = STATE(54),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [55] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(55),
    [sym_preproc_endregion] = STATE(55),
    [sym_preproc_line] = STATE(55),
    [sym_preproc_pragma] = STATE(55),
    [sym_preproc_nullable] = STATE(55),
    [sym_preproc_error] = STATE(55),
    [sym_preproc_warning] = STATE(55),
    [sym_preproc_define] = STATE(55),
    [sym_preproc_undef] = STATE(55),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(48),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [56] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(56),
    [sym_preproc_endregion] = STATE(56),
    [sym_preproc_line] = STATE(56),
    [sym_preproc_pragma] = STATE(56),
    [sym_preproc_nullable] = STATE(56),
    [sym_preproc_error] = STATE(56),
    [sym_preproc_warning] = STATE(56),
    [sym_preproc_define] = STATE(56),
    [sym_preproc_undef] = STATE(56),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [57] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(57),
    [sym_preproc_endregion] = STATE(57),
    [sym_preproc_line] = STATE(57),
    [sym_preproc_pragma] = STATE(57),
    [sym_preproc_nullable] = STATE(57),
    [sym_preproc_error] = STATE(57),
    [sym_preproc_warning] = STATE(57),
    [sym_preproc_define] = STATE(57),
    [sym_preproc_undef] = STATE(57),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(58),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [58] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(58),
    [sym_preproc_endregion] = STATE(58),
    [sym_preproc_line] = STATE(58),
    [sym_preproc_pragma] = STATE(58),
    [sym_preproc_nullable] = STATE(58),
    [sym_preproc_error] = STATE(58),
    [sym_preproc_warning] = STATE(58),
    [sym_preproc_define] = STATE(58),
    [sym_preproc_undef] = STATE(58),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [59] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(59),
    [sym_preproc_endregion] = STATE(59),
    [sym_preproc_line] = STATE(59),
    [sym_preproc_pragma] = STATE(59),
    [sym_preproc_nullable] = STATE(59),
    [sym_preproc_error] = STATE(59),
    [sym_preproc_warning] = STATE(59),
    [sym_preproc_define] = STATE(59),
    [sym_preproc_undef] = STATE(59),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(60),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [60] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(60),
    [sym_preproc_endregion] = STATE(60),
    [sym_preproc_line] = STATE(60),
    [sym_preproc_pragma] = STATE(60),
    [sym_preproc_nullable] = STATE(60),
    [sym_preproc_error] = STATE(60),
    [sym_preproc_warning] = STATE(60),
    [sym_preproc_define] = STATE(60),
    [sym_preproc_undef] = STATE(60),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(31),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [61] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2149),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(61),
    [sym_preproc_endregion] = STATE(61),
    [sym_preproc_line] = STATE(61),
    [sym_preproc_pragma] = STATE(61),
    [sym_preproc_nullable] = STATE(61),
    [sym_preproc_error] = STATE(61),
    [sym_preproc_warning] = STATE(61),
    [sym_preproc_define] = STATE(61),
    [sym_preproc_undef] = STATE(61),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym_block_repeat1] = STATE(41),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [62] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7138),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(62),
    [sym_preproc_endregion] = STATE(62),
    [sym_preproc_line] = STATE(62),
    [sym_preproc_pragma] = STATE(62),
    [sym_preproc_nullable] = STATE(62),
    [sym_preproc_error] = STATE(62),
    [sym_preproc_warning] = STATE(62),
    [sym_preproc_define] = STATE(62),
    [sym_preproc_undef] = STATE(62),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [63] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1990),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(63),
    [sym_preproc_endregion] = STATE(63),
    [sym_preproc_line] = STATE(63),
    [sym_preproc_pragma] = STATE(63),
    [sym_preproc_nullable] = STATE(63),
    [sym_preproc_error] = STATE(63),
    [sym_preproc_warning] = STATE(63),
    [sym_preproc_define] = STATE(63),
    [sym_preproc_undef] = STATE(63),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [64] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2025),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(64),
    [sym_preproc_endregion] = STATE(64),
    [sym_preproc_line] = STATE(64),
    [sym_preproc_pragma] = STATE(64),
    [sym_preproc_nullable] = STATE(64),
    [sym_preproc_error] = STATE(64),
    [sym_preproc_warning] = STATE(64),
    [sym_preproc_define] = STATE(64),
    [sym_preproc_undef] = STATE(64),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [65] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2144),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(65),
    [sym_preproc_endregion] = STATE(65),
    [sym_preproc_line] = STATE(65),
    [sym_preproc_pragma] = STATE(65),
    [sym_preproc_nullable] = STATE(65),
    [sym_preproc_error] = STATE(65),
    [sym_preproc_warning] = STATE(65),
    [sym_preproc_define] = STATE(65),
    [sym_preproc_undef] = STATE(65),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [66] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2102),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(66),
    [sym_preproc_endregion] = STATE(66),
    [sym_preproc_line] = STATE(66),
    [sym_preproc_pragma] = STATE(66),
    [sym_preproc_nullable] = STATE(66),
    [sym_preproc_error] = STATE(66),
    [sym_preproc_warning] = STATE(66),
    [sym_preproc_define] = STATE(66),
    [sym_preproc_undef] = STATE(66),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [67] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2131),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(67),
    [sym_preproc_endregion] = STATE(67),
    [sym_preproc_line] = STATE(67),
    [sym_preproc_pragma] = STATE(67),
    [sym_preproc_nullable] = STATE(67),
    [sym_preproc_error] = STATE(67),
    [sym_preproc_warning] = STATE(67),
    [sym_preproc_define] = STATE(67),
    [sym_preproc_undef] = STATE(67),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [68] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2026),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(68),
    [sym_preproc_endregion] = STATE(68),
    [sym_preproc_line] = STATE(68),
    [sym_preproc_pragma] = STATE(68),
    [sym_preproc_nullable] = STATE(68),
    [sym_preproc_error] = STATE(68),
    [sym_preproc_warning] = STATE(68),
    [sym_preproc_define] = STATE(68),
    [sym_preproc_undef] = STATE(68),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [69] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7270),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(69),
    [sym_preproc_endregion] = STATE(69),
    [sym_preproc_line] = STATE(69),
    [sym_preproc_pragma] = STATE(69),
    [sym_preproc_nullable] = STATE(69),
    [sym_preproc_error] = STATE(69),
    [sym_preproc_warning] = STATE(69),
    [sym_preproc_define] = STATE(69),
    [sym_preproc_undef] = STATE(69),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [70] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7242),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(70),
    [sym_preproc_endregion] = STATE(70),
    [sym_preproc_line] = STATE(70),
    [sym_preproc_pragma] = STATE(70),
    [sym_preproc_nullable] = STATE(70),
    [sym_preproc_error] = STATE(70),
    [sym_preproc_warning] = STATE(70),
    [sym_preproc_define] = STATE(70),
    [sym_preproc_undef] = STATE(70),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [71] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2028),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(71),
    [sym_preproc_endregion] = STATE(71),
    [sym_preproc_line] = STATE(71),
    [sym_preproc_pragma] = STATE(71),
    [sym_preproc_nullable] = STATE(71),
    [sym_preproc_error] = STATE(71),
    [sym_preproc_warning] = STATE(71),
    [sym_preproc_define] = STATE(71),
    [sym_preproc_undef] = STATE(71),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [72] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2038),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(72),
    [sym_preproc_endregion] = STATE(72),
    [sym_preproc_line] = STATE(72),
    [sym_preproc_pragma] = STATE(72),
    [sym_preproc_nullable] = STATE(72),
    [sym_preproc_error] = STATE(72),
    [sym_preproc_warning] = STATE(72),
    [sym_preproc_define] = STATE(72),
    [sym_preproc_undef] = STATE(72),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [73] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2061),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(73),
    [sym_preproc_endregion] = STATE(73),
    [sym_preproc_line] = STATE(73),
    [sym_preproc_pragma] = STATE(73),
    [sym_preproc_nullable] = STATE(73),
    [sym_preproc_error] = STATE(73),
    [sym_preproc_warning] = STATE(73),
    [sym_preproc_define] = STATE(73),
    [sym_preproc_undef] = STATE(73),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [74] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7177),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(74),
    [sym_preproc_endregion] = STATE(74),
    [sym_preproc_line] = STATE(74),
    [sym_preproc_pragma] = STATE(74),
    [sym_preproc_nullable] = STATE(74),
    [sym_preproc_error] = STATE(74),
    [sym_preproc_warning] = STATE(74),
    [sym_preproc_define] = STATE(74),
    [sym_preproc_undef] = STATE(74),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [75] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7204),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(75),
    [sym_preproc_endregion] = STATE(75),
    [sym_preproc_line] = STATE(75),
    [sym_preproc_pragma] = STATE(75),
    [sym_preproc_nullable] = STATE(75),
    [sym_preproc_error] = STATE(75),
    [sym_preproc_warning] = STATE(75),
    [sym_preproc_define] = STATE(75),
    [sym_preproc_undef] = STATE(75),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [76] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2043),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(76),
    [sym_preproc_endregion] = STATE(76),
    [sym_preproc_line] = STATE(76),
    [sym_preproc_pragma] = STATE(76),
    [sym_preproc_nullable] = STATE(76),
    [sym_preproc_error] = STATE(76),
    [sym_preproc_warning] = STATE(76),
    [sym_preproc_define] = STATE(76),
    [sym_preproc_undef] = STATE(76),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [77] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2056),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(77),
    [sym_preproc_endregion] = STATE(77),
    [sym_preproc_line] = STATE(77),
    [sym_preproc_pragma] = STATE(77),
    [sym_preproc_nullable] = STATE(77),
    [sym_preproc_error] = STATE(77),
    [sym_preproc_warning] = STATE(77),
    [sym_preproc_define] = STATE(77),
    [sym_preproc_undef] = STATE(77),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [78] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2030),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(78),
    [sym_preproc_endregion] = STATE(78),
    [sym_preproc_line] = STATE(78),
    [sym_preproc_pragma] = STATE(78),
    [sym_preproc_nullable] = STATE(78),
    [sym_preproc_error] = STATE(78),
    [sym_preproc_warning] = STATE(78),
    [sym_preproc_define] = STATE(78),
    [sym_preproc_undef] = STATE(78),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [79] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7260),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(79),
    [sym_preproc_endregion] = STATE(79),
    [sym_preproc_line] = STATE(79),
    [sym_preproc_pragma] = STATE(79),
    [sym_preproc_nullable] = STATE(79),
    [sym_preproc_error] = STATE(79),
    [sym_preproc_warning] = STATE(79),
    [sym_preproc_define] = STATE(79),
    [sym_preproc_undef] = STATE(79),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [80] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7264),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(80),
    [sym_preproc_endregion] = STATE(80),
    [sym_preproc_line] = STATE(80),
    [sym_preproc_pragma] = STATE(80),
    [sym_preproc_nullable] = STATE(80),
    [sym_preproc_error] = STATE(80),
    [sym_preproc_warning] = STATE(80),
    [sym_preproc_define] = STATE(80),
    [sym_preproc_undef] = STATE(80),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [81] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2053),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(81),
    [sym_preproc_endregion] = STATE(81),
    [sym_preproc_line] = STATE(81),
    [sym_preproc_pragma] = STATE(81),
    [sym_preproc_nullable] = STATE(81),
    [sym_preproc_error] = STATE(81),
    [sym_preproc_warning] = STATE(81),
    [sym_preproc_define] = STATE(81),
    [sym_preproc_undef] = STATE(81),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [82] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7793),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(82),
    [sym_preproc_endregion] = STATE(82),
    [sym_preproc_line] = STATE(82),
    [sym_preproc_pragma] = STATE(82),
    [sym_preproc_nullable] = STATE(82),
    [sym_preproc_error] = STATE(82),
    [sym_preproc_warning] = STATE(82),
    [sym_preproc_define] = STATE(82),
    [sym_preproc_undef] = STATE(82),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [83] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2019),
    [sym_variable_declaration] = STATE(7408),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2022),
    [sym_break_statement] = STATE(2019),
    [sym_checked_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_empty_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym_fixed_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_lock_statement] = STATE(2019),
    [sym_yield_statement] = STATE(2019),
    [sym_switch_statement] = STATE(2019),
    [sym_throw_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_unsafe_statement] = STATE(2019),
    [sym_using_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym__foreach_statement_initializer] = STATE(81),
    [sym_goto_statement] = STATE(2019),
    [sym_labeled_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_while_statement] = STATE(2019),
    [sym_local_declaration_statement] = STATE(2019),
    [sym_local_function_statement] = STATE(2019),
    [sym__local_function_declaration] = STATE(6359),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5763),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2370),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2019),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(83),
    [sym_preproc_endregion] = STATE(83),
    [sym_preproc_line] = STATE(83),
    [sym_preproc_pragma] = STATE(83),
    [sym_preproc_nullable] = STATE(83),
    [sym_preproc_error] = STATE(83),
    [sym_preproc_warning] = STATE(83),
    [sym_preproc_define] = STATE(83),
    [sym_preproc_undef] = STATE(83),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2541),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1037),
    [anon_sym_unsafe] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1041),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_lock] = ACTIONS(103),
    [anon_sym_yield] = ACTIONS(105),
    [anon_sym_switch] = ACTIONS(107),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(113),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(115),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [84] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7110),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(84),
    [sym_preproc_endregion] = STATE(84),
    [sym_preproc_line] = STATE(84),
    [sym_preproc_pragma] = STATE(84),
    [sym_preproc_nullable] = STATE(84),
    [sym_preproc_error] = STATE(84),
    [sym_preproc_warning] = STATE(84),
    [sym_preproc_define] = STATE(84),
    [sym_preproc_undef] = STATE(84),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [85] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7194),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(85),
    [sym_preproc_endregion] = STATE(85),
    [sym_preproc_line] = STATE(85),
    [sym_preproc_pragma] = STATE(85),
    [sym_preproc_nullable] = STATE(85),
    [sym_preproc_error] = STATE(85),
    [sym_preproc_warning] = STATE(85),
    [sym_preproc_define] = STATE(85),
    [sym_preproc_undef] = STATE(85),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [86] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7657),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(86),
    [sym_preproc_endregion] = STATE(86),
    [sym_preproc_line] = STATE(86),
    [sym_preproc_pragma] = STATE(86),
    [sym_preproc_nullable] = STATE(86),
    [sym_preproc_error] = STATE(86),
    [sym_preproc_warning] = STATE(86),
    [sym_preproc_define] = STATE(86),
    [sym_preproc_undef] = STATE(86),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [87] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7223),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(87),
    [sym_preproc_endregion] = STATE(87),
    [sym_preproc_line] = STATE(87),
    [sym_preproc_pragma] = STATE(87),
    [sym_preproc_nullable] = STATE(87),
    [sym_preproc_error] = STATE(87),
    [sym_preproc_warning] = STATE(87),
    [sym_preproc_define] = STATE(87),
    [sym_preproc_undef] = STATE(87),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [88] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1960),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(88),
    [sym_preproc_endregion] = STATE(88),
    [sym_preproc_line] = STATE(88),
    [sym_preproc_pragma] = STATE(88),
    [sym_preproc_nullable] = STATE(88),
    [sym_preproc_error] = STATE(88),
    [sym_preproc_warning] = STATE(88),
    [sym_preproc_define] = STATE(88),
    [sym_preproc_undef] = STATE(88),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [89] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2125),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(89),
    [sym_preproc_endregion] = STATE(89),
    [sym_preproc_line] = STATE(89),
    [sym_preproc_pragma] = STATE(89),
    [sym_preproc_nullable] = STATE(89),
    [sym_preproc_error] = STATE(89),
    [sym_preproc_warning] = STATE(89),
    [sym_preproc_define] = STATE(89),
    [sym_preproc_undef] = STATE(89),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [90] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1962),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(90),
    [sym_preproc_endregion] = STATE(90),
    [sym_preproc_line] = STATE(90),
    [sym_preproc_pragma] = STATE(90),
    [sym_preproc_nullable] = STATE(90),
    [sym_preproc_error] = STATE(90),
    [sym_preproc_warning] = STATE(90),
    [sym_preproc_define] = STATE(90),
    [sym_preproc_undef] = STATE(90),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [91] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1976),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(91),
    [sym_preproc_endregion] = STATE(91),
    [sym_preproc_line] = STATE(91),
    [sym_preproc_pragma] = STATE(91),
    [sym_preproc_nullable] = STATE(91),
    [sym_preproc_error] = STATE(91),
    [sym_preproc_warning] = STATE(91),
    [sym_preproc_define] = STATE(91),
    [sym_preproc_undef] = STATE(91),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [92] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2113),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(92),
    [sym_preproc_endregion] = STATE(92),
    [sym_preproc_line] = STATE(92),
    [sym_preproc_pragma] = STATE(92),
    [sym_preproc_nullable] = STATE(92),
    [sym_preproc_error] = STATE(92),
    [sym_preproc_warning] = STATE(92),
    [sym_preproc_define] = STATE(92),
    [sym_preproc_undef] = STATE(92),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [93] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1989),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(93),
    [sym_preproc_endregion] = STATE(93),
    [sym_preproc_line] = STATE(93),
    [sym_preproc_pragma] = STATE(93),
    [sym_preproc_nullable] = STATE(93),
    [sym_preproc_error] = STATE(93),
    [sym_preproc_warning] = STATE(93),
    [sym_preproc_define] = STATE(93),
    [sym_preproc_undef] = STATE(93),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [94] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1991),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(94),
    [sym_preproc_endregion] = STATE(94),
    [sym_preproc_line] = STATE(94),
    [sym_preproc_pragma] = STATE(94),
    [sym_preproc_nullable] = STATE(94),
    [sym_preproc_error] = STATE(94),
    [sym_preproc_warning] = STATE(94),
    [sym_preproc_define] = STATE(94),
    [sym_preproc_undef] = STATE(94),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [95] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2136),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(95),
    [sym_preproc_endregion] = STATE(95),
    [sym_preproc_line] = STATE(95),
    [sym_preproc_pragma] = STATE(95),
    [sym_preproc_nullable] = STATE(95),
    [sym_preproc_error] = STATE(95),
    [sym_preproc_warning] = STATE(95),
    [sym_preproc_define] = STATE(95),
    [sym_preproc_undef] = STATE(95),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [96] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1987),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(96),
    [sym_preproc_endregion] = STATE(96),
    [sym_preproc_line] = STATE(96),
    [sym_preproc_pragma] = STATE(96),
    [sym_preproc_nullable] = STATE(96),
    [sym_preproc_error] = STATE(96),
    [sym_preproc_warning] = STATE(96),
    [sym_preproc_define] = STATE(96),
    [sym_preproc_undef] = STATE(96),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [97] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1964),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(97),
    [sym_preproc_endregion] = STATE(97),
    [sym_preproc_line] = STATE(97),
    [sym_preproc_pragma] = STATE(97),
    [sym_preproc_nullable] = STATE(97),
    [sym_preproc_error] = STATE(97),
    [sym_preproc_warning] = STATE(97),
    [sym_preproc_define] = STATE(97),
    [sym_preproc_undef] = STATE(97),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [98] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1949),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(98),
    [sym_preproc_endregion] = STATE(98),
    [sym_preproc_line] = STATE(98),
    [sym_preproc_pragma] = STATE(98),
    [sym_preproc_nullable] = STATE(98),
    [sym_preproc_error] = STATE(98),
    [sym_preproc_warning] = STATE(98),
    [sym_preproc_define] = STATE(98),
    [sym_preproc_undef] = STATE(98),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [99] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(1985),
    [sym_variable_declaration] = STATE(7450),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(1993),
    [sym_break_statement] = STATE(1985),
    [sym_checked_statement] = STATE(1985),
    [sym_continue_statement] = STATE(1985),
    [sym_do_statement] = STATE(1985),
    [sym_empty_statement] = STATE(1985),
    [sym_expression_statement] = STATE(1985),
    [sym_fixed_statement] = STATE(1985),
    [sym_for_statement] = STATE(1985),
    [sym_return_statement] = STATE(1985),
    [sym_lock_statement] = STATE(1985),
    [sym_yield_statement] = STATE(1985),
    [sym_switch_statement] = STATE(1985),
    [sym_throw_statement] = STATE(1985),
    [sym_try_statement] = STATE(1985),
    [sym_unsafe_statement] = STATE(1985),
    [sym_using_statement] = STATE(1985),
    [sym_foreach_statement] = STATE(1985),
    [sym__foreach_statement_initializer] = STATE(88),
    [sym_goto_statement] = STATE(1985),
    [sym_labeled_statement] = STATE(1985),
    [sym_if_statement] = STATE(1985),
    [sym_while_statement] = STATE(1985),
    [sym_local_declaration_statement] = STATE(1985),
    [sym_local_function_statement] = STATE(1985),
    [sym__local_function_declaration] = STATE(6364),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5234),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2269),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(1985),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(99),
    [sym_preproc_endregion] = STATE(99),
    [sym_preproc_line] = STATE(99),
    [sym_preproc_pragma] = STATE(99),
    [sym_preproc_nullable] = STATE(99),
    [sym_preproc_error] = STATE(99),
    [sym_preproc_warning] = STATE(99),
    [sym_preproc_define] = STATE(99),
    [sym_preproc_undef] = STATE(99),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2554),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1031),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(1033),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_unchecked] = ACTIONS(179),
    [anon_sym_continue] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_lock] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_switch] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(201),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [100] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2127),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(100),
    [sym_preproc_endregion] = STATE(100),
    [sym_preproc_line] = STATE(100),
    [sym_preproc_pragma] = STATE(100),
    [sym_preproc_nullable] = STATE(100),
    [sym_preproc_error] = STATE(100),
    [sym_preproc_warning] = STATE(100),
    [sym_preproc_define] = STATE(100),
    [sym_preproc_undef] = STATE(100),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [101] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2129),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(101),
    [sym_preproc_endregion] = STATE(101),
    [sym_preproc_line] = STATE(101),
    [sym_preproc_pragma] = STATE(101),
    [sym_preproc_nullable] = STATE(101),
    [sym_preproc_error] = STATE(101),
    [sym_preproc_warning] = STATE(101),
    [sym_preproc_define] = STATE(101),
    [sym_preproc_undef] = STATE(101),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [102] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7791),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(102),
    [sym_preproc_endregion] = STATE(102),
    [sym_preproc_line] = STATE(102),
    [sym_preproc_pragma] = STATE(102),
    [sym_preproc_nullable] = STATE(102),
    [sym_preproc_error] = STATE(102),
    [sym_preproc_warning] = STATE(102),
    [sym_preproc_define] = STATE(102),
    [sym_preproc_undef] = STATE(102),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [103] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2130),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(103),
    [sym_preproc_endregion] = STATE(103),
    [sym_preproc_line] = STATE(103),
    [sym_preproc_pragma] = STATE(103),
    [sym_preproc_nullable] = STATE(103),
    [sym_preproc_error] = STATE(103),
    [sym_preproc_warning] = STATE(103),
    [sym_preproc_define] = STATE(103),
    [sym_preproc_undef] = STATE(103),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [104] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(7225),
    [sym_variable_declaration] = STATE(7502),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(7786),
    [sym_break_statement] = STATE(7225),
    [sym_checked_statement] = STATE(7225),
    [sym_continue_statement] = STATE(7225),
    [sym_do_statement] = STATE(7225),
    [sym_empty_statement] = STATE(7225),
    [sym_expression_statement] = STATE(7225),
    [sym_fixed_statement] = STATE(7225),
    [sym_for_statement] = STATE(7225),
    [sym_return_statement] = STATE(7225),
    [sym_lock_statement] = STATE(7225),
    [sym_yield_statement] = STATE(7225),
    [sym_switch_statement] = STATE(7225),
    [sym_throw_statement] = STATE(7225),
    [sym_try_statement] = STATE(7225),
    [sym_unsafe_statement] = STATE(7225),
    [sym_using_statement] = STATE(7225),
    [sym_foreach_statement] = STATE(7225),
    [sym__foreach_statement_initializer] = STATE(62),
    [sym_goto_statement] = STATE(7225),
    [sym_labeled_statement] = STATE(7225),
    [sym_if_statement] = STATE(7225),
    [sym_while_statement] = STATE(7225),
    [sym_local_declaration_statement] = STATE(7225),
    [sym_local_function_statement] = STATE(7225),
    [sym__local_function_declaration] = STATE(6366),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5768),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2364),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(7225),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(104),
    [sym_preproc_endregion] = STATE(104),
    [sym_preproc_line] = STATE(104),
    [sym_preproc_pragma] = STATE(104),
    [sym_preproc_nullable] = STATE(104),
    [sym_preproc_error] = STATE(104),
    [sym_preproc_warning] = STATE(104),
    [sym_preproc_define] = STATE(104),
    [sym_preproc_undef] = STATE(104),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2566),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(989),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_unchecked] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_lock] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [105] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(2109),
    [sym_variable_declaration] = STATE(7456),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5852),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_statement] = STATE(2137),
    [sym_break_statement] = STATE(2109),
    [sym_checked_statement] = STATE(2109),
    [sym_continue_statement] = STATE(2109),
    [sym_do_statement] = STATE(2109),
    [sym_empty_statement] = STATE(2109),
    [sym_expression_statement] = STATE(2109),
    [sym_fixed_statement] = STATE(2109),
    [sym_for_statement] = STATE(2109),
    [sym_return_statement] = STATE(2109),
    [sym_lock_statement] = STATE(2109),
    [sym_yield_statement] = STATE(2109),
    [sym_switch_statement] = STATE(2109),
    [sym_throw_statement] = STATE(2109),
    [sym_try_statement] = STATE(2109),
    [sym_unsafe_statement] = STATE(2109),
    [sym_using_statement] = STATE(2109),
    [sym_foreach_statement] = STATE(2109),
    [sym__foreach_statement_initializer] = STATE(89),
    [sym_goto_statement] = STATE(2109),
    [sym_labeled_statement] = STATE(2109),
    [sym_if_statement] = STATE(2109),
    [sym_while_statement] = STATE(2109),
    [sym_local_declaration_statement] = STATE(2109),
    [sym_local_function_statement] = STATE(2109),
    [sym__local_function_declaration] = STATE(6374),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(5373),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2287),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_top_level] = STATE(2109),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(105),
    [sym_preproc_endregion] = STATE(105),
    [sym_preproc_line] = STATE(105),
    [sym_preproc_pragma] = STATE(105),
    [sym_preproc_nullable] = STATE(105),
    [sym_preproc_error] = STATE(105),
    [sym_preproc_warning] = STATE(105),
    [sym_preproc_define] = STATE(105),
    [sym_preproc_undef] = STATE(105),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2545),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(649),
    [anon_sym_unsafe] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(669),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_unchecked] = ACTIONS(673),
    [anon_sym_continue] = ACTIONS(677),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_lock] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_foreach] = ACTIONS(117),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [106] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6638),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(106),
    [sym_preproc_endregion] = STATE(106),
    [sym_preproc_line] = STATE(106),
    [sym_preproc_pragma] = STATE(106),
    [sym_preproc_nullable] = STATE(106),
    [sym_preproc_error] = STATE(106),
    [sym_preproc_warning] = STATE(106),
    [sym_preproc_define] = STATE(106),
    [sym_preproc_undef] = STATE(106),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [107] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6581),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(107),
    [sym_preproc_endregion] = STATE(107),
    [sym_preproc_line] = STATE(107),
    [sym_preproc_pragma] = STATE(107),
    [sym_preproc_nullable] = STATE(107),
    [sym_preproc_error] = STATE(107),
    [sym_preproc_warning] = STATE(107),
    [sym_preproc_define] = STATE(107),
    [sym_preproc_undef] = STATE(107),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [108] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6585),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(108),
    [sym_preproc_endregion] = STATE(108),
    [sym_preproc_line] = STATE(108),
    [sym_preproc_pragma] = STATE(108),
    [sym_preproc_nullable] = STATE(108),
    [sym_preproc_error] = STATE(108),
    [sym_preproc_warning] = STATE(108),
    [sym_preproc_define] = STATE(108),
    [sym_preproc_undef] = STATE(108),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [109] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6647),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(109),
    [sym_preproc_endregion] = STATE(109),
    [sym_preproc_line] = STATE(109),
    [sym_preproc_pragma] = STATE(109),
    [sym_preproc_nullable] = STATE(109),
    [sym_preproc_error] = STATE(109),
    [sym_preproc_warning] = STATE(109),
    [sym_preproc_define] = STATE(109),
    [sym_preproc_undef] = STATE(109),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1099),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [110] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6565),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(110),
    [sym_preproc_endregion] = STATE(110),
    [sym_preproc_line] = STATE(110),
    [sym_preproc_pragma] = STATE(110),
    [sym_preproc_nullable] = STATE(110),
    [sym_preproc_error] = STATE(110),
    [sym_preproc_warning] = STATE(110),
    [sym_preproc_define] = STATE(110),
    [sym_preproc_undef] = STATE(110),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [111] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6646),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(111),
    [sym_preproc_endregion] = STATE(111),
    [sym_preproc_line] = STATE(111),
    [sym_preproc_pragma] = STATE(111),
    [sym_preproc_nullable] = STATE(111),
    [sym_preproc_error] = STATE(111),
    [sym_preproc_warning] = STATE(111),
    [sym_preproc_define] = STATE(111),
    [sym_preproc_undef] = STATE(111),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1107),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [112] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6626),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(112),
    [sym_preproc_endregion] = STATE(112),
    [sym_preproc_line] = STATE(112),
    [sym_preproc_pragma] = STATE(112),
    [sym_preproc_nullable] = STATE(112),
    [sym_preproc_error] = STATE(112),
    [sym_preproc_warning] = STATE(112),
    [sym_preproc_define] = STATE(112),
    [sym_preproc_undef] = STATE(112),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [113] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5433),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6680),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5271),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(113),
    [sym_preproc_endregion] = STATE(113),
    [sym_preproc_line] = STATE(113),
    [sym_preproc_pragma] = STATE(113),
    [sym_preproc_nullable] = STATE(113),
    [sym_preproc_error] = STATE(113),
    [sym_preproc_warning] = STATE(113),
    [sym_preproc_define] = STATE(113),
    [sym_preproc_undef] = STATE(113),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [114] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5026),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym__variable_designation] = STATE(6986),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2233),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(114),
    [sym_preproc_endregion] = STATE(114),
    [sym_preproc_line] = STATE(114),
    [sym_preproc_pragma] = STATE(114),
    [sym_preproc_nullable] = STATE(114),
    [sym_preproc_error] = STATE(114),
    [sym_preproc_warning] = STATE(114),
    [sym_preproc_define] = STATE(114),
    [sym_preproc_undef] = STATE(114),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1145),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [115] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5066),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(115),
    [sym_preproc_endregion] = STATE(115),
    [sym_preproc_line] = STATE(115),
    [sym_preproc_pragma] = STATE(115),
    [sym_preproc_nullable] = STATE(115),
    [sym_preproc_error] = STATE(115),
    [sym_preproc_warning] = STATE(115),
    [sym_preproc_define] = STATE(115),
    [sym_preproc_undef] = STATE(115),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [116] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5077),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(116),
    [sym_preproc_endregion] = STATE(116),
    [sym_preproc_line] = STATE(116),
    [sym_preproc_pragma] = STATE(116),
    [sym_preproc_nullable] = STATE(116),
    [sym_preproc_error] = STATE(116),
    [sym_preproc_warning] = STATE(116),
    [sym_preproc_define] = STATE(116),
    [sym_preproc_undef] = STATE(116),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [117] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4976),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(117),
    [sym_preproc_endregion] = STATE(117),
    [sym_preproc_line] = STATE(117),
    [sym_preproc_pragma] = STATE(117),
    [sym_preproc_nullable] = STATE(117),
    [sym_preproc_error] = STATE(117),
    [sym_preproc_warning] = STATE(117),
    [sym_preproc_define] = STATE(117),
    [sym_preproc_undef] = STATE(117),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [118] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4968),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6727),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(118),
    [sym_preproc_endregion] = STATE(118),
    [sym_preproc_line] = STATE(118),
    [sym_preproc_pragma] = STATE(118),
    [sym_preproc_nullable] = STATE(118),
    [sym_preproc_error] = STATE(118),
    [sym_preproc_warning] = STATE(118),
    [sym_preproc_define] = STATE(118),
    [sym_preproc_undef] = STATE(118),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [119] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5011),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(119),
    [sym_preproc_endregion] = STATE(119),
    [sym_preproc_line] = STATE(119),
    [sym_preproc_pragma] = STATE(119),
    [sym_preproc_nullable] = STATE(119),
    [sym_preproc_error] = STATE(119),
    [sym_preproc_warning] = STATE(119),
    [sym_preproc_define] = STATE(119),
    [sym_preproc_undef] = STATE(119),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [120] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5037),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6727),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(120),
    [sym_preproc_endregion] = STATE(120),
    [sym_preproc_line] = STATE(120),
    [sym_preproc_pragma] = STATE(120),
    [sym_preproc_nullable] = STATE(120),
    [sym_preproc_error] = STATE(120),
    [sym_preproc_warning] = STATE(120),
    [sym_preproc_define] = STATE(120),
    [sym_preproc_undef] = STATE(120),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [121] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5088),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6721),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5589),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(121),
    [sym_preproc_endregion] = STATE(121),
    [sym_preproc_line] = STATE(121),
    [sym_preproc_pragma] = STATE(121),
    [sym_preproc_nullable] = STATE(121),
    [sym_preproc_error] = STATE(121),
    [sym_preproc_warning] = STATE(121),
    [sym_preproc_define] = STATE(121),
    [sym_preproc_undef] = STATE(121),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [122] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5108),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6721),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5589),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(122),
    [sym_preproc_endregion] = STATE(122),
    [sym_preproc_line] = STATE(122),
    [sym_preproc_pragma] = STATE(122),
    [sym_preproc_nullable] = STATE(122),
    [sym_preproc_error] = STATE(122),
    [sym_preproc_warning] = STATE(122),
    [sym_preproc_define] = STATE(122),
    [sym_preproc_undef] = STATE(122),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [123] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5138),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(123),
    [sym_preproc_endregion] = STATE(123),
    [sym_preproc_line] = STATE(123),
    [sym_preproc_pragma] = STATE(123),
    [sym_preproc_nullable] = STATE(123),
    [sym_preproc_error] = STATE(123),
    [sym_preproc_warning] = STATE(123),
    [sym_preproc_define] = STATE(123),
    [sym_preproc_undef] = STATE(123),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [124] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5000),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(124),
    [sym_preproc_endregion] = STATE(124),
    [sym_preproc_line] = STATE(124),
    [sym_preproc_pragma] = STATE(124),
    [sym_preproc_nullable] = STATE(124),
    [sym_preproc_error] = STATE(124),
    [sym_preproc_warning] = STATE(124),
    [sym_preproc_define] = STATE(124),
    [sym_preproc_undef] = STATE(124),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [125] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4902),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7211),
    [sym_pattern] = STATE(6711),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6906),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5435),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(125),
    [sym_preproc_endregion] = STATE(125),
    [sym_preproc_line] = STATE(125),
    [sym_preproc_pragma] = STATE(125),
    [sym_preproc_nullable] = STATE(125),
    [sym_preproc_error] = STATE(125),
    [sym_preproc_warning] = STATE(125),
    [sym_preproc_define] = STATE(125),
    [sym_preproc_undef] = STATE(125),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [126] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4924),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(126),
    [sym_preproc_endregion] = STATE(126),
    [sym_preproc_line] = STATE(126),
    [sym_preproc_pragma] = STATE(126),
    [sym_preproc_nullable] = STATE(126),
    [sym_preproc_error] = STATE(126),
    [sym_preproc_warning] = STATE(126),
    [sym_preproc_define] = STATE(126),
    [sym_preproc_undef] = STATE(126),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [127] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4925),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(127),
    [sym_preproc_endregion] = STATE(127),
    [sym_preproc_line] = STATE(127),
    [sym_preproc_pragma] = STATE(127),
    [sym_preproc_nullable] = STATE(127),
    [sym_preproc_error] = STATE(127),
    [sym_preproc_warning] = STATE(127),
    [sym_preproc_define] = STATE(127),
    [sym_preproc_undef] = STATE(127),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [128] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4926),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(128),
    [sym_preproc_endregion] = STATE(128),
    [sym_preproc_line] = STATE(128),
    [sym_preproc_pragma] = STATE(128),
    [sym_preproc_nullable] = STATE(128),
    [sym_preproc_error] = STATE(128),
    [sym_preproc_warning] = STATE(128),
    [sym_preproc_define] = STATE(128),
    [sym_preproc_undef] = STATE(128),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [129] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4927),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(129),
    [sym_preproc_endregion] = STATE(129),
    [sym_preproc_line] = STATE(129),
    [sym_preproc_pragma] = STATE(129),
    [sym_preproc_nullable] = STATE(129),
    [sym_preproc_error] = STATE(129),
    [sym_preproc_warning] = STATE(129),
    [sym_preproc_define] = STATE(129),
    [sym_preproc_undef] = STATE(129),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [130] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4931),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(130),
    [sym_preproc_endregion] = STATE(130),
    [sym_preproc_line] = STATE(130),
    [sym_preproc_pragma] = STATE(130),
    [sym_preproc_nullable] = STATE(130),
    [sym_preproc_error] = STATE(130),
    [sym_preproc_warning] = STATE(130),
    [sym_preproc_define] = STATE(130),
    [sym_preproc_undef] = STATE(130),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [131] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3737),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(131),
    [sym_preproc_endregion] = STATE(131),
    [sym_preproc_line] = STATE(131),
    [sym_preproc_pragma] = STATE(131),
    [sym_preproc_nullable] = STATE(131),
    [sym_preproc_error] = STATE(131),
    [sym_preproc_warning] = STATE(131),
    [sym_preproc_define] = STATE(131),
    [sym_preproc_undef] = STATE(131),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token3] = ACTIONS(1159),
    [aux_sym_preproc_else_token1] = ACTIONS(1159),
    [aux_sym_preproc_elif_token1] = ACTIONS(1159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [132] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4945),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(132),
    [sym_preproc_endregion] = STATE(132),
    [sym_preproc_line] = STATE(132),
    [sym_preproc_pragma] = STATE(132),
    [sym_preproc_nullable] = STATE(132),
    [sym_preproc_error] = STATE(132),
    [sym_preproc_warning] = STATE(132),
    [sym_preproc_define] = STATE(132),
    [sym_preproc_undef] = STATE(132),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [133] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5000),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(133),
    [sym_preproc_endregion] = STATE(133),
    [sym_preproc_line] = STATE(133),
    [sym_preproc_pragma] = STATE(133),
    [sym_preproc_nullable] = STATE(133),
    [sym_preproc_error] = STATE(133),
    [sym_preproc_warning] = STATE(133),
    [sym_preproc_define] = STATE(133),
    [sym_preproc_undef] = STATE(133),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [134] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5162),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(134),
    [sym_preproc_endregion] = STATE(134),
    [sym_preproc_line] = STATE(134),
    [sym_preproc_pragma] = STATE(134),
    [sym_preproc_nullable] = STATE(134),
    [sym_preproc_error] = STATE(134),
    [sym_preproc_warning] = STATE(134),
    [sym_preproc_define] = STATE(134),
    [sym_preproc_undef] = STATE(134),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [135] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4945),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(135),
    [sym_preproc_endregion] = STATE(135),
    [sym_preproc_line] = STATE(135),
    [sym_preproc_pragma] = STATE(135),
    [sym_preproc_nullable] = STATE(135),
    [sym_preproc_error] = STATE(135),
    [sym_preproc_warning] = STATE(135),
    [sym_preproc_define] = STATE(135),
    [sym_preproc_undef] = STATE(135),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [136] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5107),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6699),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(136),
    [sym_preproc_endregion] = STATE(136),
    [sym_preproc_line] = STATE(136),
    [sym_preproc_pragma] = STATE(136),
    [sym_preproc_nullable] = STATE(136),
    [sym_preproc_error] = STATE(136),
    [sym_preproc_warning] = STATE(136),
    [sym_preproc_define] = STATE(136),
    [sym_preproc_undef] = STATE(136),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [137] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5026),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(137),
    [sym_preproc_endregion] = STATE(137),
    [sym_preproc_line] = STATE(137),
    [sym_preproc_pragma] = STATE(137),
    [sym_preproc_nullable] = STATE(137),
    [sym_preproc_error] = STATE(137),
    [sym_preproc_warning] = STATE(137),
    [sym_preproc_define] = STATE(137),
    [sym_preproc_undef] = STATE(137),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [138] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3813),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(138),
    [sym_preproc_endregion] = STATE(138),
    [sym_preproc_line] = STATE(138),
    [sym_preproc_pragma] = STATE(138),
    [sym_preproc_nullable] = STATE(138),
    [sym_preproc_error] = STATE(138),
    [sym_preproc_warning] = STATE(138),
    [sym_preproc_define] = STATE(138),
    [sym_preproc_undef] = STATE(138),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token3] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [139] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5047),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(139),
    [sym_preproc_endregion] = STATE(139),
    [sym_preproc_line] = STATE(139),
    [sym_preproc_pragma] = STATE(139),
    [sym_preproc_nullable] = STATE(139),
    [sym_preproc_error] = STATE(139),
    [sym_preproc_warning] = STATE(139),
    [sym_preproc_define] = STATE(139),
    [sym_preproc_undef] = STATE(139),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [140] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5035),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(140),
    [sym_preproc_endregion] = STATE(140),
    [sym_preproc_line] = STATE(140),
    [sym_preproc_pragma] = STATE(140),
    [sym_preproc_nullable] = STATE(140),
    [sym_preproc_error] = STATE(140),
    [sym_preproc_warning] = STATE(140),
    [sym_preproc_define] = STATE(140),
    [sym_preproc_undef] = STATE(140),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [141] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5055),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(141),
    [sym_preproc_endregion] = STATE(141),
    [sym_preproc_line] = STATE(141),
    [sym_preproc_pragma] = STATE(141),
    [sym_preproc_nullable] = STATE(141),
    [sym_preproc_error] = STATE(141),
    [sym_preproc_warning] = STATE(141),
    [sym_preproc_define] = STATE(141),
    [sym_preproc_undef] = STATE(141),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [142] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5026),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(142),
    [sym_preproc_endregion] = STATE(142),
    [sym_preproc_line] = STATE(142),
    [sym_preproc_pragma] = STATE(142),
    [sym_preproc_nullable] = STATE(142),
    [sym_preproc_error] = STATE(142),
    [sym_preproc_warning] = STATE(142),
    [sym_preproc_define] = STATE(142),
    [sym_preproc_undef] = STATE(142),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [143] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5059),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(143),
    [sym_preproc_endregion] = STATE(143),
    [sym_preproc_line] = STATE(143),
    [sym_preproc_pragma] = STATE(143),
    [sym_preproc_nullable] = STATE(143),
    [sym_preproc_error] = STATE(143),
    [sym_preproc_warning] = STATE(143),
    [sym_preproc_define] = STATE(143),
    [sym_preproc_undef] = STATE(143),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [144] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5062),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(144),
    [sym_preproc_endregion] = STATE(144),
    [sym_preproc_line] = STATE(144),
    [sym_preproc_pragma] = STATE(144),
    [sym_preproc_nullable] = STATE(144),
    [sym_preproc_error] = STATE(144),
    [sym_preproc_warning] = STATE(144),
    [sym_preproc_define] = STATE(144),
    [sym_preproc_undef] = STATE(144),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [145] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5035),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_pattern] = STATE(6724),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(145),
    [sym_preproc_endregion] = STATE(145),
    [sym_preproc_line] = STATE(145),
    [sym_preproc_pragma] = STATE(145),
    [sym_preproc_nullable] = STATE(145),
    [sym_preproc_error] = STATE(145),
    [sym_preproc_warning] = STATE(145),
    [sym_preproc_define] = STATE(145),
    [sym_preproc_undef] = STATE(145),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [146] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4923),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7211),
    [sym_pattern] = STATE(6711),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6906),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5435),
    [sym_lvalue_expression] = STATE(3573),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2222),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(146),
    [sym_preproc_endregion] = STATE(146),
    [sym_preproc_line] = STATE(146),
    [sym_preproc_pragma] = STATE(146),
    [sym_preproc_nullable] = STATE(146),
    [sym_preproc_error] = STATE(146),
    [sym_preproc_warning] = STATE(146),
    [sym_preproc_define] = STATE(146),
    [sym_preproc_undef] = STATE(146),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_ref] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [147] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4983),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6766),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym__variable_designation] = STATE(6986),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_expression] = STATE(5467),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2232),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(147),
    [sym_preproc_endregion] = STATE(147),
    [sym_preproc_line] = STATE(147),
    [sym_preproc_pragma] = STATE(147),
    [sym_preproc_nullable] = STATE(147),
    [sym_preproc_error] = STATE(147),
    [sym_preproc_warning] = STATE(147),
    [sym_preproc_define] = STATE(147),
    [sym_preproc_undef] = STATE(147),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1145),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [148] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4983),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6766),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6818),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym__variable_designation] = STATE(6986),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_expression] = STATE(5467),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2232),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(148),
    [sym_preproc_endregion] = STATE(148),
    [sym_preproc_line] = STATE(148),
    [sym_preproc_pragma] = STATE(148),
    [sym_preproc_nullable] = STATE(148),
    [sym_preproc_error] = STATE(148),
    [sym_preproc_warning] = STATE(148),
    [sym_preproc_define] = STATE(148),
    [sym_preproc_undef] = STATE(148),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1243),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1145),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [149] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4141),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(149),
    [sym_preproc_endregion] = STATE(149),
    [sym_preproc_line] = STATE(149),
    [sym_preproc_pragma] = STATE(149),
    [sym_preproc_nullable] = STATE(149),
    [sym_preproc_error] = STATE(149),
    [sym_preproc_warning] = STATE(149),
    [sym_preproc_define] = STATE(149),
    [sym_preproc_undef] = STATE(149),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token3] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [150] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4119),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(150),
    [sym_preproc_endregion] = STATE(150),
    [sym_preproc_line] = STATE(150),
    [sym_preproc_pragma] = STATE(150),
    [sym_preproc_nullable] = STATE(150),
    [sym_preproc_error] = STATE(150),
    [sym_preproc_warning] = STATE(150),
    [sym_preproc_define] = STATE(150),
    [sym_preproc_undef] = STATE(150),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token3] = ACTIONS(1159),
    [aux_sym_preproc_else_token1] = ACTIONS(1159),
    [aux_sym_preproc_elif_token1] = ACTIONS(1159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [151] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4291),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(151),
    [sym_preproc_endregion] = STATE(151),
    [sym_preproc_line] = STATE(151),
    [sym_preproc_pragma] = STATE(151),
    [sym_preproc_nullable] = STATE(151),
    [sym_preproc_error] = STATE(151),
    [sym_preproc_warning] = STATE(151),
    [sym_preproc_define] = STATE(151),
    [sym_preproc_undef] = STATE(151),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [152] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4287),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(152),
    [sym_preproc_endregion] = STATE(152),
    [sym_preproc_line] = STATE(152),
    [sym_preproc_pragma] = STATE(152),
    [sym_preproc_nullable] = STATE(152),
    [sym_preproc_error] = STATE(152),
    [sym_preproc_warning] = STATE(152),
    [sym_preproc_define] = STATE(152),
    [sym_preproc_undef] = STATE(152),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [153] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4312),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(153),
    [sym_preproc_endregion] = STATE(153),
    [sym_preproc_line] = STATE(153),
    [sym_preproc_pragma] = STATE(153),
    [sym_preproc_nullable] = STATE(153),
    [sym_preproc_error] = STATE(153),
    [sym_preproc_warning] = STATE(153),
    [sym_preproc_define] = STATE(153),
    [sym_preproc_undef] = STATE(153),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [154] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4289),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(154),
    [sym_preproc_endregion] = STATE(154),
    [sym_preproc_line] = STATE(154),
    [sym_preproc_pragma] = STATE(154),
    [sym_preproc_nullable] = STATE(154),
    [sym_preproc_error] = STATE(154),
    [sym_preproc_warning] = STATE(154),
    [sym_preproc_define] = STATE(154),
    [sym_preproc_undef] = STATE(154),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [155] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4302),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(155),
    [sym_preproc_endregion] = STATE(155),
    [sym_preproc_line] = STATE(155),
    [sym_preproc_pragma] = STATE(155),
    [sym_preproc_nullable] = STATE(155),
    [sym_preproc_error] = STATE(155),
    [sym_preproc_warning] = STATE(155),
    [sym_preproc_define] = STATE(155),
    [sym_preproc_undef] = STATE(155),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token3] = ACTIONS(1159),
    [aux_sym_preproc_else_token1] = ACTIONS(1159),
    [aux_sym_preproc_elif_token1] = ACTIONS(1159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [156] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(156),
    [sym_preproc_endregion] = STATE(156),
    [sym_preproc_line] = STATE(156),
    [sym_preproc_pragma] = STATE(156),
    [sym_preproc_nullable] = STATE(156),
    [sym_preproc_error] = STATE(156),
    [sym_preproc_warning] = STATE(156),
    [sym_preproc_define] = STATE(156),
    [sym_preproc_undef] = STATE(156),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token3] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [157] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4235),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(157),
    [sym_preproc_endregion] = STATE(157),
    [sym_preproc_line] = STATE(157),
    [sym_preproc_pragma] = STATE(157),
    [sym_preproc_nullable] = STATE(157),
    [sym_preproc_error] = STATE(157),
    [sym_preproc_warning] = STATE(157),
    [sym_preproc_define] = STATE(157),
    [sym_preproc_undef] = STATE(157),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [158] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4347),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(158),
    [sym_preproc_endregion] = STATE(158),
    [sym_preproc_line] = STATE(158),
    [sym_preproc_pragma] = STATE(158),
    [sym_preproc_nullable] = STATE(158),
    [sym_preproc_error] = STATE(158),
    [sym_preproc_warning] = STATE(158),
    [sym_preproc_define] = STATE(158),
    [sym_preproc_undef] = STATE(158),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [159] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4329),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(159),
    [sym_preproc_endregion] = STATE(159),
    [sym_preproc_line] = STATE(159),
    [sym_preproc_pragma] = STATE(159),
    [sym_preproc_nullable] = STATE(159),
    [sym_preproc_error] = STATE(159),
    [sym_preproc_warning] = STATE(159),
    [sym_preproc_define] = STATE(159),
    [sym_preproc_undef] = STATE(159),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1229),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [160] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4456),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(160),
    [sym_preproc_endregion] = STATE(160),
    [sym_preproc_line] = STATE(160),
    [sym_preproc_pragma] = STATE(160),
    [sym_preproc_nullable] = STATE(160),
    [sym_preproc_error] = STATE(160),
    [sym_preproc_warning] = STATE(160),
    [sym_preproc_define] = STATE(160),
    [sym_preproc_undef] = STATE(160),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1159),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [161] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4373),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(161),
    [sym_preproc_endregion] = STATE(161),
    [sym_preproc_line] = STATE(161),
    [sym_preproc_pragma] = STATE(161),
    [sym_preproc_nullable] = STATE(161),
    [sym_preproc_error] = STATE(161),
    [sym_preproc_warning] = STATE(161),
    [sym_preproc_define] = STATE(161),
    [sym_preproc_undef] = STATE(161),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1159),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [162] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4496),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(162),
    [sym_preproc_endregion] = STATE(162),
    [sym_preproc_line] = STATE(162),
    [sym_preproc_pragma] = STATE(162),
    [sym_preproc_nullable] = STATE(162),
    [sym_preproc_error] = STATE(162),
    [sym_preproc_warning] = STATE(162),
    [sym_preproc_define] = STATE(162),
    [sym_preproc_undef] = STATE(162),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1229),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [163] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4416),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(163),
    [sym_preproc_endregion] = STATE(163),
    [sym_preproc_line] = STATE(163),
    [sym_preproc_pragma] = STATE(163),
    [sym_preproc_nullable] = STATE(163),
    [sym_preproc_error] = STATE(163),
    [sym_preproc_warning] = STATE(163),
    [sym_preproc_define] = STATE(163),
    [sym_preproc_undef] = STATE(163),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [164] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4810),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(164),
    [sym_preproc_endregion] = STATE(164),
    [sym_preproc_line] = STATE(164),
    [sym_preproc_pragma] = STATE(164),
    [sym_preproc_nullable] = STATE(164),
    [sym_preproc_error] = STATE(164),
    [sym_preproc_warning] = STATE(164),
    [sym_preproc_define] = STATE(164),
    [sym_preproc_undef] = STATE(164),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [165] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4463),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(165),
    [sym_preproc_endregion] = STATE(165),
    [sym_preproc_line] = STATE(165),
    [sym_preproc_pragma] = STATE(165),
    [sym_preproc_nullable] = STATE(165),
    [sym_preproc_error] = STATE(165),
    [sym_preproc_warning] = STATE(165),
    [sym_preproc_define] = STATE(165),
    [sym_preproc_undef] = STATE(165),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [166] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4694),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(166),
    [sym_preproc_endregion] = STATE(166),
    [sym_preproc_line] = STATE(166),
    [sym_preproc_pragma] = STATE(166),
    [sym_preproc_nullable] = STATE(166),
    [sym_preproc_error] = STATE(166),
    [sym_preproc_warning] = STATE(166),
    [sym_preproc_define] = STATE(166),
    [sym_preproc_undef] = STATE(166),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [167] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4736),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(167),
    [sym_preproc_endregion] = STATE(167),
    [sym_preproc_line] = STATE(167),
    [sym_preproc_pragma] = STATE(167),
    [sym_preproc_nullable] = STATE(167),
    [sym_preproc_error] = STATE(167),
    [sym_preproc_warning] = STATE(167),
    [sym_preproc_define] = STATE(167),
    [sym_preproc_undef] = STATE(167),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(1159),
    [aux_sym_preproc_else_token1] = ACTIONS(1159),
    [aux_sym_preproc_elif_token1] = ACTIONS(1159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [168] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(168),
    [sym_preproc_endregion] = STATE(168),
    [sym_preproc_line] = STATE(168),
    [sym_preproc_pragma] = STATE(168),
    [sym_preproc_nullable] = STATE(168),
    [sym_preproc_error] = STATE(168),
    [sym_preproc_warning] = STATE(168),
    [sym_preproc_define] = STATE(168),
    [sym_preproc_undef] = STATE(168),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [169] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4616),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(169),
    [sym_preproc_endregion] = STATE(169),
    [sym_preproc_line] = STATE(169),
    [sym_preproc_pragma] = STATE(169),
    [sym_preproc_nullable] = STATE(169),
    [sym_preproc_error] = STATE(169),
    [sym_preproc_warning] = STATE(169),
    [sym_preproc_define] = STATE(169),
    [sym_preproc_undef] = STATE(169),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [170] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4834),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(170),
    [sym_preproc_endregion] = STATE(170),
    [sym_preproc_line] = STATE(170),
    [sym_preproc_pragma] = STATE(170),
    [sym_preproc_nullable] = STATE(170),
    [sym_preproc_error] = STATE(170),
    [sym_preproc_warning] = STATE(170),
    [sym_preproc_define] = STATE(170),
    [sym_preproc_undef] = STATE(170),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [171] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(171),
    [sym_preproc_endregion] = STATE(171),
    [sym_preproc_line] = STATE(171),
    [sym_preproc_pragma] = STATE(171),
    [sym_preproc_nullable] = STATE(171),
    [sym_preproc_error] = STATE(171),
    [sym_preproc_warning] = STATE(171),
    [sym_preproc_define] = STATE(171),
    [sym_preproc_undef] = STATE(171),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(6840),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [172] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4738),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(172),
    [sym_preproc_endregion] = STATE(172),
    [sym_preproc_line] = STATE(172),
    [sym_preproc_pragma] = STATE(172),
    [sym_preproc_nullable] = STATE(172),
    [sym_preproc_error] = STATE(172),
    [sym_preproc_warning] = STATE(172),
    [sym_preproc_define] = STATE(172),
    [sym_preproc_undef] = STATE(172),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1229),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [173] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4948),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(173),
    [sym_preproc_endregion] = STATE(173),
    [sym_preproc_line] = STATE(173),
    [sym_preproc_pragma] = STATE(173),
    [sym_preproc_nullable] = STATE(173),
    [sym_preproc_error] = STATE(173),
    [sym_preproc_warning] = STATE(173),
    [sym_preproc_define] = STATE(173),
    [sym_preproc_undef] = STATE(173),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [174] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4533),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(174),
    [sym_preproc_endregion] = STATE(174),
    [sym_preproc_line] = STATE(174),
    [sym_preproc_pragma] = STATE(174),
    [sym_preproc_nullable] = STATE(174),
    [sym_preproc_error] = STATE(174),
    [sym_preproc_warning] = STATE(174),
    [sym_preproc_define] = STATE(174),
    [sym_preproc_undef] = STATE(174),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1557),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1557),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1159),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [175] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4504),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(175),
    [sym_preproc_endregion] = STATE(175),
    [sym_preproc_line] = STATE(175),
    [sym_preproc_pragma] = STATE(175),
    [sym_preproc_nullable] = STATE(175),
    [sym_preproc_error] = STATE(175),
    [sym_preproc_warning] = STATE(175),
    [sym_preproc_define] = STATE(175),
    [sym_preproc_undef] = STATE(175),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1557),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1557),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [176] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5025),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(176),
    [sym_preproc_endregion] = STATE(176),
    [sym_preproc_line] = STATE(176),
    [sym_preproc_pragma] = STATE(176),
    [sym_preproc_nullable] = STATE(176),
    [sym_preproc_error] = STATE(176),
    [sym_preproc_warning] = STATE(176),
    [sym_preproc_define] = STATE(176),
    [sym_preproc_undef] = STATE(176),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [177] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(177),
    [sym_preproc_endregion] = STATE(177),
    [sym_preproc_line] = STATE(177),
    [sym_preproc_pragma] = STATE(177),
    [sym_preproc_nullable] = STATE(177),
    [sym_preproc_error] = STATE(177),
    [sym_preproc_warning] = STATE(177),
    [sym_preproc_define] = STATE(177),
    [sym_preproc_undef] = STATE(177),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(6896),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [178] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4746),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(178),
    [sym_preproc_endregion] = STATE(178),
    [sym_preproc_line] = STATE(178),
    [sym_preproc_pragma] = STATE(178),
    [sym_preproc_nullable] = STATE(178),
    [sym_preproc_error] = STATE(178),
    [sym_preproc_warning] = STATE(178),
    [sym_preproc_define] = STATE(178),
    [sym_preproc_undef] = STATE(178),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_EQ_GT] = ACTIONS(1159),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [179] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4549),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(179),
    [sym_preproc_endregion] = STATE(179),
    [sym_preproc_line] = STATE(179),
    [sym_preproc_pragma] = STATE(179),
    [sym_preproc_nullable] = STATE(179),
    [sym_preproc_error] = STATE(179),
    [sym_preproc_warning] = STATE(179),
    [sym_preproc_define] = STATE(179),
    [sym_preproc_undef] = STATE(179),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [180] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5016),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(180),
    [sym_preproc_endregion] = STATE(180),
    [sym_preproc_line] = STATE(180),
    [sym_preproc_pragma] = STATE(180),
    [sym_preproc_nullable] = STATE(180),
    [sym_preproc_error] = STATE(180),
    [sym_preproc_warning] = STATE(180),
    [sym_preproc_define] = STATE(180),
    [sym_preproc_undef] = STATE(180),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [181] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4492),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(181),
    [sym_preproc_endregion] = STATE(181),
    [sym_preproc_line] = STATE(181),
    [sym_preproc_pragma] = STATE(181),
    [sym_preproc_nullable] = STATE(181),
    [sym_preproc_error] = STATE(181),
    [sym_preproc_warning] = STATE(181),
    [sym_preproc_define] = STATE(181),
    [sym_preproc_undef] = STATE(181),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [182] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4485),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(182),
    [sym_preproc_endregion] = STATE(182),
    [sym_preproc_line] = STATE(182),
    [sym_preproc_pragma] = STATE(182),
    [sym_preproc_nullable] = STATE(182),
    [sym_preproc_error] = STATE(182),
    [sym_preproc_warning] = STATE(182),
    [sym_preproc_define] = STATE(182),
    [sym_preproc_undef] = STATE(182),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [183] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4794),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(183),
    [sym_preproc_endregion] = STATE(183),
    [sym_preproc_line] = STATE(183),
    [sym_preproc_pragma] = STATE(183),
    [sym_preproc_nullable] = STATE(183),
    [sym_preproc_error] = STATE(183),
    [sym_preproc_warning] = STATE(183),
    [sym_preproc_define] = STATE(183),
    [sym_preproc_undef] = STATE(183),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [184] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4585),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(184),
    [sym_preproc_endregion] = STATE(184),
    [sym_preproc_line] = STATE(184),
    [sym_preproc_pragma] = STATE(184),
    [sym_preproc_nullable] = STATE(184),
    [sym_preproc_error] = STATE(184),
    [sym_preproc_warning] = STATE(184),
    [sym_preproc_define] = STATE(184),
    [sym_preproc_undef] = STATE(184),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [185] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5115),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(185),
    [sym_preproc_endregion] = STATE(185),
    [sym_preproc_line] = STATE(185),
    [sym_preproc_pragma] = STATE(185),
    [sym_preproc_nullable] = STATE(185),
    [sym_preproc_error] = STATE(185),
    [sym_preproc_warning] = STATE(185),
    [sym_preproc_define] = STATE(185),
    [sym_preproc_undef] = STATE(185),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1159),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [186] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4942),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(186),
    [sym_preproc_endregion] = STATE(186),
    [sym_preproc_line] = STATE(186),
    [sym_preproc_pragma] = STATE(186),
    [sym_preproc_nullable] = STATE(186),
    [sym_preproc_error] = STATE(186),
    [sym_preproc_warning] = STATE(186),
    [sym_preproc_define] = STATE(186),
    [sym_preproc_undef] = STATE(186),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1229),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [187] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5052),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(187),
    [sym_preproc_endregion] = STATE(187),
    [sym_preproc_line] = STATE(187),
    [sym_preproc_pragma] = STATE(187),
    [sym_preproc_nullable] = STATE(187),
    [sym_preproc_error] = STATE(187),
    [sym_preproc_warning] = STATE(187),
    [sym_preproc_define] = STATE(187),
    [sym_preproc_undef] = STATE(187),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [188] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5004),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(188),
    [sym_preproc_endregion] = STATE(188),
    [sym_preproc_line] = STATE(188),
    [sym_preproc_pragma] = STATE(188),
    [sym_preproc_nullable] = STATE(188),
    [sym_preproc_error] = STATE(188),
    [sym_preproc_warning] = STATE(188),
    [sym_preproc_define] = STATE(188),
    [sym_preproc_undef] = STATE(188),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [189] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5018),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(189),
    [sym_preproc_endregion] = STATE(189),
    [sym_preproc_line] = STATE(189),
    [sym_preproc_pragma] = STATE(189),
    [sym_preproc_nullable] = STATE(189),
    [sym_preproc_error] = STATE(189),
    [sym_preproc_warning] = STATE(189),
    [sym_preproc_define] = STATE(189),
    [sym_preproc_undef] = STATE(189),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(1159),
    [aux_sym_preproc_else_token1] = ACTIONS(1159),
    [aux_sym_preproc_elif_token1] = ACTIONS(1159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [190] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4812),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(190),
    [sym_preproc_endregion] = STATE(190),
    [sym_preproc_line] = STATE(190),
    [sym_preproc_pragma] = STATE(190),
    [sym_preproc_nullable] = STATE(190),
    [sym_preproc_error] = STATE(190),
    [sym_preproc_warning] = STATE(190),
    [sym_preproc_define] = STATE(190),
    [sym_preproc_undef] = STATE(190),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1663),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1159),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [191] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4637),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(191),
    [sym_preproc_endregion] = STATE(191),
    [sym_preproc_line] = STATE(191),
    [sym_preproc_pragma] = STATE(191),
    [sym_preproc_nullable] = STATE(191),
    [sym_preproc_error] = STATE(191),
    [sym_preproc_warning] = STATE(191),
    [sym_preproc_define] = STATE(191),
    [sym_preproc_undef] = STATE(191),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1663),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [192] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5069),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(192),
    [sym_preproc_endregion] = STATE(192),
    [sym_preproc_line] = STATE(192),
    [sym_preproc_pragma] = STATE(192),
    [sym_preproc_nullable] = STATE(192),
    [sym_preproc_error] = STATE(192),
    [sym_preproc_warning] = STATE(192),
    [sym_preproc_define] = STATE(192),
    [sym_preproc_undef] = STATE(192),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1679),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_EQ_GT] = ACTIONS(1159),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [193] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4917),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(193),
    [sym_preproc_endregion] = STATE(193),
    [sym_preproc_line] = STATE(193),
    [sym_preproc_pragma] = STATE(193),
    [sym_preproc_nullable] = STATE(193),
    [sym_preproc_error] = STATE(193),
    [sym_preproc_warning] = STATE(193),
    [sym_preproc_define] = STATE(193),
    [sym_preproc_undef] = STATE(193),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1679),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [194] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(194),
    [sym_preproc_endregion] = STATE(194),
    [sym_preproc_line] = STATE(194),
    [sym_preproc_pragma] = STATE(194),
    [sym_preproc_nullable] = STATE(194),
    [sym_preproc_error] = STATE(194),
    [sym_preproc_warning] = STATE(194),
    [sym_preproc_define] = STATE(194),
    [sym_preproc_undef] = STATE(194),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(6952),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [195] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3710),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(195),
    [sym_preproc_endregion] = STATE(195),
    [sym_preproc_line] = STATE(195),
    [sym_preproc_pragma] = STATE(195),
    [sym_preproc_nullable] = STATE(195),
    [sym_preproc_error] = STATE(195),
    [sym_preproc_warning] = STATE(195),
    [sym_preproc_define] = STATE(195),
    [sym_preproc_undef] = STATE(195),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1705),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [196] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5081),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(196),
    [sym_preproc_endregion] = STATE(196),
    [sym_preproc_line] = STATE(196),
    [sym_preproc_pragma] = STATE(196),
    [sym_preproc_nullable] = STATE(196),
    [sym_preproc_error] = STATE(196),
    [sym_preproc_warning] = STATE(196),
    [sym_preproc_define] = STATE(196),
    [sym_preproc_undef] = STATE(196),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1763),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [197] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4977),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(197),
    [sym_preproc_endregion] = STATE(197),
    [sym_preproc_line] = STATE(197),
    [sym_preproc_pragma] = STATE(197),
    [sym_preproc_nullable] = STATE(197),
    [sym_preproc_error] = STATE(197),
    [sym_preproc_warning] = STATE(197),
    [sym_preproc_define] = STATE(197),
    [sym_preproc_undef] = STATE(197),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1763),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [198] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3682),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(198),
    [sym_preproc_endregion] = STATE(198),
    [sym_preproc_line] = STATE(198),
    [sym_preproc_pragma] = STATE(198),
    [sym_preproc_nullable] = STATE(198),
    [sym_preproc_error] = STATE(198),
    [sym_preproc_warning] = STATE(198),
    [sym_preproc_define] = STATE(198),
    [sym_preproc_undef] = STATE(198),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1781),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [199] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(199),
    [sym_preproc_endregion] = STATE(199),
    [sym_preproc_line] = STATE(199),
    [sym_preproc_pragma] = STATE(199),
    [sym_preproc_nullable] = STATE(199),
    [sym_preproc_error] = STATE(199),
    [sym_preproc_warning] = STATE(199),
    [sym_preproc_define] = STATE(199),
    [sym_preproc_undef] = STATE(199),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(7058),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [200] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(200),
    [sym_preproc_endregion] = STATE(200),
    [sym_preproc_line] = STATE(200),
    [sym_preproc_pragma] = STATE(200),
    [sym_preproc_nullable] = STATE(200),
    [sym_preproc_error] = STATE(200),
    [sym_preproc_warning] = STATE(200),
    [sym_preproc_define] = STATE(200),
    [sym_preproc_undef] = STATE(200),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(6939),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [201] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(201),
    [sym_preproc_endregion] = STATE(201),
    [sym_preproc_line] = STATE(201),
    [sym_preproc_pragma] = STATE(201),
    [sym_preproc_nullable] = STATE(201),
    [sym_preproc_error] = STATE(201),
    [sym_preproc_warning] = STATE(201),
    [sym_preproc_define] = STATE(201),
    [sym_preproc_undef] = STATE(201),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(6854),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [202] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(202),
    [sym_preproc_endregion] = STATE(202),
    [sym_preproc_line] = STATE(202),
    [sym_preproc_pragma] = STATE(202),
    [sym_preproc_nullable] = STATE(202),
    [sym_preproc_error] = STATE(202),
    [sym_preproc_warning] = STATE(202),
    [sym_preproc_define] = STATE(202),
    [sym_preproc_undef] = STATE(202),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(7051),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [203] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3696),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(203),
    [sym_preproc_endregion] = STATE(203),
    [sym_preproc_line] = STATE(203),
    [sym_preproc_pragma] = STATE(203),
    [sym_preproc_nullable] = STATE(203),
    [sym_preproc_error] = STATE(203),
    [sym_preproc_warning] = STATE(203),
    [sym_preproc_define] = STATE(203),
    [sym_preproc_undef] = STATE(203),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1705),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [204] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4887),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(204),
    [sym_preproc_endregion] = STATE(204),
    [sym_preproc_line] = STATE(204),
    [sym_preproc_pragma] = STATE(204),
    [sym_preproc_nullable] = STATE(204),
    [sym_preproc_error] = STATE(204),
    [sym_preproc_warning] = STATE(204),
    [sym_preproc_define] = STATE(204),
    [sym_preproc_undef] = STATE(204),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1797),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [205] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4847),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(205),
    [sym_preproc_endregion] = STATE(205),
    [sym_preproc_line] = STATE(205),
    [sym_preproc_pragma] = STATE(205),
    [sym_preproc_nullable] = STATE(205),
    [sym_preproc_error] = STATE(205),
    [sym_preproc_warning] = STATE(205),
    [sym_preproc_define] = STATE(205),
    [sym_preproc_undef] = STATE(205),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1797),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [206] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3615),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(206),
    [sym_preproc_endregion] = STATE(206),
    [sym_preproc_line] = STATE(206),
    [sym_preproc_pragma] = STATE(206),
    [sym_preproc_nullable] = STATE(206),
    [sym_preproc_error] = STATE(206),
    [sym_preproc_warning] = STATE(206),
    [sym_preproc_define] = STATE(206),
    [sym_preproc_undef] = STATE(206),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1781),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [207] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4677),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(207),
    [sym_preproc_endregion] = STATE(207),
    [sym_preproc_line] = STATE(207),
    [sym_preproc_pragma] = STATE(207),
    [sym_preproc_nullable] = STATE(207),
    [sym_preproc_error] = STATE(207),
    [sym_preproc_warning] = STATE(207),
    [sym_preproc_define] = STATE(207),
    [sym_preproc_undef] = STATE(207),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_list_pattern_repeat1] = STATE(6839),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [208] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4700),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(208),
    [sym_preproc_endregion] = STATE(208),
    [sym_preproc_line] = STATE(208),
    [sym_preproc_pragma] = STATE(208),
    [sym_preproc_nullable] = STATE(208),
    [sym_preproc_error] = STATE(208),
    [sym_preproc_warning] = STATE(208),
    [sym_preproc_define] = STATE(208),
    [sym_preproc_undef] = STATE(208),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_interpolation_close_brace] = ACTIONS(1159),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [209] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4138),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(209),
    [sym_preproc_endregion] = STATE(209),
    [sym_preproc_line] = STATE(209),
    [sym_preproc_pragma] = STATE(209),
    [sym_preproc_nullable] = STATE(209),
    [sym_preproc_error] = STATE(209),
    [sym_preproc_warning] = STATE(209),
    [sym_preproc_define] = STATE(209),
    [sym_preproc_undef] = STATE(209),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1815),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1815),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [210] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5058),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(210),
    [sym_preproc_endregion] = STATE(210),
    [sym_preproc_line] = STATE(210),
    [sym_preproc_pragma] = STATE(210),
    [sym_preproc_nullable] = STATE(210),
    [sym_preproc_error] = STATE(210),
    [sym_preproc_warning] = STATE(210),
    [sym_preproc_define] = STATE(210),
    [sym_preproc_undef] = STATE(210),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1833),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [211] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5074),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(211),
    [sym_preproc_endregion] = STATE(211),
    [sym_preproc_line] = STATE(211),
    [sym_preproc_pragma] = STATE(211),
    [sym_preproc_nullable] = STATE(211),
    [sym_preproc_error] = STATE(211),
    [sym_preproc_warning] = STATE(211),
    [sym_preproc_define] = STATE(211),
    [sym_preproc_undef] = STATE(211),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1833),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [212] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4811),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(212),
    [sym_preproc_endregion] = STATE(212),
    [sym_preproc_line] = STATE(212),
    [sym_preproc_pragma] = STATE(212),
    [sym_preproc_nullable] = STATE(212),
    [sym_preproc_error] = STATE(212),
    [sym_preproc_warning] = STATE(212),
    [sym_preproc_define] = STATE(212),
    [sym_preproc_undef] = STATE(212),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [213] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4627),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(213),
    [sym_preproc_endregion] = STATE(213),
    [sym_preproc_line] = STATE(213),
    [sym_preproc_pragma] = STATE(213),
    [sym_preproc_nullable] = STATE(213),
    [sym_preproc_error] = STATE(213),
    [sym_preproc_warning] = STATE(213),
    [sym_preproc_define] = STATE(213),
    [sym_preproc_undef] = STATE(213),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [214] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5061),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(214),
    [sym_preproc_endregion] = STATE(214),
    [sym_preproc_line] = STATE(214),
    [sym_preproc_pragma] = STATE(214),
    [sym_preproc_nullable] = STATE(214),
    [sym_preproc_error] = STATE(214),
    [sym_preproc_warning] = STATE(214),
    [sym_preproc_define] = STATE(214),
    [sym_preproc_undef] = STATE(214),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [215] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5101),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(215),
    [sym_preproc_endregion] = STATE(215),
    [sym_preproc_line] = STATE(215),
    [sym_preproc_pragma] = STATE(215),
    [sym_preproc_nullable] = STATE(215),
    [sym_preproc_error] = STATE(215),
    [sym_preproc_warning] = STATE(215),
    [sym_preproc_define] = STATE(215),
    [sym_preproc_undef] = STATE(215),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [216] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4590),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(216),
    [sym_preproc_endregion] = STATE(216),
    [sym_preproc_line] = STATE(216),
    [sym_preproc_pragma] = STATE(216),
    [sym_preproc_nullable] = STATE(216),
    [sym_preproc_error] = STATE(216),
    [sym_preproc_warning] = STATE(216),
    [sym_preproc_define] = STATE(216),
    [sym_preproc_undef] = STATE(216),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1887),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1887),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [217] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5018),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(217),
    [sym_preproc_endregion] = STATE(217),
    [sym_preproc_line] = STATE(217),
    [sym_preproc_pragma] = STATE(217),
    [sym_preproc_nullable] = STATE(217),
    [sym_preproc_error] = STATE(217),
    [sym_preproc_warning] = STATE(217),
    [sym_preproc_define] = STATE(217),
    [sym_preproc_undef] = STATE(217),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1899),
    [anon_sym_RBRACK] = ACTIONS(1899),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [218] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4117),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(218),
    [sym_preproc_endregion] = STATE(218),
    [sym_preproc_line] = STATE(218),
    [sym_preproc_pragma] = STATE(218),
    [sym_preproc_nullable] = STATE(218),
    [sym_preproc_error] = STATE(218),
    [sym_preproc_warning] = STATE(218),
    [sym_preproc_define] = STATE(218),
    [sym_preproc_undef] = STATE(218),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1815),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1815),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [219] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5065),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(219),
    [sym_preproc_endregion] = STATE(219),
    [sym_preproc_line] = STATE(219),
    [sym_preproc_pragma] = STATE(219),
    [sym_preproc_nullable] = STATE(219),
    [sym_preproc_error] = STATE(219),
    [sym_preproc_warning] = STATE(219),
    [sym_preproc_define] = STATE(219),
    [sym_preproc_undef] = STATE(219),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1907),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [220] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5153),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(220),
    [sym_preproc_endregion] = STATE(220),
    [sym_preproc_line] = STATE(220),
    [sym_preproc_pragma] = STATE(220),
    [sym_preproc_nullable] = STATE(220),
    [sym_preproc_error] = STATE(220),
    [sym_preproc_warning] = STATE(220),
    [sym_preproc_define] = STATE(220),
    [sym_preproc_undef] = STATE(220),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1907),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [221] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4807),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(221),
    [sym_preproc_endregion] = STATE(221),
    [sym_preproc_line] = STATE(221),
    [sym_preproc_pragma] = STATE(221),
    [sym_preproc_nullable] = STATE(221),
    [sym_preproc_error] = STATE(221),
    [sym_preproc_warning] = STATE(221),
    [sym_preproc_define] = STATE(221),
    [sym_preproc_undef] = STATE(221),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1925),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [222] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4603),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(222),
    [sym_preproc_endregion] = STATE(222),
    [sym_preproc_line] = STATE(222),
    [sym_preproc_pragma] = STATE(222),
    [sym_preproc_nullable] = STATE(222),
    [sym_preproc_error] = STATE(222),
    [sym_preproc_warning] = STATE(222),
    [sym_preproc_define] = STATE(222),
    [sym_preproc_undef] = STATE(222),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1925),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [223] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4049),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(223),
    [sym_preproc_endregion] = STATE(223),
    [sym_preproc_line] = STATE(223),
    [sym_preproc_pragma] = STATE(223),
    [sym_preproc_nullable] = STATE(223),
    [sym_preproc_error] = STATE(223),
    [sym_preproc_warning] = STATE(223),
    [sym_preproc_define] = STATE(223),
    [sym_preproc_undef] = STATE(223),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [224] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4796),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(224),
    [sym_preproc_endregion] = STATE(224),
    [sym_preproc_line] = STATE(224),
    [sym_preproc_pragma] = STATE(224),
    [sym_preproc_nullable] = STATE(224),
    [sym_preproc_error] = STATE(224),
    [sym_preproc_warning] = STATE(224),
    [sym_preproc_define] = STATE(224),
    [sym_preproc_undef] = STATE(224),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1887),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1887),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [225] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4068),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(225),
    [sym_preproc_endregion] = STATE(225),
    [sym_preproc_line] = STATE(225),
    [sym_preproc_pragma] = STATE(225),
    [sym_preproc_nullable] = STATE(225),
    [sym_preproc_error] = STATE(225),
    [sym_preproc_warning] = STATE(225),
    [sym_preproc_define] = STATE(225),
    [sym_preproc_undef] = STATE(225),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [226] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6858),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(4605),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(226),
    [sym_preproc_endregion] = STATE(226),
    [sym_preproc_line] = STATE(226),
    [sym_preproc_pragma] = STATE(226),
    [sym_preproc_nullable] = STATE(226),
    [sym_preproc_error] = STATE(226),
    [sym_preproc_warning] = STATE(226),
    [sym_preproc_define] = STATE(226),
    [sym_preproc_undef] = STATE(226),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1959),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [227] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3771),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(227),
    [sym_preproc_endregion] = STATE(227),
    [sym_preproc_line] = STATE(227),
    [sym_preproc_pragma] = STATE(227),
    [sym_preproc_nullable] = STATE(227),
    [sym_preproc_error] = STATE(227),
    [sym_preproc_warning] = STATE(227),
    [sym_preproc_define] = STATE(227),
    [sym_preproc_undef] = STATE(227),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [228] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7036),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(228),
    [sym_preproc_endregion] = STATE(228),
    [sym_preproc_line] = STATE(228),
    [sym_preproc_pragma] = STATE(228),
    [sym_preproc_nullable] = STATE(228),
    [sym_preproc_error] = STATE(228),
    [sym_preproc_warning] = STATE(228),
    [sym_preproc_define] = STATE(228),
    [sym_preproc_undef] = STATE(228),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [229] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5619),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(229),
    [sym_preproc_endregion] = STATE(229),
    [sym_preproc_line] = STATE(229),
    [sym_preproc_pragma] = STATE(229),
    [sym_preproc_nullable] = STATE(229),
    [sym_preproc_error] = STATE(229),
    [sym_preproc_warning] = STATE(229),
    [sym_preproc_define] = STATE(229),
    [sym_preproc_undef] = STATE(229),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [230] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6858),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(4605),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(230),
    [sym_preproc_endregion] = STATE(230),
    [sym_preproc_line] = STATE(230),
    [sym_preproc_pragma] = STATE(230),
    [sym_preproc_nullable] = STATE(230),
    [sym_preproc_error] = STATE(230),
    [sym_preproc_warning] = STATE(230),
    [sym_preproc_define] = STATE(230),
    [sym_preproc_undef] = STATE(230),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [231] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6858),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(231),
    [sym_preproc_endregion] = STATE(231),
    [sym_preproc_line] = STATE(231),
    [sym_preproc_pragma] = STATE(231),
    [sym_preproc_nullable] = STATE(231),
    [sym_preproc_error] = STATE(231),
    [sym_preproc_warning] = STATE(231),
    [sym_preproc_define] = STATE(231),
    [sym_preproc_undef] = STATE(231),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [232] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5197),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(232),
    [sym_preproc_endregion] = STATE(232),
    [sym_preproc_line] = STATE(232),
    [sym_preproc_pragma] = STATE(232),
    [sym_preproc_nullable] = STATE(232),
    [sym_preproc_error] = STATE(232),
    [sym_preproc_warning] = STATE(232),
    [sym_preproc_define] = STATE(232),
    [sym_preproc_undef] = STATE(232),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_EQ_GT] = ACTIONS(1159),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [233] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5191),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(233),
    [sym_preproc_endregion] = STATE(233),
    [sym_preproc_line] = STATE(233),
    [sym_preproc_pragma] = STATE(233),
    [sym_preproc_nullable] = STATE(233),
    [sym_preproc_error] = STATE(233),
    [sym_preproc_warning] = STATE(233),
    [sym_preproc_define] = STATE(233),
    [sym_preproc_undef] = STATE(233),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [234] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5383),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(234),
    [sym_preproc_endregion] = STATE(234),
    [sym_preproc_line] = STATE(234),
    [sym_preproc_pragma] = STATE(234),
    [sym_preproc_nullable] = STATE(234),
    [sym_preproc_error] = STATE(234),
    [sym_preproc_warning] = STATE(234),
    [sym_preproc_define] = STATE(234),
    [sym_preproc_undef] = STATE(234),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [235] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7035),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(235),
    [sym_preproc_endregion] = STATE(235),
    [sym_preproc_line] = STATE(235),
    [sym_preproc_pragma] = STATE(235),
    [sym_preproc_nullable] = STATE(235),
    [sym_preproc_error] = STATE(235),
    [sym_preproc_warning] = STATE(235),
    [sym_preproc_define] = STATE(235),
    [sym_preproc_undef] = STATE(235),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2027),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [236] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(6907),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(236),
    [sym_preproc_endregion] = STATE(236),
    [sym_preproc_line] = STATE(236),
    [sym_preproc_pragma] = STATE(236),
    [sym_preproc_nullable] = STATE(236),
    [sym_preproc_error] = STATE(236),
    [sym_preproc_warning] = STATE(236),
    [sym_preproc_define] = STATE(236),
    [sym_preproc_undef] = STATE(236),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [237] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5574),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(237),
    [sym_preproc_endregion] = STATE(237),
    [sym_preproc_line] = STATE(237),
    [sym_preproc_pragma] = STATE(237),
    [sym_preproc_nullable] = STATE(237),
    [sym_preproc_error] = STATE(237),
    [sym_preproc_warning] = STATE(237),
    [sym_preproc_define] = STATE(237),
    [sym_preproc_undef] = STATE(237),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2039),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2039),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_EQ_GT] = ACTIONS(1159),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [238] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5501),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(238),
    [sym_preproc_endregion] = STATE(238),
    [sym_preproc_line] = STATE(238),
    [sym_preproc_pragma] = STATE(238),
    [sym_preproc_nullable] = STATE(238),
    [sym_preproc_error] = STATE(238),
    [sym_preproc_warning] = STATE(238),
    [sym_preproc_define] = STATE(238),
    [sym_preproc_undef] = STATE(238),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2051),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [239] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6909),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(4605),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(239),
    [sym_preproc_endregion] = STATE(239),
    [sym_preproc_line] = STATE(239),
    [sym_preproc_pragma] = STATE(239),
    [sym_preproc_nullable] = STATE(239),
    [sym_preproc_error] = STATE(239),
    [sym_preproc_warning] = STATE(239),
    [sym_preproc_define] = STATE(239),
    [sym_preproc_undef] = STATE(239),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [240] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5664),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(240),
    [sym_preproc_endregion] = STATE(240),
    [sym_preproc_line] = STATE(240),
    [sym_preproc_pragma] = STATE(240),
    [sym_preproc_nullable] = STATE(240),
    [sym_preproc_error] = STATE(240),
    [sym_preproc_warning] = STATE(240),
    [sym_preproc_define] = STATE(240),
    [sym_preproc_undef] = STATE(240),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2039),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2039),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [241] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2241),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6858),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(4605),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(241),
    [sym_preproc_endregion] = STATE(241),
    [sym_preproc_line] = STATE(241),
    [sym_preproc_pragma] = STATE(241),
    [sym_preproc_nullable] = STATE(241),
    [sym_preproc_error] = STATE(241),
    [sym_preproc_warning] = STATE(241),
    [sym_preproc_define] = STATE(241),
    [sym_preproc_undef] = STATE(241),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [242] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(242),
    [sym_preproc_endregion] = STATE(242),
    [sym_preproc_line] = STATE(242),
    [sym_preproc_pragma] = STATE(242),
    [sym_preproc_nullable] = STATE(242),
    [sym_preproc_error] = STATE(242),
    [sym_preproc_warning] = STATE(242),
    [sym_preproc_define] = STATE(242),
    [sym_preproc_undef] = STATE(242),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(2063),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(2063),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_QMARK_QMARK] = ACTIONS(2061),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(2063),
    [anon_sym_is] = ACTIONS(2063),
    [anon_sym_DASH_GT] = ACTIONS(2061),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(2063),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [243] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5411),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(243),
    [sym_preproc_endregion] = STATE(243),
    [sym_preproc_line] = STATE(243),
    [sym_preproc_pragma] = STATE(243),
    [sym_preproc_nullable] = STATE(243),
    [sym_preproc_error] = STATE(243),
    [sym_preproc_warning] = STATE(243),
    [sym_preproc_define] = STATE(243),
    [sym_preproc_undef] = STATE(243),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(79),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [244] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(244),
    [sym_preproc_endregion] = STATE(244),
    [sym_preproc_line] = STATE(244),
    [sym_preproc_pragma] = STATE(244),
    [sym_preproc_nullable] = STATE(244),
    [sym_preproc_error] = STATE(244),
    [sym_preproc_warning] = STATE(244),
    [sym_preproc_define] = STATE(244),
    [sym_preproc_undef] = STATE(244),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2071),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [245] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5536),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(245),
    [sym_preproc_endregion] = STATE(245),
    [sym_preproc_line] = STATE(245),
    [sym_preproc_pragma] = STATE(245),
    [sym_preproc_nullable] = STATE(245),
    [sym_preproc_error] = STATE(245),
    [sym_preproc_warning] = STATE(245),
    [sym_preproc_define] = STATE(245),
    [sym_preproc_undef] = STATE(245),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2071),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [246] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(6827),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(246),
    [sym_preproc_endregion] = STATE(246),
    [sym_preproc_line] = STATE(246),
    [sym_preproc_pragma] = STATE(246),
    [sym_preproc_nullable] = STATE(246),
    [sym_preproc_error] = STATE(246),
    [sym_preproc_warning] = STATE(246),
    [sym_preproc_define] = STATE(246),
    [sym_preproc_undef] = STATE(246),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [247] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2286),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4597),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6789),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5423),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4599),
    [sym_postfix_unary_expression] = STATE(4604),
    [sym_prefix_unary_expression] = STATE(4604),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4599),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4604),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4599),
    [sym_member_access_expression] = STATE(3212),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4604),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6809),
    [sym_default_expression] = STATE(4599),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4599),
    [sym_typeof_expression] = STATE(4599),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3212),
    [sym_literal] = STATE(4599),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(247),
    [sym_preproc_endregion] = STATE(247),
    [sym_preproc_line] = STATE(247),
    [sym_preproc_pragma] = STATE(247),
    [sym_preproc_nullable] = STATE(247),
    [sym_preproc_error] = STATE(247),
    [sym_preproc_warning] = STATE(247),
    [sym_preproc_define] = STATE(247),
    [sym_preproc_undef] = STATE(247),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_out] = ACTIONS(2081),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [248] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(6904),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(248),
    [sym_preproc_endregion] = STATE(248),
    [sym_preproc_line] = STATE(248),
    [sym_preproc_pragma] = STATE(248),
    [sym_preproc_nullable] = STATE(248),
    [sym_preproc_error] = STATE(248),
    [sym_preproc_warning] = STATE(248),
    [sym_preproc_define] = STATE(248),
    [sym_preproc_undef] = STATE(248),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2087),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [249] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3990),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(249),
    [sym_preproc_endregion] = STATE(249),
    [sym_preproc_line] = STATE(249),
    [sym_preproc_pragma] = STATE(249),
    [sym_preproc_nullable] = STATE(249),
    [sym_preproc_error] = STATE(249),
    [sym_preproc_warning] = STATE(249),
    [sym_preproc_define] = STATE(249),
    [sym_preproc_undef] = STATE(249),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [250] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(6887),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(250),
    [sym_preproc_endregion] = STATE(250),
    [sym_preproc_line] = STATE(250),
    [sym_preproc_pragma] = STATE(250),
    [sym_preproc_nullable] = STATE(250),
    [sym_preproc_error] = STATE(250),
    [sym_preproc_warning] = STATE(250),
    [sym_preproc_define] = STATE(250),
    [sym_preproc_undef] = STATE(250),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [251] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5699),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(251),
    [sym_preproc_endregion] = STATE(251),
    [sym_preproc_line] = STATE(251),
    [sym_preproc_pragma] = STATE(251),
    [sym_preproc_nullable] = STATE(251),
    [sym_preproc_error] = STATE(251),
    [sym_preproc_warning] = STATE(251),
    [sym_preproc_define] = STATE(251),
    [sym_preproc_undef] = STATE(251),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [252] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5610),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(252),
    [sym_preproc_endregion] = STATE(252),
    [sym_preproc_line] = STATE(252),
    [sym_preproc_pragma] = STATE(252),
    [sym_preproc_nullable] = STATE(252),
    [sym_preproc_error] = STATE(252),
    [sym_preproc_warning] = STATE(252),
    [sym_preproc_define] = STATE(252),
    [sym_preproc_undef] = STATE(252),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [253] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5354),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(253),
    [sym_preproc_endregion] = STATE(253),
    [sym_preproc_line] = STATE(253),
    [sym_preproc_pragma] = STATE(253),
    [sym_preproc_nullable] = STATE(253),
    [sym_preproc_error] = STATE(253),
    [sym_preproc_warning] = STATE(253),
    [sym_preproc_define] = STATE(253),
    [sym_preproc_undef] = STATE(253),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2127),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [254] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5232),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(254),
    [sym_preproc_endregion] = STATE(254),
    [sym_preproc_line] = STATE(254),
    [sym_preproc_pragma] = STATE(254),
    [sym_preproc_nullable] = STATE(254),
    [sym_preproc_error] = STATE(254),
    [sym_preproc_warning] = STATE(254),
    [sym_preproc_define] = STATE(254),
    [sym_preproc_undef] = STATE(254),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2127),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [255] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4096),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(255),
    [sym_preproc_endregion] = STATE(255),
    [sym_preproc_line] = STATE(255),
    [sym_preproc_pragma] = STATE(255),
    [sym_preproc_nullable] = STATE(255),
    [sym_preproc_error] = STATE(255),
    [sym_preproc_warning] = STATE(255),
    [sym_preproc_define] = STATE(255),
    [sym_preproc_undef] = STATE(255),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [256] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6909),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(256),
    [sym_preproc_endregion] = STATE(256),
    [sym_preproc_line] = STATE(256),
    [sym_preproc_pragma] = STATE(256),
    [sym_preproc_nullable] = STATE(256),
    [sym_preproc_error] = STATE(256),
    [sym_preproc_warning] = STATE(256),
    [sym_preproc_define] = STATE(256),
    [sym_preproc_undef] = STATE(256),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [257] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3762),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(257),
    [sym_preproc_endregion] = STATE(257),
    [sym_preproc_line] = STATE(257),
    [sym_preproc_pragma] = STATE(257),
    [sym_preproc_nullable] = STATE(257),
    [sym_preproc_error] = STATE(257),
    [sym_preproc_warning] = STATE(257),
    [sym_preproc_define] = STATE(257),
    [sym_preproc_undef] = STATE(257),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [258] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(258),
    [sym_preproc_endregion] = STATE(258),
    [sym_preproc_line] = STATE(258),
    [sym_preproc_pragma] = STATE(258),
    [sym_preproc_nullable] = STATE(258),
    [sym_preproc_error] = STATE(258),
    [sym_preproc_warning] = STATE(258),
    [sym_preproc_define] = STATE(258),
    [sym_preproc_undef] = STATE(258),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [259] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4178),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(259),
    [sym_preproc_endregion] = STATE(259),
    [sym_preproc_line] = STATE(259),
    [sym_preproc_pragma] = STATE(259),
    [sym_preproc_nullable] = STATE(259),
    [sym_preproc_error] = STATE(259),
    [sym_preproc_warning] = STATE(259),
    [sym_preproc_define] = STATE(259),
    [sym_preproc_undef] = STATE(259),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [260] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5322),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(260),
    [sym_preproc_endregion] = STATE(260),
    [sym_preproc_line] = STATE(260),
    [sym_preproc_pragma] = STATE(260),
    [sym_preproc_nullable] = STATE(260),
    [sym_preproc_error] = STATE(260),
    [sym_preproc_warning] = STATE(260),
    [sym_preproc_define] = STATE(260),
    [sym_preproc_undef] = STATE(260),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2165),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [261] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5334),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(261),
    [sym_preproc_endregion] = STATE(261),
    [sym_preproc_line] = STATE(261),
    [sym_preproc_pragma] = STATE(261),
    [sym_preproc_nullable] = STATE(261),
    [sym_preproc_error] = STATE(261),
    [sym_preproc_warning] = STATE(261),
    [sym_preproc_define] = STATE(261),
    [sym_preproc_undef] = STATE(261),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2165),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [262] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(262),
    [sym_preproc_endregion] = STATE(262),
    [sym_preproc_line] = STATE(262),
    [sym_preproc_pragma] = STATE(262),
    [sym_preproc_nullable] = STATE(262),
    [sym_preproc_error] = STATE(262),
    [sym_preproc_warning] = STATE(262),
    [sym_preproc_define] = STATE(262),
    [sym_preproc_undef] = STATE(262),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2177),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [263] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5570),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(263),
    [sym_preproc_endregion] = STATE(263),
    [sym_preproc_line] = STATE(263),
    [sym_preproc_pragma] = STATE(263),
    [sym_preproc_nullable] = STATE(263),
    [sym_preproc_error] = STATE(263),
    [sym_preproc_warning] = STATE(263),
    [sym_preproc_define] = STATE(263),
    [sym_preproc_undef] = STATE(263),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2185),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2185),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [264] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4227),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(264),
    [sym_preproc_endregion] = STATE(264),
    [sym_preproc_line] = STATE(264),
    [sym_preproc_pragma] = STATE(264),
    [sym_preproc_nullable] = STATE(264),
    [sym_preproc_error] = STATE(264),
    [sym_preproc_warning] = STATE(264),
    [sym_preproc_define] = STATE(264),
    [sym_preproc_undef] = STATE(264),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [265] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(265),
    [sym_preproc_endregion] = STATE(265),
    [sym_preproc_line] = STATE(265),
    [sym_preproc_pragma] = STATE(265),
    [sym_preproc_nullable] = STATE(265),
    [sym_preproc_error] = STATE(265),
    [sym_preproc_warning] = STATE(265),
    [sym_preproc_define] = STATE(265),
    [sym_preproc_undef] = STATE(265),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [266] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4172),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(266),
    [sym_preproc_endregion] = STATE(266),
    [sym_preproc_line] = STATE(266),
    [sym_preproc_pragma] = STATE(266),
    [sym_preproc_nullable] = STATE(266),
    [sym_preproc_error] = STATE(266),
    [sym_preproc_warning] = STATE(266),
    [sym_preproc_define] = STATE(266),
    [sym_preproc_undef] = STATE(266),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2149),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [267] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5546),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(267),
    [sym_preproc_endregion] = STATE(267),
    [sym_preproc_line] = STATE(267),
    [sym_preproc_pragma] = STATE(267),
    [sym_preproc_nullable] = STATE(267),
    [sym_preproc_error] = STATE(267),
    [sym_preproc_warning] = STATE(267),
    [sym_preproc_define] = STATE(267),
    [sym_preproc_undef] = STATE(267),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [268] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(268),
    [sym_preproc_endregion] = STATE(268),
    [sym_preproc_line] = STATE(268),
    [sym_preproc_pragma] = STATE(268),
    [sym_preproc_nullable] = STATE(268),
    [sym_preproc_error] = STATE(268),
    [sym_preproc_warning] = STATE(268),
    [sym_preproc_define] = STATE(268),
    [sym_preproc_undef] = STATE(268),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [269] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5194),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(269),
    [sym_preproc_endregion] = STATE(269),
    [sym_preproc_line] = STATE(269),
    [sym_preproc_pragma] = STATE(269),
    [sym_preproc_nullable] = STATE(269),
    [sym_preproc_error] = STATE(269),
    [sym_preproc_warning] = STATE(269),
    [sym_preproc_define] = STATE(269),
    [sym_preproc_undef] = STATE(269),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [270] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4253),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(270),
    [sym_preproc_endregion] = STATE(270),
    [sym_preproc_line] = STATE(270),
    [sym_preproc_pragma] = STATE(270),
    [sym_preproc_nullable] = STATE(270),
    [sym_preproc_error] = STATE(270),
    [sym_preproc_warning] = STATE(270),
    [sym_preproc_define] = STATE(270),
    [sym_preproc_undef] = STATE(270),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [271] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5670),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(271),
    [sym_preproc_endregion] = STATE(271),
    [sym_preproc_line] = STATE(271),
    [sym_preproc_pragma] = STATE(271),
    [sym_preproc_nullable] = STATE(271),
    [sym_preproc_error] = STATE(271),
    [sym_preproc_warning] = STATE(271),
    [sym_preproc_define] = STATE(271),
    [sym_preproc_undef] = STATE(271),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [272] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(272),
    [sym_preproc_endregion] = STATE(272),
    [sym_preproc_line] = STATE(272),
    [sym_preproc_pragma] = STATE(272),
    [sym_preproc_nullable] = STATE(272),
    [sym_preproc_error] = STATE(272),
    [sym_preproc_warning] = STATE(272),
    [sym_preproc_define] = STATE(272),
    [sym_preproc_undef] = STATE(272),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [273] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6927),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(273),
    [sym_preproc_endregion] = STATE(273),
    [sym_preproc_line] = STATE(273),
    [sym_preproc_pragma] = STATE(273),
    [sym_preproc_nullable] = STATE(273),
    [sym_preproc_error] = STATE(273),
    [sym_preproc_warning] = STATE(273),
    [sym_preproc_define] = STATE(273),
    [sym_preproc_undef] = STATE(273),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [274] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(274),
    [sym_preproc_endregion] = STATE(274),
    [sym_preproc_line] = STATE(274),
    [sym_preproc_pragma] = STATE(274),
    [sym_preproc_nullable] = STATE(274),
    [sym_preproc_error] = STATE(274),
    [sym_preproc_warning] = STATE(274),
    [sym_preproc_define] = STATE(274),
    [sym_preproc_undef] = STATE(274),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [275] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5530),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(275),
    [sym_preproc_endregion] = STATE(275),
    [sym_preproc_line] = STATE(275),
    [sym_preproc_pragma] = STATE(275),
    [sym_preproc_nullable] = STATE(275),
    [sym_preproc_error] = STATE(275),
    [sym_preproc_warning] = STATE(275),
    [sym_preproc_define] = STATE(275),
    [sym_preproc_undef] = STATE(275),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [276] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(276),
    [sym_preproc_endregion] = STATE(276),
    [sym_preproc_line] = STATE(276),
    [sym_preproc_pragma] = STATE(276),
    [sym_preproc_nullable] = STATE(276),
    [sym_preproc_error] = STATE(276),
    [sym_preproc_warning] = STATE(276),
    [sym_preproc_define] = STATE(276),
    [sym_preproc_undef] = STATE(276),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2273),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [277] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6927),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(277),
    [sym_preproc_endregion] = STATE(277),
    [sym_preproc_line] = STATE(277),
    [sym_preproc_pragma] = STATE(277),
    [sym_preproc_nullable] = STATE(277),
    [sym_preproc_error] = STATE(277),
    [sym_preproc_warning] = STATE(277),
    [sym_preproc_define] = STATE(277),
    [sym_preproc_undef] = STATE(277),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [278] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(278),
    [sym_preproc_endregion] = STATE(278),
    [sym_preproc_line] = STATE(278),
    [sym_preproc_pragma] = STATE(278),
    [sym_preproc_nullable] = STATE(278),
    [sym_preproc_error] = STATE(278),
    [sym_preproc_warning] = STATE(278),
    [sym_preproc_define] = STATE(278),
    [sym_preproc_undef] = STATE(278),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2277),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [279] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5360),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(279),
    [sym_preproc_endregion] = STATE(279),
    [sym_preproc_line] = STATE(279),
    [sym_preproc_pragma] = STATE(279),
    [sym_preproc_nullable] = STATE(279),
    [sym_preproc_error] = STATE(279),
    [sym_preproc_warning] = STATE(279),
    [sym_preproc_define] = STATE(279),
    [sym_preproc_undef] = STATE(279),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2285),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2285),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [280] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5261),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(280),
    [sym_preproc_endregion] = STATE(280),
    [sym_preproc_line] = STATE(280),
    [sym_preproc_pragma] = STATE(280),
    [sym_preproc_nullable] = STATE(280),
    [sym_preproc_error] = STATE(280),
    [sym_preproc_warning] = STATE(280),
    [sym_preproc_define] = STATE(280),
    [sym_preproc_undef] = STATE(280),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2285),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2285),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [281] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(281),
    [sym_preproc_endregion] = STATE(281),
    [sym_preproc_line] = STATE(281),
    [sym_preproc_pragma] = STATE(281),
    [sym_preproc_nullable] = STATE(281),
    [sym_preproc_error] = STATE(281),
    [sym_preproc_warning] = STATE(281),
    [sym_preproc_define] = STATE(281),
    [sym_preproc_undef] = STATE(281),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2297),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [282] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5598),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(282),
    [sym_preproc_endregion] = STATE(282),
    [sym_preproc_line] = STATE(282),
    [sym_preproc_pragma] = STATE(282),
    [sym_preproc_nullable] = STATE(282),
    [sym_preproc_error] = STATE(282),
    [sym_preproc_warning] = STATE(282),
    [sym_preproc_define] = STATE(282),
    [sym_preproc_undef] = STATE(282),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2185),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(2185),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1231),
    [anon_sym_DASH_GT] = ACTIONS(1229),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [283] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(283),
    [sym_preproc_endregion] = STATE(283),
    [sym_preproc_line] = STATE(283),
    [sym_preproc_pragma] = STATE(283),
    [sym_preproc_nullable] = STATE(283),
    [sym_preproc_error] = STATE(283),
    [sym_preproc_warning] = STATE(283),
    [sym_preproc_define] = STATE(283),
    [sym_preproc_undef] = STATE(283),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [284] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(284),
    [sym_preproc_endregion] = STATE(284),
    [sym_preproc_line] = STATE(284),
    [sym_preproc_pragma] = STATE(284),
    [sym_preproc_nullable] = STATE(284),
    [sym_preproc_error] = STATE(284),
    [sym_preproc_warning] = STATE(284),
    [sym_preproc_define] = STATE(284),
    [sym_preproc_undef] = STATE(284),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [285] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6927),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(285),
    [sym_preproc_endregion] = STATE(285),
    [sym_preproc_line] = STATE(285),
    [sym_preproc_pragma] = STATE(285),
    [sym_preproc_nullable] = STATE(285),
    [sym_preproc_error] = STATE(285),
    [sym_preproc_warning] = STATE(285),
    [sym_preproc_define] = STATE(285),
    [sym_preproc_undef] = STATE(285),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2303),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [286] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(286),
    [sym_preproc_endregion] = STATE(286),
    [sym_preproc_line] = STATE(286),
    [sym_preproc_pragma] = STATE(286),
    [sym_preproc_nullable] = STATE(286),
    [sym_preproc_error] = STATE(286),
    [sym_preproc_warning] = STATE(286),
    [sym_preproc_define] = STATE(286),
    [sym_preproc_undef] = STATE(286),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [287] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6927),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(287),
    [sym_preproc_endregion] = STATE(287),
    [sym_preproc_line] = STATE(287),
    [sym_preproc_pragma] = STATE(287),
    [sym_preproc_nullable] = STATE(287),
    [sym_preproc_error] = STATE(287),
    [sym_preproc_warning] = STATE(287),
    [sym_preproc_define] = STATE(287),
    [sym_preproc_undef] = STATE(287),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [288] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(288),
    [sym_preproc_endregion] = STATE(288),
    [sym_preproc_line] = STATE(288),
    [sym_preproc_pragma] = STATE(288),
    [sym_preproc_nullable] = STATE(288),
    [sym_preproc_error] = STATE(288),
    [sym_preproc_warning] = STATE(288),
    [sym_preproc_define] = STATE(288),
    [sym_preproc_undef] = STATE(288),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(2309),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [289] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5184),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(289),
    [sym_preproc_endregion] = STATE(289),
    [sym_preproc_line] = STATE(289),
    [sym_preproc_pragma] = STATE(289),
    [sym_preproc_nullable] = STATE(289),
    [sym_preproc_error] = STATE(289),
    [sym_preproc_warning] = STATE(289),
    [sym_preproc_define] = STATE(289),
    [sym_preproc_undef] = STATE(289),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_QMARK] = ACTIONS(1173),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_is] = ACTIONS(1173),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [290] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(290),
    [sym_preproc_endregion] = STATE(290),
    [sym_preproc_line] = STATE(290),
    [sym_preproc_pragma] = STATE(290),
    [sym_preproc_nullable] = STATE(290),
    [sym_preproc_error] = STATE(290),
    [sym_preproc_warning] = STATE(290),
    [sym_preproc_define] = STATE(290),
    [sym_preproc_undef] = STATE(290),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [291] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_variable_declaration] = STATE(7498),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5899),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(291),
    [sym_preproc_endregion] = STATE(291),
    [sym_preproc_line] = STATE(291),
    [sym_preproc_pragma] = STATE(291),
    [sym_preproc_nullable] = STATE(291),
    [sym_preproc_error] = STATE(291),
    [sym_preproc_warning] = STATE(291),
    [sym_preproc_define] = STATE(291),
    [sym_preproc_undef] = STATE(291),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2564),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(2317),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_foreach] = ACTIONS(2321),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [292] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(292),
    [sym_preproc_endregion] = STATE(292),
    [sym_preproc_line] = STATE(292),
    [sym_preproc_pragma] = STATE(292),
    [sym_preproc_nullable] = STATE(292),
    [sym_preproc_error] = STATE(292),
    [sym_preproc_warning] = STATE(292),
    [sym_preproc_define] = STATE(292),
    [sym_preproc_undef] = STATE(292),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [293] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6673),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_switch_expression_arm] = STATE(7196),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(293),
    [sym_preproc_endregion] = STATE(293),
    [sym_preproc_line] = STATE(293),
    [sym_preproc_pragma] = STATE(293),
    [sym_preproc_nullable] = STATE(293),
    [sym_preproc_error] = STATE(293),
    [sym_preproc_warning] = STATE(293),
    [sym_preproc_define] = STATE(293),
    [sym_preproc_undef] = STATE(293),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [294] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6766),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6927),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5467),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2237),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(294),
    [sym_preproc_endregion] = STATE(294),
    [sym_preproc_line] = STATE(294),
    [sym_preproc_pragma] = STATE(294),
    [sym_preproc_nullable] = STATE(294),
    [sym_preproc_error] = STATE(294),
    [sym_preproc_warning] = STATE(294),
    [sym_preproc_define] = STATE(294),
    [sym_preproc_undef] = STATE(294),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [295] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(295),
    [sym_preproc_endregion] = STATE(295),
    [sym_preproc_line] = STATE(295),
    [sym_preproc_pragma] = STATE(295),
    [sym_preproc_nullable] = STATE(295),
    [sym_preproc_error] = STATE(295),
    [sym_preproc_warning] = STATE(295),
    [sym_preproc_define] = STATE(295),
    [sym_preproc_undef] = STATE(295),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2327),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [296] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_variable_declaration] = STATE(7498),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5899),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(296),
    [sym_preproc_endregion] = STATE(296),
    [sym_preproc_line] = STATE(296),
    [sym_preproc_pragma] = STATE(296),
    [sym_preproc_nullable] = STATE(296),
    [sym_preproc_error] = STATE(296),
    [sym_preproc_warning] = STATE(296),
    [sym_preproc_define] = STATE(296),
    [sym_preproc_undef] = STATE(296),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2564),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(2317),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_foreach] = ACTIONS(2321),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [297] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_variable_declaration] = STATE(7613),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5899),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(297),
    [sym_preproc_endregion] = STATE(297),
    [sym_preproc_line] = STATE(297),
    [sym_preproc_pragma] = STATE(297),
    [sym_preproc_nullable] = STATE(297),
    [sym_preproc_error] = STATE(297),
    [sym_preproc_warning] = STATE(297),
    [sym_preproc_define] = STATE(297),
    [sym_preproc_undef] = STATE(297),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2550),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(2329),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_foreach] = ACTIONS(2321),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [298] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(298),
    [sym_preproc_endregion] = STATE(298),
    [sym_preproc_line] = STATE(298),
    [sym_preproc_pragma] = STATE(298),
    [sym_preproc_nullable] = STATE(298),
    [sym_preproc_error] = STATE(298),
    [sym_preproc_warning] = STATE(298),
    [sym_preproc_define] = STATE(298),
    [sym_preproc_undef] = STATE(298),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2331),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [299] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(299),
    [sym_preproc_endregion] = STATE(299),
    [sym_preproc_line] = STATE(299),
    [sym_preproc_pragma] = STATE(299),
    [sym_preproc_nullable] = STATE(299),
    [sym_preproc_error] = STATE(299),
    [sym_preproc_warning] = STATE(299),
    [sym_preproc_define] = STATE(299),
    [sym_preproc_undef] = STATE(299),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [300] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(300),
    [sym_preproc_endregion] = STATE(300),
    [sym_preproc_line] = STATE(300),
    [sym_preproc_pragma] = STATE(300),
    [sym_preproc_nullable] = STATE(300),
    [sym_preproc_error] = STATE(300),
    [sym_preproc_warning] = STATE(300),
    [sym_preproc_define] = STATE(300),
    [sym_preproc_undef] = STATE(300),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [301] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(301),
    [sym_preproc_endregion] = STATE(301),
    [sym_preproc_line] = STATE(301),
    [sym_preproc_pragma] = STATE(301),
    [sym_preproc_nullable] = STATE(301),
    [sym_preproc_error] = STATE(301),
    [sym_preproc_warning] = STATE(301),
    [sym_preproc_define] = STATE(301),
    [sym_preproc_undef] = STATE(301),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [302] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(302),
    [sym_preproc_endregion] = STATE(302),
    [sym_preproc_line] = STATE(302),
    [sym_preproc_pragma] = STATE(302),
    [sym_preproc_nullable] = STATE(302),
    [sym_preproc_error] = STATE(302),
    [sym_preproc_warning] = STATE(302),
    [sym_preproc_define] = STATE(302),
    [sym_preproc_undef] = STATE(302),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [303] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(303),
    [sym_preproc_endregion] = STATE(303),
    [sym_preproc_line] = STATE(303),
    [sym_preproc_pragma] = STATE(303),
    [sym_preproc_nullable] = STATE(303),
    [sym_preproc_error] = STATE(303),
    [sym_preproc_warning] = STATE(303),
    [sym_preproc_define] = STATE(303),
    [sym_preproc_undef] = STATE(303),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [304] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_variable_declaration] = STATE(7652),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5899),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(304),
    [sym_preproc_endregion] = STATE(304),
    [sym_preproc_line] = STATE(304),
    [sym_preproc_pragma] = STATE(304),
    [sym_preproc_nullable] = STATE(304),
    [sym_preproc_error] = STATE(304),
    [sym_preproc_warning] = STATE(304),
    [sym_preproc_define] = STATE(304),
    [sym_preproc_undef] = STATE(304),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2557),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(2343),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_foreach] = ACTIONS(2321),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [305] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(305),
    [sym_preproc_endregion] = STATE(305),
    [sym_preproc_line] = STATE(305),
    [sym_preproc_pragma] = STATE(305),
    [sym_preproc_nullable] = STATE(305),
    [sym_preproc_error] = STATE(305),
    [sym_preproc_warning] = STATE(305),
    [sym_preproc_define] = STATE(305),
    [sym_preproc_undef] = STATE(305),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2345),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [306] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6697),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_subpattern] = STATE(6927),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2224),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(306),
    [sym_preproc_endregion] = STATE(306),
    [sym_preproc_line] = STATE(306),
    [sym_preproc_pragma] = STATE(306),
    [sym_preproc_nullable] = STATE(306),
    [sym_preproc_error] = STATE(306),
    [sym_preproc_warning] = STATE(306),
    [sym_preproc_define] = STATE(306),
    [sym_preproc_undef] = STATE(306),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [307] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(307),
    [sym_preproc_endregion] = STATE(307),
    [sym_preproc_line] = STATE(307),
    [sym_preproc_pragma] = STATE(307),
    [sym_preproc_nullable] = STATE(307),
    [sym_preproc_error] = STATE(307),
    [sym_preproc_warning] = STATE(307),
    [sym_preproc_define] = STATE(307),
    [sym_preproc_undef] = STATE(307),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [308] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(308),
    [sym_preproc_endregion] = STATE(308),
    [sym_preproc_line] = STATE(308),
    [sym_preproc_pragma] = STATE(308),
    [sym_preproc_nullable] = STATE(308),
    [sym_preproc_error] = STATE(308),
    [sym_preproc_warning] = STATE(308),
    [sym_preproc_define] = STATE(308),
    [sym_preproc_undef] = STATE(308),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2349),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [309] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(309),
    [sym_preproc_endregion] = STATE(309),
    [sym_preproc_line] = STATE(309),
    [sym_preproc_pragma] = STATE(309),
    [sym_preproc_nullable] = STATE(309),
    [sym_preproc_error] = STATE(309),
    [sym_preproc_warning] = STATE(309),
    [sym_preproc_define] = STATE(309),
    [sym_preproc_undef] = STATE(309),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2351),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [310] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(310),
    [sym_preproc_endregion] = STATE(310),
    [sym_preproc_line] = STATE(310),
    [sym_preproc_pragma] = STATE(310),
    [sym_preproc_nullable] = STATE(310),
    [sym_preproc_error] = STATE(310),
    [sym_preproc_warning] = STATE(310),
    [sym_preproc_define] = STATE(310),
    [sym_preproc_undef] = STATE(310),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [311] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym_variable_declaration] = STATE(7491),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5899),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(311),
    [sym_preproc_endregion] = STATE(311),
    [sym_preproc_line] = STATE(311),
    [sym_preproc_pragma] = STATE(311),
    [sym_preproc_nullable] = STATE(311),
    [sym_preproc_error] = STATE(311),
    [sym_preproc_warning] = STATE(311),
    [sym_preproc_define] = STATE(311),
    [sym_preproc_undef] = STATE(311),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2549),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_using] = ACTIONS(2355),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_foreach] = ACTIONS(2321),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [312] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(312),
    [sym_preproc_endregion] = STATE(312),
    [sym_preproc_line] = STATE(312),
    [sym_preproc_pragma] = STATE(312),
    [sym_preproc_nullable] = STATE(312),
    [sym_preproc_error] = STATE(312),
    [sym_preproc_warning] = STATE(312),
    [sym_preproc_define] = STATE(312),
    [sym_preproc_undef] = STATE(312),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [313] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(313),
    [sym_preproc_endregion] = STATE(313),
    [sym_preproc_line] = STATE(313),
    [sym_preproc_pragma] = STATE(313),
    [sym_preproc_nullable] = STATE(313),
    [sym_preproc_error] = STATE(313),
    [sym_preproc_warning] = STATE(313),
    [sym_preproc_define] = STATE(313),
    [sym_preproc_undef] = STATE(313),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(2359),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [314] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4152),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5733),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(314),
    [sym_preproc_endregion] = STATE(314),
    [sym_preproc_line] = STATE(314),
    [sym_preproc_pragma] = STATE(314),
    [sym_preproc_nullable] = STATE(314),
    [sym_preproc_error] = STATE(314),
    [sym_preproc_warning] = STATE(314),
    [sym_preproc_define] = STATE(314),
    [sym_preproc_undef] = STATE(314),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2381),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [315] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6691),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(315),
    [sym_preproc_endregion] = STATE(315),
    [sym_preproc_line] = STATE(315),
    [sym_preproc_pragma] = STATE(315),
    [sym_preproc_nullable] = STATE(315),
    [sym_preproc_error] = STATE(315),
    [sym_preproc_warning] = STATE(315),
    [sym_preproc_define] = STATE(315),
    [sym_preproc_undef] = STATE(315),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [316] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2250),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(316),
    [sym_preproc_endregion] = STATE(316),
    [sym_preproc_line] = STATE(316),
    [sym_preproc_pragma] = STATE(316),
    [sym_preproc_nullable] = STATE(316),
    [sym_preproc_error] = STATE(316),
    [sym_preproc_warning] = STATE(316),
    [sym_preproc_define] = STATE(316),
    [sym_preproc_undef] = STATE(316),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2399),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [317] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2901),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2319),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3944),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2577),
    [sym_property_pattern_clause] = STATE(2654),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5751),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(317),
    [sym_preproc_endregion] = STATE(317),
    [sym_preproc_line] = STATE(317),
    [sym_preproc_pragma] = STATE(317),
    [sym_preproc_nullable] = STATE(317),
    [sym_preproc_error] = STATE(317),
    [sym_preproc_warning] = STATE(317),
    [sym_preproc_define] = STATE(317),
    [sym_preproc_undef] = STATE(317),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(2407),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [318] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2910),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2357),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2523),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5567),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2594),
    [sym_property_pattern_clause] = STATE(2841),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5756),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(318),
    [sym_preproc_endregion] = STATE(318),
    [sym_preproc_line] = STATE(318),
    [sym_preproc_pragma] = STATE(318),
    [sym_preproc_nullable] = STATE(318),
    [sym_preproc_error] = STATE(318),
    [sym_preproc_warning] = STATE(318),
    [sym_preproc_define] = STATE(318),
    [sym_preproc_undef] = STATE(318),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_GT_EQ] = ACTIONS(2421),
    [anon_sym_LT_EQ] = ACTIONS(2421),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [319] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2910),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2357),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2523),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2594),
    [sym_property_pattern_clause] = STATE(2841),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5756),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(319),
    [sym_preproc_endregion] = STATE(319),
    [sym_preproc_line] = STATE(319),
    [sym_preproc_pragma] = STATE(319),
    [sym_preproc_nullable] = STATE(319),
    [sym_preproc_error] = STATE(319),
    [sym_preproc_warning] = STATE(319),
    [sym_preproc_define] = STATE(319),
    [sym_preproc_undef] = STATE(319),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_GT_EQ] = ACTIONS(2421),
    [anon_sym_LT_EQ] = ACTIONS(2421),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [320] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2910),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2357),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2523),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5468),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2594),
    [sym_property_pattern_clause] = STATE(2841),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5756),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(320),
    [sym_preproc_endregion] = STATE(320),
    [sym_preproc_line] = STATE(320),
    [sym_preproc_pragma] = STATE(320),
    [sym_preproc_nullable] = STATE(320),
    [sym_preproc_error] = STATE(320),
    [sym_preproc_warning] = STATE(320),
    [sym_preproc_define] = STATE(320),
    [sym_preproc_undef] = STATE(320),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_GT_EQ] = ACTIONS(2421),
    [anon_sym_LT_EQ] = ACTIONS(2421),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [321] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2908),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2330),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2530),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4174),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2610),
    [sym_property_pattern_clause] = STATE(2691),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(321),
    [sym_preproc_endregion] = STATE(321),
    [sym_preproc_line] = STATE(321),
    [sym_preproc_pragma] = STATE(321),
    [sym_preproc_nullable] = STATE(321),
    [sym_preproc_error] = STATE(321),
    [sym_preproc_warning] = STATE(321),
    [sym_preproc_define] = STATE(321),
    [sym_preproc_undef] = STATE(321),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2433),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [322] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6649),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(322),
    [sym_preproc_endregion] = STATE(322),
    [sym_preproc_line] = STATE(322),
    [sym_preproc_pragma] = STATE(322),
    [sym_preproc_nullable] = STATE(322),
    [sym_preproc_error] = STATE(322),
    [sym_preproc_warning] = STATE(322),
    [sym_preproc_define] = STATE(322),
    [sym_preproc_undef] = STATE(322),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [323] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6560),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(323),
    [sym_preproc_endregion] = STATE(323),
    [sym_preproc_line] = STATE(323),
    [sym_preproc_pragma] = STATE(323),
    [sym_preproc_nullable] = STATE(323),
    [sym_preproc_error] = STATE(323),
    [sym_preproc_warning] = STATE(323),
    [sym_preproc_define] = STATE(323),
    [sym_preproc_undef] = STATE(323),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [324] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2650),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4402),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(324),
    [sym_preproc_endregion] = STATE(324),
    [sym_preproc_line] = STATE(324),
    [sym_preproc_pragma] = STATE(324),
    [sym_preproc_nullable] = STATE(324),
    [sym_preproc_error] = STATE(324),
    [sym_preproc_warning] = STATE(324),
    [sym_preproc_define] = STATE(324),
    [sym_preproc_undef] = STATE(324),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2447),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [325] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2909),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2354),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2518),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4211),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2619),
    [sym_property_pattern_clause] = STATE(2820),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5758),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(325),
    [sym_preproc_endregion] = STATE(325),
    [sym_preproc_line] = STATE(325),
    [sym_preproc_pragma] = STATE(325),
    [sym_preproc_nullable] = STATE(325),
    [sym_preproc_error] = STATE(325),
    [sym_preproc_warning] = STATE(325),
    [sym_preproc_define] = STATE(325),
    [sym_preproc_undef] = STATE(325),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2457),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2459),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [326] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2899),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2327),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2502),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3819),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2574),
    [sym_property_pattern_clause] = STATE(2676),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5710),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(326),
    [sym_preproc_endregion] = STATE(326),
    [sym_preproc_line] = STATE(326),
    [sym_preproc_pragma] = STATE(326),
    [sym_preproc_nullable] = STATE(326),
    [sym_preproc_error] = STATE(326),
    [sym_preproc_warning] = STATE(326),
    [sym_preproc_define] = STATE(326),
    [sym_preproc_undef] = STATE(326),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2467),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [327] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2494),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5493),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2578),
    [sym_property_pattern_clause] = STATE(2672),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5715),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(327),
    [sym_preproc_endregion] = STATE(327),
    [sym_preproc_line] = STATE(327),
    [sym_preproc_pragma] = STATE(327),
    [sym_preproc_nullable] = STATE(327),
    [sym_preproc_error] = STATE(327),
    [sym_preproc_warning] = STATE(327),
    [sym_preproc_define] = STATE(327),
    [sym_preproc_undef] = STATE(327),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2477),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [328] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2901),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2319),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3834),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2577),
    [sym_property_pattern_clause] = STATE(2654),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5751),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(328),
    [sym_preproc_endregion] = STATE(328),
    [sym_preproc_line] = STATE(328),
    [sym_preproc_pragma] = STATE(328),
    [sym_preproc_nullable] = STATE(328),
    [sym_preproc_error] = STATE(328),
    [sym_preproc_warning] = STATE(328),
    [sym_preproc_define] = STATE(328),
    [sym_preproc_undef] = STATE(328),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(2407),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [329] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2650),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(329),
    [sym_preproc_endregion] = STATE(329),
    [sym_preproc_line] = STATE(329),
    [sym_preproc_pragma] = STATE(329),
    [sym_preproc_nullable] = STATE(329),
    [sym_preproc_error] = STATE(329),
    [sym_preproc_warning] = STATE(329),
    [sym_preproc_define] = STATE(329),
    [sym_preproc_undef] = STATE(329),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2447),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [330] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2901),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2319),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4069),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2577),
    [sym_property_pattern_clause] = STATE(2654),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5751),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(330),
    [sym_preproc_endregion] = STATE(330),
    [sym_preproc_line] = STATE(330),
    [sym_preproc_pragma] = STATE(330),
    [sym_preproc_nullable] = STATE(330),
    [sym_preproc_error] = STATE(330),
    [sym_preproc_warning] = STATE(330),
    [sym_preproc_define] = STATE(330),
    [sym_preproc_undef] = STATE(330),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(2407),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [331] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2778),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2260),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2422),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4598),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2527),
    [sym_property_pattern_clause] = STATE(2583),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5713),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(331),
    [sym_preproc_endregion] = STATE(331),
    [sym_preproc_line] = STATE(331),
    [sym_preproc_pragma] = STATE(331),
    [sym_preproc_nullable] = STATE(331),
    [sym_preproc_error] = STATE(331),
    [sym_preproc_warning] = STATE(331),
    [sym_preproc_define] = STATE(331),
    [sym_preproc_undef] = STATE(331),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_GT_EQ] = ACTIONS(2493),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2503),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [332] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6719),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(332),
    [sym_preproc_endregion] = STATE(332),
    [sym_preproc_line] = STATE(332),
    [sym_preproc_pragma] = STATE(332),
    [sym_preproc_nullable] = STATE(332),
    [sym_preproc_error] = STATE(332),
    [sym_preproc_warning] = STATE(332),
    [sym_preproc_define] = STATE(332),
    [sym_preproc_undef] = STATE(332),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(2315),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [333] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2931),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2355),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2519),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5556),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2590),
    [sym_property_pattern_clause] = STATE(2830),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(333),
    [sym_preproc_endregion] = STATE(333),
    [sym_preproc_line] = STATE(333),
    [sym_preproc_pragma] = STATE(333),
    [sym_preproc_nullable] = STATE(333),
    [sym_preproc_error] = STATE(333),
    [sym_preproc_warning] = STATE(333),
    [sym_preproc_define] = STATE(333),
    [sym_preproc_undef] = STATE(333),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2507),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_GT_EQ] = ACTIONS(2509),
    [anon_sym_LT_EQ] = ACTIONS(2509),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [334] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2904),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2485),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5206),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(334),
    [sym_preproc_endregion] = STATE(334),
    [sym_preproc_line] = STATE(334),
    [sym_preproc_pragma] = STATE(334),
    [sym_preproc_nullable] = STATE(334),
    [sym_preproc_error] = STATE(334),
    [sym_preproc_warning] = STATE(334),
    [sym_preproc_define] = STATE(334),
    [sym_preproc_undef] = STATE(334),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [335] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2904),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2485),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(335),
    [sym_preproc_endregion] = STATE(335),
    [sym_preproc_line] = STATE(335),
    [sym_preproc_pragma] = STATE(335),
    [sym_preproc_nullable] = STATE(335),
    [sym_preproc_error] = STATE(335),
    [sym_preproc_warning] = STATE(335),
    [sym_preproc_define] = STATE(335),
    [sym_preproc_undef] = STATE(335),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [336] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2904),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2485),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5263),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(336),
    [sym_preproc_endregion] = STATE(336),
    [sym_preproc_line] = STATE(336),
    [sym_preproc_pragma] = STATE(336),
    [sym_preproc_nullable] = STATE(336),
    [sym_preproc_error] = STATE(336),
    [sym_preproc_warning] = STATE(336),
    [sym_preproc_define] = STATE(336),
    [sym_preproc_undef] = STATE(336),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [337] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2650),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2248),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(337),
    [sym_preproc_endregion] = STATE(337),
    [sym_preproc_line] = STATE(337),
    [sym_preproc_pragma] = STATE(337),
    [sym_preproc_nullable] = STATE(337),
    [sym_preproc_error] = STATE(337),
    [sym_preproc_warning] = STATE(337),
    [sym_preproc_define] = STATE(337),
    [sym_preproc_undef] = STATE(337),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2447),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [338] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4606),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5714),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(338),
    [sym_preproc_endregion] = STATE(338),
    [sym_preproc_line] = STATE(338),
    [sym_preproc_pragma] = STATE(338),
    [sym_preproc_nullable] = STATE(338),
    [sym_preproc_error] = STATE(338),
    [sym_preproc_warning] = STATE(338),
    [sym_preproc_define] = STATE(338),
    [sym_preproc_undef] = STATE(338),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [339] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2494),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2578),
    [sym_property_pattern_clause] = STATE(2672),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5715),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(339),
    [sym_preproc_endregion] = STATE(339),
    [sym_preproc_line] = STATE(339),
    [sym_preproc_pragma] = STATE(339),
    [sym_preproc_nullable] = STATE(339),
    [sym_preproc_error] = STATE(339),
    [sym_preproc_warning] = STATE(339),
    [sym_preproc_define] = STATE(339),
    [sym_preproc_undef] = STATE(339),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2477),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [340] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2494),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5671),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2578),
    [sym_property_pattern_clause] = STATE(2672),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5715),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(340),
    [sym_preproc_endregion] = STATE(340),
    [sym_preproc_line] = STATE(340),
    [sym_preproc_pragma] = STATE(340),
    [sym_preproc_nullable] = STATE(340),
    [sym_preproc_error] = STATE(340),
    [sym_preproc_warning] = STATE(340),
    [sym_preproc_define] = STATE(340),
    [sym_preproc_undef] = STATE(340),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2477),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [341] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2929),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2368),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2534),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5326),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2589),
    [sym_property_pattern_clause] = STATE(2873),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5723),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(341),
    [sym_preproc_endregion] = STATE(341),
    [sym_preproc_line] = STATE(341),
    [sym_preproc_pragma] = STATE(341),
    [sym_preproc_nullable] = STATE(341),
    [sym_preproc_error] = STATE(341),
    [sym_preproc_warning] = STATE(341),
    [sym_preproc_define] = STATE(341),
    [sym_preproc_undef] = STATE(341),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [342] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2901),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2319),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2476),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3976),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2577),
    [sym_property_pattern_clause] = STATE(2654),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5751),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(342),
    [sym_preproc_endregion] = STATE(342),
    [sym_preproc_line] = STATE(342),
    [sym_preproc_pragma] = STATE(342),
    [sym_preproc_nullable] = STATE(342),
    [sym_preproc_error] = STATE(342),
    [sym_preproc_warning] = STATE(342),
    [sym_preproc_define] = STATE(342),
    [sym_preproc_undef] = STATE(342),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(2407),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [343] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5733),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(343),
    [sym_preproc_endregion] = STATE(343),
    [sym_preproc_line] = STATE(343),
    [sym_preproc_pragma] = STATE(343),
    [sym_preproc_nullable] = STATE(343),
    [sym_preproc_error] = STATE(343),
    [sym_preproc_warning] = STATE(343),
    [sym_preproc_define] = STATE(343),
    [sym_preproc_undef] = STATE(343),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2381),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [344] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5733),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(344),
    [sym_preproc_endregion] = STATE(344),
    [sym_preproc_line] = STATE(344),
    [sym_preproc_pragma] = STATE(344),
    [sym_preproc_nullable] = STATE(344),
    [sym_preproc_error] = STATE(344),
    [sym_preproc_warning] = STATE(344),
    [sym_preproc_define] = STATE(344),
    [sym_preproc_undef] = STATE(344),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2381),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [345] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2929),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2368),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2534),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2589),
    [sym_property_pattern_clause] = STATE(2873),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5723),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(345),
    [sym_preproc_endregion] = STATE(345),
    [sym_preproc_line] = STATE(345),
    [sym_preproc_pragma] = STATE(345),
    [sym_preproc_nullable] = STATE(345),
    [sym_preproc_error] = STATE(345),
    [sym_preproc_warning] = STATE(345),
    [sym_preproc_define] = STATE(345),
    [sym_preproc_undef] = STATE(345),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [346] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2910),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2357),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2521),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5565),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2594),
    [sym_property_pattern_clause] = STATE(2841),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5756),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(346),
    [sym_preproc_endregion] = STATE(346),
    [sym_preproc_line] = STATE(346),
    [sym_preproc_pragma] = STATE(346),
    [sym_preproc_nullable] = STATE(346),
    [sym_preproc_error] = STATE(346),
    [sym_preproc_warning] = STATE(346),
    [sym_preproc_define] = STATE(346),
    [sym_preproc_undef] = STATE(346),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_GT_EQ] = ACTIONS(2421),
    [anon_sym_LT_EQ] = ACTIONS(2421),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [347] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2713),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2280),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2390),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(5072),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2516),
    [sym_property_pattern_clause] = STATE(2579),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5712),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(347),
    [sym_preproc_endregion] = STATE(347),
    [sym_preproc_line] = STATE(347),
    [sym_preproc_pragma] = STATE(347),
    [sym_preproc_nullable] = STATE(347),
    [sym_preproc_error] = STATE(347),
    [sym_preproc_warning] = STATE(347),
    [sym_preproc_define] = STATE(347),
    [sym_preproc_undef] = STATE(347),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2543),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [348] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2929),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2368),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2507),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5304),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2589),
    [sym_property_pattern_clause] = STATE(2873),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5723),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(348),
    [sym_preproc_endregion] = STATE(348),
    [sym_preproc_line] = STATE(348),
    [sym_preproc_pragma] = STATE(348),
    [sym_preproc_nullable] = STATE(348),
    [sym_preproc_error] = STATE(348),
    [sym_preproc_warning] = STATE(348),
    [sym_preproc_define] = STATE(348),
    [sym_preproc_undef] = STATE(348),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [349] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2929),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2368),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2534),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5302),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2589),
    [sym_property_pattern_clause] = STATE(2873),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5723),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(349),
    [sym_preproc_endregion] = STATE(349),
    [sym_preproc_line] = STATE(349),
    [sym_preproc_pragma] = STATE(349),
    [sym_preproc_nullable] = STATE(349),
    [sym_preproc_error] = STATE(349),
    [sym_preproc_warning] = STATE(349),
    [sym_preproc_define] = STATE(349),
    [sym_preproc_undef] = STATE(349),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [350] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2650),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4542),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(350),
    [sym_preproc_endregion] = STATE(350),
    [sym_preproc_line] = STATE(350),
    [sym_preproc_pragma] = STATE(350),
    [sym_preproc_nullable] = STATE(350),
    [sym_preproc_error] = STATE(350),
    [sym_preproc_warning] = STATE(350),
    [sym_preproc_define] = STATE(350),
    [sym_preproc_undef] = STATE(350),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2447),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [351] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2713),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2280),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2390),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4862),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2516),
    [sym_property_pattern_clause] = STATE(2579),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5712),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(351),
    [sym_preproc_endregion] = STATE(351),
    [sym_preproc_line] = STATE(351),
    [sym_preproc_pragma] = STATE(351),
    [sym_preproc_nullable] = STATE(351),
    [sym_preproc_error] = STATE(351),
    [sym_preproc_warning] = STATE(351),
    [sym_preproc_define] = STATE(351),
    [sym_preproc_undef] = STATE(351),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2543),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [352] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2713),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2280),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2390),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(5021),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2516),
    [sym_property_pattern_clause] = STATE(2579),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5712),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(352),
    [sym_preproc_endregion] = STATE(352),
    [sym_preproc_line] = STATE(352),
    [sym_preproc_pragma] = STATE(352),
    [sym_preproc_nullable] = STATE(352),
    [sym_preproc_error] = STATE(352),
    [sym_preproc_warning] = STATE(352),
    [sym_preproc_define] = STATE(352),
    [sym_preproc_undef] = STATE(352),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2543),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [353] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2906),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2504),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5351),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(353),
    [sym_preproc_endregion] = STATE(353),
    [sym_preproc_line] = STATE(353),
    [sym_preproc_pragma] = STATE(353),
    [sym_preproc_nullable] = STATE(353),
    [sym_preproc_error] = STATE(353),
    [sym_preproc_warning] = STATE(353),
    [sym_preproc_define] = STATE(353),
    [sym_preproc_undef] = STATE(353),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2551),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [354] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2778),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2260),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2420),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4706),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2527),
    [sym_property_pattern_clause] = STATE(2583),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5713),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(354),
    [sym_preproc_endregion] = STATE(354),
    [sym_preproc_line] = STATE(354),
    [sym_preproc_pragma] = STATE(354),
    [sym_preproc_nullable] = STATE(354),
    [sym_preproc_error] = STATE(354),
    [sym_preproc_warning] = STATE(354),
    [sym_preproc_define] = STATE(354),
    [sym_preproc_undef] = STATE(354),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_GT_EQ] = ACTIONS(2493),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2503),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [355] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2904),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2483),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(355),
    [sym_preproc_endregion] = STATE(355),
    [sym_preproc_line] = STATE(355),
    [sym_preproc_pragma] = STATE(355),
    [sym_preproc_nullable] = STATE(355),
    [sym_preproc_error] = STATE(355),
    [sym_preproc_warning] = STATE(355),
    [sym_preproc_define] = STATE(355),
    [sym_preproc_undef] = STATE(355),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [356] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2906),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2504),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(356),
    [sym_preproc_endregion] = STATE(356),
    [sym_preproc_line] = STATE(356),
    [sym_preproc_pragma] = STATE(356),
    [sym_preproc_nullable] = STATE(356),
    [sym_preproc_error] = STATE(356),
    [sym_preproc_warning] = STATE(356),
    [sym_preproc_define] = STATE(356),
    [sym_preproc_undef] = STATE(356),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2551),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [357] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2932),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2369),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2531),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5188),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2618),
    [sym_property_pattern_clause] = STATE(2878),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(357),
    [sym_preproc_endregion] = STATE(357),
    [sym_preproc_line] = STATE(357),
    [sym_preproc_pragma] = STATE(357),
    [sym_preproc_nullable] = STATE(357),
    [sym_preproc_error] = STATE(357),
    [sym_preproc_warning] = STATE(357),
    [sym_preproc_define] = STATE(357),
    [sym_preproc_undef] = STATE(357),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(2557),
    [anon_sym_LT_EQ] = ACTIONS(2557),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2559),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [358] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2778),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2260),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2420),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4862),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2527),
    [sym_property_pattern_clause] = STATE(2583),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5713),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(358),
    [sym_preproc_endregion] = STATE(358),
    [sym_preproc_line] = STATE(358),
    [sym_preproc_pragma] = STATE(358),
    [sym_preproc_nullable] = STATE(358),
    [sym_preproc_error] = STATE(358),
    [sym_preproc_warning] = STATE(358),
    [sym_preproc_define] = STATE(358),
    [sym_preproc_undef] = STATE(358),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_GT_EQ] = ACTIONS(2493),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2503),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [359] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5759),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2305),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5285),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(5362),
    [sym_postfix_unary_expression] = STATE(5364),
    [sym_prefix_unary_expression] = STATE(5364),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(5362),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(5364),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(5362),
    [sym_member_access_expression] = STATE(3532),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(5364),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(5362),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(5362),
    [sym_typeof_expression] = STATE(5362),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3532),
    [sym_literal] = STATE(5362),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2256),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(359),
    [sym_preproc_endregion] = STATE(359),
    [sym_preproc_line] = STATE(359),
    [sym_preproc_pragma] = STATE(359),
    [sym_preproc_nullable] = STATE(359),
    [sym_preproc_error] = STATE(359),
    [sym_preproc_warning] = STATE(359),
    [sym_preproc_define] = STATE(359),
    [sym_preproc_undef] = STATE(359),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2567),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2569),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2571),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [360] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2906),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2504),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5190),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(360),
    [sym_preproc_endregion] = STATE(360),
    [sym_preproc_line] = STATE(360),
    [sym_preproc_pragma] = STATE(360),
    [sym_preproc_nullable] = STATE(360),
    [sym_preproc_error] = STATE(360),
    [sym_preproc_warning] = STATE(360),
    [sym_preproc_define] = STATE(360),
    [sym_preproc_undef] = STATE(360),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2551),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [361] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2909),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2354),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2540),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4167),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2619),
    [sym_property_pattern_clause] = STATE(2820),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5758),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(361),
    [sym_preproc_endregion] = STATE(361),
    [sym_preproc_line] = STATE(361),
    [sym_preproc_pragma] = STATE(361),
    [sym_preproc_nullable] = STATE(361),
    [sym_preproc_error] = STATE(361),
    [sym_preproc_warning] = STATE(361),
    [sym_preproc_define] = STATE(361),
    [sym_preproc_undef] = STATE(361),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2457),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2459),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [362] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2486),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2578),
    [sym_property_pattern_clause] = STATE(2672),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5715),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(362),
    [sym_preproc_endregion] = STATE(362),
    [sym_preproc_line] = STATE(362),
    [sym_preproc_pragma] = STATE(362),
    [sym_preproc_nullable] = STATE(362),
    [sym_preproc_error] = STATE(362),
    [sym_preproc_warning] = STATE(362),
    [sym_preproc_define] = STATE(362),
    [sym_preproc_undef] = STATE(362),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2477),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [363] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2909),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2354),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2540),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4168),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2619),
    [sym_property_pattern_clause] = STATE(2820),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5758),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(363),
    [sym_preproc_endregion] = STATE(363),
    [sym_preproc_line] = STATE(363),
    [sym_preproc_pragma] = STATE(363),
    [sym_preproc_nullable] = STATE(363),
    [sym_preproc_error] = STATE(363),
    [sym_preproc_warning] = STATE(363),
    [sym_preproc_define] = STATE(363),
    [sym_preproc_undef] = STATE(363),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2457),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2459),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [364] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2896),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2498),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5728),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(364),
    [sym_preproc_endregion] = STATE(364),
    [sym_preproc_line] = STATE(364),
    [sym_preproc_pragma] = STATE(364),
    [sym_preproc_nullable] = STATE(364),
    [sym_preproc_error] = STATE(364),
    [sym_preproc_warning] = STATE(364),
    [sym_preproc_define] = STATE(364),
    [sym_preproc_undef] = STATE(364),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [365] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2250),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5750),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(365),
    [sym_preproc_endregion] = STATE(365),
    [sym_preproc_line] = STATE(365),
    [sym_preproc_pragma] = STATE(365),
    [sym_preproc_nullable] = STATE(365),
    [sym_preproc_error] = STATE(365),
    [sym_preproc_warning] = STATE(365),
    [sym_preproc_define] = STATE(365),
    [sym_preproc_undef] = STATE(365),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2587),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [366] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2909),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2354),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2540),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4177),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2619),
    [sym_property_pattern_clause] = STATE(2820),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5758),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(366),
    [sym_preproc_endregion] = STATE(366),
    [sym_preproc_line] = STATE(366),
    [sym_preproc_pragma] = STATE(366),
    [sym_preproc_nullable] = STATE(366),
    [sym_preproc_error] = STATE(366),
    [sym_preproc_warning] = STATE(366),
    [sym_preproc_define] = STATE(366),
    [sym_preproc_undef] = STATE(366),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2457),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2459),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [367] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2909),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2354),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2509),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4174),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2619),
    [sym_property_pattern_clause] = STATE(2820),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5758),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(367),
    [sym_preproc_endregion] = STATE(367),
    [sym_preproc_line] = STATE(367),
    [sym_preproc_pragma] = STATE(367),
    [sym_preproc_nullable] = STATE(367),
    [sym_preproc_error] = STATE(367),
    [sym_preproc_warning] = STATE(367),
    [sym_preproc_define] = STATE(367),
    [sym_preproc_undef] = STATE(367),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2453),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2457),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2459),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [368] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2482),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5438),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5716),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(368),
    [sym_preproc_endregion] = STATE(368),
    [sym_preproc_line] = STATE(368),
    [sym_preproc_pragma] = STATE(368),
    [sym_preproc_nullable] = STATE(368),
    [sym_preproc_error] = STATE(368),
    [sym_preproc_warning] = STATE(368),
    [sym_preproc_define] = STATE(368),
    [sym_preproc_undef] = STATE(368),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [369] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2905),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2493),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5002),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5721),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(369),
    [sym_preproc_endregion] = STATE(369),
    [sym_preproc_line] = STATE(369),
    [sym_preproc_pragma] = STATE(369),
    [sym_preproc_nullable] = STATE(369),
    [sym_preproc_error] = STATE(369),
    [sym_preproc_warning] = STATE(369),
    [sym_preproc_define] = STATE(369),
    [sym_preproc_undef] = STATE(369),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [370] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2920),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2361),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2511),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2600),
    [sym_property_pattern_clause] = STATE(2858),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5711),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(370),
    [sym_preproc_endregion] = STATE(370),
    [sym_preproc_line] = STATE(370),
    [sym_preproc_pragma] = STATE(370),
    [sym_preproc_nullable] = STATE(370),
    [sym_preproc_error] = STATE(370),
    [sym_preproc_warning] = STATE(370),
    [sym_preproc_define] = STATE(370),
    [sym_preproc_undef] = STATE(370),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2609),
    [anon_sym_GT] = ACTIONS(2609),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [371] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2923),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2339),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2536),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2596),
    [sym_property_pattern_clause] = STATE(2771),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(371),
    [sym_preproc_endregion] = STATE(371),
    [sym_preproc_line] = STATE(371),
    [sym_preproc_pragma] = STATE(371),
    [sym_preproc_nullable] = STATE(371),
    [sym_preproc_error] = STATE(371),
    [sym_preproc_warning] = STATE(371),
    [sym_preproc_define] = STATE(371),
    [sym_preproc_undef] = STATE(371),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [372] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2905),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2493),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5721),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(372),
    [sym_preproc_endregion] = STATE(372),
    [sym_preproc_line] = STATE(372),
    [sym_preproc_pragma] = STATE(372),
    [sym_preproc_nullable] = STATE(372),
    [sym_preproc_error] = STATE(372),
    [sym_preproc_warning] = STATE(372),
    [sym_preproc_define] = STATE(372),
    [sym_preproc_undef] = STATE(372),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [373] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2929),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2368),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2528),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2589),
    [sym_property_pattern_clause] = STATE(2873),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5723),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(373),
    [sym_preproc_endregion] = STATE(373),
    [sym_preproc_line] = STATE(373),
    [sym_preproc_pragma] = STATE(373),
    [sym_preproc_nullable] = STATE(373),
    [sym_preproc_error] = STATE(373),
    [sym_preproc_warning] = STATE(373),
    [sym_preproc_define] = STATE(373),
    [sym_preproc_undef] = STATE(373),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2535),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [374] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2931),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2355),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2526),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2590),
    [sym_property_pattern_clause] = STATE(2830),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(374),
    [sym_preproc_endregion] = STATE(374),
    [sym_preproc_line] = STATE(374),
    [sym_preproc_pragma] = STATE(374),
    [sym_preproc_nullable] = STATE(374),
    [sym_preproc_error] = STATE(374),
    [sym_preproc_warning] = STATE(374),
    [sym_preproc_define] = STATE(374),
    [sym_preproc_undef] = STATE(374),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2507),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_GT_EQ] = ACTIONS(2509),
    [anon_sym_LT_EQ] = ACTIONS(2509),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [375] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2905),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2493),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5083),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5721),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(375),
    [sym_preproc_endregion] = STATE(375),
    [sym_preproc_line] = STATE(375),
    [sym_preproc_pragma] = STATE(375),
    [sym_preproc_nullable] = STATE(375),
    [sym_preproc_error] = STATE(375),
    [sym_preproc_warning] = STATE(375),
    [sym_preproc_define] = STATE(375),
    [sym_preproc_undef] = STATE(375),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [376] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2932),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2369),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2505),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2618),
    [sym_property_pattern_clause] = STATE(2878),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(376),
    [sym_preproc_endregion] = STATE(376),
    [sym_preproc_line] = STATE(376),
    [sym_preproc_pragma] = STATE(376),
    [sym_preproc_nullable] = STATE(376),
    [sym_preproc_error] = STATE(376),
    [sym_preproc_warning] = STATE(376),
    [sym_preproc_define] = STATE(376),
    [sym_preproc_undef] = STATE(376),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(2557),
    [anon_sym_LT_EQ] = ACTIONS(2557),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2559),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [377] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2910),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2357),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2535),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2594),
    [sym_property_pattern_clause] = STATE(2841),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5756),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(377),
    [sym_preproc_endregion] = STATE(377),
    [sym_preproc_line] = STATE(377),
    [sym_preproc_pragma] = STATE(377),
    [sym_preproc_nullable] = STATE(377),
    [sym_preproc_error] = STATE(377),
    [sym_preproc_warning] = STATE(377),
    [sym_preproc_define] = STATE(377),
    [sym_preproc_undef] = STATE(377),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_GT_EQ] = ACTIONS(2421),
    [anon_sym_LT_EQ] = ACTIONS(2421),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [378] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2778),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2260),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2420),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4802),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2527),
    [sym_property_pattern_clause] = STATE(2583),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5713),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(378),
    [sym_preproc_endregion] = STATE(378),
    [sym_preproc_line] = STATE(378),
    [sym_preproc_pragma] = STATE(378),
    [sym_preproc_nullable] = STATE(378),
    [sym_preproc_error] = STATE(378),
    [sym_preproc_warning] = STATE(378),
    [sym_preproc_define] = STATE(378),
    [sym_preproc_undef] = STATE(378),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_GT_EQ] = ACTIONS(2493),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2503),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [379] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2490),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5716),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(379),
    [sym_preproc_endregion] = STATE(379),
    [sym_preproc_line] = STATE(379),
    [sym_preproc_pragma] = STATE(379),
    [sym_preproc_nullable] = STATE(379),
    [sym_preproc_error] = STATE(379),
    [sym_preproc_warning] = STATE(379),
    [sym_preproc_define] = STATE(379),
    [sym_preproc_undef] = STATE(379),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [380] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2250),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(380),
    [sym_preproc_endregion] = STATE(380),
    [sym_preproc_line] = STATE(380),
    [sym_preproc_pragma] = STATE(380),
    [sym_preproc_nullable] = STATE(380),
    [sym_preproc_error] = STATE(380),
    [sym_preproc_warning] = STATE(380),
    [sym_preproc_define] = STATE(380),
    [sym_preproc_undef] = STATE(380),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [381] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5759),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2305),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5285),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6744),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(5362),
    [sym_postfix_unary_expression] = STATE(5364),
    [sym_prefix_unary_expression] = STATE(5364),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(5362),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(5364),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(5362),
    [sym_member_access_expression] = STATE(3532),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(5364),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(5362),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(5362),
    [sym_typeof_expression] = STATE(5362),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3532),
    [sym_literal] = STATE(5362),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2256),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(381),
    [sym_preproc_endregion] = STATE(381),
    [sym_preproc_line] = STATE(381),
    [sym_preproc_pragma] = STATE(381),
    [sym_preproc_nullable] = STATE(381),
    [sym_preproc_error] = STATE(381),
    [sym_preproc_warning] = STATE(381),
    [sym_preproc_define] = STATE(381),
    [sym_preproc_undef] = STATE(381),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2567),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2569),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2571),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [382] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2253),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4406),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(382),
    [sym_preproc_endregion] = STATE(382),
    [sym_preproc_line] = STATE(382),
    [sym_preproc_pragma] = STATE(382),
    [sym_preproc_nullable] = STATE(382),
    [sym_preproc_error] = STATE(382),
    [sym_preproc_warning] = STATE(382),
    [sym_preproc_define] = STATE(382),
    [sym_preproc_undef] = STATE(382),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [383] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2650),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2242),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4505),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(383),
    [sym_preproc_endregion] = STATE(383),
    [sym_preproc_line] = STATE(383),
    [sym_preproc_pragma] = STATE(383),
    [sym_preproc_nullable] = STATE(383),
    [sym_preproc_error] = STATE(383),
    [sym_preproc_warning] = STATE(383),
    [sym_preproc_define] = STATE(383),
    [sym_preproc_undef] = STATE(383),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2447),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [384] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2901),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2319),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2473),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3819),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2577),
    [sym_property_pattern_clause] = STATE(2654),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5751),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(384),
    [sym_preproc_endregion] = STATE(384),
    [sym_preproc_line] = STATE(384),
    [sym_preproc_pragma] = STATE(384),
    [sym_preproc_nullable] = STATE(384),
    [sym_preproc_error] = STATE(384),
    [sym_preproc_warning] = STATE(384),
    [sym_preproc_define] = STATE(384),
    [sym_preproc_undef] = STATE(384),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(2407),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [385] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(385),
    [sym_preproc_endregion] = STATE(385),
    [sym_preproc_line] = STATE(385),
    [sym_preproc_pragma] = STATE(385),
    [sym_preproc_nullable] = STATE(385),
    [sym_preproc_error] = STATE(385),
    [sym_preproc_warning] = STATE(385),
    [sym_preproc_define] = STATE(385),
    [sym_preproc_undef] = STATE(385),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [386] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2923),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2339),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2508),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5541),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2596),
    [sym_property_pattern_clause] = STATE(2771),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(386),
    [sym_preproc_endregion] = STATE(386),
    [sym_preproc_line] = STATE(386),
    [sym_preproc_pragma] = STATE(386),
    [sym_preproc_nullable] = STATE(386),
    [sym_preproc_error] = STATE(386),
    [sym_preproc_warning] = STATE(386),
    [sym_preproc_define] = STATE(386),
    [sym_preproc_undef] = STATE(386),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [387] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2923),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2339),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2508),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2596),
    [sym_property_pattern_clause] = STATE(2771),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(387),
    [sym_preproc_endregion] = STATE(387),
    [sym_preproc_line] = STATE(387),
    [sym_preproc_pragma] = STATE(387),
    [sym_preproc_nullable] = STATE(387),
    [sym_preproc_error] = STATE(387),
    [sym_preproc_warning] = STATE(387),
    [sym_preproc_define] = STATE(387),
    [sym_preproc_undef] = STATE(387),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [388] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2923),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2339),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2508),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5472),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2596),
    [sym_property_pattern_clause] = STATE(2771),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(388),
    [sym_preproc_endregion] = STATE(388),
    [sym_preproc_line] = STATE(388),
    [sym_preproc_pragma] = STATE(388),
    [sym_preproc_nullable] = STATE(388),
    [sym_preproc_error] = STATE(388),
    [sym_preproc_warning] = STATE(388),
    [sym_preproc_define] = STATE(388),
    [sym_preproc_undef] = STATE(388),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [389] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6774),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(389),
    [sym_preproc_endregion] = STATE(389),
    [sym_preproc_line] = STATE(389),
    [sym_preproc_pragma] = STATE(389),
    [sym_preproc_nullable] = STATE(389),
    [sym_preproc_error] = STATE(389),
    [sym_preproc_warning] = STATE(389),
    [sym_preproc_define] = STATE(389),
    [sym_preproc_undef] = STATE(389),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [390] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2488),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5691),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5716),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(390),
    [sym_preproc_endregion] = STATE(390),
    [sym_preproc_line] = STATE(390),
    [sym_preproc_pragma] = STATE(390),
    [sym_preproc_nullable] = STATE(390),
    [sym_preproc_error] = STATE(390),
    [sym_preproc_warning] = STATE(390),
    [sym_preproc_define] = STATE(390),
    [sym_preproc_undef] = STATE(390),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [391] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2488),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5716),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(391),
    [sym_preproc_endregion] = STATE(391),
    [sym_preproc_line] = STATE(391),
    [sym_preproc_pragma] = STATE(391),
    [sym_preproc_nullable] = STATE(391),
    [sym_preproc_error] = STATE(391),
    [sym_preproc_warning] = STATE(391),
    [sym_preproc_define] = STATE(391),
    [sym_preproc_undef] = STATE(391),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [392] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(392),
    [sym_preproc_endregion] = STATE(392),
    [sym_preproc_line] = STATE(392),
    [sym_preproc_pragma] = STATE(392),
    [sym_preproc_nullable] = STATE(392),
    [sym_preproc_error] = STATE(392),
    [sym_preproc_warning] = STATE(392),
    [sym_preproc_define] = STATE(392),
    [sym_preproc_undef] = STATE(392),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [393] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6723),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(393),
    [sym_preproc_endregion] = STATE(393),
    [sym_preproc_line] = STATE(393),
    [sym_preproc_pragma] = STATE(393),
    [sym_preproc_nullable] = STATE(393),
    [sym_preproc_error] = STATE(393),
    [sym_preproc_warning] = STATE(393),
    [sym_preproc_define] = STATE(393),
    [sym_preproc_undef] = STATE(393),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [394] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(394),
    [sym_preproc_endregion] = STATE(394),
    [sym_preproc_line] = STATE(394),
    [sym_preproc_pragma] = STATE(394),
    [sym_preproc_nullable] = STATE(394),
    [sym_preproc_error] = STATE(394),
    [sym_preproc_warning] = STATE(394),
    [sym_preproc_define] = STATE(394),
    [sym_preproc_undef] = STATE(394),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [395] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6734),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(395),
    [sym_preproc_endregion] = STATE(395),
    [sym_preproc_line] = STATE(395),
    [sym_preproc_pragma] = STATE(395),
    [sym_preproc_nullable] = STATE(395),
    [sym_preproc_error] = STATE(395),
    [sym_preproc_warning] = STATE(395),
    [sym_preproc_define] = STATE(395),
    [sym_preproc_undef] = STATE(395),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [396] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5767),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5273),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6788),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4278),
    [sym_postfix_unary_expression] = STATE(4296),
    [sym_prefix_unary_expression] = STATE(4296),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4278),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4296),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4278),
    [sym_member_access_expression] = STATE(3162),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4296),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4278),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4278),
    [sym_typeof_expression] = STATE(4278),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3162),
    [sym_literal] = STATE(4278),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(396),
    [sym_preproc_endregion] = STATE(396),
    [sym_preproc_line] = STATE(396),
    [sym_preproc_pragma] = STATE(396),
    [sym_preproc_nullable] = STATE(396),
    [sym_preproc_error] = STATE(396),
    [sym_preproc_warning] = STATE(396),
    [sym_preproc_define] = STATE(396),
    [sym_preproc_undef] = STATE(396),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1987),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [397] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2496),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5729),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(397),
    [sym_preproc_endregion] = STATE(397),
    [sym_preproc_line] = STATE(397),
    [sym_preproc_pragma] = STATE(397),
    [sym_preproc_nullable] = STATE(397),
    [sym_preproc_error] = STATE(397),
    [sym_preproc_warning] = STATE(397),
    [sym_preproc_define] = STATE(397),
    [sym_preproc_undef] = STATE(397),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [398] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2920),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2361),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2524),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5219),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2600),
    [sym_property_pattern_clause] = STATE(2858),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5711),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(398),
    [sym_preproc_endregion] = STATE(398),
    [sym_preproc_line] = STATE(398),
    [sym_preproc_pragma] = STATE(398),
    [sym_preproc_nullable] = STATE(398),
    [sym_preproc_error] = STATE(398),
    [sym_preproc_warning] = STATE(398),
    [sym_preproc_define] = STATE(398),
    [sym_preproc_undef] = STATE(398),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2609),
    [anon_sym_GT] = ACTIONS(2609),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [399] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2253),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4803),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(399),
    [sym_preproc_endregion] = STATE(399),
    [sym_preproc_line] = STATE(399),
    [sym_preproc_pragma] = STATE(399),
    [sym_preproc_nullable] = STATE(399),
    [sym_preproc_error] = STATE(399),
    [sym_preproc_warning] = STATE(399),
    [sym_preproc_define] = STATE(399),
    [sym_preproc_undef] = STATE(399),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2399),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [400] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2488),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5549),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5716),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(400),
    [sym_preproc_endregion] = STATE(400),
    [sym_preproc_line] = STATE(400),
    [sym_preproc_pragma] = STATE(400),
    [sym_preproc_nullable] = STATE(400),
    [sym_preproc_error] = STATE(400),
    [sym_preproc_warning] = STATE(400),
    [sym_preproc_define] = STATE(400),
    [sym_preproc_undef] = STATE(400),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [401] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2489),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5356),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5729),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(401),
    [sym_preproc_endregion] = STATE(401),
    [sym_preproc_line] = STATE(401),
    [sym_preproc_pragma] = STATE(401),
    [sym_preproc_nullable] = STATE(401),
    [sym_preproc_error] = STATE(401),
    [sym_preproc_warning] = STATE(401),
    [sym_preproc_define] = STATE(401),
    [sym_preproc_undef] = STATE(401),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [402] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2238),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(4481),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6789),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5167),
    [sym_property_pattern_clause] = STATE(5757),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4437),
    [sym_postfix_unary_expression] = STATE(4438),
    [sym_prefix_unary_expression] = STATE(4438),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4437),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4438),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4437),
    [sym_member_access_expression] = STATE(3186),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4438),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4437),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4437),
    [sym_typeof_expression] = STATE(4437),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3186),
    [sym_literal] = STATE(4437),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(402),
    [sym_preproc_endregion] = STATE(402),
    [sym_preproc_line] = STATE(402),
    [sym_preproc_pragma] = STATE(402),
    [sym_preproc_nullable] = STATE(402),
    [sym_preproc_error] = STATE(402),
    [sym_preproc_warning] = STATE(402),
    [sym_preproc_define] = STATE(402),
    [sym_preproc_undef] = STATE(402),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_ref] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1075),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(1149),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [403] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4804),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(403),
    [sym_preproc_endregion] = STATE(403),
    [sym_preproc_line] = STATE(403),
    [sym_preproc_pragma] = STATE(403),
    [sym_preproc_nullable] = STATE(403),
    [sym_preproc_error] = STATE(403),
    [sym_preproc_warning] = STATE(403),
    [sym_preproc_define] = STATE(403),
    [sym_preproc_undef] = STATE(403),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2399),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [404] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(404),
    [sym_preproc_endregion] = STATE(404),
    [sym_preproc_line] = STATE(404),
    [sym_preproc_pragma] = STATE(404),
    [sym_preproc_nullable] = STATE(404),
    [sym_preproc_error] = STATE(404),
    [sym_preproc_warning] = STATE(404),
    [sym_preproc_define] = STATE(404),
    [sym_preproc_undef] = STATE(404),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2399),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [405] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4734),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(405),
    [sym_preproc_endregion] = STATE(405),
    [sym_preproc_line] = STATE(405),
    [sym_preproc_pragma] = STATE(405),
    [sym_preproc_nullable] = STATE(405),
    [sym_preproc_error] = STATE(405),
    [sym_preproc_warning] = STATE(405),
    [sym_preproc_define] = STATE(405),
    [sym_preproc_undef] = STATE(405),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2399),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [406] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2489),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5729),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(406),
    [sym_preproc_endregion] = STATE(406),
    [sym_preproc_line] = STATE(406),
    [sym_preproc_pragma] = STATE(406),
    [sym_preproc_nullable] = STATE(406),
    [sym_preproc_error] = STATE(406),
    [sym_preproc_warning] = STATE(406),
    [sym_preproc_define] = STATE(406),
    [sym_preproc_undef] = STATE(406),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [407] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2489),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5181),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5729),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(407),
    [sym_preproc_endregion] = STATE(407),
    [sym_preproc_line] = STATE(407),
    [sym_preproc_pragma] = STATE(407),
    [sym_preproc_nullable] = STATE(407),
    [sym_preproc_error] = STATE(407),
    [sym_preproc_warning] = STATE(407),
    [sym_preproc_define] = STATE(407),
    [sym_preproc_undef] = STATE(407),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [408] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2475),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5489),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2578),
    [sym_property_pattern_clause] = STATE(2672),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5715),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(408),
    [sym_preproc_endregion] = STATE(408),
    [sym_preproc_line] = STATE(408),
    [sym_preproc_pragma] = STATE(408),
    [sym_preproc_nullable] = STATE(408),
    [sym_preproc_error] = STATE(408),
    [sym_preproc_warning] = STATE(408),
    [sym_preproc_define] = STATE(408),
    [sym_preproc_undef] = STATE(408),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_GT_EQ] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2475),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2477),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [409] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2253),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5511),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5750),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(409),
    [sym_preproc_endregion] = STATE(409),
    [sym_preproc_line] = STATE(409),
    [sym_preproc_pragma] = STATE(409),
    [sym_preproc_nullable] = STATE(409),
    [sym_preproc_error] = STATE(409),
    [sym_preproc_warning] = STATE(409),
    [sym_preproc_define] = STATE(409),
    [sym_preproc_undef] = STATE(409),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2587),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [410] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2908),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2330),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2533),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4256),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2610),
    [sym_property_pattern_clause] = STATE(2691),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(410),
    [sym_preproc_endregion] = STATE(410),
    [sym_preproc_line] = STATE(410),
    [sym_preproc_pragma] = STATE(410),
    [sym_preproc_nullable] = STATE(410),
    [sym_preproc_error] = STATE(410),
    [sym_preproc_warning] = STATE(410),
    [sym_preproc_define] = STATE(410),
    [sym_preproc_undef] = STATE(410),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2433),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [411] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2920),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2361),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2525),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5270),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2600),
    [sym_property_pattern_clause] = STATE(2858),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5711),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(411),
    [sym_preproc_endregion] = STATE(411),
    [sym_preproc_line] = STATE(411),
    [sym_preproc_pragma] = STATE(411),
    [sym_preproc_nullable] = STATE(411),
    [sym_preproc_error] = STATE(411),
    [sym_preproc_warning] = STATE(411),
    [sym_preproc_define] = STATE(411),
    [sym_preproc_undef] = STATE(411),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2609),
    [anon_sym_GT] = ACTIONS(2609),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [412] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2920),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2361),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2525),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2600),
    [sym_property_pattern_clause] = STATE(2858),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5711),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(412),
    [sym_preproc_endregion] = STATE(412),
    [sym_preproc_line] = STATE(412),
    [sym_preproc_pragma] = STATE(412),
    [sym_preproc_nullable] = STATE(412),
    [sym_preproc_error] = STATE(412),
    [sym_preproc_warning] = STATE(412),
    [sym_preproc_define] = STATE(412),
    [sym_preproc_undef] = STATE(412),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2609),
    [anon_sym_GT] = ACTIONS(2609),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [413] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2932),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2369),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2537),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5275),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2618),
    [sym_property_pattern_clause] = STATE(2878),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(413),
    [sym_preproc_endregion] = STATE(413),
    [sym_preproc_line] = STATE(413),
    [sym_preproc_pragma] = STATE(413),
    [sym_preproc_nullable] = STATE(413),
    [sym_preproc_error] = STATE(413),
    [sym_preproc_warning] = STATE(413),
    [sym_preproc_define] = STATE(413),
    [sym_preproc_undef] = STATE(413),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(2557),
    [anon_sym_LT_EQ] = ACTIONS(2557),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2559),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [414] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2932),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2369),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2537),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2618),
    [sym_property_pattern_clause] = STATE(2878),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(414),
    [sym_preproc_endregion] = STATE(414),
    [sym_preproc_line] = STATE(414),
    [sym_preproc_pragma] = STATE(414),
    [sym_preproc_nullable] = STATE(414),
    [sym_preproc_error] = STATE(414),
    [sym_preproc_warning] = STATE(414),
    [sym_preproc_define] = STATE(414),
    [sym_preproc_undef] = STATE(414),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(2557),
    [anon_sym_LT_EQ] = ACTIONS(2557),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2559),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [415] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2932),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2369),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2537),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5185),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2618),
    [sym_property_pattern_clause] = STATE(2878),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(415),
    [sym_preproc_endregion] = STATE(415),
    [sym_preproc_line] = STATE(415),
    [sym_preproc_pragma] = STATE(415),
    [sym_preproc_nullable] = STATE(415),
    [sym_preproc_error] = STATE(415),
    [sym_preproc_warning] = STATE(415),
    [sym_preproc_define] = STATE(415),
    [sym_preproc_undef] = STATE(415),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(2557),
    [anon_sym_LT_EQ] = ACTIONS(2557),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2559),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [416] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2920),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2361),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2525),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5177),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2600),
    [sym_property_pattern_clause] = STATE(2858),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5711),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(416),
    [sym_preproc_endregion] = STATE(416),
    [sym_preproc_line] = STATE(416),
    [sym_preproc_pragma] = STATE(416),
    [sym_preproc_nullable] = STATE(416),
    [sym_preproc_error] = STATE(416),
    [sym_preproc_warning] = STATE(416),
    [sym_preproc_define] = STATE(416),
    [sym_preproc_undef] = STATE(416),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2609),
    [anon_sym_GT] = ACTIONS(2609),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [417] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2253),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4565),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5714),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(417),
    [sym_preproc_endregion] = STATE(417),
    [sym_preproc_line] = STATE(417),
    [sym_preproc_pragma] = STATE(417),
    [sym_preproc_nullable] = STATE(417),
    [sym_preproc_error] = STATE(417),
    [sym_preproc_warning] = STATE(417),
    [sym_preproc_define] = STATE(417),
    [sym_preproc_undef] = STATE(417),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [418] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2778),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2260),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2416),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4705),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2527),
    [sym_property_pattern_clause] = STATE(2583),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5713),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(418),
    [sym_preproc_endregion] = STATE(418),
    [sym_preproc_line] = STATE(418),
    [sym_preproc_pragma] = STATE(418),
    [sym_preproc_nullable] = STATE(418),
    [sym_preproc_error] = STATE(418),
    [sym_preproc_warning] = STATE(418),
    [sym_preproc_define] = STATE(418),
    [sym_preproc_undef] = STATE(418),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_GT_EQ] = ACTIONS(2493),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2503),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [419] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2905),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2478),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5721),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(419),
    [sym_preproc_endregion] = STATE(419),
    [sym_preproc_line] = STATE(419),
    [sym_preproc_pragma] = STATE(419),
    [sym_preproc_nullable] = STATE(419),
    [sym_preproc_error] = STATE(419),
    [sym_preproc_warning] = STATE(419),
    [sym_preproc_define] = STATE(419),
    [sym_preproc_undef] = STATE(419),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_GT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(2601),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [420] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5714),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(420),
    [sym_preproc_endregion] = STATE(420),
    [sym_preproc_line] = STATE(420),
    [sym_preproc_pragma] = STATE(420),
    [sym_preproc_nullable] = STATE(420),
    [sym_preproc_error] = STATE(420),
    [sym_preproc_warning] = STATE(420),
    [sym_preproc_define] = STATE(420),
    [sym_preproc_undef] = STATE(420),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [421] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2906),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2300),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2499),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2568),
    [sym_property_pattern_clause] = STATE(2622),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5720),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(421),
    [sym_preproc_endregion] = STATE(421),
    [sym_preproc_line] = STATE(421),
    [sym_preproc_pragma] = STATE(421),
    [sym_preproc_nullable] = STATE(421),
    [sym_preproc_error] = STATE(421),
    [sym_preproc_warning] = STATE(421),
    [sym_preproc_define] = STATE(421),
    [sym_preproc_undef] = STATE(421),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2549),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2551),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [422] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4521),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(422),
    [sym_preproc_endregion] = STATE(422),
    [sym_preproc_line] = STATE(422),
    [sym_preproc_pragma] = STATE(422),
    [sym_preproc_nullable] = STATE(422),
    [sym_preproc_error] = STATE(422),
    [sym_preproc_warning] = STATE(422),
    [sym_preproc_define] = STATE(422),
    [sym_preproc_undef] = STATE(422),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [423] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4717),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5714),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(423),
    [sym_preproc_endregion] = STATE(423),
    [sym_preproc_line] = STATE(423),
    [sym_preproc_pragma] = STATE(423),
    [sym_preproc_nullable] = STATE(423),
    [sym_preproc_error] = STATE(423),
    [sym_preproc_warning] = STATE(423),
    [sym_preproc_define] = STATE(423),
    [sym_preproc_undef] = STATE(423),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [424] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2908),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2330),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2514),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4272),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2610),
    [sym_property_pattern_clause] = STATE(2691),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(424),
    [sym_preproc_endregion] = STATE(424),
    [sym_preproc_line] = STATE(424),
    [sym_preproc_pragma] = STATE(424),
    [sym_preproc_nullable] = STATE(424),
    [sym_preproc_error] = STATE(424),
    [sym_preproc_warning] = STATE(424),
    [sym_preproc_define] = STATE(424),
    [sym_preproc_undef] = STATE(424),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2433),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [425] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5759),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2299),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5285),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6547),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5568),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4599),
    [sym_postfix_unary_expression] = STATE(4604),
    [sym_prefix_unary_expression] = STATE(4604),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4599),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4604),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4599),
    [sym_member_access_expression] = STATE(3212),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4604),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4599),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4599),
    [sym_typeof_expression] = STATE(4599),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3212),
    [sym_literal] = STATE(4599),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2256),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(425),
    [sym_preproc_endregion] = STATE(425),
    [sym_preproc_line] = STATE(425),
    [sym_preproc_pragma] = STATE(425),
    [sym_preproc_nullable] = STATE(425),
    [sym_preproc_error] = STATE(425),
    [sym_preproc_warning] = STATE(425),
    [sym_preproc_define] = STATE(425),
    [sym_preproc_undef] = STATE(425),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2567),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2569),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(2571),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [426] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2931),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2355),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2522),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5708),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2590),
    [sym_property_pattern_clause] = STATE(2830),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(426),
    [sym_preproc_endregion] = STATE(426),
    [sym_preproc_line] = STATE(426),
    [sym_preproc_pragma] = STATE(426),
    [sym_preproc_nullable] = STATE(426),
    [sym_preproc_error] = STATE(426),
    [sym_preproc_warning] = STATE(426),
    [sym_preproc_define] = STATE(426),
    [sym_preproc_undef] = STATE(426),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2507),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_GT_EQ] = ACTIONS(2509),
    [anon_sym_LT_EQ] = ACTIONS(2509),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [427] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2931),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2355),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2522),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2590),
    [sym_property_pattern_clause] = STATE(2830),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(427),
    [sym_preproc_endregion] = STATE(427),
    [sym_preproc_line] = STATE(427),
    [sym_preproc_pragma] = STATE(427),
    [sym_preproc_nullable] = STATE(427),
    [sym_preproc_error] = STATE(427),
    [sym_preproc_warning] = STATE(427),
    [sym_preproc_define] = STATE(427),
    [sym_preproc_undef] = STATE(427),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2507),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_GT_EQ] = ACTIONS(2509),
    [anon_sym_LT_EQ] = ACTIONS(2509),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [428] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2931),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2355),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2522),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5695),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2590),
    [sym_property_pattern_clause] = STATE(2830),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(428),
    [sym_preproc_endregion] = STATE(428),
    [sym_preproc_line] = STATE(428),
    [sym_preproc_pragma] = STATE(428),
    [sym_preproc_nullable] = STATE(428),
    [sym_preproc_error] = STATE(428),
    [sym_preproc_warning] = STATE(428),
    [sym_preproc_define] = STATE(428),
    [sym_preproc_undef] = STATE(428),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2507),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_GT_EQ] = ACTIONS(2509),
    [anon_sym_LT_EQ] = ACTIONS(2509),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2511),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [429] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2899),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2327),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2484),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3779),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2574),
    [sym_property_pattern_clause] = STATE(2676),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5710),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(429),
    [sym_preproc_endregion] = STATE(429),
    [sym_preproc_line] = STATE(429),
    [sym_preproc_pragma] = STATE(429),
    [sym_preproc_nullable] = STATE(429),
    [sym_preproc_error] = STATE(429),
    [sym_preproc_warning] = STATE(429),
    [sym_preproc_define] = STATE(429),
    [sym_preproc_undef] = STATE(429),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2467),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [430] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2899),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2327),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2484),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3834),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2574),
    [sym_property_pattern_clause] = STATE(2676),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5710),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(430),
    [sym_preproc_endregion] = STATE(430),
    [sym_preproc_line] = STATE(430),
    [sym_preproc_pragma] = STATE(430),
    [sym_preproc_nullable] = STATE(430),
    [sym_preproc_error] = STATE(430),
    [sym_preproc_warning] = STATE(430),
    [sym_preproc_define] = STATE(430),
    [sym_preproc_undef] = STATE(430),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2467),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [431] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2250),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3429),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5714),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(431),
    [sym_preproc_endregion] = STATE(431),
    [sym_preproc_line] = STATE(431),
    [sym_preproc_pragma] = STATE(431),
    [sym_preproc_nullable] = STATE(431),
    [sym_preproc_error] = STATE(431),
    [sym_preproc_warning] = STATE(431),
    [sym_preproc_define] = STATE(431),
    [sym_preproc_undef] = STATE(431),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(2523),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [432] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2713),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2280),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2429),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(5030),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2516),
    [sym_property_pattern_clause] = STATE(2579),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5712),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(432),
    [sym_preproc_endregion] = STATE(432),
    [sym_preproc_line] = STATE(432),
    [sym_preproc_pragma] = STATE(432),
    [sym_preproc_nullable] = STATE(432),
    [sym_preproc_error] = STATE(432),
    [sym_preproc_warning] = STATE(432),
    [sym_preproc_define] = STATE(432),
    [sym_preproc_undef] = STATE(432),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2543),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [433] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5363),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5736),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(433),
    [sym_preproc_endregion] = STATE(433),
    [sym_preproc_line] = STATE(433),
    [sym_preproc_pragma] = STATE(433),
    [sym_preproc_nullable] = STATE(433),
    [sym_preproc_error] = STATE(433),
    [sym_preproc_warning] = STATE(433),
    [sym_preproc_define] = STATE(433),
    [sym_preproc_undef] = STATE(433),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(2641),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(2643),
    [anon_sym_LT_EQ] = ACTIONS(2643),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [434] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5736),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(434),
    [sym_preproc_endregion] = STATE(434),
    [sym_preproc_line] = STATE(434),
    [sym_preproc_pragma] = STATE(434),
    [sym_preproc_nullable] = STATE(434),
    [sym_preproc_error] = STATE(434),
    [sym_preproc_warning] = STATE(434),
    [sym_preproc_define] = STATE(434),
    [sym_preproc_undef] = STATE(434),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(2641),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(2643),
    [anon_sym_LT_EQ] = ACTIONS(2643),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [435] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2246),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5281),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5736),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(435),
    [sym_preproc_endregion] = STATE(435),
    [sym_preproc_line] = STATE(435),
    [sym_preproc_pragma] = STATE(435),
    [sym_preproc_nullable] = STATE(435),
    [sym_preproc_error] = STATE(435),
    [sym_preproc_warning] = STATE(435),
    [sym_preproc_define] = STATE(435),
    [sym_preproc_undef] = STATE(435),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(2641),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(2643),
    [anon_sym_LT_EQ] = ACTIONS(2643),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [436] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2242),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5283),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5736),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(436),
    [sym_preproc_endregion] = STATE(436),
    [sym_preproc_line] = STATE(436),
    [sym_preproc_pragma] = STATE(436),
    [sym_preproc_nullable] = STATE(436),
    [sym_preproc_error] = STATE(436),
    [sym_preproc_warning] = STATE(436),
    [sym_preproc_define] = STATE(436),
    [sym_preproc_undef] = STATE(436),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(2641),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(2643),
    [anon_sym_LT_EQ] = ACTIONS(2643),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [437] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2248),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5733),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(437),
    [sym_preproc_endregion] = STATE(437),
    [sym_preproc_line] = STATE(437),
    [sym_preproc_pragma] = STATE(437),
    [sym_preproc_nullable] = STATE(437),
    [sym_preproc_error] = STATE(437),
    [sym_preproc_warning] = STATE(437),
    [sym_preproc_define] = STATE(437),
    [sym_preproc_undef] = STATE(437),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2381),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [438] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2899),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2327),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2484),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3863),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2574),
    [sym_property_pattern_clause] = STATE(2676),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5710),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(438),
    [sym_preproc_endregion] = STATE(438),
    [sym_preproc_line] = STATE(438),
    [sym_preproc_pragma] = STATE(438),
    [sym_preproc_nullable] = STATE(438),
    [sym_preproc_error] = STATE(438),
    [sym_preproc_warning] = STATE(438),
    [sym_preproc_define] = STATE(438),
    [sym_preproc_undef] = STATE(438),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2467),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [439] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2501),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5218),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5729),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(439),
    [sym_preproc_endregion] = STATE(439),
    [sym_preproc_line] = STATE(439),
    [sym_preproc_pragma] = STATE(439),
    [sym_preproc_nullable] = STATE(439),
    [sym_preproc_error] = STATE(439),
    [sym_preproc_warning] = STATE(439),
    [sym_preproc_define] = STATE(439),
    [sym_preproc_undef] = STATE(439),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2603),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [440] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(440),
    [sym_preproc_endregion] = STATE(440),
    [sym_preproc_line] = STATE(440),
    [sym_preproc_pragma] = STATE(440),
    [sym_preproc_nullable] = STATE(440),
    [sym_preproc_error] = STATE(440),
    [sym_preproc_warning] = STATE(440),
    [sym_preproc_define] = STATE(440),
    [sym_preproc_undef] = STATE(440),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [441] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2248),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3367),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5736),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(441),
    [sym_preproc_endregion] = STATE(441),
    [sym_preproc_line] = STATE(441),
    [sym_preproc_pragma] = STATE(441),
    [sym_preproc_nullable] = STATE(441),
    [sym_preproc_error] = STATE(441),
    [sym_preproc_warning] = STATE(441),
    [sym_preproc_define] = STATE(441),
    [sym_preproc_undef] = STATE(441),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(2641),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_GT_EQ] = ACTIONS(2643),
    [anon_sym_LT_EQ] = ACTIONS(2643),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [442] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2449),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4461),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(442),
    [sym_preproc_endregion] = STATE(442),
    [sym_preproc_line] = STATE(442),
    [sym_preproc_pragma] = STATE(442),
    [sym_preproc_nullable] = STATE(442),
    [sym_preproc_error] = STATE(442),
    [sym_preproc_warning] = STATE(442),
    [sym_preproc_define] = STATE(442),
    [sym_preproc_undef] = STATE(442),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [443] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2923),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2339),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2506),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5538),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2596),
    [sym_property_pattern_clause] = STATE(2771),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(443),
    [sym_preproc_endregion] = STATE(443),
    [sym_preproc_line] = STATE(443),
    [sym_preproc_pragma] = STATE(443),
    [sym_preproc_nullable] = STATE(443),
    [sym_preproc_error] = STATE(443),
    [sym_preproc_warning] = STATE(443),
    [sym_preproc_define] = STATE(443),
    [sym_preproc_undef] = STATE(443),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [444] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5516),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5750),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(444),
    [sym_preproc_endregion] = STATE(444),
    [sym_preproc_line] = STATE(444),
    [sym_preproc_pragma] = STATE(444),
    [sym_preproc_nullable] = STATE(444),
    [sym_preproc_error] = STATE(444),
    [sym_preproc_warning] = STATE(444),
    [sym_preproc_define] = STATE(444),
    [sym_preproc_undef] = STATE(444),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2587),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [445] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5759),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2305),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5285),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_pattern] = STATE(6708),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(5717),
    [sym_property_pattern_clause] = STATE(5795),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5748),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(5362),
    [sym_postfix_unary_expression] = STATE(5364),
    [sym_prefix_unary_expression] = STATE(5364),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(5362),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(5364),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(5362),
    [sym_member_access_expression] = STATE(3532),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(5364),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(5362),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(5362),
    [sym_typeof_expression] = STATE(5362),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3532),
    [sym_literal] = STATE(5362),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2256),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(445),
    [sym_preproc_endregion] = STATE(445),
    [sym_preproc_line] = STATE(445),
    [sym_preproc_pragma] = STATE(445),
    [sym_preproc_nullable] = STATE(445),
    [sym_preproc_error] = STATE(445),
    [sym_preproc_warning] = STATE(445),
    [sym_preproc_define] = STATE(445),
    [sym_preproc_undef] = STATE(445),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2567),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2569),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2571),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [446] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3535),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5750),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(446),
    [sym_preproc_endregion] = STATE(446),
    [sym_preproc_line] = STATE(446),
    [sym_preproc_pragma] = STATE(446),
    [sym_preproc_nullable] = STATE(446),
    [sym_preproc_error] = STATE(446),
    [sym_preproc_warning] = STATE(446),
    [sym_preproc_define] = STATE(446),
    [sym_preproc_undef] = STATE(446),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2587),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [447] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2896),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2497),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5053),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5728),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(447),
    [sym_preproc_endregion] = STATE(447),
    [sym_preproc_line] = STATE(447),
    [sym_preproc_pragma] = STATE(447),
    [sym_preproc_nullable] = STATE(447),
    [sym_preproc_error] = STATE(447),
    [sym_preproc_warning] = STATE(447),
    [sym_preproc_define] = STATE(447),
    [sym_preproc_undef] = STATE(447),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [448] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2896),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2497),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3280),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5728),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(448),
    [sym_preproc_endregion] = STATE(448),
    [sym_preproc_line] = STATE(448),
    [sym_preproc_pragma] = STATE(448),
    [sym_preproc_nullable] = STATE(448),
    [sym_preproc_error] = STATE(448),
    [sym_preproc_warning] = STATE(448),
    [sym_preproc_define] = STATE(448),
    [sym_preproc_undef] = STATE(448),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [449] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2896),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2304),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2497),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5019),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2559),
    [sym_property_pattern_clause] = STATE(2609),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5728),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(449),
    [sym_preproc_endregion] = STATE(449),
    [sym_preproc_line] = STATE(449),
    [sym_preproc_pragma] = STATE(449),
    [sym_preproc_nullable] = STATE(449),
    [sym_preproc_error] = STATE(449),
    [sym_preproc_warning] = STATE(449),
    [sym_preproc_define] = STATE(449),
    [sym_preproc_undef] = STATE(449),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [450] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2445),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2198),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2242),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4118),
    [sym_constant_pattern] = STATE(3298),
    [sym_parenthesized_pattern] = STATE(3298),
    [sym_var_pattern] = STATE(3298),
    [sym_type_pattern] = STATE(3298),
    [sym_list_pattern] = STATE(3298),
    [sym_recursive_pattern] = STATE(3298),
    [sym_positional_pattern_clause] = STATE(2278),
    [sym_property_pattern_clause] = STATE(2321),
    [sym_relational_pattern] = STATE(3298),
    [sym_negated_pattern] = STATE(3298),
    [sym_and_pattern] = STATE(3298),
    [sym_or_pattern] = STATE(3298),
    [sym_declaration_pattern] = STATE(3298),
    [sym_expression] = STATE(5733),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3382),
    [sym_postfix_unary_expression] = STATE(3383),
    [sym_prefix_unary_expression] = STATE(3383),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3382),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3383),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3382),
    [sym_member_access_expression] = STATE(2629),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3383),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3382),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3382),
    [sym_typeof_expression] = STATE(3382),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2629),
    [sym_literal] = STATE(3382),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(450),
    [sym_preproc_endregion] = STATE(450),
    [sym_preproc_line] = STATE(450),
    [sym_preproc_pragma] = STATE(450),
    [sym_preproc_nullable] = STATE(450),
    [sym_preproc_error] = STATE(450),
    [sym_preproc_warning] = STATE(450),
    [sym_preproc_define] = STATE(450),
    [sym_preproc_undef] = STATE(450),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2375),
    [sym_predefined_type] = ACTIONS(2377),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2379),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2381),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [451] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2908),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2330),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2514),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4168),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2610),
    [sym_property_pattern_clause] = STATE(2691),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(451),
    [sym_preproc_endregion] = STATE(451),
    [sym_preproc_line] = STATE(451),
    [sym_preproc_pragma] = STATE(451),
    [sym_preproc_nullable] = STATE(451),
    [sym_preproc_error] = STATE(451),
    [sym_preproc_warning] = STATE(451),
    [sym_preproc_define] = STATE(451),
    [sym_preproc_undef] = STATE(451),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2433),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [452] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2637),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2199),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2249),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(5496),
    [sym_constant_pattern] = STATE(3401),
    [sym_parenthesized_pattern] = STATE(3401),
    [sym_var_pattern] = STATE(3401),
    [sym_type_pattern] = STATE(3401),
    [sym_list_pattern] = STATE(3401),
    [sym_recursive_pattern] = STATE(3401),
    [sym_positional_pattern_clause] = STATE(2296),
    [sym_property_pattern_clause] = STATE(2347),
    [sym_relational_pattern] = STATE(3401),
    [sym_negated_pattern] = STATE(3401),
    [sym_and_pattern] = STATE(3401),
    [sym_or_pattern] = STATE(3401),
    [sym_declaration_pattern] = STATE(3401),
    [sym_expression] = STATE(5750),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3408),
    [sym_postfix_unary_expression] = STATE(3409),
    [sym_prefix_unary_expression] = STATE(3409),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3408),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3409),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3408),
    [sym_member_access_expression] = STATE(2718),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3409),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3408),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3408),
    [sym_typeof_expression] = STATE(3408),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2718),
    [sym_literal] = STATE(3408),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(452),
    [sym_preproc_endregion] = STATE(452),
    [sym_preproc_line] = STATE(452),
    [sym_preproc_pragma] = STATE(452),
    [sym_preproc_nullable] = STATE(452),
    [sym_preproc_error] = STATE(452),
    [sym_preproc_warning] = STATE(452),
    [sym_preproc_define] = STATE(452),
    [sym_preproc_undef] = STATE(452),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2395),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(1081),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2587),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [453] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2908),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2330),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2514),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(4236),
    [sym_constant_pattern] = STATE(4213),
    [sym_parenthesized_pattern] = STATE(4213),
    [sym_var_pattern] = STATE(4213),
    [sym_type_pattern] = STATE(4213),
    [sym_list_pattern] = STATE(4213),
    [sym_recursive_pattern] = STATE(4213),
    [sym_positional_pattern_clause] = STATE(2610),
    [sym_property_pattern_clause] = STATE(2691),
    [sym_relational_pattern] = STATE(4213),
    [sym_negated_pattern] = STATE(4213),
    [sym_and_pattern] = STATE(4213),
    [sym_or_pattern] = STATE(4213),
    [sym_declaration_pattern] = STATE(4213),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4202),
    [sym_postfix_unary_expression] = STATE(4207),
    [sym_prefix_unary_expression] = STATE(4207),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4202),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4207),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4202),
    [sym_member_access_expression] = STATE(3118),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4207),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4202),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4202),
    [sym_typeof_expression] = STATE(4202),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3118),
    [sym_literal] = STATE(4202),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(453),
    [sym_preproc_endregion] = STATE(453),
    [sym_preproc_line] = STATE(453),
    [sym_preproc_pragma] = STATE(453),
    [sym_preproc_nullable] = STATE(453),
    [sym_preproc_error] = STATE(453),
    [sym_preproc_warning] = STATE(453),
    [sym_preproc_define] = STATE(453),
    [sym_preproc_undef] = STATE(453),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2433),
    [sym_predefined_type] = ACTIONS(2435),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2437),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [454] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2899),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2327),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2480),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_pattern] = STATE(3778),
    [sym_constant_pattern] = STATE(3785),
    [sym_parenthesized_pattern] = STATE(3785),
    [sym_var_pattern] = STATE(3785),
    [sym_type_pattern] = STATE(3785),
    [sym_list_pattern] = STATE(3785),
    [sym_recursive_pattern] = STATE(3785),
    [sym_positional_pattern_clause] = STATE(2574),
    [sym_property_pattern_clause] = STATE(2676),
    [sym_relational_pattern] = STATE(3785),
    [sym_negated_pattern] = STATE(3785),
    [sym_and_pattern] = STATE(3785),
    [sym_or_pattern] = STATE(3785),
    [sym_declaration_pattern] = STATE(3785),
    [sym_expression] = STATE(5710),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3920),
    [sym_postfix_unary_expression] = STATE(3921),
    [sym_prefix_unary_expression] = STATE(3921),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3920),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3921),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3920),
    [sym_member_access_expression] = STATE(2938),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3921),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3920),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3920),
    [sym_typeof_expression] = STATE(3920),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2938),
    [sym_literal] = STATE(3920),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(454),
    [sym_preproc_endregion] = STATE(454),
    [sym_preproc_line] = STATE(454),
    [sym_preproc_pragma] = STATE(454),
    [sym_preproc_nullable] = STATE(454),
    [sym_preproc_error] = STATE(454),
    [sym_preproc_warning] = STATE(454),
    [sym_preproc_define] = STATE(454),
    [sym_preproc_undef] = STATE(454),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2461),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_GT_EQ] = ACTIONS(2465),
    [anon_sym_LT_EQ] = ACTIONS(2465),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2409),
    [sym_predefined_type] = ACTIONS(2411),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2467),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [455] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2713),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2280),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2434),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_pattern] = STATE(4598),
    [sym_constant_pattern] = STATE(4766),
    [sym_parenthesized_pattern] = STATE(4766),
    [sym_var_pattern] = STATE(4766),
    [sym_type_pattern] = STATE(4766),
    [sym_list_pattern] = STATE(4766),
    [sym_recursive_pattern] = STATE(4766),
    [sym_positional_pattern_clause] = STATE(2516),
    [sym_property_pattern_clause] = STATE(2579),
    [sym_relational_pattern] = STATE(4766),
    [sym_negated_pattern] = STATE(4766),
    [sym_and_pattern] = STATE(4766),
    [sym_or_pattern] = STATE(4766),
    [sym_declaration_pattern] = STATE(4766),
    [sym_expression] = STATE(5712),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(4566),
    [sym_postfix_unary_expression] = STATE(4567),
    [sym_prefix_unary_expression] = STATE(4567),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(4566),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(4567),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(4566),
    [sym_member_access_expression] = STATE(3230),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(4567),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(4566),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(4566),
    [sym_typeof_expression] = STATE(4566),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3230),
    [sym_literal] = STATE(4566),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(455),
    [sym_preproc_endregion] = STATE(455),
    [sym_preproc_line] = STATE(455),
    [sym_preproc_pragma] = STATE(455),
    [sym_preproc_nullable] = STATE(455),
    [sym_preproc_error] = STATE(455),
    [sym_preproc_warning] = STATE(455),
    [sym_preproc_define] = STATE(455),
    [sym_preproc_undef] = STATE(455),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2497),
    [sym_predefined_type] = ACTIONS(2499),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [sym_discard] = ACTIONS(2501),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(2543),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [456] = {
    [sym_attribute] = STATE(7092),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5840),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(456),
    [sym_preproc_endregion] = STATE(456),
    [sym_preproc_line] = STATE(456),
    [sym_preproc_pragma] = STATE(456),
    [sym_preproc_nullable] = STATE(456),
    [sym_preproc_error] = STATE(456),
    [sym_preproc_warning] = STATE(456),
    [sym_preproc_define] = STATE(456),
    [sym_preproc_undef] = STATE(456),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_assembly] = ACTIONS(2647),
    [anon_sym_module] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [457] = {
    [sym_attribute] = STATE(7092),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5840),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(457),
    [sym_preproc_endregion] = STATE(457),
    [sym_preproc_line] = STATE(457),
    [sym_preproc_pragma] = STATE(457),
    [sym_preproc_nullable] = STATE(457),
    [sym_preproc_error] = STATE(457),
    [sym_preproc_warning] = STATE(457),
    [sym_preproc_define] = STATE(457),
    [sym_preproc_undef] = STATE(457),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_assembly] = ACTIONS(2651),
    [anon_sym_module] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [458] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6817),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(458),
    [sym_preproc_endregion] = STATE(458),
    [sym_preproc_line] = STATE(458),
    [sym_preproc_pragma] = STATE(458),
    [sym_preproc_nullable] = STATE(458),
    [sym_preproc_error] = STATE(458),
    [sym_preproc_warning] = STATE(458),
    [sym_preproc_define] = STATE(458),
    [sym_preproc_undef] = STATE(458),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [459] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7044),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(459),
    [sym_preproc_endregion] = STATE(459),
    [sym_preproc_line] = STATE(459),
    [sym_preproc_pragma] = STATE(459),
    [sym_preproc_nullable] = STATE(459),
    [sym_preproc_error] = STATE(459),
    [sym_preproc_warning] = STATE(459),
    [sym_preproc_define] = STATE(459),
    [sym_preproc_undef] = STATE(459),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [460] = {
    [sym_attribute] = STATE(6961),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5832),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(460),
    [sym_preproc_endregion] = STATE(460),
    [sym_preproc_line] = STATE(460),
    [sym_preproc_pragma] = STATE(460),
    [sym_preproc_nullable] = STATE(460),
    [sym_preproc_error] = STATE(460),
    [sym_preproc_warning] = STATE(460),
    [sym_preproc_define] = STATE(460),
    [sym_preproc_undef] = STATE(460),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [461] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6957),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(461),
    [sym_preproc_endregion] = STATE(461),
    [sym_preproc_line] = STATE(461),
    [sym_preproc_pragma] = STATE(461),
    [sym_preproc_nullable] = STATE(461),
    [sym_preproc_error] = STATE(461),
    [sym_preproc_warning] = STATE(461),
    [sym_preproc_define] = STATE(461),
    [sym_preproc_undef] = STATE(461),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [462] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7009),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(462),
    [sym_preproc_endregion] = STATE(462),
    [sym_preproc_line] = STATE(462),
    [sym_preproc_pragma] = STATE(462),
    [sym_preproc_nullable] = STATE(462),
    [sym_preproc_error] = STATE(462),
    [sym_preproc_warning] = STATE(462),
    [sym_preproc_define] = STATE(462),
    [sym_preproc_undef] = STATE(462),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [463] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(463),
    [sym_preproc_endregion] = STATE(463),
    [sym_preproc_line] = STATE(463),
    [sym_preproc_pragma] = STATE(463),
    [sym_preproc_nullable] = STATE(463),
    [sym_preproc_error] = STATE(463),
    [sym_preproc_warning] = STATE(463),
    [sym_preproc_define] = STATE(463),
    [sym_preproc_undef] = STATE(463),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [464] = {
    [sym_attribute] = STATE(7041),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_attribute_target_specifier] = STATE(5831),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6962),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5826),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(464),
    [sym_preproc_endregion] = STATE(464),
    [sym_preproc_line] = STATE(464),
    [sym_preproc_pragma] = STATE(464),
    [sym_preproc_nullable] = STATE(464),
    [sym_preproc_error] = STATE(464),
    [sym_preproc_warning] = STATE(464),
    [sym_preproc_define] = STATE(464),
    [sym_preproc_undef] = STATE(464),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_field] = ACTIONS(1053),
    [anon_sym_event] = ACTIONS(1053),
    [anon_sym_method] = ACTIONS(1053),
    [anon_sym_param] = ACTIONS(1053),
    [anon_sym_property] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typevar] = ACTIONS(1053),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [465] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5876),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(465),
    [sym_preproc_endregion] = STATE(465),
    [sym_preproc_line] = STATE(465),
    [sym_preproc_pragma] = STATE(465),
    [sym_preproc_nullable] = STATE(465),
    [sym_preproc_error] = STATE(465),
    [sym_preproc_warning] = STATE(465),
    [sym_preproc_define] = STATE(465),
    [sym_preproc_undef] = STATE(465),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [466] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(466),
    [sym_preproc_endregion] = STATE(466),
    [sym_preproc_line] = STATE(466),
    [sym_preproc_pragma] = STATE(466),
    [sym_preproc_nullable] = STATE(466),
    [sym_preproc_error] = STATE(466),
    [sym_preproc_warning] = STATE(466),
    [sym_preproc_define] = STATE(466),
    [sym_preproc_undef] = STATE(466),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [467] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5910),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(467),
    [sym_preproc_endregion] = STATE(467),
    [sym_preproc_line] = STATE(467),
    [sym_preproc_pragma] = STATE(467),
    [sym_preproc_nullable] = STATE(467),
    [sym_preproc_error] = STATE(467),
    [sym_preproc_warning] = STATE(467),
    [sym_preproc_define] = STATE(467),
    [sym_preproc_undef] = STATE(467),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [468] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5877),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5589),
    [sym_lvalue_expression] = STATE(3633),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(468),
    [sym_preproc_endregion] = STATE(468),
    [sym_preproc_line] = STATE(468),
    [sym_preproc_pragma] = STATE(468),
    [sym_preproc_nullable] = STATE(468),
    [sym_preproc_error] = STATE(468),
    [sym_preproc_warning] = STATE(468),
    [sym_preproc_define] = STATE(468),
    [sym_preproc_undef] = STATE(468),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [469] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5887),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(469),
    [sym_preproc_endregion] = STATE(469),
    [sym_preproc_line] = STATE(469),
    [sym_preproc_pragma] = STATE(469),
    [sym_preproc_nullable] = STATE(469),
    [sym_preproc_error] = STATE(469),
    [sym_preproc_warning] = STATE(469),
    [sym_preproc_define] = STATE(469),
    [sym_preproc_undef] = STATE(469),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [470] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5912),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(470),
    [sym_preproc_endregion] = STATE(470),
    [sym_preproc_line] = STATE(470),
    [sym_preproc_pragma] = STATE(470),
    [sym_preproc_nullable] = STATE(470),
    [sym_preproc_error] = STATE(470),
    [sym_preproc_warning] = STATE(470),
    [sym_preproc_define] = STATE(470),
    [sym_preproc_undef] = STATE(470),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [471] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5875),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5435),
    [sym_lvalue_expression] = STATE(3678),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(471),
    [sym_preproc_endregion] = STATE(471),
    [sym_preproc_line] = STATE(471),
    [sym_preproc_pragma] = STATE(471),
    [sym_preproc_nullable] = STATE(471),
    [sym_preproc_error] = STATE(471),
    [sym_preproc_warning] = STATE(471),
    [sym_preproc_define] = STATE(471),
    [sym_preproc_undef] = STATE(471),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [472] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5886),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(472),
    [sym_preproc_endregion] = STATE(472),
    [sym_preproc_line] = STATE(472),
    [sym_preproc_pragma] = STATE(472),
    [sym_preproc_nullable] = STATE(472),
    [sym_preproc_error] = STATE(472),
    [sym_preproc_warning] = STATE(472),
    [sym_preproc_define] = STATE(472),
    [sym_preproc_undef] = STATE(472),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [473] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3633),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(473),
    [sym_preproc_endregion] = STATE(473),
    [sym_preproc_line] = STATE(473),
    [sym_preproc_pragma] = STATE(473),
    [sym_preproc_nullable] = STATE(473),
    [sym_preproc_error] = STATE(473),
    [sym_preproc_warning] = STATE(473),
    [sym_preproc_define] = STATE(473),
    [sym_preproc_undef] = STATE(473),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [474] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(474),
    [sym_preproc_endregion] = STATE(474),
    [sym_preproc_line] = STATE(474),
    [sym_preproc_pragma] = STATE(474),
    [sym_preproc_nullable] = STATE(474),
    [sym_preproc_error] = STATE(474),
    [sym_preproc_warning] = STATE(474),
    [sym_preproc_define] = STATE(474),
    [sym_preproc_undef] = STATE(474),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [475] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3678),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(475),
    [sym_preproc_endregion] = STATE(475),
    [sym_preproc_line] = STATE(475),
    [sym_preproc_pragma] = STATE(475),
    [sym_preproc_nullable] = STATE(475),
    [sym_preproc_error] = STATE(475),
    [sym_preproc_warning] = STATE(475),
    [sym_preproc_define] = STATE(475),
    [sym_preproc_undef] = STATE(475),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [476] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5847),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(476),
    [sym_preproc_endregion] = STATE(476),
    [sym_preproc_line] = STATE(476),
    [sym_preproc_pragma] = STATE(476),
    [sym_preproc_nullable] = STATE(476),
    [sym_preproc_error] = STATE(476),
    [sym_preproc_warning] = STATE(476),
    [sym_preproc_define] = STATE(476),
    [sym_preproc_undef] = STATE(476),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [477] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5908),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(477),
    [sym_preproc_endregion] = STATE(477),
    [sym_preproc_line] = STATE(477),
    [sym_preproc_pragma] = STATE(477),
    [sym_preproc_nullable] = STATE(477),
    [sym_preproc_error] = STATE(477),
    [sym_preproc_warning] = STATE(477),
    [sym_preproc_define] = STATE(477),
    [sym_preproc_undef] = STATE(477),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [478] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5866),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(478),
    [sym_preproc_endregion] = STATE(478),
    [sym_preproc_line] = STATE(478),
    [sym_preproc_pragma] = STATE(478),
    [sym_preproc_nullable] = STATE(478),
    [sym_preproc_error] = STATE(478),
    [sym_preproc_warning] = STATE(478),
    [sym_preproc_define] = STATE(478),
    [sym_preproc_undef] = STATE(478),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [479] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5895),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(479),
    [sym_preproc_endregion] = STATE(479),
    [sym_preproc_line] = STATE(479),
    [sym_preproc_pragma] = STATE(479),
    [sym_preproc_nullable] = STATE(479),
    [sym_preproc_error] = STATE(479),
    [sym_preproc_warning] = STATE(479),
    [sym_preproc_define] = STATE(479),
    [sym_preproc_undef] = STATE(479),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [480] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(480),
    [sym_preproc_endregion] = STATE(480),
    [sym_preproc_line] = STATE(480),
    [sym_preproc_pragma] = STATE(480),
    [sym_preproc_nullable] = STATE(480),
    [sym_preproc_error] = STATE(480),
    [sym_preproc_warning] = STATE(480),
    [sym_preproc_define] = STATE(480),
    [sym_preproc_undef] = STATE(480),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [481] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5911),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(481),
    [sym_preproc_endregion] = STATE(481),
    [sym_preproc_line] = STATE(481),
    [sym_preproc_pragma] = STATE(481),
    [sym_preproc_nullable] = STATE(481),
    [sym_preproc_error] = STATE(481),
    [sym_preproc_warning] = STATE(481),
    [sym_preproc_define] = STATE(481),
    [sym_preproc_undef] = STATE(481),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [482] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5915),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5589),
    [sym_lvalue_expression] = STATE(3633),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(482),
    [sym_preproc_endregion] = STATE(482),
    [sym_preproc_line] = STATE(482),
    [sym_preproc_pragma] = STATE(482),
    [sym_preproc_nullable] = STATE(482),
    [sym_preproc_error] = STATE(482),
    [sym_preproc_warning] = STATE(482),
    [sym_preproc_define] = STATE(482),
    [sym_preproc_undef] = STATE(482),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [483] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5882),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(483),
    [sym_preproc_endregion] = STATE(483),
    [sym_preproc_line] = STATE(483),
    [sym_preproc_pragma] = STATE(483),
    [sym_preproc_nullable] = STATE(483),
    [sym_preproc_error] = STATE(483),
    [sym_preproc_warning] = STATE(483),
    [sym_preproc_define] = STATE(483),
    [sym_preproc_undef] = STATE(483),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [484] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5897),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5435),
    [sym_lvalue_expression] = STATE(3678),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(484),
    [sym_preproc_endregion] = STATE(484),
    [sym_preproc_line] = STATE(484),
    [sym_preproc_pragma] = STATE(484),
    [sym_preproc_nullable] = STATE(484),
    [sym_preproc_error] = STATE(484),
    [sym_preproc_warning] = STATE(484),
    [sym_preproc_define] = STATE(484),
    [sym_preproc_undef] = STATE(484),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [485] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5890),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(485),
    [sym_preproc_endregion] = STATE(485),
    [sym_preproc_line] = STATE(485),
    [sym_preproc_pragma] = STATE(485),
    [sym_preproc_nullable] = STATE(485),
    [sym_preproc_error] = STATE(485),
    [sym_preproc_warning] = STATE(485),
    [sym_preproc_define] = STATE(485),
    [sym_preproc_undef] = STATE(485),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [486] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5883),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(486),
    [sym_preproc_endregion] = STATE(486),
    [sym_preproc_line] = STATE(486),
    [sym_preproc_pragma] = STATE(486),
    [sym_preproc_nullable] = STATE(486),
    [sym_preproc_error] = STATE(486),
    [sym_preproc_warning] = STATE(486),
    [sym_preproc_define] = STATE(486),
    [sym_preproc_undef] = STATE(486),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [487] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5871),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(487),
    [sym_preproc_endregion] = STATE(487),
    [sym_preproc_line] = STATE(487),
    [sym_preproc_pragma] = STATE(487),
    [sym_preproc_nullable] = STATE(487),
    [sym_preproc_error] = STATE(487),
    [sym_preproc_warning] = STATE(487),
    [sym_preproc_define] = STATE(487),
    [sym_preproc_undef] = STATE(487),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [488] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5872),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(488),
    [sym_preproc_endregion] = STATE(488),
    [sym_preproc_line] = STATE(488),
    [sym_preproc_pragma] = STATE(488),
    [sym_preproc_nullable] = STATE(488),
    [sym_preproc_error] = STATE(488),
    [sym_preproc_warning] = STATE(488),
    [sym_preproc_define] = STATE(488),
    [sym_preproc_undef] = STATE(488),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [489] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5884),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5589),
    [sym_lvalue_expression] = STATE(3633),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(489),
    [sym_preproc_endregion] = STATE(489),
    [sym_preproc_line] = STATE(489),
    [sym_preproc_pragma] = STATE(489),
    [sym_preproc_nullable] = STATE(489),
    [sym_preproc_error] = STATE(489),
    [sym_preproc_warning] = STATE(489),
    [sym_preproc_define] = STATE(489),
    [sym_preproc_undef] = STATE(489),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [490] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5879),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(490),
    [sym_preproc_endregion] = STATE(490),
    [sym_preproc_line] = STATE(490),
    [sym_preproc_pragma] = STATE(490),
    [sym_preproc_nullable] = STATE(490),
    [sym_preproc_error] = STATE(490),
    [sym_preproc_warning] = STATE(490),
    [sym_preproc_define] = STATE(490),
    [sym_preproc_undef] = STATE(490),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [491] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5888),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5435),
    [sym_lvalue_expression] = STATE(3678),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(491),
    [sym_preproc_endregion] = STATE(491),
    [sym_preproc_line] = STATE(491),
    [sym_preproc_pragma] = STATE(491),
    [sym_preproc_nullable] = STATE(491),
    [sym_preproc_error] = STATE(491),
    [sym_preproc_warning] = STATE(491),
    [sym_preproc_define] = STATE(491),
    [sym_preproc_undef] = STATE(491),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [492] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5889),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(492),
    [sym_preproc_endregion] = STATE(492),
    [sym_preproc_line] = STATE(492),
    [sym_preproc_pragma] = STATE(492),
    [sym_preproc_nullable] = STATE(492),
    [sym_preproc_error] = STATE(492),
    [sym_preproc_warning] = STATE(492),
    [sym_preproc_define] = STATE(492),
    [sym_preproc_undef] = STATE(492),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [493] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7211),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(493),
    [sym_preproc_endregion] = STATE(493),
    [sym_preproc_line] = STATE(493),
    [sym_preproc_pragma] = STATE(493),
    [sym_preproc_nullable] = STATE(493),
    [sym_preproc_error] = STATE(493),
    [sym_preproc_warning] = STATE(493),
    [sym_preproc_define] = STATE(493),
    [sym_preproc_undef] = STATE(493),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [494] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(494),
    [sym_preproc_endregion] = STATE(494),
    [sym_preproc_line] = STATE(494),
    [sym_preproc_pragma] = STATE(494),
    [sym_preproc_nullable] = STATE(494),
    [sym_preproc_error] = STATE(494),
    [sym_preproc_warning] = STATE(494),
    [sym_preproc_define] = STATE(494),
    [sym_preproc_undef] = STATE(494),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [495] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5903),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(495),
    [sym_preproc_endregion] = STATE(495),
    [sym_preproc_line] = STATE(495),
    [sym_preproc_pragma] = STATE(495),
    [sym_preproc_nullable] = STATE(495),
    [sym_preproc_error] = STATE(495),
    [sym_preproc_warning] = STATE(495),
    [sym_preproc_define] = STATE(495),
    [sym_preproc_undef] = STATE(495),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [496] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5905),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(496),
    [sym_preproc_endregion] = STATE(496),
    [sym_preproc_line] = STATE(496),
    [sym_preproc_pragma] = STATE(496),
    [sym_preproc_nullable] = STATE(496),
    [sym_preproc_error] = STATE(496),
    [sym_preproc_warning] = STATE(496),
    [sym_preproc_define] = STATE(496),
    [sym_preproc_undef] = STATE(496),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [497] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5916),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(497),
    [sym_preproc_endregion] = STATE(497),
    [sym_preproc_line] = STATE(497),
    [sym_preproc_pragma] = STATE(497),
    [sym_preproc_nullable] = STATE(497),
    [sym_preproc_error] = STATE(497),
    [sym_preproc_warning] = STATE(497),
    [sym_preproc_define] = STATE(497),
    [sym_preproc_undef] = STATE(497),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [498] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5848),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(498),
    [sym_preproc_endregion] = STATE(498),
    [sym_preproc_line] = STATE(498),
    [sym_preproc_pragma] = STATE(498),
    [sym_preproc_nullable] = STATE(498),
    [sym_preproc_error] = STATE(498),
    [sym_preproc_warning] = STATE(498),
    [sym_preproc_define] = STATE(498),
    [sym_preproc_undef] = STATE(498),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [499] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5850),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(499),
    [sym_preproc_endregion] = STATE(499),
    [sym_preproc_line] = STATE(499),
    [sym_preproc_pragma] = STATE(499),
    [sym_preproc_nullable] = STATE(499),
    [sym_preproc_error] = STATE(499),
    [sym_preproc_warning] = STATE(499),
    [sym_preproc_define] = STATE(499),
    [sym_preproc_undef] = STATE(499),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [500] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5854),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(500),
    [sym_preproc_endregion] = STATE(500),
    [sym_preproc_line] = STATE(500),
    [sym_preproc_pragma] = STATE(500),
    [sym_preproc_nullable] = STATE(500),
    [sym_preproc_error] = STATE(500),
    [sym_preproc_warning] = STATE(500),
    [sym_preproc_define] = STATE(500),
    [sym_preproc_undef] = STATE(500),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [501] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7106),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5892),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5589),
    [sym_lvalue_expression] = STATE(3633),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(501),
    [sym_preproc_endregion] = STATE(501),
    [sym_preproc_line] = STATE(501),
    [sym_preproc_pragma] = STATE(501),
    [sym_preproc_nullable] = STATE(501),
    [sym_preproc_error] = STATE(501),
    [sym_preproc_warning] = STATE(501),
    [sym_preproc_define] = STATE(501),
    [sym_preproc_undef] = STATE(501),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [502] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5855),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(502),
    [sym_preproc_endregion] = STATE(502),
    [sym_preproc_line] = STATE(502),
    [sym_preproc_pragma] = STATE(502),
    [sym_preproc_nullable] = STATE(502),
    [sym_preproc_error] = STATE(502),
    [sym_preproc_warning] = STATE(502),
    [sym_preproc_define] = STATE(502),
    [sym_preproc_undef] = STATE(502),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [503] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7136),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5893),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5435),
    [sym_lvalue_expression] = STATE(3678),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(503),
    [sym_preproc_endregion] = STATE(503),
    [sym_preproc_line] = STATE(503),
    [sym_preproc_pragma] = STATE(503),
    [sym_preproc_nullable] = STATE(503),
    [sym_preproc_error] = STATE(503),
    [sym_preproc_warning] = STATE(503),
    [sym_preproc_define] = STATE(503),
    [sym_preproc_undef] = STATE(503),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [504] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5856),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3643),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(504),
    [sym_preproc_endregion] = STATE(504),
    [sym_preproc_line] = STATE(504),
    [sym_preproc_pragma] = STATE(504),
    [sym_preproc_nullable] = STATE(504),
    [sym_preproc_error] = STATE(504),
    [sym_preproc_warning] = STATE(504),
    [sym_preproc_define] = STATE(504),
    [sym_preproc_undef] = STATE(504),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [505] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5862),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(505),
    [sym_preproc_endregion] = STATE(505),
    [sym_preproc_line] = STATE(505),
    [sym_preproc_pragma] = STATE(505),
    [sym_preproc_nullable] = STATE(505),
    [sym_preproc_error] = STATE(505),
    [sym_preproc_warning] = STATE(505),
    [sym_preproc_define] = STATE(505),
    [sym_preproc_undef] = STATE(505),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [506] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5864),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(506),
    [sym_preproc_endregion] = STATE(506),
    [sym_preproc_line] = STATE(506),
    [sym_preproc_pragma] = STATE(506),
    [sym_preproc_nullable] = STATE(506),
    [sym_preproc_error] = STATE(506),
    [sym_preproc_warning] = STATE(506),
    [sym_preproc_define] = STATE(506),
    [sym_preproc_undef] = STATE(506),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [507] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5867),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(507),
    [sym_preproc_endregion] = STATE(507),
    [sym_preproc_line] = STATE(507),
    [sym_preproc_pragma] = STATE(507),
    [sym_preproc_nullable] = STATE(507),
    [sym_preproc_error] = STATE(507),
    [sym_preproc_warning] = STATE(507),
    [sym_preproc_define] = STATE(507),
    [sym_preproc_undef] = STATE(507),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [508] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5880),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(508),
    [sym_preproc_endregion] = STATE(508),
    [sym_preproc_line] = STATE(508),
    [sym_preproc_pragma] = STATE(508),
    [sym_preproc_nullable] = STATE(508),
    [sym_preproc_error] = STATE(508),
    [sym_preproc_warning] = STATE(508),
    [sym_preproc_define] = STATE(508),
    [sym_preproc_undef] = STATE(508),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [509] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5900),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(509),
    [sym_preproc_endregion] = STATE(509),
    [sym_preproc_line] = STATE(509),
    [sym_preproc_pragma] = STATE(509),
    [sym_preproc_nullable] = STATE(509),
    [sym_preproc_error] = STATE(509),
    [sym_preproc_warning] = STATE(509),
    [sym_preproc_define] = STATE(509),
    [sym_preproc_undef] = STATE(509),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [510] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5902),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5378),
    [sym_lvalue_expression] = STATE(3672),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(510),
    [sym_preproc_endregion] = STATE(510),
    [sym_preproc_line] = STATE(510),
    [sym_preproc_pragma] = STATE(510),
    [sym_preproc_nullable] = STATE(510),
    [sym_preproc_error] = STATE(510),
    [sym_preproc_warning] = STATE(510),
    [sym_preproc_define] = STATE(510),
    [sym_preproc_undef] = STATE(510),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [511] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5904),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(511),
    [sym_preproc_endregion] = STATE(511),
    [sym_preproc_line] = STATE(511),
    [sym_preproc_pragma] = STATE(511),
    [sym_preproc_nullable] = STATE(511),
    [sym_preproc_error] = STATE(511),
    [sym_preproc_warning] = STATE(511),
    [sym_preproc_define] = STATE(511),
    [sym_preproc_undef] = STATE(511),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [512] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5896),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(512),
    [sym_preproc_endregion] = STATE(512),
    [sym_preproc_line] = STATE(512),
    [sym_preproc_pragma] = STATE(512),
    [sym_preproc_nullable] = STATE(512),
    [sym_preproc_error] = STATE(512),
    [sym_preproc_warning] = STATE(512),
    [sym_preproc_define] = STATE(512),
    [sym_preproc_undef] = STATE(512),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [513] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5914),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(513),
    [sym_preproc_endregion] = STATE(513),
    [sym_preproc_line] = STATE(513),
    [sym_preproc_pragma] = STATE(513),
    [sym_preproc_nullable] = STATE(513),
    [sym_preproc_error] = STATE(513),
    [sym_preproc_warning] = STATE(513),
    [sym_preproc_define] = STATE(513),
    [sym_preproc_undef] = STATE(513),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [514] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5913),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(514),
    [sym_preproc_endregion] = STATE(514),
    [sym_preproc_line] = STATE(514),
    [sym_preproc_pragma] = STATE(514),
    [sym_preproc_nullable] = STATE(514),
    [sym_preproc_error] = STATE(514),
    [sym_preproc_warning] = STATE(514),
    [sym_preproc_define] = STATE(514),
    [sym_preproc_undef] = STATE(514),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [515] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5853),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(515),
    [sym_preproc_endregion] = STATE(515),
    [sym_preproc_line] = STATE(515),
    [sym_preproc_pragma] = STATE(515),
    [sym_preproc_nullable] = STATE(515),
    [sym_preproc_error] = STATE(515),
    [sym_preproc_warning] = STATE(515),
    [sym_preproc_define] = STATE(515),
    [sym_preproc_undef] = STATE(515),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [516] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5858),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(516),
    [sym_preproc_endregion] = STATE(516),
    [sym_preproc_line] = STATE(516),
    [sym_preproc_pragma] = STATE(516),
    [sym_preproc_nullable] = STATE(516),
    [sym_preproc_error] = STATE(516),
    [sym_preproc_warning] = STATE(516),
    [sym_preproc_define] = STATE(516),
    [sym_preproc_undef] = STATE(516),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [517] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(517),
    [sym_preproc_endregion] = STATE(517),
    [sym_preproc_line] = STATE(517),
    [sym_preproc_pragma] = STATE(517),
    [sym_preproc_nullable] = STATE(517),
    [sym_preproc_error] = STATE(517),
    [sym_preproc_warning] = STATE(517),
    [sym_preproc_define] = STATE(517),
    [sym_preproc_undef] = STATE(517),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [518] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7145),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5917),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(518),
    [sym_preproc_endregion] = STATE(518),
    [sym_preproc_line] = STATE(518),
    [sym_preproc_pragma] = STATE(518),
    [sym_preproc_nullable] = STATE(518),
    [sym_preproc_error] = STATE(518),
    [sym_preproc_warning] = STATE(518),
    [sym_preproc_define] = STATE(518),
    [sym_preproc_undef] = STATE(518),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [519] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5865),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(519),
    [sym_preproc_endregion] = STATE(519),
    [sym_preproc_line] = STATE(519),
    [sym_preproc_pragma] = STATE(519),
    [sym_preproc_nullable] = STATE(519),
    [sym_preproc_error] = STATE(519),
    [sym_preproc_warning] = STATE(519),
    [sym_preproc_define] = STATE(519),
    [sym_preproc_undef] = STATE(519),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [520] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5868),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(520),
    [sym_preproc_endregion] = STATE(520),
    [sym_preproc_line] = STATE(520),
    [sym_preproc_pragma] = STATE(520),
    [sym_preproc_nullable] = STATE(520),
    [sym_preproc_error] = STATE(520),
    [sym_preproc_warning] = STATE(520),
    [sym_preproc_define] = STATE(520),
    [sym_preproc_undef] = STATE(520),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [521] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5870),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(521),
    [sym_preproc_endregion] = STATE(521),
    [sym_preproc_line] = STATE(521),
    [sym_preproc_pragma] = STATE(521),
    [sym_preproc_nullable] = STATE(521),
    [sym_preproc_error] = STATE(521),
    [sym_preproc_warning] = STATE(521),
    [sym_preproc_define] = STATE(521),
    [sym_preproc_undef] = STATE(521),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [522] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5873),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5488),
    [sym_lvalue_expression] = STATE(3666),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(522),
    [sym_preproc_endregion] = STATE(522),
    [sym_preproc_line] = STATE(522),
    [sym_preproc_pragma] = STATE(522),
    [sym_preproc_nullable] = STATE(522),
    [sym_preproc_error] = STATE(522),
    [sym_preproc_warning] = STATE(522),
    [sym_preproc_define] = STATE(522),
    [sym_preproc_undef] = STATE(522),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [523] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_argument] = STATE(7337),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5898),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(5404),
    [sym_lvalue_expression] = STATE(3658),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2292),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(523),
    [sym_preproc_endregion] = STATE(523),
    [sym_preproc_line] = STATE(523),
    [sym_preproc_pragma] = STATE(523),
    [sym_preproc_nullable] = STATE(523),
    [sym_preproc_error] = STATE(523),
    [sym_preproc_warning] = STATE(523),
    [sym_preproc_define] = STATE(523),
    [sym_preproc_undef] = STATE(523),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2893),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_out] = ACTIONS(1127),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(1135),
    [anon_sym_scoped] = ACTIONS(1137),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [524] = {
    [sym_attribute_list] = STATE(5520),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4457),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7767),
    [sym_preproc_elif_in_expression] = STATE(7767),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7770),
    [sym_preproc_elif_in_attribute_list] = STATE(7770),
    [sym_preproc_region] = STATE(524),
    [sym_preproc_endregion] = STATE(524),
    [sym_preproc_line] = STATE(524),
    [sym_preproc_pragma] = STATE(524),
    [sym_preproc_nullable] = STATE(524),
    [sym_preproc_error] = STATE(524),
    [sym_preproc_warning] = STATE(524),
    [sym_preproc_define] = STATE(524),
    [sym_preproc_undef] = STATE(524),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2659),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [525] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4490),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7511),
    [sym_preproc_elif_in_expression] = STATE(7511),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(525),
    [sym_preproc_endregion] = STATE(525),
    [sym_preproc_line] = STATE(525),
    [sym_preproc_pragma] = STATE(525),
    [sym_preproc_nullable] = STATE(525),
    [sym_preproc_error] = STATE(525),
    [sym_preproc_warning] = STATE(525),
    [sym_preproc_define] = STATE(525),
    [sym_preproc_undef] = STATE(525),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [526] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4454),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7669),
    [sym_preproc_elif_in_expression] = STATE(7669),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(526),
    [sym_preproc_endregion] = STATE(526),
    [sym_preproc_line] = STATE(526),
    [sym_preproc_pragma] = STATE(526),
    [sym_preproc_nullable] = STATE(526),
    [sym_preproc_error] = STATE(526),
    [sym_preproc_warning] = STATE(526),
    [sym_preproc_define] = STATE(526),
    [sym_preproc_undef] = STATE(526),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2667),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [527] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4477),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7656),
    [sym_preproc_elif_in_expression] = STATE(7656),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(527),
    [sym_preproc_endregion] = STATE(527),
    [sym_preproc_line] = STATE(527),
    [sym_preproc_pragma] = STATE(527),
    [sym_preproc_nullable] = STATE(527),
    [sym_preproc_error] = STATE(527),
    [sym_preproc_warning] = STATE(527),
    [sym_preproc_define] = STATE(527),
    [sym_preproc_undef] = STATE(527),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [528] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4512),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7530),
    [sym_preproc_elif_in_expression] = STATE(7530),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(528),
    [sym_preproc_endregion] = STATE(528),
    [sym_preproc_line] = STATE(528),
    [sym_preproc_pragma] = STATE(528),
    [sym_preproc_nullable] = STATE(528),
    [sym_preproc_error] = STATE(528),
    [sym_preproc_warning] = STATE(528),
    [sym_preproc_define] = STATE(528),
    [sym_preproc_undef] = STATE(528),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [529] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(529),
    [sym_preproc_endregion] = STATE(529),
    [sym_preproc_line] = STATE(529),
    [sym_preproc_pragma] = STATE(529),
    [sym_preproc_nullable] = STATE(529),
    [sym_preproc_error] = STATE(529),
    [sym_preproc_warning] = STATE(529),
    [sym_preproc_define] = STATE(529),
    [sym_preproc_undef] = STATE(529),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [530] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4541),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7365),
    [sym_preproc_elif_in_expression] = STATE(7365),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(530),
    [sym_preproc_endregion] = STATE(530),
    [sym_preproc_line] = STATE(530),
    [sym_preproc_pragma] = STATE(530),
    [sym_preproc_nullable] = STATE(530),
    [sym_preproc_error] = STATE(530),
    [sym_preproc_warning] = STATE(530),
    [sym_preproc_define] = STATE(530),
    [sym_preproc_undef] = STATE(530),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [531] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4453),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7477),
    [sym_preproc_elif_in_expression] = STATE(7477),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(531),
    [sym_preproc_endregion] = STATE(531),
    [sym_preproc_line] = STATE(531),
    [sym_preproc_pragma] = STATE(531),
    [sym_preproc_nullable] = STATE(531),
    [sym_preproc_error] = STATE(531),
    [sym_preproc_warning] = STATE(531),
    [sym_preproc_define] = STATE(531),
    [sym_preproc_undef] = STATE(531),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [532] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4490),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7511),
    [sym_preproc_elif_in_expression] = STATE(7511),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(532),
    [sym_preproc_endregion] = STATE(532),
    [sym_preproc_line] = STATE(532),
    [sym_preproc_pragma] = STATE(532),
    [sym_preproc_nullable] = STATE(532),
    [sym_preproc_error] = STATE(532),
    [sym_preproc_warning] = STATE(532),
    [sym_preproc_define] = STATE(532),
    [sym_preproc_undef] = STATE(532),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [533] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4512),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7530),
    [sym_preproc_elif_in_expression] = STATE(7530),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(533),
    [sym_preproc_endregion] = STATE(533),
    [sym_preproc_line] = STATE(533),
    [sym_preproc_pragma] = STATE(533),
    [sym_preproc_nullable] = STATE(533),
    [sym_preproc_error] = STATE(533),
    [sym_preproc_warning] = STATE(533),
    [sym_preproc_define] = STATE(533),
    [sym_preproc_undef] = STATE(533),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [534] = {
    [sym_attribute_list] = STATE(5439),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4541),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7365),
    [sym_preproc_elif_in_expression] = STATE(7365),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_else_in_attribute_list] = STATE(7663),
    [sym_preproc_elif_in_attribute_list] = STATE(7663),
    [sym_preproc_region] = STATE(534),
    [sym_preproc_endregion] = STATE(534),
    [sym_preproc_line] = STATE(534),
    [sym_preproc_pragma] = STATE(534),
    [sym_preproc_nullable] = STATE(534),
    [sym_preproc_error] = STATE(534),
    [sym_preproc_warning] = STATE(534),
    [sym_preproc_define] = STATE(534),
    [sym_preproc_undef] = STATE(534),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [535] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7000),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(535),
    [sym_preproc_endregion] = STATE(535),
    [sym_preproc_line] = STATE(535),
    [sym_preproc_pragma] = STATE(535),
    [sym_preproc_nullable] = STATE(535),
    [sym_preproc_error] = STATE(535),
    [sym_preproc_warning] = STATE(535),
    [sym_preproc_define] = STATE(535),
    [sym_preproc_undef] = STATE(535),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [536] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6971),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7167),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(536),
    [sym_preproc_endregion] = STATE(536),
    [sym_preproc_line] = STATE(536),
    [sym_preproc_pragma] = STATE(536),
    [sym_preproc_nullable] = STATE(536),
    [sym_preproc_error] = STATE(536),
    [sym_preproc_warning] = STATE(536),
    [sym_preproc_define] = STATE(536),
    [sym_preproc_undef] = STATE(536),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2677),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [537] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6985),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7239),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(537),
    [sym_preproc_endregion] = STATE(537),
    [sym_preproc_line] = STATE(537),
    [sym_preproc_pragma] = STATE(537),
    [sym_preproc_nullable] = STATE(537),
    [sym_preproc_error] = STATE(537),
    [sym_preproc_warning] = STATE(537),
    [sym_preproc_define] = STATE(537),
    [sym_preproc_undef] = STATE(537),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2679),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [538] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6971),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7154),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(538),
    [sym_preproc_endregion] = STATE(538),
    [sym_preproc_line] = STATE(538),
    [sym_preproc_pragma] = STATE(538),
    [sym_preproc_nullable] = STATE(538),
    [sym_preproc_error] = STATE(538),
    [sym_preproc_warning] = STATE(538),
    [sym_preproc_define] = STATE(538),
    [sym_preproc_undef] = STATE(538),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2677),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [539] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6934),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7137),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(539),
    [sym_preproc_endregion] = STATE(539),
    [sym_preproc_line] = STATE(539),
    [sym_preproc_pragma] = STATE(539),
    [sym_preproc_nullable] = STATE(539),
    [sym_preproc_error] = STATE(539),
    [sym_preproc_warning] = STATE(539),
    [sym_preproc_define] = STATE(539),
    [sym_preproc_undef] = STATE(539),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2681),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [540] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6988),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7234),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(540),
    [sym_preproc_endregion] = STATE(540),
    [sym_preproc_line] = STATE(540),
    [sym_preproc_pragma] = STATE(540),
    [sym_preproc_nullable] = STATE(540),
    [sym_preproc_error] = STATE(540),
    [sym_preproc_warning] = STATE(540),
    [sym_preproc_define] = STATE(540),
    [sym_preproc_undef] = STATE(540),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2683),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [541] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6934),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5921),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7154),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(541),
    [sym_preproc_endregion] = STATE(541),
    [sym_preproc_line] = STATE(541),
    [sym_preproc_pragma] = STATE(541),
    [sym_preproc_nullable] = STATE(541),
    [sym_preproc_error] = STATE(541),
    [sym_preproc_warning] = STATE(541),
    [sym_preproc_define] = STATE(541),
    [sym_preproc_undef] = STATE(541),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2681),
    [anon_sym_ref] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2675),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [542] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6971),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(542),
    [sym_preproc_endregion] = STATE(542),
    [sym_preproc_line] = STATE(542),
    [sym_preproc_pragma] = STATE(542),
    [sym_preproc_nullable] = STATE(542),
    [sym_preproc_error] = STATE(542),
    [sym_preproc_warning] = STATE(542),
    [sym_preproc_define] = STATE(542),
    [sym_preproc_undef] = STATE(542),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2677),
    [anon_sym_ref] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [543] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(543),
    [sym_preproc_endregion] = STATE(543),
    [sym_preproc_line] = STATE(543),
    [sym_preproc_pragma] = STATE(543),
    [sym_preproc_nullable] = STATE(543),
    [sym_preproc_error] = STATE(543),
    [sym_preproc_warning] = STATE(543),
    [sym_preproc_define] = STATE(543),
    [sym_preproc_undef] = STATE(543),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [544] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(544),
    [sym_preproc_endregion] = STATE(544),
    [sym_preproc_line] = STATE(544),
    [sym_preproc_pragma] = STATE(544),
    [sym_preproc_nullable] = STATE(544),
    [sym_preproc_error] = STATE(544),
    [sym_preproc_warning] = STATE(544),
    [sym_preproc_define] = STATE(544),
    [sym_preproc_undef] = STATE(544),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2689),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [545] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(545),
    [sym_preproc_endregion] = STATE(545),
    [sym_preproc_line] = STATE(545),
    [sym_preproc_pragma] = STATE(545),
    [sym_preproc_nullable] = STATE(545),
    [sym_preproc_error] = STATE(545),
    [sym_preproc_warning] = STATE(545),
    [sym_preproc_define] = STATE(545),
    [sym_preproc_undef] = STATE(545),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [546] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(546),
    [sym_preproc_endregion] = STATE(546),
    [sym_preproc_line] = STATE(546),
    [sym_preproc_pragma] = STATE(546),
    [sym_preproc_nullable] = STATE(546),
    [sym_preproc_error] = STATE(546),
    [sym_preproc_warning] = STATE(546),
    [sym_preproc_define] = STATE(546),
    [sym_preproc_undef] = STATE(546),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2693),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [547] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(547),
    [sym_preproc_endregion] = STATE(547),
    [sym_preproc_line] = STATE(547),
    [sym_preproc_pragma] = STATE(547),
    [sym_preproc_nullable] = STATE(547),
    [sym_preproc_error] = STATE(547),
    [sym_preproc_warning] = STATE(547),
    [sym_preproc_define] = STATE(547),
    [sym_preproc_undef] = STATE(547),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [548] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7000),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(548),
    [sym_preproc_endregion] = STATE(548),
    [sym_preproc_line] = STATE(548),
    [sym_preproc_pragma] = STATE(548),
    [sym_preproc_nullable] = STATE(548),
    [sym_preproc_error] = STATE(548),
    [sym_preproc_warning] = STATE(548),
    [sym_preproc_define] = STATE(548),
    [sym_preproc_undef] = STATE(548),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2671),
    [anon_sym_ref] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [549] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4457),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_else_in_expression] = STATE(7767),
    [sym_preproc_elif_in_expression] = STATE(7767),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(549),
    [sym_preproc_endregion] = STATE(549),
    [sym_preproc_line] = STATE(549),
    [sym_preproc_pragma] = STATE(549),
    [sym_preproc_nullable] = STATE(549),
    [sym_preproc_error] = STATE(549),
    [sym_preproc_warning] = STATE(549),
    [sym_preproc_define] = STATE(549),
    [sym_preproc_undef] = STATE(549),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2697),
    [aux_sym_preproc_else_token1] = ACTIONS(2699),
    [aux_sym_preproc_elif_token1] = ACTIONS(2701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [550] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6985),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(550),
    [sym_preproc_endregion] = STATE(550),
    [sym_preproc_line] = STATE(550),
    [sym_preproc_pragma] = STATE(550),
    [sym_preproc_nullable] = STATE(550),
    [sym_preproc_error] = STATE(550),
    [sym_preproc_warning] = STATE(550),
    [sym_preproc_define] = STATE(550),
    [sym_preproc_undef] = STATE(550),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2679),
    [anon_sym_ref] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [551] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(551),
    [sym_preproc_endregion] = STATE(551),
    [sym_preproc_line] = STATE(551),
    [sym_preproc_pragma] = STATE(551),
    [sym_preproc_nullable] = STATE(551),
    [sym_preproc_error] = STATE(551),
    [sym_preproc_warning] = STATE(551),
    [sym_preproc_define] = STATE(551),
    [sym_preproc_undef] = STATE(551),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [552] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(552),
    [sym_preproc_endregion] = STATE(552),
    [sym_preproc_line] = STATE(552),
    [sym_preproc_pragma] = STATE(552),
    [sym_preproc_nullable] = STATE(552),
    [sym_preproc_error] = STATE(552),
    [sym_preproc_warning] = STATE(552),
    [sym_preproc_define] = STATE(552),
    [sym_preproc_undef] = STATE(552),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2705),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [553] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(553),
    [sym_preproc_endregion] = STATE(553),
    [sym_preproc_line] = STATE(553),
    [sym_preproc_pragma] = STATE(553),
    [sym_preproc_nullable] = STATE(553),
    [sym_preproc_error] = STATE(553),
    [sym_preproc_warning] = STATE(553),
    [sym_preproc_define] = STATE(553),
    [sym_preproc_undef] = STATE(553),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [554] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6934),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(554),
    [sym_preproc_endregion] = STATE(554),
    [sym_preproc_line] = STATE(554),
    [sym_preproc_pragma] = STATE(554),
    [sym_preproc_nullable] = STATE(554),
    [sym_preproc_error] = STATE(554),
    [sym_preproc_warning] = STATE(554),
    [sym_preproc_define] = STATE(554),
    [sym_preproc_undef] = STATE(554),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2681),
    [anon_sym_ref] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [555] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(555),
    [sym_preproc_endregion] = STATE(555),
    [sym_preproc_line] = STATE(555),
    [sym_preproc_pragma] = STATE(555),
    [sym_preproc_nullable] = STATE(555),
    [sym_preproc_error] = STATE(555),
    [sym_preproc_warning] = STATE(555),
    [sym_preproc_define] = STATE(555),
    [sym_preproc_undef] = STATE(555),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [556] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6988),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(556),
    [sym_preproc_endregion] = STATE(556),
    [sym_preproc_line] = STATE(556),
    [sym_preproc_pragma] = STATE(556),
    [sym_preproc_nullable] = STATE(556),
    [sym_preproc_error] = STATE(556),
    [sym_preproc_warning] = STATE(556),
    [sym_preproc_define] = STATE(556),
    [sym_preproc_undef] = STATE(556),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2683),
    [anon_sym_ref] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [557] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(557),
    [sym_preproc_endregion] = STATE(557),
    [sym_preproc_line] = STATE(557),
    [sym_preproc_pragma] = STATE(557),
    [sym_preproc_nullable] = STATE(557),
    [sym_preproc_error] = STATE(557),
    [sym_preproc_warning] = STATE(557),
    [sym_preproc_define] = STATE(557),
    [sym_preproc_undef] = STATE(557),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [558] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(558),
    [sym_preproc_endregion] = STATE(558),
    [sym_preproc_line] = STATE(558),
    [sym_preproc_pragma] = STATE(558),
    [sym_preproc_nullable] = STATE(558),
    [sym_preproc_error] = STATE(558),
    [sym_preproc_warning] = STATE(558),
    [sym_preproc_define] = STATE(558),
    [sym_preproc_undef] = STATE(558),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [559] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(559),
    [sym_preproc_endregion] = STATE(559),
    [sym_preproc_line] = STATE(559),
    [sym_preproc_pragma] = STATE(559),
    [sym_preproc_nullable] = STATE(559),
    [sym_preproc_error] = STATE(559),
    [sym_preproc_warning] = STATE(559),
    [sym_preproc_define] = STATE(559),
    [sym_preproc_undef] = STATE(559),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [560] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6817),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(560),
    [sym_preproc_endregion] = STATE(560),
    [sym_preproc_line] = STATE(560),
    [sym_preproc_pragma] = STATE(560),
    [sym_preproc_nullable] = STATE(560),
    [sym_preproc_error] = STATE(560),
    [sym_preproc_warning] = STATE(560),
    [sym_preproc_define] = STATE(560),
    [sym_preproc_undef] = STATE(560),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [561] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7044),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(561),
    [sym_preproc_endregion] = STATE(561),
    [sym_preproc_line] = STATE(561),
    [sym_preproc_pragma] = STATE(561),
    [sym_preproc_nullable] = STATE(561),
    [sym_preproc_error] = STATE(561),
    [sym_preproc_warning] = STATE(561),
    [sym_preproc_define] = STATE(561),
    [sym_preproc_undef] = STATE(561),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [562] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5282),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(562),
    [sym_preproc_endregion] = STATE(562),
    [sym_preproc_line] = STATE(562),
    [sym_preproc_pragma] = STATE(562),
    [sym_preproc_nullable] = STATE(562),
    [sym_preproc_error] = STATE(562),
    [sym_preproc_warning] = STATE(562),
    [sym_preproc_define] = STATE(562),
    [sym_preproc_undef] = STATE(562),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [563] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7009),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(563),
    [sym_preproc_endregion] = STATE(563),
    [sym_preproc_line] = STATE(563),
    [sym_preproc_pragma] = STATE(563),
    [sym_preproc_nullable] = STATE(563),
    [sym_preproc_error] = STATE(563),
    [sym_preproc_warning] = STATE(563),
    [sym_preproc_define] = STATE(563),
    [sym_preproc_undef] = STATE(563),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [564] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5732),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2263),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4938),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(564),
    [sym_preproc_endregion] = STATE(564),
    [sym_preproc_line] = STATE(564),
    [sym_preproc_pragma] = STATE(564),
    [sym_preproc_nullable] = STATE(564),
    [sym_preproc_error] = STATE(564),
    [sym_preproc_warning] = STATE(564),
    [sym_preproc_define] = STATE(564),
    [sym_preproc_undef] = STATE(564),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [565] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(565),
    [sym_preproc_endregion] = STATE(565),
    [sym_preproc_line] = STATE(565),
    [sym_preproc_pragma] = STATE(565),
    [sym_preproc_nullable] = STATE(565),
    [sym_preproc_error] = STATE(565),
    [sym_preproc_warning] = STATE(565),
    [sym_preproc_define] = STATE(565),
    [sym_preproc_undef] = STATE(565),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [566] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6957),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(566),
    [sym_preproc_endregion] = STATE(566),
    [sym_preproc_line] = STATE(566),
    [sym_preproc_pragma] = STATE(566),
    [sym_preproc_nullable] = STATE(566),
    [sym_preproc_error] = STATE(566),
    [sym_preproc_warning] = STATE(566),
    [sym_preproc_define] = STATE(566),
    [sym_preproc_undef] = STATE(566),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [567] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5213),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(567),
    [sym_preproc_endregion] = STATE(567),
    [sym_preproc_line] = STATE(567),
    [sym_preproc_pragma] = STATE(567),
    [sym_preproc_nullable] = STATE(567),
    [sym_preproc_error] = STATE(567),
    [sym_preproc_warning] = STATE(567),
    [sym_preproc_define] = STATE(567),
    [sym_preproc_undef] = STATE(567),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [568] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5038),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(568),
    [sym_preproc_endregion] = STATE(568),
    [sym_preproc_line] = STATE(568),
    [sym_preproc_pragma] = STATE(568),
    [sym_preproc_nullable] = STATE(568),
    [sym_preproc_error] = STATE(568),
    [sym_preproc_warning] = STATE(568),
    [sym_preproc_define] = STATE(568),
    [sym_preproc_undef] = STATE(568),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [569] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5229),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(569),
    [sym_preproc_endregion] = STATE(569),
    [sym_preproc_line] = STATE(569),
    [sym_preproc_pragma] = STATE(569),
    [sym_preproc_nullable] = STATE(569),
    [sym_preproc_error] = STATE(569),
    [sym_preproc_warning] = STATE(569),
    [sym_preproc_define] = STATE(569),
    [sym_preproc_undef] = STATE(569),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [570] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5054),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(570),
    [sym_preproc_endregion] = STATE(570),
    [sym_preproc_line] = STATE(570),
    [sym_preproc_pragma] = STATE(570),
    [sym_preproc_nullable] = STATE(570),
    [sym_preproc_error] = STATE(570),
    [sym_preproc_warning] = STATE(570),
    [sym_preproc_define] = STATE(570),
    [sym_preproc_undef] = STATE(570),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [571] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7020),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(571),
    [sym_preproc_endregion] = STATE(571),
    [sym_preproc_line] = STATE(571),
    [sym_preproc_pragma] = STATE(571),
    [sym_preproc_nullable] = STATE(571),
    [sym_preproc_error] = STATE(571),
    [sym_preproc_warning] = STATE(571),
    [sym_preproc_define] = STATE(571),
    [sym_preproc_undef] = STATE(571),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [572] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7169),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5311),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(572),
    [sym_preproc_endregion] = STATE(572),
    [sym_preproc_line] = STATE(572),
    [sym_preproc_pragma] = STATE(572),
    [sym_preproc_nullable] = STATE(572),
    [sym_preproc_error] = STATE(572),
    [sym_preproc_warning] = STATE(572),
    [sym_preproc_define] = STATE(572),
    [sym_preproc_undef] = STATE(572),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [573] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(6962),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(573),
    [sym_preproc_endregion] = STATE(573),
    [sym_preproc_line] = STATE(573),
    [sym_preproc_pragma] = STATE(573),
    [sym_preproc_nullable] = STATE(573),
    [sym_preproc_error] = STATE(573),
    [sym_preproc_warning] = STATE(573),
    [sym_preproc_define] = STATE(573),
    [sym_preproc_undef] = STATE(573),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [574] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_argument] = STATE(7095),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6819),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2215),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(574),
    [sym_preproc_endregion] = STATE(574),
    [sym_preproc_line] = STATE(574),
    [sym_preproc_pragma] = STATE(574),
    [sym_preproc_nullable] = STATE(574),
    [sym_preproc_error] = STATE(574),
    [sym_preproc_warning] = STATE(574),
    [sym_preproc_define] = STATE(574),
    [sym_preproc_undef] = STATE(574),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_out] = ACTIONS(1063),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [575] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7002),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(575),
    [sym_preproc_endregion] = STATE(575),
    [sym_preproc_line] = STATE(575),
    [sym_preproc_pragma] = STATE(575),
    [sym_preproc_nullable] = STATE(575),
    [sym_preproc_error] = STATE(575),
    [sym_preproc_warning] = STATE(575),
    [sym_preproc_define] = STATE(575),
    [sym_preproc_undef] = STATE(575),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [576] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4901),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(576),
    [sym_preproc_endregion] = STATE(576),
    [sym_preproc_line] = STATE(576),
    [sym_preproc_pragma] = STATE(576),
    [sym_preproc_nullable] = STATE(576),
    [sym_preproc_error] = STATE(576),
    [sym_preproc_warning] = STATE(576),
    [sym_preproc_define] = STATE(576),
    [sym_preproc_undef] = STATE(576),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(7024),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [577] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(6989),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(577),
    [sym_preproc_endregion] = STATE(577),
    [sym_preproc_line] = STATE(577),
    [sym_preproc_pragma] = STATE(577),
    [sym_preproc_nullable] = STATE(577),
    [sym_preproc_error] = STATE(577),
    [sym_preproc_warning] = STATE(577),
    [sym_preproc_define] = STATE(577),
    [sym_preproc_undef] = STATE(577),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [578] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5082),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(578),
    [sym_preproc_endregion] = STATE(578),
    [sym_preproc_line] = STATE(578),
    [sym_preproc_pragma] = STATE(578),
    [sym_preproc_nullable] = STATE(578),
    [sym_preproc_error] = STATE(578),
    [sym_preproc_warning] = STATE(578),
    [sym_preproc_define] = STATE(578),
    [sym_preproc_undef] = STATE(578),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(7013),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [579] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(6942),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(579),
    [sym_preproc_endregion] = STATE(579),
    [sym_preproc_line] = STATE(579),
    [sym_preproc_pragma] = STATE(579),
    [sym_preproc_nullable] = STATE(579),
    [sym_preproc_error] = STATE(579),
    [sym_preproc_warning] = STATE(579),
    [sym_preproc_define] = STATE(579),
    [sym_preproc_undef] = STATE(579),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2739),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [580] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4940),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(580),
    [sym_preproc_endregion] = STATE(580),
    [sym_preproc_line] = STATE(580),
    [sym_preproc_pragma] = STATE(580),
    [sym_preproc_nullable] = STATE(580),
    [sym_preproc_error] = STATE(580),
    [sym_preproc_warning] = STATE(580),
    [sym_preproc_define] = STATE(580),
    [sym_preproc_undef] = STATE(580),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(7078),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2741),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [581] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4975),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(581),
    [sym_preproc_endregion] = STATE(581),
    [sym_preproc_line] = STATE(581),
    [sym_preproc_pragma] = STATE(581),
    [sym_preproc_nullable] = STATE(581),
    [sym_preproc_error] = STATE(581),
    [sym_preproc_warning] = STATE(581),
    [sym_preproc_define] = STATE(581),
    [sym_preproc_undef] = STATE(581),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(7006),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2743),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [582] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5029),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(582),
    [sym_preproc_endregion] = STATE(582),
    [sym_preproc_line] = STATE(582),
    [sym_preproc_pragma] = STATE(582),
    [sym_preproc_nullable] = STATE(582),
    [sym_preproc_error] = STATE(582),
    [sym_preproc_warning] = STATE(582),
    [sym_preproc_define] = STATE(582),
    [sym_preproc_undef] = STATE(582),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6799),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [583] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5753),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2259),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5535),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(583),
    [sym_preproc_endregion] = STATE(583),
    [sym_preproc_line] = STATE(583),
    [sym_preproc_pragma] = STATE(583),
    [sym_preproc_nullable] = STATE(583),
    [sym_preproc_error] = STATE(583),
    [sym_preproc_warning] = STATE(583),
    [sym_preproc_define] = STATE(583),
    [sym_preproc_undef] = STATE(583),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(2719),
    [anon_sym_alias] = ACTIONS(2719),
    [anon_sym_global] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_ref] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(2719),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(2719),
    [anon_sym_notnull] = ACTIONS(2719),
    [anon_sym_unmanaged] = ACTIONS(2719),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(2719),
    [anon_sym_scoped] = ACTIONS(2719),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2719),
    [sym_predefined_type] = ACTIONS(2719),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(2719),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(2719),
    [anon_sym_into] = ACTIONS(2719),
    [anon_sym_join] = ACTIONS(2719),
    [anon_sym_on] = ACTIONS(2719),
    [anon_sym_equals] = ACTIONS(2719),
    [anon_sym_let] = ACTIONS(2719),
    [anon_sym_orderby] = ACTIONS(2719),
    [anon_sym_ascending] = ACTIONS(2719),
    [anon_sym_descending] = ACTIONS(2719),
    [anon_sym_group] = ACTIONS(2719),
    [anon_sym_by] = ACTIONS(2719),
    [anon_sym_select] = ACTIONS(2719),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [584] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5085),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(584),
    [sym_preproc_endregion] = STATE(584),
    [sym_preproc_line] = STATE(584),
    [sym_preproc_pragma] = STATE(584),
    [sym_preproc_nullable] = STATE(584),
    [sym_preproc_error] = STATE(584),
    [sym_preproc_warning] = STATE(584),
    [sym_preproc_define] = STATE(584),
    [sym_preproc_undef] = STATE(584),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6803),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [585] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(6987),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(585),
    [sym_preproc_endregion] = STATE(585),
    [sym_preproc_line] = STATE(585),
    [sym_preproc_pragma] = STATE(585),
    [sym_preproc_nullable] = STATE(585),
    [sym_preproc_error] = STATE(585),
    [sym_preproc_warning] = STATE(585),
    [sym_preproc_define] = STATE(585),
    [sym_preproc_undef] = STATE(585),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2751),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [586] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4959),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(586),
    [sym_preproc_endregion] = STATE(586),
    [sym_preproc_line] = STATE(586),
    [sym_preproc_pragma] = STATE(586),
    [sym_preproc_nullable] = STATE(586),
    [sym_preproc_error] = STATE(586),
    [sym_preproc_warning] = STATE(586),
    [sym_preproc_define] = STATE(586),
    [sym_preproc_undef] = STATE(586),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6824),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2755),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [587] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7011),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(587),
    [sym_preproc_endregion] = STATE(587),
    [sym_preproc_line] = STATE(587),
    [sym_preproc_pragma] = STATE(587),
    [sym_preproc_nullable] = STATE(587),
    [sym_preproc_error] = STATE(587),
    [sym_preproc_warning] = STATE(587),
    [sym_preproc_define] = STATE(587),
    [sym_preproc_undef] = STATE(587),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2757),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [588] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5149),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6809),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(588),
    [sym_preproc_endregion] = STATE(588),
    [sym_preproc_line] = STATE(588),
    [sym_preproc_pragma] = STATE(588),
    [sym_preproc_nullable] = STATE(588),
    [sym_preproc_error] = STATE(588),
    [sym_preproc_warning] = STATE(588),
    [sym_preproc_define] = STATE(588),
    [sym_preproc_undef] = STATE(588),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_out] = ACTIONS(2081),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [589] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4971),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(589),
    [sym_preproc_endregion] = STATE(589),
    [sym_preproc_line] = STATE(589),
    [sym_preproc_pragma] = STATE(589),
    [sym_preproc_nullable] = STATE(589),
    [sym_preproc_error] = STATE(589),
    [sym_preproc_warning] = STATE(589),
    [sym_preproc_define] = STATE(589),
    [sym_preproc_undef] = STATE(589),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym_array_rank_specifier_repeat1] = STATE(7096),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2763),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [590] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7001),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(590),
    [sym_preproc_endregion] = STATE(590),
    [sym_preproc_line] = STATE(590),
    [sym_preproc_pragma] = STATE(590),
    [sym_preproc_nullable] = STATE(590),
    [sym_preproc_error] = STATE(590),
    [sym_preproc_warning] = STATE(590),
    [sym_preproc_define] = STATE(590),
    [sym_preproc_undef] = STATE(590),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2765),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [591] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7564),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5553),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(591),
    [sym_preproc_endregion] = STATE(591),
    [sym_preproc_line] = STATE(591),
    [sym_preproc_pragma] = STATE(591),
    [sym_preproc_nullable] = STATE(591),
    [sym_preproc_error] = STATE(591),
    [sym_preproc_warning] = STATE(591),
    [sym_preproc_define] = STATE(591),
    [sym_preproc_undef] = STATE(591),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [592] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5515),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(592),
    [sym_preproc_endregion] = STATE(592),
    [sym_preproc_line] = STATE(592),
    [sym_preproc_pragma] = STATE(592),
    [sym_preproc_nullable] = STATE(592),
    [sym_preproc_error] = STATE(592),
    [sym_preproc_warning] = STATE(592),
    [sym_preproc_define] = STATE(592),
    [sym_preproc_undef] = STATE(592),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2777),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [593] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5027),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(593),
    [sym_preproc_endregion] = STATE(593),
    [sym_preproc_line] = STATE(593),
    [sym_preproc_pragma] = STATE(593),
    [sym_preproc_nullable] = STATE(593),
    [sym_preproc_error] = STATE(593),
    [sym_preproc_warning] = STATE(593),
    [sym_preproc_define] = STATE(593),
    [sym_preproc_undef] = STATE(593),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [594] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4941),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(594),
    [sym_preproc_endregion] = STATE(594),
    [sym_preproc_line] = STATE(594),
    [sym_preproc_pragma] = STATE(594),
    [sym_preproc_nullable] = STATE(594),
    [sym_preproc_error] = STATE(594),
    [sym_preproc_warning] = STATE(594),
    [sym_preproc_define] = STATE(594),
    [sym_preproc_undef] = STATE(594),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [595] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(595),
    [sym_preproc_endregion] = STATE(595),
    [sym_preproc_line] = STATE(595),
    [sym_preproc_pragma] = STATE(595),
    [sym_preproc_nullable] = STATE(595),
    [sym_preproc_error] = STATE(595),
    [sym_preproc_warning] = STATE(595),
    [sym_preproc_define] = STATE(595),
    [sym_preproc_undef] = STATE(595),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2783),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [596] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5277),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(596),
    [sym_preproc_endregion] = STATE(596),
    [sym_preproc_line] = STATE(596),
    [sym_preproc_pragma] = STATE(596),
    [sym_preproc_nullable] = STATE(596),
    [sym_preproc_error] = STATE(596),
    [sym_preproc_warning] = STATE(596),
    [sym_preproc_define] = STATE(596),
    [sym_preproc_undef] = STATE(596),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [597] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(597),
    [sym_preproc_endregion] = STATE(597),
    [sym_preproc_line] = STATE(597),
    [sym_preproc_pragma] = STATE(597),
    [sym_preproc_nullable] = STATE(597),
    [sym_preproc_error] = STATE(597),
    [sym_preproc_warning] = STATE(597),
    [sym_preproc_define] = STATE(597),
    [sym_preproc_undef] = STATE(597),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [598] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5410),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(598),
    [sym_preproc_endregion] = STATE(598),
    [sym_preproc_line] = STATE(598),
    [sym_preproc_pragma] = STATE(598),
    [sym_preproc_nullable] = STATE(598),
    [sym_preproc_error] = STATE(598),
    [sym_preproc_warning] = STATE(598),
    [sym_preproc_define] = STATE(598),
    [sym_preproc_undef] = STATE(598),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [599] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5537),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(599),
    [sym_preproc_endregion] = STATE(599),
    [sym_preproc_line] = STATE(599),
    [sym_preproc_pragma] = STATE(599),
    [sym_preproc_nullable] = STATE(599),
    [sym_preproc_error] = STATE(599),
    [sym_preproc_warning] = STATE(599),
    [sym_preproc_define] = STATE(599),
    [sym_preproc_undef] = STATE(599),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2793),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [600] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7609),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5403),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(600),
    [sym_preproc_endregion] = STATE(600),
    [sym_preproc_line] = STATE(600),
    [sym_preproc_pragma] = STATE(600),
    [sym_preproc_nullable] = STATE(600),
    [sym_preproc_error] = STATE(600),
    [sym_preproc_warning] = STATE(600),
    [sym_preproc_define] = STATE(600),
    [sym_preproc_undef] = STATE(600),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [601] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5427),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(601),
    [sym_preproc_endregion] = STATE(601),
    [sym_preproc_line] = STATE(601),
    [sym_preproc_pragma] = STATE(601),
    [sym_preproc_nullable] = STATE(601),
    [sym_preproc_error] = STATE(601),
    [sym_preproc_warning] = STATE(601),
    [sym_preproc_define] = STATE(601),
    [sym_preproc_undef] = STATE(601),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [602] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7616),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5447),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(602),
    [sym_preproc_endregion] = STATE(602),
    [sym_preproc_line] = STATE(602),
    [sym_preproc_pragma] = STATE(602),
    [sym_preproc_nullable] = STATE(602),
    [sym_preproc_error] = STATE(602),
    [sym_preproc_warning] = STATE(602),
    [sym_preproc_define] = STATE(602),
    [sym_preproc_undef] = STATE(602),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [603] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(603),
    [sym_preproc_endregion] = STATE(603),
    [sym_preproc_line] = STATE(603),
    [sym_preproc_pragma] = STATE(603),
    [sym_preproc_nullable] = STATE(603),
    [sym_preproc_error] = STATE(603),
    [sym_preproc_warning] = STATE(603),
    [sym_preproc_define] = STATE(603),
    [sym_preproc_undef] = STATE(603),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [604] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7395),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5441),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(604),
    [sym_preproc_endregion] = STATE(604),
    [sym_preproc_line] = STATE(604),
    [sym_preproc_pragma] = STATE(604),
    [sym_preproc_nullable] = STATE(604),
    [sym_preproc_error] = STATE(604),
    [sym_preproc_warning] = STATE(604),
    [sym_preproc_define] = STATE(604),
    [sym_preproc_undef] = STATE(604),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [605] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(605),
    [sym_preproc_endregion] = STATE(605),
    [sym_preproc_line] = STATE(605),
    [sym_preproc_pragma] = STATE(605),
    [sym_preproc_nullable] = STATE(605),
    [sym_preproc_error] = STATE(605),
    [sym_preproc_warning] = STATE(605),
    [sym_preproc_define] = STATE(605),
    [sym_preproc_undef] = STATE(605),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [606] = {
    [sym_attribute_argument] = STATE(7065),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5335),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2293),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(606),
    [sym_preproc_endregion] = STATE(606),
    [sym_preproc_line] = STATE(606),
    [sym_preproc_pragma] = STATE(606),
    [sym_preproc_nullable] = STATE(606),
    [sym_preproc_error] = STATE(606),
    [sym_preproc_warning] = STATE(606),
    [sym_preproc_define] = STATE(606),
    [sym_preproc_undef] = STATE(606),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [607] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(607),
    [sym_preproc_endregion] = STATE(607),
    [sym_preproc_line] = STATE(607),
    [sym_preproc_pragma] = STATE(607),
    [sym_preproc_nullable] = STATE(607),
    [sym_preproc_error] = STATE(607),
    [sym_preproc_warning] = STATE(607),
    [sym_preproc_define] = STATE(607),
    [sym_preproc_undef] = STATE(607),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [608] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2933),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5706),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3841),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(608),
    [sym_preproc_endregion] = STATE(608),
    [sym_preproc_line] = STATE(608),
    [sym_preproc_pragma] = STATE(608),
    [sym_preproc_nullable] = STATE(608),
    [sym_preproc_error] = STATE(608),
    [sym_preproc_warning] = STATE(608),
    [sym_preproc_define] = STATE(608),
    [sym_preproc_undef] = STATE(608),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2807),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [609] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5698),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(609),
    [sym_preproc_endregion] = STATE(609),
    [sym_preproc_line] = STATE(609),
    [sym_preproc_pragma] = STATE(609),
    [sym_preproc_nullable] = STATE(609),
    [sym_preproc_error] = STATE(609),
    [sym_preproc_warning] = STATE(609),
    [sym_preproc_define] = STATE(609),
    [sym_preproc_undef] = STATE(609),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [610] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(610),
    [sym_preproc_endregion] = STATE(610),
    [sym_preproc_line] = STATE(610),
    [sym_preproc_pragma] = STATE(610),
    [sym_preproc_nullable] = STATE(610),
    [sym_preproc_error] = STATE(610),
    [sym_preproc_warning] = STATE(610),
    [sym_preproc_define] = STATE(610),
    [sym_preproc_undef] = STATE(610),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [611] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3249),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5374),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(4654),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(611),
    [sym_preproc_endregion] = STATE(611),
    [sym_preproc_line] = STATE(611),
    [sym_preproc_pragma] = STATE(611),
    [sym_preproc_nullable] = STATE(611),
    [sym_preproc_error] = STATE(611),
    [sym_preproc_warning] = STATE(611),
    [sym_preproc_define] = STATE(611),
    [sym_preproc_undef] = STATE(611),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [612] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5450),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(612),
    [sym_preproc_endregion] = STATE(612),
    [sym_preproc_line] = STATE(612),
    [sym_preproc_pragma] = STATE(612),
    [sym_preproc_nullable] = STATE(612),
    [sym_preproc_error] = STATE(612),
    [sym_preproc_warning] = STATE(612),
    [sym_preproc_define] = STATE(612),
    [sym_preproc_undef] = STATE(612),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [613] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5376),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(613),
    [sym_preproc_endregion] = STATE(613),
    [sym_preproc_line] = STATE(613),
    [sym_preproc_pragma] = STATE(613),
    [sym_preproc_nullable] = STATE(613),
    [sym_preproc_error] = STATE(613),
    [sym_preproc_warning] = STATE(613),
    [sym_preproc_define] = STATE(613),
    [sym_preproc_undef] = STATE(613),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [614] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5388),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(614),
    [sym_preproc_endregion] = STATE(614),
    [sym_preproc_line] = STATE(614),
    [sym_preproc_pragma] = STATE(614),
    [sym_preproc_nullable] = STATE(614),
    [sym_preproc_error] = STATE(614),
    [sym_preproc_warning] = STATE(614),
    [sym_preproc_define] = STATE(614),
    [sym_preproc_undef] = STATE(614),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [615] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5394),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(615),
    [sym_preproc_endregion] = STATE(615),
    [sym_preproc_line] = STATE(615),
    [sym_preproc_pragma] = STATE(615),
    [sym_preproc_nullable] = STATE(615),
    [sym_preproc_error] = STATE(615),
    [sym_preproc_warning] = STATE(615),
    [sym_preproc_define] = STATE(615),
    [sym_preproc_undef] = STATE(615),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [616] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5596),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(616),
    [sym_preproc_endregion] = STATE(616),
    [sym_preproc_line] = STATE(616),
    [sym_preproc_pragma] = STATE(616),
    [sym_preproc_nullable] = STATE(616),
    [sym_preproc_error] = STATE(616),
    [sym_preproc_warning] = STATE(616),
    [sym_preproc_define] = STATE(616),
    [sym_preproc_undef] = STATE(616),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_case] = ACTIONS(2821),
    [anon_sym_default] = ACTIONS(2823),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [617] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7398),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5612),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(617),
    [sym_preproc_endregion] = STATE(617),
    [sym_preproc_line] = STATE(617),
    [sym_preproc_pragma] = STATE(617),
    [sym_preproc_nullable] = STATE(617),
    [sym_preproc_error] = STATE(617),
    [sym_preproc_warning] = STATE(617),
    [sym_preproc_define] = STATE(617),
    [sym_preproc_undef] = STATE(617),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [618] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5465),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(618),
    [sym_preproc_endregion] = STATE(618),
    [sym_preproc_line] = STATE(618),
    [sym_preproc_pragma] = STATE(618),
    [sym_preproc_nullable] = STATE(618),
    [sym_preproc_error] = STATE(618),
    [sym_preproc_warning] = STATE(618),
    [sym_preproc_define] = STATE(618),
    [sym_preproc_undef] = STATE(618),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [619] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7525),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5648),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(619),
    [sym_preproc_endregion] = STATE(619),
    [sym_preproc_line] = STATE(619),
    [sym_preproc_pragma] = STATE(619),
    [sym_preproc_nullable] = STATE(619),
    [sym_preproc_error] = STATE(619),
    [sym_preproc_warning] = STATE(619),
    [sym_preproc_define] = STATE(619),
    [sym_preproc_undef] = STATE(619),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [620] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5071),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(620),
    [sym_preproc_endregion] = STATE(620),
    [sym_preproc_line] = STATE(620),
    [sym_preproc_pragma] = STATE(620),
    [sym_preproc_nullable] = STATE(620),
    [sym_preproc_error] = STATE(620),
    [sym_preproc_warning] = STATE(620),
    [sym_preproc_define] = STATE(620),
    [sym_preproc_undef] = STATE(620),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2825),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [621] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(621),
    [sym_preproc_endregion] = STATE(621),
    [sym_preproc_line] = STATE(621),
    [sym_preproc_pragma] = STATE(621),
    [sym_preproc_nullable] = STATE(621),
    [sym_preproc_error] = STATE(621),
    [sym_preproc_warning] = STATE(621),
    [sym_preproc_define] = STATE(621),
    [sym_preproc_undef] = STATE(621),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [622] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2933),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5485),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3841),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(622),
    [sym_preproc_endregion] = STATE(622),
    [sym_preproc_line] = STATE(622),
    [sym_preproc_pragma] = STATE(622),
    [sym_preproc_nullable] = STATE(622),
    [sym_preproc_error] = STATE(622),
    [sym_preproc_warning] = STATE(622),
    [sym_preproc_define] = STATE(622),
    [sym_preproc_undef] = STATE(622),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2807),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [623] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5559),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(623),
    [sym_preproc_endregion] = STATE(623),
    [sym_preproc_line] = STATE(623),
    [sym_preproc_pragma] = STATE(623),
    [sym_preproc_nullable] = STATE(623),
    [sym_preproc_error] = STATE(623),
    [sym_preproc_warning] = STATE(623),
    [sym_preproc_define] = STATE(623),
    [sym_preproc_undef] = STATE(623),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [624] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3249),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5486),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(4654),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(624),
    [sym_preproc_endregion] = STATE(624),
    [sym_preproc_line] = STATE(624),
    [sym_preproc_pragma] = STATE(624),
    [sym_preproc_nullable] = STATE(624),
    [sym_preproc_error] = STATE(624),
    [sym_preproc_warning] = STATE(624),
    [sym_preproc_define] = STATE(624),
    [sym_preproc_undef] = STATE(624),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [625] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5578),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(625),
    [sym_preproc_endregion] = STATE(625),
    [sym_preproc_line] = STATE(625),
    [sym_preproc_pragma] = STATE(625),
    [sym_preproc_nullable] = STATE(625),
    [sym_preproc_error] = STATE(625),
    [sym_preproc_warning] = STATE(625),
    [sym_preproc_define] = STATE(625),
    [sym_preproc_undef] = STATE(625),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [626] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5382),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(626),
    [sym_preproc_endregion] = STATE(626),
    [sym_preproc_line] = STATE(626),
    [sym_preproc_pragma] = STATE(626),
    [sym_preproc_nullable] = STATE(626),
    [sym_preproc_error] = STATE(626),
    [sym_preproc_warning] = STATE(626),
    [sym_preproc_define] = STATE(626),
    [sym_preproc_undef] = STATE(626),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [627] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5398),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(627),
    [sym_preproc_endregion] = STATE(627),
    [sym_preproc_line] = STATE(627),
    [sym_preproc_pragma] = STATE(627),
    [sym_preproc_nullable] = STATE(627),
    [sym_preproc_error] = STATE(627),
    [sym_preproc_warning] = STATE(627),
    [sym_preproc_define] = STATE(627),
    [sym_preproc_undef] = STATE(627),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [628] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7357),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5623),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(628),
    [sym_preproc_endregion] = STATE(628),
    [sym_preproc_line] = STATE(628),
    [sym_preproc_pragma] = STATE(628),
    [sym_preproc_nullable] = STATE(628),
    [sym_preproc_error] = STATE(628),
    [sym_preproc_warning] = STATE(628),
    [sym_preproc_define] = STATE(628),
    [sym_preproc_undef] = STATE(628),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [629] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_using_variable_declaration] = STATE(7645),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5851),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_expression] = STATE(5479),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(629),
    [sym_preproc_endregion] = STATE(629),
    [sym_preproc_line] = STATE(629),
    [sym_preproc_pragma] = STATE(629),
    [sym_preproc_nullable] = STATE(629),
    [sym_preproc_error] = STATE(629),
    [sym_preproc_warning] = STATE(629),
    [sym_preproc_define] = STATE(629),
    [sym_preproc_undef] = STATE(629),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [630] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5392),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(630),
    [sym_preproc_endregion] = STATE(630),
    [sym_preproc_line] = STATE(630),
    [sym_preproc_pragma] = STATE(630),
    [sym_preproc_nullable] = STATE(630),
    [sym_preproc_error] = STATE(630),
    [sym_preproc_warning] = STATE(630),
    [sym_preproc_define] = STATE(630),
    [sym_preproc_undef] = STATE(630),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [631] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5484),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(631),
    [sym_preproc_endregion] = STATE(631),
    [sym_preproc_line] = STATE(631),
    [sym_preproc_pragma] = STATE(631),
    [sym_preproc_nullable] = STATE(631),
    [sym_preproc_error] = STATE(631),
    [sym_preproc_warning] = STATE(631),
    [sym_preproc_define] = STATE(631),
    [sym_preproc_undef] = STATE(631),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2829),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [632] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5400),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(632),
    [sym_preproc_endregion] = STATE(632),
    [sym_preproc_line] = STATE(632),
    [sym_preproc_pragma] = STATE(632),
    [sym_preproc_nullable] = STATE(632),
    [sym_preproc_error] = STATE(632),
    [sym_preproc_warning] = STATE(632),
    [sym_preproc_define] = STATE(632),
    [sym_preproc_undef] = STATE(632),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [633] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5393),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(633),
    [sym_preproc_endregion] = STATE(633),
    [sym_preproc_line] = STATE(633),
    [sym_preproc_pragma] = STATE(633),
    [sym_preproc_nullable] = STATE(633),
    [sym_preproc_error] = STATE(633),
    [sym_preproc_warning] = STATE(633),
    [sym_preproc_define] = STATE(633),
    [sym_preproc_undef] = STATE(633),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [634] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5387),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(634),
    [sym_preproc_endregion] = STATE(634),
    [sym_preproc_line] = STATE(634),
    [sym_preproc_pragma] = STATE(634),
    [sym_preproc_nullable] = STATE(634),
    [sym_preproc_error] = STATE(634),
    [sym_preproc_warning] = STATE(634),
    [sym_preproc_define] = STATE(634),
    [sym_preproc_undef] = STATE(634),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [635] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5401),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(635),
    [sym_preproc_endregion] = STATE(635),
    [sym_preproc_line] = STATE(635),
    [sym_preproc_pragma] = STATE(635),
    [sym_preproc_nullable] = STATE(635),
    [sym_preproc_error] = STATE(635),
    [sym_preproc_warning] = STATE(635),
    [sym_preproc_define] = STATE(635),
    [sym_preproc_undef] = STATE(635),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [636] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(636),
    [sym_preproc_endregion] = STATE(636),
    [sym_preproc_line] = STATE(636),
    [sym_preproc_pragma] = STATE(636),
    [sym_preproc_nullable] = STATE(636),
    [sym_preproc_error] = STATE(636),
    [sym_preproc_warning] = STATE(636),
    [sym_preproc_define] = STATE(636),
    [sym_preproc_undef] = STATE(636),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [637] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5260),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(637),
    [sym_preproc_endregion] = STATE(637),
    [sym_preproc_line] = STATE(637),
    [sym_preproc_pragma] = STATE(637),
    [sym_preproc_nullable] = STATE(637),
    [sym_preproc_error] = STATE(637),
    [sym_preproc_warning] = STATE(637),
    [sym_preproc_define] = STATE(637),
    [sym_preproc_undef] = STATE(637),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_RBRACK] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [638] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4891),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(638),
    [sym_preproc_endregion] = STATE(638),
    [sym_preproc_line] = STATE(638),
    [sym_preproc_pragma] = STATE(638),
    [sym_preproc_nullable] = STATE(638),
    [sym_preproc_error] = STATE(638),
    [sym_preproc_warning] = STATE(638),
    [sym_preproc_define] = STATE(638),
    [sym_preproc_undef] = STATE(638),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [639] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5700),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(639),
    [sym_preproc_endregion] = STATE(639),
    [sym_preproc_line] = STATE(639),
    [sym_preproc_pragma] = STATE(639),
    [sym_preproc_nullable] = STATE(639),
    [sym_preproc_error] = STATE(639),
    [sym_preproc_warning] = STATE(639),
    [sym_preproc_define] = STATE(639),
    [sym_preproc_undef] = STATE(639),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [640] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5396),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(640),
    [sym_preproc_endregion] = STATE(640),
    [sym_preproc_line] = STATE(640),
    [sym_preproc_pragma] = STATE(640),
    [sym_preproc_nullable] = STATE(640),
    [sym_preproc_error] = STATE(640),
    [sym_preproc_warning] = STATE(640),
    [sym_preproc_define] = STATE(640),
    [sym_preproc_undef] = STATE(640),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [641] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5402),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(641),
    [sym_preproc_endregion] = STATE(641),
    [sym_preproc_line] = STATE(641),
    [sym_preproc_pragma] = STATE(641),
    [sym_preproc_nullable] = STATE(641),
    [sym_preproc_error] = STATE(641),
    [sym_preproc_warning] = STATE(641),
    [sym_preproc_define] = STATE(641),
    [sym_preproc_undef] = STATE(641),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [642] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4969),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(642),
    [sym_preproc_endregion] = STATE(642),
    [sym_preproc_line] = STATE(642),
    [sym_preproc_pragma] = STATE(642),
    [sym_preproc_nullable] = STATE(642),
    [sym_preproc_error] = STATE(642),
    [sym_preproc_warning] = STATE(642),
    [sym_preproc_define] = STATE(642),
    [sym_preproc_undef] = STATE(642),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(933),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [643] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5038),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(643),
    [sym_preproc_endregion] = STATE(643),
    [sym_preproc_line] = STATE(643),
    [sym_preproc_pragma] = STATE(643),
    [sym_preproc_nullable] = STATE(643),
    [sym_preproc_error] = STATE(643),
    [sym_preproc_warning] = STATE(643),
    [sym_preproc_define] = STATE(643),
    [sym_preproc_undef] = STATE(643),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [644] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5397),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(644),
    [sym_preproc_endregion] = STATE(644),
    [sym_preproc_line] = STATE(644),
    [sym_preproc_pragma] = STATE(644),
    [sym_preproc_nullable] = STATE(644),
    [sym_preproc_error] = STATE(644),
    [sym_preproc_warning] = STATE(644),
    [sym_preproc_define] = STATE(644),
    [sym_preproc_undef] = STATE(644),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [645] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5399),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(645),
    [sym_preproc_endregion] = STATE(645),
    [sym_preproc_line] = STATE(645),
    [sym_preproc_pragma] = STATE(645),
    [sym_preproc_nullable] = STATE(645),
    [sym_preproc_error] = STATE(645),
    [sym_preproc_warning] = STATE(645),
    [sym_preproc_define] = STATE(645),
    [sym_preproc_undef] = STATE(645),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [646] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5522),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(646),
    [sym_preproc_endregion] = STATE(646),
    [sym_preproc_line] = STATE(646),
    [sym_preproc_pragma] = STATE(646),
    [sym_preproc_nullable] = STATE(646),
    [sym_preproc_error] = STATE(646),
    [sym_preproc_warning] = STATE(646),
    [sym_preproc_define] = STATE(646),
    [sym_preproc_undef] = STATE(646),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [647] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2933),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5627),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3841),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(647),
    [sym_preproc_endregion] = STATE(647),
    [sym_preproc_line] = STATE(647),
    [sym_preproc_pragma] = STATE(647),
    [sym_preproc_nullable] = STATE(647),
    [sym_preproc_error] = STATE(647),
    [sym_preproc_warning] = STATE(647),
    [sym_preproc_define] = STATE(647),
    [sym_preproc_undef] = STATE(647),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2807),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [648] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5752),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2262),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5084),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(7105),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(648),
    [sym_preproc_endregion] = STATE(648),
    [sym_preproc_line] = STATE(648),
    [sym_preproc_pragma] = STATE(648),
    [sym_preproc_nullable] = STATE(648),
    [sym_preproc_error] = STATE(648),
    [sym_preproc_warning] = STATE(648),
    [sym_preproc_define] = STATE(648),
    [sym_preproc_undef] = STATE(648),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [649] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2767),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5635),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(649),
    [sym_preproc_endregion] = STATE(649),
    [sym_preproc_line] = STATE(649),
    [sym_preproc_pragma] = STATE(649),
    [sym_preproc_nullable] = STATE(649),
    [sym_preproc_error] = STATE(649),
    [sym_preproc_warning] = STATE(649),
    [sym_preproc_define] = STATE(649),
    [sym_preproc_undef] = STATE(649),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [650] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5551),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(650),
    [sym_preproc_endregion] = STATE(650),
    [sym_preproc_line] = STATE(650),
    [sym_preproc_pragma] = STATE(650),
    [sym_preproc_nullable] = STATE(650),
    [sym_preproc_error] = STATE(650),
    [sym_preproc_warning] = STATE(650),
    [sym_preproc_define] = STATE(650),
    [sym_preproc_undef] = STATE(650),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [651] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5502),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(651),
    [sym_preproc_endregion] = STATE(651),
    [sym_preproc_line] = STATE(651),
    [sym_preproc_pragma] = STATE(651),
    [sym_preproc_nullable] = STATE(651),
    [sym_preproc_error] = STATE(651),
    [sym_preproc_warning] = STATE(651),
    [sym_preproc_define] = STATE(651),
    [sym_preproc_undef] = STATE(651),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_case] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2847),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [652] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5645),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3426),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(652),
    [sym_preproc_endregion] = STATE(652),
    [sym_preproc_line] = STATE(652),
    [sym_preproc_pragma] = STATE(652),
    [sym_preproc_nullable] = STATE(652),
    [sym_preproc_error] = STATE(652),
    [sym_preproc_warning] = STATE(652),
    [sym_preproc_define] = STATE(652),
    [sym_preproc_undef] = STATE(652),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [653] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(653),
    [sym_preproc_endregion] = STATE(653),
    [sym_preproc_line] = STATE(653),
    [sym_preproc_pragma] = STATE(653),
    [sym_preproc_nullable] = STATE(653),
    [sym_preproc_error] = STATE(653),
    [sym_preproc_warning] = STATE(653),
    [sym_preproc_define] = STATE(653),
    [sym_preproc_undef] = STATE(653),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [654] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(654),
    [sym_preproc_endregion] = STATE(654),
    [sym_preproc_line] = STATE(654),
    [sym_preproc_pragma] = STATE(654),
    [sym_preproc_nullable] = STATE(654),
    [sym_preproc_error] = STATE(654),
    [sym_preproc_warning] = STATE(654),
    [sym_preproc_define] = STATE(654),
    [sym_preproc_undef] = STATE(654),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [655] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5415),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(655),
    [sym_preproc_endregion] = STATE(655),
    [sym_preproc_line] = STATE(655),
    [sym_preproc_pragma] = STATE(655),
    [sym_preproc_nullable] = STATE(655),
    [sym_preproc_error] = STATE(655),
    [sym_preproc_warning] = STATE(655),
    [sym_preproc_define] = STATE(655),
    [sym_preproc_undef] = STATE(655),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [656] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(656),
    [sym_preproc_endregion] = STATE(656),
    [sym_preproc_line] = STATE(656),
    [sym_preproc_pragma] = STATE(656),
    [sym_preproc_nullable] = STATE(656),
    [sym_preproc_error] = STATE(656),
    [sym_preproc_warning] = STATE(656),
    [sym_preproc_define] = STATE(656),
    [sym_preproc_undef] = STATE(656),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [657] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3249),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5442),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(4654),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(657),
    [sym_preproc_endregion] = STATE(657),
    [sym_preproc_line] = STATE(657),
    [sym_preproc_pragma] = STATE(657),
    [sym_preproc_nullable] = STATE(657),
    [sym_preproc_error] = STATE(657),
    [sym_preproc_warning] = STATE(657),
    [sym_preproc_define] = STATE(657),
    [sym_preproc_undef] = STATE(657),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [658] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5555),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(658),
    [sym_preproc_endregion] = STATE(658),
    [sym_preproc_line] = STATE(658),
    [sym_preproc_pragma] = STATE(658),
    [sym_preproc_nullable] = STATE(658),
    [sym_preproc_error] = STATE(658),
    [sym_preproc_warning] = STATE(658),
    [sym_preproc_define] = STATE(658),
    [sym_preproc_undef] = STATE(658),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2793),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [659] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2933),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5476),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3841),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(659),
    [sym_preproc_endregion] = STATE(659),
    [sym_preproc_line] = STATE(659),
    [sym_preproc_pragma] = STATE(659),
    [sym_preproc_nullable] = STATE(659),
    [sym_preproc_error] = STATE(659),
    [sym_preproc_warning] = STATE(659),
    [sym_preproc_define] = STATE(659),
    [sym_preproc_undef] = STATE(659),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2807),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [660] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(660),
    [sym_preproc_endregion] = STATE(660),
    [sym_preproc_line] = STATE(660),
    [sym_preproc_pragma] = STATE(660),
    [sym_preproc_nullable] = STATE(660),
    [sym_preproc_error] = STATE(660),
    [sym_preproc_warning] = STATE(660),
    [sym_preproc_define] = STATE(660),
    [sym_preproc_undef] = STATE(660),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [661] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3249),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5481),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(4654),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(661),
    [sym_preproc_endregion] = STATE(661),
    [sym_preproc_line] = STATE(661),
    [sym_preproc_pragma] = STATE(661),
    [sym_preproc_nullable] = STATE(661),
    [sym_preproc_error] = STATE(661),
    [sym_preproc_warning] = STATE(661),
    [sym_preproc_define] = STATE(661),
    [sym_preproc_undef] = STATE(661),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [662] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_variable_declaration] = STATE(7555),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5899),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4993),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(662),
    [sym_preproc_endregion] = STATE(662),
    [sym_preproc_line] = STATE(662),
    [sym_preproc_pragma] = STATE(662),
    [sym_preproc_nullable] = STATE(662),
    [sym_preproc_error] = STATE(662),
    [sym_preproc_warning] = STATE(662),
    [sym_preproc_define] = STATE(662),
    [sym_preproc_undef] = STATE(662),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [663] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(663),
    [sym_preproc_endregion] = STATE(663),
    [sym_preproc_line] = STATE(663),
    [sym_preproc_pragma] = STATE(663),
    [sym_preproc_nullable] = STATE(663),
    [sym_preproc_error] = STATE(663),
    [sym_preproc_warning] = STATE(663),
    [sym_preproc_define] = STATE(663),
    [sym_preproc_undef] = STATE(663),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [664] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5653),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(664),
    [sym_preproc_endregion] = STATE(664),
    [sym_preproc_line] = STATE(664),
    [sym_preproc_pragma] = STATE(664),
    [sym_preproc_nullable] = STATE(664),
    [sym_preproc_error] = STATE(664),
    [sym_preproc_warning] = STATE(664),
    [sym_preproc_define] = STATE(664),
    [sym_preproc_undef] = STATE(664),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [665] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5386),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(665),
    [sym_preproc_endregion] = STATE(665),
    [sym_preproc_line] = STATE(665),
    [sym_preproc_pragma] = STATE(665),
    [sym_preproc_nullable] = STATE(665),
    [sym_preproc_error] = STATE(665),
    [sym_preproc_warning] = STATE(665),
    [sym_preproc_define] = STATE(665),
    [sym_preproc_undef] = STATE(665),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [666] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5487),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(666),
    [sym_preproc_endregion] = STATE(666),
    [sym_preproc_line] = STATE(666),
    [sym_preproc_pragma] = STATE(666),
    [sym_preproc_nullable] = STATE(666),
    [sym_preproc_error] = STATE(666),
    [sym_preproc_warning] = STATE(666),
    [sym_preproc_define] = STATE(666),
    [sym_preproc_undef] = STATE(666),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [667] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5390),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(667),
    [sym_preproc_endregion] = STATE(667),
    [sym_preproc_line] = STATE(667),
    [sym_preproc_pragma] = STATE(667),
    [sym_preproc_nullable] = STATE(667),
    [sym_preproc_error] = STATE(667),
    [sym_preproc_warning] = STATE(667),
    [sym_preproc_define] = STATE(667),
    [sym_preproc_undef] = STATE(667),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_case] = ACTIONS(2863),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [668] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5510),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(668),
    [sym_preproc_endregion] = STATE(668),
    [sym_preproc_line] = STATE(668),
    [sym_preproc_pragma] = STATE(668),
    [sym_preproc_nullable] = STATE(668),
    [sym_preproc_error] = STATE(668),
    [sym_preproc_warning] = STATE(668),
    [sym_preproc_define] = STATE(668),
    [sym_preproc_undef] = STATE(668),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [669] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5547),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(669),
    [sym_preproc_endregion] = STATE(669),
    [sym_preproc_line] = STATE(669),
    [sym_preproc_pragma] = STATE(669),
    [sym_preproc_nullable] = STATE(669),
    [sym_preproc_error] = STATE(669),
    [sym_preproc_warning] = STATE(669),
    [sym_preproc_define] = STATE(669),
    [sym_preproc_undef] = STATE(669),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [670] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(670),
    [sym_preproc_endregion] = STATE(670),
    [sym_preproc_line] = STATE(670),
    [sym_preproc_pragma] = STATE(670),
    [sym_preproc_nullable] = STATE(670),
    [sym_preproc_error] = STATE(670),
    [sym_preproc_warning] = STATE(670),
    [sym_preproc_define] = STATE(670),
    [sym_preproc_undef] = STATE(670),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [671] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5038),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(671),
    [sym_preproc_endregion] = STATE(671),
    [sym_preproc_line] = STATE(671),
    [sym_preproc_pragma] = STATE(671),
    [sym_preproc_nullable] = STATE(671),
    [sym_preproc_error] = STATE(671),
    [sym_preproc_warning] = STATE(671),
    [sym_preproc_define] = STATE(671),
    [sym_preproc_undef] = STATE(671),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [672] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5571),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(672),
    [sym_preproc_endregion] = STATE(672),
    [sym_preproc_line] = STATE(672),
    [sym_preproc_pragma] = STATE(672),
    [sym_preproc_nullable] = STATE(672),
    [sym_preproc_error] = STATE(672),
    [sym_preproc_warning] = STATE(672),
    [sym_preproc_define] = STATE(672),
    [sym_preproc_undef] = STATE(672),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [673] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5084),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(7105),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(673),
    [sym_preproc_endregion] = STATE(673),
    [sym_preproc_line] = STATE(673),
    [sym_preproc_pragma] = STATE(673),
    [sym_preproc_nullable] = STATE(673),
    [sym_preproc_error] = STATE(673),
    [sym_preproc_warning] = STATE(673),
    [sym_preproc_define] = STATE(673),
    [sym_preproc_undef] = STATE(673),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [674] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2474),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5575),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3144),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(674),
    [sym_preproc_endregion] = STATE(674),
    [sym_preproc_line] = STATE(674),
    [sym_preproc_pragma] = STATE(674),
    [sym_preproc_nullable] = STATE(674),
    [sym_preproc_error] = STATE(674),
    [sym_preproc_warning] = STATE(674),
    [sym_preproc_define] = STATE(674),
    [sym_preproc_undef] = STATE(674),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [675] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5727),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5277),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(675),
    [sym_preproc_endregion] = STATE(675),
    [sym_preproc_line] = STATE(675),
    [sym_preproc_pragma] = STATE(675),
    [sym_preproc_nullable] = STATE(675),
    [sym_preproc_error] = STATE(675),
    [sym_preproc_warning] = STATE(675),
    [sym_preproc_define] = STATE(675),
    [sym_preproc_undef] = STATE(675),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [676] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4934),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(676),
    [sym_preproc_endregion] = STATE(676),
    [sym_preproc_line] = STATE(676),
    [sym_preproc_pragma] = STATE(676),
    [sym_preproc_nullable] = STATE(676),
    [sym_preproc_error] = STATE(676),
    [sym_preproc_warning] = STATE(676),
    [sym_preproc_define] = STATE(676),
    [sym_preproc_undef] = STATE(676),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [677] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3164),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5391),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(677),
    [sym_preproc_endregion] = STATE(677),
    [sym_preproc_line] = STATE(677),
    [sym_preproc_pragma] = STATE(677),
    [sym_preproc_nullable] = STATE(677),
    [sym_preproc_error] = STATE(677),
    [sym_preproc_warning] = STATE(677),
    [sym_preproc_define] = STATE(677),
    [sym_preproc_undef] = STATE(677),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [678] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5650),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(678),
    [sym_preproc_endregion] = STATE(678),
    [sym_preproc_line] = STATE(678),
    [sym_preproc_pragma] = STATE(678),
    [sym_preproc_nullable] = STATE(678),
    [sym_preproc_error] = STATE(678),
    [sym_preproc_warning] = STATE(678),
    [sym_preproc_define] = STATE(678),
    [sym_preproc_undef] = STATE(678),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [679] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2653),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5655),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3357),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(679),
    [sym_preproc_endregion] = STATE(679),
    [sym_preproc_line] = STATE(679),
    [sym_preproc_pragma] = STATE(679),
    [sym_preproc_nullable] = STATE(679),
    [sym_preproc_error] = STATE(679),
    [sym_preproc_warning] = STATE(679),
    [sym_preproc_define] = STATE(679),
    [sym_preproc_undef] = STATE(679),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [680] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2443),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5395),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_member_binding_expression] = STATE(3002),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(680),
    [sym_preproc_endregion] = STATE(680),
    [sym_preproc_line] = STATE(680),
    [sym_preproc_pragma] = STATE(680),
    [sym_preproc_nullable] = STATE(680),
    [sym_preproc_error] = STATE(680),
    [sym_preproc_warning] = STATE(680),
    [sym_preproc_define] = STATE(680),
    [sym_preproc_undef] = STATE(680),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [681] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5159),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(681),
    [sym_preproc_endregion] = STATE(681),
    [sym_preproc_line] = STATE(681),
    [sym_preproc_pragma] = STATE(681),
    [sym_preproc_nullable] = STATE(681),
    [sym_preproc_error] = STATE(681),
    [sym_preproc_warning] = STATE(681),
    [sym_preproc_define] = STATE(681),
    [sym_preproc_undef] = STATE(681),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [682] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5321),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(682),
    [sym_preproc_endregion] = STATE(682),
    [sym_preproc_line] = STATE(682),
    [sym_preproc_pragma] = STATE(682),
    [sym_preproc_nullable] = STATE(682),
    [sym_preproc_error] = STATE(682),
    [sym_preproc_warning] = STATE(682),
    [sym_preproc_define] = STATE(682),
    [sym_preproc_undef] = STATE(682),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [683] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3891),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3979),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(683),
    [sym_preproc_endregion] = STATE(683),
    [sym_preproc_line] = STATE(683),
    [sym_preproc_pragma] = STATE(683),
    [sym_preproc_nullable] = STATE(683),
    [sym_preproc_error] = STATE(683),
    [sym_preproc_warning] = STATE(683),
    [sym_preproc_define] = STATE(683),
    [sym_preproc_undef] = STATE(683),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [684] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4369),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(684),
    [sym_preproc_endregion] = STATE(684),
    [sym_preproc_line] = STATE(684),
    [sym_preproc_pragma] = STATE(684),
    [sym_preproc_nullable] = STATE(684),
    [sym_preproc_error] = STATE(684),
    [sym_preproc_warning] = STATE(684),
    [sym_preproc_define] = STATE(684),
    [sym_preproc_undef] = STATE(684),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [685] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5114),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(685),
    [sym_preproc_endregion] = STATE(685),
    [sym_preproc_line] = STATE(685),
    [sym_preproc_pragma] = STATE(685),
    [sym_preproc_nullable] = STATE(685),
    [sym_preproc_error] = STATE(685),
    [sym_preproc_warning] = STATE(685),
    [sym_preproc_define] = STATE(685),
    [sym_preproc_undef] = STATE(685),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [686] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4383),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(686),
    [sym_preproc_endregion] = STATE(686),
    [sym_preproc_line] = STATE(686),
    [sym_preproc_pragma] = STATE(686),
    [sym_preproc_nullable] = STATE(686),
    [sym_preproc_error] = STATE(686),
    [sym_preproc_warning] = STATE(686),
    [sym_preproc_define] = STATE(686),
    [sym_preproc_undef] = STATE(686),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [687] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4223),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(687),
    [sym_preproc_endregion] = STATE(687),
    [sym_preproc_line] = STATE(687),
    [sym_preproc_pragma] = STATE(687),
    [sym_preproc_nullable] = STATE(687),
    [sym_preproc_error] = STATE(687),
    [sym_preproc_warning] = STATE(687),
    [sym_preproc_define] = STATE(687),
    [sym_preproc_undef] = STATE(687),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [688] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4888),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(688),
    [sym_preproc_endregion] = STATE(688),
    [sym_preproc_line] = STATE(688),
    [sym_preproc_pragma] = STATE(688),
    [sym_preproc_nullable] = STATE(688),
    [sym_preproc_error] = STATE(688),
    [sym_preproc_warning] = STATE(688),
    [sym_preproc_define] = STATE(688),
    [sym_preproc_undef] = STATE(688),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [689] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4431),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(689),
    [sym_preproc_endregion] = STATE(689),
    [sym_preproc_line] = STATE(689),
    [sym_preproc_pragma] = STATE(689),
    [sym_preproc_nullable] = STATE(689),
    [sym_preproc_error] = STATE(689),
    [sym_preproc_warning] = STATE(689),
    [sym_preproc_define] = STATE(689),
    [sym_preproc_undef] = STATE(689),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [690] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4919),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(690),
    [sym_preproc_endregion] = STATE(690),
    [sym_preproc_line] = STATE(690),
    [sym_preproc_pragma] = STATE(690),
    [sym_preproc_nullable] = STATE(690),
    [sym_preproc_error] = STATE(690),
    [sym_preproc_warning] = STATE(690),
    [sym_preproc_define] = STATE(690),
    [sym_preproc_undef] = STATE(690),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [691] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5501),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(691),
    [sym_preproc_endregion] = STATE(691),
    [sym_preproc_line] = STATE(691),
    [sym_preproc_pragma] = STATE(691),
    [sym_preproc_nullable] = STATE(691),
    [sym_preproc_error] = STATE(691),
    [sym_preproc_warning] = STATE(691),
    [sym_preproc_define] = STATE(691),
    [sym_preproc_undef] = STATE(691),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2051),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [692] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4921),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(692),
    [sym_preproc_endregion] = STATE(692),
    [sym_preproc_line] = STATE(692),
    [sym_preproc_pragma] = STATE(692),
    [sym_preproc_nullable] = STATE(692),
    [sym_preproc_error] = STATE(692),
    [sym_preproc_warning] = STATE(692),
    [sym_preproc_define] = STATE(692),
    [sym_preproc_undef] = STATE(692),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [693] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5113),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(693),
    [sym_preproc_endregion] = STATE(693),
    [sym_preproc_line] = STATE(693),
    [sym_preproc_pragma] = STATE(693),
    [sym_preproc_nullable] = STATE(693),
    [sym_preproc_error] = STATE(693),
    [sym_preproc_warning] = STATE(693),
    [sym_preproc_define] = STATE(693),
    [sym_preproc_undef] = STATE(693),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [694] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4266),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(694),
    [sym_preproc_endregion] = STATE(694),
    [sym_preproc_line] = STATE(694),
    [sym_preproc_pragma] = STATE(694),
    [sym_preproc_nullable] = STATE(694),
    [sym_preproc_error] = STATE(694),
    [sym_preproc_warning] = STATE(694),
    [sym_preproc_define] = STATE(694),
    [sym_preproc_undef] = STATE(694),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [695] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5024),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(695),
    [sym_preproc_endregion] = STATE(695),
    [sym_preproc_line] = STATE(695),
    [sym_preproc_pragma] = STATE(695),
    [sym_preproc_nullable] = STATE(695),
    [sym_preproc_error] = STATE(695),
    [sym_preproc_warning] = STATE(695),
    [sym_preproc_define] = STATE(695),
    [sym_preproc_undef] = STATE(695),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [696] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5008),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(696),
    [sym_preproc_endregion] = STATE(696),
    [sym_preproc_line] = STATE(696),
    [sym_preproc_pragma] = STATE(696),
    [sym_preproc_nullable] = STATE(696),
    [sym_preproc_error] = STATE(696),
    [sym_preproc_warning] = STATE(696),
    [sym_preproc_define] = STATE(696),
    [sym_preproc_undef] = STATE(696),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [697] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym__anonymous_object_member_declarator] = STATE(7235),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2307),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(697),
    [sym_preproc_endregion] = STATE(697),
    [sym_preproc_line] = STATE(697),
    [sym_preproc_pragma] = STATE(697),
    [sym_preproc_nullable] = STATE(697),
    [sym_preproc_error] = STATE(697),
    [sym_preproc_warning] = STATE(697),
    [sym_preproc_define] = STATE(697),
    [sym_preproc_undef] = STATE(697),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [698] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4556),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(698),
    [sym_preproc_endregion] = STATE(698),
    [sym_preproc_line] = STATE(698),
    [sym_preproc_pragma] = STATE(698),
    [sym_preproc_nullable] = STATE(698),
    [sym_preproc_error] = STATE(698),
    [sym_preproc_warning] = STATE(698),
    [sym_preproc_define] = STATE(698),
    [sym_preproc_undef] = STATE(698),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [699] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5131),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(699),
    [sym_preproc_endregion] = STATE(699),
    [sym_preproc_line] = STATE(699),
    [sym_preproc_pragma] = STATE(699),
    [sym_preproc_nullable] = STATE(699),
    [sym_preproc_error] = STATE(699),
    [sym_preproc_warning] = STATE(699),
    [sym_preproc_define] = STATE(699),
    [sym_preproc_undef] = STATE(699),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [700] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4433),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(700),
    [sym_preproc_endregion] = STATE(700),
    [sym_preproc_line] = STATE(700),
    [sym_preproc_pragma] = STATE(700),
    [sym_preproc_nullable] = STATE(700),
    [sym_preproc_error] = STATE(700),
    [sym_preproc_warning] = STATE(700),
    [sym_preproc_define] = STATE(700),
    [sym_preproc_undef] = STATE(700),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [701] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5132),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(701),
    [sym_preproc_endregion] = STATE(701),
    [sym_preproc_line] = STATE(701),
    [sym_preproc_pragma] = STATE(701),
    [sym_preproc_nullable] = STATE(701),
    [sym_preproc_error] = STATE(701),
    [sym_preproc_warning] = STATE(701),
    [sym_preproc_define] = STATE(701),
    [sym_preproc_undef] = STATE(701),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [702] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4758),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(702),
    [sym_preproc_endregion] = STATE(702),
    [sym_preproc_line] = STATE(702),
    [sym_preproc_pragma] = STATE(702),
    [sym_preproc_nullable] = STATE(702),
    [sym_preproc_error] = STATE(702),
    [sym_preproc_warning] = STATE(702),
    [sym_preproc_define] = STATE(702),
    [sym_preproc_undef] = STATE(702),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [703] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4320),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(703),
    [sym_preproc_endregion] = STATE(703),
    [sym_preproc_line] = STATE(703),
    [sym_preproc_pragma] = STATE(703),
    [sym_preproc_nullable] = STATE(703),
    [sym_preproc_error] = STATE(703),
    [sym_preproc_warning] = STATE(703),
    [sym_preproc_define] = STATE(703),
    [sym_preproc_undef] = STATE(703),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [704] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4285),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(704),
    [sym_preproc_endregion] = STATE(704),
    [sym_preproc_line] = STATE(704),
    [sym_preproc_pragma] = STATE(704),
    [sym_preproc_nullable] = STATE(704),
    [sym_preproc_error] = STATE(704),
    [sym_preproc_warning] = STATE(704),
    [sym_preproc_define] = STATE(704),
    [sym_preproc_undef] = STATE(704),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [705] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(705),
    [sym_preproc_endregion] = STATE(705),
    [sym_preproc_line] = STATE(705),
    [sym_preproc_pragma] = STATE(705),
    [sym_preproc_nullable] = STATE(705),
    [sym_preproc_error] = STATE(705),
    [sym_preproc_warning] = STATE(705),
    [sym_preproc_define] = STATE(705),
    [sym_preproc_undef] = STATE(705),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [706] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5624),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(706),
    [sym_preproc_endregion] = STATE(706),
    [sym_preproc_line] = STATE(706),
    [sym_preproc_pragma] = STATE(706),
    [sym_preproc_nullable] = STATE(706),
    [sym_preproc_error] = STATE(706),
    [sym_preproc_warning] = STATE(706),
    [sym_preproc_define] = STATE(706),
    [sym_preproc_undef] = STATE(706),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [707] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4888),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(707),
    [sym_preproc_endregion] = STATE(707),
    [sym_preproc_line] = STATE(707),
    [sym_preproc_pragma] = STATE(707),
    [sym_preproc_nullable] = STATE(707),
    [sym_preproc_error] = STATE(707),
    [sym_preproc_warning] = STATE(707),
    [sym_preproc_define] = STATE(707),
    [sym_preproc_undef] = STATE(707),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [708] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4531),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(708),
    [sym_preproc_endregion] = STATE(708),
    [sym_preproc_line] = STATE(708),
    [sym_preproc_pragma] = STATE(708),
    [sym_preproc_nullable] = STATE(708),
    [sym_preproc_error] = STATE(708),
    [sym_preproc_warning] = STATE(708),
    [sym_preproc_define] = STATE(708),
    [sym_preproc_undef] = STATE(708),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [709] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4146),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(709),
    [sym_preproc_endregion] = STATE(709),
    [sym_preproc_line] = STATE(709),
    [sym_preproc_pragma] = STATE(709),
    [sym_preproc_nullable] = STATE(709),
    [sym_preproc_error] = STATE(709),
    [sym_preproc_warning] = STATE(709),
    [sym_preproc_define] = STATE(709),
    [sym_preproc_undef] = STATE(709),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [710] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4699),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(710),
    [sym_preproc_endregion] = STATE(710),
    [sym_preproc_line] = STATE(710),
    [sym_preproc_pragma] = STATE(710),
    [sym_preproc_nullable] = STATE(710),
    [sym_preproc_error] = STATE(710),
    [sym_preproc_warning] = STATE(710),
    [sym_preproc_define] = STATE(710),
    [sym_preproc_undef] = STATE(710),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [711] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(711),
    [sym_preproc_endregion] = STATE(711),
    [sym_preproc_line] = STATE(711),
    [sym_preproc_pragma] = STATE(711),
    [sym_preproc_nullable] = STATE(711),
    [sym_preproc_error] = STATE(711),
    [sym_preproc_warning] = STATE(711),
    [sym_preproc_define] = STATE(711),
    [sym_preproc_undef] = STATE(711),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [712] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4698),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(712),
    [sym_preproc_endregion] = STATE(712),
    [sym_preproc_line] = STATE(712),
    [sym_preproc_pragma] = STATE(712),
    [sym_preproc_nullable] = STATE(712),
    [sym_preproc_error] = STATE(712),
    [sym_preproc_warning] = STATE(712),
    [sym_preproc_define] = STATE(712),
    [sym_preproc_undef] = STATE(712),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [713] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5774),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2262),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5535),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2256),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(713),
    [sym_preproc_endregion] = STATE(713),
    [sym_preproc_line] = STATE(713),
    [sym_preproc_pragma] = STATE(713),
    [sym_preproc_nullable] = STATE(713),
    [sym_preproc_error] = STATE(713),
    [sym_preproc_warning] = STATE(713),
    [sym_preproc_define] = STATE(713),
    [sym_preproc_undef] = STATE(713),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2891),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2567),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [714] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5452),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(714),
    [sym_preproc_endregion] = STATE(714),
    [sym_preproc_line] = STATE(714),
    [sym_preproc_pragma] = STATE(714),
    [sym_preproc_nullable] = STATE(714),
    [sym_preproc_error] = STATE(714),
    [sym_preproc_warning] = STATE(714),
    [sym_preproc_define] = STATE(714),
    [sym_preproc_undef] = STATE(714),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [715] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3823),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(715),
    [sym_preproc_endregion] = STATE(715),
    [sym_preproc_line] = STATE(715),
    [sym_preproc_pragma] = STATE(715),
    [sym_preproc_nullable] = STATE(715),
    [sym_preproc_error] = STATE(715),
    [sym_preproc_warning] = STATE(715),
    [sym_preproc_define] = STATE(715),
    [sym_preproc_undef] = STATE(715),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [716] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(716),
    [sym_preproc_endregion] = STATE(716),
    [sym_preproc_line] = STATE(716),
    [sym_preproc_pragma] = STATE(716),
    [sym_preproc_nullable] = STATE(716),
    [sym_preproc_error] = STATE(716),
    [sym_preproc_warning] = STATE(716),
    [sym_preproc_define] = STATE(716),
    [sym_preproc_undef] = STATE(716),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [717] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4809),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(717),
    [sym_preproc_endregion] = STATE(717),
    [sym_preproc_line] = STATE(717),
    [sym_preproc_pragma] = STATE(717),
    [sym_preproc_nullable] = STATE(717),
    [sym_preproc_error] = STATE(717),
    [sym_preproc_warning] = STATE(717),
    [sym_preproc_define] = STATE(717),
    [sym_preproc_undef] = STATE(717),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [718] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5761),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2316),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2256),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(718),
    [sym_preproc_endregion] = STATE(718),
    [sym_preproc_line] = STATE(718),
    [sym_preproc_pragma] = STATE(718),
    [sym_preproc_nullable] = STATE(718),
    [sym_preproc_error] = STATE(718),
    [sym_preproc_warning] = STATE(718),
    [sym_preproc_define] = STATE(718),
    [sym_preproc_undef] = STATE(718),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2891),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2567),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [719] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5198),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(719),
    [sym_preproc_endregion] = STATE(719),
    [sym_preproc_line] = STATE(719),
    [sym_preproc_pragma] = STATE(719),
    [sym_preproc_nullable] = STATE(719),
    [sym_preproc_error] = STATE(719),
    [sym_preproc_warning] = STATE(719),
    [sym_preproc_define] = STATE(719),
    [sym_preproc_undef] = STATE(719),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [720] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(720),
    [sym_preproc_endregion] = STATE(720),
    [sym_preproc_line] = STATE(720),
    [sym_preproc_pragma] = STATE(720),
    [sym_preproc_nullable] = STATE(720),
    [sym_preproc_error] = STATE(720),
    [sym_preproc_warning] = STATE(720),
    [sym_preproc_define] = STATE(720),
    [sym_preproc_undef] = STATE(720),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [721] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4163),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(721),
    [sym_preproc_endregion] = STATE(721),
    [sym_preproc_line] = STATE(721),
    [sym_preproc_pragma] = STATE(721),
    [sym_preproc_nullable] = STATE(721),
    [sym_preproc_error] = STATE(721),
    [sym_preproc_warning] = STATE(721),
    [sym_preproc_define] = STATE(721),
    [sym_preproc_undef] = STATE(721),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [722] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5411),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(722),
    [sym_preproc_endregion] = STATE(722),
    [sym_preproc_line] = STATE(722),
    [sym_preproc_pragma] = STATE(722),
    [sym_preproc_nullable] = STATE(722),
    [sym_preproc_error] = STATE(722),
    [sym_preproc_warning] = STATE(722),
    [sym_preproc_define] = STATE(722),
    [sym_preproc_undef] = STATE(722),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [723] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5535),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(723),
    [sym_preproc_endregion] = STATE(723),
    [sym_preproc_line] = STATE(723),
    [sym_preproc_pragma] = STATE(723),
    [sym_preproc_nullable] = STATE(723),
    [sym_preproc_error] = STATE(723),
    [sym_preproc_warning] = STATE(723),
    [sym_preproc_define] = STATE(723),
    [sym_preproc_undef] = STATE(723),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [724] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3891),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3693),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(724),
    [sym_preproc_endregion] = STATE(724),
    [sym_preproc_line] = STATE(724),
    [sym_preproc_pragma] = STATE(724),
    [sym_preproc_nullable] = STATE(724),
    [sym_preproc_error] = STATE(724),
    [sym_preproc_warning] = STATE(724),
    [sym_preproc_define] = STATE(724),
    [sym_preproc_undef] = STATE(724),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [725] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5463),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(725),
    [sym_preproc_endregion] = STATE(725),
    [sym_preproc_line] = STATE(725),
    [sym_preproc_pragma] = STATE(725),
    [sym_preproc_nullable] = STATE(725),
    [sym_preproc_error] = STATE(725),
    [sym_preproc_warning] = STATE(725),
    [sym_preproc_define] = STATE(725),
    [sym_preproc_undef] = STATE(725),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [726] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5545),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(726),
    [sym_preproc_endregion] = STATE(726),
    [sym_preproc_line] = STATE(726),
    [sym_preproc_pragma] = STATE(726),
    [sym_preproc_nullable] = STATE(726),
    [sym_preproc_error] = STATE(726),
    [sym_preproc_warning] = STATE(726),
    [sym_preproc_define] = STATE(726),
    [sym_preproc_undef] = STATE(726),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [727] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5590),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(727),
    [sym_preproc_endregion] = STATE(727),
    [sym_preproc_line] = STATE(727),
    [sym_preproc_pragma] = STATE(727),
    [sym_preproc_nullable] = STATE(727),
    [sym_preproc_error] = STATE(727),
    [sym_preproc_warning] = STATE(727),
    [sym_preproc_define] = STATE(727),
    [sym_preproc_undef] = STATE(727),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [728] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5183),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(728),
    [sym_preproc_endregion] = STATE(728),
    [sym_preproc_line] = STATE(728),
    [sym_preproc_pragma] = STATE(728),
    [sym_preproc_nullable] = STATE(728),
    [sym_preproc_error] = STATE(728),
    [sym_preproc_warning] = STATE(728),
    [sym_preproc_define] = STATE(728),
    [sym_preproc_undef] = STATE(728),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [729] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5619),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(729),
    [sym_preproc_endregion] = STATE(729),
    [sym_preproc_line] = STATE(729),
    [sym_preproc_pragma] = STATE(729),
    [sym_preproc_nullable] = STATE(729),
    [sym_preproc_error] = STATE(729),
    [sym_preproc_warning] = STATE(729),
    [sym_preproc_define] = STATE(729),
    [sym_preproc_undef] = STATE(729),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [730] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4420),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(730),
    [sym_preproc_endregion] = STATE(730),
    [sym_preproc_line] = STATE(730),
    [sym_preproc_pragma] = STATE(730),
    [sym_preproc_nullable] = STATE(730),
    [sym_preproc_error] = STATE(730),
    [sym_preproc_warning] = STATE(730),
    [sym_preproc_define] = STATE(730),
    [sym_preproc_undef] = STATE(730),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [731] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4620),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(731),
    [sym_preproc_endregion] = STATE(731),
    [sym_preproc_line] = STATE(731),
    [sym_preproc_pragma] = STATE(731),
    [sym_preproc_nullable] = STATE(731),
    [sym_preproc_error] = STATE(731),
    [sym_preproc_warning] = STATE(731),
    [sym_preproc_define] = STATE(731),
    [sym_preproc_undef] = STATE(731),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [732] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4731),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(732),
    [sym_preproc_endregion] = STATE(732),
    [sym_preproc_line] = STATE(732),
    [sym_preproc_pragma] = STATE(732),
    [sym_preproc_nullable] = STATE(732),
    [sym_preproc_error] = STATE(732),
    [sym_preproc_warning] = STATE(732),
    [sym_preproc_define] = STATE(732),
    [sym_preproc_undef] = STATE(732),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [733] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4230),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(733),
    [sym_preproc_endregion] = STATE(733),
    [sym_preproc_line] = STATE(733),
    [sym_preproc_pragma] = STATE(733),
    [sym_preproc_nullable] = STATE(733),
    [sym_preproc_error] = STATE(733),
    [sym_preproc_warning] = STATE(733),
    [sym_preproc_define] = STATE(733),
    [sym_preproc_undef] = STATE(733),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [734] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4964),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(734),
    [sym_preproc_endregion] = STATE(734),
    [sym_preproc_line] = STATE(734),
    [sym_preproc_pragma] = STATE(734),
    [sym_preproc_nullable] = STATE(734),
    [sym_preproc_error] = STATE(734),
    [sym_preproc_warning] = STATE(734),
    [sym_preproc_define] = STATE(734),
    [sym_preproc_undef] = STATE(734),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [735] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4143),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(735),
    [sym_preproc_endregion] = STATE(735),
    [sym_preproc_line] = STATE(735),
    [sym_preproc_pragma] = STATE(735),
    [sym_preproc_nullable] = STATE(735),
    [sym_preproc_error] = STATE(735),
    [sym_preproc_warning] = STATE(735),
    [sym_preproc_define] = STATE(735),
    [sym_preproc_undef] = STATE(735),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [736] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(736),
    [sym_preproc_endregion] = STATE(736),
    [sym_preproc_line] = STATE(736),
    [sym_preproc_pragma] = STATE(736),
    [sym_preproc_nullable] = STATE(736),
    [sym_preproc_error] = STATE(736),
    [sym_preproc_warning] = STATE(736),
    [sym_preproc_define] = STATE(736),
    [sym_preproc_undef] = STATE(736),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [737] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3694),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(737),
    [sym_preproc_endregion] = STATE(737),
    [sym_preproc_line] = STATE(737),
    [sym_preproc_pragma] = STATE(737),
    [sym_preproc_nullable] = STATE(737),
    [sym_preproc_error] = STATE(737),
    [sym_preproc_warning] = STATE(737),
    [sym_preproc_define] = STATE(737),
    [sym_preproc_undef] = STATE(737),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [738] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2829),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2284),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2544),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2229),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(738),
    [sym_preproc_endregion] = STATE(738),
    [sym_preproc_line] = STATE(738),
    [sym_preproc_pragma] = STATE(738),
    [sym_preproc_nullable] = STATE(738),
    [sym_preproc_error] = STATE(738),
    [sym_preproc_warning] = STATE(738),
    [sym_preproc_define] = STATE(738),
    [sym_preproc_undef] = STATE(738),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(2489),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2907),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2495),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2909),
    [sym_predefined_type] = ACTIONS(2911),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [739] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4855),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(739),
    [sym_preproc_endregion] = STATE(739),
    [sym_preproc_line] = STATE(739),
    [sym_preproc_pragma] = STATE(739),
    [sym_preproc_nullable] = STATE(739),
    [sym_preproc_error] = STATE(739),
    [sym_preproc_warning] = STATE(739),
    [sym_preproc_define] = STATE(739),
    [sym_preproc_undef] = STATE(739),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [740] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5278),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(740),
    [sym_preproc_endregion] = STATE(740),
    [sym_preproc_line] = STATE(740),
    [sym_preproc_pragma] = STATE(740),
    [sym_preproc_nullable] = STATE(740),
    [sym_preproc_error] = STATE(740),
    [sym_preproc_warning] = STATE(740),
    [sym_preproc_define] = STATE(740),
    [sym_preproc_undef] = STATE(740),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [741] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5669),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(741),
    [sym_preproc_endregion] = STATE(741),
    [sym_preproc_line] = STATE(741),
    [sym_preproc_pragma] = STATE(741),
    [sym_preproc_nullable] = STATE(741),
    [sym_preproc_error] = STATE(741),
    [sym_preproc_warning] = STATE(741),
    [sym_preproc_define] = STATE(741),
    [sym_preproc_undef] = STATE(741),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [742] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5286),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(742),
    [sym_preproc_endregion] = STATE(742),
    [sym_preproc_line] = STATE(742),
    [sym_preproc_pragma] = STATE(742),
    [sym_preproc_nullable] = STATE(742),
    [sym_preproc_error] = STATE(742),
    [sym_preproc_warning] = STATE(742),
    [sym_preproc_define] = STATE(742),
    [sym_preproc_undef] = STATE(742),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [743] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(743),
    [sym_preproc_endregion] = STATE(743),
    [sym_preproc_line] = STATE(743),
    [sym_preproc_pragma] = STATE(743),
    [sym_preproc_nullable] = STATE(743),
    [sym_preproc_error] = STATE(743),
    [sym_preproc_warning] = STATE(743),
    [sym_preproc_define] = STATE(743),
    [sym_preproc_undef] = STATE(743),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [744] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5076),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(744),
    [sym_preproc_endregion] = STATE(744),
    [sym_preproc_line] = STATE(744),
    [sym_preproc_pragma] = STATE(744),
    [sym_preproc_nullable] = STATE(744),
    [sym_preproc_error] = STATE(744),
    [sym_preproc_warning] = STATE(744),
    [sym_preproc_define] = STATE(744),
    [sym_preproc_undef] = STATE(744),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [745] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4486),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(745),
    [sym_preproc_endregion] = STATE(745),
    [sym_preproc_line] = STATE(745),
    [sym_preproc_pragma] = STATE(745),
    [sym_preproc_nullable] = STATE(745),
    [sym_preproc_error] = STATE(745),
    [sym_preproc_warning] = STATE(745),
    [sym_preproc_define] = STATE(745),
    [sym_preproc_undef] = STATE(745),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [746] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(746),
    [sym_preproc_endregion] = STATE(746),
    [sym_preproc_line] = STATE(746),
    [sym_preproc_pragma] = STATE(746),
    [sym_preproc_nullable] = STATE(746),
    [sym_preproc_error] = STATE(746),
    [sym_preproc_warning] = STATE(746),
    [sym_preproc_define] = STATE(746),
    [sym_preproc_undef] = STATE(746),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [747] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4780),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(747),
    [sym_preproc_endregion] = STATE(747),
    [sym_preproc_line] = STATE(747),
    [sym_preproc_pragma] = STATE(747),
    [sym_preproc_nullable] = STATE(747),
    [sym_preproc_error] = STATE(747),
    [sym_preproc_warning] = STATE(747),
    [sym_preproc_define] = STATE(747),
    [sym_preproc_undef] = STATE(747),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [748] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5080),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(748),
    [sym_preproc_endregion] = STATE(748),
    [sym_preproc_line] = STATE(748),
    [sym_preproc_pragma] = STATE(748),
    [sym_preproc_nullable] = STATE(748),
    [sym_preproc_error] = STATE(748),
    [sym_preproc_warning] = STATE(748),
    [sym_preproc_define] = STATE(748),
    [sym_preproc_undef] = STATE(748),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [749] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4782),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(749),
    [sym_preproc_endregion] = STATE(749),
    [sym_preproc_line] = STATE(749),
    [sym_preproc_pragma] = STATE(749),
    [sym_preproc_nullable] = STATE(749),
    [sym_preproc_error] = STATE(749),
    [sym_preproc_warning] = STATE(749),
    [sym_preproc_define] = STATE(749),
    [sym_preproc_undef] = STATE(749),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [750] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(750),
    [sym_preproc_endregion] = STATE(750),
    [sym_preproc_line] = STATE(750),
    [sym_preproc_pragma] = STATE(750),
    [sym_preproc_nullable] = STATE(750),
    [sym_preproc_error] = STATE(750),
    [sym_preproc_warning] = STATE(750),
    [sym_preproc_define] = STATE(750),
    [sym_preproc_undef] = STATE(750),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [751] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3843),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(751),
    [sym_preproc_endregion] = STATE(751),
    [sym_preproc_line] = STATE(751),
    [sym_preproc_pragma] = STATE(751),
    [sym_preproc_nullable] = STATE(751),
    [sym_preproc_error] = STATE(751),
    [sym_preproc_warning] = STATE(751),
    [sym_preproc_define] = STATE(751),
    [sym_preproc_undef] = STATE(751),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [752] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4025),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym__ordering] = STATE(6385),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(752),
    [sym_preproc_endregion] = STATE(752),
    [sym_preproc_line] = STATE(752),
    [sym_preproc_pragma] = STATE(752),
    [sym_preproc_nullable] = STATE(752),
    [sym_preproc_error] = STATE(752),
    [sym_preproc_warning] = STATE(752),
    [sym_preproc_define] = STATE(752),
    [sym_preproc_undef] = STATE(752),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [753] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5562),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(753),
    [sym_preproc_endregion] = STATE(753),
    [sym_preproc_line] = STATE(753),
    [sym_preproc_pragma] = STATE(753),
    [sym_preproc_nullable] = STATE(753),
    [sym_preproc_error] = STATE(753),
    [sym_preproc_warning] = STATE(753),
    [sym_preproc_define] = STATE(753),
    [sym_preproc_undef] = STATE(753),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [754] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4111),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(754),
    [sym_preproc_endregion] = STATE(754),
    [sym_preproc_line] = STATE(754),
    [sym_preproc_pragma] = STATE(754),
    [sym_preproc_nullable] = STATE(754),
    [sym_preproc_error] = STATE(754),
    [sym_preproc_warning] = STATE(754),
    [sym_preproc_define] = STATE(754),
    [sym_preproc_undef] = STATE(754),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [755] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5688),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(755),
    [sym_preproc_endregion] = STATE(755),
    [sym_preproc_line] = STATE(755),
    [sym_preproc_pragma] = STATE(755),
    [sym_preproc_nullable] = STATE(755),
    [sym_preproc_error] = STATE(755),
    [sym_preproc_warning] = STATE(755),
    [sym_preproc_define] = STATE(755),
    [sym_preproc_undef] = STATE(755),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [756] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5054),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(6878),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(756),
    [sym_preproc_endregion] = STATE(756),
    [sym_preproc_line] = STATE(756),
    [sym_preproc_pragma] = STATE(756),
    [sym_preproc_nullable] = STATE(756),
    [sym_preproc_error] = STATE(756),
    [sym_preproc_warning] = STATE(756),
    [sym_preproc_define] = STATE(756),
    [sym_preproc_undef] = STATE(756),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [757] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4589),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(757),
    [sym_preproc_endregion] = STATE(757),
    [sym_preproc_line] = STATE(757),
    [sym_preproc_pragma] = STATE(757),
    [sym_preproc_nullable] = STATE(757),
    [sym_preproc_error] = STATE(757),
    [sym_preproc_warning] = STATE(757),
    [sym_preproc_define] = STATE(757),
    [sym_preproc_undef] = STATE(757),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [758] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(758),
    [sym_preproc_endregion] = STATE(758),
    [sym_preproc_line] = STATE(758),
    [sym_preproc_pragma] = STATE(758),
    [sym_preproc_nullable] = STATE(758),
    [sym_preproc_error] = STATE(758),
    [sym_preproc_warning] = STATE(758),
    [sym_preproc_define] = STATE(758),
    [sym_preproc_undef] = STATE(758),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [759] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5534),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(759),
    [sym_preproc_endregion] = STATE(759),
    [sym_preproc_line] = STATE(759),
    [sym_preproc_pragma] = STATE(759),
    [sym_preproc_nullable] = STATE(759),
    [sym_preproc_error] = STATE(759),
    [sym_preproc_warning] = STATE(759),
    [sym_preproc_define] = STATE(759),
    [sym_preproc_undef] = STATE(759),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [760] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4979),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(760),
    [sym_preproc_endregion] = STATE(760),
    [sym_preproc_line] = STATE(760),
    [sym_preproc_pragma] = STATE(760),
    [sym_preproc_nullable] = STATE(760),
    [sym_preproc_error] = STATE(760),
    [sym_preproc_warning] = STATE(760),
    [sym_preproc_define] = STATE(760),
    [sym_preproc_undef] = STATE(760),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [761] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4025),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym__ordering] = STATE(6391),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(761),
    [sym_preproc_endregion] = STATE(761),
    [sym_preproc_line] = STATE(761),
    [sym_preproc_pragma] = STATE(761),
    [sym_preproc_nullable] = STATE(761),
    [sym_preproc_error] = STATE(761),
    [sym_preproc_warning] = STATE(761),
    [sym_preproc_define] = STATE(761),
    [sym_preproc_undef] = STATE(761),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [762] = {
    [sym_attribute_list] = STATE(5810),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5624),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(762),
    [sym_preproc_endregion] = STATE(762),
    [sym_preproc_line] = STATE(762),
    [sym_preproc_pragma] = STATE(762),
    [sym_preproc_nullable] = STATE(762),
    [sym_preproc_error] = STATE(762),
    [sym_preproc_warning] = STATE(762),
    [sym_preproc_define] = STATE(762),
    [sym_preproc_undef] = STATE(762),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_if_token3] = ACTIONS(2921),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [763] = {
    [sym_attribute_argument] = STATE(7142),
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5335),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2293),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(763),
    [sym_preproc_endregion] = STATE(763),
    [sym_preproc_line] = STATE(763),
    [sym_preproc_pragma] = STATE(763),
    [sym_preproc_nullable] = STATE(763),
    [sym_preproc_error] = STATE(763),
    [sym_preproc_warning] = STATE(763),
    [sym_preproc_define] = STATE(763),
    [sym_preproc_undef] = STATE(763),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [764] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5732),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2263),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4809),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(764),
    [sym_preproc_endregion] = STATE(764),
    [sym_preproc_line] = STATE(764),
    [sym_preproc_pragma] = STATE(764),
    [sym_preproc_nullable] = STATE(764),
    [sym_preproc_error] = STATE(764),
    [sym_preproc_warning] = STATE(764),
    [sym_preproc_define] = STATE(764),
    [sym_preproc_undef] = STATE(764),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [765] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(765),
    [sym_preproc_endregion] = STATE(765),
    [sym_preproc_line] = STATE(765),
    [sym_preproc_pragma] = STATE(765),
    [sym_preproc_nullable] = STATE(765),
    [sym_preproc_error] = STATE(765),
    [sym_preproc_warning] = STATE(765),
    [sym_preproc_define] = STATE(765),
    [sym_preproc_undef] = STATE(765),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [766] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4981),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(766),
    [sym_preproc_endregion] = STATE(766),
    [sym_preproc_line] = STATE(766),
    [sym_preproc_pragma] = STATE(766),
    [sym_preproc_nullable] = STATE(766),
    [sym_preproc_error] = STATE(766),
    [sym_preproc_warning] = STATE(766),
    [sym_preproc_define] = STATE(766),
    [sym_preproc_undef] = STATE(766),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [767] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5542),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(767),
    [sym_preproc_endregion] = STATE(767),
    [sym_preproc_line] = STATE(767),
    [sym_preproc_pragma] = STATE(767),
    [sym_preproc_nullable] = STATE(767),
    [sym_preproc_error] = STATE(767),
    [sym_preproc_warning] = STATE(767),
    [sym_preproc_define] = STATE(767),
    [sym_preproc_undef] = STATE(767),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [768] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5426),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(768),
    [sym_preproc_endregion] = STATE(768),
    [sym_preproc_line] = STATE(768),
    [sym_preproc_pragma] = STATE(768),
    [sym_preproc_nullable] = STATE(768),
    [sym_preproc_error] = STATE(768),
    [sym_preproc_warning] = STATE(768),
    [sym_preproc_define] = STATE(768),
    [sym_preproc_undef] = STATE(768),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [769] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4997),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(769),
    [sym_preproc_endregion] = STATE(769),
    [sym_preproc_line] = STATE(769),
    [sym_preproc_pragma] = STATE(769),
    [sym_preproc_nullable] = STATE(769),
    [sym_preproc_error] = STATE(769),
    [sym_preproc_warning] = STATE(769),
    [sym_preproc_define] = STATE(769),
    [sym_preproc_undef] = STATE(769),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [770] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5103),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(770),
    [sym_preproc_endregion] = STATE(770),
    [sym_preproc_line] = STATE(770),
    [sym_preproc_pragma] = STATE(770),
    [sym_preproc_nullable] = STATE(770),
    [sym_preproc_error] = STATE(770),
    [sym_preproc_warning] = STATE(770),
    [sym_preproc_define] = STATE(770),
    [sym_preproc_undef] = STATE(770),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [771] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4269),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(771),
    [sym_preproc_endregion] = STATE(771),
    [sym_preproc_line] = STATE(771),
    [sym_preproc_pragma] = STATE(771),
    [sym_preproc_nullable] = STATE(771),
    [sym_preproc_error] = STATE(771),
    [sym_preproc_warning] = STATE(771),
    [sym_preproc_define] = STATE(771),
    [sym_preproc_undef] = STATE(771),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [772] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4888),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(772),
    [sym_preproc_endregion] = STATE(772),
    [sym_preproc_line] = STATE(772),
    [sym_preproc_pragma] = STATE(772),
    [sym_preproc_nullable] = STATE(772),
    [sym_preproc_error] = STATE(772),
    [sym_preproc_warning] = STATE(772),
    [sym_preproc_define] = STATE(772),
    [sym_preproc_undef] = STATE(772),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [773] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4676),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(773),
    [sym_preproc_endregion] = STATE(773),
    [sym_preproc_line] = STATE(773),
    [sym_preproc_pragma] = STATE(773),
    [sym_preproc_nullable] = STATE(773),
    [sym_preproc_error] = STATE(773),
    [sym_preproc_warning] = STATE(773),
    [sym_preproc_define] = STATE(773),
    [sym_preproc_undef] = STATE(773),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [774] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5460),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(774),
    [sym_preproc_endregion] = STATE(774),
    [sym_preproc_line] = STATE(774),
    [sym_preproc_pragma] = STATE(774),
    [sym_preproc_nullable] = STATE(774),
    [sym_preproc_error] = STATE(774),
    [sym_preproc_warning] = STATE(774),
    [sym_preproc_define] = STATE(774),
    [sym_preproc_undef] = STATE(774),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [775] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5236),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(775),
    [sym_preproc_endregion] = STATE(775),
    [sym_preproc_line] = STATE(775),
    [sym_preproc_pragma] = STATE(775),
    [sym_preproc_nullable] = STATE(775),
    [sym_preproc_error] = STATE(775),
    [sym_preproc_warning] = STATE(775),
    [sym_preproc_define] = STATE(775),
    [sym_preproc_undef] = STATE(775),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [776] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4998),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(776),
    [sym_preproc_endregion] = STATE(776),
    [sym_preproc_line] = STATE(776),
    [sym_preproc_pragma] = STATE(776),
    [sym_preproc_nullable] = STATE(776),
    [sym_preproc_error] = STATE(776),
    [sym_preproc_warning] = STATE(776),
    [sym_preproc_define] = STATE(776),
    [sym_preproc_undef] = STATE(776),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [777] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5353),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(777),
    [sym_preproc_endregion] = STATE(777),
    [sym_preproc_line] = STATE(777),
    [sym_preproc_pragma] = STATE(777),
    [sym_preproc_nullable] = STATE(777),
    [sym_preproc_error] = STATE(777),
    [sym_preproc_warning] = STATE(777),
    [sym_preproc_define] = STATE(777),
    [sym_preproc_undef] = STATE(777),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [778] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(778),
    [sym_preproc_endregion] = STATE(778),
    [sym_preproc_line] = STATE(778),
    [sym_preproc_pragma] = STATE(778),
    [sym_preproc_nullable] = STATE(778),
    [sym_preproc_error] = STATE(778),
    [sym_preproc_warning] = STATE(778),
    [sym_preproc_define] = STATE(778),
    [sym_preproc_undef] = STATE(778),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [779] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5543),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(779),
    [sym_preproc_endregion] = STATE(779),
    [sym_preproc_line] = STATE(779),
    [sym_preproc_pragma] = STATE(779),
    [sym_preproc_nullable] = STATE(779),
    [sym_preproc_error] = STATE(779),
    [sym_preproc_warning] = STATE(779),
    [sym_preproc_define] = STATE(779),
    [sym_preproc_undef] = STATE(779),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [780] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4852),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(780),
    [sym_preproc_endregion] = STATE(780),
    [sym_preproc_line] = STATE(780),
    [sym_preproc_pragma] = STATE(780),
    [sym_preproc_nullable] = STATE(780),
    [sym_preproc_error] = STATE(780),
    [sym_preproc_warning] = STATE(780),
    [sym_preproc_define] = STATE(780),
    [sym_preproc_undef] = STATE(780),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [781] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2680),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2201),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2217),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(781),
    [sym_preproc_endregion] = STATE(781),
    [sym_preproc_line] = STATE(781),
    [sym_preproc_pragma] = STATE(781),
    [sym_preproc_nullable] = STATE(781),
    [sym_preproc_error] = STATE(781),
    [sym_preproc_warning] = STATE(781),
    [sym_preproc_define] = STATE(781),
    [sym_preproc_undef] = STATE(781),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_ref] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2393),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2939),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [782] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5379),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(782),
    [sym_preproc_endregion] = STATE(782),
    [sym_preproc_line] = STATE(782),
    [sym_preproc_pragma] = STATE(782),
    [sym_preproc_nullable] = STATE(782),
    [sym_preproc_error] = STATE(782),
    [sym_preproc_warning] = STATE(782),
    [sym_preproc_define] = STATE(782),
    [sym_preproc_undef] = STATE(782),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [783] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4800),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(783),
    [sym_preproc_endregion] = STATE(783),
    [sym_preproc_line] = STATE(783),
    [sym_preproc_pragma] = STATE(783),
    [sym_preproc_nullable] = STATE(783),
    [sym_preproc_error] = STATE(783),
    [sym_preproc_warning] = STATE(783),
    [sym_preproc_define] = STATE(783),
    [sym_preproc_undef] = STATE(783),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [784] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4854),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(784),
    [sym_preproc_endregion] = STATE(784),
    [sym_preproc_line] = STATE(784),
    [sym_preproc_pragma] = STATE(784),
    [sym_preproc_nullable] = STATE(784),
    [sym_preproc_error] = STATE(784),
    [sym_preproc_warning] = STATE(784),
    [sym_preproc_define] = STATE(784),
    [sym_preproc_undef] = STATE(784),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [785] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5601),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(785),
    [sym_preproc_endregion] = STATE(785),
    [sym_preproc_line] = STATE(785),
    [sym_preproc_pragma] = STATE(785),
    [sym_preproc_nullable] = STATE(785),
    [sym_preproc_error] = STATE(785),
    [sym_preproc_warning] = STATE(785),
    [sym_preproc_define] = STATE(785),
    [sym_preproc_undef] = STATE(785),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [786] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5105),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(786),
    [sym_preproc_endregion] = STATE(786),
    [sym_preproc_line] = STATE(786),
    [sym_preproc_pragma] = STATE(786),
    [sym_preproc_nullable] = STATE(786),
    [sym_preproc_error] = STATE(786),
    [sym_preproc_warning] = STATE(786),
    [sym_preproc_define] = STATE(786),
    [sym_preproc_undef] = STATE(786),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [787] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5222),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(787),
    [sym_preproc_endregion] = STATE(787),
    [sym_preproc_line] = STATE(787),
    [sym_preproc_pragma] = STATE(787),
    [sym_preproc_nullable] = STATE(787),
    [sym_preproc_error] = STATE(787),
    [sym_preproc_warning] = STATE(787),
    [sym_preproc_define] = STATE(787),
    [sym_preproc_undef] = STATE(787),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2943),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [788] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4709),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(788),
    [sym_preproc_endregion] = STATE(788),
    [sym_preproc_line] = STATE(788),
    [sym_preproc_pragma] = STATE(788),
    [sym_preproc_nullable] = STATE(788),
    [sym_preproc_error] = STATE(788),
    [sym_preproc_warning] = STATE(788),
    [sym_preproc_define] = STATE(788),
    [sym_preproc_undef] = STATE(788),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [789] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5754),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4888),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(789),
    [sym_preproc_endregion] = STATE(789),
    [sym_preproc_line] = STATE(789),
    [sym_preproc_pragma] = STATE(789),
    [sym_preproc_nullable] = STATE(789),
    [sym_preproc_error] = STATE(789),
    [sym_preproc_warning] = STATE(789),
    [sym_preproc_define] = STATE(789),
    [sym_preproc_undef] = STATE(789),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2771),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [790] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(790),
    [sym_preproc_endregion] = STATE(790),
    [sym_preproc_line] = STATE(790),
    [sym_preproc_pragma] = STATE(790),
    [sym_preproc_nullable] = STATE(790),
    [sym_preproc_error] = STATE(790),
    [sym_preproc_warning] = STATE(790),
    [sym_preproc_define] = STATE(790),
    [sym_preproc_undef] = STATE(790),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [791] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3891),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3649),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(791),
    [sym_preproc_endregion] = STATE(791),
    [sym_preproc_line] = STATE(791),
    [sym_preproc_pragma] = STATE(791),
    [sym_preproc_nullable] = STATE(791),
    [sym_preproc_error] = STATE(791),
    [sym_preproc_warning] = STATE(791),
    [sym_preproc_define] = STATE(791),
    [sym_preproc_undef] = STATE(791),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [792] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3625),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(792),
    [sym_preproc_endregion] = STATE(792),
    [sym_preproc_line] = STATE(792),
    [sym_preproc_pragma] = STATE(792),
    [sym_preproc_nullable] = STATE(792),
    [sym_preproc_error] = STATE(792),
    [sym_preproc_warning] = STATE(792),
    [sym_preproc_define] = STATE(792),
    [sym_preproc_undef] = STATE(792),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [793] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3955),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(793),
    [sym_preproc_endregion] = STATE(793),
    [sym_preproc_line] = STATE(793),
    [sym_preproc_pragma] = STATE(793),
    [sym_preproc_nullable] = STATE(793),
    [sym_preproc_error] = STATE(793),
    [sym_preproc_warning] = STATE(793),
    [sym_preproc_define] = STATE(793),
    [sym_preproc_undef] = STATE(793),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [794] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3963),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(794),
    [sym_preproc_endregion] = STATE(794),
    [sym_preproc_line] = STATE(794),
    [sym_preproc_pragma] = STATE(794),
    [sym_preproc_nullable] = STATE(794),
    [sym_preproc_error] = STATE(794),
    [sym_preproc_warning] = STATE(794),
    [sym_preproc_define] = STATE(794),
    [sym_preproc_undef] = STATE(794),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [795] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5006),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(795),
    [sym_preproc_endregion] = STATE(795),
    [sym_preproc_line] = STATE(795),
    [sym_preproc_pragma] = STATE(795),
    [sym_preproc_nullable] = STATE(795),
    [sym_preproc_error] = STATE(795),
    [sym_preproc_warning] = STATE(795),
    [sym_preproc_define] = STATE(795),
    [sym_preproc_undef] = STATE(795),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [796] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3891),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3795),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(796),
    [sym_preproc_endregion] = STATE(796),
    [sym_preproc_line] = STATE(796),
    [sym_preproc_pragma] = STATE(796),
    [sym_preproc_nullable] = STATE(796),
    [sym_preproc_error] = STATE(796),
    [sym_preproc_warning] = STATE(796),
    [sym_preproc_define] = STATE(796),
    [sym_preproc_undef] = STATE(796),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [797] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4351),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(797),
    [sym_preproc_endregion] = STATE(797),
    [sym_preproc_line] = STATE(797),
    [sym_preproc_pragma] = STATE(797),
    [sym_preproc_nullable] = STATE(797),
    [sym_preproc_error] = STATE(797),
    [sym_preproc_warning] = STATE(797),
    [sym_preproc_define] = STATE(797),
    [sym_preproc_undef] = STATE(797),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [798] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4311),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(798),
    [sym_preproc_endregion] = STATE(798),
    [sym_preproc_line] = STATE(798),
    [sym_preproc_pragma] = STATE(798),
    [sym_preproc_nullable] = STATE(798),
    [sym_preproc_error] = STATE(798),
    [sym_preproc_warning] = STATE(798),
    [sym_preproc_define] = STATE(798),
    [sym_preproc_undef] = STATE(798),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [799] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2447),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2201),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2192),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(799),
    [sym_preproc_endregion] = STATE(799),
    [sym_preproc_line] = STATE(799),
    [sym_preproc_pragma] = STATE(799),
    [sym_preproc_nullable] = STATE(799),
    [sym_preproc_error] = STATE(799),
    [sym_preproc_warning] = STATE(799),
    [sym_preproc_define] = STATE(799),
    [sym_preproc_undef] = STATE(799),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_ref] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2947),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2939),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [800] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5753),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2259),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5535),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(800),
    [sym_preproc_endregion] = STATE(800),
    [sym_preproc_line] = STATE(800),
    [sym_preproc_pragma] = STATE(800),
    [sym_preproc_nullable] = STATE(800),
    [sym_preproc_error] = STATE(800),
    [sym_preproc_warning] = STATE(800),
    [sym_preproc_define] = STATE(800),
    [sym_preproc_undef] = STATE(800),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [801] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5569),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(801),
    [sym_preproc_endregion] = STATE(801),
    [sym_preproc_line] = STATE(801),
    [sym_preproc_pragma] = STATE(801),
    [sym_preproc_nullable] = STATE(801),
    [sym_preproc_error] = STATE(801),
    [sym_preproc_warning] = STATE(801),
    [sym_preproc_define] = STATE(801),
    [sym_preproc_undef] = STATE(801),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [802] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(2447),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2201),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2268),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(802),
    [sym_preproc_endregion] = STATE(802),
    [sym_preproc_line] = STATE(802),
    [sym_preproc_pragma] = STATE(802),
    [sym_preproc_nullable] = STATE(802),
    [sym_preproc_error] = STATE(802),
    [sym_preproc_warning] = STATE(802),
    [sym_preproc_define] = STATE(802),
    [sym_preproc_undef] = STATE(802),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_ref] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2947),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2373),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2949),
    [sym_predefined_type] = ACTIONS(2397),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [803] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(803),
    [sym_preproc_endregion] = STATE(803),
    [sym_preproc_line] = STATE(803),
    [sym_preproc_pragma] = STATE(803),
    [sym_preproc_nullable] = STATE(803),
    [sym_preproc_error] = STATE(803),
    [sym_preproc_warning] = STATE(803),
    [sym_preproc_define] = STATE(803),
    [sym_preproc_undef] = STATE(803),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [804] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4937),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(804),
    [sym_preproc_endregion] = STATE(804),
    [sym_preproc_line] = STATE(804),
    [sym_preproc_pragma] = STATE(804),
    [sym_preproc_nullable] = STATE(804),
    [sym_preproc_error] = STATE(804),
    [sym_preproc_warning] = STATE(804),
    [sym_preproc_define] = STATE(804),
    [sym_preproc_undef] = STATE(804),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [805] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5491),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(805),
    [sym_preproc_endregion] = STATE(805),
    [sym_preproc_line] = STATE(805),
    [sym_preproc_pragma] = STATE(805),
    [sym_preproc_nullable] = STATE(805),
    [sym_preproc_error] = STATE(805),
    [sym_preproc_warning] = STATE(805),
    [sym_preproc_define] = STATE(805),
    [sym_preproc_undef] = STATE(805),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [806] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(806),
    [sym_preproc_endregion] = STATE(806),
    [sym_preproc_line] = STATE(806),
    [sym_preproc_pragma] = STATE(806),
    [sym_preproc_nullable] = STATE(806),
    [sym_preproc_error] = STATE(806),
    [sym_preproc_warning] = STATE(806),
    [sym_preproc_define] = STATE(806),
    [sym_preproc_undef] = STATE(806),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [807] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5604),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(807),
    [sym_preproc_endregion] = STATE(807),
    [sym_preproc_line] = STATE(807),
    [sym_preproc_pragma] = STATE(807),
    [sym_preproc_nullable] = STATE(807),
    [sym_preproc_error] = STATE(807),
    [sym_preproc_warning] = STATE(807),
    [sym_preproc_define] = STATE(807),
    [sym_preproc_undef] = STATE(807),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [808] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4408),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(808),
    [sym_preproc_endregion] = STATE(808),
    [sym_preproc_line] = STATE(808),
    [sym_preproc_pragma] = STATE(808),
    [sym_preproc_nullable] = STATE(808),
    [sym_preproc_error] = STATE(808),
    [sym_preproc_warning] = STATE(808),
    [sym_preproc_define] = STATE(808),
    [sym_preproc_undef] = STATE(808),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [809] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4946),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(809),
    [sym_preproc_endregion] = STATE(809),
    [sym_preproc_line] = STATE(809),
    [sym_preproc_pragma] = STATE(809),
    [sym_preproc_nullable] = STATE(809),
    [sym_preproc_error] = STATE(809),
    [sym_preproc_warning] = STATE(809),
    [sym_preproc_define] = STATE(809),
    [sym_preproc_undef] = STATE(809),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [810] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4332),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(810),
    [sym_preproc_endregion] = STATE(810),
    [sym_preproc_line] = STATE(810),
    [sym_preproc_pragma] = STATE(810),
    [sym_preproc_nullable] = STATE(810),
    [sym_preproc_error] = STATE(810),
    [sym_preproc_warning] = STATE(810),
    [sym_preproc_define] = STATE(810),
    [sym_preproc_undef] = STATE(810),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [811] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5749),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2259),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(811),
    [sym_preproc_endregion] = STATE(811),
    [sym_preproc_line] = STATE(811),
    [sym_preproc_pragma] = STATE(811),
    [sym_preproc_nullable] = STATE(811),
    [sym_preproc_error] = STATE(811),
    [sym_preproc_warning] = STATE(811),
    [sym_preproc_define] = STATE(811),
    [sym_preproc_undef] = STATE(811),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [812] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4587),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(812),
    [sym_preproc_endregion] = STATE(812),
    [sym_preproc_line] = STATE(812),
    [sym_preproc_pragma] = STATE(812),
    [sym_preproc_nullable] = STATE(812),
    [sym_preproc_error] = STATE(812),
    [sym_preproc_warning] = STATE(812),
    [sym_preproc_define] = STATE(812),
    [sym_preproc_undef] = STATE(812),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [813] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5737),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2245),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4809),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(813),
    [sym_preproc_endregion] = STATE(813),
    [sym_preproc_line] = STATE(813),
    [sym_preproc_pragma] = STATE(813),
    [sym_preproc_nullable] = STATE(813),
    [sym_preproc_error] = STATE(813),
    [sym_preproc_warning] = STATE(813),
    [sym_preproc_define] = STATE(813),
    [sym_preproc_undef] = STATE(813),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [814] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3104),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5032),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(814),
    [sym_preproc_endregion] = STATE(814),
    [sym_preproc_line] = STATE(814),
    [sym_preproc_pragma] = STATE(814),
    [sym_preproc_nullable] = STATE(814),
    [sym_preproc_error] = STATE(814),
    [sym_preproc_warning] = STATE(814),
    [sym_preproc_define] = STATE(814),
    [sym_preproc_undef] = STATE(814),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [815] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5722),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2221),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5535),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(815),
    [sym_preproc_endregion] = STATE(815),
    [sym_preproc_line] = STATE(815),
    [sym_preproc_pragma] = STATE(815),
    [sym_preproc_nullable] = STATE(815),
    [sym_preproc_error] = STATE(815),
    [sym_preproc_warning] = STATE(815),
    [sym_preproc_define] = STATE(815),
    [sym_preproc_undef] = STATE(815),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(1073),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [816] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3761),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(816),
    [sym_preproc_endregion] = STATE(816),
    [sym_preproc_line] = STATE(816),
    [sym_preproc_pragma] = STATE(816),
    [sym_preproc_nullable] = STATE(816),
    [sym_preproc_error] = STATE(816),
    [sym_preproc_warning] = STATE(816),
    [sym_preproc_define] = STATE(816),
    [sym_preproc_undef] = STATE(816),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [817] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4185),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(817),
    [sym_preproc_endregion] = STATE(817),
    [sym_preproc_line] = STATE(817),
    [sym_preproc_pragma] = STATE(817),
    [sym_preproc_nullable] = STATE(817),
    [sym_preproc_error] = STATE(817),
    [sym_preproc_warning] = STATE(817),
    [sym_preproc_define] = STATE(817),
    [sym_preproc_undef] = STATE(817),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [818] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5593),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(818),
    [sym_preproc_endregion] = STATE(818),
    [sym_preproc_line] = STATE(818),
    [sym_preproc_pragma] = STATE(818),
    [sym_preproc_nullable] = STATE(818),
    [sym_preproc_error] = STATE(818),
    [sym_preproc_warning] = STATE(818),
    [sym_preproc_define] = STATE(818),
    [sym_preproc_undef] = STATE(818),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [819] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5752),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2262),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4888),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(819),
    [sym_preproc_endregion] = STATE(819),
    [sym_preproc_line] = STATE(819),
    [sym_preproc_pragma] = STATE(819),
    [sym_preproc_nullable] = STATE(819),
    [sym_preproc_error] = STATE(819),
    [sym_preproc_warning] = STATE(819),
    [sym_preproc_define] = STATE(819),
    [sym_preproc_undef] = STATE(819),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(2083),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(2657),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [820] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5959),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5086),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_declaration_expression] = STATE(7105),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(820),
    [sym_preproc_endregion] = STATE(820),
    [sym_preproc_line] = STATE(820),
    [sym_preproc_pragma] = STATE(820),
    [sym_preproc_nullable] = STATE(820),
    [sym_preproc_error] = STATE(820),
    [sym_preproc_warning] = STATE(820),
    [sym_preproc_define] = STATE(820),
    [sym_preproc_undef] = STATE(820),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [821] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5022),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(821),
    [sym_preproc_endregion] = STATE(821),
    [sym_preproc_line] = STATE(821),
    [sym_preproc_pragma] = STATE(821),
    [sym_preproc_nullable] = STATE(821),
    [sym_preproc_error] = STATE(821),
    [sym_preproc_warning] = STATE(821),
    [sym_preproc_define] = STATE(821),
    [sym_preproc_undef] = STATE(821),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [822] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4733),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(822),
    [sym_preproc_endregion] = STATE(822),
    [sym_preproc_line] = STATE(822),
    [sym_preproc_pragma] = STATE(822),
    [sym_preproc_nullable] = STATE(822),
    [sym_preproc_error] = STATE(822),
    [sym_preproc_warning] = STATE(822),
    [sym_preproc_define] = STATE(822),
    [sym_preproc_undef] = STATE(822),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [823] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4890),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(823),
    [sym_preproc_endregion] = STATE(823),
    [sym_preproc_line] = STATE(823),
    [sym_preproc_pragma] = STATE(823),
    [sym_preproc_nullable] = STATE(823),
    [sym_preproc_error] = STATE(823),
    [sym_preproc_warning] = STATE(823),
    [sym_preproc_define] = STATE(823),
    [sym_preproc_undef] = STATE(823),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [824] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(824),
    [sym_preproc_endregion] = STATE(824),
    [sym_preproc_line] = STATE(824),
    [sym_preproc_pragma] = STATE(824),
    [sym_preproc_nullable] = STATE(824),
    [sym_preproc_error] = STATE(824),
    [sym_preproc_warning] = STATE(824),
    [sym_preproc_define] = STATE(824),
    [sym_preproc_undef] = STATE(824),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [825] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5267),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(825),
    [sym_preproc_endregion] = STATE(825),
    [sym_preproc_line] = STATE(825),
    [sym_preproc_pragma] = STATE(825),
    [sym_preproc_nullable] = STATE(825),
    [sym_preproc_error] = STATE(825),
    [sym_preproc_warning] = STATE(825),
    [sym_preproc_define] = STATE(825),
    [sym_preproc_undef] = STATE(825),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [826] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4258),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(826),
    [sym_preproc_endregion] = STATE(826),
    [sym_preproc_line] = STATE(826),
    [sym_preproc_pragma] = STATE(826),
    [sym_preproc_nullable] = STATE(826),
    [sym_preproc_error] = STATE(826),
    [sym_preproc_warning] = STATE(826),
    [sym_preproc_define] = STATE(826),
    [sym_preproc_undef] = STATE(826),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [827] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4169),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(827),
    [sym_preproc_endregion] = STATE(827),
    [sym_preproc_line] = STATE(827),
    [sym_preproc_pragma] = STATE(827),
    [sym_preproc_nullable] = STATE(827),
    [sym_preproc_error] = STATE(827),
    [sym_preproc_warning] = STATE(827),
    [sym_preproc_define] = STATE(827),
    [sym_preproc_undef] = STATE(827),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [828] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5573),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(828),
    [sym_preproc_endregion] = STATE(828),
    [sym_preproc_line] = STATE(828),
    [sym_preproc_pragma] = STATE(828),
    [sym_preproc_nullable] = STATE(828),
    [sym_preproc_error] = STATE(828),
    [sym_preproc_warning] = STATE(828),
    [sym_preproc_define] = STATE(828),
    [sym_preproc_undef] = STATE(828),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [829] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3388),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4756),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(829),
    [sym_preproc_endregion] = STATE(829),
    [sym_preproc_line] = STATE(829),
    [sym_preproc_pragma] = STATE(829),
    [sym_preproc_nullable] = STATE(829),
    [sym_preproc_error] = STATE(829),
    [sym_preproc_warning] = STATE(829),
    [sym_preproc_define] = STATE(829),
    [sym_preproc_undef] = STATE(829),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [830] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3097),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5337),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(830),
    [sym_preproc_endregion] = STATE(830),
    [sym_preproc_line] = STATE(830),
    [sym_preproc_pragma] = STATE(830),
    [sym_preproc_nullable] = STATE(830),
    [sym_preproc_error] = STATE(830),
    [sym_preproc_warning] = STATE(830),
    [sym_preproc_define] = STATE(830),
    [sym_preproc_undef] = STATE(830),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [831] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4742),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(831),
    [sym_preproc_endregion] = STATE(831),
    [sym_preproc_line] = STATE(831),
    [sym_preproc_pragma] = STATE(831),
    [sym_preproc_nullable] = STATE(831),
    [sym_preproc_error] = STATE(831),
    [sym_preproc_warning] = STATE(831),
    [sym_preproc_define] = STATE(831),
    [sym_preproc_undef] = STATE(831),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [832] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5359),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(832),
    [sym_preproc_endregion] = STATE(832),
    [sym_preproc_line] = STATE(832),
    [sym_preproc_pragma] = STATE(832),
    [sym_preproc_nullable] = STATE(832),
    [sym_preproc_error] = STATE(832),
    [sym_preproc_warning] = STATE(832),
    [sym_preproc_define] = STATE(832),
    [sym_preproc_undef] = STATE(832),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [833] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4000),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(833),
    [sym_preproc_endregion] = STATE(833),
    [sym_preproc_line] = STATE(833),
    [sym_preproc_pragma] = STATE(833),
    [sym_preproc_nullable] = STATE(833),
    [sym_preproc_error] = STATE(833),
    [sym_preproc_warning] = STATE(833),
    [sym_preproc_define] = STATE(833),
    [sym_preproc_undef] = STATE(833),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [834] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5383),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(834),
    [sym_preproc_endregion] = STATE(834),
    [sym_preproc_line] = STATE(834),
    [sym_preproc_pragma] = STATE(834),
    [sym_preproc_nullable] = STATE(834),
    [sym_preproc_error] = STATE(834),
    [sym_preproc_warning] = STATE(834),
    [sym_preproc_define] = STATE(834),
    [sym_preproc_undef] = STATE(834),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [835] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5483),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(835),
    [sym_preproc_endregion] = STATE(835),
    [sym_preproc_line] = STATE(835),
    [sym_preproc_pragma] = STATE(835),
    [sym_preproc_nullable] = STATE(835),
    [sym_preproc_error] = STATE(835),
    [sym_preproc_warning] = STATE(835),
    [sym_preproc_define] = STATE(835),
    [sym_preproc_undef] = STATE(835),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [836] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_block] = STATE(3432),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4554),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(836),
    [sym_preproc_endregion] = STATE(836),
    [sym_preproc_line] = STATE(836),
    [sym_preproc_pragma] = STATE(836),
    [sym_preproc_nullable] = STATE(836),
    [sym_preproc_error] = STATE(836),
    [sym_preproc_warning] = STATE(836),
    [sym_preproc_define] = STATE(836),
    [sym_preproc_undef] = STATE(836),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [837] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5561),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(837),
    [sym_preproc_endregion] = STATE(837),
    [sym_preproc_line] = STATE(837),
    [sym_preproc_pragma] = STATE(837),
    [sym_preproc_nullable] = STATE(837),
    [sym_preproc_error] = STATE(837),
    [sym_preproc_warning] = STATE(837),
    [sym_preproc_define] = STATE(837),
    [sym_preproc_undef] = STATE(837),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [838] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4451),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(838),
    [sym_preproc_endregion] = STATE(838),
    [sym_preproc_line] = STATE(838),
    [sym_preproc_pragma] = STATE(838),
    [sym_preproc_nullable] = STATE(838),
    [sym_preproc_error] = STATE(838),
    [sym_preproc_warning] = STATE(838),
    [sym_preproc_define] = STATE(838),
    [sym_preproc_undef] = STATE(838),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [839] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(2295),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4489),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(839),
    [sym_preproc_endregion] = STATE(839),
    [sym_preproc_line] = STATE(839),
    [sym_preproc_pragma] = STATE(839),
    [sym_preproc_nullable] = STATE(839),
    [sym_preproc_error] = STATE(839),
    [sym_preproc_warning] = STATE(839),
    [sym_preproc_define] = STATE(839),
    [sym_preproc_undef] = STATE(839),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [840] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4586),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(840),
    [sym_preproc_endregion] = STATE(840),
    [sym_preproc_line] = STATE(840),
    [sym_preproc_pragma] = STATE(840),
    [sym_preproc_nullable] = STATE(840),
    [sym_preproc_error] = STATE(840),
    [sym_preproc_warning] = STATE(840),
    [sym_preproc_define] = STATE(840),
    [sym_preproc_undef] = STATE(840),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [841] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3855),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(841),
    [sym_preproc_endregion] = STATE(841),
    [sym_preproc_line] = STATE(841),
    [sym_preproc_pragma] = STATE(841),
    [sym_preproc_nullable] = STATE(841),
    [sym_preproc_error] = STATE(841),
    [sym_preproc_warning] = STATE(841),
    [sym_preproc_define] = STATE(841),
    [sym_preproc_undef] = STATE(841),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [842] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3856),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(842),
    [sym_preproc_endregion] = STATE(842),
    [sym_preproc_line] = STATE(842),
    [sym_preproc_pragma] = STATE(842),
    [sym_preproc_nullable] = STATE(842),
    [sym_preproc_error] = STATE(842),
    [sym_preproc_warning] = STATE(842),
    [sym_preproc_define] = STATE(842),
    [sym_preproc_undef] = STATE(842),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [843] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4474),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(843),
    [sym_preproc_endregion] = STATE(843),
    [sym_preproc_line] = STATE(843),
    [sym_preproc_pragma] = STATE(843),
    [sym_preproc_nullable] = STATE(843),
    [sym_preproc_error] = STATE(843),
    [sym_preproc_warning] = STATE(843),
    [sym_preproc_define] = STATE(843),
    [sym_preproc_undef] = STATE(843),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [844] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5106),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(844),
    [sym_preproc_endregion] = STATE(844),
    [sym_preproc_line] = STATE(844),
    [sym_preproc_pragma] = STATE(844),
    [sym_preproc_nullable] = STATE(844),
    [sym_preproc_error] = STATE(844),
    [sym_preproc_warning] = STATE(844),
    [sym_preproc_define] = STATE(844),
    [sym_preproc_undef] = STATE(844),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [845] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3680),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(845),
    [sym_preproc_endregion] = STATE(845),
    [sym_preproc_line] = STATE(845),
    [sym_preproc_pragma] = STATE(845),
    [sym_preproc_nullable] = STATE(845),
    [sym_preproc_error] = STATE(845),
    [sym_preproc_warning] = STATE(845),
    [sym_preproc_define] = STATE(845),
    [sym_preproc_undef] = STATE(845),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [846] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4274),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(846),
    [sym_preproc_endregion] = STATE(846),
    [sym_preproc_line] = STATE(846),
    [sym_preproc_pragma] = STATE(846),
    [sym_preproc_nullable] = STATE(846),
    [sym_preproc_error] = STATE(846),
    [sym_preproc_warning] = STATE(846),
    [sym_preproc_define] = STATE(846),
    [sym_preproc_undef] = STATE(846),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [847] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4413),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(847),
    [sym_preproc_endregion] = STATE(847),
    [sym_preproc_line] = STATE(847),
    [sym_preproc_pragma] = STATE(847),
    [sym_preproc_nullable] = STATE(847),
    [sym_preproc_error] = STATE(847),
    [sym_preproc_warning] = STATE(847),
    [sym_preproc_define] = STATE(847),
    [sym_preproc_undef] = STATE(847),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [848] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4967),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(848),
    [sym_preproc_endregion] = STATE(848),
    [sym_preproc_line] = STATE(848),
    [sym_preproc_pragma] = STATE(848),
    [sym_preproc_nullable] = STATE(848),
    [sym_preproc_error] = STATE(848),
    [sym_preproc_warning] = STATE(848),
    [sym_preproc_define] = STATE(848),
    [sym_preproc_undef] = STATE(848),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [849] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4737),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(849),
    [sym_preproc_endregion] = STATE(849),
    [sym_preproc_line] = STATE(849),
    [sym_preproc_pragma] = STATE(849),
    [sym_preproc_nullable] = STATE(849),
    [sym_preproc_error] = STATE(849),
    [sym_preproc_warning] = STATE(849),
    [sym_preproc_define] = STATE(849),
    [sym_preproc_undef] = STATE(849),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [850] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4362),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(850),
    [sym_preproc_endregion] = STATE(850),
    [sym_preproc_line] = STATE(850),
    [sym_preproc_pragma] = STATE(850),
    [sym_preproc_nullable] = STATE(850),
    [sym_preproc_error] = STATE(850),
    [sym_preproc_warning] = STATE(850),
    [sym_preproc_define] = STATE(850),
    [sym_preproc_undef] = STATE(850),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [851] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4458),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(851),
    [sym_preproc_endregion] = STATE(851),
    [sym_preproc_line] = STATE(851),
    [sym_preproc_pragma] = STATE(851),
    [sym_preproc_nullable] = STATE(851),
    [sym_preproc_error] = STATE(851),
    [sym_preproc_warning] = STATE(851),
    [sym_preproc_define] = STATE(851),
    [sym_preproc_undef] = STATE(851),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [852] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4493),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(852),
    [sym_preproc_endregion] = STATE(852),
    [sym_preproc_line] = STATE(852),
    [sym_preproc_pragma] = STATE(852),
    [sym_preproc_nullable] = STATE(852),
    [sym_preproc_error] = STATE(852),
    [sym_preproc_warning] = STATE(852),
    [sym_preproc_define] = STATE(852),
    [sym_preproc_undef] = STATE(852),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [853] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4499),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(853),
    [sym_preproc_endregion] = STATE(853),
    [sym_preproc_line] = STATE(853),
    [sym_preproc_pragma] = STATE(853),
    [sym_preproc_nullable] = STATE(853),
    [sym_preproc_error] = STATE(853),
    [sym_preproc_warning] = STATE(853),
    [sym_preproc_define] = STATE(853),
    [sym_preproc_undef] = STATE(853),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [854] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4500),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(854),
    [sym_preproc_endregion] = STATE(854),
    [sym_preproc_line] = STATE(854),
    [sym_preproc_pragma] = STATE(854),
    [sym_preproc_nullable] = STATE(854),
    [sym_preproc_error] = STATE(854),
    [sym_preproc_warning] = STATE(854),
    [sym_preproc_define] = STATE(854),
    [sym_preproc_undef] = STATE(854),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [855] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4510),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(855),
    [sym_preproc_endregion] = STATE(855),
    [sym_preproc_line] = STATE(855),
    [sym_preproc_pragma] = STATE(855),
    [sym_preproc_nullable] = STATE(855),
    [sym_preproc_error] = STATE(855),
    [sym_preproc_warning] = STATE(855),
    [sym_preproc_define] = STATE(855),
    [sym_preproc_undef] = STATE(855),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [856] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4518),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(856),
    [sym_preproc_endregion] = STATE(856),
    [sym_preproc_line] = STATE(856),
    [sym_preproc_pragma] = STATE(856),
    [sym_preproc_nullable] = STATE(856),
    [sym_preproc_error] = STATE(856),
    [sym_preproc_warning] = STATE(856),
    [sym_preproc_define] = STATE(856),
    [sym_preproc_undef] = STATE(856),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [857] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4534),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(857),
    [sym_preproc_endregion] = STATE(857),
    [sym_preproc_line] = STATE(857),
    [sym_preproc_pragma] = STATE(857),
    [sym_preproc_nullable] = STATE(857),
    [sym_preproc_error] = STATE(857),
    [sym_preproc_warning] = STATE(857),
    [sym_preproc_define] = STATE(857),
    [sym_preproc_undef] = STATE(857),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [858] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4473),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(858),
    [sym_preproc_endregion] = STATE(858),
    [sym_preproc_line] = STATE(858),
    [sym_preproc_pragma] = STATE(858),
    [sym_preproc_nullable] = STATE(858),
    [sym_preproc_error] = STATE(858),
    [sym_preproc_warning] = STATE(858),
    [sym_preproc_define] = STATE(858),
    [sym_preproc_undef] = STATE(858),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [859] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4400),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(859),
    [sym_preproc_endregion] = STATE(859),
    [sym_preproc_line] = STATE(859),
    [sym_preproc_pragma] = STATE(859),
    [sym_preproc_nullable] = STATE(859),
    [sym_preproc_error] = STATE(859),
    [sym_preproc_warning] = STATE(859),
    [sym_preproc_define] = STATE(859),
    [sym_preproc_undef] = STATE(859),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [860] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4429),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(860),
    [sym_preproc_endregion] = STATE(860),
    [sym_preproc_line] = STATE(860),
    [sym_preproc_pragma] = STATE(860),
    [sym_preproc_nullable] = STATE(860),
    [sym_preproc_error] = STATE(860),
    [sym_preproc_warning] = STATE(860),
    [sym_preproc_define] = STATE(860),
    [sym_preproc_undef] = STATE(860),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [861] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4410),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(861),
    [sym_preproc_endregion] = STATE(861),
    [sym_preproc_line] = STATE(861),
    [sym_preproc_pragma] = STATE(861),
    [sym_preproc_nullable] = STATE(861),
    [sym_preproc_error] = STATE(861),
    [sym_preproc_warning] = STATE(861),
    [sym_preproc_define] = STATE(861),
    [sym_preproc_undef] = STATE(861),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [862] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4740),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(862),
    [sym_preproc_endregion] = STATE(862),
    [sym_preproc_line] = STATE(862),
    [sym_preproc_pragma] = STATE(862),
    [sym_preproc_nullable] = STATE(862),
    [sym_preproc_error] = STATE(862),
    [sym_preproc_warning] = STATE(862),
    [sym_preproc_define] = STATE(862),
    [sym_preproc_undef] = STATE(862),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [863] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5033),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(863),
    [sym_preproc_endregion] = STATE(863),
    [sym_preproc_line] = STATE(863),
    [sym_preproc_pragma] = STATE(863),
    [sym_preproc_nullable] = STATE(863),
    [sym_preproc_error] = STATE(863),
    [sym_preproc_warning] = STATE(863),
    [sym_preproc_define] = STATE(863),
    [sym_preproc_undef] = STATE(863),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [864] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(864),
    [sym_preproc_endregion] = STATE(864),
    [sym_preproc_line] = STATE(864),
    [sym_preproc_pragma] = STATE(864),
    [sym_preproc_nullable] = STATE(864),
    [sym_preproc_error] = STATE(864),
    [sym_preproc_warning] = STATE(864),
    [sym_preproc_define] = STATE(864),
    [sym_preproc_undef] = STATE(864),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [865] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4324),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(865),
    [sym_preproc_endregion] = STATE(865),
    [sym_preproc_line] = STATE(865),
    [sym_preproc_pragma] = STATE(865),
    [sym_preproc_nullable] = STATE(865),
    [sym_preproc_error] = STATE(865),
    [sym_preproc_warning] = STATE(865),
    [sym_preproc_define] = STATE(865),
    [sym_preproc_undef] = STATE(865),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [866] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4743),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(866),
    [sym_preproc_endregion] = STATE(866),
    [sym_preproc_line] = STATE(866),
    [sym_preproc_pragma] = STATE(866),
    [sym_preproc_nullable] = STATE(866),
    [sym_preproc_error] = STATE(866),
    [sym_preproc_warning] = STATE(866),
    [sym_preproc_define] = STATE(866),
    [sym_preproc_undef] = STATE(866),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [867] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5110),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(867),
    [sym_preproc_endregion] = STATE(867),
    [sym_preproc_line] = STATE(867),
    [sym_preproc_pragma] = STATE(867),
    [sym_preproc_nullable] = STATE(867),
    [sym_preproc_error] = STATE(867),
    [sym_preproc_warning] = STATE(867),
    [sym_preproc_define] = STATE(867),
    [sym_preproc_undef] = STATE(867),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [868] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4270),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(868),
    [sym_preproc_endregion] = STATE(868),
    [sym_preproc_line] = STATE(868),
    [sym_preproc_pragma] = STATE(868),
    [sym_preproc_nullable] = STATE(868),
    [sym_preproc_error] = STATE(868),
    [sym_preproc_warning] = STATE(868),
    [sym_preproc_define] = STATE(868),
    [sym_preproc_undef] = STATE(868),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [869] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(869),
    [sym_preproc_endregion] = STATE(869),
    [sym_preproc_line] = STATE(869),
    [sym_preproc_pragma] = STATE(869),
    [sym_preproc_nullable] = STATE(869),
    [sym_preproc_error] = STATE(869),
    [sym_preproc_warning] = STATE(869),
    [sym_preproc_define] = STATE(869),
    [sym_preproc_undef] = STATE(869),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [870] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4759),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(870),
    [sym_preproc_endregion] = STATE(870),
    [sym_preproc_line] = STATE(870),
    [sym_preproc_pragma] = STATE(870),
    [sym_preproc_nullable] = STATE(870),
    [sym_preproc_error] = STATE(870),
    [sym_preproc_warning] = STATE(870),
    [sym_preproc_define] = STATE(870),
    [sym_preproc_undef] = STATE(870),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [871] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4760),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(871),
    [sym_preproc_endregion] = STATE(871),
    [sym_preproc_line] = STATE(871),
    [sym_preproc_pragma] = STATE(871),
    [sym_preproc_nullable] = STATE(871),
    [sym_preproc_error] = STATE(871),
    [sym_preproc_warning] = STATE(871),
    [sym_preproc_define] = STATE(871),
    [sym_preproc_undef] = STATE(871),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [872] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4761),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(872),
    [sym_preproc_endregion] = STATE(872),
    [sym_preproc_line] = STATE(872),
    [sym_preproc_pragma] = STATE(872),
    [sym_preproc_nullable] = STATE(872),
    [sym_preproc_error] = STATE(872),
    [sym_preproc_warning] = STATE(872),
    [sym_preproc_define] = STATE(872),
    [sym_preproc_undef] = STATE(872),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [873] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4545),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(873),
    [sym_preproc_endregion] = STATE(873),
    [sym_preproc_line] = STATE(873),
    [sym_preproc_pragma] = STATE(873),
    [sym_preproc_nullable] = STATE(873),
    [sym_preproc_error] = STATE(873),
    [sym_preproc_warning] = STATE(873),
    [sym_preproc_define] = STATE(873),
    [sym_preproc_undef] = STATE(873),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [874] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4546),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(874),
    [sym_preproc_endregion] = STATE(874),
    [sym_preproc_line] = STATE(874),
    [sym_preproc_pragma] = STATE(874),
    [sym_preproc_nullable] = STATE(874),
    [sym_preproc_error] = STATE(874),
    [sym_preproc_warning] = STATE(874),
    [sym_preproc_define] = STATE(874),
    [sym_preproc_undef] = STATE(874),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [875] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4547),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(875),
    [sym_preproc_endregion] = STATE(875),
    [sym_preproc_line] = STATE(875),
    [sym_preproc_pragma] = STATE(875),
    [sym_preproc_nullable] = STATE(875),
    [sym_preproc_error] = STATE(875),
    [sym_preproc_warning] = STATE(875),
    [sym_preproc_define] = STATE(875),
    [sym_preproc_undef] = STATE(875),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [876] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4762),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(876),
    [sym_preproc_endregion] = STATE(876),
    [sym_preproc_line] = STATE(876),
    [sym_preproc_pragma] = STATE(876),
    [sym_preproc_nullable] = STATE(876),
    [sym_preproc_error] = STATE(876),
    [sym_preproc_warning] = STATE(876),
    [sym_preproc_define] = STATE(876),
    [sym_preproc_undef] = STATE(876),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [877] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4548),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(877),
    [sym_preproc_endregion] = STATE(877),
    [sym_preproc_line] = STATE(877),
    [sym_preproc_pragma] = STATE(877),
    [sym_preproc_nullable] = STATE(877),
    [sym_preproc_error] = STATE(877),
    [sym_preproc_warning] = STATE(877),
    [sym_preproc_define] = STATE(877),
    [sym_preproc_undef] = STATE(877),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [878] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4568),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(878),
    [sym_preproc_endregion] = STATE(878),
    [sym_preproc_line] = STATE(878),
    [sym_preproc_pragma] = STATE(878),
    [sym_preproc_nullable] = STATE(878),
    [sym_preproc_error] = STATE(878),
    [sym_preproc_warning] = STATE(878),
    [sym_preproc_define] = STATE(878),
    [sym_preproc_undef] = STATE(878),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [879] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4550),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(879),
    [sym_preproc_endregion] = STATE(879),
    [sym_preproc_line] = STATE(879),
    [sym_preproc_pragma] = STATE(879),
    [sym_preproc_nullable] = STATE(879),
    [sym_preproc_error] = STATE(879),
    [sym_preproc_warning] = STATE(879),
    [sym_preproc_define] = STATE(879),
    [sym_preproc_undef] = STATE(879),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [880] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4551),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(880),
    [sym_preproc_endregion] = STATE(880),
    [sym_preproc_line] = STATE(880),
    [sym_preproc_pragma] = STATE(880),
    [sym_preproc_nullable] = STATE(880),
    [sym_preproc_error] = STATE(880),
    [sym_preproc_warning] = STATE(880),
    [sym_preproc_define] = STATE(880),
    [sym_preproc_undef] = STATE(880),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [881] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4552),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(881),
    [sym_preproc_endregion] = STATE(881),
    [sym_preproc_line] = STATE(881),
    [sym_preproc_pragma] = STATE(881),
    [sym_preproc_nullable] = STATE(881),
    [sym_preproc_error] = STATE(881),
    [sym_preproc_warning] = STATE(881),
    [sym_preproc_define] = STATE(881),
    [sym_preproc_undef] = STATE(881),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [882] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4229),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(882),
    [sym_preproc_endregion] = STATE(882),
    [sym_preproc_line] = STATE(882),
    [sym_preproc_pragma] = STATE(882),
    [sym_preproc_nullable] = STATE(882),
    [sym_preproc_error] = STATE(882),
    [sym_preproc_warning] = STATE(882),
    [sym_preproc_define] = STATE(882),
    [sym_preproc_undef] = STATE(882),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [883] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4363),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(883),
    [sym_preproc_endregion] = STATE(883),
    [sym_preproc_line] = STATE(883),
    [sym_preproc_pragma] = STATE(883),
    [sym_preproc_nullable] = STATE(883),
    [sym_preproc_error] = STATE(883),
    [sym_preproc_warning] = STATE(883),
    [sym_preproc_define] = STATE(883),
    [sym_preproc_undef] = STATE(883),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [884] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5697),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(884),
    [sym_preproc_endregion] = STATE(884),
    [sym_preproc_line] = STATE(884),
    [sym_preproc_pragma] = STATE(884),
    [sym_preproc_nullable] = STATE(884),
    [sym_preproc_error] = STATE(884),
    [sym_preproc_warning] = STATE(884),
    [sym_preproc_define] = STATE(884),
    [sym_preproc_undef] = STATE(884),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [885] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4239),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(885),
    [sym_preproc_endregion] = STATE(885),
    [sym_preproc_line] = STATE(885),
    [sym_preproc_pragma] = STATE(885),
    [sym_preproc_nullable] = STATE(885),
    [sym_preproc_error] = STATE(885),
    [sym_preproc_warning] = STATE(885),
    [sym_preproc_define] = STATE(885),
    [sym_preproc_undef] = STATE(885),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [886] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4243),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(886),
    [sym_preproc_endregion] = STATE(886),
    [sym_preproc_line] = STATE(886),
    [sym_preproc_pragma] = STATE(886),
    [sym_preproc_nullable] = STATE(886),
    [sym_preproc_error] = STATE(886),
    [sym_preproc_warning] = STATE(886),
    [sym_preproc_define] = STATE(886),
    [sym_preproc_undef] = STATE(886),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [887] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4455),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(887),
    [sym_preproc_endregion] = STATE(887),
    [sym_preproc_line] = STATE(887),
    [sym_preproc_pragma] = STATE(887),
    [sym_preproc_nullable] = STATE(887),
    [sym_preproc_error] = STATE(887),
    [sym_preproc_warning] = STATE(887),
    [sym_preproc_define] = STATE(887),
    [sym_preproc_undef] = STATE(887),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [888] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(888),
    [sym_preproc_endregion] = STATE(888),
    [sym_preproc_line] = STATE(888),
    [sym_preproc_pragma] = STATE(888),
    [sym_preproc_nullable] = STATE(888),
    [sym_preproc_error] = STATE(888),
    [sym_preproc_warning] = STATE(888),
    [sym_preproc_define] = STATE(888),
    [sym_preproc_undef] = STATE(888),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [889] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4254),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(889),
    [sym_preproc_endregion] = STATE(889),
    [sym_preproc_line] = STATE(889),
    [sym_preproc_pragma] = STATE(889),
    [sym_preproc_nullable] = STATE(889),
    [sym_preproc_error] = STATE(889),
    [sym_preproc_warning] = STATE(889),
    [sym_preproc_define] = STATE(889),
    [sym_preproc_undef] = STATE(889),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [890] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4271),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(890),
    [sym_preproc_endregion] = STATE(890),
    [sym_preproc_line] = STATE(890),
    [sym_preproc_pragma] = STATE(890),
    [sym_preproc_nullable] = STATE(890),
    [sym_preproc_error] = STATE(890),
    [sym_preproc_warning] = STATE(890),
    [sym_preproc_define] = STATE(890),
    [sym_preproc_undef] = STATE(890),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [891] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4279),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(891),
    [sym_preproc_endregion] = STATE(891),
    [sym_preproc_line] = STATE(891),
    [sym_preproc_pragma] = STATE(891),
    [sym_preproc_nullable] = STATE(891),
    [sym_preproc_error] = STATE(891),
    [sym_preproc_warning] = STATE(891),
    [sym_preproc_define] = STATE(891),
    [sym_preproc_undef] = STATE(891),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [892] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4224),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(892),
    [sym_preproc_endregion] = STATE(892),
    [sym_preproc_line] = STATE(892),
    [sym_preproc_pragma] = STATE(892),
    [sym_preproc_nullable] = STATE(892),
    [sym_preproc_error] = STATE(892),
    [sym_preproc_warning] = STATE(892),
    [sym_preproc_define] = STATE(892),
    [sym_preproc_undef] = STATE(892),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [893] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4232),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(893),
    [sym_preproc_endregion] = STATE(893),
    [sym_preproc_line] = STATE(893),
    [sym_preproc_pragma] = STATE(893),
    [sym_preproc_nullable] = STATE(893),
    [sym_preproc_error] = STATE(893),
    [sym_preproc_warning] = STATE(893),
    [sym_preproc_define] = STATE(893),
    [sym_preproc_undef] = STATE(893),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [894] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4233),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(894),
    [sym_preproc_endregion] = STATE(894),
    [sym_preproc_line] = STATE(894),
    [sym_preproc_pragma] = STATE(894),
    [sym_preproc_nullable] = STATE(894),
    [sym_preproc_error] = STATE(894),
    [sym_preproc_warning] = STATE(894),
    [sym_preproc_define] = STATE(894),
    [sym_preproc_undef] = STATE(894),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [895] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4240),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(895),
    [sym_preproc_endregion] = STATE(895),
    [sym_preproc_line] = STATE(895),
    [sym_preproc_pragma] = STATE(895),
    [sym_preproc_nullable] = STATE(895),
    [sym_preproc_error] = STATE(895),
    [sym_preproc_warning] = STATE(895),
    [sym_preproc_define] = STATE(895),
    [sym_preproc_undef] = STATE(895),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [896] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4242),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(896),
    [sym_preproc_endregion] = STATE(896),
    [sym_preproc_line] = STATE(896),
    [sym_preproc_pragma] = STATE(896),
    [sym_preproc_nullable] = STATE(896),
    [sym_preproc_error] = STATE(896),
    [sym_preproc_warning] = STATE(896),
    [sym_preproc_define] = STATE(896),
    [sym_preproc_undef] = STATE(896),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [897] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4244),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(897),
    [sym_preproc_endregion] = STATE(897),
    [sym_preproc_line] = STATE(897),
    [sym_preproc_pragma] = STATE(897),
    [sym_preproc_nullable] = STATE(897),
    [sym_preproc_error] = STATE(897),
    [sym_preproc_warning] = STATE(897),
    [sym_preproc_define] = STATE(897),
    [sym_preproc_undef] = STATE(897),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [898] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4246),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(898),
    [sym_preproc_endregion] = STATE(898),
    [sym_preproc_line] = STATE(898),
    [sym_preproc_pragma] = STATE(898),
    [sym_preproc_nullable] = STATE(898),
    [sym_preproc_error] = STATE(898),
    [sym_preproc_warning] = STATE(898),
    [sym_preproc_define] = STATE(898),
    [sym_preproc_undef] = STATE(898),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [899] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4250),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(899),
    [sym_preproc_endregion] = STATE(899),
    [sym_preproc_line] = STATE(899),
    [sym_preproc_pragma] = STATE(899),
    [sym_preproc_nullable] = STATE(899),
    [sym_preproc_error] = STATE(899),
    [sym_preproc_warning] = STATE(899),
    [sym_preproc_define] = STATE(899),
    [sym_preproc_undef] = STATE(899),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [900] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4418),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(900),
    [sym_preproc_endregion] = STATE(900),
    [sym_preproc_line] = STATE(900),
    [sym_preproc_pragma] = STATE(900),
    [sym_preproc_nullable] = STATE(900),
    [sym_preproc_error] = STATE(900),
    [sym_preproc_warning] = STATE(900),
    [sym_preproc_define] = STATE(900),
    [sym_preproc_undef] = STATE(900),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [901] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(901),
    [sym_preproc_endregion] = STATE(901),
    [sym_preproc_line] = STATE(901),
    [sym_preproc_pragma] = STATE(901),
    [sym_preproc_nullable] = STATE(901),
    [sym_preproc_error] = STATE(901),
    [sym_preproc_warning] = STATE(901),
    [sym_preproc_define] = STATE(901),
    [sym_preproc_undef] = STATE(901),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [902] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5424),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(902),
    [sym_preproc_endregion] = STATE(902),
    [sym_preproc_line] = STATE(902),
    [sym_preproc_pragma] = STATE(902),
    [sym_preproc_nullable] = STATE(902),
    [sym_preproc_error] = STATE(902),
    [sym_preproc_warning] = STATE(902),
    [sym_preproc_define] = STATE(902),
    [sym_preproc_undef] = STATE(902),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [903] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4440),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(903),
    [sym_preproc_endregion] = STATE(903),
    [sym_preproc_line] = STATE(903),
    [sym_preproc_pragma] = STATE(903),
    [sym_preproc_nullable] = STATE(903),
    [sym_preproc_error] = STATE(903),
    [sym_preproc_warning] = STATE(903),
    [sym_preproc_define] = STATE(903),
    [sym_preproc_undef] = STATE(903),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [904] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5230),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(904),
    [sym_preproc_endregion] = STATE(904),
    [sym_preproc_line] = STATE(904),
    [sym_preproc_pragma] = STATE(904),
    [sym_preproc_nullable] = STATE(904),
    [sym_preproc_error] = STATE(904),
    [sym_preproc_warning] = STATE(904),
    [sym_preproc_define] = STATE(904),
    [sym_preproc_undef] = STATE(904),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [905] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4623),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(905),
    [sym_preproc_endregion] = STATE(905),
    [sym_preproc_line] = STATE(905),
    [sym_preproc_pragma] = STATE(905),
    [sym_preproc_nullable] = STATE(905),
    [sym_preproc_error] = STATE(905),
    [sym_preproc_warning] = STATE(905),
    [sym_preproc_define] = STATE(905),
    [sym_preproc_undef] = STATE(905),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [906] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5478),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(906),
    [sym_preproc_endregion] = STATE(906),
    [sym_preproc_line] = STATE(906),
    [sym_preproc_pragma] = STATE(906),
    [sym_preproc_nullable] = STATE(906),
    [sym_preproc_error] = STATE(906),
    [sym_preproc_warning] = STATE(906),
    [sym_preproc_define] = STATE(906),
    [sym_preproc_undef] = STATE(906),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [907] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4104),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(907),
    [sym_preproc_endregion] = STATE(907),
    [sym_preproc_line] = STATE(907),
    [sym_preproc_pragma] = STATE(907),
    [sym_preproc_nullable] = STATE(907),
    [sym_preproc_error] = STATE(907),
    [sym_preproc_warning] = STATE(907),
    [sym_preproc_define] = STATE(907),
    [sym_preproc_undef] = STATE(907),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [908] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(908),
    [sym_preproc_endregion] = STATE(908),
    [sym_preproc_line] = STATE(908),
    [sym_preproc_pragma] = STATE(908),
    [sym_preproc_nullable] = STATE(908),
    [sym_preproc_error] = STATE(908),
    [sym_preproc_warning] = STATE(908),
    [sym_preproc_define] = STATE(908),
    [sym_preproc_undef] = STATE(908),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [909] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4190),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(909),
    [sym_preproc_endregion] = STATE(909),
    [sym_preproc_line] = STATE(909),
    [sym_preproc_pragma] = STATE(909),
    [sym_preproc_nullable] = STATE(909),
    [sym_preproc_error] = STATE(909),
    [sym_preproc_warning] = STATE(909),
    [sym_preproc_define] = STATE(909),
    [sym_preproc_undef] = STATE(909),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [910] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(910),
    [sym_preproc_endregion] = STATE(910),
    [sym_preproc_line] = STATE(910),
    [sym_preproc_pragma] = STATE(910),
    [sym_preproc_nullable] = STATE(910),
    [sym_preproc_error] = STATE(910),
    [sym_preproc_warning] = STATE(910),
    [sym_preproc_define] = STATE(910),
    [sym_preproc_undef] = STATE(910),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [911] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5743),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(911),
    [sym_preproc_endregion] = STATE(911),
    [sym_preproc_line] = STATE(911),
    [sym_preproc_pragma] = STATE(911),
    [sym_preproc_nullable] = STATE(911),
    [sym_preproc_error] = STATE(911),
    [sym_preproc_warning] = STATE(911),
    [sym_preproc_define] = STATE(911),
    [sym_preproc_undef] = STATE(911),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [912] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4488),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(912),
    [sym_preproc_endregion] = STATE(912),
    [sym_preproc_line] = STATE(912),
    [sym_preproc_pragma] = STATE(912),
    [sym_preproc_nullable] = STATE(912),
    [sym_preproc_error] = STATE(912),
    [sym_preproc_warning] = STATE(912),
    [sym_preproc_define] = STATE(912),
    [sym_preproc_undef] = STATE(912),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [913] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4939),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(913),
    [sym_preproc_endregion] = STATE(913),
    [sym_preproc_line] = STATE(913),
    [sym_preproc_pragma] = STATE(913),
    [sym_preproc_nullable] = STATE(913),
    [sym_preproc_error] = STATE(913),
    [sym_preproc_warning] = STATE(913),
    [sym_preproc_define] = STATE(913),
    [sym_preproc_undef] = STATE(913),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [914] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(914),
    [sym_preproc_endregion] = STATE(914),
    [sym_preproc_line] = STATE(914),
    [sym_preproc_pragma] = STATE(914),
    [sym_preproc_nullable] = STATE(914),
    [sym_preproc_error] = STATE(914),
    [sym_preproc_warning] = STATE(914),
    [sym_preproc_define] = STATE(914),
    [sym_preproc_undef] = STATE(914),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [915] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5457),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(915),
    [sym_preproc_endregion] = STATE(915),
    [sym_preproc_line] = STATE(915),
    [sym_preproc_pragma] = STATE(915),
    [sym_preproc_nullable] = STATE(915),
    [sym_preproc_error] = STATE(915),
    [sym_preproc_warning] = STATE(915),
    [sym_preproc_define] = STATE(915),
    [sym_preproc_undef] = STATE(915),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [916] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5504),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(916),
    [sym_preproc_endregion] = STATE(916),
    [sym_preproc_line] = STATE(916),
    [sym_preproc_pragma] = STATE(916),
    [sym_preproc_nullable] = STATE(916),
    [sym_preproc_error] = STATE(916),
    [sym_preproc_warning] = STATE(916),
    [sym_preproc_define] = STATE(916),
    [sym_preproc_undef] = STATE(916),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [917] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4826),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(917),
    [sym_preproc_endregion] = STATE(917),
    [sym_preproc_line] = STATE(917),
    [sym_preproc_pragma] = STATE(917),
    [sym_preproc_nullable] = STATE(917),
    [sym_preproc_error] = STATE(917),
    [sym_preproc_warning] = STATE(917),
    [sym_preproc_define] = STATE(917),
    [sym_preproc_undef] = STATE(917),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [918] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4827),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(918),
    [sym_preproc_endregion] = STATE(918),
    [sym_preproc_line] = STATE(918),
    [sym_preproc_pragma] = STATE(918),
    [sym_preproc_nullable] = STATE(918),
    [sym_preproc_error] = STATE(918),
    [sym_preproc_warning] = STATE(918),
    [sym_preproc_define] = STATE(918),
    [sym_preproc_undef] = STATE(918),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [919] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4828),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(919),
    [sym_preproc_endregion] = STATE(919),
    [sym_preproc_line] = STATE(919),
    [sym_preproc_pragma] = STATE(919),
    [sym_preproc_nullable] = STATE(919),
    [sym_preproc_error] = STATE(919),
    [sym_preproc_warning] = STATE(919),
    [sym_preproc_define] = STATE(919),
    [sym_preproc_undef] = STATE(919),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [920] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4829),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(920),
    [sym_preproc_endregion] = STATE(920),
    [sym_preproc_line] = STATE(920),
    [sym_preproc_pragma] = STATE(920),
    [sym_preproc_nullable] = STATE(920),
    [sym_preproc_error] = STATE(920),
    [sym_preproc_warning] = STATE(920),
    [sym_preproc_define] = STATE(920),
    [sym_preproc_undef] = STATE(920),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [921] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4830),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(921),
    [sym_preproc_endregion] = STATE(921),
    [sym_preproc_line] = STATE(921),
    [sym_preproc_pragma] = STATE(921),
    [sym_preproc_nullable] = STATE(921),
    [sym_preproc_error] = STATE(921),
    [sym_preproc_warning] = STATE(921),
    [sym_preproc_define] = STATE(921),
    [sym_preproc_undef] = STATE(921),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [922] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4831),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(922),
    [sym_preproc_endregion] = STATE(922),
    [sym_preproc_line] = STATE(922),
    [sym_preproc_pragma] = STATE(922),
    [sym_preproc_nullable] = STATE(922),
    [sym_preproc_error] = STATE(922),
    [sym_preproc_warning] = STATE(922),
    [sym_preproc_define] = STATE(922),
    [sym_preproc_undef] = STATE(922),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [923] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4832),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(923),
    [sym_preproc_endregion] = STATE(923),
    [sym_preproc_line] = STATE(923),
    [sym_preproc_pragma] = STATE(923),
    [sym_preproc_nullable] = STATE(923),
    [sym_preproc_error] = STATE(923),
    [sym_preproc_warning] = STATE(923),
    [sym_preproc_define] = STATE(923),
    [sym_preproc_undef] = STATE(923),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [924] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4833),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(924),
    [sym_preproc_endregion] = STATE(924),
    [sym_preproc_line] = STATE(924),
    [sym_preproc_pragma] = STATE(924),
    [sym_preproc_nullable] = STATE(924),
    [sym_preproc_error] = STATE(924),
    [sym_preproc_warning] = STATE(924),
    [sym_preproc_define] = STATE(924),
    [sym_preproc_undef] = STATE(924),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [925] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4835),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(925),
    [sym_preproc_endregion] = STATE(925),
    [sym_preproc_line] = STATE(925),
    [sym_preproc_pragma] = STATE(925),
    [sym_preproc_nullable] = STATE(925),
    [sym_preproc_error] = STATE(925),
    [sym_preproc_warning] = STATE(925),
    [sym_preproc_define] = STATE(925),
    [sym_preproc_undef] = STATE(925),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [926] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4836),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(926),
    [sym_preproc_endregion] = STATE(926),
    [sym_preproc_line] = STATE(926),
    [sym_preproc_pragma] = STATE(926),
    [sym_preproc_nullable] = STATE(926),
    [sym_preproc_error] = STATE(926),
    [sym_preproc_warning] = STATE(926),
    [sym_preproc_define] = STATE(926),
    [sym_preproc_undef] = STATE(926),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [927] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4837),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(927),
    [sym_preproc_endregion] = STATE(927),
    [sym_preproc_line] = STATE(927),
    [sym_preproc_pragma] = STATE(927),
    [sym_preproc_nullable] = STATE(927),
    [sym_preproc_error] = STATE(927),
    [sym_preproc_warning] = STATE(927),
    [sym_preproc_define] = STATE(927),
    [sym_preproc_undef] = STATE(927),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [928] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4953),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(928),
    [sym_preproc_endregion] = STATE(928),
    [sym_preproc_line] = STATE(928),
    [sym_preproc_pragma] = STATE(928),
    [sym_preproc_nullable] = STATE(928),
    [sym_preproc_error] = STATE(928),
    [sym_preproc_warning] = STATE(928),
    [sym_preproc_define] = STATE(928),
    [sym_preproc_undef] = STATE(928),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [929] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4220),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(929),
    [sym_preproc_endregion] = STATE(929),
    [sym_preproc_line] = STATE(929),
    [sym_preproc_pragma] = STATE(929),
    [sym_preproc_nullable] = STATE(929),
    [sym_preproc_error] = STATE(929),
    [sym_preproc_warning] = STATE(929),
    [sym_preproc_define] = STATE(929),
    [sym_preproc_undef] = STATE(929),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [930] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(930),
    [sym_preproc_endregion] = STATE(930),
    [sym_preproc_line] = STATE(930),
    [sym_preproc_pragma] = STATE(930),
    [sym_preproc_nullable] = STATE(930),
    [sym_preproc_error] = STATE(930),
    [sym_preproc_warning] = STATE(930),
    [sym_preproc_define] = STATE(930),
    [sym_preproc_undef] = STATE(930),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [931] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4739),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(931),
    [sym_preproc_endregion] = STATE(931),
    [sym_preproc_line] = STATE(931),
    [sym_preproc_pragma] = STATE(931),
    [sym_preproc_nullable] = STATE(931),
    [sym_preproc_error] = STATE(931),
    [sym_preproc_warning] = STATE(931),
    [sym_preproc_define] = STATE(931),
    [sym_preproc_undef] = STATE(931),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [932] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5544),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(932),
    [sym_preproc_endregion] = STATE(932),
    [sym_preproc_line] = STATE(932),
    [sym_preproc_pragma] = STATE(932),
    [sym_preproc_nullable] = STATE(932),
    [sym_preproc_error] = STATE(932),
    [sym_preproc_warning] = STATE(932),
    [sym_preproc_define] = STATE(932),
    [sym_preproc_undef] = STATE(932),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [933] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5629),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(933),
    [sym_preproc_endregion] = STATE(933),
    [sym_preproc_line] = STATE(933),
    [sym_preproc_pragma] = STATE(933),
    [sym_preproc_nullable] = STATE(933),
    [sym_preproc_error] = STATE(933),
    [sym_preproc_warning] = STATE(933),
    [sym_preproc_define] = STATE(933),
    [sym_preproc_undef] = STATE(933),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [934] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4859),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(934),
    [sym_preproc_endregion] = STATE(934),
    [sym_preproc_line] = STATE(934),
    [sym_preproc_pragma] = STATE(934),
    [sym_preproc_nullable] = STATE(934),
    [sym_preproc_error] = STATE(934),
    [sym_preproc_warning] = STATE(934),
    [sym_preproc_define] = STATE(934),
    [sym_preproc_undef] = STATE(934),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [935] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5375),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(935),
    [sym_preproc_endregion] = STATE(935),
    [sym_preproc_line] = STATE(935),
    [sym_preproc_pragma] = STATE(935),
    [sym_preproc_nullable] = STATE(935),
    [sym_preproc_error] = STATE(935),
    [sym_preproc_warning] = STATE(935),
    [sym_preproc_define] = STATE(935),
    [sym_preproc_undef] = STATE(935),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [936] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4214),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(936),
    [sym_preproc_endregion] = STATE(936),
    [sym_preproc_line] = STATE(936),
    [sym_preproc_pragma] = STATE(936),
    [sym_preproc_nullable] = STATE(936),
    [sym_preproc_error] = STATE(936),
    [sym_preproc_warning] = STATE(936),
    [sym_preproc_define] = STATE(936),
    [sym_preproc_undef] = STATE(936),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [937] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4370),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(937),
    [sym_preproc_endregion] = STATE(937),
    [sym_preproc_line] = STATE(937),
    [sym_preproc_pragma] = STATE(937),
    [sym_preproc_nullable] = STATE(937),
    [sym_preproc_error] = STATE(937),
    [sym_preproc_warning] = STATE(937),
    [sym_preproc_define] = STATE(937),
    [sym_preproc_undef] = STATE(937),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [938] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5738),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3219),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(938),
    [sym_preproc_endregion] = STATE(938),
    [sym_preproc_line] = STATE(938),
    [sym_preproc_pragma] = STATE(938),
    [sym_preproc_nullable] = STATE(938),
    [sym_preproc_error] = STATE(938),
    [sym_preproc_warning] = STATE(938),
    [sym_preproc_define] = STATE(938),
    [sym_preproc_undef] = STATE(938),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [939] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4872),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(939),
    [sym_preproc_endregion] = STATE(939),
    [sym_preproc_line] = STATE(939),
    [sym_preproc_pragma] = STATE(939),
    [sym_preproc_nullable] = STATE(939),
    [sym_preproc_error] = STATE(939),
    [sym_preproc_warning] = STATE(939),
    [sym_preproc_define] = STATE(939),
    [sym_preproc_undef] = STATE(939),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [940] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4873),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(940),
    [sym_preproc_endregion] = STATE(940),
    [sym_preproc_line] = STATE(940),
    [sym_preproc_pragma] = STATE(940),
    [sym_preproc_nullable] = STATE(940),
    [sym_preproc_error] = STATE(940),
    [sym_preproc_warning] = STATE(940),
    [sym_preproc_define] = STATE(940),
    [sym_preproc_undef] = STATE(940),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [941] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4543),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(941),
    [sym_preproc_endregion] = STATE(941),
    [sym_preproc_line] = STATE(941),
    [sym_preproc_pragma] = STATE(941),
    [sym_preproc_nullable] = STATE(941),
    [sym_preproc_error] = STATE(941),
    [sym_preproc_warning] = STATE(941),
    [sym_preproc_define] = STATE(941),
    [sym_preproc_undef] = STATE(941),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [942] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4874),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(942),
    [sym_preproc_endregion] = STATE(942),
    [sym_preproc_line] = STATE(942),
    [sym_preproc_pragma] = STATE(942),
    [sym_preproc_nullable] = STATE(942),
    [sym_preproc_error] = STATE(942),
    [sym_preproc_warning] = STATE(942),
    [sym_preproc_define] = STATE(942),
    [sym_preproc_undef] = STATE(942),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [943] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4875),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(943),
    [sym_preproc_endregion] = STATE(943),
    [sym_preproc_line] = STATE(943),
    [sym_preproc_pragma] = STATE(943),
    [sym_preproc_nullable] = STATE(943),
    [sym_preproc_error] = STATE(943),
    [sym_preproc_warning] = STATE(943),
    [sym_preproc_define] = STATE(943),
    [sym_preproc_undef] = STATE(943),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [944] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4876),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(944),
    [sym_preproc_endregion] = STATE(944),
    [sym_preproc_line] = STATE(944),
    [sym_preproc_pragma] = STATE(944),
    [sym_preproc_nullable] = STATE(944),
    [sym_preproc_error] = STATE(944),
    [sym_preproc_warning] = STATE(944),
    [sym_preproc_define] = STATE(944),
    [sym_preproc_undef] = STATE(944),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [945] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4877),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(945),
    [sym_preproc_endregion] = STATE(945),
    [sym_preproc_line] = STATE(945),
    [sym_preproc_pragma] = STATE(945),
    [sym_preproc_nullable] = STATE(945),
    [sym_preproc_error] = STATE(945),
    [sym_preproc_warning] = STATE(945),
    [sym_preproc_define] = STATE(945),
    [sym_preproc_undef] = STATE(945),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [946] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4878),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(946),
    [sym_preproc_endregion] = STATE(946),
    [sym_preproc_line] = STATE(946),
    [sym_preproc_pragma] = STATE(946),
    [sym_preproc_nullable] = STATE(946),
    [sym_preproc_error] = STATE(946),
    [sym_preproc_warning] = STATE(946),
    [sym_preproc_define] = STATE(946),
    [sym_preproc_undef] = STATE(946),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [947] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4879),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(947),
    [sym_preproc_endregion] = STATE(947),
    [sym_preproc_line] = STATE(947),
    [sym_preproc_pragma] = STATE(947),
    [sym_preproc_nullable] = STATE(947),
    [sym_preproc_error] = STATE(947),
    [sym_preproc_warning] = STATE(947),
    [sym_preproc_define] = STATE(947),
    [sym_preproc_undef] = STATE(947),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [948] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4880),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(948),
    [sym_preproc_endregion] = STATE(948),
    [sym_preproc_line] = STATE(948),
    [sym_preproc_pragma] = STATE(948),
    [sym_preproc_nullable] = STATE(948),
    [sym_preproc_error] = STATE(948),
    [sym_preproc_warning] = STATE(948),
    [sym_preproc_define] = STATE(948),
    [sym_preproc_undef] = STATE(948),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [949] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4881),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(949),
    [sym_preproc_endregion] = STATE(949),
    [sym_preproc_line] = STATE(949),
    [sym_preproc_pragma] = STATE(949),
    [sym_preproc_nullable] = STATE(949),
    [sym_preproc_error] = STATE(949),
    [sym_preproc_warning] = STATE(949),
    [sym_preproc_define] = STATE(949),
    [sym_preproc_undef] = STATE(949),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [950] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(950),
    [sym_preproc_endregion] = STATE(950),
    [sym_preproc_line] = STATE(950),
    [sym_preproc_pragma] = STATE(950),
    [sym_preproc_nullable] = STATE(950),
    [sym_preproc_error] = STATE(950),
    [sym_preproc_warning] = STATE(950),
    [sym_preproc_define] = STATE(950),
    [sym_preproc_undef] = STATE(950),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [951] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(951),
    [sym_preproc_endregion] = STATE(951),
    [sym_preproc_line] = STATE(951),
    [sym_preproc_pragma] = STATE(951),
    [sym_preproc_nullable] = STATE(951),
    [sym_preproc_error] = STATE(951),
    [sym_preproc_warning] = STATE(951),
    [sym_preproc_define] = STATE(951),
    [sym_preproc_undef] = STATE(951),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [952] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4173),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(952),
    [sym_preproc_endregion] = STATE(952),
    [sym_preproc_line] = STATE(952),
    [sym_preproc_pragma] = STATE(952),
    [sym_preproc_nullable] = STATE(952),
    [sym_preproc_error] = STATE(952),
    [sym_preproc_warning] = STATE(952),
    [sym_preproc_define] = STATE(952),
    [sym_preproc_undef] = STATE(952),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [953] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(953),
    [sym_preproc_endregion] = STATE(953),
    [sym_preproc_line] = STATE(953),
    [sym_preproc_pragma] = STATE(953),
    [sym_preproc_nullable] = STATE(953),
    [sym_preproc_error] = STATE(953),
    [sym_preproc_warning] = STATE(953),
    [sym_preproc_define] = STATE(953),
    [sym_preproc_undef] = STATE(953),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [954] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4892),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(954),
    [sym_preproc_endregion] = STATE(954),
    [sym_preproc_line] = STATE(954),
    [sym_preproc_pragma] = STATE(954),
    [sym_preproc_nullable] = STATE(954),
    [sym_preproc_error] = STATE(954),
    [sym_preproc_warning] = STATE(954),
    [sym_preproc_define] = STATE(954),
    [sym_preproc_undef] = STATE(954),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [955] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4231),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(955),
    [sym_preproc_endregion] = STATE(955),
    [sym_preproc_line] = STATE(955),
    [sym_preproc_pragma] = STATE(955),
    [sym_preproc_nullable] = STATE(955),
    [sym_preproc_error] = STATE(955),
    [sym_preproc_warning] = STATE(955),
    [sym_preproc_define] = STATE(955),
    [sym_preproc_undef] = STATE(955),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [956] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4182),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(956),
    [sym_preproc_endregion] = STATE(956),
    [sym_preproc_line] = STATE(956),
    [sym_preproc_pragma] = STATE(956),
    [sym_preproc_nullable] = STATE(956),
    [sym_preproc_error] = STATE(956),
    [sym_preproc_warning] = STATE(956),
    [sym_preproc_define] = STATE(956),
    [sym_preproc_undef] = STATE(956),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [957] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4134),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(957),
    [sym_preproc_endregion] = STATE(957),
    [sym_preproc_line] = STATE(957),
    [sym_preproc_pragma] = STATE(957),
    [sym_preproc_nullable] = STATE(957),
    [sym_preproc_error] = STATE(957),
    [sym_preproc_warning] = STATE(957),
    [sym_preproc_define] = STATE(957),
    [sym_preproc_undef] = STATE(957),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [958] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4745),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(958),
    [sym_preproc_endregion] = STATE(958),
    [sym_preproc_line] = STATE(958),
    [sym_preproc_pragma] = STATE(958),
    [sym_preproc_nullable] = STATE(958),
    [sym_preproc_error] = STATE(958),
    [sym_preproc_warning] = STATE(958),
    [sym_preproc_define] = STATE(958),
    [sym_preproc_undef] = STATE(958),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [959] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4198),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(959),
    [sym_preproc_endregion] = STATE(959),
    [sym_preproc_line] = STATE(959),
    [sym_preproc_pragma] = STATE(959),
    [sym_preproc_nullable] = STATE(959),
    [sym_preproc_error] = STATE(959),
    [sym_preproc_warning] = STATE(959),
    [sym_preproc_define] = STATE(959),
    [sym_preproc_undef] = STATE(959),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [960] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4195),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(960),
    [sym_preproc_endregion] = STATE(960),
    [sym_preproc_line] = STATE(960),
    [sym_preproc_pragma] = STATE(960),
    [sym_preproc_nullable] = STATE(960),
    [sym_preproc_error] = STATE(960),
    [sym_preproc_warning] = STATE(960),
    [sym_preproc_define] = STATE(960),
    [sym_preproc_undef] = STATE(960),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [961] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4199),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(961),
    [sym_preproc_endregion] = STATE(961),
    [sym_preproc_line] = STATE(961),
    [sym_preproc_pragma] = STATE(961),
    [sym_preproc_nullable] = STATE(961),
    [sym_preproc_error] = STATE(961),
    [sym_preproc_warning] = STATE(961),
    [sym_preproc_define] = STATE(961),
    [sym_preproc_undef] = STATE(961),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [962] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4204),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(962),
    [sym_preproc_endregion] = STATE(962),
    [sym_preproc_line] = STATE(962),
    [sym_preproc_pragma] = STATE(962),
    [sym_preproc_nullable] = STATE(962),
    [sym_preproc_error] = STATE(962),
    [sym_preproc_warning] = STATE(962),
    [sym_preproc_define] = STATE(962),
    [sym_preproc_undef] = STATE(962),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [963] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4208),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(963),
    [sym_preproc_endregion] = STATE(963),
    [sym_preproc_line] = STATE(963),
    [sym_preproc_pragma] = STATE(963),
    [sym_preproc_nullable] = STATE(963),
    [sym_preproc_error] = STATE(963),
    [sym_preproc_warning] = STATE(963),
    [sym_preproc_define] = STATE(963),
    [sym_preproc_undef] = STATE(963),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [964] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4218),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(964),
    [sym_preproc_endregion] = STATE(964),
    [sym_preproc_line] = STATE(964),
    [sym_preproc_pragma] = STATE(964),
    [sym_preproc_nullable] = STATE(964),
    [sym_preproc_error] = STATE(964),
    [sym_preproc_warning] = STATE(964),
    [sym_preproc_define] = STATE(964),
    [sym_preproc_undef] = STATE(964),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [965] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4194),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(965),
    [sym_preproc_endregion] = STATE(965),
    [sym_preproc_line] = STATE(965),
    [sym_preproc_pragma] = STATE(965),
    [sym_preproc_nullable] = STATE(965),
    [sym_preproc_error] = STATE(965),
    [sym_preproc_warning] = STATE(965),
    [sym_preproc_define] = STATE(965),
    [sym_preproc_undef] = STATE(965),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [966] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4192),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(966),
    [sym_preproc_endregion] = STATE(966),
    [sym_preproc_line] = STATE(966),
    [sym_preproc_pragma] = STATE(966),
    [sym_preproc_nullable] = STATE(966),
    [sym_preproc_error] = STATE(966),
    [sym_preproc_warning] = STATE(966),
    [sym_preproc_define] = STATE(966),
    [sym_preproc_undef] = STATE(966),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [967] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4180),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(967),
    [sym_preproc_endregion] = STATE(967),
    [sym_preproc_line] = STATE(967),
    [sym_preproc_pragma] = STATE(967),
    [sym_preproc_nullable] = STATE(967),
    [sym_preproc_error] = STATE(967),
    [sym_preproc_warning] = STATE(967),
    [sym_preproc_define] = STATE(967),
    [sym_preproc_undef] = STATE(967),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [968] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4183),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(968),
    [sym_preproc_endregion] = STATE(968),
    [sym_preproc_line] = STATE(968),
    [sym_preproc_pragma] = STATE(968),
    [sym_preproc_nullable] = STATE(968),
    [sym_preproc_error] = STATE(968),
    [sym_preproc_warning] = STATE(968),
    [sym_preproc_define] = STATE(968),
    [sym_preproc_undef] = STATE(968),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [969] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4184),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(969),
    [sym_preproc_endregion] = STATE(969),
    [sym_preproc_line] = STATE(969),
    [sym_preproc_pragma] = STATE(969),
    [sym_preproc_nullable] = STATE(969),
    [sym_preproc_error] = STATE(969),
    [sym_preproc_warning] = STATE(969),
    [sym_preproc_define] = STATE(969),
    [sym_preproc_undef] = STATE(969),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [970] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4187),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(970),
    [sym_preproc_endregion] = STATE(970),
    [sym_preproc_line] = STATE(970),
    [sym_preproc_pragma] = STATE(970),
    [sym_preproc_nullable] = STATE(970),
    [sym_preproc_error] = STATE(970),
    [sym_preproc_warning] = STATE(970),
    [sym_preproc_define] = STATE(970),
    [sym_preproc_undef] = STATE(970),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [971] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(971),
    [sym_preproc_endregion] = STATE(971),
    [sym_preproc_line] = STATE(971),
    [sym_preproc_pragma] = STATE(971),
    [sym_preproc_nullable] = STATE(971),
    [sym_preproc_error] = STATE(971),
    [sym_preproc_warning] = STATE(971),
    [sym_preproc_define] = STATE(971),
    [sym_preproc_undef] = STATE(971),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [972] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4544),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(972),
    [sym_preproc_endregion] = STATE(972),
    [sym_preproc_line] = STATE(972),
    [sym_preproc_pragma] = STATE(972),
    [sym_preproc_nullable] = STATE(972),
    [sym_preproc_error] = STATE(972),
    [sym_preproc_warning] = STATE(972),
    [sym_preproc_define] = STATE(972),
    [sym_preproc_undef] = STATE(972),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [973] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(973),
    [sym_preproc_endregion] = STATE(973),
    [sym_preproc_line] = STATE(973),
    [sym_preproc_pragma] = STATE(973),
    [sym_preproc_nullable] = STATE(973),
    [sym_preproc_error] = STATE(973),
    [sym_preproc_warning] = STATE(973),
    [sym_preproc_define] = STATE(973),
    [sym_preproc_undef] = STATE(973),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [974] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4553),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(974),
    [sym_preproc_endregion] = STATE(974),
    [sym_preproc_line] = STATE(974),
    [sym_preproc_pragma] = STATE(974),
    [sym_preproc_nullable] = STATE(974),
    [sym_preproc_error] = STATE(974),
    [sym_preproc_warning] = STATE(974),
    [sym_preproc_define] = STATE(974),
    [sym_preproc_undef] = STATE(974),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [975] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4555),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(975),
    [sym_preproc_endregion] = STATE(975),
    [sym_preproc_line] = STATE(975),
    [sym_preproc_pragma] = STATE(975),
    [sym_preproc_nullable] = STATE(975),
    [sym_preproc_error] = STATE(975),
    [sym_preproc_warning] = STATE(975),
    [sym_preproc_define] = STATE(975),
    [sym_preproc_undef] = STATE(975),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [976] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4248),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(976),
    [sym_preproc_endregion] = STATE(976),
    [sym_preproc_line] = STATE(976),
    [sym_preproc_pragma] = STATE(976),
    [sym_preproc_nullable] = STATE(976),
    [sym_preproc_error] = STATE(976),
    [sym_preproc_warning] = STATE(976),
    [sym_preproc_define] = STATE(976),
    [sym_preproc_undef] = STATE(976),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [977] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(977),
    [sym_preproc_endregion] = STATE(977),
    [sym_preproc_line] = STATE(977),
    [sym_preproc_pragma] = STATE(977),
    [sym_preproc_nullable] = STATE(977),
    [sym_preproc_error] = STATE(977),
    [sym_preproc_warning] = STATE(977),
    [sym_preproc_define] = STATE(977),
    [sym_preproc_undef] = STATE(977),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [978] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4479),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(978),
    [sym_preproc_endregion] = STATE(978),
    [sym_preproc_line] = STATE(978),
    [sym_preproc_pragma] = STATE(978),
    [sym_preproc_nullable] = STATE(978),
    [sym_preproc_error] = STATE(978),
    [sym_preproc_warning] = STATE(978),
    [sym_preproc_define] = STATE(978),
    [sym_preproc_undef] = STATE(978),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [979] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4480),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(979),
    [sym_preproc_endregion] = STATE(979),
    [sym_preproc_line] = STATE(979),
    [sym_preproc_pragma] = STATE(979),
    [sym_preproc_nullable] = STATE(979),
    [sym_preproc_error] = STATE(979),
    [sym_preproc_warning] = STATE(979),
    [sym_preproc_define] = STATE(979),
    [sym_preproc_undef] = STATE(979),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [980] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4494),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(980),
    [sym_preproc_endregion] = STATE(980),
    [sym_preproc_line] = STATE(980),
    [sym_preproc_pragma] = STATE(980),
    [sym_preproc_nullable] = STATE(980),
    [sym_preproc_error] = STATE(980),
    [sym_preproc_warning] = STATE(980),
    [sym_preproc_define] = STATE(980),
    [sym_preproc_undef] = STATE(980),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [981] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4502),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(981),
    [sym_preproc_endregion] = STATE(981),
    [sym_preproc_line] = STATE(981),
    [sym_preproc_pragma] = STATE(981),
    [sym_preproc_nullable] = STATE(981),
    [sym_preproc_error] = STATE(981),
    [sym_preproc_warning] = STATE(981),
    [sym_preproc_define] = STATE(981),
    [sym_preproc_undef] = STATE(981),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [982] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4513),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(982),
    [sym_preproc_endregion] = STATE(982),
    [sym_preproc_line] = STATE(982),
    [sym_preproc_pragma] = STATE(982),
    [sym_preproc_nullable] = STATE(982),
    [sym_preproc_error] = STATE(982),
    [sym_preproc_warning] = STATE(982),
    [sym_preproc_define] = STATE(982),
    [sym_preproc_undef] = STATE(982),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [983] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4516),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(983),
    [sym_preproc_endregion] = STATE(983),
    [sym_preproc_line] = STATE(983),
    [sym_preproc_pragma] = STATE(983),
    [sym_preproc_nullable] = STATE(983),
    [sym_preproc_error] = STATE(983),
    [sym_preproc_warning] = STATE(983),
    [sym_preproc_define] = STATE(983),
    [sym_preproc_undef] = STATE(983),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [984] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4509),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(984),
    [sym_preproc_endregion] = STATE(984),
    [sym_preproc_line] = STATE(984),
    [sym_preproc_pragma] = STATE(984),
    [sym_preproc_nullable] = STATE(984),
    [sym_preproc_error] = STATE(984),
    [sym_preproc_warning] = STATE(984),
    [sym_preproc_define] = STATE(984),
    [sym_preproc_undef] = STATE(984),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [985] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4528),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(985),
    [sym_preproc_endregion] = STATE(985),
    [sym_preproc_line] = STATE(985),
    [sym_preproc_pragma] = STATE(985),
    [sym_preproc_nullable] = STATE(985),
    [sym_preproc_error] = STATE(985),
    [sym_preproc_warning] = STATE(985),
    [sym_preproc_define] = STATE(985),
    [sym_preproc_undef] = STATE(985),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [986] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4397),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(986),
    [sym_preproc_endregion] = STATE(986),
    [sym_preproc_line] = STATE(986),
    [sym_preproc_pragma] = STATE(986),
    [sym_preproc_nullable] = STATE(986),
    [sym_preproc_error] = STATE(986),
    [sym_preproc_warning] = STATE(986),
    [sym_preproc_define] = STATE(986),
    [sym_preproc_undef] = STATE(986),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [987] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4475),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(987),
    [sym_preproc_endregion] = STATE(987),
    [sym_preproc_line] = STATE(987),
    [sym_preproc_pragma] = STATE(987),
    [sym_preproc_nullable] = STATE(987),
    [sym_preproc_error] = STATE(987),
    [sym_preproc_warning] = STATE(987),
    [sym_preproc_define] = STATE(987),
    [sym_preproc_undef] = STATE(987),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [988] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4392),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(988),
    [sym_preproc_endregion] = STATE(988),
    [sym_preproc_line] = STATE(988),
    [sym_preproc_pragma] = STATE(988),
    [sym_preproc_nullable] = STATE(988),
    [sym_preproc_error] = STATE(988),
    [sym_preproc_warning] = STATE(988),
    [sym_preproc_define] = STATE(988),
    [sym_preproc_undef] = STATE(988),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [989] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4255),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(989),
    [sym_preproc_endregion] = STATE(989),
    [sym_preproc_line] = STATE(989),
    [sym_preproc_pragma] = STATE(989),
    [sym_preproc_nullable] = STATE(989),
    [sym_preproc_error] = STATE(989),
    [sym_preproc_warning] = STATE(989),
    [sym_preproc_define] = STATE(989),
    [sym_preproc_undef] = STATE(989),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [990] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(990),
    [sym_preproc_endregion] = STATE(990),
    [sym_preproc_line] = STATE(990),
    [sym_preproc_pragma] = STATE(990),
    [sym_preproc_nullable] = STATE(990),
    [sym_preproc_error] = STATE(990),
    [sym_preproc_warning] = STATE(990),
    [sym_preproc_define] = STATE(990),
    [sym_preproc_undef] = STATE(990),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [991] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4281),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(991),
    [sym_preproc_endregion] = STATE(991),
    [sym_preproc_line] = STATE(991),
    [sym_preproc_pragma] = STATE(991),
    [sym_preproc_nullable] = STATE(991),
    [sym_preproc_error] = STATE(991),
    [sym_preproc_warning] = STATE(991),
    [sym_preproc_define] = STATE(991),
    [sym_preproc_undef] = STATE(991),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [992] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(992),
    [sym_preproc_endregion] = STATE(992),
    [sym_preproc_line] = STATE(992),
    [sym_preproc_pragma] = STATE(992),
    [sym_preproc_nullable] = STATE(992),
    [sym_preproc_error] = STATE(992),
    [sym_preproc_warning] = STATE(992),
    [sym_preproc_define] = STATE(992),
    [sym_preproc_undef] = STATE(992),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [993] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5718),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2948),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(993),
    [sym_preproc_endregion] = STATE(993),
    [sym_preproc_line] = STATE(993),
    [sym_preproc_pragma] = STATE(993),
    [sym_preproc_nullable] = STATE(993),
    [sym_preproc_error] = STATE(993),
    [sym_preproc_warning] = STATE(993),
    [sym_preproc_define] = STATE(993),
    [sym_preproc_undef] = STATE(993),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [994] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4301),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(994),
    [sym_preproc_endregion] = STATE(994),
    [sym_preproc_line] = STATE(994),
    [sym_preproc_pragma] = STATE(994),
    [sym_preproc_nullable] = STATE(994),
    [sym_preproc_error] = STATE(994),
    [sym_preproc_warning] = STATE(994),
    [sym_preproc_define] = STATE(994),
    [sym_preproc_undef] = STATE(994),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [995] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4338),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(995),
    [sym_preproc_endregion] = STATE(995),
    [sym_preproc_line] = STATE(995),
    [sym_preproc_pragma] = STATE(995),
    [sym_preproc_nullable] = STATE(995),
    [sym_preproc_error] = STATE(995),
    [sym_preproc_warning] = STATE(995),
    [sym_preproc_define] = STATE(995),
    [sym_preproc_undef] = STATE(995),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [996] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(996),
    [sym_preproc_endregion] = STATE(996),
    [sym_preproc_line] = STATE(996),
    [sym_preproc_pragma] = STATE(996),
    [sym_preproc_nullable] = STATE(996),
    [sym_preproc_error] = STATE(996),
    [sym_preproc_warning] = STATE(996),
    [sym_preproc_define] = STATE(996),
    [sym_preproc_undef] = STATE(996),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [997] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4356),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(997),
    [sym_preproc_endregion] = STATE(997),
    [sym_preproc_line] = STATE(997),
    [sym_preproc_pragma] = STATE(997),
    [sym_preproc_nullable] = STATE(997),
    [sym_preproc_error] = STATE(997),
    [sym_preproc_warning] = STATE(997),
    [sym_preproc_define] = STATE(997),
    [sym_preproc_undef] = STATE(997),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [998] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4359),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(998),
    [sym_preproc_endregion] = STATE(998),
    [sym_preproc_line] = STATE(998),
    [sym_preproc_pragma] = STATE(998),
    [sym_preproc_nullable] = STATE(998),
    [sym_preproc_error] = STATE(998),
    [sym_preproc_warning] = STATE(998),
    [sym_preproc_define] = STATE(998),
    [sym_preproc_undef] = STATE(998),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [999] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4996),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(999),
    [sym_preproc_endregion] = STATE(999),
    [sym_preproc_line] = STATE(999),
    [sym_preproc_pragma] = STATE(999),
    [sym_preproc_nullable] = STATE(999),
    [sym_preproc_error] = STATE(999),
    [sym_preproc_warning] = STATE(999),
    [sym_preproc_define] = STATE(999),
    [sym_preproc_undef] = STATE(999),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1000] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1000),
    [sym_preproc_endregion] = STATE(1000),
    [sym_preproc_line] = STATE(1000),
    [sym_preproc_pragma] = STATE(1000),
    [sym_preproc_nullable] = STATE(1000),
    [sym_preproc_error] = STATE(1000),
    [sym_preproc_warning] = STATE(1000),
    [sym_preproc_define] = STATE(1000),
    [sym_preproc_undef] = STATE(1000),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1001] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4315),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1001),
    [sym_preproc_endregion] = STATE(1001),
    [sym_preproc_line] = STATE(1001),
    [sym_preproc_pragma] = STATE(1001),
    [sym_preproc_nullable] = STATE(1001),
    [sym_preproc_error] = STATE(1001),
    [sym_preproc_warning] = STATE(1001),
    [sym_preproc_define] = STATE(1001),
    [sym_preproc_undef] = STATE(1001),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1002] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4328),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1002),
    [sym_preproc_endregion] = STATE(1002),
    [sym_preproc_line] = STATE(1002),
    [sym_preproc_pragma] = STATE(1002),
    [sym_preproc_nullable] = STATE(1002),
    [sym_preproc_error] = STATE(1002),
    [sym_preproc_warning] = STATE(1002),
    [sym_preproc_define] = STATE(1002),
    [sym_preproc_undef] = STATE(1002),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1003] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1003),
    [sym_preproc_endregion] = STATE(1003),
    [sym_preproc_line] = STATE(1003),
    [sym_preproc_pragma] = STATE(1003),
    [sym_preproc_nullable] = STATE(1003),
    [sym_preproc_error] = STATE(1003),
    [sym_preproc_warning] = STATE(1003),
    [sym_preproc_define] = STATE(1003),
    [sym_preproc_undef] = STATE(1003),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1004] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4349),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1004),
    [sym_preproc_endregion] = STATE(1004),
    [sym_preproc_line] = STATE(1004),
    [sym_preproc_pragma] = STATE(1004),
    [sym_preproc_nullable] = STATE(1004),
    [sym_preproc_error] = STATE(1004),
    [sym_preproc_warning] = STATE(1004),
    [sym_preproc_define] = STATE(1004),
    [sym_preproc_undef] = STATE(1004),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1005] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4352),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1005),
    [sym_preproc_endregion] = STATE(1005),
    [sym_preproc_line] = STATE(1005),
    [sym_preproc_pragma] = STATE(1005),
    [sym_preproc_nullable] = STATE(1005),
    [sym_preproc_error] = STATE(1005),
    [sym_preproc_warning] = STATE(1005),
    [sym_preproc_define] = STATE(1005),
    [sym_preproc_undef] = STATE(1005),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1006] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4354),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1006),
    [sym_preproc_endregion] = STATE(1006),
    [sym_preproc_line] = STATE(1006),
    [sym_preproc_pragma] = STATE(1006),
    [sym_preproc_nullable] = STATE(1006),
    [sym_preproc_error] = STATE(1006),
    [sym_preproc_warning] = STATE(1006),
    [sym_preproc_define] = STATE(1006),
    [sym_preproc_undef] = STATE(1006),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1007] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4225),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1007),
    [sym_preproc_endregion] = STATE(1007),
    [sym_preproc_line] = STATE(1007),
    [sym_preproc_pragma] = STATE(1007),
    [sym_preproc_nullable] = STATE(1007),
    [sym_preproc_error] = STATE(1007),
    [sym_preproc_warning] = STATE(1007),
    [sym_preproc_define] = STATE(1007),
    [sym_preproc_undef] = STATE(1007),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1008] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4994),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1008),
    [sym_preproc_endregion] = STATE(1008),
    [sym_preproc_line] = STATE(1008),
    [sym_preproc_pragma] = STATE(1008),
    [sym_preproc_nullable] = STATE(1008),
    [sym_preproc_error] = STATE(1008),
    [sym_preproc_warning] = STATE(1008),
    [sym_preproc_define] = STATE(1008),
    [sym_preproc_undef] = STATE(1008),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1009] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5001),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1009),
    [sym_preproc_endregion] = STATE(1009),
    [sym_preproc_line] = STATE(1009),
    [sym_preproc_pragma] = STATE(1009),
    [sym_preproc_nullable] = STATE(1009),
    [sym_preproc_error] = STATE(1009),
    [sym_preproc_warning] = STATE(1009),
    [sym_preproc_define] = STATE(1009),
    [sym_preproc_undef] = STATE(1009),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1010] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5009),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1010),
    [sym_preproc_endregion] = STATE(1010),
    [sym_preproc_line] = STATE(1010),
    [sym_preproc_pragma] = STATE(1010),
    [sym_preproc_nullable] = STATE(1010),
    [sym_preproc_error] = STATE(1010),
    [sym_preproc_warning] = STATE(1010),
    [sym_preproc_define] = STATE(1010),
    [sym_preproc_undef] = STATE(1010),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1011] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5010),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1011),
    [sym_preproc_endregion] = STATE(1011),
    [sym_preproc_line] = STATE(1011),
    [sym_preproc_pragma] = STATE(1011),
    [sym_preproc_nullable] = STATE(1011),
    [sym_preproc_error] = STATE(1011),
    [sym_preproc_warning] = STATE(1011),
    [sym_preproc_define] = STATE(1011),
    [sym_preproc_undef] = STATE(1011),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1012] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5012),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1012),
    [sym_preproc_endregion] = STATE(1012),
    [sym_preproc_line] = STATE(1012),
    [sym_preproc_pragma] = STATE(1012),
    [sym_preproc_nullable] = STATE(1012),
    [sym_preproc_error] = STATE(1012),
    [sym_preproc_warning] = STATE(1012),
    [sym_preproc_define] = STATE(1012),
    [sym_preproc_undef] = STATE(1012),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1013] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5013),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1013),
    [sym_preproc_endregion] = STATE(1013),
    [sym_preproc_line] = STATE(1013),
    [sym_preproc_pragma] = STATE(1013),
    [sym_preproc_nullable] = STATE(1013),
    [sym_preproc_error] = STATE(1013),
    [sym_preproc_warning] = STATE(1013),
    [sym_preproc_define] = STATE(1013),
    [sym_preproc_undef] = STATE(1013),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1014] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5014),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1014),
    [sym_preproc_endregion] = STATE(1014),
    [sym_preproc_line] = STATE(1014),
    [sym_preproc_pragma] = STATE(1014),
    [sym_preproc_nullable] = STATE(1014),
    [sym_preproc_error] = STATE(1014),
    [sym_preproc_warning] = STATE(1014),
    [sym_preproc_define] = STATE(1014),
    [sym_preproc_undef] = STATE(1014),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1015] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5015),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1015),
    [sym_preproc_endregion] = STATE(1015),
    [sym_preproc_line] = STATE(1015),
    [sym_preproc_pragma] = STATE(1015),
    [sym_preproc_nullable] = STATE(1015),
    [sym_preproc_error] = STATE(1015),
    [sym_preproc_warning] = STATE(1015),
    [sym_preproc_define] = STATE(1015),
    [sym_preproc_undef] = STATE(1015),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1016] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4658),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1016),
    [sym_preproc_endregion] = STATE(1016),
    [sym_preproc_line] = STATE(1016),
    [sym_preproc_pragma] = STATE(1016),
    [sym_preproc_nullable] = STATE(1016),
    [sym_preproc_error] = STATE(1016),
    [sym_preproc_warning] = STATE(1016),
    [sym_preproc_define] = STATE(1016),
    [sym_preproc_undef] = STATE(1016),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1017] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5017),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1017),
    [sym_preproc_endregion] = STATE(1017),
    [sym_preproc_line] = STATE(1017),
    [sym_preproc_pragma] = STATE(1017),
    [sym_preproc_nullable] = STATE(1017),
    [sym_preproc_error] = STATE(1017),
    [sym_preproc_warning] = STATE(1017),
    [sym_preproc_define] = STATE(1017),
    [sym_preproc_undef] = STATE(1017),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1018] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5020),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1018),
    [sym_preproc_endregion] = STATE(1018),
    [sym_preproc_line] = STATE(1018),
    [sym_preproc_pragma] = STATE(1018),
    [sym_preproc_nullable] = STATE(1018),
    [sym_preproc_error] = STATE(1018),
    [sym_preproc_warning] = STATE(1018),
    [sym_preproc_define] = STATE(1018),
    [sym_preproc_undef] = STATE(1018),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1019] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5023),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1019),
    [sym_preproc_endregion] = STATE(1019),
    [sym_preproc_line] = STATE(1019),
    [sym_preproc_pragma] = STATE(1019),
    [sym_preproc_nullable] = STATE(1019),
    [sym_preproc_error] = STATE(1019),
    [sym_preproc_warning] = STATE(1019),
    [sym_preproc_define] = STATE(1019),
    [sym_preproc_undef] = STATE(1019),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1020] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4999),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1020),
    [sym_preproc_endregion] = STATE(1020),
    [sym_preproc_line] = STATE(1020),
    [sym_preproc_pragma] = STATE(1020),
    [sym_preproc_nullable] = STATE(1020),
    [sym_preproc_error] = STATE(1020),
    [sym_preproc_warning] = STATE(1020),
    [sym_preproc_define] = STATE(1020),
    [sym_preproc_undef] = STATE(1020),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1021] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3881),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1021),
    [sym_preproc_endregion] = STATE(1021),
    [sym_preproc_line] = STATE(1021),
    [sym_preproc_pragma] = STATE(1021),
    [sym_preproc_nullable] = STATE(1021),
    [sym_preproc_error] = STATE(1021),
    [sym_preproc_warning] = STATE(1021),
    [sym_preproc_define] = STATE(1021),
    [sym_preproc_undef] = STATE(1021),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1022] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1022),
    [sym_preproc_endregion] = STATE(1022),
    [sym_preproc_line] = STATE(1022),
    [sym_preproc_pragma] = STATE(1022),
    [sym_preproc_nullable] = STATE(1022),
    [sym_preproc_error] = STATE(1022),
    [sym_preproc_warning] = STATE(1022),
    [sym_preproc_define] = STATE(1022),
    [sym_preproc_undef] = STATE(1022),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1023] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1023),
    [sym_preproc_endregion] = STATE(1023),
    [sym_preproc_line] = STATE(1023),
    [sym_preproc_pragma] = STATE(1023),
    [sym_preproc_nullable] = STATE(1023),
    [sym_preproc_error] = STATE(1023),
    [sym_preproc_warning] = STATE(1023),
    [sym_preproc_define] = STATE(1023),
    [sym_preproc_undef] = STATE(1023),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1024] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4765),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1024),
    [sym_preproc_endregion] = STATE(1024),
    [sym_preproc_line] = STATE(1024),
    [sym_preproc_pragma] = STATE(1024),
    [sym_preproc_nullable] = STATE(1024),
    [sym_preproc_error] = STATE(1024),
    [sym_preproc_warning] = STATE(1024),
    [sym_preproc_define] = STATE(1024),
    [sym_preproc_undef] = STATE(1024),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1025] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5031),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1025),
    [sym_preproc_endregion] = STATE(1025),
    [sym_preproc_line] = STATE(1025),
    [sym_preproc_pragma] = STATE(1025),
    [sym_preproc_nullable] = STATE(1025),
    [sym_preproc_error] = STATE(1025),
    [sym_preproc_warning] = STATE(1025),
    [sym_preproc_define] = STATE(1025),
    [sym_preproc_undef] = STATE(1025),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1026] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3886),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1026),
    [sym_preproc_endregion] = STATE(1026),
    [sym_preproc_line] = STATE(1026),
    [sym_preproc_pragma] = STATE(1026),
    [sym_preproc_nullable] = STATE(1026),
    [sym_preproc_error] = STATE(1026),
    [sym_preproc_warning] = STATE(1026),
    [sym_preproc_define] = STATE(1026),
    [sym_preproc_undef] = STATE(1026),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1027] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4151),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1027),
    [sym_preproc_endregion] = STATE(1027),
    [sym_preproc_line] = STATE(1027),
    [sym_preproc_pragma] = STATE(1027),
    [sym_preproc_nullable] = STATE(1027),
    [sym_preproc_error] = STATE(1027),
    [sym_preproc_warning] = STATE(1027),
    [sym_preproc_define] = STATE(1027),
    [sym_preproc_undef] = STATE(1027),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1028] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4305),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1028),
    [sym_preproc_endregion] = STATE(1028),
    [sym_preproc_line] = STATE(1028),
    [sym_preproc_pragma] = STATE(1028),
    [sym_preproc_nullable] = STATE(1028),
    [sym_preproc_error] = STATE(1028),
    [sym_preproc_warning] = STATE(1028),
    [sym_preproc_define] = STATE(1028),
    [sym_preproc_undef] = STATE(1028),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1029] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4322),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1029),
    [sym_preproc_endregion] = STATE(1029),
    [sym_preproc_line] = STATE(1029),
    [sym_preproc_pragma] = STATE(1029),
    [sym_preproc_nullable] = STATE(1029),
    [sym_preproc_error] = STATE(1029),
    [sym_preproc_warning] = STATE(1029),
    [sym_preproc_define] = STATE(1029),
    [sym_preproc_undef] = STATE(1029),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1030] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4310),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1030),
    [sym_preproc_endregion] = STATE(1030),
    [sym_preproc_line] = STATE(1030),
    [sym_preproc_pragma] = STATE(1030),
    [sym_preproc_nullable] = STATE(1030),
    [sym_preproc_error] = STATE(1030),
    [sym_preproc_warning] = STATE(1030),
    [sym_preproc_define] = STATE(1030),
    [sym_preproc_undef] = STATE(1030),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1031] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4325),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1031),
    [sym_preproc_endregion] = STATE(1031),
    [sym_preproc_line] = STATE(1031),
    [sym_preproc_pragma] = STATE(1031),
    [sym_preproc_nullable] = STATE(1031),
    [sym_preproc_error] = STATE(1031),
    [sym_preproc_warning] = STATE(1031),
    [sym_preproc_define] = STATE(1031),
    [sym_preproc_undef] = STATE(1031),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1032] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4339),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1032),
    [sym_preproc_endregion] = STATE(1032),
    [sym_preproc_line] = STATE(1032),
    [sym_preproc_pragma] = STATE(1032),
    [sym_preproc_nullable] = STATE(1032),
    [sym_preproc_error] = STATE(1032),
    [sym_preproc_warning] = STATE(1032),
    [sym_preproc_define] = STATE(1032),
    [sym_preproc_undef] = STATE(1032),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1033] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4345),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1033),
    [sym_preproc_endregion] = STATE(1033),
    [sym_preproc_line] = STATE(1033),
    [sym_preproc_pragma] = STATE(1033),
    [sym_preproc_nullable] = STATE(1033),
    [sym_preproc_error] = STATE(1033),
    [sym_preproc_warning] = STATE(1033),
    [sym_preproc_define] = STATE(1033),
    [sym_preproc_undef] = STATE(1033),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1034] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4371),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1034),
    [sym_preproc_endregion] = STATE(1034),
    [sym_preproc_line] = STATE(1034),
    [sym_preproc_pragma] = STATE(1034),
    [sym_preproc_nullable] = STATE(1034),
    [sym_preproc_error] = STATE(1034),
    [sym_preproc_warning] = STATE(1034),
    [sym_preproc_define] = STATE(1034),
    [sym_preproc_undef] = STATE(1034),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1035] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4307),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1035),
    [sym_preproc_endregion] = STATE(1035),
    [sym_preproc_line] = STATE(1035),
    [sym_preproc_pragma] = STATE(1035),
    [sym_preproc_nullable] = STATE(1035),
    [sym_preproc_error] = STATE(1035),
    [sym_preproc_warning] = STATE(1035),
    [sym_preproc_define] = STATE(1035),
    [sym_preproc_undef] = STATE(1035),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1036] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4308),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1036),
    [sym_preproc_endregion] = STATE(1036),
    [sym_preproc_line] = STATE(1036),
    [sym_preproc_pragma] = STATE(1036),
    [sym_preproc_nullable] = STATE(1036),
    [sym_preproc_error] = STATE(1036),
    [sym_preproc_warning] = STATE(1036),
    [sym_preproc_define] = STATE(1036),
    [sym_preproc_undef] = STATE(1036),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1037] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4313),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1037),
    [sym_preproc_endregion] = STATE(1037),
    [sym_preproc_line] = STATE(1037),
    [sym_preproc_pragma] = STATE(1037),
    [sym_preproc_nullable] = STATE(1037),
    [sym_preproc_error] = STATE(1037),
    [sym_preproc_warning] = STATE(1037),
    [sym_preproc_define] = STATE(1037),
    [sym_preproc_undef] = STATE(1037),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1038] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4317),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1038),
    [sym_preproc_endregion] = STATE(1038),
    [sym_preproc_line] = STATE(1038),
    [sym_preproc_pragma] = STATE(1038),
    [sym_preproc_nullable] = STATE(1038),
    [sym_preproc_error] = STATE(1038),
    [sym_preproc_warning] = STATE(1038),
    [sym_preproc_define] = STATE(1038),
    [sym_preproc_undef] = STATE(1038),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1039] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1039),
    [sym_preproc_endregion] = STATE(1039),
    [sym_preproc_line] = STATE(1039),
    [sym_preproc_pragma] = STATE(1039),
    [sym_preproc_nullable] = STATE(1039),
    [sym_preproc_error] = STATE(1039),
    [sym_preproc_warning] = STATE(1039),
    [sym_preproc_define] = STATE(1039),
    [sym_preproc_undef] = STATE(1039),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1040] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5333),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1040),
    [sym_preproc_endregion] = STATE(1040),
    [sym_preproc_line] = STATE(1040),
    [sym_preproc_pragma] = STATE(1040),
    [sym_preproc_nullable] = STATE(1040),
    [sym_preproc_error] = STATE(1040),
    [sym_preproc_warning] = STATE(1040),
    [sym_preproc_define] = STATE(1040),
    [sym_preproc_undef] = STATE(1040),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1041] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1041),
    [sym_preproc_endregion] = STATE(1041),
    [sym_preproc_line] = STATE(1041),
    [sym_preproc_pragma] = STATE(1041),
    [sym_preproc_nullable] = STATE(1041),
    [sym_preproc_error] = STATE(1041),
    [sym_preproc_warning] = STATE(1041),
    [sym_preproc_define] = STATE(1041),
    [sym_preproc_undef] = STATE(1041),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1042] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5336),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1042),
    [sym_preproc_endregion] = STATE(1042),
    [sym_preproc_line] = STATE(1042),
    [sym_preproc_pragma] = STATE(1042),
    [sym_preproc_nullable] = STATE(1042),
    [sym_preproc_error] = STATE(1042),
    [sym_preproc_warning] = STATE(1042),
    [sym_preproc_define] = STATE(1042),
    [sym_preproc_undef] = STATE(1042),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1043] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4462),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1043),
    [sym_preproc_endregion] = STATE(1043),
    [sym_preproc_line] = STATE(1043),
    [sym_preproc_pragma] = STATE(1043),
    [sym_preproc_nullable] = STATE(1043),
    [sym_preproc_error] = STATE(1043),
    [sym_preproc_warning] = STATE(1043),
    [sym_preproc_define] = STATE(1043),
    [sym_preproc_undef] = STATE(1043),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1044] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5338),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1044),
    [sym_preproc_endregion] = STATE(1044),
    [sym_preproc_line] = STATE(1044),
    [sym_preproc_pragma] = STATE(1044),
    [sym_preproc_nullable] = STATE(1044),
    [sym_preproc_error] = STATE(1044),
    [sym_preproc_warning] = STATE(1044),
    [sym_preproc_define] = STATE(1044),
    [sym_preproc_undef] = STATE(1044),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1045] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5339),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1045),
    [sym_preproc_endregion] = STATE(1045),
    [sym_preproc_line] = STATE(1045),
    [sym_preproc_pragma] = STATE(1045),
    [sym_preproc_nullable] = STATE(1045),
    [sym_preproc_error] = STATE(1045),
    [sym_preproc_warning] = STATE(1045),
    [sym_preproc_define] = STATE(1045),
    [sym_preproc_undef] = STATE(1045),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1046] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5345),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1046),
    [sym_preproc_endregion] = STATE(1046),
    [sym_preproc_line] = STATE(1046),
    [sym_preproc_pragma] = STATE(1046),
    [sym_preproc_nullable] = STATE(1046),
    [sym_preproc_error] = STATE(1046),
    [sym_preproc_warning] = STATE(1046),
    [sym_preproc_define] = STATE(1046),
    [sym_preproc_undef] = STATE(1046),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1047] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5361),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1047),
    [sym_preproc_endregion] = STATE(1047),
    [sym_preproc_line] = STATE(1047),
    [sym_preproc_pragma] = STATE(1047),
    [sym_preproc_nullable] = STATE(1047),
    [sym_preproc_error] = STATE(1047),
    [sym_preproc_warning] = STATE(1047),
    [sym_preproc_define] = STATE(1047),
    [sym_preproc_undef] = STATE(1047),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1048] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5186),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1048),
    [sym_preproc_endregion] = STATE(1048),
    [sym_preproc_line] = STATE(1048),
    [sym_preproc_pragma] = STATE(1048),
    [sym_preproc_nullable] = STATE(1048),
    [sym_preproc_error] = STATE(1048),
    [sym_preproc_warning] = STATE(1048),
    [sym_preproc_define] = STATE(1048),
    [sym_preproc_undef] = STATE(1048),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1049] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5199),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1049),
    [sym_preproc_endregion] = STATE(1049),
    [sym_preproc_line] = STATE(1049),
    [sym_preproc_pragma] = STATE(1049),
    [sym_preproc_nullable] = STATE(1049),
    [sym_preproc_error] = STATE(1049),
    [sym_preproc_warning] = STATE(1049),
    [sym_preproc_define] = STATE(1049),
    [sym_preproc_undef] = STATE(1049),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1050] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5235),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1050),
    [sym_preproc_endregion] = STATE(1050),
    [sym_preproc_line] = STATE(1050),
    [sym_preproc_pragma] = STATE(1050),
    [sym_preproc_nullable] = STATE(1050),
    [sym_preproc_error] = STATE(1050),
    [sym_preproc_warning] = STATE(1050),
    [sym_preproc_define] = STATE(1050),
    [sym_preproc_undef] = STATE(1050),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1051] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5237),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1051),
    [sym_preproc_endregion] = STATE(1051),
    [sym_preproc_line] = STATE(1051),
    [sym_preproc_pragma] = STATE(1051),
    [sym_preproc_nullable] = STATE(1051),
    [sym_preproc_error] = STATE(1051),
    [sym_preproc_warning] = STATE(1051),
    [sym_preproc_define] = STATE(1051),
    [sym_preproc_undef] = STATE(1051),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1052] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5238),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1052),
    [sym_preproc_endregion] = STATE(1052),
    [sym_preproc_line] = STATE(1052),
    [sym_preproc_pragma] = STATE(1052),
    [sym_preproc_nullable] = STATE(1052),
    [sym_preproc_error] = STATE(1052),
    [sym_preproc_warning] = STATE(1052),
    [sym_preproc_define] = STATE(1052),
    [sym_preproc_undef] = STATE(1052),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1053] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5253),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1053),
    [sym_preproc_endregion] = STATE(1053),
    [sym_preproc_line] = STATE(1053),
    [sym_preproc_pragma] = STATE(1053),
    [sym_preproc_nullable] = STATE(1053),
    [sym_preproc_error] = STATE(1053),
    [sym_preproc_warning] = STATE(1053),
    [sym_preproc_define] = STATE(1053),
    [sym_preproc_undef] = STATE(1053),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1054] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5254),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1054),
    [sym_preproc_endregion] = STATE(1054),
    [sym_preproc_line] = STATE(1054),
    [sym_preproc_pragma] = STATE(1054),
    [sym_preproc_nullable] = STATE(1054),
    [sym_preproc_error] = STATE(1054),
    [sym_preproc_warning] = STATE(1054),
    [sym_preproc_define] = STATE(1054),
    [sym_preproc_undef] = STATE(1054),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1055] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5264),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1055),
    [sym_preproc_endregion] = STATE(1055),
    [sym_preproc_line] = STATE(1055),
    [sym_preproc_pragma] = STATE(1055),
    [sym_preproc_nullable] = STATE(1055),
    [sym_preproc_error] = STATE(1055),
    [sym_preproc_warning] = STATE(1055),
    [sym_preproc_define] = STATE(1055),
    [sym_preproc_undef] = STATE(1055),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1056] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1056),
    [sym_preproc_endregion] = STATE(1056),
    [sym_preproc_line] = STATE(1056),
    [sym_preproc_pragma] = STATE(1056),
    [sym_preproc_nullable] = STATE(1056),
    [sym_preproc_error] = STATE(1056),
    [sym_preproc_warning] = STATE(1056),
    [sym_preproc_define] = STATE(1056),
    [sym_preproc_undef] = STATE(1056),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1057] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4314),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1057),
    [sym_preproc_endregion] = STATE(1057),
    [sym_preproc_line] = STATE(1057),
    [sym_preproc_pragma] = STATE(1057),
    [sym_preproc_nullable] = STATE(1057),
    [sym_preproc_error] = STATE(1057),
    [sym_preproc_warning] = STATE(1057),
    [sym_preproc_define] = STATE(1057),
    [sym_preproc_undef] = STATE(1057),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1058] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1058),
    [sym_preproc_endregion] = STATE(1058),
    [sym_preproc_line] = STATE(1058),
    [sym_preproc_pragma] = STATE(1058),
    [sym_preproc_nullable] = STATE(1058),
    [sym_preproc_error] = STATE(1058),
    [sym_preproc_warning] = STATE(1058),
    [sym_preproc_define] = STATE(1058),
    [sym_preproc_undef] = STATE(1058),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1059] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4381),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1059),
    [sym_preproc_endregion] = STATE(1059),
    [sym_preproc_line] = STATE(1059),
    [sym_preproc_pragma] = STATE(1059),
    [sym_preproc_nullable] = STATE(1059),
    [sym_preproc_error] = STATE(1059),
    [sym_preproc_warning] = STATE(1059),
    [sym_preproc_define] = STATE(1059),
    [sym_preproc_undef] = STATE(1059),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1060] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4304),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1060),
    [sym_preproc_endregion] = STATE(1060),
    [sym_preproc_line] = STATE(1060),
    [sym_preproc_pragma] = STATE(1060),
    [sym_preproc_nullable] = STATE(1060),
    [sym_preproc_error] = STATE(1060),
    [sym_preproc_warning] = STATE(1060),
    [sym_preproc_define] = STATE(1060),
    [sym_preproc_undef] = STATE(1060),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1061] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4443),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1061),
    [sym_preproc_endregion] = STATE(1061),
    [sym_preproc_line] = STATE(1061),
    [sym_preproc_pragma] = STATE(1061),
    [sym_preproc_nullable] = STATE(1061),
    [sym_preproc_error] = STATE(1061),
    [sym_preproc_warning] = STATE(1061),
    [sym_preproc_define] = STATE(1061),
    [sym_preproc_undef] = STATE(1061),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1062] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1062),
    [sym_preproc_endregion] = STATE(1062),
    [sym_preproc_line] = STATE(1062),
    [sym_preproc_pragma] = STATE(1062),
    [sym_preproc_nullable] = STATE(1062),
    [sym_preproc_error] = STATE(1062),
    [sym_preproc_warning] = STATE(1062),
    [sym_preproc_define] = STATE(1062),
    [sym_preproc_undef] = STATE(1062),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1063] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4570),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1063),
    [sym_preproc_endregion] = STATE(1063),
    [sym_preproc_line] = STATE(1063),
    [sym_preproc_pragma] = STATE(1063),
    [sym_preproc_nullable] = STATE(1063),
    [sym_preproc_error] = STATE(1063),
    [sym_preproc_warning] = STATE(1063),
    [sym_preproc_define] = STATE(1063),
    [sym_preproc_undef] = STATE(1063),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1064] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4571),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1064),
    [sym_preproc_endregion] = STATE(1064),
    [sym_preproc_line] = STATE(1064),
    [sym_preproc_pragma] = STATE(1064),
    [sym_preproc_nullable] = STATE(1064),
    [sym_preproc_error] = STATE(1064),
    [sym_preproc_warning] = STATE(1064),
    [sym_preproc_define] = STATE(1064),
    [sym_preproc_undef] = STATE(1064),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1065] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4726),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1065),
    [sym_preproc_endregion] = STATE(1065),
    [sym_preproc_line] = STATE(1065),
    [sym_preproc_pragma] = STATE(1065),
    [sym_preproc_nullable] = STATE(1065),
    [sym_preproc_error] = STATE(1065),
    [sym_preproc_warning] = STATE(1065),
    [sym_preproc_define] = STATE(1065),
    [sym_preproc_undef] = STATE(1065),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1066] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4557),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1066),
    [sym_preproc_endregion] = STATE(1066),
    [sym_preproc_line] = STATE(1066),
    [sym_preproc_pragma] = STATE(1066),
    [sym_preproc_nullable] = STATE(1066),
    [sym_preproc_error] = STATE(1066),
    [sym_preproc_warning] = STATE(1066),
    [sym_preproc_define] = STATE(1066),
    [sym_preproc_undef] = STATE(1066),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1067] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4558),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1067),
    [sym_preproc_endregion] = STATE(1067),
    [sym_preproc_line] = STATE(1067),
    [sym_preproc_pragma] = STATE(1067),
    [sym_preproc_nullable] = STATE(1067),
    [sym_preproc_error] = STATE(1067),
    [sym_preproc_warning] = STATE(1067),
    [sym_preproc_define] = STATE(1067),
    [sym_preproc_undef] = STATE(1067),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1068] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4559),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1068),
    [sym_preproc_endregion] = STATE(1068),
    [sym_preproc_line] = STATE(1068),
    [sym_preproc_pragma] = STATE(1068),
    [sym_preproc_nullable] = STATE(1068),
    [sym_preproc_error] = STATE(1068),
    [sym_preproc_warning] = STATE(1068),
    [sym_preproc_define] = STATE(1068),
    [sym_preproc_undef] = STATE(1068),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1069] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4572),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1069),
    [sym_preproc_endregion] = STATE(1069),
    [sym_preproc_line] = STATE(1069),
    [sym_preproc_pragma] = STATE(1069),
    [sym_preproc_nullable] = STATE(1069),
    [sym_preproc_error] = STATE(1069),
    [sym_preproc_warning] = STATE(1069),
    [sym_preproc_define] = STATE(1069),
    [sym_preproc_undef] = STATE(1069),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1070] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4560),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1070),
    [sym_preproc_endregion] = STATE(1070),
    [sym_preproc_line] = STATE(1070),
    [sym_preproc_pragma] = STATE(1070),
    [sym_preproc_nullable] = STATE(1070),
    [sym_preproc_error] = STATE(1070),
    [sym_preproc_warning] = STATE(1070),
    [sym_preproc_define] = STATE(1070),
    [sym_preproc_undef] = STATE(1070),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1071] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4561),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1071),
    [sym_preproc_endregion] = STATE(1071),
    [sym_preproc_line] = STATE(1071),
    [sym_preproc_pragma] = STATE(1071),
    [sym_preproc_nullable] = STATE(1071),
    [sym_preproc_error] = STATE(1071),
    [sym_preproc_warning] = STATE(1071),
    [sym_preproc_define] = STATE(1071),
    [sym_preproc_undef] = STATE(1071),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1072] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4562),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1072),
    [sym_preproc_endregion] = STATE(1072),
    [sym_preproc_line] = STATE(1072),
    [sym_preproc_pragma] = STATE(1072),
    [sym_preproc_nullable] = STATE(1072),
    [sym_preproc_error] = STATE(1072),
    [sym_preproc_warning] = STATE(1072),
    [sym_preproc_define] = STATE(1072),
    [sym_preproc_undef] = STATE(1072),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1073] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4563),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1073),
    [sym_preproc_endregion] = STATE(1073),
    [sym_preproc_line] = STATE(1073),
    [sym_preproc_pragma] = STATE(1073),
    [sym_preproc_nullable] = STATE(1073),
    [sym_preproc_error] = STATE(1073),
    [sym_preproc_warning] = STATE(1073),
    [sym_preproc_define] = STATE(1073),
    [sym_preproc_undef] = STATE(1073),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1074] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4476),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1074),
    [sym_preproc_endregion] = STATE(1074),
    [sym_preproc_line] = STATE(1074),
    [sym_preproc_pragma] = STATE(1074),
    [sym_preproc_nullable] = STATE(1074),
    [sym_preproc_error] = STATE(1074),
    [sym_preproc_warning] = STATE(1074),
    [sym_preproc_define] = STATE(1074),
    [sym_preproc_undef] = STATE(1074),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1075] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1075),
    [sym_preproc_endregion] = STATE(1075),
    [sym_preproc_line] = STATE(1075),
    [sym_preproc_pragma] = STATE(1075),
    [sym_preproc_nullable] = STATE(1075),
    [sym_preproc_error] = STATE(1075),
    [sym_preproc_warning] = STATE(1075),
    [sym_preproc_define] = STATE(1075),
    [sym_preproc_undef] = STATE(1075),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1076] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4464),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1076),
    [sym_preproc_endregion] = STATE(1076),
    [sym_preproc_line] = STATE(1076),
    [sym_preproc_pragma] = STATE(1076),
    [sym_preproc_nullable] = STATE(1076),
    [sym_preproc_error] = STATE(1076),
    [sym_preproc_warning] = STATE(1076),
    [sym_preproc_define] = STATE(1076),
    [sym_preproc_undef] = STATE(1076),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1077] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4277),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1077),
    [sym_preproc_endregion] = STATE(1077),
    [sym_preproc_line] = STATE(1077),
    [sym_preproc_pragma] = STATE(1077),
    [sym_preproc_nullable] = STATE(1077),
    [sym_preproc_error] = STATE(1077),
    [sym_preproc_warning] = STATE(1077),
    [sym_preproc_define] = STATE(1077),
    [sym_preproc_undef] = STATE(1077),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1078] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4116),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1078),
    [sym_preproc_endregion] = STATE(1078),
    [sym_preproc_line] = STATE(1078),
    [sym_preproc_pragma] = STATE(1078),
    [sym_preproc_nullable] = STATE(1078),
    [sym_preproc_error] = STATE(1078),
    [sym_preproc_warning] = STATE(1078),
    [sym_preproc_define] = STATE(1078),
    [sym_preproc_undef] = STATE(1078),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1079] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1079),
    [sym_preproc_endregion] = STATE(1079),
    [sym_preproc_line] = STATE(1079),
    [sym_preproc_pragma] = STATE(1079),
    [sym_preproc_nullable] = STATE(1079),
    [sym_preproc_error] = STATE(1079),
    [sym_preproc_warning] = STATE(1079),
    [sym_preproc_define] = STATE(1079),
    [sym_preproc_undef] = STATE(1079),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1080] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5919),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5560),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1080),
    [sym_preproc_endregion] = STATE(1080),
    [sym_preproc_line] = STATE(1080),
    [sym_preproc_pragma] = STATE(1080),
    [sym_preproc_nullable] = STATE(1080),
    [sym_preproc_error] = STATE(1080),
    [sym_preproc_warning] = STATE(1080),
    [sym_preproc_define] = STATE(1080),
    [sym_preproc_undef] = STATE(1080),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1081] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4714),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1081),
    [sym_preproc_endregion] = STATE(1081),
    [sym_preproc_line] = STATE(1081),
    [sym_preproc_pragma] = STATE(1081),
    [sym_preproc_nullable] = STATE(1081),
    [sym_preproc_error] = STATE(1081),
    [sym_preproc_warning] = STATE(1081),
    [sym_preproc_define] = STATE(1081),
    [sym_preproc_undef] = STATE(1081),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1082] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5613),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1082),
    [sym_preproc_endregion] = STATE(1082),
    [sym_preproc_line] = STATE(1082),
    [sym_preproc_pragma] = STATE(1082),
    [sym_preproc_nullable] = STATE(1082),
    [sym_preproc_error] = STATE(1082),
    [sym_preproc_warning] = STATE(1082),
    [sym_preproc_define] = STATE(1082),
    [sym_preproc_undef] = STATE(1082),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1083] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1083),
    [sym_preproc_endregion] = STATE(1083),
    [sym_preproc_line] = STATE(1083),
    [sym_preproc_pragma] = STATE(1083),
    [sym_preproc_nullable] = STATE(1083),
    [sym_preproc_error] = STATE(1083),
    [sym_preproc_warning] = STATE(1083),
    [sym_preproc_define] = STATE(1083),
    [sym_preproc_undef] = STATE(1083),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1084] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5436),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1084),
    [sym_preproc_endregion] = STATE(1084),
    [sym_preproc_line] = STATE(1084),
    [sym_preproc_pragma] = STATE(1084),
    [sym_preproc_nullable] = STATE(1084),
    [sym_preproc_error] = STATE(1084),
    [sym_preproc_warning] = STATE(1084),
    [sym_preproc_define] = STATE(1084),
    [sym_preproc_undef] = STATE(1084),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1085] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5443),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1085),
    [sym_preproc_endregion] = STATE(1085),
    [sym_preproc_line] = STATE(1085),
    [sym_preproc_pragma] = STATE(1085),
    [sym_preproc_nullable] = STATE(1085),
    [sym_preproc_error] = STATE(1085),
    [sym_preproc_warning] = STATE(1085),
    [sym_preproc_define] = STATE(1085),
    [sym_preproc_undef] = STATE(1085),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1086] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5444),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1086),
    [sym_preproc_endregion] = STATE(1086),
    [sym_preproc_line] = STATE(1086),
    [sym_preproc_pragma] = STATE(1086),
    [sym_preproc_nullable] = STATE(1086),
    [sym_preproc_error] = STATE(1086),
    [sym_preproc_warning] = STATE(1086),
    [sym_preproc_define] = STATE(1086),
    [sym_preproc_undef] = STATE(1086),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1087] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5445),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1087),
    [sym_preproc_endregion] = STATE(1087),
    [sym_preproc_line] = STATE(1087),
    [sym_preproc_pragma] = STATE(1087),
    [sym_preproc_nullable] = STATE(1087),
    [sym_preproc_error] = STATE(1087),
    [sym_preproc_warning] = STATE(1087),
    [sym_preproc_define] = STATE(1087),
    [sym_preproc_undef] = STATE(1087),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1088] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5446),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1088),
    [sym_preproc_endregion] = STATE(1088),
    [sym_preproc_line] = STATE(1088),
    [sym_preproc_pragma] = STATE(1088),
    [sym_preproc_nullable] = STATE(1088),
    [sym_preproc_error] = STATE(1088),
    [sym_preproc_warning] = STATE(1088),
    [sym_preproc_define] = STATE(1088),
    [sym_preproc_undef] = STATE(1088),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1089] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5448),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1089),
    [sym_preproc_endregion] = STATE(1089),
    [sym_preproc_line] = STATE(1089),
    [sym_preproc_pragma] = STATE(1089),
    [sym_preproc_nullable] = STATE(1089),
    [sym_preproc_error] = STATE(1089),
    [sym_preproc_warning] = STATE(1089),
    [sym_preproc_define] = STATE(1089),
    [sym_preproc_undef] = STATE(1089),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1090] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5449),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1090),
    [sym_preproc_endregion] = STATE(1090),
    [sym_preproc_line] = STATE(1090),
    [sym_preproc_pragma] = STATE(1090),
    [sym_preproc_nullable] = STATE(1090),
    [sym_preproc_error] = STATE(1090),
    [sym_preproc_warning] = STATE(1090),
    [sym_preproc_define] = STATE(1090),
    [sym_preproc_undef] = STATE(1090),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1091] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5451),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1091),
    [sym_preproc_endregion] = STATE(1091),
    [sym_preproc_line] = STATE(1091),
    [sym_preproc_pragma] = STATE(1091),
    [sym_preproc_nullable] = STATE(1091),
    [sym_preproc_error] = STATE(1091),
    [sym_preproc_warning] = STATE(1091),
    [sym_preproc_define] = STATE(1091),
    [sym_preproc_undef] = STATE(1091),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1092] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5454),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1092),
    [sym_preproc_endregion] = STATE(1092),
    [sym_preproc_line] = STATE(1092),
    [sym_preproc_pragma] = STATE(1092),
    [sym_preproc_nullable] = STATE(1092),
    [sym_preproc_error] = STATE(1092),
    [sym_preproc_warning] = STATE(1092),
    [sym_preproc_define] = STATE(1092),
    [sym_preproc_undef] = STATE(1092),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1093] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5455),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1093),
    [sym_preproc_endregion] = STATE(1093),
    [sym_preproc_line] = STATE(1093),
    [sym_preproc_pragma] = STATE(1093),
    [sym_preproc_nullable] = STATE(1093),
    [sym_preproc_error] = STATE(1093),
    [sym_preproc_warning] = STATE(1093),
    [sym_preproc_define] = STATE(1093),
    [sym_preproc_undef] = STATE(1093),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1094] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5456),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1094),
    [sym_preproc_endregion] = STATE(1094),
    [sym_preproc_line] = STATE(1094),
    [sym_preproc_pragma] = STATE(1094),
    [sym_preproc_nullable] = STATE(1094),
    [sym_preproc_error] = STATE(1094),
    [sym_preproc_warning] = STATE(1094),
    [sym_preproc_define] = STATE(1094),
    [sym_preproc_undef] = STATE(1094),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1095] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5644),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1095),
    [sym_preproc_endregion] = STATE(1095),
    [sym_preproc_line] = STATE(1095),
    [sym_preproc_pragma] = STATE(1095),
    [sym_preproc_nullable] = STATE(1095),
    [sym_preproc_error] = STATE(1095),
    [sym_preproc_warning] = STATE(1095),
    [sym_preproc_define] = STATE(1095),
    [sym_preproc_undef] = STATE(1095),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1096] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5312),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1096),
    [sym_preproc_endregion] = STATE(1096),
    [sym_preproc_line] = STATE(1096),
    [sym_preproc_pragma] = STATE(1096),
    [sym_preproc_nullable] = STATE(1096),
    [sym_preproc_error] = STATE(1096),
    [sym_preproc_warning] = STATE(1096),
    [sym_preproc_define] = STATE(1096),
    [sym_preproc_undef] = STATE(1096),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1097] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1097),
    [sym_preproc_endregion] = STATE(1097),
    [sym_preproc_line] = STATE(1097),
    [sym_preproc_pragma] = STATE(1097),
    [sym_preproc_nullable] = STATE(1097),
    [sym_preproc_error] = STATE(1097),
    [sym_preproc_warning] = STATE(1097),
    [sym_preproc_define] = STATE(1097),
    [sym_preproc_undef] = STATE(1097),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1098] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5048),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1098),
    [sym_preproc_endregion] = STATE(1098),
    [sym_preproc_line] = STATE(1098),
    [sym_preproc_pragma] = STATE(1098),
    [sym_preproc_nullable] = STATE(1098),
    [sym_preproc_error] = STATE(1098),
    [sym_preproc_warning] = STATE(1098),
    [sym_preproc_define] = STATE(1098),
    [sym_preproc_undef] = STATE(1098),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1099] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4237),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1099),
    [sym_preproc_endregion] = STATE(1099),
    [sym_preproc_line] = STATE(1099),
    [sym_preproc_pragma] = STATE(1099),
    [sym_preproc_nullable] = STATE(1099),
    [sym_preproc_error] = STATE(1099),
    [sym_preproc_warning] = STATE(1099),
    [sym_preproc_define] = STATE(1099),
    [sym_preproc_undef] = STATE(1099),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1100] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5470),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1100),
    [sym_preproc_endregion] = STATE(1100),
    [sym_preproc_line] = STATE(1100),
    [sym_preproc_pragma] = STATE(1100),
    [sym_preproc_nullable] = STATE(1100),
    [sym_preproc_error] = STATE(1100),
    [sym_preproc_warning] = STATE(1100),
    [sym_preproc_define] = STATE(1100),
    [sym_preproc_undef] = STATE(1100),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1101] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4101),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1101),
    [sym_preproc_endregion] = STATE(1101),
    [sym_preproc_line] = STATE(1101),
    [sym_preproc_pragma] = STATE(1101),
    [sym_preproc_nullable] = STATE(1101),
    [sym_preproc_error] = STATE(1101),
    [sym_preproc_warning] = STATE(1101),
    [sym_preproc_define] = STATE(1101),
    [sym_preproc_undef] = STATE(1101),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1102] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5318),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1102),
    [sym_preproc_endregion] = STATE(1102),
    [sym_preproc_line] = STATE(1102),
    [sym_preproc_pragma] = STATE(1102),
    [sym_preproc_nullable] = STATE(1102),
    [sym_preproc_error] = STATE(1102),
    [sym_preproc_warning] = STATE(1102),
    [sym_preproc_define] = STATE(1102),
    [sym_preproc_undef] = STATE(1102),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1103] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3597),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1103),
    [sym_preproc_endregion] = STATE(1103),
    [sym_preproc_line] = STATE(1103),
    [sym_preproc_pragma] = STATE(1103),
    [sym_preproc_nullable] = STATE(1103),
    [sym_preproc_error] = STATE(1103),
    [sym_preproc_warning] = STATE(1103),
    [sym_preproc_define] = STATE(1103),
    [sym_preproc_undef] = STATE(1103),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1104] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4574),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1104),
    [sym_preproc_endregion] = STATE(1104),
    [sym_preproc_line] = STATE(1104),
    [sym_preproc_pragma] = STATE(1104),
    [sym_preproc_nullable] = STATE(1104),
    [sym_preproc_error] = STATE(1104),
    [sym_preproc_warning] = STATE(1104),
    [sym_preproc_define] = STATE(1104),
    [sym_preproc_undef] = STATE(1104),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1105] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4575),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1105),
    [sym_preproc_endregion] = STATE(1105),
    [sym_preproc_line] = STATE(1105),
    [sym_preproc_pragma] = STATE(1105),
    [sym_preproc_nullable] = STATE(1105),
    [sym_preproc_error] = STATE(1105),
    [sym_preproc_warning] = STATE(1105),
    [sym_preproc_define] = STATE(1105),
    [sym_preproc_undef] = STATE(1105),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1106] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4788),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1106),
    [sym_preproc_endregion] = STATE(1106),
    [sym_preproc_line] = STATE(1106),
    [sym_preproc_pragma] = STATE(1106),
    [sym_preproc_nullable] = STATE(1106),
    [sym_preproc_error] = STATE(1106),
    [sym_preproc_warning] = STATE(1106),
    [sym_preproc_define] = STATE(1106),
    [sym_preproc_undef] = STATE(1106),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1107] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4576),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1107),
    [sym_preproc_endregion] = STATE(1107),
    [sym_preproc_line] = STATE(1107),
    [sym_preproc_pragma] = STATE(1107),
    [sym_preproc_nullable] = STATE(1107),
    [sym_preproc_error] = STATE(1107),
    [sym_preproc_warning] = STATE(1107),
    [sym_preproc_define] = STATE(1107),
    [sym_preproc_undef] = STATE(1107),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1108] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4577),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1108),
    [sym_preproc_endregion] = STATE(1108),
    [sym_preproc_line] = STATE(1108),
    [sym_preproc_pragma] = STATE(1108),
    [sym_preproc_nullable] = STATE(1108),
    [sym_preproc_error] = STATE(1108),
    [sym_preproc_warning] = STATE(1108),
    [sym_preproc_define] = STATE(1108),
    [sym_preproc_undef] = STATE(1108),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1109] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4578),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1109),
    [sym_preproc_endregion] = STATE(1109),
    [sym_preproc_line] = STATE(1109),
    [sym_preproc_pragma] = STATE(1109),
    [sym_preproc_nullable] = STATE(1109),
    [sym_preproc_error] = STATE(1109),
    [sym_preproc_warning] = STATE(1109),
    [sym_preproc_define] = STATE(1109),
    [sym_preproc_undef] = STATE(1109),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1110] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4579),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1110),
    [sym_preproc_endregion] = STATE(1110),
    [sym_preproc_line] = STATE(1110),
    [sym_preproc_pragma] = STATE(1110),
    [sym_preproc_nullable] = STATE(1110),
    [sym_preproc_error] = STATE(1110),
    [sym_preproc_warning] = STATE(1110),
    [sym_preproc_define] = STATE(1110),
    [sym_preproc_undef] = STATE(1110),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1111] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4580),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1111),
    [sym_preproc_endregion] = STATE(1111),
    [sym_preproc_line] = STATE(1111),
    [sym_preproc_pragma] = STATE(1111),
    [sym_preproc_nullable] = STATE(1111),
    [sym_preproc_error] = STATE(1111),
    [sym_preproc_warning] = STATE(1111),
    [sym_preproc_define] = STATE(1111),
    [sym_preproc_undef] = STATE(1111),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1112] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4581),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1112),
    [sym_preproc_endregion] = STATE(1112),
    [sym_preproc_line] = STATE(1112),
    [sym_preproc_pragma] = STATE(1112),
    [sym_preproc_nullable] = STATE(1112),
    [sym_preproc_error] = STATE(1112),
    [sym_preproc_warning] = STATE(1112),
    [sym_preproc_define] = STATE(1112),
    [sym_preproc_undef] = STATE(1112),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1113] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4582),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1113),
    [sym_preproc_endregion] = STATE(1113),
    [sym_preproc_line] = STATE(1113),
    [sym_preproc_pragma] = STATE(1113),
    [sym_preproc_nullable] = STATE(1113),
    [sym_preproc_error] = STATE(1113),
    [sym_preproc_warning] = STATE(1113),
    [sym_preproc_define] = STATE(1113),
    [sym_preproc_undef] = STATE(1113),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1114] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4583),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1114),
    [sym_preproc_endregion] = STATE(1114),
    [sym_preproc_line] = STATE(1114),
    [sym_preproc_pragma] = STATE(1114),
    [sym_preproc_nullable] = STATE(1114),
    [sym_preproc_error] = STATE(1114),
    [sym_preproc_warning] = STATE(1114),
    [sym_preproc_define] = STATE(1114),
    [sym_preproc_undef] = STATE(1114),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1115] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1115),
    [sym_preproc_endregion] = STATE(1115),
    [sym_preproc_line] = STATE(1115),
    [sym_preproc_pragma] = STATE(1115),
    [sym_preproc_nullable] = STATE(1115),
    [sym_preproc_error] = STATE(1115),
    [sym_preproc_warning] = STATE(1115),
    [sym_preproc_define] = STATE(1115),
    [sym_preproc_undef] = STATE(1115),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1116] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5240),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1116),
    [sym_preproc_endregion] = STATE(1116),
    [sym_preproc_line] = STATE(1116),
    [sym_preproc_pragma] = STATE(1116),
    [sym_preproc_nullable] = STATE(1116),
    [sym_preproc_error] = STATE(1116),
    [sym_preproc_warning] = STATE(1116),
    [sym_preproc_define] = STATE(1116),
    [sym_preproc_undef] = STATE(1116),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1117] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1117),
    [sym_preproc_endregion] = STATE(1117),
    [sym_preproc_line] = STATE(1117),
    [sym_preproc_pragma] = STATE(1117),
    [sym_preproc_nullable] = STATE(1117),
    [sym_preproc_error] = STATE(1117),
    [sym_preproc_warning] = STATE(1117),
    [sym_preproc_define] = STATE(1117),
    [sym_preproc_undef] = STATE(1117),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1118] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5262),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1118),
    [sym_preproc_endregion] = STATE(1118),
    [sym_preproc_line] = STATE(1118),
    [sym_preproc_pragma] = STATE(1118),
    [sym_preproc_nullable] = STATE(1118),
    [sym_preproc_error] = STATE(1118),
    [sym_preproc_warning] = STATE(1118),
    [sym_preproc_define] = STATE(1118),
    [sym_preproc_undef] = STATE(1118),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1119] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4768),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1119),
    [sym_preproc_endregion] = STATE(1119),
    [sym_preproc_line] = STATE(1119),
    [sym_preproc_pragma] = STATE(1119),
    [sym_preproc_nullable] = STATE(1119),
    [sym_preproc_error] = STATE(1119),
    [sym_preproc_warning] = STATE(1119),
    [sym_preproc_define] = STATE(1119),
    [sym_preproc_undef] = STATE(1119),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1120] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1120),
    [sym_preproc_endregion] = STATE(1120),
    [sym_preproc_line] = STATE(1120),
    [sym_preproc_pragma] = STATE(1120),
    [sym_preproc_nullable] = STATE(1120),
    [sym_preproc_error] = STATE(1120),
    [sym_preproc_warning] = STATE(1120),
    [sym_preproc_define] = STATE(1120),
    [sym_preproc_undef] = STATE(1120),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1121] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5272),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1121),
    [sym_preproc_endregion] = STATE(1121),
    [sym_preproc_line] = STATE(1121),
    [sym_preproc_pragma] = STATE(1121),
    [sym_preproc_nullable] = STATE(1121),
    [sym_preproc_error] = STATE(1121),
    [sym_preproc_warning] = STATE(1121),
    [sym_preproc_define] = STATE(1121),
    [sym_preproc_undef] = STATE(1121),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1122] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5274),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1122),
    [sym_preproc_endregion] = STATE(1122),
    [sym_preproc_line] = STATE(1122),
    [sym_preproc_pragma] = STATE(1122),
    [sym_preproc_nullable] = STATE(1122),
    [sym_preproc_error] = STATE(1122),
    [sym_preproc_warning] = STATE(1122),
    [sym_preproc_define] = STATE(1122),
    [sym_preproc_undef] = STATE(1122),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1123] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5276),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1123),
    [sym_preproc_endregion] = STATE(1123),
    [sym_preproc_line] = STATE(1123),
    [sym_preproc_pragma] = STATE(1123),
    [sym_preproc_nullable] = STATE(1123),
    [sym_preproc_error] = STATE(1123),
    [sym_preproc_warning] = STATE(1123),
    [sym_preproc_define] = STATE(1123),
    [sym_preproc_undef] = STATE(1123),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1124] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5280),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1124),
    [sym_preproc_endregion] = STATE(1124),
    [sym_preproc_line] = STATE(1124),
    [sym_preproc_pragma] = STATE(1124),
    [sym_preproc_nullable] = STATE(1124),
    [sym_preproc_error] = STATE(1124),
    [sym_preproc_warning] = STATE(1124),
    [sym_preproc_define] = STATE(1124),
    [sym_preproc_undef] = STATE(1124),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1125] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1125),
    [sym_preproc_endregion] = STATE(1125),
    [sym_preproc_line] = STATE(1125),
    [sym_preproc_pragma] = STATE(1125),
    [sym_preproc_nullable] = STATE(1125),
    [sym_preproc_error] = STATE(1125),
    [sym_preproc_warning] = STATE(1125),
    [sym_preproc_define] = STATE(1125),
    [sym_preproc_undef] = STATE(1125),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1126] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5290),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1126),
    [sym_preproc_endregion] = STATE(1126),
    [sym_preproc_line] = STATE(1126),
    [sym_preproc_pragma] = STATE(1126),
    [sym_preproc_nullable] = STATE(1126),
    [sym_preproc_error] = STATE(1126),
    [sym_preproc_warning] = STATE(1126),
    [sym_preproc_define] = STATE(1126),
    [sym_preproc_undef] = STATE(1126),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1127] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5298),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1127),
    [sym_preproc_endregion] = STATE(1127),
    [sym_preproc_line] = STATE(1127),
    [sym_preproc_pragma] = STATE(1127),
    [sym_preproc_nullable] = STATE(1127),
    [sym_preproc_error] = STATE(1127),
    [sym_preproc_warning] = STATE(1127),
    [sym_preproc_define] = STATE(1127),
    [sym_preproc_undef] = STATE(1127),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1128] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5303),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1128),
    [sym_preproc_endregion] = STATE(1128),
    [sym_preproc_line] = STATE(1128),
    [sym_preproc_pragma] = STATE(1128),
    [sym_preproc_nullable] = STATE(1128),
    [sym_preproc_error] = STATE(1128),
    [sym_preproc_warning] = STATE(1128),
    [sym_preproc_define] = STATE(1128),
    [sym_preproc_undef] = STATE(1128),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1129] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5307),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1129),
    [sym_preproc_endregion] = STATE(1129),
    [sym_preproc_line] = STATE(1129),
    [sym_preproc_pragma] = STATE(1129),
    [sym_preproc_nullable] = STATE(1129),
    [sym_preproc_error] = STATE(1129),
    [sym_preproc_warning] = STATE(1129),
    [sym_preproc_define] = STATE(1129),
    [sym_preproc_undef] = STATE(1129),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1130] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5328),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1130),
    [sym_preproc_endregion] = STATE(1130),
    [sym_preproc_line] = STATE(1130),
    [sym_preproc_pragma] = STATE(1130),
    [sym_preproc_nullable] = STATE(1130),
    [sym_preproc_error] = STATE(1130),
    [sym_preproc_warning] = STATE(1130),
    [sym_preproc_define] = STATE(1130),
    [sym_preproc_undef] = STATE(1130),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1131] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5331),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1131),
    [sym_preproc_endregion] = STATE(1131),
    [sym_preproc_line] = STATE(1131),
    [sym_preproc_pragma] = STATE(1131),
    [sym_preproc_nullable] = STATE(1131),
    [sym_preproc_error] = STATE(1131),
    [sym_preproc_warning] = STATE(1131),
    [sym_preproc_define] = STATE(1131),
    [sym_preproc_undef] = STATE(1131),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1132] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1132),
    [sym_preproc_endregion] = STATE(1132),
    [sym_preproc_line] = STATE(1132),
    [sym_preproc_pragma] = STATE(1132),
    [sym_preproc_nullable] = STATE(1132),
    [sym_preproc_error] = STATE(1132),
    [sym_preproc_warning] = STATE(1132),
    [sym_preproc_define] = STATE(1132),
    [sym_preproc_undef] = STATE(1132),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1133] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4584),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1133),
    [sym_preproc_endregion] = STATE(1133),
    [sym_preproc_line] = STATE(1133),
    [sym_preproc_pragma] = STATE(1133),
    [sym_preproc_nullable] = STATE(1133),
    [sym_preproc_error] = STATE(1133),
    [sym_preproc_warning] = STATE(1133),
    [sym_preproc_define] = STATE(1133),
    [sym_preproc_undef] = STATE(1133),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1134] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1134),
    [sym_preproc_endregion] = STATE(1134),
    [sym_preproc_line] = STATE(1134),
    [sym_preproc_pragma] = STATE(1134),
    [sym_preproc_nullable] = STATE(1134),
    [sym_preproc_error] = STATE(1134),
    [sym_preproc_warning] = STATE(1134),
    [sym_preproc_define] = STATE(1134),
    [sym_preproc_undef] = STATE(1134),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1135] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4294),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1135),
    [sym_preproc_endregion] = STATE(1135),
    [sym_preproc_line] = STATE(1135),
    [sym_preproc_pragma] = STATE(1135),
    [sym_preproc_nullable] = STATE(1135),
    [sym_preproc_error] = STATE(1135),
    [sym_preproc_warning] = STATE(1135),
    [sym_preproc_define] = STATE(1135),
    [sym_preproc_undef] = STATE(1135),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1136] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4275),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1136),
    [sym_preproc_endregion] = STATE(1136),
    [sym_preproc_line] = STATE(1136),
    [sym_preproc_pragma] = STATE(1136),
    [sym_preproc_nullable] = STATE(1136),
    [sym_preproc_error] = STATE(1136),
    [sym_preproc_warning] = STATE(1136),
    [sym_preproc_define] = STATE(1136),
    [sym_preproc_undef] = STATE(1136),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1137] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4276),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1137),
    [sym_preproc_endregion] = STATE(1137),
    [sym_preproc_line] = STATE(1137),
    [sym_preproc_pragma] = STATE(1137),
    [sym_preproc_nullable] = STATE(1137),
    [sym_preproc_error] = STATE(1137),
    [sym_preproc_warning] = STATE(1137),
    [sym_preproc_define] = STATE(1137),
    [sym_preproc_undef] = STATE(1137),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1138] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4288),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1138),
    [sym_preproc_endregion] = STATE(1138),
    [sym_preproc_line] = STATE(1138),
    [sym_preproc_pragma] = STATE(1138),
    [sym_preproc_nullable] = STATE(1138),
    [sym_preproc_error] = STATE(1138),
    [sym_preproc_warning] = STATE(1138),
    [sym_preproc_define] = STATE(1138),
    [sym_preproc_undef] = STATE(1138),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1139] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4588),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1139),
    [sym_preproc_endregion] = STATE(1139),
    [sym_preproc_line] = STATE(1139),
    [sym_preproc_pragma] = STATE(1139),
    [sym_preproc_nullable] = STATE(1139),
    [sym_preproc_error] = STATE(1139),
    [sym_preproc_warning] = STATE(1139),
    [sym_preproc_define] = STATE(1139),
    [sym_preproc_undef] = STATE(1139),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1140] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4295),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1140),
    [sym_preproc_endregion] = STATE(1140),
    [sym_preproc_line] = STATE(1140),
    [sym_preproc_pragma] = STATE(1140),
    [sym_preproc_nullable] = STATE(1140),
    [sym_preproc_error] = STATE(1140),
    [sym_preproc_warning] = STATE(1140),
    [sym_preproc_define] = STATE(1140),
    [sym_preproc_undef] = STATE(1140),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1141] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4729),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1141),
    [sym_preproc_endregion] = STATE(1141),
    [sym_preproc_line] = STATE(1141),
    [sym_preproc_pragma] = STATE(1141),
    [sym_preproc_nullable] = STATE(1141),
    [sym_preproc_error] = STATE(1141),
    [sym_preproc_warning] = STATE(1141),
    [sym_preproc_define] = STATE(1141),
    [sym_preproc_undef] = STATE(1141),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1142] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1142),
    [sym_preproc_endregion] = STATE(1142),
    [sym_preproc_line] = STATE(1142),
    [sym_preproc_pragma] = STATE(1142),
    [sym_preproc_nullable] = STATE(1142),
    [sym_preproc_error] = STATE(1142),
    [sym_preproc_warning] = STATE(1142),
    [sym_preproc_define] = STATE(1142),
    [sym_preproc_undef] = STATE(1142),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1143] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4529),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1143),
    [sym_preproc_endregion] = STATE(1143),
    [sym_preproc_line] = STATE(1143),
    [sym_preproc_pragma] = STATE(1143),
    [sym_preproc_nullable] = STATE(1143),
    [sym_preproc_error] = STATE(1143),
    [sym_preproc_warning] = STATE(1143),
    [sym_preproc_define] = STATE(1143),
    [sym_preproc_undef] = STATE(1143),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1144] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4532),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1144),
    [sym_preproc_endregion] = STATE(1144),
    [sym_preproc_line] = STATE(1144),
    [sym_preproc_pragma] = STATE(1144),
    [sym_preproc_nullable] = STATE(1144),
    [sym_preproc_error] = STATE(1144),
    [sym_preproc_warning] = STATE(1144),
    [sym_preproc_define] = STATE(1144),
    [sym_preproc_undef] = STATE(1144),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1145] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4446),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1145),
    [sym_preproc_endregion] = STATE(1145),
    [sym_preproc_line] = STATE(1145),
    [sym_preproc_pragma] = STATE(1145),
    [sym_preproc_nullable] = STATE(1145),
    [sym_preproc_error] = STATE(1145),
    [sym_preproc_warning] = STATE(1145),
    [sym_preproc_define] = STATE(1145),
    [sym_preproc_undef] = STATE(1145),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1146] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4423),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1146),
    [sym_preproc_endregion] = STATE(1146),
    [sym_preproc_line] = STATE(1146),
    [sym_preproc_pragma] = STATE(1146),
    [sym_preproc_nullable] = STATE(1146),
    [sym_preproc_error] = STATE(1146),
    [sym_preproc_warning] = STATE(1146),
    [sym_preproc_define] = STATE(1146),
    [sym_preproc_undef] = STATE(1146),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1147] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4424),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1147),
    [sym_preproc_endregion] = STATE(1147),
    [sym_preproc_line] = STATE(1147),
    [sym_preproc_pragma] = STATE(1147),
    [sym_preproc_nullable] = STATE(1147),
    [sym_preproc_error] = STATE(1147),
    [sym_preproc_warning] = STATE(1147),
    [sym_preproc_define] = STATE(1147),
    [sym_preproc_undef] = STATE(1147),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1148] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4425),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1148),
    [sym_preproc_endregion] = STATE(1148),
    [sym_preproc_line] = STATE(1148),
    [sym_preproc_pragma] = STATE(1148),
    [sym_preproc_nullable] = STATE(1148),
    [sym_preproc_error] = STATE(1148),
    [sym_preproc_warning] = STATE(1148),
    [sym_preproc_define] = STATE(1148),
    [sym_preproc_undef] = STATE(1148),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1149] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4535),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1149),
    [sym_preproc_endregion] = STATE(1149),
    [sym_preproc_line] = STATE(1149),
    [sym_preproc_pragma] = STATE(1149),
    [sym_preproc_nullable] = STATE(1149),
    [sym_preproc_error] = STATE(1149),
    [sym_preproc_warning] = STATE(1149),
    [sym_preproc_define] = STATE(1149),
    [sym_preproc_undef] = STATE(1149),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1150] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4426),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1150),
    [sym_preproc_endregion] = STATE(1150),
    [sym_preproc_line] = STATE(1150),
    [sym_preproc_pragma] = STATE(1150),
    [sym_preproc_nullable] = STATE(1150),
    [sym_preproc_error] = STATE(1150),
    [sym_preproc_warning] = STATE(1150),
    [sym_preproc_define] = STATE(1150),
    [sym_preproc_undef] = STATE(1150),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1151] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4292),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1151),
    [sym_preproc_endregion] = STATE(1151),
    [sym_preproc_line] = STATE(1151),
    [sym_preproc_pragma] = STATE(1151),
    [sym_preproc_nullable] = STATE(1151),
    [sym_preproc_error] = STATE(1151),
    [sym_preproc_warning] = STATE(1151),
    [sym_preproc_define] = STATE(1151),
    [sym_preproc_undef] = STATE(1151),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1152] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4428),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1152),
    [sym_preproc_endregion] = STATE(1152),
    [sym_preproc_line] = STATE(1152),
    [sym_preproc_pragma] = STATE(1152),
    [sym_preproc_nullable] = STATE(1152),
    [sym_preproc_error] = STATE(1152),
    [sym_preproc_warning] = STATE(1152),
    [sym_preproc_define] = STATE(1152),
    [sym_preproc_undef] = STATE(1152),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1153] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4430),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1153),
    [sym_preproc_endregion] = STATE(1153),
    [sym_preproc_line] = STATE(1153),
    [sym_preproc_pragma] = STATE(1153),
    [sym_preproc_nullable] = STATE(1153),
    [sym_preproc_error] = STATE(1153),
    [sym_preproc_warning] = STATE(1153),
    [sym_preproc_define] = STATE(1153),
    [sym_preproc_undef] = STATE(1153),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1154] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4432),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1154),
    [sym_preproc_endregion] = STATE(1154),
    [sym_preproc_line] = STATE(1154),
    [sym_preproc_pragma] = STATE(1154),
    [sym_preproc_nullable] = STATE(1154),
    [sym_preproc_error] = STATE(1154),
    [sym_preproc_warning] = STATE(1154),
    [sym_preproc_define] = STATE(1154),
    [sym_preproc_undef] = STATE(1154),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1155] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4730),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1155),
    [sym_preproc_endregion] = STATE(1155),
    [sym_preproc_line] = STATE(1155),
    [sym_preproc_pragma] = STATE(1155),
    [sym_preproc_nullable] = STATE(1155),
    [sym_preproc_error] = STATE(1155),
    [sym_preproc_warning] = STATE(1155),
    [sym_preproc_define] = STATE(1155),
    [sym_preproc_undef] = STATE(1155),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1156] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4261),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1156),
    [sym_preproc_endregion] = STATE(1156),
    [sym_preproc_line] = STATE(1156),
    [sym_preproc_pragma] = STATE(1156),
    [sym_preproc_nullable] = STATE(1156),
    [sym_preproc_error] = STATE(1156),
    [sym_preproc_warning] = STATE(1156),
    [sym_preproc_define] = STATE(1156),
    [sym_preproc_undef] = STATE(1156),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1157] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1157),
    [sym_preproc_endregion] = STATE(1157),
    [sym_preproc_line] = STATE(1157),
    [sym_preproc_pragma] = STATE(1157),
    [sym_preproc_nullable] = STATE(1157),
    [sym_preproc_error] = STATE(1157),
    [sym_preproc_warning] = STATE(1157),
    [sym_preproc_define] = STATE(1157),
    [sym_preproc_undef] = STATE(1157),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1158] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4284),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1158),
    [sym_preproc_endregion] = STATE(1158),
    [sym_preproc_line] = STATE(1158),
    [sym_preproc_pragma] = STATE(1158),
    [sym_preproc_nullable] = STATE(1158),
    [sym_preproc_error] = STATE(1158),
    [sym_preproc_warning] = STATE(1158),
    [sym_preproc_define] = STATE(1158),
    [sym_preproc_undef] = STATE(1158),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1159] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4732),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1159),
    [sym_preproc_endregion] = STATE(1159),
    [sym_preproc_line] = STATE(1159),
    [sym_preproc_pragma] = STATE(1159),
    [sym_preproc_nullable] = STATE(1159),
    [sym_preproc_error] = STATE(1159),
    [sym_preproc_warning] = STATE(1159),
    [sym_preproc_define] = STATE(1159),
    [sym_preproc_undef] = STATE(1159),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1160] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4290),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1160),
    [sym_preproc_endregion] = STATE(1160),
    [sym_preproc_line] = STATE(1160),
    [sym_preproc_pragma] = STATE(1160),
    [sym_preproc_nullable] = STATE(1160),
    [sym_preproc_error] = STATE(1160),
    [sym_preproc_warning] = STATE(1160),
    [sym_preproc_define] = STATE(1160),
    [sym_preproc_undef] = STATE(1160),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1161] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4260),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1161),
    [sym_preproc_endregion] = STATE(1161),
    [sym_preproc_line] = STATE(1161),
    [sym_preproc_pragma] = STATE(1161),
    [sym_preproc_nullable] = STATE(1161),
    [sym_preproc_error] = STATE(1161),
    [sym_preproc_warning] = STATE(1161),
    [sym_preproc_define] = STATE(1161),
    [sym_preproc_undef] = STATE(1161),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1162] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4226),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1162),
    [sym_preproc_endregion] = STATE(1162),
    [sym_preproc_line] = STATE(1162),
    [sym_preproc_pragma] = STATE(1162),
    [sym_preproc_nullable] = STATE(1162),
    [sym_preproc_error] = STATE(1162),
    [sym_preproc_warning] = STATE(1162),
    [sym_preproc_define] = STATE(1162),
    [sym_preproc_undef] = STATE(1162),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1163] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3630),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1163),
    [sym_preproc_endregion] = STATE(1163),
    [sym_preproc_line] = STATE(1163),
    [sym_preproc_pragma] = STATE(1163),
    [sym_preproc_nullable] = STATE(1163),
    [sym_preproc_error] = STATE(1163),
    [sym_preproc_warning] = STATE(1163),
    [sym_preproc_define] = STATE(1163),
    [sym_preproc_undef] = STATE(1163),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1164] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1164),
    [sym_preproc_endregion] = STATE(1164),
    [sym_preproc_line] = STATE(1164),
    [sym_preproc_pragma] = STATE(1164),
    [sym_preproc_nullable] = STATE(1164),
    [sym_preproc_error] = STATE(1164),
    [sym_preproc_warning] = STATE(1164),
    [sym_preproc_define] = STATE(1164),
    [sym_preproc_undef] = STATE(1164),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1165] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3978),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1165),
    [sym_preproc_endregion] = STATE(1165),
    [sym_preproc_line] = STATE(1165),
    [sym_preproc_pragma] = STATE(1165),
    [sym_preproc_nullable] = STATE(1165),
    [sym_preproc_error] = STATE(1165),
    [sym_preproc_warning] = STATE(1165),
    [sym_preproc_define] = STATE(1165),
    [sym_preproc_undef] = STATE(1165),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1166] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5626),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1166),
    [sym_preproc_endregion] = STATE(1166),
    [sym_preproc_line] = STATE(1166),
    [sym_preproc_pragma] = STATE(1166),
    [sym_preproc_nullable] = STATE(1166),
    [sym_preproc_error] = STATE(1166),
    [sym_preproc_warning] = STATE(1166),
    [sym_preproc_define] = STATE(1166),
    [sym_preproc_undef] = STATE(1166),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1167] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1167),
    [sym_preproc_endregion] = STATE(1167),
    [sym_preproc_line] = STATE(1167),
    [sym_preproc_pragma] = STATE(1167),
    [sym_preproc_nullable] = STATE(1167),
    [sym_preproc_error] = STATE(1167),
    [sym_preproc_warning] = STATE(1167),
    [sym_preproc_define] = STATE(1167),
    [sym_preproc_undef] = STATE(1167),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1168] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4136),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1168),
    [sym_preproc_endregion] = STATE(1168),
    [sym_preproc_line] = STATE(1168),
    [sym_preproc_pragma] = STATE(1168),
    [sym_preproc_nullable] = STATE(1168),
    [sym_preproc_error] = STATE(1168),
    [sym_preproc_warning] = STATE(1168),
    [sym_preproc_define] = STATE(1168),
    [sym_preproc_undef] = STATE(1168),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1169] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5634),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1169),
    [sym_preproc_endregion] = STATE(1169),
    [sym_preproc_line] = STATE(1169),
    [sym_preproc_pragma] = STATE(1169),
    [sym_preproc_nullable] = STATE(1169),
    [sym_preproc_error] = STATE(1169),
    [sym_preproc_warning] = STATE(1169),
    [sym_preproc_define] = STATE(1169),
    [sym_preproc_undef] = STATE(1169),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1170] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5636),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1170),
    [sym_preproc_endregion] = STATE(1170),
    [sym_preproc_line] = STATE(1170),
    [sym_preproc_pragma] = STATE(1170),
    [sym_preproc_nullable] = STATE(1170),
    [sym_preproc_error] = STATE(1170),
    [sym_preproc_warning] = STATE(1170),
    [sym_preproc_define] = STATE(1170),
    [sym_preproc_undef] = STATE(1170),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1171] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5637),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1171),
    [sym_preproc_endregion] = STATE(1171),
    [sym_preproc_line] = STATE(1171),
    [sym_preproc_pragma] = STATE(1171),
    [sym_preproc_nullable] = STATE(1171),
    [sym_preproc_error] = STATE(1171),
    [sym_preproc_warning] = STATE(1171),
    [sym_preproc_define] = STATE(1171),
    [sym_preproc_undef] = STATE(1171),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1172] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5638),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1172),
    [sym_preproc_endregion] = STATE(1172),
    [sym_preproc_line] = STATE(1172),
    [sym_preproc_pragma] = STATE(1172),
    [sym_preproc_nullable] = STATE(1172),
    [sym_preproc_error] = STATE(1172),
    [sym_preproc_warning] = STATE(1172),
    [sym_preproc_define] = STATE(1172),
    [sym_preproc_undef] = STATE(1172),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1173] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5639),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1173),
    [sym_preproc_endregion] = STATE(1173),
    [sym_preproc_line] = STATE(1173),
    [sym_preproc_pragma] = STATE(1173),
    [sym_preproc_nullable] = STATE(1173),
    [sym_preproc_error] = STATE(1173),
    [sym_preproc_warning] = STATE(1173),
    [sym_preproc_define] = STATE(1173),
    [sym_preproc_undef] = STATE(1173),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1174] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5640),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1174),
    [sym_preproc_endregion] = STATE(1174),
    [sym_preproc_line] = STATE(1174),
    [sym_preproc_pragma] = STATE(1174),
    [sym_preproc_nullable] = STATE(1174),
    [sym_preproc_error] = STATE(1174),
    [sym_preproc_warning] = STATE(1174),
    [sym_preproc_define] = STATE(1174),
    [sym_preproc_undef] = STATE(1174),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1175] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5641),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1175),
    [sym_preproc_endregion] = STATE(1175),
    [sym_preproc_line] = STATE(1175),
    [sym_preproc_pragma] = STATE(1175),
    [sym_preproc_nullable] = STATE(1175),
    [sym_preproc_error] = STATE(1175),
    [sym_preproc_warning] = STATE(1175),
    [sym_preproc_define] = STATE(1175),
    [sym_preproc_undef] = STATE(1175),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1176] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5642),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1176),
    [sym_preproc_endregion] = STATE(1176),
    [sym_preproc_line] = STATE(1176),
    [sym_preproc_pragma] = STATE(1176),
    [sym_preproc_nullable] = STATE(1176),
    [sym_preproc_error] = STATE(1176),
    [sym_preproc_warning] = STATE(1176),
    [sym_preproc_define] = STATE(1176),
    [sym_preproc_undef] = STATE(1176),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1177] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3704),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1177),
    [sym_preproc_endregion] = STATE(1177),
    [sym_preproc_line] = STATE(1177),
    [sym_preproc_pragma] = STATE(1177),
    [sym_preproc_nullable] = STATE(1177),
    [sym_preproc_error] = STATE(1177),
    [sym_preproc_warning] = STATE(1177),
    [sym_preproc_define] = STATE(1177),
    [sym_preproc_undef] = STATE(1177),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1178] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5679),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1178),
    [sym_preproc_endregion] = STATE(1178),
    [sym_preproc_line] = STATE(1178),
    [sym_preproc_pragma] = STATE(1178),
    [sym_preproc_nullable] = STATE(1178),
    [sym_preproc_error] = STATE(1178),
    [sym_preproc_warning] = STATE(1178),
    [sym_preproc_define] = STATE(1178),
    [sym_preproc_undef] = STATE(1178),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1179] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5680),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1179),
    [sym_preproc_endregion] = STATE(1179),
    [sym_preproc_line] = STATE(1179),
    [sym_preproc_pragma] = STATE(1179),
    [sym_preproc_nullable] = STATE(1179),
    [sym_preproc_error] = STATE(1179),
    [sym_preproc_warning] = STATE(1179),
    [sym_preproc_define] = STATE(1179),
    [sym_preproc_undef] = STATE(1179),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1180] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5685),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1180),
    [sym_preproc_endregion] = STATE(1180),
    [sym_preproc_line] = STATE(1180),
    [sym_preproc_pragma] = STATE(1180),
    [sym_preproc_nullable] = STATE(1180),
    [sym_preproc_error] = STATE(1180),
    [sym_preproc_warning] = STATE(1180),
    [sym_preproc_define] = STATE(1180),
    [sym_preproc_undef] = STATE(1180),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1181] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5461),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1181),
    [sym_preproc_endregion] = STATE(1181),
    [sym_preproc_line] = STATE(1181),
    [sym_preproc_pragma] = STATE(1181),
    [sym_preproc_nullable] = STATE(1181),
    [sym_preproc_error] = STATE(1181),
    [sym_preproc_warning] = STATE(1181),
    [sym_preproc_define] = STATE(1181),
    [sym_preproc_undef] = STATE(1181),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1182] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3923),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1182),
    [sym_preproc_endregion] = STATE(1182),
    [sym_preproc_line] = STATE(1182),
    [sym_preproc_pragma] = STATE(1182),
    [sym_preproc_nullable] = STATE(1182),
    [sym_preproc_error] = STATE(1182),
    [sym_preproc_warning] = STATE(1182),
    [sym_preproc_define] = STATE(1182),
    [sym_preproc_undef] = STATE(1182),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1183] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5202),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1183),
    [sym_preproc_endregion] = STATE(1183),
    [sym_preproc_line] = STATE(1183),
    [sym_preproc_pragma] = STATE(1183),
    [sym_preproc_nullable] = STATE(1183),
    [sym_preproc_error] = STATE(1183),
    [sym_preproc_warning] = STATE(1183),
    [sym_preproc_define] = STATE(1183),
    [sym_preproc_undef] = STATE(1183),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1184] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1184),
    [sym_preproc_endregion] = STATE(1184),
    [sym_preproc_line] = STATE(1184),
    [sym_preproc_pragma] = STATE(1184),
    [sym_preproc_nullable] = STATE(1184),
    [sym_preproc_error] = STATE(1184),
    [sym_preproc_warning] = STATE(1184),
    [sym_preproc_define] = STATE(1184),
    [sym_preproc_undef] = STATE(1184),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1185] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5259),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1185),
    [sym_preproc_endregion] = STATE(1185),
    [sym_preproc_line] = STATE(1185),
    [sym_preproc_pragma] = STATE(1185),
    [sym_preproc_nullable] = STATE(1185),
    [sym_preproc_error] = STATE(1185),
    [sym_preproc_warning] = STATE(1185),
    [sym_preproc_define] = STATE(1185),
    [sym_preproc_undef] = STATE(1185),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1186] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5056),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1186),
    [sym_preproc_endregion] = STATE(1186),
    [sym_preproc_line] = STATE(1186),
    [sym_preproc_pragma] = STATE(1186),
    [sym_preproc_nullable] = STATE(1186),
    [sym_preproc_error] = STATE(1186),
    [sym_preproc_warning] = STATE(1186),
    [sym_preproc_define] = STATE(1186),
    [sym_preproc_undef] = STATE(1186),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1187] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5469),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1187),
    [sym_preproc_endregion] = STATE(1187),
    [sym_preproc_line] = STATE(1187),
    [sym_preproc_pragma] = STATE(1187),
    [sym_preproc_nullable] = STATE(1187),
    [sym_preproc_error] = STATE(1187),
    [sym_preproc_warning] = STATE(1187),
    [sym_preproc_define] = STATE(1187),
    [sym_preproc_undef] = STATE(1187),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1188] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5694),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1188),
    [sym_preproc_endregion] = STATE(1188),
    [sym_preproc_line] = STATE(1188),
    [sym_preproc_pragma] = STATE(1188),
    [sym_preproc_nullable] = STATE(1188),
    [sym_preproc_error] = STATE(1188),
    [sym_preproc_warning] = STATE(1188),
    [sym_preproc_define] = STATE(1188),
    [sym_preproc_undef] = STATE(1188),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1189] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3991),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1189),
    [sym_preproc_endregion] = STATE(1189),
    [sym_preproc_line] = STATE(1189),
    [sym_preproc_pragma] = STATE(1189),
    [sym_preproc_nullable] = STATE(1189),
    [sym_preproc_error] = STATE(1189),
    [sym_preproc_warning] = STATE(1189),
    [sym_preproc_define] = STATE(1189),
    [sym_preproc_undef] = STATE(1189),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1190] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3765),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1190),
    [sym_preproc_endregion] = STATE(1190),
    [sym_preproc_line] = STATE(1190),
    [sym_preproc_pragma] = STATE(1190),
    [sym_preproc_nullable] = STATE(1190),
    [sym_preproc_error] = STATE(1190),
    [sym_preproc_warning] = STATE(1190),
    [sym_preproc_define] = STATE(1190),
    [sym_preproc_undef] = STATE(1190),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1191] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4982),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1191),
    [sym_preproc_endregion] = STATE(1191),
    [sym_preproc_line] = STATE(1191),
    [sym_preproc_pragma] = STATE(1191),
    [sym_preproc_nullable] = STATE(1191),
    [sym_preproc_error] = STATE(1191),
    [sym_preproc_warning] = STATE(1191),
    [sym_preproc_define] = STATE(1191),
    [sym_preproc_undef] = STATE(1191),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1192] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4984),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1192),
    [sym_preproc_endregion] = STATE(1192),
    [sym_preproc_line] = STATE(1192),
    [sym_preproc_pragma] = STATE(1192),
    [sym_preproc_nullable] = STATE(1192),
    [sym_preproc_error] = STATE(1192),
    [sym_preproc_warning] = STATE(1192),
    [sym_preproc_define] = STATE(1192),
    [sym_preproc_undef] = STATE(1192),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1193] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5050),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1193),
    [sym_preproc_endregion] = STATE(1193),
    [sym_preproc_line] = STATE(1193),
    [sym_preproc_pragma] = STATE(1193),
    [sym_preproc_nullable] = STATE(1193),
    [sym_preproc_error] = STATE(1193),
    [sym_preproc_warning] = STATE(1193),
    [sym_preproc_define] = STATE(1193),
    [sym_preproc_undef] = STATE(1193),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1194] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4985),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1194),
    [sym_preproc_endregion] = STATE(1194),
    [sym_preproc_line] = STATE(1194),
    [sym_preproc_pragma] = STATE(1194),
    [sym_preproc_nullable] = STATE(1194),
    [sym_preproc_error] = STATE(1194),
    [sym_preproc_warning] = STATE(1194),
    [sym_preproc_define] = STATE(1194),
    [sym_preproc_undef] = STATE(1194),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1195] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4986),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1195),
    [sym_preproc_endregion] = STATE(1195),
    [sym_preproc_line] = STATE(1195),
    [sym_preproc_pragma] = STATE(1195),
    [sym_preproc_nullable] = STATE(1195),
    [sym_preproc_error] = STATE(1195),
    [sym_preproc_warning] = STATE(1195),
    [sym_preproc_define] = STATE(1195),
    [sym_preproc_undef] = STATE(1195),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1196] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4987),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1196),
    [sym_preproc_endregion] = STATE(1196),
    [sym_preproc_line] = STATE(1196),
    [sym_preproc_pragma] = STATE(1196),
    [sym_preproc_nullable] = STATE(1196),
    [sym_preproc_error] = STATE(1196),
    [sym_preproc_warning] = STATE(1196),
    [sym_preproc_define] = STATE(1196),
    [sym_preproc_undef] = STATE(1196),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1197] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4988),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1197),
    [sym_preproc_endregion] = STATE(1197),
    [sym_preproc_line] = STATE(1197),
    [sym_preproc_pragma] = STATE(1197),
    [sym_preproc_nullable] = STATE(1197),
    [sym_preproc_error] = STATE(1197),
    [sym_preproc_warning] = STATE(1197),
    [sym_preproc_define] = STATE(1197),
    [sym_preproc_undef] = STATE(1197),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1198] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4989),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1198),
    [sym_preproc_endregion] = STATE(1198),
    [sym_preproc_line] = STATE(1198),
    [sym_preproc_pragma] = STATE(1198),
    [sym_preproc_nullable] = STATE(1198),
    [sym_preproc_error] = STATE(1198),
    [sym_preproc_warning] = STATE(1198),
    [sym_preproc_define] = STATE(1198),
    [sym_preproc_undef] = STATE(1198),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1199] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4990),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1199),
    [sym_preproc_endregion] = STATE(1199),
    [sym_preproc_line] = STATE(1199),
    [sym_preproc_pragma] = STATE(1199),
    [sym_preproc_nullable] = STATE(1199),
    [sym_preproc_error] = STATE(1199),
    [sym_preproc_warning] = STATE(1199),
    [sym_preproc_define] = STATE(1199),
    [sym_preproc_undef] = STATE(1199),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1200] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4991),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1200),
    [sym_preproc_endregion] = STATE(1200),
    [sym_preproc_line] = STATE(1200),
    [sym_preproc_pragma] = STATE(1200),
    [sym_preproc_nullable] = STATE(1200),
    [sym_preproc_error] = STATE(1200),
    [sym_preproc_warning] = STATE(1200),
    [sym_preproc_define] = STATE(1200),
    [sym_preproc_undef] = STATE(1200),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1201] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4992),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1201),
    [sym_preproc_endregion] = STATE(1201),
    [sym_preproc_line] = STATE(1201),
    [sym_preproc_pragma] = STATE(1201),
    [sym_preproc_nullable] = STATE(1201),
    [sym_preproc_error] = STATE(1201),
    [sym_preproc_warning] = STATE(1201),
    [sym_preproc_define] = STATE(1201),
    [sym_preproc_undef] = STATE(1201),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1202] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1202),
    [sym_preproc_endregion] = STATE(1202),
    [sym_preproc_line] = STATE(1202),
    [sym_preproc_pragma] = STATE(1202),
    [sym_preproc_nullable] = STATE(1202),
    [sym_preproc_error] = STATE(1202),
    [sym_preproc_warning] = STATE(1202),
    [sym_preproc_define] = STATE(1202),
    [sym_preproc_undef] = STATE(1202),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1203] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4342),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1203),
    [sym_preproc_endregion] = STATE(1203),
    [sym_preproc_line] = STATE(1203),
    [sym_preproc_pragma] = STATE(1203),
    [sym_preproc_nullable] = STATE(1203),
    [sym_preproc_error] = STATE(1203),
    [sym_preproc_warning] = STATE(1203),
    [sym_preproc_define] = STATE(1203),
    [sym_preproc_undef] = STATE(1203),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1204] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5192),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1204),
    [sym_preproc_endregion] = STATE(1204),
    [sym_preproc_line] = STATE(1204),
    [sym_preproc_pragma] = STATE(1204),
    [sym_preproc_nullable] = STATE(1204),
    [sym_preproc_error] = STATE(1204),
    [sym_preproc_warning] = STATE(1204),
    [sym_preproc_define] = STATE(1204),
    [sym_preproc_undef] = STATE(1204),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1205] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1205),
    [sym_preproc_endregion] = STATE(1205),
    [sym_preproc_line] = STATE(1205),
    [sym_preproc_pragma] = STATE(1205),
    [sym_preproc_nullable] = STATE(1205),
    [sym_preproc_error] = STATE(1205),
    [sym_preproc_warning] = STATE(1205),
    [sym_preproc_define] = STATE(1205),
    [sym_preproc_undef] = STATE(1205),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1206] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5195),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1206),
    [sym_preproc_endregion] = STATE(1206),
    [sym_preproc_line] = STATE(1206),
    [sym_preproc_pragma] = STATE(1206),
    [sym_preproc_nullable] = STATE(1206),
    [sym_preproc_error] = STATE(1206),
    [sym_preproc_warning] = STATE(1206),
    [sym_preproc_define] = STATE(1206),
    [sym_preproc_undef] = STATE(1206),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1207] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4791),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1207),
    [sym_preproc_endregion] = STATE(1207),
    [sym_preproc_line] = STATE(1207),
    [sym_preproc_pragma] = STATE(1207),
    [sym_preproc_nullable] = STATE(1207),
    [sym_preproc_error] = STATE(1207),
    [sym_preproc_warning] = STATE(1207),
    [sym_preproc_define] = STATE(1207),
    [sym_preproc_undef] = STATE(1207),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1208] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5200),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1208),
    [sym_preproc_endregion] = STATE(1208),
    [sym_preproc_line] = STATE(1208),
    [sym_preproc_pragma] = STATE(1208),
    [sym_preproc_nullable] = STATE(1208),
    [sym_preproc_error] = STATE(1208),
    [sym_preproc_warning] = STATE(1208),
    [sym_preproc_define] = STATE(1208),
    [sym_preproc_undef] = STATE(1208),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1209] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5204),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1209),
    [sym_preproc_endregion] = STATE(1209),
    [sym_preproc_line] = STATE(1209),
    [sym_preproc_pragma] = STATE(1209),
    [sym_preproc_nullable] = STATE(1209),
    [sym_preproc_error] = STATE(1209),
    [sym_preproc_warning] = STATE(1209),
    [sym_preproc_define] = STATE(1209),
    [sym_preproc_undef] = STATE(1209),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1210] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5205),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1210),
    [sym_preproc_endregion] = STATE(1210),
    [sym_preproc_line] = STATE(1210),
    [sym_preproc_pragma] = STATE(1210),
    [sym_preproc_nullable] = STATE(1210),
    [sym_preproc_error] = STATE(1210),
    [sym_preproc_warning] = STATE(1210),
    [sym_preproc_define] = STATE(1210),
    [sym_preproc_undef] = STATE(1210),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1211] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5207),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1211),
    [sym_preproc_endregion] = STATE(1211),
    [sym_preproc_line] = STATE(1211),
    [sym_preproc_pragma] = STATE(1211),
    [sym_preproc_nullable] = STATE(1211),
    [sym_preproc_error] = STATE(1211),
    [sym_preproc_warning] = STATE(1211),
    [sym_preproc_define] = STATE(1211),
    [sym_preproc_undef] = STATE(1211),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1212] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5208),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1212),
    [sym_preproc_endregion] = STATE(1212),
    [sym_preproc_line] = STATE(1212),
    [sym_preproc_pragma] = STATE(1212),
    [sym_preproc_nullable] = STATE(1212),
    [sym_preproc_error] = STATE(1212),
    [sym_preproc_warning] = STATE(1212),
    [sym_preproc_define] = STATE(1212),
    [sym_preproc_undef] = STATE(1212),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1213] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5209),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1213),
    [sym_preproc_endregion] = STATE(1213),
    [sym_preproc_line] = STATE(1213),
    [sym_preproc_pragma] = STATE(1213),
    [sym_preproc_nullable] = STATE(1213),
    [sym_preproc_error] = STATE(1213),
    [sym_preproc_warning] = STATE(1213),
    [sym_preproc_define] = STATE(1213),
    [sym_preproc_undef] = STATE(1213),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1214] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5211),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1214),
    [sym_preproc_endregion] = STATE(1214),
    [sym_preproc_line] = STATE(1214),
    [sym_preproc_pragma] = STATE(1214),
    [sym_preproc_nullable] = STATE(1214),
    [sym_preproc_error] = STATE(1214),
    [sym_preproc_warning] = STATE(1214),
    [sym_preproc_define] = STATE(1214),
    [sym_preproc_undef] = STATE(1214),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1215] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5224),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1215),
    [sym_preproc_endregion] = STATE(1215),
    [sym_preproc_line] = STATE(1215),
    [sym_preproc_pragma] = STATE(1215),
    [sym_preproc_nullable] = STATE(1215),
    [sym_preproc_error] = STATE(1215),
    [sym_preproc_warning] = STATE(1215),
    [sym_preproc_define] = STATE(1215),
    [sym_preproc_undef] = STATE(1215),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1216] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5225),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1216),
    [sym_preproc_endregion] = STATE(1216),
    [sym_preproc_line] = STATE(1216),
    [sym_preproc_pragma] = STATE(1216),
    [sym_preproc_nullable] = STATE(1216),
    [sym_preproc_error] = STATE(1216),
    [sym_preproc_warning] = STATE(1216),
    [sym_preproc_define] = STATE(1216),
    [sym_preproc_undef] = STATE(1216),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1217] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5226),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1217),
    [sym_preproc_endregion] = STATE(1217),
    [sym_preproc_line] = STATE(1217),
    [sym_preproc_pragma] = STATE(1217),
    [sym_preproc_nullable] = STATE(1217),
    [sym_preproc_error] = STATE(1217),
    [sym_preproc_warning] = STATE(1217),
    [sym_preproc_define] = STATE(1217),
    [sym_preproc_undef] = STATE(1217),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1218] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5252),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1218),
    [sym_preproc_endregion] = STATE(1218),
    [sym_preproc_line] = STATE(1218),
    [sym_preproc_pragma] = STATE(1218),
    [sym_preproc_nullable] = STATE(1218),
    [sym_preproc_error] = STATE(1218),
    [sym_preproc_warning] = STATE(1218),
    [sym_preproc_define] = STATE(1218),
    [sym_preproc_undef] = STATE(1218),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1219] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5257),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1219),
    [sym_preproc_endregion] = STATE(1219),
    [sym_preproc_line] = STATE(1219),
    [sym_preproc_pragma] = STATE(1219),
    [sym_preproc_nullable] = STATE(1219),
    [sym_preproc_error] = STATE(1219),
    [sym_preproc_warning] = STATE(1219),
    [sym_preproc_define] = STATE(1219),
    [sym_preproc_undef] = STATE(1219),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1220] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1220),
    [sym_preproc_endregion] = STATE(1220),
    [sym_preproc_line] = STATE(1220),
    [sym_preproc_pragma] = STATE(1220),
    [sym_preproc_nullable] = STATE(1220),
    [sym_preproc_error] = STATE(1220),
    [sym_preproc_warning] = STATE(1220),
    [sym_preproc_define] = STATE(1220),
    [sym_preproc_undef] = STATE(1220),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1221] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5003),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1221),
    [sym_preproc_endregion] = STATE(1221),
    [sym_preproc_line] = STATE(1221),
    [sym_preproc_pragma] = STATE(1221),
    [sym_preproc_nullable] = STATE(1221),
    [sym_preproc_error] = STATE(1221),
    [sym_preproc_warning] = STATE(1221),
    [sym_preproc_define] = STATE(1221),
    [sym_preproc_undef] = STATE(1221),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1222] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1222),
    [sym_preproc_endregion] = STATE(1222),
    [sym_preproc_line] = STATE(1222),
    [sym_preproc_pragma] = STATE(1222),
    [sym_preproc_nullable] = STATE(1222),
    [sym_preproc_error] = STATE(1222),
    [sym_preproc_warning] = STATE(1222),
    [sym_preproc_define] = STATE(1222),
    [sym_preproc_undef] = STATE(1222),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1223] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5471),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1223),
    [sym_preproc_endregion] = STATE(1223),
    [sym_preproc_line] = STATE(1223),
    [sym_preproc_pragma] = STATE(1223),
    [sym_preproc_nullable] = STATE(1223),
    [sym_preproc_error] = STATE(1223),
    [sym_preproc_warning] = STATE(1223),
    [sym_preproc_define] = STATE(1223),
    [sym_preproc_undef] = STATE(1223),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1224] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5005),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1224),
    [sym_preproc_endregion] = STATE(1224),
    [sym_preproc_line] = STATE(1224),
    [sym_preproc_pragma] = STATE(1224),
    [sym_preproc_nullable] = STATE(1224),
    [sym_preproc_error] = STATE(1224),
    [sym_preproc_warning] = STATE(1224),
    [sym_preproc_define] = STATE(1224),
    [sym_preproc_undef] = STATE(1224),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1225] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5007),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1225),
    [sym_preproc_endregion] = STATE(1225),
    [sym_preproc_line] = STATE(1225),
    [sym_preproc_pragma] = STATE(1225),
    [sym_preproc_nullable] = STATE(1225),
    [sym_preproc_error] = STATE(1225),
    [sym_preproc_warning] = STATE(1225),
    [sym_preproc_define] = STATE(1225),
    [sym_preproc_undef] = STATE(1225),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1226] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4166),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1226),
    [sym_preproc_endregion] = STATE(1226),
    [sym_preproc_line] = STATE(1226),
    [sym_preproc_pragma] = STATE(1226),
    [sym_preproc_nullable] = STATE(1226),
    [sym_preproc_error] = STATE(1226),
    [sym_preproc_warning] = STATE(1226),
    [sym_preproc_define] = STATE(1226),
    [sym_preproc_undef] = STATE(1226),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1227] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4747),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1227),
    [sym_preproc_endregion] = STATE(1227),
    [sym_preproc_line] = STATE(1227),
    [sym_preproc_pragma] = STATE(1227),
    [sym_preproc_nullable] = STATE(1227),
    [sym_preproc_error] = STATE(1227),
    [sym_preproc_warning] = STATE(1227),
    [sym_preproc_define] = STATE(1227),
    [sym_preproc_undef] = STATE(1227),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1228] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1228),
    [sym_preproc_endregion] = STATE(1228),
    [sym_preproc_line] = STATE(1228),
    [sym_preproc_pragma] = STATE(1228),
    [sym_preproc_nullable] = STATE(1228),
    [sym_preproc_error] = STATE(1228),
    [sym_preproc_warning] = STATE(1228),
    [sym_preproc_define] = STATE(1228),
    [sym_preproc_undef] = STATE(1228),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1229] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4600),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1229),
    [sym_preproc_endregion] = STATE(1229),
    [sym_preproc_line] = STATE(1229),
    [sym_preproc_pragma] = STATE(1229),
    [sym_preproc_nullable] = STATE(1229),
    [sym_preproc_error] = STATE(1229),
    [sym_preproc_warning] = STATE(1229),
    [sym_preproc_define] = STATE(1229),
    [sym_preproc_undef] = STATE(1229),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1230] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4601),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1230),
    [sym_preproc_endregion] = STATE(1230),
    [sym_preproc_line] = STATE(1230),
    [sym_preproc_pragma] = STATE(1230),
    [sym_preproc_nullable] = STATE(1230),
    [sym_preproc_error] = STATE(1230),
    [sym_preproc_warning] = STATE(1230),
    [sym_preproc_define] = STATE(1230),
    [sym_preproc_undef] = STATE(1230),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1231] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4770),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1231),
    [sym_preproc_endregion] = STATE(1231),
    [sym_preproc_line] = STATE(1231),
    [sym_preproc_pragma] = STATE(1231),
    [sym_preproc_nullable] = STATE(1231),
    [sym_preproc_error] = STATE(1231),
    [sym_preproc_warning] = STATE(1231),
    [sym_preproc_define] = STATE(1231),
    [sym_preproc_undef] = STATE(1231),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1232] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4748),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1232),
    [sym_preproc_endregion] = STATE(1232),
    [sym_preproc_line] = STATE(1232),
    [sym_preproc_pragma] = STATE(1232),
    [sym_preproc_nullable] = STATE(1232),
    [sym_preproc_error] = STATE(1232),
    [sym_preproc_warning] = STATE(1232),
    [sym_preproc_define] = STATE(1232),
    [sym_preproc_undef] = STATE(1232),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1233] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4749),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1233),
    [sym_preproc_endregion] = STATE(1233),
    [sym_preproc_line] = STATE(1233),
    [sym_preproc_pragma] = STATE(1233),
    [sym_preproc_nullable] = STATE(1233),
    [sym_preproc_error] = STATE(1233),
    [sym_preproc_warning] = STATE(1233),
    [sym_preproc_define] = STATE(1233),
    [sym_preproc_undef] = STATE(1233),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1234] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4750),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1234),
    [sym_preproc_endregion] = STATE(1234),
    [sym_preproc_line] = STATE(1234),
    [sym_preproc_pragma] = STATE(1234),
    [sym_preproc_nullable] = STATE(1234),
    [sym_preproc_error] = STATE(1234),
    [sym_preproc_warning] = STATE(1234),
    [sym_preproc_define] = STATE(1234),
    [sym_preproc_undef] = STATE(1234),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1235] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4602),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1235),
    [sym_preproc_endregion] = STATE(1235),
    [sym_preproc_line] = STATE(1235),
    [sym_preproc_pragma] = STATE(1235),
    [sym_preproc_nullable] = STATE(1235),
    [sym_preproc_error] = STATE(1235),
    [sym_preproc_warning] = STATE(1235),
    [sym_preproc_define] = STATE(1235),
    [sym_preproc_undef] = STATE(1235),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1236] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4751),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1236),
    [sym_preproc_endregion] = STATE(1236),
    [sym_preproc_line] = STATE(1236),
    [sym_preproc_pragma] = STATE(1236),
    [sym_preproc_nullable] = STATE(1236),
    [sym_preproc_error] = STATE(1236),
    [sym_preproc_warning] = STATE(1236),
    [sym_preproc_define] = STATE(1236),
    [sym_preproc_undef] = STATE(1236),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1237] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1237),
    [sym_preproc_endregion] = STATE(1237),
    [sym_preproc_line] = STATE(1237),
    [sym_preproc_pragma] = STATE(1237),
    [sym_preproc_nullable] = STATE(1237),
    [sym_preproc_error] = STATE(1237),
    [sym_preproc_warning] = STATE(1237),
    [sym_preproc_define] = STATE(1237),
    [sym_preproc_undef] = STATE(1237),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1238] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4752),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1238),
    [sym_preproc_endregion] = STATE(1238),
    [sym_preproc_line] = STATE(1238),
    [sym_preproc_pragma] = STATE(1238),
    [sym_preproc_nullable] = STATE(1238),
    [sym_preproc_error] = STATE(1238),
    [sym_preproc_warning] = STATE(1238),
    [sym_preproc_define] = STATE(1238),
    [sym_preproc_undef] = STATE(1238),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1239] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4753),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1239),
    [sym_preproc_endregion] = STATE(1239),
    [sym_preproc_line] = STATE(1239),
    [sym_preproc_pragma] = STATE(1239),
    [sym_preproc_nullable] = STATE(1239),
    [sym_preproc_error] = STATE(1239),
    [sym_preproc_warning] = STATE(1239),
    [sym_preproc_define] = STATE(1239),
    [sym_preproc_undef] = STATE(1239),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1240] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4754),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1240),
    [sym_preproc_endregion] = STATE(1240),
    [sym_preproc_line] = STATE(1240),
    [sym_preproc_pragma] = STATE(1240),
    [sym_preproc_nullable] = STATE(1240),
    [sym_preproc_error] = STATE(1240),
    [sym_preproc_warning] = STATE(1240),
    [sym_preproc_define] = STATE(1240),
    [sym_preproc_undef] = STATE(1240),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1241] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4755),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1241),
    [sym_preproc_endregion] = STATE(1241),
    [sym_preproc_line] = STATE(1241),
    [sym_preproc_pragma] = STATE(1241),
    [sym_preproc_nullable] = STATE(1241),
    [sym_preproc_error] = STATE(1241),
    [sym_preproc_warning] = STATE(1241),
    [sym_preproc_define] = STATE(1241),
    [sym_preproc_undef] = STATE(1241),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1242] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1242),
    [sym_preproc_endregion] = STATE(1242),
    [sym_preproc_line] = STATE(1242),
    [sym_preproc_pragma] = STATE(1242),
    [sym_preproc_nullable] = STATE(1242),
    [sym_preproc_error] = STATE(1242),
    [sym_preproc_warning] = STATE(1242),
    [sym_preproc_define] = STATE(1242),
    [sym_preproc_undef] = STATE(1242),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1243] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4757),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1243),
    [sym_preproc_endregion] = STATE(1243),
    [sym_preproc_line] = STATE(1243),
    [sym_preproc_pragma] = STATE(1243),
    [sym_preproc_nullable] = STATE(1243),
    [sym_preproc_error] = STATE(1243),
    [sym_preproc_warning] = STATE(1243),
    [sym_preproc_define] = STATE(1243),
    [sym_preproc_undef] = STATE(1243),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1244] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1244),
    [sym_preproc_endregion] = STATE(1244),
    [sym_preproc_line] = STATE(1244),
    [sym_preproc_pragma] = STATE(1244),
    [sym_preproc_nullable] = STATE(1244),
    [sym_preproc_error] = STATE(1244),
    [sym_preproc_warning] = STATE(1244),
    [sym_preproc_define] = STATE(1244),
    [sym_preproc_undef] = STATE(1244),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1245] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1245),
    [sym_preproc_endregion] = STATE(1245),
    [sym_preproc_line] = STATE(1245),
    [sym_preproc_pragma] = STATE(1245),
    [sym_preproc_nullable] = STATE(1245),
    [sym_preproc_error] = STATE(1245),
    [sym_preproc_warning] = STATE(1245),
    [sym_preproc_define] = STATE(1245),
    [sym_preproc_undef] = STATE(1245),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1246] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4727),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1246),
    [sym_preproc_endregion] = STATE(1246),
    [sym_preproc_line] = STATE(1246),
    [sym_preproc_pragma] = STATE(1246),
    [sym_preproc_nullable] = STATE(1246),
    [sym_preproc_error] = STATE(1246),
    [sym_preproc_warning] = STATE(1246),
    [sym_preproc_define] = STATE(1246),
    [sym_preproc_undef] = STATE(1246),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1247] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1247),
    [sym_preproc_endregion] = STATE(1247),
    [sym_preproc_line] = STATE(1247),
    [sym_preproc_pragma] = STATE(1247),
    [sym_preproc_nullable] = STATE(1247),
    [sym_preproc_error] = STATE(1247),
    [sym_preproc_warning] = STATE(1247),
    [sym_preproc_define] = STATE(1247),
    [sym_preproc_undef] = STATE(1247),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1248] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4608),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1248),
    [sym_preproc_endregion] = STATE(1248),
    [sym_preproc_line] = STATE(1248),
    [sym_preproc_pragma] = STATE(1248),
    [sym_preproc_nullable] = STATE(1248),
    [sym_preproc_error] = STATE(1248),
    [sym_preproc_warning] = STATE(1248),
    [sym_preproc_define] = STATE(1248),
    [sym_preproc_undef] = STATE(1248),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1249] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4609),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1249),
    [sym_preproc_endregion] = STATE(1249),
    [sym_preproc_line] = STATE(1249),
    [sym_preproc_pragma] = STATE(1249),
    [sym_preproc_nullable] = STATE(1249),
    [sym_preproc_error] = STATE(1249),
    [sym_preproc_warning] = STATE(1249),
    [sym_preproc_define] = STATE(1249),
    [sym_preproc_undef] = STATE(1249),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1250] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4610),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1250),
    [sym_preproc_endregion] = STATE(1250),
    [sym_preproc_line] = STATE(1250),
    [sym_preproc_pragma] = STATE(1250),
    [sym_preproc_nullable] = STATE(1250),
    [sym_preproc_error] = STATE(1250),
    [sym_preproc_warning] = STATE(1250),
    [sym_preproc_define] = STATE(1250),
    [sym_preproc_undef] = STATE(1250),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1251] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4611),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1251),
    [sym_preproc_endregion] = STATE(1251),
    [sym_preproc_line] = STATE(1251),
    [sym_preproc_pragma] = STATE(1251),
    [sym_preproc_nullable] = STATE(1251),
    [sym_preproc_error] = STATE(1251),
    [sym_preproc_warning] = STATE(1251),
    [sym_preproc_define] = STATE(1251),
    [sym_preproc_undef] = STATE(1251),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1252] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4612),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1252),
    [sym_preproc_endregion] = STATE(1252),
    [sym_preproc_line] = STATE(1252),
    [sym_preproc_pragma] = STATE(1252),
    [sym_preproc_nullable] = STATE(1252),
    [sym_preproc_error] = STATE(1252),
    [sym_preproc_warning] = STATE(1252),
    [sym_preproc_define] = STATE(1252),
    [sym_preproc_undef] = STATE(1252),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1253] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4613),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1253),
    [sym_preproc_endregion] = STATE(1253),
    [sym_preproc_line] = STATE(1253),
    [sym_preproc_pragma] = STATE(1253),
    [sym_preproc_nullable] = STATE(1253),
    [sym_preproc_error] = STATE(1253),
    [sym_preproc_warning] = STATE(1253),
    [sym_preproc_define] = STATE(1253),
    [sym_preproc_undef] = STATE(1253),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1254] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4614),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1254),
    [sym_preproc_endregion] = STATE(1254),
    [sym_preproc_line] = STATE(1254),
    [sym_preproc_pragma] = STATE(1254),
    [sym_preproc_nullable] = STATE(1254),
    [sym_preproc_error] = STATE(1254),
    [sym_preproc_warning] = STATE(1254),
    [sym_preproc_define] = STATE(1254),
    [sym_preproc_undef] = STATE(1254),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1255] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4615),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1255),
    [sym_preproc_endregion] = STATE(1255),
    [sym_preproc_line] = STATE(1255),
    [sym_preproc_pragma] = STATE(1255),
    [sym_preproc_nullable] = STATE(1255),
    [sym_preproc_error] = STATE(1255),
    [sym_preproc_warning] = STATE(1255),
    [sym_preproc_define] = STATE(1255),
    [sym_preproc_undef] = STATE(1255),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1256] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4617),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1256),
    [sym_preproc_endregion] = STATE(1256),
    [sym_preproc_line] = STATE(1256),
    [sym_preproc_pragma] = STATE(1256),
    [sym_preproc_nullable] = STATE(1256),
    [sym_preproc_error] = STATE(1256),
    [sym_preproc_warning] = STATE(1256),
    [sym_preproc_define] = STATE(1256),
    [sym_preproc_undef] = STATE(1256),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1257] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4618),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1257),
    [sym_preproc_endregion] = STATE(1257),
    [sym_preproc_line] = STATE(1257),
    [sym_preproc_pragma] = STATE(1257),
    [sym_preproc_nullable] = STATE(1257),
    [sym_preproc_error] = STATE(1257),
    [sym_preproc_warning] = STATE(1257),
    [sym_preproc_define] = STATE(1257),
    [sym_preproc_undef] = STATE(1257),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1258] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4619),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1258),
    [sym_preproc_endregion] = STATE(1258),
    [sym_preproc_line] = STATE(1258),
    [sym_preproc_pragma] = STATE(1258),
    [sym_preproc_nullable] = STATE(1258),
    [sym_preproc_error] = STATE(1258),
    [sym_preproc_warning] = STATE(1258),
    [sym_preproc_define] = STATE(1258),
    [sym_preproc_undef] = STATE(1258),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1259] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4034),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1259),
    [sym_preproc_endregion] = STATE(1259),
    [sym_preproc_line] = STATE(1259),
    [sym_preproc_pragma] = STATE(1259),
    [sym_preproc_nullable] = STATE(1259),
    [sym_preproc_error] = STATE(1259),
    [sym_preproc_warning] = STATE(1259),
    [sym_preproc_define] = STATE(1259),
    [sym_preproc_undef] = STATE(1259),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1260] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4728),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1260),
    [sym_preproc_endregion] = STATE(1260),
    [sym_preproc_line] = STATE(1260),
    [sym_preproc_pragma] = STATE(1260),
    [sym_preproc_nullable] = STATE(1260),
    [sym_preproc_error] = STATE(1260),
    [sym_preproc_warning] = STATE(1260),
    [sym_preproc_define] = STATE(1260),
    [sym_preproc_undef] = STATE(1260),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1261] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4411),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1261),
    [sym_preproc_endregion] = STATE(1261),
    [sym_preproc_line] = STATE(1261),
    [sym_preproc_pragma] = STATE(1261),
    [sym_preproc_nullable] = STATE(1261),
    [sym_preproc_error] = STATE(1261),
    [sym_preproc_warning] = STATE(1261),
    [sym_preproc_define] = STATE(1261),
    [sym_preproc_undef] = STATE(1261),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1262] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4037),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1262),
    [sym_preproc_endregion] = STATE(1262),
    [sym_preproc_line] = STATE(1262),
    [sym_preproc_pragma] = STATE(1262),
    [sym_preproc_nullable] = STATE(1262),
    [sym_preproc_error] = STATE(1262),
    [sym_preproc_warning] = STATE(1262),
    [sym_preproc_define] = STATE(1262),
    [sym_preproc_undef] = STATE(1262),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1263] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1263),
    [sym_preproc_endregion] = STATE(1263),
    [sym_preproc_line] = STATE(1263),
    [sym_preproc_pragma] = STATE(1263),
    [sym_preproc_nullable] = STATE(1263),
    [sym_preproc_error] = STATE(1263),
    [sym_preproc_warning] = STATE(1263),
    [sym_preproc_define] = STATE(1263),
    [sym_preproc_undef] = STATE(1263),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1264] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4038),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1264),
    [sym_preproc_endregion] = STATE(1264),
    [sym_preproc_line] = STATE(1264),
    [sym_preproc_pragma] = STATE(1264),
    [sym_preproc_nullable] = STATE(1264),
    [sym_preproc_error] = STATE(1264),
    [sym_preproc_warning] = STATE(1264),
    [sym_preproc_define] = STATE(1264),
    [sym_preproc_undef] = STATE(1264),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1265] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4372),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1265),
    [sym_preproc_endregion] = STATE(1265),
    [sym_preproc_line] = STATE(1265),
    [sym_preproc_pragma] = STATE(1265),
    [sym_preproc_nullable] = STATE(1265),
    [sym_preproc_error] = STATE(1265),
    [sym_preproc_warning] = STATE(1265),
    [sym_preproc_define] = STATE(1265),
    [sym_preproc_undef] = STATE(1265),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1266] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4039),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1266),
    [sym_preproc_endregion] = STATE(1266),
    [sym_preproc_line] = STATE(1266),
    [sym_preproc_pragma] = STATE(1266),
    [sym_preproc_nullable] = STATE(1266),
    [sym_preproc_error] = STATE(1266),
    [sym_preproc_warning] = STATE(1266),
    [sym_preproc_define] = STATE(1266),
    [sym_preproc_undef] = STATE(1266),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1267] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4621),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1267),
    [sym_preproc_endregion] = STATE(1267),
    [sym_preproc_line] = STATE(1267),
    [sym_preproc_pragma] = STATE(1267),
    [sym_preproc_nullable] = STATE(1267),
    [sym_preproc_error] = STATE(1267),
    [sym_preproc_warning] = STATE(1267),
    [sym_preproc_define] = STATE(1267),
    [sym_preproc_undef] = STATE(1267),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1268] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4040),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1268),
    [sym_preproc_endregion] = STATE(1268),
    [sym_preproc_line] = STATE(1268),
    [sym_preproc_pragma] = STATE(1268),
    [sym_preproc_nullable] = STATE(1268),
    [sym_preproc_error] = STATE(1268),
    [sym_preproc_warning] = STATE(1268),
    [sym_preproc_define] = STATE(1268),
    [sym_preproc_undef] = STATE(1268),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1269] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4041),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1269),
    [sym_preproc_endregion] = STATE(1269),
    [sym_preproc_line] = STATE(1269),
    [sym_preproc_pragma] = STATE(1269),
    [sym_preproc_nullable] = STATE(1269),
    [sym_preproc_error] = STATE(1269),
    [sym_preproc_warning] = STATE(1269),
    [sym_preproc_define] = STATE(1269),
    [sym_preproc_undef] = STATE(1269),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1270] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4412),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1270),
    [sym_preproc_endregion] = STATE(1270),
    [sym_preproc_line] = STATE(1270),
    [sym_preproc_pragma] = STATE(1270),
    [sym_preproc_nullable] = STATE(1270),
    [sym_preproc_error] = STATE(1270),
    [sym_preproc_warning] = STATE(1270),
    [sym_preproc_define] = STATE(1270),
    [sym_preproc_undef] = STATE(1270),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1271] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4042),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1271),
    [sym_preproc_endregion] = STATE(1271),
    [sym_preproc_line] = STATE(1271),
    [sym_preproc_pragma] = STATE(1271),
    [sym_preproc_nullable] = STATE(1271),
    [sym_preproc_error] = STATE(1271),
    [sym_preproc_warning] = STATE(1271),
    [sym_preproc_define] = STATE(1271),
    [sym_preproc_undef] = STATE(1271),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1272] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5039),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1272),
    [sym_preproc_endregion] = STATE(1272),
    [sym_preproc_line] = STATE(1272),
    [sym_preproc_pragma] = STATE(1272),
    [sym_preproc_nullable] = STATE(1272),
    [sym_preproc_error] = STATE(1272),
    [sym_preproc_warning] = STATE(1272),
    [sym_preproc_define] = STATE(1272),
    [sym_preproc_undef] = STATE(1272),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1273] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5040),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1273),
    [sym_preproc_endregion] = STATE(1273),
    [sym_preproc_line] = STATE(1273),
    [sym_preproc_pragma] = STATE(1273),
    [sym_preproc_nullable] = STATE(1273),
    [sym_preproc_error] = STATE(1273),
    [sym_preproc_warning] = STATE(1273),
    [sym_preproc_define] = STATE(1273),
    [sym_preproc_undef] = STATE(1273),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1274] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5057),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1274),
    [sym_preproc_endregion] = STATE(1274),
    [sym_preproc_line] = STATE(1274),
    [sym_preproc_pragma] = STATE(1274),
    [sym_preproc_nullable] = STATE(1274),
    [sym_preproc_error] = STATE(1274),
    [sym_preproc_warning] = STATE(1274),
    [sym_preproc_define] = STATE(1274),
    [sym_preproc_undef] = STATE(1274),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1275] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5041),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1275),
    [sym_preproc_endregion] = STATE(1275),
    [sym_preproc_line] = STATE(1275),
    [sym_preproc_pragma] = STATE(1275),
    [sym_preproc_nullable] = STATE(1275),
    [sym_preproc_error] = STATE(1275),
    [sym_preproc_warning] = STATE(1275),
    [sym_preproc_define] = STATE(1275),
    [sym_preproc_undef] = STATE(1275),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1276] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5042),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1276),
    [sym_preproc_endregion] = STATE(1276),
    [sym_preproc_line] = STATE(1276),
    [sym_preproc_pragma] = STATE(1276),
    [sym_preproc_nullable] = STATE(1276),
    [sym_preproc_error] = STATE(1276),
    [sym_preproc_warning] = STATE(1276),
    [sym_preproc_define] = STATE(1276),
    [sym_preproc_undef] = STATE(1276),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1277] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5043),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1277),
    [sym_preproc_endregion] = STATE(1277),
    [sym_preproc_line] = STATE(1277),
    [sym_preproc_pragma] = STATE(1277),
    [sym_preproc_nullable] = STATE(1277),
    [sym_preproc_error] = STATE(1277),
    [sym_preproc_warning] = STATE(1277),
    [sym_preproc_define] = STATE(1277),
    [sym_preproc_undef] = STATE(1277),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1278] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5044),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1278),
    [sym_preproc_endregion] = STATE(1278),
    [sym_preproc_line] = STATE(1278),
    [sym_preproc_pragma] = STATE(1278),
    [sym_preproc_nullable] = STATE(1278),
    [sym_preproc_error] = STATE(1278),
    [sym_preproc_warning] = STATE(1278),
    [sym_preproc_define] = STATE(1278),
    [sym_preproc_undef] = STATE(1278),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1279] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5045),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1279),
    [sym_preproc_endregion] = STATE(1279),
    [sym_preproc_line] = STATE(1279),
    [sym_preproc_pragma] = STATE(1279),
    [sym_preproc_nullable] = STATE(1279),
    [sym_preproc_error] = STATE(1279),
    [sym_preproc_warning] = STATE(1279),
    [sym_preproc_define] = STATE(1279),
    [sym_preproc_undef] = STATE(1279),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1280] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5046),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1280),
    [sym_preproc_endregion] = STATE(1280),
    [sym_preproc_line] = STATE(1280),
    [sym_preproc_pragma] = STATE(1280),
    [sym_preproc_nullable] = STATE(1280),
    [sym_preproc_error] = STATE(1280),
    [sym_preproc_warning] = STATE(1280),
    [sym_preproc_define] = STATE(1280),
    [sym_preproc_undef] = STATE(1280),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1281] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5049),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1281),
    [sym_preproc_endregion] = STATE(1281),
    [sym_preproc_line] = STATE(1281),
    [sym_preproc_pragma] = STATE(1281),
    [sym_preproc_nullable] = STATE(1281),
    [sym_preproc_error] = STATE(1281),
    [sym_preproc_warning] = STATE(1281),
    [sym_preproc_define] = STATE(1281),
    [sym_preproc_undef] = STATE(1281),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1282] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5051),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1282),
    [sym_preproc_endregion] = STATE(1282),
    [sym_preproc_line] = STATE(1282),
    [sym_preproc_pragma] = STATE(1282),
    [sym_preproc_nullable] = STATE(1282),
    [sym_preproc_error] = STATE(1282),
    [sym_preproc_warning] = STATE(1282),
    [sym_preproc_define] = STATE(1282),
    [sym_preproc_undef] = STATE(1282),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1283] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4043),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1283),
    [sym_preproc_endregion] = STATE(1283),
    [sym_preproc_line] = STATE(1283),
    [sym_preproc_pragma] = STATE(1283),
    [sym_preproc_nullable] = STATE(1283),
    [sym_preproc_error] = STATE(1283),
    [sym_preproc_warning] = STATE(1283),
    [sym_preproc_define] = STATE(1283),
    [sym_preproc_undef] = STATE(1283),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1284] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1284),
    [sym_preproc_endregion] = STATE(1284),
    [sym_preproc_line] = STATE(1284),
    [sym_preproc_pragma] = STATE(1284),
    [sym_preproc_nullable] = STATE(1284),
    [sym_preproc_error] = STATE(1284),
    [sym_preproc_warning] = STATE(1284),
    [sym_preproc_define] = STATE(1284),
    [sym_preproc_undef] = STATE(1284),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1285] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5323),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1285),
    [sym_preproc_endregion] = STATE(1285),
    [sym_preproc_line] = STATE(1285),
    [sym_preproc_pragma] = STATE(1285),
    [sym_preproc_nullable] = STATE(1285),
    [sym_preproc_error] = STATE(1285),
    [sym_preproc_warning] = STATE(1285),
    [sym_preproc_define] = STATE(1285),
    [sym_preproc_undef] = STATE(1285),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1286] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1286),
    [sym_preproc_endregion] = STATE(1286),
    [sym_preproc_line] = STATE(1286),
    [sym_preproc_pragma] = STATE(1286),
    [sym_preproc_nullable] = STATE(1286),
    [sym_preproc_error] = STATE(1286),
    [sym_preproc_warning] = STATE(1286),
    [sym_preproc_define] = STATE(1286),
    [sym_preproc_undef] = STATE(1286),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1287] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4045),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1287),
    [sym_preproc_endregion] = STATE(1287),
    [sym_preproc_line] = STATE(1287),
    [sym_preproc_pragma] = STATE(1287),
    [sym_preproc_nullable] = STATE(1287),
    [sym_preproc_error] = STATE(1287),
    [sym_preproc_warning] = STATE(1287),
    [sym_preproc_define] = STATE(1287),
    [sym_preproc_undef] = STATE(1287),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1288] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5365),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1288),
    [sym_preproc_endregion] = STATE(1288),
    [sym_preproc_line] = STATE(1288),
    [sym_preproc_pragma] = STATE(1288),
    [sym_preproc_nullable] = STATE(1288),
    [sym_preproc_error] = STATE(1288),
    [sym_preproc_warning] = STATE(1288),
    [sym_preproc_define] = STATE(1288),
    [sym_preproc_undef] = STATE(1288),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1289] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4046),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1289),
    [sym_preproc_endregion] = STATE(1289),
    [sym_preproc_line] = STATE(1289),
    [sym_preproc_pragma] = STATE(1289),
    [sym_preproc_nullable] = STATE(1289),
    [sym_preproc_error] = STATE(1289),
    [sym_preproc_warning] = STATE(1289),
    [sym_preproc_define] = STATE(1289),
    [sym_preproc_undef] = STATE(1289),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1290] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4434),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1290),
    [sym_preproc_endregion] = STATE(1290),
    [sym_preproc_line] = STATE(1290),
    [sym_preproc_pragma] = STATE(1290),
    [sym_preproc_nullable] = STATE(1290),
    [sym_preproc_error] = STATE(1290),
    [sym_preproc_warning] = STATE(1290),
    [sym_preproc_define] = STATE(1290),
    [sym_preproc_undef] = STATE(1290),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1291] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5189),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1291),
    [sym_preproc_endregion] = STATE(1291),
    [sym_preproc_line] = STATE(1291),
    [sym_preproc_pragma] = STATE(1291),
    [sym_preproc_nullable] = STATE(1291),
    [sym_preproc_error] = STATE(1291),
    [sym_preproc_warning] = STATE(1291),
    [sym_preproc_define] = STATE(1291),
    [sym_preproc_undef] = STATE(1291),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1292] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5203),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1292),
    [sym_preproc_endregion] = STATE(1292),
    [sym_preproc_line] = STATE(1292),
    [sym_preproc_pragma] = STATE(1292),
    [sym_preproc_nullable] = STATE(1292),
    [sym_preproc_error] = STATE(1292),
    [sym_preproc_warning] = STATE(1292),
    [sym_preproc_define] = STATE(1292),
    [sym_preproc_undef] = STATE(1292),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1293] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5214),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1293),
    [sym_preproc_endregion] = STATE(1293),
    [sym_preproc_line] = STATE(1293),
    [sym_preproc_pragma] = STATE(1293),
    [sym_preproc_nullable] = STATE(1293),
    [sym_preproc_error] = STATE(1293),
    [sym_preproc_warning] = STATE(1293),
    [sym_preproc_define] = STATE(1293),
    [sym_preproc_undef] = STATE(1293),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1294] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5216),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1294),
    [sym_preproc_endregion] = STATE(1294),
    [sym_preproc_line] = STATE(1294),
    [sym_preproc_pragma] = STATE(1294),
    [sym_preproc_nullable] = STATE(1294),
    [sym_preproc_error] = STATE(1294),
    [sym_preproc_warning] = STATE(1294),
    [sym_preproc_define] = STATE(1294),
    [sym_preproc_undef] = STATE(1294),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1295] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5340),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1295),
    [sym_preproc_endregion] = STATE(1295),
    [sym_preproc_line] = STATE(1295),
    [sym_preproc_pragma] = STATE(1295),
    [sym_preproc_nullable] = STATE(1295),
    [sym_preproc_error] = STATE(1295),
    [sym_preproc_warning] = STATE(1295),
    [sym_preproc_define] = STATE(1295),
    [sym_preproc_undef] = STATE(1295),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1296] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5341),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1296),
    [sym_preproc_endregion] = STATE(1296),
    [sym_preproc_line] = STATE(1296),
    [sym_preproc_pragma] = STATE(1296),
    [sym_preproc_nullable] = STATE(1296),
    [sym_preproc_error] = STATE(1296),
    [sym_preproc_warning] = STATE(1296),
    [sym_preproc_define] = STATE(1296),
    [sym_preproc_undef] = STATE(1296),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1297] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5342),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1297),
    [sym_preproc_endregion] = STATE(1297),
    [sym_preproc_line] = STATE(1297),
    [sym_preproc_pragma] = STATE(1297),
    [sym_preproc_nullable] = STATE(1297),
    [sym_preproc_error] = STATE(1297),
    [sym_preproc_warning] = STATE(1297),
    [sym_preproc_define] = STATE(1297),
    [sym_preproc_undef] = STATE(1297),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1298] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5217),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1298),
    [sym_preproc_endregion] = STATE(1298),
    [sym_preproc_line] = STATE(1298),
    [sym_preproc_pragma] = STATE(1298),
    [sym_preproc_nullable] = STATE(1298),
    [sym_preproc_error] = STATE(1298),
    [sym_preproc_warning] = STATE(1298),
    [sym_preproc_define] = STATE(1298),
    [sym_preproc_undef] = STATE(1298),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1299] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5347),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1299),
    [sym_preproc_endregion] = STATE(1299),
    [sym_preproc_line] = STATE(1299),
    [sym_preproc_pragma] = STATE(1299),
    [sym_preproc_nullable] = STATE(1299),
    [sym_preproc_error] = STATE(1299),
    [sym_preproc_warning] = STATE(1299),
    [sym_preproc_define] = STATE(1299),
    [sym_preproc_undef] = STATE(1299),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1300] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5352),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1300),
    [sym_preproc_endregion] = STATE(1300),
    [sym_preproc_line] = STATE(1300),
    [sym_preproc_pragma] = STATE(1300),
    [sym_preproc_nullable] = STATE(1300),
    [sym_preproc_error] = STATE(1300),
    [sym_preproc_warning] = STATE(1300),
    [sym_preproc_define] = STATE(1300),
    [sym_preproc_undef] = STATE(1300),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1301] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5357),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1301),
    [sym_preproc_endregion] = STATE(1301),
    [sym_preproc_line] = STATE(1301),
    [sym_preproc_pragma] = STATE(1301),
    [sym_preproc_nullable] = STATE(1301),
    [sym_preproc_error] = STATE(1301),
    [sym_preproc_warning] = STATE(1301),
    [sym_preproc_define] = STATE(1301),
    [sym_preproc_undef] = STATE(1301),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1302] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5358),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1302),
    [sym_preproc_endregion] = STATE(1302),
    [sym_preproc_line] = STATE(1302),
    [sym_preproc_pragma] = STATE(1302),
    [sym_preproc_nullable] = STATE(1302),
    [sym_preproc_error] = STATE(1302),
    [sym_preproc_warning] = STATE(1302),
    [sym_preproc_define] = STATE(1302),
    [sym_preproc_undef] = STATE(1302),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1303] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1303),
    [sym_preproc_endregion] = STATE(1303),
    [sym_preproc_line] = STATE(1303),
    [sym_preproc_pragma] = STATE(1303),
    [sym_preproc_nullable] = STATE(1303),
    [sym_preproc_error] = STATE(1303),
    [sym_preproc_warning] = STATE(1303),
    [sym_preproc_define] = STATE(1303),
    [sym_preproc_undef] = STATE(1303),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1304] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4047),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1304),
    [sym_preproc_endregion] = STATE(1304),
    [sym_preproc_line] = STATE(1304),
    [sym_preproc_pragma] = STATE(1304),
    [sym_preproc_nullable] = STATE(1304),
    [sym_preproc_error] = STATE(1304),
    [sym_preproc_warning] = STATE(1304),
    [sym_preproc_define] = STATE(1304),
    [sym_preproc_undef] = STATE(1304),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1305] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5073),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1305),
    [sym_preproc_endregion] = STATE(1305),
    [sym_preproc_line] = STATE(1305),
    [sym_preproc_pragma] = STATE(1305),
    [sym_preproc_nullable] = STATE(1305),
    [sym_preproc_error] = STATE(1305),
    [sym_preproc_warning] = STATE(1305),
    [sym_preproc_define] = STATE(1305),
    [sym_preproc_undef] = STATE(1305),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1306] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1306),
    [sym_preproc_endregion] = STATE(1306),
    [sym_preproc_line] = STATE(1306),
    [sym_preproc_pragma] = STATE(1306),
    [sym_preproc_nullable] = STATE(1306),
    [sym_preproc_error] = STATE(1306),
    [sym_preproc_warning] = STATE(1306),
    [sym_preproc_define] = STATE(1306),
    [sym_preproc_undef] = STATE(1306),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1307] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4145),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1307),
    [sym_preproc_endregion] = STATE(1307),
    [sym_preproc_line] = STATE(1307),
    [sym_preproc_pragma] = STATE(1307),
    [sym_preproc_nullable] = STATE(1307),
    [sym_preproc_error] = STATE(1307),
    [sym_preproc_warning] = STATE(1307),
    [sym_preproc_define] = STATE(1307),
    [sym_preproc_undef] = STATE(1307),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1308] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5075),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1308),
    [sym_preproc_endregion] = STATE(1308),
    [sym_preproc_line] = STATE(1308),
    [sym_preproc_pragma] = STATE(1308),
    [sym_preproc_nullable] = STATE(1308),
    [sym_preproc_error] = STATE(1308),
    [sym_preproc_warning] = STATE(1308),
    [sym_preproc_define] = STATE(1308),
    [sym_preproc_undef] = STATE(1308),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1309] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5079),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1309),
    [sym_preproc_endregion] = STATE(1309),
    [sym_preproc_line] = STATE(1309),
    [sym_preproc_pragma] = STATE(1309),
    [sym_preproc_nullable] = STATE(1309),
    [sym_preproc_error] = STATE(1309),
    [sym_preproc_warning] = STATE(1309),
    [sym_preproc_define] = STATE(1309),
    [sym_preproc_undef] = STATE(1309),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1310] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4771),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1310),
    [sym_preproc_endregion] = STATE(1310),
    [sym_preproc_line] = STATE(1310),
    [sym_preproc_pragma] = STATE(1310),
    [sym_preproc_nullable] = STATE(1310),
    [sym_preproc_error] = STATE(1310),
    [sym_preproc_warning] = STATE(1310),
    [sym_preproc_define] = STATE(1310),
    [sym_preproc_undef] = STATE(1310),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1311] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1311),
    [sym_preproc_endregion] = STATE(1311),
    [sym_preproc_line] = STATE(1311),
    [sym_preproc_pragma] = STATE(1311),
    [sym_preproc_nullable] = STATE(1311),
    [sym_preproc_error] = STATE(1311),
    [sym_preproc_warning] = STATE(1311),
    [sym_preproc_define] = STATE(1311),
    [sym_preproc_undef] = STATE(1311),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1312] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4624),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1312),
    [sym_preproc_endregion] = STATE(1312),
    [sym_preproc_line] = STATE(1312),
    [sym_preproc_pragma] = STATE(1312),
    [sym_preproc_nullable] = STATE(1312),
    [sym_preproc_error] = STATE(1312),
    [sym_preproc_warning] = STATE(1312),
    [sym_preproc_define] = STATE(1312),
    [sym_preproc_undef] = STATE(1312),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1313] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4625),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1313),
    [sym_preproc_endregion] = STATE(1313),
    [sym_preproc_line] = STATE(1313),
    [sym_preproc_pragma] = STATE(1313),
    [sym_preproc_nullable] = STATE(1313),
    [sym_preproc_error] = STATE(1313),
    [sym_preproc_warning] = STATE(1313),
    [sym_preproc_define] = STATE(1313),
    [sym_preproc_undef] = STATE(1313),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1314] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4797),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1314),
    [sym_preproc_endregion] = STATE(1314),
    [sym_preproc_line] = STATE(1314),
    [sym_preproc_pragma] = STATE(1314),
    [sym_preproc_nullable] = STATE(1314),
    [sym_preproc_error] = STATE(1314),
    [sym_preproc_warning] = STATE(1314),
    [sym_preproc_define] = STATE(1314),
    [sym_preproc_undef] = STATE(1314),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1315] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4772),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1315),
    [sym_preproc_endregion] = STATE(1315),
    [sym_preproc_line] = STATE(1315),
    [sym_preproc_pragma] = STATE(1315),
    [sym_preproc_nullable] = STATE(1315),
    [sym_preproc_error] = STATE(1315),
    [sym_preproc_warning] = STATE(1315),
    [sym_preproc_define] = STATE(1315),
    [sym_preproc_undef] = STATE(1315),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1316] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4773),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1316),
    [sym_preproc_endregion] = STATE(1316),
    [sym_preproc_line] = STATE(1316),
    [sym_preproc_pragma] = STATE(1316),
    [sym_preproc_nullable] = STATE(1316),
    [sym_preproc_error] = STATE(1316),
    [sym_preproc_warning] = STATE(1316),
    [sym_preproc_define] = STATE(1316),
    [sym_preproc_undef] = STATE(1316),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1317] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4774),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1317),
    [sym_preproc_endregion] = STATE(1317),
    [sym_preproc_line] = STATE(1317),
    [sym_preproc_pragma] = STATE(1317),
    [sym_preproc_nullable] = STATE(1317),
    [sym_preproc_error] = STATE(1317),
    [sym_preproc_warning] = STATE(1317),
    [sym_preproc_define] = STATE(1317),
    [sym_preproc_undef] = STATE(1317),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1318] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4626),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1318),
    [sym_preproc_endregion] = STATE(1318),
    [sym_preproc_line] = STATE(1318),
    [sym_preproc_pragma] = STATE(1318),
    [sym_preproc_nullable] = STATE(1318),
    [sym_preproc_error] = STATE(1318),
    [sym_preproc_warning] = STATE(1318),
    [sym_preproc_define] = STATE(1318),
    [sym_preproc_undef] = STATE(1318),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1319] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4775),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1319),
    [sym_preproc_endregion] = STATE(1319),
    [sym_preproc_line] = STATE(1319),
    [sym_preproc_pragma] = STATE(1319),
    [sym_preproc_nullable] = STATE(1319),
    [sym_preproc_error] = STATE(1319),
    [sym_preproc_warning] = STATE(1319),
    [sym_preproc_define] = STATE(1319),
    [sym_preproc_undef] = STATE(1319),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1320] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4776),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1320),
    [sym_preproc_endregion] = STATE(1320),
    [sym_preproc_line] = STATE(1320),
    [sym_preproc_pragma] = STATE(1320),
    [sym_preproc_nullable] = STATE(1320),
    [sym_preproc_error] = STATE(1320),
    [sym_preproc_warning] = STATE(1320),
    [sym_preproc_define] = STATE(1320),
    [sym_preproc_undef] = STATE(1320),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1321] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4777),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1321),
    [sym_preproc_endregion] = STATE(1321),
    [sym_preproc_line] = STATE(1321),
    [sym_preproc_pragma] = STATE(1321),
    [sym_preproc_nullable] = STATE(1321),
    [sym_preproc_error] = STATE(1321),
    [sym_preproc_warning] = STATE(1321),
    [sym_preproc_define] = STATE(1321),
    [sym_preproc_undef] = STATE(1321),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1322] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4778),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1322),
    [sym_preproc_endregion] = STATE(1322),
    [sym_preproc_line] = STATE(1322),
    [sym_preproc_pragma] = STATE(1322),
    [sym_preproc_nullable] = STATE(1322),
    [sym_preproc_error] = STATE(1322),
    [sym_preproc_warning] = STATE(1322),
    [sym_preproc_define] = STATE(1322),
    [sym_preproc_undef] = STATE(1322),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1323] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4779),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1323),
    [sym_preproc_endregion] = STATE(1323),
    [sym_preproc_line] = STATE(1323),
    [sym_preproc_pragma] = STATE(1323),
    [sym_preproc_nullable] = STATE(1323),
    [sym_preproc_error] = STATE(1323),
    [sym_preproc_warning] = STATE(1323),
    [sym_preproc_define] = STATE(1323),
    [sym_preproc_undef] = STATE(1323),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1324] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1324),
    [sym_preproc_endregion] = STATE(1324),
    [sym_preproc_line] = STATE(1324),
    [sym_preproc_pragma] = STATE(1324),
    [sym_preproc_nullable] = STATE(1324),
    [sym_preproc_error] = STATE(1324),
    [sym_preproc_warning] = STATE(1324),
    [sym_preproc_define] = STATE(1324),
    [sym_preproc_undef] = STATE(1324),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1325] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4781),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1325),
    [sym_preproc_endregion] = STATE(1325),
    [sym_preproc_line] = STATE(1325),
    [sym_preproc_pragma] = STATE(1325),
    [sym_preproc_nullable] = STATE(1325),
    [sym_preproc_error] = STATE(1325),
    [sym_preproc_warning] = STATE(1325),
    [sym_preproc_define] = STATE(1325),
    [sym_preproc_undef] = STATE(1325),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1326] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3680),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3140),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7543),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1326),
    [sym_preproc_endregion] = STATE(1326),
    [sym_preproc_line] = STATE(1326),
    [sym_preproc_pragma] = STATE(1326),
    [sym_preproc_nullable] = STATE(1326),
    [sym_preproc_error] = STATE(1326),
    [sym_preproc_warning] = STATE(1326),
    [sym_preproc_define] = STATE(1326),
    [sym_preproc_undef] = STATE(1326),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_ref] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1327] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1327),
    [sym_preproc_endregion] = STATE(1327),
    [sym_preproc_line] = STATE(1327),
    [sym_preproc_pragma] = STATE(1327),
    [sym_preproc_nullable] = STATE(1327),
    [sym_preproc_error] = STATE(1327),
    [sym_preproc_warning] = STATE(1327),
    [sym_preproc_define] = STATE(1327),
    [sym_preproc_undef] = STATE(1327),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1328] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1328),
    [sym_preproc_endregion] = STATE(1328),
    [sym_preproc_line] = STATE(1328),
    [sym_preproc_pragma] = STATE(1328),
    [sym_preproc_nullable] = STATE(1328),
    [sym_preproc_error] = STATE(1328),
    [sym_preproc_warning] = STATE(1328),
    [sym_preproc_define] = STATE(1328),
    [sym_preproc_undef] = STATE(1328),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1329] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5428),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1329),
    [sym_preproc_endregion] = STATE(1329),
    [sym_preproc_line] = STATE(1329),
    [sym_preproc_pragma] = STATE(1329),
    [sym_preproc_nullable] = STATE(1329),
    [sym_preproc_error] = STATE(1329),
    [sym_preproc_warning] = STATE(1329),
    [sym_preproc_define] = STATE(1329),
    [sym_preproc_undef] = STATE(1329),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1330] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1330),
    [sym_preproc_endregion] = STATE(1330),
    [sym_preproc_line] = STATE(1330),
    [sym_preproc_pragma] = STATE(1330),
    [sym_preproc_nullable] = STATE(1330),
    [sym_preproc_error] = STATE(1330),
    [sym_preproc_warning] = STATE(1330),
    [sym_preproc_define] = STATE(1330),
    [sym_preproc_undef] = STATE(1330),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1331] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5521),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1331),
    [sym_preproc_endregion] = STATE(1331),
    [sym_preproc_line] = STATE(1331),
    [sym_preproc_pragma] = STATE(1331),
    [sym_preproc_nullable] = STATE(1331),
    [sym_preproc_error] = STATE(1331),
    [sym_preproc_warning] = STATE(1331),
    [sym_preproc_define] = STATE(1331),
    [sym_preproc_undef] = STATE(1331),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1332] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5523),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1332),
    [sym_preproc_endregion] = STATE(1332),
    [sym_preproc_line] = STATE(1332),
    [sym_preproc_pragma] = STATE(1332),
    [sym_preproc_nullable] = STATE(1332),
    [sym_preproc_error] = STATE(1332),
    [sym_preproc_warning] = STATE(1332),
    [sym_preproc_define] = STATE(1332),
    [sym_preproc_undef] = STATE(1332),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1333] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5524),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1333),
    [sym_preproc_endregion] = STATE(1333),
    [sym_preproc_line] = STATE(1333),
    [sym_preproc_pragma] = STATE(1333),
    [sym_preproc_nullable] = STATE(1333),
    [sym_preproc_error] = STATE(1333),
    [sym_preproc_warning] = STATE(1333),
    [sym_preproc_define] = STATE(1333),
    [sym_preproc_undef] = STATE(1333),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1334] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5525),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1334),
    [sym_preproc_endregion] = STATE(1334),
    [sym_preproc_line] = STATE(1334),
    [sym_preproc_pragma] = STATE(1334),
    [sym_preproc_nullable] = STATE(1334),
    [sym_preproc_error] = STATE(1334),
    [sym_preproc_warning] = STATE(1334),
    [sym_preproc_define] = STATE(1334),
    [sym_preproc_undef] = STATE(1334),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1335] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5526),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1335),
    [sym_preproc_endregion] = STATE(1335),
    [sym_preproc_line] = STATE(1335),
    [sym_preproc_pragma] = STATE(1335),
    [sym_preproc_nullable] = STATE(1335),
    [sym_preproc_error] = STATE(1335),
    [sym_preproc_warning] = STATE(1335),
    [sym_preproc_define] = STATE(1335),
    [sym_preproc_undef] = STATE(1335),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1336] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5527),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1336),
    [sym_preproc_endregion] = STATE(1336),
    [sym_preproc_line] = STATE(1336),
    [sym_preproc_pragma] = STATE(1336),
    [sym_preproc_nullable] = STATE(1336),
    [sym_preproc_error] = STATE(1336),
    [sym_preproc_warning] = STATE(1336),
    [sym_preproc_define] = STATE(1336),
    [sym_preproc_undef] = STATE(1336),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1337] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5528),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1337),
    [sym_preproc_endregion] = STATE(1337),
    [sym_preproc_line] = STATE(1337),
    [sym_preproc_pragma] = STATE(1337),
    [sym_preproc_nullable] = STATE(1337),
    [sym_preproc_error] = STATE(1337),
    [sym_preproc_warning] = STATE(1337),
    [sym_preproc_define] = STATE(1337),
    [sym_preproc_undef] = STATE(1337),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1338] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5529),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1338),
    [sym_preproc_endregion] = STATE(1338),
    [sym_preproc_line] = STATE(1338),
    [sym_preproc_pragma] = STATE(1338),
    [sym_preproc_nullable] = STATE(1338),
    [sym_preproc_error] = STATE(1338),
    [sym_preproc_warning] = STATE(1338),
    [sym_preproc_define] = STATE(1338),
    [sym_preproc_undef] = STATE(1338),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1339] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5531),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1339),
    [sym_preproc_endregion] = STATE(1339),
    [sym_preproc_line] = STATE(1339),
    [sym_preproc_pragma] = STATE(1339),
    [sym_preproc_nullable] = STATE(1339),
    [sym_preproc_error] = STATE(1339),
    [sym_preproc_warning] = STATE(1339),
    [sym_preproc_define] = STATE(1339),
    [sym_preproc_undef] = STATE(1339),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1340] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5532),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1340),
    [sym_preproc_endregion] = STATE(1340),
    [sym_preproc_line] = STATE(1340),
    [sym_preproc_pragma] = STATE(1340),
    [sym_preproc_nullable] = STATE(1340),
    [sym_preproc_error] = STATE(1340),
    [sym_preproc_warning] = STATE(1340),
    [sym_preproc_define] = STATE(1340),
    [sym_preproc_undef] = STATE(1340),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1341] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5533),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1341),
    [sym_preproc_endregion] = STATE(1341),
    [sym_preproc_line] = STATE(1341),
    [sym_preproc_pragma] = STATE(1341),
    [sym_preproc_nullable] = STATE(1341),
    [sym_preproc_error] = STATE(1341),
    [sym_preproc_warning] = STATE(1341),
    [sym_preproc_define] = STATE(1341),
    [sym_preproc_undef] = STATE(1341),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1342] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5459),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1342),
    [sym_preproc_endregion] = STATE(1342),
    [sym_preproc_line] = STATE(1342),
    [sym_preproc_pragma] = STATE(1342),
    [sym_preproc_nullable] = STATE(1342),
    [sym_preproc_error] = STATE(1342),
    [sym_preproc_warning] = STATE(1342),
    [sym_preproc_define] = STATE(1342),
    [sym_preproc_undef] = STATE(1342),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1343] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4273),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1343),
    [sym_preproc_endregion] = STATE(1343),
    [sym_preproc_line] = STATE(1343),
    [sym_preproc_pragma] = STATE(1343),
    [sym_preproc_nullable] = STATE(1343),
    [sym_preproc_error] = STATE(1343),
    [sym_preproc_warning] = STATE(1343),
    [sym_preproc_define] = STATE(1343),
    [sym_preproc_undef] = STATE(1343),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1344] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1344),
    [sym_preproc_endregion] = STATE(1344),
    [sym_preproc_line] = STATE(1344),
    [sym_preproc_pragma] = STATE(1344),
    [sym_preproc_nullable] = STATE(1344),
    [sym_preproc_error] = STATE(1344),
    [sym_preproc_warning] = STATE(1344),
    [sym_preproc_define] = STATE(1344),
    [sym_preproc_undef] = STATE(1344),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1345] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5063),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1345),
    [sym_preproc_endregion] = STATE(1345),
    [sym_preproc_line] = STATE(1345),
    [sym_preproc_pragma] = STATE(1345),
    [sym_preproc_nullable] = STATE(1345),
    [sym_preproc_error] = STATE(1345),
    [sym_preproc_warning] = STATE(1345),
    [sym_preproc_define] = STATE(1345),
    [sym_preproc_undef] = STATE(1345),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1346] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3934),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1346),
    [sym_preproc_endregion] = STATE(1346),
    [sym_preproc_line] = STATE(1346),
    [sym_preproc_pragma] = STATE(1346),
    [sym_preproc_nullable] = STATE(1346),
    [sym_preproc_error] = STATE(1346),
    [sym_preproc_warning] = STATE(1346),
    [sym_preproc_define] = STATE(1346),
    [sym_preproc_undef] = STATE(1346),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1347] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5540),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1347),
    [sym_preproc_endregion] = STATE(1347),
    [sym_preproc_line] = STATE(1347),
    [sym_preproc_pragma] = STATE(1347),
    [sym_preproc_nullable] = STATE(1347),
    [sym_preproc_error] = STATE(1347),
    [sym_preproc_warning] = STATE(1347),
    [sym_preproc_define] = STATE(1347),
    [sym_preproc_undef] = STATE(1347),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1348] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4282),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1348),
    [sym_preproc_endregion] = STATE(1348),
    [sym_preproc_line] = STATE(1348),
    [sym_preproc_pragma] = STATE(1348),
    [sym_preproc_nullable] = STATE(1348),
    [sym_preproc_error] = STATE(1348),
    [sym_preproc_warning] = STATE(1348),
    [sym_preproc_define] = STATE(1348),
    [sym_preproc_undef] = STATE(1348),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1349] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5090),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1349),
    [sym_preproc_endregion] = STATE(1349),
    [sym_preproc_line] = STATE(1349),
    [sym_preproc_pragma] = STATE(1349),
    [sym_preproc_nullable] = STATE(1349),
    [sym_preproc_error] = STATE(1349),
    [sym_preproc_warning] = STATE(1349),
    [sym_preproc_define] = STATE(1349),
    [sym_preproc_undef] = STATE(1349),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1350] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5091),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1350),
    [sym_preproc_endregion] = STATE(1350),
    [sym_preproc_line] = STATE(1350),
    [sym_preproc_pragma] = STATE(1350),
    [sym_preproc_nullable] = STATE(1350),
    [sym_preproc_error] = STATE(1350),
    [sym_preproc_warning] = STATE(1350),
    [sym_preproc_define] = STATE(1350),
    [sym_preproc_undef] = STATE(1350),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1351] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5060),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1351),
    [sym_preproc_endregion] = STATE(1351),
    [sym_preproc_line] = STATE(1351),
    [sym_preproc_pragma] = STATE(1351),
    [sym_preproc_nullable] = STATE(1351),
    [sym_preproc_error] = STATE(1351),
    [sym_preproc_warning] = STATE(1351),
    [sym_preproc_define] = STATE(1351),
    [sym_preproc_undef] = STATE(1351),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1352] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5092),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1352),
    [sym_preproc_endregion] = STATE(1352),
    [sym_preproc_line] = STATE(1352),
    [sym_preproc_pragma] = STATE(1352),
    [sym_preproc_nullable] = STATE(1352),
    [sym_preproc_error] = STATE(1352),
    [sym_preproc_warning] = STATE(1352),
    [sym_preproc_define] = STATE(1352),
    [sym_preproc_undef] = STATE(1352),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1353] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5093),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1353),
    [sym_preproc_endregion] = STATE(1353),
    [sym_preproc_line] = STATE(1353),
    [sym_preproc_pragma] = STATE(1353),
    [sym_preproc_nullable] = STATE(1353),
    [sym_preproc_error] = STATE(1353),
    [sym_preproc_warning] = STATE(1353),
    [sym_preproc_define] = STATE(1353),
    [sym_preproc_undef] = STATE(1353),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1354] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5094),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1354),
    [sym_preproc_endregion] = STATE(1354),
    [sym_preproc_line] = STATE(1354),
    [sym_preproc_pragma] = STATE(1354),
    [sym_preproc_nullable] = STATE(1354),
    [sym_preproc_error] = STATE(1354),
    [sym_preproc_warning] = STATE(1354),
    [sym_preproc_define] = STATE(1354),
    [sym_preproc_undef] = STATE(1354),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1355] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5095),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1355),
    [sym_preproc_endregion] = STATE(1355),
    [sym_preproc_line] = STATE(1355),
    [sym_preproc_pragma] = STATE(1355),
    [sym_preproc_nullable] = STATE(1355),
    [sym_preproc_error] = STATE(1355),
    [sym_preproc_warning] = STATE(1355),
    [sym_preproc_define] = STATE(1355),
    [sym_preproc_undef] = STATE(1355),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1356] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5096),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1356),
    [sym_preproc_endregion] = STATE(1356),
    [sym_preproc_line] = STATE(1356),
    [sym_preproc_pragma] = STATE(1356),
    [sym_preproc_nullable] = STATE(1356),
    [sym_preproc_error] = STATE(1356),
    [sym_preproc_warning] = STATE(1356),
    [sym_preproc_define] = STATE(1356),
    [sym_preproc_undef] = STATE(1356),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1357] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5097),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1357),
    [sym_preproc_endregion] = STATE(1357),
    [sym_preproc_line] = STATE(1357),
    [sym_preproc_pragma] = STATE(1357),
    [sym_preproc_nullable] = STATE(1357),
    [sym_preproc_error] = STATE(1357),
    [sym_preproc_warning] = STATE(1357),
    [sym_preproc_define] = STATE(1357),
    [sym_preproc_undef] = STATE(1357),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1358] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5098),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1358),
    [sym_preproc_endregion] = STATE(1358),
    [sym_preproc_line] = STATE(1358),
    [sym_preproc_pragma] = STATE(1358),
    [sym_preproc_nullable] = STATE(1358),
    [sym_preproc_error] = STATE(1358),
    [sym_preproc_warning] = STATE(1358),
    [sym_preproc_define] = STATE(1358),
    [sym_preproc_undef] = STATE(1358),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1359] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5099),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1359),
    [sym_preproc_endregion] = STATE(1359),
    [sym_preproc_line] = STATE(1359),
    [sym_preproc_pragma] = STATE(1359),
    [sym_preproc_nullable] = STATE(1359),
    [sym_preproc_error] = STATE(1359),
    [sym_preproc_warning] = STATE(1359),
    [sym_preproc_define] = STATE(1359),
    [sym_preproc_undef] = STATE(1359),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1360] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1360),
    [sym_preproc_endregion] = STATE(1360),
    [sym_preproc_line] = STATE(1360),
    [sym_preproc_pragma] = STATE(1360),
    [sym_preproc_nullable] = STATE(1360),
    [sym_preproc_error] = STATE(1360),
    [sym_preproc_warning] = STATE(1360),
    [sym_preproc_define] = STATE(1360),
    [sym_preproc_undef] = STATE(1360),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1361] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4783),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1361),
    [sym_preproc_endregion] = STATE(1361),
    [sym_preproc_line] = STATE(1361),
    [sym_preproc_pragma] = STATE(1361),
    [sym_preproc_nullable] = STATE(1361),
    [sym_preproc_error] = STATE(1361),
    [sym_preproc_warning] = STATE(1361),
    [sym_preproc_define] = STATE(1361),
    [sym_preproc_undef] = STATE(1361),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1362] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5100),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1362),
    [sym_preproc_endregion] = STATE(1362),
    [sym_preproc_line] = STATE(1362),
    [sym_preproc_pragma] = STATE(1362),
    [sym_preproc_nullable] = STATE(1362),
    [sym_preproc_error] = STATE(1362),
    [sym_preproc_warning] = STATE(1362),
    [sym_preproc_define] = STATE(1362),
    [sym_preproc_undef] = STATE(1362),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1363] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1363),
    [sym_preproc_endregion] = STATE(1363),
    [sym_preproc_line] = STATE(1363),
    [sym_preproc_pragma] = STATE(1363),
    [sym_preproc_nullable] = STATE(1363),
    [sym_preproc_error] = STATE(1363),
    [sym_preproc_warning] = STATE(1363),
    [sym_preproc_define] = STATE(1363),
    [sym_preproc_undef] = STATE(1363),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1364] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5102),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1364),
    [sym_preproc_endregion] = STATE(1364),
    [sym_preproc_line] = STATE(1364),
    [sym_preproc_pragma] = STATE(1364),
    [sym_preproc_nullable] = STATE(1364),
    [sym_preproc_error] = STATE(1364),
    [sym_preproc_warning] = STATE(1364),
    [sym_preproc_define] = STATE(1364),
    [sym_preproc_undef] = STATE(1364),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1365] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5104),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1365),
    [sym_preproc_endregion] = STATE(1365),
    [sym_preproc_line] = STATE(1365),
    [sym_preproc_pragma] = STATE(1365),
    [sym_preproc_nullable] = STATE(1365),
    [sym_preproc_error] = STATE(1365),
    [sym_preproc_warning] = STATE(1365),
    [sym_preproc_define] = STATE(1365),
    [sym_preproc_undef] = STATE(1365),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1366] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5475),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1366),
    [sym_preproc_endregion] = STATE(1366),
    [sym_preproc_line] = STATE(1366),
    [sym_preproc_pragma] = STATE(1366),
    [sym_preproc_nullable] = STATE(1366),
    [sym_preproc_error] = STATE(1366),
    [sym_preproc_warning] = STATE(1366),
    [sym_preproc_define] = STATE(1366),
    [sym_preproc_undef] = STATE(1366),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1367] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4784),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1367),
    [sym_preproc_endregion] = STATE(1367),
    [sym_preproc_line] = STATE(1367),
    [sym_preproc_pragma] = STATE(1367),
    [sym_preproc_nullable] = STATE(1367),
    [sym_preproc_error] = STATE(1367),
    [sym_preproc_warning] = STATE(1367),
    [sym_preproc_define] = STATE(1367),
    [sym_preproc_undef] = STATE(1367),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1368] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1368),
    [sym_preproc_endregion] = STATE(1368),
    [sym_preproc_line] = STATE(1368),
    [sym_preproc_pragma] = STATE(1368),
    [sym_preproc_nullable] = STATE(1368),
    [sym_preproc_error] = STATE(1368),
    [sym_preproc_warning] = STATE(1368),
    [sym_preproc_define] = STATE(1368),
    [sym_preproc_undef] = STATE(1368),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1369] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4634),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1369),
    [sym_preproc_endregion] = STATE(1369),
    [sym_preproc_line] = STATE(1369),
    [sym_preproc_pragma] = STATE(1369),
    [sym_preproc_nullable] = STATE(1369),
    [sym_preproc_error] = STATE(1369),
    [sym_preproc_warning] = STATE(1369),
    [sym_preproc_define] = STATE(1369),
    [sym_preproc_undef] = STATE(1369),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1370] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4635),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1370),
    [sym_preproc_endregion] = STATE(1370),
    [sym_preproc_line] = STATE(1370),
    [sym_preproc_pragma] = STATE(1370),
    [sym_preproc_nullable] = STATE(1370),
    [sym_preproc_error] = STATE(1370),
    [sym_preproc_warning] = STATE(1370),
    [sym_preproc_define] = STATE(1370),
    [sym_preproc_undef] = STATE(1370),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1371] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4808),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1371),
    [sym_preproc_endregion] = STATE(1371),
    [sym_preproc_line] = STATE(1371),
    [sym_preproc_pragma] = STATE(1371),
    [sym_preproc_nullable] = STATE(1371),
    [sym_preproc_error] = STATE(1371),
    [sym_preproc_warning] = STATE(1371),
    [sym_preproc_define] = STATE(1371),
    [sym_preproc_undef] = STATE(1371),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1372] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4785),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1372),
    [sym_preproc_endregion] = STATE(1372),
    [sym_preproc_line] = STATE(1372),
    [sym_preproc_pragma] = STATE(1372),
    [sym_preproc_nullable] = STATE(1372),
    [sym_preproc_error] = STATE(1372),
    [sym_preproc_warning] = STATE(1372),
    [sym_preproc_define] = STATE(1372),
    [sym_preproc_undef] = STATE(1372),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1373] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4786),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1373),
    [sym_preproc_endregion] = STATE(1373),
    [sym_preproc_line] = STATE(1373),
    [sym_preproc_pragma] = STATE(1373),
    [sym_preproc_nullable] = STATE(1373),
    [sym_preproc_error] = STATE(1373),
    [sym_preproc_warning] = STATE(1373),
    [sym_preproc_define] = STATE(1373),
    [sym_preproc_undef] = STATE(1373),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1374] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4787),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1374),
    [sym_preproc_endregion] = STATE(1374),
    [sym_preproc_line] = STATE(1374),
    [sym_preproc_pragma] = STATE(1374),
    [sym_preproc_nullable] = STATE(1374),
    [sym_preproc_error] = STATE(1374),
    [sym_preproc_warning] = STATE(1374),
    [sym_preproc_define] = STATE(1374),
    [sym_preproc_undef] = STATE(1374),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1375] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4636),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1375),
    [sym_preproc_endregion] = STATE(1375),
    [sym_preproc_line] = STATE(1375),
    [sym_preproc_pragma] = STATE(1375),
    [sym_preproc_nullable] = STATE(1375),
    [sym_preproc_error] = STATE(1375),
    [sym_preproc_warning] = STATE(1375),
    [sym_preproc_define] = STATE(1375),
    [sym_preproc_undef] = STATE(1375),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1376] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4789),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1376),
    [sym_preproc_endregion] = STATE(1376),
    [sym_preproc_line] = STATE(1376),
    [sym_preproc_pragma] = STATE(1376),
    [sym_preproc_nullable] = STATE(1376),
    [sym_preproc_error] = STATE(1376),
    [sym_preproc_warning] = STATE(1376),
    [sym_preproc_define] = STATE(1376),
    [sym_preproc_undef] = STATE(1376),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1377] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5477),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1377),
    [sym_preproc_endregion] = STATE(1377),
    [sym_preproc_line] = STATE(1377),
    [sym_preproc_pragma] = STATE(1377),
    [sym_preproc_nullable] = STATE(1377),
    [sym_preproc_error] = STATE(1377),
    [sym_preproc_warning] = STATE(1377),
    [sym_preproc_define] = STATE(1377),
    [sym_preproc_undef] = STATE(1377),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1378] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4793),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1378),
    [sym_preproc_endregion] = STATE(1378),
    [sym_preproc_line] = STATE(1378),
    [sym_preproc_pragma] = STATE(1378),
    [sym_preproc_nullable] = STATE(1378),
    [sym_preproc_error] = STATE(1378),
    [sym_preproc_warning] = STATE(1378),
    [sym_preproc_define] = STATE(1378),
    [sym_preproc_undef] = STATE(1378),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1379] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4795),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1379),
    [sym_preproc_endregion] = STATE(1379),
    [sym_preproc_line] = STATE(1379),
    [sym_preproc_pragma] = STATE(1379),
    [sym_preproc_nullable] = STATE(1379),
    [sym_preproc_error] = STATE(1379),
    [sym_preproc_warning] = STATE(1379),
    [sym_preproc_define] = STATE(1379),
    [sym_preproc_undef] = STATE(1379),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1380] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4798),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1380),
    [sym_preproc_endregion] = STATE(1380),
    [sym_preproc_line] = STATE(1380),
    [sym_preproc_pragma] = STATE(1380),
    [sym_preproc_nullable] = STATE(1380),
    [sym_preproc_error] = STATE(1380),
    [sym_preproc_warning] = STATE(1380),
    [sym_preproc_define] = STATE(1380),
    [sym_preproc_undef] = STATE(1380),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1381] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4799),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1381),
    [sym_preproc_endregion] = STATE(1381),
    [sym_preproc_line] = STATE(1381),
    [sym_preproc_pragma] = STATE(1381),
    [sym_preproc_nullable] = STATE(1381),
    [sym_preproc_error] = STATE(1381),
    [sym_preproc_warning] = STATE(1381),
    [sym_preproc_define] = STATE(1381),
    [sym_preproc_undef] = STATE(1381),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1382] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1382),
    [sym_preproc_endregion] = STATE(1382),
    [sym_preproc_line] = STATE(1382),
    [sym_preproc_pragma] = STATE(1382),
    [sym_preproc_nullable] = STATE(1382),
    [sym_preproc_error] = STATE(1382),
    [sym_preproc_warning] = STATE(1382),
    [sym_preproc_define] = STATE(1382),
    [sym_preproc_undef] = STATE(1382),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1383] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4801),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1383),
    [sym_preproc_endregion] = STATE(1383),
    [sym_preproc_line] = STATE(1383),
    [sym_preproc_pragma] = STATE(1383),
    [sym_preproc_nullable] = STATE(1383),
    [sym_preproc_error] = STATE(1383),
    [sym_preproc_warning] = STATE(1383),
    [sym_preproc_define] = STATE(1383),
    [sym_preproc_undef] = STATE(1383),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1384] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1384),
    [sym_preproc_endregion] = STATE(1384),
    [sym_preproc_line] = STATE(1384),
    [sym_preproc_pragma] = STATE(1384),
    [sym_preproc_nullable] = STATE(1384),
    [sym_preproc_error] = STATE(1384),
    [sym_preproc_warning] = STATE(1384),
    [sym_preproc_define] = STATE(1384),
    [sym_preproc_undef] = STATE(1384),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1385] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1385),
    [sym_preproc_endregion] = STATE(1385),
    [sym_preproc_line] = STATE(1385),
    [sym_preproc_pragma] = STATE(1385),
    [sym_preproc_nullable] = STATE(1385),
    [sym_preproc_error] = STATE(1385),
    [sym_preproc_warning] = STATE(1385),
    [sym_preproc_define] = STATE(1385),
    [sym_preproc_undef] = STATE(1385),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1386] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5480),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1386),
    [sym_preproc_endregion] = STATE(1386),
    [sym_preproc_line] = STATE(1386),
    [sym_preproc_pragma] = STATE(1386),
    [sym_preproc_nullable] = STATE(1386),
    [sym_preproc_error] = STATE(1386),
    [sym_preproc_warning] = STATE(1386),
    [sym_preproc_define] = STATE(1386),
    [sym_preproc_undef] = STATE(1386),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1387] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1387),
    [sym_preproc_endregion] = STATE(1387),
    [sym_preproc_line] = STATE(1387),
    [sym_preproc_pragma] = STATE(1387),
    [sym_preproc_nullable] = STATE(1387),
    [sym_preproc_error] = STATE(1387),
    [sym_preproc_warning] = STATE(1387),
    [sym_preproc_define] = STATE(1387),
    [sym_preproc_undef] = STATE(1387),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1388] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5577),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1388),
    [sym_preproc_endregion] = STATE(1388),
    [sym_preproc_line] = STATE(1388),
    [sym_preproc_pragma] = STATE(1388),
    [sym_preproc_nullable] = STATE(1388),
    [sym_preproc_error] = STATE(1388),
    [sym_preproc_warning] = STATE(1388),
    [sym_preproc_define] = STATE(1388),
    [sym_preproc_undef] = STATE(1388),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1389] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1389),
    [sym_preproc_endregion] = STATE(1389),
    [sym_preproc_line] = STATE(1389),
    [sym_preproc_pragma] = STATE(1389),
    [sym_preproc_nullable] = STATE(1389),
    [sym_preproc_error] = STATE(1389),
    [sym_preproc_warning] = STATE(1389),
    [sym_preproc_define] = STATE(1389),
    [sym_preproc_undef] = STATE(1389),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1390] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5581),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1390),
    [sym_preproc_endregion] = STATE(1390),
    [sym_preproc_line] = STATE(1390),
    [sym_preproc_pragma] = STATE(1390),
    [sym_preproc_nullable] = STATE(1390),
    [sym_preproc_error] = STATE(1390),
    [sym_preproc_warning] = STATE(1390),
    [sym_preproc_define] = STATE(1390),
    [sym_preproc_undef] = STATE(1390),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1391] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5584),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1391),
    [sym_preproc_endregion] = STATE(1391),
    [sym_preproc_line] = STATE(1391),
    [sym_preproc_pragma] = STATE(1391),
    [sym_preproc_nullable] = STATE(1391),
    [sym_preproc_error] = STATE(1391),
    [sym_preproc_warning] = STATE(1391),
    [sym_preproc_define] = STATE(1391),
    [sym_preproc_undef] = STATE(1391),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1392] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5592),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1392),
    [sym_preproc_endregion] = STATE(1392),
    [sym_preproc_line] = STATE(1392),
    [sym_preproc_pragma] = STATE(1392),
    [sym_preproc_nullable] = STATE(1392),
    [sym_preproc_error] = STATE(1392),
    [sym_preproc_warning] = STATE(1392),
    [sym_preproc_define] = STATE(1392),
    [sym_preproc_undef] = STATE(1392),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1393] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5594),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1393),
    [sym_preproc_endregion] = STATE(1393),
    [sym_preproc_line] = STATE(1393),
    [sym_preproc_pragma] = STATE(1393),
    [sym_preproc_nullable] = STATE(1393),
    [sym_preproc_error] = STATE(1393),
    [sym_preproc_warning] = STATE(1393),
    [sym_preproc_define] = STATE(1393),
    [sym_preproc_undef] = STATE(1393),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1394] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5595),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1394),
    [sym_preproc_endregion] = STATE(1394),
    [sym_preproc_line] = STATE(1394),
    [sym_preproc_pragma] = STATE(1394),
    [sym_preproc_nullable] = STATE(1394),
    [sym_preproc_error] = STATE(1394),
    [sym_preproc_warning] = STATE(1394),
    [sym_preproc_define] = STATE(1394),
    [sym_preproc_undef] = STATE(1394),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1395] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5597),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1395),
    [sym_preproc_endregion] = STATE(1395),
    [sym_preproc_line] = STATE(1395),
    [sym_preproc_pragma] = STATE(1395),
    [sym_preproc_nullable] = STATE(1395),
    [sym_preproc_error] = STATE(1395),
    [sym_preproc_warning] = STATE(1395),
    [sym_preproc_define] = STATE(1395),
    [sym_preproc_undef] = STATE(1395),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1396] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5599),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1396),
    [sym_preproc_endregion] = STATE(1396),
    [sym_preproc_line] = STATE(1396),
    [sym_preproc_pragma] = STATE(1396),
    [sym_preproc_nullable] = STATE(1396),
    [sym_preproc_error] = STATE(1396),
    [sym_preproc_warning] = STATE(1396),
    [sym_preproc_define] = STATE(1396),
    [sym_preproc_undef] = STATE(1396),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1397] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5600),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1397),
    [sym_preproc_endregion] = STATE(1397),
    [sym_preproc_line] = STATE(1397),
    [sym_preproc_pragma] = STATE(1397),
    [sym_preproc_nullable] = STATE(1397),
    [sym_preproc_error] = STATE(1397),
    [sym_preproc_warning] = STATE(1397),
    [sym_preproc_define] = STATE(1397),
    [sym_preproc_undef] = STATE(1397),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1398] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5602),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1398),
    [sym_preproc_endregion] = STATE(1398),
    [sym_preproc_line] = STATE(1398),
    [sym_preproc_pragma] = STATE(1398),
    [sym_preproc_nullable] = STATE(1398),
    [sym_preproc_error] = STATE(1398),
    [sym_preproc_warning] = STATE(1398),
    [sym_preproc_define] = STATE(1398),
    [sym_preproc_undef] = STATE(1398),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1399] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4153),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1399),
    [sym_preproc_endregion] = STATE(1399),
    [sym_preproc_line] = STATE(1399),
    [sym_preproc_pragma] = STATE(1399),
    [sym_preproc_nullable] = STATE(1399),
    [sym_preproc_error] = STATE(1399),
    [sym_preproc_warning] = STATE(1399),
    [sym_preproc_define] = STATE(1399),
    [sym_preproc_undef] = STATE(1399),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1400] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5482),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1400),
    [sym_preproc_endregion] = STATE(1400),
    [sym_preproc_line] = STATE(1400),
    [sym_preproc_pragma] = STATE(1400),
    [sym_preproc_nullable] = STATE(1400),
    [sym_preproc_error] = STATE(1400),
    [sym_preproc_warning] = STATE(1400),
    [sym_preproc_define] = STATE(1400),
    [sym_preproc_undef] = STATE(1400),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1401] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5343),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1401),
    [sym_preproc_endregion] = STATE(1401),
    [sym_preproc_line] = STATE(1401),
    [sym_preproc_pragma] = STATE(1401),
    [sym_preproc_nullable] = STATE(1401),
    [sym_preproc_error] = STATE(1401),
    [sym_preproc_warning] = STATE(1401),
    [sym_preproc_define] = STATE(1401),
    [sym_preproc_undef] = STATE(1401),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1402] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5087),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1402),
    [sym_preproc_endregion] = STATE(1402),
    [sym_preproc_line] = STATE(1402),
    [sym_preproc_pragma] = STATE(1402),
    [sym_preproc_nullable] = STATE(1402),
    [sym_preproc_error] = STATE(1402),
    [sym_preproc_warning] = STATE(1402),
    [sym_preproc_define] = STATE(1402),
    [sym_preproc_undef] = STATE(1402),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1403] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1403),
    [sym_preproc_endregion] = STATE(1403),
    [sym_preproc_line] = STATE(1403),
    [sym_preproc_pragma] = STATE(1403),
    [sym_preproc_nullable] = STATE(1403),
    [sym_preproc_error] = STATE(1403),
    [sym_preproc_warning] = STATE(1403),
    [sym_preproc_define] = STATE(1403),
    [sym_preproc_undef] = STATE(1403),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1404] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5089),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1404),
    [sym_preproc_endregion] = STATE(1404),
    [sym_preproc_line] = STATE(1404),
    [sym_preproc_pragma] = STATE(1404),
    [sym_preproc_nullable] = STATE(1404),
    [sym_preproc_error] = STATE(1404),
    [sym_preproc_warning] = STATE(1404),
    [sym_preproc_define] = STATE(1404),
    [sym_preproc_undef] = STATE(1404),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1405] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5067),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1405),
    [sym_preproc_endregion] = STATE(1405),
    [sym_preproc_line] = STATE(1405),
    [sym_preproc_pragma] = STATE(1405),
    [sym_preproc_nullable] = STATE(1405),
    [sym_preproc_error] = STATE(1405),
    [sym_preproc_warning] = STATE(1405),
    [sym_preproc_define] = STATE(1405),
    [sym_preproc_undef] = STATE(1405),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1406] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5611),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1406),
    [sym_preproc_endregion] = STATE(1406),
    [sym_preproc_line] = STATE(1406),
    [sym_preproc_pragma] = STATE(1406),
    [sym_preproc_nullable] = STATE(1406),
    [sym_preproc_error] = STATE(1406),
    [sym_preproc_warning] = STATE(1406),
    [sym_preproc_define] = STATE(1406),
    [sym_preproc_undef] = STATE(1406),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1407] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5355),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1407),
    [sym_preproc_endregion] = STATE(1407),
    [sym_preproc_line] = STATE(1407),
    [sym_preproc_pragma] = STATE(1407),
    [sym_preproc_nullable] = STATE(1407),
    [sym_preproc_error] = STATE(1407),
    [sym_preproc_warning] = STATE(1407),
    [sym_preproc_define] = STATE(1407),
    [sym_preproc_undef] = STATE(1407),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1408] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5139),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1408),
    [sym_preproc_endregion] = STATE(1408),
    [sym_preproc_line] = STATE(1408),
    [sym_preproc_pragma] = STATE(1408),
    [sym_preproc_nullable] = STATE(1408),
    [sym_preproc_error] = STATE(1408),
    [sym_preproc_warning] = STATE(1408),
    [sym_preproc_define] = STATE(1408),
    [sym_preproc_undef] = STATE(1408),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1409] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5140),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1409),
    [sym_preproc_endregion] = STATE(1409),
    [sym_preproc_line] = STATE(1409),
    [sym_preproc_pragma] = STATE(1409),
    [sym_preproc_nullable] = STATE(1409),
    [sym_preproc_error] = STATE(1409),
    [sym_preproc_warning] = STATE(1409),
    [sym_preproc_define] = STATE(1409),
    [sym_preproc_undef] = STATE(1409),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1410] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5064),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1410),
    [sym_preproc_endregion] = STATE(1410),
    [sym_preproc_line] = STATE(1410),
    [sym_preproc_pragma] = STATE(1410),
    [sym_preproc_nullable] = STATE(1410),
    [sym_preproc_error] = STATE(1410),
    [sym_preproc_warning] = STATE(1410),
    [sym_preproc_define] = STATE(1410),
    [sym_preproc_undef] = STATE(1410),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1411] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5142),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1411),
    [sym_preproc_endregion] = STATE(1411),
    [sym_preproc_line] = STATE(1411),
    [sym_preproc_pragma] = STATE(1411),
    [sym_preproc_nullable] = STATE(1411),
    [sym_preproc_error] = STATE(1411),
    [sym_preproc_warning] = STATE(1411),
    [sym_preproc_define] = STATE(1411),
    [sym_preproc_undef] = STATE(1411),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1412] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5143),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1412),
    [sym_preproc_endregion] = STATE(1412),
    [sym_preproc_line] = STATE(1412),
    [sym_preproc_pragma] = STATE(1412),
    [sym_preproc_nullable] = STATE(1412),
    [sym_preproc_error] = STATE(1412),
    [sym_preproc_warning] = STATE(1412),
    [sym_preproc_define] = STATE(1412),
    [sym_preproc_undef] = STATE(1412),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1413] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5144),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1413),
    [sym_preproc_endregion] = STATE(1413),
    [sym_preproc_line] = STATE(1413),
    [sym_preproc_pragma] = STATE(1413),
    [sym_preproc_nullable] = STATE(1413),
    [sym_preproc_error] = STATE(1413),
    [sym_preproc_warning] = STATE(1413),
    [sym_preproc_define] = STATE(1413),
    [sym_preproc_undef] = STATE(1413),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1414] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5145),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1414),
    [sym_preproc_endregion] = STATE(1414),
    [sym_preproc_line] = STATE(1414),
    [sym_preproc_pragma] = STATE(1414),
    [sym_preproc_nullable] = STATE(1414),
    [sym_preproc_error] = STATE(1414),
    [sym_preproc_warning] = STATE(1414),
    [sym_preproc_define] = STATE(1414),
    [sym_preproc_undef] = STATE(1414),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1415] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5146),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1415),
    [sym_preproc_endregion] = STATE(1415),
    [sym_preproc_line] = STATE(1415),
    [sym_preproc_pragma] = STATE(1415),
    [sym_preproc_nullable] = STATE(1415),
    [sym_preproc_error] = STATE(1415),
    [sym_preproc_warning] = STATE(1415),
    [sym_preproc_define] = STATE(1415),
    [sym_preproc_undef] = STATE(1415),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1416] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5147),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1416),
    [sym_preproc_endregion] = STATE(1416),
    [sym_preproc_line] = STATE(1416),
    [sym_preproc_pragma] = STATE(1416),
    [sym_preproc_nullable] = STATE(1416),
    [sym_preproc_error] = STATE(1416),
    [sym_preproc_warning] = STATE(1416),
    [sym_preproc_define] = STATE(1416),
    [sym_preproc_undef] = STATE(1416),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1417] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5148),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1417),
    [sym_preproc_endregion] = STATE(1417),
    [sym_preproc_line] = STATE(1417),
    [sym_preproc_pragma] = STATE(1417),
    [sym_preproc_nullable] = STATE(1417),
    [sym_preproc_error] = STATE(1417),
    [sym_preproc_warning] = STATE(1417),
    [sym_preproc_define] = STATE(1417),
    [sym_preproc_undef] = STATE(1417),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1418] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1418),
    [sym_preproc_endregion] = STATE(1418),
    [sym_preproc_line] = STATE(1418),
    [sym_preproc_pragma] = STATE(1418),
    [sym_preproc_nullable] = STATE(1418),
    [sym_preproc_error] = STATE(1418),
    [sym_preproc_warning] = STATE(1418),
    [sym_preproc_define] = STATE(1418),
    [sym_preproc_undef] = STATE(1418),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1419] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5151),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1419),
    [sym_preproc_endregion] = STATE(1419),
    [sym_preproc_line] = STATE(1419),
    [sym_preproc_pragma] = STATE(1419),
    [sym_preproc_nullable] = STATE(1419),
    [sym_preproc_error] = STATE(1419),
    [sym_preproc_warning] = STATE(1419),
    [sym_preproc_define] = STATE(1419),
    [sym_preproc_undef] = STATE(1419),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1420] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1420),
    [sym_preproc_endregion] = STATE(1420),
    [sym_preproc_line] = STATE(1420),
    [sym_preproc_pragma] = STATE(1420),
    [sym_preproc_nullable] = STATE(1420),
    [sym_preproc_error] = STATE(1420),
    [sym_preproc_warning] = STATE(1420),
    [sym_preproc_define] = STATE(1420),
    [sym_preproc_undef] = STATE(1420),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1421] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5156),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1421),
    [sym_preproc_endregion] = STATE(1421),
    [sym_preproc_line] = STATE(1421),
    [sym_preproc_pragma] = STATE(1421),
    [sym_preproc_nullable] = STATE(1421),
    [sym_preproc_error] = STATE(1421),
    [sym_preproc_warning] = STATE(1421),
    [sym_preproc_define] = STATE(1421),
    [sym_preproc_undef] = STATE(1421),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1422] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5161),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1422),
    [sym_preproc_endregion] = STATE(1422),
    [sym_preproc_line] = STATE(1422),
    [sym_preproc_pragma] = STATE(1422),
    [sym_preproc_nullable] = STATE(1422),
    [sym_preproc_error] = STATE(1422),
    [sym_preproc_warning] = STATE(1422),
    [sym_preproc_define] = STATE(1422),
    [sym_preproc_undef] = STATE(1422),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1423] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3494),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6235),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7412),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1423),
    [sym_preproc_endregion] = STATE(1423),
    [sym_preproc_line] = STATE(1423),
    [sym_preproc_pragma] = STATE(1423),
    [sym_preproc_nullable] = STATE(1423),
    [sym_preproc_error] = STATE(1423),
    [sym_preproc_warning] = STATE(1423),
    [sym_preproc_define] = STATE(1423),
    [sym_preproc_undef] = STATE(1423),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_ref] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1424] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1424),
    [sym_preproc_endregion] = STATE(1424),
    [sym_preproc_line] = STATE(1424),
    [sym_preproc_pragma] = STATE(1424),
    [sym_preproc_nullable] = STATE(1424),
    [sym_preproc_error] = STATE(1424),
    [sym_preproc_warning] = STATE(1424),
    [sym_preproc_define] = STATE(1424),
    [sym_preproc_undef] = STATE(1424),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1425] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5628),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1425),
    [sym_preproc_endregion] = STATE(1425),
    [sym_preproc_line] = STATE(1425),
    [sym_preproc_pragma] = STATE(1425),
    [sym_preproc_nullable] = STATE(1425),
    [sym_preproc_error] = STATE(1425),
    [sym_preproc_warning] = STATE(1425),
    [sym_preproc_define] = STATE(1425),
    [sym_preproc_undef] = STATE(1425),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1426] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1426),
    [sym_preproc_endregion] = STATE(1426),
    [sym_preproc_line] = STATE(1426),
    [sym_preproc_pragma] = STATE(1426),
    [sym_preproc_nullable] = STATE(1426),
    [sym_preproc_error] = STATE(1426),
    [sym_preproc_warning] = STATE(1426),
    [sym_preproc_define] = STATE(1426),
    [sym_preproc_undef] = STATE(1426),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1427] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5643),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1427),
    [sym_preproc_endregion] = STATE(1427),
    [sym_preproc_line] = STATE(1427),
    [sym_preproc_pragma] = STATE(1427),
    [sym_preproc_nullable] = STATE(1427),
    [sym_preproc_error] = STATE(1427),
    [sym_preproc_warning] = STATE(1427),
    [sym_preproc_define] = STATE(1427),
    [sym_preproc_undef] = STATE(1427),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1428] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5647),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1428),
    [sym_preproc_endregion] = STATE(1428),
    [sym_preproc_line] = STATE(1428),
    [sym_preproc_pragma] = STATE(1428),
    [sym_preproc_nullable] = STATE(1428),
    [sym_preproc_error] = STATE(1428),
    [sym_preproc_warning] = STATE(1428),
    [sym_preproc_define] = STATE(1428),
    [sym_preproc_undef] = STATE(1428),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1429] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5649),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1429),
    [sym_preproc_endregion] = STATE(1429),
    [sym_preproc_line] = STATE(1429),
    [sym_preproc_pragma] = STATE(1429),
    [sym_preproc_nullable] = STATE(1429),
    [sym_preproc_error] = STATE(1429),
    [sym_preproc_warning] = STATE(1429),
    [sym_preproc_define] = STATE(1429),
    [sym_preproc_undef] = STATE(1429),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1430] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5651),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1430),
    [sym_preproc_endregion] = STATE(1430),
    [sym_preproc_line] = STATE(1430),
    [sym_preproc_pragma] = STATE(1430),
    [sym_preproc_nullable] = STATE(1430),
    [sym_preproc_error] = STATE(1430),
    [sym_preproc_warning] = STATE(1430),
    [sym_preproc_define] = STATE(1430),
    [sym_preproc_undef] = STATE(1430),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1431] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5652),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1431),
    [sym_preproc_endregion] = STATE(1431),
    [sym_preproc_line] = STATE(1431),
    [sym_preproc_pragma] = STATE(1431),
    [sym_preproc_nullable] = STATE(1431),
    [sym_preproc_error] = STATE(1431),
    [sym_preproc_warning] = STATE(1431),
    [sym_preproc_define] = STATE(1431),
    [sym_preproc_undef] = STATE(1431),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1432] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5654),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1432),
    [sym_preproc_endregion] = STATE(1432),
    [sym_preproc_line] = STATE(1432),
    [sym_preproc_pragma] = STATE(1432),
    [sym_preproc_nullable] = STATE(1432),
    [sym_preproc_error] = STATE(1432),
    [sym_preproc_warning] = STATE(1432),
    [sym_preproc_define] = STATE(1432),
    [sym_preproc_undef] = STATE(1432),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1433] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5656),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1433),
    [sym_preproc_endregion] = STATE(1433),
    [sym_preproc_line] = STATE(1433),
    [sym_preproc_pragma] = STATE(1433),
    [sym_preproc_nullable] = STATE(1433),
    [sym_preproc_error] = STATE(1433),
    [sym_preproc_warning] = STATE(1433),
    [sym_preproc_define] = STATE(1433),
    [sym_preproc_undef] = STATE(1433),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1434] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5658),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1434),
    [sym_preproc_endregion] = STATE(1434),
    [sym_preproc_line] = STATE(1434),
    [sym_preproc_pragma] = STATE(1434),
    [sym_preproc_nullable] = STATE(1434),
    [sym_preproc_error] = STATE(1434),
    [sym_preproc_warning] = STATE(1434),
    [sym_preproc_define] = STATE(1434),
    [sym_preproc_undef] = STATE(1434),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1435] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5665),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1435),
    [sym_preproc_endregion] = STATE(1435),
    [sym_preproc_line] = STATE(1435),
    [sym_preproc_pragma] = STATE(1435),
    [sym_preproc_nullable] = STATE(1435),
    [sym_preproc_error] = STATE(1435),
    [sym_preproc_warning] = STATE(1435),
    [sym_preproc_define] = STATE(1435),
    [sym_preproc_undef] = STATE(1435),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1436] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5666),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1436),
    [sym_preproc_endregion] = STATE(1436),
    [sym_preproc_line] = STATE(1436),
    [sym_preproc_pragma] = STATE(1436),
    [sym_preproc_nullable] = STATE(1436),
    [sym_preproc_error] = STATE(1436),
    [sym_preproc_warning] = STATE(1436),
    [sym_preproc_define] = STATE(1436),
    [sym_preproc_undef] = STATE(1436),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1437] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5667),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1437),
    [sym_preproc_endregion] = STATE(1437),
    [sym_preproc_line] = STATE(1437),
    [sym_preproc_pragma] = STATE(1437),
    [sym_preproc_nullable] = STATE(1437),
    [sym_preproc_error] = STATE(1437),
    [sym_preproc_warning] = STATE(1437),
    [sym_preproc_define] = STATE(1437),
    [sym_preproc_undef] = STATE(1437),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1438] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5686),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1438),
    [sym_preproc_endregion] = STATE(1438),
    [sym_preproc_line] = STATE(1438),
    [sym_preproc_pragma] = STATE(1438),
    [sym_preproc_nullable] = STATE(1438),
    [sym_preproc_error] = STATE(1438),
    [sym_preproc_warning] = STATE(1438),
    [sym_preproc_define] = STATE(1438),
    [sym_preproc_undef] = STATE(1438),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1439] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5175),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1439),
    [sym_preproc_endregion] = STATE(1439),
    [sym_preproc_line] = STATE(1439),
    [sym_preproc_pragma] = STATE(1439),
    [sym_preproc_nullable] = STATE(1439),
    [sym_preproc_error] = STATE(1439),
    [sym_preproc_warning] = STATE(1439),
    [sym_preproc_define] = STATE(1439),
    [sym_preproc_undef] = STATE(1439),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1440] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1440),
    [sym_preproc_endregion] = STATE(1440),
    [sym_preproc_line] = STATE(1440),
    [sym_preproc_pragma] = STATE(1440),
    [sym_preproc_nullable] = STATE(1440),
    [sym_preproc_error] = STATE(1440),
    [sym_preproc_warning] = STATE(1440),
    [sym_preproc_define] = STATE(1440),
    [sym_preproc_undef] = STATE(1440),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1441] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5070),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1441),
    [sym_preproc_endregion] = STATE(1441),
    [sym_preproc_line] = STATE(1441),
    [sym_preproc_pragma] = STATE(1441),
    [sym_preproc_nullable] = STATE(1441),
    [sym_preproc_error] = STATE(1441),
    [sym_preproc_warning] = STATE(1441),
    [sym_preproc_define] = STATE(1441),
    [sym_preproc_undef] = STATE(1441),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1442] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5676),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1442),
    [sym_preproc_endregion] = STATE(1442),
    [sym_preproc_line] = STATE(1442),
    [sym_preproc_pragma] = STATE(1442),
    [sym_preproc_nullable] = STATE(1442),
    [sym_preproc_error] = STATE(1442),
    [sym_preproc_warning] = STATE(1442),
    [sym_preproc_define] = STATE(1442),
    [sym_preproc_undef] = STATE(1442),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1443] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5180),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1443),
    [sym_preproc_endregion] = STATE(1443),
    [sym_preproc_line] = STATE(1443),
    [sym_preproc_pragma] = STATE(1443),
    [sym_preproc_nullable] = STATE(1443),
    [sym_preproc_error] = STATE(1443),
    [sym_preproc_warning] = STATE(1443),
    [sym_preproc_define] = STATE(1443),
    [sym_preproc_undef] = STATE(1443),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1444] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4905),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1444),
    [sym_preproc_endregion] = STATE(1444),
    [sym_preproc_line] = STATE(1444),
    [sym_preproc_pragma] = STATE(1444),
    [sym_preproc_nullable] = STATE(1444),
    [sym_preproc_error] = STATE(1444),
    [sym_preproc_warning] = STATE(1444),
    [sym_preproc_define] = STATE(1444),
    [sym_preproc_undef] = STATE(1444),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1445] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4906),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1445),
    [sym_preproc_endregion] = STATE(1445),
    [sym_preproc_line] = STATE(1445),
    [sym_preproc_pragma] = STATE(1445),
    [sym_preproc_nullable] = STATE(1445),
    [sym_preproc_error] = STATE(1445),
    [sym_preproc_warning] = STATE(1445),
    [sym_preproc_define] = STATE(1445),
    [sym_preproc_undef] = STATE(1445),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1446] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5068),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1446),
    [sym_preproc_endregion] = STATE(1446),
    [sym_preproc_line] = STATE(1446),
    [sym_preproc_pragma] = STATE(1446),
    [sym_preproc_nullable] = STATE(1446),
    [sym_preproc_error] = STATE(1446),
    [sym_preproc_warning] = STATE(1446),
    [sym_preproc_define] = STATE(1446),
    [sym_preproc_undef] = STATE(1446),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1447] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4907),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1447),
    [sym_preproc_endregion] = STATE(1447),
    [sym_preproc_line] = STATE(1447),
    [sym_preproc_pragma] = STATE(1447),
    [sym_preproc_nullable] = STATE(1447),
    [sym_preproc_error] = STATE(1447),
    [sym_preproc_warning] = STATE(1447),
    [sym_preproc_define] = STATE(1447),
    [sym_preproc_undef] = STATE(1447),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1448] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4908),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1448),
    [sym_preproc_endregion] = STATE(1448),
    [sym_preproc_line] = STATE(1448),
    [sym_preproc_pragma] = STATE(1448),
    [sym_preproc_nullable] = STATE(1448),
    [sym_preproc_error] = STATE(1448),
    [sym_preproc_warning] = STATE(1448),
    [sym_preproc_define] = STATE(1448),
    [sym_preproc_undef] = STATE(1448),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1449] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4909),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1449),
    [sym_preproc_endregion] = STATE(1449),
    [sym_preproc_line] = STATE(1449),
    [sym_preproc_pragma] = STATE(1449),
    [sym_preproc_nullable] = STATE(1449),
    [sym_preproc_error] = STATE(1449),
    [sym_preproc_warning] = STATE(1449),
    [sym_preproc_define] = STATE(1449),
    [sym_preproc_undef] = STATE(1449),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1450] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4910),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1450),
    [sym_preproc_endregion] = STATE(1450),
    [sym_preproc_line] = STATE(1450),
    [sym_preproc_pragma] = STATE(1450),
    [sym_preproc_nullable] = STATE(1450),
    [sym_preproc_error] = STATE(1450),
    [sym_preproc_warning] = STATE(1450),
    [sym_preproc_define] = STATE(1450),
    [sym_preproc_undef] = STATE(1450),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1451] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4911),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1451),
    [sym_preproc_endregion] = STATE(1451),
    [sym_preproc_line] = STATE(1451),
    [sym_preproc_pragma] = STATE(1451),
    [sym_preproc_nullable] = STATE(1451),
    [sym_preproc_error] = STATE(1451),
    [sym_preproc_warning] = STATE(1451),
    [sym_preproc_define] = STATE(1451),
    [sym_preproc_undef] = STATE(1451),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1452] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4912),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1452),
    [sym_preproc_endregion] = STATE(1452),
    [sym_preproc_line] = STATE(1452),
    [sym_preproc_pragma] = STATE(1452),
    [sym_preproc_nullable] = STATE(1452),
    [sym_preproc_error] = STATE(1452),
    [sym_preproc_warning] = STATE(1452),
    [sym_preproc_define] = STATE(1452),
    [sym_preproc_undef] = STATE(1452),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1453] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4913),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1453),
    [sym_preproc_endregion] = STATE(1453),
    [sym_preproc_line] = STATE(1453),
    [sym_preproc_pragma] = STATE(1453),
    [sym_preproc_nullable] = STATE(1453),
    [sym_preproc_error] = STATE(1453),
    [sym_preproc_warning] = STATE(1453),
    [sym_preproc_define] = STATE(1453),
    [sym_preproc_undef] = STATE(1453),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1454] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4914),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1454),
    [sym_preproc_endregion] = STATE(1454),
    [sym_preproc_line] = STATE(1454),
    [sym_preproc_pragma] = STATE(1454),
    [sym_preproc_nullable] = STATE(1454),
    [sym_preproc_error] = STATE(1454),
    [sym_preproc_warning] = STATE(1454),
    [sym_preproc_define] = STATE(1454),
    [sym_preproc_undef] = STATE(1454),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1455] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1455),
    [sym_preproc_endregion] = STATE(1455),
    [sym_preproc_line] = STATE(1455),
    [sym_preproc_pragma] = STATE(1455),
    [sym_preproc_nullable] = STATE(1455),
    [sym_preproc_error] = STATE(1455),
    [sym_preproc_warning] = STATE(1455),
    [sym_preproc_define] = STATE(1455),
    [sym_preproc_undef] = STATE(1455),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1456] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4916),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1456),
    [sym_preproc_endregion] = STATE(1456),
    [sym_preproc_line] = STATE(1456),
    [sym_preproc_pragma] = STATE(1456),
    [sym_preproc_nullable] = STATE(1456),
    [sym_preproc_error] = STATE(1456),
    [sym_preproc_warning] = STATE(1456),
    [sym_preproc_define] = STATE(1456),
    [sym_preproc_undef] = STATE(1456),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1457] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1457),
    [sym_preproc_endregion] = STATE(1457),
    [sym_preproc_line] = STATE(1457),
    [sym_preproc_pragma] = STATE(1457),
    [sym_preproc_nullable] = STATE(1457),
    [sym_preproc_error] = STATE(1457),
    [sym_preproc_warning] = STATE(1457),
    [sym_preproc_define] = STATE(1457),
    [sym_preproc_undef] = STATE(1457),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1458] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4918),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1458),
    [sym_preproc_endregion] = STATE(1458),
    [sym_preproc_line] = STATE(1458),
    [sym_preproc_pragma] = STATE(1458),
    [sym_preproc_nullable] = STATE(1458),
    [sym_preproc_error] = STATE(1458),
    [sym_preproc_warning] = STATE(1458),
    [sym_preproc_define] = STATE(1458),
    [sym_preproc_undef] = STATE(1458),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1459] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4920),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1459),
    [sym_preproc_endregion] = STATE(1459),
    [sym_preproc_line] = STATE(1459),
    [sym_preproc_pragma] = STATE(1459),
    [sym_preproc_nullable] = STATE(1459),
    [sym_preproc_error] = STATE(1459),
    [sym_preproc_warning] = STATE(1459),
    [sym_preproc_define] = STATE(1459),
    [sym_preproc_undef] = STATE(1459),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1460] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5111),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1460),
    [sym_preproc_endregion] = STATE(1460),
    [sym_preproc_line] = STATE(1460),
    [sym_preproc_pragma] = STATE(1460),
    [sym_preproc_nullable] = STATE(1460),
    [sym_preproc_error] = STATE(1460),
    [sym_preproc_warning] = STATE(1460),
    [sym_preproc_define] = STATE(1460),
    [sym_preproc_undef] = STATE(1460),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1461] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3200),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7427),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1461),
    [sym_preproc_endregion] = STATE(1461),
    [sym_preproc_line] = STATE(1461),
    [sym_preproc_pragma] = STATE(1461),
    [sym_preproc_nullable] = STATE(1461),
    [sym_preproc_error] = STATE(1461),
    [sym_preproc_warning] = STATE(1461),
    [sym_preproc_define] = STATE(1461),
    [sym_preproc_undef] = STATE(1461),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_ref] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1353),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1462] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5922),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1462),
    [sym_preproc_endregion] = STATE(1462),
    [sym_preproc_line] = STATE(1462),
    [sym_preproc_pragma] = STATE(1462),
    [sym_preproc_nullable] = STATE(1462),
    [sym_preproc_error] = STATE(1462),
    [sym_preproc_warning] = STATE(1462),
    [sym_preproc_define] = STATE(1462),
    [sym_preproc_undef] = STATE(1462),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1463] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4362),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1463),
    [sym_preproc_endregion] = STATE(1463),
    [sym_preproc_line] = STATE(1463),
    [sym_preproc_pragma] = STATE(1463),
    [sym_preproc_nullable] = STATE(1463),
    [sym_preproc_error] = STATE(1463),
    [sym_preproc_warning] = STATE(1463),
    [sym_preproc_define] = STATE(1463),
    [sym_preproc_undef] = STATE(1463),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1464] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5947),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5500),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1464),
    [sym_preproc_endregion] = STATE(1464),
    [sym_preproc_line] = STATE(1464),
    [sym_preproc_pragma] = STATE(1464),
    [sym_preproc_nullable] = STATE(1464),
    [sym_preproc_error] = STATE(1464),
    [sym_preproc_warning] = STATE(1464),
    [sym_preproc_define] = STATE(1464),
    [sym_preproc_undef] = STATE(1464),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1465] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4514),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1465),
    [sym_preproc_endregion] = STATE(1465),
    [sym_preproc_line] = STATE(1465),
    [sym_preproc_pragma] = STATE(1465),
    [sym_preproc_nullable] = STATE(1465),
    [sym_preproc_error] = STATE(1465),
    [sym_preproc_warning] = STATE(1465),
    [sym_preproc_define] = STATE(1465),
    [sym_preproc_undef] = STATE(1465),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1466] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4154),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1466),
    [sym_preproc_endregion] = STATE(1466),
    [sym_preproc_line] = STATE(1466),
    [sym_preproc_pragma] = STATE(1466),
    [sym_preproc_nullable] = STATE(1466),
    [sym_preproc_error] = STATE(1466),
    [sym_preproc_warning] = STATE(1466),
    [sym_preproc_define] = STATE(1466),
    [sym_preproc_undef] = STATE(1466),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1467] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4393),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1467),
    [sym_preproc_endregion] = STATE(1467),
    [sym_preproc_line] = STATE(1467),
    [sym_preproc_pragma] = STATE(1467),
    [sym_preproc_nullable] = STATE(1467),
    [sym_preproc_error] = STATE(1467),
    [sym_preproc_warning] = STATE(1467),
    [sym_preproc_define] = STATE(1467),
    [sym_preproc_undef] = STATE(1467),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1468] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4109),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1468),
    [sym_preproc_endregion] = STATE(1468),
    [sym_preproc_line] = STATE(1468),
    [sym_preproc_pragma] = STATE(1468),
    [sym_preproc_nullable] = STATE(1468),
    [sym_preproc_error] = STATE(1468),
    [sym_preproc_warning] = STATE(1468),
    [sym_preproc_define] = STATE(1468),
    [sym_preproc_undef] = STATE(1468),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1469] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4113),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1469),
    [sym_preproc_endregion] = STATE(1469),
    [sym_preproc_line] = STATE(1469),
    [sym_preproc_pragma] = STATE(1469),
    [sym_preproc_nullable] = STATE(1469),
    [sym_preproc_error] = STATE(1469),
    [sym_preproc_warning] = STATE(1469),
    [sym_preproc_define] = STATE(1469),
    [sym_preproc_undef] = STATE(1469),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1470] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3510),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6226),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7540),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1470),
    [sym_preproc_endregion] = STATE(1470),
    [sym_preproc_line] = STATE(1470),
    [sym_preproc_pragma] = STATE(1470),
    [sym_preproc_nullable] = STATE(1470),
    [sym_preproc_error] = STATE(1470),
    [sym_preproc_warning] = STATE(1470),
    [sym_preproc_define] = STATE(1470),
    [sym_preproc_undef] = STATE(1470),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1471] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1471),
    [sym_preproc_endregion] = STATE(1471),
    [sym_preproc_line] = STATE(1471),
    [sym_preproc_pragma] = STATE(1471),
    [sym_preproc_nullable] = STATE(1471),
    [sym_preproc_error] = STATE(1471),
    [sym_preproc_warning] = STATE(1471),
    [sym_preproc_define] = STATE(1471),
    [sym_preproc_undef] = STATE(1471),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1472] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4122),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1472),
    [sym_preproc_endregion] = STATE(1472),
    [sym_preproc_line] = STATE(1472),
    [sym_preproc_pragma] = STATE(1472),
    [sym_preproc_nullable] = STATE(1472),
    [sym_preproc_error] = STATE(1472),
    [sym_preproc_warning] = STATE(1472),
    [sym_preproc_define] = STATE(1472),
    [sym_preproc_undef] = STATE(1472),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1473] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5255),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1473),
    [sym_preproc_endregion] = STATE(1473),
    [sym_preproc_line] = STATE(1473),
    [sym_preproc_pragma] = STATE(1473),
    [sym_preproc_nullable] = STATE(1473),
    [sym_preproc_error] = STATE(1473),
    [sym_preproc_warning] = STATE(1473),
    [sym_preproc_define] = STATE(1473),
    [sym_preproc_undef] = STATE(1473),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1474] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4124),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1474),
    [sym_preproc_endregion] = STATE(1474),
    [sym_preproc_line] = STATE(1474),
    [sym_preproc_pragma] = STATE(1474),
    [sym_preproc_nullable] = STATE(1474),
    [sym_preproc_error] = STATE(1474),
    [sym_preproc_warning] = STATE(1474),
    [sym_preproc_define] = STATE(1474),
    [sym_preproc_undef] = STATE(1474),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1475] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5327),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1475),
    [sym_preproc_endregion] = STATE(1475),
    [sym_preproc_line] = STATE(1475),
    [sym_preproc_pragma] = STATE(1475),
    [sym_preproc_nullable] = STATE(1475),
    [sym_preproc_error] = STATE(1475),
    [sym_preproc_warning] = STATE(1475),
    [sym_preproc_define] = STATE(1475),
    [sym_preproc_undef] = STATE(1475),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1476] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4125),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1476),
    [sym_preproc_endregion] = STATE(1476),
    [sym_preproc_line] = STATE(1476),
    [sym_preproc_pragma] = STATE(1476),
    [sym_preproc_nullable] = STATE(1476),
    [sym_preproc_error] = STATE(1476),
    [sym_preproc_warning] = STATE(1476),
    [sym_preproc_define] = STATE(1476),
    [sym_preproc_undef] = STATE(1476),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1477] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4131),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1477),
    [sym_preproc_endregion] = STATE(1477),
    [sym_preproc_line] = STATE(1477),
    [sym_preproc_pragma] = STATE(1477),
    [sym_preproc_nullable] = STATE(1477),
    [sym_preproc_error] = STATE(1477),
    [sym_preproc_warning] = STATE(1477),
    [sym_preproc_define] = STATE(1477),
    [sym_preproc_undef] = STATE(1477),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1478] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3575),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6216),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7577),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1478),
    [sym_preproc_endregion] = STATE(1478),
    [sym_preproc_line] = STATE(1478),
    [sym_preproc_pragma] = STATE(1478),
    [sym_preproc_nullable] = STATE(1478),
    [sym_preproc_error] = STATE(1478),
    [sym_preproc_warning] = STATE(1478),
    [sym_preproc_define] = STATE(1478),
    [sym_preproc_undef] = STATE(1478),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_ref] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1653),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1479] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1479),
    [sym_preproc_endregion] = STATE(1479),
    [sym_preproc_line] = STATE(1479),
    [sym_preproc_pragma] = STATE(1479),
    [sym_preproc_nullable] = STATE(1479),
    [sym_preproc_error] = STATE(1479),
    [sym_preproc_warning] = STATE(1479),
    [sym_preproc_define] = STATE(1479),
    [sym_preproc_undef] = STATE(1479),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1480] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4133),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1480),
    [sym_preproc_endregion] = STATE(1480),
    [sym_preproc_line] = STATE(1480),
    [sym_preproc_pragma] = STATE(1480),
    [sym_preproc_nullable] = STATE(1480),
    [sym_preproc_error] = STATE(1480),
    [sym_preproc_warning] = STATE(1480),
    [sym_preproc_define] = STATE(1480),
    [sym_preproc_undef] = STATE(1480),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1481] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4767),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1481),
    [sym_preproc_endregion] = STATE(1481),
    [sym_preproc_line] = STATE(1481),
    [sym_preproc_pragma] = STATE(1481),
    [sym_preproc_nullable] = STATE(1481),
    [sym_preproc_error] = STATE(1481),
    [sym_preproc_warning] = STATE(1481),
    [sym_preproc_define] = STATE(1481),
    [sym_preproc_undef] = STATE(1481),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1482] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5305),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1482),
    [sym_preproc_endregion] = STATE(1482),
    [sym_preproc_line] = STATE(1482),
    [sym_preproc_pragma] = STATE(1482),
    [sym_preproc_nullable] = STATE(1482),
    [sym_preproc_error] = STATE(1482),
    [sym_preproc_warning] = STATE(1482),
    [sym_preproc_define] = STATE(1482),
    [sym_preproc_undef] = STATE(1482),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1483] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4769),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1483),
    [sym_preproc_endregion] = STATE(1483),
    [sym_preproc_line] = STATE(1483),
    [sym_preproc_pragma] = STATE(1483),
    [sym_preproc_nullable] = STATE(1483),
    [sym_preproc_error] = STATE(1483),
    [sym_preproc_warning] = STATE(1483),
    [sym_preproc_define] = STATE(1483),
    [sym_preproc_undef] = STATE(1483),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1484] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4164),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1484),
    [sym_preproc_endregion] = STATE(1484),
    [sym_preproc_line] = STATE(1484),
    [sym_preproc_pragma] = STATE(1484),
    [sym_preproc_nullable] = STATE(1484),
    [sym_preproc_error] = STATE(1484),
    [sym_preproc_warning] = STATE(1484),
    [sym_preproc_define] = STATE(1484),
    [sym_preproc_undef] = STATE(1484),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1485] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4105),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1485),
    [sym_preproc_endregion] = STATE(1485),
    [sym_preproc_line] = STATE(1485),
    [sym_preproc_pragma] = STATE(1485),
    [sym_preproc_nullable] = STATE(1485),
    [sym_preproc_error] = STATE(1485),
    [sym_preproc_warning] = STATE(1485),
    [sym_preproc_define] = STATE(1485),
    [sym_preproc_undef] = STATE(1485),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1486] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1486),
    [sym_preproc_endregion] = STATE(1486),
    [sym_preproc_line] = STATE(1486),
    [sym_preproc_pragma] = STATE(1486),
    [sym_preproc_nullable] = STATE(1486),
    [sym_preproc_error] = STATE(1486),
    [sym_preproc_warning] = STATE(1486),
    [sym_preproc_define] = STATE(1486),
    [sym_preproc_undef] = STATE(1486),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1487] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1487),
    [sym_preproc_endregion] = STATE(1487),
    [sym_preproc_line] = STATE(1487),
    [sym_preproc_pragma] = STATE(1487),
    [sym_preproc_nullable] = STATE(1487),
    [sym_preproc_error] = STATE(1487),
    [sym_preproc_warning] = STATE(1487),
    [sym_preproc_define] = STATE(1487),
    [sym_preproc_undef] = STATE(1487),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1488] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4110),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1488),
    [sym_preproc_endregion] = STATE(1488),
    [sym_preproc_line] = STATE(1488),
    [sym_preproc_pragma] = STATE(1488),
    [sym_preproc_nullable] = STATE(1488),
    [sym_preproc_error] = STATE(1488),
    [sym_preproc_warning] = STATE(1488),
    [sym_preproc_define] = STATE(1488),
    [sym_preproc_undef] = STATE(1488),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1489] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4790),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1489),
    [sym_preproc_endregion] = STATE(1489),
    [sym_preproc_line] = STATE(1489),
    [sym_preproc_pragma] = STATE(1489),
    [sym_preproc_nullable] = STATE(1489),
    [sym_preproc_error] = STATE(1489),
    [sym_preproc_warning] = STATE(1489),
    [sym_preproc_define] = STATE(1489),
    [sym_preproc_undef] = STATE(1489),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1490] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5558),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1490),
    [sym_preproc_endregion] = STATE(1490),
    [sym_preproc_line] = STATE(1490),
    [sym_preproc_pragma] = STATE(1490),
    [sym_preproc_nullable] = STATE(1490),
    [sym_preproc_error] = STATE(1490),
    [sym_preproc_warning] = STATE(1490),
    [sym_preproc_define] = STATE(1490),
    [sym_preproc_undef] = STATE(1490),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1491] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4792),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1491),
    [sym_preproc_endregion] = STATE(1491),
    [sym_preproc_line] = STATE(1491),
    [sym_preproc_pragma] = STATE(1491),
    [sym_preproc_nullable] = STATE(1491),
    [sym_preproc_error] = STATE(1491),
    [sym_preproc_warning] = STATE(1491),
    [sym_preproc_define] = STATE(1491),
    [sym_preproc_undef] = STATE(1491),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1492] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4949),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1492),
    [sym_preproc_endregion] = STATE(1492),
    [sym_preproc_line] = STATE(1492),
    [sym_preproc_pragma] = STATE(1492),
    [sym_preproc_nullable] = STATE(1492),
    [sym_preproc_error] = STATE(1492),
    [sym_preproc_warning] = STATE(1492),
    [sym_preproc_define] = STATE(1492),
    [sym_preproc_undef] = STATE(1492),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1493] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3524),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7430),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1493),
    [sym_preproc_endregion] = STATE(1493),
    [sym_preproc_line] = STATE(1493),
    [sym_preproc_pragma] = STATE(1493),
    [sym_preproc_nullable] = STATE(1493),
    [sym_preproc_error] = STATE(1493),
    [sym_preproc_warning] = STATE(1493),
    [sym_preproc_define] = STATE(1493),
    [sym_preproc_undef] = STATE(1493),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_ref] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1494] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1494),
    [sym_preproc_endregion] = STATE(1494),
    [sym_preproc_line] = STATE(1494),
    [sym_preproc_pragma] = STATE(1494),
    [sym_preproc_nullable] = STATE(1494),
    [sym_preproc_error] = STATE(1494),
    [sym_preproc_warning] = STATE(1494),
    [sym_preproc_define] = STATE(1494),
    [sym_preproc_undef] = STATE(1494),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1495] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4805),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1495),
    [sym_preproc_endregion] = STATE(1495),
    [sym_preproc_line] = STATE(1495),
    [sym_preproc_pragma] = STATE(1495),
    [sym_preproc_nullable] = STATE(1495),
    [sym_preproc_error] = STATE(1495),
    [sym_preproc_warning] = STATE(1495),
    [sym_preproc_define] = STATE(1495),
    [sym_preproc_undef] = STATE(1495),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1496] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1496),
    [sym_preproc_endregion] = STATE(1496),
    [sym_preproc_line] = STATE(1496),
    [sym_preproc_pragma] = STATE(1496),
    [sym_preproc_nullable] = STATE(1496),
    [sym_preproc_error] = STATE(1496),
    [sym_preproc_warning] = STATE(1496),
    [sym_preproc_define] = STATE(1496),
    [sym_preproc_undef] = STATE(1496),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1497] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4806),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1497),
    [sym_preproc_endregion] = STATE(1497),
    [sym_preproc_line] = STATE(1497),
    [sym_preproc_pragma] = STATE(1497),
    [sym_preproc_nullable] = STATE(1497),
    [sym_preproc_error] = STATE(1497),
    [sym_preproc_warning] = STATE(1497),
    [sym_preproc_define] = STATE(1497),
    [sym_preproc_undef] = STATE(1497),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1498] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4460),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1498),
    [sym_preproc_endregion] = STATE(1498),
    [sym_preproc_line] = STATE(1498),
    [sym_preproc_pragma] = STATE(1498),
    [sym_preproc_nullable] = STATE(1498),
    [sym_preproc_error] = STATE(1498),
    [sym_preproc_warning] = STATE(1498),
    [sym_preproc_define] = STATE(1498),
    [sym_preproc_undef] = STATE(1498),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1499] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3163),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6238),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7781),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1499),
    [sym_preproc_endregion] = STATE(1499),
    [sym_preproc_line] = STATE(1499),
    [sym_preproc_pragma] = STATE(1499),
    [sym_preproc_nullable] = STATE(1499),
    [sym_preproc_error] = STATE(1499),
    [sym_preproc_warning] = STATE(1499),
    [sym_preproc_define] = STATE(1499),
    [sym_preproc_undef] = STATE(1499),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_ref] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_DOT_DOT] = ACTIONS(2157),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1500] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5718),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2948),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1500),
    [sym_preproc_endregion] = STATE(1500),
    [sym_preproc_line] = STATE(1500),
    [sym_preproc_pragma] = STATE(1500),
    [sym_preproc_nullable] = STATE(1500),
    [sym_preproc_error] = STATE(1500),
    [sym_preproc_warning] = STATE(1500),
    [sym_preproc_define] = STATE(1500),
    [sym_preproc_undef] = STATE(1500),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1501] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4741),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1501),
    [sym_preproc_endregion] = STATE(1501),
    [sym_preproc_line] = STATE(1501),
    [sym_preproc_pragma] = STATE(1501),
    [sym_preproc_nullable] = STATE(1501),
    [sym_preproc_error] = STATE(1501),
    [sym_preproc_warning] = STATE(1501),
    [sym_preproc_define] = STATE(1501),
    [sym_preproc_undef] = STATE(1501),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1502] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4744),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1502),
    [sym_preproc_endregion] = STATE(1502),
    [sym_preproc_line] = STATE(1502),
    [sym_preproc_pragma] = STATE(1502),
    [sym_preproc_nullable] = STATE(1502),
    [sym_preproc_error] = STATE(1502),
    [sym_preproc_warning] = STATE(1502),
    [sym_preproc_define] = STATE(1502),
    [sym_preproc_undef] = STATE(1502),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1503] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1503),
    [sym_preproc_endregion] = STATE(1503),
    [sym_preproc_line] = STATE(1503),
    [sym_preproc_pragma] = STATE(1503),
    [sym_preproc_nullable] = STATE(1503),
    [sym_preproc_error] = STATE(1503),
    [sym_preproc_warning] = STATE(1503),
    [sym_preproc_define] = STATE(1503),
    [sym_preproc_undef] = STATE(1503),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1504] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1504),
    [sym_preproc_endregion] = STATE(1504),
    [sym_preproc_line] = STATE(1504),
    [sym_preproc_pragma] = STATE(1504),
    [sym_preproc_nullable] = STATE(1504),
    [sym_preproc_error] = STATE(1504),
    [sym_preproc_warning] = STATE(1504),
    [sym_preproc_define] = STATE(1504),
    [sym_preproc_undef] = STATE(1504),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1505] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1505),
    [sym_preproc_endregion] = STATE(1505),
    [sym_preproc_line] = STATE(1505),
    [sym_preproc_pragma] = STATE(1505),
    [sym_preproc_nullable] = STATE(1505),
    [sym_preproc_error] = STATE(1505),
    [sym_preproc_warning] = STATE(1505),
    [sym_preproc_define] = STATE(1505),
    [sym_preproc_undef] = STATE(1505),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1506] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5940),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2348),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1506),
    [sym_preproc_endregion] = STATE(1506),
    [sym_preproc_line] = STATE(1506),
    [sym_preproc_pragma] = STATE(1506),
    [sym_preproc_nullable] = STATE(1506),
    [sym_preproc_error] = STATE(1506),
    [sym_preproc_warning] = STATE(1506),
    [sym_preproc_define] = STATE(1506),
    [sym_preproc_undef] = STATE(1506),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1507] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3630),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1507),
    [sym_preproc_endregion] = STATE(1507),
    [sym_preproc_line] = STATE(1507),
    [sym_preproc_pragma] = STATE(1507),
    [sym_preproc_nullable] = STATE(1507),
    [sym_preproc_error] = STATE(1507),
    [sym_preproc_warning] = STATE(1507),
    [sym_preproc_define] = STATE(1507),
    [sym_preproc_undef] = STATE(1507),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1508] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5949),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1508),
    [sym_preproc_endregion] = STATE(1508),
    [sym_preproc_line] = STATE(1508),
    [sym_preproc_pragma] = STATE(1508),
    [sym_preproc_nullable] = STATE(1508),
    [sym_preproc_error] = STATE(1508),
    [sym_preproc_warning] = STATE(1508),
    [sym_preproc_define] = STATE(1508),
    [sym_preproc_undef] = STATE(1508),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1651),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1509] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3582),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6222),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7647),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1509),
    [sym_preproc_endregion] = STATE(1509),
    [sym_preproc_line] = STATE(1509),
    [sym_preproc_pragma] = STATE(1509),
    [sym_preproc_nullable] = STATE(1509),
    [sym_preproc_error] = STATE(1509),
    [sym_preproc_warning] = STATE(1509),
    [sym_preproc_define] = STATE(1509),
    [sym_preproc_undef] = STATE(1509),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_ref] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1510] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1510),
    [sym_preproc_endregion] = STATE(1510),
    [sym_preproc_line] = STATE(1510),
    [sym_preproc_pragma] = STATE(1510),
    [sym_preproc_nullable] = STATE(1510),
    [sym_preproc_error] = STATE(1510),
    [sym_preproc_warning] = STATE(1510),
    [sym_preproc_define] = STATE(1510),
    [sym_preproc_undef] = STATE(1510),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1511] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5929),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3626),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6217),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7455),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1511),
    [sym_preproc_endregion] = STATE(1511),
    [sym_preproc_line] = STATE(1511),
    [sym_preproc_pragma] = STATE(1511),
    [sym_preproc_nullable] = STATE(1511),
    [sym_preproc_error] = STATE(1511),
    [sym_preproc_warning] = STATE(1511),
    [sym_preproc_define] = STATE(1511),
    [sym_preproc_undef] = STATE(1511),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_ref] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_DOT_DOT] = ACTIONS(2175),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1512] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1512),
    [sym_preproc_endregion] = STATE(1512),
    [sym_preproc_line] = STATE(1512),
    [sym_preproc_pragma] = STATE(1512),
    [sym_preproc_nullable] = STATE(1512),
    [sym_preproc_error] = STATE(1512),
    [sym_preproc_warning] = STATE(1512),
    [sym_preproc_define] = STATE(1512),
    [sym_preproc_undef] = STATE(1512),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1513] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1513),
    [sym_preproc_endregion] = STATE(1513),
    [sym_preproc_line] = STATE(1513),
    [sym_preproc_pragma] = STATE(1513),
    [sym_preproc_nullable] = STATE(1513),
    [sym_preproc_error] = STATE(1513),
    [sym_preproc_warning] = STATE(1513),
    [sym_preproc_define] = STATE(1513),
    [sym_preproc_undef] = STATE(1513),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1514] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1514),
    [sym_preproc_endregion] = STATE(1514),
    [sym_preproc_line] = STATE(1514),
    [sym_preproc_pragma] = STATE(1514),
    [sym_preproc_nullable] = STATE(1514),
    [sym_preproc_error] = STATE(1514),
    [sym_preproc_warning] = STATE(1514),
    [sym_preproc_define] = STATE(1514),
    [sym_preproc_undef] = STATE(1514),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1515] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1515),
    [sym_preproc_endregion] = STATE(1515),
    [sym_preproc_line] = STATE(1515),
    [sym_preproc_pragma] = STATE(1515),
    [sym_preproc_nullable] = STATE(1515),
    [sym_preproc_error] = STATE(1515),
    [sym_preproc_warning] = STATE(1515),
    [sym_preproc_define] = STATE(1515),
    [sym_preproc_undef] = STATE(1515),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1516] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1516),
    [sym_preproc_endregion] = STATE(1516),
    [sym_preproc_line] = STATE(1516),
    [sym_preproc_pragma] = STATE(1516),
    [sym_preproc_nullable] = STATE(1516),
    [sym_preproc_error] = STATE(1516),
    [sym_preproc_warning] = STATE(1516),
    [sym_preproc_define] = STATE(1516),
    [sym_preproc_undef] = STATE(1516),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1517] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3185),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6223),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7685),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1517),
    [sym_preproc_endregion] = STATE(1517),
    [sym_preproc_line] = STATE(1517),
    [sym_preproc_pragma] = STATE(1517),
    [sym_preproc_nullable] = STATE(1517),
    [sym_preproc_error] = STATE(1517),
    [sym_preproc_warning] = STATE(1517),
    [sym_preproc_define] = STATE(1517),
    [sym_preproc_undef] = STATE(1517),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_ref] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1371),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1518] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5956),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1518),
    [sym_preproc_endregion] = STATE(1518),
    [sym_preproc_line] = STATE(1518),
    [sym_preproc_pragma] = STATE(1518),
    [sym_preproc_nullable] = STATE(1518),
    [sym_preproc_error] = STATE(1518),
    [sym_preproc_warning] = STATE(1518),
    [sym_preproc_define] = STATE(1518),
    [sym_preproc_undef] = STATE(1518),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1519] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5932),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3329),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6201),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7668),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1519),
    [sym_preproc_endregion] = STATE(1519),
    [sym_preproc_line] = STATE(1519),
    [sym_preproc_pragma] = STATE(1519),
    [sym_preproc_nullable] = STATE(1519),
    [sym_preproc_error] = STATE(1519),
    [sym_preproc_warning] = STATE(1519),
    [sym_preproc_define] = STATE(1519),
    [sym_preproc_undef] = STATE(1519),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_ref] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_CARET] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1563),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1520] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1520),
    [sym_preproc_endregion] = STATE(1520),
    [sym_preproc_line] = STATE(1520),
    [sym_preproc_pragma] = STATE(1520),
    [sym_preproc_nullable] = STATE(1520),
    [sym_preproc_error] = STATE(1520),
    [sym_preproc_warning] = STATE(1520),
    [sym_preproc_define] = STATE(1520),
    [sym_preproc_undef] = STATE(1520),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1521] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3590),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6203),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7748),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1521),
    [sym_preproc_endregion] = STATE(1521),
    [sym_preproc_line] = STATE(1521),
    [sym_preproc_pragma] = STATE(1521),
    [sym_preproc_nullable] = STATE(1521),
    [sym_preproc_error] = STATE(1521),
    [sym_preproc_warning] = STATE(1521),
    [sym_preproc_define] = STATE(1521),
    [sym_preproc_undef] = STATE(1521),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_ref] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1871),
    [anon_sym_AMP] = ACTIONS(1871),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1875),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1522] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1522),
    [sym_preproc_endregion] = STATE(1522),
    [sym_preproc_line] = STATE(1522),
    [sym_preproc_pragma] = STATE(1522),
    [sym_preproc_nullable] = STATE(1522),
    [sym_preproc_error] = STATE(1522),
    [sym_preproc_warning] = STATE(1522),
    [sym_preproc_define] = STATE(1522),
    [sym_preproc_undef] = STATE(1522),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1523] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5933),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3634),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6228),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7702),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1523),
    [sym_preproc_endregion] = STATE(1523),
    [sym_preproc_line] = STATE(1523),
    [sym_preproc_pragma] = STATE(1523),
    [sym_preproc_nullable] = STATE(1523),
    [sym_preproc_error] = STATE(1523),
    [sym_preproc_warning] = STATE(1523),
    [sym_preproc_define] = STATE(1523),
    [sym_preproc_undef] = STATE(1523),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_ref] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2283),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2287),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2291),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1524] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1524),
    [sym_preproc_endregion] = STATE(1524),
    [sym_preproc_line] = STATE(1524),
    [sym_preproc_pragma] = STATE(1524),
    [sym_preproc_nullable] = STATE(1524),
    [sym_preproc_error] = STATE(1524),
    [sym_preproc_warning] = STATE(1524),
    [sym_preproc_define] = STATE(1524),
    [sym_preproc_undef] = STATE(1524),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1525] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1525),
    [sym_preproc_endregion] = STATE(1525),
    [sym_preproc_line] = STATE(1525),
    [sym_preproc_pragma] = STATE(1525),
    [sym_preproc_nullable] = STATE(1525),
    [sym_preproc_error] = STATE(1525),
    [sym_preproc_warning] = STATE(1525),
    [sym_preproc_define] = STATE(1525),
    [sym_preproc_undef] = STATE(1525),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1526] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5735),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2463),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1526),
    [sym_preproc_endregion] = STATE(1526),
    [sym_preproc_line] = STATE(1526),
    [sym_preproc_pragma] = STATE(1526),
    [sym_preproc_nullable] = STATE(1526),
    [sym_preproc_error] = STATE(1526),
    [sym_preproc_warning] = STATE(1526),
    [sym_preproc_define] = STATE(1526),
    [sym_preproc_undef] = STATE(1526),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1527] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5934),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3638),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6234),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7718),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1527),
    [sym_preproc_endregion] = STATE(1527),
    [sym_preproc_line] = STATE(1527),
    [sym_preproc_pragma] = STATE(1527),
    [sym_preproc_nullable] = STATE(1527),
    [sym_preproc_error] = STATE(1527),
    [sym_preproc_warning] = STATE(1527),
    [sym_preproc_define] = STATE(1527),
    [sym_preproc_undef] = STATE(1527),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_ref] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1528] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1528),
    [sym_preproc_endregion] = STATE(1528),
    [sym_preproc_line] = STATE(1528),
    [sym_preproc_pragma] = STATE(1528),
    [sym_preproc_nullable] = STATE(1528),
    [sym_preproc_error] = STATE(1528),
    [sym_preproc_warning] = STATE(1528),
    [sym_preproc_define] = STATE(1528),
    [sym_preproc_undef] = STATE(1528),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1529] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3511),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6232),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7769),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1529),
    [sym_preproc_endregion] = STATE(1529),
    [sym_preproc_line] = STATE(1529),
    [sym_preproc_pragma] = STATE(1529),
    [sym_preproc_nullable] = STATE(1529),
    [sym_preproc_error] = STATE(1529),
    [sym_preproc_warning] = STATE(1529),
    [sym_preproc_define] = STATE(1529),
    [sym_preproc_undef] = STATE(1529),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_ref] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1530] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1530),
    [sym_preproc_endregion] = STATE(1530),
    [sym_preproc_line] = STATE(1530),
    [sym_preproc_pragma] = STATE(1530),
    [sym_preproc_nullable] = STATE(1530),
    [sym_preproc_error] = STATE(1530),
    [sym_preproc_warning] = STATE(1530),
    [sym_preproc_define] = STATE(1530),
    [sym_preproc_undef] = STATE(1530),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1531] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5957),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2363),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3359),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6229),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7727),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1531),
    [sym_preproc_endregion] = STATE(1531),
    [sym_preproc_line] = STATE(1531),
    [sym_preproc_pragma] = STATE(1531),
    [sym_preproc_nullable] = STATE(1531),
    [sym_preproc_error] = STATE(1531),
    [sym_preproc_warning] = STATE(1531),
    [sym_preproc_define] = STATE(1531),
    [sym_preproc_undef] = STATE(1531),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1532] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5935),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2409),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1532),
    [sym_preproc_endregion] = STATE(1532),
    [sym_preproc_line] = STATE(1532),
    [sym_preproc_pragma] = STATE(1532),
    [sym_preproc_nullable] = STATE(1532),
    [sym_preproc_error] = STATE(1532),
    [sym_preproc_warning] = STATE(1532),
    [sym_preproc_define] = STATE(1532),
    [sym_preproc_undef] = STATE(1532),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1533] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3560),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6236),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7798),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1533),
    [sym_preproc_endregion] = STATE(1533),
    [sym_preproc_line] = STATE(1533),
    [sym_preproc_pragma] = STATE(1533),
    [sym_preproc_nullable] = STATE(1533),
    [sym_preproc_error] = STATE(1533),
    [sym_preproc_warning] = STATE(1533),
    [sym_preproc_define] = STATE(1533),
    [sym_preproc_undef] = STATE(1533),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_ref] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_TILDE] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1685),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1534] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5709),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1534),
    [sym_preproc_endregion] = STATE(1534),
    [sym_preproc_line] = STATE(1534),
    [sym_preproc_pragma] = STATE(1534),
    [sym_preproc_nullable] = STATE(1534),
    [sym_preproc_error] = STATE(1534),
    [sym_preproc_warning] = STATE(1534),
    [sym_preproc_define] = STATE(1534),
    [sym_preproc_undef] = STATE(1534),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1535] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3641),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6214),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7739),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1535),
    [sym_preproc_endregion] = STATE(1535),
    [sym_preproc_line] = STATE(1535),
    [sym_preproc_pragma] = STATE(1535),
    [sym_preproc_nullable] = STATE(1535),
    [sym_preproc_error] = STATE(1535),
    [sym_preproc_warning] = STATE(1535),
    [sym_preproc_define] = STATE(1535),
    [sym_preproc_undef] = STATE(1535),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_ref] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_DOT_DOT] = ACTIONS(2023),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1536] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1536),
    [sym_preproc_endregion] = STATE(1536),
    [sym_preproc_line] = STATE(1536),
    [sym_preproc_pragma] = STATE(1536),
    [sym_preproc_nullable] = STATE(1536),
    [sym_preproc_error] = STATE(1536),
    [sym_preproc_warning] = STATE(1536),
    [sym_preproc_define] = STATE(1536),
    [sym_preproc_undef] = STATE(1536),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1537] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5936),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2426),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3517),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6219),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7615),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1537),
    [sym_preproc_endregion] = STATE(1537),
    [sym_preproc_line] = STATE(1537),
    [sym_preproc_pragma] = STATE(1537),
    [sym_preproc_nullable] = STATE(1537),
    [sym_preproc_error] = STATE(1537),
    [sym_preproc_warning] = STATE(1537),
    [sym_preproc_define] = STATE(1537),
    [sym_preproc_undef] = STATE(1537),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_ref] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_CARET] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1927),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1935),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1538] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1538),
    [sym_preproc_endregion] = STATE(1538),
    [sym_preproc_line] = STATE(1538),
    [sym_preproc_pragma] = STATE(1538),
    [sym_preproc_nullable] = STATE(1538),
    [sym_preproc_error] = STATE(1538),
    [sym_preproc_warning] = STATE(1538),
    [sym_preproc_define] = STATE(1538),
    [sym_preproc_undef] = STATE(1538),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1539] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5937),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2430),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3523),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6208),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7787),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1539),
    [sym_preproc_endregion] = STATE(1539),
    [sym_preproc_line] = STATE(1539),
    [sym_preproc_pragma] = STATE(1539),
    [sym_preproc_nullable] = STATE(1539),
    [sym_preproc_error] = STATE(1539),
    [sym_preproc_warning] = STATE(1539),
    [sym_preproc_define] = STATE(1539),
    [sym_preproc_undef] = STATE(1539),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_ref] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1540] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5730),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2648),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1540),
    [sym_preproc_endregion] = STATE(1540),
    [sym_preproc_line] = STATE(1540),
    [sym_preproc_pragma] = STATE(1540),
    [sym_preproc_nullable] = STATE(1540),
    [sym_preproc_error] = STATE(1540),
    [sym_preproc_warning] = STATE(1540),
    [sym_preproc_define] = STATE(1540),
    [sym_preproc_undef] = STATE(1540),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1541] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3529),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6199),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7700),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1541),
    [sym_preproc_endregion] = STATE(1541),
    [sym_preproc_line] = STATE(1541),
    [sym_preproc_pragma] = STATE(1541),
    [sym_preproc_nullable] = STATE(1541),
    [sym_preproc_error] = STATE(1541),
    [sym_preproc_warning] = STATE(1541),
    [sym_preproc_define] = STATE(1541),
    [sym_preproc_undef] = STATE(1541),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1659),
    [anon_sym_ref] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1669),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_DOT_DOT] = ACTIONS(1673),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1542] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5034),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1542),
    [sym_preproc_endregion] = STATE(1542),
    [sym_preproc_line] = STATE(1542),
    [sym_preproc_pragma] = STATE(1542),
    [sym_preproc_nullable] = STATE(1542),
    [sym_preproc_error] = STATE(1542),
    [sym_preproc_warning] = STATE(1542),
    [sym_preproc_define] = STATE(1542),
    [sym_preproc_undef] = STATE(1542),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1543] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1543),
    [sym_preproc_endregion] = STATE(1543),
    [sym_preproc_line] = STATE(1543),
    [sym_preproc_pragma] = STATE(1543),
    [sym_preproc_nullable] = STATE(1543),
    [sym_preproc_error] = STATE(1543),
    [sym_preproc_warning] = STATE(1543),
    [sym_preproc_define] = STATE(1543),
    [sym_preproc_undef] = STATE(1543),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1544] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1544),
    [sym_preproc_endregion] = STATE(1544),
    [sym_preproc_line] = STATE(1544),
    [sym_preproc_pragma] = STATE(1544),
    [sym_preproc_nullable] = STATE(1544),
    [sym_preproc_error] = STATE(1544),
    [sym_preproc_warning] = STATE(1544),
    [sym_preproc_define] = STATE(1544),
    [sym_preproc_undef] = STATE(1544),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1545] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5348),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1545),
    [sym_preproc_endregion] = STATE(1545),
    [sym_preproc_line] = STATE(1545),
    [sym_preproc_pragma] = STATE(1545),
    [sym_preproc_nullable] = STATE(1545),
    [sym_preproc_error] = STATE(1545),
    [sym_preproc_warning] = STATE(1545),
    [sym_preproc_define] = STATE(1545),
    [sym_preproc_undef] = STATE(1545),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1546] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5503),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1546),
    [sym_preproc_endregion] = STATE(1546),
    [sym_preproc_line] = STATE(1546),
    [sym_preproc_pragma] = STATE(1546),
    [sym_preproc_nullable] = STATE(1546),
    [sym_preproc_error] = STATE(1546),
    [sym_preproc_warning] = STATE(1546),
    [sym_preproc_define] = STATE(1546),
    [sym_preproc_undef] = STATE(1546),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1547] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5407),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1547),
    [sym_preproc_endregion] = STATE(1547),
    [sym_preproc_line] = STATE(1547),
    [sym_preproc_pragma] = STATE(1547),
    [sym_preproc_nullable] = STATE(1547),
    [sym_preproc_error] = STATE(1547),
    [sym_preproc_warning] = STATE(1547),
    [sym_preproc_define] = STATE(1547),
    [sym_preproc_undef] = STATE(1547),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1548] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5408),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1548),
    [sym_preproc_endregion] = STATE(1548),
    [sym_preproc_line] = STATE(1548),
    [sym_preproc_pragma] = STATE(1548),
    [sym_preproc_nullable] = STATE(1548),
    [sym_preproc_error] = STATE(1548),
    [sym_preproc_warning] = STATE(1548),
    [sym_preproc_define] = STATE(1548),
    [sym_preproc_undef] = STATE(1548),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1549] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5409),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1549),
    [sym_preproc_endregion] = STATE(1549),
    [sym_preproc_line] = STATE(1549),
    [sym_preproc_pragma] = STATE(1549),
    [sym_preproc_nullable] = STATE(1549),
    [sym_preproc_error] = STATE(1549),
    [sym_preproc_warning] = STATE(1549),
    [sym_preproc_define] = STATE(1549),
    [sym_preproc_undef] = STATE(1549),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1550] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5371),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1550),
    [sym_preproc_endregion] = STATE(1550),
    [sym_preproc_line] = STATE(1550),
    [sym_preproc_pragma] = STATE(1550),
    [sym_preproc_nullable] = STATE(1550),
    [sym_preproc_error] = STATE(1550),
    [sym_preproc_warning] = STATE(1550),
    [sym_preproc_define] = STATE(1550),
    [sym_preproc_undef] = STATE(1550),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1551] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5412),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1551),
    [sym_preproc_endregion] = STATE(1551),
    [sym_preproc_line] = STATE(1551),
    [sym_preproc_pragma] = STATE(1551),
    [sym_preproc_nullable] = STATE(1551),
    [sym_preproc_error] = STATE(1551),
    [sym_preproc_warning] = STATE(1551),
    [sym_preproc_define] = STATE(1551),
    [sym_preproc_undef] = STATE(1551),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1552] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5413),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1552),
    [sym_preproc_endregion] = STATE(1552),
    [sym_preproc_line] = STATE(1552),
    [sym_preproc_pragma] = STATE(1552),
    [sym_preproc_nullable] = STATE(1552),
    [sym_preproc_error] = STATE(1552),
    [sym_preproc_warning] = STATE(1552),
    [sym_preproc_define] = STATE(1552),
    [sym_preproc_undef] = STATE(1552),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1553] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5414),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1553),
    [sym_preproc_endregion] = STATE(1553),
    [sym_preproc_line] = STATE(1553),
    [sym_preproc_pragma] = STATE(1553),
    [sym_preproc_nullable] = STATE(1553),
    [sym_preproc_error] = STATE(1553),
    [sym_preproc_warning] = STATE(1553),
    [sym_preproc_define] = STATE(1553),
    [sym_preproc_undef] = STATE(1553),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1554] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4361),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1554),
    [sym_preproc_endregion] = STATE(1554),
    [sym_preproc_line] = STATE(1554),
    [sym_preproc_pragma] = STATE(1554),
    [sym_preproc_nullable] = STATE(1554),
    [sym_preproc_error] = STATE(1554),
    [sym_preproc_warning] = STATE(1554),
    [sym_preproc_define] = STATE(1554),
    [sym_preproc_undef] = STATE(1554),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1555] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5440),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1555),
    [sym_preproc_endregion] = STATE(1555),
    [sym_preproc_line] = STATE(1555),
    [sym_preproc_pragma] = STATE(1555),
    [sym_preproc_nullable] = STATE(1555),
    [sym_preproc_error] = STATE(1555),
    [sym_preproc_warning] = STATE(1555),
    [sym_preproc_define] = STATE(1555),
    [sym_preproc_undef] = STATE(1555),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1556] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1556),
    [sym_preproc_endregion] = STATE(1556),
    [sym_preproc_line] = STATE(1556),
    [sym_preproc_pragma] = STATE(1556),
    [sym_preproc_nullable] = STATE(1556),
    [sym_preproc_error] = STATE(1556),
    [sym_preproc_warning] = STATE(1556),
    [sym_preproc_define] = STATE(1556),
    [sym_preproc_undef] = STATE(1556),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1557] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4893),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1557),
    [sym_preproc_endregion] = STATE(1557),
    [sym_preproc_line] = STATE(1557),
    [sym_preproc_pragma] = STATE(1557),
    [sym_preproc_nullable] = STATE(1557),
    [sym_preproc_error] = STATE(1557),
    [sym_preproc_warning] = STATE(1557),
    [sym_preproc_define] = STATE(1557),
    [sym_preproc_undef] = STATE(1557),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1558] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4894),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1558),
    [sym_preproc_endregion] = STATE(1558),
    [sym_preproc_line] = STATE(1558),
    [sym_preproc_pragma] = STATE(1558),
    [sym_preproc_nullable] = STATE(1558),
    [sym_preproc_error] = STATE(1558),
    [sym_preproc_warning] = STATE(1558),
    [sym_preproc_define] = STATE(1558),
    [sym_preproc_undef] = STATE(1558),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1559] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5036),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1559),
    [sym_preproc_endregion] = STATE(1559),
    [sym_preproc_line] = STATE(1559),
    [sym_preproc_pragma] = STATE(1559),
    [sym_preproc_nullable] = STATE(1559),
    [sym_preproc_error] = STATE(1559),
    [sym_preproc_warning] = STATE(1559),
    [sym_preproc_define] = STATE(1559),
    [sym_preproc_undef] = STATE(1559),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1560] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4895),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1560),
    [sym_preproc_endregion] = STATE(1560),
    [sym_preproc_line] = STATE(1560),
    [sym_preproc_pragma] = STATE(1560),
    [sym_preproc_nullable] = STATE(1560),
    [sym_preproc_error] = STATE(1560),
    [sym_preproc_warning] = STATE(1560),
    [sym_preproc_define] = STATE(1560),
    [sym_preproc_undef] = STATE(1560),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1561] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4896),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1561),
    [sym_preproc_endregion] = STATE(1561),
    [sym_preproc_line] = STATE(1561),
    [sym_preproc_pragma] = STATE(1561),
    [sym_preproc_nullable] = STATE(1561),
    [sym_preproc_error] = STATE(1561),
    [sym_preproc_warning] = STATE(1561),
    [sym_preproc_define] = STATE(1561),
    [sym_preproc_undef] = STATE(1561),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1562] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4897),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1562),
    [sym_preproc_endregion] = STATE(1562),
    [sym_preproc_line] = STATE(1562),
    [sym_preproc_pragma] = STATE(1562),
    [sym_preproc_nullable] = STATE(1562),
    [sym_preproc_error] = STATE(1562),
    [sym_preproc_warning] = STATE(1562),
    [sym_preproc_define] = STATE(1562),
    [sym_preproc_undef] = STATE(1562),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1563] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4898),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1563),
    [sym_preproc_endregion] = STATE(1563),
    [sym_preproc_line] = STATE(1563),
    [sym_preproc_pragma] = STATE(1563),
    [sym_preproc_nullable] = STATE(1563),
    [sym_preproc_error] = STATE(1563),
    [sym_preproc_warning] = STATE(1563),
    [sym_preproc_define] = STATE(1563),
    [sym_preproc_undef] = STATE(1563),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1564] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4899),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1564),
    [sym_preproc_endregion] = STATE(1564),
    [sym_preproc_line] = STATE(1564),
    [sym_preproc_pragma] = STATE(1564),
    [sym_preproc_nullable] = STATE(1564),
    [sym_preproc_error] = STATE(1564),
    [sym_preproc_warning] = STATE(1564),
    [sym_preproc_define] = STATE(1564),
    [sym_preproc_undef] = STATE(1564),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1565] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4900),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1565),
    [sym_preproc_endregion] = STATE(1565),
    [sym_preproc_line] = STATE(1565),
    [sym_preproc_pragma] = STATE(1565),
    [sym_preproc_nullable] = STATE(1565),
    [sym_preproc_error] = STATE(1565),
    [sym_preproc_warning] = STATE(1565),
    [sym_preproc_define] = STATE(1565),
    [sym_preproc_undef] = STATE(1565),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1566] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4137),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1566),
    [sym_preproc_endregion] = STATE(1566),
    [sym_preproc_line] = STATE(1566),
    [sym_preproc_pragma] = STATE(1566),
    [sym_preproc_nullable] = STATE(1566),
    [sym_preproc_error] = STATE(1566),
    [sym_preproc_warning] = STATE(1566),
    [sym_preproc_define] = STATE(1566),
    [sym_preproc_undef] = STATE(1566),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1567] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4134),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1567),
    [sym_preproc_endregion] = STATE(1567),
    [sym_preproc_line] = STATE(1567),
    [sym_preproc_pragma] = STATE(1567),
    [sym_preproc_nullable] = STATE(1567),
    [sym_preproc_error] = STATE(1567),
    [sym_preproc_warning] = STATE(1567),
    [sym_preproc_define] = STATE(1567),
    [sym_preproc_undef] = STATE(1567),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1568] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4954),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1568),
    [sym_preproc_endregion] = STATE(1568),
    [sym_preproc_line] = STATE(1568),
    [sym_preproc_pragma] = STATE(1568),
    [sym_preproc_nullable] = STATE(1568),
    [sym_preproc_error] = STATE(1568),
    [sym_preproc_warning] = STATE(1568),
    [sym_preproc_define] = STATE(1568),
    [sym_preproc_undef] = STATE(1568),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1569] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4955),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1569),
    [sym_preproc_endregion] = STATE(1569),
    [sym_preproc_line] = STATE(1569),
    [sym_preproc_pragma] = STATE(1569),
    [sym_preproc_nullable] = STATE(1569),
    [sym_preproc_error] = STATE(1569),
    [sym_preproc_warning] = STATE(1569),
    [sym_preproc_define] = STATE(1569),
    [sym_preproc_undef] = STATE(1569),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1570] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5078),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1570),
    [sym_preproc_endregion] = STATE(1570),
    [sym_preproc_line] = STATE(1570),
    [sym_preproc_pragma] = STATE(1570),
    [sym_preproc_nullable] = STATE(1570),
    [sym_preproc_error] = STATE(1570),
    [sym_preproc_warning] = STATE(1570),
    [sym_preproc_define] = STATE(1570),
    [sym_preproc_undef] = STATE(1570),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1571] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4956),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1571),
    [sym_preproc_endregion] = STATE(1571),
    [sym_preproc_line] = STATE(1571),
    [sym_preproc_pragma] = STATE(1571),
    [sym_preproc_nullable] = STATE(1571),
    [sym_preproc_error] = STATE(1571),
    [sym_preproc_warning] = STATE(1571),
    [sym_preproc_define] = STATE(1571),
    [sym_preproc_undef] = STATE(1571),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1572] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4957),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1572),
    [sym_preproc_endregion] = STATE(1572),
    [sym_preproc_line] = STATE(1572),
    [sym_preproc_pragma] = STATE(1572),
    [sym_preproc_nullable] = STATE(1572),
    [sym_preproc_error] = STATE(1572),
    [sym_preproc_warning] = STATE(1572),
    [sym_preproc_define] = STATE(1572),
    [sym_preproc_undef] = STATE(1572),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1573] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4958),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1573),
    [sym_preproc_endregion] = STATE(1573),
    [sym_preproc_line] = STATE(1573),
    [sym_preproc_pragma] = STATE(1573),
    [sym_preproc_nullable] = STATE(1573),
    [sym_preproc_error] = STATE(1573),
    [sym_preproc_warning] = STATE(1573),
    [sym_preproc_define] = STATE(1573),
    [sym_preproc_undef] = STATE(1573),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1574] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4889),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1574),
    [sym_preproc_endregion] = STATE(1574),
    [sym_preproc_line] = STATE(1574),
    [sym_preproc_pragma] = STATE(1574),
    [sym_preproc_nullable] = STATE(1574),
    [sym_preproc_error] = STATE(1574),
    [sym_preproc_warning] = STATE(1574),
    [sym_preproc_define] = STATE(1574),
    [sym_preproc_undef] = STATE(1574),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1575] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4960),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1575),
    [sym_preproc_endregion] = STATE(1575),
    [sym_preproc_line] = STATE(1575),
    [sym_preproc_pragma] = STATE(1575),
    [sym_preproc_nullable] = STATE(1575),
    [sym_preproc_error] = STATE(1575),
    [sym_preproc_warning] = STATE(1575),
    [sym_preproc_define] = STATE(1575),
    [sym_preproc_undef] = STATE(1575),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1576] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4961),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1576),
    [sym_preproc_endregion] = STATE(1576),
    [sym_preproc_line] = STATE(1576),
    [sym_preproc_pragma] = STATE(1576),
    [sym_preproc_nullable] = STATE(1576),
    [sym_preproc_error] = STATE(1576),
    [sym_preproc_warning] = STATE(1576),
    [sym_preproc_define] = STATE(1576),
    [sym_preproc_undef] = STATE(1576),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1577] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4962),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1577),
    [sym_preproc_endregion] = STATE(1577),
    [sym_preproc_line] = STATE(1577),
    [sym_preproc_pragma] = STATE(1577),
    [sym_preproc_nullable] = STATE(1577),
    [sym_preproc_error] = STATE(1577),
    [sym_preproc_warning] = STATE(1577),
    [sym_preproc_define] = STATE(1577),
    [sym_preproc_undef] = STATE(1577),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1578] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4963),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1578),
    [sym_preproc_endregion] = STATE(1578),
    [sym_preproc_line] = STATE(1578),
    [sym_preproc_pragma] = STATE(1578),
    [sym_preproc_nullable] = STATE(1578),
    [sym_preproc_error] = STATE(1578),
    [sym_preproc_warning] = STATE(1578),
    [sym_preproc_define] = STATE(1578),
    [sym_preproc_undef] = STATE(1578),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1579] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4158),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1579),
    [sym_preproc_endregion] = STATE(1579),
    [sym_preproc_line] = STATE(1579),
    [sym_preproc_pragma] = STATE(1579),
    [sym_preproc_nullable] = STATE(1579),
    [sym_preproc_error] = STATE(1579),
    [sym_preproc_warning] = STATE(1579),
    [sym_preproc_define] = STATE(1579),
    [sym_preproc_undef] = STATE(1579),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1580] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4903),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1580),
    [sym_preproc_endregion] = STATE(1580),
    [sym_preproc_line] = STATE(1580),
    [sym_preproc_pragma] = STATE(1580),
    [sym_preproc_nullable] = STATE(1580),
    [sym_preproc_error] = STATE(1580),
    [sym_preproc_warning] = STATE(1580),
    [sym_preproc_define] = STATE(1580),
    [sym_preproc_undef] = STATE(1580),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1581] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1581),
    [sym_preproc_endregion] = STATE(1581),
    [sym_preproc_line] = STATE(1581),
    [sym_preproc_pragma] = STATE(1581),
    [sym_preproc_nullable] = STATE(1581),
    [sym_preproc_error] = STATE(1581),
    [sym_preproc_warning] = STATE(1581),
    [sym_preproc_define] = STATE(1581),
    [sym_preproc_undef] = STATE(1581),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1582] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4165),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1582),
    [sym_preproc_endregion] = STATE(1582),
    [sym_preproc_line] = STATE(1582),
    [sym_preproc_pragma] = STATE(1582),
    [sym_preproc_nullable] = STATE(1582),
    [sym_preproc_error] = STATE(1582),
    [sym_preproc_warning] = STATE(1582),
    [sym_preproc_define] = STATE(1582),
    [sym_preproc_undef] = STATE(1582),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1583] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3713),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1583),
    [sym_preproc_endregion] = STATE(1583),
    [sym_preproc_line] = STATE(1583),
    [sym_preproc_pragma] = STATE(1583),
    [sym_preproc_nullable] = STATE(1583),
    [sym_preproc_error] = STATE(1583),
    [sym_preproc_warning] = STATE(1583),
    [sym_preproc_define] = STATE(1583),
    [sym_preproc_undef] = STATE(1583),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1584] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3597),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1584),
    [sym_preproc_endregion] = STATE(1584),
    [sym_preproc_line] = STATE(1584),
    [sym_preproc_pragma] = STATE(1584),
    [sym_preproc_nullable] = STATE(1584),
    [sym_preproc_error] = STATE(1584),
    [sym_preproc_warning] = STATE(1584),
    [sym_preproc_define] = STATE(1584),
    [sym_preproc_undef] = STATE(1584),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1585] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4156),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1585),
    [sym_preproc_endregion] = STATE(1585),
    [sym_preproc_line] = STATE(1585),
    [sym_preproc_pragma] = STATE(1585),
    [sym_preproc_nullable] = STATE(1585),
    [sym_preproc_error] = STATE(1585),
    [sym_preproc_warning] = STATE(1585),
    [sym_preproc_define] = STATE(1585),
    [sym_preproc_undef] = STATE(1585),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1586] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4157),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1586),
    [sym_preproc_endregion] = STATE(1586),
    [sym_preproc_line] = STATE(1586),
    [sym_preproc_pragma] = STATE(1586),
    [sym_preproc_nullable] = STATE(1586),
    [sym_preproc_error] = STATE(1586),
    [sym_preproc_warning] = STATE(1586),
    [sym_preproc_define] = STATE(1586),
    [sym_preproc_undef] = STATE(1586),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1587] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4159),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1587),
    [sym_preproc_endregion] = STATE(1587),
    [sym_preproc_line] = STATE(1587),
    [sym_preproc_pragma] = STATE(1587),
    [sym_preproc_nullable] = STATE(1587),
    [sym_preproc_error] = STATE(1587),
    [sym_preproc_warning] = STATE(1587),
    [sym_preproc_define] = STATE(1587),
    [sym_preproc_undef] = STATE(1587),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1588] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4114),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1588),
    [sym_preproc_endregion] = STATE(1588),
    [sym_preproc_line] = STATE(1588),
    [sym_preproc_pragma] = STATE(1588),
    [sym_preproc_nullable] = STATE(1588),
    [sym_preproc_error] = STATE(1588),
    [sym_preproc_warning] = STATE(1588),
    [sym_preproc_define] = STATE(1588),
    [sym_preproc_undef] = STATE(1588),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1589] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4115),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1589),
    [sym_preproc_endregion] = STATE(1589),
    [sym_preproc_line] = STATE(1589),
    [sym_preproc_pragma] = STATE(1589),
    [sym_preproc_nullable] = STATE(1589),
    [sym_preproc_error] = STATE(1589),
    [sym_preproc_warning] = STATE(1589),
    [sym_preproc_define] = STATE(1589),
    [sym_preproc_undef] = STATE(1589),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1590] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4128),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1590),
    [sym_preproc_endregion] = STATE(1590),
    [sym_preproc_line] = STATE(1590),
    [sym_preproc_pragma] = STATE(1590),
    [sym_preproc_nullable] = STATE(1590),
    [sym_preproc_error] = STATE(1590),
    [sym_preproc_warning] = STATE(1590),
    [sym_preproc_define] = STATE(1590),
    [sym_preproc_undef] = STATE(1590),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1591] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4160),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1591),
    [sym_preproc_endregion] = STATE(1591),
    [sym_preproc_line] = STATE(1591),
    [sym_preproc_pragma] = STATE(1591),
    [sym_preproc_nullable] = STATE(1591),
    [sym_preproc_error] = STATE(1591),
    [sym_preproc_warning] = STATE(1591),
    [sym_preproc_define] = STATE(1591),
    [sym_preproc_undef] = STATE(1591),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1592] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4120),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1592),
    [sym_preproc_endregion] = STATE(1592),
    [sym_preproc_line] = STATE(1592),
    [sym_preproc_pragma] = STATE(1592),
    [sym_preproc_nullable] = STATE(1592),
    [sym_preproc_error] = STATE(1592),
    [sym_preproc_warning] = STATE(1592),
    [sym_preproc_define] = STATE(1592),
    [sym_preproc_undef] = STATE(1592),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1593] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4915),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1593),
    [sym_preproc_endregion] = STATE(1593),
    [sym_preproc_line] = STATE(1593),
    [sym_preproc_pragma] = STATE(1593),
    [sym_preproc_nullable] = STATE(1593),
    [sym_preproc_error] = STATE(1593),
    [sym_preproc_warning] = STATE(1593),
    [sym_preproc_define] = STATE(1593),
    [sym_preproc_undef] = STATE(1593),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1594] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4140),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1594),
    [sym_preproc_endregion] = STATE(1594),
    [sym_preproc_line] = STATE(1594),
    [sym_preproc_pragma] = STATE(1594),
    [sym_preproc_nullable] = STATE(1594),
    [sym_preproc_error] = STATE(1594),
    [sym_preproc_warning] = STATE(1594),
    [sym_preproc_define] = STATE(1594),
    [sym_preproc_undef] = STATE(1594),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1595] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4142),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1595),
    [sym_preproc_endregion] = STATE(1595),
    [sym_preproc_line] = STATE(1595),
    [sym_preproc_pragma] = STATE(1595),
    [sym_preproc_nullable] = STATE(1595),
    [sym_preproc_error] = STATE(1595),
    [sym_preproc_warning] = STATE(1595),
    [sym_preproc_define] = STATE(1595),
    [sym_preproc_undef] = STATE(1595),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1596] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4106),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1596),
    [sym_preproc_endregion] = STATE(1596),
    [sym_preproc_line] = STATE(1596),
    [sym_preproc_pragma] = STATE(1596),
    [sym_preproc_nullable] = STATE(1596),
    [sym_preproc_error] = STATE(1596),
    [sym_preproc_warning] = STATE(1596),
    [sym_preproc_define] = STATE(1596),
    [sym_preproc_undef] = STATE(1596),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1597] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3706),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1597),
    [sym_preproc_endregion] = STATE(1597),
    [sym_preproc_line] = STATE(1597),
    [sym_preproc_pragma] = STATE(1597),
    [sym_preproc_nullable] = STATE(1597),
    [sym_preproc_error] = STATE(1597),
    [sym_preproc_warning] = STATE(1597),
    [sym_preproc_define] = STATE(1597),
    [sym_preproc_undef] = STATE(1597),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1598] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4922),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1598),
    [sym_preproc_endregion] = STATE(1598),
    [sym_preproc_line] = STATE(1598),
    [sym_preproc_pragma] = STATE(1598),
    [sym_preproc_nullable] = STATE(1598),
    [sym_preproc_error] = STATE(1598),
    [sym_preproc_warning] = STATE(1598),
    [sym_preproc_define] = STATE(1598),
    [sym_preproc_undef] = STATE(1598),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1599] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4136),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1599),
    [sym_preproc_endregion] = STATE(1599),
    [sym_preproc_line] = STATE(1599),
    [sym_preproc_pragma] = STATE(1599),
    [sym_preproc_nullable] = STATE(1599),
    [sym_preproc_error] = STATE(1599),
    [sym_preproc_warning] = STATE(1599),
    [sym_preproc_define] = STATE(1599),
    [sym_preproc_undef] = STATE(1599),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1600] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4331),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1600),
    [sym_preproc_endregion] = STATE(1600),
    [sym_preproc_line] = STATE(1600),
    [sym_preproc_pragma] = STATE(1600),
    [sym_preproc_nullable] = STATE(1600),
    [sym_preproc_error] = STATE(1600),
    [sym_preproc_warning] = STATE(1600),
    [sym_preproc_define] = STATE(1600),
    [sym_preproc_undef] = STATE(1600),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1601] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3695),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1601),
    [sym_preproc_endregion] = STATE(1601),
    [sym_preproc_line] = STATE(1601),
    [sym_preproc_pragma] = STATE(1601),
    [sym_preproc_nullable] = STATE(1601),
    [sym_preproc_error] = STATE(1601),
    [sym_preproc_warning] = STATE(1601),
    [sym_preproc_define] = STATE(1601),
    [sym_preproc_undef] = STATE(1601),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1602] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5506),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1602),
    [sym_preproc_endregion] = STATE(1602),
    [sym_preproc_line] = STATE(1602),
    [sym_preproc_pragma] = STATE(1602),
    [sym_preproc_nullable] = STATE(1602),
    [sym_preproc_error] = STATE(1602),
    [sym_preproc_warning] = STATE(1602),
    [sym_preproc_define] = STATE(1602),
    [sym_preproc_undef] = STATE(1602),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1603] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4363),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1603),
    [sym_preproc_endregion] = STATE(1603),
    [sym_preproc_line] = STATE(1603),
    [sym_preproc_pragma] = STATE(1603),
    [sym_preproc_nullable] = STATE(1603),
    [sym_preproc_error] = STATE(1603),
    [sym_preproc_warning] = STATE(1603),
    [sym_preproc_define] = STATE(1603),
    [sym_preproc_undef] = STATE(1603),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1604] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3715),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1604),
    [sym_preproc_endregion] = STATE(1604),
    [sym_preproc_line] = STATE(1604),
    [sym_preproc_pragma] = STATE(1604),
    [sym_preproc_nullable] = STATE(1604),
    [sym_preproc_error] = STATE(1604),
    [sym_preproc_warning] = STATE(1604),
    [sym_preproc_define] = STATE(1604),
    [sym_preproc_undef] = STATE(1604),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1605] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3716),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1605),
    [sym_preproc_endregion] = STATE(1605),
    [sym_preproc_line] = STATE(1605),
    [sym_preproc_pragma] = STATE(1605),
    [sym_preproc_nullable] = STATE(1605),
    [sym_preproc_error] = STATE(1605),
    [sym_preproc_warning] = STATE(1605),
    [sym_preproc_define] = STATE(1605),
    [sym_preproc_undef] = STATE(1605),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1606] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3717),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1606),
    [sym_preproc_endregion] = STATE(1606),
    [sym_preproc_line] = STATE(1606),
    [sym_preproc_pragma] = STATE(1606),
    [sym_preproc_nullable] = STATE(1606),
    [sym_preproc_error] = STATE(1606),
    [sym_preproc_warning] = STATE(1606),
    [sym_preproc_define] = STATE(1606),
    [sym_preproc_undef] = STATE(1606),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1607] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3722),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1607),
    [sym_preproc_endregion] = STATE(1607),
    [sym_preproc_line] = STATE(1607),
    [sym_preproc_pragma] = STATE(1607),
    [sym_preproc_nullable] = STATE(1607),
    [sym_preproc_error] = STATE(1607),
    [sym_preproc_warning] = STATE(1607),
    [sym_preproc_define] = STATE(1607),
    [sym_preproc_undef] = STATE(1607),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1608] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3726),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1608),
    [sym_preproc_endregion] = STATE(1608),
    [sym_preproc_line] = STATE(1608),
    [sym_preproc_pragma] = STATE(1608),
    [sym_preproc_nullable] = STATE(1608),
    [sym_preproc_error] = STATE(1608),
    [sym_preproc_warning] = STATE(1608),
    [sym_preproc_define] = STATE(1608),
    [sym_preproc_undef] = STATE(1608),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1609] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3727),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1609),
    [sym_preproc_endregion] = STATE(1609),
    [sym_preproc_line] = STATE(1609),
    [sym_preproc_pragma] = STATE(1609),
    [sym_preproc_nullable] = STATE(1609),
    [sym_preproc_error] = STATE(1609),
    [sym_preproc_warning] = STATE(1609),
    [sym_preproc_define] = STATE(1609),
    [sym_preproc_undef] = STATE(1609),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1610] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3689),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1610),
    [sym_preproc_endregion] = STATE(1610),
    [sym_preproc_line] = STATE(1610),
    [sym_preproc_pragma] = STATE(1610),
    [sym_preproc_nullable] = STATE(1610),
    [sym_preproc_error] = STATE(1610),
    [sym_preproc_warning] = STATE(1610),
    [sym_preproc_define] = STATE(1610),
    [sym_preproc_undef] = STATE(1610),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1611] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3732),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1611),
    [sym_preproc_endregion] = STATE(1611),
    [sym_preproc_line] = STATE(1611),
    [sym_preproc_pragma] = STATE(1611),
    [sym_preproc_nullable] = STATE(1611),
    [sym_preproc_error] = STATE(1611),
    [sym_preproc_warning] = STATE(1611),
    [sym_preproc_define] = STATE(1611),
    [sym_preproc_undef] = STATE(1611),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1612] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3733),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1612),
    [sym_preproc_endregion] = STATE(1612),
    [sym_preproc_line] = STATE(1612),
    [sym_preproc_pragma] = STATE(1612),
    [sym_preproc_nullable] = STATE(1612),
    [sym_preproc_error] = STATE(1612),
    [sym_preproc_warning] = STATE(1612),
    [sym_preproc_define] = STATE(1612),
    [sym_preproc_undef] = STATE(1612),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1613] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3690),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1613),
    [sym_preproc_endregion] = STATE(1613),
    [sym_preproc_line] = STATE(1613),
    [sym_preproc_pragma] = STATE(1613),
    [sym_preproc_nullable] = STATE(1613),
    [sym_preproc_error] = STATE(1613),
    [sym_preproc_warning] = STATE(1613),
    [sym_preproc_define] = STATE(1613),
    [sym_preproc_undef] = STATE(1613),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1614] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3691),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1614),
    [sym_preproc_endregion] = STATE(1614),
    [sym_preproc_line] = STATE(1614),
    [sym_preproc_pragma] = STATE(1614),
    [sym_preproc_nullable] = STATE(1614),
    [sym_preproc_error] = STATE(1614),
    [sym_preproc_warning] = STATE(1614),
    [sym_preproc_define] = STATE(1614),
    [sym_preproc_undef] = STATE(1614),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1615] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3680),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1615),
    [sym_preproc_endregion] = STATE(1615),
    [sym_preproc_line] = STATE(1615),
    [sym_preproc_pragma] = STATE(1615),
    [sym_preproc_nullable] = STATE(1615),
    [sym_preproc_error] = STATE(1615),
    [sym_preproc_warning] = STATE(1615),
    [sym_preproc_define] = STATE(1615),
    [sym_preproc_undef] = STATE(1615),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1616] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4444),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1616),
    [sym_preproc_endregion] = STATE(1616),
    [sym_preproc_line] = STATE(1616),
    [sym_preproc_pragma] = STATE(1616),
    [sym_preproc_nullable] = STATE(1616),
    [sym_preproc_error] = STATE(1616),
    [sym_preproc_warning] = STATE(1616),
    [sym_preproc_define] = STATE(1616),
    [sym_preproc_undef] = STATE(1616),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1617] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4362),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1617),
    [sym_preproc_endregion] = STATE(1617),
    [sym_preproc_line] = STATE(1617),
    [sym_preproc_pragma] = STATE(1617),
    [sym_preproc_nullable] = STATE(1617),
    [sym_preproc_error] = STATE(1617),
    [sym_preproc_warning] = STATE(1617),
    [sym_preproc_define] = STATE(1617),
    [sym_preproc_undef] = STATE(1617),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1618] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4050),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1618),
    [sym_preproc_endregion] = STATE(1618),
    [sym_preproc_line] = STATE(1618),
    [sym_preproc_pragma] = STATE(1618),
    [sym_preproc_nullable] = STATE(1618),
    [sym_preproc_error] = STATE(1618),
    [sym_preproc_warning] = STATE(1618),
    [sym_preproc_define] = STATE(1618),
    [sym_preproc_undef] = STATE(1618),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1619] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4421),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1619),
    [sym_preproc_endregion] = STATE(1619),
    [sym_preproc_line] = STATE(1619),
    [sym_preproc_pragma] = STATE(1619),
    [sym_preproc_nullable] = STATE(1619),
    [sym_preproc_error] = STATE(1619),
    [sym_preproc_warning] = STATE(1619),
    [sym_preproc_define] = STATE(1619),
    [sym_preproc_undef] = STATE(1619),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1620] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4427),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1620),
    [sym_preproc_endregion] = STATE(1620),
    [sym_preproc_line] = STATE(1620),
    [sym_preproc_pragma] = STATE(1620),
    [sym_preproc_nullable] = STATE(1620),
    [sym_preproc_error] = STATE(1620),
    [sym_preproc_warning] = STATE(1620),
    [sym_preproc_define] = STATE(1620),
    [sym_preproc_undef] = STATE(1620),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1621] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4326),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3250),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7605),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1621),
    [sym_preproc_endregion] = STATE(1621),
    [sym_preproc_line] = STATE(1621),
    [sym_preproc_pragma] = STATE(1621),
    [sym_preproc_nullable] = STATE(1621),
    [sym_preproc_error] = STATE(1621),
    [sym_preproc_warning] = STATE(1621),
    [sym_preproc_define] = STATE(1621),
    [sym_preproc_undef] = STATE(1621),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1375),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1622] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4974),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1622),
    [sym_preproc_endregion] = STATE(1622),
    [sym_preproc_line] = STATE(1622),
    [sym_preproc_pragma] = STATE(1622),
    [sym_preproc_nullable] = STATE(1622),
    [sym_preproc_error] = STATE(1622),
    [sym_preproc_warning] = STATE(1622),
    [sym_preproc_define] = STATE(1622),
    [sym_preproc_undef] = STATE(1622),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1623] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3222),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1623),
    [sym_preproc_endregion] = STATE(1623),
    [sym_preproc_line] = STATE(1623),
    [sym_preproc_pragma] = STATE(1623),
    [sym_preproc_nullable] = STATE(1623),
    [sym_preproc_error] = STATE(1623),
    [sym_preproc_warning] = STATE(1623),
    [sym_preproc_define] = STATE(1623),
    [sym_preproc_undef] = STATE(1623),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1624] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4467),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1624),
    [sym_preproc_endregion] = STATE(1624),
    [sym_preproc_line] = STATE(1624),
    [sym_preproc_pragma] = STATE(1624),
    [sym_preproc_nullable] = STATE(1624),
    [sym_preproc_error] = STATE(1624),
    [sym_preproc_warning] = STATE(1624),
    [sym_preproc_define] = STATE(1624),
    [sym_preproc_undef] = STATE(1624),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1625] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4468),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1625),
    [sym_preproc_endregion] = STATE(1625),
    [sym_preproc_line] = STATE(1625),
    [sym_preproc_pragma] = STATE(1625),
    [sym_preproc_nullable] = STATE(1625),
    [sym_preproc_error] = STATE(1625),
    [sym_preproc_warning] = STATE(1625),
    [sym_preproc_define] = STATE(1625),
    [sym_preproc_undef] = STATE(1625),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1626] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4469),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1626),
    [sym_preproc_endregion] = STATE(1626),
    [sym_preproc_line] = STATE(1626),
    [sym_preproc_pragma] = STATE(1626),
    [sym_preproc_nullable] = STATE(1626),
    [sym_preproc_error] = STATE(1626),
    [sym_preproc_warning] = STATE(1626),
    [sym_preproc_define] = STATE(1626),
    [sym_preproc_undef] = STATE(1626),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1627] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4471),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1627),
    [sym_preproc_endregion] = STATE(1627),
    [sym_preproc_line] = STATE(1627),
    [sym_preproc_pragma] = STATE(1627),
    [sym_preproc_nullable] = STATE(1627),
    [sym_preproc_error] = STATE(1627),
    [sym_preproc_warning] = STATE(1627),
    [sym_preproc_define] = STATE(1627),
    [sym_preproc_undef] = STATE(1627),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1628] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4501),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1628),
    [sym_preproc_endregion] = STATE(1628),
    [sym_preproc_line] = STATE(1628),
    [sym_preproc_pragma] = STATE(1628),
    [sym_preproc_nullable] = STATE(1628),
    [sym_preproc_error] = STATE(1628),
    [sym_preproc_warning] = STATE(1628),
    [sym_preproc_define] = STATE(1628),
    [sym_preproc_undef] = STATE(1628),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1629] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4396),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1629),
    [sym_preproc_endregion] = STATE(1629),
    [sym_preproc_line] = STATE(1629),
    [sym_preproc_pragma] = STATE(1629),
    [sym_preproc_nullable] = STATE(1629),
    [sym_preproc_error] = STATE(1629),
    [sym_preproc_warning] = STATE(1629),
    [sym_preproc_define] = STATE(1629),
    [sym_preproc_undef] = STATE(1629),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1630] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4482),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1630),
    [sym_preproc_endregion] = STATE(1630),
    [sym_preproc_line] = STATE(1630),
    [sym_preproc_pragma] = STATE(1630),
    [sym_preproc_nullable] = STATE(1630),
    [sym_preproc_error] = STATE(1630),
    [sym_preproc_warning] = STATE(1630),
    [sym_preproc_define] = STATE(1630),
    [sym_preproc_undef] = STATE(1630),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1631] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4390),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1631),
    [sym_preproc_endregion] = STATE(1631),
    [sym_preproc_line] = STATE(1631),
    [sym_preproc_pragma] = STATE(1631),
    [sym_preproc_nullable] = STATE(1631),
    [sym_preproc_error] = STATE(1631),
    [sym_preproc_warning] = STATE(1631),
    [sym_preproc_define] = STATE(1631),
    [sym_preproc_undef] = STATE(1631),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1632] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4507),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1632),
    [sym_preproc_endregion] = STATE(1632),
    [sym_preproc_line] = STATE(1632),
    [sym_preproc_pragma] = STATE(1632),
    [sym_preproc_nullable] = STATE(1632),
    [sym_preproc_error] = STATE(1632),
    [sym_preproc_warning] = STATE(1632),
    [sym_preproc_define] = STATE(1632),
    [sym_preproc_undef] = STATE(1632),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1633] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4511),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1633),
    [sym_preproc_endregion] = STATE(1633),
    [sym_preproc_line] = STATE(1633),
    [sym_preproc_pragma] = STATE(1633),
    [sym_preproc_nullable] = STATE(1633),
    [sym_preproc_error] = STATE(1633),
    [sym_preproc_warning] = STATE(1633),
    [sym_preproc_define] = STATE(1633),
    [sym_preproc_undef] = STATE(1633),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1634] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4391),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1634),
    [sym_preproc_endregion] = STATE(1634),
    [sym_preproc_line] = STATE(1634),
    [sym_preproc_pragma] = STATE(1634),
    [sym_preproc_nullable] = STATE(1634),
    [sym_preproc_error] = STATE(1634),
    [sym_preproc_warning] = STATE(1634),
    [sym_preproc_define] = STATE(1634),
    [sym_preproc_undef] = STATE(1634),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1635] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4978),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1635),
    [sym_preproc_endregion] = STATE(1635),
    [sym_preproc_line] = STATE(1635),
    [sym_preproc_pragma] = STATE(1635),
    [sym_preproc_nullable] = STATE(1635),
    [sym_preproc_error] = STATE(1635),
    [sym_preproc_warning] = STATE(1635),
    [sym_preproc_define] = STATE(1635),
    [sym_preproc_undef] = STATE(1635),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1636] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4363),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1636),
    [sym_preproc_endregion] = STATE(1636),
    [sym_preproc_line] = STATE(1636),
    [sym_preproc_pragma] = STATE(1636),
    [sym_preproc_nullable] = STATE(1636),
    [sym_preproc_error] = STATE(1636),
    [sym_preproc_warning] = STATE(1636),
    [sym_preproc_define] = STATE(1636),
    [sym_preproc_undef] = STATE(1636),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1637] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4980),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1637),
    [sym_preproc_endregion] = STATE(1637),
    [sym_preproc_line] = STATE(1637),
    [sym_preproc_pragma] = STATE(1637),
    [sym_preproc_nullable] = STATE(1637),
    [sym_preproc_error] = STATE(1637),
    [sym_preproc_warning] = STATE(1637),
    [sym_preproc_define] = STATE(1637),
    [sym_preproc_undef] = STATE(1637),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1638] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3647),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1638),
    [sym_preproc_endregion] = STATE(1638),
    [sym_preproc_line] = STATE(1638),
    [sym_preproc_pragma] = STATE(1638),
    [sym_preproc_nullable] = STATE(1638),
    [sym_preproc_error] = STATE(1638),
    [sym_preproc_warning] = STATE(1638),
    [sym_preproc_define] = STATE(1638),
    [sym_preproc_undef] = STATE(1638),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1639] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3597),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1639),
    [sym_preproc_endregion] = STATE(1639),
    [sym_preproc_line] = STATE(1639),
    [sym_preproc_pragma] = STATE(1639),
    [sym_preproc_nullable] = STATE(1639),
    [sym_preproc_error] = STATE(1639),
    [sym_preproc_warning] = STATE(1639),
    [sym_preproc_define] = STATE(1639),
    [sym_preproc_undef] = STATE(1639),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1640] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3799),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1640),
    [sym_preproc_endregion] = STATE(1640),
    [sym_preproc_line] = STATE(1640),
    [sym_preproc_pragma] = STATE(1640),
    [sym_preproc_nullable] = STATE(1640),
    [sym_preproc_error] = STATE(1640),
    [sym_preproc_warning] = STATE(1640),
    [sym_preproc_define] = STATE(1640),
    [sym_preproc_undef] = STATE(1640),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1641] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3648),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1641),
    [sym_preproc_endregion] = STATE(1641),
    [sym_preproc_line] = STATE(1641),
    [sym_preproc_pragma] = STATE(1641),
    [sym_preproc_nullable] = STATE(1641),
    [sym_preproc_error] = STATE(1641),
    [sym_preproc_warning] = STATE(1641),
    [sym_preproc_define] = STATE(1641),
    [sym_preproc_undef] = STATE(1641),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1642] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1642),
    [sym_preproc_endregion] = STATE(1642),
    [sym_preproc_line] = STATE(1642),
    [sym_preproc_pragma] = STATE(1642),
    [sym_preproc_nullable] = STATE(1642),
    [sym_preproc_error] = STATE(1642),
    [sym_preproc_warning] = STATE(1642),
    [sym_preproc_define] = STATE(1642),
    [sym_preproc_undef] = STATE(1642),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1643] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3650),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1643),
    [sym_preproc_endregion] = STATE(1643),
    [sym_preproc_line] = STATE(1643),
    [sym_preproc_pragma] = STATE(1643),
    [sym_preproc_nullable] = STATE(1643),
    [sym_preproc_error] = STATE(1643),
    [sym_preproc_warning] = STATE(1643),
    [sym_preproc_define] = STATE(1643),
    [sym_preproc_undef] = STATE(1643),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1644] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3593),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1644),
    [sym_preproc_endregion] = STATE(1644),
    [sym_preproc_line] = STATE(1644),
    [sym_preproc_pragma] = STATE(1644),
    [sym_preproc_nullable] = STATE(1644),
    [sym_preproc_error] = STATE(1644),
    [sym_preproc_warning] = STATE(1644),
    [sym_preproc_define] = STATE(1644),
    [sym_preproc_undef] = STATE(1644),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1645] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3594),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1645),
    [sym_preproc_endregion] = STATE(1645),
    [sym_preproc_line] = STATE(1645),
    [sym_preproc_pragma] = STATE(1645),
    [sym_preproc_nullable] = STATE(1645),
    [sym_preproc_error] = STATE(1645),
    [sym_preproc_warning] = STATE(1645),
    [sym_preproc_define] = STATE(1645),
    [sym_preproc_undef] = STATE(1645),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1646] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3595),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1646),
    [sym_preproc_endregion] = STATE(1646),
    [sym_preproc_line] = STATE(1646),
    [sym_preproc_pragma] = STATE(1646),
    [sym_preproc_nullable] = STATE(1646),
    [sym_preproc_error] = STATE(1646),
    [sym_preproc_warning] = STATE(1646),
    [sym_preproc_define] = STATE(1646),
    [sym_preproc_undef] = STATE(1646),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1647] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3653),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1647),
    [sym_preproc_endregion] = STATE(1647),
    [sym_preproc_line] = STATE(1647),
    [sym_preproc_pragma] = STATE(1647),
    [sym_preproc_nullable] = STATE(1647),
    [sym_preproc_error] = STATE(1647),
    [sym_preproc_warning] = STATE(1647),
    [sym_preproc_define] = STATE(1647),
    [sym_preproc_undef] = STATE(1647),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1648] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3654),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1648),
    [sym_preproc_endregion] = STATE(1648),
    [sym_preproc_line] = STATE(1648),
    [sym_preproc_pragma] = STATE(1648),
    [sym_preproc_nullable] = STATE(1648),
    [sym_preproc_error] = STATE(1648),
    [sym_preproc_warning] = STATE(1648),
    [sym_preproc_define] = STATE(1648),
    [sym_preproc_undef] = STATE(1648),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1649] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3657),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1649),
    [sym_preproc_endregion] = STATE(1649),
    [sym_preproc_line] = STATE(1649),
    [sym_preproc_pragma] = STATE(1649),
    [sym_preproc_nullable] = STATE(1649),
    [sym_preproc_error] = STATE(1649),
    [sym_preproc_warning] = STATE(1649),
    [sym_preproc_define] = STATE(1649),
    [sym_preproc_undef] = STATE(1649),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1650] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3596),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1650),
    [sym_preproc_endregion] = STATE(1650),
    [sym_preproc_line] = STATE(1650),
    [sym_preproc_pragma] = STATE(1650),
    [sym_preproc_nullable] = STATE(1650),
    [sym_preproc_error] = STATE(1650),
    [sym_preproc_warning] = STATE(1650),
    [sym_preproc_define] = STATE(1650),
    [sym_preproc_undef] = STATE(1650),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1651] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3661),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1651),
    [sym_preproc_endregion] = STATE(1651),
    [sym_preproc_line] = STATE(1651),
    [sym_preproc_pragma] = STATE(1651),
    [sym_preproc_nullable] = STATE(1651),
    [sym_preproc_error] = STATE(1651),
    [sym_preproc_warning] = STATE(1651),
    [sym_preproc_define] = STATE(1651),
    [sym_preproc_undef] = STATE(1651),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1652] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3662),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1652),
    [sym_preproc_endregion] = STATE(1652),
    [sym_preproc_line] = STATE(1652),
    [sym_preproc_pragma] = STATE(1652),
    [sym_preproc_nullable] = STATE(1652),
    [sym_preproc_error] = STATE(1652),
    [sym_preproc_warning] = STATE(1652),
    [sym_preproc_define] = STATE(1652),
    [sym_preproc_undef] = STATE(1652),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1653] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3664),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1653),
    [sym_preproc_endregion] = STATE(1653),
    [sym_preproc_line] = STATE(1653),
    [sym_preproc_pragma] = STATE(1653),
    [sym_preproc_nullable] = STATE(1653),
    [sym_preproc_error] = STATE(1653),
    [sym_preproc_warning] = STATE(1653),
    [sym_preproc_define] = STATE(1653),
    [sym_preproc_undef] = STATE(1653),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1654] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3668),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1654),
    [sym_preproc_endregion] = STATE(1654),
    [sym_preproc_line] = STATE(1654),
    [sym_preproc_pragma] = STATE(1654),
    [sym_preproc_nullable] = STATE(1654),
    [sym_preproc_error] = STATE(1654),
    [sym_preproc_warning] = STATE(1654),
    [sym_preproc_define] = STATE(1654),
    [sym_preproc_undef] = STATE(1654),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1655] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3680),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1655),
    [sym_preproc_endregion] = STATE(1655),
    [sym_preproc_line] = STATE(1655),
    [sym_preproc_pragma] = STATE(1655),
    [sym_preproc_nullable] = STATE(1655),
    [sym_preproc_error] = STATE(1655),
    [sym_preproc_warning] = STATE(1655),
    [sym_preproc_define] = STATE(1655),
    [sym_preproc_undef] = STATE(1655),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1656] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4384),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1656),
    [sym_preproc_endregion] = STATE(1656),
    [sym_preproc_line] = STATE(1656),
    [sym_preproc_pragma] = STATE(1656),
    [sym_preproc_nullable] = STATE(1656),
    [sym_preproc_error] = STATE(1656),
    [sym_preproc_warning] = STATE(1656),
    [sym_preproc_define] = STATE(1656),
    [sym_preproc_undef] = STATE(1656),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1657] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4362),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1657),
    [sym_preproc_endregion] = STATE(1657),
    [sym_preproc_line] = STATE(1657),
    [sym_preproc_pragma] = STATE(1657),
    [sym_preproc_nullable] = STATE(1657),
    [sym_preproc_error] = STATE(1657),
    [sym_preproc_warning] = STATE(1657),
    [sym_preproc_define] = STATE(1657),
    [sym_preproc_undef] = STATE(1657),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1658] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5614),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1658),
    [sym_preproc_endregion] = STATE(1658),
    [sym_preproc_line] = STATE(1658),
    [sym_preproc_pragma] = STATE(1658),
    [sym_preproc_nullable] = STATE(1658),
    [sym_preproc_error] = STATE(1658),
    [sym_preproc_warning] = STATE(1658),
    [sym_preproc_define] = STATE(1658),
    [sym_preproc_undef] = STATE(1658),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1659] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3804),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1659),
    [sym_preproc_endregion] = STATE(1659),
    [sym_preproc_line] = STATE(1659),
    [sym_preproc_pragma] = STATE(1659),
    [sym_preproc_nullable] = STATE(1659),
    [sym_preproc_error] = STATE(1659),
    [sym_preproc_warning] = STATE(1659),
    [sym_preproc_define] = STATE(1659),
    [sym_preproc_undef] = STATE(1659),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1660] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4299),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1660),
    [sym_preproc_endregion] = STATE(1660),
    [sym_preproc_line] = STATE(1660),
    [sym_preproc_pragma] = STATE(1660),
    [sym_preproc_nullable] = STATE(1660),
    [sym_preproc_error] = STATE(1660),
    [sym_preproc_warning] = STATE(1660),
    [sym_preproc_define] = STATE(1660),
    [sym_preproc_undef] = STATE(1660),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1661] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3806),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1661),
    [sym_preproc_endregion] = STATE(1661),
    [sym_preproc_line] = STATE(1661),
    [sym_preproc_pragma] = STATE(1661),
    [sym_preproc_nullable] = STATE(1661),
    [sym_preproc_error] = STATE(1661),
    [sym_preproc_warning] = STATE(1661),
    [sym_preproc_define] = STATE(1661),
    [sym_preproc_undef] = STATE(1661),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1662] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4309),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1662),
    [sym_preproc_endregion] = STATE(1662),
    [sym_preproc_line] = STATE(1662),
    [sym_preproc_pragma] = STATE(1662),
    [sym_preproc_nullable] = STATE(1662),
    [sym_preproc_error] = STATE(1662),
    [sym_preproc_warning] = STATE(1662),
    [sym_preproc_define] = STATE(1662),
    [sym_preproc_undef] = STATE(1662),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1663] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4340),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1663),
    [sym_preproc_endregion] = STATE(1663),
    [sym_preproc_line] = STATE(1663),
    [sym_preproc_pragma] = STATE(1663),
    [sym_preproc_nullable] = STATE(1663),
    [sym_preproc_error] = STATE(1663),
    [sym_preproc_warning] = STATE(1663),
    [sym_preproc_define] = STATE(1663),
    [sym_preproc_undef] = STATE(1663),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1664] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4341),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1664),
    [sym_preproc_endregion] = STATE(1664),
    [sym_preproc_line] = STATE(1664),
    [sym_preproc_pragma] = STATE(1664),
    [sym_preproc_nullable] = STATE(1664),
    [sym_preproc_error] = STATE(1664),
    [sym_preproc_warning] = STATE(1664),
    [sym_preproc_define] = STATE(1664),
    [sym_preproc_undef] = STATE(1664),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1665] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4344),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1665),
    [sym_preproc_endregion] = STATE(1665),
    [sym_preproc_line] = STATE(1665),
    [sym_preproc_pragma] = STATE(1665),
    [sym_preproc_nullable] = STATE(1665),
    [sym_preproc_error] = STATE(1665),
    [sym_preproc_warning] = STATE(1665),
    [sym_preproc_define] = STATE(1665),
    [sym_preproc_undef] = STATE(1665),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1666] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4321),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1666),
    [sym_preproc_endregion] = STATE(1666),
    [sym_preproc_line] = STATE(1666),
    [sym_preproc_pragma] = STATE(1666),
    [sym_preproc_nullable] = STATE(1666),
    [sym_preproc_error] = STATE(1666),
    [sym_preproc_warning] = STATE(1666),
    [sym_preproc_define] = STATE(1666),
    [sym_preproc_undef] = STATE(1666),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1667] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4327),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1667),
    [sym_preproc_endregion] = STATE(1667),
    [sym_preproc_line] = STATE(1667),
    [sym_preproc_pragma] = STATE(1667),
    [sym_preproc_nullable] = STATE(1667),
    [sym_preproc_error] = STATE(1667),
    [sym_preproc_warning] = STATE(1667),
    [sym_preproc_define] = STATE(1667),
    [sym_preproc_undef] = STATE(1667),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1668] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4330),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1668),
    [sym_preproc_endregion] = STATE(1668),
    [sym_preproc_line] = STATE(1668),
    [sym_preproc_pragma] = STATE(1668),
    [sym_preproc_nullable] = STATE(1668),
    [sym_preproc_error] = STATE(1668),
    [sym_preproc_warning] = STATE(1668),
    [sym_preproc_define] = STATE(1668),
    [sym_preproc_undef] = STATE(1668),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1669] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4346),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1669),
    [sym_preproc_endregion] = STATE(1669),
    [sym_preproc_line] = STATE(1669),
    [sym_preproc_pragma] = STATE(1669),
    [sym_preproc_nullable] = STATE(1669),
    [sym_preproc_error] = STATE(1669),
    [sym_preproc_warning] = STATE(1669),
    [sym_preproc_define] = STATE(1669),
    [sym_preproc_undef] = STATE(1669),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1670] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4298),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1670),
    [sym_preproc_endregion] = STATE(1670),
    [sym_preproc_line] = STATE(1670),
    [sym_preproc_pragma] = STATE(1670),
    [sym_preproc_nullable] = STATE(1670),
    [sym_preproc_error] = STATE(1670),
    [sym_preproc_warning] = STATE(1670),
    [sym_preproc_define] = STATE(1670),
    [sym_preproc_undef] = STATE(1670),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1671] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4375),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1671),
    [sym_preproc_endregion] = STATE(1671),
    [sym_preproc_line] = STATE(1671),
    [sym_preproc_pragma] = STATE(1671),
    [sym_preproc_nullable] = STATE(1671),
    [sym_preproc_error] = STATE(1671),
    [sym_preproc_warning] = STATE(1671),
    [sym_preproc_define] = STATE(1671),
    [sym_preproc_undef] = STATE(1671),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1672] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4376),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1672),
    [sym_preproc_endregion] = STATE(1672),
    [sym_preproc_line] = STATE(1672),
    [sym_preproc_pragma] = STATE(1672),
    [sym_preproc_nullable] = STATE(1672),
    [sym_preproc_error] = STATE(1672),
    [sym_preproc_warning] = STATE(1672),
    [sym_preproc_define] = STATE(1672),
    [sym_preproc_undef] = STATE(1672),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1673] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4379),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1673),
    [sym_preproc_endregion] = STATE(1673),
    [sym_preproc_line] = STATE(1673),
    [sym_preproc_pragma] = STATE(1673),
    [sym_preproc_nullable] = STATE(1673),
    [sym_preproc_error] = STATE(1673),
    [sym_preproc_warning] = STATE(1673),
    [sym_preproc_define] = STATE(1673),
    [sym_preproc_undef] = STATE(1673),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1674] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4363),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1674),
    [sym_preproc_endregion] = STATE(1674),
    [sym_preproc_line] = STATE(1674),
    [sym_preproc_pragma] = STATE(1674),
    [sym_preproc_nullable] = STATE(1674),
    [sym_preproc_error] = STATE(1674),
    [sym_preproc_warning] = STATE(1674),
    [sym_preproc_define] = STATE(1674),
    [sym_preproc_undef] = STATE(1674),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1675] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3807),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1675),
    [sym_preproc_endregion] = STATE(1675),
    [sym_preproc_line] = STATE(1675),
    [sym_preproc_pragma] = STATE(1675),
    [sym_preproc_nullable] = STATE(1675),
    [sym_preproc_error] = STATE(1675),
    [sym_preproc_warning] = STATE(1675),
    [sym_preproc_define] = STATE(1675),
    [sym_preproc_undef] = STATE(1675),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1676] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1676),
    [sym_preproc_endregion] = STATE(1676),
    [sym_preproc_line] = STATE(1676),
    [sym_preproc_pragma] = STATE(1676),
    [sym_preproc_nullable] = STATE(1676),
    [sym_preproc_error] = STATE(1676),
    [sym_preproc_warning] = STATE(1676),
    [sym_preproc_define] = STATE(1676),
    [sym_preproc_undef] = STATE(1676),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1677] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1677),
    [sym_preproc_endregion] = STATE(1677),
    [sym_preproc_line] = STATE(1677),
    [sym_preproc_pragma] = STATE(1677),
    [sym_preproc_nullable] = STATE(1677),
    [sym_preproc_error] = STATE(1677),
    [sym_preproc_warning] = STATE(1677),
    [sym_preproc_define] = STATE(1677),
    [sym_preproc_undef] = STATE(1677),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1678] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3808),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1678),
    [sym_preproc_endregion] = STATE(1678),
    [sym_preproc_line] = STATE(1678),
    [sym_preproc_pragma] = STATE(1678),
    [sym_preproc_nullable] = STATE(1678),
    [sym_preproc_error] = STATE(1678),
    [sym_preproc_warning] = STATE(1678),
    [sym_preproc_define] = STATE(1678),
    [sym_preproc_undef] = STATE(1678),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1679] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5466),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1679),
    [sym_preproc_endregion] = STATE(1679),
    [sym_preproc_line] = STATE(1679),
    [sym_preproc_pragma] = STATE(1679),
    [sym_preproc_nullable] = STATE(1679),
    [sym_preproc_error] = STATE(1679),
    [sym_preproc_warning] = STATE(1679),
    [sym_preproc_define] = STATE(1679),
    [sym_preproc_undef] = STATE(1679),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1680] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3248),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3572),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6233),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7777),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1680),
    [sym_preproc_endregion] = STATE(1680),
    [sym_preproc_line] = STATE(1680),
    [sym_preproc_pragma] = STATE(1680),
    [sym_preproc_nullable] = STATE(1680),
    [sym_preproc_error] = STATE(1680),
    [sym_preproc_warning] = STATE(1680),
    [sym_preproc_define] = STATE(1680),
    [sym_preproc_undef] = STATE(1680),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_ref] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1681] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3809),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1681),
    [sym_preproc_endregion] = STATE(1681),
    [sym_preproc_line] = STATE(1681),
    [sym_preproc_pragma] = STATE(1681),
    [sym_preproc_nullable] = STATE(1681),
    [sym_preproc_error] = STATE(1681),
    [sym_preproc_warning] = STATE(1681),
    [sym_preproc_define] = STATE(1681),
    [sym_preproc_undef] = STATE(1681),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1682] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3655),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1682),
    [sym_preproc_endregion] = STATE(1682),
    [sym_preproc_line] = STATE(1682),
    [sym_preproc_pragma] = STATE(1682),
    [sym_preproc_nullable] = STATE(1682),
    [sym_preproc_error] = STATE(1682),
    [sym_preproc_warning] = STATE(1682),
    [sym_preproc_define] = STATE(1682),
    [sym_preproc_undef] = STATE(1682),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1683] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3810),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1683),
    [sym_preproc_endregion] = STATE(1683),
    [sym_preproc_line] = STATE(1683),
    [sym_preproc_pragma] = STATE(1683),
    [sym_preproc_nullable] = STATE(1683),
    [sym_preproc_error] = STATE(1683),
    [sym_preproc_warning] = STATE(1683),
    [sym_preproc_define] = STATE(1683),
    [sym_preproc_undef] = STATE(1683),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1684] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3811),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1684),
    [sym_preproc_endregion] = STATE(1684),
    [sym_preproc_line] = STATE(1684),
    [sym_preproc_pragma] = STATE(1684),
    [sym_preproc_nullable] = STATE(1684),
    [sym_preproc_error] = STATE(1684),
    [sym_preproc_warning] = STATE(1684),
    [sym_preproc_define] = STATE(1684),
    [sym_preproc_undef] = STATE(1684),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1685] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3812),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1685),
    [sym_preproc_endregion] = STATE(1685),
    [sym_preproc_line] = STATE(1685),
    [sym_preproc_pragma] = STATE(1685),
    [sym_preproc_nullable] = STATE(1685),
    [sym_preproc_error] = STATE(1685),
    [sym_preproc_warning] = STATE(1685),
    [sym_preproc_define] = STATE(1685),
    [sym_preproc_undef] = STATE(1685),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1686] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3659),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1686),
    [sym_preproc_endregion] = STATE(1686),
    [sym_preproc_line] = STATE(1686),
    [sym_preproc_pragma] = STATE(1686),
    [sym_preproc_nullable] = STATE(1686),
    [sym_preproc_error] = STATE(1686),
    [sym_preproc_warning] = STATE(1686),
    [sym_preproc_define] = STATE(1686),
    [sym_preproc_undef] = STATE(1686),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1687] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4116),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3161),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6202),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7391),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1687),
    [sym_preproc_endregion] = STATE(1687),
    [sym_preproc_line] = STATE(1687),
    [sym_preproc_pragma] = STATE(1687),
    [sym_preproc_nullable] = STATE(1687),
    [sym_preproc_error] = STATE(1687),
    [sym_preproc_warning] = STATE(1687),
    [sym_preproc_define] = STATE(1687),
    [sym_preproc_undef] = STATE(1687),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_ref] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1821),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1688] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3814),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1688),
    [sym_preproc_endregion] = STATE(1688),
    [sym_preproc_line] = STATE(1688),
    [sym_preproc_pragma] = STATE(1688),
    [sym_preproc_nullable] = STATE(1688),
    [sym_preproc_error] = STATE(1688),
    [sym_preproc_warning] = STATE(1688),
    [sym_preproc_define] = STATE(1688),
    [sym_preproc_undef] = STATE(1688),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1689] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5920),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2376),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3630),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2955),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7630),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1689),
    [sym_preproc_endregion] = STATE(1689),
    [sym_preproc_line] = STATE(1689),
    [sym_preproc_pragma] = STATE(1689),
    [sym_preproc_nullable] = STATE(1689),
    [sym_preproc_error] = STATE(1689),
    [sym_preproc_warning] = STATE(1689),
    [sym_preproc_define] = STATE(1689),
    [sym_preproc_undef] = STATE(1689),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_ref] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1701),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1690] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3815),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1690),
    [sym_preproc_endregion] = STATE(1690),
    [sym_preproc_line] = STATE(1690),
    [sym_preproc_pragma] = STATE(1690),
    [sym_preproc_nullable] = STATE(1690),
    [sym_preproc_error] = STATE(1690),
    [sym_preproc_warning] = STATE(1690),
    [sym_preproc_define] = STATE(1690),
    [sym_preproc_undef] = STATE(1690),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1691] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3816),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1691),
    [sym_preproc_endregion] = STATE(1691),
    [sym_preproc_line] = STATE(1691),
    [sym_preproc_pragma] = STATE(1691),
    [sym_preproc_nullable] = STATE(1691),
    [sym_preproc_error] = STATE(1691),
    [sym_preproc_warning] = STATE(1691),
    [sym_preproc_define] = STATE(1691),
    [sym_preproc_undef] = STATE(1691),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1692] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3822),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1692),
    [sym_preproc_endregion] = STATE(1692),
    [sym_preproc_line] = STATE(1692),
    [sym_preproc_pragma] = STATE(1692),
    [sym_preproc_nullable] = STATE(1692),
    [sym_preproc_error] = STATE(1692),
    [sym_preproc_warning] = STATE(1692),
    [sym_preproc_define] = STATE(1692),
    [sym_preproc_undef] = STATE(1692),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1693] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5507),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1693),
    [sym_preproc_endregion] = STATE(1693),
    [sym_preproc_line] = STATE(1693),
    [sym_preproc_pragma] = STATE(1693),
    [sym_preproc_nullable] = STATE(1693),
    [sym_preproc_error] = STATE(1693),
    [sym_preproc_warning] = STATE(1693),
    [sym_preproc_define] = STATE(1693),
    [sym_preproc_undef] = STATE(1693),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1694] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3630),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1694),
    [sym_preproc_endregion] = STATE(1694),
    [sym_preproc_line] = STATE(1694),
    [sym_preproc_pragma] = STATE(1694),
    [sym_preproc_nullable] = STATE(1694),
    [sym_preproc_error] = STATE(1694),
    [sym_preproc_warning] = STATE(1694),
    [sym_preproc_define] = STATE(1694),
    [sym_preproc_undef] = STATE(1694),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1695] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1695),
    [sym_preproc_endregion] = STATE(1695),
    [sym_preproc_line] = STATE(1695),
    [sym_preproc_pragma] = STATE(1695),
    [sym_preproc_nullable] = STATE(1695),
    [sym_preproc_error] = STATE(1695),
    [sym_preproc_warning] = STATE(1695),
    [sym_preproc_define] = STATE(1695),
    [sym_preproc_undef] = STATE(1695),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1696] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1696),
    [sym_preproc_endregion] = STATE(1696),
    [sym_preproc_line] = STATE(1696),
    [sym_preproc_pragma] = STATE(1696),
    [sym_preproc_nullable] = STATE(1696),
    [sym_preproc_error] = STATE(1696),
    [sym_preproc_warning] = STATE(1696),
    [sym_preproc_define] = STATE(1696),
    [sym_preproc_undef] = STATE(1696),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1697] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4252),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1697),
    [sym_preproc_endregion] = STATE(1697),
    [sym_preproc_line] = STATE(1697),
    [sym_preproc_pragma] = STATE(1697),
    [sym_preproc_nullable] = STATE(1697),
    [sym_preproc_error] = STATE(1697),
    [sym_preproc_warning] = STATE(1697),
    [sym_preproc_define] = STATE(1697),
    [sym_preproc_undef] = STATE(1697),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1698] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5615),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1698),
    [sym_preproc_endregion] = STATE(1698),
    [sym_preproc_line] = STATE(1698),
    [sym_preproc_pragma] = STATE(1698),
    [sym_preproc_nullable] = STATE(1698),
    [sym_preproc_error] = STATE(1698),
    [sym_preproc_warning] = STATE(1698),
    [sym_preproc_define] = STATE(1698),
    [sym_preproc_undef] = STATE(1698),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1699] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5616),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1699),
    [sym_preproc_endregion] = STATE(1699),
    [sym_preproc_line] = STATE(1699),
    [sym_preproc_pragma] = STATE(1699),
    [sym_preproc_nullable] = STATE(1699),
    [sym_preproc_error] = STATE(1699),
    [sym_preproc_warning] = STATE(1699),
    [sym_preproc_define] = STATE(1699),
    [sym_preproc_undef] = STATE(1699),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1700] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5617),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1700),
    [sym_preproc_endregion] = STATE(1700),
    [sym_preproc_line] = STATE(1700),
    [sym_preproc_pragma] = STATE(1700),
    [sym_preproc_nullable] = STATE(1700),
    [sym_preproc_error] = STATE(1700),
    [sym_preproc_warning] = STATE(1700),
    [sym_preproc_define] = STATE(1700),
    [sym_preproc_undef] = STATE(1700),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1701] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5618),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1701),
    [sym_preproc_endregion] = STATE(1701),
    [sym_preproc_line] = STATE(1701),
    [sym_preproc_pragma] = STATE(1701),
    [sym_preproc_nullable] = STATE(1701),
    [sym_preproc_error] = STATE(1701),
    [sym_preproc_warning] = STATE(1701),
    [sym_preproc_define] = STATE(1701),
    [sym_preproc_undef] = STATE(1701),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1702] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5620),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1702),
    [sym_preproc_endregion] = STATE(1702),
    [sym_preproc_line] = STATE(1702),
    [sym_preproc_pragma] = STATE(1702),
    [sym_preproc_nullable] = STATE(1702),
    [sym_preproc_error] = STATE(1702),
    [sym_preproc_warning] = STATE(1702),
    [sym_preproc_define] = STATE(1702),
    [sym_preproc_undef] = STATE(1702),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1703] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5621),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1703),
    [sym_preproc_endregion] = STATE(1703),
    [sym_preproc_line] = STATE(1703),
    [sym_preproc_pragma] = STATE(1703),
    [sym_preproc_nullable] = STATE(1703),
    [sym_preproc_error] = STATE(1703),
    [sym_preproc_warning] = STATE(1703),
    [sym_preproc_define] = STATE(1703),
    [sym_preproc_undef] = STATE(1703),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1704] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5622),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1704),
    [sym_preproc_endregion] = STATE(1704),
    [sym_preproc_line] = STATE(1704),
    [sym_preproc_pragma] = STATE(1704),
    [sym_preproc_nullable] = STATE(1704),
    [sym_preproc_error] = STATE(1704),
    [sym_preproc_warning] = STATE(1704),
    [sym_preproc_define] = STATE(1704),
    [sym_preproc_undef] = STATE(1704),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1705] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3826),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3103),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6207),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7633),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1705),
    [sym_preproc_endregion] = STATE(1705),
    [sym_preproc_line] = STATE(1705),
    [sym_preproc_pragma] = STATE(1705),
    [sym_preproc_nullable] = STATE(1705),
    [sym_preproc_error] = STATE(1705),
    [sym_preproc_warning] = STATE(1705),
    [sym_preproc_define] = STATE(1705),
    [sym_preproc_undef] = STATE(1705),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_ref] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1193),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1195),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1706] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5509),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1706),
    [sym_preproc_endregion] = STATE(1706),
    [sym_preproc_line] = STATE(1706),
    [sym_preproc_pragma] = STATE(1706),
    [sym_preproc_nullable] = STATE(1706),
    [sym_preproc_error] = STATE(1706),
    [sym_preproc_warning] = STATE(1706),
    [sym_preproc_define] = STATE(1706),
    [sym_preproc_undef] = STATE(1706),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1707] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1707),
    [sym_preproc_endregion] = STATE(1707),
    [sym_preproc_line] = STATE(1707),
    [sym_preproc_pragma] = STATE(1707),
    [sym_preproc_nullable] = STATE(1707),
    [sym_preproc_error] = STATE(1707),
    [sym_preproc_warning] = STATE(1707),
    [sym_preproc_define] = STATE(1707),
    [sym_preproc_undef] = STATE(1707),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1708] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5172),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1708),
    [sym_preproc_endregion] = STATE(1708),
    [sym_preproc_line] = STATE(1708),
    [sym_preproc_pragma] = STATE(1708),
    [sym_preproc_nullable] = STATE(1708),
    [sym_preproc_error] = STATE(1708),
    [sym_preproc_warning] = STATE(1708),
    [sym_preproc_define] = STATE(1708),
    [sym_preproc_undef] = STATE(1708),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1709] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5196),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1709),
    [sym_preproc_endregion] = STATE(1709),
    [sym_preproc_line] = STATE(1709),
    [sym_preproc_pragma] = STATE(1709),
    [sym_preproc_nullable] = STATE(1709),
    [sym_preproc_error] = STATE(1709),
    [sym_preproc_warning] = STATE(1709),
    [sym_preproc_define] = STATE(1709),
    [sym_preproc_undef] = STATE(1709),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1710] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5201),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3578),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7546),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1710),
    [sym_preproc_endregion] = STATE(1710),
    [sym_preproc_line] = STATE(1710),
    [sym_preproc_pragma] = STATE(1710),
    [sym_preproc_nullable] = STATE(1710),
    [sym_preproc_error] = STATE(1710),
    [sym_preproc_warning] = STATE(1710),
    [sym_preproc_define] = STATE(1710),
    [sym_preproc_undef] = STATE(1710),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1711] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4950),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1711),
    [sym_preproc_endregion] = STATE(1711),
    [sym_preproc_line] = STATE(1711),
    [sym_preproc_pragma] = STATE(1711),
    [sym_preproc_nullable] = STATE(1711),
    [sym_preproc_error] = STATE(1711),
    [sym_preproc_warning] = STATE(1711),
    [sym_preproc_define] = STATE(1711),
    [sym_preproc_undef] = STATE(1711),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1712] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1712),
    [sym_preproc_endregion] = STATE(1712),
    [sym_preproc_line] = STATE(1712),
    [sym_preproc_pragma] = STATE(1712),
    [sym_preproc_nullable] = STATE(1712),
    [sym_preproc_error] = STATE(1712),
    [sym_preproc_warning] = STATE(1712),
    [sym_preproc_define] = STATE(1712),
    [sym_preproc_undef] = STATE(1712),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1713] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5633),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1713),
    [sym_preproc_endregion] = STATE(1713),
    [sym_preproc_line] = STATE(1713),
    [sym_preproc_pragma] = STATE(1713),
    [sym_preproc_nullable] = STATE(1713),
    [sym_preproc_error] = STATE(1713),
    [sym_preproc_warning] = STATE(1713),
    [sym_preproc_define] = STATE(1713),
    [sym_preproc_undef] = STATE(1713),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1714] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5690),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1714),
    [sym_preproc_endregion] = STATE(1714),
    [sym_preproc_line] = STATE(1714),
    [sym_preproc_pragma] = STATE(1714),
    [sym_preproc_nullable] = STATE(1714),
    [sym_preproc_error] = STATE(1714),
    [sym_preproc_warning] = STATE(1714),
    [sym_preproc_define] = STATE(1714),
    [sym_preproc_undef] = STATE(1714),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1715] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5377),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1715),
    [sym_preproc_endregion] = STATE(1715),
    [sym_preproc_line] = STATE(1715),
    [sym_preproc_pragma] = STATE(1715),
    [sym_preproc_nullable] = STATE(1715),
    [sym_preproc_error] = STATE(1715),
    [sym_preproc_warning] = STATE(1715),
    [sym_preproc_define] = STATE(1715),
    [sym_preproc_undef] = STATE(1715),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1716] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5381),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1716),
    [sym_preproc_endregion] = STATE(1716),
    [sym_preproc_line] = STATE(1716),
    [sym_preproc_pragma] = STATE(1716),
    [sym_preproc_nullable] = STATE(1716),
    [sym_preproc_error] = STATE(1716),
    [sym_preproc_warning] = STATE(1716),
    [sym_preproc_define] = STATE(1716),
    [sym_preproc_undef] = STATE(1716),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1717] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5384),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1717),
    [sym_preproc_endregion] = STATE(1717),
    [sym_preproc_line] = STATE(1717),
    [sym_preproc_pragma] = STATE(1717),
    [sym_preproc_nullable] = STATE(1717),
    [sym_preproc_error] = STATE(1717),
    [sym_preproc_warning] = STATE(1717),
    [sym_preproc_define] = STATE(1717),
    [sym_preproc_undef] = STATE(1717),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1718] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5385),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1718),
    [sym_preproc_endregion] = STATE(1718),
    [sym_preproc_line] = STATE(1718),
    [sym_preproc_pragma] = STATE(1718),
    [sym_preproc_nullable] = STATE(1718),
    [sym_preproc_error] = STATE(1718),
    [sym_preproc_warning] = STATE(1718),
    [sym_preproc_define] = STATE(1718),
    [sym_preproc_undef] = STATE(1718),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1719] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5389),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1719),
    [sym_preproc_endregion] = STATE(1719),
    [sym_preproc_line] = STATE(1719),
    [sym_preproc_pragma] = STATE(1719),
    [sym_preproc_nullable] = STATE(1719),
    [sym_preproc_error] = STATE(1719),
    [sym_preproc_warning] = STATE(1719),
    [sym_preproc_define] = STATE(1719),
    [sym_preproc_undef] = STATE(1719),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1720] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5429),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1720),
    [sym_preproc_endregion] = STATE(1720),
    [sym_preproc_line] = STATE(1720),
    [sym_preproc_pragma] = STATE(1720),
    [sym_preproc_nullable] = STATE(1720),
    [sym_preproc_error] = STATE(1720),
    [sym_preproc_warning] = STATE(1720),
    [sym_preproc_define] = STATE(1720),
    [sym_preproc_undef] = STATE(1720),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1721] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5430),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1721),
    [sym_preproc_endregion] = STATE(1721),
    [sym_preproc_line] = STATE(1721),
    [sym_preproc_pragma] = STATE(1721),
    [sym_preproc_nullable] = STATE(1721),
    [sym_preproc_error] = STATE(1721),
    [sym_preproc_warning] = STATE(1721),
    [sym_preproc_define] = STATE(1721),
    [sym_preproc_undef] = STATE(1721),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1722] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5432),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1722),
    [sym_preproc_endregion] = STATE(1722),
    [sym_preproc_line] = STATE(1722),
    [sym_preproc_pragma] = STATE(1722),
    [sym_preproc_nullable] = STATE(1722),
    [sym_preproc_error] = STATE(1722),
    [sym_preproc_warning] = STATE(1722),
    [sym_preproc_define] = STATE(1722),
    [sym_preproc_undef] = STATE(1722),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1723] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5926),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2397),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5473),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3714),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6206),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7504),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1723),
    [sym_preproc_endregion] = STATE(1723),
    [sym_preproc_line] = STATE(1723),
    [sym_preproc_pragma] = STATE(1723),
    [sym_preproc_nullable] = STATE(1723),
    [sym_preproc_error] = STATE(1723),
    [sym_preproc_warning] = STATE(1723),
    [sym_preproc_define] = STATE(1723),
    [sym_preproc_undef] = STATE(1723),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_ref] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2247),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1724] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5630),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1724),
    [sym_preproc_endregion] = STATE(1724),
    [sym_preproc_line] = STATE(1724),
    [sym_preproc_pragma] = STATE(1724),
    [sym_preproc_nullable] = STATE(1724),
    [sym_preproc_error] = STATE(1724),
    [sym_preproc_warning] = STATE(1724),
    [sym_preproc_define] = STATE(1724),
    [sym_preproc_undef] = STATE(1724),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1725] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5631),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1725),
    [sym_preproc_endregion] = STATE(1725),
    [sym_preproc_line] = STATE(1725),
    [sym_preproc_pragma] = STATE(1725),
    [sym_preproc_nullable] = STATE(1725),
    [sym_preproc_error] = STATE(1725),
    [sym_preproc_warning] = STATE(1725),
    [sym_preproc_define] = STATE(1725),
    [sym_preproc_undef] = STATE(1725),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1726] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5632),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1726),
    [sym_preproc_endregion] = STATE(1726),
    [sym_preproc_line] = STATE(1726),
    [sym_preproc_pragma] = STATE(1726),
    [sym_preproc_nullable] = STATE(1726),
    [sym_preproc_error] = STATE(1726),
    [sym_preproc_warning] = STATE(1726),
    [sym_preproc_define] = STATE(1726),
    [sym_preproc_undef] = STATE(1726),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1727] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5474),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1727),
    [sym_preproc_endregion] = STATE(1727),
    [sym_preproc_line] = STATE(1727),
    [sym_preproc_pragma] = STATE(1727),
    [sym_preproc_nullable] = STATE(1727),
    [sym_preproc_error] = STATE(1727),
    [sym_preproc_warning] = STATE(1727),
    [sym_preproc_define] = STATE(1727),
    [sym_preproc_undef] = STATE(1727),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1728] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5923),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2392),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4234),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3178),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6211),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7479),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1728),
    [sym_preproc_endregion] = STATE(1728),
    [sym_preproc_line] = STATE(1728),
    [sym_preproc_pragma] = STATE(1728),
    [sym_preproc_nullable] = STATE(1728),
    [sym_preproc_error] = STATE(1728),
    [sym_preproc_warning] = STATE(1728),
    [sym_preproc_define] = STATE(1728),
    [sym_preproc_undef] = STATE(1728),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1813),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2207),
    [anon_sym_DOT_DOT] = ACTIONS(2209),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1729] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3563),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1729),
    [sym_preproc_endregion] = STATE(1729),
    [sym_preproc_line] = STATE(1729),
    [sym_preproc_pragma] = STATE(1729),
    [sym_preproc_nullable] = STATE(1729),
    [sym_preproc_error] = STATE(1729),
    [sym_preproc_warning] = STATE(1729),
    [sym_preproc_define] = STATE(1729),
    [sym_preproc_undef] = STATE(1729),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1730] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1730),
    [sym_preproc_endregion] = STATE(1730),
    [sym_preproc_line] = STATE(1730),
    [sym_preproc_pragma] = STATE(1730),
    [sym_preproc_nullable] = STATE(1730),
    [sym_preproc_error] = STATE(1730),
    [sym_preproc_warning] = STATE(1730),
    [sym_preproc_define] = STATE(1730),
    [sym_preproc_undef] = STATE(1730),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1731] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4121),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3158),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6231),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7410),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1731),
    [sym_preproc_endregion] = STATE(1731),
    [sym_preproc_line] = STATE(1731),
    [sym_preproc_pragma] = STATE(1731),
    [sym_preproc_nullable] = STATE(1731),
    [sym_preproc_error] = STATE(1731),
    [sym_preproc_warning] = STATE(1731),
    [sym_preproc_define] = STATE(1731),
    [sym_preproc_undef] = STATE(1731),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_ref] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1732] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5210),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3581),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7706),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1732),
    [sym_preproc_endregion] = STATE(1732),
    [sym_preproc_line] = STATE(1732),
    [sym_preproc_pragma] = STATE(1732),
    [sym_preproc_nullable] = STATE(1732),
    [sym_preproc_error] = STATE(1732),
    [sym_preproc_warning] = STATE(1732),
    [sym_preproc_define] = STATE(1732),
    [sym_preproc_undef] = STATE(1732),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_ref] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1637),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1733] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5212),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1733),
    [sym_preproc_endregion] = STATE(1733),
    [sym_preproc_line] = STATE(1733),
    [sym_preproc_pragma] = STATE(1733),
    [sym_preproc_nullable] = STATE(1733),
    [sym_preproc_error] = STATE(1733),
    [sym_preproc_warning] = STATE(1733),
    [sym_preproc_define] = STATE(1733),
    [sym_preproc_undef] = STATE(1733),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1734] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4678),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1734),
    [sym_preproc_endregion] = STATE(1734),
    [sym_preproc_line] = STATE(1734),
    [sym_preproc_pragma] = STATE(1734),
    [sym_preproc_nullable] = STATE(1734),
    [sym_preproc_error] = STATE(1734),
    [sym_preproc_warning] = STATE(1734),
    [sym_preproc_define] = STATE(1734),
    [sym_preproc_undef] = STATE(1734),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1735] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3579),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1735),
    [sym_preproc_endregion] = STATE(1735),
    [sym_preproc_line] = STATE(1735),
    [sym_preproc_pragma] = STATE(1735),
    [sym_preproc_nullable] = STATE(1735),
    [sym_preproc_error] = STATE(1735),
    [sym_preproc_warning] = STATE(1735),
    [sym_preproc_define] = STATE(1735),
    [sym_preproc_undef] = STATE(1735),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1736] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5215),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1736),
    [sym_preproc_endregion] = STATE(1736),
    [sym_preproc_line] = STATE(1736),
    [sym_preproc_pragma] = STATE(1736),
    [sym_preproc_nullable] = STATE(1736),
    [sym_preproc_error] = STATE(1736),
    [sym_preproc_warning] = STATE(1736),
    [sym_preproc_define] = STATE(1736),
    [sym_preproc_undef] = STATE(1736),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1737] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4995),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1737),
    [sym_preproc_endregion] = STATE(1737),
    [sym_preproc_line] = STATE(1737),
    [sym_preproc_pragma] = STATE(1737),
    [sym_preproc_nullable] = STATE(1737),
    [sym_preproc_error] = STATE(1737),
    [sym_preproc_warning] = STATE(1737),
    [sym_preproc_define] = STATE(1737),
    [sym_preproc_undef] = STATE(1737),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1738] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4681),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1738),
    [sym_preproc_endregion] = STATE(1738),
    [sym_preproc_line] = STATE(1738),
    [sym_preproc_pragma] = STATE(1738),
    [sym_preproc_nullable] = STATE(1738),
    [sym_preproc_error] = STATE(1738),
    [sym_preproc_warning] = STATE(1738),
    [sym_preproc_define] = STATE(1738),
    [sym_preproc_undef] = STATE(1738),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1739] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4685),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1739),
    [sym_preproc_endregion] = STATE(1739),
    [sym_preproc_line] = STATE(1739),
    [sym_preproc_pragma] = STATE(1739),
    [sym_preproc_nullable] = STATE(1739),
    [sym_preproc_error] = STATE(1739),
    [sym_preproc_warning] = STATE(1739),
    [sym_preproc_define] = STATE(1739),
    [sym_preproc_undef] = STATE(1739),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1740] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4686),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1740),
    [sym_preproc_endregion] = STATE(1740),
    [sym_preproc_line] = STATE(1740),
    [sym_preproc_pragma] = STATE(1740),
    [sym_preproc_nullable] = STATE(1740),
    [sym_preproc_error] = STATE(1740),
    [sym_preproc_warning] = STATE(1740),
    [sym_preproc_define] = STATE(1740),
    [sym_preproc_undef] = STATE(1740),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1741] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4687),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1741),
    [sym_preproc_endregion] = STATE(1741),
    [sym_preproc_line] = STATE(1741),
    [sym_preproc_pragma] = STATE(1741),
    [sym_preproc_nullable] = STATE(1741),
    [sym_preproc_error] = STATE(1741),
    [sym_preproc_warning] = STATE(1741),
    [sym_preproc_define] = STATE(1741),
    [sym_preproc_undef] = STATE(1741),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1742] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4688),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1742),
    [sym_preproc_endregion] = STATE(1742),
    [sym_preproc_line] = STATE(1742),
    [sym_preproc_pragma] = STATE(1742),
    [sym_preproc_nullable] = STATE(1742),
    [sym_preproc_error] = STATE(1742),
    [sym_preproc_warning] = STATE(1742),
    [sym_preproc_define] = STATE(1742),
    [sym_preproc_undef] = STATE(1742),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1743] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4689),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1743),
    [sym_preproc_endregion] = STATE(1743),
    [sym_preproc_line] = STATE(1743),
    [sym_preproc_pragma] = STATE(1743),
    [sym_preproc_nullable] = STATE(1743),
    [sym_preproc_error] = STATE(1743),
    [sym_preproc_warning] = STATE(1743),
    [sym_preproc_define] = STATE(1743),
    [sym_preproc_undef] = STATE(1743),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1744] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4690),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1744),
    [sym_preproc_endregion] = STATE(1744),
    [sym_preproc_line] = STATE(1744),
    [sym_preproc_pragma] = STATE(1744),
    [sym_preproc_nullable] = STATE(1744),
    [sym_preproc_error] = STATE(1744),
    [sym_preproc_warning] = STATE(1744),
    [sym_preproc_define] = STATE(1744),
    [sym_preproc_undef] = STATE(1744),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1745] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4691),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1745),
    [sym_preproc_endregion] = STATE(1745),
    [sym_preproc_line] = STATE(1745),
    [sym_preproc_pragma] = STATE(1745),
    [sym_preproc_nullable] = STATE(1745),
    [sym_preproc_error] = STATE(1745),
    [sym_preproc_warning] = STATE(1745),
    [sym_preproc_define] = STATE(1745),
    [sym_preproc_undef] = STATE(1745),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1746] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(2479),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1746),
    [sym_preproc_endregion] = STATE(1746),
    [sym_preproc_line] = STATE(1746),
    [sym_preproc_pragma] = STATE(1746),
    [sym_preproc_nullable] = STATE(1746),
    [sym_preproc_error] = STATE(1746),
    [sym_preproc_warning] = STATE(1746),
    [sym_preproc_define] = STATE(1746),
    [sym_preproc_undef] = STATE(1746),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1747] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4695),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1747),
    [sym_preproc_endregion] = STATE(1747),
    [sym_preproc_line] = STATE(1747),
    [sym_preproc_pragma] = STATE(1747),
    [sym_preproc_nullable] = STATE(1747),
    [sym_preproc_error] = STATE(1747),
    [sym_preproc_warning] = STATE(1747),
    [sym_preproc_define] = STATE(1747),
    [sym_preproc_undef] = STATE(1747),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1748] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4696),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1748),
    [sym_preproc_endregion] = STATE(1748),
    [sym_preproc_line] = STATE(1748),
    [sym_preproc_pragma] = STATE(1748),
    [sym_preproc_nullable] = STATE(1748),
    [sym_preproc_error] = STATE(1748),
    [sym_preproc_warning] = STATE(1748),
    [sym_preproc_define] = STATE(1748),
    [sym_preproc_undef] = STATE(1748),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1749] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4697),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1749),
    [sym_preproc_endregion] = STATE(1749),
    [sym_preproc_line] = STATE(1749),
    [sym_preproc_pragma] = STATE(1749),
    [sym_preproc_nullable] = STATE(1749),
    [sym_preproc_error] = STATE(1749),
    [sym_preproc_warning] = STATE(1749),
    [sym_preproc_define] = STATE(1749),
    [sym_preproc_undef] = STATE(1749),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1750] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4682),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1750),
    [sym_preproc_endregion] = STATE(1750),
    [sym_preproc_line] = STATE(1750),
    [sym_preproc_pragma] = STATE(1750),
    [sym_preproc_nullable] = STATE(1750),
    [sym_preproc_error] = STATE(1750),
    [sym_preproc_warning] = STATE(1750),
    [sym_preproc_define] = STATE(1750),
    [sym_preproc_undef] = STATE(1750),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1751] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4436),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1751),
    [sym_preproc_endregion] = STATE(1751),
    [sym_preproc_line] = STATE(1751),
    [sym_preproc_pragma] = STATE(1751),
    [sym_preproc_nullable] = STATE(1751),
    [sym_preproc_error] = STATE(1751),
    [sym_preproc_warning] = STATE(1751),
    [sym_preproc_define] = STATE(1751),
    [sym_preproc_undef] = STATE(1751),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1752] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1752),
    [sym_preproc_endregion] = STATE(1752),
    [sym_preproc_line] = STATE(1752),
    [sym_preproc_pragma] = STATE(1752),
    [sym_preproc_nullable] = STATE(1752),
    [sym_preproc_error] = STATE(1752),
    [sym_preproc_warning] = STATE(1752),
    [sym_preproc_define] = STATE(1752),
    [sym_preproc_undef] = STATE(1752),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1753] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5552),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3461),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7422),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1753),
    [sym_preproc_endregion] = STATE(1753),
    [sym_preproc_line] = STATE(1753),
    [sym_preproc_pragma] = STATE(1753),
    [sym_preproc_nullable] = STATE(1753),
    [sym_preproc_error] = STATE(1753),
    [sym_preproc_warning] = STATE(1753),
    [sym_preproc_define] = STATE(1753),
    [sym_preproc_undef] = STATE(1753),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_ref] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_PLUS_PLUS] = ACTIONS(75),
    [anon_sym_DASH_DASH] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(75),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1754] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5606),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1754),
    [sym_preproc_endregion] = STATE(1754),
    [sym_preproc_line] = STATE(1754),
    [sym_preproc_pragma] = STATE(1754),
    [sym_preproc_nullable] = STATE(1754),
    [sym_preproc_error] = STATE(1754),
    [sym_preproc_warning] = STATE(1754),
    [sym_preproc_define] = STATE(1754),
    [sym_preproc_undef] = STATE(1754),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1755] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5165),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1755),
    [sym_preproc_endregion] = STATE(1755),
    [sym_preproc_line] = STATE(1755),
    [sym_preproc_pragma] = STATE(1755),
    [sym_preproc_nullable] = STATE(1755),
    [sym_preproc_error] = STATE(1755),
    [sym_preproc_warning] = STATE(1755),
    [sym_preproc_define] = STATE(1755),
    [sym_preproc_undef] = STATE(1755),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1756] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5607),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1756),
    [sym_preproc_endregion] = STATE(1756),
    [sym_preproc_line] = STATE(1756),
    [sym_preproc_pragma] = STATE(1756),
    [sym_preproc_nullable] = STATE(1756),
    [sym_preproc_error] = STATE(1756),
    [sym_preproc_warning] = STATE(1756),
    [sym_preproc_define] = STATE(1756),
    [sym_preproc_undef] = STATE(1756),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1757] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5608),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1757),
    [sym_preproc_endregion] = STATE(1757),
    [sym_preproc_line] = STATE(1757),
    [sym_preproc_pragma] = STATE(1757),
    [sym_preproc_nullable] = STATE(1757),
    [sym_preproc_error] = STATE(1757),
    [sym_preproc_warning] = STATE(1757),
    [sym_preproc_define] = STATE(1757),
    [sym_preproc_undef] = STATE(1757),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1758] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5416),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1758),
    [sym_preproc_endregion] = STATE(1758),
    [sym_preproc_line] = STATE(1758),
    [sym_preproc_pragma] = STATE(1758),
    [sym_preproc_nullable] = STATE(1758),
    [sym_preproc_error] = STATE(1758),
    [sym_preproc_warning] = STATE(1758),
    [sym_preproc_define] = STATE(1758),
    [sym_preproc_undef] = STATE(1758),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1759] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5417),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1759),
    [sym_preproc_endregion] = STATE(1759),
    [sym_preproc_line] = STATE(1759),
    [sym_preproc_pragma] = STATE(1759),
    [sym_preproc_nullable] = STATE(1759),
    [sym_preproc_error] = STATE(1759),
    [sym_preproc_warning] = STATE(1759),
    [sym_preproc_define] = STATE(1759),
    [sym_preproc_undef] = STATE(1759),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1760] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5418),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1760),
    [sym_preproc_endregion] = STATE(1760),
    [sym_preproc_line] = STATE(1760),
    [sym_preproc_pragma] = STATE(1760),
    [sym_preproc_nullable] = STATE(1760),
    [sym_preproc_error] = STATE(1760),
    [sym_preproc_warning] = STATE(1760),
    [sym_preproc_define] = STATE(1760),
    [sym_preproc_undef] = STATE(1760),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1761] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5609),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1761),
    [sym_preproc_endregion] = STATE(1761),
    [sym_preproc_line] = STATE(1761),
    [sym_preproc_pragma] = STATE(1761),
    [sym_preproc_nullable] = STATE(1761),
    [sym_preproc_error] = STATE(1761),
    [sym_preproc_warning] = STATE(1761),
    [sym_preproc_define] = STATE(1761),
    [sym_preproc_undef] = STATE(1761),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1762] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5419),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1762),
    [sym_preproc_endregion] = STATE(1762),
    [sym_preproc_line] = STATE(1762),
    [sym_preproc_pragma] = STATE(1762),
    [sym_preproc_nullable] = STATE(1762),
    [sym_preproc_error] = STATE(1762),
    [sym_preproc_warning] = STATE(1762),
    [sym_preproc_define] = STATE(1762),
    [sym_preproc_undef] = STATE(1762),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1763] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5166),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1763),
    [sym_preproc_endregion] = STATE(1763),
    [sym_preproc_line] = STATE(1763),
    [sym_preproc_pragma] = STATE(1763),
    [sym_preproc_nullable] = STATE(1763),
    [sym_preproc_error] = STATE(1763),
    [sym_preproc_warning] = STATE(1763),
    [sym_preproc_define] = STATE(1763),
    [sym_preproc_undef] = STATE(1763),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1764] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5420),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1764),
    [sym_preproc_endregion] = STATE(1764),
    [sym_preproc_line] = STATE(1764),
    [sym_preproc_pragma] = STATE(1764),
    [sym_preproc_nullable] = STATE(1764),
    [sym_preproc_error] = STATE(1764),
    [sym_preproc_warning] = STATE(1764),
    [sym_preproc_define] = STATE(1764),
    [sym_preproc_undef] = STATE(1764),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1765] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5421),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1765),
    [sym_preproc_endregion] = STATE(1765),
    [sym_preproc_line] = STATE(1765),
    [sym_preproc_pragma] = STATE(1765),
    [sym_preproc_nullable] = STATE(1765),
    [sym_preproc_error] = STATE(1765),
    [sym_preproc_warning] = STATE(1765),
    [sym_preproc_define] = STATE(1765),
    [sym_preproc_undef] = STATE(1765),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1766] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5422),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1766),
    [sym_preproc_endregion] = STATE(1766),
    [sym_preproc_line] = STATE(1766),
    [sym_preproc_pragma] = STATE(1766),
    [sym_preproc_nullable] = STATE(1766),
    [sym_preproc_error] = STATE(1766),
    [sym_preproc_warning] = STATE(1766),
    [sym_preproc_define] = STATE(1766),
    [sym_preproc_undef] = STATE(1766),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1767] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5425),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1767),
    [sym_preproc_endregion] = STATE(1767),
    [sym_preproc_line] = STATE(1767),
    [sym_preproc_pragma] = STATE(1767),
    [sym_preproc_nullable] = STATE(1767),
    [sym_preproc_error] = STATE(1767),
    [sym_preproc_warning] = STATE(1767),
    [sym_preproc_define] = STATE(1767),
    [sym_preproc_undef] = STATE(1767),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1768] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5349),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1768),
    [sym_preproc_endregion] = STATE(1768),
    [sym_preproc_line] = STATE(1768),
    [sym_preproc_pragma] = STATE(1768),
    [sym_preproc_nullable] = STATE(1768),
    [sym_preproc_error] = STATE(1768),
    [sym_preproc_warning] = STATE(1768),
    [sym_preproc_define] = STATE(1768),
    [sym_preproc_undef] = STATE(1768),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1769] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5494),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1769),
    [sym_preproc_endregion] = STATE(1769),
    [sym_preproc_line] = STATE(1769),
    [sym_preproc_pragma] = STATE(1769),
    [sym_preproc_nullable] = STATE(1769),
    [sym_preproc_error] = STATE(1769),
    [sym_preproc_warning] = STATE(1769),
    [sym_preproc_define] = STATE(1769),
    [sym_preproc_undef] = STATE(1769),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1770] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3564),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1770),
    [sym_preproc_endregion] = STATE(1770),
    [sym_preproc_line] = STATE(1770),
    [sym_preproc_pragma] = STATE(1770),
    [sym_preproc_nullable] = STATE(1770),
    [sym_preproc_error] = STATE(1770),
    [sym_preproc_warning] = STATE(1770),
    [sym_preproc_define] = STATE(1770),
    [sym_preproc_undef] = STATE(1770),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1771] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5431),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1771),
    [sym_preproc_endregion] = STATE(1771),
    [sym_preproc_line] = STATE(1771),
    [sym_preproc_pragma] = STATE(1771),
    [sym_preproc_nullable] = STATE(1771),
    [sym_preproc_error] = STATE(1771),
    [sym_preproc_warning] = STATE(1771),
    [sym_preproc_define] = STATE(1771),
    [sym_preproc_undef] = STATE(1771),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1772] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5434),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3731),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6225),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7726),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1772),
    [sym_preproc_endregion] = STATE(1772),
    [sym_preproc_line] = STATE(1772),
    [sym_preproc_pragma] = STATE(1772),
    [sym_preproc_nullable] = STATE(1772),
    [sym_preproc_error] = STATE(1772),
    [sym_preproc_warning] = STATE(1772),
    [sym_preproc_define] = STATE(1772),
    [sym_preproc_undef] = STATE(1772),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_ref] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2113),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_DOT_DOT] = ACTIONS(2119),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(2121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1773] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5350),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1773),
    [sym_preproc_endregion] = STATE(1773),
    [sym_preproc_line] = STATE(1773),
    [sym_preproc_pragma] = STATE(1773),
    [sym_preproc_nullable] = STATE(1773),
    [sym_preproc_error] = STATE(1773),
    [sym_preproc_warning] = STATE(1773),
    [sym_preproc_define] = STATE(1773),
    [sym_preproc_undef] = STATE(1773),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1774] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5946),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2318),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4370),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3353),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7761),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1774),
    [sym_preproc_endregion] = STATE(1774),
    [sym_preproc_line] = STATE(1774),
    [sym_preproc_pragma] = STATE(1774),
    [sym_preproc_nullable] = STATE(1774),
    [sym_preproc_error] = STATE(1774),
    [sym_preproc_warning] = STATE(1774),
    [sym_preproc_define] = STATE(1774),
    [sym_preproc_undef] = STATE(1774),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_ref] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1471),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1481),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1775] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4386),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1775),
    [sym_preproc_endregion] = STATE(1775),
    [sym_preproc_line] = STATE(1775),
    [sym_preproc_pragma] = STATE(1775),
    [sym_preproc_nullable] = STATE(1775),
    [sym_preproc_error] = STATE(1775),
    [sym_preproc_warning] = STATE(1775),
    [sym_preproc_define] = STATE(1775),
    [sym_preproc_undef] = STATE(1775),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1776] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4357),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1776),
    [sym_preproc_endregion] = STATE(1776),
    [sym_preproc_line] = STATE(1776),
    [sym_preproc_pragma] = STATE(1776),
    [sym_preproc_nullable] = STATE(1776),
    [sym_preproc_error] = STATE(1776),
    [sym_preproc_warning] = STATE(1776),
    [sym_preproc_define] = STATE(1776),
    [sym_preproc_undef] = STATE(1776),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1777] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4286),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1777),
    [sym_preproc_endregion] = STATE(1777),
    [sym_preproc_line] = STATE(1777),
    [sym_preproc_pragma] = STATE(1777),
    [sym_preproc_nullable] = STATE(1777),
    [sym_preproc_error] = STATE(1777),
    [sym_preproc_warning] = STATE(1777),
    [sym_preproc_define] = STATE(1777),
    [sym_preproc_undef] = STATE(1777),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1778] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5231),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1778),
    [sym_preproc_endregion] = STATE(1778),
    [sym_preproc_line] = STATE(1778),
    [sym_preproc_pragma] = STATE(1778),
    [sym_preproc_nullable] = STATE(1778),
    [sym_preproc_error] = STATE(1778),
    [sym_preproc_warning] = STATE(1778),
    [sym_preproc_define] = STATE(1778),
    [sym_preproc_undef] = STATE(1778),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1779] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1779),
    [sym_preproc_endregion] = STATE(1779),
    [sym_preproc_line] = STATE(1779),
    [sym_preproc_pragma] = STATE(1779),
    [sym_preproc_nullable] = STATE(1779),
    [sym_preproc_error] = STATE(1779),
    [sym_preproc_warning] = STATE(1779),
    [sym_preproc_define] = STATE(1779),
    [sym_preproc_undef] = STATE(1779),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1780] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5498),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1780),
    [sym_preproc_endregion] = STATE(1780),
    [sym_preproc_line] = STATE(1780),
    [sym_preproc_pragma] = STATE(1780),
    [sym_preproc_nullable] = STATE(1780),
    [sym_preproc_error] = STATE(1780),
    [sym_preproc_warning] = STATE(1780),
    [sym_preproc_define] = STATE(1780),
    [sym_preproc_undef] = STATE(1780),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1781] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5233),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1781),
    [sym_preproc_endregion] = STATE(1781),
    [sym_preproc_line] = STATE(1781),
    [sym_preproc_pragma] = STATE(1781),
    [sym_preproc_nullable] = STATE(1781),
    [sym_preproc_error] = STATE(1781),
    [sym_preproc_warning] = STATE(1781),
    [sym_preproc_define] = STATE(1781),
    [sym_preproc_undef] = STATE(1781),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1782] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5499),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1782),
    [sym_preproc_endregion] = STATE(1782),
    [sym_preproc_line] = STATE(1782),
    [sym_preproc_pragma] = STATE(1782),
    [sym_preproc_nullable] = STATE(1782),
    [sym_preproc_error] = STATE(1782),
    [sym_preproc_warning] = STATE(1782),
    [sym_preproc_define] = STATE(1782),
    [sym_preproc_undef] = STATE(1782),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1783] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4885),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1783),
    [sym_preproc_endregion] = STATE(1783),
    [sym_preproc_line] = STATE(1783),
    [sym_preproc_pragma] = STATE(1783),
    [sym_preproc_nullable] = STATE(1783),
    [sym_preproc_error] = STATE(1783),
    [sym_preproc_warning] = STATE(1783),
    [sym_preproc_define] = STATE(1783),
    [sym_preproc_undef] = STATE(1783),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1784] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5239),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1784),
    [sym_preproc_endregion] = STATE(1784),
    [sym_preproc_line] = STATE(1784),
    [sym_preproc_pragma] = STATE(1784),
    [sym_preproc_nullable] = STATE(1784),
    [sym_preproc_error] = STATE(1784),
    [sym_preproc_warning] = STATE(1784),
    [sym_preproc_define] = STATE(1784),
    [sym_preproc_undef] = STATE(1784),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1785] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5241),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1785),
    [sym_preproc_endregion] = STATE(1785),
    [sym_preproc_line] = STATE(1785),
    [sym_preproc_pragma] = STATE(1785),
    [sym_preproc_nullable] = STATE(1785),
    [sym_preproc_error] = STATE(1785),
    [sym_preproc_warning] = STATE(1785),
    [sym_preproc_define] = STATE(1785),
    [sym_preproc_undef] = STATE(1785),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1786] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5242),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1786),
    [sym_preproc_endregion] = STATE(1786),
    [sym_preproc_line] = STATE(1786),
    [sym_preproc_pragma] = STATE(1786),
    [sym_preproc_nullable] = STATE(1786),
    [sym_preproc_error] = STATE(1786),
    [sym_preproc_warning] = STATE(1786),
    [sym_preproc_define] = STATE(1786),
    [sym_preproc_undef] = STATE(1786),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1787] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5243),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1787),
    [sym_preproc_endregion] = STATE(1787),
    [sym_preproc_line] = STATE(1787),
    [sym_preproc_pragma] = STATE(1787),
    [sym_preproc_nullable] = STATE(1787),
    [sym_preproc_error] = STATE(1787),
    [sym_preproc_warning] = STATE(1787),
    [sym_preproc_define] = STATE(1787),
    [sym_preproc_undef] = STATE(1787),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1788] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5244),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1788),
    [sym_preproc_endregion] = STATE(1788),
    [sym_preproc_line] = STATE(1788),
    [sym_preproc_pragma] = STATE(1788),
    [sym_preproc_nullable] = STATE(1788),
    [sym_preproc_error] = STATE(1788),
    [sym_preproc_warning] = STATE(1788),
    [sym_preproc_define] = STATE(1788),
    [sym_preproc_undef] = STATE(1788),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1789] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5245),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1789),
    [sym_preproc_endregion] = STATE(1789),
    [sym_preproc_line] = STATE(1789),
    [sym_preproc_pragma] = STATE(1789),
    [sym_preproc_nullable] = STATE(1789),
    [sym_preproc_error] = STATE(1789),
    [sym_preproc_warning] = STATE(1789),
    [sym_preproc_define] = STATE(1789),
    [sym_preproc_undef] = STATE(1789),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1790] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5246),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1790),
    [sym_preproc_endregion] = STATE(1790),
    [sym_preproc_line] = STATE(1790),
    [sym_preproc_pragma] = STATE(1790),
    [sym_preproc_nullable] = STATE(1790),
    [sym_preproc_error] = STATE(1790),
    [sym_preproc_warning] = STATE(1790),
    [sym_preproc_define] = STATE(1790),
    [sym_preproc_undef] = STATE(1790),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1791] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5247),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1791),
    [sym_preproc_endregion] = STATE(1791),
    [sym_preproc_line] = STATE(1791),
    [sym_preproc_pragma] = STATE(1791),
    [sym_preproc_nullable] = STATE(1791),
    [sym_preproc_error] = STATE(1791),
    [sym_preproc_warning] = STATE(1791),
    [sym_preproc_define] = STATE(1791),
    [sym_preproc_undef] = STATE(1791),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1792] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5248),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1792),
    [sym_preproc_endregion] = STATE(1792),
    [sym_preproc_line] = STATE(1792),
    [sym_preproc_pragma] = STATE(1792),
    [sym_preproc_nullable] = STATE(1792),
    [sym_preproc_error] = STATE(1792),
    [sym_preproc_warning] = STATE(1792),
    [sym_preproc_define] = STATE(1792),
    [sym_preproc_undef] = STATE(1792),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1793] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5249),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1793),
    [sym_preproc_endregion] = STATE(1793),
    [sym_preproc_line] = STATE(1793),
    [sym_preproc_pragma] = STATE(1793),
    [sym_preproc_nullable] = STATE(1793),
    [sym_preproc_error] = STATE(1793),
    [sym_preproc_warning] = STATE(1793),
    [sym_preproc_define] = STATE(1793),
    [sym_preproc_undef] = STATE(1793),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1794] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5250),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1794),
    [sym_preproc_endregion] = STATE(1794),
    [sym_preproc_line] = STATE(1794),
    [sym_preproc_pragma] = STATE(1794),
    [sym_preproc_nullable] = STATE(1794),
    [sym_preproc_error] = STATE(1794),
    [sym_preproc_warning] = STATE(1794),
    [sym_preproc_define] = STATE(1794),
    [sym_preproc_undef] = STATE(1794),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1795] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5251),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1795),
    [sym_preproc_endregion] = STATE(1795),
    [sym_preproc_line] = STATE(1795),
    [sym_preproc_pragma] = STATE(1795),
    [sym_preproc_nullable] = STATE(1795),
    [sym_preproc_error] = STATE(1795),
    [sym_preproc_warning] = STATE(1795),
    [sym_preproc_define] = STATE(1795),
    [sym_preproc_undef] = STATE(1795),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1796] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1796),
    [sym_preproc_endregion] = STATE(1796),
    [sym_preproc_line] = STATE(1796),
    [sym_preproc_pragma] = STATE(1796),
    [sym_preproc_nullable] = STATE(1796),
    [sym_preproc_error] = STATE(1796),
    [sym_preproc_warning] = STATE(1796),
    [sym_preproc_define] = STATE(1796),
    [sym_preproc_undef] = STATE(1796),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1797] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4838),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1797),
    [sym_preproc_endregion] = STATE(1797),
    [sym_preproc_line] = STATE(1797),
    [sym_preproc_pragma] = STATE(1797),
    [sym_preproc_nullable] = STATE(1797),
    [sym_preproc_error] = STATE(1797),
    [sym_preproc_warning] = STATE(1797),
    [sym_preproc_define] = STATE(1797),
    [sym_preproc_undef] = STATE(1797),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1798] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3173),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1798),
    [sym_preproc_endregion] = STATE(1798),
    [sym_preproc_line] = STATE(1798),
    [sym_preproc_pragma] = STATE(1798),
    [sym_preproc_nullable] = STATE(1798),
    [sym_preproc_error] = STATE(1798),
    [sym_preproc_warning] = STATE(1798),
    [sym_preproc_define] = STATE(1798),
    [sym_preproc_undef] = STATE(1798),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1799] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4839),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1799),
    [sym_preproc_endregion] = STATE(1799),
    [sym_preproc_line] = STATE(1799),
    [sym_preproc_pragma] = STATE(1799),
    [sym_preproc_nullable] = STATE(1799),
    [sym_preproc_error] = STATE(1799),
    [sym_preproc_warning] = STATE(1799),
    [sym_preproc_define] = STATE(1799),
    [sym_preproc_undef] = STATE(1799),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1800] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4840),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1800),
    [sym_preproc_endregion] = STATE(1800),
    [sym_preproc_line] = STATE(1800),
    [sym_preproc_pragma] = STATE(1800),
    [sym_preproc_nullable] = STATE(1800),
    [sym_preproc_error] = STATE(1800),
    [sym_preproc_warning] = STATE(1800),
    [sym_preproc_define] = STATE(1800),
    [sym_preproc_undef] = STATE(1800),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1801] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4841),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1801),
    [sym_preproc_endregion] = STATE(1801),
    [sym_preproc_line] = STATE(1801),
    [sym_preproc_pragma] = STATE(1801),
    [sym_preproc_nullable] = STATE(1801),
    [sym_preproc_error] = STATE(1801),
    [sym_preproc_warning] = STATE(1801),
    [sym_preproc_define] = STATE(1801),
    [sym_preproc_undef] = STATE(1801),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1802] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4842),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1802),
    [sym_preproc_endregion] = STATE(1802),
    [sym_preproc_line] = STATE(1802),
    [sym_preproc_pragma] = STATE(1802),
    [sym_preproc_nullable] = STATE(1802),
    [sym_preproc_error] = STATE(1802),
    [sym_preproc_warning] = STATE(1802),
    [sym_preproc_define] = STATE(1802),
    [sym_preproc_undef] = STATE(1802),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1803] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4843),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1803),
    [sym_preproc_endregion] = STATE(1803),
    [sym_preproc_line] = STATE(1803),
    [sym_preproc_pragma] = STATE(1803),
    [sym_preproc_nullable] = STATE(1803),
    [sym_preproc_error] = STATE(1803),
    [sym_preproc_warning] = STATE(1803),
    [sym_preproc_define] = STATE(1803),
    [sym_preproc_undef] = STATE(1803),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1804] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4844),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1804),
    [sym_preproc_endregion] = STATE(1804),
    [sym_preproc_line] = STATE(1804),
    [sym_preproc_pragma] = STATE(1804),
    [sym_preproc_nullable] = STATE(1804),
    [sym_preproc_error] = STATE(1804),
    [sym_preproc_warning] = STATE(1804),
    [sym_preproc_define] = STATE(1804),
    [sym_preproc_undef] = STATE(1804),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1805] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4845),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1805),
    [sym_preproc_endregion] = STATE(1805),
    [sym_preproc_line] = STATE(1805),
    [sym_preproc_pragma] = STATE(1805),
    [sym_preproc_nullable] = STATE(1805),
    [sym_preproc_error] = STATE(1805),
    [sym_preproc_warning] = STATE(1805),
    [sym_preproc_define] = STATE(1805),
    [sym_preproc_undef] = STATE(1805),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1806] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4846),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1806),
    [sym_preproc_endregion] = STATE(1806),
    [sym_preproc_line] = STATE(1806),
    [sym_preproc_pragma] = STATE(1806),
    [sym_preproc_nullable] = STATE(1806),
    [sym_preproc_error] = STATE(1806),
    [sym_preproc_warning] = STATE(1806),
    [sym_preproc_define] = STATE(1806),
    [sym_preproc_undef] = STATE(1806),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1807] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1807),
    [sym_preproc_endregion] = STATE(1807),
    [sym_preproc_line] = STATE(1807),
    [sym_preproc_pragma] = STATE(1807),
    [sym_preproc_nullable] = STATE(1807),
    [sym_preproc_error] = STATE(1807),
    [sym_preproc_warning] = STATE(1807),
    [sym_preproc_define] = STATE(1807),
    [sym_preproc_undef] = STATE(1807),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1808] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4848),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1808),
    [sym_preproc_endregion] = STATE(1808),
    [sym_preproc_line] = STATE(1808),
    [sym_preproc_pragma] = STATE(1808),
    [sym_preproc_nullable] = STATE(1808),
    [sym_preproc_error] = STATE(1808),
    [sym_preproc_warning] = STATE(1808),
    [sym_preproc_define] = STATE(1808),
    [sym_preproc_undef] = STATE(1808),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1809] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4849),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1809),
    [sym_preproc_endregion] = STATE(1809),
    [sym_preproc_line] = STATE(1809),
    [sym_preproc_pragma] = STATE(1809),
    [sym_preproc_nullable] = STATE(1809),
    [sym_preproc_error] = STATE(1809),
    [sym_preproc_warning] = STATE(1809),
    [sym_preproc_define] = STATE(1809),
    [sym_preproc_undef] = STATE(1809),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1810] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4850),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1810),
    [sym_preproc_endregion] = STATE(1810),
    [sym_preproc_line] = STATE(1810),
    [sym_preproc_pragma] = STATE(1810),
    [sym_preproc_nullable] = STATE(1810),
    [sym_preproc_error] = STATE(1810),
    [sym_preproc_warning] = STATE(1810),
    [sym_preproc_define] = STATE(1810),
    [sym_preproc_undef] = STATE(1810),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1811] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4851),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1811),
    [sym_preproc_endregion] = STATE(1811),
    [sym_preproc_line] = STATE(1811),
    [sym_preproc_pragma] = STATE(1811),
    [sym_preproc_nullable] = STATE(1811),
    [sym_preproc_error] = STATE(1811),
    [sym_preproc_warning] = STATE(1811),
    [sym_preproc_define] = STATE(1811),
    [sym_preproc_undef] = STATE(1811),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1812] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3184),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1812),
    [sym_preproc_endregion] = STATE(1812),
    [sym_preproc_line] = STATE(1812),
    [sym_preproc_pragma] = STATE(1812),
    [sym_preproc_nullable] = STATE(1812),
    [sym_preproc_error] = STATE(1812),
    [sym_preproc_warning] = STATE(1812),
    [sym_preproc_define] = STATE(1812),
    [sym_preproc_undef] = STATE(1812),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1813] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4972),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1813),
    [sym_preproc_endregion] = STATE(1813),
    [sym_preproc_line] = STATE(1813),
    [sym_preproc_pragma] = STATE(1813),
    [sym_preproc_nullable] = STATE(1813),
    [sym_preproc_error] = STATE(1813),
    [sym_preproc_warning] = STATE(1813),
    [sym_preproc_define] = STATE(1813),
    [sym_preproc_undef] = STATE(1813),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1814] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4853),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1814),
    [sym_preproc_endregion] = STATE(1814),
    [sym_preproc_line] = STATE(1814),
    [sym_preproc_pragma] = STATE(1814),
    [sym_preproc_nullable] = STATE(1814),
    [sym_preproc_error] = STATE(1814),
    [sym_preproc_warning] = STATE(1814),
    [sym_preproc_define] = STATE(1814),
    [sym_preproc_undef] = STATE(1814),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1815] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5179),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1815),
    [sym_preproc_endregion] = STATE(1815),
    [sym_preproc_line] = STATE(1815),
    [sym_preproc_pragma] = STATE(1815),
    [sym_preproc_nullable] = STATE(1815),
    [sym_preproc_error] = STATE(1815),
    [sym_preproc_warning] = STATE(1815),
    [sym_preproc_define] = STATE(1815),
    [sym_preproc_undef] = STATE(1815),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1816] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5182),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1816),
    [sym_preproc_endregion] = STATE(1816),
    [sym_preproc_line] = STATE(1816),
    [sym_preproc_pragma] = STATE(1816),
    [sym_preproc_nullable] = STATE(1816),
    [sym_preproc_error] = STATE(1816),
    [sym_preproc_warning] = STATE(1816),
    [sym_preproc_define] = STATE(1816),
    [sym_preproc_undef] = STATE(1816),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1817] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4708),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1817),
    [sym_preproc_endregion] = STATE(1817),
    [sym_preproc_line] = STATE(1817),
    [sym_preproc_pragma] = STATE(1817),
    [sym_preproc_nullable] = STATE(1817),
    [sym_preproc_error] = STATE(1817),
    [sym_preproc_warning] = STATE(1817),
    [sym_preproc_define] = STATE(1817),
    [sym_preproc_undef] = STATE(1817),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1818] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4943),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1818),
    [sym_preproc_endregion] = STATE(1818),
    [sym_preproc_line] = STATE(1818),
    [sym_preproc_pragma] = STATE(1818),
    [sym_preproc_nullable] = STATE(1818),
    [sym_preproc_error] = STATE(1818),
    [sym_preproc_warning] = STATE(1818),
    [sym_preproc_define] = STATE(1818),
    [sym_preproc_undef] = STATE(1818),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1819] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4370),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3252),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6227),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7553),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1819),
    [sym_preproc_endregion] = STATE(1819),
    [sym_preproc_line] = STATE(1819),
    [sym_preproc_pragma] = STATE(1819),
    [sym_preproc_nullable] = STATE(1819),
    [sym_preproc_error] = STATE(1819),
    [sym_preproc_warning] = STATE(1819),
    [sym_preproc_define] = STATE(1819),
    [sym_preproc_undef] = STATE(1819),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_ref] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1820] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4452),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1820),
    [sym_preproc_endregion] = STATE(1820),
    [sym_preproc_line] = STATE(1820),
    [sym_preproc_pragma] = STATE(1820),
    [sym_preproc_nullable] = STATE(1820),
    [sym_preproc_error] = STATE(1820),
    [sym_preproc_warning] = STATE(1820),
    [sym_preproc_define] = STATE(1820),
    [sym_preproc_undef] = STATE(1820),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1821] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4973),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1821),
    [sym_preproc_endregion] = STATE(1821),
    [sym_preproc_line] = STATE(1821),
    [sym_preproc_pragma] = STATE(1821),
    [sym_preproc_nullable] = STATE(1821),
    [sym_preproc_error] = STATE(1821),
    [sym_preproc_warning] = STATE(1821),
    [sym_preproc_define] = STATE(1821),
    [sym_preproc_undef] = STATE(1821),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1822] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3960),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1822),
    [sym_preproc_endregion] = STATE(1822),
    [sym_preproc_line] = STATE(1822),
    [sym_preproc_pragma] = STATE(1822),
    [sym_preproc_nullable] = STATE(1822),
    [sym_preproc_error] = STATE(1822),
    [sym_preproc_warning] = STATE(1822),
    [sym_preproc_define] = STATE(1822),
    [sym_preproc_undef] = STATE(1822),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1823] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3962),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1823),
    [sym_preproc_endregion] = STATE(1823),
    [sym_preproc_line] = STATE(1823),
    [sym_preproc_pragma] = STATE(1823),
    [sym_preproc_nullable] = STATE(1823),
    [sym_preproc_error] = STATE(1823),
    [sym_preproc_warning] = STATE(1823),
    [sym_preproc_define] = STATE(1823),
    [sym_preproc_undef] = STATE(1823),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1824] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3952),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1824),
    [sym_preproc_endregion] = STATE(1824),
    [sym_preproc_line] = STATE(1824),
    [sym_preproc_pragma] = STATE(1824),
    [sym_preproc_nullable] = STATE(1824),
    [sym_preproc_error] = STATE(1824),
    [sym_preproc_warning] = STATE(1824),
    [sym_preproc_define] = STATE(1824),
    [sym_preproc_undef] = STATE(1824),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1825] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1825),
    [sym_preproc_endregion] = STATE(1825),
    [sym_preproc_line] = STATE(1825),
    [sym_preproc_pragma] = STATE(1825),
    [sym_preproc_nullable] = STATE(1825),
    [sym_preproc_error] = STATE(1825),
    [sym_preproc_warning] = STATE(1825),
    [sym_preproc_define] = STATE(1825),
    [sym_preproc_undef] = STATE(1825),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1826] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5707),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5458),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3719),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6200),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7570),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1826),
    [sym_preproc_endregion] = STATE(1826),
    [sym_preproc_line] = STATE(1826),
    [sym_preproc_pragma] = STATE(1826),
    [sym_preproc_nullable] = STATE(1826),
    [sym_preproc_error] = STATE(1826),
    [sym_preproc_warning] = STATE(1826),
    [sym_preproc_define] = STATE(1826),
    [sym_preproc_undef] = STATE(1826),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_ref] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1827] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1827),
    [sym_preproc_endregion] = STATE(1827),
    [sym_preproc_line] = STATE(1827),
    [sym_preproc_pragma] = STATE(1827),
    [sym_preproc_nullable] = STATE(1827),
    [sym_preproc_error] = STATE(1827),
    [sym_preproc_warning] = STATE(1827),
    [sym_preproc_define] = STATE(1827),
    [sym_preproc_undef] = STATE(1827),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1828] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5173),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1828),
    [sym_preproc_endregion] = STATE(1828),
    [sym_preproc_line] = STATE(1828),
    [sym_preproc_pragma] = STATE(1828),
    [sym_preproc_nullable] = STATE(1828),
    [sym_preproc_error] = STATE(1828),
    [sym_preproc_warning] = STATE(1828),
    [sym_preproc_define] = STATE(1828),
    [sym_preproc_undef] = STATE(1828),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1829] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3956),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1829),
    [sym_preproc_endregion] = STATE(1829),
    [sym_preproc_line] = STATE(1829),
    [sym_preproc_pragma] = STATE(1829),
    [sym_preproc_nullable] = STATE(1829),
    [sym_preproc_error] = STATE(1829),
    [sym_preproc_warning] = STATE(1829),
    [sym_preproc_define] = STATE(1829),
    [sym_preproc_undef] = STATE(1829),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1830] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4058),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1830),
    [sym_preproc_endregion] = STATE(1830),
    [sym_preproc_line] = STATE(1830),
    [sym_preproc_pragma] = STATE(1830),
    [sym_preproc_nullable] = STATE(1830),
    [sym_preproc_error] = STATE(1830),
    [sym_preproc_warning] = STATE(1830),
    [sym_preproc_define] = STATE(1830),
    [sym_preproc_undef] = STATE(1830),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1831] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4059),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1831),
    [sym_preproc_endregion] = STATE(1831),
    [sym_preproc_line] = STATE(1831),
    [sym_preproc_pragma] = STATE(1831),
    [sym_preproc_nullable] = STATE(1831),
    [sym_preproc_error] = STATE(1831),
    [sym_preproc_warning] = STATE(1831),
    [sym_preproc_define] = STATE(1831),
    [sym_preproc_undef] = STATE(1831),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1832] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4060),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1832),
    [sym_preproc_endregion] = STATE(1832),
    [sym_preproc_line] = STATE(1832),
    [sym_preproc_pragma] = STATE(1832),
    [sym_preproc_nullable] = STATE(1832),
    [sym_preproc_error] = STATE(1832),
    [sym_preproc_warning] = STATE(1832),
    [sym_preproc_define] = STATE(1832),
    [sym_preproc_undef] = STATE(1832),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1833] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3959),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1833),
    [sym_preproc_endregion] = STATE(1833),
    [sym_preproc_line] = STATE(1833),
    [sym_preproc_pragma] = STATE(1833),
    [sym_preproc_nullable] = STATE(1833),
    [sym_preproc_error] = STATE(1833),
    [sym_preproc_warning] = STATE(1833),
    [sym_preproc_define] = STATE(1833),
    [sym_preproc_undef] = STATE(1833),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1834] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3964),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1834),
    [sym_preproc_endregion] = STATE(1834),
    [sym_preproc_line] = STATE(1834),
    [sym_preproc_pragma] = STATE(1834),
    [sym_preproc_nullable] = STATE(1834),
    [sym_preproc_error] = STATE(1834),
    [sym_preproc_warning] = STATE(1834),
    [sym_preproc_define] = STATE(1834),
    [sym_preproc_undef] = STATE(1834),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1835] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3966),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1835),
    [sym_preproc_endregion] = STATE(1835),
    [sym_preproc_line] = STATE(1835),
    [sym_preproc_pragma] = STATE(1835),
    [sym_preproc_nullable] = STATE(1835),
    [sym_preproc_error] = STATE(1835),
    [sym_preproc_warning] = STATE(1835),
    [sym_preproc_define] = STATE(1835),
    [sym_preproc_undef] = STATE(1835),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1836] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4061),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1836),
    [sym_preproc_endregion] = STATE(1836),
    [sym_preproc_line] = STATE(1836),
    [sym_preproc_pragma] = STATE(1836),
    [sym_preproc_nullable] = STATE(1836),
    [sym_preproc_error] = STATE(1836),
    [sym_preproc_warning] = STATE(1836),
    [sym_preproc_define] = STATE(1836),
    [sym_preproc_undef] = STATE(1836),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1837] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3967),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1837),
    [sym_preproc_endregion] = STATE(1837),
    [sym_preproc_line] = STATE(1837),
    [sym_preproc_pragma] = STATE(1837),
    [sym_preproc_nullable] = STATE(1837),
    [sym_preproc_error] = STATE(1837),
    [sym_preproc_warning] = STATE(1837),
    [sym_preproc_define] = STATE(1837),
    [sym_preproc_undef] = STATE(1837),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1838] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3969),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1838),
    [sym_preproc_endregion] = STATE(1838),
    [sym_preproc_line] = STATE(1838),
    [sym_preproc_pragma] = STATE(1838),
    [sym_preproc_nullable] = STATE(1838),
    [sym_preproc_error] = STATE(1838),
    [sym_preproc_warning] = STATE(1838),
    [sym_preproc_define] = STATE(1838),
    [sym_preproc_undef] = STATE(1838),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1839] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3970),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1839),
    [sym_preproc_endregion] = STATE(1839),
    [sym_preproc_line] = STATE(1839),
    [sym_preproc_pragma] = STATE(1839),
    [sym_preproc_nullable] = STATE(1839),
    [sym_preproc_error] = STATE(1839),
    [sym_preproc_warning] = STATE(1839),
    [sym_preproc_define] = STATE(1839),
    [sym_preproc_undef] = STATE(1839),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1840] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3972),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1840),
    [sym_preproc_endregion] = STATE(1840),
    [sym_preproc_line] = STATE(1840),
    [sym_preproc_pragma] = STATE(1840),
    [sym_preproc_nullable] = STATE(1840),
    [sym_preproc_error] = STATE(1840),
    [sym_preproc_warning] = STATE(1840),
    [sym_preproc_define] = STATE(1840),
    [sym_preproc_undef] = STATE(1840),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1841] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2950),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1841),
    [sym_preproc_endregion] = STATE(1841),
    [sym_preproc_line] = STATE(1841),
    [sym_preproc_pragma] = STATE(1841),
    [sym_preproc_nullable] = STATE(1841),
    [sym_preproc_error] = STATE(1841),
    [sym_preproc_warning] = STATE(1841),
    [sym_preproc_define] = STATE(1841),
    [sym_preproc_undef] = STATE(1841),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1842] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5176),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1842),
    [sym_preproc_endregion] = STATE(1842),
    [sym_preproc_line] = STATE(1842),
    [sym_preproc_pragma] = STATE(1842),
    [sym_preproc_nullable] = STATE(1842),
    [sym_preproc_error] = STATE(1842),
    [sym_preproc_warning] = STATE(1842),
    [sym_preproc_define] = STATE(1842),
    [sym_preproc_undef] = STATE(1842),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1843] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5550),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3723),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6205),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7599),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2271),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1843),
    [sym_preproc_endregion] = STATE(1843),
    [sym_preproc_line] = STATE(1843),
    [sym_preproc_pragma] = STATE(1843),
    [sym_preproc_nullable] = STATE(1843),
    [sym_preproc_error] = STATE(1843),
    [sym_preproc_warning] = STATE(1843),
    [sym_preproc_define] = STATE(1843),
    [sym_preproc_undef] = STATE(1843),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_ref] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_CARET] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1844] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4947),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1844),
    [sym_preproc_endregion] = STATE(1844),
    [sym_preproc_line] = STATE(1844),
    [sym_preproc_pragma] = STATE(1844),
    [sym_preproc_nullable] = STATE(1844),
    [sym_preproc_error] = STATE(1844),
    [sym_preproc_warning] = STATE(1844),
    [sym_preproc_define] = STATE(1844),
    [sym_preproc_undef] = STATE(1844),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1845] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4884),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1845),
    [sym_preproc_endregion] = STATE(1845),
    [sym_preproc_line] = STATE(1845),
    [sym_preproc_pragma] = STATE(1845),
    [sym_preproc_nullable] = STATE(1845),
    [sym_preproc_error] = STATE(1845),
    [sym_preproc_warning] = STATE(1845),
    [sym_preproc_define] = STATE(1845),
    [sym_preproc_undef] = STATE(1845),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1846] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4886),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1846),
    [sym_preproc_endregion] = STATE(1846),
    [sym_preproc_line] = STATE(1846),
    [sym_preproc_pragma] = STATE(1846),
    [sym_preproc_nullable] = STATE(1846),
    [sym_preproc_error] = STATE(1846),
    [sym_preproc_warning] = STATE(1846),
    [sym_preproc_define] = STATE(1846),
    [sym_preproc_undef] = STATE(1846),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1847] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5112),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1847),
    [sym_preproc_endregion] = STATE(1847),
    [sym_preproc_line] = STATE(1847),
    [sym_preproc_pragma] = STATE(1847),
    [sym_preproc_nullable] = STATE(1847),
    [sym_preproc_error] = STATE(1847),
    [sym_preproc_warning] = STATE(1847),
    [sym_preproc_define] = STATE(1847),
    [sym_preproc_undef] = STATE(1847),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1848] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5954),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3686),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6221),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7539),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1848),
    [sym_preproc_endregion] = STATE(1848),
    [sym_preproc_line] = STATE(1848),
    [sym_preproc_pragma] = STATE(1848),
    [sym_preproc_nullable] = STATE(1848),
    [sym_preproc_error] = STATE(1848),
    [sym_preproc_warning] = STATE(1848),
    [sym_preproc_define] = STATE(1848),
    [sym_preproc_undef] = STATE(1848),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_ref] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(2129),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_DOT_DOT] = ACTIONS(2135),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1849] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5924),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2391),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2940),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3141),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6237),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7554),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1849),
    [sym_preproc_endregion] = STATE(1849),
    [sym_preproc_line] = STATE(1849),
    [sym_preproc_pragma] = STATE(1849),
    [sym_preproc_nullable] = STATE(1849),
    [sym_preproc_error] = STATE(1849),
    [sym_preproc_warning] = STATE(1849),
    [sym_preproc_define] = STATE(1849),
    [sym_preproc_undef] = STATE(1849),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_ref] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1850] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2625),
    [sym__name] = STATE(5931),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3177),
    [sym_non_lvalue_expression] = STATE(3343),
    [sym_lvalue_expression] = STATE(3557),
    [sym__expression_statement_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3346),
    [sym_binary_expression] = STATE(3325),
    [sym_postfix_unary_expression] = STATE(3346),
    [sym_prefix_unary_expression] = STATE(3346),
    [sym__pointer_indirection_expression] = STATE(2677),
    [sym_query_expression] = STATE(3325),
    [sym_from_clause] = STATE(6215),
    [sym_conditional_expression] = STATE(3325),
    [sym_conditional_access_expression] = STATE(3325),
    [sym_as_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_is_pattern_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_checked_expression] = STATE(3325),
    [sym_invocation_expression] = STATE(3346),
    [sym_switch_expression] = STATE(3325),
    [sym_await_expression] = STATE(3346),
    [sym_throw_expression] = STATE(3325),
    [sym_element_access_expression] = STATE(2677),
    [sym_interpolated_string_expression] = STATE(3325),
    [sym_member_access_expression] = STATE(2677),
    [sym_object_creation_expression] = STATE(3346),
    [sym_parenthesized_expression] = STATE(3346),
    [sym__parenthesized_lvalue_expression] = STATE(2677),
    [sym_lambda_expression] = STATE(3325),
    [sym__lambda_expression_init] = STATE(7559),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3325),
    [sym_anonymous_method_expression] = STATE(3325),
    [sym_anonymous_object_creation_expression] = STATE(3325),
    [sym_implicit_array_creation_expression] = STATE(3325),
    [sym_implicit_object_creation_expression] = STATE(3325),
    [sym_implicit_stackalloc_expression] = STATE(3325),
    [sym_initializer_expression] = STATE(3325),
    [sym_default_expression] = STATE(3325),
    [sym_with_expression] = STATE(3325),
    [sym_sizeof_expression] = STATE(3325),
    [sym_typeof_expression] = STATE(3325),
    [sym_makeref_expression] = STATE(3325),
    [sym_ref_expression] = STATE(3325),
    [sym_reftype_expression] = STATE(3325),
    [sym_refvalue_expression] = STATE(3325),
    [sym_stackalloc_expression] = STATE(3325),
    [sym_range_expression] = STATE(3325),
    [sym_tuple_expression] = STATE(2677),
    [sym_literal] = STATE(3325),
    [sym_character_literal] = STATE(3276),
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [sym_boolean_literal] = STATE(3276),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3325),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1850),
    [sym_preproc_endregion] = STATE(1850),
    [sym_preproc_line] = STATE(1850),
    [sym_preproc_pragma] = STATE(1850),
    [sym_preproc_nullable] = STATE(1850),
    [sym_preproc_error] = STATE(1850),
    [sym_preproc_warning] = STATE(1850),
    [sym_preproc_define] = STATE(1850),
    [sym_preproc_undef] = STATE(1850),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3512),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_ref] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_delegate] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_this] = ACTIONS(1185),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1189),
    [anon_sym_unchecked] = ACTIONS(1175),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1203),
    [anon_sym___makeref] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(1207),
    [anon_sym___refvalue] = ACTIONS(1209),
    [sym_null_literal] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_integer_literal] = ACTIONS(1211),
    [sym_real_literal] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [sym_verbatim_string_literal] = ACTIONS(1215),
    [aux_sym_preproc_if_token1] = ACTIONS(1807),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1221),
    [sym_interpolation_verbatim_start] = ACTIONS(1223),
    [sym_interpolation_raw_start] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1227),
  },
  [1851] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5646),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1851),
    [sym_preproc_endregion] = STATE(1851),
    [sym_preproc_line] = STATE(1851),
    [sym_preproc_pragma] = STATE(1851),
    [sym_preproc_nullable] = STATE(1851),
    [sym_preproc_error] = STATE(1851),
    [sym_preproc_warning] = STATE(1851),
    [sym_preproc_define] = STATE(1851),
    [sym_preproc_undef] = STATE(1851),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1852] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5150),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1852),
    [sym_preproc_endregion] = STATE(1852),
    [sym_preproc_line] = STATE(1852),
    [sym_preproc_pragma] = STATE(1852),
    [sym_preproc_nullable] = STATE(1852),
    [sym_preproc_error] = STATE(1852),
    [sym_preproc_warning] = STATE(1852),
    [sym_preproc_define] = STATE(1852),
    [sym_preproc_undef] = STATE(1852),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1853] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4370),
    [sym_non_lvalue_expression] = STATE(4632),
    [sym_lvalue_expression] = STATE(3480),
    [sym__expression_statement_expression] = STATE(4629),
    [sym_assignment_expression] = STATE(4633),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4633),
    [sym_prefix_unary_expression] = STATE(4633),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(4629),
    [sym_from_clause] = STATE(6209),
    [sym_conditional_expression] = STATE(4629),
    [sym_conditional_access_expression] = STATE(4629),
    [sym_as_expression] = STATE(4629),
    [sym_is_expression] = STATE(4629),
    [sym_is_pattern_expression] = STATE(4629),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(4629),
    [sym_invocation_expression] = STATE(4633),
    [sym_switch_expression] = STATE(4629),
    [sym_await_expression] = STATE(4633),
    [sym_throw_expression] = STATE(4629),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(4633),
    [sym_parenthesized_expression] = STATE(4633),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(4629),
    [sym__lambda_expression_init] = STATE(7483),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(4629),
    [sym_anonymous_method_expression] = STATE(4629),
    [sym_anonymous_object_creation_expression] = STATE(4629),
    [sym_implicit_array_creation_expression] = STATE(4629),
    [sym_implicit_object_creation_expression] = STATE(4629),
    [sym_implicit_stackalloc_expression] = STATE(4629),
    [sym_initializer_expression] = STATE(4629),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(4629),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(4629),
    [sym_ref_expression] = STATE(4629),
    [sym_reftype_expression] = STATE(4629),
    [sym_refvalue_expression] = STATE(4629),
    [sym_stackalloc_expression] = STATE(4629),
    [sym_range_expression] = STATE(4629),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4631),
    [sym_string_literal] = STATE(4631),
    [sym_raw_string_literal] = STATE(4631),
    [sym_boolean_literal] = STATE(4631),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(4629),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1853),
    [sym_preproc_endregion] = STATE(1853),
    [sym_preproc_line] = STATE(1853),
    [sym_preproc_pragma] = STATE(1853),
    [sym_preproc_nullable] = STATE(1853),
    [sym_preproc_error] = STATE(1853),
    [sym_preproc_warning] = STATE(1853),
    [sym_preproc_define] = STATE(1853),
    [sym_preproc_undef] = STATE(1853),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3495),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_delegate] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1405),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1407),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(1437),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym_typeof] = ACTIONS(1441),
    [anon_sym___makeref] = ACTIONS(1443),
    [anon_sym___reftype] = ACTIONS(1445),
    [anon_sym___refvalue] = ACTIONS(1447),
    [sym_null_literal] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [sym_integer_literal] = ACTIONS(1449),
    [sym_real_literal] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_verbatim_string_literal] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1459),
    [sym_interpolation_verbatim_start] = ACTIONS(1461),
    [sym_interpolation_raw_start] = ACTIONS(1463),
    [sym_raw_string_start] = ACTIONS(1465),
  },
  [1854] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(3253),
    [sym__name] = STATE(5941),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2326),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2272),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5738),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3219),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(3226),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(3226),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(3226),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(3226),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(3226),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2255),
    [sym__reserved_identifier] = STATE(2244),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1854),
    [sym_preproc_endregion] = STATE(1854),
    [sym_preproc_line] = STATE(1854),
    [sym_preproc_pragma] = STATE(1854),
    [sym_preproc_nullable] = STATE(1854),
    [sym_preproc_error] = STATE(1854),
    [sym_preproc_warning] = STATE(1854),
    [sym_preproc_define] = STATE(1854),
    [sym_preproc_undef] = STATE(1854),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(1391),
    [anon_sym_alias] = ACTIONS(1393),
    [anon_sym_global] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(1393),
    [anon_sym_notnull] = ACTIONS(1393),
    [anon_sym_unmanaged] = ACTIONS(1393),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1417),
    [anon_sym_scoped] = ACTIONS(1419),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(1423),
    [sym_predefined_type] = ACTIONS(1425),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(1435),
    [anon_sym_into] = ACTIONS(1393),
    [anon_sym_join] = ACTIONS(1393),
    [anon_sym_on] = ACTIONS(1393),
    [anon_sym_equals] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_orderby] = ACTIONS(1393),
    [anon_sym_ascending] = ACTIONS(1393),
    [anon_sym_descending] = ACTIONS(1393),
    [anon_sym_group] = ACTIONS(1393),
    [anon_sym_by] = ACTIONS(1393),
    [anon_sym_select] = ACTIONS(1393),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1855] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4932),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1855),
    [sym_preproc_endregion] = STATE(1855),
    [sym_preproc_line] = STATE(1855),
    [sym_preproc_pragma] = STATE(1855),
    [sym_preproc_nullable] = STATE(1855),
    [sym_preproc_error] = STATE(1855),
    [sym_preproc_warning] = STATE(1855),
    [sym_preproc_define] = STATE(1855),
    [sym_preproc_undef] = STATE(1855),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1856] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4933),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1856),
    [sym_preproc_endregion] = STATE(1856),
    [sym_preproc_line] = STATE(1856),
    [sym_preproc_pragma] = STATE(1856),
    [sym_preproc_nullable] = STATE(1856),
    [sym_preproc_error] = STATE(1856),
    [sym_preproc_warning] = STATE(1856),
    [sym_preproc_define] = STATE(1856),
    [sym_preproc_undef] = STATE(1856),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1857] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4238),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1857),
    [sym_preproc_endregion] = STATE(1857),
    [sym_preproc_line] = STATE(1857),
    [sym_preproc_pragma] = STATE(1857),
    [sym_preproc_nullable] = STATE(1857),
    [sym_preproc_error] = STATE(1857),
    [sym_preproc_warning] = STATE(1857),
    [sym_preproc_define] = STATE(1857),
    [sym_preproc_undef] = STATE(1857),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1858] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4241),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1858),
    [sym_preproc_endregion] = STATE(1858),
    [sym_preproc_line] = STATE(1858),
    [sym_preproc_pragma] = STATE(1858),
    [sym_preproc_nullable] = STATE(1858),
    [sym_preproc_error] = STATE(1858),
    [sym_preproc_warning] = STATE(1858),
    [sym_preproc_define] = STATE(1858),
    [sym_preproc_undef] = STATE(1858),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1859] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4228),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1859),
    [sym_preproc_endregion] = STATE(1859),
    [sym_preproc_line] = STATE(1859),
    [sym_preproc_pragma] = STATE(1859),
    [sym_preproc_nullable] = STATE(1859),
    [sym_preproc_error] = STATE(1859),
    [sym_preproc_warning] = STATE(1859),
    [sym_preproc_define] = STATE(1859),
    [sym_preproc_undef] = STATE(1859),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1860] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4245),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1860),
    [sym_preproc_endregion] = STATE(1860),
    [sym_preproc_line] = STATE(1860),
    [sym_preproc_pragma] = STATE(1860),
    [sym_preproc_nullable] = STATE(1860),
    [sym_preproc_error] = STATE(1860),
    [sym_preproc_warning] = STATE(1860),
    [sym_preproc_define] = STATE(1860),
    [sym_preproc_undef] = STATE(1860),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1861] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5490),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1861),
    [sym_preproc_endregion] = STATE(1861),
    [sym_preproc_line] = STATE(1861),
    [sym_preproc_pragma] = STATE(1861),
    [sym_preproc_nullable] = STATE(1861),
    [sym_preproc_error] = STATE(1861),
    [sym_preproc_warning] = STATE(1861),
    [sym_preproc_define] = STATE(1861),
    [sym_preproc_undef] = STATE(1861),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1862] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4247),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1862),
    [sym_preproc_endregion] = STATE(1862),
    [sym_preproc_line] = STATE(1862),
    [sym_preproc_pragma] = STATE(1862),
    [sym_preproc_nullable] = STATE(1862),
    [sym_preproc_error] = STATE(1862),
    [sym_preproc_warning] = STATE(1862),
    [sym_preproc_define] = STATE(1862),
    [sym_preproc_undef] = STATE(1862),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1863] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5497),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1863),
    [sym_preproc_endregion] = STATE(1863),
    [sym_preproc_line] = STATE(1863),
    [sym_preproc_pragma] = STATE(1863),
    [sym_preproc_nullable] = STATE(1863),
    [sym_preproc_error] = STATE(1863),
    [sym_preproc_warning] = STATE(1863),
    [sym_preproc_define] = STATE(1863),
    [sym_preproc_undef] = STATE(1863),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1864] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4257),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1864),
    [sym_preproc_endregion] = STATE(1864),
    [sym_preproc_line] = STATE(1864),
    [sym_preproc_pragma] = STATE(1864),
    [sym_preproc_nullable] = STATE(1864),
    [sym_preproc_error] = STATE(1864),
    [sym_preproc_warning] = STATE(1864),
    [sym_preproc_define] = STATE(1864),
    [sym_preproc_undef] = STATE(1864),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1865] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4221),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1865),
    [sym_preproc_endregion] = STATE(1865),
    [sym_preproc_line] = STATE(1865),
    [sym_preproc_pragma] = STATE(1865),
    [sym_preproc_nullable] = STATE(1865),
    [sym_preproc_error] = STATE(1865),
    [sym_preproc_warning] = STATE(1865),
    [sym_preproc_define] = STATE(1865),
    [sym_preproc_undef] = STATE(1865),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1866] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1866),
    [sym_preproc_endregion] = STATE(1866),
    [sym_preproc_line] = STATE(1866),
    [sym_preproc_pragma] = STATE(1866),
    [sym_preproc_nullable] = STATE(1866),
    [sym_preproc_error] = STATE(1866),
    [sym_preproc_warning] = STATE(1866),
    [sym_preproc_define] = STATE(1866),
    [sym_preproc_undef] = STATE(1866),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1867] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4263),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1867),
    [sym_preproc_endregion] = STATE(1867),
    [sym_preproc_line] = STATE(1867),
    [sym_preproc_pragma] = STATE(1867),
    [sym_preproc_nullable] = STATE(1867),
    [sym_preproc_error] = STATE(1867),
    [sym_preproc_warning] = STATE(1867),
    [sym_preproc_define] = STATE(1867),
    [sym_preproc_undef] = STATE(1867),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1868] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4264),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1868),
    [sym_preproc_endregion] = STATE(1868),
    [sym_preproc_line] = STATE(1868),
    [sym_preproc_pragma] = STATE(1868),
    [sym_preproc_nullable] = STATE(1868),
    [sym_preproc_error] = STATE(1868),
    [sym_preproc_warning] = STATE(1868),
    [sym_preproc_define] = STATE(1868),
    [sym_preproc_undef] = STATE(1868),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1869] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5512),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1869),
    [sym_preproc_endregion] = STATE(1869),
    [sym_preproc_line] = STATE(1869),
    [sym_preproc_pragma] = STATE(1869),
    [sym_preproc_nullable] = STATE(1869),
    [sym_preproc_error] = STATE(1869),
    [sym_preproc_warning] = STATE(1869),
    [sym_preproc_define] = STATE(1869),
    [sym_preproc_undef] = STATE(1869),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1870] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4265),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1870),
    [sym_preproc_endregion] = STATE(1870),
    [sym_preproc_line] = STATE(1870),
    [sym_preproc_pragma] = STATE(1870),
    [sym_preproc_nullable] = STATE(1870),
    [sym_preproc_error] = STATE(1870),
    [sym_preproc_warning] = STATE(1870),
    [sym_preproc_define] = STATE(1870),
    [sym_preproc_undef] = STATE(1870),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1871] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5519),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1871),
    [sym_preproc_endregion] = STATE(1871),
    [sym_preproc_line] = STATE(1871),
    [sym_preproc_pragma] = STATE(1871),
    [sym_preproc_nullable] = STATE(1871),
    [sym_preproc_error] = STATE(1871),
    [sym_preproc_warning] = STATE(1871),
    [sym_preproc_define] = STATE(1871),
    [sym_preproc_undef] = STATE(1871),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1872] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4935),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1872),
    [sym_preproc_endregion] = STATE(1872),
    [sym_preproc_line] = STATE(1872),
    [sym_preproc_pragma] = STATE(1872),
    [sym_preproc_nullable] = STATE(1872),
    [sym_preproc_error] = STATE(1872),
    [sym_preproc_warning] = STATE(1872),
    [sym_preproc_define] = STATE(1872),
    [sym_preproc_undef] = STATE(1872),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1873] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3262),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3188),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6213),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7682),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1873),
    [sym_preproc_endregion] = STATE(1873),
    [sym_preproc_line] = STATE(1873),
    [sym_preproc_pragma] = STATE(1873),
    [sym_preproc_nullable] = STATE(1873),
    [sym_preproc_error] = STATE(1873),
    [sym_preproc_warning] = STATE(1873),
    [sym_preproc_define] = STATE(1873),
    [sym_preproc_undef] = STATE(1873),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_ref] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1335),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1874] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5539),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1874),
    [sym_preproc_endregion] = STATE(1874),
    [sym_preproc_line] = STATE(1874),
    [sym_preproc_pragma] = STATE(1874),
    [sym_preproc_nullable] = STATE(1874),
    [sym_preproc_error] = STATE(1874),
    [sym_preproc_warning] = STATE(1874),
    [sym_preproc_define] = STATE(1874),
    [sym_preproc_undef] = STATE(1874),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1875] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5279),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2212),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4936),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3568),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7470),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1875),
    [sym_preproc_endregion] = STATE(1875),
    [sym_preproc_line] = STATE(1875),
    [sym_preproc_pragma] = STATE(1875),
    [sym_preproc_nullable] = STATE(1875),
    [sym_preproc_error] = STATE(1875),
    [sym_preproc_warning] = STATE(1875),
    [sym_preproc_define] = STATE(1875),
    [sym_preproc_undef] = STATE(1875),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1876] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3858),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1876),
    [sym_preproc_endregion] = STATE(1876),
    [sym_preproc_line] = STATE(1876),
    [sym_preproc_pragma] = STATE(1876),
    [sym_preproc_nullable] = STATE(1876),
    [sym_preproc_error] = STATE(1876),
    [sym_preproc_warning] = STATE(1876),
    [sym_preproc_define] = STATE(1876),
    [sym_preproc_undef] = STATE(1876),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1877] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3597),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1877),
    [sym_preproc_endregion] = STATE(1877),
    [sym_preproc_line] = STATE(1877),
    [sym_preproc_pragma] = STATE(1877),
    [sym_preproc_nullable] = STATE(1877),
    [sym_preproc_error] = STATE(1877),
    [sym_preproc_warning] = STATE(1877),
    [sym_preproc_define] = STATE(1877),
    [sym_preproc_undef] = STATE(1877),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1878] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5548),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1878),
    [sym_preproc_endregion] = STATE(1878),
    [sym_preproc_line] = STATE(1878),
    [sym_preproc_pragma] = STATE(1878),
    [sym_preproc_nullable] = STATE(1878),
    [sym_preproc_error] = STATE(1878),
    [sym_preproc_warning] = STATE(1878),
    [sym_preproc_define] = STATE(1878),
    [sym_preproc_undef] = STATE(1878),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1879] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5557),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1879),
    [sym_preproc_endregion] = STATE(1879),
    [sym_preproc_line] = STATE(1879),
    [sym_preproc_pragma] = STATE(1879),
    [sym_preproc_nullable] = STATE(1879),
    [sym_preproc_error] = STATE(1879),
    [sym_preproc_warning] = STATE(1879),
    [sym_preproc_define] = STATE(1879),
    [sym_preproc_undef] = STATE(1879),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1880] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5223),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1880),
    [sym_preproc_endregion] = STATE(1880),
    [sym_preproc_line] = STATE(1880),
    [sym_preproc_pragma] = STATE(1880),
    [sym_preproc_nullable] = STATE(1880),
    [sym_preproc_error] = STATE(1880),
    [sym_preproc_warning] = STATE(1880),
    [sym_preproc_define] = STATE(1880),
    [sym_preproc_undef] = STATE(1880),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1881] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3788),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1881),
    [sym_preproc_endregion] = STATE(1881),
    [sym_preproc_line] = STATE(1881),
    [sym_preproc_pragma] = STATE(1881),
    [sym_preproc_nullable] = STATE(1881),
    [sym_preproc_error] = STATE(1881),
    [sym_preproc_warning] = STATE(1881),
    [sym_preproc_define] = STATE(1881),
    [sym_preproc_undef] = STATE(1881),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1882] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5603),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3720),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6230),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7556),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1882),
    [sym_preproc_endregion] = STATE(1882),
    [sym_preproc_line] = STATE(1882),
    [sym_preproc_pragma] = STATE(1882),
    [sym_preproc_nullable] = STATE(1882),
    [sym_preproc_error] = STATE(1882),
    [sym_preproc_warning] = STATE(1882),
    [sym_preproc_define] = STATE(1882),
    [sym_preproc_undef] = STATE(1882),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_ref] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1883] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5566),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1883),
    [sym_preproc_endregion] = STATE(1883),
    [sym_preproc_line] = STATE(1883),
    [sym_preproc_pragma] = STATE(1883),
    [sym_preproc_nullable] = STATE(1883),
    [sym_preproc_error] = STATE(1883),
    [sym_preproc_warning] = STATE(1883),
    [sym_preproc_define] = STATE(1883),
    [sym_preproc_undef] = STATE(1883),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1884] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3639),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(2947),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6220),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7600),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1884),
    [sym_preproc_endregion] = STATE(1884),
    [sym_preproc_line] = STATE(1884),
    [sym_preproc_pragma] = STATE(1884),
    [sym_preproc_nullable] = STATE(1884),
    [sym_preproc_error] = STATE(1884),
    [sym_preproc_warning] = STATE(1884),
    [sym_preproc_define] = STATE(1884),
    [sym_preproc_undef] = STATE(1884),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_ref] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1885] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3839),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1885),
    [sym_preproc_endregion] = STATE(1885),
    [sym_preproc_line] = STATE(1885),
    [sym_preproc_pragma] = STATE(1885),
    [sym_preproc_nullable] = STATE(1885),
    [sym_preproc_error] = STATE(1885),
    [sym_preproc_warning] = STATE(1885),
    [sym_preproc_define] = STATE(1885),
    [sym_preproc_undef] = STATE(1885),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1886] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5572),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1886),
    [sym_preproc_endregion] = STATE(1886),
    [sym_preproc_line] = STATE(1886),
    [sym_preproc_pragma] = STATE(1886),
    [sym_preproc_nullable] = STATE(1886),
    [sym_preproc_error] = STATE(1886),
    [sym_preproc_warning] = STATE(1886),
    [sym_preproc_define] = STATE(1886),
    [sym_preproc_undef] = STATE(1886),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1887] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5576),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1887),
    [sym_preproc_endregion] = STATE(1887),
    [sym_preproc_line] = STATE(1887),
    [sym_preproc_pragma] = STATE(1887),
    [sym_preproc_nullable] = STATE(1887),
    [sym_preproc_error] = STATE(1887),
    [sym_preproc_warning] = STATE(1887),
    [sym_preproc_define] = STATE(1887),
    [sym_preproc_undef] = STATE(1887),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1888] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(4394),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1888),
    [sym_preproc_endregion] = STATE(1888),
    [sym_preproc_line] = STATE(1888),
    [sym_preproc_pragma] = STATE(1888),
    [sym_preproc_nullable] = STATE(1888),
    [sym_preproc_error] = STATE(1888),
    [sym_preproc_warning] = STATE(1888),
    [sym_preproc_define] = STATE(1888),
    [sym_preproc_undef] = STATE(1888),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1889] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5580),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1889),
    [sym_preproc_endregion] = STATE(1889),
    [sym_preproc_line] = STATE(1889),
    [sym_preproc_pragma] = STATE(1889),
    [sym_preproc_nullable] = STATE(1889),
    [sym_preproc_error] = STATE(1889),
    [sym_preproc_warning] = STATE(1889),
    [sym_preproc_define] = STATE(1889),
    [sym_preproc_undef] = STATE(1889),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1890] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2458),
    [sym__name] = STATE(5950),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2205),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(2942),
    [sym_non_lvalue_expression] = STATE(3070),
    [sym_lvalue_expression] = STATE(3379),
    [sym__expression_statement_expression] = STATE(3064),
    [sym_assignment_expression] = STATE(3071),
    [sym_binary_expression] = STATE(3064),
    [sym_postfix_unary_expression] = STATE(3071),
    [sym_prefix_unary_expression] = STATE(3071),
    [sym__pointer_indirection_expression] = STATE(2457),
    [sym_query_expression] = STATE(3064),
    [sym_from_clause] = STATE(6212),
    [sym_conditional_expression] = STATE(3064),
    [sym_conditional_access_expression] = STATE(3064),
    [sym_as_expression] = STATE(3064),
    [sym_is_expression] = STATE(3064),
    [sym_is_pattern_expression] = STATE(3064),
    [sym_cast_expression] = STATE(3064),
    [sym_checked_expression] = STATE(3064),
    [sym_invocation_expression] = STATE(3071),
    [sym_switch_expression] = STATE(3064),
    [sym_await_expression] = STATE(3071),
    [sym_throw_expression] = STATE(3064),
    [sym_element_access_expression] = STATE(2457),
    [sym_interpolated_string_expression] = STATE(3064),
    [sym_member_access_expression] = STATE(2457),
    [sym_object_creation_expression] = STATE(3071),
    [sym_parenthesized_expression] = STATE(3071),
    [sym__parenthesized_lvalue_expression] = STATE(2457),
    [sym_lambda_expression] = STATE(3064),
    [sym__lambda_expression_init] = STATE(7629),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3064),
    [sym_anonymous_method_expression] = STATE(3064),
    [sym_anonymous_object_creation_expression] = STATE(3064),
    [sym_implicit_array_creation_expression] = STATE(3064),
    [sym_implicit_object_creation_expression] = STATE(3064),
    [sym_implicit_stackalloc_expression] = STATE(3064),
    [sym_initializer_expression] = STATE(3064),
    [sym_default_expression] = STATE(3064),
    [sym_with_expression] = STATE(3064),
    [sym_sizeof_expression] = STATE(3064),
    [sym_typeof_expression] = STATE(3064),
    [sym_makeref_expression] = STATE(3064),
    [sym_ref_expression] = STATE(3064),
    [sym_reftype_expression] = STATE(3064),
    [sym_refvalue_expression] = STATE(3064),
    [sym_stackalloc_expression] = STATE(3064),
    [sym_range_expression] = STATE(3064),
    [sym_tuple_expression] = STATE(2457),
    [sym_literal] = STATE(3064),
    [sym_character_literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_raw_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3064),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1890),
    [sym_preproc_endregion] = STATE(1890),
    [sym_preproc_line] = STATE(1890),
    [sym_preproc_pragma] = STATE(1890),
    [sym_preproc_nullable] = STATE(1890),
    [sym_preproc_error] = STATE(1890),
    [sym_preproc_warning] = STATE(1890),
    [sym_preproc_define] = STATE(1890),
    [sym_preproc_undef] = STATE(1890),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3487),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_ref] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_delegate] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_this] = ACTIONS(1267),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1271),
    [anon_sym_unchecked] = ACTIONS(1257),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1281),
    [anon_sym_sizeof] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym___makeref] = ACTIONS(1287),
    [anon_sym___reftype] = ACTIONS(1289),
    [anon_sym___refvalue] = ACTIONS(1291),
    [sym_null_literal] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_integer_literal] = ACTIONS(1293),
    [sym_real_literal] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_verbatim_string_literal] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1303),
    [sym_interpolation_verbatim_start] = ACTIONS(1305),
    [sym_interpolation_raw_start] = ACTIONS(1307),
    [sym_raw_string_start] = ACTIONS(1309),
  },
  [1891] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5663),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1891),
    [sym_preproc_endregion] = STATE(1891),
    [sym_preproc_line] = STATE(1891),
    [sym_preproc_pragma] = STATE(1891),
    [sym_preproc_nullable] = STATE(1891),
    [sym_preproc_error] = STATE(1891),
    [sym_preproc_warning] = STATE(1891),
    [sym_preproc_define] = STATE(1891),
    [sym_preproc_undef] = STATE(1891),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1892] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3741),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1892),
    [sym_preproc_endregion] = STATE(1892),
    [sym_preproc_line] = STATE(1892),
    [sym_preproc_pragma] = STATE(1892),
    [sym_preproc_nullable] = STATE(1892),
    [sym_preproc_error] = STATE(1892),
    [sym_preproc_warning] = STATE(1892),
    [sym_preproc_define] = STATE(1892),
    [sym_preproc_undef] = STATE(1892),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1893] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5582),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1893),
    [sym_preproc_endregion] = STATE(1893),
    [sym_preproc_line] = STATE(1893),
    [sym_preproc_pragma] = STATE(1893),
    [sym_preproc_nullable] = STATE(1893),
    [sym_preproc_error] = STATE(1893),
    [sym_preproc_warning] = STATE(1893),
    [sym_preproc_define] = STATE(1893),
    [sym_preproc_undef] = STATE(1893),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1894] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5657),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1894),
    [sym_preproc_endregion] = STATE(1894),
    [sym_preproc_line] = STATE(1894),
    [sym_preproc_pragma] = STATE(1894),
    [sym_preproc_nullable] = STATE(1894),
    [sym_preproc_error] = STATE(1894),
    [sym_preproc_warning] = STATE(1894),
    [sym_preproc_define] = STATE(1894),
    [sym_preproc_undef] = STATE(1894),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1895] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5583),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1895),
    [sym_preproc_endregion] = STATE(1895),
    [sym_preproc_line] = STATE(1895),
    [sym_preproc_pragma] = STATE(1895),
    [sym_preproc_nullable] = STATE(1895),
    [sym_preproc_error] = STATE(1895),
    [sym_preproc_warning] = STATE(1895),
    [sym_preproc_define] = STATE(1895),
    [sym_preproc_undef] = STATE(1895),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1896] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5585),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1896),
    [sym_preproc_endregion] = STATE(1896),
    [sym_preproc_line] = STATE(1896),
    [sym_preproc_pragma] = STATE(1896),
    [sym_preproc_nullable] = STATE(1896),
    [sym_preproc_error] = STATE(1896),
    [sym_preproc_warning] = STATE(1896),
    [sym_preproc_define] = STATE(1896),
    [sym_preproc_undef] = STATE(1896),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1897] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5586),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1897),
    [sym_preproc_endregion] = STATE(1897),
    [sym_preproc_line] = STATE(1897),
    [sym_preproc_pragma] = STATE(1897),
    [sym_preproc_nullable] = STATE(1897),
    [sym_preproc_error] = STATE(1897),
    [sym_preproc_warning] = STATE(1897),
    [sym_preproc_define] = STATE(1897),
    [sym_preproc_undef] = STATE(1897),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1898] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5587),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1898),
    [sym_preproc_endregion] = STATE(1898),
    [sym_preproc_line] = STATE(1898),
    [sym_preproc_pragma] = STATE(1898),
    [sym_preproc_nullable] = STATE(1898),
    [sym_preproc_error] = STATE(1898),
    [sym_preproc_warning] = STATE(1898),
    [sym_preproc_define] = STATE(1898),
    [sym_preproc_undef] = STATE(1898),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1899] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5588),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1899),
    [sym_preproc_endregion] = STATE(1899),
    [sym_preproc_line] = STATE(1899),
    [sym_preproc_pragma] = STATE(1899),
    [sym_preproc_nullable] = STATE(1899),
    [sym_preproc_error] = STATE(1899),
    [sym_preproc_warning] = STATE(1899),
    [sym_preproc_define] = STATE(1899),
    [sym_preproc_undef] = STATE(1899),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1900] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3742),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1900),
    [sym_preproc_endregion] = STATE(1900),
    [sym_preproc_line] = STATE(1900),
    [sym_preproc_pragma] = STATE(1900),
    [sym_preproc_nullable] = STATE(1900),
    [sym_preproc_error] = STATE(1900),
    [sym_preproc_warning] = STATE(1900),
    [sym_preproc_define] = STATE(1900),
    [sym_preproc_undef] = STATE(1900),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1901] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5605),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1901),
    [sym_preproc_endregion] = STATE(1901),
    [sym_preproc_line] = STATE(1901),
    [sym_preproc_pragma] = STATE(1901),
    [sym_preproc_nullable] = STATE(1901),
    [sym_preproc_error] = STATE(1901),
    [sym_preproc_warning] = STATE(1901),
    [sym_preproc_define] = STATE(1901),
    [sym_preproc_undef] = STATE(1901),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1902] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3743),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1902),
    [sym_preproc_endregion] = STATE(1902),
    [sym_preproc_line] = STATE(1902),
    [sym_preproc_pragma] = STATE(1902),
    [sym_preproc_nullable] = STATE(1902),
    [sym_preproc_error] = STATE(1902),
    [sym_preproc_warning] = STATE(1902),
    [sym_preproc_define] = STATE(1902),
    [sym_preproc_undef] = STATE(1902),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1903] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3801),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1903),
    [sym_preproc_endregion] = STATE(1903),
    [sym_preproc_line] = STATE(1903),
    [sym_preproc_pragma] = STATE(1903),
    [sym_preproc_nullable] = STATE(1903),
    [sym_preproc_error] = STATE(1903),
    [sym_preproc_warning] = STATE(1903),
    [sym_preproc_define] = STATE(1903),
    [sym_preproc_undef] = STATE(1903),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1904] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3818),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1904),
    [sym_preproc_endregion] = STATE(1904),
    [sym_preproc_line] = STATE(1904),
    [sym_preproc_pragma] = STATE(1904),
    [sym_preproc_nullable] = STATE(1904),
    [sym_preproc_error] = STATE(1904),
    [sym_preproc_warning] = STATE(1904),
    [sym_preproc_define] = STATE(1904),
    [sym_preproc_undef] = STATE(1904),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1905] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3849),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1905),
    [sym_preproc_endregion] = STATE(1905),
    [sym_preproc_line] = STATE(1905),
    [sym_preproc_pragma] = STATE(1905),
    [sym_preproc_nullable] = STATE(1905),
    [sym_preproc_error] = STATE(1905),
    [sym_preproc_warning] = STATE(1905),
    [sym_preproc_define] = STATE(1905),
    [sym_preproc_undef] = STATE(1905),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1906] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5668),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1906),
    [sym_preproc_endregion] = STATE(1906),
    [sym_preproc_line] = STATE(1906),
    [sym_preproc_pragma] = STATE(1906),
    [sym_preproc_nullable] = STATE(1906),
    [sym_preproc_error] = STATE(1906),
    [sym_preproc_warning] = STATE(1906),
    [sym_preproc_define] = STATE(1906),
    [sym_preproc_undef] = STATE(1906),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1907] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5678),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1907),
    [sym_preproc_endregion] = STATE(1907),
    [sym_preproc_line] = STATE(1907),
    [sym_preproc_pragma] = STATE(1907),
    [sym_preproc_nullable] = STATE(1907),
    [sym_preproc_error] = STATE(1907),
    [sym_preproc_warning] = STATE(1907),
    [sym_preproc_define] = STATE(1907),
    [sym_preproc_undef] = STATE(1907),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1908] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5689),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1908),
    [sym_preproc_endregion] = STATE(1908),
    [sym_preproc_line] = STATE(1908),
    [sym_preproc_pragma] = STATE(1908),
    [sym_preproc_nullable] = STATE(1908),
    [sym_preproc_error] = STATE(1908),
    [sym_preproc_warning] = STATE(1908),
    [sym_preproc_define] = STATE(1908),
    [sym_preproc_undef] = STATE(1908),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1909] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5928),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2251),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5693),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3472),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6204),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7361),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1909),
    [sym_preproc_endregion] = STATE(1909),
    [sym_preproc_line] = STATE(1909),
    [sym_preproc_pragma] = STATE(1909),
    [sym_preproc_nullable] = STATE(1909),
    [sym_preproc_error] = STATE(1909),
    [sym_preproc_warning] = STATE(1909),
    [sym_preproc_define] = STATE(1909),
    [sym_preproc_undef] = STATE(1909),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_ref] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1059),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1515),
    [anon_sym_DASH_DASH] = ACTIONS(1515),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1077),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1910] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3745),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1910),
    [sym_preproc_endregion] = STATE(1910),
    [sym_preproc_line] = STATE(1910),
    [sym_preproc_pragma] = STATE(1910),
    [sym_preproc_nullable] = STATE(1910),
    [sym_preproc_error] = STATE(1910),
    [sym_preproc_warning] = STATE(1910),
    [sym_preproc_define] = STATE(1910),
    [sym_preproc_undef] = STATE(1910),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1911] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3850),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1911),
    [sym_preproc_endregion] = STATE(1911),
    [sym_preproc_line] = STATE(1911),
    [sym_preproc_pragma] = STATE(1911),
    [sym_preproc_nullable] = STATE(1911),
    [sym_preproc_error] = STATE(1911),
    [sym_preproc_warning] = STATE(1911),
    [sym_preproc_define] = STATE(1911),
    [sym_preproc_undef] = STATE(1911),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1912] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2495),
    [sym__name] = STATE(5943),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2389),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5701),
    [sym_non_lvalue_expression] = STATE(3120),
    [sym_lvalue_expression] = STATE(3709),
    [sym__expression_statement_expression] = STATE(3117),
    [sym_assignment_expression] = STATE(3116),
    [sym_binary_expression] = STATE(3117),
    [sym_postfix_unary_expression] = STATE(3116),
    [sym_prefix_unary_expression] = STATE(3116),
    [sym__pointer_indirection_expression] = STATE(2503),
    [sym_query_expression] = STATE(3117),
    [sym_from_clause] = STATE(6224),
    [sym_conditional_expression] = STATE(3117),
    [sym_conditional_access_expression] = STATE(3117),
    [sym_as_expression] = STATE(3117),
    [sym_is_expression] = STATE(3117),
    [sym_is_pattern_expression] = STATE(3117),
    [sym_cast_expression] = STATE(3117),
    [sym_checked_expression] = STATE(3117),
    [sym_invocation_expression] = STATE(3116),
    [sym_switch_expression] = STATE(3117),
    [sym_await_expression] = STATE(3116),
    [sym_throw_expression] = STATE(3117),
    [sym_element_access_expression] = STATE(2503),
    [sym_interpolated_string_expression] = STATE(3117),
    [sym_member_access_expression] = STATE(2503),
    [sym_object_creation_expression] = STATE(3116),
    [sym_parenthesized_expression] = STATE(3116),
    [sym__parenthesized_lvalue_expression] = STATE(2503),
    [sym_lambda_expression] = STATE(3117),
    [sym__lambda_expression_init] = STATE(7352),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3117),
    [sym_anonymous_method_expression] = STATE(3117),
    [sym_anonymous_object_creation_expression] = STATE(3117),
    [sym_implicit_array_creation_expression] = STATE(3117),
    [sym_implicit_object_creation_expression] = STATE(3117),
    [sym_implicit_stackalloc_expression] = STATE(3117),
    [sym_initializer_expression] = STATE(3117),
    [sym_default_expression] = STATE(3117),
    [sym_with_expression] = STATE(3117),
    [sym_sizeof_expression] = STATE(3117),
    [sym_typeof_expression] = STATE(3117),
    [sym_makeref_expression] = STATE(3117),
    [sym_ref_expression] = STATE(3117),
    [sym_reftype_expression] = STATE(3117),
    [sym_refvalue_expression] = STATE(3117),
    [sym_stackalloc_expression] = STATE(3117),
    [sym_range_expression] = STATE(3117),
    [sym_tuple_expression] = STATE(2503),
    [sym_literal] = STATE(3117),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3117),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1912),
    [sym_preproc_endregion] = STATE(1912),
    [sym_preproc_line] = STATE(1912),
    [sym_preproc_pragma] = STATE(1912),
    [sym_preproc_nullable] = STATE(1912),
    [sym_preproc_error] = STATE(1912),
    [sym_preproc_warning] = STATE(1912),
    [sym_preproc_define] = STATE(1912),
    [sym_preproc_undef] = STATE(1912),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3550),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_ref] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_delegate] = ACTIONS(665),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_this] = ACTIONS(83),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(87),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(2227),
    [anon_sym_DOT_DOT] = ACTIONS(2229),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1913] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2937),
    [sym__name] = STATE(5918),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2381),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(3852),
    [sym_non_lvalue_expression] = STATE(3876),
    [sym_lvalue_expression] = STATE(3094),
    [sym__expression_statement_expression] = STATE(3906),
    [sym_assignment_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3906),
    [sym_postfix_unary_expression] = STATE(3879),
    [sym_prefix_unary_expression] = STATE(3879),
    [sym__pointer_indirection_expression] = STATE(2944),
    [sym_query_expression] = STATE(3906),
    [sym_from_clause] = STATE(6210),
    [sym_conditional_expression] = STATE(3906),
    [sym_conditional_access_expression] = STATE(3906),
    [sym_as_expression] = STATE(3906),
    [sym_is_expression] = STATE(3906),
    [sym_is_pattern_expression] = STATE(3906),
    [sym_cast_expression] = STATE(3906),
    [sym_checked_expression] = STATE(3906),
    [sym_invocation_expression] = STATE(3879),
    [sym_switch_expression] = STATE(3906),
    [sym_await_expression] = STATE(3879),
    [sym_throw_expression] = STATE(3906),
    [sym_element_access_expression] = STATE(2944),
    [sym_interpolated_string_expression] = STATE(3906),
    [sym_member_access_expression] = STATE(2944),
    [sym_object_creation_expression] = STATE(3879),
    [sym_parenthesized_expression] = STATE(3879),
    [sym__parenthesized_lvalue_expression] = STATE(2944),
    [sym_lambda_expression] = STATE(3906),
    [sym__lambda_expression_init] = STATE(7403),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3906),
    [sym_anonymous_method_expression] = STATE(3906),
    [sym_anonymous_object_creation_expression] = STATE(3906),
    [sym_implicit_array_creation_expression] = STATE(3906),
    [sym_implicit_object_creation_expression] = STATE(3906),
    [sym_implicit_stackalloc_expression] = STATE(3906),
    [sym_initializer_expression] = STATE(3906),
    [sym_default_expression] = STATE(3906),
    [sym_with_expression] = STATE(3906),
    [sym_sizeof_expression] = STATE(3906),
    [sym_typeof_expression] = STATE(3906),
    [sym_makeref_expression] = STATE(3906),
    [sym_ref_expression] = STATE(3906),
    [sym_reftype_expression] = STATE(3906),
    [sym_refvalue_expression] = STATE(3906),
    [sym_stackalloc_expression] = STATE(3906),
    [sym_range_expression] = STATE(3906),
    [sym_tuple_expression] = STATE(2944),
    [sym_literal] = STATE(3906),
    [sym_character_literal] = STATE(3791),
    [sym_string_literal] = STATE(3791),
    [sym_raw_string_literal] = STATE(3791),
    [sym_boolean_literal] = STATE(3791),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3906),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1913),
    [sym_preproc_endregion] = STATE(1913),
    [sym_preproc_line] = STATE(1913),
    [sym_preproc_pragma] = STATE(1913),
    [sym_preproc_nullable] = STATE(1913),
    [sym_preproc_error] = STATE(1913),
    [sym_preproc_warning] = STATE(1913),
    [sym_preproc_define] = STATE(1913),
    [sym_preproc_undef] = STATE(1913),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3473),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_delegate] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1785),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(1713),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1715),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(1717),
    [anon_sym_unchecked] = ACTIONS(1703),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1727),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym___makeref] = ACTIONS(1733),
    [anon_sym___reftype] = ACTIONS(1735),
    [anon_sym___refvalue] = ACTIONS(1737),
    [sym_null_literal] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [sym_real_literal] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [sym_verbatim_string_literal] = ACTIONS(1743),
    [aux_sym_preproc_if_token1] = ACTIONS(1747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(1749),
    [sym_interpolation_verbatim_start] = ACTIONS(1751),
    [sym_interpolation_raw_start] = ACTIONS(1753),
    [sym_raw_string_start] = ACTIONS(1755),
  },
  [1914] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym_bracketed_argument_list] = STATE(2712),
    [sym__name] = STATE(5927),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(2401),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_type] = STATE(5967),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_expression] = STATE(5141),
    [sym_non_lvalue_expression] = STATE(3411),
    [sym_lvalue_expression] = STATE(3559),
    [sym__expression_statement_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(3412),
    [sym_binary_expression] = STATE(3407),
    [sym_postfix_unary_expression] = STATE(3412),
    [sym_prefix_unary_expression] = STATE(3412),
    [sym__pointer_indirection_expression] = STATE(2711),
    [sym_query_expression] = STATE(3407),
    [sym_from_clause] = STATE(6218),
    [sym_conditional_expression] = STATE(3407),
    [sym_conditional_access_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_is_expression] = STATE(3407),
    [sym_is_pattern_expression] = STATE(3407),
    [sym_cast_expression] = STATE(3407),
    [sym_checked_expression] = STATE(3407),
    [sym_invocation_expression] = STATE(3412),
    [sym_switch_expression] = STATE(3407),
    [sym_await_expression] = STATE(3412),
    [sym_throw_expression] = STATE(3407),
    [sym_element_access_expression] = STATE(2711),
    [sym_interpolated_string_expression] = STATE(3407),
    [sym_member_access_expression] = STATE(2711),
    [sym_object_creation_expression] = STATE(3412),
    [sym_parenthesized_expression] = STATE(3412),
    [sym__parenthesized_lvalue_expression] = STATE(2711),
    [sym_lambda_expression] = STATE(3407),
    [sym__lambda_expression_init] = STATE(7757),
    [sym__lambda_parameters] = STATE(7486),
    [sym_array_creation_expression] = STATE(3407),
    [sym_anonymous_method_expression] = STATE(3407),
    [sym_anonymous_object_creation_expression] = STATE(3407),
    [sym_implicit_array_creation_expression] = STATE(3407),
    [sym_implicit_object_creation_expression] = STATE(3407),
    [sym_implicit_stackalloc_expression] = STATE(3407),
    [sym_initializer_expression] = STATE(3407),
    [sym_default_expression] = STATE(3407),
    [sym_with_expression] = STATE(3407),
    [sym_sizeof_expression] = STATE(3407),
    [sym_typeof_expression] = STATE(3407),
    [sym_makeref_expression] = STATE(3407),
    [sym_ref_expression] = STATE(3407),
    [sym_reftype_expression] = STATE(3407),
    [sym_refvalue_expression] = STATE(3407),
    [sym_stackalloc_expression] = STATE(3407),
    [sym_range_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(2711),
    [sym_literal] = STATE(3407),
    [sym_character_literal] = STATE(3468),
    [sym_string_literal] = STATE(3468),
    [sym_raw_string_literal] = STATE(3468),
    [sym_boolean_literal] = STATE(3468),
    [sym_identifier] = STATE(2191),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_expression] = STATE(3407),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(1914),
    [sym_preproc_endregion] = STATE(1914),
    [sym_preproc_line] = STATE(1914),
    [sym_preproc_pragma] = STATE(1914),
    [sym_preproc_nullable] = STATE(1914),
    [sym_preproc_error] = STATE(1914),
    [sym_preproc_warning] = STATE(1914),
    [sym_preproc_define] = STATE(1914),
    [sym_preproc_undef] = STATE(1914),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3136),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3505),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_ref] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_delegate] = ACTIONS(1319),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_checked] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_this] = ACTIONS(1327),
    [anon_sym_scoped] = ACTIONS(85),
    [anon_sym_base] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(89),
    [sym_predefined_type] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(109),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_from] = ACTIONS(125),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [anon_sym_stackalloc] = ACTIONS(1337),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1339),
    [anon_sym___reftype] = ACTIONS(1341),
    [anon_sym___refvalue] = ACTIONS(1343),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(151),
    [sym_interpolation_verbatim_start] = ACTIONS(153),
    [sym_interpolation_raw_start] = ACTIONS(155),
    [sym_raw_string_start] = ACTIONS(157),
  },
  [1915] = {
    [sym_preproc_region] = STATE(1915),
    [sym_preproc_endregion] = STATE(1915),
    [sym_preproc_line] = STATE(1915),
    [sym_preproc_pragma] = STATE(1915),
    [sym_preproc_nullable] = STATE(1915),
    [sym_preproc_error] = STATE(1915),
    [sym_preproc_warning] = STATE(1915),
    [sym_preproc_define] = STATE(1915),
    [sym_preproc_undef] = STATE(1915),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_record] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_checked] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_true] = ACTIONS(2977),
    [anon_sym_false] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_this] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_base] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_unchecked] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_foreach] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_stackalloc] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym___makeref] = ACTIONS(2977),
    [anon_sym___reftype] = ACTIONS(2977),
    [anon_sym___refvalue] = ACTIONS(2977),
    [sym_null_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_integer_literal] = ACTIONS(2977),
    [sym_real_literal] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [sym_verbatim_string_literal] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2979),
    [sym_interpolation_verbatim_start] = ACTIONS(2979),
    [sym_interpolation_raw_start] = ACTIONS(2979),
    [sym_raw_string_start] = ACTIONS(2979),
  },
  [1916] = {
    [sym_preproc_region] = STATE(1916),
    [sym_preproc_endregion] = STATE(1916),
    [sym_preproc_line] = STATE(1916),
    [sym_preproc_pragma] = STATE(1916),
    [sym_preproc_nullable] = STATE(1916),
    [sym_preproc_error] = STATE(1916),
    [sym_preproc_warning] = STATE(1916),
    [sym_preproc_define] = STATE(1916),
    [sym_preproc_undef] = STATE(1916),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [1917] = {
    [sym_preproc_region] = STATE(1917),
    [sym_preproc_endregion] = STATE(1917),
    [sym_preproc_line] = STATE(1917),
    [sym_preproc_pragma] = STATE(1917),
    [sym_preproc_nullable] = STATE(1917),
    [sym_preproc_error] = STATE(1917),
    [sym_preproc_warning] = STATE(1917),
    [sym_preproc_define] = STATE(1917),
    [sym_preproc_undef] = STATE(1917),
    [ts_builtin_sym_end] = ACTIONS(2987),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [1918] = {
    [sym_preproc_region] = STATE(1918),
    [sym_preproc_endregion] = STATE(1918),
    [sym_preproc_line] = STATE(1918),
    [sym_preproc_pragma] = STATE(1918),
    [sym_preproc_nullable] = STATE(1918),
    [sym_preproc_error] = STATE(1918),
    [sym_preproc_warning] = STATE(1918),
    [sym_preproc_define] = STATE(1918),
    [sym_preproc_undef] = STATE(1918),
    [ts_builtin_sym_end] = ACTIONS(2979),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_record] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_checked] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_true] = ACTIONS(2977),
    [anon_sym_false] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_this] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_base] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_unchecked] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_foreach] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_stackalloc] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym___makeref] = ACTIONS(2977),
    [anon_sym___reftype] = ACTIONS(2977),
    [anon_sym___refvalue] = ACTIONS(2977),
    [sym_null_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_integer_literal] = ACTIONS(2977),
    [sym_real_literal] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [sym_verbatim_string_literal] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2979),
    [sym_interpolation_verbatim_start] = ACTIONS(2979),
    [sym_interpolation_raw_start] = ACTIONS(2979),
    [sym_raw_string_start] = ACTIONS(2979),
  },
  [1919] = {
    [sym_preproc_region] = STATE(1919),
    [sym_preproc_endregion] = STATE(1919),
    [sym_preproc_line] = STATE(1919),
    [sym_preproc_pragma] = STATE(1919),
    [sym_preproc_nullable] = STATE(1919),
    [sym_preproc_error] = STATE(1919),
    [sym_preproc_warning] = STATE(1919),
    [sym_preproc_define] = STATE(1919),
    [sym_preproc_undef] = STATE(1919),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_checked] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_true] = ACTIONS(2977),
    [anon_sym_false] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_this] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_base] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_unchecked] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_case] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_foreach] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_stackalloc] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym___makeref] = ACTIONS(2977),
    [anon_sym___reftype] = ACTIONS(2977),
    [anon_sym___refvalue] = ACTIONS(2977),
    [sym_null_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_integer_literal] = ACTIONS(2977),
    [sym_real_literal] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [sym_verbatim_string_literal] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2979),
    [sym_interpolation_verbatim_start] = ACTIONS(2979),
    [sym_interpolation_raw_start] = ACTIONS(2979),
    [sym_raw_string_start] = ACTIONS(2979),
  },
  [1920] = {
    [sym_preproc_region] = STATE(1920),
    [sym_preproc_endregion] = STATE(1920),
    [sym_preproc_line] = STATE(1920),
    [sym_preproc_pragma] = STATE(1920),
    [sym_preproc_nullable] = STATE(1920),
    [sym_preproc_error] = STATE(1920),
    [sym_preproc_warning] = STATE(1920),
    [sym_preproc_define] = STATE(1920),
    [sym_preproc_undef] = STATE(1920),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [1921] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(2892),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_else] = STATE(7462),
    [sym_preproc_elif] = STATE(7462),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7770),
    [sym_preproc_elif_in_attribute_list] = STATE(7770),
    [sym_preproc_region] = STATE(1921),
    [sym_preproc_endregion] = STATE(1921),
    [sym_preproc_line] = STATE(1921),
    [sym_preproc_pragma] = STATE(1921),
    [sym_preproc_nullable] = STATE(1921),
    [sym_preproc_error] = STATE(1921),
    [sym_preproc_warning] = STATE(1921),
    [sym_preproc_define] = STATE(1921),
    [sym_preproc_undef] = STATE(1921),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1924),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3029),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1922] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(2888),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_else] = STATE(7501),
    [sym_preproc_elif] = STATE(7501),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_else_in_attribute_list] = STATE(7493),
    [sym_preproc_elif_in_attribute_list] = STATE(7493),
    [sym_preproc_region] = STATE(1922),
    [sym_preproc_endregion] = STATE(1922),
    [sym_preproc_line] = STATE(1922),
    [sym_preproc_pragma] = STATE(1922),
    [sym_preproc_nullable] = STATE(1922),
    [sym_preproc_error] = STATE(1922),
    [sym_preproc_warning] = STATE(1922),
    [sym_preproc_define] = STATE(1922),
    [sym_preproc_undef] = STATE(1922),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1923),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3035),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3033),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1923] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_else] = STATE(7592),
    [sym_preproc_elif] = STATE(7592),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1923),
    [sym_preproc_endregion] = STATE(1923),
    [sym_preproc_line] = STATE(1923),
    [sym_preproc_pragma] = STATE(1923),
    [sym_preproc_nullable] = STATE(1923),
    [sym_preproc_error] = STATE(1923),
    [sym_preproc_warning] = STATE(1923),
    [sym_preproc_define] = STATE(1923),
    [sym_preproc_undef] = STATE(1923),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1926),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3037),
    [aux_sym_preproc_else_token1] = ACTIONS(3039),
    [aux_sym_preproc_elif_token1] = ACTIONS(3041),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1924] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_else] = STATE(7742),
    [sym_preproc_elif] = STATE(7742),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1924),
    [sym_preproc_endregion] = STATE(1924),
    [sym_preproc_line] = STATE(1924),
    [sym_preproc_pragma] = STATE(1924),
    [sym_preproc_nullable] = STATE(1924),
    [sym_preproc_error] = STATE(1924),
    [sym_preproc_warning] = STATE(1924),
    [sym_preproc_define] = STATE(1924),
    [sym_preproc_undef] = STATE(1924),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1926),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3043),
    [aux_sym_preproc_else_token1] = ACTIONS(3039),
    [aux_sym_preproc_elif_token1] = ACTIONS(3041),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1925] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_else] = STATE(7462),
    [sym_preproc_elif] = STATE(7462),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1925),
    [sym_preproc_endregion] = STATE(1925),
    [sym_preproc_line] = STATE(1925),
    [sym_preproc_pragma] = STATE(1925),
    [sym_preproc_nullable] = STATE(1925),
    [sym_preproc_error] = STATE(1925),
    [sym_preproc_warning] = STATE(1925),
    [sym_preproc_define] = STATE(1925),
    [sym_preproc_undef] = STATE(1925),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1924),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3029),
    [aux_sym_preproc_else_token1] = ACTIONS(3039),
    [aux_sym_preproc_elif_token1] = ACTIONS(3041),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1926] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1926),
    [sym_preproc_endregion] = STATE(1926),
    [sym_preproc_line] = STATE(1926),
    [sym_preproc_pragma] = STATE(1926),
    [sym_preproc_nullable] = STATE(1926),
    [sym_preproc_error] = STATE(1926),
    [sym_preproc_warning] = STATE(1926),
    [sym_preproc_define] = STATE(1926),
    [sym_preproc_undef] = STATE(1926),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1926),
    [sym__identifier_token] = ACTIONS(3045),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym_alias] = ACTIONS(3051),
    [anon_sym_global] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3057),
    [anon_sym_unsafe] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3066),
    [anon_sym_event] = ACTIONS(3069),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_ref] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3081),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_interface] = ACTIONS(3089),
    [anon_sym_delegate] = ACTIONS(3092),
    [anon_sym_record] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3060),
    [anon_sym_async] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_file] = ACTIONS(3098),
    [anon_sym_fixed] = ACTIONS(3060),
    [anon_sym_internal] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_override] = ACTIONS(3060),
    [anon_sym_partial] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_readonly] = ACTIONS(3060),
    [anon_sym_required] = ACTIONS(3060),
    [anon_sym_sealed] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_where] = ACTIONS(3051),
    [anon_sym_notnull] = ACTIONS(3051),
    [anon_sym_unmanaged] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_implicit] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_scoped] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3110),
    [sym_predefined_type] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_when] = ACTIONS(3051),
    [anon_sym_from] = ACTIONS(3051),
    [anon_sym_into] = ACTIONS(3051),
    [anon_sym_join] = ACTIONS(3051),
    [anon_sym_on] = ACTIONS(3051),
    [anon_sym_equals] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_orderby] = ACTIONS(3051),
    [anon_sym_ascending] = ACTIONS(3051),
    [anon_sym_descending] = ACTIONS(3051),
    [anon_sym_group] = ACTIONS(3051),
    [anon_sym_by] = ACTIONS(3051),
    [anon_sym_select] = ACTIONS(3051),
    [aux_sym_preproc_if_token1] = ACTIONS(3116),
    [aux_sym_preproc_if_token3] = ACTIONS(3087),
    [aux_sym_preproc_else_token1] = ACTIONS(3087),
    [aux_sym_preproc_elif_token1] = ACTIONS(3087),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1927] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1927),
    [sym_preproc_endregion] = STATE(1927),
    [sym_preproc_line] = STATE(1927),
    [sym_preproc_pragma] = STATE(1927),
    [sym_preproc_nullable] = STATE(1927),
    [sym_preproc_error] = STATE(1927),
    [sym_preproc_warning] = STATE(1927),
    [sym_preproc_define] = STATE(1927),
    [sym_preproc_undef] = STATE(1927),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1933),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1928] = {
    [sym_catch_clause] = STATE(1941),
    [sym_finally_clause] = STATE(1967),
    [sym_preproc_region] = STATE(1928),
    [sym_preproc_endregion] = STATE(1928),
    [sym_preproc_line] = STATE(1928),
    [sym_preproc_pragma] = STATE(1928),
    [sym_preproc_nullable] = STATE(1928),
    [sym_preproc_error] = STATE(1928),
    [sym_preproc_warning] = STATE(1928),
    [sym_preproc_define] = STATE(1928),
    [sym_preproc_undef] = STATE(1928),
    [aux_sym_try_statement_repeat1] = STATE(1932),
    [sym__identifier_token] = ACTIONS(3121),
    [anon_sym_extern] = ACTIONS(3121),
    [anon_sym_alias] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3121),
    [anon_sym_unsafe] = ACTIONS(3121),
    [anon_sym_static] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3121),
    [anon_sym_ref] = ACTIONS(3121),
    [anon_sym_struct] = ACTIONS(3121),
    [anon_sym_enum] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_interface] = ACTIONS(3121),
    [anon_sym_delegate] = ACTIONS(3121),
    [anon_sym_record] = ACTIONS(3121),
    [anon_sym_abstract] = ACTIONS(3121),
    [anon_sym_async] = ACTIONS(3121),
    [anon_sym_const] = ACTIONS(3121),
    [anon_sym_file] = ACTIONS(3121),
    [anon_sym_fixed] = ACTIONS(3121),
    [anon_sym_internal] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_override] = ACTIONS(3121),
    [anon_sym_partial] = ACTIONS(3121),
    [anon_sym_private] = ACTIONS(3121),
    [anon_sym_protected] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3121),
    [anon_sym_readonly] = ACTIONS(3121),
    [anon_sym_required] = ACTIONS(3121),
    [anon_sym_sealed] = ACTIONS(3121),
    [anon_sym_virtual] = ACTIONS(3121),
    [anon_sym_volatile] = ACTIONS(3121),
    [anon_sym_where] = ACTIONS(3121),
    [anon_sym_notnull] = ACTIONS(3121),
    [anon_sym_unmanaged] = ACTIONS(3121),
    [anon_sym_checked] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3123),
    [anon_sym_PLUS_PLUS] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3123),
    [anon_sym_true] = ACTIONS(3121),
    [anon_sym_false] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3123),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_this] = ACTIONS(3121),
    [anon_sym_scoped] = ACTIONS(3121),
    [anon_sym_base] = ACTIONS(3121),
    [anon_sym_var] = ACTIONS(3121),
    [sym_predefined_type] = ACTIONS(3121),
    [anon_sym_break] = ACTIONS(3121),
    [anon_sym_unchecked] = ACTIONS(3121),
    [anon_sym_continue] = ACTIONS(3121),
    [anon_sym_do] = ACTIONS(3121),
    [anon_sym_while] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3121),
    [anon_sym_lock] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3121),
    [anon_sym_switch] = ACTIONS(3121),
    [anon_sym_default] = ACTIONS(3121),
    [anon_sym_throw] = ACTIONS(3121),
    [anon_sym_try] = ACTIONS(3121),
    [anon_sym_catch] = ACTIONS(3125),
    [anon_sym_when] = ACTIONS(3121),
    [anon_sym_finally] = ACTIONS(3127),
    [anon_sym_await] = ACTIONS(3121),
    [anon_sym_foreach] = ACTIONS(3121),
    [anon_sym_goto] = ACTIONS(3121),
    [anon_sym_if] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3121),
    [anon_sym_DOT_DOT] = ACTIONS(3123),
    [anon_sym_from] = ACTIONS(3121),
    [anon_sym_into] = ACTIONS(3121),
    [anon_sym_join] = ACTIONS(3121),
    [anon_sym_on] = ACTIONS(3121),
    [anon_sym_equals] = ACTIONS(3121),
    [anon_sym_let] = ACTIONS(3121),
    [anon_sym_orderby] = ACTIONS(3121),
    [anon_sym_ascending] = ACTIONS(3121),
    [anon_sym_descending] = ACTIONS(3121),
    [anon_sym_group] = ACTIONS(3121),
    [anon_sym_by] = ACTIONS(3121),
    [anon_sym_select] = ACTIONS(3121),
    [anon_sym_stackalloc] = ACTIONS(3121),
    [anon_sym_sizeof] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3121),
    [anon_sym___makeref] = ACTIONS(3121),
    [anon_sym___reftype] = ACTIONS(3121),
    [anon_sym___refvalue] = ACTIONS(3121),
    [sym_null_literal] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3123),
    [sym_integer_literal] = ACTIONS(3121),
    [sym_real_literal] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [sym_verbatim_string_literal] = ACTIONS(3123),
    [aux_sym_preproc_if_token1] = ACTIONS(3123),
    [aux_sym_preproc_if_token3] = ACTIONS(3123),
    [aux_sym_preproc_else_token1] = ACTIONS(3123),
    [aux_sym_preproc_elif_token1] = ACTIONS(3123),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3123),
    [sym_interpolation_verbatim_start] = ACTIONS(3123),
    [sym_interpolation_raw_start] = ACTIONS(3123),
    [sym_raw_string_start] = ACTIONS(3123),
  },
  [1929] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1929),
    [sym_preproc_endregion] = STATE(1929),
    [sym_preproc_line] = STATE(1929),
    [sym_preproc_pragma] = STATE(1929),
    [sym_preproc_nullable] = STATE(1929),
    [sym_preproc_error] = STATE(1929),
    [sym_preproc_warning] = STATE(1929),
    [sym_preproc_define] = STATE(1929),
    [sym_preproc_undef] = STATE(1929),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1931),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1930] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(2997),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1930),
    [sym_preproc_endregion] = STATE(1930),
    [sym_preproc_line] = STATE(1930),
    [sym_preproc_pragma] = STATE(1930),
    [sym_preproc_nullable] = STATE(1930),
    [sym_preproc_error] = STATE(1930),
    [sym_preproc_warning] = STATE(1930),
    [sym_preproc_define] = STATE(1930),
    [sym_preproc_undef] = STATE(1930),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1931),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1931] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1931),
    [sym_preproc_endregion] = STATE(1931),
    [sym_preproc_line] = STATE(1931),
    [sym_preproc_pragma] = STATE(1931),
    [sym_preproc_nullable] = STATE(1931),
    [sym_preproc_error] = STATE(1931),
    [sym_preproc_warning] = STATE(1931),
    [sym_preproc_define] = STATE(1931),
    [sym_preproc_undef] = STATE(1931),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1926),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token3] = ACTIONS(3131),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1932] = {
    [sym_catch_clause] = STATE(1941),
    [sym_finally_clause] = STATE(1982),
    [sym_preproc_region] = STATE(1932),
    [sym_preproc_endregion] = STATE(1932),
    [sym_preproc_line] = STATE(1932),
    [sym_preproc_pragma] = STATE(1932),
    [sym_preproc_nullable] = STATE(1932),
    [sym_preproc_error] = STATE(1932),
    [sym_preproc_warning] = STATE(1932),
    [sym_preproc_define] = STATE(1932),
    [sym_preproc_undef] = STATE(1932),
    [aux_sym_try_statement_repeat1] = STATE(1934),
    [sym__identifier_token] = ACTIONS(3133),
    [anon_sym_extern] = ACTIONS(3133),
    [anon_sym_alias] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_global] = ACTIONS(3133),
    [anon_sym_using] = ACTIONS(3133),
    [anon_sym_unsafe] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_namespace] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_struct] = ACTIONS(3133),
    [anon_sym_enum] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_interface] = ACTIONS(3133),
    [anon_sym_delegate] = ACTIONS(3133),
    [anon_sym_record] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_file] = ACTIONS(3133),
    [anon_sym_fixed] = ACTIONS(3133),
    [anon_sym_internal] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_override] = ACTIONS(3133),
    [anon_sym_partial] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_required] = ACTIONS(3133),
    [anon_sym_sealed] = ACTIONS(3133),
    [anon_sym_virtual] = ACTIONS(3133),
    [anon_sym_volatile] = ACTIONS(3133),
    [anon_sym_where] = ACTIONS(3133),
    [anon_sym_notnull] = ACTIONS(3133),
    [anon_sym_unmanaged] = ACTIONS(3133),
    [anon_sym_checked] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_true] = ACTIONS(3133),
    [anon_sym_false] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_this] = ACTIONS(3133),
    [anon_sym_scoped] = ACTIONS(3133),
    [anon_sym_base] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [sym_predefined_type] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_unchecked] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_catch] = ACTIONS(3125),
    [anon_sym_when] = ACTIONS(3133),
    [anon_sym_finally] = ACTIONS(3127),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3133),
    [anon_sym_into] = ACTIONS(3133),
    [anon_sym_join] = ACTIONS(3133),
    [anon_sym_on] = ACTIONS(3133),
    [anon_sym_equals] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_orderby] = ACTIONS(3133),
    [anon_sym_ascending] = ACTIONS(3133),
    [anon_sym_descending] = ACTIONS(3133),
    [anon_sym_group] = ACTIONS(3133),
    [anon_sym_by] = ACTIONS(3133),
    [anon_sym_select] = ACTIONS(3133),
    [anon_sym_stackalloc] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym___makeref] = ACTIONS(3133),
    [anon_sym___reftype] = ACTIONS(3133),
    [anon_sym___refvalue] = ACTIONS(3133),
    [sym_null_literal] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_integer_literal] = ACTIONS(3133),
    [sym_real_literal] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [sym_verbatim_string_literal] = ACTIONS(3135),
    [aux_sym_preproc_if_token1] = ACTIONS(3135),
    [aux_sym_preproc_if_token3] = ACTIONS(3135),
    [aux_sym_preproc_else_token1] = ACTIONS(3135),
    [aux_sym_preproc_elif_token1] = ACTIONS(3135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3135),
    [sym_interpolation_verbatim_start] = ACTIONS(3135),
    [sym_interpolation_raw_start] = ACTIONS(3135),
    [sym_raw_string_start] = ACTIONS(3135),
  },
  [1933] = {
    [sym_using_directive] = STATE(2867),
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_namespace_declaration] = STATE(2867),
    [sym_class_declaration] = STATE(2867),
    [sym__class_declaration_initializer] = STATE(6794),
    [sym_struct_declaration] = STATE(2867),
    [sym__struct_declaration_initializer] = STATE(6746),
    [sym_enum_declaration] = STATE(2867),
    [sym__enum_declaration_initializer] = STATE(7010),
    [sym_interface_declaration] = STATE(2867),
    [sym__interface_declaration_initializer] = STATE(6747),
    [sym_delegate_declaration] = STATE(2867),
    [sym__delegate_declaration_initializer] = STATE(6692),
    [sym_record_declaration] = STATE(2867),
    [sym__record_declaration_initializer] = STATE(6693),
    [sym_modifier] = STATE(3166),
    [sym_operator_declaration] = STATE(2867),
    [sym_conversion_operator_declaration] = STATE(2867),
    [sym_declaration] = STATE(2868),
    [sym_field_declaration] = STATE(2867),
    [sym_constructor_declaration] = STATE(2867),
    [sym__constructor_declaration_initializer] = STATE(6485),
    [sym_destructor_declaration] = STATE(2867),
    [sym_method_declaration] = STATE(2867),
    [sym_event_declaration] = STATE(2867),
    [sym_event_field_declaration] = STATE(2867),
    [sym_indexer_declaration] = STATE(2867),
    [sym_property_declaration] = STATE(2867),
    [sym_variable_declaration] = STATE(7709),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5591),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5777),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if] = STATE(2867),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(1933),
    [sym_preproc_endregion] = STATE(1933),
    [sym_preproc_line] = STATE(1933),
    [sym_preproc_pragma] = STATE(1933),
    [sym_preproc_nullable] = STATE(1933),
    [sym_preproc_error] = STATE(1933),
    [sym_preproc_warning] = STATE(1933),
    [sym_preproc_define] = STATE(1933),
    [sym_preproc_undef] = STATE(1933),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2291),
    [aux_sym_declaration_list_repeat1] = STATE(1926),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2995),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_ref] = ACTIONS(3011),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3017),
    [anon_sym_implicit] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [1934] = {
    [sym_catch_clause] = STATE(1941),
    [sym_preproc_region] = STATE(1934),
    [sym_preproc_endregion] = STATE(1934),
    [sym_preproc_line] = STATE(1934),
    [sym_preproc_pragma] = STATE(1934),
    [sym_preproc_nullable] = STATE(1934),
    [sym_preproc_error] = STATE(1934),
    [sym_preproc_warning] = STATE(1934),
    [sym_preproc_define] = STATE(1934),
    [sym_preproc_undef] = STATE(1934),
    [aux_sym_try_statement_repeat1] = STATE(1934),
    [sym__identifier_token] = ACTIONS(3139),
    [anon_sym_extern] = ACTIONS(3139),
    [anon_sym_alias] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_global] = ACTIONS(3139),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(3139),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_namespace] = ACTIONS(3139),
    [anon_sym_class] = ACTIONS(3139),
    [anon_sym_ref] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_interface] = ACTIONS(3139),
    [anon_sym_delegate] = ACTIONS(3139),
    [anon_sym_record] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_async] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_file] = ACTIONS(3139),
    [anon_sym_fixed] = ACTIONS(3139),
    [anon_sym_internal] = ACTIONS(3139),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_override] = ACTIONS(3139),
    [anon_sym_partial] = ACTIONS(3139),
    [anon_sym_private] = ACTIONS(3139),
    [anon_sym_protected] = ACTIONS(3139),
    [anon_sym_public] = ACTIONS(3139),
    [anon_sym_readonly] = ACTIONS(3139),
    [anon_sym_required] = ACTIONS(3139),
    [anon_sym_sealed] = ACTIONS(3139),
    [anon_sym_virtual] = ACTIONS(3139),
    [anon_sym_volatile] = ACTIONS(3139),
    [anon_sym_where] = ACTIONS(3139),
    [anon_sym_notnull] = ACTIONS(3139),
    [anon_sym_unmanaged] = ACTIONS(3139),
    [anon_sym_checked] = ACTIONS(3139),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_true] = ACTIONS(3139),
    [anon_sym_false] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_CARET] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_this] = ACTIONS(3139),
    [anon_sym_scoped] = ACTIONS(3139),
    [anon_sym_base] = ACTIONS(3139),
    [anon_sym_var] = ACTIONS(3139),
    [sym_predefined_type] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_unchecked] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_lock] = ACTIONS(3139),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_throw] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_catch] = ACTIONS(3143),
    [anon_sym_when] = ACTIONS(3139),
    [anon_sym_finally] = ACTIONS(3139),
    [anon_sym_await] = ACTIONS(3139),
    [anon_sym_foreach] = ACTIONS(3139),
    [anon_sym_goto] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3139),
    [anon_sym_DOT_DOT] = ACTIONS(3141),
    [anon_sym_from] = ACTIONS(3139),
    [anon_sym_into] = ACTIONS(3139),
    [anon_sym_join] = ACTIONS(3139),
    [anon_sym_on] = ACTIONS(3139),
    [anon_sym_equals] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_orderby] = ACTIONS(3139),
    [anon_sym_ascending] = ACTIONS(3139),
    [anon_sym_descending] = ACTIONS(3139),
    [anon_sym_group] = ACTIONS(3139),
    [anon_sym_by] = ACTIONS(3139),
    [anon_sym_select] = ACTIONS(3139),
    [anon_sym_stackalloc] = ACTIONS(3139),
    [anon_sym_sizeof] = ACTIONS(3139),
    [anon_sym_typeof] = ACTIONS(3139),
    [anon_sym___makeref] = ACTIONS(3139),
    [anon_sym___reftype] = ACTIONS(3139),
    [anon_sym___refvalue] = ACTIONS(3139),
    [sym_null_literal] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3141),
    [sym_integer_literal] = ACTIONS(3139),
    [sym_real_literal] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(3141),
    [sym_verbatim_string_literal] = ACTIONS(3141),
    [aux_sym_preproc_if_token1] = ACTIONS(3141),
    [aux_sym_preproc_if_token3] = ACTIONS(3141),
    [aux_sym_preproc_else_token1] = ACTIONS(3141),
    [aux_sym_preproc_elif_token1] = ACTIONS(3141),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3141),
    [sym_interpolation_verbatim_start] = ACTIONS(3141),
    [sym_interpolation_raw_start] = ACTIONS(3141),
    [sym_raw_string_start] = ACTIONS(3141),
  },
  [1935] = {
    [sym_catch_clause] = STATE(1953),
    [sym_finally_clause] = STATE(2050),
    [sym_preproc_region] = STATE(1935),
    [sym_preproc_endregion] = STATE(1935),
    [sym_preproc_line] = STATE(1935),
    [sym_preproc_pragma] = STATE(1935),
    [sym_preproc_nullable] = STATE(1935),
    [sym_preproc_error] = STATE(1935),
    [sym_preproc_warning] = STATE(1935),
    [sym_preproc_define] = STATE(1935),
    [sym_preproc_undef] = STATE(1935),
    [aux_sym_try_statement_repeat1] = STATE(1936),
    [ts_builtin_sym_end] = ACTIONS(3123),
    [sym__identifier_token] = ACTIONS(3121),
    [anon_sym_extern] = ACTIONS(3121),
    [anon_sym_alias] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3121),
    [anon_sym_unsafe] = ACTIONS(3121),
    [anon_sym_static] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3121),
    [anon_sym_ref] = ACTIONS(3121),
    [anon_sym_struct] = ACTIONS(3121),
    [anon_sym_enum] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_interface] = ACTIONS(3121),
    [anon_sym_delegate] = ACTIONS(3121),
    [anon_sym_record] = ACTIONS(3121),
    [anon_sym_abstract] = ACTIONS(3121),
    [anon_sym_async] = ACTIONS(3121),
    [anon_sym_const] = ACTIONS(3121),
    [anon_sym_file] = ACTIONS(3121),
    [anon_sym_fixed] = ACTIONS(3121),
    [anon_sym_internal] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_override] = ACTIONS(3121),
    [anon_sym_partial] = ACTIONS(3121),
    [anon_sym_private] = ACTIONS(3121),
    [anon_sym_protected] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3121),
    [anon_sym_readonly] = ACTIONS(3121),
    [anon_sym_required] = ACTIONS(3121),
    [anon_sym_sealed] = ACTIONS(3121),
    [anon_sym_virtual] = ACTIONS(3121),
    [anon_sym_volatile] = ACTIONS(3121),
    [anon_sym_where] = ACTIONS(3121),
    [anon_sym_notnull] = ACTIONS(3121),
    [anon_sym_unmanaged] = ACTIONS(3121),
    [anon_sym_checked] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3123),
    [anon_sym_PLUS_PLUS] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3123),
    [anon_sym_true] = ACTIONS(3121),
    [anon_sym_false] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3123),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_this] = ACTIONS(3121),
    [anon_sym_scoped] = ACTIONS(3121),
    [anon_sym_base] = ACTIONS(3121),
    [anon_sym_var] = ACTIONS(3121),
    [sym_predefined_type] = ACTIONS(3121),
    [anon_sym_break] = ACTIONS(3121),
    [anon_sym_unchecked] = ACTIONS(3121),
    [anon_sym_continue] = ACTIONS(3121),
    [anon_sym_do] = ACTIONS(3121),
    [anon_sym_while] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3121),
    [anon_sym_lock] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3121),
    [anon_sym_switch] = ACTIONS(3121),
    [anon_sym_default] = ACTIONS(3121),
    [anon_sym_throw] = ACTIONS(3121),
    [anon_sym_try] = ACTIONS(3121),
    [anon_sym_catch] = ACTIONS(3146),
    [anon_sym_when] = ACTIONS(3121),
    [anon_sym_finally] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3121),
    [anon_sym_foreach] = ACTIONS(3121),
    [anon_sym_goto] = ACTIONS(3121),
    [anon_sym_if] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3121),
    [anon_sym_DOT_DOT] = ACTIONS(3123),
    [anon_sym_from] = ACTIONS(3121),
    [anon_sym_into] = ACTIONS(3121),
    [anon_sym_join] = ACTIONS(3121),
    [anon_sym_on] = ACTIONS(3121),
    [anon_sym_equals] = ACTIONS(3121),
    [anon_sym_let] = ACTIONS(3121),
    [anon_sym_orderby] = ACTIONS(3121),
    [anon_sym_ascending] = ACTIONS(3121),
    [anon_sym_descending] = ACTIONS(3121),
    [anon_sym_group] = ACTIONS(3121),
    [anon_sym_by] = ACTIONS(3121),
    [anon_sym_select] = ACTIONS(3121),
    [anon_sym_stackalloc] = ACTIONS(3121),
    [anon_sym_sizeof] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3121),
    [anon_sym___makeref] = ACTIONS(3121),
    [anon_sym___reftype] = ACTIONS(3121),
    [anon_sym___refvalue] = ACTIONS(3121),
    [sym_null_literal] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3123),
    [sym_integer_literal] = ACTIONS(3121),
    [sym_real_literal] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [sym_verbatim_string_literal] = ACTIONS(3123),
    [aux_sym_preproc_if_token1] = ACTIONS(3123),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3123),
    [sym_interpolation_verbatim_start] = ACTIONS(3123),
    [sym_interpolation_raw_start] = ACTIONS(3123),
    [sym_raw_string_start] = ACTIONS(3123),
  },
  [1936] = {
    [sym_catch_clause] = STATE(1953),
    [sym_finally_clause] = STATE(2065),
    [sym_preproc_region] = STATE(1936),
    [sym_preproc_endregion] = STATE(1936),
    [sym_preproc_line] = STATE(1936),
    [sym_preproc_pragma] = STATE(1936),
    [sym_preproc_nullable] = STATE(1936),
    [sym_preproc_error] = STATE(1936),
    [sym_preproc_warning] = STATE(1936),
    [sym_preproc_define] = STATE(1936),
    [sym_preproc_undef] = STATE(1936),
    [aux_sym_try_statement_repeat1] = STATE(1939),
    [ts_builtin_sym_end] = ACTIONS(3135),
    [sym__identifier_token] = ACTIONS(3133),
    [anon_sym_extern] = ACTIONS(3133),
    [anon_sym_alias] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_global] = ACTIONS(3133),
    [anon_sym_using] = ACTIONS(3133),
    [anon_sym_unsafe] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_namespace] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_struct] = ACTIONS(3133),
    [anon_sym_enum] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_interface] = ACTIONS(3133),
    [anon_sym_delegate] = ACTIONS(3133),
    [anon_sym_record] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_file] = ACTIONS(3133),
    [anon_sym_fixed] = ACTIONS(3133),
    [anon_sym_internal] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_override] = ACTIONS(3133),
    [anon_sym_partial] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_required] = ACTIONS(3133),
    [anon_sym_sealed] = ACTIONS(3133),
    [anon_sym_virtual] = ACTIONS(3133),
    [anon_sym_volatile] = ACTIONS(3133),
    [anon_sym_where] = ACTIONS(3133),
    [anon_sym_notnull] = ACTIONS(3133),
    [anon_sym_unmanaged] = ACTIONS(3133),
    [anon_sym_checked] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_true] = ACTIONS(3133),
    [anon_sym_false] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_this] = ACTIONS(3133),
    [anon_sym_scoped] = ACTIONS(3133),
    [anon_sym_base] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [sym_predefined_type] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_unchecked] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_catch] = ACTIONS(3146),
    [anon_sym_when] = ACTIONS(3133),
    [anon_sym_finally] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3133),
    [anon_sym_into] = ACTIONS(3133),
    [anon_sym_join] = ACTIONS(3133),
    [anon_sym_on] = ACTIONS(3133),
    [anon_sym_equals] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_orderby] = ACTIONS(3133),
    [anon_sym_ascending] = ACTIONS(3133),
    [anon_sym_descending] = ACTIONS(3133),
    [anon_sym_group] = ACTIONS(3133),
    [anon_sym_by] = ACTIONS(3133),
    [anon_sym_select] = ACTIONS(3133),
    [anon_sym_stackalloc] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym___makeref] = ACTIONS(3133),
    [anon_sym___reftype] = ACTIONS(3133),
    [anon_sym___refvalue] = ACTIONS(3133),
    [sym_null_literal] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_integer_literal] = ACTIONS(3133),
    [sym_real_literal] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [sym_verbatim_string_literal] = ACTIONS(3135),
    [aux_sym_preproc_if_token1] = ACTIONS(3135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3135),
    [sym_interpolation_verbatim_start] = ACTIONS(3135),
    [sym_interpolation_raw_start] = ACTIONS(3135),
    [sym_raw_string_start] = ACTIONS(3135),
  },
  [1937] = {
    [sym_preproc_region] = STATE(1937),
    [sym_preproc_endregion] = STATE(1937),
    [sym_preproc_line] = STATE(1937),
    [sym_preproc_pragma] = STATE(1937),
    [sym_preproc_nullable] = STATE(1937),
    [sym_preproc_error] = STATE(1937),
    [sym_preproc_warning] = STATE(1937),
    [sym_preproc_define] = STATE(1937),
    [sym_preproc_undef] = STATE(1937),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_record] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_checked] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2979),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_true] = ACTIONS(2977),
    [anon_sym_false] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym_this] = ACTIONS(2977),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_base] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_unchecked] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_catch] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_finally] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_foreach] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_stackalloc] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym___makeref] = ACTIONS(2977),
    [anon_sym___reftype] = ACTIONS(2977),
    [anon_sym___refvalue] = ACTIONS(2977),
    [sym_null_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_integer_literal] = ACTIONS(2977),
    [sym_real_literal] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [sym_verbatim_string_literal] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2979),
    [sym_interpolation_verbatim_start] = ACTIONS(2979),
    [sym_interpolation_raw_start] = ACTIONS(2979),
    [sym_raw_string_start] = ACTIONS(2979),
  },
  [1938] = {
    [sym_preproc_region] = STATE(1938),
    [sym_preproc_endregion] = STATE(1938),
    [sym_preproc_line] = STATE(1938),
    [sym_preproc_pragma] = STATE(1938),
    [sym_preproc_nullable] = STATE(1938),
    [sym_preproc_error] = STATE(1938),
    [sym_preproc_warning] = STATE(1938),
    [sym_preproc_define] = STATE(1938),
    [sym_preproc_undef] = STATE(1938),
    [sym__identifier_token] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym_alias] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_unsafe] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_ref] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3150),
    [anon_sym_delegate] = ACTIONS(3150),
    [anon_sym_record] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_file] = ACTIONS(3150),
    [anon_sym_fixed] = ACTIONS(3150),
    [anon_sym_internal] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_partial] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_required] = ACTIONS(3150),
    [anon_sym_sealed] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_where] = ACTIONS(3150),
    [anon_sym_notnull] = ACTIONS(3150),
    [anon_sym_unmanaged] = ACTIONS(3150),
    [anon_sym_checked] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_true] = ACTIONS(3150),
    [anon_sym_false] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_this] = ACTIONS(3150),
    [anon_sym_scoped] = ACTIONS(3150),
    [anon_sym_base] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [sym_predefined_type] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_unchecked] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_lock] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_catch] = ACTIONS(3150),
    [anon_sym_when] = ACTIONS(3150),
    [anon_sym_finally] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_foreach] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_into] = ACTIONS(3150),
    [anon_sym_join] = ACTIONS(3150),
    [anon_sym_on] = ACTIONS(3150),
    [anon_sym_equals] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_orderby] = ACTIONS(3150),
    [anon_sym_ascending] = ACTIONS(3150),
    [anon_sym_descending] = ACTIONS(3150),
    [anon_sym_group] = ACTIONS(3150),
    [anon_sym_by] = ACTIONS(3150),
    [anon_sym_select] = ACTIONS(3150),
    [anon_sym_stackalloc] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym___makeref] = ACTIONS(3150),
    [anon_sym___reftype] = ACTIONS(3150),
    [anon_sym___refvalue] = ACTIONS(3150),
    [sym_null_literal] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [sym_integer_literal] = ACTIONS(3150),
    [sym_real_literal] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_verbatim_string_literal] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token3] = ACTIONS(3152),
    [aux_sym_preproc_else_token1] = ACTIONS(3152),
    [aux_sym_preproc_elif_token1] = ACTIONS(3152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3152),
    [sym_interpolation_verbatim_start] = ACTIONS(3152),
    [sym_interpolation_raw_start] = ACTIONS(3152),
    [sym_raw_string_start] = ACTIONS(3152),
  },
  [1939] = {
    [sym_catch_clause] = STATE(1953),
    [sym_preproc_region] = STATE(1939),
    [sym_preproc_endregion] = STATE(1939),
    [sym_preproc_line] = STATE(1939),
    [sym_preproc_pragma] = STATE(1939),
    [sym_preproc_nullable] = STATE(1939),
    [sym_preproc_error] = STATE(1939),
    [sym_preproc_warning] = STATE(1939),
    [sym_preproc_define] = STATE(1939),
    [sym_preproc_undef] = STATE(1939),
    [aux_sym_try_statement_repeat1] = STATE(1939),
    [ts_builtin_sym_end] = ACTIONS(3141),
    [sym__identifier_token] = ACTIONS(3139),
    [anon_sym_extern] = ACTIONS(3139),
    [anon_sym_alias] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_global] = ACTIONS(3139),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(3139),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_namespace] = ACTIONS(3139),
    [anon_sym_class] = ACTIONS(3139),
    [anon_sym_ref] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_interface] = ACTIONS(3139),
    [anon_sym_delegate] = ACTIONS(3139),
    [anon_sym_record] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_async] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_file] = ACTIONS(3139),
    [anon_sym_fixed] = ACTIONS(3139),
    [anon_sym_internal] = ACTIONS(3139),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_override] = ACTIONS(3139),
    [anon_sym_partial] = ACTIONS(3139),
    [anon_sym_private] = ACTIONS(3139),
    [anon_sym_protected] = ACTIONS(3139),
    [anon_sym_public] = ACTIONS(3139),
    [anon_sym_readonly] = ACTIONS(3139),
    [anon_sym_required] = ACTIONS(3139),
    [anon_sym_sealed] = ACTIONS(3139),
    [anon_sym_virtual] = ACTIONS(3139),
    [anon_sym_volatile] = ACTIONS(3139),
    [anon_sym_where] = ACTIONS(3139),
    [anon_sym_notnull] = ACTIONS(3139),
    [anon_sym_unmanaged] = ACTIONS(3139),
    [anon_sym_checked] = ACTIONS(3139),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_true] = ACTIONS(3139),
    [anon_sym_false] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_CARET] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_this] = ACTIONS(3139),
    [anon_sym_scoped] = ACTIONS(3139),
    [anon_sym_base] = ACTIONS(3139),
    [anon_sym_var] = ACTIONS(3139),
    [sym_predefined_type] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_unchecked] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_lock] = ACTIONS(3139),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_throw] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_catch] = ACTIONS(3154),
    [anon_sym_when] = ACTIONS(3139),
    [anon_sym_finally] = ACTIONS(3139),
    [anon_sym_await] = ACTIONS(3139),
    [anon_sym_foreach] = ACTIONS(3139),
    [anon_sym_goto] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3139),
    [anon_sym_DOT_DOT] = ACTIONS(3141),
    [anon_sym_from] = ACTIONS(3139),
    [anon_sym_into] = ACTIONS(3139),
    [anon_sym_join] = ACTIONS(3139),
    [anon_sym_on] = ACTIONS(3139),
    [anon_sym_equals] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_orderby] = ACTIONS(3139),
    [anon_sym_ascending] = ACTIONS(3139),
    [anon_sym_descending] = ACTIONS(3139),
    [anon_sym_group] = ACTIONS(3139),
    [anon_sym_by] = ACTIONS(3139),
    [anon_sym_select] = ACTIONS(3139),
    [anon_sym_stackalloc] = ACTIONS(3139),
    [anon_sym_sizeof] = ACTIONS(3139),
    [anon_sym_typeof] = ACTIONS(3139),
    [anon_sym___makeref] = ACTIONS(3139),
    [anon_sym___reftype] = ACTIONS(3139),
    [anon_sym___refvalue] = ACTIONS(3139),
    [sym_null_literal] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3141),
    [sym_integer_literal] = ACTIONS(3139),
    [sym_real_literal] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(3141),
    [sym_verbatim_string_literal] = ACTIONS(3141),
    [aux_sym_preproc_if_token1] = ACTIONS(3141),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3141),
    [sym_interpolation_verbatim_start] = ACTIONS(3141),
    [sym_interpolation_raw_start] = ACTIONS(3141),
    [sym_raw_string_start] = ACTIONS(3141),
  },
  [1940] = {
    [sym_preproc_region] = STATE(1940),
    [sym_preproc_endregion] = STATE(1940),
    [sym_preproc_line] = STATE(1940),
    [sym_preproc_pragma] = STATE(1940),
    [sym_preproc_nullable] = STATE(1940),
    [sym_preproc_error] = STATE(1940),
    [sym_preproc_warning] = STATE(1940),
    [sym_preproc_define] = STATE(1940),
    [sym_preproc_undef] = STATE(1940),
    [sym__identifier_token] = ACTIONS(3157),
    [anon_sym_extern] = ACTIONS(3157),
    [anon_sym_alias] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3157),
    [anon_sym_using] = ACTIONS(3157),
    [anon_sym_unsafe] = ACTIONS(3157),
    [anon_sym_static] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3157),
    [anon_sym_namespace] = ACTIONS(3157),
    [anon_sym_class] = ACTIONS(3157),
    [anon_sym_ref] = ACTIONS(3157),
    [anon_sym_struct] = ACTIONS(3157),
    [anon_sym_enum] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_interface] = ACTIONS(3157),
    [anon_sym_delegate] = ACTIONS(3157),
    [anon_sym_record] = ACTIONS(3157),
    [anon_sym_abstract] = ACTIONS(3157),
    [anon_sym_async] = ACTIONS(3157),
    [anon_sym_const] = ACTIONS(3157),
    [anon_sym_file] = ACTIONS(3157),
    [anon_sym_fixed] = ACTIONS(3157),
    [anon_sym_internal] = ACTIONS(3157),
    [anon_sym_new] = ACTIONS(3157),
    [anon_sym_override] = ACTIONS(3157),
    [anon_sym_partial] = ACTIONS(3157),
    [anon_sym_private] = ACTIONS(3157),
    [anon_sym_protected] = ACTIONS(3157),
    [anon_sym_public] = ACTIONS(3157),
    [anon_sym_readonly] = ACTIONS(3157),
    [anon_sym_required] = ACTIONS(3157),
    [anon_sym_sealed] = ACTIONS(3157),
    [anon_sym_virtual] = ACTIONS(3157),
    [anon_sym_volatile] = ACTIONS(3157),
    [anon_sym_where] = ACTIONS(3157),
    [anon_sym_notnull] = ACTIONS(3157),
    [anon_sym_unmanaged] = ACTIONS(3157),
    [anon_sym_checked] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3159),
    [anon_sym_TILDE] = ACTIONS(3159),
    [anon_sym_PLUS_PLUS] = ACTIONS(3159),
    [anon_sym_DASH_DASH] = ACTIONS(3159),
    [anon_sym_true] = ACTIONS(3157),
    [anon_sym_false] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_CARET] = ACTIONS(3159),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_this] = ACTIONS(3157),
    [anon_sym_scoped] = ACTIONS(3157),
    [anon_sym_base] = ACTIONS(3157),
    [anon_sym_var] = ACTIONS(3157),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_break] = ACTIONS(3157),
    [anon_sym_unchecked] = ACTIONS(3157),
    [anon_sym_continue] = ACTIONS(3157),
    [anon_sym_do] = ACTIONS(3157),
    [anon_sym_while] = ACTIONS(3157),
    [anon_sym_for] = ACTIONS(3157),
    [anon_sym_lock] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3157),
    [anon_sym_switch] = ACTIONS(3157),
    [anon_sym_default] = ACTIONS(3157),
    [anon_sym_throw] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_catch] = ACTIONS(3157),
    [anon_sym_when] = ACTIONS(3157),
    [anon_sym_finally] = ACTIONS(3157),
    [anon_sym_await] = ACTIONS(3157),
    [anon_sym_foreach] = ACTIONS(3157),
    [anon_sym_goto] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3157),
    [anon_sym_else] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3157),
    [anon_sym_into] = ACTIONS(3157),
    [anon_sym_join] = ACTIONS(3157),
    [anon_sym_on] = ACTIONS(3157),
    [anon_sym_equals] = ACTIONS(3157),
    [anon_sym_let] = ACTIONS(3157),
    [anon_sym_orderby] = ACTIONS(3157),
    [anon_sym_ascending] = ACTIONS(3157),
    [anon_sym_descending] = ACTIONS(3157),
    [anon_sym_group] = ACTIONS(3157),
    [anon_sym_by] = ACTIONS(3157),
    [anon_sym_select] = ACTIONS(3157),
    [anon_sym_stackalloc] = ACTIONS(3157),
    [anon_sym_sizeof] = ACTIONS(3157),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym___makeref] = ACTIONS(3157),
    [anon_sym___reftype] = ACTIONS(3157),
    [anon_sym___refvalue] = ACTIONS(3157),
    [sym_null_literal] = ACTIONS(3157),
    [anon_sym_SQUOTE] = ACTIONS(3159),
    [sym_integer_literal] = ACTIONS(3157),
    [sym_real_literal] = ACTIONS(3159),
    [anon_sym_DQUOTE] = ACTIONS(3159),
    [sym_verbatim_string_literal] = ACTIONS(3159),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(3159),
    [aux_sym_preproc_else_token1] = ACTIONS(3159),
    [aux_sym_preproc_elif_token1] = ACTIONS(3159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3159),
    [sym_interpolation_verbatim_start] = ACTIONS(3159),
    [sym_interpolation_raw_start] = ACTIONS(3159),
    [sym_raw_string_start] = ACTIONS(3159),
  },
  [1941] = {
    [sym_preproc_region] = STATE(1941),
    [sym_preproc_endregion] = STATE(1941),
    [sym_preproc_line] = STATE(1941),
    [sym_preproc_pragma] = STATE(1941),
    [sym_preproc_nullable] = STATE(1941),
    [sym_preproc_error] = STATE(1941),
    [sym_preproc_warning] = STATE(1941),
    [sym_preproc_define] = STATE(1941),
    [sym_preproc_undef] = STATE(1941),
    [sym__identifier_token] = ACTIONS(3161),
    [anon_sym_extern] = ACTIONS(3161),
    [anon_sym_alias] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_global] = ACTIONS(3161),
    [anon_sym_using] = ACTIONS(3161),
    [anon_sym_unsafe] = ACTIONS(3161),
    [anon_sym_static] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3163),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3161),
    [anon_sym_namespace] = ACTIONS(3161),
    [anon_sym_class] = ACTIONS(3161),
    [anon_sym_ref] = ACTIONS(3161),
    [anon_sym_struct] = ACTIONS(3161),
    [anon_sym_enum] = ACTIONS(3161),
    [anon_sym_LBRACE] = ACTIONS(3163),
    [anon_sym_interface] = ACTIONS(3161),
    [anon_sym_delegate] = ACTIONS(3161),
    [anon_sym_record] = ACTIONS(3161),
    [anon_sym_abstract] = ACTIONS(3161),
    [anon_sym_async] = ACTIONS(3161),
    [anon_sym_const] = ACTIONS(3161),
    [anon_sym_file] = ACTIONS(3161),
    [anon_sym_fixed] = ACTIONS(3161),
    [anon_sym_internal] = ACTIONS(3161),
    [anon_sym_new] = ACTIONS(3161),
    [anon_sym_override] = ACTIONS(3161),
    [anon_sym_partial] = ACTIONS(3161),
    [anon_sym_private] = ACTIONS(3161),
    [anon_sym_protected] = ACTIONS(3161),
    [anon_sym_public] = ACTIONS(3161),
    [anon_sym_readonly] = ACTIONS(3161),
    [anon_sym_required] = ACTIONS(3161),
    [anon_sym_sealed] = ACTIONS(3161),
    [anon_sym_virtual] = ACTIONS(3161),
    [anon_sym_volatile] = ACTIONS(3161),
    [anon_sym_where] = ACTIONS(3161),
    [anon_sym_notnull] = ACTIONS(3161),
    [anon_sym_unmanaged] = ACTIONS(3161),
    [anon_sym_checked] = ACTIONS(3161),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3163),
    [anon_sym_true] = ACTIONS(3161),
    [anon_sym_false] = ACTIONS(3161),
    [anon_sym_PLUS] = ACTIONS(3161),
    [anon_sym_DASH] = ACTIONS(3161),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_this] = ACTIONS(3161),
    [anon_sym_scoped] = ACTIONS(3161),
    [anon_sym_base] = ACTIONS(3161),
    [anon_sym_var] = ACTIONS(3161),
    [sym_predefined_type] = ACTIONS(3161),
    [anon_sym_break] = ACTIONS(3161),
    [anon_sym_unchecked] = ACTIONS(3161),
    [anon_sym_continue] = ACTIONS(3161),
    [anon_sym_do] = ACTIONS(3161),
    [anon_sym_while] = ACTIONS(3161),
    [anon_sym_for] = ACTIONS(3161),
    [anon_sym_lock] = ACTIONS(3161),
    [anon_sym_yield] = ACTIONS(3161),
    [anon_sym_switch] = ACTIONS(3161),
    [anon_sym_default] = ACTIONS(3161),
    [anon_sym_throw] = ACTIONS(3161),
    [anon_sym_try] = ACTIONS(3161),
    [anon_sym_catch] = ACTIONS(3161),
    [anon_sym_when] = ACTIONS(3161),
    [anon_sym_finally] = ACTIONS(3161),
    [anon_sym_await] = ACTIONS(3161),
    [anon_sym_foreach] = ACTIONS(3161),
    [anon_sym_goto] = ACTIONS(3161),
    [anon_sym_if] = ACTIONS(3161),
    [anon_sym_else] = ACTIONS(3161),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_from] = ACTIONS(3161),
    [anon_sym_into] = ACTIONS(3161),
    [anon_sym_join] = ACTIONS(3161),
    [anon_sym_on] = ACTIONS(3161),
    [anon_sym_equals] = ACTIONS(3161),
    [anon_sym_let] = ACTIONS(3161),
    [anon_sym_orderby] = ACTIONS(3161),
    [anon_sym_ascending] = ACTIONS(3161),
    [anon_sym_descending] = ACTIONS(3161),
    [anon_sym_group] = ACTIONS(3161),
    [anon_sym_by] = ACTIONS(3161),
    [anon_sym_select] = ACTIONS(3161),
    [anon_sym_stackalloc] = ACTIONS(3161),
    [anon_sym_sizeof] = ACTIONS(3161),
    [anon_sym_typeof] = ACTIONS(3161),
    [anon_sym___makeref] = ACTIONS(3161),
    [anon_sym___reftype] = ACTIONS(3161),
    [anon_sym___refvalue] = ACTIONS(3161),
    [sym_null_literal] = ACTIONS(3161),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [sym_integer_literal] = ACTIONS(3161),
    [sym_real_literal] = ACTIONS(3163),
    [anon_sym_DQUOTE] = ACTIONS(3163),
    [sym_verbatim_string_literal] = ACTIONS(3163),
    [aux_sym_preproc_if_token1] = ACTIONS(3163),
    [aux_sym_preproc_if_token3] = ACTIONS(3163),
    [aux_sym_preproc_else_token1] = ACTIONS(3163),
    [aux_sym_preproc_elif_token1] = ACTIONS(3163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3163),
    [sym_interpolation_verbatim_start] = ACTIONS(3163),
    [sym_interpolation_raw_start] = ACTIONS(3163),
    [sym_raw_string_start] = ACTIONS(3163),
  },
  [1942] = {
    [sym_preproc_region] = STATE(1942),
    [sym_preproc_endregion] = STATE(1942),
    [sym_preproc_line] = STATE(1942),
    [sym_preproc_pragma] = STATE(1942),
    [sym_preproc_nullable] = STATE(1942),
    [sym_preproc_error] = STATE(1942),
    [sym_preproc_warning] = STATE(1942),
    [sym_preproc_define] = STATE(1942),
    [sym_preproc_undef] = STATE(1942),
    [sym__identifier_token] = ACTIONS(3165),
    [anon_sym_extern] = ACTIONS(3165),
    [anon_sym_alias] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_using] = ACTIONS(3165),
    [anon_sym_unsafe] = ACTIONS(3165),
    [anon_sym_static] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3165),
    [anon_sym_namespace] = ACTIONS(3165),
    [anon_sym_class] = ACTIONS(3165),
    [anon_sym_ref] = ACTIONS(3165),
    [anon_sym_struct] = ACTIONS(3165),
    [anon_sym_enum] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3165),
    [anon_sym_delegate] = ACTIONS(3165),
    [anon_sym_record] = ACTIONS(3165),
    [anon_sym_abstract] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_const] = ACTIONS(3165),
    [anon_sym_file] = ACTIONS(3165),
    [anon_sym_fixed] = ACTIONS(3165),
    [anon_sym_internal] = ACTIONS(3165),
    [anon_sym_new] = ACTIONS(3165),
    [anon_sym_override] = ACTIONS(3165),
    [anon_sym_partial] = ACTIONS(3165),
    [anon_sym_private] = ACTIONS(3165),
    [anon_sym_protected] = ACTIONS(3165),
    [anon_sym_public] = ACTIONS(3165),
    [anon_sym_readonly] = ACTIONS(3165),
    [anon_sym_required] = ACTIONS(3165),
    [anon_sym_sealed] = ACTIONS(3165),
    [anon_sym_virtual] = ACTIONS(3165),
    [anon_sym_volatile] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3165),
    [anon_sym_notnull] = ACTIONS(3165),
    [anon_sym_unmanaged] = ACTIONS(3165),
    [anon_sym_checked] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_true] = ACTIONS(3165),
    [anon_sym_false] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_this] = ACTIONS(3165),
    [anon_sym_scoped] = ACTIONS(3165),
    [anon_sym_base] = ACTIONS(3165),
    [anon_sym_var] = ACTIONS(3165),
    [sym_predefined_type] = ACTIONS(3165),
    [anon_sym_break] = ACTIONS(3165),
    [anon_sym_unchecked] = ACTIONS(3165),
    [anon_sym_continue] = ACTIONS(3165),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_for] = ACTIONS(3165),
    [anon_sym_lock] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_switch] = ACTIONS(3165),
    [anon_sym_default] = ACTIONS(3165),
    [anon_sym_throw] = ACTIONS(3165),
    [anon_sym_try] = ACTIONS(3165),
    [anon_sym_catch] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_finally] = ACTIONS(3165),
    [anon_sym_await] = ACTIONS(3165),
    [anon_sym_foreach] = ACTIONS(3165),
    [anon_sym_goto] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_into] = ACTIONS(3165),
    [anon_sym_join] = ACTIONS(3165),
    [anon_sym_on] = ACTIONS(3165),
    [anon_sym_equals] = ACTIONS(3165),
    [anon_sym_let] = ACTIONS(3165),
    [anon_sym_orderby] = ACTIONS(3165),
    [anon_sym_ascending] = ACTIONS(3165),
    [anon_sym_descending] = ACTIONS(3165),
    [anon_sym_group] = ACTIONS(3165),
    [anon_sym_by] = ACTIONS(3165),
    [anon_sym_select] = ACTIONS(3165),
    [anon_sym_stackalloc] = ACTIONS(3165),
    [anon_sym_sizeof] = ACTIONS(3165),
    [anon_sym_typeof] = ACTIONS(3165),
    [anon_sym___makeref] = ACTIONS(3165),
    [anon_sym___reftype] = ACTIONS(3165),
    [anon_sym___refvalue] = ACTIONS(3165),
    [sym_null_literal] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [sym_integer_literal] = ACTIONS(3165),
    [sym_real_literal] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [sym_verbatim_string_literal] = ACTIONS(3167),
    [aux_sym_preproc_if_token1] = ACTIONS(3167),
    [aux_sym_preproc_if_token3] = ACTIONS(3167),
    [aux_sym_preproc_else_token1] = ACTIONS(3167),
    [aux_sym_preproc_elif_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3167),
    [sym_interpolation_verbatim_start] = ACTIONS(3167),
    [sym_interpolation_raw_start] = ACTIONS(3167),
    [sym_raw_string_start] = ACTIONS(3167),
  },
  [1943] = {
    [sym_preproc_region] = STATE(1943),
    [sym_preproc_endregion] = STATE(1943),
    [sym_preproc_line] = STATE(1943),
    [sym_preproc_pragma] = STATE(1943),
    [sym_preproc_nullable] = STATE(1943),
    [sym_preproc_error] = STATE(1943),
    [sym_preproc_warning] = STATE(1943),
    [sym_preproc_define] = STATE(1943),
    [sym_preproc_undef] = STATE(1943),
    [sym__identifier_token] = ACTIONS(3169),
    [anon_sym_extern] = ACTIONS(3169),
    [anon_sym_alias] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(3171),
    [anon_sym_global] = ACTIONS(3169),
    [anon_sym_using] = ACTIONS(3169),
    [anon_sym_unsafe] = ACTIONS(3169),
    [anon_sym_static] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3169),
    [anon_sym_namespace] = ACTIONS(3169),
    [anon_sym_class] = ACTIONS(3169),
    [anon_sym_ref] = ACTIONS(3169),
    [anon_sym_struct] = ACTIONS(3169),
    [anon_sym_enum] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_interface] = ACTIONS(3169),
    [anon_sym_delegate] = ACTIONS(3169),
    [anon_sym_record] = ACTIONS(3169),
    [anon_sym_abstract] = ACTIONS(3169),
    [anon_sym_async] = ACTIONS(3169),
    [anon_sym_const] = ACTIONS(3169),
    [anon_sym_file] = ACTIONS(3169),
    [anon_sym_fixed] = ACTIONS(3169),
    [anon_sym_internal] = ACTIONS(3169),
    [anon_sym_new] = ACTIONS(3169),
    [anon_sym_override] = ACTIONS(3169),
    [anon_sym_partial] = ACTIONS(3169),
    [anon_sym_private] = ACTIONS(3169),
    [anon_sym_protected] = ACTIONS(3169),
    [anon_sym_public] = ACTIONS(3169),
    [anon_sym_readonly] = ACTIONS(3169),
    [anon_sym_required] = ACTIONS(3169),
    [anon_sym_sealed] = ACTIONS(3169),
    [anon_sym_virtual] = ACTIONS(3169),
    [anon_sym_volatile] = ACTIONS(3169),
    [anon_sym_where] = ACTIONS(3169),
    [anon_sym_notnull] = ACTIONS(3169),
    [anon_sym_unmanaged] = ACTIONS(3169),
    [anon_sym_checked] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3171),
    [anon_sym_TILDE] = ACTIONS(3171),
    [anon_sym_PLUS_PLUS] = ACTIONS(3171),
    [anon_sym_DASH_DASH] = ACTIONS(3171),
    [anon_sym_true] = ACTIONS(3169),
    [anon_sym_false] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3171),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_this] = ACTIONS(3169),
    [anon_sym_scoped] = ACTIONS(3169),
    [anon_sym_base] = ACTIONS(3169),
    [anon_sym_var] = ACTIONS(3169),
    [sym_predefined_type] = ACTIONS(3169),
    [anon_sym_break] = ACTIONS(3169),
    [anon_sym_unchecked] = ACTIONS(3169),
    [anon_sym_continue] = ACTIONS(3169),
    [anon_sym_do] = ACTIONS(3169),
    [anon_sym_while] = ACTIONS(3169),
    [anon_sym_for] = ACTIONS(3169),
    [anon_sym_lock] = ACTIONS(3169),
    [anon_sym_yield] = ACTIONS(3169),
    [anon_sym_switch] = ACTIONS(3169),
    [anon_sym_default] = ACTIONS(3169),
    [anon_sym_throw] = ACTIONS(3169),
    [anon_sym_try] = ACTIONS(3169),
    [anon_sym_when] = ACTIONS(3169),
    [anon_sym_await] = ACTIONS(3169),
    [anon_sym_foreach] = ACTIONS(3169),
    [anon_sym_goto] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_DOT_DOT] = ACTIONS(3171),
    [anon_sym_from] = ACTIONS(3169),
    [anon_sym_into] = ACTIONS(3169),
    [anon_sym_join] = ACTIONS(3169),
    [anon_sym_on] = ACTIONS(3169),
    [anon_sym_equals] = ACTIONS(3169),
    [anon_sym_let] = ACTIONS(3169),
    [anon_sym_orderby] = ACTIONS(3169),
    [anon_sym_ascending] = ACTIONS(3169),
    [anon_sym_descending] = ACTIONS(3169),
    [anon_sym_group] = ACTIONS(3169),
    [anon_sym_by] = ACTIONS(3169),
    [anon_sym_select] = ACTIONS(3169),
    [anon_sym_stackalloc] = ACTIONS(3169),
    [anon_sym_sizeof] = ACTIONS(3169),
    [anon_sym_typeof] = ACTIONS(3169),
    [anon_sym___makeref] = ACTIONS(3169),
    [anon_sym___reftype] = ACTIONS(3169),
    [anon_sym___refvalue] = ACTIONS(3169),
    [sym_null_literal] = ACTIONS(3169),
    [anon_sym_SQUOTE] = ACTIONS(3171),
    [sym_integer_literal] = ACTIONS(3169),
    [sym_real_literal] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3171),
    [sym_verbatim_string_literal] = ACTIONS(3171),
    [aux_sym_preproc_if_token1] = ACTIONS(3171),
    [aux_sym_preproc_if_token3] = ACTIONS(3171),
    [aux_sym_preproc_else_token1] = ACTIONS(3171),
    [aux_sym_preproc_elif_token1] = ACTIONS(3171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3171),
    [sym_interpolation_verbatim_start] = ACTIONS(3171),
    [sym_interpolation_raw_start] = ACTIONS(3171),
    [sym_raw_string_start] = ACTIONS(3171),
  },
  [1944] = {
    [sym_preproc_region] = STATE(1944),
    [sym_preproc_endregion] = STATE(1944),
    [sym_preproc_line] = STATE(1944),
    [sym_preproc_pragma] = STATE(1944),
    [sym_preproc_nullable] = STATE(1944),
    [sym_preproc_error] = STATE(1944),
    [sym_preproc_warning] = STATE(1944),
    [sym_preproc_define] = STATE(1944),
    [sym_preproc_undef] = STATE(1944),
    [sym__identifier_token] = ACTIONS(3173),
    [anon_sym_extern] = ACTIONS(3173),
    [anon_sym_alias] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_global] = ACTIONS(3173),
    [anon_sym_using] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(3173),
    [anon_sym_static] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(3175),
    [anon_sym_return] = ACTIONS(3173),
    [anon_sym_namespace] = ACTIONS(3173),
    [anon_sym_class] = ACTIONS(3173),
    [anon_sym_ref] = ACTIONS(3173),
    [anon_sym_struct] = ACTIONS(3173),
    [anon_sym_enum] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_interface] = ACTIONS(3173),
    [anon_sym_delegate] = ACTIONS(3173),
    [anon_sym_record] = ACTIONS(3173),
    [anon_sym_abstract] = ACTIONS(3173),
    [anon_sym_async] = ACTIONS(3173),
    [anon_sym_const] = ACTIONS(3173),
    [anon_sym_file] = ACTIONS(3173),
    [anon_sym_fixed] = ACTIONS(3173),
    [anon_sym_internal] = ACTIONS(3173),
    [anon_sym_new] = ACTIONS(3173),
    [anon_sym_override] = ACTIONS(3173),
    [anon_sym_partial] = ACTIONS(3173),
    [anon_sym_private] = ACTIONS(3173),
    [anon_sym_protected] = ACTIONS(3173),
    [anon_sym_public] = ACTIONS(3173),
    [anon_sym_readonly] = ACTIONS(3173),
    [anon_sym_required] = ACTIONS(3173),
    [anon_sym_sealed] = ACTIONS(3173),
    [anon_sym_virtual] = ACTIONS(3173),
    [anon_sym_volatile] = ACTIONS(3173),
    [anon_sym_where] = ACTIONS(3173),
    [anon_sym_notnull] = ACTIONS(3173),
    [anon_sym_unmanaged] = ACTIONS(3173),
    [anon_sym_checked] = ACTIONS(3173),
    [anon_sym_BANG] = ACTIONS(3175),
    [anon_sym_TILDE] = ACTIONS(3175),
    [anon_sym_PLUS_PLUS] = ACTIONS(3175),
    [anon_sym_DASH_DASH] = ACTIONS(3175),
    [anon_sym_true] = ACTIONS(3173),
    [anon_sym_false] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3173),
    [anon_sym_DASH] = ACTIONS(3173),
    [anon_sym_STAR] = ACTIONS(3175),
    [anon_sym_CARET] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3175),
    [anon_sym_this] = ACTIONS(3173),
    [anon_sym_scoped] = ACTIONS(3173),
    [anon_sym_base] = ACTIONS(3173),
    [anon_sym_var] = ACTIONS(3173),
    [sym_predefined_type] = ACTIONS(3173),
    [anon_sym_break] = ACTIONS(3173),
    [anon_sym_unchecked] = ACTIONS(3173),
    [anon_sym_continue] = ACTIONS(3173),
    [anon_sym_do] = ACTIONS(3173),
    [anon_sym_while] = ACTIONS(3173),
    [anon_sym_for] = ACTIONS(3173),
    [anon_sym_lock] = ACTIONS(3173),
    [anon_sym_yield] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3173),
    [anon_sym_default] = ACTIONS(3173),
    [anon_sym_throw] = ACTIONS(3173),
    [anon_sym_try] = ACTIONS(3173),
    [anon_sym_when] = ACTIONS(3173),
    [anon_sym_await] = ACTIONS(3173),
    [anon_sym_foreach] = ACTIONS(3173),
    [anon_sym_goto] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3173),
    [anon_sym_DOT_DOT] = ACTIONS(3175),
    [anon_sym_from] = ACTIONS(3173),
    [anon_sym_into] = ACTIONS(3173),
    [anon_sym_join] = ACTIONS(3173),
    [anon_sym_on] = ACTIONS(3173),
    [anon_sym_equals] = ACTIONS(3173),
    [anon_sym_let] = ACTIONS(3173),
    [anon_sym_orderby] = ACTIONS(3173),
    [anon_sym_ascending] = ACTIONS(3173),
    [anon_sym_descending] = ACTIONS(3173),
    [anon_sym_group] = ACTIONS(3173),
    [anon_sym_by] = ACTIONS(3173),
    [anon_sym_select] = ACTIONS(3173),
    [anon_sym_stackalloc] = ACTIONS(3173),
    [anon_sym_sizeof] = ACTIONS(3173),
    [anon_sym_typeof] = ACTIONS(3173),
    [anon_sym___makeref] = ACTIONS(3173),
    [anon_sym___reftype] = ACTIONS(3173),
    [anon_sym___refvalue] = ACTIONS(3173),
    [sym_null_literal] = ACTIONS(3173),
    [anon_sym_SQUOTE] = ACTIONS(3175),
    [sym_integer_literal] = ACTIONS(3173),
    [sym_real_literal] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3175),
    [sym_verbatim_string_literal] = ACTIONS(3175),
    [aux_sym_preproc_if_token1] = ACTIONS(3175),
    [aux_sym_preproc_if_token3] = ACTIONS(3175),
    [aux_sym_preproc_else_token1] = ACTIONS(3175),
    [aux_sym_preproc_elif_token1] = ACTIONS(3175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3175),
    [sym_interpolation_verbatim_start] = ACTIONS(3175),
    [sym_interpolation_raw_start] = ACTIONS(3175),
    [sym_raw_string_start] = ACTIONS(3175),
  },
  [1945] = {
    [sym_preproc_region] = STATE(1945),
    [sym_preproc_endregion] = STATE(1945),
    [sym_preproc_line] = STATE(1945),
    [sym_preproc_pragma] = STATE(1945),
    [sym_preproc_nullable] = STATE(1945),
    [sym_preproc_error] = STATE(1945),
    [sym_preproc_warning] = STATE(1945),
    [sym_preproc_define] = STATE(1945),
    [sym_preproc_undef] = STATE(1945),
    [sym__identifier_token] = ACTIONS(3177),
    [anon_sym_extern] = ACTIONS(3177),
    [anon_sym_alias] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_global] = ACTIONS(3177),
    [anon_sym_using] = ACTIONS(3177),
    [anon_sym_unsafe] = ACTIONS(3177),
    [anon_sym_static] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_return] = ACTIONS(3177),
    [anon_sym_namespace] = ACTIONS(3177),
    [anon_sym_class] = ACTIONS(3177),
    [anon_sym_ref] = ACTIONS(3177),
    [anon_sym_struct] = ACTIONS(3177),
    [anon_sym_enum] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_interface] = ACTIONS(3177),
    [anon_sym_delegate] = ACTIONS(3177),
    [anon_sym_record] = ACTIONS(3177),
    [anon_sym_abstract] = ACTIONS(3177),
    [anon_sym_async] = ACTIONS(3177),
    [anon_sym_const] = ACTIONS(3177),
    [anon_sym_file] = ACTIONS(3177),
    [anon_sym_fixed] = ACTIONS(3177),
    [anon_sym_internal] = ACTIONS(3177),
    [anon_sym_new] = ACTIONS(3177),
    [anon_sym_override] = ACTIONS(3177),
    [anon_sym_partial] = ACTIONS(3177),
    [anon_sym_private] = ACTIONS(3177),
    [anon_sym_protected] = ACTIONS(3177),
    [anon_sym_public] = ACTIONS(3177),
    [anon_sym_readonly] = ACTIONS(3177),
    [anon_sym_required] = ACTIONS(3177),
    [anon_sym_sealed] = ACTIONS(3177),
    [anon_sym_virtual] = ACTIONS(3177),
    [anon_sym_volatile] = ACTIONS(3177),
    [anon_sym_where] = ACTIONS(3177),
    [anon_sym_notnull] = ACTIONS(3177),
    [anon_sym_unmanaged] = ACTIONS(3177),
    [anon_sym_checked] = ACTIONS(3177),
    [anon_sym_BANG] = ACTIONS(3179),
    [anon_sym_TILDE] = ACTIONS(3179),
    [anon_sym_PLUS_PLUS] = ACTIONS(3179),
    [anon_sym_DASH_DASH] = ACTIONS(3179),
    [anon_sym_true] = ACTIONS(3177),
    [anon_sym_false] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3177),
    [anon_sym_DASH] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(3179),
    [anon_sym_CARET] = ACTIONS(3179),
    [anon_sym_AMP] = ACTIONS(3179),
    [anon_sym_this] = ACTIONS(3177),
    [anon_sym_scoped] = ACTIONS(3177),
    [anon_sym_base] = ACTIONS(3177),
    [anon_sym_var] = ACTIONS(3177),
    [sym_predefined_type] = ACTIONS(3177),
    [anon_sym_break] = ACTIONS(3177),
    [anon_sym_unchecked] = ACTIONS(3177),
    [anon_sym_continue] = ACTIONS(3177),
    [anon_sym_do] = ACTIONS(3177),
    [anon_sym_while] = ACTIONS(3177),
    [anon_sym_for] = ACTIONS(3177),
    [anon_sym_lock] = ACTIONS(3177),
    [anon_sym_yield] = ACTIONS(3177),
    [anon_sym_switch] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3177),
    [anon_sym_throw] = ACTIONS(3177),
    [anon_sym_try] = ACTIONS(3177),
    [anon_sym_when] = ACTIONS(3177),
    [anon_sym_await] = ACTIONS(3177),
    [anon_sym_foreach] = ACTIONS(3177),
    [anon_sym_goto] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3177),
    [anon_sym_DOT_DOT] = ACTIONS(3179),
    [anon_sym_from] = ACTIONS(3177),
    [anon_sym_into] = ACTIONS(3177),
    [anon_sym_join] = ACTIONS(3177),
    [anon_sym_on] = ACTIONS(3177),
    [anon_sym_equals] = ACTIONS(3177),
    [anon_sym_let] = ACTIONS(3177),
    [anon_sym_orderby] = ACTIONS(3177),
    [anon_sym_ascending] = ACTIONS(3177),
    [anon_sym_descending] = ACTIONS(3177),
    [anon_sym_group] = ACTIONS(3177),
    [anon_sym_by] = ACTIONS(3177),
    [anon_sym_select] = ACTIONS(3177),
    [anon_sym_stackalloc] = ACTIONS(3177),
    [anon_sym_sizeof] = ACTIONS(3177),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym___makeref] = ACTIONS(3177),
    [anon_sym___reftype] = ACTIONS(3177),
    [anon_sym___refvalue] = ACTIONS(3177),
    [sym_null_literal] = ACTIONS(3177),
    [anon_sym_SQUOTE] = ACTIONS(3179),
    [sym_integer_literal] = ACTIONS(3177),
    [sym_real_literal] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3179),
    [sym_verbatim_string_literal] = ACTIONS(3179),
    [aux_sym_preproc_if_token1] = ACTIONS(3179),
    [aux_sym_preproc_if_token3] = ACTIONS(3179),
    [aux_sym_preproc_else_token1] = ACTIONS(3179),
    [aux_sym_preproc_elif_token1] = ACTIONS(3179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3179),
    [sym_interpolation_verbatim_start] = ACTIONS(3179),
    [sym_interpolation_raw_start] = ACTIONS(3179),
    [sym_raw_string_start] = ACTIONS(3179),
  },
  [1946] = {
    [sym_preproc_region] = STATE(1946),
    [sym_preproc_endregion] = STATE(1946),
    [sym_preproc_line] = STATE(1946),
    [sym_preproc_pragma] = STATE(1946),
    [sym_preproc_nullable] = STATE(1946),
    [sym_preproc_error] = STATE(1946),
    [sym_preproc_warning] = STATE(1946),
    [sym_preproc_define] = STATE(1946),
    [sym_preproc_undef] = STATE(1946),
    [sym__identifier_token] = ACTIONS(3181),
    [anon_sym_extern] = ACTIONS(3181),
    [anon_sym_alias] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_global] = ACTIONS(3181),
    [anon_sym_using] = ACTIONS(3181),
    [anon_sym_unsafe] = ACTIONS(3181),
    [anon_sym_static] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_namespace] = ACTIONS(3181),
    [anon_sym_class] = ACTIONS(3181),
    [anon_sym_ref] = ACTIONS(3181),
    [anon_sym_struct] = ACTIONS(3181),
    [anon_sym_enum] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3181),
    [anon_sym_delegate] = ACTIONS(3181),
    [anon_sym_record] = ACTIONS(3181),
    [anon_sym_abstract] = ACTIONS(3181),
    [anon_sym_async] = ACTIONS(3181),
    [anon_sym_const] = ACTIONS(3181),
    [anon_sym_file] = ACTIONS(3181),
    [anon_sym_fixed] = ACTIONS(3181),
    [anon_sym_internal] = ACTIONS(3181),
    [anon_sym_new] = ACTIONS(3181),
    [anon_sym_override] = ACTIONS(3181),
    [anon_sym_partial] = ACTIONS(3181),
    [anon_sym_private] = ACTIONS(3181),
    [anon_sym_protected] = ACTIONS(3181),
    [anon_sym_public] = ACTIONS(3181),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_required] = ACTIONS(3181),
    [anon_sym_sealed] = ACTIONS(3181),
    [anon_sym_virtual] = ACTIONS(3181),
    [anon_sym_volatile] = ACTIONS(3181),
    [anon_sym_where] = ACTIONS(3181),
    [anon_sym_notnull] = ACTIONS(3181),
    [anon_sym_unmanaged] = ACTIONS(3181),
    [anon_sym_checked] = ACTIONS(3181),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [anon_sym_true] = ACTIONS(3181),
    [anon_sym_false] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(3183),
    [anon_sym_this] = ACTIONS(3181),
    [anon_sym_scoped] = ACTIONS(3181),
    [anon_sym_base] = ACTIONS(3181),
    [anon_sym_var] = ACTIONS(3181),
    [sym_predefined_type] = ACTIONS(3181),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_unchecked] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_lock] = ACTIONS(3181),
    [anon_sym_yield] = ACTIONS(3181),
    [anon_sym_switch] = ACTIONS(3181),
    [anon_sym_default] = ACTIONS(3181),
    [anon_sym_throw] = ACTIONS(3181),
    [anon_sym_try] = ACTIONS(3181),
    [anon_sym_when] = ACTIONS(3181),
    [anon_sym_await] = ACTIONS(3181),
    [anon_sym_foreach] = ACTIONS(3181),
    [anon_sym_goto] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3181),
    [anon_sym_DOT_DOT] = ACTIONS(3183),
    [anon_sym_from] = ACTIONS(3181),
    [anon_sym_into] = ACTIONS(3181),
    [anon_sym_join] = ACTIONS(3181),
    [anon_sym_on] = ACTIONS(3181),
    [anon_sym_equals] = ACTIONS(3181),
    [anon_sym_let] = ACTIONS(3181),
    [anon_sym_orderby] = ACTIONS(3181),
    [anon_sym_ascending] = ACTIONS(3181),
    [anon_sym_descending] = ACTIONS(3181),
    [anon_sym_group] = ACTIONS(3181),
    [anon_sym_by] = ACTIONS(3181),
    [anon_sym_select] = ACTIONS(3181),
    [anon_sym_stackalloc] = ACTIONS(3181),
    [anon_sym_sizeof] = ACTIONS(3181),
    [anon_sym_typeof] = ACTIONS(3181),
    [anon_sym___makeref] = ACTIONS(3181),
    [anon_sym___reftype] = ACTIONS(3181),
    [anon_sym___refvalue] = ACTIONS(3181),
    [sym_null_literal] = ACTIONS(3181),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [sym_integer_literal] = ACTIONS(3181),
    [sym_real_literal] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [sym_verbatim_string_literal] = ACTIONS(3183),
    [aux_sym_preproc_if_token1] = ACTIONS(3183),
    [aux_sym_preproc_if_token3] = ACTIONS(3183),
    [aux_sym_preproc_else_token1] = ACTIONS(3183),
    [aux_sym_preproc_elif_token1] = ACTIONS(3183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3183),
    [sym_interpolation_verbatim_start] = ACTIONS(3183),
    [sym_interpolation_raw_start] = ACTIONS(3183),
    [sym_raw_string_start] = ACTIONS(3183),
  },
  [1947] = {
    [sym_preproc_region] = STATE(1947),
    [sym_preproc_endregion] = STATE(1947),
    [sym_preproc_line] = STATE(1947),
    [sym_preproc_pragma] = STATE(1947),
    [sym_preproc_nullable] = STATE(1947),
    [sym_preproc_error] = STATE(1947),
    [sym_preproc_warning] = STATE(1947),
    [sym_preproc_define] = STATE(1947),
    [sym_preproc_undef] = STATE(1947),
    [sym__identifier_token] = ACTIONS(3185),
    [anon_sym_extern] = ACTIONS(3185),
    [anon_sym_alias] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_global] = ACTIONS(3185),
    [anon_sym_using] = ACTIONS(3185),
    [anon_sym_unsafe] = ACTIONS(3185),
    [anon_sym_static] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_namespace] = ACTIONS(3185),
    [anon_sym_class] = ACTIONS(3185),
    [anon_sym_ref] = ACTIONS(3185),
    [anon_sym_struct] = ACTIONS(3185),
    [anon_sym_enum] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3185),
    [anon_sym_delegate] = ACTIONS(3185),
    [anon_sym_record] = ACTIONS(3185),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_async] = ACTIONS(3185),
    [anon_sym_const] = ACTIONS(3185),
    [anon_sym_file] = ACTIONS(3185),
    [anon_sym_fixed] = ACTIONS(3185),
    [anon_sym_internal] = ACTIONS(3185),
    [anon_sym_new] = ACTIONS(3185),
    [anon_sym_override] = ACTIONS(3185),
    [anon_sym_partial] = ACTIONS(3185),
    [anon_sym_private] = ACTIONS(3185),
    [anon_sym_protected] = ACTIONS(3185),
    [anon_sym_public] = ACTIONS(3185),
    [anon_sym_readonly] = ACTIONS(3185),
    [anon_sym_required] = ACTIONS(3185),
    [anon_sym_sealed] = ACTIONS(3185),
    [anon_sym_virtual] = ACTIONS(3185),
    [anon_sym_volatile] = ACTIONS(3185),
    [anon_sym_where] = ACTIONS(3185),
    [anon_sym_notnull] = ACTIONS(3185),
    [anon_sym_unmanaged] = ACTIONS(3185),
    [anon_sym_checked] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [anon_sym_true] = ACTIONS(3185),
    [anon_sym_false] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_CARET] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_this] = ACTIONS(3185),
    [anon_sym_scoped] = ACTIONS(3185),
    [anon_sym_base] = ACTIONS(3185),
    [anon_sym_var] = ACTIONS(3185),
    [sym_predefined_type] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_unchecked] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_do] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_lock] = ACTIONS(3185),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_switch] = ACTIONS(3185),
    [anon_sym_default] = ACTIONS(3185),
    [anon_sym_throw] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [anon_sym_when] = ACTIONS(3185),
    [anon_sym_await] = ACTIONS(3185),
    [anon_sym_foreach] = ACTIONS(3185),
    [anon_sym_goto] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3185),
    [anon_sym_DOT_DOT] = ACTIONS(3187),
    [anon_sym_from] = ACTIONS(3185),
    [anon_sym_into] = ACTIONS(3185),
    [anon_sym_join] = ACTIONS(3185),
    [anon_sym_on] = ACTIONS(3185),
    [anon_sym_equals] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(3185),
    [anon_sym_orderby] = ACTIONS(3185),
    [anon_sym_ascending] = ACTIONS(3185),
    [anon_sym_descending] = ACTIONS(3185),
    [anon_sym_group] = ACTIONS(3185),
    [anon_sym_by] = ACTIONS(3185),
    [anon_sym_select] = ACTIONS(3185),
    [anon_sym_stackalloc] = ACTIONS(3185),
    [anon_sym_sizeof] = ACTIONS(3185),
    [anon_sym_typeof] = ACTIONS(3185),
    [anon_sym___makeref] = ACTIONS(3185),
    [anon_sym___reftype] = ACTIONS(3185),
    [anon_sym___refvalue] = ACTIONS(3185),
    [sym_null_literal] = ACTIONS(3185),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [sym_integer_literal] = ACTIONS(3185),
    [sym_real_literal] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [sym_verbatim_string_literal] = ACTIONS(3187),
    [aux_sym_preproc_if_token1] = ACTIONS(3187),
    [aux_sym_preproc_if_token3] = ACTIONS(3187),
    [aux_sym_preproc_else_token1] = ACTIONS(3187),
    [aux_sym_preproc_elif_token1] = ACTIONS(3187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3187),
    [sym_interpolation_verbatim_start] = ACTIONS(3187),
    [sym_interpolation_raw_start] = ACTIONS(3187),
    [sym_raw_string_start] = ACTIONS(3187),
  },
  [1948] = {
    [sym_preproc_region] = STATE(1948),
    [sym_preproc_endregion] = STATE(1948),
    [sym_preproc_line] = STATE(1948),
    [sym_preproc_pragma] = STATE(1948),
    [sym_preproc_nullable] = STATE(1948),
    [sym_preproc_error] = STATE(1948),
    [sym_preproc_warning] = STATE(1948),
    [sym_preproc_define] = STATE(1948),
    [sym_preproc_undef] = STATE(1948),
    [sym__identifier_token] = ACTIONS(3189),
    [anon_sym_extern] = ACTIONS(3189),
    [anon_sym_alias] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_using] = ACTIONS(3189),
    [anon_sym_unsafe] = ACTIONS(3189),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_namespace] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_struct] = ACTIONS(3189),
    [anon_sym_enum] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3189),
    [anon_sym_delegate] = ACTIONS(3189),
    [anon_sym_record] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_file] = ACTIONS(3189),
    [anon_sym_fixed] = ACTIONS(3189),
    [anon_sym_internal] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_override] = ACTIONS(3189),
    [anon_sym_partial] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_readonly] = ACTIONS(3189),
    [anon_sym_required] = ACTIONS(3189),
    [anon_sym_sealed] = ACTIONS(3189),
    [anon_sym_virtual] = ACTIONS(3189),
    [anon_sym_volatile] = ACTIONS(3189),
    [anon_sym_where] = ACTIONS(3189),
    [anon_sym_notnull] = ACTIONS(3189),
    [anon_sym_unmanaged] = ACTIONS(3189),
    [anon_sym_checked] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_true] = ACTIONS(3189),
    [anon_sym_false] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3191),
    [anon_sym_CARET] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3191),
    [anon_sym_this] = ACTIONS(3189),
    [anon_sym_scoped] = ACTIONS(3189),
    [anon_sym_base] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [sym_predefined_type] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_unchecked] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_when] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_into] = ACTIONS(3189),
    [anon_sym_join] = ACTIONS(3189),
    [anon_sym_on] = ACTIONS(3189),
    [anon_sym_equals] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_orderby] = ACTIONS(3189),
    [anon_sym_ascending] = ACTIONS(3189),
    [anon_sym_descending] = ACTIONS(3189),
    [anon_sym_group] = ACTIONS(3189),
    [anon_sym_by] = ACTIONS(3189),
    [anon_sym_select] = ACTIONS(3189),
    [anon_sym_stackalloc] = ACTIONS(3189),
    [anon_sym_sizeof] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym___makeref] = ACTIONS(3189),
    [anon_sym___reftype] = ACTIONS(3189),
    [anon_sym___refvalue] = ACTIONS(3189),
    [sym_null_literal] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_integer_literal] = ACTIONS(3189),
    [sym_real_literal] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [sym_verbatim_string_literal] = ACTIONS(3191),
    [aux_sym_preproc_if_token1] = ACTIONS(3191),
    [aux_sym_preproc_if_token3] = ACTIONS(3191),
    [aux_sym_preproc_else_token1] = ACTIONS(3191),
    [aux_sym_preproc_elif_token1] = ACTIONS(3191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3191),
    [sym_interpolation_verbatim_start] = ACTIONS(3191),
    [sym_interpolation_raw_start] = ACTIONS(3191),
    [sym_raw_string_start] = ACTIONS(3191),
  },
  [1949] = {
    [sym_preproc_region] = STATE(1949),
    [sym_preproc_endregion] = STATE(1949),
    [sym_preproc_line] = STATE(1949),
    [sym_preproc_pragma] = STATE(1949),
    [sym_preproc_nullable] = STATE(1949),
    [sym_preproc_error] = STATE(1949),
    [sym_preproc_warning] = STATE(1949),
    [sym_preproc_define] = STATE(1949),
    [sym_preproc_undef] = STATE(1949),
    [sym__identifier_token] = ACTIONS(3193),
    [anon_sym_extern] = ACTIONS(3193),
    [anon_sym_alias] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_global] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_unsafe] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_class] = ACTIONS(3193),
    [anon_sym_ref] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_enum] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_delegate] = ACTIONS(3193),
    [anon_sym_record] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_file] = ACTIONS(3193),
    [anon_sym_fixed] = ACTIONS(3193),
    [anon_sym_internal] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_partial] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_readonly] = ACTIONS(3193),
    [anon_sym_required] = ACTIONS(3193),
    [anon_sym_sealed] = ACTIONS(3193),
    [anon_sym_virtual] = ACTIONS(3193),
    [anon_sym_volatile] = ACTIONS(3193),
    [anon_sym_where] = ACTIONS(3193),
    [anon_sym_notnull] = ACTIONS(3193),
    [anon_sym_unmanaged] = ACTIONS(3193),
    [anon_sym_checked] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_true] = ACTIONS(3193),
    [anon_sym_false] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_STAR] = ACTIONS(3195),
    [anon_sym_CARET] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3195),
    [anon_sym_this] = ACTIONS(3193),
    [anon_sym_scoped] = ACTIONS(3193),
    [anon_sym_base] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [sym_predefined_type] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_unchecked] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_lock] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_when] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_foreach] = ACTIONS(3193),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3197),
    [anon_sym_DOT_DOT] = ACTIONS(3195),
    [anon_sym_from] = ACTIONS(3193),
    [anon_sym_into] = ACTIONS(3193),
    [anon_sym_join] = ACTIONS(3193),
    [anon_sym_on] = ACTIONS(3193),
    [anon_sym_equals] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_orderby] = ACTIONS(3193),
    [anon_sym_ascending] = ACTIONS(3193),
    [anon_sym_descending] = ACTIONS(3193),
    [anon_sym_group] = ACTIONS(3193),
    [anon_sym_by] = ACTIONS(3193),
    [anon_sym_select] = ACTIONS(3193),
    [anon_sym_stackalloc] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym___makeref] = ACTIONS(3193),
    [anon_sym___reftype] = ACTIONS(3193),
    [anon_sym___refvalue] = ACTIONS(3193),
    [sym_null_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_integer_literal] = ACTIONS(3193),
    [sym_real_literal] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [sym_verbatim_string_literal] = ACTIONS(3195),
    [aux_sym_preproc_if_token1] = ACTIONS(3195),
    [aux_sym_preproc_if_token3] = ACTIONS(3195),
    [aux_sym_preproc_else_token1] = ACTIONS(3195),
    [aux_sym_preproc_elif_token1] = ACTIONS(3195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3195),
    [sym_interpolation_verbatim_start] = ACTIONS(3195),
    [sym_interpolation_raw_start] = ACTIONS(3195),
    [sym_raw_string_start] = ACTIONS(3195),
  },
  [1950] = {
    [sym_preproc_region] = STATE(1950),
    [sym_preproc_endregion] = STATE(1950),
    [sym_preproc_line] = STATE(1950),
    [sym_preproc_pragma] = STATE(1950),
    [sym_preproc_nullable] = STATE(1950),
    [sym_preproc_error] = STATE(1950),
    [sym_preproc_warning] = STATE(1950),
    [sym_preproc_define] = STATE(1950),
    [sym_preproc_undef] = STATE(1950),
    [sym__identifier_token] = ACTIONS(3199),
    [anon_sym_extern] = ACTIONS(3199),
    [anon_sym_alias] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_global] = ACTIONS(3199),
    [anon_sym_using] = ACTIONS(3199),
    [anon_sym_unsafe] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_namespace] = ACTIONS(3199),
    [anon_sym_class] = ACTIONS(3199),
    [anon_sym_ref] = ACTIONS(3199),
    [anon_sym_struct] = ACTIONS(3199),
    [anon_sym_enum] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_interface] = ACTIONS(3199),
    [anon_sym_delegate] = ACTIONS(3199),
    [anon_sym_record] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_file] = ACTIONS(3199),
    [anon_sym_fixed] = ACTIONS(3199),
    [anon_sym_internal] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_override] = ACTIONS(3199),
    [anon_sym_partial] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_required] = ACTIONS(3199),
    [anon_sym_sealed] = ACTIONS(3199),
    [anon_sym_virtual] = ACTIONS(3199),
    [anon_sym_volatile] = ACTIONS(3199),
    [anon_sym_where] = ACTIONS(3199),
    [anon_sym_notnull] = ACTIONS(3199),
    [anon_sym_unmanaged] = ACTIONS(3199),
    [anon_sym_checked] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3199),
    [anon_sym_false] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_STAR] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_this] = ACTIONS(3199),
    [anon_sym_scoped] = ACTIONS(3199),
    [anon_sym_base] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [sym_predefined_type] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_unchecked] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_lock] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_when] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_foreach] = ACTIONS(3199),
    [anon_sym_goto] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_DOT_DOT] = ACTIONS(3201),
    [anon_sym_from] = ACTIONS(3199),
    [anon_sym_into] = ACTIONS(3199),
    [anon_sym_join] = ACTIONS(3199),
    [anon_sym_on] = ACTIONS(3199),
    [anon_sym_equals] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_orderby] = ACTIONS(3199),
    [anon_sym_ascending] = ACTIONS(3199),
    [anon_sym_descending] = ACTIONS(3199),
    [anon_sym_group] = ACTIONS(3199),
    [anon_sym_by] = ACTIONS(3199),
    [anon_sym_select] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3199),
    [anon_sym_sizeof] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym___makeref] = ACTIONS(3199),
    [anon_sym___reftype] = ACTIONS(3199),
    [anon_sym___refvalue] = ACTIONS(3199),
    [sym_null_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(3199),
    [sym_real_literal] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [sym_verbatim_string_literal] = ACTIONS(3201),
    [aux_sym_preproc_if_token1] = ACTIONS(3201),
    [aux_sym_preproc_if_token3] = ACTIONS(3201),
    [aux_sym_preproc_else_token1] = ACTIONS(3201),
    [aux_sym_preproc_elif_token1] = ACTIONS(3201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3201),
    [sym_interpolation_verbatim_start] = ACTIONS(3201),
    [sym_interpolation_raw_start] = ACTIONS(3201),
    [sym_raw_string_start] = ACTIONS(3201),
  },
  [1951] = {
    [sym_preproc_region] = STATE(1951),
    [sym_preproc_endregion] = STATE(1951),
    [sym_preproc_line] = STATE(1951),
    [sym_preproc_pragma] = STATE(1951),
    [sym_preproc_nullable] = STATE(1951),
    [sym_preproc_error] = STATE(1951),
    [sym_preproc_warning] = STATE(1951),
    [sym_preproc_define] = STATE(1951),
    [sym_preproc_undef] = STATE(1951),
    [sym__identifier_token] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_alias] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_global] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_namespace] = ACTIONS(3203),
    [anon_sym_class] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_enum] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_interface] = ACTIONS(3203),
    [anon_sym_delegate] = ACTIONS(3203),
    [anon_sym_record] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_file] = ACTIONS(3203),
    [anon_sym_fixed] = ACTIONS(3203),
    [anon_sym_internal] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_override] = ACTIONS(3203),
    [anon_sym_partial] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_required] = ACTIONS(3203),
    [anon_sym_sealed] = ACTIONS(3203),
    [anon_sym_virtual] = ACTIONS(3203),
    [anon_sym_volatile] = ACTIONS(3203),
    [anon_sym_where] = ACTIONS(3203),
    [anon_sym_notnull] = ACTIONS(3203),
    [anon_sym_unmanaged] = ACTIONS(3203),
    [anon_sym_checked] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_CARET] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_this] = ACTIONS(3203),
    [anon_sym_scoped] = ACTIONS(3203),
    [anon_sym_base] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [sym_predefined_type] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_unchecked] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_lock] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_when] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_foreach] = ACTIONS(3203),
    [anon_sym_goto] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_from] = ACTIONS(3203),
    [anon_sym_into] = ACTIONS(3203),
    [anon_sym_join] = ACTIONS(3203),
    [anon_sym_on] = ACTIONS(3203),
    [anon_sym_equals] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_orderby] = ACTIONS(3203),
    [anon_sym_ascending] = ACTIONS(3203),
    [anon_sym_descending] = ACTIONS(3203),
    [anon_sym_group] = ACTIONS(3203),
    [anon_sym_by] = ACTIONS(3203),
    [anon_sym_select] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3203),
    [anon_sym_sizeof] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym___makeref] = ACTIONS(3203),
    [anon_sym___reftype] = ACTIONS(3203),
    [anon_sym___refvalue] = ACTIONS(3203),
    [sym_null_literal] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_integer_literal] = ACTIONS(3203),
    [sym_real_literal] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_verbatim_string_literal] = ACTIONS(3205),
    [aux_sym_preproc_if_token1] = ACTIONS(3205),
    [aux_sym_preproc_if_token3] = ACTIONS(3205),
    [aux_sym_preproc_else_token1] = ACTIONS(3205),
    [aux_sym_preproc_elif_token1] = ACTIONS(3205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3205),
    [sym_interpolation_verbatim_start] = ACTIONS(3205),
    [sym_interpolation_raw_start] = ACTIONS(3205),
    [sym_raw_string_start] = ACTIONS(3205),
  },
  [1952] = {
    [sym_preproc_region] = STATE(1952),
    [sym_preproc_endregion] = STATE(1952),
    [sym_preproc_line] = STATE(1952),
    [sym_preproc_pragma] = STATE(1952),
    [sym_preproc_nullable] = STATE(1952),
    [sym_preproc_error] = STATE(1952),
    [sym_preproc_warning] = STATE(1952),
    [sym_preproc_define] = STATE(1952),
    [sym_preproc_undef] = STATE(1952),
    [sym__identifier_token] = ACTIONS(3207),
    [anon_sym_extern] = ACTIONS(3207),
    [anon_sym_alias] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_unsafe] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_ref] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_delegate] = ACTIONS(3207),
    [anon_sym_record] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_file] = ACTIONS(3207),
    [anon_sym_fixed] = ACTIONS(3207),
    [anon_sym_internal] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_partial] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_sealed] = ACTIONS(3207),
    [anon_sym_virtual] = ACTIONS(3207),
    [anon_sym_volatile] = ACTIONS(3207),
    [anon_sym_where] = ACTIONS(3207),
    [anon_sym_notnull] = ACTIONS(3207),
    [anon_sym_unmanaged] = ACTIONS(3207),
    [anon_sym_checked] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_true] = ACTIONS(3207),
    [anon_sym_false] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_CARET] = ACTIONS(3209),
    [anon_sym_AMP] = ACTIONS(3209),
    [anon_sym_this] = ACTIONS(3207),
    [anon_sym_scoped] = ACTIONS(3207),
    [anon_sym_base] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [sym_predefined_type] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_unchecked] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_lock] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_when] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_foreach] = ACTIONS(3207),
    [anon_sym_goto] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_DOT_DOT] = ACTIONS(3209),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_into] = ACTIONS(3207),
    [anon_sym_join] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_equals] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_orderby] = ACTIONS(3207),
    [anon_sym_ascending] = ACTIONS(3207),
    [anon_sym_descending] = ACTIONS(3207),
    [anon_sym_group] = ACTIONS(3207),
    [anon_sym_by] = ACTIONS(3207),
    [anon_sym_select] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3207),
    [anon_sym_sizeof] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym___makeref] = ACTIONS(3207),
    [anon_sym___reftype] = ACTIONS(3207),
    [anon_sym___refvalue] = ACTIONS(3207),
    [sym_null_literal] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_integer_literal] = ACTIONS(3207),
    [sym_real_literal] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3209),
    [sym_verbatim_string_literal] = ACTIONS(3209),
    [aux_sym_preproc_if_token1] = ACTIONS(3209),
    [aux_sym_preproc_if_token3] = ACTIONS(3209),
    [aux_sym_preproc_else_token1] = ACTIONS(3209),
    [aux_sym_preproc_elif_token1] = ACTIONS(3209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3209),
    [sym_interpolation_verbatim_start] = ACTIONS(3209),
    [sym_interpolation_raw_start] = ACTIONS(3209),
    [sym_raw_string_start] = ACTIONS(3209),
  },
  [1953] = {
    [sym_preproc_region] = STATE(1953),
    [sym_preproc_endregion] = STATE(1953),
    [sym_preproc_line] = STATE(1953),
    [sym_preproc_pragma] = STATE(1953),
    [sym_preproc_nullable] = STATE(1953),
    [sym_preproc_error] = STATE(1953),
    [sym_preproc_warning] = STATE(1953),
    [sym_preproc_define] = STATE(1953),
    [sym_preproc_undef] = STATE(1953),
    [ts_builtin_sym_end] = ACTIONS(3163),
    [sym__identifier_token] = ACTIONS(3161),
    [anon_sym_extern] = ACTIONS(3161),
    [anon_sym_alias] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_global] = ACTIONS(3161),
    [anon_sym_using] = ACTIONS(3161),
    [anon_sym_unsafe] = ACTIONS(3161),
    [anon_sym_static] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3163),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3161),
    [anon_sym_namespace] = ACTIONS(3161),
    [anon_sym_class] = ACTIONS(3161),
    [anon_sym_ref] = ACTIONS(3161),
    [anon_sym_struct] = ACTIONS(3161),
    [anon_sym_enum] = ACTIONS(3161),
    [anon_sym_LBRACE] = ACTIONS(3163),
    [anon_sym_interface] = ACTIONS(3161),
    [anon_sym_delegate] = ACTIONS(3161),
    [anon_sym_record] = ACTIONS(3161),
    [anon_sym_abstract] = ACTIONS(3161),
    [anon_sym_async] = ACTIONS(3161),
    [anon_sym_const] = ACTIONS(3161),
    [anon_sym_file] = ACTIONS(3161),
    [anon_sym_fixed] = ACTIONS(3161),
    [anon_sym_internal] = ACTIONS(3161),
    [anon_sym_new] = ACTIONS(3161),
    [anon_sym_override] = ACTIONS(3161),
    [anon_sym_partial] = ACTIONS(3161),
    [anon_sym_private] = ACTIONS(3161),
    [anon_sym_protected] = ACTIONS(3161),
    [anon_sym_public] = ACTIONS(3161),
    [anon_sym_readonly] = ACTIONS(3161),
    [anon_sym_required] = ACTIONS(3161),
    [anon_sym_sealed] = ACTIONS(3161),
    [anon_sym_virtual] = ACTIONS(3161),
    [anon_sym_volatile] = ACTIONS(3161),
    [anon_sym_where] = ACTIONS(3161),
    [anon_sym_notnull] = ACTIONS(3161),
    [anon_sym_unmanaged] = ACTIONS(3161),
    [anon_sym_checked] = ACTIONS(3161),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3163),
    [anon_sym_true] = ACTIONS(3161),
    [anon_sym_false] = ACTIONS(3161),
    [anon_sym_PLUS] = ACTIONS(3161),
    [anon_sym_DASH] = ACTIONS(3161),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_this] = ACTIONS(3161),
    [anon_sym_scoped] = ACTIONS(3161),
    [anon_sym_base] = ACTIONS(3161),
    [anon_sym_var] = ACTIONS(3161),
    [sym_predefined_type] = ACTIONS(3161),
    [anon_sym_break] = ACTIONS(3161),
    [anon_sym_unchecked] = ACTIONS(3161),
    [anon_sym_continue] = ACTIONS(3161),
    [anon_sym_do] = ACTIONS(3161),
    [anon_sym_while] = ACTIONS(3161),
    [anon_sym_for] = ACTIONS(3161),
    [anon_sym_lock] = ACTIONS(3161),
    [anon_sym_yield] = ACTIONS(3161),
    [anon_sym_switch] = ACTIONS(3161),
    [anon_sym_default] = ACTIONS(3161),
    [anon_sym_throw] = ACTIONS(3161),
    [anon_sym_try] = ACTIONS(3161),
    [anon_sym_catch] = ACTIONS(3161),
    [anon_sym_when] = ACTIONS(3161),
    [anon_sym_finally] = ACTIONS(3161),
    [anon_sym_await] = ACTIONS(3161),
    [anon_sym_foreach] = ACTIONS(3161),
    [anon_sym_goto] = ACTIONS(3161),
    [anon_sym_if] = ACTIONS(3161),
    [anon_sym_else] = ACTIONS(3161),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_from] = ACTIONS(3161),
    [anon_sym_into] = ACTIONS(3161),
    [anon_sym_join] = ACTIONS(3161),
    [anon_sym_on] = ACTIONS(3161),
    [anon_sym_equals] = ACTIONS(3161),
    [anon_sym_let] = ACTIONS(3161),
    [anon_sym_orderby] = ACTIONS(3161),
    [anon_sym_ascending] = ACTIONS(3161),
    [anon_sym_descending] = ACTIONS(3161),
    [anon_sym_group] = ACTIONS(3161),
    [anon_sym_by] = ACTIONS(3161),
    [anon_sym_select] = ACTIONS(3161),
    [anon_sym_stackalloc] = ACTIONS(3161),
    [anon_sym_sizeof] = ACTIONS(3161),
    [anon_sym_typeof] = ACTIONS(3161),
    [anon_sym___makeref] = ACTIONS(3161),
    [anon_sym___reftype] = ACTIONS(3161),
    [anon_sym___refvalue] = ACTIONS(3161),
    [sym_null_literal] = ACTIONS(3161),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [sym_integer_literal] = ACTIONS(3161),
    [sym_real_literal] = ACTIONS(3163),
    [anon_sym_DQUOTE] = ACTIONS(3163),
    [sym_verbatim_string_literal] = ACTIONS(3163),
    [aux_sym_preproc_if_token1] = ACTIONS(3163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3163),
    [sym_interpolation_verbatim_start] = ACTIONS(3163),
    [sym_interpolation_raw_start] = ACTIONS(3163),
    [sym_raw_string_start] = ACTIONS(3163),
  },
  [1954] = {
    [sym_preproc_region] = STATE(1954),
    [sym_preproc_endregion] = STATE(1954),
    [sym_preproc_line] = STATE(1954),
    [sym_preproc_pragma] = STATE(1954),
    [sym_preproc_nullable] = STATE(1954),
    [sym_preproc_error] = STATE(1954),
    [sym_preproc_warning] = STATE(1954),
    [sym_preproc_define] = STATE(1954),
    [sym_preproc_undef] = STATE(1954),
    [sym__identifier_token] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3211),
    [anon_sym_alias] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_global] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_ref] = ACTIONS(3211),
    [anon_sym_struct] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_delegate] = ACTIONS(3211),
    [anon_sym_record] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_file] = ACTIONS(3211),
    [anon_sym_fixed] = ACTIONS(3211),
    [anon_sym_internal] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_partial] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_required] = ACTIONS(3211),
    [anon_sym_sealed] = ACTIONS(3211),
    [anon_sym_virtual] = ACTIONS(3211),
    [anon_sym_volatile] = ACTIONS(3211),
    [anon_sym_where] = ACTIONS(3211),
    [anon_sym_notnull] = ACTIONS(3211),
    [anon_sym_unmanaged] = ACTIONS(3211),
    [anon_sym_checked] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_true] = ACTIONS(3211),
    [anon_sym_false] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_CARET] = ACTIONS(3213),
    [anon_sym_AMP] = ACTIONS(3213),
    [anon_sym_this] = ACTIONS(3211),
    [anon_sym_scoped] = ACTIONS(3211),
    [anon_sym_base] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [sym_predefined_type] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_unchecked] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_lock] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_when] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_foreach] = ACTIONS(3211),
    [anon_sym_goto] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_DOT_DOT] = ACTIONS(3213),
    [anon_sym_from] = ACTIONS(3211),
    [anon_sym_into] = ACTIONS(3211),
    [anon_sym_join] = ACTIONS(3211),
    [anon_sym_on] = ACTIONS(3211),
    [anon_sym_equals] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_orderby] = ACTIONS(3211),
    [anon_sym_ascending] = ACTIONS(3211),
    [anon_sym_descending] = ACTIONS(3211),
    [anon_sym_group] = ACTIONS(3211),
    [anon_sym_by] = ACTIONS(3211),
    [anon_sym_select] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3211),
    [anon_sym_sizeof] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym___makeref] = ACTIONS(3211),
    [anon_sym___reftype] = ACTIONS(3211),
    [anon_sym___refvalue] = ACTIONS(3211),
    [sym_null_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_integer_literal] = ACTIONS(3211),
    [sym_real_literal] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [sym_verbatim_string_literal] = ACTIONS(3213),
    [aux_sym_preproc_if_token1] = ACTIONS(3213),
    [aux_sym_preproc_if_token3] = ACTIONS(3213),
    [aux_sym_preproc_else_token1] = ACTIONS(3213),
    [aux_sym_preproc_elif_token1] = ACTIONS(3213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3213),
    [sym_interpolation_verbatim_start] = ACTIONS(3213),
    [sym_interpolation_raw_start] = ACTIONS(3213),
    [sym_raw_string_start] = ACTIONS(3213),
  },
  [1955] = {
    [sym_preproc_region] = STATE(1955),
    [sym_preproc_endregion] = STATE(1955),
    [sym_preproc_line] = STATE(1955),
    [sym_preproc_pragma] = STATE(1955),
    [sym_preproc_nullable] = STATE(1955),
    [sym_preproc_error] = STATE(1955),
    [sym_preproc_warning] = STATE(1955),
    [sym_preproc_define] = STATE(1955),
    [sym_preproc_undef] = STATE(1955),
    [sym__identifier_token] = ACTIONS(3215),
    [anon_sym_extern] = ACTIONS(3215),
    [anon_sym_alias] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_global] = ACTIONS(3215),
    [anon_sym_using] = ACTIONS(3215),
    [anon_sym_unsafe] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_namespace] = ACTIONS(3215),
    [anon_sym_class] = ACTIONS(3215),
    [anon_sym_ref] = ACTIONS(3215),
    [anon_sym_struct] = ACTIONS(3215),
    [anon_sym_enum] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3215),
    [anon_sym_delegate] = ACTIONS(3215),
    [anon_sym_record] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_file] = ACTIONS(3215),
    [anon_sym_fixed] = ACTIONS(3215),
    [anon_sym_internal] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_override] = ACTIONS(3215),
    [anon_sym_partial] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_required] = ACTIONS(3215),
    [anon_sym_sealed] = ACTIONS(3215),
    [anon_sym_virtual] = ACTIONS(3215),
    [anon_sym_volatile] = ACTIONS(3215),
    [anon_sym_where] = ACTIONS(3215),
    [anon_sym_notnull] = ACTIONS(3215),
    [anon_sym_unmanaged] = ACTIONS(3215),
    [anon_sym_checked] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_true] = ACTIONS(3215),
    [anon_sym_false] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3217),
    [anon_sym_CARET] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3217),
    [anon_sym_this] = ACTIONS(3215),
    [anon_sym_scoped] = ACTIONS(3215),
    [anon_sym_base] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [sym_predefined_type] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_unchecked] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_lock] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_when] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_foreach] = ACTIONS(3215),
    [anon_sym_goto] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_DOT_DOT] = ACTIONS(3217),
    [anon_sym_from] = ACTIONS(3215),
    [anon_sym_into] = ACTIONS(3215),
    [anon_sym_join] = ACTIONS(3215),
    [anon_sym_on] = ACTIONS(3215),
    [anon_sym_equals] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_orderby] = ACTIONS(3215),
    [anon_sym_ascending] = ACTIONS(3215),
    [anon_sym_descending] = ACTIONS(3215),
    [anon_sym_group] = ACTIONS(3215),
    [anon_sym_by] = ACTIONS(3215),
    [anon_sym_select] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3215),
    [anon_sym_sizeof] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym___makeref] = ACTIONS(3215),
    [anon_sym___reftype] = ACTIONS(3215),
    [anon_sym___refvalue] = ACTIONS(3215),
    [sym_null_literal] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_integer_literal] = ACTIONS(3215),
    [sym_real_literal] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [sym_verbatim_string_literal] = ACTIONS(3217),
    [aux_sym_preproc_if_token1] = ACTIONS(3217),
    [aux_sym_preproc_if_token3] = ACTIONS(3217),
    [aux_sym_preproc_else_token1] = ACTIONS(3217),
    [aux_sym_preproc_elif_token1] = ACTIONS(3217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3217),
    [sym_interpolation_verbatim_start] = ACTIONS(3217),
    [sym_interpolation_raw_start] = ACTIONS(3217),
    [sym_raw_string_start] = ACTIONS(3217),
  },
  [1956] = {
    [sym_preproc_region] = STATE(1956),
    [sym_preproc_endregion] = STATE(1956),
    [sym_preproc_line] = STATE(1956),
    [sym_preproc_pragma] = STATE(1956),
    [sym_preproc_nullable] = STATE(1956),
    [sym_preproc_error] = STATE(1956),
    [sym_preproc_warning] = STATE(1956),
    [sym_preproc_define] = STATE(1956),
    [sym_preproc_undef] = STATE(1956),
    [ts_builtin_sym_end] = ACTIONS(3152),
    [sym__identifier_token] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym_alias] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_unsafe] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_ref] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3150),
    [anon_sym_delegate] = ACTIONS(3150),
    [anon_sym_record] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_file] = ACTIONS(3150),
    [anon_sym_fixed] = ACTIONS(3150),
    [anon_sym_internal] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_partial] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_required] = ACTIONS(3150),
    [anon_sym_sealed] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_where] = ACTIONS(3150),
    [anon_sym_notnull] = ACTIONS(3150),
    [anon_sym_unmanaged] = ACTIONS(3150),
    [anon_sym_checked] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_true] = ACTIONS(3150),
    [anon_sym_false] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_this] = ACTIONS(3150),
    [anon_sym_scoped] = ACTIONS(3150),
    [anon_sym_base] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [sym_predefined_type] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_unchecked] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_lock] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_catch] = ACTIONS(3150),
    [anon_sym_when] = ACTIONS(3150),
    [anon_sym_finally] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_foreach] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_into] = ACTIONS(3150),
    [anon_sym_join] = ACTIONS(3150),
    [anon_sym_on] = ACTIONS(3150),
    [anon_sym_equals] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_orderby] = ACTIONS(3150),
    [anon_sym_ascending] = ACTIONS(3150),
    [anon_sym_descending] = ACTIONS(3150),
    [anon_sym_group] = ACTIONS(3150),
    [anon_sym_by] = ACTIONS(3150),
    [anon_sym_select] = ACTIONS(3150),
    [anon_sym_stackalloc] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym___makeref] = ACTIONS(3150),
    [anon_sym___reftype] = ACTIONS(3150),
    [anon_sym___refvalue] = ACTIONS(3150),
    [sym_null_literal] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [sym_integer_literal] = ACTIONS(3150),
    [sym_real_literal] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_verbatim_string_literal] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3152),
    [sym_interpolation_verbatim_start] = ACTIONS(3152),
    [sym_interpolation_raw_start] = ACTIONS(3152),
    [sym_raw_string_start] = ACTIONS(3152),
  },
  [1957] = {
    [sym_preproc_region] = STATE(1957),
    [sym_preproc_endregion] = STATE(1957),
    [sym_preproc_line] = STATE(1957),
    [sym_preproc_pragma] = STATE(1957),
    [sym_preproc_nullable] = STATE(1957),
    [sym_preproc_error] = STATE(1957),
    [sym_preproc_warning] = STATE(1957),
    [sym_preproc_define] = STATE(1957),
    [sym_preproc_undef] = STATE(1957),
    [ts_builtin_sym_end] = ACTIONS(2979),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_record] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_checked] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2979),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_true] = ACTIONS(2977),
    [anon_sym_false] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym_this] = ACTIONS(2977),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_base] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_unchecked] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_catch] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_finally] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_foreach] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_stackalloc] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym___makeref] = ACTIONS(2977),
    [anon_sym___reftype] = ACTIONS(2977),
    [anon_sym___refvalue] = ACTIONS(2977),
    [sym_null_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_integer_literal] = ACTIONS(2977),
    [sym_real_literal] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [sym_verbatim_string_literal] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2979),
    [sym_interpolation_verbatim_start] = ACTIONS(2979),
    [sym_interpolation_raw_start] = ACTIONS(2979),
    [sym_raw_string_start] = ACTIONS(2979),
  },
  [1958] = {
    [sym_preproc_region] = STATE(1958),
    [sym_preproc_endregion] = STATE(1958),
    [sym_preproc_line] = STATE(1958),
    [sym_preproc_pragma] = STATE(1958),
    [sym_preproc_nullable] = STATE(1958),
    [sym_preproc_error] = STATE(1958),
    [sym_preproc_warning] = STATE(1958),
    [sym_preproc_define] = STATE(1958),
    [sym_preproc_undef] = STATE(1958),
    [sym__identifier_token] = ACTIONS(3219),
    [anon_sym_extern] = ACTIONS(3219),
    [anon_sym_alias] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_global] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_unsafe] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_ref] = ACTIONS(3219),
    [anon_sym_struct] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_delegate] = ACTIONS(3219),
    [anon_sym_record] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_file] = ACTIONS(3219),
    [anon_sym_fixed] = ACTIONS(3219),
    [anon_sym_internal] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_partial] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_required] = ACTIONS(3219),
    [anon_sym_sealed] = ACTIONS(3219),
    [anon_sym_virtual] = ACTIONS(3219),
    [anon_sym_volatile] = ACTIONS(3219),
    [anon_sym_where] = ACTIONS(3219),
    [anon_sym_notnull] = ACTIONS(3219),
    [anon_sym_unmanaged] = ACTIONS(3219),
    [anon_sym_checked] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_true] = ACTIONS(3219),
    [anon_sym_false] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_CARET] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_this] = ACTIONS(3219),
    [anon_sym_scoped] = ACTIONS(3219),
    [anon_sym_base] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [sym_predefined_type] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_unchecked] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_lock] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_when] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_foreach] = ACTIONS(3219),
    [anon_sym_goto] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_DOT_DOT] = ACTIONS(3221),
    [anon_sym_from] = ACTIONS(3219),
    [anon_sym_into] = ACTIONS(3219),
    [anon_sym_join] = ACTIONS(3219),
    [anon_sym_on] = ACTIONS(3219),
    [anon_sym_equals] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_orderby] = ACTIONS(3219),
    [anon_sym_ascending] = ACTIONS(3219),
    [anon_sym_descending] = ACTIONS(3219),
    [anon_sym_group] = ACTIONS(3219),
    [anon_sym_by] = ACTIONS(3219),
    [anon_sym_select] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3219),
    [anon_sym_sizeof] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym___makeref] = ACTIONS(3219),
    [anon_sym___reftype] = ACTIONS(3219),
    [anon_sym___refvalue] = ACTIONS(3219),
    [sym_null_literal] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_integer_literal] = ACTIONS(3219),
    [sym_real_literal] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [sym_verbatim_string_literal] = ACTIONS(3221),
    [aux_sym_preproc_if_token1] = ACTIONS(3221),
    [aux_sym_preproc_if_token3] = ACTIONS(3221),
    [aux_sym_preproc_else_token1] = ACTIONS(3221),
    [aux_sym_preproc_elif_token1] = ACTIONS(3221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3221),
    [sym_interpolation_verbatim_start] = ACTIONS(3221),
    [sym_interpolation_raw_start] = ACTIONS(3221),
    [sym_raw_string_start] = ACTIONS(3221),
  },
  [1959] = {
    [sym_preproc_region] = STATE(1959),
    [sym_preproc_endregion] = STATE(1959),
    [sym_preproc_line] = STATE(1959),
    [sym_preproc_pragma] = STATE(1959),
    [sym_preproc_nullable] = STATE(1959),
    [sym_preproc_error] = STATE(1959),
    [sym_preproc_warning] = STATE(1959),
    [sym_preproc_define] = STATE(1959),
    [sym_preproc_undef] = STATE(1959),
    [sym__identifier_token] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_alias] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_ref] = ACTIONS(3223),
    [anon_sym_struct] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_delegate] = ACTIONS(3223),
    [anon_sym_record] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_file] = ACTIONS(3223),
    [anon_sym_fixed] = ACTIONS(3223),
    [anon_sym_internal] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_partial] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_required] = ACTIONS(3223),
    [anon_sym_sealed] = ACTIONS(3223),
    [anon_sym_virtual] = ACTIONS(3223),
    [anon_sym_volatile] = ACTIONS(3223),
    [anon_sym_where] = ACTIONS(3223),
    [anon_sym_notnull] = ACTIONS(3223),
    [anon_sym_unmanaged] = ACTIONS(3223),
    [anon_sym_checked] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_true] = ACTIONS(3223),
    [anon_sym_false] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3225),
    [anon_sym_CARET] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3225),
    [anon_sym_this] = ACTIONS(3223),
    [anon_sym_scoped] = ACTIONS(3223),
    [anon_sym_base] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [sym_predefined_type] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_unchecked] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_lock] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_when] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_foreach] = ACTIONS(3223),
    [anon_sym_goto] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_DOT_DOT] = ACTIONS(3225),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_into] = ACTIONS(3223),
    [anon_sym_join] = ACTIONS(3223),
    [anon_sym_on] = ACTIONS(3223),
    [anon_sym_equals] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_orderby] = ACTIONS(3223),
    [anon_sym_ascending] = ACTIONS(3223),
    [anon_sym_descending] = ACTIONS(3223),
    [anon_sym_group] = ACTIONS(3223),
    [anon_sym_by] = ACTIONS(3223),
    [anon_sym_select] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3223),
    [anon_sym_sizeof] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym___makeref] = ACTIONS(3223),
    [anon_sym___reftype] = ACTIONS(3223),
    [anon_sym___refvalue] = ACTIONS(3223),
    [sym_null_literal] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_integer_literal] = ACTIONS(3223),
    [sym_real_literal] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [sym_verbatim_string_literal] = ACTIONS(3225),
    [aux_sym_preproc_if_token1] = ACTIONS(3225),
    [aux_sym_preproc_if_token3] = ACTIONS(3225),
    [aux_sym_preproc_else_token1] = ACTIONS(3225),
    [aux_sym_preproc_elif_token1] = ACTIONS(3225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3225),
    [sym_interpolation_verbatim_start] = ACTIONS(3225),
    [sym_interpolation_raw_start] = ACTIONS(3225),
    [sym_raw_string_start] = ACTIONS(3225),
  },
  [1960] = {
    [sym_preproc_region] = STATE(1960),
    [sym_preproc_endregion] = STATE(1960),
    [sym_preproc_line] = STATE(1960),
    [sym_preproc_pragma] = STATE(1960),
    [sym_preproc_nullable] = STATE(1960),
    [sym_preproc_error] = STATE(1960),
    [sym_preproc_warning] = STATE(1960),
    [sym_preproc_define] = STATE(1960),
    [sym_preproc_undef] = STATE(1960),
    [sym__identifier_token] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3227),
    [anon_sym_alias] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_unsafe] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_ref] = ACTIONS(3227),
    [anon_sym_struct] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_delegate] = ACTIONS(3227),
    [anon_sym_record] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_file] = ACTIONS(3227),
    [anon_sym_fixed] = ACTIONS(3227),
    [anon_sym_internal] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_partial] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_required] = ACTIONS(3227),
    [anon_sym_sealed] = ACTIONS(3227),
    [anon_sym_virtual] = ACTIONS(3227),
    [anon_sym_volatile] = ACTIONS(3227),
    [anon_sym_where] = ACTIONS(3227),
    [anon_sym_notnull] = ACTIONS(3227),
    [anon_sym_unmanaged] = ACTIONS(3227),
    [anon_sym_checked] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_true] = ACTIONS(3227),
    [anon_sym_false] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_this] = ACTIONS(3227),
    [anon_sym_scoped] = ACTIONS(3227),
    [anon_sym_base] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [sym_predefined_type] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_unchecked] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_lock] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_when] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_foreach] = ACTIONS(3227),
    [anon_sym_goto] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_DOT_DOT] = ACTIONS(3229),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_into] = ACTIONS(3227),
    [anon_sym_join] = ACTIONS(3227),
    [anon_sym_on] = ACTIONS(3227),
    [anon_sym_equals] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_orderby] = ACTIONS(3227),
    [anon_sym_ascending] = ACTIONS(3227),
    [anon_sym_descending] = ACTIONS(3227),
    [anon_sym_group] = ACTIONS(3227),
    [anon_sym_by] = ACTIONS(3227),
    [anon_sym_select] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3227),
    [anon_sym_sizeof] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym___makeref] = ACTIONS(3227),
    [anon_sym___reftype] = ACTIONS(3227),
    [anon_sym___refvalue] = ACTIONS(3227),
    [sym_null_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_integer_literal] = ACTIONS(3227),
    [sym_real_literal] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [sym_verbatim_string_literal] = ACTIONS(3229),
    [aux_sym_preproc_if_token1] = ACTIONS(3229),
    [aux_sym_preproc_if_token3] = ACTIONS(3229),
    [aux_sym_preproc_else_token1] = ACTIONS(3229),
    [aux_sym_preproc_elif_token1] = ACTIONS(3229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3229),
    [sym_interpolation_verbatim_start] = ACTIONS(3229),
    [sym_interpolation_raw_start] = ACTIONS(3229),
    [sym_raw_string_start] = ACTIONS(3229),
  },
  [1961] = {
    [sym_preproc_region] = STATE(1961),
    [sym_preproc_endregion] = STATE(1961),
    [sym_preproc_line] = STATE(1961),
    [sym_preproc_pragma] = STATE(1961),
    [sym_preproc_nullable] = STATE(1961),
    [sym_preproc_error] = STATE(1961),
    [sym_preproc_warning] = STATE(1961),
    [sym_preproc_define] = STATE(1961),
    [sym_preproc_undef] = STATE(1961),
    [sym__identifier_token] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_alias] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_global] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_ref] = ACTIONS(3231),
    [anon_sym_struct] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_delegate] = ACTIONS(3231),
    [anon_sym_record] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_file] = ACTIONS(3231),
    [anon_sym_fixed] = ACTIONS(3231),
    [anon_sym_internal] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_partial] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_sealed] = ACTIONS(3231),
    [anon_sym_virtual] = ACTIONS(3231),
    [anon_sym_volatile] = ACTIONS(3231),
    [anon_sym_where] = ACTIONS(3231),
    [anon_sym_notnull] = ACTIONS(3231),
    [anon_sym_unmanaged] = ACTIONS(3231),
    [anon_sym_checked] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_false] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3231),
    [anon_sym_scoped] = ACTIONS(3231),
    [anon_sym_base] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [sym_predefined_type] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_unchecked] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_lock] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_when] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_foreach] = ACTIONS(3231),
    [anon_sym_goto] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_DOT_DOT] = ACTIONS(3233),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_into] = ACTIONS(3231),
    [anon_sym_join] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_equals] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_orderby] = ACTIONS(3231),
    [anon_sym_ascending] = ACTIONS(3231),
    [anon_sym_descending] = ACTIONS(3231),
    [anon_sym_group] = ACTIONS(3231),
    [anon_sym_by] = ACTIONS(3231),
    [anon_sym_select] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3231),
    [anon_sym_sizeof] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym___makeref] = ACTIONS(3231),
    [anon_sym___reftype] = ACTIONS(3231),
    [anon_sym___refvalue] = ACTIONS(3231),
    [sym_null_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_integer_literal] = ACTIONS(3231),
    [sym_real_literal] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_verbatim_string_literal] = ACTIONS(3233),
    [aux_sym_preproc_if_token1] = ACTIONS(3233),
    [aux_sym_preproc_if_token3] = ACTIONS(3233),
    [aux_sym_preproc_else_token1] = ACTIONS(3233),
    [aux_sym_preproc_elif_token1] = ACTIONS(3233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3233),
    [sym_interpolation_verbatim_start] = ACTIONS(3233),
    [sym_interpolation_raw_start] = ACTIONS(3233),
    [sym_raw_string_start] = ACTIONS(3233),
  },
  [1962] = {
    [sym_preproc_region] = STATE(1962),
    [sym_preproc_endregion] = STATE(1962),
    [sym_preproc_line] = STATE(1962),
    [sym_preproc_pragma] = STATE(1962),
    [sym_preproc_nullable] = STATE(1962),
    [sym_preproc_error] = STATE(1962),
    [sym_preproc_warning] = STATE(1962),
    [sym_preproc_define] = STATE(1962),
    [sym_preproc_undef] = STATE(1962),
    [sym__identifier_token] = ACTIONS(3235),
    [anon_sym_extern] = ACTIONS(3235),
    [anon_sym_alias] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_global] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_unsafe] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_ref] = ACTIONS(3235),
    [anon_sym_struct] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_delegate] = ACTIONS(3235),
    [anon_sym_record] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_file] = ACTIONS(3235),
    [anon_sym_fixed] = ACTIONS(3235),
    [anon_sym_internal] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_partial] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_required] = ACTIONS(3235),
    [anon_sym_sealed] = ACTIONS(3235),
    [anon_sym_virtual] = ACTIONS(3235),
    [anon_sym_volatile] = ACTIONS(3235),
    [anon_sym_where] = ACTIONS(3235),
    [anon_sym_notnull] = ACTIONS(3235),
    [anon_sym_unmanaged] = ACTIONS(3235),
    [anon_sym_checked] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [anon_sym_true] = ACTIONS(3235),
    [anon_sym_false] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3237),
    [anon_sym_CARET] = ACTIONS(3237),
    [anon_sym_AMP] = ACTIONS(3237),
    [anon_sym_this] = ACTIONS(3235),
    [anon_sym_scoped] = ACTIONS(3235),
    [anon_sym_base] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [sym_predefined_type] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_unchecked] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_lock] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_foreach] = ACTIONS(3235),
    [anon_sym_goto] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3237),
    [anon_sym_from] = ACTIONS(3235),
    [anon_sym_into] = ACTIONS(3235),
    [anon_sym_join] = ACTIONS(3235),
    [anon_sym_on] = ACTIONS(3235),
    [anon_sym_equals] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_orderby] = ACTIONS(3235),
    [anon_sym_ascending] = ACTIONS(3235),
    [anon_sym_descending] = ACTIONS(3235),
    [anon_sym_group] = ACTIONS(3235),
    [anon_sym_by] = ACTIONS(3235),
    [anon_sym_select] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3235),
    [anon_sym_sizeof] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym___makeref] = ACTIONS(3235),
    [anon_sym___reftype] = ACTIONS(3235),
    [anon_sym___refvalue] = ACTIONS(3235),
    [sym_null_literal] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [sym_integer_literal] = ACTIONS(3235),
    [sym_real_literal] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [sym_verbatim_string_literal] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3237),
    [aux_sym_preproc_if_token3] = ACTIONS(3237),
    [aux_sym_preproc_else_token1] = ACTIONS(3237),
    [aux_sym_preproc_elif_token1] = ACTIONS(3237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3237),
    [sym_interpolation_verbatim_start] = ACTIONS(3237),
    [sym_interpolation_raw_start] = ACTIONS(3237),
    [sym_raw_string_start] = ACTIONS(3237),
  },
  [1963] = {
    [sym_preproc_region] = STATE(1963),
    [sym_preproc_endregion] = STATE(1963),
    [sym_preproc_line] = STATE(1963),
    [sym_preproc_pragma] = STATE(1963),
    [sym_preproc_nullable] = STATE(1963),
    [sym_preproc_error] = STATE(1963),
    [sym_preproc_warning] = STATE(1963),
    [sym_preproc_define] = STATE(1963),
    [sym_preproc_undef] = STATE(1963),
    [sym__identifier_token] = ACTIONS(3239),
    [anon_sym_extern] = ACTIONS(3239),
    [anon_sym_alias] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_global] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_unsafe] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_ref] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_delegate] = ACTIONS(3239),
    [anon_sym_record] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_file] = ACTIONS(3239),
    [anon_sym_fixed] = ACTIONS(3239),
    [anon_sym_internal] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_partial] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_required] = ACTIONS(3239),
    [anon_sym_sealed] = ACTIONS(3239),
    [anon_sym_virtual] = ACTIONS(3239),
    [anon_sym_volatile] = ACTIONS(3239),
    [anon_sym_where] = ACTIONS(3239),
    [anon_sym_notnull] = ACTIONS(3239),
    [anon_sym_unmanaged] = ACTIONS(3239),
    [anon_sym_checked] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [anon_sym_true] = ACTIONS(3239),
    [anon_sym_false] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_STAR] = ACTIONS(3241),
    [anon_sym_CARET] = ACTIONS(3241),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_this] = ACTIONS(3239),
    [anon_sym_scoped] = ACTIONS(3239),
    [anon_sym_base] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [sym_predefined_type] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_unchecked] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_lock] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_when] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_foreach] = ACTIONS(3239),
    [anon_sym_goto] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_DOT_DOT] = ACTIONS(3241),
    [anon_sym_from] = ACTIONS(3239),
    [anon_sym_into] = ACTIONS(3239),
    [anon_sym_join] = ACTIONS(3239),
    [anon_sym_on] = ACTIONS(3239),
    [anon_sym_equals] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_orderby] = ACTIONS(3239),
    [anon_sym_ascending] = ACTIONS(3239),
    [anon_sym_descending] = ACTIONS(3239),
    [anon_sym_group] = ACTIONS(3239),
    [anon_sym_by] = ACTIONS(3239),
    [anon_sym_select] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3239),
    [anon_sym_sizeof] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym___makeref] = ACTIONS(3239),
    [anon_sym___reftype] = ACTIONS(3239),
    [anon_sym___refvalue] = ACTIONS(3239),
    [sym_null_literal] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [sym_integer_literal] = ACTIONS(3239),
    [sym_real_literal] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [sym_verbatim_string_literal] = ACTIONS(3241),
    [aux_sym_preproc_if_token1] = ACTIONS(3241),
    [aux_sym_preproc_if_token3] = ACTIONS(3241),
    [aux_sym_preproc_else_token1] = ACTIONS(3241),
    [aux_sym_preproc_elif_token1] = ACTIONS(3241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3241),
    [sym_interpolation_verbatim_start] = ACTIONS(3241),
    [sym_interpolation_raw_start] = ACTIONS(3241),
    [sym_raw_string_start] = ACTIONS(3241),
  },
  [1964] = {
    [sym_preproc_region] = STATE(1964),
    [sym_preproc_endregion] = STATE(1964),
    [sym_preproc_line] = STATE(1964),
    [sym_preproc_pragma] = STATE(1964),
    [sym_preproc_nullable] = STATE(1964),
    [sym_preproc_error] = STATE(1964),
    [sym_preproc_warning] = STATE(1964),
    [sym_preproc_define] = STATE(1964),
    [sym_preproc_undef] = STATE(1964),
    [sym__identifier_token] = ACTIONS(3243),
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_alias] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_global] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_unsafe] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_ref] = ACTIONS(3243),
    [anon_sym_struct] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_delegate] = ACTIONS(3243),
    [anon_sym_record] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_file] = ACTIONS(3243),
    [anon_sym_fixed] = ACTIONS(3243),
    [anon_sym_internal] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_partial] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_required] = ACTIONS(3243),
    [anon_sym_sealed] = ACTIONS(3243),
    [anon_sym_virtual] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym_where] = ACTIONS(3243),
    [anon_sym_notnull] = ACTIONS(3243),
    [anon_sym_unmanaged] = ACTIONS(3243),
    [anon_sym_checked] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [anon_sym_true] = ACTIONS(3243),
    [anon_sym_false] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_this] = ACTIONS(3243),
    [anon_sym_scoped] = ACTIONS(3243),
    [anon_sym_base] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [sym_predefined_type] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_unchecked] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_lock] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_when] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_foreach] = ACTIONS(3243),
    [anon_sym_goto] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_DOT_DOT] = ACTIONS(3245),
    [anon_sym_from] = ACTIONS(3243),
    [anon_sym_into] = ACTIONS(3243),
    [anon_sym_join] = ACTIONS(3243),
    [anon_sym_on] = ACTIONS(3243),
    [anon_sym_equals] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_orderby] = ACTIONS(3243),
    [anon_sym_ascending] = ACTIONS(3243),
    [anon_sym_descending] = ACTIONS(3243),
    [anon_sym_group] = ACTIONS(3243),
    [anon_sym_by] = ACTIONS(3243),
    [anon_sym_select] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3243),
    [anon_sym_sizeof] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym___makeref] = ACTIONS(3243),
    [anon_sym___reftype] = ACTIONS(3243),
    [anon_sym___refvalue] = ACTIONS(3243),
    [sym_null_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [sym_integer_literal] = ACTIONS(3243),
    [sym_real_literal] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [sym_verbatim_string_literal] = ACTIONS(3245),
    [aux_sym_preproc_if_token1] = ACTIONS(3245),
    [aux_sym_preproc_if_token3] = ACTIONS(3245),
    [aux_sym_preproc_else_token1] = ACTIONS(3245),
    [aux_sym_preproc_elif_token1] = ACTIONS(3245),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3245),
    [sym_interpolation_verbatim_start] = ACTIONS(3245),
    [sym_interpolation_raw_start] = ACTIONS(3245),
    [sym_raw_string_start] = ACTIONS(3245),
  },
  [1965] = {
    [sym_preproc_region] = STATE(1965),
    [sym_preproc_endregion] = STATE(1965),
    [sym_preproc_line] = STATE(1965),
    [sym_preproc_pragma] = STATE(1965),
    [sym_preproc_nullable] = STATE(1965),
    [sym_preproc_error] = STATE(1965),
    [sym_preproc_warning] = STATE(1965),
    [sym_preproc_define] = STATE(1965),
    [sym_preproc_undef] = STATE(1965),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_struct] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_record] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_checked] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_true] = ACTIONS(3247),
    [anon_sym_false] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_this] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_base] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_unchecked] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_lock] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_foreach] = ACTIONS(3247),
    [anon_sym_goto] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_DOT_DOT] = ACTIONS(3249),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3247),
    [anon_sym_sizeof] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym___makeref] = ACTIONS(3247),
    [anon_sym___reftype] = ACTIONS(3247),
    [anon_sym___refvalue] = ACTIONS(3247),
    [sym_null_literal] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_integer_literal] = ACTIONS(3247),
    [sym_real_literal] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [sym_verbatim_string_literal] = ACTIONS(3249),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_if_token3] = ACTIONS(3249),
    [aux_sym_preproc_else_token1] = ACTIONS(3249),
    [aux_sym_preproc_elif_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3249),
    [sym_interpolation_verbatim_start] = ACTIONS(3249),
    [sym_interpolation_raw_start] = ACTIONS(3249),
    [sym_raw_string_start] = ACTIONS(3249),
  },
  [1966] = {
    [sym_preproc_region] = STATE(1966),
    [sym_preproc_endregion] = STATE(1966),
    [sym_preproc_line] = STATE(1966),
    [sym_preproc_pragma] = STATE(1966),
    [sym_preproc_nullable] = STATE(1966),
    [sym_preproc_error] = STATE(1966),
    [sym_preproc_warning] = STATE(1966),
    [sym_preproc_define] = STATE(1966),
    [sym_preproc_undef] = STATE(1966),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_namespace] = ACTIONS(3251),
    [anon_sym_class] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_struct] = ACTIONS(3251),
    [anon_sym_enum] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_interface] = ACTIONS(3251),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_record] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_checked] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_true] = ACTIONS(3251),
    [anon_sym_false] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_this] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_base] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_unchecked] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_lock] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_foreach] = ACTIONS(3251),
    [anon_sym_goto] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3251),
    [anon_sym_sizeof] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym___makeref] = ACTIONS(3251),
    [anon_sym___reftype] = ACTIONS(3251),
    [anon_sym___refvalue] = ACTIONS(3251),
    [sym_null_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [sym_real_literal] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_verbatim_string_literal] = ACTIONS(3253),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_if_token3] = ACTIONS(3253),
    [aux_sym_preproc_else_token1] = ACTIONS(3253),
    [aux_sym_preproc_elif_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3253),
    [sym_interpolation_verbatim_start] = ACTIONS(3253),
    [sym_interpolation_raw_start] = ACTIONS(3253),
    [sym_raw_string_start] = ACTIONS(3253),
  },
  [1967] = {
    [sym_preproc_region] = STATE(1967),
    [sym_preproc_endregion] = STATE(1967),
    [sym_preproc_line] = STATE(1967),
    [sym_preproc_pragma] = STATE(1967),
    [sym_preproc_nullable] = STATE(1967),
    [sym_preproc_error] = STATE(1967),
    [sym_preproc_warning] = STATE(1967),
    [sym_preproc_define] = STATE(1967),
    [sym_preproc_undef] = STATE(1967),
    [sym__identifier_token] = ACTIONS(3133),
    [anon_sym_extern] = ACTIONS(3133),
    [anon_sym_alias] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_global] = ACTIONS(3133),
    [anon_sym_using] = ACTIONS(3133),
    [anon_sym_unsafe] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_namespace] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_struct] = ACTIONS(3133),
    [anon_sym_enum] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_interface] = ACTIONS(3133),
    [anon_sym_delegate] = ACTIONS(3133),
    [anon_sym_record] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_file] = ACTIONS(3133),
    [anon_sym_fixed] = ACTIONS(3133),
    [anon_sym_internal] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_override] = ACTIONS(3133),
    [anon_sym_partial] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_required] = ACTIONS(3133),
    [anon_sym_sealed] = ACTIONS(3133),
    [anon_sym_virtual] = ACTIONS(3133),
    [anon_sym_volatile] = ACTIONS(3133),
    [anon_sym_where] = ACTIONS(3133),
    [anon_sym_notnull] = ACTIONS(3133),
    [anon_sym_unmanaged] = ACTIONS(3133),
    [anon_sym_checked] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_true] = ACTIONS(3133),
    [anon_sym_false] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_this] = ACTIONS(3133),
    [anon_sym_scoped] = ACTIONS(3133),
    [anon_sym_base] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [sym_predefined_type] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_unchecked] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_when] = ACTIONS(3133),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3133),
    [anon_sym_into] = ACTIONS(3133),
    [anon_sym_join] = ACTIONS(3133),
    [anon_sym_on] = ACTIONS(3133),
    [anon_sym_equals] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_orderby] = ACTIONS(3133),
    [anon_sym_ascending] = ACTIONS(3133),
    [anon_sym_descending] = ACTIONS(3133),
    [anon_sym_group] = ACTIONS(3133),
    [anon_sym_by] = ACTIONS(3133),
    [anon_sym_select] = ACTIONS(3133),
    [anon_sym_stackalloc] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym___makeref] = ACTIONS(3133),
    [anon_sym___reftype] = ACTIONS(3133),
    [anon_sym___refvalue] = ACTIONS(3133),
    [sym_null_literal] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_integer_literal] = ACTIONS(3133),
    [sym_real_literal] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [sym_verbatim_string_literal] = ACTIONS(3135),
    [aux_sym_preproc_if_token1] = ACTIONS(3135),
    [aux_sym_preproc_if_token3] = ACTIONS(3135),
    [aux_sym_preproc_else_token1] = ACTIONS(3135),
    [aux_sym_preproc_elif_token1] = ACTIONS(3135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3135),
    [sym_interpolation_verbatim_start] = ACTIONS(3135),
    [sym_interpolation_raw_start] = ACTIONS(3135),
    [sym_raw_string_start] = ACTIONS(3135),
  },
  [1968] = {
    [sym_preproc_region] = STATE(1968),
    [sym_preproc_endregion] = STATE(1968),
    [sym_preproc_line] = STATE(1968),
    [sym_preproc_pragma] = STATE(1968),
    [sym_preproc_nullable] = STATE(1968),
    [sym_preproc_error] = STATE(1968),
    [sym_preproc_warning] = STATE(1968),
    [sym_preproc_define] = STATE(1968),
    [sym_preproc_undef] = STATE(1968),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_struct] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_record] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_checked] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_true] = ACTIONS(3255),
    [anon_sym_false] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_this] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_base] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_unchecked] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_DOT_DOT] = ACTIONS(3257),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3255),
    [anon_sym_sizeof] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym___makeref] = ACTIONS(3255),
    [anon_sym___reftype] = ACTIONS(3255),
    [anon_sym___refvalue] = ACTIONS(3255),
    [sym_null_literal] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [sym_real_literal] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [sym_verbatim_string_literal] = ACTIONS(3257),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_if_token3] = ACTIONS(3257),
    [aux_sym_preproc_else_token1] = ACTIONS(3257),
    [aux_sym_preproc_elif_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3257),
    [sym_interpolation_verbatim_start] = ACTIONS(3257),
    [sym_interpolation_raw_start] = ACTIONS(3257),
    [sym_raw_string_start] = ACTIONS(3257),
  },
  [1969] = {
    [sym_preproc_region] = STATE(1969),
    [sym_preproc_endregion] = STATE(1969),
    [sym_preproc_line] = STATE(1969),
    [sym_preproc_pragma] = STATE(1969),
    [sym_preproc_nullable] = STATE(1969),
    [sym_preproc_error] = STATE(1969),
    [sym_preproc_warning] = STATE(1969),
    [sym_preproc_define] = STATE(1969),
    [sym_preproc_undef] = STATE(1969),
    [sym__identifier_token] = ACTIONS(3259),
    [anon_sym_extern] = ACTIONS(3259),
    [anon_sym_alias] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_global] = ACTIONS(3259),
    [anon_sym_using] = ACTIONS(3259),
    [anon_sym_unsafe] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_namespace] = ACTIONS(3259),
    [anon_sym_class] = ACTIONS(3259),
    [anon_sym_ref] = ACTIONS(3259),
    [anon_sym_struct] = ACTIONS(3259),
    [anon_sym_enum] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_interface] = ACTIONS(3259),
    [anon_sym_delegate] = ACTIONS(3259),
    [anon_sym_record] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_file] = ACTIONS(3259),
    [anon_sym_fixed] = ACTIONS(3259),
    [anon_sym_internal] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_override] = ACTIONS(3259),
    [anon_sym_partial] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_required] = ACTIONS(3259),
    [anon_sym_sealed] = ACTIONS(3259),
    [anon_sym_virtual] = ACTIONS(3259),
    [anon_sym_volatile] = ACTIONS(3259),
    [anon_sym_where] = ACTIONS(3259),
    [anon_sym_notnull] = ACTIONS(3259),
    [anon_sym_unmanaged] = ACTIONS(3259),
    [anon_sym_checked] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_true] = ACTIONS(3259),
    [anon_sym_false] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_this] = ACTIONS(3259),
    [anon_sym_scoped] = ACTIONS(3259),
    [anon_sym_base] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [sym_predefined_type] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_unchecked] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_lock] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_when] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_foreach] = ACTIONS(3259),
    [anon_sym_goto] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3261),
    [anon_sym_from] = ACTIONS(3259),
    [anon_sym_into] = ACTIONS(3259),
    [anon_sym_join] = ACTIONS(3259),
    [anon_sym_on] = ACTIONS(3259),
    [anon_sym_equals] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_orderby] = ACTIONS(3259),
    [anon_sym_ascending] = ACTIONS(3259),
    [anon_sym_descending] = ACTIONS(3259),
    [anon_sym_group] = ACTIONS(3259),
    [anon_sym_by] = ACTIONS(3259),
    [anon_sym_select] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3259),
    [anon_sym_sizeof] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym___makeref] = ACTIONS(3259),
    [anon_sym___reftype] = ACTIONS(3259),
    [anon_sym___refvalue] = ACTIONS(3259),
    [sym_null_literal] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [sym_real_literal] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [sym_verbatim_string_literal] = ACTIONS(3261),
    [aux_sym_preproc_if_token1] = ACTIONS(3261),
    [aux_sym_preproc_if_token3] = ACTIONS(3261),
    [aux_sym_preproc_else_token1] = ACTIONS(3261),
    [aux_sym_preproc_elif_token1] = ACTIONS(3261),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3261),
    [sym_interpolation_verbatim_start] = ACTIONS(3261),
    [sym_interpolation_raw_start] = ACTIONS(3261),
    [sym_raw_string_start] = ACTIONS(3261),
  },
  [1970] = {
    [sym_preproc_region] = STATE(1970),
    [sym_preproc_endregion] = STATE(1970),
    [sym_preproc_line] = STATE(1970),
    [sym_preproc_pragma] = STATE(1970),
    [sym_preproc_nullable] = STATE(1970),
    [sym_preproc_error] = STATE(1970),
    [sym_preproc_warning] = STATE(1970),
    [sym_preproc_define] = STATE(1970),
    [sym_preproc_undef] = STATE(1970),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_namespace] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_struct] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_interface] = ACTIONS(3263),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_record] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_checked] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_true] = ACTIONS(3263),
    [anon_sym_false] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_this] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_base] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_unchecked] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_DOT_DOT] = ACTIONS(3265),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3263),
    [anon_sym_sizeof] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym___makeref] = ACTIONS(3263),
    [anon_sym___reftype] = ACTIONS(3263),
    [anon_sym___refvalue] = ACTIONS(3263),
    [sym_null_literal] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [sym_real_literal] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3265),
    [sym_verbatim_string_literal] = ACTIONS(3265),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_if_token3] = ACTIONS(3265),
    [aux_sym_preproc_else_token1] = ACTIONS(3265),
    [aux_sym_preproc_elif_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3265),
    [sym_interpolation_verbatim_start] = ACTIONS(3265),
    [sym_interpolation_raw_start] = ACTIONS(3265),
    [sym_raw_string_start] = ACTIONS(3265),
  },
  [1971] = {
    [sym_preproc_region] = STATE(1971),
    [sym_preproc_endregion] = STATE(1971),
    [sym_preproc_line] = STATE(1971),
    [sym_preproc_pragma] = STATE(1971),
    [sym_preproc_nullable] = STATE(1971),
    [sym_preproc_error] = STATE(1971),
    [sym_preproc_warning] = STATE(1971),
    [sym_preproc_define] = STATE(1971),
    [sym_preproc_undef] = STATE(1971),
    [sym__identifier_token] = ACTIONS(3267),
    [anon_sym_extern] = ACTIONS(3267),
    [anon_sym_alias] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_global] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_unsafe] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_ref] = ACTIONS(3267),
    [anon_sym_struct] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_delegate] = ACTIONS(3267),
    [anon_sym_record] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_file] = ACTIONS(3267),
    [anon_sym_fixed] = ACTIONS(3267),
    [anon_sym_internal] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_partial] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_required] = ACTIONS(3267),
    [anon_sym_sealed] = ACTIONS(3267),
    [anon_sym_virtual] = ACTIONS(3267),
    [anon_sym_volatile] = ACTIONS(3267),
    [anon_sym_where] = ACTIONS(3267),
    [anon_sym_notnull] = ACTIONS(3267),
    [anon_sym_unmanaged] = ACTIONS(3267),
    [anon_sym_checked] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_true] = ACTIONS(3267),
    [anon_sym_false] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_scoped] = ACTIONS(3267),
    [anon_sym_base] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [sym_predefined_type] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_unchecked] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_lock] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_when] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_foreach] = ACTIONS(3267),
    [anon_sym_goto] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_DOT_DOT] = ACTIONS(3269),
    [anon_sym_from] = ACTIONS(3267),
    [anon_sym_into] = ACTIONS(3267),
    [anon_sym_join] = ACTIONS(3267),
    [anon_sym_on] = ACTIONS(3267),
    [anon_sym_equals] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_orderby] = ACTIONS(3267),
    [anon_sym_ascending] = ACTIONS(3267),
    [anon_sym_descending] = ACTIONS(3267),
    [anon_sym_group] = ACTIONS(3267),
    [anon_sym_by] = ACTIONS(3267),
    [anon_sym_select] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3267),
    [anon_sym_sizeof] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym___makeref] = ACTIONS(3267),
    [anon_sym___reftype] = ACTIONS(3267),
    [anon_sym___refvalue] = ACTIONS(3267),
    [sym_null_literal] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_integer_literal] = ACTIONS(3267),
    [sym_real_literal] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [sym_verbatim_string_literal] = ACTIONS(3269),
    [aux_sym_preproc_if_token1] = ACTIONS(3269),
    [aux_sym_preproc_if_token3] = ACTIONS(3269),
    [aux_sym_preproc_else_token1] = ACTIONS(3269),
    [aux_sym_preproc_elif_token1] = ACTIONS(3269),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3269),
    [sym_interpolation_verbatim_start] = ACTIONS(3269),
    [sym_interpolation_raw_start] = ACTIONS(3269),
    [sym_raw_string_start] = ACTIONS(3269),
  },
  [1972] = {
    [sym_preproc_region] = STATE(1972),
    [sym_preproc_endregion] = STATE(1972),
    [sym_preproc_line] = STATE(1972),
    [sym_preproc_pragma] = STATE(1972),
    [sym_preproc_nullable] = STATE(1972),
    [sym_preproc_error] = STATE(1972),
    [sym_preproc_warning] = STATE(1972),
    [sym_preproc_define] = STATE(1972),
    [sym_preproc_undef] = STATE(1972),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_struct] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_record] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_checked] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_true] = ACTIONS(3271),
    [anon_sym_false] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_base] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_unchecked] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_lock] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_foreach] = ACTIONS(3271),
    [anon_sym_goto] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_DOT_DOT] = ACTIONS(3273),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [anon_sym_stackalloc] = ACTIONS(3271),
    [anon_sym_sizeof] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym___makeref] = ACTIONS(3271),
    [anon_sym___reftype] = ACTIONS(3271),
    [anon_sym___refvalue] = ACTIONS(3271),
    [sym_null_literal] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_integer_literal] = ACTIONS(3271),
    [sym_real_literal] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [sym_verbatim_string_literal] = ACTIONS(3273),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_if_token3] = ACTIONS(3273),
    [aux_sym_preproc_else_token1] = ACTIONS(3273),
    [aux_sym_preproc_elif_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3273),
    [sym_interpolation_verbatim_start] = ACTIONS(3273),
    [sym_interpolation_raw_start] = ACTIONS(3273),
    [sym_raw_string_start] = ACTIONS(3273),
  },
  [1973] = {
    [sym_preproc_region] = STATE(1973),
    [sym_preproc_endregion] = STATE(1973),
    [sym_preproc_line] = STATE(1973),
    [sym_preproc_pragma] = STATE(1973),
    [sym_preproc_nullable] = STATE(1973),
    [sym_preproc_error] = STATE(1973),
    [sym_preproc_warning] = STATE(1973),
    [sym_preproc_define] = STATE(1973),
    [sym_preproc_undef] = STATE(1973),
    [sym__identifier_token] = ACTIONS(3275),
    [anon_sym_extern] = ACTIONS(3275),
    [anon_sym_alias] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_global] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_unsafe] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_ref] = ACTIONS(3275),
    [anon_sym_struct] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_delegate] = ACTIONS(3275),
    [anon_sym_record] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_file] = ACTIONS(3275),
    [anon_sym_fixed] = ACTIONS(3275),
    [anon_sym_internal] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_partial] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_required] = ACTIONS(3275),
    [anon_sym_sealed] = ACTIONS(3275),
    [anon_sym_virtual] = ACTIONS(3275),
    [anon_sym_volatile] = ACTIONS(3275),
    [anon_sym_where] = ACTIONS(3275),
    [anon_sym_notnull] = ACTIONS(3275),
    [anon_sym_unmanaged] = ACTIONS(3275),
    [anon_sym_checked] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_true] = ACTIONS(3275),
    [anon_sym_false] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(3277),
    [anon_sym_CARET] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(3277),
    [anon_sym_this] = ACTIONS(3275),
    [anon_sym_scoped] = ACTIONS(3275),
    [anon_sym_base] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [sym_predefined_type] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_unchecked] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_lock] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_when] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_foreach] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_DOT_DOT] = ACTIONS(3277),
    [anon_sym_from] = ACTIONS(3275),
    [anon_sym_into] = ACTIONS(3275),
    [anon_sym_join] = ACTIONS(3275),
    [anon_sym_on] = ACTIONS(3275),
    [anon_sym_equals] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_orderby] = ACTIONS(3275),
    [anon_sym_ascending] = ACTIONS(3275),
    [anon_sym_descending] = ACTIONS(3275),
    [anon_sym_group] = ACTIONS(3275),
    [anon_sym_by] = ACTIONS(3275),
    [anon_sym_select] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3275),
    [anon_sym_sizeof] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym___makeref] = ACTIONS(3275),
    [anon_sym___reftype] = ACTIONS(3275),
    [anon_sym___refvalue] = ACTIONS(3275),
    [sym_null_literal] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_integer_literal] = ACTIONS(3275),
    [sym_real_literal] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [sym_verbatim_string_literal] = ACTIONS(3277),
    [aux_sym_preproc_if_token1] = ACTIONS(3277),
    [aux_sym_preproc_if_token3] = ACTIONS(3277),
    [aux_sym_preproc_else_token1] = ACTIONS(3277),
    [aux_sym_preproc_elif_token1] = ACTIONS(3277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3277),
    [sym_interpolation_verbatim_start] = ACTIONS(3277),
    [sym_interpolation_raw_start] = ACTIONS(3277),
    [sym_raw_string_start] = ACTIONS(3277),
  },
  [1974] = {
    [sym_preproc_region] = STATE(1974),
    [sym_preproc_endregion] = STATE(1974),
    [sym_preproc_line] = STATE(1974),
    [sym_preproc_pragma] = STATE(1974),
    [sym_preproc_nullable] = STATE(1974),
    [sym_preproc_error] = STATE(1974),
    [sym_preproc_warning] = STATE(1974),
    [sym_preproc_define] = STATE(1974),
    [sym_preproc_undef] = STATE(1974),
    [sym__identifier_token] = ACTIONS(3279),
    [anon_sym_extern] = ACTIONS(3279),
    [anon_sym_alias] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_unsafe] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_ref] = ACTIONS(3279),
    [anon_sym_struct] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_delegate] = ACTIONS(3279),
    [anon_sym_record] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_file] = ACTIONS(3279),
    [anon_sym_fixed] = ACTIONS(3279),
    [anon_sym_internal] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_partial] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_required] = ACTIONS(3279),
    [anon_sym_sealed] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3279),
    [anon_sym_volatile] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_notnull] = ACTIONS(3279),
    [anon_sym_unmanaged] = ACTIONS(3279),
    [anon_sym_checked] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_true] = ACTIONS(3279),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_CARET] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_this] = ACTIONS(3279),
    [anon_sym_scoped] = ACTIONS(3279),
    [anon_sym_base] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [sym_predefined_type] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_unchecked] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_lock] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_foreach] = ACTIONS(3279),
    [anon_sym_goto] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3281),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_ascending] = ACTIONS(3279),
    [anon_sym_descending] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3279),
    [anon_sym_sizeof] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym___makeref] = ACTIONS(3279),
    [anon_sym___reftype] = ACTIONS(3279),
    [anon_sym___refvalue] = ACTIONS(3279),
    [sym_null_literal] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_integer_literal] = ACTIONS(3279),
    [sym_real_literal] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym_verbatim_string_literal] = ACTIONS(3281),
    [aux_sym_preproc_if_token1] = ACTIONS(3281),
    [aux_sym_preproc_if_token3] = ACTIONS(3281),
    [aux_sym_preproc_else_token1] = ACTIONS(3281),
    [aux_sym_preproc_elif_token1] = ACTIONS(3281),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3281),
    [sym_interpolation_verbatim_start] = ACTIONS(3281),
    [sym_interpolation_raw_start] = ACTIONS(3281),
    [sym_raw_string_start] = ACTIONS(3281),
  },
  [1975] = {
    [sym_preproc_region] = STATE(1975),
    [sym_preproc_endregion] = STATE(1975),
    [sym_preproc_line] = STATE(1975),
    [sym_preproc_pragma] = STATE(1975),
    [sym_preproc_nullable] = STATE(1975),
    [sym_preproc_error] = STATE(1975),
    [sym_preproc_warning] = STATE(1975),
    [sym_preproc_define] = STATE(1975),
    [sym_preproc_undef] = STATE(1975),
    [ts_builtin_sym_end] = ACTIONS(3167),
    [sym__identifier_token] = ACTIONS(3165),
    [anon_sym_extern] = ACTIONS(3165),
    [anon_sym_alias] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_using] = ACTIONS(3165),
    [anon_sym_unsafe] = ACTIONS(3165),
    [anon_sym_static] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3165),
    [anon_sym_namespace] = ACTIONS(3165),
    [anon_sym_class] = ACTIONS(3165),
    [anon_sym_ref] = ACTIONS(3165),
    [anon_sym_struct] = ACTIONS(3165),
    [anon_sym_enum] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3165),
    [anon_sym_delegate] = ACTIONS(3165),
    [anon_sym_record] = ACTIONS(3165),
    [anon_sym_abstract] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_const] = ACTIONS(3165),
    [anon_sym_file] = ACTIONS(3165),
    [anon_sym_fixed] = ACTIONS(3165),
    [anon_sym_internal] = ACTIONS(3165),
    [anon_sym_new] = ACTIONS(3165),
    [anon_sym_override] = ACTIONS(3165),
    [anon_sym_partial] = ACTIONS(3165),
    [anon_sym_private] = ACTIONS(3165),
    [anon_sym_protected] = ACTIONS(3165),
    [anon_sym_public] = ACTIONS(3165),
    [anon_sym_readonly] = ACTIONS(3165),
    [anon_sym_required] = ACTIONS(3165),
    [anon_sym_sealed] = ACTIONS(3165),
    [anon_sym_virtual] = ACTIONS(3165),
    [anon_sym_volatile] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3165),
    [anon_sym_notnull] = ACTIONS(3165),
    [anon_sym_unmanaged] = ACTIONS(3165),
    [anon_sym_checked] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_true] = ACTIONS(3165),
    [anon_sym_false] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_this] = ACTIONS(3165),
    [anon_sym_scoped] = ACTIONS(3165),
    [anon_sym_base] = ACTIONS(3165),
    [anon_sym_var] = ACTIONS(3165),
    [sym_predefined_type] = ACTIONS(3165),
    [anon_sym_break] = ACTIONS(3165),
    [anon_sym_unchecked] = ACTIONS(3165),
    [anon_sym_continue] = ACTIONS(3165),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_for] = ACTIONS(3165),
    [anon_sym_lock] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_switch] = ACTIONS(3165),
    [anon_sym_default] = ACTIONS(3165),
    [anon_sym_throw] = ACTIONS(3165),
    [anon_sym_try] = ACTIONS(3165),
    [anon_sym_catch] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_finally] = ACTIONS(3165),
    [anon_sym_await] = ACTIONS(3165),
    [anon_sym_foreach] = ACTIONS(3165),
    [anon_sym_goto] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_into] = ACTIONS(3165),
    [anon_sym_join] = ACTIONS(3165),
    [anon_sym_on] = ACTIONS(3165),
    [anon_sym_equals] = ACTIONS(3165),
    [anon_sym_let] = ACTIONS(3165),
    [anon_sym_orderby] = ACTIONS(3165),
    [anon_sym_ascending] = ACTIONS(3165),
    [anon_sym_descending] = ACTIONS(3165),
    [anon_sym_group] = ACTIONS(3165),
    [anon_sym_by] = ACTIONS(3165),
    [anon_sym_select] = ACTIONS(3165),
    [anon_sym_stackalloc] = ACTIONS(3165),
    [anon_sym_sizeof] = ACTIONS(3165),
    [anon_sym_typeof] = ACTIONS(3165),
    [anon_sym___makeref] = ACTIONS(3165),
    [anon_sym___reftype] = ACTIONS(3165),
    [anon_sym___refvalue] = ACTIONS(3165),
    [sym_null_literal] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [sym_integer_literal] = ACTIONS(3165),
    [sym_real_literal] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [sym_verbatim_string_literal] = ACTIONS(3167),
    [aux_sym_preproc_if_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3167),
    [sym_interpolation_verbatim_start] = ACTIONS(3167),
    [sym_interpolation_raw_start] = ACTIONS(3167),
    [sym_raw_string_start] = ACTIONS(3167),
  },
  [1976] = {
    [sym_preproc_region] = STATE(1976),
    [sym_preproc_endregion] = STATE(1976),
    [sym_preproc_line] = STATE(1976),
    [sym_preproc_pragma] = STATE(1976),
    [sym_preproc_nullable] = STATE(1976),
    [sym_preproc_error] = STATE(1976),
    [sym_preproc_warning] = STATE(1976),
    [sym_preproc_define] = STATE(1976),
    [sym_preproc_undef] = STATE(1976),
    [sym__identifier_token] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_alias] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_global] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_unsafe] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_ref] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_delegate] = ACTIONS(3283),
    [anon_sym_record] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_file] = ACTIONS(3283),
    [anon_sym_fixed] = ACTIONS(3283),
    [anon_sym_internal] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_partial] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_required] = ACTIONS(3283),
    [anon_sym_sealed] = ACTIONS(3283),
    [anon_sym_virtual] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym_where] = ACTIONS(3283),
    [anon_sym_notnull] = ACTIONS(3283),
    [anon_sym_unmanaged] = ACTIONS(3283),
    [anon_sym_checked] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(3283),
    [anon_sym_false] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_CARET] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_this] = ACTIONS(3283),
    [anon_sym_scoped] = ACTIONS(3283),
    [anon_sym_base] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [sym_predefined_type] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_unchecked] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_lock] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_when] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_foreach] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3285),
    [anon_sym_from] = ACTIONS(3283),
    [anon_sym_into] = ACTIONS(3283),
    [anon_sym_join] = ACTIONS(3283),
    [anon_sym_on] = ACTIONS(3283),
    [anon_sym_equals] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_orderby] = ACTIONS(3283),
    [anon_sym_ascending] = ACTIONS(3283),
    [anon_sym_descending] = ACTIONS(3283),
    [anon_sym_group] = ACTIONS(3283),
    [anon_sym_by] = ACTIONS(3283),
    [anon_sym_select] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3283),
    [anon_sym_sizeof] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym___makeref] = ACTIONS(3283),
    [anon_sym___reftype] = ACTIONS(3283),
    [anon_sym___refvalue] = ACTIONS(3283),
    [sym_null_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_integer_literal] = ACTIONS(3283),
    [sym_real_literal] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [sym_verbatim_string_literal] = ACTIONS(3285),
    [aux_sym_preproc_if_token1] = ACTIONS(3285),
    [aux_sym_preproc_if_token3] = ACTIONS(3285),
    [aux_sym_preproc_else_token1] = ACTIONS(3285),
    [aux_sym_preproc_elif_token1] = ACTIONS(3285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3285),
    [sym_interpolation_verbatim_start] = ACTIONS(3285),
    [sym_interpolation_raw_start] = ACTIONS(3285),
    [sym_raw_string_start] = ACTIONS(3285),
  },
  [1977] = {
    [sym_preproc_region] = STATE(1977),
    [sym_preproc_endregion] = STATE(1977),
    [sym_preproc_line] = STATE(1977),
    [sym_preproc_pragma] = STATE(1977),
    [sym_preproc_nullable] = STATE(1977),
    [sym_preproc_error] = STATE(1977),
    [sym_preproc_warning] = STATE(1977),
    [sym_preproc_define] = STATE(1977),
    [sym_preproc_undef] = STATE(1977),
    [sym__identifier_token] = ACTIONS(3287),
    [anon_sym_extern] = ACTIONS(3287),
    [anon_sym_alias] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_unsafe] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_ref] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_delegate] = ACTIONS(3287),
    [anon_sym_record] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_file] = ACTIONS(3287),
    [anon_sym_fixed] = ACTIONS(3287),
    [anon_sym_internal] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_partial] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_required] = ACTIONS(3287),
    [anon_sym_sealed] = ACTIONS(3287),
    [anon_sym_virtual] = ACTIONS(3287),
    [anon_sym_volatile] = ACTIONS(3287),
    [anon_sym_where] = ACTIONS(3287),
    [anon_sym_notnull] = ACTIONS(3287),
    [anon_sym_unmanaged] = ACTIONS(3287),
    [anon_sym_checked] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_true] = ACTIONS(3287),
    [anon_sym_false] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_CARET] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_this] = ACTIONS(3287),
    [anon_sym_scoped] = ACTIONS(3287),
    [anon_sym_base] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [sym_predefined_type] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_unchecked] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_lock] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_when] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_foreach] = ACTIONS(3287),
    [anon_sym_goto] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3289),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_into] = ACTIONS(3287),
    [anon_sym_join] = ACTIONS(3287),
    [anon_sym_on] = ACTIONS(3287),
    [anon_sym_equals] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_orderby] = ACTIONS(3287),
    [anon_sym_ascending] = ACTIONS(3287),
    [anon_sym_descending] = ACTIONS(3287),
    [anon_sym_group] = ACTIONS(3287),
    [anon_sym_by] = ACTIONS(3287),
    [anon_sym_select] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym___makeref] = ACTIONS(3287),
    [anon_sym___reftype] = ACTIONS(3287),
    [anon_sym___refvalue] = ACTIONS(3287),
    [sym_null_literal] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_integer_literal] = ACTIONS(3287),
    [sym_real_literal] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_verbatim_string_literal] = ACTIONS(3289),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_if_token3] = ACTIONS(3289),
    [aux_sym_preproc_else_token1] = ACTIONS(3289),
    [aux_sym_preproc_elif_token1] = ACTIONS(3289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3289),
    [sym_interpolation_verbatim_start] = ACTIONS(3289),
    [sym_interpolation_raw_start] = ACTIONS(3289),
    [sym_raw_string_start] = ACTIONS(3289),
  },
  [1978] = {
    [sym_preproc_region] = STATE(1978),
    [sym_preproc_endregion] = STATE(1978),
    [sym_preproc_line] = STATE(1978),
    [sym_preproc_pragma] = STATE(1978),
    [sym_preproc_nullable] = STATE(1978),
    [sym_preproc_error] = STATE(1978),
    [sym_preproc_warning] = STATE(1978),
    [sym_preproc_define] = STATE(1978),
    [sym_preproc_undef] = STATE(1978),
    [sym__identifier_token] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_alias] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_global] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_unsafe] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_ref] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_delegate] = ACTIONS(3291),
    [anon_sym_record] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_file] = ACTIONS(3291),
    [anon_sym_fixed] = ACTIONS(3291),
    [anon_sym_internal] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_partial] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_required] = ACTIONS(3291),
    [anon_sym_sealed] = ACTIONS(3291),
    [anon_sym_virtual] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym_where] = ACTIONS(3291),
    [anon_sym_notnull] = ACTIONS(3291),
    [anon_sym_unmanaged] = ACTIONS(3291),
    [anon_sym_checked] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3291),
    [anon_sym_false] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3291),
    [anon_sym_scoped] = ACTIONS(3291),
    [anon_sym_base] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [sym_predefined_type] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_unchecked] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_lock] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_when] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_foreach] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_DOT_DOT] = ACTIONS(3293),
    [anon_sym_from] = ACTIONS(3291),
    [anon_sym_into] = ACTIONS(3291),
    [anon_sym_join] = ACTIONS(3291),
    [anon_sym_on] = ACTIONS(3291),
    [anon_sym_equals] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_orderby] = ACTIONS(3291),
    [anon_sym_ascending] = ACTIONS(3291),
    [anon_sym_descending] = ACTIONS(3291),
    [anon_sym_group] = ACTIONS(3291),
    [anon_sym_by] = ACTIONS(3291),
    [anon_sym_select] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3291),
    [anon_sym_sizeof] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym___makeref] = ACTIONS(3291),
    [anon_sym___reftype] = ACTIONS(3291),
    [anon_sym___refvalue] = ACTIONS(3291),
    [sym_null_literal] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_integer_literal] = ACTIONS(3291),
    [sym_real_literal] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [sym_verbatim_string_literal] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_if_token3] = ACTIONS(3293),
    [aux_sym_preproc_else_token1] = ACTIONS(3293),
    [aux_sym_preproc_elif_token1] = ACTIONS(3293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3293),
    [sym_interpolation_verbatim_start] = ACTIONS(3293),
    [sym_interpolation_raw_start] = ACTIONS(3293),
    [sym_raw_string_start] = ACTIONS(3293),
  },
  [1979] = {
    [sym_preproc_region] = STATE(1979),
    [sym_preproc_endregion] = STATE(1979),
    [sym_preproc_line] = STATE(1979),
    [sym_preproc_pragma] = STATE(1979),
    [sym_preproc_nullable] = STATE(1979),
    [sym_preproc_error] = STATE(1979),
    [sym_preproc_warning] = STATE(1979),
    [sym_preproc_define] = STATE(1979),
    [sym_preproc_undef] = STATE(1979),
    [sym__identifier_token] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_alias] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_global] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_delegate] = ACTIONS(3295),
    [anon_sym_record] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_file] = ACTIONS(3295),
    [anon_sym_fixed] = ACTIONS(3295),
    [anon_sym_internal] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_partial] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_required] = ACTIONS(3295),
    [anon_sym_sealed] = ACTIONS(3295),
    [anon_sym_virtual] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym_where] = ACTIONS(3295),
    [anon_sym_notnull] = ACTIONS(3295),
    [anon_sym_unmanaged] = ACTIONS(3295),
    [anon_sym_checked] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_CARET] = ACTIONS(3297),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_this] = ACTIONS(3295),
    [anon_sym_scoped] = ACTIONS(3295),
    [anon_sym_base] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [sym_predefined_type] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_unchecked] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_lock] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_when] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_foreach] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3297),
    [anon_sym_from] = ACTIONS(3295),
    [anon_sym_into] = ACTIONS(3295),
    [anon_sym_join] = ACTIONS(3295),
    [anon_sym_on] = ACTIONS(3295),
    [anon_sym_equals] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_orderby] = ACTIONS(3295),
    [anon_sym_ascending] = ACTIONS(3295),
    [anon_sym_descending] = ACTIONS(3295),
    [anon_sym_group] = ACTIONS(3295),
    [anon_sym_by] = ACTIONS(3295),
    [anon_sym_select] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym___makeref] = ACTIONS(3295),
    [anon_sym___reftype] = ACTIONS(3295),
    [anon_sym___refvalue] = ACTIONS(3295),
    [sym_null_literal] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_integer_literal] = ACTIONS(3295),
    [sym_real_literal] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [sym_verbatim_string_literal] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_if_token3] = ACTIONS(3297),
    [aux_sym_preproc_else_token1] = ACTIONS(3297),
    [aux_sym_preproc_elif_token1] = ACTIONS(3297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3297),
    [sym_interpolation_verbatim_start] = ACTIONS(3297),
    [sym_interpolation_raw_start] = ACTIONS(3297),
    [sym_raw_string_start] = ACTIONS(3297),
  },
  [1980] = {
    [sym_preproc_region] = STATE(1980),
    [sym_preproc_endregion] = STATE(1980),
    [sym_preproc_line] = STATE(1980),
    [sym_preproc_pragma] = STATE(1980),
    [sym_preproc_nullable] = STATE(1980),
    [sym_preproc_error] = STATE(1980),
    [sym_preproc_warning] = STATE(1980),
    [sym_preproc_define] = STATE(1980),
    [sym_preproc_undef] = STATE(1980),
    [sym__identifier_token] = ACTIONS(3299),
    [anon_sym_extern] = ACTIONS(3299),
    [anon_sym_alias] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_unsafe] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_ref] = ACTIONS(3299),
    [anon_sym_struct] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_delegate] = ACTIONS(3299),
    [anon_sym_record] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_file] = ACTIONS(3299),
    [anon_sym_fixed] = ACTIONS(3299),
    [anon_sym_internal] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_partial] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_required] = ACTIONS(3299),
    [anon_sym_sealed] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3299),
    [anon_sym_volatile] = ACTIONS(3299),
    [anon_sym_where] = ACTIONS(3299),
    [anon_sym_notnull] = ACTIONS(3299),
    [anon_sym_unmanaged] = ACTIONS(3299),
    [anon_sym_checked] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [anon_sym_true] = ACTIONS(3299),
    [anon_sym_false] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_CARET] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3299),
    [anon_sym_scoped] = ACTIONS(3299),
    [anon_sym_base] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [sym_predefined_type] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_unchecked] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_lock] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_when] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_foreach] = ACTIONS(3299),
    [anon_sym_goto] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_DOT_DOT] = ACTIONS(3301),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_into] = ACTIONS(3299),
    [anon_sym_join] = ACTIONS(3299),
    [anon_sym_on] = ACTIONS(3299),
    [anon_sym_equals] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_orderby] = ACTIONS(3299),
    [anon_sym_ascending] = ACTIONS(3299),
    [anon_sym_descending] = ACTIONS(3299),
    [anon_sym_group] = ACTIONS(3299),
    [anon_sym_by] = ACTIONS(3299),
    [anon_sym_select] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym___makeref] = ACTIONS(3299),
    [anon_sym___reftype] = ACTIONS(3299),
    [anon_sym___refvalue] = ACTIONS(3299),
    [sym_null_literal] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [sym_integer_literal] = ACTIONS(3299),
    [sym_real_literal] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [sym_verbatim_string_literal] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_if_token3] = ACTIONS(3301),
    [aux_sym_preproc_else_token1] = ACTIONS(3301),
    [aux_sym_preproc_elif_token1] = ACTIONS(3301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3301),
    [sym_interpolation_verbatim_start] = ACTIONS(3301),
    [sym_interpolation_raw_start] = ACTIONS(3301),
    [sym_raw_string_start] = ACTIONS(3301),
  },
  [1981] = {
    [sym_preproc_region] = STATE(1981),
    [sym_preproc_endregion] = STATE(1981),
    [sym_preproc_line] = STATE(1981),
    [sym_preproc_pragma] = STATE(1981),
    [sym_preproc_nullable] = STATE(1981),
    [sym_preproc_error] = STATE(1981),
    [sym_preproc_warning] = STATE(1981),
    [sym_preproc_define] = STATE(1981),
    [sym_preproc_undef] = STATE(1981),
    [sym__identifier_token] = ACTIONS(3303),
    [anon_sym_extern] = ACTIONS(3303),
    [anon_sym_alias] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_global] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_unsafe] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(3303),
    [anon_sym_struct] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_delegate] = ACTIONS(3303),
    [anon_sym_record] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_file] = ACTIONS(3303),
    [anon_sym_fixed] = ACTIONS(3303),
    [anon_sym_internal] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_partial] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_required] = ACTIONS(3303),
    [anon_sym_sealed] = ACTIONS(3303),
    [anon_sym_virtual] = ACTIONS(3303),
    [anon_sym_volatile] = ACTIONS(3303),
    [anon_sym_where] = ACTIONS(3303),
    [anon_sym_notnull] = ACTIONS(3303),
    [anon_sym_unmanaged] = ACTIONS(3303),
    [anon_sym_checked] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [anon_sym_true] = ACTIONS(3303),
    [anon_sym_false] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3305),
    [anon_sym_CARET] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_this] = ACTIONS(3303),
    [anon_sym_scoped] = ACTIONS(3303),
    [anon_sym_base] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [sym_predefined_type] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_unchecked] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_lock] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_when] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_foreach] = ACTIONS(3303),
    [anon_sym_goto] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_DOT_DOT] = ACTIONS(3305),
    [anon_sym_from] = ACTIONS(3303),
    [anon_sym_into] = ACTIONS(3303),
    [anon_sym_join] = ACTIONS(3303),
    [anon_sym_on] = ACTIONS(3303),
    [anon_sym_equals] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_orderby] = ACTIONS(3303),
    [anon_sym_ascending] = ACTIONS(3303),
    [anon_sym_descending] = ACTIONS(3303),
    [anon_sym_group] = ACTIONS(3303),
    [anon_sym_by] = ACTIONS(3303),
    [anon_sym_select] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym___makeref] = ACTIONS(3303),
    [anon_sym___reftype] = ACTIONS(3303),
    [anon_sym___refvalue] = ACTIONS(3303),
    [sym_null_literal] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [sym_integer_literal] = ACTIONS(3303),
    [sym_real_literal] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [sym_verbatim_string_literal] = ACTIONS(3305),
    [aux_sym_preproc_if_token1] = ACTIONS(3305),
    [aux_sym_preproc_if_token3] = ACTIONS(3305),
    [aux_sym_preproc_else_token1] = ACTIONS(3305),
    [aux_sym_preproc_elif_token1] = ACTIONS(3305),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3305),
    [sym_interpolation_verbatim_start] = ACTIONS(3305),
    [sym_interpolation_raw_start] = ACTIONS(3305),
    [sym_raw_string_start] = ACTIONS(3305),
  },
  [1982] = {
    [sym_preproc_region] = STATE(1982),
    [sym_preproc_endregion] = STATE(1982),
    [sym_preproc_line] = STATE(1982),
    [sym_preproc_pragma] = STATE(1982),
    [sym_preproc_nullable] = STATE(1982),
    [sym_preproc_error] = STATE(1982),
    [sym_preproc_warning] = STATE(1982),
    [sym_preproc_define] = STATE(1982),
    [sym_preproc_undef] = STATE(1982),
    [sym__identifier_token] = ACTIONS(3307),
    [anon_sym_extern] = ACTIONS(3307),
    [anon_sym_alias] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_unsafe] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_namespace] = ACTIONS(3307),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_ref] = ACTIONS(3307),
    [anon_sym_struct] = ACTIONS(3307),
    [anon_sym_enum] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3307),
    [anon_sym_delegate] = ACTIONS(3307),
    [anon_sym_record] = ACTIONS(3307),
    [anon_sym_abstract] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_const] = ACTIONS(3307),
    [anon_sym_file] = ACTIONS(3307),
    [anon_sym_fixed] = ACTIONS(3307),
    [anon_sym_internal] = ACTIONS(3307),
    [anon_sym_new] = ACTIONS(3307),
    [anon_sym_override] = ACTIONS(3307),
    [anon_sym_partial] = ACTIONS(3307),
    [anon_sym_private] = ACTIONS(3307),
    [anon_sym_protected] = ACTIONS(3307),
    [anon_sym_public] = ACTIONS(3307),
    [anon_sym_readonly] = ACTIONS(3307),
    [anon_sym_required] = ACTIONS(3307),
    [anon_sym_sealed] = ACTIONS(3307),
    [anon_sym_virtual] = ACTIONS(3307),
    [anon_sym_volatile] = ACTIONS(3307),
    [anon_sym_where] = ACTIONS(3307),
    [anon_sym_notnull] = ACTIONS(3307),
    [anon_sym_unmanaged] = ACTIONS(3307),
    [anon_sym_checked] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(3307),
    [anon_sym_false] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3307),
    [anon_sym_scoped] = ACTIONS(3307),
    [anon_sym_base] = ACTIONS(3307),
    [anon_sym_var] = ACTIONS(3307),
    [sym_predefined_type] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3307),
    [anon_sym_unchecked] = ACTIONS(3307),
    [anon_sym_continue] = ACTIONS(3307),
    [anon_sym_do] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_lock] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3307),
    [anon_sym_default] = ACTIONS(3307),
    [anon_sym_throw] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_when] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [anon_sym_foreach] = ACTIONS(3307),
    [anon_sym_goto] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_DOT_DOT] = ACTIONS(3309),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_into] = ACTIONS(3307),
    [anon_sym_join] = ACTIONS(3307),
    [anon_sym_on] = ACTIONS(3307),
    [anon_sym_equals] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3307),
    [anon_sym_orderby] = ACTIONS(3307),
    [anon_sym_ascending] = ACTIONS(3307),
    [anon_sym_descending] = ACTIONS(3307),
    [anon_sym_group] = ACTIONS(3307),
    [anon_sym_by] = ACTIONS(3307),
    [anon_sym_select] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3307),
    [anon_sym_sizeof] = ACTIONS(3307),
    [anon_sym_typeof] = ACTIONS(3307),
    [anon_sym___makeref] = ACTIONS(3307),
    [anon_sym___reftype] = ACTIONS(3307),
    [anon_sym___refvalue] = ACTIONS(3307),
    [sym_null_literal] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [sym_integer_literal] = ACTIONS(3307),
    [sym_real_literal] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [sym_verbatim_string_literal] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token3] = ACTIONS(3309),
    [aux_sym_preproc_else_token1] = ACTIONS(3309),
    [aux_sym_preproc_elif_token1] = ACTIONS(3309),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3309),
    [sym_interpolation_verbatim_start] = ACTIONS(3309),
    [sym_interpolation_raw_start] = ACTIONS(3309),
    [sym_raw_string_start] = ACTIONS(3309),
  },
  [1983] = {
    [sym_preproc_region] = STATE(1983),
    [sym_preproc_endregion] = STATE(1983),
    [sym_preproc_line] = STATE(1983),
    [sym_preproc_pragma] = STATE(1983),
    [sym_preproc_nullable] = STATE(1983),
    [sym_preproc_error] = STATE(1983),
    [sym_preproc_warning] = STATE(1983),
    [sym_preproc_define] = STATE(1983),
    [sym_preproc_undef] = STATE(1983),
    [sym__identifier_token] = ACTIONS(3311),
    [anon_sym_extern] = ACTIONS(3311),
    [anon_sym_alias] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_global] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_unsafe] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_ref] = ACTIONS(3311),
    [anon_sym_struct] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_delegate] = ACTIONS(3311),
    [anon_sym_record] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_file] = ACTIONS(3311),
    [anon_sym_fixed] = ACTIONS(3311),
    [anon_sym_internal] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_partial] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_required] = ACTIONS(3311),
    [anon_sym_sealed] = ACTIONS(3311),
    [anon_sym_virtual] = ACTIONS(3311),
    [anon_sym_volatile] = ACTIONS(3311),
    [anon_sym_where] = ACTIONS(3311),
    [anon_sym_notnull] = ACTIONS(3311),
    [anon_sym_unmanaged] = ACTIONS(3311),
    [anon_sym_checked] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(3311),
    [anon_sym_false] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_this] = ACTIONS(3311),
    [anon_sym_scoped] = ACTIONS(3311),
    [anon_sym_base] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [sym_predefined_type] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_unchecked] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_lock] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_when] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_foreach] = ACTIONS(3311),
    [anon_sym_goto] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_DOT_DOT] = ACTIONS(3313),
    [anon_sym_from] = ACTIONS(3311),
    [anon_sym_into] = ACTIONS(3311),
    [anon_sym_join] = ACTIONS(3311),
    [anon_sym_on] = ACTIONS(3311),
    [anon_sym_equals] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_orderby] = ACTIONS(3311),
    [anon_sym_ascending] = ACTIONS(3311),
    [anon_sym_descending] = ACTIONS(3311),
    [anon_sym_group] = ACTIONS(3311),
    [anon_sym_by] = ACTIONS(3311),
    [anon_sym_select] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym___makeref] = ACTIONS(3311),
    [anon_sym___reftype] = ACTIONS(3311),
    [anon_sym___refvalue] = ACTIONS(3311),
    [sym_null_literal] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [sym_integer_literal] = ACTIONS(3311),
    [sym_real_literal] = ACTIONS(3313),
    [anon_sym_DQUOTE] = ACTIONS(3313),
    [sym_verbatim_string_literal] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token3] = ACTIONS(3313),
    [aux_sym_preproc_else_token1] = ACTIONS(3313),
    [aux_sym_preproc_elif_token1] = ACTIONS(3313),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3313),
    [sym_interpolation_verbatim_start] = ACTIONS(3313),
    [sym_interpolation_raw_start] = ACTIONS(3313),
    [sym_raw_string_start] = ACTIONS(3313),
  },
  [1984] = {
    [sym_preproc_region] = STATE(1984),
    [sym_preproc_endregion] = STATE(1984),
    [sym_preproc_line] = STATE(1984),
    [sym_preproc_pragma] = STATE(1984),
    [sym_preproc_nullable] = STATE(1984),
    [sym_preproc_error] = STATE(1984),
    [sym_preproc_warning] = STATE(1984),
    [sym_preproc_define] = STATE(1984),
    [sym_preproc_undef] = STATE(1984),
    [ts_builtin_sym_end] = ACTIONS(3159),
    [sym__identifier_token] = ACTIONS(3157),
    [anon_sym_extern] = ACTIONS(3157),
    [anon_sym_alias] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3157),
    [anon_sym_using] = ACTIONS(3157),
    [anon_sym_unsafe] = ACTIONS(3157),
    [anon_sym_static] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3157),
    [anon_sym_namespace] = ACTIONS(3157),
    [anon_sym_class] = ACTIONS(3157),
    [anon_sym_ref] = ACTIONS(3157),
    [anon_sym_struct] = ACTIONS(3157),
    [anon_sym_enum] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_interface] = ACTIONS(3157),
    [anon_sym_delegate] = ACTIONS(3157),
    [anon_sym_record] = ACTIONS(3157),
    [anon_sym_abstract] = ACTIONS(3157),
    [anon_sym_async] = ACTIONS(3157),
    [anon_sym_const] = ACTIONS(3157),
    [anon_sym_file] = ACTIONS(3157),
    [anon_sym_fixed] = ACTIONS(3157),
    [anon_sym_internal] = ACTIONS(3157),
    [anon_sym_new] = ACTIONS(3157),
    [anon_sym_override] = ACTIONS(3157),
    [anon_sym_partial] = ACTIONS(3157),
    [anon_sym_private] = ACTIONS(3157),
    [anon_sym_protected] = ACTIONS(3157),
    [anon_sym_public] = ACTIONS(3157),
    [anon_sym_readonly] = ACTIONS(3157),
    [anon_sym_required] = ACTIONS(3157),
    [anon_sym_sealed] = ACTIONS(3157),
    [anon_sym_virtual] = ACTIONS(3157),
    [anon_sym_volatile] = ACTIONS(3157),
    [anon_sym_where] = ACTIONS(3157),
    [anon_sym_notnull] = ACTIONS(3157),
    [anon_sym_unmanaged] = ACTIONS(3157),
    [anon_sym_checked] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3159),
    [anon_sym_TILDE] = ACTIONS(3159),
    [anon_sym_PLUS_PLUS] = ACTIONS(3159),
    [anon_sym_DASH_DASH] = ACTIONS(3159),
    [anon_sym_true] = ACTIONS(3157),
    [anon_sym_false] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_CARET] = ACTIONS(3159),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_this] = ACTIONS(3157),
    [anon_sym_scoped] = ACTIONS(3157),
    [anon_sym_base] = ACTIONS(3157),
    [anon_sym_var] = ACTIONS(3157),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_break] = ACTIONS(3157),
    [anon_sym_unchecked] = ACTIONS(3157),
    [anon_sym_continue] = ACTIONS(3157),
    [anon_sym_do] = ACTIONS(3157),
    [anon_sym_while] = ACTIONS(3157),
    [anon_sym_for] = ACTIONS(3157),
    [anon_sym_lock] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3157),
    [anon_sym_switch] = ACTIONS(3157),
    [anon_sym_default] = ACTIONS(3157),
    [anon_sym_throw] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_catch] = ACTIONS(3157),
    [anon_sym_when] = ACTIONS(3157),
    [anon_sym_finally] = ACTIONS(3157),
    [anon_sym_await] = ACTIONS(3157),
    [anon_sym_foreach] = ACTIONS(3157),
    [anon_sym_goto] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3157),
    [anon_sym_else] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3157),
    [anon_sym_into] = ACTIONS(3157),
    [anon_sym_join] = ACTIONS(3157),
    [anon_sym_on] = ACTIONS(3157),
    [anon_sym_equals] = ACTIONS(3157),
    [anon_sym_let] = ACTIONS(3157),
    [anon_sym_orderby] = ACTIONS(3157),
    [anon_sym_ascending] = ACTIONS(3157),
    [anon_sym_descending] = ACTIONS(3157),
    [anon_sym_group] = ACTIONS(3157),
    [anon_sym_by] = ACTIONS(3157),
    [anon_sym_select] = ACTIONS(3157),
    [anon_sym_stackalloc] = ACTIONS(3157),
    [anon_sym_sizeof] = ACTIONS(3157),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym___makeref] = ACTIONS(3157),
    [anon_sym___reftype] = ACTIONS(3157),
    [anon_sym___refvalue] = ACTIONS(3157),
    [sym_null_literal] = ACTIONS(3157),
    [anon_sym_SQUOTE] = ACTIONS(3159),
    [sym_integer_literal] = ACTIONS(3157),
    [sym_real_literal] = ACTIONS(3159),
    [anon_sym_DQUOTE] = ACTIONS(3159),
    [sym_verbatim_string_literal] = ACTIONS(3159),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3159),
    [sym_interpolation_verbatim_start] = ACTIONS(3159),
    [sym_interpolation_raw_start] = ACTIONS(3159),
    [sym_raw_string_start] = ACTIONS(3159),
  },
  [1985] = {
    [sym_preproc_region] = STATE(1985),
    [sym_preproc_endregion] = STATE(1985),
    [sym_preproc_line] = STATE(1985),
    [sym_preproc_pragma] = STATE(1985),
    [sym_preproc_nullable] = STATE(1985),
    [sym_preproc_error] = STATE(1985),
    [sym_preproc_warning] = STATE(1985),
    [sym_preproc_define] = STATE(1985),
    [sym_preproc_undef] = STATE(1985),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_struct] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_record] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_base] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_if_token3] = ACTIONS(3317),
    [aux_sym_preproc_else_token1] = ACTIONS(3317),
    [aux_sym_preproc_elif_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
    [sym_raw_string_start] = ACTIONS(3317),
  },
  [1986] = {
    [sym_preproc_region] = STATE(1986),
    [sym_preproc_endregion] = STATE(1986),
    [sym_preproc_line] = STATE(1986),
    [sym_preproc_pragma] = STATE(1986),
    [sym_preproc_nullable] = STATE(1986),
    [sym_preproc_error] = STATE(1986),
    [sym_preproc_warning] = STATE(1986),
    [sym_preproc_define] = STATE(1986),
    [sym_preproc_undef] = STATE(1986),
    [sym__identifier_token] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym_alias] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_global] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_unsafe] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_ref] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_delegate] = ACTIONS(3319),
    [anon_sym_record] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_file] = ACTIONS(3319),
    [anon_sym_fixed] = ACTIONS(3319),
    [anon_sym_internal] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_partial] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_required] = ACTIONS(3319),
    [anon_sym_sealed] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_where] = ACTIONS(3319),
    [anon_sym_notnull] = ACTIONS(3319),
    [anon_sym_unmanaged] = ACTIONS(3319),
    [anon_sym_checked] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_true] = ACTIONS(3319),
    [anon_sym_false] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_this] = ACTIONS(3319),
    [anon_sym_scoped] = ACTIONS(3319),
    [anon_sym_base] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [sym_predefined_type] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_unchecked] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_lock] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_when] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_foreach] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_DOT_DOT] = ACTIONS(3321),
    [anon_sym_from] = ACTIONS(3319),
    [anon_sym_into] = ACTIONS(3319),
    [anon_sym_join] = ACTIONS(3319),
    [anon_sym_on] = ACTIONS(3319),
    [anon_sym_equals] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_orderby] = ACTIONS(3319),
    [anon_sym_ascending] = ACTIONS(3319),
    [anon_sym_descending] = ACTIONS(3319),
    [anon_sym_group] = ACTIONS(3319),
    [anon_sym_by] = ACTIONS(3319),
    [anon_sym_select] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3319),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym___makeref] = ACTIONS(3319),
    [anon_sym___reftype] = ACTIONS(3319),
    [anon_sym___refvalue] = ACTIONS(3319),
    [sym_null_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [sym_integer_literal] = ACTIONS(3319),
    [sym_real_literal] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_verbatim_string_literal] = ACTIONS(3321),
    [aux_sym_preproc_if_token1] = ACTIONS(3321),
    [aux_sym_preproc_if_token3] = ACTIONS(3321),
    [aux_sym_preproc_else_token1] = ACTIONS(3321),
    [aux_sym_preproc_elif_token1] = ACTIONS(3321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3321),
    [sym_interpolation_verbatim_start] = ACTIONS(3321),
    [sym_interpolation_raw_start] = ACTIONS(3321),
    [sym_raw_string_start] = ACTIONS(3321),
  },
  [1987] = {
    [sym_preproc_region] = STATE(1987),
    [sym_preproc_endregion] = STATE(1987),
    [sym_preproc_line] = STATE(1987),
    [sym_preproc_pragma] = STATE(1987),
    [sym_preproc_nullable] = STATE(1987),
    [sym_preproc_error] = STATE(1987),
    [sym_preproc_warning] = STATE(1987),
    [sym_preproc_define] = STATE(1987),
    [sym_preproc_undef] = STATE(1987),
    [sym__identifier_token] = ACTIONS(3323),
    [anon_sym_extern] = ACTIONS(3323),
    [anon_sym_alias] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_global] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_unsafe] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_struct] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_delegate] = ACTIONS(3323),
    [anon_sym_record] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_file] = ACTIONS(3323),
    [anon_sym_fixed] = ACTIONS(3323),
    [anon_sym_internal] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_partial] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_required] = ACTIONS(3323),
    [anon_sym_sealed] = ACTIONS(3323),
    [anon_sym_virtual] = ACTIONS(3323),
    [anon_sym_volatile] = ACTIONS(3323),
    [anon_sym_where] = ACTIONS(3323),
    [anon_sym_notnull] = ACTIONS(3323),
    [anon_sym_unmanaged] = ACTIONS(3323),
    [anon_sym_checked] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3325),
    [anon_sym_true] = ACTIONS(3323),
    [anon_sym_false] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3325),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_this] = ACTIONS(3323),
    [anon_sym_scoped] = ACTIONS(3323),
    [anon_sym_base] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [sym_predefined_type] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_unchecked] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_when] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_DOT_DOT] = ACTIONS(3325),
    [anon_sym_from] = ACTIONS(3323),
    [anon_sym_into] = ACTIONS(3323),
    [anon_sym_join] = ACTIONS(3323),
    [anon_sym_on] = ACTIONS(3323),
    [anon_sym_equals] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_orderby] = ACTIONS(3323),
    [anon_sym_ascending] = ACTIONS(3323),
    [anon_sym_descending] = ACTIONS(3323),
    [anon_sym_group] = ACTIONS(3323),
    [anon_sym_by] = ACTIONS(3323),
    [anon_sym_select] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3323),
    [anon_sym_sizeof] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym___makeref] = ACTIONS(3323),
    [anon_sym___reftype] = ACTIONS(3323),
    [anon_sym___refvalue] = ACTIONS(3323),
    [sym_null_literal] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [sym_integer_literal] = ACTIONS(3323),
    [sym_real_literal] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [sym_verbatim_string_literal] = ACTIONS(3325),
    [aux_sym_preproc_if_token1] = ACTIONS(3325),
    [aux_sym_preproc_if_token3] = ACTIONS(3325),
    [aux_sym_preproc_else_token1] = ACTIONS(3325),
    [aux_sym_preproc_elif_token1] = ACTIONS(3325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3325),
    [sym_interpolation_verbatim_start] = ACTIONS(3325),
    [sym_interpolation_raw_start] = ACTIONS(3325),
    [sym_raw_string_start] = ACTIONS(3325),
  },
  [1988] = {
    [sym_preproc_region] = STATE(1988),
    [sym_preproc_endregion] = STATE(1988),
    [sym_preproc_line] = STATE(1988),
    [sym_preproc_pragma] = STATE(1988),
    [sym_preproc_nullable] = STATE(1988),
    [sym_preproc_error] = STATE(1988),
    [sym_preproc_warning] = STATE(1988),
    [sym_preproc_define] = STATE(1988),
    [sym_preproc_undef] = STATE(1988),
    [sym__identifier_token] = ACTIONS(3327),
    [anon_sym_extern] = ACTIONS(3327),
    [anon_sym_alias] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_global] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_unsafe] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_struct] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_delegate] = ACTIONS(3327),
    [anon_sym_record] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_file] = ACTIONS(3327),
    [anon_sym_fixed] = ACTIONS(3327),
    [anon_sym_internal] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_partial] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_required] = ACTIONS(3327),
    [anon_sym_sealed] = ACTIONS(3327),
    [anon_sym_virtual] = ACTIONS(3327),
    [anon_sym_volatile] = ACTIONS(3327),
    [anon_sym_where] = ACTIONS(3327),
    [anon_sym_notnull] = ACTIONS(3327),
    [anon_sym_unmanaged] = ACTIONS(3327),
    [anon_sym_checked] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_true] = ACTIONS(3327),
    [anon_sym_false] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3329),
    [anon_sym_this] = ACTIONS(3327),
    [anon_sym_scoped] = ACTIONS(3327),
    [anon_sym_base] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [sym_predefined_type] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_unchecked] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_when] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_DOT_DOT] = ACTIONS(3329),
    [anon_sym_from] = ACTIONS(3327),
    [anon_sym_into] = ACTIONS(3327),
    [anon_sym_join] = ACTIONS(3327),
    [anon_sym_on] = ACTIONS(3327),
    [anon_sym_equals] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_orderby] = ACTIONS(3327),
    [anon_sym_ascending] = ACTIONS(3327),
    [anon_sym_descending] = ACTIONS(3327),
    [anon_sym_group] = ACTIONS(3327),
    [anon_sym_by] = ACTIONS(3327),
    [anon_sym_select] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3327),
    [anon_sym_sizeof] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym___makeref] = ACTIONS(3327),
    [anon_sym___reftype] = ACTIONS(3327),
    [anon_sym___refvalue] = ACTIONS(3327),
    [sym_null_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [sym_integer_literal] = ACTIONS(3327),
    [sym_real_literal] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [sym_verbatim_string_literal] = ACTIONS(3329),
    [aux_sym_preproc_if_token1] = ACTIONS(3329),
    [aux_sym_preproc_if_token3] = ACTIONS(3329),
    [aux_sym_preproc_else_token1] = ACTIONS(3329),
    [aux_sym_preproc_elif_token1] = ACTIONS(3329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3329),
    [sym_interpolation_verbatim_start] = ACTIONS(3329),
    [sym_interpolation_raw_start] = ACTIONS(3329),
    [sym_raw_string_start] = ACTIONS(3329),
  },
  [1989] = {
    [sym_preproc_region] = STATE(1989),
    [sym_preproc_endregion] = STATE(1989),
    [sym_preproc_line] = STATE(1989),
    [sym_preproc_pragma] = STATE(1989),
    [sym_preproc_nullable] = STATE(1989),
    [sym_preproc_error] = STATE(1989),
    [sym_preproc_warning] = STATE(1989),
    [sym_preproc_define] = STATE(1989),
    [sym_preproc_undef] = STATE(1989),
    [sym__identifier_token] = ACTIONS(3331),
    [anon_sym_extern] = ACTIONS(3331),
    [anon_sym_alias] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_global] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_unsafe] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_delegate] = ACTIONS(3331),
    [anon_sym_record] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_file] = ACTIONS(3331),
    [anon_sym_fixed] = ACTIONS(3331),
    [anon_sym_internal] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_partial] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_required] = ACTIONS(3331),
    [anon_sym_sealed] = ACTIONS(3331),
    [anon_sym_virtual] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_where] = ACTIONS(3331),
    [anon_sym_notnull] = ACTIONS(3331),
    [anon_sym_unmanaged] = ACTIONS(3331),
    [anon_sym_checked] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_true] = ACTIONS(3331),
    [anon_sym_false] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3333),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
    [anon_sym_this] = ACTIONS(3331),
    [anon_sym_scoped] = ACTIONS(3331),
    [anon_sym_base] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [sym_predefined_type] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_unchecked] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_when] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_DOT_DOT] = ACTIONS(3333),
    [anon_sym_from] = ACTIONS(3331),
    [anon_sym_into] = ACTIONS(3331),
    [anon_sym_join] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [anon_sym_equals] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_orderby] = ACTIONS(3331),
    [anon_sym_ascending] = ACTIONS(3331),
    [anon_sym_descending] = ACTIONS(3331),
    [anon_sym_group] = ACTIONS(3331),
    [anon_sym_by] = ACTIONS(3331),
    [anon_sym_select] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3331),
    [anon_sym_sizeof] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym___makeref] = ACTIONS(3331),
    [anon_sym___reftype] = ACTIONS(3331),
    [anon_sym___refvalue] = ACTIONS(3331),
    [sym_null_literal] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_integer_literal] = ACTIONS(3331),
    [sym_real_literal] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [sym_verbatim_string_literal] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3333),
    [aux_sym_preproc_if_token3] = ACTIONS(3333),
    [aux_sym_preproc_else_token1] = ACTIONS(3333),
    [aux_sym_preproc_elif_token1] = ACTIONS(3333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3333),
    [sym_interpolation_verbatim_start] = ACTIONS(3333),
    [sym_interpolation_raw_start] = ACTIONS(3333),
    [sym_raw_string_start] = ACTIONS(3333),
  },
  [1990] = {
    [sym_preproc_region] = STATE(1990),
    [sym_preproc_endregion] = STATE(1990),
    [sym_preproc_line] = STATE(1990),
    [sym_preproc_pragma] = STATE(1990),
    [sym_preproc_nullable] = STATE(1990),
    [sym_preproc_error] = STATE(1990),
    [sym_preproc_warning] = STATE(1990),
    [sym_preproc_define] = STATE(1990),
    [sym_preproc_undef] = STATE(1990),
    [sym__identifier_token] = ACTIONS(3335),
    [anon_sym_extern] = ACTIONS(3335),
    [anon_sym_alias] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_global] = ACTIONS(3335),
    [anon_sym_using] = ACTIONS(3335),
    [anon_sym_unsafe] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_namespace] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_struct] = ACTIONS(3335),
    [anon_sym_enum] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_interface] = ACTIONS(3335),
    [anon_sym_delegate] = ACTIONS(3335),
    [anon_sym_record] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_file] = ACTIONS(3335),
    [anon_sym_fixed] = ACTIONS(3335),
    [anon_sym_internal] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_override] = ACTIONS(3335),
    [anon_sym_partial] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_required] = ACTIONS(3335),
    [anon_sym_sealed] = ACTIONS(3335),
    [anon_sym_virtual] = ACTIONS(3335),
    [anon_sym_volatile] = ACTIONS(3335),
    [anon_sym_where] = ACTIONS(3335),
    [anon_sym_notnull] = ACTIONS(3335),
    [anon_sym_unmanaged] = ACTIONS(3335),
    [anon_sym_checked] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_TILDE] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_true] = ACTIONS(3335),
    [anon_sym_false] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_this] = ACTIONS(3335),
    [anon_sym_scoped] = ACTIONS(3335),
    [anon_sym_base] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [sym_predefined_type] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_unchecked] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_when] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_DOT_DOT] = ACTIONS(3337),
    [anon_sym_from] = ACTIONS(3335),
    [anon_sym_into] = ACTIONS(3335),
    [anon_sym_join] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [anon_sym_equals] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_orderby] = ACTIONS(3335),
    [anon_sym_ascending] = ACTIONS(3335),
    [anon_sym_descending] = ACTIONS(3335),
    [anon_sym_group] = ACTIONS(3335),
    [anon_sym_by] = ACTIONS(3335),
    [anon_sym_select] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3335),
    [anon_sym_sizeof] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym___makeref] = ACTIONS(3335),
    [anon_sym___reftype] = ACTIONS(3335),
    [anon_sym___refvalue] = ACTIONS(3335),
    [sym_null_literal] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_integer_literal] = ACTIONS(3335),
    [sym_real_literal] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [sym_verbatim_string_literal] = ACTIONS(3337),
    [aux_sym_preproc_if_token1] = ACTIONS(3337),
    [aux_sym_preproc_if_token3] = ACTIONS(3337),
    [aux_sym_preproc_else_token1] = ACTIONS(3337),
    [aux_sym_preproc_elif_token1] = ACTIONS(3337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3337),
    [sym_interpolation_verbatim_start] = ACTIONS(3337),
    [sym_interpolation_raw_start] = ACTIONS(3337),
    [sym_raw_string_start] = ACTIONS(3337),
  },
  [1991] = {
    [sym_preproc_region] = STATE(1991),
    [sym_preproc_endregion] = STATE(1991),
    [sym_preproc_line] = STATE(1991),
    [sym_preproc_pragma] = STATE(1991),
    [sym_preproc_nullable] = STATE(1991),
    [sym_preproc_error] = STATE(1991),
    [sym_preproc_warning] = STATE(1991),
    [sym_preproc_define] = STATE(1991),
    [sym_preproc_undef] = STATE(1991),
    [sym__identifier_token] = ACTIONS(3339),
    [anon_sym_extern] = ACTIONS(3339),
    [anon_sym_alias] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_global] = ACTIONS(3339),
    [anon_sym_using] = ACTIONS(3339),
    [anon_sym_unsafe] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3339),
    [anon_sym_class] = ACTIONS(3339),
    [anon_sym_ref] = ACTIONS(3339),
    [anon_sym_struct] = ACTIONS(3339),
    [anon_sym_enum] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_interface] = ACTIONS(3339),
    [anon_sym_delegate] = ACTIONS(3339),
    [anon_sym_record] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_const] = ACTIONS(3339),
    [anon_sym_file] = ACTIONS(3339),
    [anon_sym_fixed] = ACTIONS(3339),
    [anon_sym_internal] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_override] = ACTIONS(3339),
    [anon_sym_partial] = ACTIONS(3339),
    [anon_sym_private] = ACTIONS(3339),
    [anon_sym_protected] = ACTIONS(3339),
    [anon_sym_public] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_required] = ACTIONS(3339),
    [anon_sym_sealed] = ACTIONS(3339),
    [anon_sym_virtual] = ACTIONS(3339),
    [anon_sym_volatile] = ACTIONS(3339),
    [anon_sym_where] = ACTIONS(3339),
    [anon_sym_notnull] = ACTIONS(3339),
    [anon_sym_unmanaged] = ACTIONS(3339),
    [anon_sym_checked] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_TILDE] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_true] = ACTIONS(3339),
    [anon_sym_false] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_this] = ACTIONS(3339),
    [anon_sym_scoped] = ACTIONS(3339),
    [anon_sym_base] = ACTIONS(3339),
    [anon_sym_var] = ACTIONS(3339),
    [sym_predefined_type] = ACTIONS(3339),
    [anon_sym_break] = ACTIONS(3339),
    [anon_sym_unchecked] = ACTIONS(3339),
    [anon_sym_continue] = ACTIONS(3339),
    [anon_sym_do] = ACTIONS(3339),
    [anon_sym_while] = ACTIONS(3339),
    [anon_sym_for] = ACTIONS(3339),
    [anon_sym_lock] = ACTIONS(3339),
    [anon_sym_yield] = ACTIONS(3339),
    [anon_sym_switch] = ACTIONS(3339),
    [anon_sym_default] = ACTIONS(3339),
    [anon_sym_throw] = ACTIONS(3339),
    [anon_sym_try] = ACTIONS(3339),
    [anon_sym_when] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3339),
    [anon_sym_foreach] = ACTIONS(3339),
    [anon_sym_goto] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3339),
    [anon_sym_else] = ACTIONS(3339),
    [anon_sym_DOT_DOT] = ACTIONS(3341),
    [anon_sym_from] = ACTIONS(3339),
    [anon_sym_into] = ACTIONS(3339),
    [anon_sym_join] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [anon_sym_equals] = ACTIONS(3339),
    [anon_sym_let] = ACTIONS(3339),
    [anon_sym_orderby] = ACTIONS(3339),
    [anon_sym_ascending] = ACTIONS(3339),
    [anon_sym_descending] = ACTIONS(3339),
    [anon_sym_group] = ACTIONS(3339),
    [anon_sym_by] = ACTIONS(3339),
    [anon_sym_select] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3339),
    [anon_sym_sizeof] = ACTIONS(3339),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym___makeref] = ACTIONS(3339),
    [anon_sym___reftype] = ACTIONS(3339),
    [anon_sym___refvalue] = ACTIONS(3339),
    [sym_null_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_integer_literal] = ACTIONS(3339),
    [sym_real_literal] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3341),
    [sym_verbatim_string_literal] = ACTIONS(3341),
    [aux_sym_preproc_if_token1] = ACTIONS(3341),
    [aux_sym_preproc_if_token3] = ACTIONS(3341),
    [aux_sym_preproc_else_token1] = ACTIONS(3341),
    [aux_sym_preproc_elif_token1] = ACTIONS(3341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3341),
    [sym_interpolation_verbatim_start] = ACTIONS(3341),
    [sym_interpolation_raw_start] = ACTIONS(3341),
    [sym_raw_string_start] = ACTIONS(3341),
  },
  [1992] = {
    [sym_preproc_region] = STATE(1992),
    [sym_preproc_endregion] = STATE(1992),
    [sym_preproc_line] = STATE(1992),
    [sym_preproc_pragma] = STATE(1992),
    [sym_preproc_nullable] = STATE(1992),
    [sym_preproc_error] = STATE(1992),
    [sym_preproc_warning] = STATE(1992),
    [sym_preproc_define] = STATE(1992),
    [sym_preproc_undef] = STATE(1992),
    [sym__identifier_token] = ACTIONS(3343),
    [anon_sym_extern] = ACTIONS(3343),
    [anon_sym_alias] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_global] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_unsafe] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_ref] = ACTIONS(3343),
    [anon_sym_struct] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_delegate] = ACTIONS(3343),
    [anon_sym_record] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_file] = ACTIONS(3343),
    [anon_sym_fixed] = ACTIONS(3343),
    [anon_sym_internal] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_partial] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_required] = ACTIONS(3343),
    [anon_sym_sealed] = ACTIONS(3343),
    [anon_sym_virtual] = ACTIONS(3343),
    [anon_sym_volatile] = ACTIONS(3343),
    [anon_sym_where] = ACTIONS(3343),
    [anon_sym_notnull] = ACTIONS(3343),
    [anon_sym_unmanaged] = ACTIONS(3343),
    [anon_sym_checked] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3345),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3345),
    [anon_sym_this] = ACTIONS(3343),
    [anon_sym_scoped] = ACTIONS(3343),
    [anon_sym_base] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [sym_predefined_type] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_unchecked] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_lock] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_when] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_foreach] = ACTIONS(3343),
    [anon_sym_goto] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_DOT_DOT] = ACTIONS(3345),
    [anon_sym_from] = ACTIONS(3343),
    [anon_sym_into] = ACTIONS(3343),
    [anon_sym_join] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [anon_sym_equals] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_orderby] = ACTIONS(3343),
    [anon_sym_ascending] = ACTIONS(3343),
    [anon_sym_descending] = ACTIONS(3343),
    [anon_sym_group] = ACTIONS(3343),
    [anon_sym_by] = ACTIONS(3343),
    [anon_sym_select] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym___makeref] = ACTIONS(3343),
    [anon_sym___reftype] = ACTIONS(3343),
    [anon_sym___refvalue] = ACTIONS(3343),
    [sym_null_literal] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_integer_literal] = ACTIONS(3343),
    [sym_real_literal] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [sym_verbatim_string_literal] = ACTIONS(3345),
    [aux_sym_preproc_if_token1] = ACTIONS(3345),
    [aux_sym_preproc_if_token3] = ACTIONS(3345),
    [aux_sym_preproc_else_token1] = ACTIONS(3345),
    [aux_sym_preproc_elif_token1] = ACTIONS(3345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3345),
    [sym_interpolation_verbatim_start] = ACTIONS(3345),
    [sym_interpolation_raw_start] = ACTIONS(3345),
    [sym_raw_string_start] = ACTIONS(3345),
  },
  [1993] = {
    [sym_preproc_region] = STATE(1993),
    [sym_preproc_endregion] = STATE(1993),
    [sym_preproc_line] = STATE(1993),
    [sym_preproc_pragma] = STATE(1993),
    [sym_preproc_nullable] = STATE(1993),
    [sym_preproc_error] = STATE(1993),
    [sym_preproc_warning] = STATE(1993),
    [sym_preproc_define] = STATE(1993),
    [sym_preproc_undef] = STATE(1993),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_struct] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_record] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_checked] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_true] = ACTIONS(3347),
    [anon_sym_false] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_this] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_base] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_unchecked] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_lock] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_foreach] = ACTIONS(3347),
    [anon_sym_goto] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_DOT_DOT] = ACTIONS(3349),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3347),
    [anon_sym_sizeof] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym___makeref] = ACTIONS(3347),
    [anon_sym___reftype] = ACTIONS(3347),
    [anon_sym___refvalue] = ACTIONS(3347),
    [sym_null_literal] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_integer_literal] = ACTIONS(3347),
    [sym_real_literal] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [sym_verbatim_string_literal] = ACTIONS(3349),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_if_token3] = ACTIONS(3349),
    [aux_sym_preproc_else_token1] = ACTIONS(3349),
    [aux_sym_preproc_elif_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3349),
    [sym_interpolation_verbatim_start] = ACTIONS(3349),
    [sym_interpolation_raw_start] = ACTIONS(3349),
    [sym_raw_string_start] = ACTIONS(3349),
  },
  [1994] = {
    [sym_preproc_region] = STATE(1994),
    [sym_preproc_endregion] = STATE(1994),
    [sym_preproc_line] = STATE(1994),
    [sym_preproc_pragma] = STATE(1994),
    [sym_preproc_nullable] = STATE(1994),
    [sym_preproc_error] = STATE(1994),
    [sym_preproc_warning] = STATE(1994),
    [sym_preproc_define] = STATE(1994),
    [sym_preproc_undef] = STATE(1994),
    [sym__identifier_token] = ACTIONS(3351),
    [anon_sym_extern] = ACTIONS(3351),
    [anon_sym_alias] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_global] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_unsafe] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_ref] = ACTIONS(3351),
    [anon_sym_struct] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_delegate] = ACTIONS(3351),
    [anon_sym_record] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_file] = ACTIONS(3351),
    [anon_sym_fixed] = ACTIONS(3351),
    [anon_sym_internal] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_partial] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_required] = ACTIONS(3351),
    [anon_sym_sealed] = ACTIONS(3351),
    [anon_sym_virtual] = ACTIONS(3351),
    [anon_sym_volatile] = ACTIONS(3351),
    [anon_sym_where] = ACTIONS(3351),
    [anon_sym_notnull] = ACTIONS(3351),
    [anon_sym_unmanaged] = ACTIONS(3351),
    [anon_sym_checked] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_true] = ACTIONS(3351),
    [anon_sym_false] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_this] = ACTIONS(3351),
    [anon_sym_scoped] = ACTIONS(3351),
    [anon_sym_base] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [sym_predefined_type] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_unchecked] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_lock] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_when] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_foreach] = ACTIONS(3351),
    [anon_sym_goto] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_from] = ACTIONS(3351),
    [anon_sym_into] = ACTIONS(3351),
    [anon_sym_join] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [anon_sym_equals] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_orderby] = ACTIONS(3351),
    [anon_sym_ascending] = ACTIONS(3351),
    [anon_sym_descending] = ACTIONS(3351),
    [anon_sym_group] = ACTIONS(3351),
    [anon_sym_by] = ACTIONS(3351),
    [anon_sym_select] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3351),
    [anon_sym_sizeof] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym___makeref] = ACTIONS(3351),
    [anon_sym___reftype] = ACTIONS(3351),
    [anon_sym___refvalue] = ACTIONS(3351),
    [sym_null_literal] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_integer_literal] = ACTIONS(3351),
    [sym_real_literal] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [sym_verbatim_string_literal] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_if_token3] = ACTIONS(3353),
    [aux_sym_preproc_else_token1] = ACTIONS(3353),
    [aux_sym_preproc_elif_token1] = ACTIONS(3353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3353),
    [sym_interpolation_verbatim_start] = ACTIONS(3353),
    [sym_interpolation_raw_start] = ACTIONS(3353),
    [sym_raw_string_start] = ACTIONS(3353),
  },
  [1995] = {
    [sym_preproc_region] = STATE(1995),
    [sym_preproc_endregion] = STATE(1995),
    [sym_preproc_line] = STATE(1995),
    [sym_preproc_pragma] = STATE(1995),
    [sym_preproc_nullable] = STATE(1995),
    [sym_preproc_error] = STATE(1995),
    [sym_preproc_warning] = STATE(1995),
    [sym_preproc_define] = STATE(1995),
    [sym_preproc_undef] = STATE(1995),
    [sym__identifier_token] = ACTIONS(3355),
    [anon_sym_extern] = ACTIONS(3355),
    [anon_sym_alias] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_global] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_unsafe] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_ref] = ACTIONS(3355),
    [anon_sym_struct] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_delegate] = ACTIONS(3355),
    [anon_sym_record] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_file] = ACTIONS(3355),
    [anon_sym_fixed] = ACTIONS(3355),
    [anon_sym_internal] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_partial] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_required] = ACTIONS(3355),
    [anon_sym_sealed] = ACTIONS(3355),
    [anon_sym_virtual] = ACTIONS(3355),
    [anon_sym_volatile] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [anon_sym_notnull] = ACTIONS(3355),
    [anon_sym_unmanaged] = ACTIONS(3355),
    [anon_sym_checked] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [anon_sym_true] = ACTIONS(3355),
    [anon_sym_false] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_CARET] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_this] = ACTIONS(3355),
    [anon_sym_scoped] = ACTIONS(3355),
    [anon_sym_base] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [sym_predefined_type] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_unchecked] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_lock] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_when] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_foreach] = ACTIONS(3355),
    [anon_sym_goto] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_DOT_DOT] = ACTIONS(3357),
    [anon_sym_from] = ACTIONS(3355),
    [anon_sym_into] = ACTIONS(3355),
    [anon_sym_join] = ACTIONS(3355),
    [anon_sym_on] = ACTIONS(3355),
    [anon_sym_equals] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_orderby] = ACTIONS(3355),
    [anon_sym_ascending] = ACTIONS(3355),
    [anon_sym_descending] = ACTIONS(3355),
    [anon_sym_group] = ACTIONS(3355),
    [anon_sym_by] = ACTIONS(3355),
    [anon_sym_select] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym___makeref] = ACTIONS(3355),
    [anon_sym___reftype] = ACTIONS(3355),
    [anon_sym___refvalue] = ACTIONS(3355),
    [sym_null_literal] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [sym_integer_literal] = ACTIONS(3355),
    [sym_real_literal] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [sym_verbatim_string_literal] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token3] = ACTIONS(3357),
    [aux_sym_preproc_else_token1] = ACTIONS(3357),
    [aux_sym_preproc_elif_token1] = ACTIONS(3357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3357),
    [sym_interpolation_verbatim_start] = ACTIONS(3357),
    [sym_interpolation_raw_start] = ACTIONS(3357),
    [sym_raw_string_start] = ACTIONS(3357),
  },
  [1996] = {
    [sym_preproc_region] = STATE(1996),
    [sym_preproc_endregion] = STATE(1996),
    [sym_preproc_line] = STATE(1996),
    [sym_preproc_pragma] = STATE(1996),
    [sym_preproc_nullable] = STATE(1996),
    [sym_preproc_error] = STATE(1996),
    [sym_preproc_warning] = STATE(1996),
    [sym_preproc_define] = STATE(1996),
    [sym_preproc_undef] = STATE(1996),
    [sym__identifier_token] = ACTIONS(3359),
    [anon_sym_extern] = ACTIONS(3359),
    [anon_sym_alias] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_unsafe] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_ref] = ACTIONS(3359),
    [anon_sym_struct] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_delegate] = ACTIONS(3359),
    [anon_sym_record] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_file] = ACTIONS(3359),
    [anon_sym_fixed] = ACTIONS(3359),
    [anon_sym_internal] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_partial] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_required] = ACTIONS(3359),
    [anon_sym_sealed] = ACTIONS(3359),
    [anon_sym_virtual] = ACTIONS(3359),
    [anon_sym_volatile] = ACTIONS(3359),
    [anon_sym_where] = ACTIONS(3359),
    [anon_sym_notnull] = ACTIONS(3359),
    [anon_sym_unmanaged] = ACTIONS(3359),
    [anon_sym_checked] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [anon_sym_true] = ACTIONS(3359),
    [anon_sym_false] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_CARET] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_this] = ACTIONS(3359),
    [anon_sym_scoped] = ACTIONS(3359),
    [anon_sym_base] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [sym_predefined_type] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_unchecked] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_lock] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_when] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_foreach] = ACTIONS(3359),
    [anon_sym_goto] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_DOT_DOT] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3359),
    [anon_sym_into] = ACTIONS(3359),
    [anon_sym_join] = ACTIONS(3359),
    [anon_sym_on] = ACTIONS(3359),
    [anon_sym_equals] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_orderby] = ACTIONS(3359),
    [anon_sym_ascending] = ACTIONS(3359),
    [anon_sym_descending] = ACTIONS(3359),
    [anon_sym_group] = ACTIONS(3359),
    [anon_sym_by] = ACTIONS(3359),
    [anon_sym_select] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym___makeref] = ACTIONS(3359),
    [anon_sym___reftype] = ACTIONS(3359),
    [anon_sym___refvalue] = ACTIONS(3359),
    [sym_null_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [sym_integer_literal] = ACTIONS(3359),
    [sym_real_literal] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [sym_verbatim_string_literal] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token3] = ACTIONS(3361),
    [aux_sym_preproc_else_token1] = ACTIONS(3361),
    [aux_sym_preproc_elif_token1] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3361),
    [sym_interpolation_verbatim_start] = ACTIONS(3361),
    [sym_interpolation_raw_start] = ACTIONS(3361),
    [sym_raw_string_start] = ACTIONS(3361),
  },
  [1997] = {
    [sym_preproc_region] = STATE(1997),
    [sym_preproc_endregion] = STATE(1997),
    [sym_preproc_line] = STATE(1997),
    [sym_preproc_pragma] = STATE(1997),
    [sym_preproc_nullable] = STATE(1997),
    [sym_preproc_error] = STATE(1997),
    [sym_preproc_warning] = STATE(1997),
    [sym_preproc_define] = STATE(1997),
    [sym_preproc_undef] = STATE(1997),
    [sym__identifier_token] = ACTIONS(3363),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_alias] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_unsafe] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_ref] = ACTIONS(3363),
    [anon_sym_struct] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_delegate] = ACTIONS(3363),
    [anon_sym_record] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_file] = ACTIONS(3363),
    [anon_sym_fixed] = ACTIONS(3363),
    [anon_sym_internal] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_partial] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_required] = ACTIONS(3363),
    [anon_sym_sealed] = ACTIONS(3363),
    [anon_sym_virtual] = ACTIONS(3363),
    [anon_sym_volatile] = ACTIONS(3363),
    [anon_sym_where] = ACTIONS(3363),
    [anon_sym_notnull] = ACTIONS(3363),
    [anon_sym_unmanaged] = ACTIONS(3363),
    [anon_sym_checked] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [anon_sym_true] = ACTIONS(3363),
    [anon_sym_false] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3365),
    [anon_sym_CARET] = ACTIONS(3365),
    [anon_sym_AMP] = ACTIONS(3365),
    [anon_sym_this] = ACTIONS(3363),
    [anon_sym_scoped] = ACTIONS(3363),
    [anon_sym_base] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [sym_predefined_type] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_unchecked] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_lock] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_when] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_foreach] = ACTIONS(3363),
    [anon_sym_goto] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_DOT_DOT] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3363),
    [anon_sym_into] = ACTIONS(3363),
    [anon_sym_join] = ACTIONS(3363),
    [anon_sym_on] = ACTIONS(3363),
    [anon_sym_equals] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_orderby] = ACTIONS(3363),
    [anon_sym_ascending] = ACTIONS(3363),
    [anon_sym_descending] = ACTIONS(3363),
    [anon_sym_group] = ACTIONS(3363),
    [anon_sym_by] = ACTIONS(3363),
    [anon_sym_select] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym___makeref] = ACTIONS(3363),
    [anon_sym___reftype] = ACTIONS(3363),
    [anon_sym___refvalue] = ACTIONS(3363),
    [sym_null_literal] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [sym_integer_literal] = ACTIONS(3363),
    [sym_real_literal] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [sym_verbatim_string_literal] = ACTIONS(3365),
    [aux_sym_preproc_if_token1] = ACTIONS(3365),
    [aux_sym_preproc_if_token3] = ACTIONS(3365),
    [aux_sym_preproc_else_token1] = ACTIONS(3365),
    [aux_sym_preproc_elif_token1] = ACTIONS(3365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3365),
    [sym_interpolation_verbatim_start] = ACTIONS(3365),
    [sym_interpolation_raw_start] = ACTIONS(3365),
    [sym_raw_string_start] = ACTIONS(3365),
  },
  [1998] = {
    [sym_preproc_region] = STATE(1998),
    [sym_preproc_endregion] = STATE(1998),
    [sym_preproc_line] = STATE(1998),
    [sym_preproc_pragma] = STATE(1998),
    [sym_preproc_nullable] = STATE(1998),
    [sym_preproc_error] = STATE(1998),
    [sym_preproc_warning] = STATE(1998),
    [sym_preproc_define] = STATE(1998),
    [sym_preproc_undef] = STATE(1998),
    [sym__identifier_token] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym_alias] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_global] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_unsafe] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_ref] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_delegate] = ACTIONS(3367),
    [anon_sym_record] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_file] = ACTIONS(3367),
    [anon_sym_fixed] = ACTIONS(3367),
    [anon_sym_internal] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_partial] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_required] = ACTIONS(3367),
    [anon_sym_sealed] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_where] = ACTIONS(3367),
    [anon_sym_notnull] = ACTIONS(3367),
    [anon_sym_unmanaged] = ACTIONS(3367),
    [anon_sym_checked] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_true] = ACTIONS(3367),
    [anon_sym_false] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_CARET] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_this] = ACTIONS(3367),
    [anon_sym_scoped] = ACTIONS(3367),
    [anon_sym_base] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [sym_predefined_type] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_unchecked] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_lock] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_when] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_foreach] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_DOT_DOT] = ACTIONS(3369),
    [anon_sym_from] = ACTIONS(3367),
    [anon_sym_into] = ACTIONS(3367),
    [anon_sym_join] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [anon_sym_equals] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_orderby] = ACTIONS(3367),
    [anon_sym_ascending] = ACTIONS(3367),
    [anon_sym_descending] = ACTIONS(3367),
    [anon_sym_group] = ACTIONS(3367),
    [anon_sym_by] = ACTIONS(3367),
    [anon_sym_select] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3367),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym___makeref] = ACTIONS(3367),
    [anon_sym___reftype] = ACTIONS(3367),
    [anon_sym___refvalue] = ACTIONS(3367),
    [sym_null_literal] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_integer_literal] = ACTIONS(3367),
    [sym_real_literal] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_verbatim_string_literal] = ACTIONS(3369),
    [aux_sym_preproc_if_token1] = ACTIONS(3369),
    [aux_sym_preproc_if_token3] = ACTIONS(3369),
    [aux_sym_preproc_else_token1] = ACTIONS(3369),
    [aux_sym_preproc_elif_token1] = ACTIONS(3369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3369),
    [sym_interpolation_verbatim_start] = ACTIONS(3369),
    [sym_interpolation_raw_start] = ACTIONS(3369),
    [sym_raw_string_start] = ACTIONS(3369),
  },
  [1999] = {
    [sym_preproc_region] = STATE(1999),
    [sym_preproc_endregion] = STATE(1999),
    [sym_preproc_line] = STATE(1999),
    [sym_preproc_pragma] = STATE(1999),
    [sym_preproc_nullable] = STATE(1999),
    [sym_preproc_error] = STATE(1999),
    [sym_preproc_warning] = STATE(1999),
    [sym_preproc_define] = STATE(1999),
    [sym_preproc_undef] = STATE(1999),
    [sym__identifier_token] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym_alias] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_global] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_unsafe] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_ref] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_delegate] = ACTIONS(3371),
    [anon_sym_record] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_file] = ACTIONS(3371),
    [anon_sym_fixed] = ACTIONS(3371),
    [anon_sym_internal] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_partial] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_required] = ACTIONS(3371),
    [anon_sym_sealed] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_where] = ACTIONS(3371),
    [anon_sym_notnull] = ACTIONS(3371),
    [anon_sym_unmanaged] = ACTIONS(3371),
    [anon_sym_checked] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_true] = ACTIONS(3371),
    [anon_sym_false] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_CARET] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_this] = ACTIONS(3371),
    [anon_sym_scoped] = ACTIONS(3371),
    [anon_sym_base] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [sym_predefined_type] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_unchecked] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_lock] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_when] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_foreach] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_DOT_DOT] = ACTIONS(3373),
    [anon_sym_from] = ACTIONS(3371),
    [anon_sym_into] = ACTIONS(3371),
    [anon_sym_join] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [anon_sym_equals] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_orderby] = ACTIONS(3371),
    [anon_sym_ascending] = ACTIONS(3371),
    [anon_sym_descending] = ACTIONS(3371),
    [anon_sym_group] = ACTIONS(3371),
    [anon_sym_by] = ACTIONS(3371),
    [anon_sym_select] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3371),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym___makeref] = ACTIONS(3371),
    [anon_sym___reftype] = ACTIONS(3371),
    [anon_sym___refvalue] = ACTIONS(3371),
    [sym_null_literal] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_integer_literal] = ACTIONS(3371),
    [sym_real_literal] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_verbatim_string_literal] = ACTIONS(3373),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_if_token3] = ACTIONS(3373),
    [aux_sym_preproc_else_token1] = ACTIONS(3373),
    [aux_sym_preproc_elif_token1] = ACTIONS(3373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3373),
    [sym_interpolation_verbatim_start] = ACTIONS(3373),
    [sym_interpolation_raw_start] = ACTIONS(3373),
    [sym_raw_string_start] = ACTIONS(3373),
  },
  [2000] = {
    [sym_preproc_region] = STATE(2000),
    [sym_preproc_endregion] = STATE(2000),
    [sym_preproc_line] = STATE(2000),
    [sym_preproc_pragma] = STATE(2000),
    [sym_preproc_nullable] = STATE(2000),
    [sym_preproc_error] = STATE(2000),
    [sym_preproc_warning] = STATE(2000),
    [sym_preproc_define] = STATE(2000),
    [sym_preproc_undef] = STATE(2000),
    [sym__identifier_token] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym_alias] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_global] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_unsafe] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_ref] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_delegate] = ACTIONS(3375),
    [anon_sym_record] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_file] = ACTIONS(3375),
    [anon_sym_fixed] = ACTIONS(3375),
    [anon_sym_internal] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_partial] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_required] = ACTIONS(3375),
    [anon_sym_sealed] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_where] = ACTIONS(3375),
    [anon_sym_notnull] = ACTIONS(3375),
    [anon_sym_unmanaged] = ACTIONS(3375),
    [anon_sym_checked] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_true] = ACTIONS(3375),
    [anon_sym_false] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3375),
    [anon_sym_scoped] = ACTIONS(3375),
    [anon_sym_base] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [sym_predefined_type] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_unchecked] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_lock] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_when] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_foreach] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_DOT_DOT] = ACTIONS(3377),
    [anon_sym_from] = ACTIONS(3375),
    [anon_sym_into] = ACTIONS(3375),
    [anon_sym_join] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [anon_sym_equals] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_orderby] = ACTIONS(3375),
    [anon_sym_ascending] = ACTIONS(3375),
    [anon_sym_descending] = ACTIONS(3375),
    [anon_sym_group] = ACTIONS(3375),
    [anon_sym_by] = ACTIONS(3375),
    [anon_sym_select] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3375),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym___makeref] = ACTIONS(3375),
    [anon_sym___reftype] = ACTIONS(3375),
    [anon_sym___refvalue] = ACTIONS(3375),
    [sym_null_literal] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_integer_literal] = ACTIONS(3375),
    [sym_real_literal] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_verbatim_string_literal] = ACTIONS(3377),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_if_token3] = ACTIONS(3377),
    [aux_sym_preproc_else_token1] = ACTIONS(3377),
    [aux_sym_preproc_elif_token1] = ACTIONS(3377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3377),
    [sym_interpolation_verbatim_start] = ACTIONS(3377),
    [sym_interpolation_raw_start] = ACTIONS(3377),
    [sym_raw_string_start] = ACTIONS(3377),
  },
  [2001] = {
    [sym_preproc_region] = STATE(2001),
    [sym_preproc_endregion] = STATE(2001),
    [sym_preproc_line] = STATE(2001),
    [sym_preproc_pragma] = STATE(2001),
    [sym_preproc_nullable] = STATE(2001),
    [sym_preproc_error] = STATE(2001),
    [sym_preproc_warning] = STATE(2001),
    [sym_preproc_define] = STATE(2001),
    [sym_preproc_undef] = STATE(2001),
    [sym__identifier_token] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym_alias] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_global] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_unsafe] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_ref] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_delegate] = ACTIONS(3379),
    [anon_sym_record] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_file] = ACTIONS(3379),
    [anon_sym_fixed] = ACTIONS(3379),
    [anon_sym_internal] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_partial] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_required] = ACTIONS(3379),
    [anon_sym_sealed] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_where] = ACTIONS(3379),
    [anon_sym_notnull] = ACTIONS(3379),
    [anon_sym_unmanaged] = ACTIONS(3379),
    [anon_sym_checked] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_true] = ACTIONS(3379),
    [anon_sym_false] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_CARET] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_scoped] = ACTIONS(3379),
    [anon_sym_base] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [sym_predefined_type] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_unchecked] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_lock] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_when] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_foreach] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_DOT_DOT] = ACTIONS(3381),
    [anon_sym_from] = ACTIONS(3379),
    [anon_sym_into] = ACTIONS(3379),
    [anon_sym_join] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [anon_sym_equals] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_orderby] = ACTIONS(3379),
    [anon_sym_ascending] = ACTIONS(3379),
    [anon_sym_descending] = ACTIONS(3379),
    [anon_sym_group] = ACTIONS(3379),
    [anon_sym_by] = ACTIONS(3379),
    [anon_sym_select] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3379),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym___makeref] = ACTIONS(3379),
    [anon_sym___reftype] = ACTIONS(3379),
    [anon_sym___refvalue] = ACTIONS(3379),
    [sym_null_literal] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_integer_literal] = ACTIONS(3379),
    [sym_real_literal] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_verbatim_string_literal] = ACTIONS(3381),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_if_token3] = ACTIONS(3381),
    [aux_sym_preproc_else_token1] = ACTIONS(3381),
    [aux_sym_preproc_elif_token1] = ACTIONS(3381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3381),
    [sym_interpolation_verbatim_start] = ACTIONS(3381),
    [sym_interpolation_raw_start] = ACTIONS(3381),
    [sym_raw_string_start] = ACTIONS(3381),
  },
  [2002] = {
    [sym_preproc_region] = STATE(2002),
    [sym_preproc_endregion] = STATE(2002),
    [sym_preproc_line] = STATE(2002),
    [sym_preproc_pragma] = STATE(2002),
    [sym_preproc_nullable] = STATE(2002),
    [sym_preproc_error] = STATE(2002),
    [sym_preproc_warning] = STATE(2002),
    [sym_preproc_define] = STATE(2002),
    [sym_preproc_undef] = STATE(2002),
    [sym__identifier_token] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym_alias] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_global] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_unsafe] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_ref] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_delegate] = ACTIONS(3383),
    [anon_sym_record] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_file] = ACTIONS(3383),
    [anon_sym_fixed] = ACTIONS(3383),
    [anon_sym_internal] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_partial] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_required] = ACTIONS(3383),
    [anon_sym_sealed] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_where] = ACTIONS(3383),
    [anon_sym_notnull] = ACTIONS(3383),
    [anon_sym_unmanaged] = ACTIONS(3383),
    [anon_sym_checked] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_true] = ACTIONS(3383),
    [anon_sym_false] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_this] = ACTIONS(3383),
    [anon_sym_scoped] = ACTIONS(3383),
    [anon_sym_base] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [sym_predefined_type] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_unchecked] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_lock] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_when] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_foreach] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_DOT_DOT] = ACTIONS(3385),
    [anon_sym_from] = ACTIONS(3383),
    [anon_sym_into] = ACTIONS(3383),
    [anon_sym_join] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [anon_sym_equals] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_orderby] = ACTIONS(3383),
    [anon_sym_ascending] = ACTIONS(3383),
    [anon_sym_descending] = ACTIONS(3383),
    [anon_sym_group] = ACTIONS(3383),
    [anon_sym_by] = ACTIONS(3383),
    [anon_sym_select] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3383),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym___makeref] = ACTIONS(3383),
    [anon_sym___reftype] = ACTIONS(3383),
    [anon_sym___refvalue] = ACTIONS(3383),
    [sym_null_literal] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_integer_literal] = ACTIONS(3383),
    [sym_real_literal] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_verbatim_string_literal] = ACTIONS(3385),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_if_token3] = ACTIONS(3385),
    [aux_sym_preproc_else_token1] = ACTIONS(3385),
    [aux_sym_preproc_elif_token1] = ACTIONS(3385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3385),
    [sym_interpolation_verbatim_start] = ACTIONS(3385),
    [sym_interpolation_raw_start] = ACTIONS(3385),
    [sym_raw_string_start] = ACTIONS(3385),
  },
  [2003] = {
    [sym_preproc_region] = STATE(2003),
    [sym_preproc_endregion] = STATE(2003),
    [sym_preproc_line] = STATE(2003),
    [sym_preproc_pragma] = STATE(2003),
    [sym_preproc_nullable] = STATE(2003),
    [sym_preproc_error] = STATE(2003),
    [sym_preproc_warning] = STATE(2003),
    [sym_preproc_define] = STATE(2003),
    [sym_preproc_undef] = STATE(2003),
    [sym__identifier_token] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_alias] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_global] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_ref] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_delegate] = ACTIONS(3387),
    [anon_sym_record] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_file] = ACTIONS(3387),
    [anon_sym_fixed] = ACTIONS(3387),
    [anon_sym_internal] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_partial] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_required] = ACTIONS(3387),
    [anon_sym_sealed] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_where] = ACTIONS(3387),
    [anon_sym_notnull] = ACTIONS(3387),
    [anon_sym_unmanaged] = ACTIONS(3387),
    [anon_sym_checked] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_true] = ACTIONS(3387),
    [anon_sym_false] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_this] = ACTIONS(3387),
    [anon_sym_scoped] = ACTIONS(3387),
    [anon_sym_base] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [sym_predefined_type] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_unchecked] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_lock] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_when] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_foreach] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_from] = ACTIONS(3387),
    [anon_sym_into] = ACTIONS(3387),
    [anon_sym_join] = ACTIONS(3387),
    [anon_sym_on] = ACTIONS(3387),
    [anon_sym_equals] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_orderby] = ACTIONS(3387),
    [anon_sym_ascending] = ACTIONS(3387),
    [anon_sym_descending] = ACTIONS(3387),
    [anon_sym_group] = ACTIONS(3387),
    [anon_sym_by] = ACTIONS(3387),
    [anon_sym_select] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3387),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym___makeref] = ACTIONS(3387),
    [anon_sym___reftype] = ACTIONS(3387),
    [anon_sym___refvalue] = ACTIONS(3387),
    [sym_null_literal] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [sym_integer_literal] = ACTIONS(3387),
    [sym_real_literal] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_verbatim_string_literal] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_if_token3] = ACTIONS(3389),
    [aux_sym_preproc_else_token1] = ACTIONS(3389),
    [aux_sym_preproc_elif_token1] = ACTIONS(3389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3389),
    [sym_interpolation_verbatim_start] = ACTIONS(3389),
    [sym_interpolation_raw_start] = ACTIONS(3389),
    [sym_raw_string_start] = ACTIONS(3389),
  },
  [2004] = {
    [sym_preproc_region] = STATE(2004),
    [sym_preproc_endregion] = STATE(2004),
    [sym_preproc_line] = STATE(2004),
    [sym_preproc_pragma] = STATE(2004),
    [sym_preproc_nullable] = STATE(2004),
    [sym_preproc_error] = STATE(2004),
    [sym_preproc_warning] = STATE(2004),
    [sym_preproc_define] = STATE(2004),
    [sym_preproc_undef] = STATE(2004),
    [sym__identifier_token] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym_alias] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_global] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_unsafe] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_ref] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_delegate] = ACTIONS(3391),
    [anon_sym_record] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_file] = ACTIONS(3391),
    [anon_sym_fixed] = ACTIONS(3391),
    [anon_sym_internal] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_partial] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_required] = ACTIONS(3391),
    [anon_sym_sealed] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(3391),
    [anon_sym_notnull] = ACTIONS(3391),
    [anon_sym_unmanaged] = ACTIONS(3391),
    [anon_sym_checked] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_true] = ACTIONS(3391),
    [anon_sym_false] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_this] = ACTIONS(3391),
    [anon_sym_scoped] = ACTIONS(3391),
    [anon_sym_base] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [sym_predefined_type] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_unchecked] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_lock] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_when] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_foreach] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_DOT_DOT] = ACTIONS(3393),
    [anon_sym_from] = ACTIONS(3391),
    [anon_sym_into] = ACTIONS(3391),
    [anon_sym_join] = ACTIONS(3391),
    [anon_sym_on] = ACTIONS(3391),
    [anon_sym_equals] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_orderby] = ACTIONS(3391),
    [anon_sym_ascending] = ACTIONS(3391),
    [anon_sym_descending] = ACTIONS(3391),
    [anon_sym_group] = ACTIONS(3391),
    [anon_sym_by] = ACTIONS(3391),
    [anon_sym_select] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3391),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym___makeref] = ACTIONS(3391),
    [anon_sym___reftype] = ACTIONS(3391),
    [anon_sym___refvalue] = ACTIONS(3391),
    [sym_null_literal] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [sym_integer_literal] = ACTIONS(3391),
    [sym_real_literal] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_verbatim_string_literal] = ACTIONS(3393),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_if_token3] = ACTIONS(3393),
    [aux_sym_preproc_else_token1] = ACTIONS(3393),
    [aux_sym_preproc_elif_token1] = ACTIONS(3393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3393),
    [sym_interpolation_verbatim_start] = ACTIONS(3393),
    [sym_interpolation_raw_start] = ACTIONS(3393),
    [sym_raw_string_start] = ACTIONS(3393),
  },
  [2005] = {
    [sym_preproc_region] = STATE(2005),
    [sym_preproc_endregion] = STATE(2005),
    [sym_preproc_line] = STATE(2005),
    [sym_preproc_pragma] = STATE(2005),
    [sym_preproc_nullable] = STATE(2005),
    [sym_preproc_error] = STATE(2005),
    [sym_preproc_warning] = STATE(2005),
    [sym_preproc_define] = STATE(2005),
    [sym_preproc_undef] = STATE(2005),
    [sym__identifier_token] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym_alias] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_global] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_unsafe] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_LPAREN] = ACTIONS(3397),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_ref] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_delegate] = ACTIONS(3395),
    [anon_sym_record] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_file] = ACTIONS(3395),
    [anon_sym_fixed] = ACTIONS(3395),
    [anon_sym_internal] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_partial] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_required] = ACTIONS(3395),
    [anon_sym_sealed] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_where] = ACTIONS(3395),
    [anon_sym_notnull] = ACTIONS(3395),
    [anon_sym_unmanaged] = ACTIONS(3395),
    [anon_sym_checked] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_true] = ACTIONS(3395),
    [anon_sym_false] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_CARET] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_this] = ACTIONS(3395),
    [anon_sym_scoped] = ACTIONS(3395),
    [anon_sym_base] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [sym_predefined_type] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_unchecked] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_lock] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_when] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_foreach] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_DOT_DOT] = ACTIONS(3397),
    [anon_sym_from] = ACTIONS(3395),
    [anon_sym_into] = ACTIONS(3395),
    [anon_sym_join] = ACTIONS(3395),
    [anon_sym_on] = ACTIONS(3395),
    [anon_sym_equals] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_orderby] = ACTIONS(3395),
    [anon_sym_ascending] = ACTIONS(3395),
    [anon_sym_descending] = ACTIONS(3395),
    [anon_sym_group] = ACTIONS(3395),
    [anon_sym_by] = ACTIONS(3395),
    [anon_sym_select] = ACTIONS(3395),
    [anon_sym_stackalloc] = ACTIONS(3395),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym___makeref] = ACTIONS(3395),
    [anon_sym___reftype] = ACTIONS(3395),
    [anon_sym___refvalue] = ACTIONS(3395),
    [sym_null_literal] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [sym_integer_literal] = ACTIONS(3395),
    [sym_real_literal] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_verbatim_string_literal] = ACTIONS(3397),
    [aux_sym_preproc_if_token1] = ACTIONS(3397),
    [aux_sym_preproc_if_token3] = ACTIONS(3397),
    [aux_sym_preproc_else_token1] = ACTIONS(3397),
    [aux_sym_preproc_elif_token1] = ACTIONS(3397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3397),
    [sym_interpolation_verbatim_start] = ACTIONS(3397),
    [sym_interpolation_raw_start] = ACTIONS(3397),
    [sym_raw_string_start] = ACTIONS(3397),
  },
  [2006] = {
    [sym_preproc_region] = STATE(2006),
    [sym_preproc_endregion] = STATE(2006),
    [sym_preproc_line] = STATE(2006),
    [sym_preproc_pragma] = STATE(2006),
    [sym_preproc_nullable] = STATE(2006),
    [sym_preproc_error] = STATE(2006),
    [sym_preproc_warning] = STATE(2006),
    [sym_preproc_define] = STATE(2006),
    [sym_preproc_undef] = STATE(2006),
    [sym__identifier_token] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_alias] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_global] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_unsafe] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_ref] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_delegate] = ACTIONS(3399),
    [anon_sym_record] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_file] = ACTIONS(3399),
    [anon_sym_fixed] = ACTIONS(3399),
    [anon_sym_internal] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_partial] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_required] = ACTIONS(3399),
    [anon_sym_sealed] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_where] = ACTIONS(3399),
    [anon_sym_notnull] = ACTIONS(3399),
    [anon_sym_unmanaged] = ACTIONS(3399),
    [anon_sym_checked] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_true] = ACTIONS(3399),
    [anon_sym_false] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_CARET] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_this] = ACTIONS(3399),
    [anon_sym_scoped] = ACTIONS(3399),
    [anon_sym_base] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [sym_predefined_type] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_unchecked] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_lock] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_when] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_foreach] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_DOT_DOT] = ACTIONS(3401),
    [anon_sym_from] = ACTIONS(3399),
    [anon_sym_into] = ACTIONS(3399),
    [anon_sym_join] = ACTIONS(3399),
    [anon_sym_on] = ACTIONS(3399),
    [anon_sym_equals] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_orderby] = ACTIONS(3399),
    [anon_sym_ascending] = ACTIONS(3399),
    [anon_sym_descending] = ACTIONS(3399),
    [anon_sym_group] = ACTIONS(3399),
    [anon_sym_by] = ACTIONS(3399),
    [anon_sym_select] = ACTIONS(3399),
    [anon_sym_stackalloc] = ACTIONS(3399),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym___makeref] = ACTIONS(3399),
    [anon_sym___reftype] = ACTIONS(3399),
    [anon_sym___refvalue] = ACTIONS(3399),
    [sym_null_literal] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [sym_integer_literal] = ACTIONS(3399),
    [sym_real_literal] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_verbatim_string_literal] = ACTIONS(3401),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_if_token3] = ACTIONS(3401),
    [aux_sym_preproc_else_token1] = ACTIONS(3401),
    [aux_sym_preproc_elif_token1] = ACTIONS(3401),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3401),
    [sym_interpolation_verbatim_start] = ACTIONS(3401),
    [sym_interpolation_raw_start] = ACTIONS(3401),
    [sym_raw_string_start] = ACTIONS(3401),
  },
  [2007] = {
    [sym_preproc_region] = STATE(2007),
    [sym_preproc_endregion] = STATE(2007),
    [sym_preproc_line] = STATE(2007),
    [sym_preproc_pragma] = STATE(2007),
    [sym_preproc_nullable] = STATE(2007),
    [sym_preproc_error] = STATE(2007),
    [sym_preproc_warning] = STATE(2007),
    [sym_preproc_define] = STATE(2007),
    [sym_preproc_undef] = STATE(2007),
    [sym__identifier_token] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym_alias] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_global] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_unsafe] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_ref] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_delegate] = ACTIONS(3403),
    [anon_sym_record] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_file] = ACTIONS(3403),
    [anon_sym_fixed] = ACTIONS(3403),
    [anon_sym_internal] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_partial] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_required] = ACTIONS(3403),
    [anon_sym_sealed] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_where] = ACTIONS(3403),
    [anon_sym_notnull] = ACTIONS(3403),
    [anon_sym_unmanaged] = ACTIONS(3403),
    [anon_sym_checked] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_true] = ACTIONS(3403),
    [anon_sym_false] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_CARET] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_this] = ACTIONS(3403),
    [anon_sym_scoped] = ACTIONS(3403),
    [anon_sym_base] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [sym_predefined_type] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_unchecked] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_lock] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_when] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_foreach] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_DOT_DOT] = ACTIONS(3405),
    [anon_sym_from] = ACTIONS(3403),
    [anon_sym_into] = ACTIONS(3403),
    [anon_sym_join] = ACTIONS(3403),
    [anon_sym_on] = ACTIONS(3403),
    [anon_sym_equals] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_orderby] = ACTIONS(3403),
    [anon_sym_ascending] = ACTIONS(3403),
    [anon_sym_descending] = ACTIONS(3403),
    [anon_sym_group] = ACTIONS(3403),
    [anon_sym_by] = ACTIONS(3403),
    [anon_sym_select] = ACTIONS(3403),
    [anon_sym_stackalloc] = ACTIONS(3403),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym___makeref] = ACTIONS(3403),
    [anon_sym___reftype] = ACTIONS(3403),
    [anon_sym___refvalue] = ACTIONS(3403),
    [sym_null_literal] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [sym_integer_literal] = ACTIONS(3403),
    [sym_real_literal] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_verbatim_string_literal] = ACTIONS(3405),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_if_token3] = ACTIONS(3405),
    [aux_sym_preproc_else_token1] = ACTIONS(3405),
    [aux_sym_preproc_elif_token1] = ACTIONS(3405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3405),
    [sym_interpolation_verbatim_start] = ACTIONS(3405),
    [sym_interpolation_raw_start] = ACTIONS(3405),
    [sym_raw_string_start] = ACTIONS(3405),
  },
  [2008] = {
    [sym_preproc_region] = STATE(2008),
    [sym_preproc_endregion] = STATE(2008),
    [sym_preproc_line] = STATE(2008),
    [sym_preproc_pragma] = STATE(2008),
    [sym_preproc_nullable] = STATE(2008),
    [sym_preproc_error] = STATE(2008),
    [sym_preproc_warning] = STATE(2008),
    [sym_preproc_define] = STATE(2008),
    [sym_preproc_undef] = STATE(2008),
    [sym__identifier_token] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym_alias] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym_global] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_ref] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_delegate] = ACTIONS(3407),
    [anon_sym_record] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_file] = ACTIONS(3407),
    [anon_sym_fixed] = ACTIONS(3407),
    [anon_sym_internal] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_partial] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_required] = ACTIONS(3407),
    [anon_sym_sealed] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_where] = ACTIONS(3407),
    [anon_sym_notnull] = ACTIONS(3407),
    [anon_sym_unmanaged] = ACTIONS(3407),
    [anon_sym_checked] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_true] = ACTIONS(3407),
    [anon_sym_false] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_CARET] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_this] = ACTIONS(3407),
    [anon_sym_scoped] = ACTIONS(3407),
    [anon_sym_base] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [sym_predefined_type] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_unchecked] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_lock] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_when] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_foreach] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_DOT_DOT] = ACTIONS(3409),
    [anon_sym_from] = ACTIONS(3407),
    [anon_sym_into] = ACTIONS(3407),
    [anon_sym_join] = ACTIONS(3407),
    [anon_sym_on] = ACTIONS(3407),
    [anon_sym_equals] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_orderby] = ACTIONS(3407),
    [anon_sym_ascending] = ACTIONS(3407),
    [anon_sym_descending] = ACTIONS(3407),
    [anon_sym_group] = ACTIONS(3407),
    [anon_sym_by] = ACTIONS(3407),
    [anon_sym_select] = ACTIONS(3407),
    [anon_sym_stackalloc] = ACTIONS(3407),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym___makeref] = ACTIONS(3407),
    [anon_sym___reftype] = ACTIONS(3407),
    [anon_sym___refvalue] = ACTIONS(3407),
    [sym_null_literal] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [sym_integer_literal] = ACTIONS(3407),
    [sym_real_literal] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_verbatim_string_literal] = ACTIONS(3409),
    [aux_sym_preproc_if_token1] = ACTIONS(3409),
    [aux_sym_preproc_if_token3] = ACTIONS(3409),
    [aux_sym_preproc_else_token1] = ACTIONS(3409),
    [aux_sym_preproc_elif_token1] = ACTIONS(3409),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3409),
    [sym_interpolation_verbatim_start] = ACTIONS(3409),
    [sym_interpolation_raw_start] = ACTIONS(3409),
    [sym_raw_string_start] = ACTIONS(3409),
  },
  [2009] = {
    [sym_preproc_region] = STATE(2009),
    [sym_preproc_endregion] = STATE(2009),
    [sym_preproc_line] = STATE(2009),
    [sym_preproc_pragma] = STATE(2009),
    [sym_preproc_nullable] = STATE(2009),
    [sym_preproc_error] = STATE(2009),
    [sym_preproc_warning] = STATE(2009),
    [sym_preproc_define] = STATE(2009),
    [sym_preproc_undef] = STATE(2009),
    [sym__identifier_token] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_alias] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_global] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_unsafe] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_ref] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_delegate] = ACTIONS(3411),
    [anon_sym_record] = ACTIONS(3411),
    [anon_sym_abstract] = ACTIONS(3411),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_file] = ACTIONS(3411),
    [anon_sym_fixed] = ACTIONS(3411),
    [anon_sym_internal] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_override] = ACTIONS(3411),
    [anon_sym_partial] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_readonly] = ACTIONS(3411),
    [anon_sym_required] = ACTIONS(3411),
    [anon_sym_sealed] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_where] = ACTIONS(3411),
    [anon_sym_notnull] = ACTIONS(3411),
    [anon_sym_unmanaged] = ACTIONS(3411),
    [anon_sym_checked] = ACTIONS(3411),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_true] = ACTIONS(3411),
    [anon_sym_false] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_CARET] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_this] = ACTIONS(3411),
    [anon_sym_scoped] = ACTIONS(3411),
    [anon_sym_base] = ACTIONS(3411),
    [anon_sym_var] = ACTIONS(3411),
    [sym_predefined_type] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_unchecked] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_lock] = ACTIONS(3411),
    [anon_sym_yield] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_when] = ACTIONS(3411),
    [anon_sym_await] = ACTIONS(3411),
    [anon_sym_foreach] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_DOT_DOT] = ACTIONS(3413),
    [anon_sym_from] = ACTIONS(3411),
    [anon_sym_into] = ACTIONS(3411),
    [anon_sym_join] = ACTIONS(3411),
    [anon_sym_on] = ACTIONS(3411),
    [anon_sym_equals] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_orderby] = ACTIONS(3411),
    [anon_sym_ascending] = ACTIONS(3411),
    [anon_sym_descending] = ACTIONS(3411),
    [anon_sym_group] = ACTIONS(3411),
    [anon_sym_by] = ACTIONS(3411),
    [anon_sym_select] = ACTIONS(3411),
    [anon_sym_stackalloc] = ACTIONS(3411),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym_typeof] = ACTIONS(3411),
    [anon_sym___makeref] = ACTIONS(3411),
    [anon_sym___reftype] = ACTIONS(3411),
    [anon_sym___refvalue] = ACTIONS(3411),
    [sym_null_literal] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [sym_integer_literal] = ACTIONS(3411),
    [sym_real_literal] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_verbatim_string_literal] = ACTIONS(3413),
    [aux_sym_preproc_if_token1] = ACTIONS(3413),
    [aux_sym_preproc_if_token3] = ACTIONS(3413),
    [aux_sym_preproc_else_token1] = ACTIONS(3413),
    [aux_sym_preproc_elif_token1] = ACTIONS(3413),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3413),
    [sym_interpolation_verbatim_start] = ACTIONS(3413),
    [sym_interpolation_raw_start] = ACTIONS(3413),
    [sym_raw_string_start] = ACTIONS(3413),
  },
  [2010] = {
    [sym_preproc_region] = STATE(2010),
    [sym_preproc_endregion] = STATE(2010),
    [sym_preproc_line] = STATE(2010),
    [sym_preproc_pragma] = STATE(2010),
    [sym_preproc_nullable] = STATE(2010),
    [sym_preproc_error] = STATE(2010),
    [sym_preproc_warning] = STATE(2010),
    [sym_preproc_define] = STATE(2010),
    [sym_preproc_undef] = STATE(2010),
    [sym__identifier_token] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_alias] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_global] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_unsafe] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_ref] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3415),
    [anon_sym_record] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_file] = ACTIONS(3415),
    [anon_sym_fixed] = ACTIONS(3415),
    [anon_sym_internal] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_partial] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_required] = ACTIONS(3415),
    [anon_sym_sealed] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_notnull] = ACTIONS(3415),
    [anon_sym_unmanaged] = ACTIONS(3415),
    [anon_sym_checked] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_true] = ACTIONS(3415),
    [anon_sym_false] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_CARET] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_this] = ACTIONS(3415),
    [anon_sym_scoped] = ACTIONS(3415),
    [anon_sym_base] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [sym_predefined_type] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_unchecked] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_lock] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_foreach] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_DOT_DOT] = ACTIONS(3417),
    [anon_sym_from] = ACTIONS(3415),
    [anon_sym_into] = ACTIONS(3415),
    [anon_sym_join] = ACTIONS(3415),
    [anon_sym_on] = ACTIONS(3415),
    [anon_sym_equals] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_orderby] = ACTIONS(3415),
    [anon_sym_ascending] = ACTIONS(3415),
    [anon_sym_descending] = ACTIONS(3415),
    [anon_sym_group] = ACTIONS(3415),
    [anon_sym_by] = ACTIONS(3415),
    [anon_sym_select] = ACTIONS(3415),
    [anon_sym_stackalloc] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym___makeref] = ACTIONS(3415),
    [anon_sym___reftype] = ACTIONS(3415),
    [anon_sym___refvalue] = ACTIONS(3415),
    [sym_null_literal] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [sym_integer_literal] = ACTIONS(3415),
    [sym_real_literal] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_verbatim_string_literal] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token3] = ACTIONS(3417),
    [aux_sym_preproc_else_token1] = ACTIONS(3417),
    [aux_sym_preproc_elif_token1] = ACTIONS(3417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3417),
    [sym_interpolation_verbatim_start] = ACTIONS(3417),
    [sym_interpolation_raw_start] = ACTIONS(3417),
    [sym_raw_string_start] = ACTIONS(3417),
  },
  [2011] = {
    [sym_preproc_region] = STATE(2011),
    [sym_preproc_endregion] = STATE(2011),
    [sym_preproc_line] = STATE(2011),
    [sym_preproc_pragma] = STATE(2011),
    [sym_preproc_nullable] = STATE(2011),
    [sym_preproc_error] = STATE(2011),
    [sym_preproc_warning] = STATE(2011),
    [sym_preproc_define] = STATE(2011),
    [sym_preproc_undef] = STATE(2011),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_struct] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_record] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_base] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_if_token3] = ACTIONS(3317),
    [aux_sym_preproc_else_token1] = ACTIONS(3317),
    [aux_sym_preproc_elif_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
    [sym_raw_string_start] = ACTIONS(3317),
  },
  [2012] = {
    [sym_preproc_region] = STATE(2012),
    [sym_preproc_endregion] = STATE(2012),
    [sym_preproc_line] = STATE(2012),
    [sym_preproc_pragma] = STATE(2012),
    [sym_preproc_nullable] = STATE(2012),
    [sym_preproc_error] = STATE(2012),
    [sym_preproc_warning] = STATE(2012),
    [sym_preproc_define] = STATE(2012),
    [sym_preproc_undef] = STATE(2012),
    [sym__identifier_token] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym_alias] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_global] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_unsafe] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_ref] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_delegate] = ACTIONS(3419),
    [anon_sym_record] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_file] = ACTIONS(3419),
    [anon_sym_fixed] = ACTIONS(3419),
    [anon_sym_internal] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_partial] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_sealed] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_notnull] = ACTIONS(3419),
    [anon_sym_unmanaged] = ACTIONS(3419),
    [anon_sym_checked] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_true] = ACTIONS(3419),
    [anon_sym_false] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_this] = ACTIONS(3419),
    [anon_sym_scoped] = ACTIONS(3419),
    [anon_sym_base] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [sym_predefined_type] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_unchecked] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_lock] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_when] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_foreach] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_DOT_DOT] = ACTIONS(3421),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_into] = ACTIONS(3419),
    [anon_sym_join] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_equals] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_orderby] = ACTIONS(3419),
    [anon_sym_ascending] = ACTIONS(3419),
    [anon_sym_descending] = ACTIONS(3419),
    [anon_sym_group] = ACTIONS(3419),
    [anon_sym_by] = ACTIONS(3419),
    [anon_sym_select] = ACTIONS(3419),
    [anon_sym_stackalloc] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym___makeref] = ACTIONS(3419),
    [anon_sym___reftype] = ACTIONS(3419),
    [anon_sym___refvalue] = ACTIONS(3419),
    [sym_null_literal] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [sym_integer_literal] = ACTIONS(3419),
    [sym_real_literal] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_verbatim_string_literal] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token3] = ACTIONS(3421),
    [aux_sym_preproc_else_token1] = ACTIONS(3421),
    [aux_sym_preproc_elif_token1] = ACTIONS(3421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3421),
    [sym_interpolation_verbatim_start] = ACTIONS(3421),
    [sym_interpolation_raw_start] = ACTIONS(3421),
    [sym_raw_string_start] = ACTIONS(3421),
  },
  [2013] = {
    [sym_preproc_region] = STATE(2013),
    [sym_preproc_endregion] = STATE(2013),
    [sym_preproc_line] = STATE(2013),
    [sym_preproc_pragma] = STATE(2013),
    [sym_preproc_nullable] = STATE(2013),
    [sym_preproc_error] = STATE(2013),
    [sym_preproc_warning] = STATE(2013),
    [sym_preproc_define] = STATE(2013),
    [sym_preproc_undef] = STATE(2013),
    [sym__identifier_token] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym_alias] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_global] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_unsafe] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_ref] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_delegate] = ACTIONS(3423),
    [anon_sym_record] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_file] = ACTIONS(3423),
    [anon_sym_fixed] = ACTIONS(3423),
    [anon_sym_internal] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_partial] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_required] = ACTIONS(3423),
    [anon_sym_sealed] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_where] = ACTIONS(3423),
    [anon_sym_notnull] = ACTIONS(3423),
    [anon_sym_unmanaged] = ACTIONS(3423),
    [anon_sym_checked] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_true] = ACTIONS(3423),
    [anon_sym_false] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_this] = ACTIONS(3423),
    [anon_sym_scoped] = ACTIONS(3423),
    [anon_sym_base] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [sym_predefined_type] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_unchecked] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_lock] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_when] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_foreach] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_DOT_DOT] = ACTIONS(3425),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_into] = ACTIONS(3423),
    [anon_sym_join] = ACTIONS(3423),
    [anon_sym_on] = ACTIONS(3423),
    [anon_sym_equals] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_orderby] = ACTIONS(3423),
    [anon_sym_ascending] = ACTIONS(3423),
    [anon_sym_descending] = ACTIONS(3423),
    [anon_sym_group] = ACTIONS(3423),
    [anon_sym_by] = ACTIONS(3423),
    [anon_sym_select] = ACTIONS(3423),
    [anon_sym_stackalloc] = ACTIONS(3423),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym___makeref] = ACTIONS(3423),
    [anon_sym___reftype] = ACTIONS(3423),
    [anon_sym___refvalue] = ACTIONS(3423),
    [sym_null_literal] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [sym_integer_literal] = ACTIONS(3423),
    [sym_real_literal] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_verbatim_string_literal] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token3] = ACTIONS(3425),
    [aux_sym_preproc_else_token1] = ACTIONS(3425),
    [aux_sym_preproc_elif_token1] = ACTIONS(3425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3425),
    [sym_interpolation_verbatim_start] = ACTIONS(3425),
    [sym_interpolation_raw_start] = ACTIONS(3425),
    [sym_raw_string_start] = ACTIONS(3425),
  },
  [2014] = {
    [sym_preproc_region] = STATE(2014),
    [sym_preproc_endregion] = STATE(2014),
    [sym_preproc_line] = STATE(2014),
    [sym_preproc_pragma] = STATE(2014),
    [sym_preproc_nullable] = STATE(2014),
    [sym_preproc_error] = STATE(2014),
    [sym_preproc_warning] = STATE(2014),
    [sym_preproc_define] = STATE(2014),
    [sym_preproc_undef] = STATE(2014),
    [sym__identifier_token] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym_alias] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_global] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_unsafe] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_ref] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_delegate] = ACTIONS(3427),
    [anon_sym_record] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_file] = ACTIONS(3427),
    [anon_sym_fixed] = ACTIONS(3427),
    [anon_sym_internal] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_partial] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_required] = ACTIONS(3427),
    [anon_sym_sealed] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_where] = ACTIONS(3427),
    [anon_sym_notnull] = ACTIONS(3427),
    [anon_sym_unmanaged] = ACTIONS(3427),
    [anon_sym_checked] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_true] = ACTIONS(3427),
    [anon_sym_false] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_CARET] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_this] = ACTIONS(3427),
    [anon_sym_scoped] = ACTIONS(3427),
    [anon_sym_base] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [sym_predefined_type] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_unchecked] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_lock] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_foreach] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_DOT_DOT] = ACTIONS(3429),
    [anon_sym_from] = ACTIONS(3427),
    [anon_sym_into] = ACTIONS(3427),
    [anon_sym_join] = ACTIONS(3427),
    [anon_sym_on] = ACTIONS(3427),
    [anon_sym_equals] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_orderby] = ACTIONS(3427),
    [anon_sym_ascending] = ACTIONS(3427),
    [anon_sym_descending] = ACTIONS(3427),
    [anon_sym_group] = ACTIONS(3427),
    [anon_sym_by] = ACTIONS(3427),
    [anon_sym_select] = ACTIONS(3427),
    [anon_sym_stackalloc] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym___makeref] = ACTIONS(3427),
    [anon_sym___reftype] = ACTIONS(3427),
    [anon_sym___refvalue] = ACTIONS(3427),
    [sym_null_literal] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [sym_integer_literal] = ACTIONS(3427),
    [sym_real_literal] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_verbatim_string_literal] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token3] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3429),
    [sym_interpolation_verbatim_start] = ACTIONS(3429),
    [sym_interpolation_raw_start] = ACTIONS(3429),
    [sym_raw_string_start] = ACTIONS(3429),
  },
  [2015] = {
    [sym_preproc_region] = STATE(2015),
    [sym_preproc_endregion] = STATE(2015),
    [sym_preproc_line] = STATE(2015),
    [sym_preproc_pragma] = STATE(2015),
    [sym_preproc_nullable] = STATE(2015),
    [sym_preproc_error] = STATE(2015),
    [sym_preproc_warning] = STATE(2015),
    [sym_preproc_define] = STATE(2015),
    [sym_preproc_undef] = STATE(2015),
    [sym__identifier_token] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym_alias] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_global] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_unsafe] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_ref] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_delegate] = ACTIONS(3431),
    [anon_sym_record] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_file] = ACTIONS(3431),
    [anon_sym_fixed] = ACTIONS(3431),
    [anon_sym_internal] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_partial] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_required] = ACTIONS(3431),
    [anon_sym_sealed] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_where] = ACTIONS(3431),
    [anon_sym_notnull] = ACTIONS(3431),
    [anon_sym_unmanaged] = ACTIONS(3431),
    [anon_sym_checked] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_true] = ACTIONS(3431),
    [anon_sym_false] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_this] = ACTIONS(3431),
    [anon_sym_scoped] = ACTIONS(3431),
    [anon_sym_base] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [sym_predefined_type] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_unchecked] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_lock] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_when] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_foreach] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_DOT_DOT] = ACTIONS(3433),
    [anon_sym_from] = ACTIONS(3431),
    [anon_sym_into] = ACTIONS(3431),
    [anon_sym_join] = ACTIONS(3431),
    [anon_sym_on] = ACTIONS(3431),
    [anon_sym_equals] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_orderby] = ACTIONS(3431),
    [anon_sym_ascending] = ACTIONS(3431),
    [anon_sym_descending] = ACTIONS(3431),
    [anon_sym_group] = ACTIONS(3431),
    [anon_sym_by] = ACTIONS(3431),
    [anon_sym_select] = ACTIONS(3431),
    [anon_sym_stackalloc] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym___makeref] = ACTIONS(3431),
    [anon_sym___reftype] = ACTIONS(3431),
    [anon_sym___refvalue] = ACTIONS(3431),
    [sym_null_literal] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [sym_integer_literal] = ACTIONS(3431),
    [sym_real_literal] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_verbatim_string_literal] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token3] = ACTIONS(3433),
    [aux_sym_preproc_else_token1] = ACTIONS(3433),
    [aux_sym_preproc_elif_token1] = ACTIONS(3433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3433),
    [sym_interpolation_verbatim_start] = ACTIONS(3433),
    [sym_interpolation_raw_start] = ACTIONS(3433),
    [sym_raw_string_start] = ACTIONS(3433),
  },
  [2016] = {
    [sym_preproc_region] = STATE(2016),
    [sym_preproc_endregion] = STATE(2016),
    [sym_preproc_line] = STATE(2016),
    [sym_preproc_pragma] = STATE(2016),
    [sym_preproc_nullable] = STATE(2016),
    [sym_preproc_error] = STATE(2016),
    [sym_preproc_warning] = STATE(2016),
    [sym_preproc_define] = STATE(2016),
    [sym_preproc_undef] = STATE(2016),
    [sym__identifier_token] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym_alias] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_global] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_unsafe] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_ref] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_delegate] = ACTIONS(3435),
    [anon_sym_record] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_file] = ACTIONS(3435),
    [anon_sym_fixed] = ACTIONS(3435),
    [anon_sym_internal] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_partial] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_required] = ACTIONS(3435),
    [anon_sym_sealed] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_where] = ACTIONS(3435),
    [anon_sym_notnull] = ACTIONS(3435),
    [anon_sym_unmanaged] = ACTIONS(3435),
    [anon_sym_checked] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3435),
    [anon_sym_false] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_this] = ACTIONS(3435),
    [anon_sym_scoped] = ACTIONS(3435),
    [anon_sym_base] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [sym_predefined_type] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_unchecked] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_lock] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_when] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_foreach] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_DOT_DOT] = ACTIONS(3437),
    [anon_sym_from] = ACTIONS(3435),
    [anon_sym_into] = ACTIONS(3435),
    [anon_sym_join] = ACTIONS(3435),
    [anon_sym_on] = ACTIONS(3435),
    [anon_sym_equals] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_orderby] = ACTIONS(3435),
    [anon_sym_ascending] = ACTIONS(3435),
    [anon_sym_descending] = ACTIONS(3435),
    [anon_sym_group] = ACTIONS(3435),
    [anon_sym_by] = ACTIONS(3435),
    [anon_sym_select] = ACTIONS(3435),
    [anon_sym_stackalloc] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym___makeref] = ACTIONS(3435),
    [anon_sym___reftype] = ACTIONS(3435),
    [anon_sym___refvalue] = ACTIONS(3435),
    [sym_null_literal] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [sym_integer_literal] = ACTIONS(3435),
    [sym_real_literal] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_verbatim_string_literal] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token3] = ACTIONS(3437),
    [aux_sym_preproc_else_token1] = ACTIONS(3437),
    [aux_sym_preproc_elif_token1] = ACTIONS(3437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3437),
    [sym_interpolation_verbatim_start] = ACTIONS(3437),
    [sym_interpolation_raw_start] = ACTIONS(3437),
    [sym_raw_string_start] = ACTIONS(3437),
  },
  [2017] = {
    [sym_preproc_region] = STATE(2017),
    [sym_preproc_endregion] = STATE(2017),
    [sym_preproc_line] = STATE(2017),
    [sym_preproc_pragma] = STATE(2017),
    [sym_preproc_nullable] = STATE(2017),
    [sym_preproc_error] = STATE(2017),
    [sym_preproc_warning] = STATE(2017),
    [sym_preproc_define] = STATE(2017),
    [sym_preproc_undef] = STATE(2017),
    [sym__identifier_token] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym_alias] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_global] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_unsafe] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_ref] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_delegate] = ACTIONS(3439),
    [anon_sym_record] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_file] = ACTIONS(3439),
    [anon_sym_fixed] = ACTIONS(3439),
    [anon_sym_internal] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_partial] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_required] = ACTIONS(3439),
    [anon_sym_sealed] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_where] = ACTIONS(3439),
    [anon_sym_notnull] = ACTIONS(3439),
    [anon_sym_unmanaged] = ACTIONS(3439),
    [anon_sym_checked] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_true] = ACTIONS(3439),
    [anon_sym_false] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_this] = ACTIONS(3439),
    [anon_sym_scoped] = ACTIONS(3439),
    [anon_sym_base] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [sym_predefined_type] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_unchecked] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_lock] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_when] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_foreach] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_DOT_DOT] = ACTIONS(3441),
    [anon_sym_from] = ACTIONS(3439),
    [anon_sym_into] = ACTIONS(3439),
    [anon_sym_join] = ACTIONS(3439),
    [anon_sym_on] = ACTIONS(3439),
    [anon_sym_equals] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_orderby] = ACTIONS(3439),
    [anon_sym_ascending] = ACTIONS(3439),
    [anon_sym_descending] = ACTIONS(3439),
    [anon_sym_group] = ACTIONS(3439),
    [anon_sym_by] = ACTIONS(3439),
    [anon_sym_select] = ACTIONS(3439),
    [anon_sym_stackalloc] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym___makeref] = ACTIONS(3439),
    [anon_sym___reftype] = ACTIONS(3439),
    [anon_sym___refvalue] = ACTIONS(3439),
    [sym_null_literal] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [sym_integer_literal] = ACTIONS(3439),
    [sym_real_literal] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_verbatim_string_literal] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token3] = ACTIONS(3441),
    [aux_sym_preproc_else_token1] = ACTIONS(3441),
    [aux_sym_preproc_elif_token1] = ACTIONS(3441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3441),
    [sym_interpolation_verbatim_start] = ACTIONS(3441),
    [sym_interpolation_raw_start] = ACTIONS(3441),
    [sym_raw_string_start] = ACTIONS(3441),
  },
  [2018] = {
    [sym_preproc_region] = STATE(2018),
    [sym_preproc_endregion] = STATE(2018),
    [sym_preproc_line] = STATE(2018),
    [sym_preproc_pragma] = STATE(2018),
    [sym_preproc_nullable] = STATE(2018),
    [sym_preproc_error] = STATE(2018),
    [sym_preproc_warning] = STATE(2018),
    [sym_preproc_define] = STATE(2018),
    [sym_preproc_undef] = STATE(2018),
    [sym__identifier_token] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym_alias] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_global] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_unsafe] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_ref] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_delegate] = ACTIONS(3443),
    [anon_sym_record] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_file] = ACTIONS(3443),
    [anon_sym_fixed] = ACTIONS(3443),
    [anon_sym_internal] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_partial] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_required] = ACTIONS(3443),
    [anon_sym_sealed] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_where] = ACTIONS(3443),
    [anon_sym_notnull] = ACTIONS(3443),
    [anon_sym_unmanaged] = ACTIONS(3443),
    [anon_sym_checked] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_true] = ACTIONS(3443),
    [anon_sym_false] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_CARET] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_this] = ACTIONS(3443),
    [anon_sym_scoped] = ACTIONS(3443),
    [anon_sym_base] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [sym_predefined_type] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_unchecked] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_lock] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_when] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_foreach] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_DOT_DOT] = ACTIONS(3445),
    [anon_sym_from] = ACTIONS(3443),
    [anon_sym_into] = ACTIONS(3443),
    [anon_sym_join] = ACTIONS(3443),
    [anon_sym_on] = ACTIONS(3443),
    [anon_sym_equals] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_orderby] = ACTIONS(3443),
    [anon_sym_ascending] = ACTIONS(3443),
    [anon_sym_descending] = ACTIONS(3443),
    [anon_sym_group] = ACTIONS(3443),
    [anon_sym_by] = ACTIONS(3443),
    [anon_sym_select] = ACTIONS(3443),
    [anon_sym_stackalloc] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym___makeref] = ACTIONS(3443),
    [anon_sym___reftype] = ACTIONS(3443),
    [anon_sym___refvalue] = ACTIONS(3443),
    [sym_null_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [sym_integer_literal] = ACTIONS(3443),
    [sym_real_literal] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_verbatim_string_literal] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token3] = ACTIONS(3445),
    [aux_sym_preproc_else_token1] = ACTIONS(3445),
    [aux_sym_preproc_elif_token1] = ACTIONS(3445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3445),
    [sym_interpolation_verbatim_start] = ACTIONS(3445),
    [sym_interpolation_raw_start] = ACTIONS(3445),
    [sym_raw_string_start] = ACTIONS(3445),
  },
  [2019] = {
    [sym_preproc_region] = STATE(2019),
    [sym_preproc_endregion] = STATE(2019),
    [sym_preproc_line] = STATE(2019),
    [sym_preproc_pragma] = STATE(2019),
    [sym_preproc_nullable] = STATE(2019),
    [sym_preproc_error] = STATE(2019),
    [sym_preproc_warning] = STATE(2019),
    [sym_preproc_define] = STATE(2019),
    [sym_preproc_undef] = STATE(2019),
    [ts_builtin_sym_end] = ACTIONS(3317),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_struct] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_record] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_base] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
    [sym_raw_string_start] = ACTIONS(3317),
  },
  [2020] = {
    [sym_preproc_region] = STATE(2020),
    [sym_preproc_endregion] = STATE(2020),
    [sym_preproc_line] = STATE(2020),
    [sym_preproc_pragma] = STATE(2020),
    [sym_preproc_nullable] = STATE(2020),
    [sym_preproc_error] = STATE(2020),
    [sym_preproc_warning] = STATE(2020),
    [sym_preproc_define] = STATE(2020),
    [sym_preproc_undef] = STATE(2020),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym__identifier_token] = ACTIONS(3189),
    [anon_sym_extern] = ACTIONS(3189),
    [anon_sym_alias] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_using] = ACTIONS(3189),
    [anon_sym_unsafe] = ACTIONS(3189),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_namespace] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_struct] = ACTIONS(3189),
    [anon_sym_enum] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3189),
    [anon_sym_delegate] = ACTIONS(3189),
    [anon_sym_record] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_file] = ACTIONS(3189),
    [anon_sym_fixed] = ACTIONS(3189),
    [anon_sym_internal] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_override] = ACTIONS(3189),
    [anon_sym_partial] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_readonly] = ACTIONS(3189),
    [anon_sym_required] = ACTIONS(3189),
    [anon_sym_sealed] = ACTIONS(3189),
    [anon_sym_virtual] = ACTIONS(3189),
    [anon_sym_volatile] = ACTIONS(3189),
    [anon_sym_where] = ACTIONS(3189),
    [anon_sym_notnull] = ACTIONS(3189),
    [anon_sym_unmanaged] = ACTIONS(3189),
    [anon_sym_checked] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_true] = ACTIONS(3189),
    [anon_sym_false] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3191),
    [anon_sym_CARET] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3191),
    [anon_sym_this] = ACTIONS(3189),
    [anon_sym_scoped] = ACTIONS(3189),
    [anon_sym_base] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [sym_predefined_type] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_unchecked] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_when] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_into] = ACTIONS(3189),
    [anon_sym_join] = ACTIONS(3189),
    [anon_sym_on] = ACTIONS(3189),
    [anon_sym_equals] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_orderby] = ACTIONS(3189),
    [anon_sym_ascending] = ACTIONS(3189),
    [anon_sym_descending] = ACTIONS(3189),
    [anon_sym_group] = ACTIONS(3189),
    [anon_sym_by] = ACTIONS(3189),
    [anon_sym_select] = ACTIONS(3189),
    [anon_sym_stackalloc] = ACTIONS(3189),
    [anon_sym_sizeof] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym___makeref] = ACTIONS(3189),
    [anon_sym___reftype] = ACTIONS(3189),
    [anon_sym___refvalue] = ACTIONS(3189),
    [sym_null_literal] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_integer_literal] = ACTIONS(3189),
    [sym_real_literal] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [sym_verbatim_string_literal] = ACTIONS(3191),
    [aux_sym_preproc_if_token1] = ACTIONS(3191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3191),
    [sym_interpolation_verbatim_start] = ACTIONS(3191),
    [sym_interpolation_raw_start] = ACTIONS(3191),
    [sym_raw_string_start] = ACTIONS(3191),
  },
  [2021] = {
    [sym_preproc_region] = STATE(2021),
    [sym_preproc_endregion] = STATE(2021),
    [sym_preproc_line] = STATE(2021),
    [sym_preproc_pragma] = STATE(2021),
    [sym_preproc_nullable] = STATE(2021),
    [sym_preproc_error] = STATE(2021),
    [sym_preproc_warning] = STATE(2021),
    [sym_preproc_define] = STATE(2021),
    [sym_preproc_undef] = STATE(2021),
    [ts_builtin_sym_end] = ACTIONS(3313),
    [sym__identifier_token] = ACTIONS(3311),
    [anon_sym_extern] = ACTIONS(3311),
    [anon_sym_alias] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_global] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_unsafe] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_ref] = ACTIONS(3311),
    [anon_sym_struct] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_delegate] = ACTIONS(3311),
    [anon_sym_record] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_file] = ACTIONS(3311),
    [anon_sym_fixed] = ACTIONS(3311),
    [anon_sym_internal] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_partial] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_required] = ACTIONS(3311),
    [anon_sym_sealed] = ACTIONS(3311),
    [anon_sym_virtual] = ACTIONS(3311),
    [anon_sym_volatile] = ACTIONS(3311),
    [anon_sym_where] = ACTIONS(3311),
    [anon_sym_notnull] = ACTIONS(3311),
    [anon_sym_unmanaged] = ACTIONS(3311),
    [anon_sym_checked] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(3311),
    [anon_sym_false] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_this] = ACTIONS(3311),
    [anon_sym_scoped] = ACTIONS(3311),
    [anon_sym_base] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [sym_predefined_type] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_unchecked] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_lock] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_when] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_foreach] = ACTIONS(3311),
    [anon_sym_goto] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_DOT_DOT] = ACTIONS(3313),
    [anon_sym_from] = ACTIONS(3311),
    [anon_sym_into] = ACTIONS(3311),
    [anon_sym_join] = ACTIONS(3311),
    [anon_sym_on] = ACTIONS(3311),
    [anon_sym_equals] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_orderby] = ACTIONS(3311),
    [anon_sym_ascending] = ACTIONS(3311),
    [anon_sym_descending] = ACTIONS(3311),
    [anon_sym_group] = ACTIONS(3311),
    [anon_sym_by] = ACTIONS(3311),
    [anon_sym_select] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym___makeref] = ACTIONS(3311),
    [anon_sym___reftype] = ACTIONS(3311),
    [anon_sym___refvalue] = ACTIONS(3311),
    [sym_null_literal] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [sym_integer_literal] = ACTIONS(3311),
    [sym_real_literal] = ACTIONS(3313),
    [anon_sym_DQUOTE] = ACTIONS(3313),
    [sym_verbatim_string_literal] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3313),
    [sym_interpolation_verbatim_start] = ACTIONS(3313),
    [sym_interpolation_raw_start] = ACTIONS(3313),
    [sym_raw_string_start] = ACTIONS(3313),
  },
  [2022] = {
    [sym_preproc_region] = STATE(2022),
    [sym_preproc_endregion] = STATE(2022),
    [sym_preproc_line] = STATE(2022),
    [sym_preproc_pragma] = STATE(2022),
    [sym_preproc_nullable] = STATE(2022),
    [sym_preproc_error] = STATE(2022),
    [sym_preproc_warning] = STATE(2022),
    [sym_preproc_define] = STATE(2022),
    [sym_preproc_undef] = STATE(2022),
    [ts_builtin_sym_end] = ACTIONS(3285),
    [sym__identifier_token] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_alias] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_global] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_unsafe] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_ref] = ACTIONS(3283),
    [anon_sym_struct] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_delegate] = ACTIONS(3283),
    [anon_sym_record] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_file] = ACTIONS(3283),
    [anon_sym_fixed] = ACTIONS(3283),
    [anon_sym_internal] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_partial] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_required] = ACTIONS(3283),
    [anon_sym_sealed] = ACTIONS(3283),
    [anon_sym_virtual] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym_where] = ACTIONS(3283),
    [anon_sym_notnull] = ACTIONS(3283),
    [anon_sym_unmanaged] = ACTIONS(3283),
    [anon_sym_checked] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(3283),
    [anon_sym_false] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_CARET] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_this] = ACTIONS(3283),
    [anon_sym_scoped] = ACTIONS(3283),
    [anon_sym_base] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [sym_predefined_type] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_unchecked] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_lock] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_when] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_foreach] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3285),
    [anon_sym_from] = ACTIONS(3283),
    [anon_sym_into] = ACTIONS(3283),
    [anon_sym_join] = ACTIONS(3283),
    [anon_sym_on] = ACTIONS(3283),
    [anon_sym_equals] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_orderby] = ACTIONS(3283),
    [anon_sym_ascending] = ACTIONS(3283),
    [anon_sym_descending] = ACTIONS(3283),
    [anon_sym_group] = ACTIONS(3283),
    [anon_sym_by] = ACTIONS(3283),
    [anon_sym_select] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3283),
    [anon_sym_sizeof] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym___makeref] = ACTIONS(3283),
    [anon_sym___reftype] = ACTIONS(3283),
    [anon_sym___refvalue] = ACTIONS(3283),
    [sym_null_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_integer_literal] = ACTIONS(3283),
    [sym_real_literal] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [sym_verbatim_string_literal] = ACTIONS(3285),
    [aux_sym_preproc_if_token1] = ACTIONS(3285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3285),
    [sym_interpolation_verbatim_start] = ACTIONS(3285),
    [sym_interpolation_raw_start] = ACTIONS(3285),
    [sym_raw_string_start] = ACTIONS(3285),
  },
  [2023] = {
    [sym_preproc_region] = STATE(2023),
    [sym_preproc_endregion] = STATE(2023),
    [sym_preproc_line] = STATE(2023),
    [sym_preproc_pragma] = STATE(2023),
    [sym_preproc_nullable] = STATE(2023),
    [sym_preproc_error] = STATE(2023),
    [sym_preproc_warning] = STATE(2023),
    [sym_preproc_define] = STATE(2023),
    [sym_preproc_undef] = STATE(2023),
    [ts_builtin_sym_end] = ACTIONS(3171),
    [sym__identifier_token] = ACTIONS(3169),
    [anon_sym_extern] = ACTIONS(3169),
    [anon_sym_alias] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(3171),
    [anon_sym_global] = ACTIONS(3169),
    [anon_sym_using] = ACTIONS(3169),
    [anon_sym_unsafe] = ACTIONS(3169),
    [anon_sym_static] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3169),
    [anon_sym_namespace] = ACTIONS(3169),
    [anon_sym_class] = ACTIONS(3169),
    [anon_sym_ref] = ACTIONS(3169),
    [anon_sym_struct] = ACTIONS(3169),
    [anon_sym_enum] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_interface] = ACTIONS(3169),
    [anon_sym_delegate] = ACTIONS(3169),
    [anon_sym_record] = ACTIONS(3169),
    [anon_sym_abstract] = ACTIONS(3169),
    [anon_sym_async] = ACTIONS(3169),
    [anon_sym_const] = ACTIONS(3169),
    [anon_sym_file] = ACTIONS(3169),
    [anon_sym_fixed] = ACTIONS(3169),
    [anon_sym_internal] = ACTIONS(3169),
    [anon_sym_new] = ACTIONS(3169),
    [anon_sym_override] = ACTIONS(3169),
    [anon_sym_partial] = ACTIONS(3169),
    [anon_sym_private] = ACTIONS(3169),
    [anon_sym_protected] = ACTIONS(3169),
    [anon_sym_public] = ACTIONS(3169),
    [anon_sym_readonly] = ACTIONS(3169),
    [anon_sym_required] = ACTIONS(3169),
    [anon_sym_sealed] = ACTIONS(3169),
    [anon_sym_virtual] = ACTIONS(3169),
    [anon_sym_volatile] = ACTIONS(3169),
    [anon_sym_where] = ACTIONS(3169),
    [anon_sym_notnull] = ACTIONS(3169),
    [anon_sym_unmanaged] = ACTIONS(3169),
    [anon_sym_checked] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3171),
    [anon_sym_TILDE] = ACTIONS(3171),
    [anon_sym_PLUS_PLUS] = ACTIONS(3171),
    [anon_sym_DASH_DASH] = ACTIONS(3171),
    [anon_sym_true] = ACTIONS(3169),
    [anon_sym_false] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3171),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_this] = ACTIONS(3169),
    [anon_sym_scoped] = ACTIONS(3169),
    [anon_sym_base] = ACTIONS(3169),
    [anon_sym_var] = ACTIONS(3169),
    [sym_predefined_type] = ACTIONS(3169),
    [anon_sym_break] = ACTIONS(3169),
    [anon_sym_unchecked] = ACTIONS(3169),
    [anon_sym_continue] = ACTIONS(3169),
    [anon_sym_do] = ACTIONS(3169),
    [anon_sym_while] = ACTIONS(3169),
    [anon_sym_for] = ACTIONS(3169),
    [anon_sym_lock] = ACTIONS(3169),
    [anon_sym_yield] = ACTIONS(3169),
    [anon_sym_switch] = ACTIONS(3169),
    [anon_sym_default] = ACTIONS(3169),
    [anon_sym_throw] = ACTIONS(3169),
    [anon_sym_try] = ACTIONS(3169),
    [anon_sym_when] = ACTIONS(3169),
    [anon_sym_await] = ACTIONS(3169),
    [anon_sym_foreach] = ACTIONS(3169),
    [anon_sym_goto] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_DOT_DOT] = ACTIONS(3171),
    [anon_sym_from] = ACTIONS(3169),
    [anon_sym_into] = ACTIONS(3169),
    [anon_sym_join] = ACTIONS(3169),
    [anon_sym_on] = ACTIONS(3169),
    [anon_sym_equals] = ACTIONS(3169),
    [anon_sym_let] = ACTIONS(3169),
    [anon_sym_orderby] = ACTIONS(3169),
    [anon_sym_ascending] = ACTIONS(3169),
    [anon_sym_descending] = ACTIONS(3169),
    [anon_sym_group] = ACTIONS(3169),
    [anon_sym_by] = ACTIONS(3169),
    [anon_sym_select] = ACTIONS(3169),
    [anon_sym_stackalloc] = ACTIONS(3169),
    [anon_sym_sizeof] = ACTIONS(3169),
    [anon_sym_typeof] = ACTIONS(3169),
    [anon_sym___makeref] = ACTIONS(3169),
    [anon_sym___reftype] = ACTIONS(3169),
    [anon_sym___refvalue] = ACTIONS(3169),
    [sym_null_literal] = ACTIONS(3169),
    [anon_sym_SQUOTE] = ACTIONS(3171),
    [sym_integer_literal] = ACTIONS(3169),
    [sym_real_literal] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3171),
    [sym_verbatim_string_literal] = ACTIONS(3171),
    [aux_sym_preproc_if_token1] = ACTIONS(3171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3171),
    [sym_interpolation_verbatim_start] = ACTIONS(3171),
    [sym_interpolation_raw_start] = ACTIONS(3171),
    [sym_raw_string_start] = ACTIONS(3171),
  },
  [2024] = {
    [sym_preproc_region] = STATE(2024),
    [sym_preproc_endregion] = STATE(2024),
    [sym_preproc_line] = STATE(2024),
    [sym_preproc_pragma] = STATE(2024),
    [sym_preproc_nullable] = STATE(2024),
    [sym_preproc_error] = STATE(2024),
    [sym_preproc_warning] = STATE(2024),
    [sym_preproc_define] = STATE(2024),
    [sym_preproc_undef] = STATE(2024),
    [ts_builtin_sym_end] = ACTIONS(3249),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_struct] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_record] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_checked] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_true] = ACTIONS(3247),
    [anon_sym_false] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_this] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_base] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_unchecked] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_lock] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_foreach] = ACTIONS(3247),
    [anon_sym_goto] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_DOT_DOT] = ACTIONS(3249),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3247),
    [anon_sym_sizeof] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym___makeref] = ACTIONS(3247),
    [anon_sym___reftype] = ACTIONS(3247),
    [anon_sym___refvalue] = ACTIONS(3247),
    [sym_null_literal] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_integer_literal] = ACTIONS(3247),
    [sym_real_literal] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [sym_verbatim_string_literal] = ACTIONS(3249),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3249),
    [sym_interpolation_verbatim_start] = ACTIONS(3249),
    [sym_interpolation_raw_start] = ACTIONS(3249),
    [sym_raw_string_start] = ACTIONS(3249),
  },
  [2025] = {
    [sym_preproc_region] = STATE(2025),
    [sym_preproc_endregion] = STATE(2025),
    [sym_preproc_line] = STATE(2025),
    [sym_preproc_pragma] = STATE(2025),
    [sym_preproc_nullable] = STATE(2025),
    [sym_preproc_error] = STATE(2025),
    [sym_preproc_warning] = STATE(2025),
    [sym_preproc_define] = STATE(2025),
    [sym_preproc_undef] = STATE(2025),
    [ts_builtin_sym_end] = ACTIONS(3349),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_struct] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_record] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_checked] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_true] = ACTIONS(3347),
    [anon_sym_false] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_this] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_base] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_unchecked] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_lock] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_foreach] = ACTIONS(3347),
    [anon_sym_goto] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_DOT_DOT] = ACTIONS(3349),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3347),
    [anon_sym_sizeof] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym___makeref] = ACTIONS(3347),
    [anon_sym___reftype] = ACTIONS(3347),
    [anon_sym___refvalue] = ACTIONS(3347),
    [sym_null_literal] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_integer_literal] = ACTIONS(3347),
    [sym_real_literal] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [sym_verbatim_string_literal] = ACTIONS(3349),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3349),
    [sym_interpolation_verbatim_start] = ACTIONS(3349),
    [sym_interpolation_raw_start] = ACTIONS(3349),
    [sym_raw_string_start] = ACTIONS(3349),
  },
  [2026] = {
    [sym_preproc_region] = STATE(2026),
    [sym_preproc_endregion] = STATE(2026),
    [sym_preproc_line] = STATE(2026),
    [sym_preproc_pragma] = STATE(2026),
    [sym_preproc_nullable] = STATE(2026),
    [sym_preproc_error] = STATE(2026),
    [sym_preproc_warning] = STATE(2026),
    [sym_preproc_define] = STATE(2026),
    [sym_preproc_undef] = STATE(2026),
    [ts_builtin_sym_end] = ACTIONS(3237),
    [sym__identifier_token] = ACTIONS(3235),
    [anon_sym_extern] = ACTIONS(3235),
    [anon_sym_alias] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_global] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_unsafe] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_ref] = ACTIONS(3235),
    [anon_sym_struct] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_delegate] = ACTIONS(3235),
    [anon_sym_record] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_file] = ACTIONS(3235),
    [anon_sym_fixed] = ACTIONS(3235),
    [anon_sym_internal] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_partial] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_required] = ACTIONS(3235),
    [anon_sym_sealed] = ACTIONS(3235),
    [anon_sym_virtual] = ACTIONS(3235),
    [anon_sym_volatile] = ACTIONS(3235),
    [anon_sym_where] = ACTIONS(3235),
    [anon_sym_notnull] = ACTIONS(3235),
    [anon_sym_unmanaged] = ACTIONS(3235),
    [anon_sym_checked] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [anon_sym_true] = ACTIONS(3235),
    [anon_sym_false] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3237),
    [anon_sym_CARET] = ACTIONS(3237),
    [anon_sym_AMP] = ACTIONS(3237),
    [anon_sym_this] = ACTIONS(3235),
    [anon_sym_scoped] = ACTIONS(3235),
    [anon_sym_base] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [sym_predefined_type] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_unchecked] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_lock] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_foreach] = ACTIONS(3235),
    [anon_sym_goto] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3237),
    [anon_sym_from] = ACTIONS(3235),
    [anon_sym_into] = ACTIONS(3235),
    [anon_sym_join] = ACTIONS(3235),
    [anon_sym_on] = ACTIONS(3235),
    [anon_sym_equals] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_orderby] = ACTIONS(3235),
    [anon_sym_ascending] = ACTIONS(3235),
    [anon_sym_descending] = ACTIONS(3235),
    [anon_sym_group] = ACTIONS(3235),
    [anon_sym_by] = ACTIONS(3235),
    [anon_sym_select] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3235),
    [anon_sym_sizeof] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym___makeref] = ACTIONS(3235),
    [anon_sym___reftype] = ACTIONS(3235),
    [anon_sym___refvalue] = ACTIONS(3235),
    [sym_null_literal] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [sym_integer_literal] = ACTIONS(3235),
    [sym_real_literal] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [sym_verbatim_string_literal] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3237),
    [sym_interpolation_verbatim_start] = ACTIONS(3237),
    [sym_interpolation_raw_start] = ACTIONS(3237),
    [sym_raw_string_start] = ACTIONS(3237),
  },
  [2027] = {
    [sym_preproc_region] = STATE(2027),
    [sym_preproc_endregion] = STATE(2027),
    [sym_preproc_line] = STATE(2027),
    [sym_preproc_pragma] = STATE(2027),
    [sym_preproc_nullable] = STATE(2027),
    [sym_preproc_error] = STATE(2027),
    [sym_preproc_warning] = STATE(2027),
    [sym_preproc_define] = STATE(2027),
    [sym_preproc_undef] = STATE(2027),
    [ts_builtin_sym_end] = ACTIONS(3281),
    [sym__identifier_token] = ACTIONS(3279),
    [anon_sym_extern] = ACTIONS(3279),
    [anon_sym_alias] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_unsafe] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_ref] = ACTIONS(3279),
    [anon_sym_struct] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_delegate] = ACTIONS(3279),
    [anon_sym_record] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_file] = ACTIONS(3279),
    [anon_sym_fixed] = ACTIONS(3279),
    [anon_sym_internal] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_partial] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_required] = ACTIONS(3279),
    [anon_sym_sealed] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3279),
    [anon_sym_volatile] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_notnull] = ACTIONS(3279),
    [anon_sym_unmanaged] = ACTIONS(3279),
    [anon_sym_checked] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_true] = ACTIONS(3279),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_CARET] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_this] = ACTIONS(3279),
    [anon_sym_scoped] = ACTIONS(3279),
    [anon_sym_base] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [sym_predefined_type] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_unchecked] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_lock] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_foreach] = ACTIONS(3279),
    [anon_sym_goto] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3281),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_ascending] = ACTIONS(3279),
    [anon_sym_descending] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3279),
    [anon_sym_sizeof] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym___makeref] = ACTIONS(3279),
    [anon_sym___reftype] = ACTIONS(3279),
    [anon_sym___refvalue] = ACTIONS(3279),
    [sym_null_literal] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_integer_literal] = ACTIONS(3279),
    [sym_real_literal] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym_verbatim_string_literal] = ACTIONS(3281),
    [aux_sym_preproc_if_token1] = ACTIONS(3281),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3281),
    [sym_interpolation_verbatim_start] = ACTIONS(3281),
    [sym_interpolation_raw_start] = ACTIONS(3281),
    [sym_raw_string_start] = ACTIONS(3281),
  },
  [2028] = {
    [sym_preproc_region] = STATE(2028),
    [sym_preproc_endregion] = STATE(2028),
    [sym_preproc_line] = STATE(2028),
    [sym_preproc_pragma] = STATE(2028),
    [sym_preproc_nullable] = STATE(2028),
    [sym_preproc_error] = STATE(2028),
    [sym_preproc_warning] = STATE(2028),
    [sym_preproc_define] = STATE(2028),
    [sym_preproc_undef] = STATE(2028),
    [ts_builtin_sym_end] = ACTIONS(3333),
    [sym__identifier_token] = ACTIONS(3331),
    [anon_sym_extern] = ACTIONS(3331),
    [anon_sym_alias] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_global] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_unsafe] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_struct] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_delegate] = ACTIONS(3331),
    [anon_sym_record] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_file] = ACTIONS(3331),
    [anon_sym_fixed] = ACTIONS(3331),
    [anon_sym_internal] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_partial] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_required] = ACTIONS(3331),
    [anon_sym_sealed] = ACTIONS(3331),
    [anon_sym_virtual] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_where] = ACTIONS(3331),
    [anon_sym_notnull] = ACTIONS(3331),
    [anon_sym_unmanaged] = ACTIONS(3331),
    [anon_sym_checked] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_true] = ACTIONS(3331),
    [anon_sym_false] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3333),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
    [anon_sym_this] = ACTIONS(3331),
    [anon_sym_scoped] = ACTIONS(3331),
    [anon_sym_base] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [sym_predefined_type] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_unchecked] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_when] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_DOT_DOT] = ACTIONS(3333),
    [anon_sym_from] = ACTIONS(3331),
    [anon_sym_into] = ACTIONS(3331),
    [anon_sym_join] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [anon_sym_equals] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_orderby] = ACTIONS(3331),
    [anon_sym_ascending] = ACTIONS(3331),
    [anon_sym_descending] = ACTIONS(3331),
    [anon_sym_group] = ACTIONS(3331),
    [anon_sym_by] = ACTIONS(3331),
    [anon_sym_select] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3331),
    [anon_sym_sizeof] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym___makeref] = ACTIONS(3331),
    [anon_sym___reftype] = ACTIONS(3331),
    [anon_sym___refvalue] = ACTIONS(3331),
    [sym_null_literal] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_integer_literal] = ACTIONS(3331),
    [sym_real_literal] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [sym_verbatim_string_literal] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3333),
    [sym_interpolation_verbatim_start] = ACTIONS(3333),
    [sym_interpolation_raw_start] = ACTIONS(3333),
    [sym_raw_string_start] = ACTIONS(3333),
  },
  [2029] = {
    [sym_preproc_region] = STATE(2029),
    [sym_preproc_endregion] = STATE(2029),
    [sym_preproc_line] = STATE(2029),
    [sym_preproc_pragma] = STATE(2029),
    [sym_preproc_nullable] = STATE(2029),
    [sym_preproc_error] = STATE(2029),
    [sym_preproc_warning] = STATE(2029),
    [sym_preproc_define] = STATE(2029),
    [sym_preproc_undef] = STATE(2029),
    [ts_builtin_sym_end] = ACTIONS(3213),
    [sym__identifier_token] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3211),
    [anon_sym_alias] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_global] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_ref] = ACTIONS(3211),
    [anon_sym_struct] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_delegate] = ACTIONS(3211),
    [anon_sym_record] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_file] = ACTIONS(3211),
    [anon_sym_fixed] = ACTIONS(3211),
    [anon_sym_internal] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_partial] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_required] = ACTIONS(3211),
    [anon_sym_sealed] = ACTIONS(3211),
    [anon_sym_virtual] = ACTIONS(3211),
    [anon_sym_volatile] = ACTIONS(3211),
    [anon_sym_where] = ACTIONS(3211),
    [anon_sym_notnull] = ACTIONS(3211),
    [anon_sym_unmanaged] = ACTIONS(3211),
    [anon_sym_checked] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_true] = ACTIONS(3211),
    [anon_sym_false] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_CARET] = ACTIONS(3213),
    [anon_sym_AMP] = ACTIONS(3213),
    [anon_sym_this] = ACTIONS(3211),
    [anon_sym_scoped] = ACTIONS(3211),
    [anon_sym_base] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [sym_predefined_type] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_unchecked] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_lock] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_when] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_foreach] = ACTIONS(3211),
    [anon_sym_goto] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_DOT_DOT] = ACTIONS(3213),
    [anon_sym_from] = ACTIONS(3211),
    [anon_sym_into] = ACTIONS(3211),
    [anon_sym_join] = ACTIONS(3211),
    [anon_sym_on] = ACTIONS(3211),
    [anon_sym_equals] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_orderby] = ACTIONS(3211),
    [anon_sym_ascending] = ACTIONS(3211),
    [anon_sym_descending] = ACTIONS(3211),
    [anon_sym_group] = ACTIONS(3211),
    [anon_sym_by] = ACTIONS(3211),
    [anon_sym_select] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3211),
    [anon_sym_sizeof] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym___makeref] = ACTIONS(3211),
    [anon_sym___reftype] = ACTIONS(3211),
    [anon_sym___refvalue] = ACTIONS(3211),
    [sym_null_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_integer_literal] = ACTIONS(3211),
    [sym_real_literal] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [sym_verbatim_string_literal] = ACTIONS(3213),
    [aux_sym_preproc_if_token1] = ACTIONS(3213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3213),
    [sym_interpolation_verbatim_start] = ACTIONS(3213),
    [sym_interpolation_raw_start] = ACTIONS(3213),
    [sym_raw_string_start] = ACTIONS(3213),
  },
  [2030] = {
    [sym_preproc_region] = STATE(2030),
    [sym_preproc_endregion] = STATE(2030),
    [sym_preproc_line] = STATE(2030),
    [sym_preproc_pragma] = STATE(2030),
    [sym_preproc_nullable] = STATE(2030),
    [sym_preproc_error] = STATE(2030),
    [sym_preproc_warning] = STATE(2030),
    [sym_preproc_define] = STATE(2030),
    [sym_preproc_undef] = STATE(2030),
    [ts_builtin_sym_end] = ACTIONS(3195),
    [sym__identifier_token] = ACTIONS(3193),
    [anon_sym_extern] = ACTIONS(3193),
    [anon_sym_alias] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_global] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_unsafe] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_class] = ACTIONS(3193),
    [anon_sym_ref] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_enum] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_delegate] = ACTIONS(3193),
    [anon_sym_record] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_file] = ACTIONS(3193),
    [anon_sym_fixed] = ACTIONS(3193),
    [anon_sym_internal] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_partial] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_readonly] = ACTIONS(3193),
    [anon_sym_required] = ACTIONS(3193),
    [anon_sym_sealed] = ACTIONS(3193),
    [anon_sym_virtual] = ACTIONS(3193),
    [anon_sym_volatile] = ACTIONS(3193),
    [anon_sym_where] = ACTIONS(3193),
    [anon_sym_notnull] = ACTIONS(3193),
    [anon_sym_unmanaged] = ACTIONS(3193),
    [anon_sym_checked] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_true] = ACTIONS(3193),
    [anon_sym_false] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_STAR] = ACTIONS(3195),
    [anon_sym_CARET] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3195),
    [anon_sym_this] = ACTIONS(3193),
    [anon_sym_scoped] = ACTIONS(3193),
    [anon_sym_base] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [sym_predefined_type] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_unchecked] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_lock] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_when] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_foreach] = ACTIONS(3193),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3447),
    [anon_sym_DOT_DOT] = ACTIONS(3195),
    [anon_sym_from] = ACTIONS(3193),
    [anon_sym_into] = ACTIONS(3193),
    [anon_sym_join] = ACTIONS(3193),
    [anon_sym_on] = ACTIONS(3193),
    [anon_sym_equals] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_orderby] = ACTIONS(3193),
    [anon_sym_ascending] = ACTIONS(3193),
    [anon_sym_descending] = ACTIONS(3193),
    [anon_sym_group] = ACTIONS(3193),
    [anon_sym_by] = ACTIONS(3193),
    [anon_sym_select] = ACTIONS(3193),
    [anon_sym_stackalloc] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym___makeref] = ACTIONS(3193),
    [anon_sym___reftype] = ACTIONS(3193),
    [anon_sym___refvalue] = ACTIONS(3193),
    [sym_null_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_integer_literal] = ACTIONS(3193),
    [sym_real_literal] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [sym_verbatim_string_literal] = ACTIONS(3195),
    [aux_sym_preproc_if_token1] = ACTIONS(3195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3195),
    [sym_interpolation_verbatim_start] = ACTIONS(3195),
    [sym_interpolation_raw_start] = ACTIONS(3195),
    [sym_raw_string_start] = ACTIONS(3195),
  },
  [2031] = {
    [sym_preproc_region] = STATE(2031),
    [sym_preproc_endregion] = STATE(2031),
    [sym_preproc_line] = STATE(2031),
    [sym_preproc_pragma] = STATE(2031),
    [sym_preproc_nullable] = STATE(2031),
    [sym_preproc_error] = STATE(2031),
    [sym_preproc_warning] = STATE(2031),
    [sym_preproc_define] = STATE(2031),
    [sym_preproc_undef] = STATE(2031),
    [ts_builtin_sym_end] = ACTIONS(3321),
    [sym__identifier_token] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym_alias] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_global] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_unsafe] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_ref] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_delegate] = ACTIONS(3319),
    [anon_sym_record] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_file] = ACTIONS(3319),
    [anon_sym_fixed] = ACTIONS(3319),
    [anon_sym_internal] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_partial] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_required] = ACTIONS(3319),
    [anon_sym_sealed] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_where] = ACTIONS(3319),
    [anon_sym_notnull] = ACTIONS(3319),
    [anon_sym_unmanaged] = ACTIONS(3319),
    [anon_sym_checked] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_true] = ACTIONS(3319),
    [anon_sym_false] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_this] = ACTIONS(3319),
    [anon_sym_scoped] = ACTIONS(3319),
    [anon_sym_base] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [sym_predefined_type] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_unchecked] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_lock] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_when] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_foreach] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_DOT_DOT] = ACTIONS(3321),
    [anon_sym_from] = ACTIONS(3319),
    [anon_sym_into] = ACTIONS(3319),
    [anon_sym_join] = ACTIONS(3319),
    [anon_sym_on] = ACTIONS(3319),
    [anon_sym_equals] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_orderby] = ACTIONS(3319),
    [anon_sym_ascending] = ACTIONS(3319),
    [anon_sym_descending] = ACTIONS(3319),
    [anon_sym_group] = ACTIONS(3319),
    [anon_sym_by] = ACTIONS(3319),
    [anon_sym_select] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3319),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym___makeref] = ACTIONS(3319),
    [anon_sym___reftype] = ACTIONS(3319),
    [anon_sym___refvalue] = ACTIONS(3319),
    [sym_null_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [sym_integer_literal] = ACTIONS(3319),
    [sym_real_literal] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_verbatim_string_literal] = ACTIONS(3321),
    [aux_sym_preproc_if_token1] = ACTIONS(3321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3321),
    [sym_interpolation_verbatim_start] = ACTIONS(3321),
    [sym_interpolation_raw_start] = ACTIONS(3321),
    [sym_raw_string_start] = ACTIONS(3321),
  },
  [2032] = {
    [sym_preproc_region] = STATE(2032),
    [sym_preproc_endregion] = STATE(2032),
    [sym_preproc_line] = STATE(2032),
    [sym_preproc_pragma] = STATE(2032),
    [sym_preproc_nullable] = STATE(2032),
    [sym_preproc_error] = STATE(2032),
    [sym_preproc_warning] = STATE(2032),
    [sym_preproc_define] = STATE(2032),
    [sym_preproc_undef] = STATE(2032),
    [ts_builtin_sym_end] = ACTIONS(3273),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_struct] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_record] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_checked] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_true] = ACTIONS(3271),
    [anon_sym_false] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_base] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_unchecked] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_lock] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_foreach] = ACTIONS(3271),
    [anon_sym_goto] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_DOT_DOT] = ACTIONS(3273),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [anon_sym_stackalloc] = ACTIONS(3271),
    [anon_sym_sizeof] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym___makeref] = ACTIONS(3271),
    [anon_sym___reftype] = ACTIONS(3271),
    [anon_sym___refvalue] = ACTIONS(3271),
    [sym_null_literal] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_integer_literal] = ACTIONS(3271),
    [sym_real_literal] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [sym_verbatim_string_literal] = ACTIONS(3273),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3273),
    [sym_interpolation_verbatim_start] = ACTIONS(3273),
    [sym_interpolation_raw_start] = ACTIONS(3273),
    [sym_raw_string_start] = ACTIONS(3273),
  },
  [2033] = {
    [sym_preproc_region] = STATE(2033),
    [sym_preproc_endregion] = STATE(2033),
    [sym_preproc_line] = STATE(2033),
    [sym_preproc_pragma] = STATE(2033),
    [sym_preproc_nullable] = STATE(2033),
    [sym_preproc_error] = STATE(2033),
    [sym_preproc_warning] = STATE(2033),
    [sym_preproc_define] = STATE(2033),
    [sym_preproc_undef] = STATE(2033),
    [ts_builtin_sym_end] = ACTIONS(3345),
    [sym__identifier_token] = ACTIONS(3343),
    [anon_sym_extern] = ACTIONS(3343),
    [anon_sym_alias] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_global] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_unsafe] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_ref] = ACTIONS(3343),
    [anon_sym_struct] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_delegate] = ACTIONS(3343),
    [anon_sym_record] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_file] = ACTIONS(3343),
    [anon_sym_fixed] = ACTIONS(3343),
    [anon_sym_internal] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_partial] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_required] = ACTIONS(3343),
    [anon_sym_sealed] = ACTIONS(3343),
    [anon_sym_virtual] = ACTIONS(3343),
    [anon_sym_volatile] = ACTIONS(3343),
    [anon_sym_where] = ACTIONS(3343),
    [anon_sym_notnull] = ACTIONS(3343),
    [anon_sym_unmanaged] = ACTIONS(3343),
    [anon_sym_checked] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3345),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3345),
    [anon_sym_this] = ACTIONS(3343),
    [anon_sym_scoped] = ACTIONS(3343),
    [anon_sym_base] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [sym_predefined_type] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_unchecked] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_lock] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_when] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_foreach] = ACTIONS(3343),
    [anon_sym_goto] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_DOT_DOT] = ACTIONS(3345),
    [anon_sym_from] = ACTIONS(3343),
    [anon_sym_into] = ACTIONS(3343),
    [anon_sym_join] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [anon_sym_equals] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_orderby] = ACTIONS(3343),
    [anon_sym_ascending] = ACTIONS(3343),
    [anon_sym_descending] = ACTIONS(3343),
    [anon_sym_group] = ACTIONS(3343),
    [anon_sym_by] = ACTIONS(3343),
    [anon_sym_select] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym___makeref] = ACTIONS(3343),
    [anon_sym___reftype] = ACTIONS(3343),
    [anon_sym___refvalue] = ACTIONS(3343),
    [sym_null_literal] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_integer_literal] = ACTIONS(3343),
    [sym_real_literal] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [sym_verbatim_string_literal] = ACTIONS(3345),
    [aux_sym_preproc_if_token1] = ACTIONS(3345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3345),
    [sym_interpolation_verbatim_start] = ACTIONS(3345),
    [sym_interpolation_raw_start] = ACTIONS(3345),
    [sym_raw_string_start] = ACTIONS(3345),
  },
  [2034] = {
    [sym_catch_clause] = STATE(2099),
    [sym_finally_clause] = STATE(2122),
    [sym_preproc_region] = STATE(2034),
    [sym_preproc_endregion] = STATE(2034),
    [sym_preproc_line] = STATE(2034),
    [sym_preproc_pragma] = STATE(2034),
    [sym_preproc_nullable] = STATE(2034),
    [sym_preproc_error] = STATE(2034),
    [sym_preproc_warning] = STATE(2034),
    [sym_preproc_define] = STATE(2034),
    [sym_preproc_undef] = STATE(2034),
    [aux_sym_try_statement_repeat1] = STATE(2052),
    [sym__identifier_token] = ACTIONS(3121),
    [anon_sym_extern] = ACTIONS(3121),
    [anon_sym_alias] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3121),
    [anon_sym_unsafe] = ACTIONS(3121),
    [anon_sym_static] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_ref] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_RBRACE] = ACTIONS(3123),
    [anon_sym_delegate] = ACTIONS(3121),
    [anon_sym_abstract] = ACTIONS(3121),
    [anon_sym_async] = ACTIONS(3121),
    [anon_sym_const] = ACTIONS(3121),
    [anon_sym_file] = ACTIONS(3121),
    [anon_sym_fixed] = ACTIONS(3121),
    [anon_sym_internal] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_override] = ACTIONS(3121),
    [anon_sym_partial] = ACTIONS(3121),
    [anon_sym_private] = ACTIONS(3121),
    [anon_sym_protected] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3121),
    [anon_sym_readonly] = ACTIONS(3121),
    [anon_sym_required] = ACTIONS(3121),
    [anon_sym_sealed] = ACTIONS(3121),
    [anon_sym_virtual] = ACTIONS(3121),
    [anon_sym_volatile] = ACTIONS(3121),
    [anon_sym_where] = ACTIONS(3121),
    [anon_sym_notnull] = ACTIONS(3121),
    [anon_sym_unmanaged] = ACTIONS(3121),
    [anon_sym_checked] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3123),
    [anon_sym_PLUS_PLUS] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3123),
    [anon_sym_true] = ACTIONS(3121),
    [anon_sym_false] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3123),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_this] = ACTIONS(3121),
    [anon_sym_scoped] = ACTIONS(3121),
    [anon_sym_base] = ACTIONS(3121),
    [anon_sym_var] = ACTIONS(3121),
    [sym_predefined_type] = ACTIONS(3121),
    [anon_sym_break] = ACTIONS(3121),
    [anon_sym_unchecked] = ACTIONS(3121),
    [anon_sym_continue] = ACTIONS(3121),
    [anon_sym_do] = ACTIONS(3121),
    [anon_sym_while] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3121),
    [anon_sym_lock] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3121),
    [anon_sym_switch] = ACTIONS(3121),
    [anon_sym_case] = ACTIONS(3121),
    [anon_sym_default] = ACTIONS(3121),
    [anon_sym_throw] = ACTIONS(3121),
    [anon_sym_try] = ACTIONS(3121),
    [anon_sym_catch] = ACTIONS(3449),
    [anon_sym_when] = ACTIONS(3121),
    [anon_sym_finally] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3121),
    [anon_sym_foreach] = ACTIONS(3121),
    [anon_sym_goto] = ACTIONS(3121),
    [anon_sym_if] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3121),
    [anon_sym_DOT_DOT] = ACTIONS(3123),
    [anon_sym_from] = ACTIONS(3121),
    [anon_sym_into] = ACTIONS(3121),
    [anon_sym_join] = ACTIONS(3121),
    [anon_sym_on] = ACTIONS(3121),
    [anon_sym_equals] = ACTIONS(3121),
    [anon_sym_let] = ACTIONS(3121),
    [anon_sym_orderby] = ACTIONS(3121),
    [anon_sym_ascending] = ACTIONS(3121),
    [anon_sym_descending] = ACTIONS(3121),
    [anon_sym_group] = ACTIONS(3121),
    [anon_sym_by] = ACTIONS(3121),
    [anon_sym_select] = ACTIONS(3121),
    [anon_sym_stackalloc] = ACTIONS(3121),
    [anon_sym_sizeof] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3121),
    [anon_sym___makeref] = ACTIONS(3121),
    [anon_sym___reftype] = ACTIONS(3121),
    [anon_sym___refvalue] = ACTIONS(3121),
    [sym_null_literal] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3123),
    [sym_integer_literal] = ACTIONS(3121),
    [sym_real_literal] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [sym_verbatim_string_literal] = ACTIONS(3123),
    [aux_sym_preproc_if_token1] = ACTIONS(3123),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3123),
    [sym_interpolation_verbatim_start] = ACTIONS(3123),
    [sym_interpolation_raw_start] = ACTIONS(3123),
    [sym_raw_string_start] = ACTIONS(3123),
  },
  [2035] = {
    [sym_preproc_region] = STATE(2035),
    [sym_preproc_endregion] = STATE(2035),
    [sym_preproc_line] = STATE(2035),
    [sym_preproc_pragma] = STATE(2035),
    [sym_preproc_nullable] = STATE(2035),
    [sym_preproc_error] = STATE(2035),
    [sym_preproc_warning] = STATE(2035),
    [sym_preproc_define] = STATE(2035),
    [sym_preproc_undef] = STATE(2035),
    [ts_builtin_sym_end] = ACTIONS(3297),
    [sym__identifier_token] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_alias] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_global] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_delegate] = ACTIONS(3295),
    [anon_sym_record] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_file] = ACTIONS(3295),
    [anon_sym_fixed] = ACTIONS(3295),
    [anon_sym_internal] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_partial] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_required] = ACTIONS(3295),
    [anon_sym_sealed] = ACTIONS(3295),
    [anon_sym_virtual] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym_where] = ACTIONS(3295),
    [anon_sym_notnull] = ACTIONS(3295),
    [anon_sym_unmanaged] = ACTIONS(3295),
    [anon_sym_checked] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_CARET] = ACTIONS(3297),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_this] = ACTIONS(3295),
    [anon_sym_scoped] = ACTIONS(3295),
    [anon_sym_base] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [sym_predefined_type] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_unchecked] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_lock] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_when] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_foreach] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3297),
    [anon_sym_from] = ACTIONS(3295),
    [anon_sym_into] = ACTIONS(3295),
    [anon_sym_join] = ACTIONS(3295),
    [anon_sym_on] = ACTIONS(3295),
    [anon_sym_equals] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_orderby] = ACTIONS(3295),
    [anon_sym_ascending] = ACTIONS(3295),
    [anon_sym_descending] = ACTIONS(3295),
    [anon_sym_group] = ACTIONS(3295),
    [anon_sym_by] = ACTIONS(3295),
    [anon_sym_select] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym___makeref] = ACTIONS(3295),
    [anon_sym___reftype] = ACTIONS(3295),
    [anon_sym___refvalue] = ACTIONS(3295),
    [sym_null_literal] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_integer_literal] = ACTIONS(3295),
    [sym_real_literal] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [sym_verbatim_string_literal] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3297),
    [sym_interpolation_verbatim_start] = ACTIONS(3297),
    [sym_interpolation_raw_start] = ACTIONS(3297),
    [sym_raw_string_start] = ACTIONS(3297),
  },
  [2036] = {
    [sym_preproc_region] = STATE(2036),
    [sym_preproc_endregion] = STATE(2036),
    [sym_preproc_line] = STATE(2036),
    [sym_preproc_pragma] = STATE(2036),
    [sym_preproc_nullable] = STATE(2036),
    [sym_preproc_error] = STATE(2036),
    [sym_preproc_warning] = STATE(2036),
    [sym_preproc_define] = STATE(2036),
    [sym_preproc_undef] = STATE(2036),
    [ts_builtin_sym_end] = ACTIONS(3265),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_namespace] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_struct] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_interface] = ACTIONS(3263),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_record] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_checked] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_true] = ACTIONS(3263),
    [anon_sym_false] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_this] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_base] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_unchecked] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_DOT_DOT] = ACTIONS(3265),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3263),
    [anon_sym_sizeof] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym___makeref] = ACTIONS(3263),
    [anon_sym___reftype] = ACTIONS(3263),
    [anon_sym___refvalue] = ACTIONS(3263),
    [sym_null_literal] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [sym_real_literal] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3265),
    [sym_verbatim_string_literal] = ACTIONS(3265),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3265),
    [sym_interpolation_verbatim_start] = ACTIONS(3265),
    [sym_interpolation_raw_start] = ACTIONS(3265),
    [sym_raw_string_start] = ACTIONS(3265),
  },
  [2037] = {
    [sym_preproc_region] = STATE(2037),
    [sym_preproc_endregion] = STATE(2037),
    [sym_preproc_line] = STATE(2037),
    [sym_preproc_pragma] = STATE(2037),
    [sym_preproc_nullable] = STATE(2037),
    [sym_preproc_error] = STATE(2037),
    [sym_preproc_warning] = STATE(2037),
    [sym_preproc_define] = STATE(2037),
    [sym_preproc_undef] = STATE(2037),
    [ts_builtin_sym_end] = ACTIONS(3269),
    [sym__identifier_token] = ACTIONS(3267),
    [anon_sym_extern] = ACTIONS(3267),
    [anon_sym_alias] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_global] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_unsafe] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_ref] = ACTIONS(3267),
    [anon_sym_struct] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_delegate] = ACTIONS(3267),
    [anon_sym_record] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_file] = ACTIONS(3267),
    [anon_sym_fixed] = ACTIONS(3267),
    [anon_sym_internal] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_partial] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_required] = ACTIONS(3267),
    [anon_sym_sealed] = ACTIONS(3267),
    [anon_sym_virtual] = ACTIONS(3267),
    [anon_sym_volatile] = ACTIONS(3267),
    [anon_sym_where] = ACTIONS(3267),
    [anon_sym_notnull] = ACTIONS(3267),
    [anon_sym_unmanaged] = ACTIONS(3267),
    [anon_sym_checked] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_true] = ACTIONS(3267),
    [anon_sym_false] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_scoped] = ACTIONS(3267),
    [anon_sym_base] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [sym_predefined_type] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_unchecked] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_lock] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_when] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_foreach] = ACTIONS(3267),
    [anon_sym_goto] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_DOT_DOT] = ACTIONS(3269),
    [anon_sym_from] = ACTIONS(3267),
    [anon_sym_into] = ACTIONS(3267),
    [anon_sym_join] = ACTIONS(3267),
    [anon_sym_on] = ACTIONS(3267),
    [anon_sym_equals] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_orderby] = ACTIONS(3267),
    [anon_sym_ascending] = ACTIONS(3267),
    [anon_sym_descending] = ACTIONS(3267),
    [anon_sym_group] = ACTIONS(3267),
    [anon_sym_by] = ACTIONS(3267),
    [anon_sym_select] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3267),
    [anon_sym_sizeof] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym___makeref] = ACTIONS(3267),
    [anon_sym___reftype] = ACTIONS(3267),
    [anon_sym___refvalue] = ACTIONS(3267),
    [sym_null_literal] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_integer_literal] = ACTIONS(3267),
    [sym_real_literal] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [sym_verbatim_string_literal] = ACTIONS(3269),
    [aux_sym_preproc_if_token1] = ACTIONS(3269),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3269),
    [sym_interpolation_verbatim_start] = ACTIONS(3269),
    [sym_interpolation_raw_start] = ACTIONS(3269),
    [sym_raw_string_start] = ACTIONS(3269),
  },
  [2038] = {
    [sym_preproc_region] = STATE(2038),
    [sym_preproc_endregion] = STATE(2038),
    [sym_preproc_line] = STATE(2038),
    [sym_preproc_pragma] = STATE(2038),
    [sym_preproc_nullable] = STATE(2038),
    [sym_preproc_error] = STATE(2038),
    [sym_preproc_warning] = STATE(2038),
    [sym_preproc_define] = STATE(2038),
    [sym_preproc_undef] = STATE(2038),
    [ts_builtin_sym_end] = ACTIONS(3341),
    [sym__identifier_token] = ACTIONS(3339),
    [anon_sym_extern] = ACTIONS(3339),
    [anon_sym_alias] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_global] = ACTIONS(3339),
    [anon_sym_using] = ACTIONS(3339),
    [anon_sym_unsafe] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3339),
    [anon_sym_namespace] = ACTIONS(3339),
    [anon_sym_class] = ACTIONS(3339),
    [anon_sym_ref] = ACTIONS(3339),
    [anon_sym_struct] = ACTIONS(3339),
    [anon_sym_enum] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_interface] = ACTIONS(3339),
    [anon_sym_delegate] = ACTIONS(3339),
    [anon_sym_record] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_const] = ACTIONS(3339),
    [anon_sym_file] = ACTIONS(3339),
    [anon_sym_fixed] = ACTIONS(3339),
    [anon_sym_internal] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_override] = ACTIONS(3339),
    [anon_sym_partial] = ACTIONS(3339),
    [anon_sym_private] = ACTIONS(3339),
    [anon_sym_protected] = ACTIONS(3339),
    [anon_sym_public] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_required] = ACTIONS(3339),
    [anon_sym_sealed] = ACTIONS(3339),
    [anon_sym_virtual] = ACTIONS(3339),
    [anon_sym_volatile] = ACTIONS(3339),
    [anon_sym_where] = ACTIONS(3339),
    [anon_sym_notnull] = ACTIONS(3339),
    [anon_sym_unmanaged] = ACTIONS(3339),
    [anon_sym_checked] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_TILDE] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_true] = ACTIONS(3339),
    [anon_sym_false] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_this] = ACTIONS(3339),
    [anon_sym_scoped] = ACTIONS(3339),
    [anon_sym_base] = ACTIONS(3339),
    [anon_sym_var] = ACTIONS(3339),
    [sym_predefined_type] = ACTIONS(3339),
    [anon_sym_break] = ACTIONS(3339),
    [anon_sym_unchecked] = ACTIONS(3339),
    [anon_sym_continue] = ACTIONS(3339),
    [anon_sym_do] = ACTIONS(3339),
    [anon_sym_while] = ACTIONS(3339),
    [anon_sym_for] = ACTIONS(3339),
    [anon_sym_lock] = ACTIONS(3339),
    [anon_sym_yield] = ACTIONS(3339),
    [anon_sym_switch] = ACTIONS(3339),
    [anon_sym_default] = ACTIONS(3339),
    [anon_sym_throw] = ACTIONS(3339),
    [anon_sym_try] = ACTIONS(3339),
    [anon_sym_when] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3339),
    [anon_sym_foreach] = ACTIONS(3339),
    [anon_sym_goto] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3339),
    [anon_sym_else] = ACTIONS(3339),
    [anon_sym_DOT_DOT] = ACTIONS(3341),
    [anon_sym_from] = ACTIONS(3339),
    [anon_sym_into] = ACTIONS(3339),
    [anon_sym_join] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [anon_sym_equals] = ACTIONS(3339),
    [anon_sym_let] = ACTIONS(3339),
    [anon_sym_orderby] = ACTIONS(3339),
    [anon_sym_ascending] = ACTIONS(3339),
    [anon_sym_descending] = ACTIONS(3339),
    [anon_sym_group] = ACTIONS(3339),
    [anon_sym_by] = ACTIONS(3339),
    [anon_sym_select] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3339),
    [anon_sym_sizeof] = ACTIONS(3339),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym___makeref] = ACTIONS(3339),
    [anon_sym___reftype] = ACTIONS(3339),
    [anon_sym___refvalue] = ACTIONS(3339),
    [sym_null_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_integer_literal] = ACTIONS(3339),
    [sym_real_literal] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3341),
    [sym_verbatim_string_literal] = ACTIONS(3341),
    [aux_sym_preproc_if_token1] = ACTIONS(3341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3341),
    [sym_interpolation_verbatim_start] = ACTIONS(3341),
    [sym_interpolation_raw_start] = ACTIONS(3341),
    [sym_raw_string_start] = ACTIONS(3341),
  },
  [2039] = {
    [sym_preproc_region] = STATE(2039),
    [sym_preproc_endregion] = STATE(2039),
    [sym_preproc_line] = STATE(2039),
    [sym_preproc_pragma] = STATE(2039),
    [sym_preproc_nullable] = STATE(2039),
    [sym_preproc_error] = STATE(2039),
    [sym_preproc_warning] = STATE(2039),
    [sym_preproc_define] = STATE(2039),
    [sym_preproc_undef] = STATE(2039),
    [ts_builtin_sym_end] = ACTIONS(3201),
    [sym__identifier_token] = ACTIONS(3199),
    [anon_sym_extern] = ACTIONS(3199),
    [anon_sym_alias] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_global] = ACTIONS(3199),
    [anon_sym_using] = ACTIONS(3199),
    [anon_sym_unsafe] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_namespace] = ACTIONS(3199),
    [anon_sym_class] = ACTIONS(3199),
    [anon_sym_ref] = ACTIONS(3199),
    [anon_sym_struct] = ACTIONS(3199),
    [anon_sym_enum] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_interface] = ACTIONS(3199),
    [anon_sym_delegate] = ACTIONS(3199),
    [anon_sym_record] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_file] = ACTIONS(3199),
    [anon_sym_fixed] = ACTIONS(3199),
    [anon_sym_internal] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_override] = ACTIONS(3199),
    [anon_sym_partial] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_required] = ACTIONS(3199),
    [anon_sym_sealed] = ACTIONS(3199),
    [anon_sym_virtual] = ACTIONS(3199),
    [anon_sym_volatile] = ACTIONS(3199),
    [anon_sym_where] = ACTIONS(3199),
    [anon_sym_notnull] = ACTIONS(3199),
    [anon_sym_unmanaged] = ACTIONS(3199),
    [anon_sym_checked] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3199),
    [anon_sym_false] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_STAR] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_this] = ACTIONS(3199),
    [anon_sym_scoped] = ACTIONS(3199),
    [anon_sym_base] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [sym_predefined_type] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_unchecked] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_lock] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_when] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_foreach] = ACTIONS(3199),
    [anon_sym_goto] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_DOT_DOT] = ACTIONS(3201),
    [anon_sym_from] = ACTIONS(3199),
    [anon_sym_into] = ACTIONS(3199),
    [anon_sym_join] = ACTIONS(3199),
    [anon_sym_on] = ACTIONS(3199),
    [anon_sym_equals] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_orderby] = ACTIONS(3199),
    [anon_sym_ascending] = ACTIONS(3199),
    [anon_sym_descending] = ACTIONS(3199),
    [anon_sym_group] = ACTIONS(3199),
    [anon_sym_by] = ACTIONS(3199),
    [anon_sym_select] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3199),
    [anon_sym_sizeof] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym___makeref] = ACTIONS(3199),
    [anon_sym___reftype] = ACTIONS(3199),
    [anon_sym___refvalue] = ACTIONS(3199),
    [sym_null_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(3199),
    [sym_real_literal] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [sym_verbatim_string_literal] = ACTIONS(3201),
    [aux_sym_preproc_if_token1] = ACTIONS(3201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3201),
    [sym_interpolation_verbatim_start] = ACTIONS(3201),
    [sym_interpolation_raw_start] = ACTIONS(3201),
    [sym_raw_string_start] = ACTIONS(3201),
  },
  [2040] = {
    [sym_preproc_region] = STATE(2040),
    [sym_preproc_endregion] = STATE(2040),
    [sym_preproc_line] = STATE(2040),
    [sym_preproc_pragma] = STATE(2040),
    [sym_preproc_nullable] = STATE(2040),
    [sym_preproc_error] = STATE(2040),
    [sym_preproc_warning] = STATE(2040),
    [sym_preproc_define] = STATE(2040),
    [sym_preproc_undef] = STATE(2040),
    [ts_builtin_sym_end] = ACTIONS(3233),
    [sym__identifier_token] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_alias] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_global] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_ref] = ACTIONS(3231),
    [anon_sym_struct] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_delegate] = ACTIONS(3231),
    [anon_sym_record] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_file] = ACTIONS(3231),
    [anon_sym_fixed] = ACTIONS(3231),
    [anon_sym_internal] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_partial] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_sealed] = ACTIONS(3231),
    [anon_sym_virtual] = ACTIONS(3231),
    [anon_sym_volatile] = ACTIONS(3231),
    [anon_sym_where] = ACTIONS(3231),
    [anon_sym_notnull] = ACTIONS(3231),
    [anon_sym_unmanaged] = ACTIONS(3231),
    [anon_sym_checked] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_false] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3231),
    [anon_sym_scoped] = ACTIONS(3231),
    [anon_sym_base] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [sym_predefined_type] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_unchecked] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_lock] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_when] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_foreach] = ACTIONS(3231),
    [anon_sym_goto] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_DOT_DOT] = ACTIONS(3233),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_into] = ACTIONS(3231),
    [anon_sym_join] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_equals] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_orderby] = ACTIONS(3231),
    [anon_sym_ascending] = ACTIONS(3231),
    [anon_sym_descending] = ACTIONS(3231),
    [anon_sym_group] = ACTIONS(3231),
    [anon_sym_by] = ACTIONS(3231),
    [anon_sym_select] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3231),
    [anon_sym_sizeof] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym___makeref] = ACTIONS(3231),
    [anon_sym___reftype] = ACTIONS(3231),
    [anon_sym___refvalue] = ACTIONS(3231),
    [sym_null_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_integer_literal] = ACTIONS(3231),
    [sym_real_literal] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_verbatim_string_literal] = ACTIONS(3233),
    [aux_sym_preproc_if_token1] = ACTIONS(3233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3233),
    [sym_interpolation_verbatim_start] = ACTIONS(3233),
    [sym_interpolation_raw_start] = ACTIONS(3233),
    [sym_raw_string_start] = ACTIONS(3233),
  },
  [2041] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6180),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5841),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2041),
    [sym_preproc_endregion] = STATE(2041),
    [sym_preproc_line] = STATE(2041),
    [sym_preproc_pragma] = STATE(2041),
    [sym_preproc_nullable] = STATE(2041),
    [sym_preproc_error] = STATE(2041),
    [sym_preproc_warning] = STATE(2041),
    [sym_preproc_define] = STATE(2041),
    [sym_preproc_undef] = STATE(2041),
    [sym__identifier_token] = ACTIONS(3453),
    [anon_sym_alias] = ACTIONS(3456),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3456),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3456),
    [anon_sym_unmanaged] = ACTIONS(3456),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3470),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3473),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3456),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3456),
    [anon_sym_into] = ACTIONS(3456),
    [anon_sym_join] = ACTIONS(3456),
    [anon_sym_on] = ACTIONS(3456),
    [anon_sym_equals] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_orderby] = ACTIONS(3456),
    [anon_sym_ascending] = ACTIONS(3456),
    [anon_sym_descending] = ACTIONS(3456),
    [anon_sym_group] = ACTIONS(3456),
    [anon_sym_by] = ACTIONS(3456),
    [anon_sym_select] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2042] = {
    [sym_preproc_region] = STATE(2042),
    [sym_preproc_endregion] = STATE(2042),
    [sym_preproc_line] = STATE(2042),
    [sym_preproc_pragma] = STATE(2042),
    [sym_preproc_nullable] = STATE(2042),
    [sym_preproc_error] = STATE(2042),
    [sym_preproc_warning] = STATE(2042),
    [sym_preproc_define] = STATE(2042),
    [sym_preproc_undef] = STATE(2042),
    [ts_builtin_sym_end] = ACTIONS(3225),
    [sym__identifier_token] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_alias] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_ref] = ACTIONS(3223),
    [anon_sym_struct] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_delegate] = ACTIONS(3223),
    [anon_sym_record] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_file] = ACTIONS(3223),
    [anon_sym_fixed] = ACTIONS(3223),
    [anon_sym_internal] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_partial] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_required] = ACTIONS(3223),
    [anon_sym_sealed] = ACTIONS(3223),
    [anon_sym_virtual] = ACTIONS(3223),
    [anon_sym_volatile] = ACTIONS(3223),
    [anon_sym_where] = ACTIONS(3223),
    [anon_sym_notnull] = ACTIONS(3223),
    [anon_sym_unmanaged] = ACTIONS(3223),
    [anon_sym_checked] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_true] = ACTIONS(3223),
    [anon_sym_false] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3225),
    [anon_sym_CARET] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3225),
    [anon_sym_this] = ACTIONS(3223),
    [anon_sym_scoped] = ACTIONS(3223),
    [anon_sym_base] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [sym_predefined_type] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_unchecked] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_lock] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_when] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_foreach] = ACTIONS(3223),
    [anon_sym_goto] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_DOT_DOT] = ACTIONS(3225),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_into] = ACTIONS(3223),
    [anon_sym_join] = ACTIONS(3223),
    [anon_sym_on] = ACTIONS(3223),
    [anon_sym_equals] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_orderby] = ACTIONS(3223),
    [anon_sym_ascending] = ACTIONS(3223),
    [anon_sym_descending] = ACTIONS(3223),
    [anon_sym_group] = ACTIONS(3223),
    [anon_sym_by] = ACTIONS(3223),
    [anon_sym_select] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3223),
    [anon_sym_sizeof] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym___makeref] = ACTIONS(3223),
    [anon_sym___reftype] = ACTIONS(3223),
    [anon_sym___refvalue] = ACTIONS(3223),
    [sym_null_literal] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_integer_literal] = ACTIONS(3223),
    [sym_real_literal] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [sym_verbatim_string_literal] = ACTIONS(3225),
    [aux_sym_preproc_if_token1] = ACTIONS(3225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3225),
    [sym_interpolation_verbatim_start] = ACTIONS(3225),
    [sym_interpolation_raw_start] = ACTIONS(3225),
    [sym_raw_string_start] = ACTIONS(3225),
  },
  [2043] = {
    [sym_preproc_region] = STATE(2043),
    [sym_preproc_endregion] = STATE(2043),
    [sym_preproc_line] = STATE(2043),
    [sym_preproc_pragma] = STATE(2043),
    [sym_preproc_nullable] = STATE(2043),
    [sym_preproc_error] = STATE(2043),
    [sym_preproc_warning] = STATE(2043),
    [sym_preproc_define] = STATE(2043),
    [sym_preproc_undef] = STATE(2043),
    [ts_builtin_sym_end] = ACTIONS(3325),
    [sym__identifier_token] = ACTIONS(3323),
    [anon_sym_extern] = ACTIONS(3323),
    [anon_sym_alias] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_global] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_unsafe] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_struct] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_delegate] = ACTIONS(3323),
    [anon_sym_record] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_file] = ACTIONS(3323),
    [anon_sym_fixed] = ACTIONS(3323),
    [anon_sym_internal] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_partial] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_required] = ACTIONS(3323),
    [anon_sym_sealed] = ACTIONS(3323),
    [anon_sym_virtual] = ACTIONS(3323),
    [anon_sym_volatile] = ACTIONS(3323),
    [anon_sym_where] = ACTIONS(3323),
    [anon_sym_notnull] = ACTIONS(3323),
    [anon_sym_unmanaged] = ACTIONS(3323),
    [anon_sym_checked] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3325),
    [anon_sym_true] = ACTIONS(3323),
    [anon_sym_false] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3325),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_this] = ACTIONS(3323),
    [anon_sym_scoped] = ACTIONS(3323),
    [anon_sym_base] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [sym_predefined_type] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_unchecked] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_when] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_DOT_DOT] = ACTIONS(3325),
    [anon_sym_from] = ACTIONS(3323),
    [anon_sym_into] = ACTIONS(3323),
    [anon_sym_join] = ACTIONS(3323),
    [anon_sym_on] = ACTIONS(3323),
    [anon_sym_equals] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_orderby] = ACTIONS(3323),
    [anon_sym_ascending] = ACTIONS(3323),
    [anon_sym_descending] = ACTIONS(3323),
    [anon_sym_group] = ACTIONS(3323),
    [anon_sym_by] = ACTIONS(3323),
    [anon_sym_select] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3323),
    [anon_sym_sizeof] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym___makeref] = ACTIONS(3323),
    [anon_sym___reftype] = ACTIONS(3323),
    [anon_sym___refvalue] = ACTIONS(3323),
    [sym_null_literal] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [sym_integer_literal] = ACTIONS(3323),
    [sym_real_literal] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [sym_verbatim_string_literal] = ACTIONS(3325),
    [aux_sym_preproc_if_token1] = ACTIONS(3325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3325),
    [sym_interpolation_verbatim_start] = ACTIONS(3325),
    [sym_interpolation_raw_start] = ACTIONS(3325),
    [sym_raw_string_start] = ACTIONS(3325),
  },
  [2044] = {
    [sym_preproc_region] = STATE(2044),
    [sym_preproc_endregion] = STATE(2044),
    [sym_preproc_line] = STATE(2044),
    [sym_preproc_pragma] = STATE(2044),
    [sym_preproc_nullable] = STATE(2044),
    [sym_preproc_error] = STATE(2044),
    [sym_preproc_warning] = STATE(2044),
    [sym_preproc_define] = STATE(2044),
    [sym_preproc_undef] = STATE(2044),
    [ts_builtin_sym_end] = ACTIONS(3205),
    [sym__identifier_token] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_alias] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_global] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_namespace] = ACTIONS(3203),
    [anon_sym_class] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_enum] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_interface] = ACTIONS(3203),
    [anon_sym_delegate] = ACTIONS(3203),
    [anon_sym_record] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_file] = ACTIONS(3203),
    [anon_sym_fixed] = ACTIONS(3203),
    [anon_sym_internal] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_override] = ACTIONS(3203),
    [anon_sym_partial] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_required] = ACTIONS(3203),
    [anon_sym_sealed] = ACTIONS(3203),
    [anon_sym_virtual] = ACTIONS(3203),
    [anon_sym_volatile] = ACTIONS(3203),
    [anon_sym_where] = ACTIONS(3203),
    [anon_sym_notnull] = ACTIONS(3203),
    [anon_sym_unmanaged] = ACTIONS(3203),
    [anon_sym_checked] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_CARET] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_this] = ACTIONS(3203),
    [anon_sym_scoped] = ACTIONS(3203),
    [anon_sym_base] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [sym_predefined_type] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_unchecked] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_lock] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_when] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_foreach] = ACTIONS(3203),
    [anon_sym_goto] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_from] = ACTIONS(3203),
    [anon_sym_into] = ACTIONS(3203),
    [anon_sym_join] = ACTIONS(3203),
    [anon_sym_on] = ACTIONS(3203),
    [anon_sym_equals] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_orderby] = ACTIONS(3203),
    [anon_sym_ascending] = ACTIONS(3203),
    [anon_sym_descending] = ACTIONS(3203),
    [anon_sym_group] = ACTIONS(3203),
    [anon_sym_by] = ACTIONS(3203),
    [anon_sym_select] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3203),
    [anon_sym_sizeof] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym___makeref] = ACTIONS(3203),
    [anon_sym___reftype] = ACTIONS(3203),
    [anon_sym___refvalue] = ACTIONS(3203),
    [sym_null_literal] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_integer_literal] = ACTIONS(3203),
    [sym_real_literal] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_verbatim_string_literal] = ACTIONS(3205),
    [aux_sym_preproc_if_token1] = ACTIONS(3205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3205),
    [sym_interpolation_verbatim_start] = ACTIONS(3205),
    [sym_interpolation_raw_start] = ACTIONS(3205),
    [sym_raw_string_start] = ACTIONS(3205),
  },
  [2045] = {
    [sym_preproc_region] = STATE(2045),
    [sym_preproc_endregion] = STATE(2045),
    [sym_preproc_line] = STATE(2045),
    [sym_preproc_pragma] = STATE(2045),
    [sym_preproc_nullable] = STATE(2045),
    [sym_preproc_error] = STATE(2045),
    [sym_preproc_warning] = STATE(2045),
    [sym_preproc_define] = STATE(2045),
    [sym_preproc_undef] = STATE(2045),
    [ts_builtin_sym_end] = ACTIONS(3179),
    [sym__identifier_token] = ACTIONS(3177),
    [anon_sym_extern] = ACTIONS(3177),
    [anon_sym_alias] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_global] = ACTIONS(3177),
    [anon_sym_using] = ACTIONS(3177),
    [anon_sym_unsafe] = ACTIONS(3177),
    [anon_sym_static] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_return] = ACTIONS(3177),
    [anon_sym_namespace] = ACTIONS(3177),
    [anon_sym_class] = ACTIONS(3177),
    [anon_sym_ref] = ACTIONS(3177),
    [anon_sym_struct] = ACTIONS(3177),
    [anon_sym_enum] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_interface] = ACTIONS(3177),
    [anon_sym_delegate] = ACTIONS(3177),
    [anon_sym_record] = ACTIONS(3177),
    [anon_sym_abstract] = ACTIONS(3177),
    [anon_sym_async] = ACTIONS(3177),
    [anon_sym_const] = ACTIONS(3177),
    [anon_sym_file] = ACTIONS(3177),
    [anon_sym_fixed] = ACTIONS(3177),
    [anon_sym_internal] = ACTIONS(3177),
    [anon_sym_new] = ACTIONS(3177),
    [anon_sym_override] = ACTIONS(3177),
    [anon_sym_partial] = ACTIONS(3177),
    [anon_sym_private] = ACTIONS(3177),
    [anon_sym_protected] = ACTIONS(3177),
    [anon_sym_public] = ACTIONS(3177),
    [anon_sym_readonly] = ACTIONS(3177),
    [anon_sym_required] = ACTIONS(3177),
    [anon_sym_sealed] = ACTIONS(3177),
    [anon_sym_virtual] = ACTIONS(3177),
    [anon_sym_volatile] = ACTIONS(3177),
    [anon_sym_where] = ACTIONS(3177),
    [anon_sym_notnull] = ACTIONS(3177),
    [anon_sym_unmanaged] = ACTIONS(3177),
    [anon_sym_checked] = ACTIONS(3177),
    [anon_sym_BANG] = ACTIONS(3179),
    [anon_sym_TILDE] = ACTIONS(3179),
    [anon_sym_PLUS_PLUS] = ACTIONS(3179),
    [anon_sym_DASH_DASH] = ACTIONS(3179),
    [anon_sym_true] = ACTIONS(3177),
    [anon_sym_false] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3177),
    [anon_sym_DASH] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(3179),
    [anon_sym_CARET] = ACTIONS(3179),
    [anon_sym_AMP] = ACTIONS(3179),
    [anon_sym_this] = ACTIONS(3177),
    [anon_sym_scoped] = ACTIONS(3177),
    [anon_sym_base] = ACTIONS(3177),
    [anon_sym_var] = ACTIONS(3177),
    [sym_predefined_type] = ACTIONS(3177),
    [anon_sym_break] = ACTIONS(3177),
    [anon_sym_unchecked] = ACTIONS(3177),
    [anon_sym_continue] = ACTIONS(3177),
    [anon_sym_do] = ACTIONS(3177),
    [anon_sym_while] = ACTIONS(3177),
    [anon_sym_for] = ACTIONS(3177),
    [anon_sym_lock] = ACTIONS(3177),
    [anon_sym_yield] = ACTIONS(3177),
    [anon_sym_switch] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3177),
    [anon_sym_throw] = ACTIONS(3177),
    [anon_sym_try] = ACTIONS(3177),
    [anon_sym_when] = ACTIONS(3177),
    [anon_sym_await] = ACTIONS(3177),
    [anon_sym_foreach] = ACTIONS(3177),
    [anon_sym_goto] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3177),
    [anon_sym_DOT_DOT] = ACTIONS(3179),
    [anon_sym_from] = ACTIONS(3177),
    [anon_sym_into] = ACTIONS(3177),
    [anon_sym_join] = ACTIONS(3177),
    [anon_sym_on] = ACTIONS(3177),
    [anon_sym_equals] = ACTIONS(3177),
    [anon_sym_let] = ACTIONS(3177),
    [anon_sym_orderby] = ACTIONS(3177),
    [anon_sym_ascending] = ACTIONS(3177),
    [anon_sym_descending] = ACTIONS(3177),
    [anon_sym_group] = ACTIONS(3177),
    [anon_sym_by] = ACTIONS(3177),
    [anon_sym_select] = ACTIONS(3177),
    [anon_sym_stackalloc] = ACTIONS(3177),
    [anon_sym_sizeof] = ACTIONS(3177),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym___makeref] = ACTIONS(3177),
    [anon_sym___reftype] = ACTIONS(3177),
    [anon_sym___refvalue] = ACTIONS(3177),
    [sym_null_literal] = ACTIONS(3177),
    [anon_sym_SQUOTE] = ACTIONS(3179),
    [sym_integer_literal] = ACTIONS(3177),
    [sym_real_literal] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3179),
    [sym_verbatim_string_literal] = ACTIONS(3179),
    [aux_sym_preproc_if_token1] = ACTIONS(3179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3179),
    [sym_interpolation_verbatim_start] = ACTIONS(3179),
    [sym_interpolation_raw_start] = ACTIONS(3179),
    [sym_raw_string_start] = ACTIONS(3179),
  },
  [2046] = {
    [sym_preproc_region] = STATE(2046),
    [sym_preproc_endregion] = STATE(2046),
    [sym_preproc_line] = STATE(2046),
    [sym_preproc_pragma] = STATE(2046),
    [sym_preproc_nullable] = STATE(2046),
    [sym_preproc_error] = STATE(2046),
    [sym_preproc_warning] = STATE(2046),
    [sym_preproc_define] = STATE(2046),
    [sym_preproc_undef] = STATE(2046),
    [ts_builtin_sym_end] = ACTIONS(3221),
    [sym__identifier_token] = ACTIONS(3219),
    [anon_sym_extern] = ACTIONS(3219),
    [anon_sym_alias] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_global] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_unsafe] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_ref] = ACTIONS(3219),
    [anon_sym_struct] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_delegate] = ACTIONS(3219),
    [anon_sym_record] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_file] = ACTIONS(3219),
    [anon_sym_fixed] = ACTIONS(3219),
    [anon_sym_internal] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_partial] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_required] = ACTIONS(3219),
    [anon_sym_sealed] = ACTIONS(3219),
    [anon_sym_virtual] = ACTIONS(3219),
    [anon_sym_volatile] = ACTIONS(3219),
    [anon_sym_where] = ACTIONS(3219),
    [anon_sym_notnull] = ACTIONS(3219),
    [anon_sym_unmanaged] = ACTIONS(3219),
    [anon_sym_checked] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_true] = ACTIONS(3219),
    [anon_sym_false] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_CARET] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_this] = ACTIONS(3219),
    [anon_sym_scoped] = ACTIONS(3219),
    [anon_sym_base] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [sym_predefined_type] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_unchecked] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_lock] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_when] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_foreach] = ACTIONS(3219),
    [anon_sym_goto] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_DOT_DOT] = ACTIONS(3221),
    [anon_sym_from] = ACTIONS(3219),
    [anon_sym_into] = ACTIONS(3219),
    [anon_sym_join] = ACTIONS(3219),
    [anon_sym_on] = ACTIONS(3219),
    [anon_sym_equals] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_orderby] = ACTIONS(3219),
    [anon_sym_ascending] = ACTIONS(3219),
    [anon_sym_descending] = ACTIONS(3219),
    [anon_sym_group] = ACTIONS(3219),
    [anon_sym_by] = ACTIONS(3219),
    [anon_sym_select] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3219),
    [anon_sym_sizeof] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym___makeref] = ACTIONS(3219),
    [anon_sym___reftype] = ACTIONS(3219),
    [anon_sym___refvalue] = ACTIONS(3219),
    [sym_null_literal] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_integer_literal] = ACTIONS(3219),
    [sym_real_literal] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [sym_verbatim_string_literal] = ACTIONS(3221),
    [aux_sym_preproc_if_token1] = ACTIONS(3221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3221),
    [sym_interpolation_verbatim_start] = ACTIONS(3221),
    [sym_interpolation_raw_start] = ACTIONS(3221),
    [sym_raw_string_start] = ACTIONS(3221),
  },
  [2047] = {
    [sym_preproc_region] = STATE(2047),
    [sym_preproc_endregion] = STATE(2047),
    [sym_preproc_line] = STATE(2047),
    [sym_preproc_pragma] = STATE(2047),
    [sym_preproc_nullable] = STATE(2047),
    [sym_preproc_error] = STATE(2047),
    [sym_preproc_warning] = STATE(2047),
    [sym_preproc_define] = STATE(2047),
    [sym_preproc_undef] = STATE(2047),
    [ts_builtin_sym_end] = ACTIONS(3209),
    [sym__identifier_token] = ACTIONS(3207),
    [anon_sym_extern] = ACTIONS(3207),
    [anon_sym_alias] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_unsafe] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_ref] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_delegate] = ACTIONS(3207),
    [anon_sym_record] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_file] = ACTIONS(3207),
    [anon_sym_fixed] = ACTIONS(3207),
    [anon_sym_internal] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_partial] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_sealed] = ACTIONS(3207),
    [anon_sym_virtual] = ACTIONS(3207),
    [anon_sym_volatile] = ACTIONS(3207),
    [anon_sym_where] = ACTIONS(3207),
    [anon_sym_notnull] = ACTIONS(3207),
    [anon_sym_unmanaged] = ACTIONS(3207),
    [anon_sym_checked] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_true] = ACTIONS(3207),
    [anon_sym_false] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_CARET] = ACTIONS(3209),
    [anon_sym_AMP] = ACTIONS(3209),
    [anon_sym_this] = ACTIONS(3207),
    [anon_sym_scoped] = ACTIONS(3207),
    [anon_sym_base] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [sym_predefined_type] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_unchecked] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_lock] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_when] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_foreach] = ACTIONS(3207),
    [anon_sym_goto] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_DOT_DOT] = ACTIONS(3209),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_into] = ACTIONS(3207),
    [anon_sym_join] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_equals] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_orderby] = ACTIONS(3207),
    [anon_sym_ascending] = ACTIONS(3207),
    [anon_sym_descending] = ACTIONS(3207),
    [anon_sym_group] = ACTIONS(3207),
    [anon_sym_by] = ACTIONS(3207),
    [anon_sym_select] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3207),
    [anon_sym_sizeof] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym___makeref] = ACTIONS(3207),
    [anon_sym___reftype] = ACTIONS(3207),
    [anon_sym___refvalue] = ACTIONS(3207),
    [sym_null_literal] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_integer_literal] = ACTIONS(3207),
    [sym_real_literal] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3209),
    [sym_verbatim_string_literal] = ACTIONS(3209),
    [aux_sym_preproc_if_token1] = ACTIONS(3209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3209),
    [sym_interpolation_verbatim_start] = ACTIONS(3209),
    [sym_interpolation_raw_start] = ACTIONS(3209),
    [sym_raw_string_start] = ACTIONS(3209),
  },
  [2048] = {
    [sym_preproc_region] = STATE(2048),
    [sym_preproc_endregion] = STATE(2048),
    [sym_preproc_line] = STATE(2048),
    [sym_preproc_pragma] = STATE(2048),
    [sym_preproc_nullable] = STATE(2048),
    [sym_preproc_error] = STATE(2048),
    [sym_preproc_warning] = STATE(2048),
    [sym_preproc_define] = STATE(2048),
    [sym_preproc_undef] = STATE(2048),
    [ts_builtin_sym_end] = ACTIONS(3183),
    [sym__identifier_token] = ACTIONS(3181),
    [anon_sym_extern] = ACTIONS(3181),
    [anon_sym_alias] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_global] = ACTIONS(3181),
    [anon_sym_using] = ACTIONS(3181),
    [anon_sym_unsafe] = ACTIONS(3181),
    [anon_sym_static] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_namespace] = ACTIONS(3181),
    [anon_sym_class] = ACTIONS(3181),
    [anon_sym_ref] = ACTIONS(3181),
    [anon_sym_struct] = ACTIONS(3181),
    [anon_sym_enum] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3181),
    [anon_sym_delegate] = ACTIONS(3181),
    [anon_sym_record] = ACTIONS(3181),
    [anon_sym_abstract] = ACTIONS(3181),
    [anon_sym_async] = ACTIONS(3181),
    [anon_sym_const] = ACTIONS(3181),
    [anon_sym_file] = ACTIONS(3181),
    [anon_sym_fixed] = ACTIONS(3181),
    [anon_sym_internal] = ACTIONS(3181),
    [anon_sym_new] = ACTIONS(3181),
    [anon_sym_override] = ACTIONS(3181),
    [anon_sym_partial] = ACTIONS(3181),
    [anon_sym_private] = ACTIONS(3181),
    [anon_sym_protected] = ACTIONS(3181),
    [anon_sym_public] = ACTIONS(3181),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_required] = ACTIONS(3181),
    [anon_sym_sealed] = ACTIONS(3181),
    [anon_sym_virtual] = ACTIONS(3181),
    [anon_sym_volatile] = ACTIONS(3181),
    [anon_sym_where] = ACTIONS(3181),
    [anon_sym_notnull] = ACTIONS(3181),
    [anon_sym_unmanaged] = ACTIONS(3181),
    [anon_sym_checked] = ACTIONS(3181),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [anon_sym_true] = ACTIONS(3181),
    [anon_sym_false] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(3183),
    [anon_sym_this] = ACTIONS(3181),
    [anon_sym_scoped] = ACTIONS(3181),
    [anon_sym_base] = ACTIONS(3181),
    [anon_sym_var] = ACTIONS(3181),
    [sym_predefined_type] = ACTIONS(3181),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_unchecked] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_lock] = ACTIONS(3181),
    [anon_sym_yield] = ACTIONS(3181),
    [anon_sym_switch] = ACTIONS(3181),
    [anon_sym_default] = ACTIONS(3181),
    [anon_sym_throw] = ACTIONS(3181),
    [anon_sym_try] = ACTIONS(3181),
    [anon_sym_when] = ACTIONS(3181),
    [anon_sym_await] = ACTIONS(3181),
    [anon_sym_foreach] = ACTIONS(3181),
    [anon_sym_goto] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3181),
    [anon_sym_DOT_DOT] = ACTIONS(3183),
    [anon_sym_from] = ACTIONS(3181),
    [anon_sym_into] = ACTIONS(3181),
    [anon_sym_join] = ACTIONS(3181),
    [anon_sym_on] = ACTIONS(3181),
    [anon_sym_equals] = ACTIONS(3181),
    [anon_sym_let] = ACTIONS(3181),
    [anon_sym_orderby] = ACTIONS(3181),
    [anon_sym_ascending] = ACTIONS(3181),
    [anon_sym_descending] = ACTIONS(3181),
    [anon_sym_group] = ACTIONS(3181),
    [anon_sym_by] = ACTIONS(3181),
    [anon_sym_select] = ACTIONS(3181),
    [anon_sym_stackalloc] = ACTIONS(3181),
    [anon_sym_sizeof] = ACTIONS(3181),
    [anon_sym_typeof] = ACTIONS(3181),
    [anon_sym___makeref] = ACTIONS(3181),
    [anon_sym___reftype] = ACTIONS(3181),
    [anon_sym___refvalue] = ACTIONS(3181),
    [sym_null_literal] = ACTIONS(3181),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [sym_integer_literal] = ACTIONS(3181),
    [sym_real_literal] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [sym_verbatim_string_literal] = ACTIONS(3183),
    [aux_sym_preproc_if_token1] = ACTIONS(3183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3183),
    [sym_interpolation_verbatim_start] = ACTIONS(3183),
    [sym_interpolation_raw_start] = ACTIONS(3183),
    [sym_raw_string_start] = ACTIONS(3183),
  },
  [2049] = {
    [sym_preproc_region] = STATE(2049),
    [sym_preproc_endregion] = STATE(2049),
    [sym_preproc_line] = STATE(2049),
    [sym_preproc_pragma] = STATE(2049),
    [sym_preproc_nullable] = STATE(2049),
    [sym_preproc_error] = STATE(2049),
    [sym_preproc_warning] = STATE(2049),
    [sym_preproc_define] = STATE(2049),
    [sym_preproc_undef] = STATE(2049),
    [ts_builtin_sym_end] = ACTIONS(3289),
    [sym__identifier_token] = ACTIONS(3287),
    [anon_sym_extern] = ACTIONS(3287),
    [anon_sym_alias] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_unsafe] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_ref] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_delegate] = ACTIONS(3287),
    [anon_sym_record] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_file] = ACTIONS(3287),
    [anon_sym_fixed] = ACTIONS(3287),
    [anon_sym_internal] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_partial] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_required] = ACTIONS(3287),
    [anon_sym_sealed] = ACTIONS(3287),
    [anon_sym_virtual] = ACTIONS(3287),
    [anon_sym_volatile] = ACTIONS(3287),
    [anon_sym_where] = ACTIONS(3287),
    [anon_sym_notnull] = ACTIONS(3287),
    [anon_sym_unmanaged] = ACTIONS(3287),
    [anon_sym_checked] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_true] = ACTIONS(3287),
    [anon_sym_false] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_CARET] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_this] = ACTIONS(3287),
    [anon_sym_scoped] = ACTIONS(3287),
    [anon_sym_base] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [sym_predefined_type] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_unchecked] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_lock] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_when] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_foreach] = ACTIONS(3287),
    [anon_sym_goto] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3289),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_into] = ACTIONS(3287),
    [anon_sym_join] = ACTIONS(3287),
    [anon_sym_on] = ACTIONS(3287),
    [anon_sym_equals] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_orderby] = ACTIONS(3287),
    [anon_sym_ascending] = ACTIONS(3287),
    [anon_sym_descending] = ACTIONS(3287),
    [anon_sym_group] = ACTIONS(3287),
    [anon_sym_by] = ACTIONS(3287),
    [anon_sym_select] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym___makeref] = ACTIONS(3287),
    [anon_sym___reftype] = ACTIONS(3287),
    [anon_sym___refvalue] = ACTIONS(3287),
    [sym_null_literal] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_integer_literal] = ACTIONS(3287),
    [sym_real_literal] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_verbatim_string_literal] = ACTIONS(3289),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3289),
    [sym_interpolation_verbatim_start] = ACTIONS(3289),
    [sym_interpolation_raw_start] = ACTIONS(3289),
    [sym_raw_string_start] = ACTIONS(3289),
  },
  [2050] = {
    [sym_preproc_region] = STATE(2050),
    [sym_preproc_endregion] = STATE(2050),
    [sym_preproc_line] = STATE(2050),
    [sym_preproc_pragma] = STATE(2050),
    [sym_preproc_nullable] = STATE(2050),
    [sym_preproc_error] = STATE(2050),
    [sym_preproc_warning] = STATE(2050),
    [sym_preproc_define] = STATE(2050),
    [sym_preproc_undef] = STATE(2050),
    [ts_builtin_sym_end] = ACTIONS(3135),
    [sym__identifier_token] = ACTIONS(3133),
    [anon_sym_extern] = ACTIONS(3133),
    [anon_sym_alias] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_global] = ACTIONS(3133),
    [anon_sym_using] = ACTIONS(3133),
    [anon_sym_unsafe] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_namespace] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_struct] = ACTIONS(3133),
    [anon_sym_enum] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_interface] = ACTIONS(3133),
    [anon_sym_delegate] = ACTIONS(3133),
    [anon_sym_record] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_file] = ACTIONS(3133),
    [anon_sym_fixed] = ACTIONS(3133),
    [anon_sym_internal] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_override] = ACTIONS(3133),
    [anon_sym_partial] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_required] = ACTIONS(3133),
    [anon_sym_sealed] = ACTIONS(3133),
    [anon_sym_virtual] = ACTIONS(3133),
    [anon_sym_volatile] = ACTIONS(3133),
    [anon_sym_where] = ACTIONS(3133),
    [anon_sym_notnull] = ACTIONS(3133),
    [anon_sym_unmanaged] = ACTIONS(3133),
    [anon_sym_checked] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_true] = ACTIONS(3133),
    [anon_sym_false] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_this] = ACTIONS(3133),
    [anon_sym_scoped] = ACTIONS(3133),
    [anon_sym_base] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [sym_predefined_type] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_unchecked] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_when] = ACTIONS(3133),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3133),
    [anon_sym_into] = ACTIONS(3133),
    [anon_sym_join] = ACTIONS(3133),
    [anon_sym_on] = ACTIONS(3133),
    [anon_sym_equals] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_orderby] = ACTIONS(3133),
    [anon_sym_ascending] = ACTIONS(3133),
    [anon_sym_descending] = ACTIONS(3133),
    [anon_sym_group] = ACTIONS(3133),
    [anon_sym_by] = ACTIONS(3133),
    [anon_sym_select] = ACTIONS(3133),
    [anon_sym_stackalloc] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym___makeref] = ACTIONS(3133),
    [anon_sym___reftype] = ACTIONS(3133),
    [anon_sym___refvalue] = ACTIONS(3133),
    [sym_null_literal] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_integer_literal] = ACTIONS(3133),
    [sym_real_literal] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [sym_verbatim_string_literal] = ACTIONS(3135),
    [aux_sym_preproc_if_token1] = ACTIONS(3135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3135),
    [sym_interpolation_verbatim_start] = ACTIONS(3135),
    [sym_interpolation_raw_start] = ACTIONS(3135),
    [sym_raw_string_start] = ACTIONS(3135),
  },
  [2051] = {
    [sym_preproc_region] = STATE(2051),
    [sym_preproc_endregion] = STATE(2051),
    [sym_preproc_line] = STATE(2051),
    [sym_preproc_pragma] = STATE(2051),
    [sym_preproc_nullable] = STATE(2051),
    [sym_preproc_error] = STATE(2051),
    [sym_preproc_warning] = STATE(2051),
    [sym_preproc_define] = STATE(2051),
    [sym_preproc_undef] = STATE(2051),
    [ts_builtin_sym_end] = ACTIONS(3293),
    [sym__identifier_token] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_alias] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_global] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_unsafe] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_ref] = ACTIONS(3291),
    [anon_sym_struct] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_delegate] = ACTIONS(3291),
    [anon_sym_record] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_file] = ACTIONS(3291),
    [anon_sym_fixed] = ACTIONS(3291),
    [anon_sym_internal] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_partial] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_required] = ACTIONS(3291),
    [anon_sym_sealed] = ACTIONS(3291),
    [anon_sym_virtual] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym_where] = ACTIONS(3291),
    [anon_sym_notnull] = ACTIONS(3291),
    [anon_sym_unmanaged] = ACTIONS(3291),
    [anon_sym_checked] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3291),
    [anon_sym_false] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3291),
    [anon_sym_scoped] = ACTIONS(3291),
    [anon_sym_base] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [sym_predefined_type] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_unchecked] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_lock] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_when] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_foreach] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_DOT_DOT] = ACTIONS(3293),
    [anon_sym_from] = ACTIONS(3291),
    [anon_sym_into] = ACTIONS(3291),
    [anon_sym_join] = ACTIONS(3291),
    [anon_sym_on] = ACTIONS(3291),
    [anon_sym_equals] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_orderby] = ACTIONS(3291),
    [anon_sym_ascending] = ACTIONS(3291),
    [anon_sym_descending] = ACTIONS(3291),
    [anon_sym_group] = ACTIONS(3291),
    [anon_sym_by] = ACTIONS(3291),
    [anon_sym_select] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3291),
    [anon_sym_sizeof] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym___makeref] = ACTIONS(3291),
    [anon_sym___reftype] = ACTIONS(3291),
    [anon_sym___refvalue] = ACTIONS(3291),
    [sym_null_literal] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_integer_literal] = ACTIONS(3291),
    [sym_real_literal] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [sym_verbatim_string_literal] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3293),
    [sym_interpolation_verbatim_start] = ACTIONS(3293),
    [sym_interpolation_raw_start] = ACTIONS(3293),
    [sym_raw_string_start] = ACTIONS(3293),
  },
  [2052] = {
    [sym_catch_clause] = STATE(2099),
    [sym_finally_clause] = STATE(2108),
    [sym_preproc_region] = STATE(2052),
    [sym_preproc_endregion] = STATE(2052),
    [sym_preproc_line] = STATE(2052),
    [sym_preproc_pragma] = STATE(2052),
    [sym_preproc_nullable] = STATE(2052),
    [sym_preproc_error] = STATE(2052),
    [sym_preproc_warning] = STATE(2052),
    [sym_preproc_define] = STATE(2052),
    [sym_preproc_undef] = STATE(2052),
    [aux_sym_try_statement_repeat1] = STATE(2083),
    [sym__identifier_token] = ACTIONS(3133),
    [anon_sym_extern] = ACTIONS(3133),
    [anon_sym_alias] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_global] = ACTIONS(3133),
    [anon_sym_using] = ACTIONS(3133),
    [anon_sym_unsafe] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_RBRACE] = ACTIONS(3135),
    [anon_sym_delegate] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_file] = ACTIONS(3133),
    [anon_sym_fixed] = ACTIONS(3133),
    [anon_sym_internal] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_override] = ACTIONS(3133),
    [anon_sym_partial] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_required] = ACTIONS(3133),
    [anon_sym_sealed] = ACTIONS(3133),
    [anon_sym_virtual] = ACTIONS(3133),
    [anon_sym_volatile] = ACTIONS(3133),
    [anon_sym_where] = ACTIONS(3133),
    [anon_sym_notnull] = ACTIONS(3133),
    [anon_sym_unmanaged] = ACTIONS(3133),
    [anon_sym_checked] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_true] = ACTIONS(3133),
    [anon_sym_false] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_this] = ACTIONS(3133),
    [anon_sym_scoped] = ACTIONS(3133),
    [anon_sym_base] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [sym_predefined_type] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_unchecked] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_case] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_catch] = ACTIONS(3449),
    [anon_sym_when] = ACTIONS(3133),
    [anon_sym_finally] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3133),
    [anon_sym_into] = ACTIONS(3133),
    [anon_sym_join] = ACTIONS(3133),
    [anon_sym_on] = ACTIONS(3133),
    [anon_sym_equals] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_orderby] = ACTIONS(3133),
    [anon_sym_ascending] = ACTIONS(3133),
    [anon_sym_descending] = ACTIONS(3133),
    [anon_sym_group] = ACTIONS(3133),
    [anon_sym_by] = ACTIONS(3133),
    [anon_sym_select] = ACTIONS(3133),
    [anon_sym_stackalloc] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym___makeref] = ACTIONS(3133),
    [anon_sym___reftype] = ACTIONS(3133),
    [anon_sym___refvalue] = ACTIONS(3133),
    [sym_null_literal] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_integer_literal] = ACTIONS(3133),
    [sym_real_literal] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [sym_verbatim_string_literal] = ACTIONS(3135),
    [aux_sym_preproc_if_token1] = ACTIONS(3135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3135),
    [sym_interpolation_verbatim_start] = ACTIONS(3135),
    [sym_interpolation_raw_start] = ACTIONS(3135),
    [sym_raw_string_start] = ACTIONS(3135),
  },
  [2053] = {
    [sym_preproc_region] = STATE(2053),
    [sym_preproc_endregion] = STATE(2053),
    [sym_preproc_line] = STATE(2053),
    [sym_preproc_pragma] = STATE(2053),
    [sym_preproc_nullable] = STATE(2053),
    [sym_preproc_error] = STATE(2053),
    [sym_preproc_warning] = STATE(2053),
    [sym_preproc_define] = STATE(2053),
    [sym_preproc_undef] = STATE(2053),
    [ts_builtin_sym_end] = ACTIONS(3229),
    [sym__identifier_token] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3227),
    [anon_sym_alias] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_unsafe] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_ref] = ACTIONS(3227),
    [anon_sym_struct] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_delegate] = ACTIONS(3227),
    [anon_sym_record] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_file] = ACTIONS(3227),
    [anon_sym_fixed] = ACTIONS(3227),
    [anon_sym_internal] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_partial] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_required] = ACTIONS(3227),
    [anon_sym_sealed] = ACTIONS(3227),
    [anon_sym_virtual] = ACTIONS(3227),
    [anon_sym_volatile] = ACTIONS(3227),
    [anon_sym_where] = ACTIONS(3227),
    [anon_sym_notnull] = ACTIONS(3227),
    [anon_sym_unmanaged] = ACTIONS(3227),
    [anon_sym_checked] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_true] = ACTIONS(3227),
    [anon_sym_false] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_this] = ACTIONS(3227),
    [anon_sym_scoped] = ACTIONS(3227),
    [anon_sym_base] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [sym_predefined_type] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_unchecked] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_lock] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_when] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_foreach] = ACTIONS(3227),
    [anon_sym_goto] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_DOT_DOT] = ACTIONS(3229),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_into] = ACTIONS(3227),
    [anon_sym_join] = ACTIONS(3227),
    [anon_sym_on] = ACTIONS(3227),
    [anon_sym_equals] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_orderby] = ACTIONS(3227),
    [anon_sym_ascending] = ACTIONS(3227),
    [anon_sym_descending] = ACTIONS(3227),
    [anon_sym_group] = ACTIONS(3227),
    [anon_sym_by] = ACTIONS(3227),
    [anon_sym_select] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3227),
    [anon_sym_sizeof] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym___makeref] = ACTIONS(3227),
    [anon_sym___reftype] = ACTIONS(3227),
    [anon_sym___refvalue] = ACTIONS(3227),
    [sym_null_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_integer_literal] = ACTIONS(3227),
    [sym_real_literal] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [sym_verbatim_string_literal] = ACTIONS(3229),
    [aux_sym_preproc_if_token1] = ACTIONS(3229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3229),
    [sym_interpolation_verbatim_start] = ACTIONS(3229),
    [sym_interpolation_raw_start] = ACTIONS(3229),
    [sym_raw_string_start] = ACTIONS(3229),
  },
  [2054] = {
    [sym_preproc_region] = STATE(2054),
    [sym_preproc_endregion] = STATE(2054),
    [sym_preproc_line] = STATE(2054),
    [sym_preproc_pragma] = STATE(2054),
    [sym_preproc_nullable] = STATE(2054),
    [sym_preproc_error] = STATE(2054),
    [sym_preproc_warning] = STATE(2054),
    [sym_preproc_define] = STATE(2054),
    [sym_preproc_undef] = STATE(2054),
    [ts_builtin_sym_end] = ACTIONS(3261),
    [sym__identifier_token] = ACTIONS(3259),
    [anon_sym_extern] = ACTIONS(3259),
    [anon_sym_alias] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_global] = ACTIONS(3259),
    [anon_sym_using] = ACTIONS(3259),
    [anon_sym_unsafe] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_namespace] = ACTIONS(3259),
    [anon_sym_class] = ACTIONS(3259),
    [anon_sym_ref] = ACTIONS(3259),
    [anon_sym_struct] = ACTIONS(3259),
    [anon_sym_enum] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_interface] = ACTIONS(3259),
    [anon_sym_delegate] = ACTIONS(3259),
    [anon_sym_record] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_file] = ACTIONS(3259),
    [anon_sym_fixed] = ACTIONS(3259),
    [anon_sym_internal] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_override] = ACTIONS(3259),
    [anon_sym_partial] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_required] = ACTIONS(3259),
    [anon_sym_sealed] = ACTIONS(3259),
    [anon_sym_virtual] = ACTIONS(3259),
    [anon_sym_volatile] = ACTIONS(3259),
    [anon_sym_where] = ACTIONS(3259),
    [anon_sym_notnull] = ACTIONS(3259),
    [anon_sym_unmanaged] = ACTIONS(3259),
    [anon_sym_checked] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_true] = ACTIONS(3259),
    [anon_sym_false] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_this] = ACTIONS(3259),
    [anon_sym_scoped] = ACTIONS(3259),
    [anon_sym_base] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [sym_predefined_type] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_unchecked] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_lock] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_when] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_foreach] = ACTIONS(3259),
    [anon_sym_goto] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3261),
    [anon_sym_from] = ACTIONS(3259),
    [anon_sym_into] = ACTIONS(3259),
    [anon_sym_join] = ACTIONS(3259),
    [anon_sym_on] = ACTIONS(3259),
    [anon_sym_equals] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_orderby] = ACTIONS(3259),
    [anon_sym_ascending] = ACTIONS(3259),
    [anon_sym_descending] = ACTIONS(3259),
    [anon_sym_group] = ACTIONS(3259),
    [anon_sym_by] = ACTIONS(3259),
    [anon_sym_select] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3259),
    [anon_sym_sizeof] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym___makeref] = ACTIONS(3259),
    [anon_sym___reftype] = ACTIONS(3259),
    [anon_sym___refvalue] = ACTIONS(3259),
    [sym_null_literal] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [sym_real_literal] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [sym_verbatim_string_literal] = ACTIONS(3261),
    [aux_sym_preproc_if_token1] = ACTIONS(3261),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3261),
    [sym_interpolation_verbatim_start] = ACTIONS(3261),
    [sym_interpolation_raw_start] = ACTIONS(3261),
    [sym_raw_string_start] = ACTIONS(3261),
  },
  [2055] = {
    [sym_preproc_region] = STATE(2055),
    [sym_preproc_endregion] = STATE(2055),
    [sym_preproc_line] = STATE(2055),
    [sym_preproc_pragma] = STATE(2055),
    [sym_preproc_nullable] = STATE(2055),
    [sym_preproc_error] = STATE(2055),
    [sym_preproc_warning] = STATE(2055),
    [sym_preproc_define] = STATE(2055),
    [sym_preproc_undef] = STATE(2055),
    [ts_builtin_sym_end] = ACTIONS(3253),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_namespace] = ACTIONS(3251),
    [anon_sym_class] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_struct] = ACTIONS(3251),
    [anon_sym_enum] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_interface] = ACTIONS(3251),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_record] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_checked] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_true] = ACTIONS(3251),
    [anon_sym_false] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_this] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_base] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_unchecked] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_lock] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_foreach] = ACTIONS(3251),
    [anon_sym_goto] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3251),
    [anon_sym_sizeof] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym___makeref] = ACTIONS(3251),
    [anon_sym___reftype] = ACTIONS(3251),
    [anon_sym___refvalue] = ACTIONS(3251),
    [sym_null_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [sym_real_literal] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_verbatim_string_literal] = ACTIONS(3253),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3253),
    [sym_interpolation_verbatim_start] = ACTIONS(3253),
    [sym_interpolation_raw_start] = ACTIONS(3253),
    [sym_raw_string_start] = ACTIONS(3253),
  },
  [2056] = {
    [sym_preproc_region] = STATE(2056),
    [sym_preproc_endregion] = STATE(2056),
    [sym_preproc_line] = STATE(2056),
    [sym_preproc_pragma] = STATE(2056),
    [sym_preproc_nullable] = STATE(2056),
    [sym_preproc_error] = STATE(2056),
    [sym_preproc_warning] = STATE(2056),
    [sym_preproc_define] = STATE(2056),
    [sym_preproc_undef] = STATE(2056),
    [ts_builtin_sym_end] = ACTIONS(3245),
    [sym__identifier_token] = ACTIONS(3243),
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_alias] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_global] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_unsafe] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_ref] = ACTIONS(3243),
    [anon_sym_struct] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_delegate] = ACTIONS(3243),
    [anon_sym_record] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_file] = ACTIONS(3243),
    [anon_sym_fixed] = ACTIONS(3243),
    [anon_sym_internal] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_partial] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_required] = ACTIONS(3243),
    [anon_sym_sealed] = ACTIONS(3243),
    [anon_sym_virtual] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym_where] = ACTIONS(3243),
    [anon_sym_notnull] = ACTIONS(3243),
    [anon_sym_unmanaged] = ACTIONS(3243),
    [anon_sym_checked] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [anon_sym_true] = ACTIONS(3243),
    [anon_sym_false] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_this] = ACTIONS(3243),
    [anon_sym_scoped] = ACTIONS(3243),
    [anon_sym_base] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [sym_predefined_type] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_unchecked] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_lock] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_when] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_foreach] = ACTIONS(3243),
    [anon_sym_goto] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_DOT_DOT] = ACTIONS(3245),
    [anon_sym_from] = ACTIONS(3243),
    [anon_sym_into] = ACTIONS(3243),
    [anon_sym_join] = ACTIONS(3243),
    [anon_sym_on] = ACTIONS(3243),
    [anon_sym_equals] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_orderby] = ACTIONS(3243),
    [anon_sym_ascending] = ACTIONS(3243),
    [anon_sym_descending] = ACTIONS(3243),
    [anon_sym_group] = ACTIONS(3243),
    [anon_sym_by] = ACTIONS(3243),
    [anon_sym_select] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3243),
    [anon_sym_sizeof] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym___makeref] = ACTIONS(3243),
    [anon_sym___reftype] = ACTIONS(3243),
    [anon_sym___refvalue] = ACTIONS(3243),
    [sym_null_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [sym_integer_literal] = ACTIONS(3243),
    [sym_real_literal] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [sym_verbatim_string_literal] = ACTIONS(3245),
    [aux_sym_preproc_if_token1] = ACTIONS(3245),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3245),
    [sym_interpolation_verbatim_start] = ACTIONS(3245),
    [sym_interpolation_raw_start] = ACTIONS(3245),
    [sym_raw_string_start] = ACTIONS(3245),
  },
  [2057] = {
    [sym_preproc_region] = STATE(2057),
    [sym_preproc_endregion] = STATE(2057),
    [sym_preproc_line] = STATE(2057),
    [sym_preproc_pragma] = STATE(2057),
    [sym_preproc_nullable] = STATE(2057),
    [sym_preproc_error] = STATE(2057),
    [sym_preproc_warning] = STATE(2057),
    [sym_preproc_define] = STATE(2057),
    [sym_preproc_undef] = STATE(2057),
    [ts_builtin_sym_end] = ACTIONS(3277),
    [sym__identifier_token] = ACTIONS(3275),
    [anon_sym_extern] = ACTIONS(3275),
    [anon_sym_alias] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_global] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_unsafe] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_ref] = ACTIONS(3275),
    [anon_sym_struct] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_delegate] = ACTIONS(3275),
    [anon_sym_record] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_file] = ACTIONS(3275),
    [anon_sym_fixed] = ACTIONS(3275),
    [anon_sym_internal] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_partial] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_required] = ACTIONS(3275),
    [anon_sym_sealed] = ACTIONS(3275),
    [anon_sym_virtual] = ACTIONS(3275),
    [anon_sym_volatile] = ACTIONS(3275),
    [anon_sym_where] = ACTIONS(3275),
    [anon_sym_notnull] = ACTIONS(3275),
    [anon_sym_unmanaged] = ACTIONS(3275),
    [anon_sym_checked] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_true] = ACTIONS(3275),
    [anon_sym_false] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(3277),
    [anon_sym_CARET] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(3277),
    [anon_sym_this] = ACTIONS(3275),
    [anon_sym_scoped] = ACTIONS(3275),
    [anon_sym_base] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [sym_predefined_type] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_unchecked] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_lock] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_when] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_foreach] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_DOT_DOT] = ACTIONS(3277),
    [anon_sym_from] = ACTIONS(3275),
    [anon_sym_into] = ACTIONS(3275),
    [anon_sym_join] = ACTIONS(3275),
    [anon_sym_on] = ACTIONS(3275),
    [anon_sym_equals] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_orderby] = ACTIONS(3275),
    [anon_sym_ascending] = ACTIONS(3275),
    [anon_sym_descending] = ACTIONS(3275),
    [anon_sym_group] = ACTIONS(3275),
    [anon_sym_by] = ACTIONS(3275),
    [anon_sym_select] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3275),
    [anon_sym_sizeof] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym___makeref] = ACTIONS(3275),
    [anon_sym___reftype] = ACTIONS(3275),
    [anon_sym___refvalue] = ACTIONS(3275),
    [sym_null_literal] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_integer_literal] = ACTIONS(3275),
    [sym_real_literal] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [sym_verbatim_string_literal] = ACTIONS(3277),
    [aux_sym_preproc_if_token1] = ACTIONS(3277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3277),
    [sym_interpolation_verbatim_start] = ACTIONS(3277),
    [sym_interpolation_raw_start] = ACTIONS(3277),
    [sym_raw_string_start] = ACTIONS(3277),
  },
  [2058] = {
    [sym_preproc_region] = STATE(2058),
    [sym_preproc_endregion] = STATE(2058),
    [sym_preproc_line] = STATE(2058),
    [sym_preproc_pragma] = STATE(2058),
    [sym_preproc_nullable] = STATE(2058),
    [sym_preproc_error] = STATE(2058),
    [sym_preproc_warning] = STATE(2058),
    [sym_preproc_define] = STATE(2058),
    [sym_preproc_undef] = STATE(2058),
    [ts_builtin_sym_end] = ACTIONS(3175),
    [sym__identifier_token] = ACTIONS(3173),
    [anon_sym_extern] = ACTIONS(3173),
    [anon_sym_alias] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_global] = ACTIONS(3173),
    [anon_sym_using] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(3173),
    [anon_sym_static] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(3175),
    [anon_sym_return] = ACTIONS(3173),
    [anon_sym_namespace] = ACTIONS(3173),
    [anon_sym_class] = ACTIONS(3173),
    [anon_sym_ref] = ACTIONS(3173),
    [anon_sym_struct] = ACTIONS(3173),
    [anon_sym_enum] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_interface] = ACTIONS(3173),
    [anon_sym_delegate] = ACTIONS(3173),
    [anon_sym_record] = ACTIONS(3173),
    [anon_sym_abstract] = ACTIONS(3173),
    [anon_sym_async] = ACTIONS(3173),
    [anon_sym_const] = ACTIONS(3173),
    [anon_sym_file] = ACTIONS(3173),
    [anon_sym_fixed] = ACTIONS(3173),
    [anon_sym_internal] = ACTIONS(3173),
    [anon_sym_new] = ACTIONS(3173),
    [anon_sym_override] = ACTIONS(3173),
    [anon_sym_partial] = ACTIONS(3173),
    [anon_sym_private] = ACTIONS(3173),
    [anon_sym_protected] = ACTIONS(3173),
    [anon_sym_public] = ACTIONS(3173),
    [anon_sym_readonly] = ACTIONS(3173),
    [anon_sym_required] = ACTIONS(3173),
    [anon_sym_sealed] = ACTIONS(3173),
    [anon_sym_virtual] = ACTIONS(3173),
    [anon_sym_volatile] = ACTIONS(3173),
    [anon_sym_where] = ACTIONS(3173),
    [anon_sym_notnull] = ACTIONS(3173),
    [anon_sym_unmanaged] = ACTIONS(3173),
    [anon_sym_checked] = ACTIONS(3173),
    [anon_sym_BANG] = ACTIONS(3175),
    [anon_sym_TILDE] = ACTIONS(3175),
    [anon_sym_PLUS_PLUS] = ACTIONS(3175),
    [anon_sym_DASH_DASH] = ACTIONS(3175),
    [anon_sym_true] = ACTIONS(3173),
    [anon_sym_false] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3173),
    [anon_sym_DASH] = ACTIONS(3173),
    [anon_sym_STAR] = ACTIONS(3175),
    [anon_sym_CARET] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3175),
    [anon_sym_this] = ACTIONS(3173),
    [anon_sym_scoped] = ACTIONS(3173),
    [anon_sym_base] = ACTIONS(3173),
    [anon_sym_var] = ACTIONS(3173),
    [sym_predefined_type] = ACTIONS(3173),
    [anon_sym_break] = ACTIONS(3173),
    [anon_sym_unchecked] = ACTIONS(3173),
    [anon_sym_continue] = ACTIONS(3173),
    [anon_sym_do] = ACTIONS(3173),
    [anon_sym_while] = ACTIONS(3173),
    [anon_sym_for] = ACTIONS(3173),
    [anon_sym_lock] = ACTIONS(3173),
    [anon_sym_yield] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3173),
    [anon_sym_default] = ACTIONS(3173),
    [anon_sym_throw] = ACTIONS(3173),
    [anon_sym_try] = ACTIONS(3173),
    [anon_sym_when] = ACTIONS(3173),
    [anon_sym_await] = ACTIONS(3173),
    [anon_sym_foreach] = ACTIONS(3173),
    [anon_sym_goto] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3173),
    [anon_sym_DOT_DOT] = ACTIONS(3175),
    [anon_sym_from] = ACTIONS(3173),
    [anon_sym_into] = ACTIONS(3173),
    [anon_sym_join] = ACTIONS(3173),
    [anon_sym_on] = ACTIONS(3173),
    [anon_sym_equals] = ACTIONS(3173),
    [anon_sym_let] = ACTIONS(3173),
    [anon_sym_orderby] = ACTIONS(3173),
    [anon_sym_ascending] = ACTIONS(3173),
    [anon_sym_descending] = ACTIONS(3173),
    [anon_sym_group] = ACTIONS(3173),
    [anon_sym_by] = ACTIONS(3173),
    [anon_sym_select] = ACTIONS(3173),
    [anon_sym_stackalloc] = ACTIONS(3173),
    [anon_sym_sizeof] = ACTIONS(3173),
    [anon_sym_typeof] = ACTIONS(3173),
    [anon_sym___makeref] = ACTIONS(3173),
    [anon_sym___reftype] = ACTIONS(3173),
    [anon_sym___refvalue] = ACTIONS(3173),
    [sym_null_literal] = ACTIONS(3173),
    [anon_sym_SQUOTE] = ACTIONS(3175),
    [sym_integer_literal] = ACTIONS(3173),
    [sym_real_literal] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3175),
    [sym_verbatim_string_literal] = ACTIONS(3175),
    [aux_sym_preproc_if_token1] = ACTIONS(3175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3175),
    [sym_interpolation_verbatim_start] = ACTIONS(3175),
    [sym_interpolation_raw_start] = ACTIONS(3175),
    [sym_raw_string_start] = ACTIONS(3175),
  },
  [2059] = {
    [sym_preproc_region] = STATE(2059),
    [sym_preproc_endregion] = STATE(2059),
    [sym_preproc_line] = STATE(2059),
    [sym_preproc_pragma] = STATE(2059),
    [sym_preproc_nullable] = STATE(2059),
    [sym_preproc_error] = STATE(2059),
    [sym_preproc_warning] = STATE(2059),
    [sym_preproc_define] = STATE(2059),
    [sym_preproc_undef] = STATE(2059),
    [ts_builtin_sym_end] = ACTIONS(3329),
    [sym__identifier_token] = ACTIONS(3327),
    [anon_sym_extern] = ACTIONS(3327),
    [anon_sym_alias] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_global] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_unsafe] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_struct] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_delegate] = ACTIONS(3327),
    [anon_sym_record] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_file] = ACTIONS(3327),
    [anon_sym_fixed] = ACTIONS(3327),
    [anon_sym_internal] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_partial] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_required] = ACTIONS(3327),
    [anon_sym_sealed] = ACTIONS(3327),
    [anon_sym_virtual] = ACTIONS(3327),
    [anon_sym_volatile] = ACTIONS(3327),
    [anon_sym_where] = ACTIONS(3327),
    [anon_sym_notnull] = ACTIONS(3327),
    [anon_sym_unmanaged] = ACTIONS(3327),
    [anon_sym_checked] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_true] = ACTIONS(3327),
    [anon_sym_false] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3329),
    [anon_sym_this] = ACTIONS(3327),
    [anon_sym_scoped] = ACTIONS(3327),
    [anon_sym_base] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [sym_predefined_type] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_unchecked] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_when] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_DOT_DOT] = ACTIONS(3329),
    [anon_sym_from] = ACTIONS(3327),
    [anon_sym_into] = ACTIONS(3327),
    [anon_sym_join] = ACTIONS(3327),
    [anon_sym_on] = ACTIONS(3327),
    [anon_sym_equals] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_orderby] = ACTIONS(3327),
    [anon_sym_ascending] = ACTIONS(3327),
    [anon_sym_descending] = ACTIONS(3327),
    [anon_sym_group] = ACTIONS(3327),
    [anon_sym_by] = ACTIONS(3327),
    [anon_sym_select] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3327),
    [anon_sym_sizeof] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym___makeref] = ACTIONS(3327),
    [anon_sym___reftype] = ACTIONS(3327),
    [anon_sym___refvalue] = ACTIONS(3327),
    [sym_null_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [sym_integer_literal] = ACTIONS(3327),
    [sym_real_literal] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [sym_verbatim_string_literal] = ACTIONS(3329),
    [aux_sym_preproc_if_token1] = ACTIONS(3329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3329),
    [sym_interpolation_verbatim_start] = ACTIONS(3329),
    [sym_interpolation_raw_start] = ACTIONS(3329),
    [sym_raw_string_start] = ACTIONS(3329),
  },
  [2060] = {
    [sym_preproc_region] = STATE(2060),
    [sym_preproc_endregion] = STATE(2060),
    [sym_preproc_line] = STATE(2060),
    [sym_preproc_pragma] = STATE(2060),
    [sym_preproc_nullable] = STATE(2060),
    [sym_preproc_error] = STATE(2060),
    [sym_preproc_warning] = STATE(2060),
    [sym_preproc_define] = STATE(2060),
    [sym_preproc_undef] = STATE(2060),
    [ts_builtin_sym_end] = ACTIONS(3187),
    [sym__identifier_token] = ACTIONS(3185),
    [anon_sym_extern] = ACTIONS(3185),
    [anon_sym_alias] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_global] = ACTIONS(3185),
    [anon_sym_using] = ACTIONS(3185),
    [anon_sym_unsafe] = ACTIONS(3185),
    [anon_sym_static] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_namespace] = ACTIONS(3185),
    [anon_sym_class] = ACTIONS(3185),
    [anon_sym_ref] = ACTIONS(3185),
    [anon_sym_struct] = ACTIONS(3185),
    [anon_sym_enum] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3185),
    [anon_sym_delegate] = ACTIONS(3185),
    [anon_sym_record] = ACTIONS(3185),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_async] = ACTIONS(3185),
    [anon_sym_const] = ACTIONS(3185),
    [anon_sym_file] = ACTIONS(3185),
    [anon_sym_fixed] = ACTIONS(3185),
    [anon_sym_internal] = ACTIONS(3185),
    [anon_sym_new] = ACTIONS(3185),
    [anon_sym_override] = ACTIONS(3185),
    [anon_sym_partial] = ACTIONS(3185),
    [anon_sym_private] = ACTIONS(3185),
    [anon_sym_protected] = ACTIONS(3185),
    [anon_sym_public] = ACTIONS(3185),
    [anon_sym_readonly] = ACTIONS(3185),
    [anon_sym_required] = ACTIONS(3185),
    [anon_sym_sealed] = ACTIONS(3185),
    [anon_sym_virtual] = ACTIONS(3185),
    [anon_sym_volatile] = ACTIONS(3185),
    [anon_sym_where] = ACTIONS(3185),
    [anon_sym_notnull] = ACTIONS(3185),
    [anon_sym_unmanaged] = ACTIONS(3185),
    [anon_sym_checked] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [anon_sym_true] = ACTIONS(3185),
    [anon_sym_false] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_CARET] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_this] = ACTIONS(3185),
    [anon_sym_scoped] = ACTIONS(3185),
    [anon_sym_base] = ACTIONS(3185),
    [anon_sym_var] = ACTIONS(3185),
    [sym_predefined_type] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_unchecked] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_do] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_lock] = ACTIONS(3185),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_switch] = ACTIONS(3185),
    [anon_sym_default] = ACTIONS(3185),
    [anon_sym_throw] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [anon_sym_when] = ACTIONS(3185),
    [anon_sym_await] = ACTIONS(3185),
    [anon_sym_foreach] = ACTIONS(3185),
    [anon_sym_goto] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3185),
    [anon_sym_DOT_DOT] = ACTIONS(3187),
    [anon_sym_from] = ACTIONS(3185),
    [anon_sym_into] = ACTIONS(3185),
    [anon_sym_join] = ACTIONS(3185),
    [anon_sym_on] = ACTIONS(3185),
    [anon_sym_equals] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(3185),
    [anon_sym_orderby] = ACTIONS(3185),
    [anon_sym_ascending] = ACTIONS(3185),
    [anon_sym_descending] = ACTIONS(3185),
    [anon_sym_group] = ACTIONS(3185),
    [anon_sym_by] = ACTIONS(3185),
    [anon_sym_select] = ACTIONS(3185),
    [anon_sym_stackalloc] = ACTIONS(3185),
    [anon_sym_sizeof] = ACTIONS(3185),
    [anon_sym_typeof] = ACTIONS(3185),
    [anon_sym___makeref] = ACTIONS(3185),
    [anon_sym___reftype] = ACTIONS(3185),
    [anon_sym___refvalue] = ACTIONS(3185),
    [sym_null_literal] = ACTIONS(3185),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [sym_integer_literal] = ACTIONS(3185),
    [sym_real_literal] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [sym_verbatim_string_literal] = ACTIONS(3187),
    [aux_sym_preproc_if_token1] = ACTIONS(3187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3187),
    [sym_interpolation_verbatim_start] = ACTIONS(3187),
    [sym_interpolation_raw_start] = ACTIONS(3187),
    [sym_raw_string_start] = ACTIONS(3187),
  },
  [2061] = {
    [sym_preproc_region] = STATE(2061),
    [sym_preproc_endregion] = STATE(2061),
    [sym_preproc_line] = STATE(2061),
    [sym_preproc_pragma] = STATE(2061),
    [sym_preproc_nullable] = STATE(2061),
    [sym_preproc_error] = STATE(2061),
    [sym_preproc_warning] = STATE(2061),
    [sym_preproc_define] = STATE(2061),
    [sym_preproc_undef] = STATE(2061),
    [ts_builtin_sym_end] = ACTIONS(3337),
    [sym__identifier_token] = ACTIONS(3335),
    [anon_sym_extern] = ACTIONS(3335),
    [anon_sym_alias] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_global] = ACTIONS(3335),
    [anon_sym_using] = ACTIONS(3335),
    [anon_sym_unsafe] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_namespace] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_struct] = ACTIONS(3335),
    [anon_sym_enum] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_interface] = ACTIONS(3335),
    [anon_sym_delegate] = ACTIONS(3335),
    [anon_sym_record] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_file] = ACTIONS(3335),
    [anon_sym_fixed] = ACTIONS(3335),
    [anon_sym_internal] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_override] = ACTIONS(3335),
    [anon_sym_partial] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_required] = ACTIONS(3335),
    [anon_sym_sealed] = ACTIONS(3335),
    [anon_sym_virtual] = ACTIONS(3335),
    [anon_sym_volatile] = ACTIONS(3335),
    [anon_sym_where] = ACTIONS(3335),
    [anon_sym_notnull] = ACTIONS(3335),
    [anon_sym_unmanaged] = ACTIONS(3335),
    [anon_sym_checked] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_TILDE] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_true] = ACTIONS(3335),
    [anon_sym_false] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_this] = ACTIONS(3335),
    [anon_sym_scoped] = ACTIONS(3335),
    [anon_sym_base] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [sym_predefined_type] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_unchecked] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_when] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_DOT_DOT] = ACTIONS(3337),
    [anon_sym_from] = ACTIONS(3335),
    [anon_sym_into] = ACTIONS(3335),
    [anon_sym_join] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [anon_sym_equals] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_orderby] = ACTIONS(3335),
    [anon_sym_ascending] = ACTIONS(3335),
    [anon_sym_descending] = ACTIONS(3335),
    [anon_sym_group] = ACTIONS(3335),
    [anon_sym_by] = ACTIONS(3335),
    [anon_sym_select] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3335),
    [anon_sym_sizeof] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym___makeref] = ACTIONS(3335),
    [anon_sym___reftype] = ACTIONS(3335),
    [anon_sym___refvalue] = ACTIONS(3335),
    [sym_null_literal] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_integer_literal] = ACTIONS(3335),
    [sym_real_literal] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [sym_verbatim_string_literal] = ACTIONS(3337),
    [aux_sym_preproc_if_token1] = ACTIONS(3337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3337),
    [sym_interpolation_verbatim_start] = ACTIONS(3337),
    [sym_interpolation_raw_start] = ACTIONS(3337),
    [sym_raw_string_start] = ACTIONS(3337),
  },
  [2062] = {
    [sym_preproc_region] = STATE(2062),
    [sym_preproc_endregion] = STATE(2062),
    [sym_preproc_line] = STATE(2062),
    [sym_preproc_pragma] = STATE(2062),
    [sym_preproc_nullable] = STATE(2062),
    [sym_preproc_error] = STATE(2062),
    [sym_preproc_warning] = STATE(2062),
    [sym_preproc_define] = STATE(2062),
    [sym_preproc_undef] = STATE(2062),
    [ts_builtin_sym_end] = ACTIONS(3217),
    [sym__identifier_token] = ACTIONS(3215),
    [anon_sym_extern] = ACTIONS(3215),
    [anon_sym_alias] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_global] = ACTIONS(3215),
    [anon_sym_using] = ACTIONS(3215),
    [anon_sym_unsafe] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_namespace] = ACTIONS(3215),
    [anon_sym_class] = ACTIONS(3215),
    [anon_sym_ref] = ACTIONS(3215),
    [anon_sym_struct] = ACTIONS(3215),
    [anon_sym_enum] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3215),
    [anon_sym_delegate] = ACTIONS(3215),
    [anon_sym_record] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_file] = ACTIONS(3215),
    [anon_sym_fixed] = ACTIONS(3215),
    [anon_sym_internal] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_override] = ACTIONS(3215),
    [anon_sym_partial] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_required] = ACTIONS(3215),
    [anon_sym_sealed] = ACTIONS(3215),
    [anon_sym_virtual] = ACTIONS(3215),
    [anon_sym_volatile] = ACTIONS(3215),
    [anon_sym_where] = ACTIONS(3215),
    [anon_sym_notnull] = ACTIONS(3215),
    [anon_sym_unmanaged] = ACTIONS(3215),
    [anon_sym_checked] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_true] = ACTIONS(3215),
    [anon_sym_false] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3217),
    [anon_sym_CARET] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3217),
    [anon_sym_this] = ACTIONS(3215),
    [anon_sym_scoped] = ACTIONS(3215),
    [anon_sym_base] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [sym_predefined_type] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_unchecked] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_lock] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_when] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_foreach] = ACTIONS(3215),
    [anon_sym_goto] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_DOT_DOT] = ACTIONS(3217),
    [anon_sym_from] = ACTIONS(3215),
    [anon_sym_into] = ACTIONS(3215),
    [anon_sym_join] = ACTIONS(3215),
    [anon_sym_on] = ACTIONS(3215),
    [anon_sym_equals] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_orderby] = ACTIONS(3215),
    [anon_sym_ascending] = ACTIONS(3215),
    [anon_sym_descending] = ACTIONS(3215),
    [anon_sym_group] = ACTIONS(3215),
    [anon_sym_by] = ACTIONS(3215),
    [anon_sym_select] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3215),
    [anon_sym_sizeof] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym___makeref] = ACTIONS(3215),
    [anon_sym___reftype] = ACTIONS(3215),
    [anon_sym___refvalue] = ACTIONS(3215),
    [sym_null_literal] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_integer_literal] = ACTIONS(3215),
    [sym_real_literal] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [sym_verbatim_string_literal] = ACTIONS(3217),
    [aux_sym_preproc_if_token1] = ACTIONS(3217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3217),
    [sym_interpolation_verbatim_start] = ACTIONS(3217),
    [sym_interpolation_raw_start] = ACTIONS(3217),
    [sym_raw_string_start] = ACTIONS(3217),
  },
  [2063] = {
    [sym_preproc_region] = STATE(2063),
    [sym_preproc_endregion] = STATE(2063),
    [sym_preproc_line] = STATE(2063),
    [sym_preproc_pragma] = STATE(2063),
    [sym_preproc_nullable] = STATE(2063),
    [sym_preproc_error] = STATE(2063),
    [sym_preproc_warning] = STATE(2063),
    [sym_preproc_define] = STATE(2063),
    [sym_preproc_undef] = STATE(2063),
    [ts_builtin_sym_end] = ACTIONS(3305),
    [sym__identifier_token] = ACTIONS(3303),
    [anon_sym_extern] = ACTIONS(3303),
    [anon_sym_alias] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_global] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_unsafe] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(3303),
    [anon_sym_struct] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_delegate] = ACTIONS(3303),
    [anon_sym_record] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_file] = ACTIONS(3303),
    [anon_sym_fixed] = ACTIONS(3303),
    [anon_sym_internal] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_partial] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_required] = ACTIONS(3303),
    [anon_sym_sealed] = ACTIONS(3303),
    [anon_sym_virtual] = ACTIONS(3303),
    [anon_sym_volatile] = ACTIONS(3303),
    [anon_sym_where] = ACTIONS(3303),
    [anon_sym_notnull] = ACTIONS(3303),
    [anon_sym_unmanaged] = ACTIONS(3303),
    [anon_sym_checked] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [anon_sym_true] = ACTIONS(3303),
    [anon_sym_false] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3305),
    [anon_sym_CARET] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_this] = ACTIONS(3303),
    [anon_sym_scoped] = ACTIONS(3303),
    [anon_sym_base] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [sym_predefined_type] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_unchecked] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_lock] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_when] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_foreach] = ACTIONS(3303),
    [anon_sym_goto] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_DOT_DOT] = ACTIONS(3305),
    [anon_sym_from] = ACTIONS(3303),
    [anon_sym_into] = ACTIONS(3303),
    [anon_sym_join] = ACTIONS(3303),
    [anon_sym_on] = ACTIONS(3303),
    [anon_sym_equals] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_orderby] = ACTIONS(3303),
    [anon_sym_ascending] = ACTIONS(3303),
    [anon_sym_descending] = ACTIONS(3303),
    [anon_sym_group] = ACTIONS(3303),
    [anon_sym_by] = ACTIONS(3303),
    [anon_sym_select] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym___makeref] = ACTIONS(3303),
    [anon_sym___reftype] = ACTIONS(3303),
    [anon_sym___refvalue] = ACTIONS(3303),
    [sym_null_literal] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [sym_integer_literal] = ACTIONS(3303),
    [sym_real_literal] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [sym_verbatim_string_literal] = ACTIONS(3305),
    [aux_sym_preproc_if_token1] = ACTIONS(3305),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3305),
    [sym_interpolation_verbatim_start] = ACTIONS(3305),
    [sym_interpolation_raw_start] = ACTIONS(3305),
    [sym_raw_string_start] = ACTIONS(3305),
  },
  [2064] = {
    [sym_preproc_region] = STATE(2064),
    [sym_preproc_endregion] = STATE(2064),
    [sym_preproc_line] = STATE(2064),
    [sym_preproc_pragma] = STATE(2064),
    [sym_preproc_nullable] = STATE(2064),
    [sym_preproc_error] = STATE(2064),
    [sym_preproc_warning] = STATE(2064),
    [sym_preproc_define] = STATE(2064),
    [sym_preproc_undef] = STATE(2064),
    [ts_builtin_sym_end] = ACTIONS(3241),
    [sym__identifier_token] = ACTIONS(3239),
    [anon_sym_extern] = ACTIONS(3239),
    [anon_sym_alias] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_global] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_unsafe] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_ref] = ACTIONS(3239),
    [anon_sym_struct] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_delegate] = ACTIONS(3239),
    [anon_sym_record] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_file] = ACTIONS(3239),
    [anon_sym_fixed] = ACTIONS(3239),
    [anon_sym_internal] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_partial] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_required] = ACTIONS(3239),
    [anon_sym_sealed] = ACTIONS(3239),
    [anon_sym_virtual] = ACTIONS(3239),
    [anon_sym_volatile] = ACTIONS(3239),
    [anon_sym_where] = ACTIONS(3239),
    [anon_sym_notnull] = ACTIONS(3239),
    [anon_sym_unmanaged] = ACTIONS(3239),
    [anon_sym_checked] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [anon_sym_true] = ACTIONS(3239),
    [anon_sym_false] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_STAR] = ACTIONS(3241),
    [anon_sym_CARET] = ACTIONS(3241),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_this] = ACTIONS(3239),
    [anon_sym_scoped] = ACTIONS(3239),
    [anon_sym_base] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [sym_predefined_type] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_unchecked] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_lock] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_when] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_foreach] = ACTIONS(3239),
    [anon_sym_goto] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_DOT_DOT] = ACTIONS(3241),
    [anon_sym_from] = ACTIONS(3239),
    [anon_sym_into] = ACTIONS(3239),
    [anon_sym_join] = ACTIONS(3239),
    [anon_sym_on] = ACTIONS(3239),
    [anon_sym_equals] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_orderby] = ACTIONS(3239),
    [anon_sym_ascending] = ACTIONS(3239),
    [anon_sym_descending] = ACTIONS(3239),
    [anon_sym_group] = ACTIONS(3239),
    [anon_sym_by] = ACTIONS(3239),
    [anon_sym_select] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3239),
    [anon_sym_sizeof] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym___makeref] = ACTIONS(3239),
    [anon_sym___reftype] = ACTIONS(3239),
    [anon_sym___refvalue] = ACTIONS(3239),
    [sym_null_literal] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [sym_integer_literal] = ACTIONS(3239),
    [sym_real_literal] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [sym_verbatim_string_literal] = ACTIONS(3241),
    [aux_sym_preproc_if_token1] = ACTIONS(3241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3241),
    [sym_interpolation_verbatim_start] = ACTIONS(3241),
    [sym_interpolation_raw_start] = ACTIONS(3241),
    [sym_raw_string_start] = ACTIONS(3241),
  },
  [2065] = {
    [sym_preproc_region] = STATE(2065),
    [sym_preproc_endregion] = STATE(2065),
    [sym_preproc_line] = STATE(2065),
    [sym_preproc_pragma] = STATE(2065),
    [sym_preproc_nullable] = STATE(2065),
    [sym_preproc_error] = STATE(2065),
    [sym_preproc_warning] = STATE(2065),
    [sym_preproc_define] = STATE(2065),
    [sym_preproc_undef] = STATE(2065),
    [ts_builtin_sym_end] = ACTIONS(3309),
    [sym__identifier_token] = ACTIONS(3307),
    [anon_sym_extern] = ACTIONS(3307),
    [anon_sym_alias] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_unsafe] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_namespace] = ACTIONS(3307),
    [anon_sym_class] = ACTIONS(3307),
    [anon_sym_ref] = ACTIONS(3307),
    [anon_sym_struct] = ACTIONS(3307),
    [anon_sym_enum] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3307),
    [anon_sym_delegate] = ACTIONS(3307),
    [anon_sym_record] = ACTIONS(3307),
    [anon_sym_abstract] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_const] = ACTIONS(3307),
    [anon_sym_file] = ACTIONS(3307),
    [anon_sym_fixed] = ACTIONS(3307),
    [anon_sym_internal] = ACTIONS(3307),
    [anon_sym_new] = ACTIONS(3307),
    [anon_sym_override] = ACTIONS(3307),
    [anon_sym_partial] = ACTIONS(3307),
    [anon_sym_private] = ACTIONS(3307),
    [anon_sym_protected] = ACTIONS(3307),
    [anon_sym_public] = ACTIONS(3307),
    [anon_sym_readonly] = ACTIONS(3307),
    [anon_sym_required] = ACTIONS(3307),
    [anon_sym_sealed] = ACTIONS(3307),
    [anon_sym_virtual] = ACTIONS(3307),
    [anon_sym_volatile] = ACTIONS(3307),
    [anon_sym_where] = ACTIONS(3307),
    [anon_sym_notnull] = ACTIONS(3307),
    [anon_sym_unmanaged] = ACTIONS(3307),
    [anon_sym_checked] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(3307),
    [anon_sym_false] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3307),
    [anon_sym_scoped] = ACTIONS(3307),
    [anon_sym_base] = ACTIONS(3307),
    [anon_sym_var] = ACTIONS(3307),
    [sym_predefined_type] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3307),
    [anon_sym_unchecked] = ACTIONS(3307),
    [anon_sym_continue] = ACTIONS(3307),
    [anon_sym_do] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_lock] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3307),
    [anon_sym_default] = ACTIONS(3307),
    [anon_sym_throw] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_when] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [anon_sym_foreach] = ACTIONS(3307),
    [anon_sym_goto] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_DOT_DOT] = ACTIONS(3309),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_into] = ACTIONS(3307),
    [anon_sym_join] = ACTIONS(3307),
    [anon_sym_on] = ACTIONS(3307),
    [anon_sym_equals] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3307),
    [anon_sym_orderby] = ACTIONS(3307),
    [anon_sym_ascending] = ACTIONS(3307),
    [anon_sym_descending] = ACTIONS(3307),
    [anon_sym_group] = ACTIONS(3307),
    [anon_sym_by] = ACTIONS(3307),
    [anon_sym_select] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3307),
    [anon_sym_sizeof] = ACTIONS(3307),
    [anon_sym_typeof] = ACTIONS(3307),
    [anon_sym___makeref] = ACTIONS(3307),
    [anon_sym___reftype] = ACTIONS(3307),
    [anon_sym___refvalue] = ACTIONS(3307),
    [sym_null_literal] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [sym_integer_literal] = ACTIONS(3307),
    [sym_real_literal] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [sym_verbatim_string_literal] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3309),
    [sym_interpolation_verbatim_start] = ACTIONS(3309),
    [sym_interpolation_raw_start] = ACTIONS(3309),
    [sym_raw_string_start] = ACTIONS(3309),
  },
  [2066] = {
    [sym_preproc_region] = STATE(2066),
    [sym_preproc_endregion] = STATE(2066),
    [sym_preproc_line] = STATE(2066),
    [sym_preproc_pragma] = STATE(2066),
    [sym_preproc_nullable] = STATE(2066),
    [sym_preproc_error] = STATE(2066),
    [sym_preproc_warning] = STATE(2066),
    [sym_preproc_define] = STATE(2066),
    [sym_preproc_undef] = STATE(2066),
    [ts_builtin_sym_end] = ACTIONS(3257),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_struct] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_record] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_checked] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_true] = ACTIONS(3255),
    [anon_sym_false] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_this] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_base] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_unchecked] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_DOT_DOT] = ACTIONS(3257),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3255),
    [anon_sym_sizeof] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym___makeref] = ACTIONS(3255),
    [anon_sym___reftype] = ACTIONS(3255),
    [anon_sym___refvalue] = ACTIONS(3255),
    [sym_null_literal] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [sym_real_literal] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [sym_verbatim_string_literal] = ACTIONS(3257),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3257),
    [sym_interpolation_verbatim_start] = ACTIONS(3257),
    [sym_interpolation_raw_start] = ACTIONS(3257),
    [sym_raw_string_start] = ACTIONS(3257),
  },
  [2067] = {
    [sym_preproc_region] = STATE(2067),
    [sym_preproc_endregion] = STATE(2067),
    [sym_preproc_line] = STATE(2067),
    [sym_preproc_pragma] = STATE(2067),
    [sym_preproc_nullable] = STATE(2067),
    [sym_preproc_error] = STATE(2067),
    [sym_preproc_warning] = STATE(2067),
    [sym_preproc_define] = STATE(2067),
    [sym_preproc_undef] = STATE(2067),
    [ts_builtin_sym_end] = ACTIONS(3301),
    [sym__identifier_token] = ACTIONS(3299),
    [anon_sym_extern] = ACTIONS(3299),
    [anon_sym_alias] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_unsafe] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_ref] = ACTIONS(3299),
    [anon_sym_struct] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_delegate] = ACTIONS(3299),
    [anon_sym_record] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_file] = ACTIONS(3299),
    [anon_sym_fixed] = ACTIONS(3299),
    [anon_sym_internal] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_partial] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_required] = ACTIONS(3299),
    [anon_sym_sealed] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3299),
    [anon_sym_volatile] = ACTIONS(3299),
    [anon_sym_where] = ACTIONS(3299),
    [anon_sym_notnull] = ACTIONS(3299),
    [anon_sym_unmanaged] = ACTIONS(3299),
    [anon_sym_checked] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [anon_sym_true] = ACTIONS(3299),
    [anon_sym_false] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_CARET] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3299),
    [anon_sym_scoped] = ACTIONS(3299),
    [anon_sym_base] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [sym_predefined_type] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_unchecked] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_lock] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_when] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_foreach] = ACTIONS(3299),
    [anon_sym_goto] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_DOT_DOT] = ACTIONS(3301),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_into] = ACTIONS(3299),
    [anon_sym_join] = ACTIONS(3299),
    [anon_sym_on] = ACTIONS(3299),
    [anon_sym_equals] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_orderby] = ACTIONS(3299),
    [anon_sym_ascending] = ACTIONS(3299),
    [anon_sym_descending] = ACTIONS(3299),
    [anon_sym_group] = ACTIONS(3299),
    [anon_sym_by] = ACTIONS(3299),
    [anon_sym_select] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym___makeref] = ACTIONS(3299),
    [anon_sym___reftype] = ACTIONS(3299),
    [anon_sym___refvalue] = ACTIONS(3299),
    [sym_null_literal] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [sym_integer_literal] = ACTIONS(3299),
    [sym_real_literal] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [sym_verbatim_string_literal] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3301),
    [sym_interpolation_verbatim_start] = ACTIONS(3301),
    [sym_interpolation_raw_start] = ACTIONS(3301),
    [sym_raw_string_start] = ACTIONS(3301),
  },
  [2068] = {
    [sym_preproc_region] = STATE(2068),
    [sym_preproc_endregion] = STATE(2068),
    [sym_preproc_line] = STATE(2068),
    [sym_preproc_pragma] = STATE(2068),
    [sym_preproc_nullable] = STATE(2068),
    [sym_preproc_error] = STATE(2068),
    [sym_preproc_warning] = STATE(2068),
    [sym_preproc_define] = STATE(2068),
    [sym_preproc_undef] = STATE(2068),
    [ts_builtin_sym_end] = ACTIONS(3385),
    [sym__identifier_token] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym_alias] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_global] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_unsafe] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_ref] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_delegate] = ACTIONS(3383),
    [anon_sym_record] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_file] = ACTIONS(3383),
    [anon_sym_fixed] = ACTIONS(3383),
    [anon_sym_internal] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_partial] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_required] = ACTIONS(3383),
    [anon_sym_sealed] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_where] = ACTIONS(3383),
    [anon_sym_notnull] = ACTIONS(3383),
    [anon_sym_unmanaged] = ACTIONS(3383),
    [anon_sym_checked] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_true] = ACTIONS(3383),
    [anon_sym_false] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_this] = ACTIONS(3383),
    [anon_sym_scoped] = ACTIONS(3383),
    [anon_sym_base] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [sym_predefined_type] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_unchecked] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_lock] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_when] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_foreach] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_DOT_DOT] = ACTIONS(3385),
    [anon_sym_from] = ACTIONS(3383),
    [anon_sym_into] = ACTIONS(3383),
    [anon_sym_join] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [anon_sym_equals] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_orderby] = ACTIONS(3383),
    [anon_sym_ascending] = ACTIONS(3383),
    [anon_sym_descending] = ACTIONS(3383),
    [anon_sym_group] = ACTIONS(3383),
    [anon_sym_by] = ACTIONS(3383),
    [anon_sym_select] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3383),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym___makeref] = ACTIONS(3383),
    [anon_sym___reftype] = ACTIONS(3383),
    [anon_sym___refvalue] = ACTIONS(3383),
    [sym_null_literal] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_integer_literal] = ACTIONS(3383),
    [sym_real_literal] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_verbatim_string_literal] = ACTIONS(3385),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3385),
    [sym_interpolation_verbatim_start] = ACTIONS(3385),
    [sym_interpolation_raw_start] = ACTIONS(3385),
    [sym_raw_string_start] = ACTIONS(3385),
  },
  [2069] = {
    [sym_preproc_region] = STATE(2069),
    [sym_preproc_endregion] = STATE(2069),
    [sym_preproc_line] = STATE(2069),
    [sym_preproc_pragma] = STATE(2069),
    [sym_preproc_nullable] = STATE(2069),
    [sym_preproc_error] = STATE(2069),
    [sym_preproc_warning] = STATE(2069),
    [sym_preproc_define] = STATE(2069),
    [sym_preproc_undef] = STATE(2069),
    [ts_builtin_sym_end] = ACTIONS(3357),
    [sym__identifier_token] = ACTIONS(3355),
    [anon_sym_extern] = ACTIONS(3355),
    [anon_sym_alias] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_global] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_unsafe] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_ref] = ACTIONS(3355),
    [anon_sym_struct] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_delegate] = ACTIONS(3355),
    [anon_sym_record] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_file] = ACTIONS(3355),
    [anon_sym_fixed] = ACTIONS(3355),
    [anon_sym_internal] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_partial] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_required] = ACTIONS(3355),
    [anon_sym_sealed] = ACTIONS(3355),
    [anon_sym_virtual] = ACTIONS(3355),
    [anon_sym_volatile] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [anon_sym_notnull] = ACTIONS(3355),
    [anon_sym_unmanaged] = ACTIONS(3355),
    [anon_sym_checked] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [anon_sym_true] = ACTIONS(3355),
    [anon_sym_false] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_CARET] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_this] = ACTIONS(3355),
    [anon_sym_scoped] = ACTIONS(3355),
    [anon_sym_base] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [sym_predefined_type] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_unchecked] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_lock] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_when] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_foreach] = ACTIONS(3355),
    [anon_sym_goto] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_DOT_DOT] = ACTIONS(3357),
    [anon_sym_from] = ACTIONS(3355),
    [anon_sym_into] = ACTIONS(3355),
    [anon_sym_join] = ACTIONS(3355),
    [anon_sym_on] = ACTIONS(3355),
    [anon_sym_equals] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_orderby] = ACTIONS(3355),
    [anon_sym_ascending] = ACTIONS(3355),
    [anon_sym_descending] = ACTIONS(3355),
    [anon_sym_group] = ACTIONS(3355),
    [anon_sym_by] = ACTIONS(3355),
    [anon_sym_select] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3355),
    [anon_sym_sizeof] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym___makeref] = ACTIONS(3355),
    [anon_sym___reftype] = ACTIONS(3355),
    [anon_sym___refvalue] = ACTIONS(3355),
    [sym_null_literal] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [sym_integer_literal] = ACTIONS(3355),
    [sym_real_literal] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [sym_verbatim_string_literal] = ACTIONS(3357),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3357),
    [sym_interpolation_verbatim_start] = ACTIONS(3357),
    [sym_interpolation_raw_start] = ACTIONS(3357),
    [sym_raw_string_start] = ACTIONS(3357),
  },
  [2070] = {
    [sym_preproc_region] = STATE(2070),
    [sym_preproc_endregion] = STATE(2070),
    [sym_preproc_line] = STATE(2070),
    [sym_preproc_pragma] = STATE(2070),
    [sym_preproc_nullable] = STATE(2070),
    [sym_preproc_error] = STATE(2070),
    [sym_preproc_warning] = STATE(2070),
    [sym_preproc_define] = STATE(2070),
    [sym_preproc_undef] = STATE(2070),
    [ts_builtin_sym_end] = ACTIONS(3353),
    [sym__identifier_token] = ACTIONS(3351),
    [anon_sym_extern] = ACTIONS(3351),
    [anon_sym_alias] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_global] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_unsafe] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_ref] = ACTIONS(3351),
    [anon_sym_struct] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_delegate] = ACTIONS(3351),
    [anon_sym_record] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_file] = ACTIONS(3351),
    [anon_sym_fixed] = ACTIONS(3351),
    [anon_sym_internal] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_partial] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_required] = ACTIONS(3351),
    [anon_sym_sealed] = ACTIONS(3351),
    [anon_sym_virtual] = ACTIONS(3351),
    [anon_sym_volatile] = ACTIONS(3351),
    [anon_sym_where] = ACTIONS(3351),
    [anon_sym_notnull] = ACTIONS(3351),
    [anon_sym_unmanaged] = ACTIONS(3351),
    [anon_sym_checked] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_true] = ACTIONS(3351),
    [anon_sym_false] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_this] = ACTIONS(3351),
    [anon_sym_scoped] = ACTIONS(3351),
    [anon_sym_base] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [sym_predefined_type] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_unchecked] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_lock] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_when] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_foreach] = ACTIONS(3351),
    [anon_sym_goto] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_from] = ACTIONS(3351),
    [anon_sym_into] = ACTIONS(3351),
    [anon_sym_join] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [anon_sym_equals] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_orderby] = ACTIONS(3351),
    [anon_sym_ascending] = ACTIONS(3351),
    [anon_sym_descending] = ACTIONS(3351),
    [anon_sym_group] = ACTIONS(3351),
    [anon_sym_by] = ACTIONS(3351),
    [anon_sym_select] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3351),
    [anon_sym_sizeof] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym___makeref] = ACTIONS(3351),
    [anon_sym___reftype] = ACTIONS(3351),
    [anon_sym___refvalue] = ACTIONS(3351),
    [sym_null_literal] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_integer_literal] = ACTIONS(3351),
    [sym_real_literal] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [sym_verbatim_string_literal] = ACTIONS(3353),
    [aux_sym_preproc_if_token1] = ACTIONS(3353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3353),
    [sym_interpolation_verbatim_start] = ACTIONS(3353),
    [sym_interpolation_raw_start] = ACTIONS(3353),
    [sym_raw_string_start] = ACTIONS(3353),
  },
  [2071] = {
    [sym_preproc_region] = STATE(2071),
    [sym_preproc_endregion] = STATE(2071),
    [sym_preproc_line] = STATE(2071),
    [sym_preproc_pragma] = STATE(2071),
    [sym_preproc_nullable] = STATE(2071),
    [sym_preproc_error] = STATE(2071),
    [sym_preproc_warning] = STATE(2071),
    [sym_preproc_define] = STATE(2071),
    [sym_preproc_undef] = STATE(2071),
    [ts_builtin_sym_end] = ACTIONS(3421),
    [sym__identifier_token] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym_alias] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_global] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_unsafe] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_ref] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_delegate] = ACTIONS(3419),
    [anon_sym_record] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_file] = ACTIONS(3419),
    [anon_sym_fixed] = ACTIONS(3419),
    [anon_sym_internal] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_partial] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_sealed] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_notnull] = ACTIONS(3419),
    [anon_sym_unmanaged] = ACTIONS(3419),
    [anon_sym_checked] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_true] = ACTIONS(3419),
    [anon_sym_false] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_this] = ACTIONS(3419),
    [anon_sym_scoped] = ACTIONS(3419),
    [anon_sym_base] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [sym_predefined_type] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_unchecked] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_lock] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_when] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_foreach] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_DOT_DOT] = ACTIONS(3421),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_into] = ACTIONS(3419),
    [anon_sym_join] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_equals] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_orderby] = ACTIONS(3419),
    [anon_sym_ascending] = ACTIONS(3419),
    [anon_sym_descending] = ACTIONS(3419),
    [anon_sym_group] = ACTIONS(3419),
    [anon_sym_by] = ACTIONS(3419),
    [anon_sym_select] = ACTIONS(3419),
    [anon_sym_stackalloc] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym___makeref] = ACTIONS(3419),
    [anon_sym___reftype] = ACTIONS(3419),
    [anon_sym___refvalue] = ACTIONS(3419),
    [sym_null_literal] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [sym_integer_literal] = ACTIONS(3419),
    [sym_real_literal] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_verbatim_string_literal] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3421),
    [sym_interpolation_verbatim_start] = ACTIONS(3421),
    [sym_interpolation_raw_start] = ACTIONS(3421),
    [sym_raw_string_start] = ACTIONS(3421),
  },
  [2072] = {
    [sym_preproc_region] = STATE(2072),
    [sym_preproc_endregion] = STATE(2072),
    [sym_preproc_line] = STATE(2072),
    [sym_preproc_pragma] = STATE(2072),
    [sym_preproc_nullable] = STATE(2072),
    [sym_preproc_error] = STATE(2072),
    [sym_preproc_warning] = STATE(2072),
    [sym_preproc_define] = STATE(2072),
    [sym_preproc_undef] = STATE(2072),
    [ts_builtin_sym_end] = ACTIONS(3401),
    [sym__identifier_token] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_alias] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_global] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_unsafe] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_ref] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_delegate] = ACTIONS(3399),
    [anon_sym_record] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_file] = ACTIONS(3399),
    [anon_sym_fixed] = ACTIONS(3399),
    [anon_sym_internal] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_partial] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_required] = ACTIONS(3399),
    [anon_sym_sealed] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_where] = ACTIONS(3399),
    [anon_sym_notnull] = ACTIONS(3399),
    [anon_sym_unmanaged] = ACTIONS(3399),
    [anon_sym_checked] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_true] = ACTIONS(3399),
    [anon_sym_false] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_CARET] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_this] = ACTIONS(3399),
    [anon_sym_scoped] = ACTIONS(3399),
    [anon_sym_base] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [sym_predefined_type] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_unchecked] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_lock] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_when] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_foreach] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_DOT_DOT] = ACTIONS(3401),
    [anon_sym_from] = ACTIONS(3399),
    [anon_sym_into] = ACTIONS(3399),
    [anon_sym_join] = ACTIONS(3399),
    [anon_sym_on] = ACTIONS(3399),
    [anon_sym_equals] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_orderby] = ACTIONS(3399),
    [anon_sym_ascending] = ACTIONS(3399),
    [anon_sym_descending] = ACTIONS(3399),
    [anon_sym_group] = ACTIONS(3399),
    [anon_sym_by] = ACTIONS(3399),
    [anon_sym_select] = ACTIONS(3399),
    [anon_sym_stackalloc] = ACTIONS(3399),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym___makeref] = ACTIONS(3399),
    [anon_sym___reftype] = ACTIONS(3399),
    [anon_sym___refvalue] = ACTIONS(3399),
    [sym_null_literal] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [sym_integer_literal] = ACTIONS(3399),
    [sym_real_literal] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_verbatim_string_literal] = ACTIONS(3401),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3401),
    [sym_interpolation_verbatim_start] = ACTIONS(3401),
    [sym_interpolation_raw_start] = ACTIONS(3401),
    [sym_raw_string_start] = ACTIONS(3401),
  },
  [2073] = {
    [sym_preproc_region] = STATE(2073),
    [sym_preproc_endregion] = STATE(2073),
    [sym_preproc_line] = STATE(2073),
    [sym_preproc_pragma] = STATE(2073),
    [sym_preproc_nullable] = STATE(2073),
    [sym_preproc_error] = STATE(2073),
    [sym_preproc_warning] = STATE(2073),
    [sym_preproc_define] = STATE(2073),
    [sym_preproc_undef] = STATE(2073),
    [ts_builtin_sym_end] = ACTIONS(3445),
    [sym__identifier_token] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym_alias] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_global] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_unsafe] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_ref] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_delegate] = ACTIONS(3443),
    [anon_sym_record] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_file] = ACTIONS(3443),
    [anon_sym_fixed] = ACTIONS(3443),
    [anon_sym_internal] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_partial] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_required] = ACTIONS(3443),
    [anon_sym_sealed] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_where] = ACTIONS(3443),
    [anon_sym_notnull] = ACTIONS(3443),
    [anon_sym_unmanaged] = ACTIONS(3443),
    [anon_sym_checked] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_true] = ACTIONS(3443),
    [anon_sym_false] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_CARET] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_this] = ACTIONS(3443),
    [anon_sym_scoped] = ACTIONS(3443),
    [anon_sym_base] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [sym_predefined_type] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_unchecked] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_lock] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_when] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_foreach] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_DOT_DOT] = ACTIONS(3445),
    [anon_sym_from] = ACTIONS(3443),
    [anon_sym_into] = ACTIONS(3443),
    [anon_sym_join] = ACTIONS(3443),
    [anon_sym_on] = ACTIONS(3443),
    [anon_sym_equals] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_orderby] = ACTIONS(3443),
    [anon_sym_ascending] = ACTIONS(3443),
    [anon_sym_descending] = ACTIONS(3443),
    [anon_sym_group] = ACTIONS(3443),
    [anon_sym_by] = ACTIONS(3443),
    [anon_sym_select] = ACTIONS(3443),
    [anon_sym_stackalloc] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym___makeref] = ACTIONS(3443),
    [anon_sym___reftype] = ACTIONS(3443),
    [anon_sym___refvalue] = ACTIONS(3443),
    [sym_null_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [sym_integer_literal] = ACTIONS(3443),
    [sym_real_literal] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_verbatim_string_literal] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3445),
    [sym_interpolation_verbatim_start] = ACTIONS(3445),
    [sym_interpolation_raw_start] = ACTIONS(3445),
    [sym_raw_string_start] = ACTIONS(3445),
  },
  [2074] = {
    [sym_preproc_region] = STATE(2074),
    [sym_preproc_endregion] = STATE(2074),
    [sym_preproc_line] = STATE(2074),
    [sym_preproc_pragma] = STATE(2074),
    [sym_preproc_nullable] = STATE(2074),
    [sym_preproc_error] = STATE(2074),
    [sym_preproc_warning] = STATE(2074),
    [sym_preproc_define] = STATE(2074),
    [sym_preproc_undef] = STATE(2074),
    [ts_builtin_sym_end] = ACTIONS(3365),
    [sym__identifier_token] = ACTIONS(3363),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_alias] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_unsafe] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_ref] = ACTIONS(3363),
    [anon_sym_struct] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_delegate] = ACTIONS(3363),
    [anon_sym_record] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_file] = ACTIONS(3363),
    [anon_sym_fixed] = ACTIONS(3363),
    [anon_sym_internal] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_partial] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_required] = ACTIONS(3363),
    [anon_sym_sealed] = ACTIONS(3363),
    [anon_sym_virtual] = ACTIONS(3363),
    [anon_sym_volatile] = ACTIONS(3363),
    [anon_sym_where] = ACTIONS(3363),
    [anon_sym_notnull] = ACTIONS(3363),
    [anon_sym_unmanaged] = ACTIONS(3363),
    [anon_sym_checked] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [anon_sym_true] = ACTIONS(3363),
    [anon_sym_false] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3365),
    [anon_sym_CARET] = ACTIONS(3365),
    [anon_sym_AMP] = ACTIONS(3365),
    [anon_sym_this] = ACTIONS(3363),
    [anon_sym_scoped] = ACTIONS(3363),
    [anon_sym_base] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [sym_predefined_type] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_unchecked] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_lock] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_when] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_foreach] = ACTIONS(3363),
    [anon_sym_goto] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_DOT_DOT] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3363),
    [anon_sym_into] = ACTIONS(3363),
    [anon_sym_join] = ACTIONS(3363),
    [anon_sym_on] = ACTIONS(3363),
    [anon_sym_equals] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_orderby] = ACTIONS(3363),
    [anon_sym_ascending] = ACTIONS(3363),
    [anon_sym_descending] = ACTIONS(3363),
    [anon_sym_group] = ACTIONS(3363),
    [anon_sym_by] = ACTIONS(3363),
    [anon_sym_select] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3363),
    [anon_sym_sizeof] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym___makeref] = ACTIONS(3363),
    [anon_sym___reftype] = ACTIONS(3363),
    [anon_sym___refvalue] = ACTIONS(3363),
    [sym_null_literal] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [sym_integer_literal] = ACTIONS(3363),
    [sym_real_literal] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [sym_verbatim_string_literal] = ACTIONS(3365),
    [aux_sym_preproc_if_token1] = ACTIONS(3365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3365),
    [sym_interpolation_verbatim_start] = ACTIONS(3365),
    [sym_interpolation_raw_start] = ACTIONS(3365),
    [sym_raw_string_start] = ACTIONS(3365),
  },
  [2075] = {
    [sym_preproc_region] = STATE(2075),
    [sym_preproc_endregion] = STATE(2075),
    [sym_preproc_line] = STATE(2075),
    [sym_preproc_pragma] = STATE(2075),
    [sym_preproc_nullable] = STATE(2075),
    [sym_preproc_error] = STATE(2075),
    [sym_preproc_warning] = STATE(2075),
    [sym_preproc_define] = STATE(2075),
    [sym_preproc_undef] = STATE(2075),
    [ts_builtin_sym_end] = ACTIONS(3476),
    [sym__identifier_token] = ACTIONS(3478),
    [anon_sym_extern] = ACTIONS(3478),
    [anon_sym_alias] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_global] = ACTIONS(3478),
    [anon_sym_using] = ACTIONS(3478),
    [anon_sym_unsafe] = ACTIONS(3478),
    [anon_sym_static] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3478),
    [anon_sym_namespace] = ACTIONS(3478),
    [anon_sym_class] = ACTIONS(3478),
    [anon_sym_ref] = ACTIONS(3478),
    [anon_sym_struct] = ACTIONS(3478),
    [anon_sym_enum] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3478),
    [anon_sym_delegate] = ACTIONS(3478),
    [anon_sym_record] = ACTIONS(3478),
    [anon_sym_abstract] = ACTIONS(3478),
    [anon_sym_async] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_file] = ACTIONS(3478),
    [anon_sym_fixed] = ACTIONS(3478),
    [anon_sym_internal] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3478),
    [anon_sym_override] = ACTIONS(3478),
    [anon_sym_partial] = ACTIONS(3478),
    [anon_sym_private] = ACTIONS(3478),
    [anon_sym_protected] = ACTIONS(3478),
    [anon_sym_public] = ACTIONS(3478),
    [anon_sym_readonly] = ACTIONS(3478),
    [anon_sym_required] = ACTIONS(3478),
    [anon_sym_sealed] = ACTIONS(3478),
    [anon_sym_virtual] = ACTIONS(3478),
    [anon_sym_volatile] = ACTIONS(3478),
    [anon_sym_where] = ACTIONS(3478),
    [anon_sym_notnull] = ACTIONS(3478),
    [anon_sym_unmanaged] = ACTIONS(3478),
    [anon_sym_checked] = ACTIONS(3478),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_true] = ACTIONS(3478),
    [anon_sym_false] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_CARET] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_this] = ACTIONS(3478),
    [anon_sym_scoped] = ACTIONS(3478),
    [anon_sym_base] = ACTIONS(3478),
    [anon_sym_var] = ACTIONS(3478),
    [sym_predefined_type] = ACTIONS(3478),
    [anon_sym_break] = ACTIONS(3478),
    [anon_sym_unchecked] = ACTIONS(3478),
    [anon_sym_continue] = ACTIONS(3478),
    [anon_sym_do] = ACTIONS(3478),
    [anon_sym_while] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3478),
    [anon_sym_lock] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3478),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3478),
    [anon_sym_throw] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3478),
    [anon_sym_when] = ACTIONS(3478),
    [anon_sym_await] = ACTIONS(3478),
    [anon_sym_foreach] = ACTIONS(3478),
    [anon_sym_goto] = ACTIONS(3478),
    [anon_sym_if] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3476),
    [anon_sym_from] = ACTIONS(3478),
    [anon_sym_into] = ACTIONS(3478),
    [anon_sym_join] = ACTIONS(3478),
    [anon_sym_on] = ACTIONS(3478),
    [anon_sym_equals] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_orderby] = ACTIONS(3478),
    [anon_sym_ascending] = ACTIONS(3478),
    [anon_sym_descending] = ACTIONS(3478),
    [anon_sym_group] = ACTIONS(3478),
    [anon_sym_by] = ACTIONS(3478),
    [anon_sym_select] = ACTIONS(3478),
    [anon_sym_stackalloc] = ACTIONS(3478),
    [anon_sym_sizeof] = ACTIONS(3478),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym___makeref] = ACTIONS(3478),
    [anon_sym___reftype] = ACTIONS(3478),
    [anon_sym___refvalue] = ACTIONS(3478),
    [sym_null_literal] = ACTIONS(3478),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [sym_integer_literal] = ACTIONS(3478),
    [sym_real_literal] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [sym_verbatim_string_literal] = ACTIONS(3476),
    [aux_sym_preproc_if_token1] = ACTIONS(3476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3476),
    [sym_interpolation_verbatim_start] = ACTIONS(3476),
    [sym_interpolation_raw_start] = ACTIONS(3476),
    [sym_raw_string_start] = ACTIONS(3476),
  },
  [2076] = {
    [sym_preproc_region] = STATE(2076),
    [sym_preproc_endregion] = STATE(2076),
    [sym_preproc_line] = STATE(2076),
    [sym_preproc_pragma] = STATE(2076),
    [sym_preproc_nullable] = STATE(2076),
    [sym_preproc_error] = STATE(2076),
    [sym_preproc_warning] = STATE(2076),
    [sym_preproc_define] = STATE(2076),
    [sym_preproc_undef] = STATE(2076),
    [ts_builtin_sym_end] = ACTIONS(3413),
    [sym__identifier_token] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_alias] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_global] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_unsafe] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_ref] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_delegate] = ACTIONS(3411),
    [anon_sym_record] = ACTIONS(3411),
    [anon_sym_abstract] = ACTIONS(3411),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_file] = ACTIONS(3411),
    [anon_sym_fixed] = ACTIONS(3411),
    [anon_sym_internal] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_override] = ACTIONS(3411),
    [anon_sym_partial] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_readonly] = ACTIONS(3411),
    [anon_sym_required] = ACTIONS(3411),
    [anon_sym_sealed] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_where] = ACTIONS(3411),
    [anon_sym_notnull] = ACTIONS(3411),
    [anon_sym_unmanaged] = ACTIONS(3411),
    [anon_sym_checked] = ACTIONS(3411),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_true] = ACTIONS(3411),
    [anon_sym_false] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_CARET] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_this] = ACTIONS(3411),
    [anon_sym_scoped] = ACTIONS(3411),
    [anon_sym_base] = ACTIONS(3411),
    [anon_sym_var] = ACTIONS(3411),
    [sym_predefined_type] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_unchecked] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_lock] = ACTIONS(3411),
    [anon_sym_yield] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_when] = ACTIONS(3411),
    [anon_sym_await] = ACTIONS(3411),
    [anon_sym_foreach] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_DOT_DOT] = ACTIONS(3413),
    [anon_sym_from] = ACTIONS(3411),
    [anon_sym_into] = ACTIONS(3411),
    [anon_sym_join] = ACTIONS(3411),
    [anon_sym_on] = ACTIONS(3411),
    [anon_sym_equals] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_orderby] = ACTIONS(3411),
    [anon_sym_ascending] = ACTIONS(3411),
    [anon_sym_descending] = ACTIONS(3411),
    [anon_sym_group] = ACTIONS(3411),
    [anon_sym_by] = ACTIONS(3411),
    [anon_sym_select] = ACTIONS(3411),
    [anon_sym_stackalloc] = ACTIONS(3411),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym_typeof] = ACTIONS(3411),
    [anon_sym___makeref] = ACTIONS(3411),
    [anon_sym___reftype] = ACTIONS(3411),
    [anon_sym___refvalue] = ACTIONS(3411),
    [sym_null_literal] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [sym_integer_literal] = ACTIONS(3411),
    [sym_real_literal] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_verbatim_string_literal] = ACTIONS(3413),
    [aux_sym_preproc_if_token1] = ACTIONS(3413),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3413),
    [sym_interpolation_verbatim_start] = ACTIONS(3413),
    [sym_interpolation_raw_start] = ACTIONS(3413),
    [sym_raw_string_start] = ACTIONS(3413),
  },
  [2077] = {
    [sym_preproc_region] = STATE(2077),
    [sym_preproc_endregion] = STATE(2077),
    [sym_preproc_line] = STATE(2077),
    [sym_preproc_pragma] = STATE(2077),
    [sym_preproc_nullable] = STATE(2077),
    [sym_preproc_error] = STATE(2077),
    [sym_preproc_warning] = STATE(2077),
    [sym_preproc_define] = STATE(2077),
    [sym_preproc_undef] = STATE(2077),
    [ts_builtin_sym_end] = ACTIONS(3405),
    [sym__identifier_token] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym_alias] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_global] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_unsafe] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_ref] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_delegate] = ACTIONS(3403),
    [anon_sym_record] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_file] = ACTIONS(3403),
    [anon_sym_fixed] = ACTIONS(3403),
    [anon_sym_internal] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_partial] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_required] = ACTIONS(3403),
    [anon_sym_sealed] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_where] = ACTIONS(3403),
    [anon_sym_notnull] = ACTIONS(3403),
    [anon_sym_unmanaged] = ACTIONS(3403),
    [anon_sym_checked] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_true] = ACTIONS(3403),
    [anon_sym_false] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_CARET] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_this] = ACTIONS(3403),
    [anon_sym_scoped] = ACTIONS(3403),
    [anon_sym_base] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [sym_predefined_type] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_unchecked] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_lock] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_when] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_foreach] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_DOT_DOT] = ACTIONS(3405),
    [anon_sym_from] = ACTIONS(3403),
    [anon_sym_into] = ACTIONS(3403),
    [anon_sym_join] = ACTIONS(3403),
    [anon_sym_on] = ACTIONS(3403),
    [anon_sym_equals] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_orderby] = ACTIONS(3403),
    [anon_sym_ascending] = ACTIONS(3403),
    [anon_sym_descending] = ACTIONS(3403),
    [anon_sym_group] = ACTIONS(3403),
    [anon_sym_by] = ACTIONS(3403),
    [anon_sym_select] = ACTIONS(3403),
    [anon_sym_stackalloc] = ACTIONS(3403),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym___makeref] = ACTIONS(3403),
    [anon_sym___reftype] = ACTIONS(3403),
    [anon_sym___refvalue] = ACTIONS(3403),
    [sym_null_literal] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [sym_integer_literal] = ACTIONS(3403),
    [sym_real_literal] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_verbatim_string_literal] = ACTIONS(3405),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3405),
    [sym_interpolation_verbatim_start] = ACTIONS(3405),
    [sym_interpolation_raw_start] = ACTIONS(3405),
    [sym_raw_string_start] = ACTIONS(3405),
  },
  [2078] = {
    [sym_preproc_region] = STATE(2078),
    [sym_preproc_endregion] = STATE(2078),
    [sym_preproc_line] = STATE(2078),
    [sym_preproc_pragma] = STATE(2078),
    [sym_preproc_nullable] = STATE(2078),
    [sym_preproc_error] = STATE(2078),
    [sym_preproc_warning] = STATE(2078),
    [sym_preproc_define] = STATE(2078),
    [sym_preproc_undef] = STATE(2078),
    [ts_builtin_sym_end] = ACTIONS(3480),
    [sym__identifier_token] = ACTIONS(3482),
    [anon_sym_extern] = ACTIONS(3482),
    [anon_sym_alias] = ACTIONS(3482),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_global] = ACTIONS(3482),
    [anon_sym_using] = ACTIONS(3482),
    [anon_sym_unsafe] = ACTIONS(3482),
    [anon_sym_static] = ACTIONS(3482),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_namespace] = ACTIONS(3482),
    [anon_sym_class] = ACTIONS(3482),
    [anon_sym_ref] = ACTIONS(3482),
    [anon_sym_struct] = ACTIONS(3482),
    [anon_sym_enum] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3482),
    [anon_sym_delegate] = ACTIONS(3482),
    [anon_sym_record] = ACTIONS(3482),
    [anon_sym_abstract] = ACTIONS(3482),
    [anon_sym_async] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3482),
    [anon_sym_file] = ACTIONS(3482),
    [anon_sym_fixed] = ACTIONS(3482),
    [anon_sym_internal] = ACTIONS(3482),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_override] = ACTIONS(3482),
    [anon_sym_partial] = ACTIONS(3482),
    [anon_sym_private] = ACTIONS(3482),
    [anon_sym_protected] = ACTIONS(3482),
    [anon_sym_public] = ACTIONS(3482),
    [anon_sym_readonly] = ACTIONS(3482),
    [anon_sym_required] = ACTIONS(3482),
    [anon_sym_sealed] = ACTIONS(3482),
    [anon_sym_virtual] = ACTIONS(3482),
    [anon_sym_volatile] = ACTIONS(3482),
    [anon_sym_where] = ACTIONS(3482),
    [anon_sym_notnull] = ACTIONS(3482),
    [anon_sym_unmanaged] = ACTIONS(3482),
    [anon_sym_checked] = ACTIONS(3482),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_true] = ACTIONS(3482),
    [anon_sym_false] = ACTIONS(3482),
    [anon_sym_PLUS] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3482),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_this] = ACTIONS(3482),
    [anon_sym_scoped] = ACTIONS(3482),
    [anon_sym_base] = ACTIONS(3482),
    [anon_sym_var] = ACTIONS(3482),
    [sym_predefined_type] = ACTIONS(3482),
    [anon_sym_break] = ACTIONS(3482),
    [anon_sym_unchecked] = ACTIONS(3482),
    [anon_sym_continue] = ACTIONS(3482),
    [anon_sym_do] = ACTIONS(3482),
    [anon_sym_while] = ACTIONS(3482),
    [anon_sym_for] = ACTIONS(3482),
    [anon_sym_lock] = ACTIONS(3482),
    [anon_sym_yield] = ACTIONS(3482),
    [anon_sym_switch] = ACTIONS(3482),
    [anon_sym_default] = ACTIONS(3482),
    [anon_sym_throw] = ACTIONS(3482),
    [anon_sym_try] = ACTIONS(3482),
    [anon_sym_when] = ACTIONS(3482),
    [anon_sym_await] = ACTIONS(3482),
    [anon_sym_foreach] = ACTIONS(3482),
    [anon_sym_goto] = ACTIONS(3482),
    [anon_sym_if] = ACTIONS(3482),
    [anon_sym_DOT_DOT] = ACTIONS(3480),
    [anon_sym_from] = ACTIONS(3482),
    [anon_sym_into] = ACTIONS(3482),
    [anon_sym_join] = ACTIONS(3482),
    [anon_sym_on] = ACTIONS(3482),
    [anon_sym_equals] = ACTIONS(3482),
    [anon_sym_let] = ACTIONS(3482),
    [anon_sym_orderby] = ACTIONS(3482),
    [anon_sym_ascending] = ACTIONS(3482),
    [anon_sym_descending] = ACTIONS(3482),
    [anon_sym_group] = ACTIONS(3482),
    [anon_sym_by] = ACTIONS(3482),
    [anon_sym_select] = ACTIONS(3482),
    [anon_sym_stackalloc] = ACTIONS(3482),
    [anon_sym_sizeof] = ACTIONS(3482),
    [anon_sym_typeof] = ACTIONS(3482),
    [anon_sym___makeref] = ACTIONS(3482),
    [anon_sym___reftype] = ACTIONS(3482),
    [anon_sym___refvalue] = ACTIONS(3482),
    [sym_null_literal] = ACTIONS(3482),
    [anon_sym_SQUOTE] = ACTIONS(3480),
    [sym_integer_literal] = ACTIONS(3482),
    [sym_real_literal] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [sym_verbatim_string_literal] = ACTIONS(3480),
    [aux_sym_preproc_if_token1] = ACTIONS(3480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3480),
    [sym_interpolation_verbatim_start] = ACTIONS(3480),
    [sym_interpolation_raw_start] = ACTIONS(3480),
    [sym_raw_string_start] = ACTIONS(3480),
  },
  [2079] = {
    [sym_preproc_region] = STATE(2079),
    [sym_preproc_endregion] = STATE(2079),
    [sym_preproc_line] = STATE(2079),
    [sym_preproc_pragma] = STATE(2079),
    [sym_preproc_nullable] = STATE(2079),
    [sym_preproc_error] = STATE(2079),
    [sym_preproc_warning] = STATE(2079),
    [sym_preproc_define] = STATE(2079),
    [sym_preproc_undef] = STATE(2079),
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym__identifier_token] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_alias] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_global] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_unsafe] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_ref] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3415),
    [anon_sym_record] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_file] = ACTIONS(3415),
    [anon_sym_fixed] = ACTIONS(3415),
    [anon_sym_internal] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_partial] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_required] = ACTIONS(3415),
    [anon_sym_sealed] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_notnull] = ACTIONS(3415),
    [anon_sym_unmanaged] = ACTIONS(3415),
    [anon_sym_checked] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_true] = ACTIONS(3415),
    [anon_sym_false] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_CARET] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_this] = ACTIONS(3415),
    [anon_sym_scoped] = ACTIONS(3415),
    [anon_sym_base] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [sym_predefined_type] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_unchecked] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_lock] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_foreach] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_DOT_DOT] = ACTIONS(3417),
    [anon_sym_from] = ACTIONS(3415),
    [anon_sym_into] = ACTIONS(3415),
    [anon_sym_join] = ACTIONS(3415),
    [anon_sym_on] = ACTIONS(3415),
    [anon_sym_equals] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_orderby] = ACTIONS(3415),
    [anon_sym_ascending] = ACTIONS(3415),
    [anon_sym_descending] = ACTIONS(3415),
    [anon_sym_group] = ACTIONS(3415),
    [anon_sym_by] = ACTIONS(3415),
    [anon_sym_select] = ACTIONS(3415),
    [anon_sym_stackalloc] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym___makeref] = ACTIONS(3415),
    [anon_sym___reftype] = ACTIONS(3415),
    [anon_sym___refvalue] = ACTIONS(3415),
    [sym_null_literal] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [sym_integer_literal] = ACTIONS(3415),
    [sym_real_literal] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [sym_verbatim_string_literal] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3417),
    [sym_interpolation_verbatim_start] = ACTIONS(3417),
    [sym_interpolation_raw_start] = ACTIONS(3417),
    [sym_raw_string_start] = ACTIONS(3417),
  },
  [2080] = {
    [sym_preproc_region] = STATE(2080),
    [sym_preproc_endregion] = STATE(2080),
    [sym_preproc_line] = STATE(2080),
    [sym_preproc_pragma] = STATE(2080),
    [sym_preproc_nullable] = STATE(2080),
    [sym_preproc_error] = STATE(2080),
    [sym_preproc_warning] = STATE(2080),
    [sym_preproc_define] = STATE(2080),
    [sym_preproc_undef] = STATE(2080),
    [ts_builtin_sym_end] = ACTIONS(3484),
    [sym__identifier_token] = ACTIONS(3486),
    [anon_sym_extern] = ACTIONS(3486),
    [anon_sym_alias] = ACTIONS(3486),
    [anon_sym_SEMI] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_using] = ACTIONS(3486),
    [anon_sym_unsafe] = ACTIONS(3486),
    [anon_sym_static] = ACTIONS(3486),
    [anon_sym_LBRACK] = ACTIONS(3484),
    [anon_sym_LPAREN] = ACTIONS(3484),
    [anon_sym_return] = ACTIONS(3486),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_class] = ACTIONS(3486),
    [anon_sym_ref] = ACTIONS(3486),
    [anon_sym_struct] = ACTIONS(3486),
    [anon_sym_enum] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(3484),
    [anon_sym_interface] = ACTIONS(3486),
    [anon_sym_delegate] = ACTIONS(3486),
    [anon_sym_record] = ACTIONS(3486),
    [anon_sym_abstract] = ACTIONS(3486),
    [anon_sym_async] = ACTIONS(3486),
    [anon_sym_const] = ACTIONS(3486),
    [anon_sym_file] = ACTIONS(3486),
    [anon_sym_fixed] = ACTIONS(3486),
    [anon_sym_internal] = ACTIONS(3486),
    [anon_sym_new] = ACTIONS(3486),
    [anon_sym_override] = ACTIONS(3486),
    [anon_sym_partial] = ACTIONS(3486),
    [anon_sym_private] = ACTIONS(3486),
    [anon_sym_protected] = ACTIONS(3486),
    [anon_sym_public] = ACTIONS(3486),
    [anon_sym_readonly] = ACTIONS(3486),
    [anon_sym_required] = ACTIONS(3486),
    [anon_sym_sealed] = ACTIONS(3486),
    [anon_sym_virtual] = ACTIONS(3486),
    [anon_sym_volatile] = ACTIONS(3486),
    [anon_sym_where] = ACTIONS(3486),
    [anon_sym_notnull] = ACTIONS(3486),
    [anon_sym_unmanaged] = ACTIONS(3486),
    [anon_sym_checked] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3484),
    [anon_sym_TILDE] = ACTIONS(3484),
    [anon_sym_PLUS_PLUS] = ACTIONS(3484),
    [anon_sym_DASH_DASH] = ACTIONS(3484),
    [anon_sym_true] = ACTIONS(3486),
    [anon_sym_false] = ACTIONS(3486),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3484),
    [anon_sym_CARET] = ACTIONS(3484),
    [anon_sym_AMP] = ACTIONS(3484),
    [anon_sym_this] = ACTIONS(3486),
    [anon_sym_scoped] = ACTIONS(3486),
    [anon_sym_base] = ACTIONS(3486),
    [anon_sym_var] = ACTIONS(3486),
    [sym_predefined_type] = ACTIONS(3486),
    [anon_sym_break] = ACTIONS(3486),
    [anon_sym_unchecked] = ACTIONS(3486),
    [anon_sym_continue] = ACTIONS(3486),
    [anon_sym_do] = ACTIONS(3486),
    [anon_sym_while] = ACTIONS(3486),
    [anon_sym_for] = ACTIONS(3486),
    [anon_sym_lock] = ACTIONS(3486),
    [anon_sym_yield] = ACTIONS(3486),
    [anon_sym_switch] = ACTIONS(3486),
    [anon_sym_default] = ACTIONS(3486),
    [anon_sym_throw] = ACTIONS(3486),
    [anon_sym_try] = ACTIONS(3486),
    [anon_sym_when] = ACTIONS(3486),
    [anon_sym_await] = ACTIONS(3486),
    [anon_sym_foreach] = ACTIONS(3486),
    [anon_sym_goto] = ACTIONS(3486),
    [anon_sym_if] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3484),
    [anon_sym_from] = ACTIONS(3486),
    [anon_sym_into] = ACTIONS(3486),
    [anon_sym_join] = ACTIONS(3486),
    [anon_sym_on] = ACTIONS(3486),
    [anon_sym_equals] = ACTIONS(3486),
    [anon_sym_let] = ACTIONS(3486),
    [anon_sym_orderby] = ACTIONS(3486),
    [anon_sym_ascending] = ACTIONS(3486),
    [anon_sym_descending] = ACTIONS(3486),
    [anon_sym_group] = ACTIONS(3486),
    [anon_sym_by] = ACTIONS(3486),
    [anon_sym_select] = ACTIONS(3486),
    [anon_sym_stackalloc] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym_typeof] = ACTIONS(3486),
    [anon_sym___makeref] = ACTIONS(3486),
    [anon_sym___reftype] = ACTIONS(3486),
    [anon_sym___refvalue] = ACTIONS(3486),
    [sym_null_literal] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3484),
    [sym_integer_literal] = ACTIONS(3486),
    [sym_real_literal] = ACTIONS(3484),
    [anon_sym_DQUOTE] = ACTIONS(3484),
    [sym_verbatim_string_literal] = ACTIONS(3484),
    [aux_sym_preproc_if_token1] = ACTIONS(3484),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3484),
    [sym_interpolation_verbatim_start] = ACTIONS(3484),
    [sym_interpolation_raw_start] = ACTIONS(3484),
    [sym_raw_string_start] = ACTIONS(3484),
  },
  [2081] = {
    [sym_preproc_region] = STATE(2081),
    [sym_preproc_endregion] = STATE(2081),
    [sym_preproc_line] = STATE(2081),
    [sym_preproc_pragma] = STATE(2081),
    [sym_preproc_nullable] = STATE(2081),
    [sym_preproc_error] = STATE(2081),
    [sym_preproc_warning] = STATE(2081),
    [sym_preproc_define] = STATE(2081),
    [sym_preproc_undef] = STATE(2081),
    [ts_builtin_sym_end] = ACTIONS(3361),
    [sym__identifier_token] = ACTIONS(3359),
    [anon_sym_extern] = ACTIONS(3359),
    [anon_sym_alias] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_unsafe] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_ref] = ACTIONS(3359),
    [anon_sym_struct] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_delegate] = ACTIONS(3359),
    [anon_sym_record] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_file] = ACTIONS(3359),
    [anon_sym_fixed] = ACTIONS(3359),
    [anon_sym_internal] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_partial] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_required] = ACTIONS(3359),
    [anon_sym_sealed] = ACTIONS(3359),
    [anon_sym_virtual] = ACTIONS(3359),
    [anon_sym_volatile] = ACTIONS(3359),
    [anon_sym_where] = ACTIONS(3359),
    [anon_sym_notnull] = ACTIONS(3359),
    [anon_sym_unmanaged] = ACTIONS(3359),
    [anon_sym_checked] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [anon_sym_true] = ACTIONS(3359),
    [anon_sym_false] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_CARET] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_this] = ACTIONS(3359),
    [anon_sym_scoped] = ACTIONS(3359),
    [anon_sym_base] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [sym_predefined_type] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_unchecked] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_lock] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_when] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_foreach] = ACTIONS(3359),
    [anon_sym_goto] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_DOT_DOT] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3359),
    [anon_sym_into] = ACTIONS(3359),
    [anon_sym_join] = ACTIONS(3359),
    [anon_sym_on] = ACTIONS(3359),
    [anon_sym_equals] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_orderby] = ACTIONS(3359),
    [anon_sym_ascending] = ACTIONS(3359),
    [anon_sym_descending] = ACTIONS(3359),
    [anon_sym_group] = ACTIONS(3359),
    [anon_sym_by] = ACTIONS(3359),
    [anon_sym_select] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym___makeref] = ACTIONS(3359),
    [anon_sym___reftype] = ACTIONS(3359),
    [anon_sym___refvalue] = ACTIONS(3359),
    [sym_null_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [sym_integer_literal] = ACTIONS(3359),
    [sym_real_literal] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [sym_verbatim_string_literal] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3361),
    [sym_interpolation_verbatim_start] = ACTIONS(3361),
    [sym_interpolation_raw_start] = ACTIONS(3361),
    [sym_raw_string_start] = ACTIONS(3361),
  },
  [2082] = {
    [sym_preproc_region] = STATE(2082),
    [sym_preproc_endregion] = STATE(2082),
    [sym_preproc_line] = STATE(2082),
    [sym_preproc_pragma] = STATE(2082),
    [sym_preproc_nullable] = STATE(2082),
    [sym_preproc_error] = STATE(2082),
    [sym_preproc_warning] = STATE(2082),
    [sym_preproc_define] = STATE(2082),
    [sym_preproc_undef] = STATE(2082),
    [ts_builtin_sym_end] = ACTIONS(3381),
    [sym__identifier_token] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym_alias] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_global] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_unsafe] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_ref] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_delegate] = ACTIONS(3379),
    [anon_sym_record] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_file] = ACTIONS(3379),
    [anon_sym_fixed] = ACTIONS(3379),
    [anon_sym_internal] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_partial] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_required] = ACTIONS(3379),
    [anon_sym_sealed] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_where] = ACTIONS(3379),
    [anon_sym_notnull] = ACTIONS(3379),
    [anon_sym_unmanaged] = ACTIONS(3379),
    [anon_sym_checked] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_true] = ACTIONS(3379),
    [anon_sym_false] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_CARET] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_scoped] = ACTIONS(3379),
    [anon_sym_base] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [sym_predefined_type] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_unchecked] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_lock] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_when] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_foreach] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_DOT_DOT] = ACTIONS(3381),
    [anon_sym_from] = ACTIONS(3379),
    [anon_sym_into] = ACTIONS(3379),
    [anon_sym_join] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [anon_sym_equals] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_orderby] = ACTIONS(3379),
    [anon_sym_ascending] = ACTIONS(3379),
    [anon_sym_descending] = ACTIONS(3379),
    [anon_sym_group] = ACTIONS(3379),
    [anon_sym_by] = ACTIONS(3379),
    [anon_sym_select] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3379),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym___makeref] = ACTIONS(3379),
    [anon_sym___reftype] = ACTIONS(3379),
    [anon_sym___refvalue] = ACTIONS(3379),
    [sym_null_literal] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_integer_literal] = ACTIONS(3379),
    [sym_real_literal] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_verbatim_string_literal] = ACTIONS(3381),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3381),
    [sym_interpolation_verbatim_start] = ACTIONS(3381),
    [sym_interpolation_raw_start] = ACTIONS(3381),
    [sym_raw_string_start] = ACTIONS(3381),
  },
  [2083] = {
    [sym_catch_clause] = STATE(2099),
    [sym_preproc_region] = STATE(2083),
    [sym_preproc_endregion] = STATE(2083),
    [sym_preproc_line] = STATE(2083),
    [sym_preproc_pragma] = STATE(2083),
    [sym_preproc_nullable] = STATE(2083),
    [sym_preproc_error] = STATE(2083),
    [sym_preproc_warning] = STATE(2083),
    [sym_preproc_define] = STATE(2083),
    [sym_preproc_undef] = STATE(2083),
    [aux_sym_try_statement_repeat1] = STATE(2083),
    [sym__identifier_token] = ACTIONS(3139),
    [anon_sym_extern] = ACTIONS(3139),
    [anon_sym_alias] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_global] = ACTIONS(3139),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(3139),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_ref] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_async] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_file] = ACTIONS(3139),
    [anon_sym_fixed] = ACTIONS(3139),
    [anon_sym_internal] = ACTIONS(3139),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_override] = ACTIONS(3139),
    [anon_sym_partial] = ACTIONS(3139),
    [anon_sym_private] = ACTIONS(3139),
    [anon_sym_protected] = ACTIONS(3139),
    [anon_sym_public] = ACTIONS(3139),
    [anon_sym_readonly] = ACTIONS(3139),
    [anon_sym_required] = ACTIONS(3139),
    [anon_sym_sealed] = ACTIONS(3139),
    [anon_sym_virtual] = ACTIONS(3139),
    [anon_sym_volatile] = ACTIONS(3139),
    [anon_sym_where] = ACTIONS(3139),
    [anon_sym_notnull] = ACTIONS(3139),
    [anon_sym_unmanaged] = ACTIONS(3139),
    [anon_sym_checked] = ACTIONS(3139),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_true] = ACTIONS(3139),
    [anon_sym_false] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_CARET] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_this] = ACTIONS(3139),
    [anon_sym_scoped] = ACTIONS(3139),
    [anon_sym_base] = ACTIONS(3139),
    [anon_sym_var] = ACTIONS(3139),
    [sym_predefined_type] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_unchecked] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_lock] = ACTIONS(3139),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_case] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_throw] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_catch] = ACTIONS(3488),
    [anon_sym_when] = ACTIONS(3139),
    [anon_sym_finally] = ACTIONS(3139),
    [anon_sym_await] = ACTIONS(3139),
    [anon_sym_foreach] = ACTIONS(3139),
    [anon_sym_goto] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3139),
    [anon_sym_DOT_DOT] = ACTIONS(3141),
    [anon_sym_from] = ACTIONS(3139),
    [anon_sym_into] = ACTIONS(3139),
    [anon_sym_join] = ACTIONS(3139),
    [anon_sym_on] = ACTIONS(3139),
    [anon_sym_equals] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_orderby] = ACTIONS(3139),
    [anon_sym_ascending] = ACTIONS(3139),
    [anon_sym_descending] = ACTIONS(3139),
    [anon_sym_group] = ACTIONS(3139),
    [anon_sym_by] = ACTIONS(3139),
    [anon_sym_select] = ACTIONS(3139),
    [anon_sym_stackalloc] = ACTIONS(3139),
    [anon_sym_sizeof] = ACTIONS(3139),
    [anon_sym_typeof] = ACTIONS(3139),
    [anon_sym___makeref] = ACTIONS(3139),
    [anon_sym___reftype] = ACTIONS(3139),
    [anon_sym___refvalue] = ACTIONS(3139),
    [sym_null_literal] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3141),
    [sym_integer_literal] = ACTIONS(3139),
    [sym_real_literal] = ACTIONS(3141),
    [anon_sym_DQUOTE] = ACTIONS(3141),
    [sym_verbatim_string_literal] = ACTIONS(3141),
    [aux_sym_preproc_if_token1] = ACTIONS(3141),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3141),
    [sym_interpolation_verbatim_start] = ACTIONS(3141),
    [sym_interpolation_raw_start] = ACTIONS(3141),
    [sym_raw_string_start] = ACTIONS(3141),
  },
  [2084] = {
    [sym_preproc_region] = STATE(2084),
    [sym_preproc_endregion] = STATE(2084),
    [sym_preproc_line] = STATE(2084),
    [sym_preproc_pragma] = STATE(2084),
    [sym_preproc_nullable] = STATE(2084),
    [sym_preproc_error] = STATE(2084),
    [sym_preproc_warning] = STATE(2084),
    [sym_preproc_define] = STATE(2084),
    [sym_preproc_undef] = STATE(2084),
    [ts_builtin_sym_end] = ACTIONS(3369),
    [sym__identifier_token] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym_alias] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_global] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_unsafe] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_ref] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_delegate] = ACTIONS(3367),
    [anon_sym_record] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_file] = ACTIONS(3367),
    [anon_sym_fixed] = ACTIONS(3367),
    [anon_sym_internal] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_partial] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_required] = ACTIONS(3367),
    [anon_sym_sealed] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_where] = ACTIONS(3367),
    [anon_sym_notnull] = ACTIONS(3367),
    [anon_sym_unmanaged] = ACTIONS(3367),
    [anon_sym_checked] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_true] = ACTIONS(3367),
    [anon_sym_false] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_CARET] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_this] = ACTIONS(3367),
    [anon_sym_scoped] = ACTIONS(3367),
    [anon_sym_base] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [sym_predefined_type] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_unchecked] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_lock] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_when] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_foreach] = ACTIONS(3367),
    [anon_sym_goto] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_DOT_DOT] = ACTIONS(3369),
    [anon_sym_from] = ACTIONS(3367),
    [anon_sym_into] = ACTIONS(3367),
    [anon_sym_join] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [anon_sym_equals] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_orderby] = ACTIONS(3367),
    [anon_sym_ascending] = ACTIONS(3367),
    [anon_sym_descending] = ACTIONS(3367),
    [anon_sym_group] = ACTIONS(3367),
    [anon_sym_by] = ACTIONS(3367),
    [anon_sym_select] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3367),
    [anon_sym_sizeof] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym___makeref] = ACTIONS(3367),
    [anon_sym___reftype] = ACTIONS(3367),
    [anon_sym___refvalue] = ACTIONS(3367),
    [sym_null_literal] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_integer_literal] = ACTIONS(3367),
    [sym_real_literal] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [sym_verbatim_string_literal] = ACTIONS(3369),
    [aux_sym_preproc_if_token1] = ACTIONS(3369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3369),
    [sym_interpolation_verbatim_start] = ACTIONS(3369),
    [sym_interpolation_raw_start] = ACTIONS(3369),
    [sym_raw_string_start] = ACTIONS(3369),
  },
  [2085] = {
    [sym_preproc_region] = STATE(2085),
    [sym_preproc_endregion] = STATE(2085),
    [sym_preproc_line] = STATE(2085),
    [sym_preproc_pragma] = STATE(2085),
    [sym_preproc_nullable] = STATE(2085),
    [sym_preproc_error] = STATE(2085),
    [sym_preproc_warning] = STATE(2085),
    [sym_preproc_define] = STATE(2085),
    [sym_preproc_undef] = STATE(2085),
    [ts_builtin_sym_end] = ACTIONS(3409),
    [sym__identifier_token] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym_alias] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym_global] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_ref] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_delegate] = ACTIONS(3407),
    [anon_sym_record] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_file] = ACTIONS(3407),
    [anon_sym_fixed] = ACTIONS(3407),
    [anon_sym_internal] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_partial] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_required] = ACTIONS(3407),
    [anon_sym_sealed] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_where] = ACTIONS(3407),
    [anon_sym_notnull] = ACTIONS(3407),
    [anon_sym_unmanaged] = ACTIONS(3407),
    [anon_sym_checked] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_true] = ACTIONS(3407),
    [anon_sym_false] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_CARET] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_this] = ACTIONS(3407),
    [anon_sym_scoped] = ACTIONS(3407),
    [anon_sym_base] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [sym_predefined_type] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_unchecked] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_lock] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_when] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_foreach] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_DOT_DOT] = ACTIONS(3409),
    [anon_sym_from] = ACTIONS(3407),
    [anon_sym_into] = ACTIONS(3407),
    [anon_sym_join] = ACTIONS(3407),
    [anon_sym_on] = ACTIONS(3407),
    [anon_sym_equals] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_orderby] = ACTIONS(3407),
    [anon_sym_ascending] = ACTIONS(3407),
    [anon_sym_descending] = ACTIONS(3407),
    [anon_sym_group] = ACTIONS(3407),
    [anon_sym_by] = ACTIONS(3407),
    [anon_sym_select] = ACTIONS(3407),
    [anon_sym_stackalloc] = ACTIONS(3407),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym___makeref] = ACTIONS(3407),
    [anon_sym___reftype] = ACTIONS(3407),
    [anon_sym___refvalue] = ACTIONS(3407),
    [sym_null_literal] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [sym_integer_literal] = ACTIONS(3407),
    [sym_real_literal] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_verbatim_string_literal] = ACTIONS(3409),
    [aux_sym_preproc_if_token1] = ACTIONS(3409),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3409),
    [sym_interpolation_verbatim_start] = ACTIONS(3409),
    [sym_interpolation_raw_start] = ACTIONS(3409),
    [sym_raw_string_start] = ACTIONS(3409),
  },
  [2086] = {
    [sym_preproc_region] = STATE(2086),
    [sym_preproc_endregion] = STATE(2086),
    [sym_preproc_line] = STATE(2086),
    [sym_preproc_pragma] = STATE(2086),
    [sym_preproc_nullable] = STATE(2086),
    [sym_preproc_error] = STATE(2086),
    [sym_preproc_warning] = STATE(2086),
    [sym_preproc_define] = STATE(2086),
    [sym_preproc_undef] = STATE(2086),
    [ts_builtin_sym_end] = ACTIONS(3397),
    [sym__identifier_token] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym_alias] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_global] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_unsafe] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_LPAREN] = ACTIONS(3397),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_ref] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_delegate] = ACTIONS(3395),
    [anon_sym_record] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_file] = ACTIONS(3395),
    [anon_sym_fixed] = ACTIONS(3395),
    [anon_sym_internal] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_partial] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_required] = ACTIONS(3395),
    [anon_sym_sealed] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_where] = ACTIONS(3395),
    [anon_sym_notnull] = ACTIONS(3395),
    [anon_sym_unmanaged] = ACTIONS(3395),
    [anon_sym_checked] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_true] = ACTIONS(3395),
    [anon_sym_false] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_CARET] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_this] = ACTIONS(3395),
    [anon_sym_scoped] = ACTIONS(3395),
    [anon_sym_base] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [sym_predefined_type] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_unchecked] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_lock] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_when] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_foreach] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_DOT_DOT] = ACTIONS(3397),
    [anon_sym_from] = ACTIONS(3395),
    [anon_sym_into] = ACTIONS(3395),
    [anon_sym_join] = ACTIONS(3395),
    [anon_sym_on] = ACTIONS(3395),
    [anon_sym_equals] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_orderby] = ACTIONS(3395),
    [anon_sym_ascending] = ACTIONS(3395),
    [anon_sym_descending] = ACTIONS(3395),
    [anon_sym_group] = ACTIONS(3395),
    [anon_sym_by] = ACTIONS(3395),
    [anon_sym_select] = ACTIONS(3395),
    [anon_sym_stackalloc] = ACTIONS(3395),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym___makeref] = ACTIONS(3395),
    [anon_sym___reftype] = ACTIONS(3395),
    [anon_sym___refvalue] = ACTIONS(3395),
    [sym_null_literal] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [sym_integer_literal] = ACTIONS(3395),
    [sym_real_literal] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_verbatim_string_literal] = ACTIONS(3397),
    [aux_sym_preproc_if_token1] = ACTIONS(3397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3397),
    [sym_interpolation_verbatim_start] = ACTIONS(3397),
    [sym_interpolation_raw_start] = ACTIONS(3397),
    [sym_raw_string_start] = ACTIONS(3397),
  },
  [2087] = {
    [sym_preproc_region] = STATE(2087),
    [sym_preproc_endregion] = STATE(2087),
    [sym_preproc_line] = STATE(2087),
    [sym_preproc_pragma] = STATE(2087),
    [sym_preproc_nullable] = STATE(2087),
    [sym_preproc_error] = STATE(2087),
    [sym_preproc_warning] = STATE(2087),
    [sym_preproc_define] = STATE(2087),
    [sym_preproc_undef] = STATE(2087),
    [ts_builtin_sym_end] = ACTIONS(3393),
    [sym__identifier_token] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym_alias] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_global] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_unsafe] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_ref] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_delegate] = ACTIONS(3391),
    [anon_sym_record] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_file] = ACTIONS(3391),
    [anon_sym_fixed] = ACTIONS(3391),
    [anon_sym_internal] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_partial] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_required] = ACTIONS(3391),
    [anon_sym_sealed] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(3391),
    [anon_sym_notnull] = ACTIONS(3391),
    [anon_sym_unmanaged] = ACTIONS(3391),
    [anon_sym_checked] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_true] = ACTIONS(3391),
    [anon_sym_false] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_this] = ACTIONS(3391),
    [anon_sym_scoped] = ACTIONS(3391),
    [anon_sym_base] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [sym_predefined_type] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_unchecked] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_lock] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_when] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_foreach] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_DOT_DOT] = ACTIONS(3393),
    [anon_sym_from] = ACTIONS(3391),
    [anon_sym_into] = ACTIONS(3391),
    [anon_sym_join] = ACTIONS(3391),
    [anon_sym_on] = ACTIONS(3391),
    [anon_sym_equals] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_orderby] = ACTIONS(3391),
    [anon_sym_ascending] = ACTIONS(3391),
    [anon_sym_descending] = ACTIONS(3391),
    [anon_sym_group] = ACTIONS(3391),
    [anon_sym_by] = ACTIONS(3391),
    [anon_sym_select] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3391),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym___makeref] = ACTIONS(3391),
    [anon_sym___reftype] = ACTIONS(3391),
    [anon_sym___refvalue] = ACTIONS(3391),
    [sym_null_literal] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [sym_integer_literal] = ACTIONS(3391),
    [sym_real_literal] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_verbatim_string_literal] = ACTIONS(3393),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3393),
    [sym_interpolation_verbatim_start] = ACTIONS(3393),
    [sym_interpolation_raw_start] = ACTIONS(3393),
    [sym_raw_string_start] = ACTIONS(3393),
  },
  [2088] = {
    [sym_preproc_region] = STATE(2088),
    [sym_preproc_endregion] = STATE(2088),
    [sym_preproc_line] = STATE(2088),
    [sym_preproc_pragma] = STATE(2088),
    [sym_preproc_nullable] = STATE(2088),
    [sym_preproc_error] = STATE(2088),
    [sym_preproc_warning] = STATE(2088),
    [sym_preproc_define] = STATE(2088),
    [sym_preproc_undef] = STATE(2088),
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym__identifier_token] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_alias] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_global] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_ref] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_delegate] = ACTIONS(3387),
    [anon_sym_record] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_file] = ACTIONS(3387),
    [anon_sym_fixed] = ACTIONS(3387),
    [anon_sym_internal] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_partial] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_required] = ACTIONS(3387),
    [anon_sym_sealed] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_where] = ACTIONS(3387),
    [anon_sym_notnull] = ACTIONS(3387),
    [anon_sym_unmanaged] = ACTIONS(3387),
    [anon_sym_checked] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_true] = ACTIONS(3387),
    [anon_sym_false] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_this] = ACTIONS(3387),
    [anon_sym_scoped] = ACTIONS(3387),
    [anon_sym_base] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [sym_predefined_type] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_unchecked] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_lock] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_when] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_foreach] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_from] = ACTIONS(3387),
    [anon_sym_into] = ACTIONS(3387),
    [anon_sym_join] = ACTIONS(3387),
    [anon_sym_on] = ACTIONS(3387),
    [anon_sym_equals] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_orderby] = ACTIONS(3387),
    [anon_sym_ascending] = ACTIONS(3387),
    [anon_sym_descending] = ACTIONS(3387),
    [anon_sym_group] = ACTIONS(3387),
    [anon_sym_by] = ACTIONS(3387),
    [anon_sym_select] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3387),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym___makeref] = ACTIONS(3387),
    [anon_sym___reftype] = ACTIONS(3387),
    [anon_sym___refvalue] = ACTIONS(3387),
    [sym_null_literal] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [sym_integer_literal] = ACTIONS(3387),
    [sym_real_literal] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_verbatim_string_literal] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3389),
    [sym_interpolation_verbatim_start] = ACTIONS(3389),
    [sym_interpolation_raw_start] = ACTIONS(3389),
    [sym_raw_string_start] = ACTIONS(3389),
  },
  [2089] = {
    [sym_preproc_region] = STATE(2089),
    [sym_preproc_endregion] = STATE(2089),
    [sym_preproc_line] = STATE(2089),
    [sym_preproc_pragma] = STATE(2089),
    [sym_preproc_nullable] = STATE(2089),
    [sym_preproc_error] = STATE(2089),
    [sym_preproc_warning] = STATE(2089),
    [sym_preproc_define] = STATE(2089),
    [sym_preproc_undef] = STATE(2089),
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym__identifier_token] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym_alias] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_global] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_unsafe] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_ref] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_delegate] = ACTIONS(3427),
    [anon_sym_record] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_file] = ACTIONS(3427),
    [anon_sym_fixed] = ACTIONS(3427),
    [anon_sym_internal] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_partial] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_required] = ACTIONS(3427),
    [anon_sym_sealed] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_where] = ACTIONS(3427),
    [anon_sym_notnull] = ACTIONS(3427),
    [anon_sym_unmanaged] = ACTIONS(3427),
    [anon_sym_checked] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_true] = ACTIONS(3427),
    [anon_sym_false] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_CARET] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_this] = ACTIONS(3427),
    [anon_sym_scoped] = ACTIONS(3427),
    [anon_sym_base] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [sym_predefined_type] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_unchecked] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_lock] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_foreach] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_DOT_DOT] = ACTIONS(3429),
    [anon_sym_from] = ACTIONS(3427),
    [anon_sym_into] = ACTIONS(3427),
    [anon_sym_join] = ACTIONS(3427),
    [anon_sym_on] = ACTIONS(3427),
    [anon_sym_equals] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_orderby] = ACTIONS(3427),
    [anon_sym_ascending] = ACTIONS(3427),
    [anon_sym_descending] = ACTIONS(3427),
    [anon_sym_group] = ACTIONS(3427),
    [anon_sym_by] = ACTIONS(3427),
    [anon_sym_select] = ACTIONS(3427),
    [anon_sym_stackalloc] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym___makeref] = ACTIONS(3427),
    [anon_sym___reftype] = ACTIONS(3427),
    [anon_sym___refvalue] = ACTIONS(3427),
    [sym_null_literal] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [sym_integer_literal] = ACTIONS(3427),
    [sym_real_literal] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_verbatim_string_literal] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3429),
    [sym_interpolation_verbatim_start] = ACTIONS(3429),
    [sym_interpolation_raw_start] = ACTIONS(3429),
    [sym_raw_string_start] = ACTIONS(3429),
  },
  [2090] = {
    [sym_preproc_region] = STATE(2090),
    [sym_preproc_endregion] = STATE(2090),
    [sym_preproc_line] = STATE(2090),
    [sym_preproc_pragma] = STATE(2090),
    [sym_preproc_nullable] = STATE(2090),
    [sym_preproc_error] = STATE(2090),
    [sym_preproc_warning] = STATE(2090),
    [sym_preproc_define] = STATE(2090),
    [sym_preproc_undef] = STATE(2090),
    [ts_builtin_sym_end] = ACTIONS(3437),
    [sym__identifier_token] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym_alias] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_global] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_unsafe] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_ref] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_delegate] = ACTIONS(3435),
    [anon_sym_record] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_file] = ACTIONS(3435),
    [anon_sym_fixed] = ACTIONS(3435),
    [anon_sym_internal] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_partial] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_required] = ACTIONS(3435),
    [anon_sym_sealed] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_where] = ACTIONS(3435),
    [anon_sym_notnull] = ACTIONS(3435),
    [anon_sym_unmanaged] = ACTIONS(3435),
    [anon_sym_checked] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3435),
    [anon_sym_false] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_this] = ACTIONS(3435),
    [anon_sym_scoped] = ACTIONS(3435),
    [anon_sym_base] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [sym_predefined_type] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_unchecked] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_lock] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_when] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_foreach] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_DOT_DOT] = ACTIONS(3437),
    [anon_sym_from] = ACTIONS(3435),
    [anon_sym_into] = ACTIONS(3435),
    [anon_sym_join] = ACTIONS(3435),
    [anon_sym_on] = ACTIONS(3435),
    [anon_sym_equals] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_orderby] = ACTIONS(3435),
    [anon_sym_ascending] = ACTIONS(3435),
    [anon_sym_descending] = ACTIONS(3435),
    [anon_sym_group] = ACTIONS(3435),
    [anon_sym_by] = ACTIONS(3435),
    [anon_sym_select] = ACTIONS(3435),
    [anon_sym_stackalloc] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym___makeref] = ACTIONS(3435),
    [anon_sym___reftype] = ACTIONS(3435),
    [anon_sym___refvalue] = ACTIONS(3435),
    [sym_null_literal] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [sym_integer_literal] = ACTIONS(3435),
    [sym_real_literal] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_verbatim_string_literal] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3437),
    [sym_interpolation_verbatim_start] = ACTIONS(3437),
    [sym_interpolation_raw_start] = ACTIONS(3437),
    [sym_raw_string_start] = ACTIONS(3437),
  },
  [2091] = {
    [sym_preproc_region] = STATE(2091),
    [sym_preproc_endregion] = STATE(2091),
    [sym_preproc_line] = STATE(2091),
    [sym_preproc_pragma] = STATE(2091),
    [sym_preproc_nullable] = STATE(2091),
    [sym_preproc_error] = STATE(2091),
    [sym_preproc_warning] = STATE(2091),
    [sym_preproc_define] = STATE(2091),
    [sym_preproc_undef] = STATE(2091),
    [ts_builtin_sym_end] = ACTIONS(3373),
    [sym__identifier_token] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym_alias] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_global] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_unsafe] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_ref] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_delegate] = ACTIONS(3371),
    [anon_sym_record] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_file] = ACTIONS(3371),
    [anon_sym_fixed] = ACTIONS(3371),
    [anon_sym_internal] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_partial] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_required] = ACTIONS(3371),
    [anon_sym_sealed] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_where] = ACTIONS(3371),
    [anon_sym_notnull] = ACTIONS(3371),
    [anon_sym_unmanaged] = ACTIONS(3371),
    [anon_sym_checked] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_true] = ACTIONS(3371),
    [anon_sym_false] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3373),
    [anon_sym_CARET] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_this] = ACTIONS(3371),
    [anon_sym_scoped] = ACTIONS(3371),
    [anon_sym_base] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [sym_predefined_type] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_unchecked] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_lock] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_when] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_foreach] = ACTIONS(3371),
    [anon_sym_goto] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_DOT_DOT] = ACTIONS(3373),
    [anon_sym_from] = ACTIONS(3371),
    [anon_sym_into] = ACTIONS(3371),
    [anon_sym_join] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [anon_sym_equals] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_orderby] = ACTIONS(3371),
    [anon_sym_ascending] = ACTIONS(3371),
    [anon_sym_descending] = ACTIONS(3371),
    [anon_sym_group] = ACTIONS(3371),
    [anon_sym_by] = ACTIONS(3371),
    [anon_sym_select] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3371),
    [anon_sym_sizeof] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym___makeref] = ACTIONS(3371),
    [anon_sym___reftype] = ACTIONS(3371),
    [anon_sym___refvalue] = ACTIONS(3371),
    [sym_null_literal] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_integer_literal] = ACTIONS(3371),
    [sym_real_literal] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [sym_verbatim_string_literal] = ACTIONS(3373),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3373),
    [sym_interpolation_verbatim_start] = ACTIONS(3373),
    [sym_interpolation_raw_start] = ACTIONS(3373),
    [sym_raw_string_start] = ACTIONS(3373),
  },
  [2092] = {
    [sym_preproc_region] = STATE(2092),
    [sym_preproc_endregion] = STATE(2092),
    [sym_preproc_line] = STATE(2092),
    [sym_preproc_pragma] = STATE(2092),
    [sym_preproc_nullable] = STATE(2092),
    [sym_preproc_error] = STATE(2092),
    [sym_preproc_warning] = STATE(2092),
    [sym_preproc_define] = STATE(2092),
    [sym_preproc_undef] = STATE(2092),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym__identifier_token] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym_alias] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_global] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_unsafe] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_ref] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_delegate] = ACTIONS(3423),
    [anon_sym_record] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_file] = ACTIONS(3423),
    [anon_sym_fixed] = ACTIONS(3423),
    [anon_sym_internal] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_partial] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_required] = ACTIONS(3423),
    [anon_sym_sealed] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_where] = ACTIONS(3423),
    [anon_sym_notnull] = ACTIONS(3423),
    [anon_sym_unmanaged] = ACTIONS(3423),
    [anon_sym_checked] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_true] = ACTIONS(3423),
    [anon_sym_false] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_this] = ACTIONS(3423),
    [anon_sym_scoped] = ACTIONS(3423),
    [anon_sym_base] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [sym_predefined_type] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_unchecked] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_lock] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_when] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_foreach] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_DOT_DOT] = ACTIONS(3425),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_into] = ACTIONS(3423),
    [anon_sym_join] = ACTIONS(3423),
    [anon_sym_on] = ACTIONS(3423),
    [anon_sym_equals] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_orderby] = ACTIONS(3423),
    [anon_sym_ascending] = ACTIONS(3423),
    [anon_sym_descending] = ACTIONS(3423),
    [anon_sym_group] = ACTIONS(3423),
    [anon_sym_by] = ACTIONS(3423),
    [anon_sym_select] = ACTIONS(3423),
    [anon_sym_stackalloc] = ACTIONS(3423),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym___makeref] = ACTIONS(3423),
    [anon_sym___reftype] = ACTIONS(3423),
    [anon_sym___refvalue] = ACTIONS(3423),
    [sym_null_literal] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [sym_integer_literal] = ACTIONS(3423),
    [sym_real_literal] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_verbatim_string_literal] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3425),
    [sym_interpolation_verbatim_start] = ACTIONS(3425),
    [sym_interpolation_raw_start] = ACTIONS(3425),
    [sym_raw_string_start] = ACTIONS(3425),
  },
  [2093] = {
    [sym_preproc_region] = STATE(2093),
    [sym_preproc_endregion] = STATE(2093),
    [sym_preproc_line] = STATE(2093),
    [sym_preproc_pragma] = STATE(2093),
    [sym_preproc_nullable] = STATE(2093),
    [sym_preproc_error] = STATE(2093),
    [sym_preproc_warning] = STATE(2093),
    [sym_preproc_define] = STATE(2093),
    [sym_preproc_undef] = STATE(2093),
    [ts_builtin_sym_end] = ACTIONS(3484),
    [sym__identifier_token] = ACTIONS(3486),
    [anon_sym_extern] = ACTIONS(3486),
    [anon_sym_alias] = ACTIONS(3486),
    [anon_sym_SEMI] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_using] = ACTIONS(3486),
    [anon_sym_unsafe] = ACTIONS(3486),
    [anon_sym_static] = ACTIONS(3486),
    [anon_sym_LBRACK] = ACTIONS(3484),
    [anon_sym_LPAREN] = ACTIONS(3484),
    [anon_sym_return] = ACTIONS(3486),
    [anon_sym_namespace] = ACTIONS(3486),
    [anon_sym_class] = ACTIONS(3486),
    [anon_sym_ref] = ACTIONS(3486),
    [anon_sym_struct] = ACTIONS(3486),
    [anon_sym_enum] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(3484),
    [anon_sym_interface] = ACTIONS(3486),
    [anon_sym_delegate] = ACTIONS(3486),
    [anon_sym_record] = ACTIONS(3486),
    [anon_sym_abstract] = ACTIONS(3486),
    [anon_sym_async] = ACTIONS(3486),
    [anon_sym_const] = ACTIONS(3486),
    [anon_sym_file] = ACTIONS(3486),
    [anon_sym_fixed] = ACTIONS(3486),
    [anon_sym_internal] = ACTIONS(3486),
    [anon_sym_new] = ACTIONS(3486),
    [anon_sym_override] = ACTIONS(3486),
    [anon_sym_partial] = ACTIONS(3486),
    [anon_sym_private] = ACTIONS(3486),
    [anon_sym_protected] = ACTIONS(3486),
    [anon_sym_public] = ACTIONS(3486),
    [anon_sym_readonly] = ACTIONS(3486),
    [anon_sym_required] = ACTIONS(3486),
    [anon_sym_sealed] = ACTIONS(3486),
    [anon_sym_virtual] = ACTIONS(3486),
    [anon_sym_volatile] = ACTIONS(3486),
    [anon_sym_where] = ACTIONS(3486),
    [anon_sym_notnull] = ACTIONS(3486),
    [anon_sym_unmanaged] = ACTIONS(3486),
    [anon_sym_checked] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3484),
    [anon_sym_TILDE] = ACTIONS(3484),
    [anon_sym_PLUS_PLUS] = ACTIONS(3484),
    [anon_sym_DASH_DASH] = ACTIONS(3484),
    [anon_sym_true] = ACTIONS(3486),
    [anon_sym_false] = ACTIONS(3486),
    [anon_sym_PLUS] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3486),
    [anon_sym_STAR] = ACTIONS(3484),
    [anon_sym_CARET] = ACTIONS(3484),
    [anon_sym_AMP] = ACTIONS(3484),
    [anon_sym_this] = ACTIONS(3486),
    [anon_sym_scoped] = ACTIONS(3486),
    [anon_sym_base] = ACTIONS(3486),
    [anon_sym_var] = ACTIONS(3486),
    [sym_predefined_type] = ACTIONS(3486),
    [anon_sym_break] = ACTIONS(3486),
    [anon_sym_unchecked] = ACTIONS(3486),
    [anon_sym_continue] = ACTIONS(3486),
    [anon_sym_do] = ACTIONS(3486),
    [anon_sym_while] = ACTIONS(3486),
    [anon_sym_for] = ACTIONS(3486),
    [anon_sym_lock] = ACTIONS(3486),
    [anon_sym_yield] = ACTIONS(3486),
    [anon_sym_switch] = ACTIONS(3486),
    [anon_sym_default] = ACTIONS(3486),
    [anon_sym_throw] = ACTIONS(3486),
    [anon_sym_try] = ACTIONS(3486),
    [anon_sym_when] = ACTIONS(3486),
    [anon_sym_await] = ACTIONS(3486),
    [anon_sym_foreach] = ACTIONS(3486),
    [anon_sym_goto] = ACTIONS(3486),
    [anon_sym_if] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3484),
    [anon_sym_from] = ACTIONS(3486),
    [anon_sym_into] = ACTIONS(3486),
    [anon_sym_join] = ACTIONS(3486),
    [anon_sym_on] = ACTIONS(3486),
    [anon_sym_equals] = ACTIONS(3486),
    [anon_sym_let] = ACTIONS(3486),
    [anon_sym_orderby] = ACTIONS(3486),
    [anon_sym_ascending] = ACTIONS(3486),
    [anon_sym_descending] = ACTIONS(3486),
    [anon_sym_group] = ACTIONS(3486),
    [anon_sym_by] = ACTIONS(3486),
    [anon_sym_select] = ACTIONS(3486),
    [anon_sym_stackalloc] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym_typeof] = ACTIONS(3486),
    [anon_sym___makeref] = ACTIONS(3486),
    [anon_sym___reftype] = ACTIONS(3486),
    [anon_sym___refvalue] = ACTIONS(3486),
    [sym_null_literal] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3484),
    [sym_integer_literal] = ACTIONS(3486),
    [sym_real_literal] = ACTIONS(3484),
    [anon_sym_DQUOTE] = ACTIONS(3484),
    [sym_verbatim_string_literal] = ACTIONS(3484),
    [aux_sym_preproc_if_token1] = ACTIONS(3484),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3484),
    [sym_interpolation_verbatim_start] = ACTIONS(3484),
    [sym_interpolation_raw_start] = ACTIONS(3484),
    [sym_raw_string_start] = ACTIONS(3484),
  },
  [2094] = {
    [sym_preproc_region] = STATE(2094),
    [sym_preproc_endregion] = STATE(2094),
    [sym_preproc_line] = STATE(2094),
    [sym_preproc_pragma] = STATE(2094),
    [sym_preproc_nullable] = STATE(2094),
    [sym_preproc_error] = STATE(2094),
    [sym_preproc_warning] = STATE(2094),
    [sym_preproc_define] = STATE(2094),
    [sym_preproc_undef] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(3377),
    [sym__identifier_token] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym_alias] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_global] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_unsafe] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_ref] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_delegate] = ACTIONS(3375),
    [anon_sym_record] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_file] = ACTIONS(3375),
    [anon_sym_fixed] = ACTIONS(3375),
    [anon_sym_internal] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_partial] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_required] = ACTIONS(3375),
    [anon_sym_sealed] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_where] = ACTIONS(3375),
    [anon_sym_notnull] = ACTIONS(3375),
    [anon_sym_unmanaged] = ACTIONS(3375),
    [anon_sym_checked] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_true] = ACTIONS(3375),
    [anon_sym_false] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3377),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3375),
    [anon_sym_scoped] = ACTIONS(3375),
    [anon_sym_base] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [sym_predefined_type] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_unchecked] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_lock] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_when] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_foreach] = ACTIONS(3375),
    [anon_sym_goto] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_DOT_DOT] = ACTIONS(3377),
    [anon_sym_from] = ACTIONS(3375),
    [anon_sym_into] = ACTIONS(3375),
    [anon_sym_join] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [anon_sym_equals] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_orderby] = ACTIONS(3375),
    [anon_sym_ascending] = ACTIONS(3375),
    [anon_sym_descending] = ACTIONS(3375),
    [anon_sym_group] = ACTIONS(3375),
    [anon_sym_by] = ACTIONS(3375),
    [anon_sym_select] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3375),
    [anon_sym_sizeof] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym___makeref] = ACTIONS(3375),
    [anon_sym___reftype] = ACTIONS(3375),
    [anon_sym___refvalue] = ACTIONS(3375),
    [sym_null_literal] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_integer_literal] = ACTIONS(3375),
    [sym_real_literal] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [sym_verbatim_string_literal] = ACTIONS(3377),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3377),
    [sym_interpolation_verbatim_start] = ACTIONS(3377),
    [sym_interpolation_raw_start] = ACTIONS(3377),
    [sym_raw_string_start] = ACTIONS(3377),
  },
  [2095] = {
    [sym_preproc_region] = STATE(2095),
    [sym_preproc_endregion] = STATE(2095),
    [sym_preproc_line] = STATE(2095),
    [sym_preproc_pragma] = STATE(2095),
    [sym_preproc_nullable] = STATE(2095),
    [sym_preproc_error] = STATE(2095),
    [sym_preproc_warning] = STATE(2095),
    [sym_preproc_define] = STATE(2095),
    [sym_preproc_undef] = STATE(2095),
    [ts_builtin_sym_end] = ACTIONS(3433),
    [sym__identifier_token] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym_alias] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_global] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_unsafe] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_ref] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_delegate] = ACTIONS(3431),
    [anon_sym_record] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_file] = ACTIONS(3431),
    [anon_sym_fixed] = ACTIONS(3431),
    [anon_sym_internal] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_partial] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_required] = ACTIONS(3431),
    [anon_sym_sealed] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_where] = ACTIONS(3431),
    [anon_sym_notnull] = ACTIONS(3431),
    [anon_sym_unmanaged] = ACTIONS(3431),
    [anon_sym_checked] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_true] = ACTIONS(3431),
    [anon_sym_false] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_this] = ACTIONS(3431),
    [anon_sym_scoped] = ACTIONS(3431),
    [anon_sym_base] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [sym_predefined_type] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_unchecked] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_lock] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_when] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_foreach] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_DOT_DOT] = ACTIONS(3433),
    [anon_sym_from] = ACTIONS(3431),
    [anon_sym_into] = ACTIONS(3431),
    [anon_sym_join] = ACTIONS(3431),
    [anon_sym_on] = ACTIONS(3431),
    [anon_sym_equals] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_orderby] = ACTIONS(3431),
    [anon_sym_ascending] = ACTIONS(3431),
    [anon_sym_descending] = ACTIONS(3431),
    [anon_sym_group] = ACTIONS(3431),
    [anon_sym_by] = ACTIONS(3431),
    [anon_sym_select] = ACTIONS(3431),
    [anon_sym_stackalloc] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym___makeref] = ACTIONS(3431),
    [anon_sym___reftype] = ACTIONS(3431),
    [anon_sym___refvalue] = ACTIONS(3431),
    [sym_null_literal] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [sym_integer_literal] = ACTIONS(3431),
    [sym_real_literal] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_verbatim_string_literal] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3433),
    [sym_interpolation_verbatim_start] = ACTIONS(3433),
    [sym_interpolation_raw_start] = ACTIONS(3433),
    [sym_raw_string_start] = ACTIONS(3433),
  },
  [2096] = {
    [sym_preproc_region] = STATE(2096),
    [sym_preproc_endregion] = STATE(2096),
    [sym_preproc_line] = STATE(2096),
    [sym_preproc_pragma] = STATE(2096),
    [sym_preproc_nullable] = STATE(2096),
    [sym_preproc_error] = STATE(2096),
    [sym_preproc_warning] = STATE(2096),
    [sym_preproc_define] = STATE(2096),
    [sym_preproc_undef] = STATE(2096),
    [sym__identifier_token] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym_alias] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_unsafe] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_ref] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_delegate] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_file] = ACTIONS(3150),
    [anon_sym_fixed] = ACTIONS(3150),
    [anon_sym_internal] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_partial] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_required] = ACTIONS(3150),
    [anon_sym_sealed] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_where] = ACTIONS(3150),
    [anon_sym_notnull] = ACTIONS(3150),
    [anon_sym_unmanaged] = ACTIONS(3150),
    [anon_sym_checked] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_true] = ACTIONS(3150),
    [anon_sym_false] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_this] = ACTIONS(3150),
    [anon_sym_scoped] = ACTIONS(3150),
    [anon_sym_base] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [sym_predefined_type] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_unchecked] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_lock] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_catch] = ACTIONS(3150),
    [anon_sym_when] = ACTIONS(3150),
    [anon_sym_finally] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_foreach] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_into] = ACTIONS(3150),
    [anon_sym_join] = ACTIONS(3150),
    [anon_sym_on] = ACTIONS(3150),
    [anon_sym_equals] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_orderby] = ACTIONS(3150),
    [anon_sym_ascending] = ACTIONS(3150),
    [anon_sym_descending] = ACTIONS(3150),
    [anon_sym_group] = ACTIONS(3150),
    [anon_sym_by] = ACTIONS(3150),
    [anon_sym_select] = ACTIONS(3150),
    [anon_sym_stackalloc] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym___makeref] = ACTIONS(3150),
    [anon_sym___reftype] = ACTIONS(3150),
    [anon_sym___refvalue] = ACTIONS(3150),
    [sym_null_literal] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [sym_integer_literal] = ACTIONS(3150),
    [sym_real_literal] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_verbatim_string_literal] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3152),
    [sym_interpolation_verbatim_start] = ACTIONS(3152),
    [sym_interpolation_raw_start] = ACTIONS(3152),
    [sym_raw_string_start] = ACTIONS(3152),
  },
  [2097] = {
    [sym_preproc_region] = STATE(2097),
    [sym_preproc_endregion] = STATE(2097),
    [sym_preproc_line] = STATE(2097),
    [sym_preproc_pragma] = STATE(2097),
    [sym_preproc_nullable] = STATE(2097),
    [sym_preproc_error] = STATE(2097),
    [sym_preproc_warning] = STATE(2097),
    [sym_preproc_define] = STATE(2097),
    [sym_preproc_undef] = STATE(2097),
    [sym__identifier_token] = ACTIONS(3157),
    [anon_sym_extern] = ACTIONS(3157),
    [anon_sym_alias] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3157),
    [anon_sym_using] = ACTIONS(3157),
    [anon_sym_unsafe] = ACTIONS(3157),
    [anon_sym_static] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3157),
    [anon_sym_ref] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_RBRACE] = ACTIONS(3159),
    [anon_sym_delegate] = ACTIONS(3157),
    [anon_sym_abstract] = ACTIONS(3157),
    [anon_sym_async] = ACTIONS(3157),
    [anon_sym_const] = ACTIONS(3157),
    [anon_sym_file] = ACTIONS(3157),
    [anon_sym_fixed] = ACTIONS(3157),
    [anon_sym_internal] = ACTIONS(3157),
    [anon_sym_new] = ACTIONS(3157),
    [anon_sym_override] = ACTIONS(3157),
    [anon_sym_partial] = ACTIONS(3157),
    [anon_sym_private] = ACTIONS(3157),
    [anon_sym_protected] = ACTIONS(3157),
    [anon_sym_public] = ACTIONS(3157),
    [anon_sym_readonly] = ACTIONS(3157),
    [anon_sym_required] = ACTIONS(3157),
    [anon_sym_sealed] = ACTIONS(3157),
    [anon_sym_virtual] = ACTIONS(3157),
    [anon_sym_volatile] = ACTIONS(3157),
    [anon_sym_where] = ACTIONS(3157),
    [anon_sym_notnull] = ACTIONS(3157),
    [anon_sym_unmanaged] = ACTIONS(3157),
    [anon_sym_checked] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3159),
    [anon_sym_TILDE] = ACTIONS(3159),
    [anon_sym_PLUS_PLUS] = ACTIONS(3159),
    [anon_sym_DASH_DASH] = ACTIONS(3159),
    [anon_sym_true] = ACTIONS(3157),
    [anon_sym_false] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_CARET] = ACTIONS(3159),
    [anon_sym_AMP] = ACTIONS(3159),
    [anon_sym_this] = ACTIONS(3157),
    [anon_sym_scoped] = ACTIONS(3157),
    [anon_sym_base] = ACTIONS(3157),
    [anon_sym_var] = ACTIONS(3157),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_break] = ACTIONS(3157),
    [anon_sym_unchecked] = ACTIONS(3157),
    [anon_sym_continue] = ACTIONS(3157),
    [anon_sym_do] = ACTIONS(3157),
    [anon_sym_while] = ACTIONS(3157),
    [anon_sym_for] = ACTIONS(3157),
    [anon_sym_lock] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3157),
    [anon_sym_switch] = ACTIONS(3157),
    [anon_sym_case] = ACTIONS(3157),
    [anon_sym_default] = ACTIONS(3157),
    [anon_sym_throw] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_catch] = ACTIONS(3157),
    [anon_sym_when] = ACTIONS(3157),
    [anon_sym_finally] = ACTIONS(3157),
    [anon_sym_await] = ACTIONS(3157),
    [anon_sym_foreach] = ACTIONS(3157),
    [anon_sym_goto] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3157),
    [anon_sym_else] = ACTIONS(3157),
    [anon_sym_DOT_DOT] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3157),
    [anon_sym_into] = ACTIONS(3157),
    [anon_sym_join] = ACTIONS(3157),
    [anon_sym_on] = ACTIONS(3157),
    [anon_sym_equals] = ACTIONS(3157),
    [anon_sym_let] = ACTIONS(3157),
    [anon_sym_orderby] = ACTIONS(3157),
    [anon_sym_ascending] = ACTIONS(3157),
    [anon_sym_descending] = ACTIONS(3157),
    [anon_sym_group] = ACTIONS(3157),
    [anon_sym_by] = ACTIONS(3157),
    [anon_sym_select] = ACTIONS(3157),
    [anon_sym_stackalloc] = ACTIONS(3157),
    [anon_sym_sizeof] = ACTIONS(3157),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym___makeref] = ACTIONS(3157),
    [anon_sym___reftype] = ACTIONS(3157),
    [anon_sym___refvalue] = ACTIONS(3157),
    [sym_null_literal] = ACTIONS(3157),
    [anon_sym_SQUOTE] = ACTIONS(3159),
    [sym_integer_literal] = ACTIONS(3157),
    [sym_real_literal] = ACTIONS(3159),
    [anon_sym_DQUOTE] = ACTIONS(3159),
    [sym_verbatim_string_literal] = ACTIONS(3159),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3159),
    [sym_interpolation_verbatim_start] = ACTIONS(3159),
    [sym_interpolation_raw_start] = ACTIONS(3159),
    [sym_raw_string_start] = ACTIONS(3159),
  },
  [2098] = {
    [sym_preproc_region] = STATE(2098),
    [sym_preproc_endregion] = STATE(2098),
    [sym_preproc_line] = STATE(2098),
    [sym_preproc_pragma] = STATE(2098),
    [sym_preproc_nullable] = STATE(2098),
    [sym_preproc_error] = STATE(2098),
    [sym_preproc_warning] = STATE(2098),
    [sym_preproc_define] = STATE(2098),
    [sym_preproc_undef] = STATE(2098),
    [sym__identifier_token] = ACTIONS(3165),
    [anon_sym_extern] = ACTIONS(3165),
    [anon_sym_alias] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_using] = ACTIONS(3165),
    [anon_sym_unsafe] = ACTIONS(3165),
    [anon_sym_static] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3165),
    [anon_sym_ref] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_delegate] = ACTIONS(3165),
    [anon_sym_abstract] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_const] = ACTIONS(3165),
    [anon_sym_file] = ACTIONS(3165),
    [anon_sym_fixed] = ACTIONS(3165),
    [anon_sym_internal] = ACTIONS(3165),
    [anon_sym_new] = ACTIONS(3165),
    [anon_sym_override] = ACTIONS(3165),
    [anon_sym_partial] = ACTIONS(3165),
    [anon_sym_private] = ACTIONS(3165),
    [anon_sym_protected] = ACTIONS(3165),
    [anon_sym_public] = ACTIONS(3165),
    [anon_sym_readonly] = ACTIONS(3165),
    [anon_sym_required] = ACTIONS(3165),
    [anon_sym_sealed] = ACTIONS(3165),
    [anon_sym_virtual] = ACTIONS(3165),
    [anon_sym_volatile] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3165),
    [anon_sym_notnull] = ACTIONS(3165),
    [anon_sym_unmanaged] = ACTIONS(3165),
    [anon_sym_checked] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_true] = ACTIONS(3165),
    [anon_sym_false] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_this] = ACTIONS(3165),
    [anon_sym_scoped] = ACTIONS(3165),
    [anon_sym_base] = ACTIONS(3165),
    [anon_sym_var] = ACTIONS(3165),
    [sym_predefined_type] = ACTIONS(3165),
    [anon_sym_break] = ACTIONS(3165),
    [anon_sym_unchecked] = ACTIONS(3165),
    [anon_sym_continue] = ACTIONS(3165),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_for] = ACTIONS(3165),
    [anon_sym_lock] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_switch] = ACTIONS(3165),
    [anon_sym_case] = ACTIONS(3165),
    [anon_sym_default] = ACTIONS(3165),
    [anon_sym_throw] = ACTIONS(3165),
    [anon_sym_try] = ACTIONS(3165),
    [anon_sym_catch] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_finally] = ACTIONS(3165),
    [anon_sym_await] = ACTIONS(3165),
    [anon_sym_foreach] = ACTIONS(3165),
    [anon_sym_goto] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_into] = ACTIONS(3165),
    [anon_sym_join] = ACTIONS(3165),
    [anon_sym_on] = ACTIONS(3165),
    [anon_sym_equals] = ACTIONS(3165),
    [anon_sym_let] = ACTIONS(3165),
    [anon_sym_orderby] = ACTIONS(3165),
    [anon_sym_ascending] = ACTIONS(3165),
    [anon_sym_descending] = ACTIONS(3165),
    [anon_sym_group] = ACTIONS(3165),
    [anon_sym_by] = ACTIONS(3165),
    [anon_sym_select] = ACTIONS(3165),
    [anon_sym_stackalloc] = ACTIONS(3165),
    [anon_sym_sizeof] = ACTIONS(3165),
    [anon_sym_typeof] = ACTIONS(3165),
    [anon_sym___makeref] = ACTIONS(3165),
    [anon_sym___reftype] = ACTIONS(3165),
    [anon_sym___refvalue] = ACTIONS(3165),
    [sym_null_literal] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [sym_integer_literal] = ACTIONS(3165),
    [sym_real_literal] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [sym_verbatim_string_literal] = ACTIONS(3167),
    [aux_sym_preproc_if_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3167),
    [sym_interpolation_verbatim_start] = ACTIONS(3167),
    [sym_interpolation_raw_start] = ACTIONS(3167),
    [sym_raw_string_start] = ACTIONS(3167),
  },
  [2099] = {
    [sym_preproc_region] = STATE(2099),
    [sym_preproc_endregion] = STATE(2099),
    [sym_preproc_line] = STATE(2099),
    [sym_preproc_pragma] = STATE(2099),
    [sym_preproc_nullable] = STATE(2099),
    [sym_preproc_error] = STATE(2099),
    [sym_preproc_warning] = STATE(2099),
    [sym_preproc_define] = STATE(2099),
    [sym_preproc_undef] = STATE(2099),
    [sym__identifier_token] = ACTIONS(3161),
    [anon_sym_extern] = ACTIONS(3161),
    [anon_sym_alias] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_global] = ACTIONS(3161),
    [anon_sym_using] = ACTIONS(3161),
    [anon_sym_unsafe] = ACTIONS(3161),
    [anon_sym_static] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3163),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3161),
    [anon_sym_ref] = ACTIONS(3161),
    [anon_sym_LBRACE] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3163),
    [anon_sym_delegate] = ACTIONS(3161),
    [anon_sym_abstract] = ACTIONS(3161),
    [anon_sym_async] = ACTIONS(3161),
    [anon_sym_const] = ACTIONS(3161),
    [anon_sym_file] = ACTIONS(3161),
    [anon_sym_fixed] = ACTIONS(3161),
    [anon_sym_internal] = ACTIONS(3161),
    [anon_sym_new] = ACTIONS(3161),
    [anon_sym_override] = ACTIONS(3161),
    [anon_sym_partial] = ACTIONS(3161),
    [anon_sym_private] = ACTIONS(3161),
    [anon_sym_protected] = ACTIONS(3161),
    [anon_sym_public] = ACTIONS(3161),
    [anon_sym_readonly] = ACTIONS(3161),
    [anon_sym_required] = ACTIONS(3161),
    [anon_sym_sealed] = ACTIONS(3161),
    [anon_sym_virtual] = ACTIONS(3161),
    [anon_sym_volatile] = ACTIONS(3161),
    [anon_sym_where] = ACTIONS(3161),
    [anon_sym_notnull] = ACTIONS(3161),
    [anon_sym_unmanaged] = ACTIONS(3161),
    [anon_sym_checked] = ACTIONS(3161),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3163),
    [anon_sym_true] = ACTIONS(3161),
    [anon_sym_false] = ACTIONS(3161),
    [anon_sym_PLUS] = ACTIONS(3161),
    [anon_sym_DASH] = ACTIONS(3161),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_this] = ACTIONS(3161),
    [anon_sym_scoped] = ACTIONS(3161),
    [anon_sym_base] = ACTIONS(3161),
    [anon_sym_var] = ACTIONS(3161),
    [sym_predefined_type] = ACTIONS(3161),
    [anon_sym_break] = ACTIONS(3161),
    [anon_sym_unchecked] = ACTIONS(3161),
    [anon_sym_continue] = ACTIONS(3161),
    [anon_sym_do] = ACTIONS(3161),
    [anon_sym_while] = ACTIONS(3161),
    [anon_sym_for] = ACTIONS(3161),
    [anon_sym_lock] = ACTIONS(3161),
    [anon_sym_yield] = ACTIONS(3161),
    [anon_sym_switch] = ACTIONS(3161),
    [anon_sym_case] = ACTIONS(3161),
    [anon_sym_default] = ACTIONS(3161),
    [anon_sym_throw] = ACTIONS(3161),
    [anon_sym_try] = ACTIONS(3161),
    [anon_sym_catch] = ACTIONS(3161),
    [anon_sym_when] = ACTIONS(3161),
    [anon_sym_finally] = ACTIONS(3161),
    [anon_sym_await] = ACTIONS(3161),
    [anon_sym_foreach] = ACTIONS(3161),
    [anon_sym_goto] = ACTIONS(3161),
    [anon_sym_if] = ACTIONS(3161),
    [anon_sym_else] = ACTIONS(3161),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_from] = ACTIONS(3161),
    [anon_sym_into] = ACTIONS(3161),
    [anon_sym_join] = ACTIONS(3161),
    [anon_sym_on] = ACTIONS(3161),
    [anon_sym_equals] = ACTIONS(3161),
    [anon_sym_let] = ACTIONS(3161),
    [anon_sym_orderby] = ACTIONS(3161),
    [anon_sym_ascending] = ACTIONS(3161),
    [anon_sym_descending] = ACTIONS(3161),
    [anon_sym_group] = ACTIONS(3161),
    [anon_sym_by] = ACTIONS(3161),
    [anon_sym_select] = ACTIONS(3161),
    [anon_sym_stackalloc] = ACTIONS(3161),
    [anon_sym_sizeof] = ACTIONS(3161),
    [anon_sym_typeof] = ACTIONS(3161),
    [anon_sym___makeref] = ACTIONS(3161),
    [anon_sym___reftype] = ACTIONS(3161),
    [anon_sym___refvalue] = ACTIONS(3161),
    [sym_null_literal] = ACTIONS(3161),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [sym_integer_literal] = ACTIONS(3161),
    [sym_real_literal] = ACTIONS(3163),
    [anon_sym_DQUOTE] = ACTIONS(3163),
    [sym_verbatim_string_literal] = ACTIONS(3163),
    [aux_sym_preproc_if_token1] = ACTIONS(3163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3163),
    [sym_interpolation_verbatim_start] = ACTIONS(3163),
    [sym_interpolation_raw_start] = ACTIONS(3163),
    [sym_raw_string_start] = ACTIONS(3163),
  },
  [2100] = {
    [sym_preproc_region] = STATE(2100),
    [sym_preproc_endregion] = STATE(2100),
    [sym_preproc_line] = STATE(2100),
    [sym_preproc_pragma] = STATE(2100),
    [sym_preproc_nullable] = STATE(2100),
    [sym_preproc_error] = STATE(2100),
    [sym_preproc_warning] = STATE(2100),
    [sym_preproc_define] = STATE(2100),
    [sym_preproc_undef] = STATE(2100),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_checked] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2979),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_true] = ACTIONS(2977),
    [anon_sym_false] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym_this] = ACTIONS(2977),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_base] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_unchecked] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_lock] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_case] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_catch] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_finally] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_foreach] = ACTIONS(2977),
    [anon_sym_goto] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_stackalloc] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym___makeref] = ACTIONS(2977),
    [anon_sym___reftype] = ACTIONS(2977),
    [anon_sym___refvalue] = ACTIONS(2977),
    [sym_null_literal] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_integer_literal] = ACTIONS(2977),
    [sym_real_literal] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [sym_verbatim_string_literal] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(2979),
    [sym_interpolation_verbatim_start] = ACTIONS(2979),
    [sym_interpolation_raw_start] = ACTIONS(2979),
    [sym_raw_string_start] = ACTIONS(2979),
  },
  [2101] = {
    [sym_preproc_region] = STATE(2101),
    [sym_preproc_endregion] = STATE(2101),
    [sym_preproc_line] = STATE(2101),
    [sym_preproc_pragma] = STATE(2101),
    [sym_preproc_nullable] = STATE(2101),
    [sym_preproc_error] = STATE(2101),
    [sym_preproc_warning] = STATE(2101),
    [sym_preproc_define] = STATE(2101),
    [sym_preproc_undef] = STATE(2101),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2102] = {
    [sym_preproc_region] = STATE(2102),
    [sym_preproc_endregion] = STATE(2102),
    [sym_preproc_line] = STATE(2102),
    [sym_preproc_pragma] = STATE(2102),
    [sym_preproc_nullable] = STATE(2102),
    [sym_preproc_error] = STATE(2102),
    [sym_preproc_warning] = STATE(2102),
    [sym_preproc_define] = STATE(2102),
    [sym_preproc_undef] = STATE(2102),
    [sym__identifier_token] = ACTIONS(3335),
    [anon_sym_extern] = ACTIONS(3335),
    [anon_sym_alias] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_global] = ACTIONS(3335),
    [anon_sym_using] = ACTIONS(3335),
    [anon_sym_unsafe] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_ref] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_RBRACE] = ACTIONS(3337),
    [anon_sym_delegate] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_file] = ACTIONS(3335),
    [anon_sym_fixed] = ACTIONS(3335),
    [anon_sym_internal] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_override] = ACTIONS(3335),
    [anon_sym_partial] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_required] = ACTIONS(3335),
    [anon_sym_sealed] = ACTIONS(3335),
    [anon_sym_virtual] = ACTIONS(3335),
    [anon_sym_volatile] = ACTIONS(3335),
    [anon_sym_where] = ACTIONS(3335),
    [anon_sym_notnull] = ACTIONS(3335),
    [anon_sym_unmanaged] = ACTIONS(3335),
    [anon_sym_checked] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_TILDE] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_true] = ACTIONS(3335),
    [anon_sym_false] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_this] = ACTIONS(3335),
    [anon_sym_scoped] = ACTIONS(3335),
    [anon_sym_base] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [sym_predefined_type] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_unchecked] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_lock] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_case] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_when] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
    [anon_sym_foreach] = ACTIONS(3335),
    [anon_sym_goto] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_DOT_DOT] = ACTIONS(3337),
    [anon_sym_from] = ACTIONS(3335),
    [anon_sym_into] = ACTIONS(3335),
    [anon_sym_join] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [anon_sym_equals] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_orderby] = ACTIONS(3335),
    [anon_sym_ascending] = ACTIONS(3335),
    [anon_sym_descending] = ACTIONS(3335),
    [anon_sym_group] = ACTIONS(3335),
    [anon_sym_by] = ACTIONS(3335),
    [anon_sym_select] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3335),
    [anon_sym_sizeof] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym___makeref] = ACTIONS(3335),
    [anon_sym___reftype] = ACTIONS(3335),
    [anon_sym___refvalue] = ACTIONS(3335),
    [sym_null_literal] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_integer_literal] = ACTIONS(3335),
    [sym_real_literal] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [sym_verbatim_string_literal] = ACTIONS(3337),
    [aux_sym_preproc_if_token1] = ACTIONS(3337),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3337),
    [sym_interpolation_verbatim_start] = ACTIONS(3337),
    [sym_interpolation_raw_start] = ACTIONS(3337),
    [sym_raw_string_start] = ACTIONS(3337),
  },
  [2103] = {
    [sym_preproc_region] = STATE(2103),
    [sym_preproc_endregion] = STATE(2103),
    [sym_preproc_line] = STATE(2103),
    [sym_preproc_pragma] = STATE(2103),
    [sym_preproc_nullable] = STATE(2103),
    [sym_preproc_error] = STATE(2103),
    [sym_preproc_warning] = STATE(2103),
    [sym_preproc_define] = STATE(2103),
    [sym_preproc_undef] = STATE(2103),
    [sym__identifier_token] = ACTIONS(3219),
    [anon_sym_extern] = ACTIONS(3219),
    [anon_sym_alias] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_global] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_unsafe] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_ref] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_delegate] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_file] = ACTIONS(3219),
    [anon_sym_fixed] = ACTIONS(3219),
    [anon_sym_internal] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_partial] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_required] = ACTIONS(3219),
    [anon_sym_sealed] = ACTIONS(3219),
    [anon_sym_virtual] = ACTIONS(3219),
    [anon_sym_volatile] = ACTIONS(3219),
    [anon_sym_where] = ACTIONS(3219),
    [anon_sym_notnull] = ACTIONS(3219),
    [anon_sym_unmanaged] = ACTIONS(3219),
    [anon_sym_checked] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [anon_sym_true] = ACTIONS(3219),
    [anon_sym_false] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_CARET] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_this] = ACTIONS(3219),
    [anon_sym_scoped] = ACTIONS(3219),
    [anon_sym_base] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [sym_predefined_type] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_unchecked] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_lock] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_when] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_foreach] = ACTIONS(3219),
    [anon_sym_goto] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_DOT_DOT] = ACTIONS(3221),
    [anon_sym_from] = ACTIONS(3219),
    [anon_sym_into] = ACTIONS(3219),
    [anon_sym_join] = ACTIONS(3219),
    [anon_sym_on] = ACTIONS(3219),
    [anon_sym_equals] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_orderby] = ACTIONS(3219),
    [anon_sym_ascending] = ACTIONS(3219),
    [anon_sym_descending] = ACTIONS(3219),
    [anon_sym_group] = ACTIONS(3219),
    [anon_sym_by] = ACTIONS(3219),
    [anon_sym_select] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3219),
    [anon_sym_sizeof] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym___makeref] = ACTIONS(3219),
    [anon_sym___reftype] = ACTIONS(3219),
    [anon_sym___refvalue] = ACTIONS(3219),
    [sym_null_literal] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [sym_integer_literal] = ACTIONS(3219),
    [sym_real_literal] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [sym_verbatim_string_literal] = ACTIONS(3221),
    [aux_sym_preproc_if_token1] = ACTIONS(3221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3221),
    [sym_interpolation_verbatim_start] = ACTIONS(3221),
    [sym_interpolation_raw_start] = ACTIONS(3221),
    [sym_raw_string_start] = ACTIONS(3221),
  },
  [2104] = {
    [sym_preproc_region] = STATE(2104),
    [sym_preproc_endregion] = STATE(2104),
    [sym_preproc_line] = STATE(2104),
    [sym_preproc_pragma] = STATE(2104),
    [sym_preproc_nullable] = STATE(2104),
    [sym_preproc_error] = STATE(2104),
    [sym_preproc_warning] = STATE(2104),
    [sym_preproc_define] = STATE(2104),
    [sym_preproc_undef] = STATE(2104),
    [sym__identifier_token] = ACTIONS(3287),
    [anon_sym_extern] = ACTIONS(3287),
    [anon_sym_alias] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_unsafe] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_ref] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_delegate] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_file] = ACTIONS(3287),
    [anon_sym_fixed] = ACTIONS(3287),
    [anon_sym_internal] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_partial] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_required] = ACTIONS(3287),
    [anon_sym_sealed] = ACTIONS(3287),
    [anon_sym_virtual] = ACTIONS(3287),
    [anon_sym_volatile] = ACTIONS(3287),
    [anon_sym_where] = ACTIONS(3287),
    [anon_sym_notnull] = ACTIONS(3287),
    [anon_sym_unmanaged] = ACTIONS(3287),
    [anon_sym_checked] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [anon_sym_true] = ACTIONS(3287),
    [anon_sym_false] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_CARET] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_this] = ACTIONS(3287),
    [anon_sym_scoped] = ACTIONS(3287),
    [anon_sym_base] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [sym_predefined_type] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_unchecked] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_lock] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_case] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_when] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_foreach] = ACTIONS(3287),
    [anon_sym_goto] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3289),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_into] = ACTIONS(3287),
    [anon_sym_join] = ACTIONS(3287),
    [anon_sym_on] = ACTIONS(3287),
    [anon_sym_equals] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_orderby] = ACTIONS(3287),
    [anon_sym_ascending] = ACTIONS(3287),
    [anon_sym_descending] = ACTIONS(3287),
    [anon_sym_group] = ACTIONS(3287),
    [anon_sym_by] = ACTIONS(3287),
    [anon_sym_select] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym___makeref] = ACTIONS(3287),
    [anon_sym___reftype] = ACTIONS(3287),
    [anon_sym___refvalue] = ACTIONS(3287),
    [sym_null_literal] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [sym_integer_literal] = ACTIONS(3287),
    [sym_real_literal] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_verbatim_string_literal] = ACTIONS(3289),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3289),
    [sym_interpolation_verbatim_start] = ACTIONS(3289),
    [sym_interpolation_raw_start] = ACTIONS(3289),
    [sym_raw_string_start] = ACTIONS(3289),
  },
  [2105] = {
    [sym_preproc_region] = STATE(2105),
    [sym_preproc_endregion] = STATE(2105),
    [sym_preproc_line] = STATE(2105),
    [sym_preproc_pragma] = STATE(2105),
    [sym_preproc_nullable] = STATE(2105),
    [sym_preproc_error] = STATE(2105),
    [sym_preproc_warning] = STATE(2105),
    [sym_preproc_define] = STATE(2105),
    [sym_preproc_undef] = STATE(2105),
    [sym__identifier_token] = ACTIONS(3169),
    [anon_sym_extern] = ACTIONS(3169),
    [anon_sym_alias] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(3171),
    [anon_sym_global] = ACTIONS(3169),
    [anon_sym_using] = ACTIONS(3169),
    [anon_sym_unsafe] = ACTIONS(3169),
    [anon_sym_static] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3169),
    [anon_sym_ref] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_RBRACE] = ACTIONS(3171),
    [anon_sym_delegate] = ACTIONS(3169),
    [anon_sym_abstract] = ACTIONS(3169),
    [anon_sym_async] = ACTIONS(3169),
    [anon_sym_const] = ACTIONS(3169),
    [anon_sym_file] = ACTIONS(3169),
    [anon_sym_fixed] = ACTIONS(3169),
    [anon_sym_internal] = ACTIONS(3169),
    [anon_sym_new] = ACTIONS(3169),
    [anon_sym_override] = ACTIONS(3169),
    [anon_sym_partial] = ACTIONS(3169),
    [anon_sym_private] = ACTIONS(3169),
    [anon_sym_protected] = ACTIONS(3169),
    [anon_sym_public] = ACTIONS(3169),
    [anon_sym_readonly] = ACTIONS(3169),
    [anon_sym_required] = ACTIONS(3169),
    [anon_sym_sealed] = ACTIONS(3169),
    [anon_sym_virtual] = ACTIONS(3169),
    [anon_sym_volatile] = ACTIONS(3169),
    [anon_sym_where] = ACTIONS(3169),
    [anon_sym_notnull] = ACTIONS(3169),
    [anon_sym_unmanaged] = ACTIONS(3169),
    [anon_sym_checked] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3171),
    [anon_sym_TILDE] = ACTIONS(3171),
    [anon_sym_PLUS_PLUS] = ACTIONS(3171),
    [anon_sym_DASH_DASH] = ACTIONS(3171),
    [anon_sym_true] = ACTIONS(3169),
    [anon_sym_false] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(3171),
    [anon_sym_CARET] = ACTIONS(3171),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_this] = ACTIONS(3169),
    [anon_sym_scoped] = ACTIONS(3169),
    [anon_sym_base] = ACTIONS(3169),
    [anon_sym_var] = ACTIONS(3169),
    [sym_predefined_type] = ACTIONS(3169),
    [anon_sym_break] = ACTIONS(3169),
    [anon_sym_unchecked] = ACTIONS(3169),
    [anon_sym_continue] = ACTIONS(3169),
    [anon_sym_do] = ACTIONS(3169),
    [anon_sym_while] = ACTIONS(3169),
    [anon_sym_for] = ACTIONS(3169),
    [anon_sym_lock] = ACTIONS(3169),
    [anon_sym_yield] = ACTIONS(3169),
    [anon_sym_switch] = ACTIONS(3169),
    [anon_sym_case] = ACTIONS(3169),
    [anon_sym_default] = ACTIONS(3169),
    [anon_sym_throw] = ACTIONS(3169),
    [anon_sym_try] = ACTIONS(3169),
    [anon_sym_when] = ACTIONS(3169),
    [anon_sym_await] = ACTIONS(3169),
    [anon_sym_foreach] = ACTIONS(3169),
    [anon_sym_goto] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_DOT_DOT] = ACTIONS(3171),
    [anon_sym_from] = ACTIONS(3169),
    [anon_sym_into] = ACTIONS(3169),
    [anon_sym_join] = ACTIONS(3169),
    [anon_sym_on] = ACTIONS(3169),
    [anon_sym_equals] = ACTIONS(3169),
    [anon_sym_let] = ACTIONS(3169),
    [anon_sym_orderby] = ACTIONS(3169),
    [anon_sym_ascending] = ACTIONS(3169),
    [anon_sym_descending] = ACTIONS(3169),
    [anon_sym_group] = ACTIONS(3169),
    [anon_sym_by] = ACTIONS(3169),
    [anon_sym_select] = ACTIONS(3169),
    [anon_sym_stackalloc] = ACTIONS(3169),
    [anon_sym_sizeof] = ACTIONS(3169),
    [anon_sym_typeof] = ACTIONS(3169),
    [anon_sym___makeref] = ACTIONS(3169),
    [anon_sym___reftype] = ACTIONS(3169),
    [anon_sym___refvalue] = ACTIONS(3169),
    [sym_null_literal] = ACTIONS(3169),
    [anon_sym_SQUOTE] = ACTIONS(3171),
    [sym_integer_literal] = ACTIONS(3169),
    [sym_real_literal] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3171),
    [sym_verbatim_string_literal] = ACTIONS(3171),
    [aux_sym_preproc_if_token1] = ACTIONS(3171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3171),
    [sym_interpolation_verbatim_start] = ACTIONS(3171),
    [sym_interpolation_raw_start] = ACTIONS(3171),
    [sym_raw_string_start] = ACTIONS(3171),
  },
  [2106] = {
    [sym_preproc_region] = STATE(2106),
    [sym_preproc_endregion] = STATE(2106),
    [sym_preproc_line] = STATE(2106),
    [sym_preproc_pragma] = STATE(2106),
    [sym_preproc_nullable] = STATE(2106),
    [sym_preproc_error] = STATE(2106),
    [sym_preproc_warning] = STATE(2106),
    [sym_preproc_define] = STATE(2106),
    [sym_preproc_undef] = STATE(2106),
    [sym__identifier_token] = ACTIONS(3303),
    [anon_sym_extern] = ACTIONS(3303),
    [anon_sym_alias] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_global] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_unsafe] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_delegate] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_file] = ACTIONS(3303),
    [anon_sym_fixed] = ACTIONS(3303),
    [anon_sym_internal] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_partial] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_required] = ACTIONS(3303),
    [anon_sym_sealed] = ACTIONS(3303),
    [anon_sym_virtual] = ACTIONS(3303),
    [anon_sym_volatile] = ACTIONS(3303),
    [anon_sym_where] = ACTIONS(3303),
    [anon_sym_notnull] = ACTIONS(3303),
    [anon_sym_unmanaged] = ACTIONS(3303),
    [anon_sym_checked] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [anon_sym_true] = ACTIONS(3303),
    [anon_sym_false] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_STAR] = ACTIONS(3305),
    [anon_sym_CARET] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_this] = ACTIONS(3303),
    [anon_sym_scoped] = ACTIONS(3303),
    [anon_sym_base] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [sym_predefined_type] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_unchecked] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_lock] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_case] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_when] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_foreach] = ACTIONS(3303),
    [anon_sym_goto] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_DOT_DOT] = ACTIONS(3305),
    [anon_sym_from] = ACTIONS(3303),
    [anon_sym_into] = ACTIONS(3303),
    [anon_sym_join] = ACTIONS(3303),
    [anon_sym_on] = ACTIONS(3303),
    [anon_sym_equals] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_orderby] = ACTIONS(3303),
    [anon_sym_ascending] = ACTIONS(3303),
    [anon_sym_descending] = ACTIONS(3303),
    [anon_sym_group] = ACTIONS(3303),
    [anon_sym_by] = ACTIONS(3303),
    [anon_sym_select] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3303),
    [anon_sym_sizeof] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym___makeref] = ACTIONS(3303),
    [anon_sym___reftype] = ACTIONS(3303),
    [anon_sym___refvalue] = ACTIONS(3303),
    [sym_null_literal] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [sym_integer_literal] = ACTIONS(3303),
    [sym_real_literal] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [sym_verbatim_string_literal] = ACTIONS(3305),
    [aux_sym_preproc_if_token1] = ACTIONS(3305),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3305),
    [sym_interpolation_verbatim_start] = ACTIONS(3305),
    [sym_interpolation_raw_start] = ACTIONS(3305),
    [sym_raw_string_start] = ACTIONS(3305),
  },
  [2107] = {
    [sym_preproc_region] = STATE(2107),
    [sym_preproc_endregion] = STATE(2107),
    [sym_preproc_line] = STATE(2107),
    [sym_preproc_pragma] = STATE(2107),
    [sym_preproc_nullable] = STATE(2107),
    [sym_preproc_error] = STATE(2107),
    [sym_preproc_warning] = STATE(2107),
    [sym_preproc_define] = STATE(2107),
    [sym_preproc_undef] = STATE(2107),
    [sym__identifier_token] = ACTIONS(3247),
    [anon_sym_extern] = ACTIONS(3247),
    [anon_sym_alias] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_global] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_unsafe] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_ref] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_delegate] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_file] = ACTIONS(3247),
    [anon_sym_fixed] = ACTIONS(3247),
    [anon_sym_internal] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_partial] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_required] = ACTIONS(3247),
    [anon_sym_sealed] = ACTIONS(3247),
    [anon_sym_virtual] = ACTIONS(3247),
    [anon_sym_volatile] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3247),
    [anon_sym_notnull] = ACTIONS(3247),
    [anon_sym_unmanaged] = ACTIONS(3247),
    [anon_sym_checked] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [anon_sym_true] = ACTIONS(3247),
    [anon_sym_false] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3249),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_this] = ACTIONS(3247),
    [anon_sym_scoped] = ACTIONS(3247),
    [anon_sym_base] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [sym_predefined_type] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_unchecked] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_lock] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_case] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_when] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_foreach] = ACTIONS(3247),
    [anon_sym_goto] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_DOT_DOT] = ACTIONS(3249),
    [anon_sym_from] = ACTIONS(3247),
    [anon_sym_into] = ACTIONS(3247),
    [anon_sym_join] = ACTIONS(3247),
    [anon_sym_on] = ACTIONS(3247),
    [anon_sym_equals] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_orderby] = ACTIONS(3247),
    [anon_sym_ascending] = ACTIONS(3247),
    [anon_sym_descending] = ACTIONS(3247),
    [anon_sym_group] = ACTIONS(3247),
    [anon_sym_by] = ACTIONS(3247),
    [anon_sym_select] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3247),
    [anon_sym_sizeof] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym___makeref] = ACTIONS(3247),
    [anon_sym___reftype] = ACTIONS(3247),
    [anon_sym___refvalue] = ACTIONS(3247),
    [sym_null_literal] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [sym_integer_literal] = ACTIONS(3247),
    [sym_real_literal] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [sym_verbatim_string_literal] = ACTIONS(3249),
    [aux_sym_preproc_if_token1] = ACTIONS(3249),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3249),
    [sym_interpolation_verbatim_start] = ACTIONS(3249),
    [sym_interpolation_raw_start] = ACTIONS(3249),
    [sym_raw_string_start] = ACTIONS(3249),
  },
  [2108] = {
    [sym_preproc_region] = STATE(2108),
    [sym_preproc_endregion] = STATE(2108),
    [sym_preproc_line] = STATE(2108),
    [sym_preproc_pragma] = STATE(2108),
    [sym_preproc_nullable] = STATE(2108),
    [sym_preproc_error] = STATE(2108),
    [sym_preproc_warning] = STATE(2108),
    [sym_preproc_define] = STATE(2108),
    [sym_preproc_undef] = STATE(2108),
    [sym__identifier_token] = ACTIONS(3307),
    [anon_sym_extern] = ACTIONS(3307),
    [anon_sym_alias] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_global] = ACTIONS(3307),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_unsafe] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3307),
    [anon_sym_ref] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_delegate] = ACTIONS(3307),
    [anon_sym_abstract] = ACTIONS(3307),
    [anon_sym_async] = ACTIONS(3307),
    [anon_sym_const] = ACTIONS(3307),
    [anon_sym_file] = ACTIONS(3307),
    [anon_sym_fixed] = ACTIONS(3307),
    [anon_sym_internal] = ACTIONS(3307),
    [anon_sym_new] = ACTIONS(3307),
    [anon_sym_override] = ACTIONS(3307),
    [anon_sym_partial] = ACTIONS(3307),
    [anon_sym_private] = ACTIONS(3307),
    [anon_sym_protected] = ACTIONS(3307),
    [anon_sym_public] = ACTIONS(3307),
    [anon_sym_readonly] = ACTIONS(3307),
    [anon_sym_required] = ACTIONS(3307),
    [anon_sym_sealed] = ACTIONS(3307),
    [anon_sym_virtual] = ACTIONS(3307),
    [anon_sym_volatile] = ACTIONS(3307),
    [anon_sym_where] = ACTIONS(3307),
    [anon_sym_notnull] = ACTIONS(3307),
    [anon_sym_unmanaged] = ACTIONS(3307),
    [anon_sym_checked] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(3307),
    [anon_sym_false] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3307),
    [anon_sym_scoped] = ACTIONS(3307),
    [anon_sym_base] = ACTIONS(3307),
    [anon_sym_var] = ACTIONS(3307),
    [sym_predefined_type] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3307),
    [anon_sym_unchecked] = ACTIONS(3307),
    [anon_sym_continue] = ACTIONS(3307),
    [anon_sym_do] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3307),
    [anon_sym_lock] = ACTIONS(3307),
    [anon_sym_yield] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3307),
    [anon_sym_case] = ACTIONS(3307),
    [anon_sym_default] = ACTIONS(3307),
    [anon_sym_throw] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3307),
    [anon_sym_when] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3307),
    [anon_sym_foreach] = ACTIONS(3307),
    [anon_sym_goto] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_DOT_DOT] = ACTIONS(3309),
    [anon_sym_from] = ACTIONS(3307),
    [anon_sym_into] = ACTIONS(3307),
    [anon_sym_join] = ACTIONS(3307),
    [anon_sym_on] = ACTIONS(3307),
    [anon_sym_equals] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3307),
    [anon_sym_orderby] = ACTIONS(3307),
    [anon_sym_ascending] = ACTIONS(3307),
    [anon_sym_descending] = ACTIONS(3307),
    [anon_sym_group] = ACTIONS(3307),
    [anon_sym_by] = ACTIONS(3307),
    [anon_sym_select] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3307),
    [anon_sym_sizeof] = ACTIONS(3307),
    [anon_sym_typeof] = ACTIONS(3307),
    [anon_sym___makeref] = ACTIONS(3307),
    [anon_sym___reftype] = ACTIONS(3307),
    [anon_sym___refvalue] = ACTIONS(3307),
    [sym_null_literal] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [sym_integer_literal] = ACTIONS(3307),
    [sym_real_literal] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [sym_verbatim_string_literal] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3309),
    [sym_interpolation_verbatim_start] = ACTIONS(3309),
    [sym_interpolation_raw_start] = ACTIONS(3309),
    [sym_raw_string_start] = ACTIONS(3309),
  },
  [2109] = {
    [sym_preproc_region] = STATE(2109),
    [sym_preproc_endregion] = STATE(2109),
    [sym_preproc_line] = STATE(2109),
    [sym_preproc_pragma] = STATE(2109),
    [sym_preproc_nullable] = STATE(2109),
    [sym_preproc_error] = STATE(2109),
    [sym_preproc_warning] = STATE(2109),
    [sym_preproc_define] = STATE(2109),
    [sym_preproc_undef] = STATE(2109),
    [sym__identifier_token] = ACTIONS(3315),
    [anon_sym_extern] = ACTIONS(3315),
    [anon_sym_alias] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_global] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_unsafe] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_ref] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_delegate] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_file] = ACTIONS(3315),
    [anon_sym_fixed] = ACTIONS(3315),
    [anon_sym_internal] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_partial] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_required] = ACTIONS(3315),
    [anon_sym_sealed] = ACTIONS(3315),
    [anon_sym_virtual] = ACTIONS(3315),
    [anon_sym_volatile] = ACTIONS(3315),
    [anon_sym_where] = ACTIONS(3315),
    [anon_sym_notnull] = ACTIONS(3315),
    [anon_sym_unmanaged] = ACTIONS(3315),
    [anon_sym_checked] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [anon_sym_true] = ACTIONS(3315),
    [anon_sym_false] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3317),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_this] = ACTIONS(3315),
    [anon_sym_scoped] = ACTIONS(3315),
    [anon_sym_base] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [sym_predefined_type] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_unchecked] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_lock] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_case] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_when] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_foreach] = ACTIONS(3315),
    [anon_sym_goto] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_DOT_DOT] = ACTIONS(3317),
    [anon_sym_from] = ACTIONS(3315),
    [anon_sym_into] = ACTIONS(3315),
    [anon_sym_join] = ACTIONS(3315),
    [anon_sym_on] = ACTIONS(3315),
    [anon_sym_equals] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_orderby] = ACTIONS(3315),
    [anon_sym_ascending] = ACTIONS(3315),
    [anon_sym_descending] = ACTIONS(3315),
    [anon_sym_group] = ACTIONS(3315),
    [anon_sym_by] = ACTIONS(3315),
    [anon_sym_select] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3315),
    [anon_sym_sizeof] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym___makeref] = ACTIONS(3315),
    [anon_sym___reftype] = ACTIONS(3315),
    [anon_sym___refvalue] = ACTIONS(3315),
    [sym_null_literal] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [sym_integer_literal] = ACTIONS(3315),
    [sym_real_literal] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [sym_verbatim_string_literal] = ACTIONS(3317),
    [aux_sym_preproc_if_token1] = ACTIONS(3317),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3317),
    [sym_interpolation_verbatim_start] = ACTIONS(3317),
    [sym_interpolation_raw_start] = ACTIONS(3317),
    [sym_raw_string_start] = ACTIONS(3317),
  },
  [2110] = {
    [sym_preproc_region] = STATE(2110),
    [sym_preproc_endregion] = STATE(2110),
    [sym_preproc_line] = STATE(2110),
    [sym_preproc_pragma] = STATE(2110),
    [sym_preproc_nullable] = STATE(2110),
    [sym_preproc_error] = STATE(2110),
    [sym_preproc_warning] = STATE(2110),
    [sym_preproc_define] = STATE(2110),
    [sym_preproc_undef] = STATE(2110),
    [sym__identifier_token] = ACTIONS(3291),
    [anon_sym_extern] = ACTIONS(3291),
    [anon_sym_alias] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_global] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_unsafe] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_ref] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_delegate] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_file] = ACTIONS(3291),
    [anon_sym_fixed] = ACTIONS(3291),
    [anon_sym_internal] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_partial] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_required] = ACTIONS(3291),
    [anon_sym_sealed] = ACTIONS(3291),
    [anon_sym_virtual] = ACTIONS(3291),
    [anon_sym_volatile] = ACTIONS(3291),
    [anon_sym_where] = ACTIONS(3291),
    [anon_sym_notnull] = ACTIONS(3291),
    [anon_sym_unmanaged] = ACTIONS(3291),
    [anon_sym_checked] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3291),
    [anon_sym_false] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3291),
    [anon_sym_scoped] = ACTIONS(3291),
    [anon_sym_base] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [sym_predefined_type] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_unchecked] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_lock] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_when] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_foreach] = ACTIONS(3291),
    [anon_sym_goto] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_DOT_DOT] = ACTIONS(3293),
    [anon_sym_from] = ACTIONS(3291),
    [anon_sym_into] = ACTIONS(3291),
    [anon_sym_join] = ACTIONS(3291),
    [anon_sym_on] = ACTIONS(3291),
    [anon_sym_equals] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_orderby] = ACTIONS(3291),
    [anon_sym_ascending] = ACTIONS(3291),
    [anon_sym_descending] = ACTIONS(3291),
    [anon_sym_group] = ACTIONS(3291),
    [anon_sym_by] = ACTIONS(3291),
    [anon_sym_select] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3291),
    [anon_sym_sizeof] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym___makeref] = ACTIONS(3291),
    [anon_sym___reftype] = ACTIONS(3291),
    [anon_sym___refvalue] = ACTIONS(3291),
    [sym_null_literal] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [sym_integer_literal] = ACTIONS(3291),
    [sym_real_literal] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [sym_verbatim_string_literal] = ACTIONS(3293),
    [aux_sym_preproc_if_token1] = ACTIONS(3293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3293),
    [sym_interpolation_verbatim_start] = ACTIONS(3293),
    [sym_interpolation_raw_start] = ACTIONS(3293),
    [sym_raw_string_start] = ACTIONS(3293),
  },
  [2111] = {
    [sym_preproc_region] = STATE(2111),
    [sym_preproc_endregion] = STATE(2111),
    [sym_preproc_line] = STATE(2111),
    [sym_preproc_pragma] = STATE(2111),
    [sym_preproc_nullable] = STATE(2111),
    [sym_preproc_error] = STATE(2111),
    [sym_preproc_warning] = STATE(2111),
    [sym_preproc_define] = STATE(2111),
    [sym_preproc_undef] = STATE(2111),
    [sym__identifier_token] = ACTIONS(3311),
    [anon_sym_extern] = ACTIONS(3311),
    [anon_sym_alias] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_global] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_unsafe] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_ref] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_RBRACE] = ACTIONS(3313),
    [anon_sym_delegate] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_file] = ACTIONS(3311),
    [anon_sym_fixed] = ACTIONS(3311),
    [anon_sym_internal] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_partial] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_required] = ACTIONS(3311),
    [anon_sym_sealed] = ACTIONS(3311),
    [anon_sym_virtual] = ACTIONS(3311),
    [anon_sym_volatile] = ACTIONS(3311),
    [anon_sym_where] = ACTIONS(3311),
    [anon_sym_notnull] = ACTIONS(3311),
    [anon_sym_unmanaged] = ACTIONS(3311),
    [anon_sym_checked] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_TILDE] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(3311),
    [anon_sym_false] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_this] = ACTIONS(3311),
    [anon_sym_scoped] = ACTIONS(3311),
    [anon_sym_base] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [sym_predefined_type] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_unchecked] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_lock] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_case] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_when] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_foreach] = ACTIONS(3311),
    [anon_sym_goto] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_DOT_DOT] = ACTIONS(3313),
    [anon_sym_from] = ACTIONS(3311),
    [anon_sym_into] = ACTIONS(3311),
    [anon_sym_join] = ACTIONS(3311),
    [anon_sym_on] = ACTIONS(3311),
    [anon_sym_equals] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_orderby] = ACTIONS(3311),
    [anon_sym_ascending] = ACTIONS(3311),
    [anon_sym_descending] = ACTIONS(3311),
    [anon_sym_group] = ACTIONS(3311),
    [anon_sym_by] = ACTIONS(3311),
    [anon_sym_select] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym___makeref] = ACTIONS(3311),
    [anon_sym___reftype] = ACTIONS(3311),
    [anon_sym___refvalue] = ACTIONS(3311),
    [sym_null_literal] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [sym_integer_literal] = ACTIONS(3311),
    [sym_real_literal] = ACTIONS(3313),
    [anon_sym_DQUOTE] = ACTIONS(3313),
    [sym_verbatim_string_literal] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3313),
    [sym_interpolation_verbatim_start] = ACTIONS(3313),
    [sym_interpolation_raw_start] = ACTIONS(3313),
    [sym_raw_string_start] = ACTIONS(3313),
  },
  [2112] = {
    [sym_preproc_region] = STATE(2112),
    [sym_preproc_endregion] = STATE(2112),
    [sym_preproc_line] = STATE(2112),
    [sym_preproc_pragma] = STATE(2112),
    [sym_preproc_nullable] = STATE(2112),
    [sym_preproc_error] = STATE(2112),
    [sym_preproc_warning] = STATE(2112),
    [sym_preproc_define] = STATE(2112),
    [sym_preproc_undef] = STATE(2112),
    [sym__identifier_token] = ACTIONS(3343),
    [anon_sym_extern] = ACTIONS(3343),
    [anon_sym_alias] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_global] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_unsafe] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_ref] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_delegate] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_file] = ACTIONS(3343),
    [anon_sym_fixed] = ACTIONS(3343),
    [anon_sym_internal] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_partial] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_required] = ACTIONS(3343),
    [anon_sym_sealed] = ACTIONS(3343),
    [anon_sym_virtual] = ACTIONS(3343),
    [anon_sym_volatile] = ACTIONS(3343),
    [anon_sym_where] = ACTIONS(3343),
    [anon_sym_notnull] = ACTIONS(3343),
    [anon_sym_unmanaged] = ACTIONS(3343),
    [anon_sym_checked] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3345),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3345),
    [anon_sym_this] = ACTIONS(3343),
    [anon_sym_scoped] = ACTIONS(3343),
    [anon_sym_base] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [sym_predefined_type] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_unchecked] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_lock] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_case] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_when] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_foreach] = ACTIONS(3343),
    [anon_sym_goto] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_DOT_DOT] = ACTIONS(3345),
    [anon_sym_from] = ACTIONS(3343),
    [anon_sym_into] = ACTIONS(3343),
    [anon_sym_join] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [anon_sym_equals] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_orderby] = ACTIONS(3343),
    [anon_sym_ascending] = ACTIONS(3343),
    [anon_sym_descending] = ACTIONS(3343),
    [anon_sym_group] = ACTIONS(3343),
    [anon_sym_by] = ACTIONS(3343),
    [anon_sym_select] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym___makeref] = ACTIONS(3343),
    [anon_sym___reftype] = ACTIONS(3343),
    [anon_sym___refvalue] = ACTIONS(3343),
    [sym_null_literal] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_integer_literal] = ACTIONS(3343),
    [sym_real_literal] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [sym_verbatim_string_literal] = ACTIONS(3345),
    [aux_sym_preproc_if_token1] = ACTIONS(3345),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3345),
    [sym_interpolation_verbatim_start] = ACTIONS(3345),
    [sym_interpolation_raw_start] = ACTIONS(3345),
    [sym_raw_string_start] = ACTIONS(3345),
  },
  [2113] = {
    [sym_preproc_region] = STATE(2113),
    [sym_preproc_endregion] = STATE(2113),
    [sym_preproc_line] = STATE(2113),
    [sym_preproc_pragma] = STATE(2113),
    [sym_preproc_nullable] = STATE(2113),
    [sym_preproc_error] = STATE(2113),
    [sym_preproc_warning] = STATE(2113),
    [sym_preproc_define] = STATE(2113),
    [sym_preproc_undef] = STATE(2113),
    [sym__identifier_token] = ACTIONS(3235),
    [anon_sym_extern] = ACTIONS(3235),
    [anon_sym_alias] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_global] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_unsafe] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_ref] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_delegate] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_file] = ACTIONS(3235),
    [anon_sym_fixed] = ACTIONS(3235),
    [anon_sym_internal] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_partial] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_required] = ACTIONS(3235),
    [anon_sym_sealed] = ACTIONS(3235),
    [anon_sym_virtual] = ACTIONS(3235),
    [anon_sym_volatile] = ACTIONS(3235),
    [anon_sym_where] = ACTIONS(3235),
    [anon_sym_notnull] = ACTIONS(3235),
    [anon_sym_unmanaged] = ACTIONS(3235),
    [anon_sym_checked] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [anon_sym_true] = ACTIONS(3235),
    [anon_sym_false] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(3237),
    [anon_sym_CARET] = ACTIONS(3237),
    [anon_sym_AMP] = ACTIONS(3237),
    [anon_sym_this] = ACTIONS(3235),
    [anon_sym_scoped] = ACTIONS(3235),
    [anon_sym_base] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [sym_predefined_type] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_unchecked] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_lock] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_when] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_foreach] = ACTIONS(3235),
    [anon_sym_goto] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_DOT_DOT] = ACTIONS(3237),
    [anon_sym_from] = ACTIONS(3235),
    [anon_sym_into] = ACTIONS(3235),
    [anon_sym_join] = ACTIONS(3235),
    [anon_sym_on] = ACTIONS(3235),
    [anon_sym_equals] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_orderby] = ACTIONS(3235),
    [anon_sym_ascending] = ACTIONS(3235),
    [anon_sym_descending] = ACTIONS(3235),
    [anon_sym_group] = ACTIONS(3235),
    [anon_sym_by] = ACTIONS(3235),
    [anon_sym_select] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3235),
    [anon_sym_sizeof] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym___makeref] = ACTIONS(3235),
    [anon_sym___reftype] = ACTIONS(3235),
    [anon_sym___refvalue] = ACTIONS(3235),
    [sym_null_literal] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [sym_integer_literal] = ACTIONS(3235),
    [sym_real_literal] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [sym_verbatim_string_literal] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3237),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3237),
    [sym_interpolation_verbatim_start] = ACTIONS(3237),
    [sym_interpolation_raw_start] = ACTIONS(3237),
    [sym_raw_string_start] = ACTIONS(3237),
  },
  [2114] = {
    [sym_preproc_region] = STATE(2114),
    [sym_preproc_endregion] = STATE(2114),
    [sym_preproc_line] = STATE(2114),
    [sym_preproc_pragma] = STATE(2114),
    [sym_preproc_nullable] = STATE(2114),
    [sym_preproc_error] = STATE(2114),
    [sym_preproc_warning] = STATE(2114),
    [sym_preproc_define] = STATE(2114),
    [sym_preproc_undef] = STATE(2114),
    [sym__identifier_token] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_alias] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_global] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_delegate] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_file] = ACTIONS(3203),
    [anon_sym_fixed] = ACTIONS(3203),
    [anon_sym_internal] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(3203),
    [anon_sym_override] = ACTIONS(3203),
    [anon_sym_partial] = ACTIONS(3203),
    [anon_sym_private] = ACTIONS(3203),
    [anon_sym_protected] = ACTIONS(3203),
    [anon_sym_public] = ACTIONS(3203),
    [anon_sym_readonly] = ACTIONS(3203),
    [anon_sym_required] = ACTIONS(3203),
    [anon_sym_sealed] = ACTIONS(3203),
    [anon_sym_virtual] = ACTIONS(3203),
    [anon_sym_volatile] = ACTIONS(3203),
    [anon_sym_where] = ACTIONS(3203),
    [anon_sym_notnull] = ACTIONS(3203),
    [anon_sym_unmanaged] = ACTIONS(3203),
    [anon_sym_checked] = ACTIONS(3203),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_TILDE] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3205),
    [anon_sym_DASH_DASH] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_CARET] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_this] = ACTIONS(3203),
    [anon_sym_scoped] = ACTIONS(3203),
    [anon_sym_base] = ACTIONS(3203),
    [anon_sym_var] = ACTIONS(3203),
    [sym_predefined_type] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_unchecked] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_do] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_lock] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_switch] = ACTIONS(3203),
    [anon_sym_case] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_throw] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_when] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3203),
    [anon_sym_foreach] = ACTIONS(3203),
    [anon_sym_goto] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_from] = ACTIONS(3203),
    [anon_sym_into] = ACTIONS(3203),
    [anon_sym_join] = ACTIONS(3203),
    [anon_sym_on] = ACTIONS(3203),
    [anon_sym_equals] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_orderby] = ACTIONS(3203),
    [anon_sym_ascending] = ACTIONS(3203),
    [anon_sym_descending] = ACTIONS(3203),
    [anon_sym_group] = ACTIONS(3203),
    [anon_sym_by] = ACTIONS(3203),
    [anon_sym_select] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3203),
    [anon_sym_sizeof] = ACTIONS(3203),
    [anon_sym_typeof] = ACTIONS(3203),
    [anon_sym___makeref] = ACTIONS(3203),
    [anon_sym___reftype] = ACTIONS(3203),
    [anon_sym___refvalue] = ACTIONS(3203),
    [sym_null_literal] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [sym_integer_literal] = ACTIONS(3203),
    [sym_real_literal] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_verbatim_string_literal] = ACTIONS(3205),
    [aux_sym_preproc_if_token1] = ACTIONS(3205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3205),
    [sym_interpolation_verbatim_start] = ACTIONS(3205),
    [sym_interpolation_raw_start] = ACTIONS(3205),
    [sym_raw_string_start] = ACTIONS(3205),
  },
  [2115] = {
    [sym_preproc_region] = STATE(2115),
    [sym_preproc_endregion] = STATE(2115),
    [sym_preproc_line] = STATE(2115),
    [sym_preproc_pragma] = STATE(2115),
    [sym_preproc_nullable] = STATE(2115),
    [sym_preproc_error] = STATE(2115),
    [sym_preproc_warning] = STATE(2115),
    [sym_preproc_define] = STATE(2115),
    [sym_preproc_undef] = STATE(2115),
    [sym__identifier_token] = ACTIONS(3185),
    [anon_sym_extern] = ACTIONS(3185),
    [anon_sym_alias] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_global] = ACTIONS(3185),
    [anon_sym_using] = ACTIONS(3185),
    [anon_sym_unsafe] = ACTIONS(3185),
    [anon_sym_static] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_ref] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_delegate] = ACTIONS(3185),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_async] = ACTIONS(3185),
    [anon_sym_const] = ACTIONS(3185),
    [anon_sym_file] = ACTIONS(3185),
    [anon_sym_fixed] = ACTIONS(3185),
    [anon_sym_internal] = ACTIONS(3185),
    [anon_sym_new] = ACTIONS(3185),
    [anon_sym_override] = ACTIONS(3185),
    [anon_sym_partial] = ACTIONS(3185),
    [anon_sym_private] = ACTIONS(3185),
    [anon_sym_protected] = ACTIONS(3185),
    [anon_sym_public] = ACTIONS(3185),
    [anon_sym_readonly] = ACTIONS(3185),
    [anon_sym_required] = ACTIONS(3185),
    [anon_sym_sealed] = ACTIONS(3185),
    [anon_sym_virtual] = ACTIONS(3185),
    [anon_sym_volatile] = ACTIONS(3185),
    [anon_sym_where] = ACTIONS(3185),
    [anon_sym_notnull] = ACTIONS(3185),
    [anon_sym_unmanaged] = ACTIONS(3185),
    [anon_sym_checked] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [anon_sym_true] = ACTIONS(3185),
    [anon_sym_false] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(3187),
    [anon_sym_CARET] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_this] = ACTIONS(3185),
    [anon_sym_scoped] = ACTIONS(3185),
    [anon_sym_base] = ACTIONS(3185),
    [anon_sym_var] = ACTIONS(3185),
    [sym_predefined_type] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_unchecked] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_do] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_lock] = ACTIONS(3185),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_switch] = ACTIONS(3185),
    [anon_sym_case] = ACTIONS(3185),
    [anon_sym_default] = ACTIONS(3185),
    [anon_sym_throw] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [anon_sym_when] = ACTIONS(3185),
    [anon_sym_await] = ACTIONS(3185),
    [anon_sym_foreach] = ACTIONS(3185),
    [anon_sym_goto] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3185),
    [anon_sym_DOT_DOT] = ACTIONS(3187),
    [anon_sym_from] = ACTIONS(3185),
    [anon_sym_into] = ACTIONS(3185),
    [anon_sym_join] = ACTIONS(3185),
    [anon_sym_on] = ACTIONS(3185),
    [anon_sym_equals] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(3185),
    [anon_sym_orderby] = ACTIONS(3185),
    [anon_sym_ascending] = ACTIONS(3185),
    [anon_sym_descending] = ACTIONS(3185),
    [anon_sym_group] = ACTIONS(3185),
    [anon_sym_by] = ACTIONS(3185),
    [anon_sym_select] = ACTIONS(3185),
    [anon_sym_stackalloc] = ACTIONS(3185),
    [anon_sym_sizeof] = ACTIONS(3185),
    [anon_sym_typeof] = ACTIONS(3185),
    [anon_sym___makeref] = ACTIONS(3185),
    [anon_sym___reftype] = ACTIONS(3185),
    [anon_sym___refvalue] = ACTIONS(3185),
    [sym_null_literal] = ACTIONS(3185),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [sym_integer_literal] = ACTIONS(3185),
    [sym_real_literal] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [sym_verbatim_string_literal] = ACTIONS(3187),
    [aux_sym_preproc_if_token1] = ACTIONS(3187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3187),
    [sym_interpolation_verbatim_start] = ACTIONS(3187),
    [sym_interpolation_raw_start] = ACTIONS(3187),
    [sym_raw_string_start] = ACTIONS(3187),
  },
  [2116] = {
    [sym_preproc_region] = STATE(2116),
    [sym_preproc_endregion] = STATE(2116),
    [sym_preproc_line] = STATE(2116),
    [sym_preproc_pragma] = STATE(2116),
    [sym_preproc_nullable] = STATE(2116),
    [sym_preproc_error] = STATE(2116),
    [sym_preproc_warning] = STATE(2116),
    [sym_preproc_define] = STATE(2116),
    [sym_preproc_undef] = STATE(2116),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_checked] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3265),
    [anon_sym_DASH_DASH] = ACTIONS(3265),
    [anon_sym_true] = ACTIONS(3263),
    [anon_sym_false] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_this] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_base] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3263),
    [anon_sym_unchecked] = ACTIONS(3263),
    [anon_sym_continue] = ACTIONS(3263),
    [anon_sym_do] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_for] = ACTIONS(3263),
    [anon_sym_lock] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_switch] = ACTIONS(3263),
    [anon_sym_case] = ACTIONS(3263),
    [anon_sym_default] = ACTIONS(3263),
    [anon_sym_throw] = ACTIONS(3263),
    [anon_sym_try] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3263),
    [anon_sym_foreach] = ACTIONS(3263),
    [anon_sym_goto] = ACTIONS(3263),
    [anon_sym_if] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_DOT_DOT] = ACTIONS(3265),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3263),
    [anon_sym_sizeof] = ACTIONS(3263),
    [anon_sym_typeof] = ACTIONS(3263),
    [anon_sym___makeref] = ACTIONS(3263),
    [anon_sym___reftype] = ACTIONS(3263),
    [anon_sym___refvalue] = ACTIONS(3263),
    [sym_null_literal] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [sym_real_literal] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3265),
    [sym_verbatim_string_literal] = ACTIONS(3265),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3265),
    [sym_interpolation_verbatim_start] = ACTIONS(3265),
    [sym_interpolation_raw_start] = ACTIONS(3265),
    [sym_raw_string_start] = ACTIONS(3265),
  },
  [2117] = {
    [sym_preproc_region] = STATE(2117),
    [sym_preproc_endregion] = STATE(2117),
    [sym_preproc_line] = STATE(2117),
    [sym_preproc_pragma] = STATE(2117),
    [sym_preproc_nullable] = STATE(2117),
    [sym_preproc_error] = STATE(2117),
    [sym_preproc_warning] = STATE(2117),
    [sym_preproc_define] = STATE(2117),
    [sym_preproc_undef] = STATE(2117),
    [sym__identifier_token] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym_alias] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_global] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_unsafe] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_ref] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_delegate] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_file] = ACTIONS(3319),
    [anon_sym_fixed] = ACTIONS(3319),
    [anon_sym_internal] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_partial] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_required] = ACTIONS(3319),
    [anon_sym_sealed] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_where] = ACTIONS(3319),
    [anon_sym_notnull] = ACTIONS(3319),
    [anon_sym_unmanaged] = ACTIONS(3319),
    [anon_sym_checked] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_true] = ACTIONS(3319),
    [anon_sym_false] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_this] = ACTIONS(3319),
    [anon_sym_scoped] = ACTIONS(3319),
    [anon_sym_base] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [sym_predefined_type] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_unchecked] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_lock] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_when] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_foreach] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_DOT_DOT] = ACTIONS(3321),
    [anon_sym_from] = ACTIONS(3319),
    [anon_sym_into] = ACTIONS(3319),
    [anon_sym_join] = ACTIONS(3319),
    [anon_sym_on] = ACTIONS(3319),
    [anon_sym_equals] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_orderby] = ACTIONS(3319),
    [anon_sym_ascending] = ACTIONS(3319),
    [anon_sym_descending] = ACTIONS(3319),
    [anon_sym_group] = ACTIONS(3319),
    [anon_sym_by] = ACTIONS(3319),
    [anon_sym_select] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3319),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym___makeref] = ACTIONS(3319),
    [anon_sym___reftype] = ACTIONS(3319),
    [anon_sym___refvalue] = ACTIONS(3319),
    [sym_null_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [sym_integer_literal] = ACTIONS(3319),
    [sym_real_literal] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_verbatim_string_literal] = ACTIONS(3321),
    [aux_sym_preproc_if_token1] = ACTIONS(3321),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3321),
    [sym_interpolation_verbatim_start] = ACTIONS(3321),
    [sym_interpolation_raw_start] = ACTIONS(3321),
    [sym_raw_string_start] = ACTIONS(3321),
  },
  [2118] = {
    [sym_preproc_region] = STATE(2118),
    [sym_preproc_endregion] = STATE(2118),
    [sym_preproc_line] = STATE(2118),
    [sym_preproc_pragma] = STATE(2118),
    [sym_preproc_nullable] = STATE(2118),
    [sym_preproc_error] = STATE(2118),
    [sym_preproc_warning] = STATE(2118),
    [sym_preproc_define] = STATE(2118),
    [sym_preproc_undef] = STATE(2118),
    [sym__identifier_token] = ACTIONS(3239),
    [anon_sym_extern] = ACTIONS(3239),
    [anon_sym_alias] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_global] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_unsafe] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_ref] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [anon_sym_delegate] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_file] = ACTIONS(3239),
    [anon_sym_fixed] = ACTIONS(3239),
    [anon_sym_internal] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_partial] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_required] = ACTIONS(3239),
    [anon_sym_sealed] = ACTIONS(3239),
    [anon_sym_virtual] = ACTIONS(3239),
    [anon_sym_volatile] = ACTIONS(3239),
    [anon_sym_where] = ACTIONS(3239),
    [anon_sym_notnull] = ACTIONS(3239),
    [anon_sym_unmanaged] = ACTIONS(3239),
    [anon_sym_checked] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [anon_sym_true] = ACTIONS(3239),
    [anon_sym_false] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_STAR] = ACTIONS(3241),
    [anon_sym_CARET] = ACTIONS(3241),
    [anon_sym_AMP] = ACTIONS(3241),
    [anon_sym_this] = ACTIONS(3239),
    [anon_sym_scoped] = ACTIONS(3239),
    [anon_sym_base] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [sym_predefined_type] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_unchecked] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_lock] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_case] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_when] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_foreach] = ACTIONS(3239),
    [anon_sym_goto] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_DOT_DOT] = ACTIONS(3241),
    [anon_sym_from] = ACTIONS(3239),
    [anon_sym_into] = ACTIONS(3239),
    [anon_sym_join] = ACTIONS(3239),
    [anon_sym_on] = ACTIONS(3239),
    [anon_sym_equals] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_orderby] = ACTIONS(3239),
    [anon_sym_ascending] = ACTIONS(3239),
    [anon_sym_descending] = ACTIONS(3239),
    [anon_sym_group] = ACTIONS(3239),
    [anon_sym_by] = ACTIONS(3239),
    [anon_sym_select] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3239),
    [anon_sym_sizeof] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym___makeref] = ACTIONS(3239),
    [anon_sym___reftype] = ACTIONS(3239),
    [anon_sym___refvalue] = ACTIONS(3239),
    [sym_null_literal] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [sym_integer_literal] = ACTIONS(3239),
    [sym_real_literal] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [sym_verbatim_string_literal] = ACTIONS(3241),
    [aux_sym_preproc_if_token1] = ACTIONS(3241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3241),
    [sym_interpolation_verbatim_start] = ACTIONS(3241),
    [sym_interpolation_raw_start] = ACTIONS(3241),
    [sym_raw_string_start] = ACTIONS(3241),
  },
  [2119] = {
    [sym_preproc_region] = STATE(2119),
    [sym_preproc_endregion] = STATE(2119),
    [sym_preproc_line] = STATE(2119),
    [sym_preproc_pragma] = STATE(2119),
    [sym_preproc_nullable] = STATE(2119),
    [sym_preproc_error] = STATE(2119),
    [sym_preproc_warning] = STATE(2119),
    [sym_preproc_define] = STATE(2119),
    [sym_preproc_undef] = STATE(2119),
    [sym__identifier_token] = ACTIONS(3177),
    [anon_sym_extern] = ACTIONS(3177),
    [anon_sym_alias] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_global] = ACTIONS(3177),
    [anon_sym_using] = ACTIONS(3177),
    [anon_sym_unsafe] = ACTIONS(3177),
    [anon_sym_static] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_return] = ACTIONS(3177),
    [anon_sym_ref] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(3179),
    [anon_sym_delegate] = ACTIONS(3177),
    [anon_sym_abstract] = ACTIONS(3177),
    [anon_sym_async] = ACTIONS(3177),
    [anon_sym_const] = ACTIONS(3177),
    [anon_sym_file] = ACTIONS(3177),
    [anon_sym_fixed] = ACTIONS(3177),
    [anon_sym_internal] = ACTIONS(3177),
    [anon_sym_new] = ACTIONS(3177),
    [anon_sym_override] = ACTIONS(3177),
    [anon_sym_partial] = ACTIONS(3177),
    [anon_sym_private] = ACTIONS(3177),
    [anon_sym_protected] = ACTIONS(3177),
    [anon_sym_public] = ACTIONS(3177),
    [anon_sym_readonly] = ACTIONS(3177),
    [anon_sym_required] = ACTIONS(3177),
    [anon_sym_sealed] = ACTIONS(3177),
    [anon_sym_virtual] = ACTIONS(3177),
    [anon_sym_volatile] = ACTIONS(3177),
    [anon_sym_where] = ACTIONS(3177),
    [anon_sym_notnull] = ACTIONS(3177),
    [anon_sym_unmanaged] = ACTIONS(3177),
    [anon_sym_checked] = ACTIONS(3177),
    [anon_sym_BANG] = ACTIONS(3179),
    [anon_sym_TILDE] = ACTIONS(3179),
    [anon_sym_PLUS_PLUS] = ACTIONS(3179),
    [anon_sym_DASH_DASH] = ACTIONS(3179),
    [anon_sym_true] = ACTIONS(3177),
    [anon_sym_false] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3177),
    [anon_sym_DASH] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(3179),
    [anon_sym_CARET] = ACTIONS(3179),
    [anon_sym_AMP] = ACTIONS(3179),
    [anon_sym_this] = ACTIONS(3177),
    [anon_sym_scoped] = ACTIONS(3177),
    [anon_sym_base] = ACTIONS(3177),
    [anon_sym_var] = ACTIONS(3177),
    [sym_predefined_type] = ACTIONS(3177),
    [anon_sym_break] = ACTIONS(3177),
    [anon_sym_unchecked] = ACTIONS(3177),
    [anon_sym_continue] = ACTIONS(3177),
    [anon_sym_do] = ACTIONS(3177),
    [anon_sym_while] = ACTIONS(3177),
    [anon_sym_for] = ACTIONS(3177),
    [anon_sym_lock] = ACTIONS(3177),
    [anon_sym_yield] = ACTIONS(3177),
    [anon_sym_switch] = ACTIONS(3177),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3177),
    [anon_sym_throw] = ACTIONS(3177),
    [anon_sym_try] = ACTIONS(3177),
    [anon_sym_when] = ACTIONS(3177),
    [anon_sym_await] = ACTIONS(3177),
    [anon_sym_foreach] = ACTIONS(3177),
    [anon_sym_goto] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3177),
    [anon_sym_DOT_DOT] = ACTIONS(3179),
    [anon_sym_from] = ACTIONS(3177),
    [anon_sym_into] = ACTIONS(3177),
    [anon_sym_join] = ACTIONS(3177),
    [anon_sym_on] = ACTIONS(3177),
    [anon_sym_equals] = ACTIONS(3177),
    [anon_sym_let] = ACTIONS(3177),
    [anon_sym_orderby] = ACTIONS(3177),
    [anon_sym_ascending] = ACTIONS(3177),
    [anon_sym_descending] = ACTIONS(3177),
    [anon_sym_group] = ACTIONS(3177),
    [anon_sym_by] = ACTIONS(3177),
    [anon_sym_select] = ACTIONS(3177),
    [anon_sym_stackalloc] = ACTIONS(3177),
    [anon_sym_sizeof] = ACTIONS(3177),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym___makeref] = ACTIONS(3177),
    [anon_sym___reftype] = ACTIONS(3177),
    [anon_sym___refvalue] = ACTIONS(3177),
    [sym_null_literal] = ACTIONS(3177),
    [anon_sym_SQUOTE] = ACTIONS(3179),
    [sym_integer_literal] = ACTIONS(3177),
    [sym_real_literal] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3179),
    [sym_verbatim_string_literal] = ACTIONS(3179),
    [aux_sym_preproc_if_token1] = ACTIONS(3179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3179),
    [sym_interpolation_verbatim_start] = ACTIONS(3179),
    [sym_interpolation_raw_start] = ACTIONS(3179),
    [sym_raw_string_start] = ACTIONS(3179),
  },
  [2120] = {
    [sym_preproc_region] = STATE(2120),
    [sym_preproc_endregion] = STATE(2120),
    [sym_preproc_line] = STATE(2120),
    [sym_preproc_pragma] = STATE(2120),
    [sym_preproc_nullable] = STATE(2120),
    [sym_preproc_error] = STATE(2120),
    [sym_preproc_warning] = STATE(2120),
    [sym_preproc_define] = STATE(2120),
    [sym_preproc_undef] = STATE(2120),
    [sym__identifier_token] = ACTIONS(3267),
    [anon_sym_extern] = ACTIONS(3267),
    [anon_sym_alias] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_global] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_unsafe] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_ref] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_delegate] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_file] = ACTIONS(3267),
    [anon_sym_fixed] = ACTIONS(3267),
    [anon_sym_internal] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_partial] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_required] = ACTIONS(3267),
    [anon_sym_sealed] = ACTIONS(3267),
    [anon_sym_virtual] = ACTIONS(3267),
    [anon_sym_volatile] = ACTIONS(3267),
    [anon_sym_where] = ACTIONS(3267),
    [anon_sym_notnull] = ACTIONS(3267),
    [anon_sym_unmanaged] = ACTIONS(3267),
    [anon_sym_checked] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [anon_sym_true] = ACTIONS(3267),
    [anon_sym_false] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3269),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3269),
    [anon_sym_this] = ACTIONS(3267),
    [anon_sym_scoped] = ACTIONS(3267),
    [anon_sym_base] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [sym_predefined_type] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_unchecked] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_lock] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_case] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_when] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_foreach] = ACTIONS(3267),
    [anon_sym_goto] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_DOT_DOT] = ACTIONS(3269),
    [anon_sym_from] = ACTIONS(3267),
    [anon_sym_into] = ACTIONS(3267),
    [anon_sym_join] = ACTIONS(3267),
    [anon_sym_on] = ACTIONS(3267),
    [anon_sym_equals] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_orderby] = ACTIONS(3267),
    [anon_sym_ascending] = ACTIONS(3267),
    [anon_sym_descending] = ACTIONS(3267),
    [anon_sym_group] = ACTIONS(3267),
    [anon_sym_by] = ACTIONS(3267),
    [anon_sym_select] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3267),
    [anon_sym_sizeof] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym___makeref] = ACTIONS(3267),
    [anon_sym___reftype] = ACTIONS(3267),
    [anon_sym___refvalue] = ACTIONS(3267),
    [sym_null_literal] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [sym_integer_literal] = ACTIONS(3267),
    [sym_real_literal] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [sym_verbatim_string_literal] = ACTIONS(3269),
    [aux_sym_preproc_if_token1] = ACTIONS(3269),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3269),
    [sym_interpolation_verbatim_start] = ACTIONS(3269),
    [sym_interpolation_raw_start] = ACTIONS(3269),
    [sym_raw_string_start] = ACTIONS(3269),
  },
  [2121] = {
    [sym_preproc_region] = STATE(2121),
    [sym_preproc_endregion] = STATE(2121),
    [sym_preproc_line] = STATE(2121),
    [sym_preproc_pragma] = STATE(2121),
    [sym_preproc_nullable] = STATE(2121),
    [sym_preproc_error] = STATE(2121),
    [sym_preproc_warning] = STATE(2121),
    [sym_preproc_define] = STATE(2121),
    [sym_preproc_undef] = STATE(2121),
    [sym__identifier_token] = ACTIONS(3207),
    [anon_sym_extern] = ACTIONS(3207),
    [anon_sym_alias] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_unsafe] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_ref] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_delegate] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_file] = ACTIONS(3207),
    [anon_sym_fixed] = ACTIONS(3207),
    [anon_sym_internal] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_partial] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_sealed] = ACTIONS(3207),
    [anon_sym_virtual] = ACTIONS(3207),
    [anon_sym_volatile] = ACTIONS(3207),
    [anon_sym_where] = ACTIONS(3207),
    [anon_sym_notnull] = ACTIONS(3207),
    [anon_sym_unmanaged] = ACTIONS(3207),
    [anon_sym_checked] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3209),
    [anon_sym_TILDE] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [anon_sym_true] = ACTIONS(3207),
    [anon_sym_false] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_CARET] = ACTIONS(3209),
    [anon_sym_AMP] = ACTIONS(3209),
    [anon_sym_this] = ACTIONS(3207),
    [anon_sym_scoped] = ACTIONS(3207),
    [anon_sym_base] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [sym_predefined_type] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_unchecked] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_lock] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_case] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_when] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_foreach] = ACTIONS(3207),
    [anon_sym_goto] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_DOT_DOT] = ACTIONS(3209),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_into] = ACTIONS(3207),
    [anon_sym_join] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_equals] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_orderby] = ACTIONS(3207),
    [anon_sym_ascending] = ACTIONS(3207),
    [anon_sym_descending] = ACTIONS(3207),
    [anon_sym_group] = ACTIONS(3207),
    [anon_sym_by] = ACTIONS(3207),
    [anon_sym_select] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3207),
    [anon_sym_sizeof] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym___makeref] = ACTIONS(3207),
    [anon_sym___reftype] = ACTIONS(3207),
    [anon_sym___refvalue] = ACTIONS(3207),
    [sym_null_literal] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3209),
    [sym_integer_literal] = ACTIONS(3207),
    [sym_real_literal] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3209),
    [sym_verbatim_string_literal] = ACTIONS(3209),
    [aux_sym_preproc_if_token1] = ACTIONS(3209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3209),
    [sym_interpolation_verbatim_start] = ACTIONS(3209),
    [sym_interpolation_raw_start] = ACTIONS(3209),
    [sym_raw_string_start] = ACTIONS(3209),
  },
  [2122] = {
    [sym_preproc_region] = STATE(2122),
    [sym_preproc_endregion] = STATE(2122),
    [sym_preproc_line] = STATE(2122),
    [sym_preproc_pragma] = STATE(2122),
    [sym_preproc_nullable] = STATE(2122),
    [sym_preproc_error] = STATE(2122),
    [sym_preproc_warning] = STATE(2122),
    [sym_preproc_define] = STATE(2122),
    [sym_preproc_undef] = STATE(2122),
    [sym__identifier_token] = ACTIONS(3133),
    [anon_sym_extern] = ACTIONS(3133),
    [anon_sym_alias] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_global] = ACTIONS(3133),
    [anon_sym_using] = ACTIONS(3133),
    [anon_sym_unsafe] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_RBRACE] = ACTIONS(3135),
    [anon_sym_delegate] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_file] = ACTIONS(3133),
    [anon_sym_fixed] = ACTIONS(3133),
    [anon_sym_internal] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_override] = ACTIONS(3133),
    [anon_sym_partial] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_required] = ACTIONS(3133),
    [anon_sym_sealed] = ACTIONS(3133),
    [anon_sym_virtual] = ACTIONS(3133),
    [anon_sym_volatile] = ACTIONS(3133),
    [anon_sym_where] = ACTIONS(3133),
    [anon_sym_notnull] = ACTIONS(3133),
    [anon_sym_unmanaged] = ACTIONS(3133),
    [anon_sym_checked] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_true] = ACTIONS(3133),
    [anon_sym_false] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_this] = ACTIONS(3133),
    [anon_sym_scoped] = ACTIONS(3133),
    [anon_sym_base] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [sym_predefined_type] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_unchecked] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_lock] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_case] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_when] = ACTIONS(3133),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_foreach] = ACTIONS(3133),
    [anon_sym_goto] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3133),
    [anon_sym_into] = ACTIONS(3133),
    [anon_sym_join] = ACTIONS(3133),
    [anon_sym_on] = ACTIONS(3133),
    [anon_sym_equals] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_orderby] = ACTIONS(3133),
    [anon_sym_ascending] = ACTIONS(3133),
    [anon_sym_descending] = ACTIONS(3133),
    [anon_sym_group] = ACTIONS(3133),
    [anon_sym_by] = ACTIONS(3133),
    [anon_sym_select] = ACTIONS(3133),
    [anon_sym_stackalloc] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym___makeref] = ACTIONS(3133),
    [anon_sym___reftype] = ACTIONS(3133),
    [anon_sym___refvalue] = ACTIONS(3133),
    [sym_null_literal] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_integer_literal] = ACTIONS(3133),
    [sym_real_literal] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [sym_verbatim_string_literal] = ACTIONS(3135),
    [aux_sym_preproc_if_token1] = ACTIONS(3135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3135),
    [sym_interpolation_verbatim_start] = ACTIONS(3135),
    [sym_interpolation_raw_start] = ACTIONS(3135),
    [sym_raw_string_start] = ACTIONS(3135),
  },
  [2123] = {
    [sym_preproc_region] = STATE(2123),
    [sym_preproc_endregion] = STATE(2123),
    [sym_preproc_line] = STATE(2123),
    [sym_preproc_pragma] = STATE(2123),
    [sym_preproc_nullable] = STATE(2123),
    [sym_preproc_error] = STATE(2123),
    [sym_preproc_warning] = STATE(2123),
    [sym_preproc_define] = STATE(2123),
    [sym_preproc_undef] = STATE(2123),
    [sym__identifier_token] = ACTIONS(3181),
    [anon_sym_extern] = ACTIONS(3181),
    [anon_sym_alias] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_global] = ACTIONS(3181),
    [anon_sym_using] = ACTIONS(3181),
    [anon_sym_unsafe] = ACTIONS(3181),
    [anon_sym_static] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_ref] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_delegate] = ACTIONS(3181),
    [anon_sym_abstract] = ACTIONS(3181),
    [anon_sym_async] = ACTIONS(3181),
    [anon_sym_const] = ACTIONS(3181),
    [anon_sym_file] = ACTIONS(3181),
    [anon_sym_fixed] = ACTIONS(3181),
    [anon_sym_internal] = ACTIONS(3181),
    [anon_sym_new] = ACTIONS(3181),
    [anon_sym_override] = ACTIONS(3181),
    [anon_sym_partial] = ACTIONS(3181),
    [anon_sym_private] = ACTIONS(3181),
    [anon_sym_protected] = ACTIONS(3181),
    [anon_sym_public] = ACTIONS(3181),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_required] = ACTIONS(3181),
    [anon_sym_sealed] = ACTIONS(3181),
    [anon_sym_virtual] = ACTIONS(3181),
    [anon_sym_volatile] = ACTIONS(3181),
    [anon_sym_where] = ACTIONS(3181),
    [anon_sym_notnull] = ACTIONS(3181),
    [anon_sym_unmanaged] = ACTIONS(3181),
    [anon_sym_checked] = ACTIONS(3181),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [anon_sym_true] = ACTIONS(3181),
    [anon_sym_false] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(3183),
    [anon_sym_CARET] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(3183),
    [anon_sym_this] = ACTIONS(3181),
    [anon_sym_scoped] = ACTIONS(3181),
    [anon_sym_base] = ACTIONS(3181),
    [anon_sym_var] = ACTIONS(3181),
    [sym_predefined_type] = ACTIONS(3181),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_unchecked] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_lock] = ACTIONS(3181),
    [anon_sym_yield] = ACTIONS(3181),
    [anon_sym_switch] = ACTIONS(3181),
    [anon_sym_case] = ACTIONS(3181),
    [anon_sym_default] = ACTIONS(3181),
    [anon_sym_throw] = ACTIONS(3181),
    [anon_sym_try] = ACTIONS(3181),
    [anon_sym_when] = ACTIONS(3181),
    [anon_sym_await] = ACTIONS(3181),
    [anon_sym_foreach] = ACTIONS(3181),
    [anon_sym_goto] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3181),
    [anon_sym_DOT_DOT] = ACTIONS(3183),
    [anon_sym_from] = ACTIONS(3181),
    [anon_sym_into] = ACTIONS(3181),
    [anon_sym_join] = ACTIONS(3181),
    [anon_sym_on] = ACTIONS(3181),
    [anon_sym_equals] = ACTIONS(3181),
    [anon_sym_let] = ACTIONS(3181),
    [anon_sym_orderby] = ACTIONS(3181),
    [anon_sym_ascending] = ACTIONS(3181),
    [anon_sym_descending] = ACTIONS(3181),
    [anon_sym_group] = ACTIONS(3181),
    [anon_sym_by] = ACTIONS(3181),
    [anon_sym_select] = ACTIONS(3181),
    [anon_sym_stackalloc] = ACTIONS(3181),
    [anon_sym_sizeof] = ACTIONS(3181),
    [anon_sym_typeof] = ACTIONS(3181),
    [anon_sym___makeref] = ACTIONS(3181),
    [anon_sym___reftype] = ACTIONS(3181),
    [anon_sym___refvalue] = ACTIONS(3181),
    [sym_null_literal] = ACTIONS(3181),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [sym_integer_literal] = ACTIONS(3181),
    [sym_real_literal] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [sym_verbatim_string_literal] = ACTIONS(3183),
    [aux_sym_preproc_if_token1] = ACTIONS(3183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3183),
    [sym_interpolation_verbatim_start] = ACTIONS(3183),
    [sym_interpolation_raw_start] = ACTIONS(3183),
    [sym_raw_string_start] = ACTIONS(3183),
  },
  [2124] = {
    [sym_preproc_region] = STATE(2124),
    [sym_preproc_endregion] = STATE(2124),
    [sym_preproc_line] = STATE(2124),
    [sym_preproc_pragma] = STATE(2124),
    [sym_preproc_nullable] = STATE(2124),
    [sym_preproc_error] = STATE(2124),
    [sym_preproc_warning] = STATE(2124),
    [sym_preproc_define] = STATE(2124),
    [sym_preproc_undef] = STATE(2124),
    [sym__identifier_token] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_alias] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_ref] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_delegate] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_file] = ACTIONS(3223),
    [anon_sym_fixed] = ACTIONS(3223),
    [anon_sym_internal] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_partial] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_required] = ACTIONS(3223),
    [anon_sym_sealed] = ACTIONS(3223),
    [anon_sym_virtual] = ACTIONS(3223),
    [anon_sym_volatile] = ACTIONS(3223),
    [anon_sym_where] = ACTIONS(3223),
    [anon_sym_notnull] = ACTIONS(3223),
    [anon_sym_unmanaged] = ACTIONS(3223),
    [anon_sym_checked] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_true] = ACTIONS(3223),
    [anon_sym_false] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3225),
    [anon_sym_CARET] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3225),
    [anon_sym_this] = ACTIONS(3223),
    [anon_sym_scoped] = ACTIONS(3223),
    [anon_sym_base] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [sym_predefined_type] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_unchecked] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_lock] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_case] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_when] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_foreach] = ACTIONS(3223),
    [anon_sym_goto] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_DOT_DOT] = ACTIONS(3225),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_into] = ACTIONS(3223),
    [anon_sym_join] = ACTIONS(3223),
    [anon_sym_on] = ACTIONS(3223),
    [anon_sym_equals] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_orderby] = ACTIONS(3223),
    [anon_sym_ascending] = ACTIONS(3223),
    [anon_sym_descending] = ACTIONS(3223),
    [anon_sym_group] = ACTIONS(3223),
    [anon_sym_by] = ACTIONS(3223),
    [anon_sym_select] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3223),
    [anon_sym_sizeof] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym___makeref] = ACTIONS(3223),
    [anon_sym___reftype] = ACTIONS(3223),
    [anon_sym___refvalue] = ACTIONS(3223),
    [sym_null_literal] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [sym_integer_literal] = ACTIONS(3223),
    [sym_real_literal] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [sym_verbatim_string_literal] = ACTIONS(3225),
    [aux_sym_preproc_if_token1] = ACTIONS(3225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3225),
    [sym_interpolation_verbatim_start] = ACTIONS(3225),
    [sym_interpolation_raw_start] = ACTIONS(3225),
    [sym_raw_string_start] = ACTIONS(3225),
  },
  [2125] = {
    [sym_preproc_region] = STATE(2125),
    [sym_preproc_endregion] = STATE(2125),
    [sym_preproc_line] = STATE(2125),
    [sym_preproc_pragma] = STATE(2125),
    [sym_preproc_nullable] = STATE(2125),
    [sym_preproc_error] = STATE(2125),
    [sym_preproc_warning] = STATE(2125),
    [sym_preproc_define] = STATE(2125),
    [sym_preproc_undef] = STATE(2125),
    [sym__identifier_token] = ACTIONS(3227),
    [anon_sym_extern] = ACTIONS(3227),
    [anon_sym_alias] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_unsafe] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_ref] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_RBRACE] = ACTIONS(3229),
    [anon_sym_delegate] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_file] = ACTIONS(3227),
    [anon_sym_fixed] = ACTIONS(3227),
    [anon_sym_internal] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_partial] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_required] = ACTIONS(3227),
    [anon_sym_sealed] = ACTIONS(3227),
    [anon_sym_virtual] = ACTIONS(3227),
    [anon_sym_volatile] = ACTIONS(3227),
    [anon_sym_where] = ACTIONS(3227),
    [anon_sym_notnull] = ACTIONS(3227),
    [anon_sym_unmanaged] = ACTIONS(3227),
    [anon_sym_checked] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_TILDE] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3229),
    [anon_sym_DASH_DASH] = ACTIONS(3229),
    [anon_sym_true] = ACTIONS(3227),
    [anon_sym_false] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_CARET] = ACTIONS(3229),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_this] = ACTIONS(3227),
    [anon_sym_scoped] = ACTIONS(3227),
    [anon_sym_base] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [sym_predefined_type] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_unchecked] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_lock] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_case] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_when] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_foreach] = ACTIONS(3227),
    [anon_sym_goto] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_DOT_DOT] = ACTIONS(3229),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_into] = ACTIONS(3227),
    [anon_sym_join] = ACTIONS(3227),
    [anon_sym_on] = ACTIONS(3227),
    [anon_sym_equals] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_orderby] = ACTIONS(3227),
    [anon_sym_ascending] = ACTIONS(3227),
    [anon_sym_descending] = ACTIONS(3227),
    [anon_sym_group] = ACTIONS(3227),
    [anon_sym_by] = ACTIONS(3227),
    [anon_sym_select] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3227),
    [anon_sym_sizeof] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym___makeref] = ACTIONS(3227),
    [anon_sym___reftype] = ACTIONS(3227),
    [anon_sym___refvalue] = ACTIONS(3227),
    [sym_null_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [sym_integer_literal] = ACTIONS(3227),
    [sym_real_literal] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [sym_verbatim_string_literal] = ACTIONS(3229),
    [aux_sym_preproc_if_token1] = ACTIONS(3229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3229),
    [sym_interpolation_verbatim_start] = ACTIONS(3229),
    [sym_interpolation_raw_start] = ACTIONS(3229),
    [sym_raw_string_start] = ACTIONS(3229),
  },
  [2126] = {
    [sym_preproc_region] = STATE(2126),
    [sym_preproc_endregion] = STATE(2126),
    [sym_preproc_line] = STATE(2126),
    [sym_preproc_pragma] = STATE(2126),
    [sym_preproc_nullable] = STATE(2126),
    [sym_preproc_error] = STATE(2126),
    [sym_preproc_warning] = STATE(2126),
    [sym_preproc_define] = STATE(2126),
    [sym_preproc_undef] = STATE(2126),
    [sym__identifier_token] = ACTIONS(3211),
    [anon_sym_extern] = ACTIONS(3211),
    [anon_sym_alias] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_global] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_ref] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_delegate] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_file] = ACTIONS(3211),
    [anon_sym_fixed] = ACTIONS(3211),
    [anon_sym_internal] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_partial] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_required] = ACTIONS(3211),
    [anon_sym_sealed] = ACTIONS(3211),
    [anon_sym_virtual] = ACTIONS(3211),
    [anon_sym_volatile] = ACTIONS(3211),
    [anon_sym_where] = ACTIONS(3211),
    [anon_sym_notnull] = ACTIONS(3211),
    [anon_sym_unmanaged] = ACTIONS(3211),
    [anon_sym_checked] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [anon_sym_true] = ACTIONS(3211),
    [anon_sym_false] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_CARET] = ACTIONS(3213),
    [anon_sym_AMP] = ACTIONS(3213),
    [anon_sym_this] = ACTIONS(3211),
    [anon_sym_scoped] = ACTIONS(3211),
    [anon_sym_base] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [sym_predefined_type] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_unchecked] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_lock] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_case] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_when] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_foreach] = ACTIONS(3211),
    [anon_sym_goto] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_DOT_DOT] = ACTIONS(3213),
    [anon_sym_from] = ACTIONS(3211),
    [anon_sym_into] = ACTIONS(3211),
    [anon_sym_join] = ACTIONS(3211),
    [anon_sym_on] = ACTIONS(3211),
    [anon_sym_equals] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_orderby] = ACTIONS(3211),
    [anon_sym_ascending] = ACTIONS(3211),
    [anon_sym_descending] = ACTIONS(3211),
    [anon_sym_group] = ACTIONS(3211),
    [anon_sym_by] = ACTIONS(3211),
    [anon_sym_select] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3211),
    [anon_sym_sizeof] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym___makeref] = ACTIONS(3211),
    [anon_sym___reftype] = ACTIONS(3211),
    [anon_sym___refvalue] = ACTIONS(3211),
    [sym_null_literal] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [sym_integer_literal] = ACTIONS(3211),
    [sym_real_literal] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [sym_verbatim_string_literal] = ACTIONS(3213),
    [aux_sym_preproc_if_token1] = ACTIONS(3213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3213),
    [sym_interpolation_verbatim_start] = ACTIONS(3213),
    [sym_interpolation_raw_start] = ACTIONS(3213),
    [sym_raw_string_start] = ACTIONS(3213),
  },
  [2127] = {
    [sym_preproc_region] = STATE(2127),
    [sym_preproc_endregion] = STATE(2127),
    [sym_preproc_line] = STATE(2127),
    [sym_preproc_pragma] = STATE(2127),
    [sym_preproc_nullable] = STATE(2127),
    [sym_preproc_error] = STATE(2127),
    [sym_preproc_warning] = STATE(2127),
    [sym_preproc_define] = STATE(2127),
    [sym_preproc_undef] = STATE(2127),
    [sym__identifier_token] = ACTIONS(3331),
    [anon_sym_extern] = ACTIONS(3331),
    [anon_sym_alias] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_global] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_unsafe] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_ref] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_delegate] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_file] = ACTIONS(3331),
    [anon_sym_fixed] = ACTIONS(3331),
    [anon_sym_internal] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_partial] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_required] = ACTIONS(3331),
    [anon_sym_sealed] = ACTIONS(3331),
    [anon_sym_virtual] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_where] = ACTIONS(3331),
    [anon_sym_notnull] = ACTIONS(3331),
    [anon_sym_unmanaged] = ACTIONS(3331),
    [anon_sym_checked] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_true] = ACTIONS(3331),
    [anon_sym_false] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3333),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3333),
    [anon_sym_this] = ACTIONS(3331),
    [anon_sym_scoped] = ACTIONS(3331),
    [anon_sym_base] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [sym_predefined_type] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_unchecked] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_lock] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_case] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_when] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_foreach] = ACTIONS(3331),
    [anon_sym_goto] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_DOT_DOT] = ACTIONS(3333),
    [anon_sym_from] = ACTIONS(3331),
    [anon_sym_into] = ACTIONS(3331),
    [anon_sym_join] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [anon_sym_equals] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_orderby] = ACTIONS(3331),
    [anon_sym_ascending] = ACTIONS(3331),
    [anon_sym_descending] = ACTIONS(3331),
    [anon_sym_group] = ACTIONS(3331),
    [anon_sym_by] = ACTIONS(3331),
    [anon_sym_select] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3331),
    [anon_sym_sizeof] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym___makeref] = ACTIONS(3331),
    [anon_sym___reftype] = ACTIONS(3331),
    [anon_sym___refvalue] = ACTIONS(3331),
    [sym_null_literal] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_integer_literal] = ACTIONS(3331),
    [sym_real_literal] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [sym_verbatim_string_literal] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3333),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3333),
    [sym_interpolation_verbatim_start] = ACTIONS(3333),
    [sym_interpolation_raw_start] = ACTIONS(3333),
    [sym_raw_string_start] = ACTIONS(3333),
  },
  [2128] = {
    [sym_preproc_region] = STATE(2128),
    [sym_preproc_endregion] = STATE(2128),
    [sym_preproc_line] = STATE(2128),
    [sym_preproc_pragma] = STATE(2128),
    [sym_preproc_nullable] = STATE(2128),
    [sym_preproc_error] = STATE(2128),
    [sym_preproc_warning] = STATE(2128),
    [sym_preproc_define] = STATE(2128),
    [sym_preproc_undef] = STATE(2128),
    [sym__identifier_token] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_alias] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_global] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_delegate] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_file] = ACTIONS(3295),
    [anon_sym_fixed] = ACTIONS(3295),
    [anon_sym_internal] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_partial] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_required] = ACTIONS(3295),
    [anon_sym_sealed] = ACTIONS(3295),
    [anon_sym_virtual] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym_where] = ACTIONS(3295),
    [anon_sym_notnull] = ACTIONS(3295),
    [anon_sym_unmanaged] = ACTIONS(3295),
    [anon_sym_checked] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_CARET] = ACTIONS(3297),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_this] = ACTIONS(3295),
    [anon_sym_scoped] = ACTIONS(3295),
    [anon_sym_base] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [sym_predefined_type] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_unchecked] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_lock] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_when] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_foreach] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3297),
    [anon_sym_from] = ACTIONS(3295),
    [anon_sym_into] = ACTIONS(3295),
    [anon_sym_join] = ACTIONS(3295),
    [anon_sym_on] = ACTIONS(3295),
    [anon_sym_equals] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_orderby] = ACTIONS(3295),
    [anon_sym_ascending] = ACTIONS(3295),
    [anon_sym_descending] = ACTIONS(3295),
    [anon_sym_group] = ACTIONS(3295),
    [anon_sym_by] = ACTIONS(3295),
    [anon_sym_select] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3295),
    [anon_sym_sizeof] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym___makeref] = ACTIONS(3295),
    [anon_sym___reftype] = ACTIONS(3295),
    [anon_sym___refvalue] = ACTIONS(3295),
    [sym_null_literal] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [sym_integer_literal] = ACTIONS(3295),
    [sym_real_literal] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [sym_verbatim_string_literal] = ACTIONS(3297),
    [aux_sym_preproc_if_token1] = ACTIONS(3297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3297),
    [sym_interpolation_verbatim_start] = ACTIONS(3297),
    [sym_interpolation_raw_start] = ACTIONS(3297),
    [sym_raw_string_start] = ACTIONS(3297),
  },
  [2129] = {
    [sym_preproc_region] = STATE(2129),
    [sym_preproc_endregion] = STATE(2129),
    [sym_preproc_line] = STATE(2129),
    [sym_preproc_pragma] = STATE(2129),
    [sym_preproc_nullable] = STATE(2129),
    [sym_preproc_error] = STATE(2129),
    [sym_preproc_warning] = STATE(2129),
    [sym_preproc_define] = STATE(2129),
    [sym_preproc_undef] = STATE(2129),
    [sym__identifier_token] = ACTIONS(3339),
    [anon_sym_extern] = ACTIONS(3339),
    [anon_sym_alias] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_global] = ACTIONS(3339),
    [anon_sym_using] = ACTIONS(3339),
    [anon_sym_unsafe] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3339),
    [anon_sym_ref] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [anon_sym_delegate] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_const] = ACTIONS(3339),
    [anon_sym_file] = ACTIONS(3339),
    [anon_sym_fixed] = ACTIONS(3339),
    [anon_sym_internal] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_override] = ACTIONS(3339),
    [anon_sym_partial] = ACTIONS(3339),
    [anon_sym_private] = ACTIONS(3339),
    [anon_sym_protected] = ACTIONS(3339),
    [anon_sym_public] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_required] = ACTIONS(3339),
    [anon_sym_sealed] = ACTIONS(3339),
    [anon_sym_virtual] = ACTIONS(3339),
    [anon_sym_volatile] = ACTIONS(3339),
    [anon_sym_where] = ACTIONS(3339),
    [anon_sym_notnull] = ACTIONS(3339),
    [anon_sym_unmanaged] = ACTIONS(3339),
    [anon_sym_checked] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_TILDE] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_true] = ACTIONS(3339),
    [anon_sym_false] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_this] = ACTIONS(3339),
    [anon_sym_scoped] = ACTIONS(3339),
    [anon_sym_base] = ACTIONS(3339),
    [anon_sym_var] = ACTIONS(3339),
    [sym_predefined_type] = ACTIONS(3339),
    [anon_sym_break] = ACTIONS(3339),
    [anon_sym_unchecked] = ACTIONS(3339),
    [anon_sym_continue] = ACTIONS(3339),
    [anon_sym_do] = ACTIONS(3339),
    [anon_sym_while] = ACTIONS(3339),
    [anon_sym_for] = ACTIONS(3339),
    [anon_sym_lock] = ACTIONS(3339),
    [anon_sym_yield] = ACTIONS(3339),
    [anon_sym_switch] = ACTIONS(3339),
    [anon_sym_case] = ACTIONS(3339),
    [anon_sym_default] = ACTIONS(3339),
    [anon_sym_throw] = ACTIONS(3339),
    [anon_sym_try] = ACTIONS(3339),
    [anon_sym_when] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3339),
    [anon_sym_foreach] = ACTIONS(3339),
    [anon_sym_goto] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3339),
    [anon_sym_else] = ACTIONS(3339),
    [anon_sym_DOT_DOT] = ACTIONS(3341),
    [anon_sym_from] = ACTIONS(3339),
    [anon_sym_into] = ACTIONS(3339),
    [anon_sym_join] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [anon_sym_equals] = ACTIONS(3339),
    [anon_sym_let] = ACTIONS(3339),
    [anon_sym_orderby] = ACTIONS(3339),
    [anon_sym_ascending] = ACTIONS(3339),
    [anon_sym_descending] = ACTIONS(3339),
    [anon_sym_group] = ACTIONS(3339),
    [anon_sym_by] = ACTIONS(3339),
    [anon_sym_select] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3339),
    [anon_sym_sizeof] = ACTIONS(3339),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym___makeref] = ACTIONS(3339),
    [anon_sym___reftype] = ACTIONS(3339),
    [anon_sym___refvalue] = ACTIONS(3339),
    [sym_null_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_integer_literal] = ACTIONS(3339),
    [sym_real_literal] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3341),
    [sym_verbatim_string_literal] = ACTIONS(3341),
    [aux_sym_preproc_if_token1] = ACTIONS(3341),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3341),
    [sym_interpolation_verbatim_start] = ACTIONS(3341),
    [sym_interpolation_raw_start] = ACTIONS(3341),
    [sym_raw_string_start] = ACTIONS(3341),
  },
  [2130] = {
    [sym_preproc_region] = STATE(2130),
    [sym_preproc_endregion] = STATE(2130),
    [sym_preproc_line] = STATE(2130),
    [sym_preproc_pragma] = STATE(2130),
    [sym_preproc_nullable] = STATE(2130),
    [sym_preproc_error] = STATE(2130),
    [sym_preproc_warning] = STATE(2130),
    [sym_preproc_define] = STATE(2130),
    [sym_preproc_undef] = STATE(2130),
    [sym__identifier_token] = ACTIONS(3323),
    [anon_sym_extern] = ACTIONS(3323),
    [anon_sym_alias] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_global] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_unsafe] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_ref] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_RBRACE] = ACTIONS(3325),
    [anon_sym_delegate] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_file] = ACTIONS(3323),
    [anon_sym_fixed] = ACTIONS(3323),
    [anon_sym_internal] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_partial] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_required] = ACTIONS(3323),
    [anon_sym_sealed] = ACTIONS(3323),
    [anon_sym_virtual] = ACTIONS(3323),
    [anon_sym_volatile] = ACTIONS(3323),
    [anon_sym_where] = ACTIONS(3323),
    [anon_sym_notnull] = ACTIONS(3323),
    [anon_sym_unmanaged] = ACTIONS(3323),
    [anon_sym_checked] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3325),
    [anon_sym_true] = ACTIONS(3323),
    [anon_sym_false] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3325),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_this] = ACTIONS(3323),
    [anon_sym_scoped] = ACTIONS(3323),
    [anon_sym_base] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [sym_predefined_type] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_unchecked] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_lock] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_case] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_when] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_foreach] = ACTIONS(3323),
    [anon_sym_goto] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_DOT_DOT] = ACTIONS(3325),
    [anon_sym_from] = ACTIONS(3323),
    [anon_sym_into] = ACTIONS(3323),
    [anon_sym_join] = ACTIONS(3323),
    [anon_sym_on] = ACTIONS(3323),
    [anon_sym_equals] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_orderby] = ACTIONS(3323),
    [anon_sym_ascending] = ACTIONS(3323),
    [anon_sym_descending] = ACTIONS(3323),
    [anon_sym_group] = ACTIONS(3323),
    [anon_sym_by] = ACTIONS(3323),
    [anon_sym_select] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3323),
    [anon_sym_sizeof] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym___makeref] = ACTIONS(3323),
    [anon_sym___reftype] = ACTIONS(3323),
    [anon_sym___refvalue] = ACTIONS(3323),
    [sym_null_literal] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [sym_integer_literal] = ACTIONS(3323),
    [sym_real_literal] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [sym_verbatim_string_literal] = ACTIONS(3325),
    [aux_sym_preproc_if_token1] = ACTIONS(3325),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3325),
    [sym_interpolation_verbatim_start] = ACTIONS(3325),
    [sym_interpolation_raw_start] = ACTIONS(3325),
    [sym_raw_string_start] = ACTIONS(3325),
  },
  [2131] = {
    [sym_preproc_region] = STATE(2131),
    [sym_preproc_endregion] = STATE(2131),
    [sym_preproc_line] = STATE(2131),
    [sym_preproc_pragma] = STATE(2131),
    [sym_preproc_nullable] = STATE(2131),
    [sym_preproc_error] = STATE(2131),
    [sym_preproc_warning] = STATE(2131),
    [sym_preproc_define] = STATE(2131),
    [sym_preproc_undef] = STATE(2131),
    [sym__identifier_token] = ACTIONS(3243),
    [anon_sym_extern] = ACTIONS(3243),
    [anon_sym_alias] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_global] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_unsafe] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_ref] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_delegate] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_file] = ACTIONS(3243),
    [anon_sym_fixed] = ACTIONS(3243),
    [anon_sym_internal] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_partial] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_required] = ACTIONS(3243),
    [anon_sym_sealed] = ACTIONS(3243),
    [anon_sym_virtual] = ACTIONS(3243),
    [anon_sym_volatile] = ACTIONS(3243),
    [anon_sym_where] = ACTIONS(3243),
    [anon_sym_notnull] = ACTIONS(3243),
    [anon_sym_unmanaged] = ACTIONS(3243),
    [anon_sym_checked] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [anon_sym_true] = ACTIONS(3243),
    [anon_sym_false] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_this] = ACTIONS(3243),
    [anon_sym_scoped] = ACTIONS(3243),
    [anon_sym_base] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [sym_predefined_type] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_unchecked] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_lock] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_case] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_when] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_foreach] = ACTIONS(3243),
    [anon_sym_goto] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_DOT_DOT] = ACTIONS(3245),
    [anon_sym_from] = ACTIONS(3243),
    [anon_sym_into] = ACTIONS(3243),
    [anon_sym_join] = ACTIONS(3243),
    [anon_sym_on] = ACTIONS(3243),
    [anon_sym_equals] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_orderby] = ACTIONS(3243),
    [anon_sym_ascending] = ACTIONS(3243),
    [anon_sym_descending] = ACTIONS(3243),
    [anon_sym_group] = ACTIONS(3243),
    [anon_sym_by] = ACTIONS(3243),
    [anon_sym_select] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3243),
    [anon_sym_sizeof] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym___makeref] = ACTIONS(3243),
    [anon_sym___reftype] = ACTIONS(3243),
    [anon_sym___refvalue] = ACTIONS(3243),
    [sym_null_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [sym_integer_literal] = ACTIONS(3243),
    [sym_real_literal] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [sym_verbatim_string_literal] = ACTIONS(3245),
    [aux_sym_preproc_if_token1] = ACTIONS(3245),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3245),
    [sym_interpolation_verbatim_start] = ACTIONS(3245),
    [sym_interpolation_raw_start] = ACTIONS(3245),
    [sym_raw_string_start] = ACTIONS(3245),
  },
  [2132] = {
    [sym_preproc_region] = STATE(2132),
    [sym_preproc_endregion] = STATE(2132),
    [sym_preproc_line] = STATE(2132),
    [sym_preproc_pragma] = STATE(2132),
    [sym_preproc_nullable] = STATE(2132),
    [sym_preproc_error] = STATE(2132),
    [sym_preproc_warning] = STATE(2132),
    [sym_preproc_define] = STATE(2132),
    [sym_preproc_undef] = STATE(2132),
    [sym__identifier_token] = ACTIONS(3173),
    [anon_sym_extern] = ACTIONS(3173),
    [anon_sym_alias] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_global] = ACTIONS(3173),
    [anon_sym_using] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(3173),
    [anon_sym_static] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(3175),
    [anon_sym_return] = ACTIONS(3173),
    [anon_sym_ref] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_RBRACE] = ACTIONS(3175),
    [anon_sym_delegate] = ACTIONS(3173),
    [anon_sym_abstract] = ACTIONS(3173),
    [anon_sym_async] = ACTIONS(3173),
    [anon_sym_const] = ACTIONS(3173),
    [anon_sym_file] = ACTIONS(3173),
    [anon_sym_fixed] = ACTIONS(3173),
    [anon_sym_internal] = ACTIONS(3173),
    [anon_sym_new] = ACTIONS(3173),
    [anon_sym_override] = ACTIONS(3173),
    [anon_sym_partial] = ACTIONS(3173),
    [anon_sym_private] = ACTIONS(3173),
    [anon_sym_protected] = ACTIONS(3173),
    [anon_sym_public] = ACTIONS(3173),
    [anon_sym_readonly] = ACTIONS(3173),
    [anon_sym_required] = ACTIONS(3173),
    [anon_sym_sealed] = ACTIONS(3173),
    [anon_sym_virtual] = ACTIONS(3173),
    [anon_sym_volatile] = ACTIONS(3173),
    [anon_sym_where] = ACTIONS(3173),
    [anon_sym_notnull] = ACTIONS(3173),
    [anon_sym_unmanaged] = ACTIONS(3173),
    [anon_sym_checked] = ACTIONS(3173),
    [anon_sym_BANG] = ACTIONS(3175),
    [anon_sym_TILDE] = ACTIONS(3175),
    [anon_sym_PLUS_PLUS] = ACTIONS(3175),
    [anon_sym_DASH_DASH] = ACTIONS(3175),
    [anon_sym_true] = ACTIONS(3173),
    [anon_sym_false] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3173),
    [anon_sym_DASH] = ACTIONS(3173),
    [anon_sym_STAR] = ACTIONS(3175),
    [anon_sym_CARET] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(3175),
    [anon_sym_this] = ACTIONS(3173),
    [anon_sym_scoped] = ACTIONS(3173),
    [anon_sym_base] = ACTIONS(3173),
    [anon_sym_var] = ACTIONS(3173),
    [sym_predefined_type] = ACTIONS(3173),
    [anon_sym_break] = ACTIONS(3173),
    [anon_sym_unchecked] = ACTIONS(3173),
    [anon_sym_continue] = ACTIONS(3173),
    [anon_sym_do] = ACTIONS(3173),
    [anon_sym_while] = ACTIONS(3173),
    [anon_sym_for] = ACTIONS(3173),
    [anon_sym_lock] = ACTIONS(3173),
    [anon_sym_yield] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3173),
    [anon_sym_case] = ACTIONS(3173),
    [anon_sym_default] = ACTIONS(3173),
    [anon_sym_throw] = ACTIONS(3173),
    [anon_sym_try] = ACTIONS(3173),
    [anon_sym_when] = ACTIONS(3173),
    [anon_sym_await] = ACTIONS(3173),
    [anon_sym_foreach] = ACTIONS(3173),
    [anon_sym_goto] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3173),
    [anon_sym_DOT_DOT] = ACTIONS(3175),
    [anon_sym_from] = ACTIONS(3173),
    [anon_sym_into] = ACTIONS(3173),
    [anon_sym_join] = ACTIONS(3173),
    [anon_sym_on] = ACTIONS(3173),
    [anon_sym_equals] = ACTIONS(3173),
    [anon_sym_let] = ACTIONS(3173),
    [anon_sym_orderby] = ACTIONS(3173),
    [anon_sym_ascending] = ACTIONS(3173),
    [anon_sym_descending] = ACTIONS(3173),
    [anon_sym_group] = ACTIONS(3173),
    [anon_sym_by] = ACTIONS(3173),
    [anon_sym_select] = ACTIONS(3173),
    [anon_sym_stackalloc] = ACTIONS(3173),
    [anon_sym_sizeof] = ACTIONS(3173),
    [anon_sym_typeof] = ACTIONS(3173),
    [anon_sym___makeref] = ACTIONS(3173),
    [anon_sym___reftype] = ACTIONS(3173),
    [anon_sym___refvalue] = ACTIONS(3173),
    [sym_null_literal] = ACTIONS(3173),
    [anon_sym_SQUOTE] = ACTIONS(3175),
    [sym_integer_literal] = ACTIONS(3173),
    [sym_real_literal] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3175),
    [sym_verbatim_string_literal] = ACTIONS(3175),
    [aux_sym_preproc_if_token1] = ACTIONS(3175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3175),
    [sym_interpolation_verbatim_start] = ACTIONS(3175),
    [sym_interpolation_raw_start] = ACTIONS(3175),
    [sym_raw_string_start] = ACTIONS(3175),
  },
  [2133] = {
    [sym_preproc_region] = STATE(2133),
    [sym_preproc_endregion] = STATE(2133),
    [sym_preproc_line] = STATE(2133),
    [sym_preproc_pragma] = STATE(2133),
    [sym_preproc_nullable] = STATE(2133),
    [sym_preproc_error] = STATE(2133),
    [sym_preproc_warning] = STATE(2133),
    [sym_preproc_define] = STATE(2133),
    [sym_preproc_undef] = STATE(2133),
    [sym__identifier_token] = ACTIONS(3327),
    [anon_sym_extern] = ACTIONS(3327),
    [anon_sym_alias] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_global] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_unsafe] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_ref] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_delegate] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_file] = ACTIONS(3327),
    [anon_sym_fixed] = ACTIONS(3327),
    [anon_sym_internal] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_partial] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_required] = ACTIONS(3327),
    [anon_sym_sealed] = ACTIONS(3327),
    [anon_sym_virtual] = ACTIONS(3327),
    [anon_sym_volatile] = ACTIONS(3327),
    [anon_sym_where] = ACTIONS(3327),
    [anon_sym_notnull] = ACTIONS(3327),
    [anon_sym_unmanaged] = ACTIONS(3327),
    [anon_sym_checked] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_true] = ACTIONS(3327),
    [anon_sym_false] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_STAR] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3329),
    [anon_sym_this] = ACTIONS(3327),
    [anon_sym_scoped] = ACTIONS(3327),
    [anon_sym_base] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [sym_predefined_type] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_unchecked] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_lock] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_case] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_when] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_foreach] = ACTIONS(3327),
    [anon_sym_goto] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_DOT_DOT] = ACTIONS(3329),
    [anon_sym_from] = ACTIONS(3327),
    [anon_sym_into] = ACTIONS(3327),
    [anon_sym_join] = ACTIONS(3327),
    [anon_sym_on] = ACTIONS(3327),
    [anon_sym_equals] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_orderby] = ACTIONS(3327),
    [anon_sym_ascending] = ACTIONS(3327),
    [anon_sym_descending] = ACTIONS(3327),
    [anon_sym_group] = ACTIONS(3327),
    [anon_sym_by] = ACTIONS(3327),
    [anon_sym_select] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3327),
    [anon_sym_sizeof] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym___makeref] = ACTIONS(3327),
    [anon_sym___reftype] = ACTIONS(3327),
    [anon_sym___refvalue] = ACTIONS(3327),
    [sym_null_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [sym_integer_literal] = ACTIONS(3327),
    [sym_real_literal] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [sym_verbatim_string_literal] = ACTIONS(3329),
    [aux_sym_preproc_if_token1] = ACTIONS(3329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3329),
    [sym_interpolation_verbatim_start] = ACTIONS(3329),
    [sym_interpolation_raw_start] = ACTIONS(3329),
    [sym_raw_string_start] = ACTIONS(3329),
  },
  [2134] = {
    [sym_preproc_region] = STATE(2134),
    [sym_preproc_endregion] = STATE(2134),
    [sym_preproc_line] = STATE(2134),
    [sym_preproc_pragma] = STATE(2134),
    [sym_preproc_nullable] = STATE(2134),
    [sym_preproc_error] = STATE(2134),
    [sym_preproc_warning] = STATE(2134),
    [sym_preproc_define] = STATE(2134),
    [sym_preproc_undef] = STATE(2134),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_RBRACE] = ACTIONS(3253),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_checked] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3253),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3253),
    [anon_sym_DASH_DASH] = ACTIONS(3253),
    [anon_sym_true] = ACTIONS(3251),
    [anon_sym_false] = ACTIONS(3251),
    [anon_sym_PLUS] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_CARET] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3253),
    [anon_sym_this] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_base] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3251),
    [anon_sym_unchecked] = ACTIONS(3251),
    [anon_sym_continue] = ACTIONS(3251),
    [anon_sym_do] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3251),
    [anon_sym_lock] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_switch] = ACTIONS(3251),
    [anon_sym_case] = ACTIONS(3251),
    [anon_sym_default] = ACTIONS(3251),
    [anon_sym_throw] = ACTIONS(3251),
    [anon_sym_try] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3251),
    [anon_sym_foreach] = ACTIONS(3251),
    [anon_sym_goto] = ACTIONS(3251),
    [anon_sym_if] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3251),
    [anon_sym_sizeof] = ACTIONS(3251),
    [anon_sym_typeof] = ACTIONS(3251),
    [anon_sym___makeref] = ACTIONS(3251),
    [anon_sym___reftype] = ACTIONS(3251),
    [anon_sym___refvalue] = ACTIONS(3251),
    [sym_null_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [sym_real_literal] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_verbatim_string_literal] = ACTIONS(3253),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3253),
    [sym_interpolation_verbatim_start] = ACTIONS(3253),
    [sym_interpolation_raw_start] = ACTIONS(3253),
    [sym_raw_string_start] = ACTIONS(3253),
  },
  [2135] = {
    [sym_preproc_region] = STATE(2135),
    [sym_preproc_endregion] = STATE(2135),
    [sym_preproc_line] = STATE(2135),
    [sym_preproc_pragma] = STATE(2135),
    [sym_preproc_nullable] = STATE(2135),
    [sym_preproc_error] = STATE(2135),
    [sym_preproc_warning] = STATE(2135),
    [sym_preproc_define] = STATE(2135),
    [sym_preproc_undef] = STATE(2135),
    [sym__identifier_token] = ACTIONS(3189),
    [anon_sym_extern] = ACTIONS(3189),
    [anon_sym_alias] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_using] = ACTIONS(3189),
    [anon_sym_unsafe] = ACTIONS(3189),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_delegate] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_file] = ACTIONS(3189),
    [anon_sym_fixed] = ACTIONS(3189),
    [anon_sym_internal] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_override] = ACTIONS(3189),
    [anon_sym_partial] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_readonly] = ACTIONS(3189),
    [anon_sym_required] = ACTIONS(3189),
    [anon_sym_sealed] = ACTIONS(3189),
    [anon_sym_virtual] = ACTIONS(3189),
    [anon_sym_volatile] = ACTIONS(3189),
    [anon_sym_where] = ACTIONS(3189),
    [anon_sym_notnull] = ACTIONS(3189),
    [anon_sym_unmanaged] = ACTIONS(3189),
    [anon_sym_checked] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_true] = ACTIONS(3189),
    [anon_sym_false] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3191),
    [anon_sym_CARET] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3191),
    [anon_sym_this] = ACTIONS(3189),
    [anon_sym_scoped] = ACTIONS(3189),
    [anon_sym_base] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [sym_predefined_type] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_unchecked] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_when] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_into] = ACTIONS(3189),
    [anon_sym_join] = ACTIONS(3189),
    [anon_sym_on] = ACTIONS(3189),
    [anon_sym_equals] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_orderby] = ACTIONS(3189),
    [anon_sym_ascending] = ACTIONS(3189),
    [anon_sym_descending] = ACTIONS(3189),
    [anon_sym_group] = ACTIONS(3189),
    [anon_sym_by] = ACTIONS(3189),
    [anon_sym_select] = ACTIONS(3189),
    [anon_sym_stackalloc] = ACTIONS(3189),
    [anon_sym_sizeof] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym___makeref] = ACTIONS(3189),
    [anon_sym___reftype] = ACTIONS(3189),
    [anon_sym___refvalue] = ACTIONS(3189),
    [sym_null_literal] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_integer_literal] = ACTIONS(3189),
    [sym_real_literal] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [sym_verbatim_string_literal] = ACTIONS(3191),
    [aux_sym_preproc_if_token1] = ACTIONS(3191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3191),
    [sym_interpolation_verbatim_start] = ACTIONS(3191),
    [sym_interpolation_raw_start] = ACTIONS(3191),
    [sym_raw_string_start] = ACTIONS(3191),
  },
  [2136] = {
    [sym_preproc_region] = STATE(2136),
    [sym_preproc_endregion] = STATE(2136),
    [sym_preproc_line] = STATE(2136),
    [sym_preproc_pragma] = STATE(2136),
    [sym_preproc_nullable] = STATE(2136),
    [sym_preproc_error] = STATE(2136),
    [sym_preproc_warning] = STATE(2136),
    [sym_preproc_define] = STATE(2136),
    [sym_preproc_undef] = STATE(2136),
    [sym__identifier_token] = ACTIONS(3283),
    [anon_sym_extern] = ACTIONS(3283),
    [anon_sym_alias] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_global] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_unsafe] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_ref] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_delegate] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_file] = ACTIONS(3283),
    [anon_sym_fixed] = ACTIONS(3283),
    [anon_sym_internal] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_partial] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_required] = ACTIONS(3283),
    [anon_sym_sealed] = ACTIONS(3283),
    [anon_sym_virtual] = ACTIONS(3283),
    [anon_sym_volatile] = ACTIONS(3283),
    [anon_sym_where] = ACTIONS(3283),
    [anon_sym_notnull] = ACTIONS(3283),
    [anon_sym_unmanaged] = ACTIONS(3283),
    [anon_sym_checked] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(3283),
    [anon_sym_false] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_CARET] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_this] = ACTIONS(3283),
    [anon_sym_scoped] = ACTIONS(3283),
    [anon_sym_base] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [sym_predefined_type] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_unchecked] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_lock] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_when] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_foreach] = ACTIONS(3283),
    [anon_sym_goto] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3285),
    [anon_sym_from] = ACTIONS(3283),
    [anon_sym_into] = ACTIONS(3283),
    [anon_sym_join] = ACTIONS(3283),
    [anon_sym_on] = ACTIONS(3283),
    [anon_sym_equals] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_orderby] = ACTIONS(3283),
    [anon_sym_ascending] = ACTIONS(3283),
    [anon_sym_descending] = ACTIONS(3283),
    [anon_sym_group] = ACTIONS(3283),
    [anon_sym_by] = ACTIONS(3283),
    [anon_sym_select] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3283),
    [anon_sym_sizeof] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym___makeref] = ACTIONS(3283),
    [anon_sym___reftype] = ACTIONS(3283),
    [anon_sym___refvalue] = ACTIONS(3283),
    [sym_null_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [sym_integer_literal] = ACTIONS(3283),
    [sym_real_literal] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [sym_verbatim_string_literal] = ACTIONS(3285),
    [aux_sym_preproc_if_token1] = ACTIONS(3285),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3285),
    [sym_interpolation_verbatim_start] = ACTIONS(3285),
    [sym_interpolation_raw_start] = ACTIONS(3285),
    [sym_raw_string_start] = ACTIONS(3285),
  },
  [2137] = {
    [sym_preproc_region] = STATE(2137),
    [sym_preproc_endregion] = STATE(2137),
    [sym_preproc_line] = STATE(2137),
    [sym_preproc_pragma] = STATE(2137),
    [sym_preproc_nullable] = STATE(2137),
    [sym_preproc_error] = STATE(2137),
    [sym_preproc_warning] = STATE(2137),
    [sym_preproc_define] = STATE(2137),
    [sym_preproc_undef] = STATE(2137),
    [sym__identifier_token] = ACTIONS(3193),
    [anon_sym_extern] = ACTIONS(3193),
    [anon_sym_alias] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_global] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_unsafe] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_ref] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_RBRACE] = ACTIONS(3195),
    [anon_sym_delegate] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_file] = ACTIONS(3193),
    [anon_sym_fixed] = ACTIONS(3193),
    [anon_sym_internal] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_partial] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_readonly] = ACTIONS(3193),
    [anon_sym_required] = ACTIONS(3193),
    [anon_sym_sealed] = ACTIONS(3193),
    [anon_sym_virtual] = ACTIONS(3193),
    [anon_sym_volatile] = ACTIONS(3193),
    [anon_sym_where] = ACTIONS(3193),
    [anon_sym_notnull] = ACTIONS(3193),
    [anon_sym_unmanaged] = ACTIONS(3193),
    [anon_sym_checked] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_true] = ACTIONS(3193),
    [anon_sym_false] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_STAR] = ACTIONS(3195),
    [anon_sym_CARET] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3195),
    [anon_sym_this] = ACTIONS(3193),
    [anon_sym_scoped] = ACTIONS(3193),
    [anon_sym_base] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [sym_predefined_type] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_unchecked] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_lock] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_case] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_when] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_foreach] = ACTIONS(3193),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3499),
    [anon_sym_DOT_DOT] = ACTIONS(3195),
    [anon_sym_from] = ACTIONS(3193),
    [anon_sym_into] = ACTIONS(3193),
    [anon_sym_join] = ACTIONS(3193),
    [anon_sym_on] = ACTIONS(3193),
    [anon_sym_equals] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_orderby] = ACTIONS(3193),
    [anon_sym_ascending] = ACTIONS(3193),
    [anon_sym_descending] = ACTIONS(3193),
    [anon_sym_group] = ACTIONS(3193),
    [anon_sym_by] = ACTIONS(3193),
    [anon_sym_select] = ACTIONS(3193),
    [anon_sym_stackalloc] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym___makeref] = ACTIONS(3193),
    [anon_sym___reftype] = ACTIONS(3193),
    [anon_sym___refvalue] = ACTIONS(3193),
    [sym_null_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_integer_literal] = ACTIONS(3193),
    [sym_real_literal] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [sym_verbatim_string_literal] = ACTIONS(3195),
    [aux_sym_preproc_if_token1] = ACTIONS(3195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3195),
    [sym_interpolation_verbatim_start] = ACTIONS(3195),
    [sym_interpolation_raw_start] = ACTIONS(3195),
    [sym_raw_string_start] = ACTIONS(3195),
  },
  [2138] = {
    [sym_preproc_region] = STATE(2138),
    [sym_preproc_endregion] = STATE(2138),
    [sym_preproc_line] = STATE(2138),
    [sym_preproc_pragma] = STATE(2138),
    [sym_preproc_nullable] = STATE(2138),
    [sym_preproc_error] = STATE(2138),
    [sym_preproc_warning] = STATE(2138),
    [sym_preproc_define] = STATE(2138),
    [sym_preproc_undef] = STATE(2138),
    [sym__identifier_token] = ACTIONS(3299),
    [anon_sym_extern] = ACTIONS(3299),
    [anon_sym_alias] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_global] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_unsafe] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_ref] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_delegate] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_file] = ACTIONS(3299),
    [anon_sym_fixed] = ACTIONS(3299),
    [anon_sym_internal] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_partial] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_required] = ACTIONS(3299),
    [anon_sym_sealed] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3299),
    [anon_sym_volatile] = ACTIONS(3299),
    [anon_sym_where] = ACTIONS(3299),
    [anon_sym_notnull] = ACTIONS(3299),
    [anon_sym_unmanaged] = ACTIONS(3299),
    [anon_sym_checked] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [anon_sym_true] = ACTIONS(3299),
    [anon_sym_false] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(3301),
    [anon_sym_CARET] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3301),
    [anon_sym_this] = ACTIONS(3299),
    [anon_sym_scoped] = ACTIONS(3299),
    [anon_sym_base] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [sym_predefined_type] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_unchecked] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_lock] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_case] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_when] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_foreach] = ACTIONS(3299),
    [anon_sym_goto] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_DOT_DOT] = ACTIONS(3301),
    [anon_sym_from] = ACTIONS(3299),
    [anon_sym_into] = ACTIONS(3299),
    [anon_sym_join] = ACTIONS(3299),
    [anon_sym_on] = ACTIONS(3299),
    [anon_sym_equals] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_orderby] = ACTIONS(3299),
    [anon_sym_ascending] = ACTIONS(3299),
    [anon_sym_descending] = ACTIONS(3299),
    [anon_sym_group] = ACTIONS(3299),
    [anon_sym_by] = ACTIONS(3299),
    [anon_sym_select] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3299),
    [anon_sym_sizeof] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym___makeref] = ACTIONS(3299),
    [anon_sym___reftype] = ACTIONS(3299),
    [anon_sym___refvalue] = ACTIONS(3299),
    [sym_null_literal] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [sym_integer_literal] = ACTIONS(3299),
    [sym_real_literal] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [sym_verbatim_string_literal] = ACTIONS(3301),
    [aux_sym_preproc_if_token1] = ACTIONS(3301),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3301),
    [sym_interpolation_verbatim_start] = ACTIONS(3301),
    [sym_interpolation_raw_start] = ACTIONS(3301),
    [sym_raw_string_start] = ACTIONS(3301),
  },
  [2139] = {
    [sym_preproc_region] = STATE(2139),
    [sym_preproc_endregion] = STATE(2139),
    [sym_preproc_line] = STATE(2139),
    [sym_preproc_pragma] = STATE(2139),
    [sym_preproc_nullable] = STATE(2139),
    [sym_preproc_error] = STATE(2139),
    [sym_preproc_warning] = STATE(2139),
    [sym_preproc_define] = STATE(2139),
    [sym_preproc_undef] = STATE(2139),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_RBRACE] = ACTIONS(3257),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_checked] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3257),
    [anon_sym_DASH_DASH] = ACTIONS(3257),
    [anon_sym_true] = ACTIONS(3255),
    [anon_sym_false] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_CARET] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_this] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_base] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_unchecked] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_lock] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_foreach] = ACTIONS(3255),
    [anon_sym_goto] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_DOT_DOT] = ACTIONS(3257),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3255),
    [anon_sym_sizeof] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym___makeref] = ACTIONS(3255),
    [anon_sym___reftype] = ACTIONS(3255),
    [anon_sym___refvalue] = ACTIONS(3255),
    [sym_null_literal] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [sym_real_literal] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [sym_verbatim_string_literal] = ACTIONS(3257),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3257),
    [sym_interpolation_verbatim_start] = ACTIONS(3257),
    [sym_interpolation_raw_start] = ACTIONS(3257),
    [sym_raw_string_start] = ACTIONS(3257),
  },
  [2140] = {
    [sym_preproc_region] = STATE(2140),
    [sym_preproc_endregion] = STATE(2140),
    [sym_preproc_line] = STATE(2140),
    [sym_preproc_pragma] = STATE(2140),
    [sym_preproc_nullable] = STATE(2140),
    [sym_preproc_error] = STATE(2140),
    [sym_preproc_warning] = STATE(2140),
    [sym_preproc_define] = STATE(2140),
    [sym_preproc_undef] = STATE(2140),
    [sym__identifier_token] = ACTIONS(3199),
    [anon_sym_extern] = ACTIONS(3199),
    [anon_sym_alias] = ACTIONS(3199),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_global] = ACTIONS(3199),
    [anon_sym_using] = ACTIONS(3199),
    [anon_sym_unsafe] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3199),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3199),
    [anon_sym_ref] = ACTIONS(3199),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_delegate] = ACTIONS(3199),
    [anon_sym_abstract] = ACTIONS(3199),
    [anon_sym_async] = ACTIONS(3199),
    [anon_sym_const] = ACTIONS(3199),
    [anon_sym_file] = ACTIONS(3199),
    [anon_sym_fixed] = ACTIONS(3199),
    [anon_sym_internal] = ACTIONS(3199),
    [anon_sym_new] = ACTIONS(3199),
    [anon_sym_override] = ACTIONS(3199),
    [anon_sym_partial] = ACTIONS(3199),
    [anon_sym_private] = ACTIONS(3199),
    [anon_sym_protected] = ACTIONS(3199),
    [anon_sym_public] = ACTIONS(3199),
    [anon_sym_readonly] = ACTIONS(3199),
    [anon_sym_required] = ACTIONS(3199),
    [anon_sym_sealed] = ACTIONS(3199),
    [anon_sym_virtual] = ACTIONS(3199),
    [anon_sym_volatile] = ACTIONS(3199),
    [anon_sym_where] = ACTIONS(3199),
    [anon_sym_notnull] = ACTIONS(3199),
    [anon_sym_unmanaged] = ACTIONS(3199),
    [anon_sym_checked] = ACTIONS(3199),
    [anon_sym_BANG] = ACTIONS(3201),
    [anon_sym_TILDE] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3201),
    [anon_sym_DASH_DASH] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3199),
    [anon_sym_false] = ACTIONS(3199),
    [anon_sym_PLUS] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_STAR] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3201),
    [anon_sym_this] = ACTIONS(3199),
    [anon_sym_scoped] = ACTIONS(3199),
    [anon_sym_base] = ACTIONS(3199),
    [anon_sym_var] = ACTIONS(3199),
    [sym_predefined_type] = ACTIONS(3199),
    [anon_sym_break] = ACTIONS(3199),
    [anon_sym_unchecked] = ACTIONS(3199),
    [anon_sym_continue] = ACTIONS(3199),
    [anon_sym_do] = ACTIONS(3199),
    [anon_sym_while] = ACTIONS(3199),
    [anon_sym_for] = ACTIONS(3199),
    [anon_sym_lock] = ACTIONS(3199),
    [anon_sym_yield] = ACTIONS(3199),
    [anon_sym_switch] = ACTIONS(3199),
    [anon_sym_case] = ACTIONS(3199),
    [anon_sym_default] = ACTIONS(3199),
    [anon_sym_throw] = ACTIONS(3199),
    [anon_sym_try] = ACTIONS(3199),
    [anon_sym_when] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3199),
    [anon_sym_foreach] = ACTIONS(3199),
    [anon_sym_goto] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3199),
    [anon_sym_else] = ACTIONS(3199),
    [anon_sym_DOT_DOT] = ACTIONS(3201),
    [anon_sym_from] = ACTIONS(3199),
    [anon_sym_into] = ACTIONS(3199),
    [anon_sym_join] = ACTIONS(3199),
    [anon_sym_on] = ACTIONS(3199),
    [anon_sym_equals] = ACTIONS(3199),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_orderby] = ACTIONS(3199),
    [anon_sym_ascending] = ACTIONS(3199),
    [anon_sym_descending] = ACTIONS(3199),
    [anon_sym_group] = ACTIONS(3199),
    [anon_sym_by] = ACTIONS(3199),
    [anon_sym_select] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3199),
    [anon_sym_sizeof] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(3199),
    [anon_sym___makeref] = ACTIONS(3199),
    [anon_sym___reftype] = ACTIONS(3199),
    [anon_sym___refvalue] = ACTIONS(3199),
    [sym_null_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(3199),
    [sym_real_literal] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3201),
    [sym_verbatim_string_literal] = ACTIONS(3201),
    [aux_sym_preproc_if_token1] = ACTIONS(3201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3201),
    [sym_interpolation_verbatim_start] = ACTIONS(3201),
    [sym_interpolation_raw_start] = ACTIONS(3201),
    [sym_raw_string_start] = ACTIONS(3201),
  },
  [2141] = {
    [sym_preproc_region] = STATE(2141),
    [sym_preproc_endregion] = STATE(2141),
    [sym_preproc_line] = STATE(2141),
    [sym_preproc_pragma] = STATE(2141),
    [sym_preproc_nullable] = STATE(2141),
    [sym_preproc_error] = STATE(2141),
    [sym_preproc_warning] = STATE(2141),
    [sym_preproc_define] = STATE(2141),
    [sym_preproc_undef] = STATE(2141),
    [sym__identifier_token] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_alias] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_global] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_ref] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_delegate] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_file] = ACTIONS(3231),
    [anon_sym_fixed] = ACTIONS(3231),
    [anon_sym_internal] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_partial] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_sealed] = ACTIONS(3231),
    [anon_sym_virtual] = ACTIONS(3231),
    [anon_sym_volatile] = ACTIONS(3231),
    [anon_sym_where] = ACTIONS(3231),
    [anon_sym_notnull] = ACTIONS(3231),
    [anon_sym_unmanaged] = ACTIONS(3231),
    [anon_sym_checked] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_false] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_STAR] = ACTIONS(3233),
    [anon_sym_CARET] = ACTIONS(3233),
    [anon_sym_AMP] = ACTIONS(3233),
    [anon_sym_this] = ACTIONS(3231),
    [anon_sym_scoped] = ACTIONS(3231),
    [anon_sym_base] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [sym_predefined_type] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_unchecked] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_lock] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_when] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_foreach] = ACTIONS(3231),
    [anon_sym_goto] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_DOT_DOT] = ACTIONS(3233),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_into] = ACTIONS(3231),
    [anon_sym_join] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_equals] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_orderby] = ACTIONS(3231),
    [anon_sym_ascending] = ACTIONS(3231),
    [anon_sym_descending] = ACTIONS(3231),
    [anon_sym_group] = ACTIONS(3231),
    [anon_sym_by] = ACTIONS(3231),
    [anon_sym_select] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3231),
    [anon_sym_sizeof] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym___makeref] = ACTIONS(3231),
    [anon_sym___reftype] = ACTIONS(3231),
    [anon_sym___refvalue] = ACTIONS(3231),
    [sym_null_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [sym_integer_literal] = ACTIONS(3231),
    [sym_real_literal] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_verbatim_string_literal] = ACTIONS(3233),
    [aux_sym_preproc_if_token1] = ACTIONS(3233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3233),
    [sym_interpolation_verbatim_start] = ACTIONS(3233),
    [sym_interpolation_raw_start] = ACTIONS(3233),
    [sym_raw_string_start] = ACTIONS(3233),
  },
  [2142] = {
    [sym_preproc_region] = STATE(2142),
    [sym_preproc_endregion] = STATE(2142),
    [sym_preproc_line] = STATE(2142),
    [sym_preproc_pragma] = STATE(2142),
    [sym_preproc_nullable] = STATE(2142),
    [sym_preproc_error] = STATE(2142),
    [sym_preproc_warning] = STATE(2142),
    [sym_preproc_define] = STATE(2142),
    [sym_preproc_undef] = STATE(2142),
    [sym__identifier_token] = ACTIONS(3279),
    [anon_sym_extern] = ACTIONS(3279),
    [anon_sym_alias] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_unsafe] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_ref] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_delegate] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_file] = ACTIONS(3279),
    [anon_sym_fixed] = ACTIONS(3279),
    [anon_sym_internal] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_partial] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_required] = ACTIONS(3279),
    [anon_sym_sealed] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3279),
    [anon_sym_volatile] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_notnull] = ACTIONS(3279),
    [anon_sym_unmanaged] = ACTIONS(3279),
    [anon_sym_checked] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [anon_sym_true] = ACTIONS(3279),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3281),
    [anon_sym_CARET] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_this] = ACTIONS(3279),
    [anon_sym_scoped] = ACTIONS(3279),
    [anon_sym_base] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [sym_predefined_type] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_unchecked] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_lock] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_case] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_foreach] = ACTIONS(3279),
    [anon_sym_goto] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3281),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_ascending] = ACTIONS(3279),
    [anon_sym_descending] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3279),
    [anon_sym_sizeof] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym___makeref] = ACTIONS(3279),
    [anon_sym___reftype] = ACTIONS(3279),
    [anon_sym___refvalue] = ACTIONS(3279),
    [sym_null_literal] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [sym_integer_literal] = ACTIONS(3279),
    [sym_real_literal] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym_verbatim_string_literal] = ACTIONS(3281),
    [aux_sym_preproc_if_token1] = ACTIONS(3281),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3281),
    [sym_interpolation_verbatim_start] = ACTIONS(3281),
    [sym_interpolation_raw_start] = ACTIONS(3281),
    [sym_raw_string_start] = ACTIONS(3281),
  },
  [2143] = {
    [sym_preproc_region] = STATE(2143),
    [sym_preproc_endregion] = STATE(2143),
    [sym_preproc_line] = STATE(2143),
    [sym_preproc_pragma] = STATE(2143),
    [sym_preproc_nullable] = STATE(2143),
    [sym_preproc_error] = STATE(2143),
    [sym_preproc_warning] = STATE(2143),
    [sym_preproc_define] = STATE(2143),
    [sym_preproc_undef] = STATE(2143),
    [sym__identifier_token] = ACTIONS(3215),
    [anon_sym_extern] = ACTIONS(3215),
    [anon_sym_alias] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_global] = ACTIONS(3215),
    [anon_sym_using] = ACTIONS(3215),
    [anon_sym_unsafe] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3215),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3215),
    [anon_sym_ref] = ACTIONS(3215),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_delegate] = ACTIONS(3215),
    [anon_sym_abstract] = ACTIONS(3215),
    [anon_sym_async] = ACTIONS(3215),
    [anon_sym_const] = ACTIONS(3215),
    [anon_sym_file] = ACTIONS(3215),
    [anon_sym_fixed] = ACTIONS(3215),
    [anon_sym_internal] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_override] = ACTIONS(3215),
    [anon_sym_partial] = ACTIONS(3215),
    [anon_sym_private] = ACTIONS(3215),
    [anon_sym_protected] = ACTIONS(3215),
    [anon_sym_public] = ACTIONS(3215),
    [anon_sym_readonly] = ACTIONS(3215),
    [anon_sym_required] = ACTIONS(3215),
    [anon_sym_sealed] = ACTIONS(3215),
    [anon_sym_virtual] = ACTIONS(3215),
    [anon_sym_volatile] = ACTIONS(3215),
    [anon_sym_where] = ACTIONS(3215),
    [anon_sym_notnull] = ACTIONS(3215),
    [anon_sym_unmanaged] = ACTIONS(3215),
    [anon_sym_checked] = ACTIONS(3215),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [anon_sym_true] = ACTIONS(3215),
    [anon_sym_false] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_STAR] = ACTIONS(3217),
    [anon_sym_CARET] = ACTIONS(3217),
    [anon_sym_AMP] = ACTIONS(3217),
    [anon_sym_this] = ACTIONS(3215),
    [anon_sym_scoped] = ACTIONS(3215),
    [anon_sym_base] = ACTIONS(3215),
    [anon_sym_var] = ACTIONS(3215),
    [sym_predefined_type] = ACTIONS(3215),
    [anon_sym_break] = ACTIONS(3215),
    [anon_sym_unchecked] = ACTIONS(3215),
    [anon_sym_continue] = ACTIONS(3215),
    [anon_sym_do] = ACTIONS(3215),
    [anon_sym_while] = ACTIONS(3215),
    [anon_sym_for] = ACTIONS(3215),
    [anon_sym_lock] = ACTIONS(3215),
    [anon_sym_yield] = ACTIONS(3215),
    [anon_sym_switch] = ACTIONS(3215),
    [anon_sym_case] = ACTIONS(3215),
    [anon_sym_default] = ACTIONS(3215),
    [anon_sym_throw] = ACTIONS(3215),
    [anon_sym_try] = ACTIONS(3215),
    [anon_sym_when] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3215),
    [anon_sym_foreach] = ACTIONS(3215),
    [anon_sym_goto] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3215),
    [anon_sym_else] = ACTIONS(3215),
    [anon_sym_DOT_DOT] = ACTIONS(3217),
    [anon_sym_from] = ACTIONS(3215),
    [anon_sym_into] = ACTIONS(3215),
    [anon_sym_join] = ACTIONS(3215),
    [anon_sym_on] = ACTIONS(3215),
    [anon_sym_equals] = ACTIONS(3215),
    [anon_sym_let] = ACTIONS(3215),
    [anon_sym_orderby] = ACTIONS(3215),
    [anon_sym_ascending] = ACTIONS(3215),
    [anon_sym_descending] = ACTIONS(3215),
    [anon_sym_group] = ACTIONS(3215),
    [anon_sym_by] = ACTIONS(3215),
    [anon_sym_select] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3215),
    [anon_sym_sizeof] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3215),
    [anon_sym___makeref] = ACTIONS(3215),
    [anon_sym___reftype] = ACTIONS(3215),
    [anon_sym___refvalue] = ACTIONS(3215),
    [sym_null_literal] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [sym_integer_literal] = ACTIONS(3215),
    [sym_real_literal] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [sym_verbatim_string_literal] = ACTIONS(3217),
    [aux_sym_preproc_if_token1] = ACTIONS(3217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3217),
    [sym_interpolation_verbatim_start] = ACTIONS(3217),
    [sym_interpolation_raw_start] = ACTIONS(3217),
    [sym_raw_string_start] = ACTIONS(3217),
  },
  [2144] = {
    [sym_preproc_region] = STATE(2144),
    [sym_preproc_endregion] = STATE(2144),
    [sym_preproc_line] = STATE(2144),
    [sym_preproc_pragma] = STATE(2144),
    [sym_preproc_nullable] = STATE(2144),
    [sym_preproc_error] = STATE(2144),
    [sym_preproc_warning] = STATE(2144),
    [sym_preproc_define] = STATE(2144),
    [sym_preproc_undef] = STATE(2144),
    [sym__identifier_token] = ACTIONS(3347),
    [anon_sym_extern] = ACTIONS(3347),
    [anon_sym_alias] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_global] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_unsafe] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_ref] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_delegate] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_file] = ACTIONS(3347),
    [anon_sym_fixed] = ACTIONS(3347),
    [anon_sym_internal] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_partial] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_required] = ACTIONS(3347),
    [anon_sym_sealed] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(3347),
    [anon_sym_volatile] = ACTIONS(3347),
    [anon_sym_where] = ACTIONS(3347),
    [anon_sym_notnull] = ACTIONS(3347),
    [anon_sym_unmanaged] = ACTIONS(3347),
    [anon_sym_checked] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_true] = ACTIONS(3347),
    [anon_sym_false] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_this] = ACTIONS(3347),
    [anon_sym_scoped] = ACTIONS(3347),
    [anon_sym_base] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [sym_predefined_type] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_unchecked] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_lock] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_case] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_when] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_foreach] = ACTIONS(3347),
    [anon_sym_goto] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_DOT_DOT] = ACTIONS(3349),
    [anon_sym_from] = ACTIONS(3347),
    [anon_sym_into] = ACTIONS(3347),
    [anon_sym_join] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [anon_sym_equals] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_orderby] = ACTIONS(3347),
    [anon_sym_ascending] = ACTIONS(3347),
    [anon_sym_descending] = ACTIONS(3347),
    [anon_sym_group] = ACTIONS(3347),
    [anon_sym_by] = ACTIONS(3347),
    [anon_sym_select] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3347),
    [anon_sym_sizeof] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym___makeref] = ACTIONS(3347),
    [anon_sym___reftype] = ACTIONS(3347),
    [anon_sym___refvalue] = ACTIONS(3347),
    [sym_null_literal] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_integer_literal] = ACTIONS(3347),
    [sym_real_literal] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [sym_verbatim_string_literal] = ACTIONS(3349),
    [aux_sym_preproc_if_token1] = ACTIONS(3349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3349),
    [sym_interpolation_verbatim_start] = ACTIONS(3349),
    [sym_interpolation_raw_start] = ACTIONS(3349),
    [sym_raw_string_start] = ACTIONS(3349),
  },
  [2145] = {
    [sym_preproc_region] = STATE(2145),
    [sym_preproc_endregion] = STATE(2145),
    [sym_preproc_line] = STATE(2145),
    [sym_preproc_pragma] = STATE(2145),
    [sym_preproc_nullable] = STATE(2145),
    [sym_preproc_error] = STATE(2145),
    [sym_preproc_warning] = STATE(2145),
    [sym_preproc_define] = STATE(2145),
    [sym_preproc_undef] = STATE(2145),
    [sym__identifier_token] = ACTIONS(3271),
    [anon_sym_extern] = ACTIONS(3271),
    [anon_sym_alias] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_global] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_unsafe] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_ref] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_delegate] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_file] = ACTIONS(3271),
    [anon_sym_fixed] = ACTIONS(3271),
    [anon_sym_internal] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_partial] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_required] = ACTIONS(3271),
    [anon_sym_sealed] = ACTIONS(3271),
    [anon_sym_virtual] = ACTIONS(3271),
    [anon_sym_volatile] = ACTIONS(3271),
    [anon_sym_where] = ACTIONS(3271),
    [anon_sym_notnull] = ACTIONS(3271),
    [anon_sym_unmanaged] = ACTIONS(3271),
    [anon_sym_checked] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [anon_sym_true] = ACTIONS(3271),
    [anon_sym_false] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_CARET] = ACTIONS(3273),
    [anon_sym_AMP] = ACTIONS(3273),
    [anon_sym_this] = ACTIONS(3271),
    [anon_sym_scoped] = ACTIONS(3271),
    [anon_sym_base] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [sym_predefined_type] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_unchecked] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_lock] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_case] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_when] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_foreach] = ACTIONS(3271),
    [anon_sym_goto] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_DOT_DOT] = ACTIONS(3273),
    [anon_sym_from] = ACTIONS(3271),
    [anon_sym_into] = ACTIONS(3271),
    [anon_sym_join] = ACTIONS(3271),
    [anon_sym_on] = ACTIONS(3271),
    [anon_sym_equals] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_orderby] = ACTIONS(3271),
    [anon_sym_ascending] = ACTIONS(3271),
    [anon_sym_descending] = ACTIONS(3271),
    [anon_sym_group] = ACTIONS(3271),
    [anon_sym_by] = ACTIONS(3271),
    [anon_sym_select] = ACTIONS(3271),
    [anon_sym_stackalloc] = ACTIONS(3271),
    [anon_sym_sizeof] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym___makeref] = ACTIONS(3271),
    [anon_sym___reftype] = ACTIONS(3271),
    [anon_sym___refvalue] = ACTIONS(3271),
    [sym_null_literal] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [sym_integer_literal] = ACTIONS(3271),
    [sym_real_literal] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [sym_verbatim_string_literal] = ACTIONS(3273),
    [aux_sym_preproc_if_token1] = ACTIONS(3273),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3273),
    [sym_interpolation_verbatim_start] = ACTIONS(3273),
    [sym_interpolation_raw_start] = ACTIONS(3273),
    [sym_raw_string_start] = ACTIONS(3273),
  },
  [2146] = {
    [sym_preproc_region] = STATE(2146),
    [sym_preproc_endregion] = STATE(2146),
    [sym_preproc_line] = STATE(2146),
    [sym_preproc_pragma] = STATE(2146),
    [sym_preproc_nullable] = STATE(2146),
    [sym_preproc_error] = STATE(2146),
    [sym_preproc_warning] = STATE(2146),
    [sym_preproc_define] = STATE(2146),
    [sym_preproc_undef] = STATE(2146),
    [sym__identifier_token] = ACTIONS(3275),
    [anon_sym_extern] = ACTIONS(3275),
    [anon_sym_alias] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_global] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_unsafe] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_ref] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_delegate] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_file] = ACTIONS(3275),
    [anon_sym_fixed] = ACTIONS(3275),
    [anon_sym_internal] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_partial] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_required] = ACTIONS(3275),
    [anon_sym_sealed] = ACTIONS(3275),
    [anon_sym_virtual] = ACTIONS(3275),
    [anon_sym_volatile] = ACTIONS(3275),
    [anon_sym_where] = ACTIONS(3275),
    [anon_sym_notnull] = ACTIONS(3275),
    [anon_sym_unmanaged] = ACTIONS(3275),
    [anon_sym_checked] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [anon_sym_true] = ACTIONS(3275),
    [anon_sym_false] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(3277),
    [anon_sym_CARET] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(3277),
    [anon_sym_this] = ACTIONS(3275),
    [anon_sym_scoped] = ACTIONS(3275),
    [anon_sym_base] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [sym_predefined_type] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_unchecked] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_lock] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_case] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_when] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_foreach] = ACTIONS(3275),
    [anon_sym_goto] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_DOT_DOT] = ACTIONS(3277),
    [anon_sym_from] = ACTIONS(3275),
    [anon_sym_into] = ACTIONS(3275),
    [anon_sym_join] = ACTIONS(3275),
    [anon_sym_on] = ACTIONS(3275),
    [anon_sym_equals] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_orderby] = ACTIONS(3275),
    [anon_sym_ascending] = ACTIONS(3275),
    [anon_sym_descending] = ACTIONS(3275),
    [anon_sym_group] = ACTIONS(3275),
    [anon_sym_by] = ACTIONS(3275),
    [anon_sym_select] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3275),
    [anon_sym_sizeof] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym___makeref] = ACTIONS(3275),
    [anon_sym___reftype] = ACTIONS(3275),
    [anon_sym___refvalue] = ACTIONS(3275),
    [sym_null_literal] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [sym_integer_literal] = ACTIONS(3275),
    [sym_real_literal] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [sym_verbatim_string_literal] = ACTIONS(3277),
    [aux_sym_preproc_if_token1] = ACTIONS(3277),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3277),
    [sym_interpolation_verbatim_start] = ACTIONS(3277),
    [sym_interpolation_raw_start] = ACTIONS(3277),
    [sym_raw_string_start] = ACTIONS(3277),
  },
  [2147] = {
    [sym_preproc_region] = STATE(2147),
    [sym_preproc_endregion] = STATE(2147),
    [sym_preproc_line] = STATE(2147),
    [sym_preproc_pragma] = STATE(2147),
    [sym_preproc_nullable] = STATE(2147),
    [sym_preproc_error] = STATE(2147),
    [sym_preproc_warning] = STATE(2147),
    [sym_preproc_define] = STATE(2147),
    [sym_preproc_undef] = STATE(2147),
    [sym__identifier_token] = ACTIONS(3259),
    [anon_sym_extern] = ACTIONS(3259),
    [anon_sym_alias] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_global] = ACTIONS(3259),
    [anon_sym_using] = ACTIONS(3259),
    [anon_sym_unsafe] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3259),
    [anon_sym_ref] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(3261),
    [anon_sym_delegate] = ACTIONS(3259),
    [anon_sym_abstract] = ACTIONS(3259),
    [anon_sym_async] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3259),
    [anon_sym_file] = ACTIONS(3259),
    [anon_sym_fixed] = ACTIONS(3259),
    [anon_sym_internal] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3259),
    [anon_sym_override] = ACTIONS(3259),
    [anon_sym_partial] = ACTIONS(3259),
    [anon_sym_private] = ACTIONS(3259),
    [anon_sym_protected] = ACTIONS(3259),
    [anon_sym_public] = ACTIONS(3259),
    [anon_sym_readonly] = ACTIONS(3259),
    [anon_sym_required] = ACTIONS(3259),
    [anon_sym_sealed] = ACTIONS(3259),
    [anon_sym_virtual] = ACTIONS(3259),
    [anon_sym_volatile] = ACTIONS(3259),
    [anon_sym_where] = ACTIONS(3259),
    [anon_sym_notnull] = ACTIONS(3259),
    [anon_sym_unmanaged] = ACTIONS(3259),
    [anon_sym_checked] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3261),
    [anon_sym_DASH_DASH] = ACTIONS(3261),
    [anon_sym_true] = ACTIONS(3259),
    [anon_sym_false] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_this] = ACTIONS(3259),
    [anon_sym_scoped] = ACTIONS(3259),
    [anon_sym_base] = ACTIONS(3259),
    [anon_sym_var] = ACTIONS(3259),
    [sym_predefined_type] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3259),
    [anon_sym_unchecked] = ACTIONS(3259),
    [anon_sym_continue] = ACTIONS(3259),
    [anon_sym_do] = ACTIONS(3259),
    [anon_sym_while] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3259),
    [anon_sym_lock] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3259),
    [anon_sym_switch] = ACTIONS(3259),
    [anon_sym_case] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3259),
    [anon_sym_throw] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3259),
    [anon_sym_when] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3259),
    [anon_sym_foreach] = ACTIONS(3259),
    [anon_sym_goto] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(3259),
    [anon_sym_else] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3261),
    [anon_sym_from] = ACTIONS(3259),
    [anon_sym_into] = ACTIONS(3259),
    [anon_sym_join] = ACTIONS(3259),
    [anon_sym_on] = ACTIONS(3259),
    [anon_sym_equals] = ACTIONS(3259),
    [anon_sym_let] = ACTIONS(3259),
    [anon_sym_orderby] = ACTIONS(3259),
    [anon_sym_ascending] = ACTIONS(3259),
    [anon_sym_descending] = ACTIONS(3259),
    [anon_sym_group] = ACTIONS(3259),
    [anon_sym_by] = ACTIONS(3259),
    [anon_sym_select] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3259),
    [anon_sym_sizeof] = ACTIONS(3259),
    [anon_sym_typeof] = ACTIONS(3259),
    [anon_sym___makeref] = ACTIONS(3259),
    [anon_sym___reftype] = ACTIONS(3259),
    [anon_sym___refvalue] = ACTIONS(3259),
    [sym_null_literal] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [sym_real_literal] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [sym_verbatim_string_literal] = ACTIONS(3261),
    [aux_sym_preproc_if_token1] = ACTIONS(3261),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3261),
    [sym_interpolation_verbatim_start] = ACTIONS(3261),
    [sym_interpolation_raw_start] = ACTIONS(3261),
    [sym_raw_string_start] = ACTIONS(3261),
  },
  [2148] = {
    [sym_preproc_region] = STATE(2148),
    [sym_preproc_endregion] = STATE(2148),
    [sym_preproc_line] = STATE(2148),
    [sym_preproc_pragma] = STATE(2148),
    [sym_preproc_nullable] = STATE(2148),
    [sym_preproc_error] = STATE(2148),
    [sym_preproc_warning] = STATE(2148),
    [sym_preproc_define] = STATE(2148),
    [sym_preproc_undef] = STATE(2148),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2149] = {
    [sym_preproc_region] = STATE(2149),
    [sym_preproc_endregion] = STATE(2149),
    [sym_preproc_line] = STATE(2149),
    [sym_preproc_pragma] = STATE(2149),
    [sym_preproc_nullable] = STATE(2149),
    [sym_preproc_error] = STATE(2149),
    [sym_preproc_warning] = STATE(2149),
    [sym_preproc_define] = STATE(2149),
    [sym_preproc_undef] = STATE(2149),
    [sym__identifier_token] = ACTIONS(3501),
    [anon_sym_extern] = ACTIONS(3501),
    [anon_sym_alias] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym_global] = ACTIONS(3501),
    [anon_sym_using] = ACTIONS(3501),
    [anon_sym_unsafe] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3501),
    [anon_sym_ref] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_delegate] = ACTIONS(3501),
    [anon_sym_abstract] = ACTIONS(3501),
    [anon_sym_async] = ACTIONS(3501),
    [anon_sym_const] = ACTIONS(3501),
    [anon_sym_file] = ACTIONS(3501),
    [anon_sym_fixed] = ACTIONS(3501),
    [anon_sym_internal] = ACTIONS(3501),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_override] = ACTIONS(3501),
    [anon_sym_partial] = ACTIONS(3501),
    [anon_sym_private] = ACTIONS(3501),
    [anon_sym_protected] = ACTIONS(3501),
    [anon_sym_public] = ACTIONS(3501),
    [anon_sym_readonly] = ACTIONS(3501),
    [anon_sym_required] = ACTIONS(3501),
    [anon_sym_sealed] = ACTIONS(3501),
    [anon_sym_virtual] = ACTIONS(3501),
    [anon_sym_volatile] = ACTIONS(3501),
    [anon_sym_where] = ACTIONS(3501),
    [anon_sym_notnull] = ACTIONS(3501),
    [anon_sym_unmanaged] = ACTIONS(3501),
    [anon_sym_checked] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_true] = ACTIONS(3501),
    [anon_sym_false] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_CARET] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3503),
    [anon_sym_this] = ACTIONS(3501),
    [anon_sym_scoped] = ACTIONS(3501),
    [anon_sym_base] = ACTIONS(3501),
    [anon_sym_var] = ACTIONS(3501),
    [sym_predefined_type] = ACTIONS(3501),
    [anon_sym_break] = ACTIONS(3501),
    [anon_sym_unchecked] = ACTIONS(3501),
    [anon_sym_continue] = ACTIONS(3501),
    [anon_sym_do] = ACTIONS(3501),
    [anon_sym_while] = ACTIONS(3501),
    [anon_sym_for] = ACTIONS(3501),
    [anon_sym_lock] = ACTIONS(3501),
    [anon_sym_yield] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3501),
    [anon_sym_case] = ACTIONS(3501),
    [anon_sym_default] = ACTIONS(3501),
    [anon_sym_throw] = ACTIONS(3501),
    [anon_sym_try] = ACTIONS(3501),
    [anon_sym_when] = ACTIONS(3501),
    [anon_sym_await] = ACTIONS(3501),
    [anon_sym_foreach] = ACTIONS(3501),
    [anon_sym_goto] = ACTIONS(3501),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_DOT_DOT] = ACTIONS(3503),
    [anon_sym_from] = ACTIONS(3501),
    [anon_sym_into] = ACTIONS(3501),
    [anon_sym_join] = ACTIONS(3501),
    [anon_sym_on] = ACTIONS(3501),
    [anon_sym_equals] = ACTIONS(3501),
    [anon_sym_let] = ACTIONS(3501),
    [anon_sym_orderby] = ACTIONS(3501),
    [anon_sym_ascending] = ACTIONS(3501),
    [anon_sym_descending] = ACTIONS(3501),
    [anon_sym_group] = ACTIONS(3501),
    [anon_sym_by] = ACTIONS(3501),
    [anon_sym_select] = ACTIONS(3501),
    [anon_sym_stackalloc] = ACTIONS(3501),
    [anon_sym_sizeof] = ACTIONS(3501),
    [anon_sym_typeof] = ACTIONS(3501),
    [anon_sym___makeref] = ACTIONS(3501),
    [anon_sym___reftype] = ACTIONS(3501),
    [anon_sym___refvalue] = ACTIONS(3501),
    [sym_null_literal] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_integer_literal] = ACTIONS(3501),
    [sym_real_literal] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3503),
    [sym_verbatim_string_literal] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3503),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3503),
    [sym_interpolation_verbatim_start] = ACTIONS(3503),
    [sym_interpolation_raw_start] = ACTIONS(3503),
    [sym_raw_string_start] = ACTIONS(3503),
  },
  [2150] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6180),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5841),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2150),
    [sym_preproc_endregion] = STATE(2150),
    [sym_preproc_line] = STATE(2150),
    [sym_preproc_pragma] = STATE(2150),
    [sym_preproc_nullable] = STATE(2150),
    [sym_preproc_error] = STATE(2150),
    [sym_preproc_warning] = STATE(2150),
    [sym_preproc_define] = STATE(2150),
    [sym_preproc_undef] = STATE(2150),
    [sym__identifier_token] = ACTIONS(3453),
    [anon_sym_alias] = ACTIONS(3456),
    [anon_sym_global] = ACTIONS(3456),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3456),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3456),
    [anon_sym_unmanaged] = ACTIONS(3456),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3470),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3473),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3456),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3456),
    [anon_sym_into] = ACTIONS(3456),
    [anon_sym_join] = ACTIONS(3456),
    [anon_sym_on] = ACTIONS(3456),
    [anon_sym_equals] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_orderby] = ACTIONS(3456),
    [anon_sym_ascending] = ACTIONS(3456),
    [anon_sym_descending] = ACTIONS(3456),
    [anon_sym_group] = ACTIONS(3456),
    [anon_sym_by] = ACTIONS(3456),
    [anon_sym_select] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2151] = {
    [sym_preproc_region] = STATE(2151),
    [sym_preproc_endregion] = STATE(2151),
    [sym_preproc_line] = STATE(2151),
    [sym_preproc_pragma] = STATE(2151),
    [sym_preproc_nullable] = STATE(2151),
    [sym_preproc_error] = STATE(2151),
    [sym_preproc_warning] = STATE(2151),
    [sym_preproc_define] = STATE(2151),
    [sym_preproc_undef] = STATE(2151),
    [sym__identifier_token] = ACTIONS(3505),
    [anon_sym_extern] = ACTIONS(3505),
    [anon_sym_alias] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym_global] = ACTIONS(3505),
    [anon_sym_using] = ACTIONS(3505),
    [anon_sym_unsafe] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_ref] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_delegate] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_async] = ACTIONS(3505),
    [anon_sym_const] = ACTIONS(3505),
    [anon_sym_file] = ACTIONS(3505),
    [anon_sym_fixed] = ACTIONS(3505),
    [anon_sym_internal] = ACTIONS(3505),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [anon_sym_partial] = ACTIONS(3505),
    [anon_sym_private] = ACTIONS(3505),
    [anon_sym_protected] = ACTIONS(3505),
    [anon_sym_public] = ACTIONS(3505),
    [anon_sym_readonly] = ACTIONS(3505),
    [anon_sym_required] = ACTIONS(3505),
    [anon_sym_sealed] = ACTIONS(3505),
    [anon_sym_virtual] = ACTIONS(3505),
    [anon_sym_volatile] = ACTIONS(3505),
    [anon_sym_where] = ACTIONS(3505),
    [anon_sym_notnull] = ACTIONS(3505),
    [anon_sym_unmanaged] = ACTIONS(3505),
    [anon_sym_checked] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_true] = ACTIONS(3505),
    [anon_sym_false] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_this] = ACTIONS(3505),
    [anon_sym_scoped] = ACTIONS(3505),
    [anon_sym_base] = ACTIONS(3505),
    [anon_sym_var] = ACTIONS(3505),
    [sym_predefined_type] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3505),
    [anon_sym_unchecked] = ACTIONS(3505),
    [anon_sym_continue] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_lock] = ACTIONS(3505),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3505),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_throw] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_when] = ACTIONS(3505),
    [anon_sym_await] = ACTIONS(3505),
    [anon_sym_foreach] = ACTIONS(3505),
    [anon_sym_goto] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_DOT_DOT] = ACTIONS(3507),
    [anon_sym_from] = ACTIONS(3505),
    [anon_sym_into] = ACTIONS(3505),
    [anon_sym_join] = ACTIONS(3505),
    [anon_sym_on] = ACTIONS(3505),
    [anon_sym_equals] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_orderby] = ACTIONS(3505),
    [anon_sym_ascending] = ACTIONS(3505),
    [anon_sym_descending] = ACTIONS(3505),
    [anon_sym_group] = ACTIONS(3505),
    [anon_sym_by] = ACTIONS(3505),
    [anon_sym_select] = ACTIONS(3505),
    [anon_sym_stackalloc] = ACTIONS(3505),
    [anon_sym_sizeof] = ACTIONS(3505),
    [anon_sym_typeof] = ACTIONS(3505),
    [anon_sym___makeref] = ACTIONS(3505),
    [anon_sym___reftype] = ACTIONS(3505),
    [anon_sym___refvalue] = ACTIONS(3505),
    [sym_null_literal] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [sym_integer_literal] = ACTIONS(3505),
    [sym_real_literal] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [sym_verbatim_string_literal] = ACTIONS(3507),
    [aux_sym_preproc_if_token1] = ACTIONS(3507),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3507),
    [sym_interpolation_verbatim_start] = ACTIONS(3507),
    [sym_interpolation_raw_start] = ACTIONS(3507),
    [sym_raw_string_start] = ACTIONS(3507),
  },
  [2152] = {
    [sym_preproc_region] = STATE(2152),
    [sym_preproc_endregion] = STATE(2152),
    [sym_preproc_line] = STATE(2152),
    [sym_preproc_pragma] = STATE(2152),
    [sym_preproc_nullable] = STATE(2152),
    [sym_preproc_error] = STATE(2152),
    [sym_preproc_warning] = STATE(2152),
    [sym_preproc_define] = STATE(2152),
    [sym_preproc_undef] = STATE(2152),
    [sym__identifier_token] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3509),
    [anon_sym_alias] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_global] = ACTIONS(3509),
    [anon_sym_using] = ACTIONS(3509),
    [anon_sym_unsafe] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3509),
    [anon_sym_ref] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_delegate] = ACTIONS(3509),
    [anon_sym_abstract] = ACTIONS(3509),
    [anon_sym_async] = ACTIONS(3509),
    [anon_sym_const] = ACTIONS(3509),
    [anon_sym_file] = ACTIONS(3509),
    [anon_sym_fixed] = ACTIONS(3509),
    [anon_sym_internal] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_override] = ACTIONS(3509),
    [anon_sym_partial] = ACTIONS(3509),
    [anon_sym_private] = ACTIONS(3509),
    [anon_sym_protected] = ACTIONS(3509),
    [anon_sym_public] = ACTIONS(3509),
    [anon_sym_readonly] = ACTIONS(3509),
    [anon_sym_required] = ACTIONS(3509),
    [anon_sym_sealed] = ACTIONS(3509),
    [anon_sym_virtual] = ACTIONS(3509),
    [anon_sym_volatile] = ACTIONS(3509),
    [anon_sym_where] = ACTIONS(3509),
    [anon_sym_notnull] = ACTIONS(3509),
    [anon_sym_unmanaged] = ACTIONS(3509),
    [anon_sym_checked] = ACTIONS(3509),
    [anon_sym_BANG] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3511),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_true] = ACTIONS(3509),
    [anon_sym_false] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_CARET] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_this] = ACTIONS(3509),
    [anon_sym_scoped] = ACTIONS(3509),
    [anon_sym_base] = ACTIONS(3509),
    [anon_sym_var] = ACTIONS(3509),
    [sym_predefined_type] = ACTIONS(3509),
    [anon_sym_break] = ACTIONS(3509),
    [anon_sym_unchecked] = ACTIONS(3509),
    [anon_sym_continue] = ACTIONS(3509),
    [anon_sym_do] = ACTIONS(3509),
    [anon_sym_while] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3509),
    [anon_sym_lock] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3509),
    [anon_sym_switch] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3509),
    [anon_sym_throw] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3509),
    [anon_sym_when] = ACTIONS(3509),
    [anon_sym_await] = ACTIONS(3509),
    [anon_sym_foreach] = ACTIONS(3509),
    [anon_sym_goto] = ACTIONS(3509),
    [anon_sym_if] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3511),
    [anon_sym_from] = ACTIONS(3509),
    [anon_sym_into] = ACTIONS(3509),
    [anon_sym_join] = ACTIONS(3509),
    [anon_sym_on] = ACTIONS(3509),
    [anon_sym_equals] = ACTIONS(3509),
    [anon_sym_let] = ACTIONS(3509),
    [anon_sym_orderby] = ACTIONS(3509),
    [anon_sym_ascending] = ACTIONS(3509),
    [anon_sym_descending] = ACTIONS(3509),
    [anon_sym_group] = ACTIONS(3509),
    [anon_sym_by] = ACTIONS(3509),
    [anon_sym_select] = ACTIONS(3509),
    [anon_sym_stackalloc] = ACTIONS(3509),
    [anon_sym_sizeof] = ACTIONS(3509),
    [anon_sym_typeof] = ACTIONS(3509),
    [anon_sym___makeref] = ACTIONS(3509),
    [anon_sym___reftype] = ACTIONS(3509),
    [anon_sym___refvalue] = ACTIONS(3509),
    [sym_null_literal] = ACTIONS(3509),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [sym_integer_literal] = ACTIONS(3509),
    [sym_real_literal] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [sym_verbatim_string_literal] = ACTIONS(3511),
    [aux_sym_preproc_if_token1] = ACTIONS(3511),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3511),
    [sym_interpolation_verbatim_start] = ACTIONS(3511),
    [sym_interpolation_raw_start] = ACTIONS(3511),
    [sym_raw_string_start] = ACTIONS(3511),
  },
  [2153] = {
    [sym_preproc_region] = STATE(2153),
    [sym_preproc_endregion] = STATE(2153),
    [sym_preproc_line] = STATE(2153),
    [sym_preproc_pragma] = STATE(2153),
    [sym_preproc_nullable] = STATE(2153),
    [sym_preproc_error] = STATE(2153),
    [sym_preproc_warning] = STATE(2153),
    [sym_preproc_define] = STATE(2153),
    [sym_preproc_undef] = STATE(2153),
    [sym__identifier_token] = ACTIONS(3513),
    [anon_sym_extern] = ACTIONS(3513),
    [anon_sym_alias] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_global] = ACTIONS(3513),
    [anon_sym_using] = ACTIONS(3513),
    [anon_sym_unsafe] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_ref] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_delegate] = ACTIONS(3513),
    [anon_sym_abstract] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [anon_sym_file] = ACTIONS(3513),
    [anon_sym_fixed] = ACTIONS(3513),
    [anon_sym_internal] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_override] = ACTIONS(3513),
    [anon_sym_partial] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_required] = ACTIONS(3513),
    [anon_sym_sealed] = ACTIONS(3513),
    [anon_sym_virtual] = ACTIONS(3513),
    [anon_sym_volatile] = ACTIONS(3513),
    [anon_sym_where] = ACTIONS(3513),
    [anon_sym_notnull] = ACTIONS(3513),
    [anon_sym_unmanaged] = ACTIONS(3513),
    [anon_sym_checked] = ACTIONS(3513),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_true] = ACTIONS(3513),
    [anon_sym_false] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_this] = ACTIONS(3513),
    [anon_sym_scoped] = ACTIONS(3513),
    [anon_sym_base] = ACTIONS(3513),
    [anon_sym_var] = ACTIONS(3513),
    [sym_predefined_type] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_unchecked] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_lock] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3513),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_when] = ACTIONS(3513),
    [anon_sym_await] = ACTIONS(3513),
    [anon_sym_foreach] = ACTIONS(3513),
    [anon_sym_goto] = ACTIONS(3513),
    [anon_sym_if] = ACTIONS(3513),
    [anon_sym_DOT_DOT] = ACTIONS(3515),
    [anon_sym_from] = ACTIONS(3513),
    [anon_sym_into] = ACTIONS(3513),
    [anon_sym_join] = ACTIONS(3513),
    [anon_sym_on] = ACTIONS(3513),
    [anon_sym_equals] = ACTIONS(3513),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_orderby] = ACTIONS(3513),
    [anon_sym_ascending] = ACTIONS(3513),
    [anon_sym_descending] = ACTIONS(3513),
    [anon_sym_group] = ACTIONS(3513),
    [anon_sym_by] = ACTIONS(3513),
    [anon_sym_select] = ACTIONS(3513),
    [anon_sym_stackalloc] = ACTIONS(3513),
    [anon_sym_sizeof] = ACTIONS(3513),
    [anon_sym_typeof] = ACTIONS(3513),
    [anon_sym___makeref] = ACTIONS(3513),
    [anon_sym___reftype] = ACTIONS(3513),
    [anon_sym___refvalue] = ACTIONS(3513),
    [sym_null_literal] = ACTIONS(3513),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [sym_integer_literal] = ACTIONS(3513),
    [sym_real_literal] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_verbatim_string_literal] = ACTIONS(3515),
    [aux_sym_preproc_if_token1] = ACTIONS(3515),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3515),
    [sym_interpolation_verbatim_start] = ACTIONS(3515),
    [sym_interpolation_raw_start] = ACTIONS(3515),
    [sym_raw_string_start] = ACTIONS(3515),
  },
  [2154] = {
    [sym_preproc_region] = STATE(2154),
    [sym_preproc_endregion] = STATE(2154),
    [sym_preproc_line] = STATE(2154),
    [sym_preproc_pragma] = STATE(2154),
    [sym_preproc_nullable] = STATE(2154),
    [sym_preproc_error] = STATE(2154),
    [sym_preproc_warning] = STATE(2154),
    [sym_preproc_define] = STATE(2154),
    [sym_preproc_undef] = STATE(2154),
    [sym__identifier_token] = ACTIONS(3517),
    [anon_sym_extern] = ACTIONS(3517),
    [anon_sym_alias] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_global] = ACTIONS(3517),
    [anon_sym_using] = ACTIONS(3517),
    [anon_sym_unsafe] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_ref] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_delegate] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [anon_sym_file] = ACTIONS(3517),
    [anon_sym_fixed] = ACTIONS(3517),
    [anon_sym_internal] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_override] = ACTIONS(3517),
    [anon_sym_partial] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_readonly] = ACTIONS(3517),
    [anon_sym_required] = ACTIONS(3517),
    [anon_sym_sealed] = ACTIONS(3517),
    [anon_sym_virtual] = ACTIONS(3517),
    [anon_sym_volatile] = ACTIONS(3517),
    [anon_sym_where] = ACTIONS(3517),
    [anon_sym_notnull] = ACTIONS(3517),
    [anon_sym_unmanaged] = ACTIONS(3517),
    [anon_sym_checked] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_true] = ACTIONS(3517),
    [anon_sym_false] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_CARET] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_this] = ACTIONS(3517),
    [anon_sym_scoped] = ACTIONS(3517),
    [anon_sym_base] = ACTIONS(3517),
    [anon_sym_var] = ACTIONS(3517),
    [sym_predefined_type] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_unchecked] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_lock] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3517),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_when] = ACTIONS(3517),
    [anon_sym_await] = ACTIONS(3517),
    [anon_sym_foreach] = ACTIONS(3517),
    [anon_sym_goto] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_from] = ACTIONS(3517),
    [anon_sym_into] = ACTIONS(3517),
    [anon_sym_join] = ACTIONS(3517),
    [anon_sym_on] = ACTIONS(3517),
    [anon_sym_equals] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_orderby] = ACTIONS(3517),
    [anon_sym_ascending] = ACTIONS(3517),
    [anon_sym_descending] = ACTIONS(3517),
    [anon_sym_group] = ACTIONS(3517),
    [anon_sym_by] = ACTIONS(3517),
    [anon_sym_select] = ACTIONS(3517),
    [anon_sym_stackalloc] = ACTIONS(3517),
    [anon_sym_sizeof] = ACTIONS(3517),
    [anon_sym_typeof] = ACTIONS(3517),
    [anon_sym___makeref] = ACTIONS(3517),
    [anon_sym___reftype] = ACTIONS(3517),
    [anon_sym___refvalue] = ACTIONS(3517),
    [sym_null_literal] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [sym_integer_literal] = ACTIONS(3517),
    [sym_real_literal] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [sym_verbatim_string_literal] = ACTIONS(3519),
    [aux_sym_preproc_if_token1] = ACTIONS(3519),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3519),
    [sym_interpolation_verbatim_start] = ACTIONS(3519),
    [sym_interpolation_raw_start] = ACTIONS(3519),
    [sym_raw_string_start] = ACTIONS(3519),
  },
  [2155] = {
    [sym_preproc_region] = STATE(2155),
    [sym_preproc_endregion] = STATE(2155),
    [sym_preproc_line] = STATE(2155),
    [sym_preproc_pragma] = STATE(2155),
    [sym_preproc_nullable] = STATE(2155),
    [sym_preproc_error] = STATE(2155),
    [sym_preproc_warning] = STATE(2155),
    [sym_preproc_define] = STATE(2155),
    [sym_preproc_undef] = STATE(2155),
    [sym__identifier_token] = ACTIONS(3521),
    [anon_sym_extern] = ACTIONS(3521),
    [anon_sym_alias] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_global] = ACTIONS(3521),
    [anon_sym_using] = ACTIONS(3521),
    [anon_sym_unsafe] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3521),
    [anon_sym_ref] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_delegate] = ACTIONS(3521),
    [anon_sym_abstract] = ACTIONS(3521),
    [anon_sym_async] = ACTIONS(3521),
    [anon_sym_const] = ACTIONS(3521),
    [anon_sym_file] = ACTIONS(3521),
    [anon_sym_fixed] = ACTIONS(3521),
    [anon_sym_internal] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_override] = ACTIONS(3521),
    [anon_sym_partial] = ACTIONS(3521),
    [anon_sym_private] = ACTIONS(3521),
    [anon_sym_protected] = ACTIONS(3521),
    [anon_sym_public] = ACTIONS(3521),
    [anon_sym_readonly] = ACTIONS(3521),
    [anon_sym_required] = ACTIONS(3521),
    [anon_sym_sealed] = ACTIONS(3521),
    [anon_sym_virtual] = ACTIONS(3521),
    [anon_sym_volatile] = ACTIONS(3521),
    [anon_sym_where] = ACTIONS(3521),
    [anon_sym_notnull] = ACTIONS(3521),
    [anon_sym_unmanaged] = ACTIONS(3521),
    [anon_sym_checked] = ACTIONS(3521),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_true] = ACTIONS(3521),
    [anon_sym_false] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_this] = ACTIONS(3521),
    [anon_sym_scoped] = ACTIONS(3521),
    [anon_sym_base] = ACTIONS(3521),
    [anon_sym_var] = ACTIONS(3521),
    [sym_predefined_type] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3521),
    [anon_sym_unchecked] = ACTIONS(3521),
    [anon_sym_continue] = ACTIONS(3521),
    [anon_sym_do] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3521),
    [anon_sym_lock] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3521),
    [anon_sym_throw] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3521),
    [anon_sym_when] = ACTIONS(3521),
    [anon_sym_await] = ACTIONS(3521),
    [anon_sym_foreach] = ACTIONS(3521),
    [anon_sym_goto] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3523),
    [anon_sym_from] = ACTIONS(3521),
    [anon_sym_into] = ACTIONS(3521),
    [anon_sym_join] = ACTIONS(3521),
    [anon_sym_on] = ACTIONS(3521),
    [anon_sym_equals] = ACTIONS(3521),
    [anon_sym_let] = ACTIONS(3521),
    [anon_sym_orderby] = ACTIONS(3521),
    [anon_sym_ascending] = ACTIONS(3521),
    [anon_sym_descending] = ACTIONS(3521),
    [anon_sym_group] = ACTIONS(3521),
    [anon_sym_by] = ACTIONS(3521),
    [anon_sym_select] = ACTIONS(3521),
    [anon_sym_stackalloc] = ACTIONS(3521),
    [anon_sym_sizeof] = ACTIONS(3521),
    [anon_sym_typeof] = ACTIONS(3521),
    [anon_sym___makeref] = ACTIONS(3521),
    [anon_sym___reftype] = ACTIONS(3521),
    [anon_sym___refvalue] = ACTIONS(3521),
    [sym_null_literal] = ACTIONS(3521),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [sym_integer_literal] = ACTIONS(3521),
    [sym_real_literal] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [sym_verbatim_string_literal] = ACTIONS(3523),
    [aux_sym_preproc_if_token1] = ACTIONS(3523),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3523),
    [sym_interpolation_verbatim_start] = ACTIONS(3523),
    [sym_interpolation_raw_start] = ACTIONS(3523),
    [sym_raw_string_start] = ACTIONS(3523),
  },
  [2156] = {
    [sym_preproc_region] = STATE(2156),
    [sym_preproc_endregion] = STATE(2156),
    [sym_preproc_line] = STATE(2156),
    [sym_preproc_pragma] = STATE(2156),
    [sym_preproc_nullable] = STATE(2156),
    [sym_preproc_error] = STATE(2156),
    [sym_preproc_warning] = STATE(2156),
    [sym_preproc_define] = STATE(2156),
    [sym_preproc_undef] = STATE(2156),
    [sym__identifier_token] = ACTIONS(3525),
    [anon_sym_extern] = ACTIONS(3525),
    [anon_sym_alias] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_global] = ACTIONS(3525),
    [anon_sym_using] = ACTIONS(3525),
    [anon_sym_unsafe] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_ref] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_delegate] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_file] = ACTIONS(3525),
    [anon_sym_fixed] = ACTIONS(3525),
    [anon_sym_internal] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_override] = ACTIONS(3525),
    [anon_sym_partial] = ACTIONS(3525),
    [anon_sym_private] = ACTIONS(3525),
    [anon_sym_protected] = ACTIONS(3525),
    [anon_sym_public] = ACTIONS(3525),
    [anon_sym_readonly] = ACTIONS(3525),
    [anon_sym_required] = ACTIONS(3525),
    [anon_sym_sealed] = ACTIONS(3525),
    [anon_sym_virtual] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_where] = ACTIONS(3525),
    [anon_sym_notnull] = ACTIONS(3525),
    [anon_sym_unmanaged] = ACTIONS(3525),
    [anon_sym_checked] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_true] = ACTIONS(3525),
    [anon_sym_false] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_this] = ACTIONS(3525),
    [anon_sym_scoped] = ACTIONS(3525),
    [anon_sym_base] = ACTIONS(3525),
    [anon_sym_var] = ACTIONS(3525),
    [sym_predefined_type] = ACTIONS(3525),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_unchecked] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_lock] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_when] = ACTIONS(3525),
    [anon_sym_await] = ACTIONS(3525),
    [anon_sym_foreach] = ACTIONS(3525),
    [anon_sym_goto] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_DOT_DOT] = ACTIONS(3527),
    [anon_sym_from] = ACTIONS(3525),
    [anon_sym_into] = ACTIONS(3525),
    [anon_sym_join] = ACTIONS(3525),
    [anon_sym_on] = ACTIONS(3525),
    [anon_sym_equals] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_orderby] = ACTIONS(3525),
    [anon_sym_ascending] = ACTIONS(3525),
    [anon_sym_descending] = ACTIONS(3525),
    [anon_sym_group] = ACTIONS(3525),
    [anon_sym_by] = ACTIONS(3525),
    [anon_sym_select] = ACTIONS(3525),
    [anon_sym_stackalloc] = ACTIONS(3525),
    [anon_sym_sizeof] = ACTIONS(3525),
    [anon_sym_typeof] = ACTIONS(3525),
    [anon_sym___makeref] = ACTIONS(3525),
    [anon_sym___reftype] = ACTIONS(3525),
    [anon_sym___refvalue] = ACTIONS(3525),
    [sym_null_literal] = ACTIONS(3525),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [sym_integer_literal] = ACTIONS(3525),
    [sym_real_literal] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [sym_verbatim_string_literal] = ACTIONS(3527),
    [aux_sym_preproc_if_token1] = ACTIONS(3527),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3527),
    [sym_interpolation_verbatim_start] = ACTIONS(3527),
    [sym_interpolation_raw_start] = ACTIONS(3527),
    [sym_raw_string_start] = ACTIONS(3527),
  },
  [2157] = {
    [sym_preproc_region] = STATE(2157),
    [sym_preproc_endregion] = STATE(2157),
    [sym_preproc_line] = STATE(2157),
    [sym_preproc_pragma] = STATE(2157),
    [sym_preproc_nullable] = STATE(2157),
    [sym_preproc_error] = STATE(2157),
    [sym_preproc_warning] = STATE(2157),
    [sym_preproc_define] = STATE(2157),
    [sym_preproc_undef] = STATE(2157),
    [sym__identifier_token] = ACTIONS(3529),
    [anon_sym_extern] = ACTIONS(3529),
    [anon_sym_alias] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_global] = ACTIONS(3529),
    [anon_sym_using] = ACTIONS(3529),
    [anon_sym_unsafe] = ACTIONS(3529),
    [anon_sym_static] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3529),
    [anon_sym_ref] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_delegate] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_const] = ACTIONS(3529),
    [anon_sym_file] = ACTIONS(3529),
    [anon_sym_fixed] = ACTIONS(3529),
    [anon_sym_internal] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3529),
    [anon_sym_override] = ACTIONS(3529),
    [anon_sym_partial] = ACTIONS(3529),
    [anon_sym_private] = ACTIONS(3529),
    [anon_sym_protected] = ACTIONS(3529),
    [anon_sym_public] = ACTIONS(3529),
    [anon_sym_readonly] = ACTIONS(3529),
    [anon_sym_required] = ACTIONS(3529),
    [anon_sym_sealed] = ACTIONS(3529),
    [anon_sym_virtual] = ACTIONS(3529),
    [anon_sym_volatile] = ACTIONS(3529),
    [anon_sym_where] = ACTIONS(3529),
    [anon_sym_notnull] = ACTIONS(3529),
    [anon_sym_unmanaged] = ACTIONS(3529),
    [anon_sym_checked] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3531),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_true] = ACTIONS(3529),
    [anon_sym_false] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_this] = ACTIONS(3529),
    [anon_sym_scoped] = ACTIONS(3529),
    [anon_sym_base] = ACTIONS(3529),
    [anon_sym_var] = ACTIONS(3529),
    [sym_predefined_type] = ACTIONS(3529),
    [anon_sym_break] = ACTIONS(3529),
    [anon_sym_unchecked] = ACTIONS(3529),
    [anon_sym_continue] = ACTIONS(3529),
    [anon_sym_do] = ACTIONS(3529),
    [anon_sym_while] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3529),
    [anon_sym_lock] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3529),
    [anon_sym_switch] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_throw] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3529),
    [anon_sym_when] = ACTIONS(3529),
    [anon_sym_await] = ACTIONS(3529),
    [anon_sym_foreach] = ACTIONS(3529),
    [anon_sym_goto] = ACTIONS(3529),
    [anon_sym_if] = ACTIONS(3529),
    [anon_sym_DOT_DOT] = ACTIONS(3531),
    [anon_sym_from] = ACTIONS(3529),
    [anon_sym_into] = ACTIONS(3529),
    [anon_sym_join] = ACTIONS(3529),
    [anon_sym_on] = ACTIONS(3529),
    [anon_sym_equals] = ACTIONS(3529),
    [anon_sym_let] = ACTIONS(3529),
    [anon_sym_orderby] = ACTIONS(3529),
    [anon_sym_ascending] = ACTIONS(3529),
    [anon_sym_descending] = ACTIONS(3529),
    [anon_sym_group] = ACTIONS(3529),
    [anon_sym_by] = ACTIONS(3529),
    [anon_sym_select] = ACTIONS(3529),
    [anon_sym_stackalloc] = ACTIONS(3529),
    [anon_sym_sizeof] = ACTIONS(3529),
    [anon_sym_typeof] = ACTIONS(3529),
    [anon_sym___makeref] = ACTIONS(3529),
    [anon_sym___reftype] = ACTIONS(3529),
    [anon_sym___refvalue] = ACTIONS(3529),
    [sym_null_literal] = ACTIONS(3529),
    [anon_sym_SQUOTE] = ACTIONS(3531),
    [sym_integer_literal] = ACTIONS(3529),
    [sym_real_literal] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [sym_verbatim_string_literal] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3531),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3531),
    [sym_interpolation_verbatim_start] = ACTIONS(3531),
    [sym_interpolation_raw_start] = ACTIONS(3531),
    [sym_raw_string_start] = ACTIONS(3531),
  },
  [2158] = {
    [sym_preproc_region] = STATE(2158),
    [sym_preproc_endregion] = STATE(2158),
    [sym_preproc_line] = STATE(2158),
    [sym_preproc_pragma] = STATE(2158),
    [sym_preproc_nullable] = STATE(2158),
    [sym_preproc_error] = STATE(2158),
    [sym_preproc_warning] = STATE(2158),
    [sym_preproc_define] = STATE(2158),
    [sym_preproc_undef] = STATE(2158),
    [sym__identifier_token] = ACTIONS(3533),
    [anon_sym_extern] = ACTIONS(3533),
    [anon_sym_alias] = ACTIONS(3533),
    [anon_sym_SEMI] = ACTIONS(3535),
    [anon_sym_global] = ACTIONS(3533),
    [anon_sym_using] = ACTIONS(3533),
    [anon_sym_unsafe] = ACTIONS(3533),
    [anon_sym_static] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_ref] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_delegate] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_file] = ACTIONS(3533),
    [anon_sym_fixed] = ACTIONS(3533),
    [anon_sym_internal] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_override] = ACTIONS(3533),
    [anon_sym_partial] = ACTIONS(3533),
    [anon_sym_private] = ACTIONS(3533),
    [anon_sym_protected] = ACTIONS(3533),
    [anon_sym_public] = ACTIONS(3533),
    [anon_sym_readonly] = ACTIONS(3533),
    [anon_sym_required] = ACTIONS(3533),
    [anon_sym_sealed] = ACTIONS(3533),
    [anon_sym_virtual] = ACTIONS(3533),
    [anon_sym_volatile] = ACTIONS(3533),
    [anon_sym_where] = ACTIONS(3533),
    [anon_sym_notnull] = ACTIONS(3533),
    [anon_sym_unmanaged] = ACTIONS(3533),
    [anon_sym_checked] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_PLUS_PLUS] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3535),
    [anon_sym_true] = ACTIONS(3533),
    [anon_sym_false] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_this] = ACTIONS(3533),
    [anon_sym_scoped] = ACTIONS(3533),
    [anon_sym_base] = ACTIONS(3533),
    [anon_sym_var] = ACTIONS(3533),
    [sym_predefined_type] = ACTIONS(3533),
    [anon_sym_break] = ACTIONS(3533),
    [anon_sym_unchecked] = ACTIONS(3533),
    [anon_sym_continue] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_lock] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_switch] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3533),
    [anon_sym_throw] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_when] = ACTIONS(3533),
    [anon_sym_await] = ACTIONS(3533),
    [anon_sym_foreach] = ACTIONS(3533),
    [anon_sym_goto] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_DOT_DOT] = ACTIONS(3535),
    [anon_sym_from] = ACTIONS(3533),
    [anon_sym_into] = ACTIONS(3533),
    [anon_sym_join] = ACTIONS(3533),
    [anon_sym_on] = ACTIONS(3533),
    [anon_sym_equals] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_orderby] = ACTIONS(3533),
    [anon_sym_ascending] = ACTIONS(3533),
    [anon_sym_descending] = ACTIONS(3533),
    [anon_sym_group] = ACTIONS(3533),
    [anon_sym_by] = ACTIONS(3533),
    [anon_sym_select] = ACTIONS(3533),
    [anon_sym_stackalloc] = ACTIONS(3533),
    [anon_sym_sizeof] = ACTIONS(3533),
    [anon_sym_typeof] = ACTIONS(3533),
    [anon_sym___makeref] = ACTIONS(3533),
    [anon_sym___reftype] = ACTIONS(3533),
    [anon_sym___refvalue] = ACTIONS(3533),
    [sym_null_literal] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3535),
    [sym_integer_literal] = ACTIONS(3533),
    [sym_real_literal] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [sym_verbatim_string_literal] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3535),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3535),
    [sym_interpolation_verbatim_start] = ACTIONS(3535),
    [sym_interpolation_raw_start] = ACTIONS(3535),
    [sym_raw_string_start] = ACTIONS(3535),
  },
  [2159] = {
    [sym_preproc_region] = STATE(2159),
    [sym_preproc_endregion] = STATE(2159),
    [sym_preproc_line] = STATE(2159),
    [sym_preproc_pragma] = STATE(2159),
    [sym_preproc_nullable] = STATE(2159),
    [sym_preproc_error] = STATE(2159),
    [sym_preproc_warning] = STATE(2159),
    [sym_preproc_define] = STATE(2159),
    [sym_preproc_undef] = STATE(2159),
    [sym__identifier_token] = ACTIONS(3537),
    [anon_sym_extern] = ACTIONS(3537),
    [anon_sym_alias] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_global] = ACTIONS(3537),
    [anon_sym_using] = ACTIONS(3537),
    [anon_sym_unsafe] = ACTIONS(3537),
    [anon_sym_static] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3537),
    [anon_sym_ref] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_delegate] = ACTIONS(3537),
    [anon_sym_abstract] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3537),
    [anon_sym_const] = ACTIONS(3537),
    [anon_sym_file] = ACTIONS(3537),
    [anon_sym_fixed] = ACTIONS(3537),
    [anon_sym_internal] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3537),
    [anon_sym_override] = ACTIONS(3537),
    [anon_sym_partial] = ACTIONS(3537),
    [anon_sym_private] = ACTIONS(3537),
    [anon_sym_protected] = ACTIONS(3537),
    [anon_sym_public] = ACTIONS(3537),
    [anon_sym_readonly] = ACTIONS(3537),
    [anon_sym_required] = ACTIONS(3537),
    [anon_sym_sealed] = ACTIONS(3537),
    [anon_sym_virtual] = ACTIONS(3537),
    [anon_sym_volatile] = ACTIONS(3537),
    [anon_sym_where] = ACTIONS(3537),
    [anon_sym_notnull] = ACTIONS(3537),
    [anon_sym_unmanaged] = ACTIONS(3537),
    [anon_sym_checked] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_true] = ACTIONS(3537),
    [anon_sym_false] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_this] = ACTIONS(3537),
    [anon_sym_scoped] = ACTIONS(3537),
    [anon_sym_base] = ACTIONS(3537),
    [anon_sym_var] = ACTIONS(3537),
    [sym_predefined_type] = ACTIONS(3537),
    [anon_sym_break] = ACTIONS(3537),
    [anon_sym_unchecked] = ACTIONS(3537),
    [anon_sym_continue] = ACTIONS(3537),
    [anon_sym_do] = ACTIONS(3537),
    [anon_sym_while] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3537),
    [anon_sym_lock] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3537),
    [anon_sym_switch] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3537),
    [anon_sym_throw] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3537),
    [anon_sym_when] = ACTIONS(3537),
    [anon_sym_await] = ACTIONS(3537),
    [anon_sym_foreach] = ACTIONS(3537),
    [anon_sym_goto] = ACTIONS(3537),
    [anon_sym_if] = ACTIONS(3537),
    [anon_sym_DOT_DOT] = ACTIONS(3539),
    [anon_sym_from] = ACTIONS(3537),
    [anon_sym_into] = ACTIONS(3537),
    [anon_sym_join] = ACTIONS(3537),
    [anon_sym_on] = ACTIONS(3537),
    [anon_sym_equals] = ACTIONS(3537),
    [anon_sym_let] = ACTIONS(3537),
    [anon_sym_orderby] = ACTIONS(3537),
    [anon_sym_ascending] = ACTIONS(3537),
    [anon_sym_descending] = ACTIONS(3537),
    [anon_sym_group] = ACTIONS(3537),
    [anon_sym_by] = ACTIONS(3537),
    [anon_sym_select] = ACTIONS(3537),
    [anon_sym_stackalloc] = ACTIONS(3537),
    [anon_sym_sizeof] = ACTIONS(3537),
    [anon_sym_typeof] = ACTIONS(3537),
    [anon_sym___makeref] = ACTIONS(3537),
    [anon_sym___reftype] = ACTIONS(3537),
    [anon_sym___refvalue] = ACTIONS(3537),
    [sym_null_literal] = ACTIONS(3537),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [sym_integer_literal] = ACTIONS(3537),
    [sym_real_literal] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [sym_verbatim_string_literal] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3539),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3539),
    [sym_interpolation_verbatim_start] = ACTIONS(3539),
    [sym_interpolation_raw_start] = ACTIONS(3539),
    [sym_raw_string_start] = ACTIONS(3539),
  },
  [2160] = {
    [sym_preproc_region] = STATE(2160),
    [sym_preproc_endregion] = STATE(2160),
    [sym_preproc_line] = STATE(2160),
    [sym_preproc_pragma] = STATE(2160),
    [sym_preproc_nullable] = STATE(2160),
    [sym_preproc_error] = STATE(2160),
    [sym_preproc_warning] = STATE(2160),
    [sym_preproc_define] = STATE(2160),
    [sym_preproc_undef] = STATE(2160),
    [sym__identifier_token] = ACTIONS(3541),
    [anon_sym_extern] = ACTIONS(3541),
    [anon_sym_alias] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3543),
    [anon_sym_global] = ACTIONS(3541),
    [anon_sym_using] = ACTIONS(3541),
    [anon_sym_unsafe] = ACTIONS(3541),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3541),
    [anon_sym_ref] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_delegate] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_file] = ACTIONS(3541),
    [anon_sym_fixed] = ACTIONS(3541),
    [anon_sym_internal] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_override] = ACTIONS(3541),
    [anon_sym_partial] = ACTIONS(3541),
    [anon_sym_private] = ACTIONS(3541),
    [anon_sym_protected] = ACTIONS(3541),
    [anon_sym_public] = ACTIONS(3541),
    [anon_sym_readonly] = ACTIONS(3541),
    [anon_sym_required] = ACTIONS(3541),
    [anon_sym_sealed] = ACTIONS(3541),
    [anon_sym_virtual] = ACTIONS(3541),
    [anon_sym_volatile] = ACTIONS(3541),
    [anon_sym_where] = ACTIONS(3541),
    [anon_sym_notnull] = ACTIONS(3541),
    [anon_sym_unmanaged] = ACTIONS(3541),
    [anon_sym_checked] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_PLUS_PLUS] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3543),
    [anon_sym_true] = ACTIONS(3541),
    [anon_sym_false] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_this] = ACTIONS(3541),
    [anon_sym_scoped] = ACTIONS(3541),
    [anon_sym_base] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3541),
    [sym_predefined_type] = ACTIONS(3541),
    [anon_sym_break] = ACTIONS(3541),
    [anon_sym_unchecked] = ACTIONS(3541),
    [anon_sym_continue] = ACTIONS(3541),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_while] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3541),
    [anon_sym_lock] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3541),
    [anon_sym_switch] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3541),
    [anon_sym_throw] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3541),
    [anon_sym_when] = ACTIONS(3541),
    [anon_sym_await] = ACTIONS(3541),
    [anon_sym_foreach] = ACTIONS(3541),
    [anon_sym_goto] = ACTIONS(3541),
    [anon_sym_if] = ACTIONS(3541),
    [anon_sym_DOT_DOT] = ACTIONS(3543),
    [anon_sym_from] = ACTIONS(3541),
    [anon_sym_into] = ACTIONS(3541),
    [anon_sym_join] = ACTIONS(3541),
    [anon_sym_on] = ACTIONS(3541),
    [anon_sym_equals] = ACTIONS(3541),
    [anon_sym_let] = ACTIONS(3541),
    [anon_sym_orderby] = ACTIONS(3541),
    [anon_sym_ascending] = ACTIONS(3541),
    [anon_sym_descending] = ACTIONS(3541),
    [anon_sym_group] = ACTIONS(3541),
    [anon_sym_by] = ACTIONS(3541),
    [anon_sym_select] = ACTIONS(3541),
    [anon_sym_stackalloc] = ACTIONS(3541),
    [anon_sym_sizeof] = ACTIONS(3541),
    [anon_sym_typeof] = ACTIONS(3541),
    [anon_sym___makeref] = ACTIONS(3541),
    [anon_sym___reftype] = ACTIONS(3541),
    [anon_sym___refvalue] = ACTIONS(3541),
    [sym_null_literal] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3543),
    [sym_integer_literal] = ACTIONS(3541),
    [sym_real_literal] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [sym_verbatim_string_literal] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3543),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3543),
    [sym_interpolation_verbatim_start] = ACTIONS(3543),
    [sym_interpolation_raw_start] = ACTIONS(3543),
    [sym_raw_string_start] = ACTIONS(3543),
  },
  [2161] = {
    [sym_preproc_region] = STATE(2161),
    [sym_preproc_endregion] = STATE(2161),
    [sym_preproc_line] = STATE(2161),
    [sym_preproc_pragma] = STATE(2161),
    [sym_preproc_nullable] = STATE(2161),
    [sym_preproc_error] = STATE(2161),
    [sym_preproc_warning] = STATE(2161),
    [sym_preproc_define] = STATE(2161),
    [sym_preproc_undef] = STATE(2161),
    [sym__identifier_token] = ACTIONS(3545),
    [anon_sym_extern] = ACTIONS(3545),
    [anon_sym_alias] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3547),
    [anon_sym_global] = ACTIONS(3545),
    [anon_sym_using] = ACTIONS(3545),
    [anon_sym_unsafe] = ACTIONS(3545),
    [anon_sym_static] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3545),
    [anon_sym_ref] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_delegate] = ACTIONS(3545),
    [anon_sym_abstract] = ACTIONS(3545),
    [anon_sym_async] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3545),
    [anon_sym_file] = ACTIONS(3545),
    [anon_sym_fixed] = ACTIONS(3545),
    [anon_sym_internal] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3545),
    [anon_sym_override] = ACTIONS(3545),
    [anon_sym_partial] = ACTIONS(3545),
    [anon_sym_private] = ACTIONS(3545),
    [anon_sym_protected] = ACTIONS(3545),
    [anon_sym_public] = ACTIONS(3545),
    [anon_sym_readonly] = ACTIONS(3545),
    [anon_sym_required] = ACTIONS(3545),
    [anon_sym_sealed] = ACTIONS(3545),
    [anon_sym_virtual] = ACTIONS(3545),
    [anon_sym_volatile] = ACTIONS(3545),
    [anon_sym_where] = ACTIONS(3545),
    [anon_sym_notnull] = ACTIONS(3545),
    [anon_sym_unmanaged] = ACTIONS(3545),
    [anon_sym_checked] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3547),
    [anon_sym_PLUS_PLUS] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3547),
    [anon_sym_true] = ACTIONS(3545),
    [anon_sym_false] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_this] = ACTIONS(3545),
    [anon_sym_scoped] = ACTIONS(3545),
    [anon_sym_base] = ACTIONS(3545),
    [anon_sym_var] = ACTIONS(3545),
    [sym_predefined_type] = ACTIONS(3545),
    [anon_sym_break] = ACTIONS(3545),
    [anon_sym_unchecked] = ACTIONS(3545),
    [anon_sym_continue] = ACTIONS(3545),
    [anon_sym_do] = ACTIONS(3545),
    [anon_sym_while] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3545),
    [anon_sym_lock] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3545),
    [anon_sym_switch] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3545),
    [anon_sym_throw] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3545),
    [anon_sym_when] = ACTIONS(3545),
    [anon_sym_await] = ACTIONS(3545),
    [anon_sym_foreach] = ACTIONS(3545),
    [anon_sym_goto] = ACTIONS(3545),
    [anon_sym_if] = ACTIONS(3545),
    [anon_sym_DOT_DOT] = ACTIONS(3547),
    [anon_sym_from] = ACTIONS(3545),
    [anon_sym_into] = ACTIONS(3545),
    [anon_sym_join] = ACTIONS(3545),
    [anon_sym_on] = ACTIONS(3545),
    [anon_sym_equals] = ACTIONS(3545),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_orderby] = ACTIONS(3545),
    [anon_sym_ascending] = ACTIONS(3545),
    [anon_sym_descending] = ACTIONS(3545),
    [anon_sym_group] = ACTIONS(3545),
    [anon_sym_by] = ACTIONS(3545),
    [anon_sym_select] = ACTIONS(3545),
    [anon_sym_stackalloc] = ACTIONS(3545),
    [anon_sym_sizeof] = ACTIONS(3545),
    [anon_sym_typeof] = ACTIONS(3545),
    [anon_sym___makeref] = ACTIONS(3545),
    [anon_sym___reftype] = ACTIONS(3545),
    [anon_sym___refvalue] = ACTIONS(3545),
    [sym_null_literal] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [sym_integer_literal] = ACTIONS(3545),
    [sym_real_literal] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [sym_verbatim_string_literal] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3547),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3547),
    [sym_interpolation_verbatim_start] = ACTIONS(3547),
    [sym_interpolation_raw_start] = ACTIONS(3547),
    [sym_raw_string_start] = ACTIONS(3547),
  },
  [2162] = {
    [sym_preproc_region] = STATE(2162),
    [sym_preproc_endregion] = STATE(2162),
    [sym_preproc_line] = STATE(2162),
    [sym_preproc_pragma] = STATE(2162),
    [sym_preproc_nullable] = STATE(2162),
    [sym_preproc_error] = STATE(2162),
    [sym_preproc_warning] = STATE(2162),
    [sym_preproc_define] = STATE(2162),
    [sym_preproc_undef] = STATE(2162),
    [sym__identifier_token] = ACTIONS(3549),
    [anon_sym_extern] = ACTIONS(3549),
    [anon_sym_alias] = ACTIONS(3549),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3549),
    [anon_sym_using] = ACTIONS(3549),
    [anon_sym_unsafe] = ACTIONS(3549),
    [anon_sym_static] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_ref] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_delegate] = ACTIONS(3549),
    [anon_sym_abstract] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3549),
    [anon_sym_file] = ACTIONS(3549),
    [anon_sym_fixed] = ACTIONS(3549),
    [anon_sym_internal] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3549),
    [anon_sym_override] = ACTIONS(3549),
    [anon_sym_partial] = ACTIONS(3549),
    [anon_sym_private] = ACTIONS(3549),
    [anon_sym_protected] = ACTIONS(3549),
    [anon_sym_public] = ACTIONS(3549),
    [anon_sym_readonly] = ACTIONS(3549),
    [anon_sym_required] = ACTIONS(3549),
    [anon_sym_sealed] = ACTIONS(3549),
    [anon_sym_virtual] = ACTIONS(3549),
    [anon_sym_volatile] = ACTIONS(3549),
    [anon_sym_where] = ACTIONS(3549),
    [anon_sym_notnull] = ACTIONS(3549),
    [anon_sym_unmanaged] = ACTIONS(3549),
    [anon_sym_checked] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_PLUS_PLUS] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3551),
    [anon_sym_true] = ACTIONS(3549),
    [anon_sym_false] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_this] = ACTIONS(3549),
    [anon_sym_scoped] = ACTIONS(3549),
    [anon_sym_base] = ACTIONS(3549),
    [anon_sym_var] = ACTIONS(3549),
    [sym_predefined_type] = ACTIONS(3549),
    [anon_sym_break] = ACTIONS(3549),
    [anon_sym_unchecked] = ACTIONS(3549),
    [anon_sym_continue] = ACTIONS(3549),
    [anon_sym_do] = ACTIONS(3549),
    [anon_sym_while] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3549),
    [anon_sym_lock] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3549),
    [anon_sym_switch] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3549),
    [anon_sym_throw] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3549),
    [anon_sym_when] = ACTIONS(3549),
    [anon_sym_await] = ACTIONS(3549),
    [anon_sym_foreach] = ACTIONS(3549),
    [anon_sym_goto] = ACTIONS(3549),
    [anon_sym_if] = ACTIONS(3549),
    [anon_sym_DOT_DOT] = ACTIONS(3551),
    [anon_sym_from] = ACTIONS(3549),
    [anon_sym_into] = ACTIONS(3549),
    [anon_sym_join] = ACTIONS(3549),
    [anon_sym_on] = ACTIONS(3549),
    [anon_sym_equals] = ACTIONS(3549),
    [anon_sym_let] = ACTIONS(3549),
    [anon_sym_orderby] = ACTIONS(3549),
    [anon_sym_ascending] = ACTIONS(3549),
    [anon_sym_descending] = ACTIONS(3549),
    [anon_sym_group] = ACTIONS(3549),
    [anon_sym_by] = ACTIONS(3549),
    [anon_sym_select] = ACTIONS(3549),
    [anon_sym_stackalloc] = ACTIONS(3549),
    [anon_sym_sizeof] = ACTIONS(3549),
    [anon_sym_typeof] = ACTIONS(3549),
    [anon_sym___makeref] = ACTIONS(3549),
    [anon_sym___reftype] = ACTIONS(3549),
    [anon_sym___refvalue] = ACTIONS(3549),
    [sym_null_literal] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(3551),
    [sym_integer_literal] = ACTIONS(3549),
    [sym_real_literal] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_verbatim_string_literal] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3551),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3551),
    [sym_interpolation_verbatim_start] = ACTIONS(3551),
    [sym_interpolation_raw_start] = ACTIONS(3551),
    [sym_raw_string_start] = ACTIONS(3551),
  },
  [2163] = {
    [sym_preproc_region] = STATE(2163),
    [sym_preproc_endregion] = STATE(2163),
    [sym_preproc_line] = STATE(2163),
    [sym_preproc_pragma] = STATE(2163),
    [sym_preproc_nullable] = STATE(2163),
    [sym_preproc_error] = STATE(2163),
    [sym_preproc_warning] = STATE(2163),
    [sym_preproc_define] = STATE(2163),
    [sym_preproc_undef] = STATE(2163),
    [sym__identifier_token] = ACTIONS(3553),
    [anon_sym_extern] = ACTIONS(3553),
    [anon_sym_alias] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3555),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_using] = ACTIONS(3553),
    [anon_sym_unsafe] = ACTIONS(3553),
    [anon_sym_static] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3553),
    [anon_sym_ref] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_delegate] = ACTIONS(3553),
    [anon_sym_abstract] = ACTIONS(3553),
    [anon_sym_async] = ACTIONS(3553),
    [anon_sym_const] = ACTIONS(3553),
    [anon_sym_file] = ACTIONS(3553),
    [anon_sym_fixed] = ACTIONS(3553),
    [anon_sym_internal] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3553),
    [anon_sym_override] = ACTIONS(3553),
    [anon_sym_partial] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3553),
    [anon_sym_protected] = ACTIONS(3553),
    [anon_sym_public] = ACTIONS(3553),
    [anon_sym_readonly] = ACTIONS(3553),
    [anon_sym_required] = ACTIONS(3553),
    [anon_sym_sealed] = ACTIONS(3553),
    [anon_sym_virtual] = ACTIONS(3553),
    [anon_sym_volatile] = ACTIONS(3553),
    [anon_sym_where] = ACTIONS(3553),
    [anon_sym_notnull] = ACTIONS(3553),
    [anon_sym_unmanaged] = ACTIONS(3553),
    [anon_sym_checked] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_PLUS_PLUS] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3555),
    [anon_sym_true] = ACTIONS(3553),
    [anon_sym_false] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3553),
    [anon_sym_STAR] = ACTIONS(3555),
    [anon_sym_CARET] = ACTIONS(3555),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_this] = ACTIONS(3553),
    [anon_sym_scoped] = ACTIONS(3553),
    [anon_sym_base] = ACTIONS(3553),
    [anon_sym_var] = ACTIONS(3553),
    [sym_predefined_type] = ACTIONS(3553),
    [anon_sym_break] = ACTIONS(3553),
    [anon_sym_unchecked] = ACTIONS(3553),
    [anon_sym_continue] = ACTIONS(3553),
    [anon_sym_do] = ACTIONS(3553),
    [anon_sym_while] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3553),
    [anon_sym_lock] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3553),
    [anon_sym_switch] = ACTIONS(3553),
    [anon_sym_default] = ACTIONS(3553),
    [anon_sym_throw] = ACTIONS(3553),
    [anon_sym_try] = ACTIONS(3553),
    [anon_sym_when] = ACTIONS(3553),
    [anon_sym_await] = ACTIONS(3553),
    [anon_sym_foreach] = ACTIONS(3553),
    [anon_sym_goto] = ACTIONS(3553),
    [anon_sym_if] = ACTIONS(3553),
    [anon_sym_DOT_DOT] = ACTIONS(3555),
    [anon_sym_from] = ACTIONS(3553),
    [anon_sym_into] = ACTIONS(3553),
    [anon_sym_join] = ACTIONS(3553),
    [anon_sym_on] = ACTIONS(3553),
    [anon_sym_equals] = ACTIONS(3553),
    [anon_sym_let] = ACTIONS(3553),
    [anon_sym_orderby] = ACTIONS(3553),
    [anon_sym_ascending] = ACTIONS(3553),
    [anon_sym_descending] = ACTIONS(3553),
    [anon_sym_group] = ACTIONS(3553),
    [anon_sym_by] = ACTIONS(3553),
    [anon_sym_select] = ACTIONS(3553),
    [anon_sym_stackalloc] = ACTIONS(3553),
    [anon_sym_sizeof] = ACTIONS(3553),
    [anon_sym_typeof] = ACTIONS(3553),
    [anon_sym___makeref] = ACTIONS(3553),
    [anon_sym___reftype] = ACTIONS(3553),
    [anon_sym___refvalue] = ACTIONS(3553),
    [sym_null_literal] = ACTIONS(3553),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [sym_integer_literal] = ACTIONS(3553),
    [sym_real_literal] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [sym_verbatim_string_literal] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3555),
    [sym_interpolation_verbatim_start] = ACTIONS(3555),
    [sym_interpolation_raw_start] = ACTIONS(3555),
    [sym_raw_string_start] = ACTIONS(3555),
  },
  [2164] = {
    [sym_preproc_region] = STATE(2164),
    [sym_preproc_endregion] = STATE(2164),
    [sym_preproc_line] = STATE(2164),
    [sym_preproc_pragma] = STATE(2164),
    [sym_preproc_nullable] = STATE(2164),
    [sym_preproc_error] = STATE(2164),
    [sym_preproc_warning] = STATE(2164),
    [sym_preproc_define] = STATE(2164),
    [sym_preproc_undef] = STATE(2164),
    [sym__identifier_token] = ACTIONS(3557),
    [anon_sym_extern] = ACTIONS(3557),
    [anon_sym_alias] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_global] = ACTIONS(3557),
    [anon_sym_using] = ACTIONS(3557),
    [anon_sym_unsafe] = ACTIONS(3557),
    [anon_sym_static] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_LPAREN] = ACTIONS(3559),
    [anon_sym_return] = ACTIONS(3557),
    [anon_sym_ref] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(3559),
    [anon_sym_delegate] = ACTIONS(3557),
    [anon_sym_abstract] = ACTIONS(3557),
    [anon_sym_async] = ACTIONS(3557),
    [anon_sym_const] = ACTIONS(3557),
    [anon_sym_file] = ACTIONS(3557),
    [anon_sym_fixed] = ACTIONS(3557),
    [anon_sym_internal] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3557),
    [anon_sym_override] = ACTIONS(3557),
    [anon_sym_partial] = ACTIONS(3557),
    [anon_sym_private] = ACTIONS(3557),
    [anon_sym_protected] = ACTIONS(3557),
    [anon_sym_public] = ACTIONS(3557),
    [anon_sym_readonly] = ACTIONS(3557),
    [anon_sym_required] = ACTIONS(3557),
    [anon_sym_sealed] = ACTIONS(3557),
    [anon_sym_virtual] = ACTIONS(3557),
    [anon_sym_volatile] = ACTIONS(3557),
    [anon_sym_where] = ACTIONS(3557),
    [anon_sym_notnull] = ACTIONS(3557),
    [anon_sym_unmanaged] = ACTIONS(3557),
    [anon_sym_checked] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_PLUS_PLUS] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3559),
    [anon_sym_true] = ACTIONS(3557),
    [anon_sym_false] = ACTIONS(3557),
    [anon_sym_PLUS] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3559),
    [anon_sym_CARET] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3559),
    [anon_sym_this] = ACTIONS(3557),
    [anon_sym_scoped] = ACTIONS(3557),
    [anon_sym_base] = ACTIONS(3557),
    [anon_sym_var] = ACTIONS(3557),
    [sym_predefined_type] = ACTIONS(3557),
    [anon_sym_break] = ACTIONS(3557),
    [anon_sym_unchecked] = ACTIONS(3557),
    [anon_sym_continue] = ACTIONS(3557),
    [anon_sym_do] = ACTIONS(3557),
    [anon_sym_while] = ACTIONS(3557),
    [anon_sym_for] = ACTIONS(3557),
    [anon_sym_lock] = ACTIONS(3557),
    [anon_sym_yield] = ACTIONS(3557),
    [anon_sym_switch] = ACTIONS(3557),
    [anon_sym_default] = ACTIONS(3557),
    [anon_sym_throw] = ACTIONS(3557),
    [anon_sym_try] = ACTIONS(3557),
    [anon_sym_when] = ACTIONS(3557),
    [anon_sym_await] = ACTIONS(3557),
    [anon_sym_foreach] = ACTIONS(3557),
    [anon_sym_goto] = ACTIONS(3557),
    [anon_sym_if] = ACTIONS(3557),
    [anon_sym_DOT_DOT] = ACTIONS(3559),
    [anon_sym_from] = ACTIONS(3557),
    [anon_sym_into] = ACTIONS(3557),
    [anon_sym_join] = ACTIONS(3557),
    [anon_sym_on] = ACTIONS(3557),
    [anon_sym_equals] = ACTIONS(3557),
    [anon_sym_let] = ACTIONS(3557),
    [anon_sym_orderby] = ACTIONS(3557),
    [anon_sym_ascending] = ACTIONS(3557),
    [anon_sym_descending] = ACTIONS(3557),
    [anon_sym_group] = ACTIONS(3557),
    [anon_sym_by] = ACTIONS(3557),
    [anon_sym_select] = ACTIONS(3557),
    [anon_sym_stackalloc] = ACTIONS(3557),
    [anon_sym_sizeof] = ACTIONS(3557),
    [anon_sym_typeof] = ACTIONS(3557),
    [anon_sym___makeref] = ACTIONS(3557),
    [anon_sym___reftype] = ACTIONS(3557),
    [anon_sym___refvalue] = ACTIONS(3557),
    [sym_null_literal] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3559),
    [sym_integer_literal] = ACTIONS(3557),
    [sym_real_literal] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(3559),
    [sym_verbatim_string_literal] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3559),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3559),
    [sym_interpolation_verbatim_start] = ACTIONS(3559),
    [sym_interpolation_raw_start] = ACTIONS(3559),
    [sym_raw_string_start] = ACTIONS(3559),
  },
  [2165] = {
    [sym_preproc_region] = STATE(2165),
    [sym_preproc_endregion] = STATE(2165),
    [sym_preproc_line] = STATE(2165),
    [sym_preproc_pragma] = STATE(2165),
    [sym_preproc_nullable] = STATE(2165),
    [sym_preproc_error] = STATE(2165),
    [sym_preproc_warning] = STATE(2165),
    [sym_preproc_define] = STATE(2165),
    [sym_preproc_undef] = STATE(2165),
    [sym__identifier_token] = ACTIONS(3561),
    [anon_sym_extern] = ACTIONS(3561),
    [anon_sym_alias] = ACTIONS(3561),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_global] = ACTIONS(3561),
    [anon_sym_using] = ACTIONS(3561),
    [anon_sym_unsafe] = ACTIONS(3561),
    [anon_sym_static] = ACTIONS(3561),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_return] = ACTIONS(3561),
    [anon_sym_ref] = ACTIONS(3561),
    [anon_sym_LBRACE] = ACTIONS(3563),
    [anon_sym_delegate] = ACTIONS(3561),
    [anon_sym_abstract] = ACTIONS(3561),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_const] = ACTIONS(3561),
    [anon_sym_file] = ACTIONS(3561),
    [anon_sym_fixed] = ACTIONS(3561),
    [anon_sym_internal] = ACTIONS(3561),
    [anon_sym_new] = ACTIONS(3561),
    [anon_sym_override] = ACTIONS(3561),
    [anon_sym_partial] = ACTIONS(3561),
    [anon_sym_private] = ACTIONS(3561),
    [anon_sym_protected] = ACTIONS(3561),
    [anon_sym_public] = ACTIONS(3561),
    [anon_sym_readonly] = ACTIONS(3561),
    [anon_sym_required] = ACTIONS(3561),
    [anon_sym_sealed] = ACTIONS(3561),
    [anon_sym_virtual] = ACTIONS(3561),
    [anon_sym_volatile] = ACTIONS(3561),
    [anon_sym_where] = ACTIONS(3561),
    [anon_sym_notnull] = ACTIONS(3561),
    [anon_sym_unmanaged] = ACTIONS(3561),
    [anon_sym_checked] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3563),
    [anon_sym_TILDE] = ACTIONS(3563),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [anon_sym_true] = ACTIONS(3561),
    [anon_sym_false] = ACTIONS(3561),
    [anon_sym_PLUS] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3561),
    [anon_sym_STAR] = ACTIONS(3563),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(3561),
    [anon_sym_scoped] = ACTIONS(3561),
    [anon_sym_base] = ACTIONS(3561),
    [anon_sym_var] = ACTIONS(3561),
    [sym_predefined_type] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3561),
    [anon_sym_unchecked] = ACTIONS(3561),
    [anon_sym_continue] = ACTIONS(3561),
    [anon_sym_do] = ACTIONS(3561),
    [anon_sym_while] = ACTIONS(3561),
    [anon_sym_for] = ACTIONS(3561),
    [anon_sym_lock] = ACTIONS(3561),
    [anon_sym_yield] = ACTIONS(3561),
    [anon_sym_switch] = ACTIONS(3561),
    [anon_sym_default] = ACTIONS(3561),
    [anon_sym_throw] = ACTIONS(3561),
    [anon_sym_try] = ACTIONS(3561),
    [anon_sym_when] = ACTIONS(3561),
    [anon_sym_await] = ACTIONS(3561),
    [anon_sym_foreach] = ACTIONS(3561),
    [anon_sym_goto] = ACTIONS(3561),
    [anon_sym_if] = ACTIONS(3561),
    [anon_sym_DOT_DOT] = ACTIONS(3563),
    [anon_sym_from] = ACTIONS(3561),
    [anon_sym_into] = ACTIONS(3561),
    [anon_sym_join] = ACTIONS(3561),
    [anon_sym_on] = ACTIONS(3561),
    [anon_sym_equals] = ACTIONS(3561),
    [anon_sym_let] = ACTIONS(3561),
    [anon_sym_orderby] = ACTIONS(3561),
    [anon_sym_ascending] = ACTIONS(3561),
    [anon_sym_descending] = ACTIONS(3561),
    [anon_sym_group] = ACTIONS(3561),
    [anon_sym_by] = ACTIONS(3561),
    [anon_sym_select] = ACTIONS(3561),
    [anon_sym_stackalloc] = ACTIONS(3561),
    [anon_sym_sizeof] = ACTIONS(3561),
    [anon_sym_typeof] = ACTIONS(3561),
    [anon_sym___makeref] = ACTIONS(3561),
    [anon_sym___reftype] = ACTIONS(3561),
    [anon_sym___refvalue] = ACTIONS(3561),
    [sym_null_literal] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3563),
    [sym_integer_literal] = ACTIONS(3561),
    [sym_real_literal] = ACTIONS(3563),
    [anon_sym_DQUOTE] = ACTIONS(3563),
    [sym_verbatim_string_literal] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3563),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3563),
    [sym_interpolation_verbatim_start] = ACTIONS(3563),
    [sym_interpolation_raw_start] = ACTIONS(3563),
    [sym_raw_string_start] = ACTIONS(3563),
  },
  [2166] = {
    [sym_preproc_region] = STATE(2166),
    [sym_preproc_endregion] = STATE(2166),
    [sym_preproc_line] = STATE(2166),
    [sym_preproc_pragma] = STATE(2166),
    [sym_preproc_nullable] = STATE(2166),
    [sym_preproc_error] = STATE(2166),
    [sym_preproc_warning] = STATE(2166),
    [sym_preproc_define] = STATE(2166),
    [sym_preproc_undef] = STATE(2166),
    [sym__identifier_token] = ACTIONS(3565),
    [anon_sym_extern] = ACTIONS(3565),
    [anon_sym_alias] = ACTIONS(3565),
    [anon_sym_SEMI] = ACTIONS(3567),
    [anon_sym_global] = ACTIONS(3565),
    [anon_sym_using] = ACTIONS(3565),
    [anon_sym_unsafe] = ACTIONS(3565),
    [anon_sym_static] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [anon_sym_LPAREN] = ACTIONS(3567),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_ref] = ACTIONS(3565),
    [anon_sym_LBRACE] = ACTIONS(3567),
    [anon_sym_delegate] = ACTIONS(3565),
    [anon_sym_abstract] = ACTIONS(3565),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_const] = ACTIONS(3565),
    [anon_sym_file] = ACTIONS(3565),
    [anon_sym_fixed] = ACTIONS(3565),
    [anon_sym_internal] = ACTIONS(3565),
    [anon_sym_new] = ACTIONS(3565),
    [anon_sym_override] = ACTIONS(3565),
    [anon_sym_partial] = ACTIONS(3565),
    [anon_sym_private] = ACTIONS(3565),
    [anon_sym_protected] = ACTIONS(3565),
    [anon_sym_public] = ACTIONS(3565),
    [anon_sym_readonly] = ACTIONS(3565),
    [anon_sym_required] = ACTIONS(3565),
    [anon_sym_sealed] = ACTIONS(3565),
    [anon_sym_virtual] = ACTIONS(3565),
    [anon_sym_volatile] = ACTIONS(3565),
    [anon_sym_where] = ACTIONS(3565),
    [anon_sym_notnull] = ACTIONS(3565),
    [anon_sym_unmanaged] = ACTIONS(3565),
    [anon_sym_checked] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3567),
    [anon_sym_TILDE] = ACTIONS(3567),
    [anon_sym_PLUS_PLUS] = ACTIONS(3567),
    [anon_sym_DASH_DASH] = ACTIONS(3567),
    [anon_sym_true] = ACTIONS(3565),
    [anon_sym_false] = ACTIONS(3565),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_STAR] = ACTIONS(3567),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3567),
    [anon_sym_this] = ACTIONS(3565),
    [anon_sym_scoped] = ACTIONS(3565),
    [anon_sym_base] = ACTIONS(3565),
    [anon_sym_var] = ACTIONS(3565),
    [sym_predefined_type] = ACTIONS(3565),
    [anon_sym_break] = ACTIONS(3565),
    [anon_sym_unchecked] = ACTIONS(3565),
    [anon_sym_continue] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_lock] = ACTIONS(3565),
    [anon_sym_yield] = ACTIONS(3565),
    [anon_sym_switch] = ACTIONS(3565),
    [anon_sym_default] = ACTIONS(3565),
    [anon_sym_throw] = ACTIONS(3565),
    [anon_sym_try] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_await] = ACTIONS(3565),
    [anon_sym_foreach] = ACTIONS(3565),
    [anon_sym_goto] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_DOT_DOT] = ACTIONS(3567),
    [anon_sym_from] = ACTIONS(3565),
    [anon_sym_into] = ACTIONS(3565),
    [anon_sym_join] = ACTIONS(3565),
    [anon_sym_on] = ACTIONS(3565),
    [anon_sym_equals] = ACTIONS(3565),
    [anon_sym_let] = ACTIONS(3565),
    [anon_sym_orderby] = ACTIONS(3565),
    [anon_sym_ascending] = ACTIONS(3565),
    [anon_sym_descending] = ACTIONS(3565),
    [anon_sym_group] = ACTIONS(3565),
    [anon_sym_by] = ACTIONS(3565),
    [anon_sym_select] = ACTIONS(3565),
    [anon_sym_stackalloc] = ACTIONS(3565),
    [anon_sym_sizeof] = ACTIONS(3565),
    [anon_sym_typeof] = ACTIONS(3565),
    [anon_sym___makeref] = ACTIONS(3565),
    [anon_sym___reftype] = ACTIONS(3565),
    [anon_sym___refvalue] = ACTIONS(3565),
    [sym_null_literal] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3567),
    [sym_integer_literal] = ACTIONS(3565),
    [sym_real_literal] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(3567),
    [sym_verbatim_string_literal] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3567),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3567),
    [sym_interpolation_verbatim_start] = ACTIONS(3567),
    [sym_interpolation_raw_start] = ACTIONS(3567),
    [sym_raw_string_start] = ACTIONS(3567),
  },
  [2167] = {
    [sym_preproc_region] = STATE(2167),
    [sym_preproc_endregion] = STATE(2167),
    [sym_preproc_line] = STATE(2167),
    [sym_preproc_pragma] = STATE(2167),
    [sym_preproc_nullable] = STATE(2167),
    [sym_preproc_error] = STATE(2167),
    [sym_preproc_warning] = STATE(2167),
    [sym_preproc_define] = STATE(2167),
    [sym_preproc_undef] = STATE(2167),
    [sym__identifier_token] = ACTIONS(3569),
    [anon_sym_extern] = ACTIONS(3569),
    [anon_sym_alias] = ACTIONS(3569),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_global] = ACTIONS(3569),
    [anon_sym_using] = ACTIONS(3569),
    [anon_sym_unsafe] = ACTIONS(3569),
    [anon_sym_static] = ACTIONS(3569),
    [anon_sym_LBRACK] = ACTIONS(3571),
    [anon_sym_LPAREN] = ACTIONS(3571),
    [anon_sym_return] = ACTIONS(3569),
    [anon_sym_ref] = ACTIONS(3569),
    [anon_sym_LBRACE] = ACTIONS(3571),
    [anon_sym_delegate] = ACTIONS(3569),
    [anon_sym_abstract] = ACTIONS(3569),
    [anon_sym_async] = ACTIONS(3569),
    [anon_sym_const] = ACTIONS(3569),
    [anon_sym_file] = ACTIONS(3569),
    [anon_sym_fixed] = ACTIONS(3569),
    [anon_sym_internal] = ACTIONS(3569),
    [anon_sym_new] = ACTIONS(3569),
    [anon_sym_override] = ACTIONS(3569),
    [anon_sym_partial] = ACTIONS(3569),
    [anon_sym_private] = ACTIONS(3569),
    [anon_sym_protected] = ACTIONS(3569),
    [anon_sym_public] = ACTIONS(3569),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_required] = ACTIONS(3569),
    [anon_sym_sealed] = ACTIONS(3569),
    [anon_sym_virtual] = ACTIONS(3569),
    [anon_sym_volatile] = ACTIONS(3569),
    [anon_sym_where] = ACTIONS(3569),
    [anon_sym_notnull] = ACTIONS(3569),
    [anon_sym_unmanaged] = ACTIONS(3569),
    [anon_sym_checked] = ACTIONS(3569),
    [anon_sym_BANG] = ACTIONS(3571),
    [anon_sym_TILDE] = ACTIONS(3571),
    [anon_sym_PLUS_PLUS] = ACTIONS(3571),
    [anon_sym_DASH_DASH] = ACTIONS(3571),
    [anon_sym_true] = ACTIONS(3569),
    [anon_sym_false] = ACTIONS(3569),
    [anon_sym_PLUS] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3569),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_CARET] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3571),
    [anon_sym_this] = ACTIONS(3569),
    [anon_sym_scoped] = ACTIONS(3569),
    [anon_sym_base] = ACTIONS(3569),
    [anon_sym_var] = ACTIONS(3569),
    [sym_predefined_type] = ACTIONS(3569),
    [anon_sym_break] = ACTIONS(3569),
    [anon_sym_unchecked] = ACTIONS(3569),
    [anon_sym_continue] = ACTIONS(3569),
    [anon_sym_do] = ACTIONS(3569),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_for] = ACTIONS(3569),
    [anon_sym_lock] = ACTIONS(3569),
    [anon_sym_yield] = ACTIONS(3569),
    [anon_sym_switch] = ACTIONS(3569),
    [anon_sym_default] = ACTIONS(3569),
    [anon_sym_throw] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3569),
    [anon_sym_when] = ACTIONS(3569),
    [anon_sym_await] = ACTIONS(3569),
    [anon_sym_foreach] = ACTIONS(3569),
    [anon_sym_goto] = ACTIONS(3569),
    [anon_sym_if] = ACTIONS(3569),
    [anon_sym_DOT_DOT] = ACTIONS(3571),
    [anon_sym_from] = ACTIONS(3569),
    [anon_sym_into] = ACTIONS(3569),
    [anon_sym_join] = ACTIONS(3569),
    [anon_sym_on] = ACTIONS(3569),
    [anon_sym_equals] = ACTIONS(3569),
    [anon_sym_let] = ACTIONS(3569),
    [anon_sym_orderby] = ACTIONS(3569),
    [anon_sym_ascending] = ACTIONS(3569),
    [anon_sym_descending] = ACTIONS(3569),
    [anon_sym_group] = ACTIONS(3569),
    [anon_sym_by] = ACTIONS(3569),
    [anon_sym_select] = ACTIONS(3569),
    [anon_sym_stackalloc] = ACTIONS(3569),
    [anon_sym_sizeof] = ACTIONS(3569),
    [anon_sym_typeof] = ACTIONS(3569),
    [anon_sym___makeref] = ACTIONS(3569),
    [anon_sym___reftype] = ACTIONS(3569),
    [anon_sym___refvalue] = ACTIONS(3569),
    [sym_null_literal] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(3571),
    [sym_integer_literal] = ACTIONS(3569),
    [sym_real_literal] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(3571),
    [sym_verbatim_string_literal] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3571),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3571),
    [sym_interpolation_verbatim_start] = ACTIONS(3571),
    [sym_interpolation_raw_start] = ACTIONS(3571),
    [sym_raw_string_start] = ACTIONS(3571),
  },
  [2168] = {
    [sym_preproc_region] = STATE(2168),
    [sym_preproc_endregion] = STATE(2168),
    [sym_preproc_line] = STATE(2168),
    [sym_preproc_pragma] = STATE(2168),
    [sym_preproc_nullable] = STATE(2168),
    [sym_preproc_error] = STATE(2168),
    [sym_preproc_warning] = STATE(2168),
    [sym_preproc_define] = STATE(2168),
    [sym_preproc_undef] = STATE(2168),
    [sym__identifier_token] = ACTIONS(3573),
    [anon_sym_extern] = ACTIONS(3573),
    [anon_sym_alias] = ACTIONS(3573),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_global] = ACTIONS(3573),
    [anon_sym_using] = ACTIONS(3573),
    [anon_sym_unsafe] = ACTIONS(3573),
    [anon_sym_static] = ACTIONS(3573),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3573),
    [anon_sym_ref] = ACTIONS(3573),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_delegate] = ACTIONS(3573),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_async] = ACTIONS(3573),
    [anon_sym_const] = ACTIONS(3573),
    [anon_sym_file] = ACTIONS(3573),
    [anon_sym_fixed] = ACTIONS(3573),
    [anon_sym_internal] = ACTIONS(3573),
    [anon_sym_new] = ACTIONS(3573),
    [anon_sym_override] = ACTIONS(3573),
    [anon_sym_partial] = ACTIONS(3573),
    [anon_sym_private] = ACTIONS(3573),
    [anon_sym_protected] = ACTIONS(3573),
    [anon_sym_public] = ACTIONS(3573),
    [anon_sym_readonly] = ACTIONS(3573),
    [anon_sym_required] = ACTIONS(3573),
    [anon_sym_sealed] = ACTIONS(3573),
    [anon_sym_virtual] = ACTIONS(3573),
    [anon_sym_volatile] = ACTIONS(3573),
    [anon_sym_where] = ACTIONS(3573),
    [anon_sym_notnull] = ACTIONS(3573),
    [anon_sym_unmanaged] = ACTIONS(3573),
    [anon_sym_checked] = ACTIONS(3573),
    [anon_sym_BANG] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_PLUS_PLUS] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3575),
    [anon_sym_true] = ACTIONS(3573),
    [anon_sym_false] = ACTIONS(3573),
    [anon_sym_PLUS] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3573),
    [anon_sym_STAR] = ACTIONS(3575),
    [anon_sym_CARET] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3575),
    [anon_sym_this] = ACTIONS(3573),
    [anon_sym_scoped] = ACTIONS(3573),
    [anon_sym_base] = ACTIONS(3573),
    [anon_sym_var] = ACTIONS(3573),
    [sym_predefined_type] = ACTIONS(3573),
    [anon_sym_break] = ACTIONS(3573),
    [anon_sym_unchecked] = ACTIONS(3573),
    [anon_sym_continue] = ACTIONS(3573),
    [anon_sym_do] = ACTIONS(3573),
    [anon_sym_while] = ACTIONS(3573),
    [anon_sym_for] = ACTIONS(3573),
    [anon_sym_lock] = ACTIONS(3573),
    [anon_sym_yield] = ACTIONS(3573),
    [anon_sym_switch] = ACTIONS(3573),
    [anon_sym_default] = ACTIONS(3573),
    [anon_sym_throw] = ACTIONS(3573),
    [anon_sym_try] = ACTIONS(3573),
    [anon_sym_when] = ACTIONS(3573),
    [anon_sym_await] = ACTIONS(3573),
    [anon_sym_foreach] = ACTIONS(3573),
    [anon_sym_goto] = ACTIONS(3573),
    [anon_sym_if] = ACTIONS(3573),
    [anon_sym_DOT_DOT] = ACTIONS(3575),
    [anon_sym_from] = ACTIONS(3573),
    [anon_sym_into] = ACTIONS(3573),
    [anon_sym_join] = ACTIONS(3573),
    [anon_sym_on] = ACTIONS(3573),
    [anon_sym_equals] = ACTIONS(3573),
    [anon_sym_let] = ACTIONS(3573),
    [anon_sym_orderby] = ACTIONS(3573),
    [anon_sym_ascending] = ACTIONS(3573),
    [anon_sym_descending] = ACTIONS(3573),
    [anon_sym_group] = ACTIONS(3573),
    [anon_sym_by] = ACTIONS(3573),
    [anon_sym_select] = ACTIONS(3573),
    [anon_sym_stackalloc] = ACTIONS(3573),
    [anon_sym_sizeof] = ACTIONS(3573),
    [anon_sym_typeof] = ACTIONS(3573),
    [anon_sym___makeref] = ACTIONS(3573),
    [anon_sym___reftype] = ACTIONS(3573),
    [anon_sym___refvalue] = ACTIONS(3573),
    [sym_null_literal] = ACTIONS(3573),
    [anon_sym_SQUOTE] = ACTIONS(3575),
    [sym_integer_literal] = ACTIONS(3573),
    [sym_real_literal] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(3575),
    [sym_verbatim_string_literal] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3575),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3575),
    [sym_interpolation_verbatim_start] = ACTIONS(3575),
    [sym_interpolation_raw_start] = ACTIONS(3575),
    [sym_raw_string_start] = ACTIONS(3575),
  },
  [2169] = {
    [sym_preproc_region] = STATE(2169),
    [sym_preproc_endregion] = STATE(2169),
    [sym_preproc_line] = STATE(2169),
    [sym_preproc_pragma] = STATE(2169),
    [sym_preproc_nullable] = STATE(2169),
    [sym_preproc_error] = STATE(2169),
    [sym_preproc_warning] = STATE(2169),
    [sym_preproc_define] = STATE(2169),
    [sym_preproc_undef] = STATE(2169),
    [sym__identifier_token] = ACTIONS(3577),
    [anon_sym_extern] = ACTIONS(3577),
    [anon_sym_alias] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym_global] = ACTIONS(3577),
    [anon_sym_using] = ACTIONS(3577),
    [anon_sym_unsafe] = ACTIONS(3577),
    [anon_sym_static] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3579),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_ref] = ACTIONS(3577),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_delegate] = ACTIONS(3577),
    [anon_sym_abstract] = ACTIONS(3577),
    [anon_sym_async] = ACTIONS(3577),
    [anon_sym_const] = ACTIONS(3577),
    [anon_sym_file] = ACTIONS(3577),
    [anon_sym_fixed] = ACTIONS(3577),
    [anon_sym_internal] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_override] = ACTIONS(3577),
    [anon_sym_partial] = ACTIONS(3577),
    [anon_sym_private] = ACTIONS(3577),
    [anon_sym_protected] = ACTIONS(3577),
    [anon_sym_public] = ACTIONS(3577),
    [anon_sym_readonly] = ACTIONS(3577),
    [anon_sym_required] = ACTIONS(3577),
    [anon_sym_sealed] = ACTIONS(3577),
    [anon_sym_virtual] = ACTIONS(3577),
    [anon_sym_volatile] = ACTIONS(3577),
    [anon_sym_where] = ACTIONS(3577),
    [anon_sym_notnull] = ACTIONS(3577),
    [anon_sym_unmanaged] = ACTIONS(3577),
    [anon_sym_checked] = ACTIONS(3577),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_true] = ACTIONS(3577),
    [anon_sym_false] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_this] = ACTIONS(3577),
    [anon_sym_scoped] = ACTIONS(3577),
    [anon_sym_base] = ACTIONS(3577),
    [anon_sym_var] = ACTIONS(3577),
    [sym_predefined_type] = ACTIONS(3577),
    [anon_sym_break] = ACTIONS(3577),
    [anon_sym_unchecked] = ACTIONS(3577),
    [anon_sym_continue] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_lock] = ACTIONS(3577),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_switch] = ACTIONS(3577),
    [anon_sym_default] = ACTIONS(3577),
    [anon_sym_throw] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_when] = ACTIONS(3577),
    [anon_sym_await] = ACTIONS(3577),
    [anon_sym_foreach] = ACTIONS(3577),
    [anon_sym_goto] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_DOT_DOT] = ACTIONS(3579),
    [anon_sym_from] = ACTIONS(3577),
    [anon_sym_into] = ACTIONS(3577),
    [anon_sym_join] = ACTIONS(3577),
    [anon_sym_on] = ACTIONS(3577),
    [anon_sym_equals] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_orderby] = ACTIONS(3577),
    [anon_sym_ascending] = ACTIONS(3577),
    [anon_sym_descending] = ACTIONS(3577),
    [anon_sym_group] = ACTIONS(3577),
    [anon_sym_by] = ACTIONS(3577),
    [anon_sym_select] = ACTIONS(3577),
    [anon_sym_stackalloc] = ACTIONS(3577),
    [anon_sym_sizeof] = ACTIONS(3577),
    [anon_sym_typeof] = ACTIONS(3577),
    [anon_sym___makeref] = ACTIONS(3577),
    [anon_sym___reftype] = ACTIONS(3577),
    [anon_sym___refvalue] = ACTIONS(3577),
    [sym_null_literal] = ACTIONS(3577),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [sym_integer_literal] = ACTIONS(3577),
    [sym_real_literal] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_verbatim_string_literal] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3579),
    [sym_interpolation_verbatim_start] = ACTIONS(3579),
    [sym_interpolation_raw_start] = ACTIONS(3579),
    [sym_raw_string_start] = ACTIONS(3579),
  },
  [2170] = {
    [sym_preproc_region] = STATE(2170),
    [sym_preproc_endregion] = STATE(2170),
    [sym_preproc_line] = STATE(2170),
    [sym_preproc_pragma] = STATE(2170),
    [sym_preproc_nullable] = STATE(2170),
    [sym_preproc_error] = STATE(2170),
    [sym_preproc_warning] = STATE(2170),
    [sym_preproc_define] = STATE(2170),
    [sym_preproc_undef] = STATE(2170),
    [sym__identifier_token] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym_alias] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3583),
    [anon_sym_global] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_unsafe] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3583),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_ref] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3583),
    [anon_sym_delegate] = ACTIONS(3581),
    [anon_sym_abstract] = ACTIONS(3581),
    [anon_sym_async] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_file] = ACTIONS(3581),
    [anon_sym_fixed] = ACTIONS(3581),
    [anon_sym_internal] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_override] = ACTIONS(3581),
    [anon_sym_partial] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_readonly] = ACTIONS(3581),
    [anon_sym_required] = ACTIONS(3581),
    [anon_sym_sealed] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_where] = ACTIONS(3581),
    [anon_sym_notnull] = ACTIONS(3581),
    [anon_sym_unmanaged] = ACTIONS(3581),
    [anon_sym_checked] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [anon_sym_PLUS_PLUS] = ACTIONS(3583),
    [anon_sym_DASH_DASH] = ACTIONS(3583),
    [anon_sym_true] = ACTIONS(3581),
    [anon_sym_false] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_CARET] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_this] = ACTIONS(3581),
    [anon_sym_scoped] = ACTIONS(3581),
    [anon_sym_base] = ACTIONS(3581),
    [anon_sym_var] = ACTIONS(3581),
    [sym_predefined_type] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_unchecked] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_lock] = ACTIONS(3581),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_when] = ACTIONS(3581),
    [anon_sym_await] = ACTIONS(3581),
    [anon_sym_foreach] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_DOT_DOT] = ACTIONS(3583),
    [anon_sym_from] = ACTIONS(3581),
    [anon_sym_into] = ACTIONS(3581),
    [anon_sym_join] = ACTIONS(3581),
    [anon_sym_on] = ACTIONS(3581),
    [anon_sym_equals] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_orderby] = ACTIONS(3581),
    [anon_sym_ascending] = ACTIONS(3581),
    [anon_sym_descending] = ACTIONS(3581),
    [anon_sym_group] = ACTIONS(3581),
    [anon_sym_by] = ACTIONS(3581),
    [anon_sym_select] = ACTIONS(3581),
    [anon_sym_stackalloc] = ACTIONS(3581),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym_typeof] = ACTIONS(3581),
    [anon_sym___makeref] = ACTIONS(3581),
    [anon_sym___reftype] = ACTIONS(3581),
    [anon_sym___refvalue] = ACTIONS(3581),
    [sym_null_literal] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [sym_integer_literal] = ACTIONS(3581),
    [sym_real_literal] = ACTIONS(3583),
    [anon_sym_DQUOTE] = ACTIONS(3583),
    [sym_verbatim_string_literal] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3583),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3583),
    [sym_interpolation_verbatim_start] = ACTIONS(3583),
    [sym_interpolation_raw_start] = ACTIONS(3583),
    [sym_raw_string_start] = ACTIONS(3583),
  },
  [2171] = {
    [sym_preproc_region] = STATE(2171),
    [sym_preproc_endregion] = STATE(2171),
    [sym_preproc_line] = STATE(2171),
    [sym_preproc_pragma] = STATE(2171),
    [sym_preproc_nullable] = STATE(2171),
    [sym_preproc_error] = STATE(2171),
    [sym_preproc_warning] = STATE(2171),
    [sym_preproc_define] = STATE(2171),
    [sym_preproc_undef] = STATE(2171),
    [sym__identifier_token] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym_alias] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym_global] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_unsafe] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_ref] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_delegate] = ACTIONS(3585),
    [anon_sym_abstract] = ACTIONS(3585),
    [anon_sym_async] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_file] = ACTIONS(3585),
    [anon_sym_fixed] = ACTIONS(3585),
    [anon_sym_internal] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_override] = ACTIONS(3585),
    [anon_sym_partial] = ACTIONS(3585),
    [anon_sym_private] = ACTIONS(3585),
    [anon_sym_protected] = ACTIONS(3585),
    [anon_sym_public] = ACTIONS(3585),
    [anon_sym_readonly] = ACTIONS(3585),
    [anon_sym_required] = ACTIONS(3585),
    [anon_sym_sealed] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_where] = ACTIONS(3585),
    [anon_sym_notnull] = ACTIONS(3585),
    [anon_sym_unmanaged] = ACTIONS(3585),
    [anon_sym_checked] = ACTIONS(3585),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_true] = ACTIONS(3585),
    [anon_sym_false] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_this] = ACTIONS(3585),
    [anon_sym_scoped] = ACTIONS(3585),
    [anon_sym_base] = ACTIONS(3585),
    [anon_sym_var] = ACTIONS(3585),
    [sym_predefined_type] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_unchecked] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_lock] = ACTIONS(3585),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_when] = ACTIONS(3585),
    [anon_sym_await] = ACTIONS(3585),
    [anon_sym_foreach] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_DOT_DOT] = ACTIONS(3587),
    [anon_sym_from] = ACTIONS(3585),
    [anon_sym_into] = ACTIONS(3585),
    [anon_sym_join] = ACTIONS(3585),
    [anon_sym_on] = ACTIONS(3585),
    [anon_sym_equals] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_orderby] = ACTIONS(3585),
    [anon_sym_ascending] = ACTIONS(3585),
    [anon_sym_descending] = ACTIONS(3585),
    [anon_sym_group] = ACTIONS(3585),
    [anon_sym_by] = ACTIONS(3585),
    [anon_sym_select] = ACTIONS(3585),
    [anon_sym_stackalloc] = ACTIONS(3585),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym_typeof] = ACTIONS(3585),
    [anon_sym___makeref] = ACTIONS(3585),
    [anon_sym___reftype] = ACTIONS(3585),
    [anon_sym___refvalue] = ACTIONS(3585),
    [sym_null_literal] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [sym_integer_literal] = ACTIONS(3585),
    [sym_real_literal] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_verbatim_string_literal] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3587),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3587),
    [sym_interpolation_verbatim_start] = ACTIONS(3587),
    [sym_interpolation_raw_start] = ACTIONS(3587),
    [sym_raw_string_start] = ACTIONS(3587),
  },
  [2172] = {
    [sym_preproc_region] = STATE(2172),
    [sym_preproc_endregion] = STATE(2172),
    [sym_preproc_line] = STATE(2172),
    [sym_preproc_pragma] = STATE(2172),
    [sym_preproc_nullable] = STATE(2172),
    [sym_preproc_error] = STATE(2172),
    [sym_preproc_warning] = STATE(2172),
    [sym_preproc_define] = STATE(2172),
    [sym_preproc_undef] = STATE(2172),
    [sym__identifier_token] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym_alias] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3591),
    [anon_sym_global] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_unsafe] = ACTIONS(3589),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_LPAREN] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3589),
    [anon_sym_ref] = ACTIONS(3589),
    [anon_sym_LBRACE] = ACTIONS(3591),
    [anon_sym_delegate] = ACTIONS(3589),
    [anon_sym_abstract] = ACTIONS(3589),
    [anon_sym_async] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_file] = ACTIONS(3589),
    [anon_sym_fixed] = ACTIONS(3589),
    [anon_sym_internal] = ACTIONS(3589),
    [anon_sym_new] = ACTIONS(3589),
    [anon_sym_override] = ACTIONS(3589),
    [anon_sym_partial] = ACTIONS(3589),
    [anon_sym_private] = ACTIONS(3589),
    [anon_sym_protected] = ACTIONS(3589),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_readonly] = ACTIONS(3589),
    [anon_sym_required] = ACTIONS(3589),
    [anon_sym_sealed] = ACTIONS(3589),
    [anon_sym_virtual] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym_where] = ACTIONS(3589),
    [anon_sym_notnull] = ACTIONS(3589),
    [anon_sym_unmanaged] = ACTIONS(3589),
    [anon_sym_checked] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3591),
    [anon_sym_true] = ACTIONS(3589),
    [anon_sym_false] = ACTIONS(3589),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_CARET] = ACTIONS(3591),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_this] = ACTIONS(3589),
    [anon_sym_scoped] = ACTIONS(3589),
    [anon_sym_base] = ACTIONS(3589),
    [anon_sym_var] = ACTIONS(3589),
    [sym_predefined_type] = ACTIONS(3589),
    [anon_sym_break] = ACTIONS(3589),
    [anon_sym_unchecked] = ACTIONS(3589),
    [anon_sym_continue] = ACTIONS(3589),
    [anon_sym_do] = ACTIONS(3589),
    [anon_sym_while] = ACTIONS(3589),
    [anon_sym_for] = ACTIONS(3589),
    [anon_sym_lock] = ACTIONS(3589),
    [anon_sym_yield] = ACTIONS(3589),
    [anon_sym_switch] = ACTIONS(3589),
    [anon_sym_default] = ACTIONS(3589),
    [anon_sym_throw] = ACTIONS(3589),
    [anon_sym_try] = ACTIONS(3589),
    [anon_sym_when] = ACTIONS(3589),
    [anon_sym_await] = ACTIONS(3589),
    [anon_sym_foreach] = ACTIONS(3589),
    [anon_sym_goto] = ACTIONS(3589),
    [anon_sym_if] = ACTIONS(3589),
    [anon_sym_DOT_DOT] = ACTIONS(3591),
    [anon_sym_from] = ACTIONS(3589),
    [anon_sym_into] = ACTIONS(3589),
    [anon_sym_join] = ACTIONS(3589),
    [anon_sym_on] = ACTIONS(3589),
    [anon_sym_equals] = ACTIONS(3589),
    [anon_sym_let] = ACTIONS(3589),
    [anon_sym_orderby] = ACTIONS(3589),
    [anon_sym_ascending] = ACTIONS(3589),
    [anon_sym_descending] = ACTIONS(3589),
    [anon_sym_group] = ACTIONS(3589),
    [anon_sym_by] = ACTIONS(3589),
    [anon_sym_select] = ACTIONS(3589),
    [anon_sym_stackalloc] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3589),
    [anon_sym_typeof] = ACTIONS(3589),
    [anon_sym___makeref] = ACTIONS(3589),
    [anon_sym___reftype] = ACTIONS(3589),
    [anon_sym___refvalue] = ACTIONS(3589),
    [sym_null_literal] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3591),
    [sym_integer_literal] = ACTIONS(3589),
    [sym_real_literal] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3591),
    [sym_verbatim_string_literal] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_regular_start] = ACTIONS(3591),
    [sym_interpolation_verbatim_start] = ACTIONS(3591),
    [sym_interpolation_raw_start] = ACTIONS(3591),
    [sym_raw_string_start] = ACTIONS(3591),
  },
  [2173] = {
    [sym__name] = STATE(2448),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2173),
    [sym_preproc_endregion] = STATE(2173),
    [sym_preproc_line] = STATE(2173),
    [sym_preproc_pragma] = STATE(2173),
    [sym_preproc_nullable] = STATE(2173),
    [sym_preproc_error] = STATE(2173),
    [sym_preproc_warning] = STATE(2173),
    [sym_preproc_define] = STATE(2173),
    [sym_preproc_undef] = STATE(2173),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3596),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3596),
    [anon_sym_unmanaged] = ACTIONS(3596),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3596),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3596),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3596),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(3596),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(3596),
    [anon_sym_equals] = ACTIONS(3596),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(3596),
    [anon_sym_select] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2174] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2174),
    [sym_preproc_endregion] = STATE(2174),
    [sym_preproc_line] = STATE(2174),
    [sym_preproc_pragma] = STATE(2174),
    [sym_preproc_nullable] = STATE(2174),
    [sym_preproc_error] = STATE(2174),
    [sym_preproc_warning] = STATE(2174),
    [sym_preproc_define] = STATE(2174),
    [sym_preproc_undef] = STATE(2174),
    [sym__identifier_token] = ACTIONS(3601),
    [anon_sym_alias] = ACTIONS(3605),
    [anon_sym_global] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(2719),
    [anon_sym_file] = ACTIONS(3605),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3605),
    [anon_sym_unmanaged] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(2719),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3605),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3605),
    [sym_predefined_type] = ACTIONS(2719),
    [anon_sym_yield] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3605),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3605),
    [anon_sym_into] = ACTIONS(3605),
    [anon_sym_join] = ACTIONS(3605),
    [anon_sym_on] = ACTIONS(3605),
    [anon_sym_equals] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_orderby] = ACTIONS(3605),
    [anon_sym_ascending] = ACTIONS(3605),
    [anon_sym_descending] = ACTIONS(3605),
    [anon_sym_group] = ACTIONS(3605),
    [anon_sym_by] = ACTIONS(3605),
    [anon_sym_select] = ACTIONS(3605),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2175] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2175),
    [sym_preproc_endregion] = STATE(2175),
    [sym_preproc_line] = STATE(2175),
    [sym_preproc_pragma] = STATE(2175),
    [sym_preproc_nullable] = STATE(2175),
    [sym_preproc_error] = STATE(2175),
    [sym_preproc_warning] = STATE(2175),
    [sym_preproc_define] = STATE(2175),
    [sym_preproc_undef] = STATE(2175),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3615),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2176] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2176),
    [sym_preproc_endregion] = STATE(2176),
    [sym_preproc_line] = STATE(2176),
    [sym_preproc_pragma] = STATE(2176),
    [sym_preproc_nullable] = STATE(2176),
    [sym_preproc_error] = STATE(2176),
    [sym_preproc_warning] = STATE(2176),
    [sym_preproc_define] = STATE(2176),
    [sym_preproc_undef] = STATE(2176),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3615),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2177] = {
    [sym__name] = STATE(2643),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(2576),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2177),
    [sym_preproc_endregion] = STATE(2177),
    [sym_preproc_line] = STATE(2177),
    [sym_preproc_pragma] = STATE(2177),
    [sym_preproc_nullable] = STATE(2177),
    [sym_preproc_error] = STATE(2177),
    [sym_preproc_warning] = STATE(2177),
    [sym_preproc_define] = STATE(2177),
    [sym_preproc_undef] = STATE(2177),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3596),
    [anon_sym_global] = ACTIONS(3596),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3596),
    [anon_sym_unmanaged] = ACTIONS(3596),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3596),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3596),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3596),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(3596),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(3596),
    [anon_sym_equals] = ACTIONS(3596),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(3596),
    [anon_sym_select] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2178] = {
    [sym__variable_designation] = STATE(3396),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2178),
    [sym_preproc_endregion] = STATE(2178),
    [sym_preproc_line] = STATE(2178),
    [sym_preproc_pragma] = STATE(2178),
    [sym_preproc_nullable] = STATE(2178),
    [sym_preproc_error] = STATE(2178),
    [sym_preproc_warning] = STATE(2178),
    [sym_preproc_define] = STATE(2178),
    [sym_preproc_undef] = STATE(2178),
    [sym__identifier_token] = ACTIONS(3622),
    [anon_sym_alias] = ACTIONS(3626),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_global] = ACTIONS(3626),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3636),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3626),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3626),
    [anon_sym_unmanaged] = ACTIONS(3626),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3626),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3626),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3626),
    [sym_discard] = ACTIONS(3640),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3626),
    [anon_sym_into] = ACTIONS(3626),
    [anon_sym_join] = ACTIONS(3626),
    [anon_sym_on] = ACTIONS(3626),
    [anon_sym_equals] = ACTIONS(3626),
    [anon_sym_let] = ACTIONS(3626),
    [anon_sym_orderby] = ACTIONS(3626),
    [anon_sym_ascending] = ACTIONS(3626),
    [anon_sym_descending] = ACTIONS(3626),
    [anon_sym_group] = ACTIONS(3626),
    [anon_sym_by] = ACTIONS(3626),
    [anon_sym_select] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2179] = {
    [sym__name] = STATE(2855),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2714),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2809),
    [sym_ref_type] = STATE(2856),
    [sym__scoped_base_type] = STATE(2857),
    [sym_identifier] = STATE(2602),
    [sym__reserved_identifier] = STATE(2652),
    [sym_preproc_region] = STATE(2179),
    [sym_preproc_endregion] = STATE(2179),
    [sym_preproc_line] = STATE(2179),
    [sym_preproc_pragma] = STATE(2179),
    [sym_preproc_nullable] = STATE(2179),
    [sym_preproc_error] = STATE(2179),
    [sym_preproc_warning] = STATE(2179),
    [sym_preproc_define] = STATE(2179),
    [sym_preproc_undef] = STATE(2179),
    [sym__identifier_token] = ACTIONS(3644),
    [anon_sym_alias] = ACTIONS(3647),
    [anon_sym_global] = ACTIONS(3647),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3647),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3647),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3647),
    [anon_sym_unmanaged] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3647),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3647),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3647),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3647),
    [anon_sym_into] = ACTIONS(3647),
    [anon_sym_join] = ACTIONS(3647),
    [anon_sym_on] = ACTIONS(3647),
    [anon_sym_equals] = ACTIONS(3647),
    [anon_sym_let] = ACTIONS(3647),
    [anon_sym_orderby] = ACTIONS(3647),
    [anon_sym_ascending] = ACTIONS(3647),
    [anon_sym_descending] = ACTIONS(3647),
    [anon_sym_group] = ACTIONS(3647),
    [anon_sym_by] = ACTIONS(3647),
    [anon_sym_select] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2180] = {
    [sym__variable_designation] = STATE(3546),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2180),
    [sym_preproc_endregion] = STATE(2180),
    [sym_preproc_line] = STATE(2180),
    [sym_preproc_pragma] = STATE(2180),
    [sym_preproc_nullable] = STATE(2180),
    [sym_preproc_error] = STATE(2180),
    [sym_preproc_warning] = STATE(2180),
    [sym_preproc_define] = STATE(2180),
    [sym_preproc_undef] = STATE(2180),
    [sym__identifier_token] = ACTIONS(3622),
    [anon_sym_alias] = ACTIONS(3626),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_global] = ACTIONS(3626),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3652),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3626),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3626),
    [anon_sym_unmanaged] = ACTIONS(3626),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3626),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3626),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3626),
    [sym_discard] = ACTIONS(3656),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3626),
    [anon_sym_into] = ACTIONS(3626),
    [anon_sym_join] = ACTIONS(3626),
    [anon_sym_on] = ACTIONS(3626),
    [anon_sym_equals] = ACTIONS(3626),
    [anon_sym_let] = ACTIONS(3626),
    [anon_sym_orderby] = ACTIONS(3626),
    [anon_sym_ascending] = ACTIONS(3626),
    [anon_sym_descending] = ACTIONS(3626),
    [anon_sym_group] = ACTIONS(3626),
    [anon_sym_by] = ACTIONS(3626),
    [anon_sym_select] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2181] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2181),
    [sym_preproc_endregion] = STATE(2181),
    [sym_preproc_line] = STATE(2181),
    [sym_preproc_pragma] = STATE(2181),
    [sym_preproc_nullable] = STATE(2181),
    [sym_preproc_error] = STATE(2181),
    [sym_preproc_warning] = STATE(2181),
    [sym_preproc_define] = STATE(2181),
    [sym_preproc_undef] = STATE(2181),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3660),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3615),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2182] = {
    [sym_preproc_region] = STATE(2182),
    [sym_preproc_endregion] = STATE(2182),
    [sym_preproc_line] = STATE(2182),
    [sym_preproc_pragma] = STATE(2182),
    [sym_preproc_nullable] = STATE(2182),
    [sym_preproc_error] = STATE(2182),
    [sym_preproc_warning] = STATE(2182),
    [sym_preproc_define] = STATE(2182),
    [sym_preproc_undef] = STATE(2182),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_operator] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_this] = ACTIONS(3662),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2183] = {
    [sym_preproc_region] = STATE(2183),
    [sym_preproc_endregion] = STATE(2183),
    [sym_preproc_line] = STATE(2183),
    [sym_preproc_pragma] = STATE(2183),
    [sym_preproc_nullable] = STATE(2183),
    [sym_preproc_error] = STATE(2183),
    [sym_preproc_warning] = STATE(2183),
    [sym_preproc_define] = STATE(2183),
    [sym_preproc_undef] = STATE(2183),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_operator] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(3461),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2184] = {
    [sym_preproc_region] = STATE(2184),
    [sym_preproc_endregion] = STATE(2184),
    [sym_preproc_line] = STATE(2184),
    [sym_preproc_pragma] = STATE(2184),
    [sym_preproc_nullable] = STATE(2184),
    [sym_preproc_error] = STATE(2184),
    [sym_preproc_warning] = STATE(2184),
    [sym_preproc_define] = STATE(2184),
    [sym_preproc_undef] = STATE(2184),
    [sym__identifier_token] = ACTIONS(3666),
    [anon_sym_alias] = ACTIONS(3666),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_global] = ACTIONS(3666),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_file] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3666),
    [anon_sym_where] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_notnull] = ACTIONS(3666),
    [anon_sym_unmanaged] = ACTIONS(3666),
    [anon_sym_operator] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3666),
    [anon_sym_CARET] = ACTIONS(3666),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3666),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3666),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_this] = ACTIONS(3666),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_scoped] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_var] = ACTIONS(3666),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_switch] = ACTIONS(3666),
    [anon_sym_when] = ACTIONS(3666),
    [sym_discard] = ACTIONS(3666),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3666),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_PLUS_EQ] = ACTIONS(3668),
    [anon_sym_DASH_EQ] = ACTIONS(3668),
    [anon_sym_STAR_EQ] = ACTIONS(3668),
    [anon_sym_SLASH_EQ] = ACTIONS(3668),
    [anon_sym_PERCENT_EQ] = ACTIONS(3668),
    [anon_sym_AMP_EQ] = ACTIONS(3668),
    [anon_sym_CARET_EQ] = ACTIONS(3668),
    [anon_sym_PIPE_EQ] = ACTIONS(3668),
    [anon_sym_LT_LT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3666),
    [anon_sym_from] = ACTIONS(3666),
    [anon_sym_into] = ACTIONS(3666),
    [anon_sym_join] = ACTIONS(3666),
    [anon_sym_on] = ACTIONS(3666),
    [anon_sym_equals] = ACTIONS(3666),
    [anon_sym_let] = ACTIONS(3666),
    [anon_sym_orderby] = ACTIONS(3666),
    [anon_sym_ascending] = ACTIONS(3666),
    [anon_sym_descending] = ACTIONS(3666),
    [anon_sym_group] = ACTIONS(3666),
    [anon_sym_by] = ACTIONS(3666),
    [anon_sym_select] = ACTIONS(3666),
    [anon_sym_as] = ACTIONS(3666),
    [anon_sym_is] = ACTIONS(3666),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3666),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2185] = {
    [sym_preproc_region] = STATE(2185),
    [sym_preproc_endregion] = STATE(2185),
    [sym_preproc_line] = STATE(2185),
    [sym_preproc_pragma] = STATE(2185),
    [sym_preproc_nullable] = STATE(2185),
    [sym_preproc_error] = STATE(2185),
    [sym_preproc_warning] = STATE(2185),
    [sym_preproc_define] = STATE(2185),
    [sym_preproc_undef] = STATE(2185),
    [sym__identifier_token] = ACTIONS(3670),
    [anon_sym_alias] = ACTIONS(3670),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_global] = ACTIONS(3670),
    [anon_sym_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_file] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_where] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_notnull] = ACTIONS(3670),
    [anon_sym_unmanaged] = ACTIONS(3670),
    [anon_sym_operator] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_this] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_scoped] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_var] = ACTIONS(3670),
    [anon_sym_yield] = ACTIONS(3670),
    [anon_sym_switch] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [sym_discard] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3672),
    [anon_sym_DASH_EQ] = ACTIONS(3672),
    [anon_sym_STAR_EQ] = ACTIONS(3672),
    [anon_sym_SLASH_EQ] = ACTIONS(3672),
    [anon_sym_PERCENT_EQ] = ACTIONS(3672),
    [anon_sym_AMP_EQ] = ACTIONS(3672),
    [anon_sym_CARET_EQ] = ACTIONS(3672),
    [anon_sym_PIPE_EQ] = ACTIONS(3672),
    [anon_sym_LT_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3670),
    [anon_sym_from] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3670),
    [anon_sym_join] = ACTIONS(3670),
    [anon_sym_on] = ACTIONS(3670),
    [anon_sym_equals] = ACTIONS(3670),
    [anon_sym_let] = ACTIONS(3670),
    [anon_sym_orderby] = ACTIONS(3670),
    [anon_sym_ascending] = ACTIONS(3670),
    [anon_sym_descending] = ACTIONS(3670),
    [anon_sym_group] = ACTIONS(3670),
    [anon_sym_by] = ACTIONS(3670),
    [anon_sym_select] = ACTIONS(3670),
    [anon_sym_as] = ACTIONS(3670),
    [anon_sym_is] = ACTIONS(3670),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3670),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2186] = {
    [sym_preproc_region] = STATE(2186),
    [sym_preproc_endregion] = STATE(2186),
    [sym_preproc_line] = STATE(2186),
    [sym_preproc_pragma] = STATE(2186),
    [sym_preproc_nullable] = STATE(2186),
    [sym_preproc_error] = STATE(2186),
    [sym_preproc_warning] = STATE(2186),
    [sym_preproc_define] = STATE(2186),
    [sym_preproc_undef] = STATE(2186),
    [sym__identifier_token] = ACTIONS(3674),
    [anon_sym_alias] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_global] = ACTIONS(3674),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_file] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_notnull] = ACTIONS(3674),
    [anon_sym_unmanaged] = ACTIONS(3674),
    [anon_sym_operator] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_this] = ACTIONS(3674),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_scoped] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_var] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3674),
    [anon_sym_switch] = ACTIONS(3674),
    [anon_sym_when] = ACTIONS(3674),
    [sym_discard] = ACTIONS(3674),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_PLUS_EQ] = ACTIONS(3676),
    [anon_sym_DASH_EQ] = ACTIONS(3676),
    [anon_sym_STAR_EQ] = ACTIONS(3676),
    [anon_sym_SLASH_EQ] = ACTIONS(3676),
    [anon_sym_PERCENT_EQ] = ACTIONS(3676),
    [anon_sym_AMP_EQ] = ACTIONS(3676),
    [anon_sym_CARET_EQ] = ACTIONS(3676),
    [anon_sym_PIPE_EQ] = ACTIONS(3676),
    [anon_sym_LT_LT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3674),
    [anon_sym_from] = ACTIONS(3674),
    [anon_sym_into] = ACTIONS(3674),
    [anon_sym_join] = ACTIONS(3674),
    [anon_sym_on] = ACTIONS(3674),
    [anon_sym_equals] = ACTIONS(3674),
    [anon_sym_let] = ACTIONS(3674),
    [anon_sym_orderby] = ACTIONS(3674),
    [anon_sym_ascending] = ACTIONS(3674),
    [anon_sym_descending] = ACTIONS(3674),
    [anon_sym_group] = ACTIONS(3674),
    [anon_sym_by] = ACTIONS(3674),
    [anon_sym_select] = ACTIONS(3674),
    [anon_sym_as] = ACTIONS(3674),
    [anon_sym_is] = ACTIONS(3674),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3674),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2187] = {
    [sym_preproc_region] = STATE(2187),
    [sym_preproc_endregion] = STATE(2187),
    [sym_preproc_line] = STATE(2187),
    [sym_preproc_pragma] = STATE(2187),
    [sym_preproc_nullable] = STATE(2187),
    [sym_preproc_error] = STATE(2187),
    [sym_preproc_warning] = STATE(2187),
    [sym_preproc_define] = STATE(2187),
    [sym_preproc_undef] = STATE(2187),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_operator] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_this] = ACTIONS(3678),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2188] = {
    [sym__name] = STATE(5907),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(5781),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2188),
    [sym_preproc_endregion] = STATE(2188),
    [sym_preproc_line] = STATE(2188),
    [sym_preproc_pragma] = STATE(2188),
    [sym_preproc_nullable] = STATE(2188),
    [sym_preproc_error] = STATE(2188),
    [sym_preproc_warning] = STATE(2188),
    [sym_preproc_define] = STATE(2188),
    [sym_preproc_undef] = STATE(2188),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3682),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3615),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2189] = {
    [sym_preproc_region] = STATE(2189),
    [sym_preproc_endregion] = STATE(2189),
    [sym_preproc_line] = STATE(2189),
    [sym_preproc_pragma] = STATE(2189),
    [sym_preproc_nullable] = STATE(2189),
    [sym_preproc_error] = STATE(2189),
    [sym_preproc_warning] = STATE(2189),
    [sym_preproc_define] = STATE(2189),
    [sym_preproc_undef] = STATE(2189),
    [sym__identifier_token] = ACTIONS(3684),
    [anon_sym_alias] = ACTIONS(3684),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_global] = ACTIONS(3684),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_file] = ACTIONS(3684),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3684),
    [anon_sym_where] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_notnull] = ACTIONS(3684),
    [anon_sym_unmanaged] = ACTIONS(3684),
    [anon_sym_operator] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_this] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_scoped] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_var] = ACTIONS(3684),
    [anon_sym_yield] = ACTIONS(3684),
    [anon_sym_switch] = ACTIONS(3684),
    [anon_sym_when] = ACTIONS(3684),
    [sym_discard] = ACTIONS(3684),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3684),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_PLUS_EQ] = ACTIONS(3686),
    [anon_sym_DASH_EQ] = ACTIONS(3686),
    [anon_sym_STAR_EQ] = ACTIONS(3686),
    [anon_sym_SLASH_EQ] = ACTIONS(3686),
    [anon_sym_PERCENT_EQ] = ACTIONS(3686),
    [anon_sym_AMP_EQ] = ACTIONS(3686),
    [anon_sym_CARET_EQ] = ACTIONS(3686),
    [anon_sym_PIPE_EQ] = ACTIONS(3686),
    [anon_sym_LT_LT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3684),
    [anon_sym_from] = ACTIONS(3684),
    [anon_sym_into] = ACTIONS(3684),
    [anon_sym_join] = ACTIONS(3684),
    [anon_sym_on] = ACTIONS(3684),
    [anon_sym_equals] = ACTIONS(3684),
    [anon_sym_let] = ACTIONS(3684),
    [anon_sym_orderby] = ACTIONS(3684),
    [anon_sym_ascending] = ACTIONS(3684),
    [anon_sym_descending] = ACTIONS(3684),
    [anon_sym_group] = ACTIONS(3684),
    [anon_sym_by] = ACTIONS(3684),
    [anon_sym_select] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_is] = ACTIONS(3684),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3684),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2190] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2190),
    [sym_preproc_endregion] = STATE(2190),
    [sym_preproc_line] = STATE(2190),
    [sym_preproc_pragma] = STATE(2190),
    [sym_preproc_nullable] = STATE(2190),
    [sym_preproc_error] = STATE(2190),
    [sym_preproc_warning] = STATE(2190),
    [sym_preproc_define] = STATE(2190),
    [sym_preproc_undef] = STATE(2190),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3615),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2191] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2191),
    [sym_preproc_endregion] = STATE(2191),
    [sym_preproc_line] = STATE(2191),
    [sym_preproc_pragma] = STATE(2191),
    [sym_preproc_nullable] = STATE(2191),
    [sym_preproc_error] = STATE(2191),
    [sym_preproc_warning] = STATE(2191),
    [sym_preproc_define] = STATE(2191),
    [sym_preproc_undef] = STATE(2191),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2192] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2192),
    [sym_preproc_endregion] = STATE(2192),
    [sym_preproc_line] = STATE(2192),
    [sym_preproc_pragma] = STATE(2192),
    [sym_preproc_nullable] = STATE(2192),
    [sym_preproc_error] = STATE(2192),
    [sym_preproc_warning] = STATE(2192),
    [sym_preproc_define] = STATE(2192),
    [sym_preproc_undef] = STATE(2192),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2193] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2193),
    [sym_preproc_endregion] = STATE(2193),
    [sym_preproc_line] = STATE(2193),
    [sym_preproc_pragma] = STATE(2193),
    [sym_preproc_nullable] = STATE(2193),
    [sym_preproc_error] = STATE(2193),
    [sym_preproc_warning] = STATE(2193),
    [sym_preproc_define] = STATE(2193),
    [sym_preproc_undef] = STATE(2193),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2194] = {
    [sym_preproc_region] = STATE(2194),
    [sym_preproc_endregion] = STATE(2194),
    [sym_preproc_line] = STATE(2194),
    [sym_preproc_pragma] = STATE(2194),
    [sym_preproc_nullable] = STATE(2194),
    [sym_preproc_error] = STATE(2194),
    [sym_preproc_warning] = STATE(2194),
    [sym_preproc_define] = STATE(2194),
    [sym_preproc_undef] = STATE(2194),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2195] = {
    [sym_preproc_region] = STATE(2195),
    [sym_preproc_endregion] = STATE(2195),
    [sym_preproc_line] = STATE(2195),
    [sym_preproc_pragma] = STATE(2195),
    [sym_preproc_nullable] = STATE(2195),
    [sym_preproc_error] = STATE(2195),
    [sym_preproc_warning] = STATE(2195),
    [sym_preproc_define] = STATE(2195),
    [sym_preproc_undef] = STATE(2195),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_in] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2196] = {
    [sym_preproc_region] = STATE(2196),
    [sym_preproc_endregion] = STATE(2196),
    [sym_preproc_line] = STATE(2196),
    [sym_preproc_pragma] = STATE(2196),
    [sym_preproc_nullable] = STATE(2196),
    [sym_preproc_error] = STATE(2196),
    [sym_preproc_warning] = STATE(2196),
    [sym_preproc_define] = STATE(2196),
    [sym_preproc_undef] = STATE(2196),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3703),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_RBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_in] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_if_token3] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2197] = {
    [sym_preproc_region] = STATE(2197),
    [sym_preproc_endregion] = STATE(2197),
    [sym_preproc_line] = STATE(2197),
    [sym_preproc_pragma] = STATE(2197),
    [sym_preproc_nullable] = STATE(2197),
    [sym_preproc_error] = STATE(2197),
    [sym_preproc_warning] = STATE(2197),
    [sym_preproc_define] = STATE(2197),
    [sym_preproc_undef] = STATE(2197),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_RBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2198] = {
    [sym_preproc_region] = STATE(2198),
    [sym_preproc_endregion] = STATE(2198),
    [sym_preproc_line] = STATE(2198),
    [sym_preproc_pragma] = STATE(2198),
    [sym_preproc_nullable] = STATE(2198),
    [sym_preproc_error] = STATE(2198),
    [sym_preproc_warning] = STATE(2198),
    [sym_preproc_define] = STATE(2198),
    [sym_preproc_undef] = STATE(2198),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_in] = ACTIONS(3728),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_if_token3] = ACTIONS(3713),
    [aux_sym_preproc_else_token1] = ACTIONS(3713),
    [aux_sym_preproc_elif_token1] = ACTIONS(3713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2199] = {
    [sym_preproc_region] = STATE(2199),
    [sym_preproc_endregion] = STATE(2199),
    [sym_preproc_line] = STATE(2199),
    [sym_preproc_pragma] = STATE(2199),
    [sym_preproc_nullable] = STATE(2199),
    [sym_preproc_error] = STATE(2199),
    [sym_preproc_warning] = STATE(2199),
    [sym_preproc_define] = STATE(2199),
    [sym_preproc_undef] = STATE(2199),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_in] = ACTIONS(3728),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_if_token3] = ACTIONS(3713),
    [aux_sym_preproc_else_token1] = ACTIONS(3713),
    [aux_sym_preproc_elif_token1] = ACTIONS(3713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2200] = {
    [sym_preproc_region] = STATE(2200),
    [sym_preproc_endregion] = STATE(2200),
    [sym_preproc_line] = STATE(2200),
    [sym_preproc_pragma] = STATE(2200),
    [sym_preproc_nullable] = STATE(2200),
    [sym_preproc_error] = STATE(2200),
    [sym_preproc_warning] = STATE(2200),
    [sym_preproc_define] = STATE(2200),
    [sym_preproc_undef] = STATE(2200),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3703),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_RBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_in] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_if_token3] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2201] = {
    [sym_preproc_region] = STATE(2201),
    [sym_preproc_endregion] = STATE(2201),
    [sym_preproc_line] = STATE(2201),
    [sym_preproc_pragma] = STATE(2201),
    [sym_preproc_nullable] = STATE(2201),
    [sym_preproc_error] = STATE(2201),
    [sym_preproc_warning] = STATE(2201),
    [sym_preproc_define] = STATE(2201),
    [sym_preproc_undef] = STATE(2201),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3722),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_CARET] = ACTIONS(3736),
    [anon_sym_PIPE] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LT_LT] = ACTIONS(3736),
    [anon_sym_GT_GT] = ACTIONS(3736),
    [anon_sym_GT_GT_GT] = ACTIONS(3736),
    [anon_sym_EQ_EQ] = ACTIONS(3733),
    [anon_sym_BANG_EQ] = ACTIONS(3733),
    [anon_sym_GT_EQ] = ACTIONS(3733),
    [anon_sym_LT_EQ] = ACTIONS(3733),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3736),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3733),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_PIPE_PIPE] = ACTIONS(3733),
    [anon_sym_QMARK_QMARK] = ACTIONS(3736),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3736),
    [anon_sym_is] = ACTIONS(3736),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3736),
    [aux_sym_preproc_if_token3] = ACTIONS(3722),
    [aux_sym_preproc_else_token1] = ACTIONS(3722),
    [aux_sym_preproc_elif_token1] = ACTIONS(3722),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2202] = {
    [sym__variable_designation] = STATE(3546),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(2616),
    [sym_preproc_region] = STATE(2202),
    [sym_preproc_endregion] = STATE(2202),
    [sym_preproc_line] = STATE(2202),
    [sym_preproc_pragma] = STATE(2202),
    [sym_preproc_nullable] = STATE(2202),
    [sym_preproc_error] = STATE(2202),
    [sym_preproc_warning] = STATE(2202),
    [sym_preproc_define] = STATE(2202),
    [sym_preproc_undef] = STATE(2202),
    [sym__identifier_token] = ACTIONS(3739),
    [anon_sym_alias] = ACTIONS(3743),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3652),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3743),
    [anon_sym_unmanaged] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3743),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3743),
    [sym_discard] = ACTIONS(3656),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_into] = ACTIONS(3743),
    [anon_sym_join] = ACTIONS(3743),
    [anon_sym_on] = ACTIONS(3743),
    [anon_sym_equals] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_orderby] = ACTIONS(3743),
    [anon_sym_ascending] = ACTIONS(3743),
    [anon_sym_descending] = ACTIONS(3743),
    [anon_sym_group] = ACTIONS(3743),
    [anon_sym_by] = ACTIONS(3743),
    [anon_sym_select] = ACTIONS(3743),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2203] = {
    [sym_preproc_region] = STATE(2203),
    [sym_preproc_endregion] = STATE(2203),
    [sym_preproc_line] = STATE(2203),
    [sym_preproc_pragma] = STATE(2203),
    [sym_preproc_nullable] = STATE(2203),
    [sym_preproc_error] = STATE(2203),
    [sym_preproc_warning] = STATE(2203),
    [sym_preproc_define] = STATE(2203),
    [sym_preproc_undef] = STATE(2203),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2204] = {
    [sym_preproc_region] = STATE(2204),
    [sym_preproc_endregion] = STATE(2204),
    [sym_preproc_line] = STATE(2204),
    [sym_preproc_pragma] = STATE(2204),
    [sym_preproc_nullable] = STATE(2204),
    [sym_preproc_error] = STATE(2204),
    [sym_preproc_warning] = STATE(2204),
    [sym_preproc_define] = STATE(2204),
    [sym_preproc_undef] = STATE(2204),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2205] = {
    [sym_preproc_region] = STATE(2205),
    [sym_preproc_endregion] = STATE(2205),
    [sym_preproc_line] = STATE(2205),
    [sym_preproc_pragma] = STATE(2205),
    [sym_preproc_nullable] = STATE(2205),
    [sym_preproc_error] = STATE(2205),
    [sym_preproc_warning] = STATE(2205),
    [sym_preproc_define] = STATE(2205),
    [sym_preproc_undef] = STATE(2205),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_if_token3] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2206] = {
    [sym_preproc_region] = STATE(2206),
    [sym_preproc_endregion] = STATE(2206),
    [sym_preproc_line] = STATE(2206),
    [sym_preproc_pragma] = STATE(2206),
    [sym_preproc_nullable] = STATE(2206),
    [sym_preproc_error] = STATE(2206),
    [sym_preproc_warning] = STATE(2206),
    [sym_preproc_define] = STATE(2206),
    [sym_preproc_undef] = STATE(2206),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2207] = {
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_modifier] = STATE(3166),
    [sym_variable_declaration] = STATE(7628),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5372),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5772),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(2207),
    [sym_preproc_endregion] = STATE(2207),
    [sym_preproc_line] = STATE(2207),
    [sym_preproc_pragma] = STATE(2207),
    [sym_preproc_nullable] = STATE(2207),
    [sym_preproc_error] = STATE(2207),
    [sym_preproc_warning] = STATE(2207),
    [sym_preproc_define] = STATE(2207),
    [sym_preproc_undef] = STATE(2207),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2902),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2298),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3749),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3753),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3761),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(3763),
    [anon_sym_implicit] = ACTIONS(3765),
    [anon_sym_explicit] = ACTIONS(3765),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3767),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2208] = {
    [sym__variable_designation] = STATE(4815),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2208),
    [sym_preproc_endregion] = STATE(2208),
    [sym_preproc_line] = STATE(2208),
    [sym_preproc_pragma] = STATE(2208),
    [sym_preproc_nullable] = STATE(2208),
    [sym_preproc_error] = STATE(2208),
    [sym_preproc_warning] = STATE(2208),
    [sym_preproc_define] = STATE(2208),
    [sym_preproc_undef] = STATE(2208),
    [sym__identifier_token] = ACTIONS(3769),
    [anon_sym_alias] = ACTIONS(3773),
    [anon_sym_global] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3773),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3773),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3773),
    [anon_sym_unmanaged] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3773),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3773),
    [anon_sym_yield] = ACTIONS(3773),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3773),
    [sym_discard] = ACTIONS(3781),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3773),
    [anon_sym_into] = ACTIONS(3773),
    [anon_sym_join] = ACTIONS(3773),
    [anon_sym_on] = ACTIONS(3773),
    [anon_sym_equals] = ACTIONS(3773),
    [anon_sym_let] = ACTIONS(3773),
    [anon_sym_orderby] = ACTIONS(3773),
    [anon_sym_ascending] = ACTIONS(3773),
    [anon_sym_descending] = ACTIONS(3773),
    [anon_sym_group] = ACTIONS(3773),
    [anon_sym_by] = ACTIONS(3773),
    [anon_sym_select] = ACTIONS(3773),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3630),
  },
  [2209] = {
    [sym__name] = STATE(2448),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2209),
    [sym_preproc_endregion] = STATE(2209),
    [sym_preproc_line] = STATE(2209),
    [sym_preproc_pragma] = STATE(2209),
    [sym_preproc_nullable] = STATE(2209),
    [sym_preproc_error] = STATE(2209),
    [sym_preproc_warning] = STATE(2209),
    [sym_preproc_define] = STATE(2209),
    [sym_preproc_undef] = STATE(2209),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3596),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3596),
    [anon_sym_unmanaged] = ACTIONS(3596),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3596),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3596),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3596),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(3596),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(3596),
    [anon_sym_equals] = ACTIONS(3596),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(3596),
    [anon_sym_select] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2210] = {
    [sym_preproc_region] = STATE(2210),
    [sym_preproc_endregion] = STATE(2210),
    [sym_preproc_line] = STATE(2210),
    [sym_preproc_pragma] = STATE(2210),
    [sym_preproc_nullable] = STATE(2210),
    [sym_preproc_error] = STATE(2210),
    [sym_preproc_warning] = STATE(2210),
    [sym_preproc_define] = STATE(2210),
    [sym_preproc_undef] = STATE(2210),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_extern] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_unsafe] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3785),
    [anon_sym_delegate] = ACTIONS(3785),
    [anon_sym_abstract] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_const] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_fixed] = ACTIONS(3785),
    [anon_sym_internal] = ACTIONS(3785),
    [anon_sym_new] = ACTIONS(3785),
    [anon_sym_override] = ACTIONS(3785),
    [anon_sym_partial] = ACTIONS(3785),
    [anon_sym_private] = ACTIONS(3785),
    [anon_sym_protected] = ACTIONS(3785),
    [anon_sym_public] = ACTIONS(3785),
    [anon_sym_readonly] = ACTIONS(3785),
    [anon_sym_required] = ACTIONS(3785),
    [anon_sym_sealed] = ACTIONS(3785),
    [anon_sym_virtual] = ACTIONS(3785),
    [anon_sym_volatile] = ACTIONS(3785),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_var] = ACTIONS(3785),
    [sym_predefined_type] = ACTIONS(3785),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2211] = {
    [sym__name] = STATE(3220),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_ref_type] = STATE(3223),
    [sym__scoped_base_type] = STATE(3228),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(2211),
    [sym_preproc_endregion] = STATE(2211),
    [sym_preproc_line] = STATE(2211),
    [sym_preproc_pragma] = STATE(2211),
    [sym_preproc_nullable] = STATE(2211),
    [sym_preproc_error] = STATE(2211),
    [sym_preproc_warning] = STATE(2211),
    [sym_preproc_define] = STATE(2211),
    [sym_preproc_undef] = STATE(2211),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3793),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2212] = {
    [sym_preproc_region] = STATE(2212),
    [sym_preproc_endregion] = STATE(2212),
    [sym_preproc_line] = STATE(2212),
    [sym_preproc_pragma] = STATE(2212),
    [sym_preproc_nullable] = STATE(2212),
    [sym_preproc_error] = STATE(2212),
    [sym_preproc_warning] = STATE(2212),
    [sym_preproc_define] = STATE(2212),
    [sym_preproc_undef] = STATE(2212),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_if_token3] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2213] = {
    [sym__name] = STATE(3483),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_ref_type] = STATE(3271),
    [sym__scoped_base_type] = STATE(3273),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2213),
    [sym_preproc_endregion] = STATE(2213),
    [sym_preproc_line] = STATE(2213),
    [sym_preproc_pragma] = STATE(2213),
    [sym_preproc_nullable] = STATE(2213),
    [sym_preproc_error] = STATE(2213),
    [sym_preproc_warning] = STATE(2213),
    [sym_preproc_define] = STATE(2213),
    [sym_preproc_undef] = STATE(2213),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3802),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2214] = {
    [sym__variable_designation] = STATE(3546),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2214),
    [sym_preproc_endregion] = STATE(2214),
    [sym_preproc_line] = STATE(2214),
    [sym_preproc_pragma] = STATE(2214),
    [sym_preproc_nullable] = STATE(2214),
    [sym_preproc_error] = STATE(2214),
    [sym_preproc_warning] = STATE(2214),
    [sym_preproc_define] = STATE(2214),
    [sym_preproc_undef] = STATE(2214),
    [sym__identifier_token] = ACTIONS(3804),
    [anon_sym_alias] = ACTIONS(3808),
    [anon_sym_global] = ACTIONS(3808),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3808),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3808),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3808),
    [anon_sym_unmanaged] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3808),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_yield] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3808),
    [sym_discard] = ACTIONS(3656),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3808),
    [anon_sym_into] = ACTIONS(3808),
    [anon_sym_join] = ACTIONS(3808),
    [anon_sym_on] = ACTIONS(3808),
    [anon_sym_equals] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_orderby] = ACTIONS(3808),
    [anon_sym_ascending] = ACTIONS(3808),
    [anon_sym_descending] = ACTIONS(3808),
    [anon_sym_group] = ACTIONS(3808),
    [anon_sym_by] = ACTIONS(3808),
    [anon_sym_select] = ACTIONS(3808),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2215] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2215),
    [sym_preproc_endregion] = STATE(2215),
    [sym_preproc_line] = STATE(2215),
    [sym_preproc_pragma] = STATE(2215),
    [sym_preproc_nullable] = STATE(2215),
    [sym_preproc_error] = STATE(2215),
    [sym_preproc_warning] = STATE(2215),
    [sym_preproc_define] = STATE(2215),
    [sym_preproc_undef] = STATE(2215),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2216] = {
    [sym_preproc_region] = STATE(2216),
    [sym_preproc_endregion] = STATE(2216),
    [sym_preproc_line] = STATE(2216),
    [sym_preproc_pragma] = STATE(2216),
    [sym_preproc_nullable] = STATE(2216),
    [sym_preproc_error] = STATE(2216),
    [sym_preproc_warning] = STATE(2216),
    [sym_preproc_define] = STATE(2216),
    [sym_preproc_undef] = STATE(2216),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2217] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2217),
    [sym_preproc_endregion] = STATE(2217),
    [sym_preproc_line] = STATE(2217),
    [sym_preproc_pragma] = STATE(2217),
    [sym_preproc_nullable] = STATE(2217),
    [sym_preproc_error] = STATE(2217),
    [sym_preproc_warning] = STATE(2217),
    [sym_preproc_define] = STATE(2217),
    [sym_preproc_undef] = STATE(2217),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2218] = {
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_modifier] = STATE(3166),
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5968),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(2218),
    [sym_preproc_endregion] = STATE(2218),
    [sym_preproc_line] = STATE(2218),
    [sym_preproc_pragma] = STATE(2218),
    [sym_preproc_nullable] = STATE(2218),
    [sym_preproc_error] = STATE(2218),
    [sym_preproc_warning] = STATE(2218),
    [sym_preproc_define] = STATE(2218),
    [sym_preproc_undef] = STATE(2218),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2902),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2393),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3463),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(65),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3753),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3761),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3767),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2219] = {
    [sym__variable_designation] = STATE(3546),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(2616),
    [sym_preproc_region] = STATE(2219),
    [sym_preproc_endregion] = STATE(2219),
    [sym_preproc_line] = STATE(2219),
    [sym_preproc_pragma] = STATE(2219),
    [sym_preproc_nullable] = STATE(2219),
    [sym_preproc_error] = STATE(2219),
    [sym_preproc_warning] = STATE(2219),
    [sym_preproc_define] = STATE(2219),
    [sym_preproc_undef] = STATE(2219),
    [sym__identifier_token] = ACTIONS(3739),
    [anon_sym_alias] = ACTIONS(3743),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3743),
    [anon_sym_unmanaged] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3743),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3743),
    [sym_discard] = ACTIONS(3656),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_into] = ACTIONS(3743),
    [anon_sym_join] = ACTIONS(3743),
    [anon_sym_on] = ACTIONS(3743),
    [anon_sym_equals] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_orderby] = ACTIONS(3743),
    [anon_sym_ascending] = ACTIONS(3743),
    [anon_sym_descending] = ACTIONS(3743),
    [anon_sym_group] = ACTIONS(3743),
    [anon_sym_by] = ACTIONS(3743),
    [anon_sym_select] = ACTIONS(3743),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2220] = {
    [sym__variable_designation] = STATE(3803),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2220),
    [sym_preproc_endregion] = STATE(2220),
    [sym_preproc_line] = STATE(2220),
    [sym_preproc_pragma] = STATE(2220),
    [sym_preproc_nullable] = STATE(2220),
    [sym_preproc_error] = STATE(2220),
    [sym_preproc_warning] = STATE(2220),
    [sym_preproc_define] = STATE(2220),
    [sym_preproc_undef] = STATE(2220),
    [sym__identifier_token] = ACTIONS(3818),
    [anon_sym_alias] = ACTIONS(3822),
    [anon_sym_global] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3822),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3822),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3822),
    [anon_sym_unmanaged] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3822),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3822),
    [anon_sym_yield] = ACTIONS(3822),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3822),
    [sym_discard] = ACTIONS(3830),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3822),
    [anon_sym_into] = ACTIONS(3822),
    [anon_sym_join] = ACTIONS(3822),
    [anon_sym_on] = ACTIONS(3822),
    [anon_sym_equals] = ACTIONS(3822),
    [anon_sym_let] = ACTIONS(3822),
    [anon_sym_orderby] = ACTIONS(3822),
    [anon_sym_ascending] = ACTIONS(3822),
    [anon_sym_descending] = ACTIONS(3822),
    [anon_sym_group] = ACTIONS(3822),
    [anon_sym_by] = ACTIONS(3822),
    [anon_sym_select] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2221] = {
    [sym_preproc_region] = STATE(2221),
    [sym_preproc_endregion] = STATE(2221),
    [sym_preproc_line] = STATE(2221),
    [sym_preproc_pragma] = STATE(2221),
    [sym_preproc_nullable] = STATE(2221),
    [sym_preproc_error] = STATE(2221),
    [sym_preproc_warning] = STATE(2221),
    [sym_preproc_define] = STATE(2221),
    [sym_preproc_undef] = STATE(2221),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2222] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2222),
    [sym_preproc_endregion] = STATE(2222),
    [sym_preproc_line] = STATE(2222),
    [sym_preproc_pragma] = STATE(2222),
    [sym_preproc_nullable] = STATE(2222),
    [sym_preproc_error] = STATE(2222),
    [sym_preproc_warning] = STATE(2222),
    [sym_preproc_define] = STATE(2222),
    [sym_preproc_undef] = STATE(2222),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3837),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2223] = {
    [sym_preproc_region] = STATE(2223),
    [sym_preproc_endregion] = STATE(2223),
    [sym_preproc_line] = STATE(2223),
    [sym_preproc_pragma] = STATE(2223),
    [sym_preproc_nullable] = STATE(2223),
    [sym_preproc_error] = STATE(2223),
    [sym_preproc_warning] = STATE(2223),
    [sym_preproc_define] = STATE(2223),
    [sym_preproc_undef] = STATE(2223),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2224] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2224),
    [sym_preproc_endregion] = STATE(2224),
    [sym_preproc_line] = STATE(2224),
    [sym_preproc_pragma] = STATE(2224),
    [sym_preproc_nullable] = STATE(2224),
    [sym_preproc_error] = STATE(2224),
    [sym_preproc_warning] = STATE(2224),
    [sym_preproc_define] = STATE(2224),
    [sym_preproc_undef] = STATE(2224),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3842),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2225] = {
    [sym_preproc_region] = STATE(2225),
    [sym_preproc_endregion] = STATE(2225),
    [sym_preproc_line] = STATE(2225),
    [sym_preproc_pragma] = STATE(2225),
    [sym_preproc_nullable] = STATE(2225),
    [sym_preproc_error] = STATE(2225),
    [sym_preproc_warning] = STATE(2225),
    [sym_preproc_define] = STATE(2225),
    [sym_preproc_undef] = STATE(2225),
    [sym__identifier_token] = ACTIONS(2719),
    [anon_sym_alias] = ACTIONS(2719),
    [anon_sym_global] = ACTIONS(2719),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_ref] = ACTIONS(2719),
    [anon_sym_delegate] = ACTIONS(2719),
    [anon_sym_file] = ACTIONS(2719),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(2719),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_notnull] = ACTIONS(2719),
    [anon_sym_unmanaged] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_this] = ACTIONS(2719),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_scoped] = ACTIONS(2719),
    [anon_sym_var] = ACTIONS(2719),
    [sym_predefined_type] = ACTIONS(2719),
    [anon_sym_yield] = ACTIONS(2719),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(2719),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(2719),
    [anon_sym_into] = ACTIONS(2719),
    [anon_sym_join] = ACTIONS(2719),
    [anon_sym_on] = ACTIONS(2719),
    [anon_sym_equals] = ACTIONS(2719),
    [anon_sym_let] = ACTIONS(2719),
    [anon_sym_orderby] = ACTIONS(2719),
    [anon_sym_ascending] = ACTIONS(2719),
    [anon_sym_descending] = ACTIONS(2719),
    [anon_sym_group] = ACTIONS(2719),
    [anon_sym_by] = ACTIONS(2719),
    [anon_sym_select] = ACTIONS(2719),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2226] = {
    [sym__variable_designation] = STATE(4203),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2226),
    [sym_preproc_endregion] = STATE(2226),
    [sym_preproc_line] = STATE(2226),
    [sym_preproc_pragma] = STATE(2226),
    [sym_preproc_nullable] = STATE(2226),
    [sym_preproc_error] = STATE(2226),
    [sym_preproc_warning] = STATE(2226),
    [sym_preproc_define] = STATE(2226),
    [sym_preproc_undef] = STATE(2226),
    [sym__identifier_token] = ACTIONS(3848),
    [anon_sym_alias] = ACTIONS(3852),
    [anon_sym_global] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3852),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3852),
    [anon_sym_unmanaged] = ACTIONS(3852),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3852),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3852),
    [anon_sym_yield] = ACTIONS(3852),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3852),
    [sym_discard] = ACTIONS(3860),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3852),
    [anon_sym_into] = ACTIONS(3852),
    [anon_sym_join] = ACTIONS(3852),
    [anon_sym_on] = ACTIONS(3852),
    [anon_sym_equals] = ACTIONS(3852),
    [anon_sym_let] = ACTIONS(3852),
    [anon_sym_orderby] = ACTIONS(3852),
    [anon_sym_ascending] = ACTIONS(3852),
    [anon_sym_descending] = ACTIONS(3852),
    [anon_sym_group] = ACTIONS(3852),
    [anon_sym_by] = ACTIONS(3852),
    [anon_sym_select] = ACTIONS(3852),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2227] = {
    [sym__variable_designation] = STATE(3396),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2227),
    [sym_preproc_endregion] = STATE(2227),
    [sym_preproc_line] = STATE(2227),
    [sym_preproc_pragma] = STATE(2227),
    [sym_preproc_nullable] = STATE(2227),
    [sym_preproc_error] = STATE(2227),
    [sym_preproc_warning] = STATE(2227),
    [sym_preproc_define] = STATE(2227),
    [sym_preproc_undef] = STATE(2227),
    [sym__identifier_token] = ACTIONS(3622),
    [anon_sym_alias] = ACTIONS(3626),
    [anon_sym_global] = ACTIONS(3626),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3636),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3626),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3626),
    [anon_sym_unmanaged] = ACTIONS(3626),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3626),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3626),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3626),
    [sym_discard] = ACTIONS(3640),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3626),
    [anon_sym_into] = ACTIONS(3626),
    [anon_sym_join] = ACTIONS(3626),
    [anon_sym_on] = ACTIONS(3626),
    [anon_sym_equals] = ACTIONS(3626),
    [anon_sym_let] = ACTIONS(3626),
    [anon_sym_orderby] = ACTIONS(3626),
    [anon_sym_ascending] = ACTIONS(3626),
    [anon_sym_descending] = ACTIONS(3626),
    [anon_sym_group] = ACTIONS(3626),
    [anon_sym_by] = ACTIONS(3626),
    [anon_sym_select] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2228] = {
    [sym__variable_designation] = STATE(3546),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2228),
    [sym_preproc_endregion] = STATE(2228),
    [sym_preproc_line] = STATE(2228),
    [sym_preproc_pragma] = STATE(2228),
    [sym_preproc_nullable] = STATE(2228),
    [sym_preproc_error] = STATE(2228),
    [sym_preproc_warning] = STATE(2228),
    [sym_preproc_define] = STATE(2228),
    [sym_preproc_undef] = STATE(2228),
    [sym__identifier_token] = ACTIONS(3622),
    [anon_sym_alias] = ACTIONS(3626),
    [anon_sym_global] = ACTIONS(3626),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3626),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3626),
    [anon_sym_unmanaged] = ACTIONS(3626),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3626),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3626),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3626),
    [sym_discard] = ACTIONS(3656),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3626),
    [anon_sym_into] = ACTIONS(3626),
    [anon_sym_join] = ACTIONS(3626),
    [anon_sym_on] = ACTIONS(3626),
    [anon_sym_equals] = ACTIONS(3626),
    [anon_sym_let] = ACTIONS(3626),
    [anon_sym_orderby] = ACTIONS(3626),
    [anon_sym_ascending] = ACTIONS(3626),
    [anon_sym_descending] = ACTIONS(3626),
    [anon_sym_group] = ACTIONS(3626),
    [anon_sym_by] = ACTIONS(3626),
    [anon_sym_select] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2229] = {
    [sym_type_argument_list] = STATE(2273),
    [sym_preproc_region] = STATE(2229),
    [sym_preproc_endregion] = STATE(2229),
    [sym_preproc_line] = STATE(2229),
    [sym_preproc_pragma] = STATE(2229),
    [sym_preproc_nullable] = STATE(2229),
    [sym_preproc_error] = STATE(2229),
    [sym_preproc_warning] = STATE(2229),
    [sym_preproc_define] = STATE(2229),
    [sym_preproc_undef] = STATE(2229),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3864),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2230] = {
    [sym__variable_designation] = STATE(3546),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(2616),
    [sym_preproc_region] = STATE(2230),
    [sym_preproc_endregion] = STATE(2230),
    [sym_preproc_line] = STATE(2230),
    [sym_preproc_pragma] = STATE(2230),
    [sym_preproc_nullable] = STATE(2230),
    [sym_preproc_error] = STATE(2230),
    [sym_preproc_warning] = STATE(2230),
    [sym_preproc_define] = STATE(2230),
    [sym_preproc_undef] = STATE(2230),
    [sym__identifier_token] = ACTIONS(3739),
    [anon_sym_alias] = ACTIONS(3743),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3743),
    [anon_sym_unmanaged] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3743),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3743),
    [sym_discard] = ACTIONS(3656),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_into] = ACTIONS(3743),
    [anon_sym_join] = ACTIONS(3743),
    [anon_sym_on] = ACTIONS(3743),
    [anon_sym_equals] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_orderby] = ACTIONS(3743),
    [anon_sym_ascending] = ACTIONS(3743),
    [anon_sym_descending] = ACTIONS(3743),
    [anon_sym_group] = ACTIONS(3743),
    [anon_sym_by] = ACTIONS(3743),
    [anon_sym_select] = ACTIONS(3743),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2231] = {
    [sym__name] = STATE(3586),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_ref_type] = STATE(2994),
    [sym__scoped_base_type] = STATE(2965),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2231),
    [sym_preproc_endregion] = STATE(2231),
    [sym_preproc_line] = STATE(2231),
    [sym_preproc_pragma] = STATE(2231),
    [sym_preproc_nullable] = STATE(2231),
    [sym_preproc_error] = STATE(2231),
    [sym_preproc_warning] = STATE(2231),
    [sym_preproc_define] = STATE(2231),
    [sym_preproc_undef] = STATE(2231),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3875),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2232] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2232),
    [sym_preproc_endregion] = STATE(2232),
    [sym_preproc_line] = STATE(2232),
    [sym_preproc_pragma] = STATE(2232),
    [sym_preproc_nullable] = STATE(2232),
    [sym_preproc_error] = STATE(2232),
    [sym_preproc_warning] = STATE(2232),
    [sym_preproc_define] = STATE(2232),
    [sym_preproc_undef] = STATE(2232),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2233] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2233),
    [sym_preproc_endregion] = STATE(2233),
    [sym_preproc_line] = STATE(2233),
    [sym_preproc_pragma] = STATE(2233),
    [sym_preproc_nullable] = STATE(2233),
    [sym_preproc_error] = STATE(2233),
    [sym_preproc_warning] = STATE(2233),
    [sym_preproc_define] = STATE(2233),
    [sym_preproc_undef] = STATE(2233),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3837),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2234] = {
    [sym_preproc_region] = STATE(2234),
    [sym_preproc_endregion] = STATE(2234),
    [sym_preproc_line] = STATE(2234),
    [sym_preproc_pragma] = STATE(2234),
    [sym_preproc_nullable] = STATE(2234),
    [sym_preproc_error] = STATE(2234),
    [sym_preproc_warning] = STATE(2234),
    [sym_preproc_define] = STATE(2234),
    [sym_preproc_undef] = STATE(2234),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2235] = {
    [sym_preproc_region] = STATE(2235),
    [sym_preproc_endregion] = STATE(2235),
    [sym_preproc_line] = STATE(2235),
    [sym_preproc_pragma] = STATE(2235),
    [sym_preproc_nullable] = STATE(2235),
    [sym_preproc_error] = STATE(2235),
    [sym_preproc_warning] = STATE(2235),
    [sym_preproc_define] = STATE(2235),
    [sym_preproc_undef] = STATE(2235),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(3787),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_ref] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_delegate] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_readonly] = ACTIONS(3785),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(3785),
    [anon_sym_out] = ACTIONS(3785),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(3785),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_params] = ACTIONS(3785),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_var] = ACTIONS(3785),
    [sym_predefined_type] = ACTIONS(3785),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_if_token3] = ACTIONS(2991),
    [aux_sym_preproc_else_token1] = ACTIONS(2991),
    [aux_sym_preproc_elif_token1] = ACTIONS(2991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2236] = {
    [sym__variable_designation] = STATE(4203),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2236),
    [sym_preproc_endregion] = STATE(2236),
    [sym_preproc_line] = STATE(2236),
    [sym_preproc_pragma] = STATE(2236),
    [sym_preproc_nullable] = STATE(2236),
    [sym_preproc_error] = STATE(2236),
    [sym_preproc_warning] = STATE(2236),
    [sym_preproc_define] = STATE(2236),
    [sym_preproc_undef] = STATE(2236),
    [sym__identifier_token] = ACTIONS(3883),
    [anon_sym_alias] = ACTIONS(3887),
    [anon_sym_global] = ACTIONS(3887),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3887),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3887),
    [anon_sym_unmanaged] = ACTIONS(3887),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3887),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3887),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3887),
    [sym_discard] = ACTIONS(3860),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3887),
    [anon_sym_into] = ACTIONS(3887),
    [anon_sym_join] = ACTIONS(3887),
    [anon_sym_on] = ACTIONS(3887),
    [anon_sym_equals] = ACTIONS(3887),
    [anon_sym_let] = ACTIONS(3887),
    [anon_sym_orderby] = ACTIONS(3887),
    [anon_sym_ascending] = ACTIONS(3887),
    [anon_sym_descending] = ACTIONS(3887),
    [anon_sym_group] = ACTIONS(3887),
    [anon_sym_by] = ACTIONS(3887),
    [anon_sym_select] = ACTIONS(3887),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2237] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2237),
    [sym_preproc_endregion] = STATE(2237),
    [sym_preproc_line] = STATE(2237),
    [sym_preproc_pragma] = STATE(2237),
    [sym_preproc_nullable] = STATE(2237),
    [sym_preproc_error] = STATE(2237),
    [sym_preproc_warning] = STATE(2237),
    [sym_preproc_define] = STATE(2237),
    [sym_preproc_undef] = STATE(2237),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2238] = {
    [sym_preproc_region] = STATE(2238),
    [sym_preproc_endregion] = STATE(2238),
    [sym_preproc_line] = STATE(2238),
    [sym_preproc_pragma] = STATE(2238),
    [sym_preproc_nullable] = STATE(2238),
    [sym_preproc_error] = STATE(2238),
    [sym_preproc_warning] = STATE(2238),
    [sym_preproc_define] = STATE(2238),
    [sym_preproc_undef] = STATE(2238),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2239] = {
    [sym_preproc_region] = STATE(2239),
    [sym_preproc_endregion] = STATE(2239),
    [sym_preproc_line] = STATE(2239),
    [sym_preproc_pragma] = STATE(2239),
    [sym_preproc_nullable] = STATE(2239),
    [sym_preproc_error] = STATE(2239),
    [sym_preproc_warning] = STATE(2239),
    [sym_preproc_define] = STATE(2239),
    [sym_preproc_undef] = STATE(2239),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3630),
  },
  [2240] = {
    [sym__name] = STATE(3127),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_ref_type] = STATE(3016),
    [sym__scoped_base_type] = STATE(3025),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2240),
    [sym_preproc_endregion] = STATE(2240),
    [sym_preproc_line] = STATE(2240),
    [sym_preproc_pragma] = STATE(2240),
    [sym_preproc_nullable] = STATE(2240),
    [sym_preproc_error] = STATE(2240),
    [sym_preproc_warning] = STATE(2240),
    [sym_preproc_define] = STATE(2240),
    [sym_preproc_undef] = STATE(2240),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2241] = {
    [sym_preproc_region] = STATE(2241),
    [sym_preproc_endregion] = STATE(2241),
    [sym_preproc_line] = STATE(2241),
    [sym_preproc_pragma] = STATE(2241),
    [sym_preproc_nullable] = STATE(2241),
    [sym_preproc_error] = STATE(2241),
    [sym_preproc_warning] = STATE(2241),
    [sym_preproc_define] = STATE(2241),
    [sym_preproc_undef] = STATE(2241),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3718),
    [anon_sym_RBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3718),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2242] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2279),
    [sym_property_pattern_clause] = STATE(2322),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2242),
    [sym_preproc_endregion] = STATE(2242),
    [sym_preproc_line] = STATE(2242),
    [sym_preproc_pragma] = STATE(2242),
    [sym_preproc_nullable] = STATE(2242),
    [sym_preproc_error] = STATE(2242),
    [sym_preproc_warning] = STATE(2242),
    [sym_preproc_define] = STATE(2242),
    [sym_preproc_undef] = STATE(2242),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_if_token3] = ACTIONS(3901),
    [aux_sym_preproc_else_token1] = ACTIONS(3901),
    [aux_sym_preproc_elif_token1] = ACTIONS(3901),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2243] = {
    [sym_preproc_region] = STATE(2243),
    [sym_preproc_endregion] = STATE(2243),
    [sym_preproc_line] = STATE(2243),
    [sym_preproc_pragma] = STATE(2243),
    [sym_preproc_nullable] = STATE(2243),
    [sym_preproc_error] = STATE(2243),
    [sym_preproc_warning] = STATE(2243),
    [sym_preproc_define] = STATE(2243),
    [sym_preproc_undef] = STATE(2243),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2244] = {
    [sym_preproc_region] = STATE(2244),
    [sym_preproc_endregion] = STATE(2244),
    [sym_preproc_line] = STATE(2244),
    [sym_preproc_pragma] = STATE(2244),
    [sym_preproc_nullable] = STATE(2244),
    [sym_preproc_error] = STATE(2244),
    [sym_preproc_warning] = STATE(2244),
    [sym_preproc_define] = STATE(2244),
    [sym_preproc_undef] = STATE(2244),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3664),
  },
  [2245] = {
    [sym_preproc_region] = STATE(2245),
    [sym_preproc_endregion] = STATE(2245),
    [sym_preproc_line] = STATE(2245),
    [sym_preproc_pragma] = STATE(2245),
    [sym_preproc_nullable] = STATE(2245),
    [sym_preproc_error] = STATE(2245),
    [sym_preproc_warning] = STATE(2245),
    [sym_preproc_define] = STATE(2245),
    [sym_preproc_undef] = STATE(2245),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2246] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2279),
    [sym_property_pattern_clause] = STATE(2322),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2246),
    [sym_preproc_endregion] = STATE(2246),
    [sym_preproc_line] = STATE(2246),
    [sym_preproc_pragma] = STATE(2246),
    [sym_preproc_nullable] = STATE(2246),
    [sym_preproc_error] = STATE(2246),
    [sym_preproc_warning] = STATE(2246),
    [sym_preproc_define] = STATE(2246),
    [sym_preproc_undef] = STATE(2246),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_RBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_if_token3] = ACTIONS(3911),
    [aux_sym_preproc_else_token1] = ACTIONS(3911),
    [aux_sym_preproc_elif_token1] = ACTIONS(3911),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2247] = {
    [sym_preproc_region] = STATE(2247),
    [sym_preproc_endregion] = STATE(2247),
    [sym_preproc_line] = STATE(2247),
    [sym_preproc_pragma] = STATE(2247),
    [sym_preproc_nullable] = STATE(2247),
    [sym_preproc_error] = STATE(2247),
    [sym_preproc_warning] = STATE(2247),
    [sym_preproc_define] = STATE(2247),
    [sym_preproc_undef] = STATE(2247),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_RBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2248] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2279),
    [sym_property_pattern_clause] = STATE(2322),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2248),
    [sym_preproc_endregion] = STATE(2248),
    [sym_preproc_line] = STATE(2248),
    [sym_preproc_pragma] = STATE(2248),
    [sym_preproc_nullable] = STATE(2248),
    [sym_preproc_error] = STATE(2248),
    [sym_preproc_warning] = STATE(2248),
    [sym_preproc_define] = STATE(2248),
    [sym_preproc_undef] = STATE(2248),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_if_token3] = ACTIONS(3901),
    [aux_sym_preproc_else_token1] = ACTIONS(3901),
    [aux_sym_preproc_elif_token1] = ACTIONS(3901),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2249] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2302),
    [sym_property_pattern_clause] = STATE(2367),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2249),
    [sym_preproc_endregion] = STATE(2249),
    [sym_preproc_line] = STATE(2249),
    [sym_preproc_pragma] = STATE(2249),
    [sym_preproc_nullable] = STATE(2249),
    [sym_preproc_error] = STATE(2249),
    [sym_preproc_warning] = STATE(2249),
    [sym_preproc_define] = STATE(2249),
    [sym_preproc_undef] = STATE(2249),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_RBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_if_token3] = ACTIONS(3911),
    [aux_sym_preproc_else_token1] = ACTIONS(3911),
    [aux_sym_preproc_elif_token1] = ACTIONS(3911),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2250] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2302),
    [sym_property_pattern_clause] = STATE(2367),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2250),
    [sym_preproc_endregion] = STATE(2250),
    [sym_preproc_line] = STATE(2250),
    [sym_preproc_pragma] = STATE(2250),
    [sym_preproc_nullable] = STATE(2250),
    [sym_preproc_error] = STATE(2250),
    [sym_preproc_warning] = STATE(2250),
    [sym_preproc_define] = STATE(2250),
    [sym_preproc_undef] = STATE(2250),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_if_token3] = ACTIONS(3901),
    [aux_sym_preproc_else_token1] = ACTIONS(3901),
    [aux_sym_preproc_elif_token1] = ACTIONS(3901),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2251] = {
    [sym_preproc_region] = STATE(2251),
    [sym_preproc_endregion] = STATE(2251),
    [sym_preproc_line] = STATE(2251),
    [sym_preproc_pragma] = STATE(2251),
    [sym_preproc_nullable] = STATE(2251),
    [sym_preproc_error] = STATE(2251),
    [sym_preproc_warning] = STATE(2251),
    [sym_preproc_define] = STATE(2251),
    [sym_preproc_undef] = STATE(2251),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2252] = {
    [sym_preproc_region] = STATE(2252),
    [sym_preproc_endregion] = STATE(2252),
    [sym_preproc_line] = STATE(2252),
    [sym_preproc_pragma] = STATE(2252),
    [sym_preproc_nullable] = STATE(2252),
    [sym_preproc_error] = STATE(2252),
    [sym_preproc_warning] = STATE(2252),
    [sym_preproc_define] = STATE(2252),
    [sym_preproc_undef] = STATE(2252),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2253] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2302),
    [sym_property_pattern_clause] = STATE(2367),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2253),
    [sym_preproc_endregion] = STATE(2253),
    [sym_preproc_line] = STATE(2253),
    [sym_preproc_pragma] = STATE(2253),
    [sym_preproc_nullable] = STATE(2253),
    [sym_preproc_error] = STATE(2253),
    [sym_preproc_warning] = STATE(2253),
    [sym_preproc_define] = STATE(2253),
    [sym_preproc_undef] = STATE(2253),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_if_token3] = ACTIONS(3901),
    [aux_sym_preproc_else_token1] = ACTIONS(3901),
    [aux_sym_preproc_elif_token1] = ACTIONS(3901),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2254] = {
    [sym_preproc_region] = STATE(2254),
    [sym_preproc_endregion] = STATE(2254),
    [sym_preproc_line] = STATE(2254),
    [sym_preproc_pragma] = STATE(2254),
    [sym_preproc_nullable] = STATE(2254),
    [sym_preproc_error] = STATE(2254),
    [sym_preproc_warning] = STATE(2254),
    [sym_preproc_define] = STATE(2254),
    [sym_preproc_undef] = STATE(2254),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2255] = {
    [sym_type_argument_list] = STATE(2273),
    [sym_preproc_region] = STATE(2255),
    [sym_preproc_endregion] = STATE(2255),
    [sym_preproc_line] = STATE(2255),
    [sym_preproc_pragma] = STATE(2255),
    [sym_preproc_nullable] = STATE(2255),
    [sym_preproc_error] = STATE(2255),
    [sym_preproc_warning] = STATE(2255),
    [sym_preproc_define] = STATE(2255),
    [sym_preproc_undef] = STATE(2255),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3864),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2256] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2256),
    [sym_preproc_endregion] = STATE(2256),
    [sym_preproc_line] = STATE(2256),
    [sym_preproc_pragma] = STATE(2256),
    [sym_preproc_nullable] = STATE(2256),
    [sym_preproc_error] = STATE(2256),
    [sym_preproc_warning] = STATE(2256),
    [sym_preproc_define] = STATE(2256),
    [sym_preproc_undef] = STATE(2256),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2257] = {
    [sym_preproc_region] = STATE(2257),
    [sym_preproc_endregion] = STATE(2257),
    [sym_preproc_line] = STATE(2257),
    [sym_preproc_pragma] = STATE(2257),
    [sym_preproc_nullable] = STATE(2257),
    [sym_preproc_error] = STATE(2257),
    [sym_preproc_warning] = STATE(2257),
    [sym_preproc_define] = STATE(2257),
    [sym_preproc_undef] = STATE(2257),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_break] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2258] = {
    [sym_type_argument_list] = STATE(2273),
    [sym_preproc_region] = STATE(2258),
    [sym_preproc_endregion] = STATE(2258),
    [sym_preproc_line] = STATE(2258),
    [sym_preproc_pragma] = STATE(2258),
    [sym_preproc_nullable] = STATE(2258),
    [sym_preproc_error] = STATE(2258),
    [sym_preproc_warning] = STATE(2258),
    [sym_preproc_define] = STATE(2258),
    [sym_preproc_undef] = STATE(2258),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3864),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2259] = {
    [sym_preproc_region] = STATE(2259),
    [sym_preproc_endregion] = STATE(2259),
    [sym_preproc_line] = STATE(2259),
    [sym_preproc_pragma] = STATE(2259),
    [sym_preproc_nullable] = STATE(2259),
    [sym_preproc_error] = STATE(2259),
    [sym_preproc_warning] = STATE(2259),
    [sym_preproc_define] = STATE(2259),
    [sym_preproc_undef] = STATE(2259),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2260] = {
    [sym_preproc_region] = STATE(2260),
    [sym_preproc_endregion] = STATE(2260),
    [sym_preproc_line] = STATE(2260),
    [sym_preproc_pragma] = STATE(2260),
    [sym_preproc_nullable] = STATE(2260),
    [sym_preproc_error] = STATE(2260),
    [sym_preproc_warning] = STATE(2260),
    [sym_preproc_define] = STATE(2260),
    [sym_preproc_undef] = STATE(2260),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3713),
  },
  [2261] = {
    [sym_preproc_region] = STATE(2261),
    [sym_preproc_endregion] = STATE(2261),
    [sym_preproc_line] = STATE(2261),
    [sym_preproc_pragma] = STATE(2261),
    [sym_preproc_nullable] = STATE(2261),
    [sym_preproc_error] = STATE(2261),
    [sym_preproc_warning] = STATE(2261),
    [sym_preproc_define] = STATE(2261),
    [sym_preproc_undef] = STATE(2261),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3699),
  },
  [2262] = {
    [sym_preproc_region] = STATE(2262),
    [sym_preproc_endregion] = STATE(2262),
    [sym_preproc_line] = STATE(2262),
    [sym_preproc_pragma] = STATE(2262),
    [sym_preproc_nullable] = STATE(2262),
    [sym_preproc_error] = STATE(2262),
    [sym_preproc_warning] = STATE(2262),
    [sym_preproc_define] = STATE(2262),
    [sym_preproc_undef] = STATE(2262),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2263] = {
    [sym_preproc_region] = STATE(2263),
    [sym_preproc_endregion] = STATE(2263),
    [sym_preproc_line] = STATE(2263),
    [sym_preproc_pragma] = STATE(2263),
    [sym_preproc_nullable] = STATE(2263),
    [sym_preproc_error] = STATE(2263),
    [sym_preproc_warning] = STATE(2263),
    [sym_preproc_define] = STATE(2263),
    [sym_preproc_undef] = STATE(2263),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2264] = {
    [sym_preproc_region] = STATE(2264),
    [sym_preproc_endregion] = STATE(2264),
    [sym_preproc_line] = STATE(2264),
    [sym_preproc_pragma] = STATE(2264),
    [sym_preproc_nullable] = STATE(2264),
    [sym_preproc_error] = STATE(2264),
    [sym_preproc_warning] = STATE(2264),
    [sym_preproc_define] = STATE(2264),
    [sym_preproc_undef] = STATE(2264),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3703),
  },
  [2265] = {
    [sym_preproc_region] = STATE(2265),
    [sym_preproc_endregion] = STATE(2265),
    [sym_preproc_line] = STATE(2265),
    [sym_preproc_pragma] = STATE(2265),
    [sym_preproc_nullable] = STATE(2265),
    [sym_preproc_error] = STATE(2265),
    [sym_preproc_warning] = STATE(2265),
    [sym_preproc_define] = STATE(2265),
    [sym_preproc_undef] = STATE(2265),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2266] = {
    [sym_preproc_region] = STATE(2266),
    [sym_preproc_endregion] = STATE(2266),
    [sym_preproc_line] = STATE(2266),
    [sym_preproc_pragma] = STATE(2266),
    [sym_preproc_nullable] = STATE(2266),
    [sym_preproc_error] = STATE(2266),
    [sym_preproc_warning] = STATE(2266),
    [sym_preproc_define] = STATE(2266),
    [sym_preproc_undef] = STATE(2266),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2267] = {
    [sym_preproc_region] = STATE(2267),
    [sym_preproc_endregion] = STATE(2267),
    [sym_preproc_line] = STATE(2267),
    [sym_preproc_pragma] = STATE(2267),
    [sym_preproc_nullable] = STATE(2267),
    [sym_preproc_error] = STATE(2267),
    [sym_preproc_warning] = STATE(2267),
    [sym_preproc_define] = STATE(2267),
    [sym_preproc_undef] = STATE(2267),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_RPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2268] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2268),
    [sym_preproc_endregion] = STATE(2268),
    [sym_preproc_line] = STATE(2268),
    [sym_preproc_pragma] = STATE(2268),
    [sym_preproc_nullable] = STATE(2268),
    [sym_preproc_error] = STATE(2268),
    [sym_preproc_warning] = STATE(2268),
    [sym_preproc_define] = STATE(2268),
    [sym_preproc_undef] = STATE(2268),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2269] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2269),
    [sym_preproc_endregion] = STATE(2269),
    [sym_preproc_line] = STATE(2269),
    [sym_preproc_pragma] = STATE(2269),
    [sym_preproc_nullable] = STATE(2269),
    [sym_preproc_error] = STATE(2269),
    [sym_preproc_warning] = STATE(2269),
    [sym_preproc_define] = STATE(2269),
    [sym_preproc_undef] = STATE(2269),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2270] = {
    [sym_preproc_region] = STATE(2270),
    [sym_preproc_endregion] = STATE(2270),
    [sym_preproc_line] = STATE(2270),
    [sym_preproc_pragma] = STATE(2270),
    [sym_preproc_nullable] = STATE(2270),
    [sym_preproc_error] = STATE(2270),
    [sym_preproc_warning] = STATE(2270),
    [sym_preproc_define] = STATE(2270),
    [sym_preproc_undef] = STATE(2270),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2271] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2271),
    [sym_preproc_endregion] = STATE(2271),
    [sym_preproc_line] = STATE(2271),
    [sym_preproc_pragma] = STATE(2271),
    [sym_preproc_nullable] = STATE(2271),
    [sym_preproc_error] = STATE(2271),
    [sym_preproc_warning] = STATE(2271),
    [sym_preproc_define] = STATE(2271),
    [sym_preproc_undef] = STATE(2271),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2272] = {
    [sym_preproc_region] = STATE(2272),
    [sym_preproc_endregion] = STATE(2272),
    [sym_preproc_line] = STATE(2272),
    [sym_preproc_pragma] = STATE(2272),
    [sym_preproc_nullable] = STATE(2272),
    [sym_preproc_error] = STATE(2272),
    [sym_preproc_warning] = STATE(2272),
    [sym_preproc_define] = STATE(2272),
    [sym_preproc_undef] = STATE(2272),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2273] = {
    [sym_preproc_region] = STATE(2273),
    [sym_preproc_endregion] = STATE(2273),
    [sym_preproc_line] = STATE(2273),
    [sym_preproc_pragma] = STATE(2273),
    [sym_preproc_nullable] = STATE(2273),
    [sym_preproc_error] = STATE(2273),
    [sym_preproc_warning] = STATE(2273),
    [sym_preproc_define] = STATE(2273),
    [sym_preproc_undef] = STATE(2273),
    [sym__identifier_token] = ACTIONS(3666),
    [anon_sym_alias] = ACTIONS(3666),
    [anon_sym_global] = ACTIONS(3666),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_file] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_where] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_notnull] = ACTIONS(3666),
    [anon_sym_unmanaged] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3666),
    [anon_sym_CARET] = ACTIONS(3666),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3666),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3666),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_scoped] = ACTIONS(3666),
    [anon_sym_var] = ACTIONS(3666),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_switch] = ACTIONS(3666),
    [anon_sym_when] = ACTIONS(3666),
    [sym_discard] = ACTIONS(3666),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3666),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_PLUS_EQ] = ACTIONS(3668),
    [anon_sym_DASH_EQ] = ACTIONS(3668),
    [anon_sym_STAR_EQ] = ACTIONS(3668),
    [anon_sym_SLASH_EQ] = ACTIONS(3668),
    [anon_sym_PERCENT_EQ] = ACTIONS(3668),
    [anon_sym_AMP_EQ] = ACTIONS(3668),
    [anon_sym_CARET_EQ] = ACTIONS(3668),
    [anon_sym_PIPE_EQ] = ACTIONS(3668),
    [anon_sym_LT_LT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3666),
    [anon_sym_from] = ACTIONS(3666),
    [anon_sym_into] = ACTIONS(3666),
    [anon_sym_join] = ACTIONS(3666),
    [anon_sym_on] = ACTIONS(3666),
    [anon_sym_equals] = ACTIONS(3666),
    [anon_sym_let] = ACTIONS(3666),
    [anon_sym_orderby] = ACTIONS(3666),
    [anon_sym_ascending] = ACTIONS(3666),
    [anon_sym_descending] = ACTIONS(3666),
    [anon_sym_group] = ACTIONS(3666),
    [anon_sym_by] = ACTIONS(3666),
    [anon_sym_select] = ACTIONS(3666),
    [anon_sym_as] = ACTIONS(3666),
    [anon_sym_is] = ACTIONS(3666),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3666),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3668),
  },
  [2274] = {
    [sym_preproc_region] = STATE(2274),
    [sym_preproc_endregion] = STATE(2274),
    [sym_preproc_line] = STATE(2274),
    [sym_preproc_pragma] = STATE(2274),
    [sym_preproc_nullable] = STATE(2274),
    [sym_preproc_error] = STATE(2274),
    [sym_preproc_warning] = STATE(2274),
    [sym_preproc_define] = STATE(2274),
    [sym_preproc_undef] = STATE(2274),
    [sym__identifier_token] = ACTIONS(3684),
    [anon_sym_alias] = ACTIONS(3684),
    [anon_sym_global] = ACTIONS(3684),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_file] = ACTIONS(3684),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_where] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_notnull] = ACTIONS(3684),
    [anon_sym_unmanaged] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_scoped] = ACTIONS(3684),
    [anon_sym_var] = ACTIONS(3684),
    [anon_sym_yield] = ACTIONS(3684),
    [anon_sym_switch] = ACTIONS(3684),
    [anon_sym_when] = ACTIONS(3684),
    [sym_discard] = ACTIONS(3684),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3684),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_PLUS_EQ] = ACTIONS(3686),
    [anon_sym_DASH_EQ] = ACTIONS(3686),
    [anon_sym_STAR_EQ] = ACTIONS(3686),
    [anon_sym_SLASH_EQ] = ACTIONS(3686),
    [anon_sym_PERCENT_EQ] = ACTIONS(3686),
    [anon_sym_AMP_EQ] = ACTIONS(3686),
    [anon_sym_CARET_EQ] = ACTIONS(3686),
    [anon_sym_PIPE_EQ] = ACTIONS(3686),
    [anon_sym_LT_LT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3684),
    [anon_sym_from] = ACTIONS(3684),
    [anon_sym_into] = ACTIONS(3684),
    [anon_sym_join] = ACTIONS(3684),
    [anon_sym_on] = ACTIONS(3684),
    [anon_sym_equals] = ACTIONS(3684),
    [anon_sym_let] = ACTIONS(3684),
    [anon_sym_orderby] = ACTIONS(3684),
    [anon_sym_ascending] = ACTIONS(3684),
    [anon_sym_descending] = ACTIONS(3684),
    [anon_sym_group] = ACTIONS(3684),
    [anon_sym_by] = ACTIONS(3684),
    [anon_sym_select] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_is] = ACTIONS(3684),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3684),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3686),
  },
  [2275] = {
    [sym_preproc_region] = STATE(2275),
    [sym_preproc_endregion] = STATE(2275),
    [sym_preproc_line] = STATE(2275),
    [sym_preproc_pragma] = STATE(2275),
    [sym_preproc_nullable] = STATE(2275),
    [sym_preproc_error] = STATE(2275),
    [sym_preproc_warning] = STATE(2275),
    [sym_preproc_define] = STATE(2275),
    [sym_preproc_undef] = STATE(2275),
    [sym__identifier_token] = ACTIONS(3670),
    [anon_sym_alias] = ACTIONS(3670),
    [anon_sym_global] = ACTIONS(3670),
    [anon_sym_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_file] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_where] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_notnull] = ACTIONS(3670),
    [anon_sym_unmanaged] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_scoped] = ACTIONS(3670),
    [anon_sym_var] = ACTIONS(3670),
    [anon_sym_yield] = ACTIONS(3670),
    [anon_sym_switch] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [sym_discard] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3672),
    [anon_sym_DASH_EQ] = ACTIONS(3672),
    [anon_sym_STAR_EQ] = ACTIONS(3672),
    [anon_sym_SLASH_EQ] = ACTIONS(3672),
    [anon_sym_PERCENT_EQ] = ACTIONS(3672),
    [anon_sym_AMP_EQ] = ACTIONS(3672),
    [anon_sym_CARET_EQ] = ACTIONS(3672),
    [anon_sym_PIPE_EQ] = ACTIONS(3672),
    [anon_sym_LT_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3670),
    [anon_sym_from] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3670),
    [anon_sym_join] = ACTIONS(3670),
    [anon_sym_on] = ACTIONS(3670),
    [anon_sym_equals] = ACTIONS(3670),
    [anon_sym_let] = ACTIONS(3670),
    [anon_sym_orderby] = ACTIONS(3670),
    [anon_sym_ascending] = ACTIONS(3670),
    [anon_sym_descending] = ACTIONS(3670),
    [anon_sym_group] = ACTIONS(3670),
    [anon_sym_by] = ACTIONS(3670),
    [anon_sym_select] = ACTIONS(3670),
    [anon_sym_as] = ACTIONS(3670),
    [anon_sym_is] = ACTIONS(3670),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3670),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3672),
  },
  [2276] = {
    [sym_preproc_region] = STATE(2276),
    [sym_preproc_endregion] = STATE(2276),
    [sym_preproc_line] = STATE(2276),
    [sym_preproc_pragma] = STATE(2276),
    [sym_preproc_nullable] = STATE(2276),
    [sym_preproc_error] = STATE(2276),
    [sym_preproc_warning] = STATE(2276),
    [sym_preproc_define] = STATE(2276),
    [sym_preproc_undef] = STATE(2276),
    [sym__identifier_token] = ACTIONS(3674),
    [anon_sym_alias] = ACTIONS(3674),
    [anon_sym_global] = ACTIONS(3674),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_file] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_notnull] = ACTIONS(3674),
    [anon_sym_unmanaged] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_scoped] = ACTIONS(3674),
    [anon_sym_var] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3674),
    [anon_sym_switch] = ACTIONS(3674),
    [anon_sym_when] = ACTIONS(3674),
    [sym_discard] = ACTIONS(3674),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_PLUS_EQ] = ACTIONS(3676),
    [anon_sym_DASH_EQ] = ACTIONS(3676),
    [anon_sym_STAR_EQ] = ACTIONS(3676),
    [anon_sym_SLASH_EQ] = ACTIONS(3676),
    [anon_sym_PERCENT_EQ] = ACTIONS(3676),
    [anon_sym_AMP_EQ] = ACTIONS(3676),
    [anon_sym_CARET_EQ] = ACTIONS(3676),
    [anon_sym_PIPE_EQ] = ACTIONS(3676),
    [anon_sym_LT_LT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3674),
    [anon_sym_from] = ACTIONS(3674),
    [anon_sym_into] = ACTIONS(3674),
    [anon_sym_join] = ACTIONS(3674),
    [anon_sym_on] = ACTIONS(3674),
    [anon_sym_equals] = ACTIONS(3674),
    [anon_sym_let] = ACTIONS(3674),
    [anon_sym_orderby] = ACTIONS(3674),
    [anon_sym_ascending] = ACTIONS(3674),
    [anon_sym_descending] = ACTIONS(3674),
    [anon_sym_group] = ACTIONS(3674),
    [anon_sym_by] = ACTIONS(3674),
    [anon_sym_select] = ACTIONS(3674),
    [anon_sym_as] = ACTIONS(3674),
    [anon_sym_is] = ACTIONS(3674),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3674),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3676),
  },
  [2277] = {
    [sym_preproc_region] = STATE(2277),
    [sym_preproc_endregion] = STATE(2277),
    [sym_preproc_line] = STATE(2277),
    [sym_preproc_pragma] = STATE(2277),
    [sym_preproc_nullable] = STATE(2277),
    [sym_preproc_error] = STATE(2277),
    [sym_preproc_warning] = STATE(2277),
    [sym_preproc_define] = STATE(2277),
    [sym_preproc_undef] = STATE(2277),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3923),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_break] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2278] = {
    [sym_property_pattern_clause] = STATE(2324),
    [sym__variable_designation] = STATE(3286),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2278),
    [sym_preproc_endregion] = STATE(2278),
    [sym_preproc_line] = STATE(2278),
    [sym_preproc_pragma] = STATE(2278),
    [sym_preproc_nullable] = STATE(2278),
    [sym_preproc_error] = STATE(2278),
    [sym_preproc_warning] = STATE(2278),
    [sym_preproc_define] = STATE(2278),
    [sym_preproc_undef] = STATE(2278),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_if_token3] = ACTIONS(3927),
    [aux_sym_preproc_else_token1] = ACTIONS(3927),
    [aux_sym_preproc_elif_token1] = ACTIONS(3927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2279] = {
    [sym_property_pattern_clause] = STATE(2325),
    [sym__variable_designation] = STATE(3391),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2279),
    [sym_preproc_endregion] = STATE(2279),
    [sym_preproc_line] = STATE(2279),
    [sym_preproc_pragma] = STATE(2279),
    [sym_preproc_nullable] = STATE(2279),
    [sym_preproc_error] = STATE(2279),
    [sym_preproc_warning] = STATE(2279),
    [sym_preproc_define] = STATE(2279),
    [sym_preproc_undef] = STATE(2279),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_in] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_if_token3] = ACTIONS(3931),
    [aux_sym_preproc_else_token1] = ACTIONS(3931),
    [aux_sym_preproc_elif_token1] = ACTIONS(3931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2280] = {
    [sym_preproc_region] = STATE(2280),
    [sym_preproc_endregion] = STATE(2280),
    [sym_preproc_line] = STATE(2280),
    [sym_preproc_pragma] = STATE(2280),
    [sym_preproc_nullable] = STATE(2280),
    [sym_preproc_error] = STATE(2280),
    [sym_preproc_warning] = STATE(2280),
    [sym_preproc_define] = STATE(2280),
    [sym_preproc_undef] = STATE(2280),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3713),
  },
  [2281] = {
    [sym_preproc_region] = STATE(2281),
    [sym_preproc_endregion] = STATE(2281),
    [sym_preproc_line] = STATE(2281),
    [sym_preproc_pragma] = STATE(2281),
    [sym_preproc_nullable] = STATE(2281),
    [sym_preproc_error] = STATE(2281),
    [sym_preproc_warning] = STATE(2281),
    [sym_preproc_define] = STATE(2281),
    [sym_preproc_undef] = STATE(2281),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2282] = {
    [sym_preproc_region] = STATE(2282),
    [sym_preproc_endregion] = STATE(2282),
    [sym_preproc_line] = STATE(2282),
    [sym_preproc_pragma] = STATE(2282),
    [sym_preproc_nullable] = STATE(2282),
    [sym_preproc_error] = STATE(2282),
    [sym_preproc_warning] = STATE(2282),
    [sym_preproc_define] = STATE(2282),
    [sym_preproc_undef] = STATE(2282),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3664),
  },
  [2283] = {
    [sym_preproc_region] = STATE(2283),
    [sym_preproc_endregion] = STATE(2283),
    [sym_preproc_line] = STATE(2283),
    [sym_preproc_pragma] = STATE(2283),
    [sym_preproc_nullable] = STATE(2283),
    [sym_preproc_error] = STATE(2283),
    [sym_preproc_warning] = STATE(2283),
    [sym_preproc_define] = STATE(2283),
    [sym_preproc_undef] = STATE(2283),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2284] = {
    [sym_preproc_region] = STATE(2284),
    [sym_preproc_endregion] = STATE(2284),
    [sym_preproc_line] = STATE(2284),
    [sym_preproc_pragma] = STATE(2284),
    [sym_preproc_nullable] = STATE(2284),
    [sym_preproc_error] = STATE(2284),
    [sym_preproc_warning] = STATE(2284),
    [sym_preproc_define] = STATE(2284),
    [sym_preproc_undef] = STATE(2284),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_CARET] = ACTIONS(3736),
    [anon_sym_PIPE] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LT_LT] = ACTIONS(3736),
    [anon_sym_GT_GT] = ACTIONS(3736),
    [anon_sym_GT_GT_GT] = ACTIONS(3736),
    [anon_sym_EQ_EQ] = ACTIONS(3733),
    [anon_sym_BANG_EQ] = ACTIONS(3733),
    [anon_sym_GT_EQ] = ACTIONS(3733),
    [anon_sym_LT_EQ] = ACTIONS(3733),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3736),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3733),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_PIPE_PIPE] = ACTIONS(3733),
    [anon_sym_QMARK_QMARK] = ACTIONS(3736),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3736),
    [anon_sym_is] = ACTIONS(3736),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3736),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3722),
  },
  [2285] = {
    [sym_preproc_region] = STATE(2285),
    [sym_preproc_endregion] = STATE(2285),
    [sym_preproc_line] = STATE(2285),
    [sym_preproc_pragma] = STATE(2285),
    [sym_preproc_nullable] = STATE(2285),
    [sym_preproc_error] = STATE(2285),
    [sym_preproc_warning] = STATE(2285),
    [sym_preproc_define] = STATE(2285),
    [sym_preproc_undef] = STATE(2285),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3703),
  },
  [2286] = {
    [sym_preproc_region] = STATE(2286),
    [sym_preproc_endregion] = STATE(2286),
    [sym_preproc_line] = STATE(2286),
    [sym_preproc_pragma] = STATE(2286),
    [sym_preproc_nullable] = STATE(2286),
    [sym_preproc_error] = STATE(2286),
    [sym_preproc_warning] = STATE(2286),
    [sym_preproc_define] = STATE(2286),
    [sym_preproc_undef] = STATE(2286),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_RPAREN] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2287] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2287),
    [sym_preproc_endregion] = STATE(2287),
    [sym_preproc_line] = STATE(2287),
    [sym_preproc_pragma] = STATE(2287),
    [sym_preproc_nullable] = STATE(2287),
    [sym_preproc_error] = STATE(2287),
    [sym_preproc_warning] = STATE(2287),
    [sym_preproc_define] = STATE(2287),
    [sym_preproc_undef] = STATE(2287),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2288] = {
    [sym_preproc_region] = STATE(2288),
    [sym_preproc_endregion] = STATE(2288),
    [sym_preproc_line] = STATE(2288),
    [sym_preproc_pragma] = STATE(2288),
    [sym_preproc_nullable] = STATE(2288),
    [sym_preproc_error] = STATE(2288),
    [sym_preproc_warning] = STATE(2288),
    [sym_preproc_define] = STATE(2288),
    [sym_preproc_undef] = STATE(2288),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3706),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2289] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_modifier] = STATE(3740),
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5968),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(2289),
    [sym_preproc_endregion] = STATE(2289),
    [sym_preproc_line] = STATE(2289),
    [sym_preproc_pragma] = STATE(2289),
    [sym_preproc_nullable] = STATE(2289),
    [sym_preproc_error] = STATE(2289),
    [sym_preproc_warning] = STATE(2289),
    [sym_preproc_define] = STATE(2289),
    [sym_preproc_undef] = STATE(2289),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3203),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2581),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3463),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(653),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(3943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2290] = {
    [sym__name] = STATE(2643),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(2576),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2290),
    [sym_preproc_endregion] = STATE(2290),
    [sym_preproc_line] = STATE(2290),
    [sym_preproc_pragma] = STATE(2290),
    [sym_preproc_nullable] = STATE(2290),
    [sym_preproc_error] = STATE(2290),
    [sym_preproc_warning] = STATE(2290),
    [sym_preproc_define] = STATE(2290),
    [sym_preproc_undef] = STATE(2290),
    [sym__identifier_token] = ACTIONS(3593),
    [anon_sym_alias] = ACTIONS(3596),
    [anon_sym_global] = ACTIONS(3596),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3596),
    [anon_sym_unmanaged] = ACTIONS(3596),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3596),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3596),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3596),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(3596),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(3596),
    [anon_sym_equals] = ACTIONS(3596),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(3596),
    [anon_sym_select] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2291] = {
    [sym_modifier] = STATE(3166),
    [sym_variable_declaration] = STATE(7628),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5372),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5772),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2291),
    [sym_preproc_endregion] = STATE(2291),
    [sym_preproc_line] = STATE(2291),
    [sym_preproc_pragma] = STATE(2291),
    [sym_preproc_nullable] = STATE(2291),
    [sym_preproc_error] = STATE(2291),
    [sym_preproc_warning] = STATE(2291),
    [sym_preproc_define] = STATE(2291),
    [sym_preproc_undef] = STATE(2291),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3128),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(65),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3749),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3753),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3761),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_implicit] = ACTIONS(3765),
    [anon_sym_explicit] = ACTIONS(3765),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2292] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2292),
    [sym_preproc_endregion] = STATE(2292),
    [sym_preproc_line] = STATE(2292),
    [sym_preproc_pragma] = STATE(2292),
    [sym_preproc_nullable] = STATE(2292),
    [sym_preproc_error] = STATE(2292),
    [sym_preproc_warning] = STATE(2292),
    [sym_preproc_define] = STATE(2292),
    [sym_preproc_undef] = STATE(2292),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3839),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2293] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2293),
    [sym_preproc_endregion] = STATE(2293),
    [sym_preproc_line] = STATE(2293),
    [sym_preproc_pragma] = STATE(2293),
    [sym_preproc_nullable] = STATE(2293),
    [sym_preproc_error] = STATE(2293),
    [sym_preproc_warning] = STATE(2293),
    [sym_preproc_define] = STATE(2293),
    [sym_preproc_undef] = STATE(2293),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2294] = {
    [sym_preproc_region] = STATE(2294),
    [sym_preproc_endregion] = STATE(2294),
    [sym_preproc_line] = STATE(2294),
    [sym_preproc_pragma] = STATE(2294),
    [sym_preproc_nullable] = STATE(2294),
    [sym_preproc_error] = STATE(2294),
    [sym_preproc_warning] = STATE(2294),
    [sym_preproc_define] = STATE(2294),
    [sym_preproc_undef] = STATE(2294),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3706),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2295] = {
    [sym_parameter_list] = STATE(7385),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(7710),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2295),
    [sym_preproc_endregion] = STATE(2295),
    [sym_preproc_line] = STATE(2295),
    [sym_preproc_pragma] = STATE(2295),
    [sym_preproc_nullable] = STATE(2295),
    [sym_preproc_error] = STATE(2295),
    [sym_preproc_warning] = STATE(2295),
    [sym_preproc_define] = STATE(2295),
    [sym_preproc_undef] = STATE(2295),
    [sym__identifier_token] = ACTIONS(3947),
    [anon_sym_alias] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_global] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3947),
    [anon_sym_where] = ACTIONS(3947),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_notnull] = ACTIONS(3947),
    [anon_sym_unmanaged] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_scoped] = ACTIONS(3947),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_when] = ACTIONS(3947),
    [sym_discard] = ACTIONS(3947),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3947),
    [anon_sym_into] = ACTIONS(3947),
    [anon_sym_join] = ACTIONS(3947),
    [anon_sym_on] = ACTIONS(3947),
    [anon_sym_equals] = ACTIONS(3947),
    [anon_sym_let] = ACTIONS(3947),
    [anon_sym_orderby] = ACTIONS(3947),
    [anon_sym_ascending] = ACTIONS(3947),
    [anon_sym_descending] = ACTIONS(3947),
    [anon_sym_group] = ACTIONS(3947),
    [anon_sym_by] = ACTIONS(3947),
    [anon_sym_select] = ACTIONS(3947),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_is] = ACTIONS(3947),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3947),
    [aux_sym_preproc_if_token3] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2296] = {
    [sym_property_pattern_clause] = STATE(2365),
    [sym__variable_designation] = STATE(3554),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2296),
    [sym_preproc_endregion] = STATE(2296),
    [sym_preproc_line] = STATE(2296),
    [sym_preproc_pragma] = STATE(2296),
    [sym_preproc_nullable] = STATE(2296),
    [sym_preproc_error] = STATE(2296),
    [sym_preproc_warning] = STATE(2296),
    [sym_preproc_define] = STATE(2296),
    [sym_preproc_undef] = STATE(2296),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_if_token3] = ACTIONS(3927),
    [aux_sym_preproc_else_token1] = ACTIONS(3927),
    [aux_sym_preproc_elif_token1] = ACTIONS(3927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2297] = {
    [sym_preproc_region] = STATE(2297),
    [sym_preproc_endregion] = STATE(2297),
    [sym_preproc_line] = STATE(2297),
    [sym_preproc_pragma] = STATE(2297),
    [sym_preproc_nullable] = STATE(2297),
    [sym_preproc_error] = STATE(2297),
    [sym_preproc_warning] = STATE(2297),
    [sym_preproc_define] = STATE(2297),
    [sym_preproc_undef] = STATE(2297),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2298] = {
    [sym_modifier] = STATE(3166),
    [sym_variable_declaration] = STATE(7799),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5380),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5769),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2298),
    [sym_preproc_endregion] = STATE(2298),
    [sym_preproc_line] = STATE(2298),
    [sym_preproc_pragma] = STATE(2298),
    [sym_preproc_nullable] = STATE(2298),
    [sym_preproc_error] = STATE(2298),
    [sym_preproc_warning] = STATE(2298),
    [sym_preproc_define] = STATE(2298),
    [sym_preproc_undef] = STATE(2298),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3128),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(65),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_event] = ACTIONS(3951),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_ref] = ACTIONS(3955),
    [anon_sym_struct] = ACTIONS(3957),
    [anon_sym_enum] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(3961),
    [anon_sym_delegate] = ACTIONS(3963),
    [anon_sym_record] = ACTIONS(3965),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_implicit] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2299] = {
    [sym_preproc_region] = STATE(2299),
    [sym_preproc_endregion] = STATE(2299),
    [sym_preproc_line] = STATE(2299),
    [sym_preproc_pragma] = STATE(2299),
    [sym_preproc_nullable] = STATE(2299),
    [sym_preproc_error] = STATE(2299),
    [sym_preproc_warning] = STATE(2299),
    [sym_preproc_define] = STATE(2299),
    [sym_preproc_undef] = STATE(2299),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3728),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2300] = {
    [sym_preproc_region] = STATE(2300),
    [sym_preproc_endregion] = STATE(2300),
    [sym_preproc_line] = STATE(2300),
    [sym_preproc_pragma] = STATE(2300),
    [sym_preproc_nullable] = STATE(2300),
    [sym_preproc_error] = STATE(2300),
    [sym_preproc_warning] = STATE(2300),
    [sym_preproc_define] = STATE(2300),
    [sym_preproc_undef] = STATE(2300),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3728),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2301] = {
    [sym_preproc_region] = STATE(2301),
    [sym_preproc_endregion] = STATE(2301),
    [sym_preproc_line] = STATE(2301),
    [sym_preproc_pragma] = STATE(2301),
    [sym_preproc_nullable] = STATE(2301),
    [sym_preproc_error] = STATE(2301),
    [sym_preproc_warning] = STATE(2301),
    [sym_preproc_define] = STATE(2301),
    [sym_preproc_undef] = STATE(2301),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3633),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3633),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2302] = {
    [sym_property_pattern_clause] = STATE(2343),
    [sym__variable_designation] = STATE(3533),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2302),
    [sym_preproc_endregion] = STATE(2302),
    [sym_preproc_line] = STATE(2302),
    [sym_preproc_pragma] = STATE(2302),
    [sym_preproc_nullable] = STATE(2302),
    [sym_preproc_error] = STATE(2302),
    [sym_preproc_warning] = STATE(2302),
    [sym_preproc_define] = STATE(2302),
    [sym_preproc_undef] = STATE(2302),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_if_token3] = ACTIONS(3931),
    [aux_sym_preproc_else_token1] = ACTIONS(3931),
    [aux_sym_preproc_elif_token1] = ACTIONS(3931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2303] = {
    [sym_preproc_region] = STATE(2303),
    [sym_preproc_endregion] = STATE(2303),
    [sym_preproc_line] = STATE(2303),
    [sym_preproc_pragma] = STATE(2303),
    [sym_preproc_nullable] = STATE(2303),
    [sym_preproc_error] = STATE(2303),
    [sym_preproc_warning] = STATE(2303),
    [sym_preproc_define] = STATE(2303),
    [sym_preproc_undef] = STATE(2303),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3706),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2304] = {
    [sym_preproc_region] = STATE(2304),
    [sym_preproc_endregion] = STATE(2304),
    [sym_preproc_line] = STATE(2304),
    [sym_preproc_pragma] = STATE(2304),
    [sym_preproc_nullable] = STATE(2304),
    [sym_preproc_error] = STATE(2304),
    [sym_preproc_warning] = STATE(2304),
    [sym_preproc_define] = STATE(2304),
    [sym_preproc_undef] = STATE(2304),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3713),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3728),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2305] = {
    [sym_preproc_region] = STATE(2305),
    [sym_preproc_endregion] = STATE(2305),
    [sym_preproc_line] = STATE(2305),
    [sym_preproc_pragma] = STATE(2305),
    [sym_preproc_nullable] = STATE(2305),
    [sym_preproc_error] = STATE(2305),
    [sym_preproc_warning] = STATE(2305),
    [sym_preproc_define] = STATE(2305),
    [sym_preproc_undef] = STATE(2305),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3728),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2306] = {
    [sym_preproc_region] = STATE(2306),
    [sym_preproc_endregion] = STATE(2306),
    [sym_preproc_line] = STATE(2306),
    [sym_preproc_pragma] = STATE(2306),
    [sym_preproc_nullable] = STATE(2306),
    [sym_preproc_error] = STATE(2306),
    [sym_preproc_warning] = STATE(2306),
    [sym_preproc_define] = STATE(2306),
    [sym_preproc_undef] = STATE(2306),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2307] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2307),
    [sym_preproc_endregion] = STATE(2307),
    [sym_preproc_line] = STATE(2307),
    [sym_preproc_pragma] = STATE(2307),
    [sym_preproc_nullable] = STATE(2307),
    [sym_preproc_error] = STATE(2307),
    [sym_preproc_warning] = STATE(2307),
    [sym_preproc_define] = STATE(2307),
    [sym_preproc_undef] = STATE(2307),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2308] = {
    [sym_preproc_region] = STATE(2308),
    [sym_preproc_endregion] = STATE(2308),
    [sym_preproc_line] = STATE(2308),
    [sym_preproc_pragma] = STATE(2308),
    [sym_preproc_nullable] = STATE(2308),
    [sym_preproc_error] = STATE(2308),
    [sym_preproc_warning] = STATE(2308),
    [sym_preproc_define] = STATE(2308),
    [sym_preproc_undef] = STATE(2308),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3706),
    [anon_sym_descending] = ACTIONS(3706),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2309] = {
    [sym_preproc_region] = STATE(2309),
    [sym_preproc_endregion] = STATE(2309),
    [sym_preproc_line] = STATE(2309),
    [sym_preproc_pragma] = STATE(2309),
    [sym_preproc_nullable] = STATE(2309),
    [sym_preproc_error] = STATE(2309),
    [sym_preproc_warning] = STATE(2309),
    [sym_preproc_define] = STATE(2309),
    [sym_preproc_undef] = STATE(2309),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3971),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_break] = ACTIONS(3973),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2310] = {
    [sym__variable_designation] = STATE(3376),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2310),
    [sym_preproc_endregion] = STATE(2310),
    [sym_preproc_line] = STATE(2310),
    [sym_preproc_pragma] = STATE(2310),
    [sym_preproc_nullable] = STATE(2310),
    [sym_preproc_error] = STATE(2310),
    [sym_preproc_warning] = STATE(2310),
    [sym_preproc_define] = STATE(2310),
    [sym_preproc_undef] = STATE(2310),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_RBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3975),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_if_token3] = ACTIONS(3975),
    [aux_sym_preproc_else_token1] = ACTIONS(3975),
    [aux_sym_preproc_elif_token1] = ACTIONS(3975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2311] = {
    [sym_preproc_region] = STATE(2311),
    [sym_preproc_endregion] = STATE(2311),
    [sym_preproc_line] = STATE(2311),
    [sym_preproc_pragma] = STATE(2311),
    [sym_preproc_nullable] = STATE(2311),
    [sym_preproc_error] = STATE(2311),
    [sym_preproc_warning] = STATE(2311),
    [sym_preproc_define] = STATE(2311),
    [sym_preproc_undef] = STATE(2311),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3709),
  },
  [2312] = {
    [sym__variable_designation] = STATE(3293),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2312),
    [sym_preproc_endregion] = STATE(2312),
    [sym_preproc_line] = STATE(2312),
    [sym_preproc_pragma] = STATE(2312),
    [sym_preproc_nullable] = STATE(2312),
    [sym_preproc_error] = STATE(2312),
    [sym_preproc_warning] = STATE(2312),
    [sym_preproc_define] = STATE(2312),
    [sym_preproc_undef] = STATE(2312),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_RBRACK] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3981),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_if_token3] = ACTIONS(3981),
    [aux_sym_preproc_else_token1] = ACTIONS(3981),
    [aux_sym_preproc_elif_token1] = ACTIONS(3981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2313] = {
    [sym__variable_designation] = STATE(3300),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2313),
    [sym_preproc_endregion] = STATE(2313),
    [sym_preproc_line] = STATE(2313),
    [sym_preproc_pragma] = STATE(2313),
    [sym_preproc_nullable] = STATE(2313),
    [sym_preproc_error] = STATE(2313),
    [sym_preproc_warning] = STATE(2313),
    [sym_preproc_define] = STATE(2313),
    [sym_preproc_undef] = STATE(2313),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3985),
    [anon_sym_RBRACK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3985),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_if_token3] = ACTIONS(3985),
    [aux_sym_preproc_else_token1] = ACTIONS(3985),
    [aux_sym_preproc_elif_token1] = ACTIONS(3985),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2314] = {
    [sym__variable_designation] = STATE(3307),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2314),
    [sym_preproc_endregion] = STATE(2314),
    [sym_preproc_line] = STATE(2314),
    [sym_preproc_pragma] = STATE(2314),
    [sym_preproc_nullable] = STATE(2314),
    [sym_preproc_error] = STATE(2314),
    [sym_preproc_warning] = STATE(2314),
    [sym_preproc_define] = STATE(2314),
    [sym_preproc_undef] = STATE(2314),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3989),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_COLON] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_RBRACK] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_RPAREN] = ACTIONS(3989),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_in] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3989),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3989),
    [aux_sym_preproc_else_token1] = ACTIONS(3989),
    [aux_sym_preproc_elif_token1] = ACTIONS(3989),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2315] = {
    [sym__name] = STATE(2855),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2714),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2809),
    [sym_ref_type] = STATE(2856),
    [sym__scoped_base_type] = STATE(2857),
    [sym_identifier] = STATE(2602),
    [sym__reserved_identifier] = STATE(2652),
    [sym_preproc_region] = STATE(2315),
    [sym_preproc_endregion] = STATE(2315),
    [sym_preproc_line] = STATE(2315),
    [sym_preproc_pragma] = STATE(2315),
    [sym_preproc_nullable] = STATE(2315),
    [sym_preproc_error] = STATE(2315),
    [sym_preproc_warning] = STATE(2315),
    [sym_preproc_define] = STATE(2315),
    [sym_preproc_undef] = STATE(2315),
    [sym__identifier_token] = ACTIONS(3644),
    [anon_sym_alias] = ACTIONS(3647),
    [anon_sym_global] = ACTIONS(3647),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3647),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3647),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3647),
    [anon_sym_unmanaged] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3647),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3647),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3647),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3647),
    [anon_sym_into] = ACTIONS(3647),
    [anon_sym_join] = ACTIONS(3647),
    [anon_sym_on] = ACTIONS(3647),
    [anon_sym_equals] = ACTIONS(3647),
    [anon_sym_let] = ACTIONS(3647),
    [anon_sym_orderby] = ACTIONS(3647),
    [anon_sym_ascending] = ACTIONS(3647),
    [anon_sym_descending] = ACTIONS(3647),
    [anon_sym_group] = ACTIONS(3647),
    [anon_sym_by] = ACTIONS(3647),
    [anon_sym_select] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2316] = {
    [sym_preproc_region] = STATE(2316),
    [sym_preproc_endregion] = STATE(2316),
    [sym_preproc_line] = STATE(2316),
    [sym_preproc_pragma] = STATE(2316),
    [sym_preproc_nullable] = STATE(2316),
    [sym_preproc_error] = STATE(2316),
    [sym_preproc_warning] = STATE(2316),
    [sym_preproc_define] = STATE(2316),
    [sym_preproc_undef] = STATE(2316),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2317] = {
    [sym_preproc_region] = STATE(2317),
    [sym_preproc_endregion] = STATE(2317),
    [sym_preproc_line] = STATE(2317),
    [sym_preproc_pragma] = STATE(2317),
    [sym_preproc_nullable] = STATE(2317),
    [sym_preproc_error] = STATE(2317),
    [sym_preproc_warning] = STATE(2317),
    [sym_preproc_define] = STATE(2317),
    [sym_preproc_undef] = STATE(2317),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2318] = {
    [sym_preproc_region] = STATE(2318),
    [sym_preproc_endregion] = STATE(2318),
    [sym_preproc_line] = STATE(2318),
    [sym_preproc_pragma] = STATE(2318),
    [sym_preproc_nullable] = STATE(2318),
    [sym_preproc_error] = STATE(2318),
    [sym_preproc_warning] = STATE(2318),
    [sym_preproc_define] = STATE(2318),
    [sym_preproc_undef] = STATE(2318),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3731),
  },
  [2319] = {
    [sym_preproc_region] = STATE(2319),
    [sym_preproc_endregion] = STATE(2319),
    [sym_preproc_line] = STATE(2319),
    [sym_preproc_pragma] = STATE(2319),
    [sym_preproc_nullable] = STATE(2319),
    [sym_preproc_error] = STATE(2319),
    [sym_preproc_warning] = STATE(2319),
    [sym_preproc_define] = STATE(2319),
    [sym_preproc_undef] = STATE(2319),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3728),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3728),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_orderby] = ACTIONS(3728),
    [anon_sym_ascending] = ACTIONS(3728),
    [anon_sym_descending] = ACTIONS(3728),
    [anon_sym_group] = ACTIONS(3728),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3728),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2320] = {
    [sym_preproc_region] = STATE(2320),
    [sym_preproc_endregion] = STATE(2320),
    [sym_preproc_line] = STATE(2320),
    [sym_preproc_pragma] = STATE(2320),
    [sym_preproc_nullable] = STATE(2320),
    [sym_preproc_error] = STATE(2320),
    [sym_preproc_warning] = STATE(2320),
    [sym_preproc_define] = STATE(2320),
    [sym_preproc_undef] = STATE(2320),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3709),
  },
  [2321] = {
    [sym__variable_designation] = STATE(3331),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2321),
    [sym_preproc_endregion] = STATE(2321),
    [sym_preproc_line] = STATE(2321),
    [sym_preproc_pragma] = STATE(2321),
    [sym_preproc_nullable] = STATE(2321),
    [sym_preproc_error] = STATE(2321),
    [sym_preproc_warning] = STATE(2321),
    [sym_preproc_define] = STATE(2321),
    [sym_preproc_undef] = STATE(2321),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_if_token3] = ACTIONS(3927),
    [aux_sym_preproc_else_token1] = ACTIONS(3927),
    [aux_sym_preproc_elif_token1] = ACTIONS(3927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2322] = {
    [sym__variable_designation] = STATE(3268),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2322),
    [sym_preproc_endregion] = STATE(2322),
    [sym_preproc_line] = STATE(2322),
    [sym_preproc_pragma] = STATE(2322),
    [sym_preproc_nullable] = STATE(2322),
    [sym_preproc_error] = STATE(2322),
    [sym_preproc_warning] = STATE(2322),
    [sym_preproc_define] = STATE(2322),
    [sym_preproc_undef] = STATE(2322),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_in] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_if_token3] = ACTIONS(3931),
    [aux_sym_preproc_else_token1] = ACTIONS(3931),
    [aux_sym_preproc_elif_token1] = ACTIONS(3931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2323] = {
    [sym_preproc_region] = STATE(2323),
    [sym_preproc_endregion] = STATE(2323),
    [sym_preproc_line] = STATE(2323),
    [sym_preproc_pragma] = STATE(2323),
    [sym_preproc_nullable] = STATE(2323),
    [sym_preproc_error] = STATE(2323),
    [sym_preproc_warning] = STATE(2323),
    [sym_preproc_define] = STATE(2323),
    [sym_preproc_undef] = STATE(2323),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3993),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_break] = ACTIONS(3995),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2324] = {
    [sym__variable_designation] = STATE(3282),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2324),
    [sym_preproc_endregion] = STATE(2324),
    [sym_preproc_line] = STATE(2324),
    [sym_preproc_pragma] = STATE(2324),
    [sym_preproc_nullable] = STATE(2324),
    [sym_preproc_error] = STATE(2324),
    [sym_preproc_warning] = STATE(2324),
    [sym_preproc_define] = STATE(2324),
    [sym_preproc_undef] = STATE(2324),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_in] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3997),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_if_token3] = ACTIONS(3997),
    [aux_sym_preproc_else_token1] = ACTIONS(3997),
    [aux_sym_preproc_elif_token1] = ACTIONS(3997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2325] = {
    [sym__variable_designation] = STATE(3297),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2325),
    [sym_preproc_endregion] = STATE(2325),
    [sym_preproc_line] = STATE(2325),
    [sym_preproc_pragma] = STATE(2325),
    [sym_preproc_nullable] = STATE(2325),
    [sym_preproc_error] = STATE(2325),
    [sym_preproc_warning] = STATE(2325),
    [sym_preproc_define] = STATE(2325),
    [sym_preproc_undef] = STATE(2325),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(4001),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4001),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_RBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_RPAREN] = ACTIONS(4001),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_in] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(4001),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_if_token3] = ACTIONS(4001),
    [aux_sym_preproc_else_token1] = ACTIONS(4001),
    [aux_sym_preproc_elif_token1] = ACTIONS(4001),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2326] = {
    [sym_preproc_region] = STATE(2326),
    [sym_preproc_endregion] = STATE(2326),
    [sym_preproc_line] = STATE(2326),
    [sym_preproc_pragma] = STATE(2326),
    [sym_preproc_nullable] = STATE(2326),
    [sym_preproc_error] = STATE(2326),
    [sym_preproc_warning] = STATE(2326),
    [sym_preproc_define] = STATE(2326),
    [sym_preproc_undef] = STATE(2326),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3731),
  },
  [2327] = {
    [sym_preproc_region] = STATE(2327),
    [sym_preproc_endregion] = STATE(2327),
    [sym_preproc_line] = STATE(2327),
    [sym_preproc_pragma] = STATE(2327),
    [sym_preproc_nullable] = STATE(2327),
    [sym_preproc_error] = STATE(2327),
    [sym_preproc_warning] = STATE(2327),
    [sym_preproc_define] = STATE(2327),
    [sym_preproc_undef] = STATE(2327),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3728),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3728),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_orderby] = ACTIONS(3728),
    [anon_sym_ascending] = ACTIONS(3728),
    [anon_sym_descending] = ACTIONS(3728),
    [anon_sym_group] = ACTIONS(3728),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3728),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2328] = {
    [sym_preproc_region] = STATE(2328),
    [sym_preproc_endregion] = STATE(2328),
    [sym_preproc_line] = STATE(2328),
    [sym_preproc_pragma] = STATE(2328),
    [sym_preproc_nullable] = STATE(2328),
    [sym_preproc_error] = STATE(2328),
    [sym_preproc_warning] = STATE(2328),
    [sym_preproc_define] = STATE(2328),
    [sym_preproc_undef] = STATE(2328),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3706),
    [anon_sym_descending] = ACTIONS(3706),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2329] = {
    [sym_preproc_region] = STATE(2329),
    [sym_preproc_endregion] = STATE(2329),
    [sym_preproc_line] = STATE(2329),
    [sym_preproc_pragma] = STATE(2329),
    [sym_preproc_nullable] = STATE(2329),
    [sym_preproc_error] = STATE(2329),
    [sym_preproc_warning] = STATE(2329),
    [sym_preproc_define] = STATE(2329),
    [sym_preproc_undef] = STATE(2329),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3706),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2330] = {
    [sym_preproc_region] = STATE(2330),
    [sym_preproc_endregion] = STATE(2330),
    [sym_preproc_line] = STATE(2330),
    [sym_preproc_pragma] = STATE(2330),
    [sym_preproc_nullable] = STATE(2330),
    [sym_preproc_error] = STATE(2330),
    [sym_preproc_warning] = STATE(2330),
    [sym_preproc_define] = STATE(2330),
    [sym_preproc_undef] = STATE(2330),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3728),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3728),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_orderby] = ACTIONS(3728),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3728),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3728),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2331] = {
    [sym_preproc_region] = STATE(2331),
    [sym_preproc_endregion] = STATE(2331),
    [sym_preproc_line] = STATE(2331),
    [sym_preproc_pragma] = STATE(2331),
    [sym_preproc_nullable] = STATE(2331),
    [sym_preproc_error] = STATE(2331),
    [sym_preproc_warning] = STATE(2331),
    [sym_preproc_define] = STATE(2331),
    [sym_preproc_undef] = STATE(2331),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_using] = ACTIONS(4005),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2332] = {
    [sym__variable_designation] = STATE(3552),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2332),
    [sym_preproc_endregion] = STATE(2332),
    [sym_preproc_line] = STATE(2332),
    [sym_preproc_pragma] = STATE(2332),
    [sym_preproc_nullable] = STATE(2332),
    [sym_preproc_error] = STATE(2332),
    [sym_preproc_warning] = STATE(2332),
    [sym_preproc_define] = STATE(2332),
    [sym_preproc_undef] = STATE(2332),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_RBRACK] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3981),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_if_token3] = ACTIONS(3981),
    [aux_sym_preproc_else_token1] = ACTIONS(3981),
    [aux_sym_preproc_elif_token1] = ACTIONS(3981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2333] = {
    [sym__name] = STATE(4527),
    [sym_alias_qualified_name] = STATE(4398),
    [sym__simple_name] = STATE(4398),
    [sym_qualified_name] = STATE(4398),
    [sym_generic_name] = STATE(4419),
    [sym_ref_type] = STATE(4506),
    [sym__scoped_base_type] = STATE(4508),
    [sym_identifier] = STATE(4293),
    [sym__reserved_identifier] = STATE(4388),
    [sym_preproc_region] = STATE(2333),
    [sym_preproc_endregion] = STATE(2333),
    [sym_preproc_line] = STATE(2333),
    [sym_preproc_pragma] = STATE(2333),
    [sym_preproc_nullable] = STATE(2333),
    [sym_preproc_error] = STATE(2333),
    [sym_preproc_warning] = STATE(2333),
    [sym_preproc_define] = STATE(2333),
    [sym_preproc_undef] = STATE(2333),
    [sym__identifier_token] = ACTIONS(4009),
    [anon_sym_alias] = ACTIONS(4011),
    [anon_sym_global] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4013),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(4011),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(4011),
    [anon_sym_unmanaged] = ACTIONS(4011),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(4011),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(4011),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(4011),
    [anon_sym_into] = ACTIONS(4015),
    [anon_sym_join] = ACTIONS(4011),
    [anon_sym_on] = ACTIONS(4011),
    [anon_sym_equals] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_orderby] = ACTIONS(4011),
    [anon_sym_ascending] = ACTIONS(4011),
    [anon_sym_descending] = ACTIONS(4011),
    [anon_sym_group] = ACTIONS(4011),
    [anon_sym_by] = ACTIONS(4011),
    [anon_sym_select] = ACTIONS(4011),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2334] = {
    [sym_preproc_region] = STATE(2334),
    [sym_preproc_endregion] = STATE(2334),
    [sym_preproc_line] = STATE(2334),
    [sym_preproc_pragma] = STATE(2334),
    [sym_preproc_nullable] = STATE(2334),
    [sym_preproc_error] = STATE(2334),
    [sym_preproc_warning] = STATE(2334),
    [sym_preproc_define] = STATE(2334),
    [sym_preproc_undef] = STATE(2334),
    [sym__identifier_token] = ACTIONS(4018),
    [anon_sym_alias] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_global] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_file] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_in] = ACTIONS(4018),
    [anon_sym_where] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_notnull] = ACTIONS(4018),
    [anon_sym_unmanaged] = ACTIONS(4018),
    [anon_sym_operator] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_this] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_scoped] = ACTIONS(4018),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [anon_sym_var] = ACTIONS(4018),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_when] = ACTIONS(4018),
    [sym_discard] = ACTIONS(4018),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_QMARK_QMARK] = ACTIONS(4020),
    [anon_sym_from] = ACTIONS(4018),
    [anon_sym_into] = ACTIONS(4018),
    [anon_sym_join] = ACTIONS(4018),
    [anon_sym_on] = ACTIONS(4018),
    [anon_sym_equals] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_orderby] = ACTIONS(4018),
    [anon_sym_ascending] = ACTIONS(4018),
    [anon_sym_descending] = ACTIONS(4018),
    [anon_sym_group] = ACTIONS(4018),
    [anon_sym_by] = ACTIONS(4018),
    [anon_sym_select] = ACTIONS(4018),
    [anon_sym_as] = ACTIONS(4018),
    [anon_sym_is] = ACTIONS(4018),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_with] = ACTIONS(4018),
    [aux_sym_preproc_if_token3] = ACTIONS(4020),
    [aux_sym_preproc_else_token1] = ACTIONS(4020),
    [aux_sym_preproc_elif_token1] = ACTIONS(4020),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2335] = {
    [sym__variable_designation] = STATE(3503),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2335),
    [sym_preproc_endregion] = STATE(2335),
    [sym_preproc_line] = STATE(2335),
    [sym_preproc_pragma] = STATE(2335),
    [sym_preproc_nullable] = STATE(2335),
    [sym_preproc_error] = STATE(2335),
    [sym_preproc_warning] = STATE(2335),
    [sym_preproc_define] = STATE(2335),
    [sym_preproc_undef] = STATE(2335),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3989),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_COLON] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_RBRACK] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_RPAREN] = ACTIONS(3989),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3989),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3989),
    [aux_sym_preproc_else_token1] = ACTIONS(3989),
    [aux_sym_preproc_elif_token1] = ACTIONS(3989),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2336] = {
    [sym_preproc_region] = STATE(2336),
    [sym_preproc_endregion] = STATE(2336),
    [sym_preproc_line] = STATE(2336),
    [sym_preproc_pragma] = STATE(2336),
    [sym_preproc_nullable] = STATE(2336),
    [sym_preproc_error] = STATE(2336),
    [sym_preproc_warning] = STATE(2336),
    [sym_preproc_define] = STATE(2336),
    [sym_preproc_undef] = STATE(2336),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2337] = {
    [sym_preproc_region] = STATE(2337),
    [sym_preproc_endregion] = STATE(2337),
    [sym_preproc_line] = STATE(2337),
    [sym_preproc_pragma] = STATE(2337),
    [sym_preproc_nullable] = STATE(2337),
    [sym_preproc_error] = STATE(2337),
    [sym_preproc_warning] = STATE(2337),
    [sym_preproc_define] = STATE(2337),
    [sym_preproc_undef] = STATE(2337),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_operator] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_this] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2338] = {
    [sym__variable_designation] = STATE(3470),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2338),
    [sym_preproc_endregion] = STATE(2338),
    [sym_preproc_line] = STATE(2338),
    [sym_preproc_pragma] = STATE(2338),
    [sym_preproc_nullable] = STATE(2338),
    [sym_preproc_error] = STATE(2338),
    [sym_preproc_warning] = STATE(2338),
    [sym_preproc_define] = STATE(2338),
    [sym_preproc_undef] = STATE(2338),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3985),
    [anon_sym_RBRACK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_RPAREN] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3985),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_if_token3] = ACTIONS(3985),
    [aux_sym_preproc_else_token1] = ACTIONS(3985),
    [aux_sym_preproc_elif_token1] = ACTIONS(3985),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2339] = {
    [sym_preproc_region] = STATE(2339),
    [sym_preproc_endregion] = STATE(2339),
    [sym_preproc_line] = STATE(2339),
    [sym_preproc_pragma] = STATE(2339),
    [sym_preproc_nullable] = STATE(2339),
    [sym_preproc_error] = STATE(2339),
    [sym_preproc_warning] = STATE(2339),
    [sym_preproc_define] = STATE(2339),
    [sym_preproc_undef] = STATE(2339),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3728),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2340] = {
    [sym_preproc_region] = STATE(2340),
    [sym_preproc_endregion] = STATE(2340),
    [sym_preproc_line] = STATE(2340),
    [sym_preproc_pragma] = STATE(2340),
    [sym_preproc_nullable] = STATE(2340),
    [sym_preproc_error] = STATE(2340),
    [sym_preproc_warning] = STATE(2340),
    [sym_preproc_define] = STATE(2340),
    [sym_preproc_undef] = STATE(2340),
    [sym__identifier_token] = ACTIONS(4026),
    [anon_sym_alias] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_global] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_file] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_where] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_notnull] = ACTIONS(4026),
    [anon_sym_unmanaged] = ACTIONS(4026),
    [anon_sym_operator] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_this] = ACTIONS(4026),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_scoped] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [anon_sym_switch] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(4026),
    [sym_discard] = ACTIONS(4026),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4026),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4026),
    [anon_sym_into] = ACTIONS(4026),
    [anon_sym_join] = ACTIONS(4026),
    [anon_sym_on] = ACTIONS(4026),
    [anon_sym_equals] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_orderby] = ACTIONS(4026),
    [anon_sym_ascending] = ACTIONS(4026),
    [anon_sym_descending] = ACTIONS(4026),
    [anon_sym_group] = ACTIONS(4026),
    [anon_sym_by] = ACTIONS(4026),
    [anon_sym_select] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4026),
    [anon_sym_is] = ACTIONS(4026),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4026),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2341] = {
    [sym_preproc_region] = STATE(2341),
    [sym_preproc_endregion] = STATE(2341),
    [sym_preproc_line] = STATE(2341),
    [sym_preproc_pragma] = STATE(2341),
    [sym_preproc_nullable] = STATE(2341),
    [sym_preproc_error] = STATE(2341),
    [sym_preproc_warning] = STATE(2341),
    [sym_preproc_define] = STATE(2341),
    [sym_preproc_undef] = STATE(2341),
    [sym__identifier_token] = ACTIONS(4030),
    [anon_sym_alias] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_global] = ACTIONS(4030),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_file] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_where] = ACTIONS(4030),
    [anon_sym_QMARK] = ACTIONS(4030),
    [anon_sym_notnull] = ACTIONS(4030),
    [anon_sym_unmanaged] = ACTIONS(4030),
    [anon_sym_operator] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_this] = ACTIONS(4030),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_scoped] = ACTIONS(4030),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [anon_sym_var] = ACTIONS(4030),
    [anon_sym_yield] = ACTIONS(4030),
    [anon_sym_switch] = ACTIONS(4030),
    [anon_sym_when] = ACTIONS(4030),
    [sym_discard] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4030),
    [anon_sym_or] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_QMARK_QMARK] = ACTIONS(4032),
    [anon_sym_from] = ACTIONS(4030),
    [anon_sym_into] = ACTIONS(4030),
    [anon_sym_join] = ACTIONS(4030),
    [anon_sym_on] = ACTIONS(4030),
    [anon_sym_equals] = ACTIONS(4030),
    [anon_sym_let] = ACTIONS(4030),
    [anon_sym_orderby] = ACTIONS(4030),
    [anon_sym_ascending] = ACTIONS(4030),
    [anon_sym_descending] = ACTIONS(4030),
    [anon_sym_group] = ACTIONS(4030),
    [anon_sym_by] = ACTIONS(4030),
    [anon_sym_select] = ACTIONS(4030),
    [anon_sym_as] = ACTIONS(4030),
    [anon_sym_is] = ACTIONS(4030),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4030),
    [aux_sym_preproc_if_token3] = ACTIONS(4032),
    [aux_sym_preproc_else_token1] = ACTIONS(4032),
    [aux_sym_preproc_elif_token1] = ACTIONS(4032),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2342] = {
    [sym_preproc_region] = STATE(2342),
    [sym_preproc_endregion] = STATE(2342),
    [sym_preproc_line] = STATE(2342),
    [sym_preproc_pragma] = STATE(2342),
    [sym_preproc_nullable] = STATE(2342),
    [sym_preproc_error] = STATE(2342),
    [sym_preproc_warning] = STATE(2342),
    [sym_preproc_define] = STATE(2342),
    [sym_preproc_undef] = STATE(2342),
    [sym__identifier_token] = ACTIONS(4034),
    [anon_sym_alias] = ACTIONS(4034),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_global] = ACTIONS(4034),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_file] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_where] = ACTIONS(4034),
    [anon_sym_QMARK] = ACTIONS(4034),
    [anon_sym_notnull] = ACTIONS(4034),
    [anon_sym_unmanaged] = ACTIONS(4034),
    [anon_sym_operator] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_this] = ACTIONS(4034),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_scoped] = ACTIONS(4034),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [anon_sym_var] = ACTIONS(4034),
    [anon_sym_yield] = ACTIONS(4034),
    [anon_sym_switch] = ACTIONS(4034),
    [anon_sym_when] = ACTIONS(4034),
    [sym_discard] = ACTIONS(4034),
    [anon_sym_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4034),
    [anon_sym_or] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_QMARK_QMARK] = ACTIONS(4036),
    [anon_sym_from] = ACTIONS(4034),
    [anon_sym_into] = ACTIONS(4034),
    [anon_sym_join] = ACTIONS(4034),
    [anon_sym_on] = ACTIONS(4034),
    [anon_sym_equals] = ACTIONS(4034),
    [anon_sym_let] = ACTIONS(4034),
    [anon_sym_orderby] = ACTIONS(4034),
    [anon_sym_ascending] = ACTIONS(4034),
    [anon_sym_descending] = ACTIONS(4034),
    [anon_sym_group] = ACTIONS(4034),
    [anon_sym_by] = ACTIONS(4034),
    [anon_sym_select] = ACTIONS(4034),
    [anon_sym_as] = ACTIONS(4034),
    [anon_sym_is] = ACTIONS(4034),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4034),
    [aux_sym_preproc_if_token3] = ACTIONS(4036),
    [aux_sym_preproc_else_token1] = ACTIONS(4036),
    [aux_sym_preproc_elif_token1] = ACTIONS(4036),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2343] = {
    [sym__variable_designation] = STATE(3403),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2343),
    [sym_preproc_endregion] = STATE(2343),
    [sym_preproc_line] = STATE(2343),
    [sym_preproc_pragma] = STATE(2343),
    [sym_preproc_nullable] = STATE(2343),
    [sym_preproc_error] = STATE(2343),
    [sym_preproc_warning] = STATE(2343),
    [sym_preproc_define] = STATE(2343),
    [sym_preproc_undef] = STATE(2343),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(4001),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4001),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_RBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_RPAREN] = ACTIONS(4001),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(4001),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_if_token3] = ACTIONS(4001),
    [aux_sym_preproc_else_token1] = ACTIONS(4001),
    [aux_sym_preproc_elif_token1] = ACTIONS(4001),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2344] = {
    [sym_preproc_region] = STATE(2344),
    [sym_preproc_endregion] = STATE(2344),
    [sym_preproc_line] = STATE(2344),
    [sym_preproc_pragma] = STATE(2344),
    [sym_preproc_nullable] = STATE(2344),
    [sym_preproc_error] = STATE(2344),
    [sym_preproc_warning] = STATE(2344),
    [sym_preproc_define] = STATE(2344),
    [sym_preproc_undef] = STATE(2344),
    [sym__identifier_token] = ACTIONS(4038),
    [anon_sym_alias] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4038),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4038),
    [anon_sym_where] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_notnull] = ACTIONS(4038),
    [anon_sym_unmanaged] = ACTIONS(4038),
    [anon_sym_operator] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_GT_GT_GT] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_this] = ACTIONS(4038),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_scoped] = ACTIONS(4038),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4038),
    [anon_sym_yield] = ACTIONS(4038),
    [anon_sym_switch] = ACTIONS(4038),
    [anon_sym_when] = ACTIONS(4038),
    [sym_discard] = ACTIONS(4038),
    [anon_sym_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4038),
    [anon_sym_or] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_QMARK_QMARK] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4038),
    [anon_sym_into] = ACTIONS(4038),
    [anon_sym_join] = ACTIONS(4038),
    [anon_sym_on] = ACTIONS(4038),
    [anon_sym_equals] = ACTIONS(4038),
    [anon_sym_let] = ACTIONS(4038),
    [anon_sym_orderby] = ACTIONS(4038),
    [anon_sym_ascending] = ACTIONS(4038),
    [anon_sym_descending] = ACTIONS(4038),
    [anon_sym_group] = ACTIONS(4038),
    [anon_sym_by] = ACTIONS(4038),
    [anon_sym_select] = ACTIONS(4038),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_is] = ACTIONS(4038),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_with] = ACTIONS(4038),
    [aux_sym_preproc_if_token3] = ACTIONS(4040),
    [aux_sym_preproc_else_token1] = ACTIONS(4040),
    [aux_sym_preproc_elif_token1] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2345] = {
    [sym_preproc_region] = STATE(2345),
    [sym_preproc_endregion] = STATE(2345),
    [sym_preproc_line] = STATE(2345),
    [sym_preproc_pragma] = STATE(2345),
    [sym_preproc_nullable] = STATE(2345),
    [sym_preproc_error] = STATE(2345),
    [sym_preproc_warning] = STATE(2345),
    [sym_preproc_define] = STATE(2345),
    [sym_preproc_undef] = STATE(2345),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3706),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2346] = {
    [sym_preproc_region] = STATE(2346),
    [sym_preproc_endregion] = STATE(2346),
    [sym_preproc_line] = STATE(2346),
    [sym_preproc_pragma] = STATE(2346),
    [sym_preproc_nullable] = STATE(2346),
    [sym_preproc_error] = STATE(2346),
    [sym_preproc_warning] = STATE(2346),
    [sym_preproc_define] = STATE(2346),
    [sym_preproc_undef] = STATE(2346),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3706),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2347] = {
    [sym__variable_designation] = STATE(3555),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2347),
    [sym_preproc_endregion] = STATE(2347),
    [sym_preproc_line] = STATE(2347),
    [sym_preproc_pragma] = STATE(2347),
    [sym_preproc_nullable] = STATE(2347),
    [sym_preproc_error] = STATE(2347),
    [sym_preproc_warning] = STATE(2347),
    [sym_preproc_define] = STATE(2347),
    [sym_preproc_undef] = STATE(2347),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_if_token3] = ACTIONS(3927),
    [aux_sym_preproc_else_token1] = ACTIONS(3927),
    [aux_sym_preproc_elif_token1] = ACTIONS(3927),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2348] = {
    [sym_preproc_region] = STATE(2348),
    [sym_preproc_endregion] = STATE(2348),
    [sym_preproc_line] = STATE(2348),
    [sym_preproc_pragma] = STATE(2348),
    [sym_preproc_nullable] = STATE(2348),
    [sym_preproc_error] = STATE(2348),
    [sym_preproc_warning] = STATE(2348),
    [sym_preproc_define] = STATE(2348),
    [sym_preproc_undef] = STATE(2348),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3736),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2349] = {
    [sym_preproc_region] = STATE(2349),
    [sym_preproc_endregion] = STATE(2349),
    [sym_preproc_line] = STATE(2349),
    [sym_preproc_pragma] = STATE(2349),
    [sym_preproc_nullable] = STATE(2349),
    [sym_preproc_error] = STATE(2349),
    [sym_preproc_warning] = STATE(2349),
    [sym_preproc_define] = STATE(2349),
    [sym_preproc_undef] = STATE(2349),
    [sym__identifier_token] = ACTIONS(4042),
    [anon_sym_alias] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_global] = ACTIONS(4042),
    [anon_sym_LBRACK] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_file] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_in] = ACTIONS(4042),
    [anon_sym_where] = ACTIONS(4042),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_notnull] = ACTIONS(4042),
    [anon_sym_unmanaged] = ACTIONS(4042),
    [anon_sym_operator] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4044),
    [anon_sym_this] = ACTIONS(4042),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_scoped] = ACTIONS(4042),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [anon_sym_var] = ACTIONS(4042),
    [anon_sym_yield] = ACTIONS(4042),
    [anon_sym_switch] = ACTIONS(4042),
    [anon_sym_when] = ACTIONS(4042),
    [sym_discard] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4042),
    [anon_sym_or] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_QMARK_QMARK] = ACTIONS(4044),
    [anon_sym_from] = ACTIONS(4042),
    [anon_sym_into] = ACTIONS(4042),
    [anon_sym_join] = ACTIONS(4042),
    [anon_sym_on] = ACTIONS(4042),
    [anon_sym_equals] = ACTIONS(4042),
    [anon_sym_let] = ACTIONS(4042),
    [anon_sym_orderby] = ACTIONS(4042),
    [anon_sym_ascending] = ACTIONS(4042),
    [anon_sym_descending] = ACTIONS(4042),
    [anon_sym_group] = ACTIONS(4042),
    [anon_sym_by] = ACTIONS(4042),
    [anon_sym_select] = ACTIONS(4042),
    [anon_sym_as] = ACTIONS(4042),
    [anon_sym_is] = ACTIONS(4042),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_with] = ACTIONS(4042),
    [aux_sym_preproc_if_token3] = ACTIONS(4044),
    [aux_sym_preproc_else_token1] = ACTIONS(4044),
    [aux_sym_preproc_elif_token1] = ACTIONS(4044),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2350] = {
    [sym_preproc_region] = STATE(2350),
    [sym_preproc_endregion] = STATE(2350),
    [sym_preproc_line] = STATE(2350),
    [sym_preproc_pragma] = STATE(2350),
    [sym_preproc_nullable] = STATE(2350),
    [sym_preproc_error] = STATE(2350),
    [sym_preproc_warning] = STATE(2350),
    [sym_preproc_define] = STATE(2350),
    [sym_preproc_undef] = STATE(2350),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3706),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2351] = {
    [sym__variable_designation] = STATE(3493),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2351),
    [sym_preproc_endregion] = STATE(2351),
    [sym_preproc_line] = STATE(2351),
    [sym_preproc_pragma] = STATE(2351),
    [sym_preproc_nullable] = STATE(2351),
    [sym_preproc_error] = STATE(2351),
    [sym_preproc_warning] = STATE(2351),
    [sym_preproc_define] = STATE(2351),
    [sym_preproc_undef] = STATE(2351),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_RBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3975),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_if_token3] = ACTIONS(3975),
    [aux_sym_preproc_else_token1] = ACTIONS(3975),
    [aux_sym_preproc_elif_token1] = ACTIONS(3975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2352] = {
    [sym_preproc_region] = STATE(2352),
    [sym_preproc_endregion] = STATE(2352),
    [sym_preproc_line] = STATE(2352),
    [sym_preproc_pragma] = STATE(2352),
    [sym_preproc_nullable] = STATE(2352),
    [sym_preproc_error] = STATE(2352),
    [sym_preproc_warning] = STATE(2352),
    [sym_preproc_define] = STATE(2352),
    [sym_preproc_undef] = STATE(2352),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3706),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2353] = {
    [sym_preproc_region] = STATE(2353),
    [sym_preproc_endregion] = STATE(2353),
    [sym_preproc_line] = STATE(2353),
    [sym_preproc_pragma] = STATE(2353),
    [sym_preproc_nullable] = STATE(2353),
    [sym_preproc_error] = STATE(2353),
    [sym_preproc_warning] = STATE(2353),
    [sym_preproc_define] = STATE(2353),
    [sym_preproc_undef] = STATE(2353),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2354] = {
    [sym_preproc_region] = STATE(2354),
    [sym_preproc_endregion] = STATE(2354),
    [sym_preproc_line] = STATE(2354),
    [sym_preproc_pragma] = STATE(2354),
    [sym_preproc_nullable] = STATE(2354),
    [sym_preproc_error] = STATE(2354),
    [sym_preproc_warning] = STATE(2354),
    [sym_preproc_define] = STATE(2354),
    [sym_preproc_undef] = STATE(2354),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3728),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3728),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_orderby] = ACTIONS(3728),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3728),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3728),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2355] = {
    [sym_preproc_region] = STATE(2355),
    [sym_preproc_endregion] = STATE(2355),
    [sym_preproc_line] = STATE(2355),
    [sym_preproc_pragma] = STATE(2355),
    [sym_preproc_nullable] = STATE(2355),
    [sym_preproc_error] = STATE(2355),
    [sym_preproc_warning] = STATE(2355),
    [sym_preproc_define] = STATE(2355),
    [sym_preproc_undef] = STATE(2355),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2356] = {
    [sym__name] = STATE(4527),
    [sym_alias_qualified_name] = STATE(4398),
    [sym__simple_name] = STATE(4398),
    [sym_qualified_name] = STATE(4398),
    [sym_generic_name] = STATE(4419),
    [sym_ref_type] = STATE(4506),
    [sym__scoped_base_type] = STATE(4508),
    [sym_identifier] = STATE(4293),
    [sym__reserved_identifier] = STATE(4388),
    [sym_preproc_region] = STATE(2356),
    [sym_preproc_endregion] = STATE(2356),
    [sym_preproc_line] = STATE(2356),
    [sym_preproc_pragma] = STATE(2356),
    [sym_preproc_nullable] = STATE(2356),
    [sym_preproc_error] = STATE(2356),
    [sym_preproc_warning] = STATE(2356),
    [sym_preproc_define] = STATE(2356),
    [sym_preproc_undef] = STATE(2356),
    [sym__identifier_token] = ACTIONS(4009),
    [anon_sym_alias] = ACTIONS(4011),
    [anon_sym_global] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(4011),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(4011),
    [anon_sym_unmanaged] = ACTIONS(4011),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(4011),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(4011),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(4011),
    [anon_sym_into] = ACTIONS(4011),
    [anon_sym_join] = ACTIONS(4011),
    [anon_sym_on] = ACTIONS(4011),
    [anon_sym_equals] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_orderby] = ACTIONS(4011),
    [anon_sym_ascending] = ACTIONS(4011),
    [anon_sym_descending] = ACTIONS(4011),
    [anon_sym_group] = ACTIONS(4011),
    [anon_sym_by] = ACTIONS(4011),
    [anon_sym_select] = ACTIONS(4011),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2357] = {
    [sym_preproc_region] = STATE(2357),
    [sym_preproc_endregion] = STATE(2357),
    [sym_preproc_line] = STATE(2357),
    [sym_preproc_pragma] = STATE(2357),
    [sym_preproc_nullable] = STATE(2357),
    [sym_preproc_error] = STATE(2357),
    [sym_preproc_warning] = STATE(2357),
    [sym_preproc_define] = STATE(2357),
    [sym_preproc_undef] = STATE(2357),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3728),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2358] = {
    [sym_preproc_region] = STATE(2358),
    [sym_preproc_endregion] = STATE(2358),
    [sym_preproc_line] = STATE(2358),
    [sym_preproc_pragma] = STATE(2358),
    [sym_preproc_nullable] = STATE(2358),
    [sym_preproc_error] = STATE(2358),
    [sym_preproc_warning] = STATE(2358),
    [sym_preproc_define] = STATE(2358),
    [sym_preproc_undef] = STATE(2358),
    [sym__identifier_token] = ACTIONS(4048),
    [anon_sym_alias] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_global] = ACTIONS(4048),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_file] = ACTIONS(4048),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_in] = ACTIONS(4048),
    [anon_sym_where] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_notnull] = ACTIONS(4048),
    [anon_sym_unmanaged] = ACTIONS(4048),
    [anon_sym_operator] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_this] = ACTIONS(4048),
    [anon_sym_DOT] = ACTIONS(4048),
    [anon_sym_scoped] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4050),
    [anon_sym_var] = ACTIONS(4048),
    [anon_sym_yield] = ACTIONS(4048),
    [anon_sym_switch] = ACTIONS(4048),
    [anon_sym_when] = ACTIONS(4048),
    [sym_discard] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4050),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_QMARK_QMARK] = ACTIONS(4050),
    [anon_sym_from] = ACTIONS(4048),
    [anon_sym_into] = ACTIONS(4048),
    [anon_sym_join] = ACTIONS(4048),
    [anon_sym_on] = ACTIONS(4048),
    [anon_sym_equals] = ACTIONS(4048),
    [anon_sym_let] = ACTIONS(4048),
    [anon_sym_orderby] = ACTIONS(4048),
    [anon_sym_ascending] = ACTIONS(4048),
    [anon_sym_descending] = ACTIONS(4048),
    [anon_sym_group] = ACTIONS(4048),
    [anon_sym_by] = ACTIONS(4048),
    [anon_sym_select] = ACTIONS(4048),
    [anon_sym_as] = ACTIONS(4048),
    [anon_sym_is] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4048),
    [aux_sym_preproc_if_token3] = ACTIONS(4050),
    [aux_sym_preproc_else_token1] = ACTIONS(4050),
    [aux_sym_preproc_elif_token1] = ACTIONS(4050),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2359] = {
    [sym_preproc_region] = STATE(2359),
    [sym_preproc_endregion] = STATE(2359),
    [sym_preproc_line] = STATE(2359),
    [sym_preproc_pragma] = STATE(2359),
    [sym_preproc_nullable] = STATE(2359),
    [sym_preproc_error] = STATE(2359),
    [sym_preproc_warning] = STATE(2359),
    [sym_preproc_define] = STATE(2359),
    [sym_preproc_undef] = STATE(2359),
    [sym__identifier_token] = ACTIONS(4052),
    [anon_sym_alias] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_global] = ACTIONS(4052),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_file] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_where] = ACTIONS(4052),
    [anon_sym_QMARK] = ACTIONS(4052),
    [anon_sym_notnull] = ACTIONS(4052),
    [anon_sym_unmanaged] = ACTIONS(4052),
    [anon_sym_operator] = ACTIONS(4052),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_this] = ACTIONS(4052),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_scoped] = ACTIONS(4052),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [anon_sym_var] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4052),
    [anon_sym_switch] = ACTIONS(4052),
    [anon_sym_when] = ACTIONS(4052),
    [sym_discard] = ACTIONS(4052),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4052),
    [anon_sym_or] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_QMARK_QMARK] = ACTIONS(4054),
    [anon_sym_from] = ACTIONS(4052),
    [anon_sym_into] = ACTIONS(4052),
    [anon_sym_join] = ACTIONS(4052),
    [anon_sym_on] = ACTIONS(4052),
    [anon_sym_equals] = ACTIONS(4052),
    [anon_sym_let] = ACTIONS(4052),
    [anon_sym_orderby] = ACTIONS(4052),
    [anon_sym_ascending] = ACTIONS(4052),
    [anon_sym_descending] = ACTIONS(4052),
    [anon_sym_group] = ACTIONS(4052),
    [anon_sym_by] = ACTIONS(4052),
    [anon_sym_select] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4052),
    [anon_sym_is] = ACTIONS(4052),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4052),
    [aux_sym_preproc_if_token3] = ACTIONS(4054),
    [aux_sym_preproc_else_token1] = ACTIONS(4054),
    [aux_sym_preproc_elif_token1] = ACTIONS(4054),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2360] = {
    [sym_preproc_region] = STATE(2360),
    [sym_preproc_endregion] = STATE(2360),
    [sym_preproc_line] = STATE(2360),
    [sym_preproc_pragma] = STATE(2360),
    [sym_preproc_nullable] = STATE(2360),
    [sym_preproc_error] = STATE(2360),
    [sym_preproc_warning] = STATE(2360),
    [sym_preproc_define] = STATE(2360),
    [sym_preproc_undef] = STATE(2360),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3706),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2361] = {
    [sym_preproc_region] = STATE(2361),
    [sym_preproc_endregion] = STATE(2361),
    [sym_preproc_line] = STATE(2361),
    [sym_preproc_pragma] = STATE(2361),
    [sym_preproc_nullable] = STATE(2361),
    [sym_preproc_error] = STATE(2361),
    [sym_preproc_warning] = STATE(2361),
    [sym_preproc_define] = STATE(2361),
    [sym_preproc_undef] = STATE(2361),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3728),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2362] = {
    [sym_preproc_region] = STATE(2362),
    [sym_preproc_endregion] = STATE(2362),
    [sym_preproc_line] = STATE(2362),
    [sym_preproc_pragma] = STATE(2362),
    [sym_preproc_nullable] = STATE(2362),
    [sym_preproc_error] = STATE(2362),
    [sym_preproc_warning] = STATE(2362),
    [sym_preproc_define] = STATE(2362),
    [sym_preproc_undef] = STATE(2362),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3706),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2363] = {
    [sym_preproc_region] = STATE(2363),
    [sym_preproc_endregion] = STATE(2363),
    [sym_preproc_line] = STATE(2363),
    [sym_preproc_pragma] = STATE(2363),
    [sym_preproc_nullable] = STATE(2363),
    [sym_preproc_error] = STATE(2363),
    [sym_preproc_warning] = STATE(2363),
    [sym_preproc_define] = STATE(2363),
    [sym_preproc_undef] = STATE(2363),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3736),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2364] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2364),
    [sym_preproc_endregion] = STATE(2364),
    [sym_preproc_line] = STATE(2364),
    [sym_preproc_pragma] = STATE(2364),
    [sym_preproc_nullable] = STATE(2364),
    [sym_preproc_error] = STATE(2364),
    [sym_preproc_warning] = STATE(2364),
    [sym_preproc_define] = STATE(2364),
    [sym_preproc_undef] = STATE(2364),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(4056),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2365] = {
    [sym__variable_designation] = STATE(3536),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2365),
    [sym_preproc_endregion] = STATE(2365),
    [sym_preproc_line] = STATE(2365),
    [sym_preproc_pragma] = STATE(2365),
    [sym_preproc_nullable] = STATE(2365),
    [sym_preproc_error] = STATE(2365),
    [sym_preproc_warning] = STATE(2365),
    [sym_preproc_define] = STATE(2365),
    [sym_preproc_undef] = STATE(2365),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3997),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_if_token3] = ACTIONS(3997),
    [aux_sym_preproc_else_token1] = ACTIONS(3997),
    [aux_sym_preproc_elif_token1] = ACTIONS(3997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2366] = {
    [sym_preproc_region] = STATE(2366),
    [sym_preproc_endregion] = STATE(2366),
    [sym_preproc_line] = STATE(2366),
    [sym_preproc_pragma] = STATE(2366),
    [sym_preproc_nullable] = STATE(2366),
    [sym_preproc_error] = STATE(2366),
    [sym_preproc_warning] = STATE(2366),
    [sym_preproc_define] = STATE(2366),
    [sym_preproc_undef] = STATE(2366),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3706),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_LT_LT] = ACTIONS(3706),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3706),
    [anon_sym_EQ_EQ] = ACTIONS(3703),
    [anon_sym_BANG_EQ] = ACTIONS(3703),
    [anon_sym_GT_EQ] = ACTIONS(3703),
    [anon_sym_LT_EQ] = ACTIONS(3703),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_and] = ACTIONS(3706),
    [anon_sym_or] = ACTIONS(3706),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_PIPE_PIPE] = ACTIONS(3703),
    [anon_sym_QMARK_QMARK] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3706),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3706),
    [anon_sym_is] = ACTIONS(3706),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3706),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2367] = {
    [sym__variable_designation] = STATE(3534),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2367),
    [sym_preproc_endregion] = STATE(2367),
    [sym_preproc_line] = STATE(2367),
    [sym_preproc_pragma] = STATE(2367),
    [sym_preproc_nullable] = STATE(2367),
    [sym_preproc_error] = STATE(2367),
    [sym_preproc_warning] = STATE(2367),
    [sym_preproc_define] = STATE(2367),
    [sym_preproc_undef] = STATE(2367),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_RPAREN] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_if_token3] = ACTIONS(3931),
    [aux_sym_preproc_else_token1] = ACTIONS(3931),
    [aux_sym_preproc_elif_token1] = ACTIONS(3931),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2368] = {
    [sym_preproc_region] = STATE(2368),
    [sym_preproc_endregion] = STATE(2368),
    [sym_preproc_line] = STATE(2368),
    [sym_preproc_pragma] = STATE(2368),
    [sym_preproc_nullable] = STATE(2368),
    [sym_preproc_error] = STATE(2368),
    [sym_preproc_warning] = STATE(2368),
    [sym_preproc_define] = STATE(2368),
    [sym_preproc_undef] = STATE(2368),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2369] = {
    [sym_preproc_region] = STATE(2369),
    [sym_preproc_endregion] = STATE(2369),
    [sym_preproc_line] = STATE(2369),
    [sym_preproc_pragma] = STATE(2369),
    [sym_preproc_nullable] = STATE(2369),
    [sym_preproc_error] = STATE(2369),
    [sym_preproc_warning] = STATE(2369),
    [sym_preproc_define] = STATE(2369),
    [sym_preproc_undef] = STATE(2369),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3724),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3724),
    [anon_sym_PLUS_PLUS] = ACTIONS(3718),
    [anon_sym_DASH_DASH] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_STAR] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3724),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_GT_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_GT_EQ] = ACTIONS(3718),
    [anon_sym_LT_EQ] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3724),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3724),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_QMARK_QMARK] = ACTIONS(3724),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3728),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3724),
    [anon_sym_is] = ACTIONS(3724),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_with] = ACTIONS(3724),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2370] = {
    [sym_type_argument_list] = STATE(2184),
    [sym_preproc_region] = STATE(2370),
    [sym_preproc_endregion] = STATE(2370),
    [sym_preproc_line] = STATE(2370),
    [sym_preproc_pragma] = STATE(2370),
    [sym_preproc_nullable] = STATE(2370),
    [sym_preproc_error] = STATE(2370),
    [sym_preproc_warning] = STATE(2370),
    [sym_preproc_define] = STATE(2370),
    [sym_preproc_undef] = STATE(2370),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3688),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2371] = {
    [sym_modifier] = STATE(3166),
    [sym_variable_declaration] = STATE(7491),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5963),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2371),
    [sym_preproc_endregion] = STATE(2371),
    [sym_preproc_line] = STATE(2371),
    [sym_preproc_pragma] = STATE(2371),
    [sym_preproc_nullable] = STATE(2371),
    [sym_preproc_error] = STATE(2371),
    [sym_preproc_warning] = STATE(2371),
    [sym_preproc_define] = STATE(2371),
    [sym_preproc_undef] = STATE(2371),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3128),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(65),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3753),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3761),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2372] = {
    [sym__name] = STATE(4952),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_ref_type] = STATE(3016),
    [sym__scoped_base_type] = STATE(3025),
    [sym_identifier] = STATE(4435),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2372),
    [sym_preproc_endregion] = STATE(2372),
    [sym_preproc_line] = STATE(2372),
    [sym_preproc_pragma] = STATE(2372),
    [sym_preproc_nullable] = STATE(2372),
    [sym_preproc_error] = STATE(2372),
    [sym_preproc_warning] = STATE(2372),
    [sym_preproc_define] = STATE(2372),
    [sym_preproc_undef] = STATE(2372),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4060),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2373] = {
    [sym_preproc_region] = STATE(2373),
    [sym_preproc_endregion] = STATE(2373),
    [sym_preproc_line] = STATE(2373),
    [sym_preproc_pragma] = STATE(2373),
    [sym_preproc_nullable] = STATE(2373),
    [sym_preproc_error] = STATE(2373),
    [sym_preproc_warning] = STATE(2373),
    [sym_preproc_define] = STATE(2373),
    [sym_preproc_undef] = STATE(2373),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2374] = {
    [sym_preproc_region] = STATE(2374),
    [sym_preproc_endregion] = STATE(2374),
    [sym_preproc_line] = STATE(2374),
    [sym_preproc_pragma] = STATE(2374),
    [sym_preproc_nullable] = STATE(2374),
    [sym_preproc_error] = STATE(2374),
    [sym_preproc_warning] = STATE(2374),
    [sym_preproc_define] = STATE(2374),
    [sym_preproc_undef] = STATE(2374),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2375] = {
    [sym_preproc_region] = STATE(2375),
    [sym_preproc_endregion] = STATE(2375),
    [sym_preproc_line] = STATE(2375),
    [sym_preproc_pragma] = STATE(2375),
    [sym_preproc_nullable] = STATE(2375),
    [sym_preproc_error] = STATE(2375),
    [sym_preproc_warning] = STATE(2375),
    [sym_preproc_define] = STATE(2375),
    [sym_preproc_undef] = STATE(2375),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3706),
    [anon_sym_descending] = ACTIONS(3706),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2376] = {
    [sym_preproc_region] = STATE(2376),
    [sym_preproc_endregion] = STATE(2376),
    [sym_preproc_line] = STATE(2376),
    [sym_preproc_pragma] = STATE(2376),
    [sym_preproc_nullable] = STATE(2376),
    [sym_preproc_error] = STATE(2376),
    [sym_preproc_warning] = STATE(2376),
    [sym_preproc_define] = STATE(2376),
    [sym_preproc_undef] = STATE(2376),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3736),
    [anon_sym_descending] = ACTIONS(3736),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2377] = {
    [sym_preproc_region] = STATE(2377),
    [sym_preproc_endregion] = STATE(2377),
    [sym_preproc_line] = STATE(2377),
    [sym_preproc_pragma] = STATE(2377),
    [sym_preproc_nullable] = STATE(2377),
    [sym_preproc_error] = STATE(2377),
    [sym_preproc_warning] = STATE(2377),
    [sym_preproc_define] = STATE(2377),
    [sym_preproc_undef] = STATE(2377),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3630),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2378] = {
    [sym__name] = STATE(3220),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_ref_type] = STATE(3223),
    [sym__scoped_base_type] = STATE(3228),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(2378),
    [sym_preproc_endregion] = STATE(2378),
    [sym_preproc_line] = STATE(2378),
    [sym_preproc_pragma] = STATE(2378),
    [sym_preproc_nullable] = STATE(2378),
    [sym_preproc_error] = STATE(2378),
    [sym_preproc_warning] = STATE(2378),
    [sym_preproc_define] = STATE(2378),
    [sym_preproc_undef] = STATE(2378),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3795),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2379] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2379),
    [sym_preproc_endregion] = STATE(2379),
    [sym_preproc_line] = STATE(2379),
    [sym_preproc_pragma] = STATE(2379),
    [sym_preproc_nullable] = STATE(2379),
    [sym_preproc_error] = STATE(2379),
    [sym_preproc_warning] = STATE(2379),
    [sym_preproc_define] = STATE(2379),
    [sym_preproc_undef] = STATE(2379),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2380] = {
    [sym_type_argument_list] = STATE(2419),
    [sym_preproc_region] = STATE(2380),
    [sym_preproc_endregion] = STATE(2380),
    [sym_preproc_line] = STATE(2380),
    [sym_preproc_pragma] = STATE(2380),
    [sym_preproc_nullable] = STATE(2380),
    [sym_preproc_error] = STATE(2380),
    [sym_preproc_warning] = STATE(2380),
    [sym_preproc_define] = STATE(2380),
    [sym_preproc_undef] = STATE(2380),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2381] = {
    [sym_preproc_region] = STATE(2381),
    [sym_preproc_endregion] = STATE(2381),
    [sym_preproc_line] = STATE(2381),
    [sym_preproc_pragma] = STATE(2381),
    [sym_preproc_nullable] = STATE(2381),
    [sym_preproc_error] = STATE(2381),
    [sym_preproc_warning] = STATE(2381),
    [sym_preproc_define] = STATE(2381),
    [sym_preproc_undef] = STATE(2381),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3736),
    [anon_sym_descending] = ACTIONS(3736),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2382] = {
    [sym_type_argument_list] = STATE(2419),
    [sym_preproc_region] = STATE(2382),
    [sym_preproc_endregion] = STATE(2382),
    [sym_preproc_line] = STATE(2382),
    [sym_preproc_pragma] = STATE(2382),
    [sym_preproc_nullable] = STATE(2382),
    [sym_preproc_error] = STATE(2382),
    [sym_preproc_warning] = STATE(2382),
    [sym_preproc_define] = STATE(2382),
    [sym_preproc_undef] = STATE(2382),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2383] = {
    [sym_preproc_region] = STATE(2383),
    [sym_preproc_endregion] = STATE(2383),
    [sym_preproc_line] = STATE(2383),
    [sym_preproc_pragma] = STATE(2383),
    [sym_preproc_nullable] = STATE(2383),
    [sym_preproc_error] = STATE(2383),
    [sym_preproc_warning] = STATE(2383),
    [sym_preproc_define] = STATE(2383),
    [sym_preproc_undef] = STATE(2383),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3706),
    [anon_sym_descending] = ACTIONS(3706),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2384] = {
    [sym_modifier] = STATE(3166),
    [sym_variable_declaration] = STATE(7652),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5963),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2384),
    [sym_preproc_endregion] = STATE(2384),
    [sym_preproc_line] = STATE(2384),
    [sym_preproc_pragma] = STATE(2384),
    [sym_preproc_nullable] = STATE(2384),
    [sym_preproc_error] = STATE(2384),
    [sym_preproc_warning] = STATE(2384),
    [sym_preproc_define] = STATE(2384),
    [sym_preproc_undef] = STATE(2384),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3128),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(65),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3753),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3761),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(3015),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2385] = {
    [sym__name] = STATE(3483),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_ref_type] = STATE(3271),
    [sym__scoped_base_type] = STATE(3273),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2385),
    [sym_preproc_endregion] = STATE(2385),
    [sym_preproc_line] = STATE(2385),
    [sym_preproc_pragma] = STATE(2385),
    [sym_preproc_nullable] = STATE(2385),
    [sym_preproc_error] = STATE(2385),
    [sym_preproc_warning] = STATE(2385),
    [sym_preproc_define] = STATE(2385),
    [sym_preproc_undef] = STATE(2385),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4081),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2386] = {
    [sym_preproc_region] = STATE(2386),
    [sym_preproc_endregion] = STATE(2386),
    [sym_preproc_line] = STATE(2386),
    [sym_preproc_pragma] = STATE(2386),
    [sym_preproc_nullable] = STATE(2386),
    [sym_preproc_error] = STATE(2386),
    [sym_preproc_warning] = STATE(2386),
    [sym_preproc_define] = STATE(2386),
    [sym_preproc_undef] = STATE(2386),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3706),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2387] = {
    [sym_preproc_region] = STATE(2387),
    [sym_preproc_endregion] = STATE(2387),
    [sym_preproc_line] = STATE(2387),
    [sym_preproc_pragma] = STATE(2387),
    [sym_preproc_nullable] = STATE(2387),
    [sym_preproc_error] = STATE(2387),
    [sym_preproc_warning] = STATE(2387),
    [sym_preproc_define] = STATE(2387),
    [sym_preproc_undef] = STATE(2387),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2388] = {
    [sym_preproc_region] = STATE(2388),
    [sym_preproc_endregion] = STATE(2388),
    [sym_preproc_line] = STATE(2388),
    [sym_preproc_pragma] = STATE(2388),
    [sym_preproc_nullable] = STATE(2388),
    [sym_preproc_error] = STATE(2388),
    [sym_preproc_warning] = STATE(2388),
    [sym_preproc_define] = STATE(2388),
    [sym_preproc_undef] = STATE(2388),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3706),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2389] = {
    [sym_preproc_region] = STATE(2389),
    [sym_preproc_endregion] = STATE(2389),
    [sym_preproc_line] = STATE(2389),
    [sym_preproc_pragma] = STATE(2389),
    [sym_preproc_nullable] = STATE(2389),
    [sym_preproc_error] = STATE(2389),
    [sym_preproc_warning] = STATE(2389),
    [sym_preproc_define] = STATE(2389),
    [sym_preproc_undef] = STATE(2389),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3736),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2390] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2517),
    [sym_property_pattern_clause] = STATE(2584),
    [sym__variable_designation] = STATE(4817),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4445),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2390),
    [sym_preproc_endregion] = STATE(2390),
    [sym_preproc_line] = STATE(2390),
    [sym_preproc_pragma] = STATE(2390),
    [sym_preproc_nullable] = STATE(2390),
    [sym_preproc_error] = STATE(2390),
    [sym_preproc_warning] = STATE(2390),
    [sym_preproc_define] = STATE(2390),
    [sym_preproc_undef] = STATE(2390),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3911),
  },
  [2391] = {
    [sym_preproc_region] = STATE(2391),
    [sym_preproc_endregion] = STATE(2391),
    [sym_preproc_line] = STATE(2391),
    [sym_preproc_pragma] = STATE(2391),
    [sym_preproc_nullable] = STATE(2391),
    [sym_preproc_error] = STATE(2391),
    [sym_preproc_warning] = STATE(2391),
    [sym_preproc_define] = STATE(2391),
    [sym_preproc_undef] = STATE(2391),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2392] = {
    [sym_preproc_region] = STATE(2392),
    [sym_preproc_endregion] = STATE(2392),
    [sym_preproc_line] = STATE(2392),
    [sym_preproc_pragma] = STATE(2392),
    [sym_preproc_nullable] = STATE(2392),
    [sym_preproc_error] = STATE(2392),
    [sym_preproc_warning] = STATE(2392),
    [sym_preproc_define] = STATE(2392),
    [sym_preproc_undef] = STATE(2392),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3736),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3736),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_orderby] = ACTIONS(3736),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3736),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2393] = {
    [sym_modifier] = STATE(3166),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6144),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2393),
    [sym_preproc_endregion] = STATE(2393),
    [sym_preproc_line] = STATE(2393),
    [sym_preproc_pragma] = STATE(2393),
    [sym_preproc_nullable] = STATE(2393),
    [sym_preproc_error] = STATE(2393),
    [sym_preproc_warning] = STATE(2393),
    [sym_preproc_define] = STATE(2393),
    [sym_preproc_undef] = STATE(2393),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3128),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(65),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_ref] = ACTIONS(3955),
    [anon_sym_struct] = ACTIONS(3957),
    [anon_sym_enum] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(3961),
    [anon_sym_delegate] = ACTIONS(3963),
    [anon_sym_record] = ACTIONS(3965),
    [anon_sym_abstract] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_file] = ACTIONS(4094),
    [anon_sym_fixed] = ACTIONS(65),
    [anon_sym_internal] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_override] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(65),
    [anon_sym_private] = ACTIONS(65),
    [anon_sym_protected] = ACTIONS(65),
    [anon_sym_public] = ACTIONS(65),
    [anon_sym_readonly] = ACTIONS(65),
    [anon_sym_required] = ACTIONS(65),
    [anon_sym_sealed] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2394] = {
    [sym__name] = STATE(2448),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2394),
    [sym_preproc_endregion] = STATE(2394),
    [sym_preproc_line] = STATE(2394),
    [sym_preproc_pragma] = STATE(2394),
    [sym_preproc_nullable] = STATE(2394),
    [sym_preproc_error] = STATE(2394),
    [sym_preproc_warning] = STATE(2394),
    [sym_preproc_define] = STATE(2394),
    [sym_preproc_undef] = STATE(2394),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4100),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2395] = {
    [sym_preproc_region] = STATE(2395),
    [sym_preproc_endregion] = STATE(2395),
    [sym_preproc_line] = STATE(2395),
    [sym_preproc_pragma] = STATE(2395),
    [sym_preproc_nullable] = STATE(2395),
    [sym_preproc_error] = STATE(2395),
    [sym_preproc_warning] = STATE(2395),
    [sym_preproc_define] = STATE(2395),
    [sym_preproc_undef] = STATE(2395),
    [sym__identifier_token] = ACTIONS(4102),
    [anon_sym_alias] = ACTIONS(4102),
    [anon_sym_SEMI] = ACTIONS(4104),
    [anon_sym_global] = ACTIONS(4102),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4104),
    [anon_sym_RBRACK] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_RPAREN] = ACTIONS(4104),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_RBRACE] = ACTIONS(4104),
    [anon_sym_file] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_in] = ACTIONS(4102),
    [anon_sym_where] = ACTIONS(4102),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_notnull] = ACTIONS(4102),
    [anon_sym_unmanaged] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4104),
    [anon_sym_DASH_DASH] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4102),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_GT_EQ] = ACTIONS(4104),
    [anon_sym_LT_EQ] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_scoped] = ACTIONS(4102),
    [anon_sym_EQ_GT] = ACTIONS(4104),
    [anon_sym_var] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4102),
    [anon_sym_switch] = ACTIONS(4102),
    [anon_sym_when] = ACTIONS(4102),
    [sym_discard] = ACTIONS(4102),
    [anon_sym_DOT_DOT] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4102),
    [anon_sym_or] = ACTIONS(4102),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4102),
    [anon_sym_into] = ACTIONS(4102),
    [anon_sym_join] = ACTIONS(4102),
    [anon_sym_on] = ACTIONS(4102),
    [anon_sym_equals] = ACTIONS(4102),
    [anon_sym_let] = ACTIONS(4102),
    [anon_sym_orderby] = ACTIONS(4102),
    [anon_sym_ascending] = ACTIONS(4102),
    [anon_sym_descending] = ACTIONS(4102),
    [anon_sym_group] = ACTIONS(4102),
    [anon_sym_by] = ACTIONS(4102),
    [anon_sym_select] = ACTIONS(4102),
    [anon_sym_as] = ACTIONS(4102),
    [anon_sym_is] = ACTIONS(4102),
    [anon_sym_DASH_GT] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4102),
    [aux_sym_preproc_if_token3] = ACTIONS(4104),
    [aux_sym_preproc_else_token1] = ACTIONS(4104),
    [aux_sym_preproc_elif_token1] = ACTIONS(4104),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2396] = {
    [sym_preproc_region] = STATE(2396),
    [sym_preproc_endregion] = STATE(2396),
    [sym_preproc_line] = STATE(2396),
    [sym_preproc_pragma] = STATE(2396),
    [sym_preproc_nullable] = STATE(2396),
    [sym_preproc_error] = STATE(2396),
    [sym_preproc_warning] = STATE(2396),
    [sym_preproc_define] = STATE(2396),
    [sym_preproc_undef] = STATE(2396),
    [sym__identifier_token] = ACTIONS(4106),
    [anon_sym_alias] = ACTIONS(4106),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_global] = ACTIONS(4106),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_file] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_in] = ACTIONS(4106),
    [anon_sym_where] = ACTIONS(4106),
    [anon_sym_QMARK] = ACTIONS(4106),
    [anon_sym_notnull] = ACTIONS(4106),
    [anon_sym_unmanaged] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4106),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4106),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_scoped] = ACTIONS(4106),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [anon_sym_var] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4106),
    [anon_sym_switch] = ACTIONS(4106),
    [anon_sym_when] = ACTIONS(4106),
    [sym_discard] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4106),
    [anon_sym_into] = ACTIONS(4106),
    [anon_sym_join] = ACTIONS(4106),
    [anon_sym_on] = ACTIONS(4106),
    [anon_sym_equals] = ACTIONS(4106),
    [anon_sym_let] = ACTIONS(4106),
    [anon_sym_orderby] = ACTIONS(4106),
    [anon_sym_ascending] = ACTIONS(4106),
    [anon_sym_descending] = ACTIONS(4106),
    [anon_sym_group] = ACTIONS(4106),
    [anon_sym_by] = ACTIONS(4106),
    [anon_sym_select] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4106),
    [anon_sym_is] = ACTIONS(4106),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4106),
    [aux_sym_preproc_if_token3] = ACTIONS(4108),
    [aux_sym_preproc_else_token1] = ACTIONS(4108),
    [aux_sym_preproc_elif_token1] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2397] = {
    [sym_preproc_region] = STATE(2397),
    [sym_preproc_endregion] = STATE(2397),
    [sym_preproc_line] = STATE(2397),
    [sym_preproc_pragma] = STATE(2397),
    [sym_preproc_nullable] = STATE(2397),
    [sym_preproc_error] = STATE(2397),
    [sym_preproc_warning] = STATE(2397),
    [sym_preproc_define] = STATE(2397),
    [sym_preproc_undef] = STATE(2397),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2398] = {
    [sym_preproc_region] = STATE(2398),
    [sym_preproc_endregion] = STATE(2398),
    [sym_preproc_line] = STATE(2398),
    [sym_preproc_pragma] = STATE(2398),
    [sym_preproc_nullable] = STATE(2398),
    [sym_preproc_error] = STATE(2398),
    [sym_preproc_warning] = STATE(2398),
    [sym_preproc_define] = STATE(2398),
    [sym_preproc_undef] = STATE(2398),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2399] = {
    [sym_preproc_region] = STATE(2399),
    [sym_preproc_endregion] = STATE(2399),
    [sym_preproc_line] = STATE(2399),
    [sym_preproc_pragma] = STATE(2399),
    [sym_preproc_nullable] = STATE(2399),
    [sym_preproc_error] = STATE(2399),
    [sym_preproc_warning] = STATE(2399),
    [sym_preproc_define] = STATE(2399),
    [sym_preproc_undef] = STATE(2399),
    [sym__identifier_token] = ACTIONS(3947),
    [anon_sym_alias] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_global] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3947),
    [anon_sym_where] = ACTIONS(3947),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_notnull] = ACTIONS(3947),
    [anon_sym_unmanaged] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_scoped] = ACTIONS(3947),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_when] = ACTIONS(3947),
    [sym_discard] = ACTIONS(3947),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3947),
    [anon_sym_into] = ACTIONS(3947),
    [anon_sym_join] = ACTIONS(3947),
    [anon_sym_on] = ACTIONS(3947),
    [anon_sym_equals] = ACTIONS(3947),
    [anon_sym_let] = ACTIONS(3947),
    [anon_sym_orderby] = ACTIONS(3947),
    [anon_sym_ascending] = ACTIONS(3947),
    [anon_sym_descending] = ACTIONS(3947),
    [anon_sym_group] = ACTIONS(3947),
    [anon_sym_by] = ACTIONS(3947),
    [anon_sym_select] = ACTIONS(3947),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_is] = ACTIONS(3947),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3947),
    [aux_sym_preproc_if_token3] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2400] = {
    [sym_preproc_region] = STATE(2400),
    [sym_preproc_endregion] = STATE(2400),
    [sym_preproc_line] = STATE(2400),
    [sym_preproc_pragma] = STATE(2400),
    [sym_preproc_nullable] = STATE(2400),
    [sym_preproc_error] = STATE(2400),
    [sym_preproc_warning] = STATE(2400),
    [sym_preproc_define] = STATE(2400),
    [sym_preproc_undef] = STATE(2400),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3706),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2401] = {
    [sym_preproc_region] = STATE(2401),
    [sym_preproc_endregion] = STATE(2401),
    [sym_preproc_line] = STATE(2401),
    [sym_preproc_pragma] = STATE(2401),
    [sym_preproc_nullable] = STATE(2401),
    [sym_preproc_error] = STATE(2401),
    [sym_preproc_warning] = STATE(2401),
    [sym_preproc_define] = STATE(2401),
    [sym_preproc_undef] = STATE(2401),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3736),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2402] = {
    [sym_type_argument_list] = STATE(2453),
    [sym_preproc_region] = STATE(2402),
    [sym_preproc_endregion] = STATE(2402),
    [sym_preproc_line] = STATE(2402),
    [sym_preproc_pragma] = STATE(2402),
    [sym_preproc_nullable] = STATE(2402),
    [sym_preproc_error] = STATE(2402),
    [sym_preproc_warning] = STATE(2402),
    [sym_preproc_define] = STATE(2402),
    [sym_preproc_undef] = STATE(2402),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2403] = {
    [sym_preproc_region] = STATE(2403),
    [sym_preproc_endregion] = STATE(2403),
    [sym_preproc_line] = STATE(2403),
    [sym_preproc_pragma] = STATE(2403),
    [sym_preproc_nullable] = STATE(2403),
    [sym_preproc_error] = STATE(2403),
    [sym_preproc_warning] = STATE(2403),
    [sym_preproc_define] = STATE(2403),
    [sym_preproc_undef] = STATE(2403),
    [sym__identifier_token] = ACTIONS(4119),
    [anon_sym_alias] = ACTIONS(4119),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_global] = ACTIONS(4119),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_LPAREN] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_file] = ACTIONS(4119),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_in] = ACTIONS(4119),
    [anon_sym_where] = ACTIONS(4119),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_notnull] = ACTIONS(4119),
    [anon_sym_unmanaged] = ACTIONS(4119),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4121),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4119),
    [anon_sym_scoped] = ACTIONS(4119),
    [anon_sym_EQ_GT] = ACTIONS(4121),
    [anon_sym_var] = ACTIONS(4119),
    [anon_sym_yield] = ACTIONS(4119),
    [anon_sym_switch] = ACTIONS(4119),
    [anon_sym_when] = ACTIONS(4119),
    [sym_discard] = ACTIONS(4119),
    [anon_sym_DOT_DOT] = ACTIONS(4121),
    [anon_sym_and] = ACTIONS(4119),
    [anon_sym_or] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_QMARK_QMARK] = ACTIONS(4121),
    [anon_sym_from] = ACTIONS(4119),
    [anon_sym_into] = ACTIONS(4119),
    [anon_sym_join] = ACTIONS(4119),
    [anon_sym_on] = ACTIONS(4119),
    [anon_sym_equals] = ACTIONS(4119),
    [anon_sym_let] = ACTIONS(4119),
    [anon_sym_orderby] = ACTIONS(4119),
    [anon_sym_ascending] = ACTIONS(4119),
    [anon_sym_descending] = ACTIONS(4119),
    [anon_sym_group] = ACTIONS(4119),
    [anon_sym_by] = ACTIONS(4119),
    [anon_sym_select] = ACTIONS(4119),
    [anon_sym_as] = ACTIONS(4119),
    [anon_sym_is] = ACTIONS(4119),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [anon_sym_with] = ACTIONS(4119),
    [aux_sym_preproc_if_token3] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2404] = {
    [sym_preproc_region] = STATE(2404),
    [sym_preproc_endregion] = STATE(2404),
    [sym_preproc_line] = STATE(2404),
    [sym_preproc_pragma] = STATE(2404),
    [sym_preproc_nullable] = STATE(2404),
    [sym_preproc_error] = STATE(2404),
    [sym_preproc_warning] = STATE(2404),
    [sym_preproc_define] = STATE(2404),
    [sym_preproc_undef] = STATE(2404),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3706),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2405] = {
    [sym_preproc_region] = STATE(2405),
    [sym_preproc_endregion] = STATE(2405),
    [sym_preproc_line] = STATE(2405),
    [sym_preproc_pragma] = STATE(2405),
    [sym_preproc_nullable] = STATE(2405),
    [sym_preproc_error] = STATE(2405),
    [sym_preproc_warning] = STATE(2405),
    [sym_preproc_define] = STATE(2405),
    [sym_preproc_undef] = STATE(2405),
    [sym__identifier_token] = ACTIONS(4123),
    [anon_sym_alias] = ACTIONS(4123),
    [anon_sym_SEMI] = ACTIONS(4125),
    [anon_sym_global] = ACTIONS(4123),
    [anon_sym_LBRACK] = ACTIONS(4125),
    [anon_sym_COLON] = ACTIONS(4125),
    [anon_sym_COMMA] = ACTIONS(4125),
    [anon_sym_RBRACK] = ACTIONS(4125),
    [anon_sym_LPAREN] = ACTIONS(4125),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_LBRACE] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_file] = ACTIONS(4123),
    [anon_sym_LT] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(4123),
    [anon_sym_in] = ACTIONS(4123),
    [anon_sym_where] = ACTIONS(4123),
    [anon_sym_QMARK] = ACTIONS(4123),
    [anon_sym_notnull] = ACTIONS(4123),
    [anon_sym_unmanaged] = ACTIONS(4123),
    [anon_sym_BANG] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4123),
    [anon_sym_DASH] = ACTIONS(4123),
    [anon_sym_STAR] = ACTIONS(4125),
    [anon_sym_SLASH] = ACTIONS(4123),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_CARET] = ACTIONS(4125),
    [anon_sym_PIPE] = ACTIONS(4123),
    [anon_sym_AMP] = ACTIONS(4123),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_GT_GT] = ACTIONS(4123),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_DOT] = ACTIONS(4123),
    [anon_sym_scoped] = ACTIONS(4123),
    [anon_sym_EQ_GT] = ACTIONS(4125),
    [anon_sym_var] = ACTIONS(4123),
    [anon_sym_yield] = ACTIONS(4123),
    [anon_sym_switch] = ACTIONS(4123),
    [anon_sym_when] = ACTIONS(4123),
    [sym_discard] = ACTIONS(4123),
    [anon_sym_DOT_DOT] = ACTIONS(4125),
    [anon_sym_and] = ACTIONS(4123),
    [anon_sym_or] = ACTIONS(4123),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_QMARK_QMARK] = ACTIONS(4125),
    [anon_sym_from] = ACTIONS(4123),
    [anon_sym_into] = ACTIONS(4123),
    [anon_sym_join] = ACTIONS(4123),
    [anon_sym_on] = ACTIONS(4123),
    [anon_sym_equals] = ACTIONS(4123),
    [anon_sym_let] = ACTIONS(4123),
    [anon_sym_orderby] = ACTIONS(4123),
    [anon_sym_ascending] = ACTIONS(4123),
    [anon_sym_descending] = ACTIONS(4123),
    [anon_sym_group] = ACTIONS(4123),
    [anon_sym_by] = ACTIONS(4123),
    [anon_sym_select] = ACTIONS(4123),
    [anon_sym_as] = ACTIONS(4123),
    [anon_sym_is] = ACTIONS(4123),
    [anon_sym_DASH_GT] = ACTIONS(4125),
    [anon_sym_with] = ACTIONS(4123),
    [aux_sym_preproc_if_token3] = ACTIONS(4125),
    [aux_sym_preproc_else_token1] = ACTIONS(4125),
    [aux_sym_preproc_elif_token1] = ACTIONS(4125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2406] = {
    [sym_preproc_region] = STATE(2406),
    [sym_preproc_endregion] = STATE(2406),
    [sym_preproc_line] = STATE(2406),
    [sym_preproc_pragma] = STATE(2406),
    [sym_preproc_nullable] = STATE(2406),
    [sym_preproc_error] = STATE(2406),
    [sym_preproc_warning] = STATE(2406),
    [sym_preproc_define] = STATE(2406),
    [sym_preproc_undef] = STATE(2406),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3706),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2407] = {
    [sym_preproc_region] = STATE(2407),
    [sym_preproc_endregion] = STATE(2407),
    [sym_preproc_line] = STATE(2407),
    [sym_preproc_pragma] = STATE(2407),
    [sym_preproc_nullable] = STATE(2407),
    [sym_preproc_error] = STATE(2407),
    [sym_preproc_warning] = STATE(2407),
    [sym_preproc_define] = STATE(2407),
    [sym_preproc_undef] = STATE(2407),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3697),
    [anon_sym_GT_GT_GT] = ACTIONS(3699),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_GT_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3697),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(3699),
    [anon_sym_QMARK_QMARK] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3697),
    [anon_sym_is] = ACTIONS(3697),
    [anon_sym_DASH_GT] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3697),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2408] = {
    [sym_preproc_region] = STATE(2408),
    [sym_preproc_endregion] = STATE(2408),
    [sym_preproc_line] = STATE(2408),
    [sym_preproc_pragma] = STATE(2408),
    [sym_preproc_nullable] = STATE(2408),
    [sym_preproc_error] = STATE(2408),
    [sym_preproc_warning] = STATE(2408),
    [sym_preproc_define] = STATE(2408),
    [sym_preproc_undef] = STATE(2408),
    [sym__identifier_token] = ACTIONS(4127),
    [anon_sym_alias] = ACTIONS(4127),
    [anon_sym_SEMI] = ACTIONS(4129),
    [anon_sym_global] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_COLON] = ACTIONS(4129),
    [anon_sym_COMMA] = ACTIONS(4129),
    [anon_sym_RBRACK] = ACTIONS(4129),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_RPAREN] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [anon_sym_RBRACE] = ACTIONS(4129),
    [anon_sym_file] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_in] = ACTIONS(4127),
    [anon_sym_where] = ACTIONS(4127),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_notnull] = ACTIONS(4127),
    [anon_sym_unmanaged] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_SLASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4129),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_LT_LT] = ACTIONS(4129),
    [anon_sym_GT_GT] = ACTIONS(4127),
    [anon_sym_GT_GT_GT] = ACTIONS(4129),
    [anon_sym_EQ_EQ] = ACTIONS(4129),
    [anon_sym_BANG_EQ] = ACTIONS(4129),
    [anon_sym_GT_EQ] = ACTIONS(4129),
    [anon_sym_LT_EQ] = ACTIONS(4129),
    [anon_sym_DOT] = ACTIONS(4127),
    [anon_sym_scoped] = ACTIONS(4127),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_var] = ACTIONS(4127),
    [anon_sym_yield] = ACTIONS(4127),
    [anon_sym_switch] = ACTIONS(4127),
    [anon_sym_when] = ACTIONS(4127),
    [sym_discard] = ACTIONS(4127),
    [anon_sym_DOT_DOT] = ACTIONS(4129),
    [anon_sym_and] = ACTIONS(4127),
    [anon_sym_or] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4129),
    [anon_sym_PIPE_PIPE] = ACTIONS(4129),
    [anon_sym_QMARK_QMARK] = ACTIONS(4129),
    [anon_sym_from] = ACTIONS(4127),
    [anon_sym_into] = ACTIONS(4127),
    [anon_sym_join] = ACTIONS(4127),
    [anon_sym_on] = ACTIONS(4127),
    [anon_sym_equals] = ACTIONS(4127),
    [anon_sym_let] = ACTIONS(4127),
    [anon_sym_orderby] = ACTIONS(4127),
    [anon_sym_ascending] = ACTIONS(4127),
    [anon_sym_descending] = ACTIONS(4127),
    [anon_sym_group] = ACTIONS(4127),
    [anon_sym_by] = ACTIONS(4127),
    [anon_sym_select] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4127),
    [anon_sym_is] = ACTIONS(4127),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [anon_sym_with] = ACTIONS(4127),
    [aux_sym_preproc_if_token3] = ACTIONS(4129),
    [aux_sym_preproc_else_token1] = ACTIONS(4129),
    [aux_sym_preproc_elif_token1] = ACTIONS(4129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2409] = {
    [sym_preproc_region] = STATE(2409),
    [sym_preproc_endregion] = STATE(2409),
    [sym_preproc_line] = STATE(2409),
    [sym_preproc_pragma] = STATE(2409),
    [sym_preproc_nullable] = STATE(2409),
    [sym_preproc_error] = STATE(2409),
    [sym_preproc_warning] = STATE(2409),
    [sym_preproc_define] = STATE(2409),
    [sym_preproc_undef] = STATE(2409),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3736),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2410] = {
    [sym_preproc_region] = STATE(2410),
    [sym_preproc_endregion] = STATE(2410),
    [sym_preproc_line] = STATE(2410),
    [sym_preproc_pragma] = STATE(2410),
    [sym_preproc_nullable] = STATE(2410),
    [sym_preproc_error] = STATE(2410),
    [sym_preproc_warning] = STATE(2410),
    [sym_preproc_define] = STATE(2410),
    [sym_preproc_undef] = STATE(2410),
    [sym__identifier_token] = ACTIONS(3674),
    [anon_sym_alias] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_global] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_file] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_notnull] = ACTIONS(3674),
    [anon_sym_unmanaged] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_CARET] = ACTIONS(3676),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3676),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_scoped] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_var] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3674),
    [anon_sym_switch] = ACTIONS(3674),
    [anon_sym_when] = ACTIONS(3674),
    [sym_discard] = ACTIONS(3674),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3676),
    [anon_sym_from] = ACTIONS(3674),
    [anon_sym_into] = ACTIONS(3674),
    [anon_sym_join] = ACTIONS(3674),
    [anon_sym_on] = ACTIONS(3674),
    [anon_sym_equals] = ACTIONS(3674),
    [anon_sym_let] = ACTIONS(3674),
    [anon_sym_orderby] = ACTIONS(3674),
    [anon_sym_ascending] = ACTIONS(3674),
    [anon_sym_descending] = ACTIONS(3674),
    [anon_sym_group] = ACTIONS(3674),
    [anon_sym_by] = ACTIONS(3674),
    [anon_sym_select] = ACTIONS(3674),
    [anon_sym_as] = ACTIONS(3674),
    [anon_sym_is] = ACTIONS(3674),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3674),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2411] = {
    [sym_preproc_region] = STATE(2411),
    [sym_preproc_endregion] = STATE(2411),
    [sym_preproc_line] = STATE(2411),
    [sym_preproc_pragma] = STATE(2411),
    [sym_preproc_nullable] = STATE(2411),
    [sym_preproc_error] = STATE(2411),
    [sym_preproc_warning] = STATE(2411),
    [sym_preproc_define] = STATE(2411),
    [sym_preproc_undef] = STATE(2411),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2412] = {
    [sym_preproc_region] = STATE(2412),
    [sym_preproc_endregion] = STATE(2412),
    [sym_preproc_line] = STATE(2412),
    [sym_preproc_pragma] = STATE(2412),
    [sym_preproc_nullable] = STATE(2412),
    [sym_preproc_error] = STATE(2412),
    [sym_preproc_warning] = STATE(2412),
    [sym_preproc_define] = STATE(2412),
    [sym_preproc_undef] = STATE(2412),
    [sym__identifier_token] = ACTIONS(4127),
    [anon_sym_alias] = ACTIONS(4127),
    [anon_sym_SEMI] = ACTIONS(4129),
    [anon_sym_global] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_COLON] = ACTIONS(4129),
    [anon_sym_COMMA] = ACTIONS(4129),
    [anon_sym_RBRACK] = ACTIONS(4129),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_RPAREN] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [anon_sym_RBRACE] = ACTIONS(4129),
    [anon_sym_file] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_in] = ACTIONS(4127),
    [anon_sym_where] = ACTIONS(4127),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_notnull] = ACTIONS(4127),
    [anon_sym_unmanaged] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_SLASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4129),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_LT_LT] = ACTIONS(4129),
    [anon_sym_GT_GT] = ACTIONS(4127),
    [anon_sym_GT_GT_GT] = ACTIONS(4129),
    [anon_sym_EQ_EQ] = ACTIONS(4129),
    [anon_sym_BANG_EQ] = ACTIONS(4129),
    [anon_sym_GT_EQ] = ACTIONS(4129),
    [anon_sym_LT_EQ] = ACTIONS(4129),
    [anon_sym_DOT] = ACTIONS(4127),
    [anon_sym_scoped] = ACTIONS(4127),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_var] = ACTIONS(4127),
    [anon_sym_yield] = ACTIONS(4127),
    [anon_sym_switch] = ACTIONS(4127),
    [anon_sym_when] = ACTIONS(4127),
    [sym_discard] = ACTIONS(4127),
    [anon_sym_DOT_DOT] = ACTIONS(4129),
    [anon_sym_and] = ACTIONS(4127),
    [anon_sym_or] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4129),
    [anon_sym_PIPE_PIPE] = ACTIONS(4129),
    [anon_sym_QMARK_QMARK] = ACTIONS(4129),
    [anon_sym_from] = ACTIONS(4127),
    [anon_sym_into] = ACTIONS(4127),
    [anon_sym_join] = ACTIONS(4127),
    [anon_sym_on] = ACTIONS(4127),
    [anon_sym_equals] = ACTIONS(4127),
    [anon_sym_let] = ACTIONS(4127),
    [anon_sym_orderby] = ACTIONS(4127),
    [anon_sym_ascending] = ACTIONS(4127),
    [anon_sym_descending] = ACTIONS(4127),
    [anon_sym_group] = ACTIONS(4127),
    [anon_sym_by] = ACTIONS(4127),
    [anon_sym_select] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4127),
    [anon_sym_is] = ACTIONS(4127),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [anon_sym_with] = ACTIONS(4127),
    [aux_sym_preproc_if_token3] = ACTIONS(4129),
    [aux_sym_preproc_else_token1] = ACTIONS(4129),
    [aux_sym_preproc_elif_token1] = ACTIONS(4129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2413] = {
    [sym_preproc_region] = STATE(2413),
    [sym_preproc_endregion] = STATE(2413),
    [sym_preproc_line] = STATE(2413),
    [sym_preproc_pragma] = STATE(2413),
    [sym_preproc_nullable] = STATE(2413),
    [sym_preproc_error] = STATE(2413),
    [sym_preproc_warning] = STATE(2413),
    [sym_preproc_define] = STATE(2413),
    [sym_preproc_undef] = STATE(2413),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2414] = {
    [sym_preproc_region] = STATE(2414),
    [sym_preproc_endregion] = STATE(2414),
    [sym_preproc_line] = STATE(2414),
    [sym_preproc_pragma] = STATE(2414),
    [sym_preproc_nullable] = STATE(2414),
    [sym_preproc_error] = STATE(2414),
    [sym_preproc_warning] = STATE(2414),
    [sym_preproc_define] = STATE(2414),
    [sym_preproc_undef] = STATE(2414),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3706),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2415] = {
    [sym_preproc_region] = STATE(2415),
    [sym_preproc_endregion] = STATE(2415),
    [sym_preproc_line] = STATE(2415),
    [sym_preproc_pragma] = STATE(2415),
    [sym_preproc_nullable] = STATE(2415),
    [sym_preproc_error] = STATE(2415),
    [sym_preproc_warning] = STATE(2415),
    [sym_preproc_define] = STATE(2415),
    [sym_preproc_undef] = STATE(2415),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2416] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2529),
    [sym_property_pattern_clause] = STATE(2570),
    [sym__variable_designation] = STATE(4817),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4445),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2416),
    [sym_preproc_endregion] = STATE(2416),
    [sym_preproc_line] = STATE(2416),
    [sym_preproc_pragma] = STATE(2416),
    [sym_preproc_nullable] = STATE(2416),
    [sym_preproc_error] = STATE(2416),
    [sym_preproc_warning] = STATE(2416),
    [sym_preproc_define] = STATE(2416),
    [sym_preproc_undef] = STATE(2416),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3901),
  },
  [2417] = {
    [sym__name] = STATE(2448),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2417),
    [sym_preproc_endregion] = STATE(2417),
    [sym_preproc_line] = STATE(2417),
    [sym_preproc_pragma] = STATE(2417),
    [sym_preproc_nullable] = STATE(2417),
    [sym_preproc_error] = STATE(2417),
    [sym_preproc_warning] = STATE(2417),
    [sym_preproc_define] = STATE(2417),
    [sym_preproc_undef] = STATE(2417),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(3596),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2418] = {
    [sym_preproc_region] = STATE(2418),
    [sym_preproc_endregion] = STATE(2418),
    [sym_preproc_line] = STATE(2418),
    [sym_preproc_pragma] = STATE(2418),
    [sym_preproc_nullable] = STATE(2418),
    [sym_preproc_error] = STATE(2418),
    [sym_preproc_warning] = STATE(2418),
    [sym_preproc_define] = STATE(2418),
    [sym_preproc_undef] = STATE(2418),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2419] = {
    [sym_preproc_region] = STATE(2419),
    [sym_preproc_endregion] = STATE(2419),
    [sym_preproc_line] = STATE(2419),
    [sym_preproc_pragma] = STATE(2419),
    [sym_preproc_nullable] = STATE(2419),
    [sym_preproc_error] = STATE(2419),
    [sym_preproc_warning] = STATE(2419),
    [sym_preproc_define] = STATE(2419),
    [sym_preproc_undef] = STATE(2419),
    [sym__identifier_token] = ACTIONS(3666),
    [anon_sym_alias] = ACTIONS(3666),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_global] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_file] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3666),
    [anon_sym_where] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_notnull] = ACTIONS(3666),
    [anon_sym_unmanaged] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3668),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3668),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_scoped] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_var] = ACTIONS(3666),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_switch] = ACTIONS(3666),
    [anon_sym_when] = ACTIONS(3666),
    [sym_discard] = ACTIONS(3666),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3666),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3668),
    [anon_sym_from] = ACTIONS(3666),
    [anon_sym_into] = ACTIONS(3666),
    [anon_sym_join] = ACTIONS(3666),
    [anon_sym_on] = ACTIONS(3666),
    [anon_sym_equals] = ACTIONS(3666),
    [anon_sym_let] = ACTIONS(3666),
    [anon_sym_orderby] = ACTIONS(3666),
    [anon_sym_ascending] = ACTIONS(3666),
    [anon_sym_descending] = ACTIONS(3666),
    [anon_sym_group] = ACTIONS(3666),
    [anon_sym_by] = ACTIONS(3666),
    [anon_sym_select] = ACTIONS(3666),
    [anon_sym_as] = ACTIONS(3666),
    [anon_sym_is] = ACTIONS(3666),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3666),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2420] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2529),
    [sym_property_pattern_clause] = STATE(2570),
    [sym__variable_designation] = STATE(4817),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4445),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2420),
    [sym_preproc_endregion] = STATE(2420),
    [sym_preproc_line] = STATE(2420),
    [sym_preproc_pragma] = STATE(2420),
    [sym_preproc_nullable] = STATE(2420),
    [sym_preproc_error] = STATE(2420),
    [sym_preproc_warning] = STATE(2420),
    [sym_preproc_define] = STATE(2420),
    [sym_preproc_undef] = STATE(2420),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3911),
  },
  [2421] = {
    [sym_preproc_region] = STATE(2421),
    [sym_preproc_endregion] = STATE(2421),
    [sym_preproc_line] = STATE(2421),
    [sym_preproc_pragma] = STATE(2421),
    [sym_preproc_nullable] = STATE(2421),
    [sym_preproc_error] = STATE(2421),
    [sym_preproc_warning] = STATE(2421),
    [sym_preproc_define] = STATE(2421),
    [sym_preproc_undef] = STATE(2421),
    [sym__identifier_token] = ACTIONS(4142),
    [anon_sym_alias] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_global] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_file] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_notnull] = ACTIONS(4142),
    [anon_sym_unmanaged] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_scoped] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_when] = ACTIONS(4142),
    [sym_discard] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4142),
    [anon_sym_join] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4142),
    [anon_sym_equals] = ACTIONS(4142),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_orderby] = ACTIONS(4142),
    [anon_sym_ascending] = ACTIONS(4142),
    [anon_sym_descending] = ACTIONS(4142),
    [anon_sym_group] = ACTIONS(4142),
    [anon_sym_by] = ACTIONS(4142),
    [anon_sym_select] = ACTIONS(4142),
    [anon_sym_as] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2422] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2529),
    [sym_property_pattern_clause] = STATE(2570),
    [sym__variable_designation] = STATE(4817),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4445),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2422),
    [sym_preproc_endregion] = STATE(2422),
    [sym_preproc_line] = STATE(2422),
    [sym_preproc_pragma] = STATE(2422),
    [sym_preproc_nullable] = STATE(2422),
    [sym_preproc_error] = STATE(2422),
    [sym_preproc_warning] = STATE(2422),
    [sym_preproc_define] = STATE(2422),
    [sym_preproc_undef] = STATE(2422),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3901),
  },
  [2423] = {
    [sym_preproc_region] = STATE(2423),
    [sym_preproc_endregion] = STATE(2423),
    [sym_preproc_line] = STATE(2423),
    [sym_preproc_pragma] = STATE(2423),
    [sym_preproc_nullable] = STATE(2423),
    [sym_preproc_error] = STATE(2423),
    [sym_preproc_warning] = STATE(2423),
    [sym_preproc_define] = STATE(2423),
    [sym_preproc_undef] = STATE(2423),
    [sym__identifier_token] = ACTIONS(4146),
    [anon_sym_alias] = ACTIONS(4146),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_global] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_file] = ACTIONS(4146),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4146),
    [anon_sym_in] = ACTIONS(4146),
    [anon_sym_where] = ACTIONS(4146),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_notnull] = ACTIONS(4146),
    [anon_sym_unmanaged] = ACTIONS(4146),
    [anon_sym_BANG] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4146),
    [anon_sym_AMP] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4146),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_scoped] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_var] = ACTIONS(4146),
    [anon_sym_yield] = ACTIONS(4146),
    [anon_sym_switch] = ACTIONS(4146),
    [anon_sym_when] = ACTIONS(4146),
    [sym_discard] = ACTIONS(4146),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_QMARK_QMARK] = ACTIONS(4148),
    [anon_sym_from] = ACTIONS(4146),
    [anon_sym_into] = ACTIONS(4146),
    [anon_sym_join] = ACTIONS(4146),
    [anon_sym_on] = ACTIONS(4146),
    [anon_sym_equals] = ACTIONS(4146),
    [anon_sym_let] = ACTIONS(4146),
    [anon_sym_orderby] = ACTIONS(4146),
    [anon_sym_ascending] = ACTIONS(4146),
    [anon_sym_descending] = ACTIONS(4146),
    [anon_sym_group] = ACTIONS(4146),
    [anon_sym_by] = ACTIONS(4146),
    [anon_sym_select] = ACTIONS(4146),
    [anon_sym_as] = ACTIONS(4146),
    [anon_sym_is] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_with] = ACTIONS(4146),
    [aux_sym_preproc_if_token3] = ACTIONS(4148),
    [aux_sym_preproc_else_token1] = ACTIONS(4148),
    [aux_sym_preproc_elif_token1] = ACTIONS(4148),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2424] = {
    [sym_preproc_region] = STATE(2424),
    [sym_preproc_endregion] = STATE(2424),
    [sym_preproc_line] = STATE(2424),
    [sym_preproc_pragma] = STATE(2424),
    [sym_preproc_nullable] = STATE(2424),
    [sym_preproc_error] = STATE(2424),
    [sym_preproc_warning] = STATE(2424),
    [sym_preproc_define] = STATE(2424),
    [sym_preproc_undef] = STATE(2424),
    [sym__identifier_token] = ACTIONS(4150),
    [anon_sym_alias] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_global] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_RBRACK] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_file] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_notnull] = ACTIONS(4150),
    [anon_sym_unmanaged] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_CARET] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4152),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_scoped] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4152),
    [anon_sym_var] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_switch] = ACTIONS(4150),
    [anon_sym_when] = ACTIONS(4150),
    [sym_discard] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_QMARK_QMARK] = ACTIONS(4152),
    [anon_sym_from] = ACTIONS(4150),
    [anon_sym_into] = ACTIONS(4150),
    [anon_sym_join] = ACTIONS(4150),
    [anon_sym_on] = ACTIONS(4150),
    [anon_sym_equals] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_orderby] = ACTIONS(4150),
    [anon_sym_ascending] = ACTIONS(4150),
    [anon_sym_descending] = ACTIONS(4150),
    [anon_sym_group] = ACTIONS(4150),
    [anon_sym_by] = ACTIONS(4150),
    [anon_sym_select] = ACTIONS(4150),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_is] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [anon_sym_with] = ACTIONS(4150),
    [aux_sym_preproc_if_token3] = ACTIONS(4152),
    [aux_sym_preproc_else_token1] = ACTIONS(4152),
    [aux_sym_preproc_elif_token1] = ACTIONS(4152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2425] = {
    [sym_preproc_region] = STATE(2425),
    [sym_preproc_endregion] = STATE(2425),
    [sym_preproc_line] = STATE(2425),
    [sym_preproc_pragma] = STATE(2425),
    [sym_preproc_nullable] = STATE(2425),
    [sym_preproc_error] = STATE(2425),
    [sym_preproc_warning] = STATE(2425),
    [sym_preproc_define] = STATE(2425),
    [sym_preproc_undef] = STATE(2425),
    [sym__identifier_token] = ACTIONS(4154),
    [anon_sym_alias] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym_global] = ACTIONS(4154),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_file] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(4154),
    [anon_sym_where] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_notnull] = ACTIONS(4154),
    [anon_sym_unmanaged] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_GT_GT_GT] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4156),
    [anon_sym_BANG_EQ] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4156),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_scoped] = ACTIONS(4154),
    [anon_sym_EQ_GT] = ACTIONS(4156),
    [anon_sym_var] = ACTIONS(4154),
    [anon_sym_yield] = ACTIONS(4154),
    [anon_sym_switch] = ACTIONS(4154),
    [anon_sym_when] = ACTIONS(4154),
    [sym_discard] = ACTIONS(4154),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4156),
    [anon_sym_QMARK_QMARK] = ACTIONS(4156),
    [anon_sym_from] = ACTIONS(4154),
    [anon_sym_into] = ACTIONS(4154),
    [anon_sym_join] = ACTIONS(4154),
    [anon_sym_on] = ACTIONS(4154),
    [anon_sym_equals] = ACTIONS(4154),
    [anon_sym_let] = ACTIONS(4154),
    [anon_sym_orderby] = ACTIONS(4154),
    [anon_sym_ascending] = ACTIONS(4154),
    [anon_sym_descending] = ACTIONS(4154),
    [anon_sym_group] = ACTIONS(4154),
    [anon_sym_by] = ACTIONS(4154),
    [anon_sym_select] = ACTIONS(4154),
    [anon_sym_as] = ACTIONS(4154),
    [anon_sym_is] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(4156),
    [anon_sym_with] = ACTIONS(4154),
    [aux_sym_preproc_if_token3] = ACTIONS(4156),
    [aux_sym_preproc_else_token1] = ACTIONS(4156),
    [aux_sym_preproc_elif_token1] = ACTIONS(4156),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2426] = {
    [sym_preproc_region] = STATE(2426),
    [sym_preproc_endregion] = STATE(2426),
    [sym_preproc_line] = STATE(2426),
    [sym_preproc_pragma] = STATE(2426),
    [sym_preproc_nullable] = STATE(2426),
    [sym_preproc_error] = STATE(2426),
    [sym_preproc_warning] = STATE(2426),
    [sym_preproc_define] = STATE(2426),
    [sym_preproc_undef] = STATE(2426),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2427] = {
    [sym_preproc_region] = STATE(2427),
    [sym_preproc_endregion] = STATE(2427),
    [sym_preproc_line] = STATE(2427),
    [sym_preproc_pragma] = STATE(2427),
    [sym_preproc_nullable] = STATE(2427),
    [sym_preproc_error] = STATE(2427),
    [sym_preproc_warning] = STATE(2427),
    [sym_preproc_define] = STATE(2427),
    [sym_preproc_undef] = STATE(2427),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2428] = {
    [sym_preproc_region] = STATE(2428),
    [sym_preproc_endregion] = STATE(2428),
    [sym_preproc_line] = STATE(2428),
    [sym_preproc_pragma] = STATE(2428),
    [sym_preproc_nullable] = STATE(2428),
    [sym_preproc_error] = STATE(2428),
    [sym_preproc_warning] = STATE(2428),
    [sym_preproc_define] = STATE(2428),
    [sym_preproc_undef] = STATE(2428),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3722),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3722),
    [anon_sym_DASH_DASH] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_GT_GT_GT] = ACTIONS(3722),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_GT_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3722),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_QMARK_QMARK] = ACTIONS(3722),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3711),
    [anon_sym_is] = ACTIONS(3711),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_with] = ACTIONS(3711),
    [aux_sym_preproc_if_token3] = ACTIONS(3722),
    [aux_sym_preproc_else_token1] = ACTIONS(3722),
    [aux_sym_preproc_elif_token1] = ACTIONS(3722),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2429] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2517),
    [sym_property_pattern_clause] = STATE(2584),
    [sym__variable_designation] = STATE(4817),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4445),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2429),
    [sym_preproc_endregion] = STATE(2429),
    [sym_preproc_line] = STATE(2429),
    [sym_preproc_pragma] = STATE(2429),
    [sym_preproc_nullable] = STATE(2429),
    [sym_preproc_error] = STATE(2429),
    [sym_preproc_warning] = STATE(2429),
    [sym_preproc_define] = STATE(2429),
    [sym_preproc_undef] = STATE(2429),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3901),
  },
  [2430] = {
    [sym_preproc_region] = STATE(2430),
    [sym_preproc_endregion] = STATE(2430),
    [sym_preproc_line] = STATE(2430),
    [sym_preproc_pragma] = STATE(2430),
    [sym_preproc_nullable] = STATE(2430),
    [sym_preproc_error] = STATE(2430),
    [sym_preproc_warning] = STATE(2430),
    [sym_preproc_define] = STATE(2430),
    [sym_preproc_undef] = STATE(2430),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3736),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3716),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3716),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3736),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3736),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3716),
    [anon_sym_DASH_GT] = ACTIONS(3733),
    [anon_sym_with] = ACTIONS(3716),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2431] = {
    [sym_preproc_region] = STATE(2431),
    [sym_preproc_endregion] = STATE(2431),
    [sym_preproc_line] = STATE(2431),
    [sym_preproc_pragma] = STATE(2431),
    [sym_preproc_nullable] = STATE(2431),
    [sym_preproc_error] = STATE(2431),
    [sym_preproc_warning] = STATE(2431),
    [sym_preproc_define] = STATE(2431),
    [sym_preproc_undef] = STATE(2431),
    [sym__identifier_token] = ACTIONS(3670),
    [anon_sym_alias] = ACTIONS(3670),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_global] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_file] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_where] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_notnull] = ACTIONS(3670),
    [anon_sym_unmanaged] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_scoped] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_var] = ACTIONS(3670),
    [anon_sym_yield] = ACTIONS(3670),
    [anon_sym_switch] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [sym_discard] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3672),
    [anon_sym_from] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3670),
    [anon_sym_join] = ACTIONS(3670),
    [anon_sym_on] = ACTIONS(3670),
    [anon_sym_equals] = ACTIONS(3670),
    [anon_sym_let] = ACTIONS(3670),
    [anon_sym_orderby] = ACTIONS(3670),
    [anon_sym_ascending] = ACTIONS(3670),
    [anon_sym_descending] = ACTIONS(3670),
    [anon_sym_group] = ACTIONS(3670),
    [anon_sym_by] = ACTIONS(3670),
    [anon_sym_select] = ACTIONS(3670),
    [anon_sym_as] = ACTIONS(3670),
    [anon_sym_is] = ACTIONS(3670),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3670),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2432] = {
    [sym_preproc_region] = STATE(2432),
    [sym_preproc_endregion] = STATE(2432),
    [sym_preproc_line] = STATE(2432),
    [sym_preproc_pragma] = STATE(2432),
    [sym_preproc_nullable] = STATE(2432),
    [sym_preproc_error] = STATE(2432),
    [sym_preproc_warning] = STATE(2432),
    [sym_preproc_define] = STATE(2432),
    [sym_preproc_undef] = STATE(2432),
    [sym__identifier_token] = ACTIONS(3684),
    [anon_sym_alias] = ACTIONS(3684),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_global] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_file] = ACTIONS(3684),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3684),
    [anon_sym_where] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_notnull] = ACTIONS(3684),
    [anon_sym_unmanaged] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3686),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3686),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_scoped] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_var] = ACTIONS(3684),
    [anon_sym_yield] = ACTIONS(3684),
    [anon_sym_switch] = ACTIONS(3684),
    [anon_sym_when] = ACTIONS(3684),
    [sym_discard] = ACTIONS(3684),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3684),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3686),
    [anon_sym_from] = ACTIONS(3684),
    [anon_sym_into] = ACTIONS(3684),
    [anon_sym_join] = ACTIONS(3684),
    [anon_sym_on] = ACTIONS(3684),
    [anon_sym_equals] = ACTIONS(3684),
    [anon_sym_let] = ACTIONS(3684),
    [anon_sym_orderby] = ACTIONS(3684),
    [anon_sym_ascending] = ACTIONS(3684),
    [anon_sym_descending] = ACTIONS(3684),
    [anon_sym_group] = ACTIONS(3684),
    [anon_sym_by] = ACTIONS(3684),
    [anon_sym_select] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_is] = ACTIONS(3684),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3684),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2433] = {
    [sym__name] = STATE(5258),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_ref_type] = STATE(3271),
    [sym__scoped_base_type] = STATE(3273),
    [sym_identifier] = STATE(4595),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2433),
    [sym_preproc_endregion] = STATE(2433),
    [sym_preproc_line] = STATE(2433),
    [sym_preproc_pragma] = STATE(2433),
    [sym_preproc_nullable] = STATE(2433),
    [sym_preproc_error] = STATE(2433),
    [sym_preproc_warning] = STATE(2433),
    [sym_preproc_define] = STATE(2433),
    [sym_preproc_undef] = STATE(2433),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4162),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2434] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2517),
    [sym_property_pattern_clause] = STATE(2584),
    [sym__variable_designation] = STATE(4817),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4445),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2434),
    [sym_preproc_endregion] = STATE(2434),
    [sym_preproc_line] = STATE(2434),
    [sym_preproc_pragma] = STATE(2434),
    [sym_preproc_nullable] = STATE(2434),
    [sym_preproc_error] = STATE(2434),
    [sym_preproc_warning] = STATE(2434),
    [sym_preproc_define] = STATE(2434),
    [sym_preproc_undef] = STATE(2434),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3901),
  },
  [2435] = {
    [sym_preproc_region] = STATE(2435),
    [sym_preproc_endregion] = STATE(2435),
    [sym_preproc_line] = STATE(2435),
    [sym_preproc_pragma] = STATE(2435),
    [sym_preproc_nullable] = STATE(2435),
    [sym_preproc_error] = STATE(2435),
    [sym_preproc_warning] = STATE(2435),
    [sym_preproc_define] = STATE(2435),
    [sym_preproc_undef] = STATE(2435),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3701),
    [anon_sym_when] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3701),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3706),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2436] = {
    [sym_preproc_region] = STATE(2436),
    [sym_preproc_endregion] = STATE(2436),
    [sym_preproc_line] = STATE(2436),
    [sym_preproc_pragma] = STATE(2436),
    [sym_preproc_nullable] = STATE(2436),
    [sym_preproc_error] = STATE(2436),
    [sym_preproc_warning] = STATE(2436),
    [sym_preproc_define] = STATE(2436),
    [sym_preproc_undef] = STATE(2436),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3664),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3664),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_join] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_let] = ACTIONS(3664),
    [anon_sym_orderby] = ACTIONS(3664),
    [anon_sym_group] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_select] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2437] = {
    [sym_preproc_region] = STATE(2437),
    [sym_preproc_endregion] = STATE(2437),
    [sym_preproc_line] = STATE(2437),
    [sym_preproc_pragma] = STATE(2437),
    [sym_preproc_nullable] = STATE(2437),
    [sym_preproc_error] = STATE(2437),
    [sym_preproc_warning] = STATE(2437),
    [sym_preproc_define] = STATE(2437),
    [sym_preproc_undef] = STATE(2437),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4166),
    [anon_sym_in] = ACTIONS(4166),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_GT_GT_GT] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4164),
    [anon_sym_BANG_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK] = ACTIONS(4166),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_if_token3] = ACTIONS(4164),
    [aux_sym_preproc_else_token1] = ACTIONS(4164),
    [aux_sym_preproc_elif_token1] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2438] = {
    [sym_preproc_region] = STATE(2438),
    [sym_preproc_endregion] = STATE(2438),
    [sym_preproc_line] = STATE(2438),
    [sym_preproc_pragma] = STATE(2438),
    [sym_preproc_nullable] = STATE(2438),
    [sym_preproc_error] = STATE(2438),
    [sym_preproc_warning] = STATE(2438),
    [sym_preproc_define] = STATE(2438),
    [sym_preproc_undef] = STATE(2438),
    [anon_sym_SEMI] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4168),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_RBRACK] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_RPAREN] = ACTIONS(4168),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_in] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4168),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_SLASH] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_CARET] = ACTIONS(4170),
    [anon_sym_PIPE] = ACTIONS(4170),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_GT] = ACTIONS(4170),
    [anon_sym_GT_GT_GT] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4168),
    [anon_sym_BANG_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4168),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_and] = ACTIONS(4168),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_PLUS_EQ] = ACTIONS(4168),
    [anon_sym_DASH_EQ] = ACTIONS(4168),
    [anon_sym_STAR_EQ] = ACTIONS(4168),
    [anon_sym_SLASH_EQ] = ACTIONS(4168),
    [anon_sym_PERCENT_EQ] = ACTIONS(4168),
    [anon_sym_AMP_EQ] = ACTIONS(4168),
    [anon_sym_CARET_EQ] = ACTIONS(4168),
    [anon_sym_PIPE_EQ] = ACTIONS(4168),
    [anon_sym_LT_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4168),
    [anon_sym_into] = ACTIONS(4168),
    [anon_sym_join] = ACTIONS(4168),
    [anon_sym_on] = ACTIONS(4168),
    [anon_sym_equals] = ACTIONS(4168),
    [anon_sym_let] = ACTIONS(4168),
    [anon_sym_orderby] = ACTIONS(4168),
    [anon_sym_group] = ACTIONS(4168),
    [anon_sym_by] = ACTIONS(4168),
    [anon_sym_select] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4168),
    [anon_sym_is] = ACTIONS(4168),
    [anon_sym_DASH_GT] = ACTIONS(4168),
    [anon_sym_with] = ACTIONS(4168),
    [aux_sym_preproc_if_token3] = ACTIONS(4168),
    [aux_sym_preproc_else_token1] = ACTIONS(4168),
    [aux_sym_preproc_elif_token1] = ACTIONS(4168),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2439] = {
    [sym_preproc_region] = STATE(2439),
    [sym_preproc_endregion] = STATE(2439),
    [sym_preproc_line] = STATE(2439),
    [sym_preproc_pragma] = STATE(2439),
    [sym_preproc_nullable] = STATE(2439),
    [sym_preproc_error] = STATE(2439),
    [sym_preproc_warning] = STATE(2439),
    [sym_preproc_define] = STATE(2439),
    [sym_preproc_undef] = STATE(2439),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_RBRACK] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_in] = ACTIONS(4174),
    [anon_sym_where] = ACTIONS(4172),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_GT_GT_GT] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_EQ_GT] = ACTIONS(4172),
    [anon_sym_switch] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK] = ACTIONS(4174),
    [anon_sym_from] = ACTIONS(4172),
    [anon_sym_into] = ACTIONS(4172),
    [anon_sym_join] = ACTIONS(4172),
    [anon_sym_on] = ACTIONS(4172),
    [anon_sym_equals] = ACTIONS(4172),
    [anon_sym_let] = ACTIONS(4172),
    [anon_sym_orderby] = ACTIONS(4172),
    [anon_sym_group] = ACTIONS(4172),
    [anon_sym_by] = ACTIONS(4172),
    [anon_sym_select] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4172),
    [anon_sym_is] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [anon_sym_with] = ACTIONS(4172),
    [aux_sym_preproc_if_token3] = ACTIONS(4172),
    [aux_sym_preproc_else_token1] = ACTIONS(4172),
    [aux_sym_preproc_elif_token1] = ACTIONS(4172),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2440] = {
    [sym_preproc_region] = STATE(2440),
    [sym_preproc_endregion] = STATE(2440),
    [sym_preproc_line] = STATE(2440),
    [sym_preproc_pragma] = STATE(2440),
    [sym_preproc_nullable] = STATE(2440),
    [sym_preproc_error] = STATE(2440),
    [sym_preproc_warning] = STATE(2440),
    [sym_preproc_define] = STATE(2440),
    [sym_preproc_undef] = STATE(2440),
    [sym__identifier_token] = ACTIONS(4176),
    [anon_sym_alias] = ACTIONS(4176),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_global] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4176),
    [anon_sym_GT] = ACTIONS(4176),
    [anon_sym_in] = ACTIONS(4176),
    [anon_sym_where] = ACTIONS(4176),
    [anon_sym_QMARK] = ACTIONS(4176),
    [anon_sym_notnull] = ACTIONS(4176),
    [anon_sym_unmanaged] = ACTIONS(4176),
    [anon_sym_BANG] = ACTIONS(4176),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4176),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4176),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4176),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4176),
    [anon_sym_scoped] = ACTIONS(4176),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_var] = ACTIONS(4176),
    [anon_sym_yield] = ACTIONS(4176),
    [anon_sym_switch] = ACTIONS(4176),
    [anon_sym_when] = ACTIONS(4176),
    [sym_discard] = ACTIONS(4176),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4176),
    [anon_sym_or] = ACTIONS(4176),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_from] = ACTIONS(4176),
    [anon_sym_into] = ACTIONS(4176),
    [anon_sym_join] = ACTIONS(4176),
    [anon_sym_on] = ACTIONS(4176),
    [anon_sym_equals] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_orderby] = ACTIONS(4176),
    [anon_sym_ascending] = ACTIONS(4176),
    [anon_sym_descending] = ACTIONS(4176),
    [anon_sym_group] = ACTIONS(4176),
    [anon_sym_by] = ACTIONS(4176),
    [anon_sym_select] = ACTIONS(4176),
    [anon_sym_as] = ACTIONS(4176),
    [anon_sym_is] = ACTIONS(4176),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4176),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2441] = {
    [sym__name] = STATE(3220),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_ref_type] = STATE(3223),
    [sym__scoped_base_type] = STATE(3228),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(2441),
    [sym_preproc_endregion] = STATE(2441),
    [sym_preproc_line] = STATE(2441),
    [sym_preproc_pragma] = STATE(2441),
    [sym_preproc_nullable] = STATE(2441),
    [sym_preproc_error] = STATE(2441),
    [sym_preproc_warning] = STATE(2441),
    [sym_preproc_define] = STATE(2441),
    [sym_preproc_undef] = STATE(2441),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4180),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3795),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2442] = {
    [sym_preproc_region] = STATE(2442),
    [sym_preproc_endregion] = STATE(2442),
    [sym_preproc_line] = STATE(2442),
    [sym_preproc_pragma] = STATE(2442),
    [sym_preproc_nullable] = STATE(2442),
    [sym_preproc_error] = STATE(2442),
    [sym_preproc_warning] = STATE(2442),
    [sym_preproc_define] = STATE(2442),
    [sym_preproc_undef] = STATE(2442),
    [sym__identifier_token] = ACTIONS(4182),
    [anon_sym_alias] = ACTIONS(4182),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_global] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_file] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4182),
    [anon_sym_GT] = ACTIONS(4182),
    [anon_sym_in] = ACTIONS(4182),
    [anon_sym_where] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_notnull] = ACTIONS(4182),
    [anon_sym_unmanaged] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4184),
    [anon_sym_PIPE] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4184),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_GT_GT_GT] = ACTIONS(4184),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_GT_EQ] = ACTIONS(4184),
    [anon_sym_LT_EQ] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_scoped] = ACTIONS(4182),
    [anon_sym_EQ_GT] = ACTIONS(4184),
    [anon_sym_var] = ACTIONS(4182),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_switch] = ACTIONS(4182),
    [anon_sym_when] = ACTIONS(4182),
    [sym_discard] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(4184),
    [anon_sym_QMARK_QMARK] = ACTIONS(4184),
    [anon_sym_from] = ACTIONS(4182),
    [anon_sym_into] = ACTIONS(4182),
    [anon_sym_join] = ACTIONS(4182),
    [anon_sym_on] = ACTIONS(4182),
    [anon_sym_equals] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_orderby] = ACTIONS(4182),
    [anon_sym_ascending] = ACTIONS(4182),
    [anon_sym_descending] = ACTIONS(4182),
    [anon_sym_group] = ACTIONS(4182),
    [anon_sym_by] = ACTIONS(4182),
    [anon_sym_select] = ACTIONS(4182),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_is] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4184),
    [anon_sym_with] = ACTIONS(4182),
    [aux_sym_preproc_if_token3] = ACTIONS(4184),
    [aux_sym_preproc_else_token1] = ACTIONS(4184),
    [aux_sym_preproc_elif_token1] = ACTIONS(4184),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2443] = {
    [sym_preproc_region] = STATE(2443),
    [sym_preproc_endregion] = STATE(2443),
    [sym_preproc_line] = STATE(2443),
    [sym_preproc_pragma] = STATE(2443),
    [sym_preproc_nullable] = STATE(2443),
    [sym_preproc_error] = STATE(2443),
    [sym_preproc_warning] = STATE(2443),
    [sym_preproc_define] = STATE(2443),
    [sym_preproc_undef] = STATE(2443),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_in] = ACTIONS(4192),
    [anon_sym_where] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_EQ_GT] = ACTIONS(4186),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4192),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_from] = ACTIONS(4186),
    [anon_sym_into] = ACTIONS(4186),
    [anon_sym_join] = ACTIONS(4186),
    [anon_sym_on] = ACTIONS(4186),
    [anon_sym_equals] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_orderby] = ACTIONS(4186),
    [anon_sym_group] = ACTIONS(4186),
    [anon_sym_by] = ACTIONS(4186),
    [anon_sym_select] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_if_token3] = ACTIONS(4186),
    [aux_sym_preproc_else_token1] = ACTIONS(4186),
    [aux_sym_preproc_elif_token1] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2444] = {
    [sym__name] = STATE(3483),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_ref_type] = STATE(3271),
    [sym__scoped_base_type] = STATE(3273),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2444),
    [sym_preproc_endregion] = STATE(2444),
    [sym_preproc_line] = STATE(2444),
    [sym_preproc_pragma] = STATE(2444),
    [sym_preproc_nullable] = STATE(2444),
    [sym_preproc_error] = STATE(2444),
    [sym_preproc_warning] = STATE(2444),
    [sym_preproc_define] = STATE(2444),
    [sym_preproc_undef] = STATE(2444),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(4083),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2445] = {
    [sym_preproc_region] = STATE(2445),
    [sym_preproc_endregion] = STATE(2445),
    [sym_preproc_line] = STATE(2445),
    [sym_preproc_pragma] = STATE(2445),
    [sym_preproc_nullable] = STATE(2445),
    [sym_preproc_error] = STATE(2445),
    [sym_preproc_warning] = STATE(2445),
    [sym_preproc_define] = STATE(2445),
    [sym_preproc_undef] = STATE(2445),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2446] = {
    [sym_preproc_region] = STATE(2446),
    [sym_preproc_endregion] = STATE(2446),
    [sym_preproc_line] = STATE(2446),
    [sym_preproc_pragma] = STATE(2446),
    [sym_preproc_nullable] = STATE(2446),
    [sym_preproc_error] = STATE(2446),
    [sym_preproc_warning] = STATE(2446),
    [sym_preproc_define] = STATE(2446),
    [sym_preproc_undef] = STATE(2446),
    [sym__identifier_token] = ACTIONS(4198),
    [anon_sym_alias] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4200),
    [anon_sym_global] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4200),
    [anon_sym_COLON] = ACTIONS(4200),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_RBRACK] = ACTIONS(4200),
    [anon_sym_LPAREN] = ACTIONS(4200),
    [anon_sym_RPAREN] = ACTIONS(4200),
    [anon_sym_RBRACE] = ACTIONS(4200),
    [anon_sym_file] = ACTIONS(4198),
    [anon_sym_LT] = ACTIONS(4198),
    [anon_sym_GT] = ACTIONS(4198),
    [anon_sym_in] = ACTIONS(4198),
    [anon_sym_where] = ACTIONS(4198),
    [anon_sym_QMARK] = ACTIONS(4198),
    [anon_sym_notnull] = ACTIONS(4198),
    [anon_sym_unmanaged] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4200),
    [anon_sym_DASH_DASH] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(4198),
    [anon_sym_PERCENT] = ACTIONS(4200),
    [anon_sym_CARET] = ACTIONS(4200),
    [anon_sym_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4198),
    [anon_sym_LT_LT] = ACTIONS(4200),
    [anon_sym_GT_GT] = ACTIONS(4198),
    [anon_sym_GT_GT_GT] = ACTIONS(4200),
    [anon_sym_EQ_EQ] = ACTIONS(4200),
    [anon_sym_BANG_EQ] = ACTIONS(4200),
    [anon_sym_GT_EQ] = ACTIONS(4200),
    [anon_sym_LT_EQ] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4198),
    [anon_sym_scoped] = ACTIONS(4198),
    [anon_sym_EQ_GT] = ACTIONS(4200),
    [anon_sym_var] = ACTIONS(4198),
    [anon_sym_yield] = ACTIONS(4198),
    [anon_sym_switch] = ACTIONS(4198),
    [anon_sym_when] = ACTIONS(4198),
    [sym_discard] = ACTIONS(4198),
    [anon_sym_DOT_DOT] = ACTIONS(4200),
    [anon_sym_and] = ACTIONS(4198),
    [anon_sym_or] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4200),
    [anon_sym_PIPE_PIPE] = ACTIONS(4200),
    [anon_sym_QMARK_QMARK] = ACTIONS(4200),
    [anon_sym_from] = ACTIONS(4198),
    [anon_sym_into] = ACTIONS(4198),
    [anon_sym_join] = ACTIONS(4198),
    [anon_sym_on] = ACTIONS(4198),
    [anon_sym_equals] = ACTIONS(4198),
    [anon_sym_let] = ACTIONS(4198),
    [anon_sym_orderby] = ACTIONS(4198),
    [anon_sym_ascending] = ACTIONS(4198),
    [anon_sym_descending] = ACTIONS(4198),
    [anon_sym_group] = ACTIONS(4198),
    [anon_sym_by] = ACTIONS(4198),
    [anon_sym_select] = ACTIONS(4198),
    [anon_sym_as] = ACTIONS(4198),
    [anon_sym_is] = ACTIONS(4198),
    [anon_sym_DASH_GT] = ACTIONS(4200),
    [anon_sym_with] = ACTIONS(4198),
    [aux_sym_preproc_if_token3] = ACTIONS(4200),
    [aux_sym_preproc_else_token1] = ACTIONS(4200),
    [aux_sym_preproc_elif_token1] = ACTIONS(4200),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2447] = {
    [sym_preproc_region] = STATE(2447),
    [sym_preproc_endregion] = STATE(2447),
    [sym_preproc_line] = STATE(2447),
    [sym_preproc_pragma] = STATE(2447),
    [sym_preproc_nullable] = STATE(2447),
    [sym_preproc_error] = STATE(2447),
    [sym_preproc_warning] = STATE(2447),
    [sym_preproc_define] = STATE(2447),
    [sym_preproc_undef] = STATE(2447),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4202),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2448] = {
    [sym_preproc_region] = STATE(2448),
    [sym_preproc_endregion] = STATE(2448),
    [sym_preproc_line] = STATE(2448),
    [sym_preproc_pragma] = STATE(2448),
    [sym_preproc_nullable] = STATE(2448),
    [sym_preproc_error] = STATE(2448),
    [sym_preproc_warning] = STATE(2448),
    [sym_preproc_define] = STATE(2448),
    [sym_preproc_undef] = STATE(2448),
    [sym__identifier_token] = ACTIONS(4026),
    [anon_sym_alias] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_global] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_file] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_where] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_notnull] = ACTIONS(4026),
    [anon_sym_unmanaged] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4204),
    [anon_sym_scoped] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [anon_sym_switch] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(4026),
    [sym_discard] = ACTIONS(4026),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4026),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4026),
    [anon_sym_into] = ACTIONS(4026),
    [anon_sym_join] = ACTIONS(4026),
    [anon_sym_on] = ACTIONS(4026),
    [anon_sym_equals] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_orderby] = ACTIONS(4026),
    [anon_sym_ascending] = ACTIONS(4026),
    [anon_sym_descending] = ACTIONS(4026),
    [anon_sym_group] = ACTIONS(4026),
    [anon_sym_by] = ACTIONS(4026),
    [anon_sym_select] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4026),
    [anon_sym_is] = ACTIONS(4026),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4026),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2449] = {
    [sym_preproc_region] = STATE(2449),
    [sym_preproc_endregion] = STATE(2449),
    [sym_preproc_line] = STATE(2449),
    [sym_preproc_pragma] = STATE(2449),
    [sym_preproc_nullable] = STATE(2449),
    [sym_preproc_error] = STATE(2449),
    [sym_preproc_warning] = STATE(2449),
    [sym_preproc_define] = STATE(2449),
    [sym_preproc_undef] = STATE(2449),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2450] = {
    [sym_preproc_region] = STATE(2450),
    [sym_preproc_endregion] = STATE(2450),
    [sym_preproc_line] = STATE(2450),
    [sym_preproc_pragma] = STATE(2450),
    [sym_preproc_nullable] = STATE(2450),
    [sym_preproc_error] = STATE(2450),
    [sym_preproc_warning] = STATE(2450),
    [sym_preproc_define] = STATE(2450),
    [sym_preproc_undef] = STATE(2450),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4204),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2451] = {
    [sym__name] = STATE(3127),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_ref_type] = STATE(3016),
    [sym__scoped_base_type] = STATE(3025),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2451),
    [sym_preproc_endregion] = STATE(2451),
    [sym_preproc_line] = STATE(2451),
    [sym_preproc_pragma] = STATE(2451),
    [sym_preproc_nullable] = STATE(2451),
    [sym_preproc_error] = STATE(2451),
    [sym_preproc_warning] = STATE(2451),
    [sym_preproc_define] = STATE(2451),
    [sym_preproc_undef] = STATE(2451),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4208),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(4210),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(4210),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(4210),
    [anon_sym_orderby] = ACTIONS(4210),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(4210),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(4210),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2452] = {
    [sym_preproc_region] = STATE(2452),
    [sym_preproc_endregion] = STATE(2452),
    [sym_preproc_line] = STATE(2452),
    [sym_preproc_pragma] = STATE(2452),
    [sym_preproc_nullable] = STATE(2452),
    [sym_preproc_error] = STATE(2452),
    [sym_preproc_warning] = STATE(2452),
    [sym_preproc_define] = STATE(2452),
    [sym_preproc_undef] = STATE(2452),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_RBRACK] = ACTIONS(4213),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_RPAREN] = ACTIONS(4213),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_where] = ACTIONS(4213),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_BANG] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_GT_GT_GT] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_EQ_GT] = ACTIONS(4213),
    [anon_sym_switch] = ACTIONS(4213),
    [anon_sym_DOT_DOT] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(4213),
    [anon_sym_or] = ACTIONS(4215),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK] = ACTIONS(4215),
    [anon_sym_from] = ACTIONS(4213),
    [anon_sym_into] = ACTIONS(4213),
    [anon_sym_join] = ACTIONS(4213),
    [anon_sym_on] = ACTIONS(4213),
    [anon_sym_equals] = ACTIONS(4213),
    [anon_sym_let] = ACTIONS(4213),
    [anon_sym_orderby] = ACTIONS(4213),
    [anon_sym_group] = ACTIONS(4213),
    [anon_sym_by] = ACTIONS(4213),
    [anon_sym_select] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(4213),
    [anon_sym_is] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [anon_sym_with] = ACTIONS(4213),
    [aux_sym_preproc_if_token3] = ACTIONS(4213),
    [aux_sym_preproc_else_token1] = ACTIONS(4213),
    [aux_sym_preproc_elif_token1] = ACTIONS(4213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2453] = {
    [sym_preproc_region] = STATE(2453),
    [sym_preproc_endregion] = STATE(2453),
    [sym_preproc_line] = STATE(2453),
    [sym_preproc_pragma] = STATE(2453),
    [sym_preproc_nullable] = STATE(2453),
    [sym_preproc_error] = STATE(2453),
    [sym_preproc_warning] = STATE(2453),
    [sym_preproc_define] = STATE(2453),
    [sym_preproc_undef] = STATE(2453),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3666),
    [anon_sym_where] = ACTIONS(3668),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3666),
    [anon_sym_CARET] = ACTIONS(3666),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3666),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3666),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_PLUS_EQ] = ACTIONS(3668),
    [anon_sym_DASH_EQ] = ACTIONS(3668),
    [anon_sym_STAR_EQ] = ACTIONS(3668),
    [anon_sym_SLASH_EQ] = ACTIONS(3668),
    [anon_sym_PERCENT_EQ] = ACTIONS(3668),
    [anon_sym_AMP_EQ] = ACTIONS(3668),
    [anon_sym_CARET_EQ] = ACTIONS(3668),
    [anon_sym_PIPE_EQ] = ACTIONS(3668),
    [anon_sym_LT_LT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3666),
    [anon_sym_from] = ACTIONS(3668),
    [anon_sym_into] = ACTIONS(3668),
    [anon_sym_join] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_let] = ACTIONS(3668),
    [anon_sym_orderby] = ACTIONS(3668),
    [anon_sym_group] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_select] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2454] = {
    [sym_preproc_region] = STATE(2454),
    [sym_preproc_endregion] = STATE(2454),
    [sym_preproc_line] = STATE(2454),
    [sym_preproc_pragma] = STATE(2454),
    [sym_preproc_nullable] = STATE(2454),
    [sym_preproc_error] = STATE(2454),
    [sym_preproc_warning] = STATE(2454),
    [sym_preproc_define] = STATE(2454),
    [sym_preproc_undef] = STATE(2454),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3684),
    [anon_sym_where] = ACTIONS(3686),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_PLUS_EQ] = ACTIONS(3686),
    [anon_sym_DASH_EQ] = ACTIONS(3686),
    [anon_sym_STAR_EQ] = ACTIONS(3686),
    [anon_sym_SLASH_EQ] = ACTIONS(3686),
    [anon_sym_PERCENT_EQ] = ACTIONS(3686),
    [anon_sym_AMP_EQ] = ACTIONS(3686),
    [anon_sym_CARET_EQ] = ACTIONS(3686),
    [anon_sym_PIPE_EQ] = ACTIONS(3686),
    [anon_sym_LT_LT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3684),
    [anon_sym_from] = ACTIONS(3686),
    [anon_sym_into] = ACTIONS(3686),
    [anon_sym_join] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_let] = ACTIONS(3686),
    [anon_sym_orderby] = ACTIONS(3686),
    [anon_sym_group] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_select] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2455] = {
    [sym_preproc_region] = STATE(2455),
    [sym_preproc_endregion] = STATE(2455),
    [sym_preproc_line] = STATE(2455),
    [sym_preproc_pragma] = STATE(2455),
    [sym_preproc_nullable] = STATE(2455),
    [sym_preproc_error] = STATE(2455),
    [sym_preproc_warning] = STATE(2455),
    [sym_preproc_define] = STATE(2455),
    [sym_preproc_undef] = STATE(2455),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_where] = ACTIONS(3672),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3672),
    [anon_sym_DASH_EQ] = ACTIONS(3672),
    [anon_sym_STAR_EQ] = ACTIONS(3672),
    [anon_sym_SLASH_EQ] = ACTIONS(3672),
    [anon_sym_PERCENT_EQ] = ACTIONS(3672),
    [anon_sym_AMP_EQ] = ACTIONS(3672),
    [anon_sym_CARET_EQ] = ACTIONS(3672),
    [anon_sym_PIPE_EQ] = ACTIONS(3672),
    [anon_sym_LT_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3670),
    [anon_sym_from] = ACTIONS(3672),
    [anon_sym_into] = ACTIONS(3672),
    [anon_sym_join] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_let] = ACTIONS(3672),
    [anon_sym_orderby] = ACTIONS(3672),
    [anon_sym_group] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_select] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2456] = {
    [sym_preproc_region] = STATE(2456),
    [sym_preproc_endregion] = STATE(2456),
    [sym_preproc_line] = STATE(2456),
    [sym_preproc_pragma] = STATE(2456),
    [sym_preproc_nullable] = STATE(2456),
    [sym_preproc_error] = STATE(2456),
    [sym_preproc_warning] = STATE(2456),
    [sym_preproc_define] = STATE(2456),
    [sym_preproc_undef] = STATE(2456),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_PLUS_EQ] = ACTIONS(3676),
    [anon_sym_DASH_EQ] = ACTIONS(3676),
    [anon_sym_STAR_EQ] = ACTIONS(3676),
    [anon_sym_SLASH_EQ] = ACTIONS(3676),
    [anon_sym_PERCENT_EQ] = ACTIONS(3676),
    [anon_sym_AMP_EQ] = ACTIONS(3676),
    [anon_sym_CARET_EQ] = ACTIONS(3676),
    [anon_sym_PIPE_EQ] = ACTIONS(3676),
    [anon_sym_LT_LT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3674),
    [anon_sym_from] = ACTIONS(3676),
    [anon_sym_into] = ACTIONS(3676),
    [anon_sym_join] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_orderby] = ACTIONS(3676),
    [anon_sym_group] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_select] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2457] = {
    [sym_preproc_region] = STATE(2457),
    [sym_preproc_endregion] = STATE(2457),
    [sym_preproc_line] = STATE(2457),
    [sym_preproc_pragma] = STATE(2457),
    [sym_preproc_nullable] = STATE(2457),
    [sym_preproc_error] = STATE(2457),
    [sym_preproc_warning] = STATE(2457),
    [sym_preproc_define] = STATE(2457),
    [sym_preproc_undef] = STATE(2457),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3731),
    [anon_sym_into] = ACTIONS(3731),
    [anon_sym_join] = ACTIONS(3731),
    [anon_sym_on] = ACTIONS(3731),
    [anon_sym_equals] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_orderby] = ACTIONS(3731),
    [anon_sym_group] = ACTIONS(3731),
    [anon_sym_by] = ACTIONS(3731),
    [anon_sym_select] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_if_token3] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2458] = {
    [sym_preproc_region] = STATE(2458),
    [sym_preproc_endregion] = STATE(2458),
    [sym_preproc_line] = STATE(2458),
    [sym_preproc_pragma] = STATE(2458),
    [sym_preproc_nullable] = STATE(2458),
    [sym_preproc_error] = STATE(2458),
    [sym_preproc_warning] = STATE(2458),
    [sym_preproc_define] = STATE(2458),
    [sym_preproc_undef] = STATE(2458),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_RBRACK] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_in] = ACTIONS(4188),
    [anon_sym_where] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_GT_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_EQ_GT] = ACTIONS(4190),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4188),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK] = ACTIONS(4188),
    [anon_sym_from] = ACTIONS(4190),
    [anon_sym_into] = ACTIONS(4190),
    [anon_sym_join] = ACTIONS(4190),
    [anon_sym_on] = ACTIONS(4190),
    [anon_sym_equals] = ACTIONS(4190),
    [anon_sym_let] = ACTIONS(4190),
    [anon_sym_orderby] = ACTIONS(4190),
    [anon_sym_group] = ACTIONS(4190),
    [anon_sym_by] = ACTIONS(4190),
    [anon_sym_select] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_if_token3] = ACTIONS(4190),
    [aux_sym_preproc_else_token1] = ACTIONS(4190),
    [aux_sym_preproc_elif_token1] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2459] = {
    [sym__name] = STATE(3483),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_ref_type] = STATE(3271),
    [sym__scoped_base_type] = STATE(3273),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2459),
    [sym_preproc_endregion] = STATE(2459),
    [sym_preproc_line] = STATE(2459),
    [sym_preproc_pragma] = STATE(2459),
    [sym_preproc_nullable] = STATE(2459),
    [sym_preproc_error] = STATE(2459),
    [sym_preproc_warning] = STATE(2459),
    [sym_preproc_define] = STATE(2459),
    [sym_preproc_undef] = STATE(2459),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4217),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(4083),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2460] = {
    [sym_preproc_region] = STATE(2460),
    [sym_preproc_endregion] = STATE(2460),
    [sym_preproc_line] = STATE(2460),
    [sym_preproc_pragma] = STATE(2460),
    [sym_preproc_nullable] = STATE(2460),
    [sym_preproc_error] = STATE(2460),
    [sym_preproc_warning] = STATE(2460),
    [sym_preproc_define] = STATE(2460),
    [sym_preproc_undef] = STATE(2460),
    [sym__identifier_token] = ACTIONS(4219),
    [anon_sym_alias] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_global] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4221),
    [anon_sym_COLON] = ACTIONS(4221),
    [anon_sym_COMMA] = ACTIONS(4221),
    [anon_sym_RBRACK] = ACTIONS(4221),
    [anon_sym_LPAREN] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4221),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_file] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4219),
    [anon_sym_GT] = ACTIONS(4219),
    [anon_sym_in] = ACTIONS(4219),
    [anon_sym_where] = ACTIONS(4219),
    [anon_sym_QMARK] = ACTIONS(4219),
    [anon_sym_notnull] = ACTIONS(4219),
    [anon_sym_unmanaged] = ACTIONS(4219),
    [anon_sym_BANG] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4221),
    [anon_sym_DASH_DASH] = ACTIONS(4221),
    [anon_sym_PLUS] = ACTIONS(4219),
    [anon_sym_DASH] = ACTIONS(4219),
    [anon_sym_STAR] = ACTIONS(4221),
    [anon_sym_SLASH] = ACTIONS(4219),
    [anon_sym_PERCENT] = ACTIONS(4221),
    [anon_sym_CARET] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_GT_GT_GT] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4221),
    [anon_sym_GT_EQ] = ACTIONS(4221),
    [anon_sym_LT_EQ] = ACTIONS(4221),
    [anon_sym_DOT] = ACTIONS(4219),
    [anon_sym_scoped] = ACTIONS(4219),
    [anon_sym_EQ_GT] = ACTIONS(4221),
    [anon_sym_var] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(4219),
    [anon_sym_switch] = ACTIONS(4219),
    [anon_sym_when] = ACTIONS(4219),
    [sym_discard] = ACTIONS(4219),
    [anon_sym_DOT_DOT] = ACTIONS(4221),
    [anon_sym_and] = ACTIONS(4219),
    [anon_sym_or] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4221),
    [anon_sym_PIPE_PIPE] = ACTIONS(4221),
    [anon_sym_QMARK_QMARK] = ACTIONS(4221),
    [anon_sym_from] = ACTIONS(4219),
    [anon_sym_into] = ACTIONS(4219),
    [anon_sym_join] = ACTIONS(4219),
    [anon_sym_on] = ACTIONS(4219),
    [anon_sym_equals] = ACTIONS(4219),
    [anon_sym_let] = ACTIONS(4219),
    [anon_sym_orderby] = ACTIONS(4219),
    [anon_sym_ascending] = ACTIONS(4219),
    [anon_sym_descending] = ACTIONS(4219),
    [anon_sym_group] = ACTIONS(4219),
    [anon_sym_by] = ACTIONS(4219),
    [anon_sym_select] = ACTIONS(4219),
    [anon_sym_as] = ACTIONS(4219),
    [anon_sym_is] = ACTIONS(4219),
    [anon_sym_DASH_GT] = ACTIONS(4221),
    [anon_sym_with] = ACTIONS(4219),
    [aux_sym_preproc_if_token3] = ACTIONS(4221),
    [aux_sym_preproc_else_token1] = ACTIONS(4221),
    [aux_sym_preproc_elif_token1] = ACTIONS(4221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2461] = {
    [sym_preproc_region] = STATE(2461),
    [sym_preproc_endregion] = STATE(2461),
    [sym_preproc_line] = STATE(2461),
    [sym_preproc_pragma] = STATE(2461),
    [sym_preproc_nullable] = STATE(2461),
    [sym_preproc_error] = STATE(2461),
    [sym_preproc_warning] = STATE(2461),
    [sym_preproc_define] = STATE(2461),
    [sym_preproc_undef] = STATE(2461),
    [sym__identifier_token] = ACTIONS(4219),
    [anon_sym_alias] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_global] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4221),
    [anon_sym_COLON] = ACTIONS(4221),
    [anon_sym_COMMA] = ACTIONS(4221),
    [anon_sym_RBRACK] = ACTIONS(4221),
    [anon_sym_LPAREN] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4221),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_file] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4219),
    [anon_sym_GT] = ACTIONS(4219),
    [anon_sym_in] = ACTIONS(4219),
    [anon_sym_where] = ACTIONS(4219),
    [anon_sym_QMARK] = ACTIONS(4219),
    [anon_sym_notnull] = ACTIONS(4219),
    [anon_sym_unmanaged] = ACTIONS(4219),
    [anon_sym_BANG] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4221),
    [anon_sym_DASH_DASH] = ACTIONS(4221),
    [anon_sym_PLUS] = ACTIONS(4219),
    [anon_sym_DASH] = ACTIONS(4219),
    [anon_sym_STAR] = ACTIONS(4221),
    [anon_sym_SLASH] = ACTIONS(4219),
    [anon_sym_PERCENT] = ACTIONS(4221),
    [anon_sym_CARET] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_GT_GT_GT] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4221),
    [anon_sym_GT_EQ] = ACTIONS(4221),
    [anon_sym_LT_EQ] = ACTIONS(4221),
    [anon_sym_DOT] = ACTIONS(4219),
    [anon_sym_scoped] = ACTIONS(4219),
    [anon_sym_EQ_GT] = ACTIONS(4221),
    [anon_sym_var] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(4219),
    [anon_sym_switch] = ACTIONS(4219),
    [anon_sym_when] = ACTIONS(4219),
    [sym_discard] = ACTIONS(4219),
    [anon_sym_DOT_DOT] = ACTIONS(4221),
    [anon_sym_and] = ACTIONS(4219),
    [anon_sym_or] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4221),
    [anon_sym_PIPE_PIPE] = ACTIONS(4221),
    [anon_sym_QMARK_QMARK] = ACTIONS(4221),
    [anon_sym_from] = ACTIONS(4219),
    [anon_sym_into] = ACTIONS(4219),
    [anon_sym_join] = ACTIONS(4219),
    [anon_sym_on] = ACTIONS(4219),
    [anon_sym_equals] = ACTIONS(4219),
    [anon_sym_let] = ACTIONS(4219),
    [anon_sym_orderby] = ACTIONS(4219),
    [anon_sym_ascending] = ACTIONS(4219),
    [anon_sym_descending] = ACTIONS(4219),
    [anon_sym_group] = ACTIONS(4219),
    [anon_sym_by] = ACTIONS(4219),
    [anon_sym_select] = ACTIONS(4219),
    [anon_sym_as] = ACTIONS(4219),
    [anon_sym_is] = ACTIONS(4219),
    [anon_sym_DASH_GT] = ACTIONS(4221),
    [anon_sym_with] = ACTIONS(4219),
    [aux_sym_preproc_if_token3] = ACTIONS(4221),
    [aux_sym_preproc_else_token1] = ACTIONS(4221),
    [aux_sym_preproc_elif_token1] = ACTIONS(4221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2462] = {
    [sym__name] = STATE(3483),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_ref_type] = STATE(3271),
    [sym__scoped_base_type] = STATE(3273),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2462),
    [sym_preproc_endregion] = STATE(2462),
    [sym_preproc_line] = STATE(2462),
    [sym_preproc_pragma] = STATE(2462),
    [sym_preproc_nullable] = STATE(2462),
    [sym_preproc_error] = STATE(2462),
    [sym_preproc_warning] = STATE(2462),
    [sym_preproc_define] = STATE(2462),
    [sym_preproc_undef] = STATE(2462),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4223),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(4083),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2463] = {
    [sym_preproc_region] = STATE(2463),
    [sym_preproc_endregion] = STATE(2463),
    [sym_preproc_line] = STATE(2463),
    [sym_preproc_pragma] = STATE(2463),
    [sym_preproc_nullable] = STATE(2463),
    [sym_preproc_error] = STATE(2463),
    [sym_preproc_warning] = STATE(2463),
    [sym_preproc_define] = STATE(2463),
    [sym_preproc_undef] = STATE(2463),
    [anon_sym_SEMI] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4225),
    [anon_sym_RBRACK] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4225),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_in] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_PLUS_PLUS] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_EQ_GT] = ACTIONS(4225),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_or] = ACTIONS(4227),
    [anon_sym_PLUS_EQ] = ACTIONS(4225),
    [anon_sym_DASH_EQ] = ACTIONS(4225),
    [anon_sym_STAR_EQ] = ACTIONS(4225),
    [anon_sym_SLASH_EQ] = ACTIONS(4225),
    [anon_sym_PERCENT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4225),
    [anon_sym_CARET_EQ] = ACTIONS(4225),
    [anon_sym_PIPE_EQ] = ACTIONS(4225),
    [anon_sym_LT_LT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4225),
    [anon_sym_AMP_AMP] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4225),
    [anon_sym_into] = ACTIONS(4225),
    [anon_sym_join] = ACTIONS(4225),
    [anon_sym_on] = ACTIONS(4225),
    [anon_sym_equals] = ACTIONS(4225),
    [anon_sym_let] = ACTIONS(4225),
    [anon_sym_orderby] = ACTIONS(4225),
    [anon_sym_group] = ACTIONS(4225),
    [anon_sym_by] = ACTIONS(4225),
    [anon_sym_select] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4225),
    [anon_sym_is] = ACTIONS(4225),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_with] = ACTIONS(4225),
    [aux_sym_preproc_if_token3] = ACTIONS(4225),
    [aux_sym_preproc_else_token1] = ACTIONS(4225),
    [aux_sym_preproc_elif_token1] = ACTIONS(4225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2464] = {
    [sym_preproc_region] = STATE(2464),
    [sym_preproc_endregion] = STATE(2464),
    [sym_preproc_line] = STATE(2464),
    [sym_preproc_pragma] = STATE(2464),
    [sym_preproc_nullable] = STATE(2464),
    [sym_preproc_error] = STATE(2464),
    [sym_preproc_warning] = STATE(2464),
    [sym_preproc_define] = STATE(2464),
    [sym_preproc_undef] = STATE(2464),
    [sym__identifier_token] = ACTIONS(4182),
    [anon_sym_alias] = ACTIONS(4182),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_global] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_file] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4182),
    [anon_sym_GT] = ACTIONS(4182),
    [anon_sym_in] = ACTIONS(4182),
    [anon_sym_where] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_notnull] = ACTIONS(4182),
    [anon_sym_unmanaged] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4184),
    [anon_sym_PIPE] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4184),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_GT_GT_GT] = ACTIONS(4184),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_GT_EQ] = ACTIONS(4184),
    [anon_sym_LT_EQ] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_scoped] = ACTIONS(4182),
    [anon_sym_EQ_GT] = ACTIONS(4184),
    [anon_sym_var] = ACTIONS(4182),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_switch] = ACTIONS(4182),
    [anon_sym_when] = ACTIONS(4182),
    [sym_discard] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(4184),
    [anon_sym_QMARK_QMARK] = ACTIONS(4184),
    [anon_sym_from] = ACTIONS(4182),
    [anon_sym_into] = ACTIONS(4182),
    [anon_sym_join] = ACTIONS(4182),
    [anon_sym_on] = ACTIONS(4182),
    [anon_sym_equals] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_orderby] = ACTIONS(4182),
    [anon_sym_ascending] = ACTIONS(4182),
    [anon_sym_descending] = ACTIONS(4182),
    [anon_sym_group] = ACTIONS(4182),
    [anon_sym_by] = ACTIONS(4182),
    [anon_sym_select] = ACTIONS(4182),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_is] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4184),
    [anon_sym_with] = ACTIONS(4182),
    [aux_sym_preproc_if_token3] = ACTIONS(4184),
    [aux_sym_preproc_else_token1] = ACTIONS(4184),
    [aux_sym_preproc_elif_token1] = ACTIONS(4184),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2465] = {
    [sym_preproc_region] = STATE(2465),
    [sym_preproc_endregion] = STATE(2465),
    [sym_preproc_line] = STATE(2465),
    [sym_preproc_pragma] = STATE(2465),
    [sym_preproc_nullable] = STATE(2465),
    [sym_preproc_error] = STATE(2465),
    [sym_preproc_warning] = STATE(2465),
    [sym_preproc_define] = STATE(2465),
    [sym_preproc_undef] = STATE(2465),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3709),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3709),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_join] = ACTIONS(3709),
    [anon_sym_on] = ACTIONS(3709),
    [anon_sym_equals] = ACTIONS(3709),
    [anon_sym_let] = ACTIONS(3709),
    [anon_sym_orderby] = ACTIONS(3709),
    [anon_sym_group] = ACTIONS(3709),
    [anon_sym_by] = ACTIONS(3709),
    [anon_sym_select] = ACTIONS(3709),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_is] = ACTIONS(3709),
    [anon_sym_DASH_GT] = ACTIONS(3709),
    [anon_sym_with] = ACTIONS(3709),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2466] = {
    [sym__name] = STATE(3220),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_ref_type] = STATE(3223),
    [sym__scoped_base_type] = STATE(3228),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(2466),
    [sym_preproc_endregion] = STATE(2466),
    [sym_preproc_line] = STATE(2466),
    [sym_preproc_pragma] = STATE(2466),
    [sym_preproc_nullable] = STATE(2466),
    [sym_preproc_error] = STATE(2466),
    [sym_preproc_warning] = STATE(2466),
    [sym_preproc_define] = STATE(2466),
    [sym_preproc_undef] = STATE(2466),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4229),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2467] = {
    [sym_preproc_region] = STATE(2467),
    [sym_preproc_endregion] = STATE(2467),
    [sym_preproc_line] = STATE(2467),
    [sym_preproc_pragma] = STATE(2467),
    [sym_preproc_nullable] = STATE(2467),
    [sym_preproc_error] = STATE(2467),
    [sym_preproc_warning] = STATE(2467),
    [sym_preproc_define] = STATE(2467),
    [sym_preproc_undef] = STATE(2467),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_join] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_orderby] = ACTIONS(3459),
    [anon_sym_group] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_select] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2468] = {
    [sym__name] = STATE(4108),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_ref_type] = STATE(2994),
    [sym__scoped_base_type] = STATE(2965),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2468),
    [sym_preproc_endregion] = STATE(2468),
    [sym_preproc_line] = STATE(2468),
    [sym_preproc_pragma] = STATE(2468),
    [sym_preproc_nullable] = STATE(2468),
    [sym_preproc_error] = STATE(2468),
    [sym_preproc_warning] = STATE(2468),
    [sym_preproc_define] = STATE(2468),
    [sym_preproc_undef] = STATE(2468),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3875),
    [anon_sym_into] = ACTIONS(3875),
    [anon_sym_join] = ACTIONS(3875),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_orderby] = ACTIONS(3875),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3875),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3875),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2469] = {
    [sym_preproc_region] = STATE(2469),
    [sym_preproc_endregion] = STATE(2469),
    [sym_preproc_line] = STATE(2469),
    [sym_preproc_pragma] = STATE(2469),
    [sym_preproc_nullable] = STATE(2469),
    [sym_preproc_error] = STATE(2469),
    [sym_preproc_warning] = STATE(2469),
    [sym_preproc_define] = STATE(2469),
    [sym_preproc_undef] = STATE(2469),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_EQ] = ACTIONS(4235),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_COLON] = ACTIONS(4233),
    [anon_sym_COMMA] = ACTIONS(4233),
    [anon_sym_RBRACK] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4233),
    [anon_sym_RPAREN] = ACTIONS(4233),
    [anon_sym_RBRACE] = ACTIONS(4233),
    [anon_sym_LT] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4235),
    [anon_sym_in] = ACTIONS(4235),
    [anon_sym_where] = ACTIONS(4233),
    [anon_sym_QMARK] = ACTIONS(4235),
    [anon_sym_BANG] = ACTIONS(4235),
    [anon_sym_PLUS_PLUS] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4235),
    [anon_sym_DASH] = ACTIONS(4235),
    [anon_sym_STAR] = ACTIONS(4235),
    [anon_sym_SLASH] = ACTIONS(4235),
    [anon_sym_PERCENT] = ACTIONS(4235),
    [anon_sym_CARET] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4235),
    [anon_sym_LT_LT] = ACTIONS(4235),
    [anon_sym_GT_GT] = ACTIONS(4235),
    [anon_sym_GT_GT_GT] = ACTIONS(4235),
    [anon_sym_EQ_EQ] = ACTIONS(4233),
    [anon_sym_BANG_EQ] = ACTIONS(4233),
    [anon_sym_GT_EQ] = ACTIONS(4233),
    [anon_sym_LT_EQ] = ACTIONS(4233),
    [anon_sym_DOT] = ACTIONS(4235),
    [anon_sym_EQ_GT] = ACTIONS(4233),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_DOT_DOT] = ACTIONS(4233),
    [anon_sym_and] = ACTIONS(4233),
    [anon_sym_or] = ACTIONS(4235),
    [anon_sym_PLUS_EQ] = ACTIONS(4233),
    [anon_sym_DASH_EQ] = ACTIONS(4233),
    [anon_sym_STAR_EQ] = ACTIONS(4233),
    [anon_sym_SLASH_EQ] = ACTIONS(4233),
    [anon_sym_PERCENT_EQ] = ACTIONS(4233),
    [anon_sym_AMP_EQ] = ACTIONS(4233),
    [anon_sym_CARET_EQ] = ACTIONS(4233),
    [anon_sym_PIPE_EQ] = ACTIONS(4233),
    [anon_sym_LT_LT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4233),
    [anon_sym_AMP_AMP] = ACTIONS(4233),
    [anon_sym_PIPE_PIPE] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK] = ACTIONS(4235),
    [anon_sym_from] = ACTIONS(4233),
    [anon_sym_into] = ACTIONS(4233),
    [anon_sym_join] = ACTIONS(4233),
    [anon_sym_on] = ACTIONS(4233),
    [anon_sym_equals] = ACTIONS(4233),
    [anon_sym_let] = ACTIONS(4233),
    [anon_sym_orderby] = ACTIONS(4233),
    [anon_sym_group] = ACTIONS(4233),
    [anon_sym_by] = ACTIONS(4233),
    [anon_sym_select] = ACTIONS(4233),
    [anon_sym_as] = ACTIONS(4233),
    [anon_sym_is] = ACTIONS(4233),
    [anon_sym_DASH_GT] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [aux_sym_preproc_if_token3] = ACTIONS(4233),
    [aux_sym_preproc_else_token1] = ACTIONS(4233),
    [aux_sym_preproc_elif_token1] = ACTIONS(4233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2470] = {
    [sym__name] = STATE(3220),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_ref_type] = STATE(3223),
    [sym__scoped_base_type] = STATE(3228),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(2470),
    [sym_preproc_endregion] = STATE(2470),
    [sym_preproc_line] = STATE(2470),
    [sym_preproc_pragma] = STATE(2470),
    [sym_preproc_nullable] = STATE(2470),
    [sym_preproc_error] = STATE(2470),
    [sym_preproc_warning] = STATE(2470),
    [sym_preproc_define] = STATE(2470),
    [sym_preproc_undef] = STATE(2470),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4237),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3795),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2471] = {
    [sym_preproc_region] = STATE(2471),
    [sym_preproc_endregion] = STATE(2471),
    [sym_preproc_line] = STATE(2471),
    [sym_preproc_pragma] = STATE(2471),
    [sym_preproc_nullable] = STATE(2471),
    [sym_preproc_error] = STATE(2471),
    [sym_preproc_warning] = STATE(2471),
    [sym_preproc_define] = STATE(2471),
    [sym_preproc_undef] = STATE(2471),
    [anon_sym_SEMI] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_in] = ACTIONS(4241),
    [anon_sym_where] = ACTIONS(4239),
    [anon_sym_QMARK] = ACTIONS(4241),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4241),
    [anon_sym_SLASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_CARET] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(4241),
    [anon_sym_GT_GT_GT] = ACTIONS(4241),
    [anon_sym_EQ_EQ] = ACTIONS(4239),
    [anon_sym_BANG_EQ] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4241),
    [anon_sym_EQ_GT] = ACTIONS(4239),
    [anon_sym_switch] = ACTIONS(4239),
    [anon_sym_DOT_DOT] = ACTIONS(4239),
    [anon_sym_and] = ACTIONS(4239),
    [anon_sym_or] = ACTIONS(4241),
    [anon_sym_PLUS_EQ] = ACTIONS(4239),
    [anon_sym_DASH_EQ] = ACTIONS(4239),
    [anon_sym_STAR_EQ] = ACTIONS(4239),
    [anon_sym_SLASH_EQ] = ACTIONS(4239),
    [anon_sym_PERCENT_EQ] = ACTIONS(4239),
    [anon_sym_AMP_EQ] = ACTIONS(4239),
    [anon_sym_CARET_EQ] = ACTIONS(4239),
    [anon_sym_PIPE_EQ] = ACTIONS(4239),
    [anon_sym_LT_LT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK] = ACTIONS(4241),
    [anon_sym_from] = ACTIONS(4239),
    [anon_sym_into] = ACTIONS(4239),
    [anon_sym_join] = ACTIONS(4239),
    [anon_sym_on] = ACTIONS(4239),
    [anon_sym_equals] = ACTIONS(4239),
    [anon_sym_let] = ACTIONS(4239),
    [anon_sym_orderby] = ACTIONS(4239),
    [anon_sym_group] = ACTIONS(4239),
    [anon_sym_by] = ACTIONS(4239),
    [anon_sym_select] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_is] = ACTIONS(4239),
    [anon_sym_DASH_GT] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4239),
    [aux_sym_preproc_if_token3] = ACTIONS(4239),
    [aux_sym_preproc_else_token1] = ACTIONS(4239),
    [aux_sym_preproc_elif_token1] = ACTIONS(4239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2472] = {
    [sym_preproc_region] = STATE(2472),
    [sym_preproc_endregion] = STATE(2472),
    [sym_preproc_line] = STATE(2472),
    [sym_preproc_pragma] = STATE(2472),
    [sym_preproc_nullable] = STATE(2472),
    [sym_preproc_error] = STATE(2472),
    [sym_preproc_warning] = STATE(2472),
    [sym_preproc_define] = STATE(2472),
    [sym_preproc_undef] = STATE(2472),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2473] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2573),
    [sym_property_pattern_clause] = STATE(2668),
    [sym__variable_designation] = STATE(3817),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3729),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2473),
    [sym_preproc_endregion] = STATE(2473),
    [sym_preproc_line] = STATE(2473),
    [sym_preproc_pragma] = STATE(2473),
    [sym_preproc_nullable] = STATE(2473),
    [sym_preproc_error] = STATE(2473),
    [sym_preproc_warning] = STATE(2473),
    [sym_preproc_define] = STATE(2473),
    [sym_preproc_undef] = STATE(2473),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3905),
    [anon_sym_descending] = ACTIONS(3905),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2474] = {
    [sym_preproc_region] = STATE(2474),
    [sym_preproc_endregion] = STATE(2474),
    [sym_preproc_line] = STATE(2474),
    [sym_preproc_pragma] = STATE(2474),
    [sym_preproc_nullable] = STATE(2474),
    [sym_preproc_error] = STATE(2474),
    [sym_preproc_warning] = STATE(2474),
    [sym_preproc_define] = STATE(2474),
    [sym_preproc_undef] = STATE(2474),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_in] = ACTIONS(4186),
    [anon_sym_where] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_EQ_GT] = ACTIONS(4186),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4192),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_from] = ACTIONS(4186),
    [anon_sym_join] = ACTIONS(4186),
    [anon_sym_on] = ACTIONS(4186),
    [anon_sym_equals] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_orderby] = ACTIONS(4186),
    [anon_sym_group] = ACTIONS(4186),
    [anon_sym_by] = ACTIONS(4186),
    [anon_sym_select] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_if_token3] = ACTIONS(4186),
    [aux_sym_preproc_else_token1] = ACTIONS(4186),
    [aux_sym_preproc_elif_token1] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2475] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2582),
    [sym_property_pattern_clause] = STATE(2675),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2475),
    [sym_preproc_endregion] = STATE(2475),
    [sym_preproc_line] = STATE(2475),
    [sym_preproc_pragma] = STATE(2475),
    [sym_preproc_nullable] = STATE(2475),
    [sym_preproc_error] = STATE(2475),
    [sym_preproc_warning] = STATE(2475),
    [sym_preproc_define] = STATE(2475),
    [sym_preproc_undef] = STATE(2475),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2476] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2573),
    [sym_property_pattern_clause] = STATE(2668),
    [sym__variable_designation] = STATE(3817),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3729),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2476),
    [sym_preproc_endregion] = STATE(2476),
    [sym_preproc_line] = STATE(2476),
    [sym_preproc_pragma] = STATE(2476),
    [sym_preproc_nullable] = STATE(2476),
    [sym_preproc_error] = STATE(2476),
    [sym_preproc_warning] = STATE(2476),
    [sym_preproc_define] = STATE(2476),
    [sym_preproc_undef] = STATE(2476),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3905),
    [anon_sym_descending] = ACTIONS(3905),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2477] = {
    [sym_preproc_region] = STATE(2477),
    [sym_preproc_endregion] = STATE(2477),
    [sym_preproc_line] = STATE(2477),
    [sym_preproc_pragma] = STATE(2477),
    [sym_preproc_nullable] = STATE(2477),
    [sym_preproc_error] = STATE(2477),
    [sym_preproc_warning] = STATE(2477),
    [sym_preproc_define] = STATE(2477),
    [sym_preproc_undef] = STATE(2477),
    [anon_sym_SEMI] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_in] = ACTIONS(4239),
    [anon_sym_where] = ACTIONS(4239),
    [anon_sym_QMARK] = ACTIONS(4241),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4241),
    [anon_sym_SLASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_CARET] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(4241),
    [anon_sym_GT_GT_GT] = ACTIONS(4241),
    [anon_sym_EQ_EQ] = ACTIONS(4239),
    [anon_sym_BANG_EQ] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4241),
    [anon_sym_EQ_GT] = ACTIONS(4239),
    [anon_sym_switch] = ACTIONS(4239),
    [anon_sym_DOT_DOT] = ACTIONS(4239),
    [anon_sym_and] = ACTIONS(4239),
    [anon_sym_or] = ACTIONS(4241),
    [anon_sym_PLUS_EQ] = ACTIONS(4239),
    [anon_sym_DASH_EQ] = ACTIONS(4239),
    [anon_sym_STAR_EQ] = ACTIONS(4239),
    [anon_sym_SLASH_EQ] = ACTIONS(4239),
    [anon_sym_PERCENT_EQ] = ACTIONS(4239),
    [anon_sym_AMP_EQ] = ACTIONS(4239),
    [anon_sym_CARET_EQ] = ACTIONS(4239),
    [anon_sym_PIPE_EQ] = ACTIONS(4239),
    [anon_sym_LT_LT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK] = ACTIONS(4241),
    [anon_sym_from] = ACTIONS(4239),
    [anon_sym_join] = ACTIONS(4239),
    [anon_sym_on] = ACTIONS(4239),
    [anon_sym_equals] = ACTIONS(4239),
    [anon_sym_let] = ACTIONS(4239),
    [anon_sym_orderby] = ACTIONS(4239),
    [anon_sym_group] = ACTIONS(4239),
    [anon_sym_by] = ACTIONS(4239),
    [anon_sym_select] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_is] = ACTIONS(4239),
    [anon_sym_DASH_GT] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4239),
    [aux_sym_preproc_if_token3] = ACTIONS(4239),
    [aux_sym_preproc_else_token1] = ACTIONS(4239),
    [aux_sym_preproc_elif_token1] = ACTIONS(4239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2478] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2560),
    [sym_property_pattern_clause] = STATE(2611),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2478),
    [sym_preproc_endregion] = STATE(2478),
    [sym_preproc_line] = STATE(2478),
    [sym_preproc_pragma] = STATE(2478),
    [sym_preproc_nullable] = STATE(2478),
    [sym_preproc_error] = STATE(2478),
    [sym_preproc_warning] = STATE(2478),
    [sym_preproc_define] = STATE(2478),
    [sym_preproc_undef] = STATE(2478),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3905),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2479] = {
    [sym_preproc_region] = STATE(2479),
    [sym_preproc_endregion] = STATE(2479),
    [sym_preproc_line] = STATE(2479),
    [sym_preproc_pragma] = STATE(2479),
    [sym_preproc_nullable] = STATE(2479),
    [sym_preproc_error] = STATE(2479),
    [sym_preproc_warning] = STATE(2479),
    [sym_preproc_define] = STATE(2479),
    [sym_preproc_undef] = STATE(2479),
    [anon_sym_SEMI] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4225),
    [anon_sym_RBRACK] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4225),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_in] = ACTIONS(4225),
    [anon_sym_where] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_PLUS_PLUS] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_EQ_GT] = ACTIONS(4225),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_or] = ACTIONS(4227),
    [anon_sym_PLUS_EQ] = ACTIONS(4225),
    [anon_sym_DASH_EQ] = ACTIONS(4225),
    [anon_sym_STAR_EQ] = ACTIONS(4225),
    [anon_sym_SLASH_EQ] = ACTIONS(4225),
    [anon_sym_PERCENT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4225),
    [anon_sym_CARET_EQ] = ACTIONS(4225),
    [anon_sym_PIPE_EQ] = ACTIONS(4225),
    [anon_sym_LT_LT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4225),
    [anon_sym_AMP_AMP] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4225),
    [anon_sym_join] = ACTIONS(4225),
    [anon_sym_on] = ACTIONS(4225),
    [anon_sym_equals] = ACTIONS(4225),
    [anon_sym_let] = ACTIONS(4225),
    [anon_sym_orderby] = ACTIONS(4225),
    [anon_sym_group] = ACTIONS(4225),
    [anon_sym_by] = ACTIONS(4225),
    [anon_sym_select] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4225),
    [anon_sym_is] = ACTIONS(4225),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_with] = ACTIONS(4225),
    [aux_sym_preproc_if_token3] = ACTIONS(4225),
    [aux_sym_preproc_else_token1] = ACTIONS(4225),
    [aux_sym_preproc_elif_token1] = ACTIONS(4225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2480] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2575),
    [sym_property_pattern_clause] = STATE(2679),
    [sym__variable_designation] = STATE(3817),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3729),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2480),
    [sym_preproc_endregion] = STATE(2480),
    [sym_preproc_line] = STATE(2480),
    [sym_preproc_pragma] = STATE(2480),
    [sym_preproc_nullable] = STATE(2480),
    [sym_preproc_error] = STATE(2480),
    [sym_preproc_warning] = STATE(2480),
    [sym_preproc_define] = STATE(2480),
    [sym_preproc_undef] = STATE(2480),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3905),
    [anon_sym_descending] = ACTIONS(3905),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2481] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2573),
    [sym_property_pattern_clause] = STATE(2668),
    [sym__variable_designation] = STATE(3817),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3729),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2481),
    [sym_preproc_endregion] = STATE(2481),
    [sym_preproc_line] = STATE(2481),
    [sym_preproc_pragma] = STATE(2481),
    [sym_preproc_nullable] = STATE(2481),
    [sym_preproc_error] = STATE(2481),
    [sym_preproc_warning] = STATE(2481),
    [sym_preproc_define] = STATE(2481),
    [sym_preproc_undef] = STATE(2481),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3909),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3909),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_orderby] = ACTIONS(3909),
    [anon_sym_ascending] = ACTIONS(3909),
    [anon_sym_descending] = ACTIONS(3909),
    [anon_sym_group] = ACTIONS(3909),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2482] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2302),
    [sym_property_pattern_clause] = STATE(2367),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2482),
    [sym_preproc_endregion] = STATE(2482),
    [sym_preproc_line] = STATE(2482),
    [sym_preproc_pragma] = STATE(2482),
    [sym_preproc_nullable] = STATE(2482),
    [sym_preproc_error] = STATE(2482),
    [sym_preproc_warning] = STATE(2482),
    [sym_preproc_define] = STATE(2482),
    [sym_preproc_undef] = STATE(2482),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2483] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2543),
    [sym_property_pattern_clause] = STATE(2606),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2483),
    [sym_preproc_endregion] = STATE(2483),
    [sym_preproc_line] = STATE(2483),
    [sym_preproc_pragma] = STATE(2483),
    [sym_preproc_nullable] = STATE(2483),
    [sym_preproc_error] = STATE(2483),
    [sym_preproc_warning] = STATE(2483),
    [sym_preproc_define] = STATE(2483),
    [sym_preproc_undef] = STATE(2483),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3905),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2484] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2575),
    [sym_property_pattern_clause] = STATE(2679),
    [sym__variable_designation] = STATE(3817),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3729),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2484),
    [sym_preproc_endregion] = STATE(2484),
    [sym_preproc_line] = STATE(2484),
    [sym_preproc_pragma] = STATE(2484),
    [sym_preproc_nullable] = STATE(2484),
    [sym_preproc_error] = STATE(2484),
    [sym_preproc_warning] = STATE(2484),
    [sym_preproc_define] = STATE(2484),
    [sym_preproc_undef] = STATE(2484),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3909),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3909),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_orderby] = ACTIONS(3909),
    [anon_sym_ascending] = ACTIONS(3909),
    [anon_sym_descending] = ACTIONS(3909),
    [anon_sym_group] = ACTIONS(3909),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2485] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2543),
    [sym_property_pattern_clause] = STATE(2606),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2485),
    [sym_preproc_endregion] = STATE(2485),
    [sym_preproc_line] = STATE(2485),
    [sym_preproc_pragma] = STATE(2485),
    [sym_preproc_nullable] = STATE(2485),
    [sym_preproc_error] = STATE(2485),
    [sym_preproc_warning] = STATE(2485),
    [sym_preproc_define] = STATE(2485),
    [sym_preproc_undef] = STATE(2485),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3909),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2486] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2582),
    [sym_property_pattern_clause] = STATE(2675),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2486),
    [sym_preproc_endregion] = STATE(2486),
    [sym_preproc_line] = STATE(2486),
    [sym_preproc_pragma] = STATE(2486),
    [sym_preproc_nullable] = STATE(2486),
    [sym_preproc_error] = STATE(2486),
    [sym_preproc_warning] = STATE(2486),
    [sym_preproc_define] = STATE(2486),
    [sym_preproc_undef] = STATE(2486),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2487] = {
    [sym_preproc_region] = STATE(2487),
    [sym_preproc_endregion] = STATE(2487),
    [sym_preproc_line] = STATE(2487),
    [sym_preproc_pragma] = STATE(2487),
    [sym_preproc_nullable] = STATE(2487),
    [sym_preproc_error] = STATE(2487),
    [sym_preproc_warning] = STATE(2487),
    [sym_preproc_define] = STATE(2487),
    [sym_preproc_undef] = STATE(2487),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_RBRACK] = ACTIONS(4213),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_RPAREN] = ACTIONS(4213),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4213),
    [anon_sym_where] = ACTIONS(4213),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_BANG] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_GT_GT_GT] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_EQ_GT] = ACTIONS(4213),
    [anon_sym_switch] = ACTIONS(4213),
    [anon_sym_DOT_DOT] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(4213),
    [anon_sym_or] = ACTIONS(4215),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK] = ACTIONS(4215),
    [anon_sym_from] = ACTIONS(4213),
    [anon_sym_join] = ACTIONS(4213),
    [anon_sym_on] = ACTIONS(4213),
    [anon_sym_equals] = ACTIONS(4213),
    [anon_sym_let] = ACTIONS(4213),
    [anon_sym_orderby] = ACTIONS(4213),
    [anon_sym_group] = ACTIONS(4213),
    [anon_sym_by] = ACTIONS(4213),
    [anon_sym_select] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(4213),
    [anon_sym_is] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [anon_sym_with] = ACTIONS(4213),
    [aux_sym_preproc_if_token3] = ACTIONS(4213),
    [aux_sym_preproc_else_token1] = ACTIONS(4213),
    [aux_sym_preproc_elif_token1] = ACTIONS(4213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2488] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2302),
    [sym_property_pattern_clause] = STATE(2367),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2488),
    [sym_preproc_endregion] = STATE(2488),
    [sym_preproc_line] = STATE(2488),
    [sym_preproc_pragma] = STATE(2488),
    [sym_preproc_nullable] = STATE(2488),
    [sym_preproc_error] = STATE(2488),
    [sym_preproc_warning] = STATE(2488),
    [sym_preproc_define] = STATE(2488),
    [sym_preproc_undef] = STATE(2488),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3911),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2489] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2279),
    [sym_property_pattern_clause] = STATE(2322),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2489),
    [sym_preproc_endregion] = STATE(2489),
    [sym_preproc_line] = STATE(2489),
    [sym_preproc_pragma] = STATE(2489),
    [sym_preproc_nullable] = STATE(2489),
    [sym_preproc_error] = STATE(2489),
    [sym_preproc_warning] = STATE(2489),
    [sym_preproc_define] = STATE(2489),
    [sym_preproc_undef] = STATE(2489),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3911),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2490] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2302),
    [sym_property_pattern_clause] = STATE(2367),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2490),
    [sym_preproc_endregion] = STATE(2490),
    [sym_preproc_line] = STATE(2490),
    [sym_preproc_pragma] = STATE(2490),
    [sym_preproc_nullable] = STATE(2490),
    [sym_preproc_error] = STATE(2490),
    [sym_preproc_warning] = STATE(2490),
    [sym_preproc_define] = STATE(2490),
    [sym_preproc_undef] = STATE(2490),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2491] = {
    [sym_preproc_region] = STATE(2491),
    [sym_preproc_endregion] = STATE(2491),
    [sym_preproc_line] = STATE(2491),
    [sym_preproc_pragma] = STATE(2491),
    [sym_preproc_nullable] = STATE(2491),
    [sym_preproc_error] = STATE(2491),
    [sym_preproc_warning] = STATE(2491),
    [sym_preproc_define] = STATE(2491),
    [sym_preproc_undef] = STATE(2491),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_RBRACK] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_in] = ACTIONS(4172),
    [anon_sym_where] = ACTIONS(4172),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_GT_GT_GT] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_EQ_GT] = ACTIONS(4172),
    [anon_sym_switch] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK] = ACTIONS(4174),
    [anon_sym_from] = ACTIONS(4172),
    [anon_sym_join] = ACTIONS(4172),
    [anon_sym_on] = ACTIONS(4172),
    [anon_sym_equals] = ACTIONS(4172),
    [anon_sym_let] = ACTIONS(4172),
    [anon_sym_orderby] = ACTIONS(4172),
    [anon_sym_group] = ACTIONS(4172),
    [anon_sym_by] = ACTIONS(4172),
    [anon_sym_select] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4172),
    [anon_sym_is] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [anon_sym_with] = ACTIONS(4172),
    [aux_sym_preproc_if_token3] = ACTIONS(4172),
    [aux_sym_preproc_else_token1] = ACTIONS(4172),
    [aux_sym_preproc_elif_token1] = ACTIONS(4172),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2492] = {
    [sym_preproc_region] = STATE(2492),
    [sym_preproc_endregion] = STATE(2492),
    [sym_preproc_line] = STATE(2492),
    [sym_preproc_pragma] = STATE(2492),
    [sym_preproc_nullable] = STATE(2492),
    [sym_preproc_error] = STATE(2492),
    [sym_preproc_warning] = STATE(2492),
    [sym_preproc_define] = STATE(2492),
    [sym_preproc_undef] = STATE(2492),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4166),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_GT_GT_GT] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4164),
    [anon_sym_BANG_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK] = ACTIONS(4166),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_if_token3] = ACTIONS(4164),
    [aux_sym_preproc_else_token1] = ACTIONS(4164),
    [aux_sym_preproc_elif_token1] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2493] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2560),
    [sym_property_pattern_clause] = STATE(2611),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2493),
    [sym_preproc_endregion] = STATE(2493),
    [sym_preproc_line] = STATE(2493),
    [sym_preproc_pragma] = STATE(2493),
    [sym_preproc_nullable] = STATE(2493),
    [sym_preproc_error] = STATE(2493),
    [sym_preproc_warning] = STATE(2493),
    [sym_preproc_define] = STATE(2493),
    [sym_preproc_undef] = STATE(2493),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3911),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3909),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2494] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2582),
    [sym_property_pattern_clause] = STATE(2675),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2494),
    [sym_preproc_endregion] = STATE(2494),
    [sym_preproc_line] = STATE(2494),
    [sym_preproc_pragma] = STATE(2494),
    [sym_preproc_nullable] = STATE(2494),
    [sym_preproc_error] = STATE(2494),
    [sym_preproc_warning] = STATE(2494),
    [sym_preproc_define] = STATE(2494),
    [sym_preproc_undef] = STATE(2494),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2495] = {
    [sym_preproc_region] = STATE(2495),
    [sym_preproc_endregion] = STATE(2495),
    [sym_preproc_line] = STATE(2495),
    [sym_preproc_pragma] = STATE(2495),
    [sym_preproc_nullable] = STATE(2495),
    [sym_preproc_error] = STATE(2495),
    [sym_preproc_warning] = STATE(2495),
    [sym_preproc_define] = STATE(2495),
    [sym_preproc_undef] = STATE(2495),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_RBRACK] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_in] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_GT_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_EQ_GT] = ACTIONS(4190),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4188),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK] = ACTIONS(4188),
    [anon_sym_from] = ACTIONS(4190),
    [anon_sym_join] = ACTIONS(4190),
    [anon_sym_on] = ACTIONS(4190),
    [anon_sym_equals] = ACTIONS(4190),
    [anon_sym_let] = ACTIONS(4190),
    [anon_sym_orderby] = ACTIONS(4190),
    [anon_sym_group] = ACTIONS(4190),
    [anon_sym_by] = ACTIONS(4190),
    [anon_sym_select] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_if_token3] = ACTIONS(4190),
    [aux_sym_preproc_else_token1] = ACTIONS(4190),
    [aux_sym_preproc_elif_token1] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2496] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2279),
    [sym_property_pattern_clause] = STATE(2322),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2496),
    [sym_preproc_endregion] = STATE(2496),
    [sym_preproc_line] = STATE(2496),
    [sym_preproc_pragma] = STATE(2496),
    [sym_preproc_nullable] = STATE(2496),
    [sym_preproc_error] = STATE(2496),
    [sym_preproc_warning] = STATE(2496),
    [sym_preproc_define] = STATE(2496),
    [sym_preproc_undef] = STATE(2496),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2497] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2560),
    [sym_property_pattern_clause] = STATE(2611),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2497),
    [sym_preproc_endregion] = STATE(2497),
    [sym_preproc_line] = STATE(2497),
    [sym_preproc_pragma] = STATE(2497),
    [sym_preproc_nullable] = STATE(2497),
    [sym_preproc_error] = STATE(2497),
    [sym_preproc_warning] = STATE(2497),
    [sym_preproc_define] = STATE(2497),
    [sym_preproc_undef] = STATE(2497),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3909),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2498] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2560),
    [sym_property_pattern_clause] = STATE(2611),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2498),
    [sym_preproc_endregion] = STATE(2498),
    [sym_preproc_line] = STATE(2498),
    [sym_preproc_pragma] = STATE(2498),
    [sym_preproc_nullable] = STATE(2498),
    [sym_preproc_error] = STATE(2498),
    [sym_preproc_warning] = STATE(2498),
    [sym_preproc_define] = STATE(2498),
    [sym_preproc_undef] = STATE(2498),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3905),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2499] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2543),
    [sym_property_pattern_clause] = STATE(2606),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2499),
    [sym_preproc_endregion] = STATE(2499),
    [sym_preproc_line] = STATE(2499),
    [sym_preproc_pragma] = STATE(2499),
    [sym_preproc_nullable] = STATE(2499),
    [sym_preproc_error] = STATE(2499),
    [sym_preproc_warning] = STATE(2499),
    [sym_preproc_define] = STATE(2499),
    [sym_preproc_undef] = STATE(2499),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3905),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2500] = {
    [sym_preproc_region] = STATE(2500),
    [sym_preproc_endregion] = STATE(2500),
    [sym_preproc_line] = STATE(2500),
    [sym_preproc_pragma] = STATE(2500),
    [sym_preproc_nullable] = STATE(2500),
    [sym_preproc_error] = STATE(2500),
    [sym_preproc_warning] = STATE(2500),
    [sym_preproc_define] = STATE(2500),
    [sym_preproc_undef] = STATE(2500),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_EQ] = ACTIONS(4235),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_COLON] = ACTIONS(4233),
    [anon_sym_COMMA] = ACTIONS(4233),
    [anon_sym_RBRACK] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4233),
    [anon_sym_RPAREN] = ACTIONS(4233),
    [anon_sym_RBRACE] = ACTIONS(4233),
    [anon_sym_LT] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4235),
    [anon_sym_in] = ACTIONS(4233),
    [anon_sym_where] = ACTIONS(4233),
    [anon_sym_QMARK] = ACTIONS(4235),
    [anon_sym_BANG] = ACTIONS(4235),
    [anon_sym_PLUS_PLUS] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4235),
    [anon_sym_DASH] = ACTIONS(4235),
    [anon_sym_STAR] = ACTIONS(4235),
    [anon_sym_SLASH] = ACTIONS(4235),
    [anon_sym_PERCENT] = ACTIONS(4235),
    [anon_sym_CARET] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4235),
    [anon_sym_LT_LT] = ACTIONS(4235),
    [anon_sym_GT_GT] = ACTIONS(4235),
    [anon_sym_GT_GT_GT] = ACTIONS(4235),
    [anon_sym_EQ_EQ] = ACTIONS(4233),
    [anon_sym_BANG_EQ] = ACTIONS(4233),
    [anon_sym_GT_EQ] = ACTIONS(4233),
    [anon_sym_LT_EQ] = ACTIONS(4233),
    [anon_sym_DOT] = ACTIONS(4235),
    [anon_sym_EQ_GT] = ACTIONS(4233),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_DOT_DOT] = ACTIONS(4233),
    [anon_sym_and] = ACTIONS(4233),
    [anon_sym_or] = ACTIONS(4235),
    [anon_sym_PLUS_EQ] = ACTIONS(4233),
    [anon_sym_DASH_EQ] = ACTIONS(4233),
    [anon_sym_STAR_EQ] = ACTIONS(4233),
    [anon_sym_SLASH_EQ] = ACTIONS(4233),
    [anon_sym_PERCENT_EQ] = ACTIONS(4233),
    [anon_sym_AMP_EQ] = ACTIONS(4233),
    [anon_sym_CARET_EQ] = ACTIONS(4233),
    [anon_sym_PIPE_EQ] = ACTIONS(4233),
    [anon_sym_LT_LT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4233),
    [anon_sym_AMP_AMP] = ACTIONS(4233),
    [anon_sym_PIPE_PIPE] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK] = ACTIONS(4235),
    [anon_sym_from] = ACTIONS(4233),
    [anon_sym_join] = ACTIONS(4233),
    [anon_sym_on] = ACTIONS(4233),
    [anon_sym_equals] = ACTIONS(4233),
    [anon_sym_let] = ACTIONS(4233),
    [anon_sym_orderby] = ACTIONS(4233),
    [anon_sym_group] = ACTIONS(4233),
    [anon_sym_by] = ACTIONS(4233),
    [anon_sym_select] = ACTIONS(4233),
    [anon_sym_as] = ACTIONS(4233),
    [anon_sym_is] = ACTIONS(4233),
    [anon_sym_DASH_GT] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [aux_sym_preproc_if_token3] = ACTIONS(4233),
    [aux_sym_preproc_else_token1] = ACTIONS(4233),
    [aux_sym_preproc_elif_token1] = ACTIONS(4233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2501] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2279),
    [sym_property_pattern_clause] = STATE(2322),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2501),
    [sym_preproc_endregion] = STATE(2501),
    [sym_preproc_line] = STATE(2501),
    [sym_preproc_pragma] = STATE(2501),
    [sym_preproc_nullable] = STATE(2501),
    [sym_preproc_error] = STATE(2501),
    [sym_preproc_warning] = STATE(2501),
    [sym_preproc_define] = STATE(2501),
    [sym_preproc_undef] = STATE(2501),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3901),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2502] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2575),
    [sym_property_pattern_clause] = STATE(2679),
    [sym__variable_designation] = STATE(3817),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3729),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2502),
    [sym_preproc_endregion] = STATE(2502),
    [sym_preproc_line] = STATE(2502),
    [sym_preproc_pragma] = STATE(2502),
    [sym_preproc_nullable] = STATE(2502),
    [sym_preproc_error] = STATE(2502),
    [sym_preproc_warning] = STATE(2502),
    [sym_preproc_define] = STATE(2502),
    [sym_preproc_undef] = STATE(2502),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3905),
    [anon_sym_descending] = ACTIONS(3905),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2503] = {
    [sym_preproc_region] = STATE(2503),
    [sym_preproc_endregion] = STATE(2503),
    [sym_preproc_line] = STATE(2503),
    [sym_preproc_pragma] = STATE(2503),
    [sym_preproc_nullable] = STATE(2503),
    [sym_preproc_error] = STATE(2503),
    [sym_preproc_warning] = STATE(2503),
    [sym_preproc_define] = STATE(2503),
    [sym_preproc_undef] = STATE(2503),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_where] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3731),
    [anon_sym_join] = ACTIONS(3731),
    [anon_sym_on] = ACTIONS(3731),
    [anon_sym_equals] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_orderby] = ACTIONS(3731),
    [anon_sym_group] = ACTIONS(3731),
    [anon_sym_by] = ACTIONS(3731),
    [anon_sym_select] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_if_token3] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2504] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2543),
    [sym_property_pattern_clause] = STATE(2606),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(5028),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2504),
    [sym_preproc_endregion] = STATE(2504),
    [sym_preproc_line] = STATE(2504),
    [sym_preproc_pragma] = STATE(2504),
    [sym_preproc_nullable] = STATE(2504),
    [sym_preproc_error] = STATE(2504),
    [sym_preproc_warning] = STATE(2504),
    [sym_preproc_define] = STATE(2504),
    [sym_preproc_undef] = STATE(2504),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3911),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3909),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2505] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2620),
    [sym_property_pattern_clause] = STATE(2879),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2505),
    [sym_preproc_endregion] = STATE(2505),
    [sym_preproc_line] = STATE(2505),
    [sym_preproc_pragma] = STATE(2505),
    [sym_preproc_nullable] = STATE(2505),
    [sym_preproc_error] = STATE(2505),
    [sym_preproc_warning] = STATE(2505),
    [sym_preproc_define] = STATE(2505),
    [sym_preproc_undef] = STATE(2505),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3905),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2506] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2598),
    [sym_property_pattern_clause] = STATE(2774),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2506),
    [sym_preproc_endregion] = STATE(2506),
    [sym_preproc_line] = STATE(2506),
    [sym_preproc_pragma] = STATE(2506),
    [sym_preproc_nullable] = STATE(2506),
    [sym_preproc_error] = STATE(2506),
    [sym_preproc_warning] = STATE(2506),
    [sym_preproc_define] = STATE(2506),
    [sym_preproc_undef] = STATE(2506),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3905),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2507] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2615),
    [sym_property_pattern_clause] = STATE(2874),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2507),
    [sym_preproc_endregion] = STATE(2507),
    [sym_preproc_line] = STATE(2507),
    [sym_preproc_pragma] = STATE(2507),
    [sym_preproc_nullable] = STATE(2507),
    [sym_preproc_error] = STATE(2507),
    [sym_preproc_warning] = STATE(2507),
    [sym_preproc_define] = STATE(2507),
    [sym_preproc_undef] = STATE(2507),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2508] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2598),
    [sym_property_pattern_clause] = STATE(2774),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2508),
    [sym_preproc_endregion] = STATE(2508),
    [sym_preproc_line] = STATE(2508),
    [sym_preproc_pragma] = STATE(2508),
    [sym_preproc_nullable] = STATE(2508),
    [sym_preproc_error] = STATE(2508),
    [sym_preproc_warning] = STATE(2508),
    [sym_preproc_define] = STATE(2508),
    [sym_preproc_undef] = STATE(2508),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3909),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2509] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2621),
    [sym_property_pattern_clause] = STATE(2821),
    [sym__variable_designation] = STATE(4206),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4139),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2509),
    [sym_preproc_endregion] = STATE(2509),
    [sym_preproc_line] = STATE(2509),
    [sym_preproc_pragma] = STATE(2509),
    [sym_preproc_nullable] = STATE(2509),
    [sym_preproc_error] = STATE(2509),
    [sym_preproc_warning] = STATE(2509),
    [sym_preproc_define] = STATE(2509),
    [sym_preproc_undef] = STATE(2509),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2510] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7491),
    [sym__name] = STATE(5945),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5782),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2510),
    [sym_preproc_endregion] = STATE(2510),
    [sym_preproc_line] = STATE(2510),
    [sym_preproc_pragma] = STATE(2510),
    [sym_preproc_nullable] = STATE(2510),
    [sym_preproc_error] = STATE(2510),
    [sym_preproc_warning] = STATE(2510),
    [sym_preproc_define] = STATE(2510),
    [sym_preproc_undef] = STATE(2510),
    [aux_sym_using_directive_repeat1] = STATE(5801),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2549),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(4247),
    [anon_sym_static] = ACTIONS(4249),
    [anon_sym_LPAREN] = ACTIONS(4251),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2511] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2601),
    [sym_property_pattern_clause] = STATE(2861),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2511),
    [sym_preproc_endregion] = STATE(2511),
    [sym_preproc_line] = STATE(2511),
    [sym_preproc_pragma] = STATE(2511),
    [sym_preproc_nullable] = STATE(2511),
    [sym_preproc_error] = STATE(2511),
    [sym_preproc_warning] = STATE(2511),
    [sym_preproc_define] = STATE(2511),
    [sym_preproc_undef] = STATE(2511),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3905),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2512] = {
    [sym__name] = STATE(3586),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_ref_type] = STATE(2994),
    [sym__scoped_base_type] = STATE(2965),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2512),
    [sym_preproc_endregion] = STATE(2512),
    [sym_preproc_line] = STATE(2512),
    [sym_preproc_pragma] = STATE(2512),
    [sym_preproc_nullable] = STATE(2512),
    [sym_preproc_error] = STATE(2512),
    [sym_preproc_warning] = STATE(2512),
    [sym_preproc_define] = STATE(2512),
    [sym_preproc_undef] = STATE(2512),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4253),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3875),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3875),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2513] = {
    [sym__name] = STATE(3586),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_ref_type] = STATE(2994),
    [sym__scoped_base_type] = STATE(2965),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2513),
    [sym_preproc_endregion] = STATE(2513),
    [sym_preproc_line] = STATE(2513),
    [sym_preproc_pragma] = STATE(2513),
    [sym_preproc_nullable] = STATE(2513),
    [sym_preproc_error] = STATE(2513),
    [sym_preproc_warning] = STATE(2513),
    [sym_preproc_define] = STATE(2513),
    [sym_preproc_undef] = STATE(2513),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4255),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3875),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3875),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2514] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2595),
    [sym_property_pattern_clause] = STATE(2698),
    [sym__variable_designation] = STATE(4206),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4139),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2514),
    [sym_preproc_endregion] = STATE(2514),
    [sym_preproc_line] = STATE(2514),
    [sym_preproc_pragma] = STATE(2514),
    [sym_preproc_nullable] = STATE(2514),
    [sym_preproc_error] = STATE(2514),
    [sym_preproc_warning] = STATE(2514),
    [sym_preproc_define] = STATE(2514),
    [sym_preproc_undef] = STATE(2514),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3909),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3909),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_orderby] = ACTIONS(3909),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3909),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2515] = {
    [sym__name] = STATE(3586),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_ref_type] = STATE(2994),
    [sym__scoped_base_type] = STATE(2965),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2515),
    [sym_preproc_endregion] = STATE(2515),
    [sym_preproc_line] = STATE(2515),
    [sym_preproc_pragma] = STATE(2515),
    [sym_preproc_nullable] = STATE(2515),
    [sym_preproc_error] = STATE(2515),
    [sym_preproc_warning] = STATE(2515),
    [sym_preproc_define] = STATE(2515),
    [sym_preproc_undef] = STATE(2515),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4257),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3875),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2516] = {
    [sym_property_pattern_clause] = STATE(2585),
    [sym__variable_designation] = STATE(4818),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2516),
    [sym_preproc_endregion] = STATE(2516),
    [sym_preproc_line] = STATE(2516),
    [sym_preproc_pragma] = STATE(2516),
    [sym_preproc_nullable] = STATE(2516),
    [sym_preproc_error] = STATE(2516),
    [sym_preproc_warning] = STATE(2516),
    [sym_preproc_define] = STATE(2516),
    [sym_preproc_undef] = STATE(2516),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3927),
  },
  [2517] = {
    [sym_property_pattern_clause] = STATE(2586),
    [sym__variable_designation] = STATE(4860),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2517),
    [sym_preproc_endregion] = STATE(2517),
    [sym_preproc_line] = STATE(2517),
    [sym_preproc_pragma] = STATE(2517),
    [sym_preproc_nullable] = STATE(2517),
    [sym_preproc_error] = STATE(2517),
    [sym_preproc_warning] = STATE(2517),
    [sym_preproc_define] = STATE(2517),
    [sym_preproc_undef] = STATE(2517),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3931),
  },
  [2518] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2621),
    [sym_property_pattern_clause] = STATE(2821),
    [sym__variable_designation] = STATE(4206),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4139),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2518),
    [sym_preproc_endregion] = STATE(2518),
    [sym_preproc_line] = STATE(2518),
    [sym_preproc_pragma] = STATE(2518),
    [sym_preproc_nullable] = STATE(2518),
    [sym_preproc_error] = STATE(2518),
    [sym_preproc_warning] = STATE(2518),
    [sym_preproc_define] = STATE(2518),
    [sym_preproc_undef] = STATE(2518),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2519] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2591),
    [sym_property_pattern_clause] = STATE(2831),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2519),
    [sym_preproc_endregion] = STATE(2519),
    [sym_preproc_line] = STATE(2519),
    [sym_preproc_pragma] = STATE(2519),
    [sym_preproc_nullable] = STATE(2519),
    [sym_preproc_error] = STATE(2519),
    [sym_preproc_warning] = STATE(2519),
    [sym_preproc_define] = STATE(2519),
    [sym_preproc_undef] = STATE(2519),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2520] = {
    [sym__name] = STATE(3127),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_ref_type] = STATE(3016),
    [sym__scoped_base_type] = STATE(3025),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2520),
    [sym_preproc_endregion] = STATE(2520),
    [sym_preproc_line] = STATE(2520),
    [sym_preproc_pragma] = STATE(2520),
    [sym_preproc_nullable] = STATE(2520),
    [sym_preproc_error] = STATE(2520),
    [sym_preproc_warning] = STATE(2520),
    [sym_preproc_define] = STATE(2520),
    [sym_preproc_undef] = STATE(2520),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4259),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(4210),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2521] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2597),
    [sym_property_pattern_clause] = STATE(2843),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2521),
    [sym_preproc_endregion] = STATE(2521),
    [sym_preproc_line] = STATE(2521),
    [sym_preproc_pragma] = STATE(2521),
    [sym_preproc_nullable] = STATE(2521),
    [sym_preproc_error] = STATE(2521),
    [sym_preproc_warning] = STATE(2521),
    [sym_preproc_define] = STATE(2521),
    [sym_preproc_undef] = STATE(2521),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3905),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2522] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2591),
    [sym_property_pattern_clause] = STATE(2831),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2522),
    [sym_preproc_endregion] = STATE(2522),
    [sym_preproc_line] = STATE(2522),
    [sym_preproc_pragma] = STATE(2522),
    [sym_preproc_nullable] = STATE(2522),
    [sym_preproc_error] = STATE(2522),
    [sym_preproc_warning] = STATE(2522),
    [sym_preproc_define] = STATE(2522),
    [sym_preproc_undef] = STATE(2522),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3909),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2523] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2597),
    [sym_property_pattern_clause] = STATE(2843),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2523),
    [sym_preproc_endregion] = STATE(2523),
    [sym_preproc_line] = STATE(2523),
    [sym_preproc_pragma] = STATE(2523),
    [sym_preproc_nullable] = STATE(2523),
    [sym_preproc_error] = STATE(2523),
    [sym_preproc_warning] = STATE(2523),
    [sym_preproc_define] = STATE(2523),
    [sym_preproc_undef] = STATE(2523),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3909),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2524] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2601),
    [sym_property_pattern_clause] = STATE(2861),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2524),
    [sym_preproc_endregion] = STATE(2524),
    [sym_preproc_line] = STATE(2524),
    [sym_preproc_pragma] = STATE(2524),
    [sym_preproc_nullable] = STATE(2524),
    [sym_preproc_error] = STATE(2524),
    [sym_preproc_warning] = STATE(2524),
    [sym_preproc_define] = STATE(2524),
    [sym_preproc_undef] = STATE(2524),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3905),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2525] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2601),
    [sym_property_pattern_clause] = STATE(2861),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2525),
    [sym_preproc_endregion] = STATE(2525),
    [sym_preproc_line] = STATE(2525),
    [sym_preproc_pragma] = STATE(2525),
    [sym_preproc_nullable] = STATE(2525),
    [sym_preproc_error] = STATE(2525),
    [sym_preproc_warning] = STATE(2525),
    [sym_preproc_define] = STATE(2525),
    [sym_preproc_undef] = STATE(2525),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3909),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2526] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2591),
    [sym_property_pattern_clause] = STATE(2831),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2526),
    [sym_preproc_endregion] = STATE(2526),
    [sym_preproc_line] = STATE(2526),
    [sym_preproc_pragma] = STATE(2526),
    [sym_preproc_nullable] = STATE(2526),
    [sym_preproc_error] = STATE(2526),
    [sym_preproc_warning] = STATE(2526),
    [sym_preproc_define] = STATE(2526),
    [sym_preproc_undef] = STATE(2526),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2527] = {
    [sym_property_pattern_clause] = STATE(2571),
    [sym__variable_designation] = STATE(4818),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2527),
    [sym_preproc_endregion] = STATE(2527),
    [sym_preproc_line] = STATE(2527),
    [sym_preproc_pragma] = STATE(2527),
    [sym_preproc_nullable] = STATE(2527),
    [sym_preproc_error] = STATE(2527),
    [sym_preproc_warning] = STATE(2527),
    [sym_preproc_define] = STATE(2527),
    [sym_preproc_undef] = STATE(2527),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3927),
  },
  [2528] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2615),
    [sym_property_pattern_clause] = STATE(2874),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2528),
    [sym_preproc_endregion] = STATE(2528),
    [sym_preproc_line] = STATE(2528),
    [sym_preproc_pragma] = STATE(2528),
    [sym_preproc_nullable] = STATE(2528),
    [sym_preproc_error] = STATE(2528),
    [sym_preproc_warning] = STATE(2528),
    [sym_preproc_define] = STATE(2528),
    [sym_preproc_undef] = STATE(2528),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2529] = {
    [sym_property_pattern_clause] = STATE(2572),
    [sym__variable_designation] = STATE(4860),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2529),
    [sym_preproc_endregion] = STATE(2529),
    [sym_preproc_line] = STATE(2529),
    [sym_preproc_pragma] = STATE(2529),
    [sym_preproc_nullable] = STATE(2529),
    [sym_preproc_error] = STATE(2529),
    [sym_preproc_warning] = STATE(2529),
    [sym_preproc_define] = STATE(2529),
    [sym_preproc_undef] = STATE(2529),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(4090),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3931),
  },
  [2530] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2595),
    [sym_property_pattern_clause] = STATE(2698),
    [sym__variable_designation] = STATE(4206),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4139),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2530),
    [sym_preproc_endregion] = STATE(2530),
    [sym_preproc_line] = STATE(2530),
    [sym_preproc_pragma] = STATE(2530),
    [sym_preproc_nullable] = STATE(2530),
    [sym_preproc_error] = STATE(2530),
    [sym_preproc_warning] = STATE(2530),
    [sym_preproc_define] = STATE(2530),
    [sym_preproc_undef] = STATE(2530),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2531] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2620),
    [sym_property_pattern_clause] = STATE(2879),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2531),
    [sym_preproc_endregion] = STATE(2531),
    [sym_preproc_line] = STATE(2531),
    [sym_preproc_pragma] = STATE(2531),
    [sym_preproc_nullable] = STATE(2531),
    [sym_preproc_error] = STATE(2531),
    [sym_preproc_warning] = STATE(2531),
    [sym_preproc_define] = STATE(2531),
    [sym_preproc_undef] = STATE(2531),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3905),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3905),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2532] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7652),
    [sym__name] = STATE(5953),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5788),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2532),
    [sym_preproc_endregion] = STATE(2532),
    [sym_preproc_line] = STATE(2532),
    [sym_preproc_pragma] = STATE(2532),
    [sym_preproc_nullable] = STATE(2532),
    [sym_preproc_error] = STATE(2532),
    [sym_preproc_warning] = STATE(2532),
    [sym_preproc_define] = STATE(2532),
    [sym_preproc_undef] = STATE(2532),
    [aux_sym_using_directive_repeat1] = STATE(5784),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2557),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(4261),
    [anon_sym_static] = ACTIONS(4249),
    [anon_sym_LPAREN] = ACTIONS(4263),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2533] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2595),
    [sym_property_pattern_clause] = STATE(2698),
    [sym__variable_designation] = STATE(4206),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4139),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2533),
    [sym_preproc_endregion] = STATE(2533),
    [sym_preproc_line] = STATE(2533),
    [sym_preproc_pragma] = STATE(2533),
    [sym_preproc_nullable] = STATE(2533),
    [sym_preproc_error] = STATE(2533),
    [sym_preproc_warning] = STATE(2533),
    [sym_preproc_define] = STATE(2533),
    [sym_preproc_undef] = STATE(2533),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3905),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3905),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3905),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_orderby] = ACTIONS(3905),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3905),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2534] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2615),
    [sym_property_pattern_clause] = STATE(2874),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2534),
    [sym_preproc_endregion] = STATE(2534),
    [sym_preproc_line] = STATE(2534),
    [sym_preproc_pragma] = STATE(2534),
    [sym_preproc_nullable] = STATE(2534),
    [sym_preproc_error] = STATE(2534),
    [sym_preproc_warning] = STATE(2534),
    [sym_preproc_define] = STATE(2534),
    [sym_preproc_undef] = STATE(2534),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3909),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2535] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2597),
    [sym_property_pattern_clause] = STATE(2843),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2535),
    [sym_preproc_endregion] = STATE(2535),
    [sym_preproc_line] = STATE(2535),
    [sym_preproc_pragma] = STATE(2535),
    [sym_preproc_nullable] = STATE(2535),
    [sym_preproc_error] = STATE(2535),
    [sym_preproc_warning] = STATE(2535),
    [sym_preproc_define] = STATE(2535),
    [sym_preproc_undef] = STATE(2535),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3905),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2536] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2598),
    [sym_property_pattern_clause] = STATE(2774),
    [sym__variable_designation] = STATE(3548),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3549),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2536),
    [sym_preproc_endregion] = STATE(2536),
    [sym_preproc_line] = STATE(2536),
    [sym_preproc_pragma] = STATE(2536),
    [sym_preproc_nullable] = STATE(2536),
    [sym_preproc_error] = STATE(2536),
    [sym_preproc_warning] = STATE(2536),
    [sym_preproc_define] = STATE(2536),
    [sym_preproc_undef] = STATE(2536),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_LT_LT] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3901),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3905),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_and] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3905),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_QMARK_QMARK] = ACTIONS(3901),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3905),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3905),
    [anon_sym_is] = ACTIONS(3905),
    [anon_sym_DASH_GT] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2537] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2620),
    [sym_property_pattern_clause] = STATE(2879),
    [sym__variable_designation] = STATE(3377),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(3309),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2537),
    [sym_preproc_endregion] = STATE(2537),
    [sym_preproc_line] = STATE(2537),
    [sym_preproc_pragma] = STATE(2537),
    [sym_preproc_nullable] = STATE(2537),
    [sym_preproc_error] = STATE(2537),
    [sym_preproc_warning] = STATE(2537),
    [sym_preproc_define] = STATE(2537),
    [sym_preproc_undef] = STATE(2537),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3909),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2538] = {
    [sym__name] = STATE(3127),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_ref_type] = STATE(3016),
    [sym__scoped_base_type] = STATE(3025),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2538),
    [sym_preproc_endregion] = STATE(2538),
    [sym_preproc_line] = STATE(2538),
    [sym_preproc_pragma] = STATE(2538),
    [sym_preproc_nullable] = STATE(2538),
    [sym_preproc_error] = STATE(2538),
    [sym_preproc_warning] = STATE(2538),
    [sym_preproc_define] = STATE(2538),
    [sym_preproc_undef] = STATE(2538),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4265),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(4210),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2539] = {
    [sym__name] = STATE(3127),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_ref_type] = STATE(3016),
    [sym__scoped_base_type] = STATE(3025),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2539),
    [sym_preproc_endregion] = STATE(2539),
    [sym_preproc_line] = STATE(2539),
    [sym_preproc_pragma] = STATE(2539),
    [sym_preproc_nullable] = STATE(2539),
    [sym_preproc_error] = STATE(2539),
    [sym_preproc_warning] = STATE(2539),
    [sym_preproc_define] = STATE(2539),
    [sym_preproc_undef] = STATE(2539),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(4210),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2540] = {
    [sym_parameter_list] = STATE(7385),
    [sym_positional_pattern_clause] = STATE(2621),
    [sym_property_pattern_clause] = STATE(2821),
    [sym__variable_designation] = STATE(4206),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(4139),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2540),
    [sym_preproc_endregion] = STATE(2540),
    [sym_preproc_line] = STATE(2540),
    [sym_preproc_pragma] = STATE(2540),
    [sym_preproc_nullable] = STATE(2540),
    [sym_preproc_error] = STATE(2540),
    [sym_preproc_warning] = STATE(2540),
    [sym_preproc_define] = STATE(2540),
    [sym_preproc_undef] = STATE(2540),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_where] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3909),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(3909),
    [anon_sym_or] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_QMARK_QMARK] = ACTIONS(3911),
    [anon_sym_from] = ACTIONS(3909),
    [anon_sym_into] = ACTIONS(3909),
    [anon_sym_join] = ACTIONS(3909),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_orderby] = ACTIONS(3909),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3909),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3909),
    [anon_sym_is] = ACTIONS(3909),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [anon_sym_with] = ACTIONS(3909),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2541] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7491),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5963),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2541),
    [sym_preproc_endregion] = STATE(2541),
    [sym_preproc_line] = STATE(2541),
    [sym_preproc_pragma] = STATE(2541),
    [sym_preproc_nullable] = STATE(2541),
    [sym_preproc_error] = STATE(2541),
    [sym_preproc_warning] = STATE(2541),
    [sym_preproc_define] = STATE(2541),
    [sym_preproc_undef] = STATE(2541),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2542] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7498),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2542),
    [sym_preproc_endregion] = STATE(2542),
    [sym_preproc_line] = STATE(2542),
    [sym_preproc_pragma] = STATE(2542),
    [sym_preproc_nullable] = STATE(2542),
    [sym_preproc_error] = STATE(2542),
    [sym_preproc_warning] = STATE(2542),
    [sym_preproc_define] = STATE(2542),
    [sym_preproc_undef] = STATE(2542),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2564),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4269),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2543] = {
    [sym_property_pattern_clause] = STATE(2608),
    [sym__variable_designation] = STATE(3533),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2543),
    [sym_preproc_endregion] = STATE(2543),
    [sym_preproc_line] = STATE(2543),
    [sym_preproc_pragma] = STATE(2543),
    [sym_preproc_nullable] = STATE(2543),
    [sym_preproc_error] = STATE(2543),
    [sym_preproc_warning] = STATE(2543),
    [sym_preproc_define] = STATE(2543),
    [sym_preproc_undef] = STATE(2543),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3933),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2544] = {
    [sym_parameter_list] = STATE(7385),
    [sym__lambda_parameters] = STATE(7347),
    [sym_identifier] = STATE(7710),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(2544),
    [sym_preproc_endregion] = STATE(2544),
    [sym_preproc_line] = STATE(2544),
    [sym_preproc_pragma] = STATE(2544),
    [sym_preproc_nullable] = STATE(2544),
    [sym_preproc_error] = STATE(2544),
    [sym_preproc_warning] = STATE(2544),
    [sym_preproc_define] = STATE(2544),
    [sym_preproc_undef] = STATE(2544),
    [sym__identifier_token] = ACTIONS(3947),
    [anon_sym_alias] = ACTIONS(3947),
    [anon_sym_global] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_where] = ACTIONS(3947),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_notnull] = ACTIONS(3947),
    [anon_sym_unmanaged] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_scoped] = ACTIONS(3947),
    [anon_sym_var] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_when] = ACTIONS(3947),
    [sym_discard] = ACTIONS(3947),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3947),
    [anon_sym_into] = ACTIONS(3947),
    [anon_sym_join] = ACTIONS(3947),
    [anon_sym_on] = ACTIONS(3947),
    [anon_sym_equals] = ACTIONS(3947),
    [anon_sym_let] = ACTIONS(3947),
    [anon_sym_orderby] = ACTIONS(3947),
    [anon_sym_ascending] = ACTIONS(3947),
    [anon_sym_descending] = ACTIONS(3947),
    [anon_sym_group] = ACTIONS(3947),
    [anon_sym_by] = ACTIONS(3947),
    [anon_sym_select] = ACTIONS(3947),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_is] = ACTIONS(3947),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3949),
  },
  [2545] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7498),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5963),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2545),
    [sym_preproc_endregion] = STATE(2545),
    [sym_preproc_line] = STATE(2545),
    [sym_preproc_pragma] = STATE(2545),
    [sym_preproc_nullable] = STATE(2545),
    [sym_preproc_error] = STATE(2545),
    [sym_preproc_warning] = STATE(2545),
    [sym_preproc_define] = STATE(2545),
    [sym_preproc_undef] = STATE(2545),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2546] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7634),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2546),
    [sym_preproc_endregion] = STATE(2546),
    [sym_preproc_line] = STATE(2546),
    [sym_preproc_pragma] = STATE(2546),
    [sym_preproc_nullable] = STATE(2546),
    [sym_preproc_error] = STATE(2546),
    [sym_preproc_warning] = STATE(2546),
    [sym_preproc_define] = STATE(2546),
    [sym_preproc_undef] = STATE(2546),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2547] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7701),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2547),
    [sym_preproc_endregion] = STATE(2547),
    [sym_preproc_line] = STATE(2547),
    [sym_preproc_pragma] = STATE(2547),
    [sym_preproc_nullable] = STATE(2547),
    [sym_preproc_error] = STATE(2547),
    [sym_preproc_warning] = STATE(2547),
    [sym_preproc_define] = STATE(2547),
    [sym_preproc_undef] = STATE(2547),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2548),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4271),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2548] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7569),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2548),
    [sym_preproc_endregion] = STATE(2548),
    [sym_preproc_line] = STATE(2548),
    [sym_preproc_pragma] = STATE(2548),
    [sym_preproc_nullable] = STATE(2548),
    [sym_preproc_error] = STATE(2548),
    [sym_preproc_warning] = STATE(2548),
    [sym_preproc_define] = STATE(2548),
    [sym_preproc_undef] = STATE(2548),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2549] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7701),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2549),
    [sym_preproc_endregion] = STATE(2549),
    [sym_preproc_line] = STATE(2549),
    [sym_preproc_pragma] = STATE(2549),
    [sym_preproc_nullable] = STATE(2549),
    [sym_preproc_error] = STATE(2549),
    [sym_preproc_warning] = STATE(2549),
    [sym_preproc_define] = STATE(2549),
    [sym_preproc_undef] = STATE(2549),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2550] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7401),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2550),
    [sym_preproc_endregion] = STATE(2550),
    [sym_preproc_line] = STATE(2550),
    [sym_preproc_pragma] = STATE(2550),
    [sym_preproc_nullable] = STATE(2550),
    [sym_preproc_error] = STATE(2550),
    [sym_preproc_warning] = STATE(2550),
    [sym_preproc_define] = STATE(2550),
    [sym_preproc_undef] = STATE(2550),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2551] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7652),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2551),
    [sym_preproc_endregion] = STATE(2551),
    [sym_preproc_line] = STATE(2551),
    [sym_preproc_pragma] = STATE(2551),
    [sym_preproc_nullable] = STATE(2551),
    [sym_preproc_error] = STATE(2551),
    [sym_preproc_warning] = STATE(2551),
    [sym_preproc_define] = STATE(2551),
    [sym_preproc_undef] = STATE(2551),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2557),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4263),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2552] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(4377),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2552),
    [sym_preproc_endregion] = STATE(2552),
    [sym_preproc_line] = STATE(2552),
    [sym_preproc_pragma] = STATE(2552),
    [sym_preproc_nullable] = STATE(2552),
    [sym_preproc_error] = STATE(2552),
    [sym_preproc_warning] = STATE(2552),
    [sym_preproc_define] = STATE(2552),
    [sym_preproc_undef] = STATE(2552),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2553] = {
    [sym_preproc_region] = STATE(2553),
    [sym_preproc_endregion] = STATE(2553),
    [sym_preproc_line] = STATE(2553),
    [sym_preproc_pragma] = STATE(2553),
    [sym_preproc_nullable] = STATE(2553),
    [sym_preproc_error] = STATE(2553),
    [sym_preproc_warning] = STATE(2553),
    [sym_preproc_define] = STATE(2553),
    [sym_preproc_undef] = STATE(2553),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3785),
    [anon_sym_delegate] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_var] = ACTIONS(3785),
    [sym_predefined_type] = ACTIONS(3785),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(2991),
  },
  [2554] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7652),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5963),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2554),
    [sym_preproc_endregion] = STATE(2554),
    [sym_preproc_line] = STATE(2554),
    [sym_preproc_pragma] = STATE(2554),
    [sym_preproc_nullable] = STATE(2554),
    [sym_preproc_error] = STATE(2554),
    [sym_preproc_warning] = STATE(2554),
    [sym_preproc_define] = STATE(2554),
    [sym_preproc_undef] = STATE(2554),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2555] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7401),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2555),
    [sym_preproc_endregion] = STATE(2555),
    [sym_preproc_line] = STATE(2555),
    [sym_preproc_pragma] = STATE(2555),
    [sym_preproc_nullable] = STATE(2555),
    [sym_preproc_error] = STATE(2555),
    [sym_preproc_warning] = STATE(2555),
    [sym_preproc_define] = STATE(2555),
    [sym_preproc_undef] = STATE(2555),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2556),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4273),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2556] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7527),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2556),
    [sym_preproc_endregion] = STATE(2556),
    [sym_preproc_line] = STATE(2556),
    [sym_preproc_pragma] = STATE(2556),
    [sym_preproc_nullable] = STATE(2556),
    [sym_preproc_error] = STATE(2556),
    [sym_preproc_warning] = STATE(2556),
    [sym_preproc_define] = STATE(2556),
    [sym_preproc_undef] = STATE(2556),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2557] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7580),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2557),
    [sym_preproc_endregion] = STATE(2557),
    [sym_preproc_line] = STATE(2557),
    [sym_preproc_pragma] = STATE(2557),
    [sym_preproc_nullable] = STATE(2557),
    [sym_preproc_error] = STATE(2557),
    [sym_preproc_warning] = STATE(2557),
    [sym_preproc_define] = STATE(2557),
    [sym_preproc_undef] = STATE(2557),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2558] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7580),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2558),
    [sym_preproc_endregion] = STATE(2558),
    [sym_preproc_line] = STATE(2558),
    [sym_preproc_pragma] = STATE(2558),
    [sym_preproc_nullable] = STATE(2558),
    [sym_preproc_error] = STATE(2558),
    [sym_preproc_warning] = STATE(2558),
    [sym_preproc_define] = STATE(2558),
    [sym_preproc_undef] = STATE(2558),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2561),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4275),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2559] = {
    [sym_property_pattern_clause] = STATE(2612),
    [sym__variable_designation] = STATE(3286),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2559),
    [sym_preproc_endregion] = STATE(2559),
    [sym_preproc_line] = STATE(2559),
    [sym_preproc_pragma] = STATE(2559),
    [sym_preproc_nullable] = STATE(2559),
    [sym_preproc_error] = STATE(2559),
    [sym_preproc_warning] = STATE(2559),
    [sym_preproc_define] = STATE(2559),
    [sym_preproc_undef] = STATE(2559),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3929),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2560] = {
    [sym_property_pattern_clause] = STATE(2613),
    [sym__variable_designation] = STATE(3391),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2560),
    [sym_preproc_endregion] = STATE(2560),
    [sym_preproc_line] = STATE(2560),
    [sym_preproc_pragma] = STATE(2560),
    [sym_preproc_nullable] = STATE(2560),
    [sym_preproc_error] = STATE(2560),
    [sym_preproc_warning] = STATE(2560),
    [sym_preproc_define] = STATE(2560),
    [sym_preproc_undef] = STATE(2560),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3933),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2561] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7659),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2561),
    [sym_preproc_endregion] = STATE(2561),
    [sym_preproc_line] = STATE(2561),
    [sym_preproc_pragma] = STATE(2561),
    [sym_preproc_nullable] = STATE(2561),
    [sym_preproc_error] = STATE(2561),
    [sym_preproc_warning] = STATE(2561),
    [sym_preproc_define] = STATE(2561),
    [sym_preproc_undef] = STATE(2561),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2562] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2562),
    [sym_preproc_endregion] = STATE(2562),
    [sym_preproc_line] = STATE(2562),
    [sym_preproc_pragma] = STATE(2562),
    [sym_preproc_nullable] = STATE(2562),
    [sym_preproc_error] = STATE(2562),
    [sym_preproc_warning] = STATE(2562),
    [sym_preproc_define] = STATE(2562),
    [sym_preproc_undef] = STATE(2562),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2563] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7491),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2563),
    [sym_preproc_endregion] = STATE(2563),
    [sym_preproc_line] = STATE(2563),
    [sym_preproc_pragma] = STATE(2563),
    [sym_preproc_nullable] = STATE(2563),
    [sym_preproc_error] = STATE(2563),
    [sym_preproc_warning] = STATE(2563),
    [sym_preproc_define] = STATE(2563),
    [sym_preproc_undef] = STATE(2563),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2549),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4251),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2564] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7416),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2564),
    [sym_preproc_endregion] = STATE(2564),
    [sym_preproc_line] = STATE(2564),
    [sym_preproc_pragma] = STATE(2564),
    [sym_preproc_nullable] = STATE(2564),
    [sym_preproc_error] = STATE(2564),
    [sym_preproc_warning] = STATE(2564),
    [sym_preproc_define] = STATE(2564),
    [sym_preproc_undef] = STATE(2564),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2565] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7613),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2565),
    [sym_preproc_endregion] = STATE(2565),
    [sym_preproc_line] = STATE(2565),
    [sym_preproc_pragma] = STATE(2565),
    [sym_preproc_nullable] = STATE(2565),
    [sym_preproc_error] = STATE(2565),
    [sym_preproc_warning] = STATE(2565),
    [sym_preproc_define] = STATE(2565),
    [sym_preproc_undef] = STATE(2565),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2550),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4277),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2566] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7613),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5963),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2566),
    [sym_preproc_endregion] = STATE(2566),
    [sym_preproc_line] = STATE(2566),
    [sym_preproc_pragma] = STATE(2566),
    [sym_preproc_nullable] = STATE(2566),
    [sym_preproc_error] = STATE(2566),
    [sym_preproc_warning] = STATE(2566),
    [sym_preproc_define] = STATE(2566),
    [sym_preproc_undef] = STATE(2566),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2567] = {
    [sym_modifier] = STATE(3740),
    [sym_variable_declaration] = STATE(7416),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5975),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2567),
    [sym_preproc_endregion] = STATE(2567),
    [sym_preproc_line] = STATE(2567),
    [sym_preproc_pragma] = STATE(2567),
    [sym_preproc_nullable] = STATE(2567),
    [sym_preproc_error] = STATE(2567),
    [sym_preproc_warning] = STATE(2567),
    [sym_preproc_define] = STATE(2567),
    [sym_preproc_undef] = STATE(2567),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(2546),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(4279),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2568] = {
    [sym_property_pattern_clause] = STATE(2607),
    [sym__variable_designation] = STATE(3554),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2568),
    [sym_preproc_endregion] = STATE(2568),
    [sym_preproc_line] = STATE(2568),
    [sym_preproc_pragma] = STATE(2568),
    [sym_preproc_nullable] = STATE(2568),
    [sym_preproc_error] = STATE(2568),
    [sym_preproc_warning] = STATE(2568),
    [sym_preproc_define] = STATE(2568),
    [sym_preproc_undef] = STATE(2568),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3929),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2569] = {
    [sym__variable_designation] = STATE(4735),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2569),
    [sym_preproc_endregion] = STATE(2569),
    [sym_preproc_line] = STATE(2569),
    [sym_preproc_pragma] = STATE(2569),
    [sym_preproc_nullable] = STATE(2569),
    [sym_preproc_error] = STATE(2569),
    [sym_preproc_warning] = STATE(2569),
    [sym_preproc_define] = STATE(2569),
    [sym_preproc_undef] = STATE(2569),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_COLON] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(4281),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3989),
  },
  [2570] = {
    [sym__variable_designation] = STATE(4861),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2570),
    [sym_preproc_endregion] = STATE(2570),
    [sym_preproc_line] = STATE(2570),
    [sym_preproc_pragma] = STATE(2570),
    [sym_preproc_nullable] = STATE(2570),
    [sym_preproc_error] = STATE(2570),
    [sym_preproc_warning] = STATE(2570),
    [sym_preproc_define] = STATE(2570),
    [sym_preproc_undef] = STATE(2570),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3931),
  },
  [2571] = {
    [sym__variable_designation] = STATE(4868),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2571),
    [sym_preproc_endregion] = STATE(2571),
    [sym_preproc_line] = STATE(2571),
    [sym_preproc_pragma] = STATE(2571),
    [sym_preproc_nullable] = STATE(2571),
    [sym_preproc_error] = STATE(2571),
    [sym_preproc_warning] = STATE(2571),
    [sym_preproc_define] = STATE(2571),
    [sym_preproc_undef] = STATE(2571),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3997),
  },
  [2572] = {
    [sym__variable_designation] = STATE(4871),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2572),
    [sym_preproc_endregion] = STATE(2572),
    [sym_preproc_line] = STATE(2572),
    [sym_preproc_pragma] = STATE(2572),
    [sym_preproc_nullable] = STATE(2572),
    [sym_preproc_error] = STATE(2572),
    [sym_preproc_warning] = STATE(2572),
    [sym_preproc_define] = STATE(2572),
    [sym_preproc_undef] = STATE(2572),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4001),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4001),
  },
  [2573] = {
    [sym_property_pattern_clause] = STATE(2642),
    [sym__variable_designation] = STATE(3832),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2573),
    [sym_preproc_endregion] = STATE(2573),
    [sym_preproc_line] = STATE(2573),
    [sym_preproc_pragma] = STATE(2573),
    [sym_preproc_nullable] = STATE(2573),
    [sym_preproc_error] = STATE(2573),
    [sym_preproc_warning] = STATE(2573),
    [sym_preproc_define] = STATE(2573),
    [sym_preproc_undef] = STATE(2573),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3933),
    [anon_sym_descending] = ACTIONS(3933),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2574] = {
    [sym_property_pattern_clause] = STATE(2681),
    [sym__variable_designation] = STATE(3820),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2574),
    [sym_preproc_endregion] = STATE(2574),
    [sym_preproc_line] = STATE(2574),
    [sym_preproc_pragma] = STATE(2574),
    [sym_preproc_nullable] = STATE(2574),
    [sym_preproc_error] = STATE(2574),
    [sym_preproc_warning] = STATE(2574),
    [sym_preproc_define] = STATE(2574),
    [sym_preproc_undef] = STATE(2574),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3929),
    [anon_sym_descending] = ACTIONS(3929),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2575] = {
    [sym_property_pattern_clause] = STATE(2683),
    [sym__variable_designation] = STATE(3832),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2575),
    [sym_preproc_endregion] = STATE(2575),
    [sym_preproc_line] = STATE(2575),
    [sym_preproc_pragma] = STATE(2575),
    [sym_preproc_nullable] = STATE(2575),
    [sym_preproc_error] = STATE(2575),
    [sym_preproc_warning] = STATE(2575),
    [sym_preproc_define] = STATE(2575),
    [sym_preproc_undef] = STATE(2575),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3933),
    [anon_sym_descending] = ACTIONS(3933),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2576] = {
    [sym_type_argument_list] = STATE(2419),
    [sym_preproc_region] = STATE(2576),
    [sym_preproc_endregion] = STATE(2576),
    [sym_preproc_line] = STATE(2576),
    [sym_preproc_pragma] = STATE(2576),
    [sym_preproc_nullable] = STATE(2576),
    [sym_preproc_error] = STATE(2576),
    [sym_preproc_warning] = STATE(2576),
    [sym_preproc_define] = STATE(2576),
    [sym_preproc_undef] = STATE(2576),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2577] = {
    [sym_property_pattern_clause] = STATE(2628),
    [sym__variable_designation] = STATE(3820),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2577),
    [sym_preproc_endregion] = STATE(2577),
    [sym_preproc_line] = STATE(2577),
    [sym_preproc_pragma] = STATE(2577),
    [sym_preproc_nullable] = STATE(2577),
    [sym_preproc_error] = STATE(2577),
    [sym_preproc_warning] = STATE(2577),
    [sym_preproc_define] = STATE(2577),
    [sym_preproc_undef] = STATE(2577),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3929),
    [anon_sym_descending] = ACTIONS(3929),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2578] = {
    [sym_property_pattern_clause] = STATE(2632),
    [sym__variable_designation] = STATE(3554),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2578),
    [sym_preproc_endregion] = STATE(2578),
    [sym_preproc_line] = STATE(2578),
    [sym_preproc_pragma] = STATE(2578),
    [sym_preproc_nullable] = STATE(2578),
    [sym_preproc_error] = STATE(2578),
    [sym_preproc_warning] = STATE(2578),
    [sym_preproc_define] = STATE(2578),
    [sym_preproc_undef] = STATE(2578),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2579] = {
    [sym__variable_designation] = STATE(4819),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2579),
    [sym_preproc_endregion] = STATE(2579),
    [sym_preproc_line] = STATE(2579),
    [sym_preproc_pragma] = STATE(2579),
    [sym_preproc_nullable] = STATE(2579),
    [sym_preproc_error] = STATE(2579),
    [sym_preproc_warning] = STATE(2579),
    [sym_preproc_define] = STATE(2579),
    [sym_preproc_undef] = STATE(2579),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3927),
  },
  [2580] = {
    [sym__variable_designation] = STATE(4869),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2580),
    [sym_preproc_endregion] = STATE(2580),
    [sym_preproc_line] = STATE(2580),
    [sym_preproc_pragma] = STATE(2580),
    [sym_preproc_nullable] = STATE(2580),
    [sym_preproc_error] = STATE(2580),
    [sym_preproc_warning] = STATE(2580),
    [sym_preproc_define] = STATE(2580),
    [sym_preproc_undef] = STATE(2580),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(4281),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3981),
  },
  [2581] = {
    [sym_modifier] = STATE(3740),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6144),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(2581),
    [sym_preproc_endregion] = STATE(2581),
    [sym_preproc_line] = STATE(2581),
    [sym_preproc_pragma] = STATE(2581),
    [sym_preproc_nullable] = STATE(2581),
    [sym_preproc_error] = STATE(2581),
    [sym_preproc_warning] = STATE(2581),
    [sym_preproc_define] = STATE(2581),
    [sym_preproc_undef] = STATE(2581),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(645),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_unsafe] = ACTIONS(645),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_const] = ACTIONS(645),
    [anon_sym_file] = ACTIONS(4283),
    [anon_sym_fixed] = ACTIONS(645),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(645),
    [anon_sym_override] = ACTIONS(645),
    [anon_sym_partial] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(645),
    [anon_sym_public] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_required] = ACTIONS(645),
    [anon_sym_sealed] = ACTIONS(645),
    [anon_sym_virtual] = ACTIONS(645),
    [anon_sym_volatile] = ACTIONS(645),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2582] = {
    [sym_property_pattern_clause] = STATE(2624),
    [sym__variable_designation] = STATE(3533),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2582),
    [sym_preproc_endregion] = STATE(2582),
    [sym_preproc_line] = STATE(2582),
    [sym_preproc_pragma] = STATE(2582),
    [sym_preproc_nullable] = STATE(2582),
    [sym_preproc_error] = STATE(2582),
    [sym_preproc_warning] = STATE(2582),
    [sym_preproc_define] = STATE(2582),
    [sym_preproc_undef] = STATE(2582),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_in] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2583] = {
    [sym__variable_designation] = STATE(4819),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2583),
    [sym_preproc_endregion] = STATE(2583),
    [sym_preproc_line] = STATE(2583),
    [sym_preproc_pragma] = STATE(2583),
    [sym_preproc_nullable] = STATE(2583),
    [sym_preproc_error] = STATE(2583),
    [sym_preproc_warning] = STATE(2583),
    [sym_preproc_define] = STATE(2583),
    [sym_preproc_undef] = STATE(2583),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3927),
  },
  [2584] = {
    [sym__variable_designation] = STATE(4861),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2584),
    [sym_preproc_endregion] = STATE(2584),
    [sym_preproc_line] = STATE(2584),
    [sym_preproc_pragma] = STATE(2584),
    [sym_preproc_nullable] = STATE(2584),
    [sym_preproc_error] = STATE(2584),
    [sym_preproc_warning] = STATE(2584),
    [sym_preproc_define] = STATE(2584),
    [sym_preproc_undef] = STATE(2584),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3931),
  },
  [2585] = {
    [sym__variable_designation] = STATE(4868),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2585),
    [sym_preproc_endregion] = STATE(2585),
    [sym_preproc_line] = STATE(2585),
    [sym_preproc_pragma] = STATE(2585),
    [sym_preproc_nullable] = STATE(2585),
    [sym_preproc_error] = STATE(2585),
    [sym_preproc_warning] = STATE(2585),
    [sym_preproc_define] = STATE(2585),
    [sym_preproc_undef] = STATE(2585),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3997),
  },
  [2586] = {
    [sym__variable_designation] = STATE(4871),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2586),
    [sym_preproc_endregion] = STATE(2586),
    [sym_preproc_line] = STATE(2586),
    [sym_preproc_pragma] = STATE(2586),
    [sym_preproc_nullable] = STATE(2586),
    [sym_preproc_error] = STATE(2586),
    [sym_preproc_warning] = STATE(2586),
    [sym_preproc_define] = STATE(2586),
    [sym_preproc_undef] = STATE(2586),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4001),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4001),
  },
  [2587] = {
    [sym__variable_designation] = STATE(4882),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2587),
    [sym_preproc_endregion] = STATE(2587),
    [sym_preproc_line] = STATE(2587),
    [sym_preproc_pragma] = STATE(2587),
    [sym_preproc_nullable] = STATE(2587),
    [sym_preproc_error] = STATE(2587),
    [sym_preproc_warning] = STATE(2587),
    [sym_preproc_define] = STATE(2587),
    [sym_preproc_undef] = STATE(2587),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(4281),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3985),
  },
  [2588] = {
    [sym__variable_designation] = STATE(4856),
    [sym_parenthesized_variable_designation] = STATE(4814),
    [sym_identifier] = STATE(4816),
    [sym__reserved_identifier] = STATE(4318),
    [sym_preproc_region] = STATE(2588),
    [sym_preproc_endregion] = STATE(2588),
    [sym_preproc_line] = STATE(2588),
    [sym_preproc_pragma] = STATE(2588),
    [sym_preproc_nullable] = STATE(2588),
    [sym_preproc_error] = STATE(2588),
    [sym_preproc_warning] = STATE(2588),
    [sym_preproc_define] = STATE(2588),
    [sym_preproc_undef] = STATE(2588),
    [sym__identifier_token] = ACTIONS(4086),
    [anon_sym_alias] = ACTIONS(4088),
    [anon_sym_global] = ACTIONS(4088),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(4281),
    [anon_sym_file] = ACTIONS(4088),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(4088),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(4088),
    [anon_sym_unmanaged] = ACTIONS(4088),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(4088),
    [anon_sym_var] = ACTIONS(4088),
    [anon_sym_yield] = ACTIONS(4088),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(4088),
    [sym_discard] = ACTIONS(4092),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(4088),
    [anon_sym_into] = ACTIONS(4088),
    [anon_sym_join] = ACTIONS(4088),
    [anon_sym_on] = ACTIONS(4088),
    [anon_sym_equals] = ACTIONS(4088),
    [anon_sym_let] = ACTIONS(4088),
    [anon_sym_orderby] = ACTIONS(4088),
    [anon_sym_ascending] = ACTIONS(4088),
    [anon_sym_descending] = ACTIONS(4088),
    [anon_sym_group] = ACTIONS(4088),
    [anon_sym_by] = ACTIONS(4088),
    [anon_sym_select] = ACTIONS(4088),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3975),
  },
  [2589] = {
    [sym_property_pattern_clause] = STATE(2875),
    [sym__variable_designation] = STATE(3286),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2589),
    [sym_preproc_endregion] = STATE(2589),
    [sym_preproc_line] = STATE(2589),
    [sym_preproc_pragma] = STATE(2589),
    [sym_preproc_nullable] = STATE(2589),
    [sym_preproc_error] = STATE(2589),
    [sym_preproc_warning] = STATE(2589),
    [sym_preproc_define] = STATE(2589),
    [sym_preproc_undef] = STATE(2589),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2590] = {
    [sym_property_pattern_clause] = STATE(2834),
    [sym__variable_designation] = STATE(3554),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2590),
    [sym_preproc_endregion] = STATE(2590),
    [sym_preproc_line] = STATE(2590),
    [sym_preproc_pragma] = STATE(2590),
    [sym_preproc_nullable] = STATE(2590),
    [sym_preproc_error] = STATE(2590),
    [sym_preproc_warning] = STATE(2590),
    [sym_preproc_define] = STATE(2590),
    [sym_preproc_undef] = STATE(2590),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2591] = {
    [sym_property_pattern_clause] = STATE(2835),
    [sym__variable_designation] = STATE(3533),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2591),
    [sym_preproc_endregion] = STATE(2591),
    [sym_preproc_line] = STATE(2591),
    [sym_preproc_pragma] = STATE(2591),
    [sym_preproc_nullable] = STATE(2591),
    [sym_preproc_error] = STATE(2591),
    [sym_preproc_warning] = STATE(2591),
    [sym_preproc_define] = STATE(2591),
    [sym_preproc_undef] = STATE(2591),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2592] = {
    [sym_preproc_region] = STATE(2592),
    [sym_preproc_endregion] = STATE(2592),
    [sym_preproc_line] = STATE(2592),
    [sym_preproc_pragma] = STATE(2592),
    [sym_preproc_nullable] = STATE(2592),
    [sym_preproc_error] = STATE(2592),
    [sym_preproc_warning] = STATE(2592),
    [sym_preproc_define] = STATE(2592),
    [sym_preproc_undef] = STATE(2592),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3785),
    [anon_sym_delegate] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_var] = ACTIONS(3785),
    [sym_predefined_type] = ACTIONS(3785),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2593] = {
    [sym_preproc_region] = STATE(2593),
    [sym_preproc_endregion] = STATE(2593),
    [sym_preproc_line] = STATE(2593),
    [sym_preproc_pragma] = STATE(2593),
    [sym_preproc_nullable] = STATE(2593),
    [sym_preproc_error] = STATE(2593),
    [sym_preproc_warning] = STATE(2593),
    [sym_preproc_define] = STATE(2593),
    [sym_preproc_undef] = STATE(2593),
    [sym__identifier_token] = ACTIONS(4182),
    [anon_sym_alias] = ACTIONS(4182),
    [anon_sym_global] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_file] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_notnull] = ACTIONS(4182),
    [anon_sym_unmanaged] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_scoped] = ACTIONS(4182),
    [anon_sym_EQ_GT] = ACTIONS(4184),
    [anon_sym_var] = ACTIONS(4182),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_when] = ACTIONS(4182),
    [sym_discard] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(4182),
    [anon_sym_into] = ACTIONS(4182),
    [anon_sym_join] = ACTIONS(4182),
    [anon_sym_on] = ACTIONS(4182),
    [anon_sym_equals] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_orderby] = ACTIONS(4182),
    [anon_sym_ascending] = ACTIONS(4182),
    [anon_sym_descending] = ACTIONS(4182),
    [anon_sym_group] = ACTIONS(4182),
    [anon_sym_by] = ACTIONS(4182),
    [anon_sym_select] = ACTIONS(4182),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2594] = {
    [sym_property_pattern_clause] = STATE(2844),
    [sym__variable_designation] = STATE(3554),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2594),
    [sym_preproc_endregion] = STATE(2594),
    [sym_preproc_line] = STATE(2594),
    [sym_preproc_pragma] = STATE(2594),
    [sym_preproc_nullable] = STATE(2594),
    [sym_preproc_error] = STATE(2594),
    [sym_preproc_warning] = STATE(2594),
    [sym_preproc_define] = STATE(2594),
    [sym_preproc_undef] = STATE(2594),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3929),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2595] = {
    [sym_property_pattern_clause] = STATE(2705),
    [sym__variable_designation] = STATE(4217),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2595),
    [sym_preproc_endregion] = STATE(2595),
    [sym_preproc_line] = STATE(2595),
    [sym_preproc_pragma] = STATE(2595),
    [sym_preproc_nullable] = STATE(2595),
    [sym_preproc_error] = STATE(2595),
    [sym_preproc_warning] = STATE(2595),
    [sym_preproc_define] = STATE(2595),
    [sym_preproc_undef] = STATE(2595),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2596] = {
    [sym_property_pattern_clause] = STATE(2775),
    [sym__variable_designation] = STATE(3554),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2596),
    [sym_preproc_endregion] = STATE(2596),
    [sym_preproc_line] = STATE(2596),
    [sym_preproc_pragma] = STATE(2596),
    [sym_preproc_nullable] = STATE(2596),
    [sym_preproc_error] = STATE(2596),
    [sym_preproc_warning] = STATE(2596),
    [sym_preproc_define] = STATE(2596),
    [sym_preproc_undef] = STATE(2596),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3929),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2597] = {
    [sym_property_pattern_clause] = STATE(2845),
    [sym__variable_designation] = STATE(3533),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2597),
    [sym_preproc_endregion] = STATE(2597),
    [sym_preproc_line] = STATE(2597),
    [sym_preproc_pragma] = STATE(2597),
    [sym_preproc_nullable] = STATE(2597),
    [sym_preproc_error] = STATE(2597),
    [sym_preproc_warning] = STATE(2597),
    [sym_preproc_define] = STATE(2597),
    [sym_preproc_undef] = STATE(2597),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3933),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2598] = {
    [sym_property_pattern_clause] = STATE(2777),
    [sym__variable_designation] = STATE(3533),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2598),
    [sym_preproc_endregion] = STATE(2598),
    [sym_preproc_line] = STATE(2598),
    [sym_preproc_pragma] = STATE(2598),
    [sym_preproc_nullable] = STATE(2598),
    [sym_preproc_error] = STATE(2598),
    [sym_preproc_warning] = STATE(2598),
    [sym_preproc_define] = STATE(2598),
    [sym_preproc_undef] = STATE(2598),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3933),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2599] = {
    [sym_type_argument_list] = STATE(2627),
    [sym_preproc_region] = STATE(2599),
    [sym_preproc_endregion] = STATE(2599),
    [sym_preproc_line] = STATE(2599),
    [sym_preproc_pragma] = STATE(2599),
    [sym_preproc_nullable] = STATE(2599),
    [sym_preproc_error] = STATE(2599),
    [sym_preproc_warning] = STATE(2599),
    [sym_preproc_define] = STATE(2599),
    [sym_preproc_undef] = STATE(2599),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4285),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2600] = {
    [sym_property_pattern_clause] = STATE(2862),
    [sym__variable_designation] = STATE(3286),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2600),
    [sym_preproc_endregion] = STATE(2600),
    [sym_preproc_line] = STATE(2600),
    [sym_preproc_pragma] = STATE(2600),
    [sym_preproc_nullable] = STATE(2600),
    [sym_preproc_error] = STATE(2600),
    [sym_preproc_warning] = STATE(2600),
    [sym_preproc_define] = STATE(2600),
    [sym_preproc_undef] = STATE(2600),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3929),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2601] = {
    [sym_property_pattern_clause] = STATE(2863),
    [sym__variable_designation] = STATE(3391),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2601),
    [sym_preproc_endregion] = STATE(2601),
    [sym_preproc_line] = STATE(2601),
    [sym_preproc_pragma] = STATE(2601),
    [sym_preproc_nullable] = STATE(2601),
    [sym_preproc_error] = STATE(2601),
    [sym_preproc_warning] = STATE(2601),
    [sym_preproc_define] = STATE(2601),
    [sym_preproc_undef] = STATE(2601),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3933),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2602] = {
    [sym_type_argument_list] = STATE(2810),
    [sym_preproc_region] = STATE(2602),
    [sym_preproc_endregion] = STATE(2602),
    [sym_preproc_line] = STATE(2602),
    [sym_preproc_pragma] = STATE(2602),
    [sym_preproc_nullable] = STATE(2602),
    [sym_preproc_error] = STATE(2602),
    [sym_preproc_warning] = STATE(2602),
    [sym_preproc_define] = STATE(2602),
    [sym_preproc_undef] = STATE(2602),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2603] = {
    [sym_preproc_region] = STATE(2603),
    [sym_preproc_endregion] = STATE(2603),
    [sym_preproc_line] = STATE(2603),
    [sym_preproc_pragma] = STATE(2603),
    [sym_preproc_nullable] = STATE(2603),
    [sym_preproc_error] = STATE(2603),
    [sym_preproc_warning] = STATE(2603),
    [sym_preproc_define] = STATE(2603),
    [sym_preproc_undef] = STATE(2603),
    [sym__identifier_token] = ACTIONS(4219),
    [anon_sym_alias] = ACTIONS(4219),
    [anon_sym_global] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4221),
    [anon_sym_RBRACK] = ACTIONS(4221),
    [anon_sym_LPAREN] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4221),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_file] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_where] = ACTIONS(4219),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_notnull] = ACTIONS(4219),
    [anon_sym_unmanaged] = ACTIONS(4219),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_scoped] = ACTIONS(4219),
    [anon_sym_EQ_GT] = ACTIONS(4221),
    [anon_sym_var] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(4219),
    [anon_sym_switch] = ACTIONS(4293),
    [anon_sym_when] = ACTIONS(4219),
    [sym_discard] = ACTIONS(4219),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4219),
    [anon_sym_or] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_from] = ACTIONS(4219),
    [anon_sym_into] = ACTIONS(4219),
    [anon_sym_join] = ACTIONS(4219),
    [anon_sym_on] = ACTIONS(4219),
    [anon_sym_equals] = ACTIONS(4219),
    [anon_sym_let] = ACTIONS(4219),
    [anon_sym_orderby] = ACTIONS(4219),
    [anon_sym_ascending] = ACTIONS(4219),
    [anon_sym_descending] = ACTIONS(4219),
    [anon_sym_group] = ACTIONS(4219),
    [anon_sym_by] = ACTIONS(4219),
    [anon_sym_select] = ACTIONS(4219),
    [anon_sym_as] = ACTIONS(4293),
    [anon_sym_is] = ACTIONS(4293),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2604] = {
    [sym_preproc_region] = STATE(2604),
    [sym_preproc_endregion] = STATE(2604),
    [sym_preproc_line] = STATE(2604),
    [sym_preproc_pragma] = STATE(2604),
    [sym_preproc_nullable] = STATE(2604),
    [sym_preproc_error] = STATE(2604),
    [sym_preproc_warning] = STATE(2604),
    [sym_preproc_define] = STATE(2604),
    [sym_preproc_undef] = STATE(2604),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2605] = {
    [sym_preproc_region] = STATE(2605),
    [sym_preproc_endregion] = STATE(2605),
    [sym_preproc_line] = STATE(2605),
    [sym_preproc_pragma] = STATE(2605),
    [sym_preproc_nullable] = STATE(2605),
    [sym_preproc_error] = STATE(2605),
    [sym_preproc_warning] = STATE(2605),
    [sym_preproc_define] = STATE(2605),
    [sym_preproc_undef] = STATE(2605),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_event] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_ref] = ACTIONS(3255),
    [anon_sym_struct] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_delegate] = ACTIONS(3255),
    [anon_sym_record] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3257),
    [anon_sym_implicit] = ACTIONS(3255),
    [anon_sym_explicit] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [sym_predefined_type] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_if_token3] = ACTIONS(3257),
    [aux_sym_preproc_else_token1] = ACTIONS(3257),
    [aux_sym_preproc_elif_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2606] = {
    [sym__variable_designation] = STATE(3534),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2606),
    [sym_preproc_endregion] = STATE(2606),
    [sym_preproc_line] = STATE(2606),
    [sym_preproc_pragma] = STATE(2606),
    [sym_preproc_nullable] = STATE(2606),
    [sym_preproc_error] = STATE(2606),
    [sym_preproc_warning] = STATE(2606),
    [sym_preproc_define] = STATE(2606),
    [sym_preproc_undef] = STATE(2606),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3933),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2607] = {
    [sym__variable_designation] = STATE(3536),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2607),
    [sym_preproc_endregion] = STATE(2607),
    [sym_preproc_line] = STATE(2607),
    [sym_preproc_pragma] = STATE(2607),
    [sym_preproc_nullable] = STATE(2607),
    [sym_preproc_error] = STATE(2607),
    [sym_preproc_warning] = STATE(2607),
    [sym_preproc_define] = STATE(2607),
    [sym_preproc_undef] = STATE(2607),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3997),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3999),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2608] = {
    [sym__variable_designation] = STATE(3403),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2608),
    [sym_preproc_endregion] = STATE(2608),
    [sym_preproc_line] = STATE(2608),
    [sym_preproc_pragma] = STATE(2608),
    [sym_preproc_nullable] = STATE(2608),
    [sym_preproc_error] = STATE(2608),
    [sym_preproc_warning] = STATE(2608),
    [sym_preproc_define] = STATE(2608),
    [sym_preproc_undef] = STATE(2608),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(4001),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(4003),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2609] = {
    [sym__variable_designation] = STATE(3331),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2609),
    [sym_preproc_endregion] = STATE(2609),
    [sym_preproc_line] = STATE(2609),
    [sym_preproc_pragma] = STATE(2609),
    [sym_preproc_nullable] = STATE(2609),
    [sym_preproc_error] = STATE(2609),
    [sym_preproc_warning] = STATE(2609),
    [sym_preproc_define] = STATE(2609),
    [sym_preproc_undef] = STATE(2609),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3929),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2610] = {
    [sym_property_pattern_clause] = STATE(2699),
    [sym__variable_designation] = STATE(4209),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2610),
    [sym_preproc_endregion] = STATE(2610),
    [sym_preproc_line] = STATE(2610),
    [sym_preproc_pragma] = STATE(2610),
    [sym_preproc_nullable] = STATE(2610),
    [sym_preproc_error] = STATE(2610),
    [sym_preproc_warning] = STATE(2610),
    [sym_preproc_define] = STATE(2610),
    [sym_preproc_undef] = STATE(2610),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2611] = {
    [sym__variable_designation] = STATE(3268),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2611),
    [sym_preproc_endregion] = STATE(2611),
    [sym_preproc_line] = STATE(2611),
    [sym_preproc_pragma] = STATE(2611),
    [sym_preproc_nullable] = STATE(2611),
    [sym_preproc_error] = STATE(2611),
    [sym_preproc_warning] = STATE(2611),
    [sym_preproc_define] = STATE(2611),
    [sym_preproc_undef] = STATE(2611),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3931),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3933),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2612] = {
    [sym__variable_designation] = STATE(3282),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2612),
    [sym_preproc_endregion] = STATE(2612),
    [sym_preproc_line] = STATE(2612),
    [sym_preproc_pragma] = STATE(2612),
    [sym_preproc_nullable] = STATE(2612),
    [sym_preproc_error] = STATE(2612),
    [sym_preproc_warning] = STATE(2612),
    [sym_preproc_define] = STATE(2612),
    [sym_preproc_undef] = STATE(2612),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3997),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3999),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2613] = {
    [sym__variable_designation] = STATE(3297),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2613),
    [sym_preproc_endregion] = STATE(2613),
    [sym_preproc_line] = STATE(2613),
    [sym_preproc_pragma] = STATE(2613),
    [sym_preproc_nullable] = STATE(2613),
    [sym_preproc_error] = STATE(2613),
    [sym_preproc_warning] = STATE(2613),
    [sym_preproc_define] = STATE(2613),
    [sym_preproc_undef] = STATE(2613),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(4001),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(4003),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2614] = {
    [sym_preproc_region] = STATE(2614),
    [sym_preproc_endregion] = STATE(2614),
    [sym_preproc_line] = STATE(2614),
    [sym_preproc_pragma] = STATE(2614),
    [sym_preproc_nullable] = STATE(2614),
    [sym_preproc_error] = STATE(2614),
    [sym_preproc_warning] = STATE(2614),
    [sym_preproc_define] = STATE(2614),
    [sym_preproc_undef] = STATE(2614),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_using] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3265),
    [anon_sym_event] = ACTIONS(3263),
    [anon_sym_namespace] = ACTIONS(3263),
    [anon_sym_class] = ACTIONS(3263),
    [anon_sym_ref] = ACTIONS(3263),
    [anon_sym_struct] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_interface] = ACTIONS(3263),
    [anon_sym_delegate] = ACTIONS(3263),
    [anon_sym_record] = ACTIONS(3263),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3265),
    [anon_sym_implicit] = ACTIONS(3263),
    [anon_sym_explicit] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [sym_predefined_type] = ACTIONS(3263),
    [anon_sym_while] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_else] = ACTIONS(3263),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_if_token3] = ACTIONS(3265),
    [aux_sym_preproc_else_token1] = ACTIONS(3265),
    [aux_sym_preproc_elif_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2615] = {
    [sym_property_pattern_clause] = STATE(2876),
    [sym__variable_designation] = STATE(3391),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2615),
    [sym_preproc_endregion] = STATE(2615),
    [sym_preproc_line] = STATE(2615),
    [sym_preproc_pragma] = STATE(2615),
    [sym_preproc_nullable] = STATE(2615),
    [sym_preproc_error] = STATE(2615),
    [sym_preproc_warning] = STATE(2615),
    [sym_preproc_define] = STATE(2615),
    [sym_preproc_undef] = STATE(2615),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2616] = {
    [sym_preproc_region] = STATE(2616),
    [sym_preproc_endregion] = STATE(2616),
    [sym_preproc_line] = STATE(2616),
    [sym_preproc_pragma] = STATE(2616),
    [sym_preproc_nullable] = STATE(2616),
    [sym_preproc_error] = STATE(2616),
    [sym_preproc_warning] = STATE(2616),
    [sym_preproc_define] = STATE(2616),
    [sym_preproc_undef] = STATE(2616),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3664),
    [anon_sym_where] = ACTIONS(3664),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_when] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3664),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2617] = {
    [sym_preproc_region] = STATE(2617),
    [sym_preproc_endregion] = STATE(2617),
    [sym_preproc_line] = STATE(2617),
    [sym_preproc_pragma] = STATE(2617),
    [sym_preproc_nullable] = STATE(2617),
    [sym_preproc_error] = STATE(2617),
    [sym_preproc_warning] = STATE(2617),
    [sym_preproc_define] = STATE(2617),
    [sym_preproc_undef] = STATE(2617),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_using] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3253),
    [anon_sym_event] = ACTIONS(3251),
    [anon_sym_namespace] = ACTIONS(3251),
    [anon_sym_class] = ACTIONS(3251),
    [anon_sym_ref] = ACTIONS(3251),
    [anon_sym_struct] = ACTIONS(3251),
    [anon_sym_enum] = ACTIONS(3251),
    [anon_sym_RBRACE] = ACTIONS(3253),
    [anon_sym_interface] = ACTIONS(3251),
    [anon_sym_delegate] = ACTIONS(3251),
    [anon_sym_record] = ACTIONS(3251),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_TILDE] = ACTIONS(3253),
    [anon_sym_implicit] = ACTIONS(3251),
    [anon_sym_explicit] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [sym_predefined_type] = ACTIONS(3251),
    [anon_sym_while] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_else] = ACTIONS(3251),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_if_token3] = ACTIONS(3253),
    [aux_sym_preproc_else_token1] = ACTIONS(3253),
    [aux_sym_preproc_elif_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2618] = {
    [sym_property_pattern_clause] = STATE(2880),
    [sym__variable_designation] = STATE(3286),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2618),
    [sym_preproc_endregion] = STATE(2618),
    [sym_preproc_line] = STATE(2618),
    [sym_preproc_pragma] = STATE(2618),
    [sym_preproc_nullable] = STATE(2618),
    [sym_preproc_error] = STATE(2618),
    [sym_preproc_warning] = STATE(2618),
    [sym_preproc_define] = STATE(2618),
    [sym_preproc_undef] = STATE(2618),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3929),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2619] = {
    [sym_property_pattern_clause] = STATE(2824),
    [sym__variable_designation] = STATE(4209),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2619),
    [sym_preproc_endregion] = STATE(2619),
    [sym_preproc_line] = STATE(2619),
    [sym_preproc_pragma] = STATE(2619),
    [sym_preproc_nullable] = STATE(2619),
    [sym_preproc_error] = STATE(2619),
    [sym_preproc_warning] = STATE(2619),
    [sym_preproc_define] = STATE(2619),
    [sym_preproc_undef] = STATE(2619),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2620] = {
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(3391),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2620),
    [sym_preproc_endregion] = STATE(2620),
    [sym_preproc_line] = STATE(2620),
    [sym_preproc_pragma] = STATE(2620),
    [sym_preproc_nullable] = STATE(2620),
    [sym_preproc_error] = STATE(2620),
    [sym_preproc_warning] = STATE(2620),
    [sym_preproc_define] = STATE(2620),
    [sym_preproc_undef] = STATE(2620),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3933),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2621] = {
    [sym_property_pattern_clause] = STATE(2825),
    [sym__variable_designation] = STATE(4217),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2621),
    [sym_preproc_endregion] = STATE(2621),
    [sym_preproc_line] = STATE(2621),
    [sym_preproc_pragma] = STATE(2621),
    [sym_preproc_nullable] = STATE(2621),
    [sym_preproc_error] = STATE(2621),
    [sym_preproc_warning] = STATE(2621),
    [sym_preproc_define] = STATE(2621),
    [sym_preproc_undef] = STATE(2621),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2622] = {
    [sym__variable_designation] = STATE(3555),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2622),
    [sym_preproc_endregion] = STATE(2622),
    [sym_preproc_line] = STATE(2622),
    [sym_preproc_pragma] = STATE(2622),
    [sym_preproc_nullable] = STATE(2622),
    [sym_preproc_error] = STATE(2622),
    [sym_preproc_warning] = STATE(2622),
    [sym_preproc_define] = STATE(2622),
    [sym_preproc_undef] = STATE(2622),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_EQ_GT] = ACTIONS(3927),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3929),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2623] = {
    [sym_preproc_region] = STATE(2623),
    [sym_preproc_endregion] = STATE(2623),
    [sym_preproc_line] = STATE(2623),
    [sym_preproc_pragma] = STATE(2623),
    [sym_preproc_nullable] = STATE(2623),
    [sym_preproc_error] = STATE(2623),
    [sym_preproc_warning] = STATE(2623),
    [sym_preproc_define] = STATE(2623),
    [sym_preproc_undef] = STATE(2623),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_when] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_PLUS_EQ] = ACTIONS(3676),
    [anon_sym_DASH_EQ] = ACTIONS(3676),
    [anon_sym_STAR_EQ] = ACTIONS(3676),
    [anon_sym_SLASH_EQ] = ACTIONS(3676),
    [anon_sym_PERCENT_EQ] = ACTIONS(3676),
    [anon_sym_AMP_EQ] = ACTIONS(3676),
    [anon_sym_CARET_EQ] = ACTIONS(3676),
    [anon_sym_PIPE_EQ] = ACTIONS(3676),
    [anon_sym_LT_LT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3674),
    [anon_sym_into] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2624] = {
    [sym__variable_designation] = STATE(3403),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2624),
    [sym_preproc_endregion] = STATE(2624),
    [sym_preproc_line] = STATE(2624),
    [sym_preproc_pragma] = STATE(2624),
    [sym_preproc_nullable] = STATE(2624),
    [sym_preproc_error] = STATE(2624),
    [sym_preproc_warning] = STATE(2624),
    [sym_preproc_define] = STATE(2624),
    [sym_preproc_undef] = STATE(2624),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_in] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2625] = {
    [sym_preproc_region] = STATE(2625),
    [sym_preproc_endregion] = STATE(2625),
    [sym_preproc_line] = STATE(2625),
    [sym_preproc_pragma] = STATE(2625),
    [sym_preproc_nullable] = STATE(2625),
    [sym_preproc_error] = STATE(2625),
    [sym_preproc_warning] = STATE(2625),
    [sym_preproc_define] = STATE(2625),
    [sym_preproc_undef] = STATE(2625),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_RBRACK] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_in] = ACTIONS(4188),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_GT_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_EQ_GT] = ACTIONS(4190),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4190),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK] = ACTIONS(4188),
    [anon_sym_into] = ACTIONS(4190),
    [anon_sym_on] = ACTIONS(4190),
    [anon_sym_equals] = ACTIONS(4190),
    [anon_sym_by] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_if_token3] = ACTIONS(4190),
    [aux_sym_preproc_else_token1] = ACTIONS(4190),
    [aux_sym_preproc_elif_token1] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2626] = {
    [sym_preproc_region] = STATE(2626),
    [sym_preproc_endregion] = STATE(2626),
    [sym_preproc_line] = STATE(2626),
    [sym_preproc_pragma] = STATE(2626),
    [sym_preproc_nullable] = STATE(2626),
    [sym_preproc_error] = STATE(2626),
    [sym_preproc_warning] = STATE(2626),
    [sym_preproc_define] = STATE(2626),
    [sym_preproc_undef] = STATE(2626),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2627] = {
    [sym_preproc_region] = STATE(2627),
    [sym_preproc_endregion] = STATE(2627),
    [sym_preproc_line] = STATE(2627),
    [sym_preproc_pragma] = STATE(2627),
    [sym_preproc_nullable] = STATE(2627),
    [sym_preproc_error] = STATE(2627),
    [sym_preproc_warning] = STATE(2627),
    [sym_preproc_define] = STATE(2627),
    [sym_preproc_undef] = STATE(2627),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3666),
    [anon_sym_CARET] = ACTIONS(3666),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3666),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3666),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_when] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3668),
    [anon_sym_PLUS_EQ] = ACTIONS(3668),
    [anon_sym_DASH_EQ] = ACTIONS(3668),
    [anon_sym_STAR_EQ] = ACTIONS(3668),
    [anon_sym_SLASH_EQ] = ACTIONS(3668),
    [anon_sym_PERCENT_EQ] = ACTIONS(3668),
    [anon_sym_AMP_EQ] = ACTIONS(3668),
    [anon_sym_CARET_EQ] = ACTIONS(3668),
    [anon_sym_PIPE_EQ] = ACTIONS(3668),
    [anon_sym_LT_LT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3666),
    [anon_sym_into] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2628] = {
    [sym__variable_designation] = STATE(3836),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2628),
    [sym_preproc_endregion] = STATE(2628),
    [sym_preproc_line] = STATE(2628),
    [sym_preproc_pragma] = STATE(2628),
    [sym_preproc_nullable] = STATE(2628),
    [sym_preproc_error] = STATE(2628),
    [sym_preproc_warning] = STATE(2628),
    [sym_preproc_define] = STATE(2628),
    [sym_preproc_undef] = STATE(2628),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3999),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3999),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3999),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3999),
    [anon_sym_orderby] = ACTIONS(3999),
    [anon_sym_ascending] = ACTIONS(3999),
    [anon_sym_descending] = ACTIONS(3999),
    [anon_sym_group] = ACTIONS(3999),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3999),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2629] = {
    [sym_preproc_region] = STATE(2629),
    [sym_preproc_endregion] = STATE(2629),
    [sym_preproc_line] = STATE(2629),
    [sym_preproc_pragma] = STATE(2629),
    [sym_preproc_nullable] = STATE(2629),
    [sym_preproc_error] = STATE(2629),
    [sym_preproc_warning] = STATE(2629),
    [sym_preproc_define] = STATE(2629),
    [sym_preproc_undef] = STATE(2629),
    [anon_sym_SEMI] = ACTIONS(4295),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4297),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(4300),
    [anon_sym_in] = ACTIONS(4303),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_BANG] = ACTIONS(4300),
    [anon_sym_PLUS_PLUS] = ACTIONS(4297),
    [anon_sym_DASH_DASH] = ACTIONS(4297),
    [anon_sym_PLUS] = ACTIONS(4300),
    [anon_sym_DASH] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_SLASH] = ACTIONS(4300),
    [anon_sym_PERCENT] = ACTIONS(4300),
    [anon_sym_CARET] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4300),
    [anon_sym_GT_GT] = ACTIONS(4300),
    [anon_sym_GT_GT_GT] = ACTIONS(4300),
    [anon_sym_EQ_EQ] = ACTIONS(4297),
    [anon_sym_BANG_EQ] = ACTIONS(4297),
    [anon_sym_GT_EQ] = ACTIONS(4297),
    [anon_sym_LT_EQ] = ACTIONS(4297),
    [anon_sym_DOT] = ACTIONS(4300),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(4297),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4297),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4297),
    [anon_sym_QMARK_QMARK] = ACTIONS(4300),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_on] = ACTIONS(4295),
    [anon_sym_equals] = ACTIONS(4295),
    [anon_sym_by] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(4297),
    [anon_sym_is] = ACTIONS(4297),
    [anon_sym_DASH_GT] = ACTIONS(4297),
    [anon_sym_with] = ACTIONS(4297),
    [aux_sym_preproc_if_token3] = ACTIONS(4295),
    [aux_sym_preproc_else_token1] = ACTIONS(4295),
    [aux_sym_preproc_elif_token1] = ACTIONS(4295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2630] = {
    [sym__variable_designation] = STATE(3493),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2630),
    [sym_preproc_endregion] = STATE(2630),
    [sym_preproc_line] = STATE(2630),
    [sym_preproc_pragma] = STATE(2630),
    [sym_preproc_nullable] = STATE(2630),
    [sym_preproc_error] = STATE(2630),
    [sym_preproc_warning] = STATE(2630),
    [sym_preproc_define] = STATE(2630),
    [sym_preproc_undef] = STATE(2630),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2631] = {
    [sym_preproc_region] = STATE(2631),
    [sym_preproc_endregion] = STATE(2631),
    [sym_preproc_line] = STATE(2631),
    [sym_preproc_pragma] = STATE(2631),
    [sym_preproc_nullable] = STATE(2631),
    [sym_preproc_error] = STATE(2631),
    [sym_preproc_warning] = STATE(2631),
    [sym_preproc_define] = STATE(2631),
    [sym_preproc_undef] = STATE(2631),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_RBRACK] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_in] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_GT_GT_GT] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_EQ_GT] = ACTIONS(4172),
    [anon_sym_switch] = ACTIONS(4172),
    [anon_sym_when] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4172),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK] = ACTIONS(4174),
    [anon_sym_into] = ACTIONS(4172),
    [anon_sym_on] = ACTIONS(4172),
    [anon_sym_equals] = ACTIONS(4172),
    [anon_sym_by] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4172),
    [anon_sym_is] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [anon_sym_with] = ACTIONS(4172),
    [aux_sym_preproc_if_token3] = ACTIONS(4172),
    [aux_sym_preproc_else_token1] = ACTIONS(4172),
    [aux_sym_preproc_elif_token1] = ACTIONS(4172),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2632] = {
    [sym__variable_designation] = STATE(3536),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2632),
    [sym_preproc_endregion] = STATE(2632),
    [sym_preproc_line] = STATE(2632),
    [sym_preproc_pragma] = STATE(2632),
    [sym_preproc_nullable] = STATE(2632),
    [sym_preproc_error] = STATE(2632),
    [sym_preproc_warning] = STATE(2632),
    [sym_preproc_define] = STATE(2632),
    [sym_preproc_undef] = STATE(2632),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_in] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2633] = {
    [sym_preproc_region] = STATE(2633),
    [sym_preproc_endregion] = STATE(2633),
    [sym_preproc_line] = STATE(2633),
    [sym_preproc_pragma] = STATE(2633),
    [sym_preproc_nullable] = STATE(2633),
    [sym_preproc_error] = STATE(2633),
    [sym_preproc_warning] = STATE(2633),
    [sym_preproc_define] = STATE(2633),
    [sym_preproc_undef] = STATE(2633),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_when] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3686),
    [anon_sym_PLUS_EQ] = ACTIONS(3686),
    [anon_sym_DASH_EQ] = ACTIONS(3686),
    [anon_sym_STAR_EQ] = ACTIONS(3686),
    [anon_sym_SLASH_EQ] = ACTIONS(3686),
    [anon_sym_PERCENT_EQ] = ACTIONS(3686),
    [anon_sym_AMP_EQ] = ACTIONS(3686),
    [anon_sym_CARET_EQ] = ACTIONS(3686),
    [anon_sym_PIPE_EQ] = ACTIONS(3686),
    [anon_sym_LT_LT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3684),
    [anon_sym_into] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2634] = {
    [sym_type_argument_list] = STATE(2870),
    [sym_preproc_region] = STATE(2634),
    [sym_preproc_endregion] = STATE(2634),
    [sym_preproc_line] = STATE(2634),
    [sym_preproc_pragma] = STATE(2634),
    [sym_preproc_nullable] = STATE(2634),
    [sym_preproc_error] = STATE(2634),
    [sym_preproc_warning] = STATE(2634),
    [sym_preproc_define] = STATE(2634),
    [sym_preproc_undef] = STATE(2634),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4305),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2635] = {
    [sym_preproc_region] = STATE(2635),
    [sym_preproc_endregion] = STATE(2635),
    [sym_preproc_line] = STATE(2635),
    [sym_preproc_pragma] = STATE(2635),
    [sym_preproc_nullable] = STATE(2635),
    [sym_preproc_error] = STATE(2635),
    [sym_preproc_warning] = STATE(2635),
    [sym_preproc_define] = STATE(2635),
    [sym_preproc_undef] = STATE(2635),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2636] = {
    [sym_preproc_region] = STATE(2636),
    [sym_preproc_endregion] = STATE(2636),
    [sym_preproc_line] = STATE(2636),
    [sym_preproc_pragma] = STATE(2636),
    [sym_preproc_nullable] = STATE(2636),
    [sym_preproc_error] = STATE(2636),
    [sym_preproc_warning] = STATE(2636),
    [sym_preproc_define] = STATE(2636),
    [sym_preproc_undef] = STATE(2636),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_when] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3672),
    [anon_sym_PLUS_EQ] = ACTIONS(3672),
    [anon_sym_DASH_EQ] = ACTIONS(3672),
    [anon_sym_STAR_EQ] = ACTIONS(3672),
    [anon_sym_SLASH_EQ] = ACTIONS(3672),
    [anon_sym_PERCENT_EQ] = ACTIONS(3672),
    [anon_sym_AMP_EQ] = ACTIONS(3672),
    [anon_sym_CARET_EQ] = ACTIONS(3672),
    [anon_sym_PIPE_EQ] = ACTIONS(3672),
    [anon_sym_LT_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2637] = {
    [sym_preproc_region] = STATE(2637),
    [sym_preproc_endregion] = STATE(2637),
    [sym_preproc_line] = STATE(2637),
    [sym_preproc_pragma] = STATE(2637),
    [sym_preproc_nullable] = STATE(2637),
    [sym_preproc_error] = STATE(2637),
    [sym_preproc_warning] = STATE(2637),
    [sym_preproc_define] = STATE(2637),
    [sym_preproc_undef] = STATE(2637),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4310),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2638] = {
    [sym_preproc_region] = STATE(2638),
    [sym_preproc_endregion] = STATE(2638),
    [sym_preproc_line] = STATE(2638),
    [sym_preproc_pragma] = STATE(2638),
    [sym_preproc_nullable] = STATE(2638),
    [sym_preproc_error] = STATE(2638),
    [sym_preproc_warning] = STATE(2638),
    [sym_preproc_define] = STATE(2638),
    [sym_preproc_undef] = STATE(2638),
    [anon_sym_SEMI] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4168),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_RBRACK] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_RPAREN] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4168),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_in] = ACTIONS(4168),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_SLASH] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_CARET] = ACTIONS(4170),
    [anon_sym_PIPE] = ACTIONS(4170),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_GT] = ACTIONS(4170),
    [anon_sym_GT_GT_GT] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4168),
    [anon_sym_BANG_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4168),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_when] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_and] = ACTIONS(4168),
    [anon_sym_or] = ACTIONS(4168),
    [anon_sym_PLUS_EQ] = ACTIONS(4168),
    [anon_sym_DASH_EQ] = ACTIONS(4168),
    [anon_sym_STAR_EQ] = ACTIONS(4168),
    [anon_sym_SLASH_EQ] = ACTIONS(4168),
    [anon_sym_PERCENT_EQ] = ACTIONS(4168),
    [anon_sym_AMP_EQ] = ACTIONS(4168),
    [anon_sym_CARET_EQ] = ACTIONS(4168),
    [anon_sym_PIPE_EQ] = ACTIONS(4168),
    [anon_sym_LT_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK] = ACTIONS(4170),
    [anon_sym_on] = ACTIONS(4168),
    [anon_sym_equals] = ACTIONS(4168),
    [anon_sym_by] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4168),
    [anon_sym_is] = ACTIONS(4168),
    [anon_sym_DASH_GT] = ACTIONS(4168),
    [anon_sym_with] = ACTIONS(4168),
    [aux_sym_preproc_if_token3] = ACTIONS(4168),
    [aux_sym_preproc_else_token1] = ACTIONS(4168),
    [aux_sym_preproc_elif_token1] = ACTIONS(4168),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2639] = {
    [sym_preproc_region] = STATE(2639),
    [sym_preproc_endregion] = STATE(2639),
    [sym_preproc_line] = STATE(2639),
    [sym_preproc_pragma] = STATE(2639),
    [sym_preproc_nullable] = STATE(2639),
    [sym_preproc_error] = STATE(2639),
    [sym_preproc_warning] = STATE(2639),
    [sym_preproc_define] = STATE(2639),
    [sym_preproc_undef] = STATE(2639),
    [sym__identifier_token] = ACTIONS(4312),
    [anon_sym_extern] = ACTIONS(4312),
    [anon_sym_alias] = ACTIONS(4312),
    [anon_sym_global] = ACTIONS(4312),
    [anon_sym_using] = ACTIONS(4312),
    [anon_sym_unsafe] = ACTIONS(4312),
    [anon_sym_EQ] = ACTIONS(4314),
    [anon_sym_static] = ACTIONS(4312),
    [anon_sym_LBRACK] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(4314),
    [anon_sym_event] = ACTIONS(4312),
    [anon_sym_namespace] = ACTIONS(4312),
    [anon_sym_class] = ACTIONS(4312),
    [anon_sym_ref] = ACTIONS(4312),
    [anon_sym_struct] = ACTIONS(4312),
    [anon_sym_enum] = ACTIONS(4312),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_interface] = ACTIONS(4312),
    [anon_sym_delegate] = ACTIONS(4312),
    [anon_sym_record] = ACTIONS(4312),
    [anon_sym_abstract] = ACTIONS(4312),
    [anon_sym_async] = ACTIONS(4312),
    [anon_sym_const] = ACTIONS(4312),
    [anon_sym_file] = ACTIONS(4312),
    [anon_sym_fixed] = ACTIONS(4312),
    [anon_sym_internal] = ACTIONS(4312),
    [anon_sym_new] = ACTIONS(4312),
    [anon_sym_override] = ACTIONS(4312),
    [anon_sym_partial] = ACTIONS(4312),
    [anon_sym_private] = ACTIONS(4312),
    [anon_sym_protected] = ACTIONS(4312),
    [anon_sym_public] = ACTIONS(4312),
    [anon_sym_readonly] = ACTIONS(4312),
    [anon_sym_required] = ACTIONS(4312),
    [anon_sym_sealed] = ACTIONS(4312),
    [anon_sym_virtual] = ACTIONS(4312),
    [anon_sym_volatile] = ACTIONS(4312),
    [anon_sym_where] = ACTIONS(4312),
    [anon_sym_notnull] = ACTIONS(4312),
    [anon_sym_unmanaged] = ACTIONS(4312),
    [anon_sym_TILDE] = ACTIONS(4314),
    [anon_sym_implicit] = ACTIONS(4312),
    [anon_sym_explicit] = ACTIONS(4312),
    [anon_sym_scoped] = ACTIONS(4312),
    [anon_sym_var] = ACTIONS(4312),
    [sym_predefined_type] = ACTIONS(4312),
    [anon_sym_yield] = ACTIONS(4312),
    [anon_sym_when] = ACTIONS(4312),
    [anon_sym_from] = ACTIONS(4312),
    [anon_sym_into] = ACTIONS(4312),
    [anon_sym_join] = ACTIONS(4312),
    [anon_sym_on] = ACTIONS(4312),
    [anon_sym_equals] = ACTIONS(4312),
    [anon_sym_let] = ACTIONS(4312),
    [anon_sym_orderby] = ACTIONS(4312),
    [anon_sym_ascending] = ACTIONS(4312),
    [anon_sym_descending] = ACTIONS(4312),
    [anon_sym_group] = ACTIONS(4312),
    [anon_sym_by] = ACTIONS(4312),
    [anon_sym_select] = ACTIONS(4312),
    [aux_sym_preproc_if_token1] = ACTIONS(4314),
    [aux_sym_preproc_if_token3] = ACTIONS(4314),
    [aux_sym_preproc_else_token1] = ACTIONS(4314),
    [aux_sym_preproc_elif_token1] = ACTIONS(4314),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2640] = {
    [sym__variable_designation] = STATE(3842),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2640),
    [sym_preproc_endregion] = STATE(2640),
    [sym_preproc_line] = STATE(2640),
    [sym_preproc_pragma] = STATE(2640),
    [sym_preproc_nullable] = STATE(2640),
    [sym_preproc_error] = STATE(2640),
    [sym_preproc_warning] = STATE(2640),
    [sym_preproc_define] = STATE(2640),
    [sym_preproc_undef] = STATE(2640),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(4316),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2641] = {
    [sym_preproc_region] = STATE(2641),
    [sym_preproc_endregion] = STATE(2641),
    [sym_preproc_line] = STATE(2641),
    [sym_preproc_pragma] = STATE(2641),
    [sym_preproc_nullable] = STATE(2641),
    [sym_preproc_error] = STATE(2641),
    [sym_preproc_warning] = STATE(2641),
    [sym_preproc_define] = STATE(2641),
    [sym_preproc_undef] = STATE(2641),
    [anon_sym_SEMI] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4168),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_RBRACK] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_RPAREN] = ACTIONS(4168),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_in] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_SLASH] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_CARET] = ACTIONS(4170),
    [anon_sym_PIPE] = ACTIONS(4170),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_GT] = ACTIONS(4170),
    [anon_sym_GT_GT_GT] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4168),
    [anon_sym_BANG_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4168),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_when] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_and] = ACTIONS(4168),
    [anon_sym_or] = ACTIONS(4168),
    [anon_sym_PLUS_EQ] = ACTIONS(4168),
    [anon_sym_DASH_EQ] = ACTIONS(4168),
    [anon_sym_STAR_EQ] = ACTIONS(4168),
    [anon_sym_SLASH_EQ] = ACTIONS(4168),
    [anon_sym_PERCENT_EQ] = ACTIONS(4168),
    [anon_sym_AMP_EQ] = ACTIONS(4168),
    [anon_sym_CARET_EQ] = ACTIONS(4168),
    [anon_sym_PIPE_EQ] = ACTIONS(4168),
    [anon_sym_LT_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4168),
    [anon_sym_on] = ACTIONS(4168),
    [anon_sym_equals] = ACTIONS(4168),
    [anon_sym_by] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4168),
    [anon_sym_is] = ACTIONS(4168),
    [anon_sym_DASH_GT] = ACTIONS(4168),
    [anon_sym_with] = ACTIONS(4168),
    [aux_sym_preproc_if_token3] = ACTIONS(4168),
    [aux_sym_preproc_else_token1] = ACTIONS(4168),
    [aux_sym_preproc_elif_token1] = ACTIONS(4168),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2642] = {
    [sym__variable_designation] = STATE(3845),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2642),
    [sym_preproc_endregion] = STATE(2642),
    [sym_preproc_line] = STATE(2642),
    [sym_preproc_pragma] = STATE(2642),
    [sym_preproc_nullable] = STATE(2642),
    [sym_preproc_error] = STATE(2642),
    [sym_preproc_warning] = STATE(2642),
    [sym_preproc_define] = STATE(2642),
    [sym_preproc_undef] = STATE(2642),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4003),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_orderby] = ACTIONS(4003),
    [anon_sym_ascending] = ACTIONS(4003),
    [anon_sym_descending] = ACTIONS(4003),
    [anon_sym_group] = ACTIONS(4003),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4003),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2643] = {
    [sym_preproc_region] = STATE(2643),
    [sym_preproc_endregion] = STATE(2643),
    [sym_preproc_line] = STATE(2643),
    [sym_preproc_pragma] = STATE(2643),
    [sym_preproc_nullable] = STATE(2643),
    [sym_preproc_error] = STATE(2643),
    [sym_preproc_warning] = STATE(2643),
    [sym_preproc_define] = STATE(2643),
    [sym_preproc_undef] = STATE(2643),
    [sym__identifier_token] = ACTIONS(4026),
    [anon_sym_alias] = ACTIONS(4026),
    [anon_sym_global] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_file] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_where] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_notnull] = ACTIONS(4026),
    [anon_sym_unmanaged] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_scoped] = ACTIONS(4026),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [anon_sym_switch] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(4026),
    [sym_discard] = ACTIONS(4026),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4026),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4026),
    [anon_sym_into] = ACTIONS(4026),
    [anon_sym_join] = ACTIONS(4026),
    [anon_sym_on] = ACTIONS(4026),
    [anon_sym_equals] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_orderby] = ACTIONS(4026),
    [anon_sym_ascending] = ACTIONS(4026),
    [anon_sym_descending] = ACTIONS(4026),
    [anon_sym_group] = ACTIONS(4026),
    [anon_sym_by] = ACTIONS(4026),
    [anon_sym_select] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4026),
    [anon_sym_is] = ACTIONS(4026),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4026),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2644] = {
    [sym_preproc_region] = STATE(2644),
    [sym_preproc_endregion] = STATE(2644),
    [sym_preproc_line] = STATE(2644),
    [sym_preproc_pragma] = STATE(2644),
    [sym_preproc_nullable] = STATE(2644),
    [sym_preproc_error] = STATE(2644),
    [sym_preproc_warning] = STATE(2644),
    [sym_preproc_define] = STATE(2644),
    [sym_preproc_undef] = STATE(2644),
    [sym__identifier_token] = ACTIONS(4127),
    [anon_sym_alias] = ACTIONS(4127),
    [anon_sym_global] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_COLON] = ACTIONS(4129),
    [anon_sym_COMMA] = ACTIONS(4129),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [anon_sym_file] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_where] = ACTIONS(4127),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_notnull] = ACTIONS(4127),
    [anon_sym_unmanaged] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_SLASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4129),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_LT_LT] = ACTIONS(4129),
    [anon_sym_GT_GT] = ACTIONS(4127),
    [anon_sym_GT_GT_GT] = ACTIONS(4129),
    [anon_sym_EQ_EQ] = ACTIONS(4129),
    [anon_sym_BANG_EQ] = ACTIONS(4129),
    [anon_sym_GT_EQ] = ACTIONS(4129),
    [anon_sym_LT_EQ] = ACTIONS(4129),
    [anon_sym_DOT] = ACTIONS(4127),
    [anon_sym_scoped] = ACTIONS(4127),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_var] = ACTIONS(4127),
    [anon_sym_yield] = ACTIONS(4127),
    [anon_sym_switch] = ACTIONS(4127),
    [anon_sym_when] = ACTIONS(4127),
    [sym_discard] = ACTIONS(4127),
    [anon_sym_DOT_DOT] = ACTIONS(4129),
    [anon_sym_and] = ACTIONS(4127),
    [anon_sym_or] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4129),
    [anon_sym_PIPE_PIPE] = ACTIONS(4129),
    [anon_sym_QMARK_QMARK] = ACTIONS(4129),
    [anon_sym_from] = ACTIONS(4127),
    [anon_sym_into] = ACTIONS(4127),
    [anon_sym_join] = ACTIONS(4127),
    [anon_sym_on] = ACTIONS(4127),
    [anon_sym_equals] = ACTIONS(4127),
    [anon_sym_let] = ACTIONS(4127),
    [anon_sym_orderby] = ACTIONS(4127),
    [anon_sym_ascending] = ACTIONS(4127),
    [anon_sym_descending] = ACTIONS(4127),
    [anon_sym_group] = ACTIONS(4127),
    [anon_sym_by] = ACTIONS(4127),
    [anon_sym_select] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4127),
    [anon_sym_is] = ACTIONS(4127),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [anon_sym_with] = ACTIONS(4127),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4129),
  },
  [2645] = {
    [sym_preproc_region] = STATE(2645),
    [sym_preproc_endregion] = STATE(2645),
    [sym_preproc_line] = STATE(2645),
    [sym_preproc_pragma] = STATE(2645),
    [sym_preproc_nullable] = STATE(2645),
    [sym_preproc_error] = STATE(2645),
    [sym_preproc_warning] = STATE(2645),
    [sym_preproc_define] = STATE(2645),
    [sym_preproc_undef] = STATE(2645),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_when] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3709),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_on] = ACTIONS(3709),
    [anon_sym_equals] = ACTIONS(3709),
    [anon_sym_by] = ACTIONS(3709),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_is] = ACTIONS(3709),
    [anon_sym_DASH_GT] = ACTIONS(3709),
    [anon_sym_with] = ACTIONS(3709),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2646] = {
    [sym_preproc_region] = STATE(2646),
    [sym_preproc_endregion] = STATE(2646),
    [sym_preproc_line] = STATE(2646),
    [sym_preproc_pragma] = STATE(2646),
    [sym_preproc_nullable] = STATE(2646),
    [sym_preproc_error] = STATE(2646),
    [sym_preproc_warning] = STATE(2646),
    [sym_preproc_define] = STATE(2646),
    [sym_preproc_undef] = STATE(2646),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4166),
    [anon_sym_in] = ACTIONS(4166),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_GT_GT_GT] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4164),
    [anon_sym_BANG_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK] = ACTIONS(4166),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_if_token3] = ACTIONS(4164),
    [aux_sym_preproc_else_token1] = ACTIONS(4164),
    [aux_sym_preproc_elif_token1] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2647] = {
    [sym_preproc_region] = STATE(2647),
    [sym_preproc_endregion] = STATE(2647),
    [sym_preproc_line] = STATE(2647),
    [sym_preproc_pragma] = STATE(2647),
    [sym_preproc_nullable] = STATE(2647),
    [sym_preproc_error] = STATE(2647),
    [sym_preproc_warning] = STATE(2647),
    [sym_preproc_define] = STATE(2647),
    [sym_preproc_undef] = STATE(2647),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2648] = {
    [sym_preproc_region] = STATE(2648),
    [sym_preproc_endregion] = STATE(2648),
    [sym_preproc_line] = STATE(2648),
    [sym_preproc_pragma] = STATE(2648),
    [sym_preproc_nullable] = STATE(2648),
    [sym_preproc_error] = STATE(2648),
    [sym_preproc_warning] = STATE(2648),
    [sym_preproc_define] = STATE(2648),
    [sym_preproc_undef] = STATE(2648),
    [anon_sym_SEMI] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4225),
    [anon_sym_RBRACK] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4225),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_in] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_PLUS_PLUS] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_EQ_GT] = ACTIONS(4225),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_when] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_PLUS_EQ] = ACTIONS(4225),
    [anon_sym_DASH_EQ] = ACTIONS(4225),
    [anon_sym_STAR_EQ] = ACTIONS(4225),
    [anon_sym_SLASH_EQ] = ACTIONS(4225),
    [anon_sym_PERCENT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4225),
    [anon_sym_CARET_EQ] = ACTIONS(4225),
    [anon_sym_PIPE_EQ] = ACTIONS(4225),
    [anon_sym_LT_LT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4225),
    [anon_sym_AMP_AMP] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4225),
    [anon_sym_on] = ACTIONS(4225),
    [anon_sym_equals] = ACTIONS(4225),
    [anon_sym_by] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4225),
    [anon_sym_is] = ACTIONS(4225),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_with] = ACTIONS(4225),
    [aux_sym_preproc_if_token3] = ACTIONS(4225),
    [aux_sym_preproc_else_token1] = ACTIONS(4225),
    [aux_sym_preproc_elif_token1] = ACTIONS(4225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2649] = {
    [sym_preproc_region] = STATE(2649),
    [sym_preproc_endregion] = STATE(2649),
    [sym_preproc_line] = STATE(2649),
    [sym_preproc_pragma] = STATE(2649),
    [sym_preproc_nullable] = STATE(2649),
    [sym_preproc_error] = STATE(2649),
    [sym_preproc_warning] = STATE(2649),
    [sym_preproc_define] = STATE(2649),
    [sym_preproc_undef] = STATE(2649),
    [sym__identifier_token] = ACTIONS(4318),
    [anon_sym_extern] = ACTIONS(4318),
    [anon_sym_alias] = ACTIONS(4318),
    [anon_sym_global] = ACTIONS(4318),
    [anon_sym_using] = ACTIONS(4318),
    [anon_sym_unsafe] = ACTIONS(4318),
    [anon_sym_EQ] = ACTIONS(4320),
    [anon_sym_static] = ACTIONS(4318),
    [anon_sym_LBRACK] = ACTIONS(4322),
    [anon_sym_LPAREN] = ACTIONS(4322),
    [anon_sym_event] = ACTIONS(4318),
    [anon_sym_namespace] = ACTIONS(4318),
    [anon_sym_class] = ACTIONS(4318),
    [anon_sym_ref] = ACTIONS(4318),
    [anon_sym_struct] = ACTIONS(4318),
    [anon_sym_enum] = ACTIONS(4318),
    [anon_sym_RBRACE] = ACTIONS(4322),
    [anon_sym_interface] = ACTIONS(4318),
    [anon_sym_delegate] = ACTIONS(4318),
    [anon_sym_record] = ACTIONS(4318),
    [anon_sym_abstract] = ACTIONS(4318),
    [anon_sym_async] = ACTIONS(4318),
    [anon_sym_const] = ACTIONS(4318),
    [anon_sym_file] = ACTIONS(4318),
    [anon_sym_fixed] = ACTIONS(4318),
    [anon_sym_internal] = ACTIONS(4318),
    [anon_sym_new] = ACTIONS(4318),
    [anon_sym_override] = ACTIONS(4318),
    [anon_sym_partial] = ACTIONS(4318),
    [anon_sym_private] = ACTIONS(4318),
    [anon_sym_protected] = ACTIONS(4318),
    [anon_sym_public] = ACTIONS(4318),
    [anon_sym_readonly] = ACTIONS(4318),
    [anon_sym_required] = ACTIONS(4318),
    [anon_sym_sealed] = ACTIONS(4318),
    [anon_sym_virtual] = ACTIONS(4318),
    [anon_sym_volatile] = ACTIONS(4318),
    [anon_sym_where] = ACTIONS(4318),
    [anon_sym_notnull] = ACTIONS(4318),
    [anon_sym_unmanaged] = ACTIONS(4318),
    [anon_sym_TILDE] = ACTIONS(4322),
    [anon_sym_implicit] = ACTIONS(4318),
    [anon_sym_explicit] = ACTIONS(4318),
    [anon_sym_scoped] = ACTIONS(4318),
    [anon_sym_var] = ACTIONS(4318),
    [sym_predefined_type] = ACTIONS(4318),
    [anon_sym_yield] = ACTIONS(4318),
    [anon_sym_when] = ACTIONS(4318),
    [anon_sym_from] = ACTIONS(4318),
    [anon_sym_into] = ACTIONS(4318),
    [anon_sym_join] = ACTIONS(4318),
    [anon_sym_on] = ACTIONS(4318),
    [anon_sym_equals] = ACTIONS(4318),
    [anon_sym_let] = ACTIONS(4318),
    [anon_sym_orderby] = ACTIONS(4318),
    [anon_sym_ascending] = ACTIONS(4318),
    [anon_sym_descending] = ACTIONS(4318),
    [anon_sym_group] = ACTIONS(4318),
    [anon_sym_by] = ACTIONS(4318),
    [anon_sym_select] = ACTIONS(4318),
    [aux_sym_preproc_if_token1] = ACTIONS(4322),
    [aux_sym_preproc_if_token3] = ACTIONS(4322),
    [aux_sym_preproc_else_token1] = ACTIONS(4322),
    [aux_sym_preproc_elif_token1] = ACTIONS(4322),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2650] = {
    [sym_preproc_region] = STATE(2650),
    [sym_preproc_endregion] = STATE(2650),
    [sym_preproc_line] = STATE(2650),
    [sym_preproc_pragma] = STATE(2650),
    [sym_preproc_nullable] = STATE(2650),
    [sym_preproc_error] = STATE(2650),
    [sym_preproc_warning] = STATE(2650),
    [sym_preproc_define] = STATE(2650),
    [sym_preproc_undef] = STATE(2650),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4324),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2651] = {
    [sym_preproc_region] = STATE(2651),
    [sym_preproc_endregion] = STATE(2651),
    [sym_preproc_line] = STATE(2651),
    [sym_preproc_pragma] = STATE(2651),
    [sym_preproc_nullable] = STATE(2651),
    [sym_preproc_error] = STATE(2651),
    [sym_preproc_warning] = STATE(2651),
    [sym_preproc_define] = STATE(2651),
    [sym_preproc_undef] = STATE(2651),
    [sym__identifier_token] = ACTIONS(4326),
    [anon_sym_extern] = ACTIONS(4326),
    [anon_sym_alias] = ACTIONS(4326),
    [anon_sym_global] = ACTIONS(4326),
    [anon_sym_using] = ACTIONS(4326),
    [anon_sym_unsafe] = ACTIONS(4326),
    [anon_sym_EQ] = ACTIONS(4328),
    [anon_sym_static] = ACTIONS(4326),
    [anon_sym_LBRACK] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4330),
    [anon_sym_event] = ACTIONS(4326),
    [anon_sym_namespace] = ACTIONS(4326),
    [anon_sym_class] = ACTIONS(4326),
    [anon_sym_ref] = ACTIONS(4326),
    [anon_sym_struct] = ACTIONS(4326),
    [anon_sym_enum] = ACTIONS(4326),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_interface] = ACTIONS(4326),
    [anon_sym_delegate] = ACTIONS(4326),
    [anon_sym_record] = ACTIONS(4326),
    [anon_sym_abstract] = ACTIONS(4326),
    [anon_sym_async] = ACTIONS(4326),
    [anon_sym_const] = ACTIONS(4326),
    [anon_sym_file] = ACTIONS(4326),
    [anon_sym_fixed] = ACTIONS(4326),
    [anon_sym_internal] = ACTIONS(4326),
    [anon_sym_new] = ACTIONS(4326),
    [anon_sym_override] = ACTIONS(4326),
    [anon_sym_partial] = ACTIONS(4326),
    [anon_sym_private] = ACTIONS(4326),
    [anon_sym_protected] = ACTIONS(4326),
    [anon_sym_public] = ACTIONS(4326),
    [anon_sym_readonly] = ACTIONS(4326),
    [anon_sym_required] = ACTIONS(4326),
    [anon_sym_sealed] = ACTIONS(4326),
    [anon_sym_virtual] = ACTIONS(4326),
    [anon_sym_volatile] = ACTIONS(4326),
    [anon_sym_where] = ACTIONS(4326),
    [anon_sym_notnull] = ACTIONS(4326),
    [anon_sym_unmanaged] = ACTIONS(4326),
    [anon_sym_TILDE] = ACTIONS(4330),
    [anon_sym_implicit] = ACTIONS(4326),
    [anon_sym_explicit] = ACTIONS(4326),
    [anon_sym_scoped] = ACTIONS(4326),
    [anon_sym_var] = ACTIONS(4326),
    [sym_predefined_type] = ACTIONS(4326),
    [anon_sym_yield] = ACTIONS(4326),
    [anon_sym_when] = ACTIONS(4326),
    [anon_sym_from] = ACTIONS(4326),
    [anon_sym_into] = ACTIONS(4326),
    [anon_sym_join] = ACTIONS(4326),
    [anon_sym_on] = ACTIONS(4326),
    [anon_sym_equals] = ACTIONS(4326),
    [anon_sym_let] = ACTIONS(4326),
    [anon_sym_orderby] = ACTIONS(4326),
    [anon_sym_ascending] = ACTIONS(4326),
    [anon_sym_descending] = ACTIONS(4326),
    [anon_sym_group] = ACTIONS(4326),
    [anon_sym_by] = ACTIONS(4326),
    [anon_sym_select] = ACTIONS(4326),
    [aux_sym_preproc_if_token1] = ACTIONS(4330),
    [aux_sym_preproc_if_token3] = ACTIONS(4330),
    [aux_sym_preproc_else_token1] = ACTIONS(4330),
    [aux_sym_preproc_elif_token1] = ACTIONS(4330),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2652] = {
    [sym_preproc_region] = STATE(2652),
    [sym_preproc_endregion] = STATE(2652),
    [sym_preproc_line] = STATE(2652),
    [sym_preproc_pragma] = STATE(2652),
    [sym_preproc_nullable] = STATE(2652),
    [sym_preproc_error] = STATE(2652),
    [sym_preproc_warning] = STATE(2652),
    [sym_preproc_define] = STATE(2652),
    [sym_preproc_undef] = STATE(2652),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3664),
  },
  [2653] = {
    [sym_preproc_region] = STATE(2653),
    [sym_preproc_endregion] = STATE(2653),
    [sym_preproc_line] = STATE(2653),
    [sym_preproc_pragma] = STATE(2653),
    [sym_preproc_nullable] = STATE(2653),
    [sym_preproc_error] = STATE(2653),
    [sym_preproc_warning] = STATE(2653),
    [sym_preproc_define] = STATE(2653),
    [sym_preproc_undef] = STATE(2653),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_in] = ACTIONS(4192),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_EQ_GT] = ACTIONS(4186),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_when] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_into] = ACTIONS(4186),
    [anon_sym_on] = ACTIONS(4186),
    [anon_sym_equals] = ACTIONS(4186),
    [anon_sym_by] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_if_token3] = ACTIONS(4186),
    [aux_sym_preproc_else_token1] = ACTIONS(4186),
    [aux_sym_preproc_elif_token1] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2654] = {
    [sym__variable_designation] = STATE(3821),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2654),
    [sym_preproc_endregion] = STATE(2654),
    [sym_preproc_line] = STATE(2654),
    [sym_preproc_pragma] = STATE(2654),
    [sym_preproc_nullable] = STATE(2654),
    [sym_preproc_error] = STATE(2654),
    [sym_preproc_warning] = STATE(2654),
    [sym_preproc_define] = STATE(2654),
    [sym_preproc_undef] = STATE(2654),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3929),
    [anon_sym_descending] = ACTIONS(3929),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2655] = {
    [sym_preproc_region] = STATE(2655),
    [sym_preproc_endregion] = STATE(2655),
    [sym_preproc_line] = STATE(2655),
    [sym_preproc_pragma] = STATE(2655),
    [sym_preproc_nullable] = STATE(2655),
    [sym_preproc_error] = STATE(2655),
    [sym_preproc_warning] = STATE(2655),
    [sym_preproc_define] = STATE(2655),
    [sym_preproc_undef] = STATE(2655),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_EQ] = ACTIONS(4235),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_COLON] = ACTIONS(4233),
    [anon_sym_COMMA] = ACTIONS(4233),
    [anon_sym_RBRACK] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4233),
    [anon_sym_RPAREN] = ACTIONS(4233),
    [anon_sym_RBRACE] = ACTIONS(4233),
    [anon_sym_LT] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4235),
    [anon_sym_in] = ACTIONS(4235),
    [anon_sym_QMARK] = ACTIONS(4235),
    [anon_sym_BANG] = ACTIONS(4235),
    [anon_sym_PLUS_PLUS] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4235),
    [anon_sym_DASH] = ACTIONS(4235),
    [anon_sym_STAR] = ACTIONS(4235),
    [anon_sym_SLASH] = ACTIONS(4235),
    [anon_sym_PERCENT] = ACTIONS(4235),
    [anon_sym_CARET] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4235),
    [anon_sym_LT_LT] = ACTIONS(4235),
    [anon_sym_GT_GT] = ACTIONS(4235),
    [anon_sym_GT_GT_GT] = ACTIONS(4235),
    [anon_sym_EQ_EQ] = ACTIONS(4233),
    [anon_sym_BANG_EQ] = ACTIONS(4233),
    [anon_sym_GT_EQ] = ACTIONS(4233),
    [anon_sym_LT_EQ] = ACTIONS(4233),
    [anon_sym_DOT] = ACTIONS(4235),
    [anon_sym_EQ_GT] = ACTIONS(4233),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_when] = ACTIONS(4233),
    [anon_sym_DOT_DOT] = ACTIONS(4233),
    [anon_sym_and] = ACTIONS(4233),
    [anon_sym_or] = ACTIONS(4233),
    [anon_sym_PLUS_EQ] = ACTIONS(4233),
    [anon_sym_DASH_EQ] = ACTIONS(4233),
    [anon_sym_STAR_EQ] = ACTIONS(4233),
    [anon_sym_SLASH_EQ] = ACTIONS(4233),
    [anon_sym_PERCENT_EQ] = ACTIONS(4233),
    [anon_sym_AMP_EQ] = ACTIONS(4233),
    [anon_sym_CARET_EQ] = ACTIONS(4233),
    [anon_sym_PIPE_EQ] = ACTIONS(4233),
    [anon_sym_LT_LT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4233),
    [anon_sym_AMP_AMP] = ACTIONS(4233),
    [anon_sym_PIPE_PIPE] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK] = ACTIONS(4235),
    [anon_sym_into] = ACTIONS(4233),
    [anon_sym_on] = ACTIONS(4233),
    [anon_sym_equals] = ACTIONS(4233),
    [anon_sym_by] = ACTIONS(4233),
    [anon_sym_as] = ACTIONS(4233),
    [anon_sym_is] = ACTIONS(4233),
    [anon_sym_DASH_GT] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [aux_sym_preproc_if_token3] = ACTIONS(4233),
    [aux_sym_preproc_else_token1] = ACTIONS(4233),
    [aux_sym_preproc_elif_token1] = ACTIONS(4233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2656] = {
    [sym_preproc_region] = STATE(2656),
    [sym_preproc_endregion] = STATE(2656),
    [sym_preproc_line] = STATE(2656),
    [sym_preproc_pragma] = STATE(2656),
    [sym_preproc_nullable] = STATE(2656),
    [sym_preproc_error] = STATE(2656),
    [sym_preproc_warning] = STATE(2656),
    [sym_preproc_define] = STATE(2656),
    [sym_preproc_undef] = STATE(2656),
    [sym__identifier_token] = ACTIONS(4127),
    [anon_sym_alias] = ACTIONS(4127),
    [anon_sym_global] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_COLON] = ACTIONS(4129),
    [anon_sym_COMMA] = ACTIONS(4129),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [anon_sym_file] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_where] = ACTIONS(4127),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_notnull] = ACTIONS(4127),
    [anon_sym_unmanaged] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_SLASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4129),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_LT_LT] = ACTIONS(4129),
    [anon_sym_GT_GT] = ACTIONS(4127),
    [anon_sym_GT_GT_GT] = ACTIONS(4129),
    [anon_sym_EQ_EQ] = ACTIONS(4129),
    [anon_sym_BANG_EQ] = ACTIONS(4129),
    [anon_sym_GT_EQ] = ACTIONS(4129),
    [anon_sym_LT_EQ] = ACTIONS(4129),
    [anon_sym_DOT] = ACTIONS(4127),
    [anon_sym_scoped] = ACTIONS(4127),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_var] = ACTIONS(4127),
    [anon_sym_yield] = ACTIONS(4127),
    [anon_sym_switch] = ACTIONS(4127),
    [anon_sym_when] = ACTIONS(4127),
    [sym_discard] = ACTIONS(4127),
    [anon_sym_DOT_DOT] = ACTIONS(4129),
    [anon_sym_and] = ACTIONS(4127),
    [anon_sym_or] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4129),
    [anon_sym_PIPE_PIPE] = ACTIONS(4129),
    [anon_sym_QMARK_QMARK] = ACTIONS(4129),
    [anon_sym_from] = ACTIONS(4127),
    [anon_sym_into] = ACTIONS(4127),
    [anon_sym_join] = ACTIONS(4127),
    [anon_sym_on] = ACTIONS(4127),
    [anon_sym_equals] = ACTIONS(4127),
    [anon_sym_let] = ACTIONS(4127),
    [anon_sym_orderby] = ACTIONS(4127),
    [anon_sym_ascending] = ACTIONS(4127),
    [anon_sym_descending] = ACTIONS(4127),
    [anon_sym_group] = ACTIONS(4127),
    [anon_sym_by] = ACTIONS(4127),
    [anon_sym_select] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4127),
    [anon_sym_is] = ACTIONS(4127),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [anon_sym_with] = ACTIONS(4127),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4129),
  },
  [2657] = {
    [sym_preproc_region] = STATE(2657),
    [sym_preproc_endregion] = STATE(2657),
    [sym_preproc_line] = STATE(2657),
    [sym_preproc_pragma] = STATE(2657),
    [sym_preproc_nullable] = STATE(2657),
    [sym_preproc_error] = STATE(2657),
    [sym_preproc_warning] = STATE(2657),
    [sym_preproc_define] = STATE(2657),
    [sym_preproc_undef] = STATE(2657),
    [sym__identifier_token] = ACTIONS(3633),
    [anon_sym_alias] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_file] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_notnull] = ACTIONS(3633),
    [anon_sym_unmanaged] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_scoped] = ACTIONS(3633),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3633),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_when] = ACTIONS(3633),
    [sym_discard] = ACTIONS(3633),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3633),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3630),
    [anon_sym_from] = ACTIONS(3633),
    [anon_sym_into] = ACTIONS(3633),
    [anon_sym_join] = ACTIONS(3633),
    [anon_sym_on] = ACTIONS(3633),
    [anon_sym_equals] = ACTIONS(3633),
    [anon_sym_let] = ACTIONS(3633),
    [anon_sym_orderby] = ACTIONS(3633),
    [anon_sym_ascending] = ACTIONS(3633),
    [anon_sym_descending] = ACTIONS(3633),
    [anon_sym_group] = ACTIONS(3633),
    [anon_sym_by] = ACTIONS(3633),
    [anon_sym_select] = ACTIONS(3633),
    [anon_sym_as] = ACTIONS(3633),
    [anon_sym_is] = ACTIONS(3633),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3630),
  },
  [2658] = {
    [sym__variable_designation] = STATE(3827),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2658),
    [sym_preproc_endregion] = STATE(2658),
    [sym_preproc_line] = STATE(2658),
    [sym_preproc_pragma] = STATE(2658),
    [sym_preproc_nullable] = STATE(2658),
    [sym_preproc_error] = STATE(2658),
    [sym_preproc_warning] = STATE(2658),
    [sym_preproc_define] = STATE(2658),
    [sym_preproc_undef] = STATE(2658),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(4316),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2659] = {
    [sym__variable_designation] = STATE(3846),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2659),
    [sym_preproc_endregion] = STATE(2659),
    [sym_preproc_line] = STATE(2659),
    [sym_preproc_pragma] = STATE(2659),
    [sym_preproc_nullable] = STATE(2659),
    [sym_preproc_error] = STATE(2659),
    [sym_preproc_warning] = STATE(2659),
    [sym_preproc_define] = STATE(2659),
    [sym_preproc_undef] = STATE(2659),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_COMMA] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(4316),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2660] = {
    [sym_preproc_region] = STATE(2660),
    [sym_preproc_endregion] = STATE(2660),
    [sym_preproc_line] = STATE(2660),
    [sym_preproc_pragma] = STATE(2660),
    [sym_preproc_nullable] = STATE(2660),
    [sym_preproc_error] = STATE(2660),
    [sym_preproc_warning] = STATE(2660),
    [sym_preproc_define] = STATE(2660),
    [sym_preproc_undef] = STATE(2660),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2661] = {
    [sym__variable_designation] = STATE(3552),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2661),
    [sym_preproc_endregion] = STATE(2661),
    [sym_preproc_line] = STATE(2661),
    [sym_preproc_pragma] = STATE(2661),
    [sym_preproc_nullable] = STATE(2661),
    [sym_preproc_error] = STATE(2661),
    [sym_preproc_warning] = STATE(2661),
    [sym_preproc_define] = STATE(2661),
    [sym_preproc_undef] = STATE(2661),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2662] = {
    [sym_preproc_region] = STATE(2662),
    [sym_preproc_endregion] = STATE(2662),
    [sym_preproc_line] = STATE(2662),
    [sym_preproc_pragma] = STATE(2662),
    [sym_preproc_nullable] = STATE(2662),
    [sym_preproc_error] = STATE(2662),
    [sym_preproc_warning] = STATE(2662),
    [sym_preproc_define] = STATE(2662),
    [sym_preproc_undef] = STATE(2662),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2663] = {
    [sym_preproc_region] = STATE(2663),
    [sym_preproc_endregion] = STATE(2663),
    [sym_preproc_line] = STATE(2663),
    [sym_preproc_pragma] = STATE(2663),
    [sym_preproc_nullable] = STATE(2663),
    [sym_preproc_error] = STATE(2663),
    [sym_preproc_warning] = STATE(2663),
    [sym_preproc_define] = STATE(2663),
    [sym_preproc_undef] = STATE(2663),
    [sym__identifier_token] = ACTIONS(4332),
    [anon_sym_extern] = ACTIONS(4332),
    [anon_sym_alias] = ACTIONS(4332),
    [anon_sym_global] = ACTIONS(4332),
    [anon_sym_using] = ACTIONS(4332),
    [anon_sym_unsafe] = ACTIONS(4332),
    [anon_sym_EQ] = ACTIONS(4334),
    [anon_sym_static] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(4334),
    [anon_sym_LPAREN] = ACTIONS(4334),
    [anon_sym_event] = ACTIONS(4332),
    [anon_sym_namespace] = ACTIONS(4332),
    [anon_sym_class] = ACTIONS(4332),
    [anon_sym_ref] = ACTIONS(4332),
    [anon_sym_struct] = ACTIONS(4332),
    [anon_sym_enum] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4334),
    [anon_sym_interface] = ACTIONS(4332),
    [anon_sym_delegate] = ACTIONS(4332),
    [anon_sym_record] = ACTIONS(4332),
    [anon_sym_abstract] = ACTIONS(4332),
    [anon_sym_async] = ACTIONS(4332),
    [anon_sym_const] = ACTIONS(4332),
    [anon_sym_file] = ACTIONS(4332),
    [anon_sym_fixed] = ACTIONS(4332),
    [anon_sym_internal] = ACTIONS(4332),
    [anon_sym_new] = ACTIONS(4332),
    [anon_sym_override] = ACTIONS(4332),
    [anon_sym_partial] = ACTIONS(4332),
    [anon_sym_private] = ACTIONS(4332),
    [anon_sym_protected] = ACTIONS(4332),
    [anon_sym_public] = ACTIONS(4332),
    [anon_sym_readonly] = ACTIONS(4332),
    [anon_sym_required] = ACTIONS(4332),
    [anon_sym_sealed] = ACTIONS(4332),
    [anon_sym_virtual] = ACTIONS(4332),
    [anon_sym_volatile] = ACTIONS(4332),
    [anon_sym_where] = ACTIONS(4332),
    [anon_sym_notnull] = ACTIONS(4332),
    [anon_sym_unmanaged] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4334),
    [anon_sym_implicit] = ACTIONS(4332),
    [anon_sym_explicit] = ACTIONS(4332),
    [anon_sym_scoped] = ACTIONS(4332),
    [anon_sym_var] = ACTIONS(4332),
    [sym_predefined_type] = ACTIONS(4332),
    [anon_sym_yield] = ACTIONS(4332),
    [anon_sym_when] = ACTIONS(4332),
    [anon_sym_from] = ACTIONS(4332),
    [anon_sym_into] = ACTIONS(4332),
    [anon_sym_join] = ACTIONS(4332),
    [anon_sym_on] = ACTIONS(4332),
    [anon_sym_equals] = ACTIONS(4332),
    [anon_sym_let] = ACTIONS(4332),
    [anon_sym_orderby] = ACTIONS(4332),
    [anon_sym_ascending] = ACTIONS(4332),
    [anon_sym_descending] = ACTIONS(4332),
    [anon_sym_group] = ACTIONS(4332),
    [anon_sym_by] = ACTIONS(4332),
    [anon_sym_select] = ACTIONS(4332),
    [aux_sym_preproc_if_token1] = ACTIONS(4334),
    [aux_sym_preproc_if_token3] = ACTIONS(4334),
    [aux_sym_preproc_else_token1] = ACTIONS(4334),
    [aux_sym_preproc_elif_token1] = ACTIONS(4334),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2664] = {
    [sym_preproc_region] = STATE(2664),
    [sym_preproc_endregion] = STATE(2664),
    [sym_preproc_line] = STATE(2664),
    [sym_preproc_pragma] = STATE(2664),
    [sym_preproc_nullable] = STATE(2664),
    [sym_preproc_error] = STATE(2664),
    [sym_preproc_warning] = STATE(2664),
    [sym_preproc_define] = STATE(2664),
    [sym_preproc_undef] = STATE(2664),
    [anon_sym_SEMI] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_in] = ACTIONS(4241),
    [anon_sym_QMARK] = ACTIONS(4241),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4241),
    [anon_sym_SLASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_CARET] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(4241),
    [anon_sym_GT_GT_GT] = ACTIONS(4241),
    [anon_sym_EQ_EQ] = ACTIONS(4239),
    [anon_sym_BANG_EQ] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4241),
    [anon_sym_EQ_GT] = ACTIONS(4239),
    [anon_sym_switch] = ACTIONS(4239),
    [anon_sym_when] = ACTIONS(4239),
    [anon_sym_DOT_DOT] = ACTIONS(4239),
    [anon_sym_and] = ACTIONS(4239),
    [anon_sym_or] = ACTIONS(4239),
    [anon_sym_PLUS_EQ] = ACTIONS(4239),
    [anon_sym_DASH_EQ] = ACTIONS(4239),
    [anon_sym_STAR_EQ] = ACTIONS(4239),
    [anon_sym_SLASH_EQ] = ACTIONS(4239),
    [anon_sym_PERCENT_EQ] = ACTIONS(4239),
    [anon_sym_AMP_EQ] = ACTIONS(4239),
    [anon_sym_CARET_EQ] = ACTIONS(4239),
    [anon_sym_PIPE_EQ] = ACTIONS(4239),
    [anon_sym_LT_LT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK] = ACTIONS(4241),
    [anon_sym_into] = ACTIONS(4239),
    [anon_sym_on] = ACTIONS(4239),
    [anon_sym_equals] = ACTIONS(4239),
    [anon_sym_by] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_is] = ACTIONS(4239),
    [anon_sym_DASH_GT] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4239),
    [aux_sym_preproc_if_token3] = ACTIONS(4239),
    [aux_sym_preproc_else_token1] = ACTIONS(4239),
    [aux_sym_preproc_elif_token1] = ACTIONS(4239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2665] = {
    [sym_preproc_region] = STATE(2665),
    [sym_preproc_endregion] = STATE(2665),
    [sym_preproc_line] = STATE(2665),
    [sym_preproc_pragma] = STATE(2665),
    [sym_preproc_nullable] = STATE(2665),
    [sym_preproc_error] = STATE(2665),
    [sym_preproc_warning] = STATE(2665),
    [sym_preproc_define] = STATE(2665),
    [sym_preproc_undef] = STATE(2665),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_when] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3664),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2666] = {
    [sym__variable_designation] = STATE(3470),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2666),
    [sym_preproc_endregion] = STATE(2666),
    [sym_preproc_line] = STATE(2666),
    [sym_preproc_pragma] = STATE(2666),
    [sym_preproc_nullable] = STATE(2666),
    [sym_preproc_error] = STATE(2666),
    [sym_preproc_warning] = STATE(2666),
    [sym_preproc_define] = STATE(2666),
    [sym_preproc_undef] = STATE(2666),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_in] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2667] = {
    [sym__variable_designation] = STATE(3848),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2667),
    [sym_preproc_endregion] = STATE(2667),
    [sym_preproc_line] = STATE(2667),
    [sym_preproc_pragma] = STATE(2667),
    [sym_preproc_nullable] = STATE(2667),
    [sym_preproc_error] = STATE(2667),
    [sym_preproc_warning] = STATE(2667),
    [sym_preproc_define] = STATE(2667),
    [sym_preproc_undef] = STATE(2667),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(4316),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2668] = {
    [sym__variable_designation] = STATE(3833),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2668),
    [sym_preproc_endregion] = STATE(2668),
    [sym_preproc_line] = STATE(2668),
    [sym_preproc_pragma] = STATE(2668),
    [sym_preproc_nullable] = STATE(2668),
    [sym_preproc_error] = STATE(2668),
    [sym_preproc_warning] = STATE(2668),
    [sym_preproc_define] = STATE(2668),
    [sym_preproc_undef] = STATE(2668),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3933),
    [anon_sym_descending] = ACTIONS(3933),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2669] = {
    [sym_preproc_region] = STATE(2669),
    [sym_preproc_endregion] = STATE(2669),
    [sym_preproc_line] = STATE(2669),
    [sym_preproc_pragma] = STATE(2669),
    [sym_preproc_nullable] = STATE(2669),
    [sym_preproc_error] = STATE(2669),
    [sym_preproc_warning] = STATE(2669),
    [sym_preproc_define] = STATE(2669),
    [sym_preproc_undef] = STATE(2669),
    [sym__identifier_token] = ACTIONS(4336),
    [anon_sym_extern] = ACTIONS(4336),
    [anon_sym_alias] = ACTIONS(4336),
    [anon_sym_global] = ACTIONS(4336),
    [anon_sym_using] = ACTIONS(4336),
    [anon_sym_unsafe] = ACTIONS(4336),
    [anon_sym_EQ] = ACTIONS(4338),
    [anon_sym_static] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_event] = ACTIONS(4336),
    [anon_sym_namespace] = ACTIONS(4336),
    [anon_sym_class] = ACTIONS(4336),
    [anon_sym_ref] = ACTIONS(4336),
    [anon_sym_struct] = ACTIONS(4336),
    [anon_sym_enum] = ACTIONS(4336),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_interface] = ACTIONS(4336),
    [anon_sym_delegate] = ACTIONS(4336),
    [anon_sym_record] = ACTIONS(4336),
    [anon_sym_abstract] = ACTIONS(4336),
    [anon_sym_async] = ACTIONS(4336),
    [anon_sym_const] = ACTIONS(4336),
    [anon_sym_file] = ACTIONS(4336),
    [anon_sym_fixed] = ACTIONS(4336),
    [anon_sym_internal] = ACTIONS(4336),
    [anon_sym_new] = ACTIONS(4336),
    [anon_sym_override] = ACTIONS(4336),
    [anon_sym_partial] = ACTIONS(4336),
    [anon_sym_private] = ACTIONS(4336),
    [anon_sym_protected] = ACTIONS(4336),
    [anon_sym_public] = ACTIONS(4336),
    [anon_sym_readonly] = ACTIONS(4336),
    [anon_sym_required] = ACTIONS(4336),
    [anon_sym_sealed] = ACTIONS(4336),
    [anon_sym_virtual] = ACTIONS(4336),
    [anon_sym_volatile] = ACTIONS(4336),
    [anon_sym_where] = ACTIONS(4336),
    [anon_sym_notnull] = ACTIONS(4336),
    [anon_sym_unmanaged] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4340),
    [anon_sym_implicit] = ACTIONS(4336),
    [anon_sym_explicit] = ACTIONS(4336),
    [anon_sym_scoped] = ACTIONS(4336),
    [anon_sym_var] = ACTIONS(4336),
    [sym_predefined_type] = ACTIONS(4336),
    [anon_sym_yield] = ACTIONS(4336),
    [anon_sym_when] = ACTIONS(4336),
    [anon_sym_from] = ACTIONS(4336),
    [anon_sym_into] = ACTIONS(4336),
    [anon_sym_join] = ACTIONS(4336),
    [anon_sym_on] = ACTIONS(4336),
    [anon_sym_equals] = ACTIONS(4336),
    [anon_sym_let] = ACTIONS(4336),
    [anon_sym_orderby] = ACTIONS(4336),
    [anon_sym_ascending] = ACTIONS(4336),
    [anon_sym_descending] = ACTIONS(4336),
    [anon_sym_group] = ACTIONS(4336),
    [anon_sym_by] = ACTIONS(4336),
    [anon_sym_select] = ACTIONS(4336),
    [aux_sym_preproc_if_token1] = ACTIONS(4340),
    [aux_sym_preproc_if_token3] = ACTIONS(4340),
    [aux_sym_preproc_else_token1] = ACTIONS(4340),
    [aux_sym_preproc_elif_token1] = ACTIONS(4340),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2670] = {
    [sym_preproc_region] = STATE(2670),
    [sym_preproc_endregion] = STATE(2670),
    [sym_preproc_line] = STATE(2670),
    [sym_preproc_pragma] = STATE(2670),
    [sym_preproc_nullable] = STATE(2670),
    [sym_preproc_error] = STATE(2670),
    [sym_preproc_warning] = STATE(2670),
    [sym_preproc_define] = STATE(2670),
    [sym_preproc_undef] = STATE(2670),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_RBRACK] = ACTIONS(4213),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_RPAREN] = ACTIONS(4213),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_BANG] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_GT_GT_GT] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_EQ_GT] = ACTIONS(4213),
    [anon_sym_switch] = ACTIONS(4213),
    [anon_sym_when] = ACTIONS(4213),
    [anon_sym_DOT_DOT] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(4213),
    [anon_sym_or] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK] = ACTIONS(4215),
    [anon_sym_into] = ACTIONS(4213),
    [anon_sym_on] = ACTIONS(4213),
    [anon_sym_equals] = ACTIONS(4213),
    [anon_sym_by] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(4213),
    [anon_sym_is] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [anon_sym_with] = ACTIONS(4213),
    [aux_sym_preproc_if_token3] = ACTIONS(4213),
    [aux_sym_preproc_else_token1] = ACTIONS(4213),
    [aux_sym_preproc_elif_token1] = ACTIONS(4213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2671] = {
    [sym__variable_designation] = STATE(3503),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2671),
    [sym_preproc_endregion] = STATE(2671),
    [sym_preproc_line] = STATE(2671),
    [sym_preproc_pragma] = STATE(2671),
    [sym_preproc_nullable] = STATE(2671),
    [sym_preproc_error] = STATE(2671),
    [sym_preproc_warning] = STATE(2671),
    [sym_preproc_define] = STATE(2671),
    [sym_preproc_undef] = STATE(2671),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_in] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2672] = {
    [sym__variable_designation] = STATE(3555),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2672),
    [sym_preproc_endregion] = STATE(2672),
    [sym_preproc_line] = STATE(2672),
    [sym_preproc_pragma] = STATE(2672),
    [sym_preproc_nullable] = STATE(2672),
    [sym_preproc_error] = STATE(2672),
    [sym_preproc_warning] = STATE(2672),
    [sym_preproc_define] = STATE(2672),
    [sym_preproc_undef] = STATE(2672),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2673] = {
    [sym_type_argument_list] = STATE(2810),
    [sym_preproc_region] = STATE(2673),
    [sym_preproc_endregion] = STATE(2673),
    [sym_preproc_line] = STATE(2673),
    [sym_preproc_pragma] = STATE(2673),
    [sym_preproc_nullable] = STATE(2673),
    [sym_preproc_error] = STATE(2673),
    [sym_preproc_warning] = STATE(2673),
    [sym_preproc_define] = STATE(2673),
    [sym_preproc_undef] = STATE(2673),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2674] = {
    [sym_preproc_region] = STATE(2674),
    [sym_preproc_endregion] = STATE(2674),
    [sym_preproc_line] = STATE(2674),
    [sym_preproc_pragma] = STATE(2674),
    [sym_preproc_nullable] = STATE(2674),
    [sym_preproc_error] = STATE(2674),
    [sym_preproc_warning] = STATE(2674),
    [sym_preproc_define] = STATE(2674),
    [sym_preproc_undef] = STATE(2674),
    [sym__identifier_token] = ACTIONS(4342),
    [anon_sym_extern] = ACTIONS(4342),
    [anon_sym_alias] = ACTIONS(4342),
    [anon_sym_global] = ACTIONS(4342),
    [anon_sym_using] = ACTIONS(4342),
    [anon_sym_unsafe] = ACTIONS(4342),
    [anon_sym_EQ] = ACTIONS(4344),
    [anon_sym_static] = ACTIONS(4342),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_LPAREN] = ACTIONS(4346),
    [anon_sym_event] = ACTIONS(4342),
    [anon_sym_namespace] = ACTIONS(4342),
    [anon_sym_class] = ACTIONS(4342),
    [anon_sym_ref] = ACTIONS(4342),
    [anon_sym_struct] = ACTIONS(4342),
    [anon_sym_enum] = ACTIONS(4342),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_interface] = ACTIONS(4342),
    [anon_sym_delegate] = ACTIONS(4342),
    [anon_sym_record] = ACTIONS(4342),
    [anon_sym_abstract] = ACTIONS(4342),
    [anon_sym_async] = ACTIONS(4342),
    [anon_sym_const] = ACTIONS(4342),
    [anon_sym_file] = ACTIONS(4342),
    [anon_sym_fixed] = ACTIONS(4342),
    [anon_sym_internal] = ACTIONS(4342),
    [anon_sym_new] = ACTIONS(4342),
    [anon_sym_override] = ACTIONS(4342),
    [anon_sym_partial] = ACTIONS(4342),
    [anon_sym_private] = ACTIONS(4342),
    [anon_sym_protected] = ACTIONS(4342),
    [anon_sym_public] = ACTIONS(4342),
    [anon_sym_readonly] = ACTIONS(4342),
    [anon_sym_required] = ACTIONS(4342),
    [anon_sym_sealed] = ACTIONS(4342),
    [anon_sym_virtual] = ACTIONS(4342),
    [anon_sym_volatile] = ACTIONS(4342),
    [anon_sym_where] = ACTIONS(4342),
    [anon_sym_notnull] = ACTIONS(4342),
    [anon_sym_unmanaged] = ACTIONS(4342),
    [anon_sym_TILDE] = ACTIONS(4346),
    [anon_sym_implicit] = ACTIONS(4342),
    [anon_sym_explicit] = ACTIONS(4342),
    [anon_sym_scoped] = ACTIONS(4342),
    [anon_sym_var] = ACTIONS(4342),
    [sym_predefined_type] = ACTIONS(4342),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_when] = ACTIONS(4342),
    [anon_sym_from] = ACTIONS(4342),
    [anon_sym_into] = ACTIONS(4342),
    [anon_sym_join] = ACTIONS(4342),
    [anon_sym_on] = ACTIONS(4342),
    [anon_sym_equals] = ACTIONS(4342),
    [anon_sym_let] = ACTIONS(4342),
    [anon_sym_orderby] = ACTIONS(4342),
    [anon_sym_ascending] = ACTIONS(4342),
    [anon_sym_descending] = ACTIONS(4342),
    [anon_sym_group] = ACTIONS(4342),
    [anon_sym_by] = ACTIONS(4342),
    [anon_sym_select] = ACTIONS(4342),
    [aux_sym_preproc_if_token1] = ACTIONS(4346),
    [aux_sym_preproc_if_token3] = ACTIONS(4346),
    [aux_sym_preproc_else_token1] = ACTIONS(4346),
    [aux_sym_preproc_elif_token1] = ACTIONS(4346),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2675] = {
    [sym__variable_designation] = STATE(3534),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(2675),
    [sym_preproc_endregion] = STATE(2675),
    [sym_preproc_line] = STATE(2675),
    [sym_preproc_pragma] = STATE(2675),
    [sym_preproc_nullable] = STATE(2675),
    [sym_preproc_error] = STATE(2675),
    [sym_preproc_warning] = STATE(2675),
    [sym_preproc_define] = STATE(2675),
    [sym_preproc_undef] = STATE(2675),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_in] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3800),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2676] = {
    [sym__variable_designation] = STATE(3821),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2676),
    [sym_preproc_endregion] = STATE(2676),
    [sym_preproc_line] = STATE(2676),
    [sym_preproc_pragma] = STATE(2676),
    [sym_preproc_nullable] = STATE(2676),
    [sym_preproc_error] = STATE(2676),
    [sym_preproc_warning] = STATE(2676),
    [sym_preproc_define] = STATE(2676),
    [sym_preproc_undef] = STATE(2676),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3929),
    [anon_sym_descending] = ACTIONS(3929),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2677] = {
    [sym_preproc_region] = STATE(2677),
    [sym_preproc_endregion] = STATE(2677),
    [sym_preproc_line] = STATE(2677),
    [sym_preproc_pragma] = STATE(2677),
    [sym_preproc_nullable] = STATE(2677),
    [sym_preproc_error] = STATE(2677),
    [sym_preproc_warning] = STATE(2677),
    [sym_preproc_define] = STATE(2677),
    [sym_preproc_undef] = STATE(2677),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3731),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_into] = ACTIONS(3731),
    [anon_sym_on] = ACTIONS(3731),
    [anon_sym_equals] = ACTIONS(3731),
    [anon_sym_by] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_if_token3] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2678] = {
    [sym_preproc_region] = STATE(2678),
    [sym_preproc_endregion] = STATE(2678),
    [sym_preproc_line] = STATE(2678),
    [sym_preproc_pragma] = STATE(2678),
    [sym_preproc_nullable] = STATE(2678),
    [sym_preproc_error] = STATE(2678),
    [sym_preproc_warning] = STATE(2678),
    [sym_preproc_define] = STATE(2678),
    [sym_preproc_undef] = STATE(2678),
    [sym__identifier_token] = ACTIONS(4348),
    [anon_sym_extern] = ACTIONS(4348),
    [anon_sym_alias] = ACTIONS(4348),
    [anon_sym_global] = ACTIONS(4348),
    [anon_sym_using] = ACTIONS(4348),
    [anon_sym_unsafe] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4350),
    [anon_sym_static] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4352),
    [anon_sym_LPAREN] = ACTIONS(4352),
    [anon_sym_event] = ACTIONS(4348),
    [anon_sym_namespace] = ACTIONS(4348),
    [anon_sym_class] = ACTIONS(4348),
    [anon_sym_ref] = ACTIONS(4348),
    [anon_sym_struct] = ACTIONS(4348),
    [anon_sym_enum] = ACTIONS(4348),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_interface] = ACTIONS(4348),
    [anon_sym_delegate] = ACTIONS(4348),
    [anon_sym_record] = ACTIONS(4348),
    [anon_sym_abstract] = ACTIONS(4348),
    [anon_sym_async] = ACTIONS(4348),
    [anon_sym_const] = ACTIONS(4348),
    [anon_sym_file] = ACTIONS(4348),
    [anon_sym_fixed] = ACTIONS(4348),
    [anon_sym_internal] = ACTIONS(4348),
    [anon_sym_new] = ACTIONS(4348),
    [anon_sym_override] = ACTIONS(4348),
    [anon_sym_partial] = ACTIONS(4348),
    [anon_sym_private] = ACTIONS(4348),
    [anon_sym_protected] = ACTIONS(4348),
    [anon_sym_public] = ACTIONS(4348),
    [anon_sym_readonly] = ACTIONS(4348),
    [anon_sym_required] = ACTIONS(4348),
    [anon_sym_sealed] = ACTIONS(4348),
    [anon_sym_virtual] = ACTIONS(4348),
    [anon_sym_volatile] = ACTIONS(4348),
    [anon_sym_where] = ACTIONS(4348),
    [anon_sym_notnull] = ACTIONS(4348),
    [anon_sym_unmanaged] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4352),
    [anon_sym_implicit] = ACTIONS(4348),
    [anon_sym_explicit] = ACTIONS(4348),
    [anon_sym_scoped] = ACTIONS(4348),
    [anon_sym_var] = ACTIONS(4348),
    [sym_predefined_type] = ACTIONS(4348),
    [anon_sym_yield] = ACTIONS(4348),
    [anon_sym_when] = ACTIONS(4348),
    [anon_sym_from] = ACTIONS(4348),
    [anon_sym_into] = ACTIONS(4348),
    [anon_sym_join] = ACTIONS(4348),
    [anon_sym_on] = ACTIONS(4348),
    [anon_sym_equals] = ACTIONS(4348),
    [anon_sym_let] = ACTIONS(4348),
    [anon_sym_orderby] = ACTIONS(4348),
    [anon_sym_ascending] = ACTIONS(4348),
    [anon_sym_descending] = ACTIONS(4348),
    [anon_sym_group] = ACTIONS(4348),
    [anon_sym_by] = ACTIONS(4348),
    [anon_sym_select] = ACTIONS(4348),
    [aux_sym_preproc_if_token1] = ACTIONS(4352),
    [aux_sym_preproc_if_token3] = ACTIONS(4352),
    [aux_sym_preproc_else_token1] = ACTIONS(4352),
    [aux_sym_preproc_elif_token1] = ACTIONS(4352),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2679] = {
    [sym__variable_designation] = STATE(3833),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2679),
    [sym_preproc_endregion] = STATE(2679),
    [sym_preproc_line] = STATE(2679),
    [sym_preproc_pragma] = STATE(2679),
    [sym_preproc_nullable] = STATE(2679),
    [sym_preproc_error] = STATE(2679),
    [sym_preproc_warning] = STATE(2679),
    [sym_preproc_define] = STATE(2679),
    [sym_preproc_undef] = STATE(2679),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3933),
    [anon_sym_descending] = ACTIONS(3933),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2680] = {
    [sym_preproc_region] = STATE(2680),
    [sym_preproc_endregion] = STATE(2680),
    [sym_preproc_line] = STATE(2680),
    [sym_preproc_pragma] = STATE(2680),
    [sym_preproc_nullable] = STATE(2680),
    [sym_preproc_error] = STATE(2680),
    [sym_preproc_warning] = STATE(2680),
    [sym_preproc_define] = STATE(2680),
    [sym_preproc_undef] = STATE(2680),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4354),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2681] = {
    [sym__variable_designation] = STATE(3836),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2681),
    [sym_preproc_endregion] = STATE(2681),
    [sym_preproc_line] = STATE(2681),
    [sym_preproc_pragma] = STATE(2681),
    [sym_preproc_nullable] = STATE(2681),
    [sym_preproc_error] = STATE(2681),
    [sym_preproc_warning] = STATE(2681),
    [sym_preproc_define] = STATE(2681),
    [sym_preproc_undef] = STATE(2681),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3999),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3999),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3999),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(3999),
    [anon_sym_orderby] = ACTIONS(3999),
    [anon_sym_ascending] = ACTIONS(3999),
    [anon_sym_descending] = ACTIONS(3999),
    [anon_sym_group] = ACTIONS(3999),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(3999),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2682] = {
    [sym_preproc_region] = STATE(2682),
    [sym_preproc_endregion] = STATE(2682),
    [sym_preproc_line] = STATE(2682),
    [sym_preproc_pragma] = STATE(2682),
    [sym_preproc_nullable] = STATE(2682),
    [sym_preproc_error] = STATE(2682),
    [sym_preproc_warning] = STATE(2682),
    [sym_preproc_define] = STATE(2682),
    [sym_preproc_undef] = STATE(2682),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2683] = {
    [sym__variable_designation] = STATE(3845),
    [sym_parenthesized_variable_designation] = STATE(3802),
    [sym_identifier] = STATE(3805),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(2683),
    [sym_preproc_endregion] = STATE(2683),
    [sym_preproc_line] = STATE(2683),
    [sym_preproc_pragma] = STATE(2683),
    [sym_preproc_nullable] = STATE(2683),
    [sym_preproc_error] = STATE(2683),
    [sym_preproc_warning] = STATE(2683),
    [sym_preproc_define] = STATE(2683),
    [sym_preproc_undef] = STATE(2683),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(4098),
    [anon_sym_var] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(4098),
    [sym_discard] = ACTIONS(4243),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(4003),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_orderby] = ACTIONS(4003),
    [anon_sym_ascending] = ACTIONS(4003),
    [anon_sym_descending] = ACTIONS(4003),
    [anon_sym_group] = ACTIONS(4003),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4003),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2684] = {
    [sym_preproc_region] = STATE(2684),
    [sym_preproc_endregion] = STATE(2684),
    [sym_preproc_line] = STATE(2684),
    [sym_preproc_pragma] = STATE(2684),
    [sym_preproc_nullable] = STATE(2684),
    [sym_preproc_error] = STATE(2684),
    [sym_preproc_warning] = STATE(2684),
    [sym_preproc_define] = STATE(2684),
    [sym_preproc_undef] = STATE(2684),
    [sym__identifier_token] = ACTIONS(4356),
    [anon_sym_extern] = ACTIONS(4356),
    [anon_sym_alias] = ACTIONS(4356),
    [anon_sym_global] = ACTIONS(4356),
    [anon_sym_using] = ACTIONS(4356),
    [anon_sym_unsafe] = ACTIONS(4356),
    [anon_sym_EQ] = ACTIONS(4358),
    [anon_sym_static] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(4360),
    [anon_sym_LPAREN] = ACTIONS(4360),
    [anon_sym_event] = ACTIONS(4356),
    [anon_sym_namespace] = ACTIONS(4356),
    [anon_sym_class] = ACTIONS(4356),
    [anon_sym_ref] = ACTIONS(4356),
    [anon_sym_struct] = ACTIONS(4356),
    [anon_sym_enum] = ACTIONS(4356),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_interface] = ACTIONS(4356),
    [anon_sym_delegate] = ACTIONS(4356),
    [anon_sym_record] = ACTIONS(4356),
    [anon_sym_abstract] = ACTIONS(4356),
    [anon_sym_async] = ACTIONS(4356),
    [anon_sym_const] = ACTIONS(4356),
    [anon_sym_file] = ACTIONS(4356),
    [anon_sym_fixed] = ACTIONS(4356),
    [anon_sym_internal] = ACTIONS(4356),
    [anon_sym_new] = ACTIONS(4356),
    [anon_sym_override] = ACTIONS(4356),
    [anon_sym_partial] = ACTIONS(4356),
    [anon_sym_private] = ACTIONS(4356),
    [anon_sym_protected] = ACTIONS(4356),
    [anon_sym_public] = ACTIONS(4356),
    [anon_sym_readonly] = ACTIONS(4356),
    [anon_sym_required] = ACTIONS(4356),
    [anon_sym_sealed] = ACTIONS(4356),
    [anon_sym_virtual] = ACTIONS(4356),
    [anon_sym_volatile] = ACTIONS(4356),
    [anon_sym_where] = ACTIONS(4356),
    [anon_sym_notnull] = ACTIONS(4356),
    [anon_sym_unmanaged] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4360),
    [anon_sym_implicit] = ACTIONS(4356),
    [anon_sym_explicit] = ACTIONS(4356),
    [anon_sym_scoped] = ACTIONS(4356),
    [anon_sym_var] = ACTIONS(4356),
    [sym_predefined_type] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4356),
    [anon_sym_when] = ACTIONS(4356),
    [anon_sym_from] = ACTIONS(4356),
    [anon_sym_into] = ACTIONS(4356),
    [anon_sym_join] = ACTIONS(4356),
    [anon_sym_on] = ACTIONS(4356),
    [anon_sym_equals] = ACTIONS(4356),
    [anon_sym_let] = ACTIONS(4356),
    [anon_sym_orderby] = ACTIONS(4356),
    [anon_sym_ascending] = ACTIONS(4356),
    [anon_sym_descending] = ACTIONS(4356),
    [anon_sym_group] = ACTIONS(4356),
    [anon_sym_by] = ACTIONS(4356),
    [anon_sym_select] = ACTIONS(4356),
    [aux_sym_preproc_if_token1] = ACTIONS(4360),
    [aux_sym_preproc_if_token3] = ACTIONS(4360),
    [aux_sym_preproc_else_token1] = ACTIONS(4360),
    [aux_sym_preproc_elif_token1] = ACTIONS(4360),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2685] = {
    [sym_preproc_region] = STATE(2685),
    [sym_preproc_endregion] = STATE(2685),
    [sym_preproc_line] = STATE(2685),
    [sym_preproc_pragma] = STATE(2685),
    [sym_preproc_nullable] = STATE(2685),
    [sym_preproc_error] = STATE(2685),
    [sym_preproc_warning] = STATE(2685),
    [sym_preproc_define] = STATE(2685),
    [sym_preproc_undef] = STATE(2685),
    [sym__identifier_token] = ACTIONS(4362),
    [anon_sym_extern] = ACTIONS(4362),
    [anon_sym_alias] = ACTIONS(4362),
    [anon_sym_global] = ACTIONS(4362),
    [anon_sym_using] = ACTIONS(4362),
    [anon_sym_unsafe] = ACTIONS(4362),
    [anon_sym_static] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(4364),
    [anon_sym_LPAREN] = ACTIONS(4364),
    [anon_sym_event] = ACTIONS(4362),
    [anon_sym_namespace] = ACTIONS(4362),
    [anon_sym_class] = ACTIONS(4362),
    [anon_sym_ref] = ACTIONS(4362),
    [anon_sym_struct] = ACTIONS(4362),
    [anon_sym_enum] = ACTIONS(4362),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_interface] = ACTIONS(4362),
    [anon_sym_delegate] = ACTIONS(4362),
    [anon_sym_record] = ACTIONS(4362),
    [anon_sym_abstract] = ACTIONS(4362),
    [anon_sym_async] = ACTIONS(4362),
    [anon_sym_const] = ACTIONS(4362),
    [anon_sym_file] = ACTIONS(4362),
    [anon_sym_fixed] = ACTIONS(4362),
    [anon_sym_internal] = ACTIONS(4362),
    [anon_sym_new] = ACTIONS(4362),
    [anon_sym_override] = ACTIONS(4362),
    [anon_sym_partial] = ACTIONS(4362),
    [anon_sym_private] = ACTIONS(4362),
    [anon_sym_protected] = ACTIONS(4362),
    [anon_sym_public] = ACTIONS(4362),
    [anon_sym_readonly] = ACTIONS(4362),
    [anon_sym_required] = ACTIONS(4362),
    [anon_sym_sealed] = ACTIONS(4362),
    [anon_sym_virtual] = ACTIONS(4362),
    [anon_sym_volatile] = ACTIONS(4362),
    [anon_sym_where] = ACTIONS(4362),
    [anon_sym_notnull] = ACTIONS(4362),
    [anon_sym_unmanaged] = ACTIONS(4362),
    [anon_sym_TILDE] = ACTIONS(4364),
    [anon_sym_implicit] = ACTIONS(4362),
    [anon_sym_explicit] = ACTIONS(4362),
    [anon_sym_scoped] = ACTIONS(4362),
    [anon_sym_var] = ACTIONS(4362),
    [sym_predefined_type] = ACTIONS(4362),
    [anon_sym_yield] = ACTIONS(4362),
    [anon_sym_when] = ACTIONS(4362),
    [anon_sym_from] = ACTIONS(4362),
    [anon_sym_into] = ACTIONS(4362),
    [anon_sym_join] = ACTIONS(4362),
    [anon_sym_on] = ACTIONS(4362),
    [anon_sym_equals] = ACTIONS(4362),
    [anon_sym_let] = ACTIONS(4362),
    [anon_sym_orderby] = ACTIONS(4362),
    [anon_sym_ascending] = ACTIONS(4362),
    [anon_sym_descending] = ACTIONS(4362),
    [anon_sym_group] = ACTIONS(4362),
    [anon_sym_by] = ACTIONS(4362),
    [anon_sym_select] = ACTIONS(4362),
    [aux_sym_preproc_if_token1] = ACTIONS(4364),
    [aux_sym_preproc_if_token3] = ACTIONS(4364),
    [aux_sym_preproc_else_token1] = ACTIONS(4364),
    [aux_sym_preproc_elif_token1] = ACTIONS(4364),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2686] = {
    [sym_preproc_region] = STATE(2686),
    [sym_preproc_endregion] = STATE(2686),
    [sym_preproc_line] = STATE(2686),
    [sym_preproc_pragma] = STATE(2686),
    [sym_preproc_nullable] = STATE(2686),
    [sym_preproc_error] = STATE(2686),
    [sym_preproc_warning] = STATE(2686),
    [sym_preproc_define] = STATE(2686),
    [sym_preproc_undef] = STATE(2686),
    [sym__identifier_token] = ACTIONS(4366),
    [anon_sym_extern] = ACTIONS(4366),
    [anon_sym_alias] = ACTIONS(4366),
    [anon_sym_global] = ACTIONS(4366),
    [anon_sym_using] = ACTIONS(4366),
    [anon_sym_unsafe] = ACTIONS(4366),
    [anon_sym_static] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_event] = ACTIONS(4366),
    [anon_sym_namespace] = ACTIONS(4366),
    [anon_sym_class] = ACTIONS(4366),
    [anon_sym_ref] = ACTIONS(4366),
    [anon_sym_struct] = ACTIONS(4366),
    [anon_sym_enum] = ACTIONS(4366),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_interface] = ACTIONS(4366),
    [anon_sym_delegate] = ACTIONS(4366),
    [anon_sym_record] = ACTIONS(4366),
    [anon_sym_abstract] = ACTIONS(4366),
    [anon_sym_async] = ACTIONS(4366),
    [anon_sym_const] = ACTIONS(4366),
    [anon_sym_file] = ACTIONS(4366),
    [anon_sym_fixed] = ACTIONS(4366),
    [anon_sym_internal] = ACTIONS(4366),
    [anon_sym_new] = ACTIONS(4366),
    [anon_sym_override] = ACTIONS(4366),
    [anon_sym_partial] = ACTIONS(4366),
    [anon_sym_private] = ACTIONS(4366),
    [anon_sym_protected] = ACTIONS(4366),
    [anon_sym_public] = ACTIONS(4366),
    [anon_sym_readonly] = ACTIONS(4366),
    [anon_sym_required] = ACTIONS(4366),
    [anon_sym_sealed] = ACTIONS(4366),
    [anon_sym_virtual] = ACTIONS(4366),
    [anon_sym_volatile] = ACTIONS(4366),
    [anon_sym_where] = ACTIONS(4366),
    [anon_sym_notnull] = ACTIONS(4366),
    [anon_sym_unmanaged] = ACTIONS(4366),
    [anon_sym_TILDE] = ACTIONS(4368),
    [anon_sym_implicit] = ACTIONS(4366),
    [anon_sym_explicit] = ACTIONS(4366),
    [anon_sym_scoped] = ACTIONS(4366),
    [anon_sym_var] = ACTIONS(4366),
    [sym_predefined_type] = ACTIONS(4366),
    [anon_sym_yield] = ACTIONS(4366),
    [anon_sym_when] = ACTIONS(4366),
    [anon_sym_from] = ACTIONS(4366),
    [anon_sym_into] = ACTIONS(4366),
    [anon_sym_join] = ACTIONS(4366),
    [anon_sym_on] = ACTIONS(4366),
    [anon_sym_equals] = ACTIONS(4366),
    [anon_sym_let] = ACTIONS(4366),
    [anon_sym_orderby] = ACTIONS(4366),
    [anon_sym_ascending] = ACTIONS(4366),
    [anon_sym_descending] = ACTIONS(4366),
    [anon_sym_group] = ACTIONS(4366),
    [anon_sym_by] = ACTIONS(4366),
    [anon_sym_select] = ACTIONS(4366),
    [aux_sym_preproc_if_token1] = ACTIONS(4368),
    [aux_sym_preproc_if_token3] = ACTIONS(4368),
    [aux_sym_preproc_else_token1] = ACTIONS(4368),
    [aux_sym_preproc_elif_token1] = ACTIONS(4368),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2687] = {
    [sym_preproc_region] = STATE(2687),
    [sym_preproc_endregion] = STATE(2687),
    [sym_preproc_line] = STATE(2687),
    [sym_preproc_pragma] = STATE(2687),
    [sym_preproc_nullable] = STATE(2687),
    [sym_preproc_error] = STATE(2687),
    [sym_preproc_warning] = STATE(2687),
    [sym_preproc_define] = STATE(2687),
    [sym_preproc_undef] = STATE(2687),
    [sym__identifier_token] = ACTIONS(4370),
    [anon_sym_extern] = ACTIONS(4370),
    [anon_sym_alias] = ACTIONS(4370),
    [anon_sym_global] = ACTIONS(4370),
    [anon_sym_using] = ACTIONS(4370),
    [anon_sym_unsafe] = ACTIONS(4370),
    [anon_sym_static] = ACTIONS(4370),
    [anon_sym_LBRACK] = ACTIONS(4372),
    [anon_sym_LPAREN] = ACTIONS(4372),
    [anon_sym_event] = ACTIONS(4370),
    [anon_sym_namespace] = ACTIONS(4370),
    [anon_sym_class] = ACTIONS(4370),
    [anon_sym_ref] = ACTIONS(4370),
    [anon_sym_struct] = ACTIONS(4370),
    [anon_sym_enum] = ACTIONS(4370),
    [anon_sym_RBRACE] = ACTIONS(4372),
    [anon_sym_interface] = ACTIONS(4370),
    [anon_sym_delegate] = ACTIONS(4370),
    [anon_sym_record] = ACTIONS(4370),
    [anon_sym_abstract] = ACTIONS(4370),
    [anon_sym_async] = ACTIONS(4370),
    [anon_sym_const] = ACTIONS(4370),
    [anon_sym_file] = ACTIONS(4370),
    [anon_sym_fixed] = ACTIONS(4370),
    [anon_sym_internal] = ACTIONS(4370),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_override] = ACTIONS(4370),
    [anon_sym_partial] = ACTIONS(4370),
    [anon_sym_private] = ACTIONS(4370),
    [anon_sym_protected] = ACTIONS(4370),
    [anon_sym_public] = ACTIONS(4370),
    [anon_sym_readonly] = ACTIONS(4370),
    [anon_sym_required] = ACTIONS(4370),
    [anon_sym_sealed] = ACTIONS(4370),
    [anon_sym_virtual] = ACTIONS(4370),
    [anon_sym_volatile] = ACTIONS(4370),
    [anon_sym_where] = ACTIONS(4370),
    [anon_sym_notnull] = ACTIONS(4370),
    [anon_sym_unmanaged] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4372),
    [anon_sym_implicit] = ACTIONS(4370),
    [anon_sym_explicit] = ACTIONS(4370),
    [anon_sym_scoped] = ACTIONS(4370),
    [anon_sym_var] = ACTIONS(4370),
    [sym_predefined_type] = ACTIONS(4370),
    [anon_sym_yield] = ACTIONS(4370),
    [anon_sym_when] = ACTIONS(4370),
    [anon_sym_from] = ACTIONS(4370),
    [anon_sym_into] = ACTIONS(4370),
    [anon_sym_join] = ACTIONS(4370),
    [anon_sym_on] = ACTIONS(4370),
    [anon_sym_equals] = ACTIONS(4370),
    [anon_sym_let] = ACTIONS(4370),
    [anon_sym_orderby] = ACTIONS(4370),
    [anon_sym_ascending] = ACTIONS(4370),
    [anon_sym_descending] = ACTIONS(4370),
    [anon_sym_group] = ACTIONS(4370),
    [anon_sym_by] = ACTIONS(4370),
    [anon_sym_select] = ACTIONS(4370),
    [aux_sym_preproc_if_token1] = ACTIONS(4372),
    [aux_sym_preproc_if_token3] = ACTIONS(4372),
    [aux_sym_preproc_else_token1] = ACTIONS(4372),
    [aux_sym_preproc_elif_token1] = ACTIONS(4372),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2688] = {
    [sym_preproc_region] = STATE(2688),
    [sym_preproc_endregion] = STATE(2688),
    [sym_preproc_line] = STATE(2688),
    [sym_preproc_pragma] = STATE(2688),
    [sym_preproc_nullable] = STATE(2688),
    [sym_preproc_error] = STATE(2688),
    [sym_preproc_warning] = STATE(2688),
    [sym_preproc_define] = STATE(2688),
    [sym_preproc_undef] = STATE(2688),
    [sym__identifier_token] = ACTIONS(4374),
    [anon_sym_extern] = ACTIONS(4374),
    [anon_sym_alias] = ACTIONS(4374),
    [anon_sym_global] = ACTIONS(4374),
    [anon_sym_using] = ACTIONS(4374),
    [anon_sym_unsafe] = ACTIONS(4374),
    [anon_sym_static] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(4376),
    [anon_sym_LPAREN] = ACTIONS(4376),
    [anon_sym_event] = ACTIONS(4374),
    [anon_sym_namespace] = ACTIONS(4374),
    [anon_sym_class] = ACTIONS(4374),
    [anon_sym_ref] = ACTIONS(4374),
    [anon_sym_struct] = ACTIONS(4374),
    [anon_sym_enum] = ACTIONS(4374),
    [anon_sym_RBRACE] = ACTIONS(4376),
    [anon_sym_interface] = ACTIONS(4374),
    [anon_sym_delegate] = ACTIONS(4374),
    [anon_sym_record] = ACTIONS(4374),
    [anon_sym_abstract] = ACTIONS(4374),
    [anon_sym_async] = ACTIONS(4374),
    [anon_sym_const] = ACTIONS(4374),
    [anon_sym_file] = ACTIONS(4374),
    [anon_sym_fixed] = ACTIONS(4374),
    [anon_sym_internal] = ACTIONS(4374),
    [anon_sym_new] = ACTIONS(4374),
    [anon_sym_override] = ACTIONS(4374),
    [anon_sym_partial] = ACTIONS(4374),
    [anon_sym_private] = ACTIONS(4374),
    [anon_sym_protected] = ACTIONS(4374),
    [anon_sym_public] = ACTIONS(4374),
    [anon_sym_readonly] = ACTIONS(4374),
    [anon_sym_required] = ACTIONS(4374),
    [anon_sym_sealed] = ACTIONS(4374),
    [anon_sym_virtual] = ACTIONS(4374),
    [anon_sym_volatile] = ACTIONS(4374),
    [anon_sym_where] = ACTIONS(4374),
    [anon_sym_notnull] = ACTIONS(4374),
    [anon_sym_unmanaged] = ACTIONS(4374),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_implicit] = ACTIONS(4374),
    [anon_sym_explicit] = ACTIONS(4374),
    [anon_sym_scoped] = ACTIONS(4374),
    [anon_sym_var] = ACTIONS(4374),
    [sym_predefined_type] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4374),
    [anon_sym_when] = ACTIONS(4374),
    [anon_sym_from] = ACTIONS(4374),
    [anon_sym_into] = ACTIONS(4374),
    [anon_sym_join] = ACTIONS(4374),
    [anon_sym_on] = ACTIONS(4374),
    [anon_sym_equals] = ACTIONS(4374),
    [anon_sym_let] = ACTIONS(4374),
    [anon_sym_orderby] = ACTIONS(4374),
    [anon_sym_ascending] = ACTIONS(4374),
    [anon_sym_descending] = ACTIONS(4374),
    [anon_sym_group] = ACTIONS(4374),
    [anon_sym_by] = ACTIONS(4374),
    [anon_sym_select] = ACTIONS(4374),
    [aux_sym_preproc_if_token1] = ACTIONS(4376),
    [aux_sym_preproc_if_token3] = ACTIONS(4376),
    [aux_sym_preproc_else_token1] = ACTIONS(4376),
    [aux_sym_preproc_elif_token1] = ACTIONS(4376),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2689] = {
    [sym_preproc_region] = STATE(2689),
    [sym_preproc_endregion] = STATE(2689),
    [sym_preproc_line] = STATE(2689),
    [sym_preproc_pragma] = STATE(2689),
    [sym_preproc_nullable] = STATE(2689),
    [sym_preproc_error] = STATE(2689),
    [sym_preproc_warning] = STATE(2689),
    [sym_preproc_define] = STATE(2689),
    [sym_preproc_undef] = STATE(2689),
    [sym__identifier_token] = ACTIONS(4378),
    [anon_sym_extern] = ACTIONS(4378),
    [anon_sym_alias] = ACTIONS(4378),
    [anon_sym_global] = ACTIONS(4378),
    [anon_sym_using] = ACTIONS(4378),
    [anon_sym_unsafe] = ACTIONS(4378),
    [anon_sym_static] = ACTIONS(4378),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_LPAREN] = ACTIONS(4380),
    [anon_sym_event] = ACTIONS(4378),
    [anon_sym_namespace] = ACTIONS(4378),
    [anon_sym_class] = ACTIONS(4378),
    [anon_sym_ref] = ACTIONS(4378),
    [anon_sym_struct] = ACTIONS(4378),
    [anon_sym_enum] = ACTIONS(4378),
    [anon_sym_RBRACE] = ACTIONS(4380),
    [anon_sym_interface] = ACTIONS(4378),
    [anon_sym_delegate] = ACTIONS(4378),
    [anon_sym_record] = ACTIONS(4378),
    [anon_sym_abstract] = ACTIONS(4378),
    [anon_sym_async] = ACTIONS(4378),
    [anon_sym_const] = ACTIONS(4378),
    [anon_sym_file] = ACTIONS(4378),
    [anon_sym_fixed] = ACTIONS(4378),
    [anon_sym_internal] = ACTIONS(4378),
    [anon_sym_new] = ACTIONS(4378),
    [anon_sym_override] = ACTIONS(4378),
    [anon_sym_partial] = ACTIONS(4378),
    [anon_sym_private] = ACTIONS(4378),
    [anon_sym_protected] = ACTIONS(4378),
    [anon_sym_public] = ACTIONS(4378),
    [anon_sym_readonly] = ACTIONS(4378),
    [anon_sym_required] = ACTIONS(4378),
    [anon_sym_sealed] = ACTIONS(4378),
    [anon_sym_virtual] = ACTIONS(4378),
    [anon_sym_volatile] = ACTIONS(4378),
    [anon_sym_where] = ACTIONS(4378),
    [anon_sym_notnull] = ACTIONS(4378),
    [anon_sym_unmanaged] = ACTIONS(4378),
    [anon_sym_TILDE] = ACTIONS(4380),
    [anon_sym_implicit] = ACTIONS(4378),
    [anon_sym_explicit] = ACTIONS(4378),
    [anon_sym_scoped] = ACTIONS(4378),
    [anon_sym_var] = ACTIONS(4378),
    [sym_predefined_type] = ACTIONS(4378),
    [anon_sym_yield] = ACTIONS(4378),
    [anon_sym_when] = ACTIONS(4378),
    [anon_sym_from] = ACTIONS(4378),
    [anon_sym_into] = ACTIONS(4378),
    [anon_sym_join] = ACTIONS(4378),
    [anon_sym_on] = ACTIONS(4378),
    [anon_sym_equals] = ACTIONS(4378),
    [anon_sym_let] = ACTIONS(4378),
    [anon_sym_orderby] = ACTIONS(4378),
    [anon_sym_ascending] = ACTIONS(4378),
    [anon_sym_descending] = ACTIONS(4378),
    [anon_sym_group] = ACTIONS(4378),
    [anon_sym_by] = ACTIONS(4378),
    [anon_sym_select] = ACTIONS(4378),
    [aux_sym_preproc_if_token1] = ACTIONS(4380),
    [aux_sym_preproc_if_token3] = ACTIONS(4380),
    [aux_sym_preproc_else_token1] = ACTIONS(4380),
    [aux_sym_preproc_elif_token1] = ACTIONS(4380),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2690] = {
    [sym_preproc_region] = STATE(2690),
    [sym_preproc_endregion] = STATE(2690),
    [sym_preproc_line] = STATE(2690),
    [sym_preproc_pragma] = STATE(2690),
    [sym_preproc_nullable] = STATE(2690),
    [sym_preproc_error] = STATE(2690),
    [sym_preproc_warning] = STATE(2690),
    [sym_preproc_define] = STATE(2690),
    [sym_preproc_undef] = STATE(2690),
    [sym__identifier_token] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym_alias] = ACTIONS(3379),
    [anon_sym_global] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_unsafe] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_event] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_ref] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_delegate] = ACTIONS(3379),
    [anon_sym_record] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_file] = ACTIONS(3379),
    [anon_sym_fixed] = ACTIONS(3379),
    [anon_sym_internal] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_partial] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_required] = ACTIONS(3379),
    [anon_sym_sealed] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_where] = ACTIONS(3379),
    [anon_sym_notnull] = ACTIONS(3379),
    [anon_sym_unmanaged] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_implicit] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_scoped] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [sym_predefined_type] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_when] = ACTIONS(3379),
    [anon_sym_from] = ACTIONS(3379),
    [anon_sym_into] = ACTIONS(3379),
    [anon_sym_join] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [anon_sym_equals] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_orderby] = ACTIONS(3379),
    [anon_sym_ascending] = ACTIONS(3379),
    [anon_sym_descending] = ACTIONS(3379),
    [anon_sym_group] = ACTIONS(3379),
    [anon_sym_by] = ACTIONS(3379),
    [anon_sym_select] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_if_token3] = ACTIONS(3381),
    [aux_sym_preproc_else_token1] = ACTIONS(3381),
    [aux_sym_preproc_elif_token1] = ACTIONS(3381),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2691] = {
    [sym__variable_designation] = STATE(4210),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2691),
    [sym_preproc_endregion] = STATE(2691),
    [sym_preproc_line] = STATE(2691),
    [sym_preproc_pragma] = STATE(2691),
    [sym_preproc_nullable] = STATE(2691),
    [sym_preproc_error] = STATE(2691),
    [sym_preproc_warning] = STATE(2691),
    [sym_preproc_define] = STATE(2691),
    [sym_preproc_undef] = STATE(2691),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2692] = {
    [sym_preproc_region] = STATE(2692),
    [sym_preproc_endregion] = STATE(2692),
    [sym_preproc_line] = STATE(2692),
    [sym_preproc_pragma] = STATE(2692),
    [sym_preproc_nullable] = STATE(2692),
    [sym_preproc_error] = STATE(2692),
    [sym_preproc_warning] = STATE(2692),
    [sym_preproc_define] = STATE(2692),
    [sym_preproc_undef] = STATE(2692),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3686),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_when] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3686),
    [anon_sym_PLUS_EQ] = ACTIONS(3686),
    [anon_sym_DASH_EQ] = ACTIONS(3686),
    [anon_sym_STAR_EQ] = ACTIONS(3686),
    [anon_sym_SLASH_EQ] = ACTIONS(3686),
    [anon_sym_PERCENT_EQ] = ACTIONS(3686),
    [anon_sym_AMP_EQ] = ACTIONS(3686),
    [anon_sym_CARET_EQ] = ACTIONS(3686),
    [anon_sym_PIPE_EQ] = ACTIONS(3686),
    [anon_sym_LT_LT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3684),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2693] = {
    [sym_preproc_region] = STATE(2693),
    [sym_preproc_endregion] = STATE(2693),
    [sym_preproc_line] = STATE(2693),
    [sym_preproc_pragma] = STATE(2693),
    [sym_preproc_nullable] = STATE(2693),
    [sym_preproc_error] = STATE(2693),
    [sym_preproc_warning] = STATE(2693),
    [sym_preproc_define] = STATE(2693),
    [sym_preproc_undef] = STATE(2693),
    [sym__identifier_token] = ACTIONS(4382),
    [anon_sym_extern] = ACTIONS(4382),
    [anon_sym_alias] = ACTIONS(4382),
    [anon_sym_global] = ACTIONS(4382),
    [anon_sym_using] = ACTIONS(4382),
    [anon_sym_unsafe] = ACTIONS(4382),
    [anon_sym_static] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(4384),
    [anon_sym_LPAREN] = ACTIONS(4384),
    [anon_sym_event] = ACTIONS(4382),
    [anon_sym_namespace] = ACTIONS(4382),
    [anon_sym_class] = ACTIONS(4382),
    [anon_sym_ref] = ACTIONS(4382),
    [anon_sym_struct] = ACTIONS(4382),
    [anon_sym_enum] = ACTIONS(4382),
    [anon_sym_RBRACE] = ACTIONS(4384),
    [anon_sym_interface] = ACTIONS(4382),
    [anon_sym_delegate] = ACTIONS(4382),
    [anon_sym_record] = ACTIONS(4382),
    [anon_sym_abstract] = ACTIONS(4382),
    [anon_sym_async] = ACTIONS(4382),
    [anon_sym_const] = ACTIONS(4382),
    [anon_sym_file] = ACTIONS(4382),
    [anon_sym_fixed] = ACTIONS(4382),
    [anon_sym_internal] = ACTIONS(4382),
    [anon_sym_new] = ACTIONS(4382),
    [anon_sym_override] = ACTIONS(4382),
    [anon_sym_partial] = ACTIONS(4382),
    [anon_sym_private] = ACTIONS(4382),
    [anon_sym_protected] = ACTIONS(4382),
    [anon_sym_public] = ACTIONS(4382),
    [anon_sym_readonly] = ACTIONS(4382),
    [anon_sym_required] = ACTIONS(4382),
    [anon_sym_sealed] = ACTIONS(4382),
    [anon_sym_virtual] = ACTIONS(4382),
    [anon_sym_volatile] = ACTIONS(4382),
    [anon_sym_where] = ACTIONS(4382),
    [anon_sym_notnull] = ACTIONS(4382),
    [anon_sym_unmanaged] = ACTIONS(4382),
    [anon_sym_TILDE] = ACTIONS(4384),
    [anon_sym_implicit] = ACTIONS(4382),
    [anon_sym_explicit] = ACTIONS(4382),
    [anon_sym_scoped] = ACTIONS(4382),
    [anon_sym_var] = ACTIONS(4382),
    [sym_predefined_type] = ACTIONS(4382),
    [anon_sym_yield] = ACTIONS(4382),
    [anon_sym_when] = ACTIONS(4382),
    [anon_sym_from] = ACTIONS(4382),
    [anon_sym_into] = ACTIONS(4382),
    [anon_sym_join] = ACTIONS(4382),
    [anon_sym_on] = ACTIONS(4382),
    [anon_sym_equals] = ACTIONS(4382),
    [anon_sym_let] = ACTIONS(4382),
    [anon_sym_orderby] = ACTIONS(4382),
    [anon_sym_ascending] = ACTIONS(4382),
    [anon_sym_descending] = ACTIONS(4382),
    [anon_sym_group] = ACTIONS(4382),
    [anon_sym_by] = ACTIONS(4382),
    [anon_sym_select] = ACTIONS(4382),
    [aux_sym_preproc_if_token1] = ACTIONS(4384),
    [aux_sym_preproc_if_token3] = ACTIONS(4384),
    [aux_sym_preproc_else_token1] = ACTIONS(4384),
    [aux_sym_preproc_elif_token1] = ACTIONS(4384),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2694] = {
    [sym_preproc_region] = STATE(2694),
    [sym_preproc_endregion] = STATE(2694),
    [sym_preproc_line] = STATE(2694),
    [sym_preproc_pragma] = STATE(2694),
    [sym_preproc_nullable] = STATE(2694),
    [sym_preproc_error] = STATE(2694),
    [sym_preproc_warning] = STATE(2694),
    [sym_preproc_define] = STATE(2694),
    [sym_preproc_undef] = STATE(2694),
    [sym__identifier_token] = ACTIONS(4386),
    [anon_sym_extern] = ACTIONS(4386),
    [anon_sym_alias] = ACTIONS(4386),
    [anon_sym_global] = ACTIONS(4386),
    [anon_sym_using] = ACTIONS(4386),
    [anon_sym_unsafe] = ACTIONS(4386),
    [anon_sym_static] = ACTIONS(4386),
    [anon_sym_LBRACK] = ACTIONS(4388),
    [anon_sym_LPAREN] = ACTIONS(4388),
    [anon_sym_event] = ACTIONS(4386),
    [anon_sym_namespace] = ACTIONS(4386),
    [anon_sym_class] = ACTIONS(4386),
    [anon_sym_ref] = ACTIONS(4386),
    [anon_sym_struct] = ACTIONS(4386),
    [anon_sym_enum] = ACTIONS(4386),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_interface] = ACTIONS(4386),
    [anon_sym_delegate] = ACTIONS(4386),
    [anon_sym_record] = ACTIONS(4386),
    [anon_sym_abstract] = ACTIONS(4386),
    [anon_sym_async] = ACTIONS(4386),
    [anon_sym_const] = ACTIONS(4386),
    [anon_sym_file] = ACTIONS(4386),
    [anon_sym_fixed] = ACTIONS(4386),
    [anon_sym_internal] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4386),
    [anon_sym_override] = ACTIONS(4386),
    [anon_sym_partial] = ACTIONS(4386),
    [anon_sym_private] = ACTIONS(4386),
    [anon_sym_protected] = ACTIONS(4386),
    [anon_sym_public] = ACTIONS(4386),
    [anon_sym_readonly] = ACTIONS(4386),
    [anon_sym_required] = ACTIONS(4386),
    [anon_sym_sealed] = ACTIONS(4386),
    [anon_sym_virtual] = ACTIONS(4386),
    [anon_sym_volatile] = ACTIONS(4386),
    [anon_sym_where] = ACTIONS(4386),
    [anon_sym_notnull] = ACTIONS(4386),
    [anon_sym_unmanaged] = ACTIONS(4386),
    [anon_sym_TILDE] = ACTIONS(4388),
    [anon_sym_implicit] = ACTIONS(4386),
    [anon_sym_explicit] = ACTIONS(4386),
    [anon_sym_scoped] = ACTIONS(4386),
    [anon_sym_var] = ACTIONS(4386),
    [sym_predefined_type] = ACTIONS(4386),
    [anon_sym_yield] = ACTIONS(4386),
    [anon_sym_when] = ACTIONS(4386),
    [anon_sym_from] = ACTIONS(4386),
    [anon_sym_into] = ACTIONS(4386),
    [anon_sym_join] = ACTIONS(4386),
    [anon_sym_on] = ACTIONS(4386),
    [anon_sym_equals] = ACTIONS(4386),
    [anon_sym_let] = ACTIONS(4386),
    [anon_sym_orderby] = ACTIONS(4386),
    [anon_sym_ascending] = ACTIONS(4386),
    [anon_sym_descending] = ACTIONS(4386),
    [anon_sym_group] = ACTIONS(4386),
    [anon_sym_by] = ACTIONS(4386),
    [anon_sym_select] = ACTIONS(4386),
    [aux_sym_preproc_if_token1] = ACTIONS(4388),
    [aux_sym_preproc_if_token3] = ACTIONS(4388),
    [aux_sym_preproc_else_token1] = ACTIONS(4388),
    [aux_sym_preproc_elif_token1] = ACTIONS(4388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2695] = {
    [sym_preproc_region] = STATE(2695),
    [sym_preproc_endregion] = STATE(2695),
    [sym_preproc_line] = STATE(2695),
    [sym_preproc_pragma] = STATE(2695),
    [sym_preproc_nullable] = STATE(2695),
    [sym_preproc_error] = STATE(2695),
    [sym_preproc_warning] = STATE(2695),
    [sym_preproc_define] = STATE(2695),
    [sym_preproc_undef] = STATE(2695),
    [sym__identifier_token] = ACTIONS(4390),
    [anon_sym_extern] = ACTIONS(4390),
    [anon_sym_alias] = ACTIONS(4390),
    [anon_sym_global] = ACTIONS(4390),
    [anon_sym_using] = ACTIONS(4390),
    [anon_sym_unsafe] = ACTIONS(4390),
    [anon_sym_static] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(4392),
    [anon_sym_event] = ACTIONS(4390),
    [anon_sym_namespace] = ACTIONS(4390),
    [anon_sym_class] = ACTIONS(4390),
    [anon_sym_ref] = ACTIONS(4390),
    [anon_sym_struct] = ACTIONS(4390),
    [anon_sym_enum] = ACTIONS(4390),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [anon_sym_interface] = ACTIONS(4390),
    [anon_sym_delegate] = ACTIONS(4390),
    [anon_sym_record] = ACTIONS(4390),
    [anon_sym_abstract] = ACTIONS(4390),
    [anon_sym_async] = ACTIONS(4390),
    [anon_sym_const] = ACTIONS(4390),
    [anon_sym_file] = ACTIONS(4390),
    [anon_sym_fixed] = ACTIONS(4390),
    [anon_sym_internal] = ACTIONS(4390),
    [anon_sym_new] = ACTIONS(4390),
    [anon_sym_override] = ACTIONS(4390),
    [anon_sym_partial] = ACTIONS(4390),
    [anon_sym_private] = ACTIONS(4390),
    [anon_sym_protected] = ACTIONS(4390),
    [anon_sym_public] = ACTIONS(4390),
    [anon_sym_readonly] = ACTIONS(4390),
    [anon_sym_required] = ACTIONS(4390),
    [anon_sym_sealed] = ACTIONS(4390),
    [anon_sym_virtual] = ACTIONS(4390),
    [anon_sym_volatile] = ACTIONS(4390),
    [anon_sym_where] = ACTIONS(4390),
    [anon_sym_notnull] = ACTIONS(4390),
    [anon_sym_unmanaged] = ACTIONS(4390),
    [anon_sym_TILDE] = ACTIONS(4392),
    [anon_sym_implicit] = ACTIONS(4390),
    [anon_sym_explicit] = ACTIONS(4390),
    [anon_sym_scoped] = ACTIONS(4390),
    [anon_sym_var] = ACTIONS(4390),
    [sym_predefined_type] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(4390),
    [anon_sym_when] = ACTIONS(4390),
    [anon_sym_from] = ACTIONS(4390),
    [anon_sym_into] = ACTIONS(4390),
    [anon_sym_join] = ACTIONS(4390),
    [anon_sym_on] = ACTIONS(4390),
    [anon_sym_equals] = ACTIONS(4390),
    [anon_sym_let] = ACTIONS(4390),
    [anon_sym_orderby] = ACTIONS(4390),
    [anon_sym_ascending] = ACTIONS(4390),
    [anon_sym_descending] = ACTIONS(4390),
    [anon_sym_group] = ACTIONS(4390),
    [anon_sym_by] = ACTIONS(4390),
    [anon_sym_select] = ACTIONS(4390),
    [aux_sym_preproc_if_token1] = ACTIONS(4392),
    [aux_sym_preproc_if_token3] = ACTIONS(4392),
    [aux_sym_preproc_else_token1] = ACTIONS(4392),
    [aux_sym_preproc_elif_token1] = ACTIONS(4392),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2696] = {
    [sym_preproc_region] = STATE(2696),
    [sym_preproc_endregion] = STATE(2696),
    [sym_preproc_line] = STATE(2696),
    [sym_preproc_pragma] = STATE(2696),
    [sym_preproc_nullable] = STATE(2696),
    [sym_preproc_error] = STATE(2696),
    [sym_preproc_warning] = STATE(2696),
    [sym_preproc_define] = STATE(2696),
    [sym_preproc_undef] = STATE(2696),
    [sym__identifier_token] = ACTIONS(4394),
    [anon_sym_extern] = ACTIONS(4394),
    [anon_sym_alias] = ACTIONS(4394),
    [anon_sym_global] = ACTIONS(4394),
    [anon_sym_using] = ACTIONS(4394),
    [anon_sym_unsafe] = ACTIONS(4394),
    [anon_sym_static] = ACTIONS(4394),
    [anon_sym_LBRACK] = ACTIONS(4396),
    [anon_sym_LPAREN] = ACTIONS(4396),
    [anon_sym_event] = ACTIONS(4394),
    [anon_sym_namespace] = ACTIONS(4394),
    [anon_sym_class] = ACTIONS(4394),
    [anon_sym_ref] = ACTIONS(4394),
    [anon_sym_struct] = ACTIONS(4394),
    [anon_sym_enum] = ACTIONS(4394),
    [anon_sym_RBRACE] = ACTIONS(4396),
    [anon_sym_interface] = ACTIONS(4394),
    [anon_sym_delegate] = ACTIONS(4394),
    [anon_sym_record] = ACTIONS(4394),
    [anon_sym_abstract] = ACTIONS(4394),
    [anon_sym_async] = ACTIONS(4394),
    [anon_sym_const] = ACTIONS(4394),
    [anon_sym_file] = ACTIONS(4394),
    [anon_sym_fixed] = ACTIONS(4394),
    [anon_sym_internal] = ACTIONS(4394),
    [anon_sym_new] = ACTIONS(4394),
    [anon_sym_override] = ACTIONS(4394),
    [anon_sym_partial] = ACTIONS(4394),
    [anon_sym_private] = ACTIONS(4394),
    [anon_sym_protected] = ACTIONS(4394),
    [anon_sym_public] = ACTIONS(4394),
    [anon_sym_readonly] = ACTIONS(4394),
    [anon_sym_required] = ACTIONS(4394),
    [anon_sym_sealed] = ACTIONS(4394),
    [anon_sym_virtual] = ACTIONS(4394),
    [anon_sym_volatile] = ACTIONS(4394),
    [anon_sym_where] = ACTIONS(4394),
    [anon_sym_notnull] = ACTIONS(4394),
    [anon_sym_unmanaged] = ACTIONS(4394),
    [anon_sym_TILDE] = ACTIONS(4396),
    [anon_sym_implicit] = ACTIONS(4394),
    [anon_sym_explicit] = ACTIONS(4394),
    [anon_sym_scoped] = ACTIONS(4394),
    [anon_sym_var] = ACTIONS(4394),
    [sym_predefined_type] = ACTIONS(4394),
    [anon_sym_yield] = ACTIONS(4394),
    [anon_sym_when] = ACTIONS(4394),
    [anon_sym_from] = ACTIONS(4394),
    [anon_sym_into] = ACTIONS(4394),
    [anon_sym_join] = ACTIONS(4394),
    [anon_sym_on] = ACTIONS(4394),
    [anon_sym_equals] = ACTIONS(4394),
    [anon_sym_let] = ACTIONS(4394),
    [anon_sym_orderby] = ACTIONS(4394),
    [anon_sym_ascending] = ACTIONS(4394),
    [anon_sym_descending] = ACTIONS(4394),
    [anon_sym_group] = ACTIONS(4394),
    [anon_sym_by] = ACTIONS(4394),
    [anon_sym_select] = ACTIONS(4394),
    [aux_sym_preproc_if_token1] = ACTIONS(4396),
    [aux_sym_preproc_if_token3] = ACTIONS(4396),
    [aux_sym_preproc_else_token1] = ACTIONS(4396),
    [aux_sym_preproc_elif_token1] = ACTIONS(4396),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2697] = {
    [sym__variable_designation] = STATE(4193),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2697),
    [sym_preproc_endregion] = STATE(2697),
    [sym_preproc_line] = STATE(2697),
    [sym_preproc_pragma] = STATE(2697),
    [sym_preproc_nullable] = STATE(2697),
    [sym_preproc_error] = STATE(2697),
    [sym_preproc_warning] = STATE(2697),
    [sym_preproc_define] = STATE(2697),
    [sym_preproc_undef] = STATE(2697),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2698] = {
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2698),
    [sym_preproc_endregion] = STATE(2698),
    [sym_preproc_line] = STATE(2698),
    [sym_preproc_pragma] = STATE(2698),
    [sym_preproc_nullable] = STATE(2698),
    [sym_preproc_error] = STATE(2698),
    [sym_preproc_warning] = STATE(2698),
    [sym_preproc_define] = STATE(2698),
    [sym_preproc_undef] = STATE(2698),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2699] = {
    [sym__variable_designation] = STATE(4170),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2699),
    [sym_preproc_endregion] = STATE(2699),
    [sym_preproc_line] = STATE(2699),
    [sym_preproc_pragma] = STATE(2699),
    [sym_preproc_nullable] = STATE(2699),
    [sym_preproc_error] = STATE(2699),
    [sym_preproc_warning] = STATE(2699),
    [sym_preproc_define] = STATE(2699),
    [sym_preproc_undef] = STATE(2699),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3999),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3999),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3999),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3999),
    [anon_sym_orderby] = ACTIONS(3999),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3999),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3999),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2700] = {
    [sym_preproc_region] = STATE(2700),
    [sym_preproc_endregion] = STATE(2700),
    [sym_preproc_line] = STATE(2700),
    [sym_preproc_pragma] = STATE(2700),
    [sym_preproc_nullable] = STATE(2700),
    [sym_preproc_error] = STATE(2700),
    [sym_preproc_warning] = STATE(2700),
    [sym_preproc_define] = STATE(2700),
    [sym_preproc_undef] = STATE(2700),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3672),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_when] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3672),
    [anon_sym_PLUS_EQ] = ACTIONS(3672),
    [anon_sym_DASH_EQ] = ACTIONS(3672),
    [anon_sym_STAR_EQ] = ACTIONS(3672),
    [anon_sym_SLASH_EQ] = ACTIONS(3672),
    [anon_sym_PERCENT_EQ] = ACTIONS(3672),
    [anon_sym_AMP_EQ] = ACTIONS(3672),
    [anon_sym_CARET_EQ] = ACTIONS(3672),
    [anon_sym_PIPE_EQ] = ACTIONS(3672),
    [anon_sym_LT_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3670),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2701] = {
    [sym_preproc_region] = STATE(2701),
    [sym_preproc_endregion] = STATE(2701),
    [sym_preproc_line] = STATE(2701),
    [sym_preproc_pragma] = STATE(2701),
    [sym_preproc_nullable] = STATE(2701),
    [sym_preproc_error] = STATE(2701),
    [sym_preproc_warning] = STATE(2701),
    [sym_preproc_define] = STATE(2701),
    [sym_preproc_undef] = STATE(2701),
    [sym__identifier_token] = ACTIONS(4030),
    [anon_sym_alias] = ACTIONS(4030),
    [anon_sym_global] = ACTIONS(4030),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_file] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_where] = ACTIONS(4030),
    [anon_sym_QMARK] = ACTIONS(4030),
    [anon_sym_notnull] = ACTIONS(4030),
    [anon_sym_unmanaged] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_scoped] = ACTIONS(4030),
    [anon_sym_var] = ACTIONS(4030),
    [anon_sym_yield] = ACTIONS(4030),
    [anon_sym_switch] = ACTIONS(4030),
    [anon_sym_when] = ACTIONS(4030),
    [sym_discard] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4030),
    [anon_sym_or] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_QMARK_QMARK] = ACTIONS(4032),
    [anon_sym_from] = ACTIONS(4030),
    [anon_sym_into] = ACTIONS(4030),
    [anon_sym_join] = ACTIONS(4030),
    [anon_sym_on] = ACTIONS(4030),
    [anon_sym_equals] = ACTIONS(4030),
    [anon_sym_let] = ACTIONS(4030),
    [anon_sym_orderby] = ACTIONS(4030),
    [anon_sym_ascending] = ACTIONS(4030),
    [anon_sym_descending] = ACTIONS(4030),
    [anon_sym_group] = ACTIONS(4030),
    [anon_sym_by] = ACTIONS(4030),
    [anon_sym_select] = ACTIONS(4030),
    [anon_sym_as] = ACTIONS(4030),
    [anon_sym_is] = ACTIONS(4030),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4030),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4032),
  },
  [2702] = {
    [sym_preproc_region] = STATE(2702),
    [sym_preproc_endregion] = STATE(2702),
    [sym_preproc_line] = STATE(2702),
    [sym_preproc_pragma] = STATE(2702),
    [sym_preproc_nullable] = STATE(2702),
    [sym_preproc_error] = STATE(2702),
    [sym_preproc_warning] = STATE(2702),
    [sym_preproc_define] = STATE(2702),
    [sym_preproc_undef] = STATE(2702),
    [sym__identifier_token] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym_alias] = ACTIONS(3391),
    [anon_sym_global] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_unsafe] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_event] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_ref] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_delegate] = ACTIONS(3391),
    [anon_sym_record] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_file] = ACTIONS(3391),
    [anon_sym_fixed] = ACTIONS(3391),
    [anon_sym_internal] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_partial] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_required] = ACTIONS(3391),
    [anon_sym_sealed] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(3391),
    [anon_sym_notnull] = ACTIONS(3391),
    [anon_sym_unmanaged] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_implicit] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_scoped] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [sym_predefined_type] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_when] = ACTIONS(3391),
    [anon_sym_from] = ACTIONS(3391),
    [anon_sym_into] = ACTIONS(3391),
    [anon_sym_join] = ACTIONS(3391),
    [anon_sym_on] = ACTIONS(3391),
    [anon_sym_equals] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_orderby] = ACTIONS(3391),
    [anon_sym_ascending] = ACTIONS(3391),
    [anon_sym_descending] = ACTIONS(3391),
    [anon_sym_group] = ACTIONS(3391),
    [anon_sym_by] = ACTIONS(3391),
    [anon_sym_select] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_if_token3] = ACTIONS(3393),
    [aux_sym_preproc_else_token1] = ACTIONS(3393),
    [aux_sym_preproc_elif_token1] = ACTIONS(3393),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2703] = {
    [sym_preproc_region] = STATE(2703),
    [sym_preproc_endregion] = STATE(2703),
    [sym_preproc_line] = STATE(2703),
    [sym_preproc_pragma] = STATE(2703),
    [sym_preproc_nullable] = STATE(2703),
    [sym_preproc_error] = STATE(2703),
    [sym_preproc_warning] = STATE(2703),
    [sym_preproc_define] = STATE(2703),
    [sym_preproc_undef] = STATE(2703),
    [sym__identifier_token] = ACTIONS(4400),
    [anon_sym_extern] = ACTIONS(4400),
    [anon_sym_alias] = ACTIONS(4400),
    [anon_sym_global] = ACTIONS(4400),
    [anon_sym_using] = ACTIONS(4400),
    [anon_sym_unsafe] = ACTIONS(4400),
    [anon_sym_static] = ACTIONS(4400),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_LPAREN] = ACTIONS(4402),
    [anon_sym_event] = ACTIONS(4400),
    [anon_sym_namespace] = ACTIONS(4400),
    [anon_sym_class] = ACTIONS(4400),
    [anon_sym_ref] = ACTIONS(4400),
    [anon_sym_struct] = ACTIONS(4400),
    [anon_sym_enum] = ACTIONS(4400),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_interface] = ACTIONS(4400),
    [anon_sym_delegate] = ACTIONS(4400),
    [anon_sym_record] = ACTIONS(4400),
    [anon_sym_abstract] = ACTIONS(4400),
    [anon_sym_async] = ACTIONS(4400),
    [anon_sym_const] = ACTIONS(4400),
    [anon_sym_file] = ACTIONS(4400),
    [anon_sym_fixed] = ACTIONS(4400),
    [anon_sym_internal] = ACTIONS(4400),
    [anon_sym_new] = ACTIONS(4400),
    [anon_sym_override] = ACTIONS(4400),
    [anon_sym_partial] = ACTIONS(4400),
    [anon_sym_private] = ACTIONS(4400),
    [anon_sym_protected] = ACTIONS(4400),
    [anon_sym_public] = ACTIONS(4400),
    [anon_sym_readonly] = ACTIONS(4400),
    [anon_sym_required] = ACTIONS(4400),
    [anon_sym_sealed] = ACTIONS(4400),
    [anon_sym_virtual] = ACTIONS(4400),
    [anon_sym_volatile] = ACTIONS(4400),
    [anon_sym_where] = ACTIONS(4400),
    [anon_sym_notnull] = ACTIONS(4400),
    [anon_sym_unmanaged] = ACTIONS(4400),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_implicit] = ACTIONS(4400),
    [anon_sym_explicit] = ACTIONS(4400),
    [anon_sym_scoped] = ACTIONS(4400),
    [anon_sym_var] = ACTIONS(4400),
    [sym_predefined_type] = ACTIONS(4400),
    [anon_sym_yield] = ACTIONS(4400),
    [anon_sym_when] = ACTIONS(4400),
    [anon_sym_from] = ACTIONS(4400),
    [anon_sym_into] = ACTIONS(4400),
    [anon_sym_join] = ACTIONS(4400),
    [anon_sym_on] = ACTIONS(4400),
    [anon_sym_equals] = ACTIONS(4400),
    [anon_sym_let] = ACTIONS(4400),
    [anon_sym_orderby] = ACTIONS(4400),
    [anon_sym_ascending] = ACTIONS(4400),
    [anon_sym_descending] = ACTIONS(4400),
    [anon_sym_group] = ACTIONS(4400),
    [anon_sym_by] = ACTIONS(4400),
    [anon_sym_select] = ACTIONS(4400),
    [aux_sym_preproc_if_token1] = ACTIONS(4402),
    [aux_sym_preproc_if_token3] = ACTIONS(4402),
    [aux_sym_preproc_else_token1] = ACTIONS(4402),
    [aux_sym_preproc_elif_token1] = ACTIONS(4402),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2704] = {
    [sym_preproc_region] = STATE(2704),
    [sym_preproc_endregion] = STATE(2704),
    [sym_preproc_line] = STATE(2704),
    [sym_preproc_pragma] = STATE(2704),
    [sym_preproc_nullable] = STATE(2704),
    [sym_preproc_error] = STATE(2704),
    [sym_preproc_warning] = STATE(2704),
    [sym_preproc_define] = STATE(2704),
    [sym_preproc_undef] = STATE(2704),
    [sym__identifier_token] = ACTIONS(4404),
    [anon_sym_extern] = ACTIONS(4404),
    [anon_sym_alias] = ACTIONS(4404),
    [anon_sym_global] = ACTIONS(4404),
    [anon_sym_using] = ACTIONS(4404),
    [anon_sym_unsafe] = ACTIONS(4404),
    [anon_sym_static] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_event] = ACTIONS(4404),
    [anon_sym_namespace] = ACTIONS(4404),
    [anon_sym_class] = ACTIONS(4404),
    [anon_sym_ref] = ACTIONS(4404),
    [anon_sym_struct] = ACTIONS(4404),
    [anon_sym_enum] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_interface] = ACTIONS(4404),
    [anon_sym_delegate] = ACTIONS(4404),
    [anon_sym_record] = ACTIONS(4404),
    [anon_sym_abstract] = ACTIONS(4404),
    [anon_sym_async] = ACTIONS(4404),
    [anon_sym_const] = ACTIONS(4404),
    [anon_sym_file] = ACTIONS(4404),
    [anon_sym_fixed] = ACTIONS(4404),
    [anon_sym_internal] = ACTIONS(4404),
    [anon_sym_new] = ACTIONS(4404),
    [anon_sym_override] = ACTIONS(4404),
    [anon_sym_partial] = ACTIONS(4404),
    [anon_sym_private] = ACTIONS(4404),
    [anon_sym_protected] = ACTIONS(4404),
    [anon_sym_public] = ACTIONS(4404),
    [anon_sym_readonly] = ACTIONS(4404),
    [anon_sym_required] = ACTIONS(4404),
    [anon_sym_sealed] = ACTIONS(4404),
    [anon_sym_virtual] = ACTIONS(4404),
    [anon_sym_volatile] = ACTIONS(4404),
    [anon_sym_where] = ACTIONS(4404),
    [anon_sym_notnull] = ACTIONS(4404),
    [anon_sym_unmanaged] = ACTIONS(4404),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_implicit] = ACTIONS(4404),
    [anon_sym_explicit] = ACTIONS(4404),
    [anon_sym_scoped] = ACTIONS(4404),
    [anon_sym_var] = ACTIONS(4404),
    [sym_predefined_type] = ACTIONS(4404),
    [anon_sym_yield] = ACTIONS(4404),
    [anon_sym_when] = ACTIONS(4404),
    [anon_sym_from] = ACTIONS(4404),
    [anon_sym_into] = ACTIONS(4404),
    [anon_sym_join] = ACTIONS(4404),
    [anon_sym_on] = ACTIONS(4404),
    [anon_sym_equals] = ACTIONS(4404),
    [anon_sym_let] = ACTIONS(4404),
    [anon_sym_orderby] = ACTIONS(4404),
    [anon_sym_ascending] = ACTIONS(4404),
    [anon_sym_descending] = ACTIONS(4404),
    [anon_sym_group] = ACTIONS(4404),
    [anon_sym_by] = ACTIONS(4404),
    [anon_sym_select] = ACTIONS(4404),
    [aux_sym_preproc_if_token1] = ACTIONS(4406),
    [aux_sym_preproc_if_token3] = ACTIONS(4406),
    [aux_sym_preproc_else_token1] = ACTIONS(4406),
    [aux_sym_preproc_elif_token1] = ACTIONS(4406),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2705] = {
    [sym__variable_designation] = STATE(4189),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2705),
    [sym_preproc_endregion] = STATE(2705),
    [sym_preproc_line] = STATE(2705),
    [sym_preproc_pragma] = STATE(2705),
    [sym_preproc_nullable] = STATE(2705),
    [sym_preproc_error] = STATE(2705),
    [sym_preproc_warning] = STATE(2705),
    [sym_preproc_define] = STATE(2705),
    [sym_preproc_undef] = STATE(2705),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(4003),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_orderby] = ACTIONS(4003),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(4003),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(4003),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2706] = {
    [sym_preproc_region] = STATE(2706),
    [sym_preproc_endregion] = STATE(2706),
    [sym_preproc_line] = STATE(2706),
    [sym_preproc_pragma] = STATE(2706),
    [sym_preproc_nullable] = STATE(2706),
    [sym_preproc_error] = STATE(2706),
    [sym_preproc_warning] = STATE(2706),
    [sym_preproc_define] = STATE(2706),
    [sym_preproc_undef] = STATE(2706),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_when] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_PLUS_EQ] = ACTIONS(3676),
    [anon_sym_DASH_EQ] = ACTIONS(3676),
    [anon_sym_STAR_EQ] = ACTIONS(3676),
    [anon_sym_SLASH_EQ] = ACTIONS(3676),
    [anon_sym_PERCENT_EQ] = ACTIONS(3676),
    [anon_sym_AMP_EQ] = ACTIONS(3676),
    [anon_sym_CARET_EQ] = ACTIONS(3676),
    [anon_sym_PIPE_EQ] = ACTIONS(3676),
    [anon_sym_LT_LT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3674),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2707] = {
    [sym_preproc_region] = STATE(2707),
    [sym_preproc_endregion] = STATE(2707),
    [sym_preproc_line] = STATE(2707),
    [sym_preproc_pragma] = STATE(2707),
    [sym_preproc_nullable] = STATE(2707),
    [sym_preproc_error] = STATE(2707),
    [sym_preproc_warning] = STATE(2707),
    [sym_preproc_define] = STATE(2707),
    [sym_preproc_undef] = STATE(2707),
    [sym__identifier_token] = ACTIONS(4048),
    [anon_sym_alias] = ACTIONS(4048),
    [anon_sym_global] = ACTIONS(4048),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_file] = ACTIONS(4048),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_where] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_notnull] = ACTIONS(4048),
    [anon_sym_unmanaged] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_DOT] = ACTIONS(4048),
    [anon_sym_scoped] = ACTIONS(4048),
    [anon_sym_var] = ACTIONS(4048),
    [anon_sym_yield] = ACTIONS(4048),
    [anon_sym_switch] = ACTIONS(4048),
    [anon_sym_when] = ACTIONS(4048),
    [sym_discard] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4050),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_QMARK_QMARK] = ACTIONS(4050),
    [anon_sym_from] = ACTIONS(4048),
    [anon_sym_into] = ACTIONS(4048),
    [anon_sym_join] = ACTIONS(4048),
    [anon_sym_on] = ACTIONS(4048),
    [anon_sym_equals] = ACTIONS(4048),
    [anon_sym_let] = ACTIONS(4048),
    [anon_sym_orderby] = ACTIONS(4048),
    [anon_sym_ascending] = ACTIONS(4048),
    [anon_sym_descending] = ACTIONS(4048),
    [anon_sym_group] = ACTIONS(4048),
    [anon_sym_by] = ACTIONS(4048),
    [anon_sym_select] = ACTIONS(4048),
    [anon_sym_as] = ACTIONS(4048),
    [anon_sym_is] = ACTIONS(4048),
    [anon_sym_DASH_GT] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4048),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4050),
  },
  [2708] = {
    [sym_preproc_region] = STATE(2708),
    [sym_preproc_endregion] = STATE(2708),
    [sym_preproc_line] = STATE(2708),
    [sym_preproc_pragma] = STATE(2708),
    [sym_preproc_nullable] = STATE(2708),
    [sym_preproc_error] = STATE(2708),
    [sym_preproc_warning] = STATE(2708),
    [sym_preproc_define] = STATE(2708),
    [sym_preproc_undef] = STATE(2708),
    [sym__identifier_token] = ACTIONS(4408),
    [anon_sym_extern] = ACTIONS(4408),
    [anon_sym_alias] = ACTIONS(4408),
    [anon_sym_global] = ACTIONS(4408),
    [anon_sym_using] = ACTIONS(4408),
    [anon_sym_unsafe] = ACTIONS(4408),
    [anon_sym_static] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_LPAREN] = ACTIONS(4410),
    [anon_sym_event] = ACTIONS(4408),
    [anon_sym_namespace] = ACTIONS(4408),
    [anon_sym_class] = ACTIONS(4408),
    [anon_sym_ref] = ACTIONS(4408),
    [anon_sym_struct] = ACTIONS(4408),
    [anon_sym_enum] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_interface] = ACTIONS(4408),
    [anon_sym_delegate] = ACTIONS(4408),
    [anon_sym_record] = ACTIONS(4408),
    [anon_sym_abstract] = ACTIONS(4408),
    [anon_sym_async] = ACTIONS(4408),
    [anon_sym_const] = ACTIONS(4408),
    [anon_sym_file] = ACTIONS(4408),
    [anon_sym_fixed] = ACTIONS(4408),
    [anon_sym_internal] = ACTIONS(4408),
    [anon_sym_new] = ACTIONS(4408),
    [anon_sym_override] = ACTIONS(4408),
    [anon_sym_partial] = ACTIONS(4408),
    [anon_sym_private] = ACTIONS(4408),
    [anon_sym_protected] = ACTIONS(4408),
    [anon_sym_public] = ACTIONS(4408),
    [anon_sym_readonly] = ACTIONS(4408),
    [anon_sym_required] = ACTIONS(4408),
    [anon_sym_sealed] = ACTIONS(4408),
    [anon_sym_virtual] = ACTIONS(4408),
    [anon_sym_volatile] = ACTIONS(4408),
    [anon_sym_where] = ACTIONS(4408),
    [anon_sym_notnull] = ACTIONS(4408),
    [anon_sym_unmanaged] = ACTIONS(4408),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_implicit] = ACTIONS(4408),
    [anon_sym_explicit] = ACTIONS(4408),
    [anon_sym_scoped] = ACTIONS(4408),
    [anon_sym_var] = ACTIONS(4408),
    [sym_predefined_type] = ACTIONS(4408),
    [anon_sym_yield] = ACTIONS(4408),
    [anon_sym_when] = ACTIONS(4408),
    [anon_sym_from] = ACTIONS(4408),
    [anon_sym_into] = ACTIONS(4408),
    [anon_sym_join] = ACTIONS(4408),
    [anon_sym_on] = ACTIONS(4408),
    [anon_sym_equals] = ACTIONS(4408),
    [anon_sym_let] = ACTIONS(4408),
    [anon_sym_orderby] = ACTIONS(4408),
    [anon_sym_ascending] = ACTIONS(4408),
    [anon_sym_descending] = ACTIONS(4408),
    [anon_sym_group] = ACTIONS(4408),
    [anon_sym_by] = ACTIONS(4408),
    [anon_sym_select] = ACTIONS(4408),
    [aux_sym_preproc_if_token1] = ACTIONS(4410),
    [aux_sym_preproc_if_token3] = ACTIONS(4410),
    [aux_sym_preproc_else_token1] = ACTIONS(4410),
    [aux_sym_preproc_elif_token1] = ACTIONS(4410),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2709] = {
    [sym_preproc_region] = STATE(2709),
    [sym_preproc_endregion] = STATE(2709),
    [sym_preproc_line] = STATE(2709),
    [sym_preproc_pragma] = STATE(2709),
    [sym_preproc_nullable] = STATE(2709),
    [sym_preproc_error] = STATE(2709),
    [sym_preproc_warning] = STATE(2709),
    [sym_preproc_define] = STATE(2709),
    [sym_preproc_undef] = STATE(2709),
    [sym__identifier_token] = ACTIONS(4412),
    [anon_sym_extern] = ACTIONS(4412),
    [anon_sym_alias] = ACTIONS(4412),
    [anon_sym_global] = ACTIONS(4412),
    [anon_sym_using] = ACTIONS(4412),
    [anon_sym_unsafe] = ACTIONS(4412),
    [anon_sym_static] = ACTIONS(4412),
    [anon_sym_LBRACK] = ACTIONS(4414),
    [anon_sym_LPAREN] = ACTIONS(4414),
    [anon_sym_event] = ACTIONS(4412),
    [anon_sym_namespace] = ACTIONS(4412),
    [anon_sym_class] = ACTIONS(4412),
    [anon_sym_ref] = ACTIONS(4412),
    [anon_sym_struct] = ACTIONS(4412),
    [anon_sym_enum] = ACTIONS(4412),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_interface] = ACTIONS(4412),
    [anon_sym_delegate] = ACTIONS(4412),
    [anon_sym_record] = ACTIONS(4412),
    [anon_sym_abstract] = ACTIONS(4412),
    [anon_sym_async] = ACTIONS(4412),
    [anon_sym_const] = ACTIONS(4412),
    [anon_sym_file] = ACTIONS(4412),
    [anon_sym_fixed] = ACTIONS(4412),
    [anon_sym_internal] = ACTIONS(4412),
    [anon_sym_new] = ACTIONS(4412),
    [anon_sym_override] = ACTIONS(4412),
    [anon_sym_partial] = ACTIONS(4412),
    [anon_sym_private] = ACTIONS(4412),
    [anon_sym_protected] = ACTIONS(4412),
    [anon_sym_public] = ACTIONS(4412),
    [anon_sym_readonly] = ACTIONS(4412),
    [anon_sym_required] = ACTIONS(4412),
    [anon_sym_sealed] = ACTIONS(4412),
    [anon_sym_virtual] = ACTIONS(4412),
    [anon_sym_volatile] = ACTIONS(4412),
    [anon_sym_where] = ACTIONS(4412),
    [anon_sym_notnull] = ACTIONS(4412),
    [anon_sym_unmanaged] = ACTIONS(4412),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_implicit] = ACTIONS(4412),
    [anon_sym_explicit] = ACTIONS(4412),
    [anon_sym_scoped] = ACTIONS(4412),
    [anon_sym_var] = ACTIONS(4412),
    [sym_predefined_type] = ACTIONS(4412),
    [anon_sym_yield] = ACTIONS(4412),
    [anon_sym_when] = ACTIONS(4412),
    [anon_sym_from] = ACTIONS(4412),
    [anon_sym_into] = ACTIONS(4412),
    [anon_sym_join] = ACTIONS(4412),
    [anon_sym_on] = ACTIONS(4412),
    [anon_sym_equals] = ACTIONS(4412),
    [anon_sym_let] = ACTIONS(4412),
    [anon_sym_orderby] = ACTIONS(4412),
    [anon_sym_ascending] = ACTIONS(4412),
    [anon_sym_descending] = ACTIONS(4412),
    [anon_sym_group] = ACTIONS(4412),
    [anon_sym_by] = ACTIONS(4412),
    [anon_sym_select] = ACTIONS(4412),
    [aux_sym_preproc_if_token1] = ACTIONS(4414),
    [aux_sym_preproc_if_token3] = ACTIONS(4414),
    [aux_sym_preproc_else_token1] = ACTIONS(4414),
    [aux_sym_preproc_elif_token1] = ACTIONS(4414),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2710] = {
    [sym_preproc_region] = STATE(2710),
    [sym_preproc_endregion] = STATE(2710),
    [sym_preproc_line] = STATE(2710),
    [sym_preproc_pragma] = STATE(2710),
    [sym_preproc_nullable] = STATE(2710),
    [sym_preproc_error] = STATE(2710),
    [sym_preproc_warning] = STATE(2710),
    [sym_preproc_define] = STATE(2710),
    [sym_preproc_undef] = STATE(2710),
    [sym__identifier_token] = ACTIONS(4052),
    [anon_sym_alias] = ACTIONS(4052),
    [anon_sym_global] = ACTIONS(4052),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_file] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_where] = ACTIONS(4052),
    [anon_sym_QMARK] = ACTIONS(4052),
    [anon_sym_notnull] = ACTIONS(4052),
    [anon_sym_unmanaged] = ACTIONS(4052),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_scoped] = ACTIONS(4052),
    [anon_sym_var] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4052),
    [anon_sym_switch] = ACTIONS(4052),
    [anon_sym_when] = ACTIONS(4052),
    [sym_discard] = ACTIONS(4052),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4052),
    [anon_sym_or] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_QMARK_QMARK] = ACTIONS(4054),
    [anon_sym_from] = ACTIONS(4052),
    [anon_sym_into] = ACTIONS(4052),
    [anon_sym_join] = ACTIONS(4052),
    [anon_sym_on] = ACTIONS(4052),
    [anon_sym_equals] = ACTIONS(4052),
    [anon_sym_let] = ACTIONS(4052),
    [anon_sym_orderby] = ACTIONS(4052),
    [anon_sym_ascending] = ACTIONS(4052),
    [anon_sym_descending] = ACTIONS(4052),
    [anon_sym_group] = ACTIONS(4052),
    [anon_sym_by] = ACTIONS(4052),
    [anon_sym_select] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4052),
    [anon_sym_is] = ACTIONS(4052),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4052),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4054),
  },
  [2711] = {
    [sym_preproc_region] = STATE(2711),
    [sym_preproc_endregion] = STATE(2711),
    [sym_preproc_line] = STATE(2711),
    [sym_preproc_pragma] = STATE(2711),
    [sym_preproc_nullable] = STATE(2711),
    [sym_preproc_error] = STATE(2711),
    [sym_preproc_warning] = STATE(2711),
    [sym_preproc_define] = STATE(2711),
    [sym_preproc_undef] = STATE(2711),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_EQ_GT] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3731),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_on] = ACTIONS(3731),
    [anon_sym_equals] = ACTIONS(3731),
    [anon_sym_by] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_if_token3] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2712] = {
    [sym_preproc_region] = STATE(2712),
    [sym_preproc_endregion] = STATE(2712),
    [sym_preproc_line] = STATE(2712),
    [sym_preproc_pragma] = STATE(2712),
    [sym_preproc_nullable] = STATE(2712),
    [sym_preproc_error] = STATE(2712),
    [sym_preproc_warning] = STATE(2712),
    [sym_preproc_define] = STATE(2712),
    [sym_preproc_undef] = STATE(2712),
    [anon_sym_SEMI] = ACTIONS(4190),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_RBRACK] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_RPAREN] = ACTIONS(4190),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_in] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_GT_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_EQ_GT] = ACTIONS(4190),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4190),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK] = ACTIONS(4188),
    [anon_sym_on] = ACTIONS(4190),
    [anon_sym_equals] = ACTIONS(4190),
    [anon_sym_by] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_if_token3] = ACTIONS(4190),
    [aux_sym_preproc_else_token1] = ACTIONS(4190),
    [aux_sym_preproc_elif_token1] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2713] = {
    [sym_preproc_region] = STATE(2713),
    [sym_preproc_endregion] = STATE(2713),
    [sym_preproc_line] = STATE(2713),
    [sym_preproc_pragma] = STATE(2713),
    [sym_preproc_nullable] = STATE(2713),
    [sym_preproc_error] = STATE(2713),
    [sym_preproc_warning] = STATE(2713),
    [sym_preproc_define] = STATE(2713),
    [sym_preproc_undef] = STATE(2713),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4419),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4421),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2714] = {
    [sym_preproc_region] = STATE(2714),
    [sym_preproc_endregion] = STATE(2714),
    [sym_preproc_line] = STATE(2714),
    [sym_preproc_pragma] = STATE(2714),
    [sym_preproc_nullable] = STATE(2714),
    [sym_preproc_error] = STATE(2714),
    [sym_preproc_warning] = STATE(2714),
    [sym_preproc_define] = STATE(2714),
    [sym_preproc_undef] = STATE(2714),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3722),
    [anon_sym_DASH_DASH] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_GT_GT_GT] = ACTIONS(3722),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_GT_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_when] = ACTIONS(3711),
    [sym_discard] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3722),
    [anon_sym_and] = ACTIONS(3711),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_QMARK_QMARK] = ACTIONS(3722),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3711),
    [anon_sym_is] = ACTIONS(3711),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_with] = ACTIONS(3711),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3722),
  },
  [2715] = {
    [sym_preproc_region] = STATE(2715),
    [sym_preproc_endregion] = STATE(2715),
    [sym_preproc_line] = STATE(2715),
    [sym_preproc_pragma] = STATE(2715),
    [sym_preproc_nullable] = STATE(2715),
    [sym_preproc_error] = STATE(2715),
    [sym_preproc_warning] = STATE(2715),
    [sym_preproc_define] = STATE(2715),
    [sym_preproc_undef] = STATE(2715),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2716] = {
    [sym_preproc_region] = STATE(2716),
    [sym_preproc_endregion] = STATE(2716),
    [sym_preproc_line] = STATE(2716),
    [sym_preproc_pragma] = STATE(2716),
    [sym_preproc_nullable] = STATE(2716),
    [sym_preproc_error] = STATE(2716),
    [sym_preproc_warning] = STATE(2716),
    [sym_preproc_define] = STATE(2716),
    [sym_preproc_undef] = STATE(2716),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2717] = {
    [sym_preproc_region] = STATE(2717),
    [sym_preproc_endregion] = STATE(2717),
    [sym_preproc_line] = STATE(2717),
    [sym_preproc_pragma] = STATE(2717),
    [sym_preproc_nullable] = STATE(2717),
    [sym_preproc_error] = STATE(2717),
    [sym_preproc_warning] = STATE(2717),
    [sym_preproc_define] = STATE(2717),
    [sym_preproc_undef] = STATE(2717),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2718] = {
    [sym_preproc_region] = STATE(2718),
    [sym_preproc_endregion] = STATE(2718),
    [sym_preproc_line] = STATE(2718),
    [sym_preproc_pragma] = STATE(2718),
    [sym_preproc_nullable] = STATE(2718),
    [sym_preproc_error] = STATE(2718),
    [sym_preproc_warning] = STATE(2718),
    [sym_preproc_define] = STATE(2718),
    [sym_preproc_undef] = STATE(2718),
    [anon_sym_SEMI] = ACTIONS(4295),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4297),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(4300),
    [anon_sym_in] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_BANG] = ACTIONS(4300),
    [anon_sym_PLUS_PLUS] = ACTIONS(4297),
    [anon_sym_DASH_DASH] = ACTIONS(4297),
    [anon_sym_PLUS] = ACTIONS(4300),
    [anon_sym_DASH] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_SLASH] = ACTIONS(4300),
    [anon_sym_PERCENT] = ACTIONS(4300),
    [anon_sym_CARET] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4300),
    [anon_sym_GT_GT] = ACTIONS(4300),
    [anon_sym_GT_GT_GT] = ACTIONS(4300),
    [anon_sym_EQ_EQ] = ACTIONS(4297),
    [anon_sym_BANG_EQ] = ACTIONS(4297),
    [anon_sym_GT_EQ] = ACTIONS(4297),
    [anon_sym_LT_EQ] = ACTIONS(4297),
    [anon_sym_DOT] = ACTIONS(4300),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(4297),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(4297),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4297),
    [anon_sym_QMARK_QMARK] = ACTIONS(4300),
    [anon_sym_on] = ACTIONS(4295),
    [anon_sym_equals] = ACTIONS(4295),
    [anon_sym_by] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(4297),
    [anon_sym_is] = ACTIONS(4297),
    [anon_sym_DASH_GT] = ACTIONS(4297),
    [anon_sym_with] = ACTIONS(4297),
    [aux_sym_preproc_if_token3] = ACTIONS(4295),
    [aux_sym_preproc_else_token1] = ACTIONS(4295),
    [aux_sym_preproc_elif_token1] = ACTIONS(4295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2719] = {
    [sym_preproc_region] = STATE(2719),
    [sym_preproc_endregion] = STATE(2719),
    [sym_preproc_line] = STATE(2719),
    [sym_preproc_pragma] = STATE(2719),
    [sym_preproc_nullable] = STATE(2719),
    [sym_preproc_error] = STATE(2719),
    [sym_preproc_warning] = STATE(2719),
    [sym_preproc_define] = STATE(2719),
    [sym_preproc_undef] = STATE(2719),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4423),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2720] = {
    [sym_preproc_region] = STATE(2720),
    [sym_preproc_endregion] = STATE(2720),
    [sym_preproc_line] = STATE(2720),
    [sym_preproc_pragma] = STATE(2720),
    [sym_preproc_nullable] = STATE(2720),
    [sym_preproc_error] = STATE(2720),
    [sym_preproc_warning] = STATE(2720),
    [sym_preproc_define] = STATE(2720),
    [sym_preproc_undef] = STATE(2720),
    [anon_sym_SEMI] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4225),
    [anon_sym_RBRACK] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4225),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_in] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_PLUS_PLUS] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_EQ_GT] = ACTIONS(4225),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_when] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_PLUS_EQ] = ACTIONS(4225),
    [anon_sym_DASH_EQ] = ACTIONS(4225),
    [anon_sym_STAR_EQ] = ACTIONS(4225),
    [anon_sym_SLASH_EQ] = ACTIONS(4225),
    [anon_sym_PERCENT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4225),
    [anon_sym_CARET_EQ] = ACTIONS(4225),
    [anon_sym_PIPE_EQ] = ACTIONS(4225),
    [anon_sym_LT_LT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4225),
    [anon_sym_AMP_AMP] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK] = ACTIONS(4227),
    [anon_sym_on] = ACTIONS(4225),
    [anon_sym_equals] = ACTIONS(4225),
    [anon_sym_by] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4225),
    [anon_sym_is] = ACTIONS(4225),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_with] = ACTIONS(4225),
    [aux_sym_preproc_if_token3] = ACTIONS(4225),
    [aux_sym_preproc_else_token1] = ACTIONS(4225),
    [aux_sym_preproc_elif_token1] = ACTIONS(4225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2721] = {
    [sym_preproc_region] = STATE(2721),
    [sym_preproc_endregion] = STATE(2721),
    [sym_preproc_line] = STATE(2721),
    [sym_preproc_pragma] = STATE(2721),
    [sym_preproc_nullable] = STATE(2721),
    [sym_preproc_error] = STATE(2721),
    [sym_preproc_warning] = STATE(2721),
    [sym_preproc_define] = STATE(2721),
    [sym_preproc_undef] = STATE(2721),
    [sym__identifier_token] = ACTIONS(4142),
    [anon_sym_alias] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_file] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_notnull] = ACTIONS(4142),
    [anon_sym_unmanaged] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_scoped] = ACTIONS(4142),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_when] = ACTIONS(4142),
    [sym_discard] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4142),
    [anon_sym_join] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4142),
    [anon_sym_equals] = ACTIONS(4142),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_orderby] = ACTIONS(4142),
    [anon_sym_ascending] = ACTIONS(4142),
    [anon_sym_descending] = ACTIONS(4142),
    [anon_sym_group] = ACTIONS(4142),
    [anon_sym_by] = ACTIONS(4142),
    [anon_sym_select] = ACTIONS(4142),
    [anon_sym_as] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4144),
  },
  [2722] = {
    [sym_preproc_region] = STATE(2722),
    [sym_preproc_endregion] = STATE(2722),
    [sym_preproc_line] = STATE(2722),
    [sym_preproc_pragma] = STATE(2722),
    [sym_preproc_nullable] = STATE(2722),
    [sym_preproc_error] = STATE(2722),
    [sym_preproc_warning] = STATE(2722),
    [sym_preproc_define] = STATE(2722),
    [sym_preproc_undef] = STATE(2722),
    [sym__identifier_token] = ACTIONS(4425),
    [anon_sym_extern] = ACTIONS(4425),
    [anon_sym_alias] = ACTIONS(4425),
    [anon_sym_global] = ACTIONS(4425),
    [anon_sym_using] = ACTIONS(4425),
    [anon_sym_unsafe] = ACTIONS(4425),
    [anon_sym_static] = ACTIONS(4425),
    [anon_sym_LBRACK] = ACTIONS(4427),
    [anon_sym_LPAREN] = ACTIONS(4427),
    [anon_sym_event] = ACTIONS(4425),
    [anon_sym_namespace] = ACTIONS(4425),
    [anon_sym_class] = ACTIONS(4425),
    [anon_sym_ref] = ACTIONS(4425),
    [anon_sym_struct] = ACTIONS(4425),
    [anon_sym_enum] = ACTIONS(4425),
    [anon_sym_RBRACE] = ACTIONS(4427),
    [anon_sym_interface] = ACTIONS(4425),
    [anon_sym_delegate] = ACTIONS(4425),
    [anon_sym_record] = ACTIONS(4425),
    [anon_sym_abstract] = ACTIONS(4425),
    [anon_sym_async] = ACTIONS(4425),
    [anon_sym_const] = ACTIONS(4425),
    [anon_sym_file] = ACTIONS(4425),
    [anon_sym_fixed] = ACTIONS(4425),
    [anon_sym_internal] = ACTIONS(4425),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_override] = ACTIONS(4425),
    [anon_sym_partial] = ACTIONS(4425),
    [anon_sym_private] = ACTIONS(4425),
    [anon_sym_protected] = ACTIONS(4425),
    [anon_sym_public] = ACTIONS(4425),
    [anon_sym_readonly] = ACTIONS(4425),
    [anon_sym_required] = ACTIONS(4425),
    [anon_sym_sealed] = ACTIONS(4425),
    [anon_sym_virtual] = ACTIONS(4425),
    [anon_sym_volatile] = ACTIONS(4425),
    [anon_sym_where] = ACTIONS(4425),
    [anon_sym_notnull] = ACTIONS(4425),
    [anon_sym_unmanaged] = ACTIONS(4425),
    [anon_sym_TILDE] = ACTIONS(4427),
    [anon_sym_implicit] = ACTIONS(4425),
    [anon_sym_explicit] = ACTIONS(4425),
    [anon_sym_scoped] = ACTIONS(4425),
    [anon_sym_var] = ACTIONS(4425),
    [sym_predefined_type] = ACTIONS(4425),
    [anon_sym_yield] = ACTIONS(4425),
    [anon_sym_when] = ACTIONS(4425),
    [anon_sym_from] = ACTIONS(4425),
    [anon_sym_into] = ACTIONS(4425),
    [anon_sym_join] = ACTIONS(4425),
    [anon_sym_on] = ACTIONS(4425),
    [anon_sym_equals] = ACTIONS(4425),
    [anon_sym_let] = ACTIONS(4425),
    [anon_sym_orderby] = ACTIONS(4425),
    [anon_sym_ascending] = ACTIONS(4425),
    [anon_sym_descending] = ACTIONS(4425),
    [anon_sym_group] = ACTIONS(4425),
    [anon_sym_by] = ACTIONS(4425),
    [anon_sym_select] = ACTIONS(4425),
    [aux_sym_preproc_if_token1] = ACTIONS(4427),
    [aux_sym_preproc_if_token3] = ACTIONS(4427),
    [aux_sym_preproc_else_token1] = ACTIONS(4427),
    [aux_sym_preproc_elif_token1] = ACTIONS(4427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2723] = {
    [sym_preproc_region] = STATE(2723),
    [sym_preproc_endregion] = STATE(2723),
    [sym_preproc_line] = STATE(2723),
    [sym_preproc_pragma] = STATE(2723),
    [sym_preproc_nullable] = STATE(2723),
    [sym_preproc_error] = STATE(2723),
    [sym_preproc_warning] = STATE(2723),
    [sym_preproc_define] = STATE(2723),
    [sym_preproc_undef] = STATE(2723),
    [sym__identifier_token] = ACTIONS(4429),
    [anon_sym_extern] = ACTIONS(4429),
    [anon_sym_alias] = ACTIONS(4429),
    [anon_sym_global] = ACTIONS(4429),
    [anon_sym_using] = ACTIONS(4429),
    [anon_sym_unsafe] = ACTIONS(4429),
    [anon_sym_static] = ACTIONS(4429),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_event] = ACTIONS(4429),
    [anon_sym_namespace] = ACTIONS(4429),
    [anon_sym_class] = ACTIONS(4429),
    [anon_sym_ref] = ACTIONS(4429),
    [anon_sym_struct] = ACTIONS(4429),
    [anon_sym_enum] = ACTIONS(4429),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_interface] = ACTIONS(4429),
    [anon_sym_delegate] = ACTIONS(4429),
    [anon_sym_record] = ACTIONS(4429),
    [anon_sym_abstract] = ACTIONS(4429),
    [anon_sym_async] = ACTIONS(4429),
    [anon_sym_const] = ACTIONS(4429),
    [anon_sym_file] = ACTIONS(4429),
    [anon_sym_fixed] = ACTIONS(4429),
    [anon_sym_internal] = ACTIONS(4429),
    [anon_sym_new] = ACTIONS(4429),
    [anon_sym_override] = ACTIONS(4429),
    [anon_sym_partial] = ACTIONS(4429),
    [anon_sym_private] = ACTIONS(4429),
    [anon_sym_protected] = ACTIONS(4429),
    [anon_sym_public] = ACTIONS(4429),
    [anon_sym_readonly] = ACTIONS(4429),
    [anon_sym_required] = ACTIONS(4429),
    [anon_sym_sealed] = ACTIONS(4429),
    [anon_sym_virtual] = ACTIONS(4429),
    [anon_sym_volatile] = ACTIONS(4429),
    [anon_sym_where] = ACTIONS(4429),
    [anon_sym_notnull] = ACTIONS(4429),
    [anon_sym_unmanaged] = ACTIONS(4429),
    [anon_sym_TILDE] = ACTIONS(4431),
    [anon_sym_implicit] = ACTIONS(4429),
    [anon_sym_explicit] = ACTIONS(4429),
    [anon_sym_scoped] = ACTIONS(4429),
    [anon_sym_var] = ACTIONS(4429),
    [sym_predefined_type] = ACTIONS(4429),
    [anon_sym_yield] = ACTIONS(4429),
    [anon_sym_when] = ACTIONS(4429),
    [anon_sym_from] = ACTIONS(4429),
    [anon_sym_into] = ACTIONS(4429),
    [anon_sym_join] = ACTIONS(4429),
    [anon_sym_on] = ACTIONS(4429),
    [anon_sym_equals] = ACTIONS(4429),
    [anon_sym_let] = ACTIONS(4429),
    [anon_sym_orderby] = ACTIONS(4429),
    [anon_sym_ascending] = ACTIONS(4429),
    [anon_sym_descending] = ACTIONS(4429),
    [anon_sym_group] = ACTIONS(4429),
    [anon_sym_by] = ACTIONS(4429),
    [anon_sym_select] = ACTIONS(4429),
    [aux_sym_preproc_if_token1] = ACTIONS(4431),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2724] = {
    [sym_preproc_region] = STATE(2724),
    [sym_preproc_endregion] = STATE(2724),
    [sym_preproc_line] = STATE(2724),
    [sym_preproc_pragma] = STATE(2724),
    [sym_preproc_nullable] = STATE(2724),
    [sym_preproc_error] = STATE(2724),
    [sym_preproc_warning] = STATE(2724),
    [sym_preproc_define] = STATE(2724),
    [sym_preproc_undef] = STATE(2724),
    [anon_sym_SEMI] = ACTIONS(4233),
    [anon_sym_EQ] = ACTIONS(4235),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_COLON] = ACTIONS(4233),
    [anon_sym_COMMA] = ACTIONS(4233),
    [anon_sym_RBRACK] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4233),
    [anon_sym_RPAREN] = ACTIONS(4233),
    [anon_sym_RBRACE] = ACTIONS(4233),
    [anon_sym_LT] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4235),
    [anon_sym_in] = ACTIONS(4233),
    [anon_sym_QMARK] = ACTIONS(4235),
    [anon_sym_BANG] = ACTIONS(4235),
    [anon_sym_PLUS_PLUS] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4235),
    [anon_sym_DASH] = ACTIONS(4235),
    [anon_sym_STAR] = ACTIONS(4235),
    [anon_sym_SLASH] = ACTIONS(4235),
    [anon_sym_PERCENT] = ACTIONS(4235),
    [anon_sym_CARET] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4235),
    [anon_sym_LT_LT] = ACTIONS(4235),
    [anon_sym_GT_GT] = ACTIONS(4235),
    [anon_sym_GT_GT_GT] = ACTIONS(4235),
    [anon_sym_EQ_EQ] = ACTIONS(4233),
    [anon_sym_BANG_EQ] = ACTIONS(4233),
    [anon_sym_GT_EQ] = ACTIONS(4233),
    [anon_sym_LT_EQ] = ACTIONS(4233),
    [anon_sym_DOT] = ACTIONS(4235),
    [anon_sym_EQ_GT] = ACTIONS(4233),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_when] = ACTIONS(4233),
    [anon_sym_DOT_DOT] = ACTIONS(4233),
    [anon_sym_and] = ACTIONS(4233),
    [anon_sym_or] = ACTIONS(4233),
    [anon_sym_PLUS_EQ] = ACTIONS(4233),
    [anon_sym_DASH_EQ] = ACTIONS(4233),
    [anon_sym_STAR_EQ] = ACTIONS(4233),
    [anon_sym_SLASH_EQ] = ACTIONS(4233),
    [anon_sym_PERCENT_EQ] = ACTIONS(4233),
    [anon_sym_AMP_EQ] = ACTIONS(4233),
    [anon_sym_CARET_EQ] = ACTIONS(4233),
    [anon_sym_PIPE_EQ] = ACTIONS(4233),
    [anon_sym_LT_LT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4233),
    [anon_sym_AMP_AMP] = ACTIONS(4233),
    [anon_sym_PIPE_PIPE] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK] = ACTIONS(4235),
    [anon_sym_on] = ACTIONS(4233),
    [anon_sym_equals] = ACTIONS(4233),
    [anon_sym_by] = ACTIONS(4233),
    [anon_sym_as] = ACTIONS(4233),
    [anon_sym_is] = ACTIONS(4233),
    [anon_sym_DASH_GT] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [aux_sym_preproc_if_token3] = ACTIONS(4233),
    [aux_sym_preproc_else_token1] = ACTIONS(4233),
    [aux_sym_preproc_elif_token1] = ACTIONS(4233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2725] = {
    [sym_preproc_region] = STATE(2725),
    [sym_preproc_endregion] = STATE(2725),
    [sym_preproc_line] = STATE(2725),
    [sym_preproc_pragma] = STATE(2725),
    [sym_preproc_nullable] = STATE(2725),
    [sym_preproc_error] = STATE(2725),
    [sym_preproc_warning] = STATE(2725),
    [sym_preproc_define] = STATE(2725),
    [sym_preproc_undef] = STATE(2725),
    [sym__identifier_token] = ACTIONS(4433),
    [anon_sym_extern] = ACTIONS(4433),
    [anon_sym_alias] = ACTIONS(4433),
    [anon_sym_global] = ACTIONS(4433),
    [anon_sym_using] = ACTIONS(4433),
    [anon_sym_unsafe] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(4433),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_LPAREN] = ACTIONS(4435),
    [anon_sym_event] = ACTIONS(4433),
    [anon_sym_namespace] = ACTIONS(4433),
    [anon_sym_class] = ACTIONS(4433),
    [anon_sym_ref] = ACTIONS(4433),
    [anon_sym_struct] = ACTIONS(4433),
    [anon_sym_enum] = ACTIONS(4433),
    [anon_sym_RBRACE] = ACTIONS(4435),
    [anon_sym_interface] = ACTIONS(4433),
    [anon_sym_delegate] = ACTIONS(4433),
    [anon_sym_record] = ACTIONS(4433),
    [anon_sym_abstract] = ACTIONS(4433),
    [anon_sym_async] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4433),
    [anon_sym_fixed] = ACTIONS(4433),
    [anon_sym_internal] = ACTIONS(4433),
    [anon_sym_new] = ACTIONS(4433),
    [anon_sym_override] = ACTIONS(4433),
    [anon_sym_partial] = ACTIONS(4433),
    [anon_sym_private] = ACTIONS(4433),
    [anon_sym_protected] = ACTIONS(4433),
    [anon_sym_public] = ACTIONS(4433),
    [anon_sym_readonly] = ACTIONS(4433),
    [anon_sym_required] = ACTIONS(4433),
    [anon_sym_sealed] = ACTIONS(4433),
    [anon_sym_virtual] = ACTIONS(4433),
    [anon_sym_volatile] = ACTIONS(4433),
    [anon_sym_where] = ACTIONS(4433),
    [anon_sym_notnull] = ACTIONS(4433),
    [anon_sym_unmanaged] = ACTIONS(4433),
    [anon_sym_TILDE] = ACTIONS(4435),
    [anon_sym_implicit] = ACTIONS(4433),
    [anon_sym_explicit] = ACTIONS(4433),
    [anon_sym_scoped] = ACTIONS(4433),
    [anon_sym_var] = ACTIONS(4433),
    [sym_predefined_type] = ACTIONS(4433),
    [anon_sym_yield] = ACTIONS(4433),
    [anon_sym_when] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4433),
    [anon_sym_into] = ACTIONS(4433),
    [anon_sym_join] = ACTIONS(4433),
    [anon_sym_on] = ACTIONS(4433),
    [anon_sym_equals] = ACTIONS(4433),
    [anon_sym_let] = ACTIONS(4433),
    [anon_sym_orderby] = ACTIONS(4433),
    [anon_sym_ascending] = ACTIONS(4433),
    [anon_sym_descending] = ACTIONS(4433),
    [anon_sym_group] = ACTIONS(4433),
    [anon_sym_by] = ACTIONS(4433),
    [anon_sym_select] = ACTIONS(4433),
    [aux_sym_preproc_if_token1] = ACTIONS(4435),
    [aux_sym_preproc_if_token3] = ACTIONS(4435),
    [aux_sym_preproc_else_token1] = ACTIONS(4435),
    [aux_sym_preproc_elif_token1] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2726] = {
    [sym_preproc_region] = STATE(2726),
    [sym_preproc_endregion] = STATE(2726),
    [sym_preproc_line] = STATE(2726),
    [sym_preproc_pragma] = STATE(2726),
    [sym_preproc_nullable] = STATE(2726),
    [sym_preproc_error] = STATE(2726),
    [sym_preproc_warning] = STATE(2726),
    [sym_preproc_define] = STATE(2726),
    [sym_preproc_undef] = STATE(2726),
    [sym__identifier_token] = ACTIONS(4437),
    [anon_sym_extern] = ACTIONS(4437),
    [anon_sym_alias] = ACTIONS(4437),
    [anon_sym_global] = ACTIONS(4437),
    [anon_sym_using] = ACTIONS(4437),
    [anon_sym_unsafe] = ACTIONS(4437),
    [anon_sym_static] = ACTIONS(4437),
    [anon_sym_LBRACK] = ACTIONS(4439),
    [anon_sym_LPAREN] = ACTIONS(4439),
    [anon_sym_event] = ACTIONS(4437),
    [anon_sym_namespace] = ACTIONS(4437),
    [anon_sym_class] = ACTIONS(4437),
    [anon_sym_ref] = ACTIONS(4437),
    [anon_sym_struct] = ACTIONS(4437),
    [anon_sym_enum] = ACTIONS(4437),
    [anon_sym_RBRACE] = ACTIONS(4439),
    [anon_sym_interface] = ACTIONS(4437),
    [anon_sym_delegate] = ACTIONS(4437),
    [anon_sym_record] = ACTIONS(4437),
    [anon_sym_abstract] = ACTIONS(4437),
    [anon_sym_async] = ACTIONS(4437),
    [anon_sym_const] = ACTIONS(4437),
    [anon_sym_file] = ACTIONS(4437),
    [anon_sym_fixed] = ACTIONS(4437),
    [anon_sym_internal] = ACTIONS(4437),
    [anon_sym_new] = ACTIONS(4437),
    [anon_sym_override] = ACTIONS(4437),
    [anon_sym_partial] = ACTIONS(4437),
    [anon_sym_private] = ACTIONS(4437),
    [anon_sym_protected] = ACTIONS(4437),
    [anon_sym_public] = ACTIONS(4437),
    [anon_sym_readonly] = ACTIONS(4437),
    [anon_sym_required] = ACTIONS(4437),
    [anon_sym_sealed] = ACTIONS(4437),
    [anon_sym_virtual] = ACTIONS(4437),
    [anon_sym_volatile] = ACTIONS(4437),
    [anon_sym_where] = ACTIONS(4437),
    [anon_sym_notnull] = ACTIONS(4437),
    [anon_sym_unmanaged] = ACTIONS(4437),
    [anon_sym_TILDE] = ACTIONS(4439),
    [anon_sym_implicit] = ACTIONS(4437),
    [anon_sym_explicit] = ACTIONS(4437),
    [anon_sym_scoped] = ACTIONS(4437),
    [anon_sym_var] = ACTIONS(4437),
    [sym_predefined_type] = ACTIONS(4437),
    [anon_sym_yield] = ACTIONS(4437),
    [anon_sym_when] = ACTIONS(4437),
    [anon_sym_from] = ACTIONS(4437),
    [anon_sym_into] = ACTIONS(4437),
    [anon_sym_join] = ACTIONS(4437),
    [anon_sym_on] = ACTIONS(4437),
    [anon_sym_equals] = ACTIONS(4437),
    [anon_sym_let] = ACTIONS(4437),
    [anon_sym_orderby] = ACTIONS(4437),
    [anon_sym_ascending] = ACTIONS(4437),
    [anon_sym_descending] = ACTIONS(4437),
    [anon_sym_group] = ACTIONS(4437),
    [anon_sym_by] = ACTIONS(4437),
    [anon_sym_select] = ACTIONS(4437),
    [aux_sym_preproc_if_token1] = ACTIONS(4439),
    [aux_sym_preproc_if_token3] = ACTIONS(4439),
    [aux_sym_preproc_else_token1] = ACTIONS(4439),
    [aux_sym_preproc_elif_token1] = ACTIONS(4439),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2727] = {
    [sym_preproc_region] = STATE(2727),
    [sym_preproc_endregion] = STATE(2727),
    [sym_preproc_line] = STATE(2727),
    [sym_preproc_pragma] = STATE(2727),
    [sym_preproc_nullable] = STATE(2727),
    [sym_preproc_error] = STATE(2727),
    [sym_preproc_warning] = STATE(2727),
    [sym_preproc_define] = STATE(2727),
    [sym_preproc_undef] = STATE(2727),
    [anon_sym_SEMI] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_in] = ACTIONS(4239),
    [anon_sym_QMARK] = ACTIONS(4241),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4241),
    [anon_sym_SLASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_CARET] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(4241),
    [anon_sym_GT_GT_GT] = ACTIONS(4241),
    [anon_sym_EQ_EQ] = ACTIONS(4239),
    [anon_sym_BANG_EQ] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4241),
    [anon_sym_EQ_GT] = ACTIONS(4239),
    [anon_sym_switch] = ACTIONS(4239),
    [anon_sym_when] = ACTIONS(4239),
    [anon_sym_DOT_DOT] = ACTIONS(4239),
    [anon_sym_and] = ACTIONS(4239),
    [anon_sym_or] = ACTIONS(4239),
    [anon_sym_PLUS_EQ] = ACTIONS(4239),
    [anon_sym_DASH_EQ] = ACTIONS(4239),
    [anon_sym_STAR_EQ] = ACTIONS(4239),
    [anon_sym_SLASH_EQ] = ACTIONS(4239),
    [anon_sym_PERCENT_EQ] = ACTIONS(4239),
    [anon_sym_AMP_EQ] = ACTIONS(4239),
    [anon_sym_CARET_EQ] = ACTIONS(4239),
    [anon_sym_PIPE_EQ] = ACTIONS(4239),
    [anon_sym_LT_LT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK] = ACTIONS(4241),
    [anon_sym_on] = ACTIONS(4239),
    [anon_sym_equals] = ACTIONS(4239),
    [anon_sym_by] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_is] = ACTIONS(4239),
    [anon_sym_DASH_GT] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4239),
    [aux_sym_preproc_if_token3] = ACTIONS(4239),
    [aux_sym_preproc_else_token1] = ACTIONS(4239),
    [aux_sym_preproc_elif_token1] = ACTIONS(4239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2728] = {
    [sym_preproc_region] = STATE(2728),
    [sym_preproc_endregion] = STATE(2728),
    [sym_preproc_line] = STATE(2728),
    [sym_preproc_pragma] = STATE(2728),
    [sym_preproc_nullable] = STATE(2728),
    [sym_preproc_error] = STATE(2728),
    [sym_preproc_warning] = STATE(2728),
    [sym_preproc_define] = STATE(2728),
    [sym_preproc_undef] = STATE(2728),
    [anon_sym_SEMI] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_RBRACK] = ACTIONS(4213),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_RPAREN] = ACTIONS(4213),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4213),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_BANG] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_GT_GT_GT] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_EQ_GT] = ACTIONS(4213),
    [anon_sym_switch] = ACTIONS(4213),
    [anon_sym_when] = ACTIONS(4213),
    [anon_sym_DOT_DOT] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(4213),
    [anon_sym_or] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK] = ACTIONS(4215),
    [anon_sym_on] = ACTIONS(4213),
    [anon_sym_equals] = ACTIONS(4213),
    [anon_sym_by] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(4213),
    [anon_sym_is] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [anon_sym_with] = ACTIONS(4213),
    [aux_sym_preproc_if_token3] = ACTIONS(4213),
    [aux_sym_preproc_else_token1] = ACTIONS(4213),
    [aux_sym_preproc_elif_token1] = ACTIONS(4213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2729] = {
    [sym_preproc_region] = STATE(2729),
    [sym_preproc_endregion] = STATE(2729),
    [sym_preproc_line] = STATE(2729),
    [sym_preproc_pragma] = STATE(2729),
    [sym_preproc_nullable] = STATE(2729),
    [sym_preproc_error] = STATE(2729),
    [sym_preproc_warning] = STATE(2729),
    [sym_preproc_define] = STATE(2729),
    [sym_preproc_undef] = STATE(2729),
    [sym__identifier_token] = ACTIONS(3165),
    [anon_sym_extern] = ACTIONS(3165),
    [anon_sym_alias] = ACTIONS(3165),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_using] = ACTIONS(3165),
    [anon_sym_unsafe] = ACTIONS(3165),
    [anon_sym_static] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_event] = ACTIONS(3165),
    [anon_sym_namespace] = ACTIONS(3165),
    [anon_sym_class] = ACTIONS(3165),
    [anon_sym_ref] = ACTIONS(3165),
    [anon_sym_struct] = ACTIONS(3165),
    [anon_sym_enum] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3165),
    [anon_sym_delegate] = ACTIONS(3165),
    [anon_sym_record] = ACTIONS(3165),
    [anon_sym_abstract] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_const] = ACTIONS(3165),
    [anon_sym_file] = ACTIONS(3165),
    [anon_sym_fixed] = ACTIONS(3165),
    [anon_sym_internal] = ACTIONS(3165),
    [anon_sym_new] = ACTIONS(3165),
    [anon_sym_override] = ACTIONS(3165),
    [anon_sym_partial] = ACTIONS(3165),
    [anon_sym_private] = ACTIONS(3165),
    [anon_sym_protected] = ACTIONS(3165),
    [anon_sym_public] = ACTIONS(3165),
    [anon_sym_readonly] = ACTIONS(3165),
    [anon_sym_required] = ACTIONS(3165),
    [anon_sym_sealed] = ACTIONS(3165),
    [anon_sym_virtual] = ACTIONS(3165),
    [anon_sym_volatile] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3165),
    [anon_sym_notnull] = ACTIONS(3165),
    [anon_sym_unmanaged] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_implicit] = ACTIONS(3165),
    [anon_sym_explicit] = ACTIONS(3165),
    [anon_sym_scoped] = ACTIONS(3165),
    [anon_sym_var] = ACTIONS(3165),
    [sym_predefined_type] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_into] = ACTIONS(3165),
    [anon_sym_join] = ACTIONS(3165),
    [anon_sym_on] = ACTIONS(3165),
    [anon_sym_equals] = ACTIONS(3165),
    [anon_sym_let] = ACTIONS(3165),
    [anon_sym_orderby] = ACTIONS(3165),
    [anon_sym_ascending] = ACTIONS(3165),
    [anon_sym_descending] = ACTIONS(3165),
    [anon_sym_group] = ACTIONS(3165),
    [anon_sym_by] = ACTIONS(3165),
    [anon_sym_select] = ACTIONS(3165),
    [aux_sym_preproc_if_token1] = ACTIONS(3167),
    [aux_sym_preproc_if_token3] = ACTIONS(3167),
    [aux_sym_preproc_else_token1] = ACTIONS(3167),
    [aux_sym_preproc_elif_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2730] = {
    [sym_preproc_region] = STATE(2730),
    [sym_preproc_endregion] = STATE(2730),
    [sym_preproc_line] = STATE(2730),
    [sym_preproc_pragma] = STATE(2730),
    [sym_preproc_nullable] = STATE(2730),
    [sym_preproc_error] = STATE(2730),
    [sym_preproc_warning] = STATE(2730),
    [sym_preproc_define] = STATE(2730),
    [sym_preproc_undef] = STATE(2730),
    [sym__identifier_token] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym_alias] = ACTIONS(3427),
    [anon_sym_global] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_unsafe] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_event] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_ref] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_delegate] = ACTIONS(3427),
    [anon_sym_record] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_file] = ACTIONS(3427),
    [anon_sym_fixed] = ACTIONS(3427),
    [anon_sym_internal] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_partial] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_required] = ACTIONS(3427),
    [anon_sym_sealed] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_where] = ACTIONS(3427),
    [anon_sym_notnull] = ACTIONS(3427),
    [anon_sym_unmanaged] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_implicit] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_scoped] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [sym_predefined_type] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_from] = ACTIONS(3427),
    [anon_sym_into] = ACTIONS(3427),
    [anon_sym_join] = ACTIONS(3427),
    [anon_sym_on] = ACTIONS(3427),
    [anon_sym_equals] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_orderby] = ACTIONS(3427),
    [anon_sym_ascending] = ACTIONS(3427),
    [anon_sym_descending] = ACTIONS(3427),
    [anon_sym_group] = ACTIONS(3427),
    [anon_sym_by] = ACTIONS(3427),
    [anon_sym_select] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token3] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2731] = {
    [sym_preproc_region] = STATE(2731),
    [sym_preproc_endregion] = STATE(2731),
    [sym_preproc_line] = STATE(2731),
    [sym_preproc_pragma] = STATE(2731),
    [sym_preproc_nullable] = STATE(2731),
    [sym_preproc_error] = STATE(2731),
    [sym_preproc_warning] = STATE(2731),
    [sym_preproc_define] = STATE(2731),
    [sym_preproc_undef] = STATE(2731),
    [sym__identifier_token] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym_alias] = ACTIONS(3431),
    [anon_sym_global] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_unsafe] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_event] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_ref] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_delegate] = ACTIONS(3431),
    [anon_sym_record] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_file] = ACTIONS(3431),
    [anon_sym_fixed] = ACTIONS(3431),
    [anon_sym_internal] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_partial] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_required] = ACTIONS(3431),
    [anon_sym_sealed] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_where] = ACTIONS(3431),
    [anon_sym_notnull] = ACTIONS(3431),
    [anon_sym_unmanaged] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_implicit] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_scoped] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [sym_predefined_type] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_when] = ACTIONS(3431),
    [anon_sym_from] = ACTIONS(3431),
    [anon_sym_into] = ACTIONS(3431),
    [anon_sym_join] = ACTIONS(3431),
    [anon_sym_on] = ACTIONS(3431),
    [anon_sym_equals] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_orderby] = ACTIONS(3431),
    [anon_sym_ascending] = ACTIONS(3431),
    [anon_sym_descending] = ACTIONS(3431),
    [anon_sym_group] = ACTIONS(3431),
    [anon_sym_by] = ACTIONS(3431),
    [anon_sym_select] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token3] = ACTIONS(3433),
    [aux_sym_preproc_else_token1] = ACTIONS(3433),
    [aux_sym_preproc_elif_token1] = ACTIONS(3433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2732] = {
    [sym_preproc_region] = STATE(2732),
    [sym_preproc_endregion] = STATE(2732),
    [sym_preproc_line] = STATE(2732),
    [sym_preproc_pragma] = STATE(2732),
    [sym_preproc_nullable] = STATE(2732),
    [sym_preproc_error] = STATE(2732),
    [sym_preproc_warning] = STATE(2732),
    [sym_preproc_define] = STATE(2732),
    [sym_preproc_undef] = STATE(2732),
    [sym__identifier_token] = ACTIONS(4106),
    [anon_sym_alias] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4106),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_file] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_where] = ACTIONS(4106),
    [anon_sym_QMARK] = ACTIONS(4106),
    [anon_sym_notnull] = ACTIONS(4106),
    [anon_sym_unmanaged] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4106),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4106),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_scoped] = ACTIONS(4106),
    [anon_sym_var] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4106),
    [anon_sym_switch] = ACTIONS(4106),
    [anon_sym_when] = ACTIONS(4106),
    [sym_discard] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4106),
    [anon_sym_into] = ACTIONS(4106),
    [anon_sym_join] = ACTIONS(4106),
    [anon_sym_on] = ACTIONS(4106),
    [anon_sym_equals] = ACTIONS(4106),
    [anon_sym_let] = ACTIONS(4106),
    [anon_sym_orderby] = ACTIONS(4106),
    [anon_sym_ascending] = ACTIONS(4106),
    [anon_sym_descending] = ACTIONS(4106),
    [anon_sym_group] = ACTIONS(4106),
    [anon_sym_by] = ACTIONS(4106),
    [anon_sym_select] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4106),
    [anon_sym_is] = ACTIONS(4106),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4106),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4108),
  },
  [2733] = {
    [sym_preproc_region] = STATE(2733),
    [sym_preproc_endregion] = STATE(2733),
    [sym_preproc_line] = STATE(2733),
    [sym_preproc_pragma] = STATE(2733),
    [sym_preproc_nullable] = STATE(2733),
    [sym_preproc_error] = STATE(2733),
    [sym_preproc_warning] = STATE(2733),
    [sym_preproc_define] = STATE(2733),
    [sym_preproc_undef] = STATE(2733),
    [sym__identifier_token] = ACTIONS(4441),
    [anon_sym_extern] = ACTIONS(4441),
    [anon_sym_alias] = ACTIONS(4441),
    [anon_sym_global] = ACTIONS(4441),
    [anon_sym_using] = ACTIONS(4441),
    [anon_sym_unsafe] = ACTIONS(4441),
    [anon_sym_static] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_event] = ACTIONS(4441),
    [anon_sym_namespace] = ACTIONS(4441),
    [anon_sym_class] = ACTIONS(4441),
    [anon_sym_ref] = ACTIONS(4441),
    [anon_sym_struct] = ACTIONS(4441),
    [anon_sym_enum] = ACTIONS(4441),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_interface] = ACTIONS(4441),
    [anon_sym_delegate] = ACTIONS(4441),
    [anon_sym_record] = ACTIONS(4441),
    [anon_sym_abstract] = ACTIONS(4441),
    [anon_sym_async] = ACTIONS(4441),
    [anon_sym_const] = ACTIONS(4441),
    [anon_sym_file] = ACTIONS(4441),
    [anon_sym_fixed] = ACTIONS(4441),
    [anon_sym_internal] = ACTIONS(4441),
    [anon_sym_new] = ACTIONS(4441),
    [anon_sym_override] = ACTIONS(4441),
    [anon_sym_partial] = ACTIONS(4441),
    [anon_sym_private] = ACTIONS(4441),
    [anon_sym_protected] = ACTIONS(4441),
    [anon_sym_public] = ACTIONS(4441),
    [anon_sym_readonly] = ACTIONS(4441),
    [anon_sym_required] = ACTIONS(4441),
    [anon_sym_sealed] = ACTIONS(4441),
    [anon_sym_virtual] = ACTIONS(4441),
    [anon_sym_volatile] = ACTIONS(4441),
    [anon_sym_where] = ACTIONS(4441),
    [anon_sym_notnull] = ACTIONS(4441),
    [anon_sym_unmanaged] = ACTIONS(4441),
    [anon_sym_TILDE] = ACTIONS(4443),
    [anon_sym_implicit] = ACTIONS(4441),
    [anon_sym_explicit] = ACTIONS(4441),
    [anon_sym_scoped] = ACTIONS(4441),
    [anon_sym_var] = ACTIONS(4441),
    [sym_predefined_type] = ACTIONS(4441),
    [anon_sym_yield] = ACTIONS(4441),
    [anon_sym_when] = ACTIONS(4441),
    [anon_sym_from] = ACTIONS(4441),
    [anon_sym_into] = ACTIONS(4441),
    [anon_sym_join] = ACTIONS(4441),
    [anon_sym_on] = ACTIONS(4441),
    [anon_sym_equals] = ACTIONS(4441),
    [anon_sym_let] = ACTIONS(4441),
    [anon_sym_orderby] = ACTIONS(4441),
    [anon_sym_ascending] = ACTIONS(4441),
    [anon_sym_descending] = ACTIONS(4441),
    [anon_sym_group] = ACTIONS(4441),
    [anon_sym_by] = ACTIONS(4441),
    [anon_sym_select] = ACTIONS(4441),
    [aux_sym_preproc_if_token1] = ACTIONS(4443),
    [aux_sym_preproc_if_token3] = ACTIONS(4443),
    [aux_sym_preproc_else_token1] = ACTIONS(4443),
    [aux_sym_preproc_elif_token1] = ACTIONS(4443),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2734] = {
    [sym_preproc_region] = STATE(2734),
    [sym_preproc_endregion] = STATE(2734),
    [sym_preproc_line] = STATE(2734),
    [sym_preproc_pragma] = STATE(2734),
    [sym_preproc_nullable] = STATE(2734),
    [sym_preproc_error] = STATE(2734),
    [sym_preproc_warning] = STATE(2734),
    [sym_preproc_define] = STATE(2734),
    [sym_preproc_undef] = STATE(2734),
    [sym__identifier_token] = ACTIONS(4445),
    [anon_sym_extern] = ACTIONS(4445),
    [anon_sym_alias] = ACTIONS(4445),
    [anon_sym_global] = ACTIONS(4445),
    [anon_sym_using] = ACTIONS(4445),
    [anon_sym_unsafe] = ACTIONS(4445),
    [anon_sym_static] = ACTIONS(4445),
    [anon_sym_LBRACK] = ACTIONS(4447),
    [anon_sym_LPAREN] = ACTIONS(4447),
    [anon_sym_event] = ACTIONS(4445),
    [anon_sym_namespace] = ACTIONS(4445),
    [anon_sym_class] = ACTIONS(4445),
    [anon_sym_ref] = ACTIONS(4445),
    [anon_sym_struct] = ACTIONS(4445),
    [anon_sym_enum] = ACTIONS(4445),
    [anon_sym_RBRACE] = ACTIONS(4447),
    [anon_sym_interface] = ACTIONS(4445),
    [anon_sym_delegate] = ACTIONS(4445),
    [anon_sym_record] = ACTIONS(4445),
    [anon_sym_abstract] = ACTIONS(4445),
    [anon_sym_async] = ACTIONS(4445),
    [anon_sym_const] = ACTIONS(4445),
    [anon_sym_file] = ACTIONS(4445),
    [anon_sym_fixed] = ACTIONS(4445),
    [anon_sym_internal] = ACTIONS(4445),
    [anon_sym_new] = ACTIONS(4445),
    [anon_sym_override] = ACTIONS(4445),
    [anon_sym_partial] = ACTIONS(4445),
    [anon_sym_private] = ACTIONS(4445),
    [anon_sym_protected] = ACTIONS(4445),
    [anon_sym_public] = ACTIONS(4445),
    [anon_sym_readonly] = ACTIONS(4445),
    [anon_sym_required] = ACTIONS(4445),
    [anon_sym_sealed] = ACTIONS(4445),
    [anon_sym_virtual] = ACTIONS(4445),
    [anon_sym_volatile] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4445),
    [anon_sym_unmanaged] = ACTIONS(4445),
    [anon_sym_TILDE] = ACTIONS(4447),
    [anon_sym_implicit] = ACTIONS(4445),
    [anon_sym_explicit] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4445),
    [anon_sym_var] = ACTIONS(4445),
    [sym_predefined_type] = ACTIONS(4445),
    [anon_sym_yield] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4445),
    [anon_sym_from] = ACTIONS(4445),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4445),
    [anon_sym_on] = ACTIONS(4445),
    [anon_sym_equals] = ACTIONS(4445),
    [anon_sym_let] = ACTIONS(4445),
    [anon_sym_orderby] = ACTIONS(4445),
    [anon_sym_ascending] = ACTIONS(4445),
    [anon_sym_descending] = ACTIONS(4445),
    [anon_sym_group] = ACTIONS(4445),
    [anon_sym_by] = ACTIONS(4445),
    [anon_sym_select] = ACTIONS(4445),
    [aux_sym_preproc_if_token1] = ACTIONS(4447),
    [aux_sym_preproc_if_token3] = ACTIONS(4447),
    [aux_sym_preproc_else_token1] = ACTIONS(4447),
    [aux_sym_preproc_elif_token1] = ACTIONS(4447),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2735] = {
    [sym_preproc_region] = STATE(2735),
    [sym_preproc_endregion] = STATE(2735),
    [sym_preproc_line] = STATE(2735),
    [sym_preproc_pragma] = STATE(2735),
    [sym_preproc_nullable] = STATE(2735),
    [sym_preproc_error] = STATE(2735),
    [sym_preproc_warning] = STATE(2735),
    [sym_preproc_define] = STATE(2735),
    [sym_preproc_undef] = STATE(2735),
    [sym__identifier_token] = ACTIONS(4449),
    [anon_sym_extern] = ACTIONS(4449),
    [anon_sym_alias] = ACTIONS(4449),
    [anon_sym_global] = ACTIONS(4449),
    [anon_sym_using] = ACTIONS(4449),
    [anon_sym_unsafe] = ACTIONS(4449),
    [anon_sym_static] = ACTIONS(4449),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [anon_sym_event] = ACTIONS(4449),
    [anon_sym_namespace] = ACTIONS(4449),
    [anon_sym_class] = ACTIONS(4449),
    [anon_sym_ref] = ACTIONS(4449),
    [anon_sym_struct] = ACTIONS(4449),
    [anon_sym_enum] = ACTIONS(4449),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_interface] = ACTIONS(4449),
    [anon_sym_delegate] = ACTIONS(4449),
    [anon_sym_record] = ACTIONS(4449),
    [anon_sym_abstract] = ACTIONS(4449),
    [anon_sym_async] = ACTIONS(4449),
    [anon_sym_const] = ACTIONS(4449),
    [anon_sym_file] = ACTIONS(4449),
    [anon_sym_fixed] = ACTIONS(4449),
    [anon_sym_internal] = ACTIONS(4449),
    [anon_sym_new] = ACTIONS(4449),
    [anon_sym_override] = ACTIONS(4449),
    [anon_sym_partial] = ACTIONS(4449),
    [anon_sym_private] = ACTIONS(4449),
    [anon_sym_protected] = ACTIONS(4449),
    [anon_sym_public] = ACTIONS(4449),
    [anon_sym_readonly] = ACTIONS(4449),
    [anon_sym_required] = ACTIONS(4449),
    [anon_sym_sealed] = ACTIONS(4449),
    [anon_sym_virtual] = ACTIONS(4449),
    [anon_sym_volatile] = ACTIONS(4449),
    [anon_sym_where] = ACTIONS(4449),
    [anon_sym_notnull] = ACTIONS(4449),
    [anon_sym_unmanaged] = ACTIONS(4449),
    [anon_sym_TILDE] = ACTIONS(4451),
    [anon_sym_implicit] = ACTIONS(4449),
    [anon_sym_explicit] = ACTIONS(4449),
    [anon_sym_scoped] = ACTIONS(4449),
    [anon_sym_var] = ACTIONS(4449),
    [sym_predefined_type] = ACTIONS(4449),
    [anon_sym_yield] = ACTIONS(4449),
    [anon_sym_when] = ACTIONS(4449),
    [anon_sym_from] = ACTIONS(4449),
    [anon_sym_into] = ACTIONS(4449),
    [anon_sym_join] = ACTIONS(4449),
    [anon_sym_on] = ACTIONS(4449),
    [anon_sym_equals] = ACTIONS(4449),
    [anon_sym_let] = ACTIONS(4449),
    [anon_sym_orderby] = ACTIONS(4449),
    [anon_sym_ascending] = ACTIONS(4449),
    [anon_sym_descending] = ACTIONS(4449),
    [anon_sym_group] = ACTIONS(4449),
    [anon_sym_by] = ACTIONS(4449),
    [anon_sym_select] = ACTIONS(4449),
    [aux_sym_preproc_if_token1] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4451),
    [aux_sym_preproc_else_token1] = ACTIONS(4451),
    [aux_sym_preproc_elif_token1] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2736] = {
    [sym_preproc_region] = STATE(2736),
    [sym_preproc_endregion] = STATE(2736),
    [sym_preproc_line] = STATE(2736),
    [sym_preproc_pragma] = STATE(2736),
    [sym_preproc_nullable] = STATE(2736),
    [sym_preproc_error] = STATE(2736),
    [sym_preproc_warning] = STATE(2736),
    [sym_preproc_define] = STATE(2736),
    [sym_preproc_undef] = STATE(2736),
    [sym__identifier_token] = ACTIONS(4453),
    [anon_sym_extern] = ACTIONS(4453),
    [anon_sym_alias] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4453),
    [anon_sym_using] = ACTIONS(4453),
    [anon_sym_unsafe] = ACTIONS(4453),
    [anon_sym_static] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4455),
    [anon_sym_LPAREN] = ACTIONS(4455),
    [anon_sym_event] = ACTIONS(4453),
    [anon_sym_namespace] = ACTIONS(4453),
    [anon_sym_class] = ACTIONS(4453),
    [anon_sym_ref] = ACTIONS(4453),
    [anon_sym_struct] = ACTIONS(4453),
    [anon_sym_enum] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4455),
    [anon_sym_interface] = ACTIONS(4453),
    [anon_sym_delegate] = ACTIONS(4453),
    [anon_sym_record] = ACTIONS(4453),
    [anon_sym_abstract] = ACTIONS(4453),
    [anon_sym_async] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4453),
    [anon_sym_fixed] = ACTIONS(4453),
    [anon_sym_internal] = ACTIONS(4453),
    [anon_sym_new] = ACTIONS(4453),
    [anon_sym_override] = ACTIONS(4453),
    [anon_sym_partial] = ACTIONS(4453),
    [anon_sym_private] = ACTIONS(4453),
    [anon_sym_protected] = ACTIONS(4453),
    [anon_sym_public] = ACTIONS(4453),
    [anon_sym_readonly] = ACTIONS(4453),
    [anon_sym_required] = ACTIONS(4453),
    [anon_sym_sealed] = ACTIONS(4453),
    [anon_sym_virtual] = ACTIONS(4453),
    [anon_sym_volatile] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_notnull] = ACTIONS(4453),
    [anon_sym_unmanaged] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_implicit] = ACTIONS(4453),
    [anon_sym_explicit] = ACTIONS(4453),
    [anon_sym_scoped] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4453),
    [sym_predefined_type] = ACTIONS(4453),
    [anon_sym_yield] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_ascending] = ACTIONS(4453),
    [anon_sym_descending] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [aux_sym_preproc_if_token1] = ACTIONS(4455),
    [aux_sym_preproc_if_token3] = ACTIONS(4455),
    [aux_sym_preproc_else_token1] = ACTIONS(4455),
    [aux_sym_preproc_elif_token1] = ACTIONS(4455),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2737] = {
    [sym_preproc_region] = STATE(2737),
    [sym_preproc_endregion] = STATE(2737),
    [sym_preproc_line] = STATE(2737),
    [sym_preproc_pragma] = STATE(2737),
    [sym_preproc_nullable] = STATE(2737),
    [sym_preproc_error] = STATE(2737),
    [sym_preproc_warning] = STATE(2737),
    [sym_preproc_define] = STATE(2737),
    [sym_preproc_undef] = STATE(2737),
    [sym__identifier_token] = ACTIONS(4119),
    [anon_sym_alias] = ACTIONS(4119),
    [anon_sym_global] = ACTIONS(4119),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_LPAREN] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_file] = ACTIONS(4119),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_where] = ACTIONS(4119),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_notnull] = ACTIONS(4119),
    [anon_sym_unmanaged] = ACTIONS(4119),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4121),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4119),
    [anon_sym_scoped] = ACTIONS(4119),
    [anon_sym_var] = ACTIONS(4119),
    [anon_sym_yield] = ACTIONS(4119),
    [anon_sym_switch] = ACTIONS(4119),
    [anon_sym_when] = ACTIONS(4119),
    [sym_discard] = ACTIONS(4119),
    [anon_sym_DOT_DOT] = ACTIONS(4121),
    [anon_sym_and] = ACTIONS(4119),
    [anon_sym_or] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_QMARK_QMARK] = ACTIONS(4121),
    [anon_sym_from] = ACTIONS(4119),
    [anon_sym_into] = ACTIONS(4119),
    [anon_sym_join] = ACTIONS(4119),
    [anon_sym_on] = ACTIONS(4119),
    [anon_sym_equals] = ACTIONS(4119),
    [anon_sym_let] = ACTIONS(4119),
    [anon_sym_orderby] = ACTIONS(4119),
    [anon_sym_ascending] = ACTIONS(4119),
    [anon_sym_descending] = ACTIONS(4119),
    [anon_sym_group] = ACTIONS(4119),
    [anon_sym_by] = ACTIONS(4119),
    [anon_sym_select] = ACTIONS(4119),
    [anon_sym_as] = ACTIONS(4119),
    [anon_sym_is] = ACTIONS(4119),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [anon_sym_with] = ACTIONS(4119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4121),
  },
  [2738] = {
    [sym_preproc_region] = STATE(2738),
    [sym_preproc_endregion] = STATE(2738),
    [sym_preproc_line] = STATE(2738),
    [sym_preproc_pragma] = STATE(2738),
    [sym_preproc_nullable] = STATE(2738),
    [sym_preproc_error] = STATE(2738),
    [sym_preproc_warning] = STATE(2738),
    [sym_preproc_define] = STATE(2738),
    [sym_preproc_undef] = STATE(2738),
    [sym__identifier_token] = ACTIONS(3697),
    [anon_sym_alias] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_notnull] = ACTIONS(3697),
    [anon_sym_unmanaged] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3697),
    [anon_sym_GT_GT_GT] = ACTIONS(3699),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_GT_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_scoped] = ACTIONS(3697),
    [anon_sym_var] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_switch] = ACTIONS(3697),
    [anon_sym_when] = ACTIONS(3697),
    [sym_discard] = ACTIONS(3697),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_and] = ACTIONS(3697),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(3699),
    [anon_sym_QMARK_QMARK] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_into] = ACTIONS(3697),
    [anon_sym_join] = ACTIONS(3697),
    [anon_sym_on] = ACTIONS(3697),
    [anon_sym_equals] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_orderby] = ACTIONS(3697),
    [anon_sym_ascending] = ACTIONS(3697),
    [anon_sym_descending] = ACTIONS(3697),
    [anon_sym_group] = ACTIONS(3697),
    [anon_sym_by] = ACTIONS(3697),
    [anon_sym_select] = ACTIONS(3697),
    [anon_sym_as] = ACTIONS(3697),
    [anon_sym_is] = ACTIONS(3697),
    [anon_sym_DASH_GT] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3699),
  },
  [2739] = {
    [sym_preproc_region] = STATE(2739),
    [sym_preproc_endregion] = STATE(2739),
    [sym_preproc_line] = STATE(2739),
    [sym_preproc_pragma] = STATE(2739),
    [sym_preproc_nullable] = STATE(2739),
    [sym_preproc_error] = STATE(2739),
    [sym_preproc_warning] = STATE(2739),
    [sym_preproc_define] = STATE(2739),
    [sym_preproc_undef] = STATE(2739),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4166),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_GT_GT_GT] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4164),
    [anon_sym_BANG_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK] = ACTIONS(4166),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_if_token3] = ACTIONS(4164),
    [aux_sym_preproc_else_token1] = ACTIONS(4164),
    [aux_sym_preproc_elif_token1] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2740] = {
    [sym_preproc_region] = STATE(2740),
    [sym_preproc_endregion] = STATE(2740),
    [sym_preproc_line] = STATE(2740),
    [sym_preproc_pragma] = STATE(2740),
    [sym_preproc_nullable] = STATE(2740),
    [sym_preproc_error] = STATE(2740),
    [sym_preproc_warning] = STATE(2740),
    [sym_preproc_define] = STATE(2740),
    [sym_preproc_undef] = STATE(2740),
    [sym__identifier_token] = ACTIONS(4457),
    [anon_sym_extern] = ACTIONS(4457),
    [anon_sym_alias] = ACTIONS(4457),
    [anon_sym_global] = ACTIONS(4457),
    [anon_sym_using] = ACTIONS(4457),
    [anon_sym_unsafe] = ACTIONS(4457),
    [anon_sym_static] = ACTIONS(4457),
    [anon_sym_LBRACK] = ACTIONS(4459),
    [anon_sym_LPAREN] = ACTIONS(4459),
    [anon_sym_event] = ACTIONS(4457),
    [anon_sym_namespace] = ACTIONS(4457),
    [anon_sym_class] = ACTIONS(4457),
    [anon_sym_ref] = ACTIONS(4457),
    [anon_sym_struct] = ACTIONS(4457),
    [anon_sym_enum] = ACTIONS(4457),
    [anon_sym_RBRACE] = ACTIONS(4459),
    [anon_sym_interface] = ACTIONS(4457),
    [anon_sym_delegate] = ACTIONS(4457),
    [anon_sym_record] = ACTIONS(4457),
    [anon_sym_abstract] = ACTIONS(4457),
    [anon_sym_async] = ACTIONS(4457),
    [anon_sym_const] = ACTIONS(4457),
    [anon_sym_file] = ACTIONS(4457),
    [anon_sym_fixed] = ACTIONS(4457),
    [anon_sym_internal] = ACTIONS(4457),
    [anon_sym_new] = ACTIONS(4457),
    [anon_sym_override] = ACTIONS(4457),
    [anon_sym_partial] = ACTIONS(4457),
    [anon_sym_private] = ACTIONS(4457),
    [anon_sym_protected] = ACTIONS(4457),
    [anon_sym_public] = ACTIONS(4457),
    [anon_sym_readonly] = ACTIONS(4457),
    [anon_sym_required] = ACTIONS(4457),
    [anon_sym_sealed] = ACTIONS(4457),
    [anon_sym_virtual] = ACTIONS(4457),
    [anon_sym_volatile] = ACTIONS(4457),
    [anon_sym_where] = ACTIONS(4457),
    [anon_sym_notnull] = ACTIONS(4457),
    [anon_sym_unmanaged] = ACTIONS(4457),
    [anon_sym_TILDE] = ACTIONS(4459),
    [anon_sym_implicit] = ACTIONS(4457),
    [anon_sym_explicit] = ACTIONS(4457),
    [anon_sym_scoped] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4457),
    [sym_predefined_type] = ACTIONS(4457),
    [anon_sym_yield] = ACTIONS(4457),
    [anon_sym_when] = ACTIONS(4457),
    [anon_sym_from] = ACTIONS(4457),
    [anon_sym_into] = ACTIONS(4457),
    [anon_sym_join] = ACTIONS(4457),
    [anon_sym_on] = ACTIONS(4457),
    [anon_sym_equals] = ACTIONS(4457),
    [anon_sym_let] = ACTIONS(4457),
    [anon_sym_orderby] = ACTIONS(4457),
    [anon_sym_ascending] = ACTIONS(4457),
    [anon_sym_descending] = ACTIONS(4457),
    [anon_sym_group] = ACTIONS(4457),
    [anon_sym_by] = ACTIONS(4457),
    [anon_sym_select] = ACTIONS(4457),
    [aux_sym_preproc_if_token1] = ACTIONS(4459),
    [aux_sym_preproc_if_token3] = ACTIONS(4459),
    [aux_sym_preproc_else_token1] = ACTIONS(4459),
    [aux_sym_preproc_elif_token1] = ACTIONS(4459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2741] = {
    [sym_preproc_region] = STATE(2741),
    [sym_preproc_endregion] = STATE(2741),
    [sym_preproc_line] = STATE(2741),
    [sym_preproc_pragma] = STATE(2741),
    [sym_preproc_nullable] = STATE(2741),
    [sym_preproc_error] = STATE(2741),
    [sym_preproc_warning] = STATE(2741),
    [sym_preproc_define] = STATE(2741),
    [sym_preproc_undef] = STATE(2741),
    [sym__identifier_token] = ACTIONS(4146),
    [anon_sym_alias] = ACTIONS(4146),
    [anon_sym_global] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_file] = ACTIONS(4146),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4146),
    [anon_sym_where] = ACTIONS(4146),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_notnull] = ACTIONS(4146),
    [anon_sym_unmanaged] = ACTIONS(4146),
    [anon_sym_BANG] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4146),
    [anon_sym_AMP] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4146),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_scoped] = ACTIONS(4146),
    [anon_sym_var] = ACTIONS(4146),
    [anon_sym_yield] = ACTIONS(4146),
    [anon_sym_switch] = ACTIONS(4146),
    [anon_sym_when] = ACTIONS(4146),
    [sym_discard] = ACTIONS(4146),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_QMARK_QMARK] = ACTIONS(4148),
    [anon_sym_from] = ACTIONS(4146),
    [anon_sym_into] = ACTIONS(4146),
    [anon_sym_join] = ACTIONS(4146),
    [anon_sym_on] = ACTIONS(4146),
    [anon_sym_equals] = ACTIONS(4146),
    [anon_sym_let] = ACTIONS(4146),
    [anon_sym_orderby] = ACTIONS(4146),
    [anon_sym_ascending] = ACTIONS(4146),
    [anon_sym_descending] = ACTIONS(4146),
    [anon_sym_group] = ACTIONS(4146),
    [anon_sym_by] = ACTIONS(4146),
    [anon_sym_select] = ACTIONS(4146),
    [anon_sym_as] = ACTIONS(4146),
    [anon_sym_is] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_with] = ACTIONS(4146),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4148),
  },
  [2742] = {
    [sym_preproc_region] = STATE(2742),
    [sym_preproc_endregion] = STATE(2742),
    [sym_preproc_line] = STATE(2742),
    [sym_preproc_pragma] = STATE(2742),
    [sym_preproc_nullable] = STATE(2742),
    [sym_preproc_error] = STATE(2742),
    [sym_preproc_warning] = STATE(2742),
    [sym_preproc_define] = STATE(2742),
    [sym_preproc_undef] = STATE(2742),
    [sym__identifier_token] = ACTIONS(4150),
    [anon_sym_alias] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_file] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_notnull] = ACTIONS(4150),
    [anon_sym_unmanaged] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_CARET] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4152),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_scoped] = ACTIONS(4150),
    [anon_sym_var] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_switch] = ACTIONS(4150),
    [anon_sym_when] = ACTIONS(4150),
    [sym_discard] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_QMARK_QMARK] = ACTIONS(4152),
    [anon_sym_from] = ACTIONS(4150),
    [anon_sym_into] = ACTIONS(4150),
    [anon_sym_join] = ACTIONS(4150),
    [anon_sym_on] = ACTIONS(4150),
    [anon_sym_equals] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_orderby] = ACTIONS(4150),
    [anon_sym_ascending] = ACTIONS(4150),
    [anon_sym_descending] = ACTIONS(4150),
    [anon_sym_group] = ACTIONS(4150),
    [anon_sym_by] = ACTIONS(4150),
    [anon_sym_select] = ACTIONS(4150),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_is] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [anon_sym_with] = ACTIONS(4150),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4152),
  },
  [2743] = {
    [sym_preproc_region] = STATE(2743),
    [sym_preproc_endregion] = STATE(2743),
    [sym_preproc_line] = STATE(2743),
    [sym_preproc_pragma] = STATE(2743),
    [sym_preproc_nullable] = STATE(2743),
    [sym_preproc_error] = STATE(2743),
    [sym_preproc_warning] = STATE(2743),
    [sym_preproc_define] = STATE(2743),
    [sym_preproc_undef] = STATE(2743),
    [sym__identifier_token] = ACTIONS(4461),
    [anon_sym_extern] = ACTIONS(4461),
    [anon_sym_alias] = ACTIONS(4461),
    [anon_sym_global] = ACTIONS(4461),
    [anon_sym_using] = ACTIONS(4461),
    [anon_sym_unsafe] = ACTIONS(4461),
    [anon_sym_static] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(4463),
    [anon_sym_LPAREN] = ACTIONS(4463),
    [anon_sym_event] = ACTIONS(4461),
    [anon_sym_namespace] = ACTIONS(4461),
    [anon_sym_class] = ACTIONS(4461),
    [anon_sym_ref] = ACTIONS(4461),
    [anon_sym_struct] = ACTIONS(4461),
    [anon_sym_enum] = ACTIONS(4461),
    [anon_sym_RBRACE] = ACTIONS(4463),
    [anon_sym_interface] = ACTIONS(4461),
    [anon_sym_delegate] = ACTIONS(4461),
    [anon_sym_record] = ACTIONS(4461),
    [anon_sym_abstract] = ACTIONS(4461),
    [anon_sym_async] = ACTIONS(4461),
    [anon_sym_const] = ACTIONS(4461),
    [anon_sym_file] = ACTIONS(4461),
    [anon_sym_fixed] = ACTIONS(4461),
    [anon_sym_internal] = ACTIONS(4461),
    [anon_sym_new] = ACTIONS(4461),
    [anon_sym_override] = ACTIONS(4461),
    [anon_sym_partial] = ACTIONS(4461),
    [anon_sym_private] = ACTIONS(4461),
    [anon_sym_protected] = ACTIONS(4461),
    [anon_sym_public] = ACTIONS(4461),
    [anon_sym_readonly] = ACTIONS(4461),
    [anon_sym_required] = ACTIONS(4461),
    [anon_sym_sealed] = ACTIONS(4461),
    [anon_sym_virtual] = ACTIONS(4461),
    [anon_sym_volatile] = ACTIONS(4461),
    [anon_sym_where] = ACTIONS(4461),
    [anon_sym_notnull] = ACTIONS(4461),
    [anon_sym_unmanaged] = ACTIONS(4461),
    [anon_sym_TILDE] = ACTIONS(4463),
    [anon_sym_implicit] = ACTIONS(4461),
    [anon_sym_explicit] = ACTIONS(4461),
    [anon_sym_scoped] = ACTIONS(4461),
    [anon_sym_var] = ACTIONS(4461),
    [sym_predefined_type] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4461),
    [anon_sym_when] = ACTIONS(4461),
    [anon_sym_from] = ACTIONS(4461),
    [anon_sym_into] = ACTIONS(4461),
    [anon_sym_join] = ACTIONS(4461),
    [anon_sym_on] = ACTIONS(4461),
    [anon_sym_equals] = ACTIONS(4461),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_orderby] = ACTIONS(4461),
    [anon_sym_ascending] = ACTIONS(4461),
    [anon_sym_descending] = ACTIONS(4461),
    [anon_sym_group] = ACTIONS(4461),
    [anon_sym_by] = ACTIONS(4461),
    [anon_sym_select] = ACTIONS(4461),
    [aux_sym_preproc_if_token1] = ACTIONS(4463),
    [aux_sym_preproc_if_token3] = ACTIONS(4463),
    [aux_sym_preproc_else_token1] = ACTIONS(4463),
    [aux_sym_preproc_elif_token1] = ACTIONS(4463),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2744] = {
    [sym_preproc_region] = STATE(2744),
    [sym_preproc_endregion] = STATE(2744),
    [sym_preproc_line] = STATE(2744),
    [sym_preproc_pragma] = STATE(2744),
    [sym_preproc_nullable] = STATE(2744),
    [sym_preproc_error] = STATE(2744),
    [sym_preproc_warning] = STATE(2744),
    [sym_preproc_define] = STATE(2744),
    [sym_preproc_undef] = STATE(2744),
    [sym__identifier_token] = ACTIONS(4465),
    [anon_sym_extern] = ACTIONS(4465),
    [anon_sym_alias] = ACTIONS(4465),
    [anon_sym_global] = ACTIONS(4465),
    [anon_sym_using] = ACTIONS(4465),
    [anon_sym_unsafe] = ACTIONS(4465),
    [anon_sym_static] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_event] = ACTIONS(4465),
    [anon_sym_namespace] = ACTIONS(4465),
    [anon_sym_class] = ACTIONS(4465),
    [anon_sym_ref] = ACTIONS(4465),
    [anon_sym_struct] = ACTIONS(4465),
    [anon_sym_enum] = ACTIONS(4465),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_interface] = ACTIONS(4465),
    [anon_sym_delegate] = ACTIONS(4465),
    [anon_sym_record] = ACTIONS(4465),
    [anon_sym_abstract] = ACTIONS(4465),
    [anon_sym_async] = ACTIONS(4465),
    [anon_sym_const] = ACTIONS(4465),
    [anon_sym_file] = ACTIONS(4465),
    [anon_sym_fixed] = ACTIONS(4465),
    [anon_sym_internal] = ACTIONS(4465),
    [anon_sym_new] = ACTIONS(4465),
    [anon_sym_override] = ACTIONS(4465),
    [anon_sym_partial] = ACTIONS(4465),
    [anon_sym_private] = ACTIONS(4465),
    [anon_sym_protected] = ACTIONS(4465),
    [anon_sym_public] = ACTIONS(4465),
    [anon_sym_readonly] = ACTIONS(4465),
    [anon_sym_required] = ACTIONS(4465),
    [anon_sym_sealed] = ACTIONS(4465),
    [anon_sym_virtual] = ACTIONS(4465),
    [anon_sym_volatile] = ACTIONS(4465),
    [anon_sym_where] = ACTIONS(4465),
    [anon_sym_notnull] = ACTIONS(4465),
    [anon_sym_unmanaged] = ACTIONS(4465),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_implicit] = ACTIONS(4465),
    [anon_sym_explicit] = ACTIONS(4465),
    [anon_sym_scoped] = ACTIONS(4465),
    [anon_sym_var] = ACTIONS(4465),
    [sym_predefined_type] = ACTIONS(4465),
    [anon_sym_yield] = ACTIONS(4465),
    [anon_sym_when] = ACTIONS(4465),
    [anon_sym_from] = ACTIONS(4465),
    [anon_sym_into] = ACTIONS(4465),
    [anon_sym_join] = ACTIONS(4465),
    [anon_sym_on] = ACTIONS(4465),
    [anon_sym_equals] = ACTIONS(4465),
    [anon_sym_let] = ACTIONS(4465),
    [anon_sym_orderby] = ACTIONS(4465),
    [anon_sym_ascending] = ACTIONS(4465),
    [anon_sym_descending] = ACTIONS(4465),
    [anon_sym_group] = ACTIONS(4465),
    [anon_sym_by] = ACTIONS(4465),
    [anon_sym_select] = ACTIONS(4465),
    [aux_sym_preproc_if_token1] = ACTIONS(4467),
    [aux_sym_preproc_if_token3] = ACTIONS(4467),
    [aux_sym_preproc_else_token1] = ACTIONS(4467),
    [aux_sym_preproc_elif_token1] = ACTIONS(4467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2745] = {
    [sym_preproc_region] = STATE(2745),
    [sym_preproc_endregion] = STATE(2745),
    [sym_preproc_line] = STATE(2745),
    [sym_preproc_pragma] = STATE(2745),
    [sym_preproc_nullable] = STATE(2745),
    [sym_preproc_error] = STATE(2745),
    [sym_preproc_warning] = STATE(2745),
    [sym_preproc_define] = STATE(2745),
    [sym_preproc_undef] = STATE(2745),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_RBRACK] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_in] = ACTIONS(4172),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_GT_GT_GT] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_EQ_GT] = ACTIONS(4172),
    [anon_sym_switch] = ACTIONS(4172),
    [anon_sym_when] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4172),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK] = ACTIONS(4174),
    [anon_sym_on] = ACTIONS(4172),
    [anon_sym_equals] = ACTIONS(4172),
    [anon_sym_by] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4172),
    [anon_sym_is] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [anon_sym_with] = ACTIONS(4172),
    [aux_sym_preproc_if_token3] = ACTIONS(4172),
    [aux_sym_preproc_else_token1] = ACTIONS(4172),
    [aux_sym_preproc_elif_token1] = ACTIONS(4172),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2746] = {
    [sym_preproc_region] = STATE(2746),
    [sym_preproc_endregion] = STATE(2746),
    [sym_preproc_line] = STATE(2746),
    [sym_preproc_pragma] = STATE(2746),
    [sym_preproc_nullable] = STATE(2746),
    [sym_preproc_error] = STATE(2746),
    [sym_preproc_warning] = STATE(2746),
    [sym_preproc_define] = STATE(2746),
    [sym_preproc_undef] = STATE(2746),
    [sym__identifier_token] = ACTIONS(4154),
    [anon_sym_alias] = ACTIONS(4154),
    [anon_sym_global] = ACTIONS(4154),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [anon_sym_file] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_where] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_notnull] = ACTIONS(4154),
    [anon_sym_unmanaged] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_GT_GT_GT] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4156),
    [anon_sym_BANG_EQ] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4156),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_scoped] = ACTIONS(4154),
    [anon_sym_var] = ACTIONS(4154),
    [anon_sym_yield] = ACTIONS(4154),
    [anon_sym_switch] = ACTIONS(4154),
    [anon_sym_when] = ACTIONS(4154),
    [sym_discard] = ACTIONS(4154),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4156),
    [anon_sym_QMARK_QMARK] = ACTIONS(4156),
    [anon_sym_from] = ACTIONS(4154),
    [anon_sym_into] = ACTIONS(4154),
    [anon_sym_join] = ACTIONS(4154),
    [anon_sym_on] = ACTIONS(4154),
    [anon_sym_equals] = ACTIONS(4154),
    [anon_sym_let] = ACTIONS(4154),
    [anon_sym_orderby] = ACTIONS(4154),
    [anon_sym_ascending] = ACTIONS(4154),
    [anon_sym_descending] = ACTIONS(4154),
    [anon_sym_group] = ACTIONS(4154),
    [anon_sym_by] = ACTIONS(4154),
    [anon_sym_select] = ACTIONS(4154),
    [anon_sym_as] = ACTIONS(4154),
    [anon_sym_is] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(4156),
    [anon_sym_with] = ACTIONS(4154),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4156),
  },
  [2747] = {
    [sym__variable_designation] = STATE(4186),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2747),
    [sym_preproc_endregion] = STATE(2747),
    [sym_preproc_line] = STATE(2747),
    [sym_preproc_pragma] = STATE(2747),
    [sym_preproc_nullable] = STATE(2747),
    [sym_preproc_error] = STATE(2747),
    [sym_preproc_warning] = STATE(2747),
    [sym_preproc_define] = STATE(2747),
    [sym_preproc_undef] = STATE(2747),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2748] = {
    [sym_preproc_region] = STATE(2748),
    [sym_preproc_endregion] = STATE(2748),
    [sym_preproc_line] = STATE(2748),
    [sym_preproc_pragma] = STATE(2748),
    [sym_preproc_nullable] = STATE(2748),
    [sym_preproc_error] = STATE(2748),
    [sym_preproc_warning] = STATE(2748),
    [sym_preproc_define] = STATE(2748),
    [sym_preproc_undef] = STATE(2748),
    [sym__identifier_token] = ACTIONS(4102),
    [anon_sym_alias] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4102),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_file] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_where] = ACTIONS(4102),
    [anon_sym_QMARK] = ACTIONS(4102),
    [anon_sym_notnull] = ACTIONS(4102),
    [anon_sym_unmanaged] = ACTIONS(4102),
    [anon_sym_BANG] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4104),
    [anon_sym_DASH_DASH] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4104),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_CARET] = ACTIONS(4104),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4104),
    [anon_sym_GT_GT] = ACTIONS(4102),
    [anon_sym_GT_GT_GT] = ACTIONS(4104),
    [anon_sym_EQ_EQ] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_GT_EQ] = ACTIONS(4104),
    [anon_sym_LT_EQ] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_scoped] = ACTIONS(4102),
    [anon_sym_var] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4102),
    [anon_sym_switch] = ACTIONS(4102),
    [anon_sym_when] = ACTIONS(4102),
    [sym_discard] = ACTIONS(4102),
    [anon_sym_DOT_DOT] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4102),
    [anon_sym_or] = ACTIONS(4102),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_QMARK_QMARK] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4102),
    [anon_sym_into] = ACTIONS(4102),
    [anon_sym_join] = ACTIONS(4102),
    [anon_sym_on] = ACTIONS(4102),
    [anon_sym_equals] = ACTIONS(4102),
    [anon_sym_let] = ACTIONS(4102),
    [anon_sym_orderby] = ACTIONS(4102),
    [anon_sym_ascending] = ACTIONS(4102),
    [anon_sym_descending] = ACTIONS(4102),
    [anon_sym_group] = ACTIONS(4102),
    [anon_sym_by] = ACTIONS(4102),
    [anon_sym_select] = ACTIONS(4102),
    [anon_sym_as] = ACTIONS(4102),
    [anon_sym_is] = ACTIONS(4102),
    [anon_sym_DASH_GT] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4102),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4104),
  },
  [2749] = {
    [sym_preproc_region] = STATE(2749),
    [sym_preproc_endregion] = STATE(2749),
    [sym_preproc_line] = STATE(2749),
    [sym_preproc_pragma] = STATE(2749),
    [sym_preproc_nullable] = STATE(2749),
    [sym_preproc_error] = STATE(2749),
    [sym_preproc_warning] = STATE(2749),
    [sym_preproc_define] = STATE(2749),
    [sym_preproc_undef] = STATE(2749),
    [sym__identifier_token] = ACTIONS(4469),
    [anon_sym_extern] = ACTIONS(4469),
    [anon_sym_alias] = ACTIONS(4469),
    [anon_sym_global] = ACTIONS(4469),
    [anon_sym_using] = ACTIONS(4469),
    [anon_sym_unsafe] = ACTIONS(4469),
    [anon_sym_static] = ACTIONS(4469),
    [anon_sym_LBRACK] = ACTIONS(4471),
    [anon_sym_LPAREN] = ACTIONS(4471),
    [anon_sym_event] = ACTIONS(4469),
    [anon_sym_namespace] = ACTIONS(4469),
    [anon_sym_class] = ACTIONS(4469),
    [anon_sym_ref] = ACTIONS(4469),
    [anon_sym_struct] = ACTIONS(4469),
    [anon_sym_enum] = ACTIONS(4469),
    [anon_sym_RBRACE] = ACTIONS(4471),
    [anon_sym_interface] = ACTIONS(4469),
    [anon_sym_delegate] = ACTIONS(4469),
    [anon_sym_record] = ACTIONS(4469),
    [anon_sym_abstract] = ACTIONS(4469),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_const] = ACTIONS(4469),
    [anon_sym_file] = ACTIONS(4469),
    [anon_sym_fixed] = ACTIONS(4469),
    [anon_sym_internal] = ACTIONS(4469),
    [anon_sym_new] = ACTIONS(4469),
    [anon_sym_override] = ACTIONS(4469),
    [anon_sym_partial] = ACTIONS(4469),
    [anon_sym_private] = ACTIONS(4469),
    [anon_sym_protected] = ACTIONS(4469),
    [anon_sym_public] = ACTIONS(4469),
    [anon_sym_readonly] = ACTIONS(4469),
    [anon_sym_required] = ACTIONS(4469),
    [anon_sym_sealed] = ACTIONS(4469),
    [anon_sym_virtual] = ACTIONS(4469),
    [anon_sym_volatile] = ACTIONS(4469),
    [anon_sym_where] = ACTIONS(4469),
    [anon_sym_notnull] = ACTIONS(4469),
    [anon_sym_unmanaged] = ACTIONS(4469),
    [anon_sym_TILDE] = ACTIONS(4471),
    [anon_sym_implicit] = ACTIONS(4469),
    [anon_sym_explicit] = ACTIONS(4469),
    [anon_sym_scoped] = ACTIONS(4469),
    [anon_sym_var] = ACTIONS(4469),
    [sym_predefined_type] = ACTIONS(4469),
    [anon_sym_yield] = ACTIONS(4469),
    [anon_sym_when] = ACTIONS(4469),
    [anon_sym_from] = ACTIONS(4469),
    [anon_sym_into] = ACTIONS(4469),
    [anon_sym_join] = ACTIONS(4469),
    [anon_sym_on] = ACTIONS(4469),
    [anon_sym_equals] = ACTIONS(4469),
    [anon_sym_let] = ACTIONS(4469),
    [anon_sym_orderby] = ACTIONS(4469),
    [anon_sym_ascending] = ACTIONS(4469),
    [anon_sym_descending] = ACTIONS(4469),
    [anon_sym_group] = ACTIONS(4469),
    [anon_sym_by] = ACTIONS(4469),
    [anon_sym_select] = ACTIONS(4469),
    [aux_sym_preproc_if_token1] = ACTIONS(4471),
    [aux_sym_preproc_if_token3] = ACTIONS(4471),
    [aux_sym_preproc_else_token1] = ACTIONS(4471),
    [aux_sym_preproc_elif_token1] = ACTIONS(4471),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2750] = {
    [sym_preproc_region] = STATE(2750),
    [sym_preproc_endregion] = STATE(2750),
    [sym_preproc_line] = STATE(2750),
    [sym_preproc_pragma] = STATE(2750),
    [sym_preproc_nullable] = STATE(2750),
    [sym_preproc_error] = STATE(2750),
    [sym_preproc_warning] = STATE(2750),
    [sym_preproc_define] = STATE(2750),
    [sym_preproc_undef] = STATE(2750),
    [sym__identifier_token] = ACTIONS(4473),
    [anon_sym_extern] = ACTIONS(4473),
    [anon_sym_alias] = ACTIONS(4473),
    [anon_sym_global] = ACTIONS(4473),
    [anon_sym_using] = ACTIONS(4473),
    [anon_sym_unsafe] = ACTIONS(4473),
    [anon_sym_static] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(4475),
    [anon_sym_LPAREN] = ACTIONS(4475),
    [anon_sym_event] = ACTIONS(4473),
    [anon_sym_namespace] = ACTIONS(4473),
    [anon_sym_class] = ACTIONS(4473),
    [anon_sym_ref] = ACTIONS(4473),
    [anon_sym_struct] = ACTIONS(4473),
    [anon_sym_enum] = ACTIONS(4473),
    [anon_sym_RBRACE] = ACTIONS(4475),
    [anon_sym_interface] = ACTIONS(4473),
    [anon_sym_delegate] = ACTIONS(4473),
    [anon_sym_record] = ACTIONS(4473),
    [anon_sym_abstract] = ACTIONS(4473),
    [anon_sym_async] = ACTIONS(4473),
    [anon_sym_const] = ACTIONS(4473),
    [anon_sym_file] = ACTIONS(4473),
    [anon_sym_fixed] = ACTIONS(4473),
    [anon_sym_internal] = ACTIONS(4473),
    [anon_sym_new] = ACTIONS(4473),
    [anon_sym_override] = ACTIONS(4473),
    [anon_sym_partial] = ACTIONS(4473),
    [anon_sym_private] = ACTIONS(4473),
    [anon_sym_protected] = ACTIONS(4473),
    [anon_sym_public] = ACTIONS(4473),
    [anon_sym_readonly] = ACTIONS(4473),
    [anon_sym_required] = ACTIONS(4473),
    [anon_sym_sealed] = ACTIONS(4473),
    [anon_sym_virtual] = ACTIONS(4473),
    [anon_sym_volatile] = ACTIONS(4473),
    [anon_sym_where] = ACTIONS(4473),
    [anon_sym_notnull] = ACTIONS(4473),
    [anon_sym_unmanaged] = ACTIONS(4473),
    [anon_sym_TILDE] = ACTIONS(4475),
    [anon_sym_implicit] = ACTIONS(4473),
    [anon_sym_explicit] = ACTIONS(4473),
    [anon_sym_scoped] = ACTIONS(4473),
    [anon_sym_var] = ACTIONS(4473),
    [sym_predefined_type] = ACTIONS(4473),
    [anon_sym_yield] = ACTIONS(4473),
    [anon_sym_when] = ACTIONS(4473),
    [anon_sym_from] = ACTIONS(4473),
    [anon_sym_into] = ACTIONS(4473),
    [anon_sym_join] = ACTIONS(4473),
    [anon_sym_on] = ACTIONS(4473),
    [anon_sym_equals] = ACTIONS(4473),
    [anon_sym_let] = ACTIONS(4473),
    [anon_sym_orderby] = ACTIONS(4473),
    [anon_sym_ascending] = ACTIONS(4473),
    [anon_sym_descending] = ACTIONS(4473),
    [anon_sym_group] = ACTIONS(4473),
    [anon_sym_by] = ACTIONS(4473),
    [anon_sym_select] = ACTIONS(4473),
    [aux_sym_preproc_if_token1] = ACTIONS(4475),
    [aux_sym_preproc_if_token3] = ACTIONS(4475),
    [aux_sym_preproc_else_token1] = ACTIONS(4475),
    [aux_sym_preproc_elif_token1] = ACTIONS(4475),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2751] = {
    [sym_preproc_region] = STATE(2751),
    [sym_preproc_endregion] = STATE(2751),
    [sym_preproc_line] = STATE(2751),
    [sym_preproc_pragma] = STATE(2751),
    [sym_preproc_nullable] = STATE(2751),
    [sym_preproc_error] = STATE(2751),
    [sym_preproc_warning] = STATE(2751),
    [sym_preproc_define] = STATE(2751),
    [sym_preproc_undef] = STATE(2751),
    [sym__identifier_token] = ACTIONS(4477),
    [anon_sym_extern] = ACTIONS(4477),
    [anon_sym_alias] = ACTIONS(4477),
    [anon_sym_global] = ACTIONS(4477),
    [anon_sym_using] = ACTIONS(4477),
    [anon_sym_unsafe] = ACTIONS(4477),
    [anon_sym_static] = ACTIONS(4477),
    [anon_sym_LBRACK] = ACTIONS(4479),
    [anon_sym_LPAREN] = ACTIONS(4479),
    [anon_sym_event] = ACTIONS(4477),
    [anon_sym_namespace] = ACTIONS(4477),
    [anon_sym_class] = ACTIONS(4477),
    [anon_sym_ref] = ACTIONS(4477),
    [anon_sym_struct] = ACTIONS(4477),
    [anon_sym_enum] = ACTIONS(4477),
    [anon_sym_RBRACE] = ACTIONS(4479),
    [anon_sym_interface] = ACTIONS(4477),
    [anon_sym_delegate] = ACTIONS(4477),
    [anon_sym_record] = ACTIONS(4477),
    [anon_sym_abstract] = ACTIONS(4477),
    [anon_sym_async] = ACTIONS(4477),
    [anon_sym_const] = ACTIONS(4477),
    [anon_sym_file] = ACTIONS(4477),
    [anon_sym_fixed] = ACTIONS(4477),
    [anon_sym_internal] = ACTIONS(4477),
    [anon_sym_new] = ACTIONS(4477),
    [anon_sym_override] = ACTIONS(4477),
    [anon_sym_partial] = ACTIONS(4477),
    [anon_sym_private] = ACTIONS(4477),
    [anon_sym_protected] = ACTIONS(4477),
    [anon_sym_public] = ACTIONS(4477),
    [anon_sym_readonly] = ACTIONS(4477),
    [anon_sym_required] = ACTIONS(4477),
    [anon_sym_sealed] = ACTIONS(4477),
    [anon_sym_virtual] = ACTIONS(4477),
    [anon_sym_volatile] = ACTIONS(4477),
    [anon_sym_where] = ACTIONS(4477),
    [anon_sym_notnull] = ACTIONS(4477),
    [anon_sym_unmanaged] = ACTIONS(4477),
    [anon_sym_TILDE] = ACTIONS(4479),
    [anon_sym_implicit] = ACTIONS(4477),
    [anon_sym_explicit] = ACTIONS(4477),
    [anon_sym_scoped] = ACTIONS(4477),
    [anon_sym_var] = ACTIONS(4477),
    [sym_predefined_type] = ACTIONS(4477),
    [anon_sym_yield] = ACTIONS(4477),
    [anon_sym_when] = ACTIONS(4477),
    [anon_sym_from] = ACTIONS(4477),
    [anon_sym_into] = ACTIONS(4477),
    [anon_sym_join] = ACTIONS(4477),
    [anon_sym_on] = ACTIONS(4477),
    [anon_sym_equals] = ACTIONS(4477),
    [anon_sym_let] = ACTIONS(4477),
    [anon_sym_orderby] = ACTIONS(4477),
    [anon_sym_ascending] = ACTIONS(4477),
    [anon_sym_descending] = ACTIONS(4477),
    [anon_sym_group] = ACTIONS(4477),
    [anon_sym_by] = ACTIONS(4477),
    [anon_sym_select] = ACTIONS(4477),
    [aux_sym_preproc_if_token1] = ACTIONS(4479),
    [aux_sym_preproc_if_token3] = ACTIONS(4479),
    [aux_sym_preproc_else_token1] = ACTIONS(4479),
    [aux_sym_preproc_elif_token1] = ACTIONS(4479),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2752] = {
    [sym_preproc_region] = STATE(2752),
    [sym_preproc_endregion] = STATE(2752),
    [sym_preproc_line] = STATE(2752),
    [sym_preproc_pragma] = STATE(2752),
    [sym_preproc_nullable] = STATE(2752),
    [sym_preproc_error] = STATE(2752),
    [sym_preproc_warning] = STATE(2752),
    [sym_preproc_define] = STATE(2752),
    [sym_preproc_undef] = STATE(2752),
    [sym__identifier_token] = ACTIONS(3355),
    [anon_sym_extern] = ACTIONS(3355),
    [anon_sym_alias] = ACTIONS(3355),
    [anon_sym_global] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_unsafe] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_event] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_ref] = ACTIONS(3355),
    [anon_sym_struct] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_delegate] = ACTIONS(3355),
    [anon_sym_record] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_file] = ACTIONS(3355),
    [anon_sym_fixed] = ACTIONS(3355),
    [anon_sym_internal] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_partial] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_required] = ACTIONS(3355),
    [anon_sym_sealed] = ACTIONS(3355),
    [anon_sym_virtual] = ACTIONS(3355),
    [anon_sym_volatile] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [anon_sym_notnull] = ACTIONS(3355),
    [anon_sym_unmanaged] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_implicit] = ACTIONS(3355),
    [anon_sym_explicit] = ACTIONS(3355),
    [anon_sym_scoped] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [sym_predefined_type] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_when] = ACTIONS(3355),
    [anon_sym_from] = ACTIONS(3355),
    [anon_sym_into] = ACTIONS(3355),
    [anon_sym_join] = ACTIONS(3355),
    [anon_sym_on] = ACTIONS(3355),
    [anon_sym_equals] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_orderby] = ACTIONS(3355),
    [anon_sym_ascending] = ACTIONS(3355),
    [anon_sym_descending] = ACTIONS(3355),
    [anon_sym_group] = ACTIONS(3355),
    [anon_sym_by] = ACTIONS(3355),
    [anon_sym_select] = ACTIONS(3355),
    [aux_sym_preproc_if_token1] = ACTIONS(3357),
    [aux_sym_preproc_if_token3] = ACTIONS(3357),
    [aux_sym_preproc_else_token1] = ACTIONS(3357),
    [aux_sym_preproc_elif_token1] = ACTIONS(3357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2753] = {
    [sym__variable_designation] = STATE(4179),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2753),
    [sym_preproc_endregion] = STATE(2753),
    [sym_preproc_line] = STATE(2753),
    [sym_preproc_pragma] = STATE(2753),
    [sym_preproc_nullable] = STATE(2753),
    [sym_preproc_error] = STATE(2753),
    [sym_preproc_warning] = STATE(2753),
    [sym_preproc_define] = STATE(2753),
    [sym_preproc_undef] = STATE(2753),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2754] = {
    [sym_preproc_region] = STATE(2754),
    [sym_preproc_endregion] = STATE(2754),
    [sym_preproc_line] = STATE(2754),
    [sym_preproc_pragma] = STATE(2754),
    [sym_preproc_nullable] = STATE(2754),
    [sym_preproc_error] = STATE(2754),
    [sym_preproc_warning] = STATE(2754),
    [sym_preproc_define] = STATE(2754),
    [sym_preproc_undef] = STATE(2754),
    [sym__identifier_token] = ACTIONS(4481),
    [anon_sym_extern] = ACTIONS(4481),
    [anon_sym_alias] = ACTIONS(4481),
    [anon_sym_global] = ACTIONS(4481),
    [anon_sym_using] = ACTIONS(4481),
    [anon_sym_unsafe] = ACTIONS(4481),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_LBRACK] = ACTIONS(4483),
    [anon_sym_LPAREN] = ACTIONS(4483),
    [anon_sym_event] = ACTIONS(4481),
    [anon_sym_namespace] = ACTIONS(4481),
    [anon_sym_class] = ACTIONS(4481),
    [anon_sym_ref] = ACTIONS(4481),
    [anon_sym_struct] = ACTIONS(4481),
    [anon_sym_enum] = ACTIONS(4481),
    [anon_sym_RBRACE] = ACTIONS(4483),
    [anon_sym_interface] = ACTIONS(4481),
    [anon_sym_delegate] = ACTIONS(4481),
    [anon_sym_record] = ACTIONS(4481),
    [anon_sym_abstract] = ACTIONS(4481),
    [anon_sym_async] = ACTIONS(4481),
    [anon_sym_const] = ACTIONS(4481),
    [anon_sym_file] = ACTIONS(4481),
    [anon_sym_fixed] = ACTIONS(4481),
    [anon_sym_internal] = ACTIONS(4481),
    [anon_sym_new] = ACTIONS(4481),
    [anon_sym_override] = ACTIONS(4481),
    [anon_sym_partial] = ACTIONS(4481),
    [anon_sym_private] = ACTIONS(4481),
    [anon_sym_protected] = ACTIONS(4481),
    [anon_sym_public] = ACTIONS(4481),
    [anon_sym_readonly] = ACTIONS(4481),
    [anon_sym_required] = ACTIONS(4481),
    [anon_sym_sealed] = ACTIONS(4481),
    [anon_sym_virtual] = ACTIONS(4481),
    [anon_sym_volatile] = ACTIONS(4481),
    [anon_sym_where] = ACTIONS(4481),
    [anon_sym_notnull] = ACTIONS(4481),
    [anon_sym_unmanaged] = ACTIONS(4481),
    [anon_sym_TILDE] = ACTIONS(4483),
    [anon_sym_implicit] = ACTIONS(4481),
    [anon_sym_explicit] = ACTIONS(4481),
    [anon_sym_scoped] = ACTIONS(4481),
    [anon_sym_var] = ACTIONS(4481),
    [sym_predefined_type] = ACTIONS(4481),
    [anon_sym_yield] = ACTIONS(4481),
    [anon_sym_when] = ACTIONS(4481),
    [anon_sym_from] = ACTIONS(4481),
    [anon_sym_into] = ACTIONS(4481),
    [anon_sym_join] = ACTIONS(4481),
    [anon_sym_on] = ACTIONS(4481),
    [anon_sym_equals] = ACTIONS(4481),
    [anon_sym_let] = ACTIONS(4481),
    [anon_sym_orderby] = ACTIONS(4481),
    [anon_sym_ascending] = ACTIONS(4481),
    [anon_sym_descending] = ACTIONS(4481),
    [anon_sym_group] = ACTIONS(4481),
    [anon_sym_by] = ACTIONS(4481),
    [anon_sym_select] = ACTIONS(4481),
    [aux_sym_preproc_if_token1] = ACTIONS(4483),
    [aux_sym_preproc_if_token3] = ACTIONS(4483),
    [aux_sym_preproc_else_token1] = ACTIONS(4483),
    [aux_sym_preproc_elif_token1] = ACTIONS(4483),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2755] = {
    [sym_preproc_region] = STATE(2755),
    [sym_preproc_endregion] = STATE(2755),
    [sym_preproc_line] = STATE(2755),
    [sym_preproc_pragma] = STATE(2755),
    [sym_preproc_nullable] = STATE(2755),
    [sym_preproc_error] = STATE(2755),
    [sym_preproc_warning] = STATE(2755),
    [sym_preproc_define] = STATE(2755),
    [sym_preproc_undef] = STATE(2755),
    [sym__identifier_token] = ACTIONS(4485),
    [anon_sym_extern] = ACTIONS(4485),
    [anon_sym_alias] = ACTIONS(4485),
    [anon_sym_global] = ACTIONS(4485),
    [anon_sym_using] = ACTIONS(4485),
    [anon_sym_unsafe] = ACTIONS(4485),
    [anon_sym_static] = ACTIONS(4485),
    [anon_sym_LBRACK] = ACTIONS(4487),
    [anon_sym_LPAREN] = ACTIONS(4487),
    [anon_sym_event] = ACTIONS(4485),
    [anon_sym_namespace] = ACTIONS(4485),
    [anon_sym_class] = ACTIONS(4485),
    [anon_sym_ref] = ACTIONS(4485),
    [anon_sym_struct] = ACTIONS(4485),
    [anon_sym_enum] = ACTIONS(4485),
    [anon_sym_RBRACE] = ACTIONS(4487),
    [anon_sym_interface] = ACTIONS(4485),
    [anon_sym_delegate] = ACTIONS(4485),
    [anon_sym_record] = ACTIONS(4485),
    [anon_sym_abstract] = ACTIONS(4485),
    [anon_sym_async] = ACTIONS(4485),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_file] = ACTIONS(4485),
    [anon_sym_fixed] = ACTIONS(4485),
    [anon_sym_internal] = ACTIONS(4485),
    [anon_sym_new] = ACTIONS(4485),
    [anon_sym_override] = ACTIONS(4485),
    [anon_sym_partial] = ACTIONS(4485),
    [anon_sym_private] = ACTIONS(4485),
    [anon_sym_protected] = ACTIONS(4485),
    [anon_sym_public] = ACTIONS(4485),
    [anon_sym_readonly] = ACTIONS(4485),
    [anon_sym_required] = ACTIONS(4485),
    [anon_sym_sealed] = ACTIONS(4485),
    [anon_sym_virtual] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_where] = ACTIONS(4485),
    [anon_sym_notnull] = ACTIONS(4485),
    [anon_sym_unmanaged] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4487),
    [anon_sym_implicit] = ACTIONS(4485),
    [anon_sym_explicit] = ACTIONS(4485),
    [anon_sym_scoped] = ACTIONS(4485),
    [anon_sym_var] = ACTIONS(4485),
    [sym_predefined_type] = ACTIONS(4485),
    [anon_sym_yield] = ACTIONS(4485),
    [anon_sym_when] = ACTIONS(4485),
    [anon_sym_from] = ACTIONS(4485),
    [anon_sym_into] = ACTIONS(4485),
    [anon_sym_join] = ACTIONS(4485),
    [anon_sym_on] = ACTIONS(4485),
    [anon_sym_equals] = ACTIONS(4485),
    [anon_sym_let] = ACTIONS(4485),
    [anon_sym_orderby] = ACTIONS(4485),
    [anon_sym_ascending] = ACTIONS(4485),
    [anon_sym_descending] = ACTIONS(4485),
    [anon_sym_group] = ACTIONS(4485),
    [anon_sym_by] = ACTIONS(4485),
    [anon_sym_select] = ACTIONS(4485),
    [aux_sym_preproc_if_token1] = ACTIONS(4487),
    [aux_sym_preproc_if_token3] = ACTIONS(4487),
    [aux_sym_preproc_else_token1] = ACTIONS(4487),
    [aux_sym_preproc_elif_token1] = ACTIONS(4487),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2756] = {
    [sym_preproc_region] = STATE(2756),
    [sym_preproc_endregion] = STATE(2756),
    [sym_preproc_line] = STATE(2756),
    [sym_preproc_pragma] = STATE(2756),
    [sym_preproc_nullable] = STATE(2756),
    [sym_preproc_error] = STATE(2756),
    [sym_preproc_warning] = STATE(2756),
    [sym_preproc_define] = STATE(2756),
    [sym_preproc_undef] = STATE(2756),
    [sym__identifier_token] = ACTIONS(4489),
    [anon_sym_extern] = ACTIONS(4489),
    [anon_sym_alias] = ACTIONS(4489),
    [anon_sym_global] = ACTIONS(4489),
    [anon_sym_using] = ACTIONS(4489),
    [anon_sym_unsafe] = ACTIONS(4489),
    [anon_sym_static] = ACTIONS(4489),
    [anon_sym_LBRACK] = ACTIONS(4491),
    [anon_sym_LPAREN] = ACTIONS(4491),
    [anon_sym_event] = ACTIONS(4489),
    [anon_sym_namespace] = ACTIONS(4489),
    [anon_sym_class] = ACTIONS(4489),
    [anon_sym_ref] = ACTIONS(4489),
    [anon_sym_struct] = ACTIONS(4489),
    [anon_sym_enum] = ACTIONS(4489),
    [anon_sym_RBRACE] = ACTIONS(4491),
    [anon_sym_interface] = ACTIONS(4489),
    [anon_sym_delegate] = ACTIONS(4489),
    [anon_sym_record] = ACTIONS(4489),
    [anon_sym_abstract] = ACTIONS(4489),
    [anon_sym_async] = ACTIONS(4489),
    [anon_sym_const] = ACTIONS(4489),
    [anon_sym_file] = ACTIONS(4489),
    [anon_sym_fixed] = ACTIONS(4489),
    [anon_sym_internal] = ACTIONS(4489),
    [anon_sym_new] = ACTIONS(4489),
    [anon_sym_override] = ACTIONS(4489),
    [anon_sym_partial] = ACTIONS(4489),
    [anon_sym_private] = ACTIONS(4489),
    [anon_sym_protected] = ACTIONS(4489),
    [anon_sym_public] = ACTIONS(4489),
    [anon_sym_readonly] = ACTIONS(4489),
    [anon_sym_required] = ACTIONS(4489),
    [anon_sym_sealed] = ACTIONS(4489),
    [anon_sym_virtual] = ACTIONS(4489),
    [anon_sym_volatile] = ACTIONS(4489),
    [anon_sym_where] = ACTIONS(4489),
    [anon_sym_notnull] = ACTIONS(4489),
    [anon_sym_unmanaged] = ACTIONS(4489),
    [anon_sym_TILDE] = ACTIONS(4491),
    [anon_sym_implicit] = ACTIONS(4489),
    [anon_sym_explicit] = ACTIONS(4489),
    [anon_sym_scoped] = ACTIONS(4489),
    [anon_sym_var] = ACTIONS(4489),
    [sym_predefined_type] = ACTIONS(4489),
    [anon_sym_yield] = ACTIONS(4489),
    [anon_sym_when] = ACTIONS(4489),
    [anon_sym_from] = ACTIONS(4489),
    [anon_sym_into] = ACTIONS(4489),
    [anon_sym_join] = ACTIONS(4489),
    [anon_sym_on] = ACTIONS(4489),
    [anon_sym_equals] = ACTIONS(4489),
    [anon_sym_let] = ACTIONS(4489),
    [anon_sym_orderby] = ACTIONS(4489),
    [anon_sym_ascending] = ACTIONS(4489),
    [anon_sym_descending] = ACTIONS(4489),
    [anon_sym_group] = ACTIONS(4489),
    [anon_sym_by] = ACTIONS(4489),
    [anon_sym_select] = ACTIONS(4489),
    [aux_sym_preproc_if_token1] = ACTIONS(4491),
    [aux_sym_preproc_if_token3] = ACTIONS(4491),
    [aux_sym_preproc_else_token1] = ACTIONS(4491),
    [aux_sym_preproc_elif_token1] = ACTIONS(4491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2757] = {
    [sym_preproc_region] = STATE(2757),
    [sym_preproc_endregion] = STATE(2757),
    [sym_preproc_line] = STATE(2757),
    [sym_preproc_pragma] = STATE(2757),
    [sym_preproc_nullable] = STATE(2757),
    [sym_preproc_error] = STATE(2757),
    [sym_preproc_warning] = STATE(2757),
    [sym_preproc_define] = STATE(2757),
    [sym_preproc_undef] = STATE(2757),
    [sym__identifier_token] = ACTIONS(4493),
    [anon_sym_extern] = ACTIONS(4493),
    [anon_sym_alias] = ACTIONS(4493),
    [anon_sym_global] = ACTIONS(4493),
    [anon_sym_using] = ACTIONS(4493),
    [anon_sym_unsafe] = ACTIONS(4493),
    [anon_sym_static] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(4495),
    [anon_sym_event] = ACTIONS(4493),
    [anon_sym_namespace] = ACTIONS(4493),
    [anon_sym_class] = ACTIONS(4493),
    [anon_sym_ref] = ACTIONS(4493),
    [anon_sym_struct] = ACTIONS(4493),
    [anon_sym_enum] = ACTIONS(4493),
    [anon_sym_RBRACE] = ACTIONS(4495),
    [anon_sym_interface] = ACTIONS(4493),
    [anon_sym_delegate] = ACTIONS(4493),
    [anon_sym_record] = ACTIONS(4493),
    [anon_sym_abstract] = ACTIONS(4493),
    [anon_sym_async] = ACTIONS(4493),
    [anon_sym_const] = ACTIONS(4493),
    [anon_sym_file] = ACTIONS(4493),
    [anon_sym_fixed] = ACTIONS(4493),
    [anon_sym_internal] = ACTIONS(4493),
    [anon_sym_new] = ACTIONS(4493),
    [anon_sym_override] = ACTIONS(4493),
    [anon_sym_partial] = ACTIONS(4493),
    [anon_sym_private] = ACTIONS(4493),
    [anon_sym_protected] = ACTIONS(4493),
    [anon_sym_public] = ACTIONS(4493),
    [anon_sym_readonly] = ACTIONS(4493),
    [anon_sym_required] = ACTIONS(4493),
    [anon_sym_sealed] = ACTIONS(4493),
    [anon_sym_virtual] = ACTIONS(4493),
    [anon_sym_volatile] = ACTIONS(4493),
    [anon_sym_where] = ACTIONS(4493),
    [anon_sym_notnull] = ACTIONS(4493),
    [anon_sym_unmanaged] = ACTIONS(4493),
    [anon_sym_TILDE] = ACTIONS(4495),
    [anon_sym_implicit] = ACTIONS(4493),
    [anon_sym_explicit] = ACTIONS(4493),
    [anon_sym_scoped] = ACTIONS(4493),
    [anon_sym_var] = ACTIONS(4493),
    [sym_predefined_type] = ACTIONS(4493),
    [anon_sym_yield] = ACTIONS(4493),
    [anon_sym_when] = ACTIONS(4493),
    [anon_sym_from] = ACTIONS(4493),
    [anon_sym_into] = ACTIONS(4493),
    [anon_sym_join] = ACTIONS(4493),
    [anon_sym_on] = ACTIONS(4493),
    [anon_sym_equals] = ACTIONS(4493),
    [anon_sym_let] = ACTIONS(4493),
    [anon_sym_orderby] = ACTIONS(4493),
    [anon_sym_ascending] = ACTIONS(4493),
    [anon_sym_descending] = ACTIONS(4493),
    [anon_sym_group] = ACTIONS(4493),
    [anon_sym_by] = ACTIONS(4493),
    [anon_sym_select] = ACTIONS(4493),
    [aux_sym_preproc_if_token1] = ACTIONS(4495),
    [aux_sym_preproc_if_token3] = ACTIONS(4495),
    [aux_sym_preproc_else_token1] = ACTIONS(4495),
    [aux_sym_preproc_elif_token1] = ACTIONS(4495),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2758] = {
    [sym_preproc_region] = STATE(2758),
    [sym_preproc_endregion] = STATE(2758),
    [sym_preproc_line] = STATE(2758),
    [sym_preproc_pragma] = STATE(2758),
    [sym_preproc_nullable] = STATE(2758),
    [sym_preproc_error] = STATE(2758),
    [sym_preproc_warning] = STATE(2758),
    [sym_preproc_define] = STATE(2758),
    [sym_preproc_undef] = STATE(2758),
    [sym__identifier_token] = ACTIONS(4497),
    [anon_sym_extern] = ACTIONS(4497),
    [anon_sym_alias] = ACTIONS(4497),
    [anon_sym_global] = ACTIONS(4497),
    [anon_sym_using] = ACTIONS(4497),
    [anon_sym_unsafe] = ACTIONS(4497),
    [anon_sym_static] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(4499),
    [anon_sym_LPAREN] = ACTIONS(4499),
    [anon_sym_event] = ACTIONS(4497),
    [anon_sym_namespace] = ACTIONS(4497),
    [anon_sym_class] = ACTIONS(4497),
    [anon_sym_ref] = ACTIONS(4497),
    [anon_sym_struct] = ACTIONS(4497),
    [anon_sym_enum] = ACTIONS(4497),
    [anon_sym_RBRACE] = ACTIONS(4499),
    [anon_sym_interface] = ACTIONS(4497),
    [anon_sym_delegate] = ACTIONS(4497),
    [anon_sym_record] = ACTIONS(4497),
    [anon_sym_abstract] = ACTIONS(4497),
    [anon_sym_async] = ACTIONS(4497),
    [anon_sym_const] = ACTIONS(4497),
    [anon_sym_file] = ACTIONS(4497),
    [anon_sym_fixed] = ACTIONS(4497),
    [anon_sym_internal] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4497),
    [anon_sym_override] = ACTIONS(4497),
    [anon_sym_partial] = ACTIONS(4497),
    [anon_sym_private] = ACTIONS(4497),
    [anon_sym_protected] = ACTIONS(4497),
    [anon_sym_public] = ACTIONS(4497),
    [anon_sym_readonly] = ACTIONS(4497),
    [anon_sym_required] = ACTIONS(4497),
    [anon_sym_sealed] = ACTIONS(4497),
    [anon_sym_virtual] = ACTIONS(4497),
    [anon_sym_volatile] = ACTIONS(4497),
    [anon_sym_where] = ACTIONS(4497),
    [anon_sym_notnull] = ACTIONS(4497),
    [anon_sym_unmanaged] = ACTIONS(4497),
    [anon_sym_TILDE] = ACTIONS(4499),
    [anon_sym_implicit] = ACTIONS(4497),
    [anon_sym_explicit] = ACTIONS(4497),
    [anon_sym_scoped] = ACTIONS(4497),
    [anon_sym_var] = ACTIONS(4497),
    [sym_predefined_type] = ACTIONS(4497),
    [anon_sym_yield] = ACTIONS(4497),
    [anon_sym_when] = ACTIONS(4497),
    [anon_sym_from] = ACTIONS(4497),
    [anon_sym_into] = ACTIONS(4497),
    [anon_sym_join] = ACTIONS(4497),
    [anon_sym_on] = ACTIONS(4497),
    [anon_sym_equals] = ACTIONS(4497),
    [anon_sym_let] = ACTIONS(4497),
    [anon_sym_orderby] = ACTIONS(4497),
    [anon_sym_ascending] = ACTIONS(4497),
    [anon_sym_descending] = ACTIONS(4497),
    [anon_sym_group] = ACTIONS(4497),
    [anon_sym_by] = ACTIONS(4497),
    [anon_sym_select] = ACTIONS(4497),
    [aux_sym_preproc_if_token1] = ACTIONS(4499),
    [aux_sym_preproc_if_token3] = ACTIONS(4499),
    [aux_sym_preproc_else_token1] = ACTIONS(4499),
    [aux_sym_preproc_elif_token1] = ACTIONS(4499),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2759] = {
    [sym_preproc_region] = STATE(2759),
    [sym_preproc_endregion] = STATE(2759),
    [sym_preproc_line] = STATE(2759),
    [sym_preproc_pragma] = STATE(2759),
    [sym_preproc_nullable] = STATE(2759),
    [sym_preproc_error] = STATE(2759),
    [sym_preproc_warning] = STATE(2759),
    [sym_preproc_define] = STATE(2759),
    [sym_preproc_undef] = STATE(2759),
    [sym__identifier_token] = ACTIONS(4123),
    [anon_sym_alias] = ACTIONS(4123),
    [anon_sym_global] = ACTIONS(4123),
    [anon_sym_LBRACK] = ACTIONS(4125),
    [anon_sym_COLON] = ACTIONS(4125),
    [anon_sym_COMMA] = ACTIONS(4125),
    [anon_sym_LPAREN] = ACTIONS(4125),
    [anon_sym_LBRACE] = ACTIONS(4125),
    [anon_sym_file] = ACTIONS(4123),
    [anon_sym_LT] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(4123),
    [anon_sym_where] = ACTIONS(4123),
    [anon_sym_QMARK] = ACTIONS(4123),
    [anon_sym_notnull] = ACTIONS(4123),
    [anon_sym_unmanaged] = ACTIONS(4123),
    [anon_sym_BANG] = ACTIONS(4123),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4123),
    [anon_sym_DASH] = ACTIONS(4123),
    [anon_sym_STAR] = ACTIONS(4125),
    [anon_sym_SLASH] = ACTIONS(4123),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_CARET] = ACTIONS(4125),
    [anon_sym_PIPE] = ACTIONS(4123),
    [anon_sym_AMP] = ACTIONS(4123),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_GT_GT] = ACTIONS(4123),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_DOT] = ACTIONS(4123),
    [anon_sym_scoped] = ACTIONS(4123),
    [anon_sym_var] = ACTIONS(4123),
    [anon_sym_yield] = ACTIONS(4123),
    [anon_sym_switch] = ACTIONS(4123),
    [anon_sym_when] = ACTIONS(4123),
    [sym_discard] = ACTIONS(4123),
    [anon_sym_DOT_DOT] = ACTIONS(4125),
    [anon_sym_and] = ACTIONS(4123),
    [anon_sym_or] = ACTIONS(4123),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_QMARK_QMARK] = ACTIONS(4125),
    [anon_sym_from] = ACTIONS(4123),
    [anon_sym_into] = ACTIONS(4123),
    [anon_sym_join] = ACTIONS(4123),
    [anon_sym_on] = ACTIONS(4123),
    [anon_sym_equals] = ACTIONS(4123),
    [anon_sym_let] = ACTIONS(4123),
    [anon_sym_orderby] = ACTIONS(4123),
    [anon_sym_ascending] = ACTIONS(4123),
    [anon_sym_descending] = ACTIONS(4123),
    [anon_sym_group] = ACTIONS(4123),
    [anon_sym_by] = ACTIONS(4123),
    [anon_sym_select] = ACTIONS(4123),
    [anon_sym_as] = ACTIONS(4123),
    [anon_sym_is] = ACTIONS(4123),
    [anon_sym_DASH_GT] = ACTIONS(4125),
    [anon_sym_with] = ACTIONS(4123),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4125),
  },
  [2760] = {
    [sym_preproc_region] = STATE(2760),
    [sym_preproc_endregion] = STATE(2760),
    [sym_preproc_line] = STATE(2760),
    [sym_preproc_pragma] = STATE(2760),
    [sym_preproc_nullable] = STATE(2760),
    [sym_preproc_error] = STATE(2760),
    [sym_preproc_warning] = STATE(2760),
    [sym_preproc_define] = STATE(2760),
    [sym_preproc_undef] = STATE(2760),
    [sym__identifier_token] = ACTIONS(4501),
    [anon_sym_extern] = ACTIONS(4501),
    [anon_sym_alias] = ACTIONS(4501),
    [anon_sym_global] = ACTIONS(4501),
    [anon_sym_using] = ACTIONS(4501),
    [anon_sym_unsafe] = ACTIONS(4501),
    [anon_sym_static] = ACTIONS(4501),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_LPAREN] = ACTIONS(4503),
    [anon_sym_event] = ACTIONS(4501),
    [anon_sym_namespace] = ACTIONS(4501),
    [anon_sym_class] = ACTIONS(4501),
    [anon_sym_ref] = ACTIONS(4501),
    [anon_sym_struct] = ACTIONS(4501),
    [anon_sym_enum] = ACTIONS(4501),
    [anon_sym_RBRACE] = ACTIONS(4503),
    [anon_sym_interface] = ACTIONS(4501),
    [anon_sym_delegate] = ACTIONS(4501),
    [anon_sym_record] = ACTIONS(4501),
    [anon_sym_abstract] = ACTIONS(4501),
    [anon_sym_async] = ACTIONS(4501),
    [anon_sym_const] = ACTIONS(4501),
    [anon_sym_file] = ACTIONS(4501),
    [anon_sym_fixed] = ACTIONS(4501),
    [anon_sym_internal] = ACTIONS(4501),
    [anon_sym_new] = ACTIONS(4501),
    [anon_sym_override] = ACTIONS(4501),
    [anon_sym_partial] = ACTIONS(4501),
    [anon_sym_private] = ACTIONS(4501),
    [anon_sym_protected] = ACTIONS(4501),
    [anon_sym_public] = ACTIONS(4501),
    [anon_sym_readonly] = ACTIONS(4501),
    [anon_sym_required] = ACTIONS(4501),
    [anon_sym_sealed] = ACTIONS(4501),
    [anon_sym_virtual] = ACTIONS(4501),
    [anon_sym_volatile] = ACTIONS(4501),
    [anon_sym_where] = ACTIONS(4501),
    [anon_sym_notnull] = ACTIONS(4501),
    [anon_sym_unmanaged] = ACTIONS(4501),
    [anon_sym_TILDE] = ACTIONS(4503),
    [anon_sym_implicit] = ACTIONS(4501),
    [anon_sym_explicit] = ACTIONS(4501),
    [anon_sym_scoped] = ACTIONS(4501),
    [anon_sym_var] = ACTIONS(4501),
    [sym_predefined_type] = ACTIONS(4501),
    [anon_sym_yield] = ACTIONS(4501),
    [anon_sym_when] = ACTIONS(4501),
    [anon_sym_from] = ACTIONS(4501),
    [anon_sym_into] = ACTIONS(4501),
    [anon_sym_join] = ACTIONS(4501),
    [anon_sym_on] = ACTIONS(4501),
    [anon_sym_equals] = ACTIONS(4501),
    [anon_sym_let] = ACTIONS(4501),
    [anon_sym_orderby] = ACTIONS(4501),
    [anon_sym_ascending] = ACTIONS(4501),
    [anon_sym_descending] = ACTIONS(4501),
    [anon_sym_group] = ACTIONS(4501),
    [anon_sym_by] = ACTIONS(4501),
    [anon_sym_select] = ACTIONS(4501),
    [aux_sym_preproc_if_token1] = ACTIONS(4503),
    [aux_sym_preproc_if_token3] = ACTIONS(4503),
    [aux_sym_preproc_else_token1] = ACTIONS(4503),
    [aux_sym_preproc_elif_token1] = ACTIONS(4503),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2761] = {
    [sym_preproc_region] = STATE(2761),
    [sym_preproc_endregion] = STATE(2761),
    [sym_preproc_line] = STATE(2761),
    [sym_preproc_pragma] = STATE(2761),
    [sym_preproc_nullable] = STATE(2761),
    [sym_preproc_error] = STATE(2761),
    [sym_preproc_warning] = STATE(2761),
    [sym_preproc_define] = STATE(2761),
    [sym_preproc_undef] = STATE(2761),
    [sym__identifier_token] = ACTIONS(4505),
    [anon_sym_extern] = ACTIONS(4505),
    [anon_sym_alias] = ACTIONS(4505),
    [anon_sym_global] = ACTIONS(4505),
    [anon_sym_using] = ACTIONS(4505),
    [anon_sym_unsafe] = ACTIONS(4505),
    [anon_sym_static] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(4507),
    [anon_sym_event] = ACTIONS(4505),
    [anon_sym_namespace] = ACTIONS(4505),
    [anon_sym_class] = ACTIONS(4505),
    [anon_sym_ref] = ACTIONS(4505),
    [anon_sym_struct] = ACTIONS(4505),
    [anon_sym_enum] = ACTIONS(4505),
    [anon_sym_RBRACE] = ACTIONS(4507),
    [anon_sym_interface] = ACTIONS(4505),
    [anon_sym_delegate] = ACTIONS(4505),
    [anon_sym_record] = ACTIONS(4505),
    [anon_sym_abstract] = ACTIONS(4505),
    [anon_sym_async] = ACTIONS(4505),
    [anon_sym_const] = ACTIONS(4505),
    [anon_sym_file] = ACTIONS(4505),
    [anon_sym_fixed] = ACTIONS(4505),
    [anon_sym_internal] = ACTIONS(4505),
    [anon_sym_new] = ACTIONS(4505),
    [anon_sym_override] = ACTIONS(4505),
    [anon_sym_partial] = ACTIONS(4505),
    [anon_sym_private] = ACTIONS(4505),
    [anon_sym_protected] = ACTIONS(4505),
    [anon_sym_public] = ACTIONS(4505),
    [anon_sym_readonly] = ACTIONS(4505),
    [anon_sym_required] = ACTIONS(4505),
    [anon_sym_sealed] = ACTIONS(4505),
    [anon_sym_virtual] = ACTIONS(4505),
    [anon_sym_volatile] = ACTIONS(4505),
    [anon_sym_where] = ACTIONS(4505),
    [anon_sym_notnull] = ACTIONS(4505),
    [anon_sym_unmanaged] = ACTIONS(4505),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_implicit] = ACTIONS(4505),
    [anon_sym_explicit] = ACTIONS(4505),
    [anon_sym_scoped] = ACTIONS(4505),
    [anon_sym_var] = ACTIONS(4505),
    [sym_predefined_type] = ACTIONS(4505),
    [anon_sym_yield] = ACTIONS(4505),
    [anon_sym_when] = ACTIONS(4505),
    [anon_sym_from] = ACTIONS(4505),
    [anon_sym_into] = ACTIONS(4505),
    [anon_sym_join] = ACTIONS(4505),
    [anon_sym_on] = ACTIONS(4505),
    [anon_sym_equals] = ACTIONS(4505),
    [anon_sym_let] = ACTIONS(4505),
    [anon_sym_orderby] = ACTIONS(4505),
    [anon_sym_ascending] = ACTIONS(4505),
    [anon_sym_descending] = ACTIONS(4505),
    [anon_sym_group] = ACTIONS(4505),
    [anon_sym_by] = ACTIONS(4505),
    [anon_sym_select] = ACTIONS(4505),
    [aux_sym_preproc_if_token1] = ACTIONS(4507),
    [aux_sym_preproc_if_token3] = ACTIONS(4507),
    [aux_sym_preproc_else_token1] = ACTIONS(4507),
    [aux_sym_preproc_elif_token1] = ACTIONS(4507),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2762] = {
    [sym_preproc_region] = STATE(2762),
    [sym_preproc_endregion] = STATE(2762),
    [sym_preproc_line] = STATE(2762),
    [sym_preproc_pragma] = STATE(2762),
    [sym_preproc_nullable] = STATE(2762),
    [sym_preproc_error] = STATE(2762),
    [sym_preproc_warning] = STATE(2762),
    [sym_preproc_define] = STATE(2762),
    [sym_preproc_undef] = STATE(2762),
    [sym__identifier_token] = ACTIONS(4509),
    [anon_sym_extern] = ACTIONS(4509),
    [anon_sym_alias] = ACTIONS(4509),
    [anon_sym_global] = ACTIONS(4509),
    [anon_sym_using] = ACTIONS(4509),
    [anon_sym_unsafe] = ACTIONS(4509),
    [anon_sym_static] = ACTIONS(4509),
    [anon_sym_LBRACK] = ACTIONS(4511),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym_event] = ACTIONS(4509),
    [anon_sym_namespace] = ACTIONS(4509),
    [anon_sym_class] = ACTIONS(4509),
    [anon_sym_ref] = ACTIONS(4509),
    [anon_sym_struct] = ACTIONS(4509),
    [anon_sym_enum] = ACTIONS(4509),
    [anon_sym_RBRACE] = ACTIONS(4511),
    [anon_sym_interface] = ACTIONS(4509),
    [anon_sym_delegate] = ACTIONS(4509),
    [anon_sym_record] = ACTIONS(4509),
    [anon_sym_abstract] = ACTIONS(4509),
    [anon_sym_async] = ACTIONS(4509),
    [anon_sym_const] = ACTIONS(4509),
    [anon_sym_file] = ACTIONS(4509),
    [anon_sym_fixed] = ACTIONS(4509),
    [anon_sym_internal] = ACTIONS(4509),
    [anon_sym_new] = ACTIONS(4509),
    [anon_sym_override] = ACTIONS(4509),
    [anon_sym_partial] = ACTIONS(4509),
    [anon_sym_private] = ACTIONS(4509),
    [anon_sym_protected] = ACTIONS(4509),
    [anon_sym_public] = ACTIONS(4509),
    [anon_sym_readonly] = ACTIONS(4509),
    [anon_sym_required] = ACTIONS(4509),
    [anon_sym_sealed] = ACTIONS(4509),
    [anon_sym_virtual] = ACTIONS(4509),
    [anon_sym_volatile] = ACTIONS(4509),
    [anon_sym_where] = ACTIONS(4509),
    [anon_sym_notnull] = ACTIONS(4509),
    [anon_sym_unmanaged] = ACTIONS(4509),
    [anon_sym_TILDE] = ACTIONS(4511),
    [anon_sym_implicit] = ACTIONS(4509),
    [anon_sym_explicit] = ACTIONS(4509),
    [anon_sym_scoped] = ACTIONS(4509),
    [anon_sym_var] = ACTIONS(4509),
    [sym_predefined_type] = ACTIONS(4509),
    [anon_sym_yield] = ACTIONS(4509),
    [anon_sym_when] = ACTIONS(4509),
    [anon_sym_from] = ACTIONS(4509),
    [anon_sym_into] = ACTIONS(4509),
    [anon_sym_join] = ACTIONS(4509),
    [anon_sym_on] = ACTIONS(4509),
    [anon_sym_equals] = ACTIONS(4509),
    [anon_sym_let] = ACTIONS(4509),
    [anon_sym_orderby] = ACTIONS(4509),
    [anon_sym_ascending] = ACTIONS(4509),
    [anon_sym_descending] = ACTIONS(4509),
    [anon_sym_group] = ACTIONS(4509),
    [anon_sym_by] = ACTIONS(4509),
    [anon_sym_select] = ACTIONS(4509),
    [aux_sym_preproc_if_token1] = ACTIONS(4511),
    [aux_sym_preproc_if_token3] = ACTIONS(4511),
    [aux_sym_preproc_else_token1] = ACTIONS(4511),
    [aux_sym_preproc_elif_token1] = ACTIONS(4511),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2763] = {
    [sym_preproc_region] = STATE(2763),
    [sym_preproc_endregion] = STATE(2763),
    [sym_preproc_line] = STATE(2763),
    [sym_preproc_pragma] = STATE(2763),
    [sym_preproc_nullable] = STATE(2763),
    [sym_preproc_error] = STATE(2763),
    [sym_preproc_warning] = STATE(2763),
    [sym_preproc_define] = STATE(2763),
    [sym_preproc_undef] = STATE(2763),
    [sym__identifier_token] = ACTIONS(3359),
    [anon_sym_extern] = ACTIONS(3359),
    [anon_sym_alias] = ACTIONS(3359),
    [anon_sym_global] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_unsafe] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_event] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_ref] = ACTIONS(3359),
    [anon_sym_struct] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_delegate] = ACTIONS(3359),
    [anon_sym_record] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_file] = ACTIONS(3359),
    [anon_sym_fixed] = ACTIONS(3359),
    [anon_sym_internal] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_partial] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_required] = ACTIONS(3359),
    [anon_sym_sealed] = ACTIONS(3359),
    [anon_sym_virtual] = ACTIONS(3359),
    [anon_sym_volatile] = ACTIONS(3359),
    [anon_sym_where] = ACTIONS(3359),
    [anon_sym_notnull] = ACTIONS(3359),
    [anon_sym_unmanaged] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_implicit] = ACTIONS(3359),
    [anon_sym_explicit] = ACTIONS(3359),
    [anon_sym_scoped] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [sym_predefined_type] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_when] = ACTIONS(3359),
    [anon_sym_from] = ACTIONS(3359),
    [anon_sym_into] = ACTIONS(3359),
    [anon_sym_join] = ACTIONS(3359),
    [anon_sym_on] = ACTIONS(3359),
    [anon_sym_equals] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_orderby] = ACTIONS(3359),
    [anon_sym_ascending] = ACTIONS(3359),
    [anon_sym_descending] = ACTIONS(3359),
    [anon_sym_group] = ACTIONS(3359),
    [anon_sym_by] = ACTIONS(3359),
    [anon_sym_select] = ACTIONS(3359),
    [aux_sym_preproc_if_token1] = ACTIONS(3361),
    [aux_sym_preproc_if_token3] = ACTIONS(3361),
    [aux_sym_preproc_else_token1] = ACTIONS(3361),
    [aux_sym_preproc_elif_token1] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2764] = {
    [sym__variable_designation] = STATE(4215),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2764),
    [sym_preproc_endregion] = STATE(2764),
    [sym_preproc_line] = STATE(2764),
    [sym_preproc_pragma] = STATE(2764),
    [sym_preproc_nullable] = STATE(2764),
    [sym_preproc_error] = STATE(2764),
    [sym_preproc_warning] = STATE(2764),
    [sym_preproc_define] = STATE(2764),
    [sym_preproc_undef] = STATE(2764),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2765] = {
    [sym_preproc_region] = STATE(2765),
    [sym_preproc_endregion] = STATE(2765),
    [sym_preproc_line] = STATE(2765),
    [sym_preproc_pragma] = STATE(2765),
    [sym_preproc_nullable] = STATE(2765),
    [sym_preproc_error] = STATE(2765),
    [sym_preproc_warning] = STATE(2765),
    [sym_preproc_define] = STATE(2765),
    [sym_preproc_undef] = STATE(2765),
    [sym__identifier_token] = ACTIONS(3367),
    [anon_sym_extern] = ACTIONS(3367),
    [anon_sym_alias] = ACTIONS(3367),
    [anon_sym_global] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_unsafe] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_event] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_ref] = ACTIONS(3367),
    [anon_sym_struct] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_delegate] = ACTIONS(3367),
    [anon_sym_record] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_file] = ACTIONS(3367),
    [anon_sym_fixed] = ACTIONS(3367),
    [anon_sym_internal] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_partial] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_required] = ACTIONS(3367),
    [anon_sym_sealed] = ACTIONS(3367),
    [anon_sym_virtual] = ACTIONS(3367),
    [anon_sym_volatile] = ACTIONS(3367),
    [anon_sym_where] = ACTIONS(3367),
    [anon_sym_notnull] = ACTIONS(3367),
    [anon_sym_unmanaged] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_implicit] = ACTIONS(3367),
    [anon_sym_explicit] = ACTIONS(3367),
    [anon_sym_scoped] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [sym_predefined_type] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_when] = ACTIONS(3367),
    [anon_sym_from] = ACTIONS(3367),
    [anon_sym_into] = ACTIONS(3367),
    [anon_sym_join] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [anon_sym_equals] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_orderby] = ACTIONS(3367),
    [anon_sym_ascending] = ACTIONS(3367),
    [anon_sym_descending] = ACTIONS(3367),
    [anon_sym_group] = ACTIONS(3367),
    [anon_sym_by] = ACTIONS(3367),
    [anon_sym_select] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3369),
    [aux_sym_preproc_if_token3] = ACTIONS(3369),
    [aux_sym_preproc_else_token1] = ACTIONS(3369),
    [aux_sym_preproc_elif_token1] = ACTIONS(3369),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2766] = {
    [sym_preproc_region] = STATE(2766),
    [sym_preproc_endregion] = STATE(2766),
    [sym_preproc_line] = STATE(2766),
    [sym_preproc_pragma] = STATE(2766),
    [sym_preproc_nullable] = STATE(2766),
    [sym_preproc_error] = STATE(2766),
    [sym_preproc_warning] = STATE(2766),
    [sym_preproc_define] = STATE(2766),
    [sym_preproc_undef] = STATE(2766),
    [sym__identifier_token] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym_alias] = ACTIONS(3423),
    [anon_sym_global] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_unsafe] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_event] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_ref] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_delegate] = ACTIONS(3423),
    [anon_sym_record] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_file] = ACTIONS(3423),
    [anon_sym_fixed] = ACTIONS(3423),
    [anon_sym_internal] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_partial] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_required] = ACTIONS(3423),
    [anon_sym_sealed] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_where] = ACTIONS(3423),
    [anon_sym_notnull] = ACTIONS(3423),
    [anon_sym_unmanaged] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_implicit] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_scoped] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [sym_predefined_type] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_when] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_into] = ACTIONS(3423),
    [anon_sym_join] = ACTIONS(3423),
    [anon_sym_on] = ACTIONS(3423),
    [anon_sym_equals] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_orderby] = ACTIONS(3423),
    [anon_sym_ascending] = ACTIONS(3423),
    [anon_sym_descending] = ACTIONS(3423),
    [anon_sym_group] = ACTIONS(3423),
    [anon_sym_by] = ACTIONS(3423),
    [anon_sym_select] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token3] = ACTIONS(3425),
    [aux_sym_preproc_else_token1] = ACTIONS(3425),
    [aux_sym_preproc_elif_token1] = ACTIONS(3425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2767] = {
    [sym_preproc_region] = STATE(2767),
    [sym_preproc_endregion] = STATE(2767),
    [sym_preproc_line] = STATE(2767),
    [sym_preproc_pragma] = STATE(2767),
    [sym_preproc_nullable] = STATE(2767),
    [sym_preproc_error] = STATE(2767),
    [sym_preproc_warning] = STATE(2767),
    [sym_preproc_define] = STATE(2767),
    [sym_preproc_undef] = STATE(2767),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_in] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_EQ_GT] = ACTIONS(4186),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_when] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_on] = ACTIONS(4186),
    [anon_sym_equals] = ACTIONS(4186),
    [anon_sym_by] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_if_token3] = ACTIONS(4186),
    [aux_sym_preproc_else_token1] = ACTIONS(4186),
    [aux_sym_preproc_elif_token1] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2768] = {
    [sym_preproc_region] = STATE(2768),
    [sym_preproc_endregion] = STATE(2768),
    [sym_preproc_line] = STATE(2768),
    [sym_preproc_pragma] = STATE(2768),
    [sym_preproc_nullable] = STATE(2768),
    [sym_preproc_error] = STATE(2768),
    [sym_preproc_warning] = STATE(2768),
    [sym_preproc_define] = STATE(2768),
    [sym_preproc_undef] = STATE(2768),
    [sym__identifier_token] = ACTIONS(3375),
    [anon_sym_extern] = ACTIONS(3375),
    [anon_sym_alias] = ACTIONS(3375),
    [anon_sym_global] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_unsafe] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_event] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_ref] = ACTIONS(3375),
    [anon_sym_struct] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_delegate] = ACTIONS(3375),
    [anon_sym_record] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_file] = ACTIONS(3375),
    [anon_sym_fixed] = ACTIONS(3375),
    [anon_sym_internal] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_partial] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_required] = ACTIONS(3375),
    [anon_sym_sealed] = ACTIONS(3375),
    [anon_sym_virtual] = ACTIONS(3375),
    [anon_sym_volatile] = ACTIONS(3375),
    [anon_sym_where] = ACTIONS(3375),
    [anon_sym_notnull] = ACTIONS(3375),
    [anon_sym_unmanaged] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_implicit] = ACTIONS(3375),
    [anon_sym_explicit] = ACTIONS(3375),
    [anon_sym_scoped] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [sym_predefined_type] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_when] = ACTIONS(3375),
    [anon_sym_from] = ACTIONS(3375),
    [anon_sym_into] = ACTIONS(3375),
    [anon_sym_join] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [anon_sym_equals] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_orderby] = ACTIONS(3375),
    [anon_sym_ascending] = ACTIONS(3375),
    [anon_sym_descending] = ACTIONS(3375),
    [anon_sym_group] = ACTIONS(3375),
    [anon_sym_by] = ACTIONS(3375),
    [anon_sym_select] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_if_token3] = ACTIONS(3377),
    [aux_sym_preproc_else_token1] = ACTIONS(3377),
    [aux_sym_preproc_elif_token1] = ACTIONS(3377),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2769] = {
    [sym_preproc_region] = STATE(2769),
    [sym_preproc_endregion] = STATE(2769),
    [sym_preproc_line] = STATE(2769),
    [sym_preproc_pragma] = STATE(2769),
    [sym_preproc_nullable] = STATE(2769),
    [sym_preproc_error] = STATE(2769),
    [sym_preproc_warning] = STATE(2769),
    [sym_preproc_define] = STATE(2769),
    [sym_preproc_undef] = STATE(2769),
    [sym__identifier_token] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_alias] = ACTIONS(3387),
    [anon_sym_global] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_event] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_ref] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_delegate] = ACTIONS(3387),
    [anon_sym_record] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_file] = ACTIONS(3387),
    [anon_sym_fixed] = ACTIONS(3387),
    [anon_sym_internal] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_partial] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_required] = ACTIONS(3387),
    [anon_sym_sealed] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_where] = ACTIONS(3387),
    [anon_sym_notnull] = ACTIONS(3387),
    [anon_sym_unmanaged] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_implicit] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_scoped] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [sym_predefined_type] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_when] = ACTIONS(3387),
    [anon_sym_from] = ACTIONS(3387),
    [anon_sym_into] = ACTIONS(3387),
    [anon_sym_join] = ACTIONS(3387),
    [anon_sym_on] = ACTIONS(3387),
    [anon_sym_equals] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_orderby] = ACTIONS(3387),
    [anon_sym_ascending] = ACTIONS(3387),
    [anon_sym_descending] = ACTIONS(3387),
    [anon_sym_group] = ACTIONS(3387),
    [anon_sym_by] = ACTIONS(3387),
    [anon_sym_select] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_if_token3] = ACTIONS(3389),
    [aux_sym_preproc_else_token1] = ACTIONS(3389),
    [aux_sym_preproc_elif_token1] = ACTIONS(3389),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2770] = {
    [sym_preproc_region] = STATE(2770),
    [sym_preproc_endregion] = STATE(2770),
    [sym_preproc_line] = STATE(2770),
    [sym_preproc_pragma] = STATE(2770),
    [sym_preproc_nullable] = STATE(2770),
    [sym_preproc_error] = STATE(2770),
    [sym_preproc_warning] = STATE(2770),
    [sym_preproc_define] = STATE(2770),
    [sym_preproc_undef] = STATE(2770),
    [sym__identifier_token] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym_alias] = ACTIONS(3395),
    [anon_sym_global] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_unsafe] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_LPAREN] = ACTIONS(3397),
    [anon_sym_event] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_ref] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_delegate] = ACTIONS(3395),
    [anon_sym_record] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_file] = ACTIONS(3395),
    [anon_sym_fixed] = ACTIONS(3395),
    [anon_sym_internal] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_partial] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_required] = ACTIONS(3395),
    [anon_sym_sealed] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_where] = ACTIONS(3395),
    [anon_sym_notnull] = ACTIONS(3395),
    [anon_sym_unmanaged] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_implicit] = ACTIONS(3395),
    [anon_sym_explicit] = ACTIONS(3395),
    [anon_sym_scoped] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [sym_predefined_type] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_when] = ACTIONS(3395),
    [anon_sym_from] = ACTIONS(3395),
    [anon_sym_into] = ACTIONS(3395),
    [anon_sym_join] = ACTIONS(3395),
    [anon_sym_on] = ACTIONS(3395),
    [anon_sym_equals] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_orderby] = ACTIONS(3395),
    [anon_sym_ascending] = ACTIONS(3395),
    [anon_sym_descending] = ACTIONS(3395),
    [anon_sym_group] = ACTIONS(3395),
    [anon_sym_by] = ACTIONS(3395),
    [anon_sym_select] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3397),
    [aux_sym_preproc_if_token3] = ACTIONS(3397),
    [aux_sym_preproc_else_token1] = ACTIONS(3397),
    [aux_sym_preproc_elif_token1] = ACTIONS(3397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2771] = {
    [sym__variable_designation] = STATE(3555),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2771),
    [sym_preproc_endregion] = STATE(2771),
    [sym_preproc_line] = STATE(2771),
    [sym_preproc_pragma] = STATE(2771),
    [sym_preproc_nullable] = STATE(2771),
    [sym_preproc_error] = STATE(2771),
    [sym_preproc_warning] = STATE(2771),
    [sym_preproc_define] = STATE(2771),
    [sym_preproc_undef] = STATE(2771),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3929),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2772] = {
    [sym_preproc_region] = STATE(2772),
    [sym_preproc_endregion] = STATE(2772),
    [sym_preproc_line] = STATE(2772),
    [sym_preproc_pragma] = STATE(2772),
    [sym_preproc_nullable] = STATE(2772),
    [sym_preproc_error] = STATE(2772),
    [sym_preproc_warning] = STATE(2772),
    [sym_preproc_define] = STATE(2772),
    [sym_preproc_undef] = STATE(2772),
    [sym__identifier_token] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_alias] = ACTIONS(3399),
    [anon_sym_global] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_unsafe] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_event] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_ref] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_delegate] = ACTIONS(3399),
    [anon_sym_record] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_file] = ACTIONS(3399),
    [anon_sym_fixed] = ACTIONS(3399),
    [anon_sym_internal] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_partial] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_required] = ACTIONS(3399),
    [anon_sym_sealed] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_where] = ACTIONS(3399),
    [anon_sym_notnull] = ACTIONS(3399),
    [anon_sym_unmanaged] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_implicit] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_scoped] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [sym_predefined_type] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_when] = ACTIONS(3399),
    [anon_sym_from] = ACTIONS(3399),
    [anon_sym_into] = ACTIONS(3399),
    [anon_sym_join] = ACTIONS(3399),
    [anon_sym_on] = ACTIONS(3399),
    [anon_sym_equals] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_orderby] = ACTIONS(3399),
    [anon_sym_ascending] = ACTIONS(3399),
    [anon_sym_descending] = ACTIONS(3399),
    [anon_sym_group] = ACTIONS(3399),
    [anon_sym_by] = ACTIONS(3399),
    [anon_sym_select] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_if_token3] = ACTIONS(3401),
    [aux_sym_preproc_else_token1] = ACTIONS(3401),
    [aux_sym_preproc_elif_token1] = ACTIONS(3401),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2773] = {
    [sym_preproc_region] = STATE(2773),
    [sym_preproc_endregion] = STATE(2773),
    [sym_preproc_line] = STATE(2773),
    [sym_preproc_pragma] = STATE(2773),
    [sym_preproc_nullable] = STATE(2773),
    [sym_preproc_error] = STATE(2773),
    [sym_preproc_warning] = STATE(2773),
    [sym_preproc_define] = STATE(2773),
    [sym_preproc_undef] = STATE(2773),
    [sym__identifier_token] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym_alias] = ACTIONS(3443),
    [anon_sym_global] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_unsafe] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_event] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_ref] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_delegate] = ACTIONS(3443),
    [anon_sym_record] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_file] = ACTIONS(3443),
    [anon_sym_fixed] = ACTIONS(3443),
    [anon_sym_internal] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_partial] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_required] = ACTIONS(3443),
    [anon_sym_sealed] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_where] = ACTIONS(3443),
    [anon_sym_notnull] = ACTIONS(3443),
    [anon_sym_unmanaged] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_implicit] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_scoped] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [sym_predefined_type] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_when] = ACTIONS(3443),
    [anon_sym_from] = ACTIONS(3443),
    [anon_sym_into] = ACTIONS(3443),
    [anon_sym_join] = ACTIONS(3443),
    [anon_sym_on] = ACTIONS(3443),
    [anon_sym_equals] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_orderby] = ACTIONS(3443),
    [anon_sym_ascending] = ACTIONS(3443),
    [anon_sym_descending] = ACTIONS(3443),
    [anon_sym_group] = ACTIONS(3443),
    [anon_sym_by] = ACTIONS(3443),
    [anon_sym_select] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token3] = ACTIONS(3445),
    [aux_sym_preproc_else_token1] = ACTIONS(3445),
    [aux_sym_preproc_elif_token1] = ACTIONS(3445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2774] = {
    [sym__variable_designation] = STATE(3534),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2774),
    [sym_preproc_endregion] = STATE(2774),
    [sym_preproc_line] = STATE(2774),
    [sym_preproc_pragma] = STATE(2774),
    [sym_preproc_nullable] = STATE(2774),
    [sym_preproc_error] = STATE(2774),
    [sym_preproc_warning] = STATE(2774),
    [sym_preproc_define] = STATE(2774),
    [sym_preproc_undef] = STATE(2774),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3933),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2775] = {
    [sym__variable_designation] = STATE(3536),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2775),
    [sym_preproc_endregion] = STATE(2775),
    [sym_preproc_line] = STATE(2775),
    [sym_preproc_pragma] = STATE(2775),
    [sym_preproc_nullable] = STATE(2775),
    [sym_preproc_error] = STATE(2775),
    [sym_preproc_warning] = STATE(2775),
    [sym_preproc_define] = STATE(2775),
    [sym_preproc_undef] = STATE(2775),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3999),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2776] = {
    [sym_preproc_region] = STATE(2776),
    [sym_preproc_endregion] = STATE(2776),
    [sym_preproc_line] = STATE(2776),
    [sym_preproc_pragma] = STATE(2776),
    [sym_preproc_nullable] = STATE(2776),
    [sym_preproc_error] = STATE(2776),
    [sym_preproc_warning] = STATE(2776),
    [sym_preproc_define] = STATE(2776),
    [sym_preproc_undef] = STATE(2776),
    [sym__identifier_token] = ACTIONS(4513),
    [anon_sym_extern] = ACTIONS(4513),
    [anon_sym_alias] = ACTIONS(4513),
    [anon_sym_global] = ACTIONS(4513),
    [anon_sym_using] = ACTIONS(4513),
    [anon_sym_unsafe] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4515),
    [anon_sym_LPAREN] = ACTIONS(4515),
    [anon_sym_event] = ACTIONS(4513),
    [anon_sym_namespace] = ACTIONS(4513),
    [anon_sym_class] = ACTIONS(4513),
    [anon_sym_ref] = ACTIONS(4513),
    [anon_sym_struct] = ACTIONS(4513),
    [anon_sym_enum] = ACTIONS(4513),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [anon_sym_interface] = ACTIONS(4513),
    [anon_sym_delegate] = ACTIONS(4513),
    [anon_sym_record] = ACTIONS(4513),
    [anon_sym_abstract] = ACTIONS(4513),
    [anon_sym_async] = ACTIONS(4513),
    [anon_sym_const] = ACTIONS(4513),
    [anon_sym_file] = ACTIONS(4513),
    [anon_sym_fixed] = ACTIONS(4513),
    [anon_sym_internal] = ACTIONS(4513),
    [anon_sym_new] = ACTIONS(4513),
    [anon_sym_override] = ACTIONS(4513),
    [anon_sym_partial] = ACTIONS(4513),
    [anon_sym_private] = ACTIONS(4513),
    [anon_sym_protected] = ACTIONS(4513),
    [anon_sym_public] = ACTIONS(4513),
    [anon_sym_readonly] = ACTIONS(4513),
    [anon_sym_required] = ACTIONS(4513),
    [anon_sym_sealed] = ACTIONS(4513),
    [anon_sym_virtual] = ACTIONS(4513),
    [anon_sym_volatile] = ACTIONS(4513),
    [anon_sym_where] = ACTIONS(4513),
    [anon_sym_notnull] = ACTIONS(4513),
    [anon_sym_unmanaged] = ACTIONS(4513),
    [anon_sym_TILDE] = ACTIONS(4515),
    [anon_sym_implicit] = ACTIONS(4513),
    [anon_sym_explicit] = ACTIONS(4513),
    [anon_sym_scoped] = ACTIONS(4513),
    [anon_sym_var] = ACTIONS(4513),
    [sym_predefined_type] = ACTIONS(4513),
    [anon_sym_yield] = ACTIONS(4513),
    [anon_sym_when] = ACTIONS(4513),
    [anon_sym_from] = ACTIONS(4513),
    [anon_sym_into] = ACTIONS(4513),
    [anon_sym_join] = ACTIONS(4513),
    [anon_sym_on] = ACTIONS(4513),
    [anon_sym_equals] = ACTIONS(4513),
    [anon_sym_let] = ACTIONS(4513),
    [anon_sym_orderby] = ACTIONS(4513),
    [anon_sym_ascending] = ACTIONS(4513),
    [anon_sym_descending] = ACTIONS(4513),
    [anon_sym_group] = ACTIONS(4513),
    [anon_sym_by] = ACTIONS(4513),
    [anon_sym_select] = ACTIONS(4513),
    [aux_sym_preproc_if_token1] = ACTIONS(4515),
    [aux_sym_preproc_if_token3] = ACTIONS(4515),
    [aux_sym_preproc_else_token1] = ACTIONS(4515),
    [aux_sym_preproc_elif_token1] = ACTIONS(4515),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2777] = {
    [sym__variable_designation] = STATE(3403),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2777),
    [sym_preproc_endregion] = STATE(2777),
    [sym_preproc_line] = STATE(2777),
    [sym_preproc_pragma] = STATE(2777),
    [sym_preproc_nullable] = STATE(2777),
    [sym_preproc_error] = STATE(2777),
    [sym_preproc_warning] = STATE(2777),
    [sym_preproc_define] = STATE(2777),
    [sym_preproc_undef] = STATE(2777),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(4003),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2778] = {
    [sym_preproc_region] = STATE(2778),
    [sym_preproc_endregion] = STATE(2778),
    [sym_preproc_line] = STATE(2778),
    [sym_preproc_pragma] = STATE(2778),
    [sym_preproc_nullable] = STATE(2778),
    [sym_preproc_error] = STATE(2778),
    [sym_preproc_warning] = STATE(2778),
    [sym_preproc_define] = STATE(2778),
    [sym_preproc_undef] = STATE(2778),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4517),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4421),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2779] = {
    [sym_preproc_region] = STATE(2779),
    [sym_preproc_endregion] = STATE(2779),
    [sym_preproc_line] = STATE(2779),
    [sym_preproc_pragma] = STATE(2779),
    [sym_preproc_nullable] = STATE(2779),
    [sym_preproc_error] = STATE(2779),
    [sym_preproc_warning] = STATE(2779),
    [sym_preproc_define] = STATE(2779),
    [sym_preproc_undef] = STATE(2779),
    [sym__identifier_token] = ACTIONS(4519),
    [anon_sym_extern] = ACTIONS(4519),
    [anon_sym_alias] = ACTIONS(4519),
    [anon_sym_global] = ACTIONS(4519),
    [anon_sym_using] = ACTIONS(4519),
    [anon_sym_unsafe] = ACTIONS(4519),
    [anon_sym_static] = ACTIONS(4519),
    [anon_sym_LBRACK] = ACTIONS(4521),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_event] = ACTIONS(4519),
    [anon_sym_namespace] = ACTIONS(4519),
    [anon_sym_class] = ACTIONS(4519),
    [anon_sym_ref] = ACTIONS(4519),
    [anon_sym_struct] = ACTIONS(4519),
    [anon_sym_enum] = ACTIONS(4519),
    [anon_sym_RBRACE] = ACTIONS(4521),
    [anon_sym_interface] = ACTIONS(4519),
    [anon_sym_delegate] = ACTIONS(4519),
    [anon_sym_record] = ACTIONS(4519),
    [anon_sym_abstract] = ACTIONS(4519),
    [anon_sym_async] = ACTIONS(4519),
    [anon_sym_const] = ACTIONS(4519),
    [anon_sym_file] = ACTIONS(4519),
    [anon_sym_fixed] = ACTIONS(4519),
    [anon_sym_internal] = ACTIONS(4519),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_override] = ACTIONS(4519),
    [anon_sym_partial] = ACTIONS(4519),
    [anon_sym_private] = ACTIONS(4519),
    [anon_sym_protected] = ACTIONS(4519),
    [anon_sym_public] = ACTIONS(4519),
    [anon_sym_readonly] = ACTIONS(4519),
    [anon_sym_required] = ACTIONS(4519),
    [anon_sym_sealed] = ACTIONS(4519),
    [anon_sym_virtual] = ACTIONS(4519),
    [anon_sym_volatile] = ACTIONS(4519),
    [anon_sym_where] = ACTIONS(4519),
    [anon_sym_notnull] = ACTIONS(4519),
    [anon_sym_unmanaged] = ACTIONS(4519),
    [anon_sym_TILDE] = ACTIONS(4521),
    [anon_sym_implicit] = ACTIONS(4519),
    [anon_sym_explicit] = ACTIONS(4519),
    [anon_sym_scoped] = ACTIONS(4519),
    [anon_sym_var] = ACTIONS(4519),
    [sym_predefined_type] = ACTIONS(4519),
    [anon_sym_yield] = ACTIONS(4519),
    [anon_sym_when] = ACTIONS(4519),
    [anon_sym_from] = ACTIONS(4519),
    [anon_sym_into] = ACTIONS(4519),
    [anon_sym_join] = ACTIONS(4519),
    [anon_sym_on] = ACTIONS(4519),
    [anon_sym_equals] = ACTIONS(4519),
    [anon_sym_let] = ACTIONS(4519),
    [anon_sym_orderby] = ACTIONS(4519),
    [anon_sym_ascending] = ACTIONS(4519),
    [anon_sym_descending] = ACTIONS(4519),
    [anon_sym_group] = ACTIONS(4519),
    [anon_sym_by] = ACTIONS(4519),
    [anon_sym_select] = ACTIONS(4519),
    [aux_sym_preproc_if_token1] = ACTIONS(4521),
    [aux_sym_preproc_if_token3] = ACTIONS(4521),
    [aux_sym_preproc_else_token1] = ACTIONS(4521),
    [aux_sym_preproc_elif_token1] = ACTIONS(4521),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2780] = {
    [sym_preproc_region] = STATE(2780),
    [sym_preproc_endregion] = STATE(2780),
    [sym_preproc_line] = STATE(2780),
    [sym_preproc_pragma] = STATE(2780),
    [sym_preproc_nullable] = STATE(2780),
    [sym_preproc_error] = STATE(2780),
    [sym_preproc_warning] = STATE(2780),
    [sym_preproc_define] = STATE(2780),
    [sym_preproc_undef] = STATE(2780),
    [sym__identifier_token] = ACTIONS(4523),
    [anon_sym_extern] = ACTIONS(4523),
    [anon_sym_alias] = ACTIONS(4523),
    [anon_sym_global] = ACTIONS(4523),
    [anon_sym_using] = ACTIONS(4523),
    [anon_sym_unsafe] = ACTIONS(4523),
    [anon_sym_static] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4525),
    [anon_sym_LPAREN] = ACTIONS(4525),
    [anon_sym_event] = ACTIONS(4523),
    [anon_sym_namespace] = ACTIONS(4523),
    [anon_sym_class] = ACTIONS(4523),
    [anon_sym_ref] = ACTIONS(4523),
    [anon_sym_struct] = ACTIONS(4523),
    [anon_sym_enum] = ACTIONS(4523),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_interface] = ACTIONS(4523),
    [anon_sym_delegate] = ACTIONS(4523),
    [anon_sym_record] = ACTIONS(4523),
    [anon_sym_abstract] = ACTIONS(4523),
    [anon_sym_async] = ACTIONS(4523),
    [anon_sym_const] = ACTIONS(4523),
    [anon_sym_file] = ACTIONS(4523),
    [anon_sym_fixed] = ACTIONS(4523),
    [anon_sym_internal] = ACTIONS(4523),
    [anon_sym_new] = ACTIONS(4523),
    [anon_sym_override] = ACTIONS(4523),
    [anon_sym_partial] = ACTIONS(4523),
    [anon_sym_private] = ACTIONS(4523),
    [anon_sym_protected] = ACTIONS(4523),
    [anon_sym_public] = ACTIONS(4523),
    [anon_sym_readonly] = ACTIONS(4523),
    [anon_sym_required] = ACTIONS(4523),
    [anon_sym_sealed] = ACTIONS(4523),
    [anon_sym_virtual] = ACTIONS(4523),
    [anon_sym_volatile] = ACTIONS(4523),
    [anon_sym_where] = ACTIONS(4523),
    [anon_sym_notnull] = ACTIONS(4523),
    [anon_sym_unmanaged] = ACTIONS(4523),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_implicit] = ACTIONS(4523),
    [anon_sym_explicit] = ACTIONS(4523),
    [anon_sym_scoped] = ACTIONS(4523),
    [anon_sym_var] = ACTIONS(4523),
    [sym_predefined_type] = ACTIONS(4523),
    [anon_sym_yield] = ACTIONS(4523),
    [anon_sym_when] = ACTIONS(4523),
    [anon_sym_from] = ACTIONS(4523),
    [anon_sym_into] = ACTIONS(4523),
    [anon_sym_join] = ACTIONS(4523),
    [anon_sym_on] = ACTIONS(4523),
    [anon_sym_equals] = ACTIONS(4523),
    [anon_sym_let] = ACTIONS(4523),
    [anon_sym_orderby] = ACTIONS(4523),
    [anon_sym_ascending] = ACTIONS(4523),
    [anon_sym_descending] = ACTIONS(4523),
    [anon_sym_group] = ACTIONS(4523),
    [anon_sym_by] = ACTIONS(4523),
    [anon_sym_select] = ACTIONS(4523),
    [aux_sym_preproc_if_token1] = ACTIONS(4525),
    [aux_sym_preproc_if_token3] = ACTIONS(4525),
    [aux_sym_preproc_else_token1] = ACTIONS(4525),
    [aux_sym_preproc_elif_token1] = ACTIONS(4525),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2781] = {
    [sym_preproc_region] = STATE(2781),
    [sym_preproc_endregion] = STATE(2781),
    [sym_preproc_line] = STATE(2781),
    [sym_preproc_pragma] = STATE(2781),
    [sym_preproc_nullable] = STATE(2781),
    [sym_preproc_error] = STATE(2781),
    [sym_preproc_warning] = STATE(2781),
    [sym_preproc_define] = STATE(2781),
    [sym_preproc_undef] = STATE(2781),
    [sym__identifier_token] = ACTIONS(4527),
    [anon_sym_extern] = ACTIONS(4527),
    [anon_sym_alias] = ACTIONS(4527),
    [anon_sym_global] = ACTIONS(4527),
    [anon_sym_using] = ACTIONS(4527),
    [anon_sym_unsafe] = ACTIONS(4527),
    [anon_sym_static] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(4529),
    [anon_sym_LPAREN] = ACTIONS(4529),
    [anon_sym_event] = ACTIONS(4527),
    [anon_sym_namespace] = ACTIONS(4527),
    [anon_sym_class] = ACTIONS(4527),
    [anon_sym_ref] = ACTIONS(4527),
    [anon_sym_struct] = ACTIONS(4527),
    [anon_sym_enum] = ACTIONS(4527),
    [anon_sym_RBRACE] = ACTIONS(4529),
    [anon_sym_interface] = ACTIONS(4527),
    [anon_sym_delegate] = ACTIONS(4527),
    [anon_sym_record] = ACTIONS(4527),
    [anon_sym_abstract] = ACTIONS(4527),
    [anon_sym_async] = ACTIONS(4527),
    [anon_sym_const] = ACTIONS(4527),
    [anon_sym_file] = ACTIONS(4527),
    [anon_sym_fixed] = ACTIONS(4527),
    [anon_sym_internal] = ACTIONS(4527),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_override] = ACTIONS(4527),
    [anon_sym_partial] = ACTIONS(4527),
    [anon_sym_private] = ACTIONS(4527),
    [anon_sym_protected] = ACTIONS(4527),
    [anon_sym_public] = ACTIONS(4527),
    [anon_sym_readonly] = ACTIONS(4527),
    [anon_sym_required] = ACTIONS(4527),
    [anon_sym_sealed] = ACTIONS(4527),
    [anon_sym_virtual] = ACTIONS(4527),
    [anon_sym_volatile] = ACTIONS(4527),
    [anon_sym_where] = ACTIONS(4527),
    [anon_sym_notnull] = ACTIONS(4527),
    [anon_sym_unmanaged] = ACTIONS(4527),
    [anon_sym_TILDE] = ACTIONS(4529),
    [anon_sym_implicit] = ACTIONS(4527),
    [anon_sym_explicit] = ACTIONS(4527),
    [anon_sym_scoped] = ACTIONS(4527),
    [anon_sym_var] = ACTIONS(4527),
    [sym_predefined_type] = ACTIONS(4527),
    [anon_sym_yield] = ACTIONS(4527),
    [anon_sym_when] = ACTIONS(4527),
    [anon_sym_from] = ACTIONS(4527),
    [anon_sym_into] = ACTIONS(4527),
    [anon_sym_join] = ACTIONS(4527),
    [anon_sym_on] = ACTIONS(4527),
    [anon_sym_equals] = ACTIONS(4527),
    [anon_sym_let] = ACTIONS(4527),
    [anon_sym_orderby] = ACTIONS(4527),
    [anon_sym_ascending] = ACTIONS(4527),
    [anon_sym_descending] = ACTIONS(4527),
    [anon_sym_group] = ACTIONS(4527),
    [anon_sym_by] = ACTIONS(4527),
    [anon_sym_select] = ACTIONS(4527),
    [aux_sym_preproc_if_token1] = ACTIONS(4529),
    [aux_sym_preproc_if_token3] = ACTIONS(4529),
    [aux_sym_preproc_else_token1] = ACTIONS(4529),
    [aux_sym_preproc_elif_token1] = ACTIONS(4529),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2782] = {
    [sym__variable_designation] = STATE(4186),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2782),
    [sym_preproc_endregion] = STATE(2782),
    [sym_preproc_line] = STATE(2782),
    [sym_preproc_pragma] = STATE(2782),
    [sym_preproc_nullable] = STATE(2782),
    [sym_preproc_error] = STATE(2782),
    [sym_preproc_warning] = STATE(2782),
    [sym_preproc_define] = STATE(2782),
    [sym_preproc_undef] = STATE(2782),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3981),
    [anon_sym_and] = ACTIONS(3983),
    [anon_sym_or] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_QMARK_QMARK] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(3983),
    [anon_sym_DASH_GT] = ACTIONS(3981),
    [anon_sym_with] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2783] = {
    [sym_preproc_region] = STATE(2783),
    [sym_preproc_endregion] = STATE(2783),
    [sym_preproc_line] = STATE(2783),
    [sym_preproc_pragma] = STATE(2783),
    [sym_preproc_nullable] = STATE(2783),
    [sym_preproc_error] = STATE(2783),
    [sym_preproc_warning] = STATE(2783),
    [sym_preproc_define] = STATE(2783),
    [sym_preproc_undef] = STATE(2783),
    [sym__identifier_token] = ACTIONS(4531),
    [anon_sym_extern] = ACTIONS(4531),
    [anon_sym_alias] = ACTIONS(4531),
    [anon_sym_global] = ACTIONS(4531),
    [anon_sym_using] = ACTIONS(4531),
    [anon_sym_unsafe] = ACTIONS(4531),
    [anon_sym_static] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LPAREN] = ACTIONS(4533),
    [anon_sym_event] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(4531),
    [anon_sym_ref] = ACTIONS(4531),
    [anon_sym_struct] = ACTIONS(4531),
    [anon_sym_enum] = ACTIONS(4531),
    [anon_sym_RBRACE] = ACTIONS(4533),
    [anon_sym_interface] = ACTIONS(4531),
    [anon_sym_delegate] = ACTIONS(4531),
    [anon_sym_record] = ACTIONS(4531),
    [anon_sym_abstract] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4531),
    [anon_sym_const] = ACTIONS(4531),
    [anon_sym_file] = ACTIONS(4531),
    [anon_sym_fixed] = ACTIONS(4531),
    [anon_sym_internal] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4531),
    [anon_sym_override] = ACTIONS(4531),
    [anon_sym_partial] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_readonly] = ACTIONS(4531),
    [anon_sym_required] = ACTIONS(4531),
    [anon_sym_sealed] = ACTIONS(4531),
    [anon_sym_virtual] = ACTIONS(4531),
    [anon_sym_volatile] = ACTIONS(4531),
    [anon_sym_where] = ACTIONS(4531),
    [anon_sym_notnull] = ACTIONS(4531),
    [anon_sym_unmanaged] = ACTIONS(4531),
    [anon_sym_TILDE] = ACTIONS(4533),
    [anon_sym_implicit] = ACTIONS(4531),
    [anon_sym_explicit] = ACTIONS(4531),
    [anon_sym_scoped] = ACTIONS(4531),
    [anon_sym_var] = ACTIONS(4531),
    [sym_predefined_type] = ACTIONS(4531),
    [anon_sym_yield] = ACTIONS(4531),
    [anon_sym_when] = ACTIONS(4531),
    [anon_sym_from] = ACTIONS(4531),
    [anon_sym_into] = ACTIONS(4531),
    [anon_sym_join] = ACTIONS(4531),
    [anon_sym_on] = ACTIONS(4531),
    [anon_sym_equals] = ACTIONS(4531),
    [anon_sym_let] = ACTIONS(4531),
    [anon_sym_orderby] = ACTIONS(4531),
    [anon_sym_ascending] = ACTIONS(4531),
    [anon_sym_descending] = ACTIONS(4531),
    [anon_sym_group] = ACTIONS(4531),
    [anon_sym_by] = ACTIONS(4531),
    [anon_sym_select] = ACTIONS(4531),
    [aux_sym_preproc_if_token1] = ACTIONS(4533),
    [aux_sym_preproc_if_token3] = ACTIONS(4533),
    [aux_sym_preproc_else_token1] = ACTIONS(4533),
    [aux_sym_preproc_elif_token1] = ACTIONS(4533),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2784] = {
    [sym_preproc_region] = STATE(2784),
    [sym_preproc_endregion] = STATE(2784),
    [sym_preproc_line] = STATE(2784),
    [sym_preproc_pragma] = STATE(2784),
    [sym_preproc_nullable] = STATE(2784),
    [sym_preproc_error] = STATE(2784),
    [sym_preproc_warning] = STATE(2784),
    [sym_preproc_define] = STATE(2784),
    [sym_preproc_undef] = STATE(2784),
    [sym__identifier_token] = ACTIONS(4535),
    [anon_sym_extern] = ACTIONS(4535),
    [anon_sym_alias] = ACTIONS(4535),
    [anon_sym_global] = ACTIONS(4535),
    [anon_sym_using] = ACTIONS(4535),
    [anon_sym_unsafe] = ACTIONS(4535),
    [anon_sym_static] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(4537),
    [anon_sym_event] = ACTIONS(4535),
    [anon_sym_namespace] = ACTIONS(4535),
    [anon_sym_class] = ACTIONS(4535),
    [anon_sym_ref] = ACTIONS(4535),
    [anon_sym_struct] = ACTIONS(4535),
    [anon_sym_enum] = ACTIONS(4535),
    [anon_sym_RBRACE] = ACTIONS(4537),
    [anon_sym_interface] = ACTIONS(4535),
    [anon_sym_delegate] = ACTIONS(4535),
    [anon_sym_record] = ACTIONS(4535),
    [anon_sym_abstract] = ACTIONS(4535),
    [anon_sym_async] = ACTIONS(4535),
    [anon_sym_const] = ACTIONS(4535),
    [anon_sym_file] = ACTIONS(4535),
    [anon_sym_fixed] = ACTIONS(4535),
    [anon_sym_internal] = ACTIONS(4535),
    [anon_sym_new] = ACTIONS(4535),
    [anon_sym_override] = ACTIONS(4535),
    [anon_sym_partial] = ACTIONS(4535),
    [anon_sym_private] = ACTIONS(4535),
    [anon_sym_protected] = ACTIONS(4535),
    [anon_sym_public] = ACTIONS(4535),
    [anon_sym_readonly] = ACTIONS(4535),
    [anon_sym_required] = ACTIONS(4535),
    [anon_sym_sealed] = ACTIONS(4535),
    [anon_sym_virtual] = ACTIONS(4535),
    [anon_sym_volatile] = ACTIONS(4535),
    [anon_sym_where] = ACTIONS(4535),
    [anon_sym_notnull] = ACTIONS(4535),
    [anon_sym_unmanaged] = ACTIONS(4535),
    [anon_sym_TILDE] = ACTIONS(4537),
    [anon_sym_implicit] = ACTIONS(4535),
    [anon_sym_explicit] = ACTIONS(4535),
    [anon_sym_scoped] = ACTIONS(4535),
    [anon_sym_var] = ACTIONS(4535),
    [sym_predefined_type] = ACTIONS(4535),
    [anon_sym_yield] = ACTIONS(4535),
    [anon_sym_when] = ACTIONS(4535),
    [anon_sym_from] = ACTIONS(4535),
    [anon_sym_into] = ACTIONS(4535),
    [anon_sym_join] = ACTIONS(4535),
    [anon_sym_on] = ACTIONS(4535),
    [anon_sym_equals] = ACTIONS(4535),
    [anon_sym_let] = ACTIONS(4535),
    [anon_sym_orderby] = ACTIONS(4535),
    [anon_sym_ascending] = ACTIONS(4535),
    [anon_sym_descending] = ACTIONS(4535),
    [anon_sym_group] = ACTIONS(4535),
    [anon_sym_by] = ACTIONS(4535),
    [anon_sym_select] = ACTIONS(4535),
    [aux_sym_preproc_if_token1] = ACTIONS(4537),
    [aux_sym_preproc_if_token3] = ACTIONS(4537),
    [aux_sym_preproc_else_token1] = ACTIONS(4537),
    [aux_sym_preproc_elif_token1] = ACTIONS(4537),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2785] = {
    [sym_preproc_region] = STATE(2785),
    [sym_preproc_endregion] = STATE(2785),
    [sym_preproc_line] = STATE(2785),
    [sym_preproc_pragma] = STATE(2785),
    [sym_preproc_nullable] = STATE(2785),
    [sym_preproc_error] = STATE(2785),
    [sym_preproc_warning] = STATE(2785),
    [sym_preproc_define] = STATE(2785),
    [sym_preproc_undef] = STATE(2785),
    [sym__identifier_token] = ACTIONS(4539),
    [anon_sym_extern] = ACTIONS(4539),
    [anon_sym_alias] = ACTIONS(4539),
    [anon_sym_global] = ACTIONS(4539),
    [anon_sym_using] = ACTIONS(4539),
    [anon_sym_unsafe] = ACTIONS(4539),
    [anon_sym_static] = ACTIONS(4539),
    [anon_sym_LBRACK] = ACTIONS(4541),
    [anon_sym_LPAREN] = ACTIONS(4541),
    [anon_sym_event] = ACTIONS(4539),
    [anon_sym_namespace] = ACTIONS(4539),
    [anon_sym_class] = ACTIONS(4539),
    [anon_sym_ref] = ACTIONS(4539),
    [anon_sym_struct] = ACTIONS(4539),
    [anon_sym_enum] = ACTIONS(4539),
    [anon_sym_RBRACE] = ACTIONS(4541),
    [anon_sym_interface] = ACTIONS(4539),
    [anon_sym_delegate] = ACTIONS(4539),
    [anon_sym_record] = ACTIONS(4539),
    [anon_sym_abstract] = ACTIONS(4539),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_const] = ACTIONS(4539),
    [anon_sym_file] = ACTIONS(4539),
    [anon_sym_fixed] = ACTIONS(4539),
    [anon_sym_internal] = ACTIONS(4539),
    [anon_sym_new] = ACTIONS(4539),
    [anon_sym_override] = ACTIONS(4539),
    [anon_sym_partial] = ACTIONS(4539),
    [anon_sym_private] = ACTIONS(4539),
    [anon_sym_protected] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4539),
    [anon_sym_readonly] = ACTIONS(4539),
    [anon_sym_required] = ACTIONS(4539),
    [anon_sym_sealed] = ACTIONS(4539),
    [anon_sym_virtual] = ACTIONS(4539),
    [anon_sym_volatile] = ACTIONS(4539),
    [anon_sym_where] = ACTIONS(4539),
    [anon_sym_notnull] = ACTIONS(4539),
    [anon_sym_unmanaged] = ACTIONS(4539),
    [anon_sym_TILDE] = ACTIONS(4541),
    [anon_sym_implicit] = ACTIONS(4539),
    [anon_sym_explicit] = ACTIONS(4539),
    [anon_sym_scoped] = ACTIONS(4539),
    [anon_sym_var] = ACTIONS(4539),
    [sym_predefined_type] = ACTIONS(4539),
    [anon_sym_yield] = ACTIONS(4539),
    [anon_sym_when] = ACTIONS(4539),
    [anon_sym_from] = ACTIONS(4539),
    [anon_sym_into] = ACTIONS(4539),
    [anon_sym_join] = ACTIONS(4539),
    [anon_sym_on] = ACTIONS(4539),
    [anon_sym_equals] = ACTIONS(4539),
    [anon_sym_let] = ACTIONS(4539),
    [anon_sym_orderby] = ACTIONS(4539),
    [anon_sym_ascending] = ACTIONS(4539),
    [anon_sym_descending] = ACTIONS(4539),
    [anon_sym_group] = ACTIONS(4539),
    [anon_sym_by] = ACTIONS(4539),
    [anon_sym_select] = ACTIONS(4539),
    [aux_sym_preproc_if_token1] = ACTIONS(4541),
    [aux_sym_preproc_if_token3] = ACTIONS(4541),
    [aux_sym_preproc_else_token1] = ACTIONS(4541),
    [aux_sym_preproc_elif_token1] = ACTIONS(4541),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2786] = {
    [sym_preproc_region] = STATE(2786),
    [sym_preproc_endregion] = STATE(2786),
    [sym_preproc_line] = STATE(2786),
    [sym_preproc_pragma] = STATE(2786),
    [sym_preproc_nullable] = STATE(2786),
    [sym_preproc_error] = STATE(2786),
    [sym_preproc_warning] = STATE(2786),
    [sym_preproc_define] = STATE(2786),
    [sym_preproc_undef] = STATE(2786),
    [sym__identifier_token] = ACTIONS(4543),
    [anon_sym_extern] = ACTIONS(4543),
    [anon_sym_alias] = ACTIONS(4543),
    [anon_sym_global] = ACTIONS(4543),
    [anon_sym_using] = ACTIONS(4543),
    [anon_sym_unsafe] = ACTIONS(4543),
    [anon_sym_static] = ACTIONS(4543),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_LPAREN] = ACTIONS(4545),
    [anon_sym_event] = ACTIONS(4543),
    [anon_sym_namespace] = ACTIONS(4543),
    [anon_sym_class] = ACTIONS(4543),
    [anon_sym_ref] = ACTIONS(4543),
    [anon_sym_struct] = ACTIONS(4543),
    [anon_sym_enum] = ACTIONS(4543),
    [anon_sym_RBRACE] = ACTIONS(4545),
    [anon_sym_interface] = ACTIONS(4543),
    [anon_sym_delegate] = ACTIONS(4543),
    [anon_sym_record] = ACTIONS(4543),
    [anon_sym_abstract] = ACTIONS(4543),
    [anon_sym_async] = ACTIONS(4543),
    [anon_sym_const] = ACTIONS(4543),
    [anon_sym_file] = ACTIONS(4543),
    [anon_sym_fixed] = ACTIONS(4543),
    [anon_sym_internal] = ACTIONS(4543),
    [anon_sym_new] = ACTIONS(4543),
    [anon_sym_override] = ACTIONS(4543),
    [anon_sym_partial] = ACTIONS(4543),
    [anon_sym_private] = ACTIONS(4543),
    [anon_sym_protected] = ACTIONS(4543),
    [anon_sym_public] = ACTIONS(4543),
    [anon_sym_readonly] = ACTIONS(4543),
    [anon_sym_required] = ACTIONS(4543),
    [anon_sym_sealed] = ACTIONS(4543),
    [anon_sym_virtual] = ACTIONS(4543),
    [anon_sym_volatile] = ACTIONS(4543),
    [anon_sym_where] = ACTIONS(4543),
    [anon_sym_notnull] = ACTIONS(4543),
    [anon_sym_unmanaged] = ACTIONS(4543),
    [anon_sym_TILDE] = ACTIONS(4545),
    [anon_sym_implicit] = ACTIONS(4543),
    [anon_sym_explicit] = ACTIONS(4543),
    [anon_sym_scoped] = ACTIONS(4543),
    [anon_sym_var] = ACTIONS(4543),
    [sym_predefined_type] = ACTIONS(4543),
    [anon_sym_yield] = ACTIONS(4543),
    [anon_sym_when] = ACTIONS(4543),
    [anon_sym_from] = ACTIONS(4543),
    [anon_sym_into] = ACTIONS(4543),
    [anon_sym_join] = ACTIONS(4543),
    [anon_sym_on] = ACTIONS(4543),
    [anon_sym_equals] = ACTIONS(4543),
    [anon_sym_let] = ACTIONS(4543),
    [anon_sym_orderby] = ACTIONS(4543),
    [anon_sym_ascending] = ACTIONS(4543),
    [anon_sym_descending] = ACTIONS(4543),
    [anon_sym_group] = ACTIONS(4543),
    [anon_sym_by] = ACTIONS(4543),
    [anon_sym_select] = ACTIONS(4543),
    [aux_sym_preproc_if_token1] = ACTIONS(4545),
    [aux_sym_preproc_if_token3] = ACTIONS(4545),
    [aux_sym_preproc_else_token1] = ACTIONS(4545),
    [aux_sym_preproc_elif_token1] = ACTIONS(4545),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2787] = {
    [sym_preproc_region] = STATE(2787),
    [sym_preproc_endregion] = STATE(2787),
    [sym_preproc_line] = STATE(2787),
    [sym_preproc_pragma] = STATE(2787),
    [sym_preproc_nullable] = STATE(2787),
    [sym_preproc_error] = STATE(2787),
    [sym_preproc_warning] = STATE(2787),
    [sym_preproc_define] = STATE(2787),
    [sym_preproc_undef] = STATE(2787),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_extern] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4547),
    [anon_sym_global] = ACTIONS(4547),
    [anon_sym_using] = ACTIONS(4547),
    [anon_sym_unsafe] = ACTIONS(4547),
    [anon_sym_static] = ACTIONS(4547),
    [anon_sym_LBRACK] = ACTIONS(4549),
    [anon_sym_LPAREN] = ACTIONS(4549),
    [anon_sym_event] = ACTIONS(4547),
    [anon_sym_namespace] = ACTIONS(4547),
    [anon_sym_class] = ACTIONS(4547),
    [anon_sym_ref] = ACTIONS(4547),
    [anon_sym_struct] = ACTIONS(4547),
    [anon_sym_enum] = ACTIONS(4547),
    [anon_sym_RBRACE] = ACTIONS(4549),
    [anon_sym_interface] = ACTIONS(4547),
    [anon_sym_delegate] = ACTIONS(4547),
    [anon_sym_record] = ACTIONS(4547),
    [anon_sym_abstract] = ACTIONS(4547),
    [anon_sym_async] = ACTIONS(4547),
    [anon_sym_const] = ACTIONS(4547),
    [anon_sym_file] = ACTIONS(4547),
    [anon_sym_fixed] = ACTIONS(4547),
    [anon_sym_internal] = ACTIONS(4547),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_override] = ACTIONS(4547),
    [anon_sym_partial] = ACTIONS(4547),
    [anon_sym_private] = ACTIONS(4547),
    [anon_sym_protected] = ACTIONS(4547),
    [anon_sym_public] = ACTIONS(4547),
    [anon_sym_readonly] = ACTIONS(4547),
    [anon_sym_required] = ACTIONS(4547),
    [anon_sym_sealed] = ACTIONS(4547),
    [anon_sym_virtual] = ACTIONS(4547),
    [anon_sym_volatile] = ACTIONS(4547),
    [anon_sym_where] = ACTIONS(4547),
    [anon_sym_notnull] = ACTIONS(4547),
    [anon_sym_unmanaged] = ACTIONS(4547),
    [anon_sym_TILDE] = ACTIONS(4549),
    [anon_sym_implicit] = ACTIONS(4547),
    [anon_sym_explicit] = ACTIONS(4547),
    [anon_sym_scoped] = ACTIONS(4547),
    [anon_sym_var] = ACTIONS(4547),
    [sym_predefined_type] = ACTIONS(4547),
    [anon_sym_yield] = ACTIONS(4547),
    [anon_sym_when] = ACTIONS(4547),
    [anon_sym_from] = ACTIONS(4547),
    [anon_sym_into] = ACTIONS(4547),
    [anon_sym_join] = ACTIONS(4547),
    [anon_sym_on] = ACTIONS(4547),
    [anon_sym_equals] = ACTIONS(4547),
    [anon_sym_let] = ACTIONS(4547),
    [anon_sym_orderby] = ACTIONS(4547),
    [anon_sym_ascending] = ACTIONS(4547),
    [anon_sym_descending] = ACTIONS(4547),
    [anon_sym_group] = ACTIONS(4547),
    [anon_sym_by] = ACTIONS(4547),
    [anon_sym_select] = ACTIONS(4547),
    [aux_sym_preproc_if_token1] = ACTIONS(4549),
    [aux_sym_preproc_if_token3] = ACTIONS(4549),
    [aux_sym_preproc_else_token1] = ACTIONS(4549),
    [aux_sym_preproc_elif_token1] = ACTIONS(4549),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2788] = {
    [sym_preproc_region] = STATE(2788),
    [sym_preproc_endregion] = STATE(2788),
    [sym_preproc_line] = STATE(2788),
    [sym_preproc_pragma] = STATE(2788),
    [sym_preproc_nullable] = STATE(2788),
    [sym_preproc_error] = STATE(2788),
    [sym_preproc_warning] = STATE(2788),
    [sym_preproc_define] = STATE(2788),
    [sym_preproc_undef] = STATE(2788),
    [sym__identifier_token] = ACTIONS(4551),
    [anon_sym_extern] = ACTIONS(4551),
    [anon_sym_alias] = ACTIONS(4551),
    [anon_sym_global] = ACTIONS(4551),
    [anon_sym_using] = ACTIONS(4551),
    [anon_sym_unsafe] = ACTIONS(4551),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_LBRACK] = ACTIONS(4553),
    [anon_sym_LPAREN] = ACTIONS(4553),
    [anon_sym_event] = ACTIONS(4551),
    [anon_sym_namespace] = ACTIONS(4551),
    [anon_sym_class] = ACTIONS(4551),
    [anon_sym_ref] = ACTIONS(4551),
    [anon_sym_struct] = ACTIONS(4551),
    [anon_sym_enum] = ACTIONS(4551),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_interface] = ACTIONS(4551),
    [anon_sym_delegate] = ACTIONS(4551),
    [anon_sym_record] = ACTIONS(4551),
    [anon_sym_abstract] = ACTIONS(4551),
    [anon_sym_async] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4551),
    [anon_sym_fixed] = ACTIONS(4551),
    [anon_sym_internal] = ACTIONS(4551),
    [anon_sym_new] = ACTIONS(4551),
    [anon_sym_override] = ACTIONS(4551),
    [anon_sym_partial] = ACTIONS(4551),
    [anon_sym_private] = ACTIONS(4551),
    [anon_sym_protected] = ACTIONS(4551),
    [anon_sym_public] = ACTIONS(4551),
    [anon_sym_readonly] = ACTIONS(4551),
    [anon_sym_required] = ACTIONS(4551),
    [anon_sym_sealed] = ACTIONS(4551),
    [anon_sym_virtual] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_where] = ACTIONS(4551),
    [anon_sym_notnull] = ACTIONS(4551),
    [anon_sym_unmanaged] = ACTIONS(4551),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_implicit] = ACTIONS(4551),
    [anon_sym_explicit] = ACTIONS(4551),
    [anon_sym_scoped] = ACTIONS(4551),
    [anon_sym_var] = ACTIONS(4551),
    [sym_predefined_type] = ACTIONS(4551),
    [anon_sym_yield] = ACTIONS(4551),
    [anon_sym_when] = ACTIONS(4551),
    [anon_sym_from] = ACTIONS(4551),
    [anon_sym_into] = ACTIONS(4551),
    [anon_sym_join] = ACTIONS(4551),
    [anon_sym_on] = ACTIONS(4551),
    [anon_sym_equals] = ACTIONS(4551),
    [anon_sym_let] = ACTIONS(4551),
    [anon_sym_orderby] = ACTIONS(4551),
    [anon_sym_ascending] = ACTIONS(4551),
    [anon_sym_descending] = ACTIONS(4551),
    [anon_sym_group] = ACTIONS(4551),
    [anon_sym_by] = ACTIONS(4551),
    [anon_sym_select] = ACTIONS(4551),
    [aux_sym_preproc_if_token1] = ACTIONS(4553),
    [aux_sym_preproc_if_token3] = ACTIONS(4553),
    [aux_sym_preproc_else_token1] = ACTIONS(4553),
    [aux_sym_preproc_elif_token1] = ACTIONS(4553),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2789] = {
    [sym_preproc_region] = STATE(2789),
    [sym_preproc_endregion] = STATE(2789),
    [sym_preproc_line] = STATE(2789),
    [sym_preproc_pragma] = STATE(2789),
    [sym_preproc_nullable] = STATE(2789),
    [sym_preproc_error] = STATE(2789),
    [sym_preproc_warning] = STATE(2789),
    [sym_preproc_define] = STATE(2789),
    [sym_preproc_undef] = STATE(2789),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_extern] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_using] = ACTIONS(4555),
    [anon_sym_unsafe] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_event] = ACTIONS(4555),
    [anon_sym_namespace] = ACTIONS(4555),
    [anon_sym_class] = ACTIONS(4555),
    [anon_sym_ref] = ACTIONS(4555),
    [anon_sym_struct] = ACTIONS(4555),
    [anon_sym_enum] = ACTIONS(4555),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_interface] = ACTIONS(4555),
    [anon_sym_delegate] = ACTIONS(4555),
    [anon_sym_record] = ACTIONS(4555),
    [anon_sym_abstract] = ACTIONS(4555),
    [anon_sym_async] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_fixed] = ACTIONS(4555),
    [anon_sym_internal] = ACTIONS(4555),
    [anon_sym_new] = ACTIONS(4555),
    [anon_sym_override] = ACTIONS(4555),
    [anon_sym_partial] = ACTIONS(4555),
    [anon_sym_private] = ACTIONS(4555),
    [anon_sym_protected] = ACTIONS(4555),
    [anon_sym_public] = ACTIONS(4555),
    [anon_sym_readonly] = ACTIONS(4555),
    [anon_sym_required] = ACTIONS(4555),
    [anon_sym_sealed] = ACTIONS(4555),
    [anon_sym_virtual] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_TILDE] = ACTIONS(4557),
    [anon_sym_implicit] = ACTIONS(4555),
    [anon_sym_explicit] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_var] = ACTIONS(4555),
    [sym_predefined_type] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [aux_sym_preproc_if_token1] = ACTIONS(4557),
    [aux_sym_preproc_if_token3] = ACTIONS(4557),
    [aux_sym_preproc_else_token1] = ACTIONS(4557),
    [aux_sym_preproc_elif_token1] = ACTIONS(4557),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2790] = {
    [sym_preproc_region] = STATE(2790),
    [sym_preproc_endregion] = STATE(2790),
    [sym_preproc_line] = STATE(2790),
    [sym_preproc_pragma] = STATE(2790),
    [sym_preproc_nullable] = STATE(2790),
    [sym_preproc_error] = STATE(2790),
    [sym_preproc_warning] = STATE(2790),
    [sym_preproc_define] = STATE(2790),
    [sym_preproc_undef] = STATE(2790),
    [sym__identifier_token] = ACTIONS(4559),
    [anon_sym_extern] = ACTIONS(4559),
    [anon_sym_alias] = ACTIONS(4559),
    [anon_sym_global] = ACTIONS(4559),
    [anon_sym_using] = ACTIONS(4559),
    [anon_sym_unsafe] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(4559),
    [anon_sym_LBRACK] = ACTIONS(4561),
    [anon_sym_LPAREN] = ACTIONS(4561),
    [anon_sym_event] = ACTIONS(4559),
    [anon_sym_namespace] = ACTIONS(4559),
    [anon_sym_class] = ACTIONS(4559),
    [anon_sym_ref] = ACTIONS(4559),
    [anon_sym_struct] = ACTIONS(4559),
    [anon_sym_enum] = ACTIONS(4559),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_interface] = ACTIONS(4559),
    [anon_sym_delegate] = ACTIONS(4559),
    [anon_sym_record] = ACTIONS(4559),
    [anon_sym_abstract] = ACTIONS(4559),
    [anon_sym_async] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_file] = ACTIONS(4559),
    [anon_sym_fixed] = ACTIONS(4559),
    [anon_sym_internal] = ACTIONS(4559),
    [anon_sym_new] = ACTIONS(4559),
    [anon_sym_override] = ACTIONS(4559),
    [anon_sym_partial] = ACTIONS(4559),
    [anon_sym_private] = ACTIONS(4559),
    [anon_sym_protected] = ACTIONS(4559),
    [anon_sym_public] = ACTIONS(4559),
    [anon_sym_readonly] = ACTIONS(4559),
    [anon_sym_required] = ACTIONS(4559),
    [anon_sym_sealed] = ACTIONS(4559),
    [anon_sym_virtual] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_where] = ACTIONS(4559),
    [anon_sym_notnull] = ACTIONS(4559),
    [anon_sym_unmanaged] = ACTIONS(4559),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_implicit] = ACTIONS(4559),
    [anon_sym_explicit] = ACTIONS(4559),
    [anon_sym_scoped] = ACTIONS(4559),
    [anon_sym_var] = ACTIONS(4559),
    [sym_predefined_type] = ACTIONS(4559),
    [anon_sym_yield] = ACTIONS(4559),
    [anon_sym_when] = ACTIONS(4559),
    [anon_sym_from] = ACTIONS(4559),
    [anon_sym_into] = ACTIONS(4559),
    [anon_sym_join] = ACTIONS(4559),
    [anon_sym_on] = ACTIONS(4559),
    [anon_sym_equals] = ACTIONS(4559),
    [anon_sym_let] = ACTIONS(4559),
    [anon_sym_orderby] = ACTIONS(4559),
    [anon_sym_ascending] = ACTIONS(4559),
    [anon_sym_descending] = ACTIONS(4559),
    [anon_sym_group] = ACTIONS(4559),
    [anon_sym_by] = ACTIONS(4559),
    [anon_sym_select] = ACTIONS(4559),
    [aux_sym_preproc_if_token1] = ACTIONS(4561),
    [aux_sym_preproc_if_token3] = ACTIONS(4561),
    [aux_sym_preproc_else_token1] = ACTIONS(4561),
    [aux_sym_preproc_elif_token1] = ACTIONS(4561),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2791] = {
    [sym_preproc_region] = STATE(2791),
    [sym_preproc_endregion] = STATE(2791),
    [sym_preproc_line] = STATE(2791),
    [sym_preproc_pragma] = STATE(2791),
    [sym_preproc_nullable] = STATE(2791),
    [sym_preproc_error] = STATE(2791),
    [sym_preproc_warning] = STATE(2791),
    [sym_preproc_define] = STATE(2791),
    [sym_preproc_undef] = STATE(2791),
    [sym__identifier_token] = ACTIONS(4563),
    [anon_sym_extern] = ACTIONS(4563),
    [anon_sym_alias] = ACTIONS(4563),
    [anon_sym_global] = ACTIONS(4563),
    [anon_sym_using] = ACTIONS(4563),
    [anon_sym_unsafe] = ACTIONS(4563),
    [anon_sym_static] = ACTIONS(4563),
    [anon_sym_LBRACK] = ACTIONS(4565),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_event] = ACTIONS(4563),
    [anon_sym_namespace] = ACTIONS(4563),
    [anon_sym_class] = ACTIONS(4563),
    [anon_sym_ref] = ACTIONS(4563),
    [anon_sym_struct] = ACTIONS(4563),
    [anon_sym_enum] = ACTIONS(4563),
    [anon_sym_RBRACE] = ACTIONS(4565),
    [anon_sym_interface] = ACTIONS(4563),
    [anon_sym_delegate] = ACTIONS(4563),
    [anon_sym_record] = ACTIONS(4563),
    [anon_sym_abstract] = ACTIONS(4563),
    [anon_sym_async] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_file] = ACTIONS(4563),
    [anon_sym_fixed] = ACTIONS(4563),
    [anon_sym_internal] = ACTIONS(4563),
    [anon_sym_new] = ACTIONS(4563),
    [anon_sym_override] = ACTIONS(4563),
    [anon_sym_partial] = ACTIONS(4563),
    [anon_sym_private] = ACTIONS(4563),
    [anon_sym_protected] = ACTIONS(4563),
    [anon_sym_public] = ACTIONS(4563),
    [anon_sym_readonly] = ACTIONS(4563),
    [anon_sym_required] = ACTIONS(4563),
    [anon_sym_sealed] = ACTIONS(4563),
    [anon_sym_virtual] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_where] = ACTIONS(4563),
    [anon_sym_notnull] = ACTIONS(4563),
    [anon_sym_unmanaged] = ACTIONS(4563),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_implicit] = ACTIONS(4563),
    [anon_sym_explicit] = ACTIONS(4563),
    [anon_sym_scoped] = ACTIONS(4563),
    [anon_sym_var] = ACTIONS(4563),
    [sym_predefined_type] = ACTIONS(4563),
    [anon_sym_yield] = ACTIONS(4563),
    [anon_sym_when] = ACTIONS(4563),
    [anon_sym_from] = ACTIONS(4563),
    [anon_sym_into] = ACTIONS(4563),
    [anon_sym_join] = ACTIONS(4563),
    [anon_sym_on] = ACTIONS(4563),
    [anon_sym_equals] = ACTIONS(4563),
    [anon_sym_let] = ACTIONS(4563),
    [anon_sym_orderby] = ACTIONS(4563),
    [anon_sym_ascending] = ACTIONS(4563),
    [anon_sym_descending] = ACTIONS(4563),
    [anon_sym_group] = ACTIONS(4563),
    [anon_sym_by] = ACTIONS(4563),
    [anon_sym_select] = ACTIONS(4563),
    [aux_sym_preproc_if_token1] = ACTIONS(4565),
    [aux_sym_preproc_if_token3] = ACTIONS(4565),
    [aux_sym_preproc_else_token1] = ACTIONS(4565),
    [aux_sym_preproc_elif_token1] = ACTIONS(4565),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2792] = {
    [sym_preproc_region] = STATE(2792),
    [sym_preproc_endregion] = STATE(2792),
    [sym_preproc_line] = STATE(2792),
    [sym_preproc_pragma] = STATE(2792),
    [sym_preproc_nullable] = STATE(2792),
    [sym_preproc_error] = STATE(2792),
    [sym_preproc_warning] = STATE(2792),
    [sym_preproc_define] = STATE(2792),
    [sym_preproc_undef] = STATE(2792),
    [sym__identifier_token] = ACTIONS(4567),
    [anon_sym_extern] = ACTIONS(4567),
    [anon_sym_alias] = ACTIONS(4567),
    [anon_sym_global] = ACTIONS(4567),
    [anon_sym_using] = ACTIONS(4567),
    [anon_sym_unsafe] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(4567),
    [anon_sym_LBRACK] = ACTIONS(4569),
    [anon_sym_LPAREN] = ACTIONS(4569),
    [anon_sym_event] = ACTIONS(4567),
    [anon_sym_namespace] = ACTIONS(4567),
    [anon_sym_class] = ACTIONS(4567),
    [anon_sym_ref] = ACTIONS(4567),
    [anon_sym_struct] = ACTIONS(4567),
    [anon_sym_enum] = ACTIONS(4567),
    [anon_sym_RBRACE] = ACTIONS(4569),
    [anon_sym_interface] = ACTIONS(4567),
    [anon_sym_delegate] = ACTIONS(4567),
    [anon_sym_record] = ACTIONS(4567),
    [anon_sym_abstract] = ACTIONS(4567),
    [anon_sym_async] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_file] = ACTIONS(4567),
    [anon_sym_fixed] = ACTIONS(4567),
    [anon_sym_internal] = ACTIONS(4567),
    [anon_sym_new] = ACTIONS(4567),
    [anon_sym_override] = ACTIONS(4567),
    [anon_sym_partial] = ACTIONS(4567),
    [anon_sym_private] = ACTIONS(4567),
    [anon_sym_protected] = ACTIONS(4567),
    [anon_sym_public] = ACTIONS(4567),
    [anon_sym_readonly] = ACTIONS(4567),
    [anon_sym_required] = ACTIONS(4567),
    [anon_sym_sealed] = ACTIONS(4567),
    [anon_sym_virtual] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_where] = ACTIONS(4567),
    [anon_sym_notnull] = ACTIONS(4567),
    [anon_sym_unmanaged] = ACTIONS(4567),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_implicit] = ACTIONS(4567),
    [anon_sym_explicit] = ACTIONS(4567),
    [anon_sym_scoped] = ACTIONS(4567),
    [anon_sym_var] = ACTIONS(4567),
    [sym_predefined_type] = ACTIONS(4567),
    [anon_sym_yield] = ACTIONS(4567),
    [anon_sym_when] = ACTIONS(4567),
    [anon_sym_from] = ACTIONS(4567),
    [anon_sym_into] = ACTIONS(4567),
    [anon_sym_join] = ACTIONS(4567),
    [anon_sym_on] = ACTIONS(4567),
    [anon_sym_equals] = ACTIONS(4567),
    [anon_sym_let] = ACTIONS(4567),
    [anon_sym_orderby] = ACTIONS(4567),
    [anon_sym_ascending] = ACTIONS(4567),
    [anon_sym_descending] = ACTIONS(4567),
    [anon_sym_group] = ACTIONS(4567),
    [anon_sym_by] = ACTIONS(4567),
    [anon_sym_select] = ACTIONS(4567),
    [aux_sym_preproc_if_token1] = ACTIONS(4569),
    [aux_sym_preproc_if_token3] = ACTIONS(4569),
    [aux_sym_preproc_else_token1] = ACTIONS(4569),
    [aux_sym_preproc_elif_token1] = ACTIONS(4569),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2793] = {
    [sym_preproc_region] = STATE(2793),
    [sym_preproc_endregion] = STATE(2793),
    [sym_preproc_line] = STATE(2793),
    [sym_preproc_pragma] = STATE(2793),
    [sym_preproc_nullable] = STATE(2793),
    [sym_preproc_error] = STATE(2793),
    [sym_preproc_warning] = STATE(2793),
    [sym_preproc_define] = STATE(2793),
    [sym_preproc_undef] = STATE(2793),
    [sym__identifier_token] = ACTIONS(4571),
    [anon_sym_extern] = ACTIONS(4571),
    [anon_sym_alias] = ACTIONS(4571),
    [anon_sym_global] = ACTIONS(4571),
    [anon_sym_using] = ACTIONS(4571),
    [anon_sym_unsafe] = ACTIONS(4571),
    [anon_sym_static] = ACTIONS(4571),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_LPAREN] = ACTIONS(4573),
    [anon_sym_event] = ACTIONS(4571),
    [anon_sym_namespace] = ACTIONS(4571),
    [anon_sym_class] = ACTIONS(4571),
    [anon_sym_ref] = ACTIONS(4571),
    [anon_sym_struct] = ACTIONS(4571),
    [anon_sym_enum] = ACTIONS(4571),
    [anon_sym_RBRACE] = ACTIONS(4573),
    [anon_sym_interface] = ACTIONS(4571),
    [anon_sym_delegate] = ACTIONS(4571),
    [anon_sym_record] = ACTIONS(4571),
    [anon_sym_abstract] = ACTIONS(4571),
    [anon_sym_async] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_file] = ACTIONS(4571),
    [anon_sym_fixed] = ACTIONS(4571),
    [anon_sym_internal] = ACTIONS(4571),
    [anon_sym_new] = ACTIONS(4571),
    [anon_sym_override] = ACTIONS(4571),
    [anon_sym_partial] = ACTIONS(4571),
    [anon_sym_private] = ACTIONS(4571),
    [anon_sym_protected] = ACTIONS(4571),
    [anon_sym_public] = ACTIONS(4571),
    [anon_sym_readonly] = ACTIONS(4571),
    [anon_sym_required] = ACTIONS(4571),
    [anon_sym_sealed] = ACTIONS(4571),
    [anon_sym_virtual] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_where] = ACTIONS(4571),
    [anon_sym_notnull] = ACTIONS(4571),
    [anon_sym_unmanaged] = ACTIONS(4571),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_implicit] = ACTIONS(4571),
    [anon_sym_explicit] = ACTIONS(4571),
    [anon_sym_scoped] = ACTIONS(4571),
    [anon_sym_var] = ACTIONS(4571),
    [sym_predefined_type] = ACTIONS(4571),
    [anon_sym_yield] = ACTIONS(4571),
    [anon_sym_when] = ACTIONS(4571),
    [anon_sym_from] = ACTIONS(4571),
    [anon_sym_into] = ACTIONS(4571),
    [anon_sym_join] = ACTIONS(4571),
    [anon_sym_on] = ACTIONS(4571),
    [anon_sym_equals] = ACTIONS(4571),
    [anon_sym_let] = ACTIONS(4571),
    [anon_sym_orderby] = ACTIONS(4571),
    [anon_sym_ascending] = ACTIONS(4571),
    [anon_sym_descending] = ACTIONS(4571),
    [anon_sym_group] = ACTIONS(4571),
    [anon_sym_by] = ACTIONS(4571),
    [anon_sym_select] = ACTIONS(4571),
    [aux_sym_preproc_if_token1] = ACTIONS(4573),
    [aux_sym_preproc_if_token3] = ACTIONS(4573),
    [aux_sym_preproc_else_token1] = ACTIONS(4573),
    [aux_sym_preproc_elif_token1] = ACTIONS(4573),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2794] = {
    [sym_preproc_region] = STATE(2794),
    [sym_preproc_endregion] = STATE(2794),
    [sym_preproc_line] = STATE(2794),
    [sym_preproc_pragma] = STATE(2794),
    [sym_preproc_nullable] = STATE(2794),
    [sym_preproc_error] = STATE(2794),
    [sym_preproc_warning] = STATE(2794),
    [sym_preproc_define] = STATE(2794),
    [sym_preproc_undef] = STATE(2794),
    [sym__identifier_token] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym_alias] = ACTIONS(4575),
    [anon_sym_global] = ACTIONS(4575),
    [anon_sym_using] = ACTIONS(4575),
    [anon_sym_unsafe] = ACTIONS(4575),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(4577),
    [anon_sym_LPAREN] = ACTIONS(4577),
    [anon_sym_event] = ACTIONS(4575),
    [anon_sym_namespace] = ACTIONS(4575),
    [anon_sym_class] = ACTIONS(4575),
    [anon_sym_ref] = ACTIONS(4575),
    [anon_sym_struct] = ACTIONS(4575),
    [anon_sym_enum] = ACTIONS(4575),
    [anon_sym_RBRACE] = ACTIONS(4577),
    [anon_sym_interface] = ACTIONS(4575),
    [anon_sym_delegate] = ACTIONS(4575),
    [anon_sym_record] = ACTIONS(4575),
    [anon_sym_abstract] = ACTIONS(4575),
    [anon_sym_async] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_file] = ACTIONS(4575),
    [anon_sym_fixed] = ACTIONS(4575),
    [anon_sym_internal] = ACTIONS(4575),
    [anon_sym_new] = ACTIONS(4575),
    [anon_sym_override] = ACTIONS(4575),
    [anon_sym_partial] = ACTIONS(4575),
    [anon_sym_private] = ACTIONS(4575),
    [anon_sym_protected] = ACTIONS(4575),
    [anon_sym_public] = ACTIONS(4575),
    [anon_sym_readonly] = ACTIONS(4575),
    [anon_sym_required] = ACTIONS(4575),
    [anon_sym_sealed] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_where] = ACTIONS(4575),
    [anon_sym_notnull] = ACTIONS(4575),
    [anon_sym_unmanaged] = ACTIONS(4575),
    [anon_sym_TILDE] = ACTIONS(4577),
    [anon_sym_implicit] = ACTIONS(4575),
    [anon_sym_explicit] = ACTIONS(4575),
    [anon_sym_scoped] = ACTIONS(4575),
    [anon_sym_var] = ACTIONS(4575),
    [sym_predefined_type] = ACTIONS(4575),
    [anon_sym_yield] = ACTIONS(4575),
    [anon_sym_when] = ACTIONS(4575),
    [anon_sym_from] = ACTIONS(4575),
    [anon_sym_into] = ACTIONS(4575),
    [anon_sym_join] = ACTIONS(4575),
    [anon_sym_on] = ACTIONS(4575),
    [anon_sym_equals] = ACTIONS(4575),
    [anon_sym_let] = ACTIONS(4575),
    [anon_sym_orderby] = ACTIONS(4575),
    [anon_sym_ascending] = ACTIONS(4575),
    [anon_sym_descending] = ACTIONS(4575),
    [anon_sym_group] = ACTIONS(4575),
    [anon_sym_by] = ACTIONS(4575),
    [anon_sym_select] = ACTIONS(4575),
    [aux_sym_preproc_if_token1] = ACTIONS(4577),
    [aux_sym_preproc_if_token3] = ACTIONS(4577),
    [aux_sym_preproc_else_token1] = ACTIONS(4577),
    [aux_sym_preproc_elif_token1] = ACTIONS(4577),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2795] = {
    [sym_preproc_region] = STATE(2795),
    [sym_preproc_endregion] = STATE(2795),
    [sym_preproc_line] = STATE(2795),
    [sym_preproc_pragma] = STATE(2795),
    [sym_preproc_nullable] = STATE(2795),
    [sym_preproc_error] = STATE(2795),
    [sym_preproc_warning] = STATE(2795),
    [sym_preproc_define] = STATE(2795),
    [sym_preproc_undef] = STATE(2795),
    [sym__identifier_token] = ACTIONS(4579),
    [anon_sym_extern] = ACTIONS(4579),
    [anon_sym_alias] = ACTIONS(4579),
    [anon_sym_global] = ACTIONS(4579),
    [anon_sym_using] = ACTIONS(4579),
    [anon_sym_unsafe] = ACTIONS(4579),
    [anon_sym_static] = ACTIONS(4579),
    [anon_sym_LBRACK] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(4581),
    [anon_sym_event] = ACTIONS(4579),
    [anon_sym_namespace] = ACTIONS(4579),
    [anon_sym_class] = ACTIONS(4579),
    [anon_sym_ref] = ACTIONS(4579),
    [anon_sym_struct] = ACTIONS(4579),
    [anon_sym_enum] = ACTIONS(4579),
    [anon_sym_RBRACE] = ACTIONS(4581),
    [anon_sym_interface] = ACTIONS(4579),
    [anon_sym_delegate] = ACTIONS(4579),
    [anon_sym_record] = ACTIONS(4579),
    [anon_sym_abstract] = ACTIONS(4579),
    [anon_sym_async] = ACTIONS(4579),
    [anon_sym_const] = ACTIONS(4579),
    [anon_sym_file] = ACTIONS(4579),
    [anon_sym_fixed] = ACTIONS(4579),
    [anon_sym_internal] = ACTIONS(4579),
    [anon_sym_new] = ACTIONS(4579),
    [anon_sym_override] = ACTIONS(4579),
    [anon_sym_partial] = ACTIONS(4579),
    [anon_sym_private] = ACTIONS(4579),
    [anon_sym_protected] = ACTIONS(4579),
    [anon_sym_public] = ACTIONS(4579),
    [anon_sym_readonly] = ACTIONS(4579),
    [anon_sym_required] = ACTIONS(4579),
    [anon_sym_sealed] = ACTIONS(4579),
    [anon_sym_virtual] = ACTIONS(4579),
    [anon_sym_volatile] = ACTIONS(4579),
    [anon_sym_where] = ACTIONS(4579),
    [anon_sym_notnull] = ACTIONS(4579),
    [anon_sym_unmanaged] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4581),
    [anon_sym_implicit] = ACTIONS(4579),
    [anon_sym_explicit] = ACTIONS(4579),
    [anon_sym_scoped] = ACTIONS(4579),
    [anon_sym_var] = ACTIONS(4579),
    [sym_predefined_type] = ACTIONS(4579),
    [anon_sym_yield] = ACTIONS(4579),
    [anon_sym_when] = ACTIONS(4579),
    [anon_sym_from] = ACTIONS(4579),
    [anon_sym_into] = ACTIONS(4579),
    [anon_sym_join] = ACTIONS(4579),
    [anon_sym_on] = ACTIONS(4579),
    [anon_sym_equals] = ACTIONS(4579),
    [anon_sym_let] = ACTIONS(4579),
    [anon_sym_orderby] = ACTIONS(4579),
    [anon_sym_ascending] = ACTIONS(4579),
    [anon_sym_descending] = ACTIONS(4579),
    [anon_sym_group] = ACTIONS(4579),
    [anon_sym_by] = ACTIONS(4579),
    [anon_sym_select] = ACTIONS(4579),
    [aux_sym_preproc_if_token1] = ACTIONS(4581),
    [aux_sym_preproc_if_token3] = ACTIONS(4581),
    [aux_sym_preproc_else_token1] = ACTIONS(4581),
    [aux_sym_preproc_elif_token1] = ACTIONS(4581),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2796] = {
    [sym_preproc_region] = STATE(2796),
    [sym_preproc_endregion] = STATE(2796),
    [sym_preproc_line] = STATE(2796),
    [sym_preproc_pragma] = STATE(2796),
    [sym_preproc_nullable] = STATE(2796),
    [sym_preproc_error] = STATE(2796),
    [sym_preproc_warning] = STATE(2796),
    [sym_preproc_define] = STATE(2796),
    [sym_preproc_undef] = STATE(2796),
    [sym__identifier_token] = ACTIONS(4583),
    [anon_sym_extern] = ACTIONS(4583),
    [anon_sym_alias] = ACTIONS(4583),
    [anon_sym_global] = ACTIONS(4583),
    [anon_sym_using] = ACTIONS(4583),
    [anon_sym_unsafe] = ACTIONS(4583),
    [anon_sym_static] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(4585),
    [anon_sym_LPAREN] = ACTIONS(4585),
    [anon_sym_event] = ACTIONS(4583),
    [anon_sym_namespace] = ACTIONS(4583),
    [anon_sym_class] = ACTIONS(4583),
    [anon_sym_ref] = ACTIONS(4583),
    [anon_sym_struct] = ACTIONS(4583),
    [anon_sym_enum] = ACTIONS(4583),
    [anon_sym_RBRACE] = ACTIONS(4585),
    [anon_sym_interface] = ACTIONS(4583),
    [anon_sym_delegate] = ACTIONS(4583),
    [anon_sym_record] = ACTIONS(4583),
    [anon_sym_abstract] = ACTIONS(4583),
    [anon_sym_async] = ACTIONS(4583),
    [anon_sym_const] = ACTIONS(4583),
    [anon_sym_file] = ACTIONS(4583),
    [anon_sym_fixed] = ACTIONS(4583),
    [anon_sym_internal] = ACTIONS(4583),
    [anon_sym_new] = ACTIONS(4583),
    [anon_sym_override] = ACTIONS(4583),
    [anon_sym_partial] = ACTIONS(4583),
    [anon_sym_private] = ACTIONS(4583),
    [anon_sym_protected] = ACTIONS(4583),
    [anon_sym_public] = ACTIONS(4583),
    [anon_sym_readonly] = ACTIONS(4583),
    [anon_sym_required] = ACTIONS(4583),
    [anon_sym_sealed] = ACTIONS(4583),
    [anon_sym_virtual] = ACTIONS(4583),
    [anon_sym_volatile] = ACTIONS(4583),
    [anon_sym_where] = ACTIONS(4583),
    [anon_sym_notnull] = ACTIONS(4583),
    [anon_sym_unmanaged] = ACTIONS(4583),
    [anon_sym_TILDE] = ACTIONS(4585),
    [anon_sym_implicit] = ACTIONS(4583),
    [anon_sym_explicit] = ACTIONS(4583),
    [anon_sym_scoped] = ACTIONS(4583),
    [anon_sym_var] = ACTIONS(4583),
    [sym_predefined_type] = ACTIONS(4583),
    [anon_sym_yield] = ACTIONS(4583),
    [anon_sym_when] = ACTIONS(4583),
    [anon_sym_from] = ACTIONS(4583),
    [anon_sym_into] = ACTIONS(4583),
    [anon_sym_join] = ACTIONS(4583),
    [anon_sym_on] = ACTIONS(4583),
    [anon_sym_equals] = ACTIONS(4583),
    [anon_sym_let] = ACTIONS(4583),
    [anon_sym_orderby] = ACTIONS(4583),
    [anon_sym_ascending] = ACTIONS(4583),
    [anon_sym_descending] = ACTIONS(4583),
    [anon_sym_group] = ACTIONS(4583),
    [anon_sym_by] = ACTIONS(4583),
    [anon_sym_select] = ACTIONS(4583),
    [aux_sym_preproc_if_token1] = ACTIONS(4585),
    [aux_sym_preproc_if_token3] = ACTIONS(4585),
    [aux_sym_preproc_else_token1] = ACTIONS(4585),
    [aux_sym_preproc_elif_token1] = ACTIONS(4585),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2797] = {
    [sym_preproc_region] = STATE(2797),
    [sym_preproc_endregion] = STATE(2797),
    [sym_preproc_line] = STATE(2797),
    [sym_preproc_pragma] = STATE(2797),
    [sym_preproc_nullable] = STATE(2797),
    [sym_preproc_error] = STATE(2797),
    [sym_preproc_warning] = STATE(2797),
    [sym_preproc_define] = STATE(2797),
    [sym_preproc_undef] = STATE(2797),
    [sym__identifier_token] = ACTIONS(4587),
    [anon_sym_extern] = ACTIONS(4587),
    [anon_sym_alias] = ACTIONS(4587),
    [anon_sym_global] = ACTIONS(4587),
    [anon_sym_using] = ACTIONS(4587),
    [anon_sym_unsafe] = ACTIONS(4587),
    [anon_sym_static] = ACTIONS(4587),
    [anon_sym_LBRACK] = ACTIONS(4589),
    [anon_sym_LPAREN] = ACTIONS(4589),
    [anon_sym_event] = ACTIONS(4587),
    [anon_sym_namespace] = ACTIONS(4587),
    [anon_sym_class] = ACTIONS(4587),
    [anon_sym_ref] = ACTIONS(4587),
    [anon_sym_struct] = ACTIONS(4587),
    [anon_sym_enum] = ACTIONS(4587),
    [anon_sym_RBRACE] = ACTIONS(4589),
    [anon_sym_interface] = ACTIONS(4587),
    [anon_sym_delegate] = ACTIONS(4587),
    [anon_sym_record] = ACTIONS(4587),
    [anon_sym_abstract] = ACTIONS(4587),
    [anon_sym_async] = ACTIONS(4587),
    [anon_sym_const] = ACTIONS(4587),
    [anon_sym_file] = ACTIONS(4587),
    [anon_sym_fixed] = ACTIONS(4587),
    [anon_sym_internal] = ACTIONS(4587),
    [anon_sym_new] = ACTIONS(4587),
    [anon_sym_override] = ACTIONS(4587),
    [anon_sym_partial] = ACTIONS(4587),
    [anon_sym_private] = ACTIONS(4587),
    [anon_sym_protected] = ACTIONS(4587),
    [anon_sym_public] = ACTIONS(4587),
    [anon_sym_readonly] = ACTIONS(4587),
    [anon_sym_required] = ACTIONS(4587),
    [anon_sym_sealed] = ACTIONS(4587),
    [anon_sym_virtual] = ACTIONS(4587),
    [anon_sym_volatile] = ACTIONS(4587),
    [anon_sym_where] = ACTIONS(4587),
    [anon_sym_notnull] = ACTIONS(4587),
    [anon_sym_unmanaged] = ACTIONS(4587),
    [anon_sym_TILDE] = ACTIONS(4589),
    [anon_sym_implicit] = ACTIONS(4587),
    [anon_sym_explicit] = ACTIONS(4587),
    [anon_sym_scoped] = ACTIONS(4587),
    [anon_sym_var] = ACTIONS(4587),
    [sym_predefined_type] = ACTIONS(4587),
    [anon_sym_yield] = ACTIONS(4587),
    [anon_sym_when] = ACTIONS(4587),
    [anon_sym_from] = ACTIONS(4587),
    [anon_sym_into] = ACTIONS(4587),
    [anon_sym_join] = ACTIONS(4587),
    [anon_sym_on] = ACTIONS(4587),
    [anon_sym_equals] = ACTIONS(4587),
    [anon_sym_let] = ACTIONS(4587),
    [anon_sym_orderby] = ACTIONS(4587),
    [anon_sym_ascending] = ACTIONS(4587),
    [anon_sym_descending] = ACTIONS(4587),
    [anon_sym_group] = ACTIONS(4587),
    [anon_sym_by] = ACTIONS(4587),
    [anon_sym_select] = ACTIONS(4587),
    [aux_sym_preproc_if_token1] = ACTIONS(4589),
    [aux_sym_preproc_if_token3] = ACTIONS(4589),
    [aux_sym_preproc_else_token1] = ACTIONS(4589),
    [aux_sym_preproc_elif_token1] = ACTIONS(4589),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2798] = {
    [sym__variable_designation] = STATE(4193),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(2798),
    [sym_preproc_endregion] = STATE(2798),
    [sym_preproc_line] = STATE(2798),
    [sym_preproc_pragma] = STATE(2798),
    [sym_preproc_nullable] = STATE(2798),
    [sym_preproc_error] = STATE(2798),
    [sym_preproc_warning] = STATE(2798),
    [sym_preproc_define] = STATE(2798),
    [sym_preproc_undef] = STATE(2798),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3979),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3975),
    [anon_sym_BANG_EQ] = ACTIONS(3975),
    [anon_sym_GT_EQ] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3975),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_scoped] = ACTIONS(3893),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3979),
    [anon_sym_when] = ACTIONS(3893),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_and] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3975),
    [anon_sym_PIPE_PIPE] = ACTIONS(3975),
    [anon_sym_QMARK_QMARK] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_is] = ACTIONS(3979),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2799] = {
    [sym_preproc_region] = STATE(2799),
    [sym_preproc_endregion] = STATE(2799),
    [sym_preproc_line] = STATE(2799),
    [sym_preproc_pragma] = STATE(2799),
    [sym_preproc_nullable] = STATE(2799),
    [sym_preproc_error] = STATE(2799),
    [sym_preproc_warning] = STATE(2799),
    [sym_preproc_define] = STATE(2799),
    [sym_preproc_undef] = STATE(2799),
    [sym__identifier_token] = ACTIONS(4591),
    [anon_sym_extern] = ACTIONS(4591),
    [anon_sym_alias] = ACTIONS(4591),
    [anon_sym_global] = ACTIONS(4591),
    [anon_sym_using] = ACTIONS(4591),
    [anon_sym_unsafe] = ACTIONS(4591),
    [anon_sym_static] = ACTIONS(4591),
    [anon_sym_LBRACK] = ACTIONS(4593),
    [anon_sym_LPAREN] = ACTIONS(4593),
    [anon_sym_event] = ACTIONS(4591),
    [anon_sym_namespace] = ACTIONS(4591),
    [anon_sym_class] = ACTIONS(4591),
    [anon_sym_ref] = ACTIONS(4591),
    [anon_sym_struct] = ACTIONS(4591),
    [anon_sym_enum] = ACTIONS(4591),
    [anon_sym_RBRACE] = ACTIONS(4593),
    [anon_sym_interface] = ACTIONS(4591),
    [anon_sym_delegate] = ACTIONS(4591),
    [anon_sym_record] = ACTIONS(4591),
    [anon_sym_abstract] = ACTIONS(4591),
    [anon_sym_async] = ACTIONS(4591),
    [anon_sym_const] = ACTIONS(4591),
    [anon_sym_file] = ACTIONS(4591),
    [anon_sym_fixed] = ACTIONS(4591),
    [anon_sym_internal] = ACTIONS(4591),
    [anon_sym_new] = ACTIONS(4591),
    [anon_sym_override] = ACTIONS(4591),
    [anon_sym_partial] = ACTIONS(4591),
    [anon_sym_private] = ACTIONS(4591),
    [anon_sym_protected] = ACTIONS(4591),
    [anon_sym_public] = ACTIONS(4591),
    [anon_sym_readonly] = ACTIONS(4591),
    [anon_sym_required] = ACTIONS(4591),
    [anon_sym_sealed] = ACTIONS(4591),
    [anon_sym_virtual] = ACTIONS(4591),
    [anon_sym_volatile] = ACTIONS(4591),
    [anon_sym_where] = ACTIONS(4591),
    [anon_sym_notnull] = ACTIONS(4591),
    [anon_sym_unmanaged] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4593),
    [anon_sym_implicit] = ACTIONS(4591),
    [anon_sym_explicit] = ACTIONS(4591),
    [anon_sym_scoped] = ACTIONS(4591),
    [anon_sym_var] = ACTIONS(4591),
    [sym_predefined_type] = ACTIONS(4591),
    [anon_sym_yield] = ACTIONS(4591),
    [anon_sym_when] = ACTIONS(4591),
    [anon_sym_from] = ACTIONS(4591),
    [anon_sym_into] = ACTIONS(4591),
    [anon_sym_join] = ACTIONS(4591),
    [anon_sym_on] = ACTIONS(4591),
    [anon_sym_equals] = ACTIONS(4591),
    [anon_sym_let] = ACTIONS(4591),
    [anon_sym_orderby] = ACTIONS(4591),
    [anon_sym_ascending] = ACTIONS(4591),
    [anon_sym_descending] = ACTIONS(4591),
    [anon_sym_group] = ACTIONS(4591),
    [anon_sym_by] = ACTIONS(4591),
    [anon_sym_select] = ACTIONS(4591),
    [aux_sym_preproc_if_token1] = ACTIONS(4593),
    [aux_sym_preproc_if_token3] = ACTIONS(4593),
    [aux_sym_preproc_else_token1] = ACTIONS(4593),
    [aux_sym_preproc_elif_token1] = ACTIONS(4593),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2800] = {
    [sym_preproc_region] = STATE(2800),
    [sym_preproc_endregion] = STATE(2800),
    [sym_preproc_line] = STATE(2800),
    [sym_preproc_pragma] = STATE(2800),
    [sym_preproc_nullable] = STATE(2800),
    [sym_preproc_error] = STATE(2800),
    [sym_preproc_warning] = STATE(2800),
    [sym_preproc_define] = STATE(2800),
    [sym_preproc_undef] = STATE(2800),
    [sym__identifier_token] = ACTIONS(4595),
    [anon_sym_extern] = ACTIONS(4595),
    [anon_sym_alias] = ACTIONS(4595),
    [anon_sym_global] = ACTIONS(4595),
    [anon_sym_using] = ACTIONS(4595),
    [anon_sym_unsafe] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(4595),
    [anon_sym_LBRACK] = ACTIONS(4597),
    [anon_sym_LPAREN] = ACTIONS(4597),
    [anon_sym_event] = ACTIONS(4595),
    [anon_sym_namespace] = ACTIONS(4595),
    [anon_sym_class] = ACTIONS(4595),
    [anon_sym_ref] = ACTIONS(4595),
    [anon_sym_struct] = ACTIONS(4595),
    [anon_sym_enum] = ACTIONS(4595),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_interface] = ACTIONS(4595),
    [anon_sym_delegate] = ACTIONS(4595),
    [anon_sym_record] = ACTIONS(4595),
    [anon_sym_abstract] = ACTIONS(4595),
    [anon_sym_async] = ACTIONS(4595),
    [anon_sym_const] = ACTIONS(4595),
    [anon_sym_file] = ACTIONS(4595),
    [anon_sym_fixed] = ACTIONS(4595),
    [anon_sym_internal] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4595),
    [anon_sym_override] = ACTIONS(4595),
    [anon_sym_partial] = ACTIONS(4595),
    [anon_sym_private] = ACTIONS(4595),
    [anon_sym_protected] = ACTIONS(4595),
    [anon_sym_public] = ACTIONS(4595),
    [anon_sym_readonly] = ACTIONS(4595),
    [anon_sym_required] = ACTIONS(4595),
    [anon_sym_sealed] = ACTIONS(4595),
    [anon_sym_virtual] = ACTIONS(4595),
    [anon_sym_volatile] = ACTIONS(4595),
    [anon_sym_where] = ACTIONS(4595),
    [anon_sym_notnull] = ACTIONS(4595),
    [anon_sym_unmanaged] = ACTIONS(4595),
    [anon_sym_TILDE] = ACTIONS(4597),
    [anon_sym_implicit] = ACTIONS(4595),
    [anon_sym_explicit] = ACTIONS(4595),
    [anon_sym_scoped] = ACTIONS(4595),
    [anon_sym_var] = ACTIONS(4595),
    [sym_predefined_type] = ACTIONS(4595),
    [anon_sym_yield] = ACTIONS(4595),
    [anon_sym_when] = ACTIONS(4595),
    [anon_sym_from] = ACTIONS(4595),
    [anon_sym_into] = ACTIONS(4595),
    [anon_sym_join] = ACTIONS(4595),
    [anon_sym_on] = ACTIONS(4595),
    [anon_sym_equals] = ACTIONS(4595),
    [anon_sym_let] = ACTIONS(4595),
    [anon_sym_orderby] = ACTIONS(4595),
    [anon_sym_ascending] = ACTIONS(4595),
    [anon_sym_descending] = ACTIONS(4595),
    [anon_sym_group] = ACTIONS(4595),
    [anon_sym_by] = ACTIONS(4595),
    [anon_sym_select] = ACTIONS(4595),
    [aux_sym_preproc_if_token1] = ACTIONS(4597),
    [aux_sym_preproc_if_token3] = ACTIONS(4597),
    [aux_sym_preproc_else_token1] = ACTIONS(4597),
    [aux_sym_preproc_elif_token1] = ACTIONS(4597),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2801] = {
    [sym_preproc_region] = STATE(2801),
    [sym_preproc_endregion] = STATE(2801),
    [sym_preproc_line] = STATE(2801),
    [sym_preproc_pragma] = STATE(2801),
    [sym_preproc_nullable] = STATE(2801),
    [sym_preproc_error] = STATE(2801),
    [sym_preproc_warning] = STATE(2801),
    [sym_preproc_define] = STATE(2801),
    [sym_preproc_undef] = STATE(2801),
    [sym__identifier_token] = ACTIONS(4599),
    [anon_sym_extern] = ACTIONS(4599),
    [anon_sym_alias] = ACTIONS(4599),
    [anon_sym_global] = ACTIONS(4599),
    [anon_sym_using] = ACTIONS(4599),
    [anon_sym_unsafe] = ACTIONS(4599),
    [anon_sym_static] = ACTIONS(4599),
    [anon_sym_LBRACK] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(4601),
    [anon_sym_event] = ACTIONS(4599),
    [anon_sym_namespace] = ACTIONS(4599),
    [anon_sym_class] = ACTIONS(4599),
    [anon_sym_ref] = ACTIONS(4599),
    [anon_sym_struct] = ACTIONS(4599),
    [anon_sym_enum] = ACTIONS(4599),
    [anon_sym_RBRACE] = ACTIONS(4601),
    [anon_sym_interface] = ACTIONS(4599),
    [anon_sym_delegate] = ACTIONS(4599),
    [anon_sym_record] = ACTIONS(4599),
    [anon_sym_abstract] = ACTIONS(4599),
    [anon_sym_async] = ACTIONS(4599),
    [anon_sym_const] = ACTIONS(4599),
    [anon_sym_file] = ACTIONS(4599),
    [anon_sym_fixed] = ACTIONS(4599),
    [anon_sym_internal] = ACTIONS(4599),
    [anon_sym_new] = ACTIONS(4599),
    [anon_sym_override] = ACTIONS(4599),
    [anon_sym_partial] = ACTIONS(4599),
    [anon_sym_private] = ACTIONS(4599),
    [anon_sym_protected] = ACTIONS(4599),
    [anon_sym_public] = ACTIONS(4599),
    [anon_sym_readonly] = ACTIONS(4599),
    [anon_sym_required] = ACTIONS(4599),
    [anon_sym_sealed] = ACTIONS(4599),
    [anon_sym_virtual] = ACTIONS(4599),
    [anon_sym_volatile] = ACTIONS(4599),
    [anon_sym_where] = ACTIONS(4599),
    [anon_sym_notnull] = ACTIONS(4599),
    [anon_sym_unmanaged] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4601),
    [anon_sym_implicit] = ACTIONS(4599),
    [anon_sym_explicit] = ACTIONS(4599),
    [anon_sym_scoped] = ACTIONS(4599),
    [anon_sym_var] = ACTIONS(4599),
    [sym_predefined_type] = ACTIONS(4599),
    [anon_sym_yield] = ACTIONS(4599),
    [anon_sym_when] = ACTIONS(4599),
    [anon_sym_from] = ACTIONS(4599),
    [anon_sym_into] = ACTIONS(4599),
    [anon_sym_join] = ACTIONS(4599),
    [anon_sym_on] = ACTIONS(4599),
    [anon_sym_equals] = ACTIONS(4599),
    [anon_sym_let] = ACTIONS(4599),
    [anon_sym_orderby] = ACTIONS(4599),
    [anon_sym_ascending] = ACTIONS(4599),
    [anon_sym_descending] = ACTIONS(4599),
    [anon_sym_group] = ACTIONS(4599),
    [anon_sym_by] = ACTIONS(4599),
    [anon_sym_select] = ACTIONS(4599),
    [aux_sym_preproc_if_token1] = ACTIONS(4601),
    [aux_sym_preproc_if_token3] = ACTIONS(4601),
    [aux_sym_preproc_else_token1] = ACTIONS(4601),
    [aux_sym_preproc_elif_token1] = ACTIONS(4601),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2802] = {
    [sym__variable_designation] = STATE(4179),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2802),
    [sym_preproc_endregion] = STATE(2802),
    [sym_preproc_line] = STATE(2802),
    [sym_preproc_pragma] = STATE(2802),
    [sym_preproc_nullable] = STATE(2802),
    [sym_preproc_error] = STATE(2802),
    [sym_preproc_warning] = STATE(2802),
    [sym_preproc_define] = STATE(2802),
    [sym_preproc_undef] = STATE(2802),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_SLASH] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_CARET] = ACTIONS(3985),
    [anon_sym_PIPE] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3987),
    [anon_sym_LT_LT] = ACTIONS(3985),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_GT_GT_GT] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_DOT] = ACTIONS(3987),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3987),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3985),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3985),
    [anon_sym_QMARK_QMARK] = ACTIONS(3985),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [anon_sym_with] = ACTIONS(3987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2803] = {
    [sym_preproc_region] = STATE(2803),
    [sym_preproc_endregion] = STATE(2803),
    [sym_preproc_line] = STATE(2803),
    [sym_preproc_pragma] = STATE(2803),
    [sym_preproc_nullable] = STATE(2803),
    [sym_preproc_error] = STATE(2803),
    [sym_preproc_warning] = STATE(2803),
    [sym_preproc_define] = STATE(2803),
    [sym_preproc_undef] = STATE(2803),
    [sym__identifier_token] = ACTIONS(4603),
    [anon_sym_extern] = ACTIONS(4603),
    [anon_sym_alias] = ACTIONS(4603),
    [anon_sym_global] = ACTIONS(4603),
    [anon_sym_using] = ACTIONS(4603),
    [anon_sym_unsafe] = ACTIONS(4603),
    [anon_sym_static] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(4605),
    [anon_sym_event] = ACTIONS(4603),
    [anon_sym_namespace] = ACTIONS(4603),
    [anon_sym_class] = ACTIONS(4603),
    [anon_sym_ref] = ACTIONS(4603),
    [anon_sym_struct] = ACTIONS(4603),
    [anon_sym_enum] = ACTIONS(4603),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_interface] = ACTIONS(4603),
    [anon_sym_delegate] = ACTIONS(4603),
    [anon_sym_record] = ACTIONS(4603),
    [anon_sym_abstract] = ACTIONS(4603),
    [anon_sym_async] = ACTIONS(4603),
    [anon_sym_const] = ACTIONS(4603),
    [anon_sym_file] = ACTIONS(4603),
    [anon_sym_fixed] = ACTIONS(4603),
    [anon_sym_internal] = ACTIONS(4603),
    [anon_sym_new] = ACTIONS(4603),
    [anon_sym_override] = ACTIONS(4603),
    [anon_sym_partial] = ACTIONS(4603),
    [anon_sym_private] = ACTIONS(4603),
    [anon_sym_protected] = ACTIONS(4603),
    [anon_sym_public] = ACTIONS(4603),
    [anon_sym_readonly] = ACTIONS(4603),
    [anon_sym_required] = ACTIONS(4603),
    [anon_sym_sealed] = ACTIONS(4603),
    [anon_sym_virtual] = ACTIONS(4603),
    [anon_sym_volatile] = ACTIONS(4603),
    [anon_sym_where] = ACTIONS(4603),
    [anon_sym_notnull] = ACTIONS(4603),
    [anon_sym_unmanaged] = ACTIONS(4603),
    [anon_sym_TILDE] = ACTIONS(4605),
    [anon_sym_implicit] = ACTIONS(4603),
    [anon_sym_explicit] = ACTIONS(4603),
    [anon_sym_scoped] = ACTIONS(4603),
    [anon_sym_var] = ACTIONS(4603),
    [sym_predefined_type] = ACTIONS(4603),
    [anon_sym_yield] = ACTIONS(4603),
    [anon_sym_when] = ACTIONS(4603),
    [anon_sym_from] = ACTIONS(4603),
    [anon_sym_into] = ACTIONS(4603),
    [anon_sym_join] = ACTIONS(4603),
    [anon_sym_on] = ACTIONS(4603),
    [anon_sym_equals] = ACTIONS(4603),
    [anon_sym_let] = ACTIONS(4603),
    [anon_sym_orderby] = ACTIONS(4603),
    [anon_sym_ascending] = ACTIONS(4603),
    [anon_sym_descending] = ACTIONS(4603),
    [anon_sym_group] = ACTIONS(4603),
    [anon_sym_by] = ACTIONS(4603),
    [anon_sym_select] = ACTIONS(4603),
    [aux_sym_preproc_if_token1] = ACTIONS(4605),
    [aux_sym_preproc_if_token3] = ACTIONS(4605),
    [aux_sym_preproc_else_token1] = ACTIONS(4605),
    [aux_sym_preproc_elif_token1] = ACTIONS(4605),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2804] = {
    [sym_preproc_region] = STATE(2804),
    [sym_preproc_endregion] = STATE(2804),
    [sym_preproc_line] = STATE(2804),
    [sym_preproc_pragma] = STATE(2804),
    [sym_preproc_nullable] = STATE(2804),
    [sym_preproc_error] = STATE(2804),
    [sym_preproc_warning] = STATE(2804),
    [sym_preproc_define] = STATE(2804),
    [sym_preproc_undef] = STATE(2804),
    [sym__identifier_token] = ACTIONS(4607),
    [anon_sym_extern] = ACTIONS(4607),
    [anon_sym_alias] = ACTIONS(4607),
    [anon_sym_global] = ACTIONS(4607),
    [anon_sym_using] = ACTIONS(4607),
    [anon_sym_unsafe] = ACTIONS(4607),
    [anon_sym_static] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(4609),
    [anon_sym_LPAREN] = ACTIONS(4609),
    [anon_sym_event] = ACTIONS(4607),
    [anon_sym_namespace] = ACTIONS(4607),
    [anon_sym_class] = ACTIONS(4607),
    [anon_sym_ref] = ACTIONS(4607),
    [anon_sym_struct] = ACTIONS(4607),
    [anon_sym_enum] = ACTIONS(4607),
    [anon_sym_RBRACE] = ACTIONS(4609),
    [anon_sym_interface] = ACTIONS(4607),
    [anon_sym_delegate] = ACTIONS(4607),
    [anon_sym_record] = ACTIONS(4607),
    [anon_sym_abstract] = ACTIONS(4607),
    [anon_sym_async] = ACTIONS(4607),
    [anon_sym_const] = ACTIONS(4607),
    [anon_sym_file] = ACTIONS(4607),
    [anon_sym_fixed] = ACTIONS(4607),
    [anon_sym_internal] = ACTIONS(4607),
    [anon_sym_new] = ACTIONS(4607),
    [anon_sym_override] = ACTIONS(4607),
    [anon_sym_partial] = ACTIONS(4607),
    [anon_sym_private] = ACTIONS(4607),
    [anon_sym_protected] = ACTIONS(4607),
    [anon_sym_public] = ACTIONS(4607),
    [anon_sym_readonly] = ACTIONS(4607),
    [anon_sym_required] = ACTIONS(4607),
    [anon_sym_sealed] = ACTIONS(4607),
    [anon_sym_virtual] = ACTIONS(4607),
    [anon_sym_volatile] = ACTIONS(4607),
    [anon_sym_where] = ACTIONS(4607),
    [anon_sym_notnull] = ACTIONS(4607),
    [anon_sym_unmanaged] = ACTIONS(4607),
    [anon_sym_TILDE] = ACTIONS(4609),
    [anon_sym_implicit] = ACTIONS(4607),
    [anon_sym_explicit] = ACTIONS(4607),
    [anon_sym_scoped] = ACTIONS(4607),
    [anon_sym_var] = ACTIONS(4607),
    [sym_predefined_type] = ACTIONS(4607),
    [anon_sym_yield] = ACTIONS(4607),
    [anon_sym_when] = ACTIONS(4607),
    [anon_sym_from] = ACTIONS(4607),
    [anon_sym_into] = ACTIONS(4607),
    [anon_sym_join] = ACTIONS(4607),
    [anon_sym_on] = ACTIONS(4607),
    [anon_sym_equals] = ACTIONS(4607),
    [anon_sym_let] = ACTIONS(4607),
    [anon_sym_orderby] = ACTIONS(4607),
    [anon_sym_ascending] = ACTIONS(4607),
    [anon_sym_descending] = ACTIONS(4607),
    [anon_sym_group] = ACTIONS(4607),
    [anon_sym_by] = ACTIONS(4607),
    [anon_sym_select] = ACTIONS(4607),
    [aux_sym_preproc_if_token1] = ACTIONS(4609),
    [aux_sym_preproc_if_token3] = ACTIONS(4609),
    [aux_sym_preproc_else_token1] = ACTIONS(4609),
    [aux_sym_preproc_elif_token1] = ACTIONS(4609),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2805] = {
    [sym_preproc_region] = STATE(2805),
    [sym_preproc_endregion] = STATE(2805),
    [sym_preproc_line] = STATE(2805),
    [sym_preproc_pragma] = STATE(2805),
    [sym_preproc_nullable] = STATE(2805),
    [sym_preproc_error] = STATE(2805),
    [sym_preproc_warning] = STATE(2805),
    [sym_preproc_define] = STATE(2805),
    [sym_preproc_undef] = STATE(2805),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(3709),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_EQ_GT] = ACTIONS(3709),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_when] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3709),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_on] = ACTIONS(3709),
    [anon_sym_equals] = ACTIONS(3709),
    [anon_sym_by] = ACTIONS(3709),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_is] = ACTIONS(3709),
    [anon_sym_DASH_GT] = ACTIONS(3709),
    [anon_sym_with] = ACTIONS(3709),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2806] = {
    [sym__variable_designation] = STATE(4215),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2806),
    [sym_preproc_endregion] = STATE(2806),
    [sym_preproc_line] = STATE(2806),
    [sym_preproc_pragma] = STATE(2806),
    [sym_preproc_nullable] = STATE(2806),
    [sym_preproc_error] = STATE(2806),
    [sym_preproc_warning] = STATE(2806),
    [sym_preproc_define] = STATE(2806),
    [sym_preproc_undef] = STATE(2806),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_PIPE] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3989),
    [anon_sym_BANG_EQ] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3989),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3989),
    [anon_sym_QMARK_QMARK] = ACTIONS(3989),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3989),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2807] = {
    [sym_preproc_region] = STATE(2807),
    [sym_preproc_endregion] = STATE(2807),
    [sym_preproc_line] = STATE(2807),
    [sym_preproc_pragma] = STATE(2807),
    [sym_preproc_nullable] = STATE(2807),
    [sym_preproc_error] = STATE(2807),
    [sym_preproc_warning] = STATE(2807),
    [sym_preproc_define] = STATE(2807),
    [sym_preproc_undef] = STATE(2807),
    [sym__identifier_token] = ACTIONS(4611),
    [anon_sym_extern] = ACTIONS(4611),
    [anon_sym_alias] = ACTIONS(4611),
    [anon_sym_global] = ACTIONS(4611),
    [anon_sym_using] = ACTIONS(4611),
    [anon_sym_unsafe] = ACTIONS(4611),
    [anon_sym_static] = ACTIONS(4611),
    [anon_sym_LBRACK] = ACTIONS(4613),
    [anon_sym_LPAREN] = ACTIONS(4613),
    [anon_sym_event] = ACTIONS(4611),
    [anon_sym_namespace] = ACTIONS(4611),
    [anon_sym_class] = ACTIONS(4611),
    [anon_sym_ref] = ACTIONS(4611),
    [anon_sym_struct] = ACTIONS(4611),
    [anon_sym_enum] = ACTIONS(4611),
    [anon_sym_RBRACE] = ACTIONS(4613),
    [anon_sym_interface] = ACTIONS(4611),
    [anon_sym_delegate] = ACTIONS(4611),
    [anon_sym_record] = ACTIONS(4611),
    [anon_sym_abstract] = ACTIONS(4611),
    [anon_sym_async] = ACTIONS(4611),
    [anon_sym_const] = ACTIONS(4611),
    [anon_sym_file] = ACTIONS(4611),
    [anon_sym_fixed] = ACTIONS(4611),
    [anon_sym_internal] = ACTIONS(4611),
    [anon_sym_new] = ACTIONS(4611),
    [anon_sym_override] = ACTIONS(4611),
    [anon_sym_partial] = ACTIONS(4611),
    [anon_sym_private] = ACTIONS(4611),
    [anon_sym_protected] = ACTIONS(4611),
    [anon_sym_public] = ACTIONS(4611),
    [anon_sym_readonly] = ACTIONS(4611),
    [anon_sym_required] = ACTIONS(4611),
    [anon_sym_sealed] = ACTIONS(4611),
    [anon_sym_virtual] = ACTIONS(4611),
    [anon_sym_volatile] = ACTIONS(4611),
    [anon_sym_where] = ACTIONS(4611),
    [anon_sym_notnull] = ACTIONS(4611),
    [anon_sym_unmanaged] = ACTIONS(4611),
    [anon_sym_TILDE] = ACTIONS(4613),
    [anon_sym_implicit] = ACTIONS(4611),
    [anon_sym_explicit] = ACTIONS(4611),
    [anon_sym_scoped] = ACTIONS(4611),
    [anon_sym_var] = ACTIONS(4611),
    [sym_predefined_type] = ACTIONS(4611),
    [anon_sym_yield] = ACTIONS(4611),
    [anon_sym_when] = ACTIONS(4611),
    [anon_sym_from] = ACTIONS(4611),
    [anon_sym_into] = ACTIONS(4611),
    [anon_sym_join] = ACTIONS(4611),
    [anon_sym_on] = ACTIONS(4611),
    [anon_sym_equals] = ACTIONS(4611),
    [anon_sym_let] = ACTIONS(4611),
    [anon_sym_orderby] = ACTIONS(4611),
    [anon_sym_ascending] = ACTIONS(4611),
    [anon_sym_descending] = ACTIONS(4611),
    [anon_sym_group] = ACTIONS(4611),
    [anon_sym_by] = ACTIONS(4611),
    [anon_sym_select] = ACTIONS(4611),
    [aux_sym_preproc_if_token1] = ACTIONS(4613),
    [aux_sym_preproc_if_token3] = ACTIONS(4613),
    [aux_sym_preproc_else_token1] = ACTIONS(4613),
    [aux_sym_preproc_elif_token1] = ACTIONS(4613),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2808] = {
    [sym_preproc_region] = STATE(2808),
    [sym_preproc_endregion] = STATE(2808),
    [sym_preproc_line] = STATE(2808),
    [sym_preproc_pragma] = STATE(2808),
    [sym_preproc_nullable] = STATE(2808),
    [sym_preproc_error] = STATE(2808),
    [sym_preproc_warning] = STATE(2808),
    [sym_preproc_define] = STATE(2808),
    [sym_preproc_undef] = STATE(2808),
    [sym__identifier_token] = ACTIONS(4615),
    [anon_sym_extern] = ACTIONS(4615),
    [anon_sym_alias] = ACTIONS(4615),
    [anon_sym_global] = ACTIONS(4615),
    [anon_sym_using] = ACTIONS(4615),
    [anon_sym_unsafe] = ACTIONS(4615),
    [anon_sym_static] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4617),
    [anon_sym_LPAREN] = ACTIONS(4617),
    [anon_sym_event] = ACTIONS(4615),
    [anon_sym_namespace] = ACTIONS(4615),
    [anon_sym_class] = ACTIONS(4615),
    [anon_sym_ref] = ACTIONS(4615),
    [anon_sym_struct] = ACTIONS(4615),
    [anon_sym_enum] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4617),
    [anon_sym_interface] = ACTIONS(4615),
    [anon_sym_delegate] = ACTIONS(4615),
    [anon_sym_record] = ACTIONS(4615),
    [anon_sym_abstract] = ACTIONS(4615),
    [anon_sym_async] = ACTIONS(4615),
    [anon_sym_const] = ACTIONS(4615),
    [anon_sym_file] = ACTIONS(4615),
    [anon_sym_fixed] = ACTIONS(4615),
    [anon_sym_internal] = ACTIONS(4615),
    [anon_sym_new] = ACTIONS(4615),
    [anon_sym_override] = ACTIONS(4615),
    [anon_sym_partial] = ACTIONS(4615),
    [anon_sym_private] = ACTIONS(4615),
    [anon_sym_protected] = ACTIONS(4615),
    [anon_sym_public] = ACTIONS(4615),
    [anon_sym_readonly] = ACTIONS(4615),
    [anon_sym_required] = ACTIONS(4615),
    [anon_sym_sealed] = ACTIONS(4615),
    [anon_sym_virtual] = ACTIONS(4615),
    [anon_sym_volatile] = ACTIONS(4615),
    [anon_sym_where] = ACTIONS(4615),
    [anon_sym_notnull] = ACTIONS(4615),
    [anon_sym_unmanaged] = ACTIONS(4615),
    [anon_sym_TILDE] = ACTIONS(4617),
    [anon_sym_implicit] = ACTIONS(4615),
    [anon_sym_explicit] = ACTIONS(4615),
    [anon_sym_scoped] = ACTIONS(4615),
    [anon_sym_var] = ACTIONS(4615),
    [sym_predefined_type] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(4615),
    [anon_sym_when] = ACTIONS(4615),
    [anon_sym_from] = ACTIONS(4615),
    [anon_sym_into] = ACTIONS(4615),
    [anon_sym_join] = ACTIONS(4615),
    [anon_sym_on] = ACTIONS(4615),
    [anon_sym_equals] = ACTIONS(4615),
    [anon_sym_let] = ACTIONS(4615),
    [anon_sym_orderby] = ACTIONS(4615),
    [anon_sym_ascending] = ACTIONS(4615),
    [anon_sym_descending] = ACTIONS(4615),
    [anon_sym_group] = ACTIONS(4615),
    [anon_sym_by] = ACTIONS(4615),
    [anon_sym_select] = ACTIONS(4615),
    [aux_sym_preproc_if_token1] = ACTIONS(4617),
    [aux_sym_preproc_if_token3] = ACTIONS(4617),
    [aux_sym_preproc_else_token1] = ACTIONS(4617),
    [aux_sym_preproc_elif_token1] = ACTIONS(4617),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2809] = {
    [sym_preproc_region] = STATE(2809),
    [sym_preproc_endregion] = STATE(2809),
    [sym_preproc_line] = STATE(2809),
    [sym_preproc_pragma] = STATE(2809),
    [sym_preproc_nullable] = STATE(2809),
    [sym_preproc_error] = STATE(2809),
    [sym_preproc_warning] = STATE(2809),
    [sym_preproc_define] = STATE(2809),
    [sym_preproc_undef] = STATE(2809),
    [sym__identifier_token] = ACTIONS(3678),
    [anon_sym_alias] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_file] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_notnull] = ACTIONS(3678),
    [anon_sym_unmanaged] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_scoped] = ACTIONS(3678),
    [anon_sym_var] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3678),
    [anon_sym_when] = ACTIONS(3678),
    [sym_discard] = ACTIONS(3678),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3678),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3678),
    [anon_sym_join] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_equals] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_orderby] = ACTIONS(3678),
    [anon_sym_ascending] = ACTIONS(3678),
    [anon_sym_descending] = ACTIONS(3678),
    [anon_sym_group] = ACTIONS(3678),
    [anon_sym_by] = ACTIONS(3678),
    [anon_sym_select] = ACTIONS(3678),
    [anon_sym_as] = ACTIONS(3678),
    [anon_sym_is] = ACTIONS(3678),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3678),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [2810] = {
    [sym_preproc_region] = STATE(2810),
    [sym_preproc_endregion] = STATE(2810),
    [sym_preproc_line] = STATE(2810),
    [sym_preproc_pragma] = STATE(2810),
    [sym_preproc_nullable] = STATE(2810),
    [sym_preproc_error] = STATE(2810),
    [sym_preproc_warning] = STATE(2810),
    [sym_preproc_define] = STATE(2810),
    [sym_preproc_undef] = STATE(2810),
    [sym__identifier_token] = ACTIONS(3666),
    [anon_sym_alias] = ACTIONS(3666),
    [anon_sym_global] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_file] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_where] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_notnull] = ACTIONS(3666),
    [anon_sym_unmanaged] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3668),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3668),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_scoped] = ACTIONS(3666),
    [anon_sym_var] = ACTIONS(3666),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_switch] = ACTIONS(3666),
    [anon_sym_when] = ACTIONS(3666),
    [sym_discard] = ACTIONS(3666),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3666),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3668),
    [anon_sym_from] = ACTIONS(3666),
    [anon_sym_into] = ACTIONS(3666),
    [anon_sym_join] = ACTIONS(3666),
    [anon_sym_on] = ACTIONS(3666),
    [anon_sym_equals] = ACTIONS(3666),
    [anon_sym_let] = ACTIONS(3666),
    [anon_sym_orderby] = ACTIONS(3666),
    [anon_sym_ascending] = ACTIONS(3666),
    [anon_sym_descending] = ACTIONS(3666),
    [anon_sym_group] = ACTIONS(3666),
    [anon_sym_by] = ACTIONS(3666),
    [anon_sym_select] = ACTIONS(3666),
    [anon_sym_as] = ACTIONS(3666),
    [anon_sym_is] = ACTIONS(3666),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3666),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3668),
  },
  [2811] = {
    [sym_preproc_region] = STATE(2811),
    [sym_preproc_endregion] = STATE(2811),
    [sym_preproc_line] = STATE(2811),
    [sym_preproc_pragma] = STATE(2811),
    [sym_preproc_nullable] = STATE(2811),
    [sym_preproc_error] = STATE(2811),
    [sym_preproc_warning] = STATE(2811),
    [sym_preproc_define] = STATE(2811),
    [sym_preproc_undef] = STATE(2811),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2812] = {
    [sym_preproc_region] = STATE(2812),
    [sym_preproc_endregion] = STATE(2812),
    [sym_preproc_line] = STATE(2812),
    [sym_preproc_pragma] = STATE(2812),
    [sym_preproc_nullable] = STATE(2812),
    [sym_preproc_error] = STATE(2812),
    [sym_preproc_warning] = STATE(2812),
    [sym_preproc_define] = STATE(2812),
    [sym_preproc_undef] = STATE(2812),
    [sym__identifier_token] = ACTIONS(4619),
    [anon_sym_extern] = ACTIONS(4619),
    [anon_sym_alias] = ACTIONS(4619),
    [anon_sym_global] = ACTIONS(4619),
    [anon_sym_using] = ACTIONS(4619),
    [anon_sym_unsafe] = ACTIONS(4619),
    [anon_sym_static] = ACTIONS(4619),
    [anon_sym_LBRACK] = ACTIONS(4621),
    [anon_sym_LPAREN] = ACTIONS(4621),
    [anon_sym_event] = ACTIONS(4619),
    [anon_sym_namespace] = ACTIONS(4619),
    [anon_sym_class] = ACTIONS(4619),
    [anon_sym_ref] = ACTIONS(4619),
    [anon_sym_struct] = ACTIONS(4619),
    [anon_sym_enum] = ACTIONS(4619),
    [anon_sym_RBRACE] = ACTIONS(4621),
    [anon_sym_interface] = ACTIONS(4619),
    [anon_sym_delegate] = ACTIONS(4619),
    [anon_sym_record] = ACTIONS(4619),
    [anon_sym_abstract] = ACTIONS(4619),
    [anon_sym_async] = ACTIONS(4619),
    [anon_sym_const] = ACTIONS(4619),
    [anon_sym_file] = ACTIONS(4619),
    [anon_sym_fixed] = ACTIONS(4619),
    [anon_sym_internal] = ACTIONS(4619),
    [anon_sym_new] = ACTIONS(4619),
    [anon_sym_override] = ACTIONS(4619),
    [anon_sym_partial] = ACTIONS(4619),
    [anon_sym_private] = ACTIONS(4619),
    [anon_sym_protected] = ACTIONS(4619),
    [anon_sym_public] = ACTIONS(4619),
    [anon_sym_readonly] = ACTIONS(4619),
    [anon_sym_required] = ACTIONS(4619),
    [anon_sym_sealed] = ACTIONS(4619),
    [anon_sym_virtual] = ACTIONS(4619),
    [anon_sym_volatile] = ACTIONS(4619),
    [anon_sym_where] = ACTIONS(4619),
    [anon_sym_notnull] = ACTIONS(4619),
    [anon_sym_unmanaged] = ACTIONS(4619),
    [anon_sym_TILDE] = ACTIONS(4621),
    [anon_sym_implicit] = ACTIONS(4619),
    [anon_sym_explicit] = ACTIONS(4619),
    [anon_sym_scoped] = ACTIONS(4619),
    [anon_sym_var] = ACTIONS(4619),
    [sym_predefined_type] = ACTIONS(4619),
    [anon_sym_yield] = ACTIONS(4619),
    [anon_sym_when] = ACTIONS(4619),
    [anon_sym_from] = ACTIONS(4619),
    [anon_sym_into] = ACTIONS(4619),
    [anon_sym_join] = ACTIONS(4619),
    [anon_sym_on] = ACTIONS(4619),
    [anon_sym_equals] = ACTIONS(4619),
    [anon_sym_let] = ACTIONS(4619),
    [anon_sym_orderby] = ACTIONS(4619),
    [anon_sym_ascending] = ACTIONS(4619),
    [anon_sym_descending] = ACTIONS(4619),
    [anon_sym_group] = ACTIONS(4619),
    [anon_sym_by] = ACTIONS(4619),
    [anon_sym_select] = ACTIONS(4619),
    [aux_sym_preproc_if_token1] = ACTIONS(4621),
    [aux_sym_preproc_if_token3] = ACTIONS(4621),
    [aux_sym_preproc_else_token1] = ACTIONS(4621),
    [aux_sym_preproc_elif_token1] = ACTIONS(4621),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2813] = {
    [sym_preproc_region] = STATE(2813),
    [sym_preproc_endregion] = STATE(2813),
    [sym_preproc_line] = STATE(2813),
    [sym_preproc_pragma] = STATE(2813),
    [sym_preproc_nullable] = STATE(2813),
    [sym_preproc_error] = STATE(2813),
    [sym_preproc_warning] = STATE(2813),
    [sym_preproc_define] = STATE(2813),
    [sym_preproc_undef] = STATE(2813),
    [sym__identifier_token] = ACTIONS(3684),
    [anon_sym_alias] = ACTIONS(3684),
    [anon_sym_global] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_file] = ACTIONS(3684),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_where] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_notnull] = ACTIONS(3684),
    [anon_sym_unmanaged] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3686),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3686),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_scoped] = ACTIONS(3684),
    [anon_sym_var] = ACTIONS(3684),
    [anon_sym_yield] = ACTIONS(3684),
    [anon_sym_switch] = ACTIONS(3684),
    [anon_sym_when] = ACTIONS(3684),
    [sym_discard] = ACTIONS(3684),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3684),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3686),
    [anon_sym_from] = ACTIONS(3684),
    [anon_sym_into] = ACTIONS(3684),
    [anon_sym_join] = ACTIONS(3684),
    [anon_sym_on] = ACTIONS(3684),
    [anon_sym_equals] = ACTIONS(3684),
    [anon_sym_let] = ACTIONS(3684),
    [anon_sym_orderby] = ACTIONS(3684),
    [anon_sym_ascending] = ACTIONS(3684),
    [anon_sym_descending] = ACTIONS(3684),
    [anon_sym_group] = ACTIONS(3684),
    [anon_sym_by] = ACTIONS(3684),
    [anon_sym_select] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3684),
    [anon_sym_is] = ACTIONS(3684),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3684),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3686),
  },
  [2814] = {
    [sym_preproc_region] = STATE(2814),
    [sym_preproc_endregion] = STATE(2814),
    [sym_preproc_line] = STATE(2814),
    [sym_preproc_pragma] = STATE(2814),
    [sym_preproc_nullable] = STATE(2814),
    [sym_preproc_error] = STATE(2814),
    [sym_preproc_warning] = STATE(2814),
    [sym_preproc_define] = STATE(2814),
    [sym_preproc_undef] = STATE(2814),
    [sym__identifier_token] = ACTIONS(4623),
    [anon_sym_extern] = ACTIONS(4623),
    [anon_sym_alias] = ACTIONS(4623),
    [anon_sym_global] = ACTIONS(4623),
    [anon_sym_using] = ACTIONS(4623),
    [anon_sym_unsafe] = ACTIONS(4623),
    [anon_sym_static] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(4625),
    [anon_sym_LPAREN] = ACTIONS(4625),
    [anon_sym_event] = ACTIONS(4623),
    [anon_sym_namespace] = ACTIONS(4623),
    [anon_sym_class] = ACTIONS(4623),
    [anon_sym_ref] = ACTIONS(4623),
    [anon_sym_struct] = ACTIONS(4623),
    [anon_sym_enum] = ACTIONS(4623),
    [anon_sym_RBRACE] = ACTIONS(4625),
    [anon_sym_interface] = ACTIONS(4623),
    [anon_sym_delegate] = ACTIONS(4623),
    [anon_sym_record] = ACTIONS(4623),
    [anon_sym_abstract] = ACTIONS(4623),
    [anon_sym_async] = ACTIONS(4623),
    [anon_sym_const] = ACTIONS(4623),
    [anon_sym_file] = ACTIONS(4623),
    [anon_sym_fixed] = ACTIONS(4623),
    [anon_sym_internal] = ACTIONS(4623),
    [anon_sym_new] = ACTIONS(4623),
    [anon_sym_override] = ACTIONS(4623),
    [anon_sym_partial] = ACTIONS(4623),
    [anon_sym_private] = ACTIONS(4623),
    [anon_sym_protected] = ACTIONS(4623),
    [anon_sym_public] = ACTIONS(4623),
    [anon_sym_readonly] = ACTIONS(4623),
    [anon_sym_required] = ACTIONS(4623),
    [anon_sym_sealed] = ACTIONS(4623),
    [anon_sym_virtual] = ACTIONS(4623),
    [anon_sym_volatile] = ACTIONS(4623),
    [anon_sym_where] = ACTIONS(4623),
    [anon_sym_notnull] = ACTIONS(4623),
    [anon_sym_unmanaged] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4625),
    [anon_sym_implicit] = ACTIONS(4623),
    [anon_sym_explicit] = ACTIONS(4623),
    [anon_sym_scoped] = ACTIONS(4623),
    [anon_sym_var] = ACTIONS(4623),
    [sym_predefined_type] = ACTIONS(4623),
    [anon_sym_yield] = ACTIONS(4623),
    [anon_sym_when] = ACTIONS(4623),
    [anon_sym_from] = ACTIONS(4623),
    [anon_sym_into] = ACTIONS(4623),
    [anon_sym_join] = ACTIONS(4623),
    [anon_sym_on] = ACTIONS(4623),
    [anon_sym_equals] = ACTIONS(4623),
    [anon_sym_let] = ACTIONS(4623),
    [anon_sym_orderby] = ACTIONS(4623),
    [anon_sym_ascending] = ACTIONS(4623),
    [anon_sym_descending] = ACTIONS(4623),
    [anon_sym_group] = ACTIONS(4623),
    [anon_sym_by] = ACTIONS(4623),
    [anon_sym_select] = ACTIONS(4623),
    [aux_sym_preproc_if_token1] = ACTIONS(4625),
    [aux_sym_preproc_if_token3] = ACTIONS(4625),
    [aux_sym_preproc_else_token1] = ACTIONS(4625),
    [aux_sym_preproc_elif_token1] = ACTIONS(4625),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2815] = {
    [sym_preproc_region] = STATE(2815),
    [sym_preproc_endregion] = STATE(2815),
    [sym_preproc_line] = STATE(2815),
    [sym_preproc_pragma] = STATE(2815),
    [sym_preproc_nullable] = STATE(2815),
    [sym_preproc_error] = STATE(2815),
    [sym_preproc_warning] = STATE(2815),
    [sym_preproc_define] = STATE(2815),
    [sym_preproc_undef] = STATE(2815),
    [sym__identifier_token] = ACTIONS(4627),
    [anon_sym_extern] = ACTIONS(4627),
    [anon_sym_alias] = ACTIONS(4627),
    [anon_sym_global] = ACTIONS(4627),
    [anon_sym_using] = ACTIONS(4627),
    [anon_sym_unsafe] = ACTIONS(4627),
    [anon_sym_static] = ACTIONS(4627),
    [anon_sym_LBRACK] = ACTIONS(4629),
    [anon_sym_LPAREN] = ACTIONS(4629),
    [anon_sym_event] = ACTIONS(4627),
    [anon_sym_namespace] = ACTIONS(4627),
    [anon_sym_class] = ACTIONS(4627),
    [anon_sym_ref] = ACTIONS(4627),
    [anon_sym_struct] = ACTIONS(4627),
    [anon_sym_enum] = ACTIONS(4627),
    [anon_sym_RBRACE] = ACTIONS(4629),
    [anon_sym_interface] = ACTIONS(4627),
    [anon_sym_delegate] = ACTIONS(4627),
    [anon_sym_record] = ACTIONS(4627),
    [anon_sym_abstract] = ACTIONS(4627),
    [anon_sym_async] = ACTIONS(4627),
    [anon_sym_const] = ACTIONS(4627),
    [anon_sym_file] = ACTIONS(4627),
    [anon_sym_fixed] = ACTIONS(4627),
    [anon_sym_internal] = ACTIONS(4627),
    [anon_sym_new] = ACTIONS(4627),
    [anon_sym_override] = ACTIONS(4627),
    [anon_sym_partial] = ACTIONS(4627),
    [anon_sym_private] = ACTIONS(4627),
    [anon_sym_protected] = ACTIONS(4627),
    [anon_sym_public] = ACTIONS(4627),
    [anon_sym_readonly] = ACTIONS(4627),
    [anon_sym_required] = ACTIONS(4627),
    [anon_sym_sealed] = ACTIONS(4627),
    [anon_sym_virtual] = ACTIONS(4627),
    [anon_sym_volatile] = ACTIONS(4627),
    [anon_sym_where] = ACTIONS(4627),
    [anon_sym_notnull] = ACTIONS(4627),
    [anon_sym_unmanaged] = ACTIONS(4627),
    [anon_sym_TILDE] = ACTIONS(4629),
    [anon_sym_implicit] = ACTIONS(4627),
    [anon_sym_explicit] = ACTIONS(4627),
    [anon_sym_scoped] = ACTIONS(4627),
    [anon_sym_var] = ACTIONS(4627),
    [sym_predefined_type] = ACTIONS(4627),
    [anon_sym_yield] = ACTIONS(4627),
    [anon_sym_when] = ACTIONS(4627),
    [anon_sym_from] = ACTIONS(4627),
    [anon_sym_into] = ACTIONS(4627),
    [anon_sym_join] = ACTIONS(4627),
    [anon_sym_on] = ACTIONS(4627),
    [anon_sym_equals] = ACTIONS(4627),
    [anon_sym_let] = ACTIONS(4627),
    [anon_sym_orderby] = ACTIONS(4627),
    [anon_sym_ascending] = ACTIONS(4627),
    [anon_sym_descending] = ACTIONS(4627),
    [anon_sym_group] = ACTIONS(4627),
    [anon_sym_by] = ACTIONS(4627),
    [anon_sym_select] = ACTIONS(4627),
    [aux_sym_preproc_if_token1] = ACTIONS(4629),
    [aux_sym_preproc_if_token3] = ACTIONS(4629),
    [aux_sym_preproc_else_token1] = ACTIONS(4629),
    [aux_sym_preproc_elif_token1] = ACTIONS(4629),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2816] = {
    [sym_preproc_region] = STATE(2816),
    [sym_preproc_endregion] = STATE(2816),
    [sym_preproc_line] = STATE(2816),
    [sym_preproc_pragma] = STATE(2816),
    [sym_preproc_nullable] = STATE(2816),
    [sym_preproc_error] = STATE(2816),
    [sym_preproc_warning] = STATE(2816),
    [sym_preproc_define] = STATE(2816),
    [sym_preproc_undef] = STATE(2816),
    [sym__identifier_token] = ACTIONS(3670),
    [anon_sym_alias] = ACTIONS(3670),
    [anon_sym_global] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_file] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_where] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_notnull] = ACTIONS(3670),
    [anon_sym_unmanaged] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_scoped] = ACTIONS(3670),
    [anon_sym_var] = ACTIONS(3670),
    [anon_sym_yield] = ACTIONS(3670),
    [anon_sym_switch] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [sym_discard] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3672),
    [anon_sym_from] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3670),
    [anon_sym_join] = ACTIONS(3670),
    [anon_sym_on] = ACTIONS(3670),
    [anon_sym_equals] = ACTIONS(3670),
    [anon_sym_let] = ACTIONS(3670),
    [anon_sym_orderby] = ACTIONS(3670),
    [anon_sym_ascending] = ACTIONS(3670),
    [anon_sym_descending] = ACTIONS(3670),
    [anon_sym_group] = ACTIONS(3670),
    [anon_sym_by] = ACTIONS(3670),
    [anon_sym_select] = ACTIONS(3670),
    [anon_sym_as] = ACTIONS(3670),
    [anon_sym_is] = ACTIONS(3670),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3670),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3672),
  },
  [2817] = {
    [sym_preproc_region] = STATE(2817),
    [sym_preproc_endregion] = STATE(2817),
    [sym_preproc_line] = STATE(2817),
    [sym_preproc_pragma] = STATE(2817),
    [sym_preproc_nullable] = STATE(2817),
    [sym_preproc_error] = STATE(2817),
    [sym_preproc_warning] = STATE(2817),
    [sym_preproc_define] = STATE(2817),
    [sym_preproc_undef] = STATE(2817),
    [sym__identifier_token] = ACTIONS(3674),
    [anon_sym_alias] = ACTIONS(3674),
    [anon_sym_global] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_file] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_notnull] = ACTIONS(3674),
    [anon_sym_unmanaged] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_CARET] = ACTIONS(3676),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3676),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_scoped] = ACTIONS(3674),
    [anon_sym_var] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3674),
    [anon_sym_switch] = ACTIONS(3674),
    [anon_sym_when] = ACTIONS(3674),
    [sym_discard] = ACTIONS(3674),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3676),
    [anon_sym_from] = ACTIONS(3674),
    [anon_sym_into] = ACTIONS(3674),
    [anon_sym_join] = ACTIONS(3674),
    [anon_sym_on] = ACTIONS(3674),
    [anon_sym_equals] = ACTIONS(3674),
    [anon_sym_let] = ACTIONS(3674),
    [anon_sym_orderby] = ACTIONS(3674),
    [anon_sym_ascending] = ACTIONS(3674),
    [anon_sym_descending] = ACTIONS(3674),
    [anon_sym_group] = ACTIONS(3674),
    [anon_sym_by] = ACTIONS(3674),
    [anon_sym_select] = ACTIONS(3674),
    [anon_sym_as] = ACTIONS(3674),
    [anon_sym_is] = ACTIONS(3674),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3674),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3676),
  },
  [2818] = {
    [sym_preproc_region] = STATE(2818),
    [sym_preproc_endregion] = STATE(2818),
    [sym_preproc_line] = STATE(2818),
    [sym_preproc_pragma] = STATE(2818),
    [sym_preproc_nullable] = STATE(2818),
    [sym_preproc_error] = STATE(2818),
    [sym_preproc_warning] = STATE(2818),
    [sym_preproc_define] = STATE(2818),
    [sym_preproc_undef] = STATE(2818),
    [sym__identifier_token] = ACTIONS(4631),
    [anon_sym_extern] = ACTIONS(4631),
    [anon_sym_alias] = ACTIONS(4631),
    [anon_sym_global] = ACTIONS(4631),
    [anon_sym_using] = ACTIONS(4631),
    [anon_sym_unsafe] = ACTIONS(4631),
    [anon_sym_static] = ACTIONS(4631),
    [anon_sym_LBRACK] = ACTIONS(4633),
    [anon_sym_LPAREN] = ACTIONS(4633),
    [anon_sym_event] = ACTIONS(4631),
    [anon_sym_namespace] = ACTIONS(4631),
    [anon_sym_class] = ACTIONS(4631),
    [anon_sym_ref] = ACTIONS(4631),
    [anon_sym_struct] = ACTIONS(4631),
    [anon_sym_enum] = ACTIONS(4631),
    [anon_sym_RBRACE] = ACTIONS(4633),
    [anon_sym_interface] = ACTIONS(4631),
    [anon_sym_delegate] = ACTIONS(4631),
    [anon_sym_record] = ACTIONS(4631),
    [anon_sym_abstract] = ACTIONS(4631),
    [anon_sym_async] = ACTIONS(4631),
    [anon_sym_const] = ACTIONS(4631),
    [anon_sym_file] = ACTIONS(4631),
    [anon_sym_fixed] = ACTIONS(4631),
    [anon_sym_internal] = ACTIONS(4631),
    [anon_sym_new] = ACTIONS(4631),
    [anon_sym_override] = ACTIONS(4631),
    [anon_sym_partial] = ACTIONS(4631),
    [anon_sym_private] = ACTIONS(4631),
    [anon_sym_protected] = ACTIONS(4631),
    [anon_sym_public] = ACTIONS(4631),
    [anon_sym_readonly] = ACTIONS(4631),
    [anon_sym_required] = ACTIONS(4631),
    [anon_sym_sealed] = ACTIONS(4631),
    [anon_sym_virtual] = ACTIONS(4631),
    [anon_sym_volatile] = ACTIONS(4631),
    [anon_sym_where] = ACTIONS(4631),
    [anon_sym_notnull] = ACTIONS(4631),
    [anon_sym_unmanaged] = ACTIONS(4631),
    [anon_sym_TILDE] = ACTIONS(4633),
    [anon_sym_implicit] = ACTIONS(4631),
    [anon_sym_explicit] = ACTIONS(4631),
    [anon_sym_scoped] = ACTIONS(4631),
    [anon_sym_var] = ACTIONS(4631),
    [sym_predefined_type] = ACTIONS(4631),
    [anon_sym_yield] = ACTIONS(4631),
    [anon_sym_when] = ACTIONS(4631),
    [anon_sym_from] = ACTIONS(4631),
    [anon_sym_into] = ACTIONS(4631),
    [anon_sym_join] = ACTIONS(4631),
    [anon_sym_on] = ACTIONS(4631),
    [anon_sym_equals] = ACTIONS(4631),
    [anon_sym_let] = ACTIONS(4631),
    [anon_sym_orderby] = ACTIONS(4631),
    [anon_sym_ascending] = ACTIONS(4631),
    [anon_sym_descending] = ACTIONS(4631),
    [anon_sym_group] = ACTIONS(4631),
    [anon_sym_by] = ACTIONS(4631),
    [anon_sym_select] = ACTIONS(4631),
    [aux_sym_preproc_if_token1] = ACTIONS(4633),
    [aux_sym_preproc_if_token3] = ACTIONS(4633),
    [aux_sym_preproc_else_token1] = ACTIONS(4633),
    [aux_sym_preproc_elif_token1] = ACTIONS(4633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2819] = {
    [sym_preproc_region] = STATE(2819),
    [sym_preproc_endregion] = STATE(2819),
    [sym_preproc_line] = STATE(2819),
    [sym_preproc_pragma] = STATE(2819),
    [sym_preproc_nullable] = STATE(2819),
    [sym_preproc_error] = STATE(2819),
    [sym_preproc_warning] = STATE(2819),
    [sym_preproc_define] = STATE(2819),
    [sym_preproc_undef] = STATE(2819),
    [sym__identifier_token] = ACTIONS(4635),
    [anon_sym_extern] = ACTIONS(4635),
    [anon_sym_alias] = ACTIONS(4635),
    [anon_sym_global] = ACTIONS(4635),
    [anon_sym_using] = ACTIONS(4635),
    [anon_sym_unsafe] = ACTIONS(4635),
    [anon_sym_static] = ACTIONS(4635),
    [anon_sym_LBRACK] = ACTIONS(4637),
    [anon_sym_LPAREN] = ACTIONS(4637),
    [anon_sym_event] = ACTIONS(4635),
    [anon_sym_namespace] = ACTIONS(4635),
    [anon_sym_class] = ACTIONS(4635),
    [anon_sym_ref] = ACTIONS(4635),
    [anon_sym_struct] = ACTIONS(4635),
    [anon_sym_enum] = ACTIONS(4635),
    [anon_sym_RBRACE] = ACTIONS(4637),
    [anon_sym_interface] = ACTIONS(4635),
    [anon_sym_delegate] = ACTIONS(4635),
    [anon_sym_record] = ACTIONS(4635),
    [anon_sym_abstract] = ACTIONS(4635),
    [anon_sym_async] = ACTIONS(4635),
    [anon_sym_const] = ACTIONS(4635),
    [anon_sym_file] = ACTIONS(4635),
    [anon_sym_fixed] = ACTIONS(4635),
    [anon_sym_internal] = ACTIONS(4635),
    [anon_sym_new] = ACTIONS(4635),
    [anon_sym_override] = ACTIONS(4635),
    [anon_sym_partial] = ACTIONS(4635),
    [anon_sym_private] = ACTIONS(4635),
    [anon_sym_protected] = ACTIONS(4635),
    [anon_sym_public] = ACTIONS(4635),
    [anon_sym_readonly] = ACTIONS(4635),
    [anon_sym_required] = ACTIONS(4635),
    [anon_sym_sealed] = ACTIONS(4635),
    [anon_sym_virtual] = ACTIONS(4635),
    [anon_sym_volatile] = ACTIONS(4635),
    [anon_sym_where] = ACTIONS(4635),
    [anon_sym_notnull] = ACTIONS(4635),
    [anon_sym_unmanaged] = ACTIONS(4635),
    [anon_sym_TILDE] = ACTIONS(4637),
    [anon_sym_implicit] = ACTIONS(4635),
    [anon_sym_explicit] = ACTIONS(4635),
    [anon_sym_scoped] = ACTIONS(4635),
    [anon_sym_var] = ACTIONS(4635),
    [sym_predefined_type] = ACTIONS(4635),
    [anon_sym_yield] = ACTIONS(4635),
    [anon_sym_when] = ACTIONS(4635),
    [anon_sym_from] = ACTIONS(4635),
    [anon_sym_into] = ACTIONS(4635),
    [anon_sym_join] = ACTIONS(4635),
    [anon_sym_on] = ACTIONS(4635),
    [anon_sym_equals] = ACTIONS(4635),
    [anon_sym_let] = ACTIONS(4635),
    [anon_sym_orderby] = ACTIONS(4635),
    [anon_sym_ascending] = ACTIONS(4635),
    [anon_sym_descending] = ACTIONS(4635),
    [anon_sym_group] = ACTIONS(4635),
    [anon_sym_by] = ACTIONS(4635),
    [anon_sym_select] = ACTIONS(4635),
    [aux_sym_preproc_if_token1] = ACTIONS(4637),
    [aux_sym_preproc_if_token3] = ACTIONS(4637),
    [aux_sym_preproc_else_token1] = ACTIONS(4637),
    [aux_sym_preproc_elif_token1] = ACTIONS(4637),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2820] = {
    [sym__variable_designation] = STATE(4210),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2820),
    [sym_preproc_endregion] = STATE(2820),
    [sym_preproc_line] = STATE(2820),
    [sym_preproc_pragma] = STATE(2820),
    [sym_preproc_nullable] = STATE(2820),
    [sym_preproc_error] = STATE(2820),
    [sym_preproc_warning] = STATE(2820),
    [sym_preproc_define] = STATE(2820),
    [sym_preproc_undef] = STATE(2820),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3929),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3929),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_orderby] = ACTIONS(3929),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3929),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2821] = {
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2821),
    [sym_preproc_endregion] = STATE(2821),
    [sym_preproc_line] = STATE(2821),
    [sym_preproc_pragma] = STATE(2821),
    [sym_preproc_nullable] = STATE(2821),
    [sym_preproc_error] = STATE(2821),
    [sym_preproc_warning] = STATE(2821),
    [sym_preproc_define] = STATE(2821),
    [sym_preproc_undef] = STATE(2821),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3933),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3933),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_orderby] = ACTIONS(3933),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3933),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2822] = {
    [sym_preproc_region] = STATE(2822),
    [sym_preproc_endregion] = STATE(2822),
    [sym_preproc_line] = STATE(2822),
    [sym_preproc_pragma] = STATE(2822),
    [sym_preproc_nullable] = STATE(2822),
    [sym_preproc_error] = STATE(2822),
    [sym_preproc_warning] = STATE(2822),
    [sym_preproc_define] = STATE(2822),
    [sym_preproc_undef] = STATE(2822),
    [sym__identifier_token] = ACTIONS(4639),
    [anon_sym_extern] = ACTIONS(4639),
    [anon_sym_alias] = ACTIONS(4639),
    [anon_sym_global] = ACTIONS(4639),
    [anon_sym_using] = ACTIONS(4639),
    [anon_sym_unsafe] = ACTIONS(4639),
    [anon_sym_static] = ACTIONS(4639),
    [anon_sym_LBRACK] = ACTIONS(4641),
    [anon_sym_LPAREN] = ACTIONS(4641),
    [anon_sym_event] = ACTIONS(4639),
    [anon_sym_namespace] = ACTIONS(4639),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_ref] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4639),
    [anon_sym_enum] = ACTIONS(4639),
    [anon_sym_RBRACE] = ACTIONS(4641),
    [anon_sym_interface] = ACTIONS(4639),
    [anon_sym_delegate] = ACTIONS(4639),
    [anon_sym_record] = ACTIONS(4639),
    [anon_sym_abstract] = ACTIONS(4639),
    [anon_sym_async] = ACTIONS(4639),
    [anon_sym_const] = ACTIONS(4639),
    [anon_sym_file] = ACTIONS(4639),
    [anon_sym_fixed] = ACTIONS(4639),
    [anon_sym_internal] = ACTIONS(4639),
    [anon_sym_new] = ACTIONS(4639),
    [anon_sym_override] = ACTIONS(4639),
    [anon_sym_partial] = ACTIONS(4639),
    [anon_sym_private] = ACTIONS(4639),
    [anon_sym_protected] = ACTIONS(4639),
    [anon_sym_public] = ACTIONS(4639),
    [anon_sym_readonly] = ACTIONS(4639),
    [anon_sym_required] = ACTIONS(4639),
    [anon_sym_sealed] = ACTIONS(4639),
    [anon_sym_virtual] = ACTIONS(4639),
    [anon_sym_volatile] = ACTIONS(4639),
    [anon_sym_where] = ACTIONS(4639),
    [anon_sym_notnull] = ACTIONS(4639),
    [anon_sym_unmanaged] = ACTIONS(4639),
    [anon_sym_TILDE] = ACTIONS(4641),
    [anon_sym_implicit] = ACTIONS(4639),
    [anon_sym_explicit] = ACTIONS(4639),
    [anon_sym_scoped] = ACTIONS(4639),
    [anon_sym_var] = ACTIONS(4639),
    [sym_predefined_type] = ACTIONS(4639),
    [anon_sym_yield] = ACTIONS(4639),
    [anon_sym_when] = ACTIONS(4639),
    [anon_sym_from] = ACTIONS(4639),
    [anon_sym_into] = ACTIONS(4639),
    [anon_sym_join] = ACTIONS(4639),
    [anon_sym_on] = ACTIONS(4639),
    [anon_sym_equals] = ACTIONS(4639),
    [anon_sym_let] = ACTIONS(4639),
    [anon_sym_orderby] = ACTIONS(4639),
    [anon_sym_ascending] = ACTIONS(4639),
    [anon_sym_descending] = ACTIONS(4639),
    [anon_sym_group] = ACTIONS(4639),
    [anon_sym_by] = ACTIONS(4639),
    [anon_sym_select] = ACTIONS(4639),
    [aux_sym_preproc_if_token1] = ACTIONS(4641),
    [aux_sym_preproc_if_token3] = ACTIONS(4641),
    [aux_sym_preproc_else_token1] = ACTIONS(4641),
    [aux_sym_preproc_elif_token1] = ACTIONS(4641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2823] = {
    [sym_preproc_region] = STATE(2823),
    [sym_preproc_endregion] = STATE(2823),
    [sym_preproc_line] = STATE(2823),
    [sym_preproc_pragma] = STATE(2823),
    [sym_preproc_nullable] = STATE(2823),
    [sym_preproc_error] = STATE(2823),
    [sym_preproc_warning] = STATE(2823),
    [sym_preproc_define] = STATE(2823),
    [sym_preproc_undef] = STATE(2823),
    [sym__identifier_token] = ACTIONS(4643),
    [anon_sym_extern] = ACTIONS(4643),
    [anon_sym_alias] = ACTIONS(4643),
    [anon_sym_global] = ACTIONS(4643),
    [anon_sym_using] = ACTIONS(4643),
    [anon_sym_unsafe] = ACTIONS(4643),
    [anon_sym_static] = ACTIONS(4643),
    [anon_sym_LBRACK] = ACTIONS(4645),
    [anon_sym_LPAREN] = ACTIONS(4645),
    [anon_sym_event] = ACTIONS(4643),
    [anon_sym_namespace] = ACTIONS(4643),
    [anon_sym_class] = ACTIONS(4643),
    [anon_sym_ref] = ACTIONS(4643),
    [anon_sym_struct] = ACTIONS(4643),
    [anon_sym_enum] = ACTIONS(4643),
    [anon_sym_RBRACE] = ACTIONS(4645),
    [anon_sym_interface] = ACTIONS(4643),
    [anon_sym_delegate] = ACTIONS(4643),
    [anon_sym_record] = ACTIONS(4643),
    [anon_sym_abstract] = ACTIONS(4643),
    [anon_sym_async] = ACTIONS(4643),
    [anon_sym_const] = ACTIONS(4643),
    [anon_sym_file] = ACTIONS(4643),
    [anon_sym_fixed] = ACTIONS(4643),
    [anon_sym_internal] = ACTIONS(4643),
    [anon_sym_new] = ACTIONS(4643),
    [anon_sym_override] = ACTIONS(4643),
    [anon_sym_partial] = ACTIONS(4643),
    [anon_sym_private] = ACTIONS(4643),
    [anon_sym_protected] = ACTIONS(4643),
    [anon_sym_public] = ACTIONS(4643),
    [anon_sym_readonly] = ACTIONS(4643),
    [anon_sym_required] = ACTIONS(4643),
    [anon_sym_sealed] = ACTIONS(4643),
    [anon_sym_virtual] = ACTIONS(4643),
    [anon_sym_volatile] = ACTIONS(4643),
    [anon_sym_where] = ACTIONS(4643),
    [anon_sym_notnull] = ACTIONS(4643),
    [anon_sym_unmanaged] = ACTIONS(4643),
    [anon_sym_TILDE] = ACTIONS(4645),
    [anon_sym_implicit] = ACTIONS(4643),
    [anon_sym_explicit] = ACTIONS(4643),
    [anon_sym_scoped] = ACTIONS(4643),
    [anon_sym_var] = ACTIONS(4643),
    [sym_predefined_type] = ACTIONS(4643),
    [anon_sym_yield] = ACTIONS(4643),
    [anon_sym_when] = ACTIONS(4643),
    [anon_sym_from] = ACTIONS(4643),
    [anon_sym_into] = ACTIONS(4643),
    [anon_sym_join] = ACTIONS(4643),
    [anon_sym_on] = ACTIONS(4643),
    [anon_sym_equals] = ACTIONS(4643),
    [anon_sym_let] = ACTIONS(4643),
    [anon_sym_orderby] = ACTIONS(4643),
    [anon_sym_ascending] = ACTIONS(4643),
    [anon_sym_descending] = ACTIONS(4643),
    [anon_sym_group] = ACTIONS(4643),
    [anon_sym_by] = ACTIONS(4643),
    [anon_sym_select] = ACTIONS(4643),
    [aux_sym_preproc_if_token1] = ACTIONS(4645),
    [aux_sym_preproc_if_token3] = ACTIONS(4645),
    [aux_sym_preproc_else_token1] = ACTIONS(4645),
    [aux_sym_preproc_elif_token1] = ACTIONS(4645),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2824] = {
    [sym__variable_designation] = STATE(4170),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2824),
    [sym_preproc_endregion] = STATE(2824),
    [sym_preproc_line] = STATE(2824),
    [sym_preproc_pragma] = STATE(2824),
    [sym_preproc_nullable] = STATE(2824),
    [sym_preproc_error] = STATE(2824),
    [sym_preproc_warning] = STATE(2824),
    [sym_preproc_define] = STATE(2824),
    [sym_preproc_undef] = STATE(2824),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3999),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3999),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3999),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3999),
    [anon_sym_orderby] = ACTIONS(3999),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3999),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3999),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2825] = {
    [sym__variable_designation] = STATE(4189),
    [sym_parenthesized_variable_designation] = STATE(4201),
    [sym_identifier] = STATE(4205),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(2825),
    [sym_preproc_endregion] = STATE(2825),
    [sym_preproc_line] = STATE(2825),
    [sym_preproc_pragma] = STATE(2825),
    [sym_preproc_nullable] = STATE(2825),
    [sym_preproc_error] = STATE(2825),
    [sym_preproc_warning] = STATE(2825),
    [sym_preproc_define] = STATE(2825),
    [sym_preproc_undef] = STATE(2825),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3871),
    [anon_sym_var] = ACTIONS(3871),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3871),
    [sym_discard] = ACTIONS(4245),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(4003),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_orderby] = ACTIONS(4003),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(4003),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(4003),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2826] = {
    [sym_preproc_region] = STATE(2826),
    [sym_preproc_endregion] = STATE(2826),
    [sym_preproc_line] = STATE(2826),
    [sym_preproc_pragma] = STATE(2826),
    [sym_preproc_nullable] = STATE(2826),
    [sym_preproc_error] = STATE(2826),
    [sym_preproc_warning] = STATE(2826),
    [sym_preproc_define] = STATE(2826),
    [sym_preproc_undef] = STATE(2826),
    [sym__identifier_token] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3371),
    [anon_sym_alias] = ACTIONS(3371),
    [anon_sym_global] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_unsafe] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_event] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_ref] = ACTIONS(3371),
    [anon_sym_struct] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_delegate] = ACTIONS(3371),
    [anon_sym_record] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_file] = ACTIONS(3371),
    [anon_sym_fixed] = ACTIONS(3371),
    [anon_sym_internal] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_partial] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_required] = ACTIONS(3371),
    [anon_sym_sealed] = ACTIONS(3371),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_volatile] = ACTIONS(3371),
    [anon_sym_where] = ACTIONS(3371),
    [anon_sym_notnull] = ACTIONS(3371),
    [anon_sym_unmanaged] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_implicit] = ACTIONS(3371),
    [anon_sym_explicit] = ACTIONS(3371),
    [anon_sym_scoped] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [sym_predefined_type] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_when] = ACTIONS(3371),
    [anon_sym_from] = ACTIONS(3371),
    [anon_sym_into] = ACTIONS(3371),
    [anon_sym_join] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [anon_sym_equals] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_orderby] = ACTIONS(3371),
    [anon_sym_ascending] = ACTIONS(3371),
    [anon_sym_descending] = ACTIONS(3371),
    [anon_sym_group] = ACTIONS(3371),
    [anon_sym_by] = ACTIONS(3371),
    [anon_sym_select] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_if_token3] = ACTIONS(3373),
    [aux_sym_preproc_else_token1] = ACTIONS(3373),
    [aux_sym_preproc_elif_token1] = ACTIONS(3373),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2827] = {
    [sym_preproc_region] = STATE(2827),
    [sym_preproc_endregion] = STATE(2827),
    [sym_preproc_line] = STATE(2827),
    [sym_preproc_pragma] = STATE(2827),
    [sym_preproc_nullable] = STATE(2827),
    [sym_preproc_error] = STATE(2827),
    [sym_preproc_warning] = STATE(2827),
    [sym_preproc_define] = STATE(2827),
    [sym_preproc_undef] = STATE(2827),
    [sym__identifier_token] = ACTIONS(4647),
    [anon_sym_extern] = ACTIONS(4647),
    [anon_sym_alias] = ACTIONS(4647),
    [anon_sym_global] = ACTIONS(4647),
    [anon_sym_using] = ACTIONS(4647),
    [anon_sym_unsafe] = ACTIONS(4647),
    [anon_sym_static] = ACTIONS(4647),
    [anon_sym_LBRACK] = ACTIONS(4649),
    [anon_sym_LPAREN] = ACTIONS(4649),
    [anon_sym_event] = ACTIONS(4647),
    [anon_sym_namespace] = ACTIONS(4647),
    [anon_sym_class] = ACTIONS(4647),
    [anon_sym_ref] = ACTIONS(4647),
    [anon_sym_struct] = ACTIONS(4647),
    [anon_sym_enum] = ACTIONS(4647),
    [anon_sym_RBRACE] = ACTIONS(4649),
    [anon_sym_interface] = ACTIONS(4647),
    [anon_sym_delegate] = ACTIONS(4647),
    [anon_sym_record] = ACTIONS(4647),
    [anon_sym_abstract] = ACTIONS(4647),
    [anon_sym_async] = ACTIONS(4647),
    [anon_sym_const] = ACTIONS(4647),
    [anon_sym_file] = ACTIONS(4647),
    [anon_sym_fixed] = ACTIONS(4647),
    [anon_sym_internal] = ACTIONS(4647),
    [anon_sym_new] = ACTIONS(4647),
    [anon_sym_override] = ACTIONS(4647),
    [anon_sym_partial] = ACTIONS(4647),
    [anon_sym_private] = ACTIONS(4647),
    [anon_sym_protected] = ACTIONS(4647),
    [anon_sym_public] = ACTIONS(4647),
    [anon_sym_readonly] = ACTIONS(4647),
    [anon_sym_required] = ACTIONS(4647),
    [anon_sym_sealed] = ACTIONS(4647),
    [anon_sym_virtual] = ACTIONS(4647),
    [anon_sym_volatile] = ACTIONS(4647),
    [anon_sym_where] = ACTIONS(4647),
    [anon_sym_notnull] = ACTIONS(4647),
    [anon_sym_unmanaged] = ACTIONS(4647),
    [anon_sym_TILDE] = ACTIONS(4649),
    [anon_sym_implicit] = ACTIONS(4647),
    [anon_sym_explicit] = ACTIONS(4647),
    [anon_sym_scoped] = ACTIONS(4647),
    [anon_sym_var] = ACTIONS(4647),
    [sym_predefined_type] = ACTIONS(4647),
    [anon_sym_yield] = ACTIONS(4647),
    [anon_sym_when] = ACTIONS(4647),
    [anon_sym_from] = ACTIONS(4647),
    [anon_sym_into] = ACTIONS(4647),
    [anon_sym_join] = ACTIONS(4647),
    [anon_sym_on] = ACTIONS(4647),
    [anon_sym_equals] = ACTIONS(4647),
    [anon_sym_let] = ACTIONS(4647),
    [anon_sym_orderby] = ACTIONS(4647),
    [anon_sym_ascending] = ACTIONS(4647),
    [anon_sym_descending] = ACTIONS(4647),
    [anon_sym_group] = ACTIONS(4647),
    [anon_sym_by] = ACTIONS(4647),
    [anon_sym_select] = ACTIONS(4647),
    [aux_sym_preproc_if_token1] = ACTIONS(4649),
    [aux_sym_preproc_if_token3] = ACTIONS(4649),
    [aux_sym_preproc_else_token1] = ACTIONS(4649),
    [aux_sym_preproc_elif_token1] = ACTIONS(4649),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2828] = {
    [sym_preproc_region] = STATE(2828),
    [sym_preproc_endregion] = STATE(2828),
    [sym_preproc_line] = STATE(2828),
    [sym_preproc_pragma] = STATE(2828),
    [sym_preproc_nullable] = STATE(2828),
    [sym_preproc_error] = STATE(2828),
    [sym_preproc_warning] = STATE(2828),
    [sym_preproc_define] = STATE(2828),
    [sym_preproc_undef] = STATE(2828),
    [sym__identifier_token] = ACTIONS(4651),
    [anon_sym_extern] = ACTIONS(4651),
    [anon_sym_alias] = ACTIONS(4651),
    [anon_sym_global] = ACTIONS(4651),
    [anon_sym_using] = ACTIONS(4651),
    [anon_sym_unsafe] = ACTIONS(4651),
    [anon_sym_static] = ACTIONS(4651),
    [anon_sym_LBRACK] = ACTIONS(4653),
    [anon_sym_LPAREN] = ACTIONS(4653),
    [anon_sym_event] = ACTIONS(4651),
    [anon_sym_namespace] = ACTIONS(4651),
    [anon_sym_class] = ACTIONS(4651),
    [anon_sym_ref] = ACTIONS(4651),
    [anon_sym_struct] = ACTIONS(4651),
    [anon_sym_enum] = ACTIONS(4651),
    [anon_sym_RBRACE] = ACTIONS(4653),
    [anon_sym_interface] = ACTIONS(4651),
    [anon_sym_delegate] = ACTIONS(4651),
    [anon_sym_record] = ACTIONS(4651),
    [anon_sym_abstract] = ACTIONS(4651),
    [anon_sym_async] = ACTIONS(4651),
    [anon_sym_const] = ACTIONS(4651),
    [anon_sym_file] = ACTIONS(4651),
    [anon_sym_fixed] = ACTIONS(4651),
    [anon_sym_internal] = ACTIONS(4651),
    [anon_sym_new] = ACTIONS(4651),
    [anon_sym_override] = ACTIONS(4651),
    [anon_sym_partial] = ACTIONS(4651),
    [anon_sym_private] = ACTIONS(4651),
    [anon_sym_protected] = ACTIONS(4651),
    [anon_sym_public] = ACTIONS(4651),
    [anon_sym_readonly] = ACTIONS(4651),
    [anon_sym_required] = ACTIONS(4651),
    [anon_sym_sealed] = ACTIONS(4651),
    [anon_sym_virtual] = ACTIONS(4651),
    [anon_sym_volatile] = ACTIONS(4651),
    [anon_sym_where] = ACTIONS(4651),
    [anon_sym_notnull] = ACTIONS(4651),
    [anon_sym_unmanaged] = ACTIONS(4651),
    [anon_sym_TILDE] = ACTIONS(4653),
    [anon_sym_implicit] = ACTIONS(4651),
    [anon_sym_explicit] = ACTIONS(4651),
    [anon_sym_scoped] = ACTIONS(4651),
    [anon_sym_var] = ACTIONS(4651),
    [sym_predefined_type] = ACTIONS(4651),
    [anon_sym_yield] = ACTIONS(4651),
    [anon_sym_when] = ACTIONS(4651),
    [anon_sym_from] = ACTIONS(4651),
    [anon_sym_into] = ACTIONS(4651),
    [anon_sym_join] = ACTIONS(4651),
    [anon_sym_on] = ACTIONS(4651),
    [anon_sym_equals] = ACTIONS(4651),
    [anon_sym_let] = ACTIONS(4651),
    [anon_sym_orderby] = ACTIONS(4651),
    [anon_sym_ascending] = ACTIONS(4651),
    [anon_sym_descending] = ACTIONS(4651),
    [anon_sym_group] = ACTIONS(4651),
    [anon_sym_by] = ACTIONS(4651),
    [anon_sym_select] = ACTIONS(4651),
    [aux_sym_preproc_if_token1] = ACTIONS(4653),
    [aux_sym_preproc_if_token3] = ACTIONS(4653),
    [aux_sym_preproc_else_token1] = ACTIONS(4653),
    [aux_sym_preproc_elif_token1] = ACTIONS(4653),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2829] = {
    [sym_preproc_region] = STATE(2829),
    [sym_preproc_endregion] = STATE(2829),
    [sym_preproc_line] = STATE(2829),
    [sym_preproc_pragma] = STATE(2829),
    [sym_preproc_nullable] = STATE(2829),
    [sym_preproc_error] = STATE(2829),
    [sym_preproc_warning] = STATE(2829),
    [sym_preproc_define] = STATE(2829),
    [sym_preproc_undef] = STATE(2829),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4655),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2830] = {
    [sym__variable_designation] = STATE(3555),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2830),
    [sym_preproc_endregion] = STATE(2830),
    [sym_preproc_line] = STATE(2830),
    [sym_preproc_pragma] = STATE(2830),
    [sym_preproc_nullable] = STATE(2830),
    [sym_preproc_error] = STATE(2830),
    [sym_preproc_warning] = STATE(2830),
    [sym_preproc_define] = STATE(2830),
    [sym_preproc_undef] = STATE(2830),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2831] = {
    [sym__variable_designation] = STATE(3534),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2831),
    [sym_preproc_endregion] = STATE(2831),
    [sym_preproc_line] = STATE(2831),
    [sym_preproc_pragma] = STATE(2831),
    [sym_preproc_nullable] = STATE(2831),
    [sym_preproc_error] = STATE(2831),
    [sym_preproc_warning] = STATE(2831),
    [sym_preproc_define] = STATE(2831),
    [sym_preproc_undef] = STATE(2831),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2832] = {
    [sym_preproc_region] = STATE(2832),
    [sym_preproc_endregion] = STATE(2832),
    [sym_preproc_line] = STATE(2832),
    [sym_preproc_pragma] = STATE(2832),
    [sym_preproc_nullable] = STATE(2832),
    [sym_preproc_error] = STATE(2832),
    [sym_preproc_warning] = STATE(2832),
    [sym_preproc_define] = STATE(2832),
    [sym_preproc_undef] = STATE(2832),
    [sym__identifier_token] = ACTIONS(4657),
    [anon_sym_extern] = ACTIONS(4657),
    [anon_sym_alias] = ACTIONS(4657),
    [anon_sym_global] = ACTIONS(4657),
    [anon_sym_using] = ACTIONS(4657),
    [anon_sym_unsafe] = ACTIONS(4657),
    [anon_sym_static] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(4659),
    [anon_sym_LPAREN] = ACTIONS(4659),
    [anon_sym_event] = ACTIONS(4657),
    [anon_sym_namespace] = ACTIONS(4657),
    [anon_sym_class] = ACTIONS(4657),
    [anon_sym_ref] = ACTIONS(4657),
    [anon_sym_struct] = ACTIONS(4657),
    [anon_sym_enum] = ACTIONS(4657),
    [anon_sym_RBRACE] = ACTIONS(4659),
    [anon_sym_interface] = ACTIONS(4657),
    [anon_sym_delegate] = ACTIONS(4657),
    [anon_sym_record] = ACTIONS(4657),
    [anon_sym_abstract] = ACTIONS(4657),
    [anon_sym_async] = ACTIONS(4657),
    [anon_sym_const] = ACTIONS(4657),
    [anon_sym_file] = ACTIONS(4657),
    [anon_sym_fixed] = ACTIONS(4657),
    [anon_sym_internal] = ACTIONS(4657),
    [anon_sym_new] = ACTIONS(4657),
    [anon_sym_override] = ACTIONS(4657),
    [anon_sym_partial] = ACTIONS(4657),
    [anon_sym_private] = ACTIONS(4657),
    [anon_sym_protected] = ACTIONS(4657),
    [anon_sym_public] = ACTIONS(4657),
    [anon_sym_readonly] = ACTIONS(4657),
    [anon_sym_required] = ACTIONS(4657),
    [anon_sym_sealed] = ACTIONS(4657),
    [anon_sym_virtual] = ACTIONS(4657),
    [anon_sym_volatile] = ACTIONS(4657),
    [anon_sym_where] = ACTIONS(4657),
    [anon_sym_notnull] = ACTIONS(4657),
    [anon_sym_unmanaged] = ACTIONS(4657),
    [anon_sym_TILDE] = ACTIONS(4659),
    [anon_sym_implicit] = ACTIONS(4657),
    [anon_sym_explicit] = ACTIONS(4657),
    [anon_sym_scoped] = ACTIONS(4657),
    [anon_sym_var] = ACTIONS(4657),
    [sym_predefined_type] = ACTIONS(4657),
    [anon_sym_yield] = ACTIONS(4657),
    [anon_sym_when] = ACTIONS(4657),
    [anon_sym_from] = ACTIONS(4657),
    [anon_sym_into] = ACTIONS(4657),
    [anon_sym_join] = ACTIONS(4657),
    [anon_sym_on] = ACTIONS(4657),
    [anon_sym_equals] = ACTIONS(4657),
    [anon_sym_let] = ACTIONS(4657),
    [anon_sym_orderby] = ACTIONS(4657),
    [anon_sym_ascending] = ACTIONS(4657),
    [anon_sym_descending] = ACTIONS(4657),
    [anon_sym_group] = ACTIONS(4657),
    [anon_sym_by] = ACTIONS(4657),
    [anon_sym_select] = ACTIONS(4657),
    [aux_sym_preproc_if_token1] = ACTIONS(4659),
    [aux_sym_preproc_if_token3] = ACTIONS(4659),
    [aux_sym_preproc_else_token1] = ACTIONS(4659),
    [aux_sym_preproc_elif_token1] = ACTIONS(4659),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2833] = {
    [sym_preproc_region] = STATE(2833),
    [sym_preproc_endregion] = STATE(2833),
    [sym_preproc_line] = STATE(2833),
    [sym_preproc_pragma] = STATE(2833),
    [sym_preproc_nullable] = STATE(2833),
    [sym_preproc_error] = STATE(2833),
    [sym_preproc_warning] = STATE(2833),
    [sym_preproc_define] = STATE(2833),
    [sym_preproc_undef] = STATE(2833),
    [sym__identifier_token] = ACTIONS(4661),
    [anon_sym_extern] = ACTIONS(4661),
    [anon_sym_alias] = ACTIONS(4661),
    [anon_sym_global] = ACTIONS(4661),
    [anon_sym_using] = ACTIONS(4661),
    [anon_sym_unsafe] = ACTIONS(4661),
    [anon_sym_static] = ACTIONS(4661),
    [anon_sym_LBRACK] = ACTIONS(4663),
    [anon_sym_LPAREN] = ACTIONS(4663),
    [anon_sym_event] = ACTIONS(4661),
    [anon_sym_namespace] = ACTIONS(4661),
    [anon_sym_class] = ACTIONS(4661),
    [anon_sym_ref] = ACTIONS(4661),
    [anon_sym_struct] = ACTIONS(4661),
    [anon_sym_enum] = ACTIONS(4661),
    [anon_sym_RBRACE] = ACTIONS(4663),
    [anon_sym_interface] = ACTIONS(4661),
    [anon_sym_delegate] = ACTIONS(4661),
    [anon_sym_record] = ACTIONS(4661),
    [anon_sym_abstract] = ACTIONS(4661),
    [anon_sym_async] = ACTIONS(4661),
    [anon_sym_const] = ACTIONS(4661),
    [anon_sym_file] = ACTIONS(4661),
    [anon_sym_fixed] = ACTIONS(4661),
    [anon_sym_internal] = ACTIONS(4661),
    [anon_sym_new] = ACTIONS(4661),
    [anon_sym_override] = ACTIONS(4661),
    [anon_sym_partial] = ACTIONS(4661),
    [anon_sym_private] = ACTIONS(4661),
    [anon_sym_protected] = ACTIONS(4661),
    [anon_sym_public] = ACTIONS(4661),
    [anon_sym_readonly] = ACTIONS(4661),
    [anon_sym_required] = ACTIONS(4661),
    [anon_sym_sealed] = ACTIONS(4661),
    [anon_sym_virtual] = ACTIONS(4661),
    [anon_sym_volatile] = ACTIONS(4661),
    [anon_sym_where] = ACTIONS(4661),
    [anon_sym_notnull] = ACTIONS(4661),
    [anon_sym_unmanaged] = ACTIONS(4661),
    [anon_sym_TILDE] = ACTIONS(4663),
    [anon_sym_implicit] = ACTIONS(4661),
    [anon_sym_explicit] = ACTIONS(4661),
    [anon_sym_scoped] = ACTIONS(4661),
    [anon_sym_var] = ACTIONS(4661),
    [sym_predefined_type] = ACTIONS(4661),
    [anon_sym_yield] = ACTIONS(4661),
    [anon_sym_when] = ACTIONS(4661),
    [anon_sym_from] = ACTIONS(4661),
    [anon_sym_into] = ACTIONS(4661),
    [anon_sym_join] = ACTIONS(4661),
    [anon_sym_on] = ACTIONS(4661),
    [anon_sym_equals] = ACTIONS(4661),
    [anon_sym_let] = ACTIONS(4661),
    [anon_sym_orderby] = ACTIONS(4661),
    [anon_sym_ascending] = ACTIONS(4661),
    [anon_sym_descending] = ACTIONS(4661),
    [anon_sym_group] = ACTIONS(4661),
    [anon_sym_by] = ACTIONS(4661),
    [anon_sym_select] = ACTIONS(4661),
    [aux_sym_preproc_if_token1] = ACTIONS(4663),
    [aux_sym_preproc_if_token3] = ACTIONS(4663),
    [aux_sym_preproc_else_token1] = ACTIONS(4663),
    [aux_sym_preproc_elif_token1] = ACTIONS(4663),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2834] = {
    [sym__variable_designation] = STATE(3536),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2834),
    [sym_preproc_endregion] = STATE(2834),
    [sym_preproc_line] = STATE(2834),
    [sym_preproc_pragma] = STATE(2834),
    [sym_preproc_nullable] = STATE(2834),
    [sym_preproc_error] = STATE(2834),
    [sym_preproc_warning] = STATE(2834),
    [sym_preproc_define] = STATE(2834),
    [sym_preproc_undef] = STATE(2834),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3999),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2835] = {
    [sym__variable_designation] = STATE(3403),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2835),
    [sym_preproc_endregion] = STATE(2835),
    [sym_preproc_line] = STATE(2835),
    [sym_preproc_pragma] = STATE(2835),
    [sym_preproc_nullable] = STATE(2835),
    [sym_preproc_error] = STATE(2835),
    [sym_preproc_warning] = STATE(2835),
    [sym_preproc_define] = STATE(2835),
    [sym_preproc_undef] = STATE(2835),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2836] = {
    [sym_preproc_region] = STATE(2836),
    [sym_preproc_endregion] = STATE(2836),
    [sym_preproc_line] = STATE(2836),
    [sym_preproc_pragma] = STATE(2836),
    [sym_preproc_nullable] = STATE(2836),
    [sym_preproc_error] = STATE(2836),
    [sym_preproc_warning] = STATE(2836),
    [sym_preproc_define] = STATE(2836),
    [sym_preproc_undef] = STATE(2836),
    [sym__identifier_token] = ACTIONS(4665),
    [anon_sym_extern] = ACTIONS(4665),
    [anon_sym_alias] = ACTIONS(4665),
    [anon_sym_global] = ACTIONS(4665),
    [anon_sym_using] = ACTIONS(4665),
    [anon_sym_unsafe] = ACTIONS(4665),
    [anon_sym_static] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_event] = ACTIONS(4665),
    [anon_sym_namespace] = ACTIONS(4665),
    [anon_sym_class] = ACTIONS(4665),
    [anon_sym_ref] = ACTIONS(4665),
    [anon_sym_struct] = ACTIONS(4665),
    [anon_sym_enum] = ACTIONS(4665),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_interface] = ACTIONS(4665),
    [anon_sym_delegate] = ACTIONS(4665),
    [anon_sym_record] = ACTIONS(4665),
    [anon_sym_abstract] = ACTIONS(4665),
    [anon_sym_async] = ACTIONS(4665),
    [anon_sym_const] = ACTIONS(4665),
    [anon_sym_file] = ACTIONS(4665),
    [anon_sym_fixed] = ACTIONS(4665),
    [anon_sym_internal] = ACTIONS(4665),
    [anon_sym_new] = ACTIONS(4665),
    [anon_sym_override] = ACTIONS(4665),
    [anon_sym_partial] = ACTIONS(4665),
    [anon_sym_private] = ACTIONS(4665),
    [anon_sym_protected] = ACTIONS(4665),
    [anon_sym_public] = ACTIONS(4665),
    [anon_sym_readonly] = ACTIONS(4665),
    [anon_sym_required] = ACTIONS(4665),
    [anon_sym_sealed] = ACTIONS(4665),
    [anon_sym_virtual] = ACTIONS(4665),
    [anon_sym_volatile] = ACTIONS(4665),
    [anon_sym_where] = ACTIONS(4665),
    [anon_sym_notnull] = ACTIONS(4665),
    [anon_sym_unmanaged] = ACTIONS(4665),
    [anon_sym_TILDE] = ACTIONS(4667),
    [anon_sym_implicit] = ACTIONS(4665),
    [anon_sym_explicit] = ACTIONS(4665),
    [anon_sym_scoped] = ACTIONS(4665),
    [anon_sym_var] = ACTIONS(4665),
    [sym_predefined_type] = ACTIONS(4665),
    [anon_sym_yield] = ACTIONS(4665),
    [anon_sym_when] = ACTIONS(4665),
    [anon_sym_from] = ACTIONS(4665),
    [anon_sym_into] = ACTIONS(4665),
    [anon_sym_join] = ACTIONS(4665),
    [anon_sym_on] = ACTIONS(4665),
    [anon_sym_equals] = ACTIONS(4665),
    [anon_sym_let] = ACTIONS(4665),
    [anon_sym_orderby] = ACTIONS(4665),
    [anon_sym_ascending] = ACTIONS(4665),
    [anon_sym_descending] = ACTIONS(4665),
    [anon_sym_group] = ACTIONS(4665),
    [anon_sym_by] = ACTIONS(4665),
    [anon_sym_select] = ACTIONS(4665),
    [aux_sym_preproc_if_token1] = ACTIONS(4667),
    [aux_sym_preproc_if_token3] = ACTIONS(4667),
    [aux_sym_preproc_else_token1] = ACTIONS(4667),
    [aux_sym_preproc_elif_token1] = ACTIONS(4667),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2837] = {
    [sym_preproc_region] = STATE(2837),
    [sym_preproc_endregion] = STATE(2837),
    [sym_preproc_line] = STATE(2837),
    [sym_preproc_pragma] = STATE(2837),
    [sym_preproc_nullable] = STATE(2837),
    [sym_preproc_error] = STATE(2837),
    [sym_preproc_warning] = STATE(2837),
    [sym_preproc_define] = STATE(2837),
    [sym_preproc_undef] = STATE(2837),
    [sym__identifier_token] = ACTIONS(4669),
    [anon_sym_extern] = ACTIONS(4669),
    [anon_sym_alias] = ACTIONS(4669),
    [anon_sym_global] = ACTIONS(4669),
    [anon_sym_using] = ACTIONS(4669),
    [anon_sym_unsafe] = ACTIONS(4669),
    [anon_sym_static] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4671),
    [anon_sym_LPAREN] = ACTIONS(4671),
    [anon_sym_event] = ACTIONS(4669),
    [anon_sym_namespace] = ACTIONS(4669),
    [anon_sym_class] = ACTIONS(4669),
    [anon_sym_ref] = ACTIONS(4669),
    [anon_sym_struct] = ACTIONS(4669),
    [anon_sym_enum] = ACTIONS(4669),
    [anon_sym_RBRACE] = ACTIONS(4671),
    [anon_sym_interface] = ACTIONS(4669),
    [anon_sym_delegate] = ACTIONS(4669),
    [anon_sym_record] = ACTIONS(4669),
    [anon_sym_abstract] = ACTIONS(4669),
    [anon_sym_async] = ACTIONS(4669),
    [anon_sym_const] = ACTIONS(4669),
    [anon_sym_file] = ACTIONS(4669),
    [anon_sym_fixed] = ACTIONS(4669),
    [anon_sym_internal] = ACTIONS(4669),
    [anon_sym_new] = ACTIONS(4669),
    [anon_sym_override] = ACTIONS(4669),
    [anon_sym_partial] = ACTIONS(4669),
    [anon_sym_private] = ACTIONS(4669),
    [anon_sym_protected] = ACTIONS(4669),
    [anon_sym_public] = ACTIONS(4669),
    [anon_sym_readonly] = ACTIONS(4669),
    [anon_sym_required] = ACTIONS(4669),
    [anon_sym_sealed] = ACTIONS(4669),
    [anon_sym_virtual] = ACTIONS(4669),
    [anon_sym_volatile] = ACTIONS(4669),
    [anon_sym_where] = ACTIONS(4669),
    [anon_sym_notnull] = ACTIONS(4669),
    [anon_sym_unmanaged] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4671),
    [anon_sym_implicit] = ACTIONS(4669),
    [anon_sym_explicit] = ACTIONS(4669),
    [anon_sym_scoped] = ACTIONS(4669),
    [anon_sym_var] = ACTIONS(4669),
    [sym_predefined_type] = ACTIONS(4669),
    [anon_sym_yield] = ACTIONS(4669),
    [anon_sym_when] = ACTIONS(4669),
    [anon_sym_from] = ACTIONS(4669),
    [anon_sym_into] = ACTIONS(4669),
    [anon_sym_join] = ACTIONS(4669),
    [anon_sym_on] = ACTIONS(4669),
    [anon_sym_equals] = ACTIONS(4669),
    [anon_sym_let] = ACTIONS(4669),
    [anon_sym_orderby] = ACTIONS(4669),
    [anon_sym_ascending] = ACTIONS(4669),
    [anon_sym_descending] = ACTIONS(4669),
    [anon_sym_group] = ACTIONS(4669),
    [anon_sym_by] = ACTIONS(4669),
    [anon_sym_select] = ACTIONS(4669),
    [aux_sym_preproc_if_token1] = ACTIONS(4671),
    [aux_sym_preproc_if_token3] = ACTIONS(4671),
    [aux_sym_preproc_else_token1] = ACTIONS(4671),
    [aux_sym_preproc_elif_token1] = ACTIONS(4671),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2838] = {
    [sym_preproc_region] = STATE(2838),
    [sym_preproc_endregion] = STATE(2838),
    [sym_preproc_line] = STATE(2838),
    [sym_preproc_pragma] = STATE(2838),
    [sym_preproc_nullable] = STATE(2838),
    [sym_preproc_error] = STATE(2838),
    [sym_preproc_warning] = STATE(2838),
    [sym_preproc_define] = STATE(2838),
    [sym_preproc_undef] = STATE(2838),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_event] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_operator] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_implicit] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_this] = ACTIONS(3461),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2839] = {
    [sym_preproc_region] = STATE(2839),
    [sym_preproc_endregion] = STATE(2839),
    [sym_preproc_line] = STATE(2839),
    [sym_preproc_pragma] = STATE(2839),
    [sym_preproc_nullable] = STATE(2839),
    [sym_preproc_error] = STATE(2839),
    [sym_preproc_warning] = STATE(2839),
    [sym_preproc_define] = STATE(2839),
    [sym_preproc_undef] = STATE(2839),
    [sym__identifier_token] = ACTIONS(4673),
    [anon_sym_extern] = ACTIONS(4673),
    [anon_sym_alias] = ACTIONS(4673),
    [anon_sym_global] = ACTIONS(4673),
    [anon_sym_using] = ACTIONS(4673),
    [anon_sym_unsafe] = ACTIONS(4673),
    [anon_sym_static] = ACTIONS(4673),
    [anon_sym_LBRACK] = ACTIONS(4675),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym_event] = ACTIONS(4673),
    [anon_sym_namespace] = ACTIONS(4673),
    [anon_sym_class] = ACTIONS(4673),
    [anon_sym_ref] = ACTIONS(4673),
    [anon_sym_struct] = ACTIONS(4673),
    [anon_sym_enum] = ACTIONS(4673),
    [anon_sym_RBRACE] = ACTIONS(4675),
    [anon_sym_interface] = ACTIONS(4673),
    [anon_sym_delegate] = ACTIONS(4673),
    [anon_sym_record] = ACTIONS(4673),
    [anon_sym_abstract] = ACTIONS(4673),
    [anon_sym_async] = ACTIONS(4673),
    [anon_sym_const] = ACTIONS(4673),
    [anon_sym_file] = ACTIONS(4673),
    [anon_sym_fixed] = ACTIONS(4673),
    [anon_sym_internal] = ACTIONS(4673),
    [anon_sym_new] = ACTIONS(4673),
    [anon_sym_override] = ACTIONS(4673),
    [anon_sym_partial] = ACTIONS(4673),
    [anon_sym_private] = ACTIONS(4673),
    [anon_sym_protected] = ACTIONS(4673),
    [anon_sym_public] = ACTIONS(4673),
    [anon_sym_readonly] = ACTIONS(4673),
    [anon_sym_required] = ACTIONS(4673),
    [anon_sym_sealed] = ACTIONS(4673),
    [anon_sym_virtual] = ACTIONS(4673),
    [anon_sym_volatile] = ACTIONS(4673),
    [anon_sym_where] = ACTIONS(4673),
    [anon_sym_notnull] = ACTIONS(4673),
    [anon_sym_unmanaged] = ACTIONS(4673),
    [anon_sym_TILDE] = ACTIONS(4675),
    [anon_sym_implicit] = ACTIONS(4673),
    [anon_sym_explicit] = ACTIONS(4673),
    [anon_sym_scoped] = ACTIONS(4673),
    [anon_sym_var] = ACTIONS(4673),
    [sym_predefined_type] = ACTIONS(4673),
    [anon_sym_yield] = ACTIONS(4673),
    [anon_sym_when] = ACTIONS(4673),
    [anon_sym_from] = ACTIONS(4673),
    [anon_sym_into] = ACTIONS(4673),
    [anon_sym_join] = ACTIONS(4673),
    [anon_sym_on] = ACTIONS(4673),
    [anon_sym_equals] = ACTIONS(4673),
    [anon_sym_let] = ACTIONS(4673),
    [anon_sym_orderby] = ACTIONS(4673),
    [anon_sym_ascending] = ACTIONS(4673),
    [anon_sym_descending] = ACTIONS(4673),
    [anon_sym_group] = ACTIONS(4673),
    [anon_sym_by] = ACTIONS(4673),
    [anon_sym_select] = ACTIONS(4673),
    [aux_sym_preproc_if_token1] = ACTIONS(4675),
    [aux_sym_preproc_if_token3] = ACTIONS(4675),
    [aux_sym_preproc_else_token1] = ACTIONS(4675),
    [aux_sym_preproc_elif_token1] = ACTIONS(4675),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2840] = {
    [sym_preproc_region] = STATE(2840),
    [sym_preproc_endregion] = STATE(2840),
    [sym_preproc_line] = STATE(2840),
    [sym_preproc_pragma] = STATE(2840),
    [sym_preproc_nullable] = STATE(2840),
    [sym_preproc_error] = STATE(2840),
    [sym_preproc_warning] = STATE(2840),
    [sym_preproc_define] = STATE(2840),
    [sym_preproc_undef] = STATE(2840),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4677),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4421),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2841] = {
    [sym__variable_designation] = STATE(3555),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2841),
    [sym_preproc_endregion] = STATE(2841),
    [sym_preproc_line] = STATE(2841),
    [sym_preproc_pragma] = STATE(2841),
    [sym_preproc_nullable] = STATE(2841),
    [sym_preproc_error] = STATE(2841),
    [sym_preproc_warning] = STATE(2841),
    [sym_preproc_define] = STATE(2841),
    [sym_preproc_undef] = STATE(2841),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3929),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2842] = {
    [sym_preproc_region] = STATE(2842),
    [sym_preproc_endregion] = STATE(2842),
    [sym_preproc_line] = STATE(2842),
    [sym_preproc_pragma] = STATE(2842),
    [sym_preproc_nullable] = STATE(2842),
    [sym_preproc_error] = STATE(2842),
    [sym_preproc_warning] = STATE(2842),
    [sym_preproc_define] = STATE(2842),
    [sym_preproc_undef] = STATE(2842),
    [sym__identifier_token] = ACTIONS(4679),
    [anon_sym_extern] = ACTIONS(4679),
    [anon_sym_alias] = ACTIONS(4679),
    [anon_sym_global] = ACTIONS(4679),
    [anon_sym_using] = ACTIONS(4679),
    [anon_sym_unsafe] = ACTIONS(4679),
    [anon_sym_static] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_event] = ACTIONS(4679),
    [anon_sym_namespace] = ACTIONS(4679),
    [anon_sym_class] = ACTIONS(4679),
    [anon_sym_ref] = ACTIONS(4679),
    [anon_sym_struct] = ACTIONS(4679),
    [anon_sym_enum] = ACTIONS(4679),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_interface] = ACTIONS(4679),
    [anon_sym_delegate] = ACTIONS(4679),
    [anon_sym_record] = ACTIONS(4679),
    [anon_sym_abstract] = ACTIONS(4679),
    [anon_sym_async] = ACTIONS(4679),
    [anon_sym_const] = ACTIONS(4679),
    [anon_sym_file] = ACTIONS(4679),
    [anon_sym_fixed] = ACTIONS(4679),
    [anon_sym_internal] = ACTIONS(4679),
    [anon_sym_new] = ACTIONS(4679),
    [anon_sym_override] = ACTIONS(4679),
    [anon_sym_partial] = ACTIONS(4679),
    [anon_sym_private] = ACTIONS(4679),
    [anon_sym_protected] = ACTIONS(4679),
    [anon_sym_public] = ACTIONS(4679),
    [anon_sym_readonly] = ACTIONS(4679),
    [anon_sym_required] = ACTIONS(4679),
    [anon_sym_sealed] = ACTIONS(4679),
    [anon_sym_virtual] = ACTIONS(4679),
    [anon_sym_volatile] = ACTIONS(4679),
    [anon_sym_where] = ACTIONS(4679),
    [anon_sym_notnull] = ACTIONS(4679),
    [anon_sym_unmanaged] = ACTIONS(4679),
    [anon_sym_TILDE] = ACTIONS(4681),
    [anon_sym_implicit] = ACTIONS(4679),
    [anon_sym_explicit] = ACTIONS(4679),
    [anon_sym_scoped] = ACTIONS(4679),
    [anon_sym_var] = ACTIONS(4679),
    [sym_predefined_type] = ACTIONS(4679),
    [anon_sym_yield] = ACTIONS(4679),
    [anon_sym_when] = ACTIONS(4679),
    [anon_sym_from] = ACTIONS(4679),
    [anon_sym_into] = ACTIONS(4679),
    [anon_sym_join] = ACTIONS(4679),
    [anon_sym_on] = ACTIONS(4679),
    [anon_sym_equals] = ACTIONS(4679),
    [anon_sym_let] = ACTIONS(4679),
    [anon_sym_orderby] = ACTIONS(4679),
    [anon_sym_ascending] = ACTIONS(4679),
    [anon_sym_descending] = ACTIONS(4679),
    [anon_sym_group] = ACTIONS(4679),
    [anon_sym_by] = ACTIONS(4679),
    [anon_sym_select] = ACTIONS(4679),
    [aux_sym_preproc_if_token1] = ACTIONS(4681),
    [aux_sym_preproc_if_token3] = ACTIONS(4681),
    [aux_sym_preproc_else_token1] = ACTIONS(4681),
    [aux_sym_preproc_elif_token1] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2843] = {
    [sym__variable_designation] = STATE(3534),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2843),
    [sym_preproc_endregion] = STATE(2843),
    [sym_preproc_line] = STATE(2843),
    [sym_preproc_pragma] = STATE(2843),
    [sym_preproc_nullable] = STATE(2843),
    [sym_preproc_error] = STATE(2843),
    [sym_preproc_warning] = STATE(2843),
    [sym_preproc_define] = STATE(2843),
    [sym_preproc_undef] = STATE(2843),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3933),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2844] = {
    [sym__variable_designation] = STATE(3536),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2844),
    [sym_preproc_endregion] = STATE(2844),
    [sym_preproc_line] = STATE(2844),
    [sym_preproc_pragma] = STATE(2844),
    [sym_preproc_nullable] = STATE(2844),
    [sym_preproc_error] = STATE(2844),
    [sym_preproc_warning] = STATE(2844),
    [sym_preproc_define] = STATE(2844),
    [sym_preproc_undef] = STATE(2844),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3999),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2845] = {
    [sym__variable_designation] = STATE(3403),
    [sym_parenthesized_variable_designation] = STATE(3545),
    [sym_identifier] = STATE(3547),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2845),
    [sym_preproc_endregion] = STATE(2845),
    [sym_preproc_line] = STATE(2845),
    [sym_preproc_pragma] = STATE(2845),
    [sym_preproc_nullable] = STATE(2845),
    [sym_preproc_error] = STATE(2845),
    [sym_preproc_warning] = STATE(2845),
    [sym_preproc_define] = STATE(2845),
    [sym_preproc_undef] = STATE(2845),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3913),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3899),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(4003),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2846] = {
    [sym_preproc_region] = STATE(2846),
    [sym_preproc_endregion] = STATE(2846),
    [sym_preproc_line] = STATE(2846),
    [sym_preproc_pragma] = STATE(2846),
    [sym_preproc_nullable] = STATE(2846),
    [sym_preproc_error] = STATE(2846),
    [sym_preproc_warning] = STATE(2846),
    [sym_preproc_define] = STATE(2846),
    [sym_preproc_undef] = STATE(2846),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_is] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [2847] = {
    [sym_preproc_region] = STATE(2847),
    [sym_preproc_endregion] = STATE(2847),
    [sym_preproc_line] = STATE(2847),
    [sym_preproc_pragma] = STATE(2847),
    [sym_preproc_nullable] = STATE(2847),
    [sym_preproc_error] = STATE(2847),
    [sym_preproc_warning] = STATE(2847),
    [sym_preproc_define] = STATE(2847),
    [sym_preproc_undef] = STATE(2847),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2848] = {
    [sym_preproc_region] = STATE(2848),
    [sym_preproc_endregion] = STATE(2848),
    [sym_preproc_line] = STATE(2848),
    [sym_preproc_pragma] = STATE(2848),
    [sym_preproc_nullable] = STATE(2848),
    [sym_preproc_error] = STATE(2848),
    [sym_preproc_warning] = STATE(2848),
    [sym_preproc_define] = STATE(2848),
    [sym_preproc_undef] = STATE(2848),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4024),
  },
  [2849] = {
    [sym_preproc_region] = STATE(2849),
    [sym_preproc_endregion] = STATE(2849),
    [sym_preproc_line] = STATE(2849),
    [sym_preproc_pragma] = STATE(2849),
    [sym_preproc_nullable] = STATE(2849),
    [sym_preproc_error] = STATE(2849),
    [sym_preproc_warning] = STATE(2849),
    [sym_preproc_define] = STATE(2849),
    [sym_preproc_undef] = STATE(2849),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_is] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3662),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3664),
  },
  [2850] = {
    [sym_preproc_region] = STATE(2850),
    [sym_preproc_endregion] = STATE(2850),
    [sym_preproc_line] = STATE(2850),
    [sym_preproc_pragma] = STATE(2850),
    [sym_preproc_nullable] = STATE(2850),
    [sym_preproc_error] = STATE(2850),
    [sym_preproc_warning] = STATE(2850),
    [sym_preproc_define] = STATE(2850),
    [sym_preproc_undef] = STATE(2850),
    [sym__identifier_token] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym_alias] = ACTIONS(3383),
    [anon_sym_global] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_unsafe] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_event] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_ref] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_delegate] = ACTIONS(3383),
    [anon_sym_record] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_file] = ACTIONS(3383),
    [anon_sym_fixed] = ACTIONS(3383),
    [anon_sym_internal] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_partial] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_required] = ACTIONS(3383),
    [anon_sym_sealed] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_where] = ACTIONS(3383),
    [anon_sym_notnull] = ACTIONS(3383),
    [anon_sym_unmanaged] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_implicit] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_scoped] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [sym_predefined_type] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_when] = ACTIONS(3383),
    [anon_sym_from] = ACTIONS(3383),
    [anon_sym_into] = ACTIONS(3383),
    [anon_sym_join] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [anon_sym_equals] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_orderby] = ACTIONS(3383),
    [anon_sym_ascending] = ACTIONS(3383),
    [anon_sym_descending] = ACTIONS(3383),
    [anon_sym_group] = ACTIONS(3383),
    [anon_sym_by] = ACTIONS(3383),
    [anon_sym_select] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_if_token3] = ACTIONS(3385),
    [aux_sym_preproc_else_token1] = ACTIONS(3385),
    [aux_sym_preproc_elif_token1] = ACTIONS(3385),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2851] = {
    [sym_preproc_region] = STATE(2851),
    [sym_preproc_endregion] = STATE(2851),
    [sym_preproc_line] = STATE(2851),
    [sym_preproc_pragma] = STATE(2851),
    [sym_preproc_nullable] = STATE(2851),
    [sym_preproc_error] = STATE(2851),
    [sym_preproc_warning] = STATE(2851),
    [sym_preproc_define] = STATE(2851),
    [sym_preproc_undef] = STATE(2851),
    [sym__identifier_token] = ACTIONS(4683),
    [anon_sym_extern] = ACTIONS(4683),
    [anon_sym_alias] = ACTIONS(4683),
    [anon_sym_global] = ACTIONS(4683),
    [anon_sym_using] = ACTIONS(4683),
    [anon_sym_unsafe] = ACTIONS(4683),
    [anon_sym_static] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4685),
    [anon_sym_LPAREN] = ACTIONS(4685),
    [anon_sym_event] = ACTIONS(4683),
    [anon_sym_namespace] = ACTIONS(4683),
    [anon_sym_class] = ACTIONS(4683),
    [anon_sym_ref] = ACTIONS(4683),
    [anon_sym_struct] = ACTIONS(4683),
    [anon_sym_enum] = ACTIONS(4683),
    [anon_sym_RBRACE] = ACTIONS(4685),
    [anon_sym_interface] = ACTIONS(4683),
    [anon_sym_delegate] = ACTIONS(4683),
    [anon_sym_record] = ACTIONS(4683),
    [anon_sym_abstract] = ACTIONS(4683),
    [anon_sym_async] = ACTIONS(4683),
    [anon_sym_const] = ACTIONS(4683),
    [anon_sym_file] = ACTIONS(4683),
    [anon_sym_fixed] = ACTIONS(4683),
    [anon_sym_internal] = ACTIONS(4683),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_override] = ACTIONS(4683),
    [anon_sym_partial] = ACTIONS(4683),
    [anon_sym_private] = ACTIONS(4683),
    [anon_sym_protected] = ACTIONS(4683),
    [anon_sym_public] = ACTIONS(4683),
    [anon_sym_readonly] = ACTIONS(4683),
    [anon_sym_required] = ACTIONS(4683),
    [anon_sym_sealed] = ACTIONS(4683),
    [anon_sym_virtual] = ACTIONS(4683),
    [anon_sym_volatile] = ACTIONS(4683),
    [anon_sym_where] = ACTIONS(4683),
    [anon_sym_notnull] = ACTIONS(4683),
    [anon_sym_unmanaged] = ACTIONS(4683),
    [anon_sym_TILDE] = ACTIONS(4685),
    [anon_sym_implicit] = ACTIONS(4683),
    [anon_sym_explicit] = ACTIONS(4683),
    [anon_sym_scoped] = ACTIONS(4683),
    [anon_sym_var] = ACTIONS(4683),
    [sym_predefined_type] = ACTIONS(4683),
    [anon_sym_yield] = ACTIONS(4683),
    [anon_sym_when] = ACTIONS(4683),
    [anon_sym_from] = ACTIONS(4683),
    [anon_sym_into] = ACTIONS(4683),
    [anon_sym_join] = ACTIONS(4683),
    [anon_sym_on] = ACTIONS(4683),
    [anon_sym_equals] = ACTIONS(4683),
    [anon_sym_let] = ACTIONS(4683),
    [anon_sym_orderby] = ACTIONS(4683),
    [anon_sym_ascending] = ACTIONS(4683),
    [anon_sym_descending] = ACTIONS(4683),
    [anon_sym_group] = ACTIONS(4683),
    [anon_sym_by] = ACTIONS(4683),
    [anon_sym_select] = ACTIONS(4683),
    [aux_sym_preproc_if_token1] = ACTIONS(4685),
    [aux_sym_preproc_if_token3] = ACTIONS(4685),
    [aux_sym_preproc_else_token1] = ACTIONS(4685),
    [aux_sym_preproc_elif_token1] = ACTIONS(4685),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2852] = {
    [sym_preproc_region] = STATE(2852),
    [sym_preproc_endregion] = STATE(2852),
    [sym_preproc_line] = STATE(2852),
    [sym_preproc_pragma] = STATE(2852),
    [sym_preproc_nullable] = STATE(2852),
    [sym_preproc_error] = STATE(2852),
    [sym_preproc_warning] = STATE(2852),
    [sym_preproc_define] = STATE(2852),
    [sym_preproc_undef] = STATE(2852),
    [sym__identifier_token] = ACTIONS(4687),
    [anon_sym_extern] = ACTIONS(4687),
    [anon_sym_alias] = ACTIONS(4687),
    [anon_sym_global] = ACTIONS(4687),
    [anon_sym_using] = ACTIONS(4687),
    [anon_sym_unsafe] = ACTIONS(4687),
    [anon_sym_static] = ACTIONS(4687),
    [anon_sym_LBRACK] = ACTIONS(4689),
    [anon_sym_LPAREN] = ACTIONS(4689),
    [anon_sym_event] = ACTIONS(4687),
    [anon_sym_namespace] = ACTIONS(4687),
    [anon_sym_class] = ACTIONS(4687),
    [anon_sym_ref] = ACTIONS(4687),
    [anon_sym_struct] = ACTIONS(4687),
    [anon_sym_enum] = ACTIONS(4687),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_interface] = ACTIONS(4687),
    [anon_sym_delegate] = ACTIONS(4687),
    [anon_sym_record] = ACTIONS(4687),
    [anon_sym_abstract] = ACTIONS(4687),
    [anon_sym_async] = ACTIONS(4687),
    [anon_sym_const] = ACTIONS(4687),
    [anon_sym_file] = ACTIONS(4687),
    [anon_sym_fixed] = ACTIONS(4687),
    [anon_sym_internal] = ACTIONS(4687),
    [anon_sym_new] = ACTIONS(4687),
    [anon_sym_override] = ACTIONS(4687),
    [anon_sym_partial] = ACTIONS(4687),
    [anon_sym_private] = ACTIONS(4687),
    [anon_sym_protected] = ACTIONS(4687),
    [anon_sym_public] = ACTIONS(4687),
    [anon_sym_readonly] = ACTIONS(4687),
    [anon_sym_required] = ACTIONS(4687),
    [anon_sym_sealed] = ACTIONS(4687),
    [anon_sym_virtual] = ACTIONS(4687),
    [anon_sym_volatile] = ACTIONS(4687),
    [anon_sym_where] = ACTIONS(4687),
    [anon_sym_notnull] = ACTIONS(4687),
    [anon_sym_unmanaged] = ACTIONS(4687),
    [anon_sym_TILDE] = ACTIONS(4689),
    [anon_sym_implicit] = ACTIONS(4687),
    [anon_sym_explicit] = ACTIONS(4687),
    [anon_sym_scoped] = ACTIONS(4687),
    [anon_sym_var] = ACTIONS(4687),
    [sym_predefined_type] = ACTIONS(4687),
    [anon_sym_yield] = ACTIONS(4687),
    [anon_sym_when] = ACTIONS(4687),
    [anon_sym_from] = ACTIONS(4687),
    [anon_sym_into] = ACTIONS(4687),
    [anon_sym_join] = ACTIONS(4687),
    [anon_sym_on] = ACTIONS(4687),
    [anon_sym_equals] = ACTIONS(4687),
    [anon_sym_let] = ACTIONS(4687),
    [anon_sym_orderby] = ACTIONS(4687),
    [anon_sym_ascending] = ACTIONS(4687),
    [anon_sym_descending] = ACTIONS(4687),
    [anon_sym_group] = ACTIONS(4687),
    [anon_sym_by] = ACTIONS(4687),
    [anon_sym_select] = ACTIONS(4687),
    [aux_sym_preproc_if_token1] = ACTIONS(4689),
    [aux_sym_preproc_if_token3] = ACTIONS(4689),
    [aux_sym_preproc_else_token1] = ACTIONS(4689),
    [aux_sym_preproc_elif_token1] = ACTIONS(4689),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2853] = {
    [sym_preproc_region] = STATE(2853),
    [sym_preproc_endregion] = STATE(2853),
    [sym_preproc_line] = STATE(2853),
    [sym_preproc_pragma] = STATE(2853),
    [sym_preproc_nullable] = STATE(2853),
    [sym_preproc_error] = STATE(2853),
    [sym_preproc_warning] = STATE(2853),
    [sym_preproc_define] = STATE(2853),
    [sym_preproc_undef] = STATE(2853),
    [sym__identifier_token] = ACTIONS(4691),
    [anon_sym_extern] = ACTIONS(4691),
    [anon_sym_alias] = ACTIONS(4691),
    [anon_sym_global] = ACTIONS(4691),
    [anon_sym_using] = ACTIONS(4691),
    [anon_sym_unsafe] = ACTIONS(4691),
    [anon_sym_static] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4693),
    [anon_sym_LPAREN] = ACTIONS(4693),
    [anon_sym_event] = ACTIONS(4691),
    [anon_sym_namespace] = ACTIONS(4691),
    [anon_sym_class] = ACTIONS(4691),
    [anon_sym_ref] = ACTIONS(4691),
    [anon_sym_struct] = ACTIONS(4691),
    [anon_sym_enum] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4693),
    [anon_sym_interface] = ACTIONS(4691),
    [anon_sym_delegate] = ACTIONS(4691),
    [anon_sym_record] = ACTIONS(4691),
    [anon_sym_abstract] = ACTIONS(4691),
    [anon_sym_async] = ACTIONS(4691),
    [anon_sym_const] = ACTIONS(4691),
    [anon_sym_file] = ACTIONS(4691),
    [anon_sym_fixed] = ACTIONS(4691),
    [anon_sym_internal] = ACTIONS(4691),
    [anon_sym_new] = ACTIONS(4691),
    [anon_sym_override] = ACTIONS(4691),
    [anon_sym_partial] = ACTIONS(4691),
    [anon_sym_private] = ACTIONS(4691),
    [anon_sym_protected] = ACTIONS(4691),
    [anon_sym_public] = ACTIONS(4691),
    [anon_sym_readonly] = ACTIONS(4691),
    [anon_sym_required] = ACTIONS(4691),
    [anon_sym_sealed] = ACTIONS(4691),
    [anon_sym_virtual] = ACTIONS(4691),
    [anon_sym_volatile] = ACTIONS(4691),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_notnull] = ACTIONS(4691),
    [anon_sym_unmanaged] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_implicit] = ACTIONS(4691),
    [anon_sym_explicit] = ACTIONS(4691),
    [anon_sym_scoped] = ACTIONS(4691),
    [anon_sym_var] = ACTIONS(4691),
    [sym_predefined_type] = ACTIONS(4691),
    [anon_sym_yield] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_from] = ACTIONS(4691),
    [anon_sym_into] = ACTIONS(4691),
    [anon_sym_join] = ACTIONS(4691),
    [anon_sym_on] = ACTIONS(4691),
    [anon_sym_equals] = ACTIONS(4691),
    [anon_sym_let] = ACTIONS(4691),
    [anon_sym_orderby] = ACTIONS(4691),
    [anon_sym_ascending] = ACTIONS(4691),
    [anon_sym_descending] = ACTIONS(4691),
    [anon_sym_group] = ACTIONS(4691),
    [anon_sym_by] = ACTIONS(4691),
    [anon_sym_select] = ACTIONS(4691),
    [aux_sym_preproc_if_token1] = ACTIONS(4693),
    [aux_sym_preproc_if_token3] = ACTIONS(4693),
    [aux_sym_preproc_else_token1] = ACTIONS(4693),
    [aux_sym_preproc_elif_token1] = ACTIONS(4693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2854] = {
    [sym_preproc_region] = STATE(2854),
    [sym_preproc_endregion] = STATE(2854),
    [sym_preproc_line] = STATE(2854),
    [sym_preproc_pragma] = STATE(2854),
    [sym_preproc_nullable] = STATE(2854),
    [sym_preproc_error] = STATE(2854),
    [sym_preproc_warning] = STATE(2854),
    [sym_preproc_define] = STATE(2854),
    [sym_preproc_undef] = STATE(2854),
    [sym__identifier_token] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym_alias] = ACTIONS(3403),
    [anon_sym_global] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_unsafe] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_event] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_ref] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_delegate] = ACTIONS(3403),
    [anon_sym_record] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_file] = ACTIONS(3403),
    [anon_sym_fixed] = ACTIONS(3403),
    [anon_sym_internal] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_partial] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_required] = ACTIONS(3403),
    [anon_sym_sealed] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_where] = ACTIONS(3403),
    [anon_sym_notnull] = ACTIONS(3403),
    [anon_sym_unmanaged] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_implicit] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_scoped] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [sym_predefined_type] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_when] = ACTIONS(3403),
    [anon_sym_from] = ACTIONS(3403),
    [anon_sym_into] = ACTIONS(3403),
    [anon_sym_join] = ACTIONS(3403),
    [anon_sym_on] = ACTIONS(3403),
    [anon_sym_equals] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_orderby] = ACTIONS(3403),
    [anon_sym_ascending] = ACTIONS(3403),
    [anon_sym_descending] = ACTIONS(3403),
    [anon_sym_group] = ACTIONS(3403),
    [anon_sym_by] = ACTIONS(3403),
    [anon_sym_select] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_if_token3] = ACTIONS(3405),
    [aux_sym_preproc_else_token1] = ACTIONS(3405),
    [aux_sym_preproc_elif_token1] = ACTIONS(3405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2855] = {
    [sym_preproc_region] = STATE(2855),
    [sym_preproc_endregion] = STATE(2855),
    [sym_preproc_line] = STATE(2855),
    [sym_preproc_pragma] = STATE(2855),
    [sym_preproc_nullable] = STATE(2855),
    [sym_preproc_error] = STATE(2855),
    [sym_preproc_warning] = STATE(2855),
    [sym_preproc_define] = STATE(2855),
    [sym_preproc_undef] = STATE(2855),
    [sym__identifier_token] = ACTIONS(4026),
    [anon_sym_alias] = ACTIONS(4026),
    [anon_sym_global] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_file] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_where] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_notnull] = ACTIONS(4026),
    [anon_sym_unmanaged] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4423),
    [anon_sym_scoped] = ACTIONS(4026),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [anon_sym_switch] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(4026),
    [sym_discard] = ACTIONS(4026),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4026),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4026),
    [anon_sym_into] = ACTIONS(4026),
    [anon_sym_join] = ACTIONS(4026),
    [anon_sym_on] = ACTIONS(4026),
    [anon_sym_equals] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_orderby] = ACTIONS(4026),
    [anon_sym_ascending] = ACTIONS(4026),
    [anon_sym_descending] = ACTIONS(4026),
    [anon_sym_group] = ACTIONS(4026),
    [anon_sym_by] = ACTIONS(4026),
    [anon_sym_select] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4026),
    [anon_sym_is] = ACTIONS(4026),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4026),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4028),
  },
  [2856] = {
    [sym_preproc_region] = STATE(2856),
    [sym_preproc_endregion] = STATE(2856),
    [sym_preproc_line] = STATE(2856),
    [sym_preproc_pragma] = STATE(2856),
    [sym_preproc_nullable] = STATE(2856),
    [sym_preproc_error] = STATE(2856),
    [sym_preproc_warning] = STATE(2856),
    [sym_preproc_define] = STATE(2856),
    [sym_preproc_undef] = STATE(2856),
    [sym__identifier_token] = ACTIONS(4026),
    [anon_sym_alias] = ACTIONS(4026),
    [anon_sym_global] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_file] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_where] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_notnull] = ACTIONS(4026),
    [anon_sym_unmanaged] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_scoped] = ACTIONS(4026),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [anon_sym_switch] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(4026),
    [sym_discard] = ACTIONS(4026),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4026),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4026),
    [anon_sym_into] = ACTIONS(4026),
    [anon_sym_join] = ACTIONS(4026),
    [anon_sym_on] = ACTIONS(4026),
    [anon_sym_equals] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_orderby] = ACTIONS(4026),
    [anon_sym_ascending] = ACTIONS(4026),
    [anon_sym_descending] = ACTIONS(4026),
    [anon_sym_group] = ACTIONS(4026),
    [anon_sym_by] = ACTIONS(4026),
    [anon_sym_select] = ACTIONS(4026),
    [anon_sym_as] = ACTIONS(4026),
    [anon_sym_is] = ACTIONS(4026),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4026),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4028),
  },
  [2857] = {
    [sym_preproc_region] = STATE(2857),
    [sym_preproc_endregion] = STATE(2857),
    [sym_preproc_line] = STATE(2857),
    [sym_preproc_pragma] = STATE(2857),
    [sym_preproc_nullable] = STATE(2857),
    [sym_preproc_error] = STATE(2857),
    [sym_preproc_warning] = STATE(2857),
    [sym_preproc_define] = STATE(2857),
    [sym_preproc_undef] = STATE(2857),
    [sym__identifier_token] = ACTIONS(4034),
    [anon_sym_alias] = ACTIONS(4034),
    [anon_sym_global] = ACTIONS(4034),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_file] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_where] = ACTIONS(4034),
    [anon_sym_QMARK] = ACTIONS(4034),
    [anon_sym_notnull] = ACTIONS(4034),
    [anon_sym_unmanaged] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_scoped] = ACTIONS(4034),
    [anon_sym_var] = ACTIONS(4034),
    [anon_sym_yield] = ACTIONS(4034),
    [anon_sym_switch] = ACTIONS(4034),
    [anon_sym_when] = ACTIONS(4034),
    [sym_discard] = ACTIONS(4034),
    [anon_sym_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4034),
    [anon_sym_or] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_QMARK_QMARK] = ACTIONS(4036),
    [anon_sym_from] = ACTIONS(4034),
    [anon_sym_into] = ACTIONS(4034),
    [anon_sym_join] = ACTIONS(4034),
    [anon_sym_on] = ACTIONS(4034),
    [anon_sym_equals] = ACTIONS(4034),
    [anon_sym_let] = ACTIONS(4034),
    [anon_sym_orderby] = ACTIONS(4034),
    [anon_sym_ascending] = ACTIONS(4034),
    [anon_sym_descending] = ACTIONS(4034),
    [anon_sym_group] = ACTIONS(4034),
    [anon_sym_by] = ACTIONS(4034),
    [anon_sym_select] = ACTIONS(4034),
    [anon_sym_as] = ACTIONS(4034),
    [anon_sym_is] = ACTIONS(4034),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4034),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4036),
  },
  [2858] = {
    [sym__variable_designation] = STATE(3331),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2858),
    [sym_preproc_endregion] = STATE(2858),
    [sym_preproc_line] = STATE(2858),
    [sym_preproc_pragma] = STATE(2858),
    [sym_preproc_nullable] = STATE(2858),
    [sym_preproc_error] = STATE(2858),
    [sym_preproc_warning] = STATE(2858),
    [sym_preproc_define] = STATE(2858),
    [sym_preproc_undef] = STATE(2858),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3929),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2859] = {
    [sym_preproc_region] = STATE(2859),
    [sym_preproc_endregion] = STATE(2859),
    [sym_preproc_line] = STATE(2859),
    [sym_preproc_pragma] = STATE(2859),
    [sym_preproc_nullable] = STATE(2859),
    [sym_preproc_error] = STATE(2859),
    [sym_preproc_warning] = STATE(2859),
    [sym_preproc_define] = STATE(2859),
    [sym_preproc_undef] = STATE(2859),
    [sym__identifier_token] = ACTIONS(4038),
    [anon_sym_alias] = ACTIONS(4038),
    [anon_sym_global] = ACTIONS(4038),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_where] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_notnull] = ACTIONS(4038),
    [anon_sym_unmanaged] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_GT_GT_GT] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_scoped] = ACTIONS(4038),
    [anon_sym_var] = ACTIONS(4038),
    [anon_sym_yield] = ACTIONS(4038),
    [anon_sym_switch] = ACTIONS(4038),
    [anon_sym_when] = ACTIONS(4038),
    [sym_discard] = ACTIONS(4038),
    [anon_sym_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4038),
    [anon_sym_or] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_QMARK_QMARK] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4038),
    [anon_sym_into] = ACTIONS(4038),
    [anon_sym_join] = ACTIONS(4038),
    [anon_sym_on] = ACTIONS(4038),
    [anon_sym_equals] = ACTIONS(4038),
    [anon_sym_let] = ACTIONS(4038),
    [anon_sym_orderby] = ACTIONS(4038),
    [anon_sym_ascending] = ACTIONS(4038),
    [anon_sym_descending] = ACTIONS(4038),
    [anon_sym_group] = ACTIONS(4038),
    [anon_sym_by] = ACTIONS(4038),
    [anon_sym_select] = ACTIONS(4038),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_is] = ACTIONS(4038),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_with] = ACTIONS(4038),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4040),
  },
  [2860] = {
    [sym_preproc_region] = STATE(2860),
    [sym_preproc_endregion] = STATE(2860),
    [sym_preproc_line] = STATE(2860),
    [sym_preproc_pragma] = STATE(2860),
    [sym_preproc_nullable] = STATE(2860),
    [sym_preproc_error] = STATE(2860),
    [sym_preproc_warning] = STATE(2860),
    [sym_preproc_define] = STATE(2860),
    [sym_preproc_undef] = STATE(2860),
    [sym__identifier_token] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_alias] = ACTIONS(3415),
    [anon_sym_global] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_unsafe] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_event] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_ref] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3415),
    [anon_sym_record] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_file] = ACTIONS(3415),
    [anon_sym_fixed] = ACTIONS(3415),
    [anon_sym_internal] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_partial] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_required] = ACTIONS(3415),
    [anon_sym_sealed] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_notnull] = ACTIONS(3415),
    [anon_sym_unmanaged] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_implicit] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_scoped] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [sym_predefined_type] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_from] = ACTIONS(3415),
    [anon_sym_into] = ACTIONS(3415),
    [anon_sym_join] = ACTIONS(3415),
    [anon_sym_on] = ACTIONS(3415),
    [anon_sym_equals] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_orderby] = ACTIONS(3415),
    [anon_sym_ascending] = ACTIONS(3415),
    [anon_sym_descending] = ACTIONS(3415),
    [anon_sym_group] = ACTIONS(3415),
    [anon_sym_by] = ACTIONS(3415),
    [anon_sym_select] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token3] = ACTIONS(3417),
    [aux_sym_preproc_else_token1] = ACTIONS(3417),
    [aux_sym_preproc_elif_token1] = ACTIONS(3417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2861] = {
    [sym__variable_designation] = STATE(3268),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2861),
    [sym_preproc_endregion] = STATE(2861),
    [sym_preproc_line] = STATE(2861),
    [sym_preproc_pragma] = STATE(2861),
    [sym_preproc_nullable] = STATE(2861),
    [sym_preproc_error] = STATE(2861),
    [sym_preproc_warning] = STATE(2861),
    [sym_preproc_define] = STATE(2861),
    [sym_preproc_undef] = STATE(2861),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3933),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2862] = {
    [sym__variable_designation] = STATE(3282),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2862),
    [sym_preproc_endregion] = STATE(2862),
    [sym_preproc_line] = STATE(2862),
    [sym_preproc_pragma] = STATE(2862),
    [sym_preproc_nullable] = STATE(2862),
    [sym_preproc_error] = STATE(2862),
    [sym_preproc_warning] = STATE(2862),
    [sym_preproc_define] = STATE(2862),
    [sym_preproc_undef] = STATE(2862),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3999),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2863] = {
    [sym__variable_designation] = STATE(3297),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2863),
    [sym_preproc_endregion] = STATE(2863),
    [sym_preproc_line] = STATE(2863),
    [sym_preproc_pragma] = STATE(2863),
    [sym_preproc_nullable] = STATE(2863),
    [sym_preproc_error] = STATE(2863),
    [sym_preproc_warning] = STATE(2863),
    [sym_preproc_define] = STATE(2863),
    [sym_preproc_undef] = STATE(2863),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(4003),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2864] = {
    [sym_preproc_region] = STATE(2864),
    [sym_preproc_endregion] = STATE(2864),
    [sym_preproc_line] = STATE(2864),
    [sym_preproc_pragma] = STATE(2864),
    [sym_preproc_nullable] = STATE(2864),
    [sym_preproc_error] = STATE(2864),
    [sym_preproc_warning] = STATE(2864),
    [sym_preproc_define] = STATE(2864),
    [sym_preproc_undef] = STATE(2864),
    [sym__identifier_token] = ACTIONS(4695),
    [anon_sym_extern] = ACTIONS(4695),
    [anon_sym_alias] = ACTIONS(4695),
    [anon_sym_global] = ACTIONS(4695),
    [anon_sym_using] = ACTIONS(4695),
    [anon_sym_unsafe] = ACTIONS(4695),
    [anon_sym_static] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [anon_sym_event] = ACTIONS(4695),
    [anon_sym_namespace] = ACTIONS(4695),
    [anon_sym_class] = ACTIONS(4695),
    [anon_sym_ref] = ACTIONS(4695),
    [anon_sym_struct] = ACTIONS(4695),
    [anon_sym_enum] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_interface] = ACTIONS(4695),
    [anon_sym_delegate] = ACTIONS(4695),
    [anon_sym_record] = ACTIONS(4695),
    [anon_sym_abstract] = ACTIONS(4695),
    [anon_sym_async] = ACTIONS(4695),
    [anon_sym_const] = ACTIONS(4695),
    [anon_sym_file] = ACTIONS(4695),
    [anon_sym_fixed] = ACTIONS(4695),
    [anon_sym_internal] = ACTIONS(4695),
    [anon_sym_new] = ACTIONS(4695),
    [anon_sym_override] = ACTIONS(4695),
    [anon_sym_partial] = ACTIONS(4695),
    [anon_sym_private] = ACTIONS(4695),
    [anon_sym_protected] = ACTIONS(4695),
    [anon_sym_public] = ACTIONS(4695),
    [anon_sym_readonly] = ACTIONS(4695),
    [anon_sym_required] = ACTIONS(4695),
    [anon_sym_sealed] = ACTIONS(4695),
    [anon_sym_virtual] = ACTIONS(4695),
    [anon_sym_volatile] = ACTIONS(4695),
    [anon_sym_where] = ACTIONS(4695),
    [anon_sym_notnull] = ACTIONS(4695),
    [anon_sym_unmanaged] = ACTIONS(4695),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_implicit] = ACTIONS(4695),
    [anon_sym_explicit] = ACTIONS(4695),
    [anon_sym_scoped] = ACTIONS(4695),
    [anon_sym_var] = ACTIONS(4695),
    [sym_predefined_type] = ACTIONS(4695),
    [anon_sym_yield] = ACTIONS(4695),
    [anon_sym_when] = ACTIONS(4695),
    [anon_sym_from] = ACTIONS(4695),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_join] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_orderby] = ACTIONS(4695),
    [anon_sym_ascending] = ACTIONS(4695),
    [anon_sym_descending] = ACTIONS(4695),
    [anon_sym_group] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [aux_sym_preproc_if_token1] = ACTIONS(4697),
    [aux_sym_preproc_if_token3] = ACTIONS(4697),
    [aux_sym_preproc_else_token1] = ACTIONS(4697),
    [aux_sym_preproc_elif_token1] = ACTIONS(4697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2865] = {
    [sym_preproc_region] = STATE(2865),
    [sym_preproc_endregion] = STATE(2865),
    [sym_preproc_line] = STATE(2865),
    [sym_preproc_pragma] = STATE(2865),
    [sym_preproc_nullable] = STATE(2865),
    [sym_preproc_error] = STATE(2865),
    [sym_preproc_warning] = STATE(2865),
    [sym_preproc_define] = STATE(2865),
    [sym_preproc_undef] = STATE(2865),
    [sym__identifier_token] = ACTIONS(4018),
    [anon_sym_alias] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_file] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_where] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_notnull] = ACTIONS(4018),
    [anon_sym_unmanaged] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_scoped] = ACTIONS(4018),
    [anon_sym_var] = ACTIONS(4018),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_when] = ACTIONS(4018),
    [sym_discard] = ACTIONS(4018),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_QMARK_QMARK] = ACTIONS(4020),
    [anon_sym_from] = ACTIONS(4018),
    [anon_sym_into] = ACTIONS(4018),
    [anon_sym_join] = ACTIONS(4018),
    [anon_sym_on] = ACTIONS(4018),
    [anon_sym_equals] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_orderby] = ACTIONS(4018),
    [anon_sym_ascending] = ACTIONS(4018),
    [anon_sym_descending] = ACTIONS(4018),
    [anon_sym_group] = ACTIONS(4018),
    [anon_sym_by] = ACTIONS(4018),
    [anon_sym_select] = ACTIONS(4018),
    [anon_sym_as] = ACTIONS(4018),
    [anon_sym_is] = ACTIONS(4018),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_with] = ACTIONS(4018),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4020),
  },
  [2866] = {
    [sym_preproc_region] = STATE(2866),
    [sym_preproc_endregion] = STATE(2866),
    [sym_preproc_line] = STATE(2866),
    [sym_preproc_pragma] = STATE(2866),
    [sym_preproc_nullable] = STATE(2866),
    [sym_preproc_error] = STATE(2866),
    [sym_preproc_warning] = STATE(2866),
    [sym_preproc_define] = STATE(2866),
    [sym_preproc_undef] = STATE(2866),
    [sym__identifier_token] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym_alias] = ACTIONS(4699),
    [anon_sym_global] = ACTIONS(4699),
    [anon_sym_using] = ACTIONS(4699),
    [anon_sym_unsafe] = ACTIONS(4699),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_LBRACK] = ACTIONS(4701),
    [anon_sym_LPAREN] = ACTIONS(4701),
    [anon_sym_event] = ACTIONS(4699),
    [anon_sym_namespace] = ACTIONS(4699),
    [anon_sym_class] = ACTIONS(4699),
    [anon_sym_ref] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_RBRACE] = ACTIONS(4701),
    [anon_sym_interface] = ACTIONS(4699),
    [anon_sym_delegate] = ACTIONS(4699),
    [anon_sym_record] = ACTIONS(4699),
    [anon_sym_abstract] = ACTIONS(4699),
    [anon_sym_async] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_file] = ACTIONS(4699),
    [anon_sym_fixed] = ACTIONS(4699),
    [anon_sym_internal] = ACTIONS(4699),
    [anon_sym_new] = ACTIONS(4699),
    [anon_sym_override] = ACTIONS(4699),
    [anon_sym_partial] = ACTIONS(4699),
    [anon_sym_private] = ACTIONS(4699),
    [anon_sym_protected] = ACTIONS(4699),
    [anon_sym_public] = ACTIONS(4699),
    [anon_sym_readonly] = ACTIONS(4699),
    [anon_sym_required] = ACTIONS(4699),
    [anon_sym_sealed] = ACTIONS(4699),
    [anon_sym_virtual] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym_where] = ACTIONS(4699),
    [anon_sym_notnull] = ACTIONS(4699),
    [anon_sym_unmanaged] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_implicit] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_scoped] = ACTIONS(4699),
    [anon_sym_var] = ACTIONS(4699),
    [sym_predefined_type] = ACTIONS(4699),
    [anon_sym_yield] = ACTIONS(4699),
    [anon_sym_when] = ACTIONS(4699),
    [anon_sym_from] = ACTIONS(4699),
    [anon_sym_into] = ACTIONS(4699),
    [anon_sym_join] = ACTIONS(4699),
    [anon_sym_on] = ACTIONS(4699),
    [anon_sym_equals] = ACTIONS(4699),
    [anon_sym_let] = ACTIONS(4699),
    [anon_sym_orderby] = ACTIONS(4699),
    [anon_sym_ascending] = ACTIONS(4699),
    [anon_sym_descending] = ACTIONS(4699),
    [anon_sym_group] = ACTIONS(4699),
    [anon_sym_by] = ACTIONS(4699),
    [anon_sym_select] = ACTIONS(4699),
    [aux_sym_preproc_if_token1] = ACTIONS(4701),
    [aux_sym_preproc_if_token3] = ACTIONS(4701),
    [aux_sym_preproc_else_token1] = ACTIONS(4701),
    [aux_sym_preproc_elif_token1] = ACTIONS(4701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2867] = {
    [sym_preproc_region] = STATE(2867),
    [sym_preproc_endregion] = STATE(2867),
    [sym_preproc_line] = STATE(2867),
    [sym_preproc_pragma] = STATE(2867),
    [sym_preproc_nullable] = STATE(2867),
    [sym_preproc_error] = STATE(2867),
    [sym_preproc_warning] = STATE(2867),
    [sym_preproc_define] = STATE(2867),
    [sym_preproc_undef] = STATE(2867),
    [sym__identifier_token] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym_alias] = ACTIONS(4703),
    [anon_sym_global] = ACTIONS(4703),
    [anon_sym_using] = ACTIONS(4703),
    [anon_sym_unsafe] = ACTIONS(4703),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_event] = ACTIONS(4703),
    [anon_sym_namespace] = ACTIONS(4703),
    [anon_sym_class] = ACTIONS(4703),
    [anon_sym_ref] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_interface] = ACTIONS(4703),
    [anon_sym_delegate] = ACTIONS(4703),
    [anon_sym_record] = ACTIONS(4703),
    [anon_sym_abstract] = ACTIONS(4703),
    [anon_sym_async] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_file] = ACTIONS(4703),
    [anon_sym_fixed] = ACTIONS(4703),
    [anon_sym_internal] = ACTIONS(4703),
    [anon_sym_new] = ACTIONS(4703),
    [anon_sym_override] = ACTIONS(4703),
    [anon_sym_partial] = ACTIONS(4703),
    [anon_sym_private] = ACTIONS(4703),
    [anon_sym_protected] = ACTIONS(4703),
    [anon_sym_public] = ACTIONS(4703),
    [anon_sym_readonly] = ACTIONS(4703),
    [anon_sym_required] = ACTIONS(4703),
    [anon_sym_sealed] = ACTIONS(4703),
    [anon_sym_virtual] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym_where] = ACTIONS(4703),
    [anon_sym_notnull] = ACTIONS(4703),
    [anon_sym_unmanaged] = ACTIONS(4703),
    [anon_sym_TILDE] = ACTIONS(4705),
    [anon_sym_implicit] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_scoped] = ACTIONS(4703),
    [anon_sym_var] = ACTIONS(4703),
    [sym_predefined_type] = ACTIONS(4703),
    [anon_sym_yield] = ACTIONS(4703),
    [anon_sym_when] = ACTIONS(4703),
    [anon_sym_from] = ACTIONS(4703),
    [anon_sym_into] = ACTIONS(4703),
    [anon_sym_join] = ACTIONS(4703),
    [anon_sym_on] = ACTIONS(4703),
    [anon_sym_equals] = ACTIONS(4703),
    [anon_sym_let] = ACTIONS(4703),
    [anon_sym_orderby] = ACTIONS(4703),
    [anon_sym_ascending] = ACTIONS(4703),
    [anon_sym_descending] = ACTIONS(4703),
    [anon_sym_group] = ACTIONS(4703),
    [anon_sym_by] = ACTIONS(4703),
    [anon_sym_select] = ACTIONS(4703),
    [aux_sym_preproc_if_token1] = ACTIONS(4705),
    [aux_sym_preproc_if_token3] = ACTIONS(4705),
    [aux_sym_preproc_else_token1] = ACTIONS(4705),
    [aux_sym_preproc_elif_token1] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2868] = {
    [sym_preproc_region] = STATE(2868),
    [sym_preproc_endregion] = STATE(2868),
    [sym_preproc_line] = STATE(2868),
    [sym_preproc_pragma] = STATE(2868),
    [sym_preproc_nullable] = STATE(2868),
    [sym_preproc_error] = STATE(2868),
    [sym_preproc_warning] = STATE(2868),
    [sym_preproc_define] = STATE(2868),
    [sym_preproc_undef] = STATE(2868),
    [sym__identifier_token] = ACTIONS(4707),
    [anon_sym_extern] = ACTIONS(4707),
    [anon_sym_alias] = ACTIONS(4707),
    [anon_sym_global] = ACTIONS(4707),
    [anon_sym_using] = ACTIONS(4707),
    [anon_sym_unsafe] = ACTIONS(4707),
    [anon_sym_static] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_event] = ACTIONS(4707),
    [anon_sym_namespace] = ACTIONS(4707),
    [anon_sym_class] = ACTIONS(4707),
    [anon_sym_ref] = ACTIONS(4707),
    [anon_sym_struct] = ACTIONS(4707),
    [anon_sym_enum] = ACTIONS(4707),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_interface] = ACTIONS(4707),
    [anon_sym_delegate] = ACTIONS(4707),
    [anon_sym_record] = ACTIONS(4707),
    [anon_sym_abstract] = ACTIONS(4707),
    [anon_sym_async] = ACTIONS(4707),
    [anon_sym_const] = ACTIONS(4707),
    [anon_sym_file] = ACTIONS(4707),
    [anon_sym_fixed] = ACTIONS(4707),
    [anon_sym_internal] = ACTIONS(4707),
    [anon_sym_new] = ACTIONS(4707),
    [anon_sym_override] = ACTIONS(4707),
    [anon_sym_partial] = ACTIONS(4707),
    [anon_sym_private] = ACTIONS(4707),
    [anon_sym_protected] = ACTIONS(4707),
    [anon_sym_public] = ACTIONS(4707),
    [anon_sym_readonly] = ACTIONS(4707),
    [anon_sym_required] = ACTIONS(4707),
    [anon_sym_sealed] = ACTIONS(4707),
    [anon_sym_virtual] = ACTIONS(4707),
    [anon_sym_volatile] = ACTIONS(4707),
    [anon_sym_where] = ACTIONS(4707),
    [anon_sym_notnull] = ACTIONS(4707),
    [anon_sym_unmanaged] = ACTIONS(4707),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_implicit] = ACTIONS(4707),
    [anon_sym_explicit] = ACTIONS(4707),
    [anon_sym_scoped] = ACTIONS(4707),
    [anon_sym_var] = ACTIONS(4707),
    [sym_predefined_type] = ACTIONS(4707),
    [anon_sym_yield] = ACTIONS(4707),
    [anon_sym_when] = ACTIONS(4707),
    [anon_sym_from] = ACTIONS(4707),
    [anon_sym_into] = ACTIONS(4707),
    [anon_sym_join] = ACTIONS(4707),
    [anon_sym_on] = ACTIONS(4707),
    [anon_sym_equals] = ACTIONS(4707),
    [anon_sym_let] = ACTIONS(4707),
    [anon_sym_orderby] = ACTIONS(4707),
    [anon_sym_ascending] = ACTIONS(4707),
    [anon_sym_descending] = ACTIONS(4707),
    [anon_sym_group] = ACTIONS(4707),
    [anon_sym_by] = ACTIONS(4707),
    [anon_sym_select] = ACTIONS(4707),
    [aux_sym_preproc_if_token1] = ACTIONS(4709),
    [aux_sym_preproc_if_token3] = ACTIONS(4709),
    [aux_sym_preproc_else_token1] = ACTIONS(4709),
    [aux_sym_preproc_elif_token1] = ACTIONS(4709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2869] = {
    [sym_preproc_region] = STATE(2869),
    [sym_preproc_endregion] = STATE(2869),
    [sym_preproc_line] = STATE(2869),
    [sym_preproc_pragma] = STATE(2869),
    [sym_preproc_nullable] = STATE(2869),
    [sym_preproc_error] = STATE(2869),
    [sym_preproc_warning] = STATE(2869),
    [sym_preproc_define] = STATE(2869),
    [sym_preproc_undef] = STATE(2869),
    [sym__identifier_token] = ACTIONS(4711),
    [anon_sym_extern] = ACTIONS(4711),
    [anon_sym_alias] = ACTIONS(4711),
    [anon_sym_global] = ACTIONS(4711),
    [anon_sym_using] = ACTIONS(4711),
    [anon_sym_unsafe] = ACTIONS(4711),
    [anon_sym_static] = ACTIONS(4711),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_event] = ACTIONS(4711),
    [anon_sym_namespace] = ACTIONS(4711),
    [anon_sym_class] = ACTIONS(4711),
    [anon_sym_ref] = ACTIONS(4711),
    [anon_sym_struct] = ACTIONS(4711),
    [anon_sym_enum] = ACTIONS(4711),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_interface] = ACTIONS(4711),
    [anon_sym_delegate] = ACTIONS(4711),
    [anon_sym_record] = ACTIONS(4711),
    [anon_sym_abstract] = ACTIONS(4711),
    [anon_sym_async] = ACTIONS(4711),
    [anon_sym_const] = ACTIONS(4711),
    [anon_sym_file] = ACTIONS(4711),
    [anon_sym_fixed] = ACTIONS(4711),
    [anon_sym_internal] = ACTIONS(4711),
    [anon_sym_new] = ACTIONS(4711),
    [anon_sym_override] = ACTIONS(4711),
    [anon_sym_partial] = ACTIONS(4711),
    [anon_sym_private] = ACTIONS(4711),
    [anon_sym_protected] = ACTIONS(4711),
    [anon_sym_public] = ACTIONS(4711),
    [anon_sym_readonly] = ACTIONS(4711),
    [anon_sym_required] = ACTIONS(4711),
    [anon_sym_sealed] = ACTIONS(4711),
    [anon_sym_virtual] = ACTIONS(4711),
    [anon_sym_volatile] = ACTIONS(4711),
    [anon_sym_where] = ACTIONS(4711),
    [anon_sym_notnull] = ACTIONS(4711),
    [anon_sym_unmanaged] = ACTIONS(4711),
    [anon_sym_TILDE] = ACTIONS(4713),
    [anon_sym_implicit] = ACTIONS(4711),
    [anon_sym_explicit] = ACTIONS(4711),
    [anon_sym_scoped] = ACTIONS(4711),
    [anon_sym_var] = ACTIONS(4711),
    [sym_predefined_type] = ACTIONS(4711),
    [anon_sym_yield] = ACTIONS(4711),
    [anon_sym_when] = ACTIONS(4711),
    [anon_sym_from] = ACTIONS(4711),
    [anon_sym_into] = ACTIONS(4711),
    [anon_sym_join] = ACTIONS(4711),
    [anon_sym_on] = ACTIONS(4711),
    [anon_sym_equals] = ACTIONS(4711),
    [anon_sym_let] = ACTIONS(4711),
    [anon_sym_orderby] = ACTIONS(4711),
    [anon_sym_ascending] = ACTIONS(4711),
    [anon_sym_descending] = ACTIONS(4711),
    [anon_sym_group] = ACTIONS(4711),
    [anon_sym_by] = ACTIONS(4711),
    [anon_sym_select] = ACTIONS(4711),
    [aux_sym_preproc_if_token1] = ACTIONS(4713),
    [aux_sym_preproc_if_token3] = ACTIONS(4713),
    [aux_sym_preproc_else_token1] = ACTIONS(4713),
    [aux_sym_preproc_elif_token1] = ACTIONS(4713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2870] = {
    [sym_preproc_region] = STATE(2870),
    [sym_preproc_endregion] = STATE(2870),
    [sym_preproc_line] = STATE(2870),
    [sym_preproc_pragma] = STATE(2870),
    [sym_preproc_nullable] = STATE(2870),
    [sym_preproc_error] = STATE(2870),
    [sym_preproc_warning] = STATE(2870),
    [sym_preproc_define] = STATE(2870),
    [sym_preproc_undef] = STATE(2870),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3668),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3666),
    [anon_sym_CARET] = ACTIONS(3666),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3666),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3666),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_when] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3668),
    [anon_sym_PLUS_EQ] = ACTIONS(3668),
    [anon_sym_DASH_EQ] = ACTIONS(3668),
    [anon_sym_STAR_EQ] = ACTIONS(3668),
    [anon_sym_SLASH_EQ] = ACTIONS(3668),
    [anon_sym_PERCENT_EQ] = ACTIONS(3668),
    [anon_sym_AMP_EQ] = ACTIONS(3668),
    [anon_sym_CARET_EQ] = ACTIONS(3668),
    [anon_sym_PIPE_EQ] = ACTIONS(3668),
    [anon_sym_LT_LT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3666),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2871] = {
    [sym_preproc_region] = STATE(2871),
    [sym_preproc_endregion] = STATE(2871),
    [sym_preproc_line] = STATE(2871),
    [sym_preproc_pragma] = STATE(2871),
    [sym_preproc_nullable] = STATE(2871),
    [sym_preproc_error] = STATE(2871),
    [sym_preproc_warning] = STATE(2871),
    [sym_preproc_define] = STATE(2871),
    [sym_preproc_undef] = STATE(2871),
    [sym__identifier_token] = ACTIONS(3947),
    [anon_sym_alias] = ACTIONS(3947),
    [anon_sym_global] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_where] = ACTIONS(3947),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_notnull] = ACTIONS(3947),
    [anon_sym_unmanaged] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_scoped] = ACTIONS(3947),
    [anon_sym_var] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_when] = ACTIONS(3947),
    [sym_discard] = ACTIONS(3947),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3947),
    [anon_sym_into] = ACTIONS(3947),
    [anon_sym_join] = ACTIONS(3947),
    [anon_sym_on] = ACTIONS(3947),
    [anon_sym_equals] = ACTIONS(3947),
    [anon_sym_let] = ACTIONS(3947),
    [anon_sym_orderby] = ACTIONS(3947),
    [anon_sym_ascending] = ACTIONS(3947),
    [anon_sym_descending] = ACTIONS(3947),
    [anon_sym_group] = ACTIONS(3947),
    [anon_sym_by] = ACTIONS(3947),
    [anon_sym_select] = ACTIONS(3947),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_is] = ACTIONS(3947),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3949),
  },
  [2872] = {
    [sym_preproc_region] = STATE(2872),
    [sym_preproc_endregion] = STATE(2872),
    [sym_preproc_line] = STATE(2872),
    [sym_preproc_pragma] = STATE(2872),
    [sym_preproc_nullable] = STATE(2872),
    [sym_preproc_error] = STATE(2872),
    [sym_preproc_warning] = STATE(2872),
    [sym_preproc_define] = STATE(2872),
    [sym_preproc_undef] = STATE(2872),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_event] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(2977),
    [anon_sym_struct] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_delegate] = ACTIONS(2977),
    [anon_sym_record] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_implicit] = ACTIONS(2977),
    [anon_sym_explicit] = ACTIONS(2977),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [sym_predefined_type] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2873] = {
    [sym__variable_designation] = STATE(3331),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2873),
    [sym_preproc_endregion] = STATE(2873),
    [sym_preproc_line] = STATE(2873),
    [sym_preproc_pragma] = STATE(2873),
    [sym_preproc_nullable] = STATE(2873),
    [sym_preproc_error] = STATE(2873),
    [sym_preproc_warning] = STATE(2873),
    [sym_preproc_define] = STATE(2873),
    [sym_preproc_undef] = STATE(2873),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2874] = {
    [sym__variable_designation] = STATE(3268),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2874),
    [sym_preproc_endregion] = STATE(2874),
    [sym_preproc_line] = STATE(2874),
    [sym_preproc_pragma] = STATE(2874),
    [sym_preproc_nullable] = STATE(2874),
    [sym_preproc_error] = STATE(2874),
    [sym_preproc_warning] = STATE(2874),
    [sym_preproc_define] = STATE(2874),
    [sym_preproc_undef] = STATE(2874),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2875] = {
    [sym__variable_designation] = STATE(3282),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2875),
    [sym_preproc_endregion] = STATE(2875),
    [sym_preproc_line] = STATE(2875),
    [sym_preproc_pragma] = STATE(2875),
    [sym_preproc_nullable] = STATE(2875),
    [sym_preproc_error] = STATE(2875),
    [sym_preproc_warning] = STATE(2875),
    [sym_preproc_define] = STATE(2875),
    [sym_preproc_undef] = STATE(2875),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(3999),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2876] = {
    [sym__variable_designation] = STATE(3297),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2876),
    [sym_preproc_endregion] = STATE(2876),
    [sym_preproc_line] = STATE(2876),
    [sym_preproc_pragma] = STATE(2876),
    [sym_preproc_nullable] = STATE(2876),
    [sym_preproc_error] = STATE(2876),
    [sym_preproc_warning] = STATE(2876),
    [sym_preproc_define] = STATE(2876),
    [sym_preproc_undef] = STATE(2876),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3899),
    [anon_sym_equals] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2877] = {
    [sym_preproc_region] = STATE(2877),
    [sym_preproc_endregion] = STATE(2877),
    [sym_preproc_line] = STATE(2877),
    [sym_preproc_pragma] = STATE(2877),
    [sym_preproc_nullable] = STATE(2877),
    [sym_preproc_error] = STATE(2877),
    [sym_preproc_warning] = STATE(2877),
    [sym_preproc_define] = STATE(2877),
    [sym_preproc_undef] = STATE(2877),
    [sym__identifier_token] = ACTIONS(4042),
    [anon_sym_alias] = ACTIONS(4042),
    [anon_sym_global] = ACTIONS(4042),
    [anon_sym_LBRACK] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_file] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_where] = ACTIONS(4042),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_notnull] = ACTIONS(4042),
    [anon_sym_unmanaged] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_scoped] = ACTIONS(4042),
    [anon_sym_var] = ACTIONS(4042),
    [anon_sym_yield] = ACTIONS(4042),
    [anon_sym_switch] = ACTIONS(4042),
    [anon_sym_when] = ACTIONS(4042),
    [sym_discard] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4042),
    [anon_sym_or] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_QMARK_QMARK] = ACTIONS(4044),
    [anon_sym_from] = ACTIONS(4042),
    [anon_sym_into] = ACTIONS(4042),
    [anon_sym_join] = ACTIONS(4042),
    [anon_sym_on] = ACTIONS(4042),
    [anon_sym_equals] = ACTIONS(4042),
    [anon_sym_let] = ACTIONS(4042),
    [anon_sym_orderby] = ACTIONS(4042),
    [anon_sym_ascending] = ACTIONS(4042),
    [anon_sym_descending] = ACTIONS(4042),
    [anon_sym_group] = ACTIONS(4042),
    [anon_sym_by] = ACTIONS(4042),
    [anon_sym_select] = ACTIONS(4042),
    [anon_sym_as] = ACTIONS(4042),
    [anon_sym_is] = ACTIONS(4042),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_with] = ACTIONS(4042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4044),
  },
  [2878] = {
    [sym__variable_designation] = STATE(3331),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2878),
    [sym_preproc_endregion] = STATE(2878),
    [sym_preproc_line] = STATE(2878),
    [sym_preproc_pragma] = STATE(2878),
    [sym_preproc_nullable] = STATE(2878),
    [sym_preproc_error] = STATE(2878),
    [sym_preproc_warning] = STATE(2878),
    [sym_preproc_define] = STATE(2878),
    [sym_preproc_undef] = STATE(2878),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_GT_GT_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3929),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_QMARK_QMARK] = ACTIONS(3927),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3929),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3929),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_is] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2879] = {
    [sym__variable_designation] = STATE(3268),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2879),
    [sym_preproc_endregion] = STATE(2879),
    [sym_preproc_line] = STATE(2879),
    [sym_preproc_pragma] = STATE(2879),
    [sym_preproc_nullable] = STATE(2879),
    [sym_preproc_error] = STATE(2879),
    [sym_preproc_warning] = STATE(2879),
    [sym_preproc_define] = STATE(2879),
    [sym_preproc_undef] = STATE(2879),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3933),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_QMARK_QMARK] = ACTIONS(3931),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3933),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3933),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_is] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2880] = {
    [sym__variable_designation] = STATE(3282),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2880),
    [sym_preproc_endregion] = STATE(2880),
    [sym_preproc_line] = STATE(2880),
    [sym_preproc_pragma] = STATE(2880),
    [sym_preproc_nullable] = STATE(2880),
    [sym_preproc_error] = STATE(2880),
    [sym_preproc_warning] = STATE(2880),
    [sym_preproc_define] = STATE(2880),
    [sym_preproc_undef] = STATE(2880),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(3999),
    [anon_sym_GT] = ACTIONS(3999),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3999),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3999),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS] = ACTIONS(3999),
    [anon_sym_DASH] = ACTIONS(3999),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3999),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3999),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3999),
    [anon_sym_GT_GT_GT] = ACTIONS(3997),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3999),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(3999),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3999),
    [anon_sym_or] = ACTIONS(3999),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_QMARK_QMARK] = ACTIONS(3997),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(3999),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(3999),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3999),
    [anon_sym_is] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [anon_sym_with] = ACTIONS(3999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2881] = {
    [sym__variable_designation] = STATE(3297),
    [sym_parenthesized_variable_designation] = STATE(3381),
    [sym_identifier] = STATE(3341),
    [sym__reserved_identifier] = STATE(3241),
    [sym_preproc_region] = STATE(2881),
    [sym_preproc_endregion] = STATE(2881),
    [sym_preproc_line] = STATE(2881),
    [sym_preproc_pragma] = STATE(2881),
    [sym_preproc_nullable] = STATE(2881),
    [sym_preproc_error] = STATE(2881),
    [sym_preproc_warning] = STATE(2881),
    [sym_preproc_define] = STATE(2881),
    [sym_preproc_undef] = STATE(2881),
    [sym__identifier_token] = ACTIONS(3897),
    [anon_sym_alias] = ACTIONS(3899),
    [anon_sym_global] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_file] = ACTIONS(3899),
    [anon_sym_LT] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_where] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_notnull] = ACTIONS(3899),
    [anon_sym_unmanaged] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(4003),
    [anon_sym_PLUS_PLUS] = ACTIONS(4001),
    [anon_sym_DASH_DASH] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_CARET] = ACTIONS(4001),
    [anon_sym_PIPE] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LT_LT] = ACTIONS(4001),
    [anon_sym_GT_GT] = ACTIONS(4003),
    [anon_sym_GT_GT_GT] = ACTIONS(4001),
    [anon_sym_EQ_EQ] = ACTIONS(4001),
    [anon_sym_BANG_EQ] = ACTIONS(4001),
    [anon_sym_GT_EQ] = ACTIONS(4001),
    [anon_sym_LT_EQ] = ACTIONS(4001),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_scoped] = ACTIONS(3899),
    [anon_sym_var] = ACTIONS(3899),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_switch] = ACTIONS(4003),
    [anon_sym_when] = ACTIONS(3899),
    [sym_discard] = ACTIONS(3907),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_PIPE_PIPE] = ACTIONS(4001),
    [anon_sym_QMARK_QMARK] = ACTIONS(4001),
    [anon_sym_from] = ACTIONS(3899),
    [anon_sym_into] = ACTIONS(4003),
    [anon_sym_join] = ACTIONS(3899),
    [anon_sym_on] = ACTIONS(4003),
    [anon_sym_equals] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_orderby] = ACTIONS(3899),
    [anon_sym_ascending] = ACTIONS(3899),
    [anon_sym_descending] = ACTIONS(3899),
    [anon_sym_group] = ACTIONS(3899),
    [anon_sym_by] = ACTIONS(3899),
    [anon_sym_select] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_is] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4001),
    [anon_sym_with] = ACTIONS(4003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2882] = {
    [sym_preproc_region] = STATE(2882),
    [sym_preproc_endregion] = STATE(2882),
    [sym_preproc_line] = STATE(2882),
    [sym_preproc_pragma] = STATE(2882),
    [sym_preproc_nullable] = STATE(2882),
    [sym_preproc_error] = STATE(2882),
    [sym_preproc_warning] = STATE(2882),
    [sym_preproc_define] = STATE(2882),
    [sym_preproc_undef] = STATE(2882),
    [sym__identifier_token] = ACTIONS(4715),
    [anon_sym_extern] = ACTIONS(4715),
    [anon_sym_alias] = ACTIONS(4715),
    [anon_sym_global] = ACTIONS(4715),
    [anon_sym_using] = ACTIONS(4715),
    [anon_sym_unsafe] = ACTIONS(4715),
    [anon_sym_static] = ACTIONS(4715),
    [anon_sym_LBRACK] = ACTIONS(4717),
    [anon_sym_LPAREN] = ACTIONS(4717),
    [anon_sym_event] = ACTIONS(4715),
    [anon_sym_namespace] = ACTIONS(4715),
    [anon_sym_class] = ACTIONS(4715),
    [anon_sym_ref] = ACTIONS(4715),
    [anon_sym_struct] = ACTIONS(4715),
    [anon_sym_enum] = ACTIONS(4715),
    [anon_sym_RBRACE] = ACTIONS(4717),
    [anon_sym_interface] = ACTIONS(4715),
    [anon_sym_delegate] = ACTIONS(4715),
    [anon_sym_record] = ACTIONS(4715),
    [anon_sym_abstract] = ACTIONS(4715),
    [anon_sym_async] = ACTIONS(4715),
    [anon_sym_const] = ACTIONS(4715),
    [anon_sym_file] = ACTIONS(4715),
    [anon_sym_fixed] = ACTIONS(4715),
    [anon_sym_internal] = ACTIONS(4715),
    [anon_sym_new] = ACTIONS(4715),
    [anon_sym_override] = ACTIONS(4715),
    [anon_sym_partial] = ACTIONS(4715),
    [anon_sym_private] = ACTIONS(4715),
    [anon_sym_protected] = ACTIONS(4715),
    [anon_sym_public] = ACTIONS(4715),
    [anon_sym_readonly] = ACTIONS(4715),
    [anon_sym_required] = ACTIONS(4715),
    [anon_sym_sealed] = ACTIONS(4715),
    [anon_sym_virtual] = ACTIONS(4715),
    [anon_sym_volatile] = ACTIONS(4715),
    [anon_sym_where] = ACTIONS(4715),
    [anon_sym_notnull] = ACTIONS(4715),
    [anon_sym_unmanaged] = ACTIONS(4715),
    [anon_sym_TILDE] = ACTIONS(4717),
    [anon_sym_implicit] = ACTIONS(4715),
    [anon_sym_explicit] = ACTIONS(4715),
    [anon_sym_scoped] = ACTIONS(4715),
    [anon_sym_var] = ACTIONS(4715),
    [sym_predefined_type] = ACTIONS(4715),
    [anon_sym_yield] = ACTIONS(4715),
    [anon_sym_when] = ACTIONS(4715),
    [anon_sym_from] = ACTIONS(4715),
    [anon_sym_into] = ACTIONS(4715),
    [anon_sym_join] = ACTIONS(4715),
    [anon_sym_on] = ACTIONS(4715),
    [anon_sym_equals] = ACTIONS(4715),
    [anon_sym_let] = ACTIONS(4715),
    [anon_sym_orderby] = ACTIONS(4715),
    [anon_sym_ascending] = ACTIONS(4715),
    [anon_sym_descending] = ACTIONS(4715),
    [anon_sym_group] = ACTIONS(4715),
    [anon_sym_by] = ACTIONS(4715),
    [anon_sym_select] = ACTIONS(4715),
    [aux_sym_preproc_if_token1] = ACTIONS(4717),
    [aux_sym_preproc_if_token3] = ACTIONS(4717),
    [aux_sym_preproc_else_token1] = ACTIONS(4717),
    [aux_sym_preproc_elif_token1] = ACTIONS(4717),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2883] = {
    [sym_preproc_region] = STATE(2883),
    [sym_preproc_endregion] = STATE(2883),
    [sym_preproc_line] = STATE(2883),
    [sym_preproc_pragma] = STATE(2883),
    [sym_preproc_nullable] = STATE(2883),
    [sym_preproc_error] = STATE(2883),
    [sym_preproc_warning] = STATE(2883),
    [sym_preproc_define] = STATE(2883),
    [sym_preproc_undef] = STATE(2883),
    [sym__identifier_token] = ACTIONS(4719),
    [anon_sym_extern] = ACTIONS(4719),
    [anon_sym_alias] = ACTIONS(4719),
    [anon_sym_global] = ACTIONS(4719),
    [anon_sym_using] = ACTIONS(4719),
    [anon_sym_unsafe] = ACTIONS(4719),
    [anon_sym_static] = ACTIONS(4719),
    [anon_sym_LBRACK] = ACTIONS(4721),
    [anon_sym_LPAREN] = ACTIONS(4721),
    [anon_sym_event] = ACTIONS(4719),
    [anon_sym_namespace] = ACTIONS(4719),
    [anon_sym_class] = ACTIONS(4719),
    [anon_sym_ref] = ACTIONS(4719),
    [anon_sym_struct] = ACTIONS(4719),
    [anon_sym_enum] = ACTIONS(4719),
    [anon_sym_RBRACE] = ACTIONS(4721),
    [anon_sym_interface] = ACTIONS(4719),
    [anon_sym_delegate] = ACTIONS(4719),
    [anon_sym_record] = ACTIONS(4719),
    [anon_sym_abstract] = ACTIONS(4719),
    [anon_sym_async] = ACTIONS(4719),
    [anon_sym_const] = ACTIONS(4719),
    [anon_sym_file] = ACTIONS(4719),
    [anon_sym_fixed] = ACTIONS(4719),
    [anon_sym_internal] = ACTIONS(4719),
    [anon_sym_new] = ACTIONS(4719),
    [anon_sym_override] = ACTIONS(4719),
    [anon_sym_partial] = ACTIONS(4719),
    [anon_sym_private] = ACTIONS(4719),
    [anon_sym_protected] = ACTIONS(4719),
    [anon_sym_public] = ACTIONS(4719),
    [anon_sym_readonly] = ACTIONS(4719),
    [anon_sym_required] = ACTIONS(4719),
    [anon_sym_sealed] = ACTIONS(4719),
    [anon_sym_virtual] = ACTIONS(4719),
    [anon_sym_volatile] = ACTIONS(4719),
    [anon_sym_where] = ACTIONS(4719),
    [anon_sym_notnull] = ACTIONS(4719),
    [anon_sym_unmanaged] = ACTIONS(4719),
    [anon_sym_TILDE] = ACTIONS(4721),
    [anon_sym_implicit] = ACTIONS(4719),
    [anon_sym_explicit] = ACTIONS(4719),
    [anon_sym_scoped] = ACTIONS(4719),
    [anon_sym_var] = ACTIONS(4719),
    [sym_predefined_type] = ACTIONS(4719),
    [anon_sym_yield] = ACTIONS(4719),
    [anon_sym_when] = ACTIONS(4719),
    [anon_sym_from] = ACTIONS(4719),
    [anon_sym_into] = ACTIONS(4719),
    [anon_sym_join] = ACTIONS(4719),
    [anon_sym_on] = ACTIONS(4719),
    [anon_sym_equals] = ACTIONS(4719),
    [anon_sym_let] = ACTIONS(4719),
    [anon_sym_orderby] = ACTIONS(4719),
    [anon_sym_ascending] = ACTIONS(4719),
    [anon_sym_descending] = ACTIONS(4719),
    [anon_sym_group] = ACTIONS(4719),
    [anon_sym_by] = ACTIONS(4719),
    [anon_sym_select] = ACTIONS(4719),
    [aux_sym_preproc_if_token1] = ACTIONS(4721),
    [aux_sym_preproc_if_token3] = ACTIONS(4721),
    [aux_sym_preproc_else_token1] = ACTIONS(4721),
    [aux_sym_preproc_elif_token1] = ACTIONS(4721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2884] = {
    [sym_preproc_region] = STATE(2884),
    [sym_preproc_endregion] = STATE(2884),
    [sym_preproc_line] = STATE(2884),
    [sym_preproc_pragma] = STATE(2884),
    [sym_preproc_nullable] = STATE(2884),
    [sym_preproc_error] = STATE(2884),
    [sym_preproc_warning] = STATE(2884),
    [sym_preproc_define] = STATE(2884),
    [sym_preproc_undef] = STATE(2884),
    [sym__identifier_token] = ACTIONS(4723),
    [anon_sym_extern] = ACTIONS(4723),
    [anon_sym_alias] = ACTIONS(4723),
    [anon_sym_global] = ACTIONS(4723),
    [anon_sym_using] = ACTIONS(4723),
    [anon_sym_unsafe] = ACTIONS(4723),
    [anon_sym_static] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(4725),
    [anon_sym_LPAREN] = ACTIONS(4725),
    [anon_sym_event] = ACTIONS(4723),
    [anon_sym_namespace] = ACTIONS(4723),
    [anon_sym_class] = ACTIONS(4723),
    [anon_sym_ref] = ACTIONS(4723),
    [anon_sym_struct] = ACTIONS(4723),
    [anon_sym_enum] = ACTIONS(4723),
    [anon_sym_RBRACE] = ACTIONS(4725),
    [anon_sym_interface] = ACTIONS(4723),
    [anon_sym_delegate] = ACTIONS(4723),
    [anon_sym_record] = ACTIONS(4723),
    [anon_sym_abstract] = ACTIONS(4723),
    [anon_sym_async] = ACTIONS(4723),
    [anon_sym_const] = ACTIONS(4723),
    [anon_sym_file] = ACTIONS(4723),
    [anon_sym_fixed] = ACTIONS(4723),
    [anon_sym_internal] = ACTIONS(4723),
    [anon_sym_new] = ACTIONS(4723),
    [anon_sym_override] = ACTIONS(4723),
    [anon_sym_partial] = ACTIONS(4723),
    [anon_sym_private] = ACTIONS(4723),
    [anon_sym_protected] = ACTIONS(4723),
    [anon_sym_public] = ACTIONS(4723),
    [anon_sym_readonly] = ACTIONS(4723),
    [anon_sym_required] = ACTIONS(4723),
    [anon_sym_sealed] = ACTIONS(4723),
    [anon_sym_virtual] = ACTIONS(4723),
    [anon_sym_volatile] = ACTIONS(4723),
    [anon_sym_where] = ACTIONS(4723),
    [anon_sym_notnull] = ACTIONS(4723),
    [anon_sym_unmanaged] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4725),
    [anon_sym_implicit] = ACTIONS(4723),
    [anon_sym_explicit] = ACTIONS(4723),
    [anon_sym_scoped] = ACTIONS(4723),
    [anon_sym_var] = ACTIONS(4723),
    [sym_predefined_type] = ACTIONS(4723),
    [anon_sym_yield] = ACTIONS(4723),
    [anon_sym_when] = ACTIONS(4723),
    [anon_sym_from] = ACTIONS(4723),
    [anon_sym_into] = ACTIONS(4723),
    [anon_sym_join] = ACTIONS(4723),
    [anon_sym_on] = ACTIONS(4723),
    [anon_sym_equals] = ACTIONS(4723),
    [anon_sym_let] = ACTIONS(4723),
    [anon_sym_orderby] = ACTIONS(4723),
    [anon_sym_ascending] = ACTIONS(4723),
    [anon_sym_descending] = ACTIONS(4723),
    [anon_sym_group] = ACTIONS(4723),
    [anon_sym_by] = ACTIONS(4723),
    [anon_sym_select] = ACTIONS(4723),
    [aux_sym_preproc_if_token1] = ACTIONS(4725),
    [aux_sym_preproc_if_token3] = ACTIONS(4725),
    [aux_sym_preproc_else_token1] = ACTIONS(4725),
    [aux_sym_preproc_elif_token1] = ACTIONS(4725),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2885] = {
    [sym_preproc_region] = STATE(2885),
    [sym_preproc_endregion] = STATE(2885),
    [sym_preproc_line] = STATE(2885),
    [sym_preproc_pragma] = STATE(2885),
    [sym_preproc_nullable] = STATE(2885),
    [sym_preproc_error] = STATE(2885),
    [sym_preproc_warning] = STATE(2885),
    [sym_preproc_define] = STATE(2885),
    [sym_preproc_undef] = STATE(2885),
    [sym__identifier_token] = ACTIONS(4727),
    [anon_sym_extern] = ACTIONS(4727),
    [anon_sym_alias] = ACTIONS(4727),
    [anon_sym_global] = ACTIONS(4727),
    [anon_sym_using] = ACTIONS(4727),
    [anon_sym_unsafe] = ACTIONS(4727),
    [anon_sym_static] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4729),
    [anon_sym_LPAREN] = ACTIONS(4729),
    [anon_sym_event] = ACTIONS(4727),
    [anon_sym_namespace] = ACTIONS(4727),
    [anon_sym_class] = ACTIONS(4727),
    [anon_sym_ref] = ACTIONS(4727),
    [anon_sym_struct] = ACTIONS(4727),
    [anon_sym_enum] = ACTIONS(4727),
    [anon_sym_RBRACE] = ACTIONS(4729),
    [anon_sym_interface] = ACTIONS(4727),
    [anon_sym_delegate] = ACTIONS(4727),
    [anon_sym_record] = ACTIONS(4727),
    [anon_sym_abstract] = ACTIONS(4727),
    [anon_sym_async] = ACTIONS(4727),
    [anon_sym_const] = ACTIONS(4727),
    [anon_sym_file] = ACTIONS(4727),
    [anon_sym_fixed] = ACTIONS(4727),
    [anon_sym_internal] = ACTIONS(4727),
    [anon_sym_new] = ACTIONS(4727),
    [anon_sym_override] = ACTIONS(4727),
    [anon_sym_partial] = ACTIONS(4727),
    [anon_sym_private] = ACTIONS(4727),
    [anon_sym_protected] = ACTIONS(4727),
    [anon_sym_public] = ACTIONS(4727),
    [anon_sym_readonly] = ACTIONS(4727),
    [anon_sym_required] = ACTIONS(4727),
    [anon_sym_sealed] = ACTIONS(4727),
    [anon_sym_virtual] = ACTIONS(4727),
    [anon_sym_volatile] = ACTIONS(4727),
    [anon_sym_where] = ACTIONS(4727),
    [anon_sym_notnull] = ACTIONS(4727),
    [anon_sym_unmanaged] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4729),
    [anon_sym_implicit] = ACTIONS(4727),
    [anon_sym_explicit] = ACTIONS(4727),
    [anon_sym_scoped] = ACTIONS(4727),
    [anon_sym_var] = ACTIONS(4727),
    [sym_predefined_type] = ACTIONS(4727),
    [anon_sym_yield] = ACTIONS(4727),
    [anon_sym_when] = ACTIONS(4727),
    [anon_sym_from] = ACTIONS(4727),
    [anon_sym_into] = ACTIONS(4727),
    [anon_sym_join] = ACTIONS(4727),
    [anon_sym_on] = ACTIONS(4727),
    [anon_sym_equals] = ACTIONS(4727),
    [anon_sym_let] = ACTIONS(4727),
    [anon_sym_orderby] = ACTIONS(4727),
    [anon_sym_ascending] = ACTIONS(4727),
    [anon_sym_descending] = ACTIONS(4727),
    [anon_sym_group] = ACTIONS(4727),
    [anon_sym_by] = ACTIONS(4727),
    [anon_sym_select] = ACTIONS(4727),
    [aux_sym_preproc_if_token1] = ACTIONS(4729),
    [aux_sym_preproc_if_token3] = ACTIONS(4729),
    [aux_sym_preproc_else_token1] = ACTIONS(4729),
    [aux_sym_preproc_elif_token1] = ACTIONS(4729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2886] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym_tuple_pattern] = STATE(7084),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6181),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5778),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(2886),
    [sym_preproc_endregion] = STATE(2886),
    [sym_preproc_line] = STATE(2886),
    [sym_preproc_pragma] = STATE(2886),
    [sym_preproc_nullable] = STATE(2886),
    [sym_preproc_error] = STATE(2886),
    [sym_preproc_warning] = STATE(2886),
    [sym_preproc_define] = STATE(2886),
    [sym_preproc_undef] = STATE(2886),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3012),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [sym_discard] = ACTIONS(4739),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2887] = {
    [sym_preproc_region] = STATE(2887),
    [sym_preproc_endregion] = STATE(2887),
    [sym_preproc_line] = STATE(2887),
    [sym_preproc_pragma] = STATE(2887),
    [sym_preproc_nullable] = STATE(2887),
    [sym_preproc_error] = STATE(2887),
    [sym_preproc_warning] = STATE(2887),
    [sym_preproc_define] = STATE(2887),
    [sym_preproc_undef] = STATE(2887),
    [sym__identifier_token] = ACTIONS(4182),
    [anon_sym_alias] = ACTIONS(4182),
    [anon_sym_global] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_file] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4182),
    [anon_sym_GT] = ACTIONS(4182),
    [anon_sym_where] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_notnull] = ACTIONS(4182),
    [anon_sym_unmanaged] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4184),
    [anon_sym_PIPE] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4184),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_GT_GT_GT] = ACTIONS(4184),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_GT_EQ] = ACTIONS(4184),
    [anon_sym_LT_EQ] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_scoped] = ACTIONS(4182),
    [anon_sym_var] = ACTIONS(4182),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_switch] = ACTIONS(4182),
    [anon_sym_when] = ACTIONS(4182),
    [sym_discard] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(4184),
    [anon_sym_QMARK_QMARK] = ACTIONS(4184),
    [anon_sym_from] = ACTIONS(4182),
    [anon_sym_into] = ACTIONS(4182),
    [anon_sym_join] = ACTIONS(4182),
    [anon_sym_on] = ACTIONS(4182),
    [anon_sym_equals] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_orderby] = ACTIONS(4182),
    [anon_sym_ascending] = ACTIONS(4182),
    [anon_sym_descending] = ACTIONS(4182),
    [anon_sym_group] = ACTIONS(4182),
    [anon_sym_by] = ACTIONS(4182),
    [anon_sym_select] = ACTIONS(4182),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_is] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4184),
    [anon_sym_with] = ACTIONS(4182),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4184),
  },
  [2888] = {
    [sym_preproc_else_in_attribute_list] = STATE(7433),
    [sym_preproc_elif_in_attribute_list] = STATE(7433),
    [sym_preproc_region] = STATE(2888),
    [sym_preproc_endregion] = STATE(2888),
    [sym_preproc_line] = STATE(2888),
    [sym_preproc_pragma] = STATE(2888),
    [sym_preproc_nullable] = STATE(2888),
    [sym_preproc_error] = STATE(2888),
    [sym_preproc_warning] = STATE(2888),
    [sym_preproc_define] = STATE(2888),
    [sym_preproc_undef] = STATE(2888),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_event] = ACTIONS(4743),
    [anon_sym_class] = ACTIONS(4743),
    [anon_sym_ref] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_interface] = ACTIONS(4743),
    [anon_sym_delegate] = ACTIONS(4743),
    [anon_sym_record] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4745),
    [anon_sym_implicit] = ACTIONS(4743),
    [anon_sym_explicit] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [sym_predefined_type] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_if_token3] = ACTIONS(4747),
    [aux_sym_preproc_else_token1] = ACTIONS(4749),
    [aux_sym_preproc_elif_token1] = ACTIONS(4751),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2889] = {
    [sym_preproc_region] = STATE(2889),
    [sym_preproc_endregion] = STATE(2889),
    [sym_preproc_line] = STATE(2889),
    [sym_preproc_pragma] = STATE(2889),
    [sym_preproc_nullable] = STATE(2889),
    [sym_preproc_error] = STATE(2889),
    [sym_preproc_warning] = STATE(2889),
    [sym_preproc_define] = STATE(2889),
    [sym_preproc_undef] = STATE(2889),
    [sym__identifier_token] = ACTIONS(4219),
    [anon_sym_alias] = ACTIONS(4219),
    [anon_sym_global] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4221),
    [anon_sym_COLON] = ACTIONS(4221),
    [anon_sym_COMMA] = ACTIONS(4221),
    [anon_sym_LPAREN] = ACTIONS(4221),
    [anon_sym_file] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4219),
    [anon_sym_GT] = ACTIONS(4219),
    [anon_sym_where] = ACTIONS(4219),
    [anon_sym_QMARK] = ACTIONS(4219),
    [anon_sym_notnull] = ACTIONS(4219),
    [anon_sym_unmanaged] = ACTIONS(4219),
    [anon_sym_BANG] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4221),
    [anon_sym_DASH_DASH] = ACTIONS(4221),
    [anon_sym_PLUS] = ACTIONS(4219),
    [anon_sym_DASH] = ACTIONS(4219),
    [anon_sym_STAR] = ACTIONS(4221),
    [anon_sym_SLASH] = ACTIONS(4219),
    [anon_sym_PERCENT] = ACTIONS(4221),
    [anon_sym_CARET] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_GT_GT_GT] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4221),
    [anon_sym_GT_EQ] = ACTIONS(4221),
    [anon_sym_LT_EQ] = ACTIONS(4221),
    [anon_sym_DOT] = ACTIONS(4219),
    [anon_sym_scoped] = ACTIONS(4219),
    [anon_sym_var] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(4219),
    [anon_sym_switch] = ACTIONS(4219),
    [anon_sym_when] = ACTIONS(4219),
    [sym_discard] = ACTIONS(4219),
    [anon_sym_DOT_DOT] = ACTIONS(4221),
    [anon_sym_and] = ACTIONS(4219),
    [anon_sym_or] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4221),
    [anon_sym_PIPE_PIPE] = ACTIONS(4221),
    [anon_sym_QMARK_QMARK] = ACTIONS(4221),
    [anon_sym_from] = ACTIONS(4219),
    [anon_sym_into] = ACTIONS(4219),
    [anon_sym_join] = ACTIONS(4219),
    [anon_sym_on] = ACTIONS(4219),
    [anon_sym_equals] = ACTIONS(4219),
    [anon_sym_let] = ACTIONS(4219),
    [anon_sym_orderby] = ACTIONS(4219),
    [anon_sym_ascending] = ACTIONS(4219),
    [anon_sym_descending] = ACTIONS(4219),
    [anon_sym_group] = ACTIONS(4219),
    [anon_sym_by] = ACTIONS(4219),
    [anon_sym_select] = ACTIONS(4219),
    [anon_sym_as] = ACTIONS(4219),
    [anon_sym_is] = ACTIONS(4219),
    [anon_sym_DASH_GT] = ACTIONS(4221),
    [anon_sym_with] = ACTIONS(4219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4221),
  },
  [2890] = {
    [sym_preproc_region] = STATE(2890),
    [sym_preproc_endregion] = STATE(2890),
    [sym_preproc_line] = STATE(2890),
    [sym_preproc_pragma] = STATE(2890),
    [sym_preproc_nullable] = STATE(2890),
    [sym_preproc_error] = STATE(2890),
    [sym_preproc_warning] = STATE(2890),
    [sym_preproc_define] = STATE(2890),
    [sym_preproc_undef] = STATE(2890),
    [sym__identifier_token] = ACTIONS(4182),
    [anon_sym_alias] = ACTIONS(4182),
    [anon_sym_global] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_file] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4182),
    [anon_sym_GT] = ACTIONS(4182),
    [anon_sym_where] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_notnull] = ACTIONS(4182),
    [anon_sym_unmanaged] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4184),
    [anon_sym_PIPE] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4184),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_GT_GT_GT] = ACTIONS(4184),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_GT_EQ] = ACTIONS(4184),
    [anon_sym_LT_EQ] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_scoped] = ACTIONS(4182),
    [anon_sym_var] = ACTIONS(4182),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_switch] = ACTIONS(4182),
    [anon_sym_when] = ACTIONS(4182),
    [sym_discard] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(4184),
    [anon_sym_QMARK_QMARK] = ACTIONS(4184),
    [anon_sym_from] = ACTIONS(4182),
    [anon_sym_into] = ACTIONS(4182),
    [anon_sym_join] = ACTIONS(4182),
    [anon_sym_on] = ACTIONS(4182),
    [anon_sym_equals] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_orderby] = ACTIONS(4182),
    [anon_sym_ascending] = ACTIONS(4182),
    [anon_sym_descending] = ACTIONS(4182),
    [anon_sym_group] = ACTIONS(4182),
    [anon_sym_by] = ACTIONS(4182),
    [anon_sym_select] = ACTIONS(4182),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_is] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4184),
    [anon_sym_with] = ACTIONS(4182),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4184),
  },
  [2891] = {
    [sym_preproc_region] = STATE(2891),
    [sym_preproc_endregion] = STATE(2891),
    [sym_preproc_line] = STATE(2891),
    [sym_preproc_pragma] = STATE(2891),
    [sym_preproc_nullable] = STATE(2891),
    [sym_preproc_error] = STATE(2891),
    [sym_preproc_warning] = STATE(2891),
    [sym_preproc_define] = STATE(2891),
    [sym_preproc_undef] = STATE(2891),
    [sym__identifier_token] = ACTIONS(4219),
    [anon_sym_alias] = ACTIONS(4219),
    [anon_sym_global] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4221),
    [anon_sym_COLON] = ACTIONS(4221),
    [anon_sym_COMMA] = ACTIONS(4221),
    [anon_sym_LPAREN] = ACTIONS(4221),
    [anon_sym_file] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4219),
    [anon_sym_GT] = ACTIONS(4219),
    [anon_sym_where] = ACTIONS(4219),
    [anon_sym_QMARK] = ACTIONS(4219),
    [anon_sym_notnull] = ACTIONS(4219),
    [anon_sym_unmanaged] = ACTIONS(4219),
    [anon_sym_BANG] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4221),
    [anon_sym_DASH_DASH] = ACTIONS(4221),
    [anon_sym_PLUS] = ACTIONS(4219),
    [anon_sym_DASH] = ACTIONS(4219),
    [anon_sym_STAR] = ACTIONS(4221),
    [anon_sym_SLASH] = ACTIONS(4219),
    [anon_sym_PERCENT] = ACTIONS(4221),
    [anon_sym_CARET] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_GT_GT_GT] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4221),
    [anon_sym_GT_EQ] = ACTIONS(4221),
    [anon_sym_LT_EQ] = ACTIONS(4221),
    [anon_sym_DOT] = ACTIONS(4219),
    [anon_sym_scoped] = ACTIONS(4219),
    [anon_sym_var] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(4219),
    [anon_sym_switch] = ACTIONS(4219),
    [anon_sym_when] = ACTIONS(4219),
    [sym_discard] = ACTIONS(4219),
    [anon_sym_DOT_DOT] = ACTIONS(4221),
    [anon_sym_and] = ACTIONS(4219),
    [anon_sym_or] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4221),
    [anon_sym_PIPE_PIPE] = ACTIONS(4221),
    [anon_sym_QMARK_QMARK] = ACTIONS(4221),
    [anon_sym_from] = ACTIONS(4219),
    [anon_sym_into] = ACTIONS(4219),
    [anon_sym_join] = ACTIONS(4219),
    [anon_sym_on] = ACTIONS(4219),
    [anon_sym_equals] = ACTIONS(4219),
    [anon_sym_let] = ACTIONS(4219),
    [anon_sym_orderby] = ACTIONS(4219),
    [anon_sym_ascending] = ACTIONS(4219),
    [anon_sym_descending] = ACTIONS(4219),
    [anon_sym_group] = ACTIONS(4219),
    [anon_sym_by] = ACTIONS(4219),
    [anon_sym_select] = ACTIONS(4219),
    [anon_sym_as] = ACTIONS(4219),
    [anon_sym_is] = ACTIONS(4219),
    [anon_sym_DASH_GT] = ACTIONS(4221),
    [anon_sym_with] = ACTIONS(4219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4221),
  },
  [2892] = {
    [sym_preproc_else_in_attribute_list] = STATE(7655),
    [sym_preproc_elif_in_attribute_list] = STATE(7655),
    [sym_preproc_region] = STATE(2892),
    [sym_preproc_endregion] = STATE(2892),
    [sym_preproc_line] = STATE(2892),
    [sym_preproc_pragma] = STATE(2892),
    [sym_preproc_nullable] = STATE(2892),
    [sym_preproc_error] = STATE(2892),
    [sym_preproc_warning] = STATE(2892),
    [sym_preproc_define] = STATE(2892),
    [sym_preproc_undef] = STATE(2892),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_event] = ACTIONS(4743),
    [anon_sym_class] = ACTIONS(4743),
    [anon_sym_ref] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_interface] = ACTIONS(4743),
    [anon_sym_delegate] = ACTIONS(4743),
    [anon_sym_record] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4745),
    [anon_sym_implicit] = ACTIONS(4743),
    [anon_sym_explicit] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [sym_predefined_type] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_if_token3] = ACTIONS(4753),
    [aux_sym_preproc_else_token1] = ACTIONS(4749),
    [aux_sym_preproc_elif_token1] = ACTIONS(4751),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2893] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5970),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5742),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(2893),
    [sym_preproc_endregion] = STATE(2893),
    [sym_preproc_line] = STATE(2893),
    [sym_preproc_pragma] = STATE(2893),
    [sym_preproc_nullable] = STATE(2893),
    [sym_preproc_error] = STATE(2893),
    [sym_preproc_warning] = STATE(2893),
    [sym_preproc_define] = STATE(2893),
    [sym_preproc_undef] = STATE(2893),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(4439),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3430),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3463),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4755),
    [anon_sym_params] = ACTIONS(4757),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2894] = {
    [sym_preproc_region] = STATE(2894),
    [sym_preproc_endregion] = STATE(2894),
    [sym_preproc_line] = STATE(2894),
    [sym_preproc_pragma] = STATE(2894),
    [sym_preproc_nullable] = STATE(2894),
    [sym_preproc_error] = STATE(2894),
    [sym_preproc_warning] = STATE(2894),
    [sym_preproc_define] = STATE(2894),
    [sym_preproc_undef] = STATE(2894),
    [sym__identifier_token] = ACTIONS(4176),
    [anon_sym_alias] = ACTIONS(4176),
    [anon_sym_global] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4176),
    [anon_sym_GT] = ACTIONS(4176),
    [anon_sym_where] = ACTIONS(4176),
    [anon_sym_QMARK] = ACTIONS(4176),
    [anon_sym_notnull] = ACTIONS(4176),
    [anon_sym_unmanaged] = ACTIONS(4176),
    [anon_sym_BANG] = ACTIONS(4176),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4176),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4176),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4176),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4176),
    [anon_sym_scoped] = ACTIONS(4176),
    [anon_sym_var] = ACTIONS(4176),
    [anon_sym_yield] = ACTIONS(4176),
    [anon_sym_switch] = ACTIONS(4176),
    [anon_sym_when] = ACTIONS(4176),
    [sym_discard] = ACTIONS(4176),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4176),
    [anon_sym_or] = ACTIONS(4176),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_from] = ACTIONS(4176),
    [anon_sym_into] = ACTIONS(4176),
    [anon_sym_join] = ACTIONS(4176),
    [anon_sym_on] = ACTIONS(4176),
    [anon_sym_equals] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_orderby] = ACTIONS(4176),
    [anon_sym_ascending] = ACTIONS(4176),
    [anon_sym_descending] = ACTIONS(4176),
    [anon_sym_group] = ACTIONS(4176),
    [anon_sym_by] = ACTIONS(4176),
    [anon_sym_select] = ACTIONS(4176),
    [anon_sym_as] = ACTIONS(4176),
    [anon_sym_is] = ACTIONS(4176),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4178),
  },
  [2895] = {
    [sym_preproc_region] = STATE(2895),
    [sym_preproc_endregion] = STATE(2895),
    [sym_preproc_line] = STATE(2895),
    [sym_preproc_pragma] = STATE(2895),
    [sym_preproc_nullable] = STATE(2895),
    [sym_preproc_error] = STATE(2895),
    [sym_preproc_warning] = STATE(2895),
    [sym_preproc_define] = STATE(2895),
    [sym_preproc_undef] = STATE(2895),
    [sym__identifier_token] = ACTIONS(4198),
    [anon_sym_alias] = ACTIONS(4198),
    [anon_sym_global] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4200),
    [anon_sym_COLON] = ACTIONS(4200),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_LPAREN] = ACTIONS(4200),
    [anon_sym_file] = ACTIONS(4198),
    [anon_sym_LT] = ACTIONS(4198),
    [anon_sym_GT] = ACTIONS(4198),
    [anon_sym_where] = ACTIONS(4198),
    [anon_sym_QMARK] = ACTIONS(4198),
    [anon_sym_notnull] = ACTIONS(4198),
    [anon_sym_unmanaged] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4200),
    [anon_sym_DASH_DASH] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(4198),
    [anon_sym_PERCENT] = ACTIONS(4200),
    [anon_sym_CARET] = ACTIONS(4200),
    [anon_sym_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4198),
    [anon_sym_LT_LT] = ACTIONS(4200),
    [anon_sym_GT_GT] = ACTIONS(4198),
    [anon_sym_GT_GT_GT] = ACTIONS(4200),
    [anon_sym_EQ_EQ] = ACTIONS(4200),
    [anon_sym_BANG_EQ] = ACTIONS(4200),
    [anon_sym_GT_EQ] = ACTIONS(4200),
    [anon_sym_LT_EQ] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4198),
    [anon_sym_scoped] = ACTIONS(4198),
    [anon_sym_var] = ACTIONS(4198),
    [anon_sym_yield] = ACTIONS(4198),
    [anon_sym_switch] = ACTIONS(4198),
    [anon_sym_when] = ACTIONS(4198),
    [sym_discard] = ACTIONS(4198),
    [anon_sym_DOT_DOT] = ACTIONS(4200),
    [anon_sym_and] = ACTIONS(4198),
    [anon_sym_or] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4200),
    [anon_sym_PIPE_PIPE] = ACTIONS(4200),
    [anon_sym_QMARK_QMARK] = ACTIONS(4200),
    [anon_sym_from] = ACTIONS(4198),
    [anon_sym_into] = ACTIONS(4198),
    [anon_sym_join] = ACTIONS(4198),
    [anon_sym_on] = ACTIONS(4198),
    [anon_sym_equals] = ACTIONS(4198),
    [anon_sym_let] = ACTIONS(4198),
    [anon_sym_orderby] = ACTIONS(4198),
    [anon_sym_ascending] = ACTIONS(4198),
    [anon_sym_descending] = ACTIONS(4198),
    [anon_sym_group] = ACTIONS(4198),
    [anon_sym_by] = ACTIONS(4198),
    [anon_sym_select] = ACTIONS(4198),
    [anon_sym_as] = ACTIONS(4198),
    [anon_sym_is] = ACTIONS(4198),
    [anon_sym_DASH_GT] = ACTIONS(4200),
    [anon_sym_with] = ACTIONS(4198),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4200),
  },
  [2896] = {
    [sym_preproc_region] = STATE(2896),
    [sym_preproc_endregion] = STATE(2896),
    [sym_preproc_line] = STATE(2896),
    [sym_preproc_pragma] = STATE(2896),
    [sym_preproc_nullable] = STATE(2896),
    [sym_preproc_error] = STATE(2896),
    [sym_preproc_warning] = STATE(2896),
    [sym_preproc_define] = STATE(2896),
    [sym_preproc_undef] = STATE(2896),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4759),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2897] = {
    [sym_preproc_region] = STATE(2897),
    [sym_preproc_endregion] = STATE(2897),
    [sym_preproc_line] = STATE(2897),
    [sym_preproc_pragma] = STATE(2897),
    [sym_preproc_nullable] = STATE(2897),
    [sym_preproc_error] = STATE(2897),
    [sym_preproc_warning] = STATE(2897),
    [sym_preproc_define] = STATE(2897),
    [sym_preproc_undef] = STATE(2897),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2898] = {
    [sym_preproc_region] = STATE(2898),
    [sym_preproc_endregion] = STATE(2898),
    [sym_preproc_line] = STATE(2898),
    [sym_preproc_pragma] = STATE(2898),
    [sym_preproc_nullable] = STATE(2898),
    [sym_preproc_error] = STATE(2898),
    [sym_preproc_warning] = STATE(2898),
    [sym_preproc_define] = STATE(2898),
    [sym_preproc_undef] = STATE(2898),
    [sym__identifier_token] = ACTIONS(4127),
    [anon_sym_alias] = ACTIONS(4127),
    [anon_sym_global] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [anon_sym_file] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_where] = ACTIONS(4127),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_notnull] = ACTIONS(4127),
    [anon_sym_unmanaged] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_SLASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4129),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_LT_LT] = ACTIONS(4129),
    [anon_sym_GT_GT] = ACTIONS(4127),
    [anon_sym_GT_GT_GT] = ACTIONS(4129),
    [anon_sym_EQ_EQ] = ACTIONS(4129),
    [anon_sym_BANG_EQ] = ACTIONS(4129),
    [anon_sym_GT_EQ] = ACTIONS(4129),
    [anon_sym_LT_EQ] = ACTIONS(4129),
    [anon_sym_DOT] = ACTIONS(4127),
    [anon_sym_scoped] = ACTIONS(4127),
    [anon_sym_EQ_GT] = ACTIONS(4129),
    [anon_sym_var] = ACTIONS(4127),
    [anon_sym_yield] = ACTIONS(4127),
    [anon_sym_switch] = ACTIONS(4127),
    [anon_sym_when] = ACTIONS(4127),
    [sym_discard] = ACTIONS(4127),
    [anon_sym_DOT_DOT] = ACTIONS(4129),
    [anon_sym_and] = ACTIONS(4127),
    [anon_sym_or] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4129),
    [anon_sym_PIPE_PIPE] = ACTIONS(4129),
    [anon_sym_QMARK_QMARK] = ACTIONS(4129),
    [anon_sym_from] = ACTIONS(4127),
    [anon_sym_into] = ACTIONS(4127),
    [anon_sym_join] = ACTIONS(4127),
    [anon_sym_on] = ACTIONS(4127),
    [anon_sym_equals] = ACTIONS(4127),
    [anon_sym_let] = ACTIONS(4127),
    [anon_sym_orderby] = ACTIONS(4127),
    [anon_sym_ascending] = ACTIONS(4127),
    [anon_sym_descending] = ACTIONS(4127),
    [anon_sym_group] = ACTIONS(4127),
    [anon_sym_by] = ACTIONS(4127),
    [anon_sym_select] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4127),
    [anon_sym_is] = ACTIONS(4127),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [anon_sym_with] = ACTIONS(4127),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2899] = {
    [sym_preproc_region] = STATE(2899),
    [sym_preproc_endregion] = STATE(2899),
    [sym_preproc_line] = STATE(2899),
    [sym_preproc_pragma] = STATE(2899),
    [sym_preproc_nullable] = STATE(2899),
    [sym_preproc_error] = STATE(2899),
    [sym_preproc_warning] = STATE(2899),
    [sym_preproc_define] = STATE(2899),
    [sym_preproc_undef] = STATE(2899),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2900] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6121),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_identifier] = STATE(5800),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(2900),
    [sym_preproc_endregion] = STATE(2900),
    [sym_preproc_line] = STATE(2900),
    [sym_preproc_pragma] = STATE(2900),
    [sym_preproc_nullable] = STATE(2900),
    [sym_preproc_error] = STATE(2900),
    [sym_preproc_warning] = STATE(2900),
    [sym_preproc_define] = STATE(2900),
    [sym_preproc_undef] = STATE(2900),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3012),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2901] = {
    [sym_preproc_region] = STATE(2901),
    [sym_preproc_endregion] = STATE(2901),
    [sym_preproc_line] = STATE(2901),
    [sym_preproc_pragma] = STATE(2901),
    [sym_preproc_nullable] = STATE(2901),
    [sym_preproc_error] = STATE(2901),
    [sym_preproc_warning] = STATE(2901),
    [sym_preproc_define] = STATE(2901),
    [sym_preproc_undef] = STATE(2901),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4769),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2902] = {
    [sym_attribute_list] = STATE(3038),
    [sym__attribute_list] = STATE(3045),
    [sym_preproc_if_in_attribute_list] = STATE(3038),
    [sym_preproc_region] = STATE(2902),
    [sym_preproc_endregion] = STATE(2902),
    [sym_preproc_line] = STATE(2902),
    [sym_preproc_pragma] = STATE(2902),
    [sym_preproc_nullable] = STATE(2902),
    [sym_preproc_error] = STATE(2902),
    [sym_preproc_warning] = STATE(2902),
    [sym_preproc_define] = STATE(2902),
    [sym_preproc_undef] = STATE(2902),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(2902),
    [sym__identifier_token] = ACTIONS(4771),
    [anon_sym_extern] = ACTIONS(4771),
    [anon_sym_alias] = ACTIONS(4771),
    [anon_sym_global] = ACTIONS(4771),
    [anon_sym_unsafe] = ACTIONS(4771),
    [anon_sym_static] = ACTIONS(4771),
    [anon_sym_LBRACK] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(4776),
    [anon_sym_event] = ACTIONS(4771),
    [anon_sym_class] = ACTIONS(4771),
    [anon_sym_ref] = ACTIONS(4771),
    [anon_sym_struct] = ACTIONS(4771),
    [anon_sym_enum] = ACTIONS(4771),
    [anon_sym_interface] = ACTIONS(4771),
    [anon_sym_delegate] = ACTIONS(4771),
    [anon_sym_record] = ACTIONS(4771),
    [anon_sym_abstract] = ACTIONS(4771),
    [anon_sym_async] = ACTIONS(4771),
    [anon_sym_const] = ACTIONS(4771),
    [anon_sym_file] = ACTIONS(4771),
    [anon_sym_fixed] = ACTIONS(4771),
    [anon_sym_internal] = ACTIONS(4771),
    [anon_sym_new] = ACTIONS(4771),
    [anon_sym_override] = ACTIONS(4771),
    [anon_sym_partial] = ACTIONS(4771),
    [anon_sym_private] = ACTIONS(4771),
    [anon_sym_protected] = ACTIONS(4771),
    [anon_sym_public] = ACTIONS(4771),
    [anon_sym_readonly] = ACTIONS(4771),
    [anon_sym_required] = ACTIONS(4771),
    [anon_sym_sealed] = ACTIONS(4771),
    [anon_sym_virtual] = ACTIONS(4771),
    [anon_sym_volatile] = ACTIONS(4771),
    [anon_sym_where] = ACTIONS(4771),
    [anon_sym_notnull] = ACTIONS(4771),
    [anon_sym_unmanaged] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4776),
    [anon_sym_implicit] = ACTIONS(4771),
    [anon_sym_explicit] = ACTIONS(4771),
    [anon_sym_scoped] = ACTIONS(4771),
    [anon_sym_var] = ACTIONS(4771),
    [sym_predefined_type] = ACTIONS(4771),
    [anon_sym_yield] = ACTIONS(4771),
    [anon_sym_when] = ACTIONS(4771),
    [anon_sym_from] = ACTIONS(4771),
    [anon_sym_into] = ACTIONS(4771),
    [anon_sym_join] = ACTIONS(4771),
    [anon_sym_on] = ACTIONS(4771),
    [anon_sym_equals] = ACTIONS(4771),
    [anon_sym_let] = ACTIONS(4771),
    [anon_sym_orderby] = ACTIONS(4771),
    [anon_sym_ascending] = ACTIONS(4771),
    [anon_sym_descending] = ACTIONS(4771),
    [anon_sym_group] = ACTIONS(4771),
    [anon_sym_by] = ACTIONS(4771),
    [anon_sym_select] = ACTIONS(4771),
    [aux_sym_preproc_if_token1] = ACTIONS(4778),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2903] = {
    [sym_preproc_region] = STATE(2903),
    [sym_preproc_endregion] = STATE(2903),
    [sym_preproc_line] = STATE(2903),
    [sym_preproc_pragma] = STATE(2903),
    [sym_preproc_nullable] = STATE(2903),
    [sym_preproc_error] = STATE(2903),
    [sym_preproc_warning] = STATE(2903),
    [sym_preproc_define] = STATE(2903),
    [sym_preproc_undef] = STATE(2903),
    [sym__identifier_token] = ACTIONS(4127),
    [anon_sym_alias] = ACTIONS(4127),
    [anon_sym_global] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_LPAREN] = ACTIONS(4129),
    [anon_sym_LBRACE] = ACTIONS(4129),
    [anon_sym_file] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_where] = ACTIONS(4127),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_notnull] = ACTIONS(4127),
    [anon_sym_unmanaged] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4127),
    [anon_sym_PLUS_PLUS] = ACTIONS(4129),
    [anon_sym_DASH_DASH] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_SLASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4129),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_LT_LT] = ACTIONS(4129),
    [anon_sym_GT_GT] = ACTIONS(4127),
    [anon_sym_GT_GT_GT] = ACTIONS(4129),
    [anon_sym_EQ_EQ] = ACTIONS(4129),
    [anon_sym_BANG_EQ] = ACTIONS(4129),
    [anon_sym_GT_EQ] = ACTIONS(4129),
    [anon_sym_LT_EQ] = ACTIONS(4129),
    [anon_sym_DOT] = ACTIONS(4127),
    [anon_sym_scoped] = ACTIONS(4127),
    [anon_sym_EQ_GT] = ACTIONS(4129),
    [anon_sym_var] = ACTIONS(4127),
    [anon_sym_yield] = ACTIONS(4127),
    [anon_sym_switch] = ACTIONS(4127),
    [anon_sym_when] = ACTIONS(4127),
    [sym_discard] = ACTIONS(4127),
    [anon_sym_DOT_DOT] = ACTIONS(4129),
    [anon_sym_and] = ACTIONS(4127),
    [anon_sym_or] = ACTIONS(4127),
    [anon_sym_AMP_AMP] = ACTIONS(4129),
    [anon_sym_PIPE_PIPE] = ACTIONS(4129),
    [anon_sym_QMARK_QMARK] = ACTIONS(4129),
    [anon_sym_from] = ACTIONS(4127),
    [anon_sym_into] = ACTIONS(4127),
    [anon_sym_join] = ACTIONS(4127),
    [anon_sym_on] = ACTIONS(4127),
    [anon_sym_equals] = ACTIONS(4127),
    [anon_sym_let] = ACTIONS(4127),
    [anon_sym_orderby] = ACTIONS(4127),
    [anon_sym_ascending] = ACTIONS(4127),
    [anon_sym_descending] = ACTIONS(4127),
    [anon_sym_group] = ACTIONS(4127),
    [anon_sym_by] = ACTIONS(4127),
    [anon_sym_select] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4127),
    [anon_sym_is] = ACTIONS(4127),
    [anon_sym_DASH_GT] = ACTIONS(4129),
    [anon_sym_with] = ACTIONS(4127),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2904] = {
    [sym_preproc_region] = STATE(2904),
    [sym_preproc_endregion] = STATE(2904),
    [sym_preproc_line] = STATE(2904),
    [sym_preproc_pragma] = STATE(2904),
    [sym_preproc_nullable] = STATE(2904),
    [sym_preproc_error] = STATE(2904),
    [sym_preproc_warning] = STATE(2904),
    [sym_preproc_define] = STATE(2904),
    [sym_preproc_undef] = STATE(2904),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4781),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2905] = {
    [sym_preproc_region] = STATE(2905),
    [sym_preproc_endregion] = STATE(2905),
    [sym_preproc_line] = STATE(2905),
    [sym_preproc_pragma] = STATE(2905),
    [sym_preproc_nullable] = STATE(2905),
    [sym_preproc_error] = STATE(2905),
    [sym_preproc_warning] = STATE(2905),
    [sym_preproc_define] = STATE(2905),
    [sym_preproc_undef] = STATE(2905),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2906] = {
    [sym_preproc_region] = STATE(2906),
    [sym_preproc_endregion] = STATE(2906),
    [sym_preproc_line] = STATE(2906),
    [sym_preproc_pragma] = STATE(2906),
    [sym_preproc_nullable] = STATE(2906),
    [sym_preproc_error] = STATE(2906),
    [sym_preproc_warning] = STATE(2906),
    [sym_preproc_define] = STATE(2906),
    [sym_preproc_undef] = STATE(2906),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4785),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2907] = {
    [sym_attribute_list] = STATE(3570),
    [sym__attribute_list] = STATE(3569),
    [sym_modifier] = STATE(3734),
    [sym_accessor_declaration] = STATE(3551),
    [sym_identifier] = STATE(6456),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_attribute_list] = STATE(3570),
    [sym_preproc_region] = STATE(2907),
    [sym_preproc_endregion] = STATE(2907),
    [sym_preproc_line] = STATE(2907),
    [sym_preproc_pragma] = STATE(2907),
    [sym_preproc_nullable] = STATE(2907),
    [sym_preproc_error] = STATE(2907),
    [sym_preproc_warning] = STATE(2907),
    [sym_preproc_define] = STATE(2907),
    [sym_preproc_undef] = STATE(2907),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3053),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3272),
    [aux_sym_accessor_list_repeat1] = STATE(2928),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(4787),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(4787),
    [anon_sym_static] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4789),
    [anon_sym_RBRACE] = ACTIONS(4791),
    [anon_sym_abstract] = ACTIONS(4787),
    [anon_sym_async] = ACTIONS(4787),
    [anon_sym_const] = ACTIONS(4787),
    [anon_sym_file] = ACTIONS(4793),
    [anon_sym_fixed] = ACTIONS(4787),
    [anon_sym_internal] = ACTIONS(4787),
    [anon_sym_new] = ACTIONS(4787),
    [anon_sym_override] = ACTIONS(4787),
    [anon_sym_partial] = ACTIONS(4787),
    [anon_sym_private] = ACTIONS(4787),
    [anon_sym_protected] = ACTIONS(4787),
    [anon_sym_public] = ACTIONS(4787),
    [anon_sym_readonly] = ACTIONS(4787),
    [anon_sym_required] = ACTIONS(4787),
    [anon_sym_sealed] = ACTIONS(4787),
    [anon_sym_virtual] = ACTIONS(4787),
    [anon_sym_volatile] = ACTIONS(4787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_get] = ACTIONS(4795),
    [anon_sym_set] = ACTIONS(4795),
    [anon_sym_add] = ACTIONS(4795),
    [anon_sym_remove] = ACTIONS(4795),
    [anon_sym_init] = ACTIONS(4795),
    [anon_sym_scoped] = ACTIONS(29),
    [anon_sym_var] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_from] = ACTIONS(29),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [aux_sym_preproc_if_token1] = ACTIONS(4797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2908] = {
    [sym_preproc_region] = STATE(2908),
    [sym_preproc_endregion] = STATE(2908),
    [sym_preproc_line] = STATE(2908),
    [sym_preproc_pragma] = STATE(2908),
    [sym_preproc_nullable] = STATE(2908),
    [sym_preproc_error] = STATE(2908),
    [sym_preproc_warning] = STATE(2908),
    [sym_preproc_define] = STATE(2908),
    [sym_preproc_undef] = STATE(2908),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2909] = {
    [sym_preproc_region] = STATE(2909),
    [sym_preproc_endregion] = STATE(2909),
    [sym_preproc_line] = STATE(2909),
    [sym_preproc_pragma] = STATE(2909),
    [sym_preproc_nullable] = STATE(2909),
    [sym_preproc_error] = STATE(2909),
    [sym_preproc_warning] = STATE(2909),
    [sym_preproc_define] = STATE(2909),
    [sym_preproc_undef] = STATE(2909),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2910] = {
    [sym_preproc_region] = STATE(2910),
    [sym_preproc_endregion] = STATE(2910),
    [sym_preproc_line] = STATE(2910),
    [sym_preproc_pragma] = STATE(2910),
    [sym_preproc_nullable] = STATE(2910),
    [sym_preproc_error] = STATE(2910),
    [sym_preproc_warning] = STATE(2910),
    [sym_preproc_define] = STATE(2910),
    [sym_preproc_undef] = STATE(2910),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4805),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2911] = {
    [sym_preproc_region] = STATE(2911),
    [sym_preproc_endregion] = STATE(2911),
    [sym_preproc_line] = STATE(2911),
    [sym_preproc_pragma] = STATE(2911),
    [sym_preproc_nullable] = STATE(2911),
    [sym_preproc_error] = STATE(2911),
    [sym_preproc_warning] = STATE(2911),
    [sym_preproc_define] = STATE(2911),
    [sym_preproc_undef] = STATE(2911),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_catch] = ACTIONS(2979),
    [anon_sym_finally] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2912] = {
    [sym_preproc_region] = STATE(2912),
    [sym_preproc_endregion] = STATE(2912),
    [sym_preproc_line] = STATE(2912),
    [sym_preproc_pragma] = STATE(2912),
    [sym_preproc_nullable] = STATE(2912),
    [sym_preproc_error] = STATE(2912),
    [sym_preproc_warning] = STATE(2912),
    [sym_preproc_define] = STATE(2912),
    [sym_preproc_undef] = STATE(2912),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_where] = ACTIONS(4172),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_GT_GT_GT] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_switch] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK] = ACTIONS(4174),
    [anon_sym_from] = ACTIONS(4172),
    [anon_sym_into] = ACTIONS(4172),
    [anon_sym_join] = ACTIONS(4172),
    [anon_sym_let] = ACTIONS(4172),
    [anon_sym_orderby] = ACTIONS(4172),
    [anon_sym_ascending] = ACTIONS(4172),
    [anon_sym_descending] = ACTIONS(4172),
    [anon_sym_group] = ACTIONS(4172),
    [anon_sym_select] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4174),
    [anon_sym_is] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [anon_sym_with] = ACTIONS(4172),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2913] = {
    [sym_preproc_region] = STATE(2913),
    [sym_preproc_endregion] = STATE(2913),
    [sym_preproc_line] = STATE(2913),
    [sym_preproc_pragma] = STATE(2913),
    [sym_preproc_nullable] = STATE(2913),
    [sym_preproc_error] = STATE(2913),
    [sym_preproc_warning] = STATE(2913),
    [sym_preproc_define] = STATE(2913),
    [sym_preproc_undef] = STATE(2913),
    [sym__identifier_token] = ACTIONS(4807),
    [anon_sym_extern] = ACTIONS(4807),
    [anon_sym_alias] = ACTIONS(4807),
    [anon_sym_global] = ACTIONS(4807),
    [anon_sym_unsafe] = ACTIONS(4807),
    [anon_sym_static] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4809),
    [anon_sym_LPAREN] = ACTIONS(4809),
    [anon_sym_event] = ACTIONS(4807),
    [anon_sym_class] = ACTIONS(4807),
    [anon_sym_ref] = ACTIONS(4807),
    [anon_sym_struct] = ACTIONS(4807),
    [anon_sym_enum] = ACTIONS(4807),
    [anon_sym_interface] = ACTIONS(4807),
    [anon_sym_delegate] = ACTIONS(4807),
    [anon_sym_record] = ACTIONS(4807),
    [anon_sym_abstract] = ACTIONS(4807),
    [anon_sym_async] = ACTIONS(4807),
    [anon_sym_const] = ACTIONS(4807),
    [anon_sym_file] = ACTIONS(4807),
    [anon_sym_fixed] = ACTIONS(4807),
    [anon_sym_internal] = ACTIONS(4807),
    [anon_sym_new] = ACTIONS(4807),
    [anon_sym_override] = ACTIONS(4807),
    [anon_sym_partial] = ACTIONS(4807),
    [anon_sym_private] = ACTIONS(4807),
    [anon_sym_protected] = ACTIONS(4807),
    [anon_sym_public] = ACTIONS(4807),
    [anon_sym_readonly] = ACTIONS(4807),
    [anon_sym_required] = ACTIONS(4807),
    [anon_sym_sealed] = ACTIONS(4807),
    [anon_sym_virtual] = ACTIONS(4807),
    [anon_sym_volatile] = ACTIONS(4807),
    [anon_sym_where] = ACTIONS(4807),
    [anon_sym_notnull] = ACTIONS(4807),
    [anon_sym_unmanaged] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4809),
    [anon_sym_implicit] = ACTIONS(4807),
    [anon_sym_explicit] = ACTIONS(4807),
    [anon_sym_scoped] = ACTIONS(4807),
    [anon_sym_var] = ACTIONS(4807),
    [sym_predefined_type] = ACTIONS(4807),
    [anon_sym_yield] = ACTIONS(4807),
    [anon_sym_when] = ACTIONS(4807),
    [anon_sym_from] = ACTIONS(4807),
    [anon_sym_into] = ACTIONS(4807),
    [anon_sym_join] = ACTIONS(4807),
    [anon_sym_on] = ACTIONS(4807),
    [anon_sym_equals] = ACTIONS(4807),
    [anon_sym_let] = ACTIONS(4807),
    [anon_sym_orderby] = ACTIONS(4807),
    [anon_sym_ascending] = ACTIONS(4807),
    [anon_sym_descending] = ACTIONS(4807),
    [anon_sym_group] = ACTIONS(4807),
    [anon_sym_by] = ACTIONS(4807),
    [anon_sym_select] = ACTIONS(4807),
    [aux_sym_preproc_if_token1] = ACTIONS(4809),
    [aux_sym_preproc_if_token3] = ACTIONS(4809),
    [aux_sym_preproc_else_token1] = ACTIONS(4809),
    [aux_sym_preproc_elif_token1] = ACTIONS(4809),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2914] = {
    [sym_preproc_region] = STATE(2914),
    [sym_preproc_endregion] = STATE(2914),
    [sym_preproc_line] = STATE(2914),
    [sym_preproc_pragma] = STATE(2914),
    [sym_preproc_nullable] = STATE(2914),
    [sym_preproc_error] = STATE(2914),
    [sym_preproc_warning] = STATE(2914),
    [sym_preproc_define] = STATE(2914),
    [sym_preproc_undef] = STATE(2914),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4166),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_GT_GT_GT] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4164),
    [anon_sym_BANG_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK] = ACTIONS(4166),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_ascending] = ACTIONS(4164),
    [anon_sym_descending] = ACTIONS(4164),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4166),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2915] = {
    [sym_argument_list] = STATE(2949),
    [sym_initializer_expression] = STATE(3100),
    [sym_preproc_region] = STATE(2915),
    [sym_preproc_endregion] = STATE(2915),
    [sym_preproc_line] = STATE(2915),
    [sym_preproc_pragma] = STATE(2915),
    [sym_preproc_nullable] = STATE(2915),
    [sym_preproc_error] = STATE(2915),
    [sym_preproc_warning] = STATE(2915),
    [sym_preproc_define] = STATE(2915),
    [sym_preproc_undef] = STATE(2915),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_COLON] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(4811),
    [anon_sym_RBRACK] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(4813),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LT] = ACTIONS(4815),
    [anon_sym_GT] = ACTIONS(4815),
    [anon_sym_in] = ACTIONS(4815),
    [anon_sym_where] = ACTIONS(4811),
    [anon_sym_QMARK] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4815),
    [anon_sym_PERCENT] = ACTIONS(4811),
    [anon_sym_CARET] = ACTIONS(4811),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_LT_LT] = ACTIONS(4811),
    [anon_sym_GT_GT] = ACTIONS(4815),
    [anon_sym_GT_GT_GT] = ACTIONS(4811),
    [anon_sym_EQ_EQ] = ACTIONS(4811),
    [anon_sym_BANG_EQ] = ACTIONS(4811),
    [anon_sym_GT_EQ] = ACTIONS(4811),
    [anon_sym_LT_EQ] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_EQ_GT] = ACTIONS(4811),
    [anon_sym_switch] = ACTIONS(4811),
    [anon_sym_DOT_DOT] = ACTIONS(4811),
    [anon_sym_and] = ACTIONS(4811),
    [anon_sym_or] = ACTIONS(4815),
    [anon_sym_AMP_AMP] = ACTIONS(4811),
    [anon_sym_PIPE_PIPE] = ACTIONS(4811),
    [anon_sym_QMARK_QMARK] = ACTIONS(4811),
    [anon_sym_from] = ACTIONS(4811),
    [anon_sym_into] = ACTIONS(4811),
    [anon_sym_join] = ACTIONS(4811),
    [anon_sym_on] = ACTIONS(4811),
    [anon_sym_equals] = ACTIONS(4811),
    [anon_sym_let] = ACTIONS(4811),
    [anon_sym_orderby] = ACTIONS(4811),
    [anon_sym_group] = ACTIONS(4811),
    [anon_sym_by] = ACTIONS(4811),
    [anon_sym_select] = ACTIONS(4811),
    [anon_sym_as] = ACTIONS(4811),
    [anon_sym_is] = ACTIONS(4811),
    [anon_sym_DASH_GT] = ACTIONS(4811),
    [anon_sym_with] = ACTIONS(4811),
    [aux_sym_preproc_if_token3] = ACTIONS(4811),
    [aux_sym_preproc_else_token1] = ACTIONS(4811),
    [aux_sym_preproc_elif_token1] = ACTIONS(4811),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2916] = {
    [sym_preproc_region] = STATE(2916),
    [sym_preproc_endregion] = STATE(2916),
    [sym_preproc_line] = STATE(2916),
    [sym_preproc_pragma] = STATE(2916),
    [sym_preproc_nullable] = STATE(2916),
    [sym_preproc_error] = STATE(2916),
    [sym_preproc_warning] = STATE(2916),
    [sym_preproc_define] = STATE(2916),
    [sym_preproc_undef] = STATE(2916),
    [sym__identifier_token] = ACTIONS(4219),
    [anon_sym_alias] = ACTIONS(4219),
    [anon_sym_global] = ACTIONS(4219),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COLON] = ACTIONS(4221),
    [anon_sym_LPAREN] = ACTIONS(4221),
    [anon_sym_file] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_where] = ACTIONS(4219),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_notnull] = ACTIONS(4219),
    [anon_sym_unmanaged] = ACTIONS(4219),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_scoped] = ACTIONS(4219),
    [anon_sym_var] = ACTIONS(4219),
    [anon_sym_yield] = ACTIONS(4219),
    [anon_sym_switch] = ACTIONS(4293),
    [anon_sym_when] = ACTIONS(4219),
    [sym_discard] = ACTIONS(4219),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4219),
    [anon_sym_or] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_from] = ACTIONS(4219),
    [anon_sym_into] = ACTIONS(4219),
    [anon_sym_join] = ACTIONS(4219),
    [anon_sym_on] = ACTIONS(4219),
    [anon_sym_equals] = ACTIONS(4219),
    [anon_sym_let] = ACTIONS(4219),
    [anon_sym_orderby] = ACTIONS(4219),
    [anon_sym_ascending] = ACTIONS(4219),
    [anon_sym_descending] = ACTIONS(4219),
    [anon_sym_group] = ACTIONS(4219),
    [anon_sym_by] = ACTIONS(4219),
    [anon_sym_select] = ACTIONS(4219),
    [anon_sym_as] = ACTIONS(4293),
    [anon_sym_is] = ACTIONS(4293),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2917] = {
    [sym_preproc_region] = STATE(2917),
    [sym_preproc_endregion] = STATE(2917),
    [sym_preproc_line] = STATE(2917),
    [sym_preproc_pragma] = STATE(2917),
    [sym_preproc_nullable] = STATE(2917),
    [sym_preproc_error] = STATE(2917),
    [sym_preproc_warning] = STATE(2917),
    [sym_preproc_define] = STATE(2917),
    [sym_preproc_undef] = STATE(2917),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_where] = ACTIONS(4239),
    [anon_sym_QMARK] = ACTIONS(4241),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4241),
    [anon_sym_SLASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_CARET] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(4241),
    [anon_sym_GT_GT_GT] = ACTIONS(4241),
    [anon_sym_EQ_EQ] = ACTIONS(4239),
    [anon_sym_BANG_EQ] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4241),
    [anon_sym_switch] = ACTIONS(4239),
    [anon_sym_DOT_DOT] = ACTIONS(4239),
    [anon_sym_and] = ACTIONS(4239),
    [anon_sym_or] = ACTIONS(4241),
    [anon_sym_PLUS_EQ] = ACTIONS(4239),
    [anon_sym_DASH_EQ] = ACTIONS(4239),
    [anon_sym_STAR_EQ] = ACTIONS(4239),
    [anon_sym_SLASH_EQ] = ACTIONS(4239),
    [anon_sym_PERCENT_EQ] = ACTIONS(4239),
    [anon_sym_AMP_EQ] = ACTIONS(4239),
    [anon_sym_CARET_EQ] = ACTIONS(4239),
    [anon_sym_PIPE_EQ] = ACTIONS(4239),
    [anon_sym_LT_LT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK] = ACTIONS(4241),
    [anon_sym_from] = ACTIONS(4239),
    [anon_sym_into] = ACTIONS(4239),
    [anon_sym_join] = ACTIONS(4239),
    [anon_sym_let] = ACTIONS(4239),
    [anon_sym_orderby] = ACTIONS(4239),
    [anon_sym_ascending] = ACTIONS(4239),
    [anon_sym_descending] = ACTIONS(4239),
    [anon_sym_group] = ACTIONS(4239),
    [anon_sym_select] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4241),
    [anon_sym_is] = ACTIONS(4239),
    [anon_sym_DASH_GT] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2918] = {
    [sym_preproc_region] = STATE(2918),
    [sym_preproc_endregion] = STATE(2918),
    [sym_preproc_line] = STATE(2918),
    [sym_preproc_pragma] = STATE(2918),
    [sym_preproc_nullable] = STATE(2918),
    [sym_preproc_error] = STATE(2918),
    [sym_preproc_warning] = STATE(2918),
    [sym_preproc_define] = STATE(2918),
    [sym_preproc_undef] = STATE(2918),
    [sym__identifier_token] = ACTIONS(4182),
    [anon_sym_alias] = ACTIONS(4182),
    [anon_sym_global] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_file] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_notnull] = ACTIONS(4182),
    [anon_sym_unmanaged] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_scoped] = ACTIONS(4182),
    [anon_sym_var] = ACTIONS(4182),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_when] = ACTIONS(4182),
    [sym_discard] = ACTIONS(4182),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(4182),
    [anon_sym_into] = ACTIONS(4182),
    [anon_sym_join] = ACTIONS(4182),
    [anon_sym_on] = ACTIONS(4182),
    [anon_sym_equals] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_orderby] = ACTIONS(4182),
    [anon_sym_ascending] = ACTIONS(4182),
    [anon_sym_descending] = ACTIONS(4182),
    [anon_sym_group] = ACTIONS(4182),
    [anon_sym_by] = ACTIONS(4182),
    [anon_sym_select] = ACTIONS(4182),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2981),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2981),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2919] = {
    [sym_preproc_region] = STATE(2919),
    [sym_preproc_endregion] = STATE(2919),
    [sym_preproc_line] = STATE(2919),
    [sym_preproc_pragma] = STATE(2919),
    [sym_preproc_nullable] = STATE(2919),
    [sym_preproc_error] = STATE(2919),
    [sym_preproc_warning] = STATE(2919),
    [sym_preproc_define] = STATE(2919),
    [sym_preproc_undef] = STATE(2919),
    [sym__identifier_token] = ACTIONS(4817),
    [anon_sym_extern] = ACTIONS(4817),
    [anon_sym_alias] = ACTIONS(4817),
    [anon_sym_global] = ACTIONS(4817),
    [anon_sym_unsafe] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym_event] = ACTIONS(4817),
    [anon_sym_class] = ACTIONS(4817),
    [anon_sym_ref] = ACTIONS(4817),
    [anon_sym_struct] = ACTIONS(4817),
    [anon_sym_enum] = ACTIONS(4817),
    [anon_sym_interface] = ACTIONS(4817),
    [anon_sym_delegate] = ACTIONS(4817),
    [anon_sym_record] = ACTIONS(4817),
    [anon_sym_abstract] = ACTIONS(4817),
    [anon_sym_async] = ACTIONS(4817),
    [anon_sym_const] = ACTIONS(4817),
    [anon_sym_file] = ACTIONS(4817),
    [anon_sym_fixed] = ACTIONS(4817),
    [anon_sym_internal] = ACTIONS(4817),
    [anon_sym_new] = ACTIONS(4817),
    [anon_sym_override] = ACTIONS(4817),
    [anon_sym_partial] = ACTIONS(4817),
    [anon_sym_private] = ACTIONS(4817),
    [anon_sym_protected] = ACTIONS(4817),
    [anon_sym_public] = ACTIONS(4817),
    [anon_sym_readonly] = ACTIONS(4817),
    [anon_sym_required] = ACTIONS(4817),
    [anon_sym_sealed] = ACTIONS(4817),
    [anon_sym_virtual] = ACTIONS(4817),
    [anon_sym_volatile] = ACTIONS(4817),
    [anon_sym_where] = ACTIONS(4817),
    [anon_sym_notnull] = ACTIONS(4817),
    [anon_sym_unmanaged] = ACTIONS(4817),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_implicit] = ACTIONS(4817),
    [anon_sym_explicit] = ACTIONS(4817),
    [anon_sym_scoped] = ACTIONS(4817),
    [anon_sym_var] = ACTIONS(4817),
    [sym_predefined_type] = ACTIONS(4817),
    [anon_sym_yield] = ACTIONS(4817),
    [anon_sym_when] = ACTIONS(4817),
    [anon_sym_from] = ACTIONS(4817),
    [anon_sym_into] = ACTIONS(4817),
    [anon_sym_join] = ACTIONS(4817),
    [anon_sym_on] = ACTIONS(4817),
    [anon_sym_equals] = ACTIONS(4817),
    [anon_sym_let] = ACTIONS(4817),
    [anon_sym_orderby] = ACTIONS(4817),
    [anon_sym_ascending] = ACTIONS(4817),
    [anon_sym_descending] = ACTIONS(4817),
    [anon_sym_group] = ACTIONS(4817),
    [anon_sym_by] = ACTIONS(4817),
    [anon_sym_select] = ACTIONS(4817),
    [aux_sym_preproc_if_token1] = ACTIONS(4819),
    [aux_sym_preproc_if_token3] = ACTIONS(4819),
    [aux_sym_preproc_else_token1] = ACTIONS(4819),
    [aux_sym_preproc_elif_token1] = ACTIONS(4819),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2920] = {
    [sym_preproc_region] = STATE(2920),
    [sym_preproc_endregion] = STATE(2920),
    [sym_preproc_line] = STATE(2920),
    [sym_preproc_pragma] = STATE(2920),
    [sym_preproc_nullable] = STATE(2920),
    [sym_preproc_error] = STATE(2920),
    [sym_preproc_warning] = STATE(2920),
    [sym_preproc_define] = STATE(2920),
    [sym_preproc_undef] = STATE(2920),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4821),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2921] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter] = STATE(6893),
    [sym__parameter_array] = STATE(6838),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6181),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5765),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(2921),
    [sym_preproc_endregion] = STATE(2921),
    [sym_preproc_line] = STATE(2921),
    [sym_preproc_pragma] = STATE(2921),
    [sym_preproc_nullable] = STATE(2921),
    [sym_preproc_error] = STATE(2921),
    [sym_preproc_warning] = STATE(2921),
    [sym_preproc_define] = STATE(2921),
    [sym_preproc_undef] = STATE(2921),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3012),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2922] = {
    [sym_preproc_region] = STATE(2922),
    [sym_preproc_endregion] = STATE(2922),
    [sym_preproc_line] = STATE(2922),
    [sym_preproc_pragma] = STATE(2922),
    [sym_preproc_nullable] = STATE(2922),
    [sym_preproc_error] = STATE(2922),
    [sym_preproc_warning] = STATE(2922),
    [sym_preproc_define] = STATE(2922),
    [sym_preproc_undef] = STATE(2922),
    [sym__identifier_token] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_alias] = ACTIONS(4823),
    [anon_sym_global] = ACTIONS(4823),
    [anon_sym_unsafe] = ACTIONS(4823),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4825),
    [anon_sym_LPAREN] = ACTIONS(4825),
    [anon_sym_event] = ACTIONS(4823),
    [anon_sym_class] = ACTIONS(4823),
    [anon_sym_ref] = ACTIONS(4823),
    [anon_sym_struct] = ACTIONS(4823),
    [anon_sym_enum] = ACTIONS(4823),
    [anon_sym_interface] = ACTIONS(4823),
    [anon_sym_delegate] = ACTIONS(4823),
    [anon_sym_record] = ACTIONS(4823),
    [anon_sym_abstract] = ACTIONS(4823),
    [anon_sym_async] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_file] = ACTIONS(4823),
    [anon_sym_fixed] = ACTIONS(4823),
    [anon_sym_internal] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_override] = ACTIONS(4823),
    [anon_sym_partial] = ACTIONS(4823),
    [anon_sym_private] = ACTIONS(4823),
    [anon_sym_protected] = ACTIONS(4823),
    [anon_sym_public] = ACTIONS(4823),
    [anon_sym_readonly] = ACTIONS(4823),
    [anon_sym_required] = ACTIONS(4823),
    [anon_sym_sealed] = ACTIONS(4823),
    [anon_sym_virtual] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym_where] = ACTIONS(4823),
    [anon_sym_notnull] = ACTIONS(4823),
    [anon_sym_unmanaged] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4825),
    [anon_sym_implicit] = ACTIONS(4823),
    [anon_sym_explicit] = ACTIONS(4823),
    [anon_sym_scoped] = ACTIONS(4823),
    [anon_sym_var] = ACTIONS(4823),
    [sym_predefined_type] = ACTIONS(4823),
    [anon_sym_yield] = ACTIONS(4823),
    [anon_sym_when] = ACTIONS(4823),
    [anon_sym_from] = ACTIONS(4823),
    [anon_sym_into] = ACTIONS(4823),
    [anon_sym_join] = ACTIONS(4823),
    [anon_sym_on] = ACTIONS(4823),
    [anon_sym_equals] = ACTIONS(4823),
    [anon_sym_let] = ACTIONS(4823),
    [anon_sym_orderby] = ACTIONS(4823),
    [anon_sym_ascending] = ACTIONS(4823),
    [anon_sym_descending] = ACTIONS(4823),
    [anon_sym_group] = ACTIONS(4823),
    [anon_sym_by] = ACTIONS(4823),
    [anon_sym_select] = ACTIONS(4823),
    [aux_sym_preproc_if_token1] = ACTIONS(4825),
    [aux_sym_preproc_if_token3] = ACTIONS(4825),
    [aux_sym_preproc_else_token1] = ACTIONS(4825),
    [aux_sym_preproc_elif_token1] = ACTIONS(4825),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2923] = {
    [sym_preproc_region] = STATE(2923),
    [sym_preproc_endregion] = STATE(2923),
    [sym_preproc_line] = STATE(2923),
    [sym_preproc_pragma] = STATE(2923),
    [sym_preproc_nullable] = STATE(2923),
    [sym_preproc_error] = STATE(2923),
    [sym_preproc_warning] = STATE(2923),
    [sym_preproc_define] = STATE(2923),
    [sym_preproc_undef] = STATE(2923),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4827),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2924] = {
    [sym_preproc_region] = STATE(2924),
    [sym_preproc_endregion] = STATE(2924),
    [sym_preproc_line] = STATE(2924),
    [sym_preproc_pragma] = STATE(2924),
    [sym_preproc_nullable] = STATE(2924),
    [sym_preproc_error] = STATE(2924),
    [sym_preproc_warning] = STATE(2924),
    [sym_preproc_define] = STATE(2924),
    [sym_preproc_undef] = STATE(2924),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4829),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2925] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter] = STATE(6859),
    [sym__parameter_array] = STATE(6861),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6181),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5765),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(2925),
    [sym_preproc_endregion] = STATE(2925),
    [sym_preproc_line] = STATE(2925),
    [sym_preproc_pragma] = STATE(2925),
    [sym_preproc_nullable] = STATE(2925),
    [sym_preproc_error] = STATE(2925),
    [sym_preproc_warning] = STATE(2925),
    [sym_preproc_define] = STATE(2925),
    [sym_preproc_undef] = STATE(2925),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3012),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_RBRACK] = ACTIONS(4831),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2926] = {
    [sym_preproc_region] = STATE(2926),
    [sym_preproc_endregion] = STATE(2926),
    [sym_preproc_line] = STATE(2926),
    [sym_preproc_pragma] = STATE(2926),
    [sym_preproc_nullable] = STATE(2926),
    [sym_preproc_error] = STATE(2926),
    [sym_preproc_warning] = STATE(2926),
    [sym_preproc_define] = STATE(2926),
    [sym_preproc_undef] = STATE(2926),
    [sym__identifier_token] = ACTIONS(4833),
    [anon_sym_extern] = ACTIONS(4833),
    [anon_sym_alias] = ACTIONS(4833),
    [anon_sym_global] = ACTIONS(4833),
    [anon_sym_unsafe] = ACTIONS(4833),
    [anon_sym_static] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4835),
    [anon_sym_LPAREN] = ACTIONS(4835),
    [anon_sym_event] = ACTIONS(4833),
    [anon_sym_class] = ACTIONS(4833),
    [anon_sym_ref] = ACTIONS(4833),
    [anon_sym_struct] = ACTIONS(4833),
    [anon_sym_enum] = ACTIONS(4833),
    [anon_sym_interface] = ACTIONS(4833),
    [anon_sym_delegate] = ACTIONS(4833),
    [anon_sym_record] = ACTIONS(4833),
    [anon_sym_abstract] = ACTIONS(4833),
    [anon_sym_async] = ACTIONS(4833),
    [anon_sym_const] = ACTIONS(4833),
    [anon_sym_file] = ACTIONS(4833),
    [anon_sym_fixed] = ACTIONS(4833),
    [anon_sym_internal] = ACTIONS(4833),
    [anon_sym_new] = ACTIONS(4833),
    [anon_sym_override] = ACTIONS(4833),
    [anon_sym_partial] = ACTIONS(4833),
    [anon_sym_private] = ACTIONS(4833),
    [anon_sym_protected] = ACTIONS(4833),
    [anon_sym_public] = ACTIONS(4833),
    [anon_sym_readonly] = ACTIONS(4833),
    [anon_sym_required] = ACTIONS(4833),
    [anon_sym_sealed] = ACTIONS(4833),
    [anon_sym_virtual] = ACTIONS(4833),
    [anon_sym_volatile] = ACTIONS(4833),
    [anon_sym_where] = ACTIONS(4833),
    [anon_sym_notnull] = ACTIONS(4833),
    [anon_sym_unmanaged] = ACTIONS(4833),
    [anon_sym_TILDE] = ACTIONS(4835),
    [anon_sym_implicit] = ACTIONS(4833),
    [anon_sym_explicit] = ACTIONS(4833),
    [anon_sym_scoped] = ACTIONS(4833),
    [anon_sym_var] = ACTIONS(4833),
    [sym_predefined_type] = ACTIONS(4833),
    [anon_sym_yield] = ACTIONS(4833),
    [anon_sym_when] = ACTIONS(4833),
    [anon_sym_from] = ACTIONS(4833),
    [anon_sym_into] = ACTIONS(4833),
    [anon_sym_join] = ACTIONS(4833),
    [anon_sym_on] = ACTIONS(4833),
    [anon_sym_equals] = ACTIONS(4833),
    [anon_sym_let] = ACTIONS(4833),
    [anon_sym_orderby] = ACTIONS(4833),
    [anon_sym_ascending] = ACTIONS(4833),
    [anon_sym_descending] = ACTIONS(4833),
    [anon_sym_group] = ACTIONS(4833),
    [anon_sym_by] = ACTIONS(4833),
    [anon_sym_select] = ACTIONS(4833),
    [aux_sym_preproc_if_token1] = ACTIONS(4835),
    [aux_sym_preproc_if_token3] = ACTIONS(4835),
    [aux_sym_preproc_else_token1] = ACTIONS(4835),
    [aux_sym_preproc_elif_token1] = ACTIONS(4835),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2927] = {
    [sym_preproc_region] = STATE(2927),
    [sym_preproc_endregion] = STATE(2927),
    [sym_preproc_line] = STATE(2927),
    [sym_preproc_pragma] = STATE(2927),
    [sym_preproc_nullable] = STATE(2927),
    [sym_preproc_error] = STATE(2927),
    [sym_preproc_warning] = STATE(2927),
    [sym_preproc_define] = STATE(2927),
    [sym_preproc_undef] = STATE(2927),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(3167),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_RBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3167),
    [anon_sym_where] = ACTIONS(3167),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3167),
    [anon_sym_GT_EQ] = ACTIONS(3167),
    [anon_sym_LT_EQ] = ACTIONS(3167),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_catch] = ACTIONS(3167),
    [anon_sym_finally] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_and] = ACTIONS(3167),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3167),
    [anon_sym_QMARK_QMARK] = ACTIONS(3167),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_join] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_orderby] = ACTIONS(3167),
    [anon_sym_group] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_select] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3167),
    [anon_sym_is] = ACTIONS(3167),
    [anon_sym_DASH_GT] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [aux_sym_preproc_if_token3] = ACTIONS(3167),
    [aux_sym_preproc_else_token1] = ACTIONS(3167),
    [aux_sym_preproc_elif_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2928] = {
    [sym_attribute_list] = STATE(3570),
    [sym__attribute_list] = STATE(3569),
    [sym_modifier] = STATE(3734),
    [sym_accessor_declaration] = STATE(3551),
    [sym_identifier] = STATE(6456),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_attribute_list] = STATE(3570),
    [sym_preproc_region] = STATE(2928),
    [sym_preproc_endregion] = STATE(2928),
    [sym_preproc_line] = STATE(2928),
    [sym_preproc_pragma] = STATE(2928),
    [sym_preproc_nullable] = STATE(2928),
    [sym_preproc_error] = STATE(2928),
    [sym_preproc_warning] = STATE(2928),
    [sym_preproc_define] = STATE(2928),
    [sym_preproc_undef] = STATE(2928),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3053),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3272),
    [aux_sym_accessor_list_repeat1] = STATE(2930),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(4787),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(4787),
    [anon_sym_static] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4789),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_abstract] = ACTIONS(4787),
    [anon_sym_async] = ACTIONS(4787),
    [anon_sym_const] = ACTIONS(4787),
    [anon_sym_file] = ACTIONS(4793),
    [anon_sym_fixed] = ACTIONS(4787),
    [anon_sym_internal] = ACTIONS(4787),
    [anon_sym_new] = ACTIONS(4787),
    [anon_sym_override] = ACTIONS(4787),
    [anon_sym_partial] = ACTIONS(4787),
    [anon_sym_private] = ACTIONS(4787),
    [anon_sym_protected] = ACTIONS(4787),
    [anon_sym_public] = ACTIONS(4787),
    [anon_sym_readonly] = ACTIONS(4787),
    [anon_sym_required] = ACTIONS(4787),
    [anon_sym_sealed] = ACTIONS(4787),
    [anon_sym_virtual] = ACTIONS(4787),
    [anon_sym_volatile] = ACTIONS(4787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_get] = ACTIONS(4795),
    [anon_sym_set] = ACTIONS(4795),
    [anon_sym_add] = ACTIONS(4795),
    [anon_sym_remove] = ACTIONS(4795),
    [anon_sym_init] = ACTIONS(4795),
    [anon_sym_scoped] = ACTIONS(29),
    [anon_sym_var] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_from] = ACTIONS(29),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [aux_sym_preproc_if_token1] = ACTIONS(4797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2929] = {
    [sym_preproc_region] = STATE(2929),
    [sym_preproc_endregion] = STATE(2929),
    [sym_preproc_line] = STATE(2929),
    [sym_preproc_pragma] = STATE(2929),
    [sym_preproc_nullable] = STATE(2929),
    [sym_preproc_error] = STATE(2929),
    [sym_preproc_warning] = STATE(2929),
    [sym_preproc_define] = STATE(2929),
    [sym_preproc_undef] = STATE(2929),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4839),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2930] = {
    [sym_attribute_list] = STATE(3570),
    [sym__attribute_list] = STATE(3569),
    [sym_modifier] = STATE(3734),
    [sym_accessor_declaration] = STATE(3551),
    [sym_identifier] = STATE(6456),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_attribute_list] = STATE(3570),
    [sym_preproc_region] = STATE(2930),
    [sym_preproc_endregion] = STATE(2930),
    [sym_preproc_line] = STATE(2930),
    [sym_preproc_pragma] = STATE(2930),
    [sym_preproc_nullable] = STATE(2930),
    [sym_preproc_error] = STATE(2930),
    [sym_preproc_warning] = STATE(2930),
    [sym_preproc_define] = STATE(2930),
    [sym_preproc_undef] = STATE(2930),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3053),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3272),
    [aux_sym_accessor_list_repeat1] = STATE(2930),
    [sym__identifier_token] = ACTIONS(4841),
    [anon_sym_extern] = ACTIONS(4844),
    [anon_sym_alias] = ACTIONS(4847),
    [anon_sym_global] = ACTIONS(4847),
    [anon_sym_unsafe] = ACTIONS(4844),
    [anon_sym_static] = ACTIONS(4844),
    [anon_sym_LBRACK] = ACTIONS(4850),
    [anon_sym_RBRACE] = ACTIONS(4853),
    [anon_sym_abstract] = ACTIONS(4844),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_const] = ACTIONS(4844),
    [anon_sym_file] = ACTIONS(4855),
    [anon_sym_fixed] = ACTIONS(4844),
    [anon_sym_internal] = ACTIONS(4844),
    [anon_sym_new] = ACTIONS(4844),
    [anon_sym_override] = ACTIONS(4844),
    [anon_sym_partial] = ACTIONS(4844),
    [anon_sym_private] = ACTIONS(4844),
    [anon_sym_protected] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4844),
    [anon_sym_readonly] = ACTIONS(4844),
    [anon_sym_required] = ACTIONS(4844),
    [anon_sym_sealed] = ACTIONS(4844),
    [anon_sym_virtual] = ACTIONS(4844),
    [anon_sym_volatile] = ACTIONS(4844),
    [anon_sym_where] = ACTIONS(4847),
    [anon_sym_notnull] = ACTIONS(4847),
    [anon_sym_unmanaged] = ACTIONS(4847),
    [anon_sym_get] = ACTIONS(4858),
    [anon_sym_set] = ACTIONS(4858),
    [anon_sym_add] = ACTIONS(4858),
    [anon_sym_remove] = ACTIONS(4858),
    [anon_sym_init] = ACTIONS(4858),
    [anon_sym_scoped] = ACTIONS(4847),
    [anon_sym_var] = ACTIONS(4847),
    [anon_sym_yield] = ACTIONS(4847),
    [anon_sym_when] = ACTIONS(4847),
    [anon_sym_from] = ACTIONS(4847),
    [anon_sym_into] = ACTIONS(4847),
    [anon_sym_join] = ACTIONS(4847),
    [anon_sym_on] = ACTIONS(4847),
    [anon_sym_equals] = ACTIONS(4847),
    [anon_sym_let] = ACTIONS(4847),
    [anon_sym_orderby] = ACTIONS(4847),
    [anon_sym_ascending] = ACTIONS(4847),
    [anon_sym_descending] = ACTIONS(4847),
    [anon_sym_group] = ACTIONS(4847),
    [anon_sym_by] = ACTIONS(4847),
    [anon_sym_select] = ACTIONS(4847),
    [aux_sym_preproc_if_token1] = ACTIONS(4861),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2931] = {
    [sym_preproc_region] = STATE(2931),
    [sym_preproc_endregion] = STATE(2931),
    [sym_preproc_line] = STATE(2931),
    [sym_preproc_pragma] = STATE(2931),
    [sym_preproc_nullable] = STATE(2931),
    [sym_preproc_error] = STATE(2931),
    [sym_preproc_warning] = STATE(2931),
    [sym_preproc_define] = STATE(2931),
    [sym_preproc_undef] = STATE(2931),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2932] = {
    [sym_preproc_region] = STATE(2932),
    [sym_preproc_endregion] = STATE(2932),
    [sym_preproc_line] = STATE(2932),
    [sym_preproc_pragma] = STATE(2932),
    [sym_preproc_nullable] = STATE(2932),
    [sym_preproc_error] = STATE(2932),
    [sym_preproc_warning] = STATE(2932),
    [sym_preproc_define] = STATE(2932),
    [sym_preproc_undef] = STATE(2932),
    [sym__identifier_token] = ACTIONS(4022),
    [anon_sym_alias] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_notnull] = ACTIONS(4022),
    [anon_sym_unmanaged] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4866),
    [anon_sym_scoped] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_switch] = ACTIONS(4022),
    [anon_sym_when] = ACTIONS(4022),
    [sym_discard] = ACTIONS(4022),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4022),
    [anon_sym_into] = ACTIONS(4022),
    [anon_sym_join] = ACTIONS(4022),
    [anon_sym_on] = ACTIONS(4022),
    [anon_sym_equals] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_orderby] = ACTIONS(4022),
    [anon_sym_ascending] = ACTIONS(4022),
    [anon_sym_descending] = ACTIONS(4022),
    [anon_sym_group] = ACTIONS(4022),
    [anon_sym_by] = ACTIONS(4022),
    [anon_sym_select] = ACTIONS(4022),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_is] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2933] = {
    [sym_preproc_region] = STATE(2933),
    [sym_preproc_endregion] = STATE(2933),
    [sym_preproc_line] = STATE(2933),
    [sym_preproc_pragma] = STATE(2933),
    [sym_preproc_nullable] = STATE(2933),
    [sym_preproc_error] = STATE(2933),
    [sym_preproc_warning] = STATE(2933),
    [sym_preproc_define] = STATE(2933),
    [sym_preproc_undef] = STATE(2933),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_where] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4192),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_from] = ACTIONS(4186),
    [anon_sym_into] = ACTIONS(4186),
    [anon_sym_join] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_orderby] = ACTIONS(4186),
    [anon_sym_ascending] = ACTIONS(4186),
    [anon_sym_descending] = ACTIONS(4186),
    [anon_sym_group] = ACTIONS(4186),
    [anon_sym_select] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4192),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2934] = {
    [sym_preproc_region] = STATE(2934),
    [sym_preproc_endregion] = STATE(2934),
    [sym_preproc_line] = STATE(2934),
    [sym_preproc_pragma] = STATE(2934),
    [sym_preproc_nullable] = STATE(2934),
    [sym_preproc_error] = STATE(2934),
    [sym_preproc_warning] = STATE(2934),
    [sym_preproc_define] = STATE(2934),
    [sym_preproc_undef] = STATE(2934),
    [anon_sym_EQ] = ACTIONS(4235),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_COMMA] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4233),
    [anon_sym_LT] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4235),
    [anon_sym_where] = ACTIONS(4233),
    [anon_sym_QMARK] = ACTIONS(4235),
    [anon_sym_BANG] = ACTIONS(4235),
    [anon_sym_PLUS_PLUS] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4235),
    [anon_sym_DASH] = ACTIONS(4235),
    [anon_sym_STAR] = ACTIONS(4235),
    [anon_sym_SLASH] = ACTIONS(4235),
    [anon_sym_PERCENT] = ACTIONS(4235),
    [anon_sym_CARET] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4235),
    [anon_sym_LT_LT] = ACTIONS(4235),
    [anon_sym_GT_GT] = ACTIONS(4235),
    [anon_sym_GT_GT_GT] = ACTIONS(4235),
    [anon_sym_EQ_EQ] = ACTIONS(4233),
    [anon_sym_BANG_EQ] = ACTIONS(4233),
    [anon_sym_GT_EQ] = ACTIONS(4233),
    [anon_sym_LT_EQ] = ACTIONS(4233),
    [anon_sym_DOT] = ACTIONS(4235),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_DOT_DOT] = ACTIONS(4233),
    [anon_sym_and] = ACTIONS(4233),
    [anon_sym_or] = ACTIONS(4235),
    [anon_sym_PLUS_EQ] = ACTIONS(4233),
    [anon_sym_DASH_EQ] = ACTIONS(4233),
    [anon_sym_STAR_EQ] = ACTIONS(4233),
    [anon_sym_SLASH_EQ] = ACTIONS(4233),
    [anon_sym_PERCENT_EQ] = ACTIONS(4233),
    [anon_sym_AMP_EQ] = ACTIONS(4233),
    [anon_sym_CARET_EQ] = ACTIONS(4233),
    [anon_sym_PIPE_EQ] = ACTIONS(4233),
    [anon_sym_LT_LT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4233),
    [anon_sym_AMP_AMP] = ACTIONS(4233),
    [anon_sym_PIPE_PIPE] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK] = ACTIONS(4235),
    [anon_sym_from] = ACTIONS(4233),
    [anon_sym_into] = ACTIONS(4233),
    [anon_sym_join] = ACTIONS(4233),
    [anon_sym_let] = ACTIONS(4233),
    [anon_sym_orderby] = ACTIONS(4233),
    [anon_sym_ascending] = ACTIONS(4233),
    [anon_sym_descending] = ACTIONS(4233),
    [anon_sym_group] = ACTIONS(4233),
    [anon_sym_select] = ACTIONS(4233),
    [anon_sym_as] = ACTIONS(4235),
    [anon_sym_is] = ACTIONS(4233),
    [anon_sym_DASH_GT] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2935] = {
    [sym_type_argument_list] = STATE(2991),
    [sym_preproc_region] = STATE(2935),
    [sym_preproc_endregion] = STATE(2935),
    [sym_preproc_line] = STATE(2935),
    [sym_preproc_pragma] = STATE(2935),
    [sym_preproc_nullable] = STATE(2935),
    [sym_preproc_error] = STATE(2935),
    [sym_preproc_warning] = STATE(2935),
    [sym_preproc_define] = STATE(2935),
    [sym_preproc_undef] = STATE(2935),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4868),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2936] = {
    [sym_preproc_region] = STATE(2936),
    [sym_preproc_endregion] = STATE(2936),
    [sym_preproc_line] = STATE(2936),
    [sym_preproc_pragma] = STATE(2936),
    [sym_preproc_nullable] = STATE(2936),
    [sym_preproc_error] = STATE(2936),
    [sym_preproc_warning] = STATE(2936),
    [sym_preproc_define] = STATE(2936),
    [sym_preproc_undef] = STATE(2936),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4168),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_SLASH] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_CARET] = ACTIONS(4170),
    [anon_sym_PIPE] = ACTIONS(4170),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_GT] = ACTIONS(4170),
    [anon_sym_GT_GT_GT] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4168),
    [anon_sym_BANG_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4168),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_and] = ACTIONS(4168),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_PLUS_EQ] = ACTIONS(4168),
    [anon_sym_DASH_EQ] = ACTIONS(4168),
    [anon_sym_STAR_EQ] = ACTIONS(4168),
    [anon_sym_SLASH_EQ] = ACTIONS(4168),
    [anon_sym_PERCENT_EQ] = ACTIONS(4168),
    [anon_sym_AMP_EQ] = ACTIONS(4168),
    [anon_sym_CARET_EQ] = ACTIONS(4168),
    [anon_sym_PIPE_EQ] = ACTIONS(4168),
    [anon_sym_LT_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK] = ACTIONS(4170),
    [anon_sym_from] = ACTIONS(4168),
    [anon_sym_into] = ACTIONS(4168),
    [anon_sym_join] = ACTIONS(4168),
    [anon_sym_let] = ACTIONS(4168),
    [anon_sym_orderby] = ACTIONS(4168),
    [anon_sym_ascending] = ACTIONS(4168),
    [anon_sym_descending] = ACTIONS(4168),
    [anon_sym_group] = ACTIONS(4168),
    [anon_sym_select] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4170),
    [anon_sym_is] = ACTIONS(4168),
    [anon_sym_DASH_GT] = ACTIONS(4168),
    [anon_sym_with] = ACTIONS(4168),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2937] = {
    [sym_preproc_region] = STATE(2937),
    [sym_preproc_endregion] = STATE(2937),
    [sym_preproc_line] = STATE(2937),
    [sym_preproc_pragma] = STATE(2937),
    [sym_preproc_nullable] = STATE(2937),
    [sym_preproc_error] = STATE(2937),
    [sym_preproc_warning] = STATE(2937),
    [sym_preproc_define] = STATE(2937),
    [sym_preproc_undef] = STATE(2937),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_where] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_GT_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4188),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK] = ACTIONS(4188),
    [anon_sym_from] = ACTIONS(4190),
    [anon_sym_into] = ACTIONS(4190),
    [anon_sym_join] = ACTIONS(4190),
    [anon_sym_let] = ACTIONS(4190),
    [anon_sym_orderby] = ACTIONS(4190),
    [anon_sym_ascending] = ACTIONS(4190),
    [anon_sym_descending] = ACTIONS(4190),
    [anon_sym_group] = ACTIONS(4190),
    [anon_sym_select] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4188),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2938] = {
    [sym_preproc_region] = STATE(2938),
    [sym_preproc_endregion] = STATE(2938),
    [sym_preproc_line] = STATE(2938),
    [sym_preproc_pragma] = STATE(2938),
    [sym_preproc_nullable] = STATE(2938),
    [sym_preproc_error] = STATE(2938),
    [sym_preproc_warning] = STATE(2938),
    [sym_preproc_define] = STATE(2938),
    [sym_preproc_undef] = STATE(2938),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4297),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(4300),
    [anon_sym_where] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_BANG] = ACTIONS(4300),
    [anon_sym_PLUS_PLUS] = ACTIONS(4297),
    [anon_sym_DASH_DASH] = ACTIONS(4297),
    [anon_sym_PLUS] = ACTIONS(4300),
    [anon_sym_DASH] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_SLASH] = ACTIONS(4300),
    [anon_sym_PERCENT] = ACTIONS(4300),
    [anon_sym_CARET] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4300),
    [anon_sym_GT_GT] = ACTIONS(4300),
    [anon_sym_GT_GT_GT] = ACTIONS(4300),
    [anon_sym_EQ_EQ] = ACTIONS(4297),
    [anon_sym_BANG_EQ] = ACTIONS(4297),
    [anon_sym_GT_EQ] = ACTIONS(4297),
    [anon_sym_LT_EQ] = ACTIONS(4297),
    [anon_sym_DOT] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(4297),
    [anon_sym_DOT_DOT] = ACTIONS(4297),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4303),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4297),
    [anon_sym_QMARK_QMARK] = ACTIONS(4300),
    [anon_sym_from] = ACTIONS(4295),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_join] = ACTIONS(4295),
    [anon_sym_let] = ACTIONS(4295),
    [anon_sym_orderby] = ACTIONS(4295),
    [anon_sym_ascending] = ACTIONS(4295),
    [anon_sym_descending] = ACTIONS(4295),
    [anon_sym_group] = ACTIONS(4295),
    [anon_sym_select] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(4300),
    [anon_sym_is] = ACTIONS(4297),
    [anon_sym_DASH_GT] = ACTIONS(4297),
    [anon_sym_with] = ACTIONS(4297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2939] = {
    [sym_initializer_expression] = STATE(3099),
    [sym_preproc_region] = STATE(2939),
    [sym_preproc_endregion] = STATE(2939),
    [sym_preproc_line] = STATE(2939),
    [sym_preproc_pragma] = STATE(2939),
    [sym_preproc_nullable] = STATE(2939),
    [sym_preproc_error] = STATE(2939),
    [sym_preproc_warning] = STATE(2939),
    [sym_preproc_define] = STATE(2939),
    [sym_preproc_undef] = STATE(2939),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_RBRACK] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_LT] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4873),
    [anon_sym_in] = ACTIONS(4873),
    [anon_sym_where] = ACTIONS(4871),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_BANG] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4873),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_SLASH] = ACTIONS(4873),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4873),
    [anon_sym_AMP] = ACTIONS(4873),
    [anon_sym_LT_LT] = ACTIONS(4871),
    [anon_sym_GT_GT] = ACTIONS(4873),
    [anon_sym_GT_GT_GT] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4871),
    [anon_sym_BANG_EQ] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4871),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4873),
    [anon_sym_EQ_GT] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(4871),
    [anon_sym_DOT_DOT] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_or] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE] = ACTIONS(4871),
    [anon_sym_QMARK_QMARK] = ACTIONS(4871),
    [anon_sym_from] = ACTIONS(4871),
    [anon_sym_into] = ACTIONS(4871),
    [anon_sym_join] = ACTIONS(4871),
    [anon_sym_on] = ACTIONS(4871),
    [anon_sym_equals] = ACTIONS(4871),
    [anon_sym_let] = ACTIONS(4871),
    [anon_sym_orderby] = ACTIONS(4871),
    [anon_sym_group] = ACTIONS(4871),
    [anon_sym_by] = ACTIONS(4871),
    [anon_sym_select] = ACTIONS(4871),
    [anon_sym_as] = ACTIONS(4871),
    [anon_sym_is] = ACTIONS(4871),
    [anon_sym_DASH_GT] = ACTIONS(4871),
    [anon_sym_with] = ACTIONS(4871),
    [aux_sym_preproc_if_token3] = ACTIONS(4871),
    [aux_sym_preproc_else_token1] = ACTIONS(4871),
    [aux_sym_preproc_elif_token1] = ACTIONS(4871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2940] = {
    [sym_argument_list] = STATE(3081),
    [sym_bracketed_argument_list] = STATE(2469),
    [sym_preproc_region] = STATE(2940),
    [sym_preproc_endregion] = STATE(2940),
    [sym_preproc_line] = STATE(2940),
    [sym_preproc_pragma] = STATE(2940),
    [sym_preproc_nullable] = STATE(2940),
    [sym_preproc_error] = STATE(2940),
    [sym_preproc_warning] = STATE(2940),
    [sym_preproc_define] = STATE(2940),
    [sym_preproc_undef] = STATE(2940),
    [anon_sym_SEMI] = ACTIONS(4875),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_RBRACK] = ACTIONS(4875),
    [anon_sym_LPAREN] = ACTIONS(4813),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [anon_sym_LT] = ACTIONS(4879),
    [anon_sym_GT] = ACTIONS(4879),
    [anon_sym_in] = ACTIONS(4879),
    [anon_sym_where] = ACTIONS(4875),
    [anon_sym_QMARK] = ACTIONS(4879),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_PLUS_PLUS] = ACTIONS(4883),
    [anon_sym_DASH_DASH] = ACTIONS(4883),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4875),
    [anon_sym_SLASH] = ACTIONS(4879),
    [anon_sym_PERCENT] = ACTIONS(4875),
    [anon_sym_CARET] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4879),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_LT_LT] = ACTIONS(4875),
    [anon_sym_GT_GT] = ACTIONS(4879),
    [anon_sym_GT_GT_GT] = ACTIONS(4875),
    [anon_sym_EQ_EQ] = ACTIONS(4875),
    [anon_sym_BANG_EQ] = ACTIONS(4875),
    [anon_sym_GT_EQ] = ACTIONS(4875),
    [anon_sym_LT_EQ] = ACTIONS(4875),
    [anon_sym_DOT] = ACTIONS(4829),
    [anon_sym_EQ_GT] = ACTIONS(4875),
    [anon_sym_switch] = ACTIONS(4875),
    [anon_sym_DOT_DOT] = ACTIONS(4875),
    [anon_sym_and] = ACTIONS(4875),
    [anon_sym_or] = ACTIONS(4879),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_PIPE_PIPE] = ACTIONS(4875),
    [anon_sym_QMARK_QMARK] = ACTIONS(4875),
    [anon_sym_from] = ACTIONS(4875),
    [anon_sym_into] = ACTIONS(4875),
    [anon_sym_join] = ACTIONS(4875),
    [anon_sym_on] = ACTIONS(4875),
    [anon_sym_equals] = ACTIONS(4875),
    [anon_sym_let] = ACTIONS(4875),
    [anon_sym_orderby] = ACTIONS(4875),
    [anon_sym_group] = ACTIONS(4875),
    [anon_sym_by] = ACTIONS(4875),
    [anon_sym_select] = ACTIONS(4875),
    [anon_sym_as] = ACTIONS(4875),
    [anon_sym_is] = ACTIONS(4875),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4875),
    [aux_sym_preproc_if_token3] = ACTIONS(4875),
    [aux_sym_preproc_else_token1] = ACTIONS(4875),
    [aux_sym_preproc_elif_token1] = ACTIONS(4875),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2941] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter] = STATE(6832),
    [sym__parameter_array] = STATE(6842),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6181),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5765),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(2941),
    [sym_preproc_endregion] = STATE(2941),
    [sym_preproc_line] = STATE(2941),
    [sym_preproc_pragma] = STATE(2941),
    [sym_preproc_nullable] = STATE(2941),
    [sym_preproc_error] = STATE(2941),
    [sym_preproc_warning] = STATE(2941),
    [sym_preproc_define] = STATE(2941),
    [sym_preproc_undef] = STATE(2941),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3012),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3544),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_params] = ACTIONS(1139),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2942] = {
    [sym_argument_list] = STATE(3081),
    [sym_bracketed_argument_list] = STATE(2469),
    [sym_preproc_region] = STATE(2942),
    [sym_preproc_endregion] = STATE(2942),
    [sym_preproc_line] = STATE(2942),
    [sym_preproc_pragma] = STATE(2942),
    [sym_preproc_nullable] = STATE(2942),
    [sym_preproc_error] = STATE(2942),
    [sym_preproc_warning] = STATE(2942),
    [sym_preproc_define] = STATE(2942),
    [sym_preproc_undef] = STATE(2942),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_COLON] = ACTIONS(4885),
    [anon_sym_COMMA] = ACTIONS(4885),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(4813),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_in] = ACTIONS(4887),
    [anon_sym_where] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(4887),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_PLUS_PLUS] = ACTIONS(4883),
    [anon_sym_DASH_DASH] = ACTIONS(4883),
    [anon_sym_PLUS] = ACTIONS(4887),
    [anon_sym_DASH] = ACTIONS(4887),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4887),
    [anon_sym_PERCENT] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_AMP] = ACTIONS(4887),
    [anon_sym_LT_LT] = ACTIONS(4885),
    [anon_sym_GT_GT] = ACTIONS(4887),
    [anon_sym_GT_GT_GT] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [anon_sym_GT_EQ] = ACTIONS(4885),
    [anon_sym_LT_EQ] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4829),
    [anon_sym_EQ_GT] = ACTIONS(4885),
    [anon_sym_switch] = ACTIONS(4885),
    [anon_sym_DOT_DOT] = ACTIONS(4885),
    [anon_sym_and] = ACTIONS(4885),
    [anon_sym_or] = ACTIONS(4887),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_QMARK_QMARK] = ACTIONS(4885),
    [anon_sym_from] = ACTIONS(4885),
    [anon_sym_into] = ACTIONS(4885),
    [anon_sym_join] = ACTIONS(4885),
    [anon_sym_on] = ACTIONS(4885),
    [anon_sym_equals] = ACTIONS(4885),
    [anon_sym_let] = ACTIONS(4885),
    [anon_sym_orderby] = ACTIONS(4885),
    [anon_sym_group] = ACTIONS(4885),
    [anon_sym_by] = ACTIONS(4885),
    [anon_sym_select] = ACTIONS(4885),
    [anon_sym_as] = ACTIONS(4885),
    [anon_sym_is] = ACTIONS(4885),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4885),
    [aux_sym_preproc_if_token3] = ACTIONS(4885),
    [aux_sym_preproc_else_token1] = ACTIONS(4885),
    [aux_sym_preproc_elif_token1] = ACTIONS(4885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2943] = {
    [sym_initializer_expression] = STATE(3063),
    [sym_preproc_region] = STATE(2943),
    [sym_preproc_endregion] = STATE(2943),
    [sym_preproc_line] = STATE(2943),
    [sym_preproc_pragma] = STATE(2943),
    [sym_preproc_nullable] = STATE(2943),
    [sym_preproc_error] = STATE(2943),
    [sym_preproc_warning] = STATE(2943),
    [sym_preproc_define] = STATE(2943),
    [sym_preproc_undef] = STATE(2943),
    [anon_sym_SEMI] = ACTIONS(4889),
    [anon_sym_LBRACK] = ACTIONS(4891),
    [anon_sym_COLON] = ACTIONS(4889),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RBRACK] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_in] = ACTIONS(4894),
    [anon_sym_where] = ACTIONS(4889),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_BANG] = ACTIONS(4894),
    [anon_sym_PLUS_PLUS] = ACTIONS(4889),
    [anon_sym_DASH_DASH] = ACTIONS(4889),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_SLASH] = ACTIONS(4894),
    [anon_sym_PERCENT] = ACTIONS(4889),
    [anon_sym_CARET] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4889),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_GT_GT_GT] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [anon_sym_GT_EQ] = ACTIONS(4889),
    [anon_sym_LT_EQ] = ACTIONS(4889),
    [anon_sym_DOT] = ACTIONS(4894),
    [anon_sym_EQ_GT] = ACTIONS(4889),
    [anon_sym_switch] = ACTIONS(4889),
    [anon_sym_DOT_DOT] = ACTIONS(4889),
    [anon_sym_and] = ACTIONS(4889),
    [anon_sym_or] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_QMARK_QMARK] = ACTIONS(4889),
    [anon_sym_from] = ACTIONS(4889),
    [anon_sym_into] = ACTIONS(4889),
    [anon_sym_join] = ACTIONS(4889),
    [anon_sym_on] = ACTIONS(4889),
    [anon_sym_equals] = ACTIONS(4889),
    [anon_sym_let] = ACTIONS(4889),
    [anon_sym_orderby] = ACTIONS(4889),
    [anon_sym_group] = ACTIONS(4889),
    [anon_sym_by] = ACTIONS(4889),
    [anon_sym_select] = ACTIONS(4889),
    [anon_sym_as] = ACTIONS(4889),
    [anon_sym_is] = ACTIONS(4889),
    [anon_sym_DASH_GT] = ACTIONS(4889),
    [anon_sym_with] = ACTIONS(4889),
    [aux_sym_preproc_if_token3] = ACTIONS(4889),
    [aux_sym_preproc_else_token1] = ACTIONS(4889),
    [aux_sym_preproc_elif_token1] = ACTIONS(4889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2944] = {
    [sym_preproc_region] = STATE(2944),
    [sym_preproc_endregion] = STATE(2944),
    [sym_preproc_line] = STATE(2944),
    [sym_preproc_pragma] = STATE(2944),
    [sym_preproc_nullable] = STATE(2944),
    [sym_preproc_error] = STATE(2944),
    [sym_preproc_warning] = STATE(2944),
    [sym_preproc_define] = STATE(2944),
    [sym_preproc_undef] = STATE(2944),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3716),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3731),
    [anon_sym_into] = ACTIONS(3731),
    [anon_sym_join] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_orderby] = ACTIONS(3731),
    [anon_sym_ascending] = ACTIONS(3731),
    [anon_sym_descending] = ACTIONS(3731),
    [anon_sym_group] = ACTIONS(3731),
    [anon_sym_select] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3716),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2945] = {
    [sym_preproc_region] = STATE(2945),
    [sym_preproc_endregion] = STATE(2945),
    [sym_preproc_line] = STATE(2945),
    [sym_preproc_pragma] = STATE(2945),
    [sym_preproc_nullable] = STATE(2945),
    [sym_preproc_error] = STATE(2945),
    [sym_preproc_warning] = STATE(2945),
    [sym_preproc_define] = STATE(2945),
    [sym_preproc_undef] = STATE(2945),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_where] = ACTIONS(4213),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_BANG] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_GT_GT_GT] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_switch] = ACTIONS(4213),
    [anon_sym_DOT_DOT] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(4213),
    [anon_sym_or] = ACTIONS(4215),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK] = ACTIONS(4215),
    [anon_sym_from] = ACTIONS(4213),
    [anon_sym_into] = ACTIONS(4213),
    [anon_sym_join] = ACTIONS(4213),
    [anon_sym_let] = ACTIONS(4213),
    [anon_sym_orderby] = ACTIONS(4213),
    [anon_sym_ascending] = ACTIONS(4213),
    [anon_sym_descending] = ACTIONS(4213),
    [anon_sym_group] = ACTIONS(4213),
    [anon_sym_select] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(4215),
    [anon_sym_is] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [anon_sym_with] = ACTIONS(4213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2946] = {
    [sym_preproc_region] = STATE(2946),
    [sym_preproc_endregion] = STATE(2946),
    [sym_preproc_line] = STATE(2946),
    [sym_preproc_pragma] = STATE(2946),
    [sym_preproc_nullable] = STATE(2946),
    [sym_preproc_error] = STATE(2946),
    [sym_preproc_warning] = STATE(2946),
    [sym_preproc_define] = STATE(2946),
    [sym_preproc_undef] = STATE(2946),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_where] = ACTIONS(3630),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3630),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3630),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3630),
    [anon_sym_from] = ACTIONS(3630),
    [anon_sym_into] = ACTIONS(3630),
    [anon_sym_join] = ACTIONS(3630),
    [anon_sym_on] = ACTIONS(3630),
    [anon_sym_equals] = ACTIONS(3630),
    [anon_sym_let] = ACTIONS(3630),
    [anon_sym_orderby] = ACTIONS(3630),
    [anon_sym_group] = ACTIONS(3630),
    [anon_sym_by] = ACTIONS(3630),
    [anon_sym_select] = ACTIONS(3630),
    [anon_sym_as] = ACTIONS(3630),
    [anon_sym_is] = ACTIONS(3630),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3630),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2947] = {
    [sym_preproc_region] = STATE(2947),
    [sym_preproc_endregion] = STATE(2947),
    [sym_preproc_line] = STATE(2947),
    [sym_preproc_pragma] = STATE(2947),
    [sym_preproc_nullable] = STATE(2947),
    [sym_preproc_error] = STATE(2947),
    [sym_preproc_warning] = STATE(2947),
    [sym_preproc_define] = STATE(2947),
    [sym_preproc_undef] = STATE(2947),
    [anon_sym_EQ] = ACTIONS(4896),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_PLUS_EQ] = ACTIONS(4902),
    [anon_sym_DASH_EQ] = ACTIONS(4902),
    [anon_sym_STAR_EQ] = ACTIONS(4902),
    [anon_sym_SLASH_EQ] = ACTIONS(4902),
    [anon_sym_PERCENT_EQ] = ACTIONS(4902),
    [anon_sym_AMP_EQ] = ACTIONS(4902),
    [anon_sym_CARET_EQ] = ACTIONS(4902),
    [anon_sym_PIPE_EQ] = ACTIONS(4902),
    [anon_sym_LT_LT_EQ] = ACTIONS(4902),
    [anon_sym_GT_GT_EQ] = ACTIONS(4902),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4902),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_ascending] = ACTIONS(4898),
    [anon_sym_descending] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2948] = {
    [sym_preproc_region] = STATE(2948),
    [sym_preproc_endregion] = STATE(2948),
    [sym_preproc_line] = STATE(2948),
    [sym_preproc_pragma] = STATE(2948),
    [sym_preproc_nullable] = STATE(2948),
    [sym_preproc_error] = STATE(2948),
    [sym_preproc_warning] = STATE(2948),
    [sym_preproc_define] = STATE(2948),
    [sym_preproc_undef] = STATE(2948),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_where] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_PLUS_PLUS] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_or] = ACTIONS(4227),
    [anon_sym_PLUS_EQ] = ACTIONS(4225),
    [anon_sym_DASH_EQ] = ACTIONS(4225),
    [anon_sym_STAR_EQ] = ACTIONS(4225),
    [anon_sym_SLASH_EQ] = ACTIONS(4225),
    [anon_sym_PERCENT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4225),
    [anon_sym_CARET_EQ] = ACTIONS(4225),
    [anon_sym_PIPE_EQ] = ACTIONS(4225),
    [anon_sym_LT_LT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4225),
    [anon_sym_AMP_AMP] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK] = ACTIONS(4227),
    [anon_sym_from] = ACTIONS(4225),
    [anon_sym_into] = ACTIONS(4225),
    [anon_sym_join] = ACTIONS(4225),
    [anon_sym_let] = ACTIONS(4225),
    [anon_sym_orderby] = ACTIONS(4225),
    [anon_sym_ascending] = ACTIONS(4225),
    [anon_sym_descending] = ACTIONS(4225),
    [anon_sym_group] = ACTIONS(4225),
    [anon_sym_select] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4227),
    [anon_sym_is] = ACTIONS(4225),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_with] = ACTIONS(4225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2949] = {
    [sym_initializer_expression] = STATE(3046),
    [sym_preproc_region] = STATE(2949),
    [sym_preproc_endregion] = STATE(2949),
    [sym_preproc_line] = STATE(2949),
    [sym_preproc_pragma] = STATE(2949),
    [sym_preproc_nullable] = STATE(2949),
    [sym_preproc_error] = STATE(2949),
    [sym_preproc_warning] = STATE(2949),
    [sym_preproc_define] = STATE(2949),
    [sym_preproc_undef] = STATE(2949),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_COLON] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_RBRACK] = ACTIONS(4904),
    [anon_sym_LPAREN] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_in] = ACTIONS(4906),
    [anon_sym_where] = ACTIONS(4904),
    [anon_sym_QMARK] = ACTIONS(4906),
    [anon_sym_BANG] = ACTIONS(4906),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_CARET] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_GT_GT_GT] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_EQ_GT] = ACTIONS(4904),
    [anon_sym_switch] = ACTIONS(4904),
    [anon_sym_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_QMARK_QMARK] = ACTIONS(4904),
    [anon_sym_from] = ACTIONS(4904),
    [anon_sym_into] = ACTIONS(4904),
    [anon_sym_join] = ACTIONS(4904),
    [anon_sym_on] = ACTIONS(4904),
    [anon_sym_equals] = ACTIONS(4904),
    [anon_sym_let] = ACTIONS(4904),
    [anon_sym_orderby] = ACTIONS(4904),
    [anon_sym_group] = ACTIONS(4904),
    [anon_sym_by] = ACTIONS(4904),
    [anon_sym_select] = ACTIONS(4904),
    [anon_sym_as] = ACTIONS(4904),
    [anon_sym_is] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [anon_sym_with] = ACTIONS(4904),
    [aux_sym_preproc_if_token3] = ACTIONS(4904),
    [aux_sym_preproc_else_token1] = ACTIONS(4904),
    [aux_sym_preproc_elif_token1] = ACTIONS(4904),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2950] = {
    [sym_argument_list] = STATE(3081),
    [sym_bracketed_argument_list] = STATE(2469),
    [sym_preproc_region] = STATE(2950),
    [sym_preproc_endregion] = STATE(2950),
    [sym_preproc_line] = STATE(2950),
    [sym_preproc_pragma] = STATE(2950),
    [sym_preproc_nullable] = STATE(2950),
    [sym_preproc_error] = STATE(2950),
    [sym_preproc_warning] = STATE(2950),
    [sym_preproc_define] = STATE(2950),
    [sym_preproc_undef] = STATE(2950),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(4813),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_in] = ACTIONS(4910),
    [anon_sym_where] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4910),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_PLUS_PLUS] = ACTIONS(4883),
    [anon_sym_DASH_DASH] = ACTIONS(4883),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4829),
    [anon_sym_EQ_GT] = ACTIONS(4908),
    [anon_sym_switch] = ACTIONS(4908),
    [anon_sym_DOT_DOT] = ACTIONS(4908),
    [anon_sym_and] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_QMARK_QMARK] = ACTIONS(4908),
    [anon_sym_from] = ACTIONS(4908),
    [anon_sym_into] = ACTIONS(4908),
    [anon_sym_join] = ACTIONS(4908),
    [anon_sym_on] = ACTIONS(4908),
    [anon_sym_equals] = ACTIONS(4908),
    [anon_sym_let] = ACTIONS(4908),
    [anon_sym_orderby] = ACTIONS(4908),
    [anon_sym_group] = ACTIONS(4908),
    [anon_sym_by] = ACTIONS(4908),
    [anon_sym_select] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4908),
    [anon_sym_is] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4908),
    [aux_sym_preproc_if_token3] = ACTIONS(4908),
    [aux_sym_preproc_else_token1] = ACTIONS(4908),
    [aux_sym_preproc_elif_token1] = ACTIONS(4908),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2951] = {
    [sym_preproc_region] = STATE(2951),
    [sym_preproc_endregion] = STATE(2951),
    [sym_preproc_line] = STATE(2951),
    [sym_preproc_pragma] = STATE(2951),
    [sym_preproc_nullable] = STATE(2951),
    [sym_preproc_error] = STATE(2951),
    [sym_preproc_warning] = STATE(2951),
    [sym_preproc_define] = STATE(2951),
    [sym_preproc_undef] = STATE(2951),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_join] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_orderby] = ACTIONS(3459),
    [anon_sym_group] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_select] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2952] = {
    [sym_preproc_region] = STATE(2952),
    [sym_preproc_endregion] = STATE(2952),
    [sym_preproc_line] = STATE(2952),
    [sym_preproc_pragma] = STATE(2952),
    [sym_preproc_nullable] = STATE(2952),
    [sym_preproc_error] = STATE(2952),
    [sym_preproc_warning] = STATE(2952),
    [sym_preproc_define] = STATE(2952),
    [sym_preproc_undef] = STATE(2952),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3664),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3664),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_join] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_let] = ACTIONS(3664),
    [anon_sym_orderby] = ACTIONS(3664),
    [anon_sym_group] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_select] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2953] = {
    [sym_preproc_region] = STATE(2953),
    [sym_preproc_endregion] = STATE(2953),
    [sym_preproc_line] = STATE(2953),
    [sym_preproc_pragma] = STATE(2953),
    [sym_preproc_nullable] = STATE(2953),
    [sym_preproc_error] = STATE(2953),
    [sym_preproc_warning] = STATE(2953),
    [sym_preproc_define] = STATE(2953),
    [sym_preproc_undef] = STATE(2953),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_where] = ACTIONS(3709),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3701),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3709),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_join] = ACTIONS(3709),
    [anon_sym_let] = ACTIONS(3709),
    [anon_sym_orderby] = ACTIONS(3709),
    [anon_sym_ascending] = ACTIONS(3709),
    [anon_sym_descending] = ACTIONS(3709),
    [anon_sym_group] = ACTIONS(3709),
    [anon_sym_select] = ACTIONS(3709),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_is] = ACTIONS(3709),
    [anon_sym_DASH_GT] = ACTIONS(3709),
    [anon_sym_with] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2954] = {
    [sym_preproc_region] = STATE(2954),
    [sym_preproc_endregion] = STATE(2954),
    [sym_preproc_line] = STATE(2954),
    [sym_preproc_pragma] = STATE(2954),
    [sym_preproc_nullable] = STATE(2954),
    [sym_preproc_error] = STATE(2954),
    [sym_preproc_warning] = STATE(2954),
    [sym_preproc_define] = STATE(2954),
    [sym_preproc_undef] = STATE(2954),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_where] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [anon_sym_switch] = ACTIONS(4032),
    [anon_sym_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4032),
    [anon_sym_or] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_QMARK_QMARK] = ACTIONS(4032),
    [anon_sym_from] = ACTIONS(4032),
    [anon_sym_into] = ACTIONS(4032),
    [anon_sym_join] = ACTIONS(4032),
    [anon_sym_on] = ACTIONS(4032),
    [anon_sym_equals] = ACTIONS(4032),
    [anon_sym_let] = ACTIONS(4032),
    [anon_sym_orderby] = ACTIONS(4032),
    [anon_sym_group] = ACTIONS(4032),
    [anon_sym_by] = ACTIONS(4032),
    [anon_sym_select] = ACTIONS(4032),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_is] = ACTIONS(4032),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4032),
    [aux_sym_preproc_if_token3] = ACTIONS(4032),
    [aux_sym_preproc_else_token1] = ACTIONS(4032),
    [aux_sym_preproc_elif_token1] = ACTIONS(4032),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2955] = {
    [sym_preproc_region] = STATE(2955),
    [sym_preproc_endregion] = STATE(2955),
    [sym_preproc_line] = STATE(2955),
    [sym_preproc_pragma] = STATE(2955),
    [sym_preproc_nullable] = STATE(2955),
    [sym_preproc_error] = STATE(2955),
    [sym_preproc_warning] = STATE(2955),
    [sym_preproc_define] = STATE(2955),
    [sym_preproc_undef] = STATE(2955),
    [anon_sym_EQ] = ACTIONS(4912),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_PLUS_EQ] = ACTIONS(4914),
    [anon_sym_DASH_EQ] = ACTIONS(4914),
    [anon_sym_STAR_EQ] = ACTIONS(4914),
    [anon_sym_SLASH_EQ] = ACTIONS(4914),
    [anon_sym_PERCENT_EQ] = ACTIONS(4914),
    [anon_sym_AMP_EQ] = ACTIONS(4914),
    [anon_sym_CARET_EQ] = ACTIONS(4914),
    [anon_sym_PIPE_EQ] = ACTIONS(4914),
    [anon_sym_LT_LT_EQ] = ACTIONS(4914),
    [anon_sym_GT_GT_EQ] = ACTIONS(4914),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4914),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_ascending] = ACTIONS(4898),
    [anon_sym_descending] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2956] = {
    [sym_initializer_expression] = STATE(3107),
    [sym_preproc_region] = STATE(2956),
    [sym_preproc_endregion] = STATE(2956),
    [sym_preproc_line] = STATE(2956),
    [sym_preproc_pragma] = STATE(2956),
    [sym_preproc_nullable] = STATE(2956),
    [sym_preproc_error] = STATE(2956),
    [sym_preproc_warning] = STATE(2956),
    [sym_preproc_define] = STATE(2956),
    [sym_preproc_undef] = STATE(2956),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4916),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(4923),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4926),
    [anon_sym_in] = ACTIONS(4920),
    [anon_sym_where] = ACTIONS(4920),
    [anon_sym_QMARK] = ACTIONS(4929),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4926),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4926),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_GT_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4926),
    [anon_sym_EQ_GT] = ACTIONS(4920),
    [anon_sym_switch] = ACTIONS(4920),
    [anon_sym_DOT_DOT] = ACTIONS(4920),
    [anon_sym_and] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_QMARK_QMARK] = ACTIONS(4920),
    [anon_sym_from] = ACTIONS(4920),
    [anon_sym_join] = ACTIONS(4920),
    [anon_sym_on] = ACTIONS(4920),
    [anon_sym_equals] = ACTIONS(4920),
    [anon_sym_let] = ACTIONS(4920),
    [anon_sym_orderby] = ACTIONS(4920),
    [anon_sym_group] = ACTIONS(4920),
    [anon_sym_by] = ACTIONS(4920),
    [anon_sym_select] = ACTIONS(4920),
    [anon_sym_as] = ACTIONS(4920),
    [anon_sym_is] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_with] = ACTIONS(4920),
    [aux_sym_preproc_if_token3] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4920),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2957] = {
    [sym_preproc_region] = STATE(2957),
    [sym_preproc_endregion] = STATE(2957),
    [sym_preproc_line] = STATE(2957),
    [sym_preproc_pragma] = STATE(2957),
    [sym_preproc_nullable] = STATE(2957),
    [sym_preproc_error] = STATE(2957),
    [sym_preproc_warning] = STATE(2957),
    [sym_preproc_define] = STATE(2957),
    [sym_preproc_undef] = STATE(2957),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3697),
    [anon_sym_where] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3697),
    [anon_sym_GT_GT_GT] = ACTIONS(3699),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_GT_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_and] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(3699),
    [anon_sym_QMARK_QMARK] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3699),
    [anon_sym_into] = ACTIONS(3699),
    [anon_sym_join] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_orderby] = ACTIONS(3699),
    [anon_sym_group] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_select] = ACTIONS(3699),
    [anon_sym_as] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(3699),
    [anon_sym_DASH_GT] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3699),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2958] = {
    [sym_preproc_region] = STATE(2958),
    [sym_preproc_endregion] = STATE(2958),
    [sym_preproc_line] = STATE(2958),
    [sym_preproc_pragma] = STATE(2958),
    [sym_preproc_nullable] = STATE(2958),
    [sym_preproc_error] = STATE(2958),
    [sym_preproc_warning] = STATE(2958),
    [sym_preproc_define] = STATE(2958),
    [sym_preproc_undef] = STATE(2958),
    [anon_sym_SEMI] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_RBRACK] = ACTIONS(4933),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_RPAREN] = ACTIONS(4933),
    [anon_sym_LBRACE] = ACTIONS(4933),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_LT] = ACTIONS(4935),
    [anon_sym_GT] = ACTIONS(4935),
    [anon_sym_in] = ACTIONS(4935),
    [anon_sym_where] = ACTIONS(4933),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_PLUS_PLUS] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4933),
    [anon_sym_PLUS] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4933),
    [anon_sym_SLASH] = ACTIONS(4935),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_CARET] = ACTIONS(4933),
    [anon_sym_PIPE] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_LT_LT] = ACTIONS(4933),
    [anon_sym_GT_GT] = ACTIONS(4935),
    [anon_sym_GT_GT_GT] = ACTIONS(4933),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4933),
    [anon_sym_GT_EQ] = ACTIONS(4933),
    [anon_sym_LT_EQ] = ACTIONS(4933),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_EQ_GT] = ACTIONS(4933),
    [anon_sym_switch] = ACTIONS(4933),
    [anon_sym_DOT_DOT] = ACTIONS(4933),
    [anon_sym_and] = ACTIONS(4933),
    [anon_sym_or] = ACTIONS(4935),
    [anon_sym_AMP_AMP] = ACTIONS(4933),
    [anon_sym_PIPE_PIPE] = ACTIONS(4933),
    [anon_sym_QMARK_QMARK] = ACTIONS(4933),
    [anon_sym_from] = ACTIONS(4933),
    [anon_sym_into] = ACTIONS(4933),
    [anon_sym_join] = ACTIONS(4933),
    [anon_sym_on] = ACTIONS(4933),
    [anon_sym_equals] = ACTIONS(4933),
    [anon_sym_let] = ACTIONS(4933),
    [anon_sym_orderby] = ACTIONS(4933),
    [anon_sym_group] = ACTIONS(4933),
    [anon_sym_by] = ACTIONS(4933),
    [anon_sym_select] = ACTIONS(4933),
    [anon_sym_as] = ACTIONS(4933),
    [anon_sym_is] = ACTIONS(4933),
    [anon_sym_DASH_GT] = ACTIONS(4933),
    [anon_sym_with] = ACTIONS(4933),
    [aux_sym_preproc_if_token3] = ACTIONS(4933),
    [aux_sym_preproc_else_token1] = ACTIONS(4933),
    [aux_sym_preproc_elif_token1] = ACTIONS(4933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2959] = {
    [sym_preproc_region] = STATE(2959),
    [sym_preproc_endregion] = STATE(2959),
    [sym_preproc_line] = STATE(2959),
    [sym_preproc_pragma] = STATE(2959),
    [sym_preproc_nullable] = STATE(2959),
    [sym_preproc_error] = STATE(2959),
    [sym_preproc_warning] = STATE(2959),
    [sym_preproc_define] = STATE(2959),
    [sym_preproc_undef] = STATE(2959),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3684),
    [anon_sym_where] = ACTIONS(3686),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3686),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3686),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3686),
    [anon_sym_from] = ACTIONS(3686),
    [anon_sym_into] = ACTIONS(3686),
    [anon_sym_join] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_let] = ACTIONS(3686),
    [anon_sym_orderby] = ACTIONS(3686),
    [anon_sym_group] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_select] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2960] = {
    [sym_preproc_else_in_attribute_list] = STATE(7596),
    [sym_preproc_elif_in_attribute_list] = STATE(7596),
    [sym_preproc_region] = STATE(2960),
    [sym_preproc_endregion] = STATE(2960),
    [sym_preproc_line] = STATE(2960),
    [sym_preproc_pragma] = STATE(2960),
    [sym_preproc_nullable] = STATE(2960),
    [sym_preproc_error] = STATE(2960),
    [sym_preproc_warning] = STATE(2960),
    [sym_preproc_define] = STATE(2960),
    [sym_preproc_undef] = STATE(2960),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_class] = ACTIONS(4743),
    [anon_sym_ref] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_interface] = ACTIONS(4743),
    [anon_sym_delegate] = ACTIONS(4743),
    [anon_sym_record] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [sym_predefined_type] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_if_token3] = ACTIONS(4937),
    [aux_sym_preproc_else_token1] = ACTIONS(4749),
    [aux_sym_preproc_elif_token1] = ACTIONS(4751),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2961] = {
    [sym_preproc_region] = STATE(2961),
    [sym_preproc_endregion] = STATE(2961),
    [sym_preproc_line] = STATE(2961),
    [sym_preproc_pragma] = STATE(2961),
    [sym_preproc_nullable] = STATE(2961),
    [sym_preproc_error] = STATE(2961),
    [sym_preproc_warning] = STATE(2961),
    [sym_preproc_define] = STATE(2961),
    [sym_preproc_undef] = STATE(2961),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3947),
    [anon_sym_where] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3949),
    [anon_sym_or] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3949),
    [anon_sym_into] = ACTIONS(3949),
    [anon_sym_join] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_orderby] = ACTIONS(3949),
    [anon_sym_group] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_select] = ACTIONS(3949),
    [anon_sym_as] = ACTIONS(3949),
    [anon_sym_is] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3949),
    [aux_sym_preproc_if_token3] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2962] = {
    [sym_preproc_region] = STATE(2962),
    [sym_preproc_endregion] = STATE(2962),
    [sym_preproc_line] = STATE(2962),
    [sym_preproc_pragma] = STATE(2962),
    [sym_preproc_nullable] = STATE(2962),
    [sym_preproc_error] = STATE(2962),
    [sym_preproc_warning] = STATE(2962),
    [sym_preproc_define] = STATE(2962),
    [sym_preproc_undef] = STATE(2962),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_in] = ACTIONS(4106),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4106),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4106),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4108),
    [aux_sym_preproc_else_token1] = ACTIONS(4108),
    [aux_sym_preproc_elif_token1] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2963] = {
    [sym_preproc_region] = STATE(2963),
    [sym_preproc_endregion] = STATE(2963),
    [sym_preproc_line] = STATE(2963),
    [sym_preproc_pragma] = STATE(2963),
    [sym_preproc_nullable] = STATE(2963),
    [sym_preproc_error] = STATE(2963),
    [sym_preproc_warning] = STATE(2963),
    [sym_preproc_define] = STATE(2963),
    [sym_preproc_undef] = STATE(2963),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(4154),
    [anon_sym_where] = ACTIONS(4156),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_GT_GT_GT] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4156),
    [anon_sym_BANG_EQ] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4156),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_EQ_GT] = ACTIONS(4156),
    [anon_sym_switch] = ACTIONS(4156),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4156),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4156),
    [anon_sym_QMARK_QMARK] = ACTIONS(4156),
    [anon_sym_from] = ACTIONS(4156),
    [anon_sym_into] = ACTIONS(4156),
    [anon_sym_join] = ACTIONS(4156),
    [anon_sym_on] = ACTIONS(4156),
    [anon_sym_equals] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_orderby] = ACTIONS(4156),
    [anon_sym_group] = ACTIONS(4156),
    [anon_sym_by] = ACTIONS(4156),
    [anon_sym_select] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4156),
    [anon_sym_is] = ACTIONS(4156),
    [anon_sym_DASH_GT] = ACTIONS(4156),
    [anon_sym_with] = ACTIONS(4156),
    [aux_sym_preproc_if_token3] = ACTIONS(4156),
    [aux_sym_preproc_else_token1] = ACTIONS(4156),
    [aux_sym_preproc_elif_token1] = ACTIONS(4156),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2964] = {
    [sym_preproc_region] = STATE(2964),
    [sym_preproc_endregion] = STATE(2964),
    [sym_preproc_line] = STATE(2964),
    [sym_preproc_pragma] = STATE(2964),
    [sym_preproc_nullable] = STATE(2964),
    [sym_preproc_error] = STATE(2964),
    [sym_preproc_warning] = STATE(2964),
    [sym_preproc_define] = STATE(2964),
    [sym_preproc_undef] = STATE(2964),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2965] = {
    [sym_preproc_region] = STATE(2965),
    [sym_preproc_endregion] = STATE(2965),
    [sym_preproc_line] = STATE(2965),
    [sym_preproc_pragma] = STATE(2965),
    [sym_preproc_nullable] = STATE(2965),
    [sym_preproc_error] = STATE(2965),
    [sym_preproc_warning] = STATE(2965),
    [sym_preproc_define] = STATE(2965),
    [sym_preproc_undef] = STATE(2965),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_where] = ACTIONS(4036),
    [anon_sym_QMARK] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [anon_sym_switch] = ACTIONS(4036),
    [anon_sym_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_or] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_QMARK_QMARK] = ACTIONS(4036),
    [anon_sym_from] = ACTIONS(4036),
    [anon_sym_into] = ACTIONS(4036),
    [anon_sym_join] = ACTIONS(4036),
    [anon_sym_on] = ACTIONS(4036),
    [anon_sym_equals] = ACTIONS(4036),
    [anon_sym_let] = ACTIONS(4036),
    [anon_sym_orderby] = ACTIONS(4036),
    [anon_sym_group] = ACTIONS(4036),
    [anon_sym_by] = ACTIONS(4036),
    [anon_sym_select] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4036),
    [anon_sym_is] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4036),
    [aux_sym_preproc_if_token3] = ACTIONS(4036),
    [aux_sym_preproc_else_token1] = ACTIONS(4036),
    [aux_sym_preproc_elif_token1] = ACTIONS(4036),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2966] = {
    [sym_preproc_region] = STATE(2966),
    [sym_preproc_endregion] = STATE(2966),
    [sym_preproc_line] = STATE(2966),
    [sym_preproc_pragma] = STATE(2966),
    [sym_preproc_nullable] = STATE(2966),
    [sym_preproc_error] = STATE(2966),
    [sym_preproc_warning] = STATE(2966),
    [sym_preproc_define] = STATE(2966),
    [sym_preproc_undef] = STATE(2966),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2967] = {
    [sym_preproc_region] = STATE(2967),
    [sym_preproc_endregion] = STATE(2967),
    [sym_preproc_line] = STATE(2967),
    [sym_preproc_pragma] = STATE(2967),
    [sym_preproc_nullable] = STATE(2967),
    [sym_preproc_error] = STATE(2967),
    [sym_preproc_warning] = STATE(2967),
    [sym_preproc_define] = STATE(2967),
    [sym_preproc_undef] = STATE(2967),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4038),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_GT_GT_GT] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_switch] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4040),
    [anon_sym_or] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_QMARK_QMARK] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(4040),
    [anon_sym_is] = ACTIONS(4040),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_with] = ACTIONS(4040),
    [aux_sym_preproc_if_token3] = ACTIONS(4040),
    [aux_sym_preproc_else_token1] = ACTIONS(4040),
    [aux_sym_preproc_elif_token1] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2968] = {
    [sym_preproc_region] = STATE(2968),
    [sym_preproc_endregion] = STATE(2968),
    [sym_preproc_line] = STATE(2968),
    [sym_preproc_pragma] = STATE(2968),
    [sym_preproc_nullable] = STATE(2968),
    [sym_preproc_error] = STATE(2968),
    [sym_preproc_warning] = STATE(2968),
    [sym_preproc_define] = STATE(2968),
    [sym_preproc_undef] = STATE(2968),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_in] = ACTIONS(4042),
    [anon_sym_where] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4044),
    [anon_sym_or] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_QMARK_QMARK] = ACTIONS(4044),
    [anon_sym_from] = ACTIONS(4044),
    [anon_sym_into] = ACTIONS(4044),
    [anon_sym_join] = ACTIONS(4044),
    [anon_sym_on] = ACTIONS(4044),
    [anon_sym_equals] = ACTIONS(4044),
    [anon_sym_let] = ACTIONS(4044),
    [anon_sym_orderby] = ACTIONS(4044),
    [anon_sym_group] = ACTIONS(4044),
    [anon_sym_by] = ACTIONS(4044),
    [anon_sym_select] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4044),
    [anon_sym_is] = ACTIONS(4044),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_with] = ACTIONS(4044),
    [aux_sym_preproc_if_token3] = ACTIONS(4044),
    [aux_sym_preproc_else_token1] = ACTIONS(4044),
    [aux_sym_preproc_elif_token1] = ACTIONS(4044),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2969] = {
    [sym_initializer_expression] = STATE(3132),
    [sym_preproc_region] = STATE(2969),
    [sym_preproc_endregion] = STATE(2969),
    [sym_preproc_line] = STATE(2969),
    [sym_preproc_pragma] = STATE(2969),
    [sym_preproc_nullable] = STATE(2969),
    [sym_preproc_error] = STATE(2969),
    [sym_preproc_warning] = STATE(2969),
    [sym_preproc_define] = STATE(2969),
    [sym_preproc_undef] = STATE(2969),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_COLON] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_RBRACK] = ACTIONS(4904),
    [anon_sym_LPAREN] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_in] = ACTIONS(4904),
    [anon_sym_where] = ACTIONS(4904),
    [anon_sym_QMARK] = ACTIONS(4906),
    [anon_sym_BANG] = ACTIONS(4906),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_CARET] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_GT_GT_GT] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_EQ_GT] = ACTIONS(4904),
    [anon_sym_switch] = ACTIONS(4904),
    [anon_sym_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_QMARK_QMARK] = ACTIONS(4904),
    [anon_sym_from] = ACTIONS(4904),
    [anon_sym_join] = ACTIONS(4904),
    [anon_sym_on] = ACTIONS(4904),
    [anon_sym_equals] = ACTIONS(4904),
    [anon_sym_let] = ACTIONS(4904),
    [anon_sym_orderby] = ACTIONS(4904),
    [anon_sym_group] = ACTIONS(4904),
    [anon_sym_by] = ACTIONS(4904),
    [anon_sym_select] = ACTIONS(4904),
    [anon_sym_as] = ACTIONS(4904),
    [anon_sym_is] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [anon_sym_with] = ACTIONS(4904),
    [aux_sym_preproc_if_token3] = ACTIONS(4904),
    [aux_sym_preproc_else_token1] = ACTIONS(4904),
    [aux_sym_preproc_elif_token1] = ACTIONS(4904),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2970] = {
    [sym_initializer_expression] = STATE(3105),
    [sym_preproc_region] = STATE(2970),
    [sym_preproc_endregion] = STATE(2970),
    [sym_preproc_line] = STATE(2970),
    [sym_preproc_pragma] = STATE(2970),
    [sym_preproc_nullable] = STATE(2970),
    [sym_preproc_error] = STATE(2970),
    [sym_preproc_warning] = STATE(2970),
    [sym_preproc_define] = STATE(2970),
    [sym_preproc_undef] = STATE(2970),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_RBRACK] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_LT] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4873),
    [anon_sym_in] = ACTIONS(4871),
    [anon_sym_where] = ACTIONS(4871),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_BANG] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4873),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_SLASH] = ACTIONS(4873),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4873),
    [anon_sym_AMP] = ACTIONS(4873),
    [anon_sym_LT_LT] = ACTIONS(4871),
    [anon_sym_GT_GT] = ACTIONS(4873),
    [anon_sym_GT_GT_GT] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4871),
    [anon_sym_BANG_EQ] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4871),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4873),
    [anon_sym_EQ_GT] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(4871),
    [anon_sym_DOT_DOT] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_or] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE] = ACTIONS(4871),
    [anon_sym_QMARK_QMARK] = ACTIONS(4871),
    [anon_sym_from] = ACTIONS(4871),
    [anon_sym_join] = ACTIONS(4871),
    [anon_sym_on] = ACTIONS(4871),
    [anon_sym_equals] = ACTIONS(4871),
    [anon_sym_let] = ACTIONS(4871),
    [anon_sym_orderby] = ACTIONS(4871),
    [anon_sym_group] = ACTIONS(4871),
    [anon_sym_by] = ACTIONS(4871),
    [anon_sym_select] = ACTIONS(4871),
    [anon_sym_as] = ACTIONS(4871),
    [anon_sym_is] = ACTIONS(4871),
    [anon_sym_DASH_GT] = ACTIONS(4871),
    [anon_sym_with] = ACTIONS(4871),
    [aux_sym_preproc_if_token3] = ACTIONS(4871),
    [aux_sym_preproc_else_token1] = ACTIONS(4871),
    [aux_sym_preproc_elif_token1] = ACTIONS(4871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2971] = {
    [sym_preproc_region] = STATE(2971),
    [sym_preproc_endregion] = STATE(2971),
    [sym_preproc_line] = STATE(2971),
    [sym_preproc_pragma] = STATE(2971),
    [sym_preproc_nullable] = STATE(2971),
    [sym_preproc_error] = STATE(2971),
    [sym_preproc_warning] = STATE(2971),
    [sym_preproc_define] = STATE(2971),
    [sym_preproc_undef] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_COLON] = ACTIONS(4939),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_RBRACK] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4941),
    [anon_sym_in] = ACTIONS(4941),
    [anon_sym_where] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_BANG] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4941),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4941),
    [anon_sym_GT_GT_GT] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4939),
    [anon_sym_BANG_EQ] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4939),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4941),
    [anon_sym_EQ_GT] = ACTIONS(4939),
    [anon_sym_switch] = ACTIONS(4939),
    [anon_sym_DOT_DOT] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_or] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4939),
    [anon_sym_QMARK_QMARK] = ACTIONS(4939),
    [anon_sym_from] = ACTIONS(4939),
    [anon_sym_into] = ACTIONS(4939),
    [anon_sym_join] = ACTIONS(4939),
    [anon_sym_on] = ACTIONS(4939),
    [anon_sym_equals] = ACTIONS(4939),
    [anon_sym_let] = ACTIONS(4939),
    [anon_sym_orderby] = ACTIONS(4939),
    [anon_sym_group] = ACTIONS(4939),
    [anon_sym_by] = ACTIONS(4939),
    [anon_sym_select] = ACTIONS(4939),
    [anon_sym_as] = ACTIONS(4939),
    [anon_sym_is] = ACTIONS(4939),
    [anon_sym_DASH_GT] = ACTIONS(4939),
    [anon_sym_with] = ACTIONS(4939),
    [aux_sym_preproc_if_token3] = ACTIONS(4939),
    [aux_sym_preproc_else_token1] = ACTIONS(4939),
    [aux_sym_preproc_elif_token1] = ACTIONS(4939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2972] = {
    [sym_preproc_region] = STATE(2972),
    [sym_preproc_endregion] = STATE(2972),
    [sym_preproc_line] = STATE(2972),
    [sym_preproc_pragma] = STATE(2972),
    [sym_preproc_nullable] = STATE(2972),
    [sym_preproc_error] = STATE(2972),
    [sym_preproc_warning] = STATE(2972),
    [sym_preproc_define] = STATE(2972),
    [sym_preproc_undef] = STATE(2972),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4144),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_join] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4144),
    [anon_sym_orderby] = ACTIONS(4144),
    [anon_sym_group] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_select] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2973] = {
    [sym_preproc_region] = STATE(2973),
    [sym_preproc_endregion] = STATE(2973),
    [sym_preproc_line] = STATE(2973),
    [sym_preproc_pragma] = STATE(2973),
    [sym_preproc_nullable] = STATE(2973),
    [sym_preproc_error] = STATE(2973),
    [sym_preproc_warning] = STATE(2973),
    [sym_preproc_define] = STATE(2973),
    [sym_preproc_undef] = STATE(2973),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_in] = ACTIONS(4018),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_QMARK_QMARK] = ACTIONS(4020),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4020),
    [anon_sym_is] = ACTIONS(4020),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_with] = ACTIONS(4020),
    [aux_sym_preproc_if_token3] = ACTIONS(4020),
    [aux_sym_preproc_else_token1] = ACTIONS(4020),
    [aux_sym_preproc_elif_token1] = ACTIONS(4020),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2974] = {
    [sym_preproc_region] = STATE(2974),
    [sym_preproc_endregion] = STATE(2974),
    [sym_preproc_line] = STATE(2974),
    [sym_preproc_pragma] = STATE(2974),
    [sym_preproc_nullable] = STATE(2974),
    [sym_preproc_error] = STATE(2974),
    [sym_preproc_warning] = STATE(2974),
    [sym_preproc_define] = STATE(2974),
    [sym_preproc_undef] = STATE(2974),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_RBRACK] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_CARET] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4152),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4152),
    [anon_sym_switch] = ACTIONS(4152),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_and] = ACTIONS(4152),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_QMARK_QMARK] = ACTIONS(4152),
    [anon_sym_from] = ACTIONS(4152),
    [anon_sym_into] = ACTIONS(4152),
    [anon_sym_join] = ACTIONS(4152),
    [anon_sym_on] = ACTIONS(4152),
    [anon_sym_equals] = ACTIONS(4152),
    [anon_sym_let] = ACTIONS(4152),
    [anon_sym_orderby] = ACTIONS(4152),
    [anon_sym_group] = ACTIONS(4152),
    [anon_sym_by] = ACTIONS(4152),
    [anon_sym_select] = ACTIONS(4152),
    [anon_sym_as] = ACTIONS(4152),
    [anon_sym_is] = ACTIONS(4152),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [anon_sym_with] = ACTIONS(4152),
    [aux_sym_preproc_if_token3] = ACTIONS(4152),
    [aux_sym_preproc_else_token1] = ACTIONS(4152),
    [aux_sym_preproc_elif_token1] = ACTIONS(4152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2975] = {
    [sym_preproc_region] = STATE(2975),
    [sym_preproc_endregion] = STATE(2975),
    [sym_preproc_line] = STATE(2975),
    [sym_preproc_pragma] = STATE(2975),
    [sym_preproc_nullable] = STATE(2975),
    [sym_preproc_error] = STATE(2975),
    [sym_preproc_warning] = STATE(2975),
    [sym_preproc_define] = STATE(2975),
    [sym_preproc_undef] = STATE(2975),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_COLON] = ACTIONS(4943),
    [anon_sym_COMMA] = ACTIONS(4943),
    [anon_sym_RBRACK] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_LT] = ACTIONS(4945),
    [anon_sym_GT] = ACTIONS(4945),
    [anon_sym_in] = ACTIONS(4945),
    [anon_sym_where] = ACTIONS(4943),
    [anon_sym_QMARK] = ACTIONS(4945),
    [anon_sym_BANG] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_SLASH] = ACTIONS(4945),
    [anon_sym_PERCENT] = ACTIONS(4943),
    [anon_sym_CARET] = ACTIONS(4943),
    [anon_sym_PIPE] = ACTIONS(4945),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_LT_LT] = ACTIONS(4943),
    [anon_sym_GT_GT] = ACTIONS(4945),
    [anon_sym_GT_GT_GT] = ACTIONS(4943),
    [anon_sym_EQ_EQ] = ACTIONS(4943),
    [anon_sym_BANG_EQ] = ACTIONS(4943),
    [anon_sym_GT_EQ] = ACTIONS(4943),
    [anon_sym_LT_EQ] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4945),
    [anon_sym_EQ_GT] = ACTIONS(4943),
    [anon_sym_switch] = ACTIONS(4943),
    [anon_sym_DOT_DOT] = ACTIONS(4943),
    [anon_sym_and] = ACTIONS(4943),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_AMP_AMP] = ACTIONS(4943),
    [anon_sym_PIPE_PIPE] = ACTIONS(4943),
    [anon_sym_QMARK_QMARK] = ACTIONS(4943),
    [anon_sym_from] = ACTIONS(4943),
    [anon_sym_into] = ACTIONS(4943),
    [anon_sym_join] = ACTIONS(4943),
    [anon_sym_on] = ACTIONS(4943),
    [anon_sym_equals] = ACTIONS(4943),
    [anon_sym_let] = ACTIONS(4943),
    [anon_sym_orderby] = ACTIONS(4943),
    [anon_sym_group] = ACTIONS(4943),
    [anon_sym_by] = ACTIONS(4943),
    [anon_sym_select] = ACTIONS(4943),
    [anon_sym_as] = ACTIONS(4943),
    [anon_sym_is] = ACTIONS(4943),
    [anon_sym_DASH_GT] = ACTIONS(4943),
    [anon_sym_with] = ACTIONS(4943),
    [aux_sym_raw_string_literal_token1] = ACTIONS(4947),
    [aux_sym_preproc_if_token3] = ACTIONS(4943),
    [aux_sym_preproc_else_token1] = ACTIONS(4943),
    [aux_sym_preproc_elif_token1] = ACTIONS(4943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2976] = {
    [sym_preproc_region] = STATE(2976),
    [sym_preproc_endregion] = STATE(2976),
    [sym_preproc_line] = STATE(2976),
    [sym_preproc_pragma] = STATE(2976),
    [sym_preproc_nullable] = STATE(2976),
    [sym_preproc_error] = STATE(2976),
    [sym_preproc_warning] = STATE(2976),
    [sym_preproc_define] = STATE(2976),
    [sym_preproc_undef] = STATE(2976),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_CARET] = ACTIONS(3676),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3676),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3676),
    [anon_sym_from] = ACTIONS(3676),
    [anon_sym_into] = ACTIONS(3676),
    [anon_sym_join] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_orderby] = ACTIONS(3676),
    [anon_sym_group] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_select] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2977] = {
    [sym_initializer_expression] = STATE(3126),
    [sym_preproc_region] = STATE(2977),
    [sym_preproc_endregion] = STATE(2977),
    [sym_preproc_line] = STATE(2977),
    [sym_preproc_pragma] = STATE(2977),
    [sym_preproc_nullable] = STATE(2977),
    [sym_preproc_error] = STATE(2977),
    [sym_preproc_warning] = STATE(2977),
    [sym_preproc_define] = STATE(2977),
    [sym_preproc_undef] = STATE(2977),
    [anon_sym_SEMI] = ACTIONS(4889),
    [anon_sym_LBRACK] = ACTIONS(4891),
    [anon_sym_COLON] = ACTIONS(4889),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RBRACK] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_in] = ACTIONS(4889),
    [anon_sym_where] = ACTIONS(4889),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_BANG] = ACTIONS(4894),
    [anon_sym_PLUS_PLUS] = ACTIONS(4889),
    [anon_sym_DASH_DASH] = ACTIONS(4889),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_SLASH] = ACTIONS(4894),
    [anon_sym_PERCENT] = ACTIONS(4889),
    [anon_sym_CARET] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4889),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_GT_GT_GT] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [anon_sym_GT_EQ] = ACTIONS(4889),
    [anon_sym_LT_EQ] = ACTIONS(4889),
    [anon_sym_DOT] = ACTIONS(4894),
    [anon_sym_EQ_GT] = ACTIONS(4889),
    [anon_sym_switch] = ACTIONS(4889),
    [anon_sym_DOT_DOT] = ACTIONS(4889),
    [anon_sym_and] = ACTIONS(4889),
    [anon_sym_or] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_QMARK_QMARK] = ACTIONS(4889),
    [anon_sym_from] = ACTIONS(4889),
    [anon_sym_join] = ACTIONS(4889),
    [anon_sym_on] = ACTIONS(4889),
    [anon_sym_equals] = ACTIONS(4889),
    [anon_sym_let] = ACTIONS(4889),
    [anon_sym_orderby] = ACTIONS(4889),
    [anon_sym_group] = ACTIONS(4889),
    [anon_sym_by] = ACTIONS(4889),
    [anon_sym_select] = ACTIONS(4889),
    [anon_sym_as] = ACTIONS(4889),
    [anon_sym_is] = ACTIONS(4889),
    [anon_sym_DASH_GT] = ACTIONS(4889),
    [anon_sym_with] = ACTIONS(4889),
    [aux_sym_preproc_if_token3] = ACTIONS(4889),
    [aux_sym_preproc_else_token1] = ACTIONS(4889),
    [aux_sym_preproc_elif_token1] = ACTIONS(4889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2978] = {
    [sym_preproc_region] = STATE(2978),
    [sym_preproc_endregion] = STATE(2978),
    [sym_preproc_line] = STATE(2978),
    [sym_preproc_pragma] = STATE(2978),
    [sym_preproc_nullable] = STATE(2978),
    [sym_preproc_error] = STATE(2978),
    [sym_preproc_warning] = STATE(2978),
    [sym_preproc_define] = STATE(2978),
    [sym_preproc_undef] = STATE(2978),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_in] = ACTIONS(4048),
    [anon_sym_where] = ACTIONS(4050),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_DOT] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4050),
    [anon_sym_switch] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4050),
    [anon_sym_and] = ACTIONS(4050),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_QMARK_QMARK] = ACTIONS(4050),
    [anon_sym_from] = ACTIONS(4050),
    [anon_sym_into] = ACTIONS(4050),
    [anon_sym_join] = ACTIONS(4050),
    [anon_sym_on] = ACTIONS(4050),
    [anon_sym_equals] = ACTIONS(4050),
    [anon_sym_let] = ACTIONS(4050),
    [anon_sym_orderby] = ACTIONS(4050),
    [anon_sym_group] = ACTIONS(4050),
    [anon_sym_by] = ACTIONS(4050),
    [anon_sym_select] = ACTIONS(4050),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_is] = ACTIONS(4050),
    [anon_sym_DASH_GT] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4050),
    [aux_sym_preproc_if_token3] = ACTIONS(4050),
    [aux_sym_preproc_else_token1] = ACTIONS(4050),
    [aux_sym_preproc_elif_token1] = ACTIONS(4050),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2979] = {
    [sym_preproc_region] = STATE(2979),
    [sym_preproc_endregion] = STATE(2979),
    [sym_preproc_line] = STATE(2979),
    [sym_preproc_pragma] = STATE(2979),
    [sym_preproc_nullable] = STATE(2979),
    [sym_preproc_error] = STATE(2979),
    [sym_preproc_warning] = STATE(2979),
    [sym_preproc_define] = STATE(2979),
    [sym_preproc_undef] = STATE(2979),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4949),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2980] = {
    [sym_preproc_region] = STATE(2980),
    [sym_preproc_endregion] = STATE(2980),
    [sym_preproc_line] = STATE(2980),
    [sym_preproc_pragma] = STATE(2980),
    [sym_preproc_nullable] = STATE(2980),
    [sym_preproc_error] = STATE(2980),
    [sym_preproc_warning] = STATE(2980),
    [sym_preproc_define] = STATE(2980),
    [sym_preproc_undef] = STATE(2980),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3664),
    [anon_sym_where] = ACTIONS(3664),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3664),
    [anon_sym_join] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_let] = ACTIONS(3664),
    [anon_sym_orderby] = ACTIONS(3664),
    [anon_sym_group] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_select] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2981] = {
    [sym_preproc_region] = STATE(2981),
    [sym_preproc_endregion] = STATE(2981),
    [sym_preproc_line] = STATE(2981),
    [sym_preproc_pragma] = STATE(2981),
    [sym_preproc_nullable] = STATE(2981),
    [sym_preproc_error] = STATE(2981),
    [sym_preproc_warning] = STATE(2981),
    [sym_preproc_define] = STATE(2981),
    [sym_preproc_undef] = STATE(2981),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_where] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4052),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [anon_sym_switch] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_QMARK_QMARK] = ACTIONS(4054),
    [anon_sym_from] = ACTIONS(4054),
    [anon_sym_into] = ACTIONS(4054),
    [anon_sym_join] = ACTIONS(4054),
    [anon_sym_on] = ACTIONS(4054),
    [anon_sym_equals] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_orderby] = ACTIONS(4054),
    [anon_sym_group] = ACTIONS(4054),
    [anon_sym_by] = ACTIONS(4054),
    [anon_sym_select] = ACTIONS(4054),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_is] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [aux_sym_preproc_if_token3] = ACTIONS(4054),
    [aux_sym_preproc_else_token1] = ACTIONS(4054),
    [aux_sym_preproc_elif_token1] = ACTIONS(4054),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2982] = {
    [sym_preproc_region] = STATE(2982),
    [sym_preproc_endregion] = STATE(2982),
    [sym_preproc_line] = STATE(2982),
    [sym_preproc_pragma] = STATE(2982),
    [sym_preproc_nullable] = STATE(2982),
    [sym_preproc_error] = STATE(2982),
    [sym_preproc_warning] = STATE(2982),
    [sym_preproc_define] = STATE(2982),
    [sym_preproc_undef] = STATE(2982),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_where] = ACTIONS(3630),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3630),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3630),
    [anon_sym_or] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3630),
    [anon_sym_from] = ACTIONS(3630),
    [anon_sym_join] = ACTIONS(3630),
    [anon_sym_on] = ACTIONS(3630),
    [anon_sym_equals] = ACTIONS(3630),
    [anon_sym_let] = ACTIONS(3630),
    [anon_sym_orderby] = ACTIONS(3630),
    [anon_sym_group] = ACTIONS(3630),
    [anon_sym_by] = ACTIONS(3630),
    [anon_sym_select] = ACTIONS(3630),
    [anon_sym_as] = ACTIONS(3630),
    [anon_sym_is] = ACTIONS(3630),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3630),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2983] = {
    [sym_preproc_region] = STATE(2983),
    [sym_preproc_endregion] = STATE(2983),
    [sym_preproc_line] = STATE(2983),
    [sym_preproc_pragma] = STATE(2983),
    [sym_preproc_nullable] = STATE(2983),
    [sym_preproc_error] = STATE(2983),
    [sym_preproc_warning] = STATE(2983),
    [sym_preproc_define] = STATE(2983),
    [sym_preproc_undef] = STATE(2983),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2984] = {
    [sym_preproc_region] = STATE(2984),
    [sym_preproc_endregion] = STATE(2984),
    [sym_preproc_line] = STATE(2984),
    [sym_preproc_pragma] = STATE(2984),
    [sym_preproc_nullable] = STATE(2984),
    [sym_preproc_error] = STATE(2984),
    [sym_preproc_warning] = STATE(2984),
    [sym_preproc_define] = STATE(2984),
    [sym_preproc_undef] = STATE(2984),
    [anon_sym_SEMI] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_COLON] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(4952),
    [anon_sym_RBRACK] = ACTIONS(4952),
    [anon_sym_LPAREN] = ACTIONS(4952),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_RBRACE] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4954),
    [anon_sym_in] = ACTIONS(4954),
    [anon_sym_where] = ACTIONS(4952),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4954),
    [anon_sym_DASH] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4954),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_PIPE] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4954),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_GT_GT_GT] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4952),
    [anon_sym_BANG_EQ] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4952),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_DOT] = ACTIONS(4954),
    [anon_sym_EQ_GT] = ACTIONS(4952),
    [anon_sym_switch] = ACTIONS(4952),
    [anon_sym_DOT_DOT] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_or] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4952),
    [anon_sym_QMARK_QMARK] = ACTIONS(4952),
    [anon_sym_from] = ACTIONS(4952),
    [anon_sym_into] = ACTIONS(4952),
    [anon_sym_join] = ACTIONS(4952),
    [anon_sym_on] = ACTIONS(4952),
    [anon_sym_equals] = ACTIONS(4952),
    [anon_sym_let] = ACTIONS(4952),
    [anon_sym_orderby] = ACTIONS(4952),
    [anon_sym_group] = ACTIONS(4952),
    [anon_sym_by] = ACTIONS(4952),
    [anon_sym_select] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_DASH_GT] = ACTIONS(4952),
    [anon_sym_with] = ACTIONS(4952),
    [sym_string_literal_encoding] = ACTIONS(4956),
    [aux_sym_preproc_if_token3] = ACTIONS(4952),
    [aux_sym_preproc_else_token1] = ACTIONS(4952),
    [aux_sym_preproc_elif_token1] = ACTIONS(4952),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2985] = {
    [sym_preproc_region] = STATE(2985),
    [sym_preproc_endregion] = STATE(2985),
    [sym_preproc_line] = STATE(2985),
    [sym_preproc_pragma] = STATE(2985),
    [sym_preproc_nullable] = STATE(2985),
    [sym_preproc_error] = STATE(2985),
    [sym_preproc_warning] = STATE(2985),
    [sym_preproc_define] = STATE(2985),
    [sym_preproc_undef] = STATE(2985),
    [anon_sym_SEMI] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_COLON] = ACTIONS(4958),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_RBRACK] = ACTIONS(4958),
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_RPAREN] = ACTIONS(4958),
    [anon_sym_LBRACE] = ACTIONS(4958),
    [anon_sym_RBRACE] = ACTIONS(4958),
    [anon_sym_LT] = ACTIONS(4960),
    [anon_sym_GT] = ACTIONS(4960),
    [anon_sym_in] = ACTIONS(4960),
    [anon_sym_where] = ACTIONS(4958),
    [anon_sym_QMARK] = ACTIONS(4960),
    [anon_sym_BANG] = ACTIONS(4960),
    [anon_sym_PLUS_PLUS] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(4958),
    [anon_sym_PLUS] = ACTIONS(4960),
    [anon_sym_DASH] = ACTIONS(4960),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_SLASH] = ACTIONS(4960),
    [anon_sym_PERCENT] = ACTIONS(4958),
    [anon_sym_CARET] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym_LT_LT] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(4960),
    [anon_sym_GT_GT_GT] = ACTIONS(4958),
    [anon_sym_EQ_EQ] = ACTIONS(4958),
    [anon_sym_BANG_EQ] = ACTIONS(4958),
    [anon_sym_GT_EQ] = ACTIONS(4958),
    [anon_sym_LT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(4960),
    [anon_sym_EQ_GT] = ACTIONS(4958),
    [anon_sym_switch] = ACTIONS(4958),
    [anon_sym_DOT_DOT] = ACTIONS(4958),
    [anon_sym_and] = ACTIONS(4958),
    [anon_sym_or] = ACTIONS(4960),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_PIPE_PIPE] = ACTIONS(4958),
    [anon_sym_QMARK_QMARK] = ACTIONS(4958),
    [anon_sym_from] = ACTIONS(4958),
    [anon_sym_into] = ACTIONS(4958),
    [anon_sym_join] = ACTIONS(4958),
    [anon_sym_on] = ACTIONS(4958),
    [anon_sym_equals] = ACTIONS(4958),
    [anon_sym_let] = ACTIONS(4958),
    [anon_sym_orderby] = ACTIONS(4958),
    [anon_sym_group] = ACTIONS(4958),
    [anon_sym_by] = ACTIONS(4958),
    [anon_sym_select] = ACTIONS(4958),
    [anon_sym_as] = ACTIONS(4958),
    [anon_sym_is] = ACTIONS(4958),
    [anon_sym_DASH_GT] = ACTIONS(4958),
    [anon_sym_with] = ACTIONS(4958),
    [aux_sym_preproc_if_token3] = ACTIONS(4958),
    [aux_sym_preproc_else_token1] = ACTIONS(4958),
    [aux_sym_preproc_elif_token1] = ACTIONS(4958),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2986] = {
    [sym_preproc_region] = STATE(2986),
    [sym_preproc_endregion] = STATE(2986),
    [sym_preproc_line] = STATE(2986),
    [sym_preproc_pragma] = STATE(2986),
    [sym_preproc_nullable] = STATE(2986),
    [sym_preproc_error] = STATE(2986),
    [sym_preproc_warning] = STATE(2986),
    [sym_preproc_define] = STATE(2986),
    [sym_preproc_undef] = STATE(2986),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_where] = ACTIONS(3672),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3672),
    [anon_sym_from] = ACTIONS(3672),
    [anon_sym_into] = ACTIONS(3672),
    [anon_sym_join] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_let] = ACTIONS(3672),
    [anon_sym_orderby] = ACTIONS(3672),
    [anon_sym_group] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_select] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2987] = {
    [sym_preproc_region] = STATE(2987),
    [sym_preproc_endregion] = STATE(2987),
    [sym_preproc_line] = STATE(2987),
    [sym_preproc_pragma] = STATE(2987),
    [sym_preproc_nullable] = STATE(2987),
    [sym_preproc_error] = STATE(2987),
    [sym_preproc_warning] = STATE(2987),
    [sym_preproc_define] = STATE(2987),
    [sym_preproc_undef] = STATE(2987),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4949),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2988] = {
    [sym_type_argument_list] = STATE(3027),
    [sym_preproc_region] = STATE(2988),
    [sym_preproc_endregion] = STATE(2988),
    [sym_preproc_line] = STATE(2988),
    [sym_preproc_pragma] = STATE(2988),
    [sym_preproc_nullable] = STATE(2988),
    [sym_preproc_error] = STATE(2988),
    [sym_preproc_warning] = STATE(2988),
    [sym_preproc_define] = STATE(2988),
    [sym_preproc_undef] = STATE(2988),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4962),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(4965),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2989] = {
    [sym_preproc_region] = STATE(2989),
    [sym_preproc_endregion] = STATE(2989),
    [sym_preproc_line] = STATE(2989),
    [sym_preproc_pragma] = STATE(2989),
    [sym_preproc_nullable] = STATE(2989),
    [sym_preproc_error] = STATE(2989),
    [sym_preproc_warning] = STATE(2989),
    [sym_preproc_define] = STATE(2989),
    [sym_preproc_undef] = STATE(2989),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3459),
    [anon_sym_join] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_orderby] = ACTIONS(3459),
    [anon_sym_group] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_select] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2990] = {
    [sym_preproc_region] = STATE(2990),
    [sym_preproc_endregion] = STATE(2990),
    [sym_preproc_line] = STATE(2990),
    [sym_preproc_pragma] = STATE(2990),
    [sym_preproc_nullable] = STATE(2990),
    [sym_preproc_error] = STATE(2990),
    [sym_preproc_warning] = STATE(2990),
    [sym_preproc_define] = STATE(2990),
    [sym_preproc_undef] = STATE(2990),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_LPAREN] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_in] = ACTIONS(4119),
    [anon_sym_where] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4121),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4119),
    [anon_sym_EQ_GT] = ACTIONS(4121),
    [anon_sym_switch] = ACTIONS(4121),
    [anon_sym_DOT_DOT] = ACTIONS(4121),
    [anon_sym_and] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_QMARK_QMARK] = ACTIONS(4121),
    [anon_sym_from] = ACTIONS(4121),
    [anon_sym_into] = ACTIONS(4121),
    [anon_sym_join] = ACTIONS(4121),
    [anon_sym_on] = ACTIONS(4121),
    [anon_sym_equals] = ACTIONS(4121),
    [anon_sym_let] = ACTIONS(4121),
    [anon_sym_orderby] = ACTIONS(4121),
    [anon_sym_group] = ACTIONS(4121),
    [anon_sym_by] = ACTIONS(4121),
    [anon_sym_select] = ACTIONS(4121),
    [anon_sym_as] = ACTIONS(4121),
    [anon_sym_is] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [anon_sym_with] = ACTIONS(4121),
    [aux_sym_preproc_if_token3] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2991] = {
    [sym_preproc_region] = STATE(2991),
    [sym_preproc_endregion] = STATE(2991),
    [sym_preproc_line] = STATE(2991),
    [sym_preproc_pragma] = STATE(2991),
    [sym_preproc_nullable] = STATE(2991),
    [sym_preproc_error] = STATE(2991),
    [sym_preproc_warning] = STATE(2991),
    [sym_preproc_define] = STATE(2991),
    [sym_preproc_undef] = STATE(2991),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3666),
    [anon_sym_where] = ACTIONS(3668),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3668),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3668),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3668),
    [anon_sym_from] = ACTIONS(3668),
    [anon_sym_into] = ACTIONS(3668),
    [anon_sym_join] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_let] = ACTIONS(3668),
    [anon_sym_orderby] = ACTIONS(3668),
    [anon_sym_group] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_select] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2992] = {
    [sym_preproc_region] = STATE(2992),
    [sym_preproc_endregion] = STATE(2992),
    [sym_preproc_line] = STATE(2992),
    [sym_preproc_pragma] = STATE(2992),
    [sym_preproc_nullable] = STATE(2992),
    [sym_preproc_error] = STATE(2992),
    [sym_preproc_warning] = STATE(2992),
    [sym_preproc_define] = STATE(2992),
    [sym_preproc_undef] = STATE(2992),
    [anon_sym_SEMI] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3722),
    [anon_sym_DASH_DASH] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_GT_GT_GT] = ACTIONS(3722),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_GT_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_switch] = ACTIONS(3722),
    [anon_sym_DOT_DOT] = ACTIONS(3722),
    [anon_sym_and] = ACTIONS(3722),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_QMARK_QMARK] = ACTIONS(3722),
    [anon_sym_from] = ACTIONS(3722),
    [anon_sym_into] = ACTIONS(3722),
    [anon_sym_join] = ACTIONS(3722),
    [anon_sym_on] = ACTIONS(3722),
    [anon_sym_equals] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_orderby] = ACTIONS(3722),
    [anon_sym_group] = ACTIONS(3722),
    [anon_sym_by] = ACTIONS(3722),
    [anon_sym_select] = ACTIONS(3722),
    [anon_sym_as] = ACTIONS(3722),
    [anon_sym_is] = ACTIONS(3722),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_with] = ACTIONS(3722),
    [aux_sym_preproc_if_token3] = ACTIONS(3722),
    [aux_sym_preproc_else_token1] = ACTIONS(3722),
    [aux_sym_preproc_elif_token1] = ACTIONS(3722),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2993] = {
    [sym_preproc_region] = STATE(2993),
    [sym_preproc_endregion] = STATE(2993),
    [sym_preproc_line] = STATE(2993),
    [sym_preproc_pragma] = STATE(2993),
    [sym_preproc_nullable] = STATE(2993),
    [sym_preproc_error] = STATE(2993),
    [sym_preproc_warning] = STATE(2993),
    [sym_preproc_define] = STATE(2993),
    [sym_preproc_undef] = STATE(2993),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RBRACK] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(4969),
    [anon_sym_where] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_EQ_GT] = ACTIONS(4967),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4969),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_from] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_join] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_let] = ACTIONS(4967),
    [anon_sym_orderby] = ACTIONS(4967),
    [anon_sym_group] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_select] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4967),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [sym_string_literal_encoding] = ACTIONS(4971),
    [aux_sym_preproc_if_token3] = ACTIONS(4967),
    [aux_sym_preproc_else_token1] = ACTIONS(4967),
    [aux_sym_preproc_elif_token1] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2994] = {
    [sym_preproc_region] = STATE(2994),
    [sym_preproc_endregion] = STATE(2994),
    [sym_preproc_line] = STATE(2994),
    [sym_preproc_pragma] = STATE(2994),
    [sym_preproc_nullable] = STATE(2994),
    [sym_preproc_error] = STATE(2994),
    [sym_preproc_warning] = STATE(2994),
    [sym_preproc_define] = STATE(2994),
    [sym_preproc_undef] = STATE(2994),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_where] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4028),
    [anon_sym_into] = ACTIONS(4028),
    [anon_sym_join] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_let] = ACTIONS(4028),
    [anon_sym_orderby] = ACTIONS(4028),
    [anon_sym_group] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_select] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2995] = {
    [sym_type_argument_list] = STATE(3027),
    [sym_preproc_region] = STATE(2995),
    [sym_preproc_endregion] = STATE(2995),
    [sym_preproc_line] = STATE(2995),
    [sym_preproc_pragma] = STATE(2995),
    [sym_preproc_nullable] = STATE(2995),
    [sym_preproc_error] = STATE(2995),
    [sym_preproc_warning] = STATE(2995),
    [sym_preproc_define] = STATE(2995),
    [sym_preproc_undef] = STATE(2995),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4962),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2996] = {
    [sym_preproc_region] = STATE(2996),
    [sym_preproc_endregion] = STATE(2996),
    [sym_preproc_line] = STATE(2996),
    [sym_preproc_pragma] = STATE(2996),
    [sym_preproc_nullable] = STATE(2996),
    [sym_preproc_error] = STATE(2996),
    [sym_preproc_warning] = STATE(2996),
    [sym_preproc_define] = STATE(2996),
    [sym_preproc_undef] = STATE(2996),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4146),
    [anon_sym_in] = ACTIONS(4146),
    [anon_sym_where] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_BANG] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4146),
    [anon_sym_AMP] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4146),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_switch] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_QMARK_QMARK] = ACTIONS(4148),
    [anon_sym_from] = ACTIONS(4148),
    [anon_sym_into] = ACTIONS(4148),
    [anon_sym_join] = ACTIONS(4148),
    [anon_sym_on] = ACTIONS(4148),
    [anon_sym_equals] = ACTIONS(4148),
    [anon_sym_let] = ACTIONS(4148),
    [anon_sym_orderby] = ACTIONS(4148),
    [anon_sym_group] = ACTIONS(4148),
    [anon_sym_by] = ACTIONS(4148),
    [anon_sym_select] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4148),
    [anon_sym_is] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_with] = ACTIONS(4148),
    [aux_sym_preproc_if_token3] = ACTIONS(4148),
    [aux_sym_preproc_else_token1] = ACTIONS(4148),
    [aux_sym_preproc_elif_token1] = ACTIONS(4148),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2997] = {
    [sym_preproc_region] = STATE(2997),
    [sym_preproc_endregion] = STATE(2997),
    [sym_preproc_line] = STATE(2997),
    [sym_preproc_pragma] = STATE(2997),
    [sym_preproc_nullable] = STATE(2997),
    [sym_preproc_error] = STATE(2997),
    [sym_preproc_warning] = STATE(2997),
    [sym_preproc_define] = STATE(2997),
    [sym_preproc_undef] = STATE(2997),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_event] = ACTIONS(4743),
    [anon_sym_class] = ACTIONS(4743),
    [anon_sym_ref] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_interface] = ACTIONS(4743),
    [anon_sym_delegate] = ACTIONS(4743),
    [anon_sym_record] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4745),
    [anon_sym_implicit] = ACTIONS(4743),
    [anon_sym_explicit] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [sym_predefined_type] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_if_token3] = ACTIONS(4973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2998] = {
    [sym_preproc_region] = STATE(2998),
    [sym_preproc_endregion] = STATE(2998),
    [sym_preproc_line] = STATE(2998),
    [sym_preproc_pragma] = STATE(2998),
    [sym_preproc_nullable] = STATE(2998),
    [sym_preproc_error] = STATE(2998),
    [sym_preproc_warning] = STATE(2998),
    [sym_preproc_define] = STATE(2998),
    [sym_preproc_undef] = STATE(2998),
    [anon_sym_SEMI] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_COLON] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(4975),
    [anon_sym_RBRACK] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_RPAREN] = ACTIONS(4975),
    [anon_sym_RBRACE] = ACTIONS(4975),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_GT] = ACTIONS(4977),
    [anon_sym_in] = ACTIONS(4977),
    [anon_sym_where] = ACTIONS(4975),
    [anon_sym_QMARK] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_PLUS_PLUS] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4975),
    [anon_sym_SLASH] = ACTIONS(4977),
    [anon_sym_PERCENT] = ACTIONS(4975),
    [anon_sym_CARET] = ACTIONS(4975),
    [anon_sym_PIPE] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4975),
    [anon_sym_GT_GT] = ACTIONS(4977),
    [anon_sym_GT_GT_GT] = ACTIONS(4975),
    [anon_sym_EQ_EQ] = ACTIONS(4975),
    [anon_sym_BANG_EQ] = ACTIONS(4975),
    [anon_sym_GT_EQ] = ACTIONS(4975),
    [anon_sym_LT_EQ] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_EQ_GT] = ACTIONS(4975),
    [anon_sym_switch] = ACTIONS(4975),
    [anon_sym_DOT_DOT] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_or] = ACTIONS(4977),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_PIPE_PIPE] = ACTIONS(4975),
    [anon_sym_QMARK_QMARK] = ACTIONS(4975),
    [anon_sym_from] = ACTIONS(4975),
    [anon_sym_into] = ACTIONS(4975),
    [anon_sym_join] = ACTIONS(4975),
    [anon_sym_on] = ACTIONS(4975),
    [anon_sym_equals] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_orderby] = ACTIONS(4975),
    [anon_sym_group] = ACTIONS(4975),
    [anon_sym_by] = ACTIONS(4975),
    [anon_sym_select] = ACTIONS(4975),
    [anon_sym_as] = ACTIONS(4975),
    [anon_sym_is] = ACTIONS(4975),
    [anon_sym_DASH_GT] = ACTIONS(4975),
    [anon_sym_with] = ACTIONS(4975),
    [aux_sym_preproc_if_token3] = ACTIONS(4975),
    [aux_sym_preproc_else_token1] = ACTIONS(4975),
    [aux_sym_preproc_elif_token1] = ACTIONS(4975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [2999] = {
    [sym_preproc_region] = STATE(2999),
    [sym_preproc_endregion] = STATE(2999),
    [sym_preproc_line] = STATE(2999),
    [sym_preproc_pragma] = STATE(2999),
    [sym_preproc_nullable] = STATE(2999),
    [sym_preproc_error] = STATE(2999),
    [sym_preproc_warning] = STATE(2999),
    [sym_preproc_define] = STATE(2999),
    [sym_preproc_undef] = STATE(2999),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4144),
    [anon_sym_where] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4144),
    [anon_sym_join] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4144),
    [anon_sym_orderby] = ACTIONS(4144),
    [anon_sym_group] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_select] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3000] = {
    [sym_preproc_region] = STATE(3000),
    [sym_preproc_endregion] = STATE(3000),
    [sym_preproc_line] = STATE(3000),
    [sym_preproc_pragma] = STATE(3000),
    [sym_preproc_nullable] = STATE(3000),
    [sym_preproc_error] = STATE(3000),
    [sym_preproc_warning] = STATE(3000),
    [sym_preproc_define] = STATE(3000),
    [sym_preproc_undef] = STATE(3000),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_in] = ACTIONS(4020),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_QMARK_QMARK] = ACTIONS(4020),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4020),
    [anon_sym_is] = ACTIONS(4020),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_with] = ACTIONS(4020),
    [aux_sym_preproc_if_token3] = ACTIONS(4020),
    [aux_sym_preproc_else_token1] = ACTIONS(4020),
    [aux_sym_preproc_elif_token1] = ACTIONS(4020),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3001] = {
    [sym_preproc_region] = STATE(3001),
    [sym_preproc_endregion] = STATE(3001),
    [sym_preproc_line] = STATE(3001),
    [sym_preproc_pragma] = STATE(3001),
    [sym_preproc_nullable] = STATE(3001),
    [sym_preproc_error] = STATE(3001),
    [sym_preproc_warning] = STATE(3001),
    [sym_preproc_define] = STATE(3001),
    [sym_preproc_undef] = STATE(3001),
    [anon_sym_SEMI] = ACTIONS(4979),
    [anon_sym_LBRACK] = ACTIONS(4979),
    [anon_sym_COLON] = ACTIONS(4979),
    [anon_sym_COMMA] = ACTIONS(4979),
    [anon_sym_RBRACK] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4979),
    [anon_sym_RPAREN] = ACTIONS(4979),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_LT] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4981),
    [anon_sym_in] = ACTIONS(4981),
    [anon_sym_where] = ACTIONS(4979),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_BANG] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4979),
    [anon_sym_DASH_DASH] = ACTIONS(4979),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4981),
    [anon_sym_STAR] = ACTIONS(4979),
    [anon_sym_SLASH] = ACTIONS(4981),
    [anon_sym_PERCENT] = ACTIONS(4979),
    [anon_sym_CARET] = ACTIONS(4979),
    [anon_sym_PIPE] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4981),
    [anon_sym_LT_LT] = ACTIONS(4979),
    [anon_sym_GT_GT] = ACTIONS(4981),
    [anon_sym_GT_GT_GT] = ACTIONS(4979),
    [anon_sym_EQ_EQ] = ACTIONS(4979),
    [anon_sym_BANG_EQ] = ACTIONS(4979),
    [anon_sym_GT_EQ] = ACTIONS(4979),
    [anon_sym_LT_EQ] = ACTIONS(4979),
    [anon_sym_DOT] = ACTIONS(4981),
    [anon_sym_EQ_GT] = ACTIONS(4979),
    [anon_sym_switch] = ACTIONS(4979),
    [anon_sym_DOT_DOT] = ACTIONS(4979),
    [anon_sym_and] = ACTIONS(4979),
    [anon_sym_or] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4979),
    [anon_sym_PIPE_PIPE] = ACTIONS(4979),
    [anon_sym_QMARK_QMARK] = ACTIONS(4979),
    [anon_sym_from] = ACTIONS(4979),
    [anon_sym_into] = ACTIONS(4979),
    [anon_sym_join] = ACTIONS(4979),
    [anon_sym_on] = ACTIONS(4979),
    [anon_sym_equals] = ACTIONS(4979),
    [anon_sym_let] = ACTIONS(4979),
    [anon_sym_orderby] = ACTIONS(4979),
    [anon_sym_group] = ACTIONS(4979),
    [anon_sym_by] = ACTIONS(4979),
    [anon_sym_select] = ACTIONS(4979),
    [anon_sym_as] = ACTIONS(4979),
    [anon_sym_is] = ACTIONS(4979),
    [anon_sym_DASH_GT] = ACTIONS(4979),
    [anon_sym_with] = ACTIONS(4979),
    [aux_sym_preproc_if_token3] = ACTIONS(4979),
    [aux_sym_preproc_else_token1] = ACTIONS(4979),
    [aux_sym_preproc_elif_token1] = ACTIONS(4979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3002] = {
    [sym_preproc_region] = STATE(3002),
    [sym_preproc_endregion] = STATE(3002),
    [sym_preproc_line] = STATE(3002),
    [sym_preproc_pragma] = STATE(3002),
    [sym_preproc_nullable] = STATE(3002),
    [sym_preproc_error] = STATE(3002),
    [sym_preproc_warning] = STATE(3002),
    [sym_preproc_define] = STATE(3002),
    [sym_preproc_undef] = STATE(3002),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_COLON] = ACTIONS(4983),
    [anon_sym_COMMA] = ACTIONS(4983),
    [anon_sym_RBRACK] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_LT] = ACTIONS(4985),
    [anon_sym_GT] = ACTIONS(4985),
    [anon_sym_in] = ACTIONS(4985),
    [anon_sym_where] = ACTIONS(4983),
    [anon_sym_QMARK] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4985),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4985),
    [anon_sym_DASH] = ACTIONS(4985),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_SLASH] = ACTIONS(4985),
    [anon_sym_PERCENT] = ACTIONS(4983),
    [anon_sym_CARET] = ACTIONS(4983),
    [anon_sym_PIPE] = ACTIONS(4985),
    [anon_sym_AMP] = ACTIONS(4985),
    [anon_sym_LT_LT] = ACTIONS(4983),
    [anon_sym_GT_GT] = ACTIONS(4985),
    [anon_sym_GT_GT_GT] = ACTIONS(4983),
    [anon_sym_EQ_EQ] = ACTIONS(4983),
    [anon_sym_BANG_EQ] = ACTIONS(4983),
    [anon_sym_GT_EQ] = ACTIONS(4983),
    [anon_sym_LT_EQ] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4985),
    [anon_sym_EQ_GT] = ACTIONS(4983),
    [anon_sym_switch] = ACTIONS(4983),
    [anon_sym_DOT_DOT] = ACTIONS(4983),
    [anon_sym_and] = ACTIONS(4983),
    [anon_sym_or] = ACTIONS(4985),
    [anon_sym_AMP_AMP] = ACTIONS(4983),
    [anon_sym_PIPE_PIPE] = ACTIONS(4983),
    [anon_sym_QMARK_QMARK] = ACTIONS(4983),
    [anon_sym_from] = ACTIONS(4983),
    [anon_sym_into] = ACTIONS(4983),
    [anon_sym_join] = ACTIONS(4983),
    [anon_sym_on] = ACTIONS(4983),
    [anon_sym_equals] = ACTIONS(4983),
    [anon_sym_let] = ACTIONS(4983),
    [anon_sym_orderby] = ACTIONS(4983),
    [anon_sym_group] = ACTIONS(4983),
    [anon_sym_by] = ACTIONS(4983),
    [anon_sym_select] = ACTIONS(4983),
    [anon_sym_as] = ACTIONS(4983),
    [anon_sym_is] = ACTIONS(4983),
    [anon_sym_DASH_GT] = ACTIONS(4983),
    [anon_sym_with] = ACTIONS(4983),
    [aux_sym_preproc_if_token3] = ACTIONS(4983),
    [aux_sym_preproc_else_token1] = ACTIONS(4983),
    [aux_sym_preproc_elif_token1] = ACTIONS(4983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3003] = {
    [sym_preproc_region] = STATE(3003),
    [sym_preproc_endregion] = STATE(3003),
    [sym_preproc_line] = STATE(3003),
    [sym_preproc_pragma] = STATE(3003),
    [sym_preproc_nullable] = STATE(3003),
    [sym_preproc_error] = STATE(3003),
    [sym_preproc_warning] = STATE(3003),
    [sym_preproc_define] = STATE(3003),
    [sym_preproc_undef] = STATE(3003),
    [anon_sym_SEMI] = ACTIONS(4987),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_COLON] = ACTIONS(4987),
    [anon_sym_COMMA] = ACTIONS(4987),
    [anon_sym_RBRACK] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_LT] = ACTIONS(4989),
    [anon_sym_GT] = ACTIONS(4989),
    [anon_sym_in] = ACTIONS(4989),
    [anon_sym_where] = ACTIONS(4987),
    [anon_sym_QMARK] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4987),
    [anon_sym_PLUS] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4987),
    [anon_sym_SLASH] = ACTIONS(4989),
    [anon_sym_PERCENT] = ACTIONS(4987),
    [anon_sym_CARET] = ACTIONS(4987),
    [anon_sym_PIPE] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_LT_LT] = ACTIONS(4987),
    [anon_sym_GT_GT] = ACTIONS(4989),
    [anon_sym_GT_GT_GT] = ACTIONS(4987),
    [anon_sym_EQ_EQ] = ACTIONS(4987),
    [anon_sym_BANG_EQ] = ACTIONS(4987),
    [anon_sym_GT_EQ] = ACTIONS(4987),
    [anon_sym_LT_EQ] = ACTIONS(4987),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_EQ_GT] = ACTIONS(4987),
    [anon_sym_switch] = ACTIONS(4987),
    [anon_sym_DOT_DOT] = ACTIONS(4987),
    [anon_sym_and] = ACTIONS(4987),
    [anon_sym_or] = ACTIONS(4989),
    [anon_sym_AMP_AMP] = ACTIONS(4987),
    [anon_sym_PIPE_PIPE] = ACTIONS(4987),
    [anon_sym_QMARK_QMARK] = ACTIONS(4987),
    [anon_sym_from] = ACTIONS(4987),
    [anon_sym_into] = ACTIONS(4987),
    [anon_sym_join] = ACTIONS(4987),
    [anon_sym_on] = ACTIONS(4987),
    [anon_sym_equals] = ACTIONS(4987),
    [anon_sym_let] = ACTIONS(4987),
    [anon_sym_orderby] = ACTIONS(4987),
    [anon_sym_group] = ACTIONS(4987),
    [anon_sym_by] = ACTIONS(4987),
    [anon_sym_select] = ACTIONS(4987),
    [anon_sym_as] = ACTIONS(4987),
    [anon_sym_is] = ACTIONS(4987),
    [anon_sym_DASH_GT] = ACTIONS(4987),
    [anon_sym_with] = ACTIONS(4987),
    [aux_sym_preproc_if_token3] = ACTIONS(4987),
    [aux_sym_preproc_else_token1] = ACTIONS(4987),
    [aux_sym_preproc_elif_token1] = ACTIONS(4987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3004] = {
    [sym_preproc_region] = STATE(3004),
    [sym_preproc_endregion] = STATE(3004),
    [sym_preproc_line] = STATE(3004),
    [sym_preproc_pragma] = STATE(3004),
    [sym_preproc_nullable] = STATE(3004),
    [sym_preproc_error] = STATE(3004),
    [sym_preproc_warning] = STATE(3004),
    [sym_preproc_define] = STATE(3004),
    [sym_preproc_undef] = STATE(3004),
    [anon_sym_SEMI] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_COLON] = ACTIONS(4991),
    [anon_sym_COMMA] = ACTIONS(4991),
    [anon_sym_RBRACK] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_RPAREN] = ACTIONS(4991),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_LT] = ACTIONS(4993),
    [anon_sym_GT] = ACTIONS(4993),
    [anon_sym_in] = ACTIONS(4993),
    [anon_sym_where] = ACTIONS(4991),
    [anon_sym_QMARK] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4991),
    [anon_sym_PLUS] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4991),
    [anon_sym_SLASH] = ACTIONS(4993),
    [anon_sym_PERCENT] = ACTIONS(4991),
    [anon_sym_CARET] = ACTIONS(4991),
    [anon_sym_PIPE] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_LT_LT] = ACTIONS(4991),
    [anon_sym_GT_GT] = ACTIONS(4993),
    [anon_sym_GT_GT_GT] = ACTIONS(4991),
    [anon_sym_EQ_EQ] = ACTIONS(4991),
    [anon_sym_BANG_EQ] = ACTIONS(4991),
    [anon_sym_GT_EQ] = ACTIONS(4991),
    [anon_sym_LT_EQ] = ACTIONS(4991),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_EQ_GT] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_DOT_DOT] = ACTIONS(4991),
    [anon_sym_and] = ACTIONS(4991),
    [anon_sym_or] = ACTIONS(4993),
    [anon_sym_AMP_AMP] = ACTIONS(4991),
    [anon_sym_PIPE_PIPE] = ACTIONS(4991),
    [anon_sym_QMARK_QMARK] = ACTIONS(4991),
    [anon_sym_from] = ACTIONS(4991),
    [anon_sym_into] = ACTIONS(4991),
    [anon_sym_join] = ACTIONS(4991),
    [anon_sym_on] = ACTIONS(4991),
    [anon_sym_equals] = ACTIONS(4991),
    [anon_sym_let] = ACTIONS(4991),
    [anon_sym_orderby] = ACTIONS(4991),
    [anon_sym_group] = ACTIONS(4991),
    [anon_sym_by] = ACTIONS(4991),
    [anon_sym_select] = ACTIONS(4991),
    [anon_sym_as] = ACTIONS(4991),
    [anon_sym_is] = ACTIONS(4991),
    [anon_sym_DASH_GT] = ACTIONS(4991),
    [anon_sym_with] = ACTIONS(4991),
    [aux_sym_preproc_if_token3] = ACTIONS(4991),
    [aux_sym_preproc_else_token1] = ACTIONS(4991),
    [aux_sym_preproc_elif_token1] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3005] = {
    [sym_preproc_region] = STATE(3005),
    [sym_preproc_endregion] = STATE(3005),
    [sym_preproc_line] = STATE(3005),
    [sym_preproc_pragma] = STATE(3005),
    [sym_preproc_nullable] = STATE(3005),
    [sym_preproc_error] = STATE(3005),
    [sym_preproc_warning] = STATE(3005),
    [sym_preproc_define] = STATE(3005),
    [sym_preproc_undef] = STATE(3005),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_LBRACK] = ACTIONS(4995),
    [anon_sym_COLON] = ACTIONS(4995),
    [anon_sym_COMMA] = ACTIONS(4995),
    [anon_sym_RBRACK] = ACTIONS(4995),
    [anon_sym_LPAREN] = ACTIONS(4995),
    [anon_sym_RPAREN] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_in] = ACTIONS(4997),
    [anon_sym_where] = ACTIONS(4995),
    [anon_sym_QMARK] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_PLUS_PLUS] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4995),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4995),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4995),
    [anon_sym_CARET] = ACTIONS(4995),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4995),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_GT_GT_GT] = ACTIONS(4995),
    [anon_sym_EQ_EQ] = ACTIONS(4995),
    [anon_sym_BANG_EQ] = ACTIONS(4995),
    [anon_sym_GT_EQ] = ACTIONS(4995),
    [anon_sym_LT_EQ] = ACTIONS(4995),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_EQ_GT] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_DOT_DOT] = ACTIONS(4995),
    [anon_sym_and] = ACTIONS(4995),
    [anon_sym_or] = ACTIONS(4997),
    [anon_sym_AMP_AMP] = ACTIONS(4995),
    [anon_sym_PIPE_PIPE] = ACTIONS(4995),
    [anon_sym_QMARK_QMARK] = ACTIONS(4995),
    [anon_sym_from] = ACTIONS(4995),
    [anon_sym_into] = ACTIONS(4995),
    [anon_sym_join] = ACTIONS(4995),
    [anon_sym_on] = ACTIONS(4995),
    [anon_sym_equals] = ACTIONS(4995),
    [anon_sym_let] = ACTIONS(4995),
    [anon_sym_orderby] = ACTIONS(4995),
    [anon_sym_group] = ACTIONS(4995),
    [anon_sym_by] = ACTIONS(4995),
    [anon_sym_select] = ACTIONS(4995),
    [anon_sym_as] = ACTIONS(4995),
    [anon_sym_is] = ACTIONS(4995),
    [anon_sym_DASH_GT] = ACTIONS(4995),
    [anon_sym_with] = ACTIONS(4995),
    [aux_sym_preproc_if_token3] = ACTIONS(4995),
    [aux_sym_preproc_else_token1] = ACTIONS(4995),
    [aux_sym_preproc_elif_token1] = ACTIONS(4995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3006] = {
    [sym_preproc_region] = STATE(3006),
    [sym_preproc_endregion] = STATE(3006),
    [sym_preproc_line] = STATE(3006),
    [sym_preproc_pragma] = STATE(3006),
    [sym_preproc_nullable] = STATE(3006),
    [sym_preproc_error] = STATE(3006),
    [sym_preproc_warning] = STATE(3006),
    [sym_preproc_define] = STATE(3006),
    [sym_preproc_undef] = STATE(3006),
    [anon_sym_SEMI] = ACTIONS(4999),
    [anon_sym_LBRACK] = ACTIONS(4999),
    [anon_sym_COLON] = ACTIONS(4999),
    [anon_sym_COMMA] = ACTIONS(4999),
    [anon_sym_RBRACK] = ACTIONS(4999),
    [anon_sym_LPAREN] = ACTIONS(4999),
    [anon_sym_RPAREN] = ACTIONS(4999),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym_LT] = ACTIONS(5001),
    [anon_sym_GT] = ACTIONS(5001),
    [anon_sym_in] = ACTIONS(5001),
    [anon_sym_where] = ACTIONS(4999),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(4999),
    [anon_sym_PLUS] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(4999),
    [anon_sym_SLASH] = ACTIONS(5001),
    [anon_sym_PERCENT] = ACTIONS(4999),
    [anon_sym_CARET] = ACTIONS(4999),
    [anon_sym_PIPE] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_LT_LT] = ACTIONS(4999),
    [anon_sym_GT_GT] = ACTIONS(5001),
    [anon_sym_GT_GT_GT] = ACTIONS(4999),
    [anon_sym_EQ_EQ] = ACTIONS(4999),
    [anon_sym_BANG_EQ] = ACTIONS(4999),
    [anon_sym_GT_EQ] = ACTIONS(4999),
    [anon_sym_LT_EQ] = ACTIONS(4999),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_EQ_GT] = ACTIONS(4999),
    [anon_sym_switch] = ACTIONS(4999),
    [anon_sym_DOT_DOT] = ACTIONS(4999),
    [anon_sym_and] = ACTIONS(4999),
    [anon_sym_or] = ACTIONS(5001),
    [anon_sym_AMP_AMP] = ACTIONS(4999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4999),
    [anon_sym_QMARK_QMARK] = ACTIONS(4999),
    [anon_sym_from] = ACTIONS(4999),
    [anon_sym_into] = ACTIONS(4999),
    [anon_sym_join] = ACTIONS(4999),
    [anon_sym_on] = ACTIONS(4999),
    [anon_sym_equals] = ACTIONS(4999),
    [anon_sym_let] = ACTIONS(4999),
    [anon_sym_orderby] = ACTIONS(4999),
    [anon_sym_group] = ACTIONS(4999),
    [anon_sym_by] = ACTIONS(4999),
    [anon_sym_select] = ACTIONS(4999),
    [anon_sym_as] = ACTIONS(4999),
    [anon_sym_is] = ACTIONS(4999),
    [anon_sym_DASH_GT] = ACTIONS(4999),
    [anon_sym_with] = ACTIONS(4999),
    [aux_sym_preproc_if_token3] = ACTIONS(4999),
    [aux_sym_preproc_else_token1] = ACTIONS(4999),
    [aux_sym_preproc_elif_token1] = ACTIONS(4999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3007] = {
    [sym_preproc_region] = STATE(3007),
    [sym_preproc_endregion] = STATE(3007),
    [sym_preproc_line] = STATE(3007),
    [sym_preproc_pragma] = STATE(3007),
    [sym_preproc_nullable] = STATE(3007),
    [sym_preproc_error] = STATE(3007),
    [sym_preproc_warning] = STATE(3007),
    [sym_preproc_define] = STATE(3007),
    [sym_preproc_undef] = STATE(3007),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RBRACK] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(4969),
    [anon_sym_where] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_EQ_GT] = ACTIONS(4967),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4969),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_from] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_join] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_let] = ACTIONS(4967),
    [anon_sym_orderby] = ACTIONS(4967),
    [anon_sym_group] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_select] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4967),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [aux_sym_preproc_if_token3] = ACTIONS(4967),
    [aux_sym_preproc_else_token1] = ACTIONS(4967),
    [aux_sym_preproc_elif_token1] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3008] = {
    [sym_preproc_region] = STATE(3008),
    [sym_preproc_endregion] = STATE(3008),
    [sym_preproc_line] = STATE(3008),
    [sym_preproc_pragma] = STATE(3008),
    [sym_preproc_nullable] = STATE(3008),
    [sym_preproc_error] = STATE(3008),
    [sym_preproc_warning] = STATE(3008),
    [sym_preproc_define] = STATE(3008),
    [sym_preproc_undef] = STATE(3008),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_COLON] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RBRACK] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_in] = ACTIONS(5005),
    [anon_sym_where] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_CARET] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5003),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_GT_GT_GT] = ACTIONS(5003),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_EQ_GT] = ACTIONS(5003),
    [anon_sym_switch] = ACTIONS(5003),
    [anon_sym_DOT_DOT] = ACTIONS(5003),
    [anon_sym_and] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_QMARK_QMARK] = ACTIONS(5003),
    [anon_sym_from] = ACTIONS(5003),
    [anon_sym_into] = ACTIONS(5003),
    [anon_sym_join] = ACTIONS(5003),
    [anon_sym_on] = ACTIONS(5003),
    [anon_sym_equals] = ACTIONS(5003),
    [anon_sym_let] = ACTIONS(5003),
    [anon_sym_orderby] = ACTIONS(5003),
    [anon_sym_group] = ACTIONS(5003),
    [anon_sym_by] = ACTIONS(5003),
    [anon_sym_select] = ACTIONS(5003),
    [anon_sym_as] = ACTIONS(5003),
    [anon_sym_is] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [anon_sym_with] = ACTIONS(5003),
    [aux_sym_preproc_if_token3] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3009] = {
    [sym_preproc_region] = STATE(3009),
    [sym_preproc_endregion] = STATE(3009),
    [sym_preproc_line] = STATE(3009),
    [sym_preproc_pragma] = STATE(3009),
    [sym_preproc_nullable] = STATE(3009),
    [sym_preproc_error] = STATE(3009),
    [sym_preproc_warning] = STATE(3009),
    [sym_preproc_define] = STATE(3009),
    [sym_preproc_undef] = STATE(3009),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4146),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_where] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_BANG] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4146),
    [anon_sym_AMP] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4146),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_switch] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_QMARK_QMARK] = ACTIONS(4148),
    [anon_sym_from] = ACTIONS(4148),
    [anon_sym_join] = ACTIONS(4148),
    [anon_sym_on] = ACTIONS(4148),
    [anon_sym_equals] = ACTIONS(4148),
    [anon_sym_let] = ACTIONS(4148),
    [anon_sym_orderby] = ACTIONS(4148),
    [anon_sym_group] = ACTIONS(4148),
    [anon_sym_by] = ACTIONS(4148),
    [anon_sym_select] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4148),
    [anon_sym_is] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_with] = ACTIONS(4148),
    [aux_sym_preproc_if_token3] = ACTIONS(4148),
    [aux_sym_preproc_else_token1] = ACTIONS(4148),
    [aux_sym_preproc_elif_token1] = ACTIONS(4148),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3010] = {
    [sym_preproc_region] = STATE(3010),
    [sym_preproc_endregion] = STATE(3010),
    [sym_preproc_line] = STATE(3010),
    [sym_preproc_pragma] = STATE(3010),
    [sym_preproc_nullable] = STATE(3010),
    [sym_preproc_error] = STATE(3010),
    [sym_preproc_warning] = STATE(3010),
    [sym_preproc_define] = STATE(3010),
    [sym_preproc_undef] = STATE(3010),
    [anon_sym_SEMI] = ACTIONS(5007),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5007),
    [anon_sym_COMMA] = ACTIONS(5007),
    [anon_sym_RBRACK] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_LT] = ACTIONS(5009),
    [anon_sym_GT] = ACTIONS(5009),
    [anon_sym_in] = ACTIONS(5009),
    [anon_sym_where] = ACTIONS(5007),
    [anon_sym_QMARK] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_PLUS_PLUS] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5007),
    [anon_sym_PLUS] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5009),
    [anon_sym_PERCENT] = ACTIONS(5007),
    [anon_sym_CARET] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_LT_LT] = ACTIONS(5007),
    [anon_sym_GT_GT] = ACTIONS(5009),
    [anon_sym_GT_GT_GT] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(5007),
    [anon_sym_BANG_EQ] = ACTIONS(5007),
    [anon_sym_GT_EQ] = ACTIONS(5007),
    [anon_sym_LT_EQ] = ACTIONS(5007),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_EQ_GT] = ACTIONS(5007),
    [anon_sym_switch] = ACTIONS(5007),
    [anon_sym_DOT_DOT] = ACTIONS(5007),
    [anon_sym_and] = ACTIONS(5007),
    [anon_sym_or] = ACTIONS(5009),
    [anon_sym_AMP_AMP] = ACTIONS(5007),
    [anon_sym_PIPE_PIPE] = ACTIONS(5007),
    [anon_sym_QMARK_QMARK] = ACTIONS(5007),
    [anon_sym_from] = ACTIONS(5007),
    [anon_sym_into] = ACTIONS(5007),
    [anon_sym_join] = ACTIONS(5007),
    [anon_sym_on] = ACTIONS(5007),
    [anon_sym_equals] = ACTIONS(5007),
    [anon_sym_let] = ACTIONS(5007),
    [anon_sym_orderby] = ACTIONS(5007),
    [anon_sym_group] = ACTIONS(5007),
    [anon_sym_by] = ACTIONS(5007),
    [anon_sym_select] = ACTIONS(5007),
    [anon_sym_as] = ACTIONS(5007),
    [anon_sym_is] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5007),
    [anon_sym_with] = ACTIONS(5007),
    [aux_sym_preproc_if_token3] = ACTIONS(5007),
    [aux_sym_preproc_else_token1] = ACTIONS(5007),
    [aux_sym_preproc_elif_token1] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3011] = {
    [sym_preproc_region] = STATE(3011),
    [sym_preproc_endregion] = STATE(3011),
    [sym_preproc_line] = STATE(3011),
    [sym_preproc_pragma] = STATE(3011),
    [sym_preproc_nullable] = STATE(3011),
    [sym_preproc_error] = STATE(3011),
    [sym_preproc_warning] = STATE(3011),
    [sym_preproc_define] = STATE(3011),
    [sym_preproc_undef] = STATE(3011),
    [anon_sym_SEMI] = ACTIONS(5011),
    [anon_sym_LBRACK] = ACTIONS(5011),
    [anon_sym_COLON] = ACTIONS(5011),
    [anon_sym_COMMA] = ACTIONS(5011),
    [anon_sym_RBRACK] = ACTIONS(5011),
    [anon_sym_LPAREN] = ACTIONS(5011),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [anon_sym_LT] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5013),
    [anon_sym_in] = ACTIONS(5013),
    [anon_sym_where] = ACTIONS(5011),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_BANG] = ACTIONS(5013),
    [anon_sym_PLUS_PLUS] = ACTIONS(5011),
    [anon_sym_DASH_DASH] = ACTIONS(5011),
    [anon_sym_PLUS] = ACTIONS(5013),
    [anon_sym_DASH] = ACTIONS(5013),
    [anon_sym_STAR] = ACTIONS(5011),
    [anon_sym_SLASH] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5011),
    [anon_sym_CARET] = ACTIONS(5011),
    [anon_sym_PIPE] = ACTIONS(5013),
    [anon_sym_AMP] = ACTIONS(5013),
    [anon_sym_LT_LT] = ACTIONS(5011),
    [anon_sym_GT_GT] = ACTIONS(5013),
    [anon_sym_GT_GT_GT] = ACTIONS(5011),
    [anon_sym_EQ_EQ] = ACTIONS(5011),
    [anon_sym_BANG_EQ] = ACTIONS(5011),
    [anon_sym_GT_EQ] = ACTIONS(5011),
    [anon_sym_LT_EQ] = ACTIONS(5011),
    [anon_sym_DOT] = ACTIONS(5013),
    [anon_sym_EQ_GT] = ACTIONS(5011),
    [anon_sym_switch] = ACTIONS(5011),
    [anon_sym_DOT_DOT] = ACTIONS(5011),
    [anon_sym_and] = ACTIONS(5011),
    [anon_sym_or] = ACTIONS(5013),
    [anon_sym_AMP_AMP] = ACTIONS(5011),
    [anon_sym_PIPE_PIPE] = ACTIONS(5011),
    [anon_sym_QMARK_QMARK] = ACTIONS(5011),
    [anon_sym_from] = ACTIONS(5011),
    [anon_sym_into] = ACTIONS(5011),
    [anon_sym_join] = ACTIONS(5011),
    [anon_sym_on] = ACTIONS(5011),
    [anon_sym_equals] = ACTIONS(5011),
    [anon_sym_let] = ACTIONS(5011),
    [anon_sym_orderby] = ACTIONS(5011),
    [anon_sym_group] = ACTIONS(5011),
    [anon_sym_by] = ACTIONS(5011),
    [anon_sym_select] = ACTIONS(5011),
    [anon_sym_as] = ACTIONS(5011),
    [anon_sym_is] = ACTIONS(5011),
    [anon_sym_DASH_GT] = ACTIONS(5011),
    [anon_sym_with] = ACTIONS(5011),
    [aux_sym_preproc_if_token3] = ACTIONS(5011),
    [aux_sym_preproc_else_token1] = ACTIONS(5011),
    [aux_sym_preproc_elif_token1] = ACTIONS(5011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3012] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6128),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5760),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(3012),
    [sym_preproc_endregion] = STATE(3012),
    [sym_preproc_line] = STATE(3012),
    [sym_preproc_pragma] = STATE(3012),
    [sym_preproc_nullable] = STATE(3012),
    [sym_preproc_error] = STATE(3012),
    [sym_preproc_warning] = STATE(3012),
    [sym_preproc_define] = STATE(3012),
    [sym_preproc_undef] = STATE(3012),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(4439),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(3430),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_params] = ACTIONS(4757),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3013] = {
    [sym_preproc_region] = STATE(3013),
    [sym_preproc_endregion] = STATE(3013),
    [sym_preproc_line] = STATE(3013),
    [sym_preproc_pragma] = STATE(3013),
    [sym_preproc_nullable] = STATE(3013),
    [sym_preproc_error] = STATE(3013),
    [sym_preproc_warning] = STATE(3013),
    [sym_preproc_define] = STATE(3013),
    [sym_preproc_undef] = STATE(3013),
    [anon_sym_SEMI] = ACTIONS(5015),
    [anon_sym_LBRACK] = ACTIONS(5015),
    [anon_sym_COLON] = ACTIONS(5015),
    [anon_sym_COMMA] = ACTIONS(5015),
    [anon_sym_RBRACK] = ACTIONS(5015),
    [anon_sym_LPAREN] = ACTIONS(5015),
    [anon_sym_RPAREN] = ACTIONS(5015),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_LT] = ACTIONS(5017),
    [anon_sym_GT] = ACTIONS(5017),
    [anon_sym_in] = ACTIONS(5017),
    [anon_sym_where] = ACTIONS(5015),
    [anon_sym_QMARK] = ACTIONS(5017),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_PLUS_PLUS] = ACTIONS(5015),
    [anon_sym_DASH_DASH] = ACTIONS(5015),
    [anon_sym_PLUS] = ACTIONS(5017),
    [anon_sym_DASH] = ACTIONS(5017),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_SLASH] = ACTIONS(5017),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_PIPE] = ACTIONS(5017),
    [anon_sym_AMP] = ACTIONS(5017),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_GT_GT] = ACTIONS(5017),
    [anon_sym_GT_GT_GT] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5015),
    [anon_sym_BANG_EQ] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5015),
    [anon_sym_LT_EQ] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5017),
    [anon_sym_EQ_GT] = ACTIONS(5015),
    [anon_sym_switch] = ACTIONS(5015),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_and] = ACTIONS(5015),
    [anon_sym_or] = ACTIONS(5017),
    [anon_sym_AMP_AMP] = ACTIONS(5015),
    [anon_sym_PIPE_PIPE] = ACTIONS(5015),
    [anon_sym_QMARK_QMARK] = ACTIONS(5015),
    [anon_sym_from] = ACTIONS(5015),
    [anon_sym_into] = ACTIONS(5015),
    [anon_sym_join] = ACTIONS(5015),
    [anon_sym_on] = ACTIONS(5015),
    [anon_sym_equals] = ACTIONS(5015),
    [anon_sym_let] = ACTIONS(5015),
    [anon_sym_orderby] = ACTIONS(5015),
    [anon_sym_group] = ACTIONS(5015),
    [anon_sym_by] = ACTIONS(5015),
    [anon_sym_select] = ACTIONS(5015),
    [anon_sym_as] = ACTIONS(5015),
    [anon_sym_is] = ACTIONS(5015),
    [anon_sym_DASH_GT] = ACTIONS(5015),
    [anon_sym_with] = ACTIONS(5015),
    [aux_sym_preproc_if_token3] = ACTIONS(5015),
    [aux_sym_preproc_else_token1] = ACTIONS(5015),
    [aux_sym_preproc_elif_token1] = ACTIONS(5015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3014] = {
    [sym_preproc_region] = STATE(3014),
    [sym_preproc_endregion] = STATE(3014),
    [sym_preproc_line] = STATE(3014),
    [sym_preproc_pragma] = STATE(3014),
    [sym_preproc_nullable] = STATE(3014),
    [sym_preproc_error] = STATE(3014),
    [sym_preproc_warning] = STATE(3014),
    [sym_preproc_define] = STATE(3014),
    [sym_preproc_undef] = STATE(3014),
    [anon_sym_SEMI] = ACTIONS(5019),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_COLON] = ACTIONS(5019),
    [anon_sym_COMMA] = ACTIONS(5019),
    [anon_sym_RBRACK] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_RPAREN] = ACTIONS(5019),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_LT] = ACTIONS(5021),
    [anon_sym_GT] = ACTIONS(5021),
    [anon_sym_in] = ACTIONS(5021),
    [anon_sym_where] = ACTIONS(5019),
    [anon_sym_QMARK] = ACTIONS(5021),
    [anon_sym_BANG] = ACTIONS(5021),
    [anon_sym_PLUS_PLUS] = ACTIONS(5019),
    [anon_sym_DASH_DASH] = ACTIONS(5019),
    [anon_sym_PLUS] = ACTIONS(5021),
    [anon_sym_DASH] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(5019),
    [anon_sym_SLASH] = ACTIONS(5021),
    [anon_sym_PERCENT] = ACTIONS(5019),
    [anon_sym_CARET] = ACTIONS(5019),
    [anon_sym_PIPE] = ACTIONS(5021),
    [anon_sym_AMP] = ACTIONS(5021),
    [anon_sym_LT_LT] = ACTIONS(5019),
    [anon_sym_GT_GT] = ACTIONS(5021),
    [anon_sym_GT_GT_GT] = ACTIONS(5019),
    [anon_sym_EQ_EQ] = ACTIONS(5019),
    [anon_sym_BANG_EQ] = ACTIONS(5019),
    [anon_sym_GT_EQ] = ACTIONS(5019),
    [anon_sym_LT_EQ] = ACTIONS(5019),
    [anon_sym_DOT] = ACTIONS(5021),
    [anon_sym_EQ_GT] = ACTIONS(5019),
    [anon_sym_switch] = ACTIONS(5019),
    [anon_sym_DOT_DOT] = ACTIONS(5019),
    [anon_sym_and] = ACTIONS(5019),
    [anon_sym_or] = ACTIONS(5021),
    [anon_sym_AMP_AMP] = ACTIONS(5019),
    [anon_sym_PIPE_PIPE] = ACTIONS(5019),
    [anon_sym_QMARK_QMARK] = ACTIONS(5019),
    [anon_sym_from] = ACTIONS(5019),
    [anon_sym_into] = ACTIONS(5019),
    [anon_sym_join] = ACTIONS(5019),
    [anon_sym_on] = ACTIONS(5019),
    [anon_sym_equals] = ACTIONS(5019),
    [anon_sym_let] = ACTIONS(5019),
    [anon_sym_orderby] = ACTIONS(5019),
    [anon_sym_group] = ACTIONS(5019),
    [anon_sym_by] = ACTIONS(5019),
    [anon_sym_select] = ACTIONS(5019),
    [anon_sym_as] = ACTIONS(5019),
    [anon_sym_is] = ACTIONS(5019),
    [anon_sym_DASH_GT] = ACTIONS(5019),
    [anon_sym_with] = ACTIONS(5019),
    [aux_sym_preproc_if_token3] = ACTIONS(5019),
    [aux_sym_preproc_else_token1] = ACTIONS(5019),
    [aux_sym_preproc_elif_token1] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3015] = {
    [sym_preproc_region] = STATE(3015),
    [sym_preproc_endregion] = STATE(3015),
    [sym_preproc_line] = STATE(3015),
    [sym_preproc_pragma] = STATE(3015),
    [sym_preproc_nullable] = STATE(3015),
    [sym_preproc_error] = STATE(3015),
    [sym_preproc_warning] = STATE(3015),
    [sym_preproc_define] = STATE(3015),
    [sym_preproc_undef] = STATE(3015),
    [anon_sym_SEMI] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_COLON] = ACTIONS(5023),
    [anon_sym_COMMA] = ACTIONS(5023),
    [anon_sym_RBRACK] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_RPAREN] = ACTIONS(5023),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_LT] = ACTIONS(5025),
    [anon_sym_GT] = ACTIONS(5025),
    [anon_sym_in] = ACTIONS(5025),
    [anon_sym_where] = ACTIONS(5023),
    [anon_sym_QMARK] = ACTIONS(5025),
    [anon_sym_BANG] = ACTIONS(5025),
    [anon_sym_PLUS_PLUS] = ACTIONS(5023),
    [anon_sym_DASH_DASH] = ACTIONS(5023),
    [anon_sym_PLUS] = ACTIONS(5025),
    [anon_sym_DASH] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5023),
    [anon_sym_SLASH] = ACTIONS(5025),
    [anon_sym_PERCENT] = ACTIONS(5023),
    [anon_sym_CARET] = ACTIONS(5023),
    [anon_sym_PIPE] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5025),
    [anon_sym_LT_LT] = ACTIONS(5023),
    [anon_sym_GT_GT] = ACTIONS(5025),
    [anon_sym_GT_GT_GT] = ACTIONS(5023),
    [anon_sym_EQ_EQ] = ACTIONS(5023),
    [anon_sym_BANG_EQ] = ACTIONS(5023),
    [anon_sym_GT_EQ] = ACTIONS(5023),
    [anon_sym_LT_EQ] = ACTIONS(5023),
    [anon_sym_DOT] = ACTIONS(5025),
    [anon_sym_EQ_GT] = ACTIONS(5023),
    [anon_sym_switch] = ACTIONS(5023),
    [anon_sym_DOT_DOT] = ACTIONS(5023),
    [anon_sym_and] = ACTIONS(5023),
    [anon_sym_or] = ACTIONS(5025),
    [anon_sym_AMP_AMP] = ACTIONS(5023),
    [anon_sym_PIPE_PIPE] = ACTIONS(5023),
    [anon_sym_QMARK_QMARK] = ACTIONS(5023),
    [anon_sym_from] = ACTIONS(5023),
    [anon_sym_into] = ACTIONS(5023),
    [anon_sym_join] = ACTIONS(5023),
    [anon_sym_on] = ACTIONS(5023),
    [anon_sym_equals] = ACTIONS(5023),
    [anon_sym_let] = ACTIONS(5023),
    [anon_sym_orderby] = ACTIONS(5023),
    [anon_sym_group] = ACTIONS(5023),
    [anon_sym_by] = ACTIONS(5023),
    [anon_sym_select] = ACTIONS(5023),
    [anon_sym_as] = ACTIONS(5023),
    [anon_sym_is] = ACTIONS(5023),
    [anon_sym_DASH_GT] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5023),
    [aux_sym_preproc_if_token3] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3016] = {
    [sym_preproc_region] = STATE(3016),
    [sym_preproc_endregion] = STATE(3016),
    [sym_preproc_line] = STATE(3016),
    [sym_preproc_pragma] = STATE(3016),
    [sym_preproc_nullable] = STATE(3016),
    [sym_preproc_error] = STATE(3016),
    [sym_preproc_warning] = STATE(3016),
    [sym_preproc_define] = STATE(3016),
    [sym_preproc_undef] = STATE(3016),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4028),
    [anon_sym_where] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4028),
    [anon_sym_join] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_let] = ACTIONS(4028),
    [anon_sym_orderby] = ACTIONS(4028),
    [anon_sym_group] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_select] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3017] = {
    [sym_preproc_region] = STATE(3017),
    [sym_preproc_endregion] = STATE(3017),
    [sym_preproc_line] = STATE(3017),
    [sym_preproc_pragma] = STATE(3017),
    [sym_preproc_nullable] = STATE(3017),
    [sym_preproc_error] = STATE(3017),
    [sym_preproc_warning] = STATE(3017),
    [sym_preproc_define] = STATE(3017),
    [sym_preproc_undef] = STATE(3017),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_COLON] = ACTIONS(5027),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_RBRACK] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_in] = ACTIONS(5029),
    [anon_sym_where] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5029),
    [anon_sym_BANG] = ACTIONS(5029),
    [anon_sym_PLUS_PLUS] = ACTIONS(5027),
    [anon_sym_DASH_DASH] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_PERCENT] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_GT] = ACTIONS(5027),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_EQ_GT] = ACTIONS(5027),
    [anon_sym_switch] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5027),
    [anon_sym_and] = ACTIONS(5027),
    [anon_sym_or] = ACTIONS(5029),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK_QMARK] = ACTIONS(5027),
    [anon_sym_from] = ACTIONS(5027),
    [anon_sym_into] = ACTIONS(5027),
    [anon_sym_join] = ACTIONS(5027),
    [anon_sym_on] = ACTIONS(5027),
    [anon_sym_equals] = ACTIONS(5027),
    [anon_sym_let] = ACTIONS(5027),
    [anon_sym_orderby] = ACTIONS(5027),
    [anon_sym_group] = ACTIONS(5027),
    [anon_sym_by] = ACTIONS(5027),
    [anon_sym_select] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5027),
    [anon_sym_is] = ACTIONS(5027),
    [anon_sym_DASH_GT] = ACTIONS(5027),
    [anon_sym_with] = ACTIONS(5027),
    [aux_sym_preproc_if_token3] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3018] = {
    [sym_preproc_region] = STATE(3018),
    [sym_preproc_endregion] = STATE(3018),
    [sym_preproc_line] = STATE(3018),
    [sym_preproc_pragma] = STATE(3018),
    [sym_preproc_nullable] = STATE(3018),
    [sym_preproc_error] = STATE(3018),
    [sym_preproc_warning] = STATE(3018),
    [sym_preproc_define] = STATE(3018),
    [sym_preproc_undef] = STATE(3018),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_in] = ACTIONS(4032),
    [anon_sym_where] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [anon_sym_switch] = ACTIONS(4032),
    [anon_sym_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4032),
    [anon_sym_or] = ACTIONS(4030),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_QMARK_QMARK] = ACTIONS(4032),
    [anon_sym_from] = ACTIONS(4032),
    [anon_sym_join] = ACTIONS(4032),
    [anon_sym_on] = ACTIONS(4032),
    [anon_sym_equals] = ACTIONS(4032),
    [anon_sym_let] = ACTIONS(4032),
    [anon_sym_orderby] = ACTIONS(4032),
    [anon_sym_group] = ACTIONS(4032),
    [anon_sym_by] = ACTIONS(4032),
    [anon_sym_select] = ACTIONS(4032),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_is] = ACTIONS(4032),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4032),
    [aux_sym_preproc_if_token3] = ACTIONS(4032),
    [aux_sym_preproc_else_token1] = ACTIONS(4032),
    [aux_sym_preproc_elif_token1] = ACTIONS(4032),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3019] = {
    [sym_preproc_region] = STATE(3019),
    [sym_preproc_endregion] = STATE(3019),
    [sym_preproc_line] = STATE(3019),
    [sym_preproc_pragma] = STATE(3019),
    [sym_preproc_nullable] = STATE(3019),
    [sym_preproc_error] = STATE(3019),
    [sym_preproc_warning] = STATE(3019),
    [sym_preproc_define] = STATE(3019),
    [sym_preproc_undef] = STATE(3019),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_where] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3697),
    [anon_sym_GT_GT_GT] = ACTIONS(3699),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_GT_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_and] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(3699),
    [anon_sym_QMARK_QMARK] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3699),
    [anon_sym_join] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_orderby] = ACTIONS(3699),
    [anon_sym_group] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_select] = ACTIONS(3699),
    [anon_sym_as] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(3699),
    [anon_sym_DASH_GT] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3699),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3020] = {
    [sym_preproc_region] = STATE(3020),
    [sym_preproc_endregion] = STATE(3020),
    [sym_preproc_line] = STATE(3020),
    [sym_preproc_pragma] = STATE(3020),
    [sym_preproc_nullable] = STATE(3020),
    [sym_preproc_error] = STATE(3020),
    [sym_preproc_warning] = STATE(3020),
    [sym_preproc_define] = STATE(3020),
    [sym_preproc_undef] = STATE(3020),
    [anon_sym_SEMI] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_COLON] = ACTIONS(5031),
    [anon_sym_COMMA] = ACTIONS(5031),
    [anon_sym_RBRACK] = ACTIONS(5031),
    [anon_sym_LPAREN] = ACTIONS(5031),
    [anon_sym_RPAREN] = ACTIONS(5031),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_GT] = ACTIONS(5033),
    [anon_sym_in] = ACTIONS(5033),
    [anon_sym_where] = ACTIONS(5031),
    [anon_sym_QMARK] = ACTIONS(5033),
    [anon_sym_BANG] = ACTIONS(5033),
    [anon_sym_PLUS_PLUS] = ACTIONS(5031),
    [anon_sym_DASH_DASH] = ACTIONS(5031),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5031),
    [anon_sym_SLASH] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5031),
    [anon_sym_CARET] = ACTIONS(5031),
    [anon_sym_PIPE] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(5031),
    [anon_sym_GT_GT] = ACTIONS(5033),
    [anon_sym_GT_GT_GT] = ACTIONS(5031),
    [anon_sym_EQ_EQ] = ACTIONS(5031),
    [anon_sym_BANG_EQ] = ACTIONS(5031),
    [anon_sym_GT_EQ] = ACTIONS(5031),
    [anon_sym_LT_EQ] = ACTIONS(5031),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_EQ_GT] = ACTIONS(5031),
    [anon_sym_switch] = ACTIONS(5031),
    [anon_sym_DOT_DOT] = ACTIONS(5031),
    [anon_sym_and] = ACTIONS(5031),
    [anon_sym_or] = ACTIONS(5033),
    [anon_sym_AMP_AMP] = ACTIONS(5031),
    [anon_sym_PIPE_PIPE] = ACTIONS(5031),
    [anon_sym_QMARK_QMARK] = ACTIONS(5031),
    [anon_sym_from] = ACTIONS(5031),
    [anon_sym_into] = ACTIONS(5031),
    [anon_sym_join] = ACTIONS(5031),
    [anon_sym_on] = ACTIONS(5031),
    [anon_sym_equals] = ACTIONS(5031),
    [anon_sym_let] = ACTIONS(5031),
    [anon_sym_orderby] = ACTIONS(5031),
    [anon_sym_group] = ACTIONS(5031),
    [anon_sym_by] = ACTIONS(5031),
    [anon_sym_select] = ACTIONS(5031),
    [anon_sym_as] = ACTIONS(5031),
    [anon_sym_is] = ACTIONS(5031),
    [anon_sym_DASH_GT] = ACTIONS(5031),
    [anon_sym_with] = ACTIONS(5031),
    [aux_sym_preproc_if_token3] = ACTIONS(5031),
    [aux_sym_preproc_else_token1] = ACTIONS(5031),
    [aux_sym_preproc_elif_token1] = ACTIONS(5031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3021] = {
    [sym_preproc_region] = STATE(3021),
    [sym_preproc_endregion] = STATE(3021),
    [sym_preproc_line] = STATE(3021),
    [sym_preproc_pragma] = STATE(3021),
    [sym_preproc_nullable] = STATE(3021),
    [sym_preproc_error] = STATE(3021),
    [sym_preproc_warning] = STATE(3021),
    [sym_preproc_define] = STATE(3021),
    [sym_preproc_undef] = STATE(3021),
    [anon_sym_SEMI] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_COLON] = ACTIONS(5035),
    [anon_sym_COMMA] = ACTIONS(5035),
    [anon_sym_RBRACK] = ACTIONS(5035),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_RPAREN] = ACTIONS(5035),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_GT] = ACTIONS(5037),
    [anon_sym_in] = ACTIONS(5037),
    [anon_sym_where] = ACTIONS(5035),
    [anon_sym_QMARK] = ACTIONS(5037),
    [anon_sym_BANG] = ACTIONS(5037),
    [anon_sym_PLUS_PLUS] = ACTIONS(5035),
    [anon_sym_DASH_DASH] = ACTIONS(5035),
    [anon_sym_PLUS] = ACTIONS(5037),
    [anon_sym_DASH] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5035),
    [anon_sym_SLASH] = ACTIONS(5037),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [anon_sym_CARET] = ACTIONS(5035),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(5035),
    [anon_sym_GT_GT] = ACTIONS(5037),
    [anon_sym_GT_GT_GT] = ACTIONS(5035),
    [anon_sym_EQ_EQ] = ACTIONS(5035),
    [anon_sym_BANG_EQ] = ACTIONS(5035),
    [anon_sym_GT_EQ] = ACTIONS(5035),
    [anon_sym_LT_EQ] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5037),
    [anon_sym_EQ_GT] = ACTIONS(5035),
    [anon_sym_switch] = ACTIONS(5035),
    [anon_sym_DOT_DOT] = ACTIONS(5035),
    [anon_sym_and] = ACTIONS(5035),
    [anon_sym_or] = ACTIONS(5037),
    [anon_sym_AMP_AMP] = ACTIONS(5035),
    [anon_sym_PIPE_PIPE] = ACTIONS(5035),
    [anon_sym_QMARK_QMARK] = ACTIONS(5035),
    [anon_sym_from] = ACTIONS(5035),
    [anon_sym_into] = ACTIONS(5035),
    [anon_sym_join] = ACTIONS(5035),
    [anon_sym_on] = ACTIONS(5035),
    [anon_sym_equals] = ACTIONS(5035),
    [anon_sym_let] = ACTIONS(5035),
    [anon_sym_orderby] = ACTIONS(5035),
    [anon_sym_group] = ACTIONS(5035),
    [anon_sym_by] = ACTIONS(5035),
    [anon_sym_select] = ACTIONS(5035),
    [anon_sym_as] = ACTIONS(5035),
    [anon_sym_is] = ACTIONS(5035),
    [anon_sym_DASH_GT] = ACTIONS(5035),
    [anon_sym_with] = ACTIONS(5035),
    [aux_sym_preproc_if_token3] = ACTIONS(5035),
    [aux_sym_preproc_else_token1] = ACTIONS(5035),
    [aux_sym_preproc_elif_token1] = ACTIONS(5035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3022] = {
    [sym_preproc_region] = STATE(3022),
    [sym_preproc_endregion] = STATE(3022),
    [sym_preproc_line] = STATE(3022),
    [sym_preproc_pragma] = STATE(3022),
    [sym_preproc_nullable] = STATE(3022),
    [sym_preproc_error] = STATE(3022),
    [sym_preproc_warning] = STATE(3022),
    [sym_preproc_define] = STATE(3022),
    [sym_preproc_undef] = STATE(3022),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_COLON] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5039),
    [anon_sym_RBRACK] = ACTIONS(5039),
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_RPAREN] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_in] = ACTIONS(5041),
    [anon_sym_where] = ACTIONS(5039),
    [anon_sym_QMARK] = ACTIONS(5041),
    [anon_sym_BANG] = ACTIONS(5041),
    [anon_sym_PLUS_PLUS] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(5039),
    [anon_sym_PLUS] = ACTIONS(5041),
    [anon_sym_DASH] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_SLASH] = ACTIONS(5041),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_CARET] = ACTIONS(5039),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5041),
    [anon_sym_LT_LT] = ACTIONS(5039),
    [anon_sym_GT_GT] = ACTIONS(5041),
    [anon_sym_GT_GT_GT] = ACTIONS(5039),
    [anon_sym_EQ_EQ] = ACTIONS(5039),
    [anon_sym_BANG_EQ] = ACTIONS(5039),
    [anon_sym_GT_EQ] = ACTIONS(5039),
    [anon_sym_LT_EQ] = ACTIONS(5039),
    [anon_sym_DOT] = ACTIONS(5041),
    [anon_sym_EQ_GT] = ACTIONS(5039),
    [anon_sym_switch] = ACTIONS(5039),
    [anon_sym_DOT_DOT] = ACTIONS(5039),
    [anon_sym_and] = ACTIONS(5039),
    [anon_sym_or] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5039),
    [anon_sym_PIPE_PIPE] = ACTIONS(5039),
    [anon_sym_QMARK_QMARK] = ACTIONS(5039),
    [anon_sym_from] = ACTIONS(5039),
    [anon_sym_into] = ACTIONS(5039),
    [anon_sym_join] = ACTIONS(5039),
    [anon_sym_on] = ACTIONS(5039),
    [anon_sym_equals] = ACTIONS(5039),
    [anon_sym_let] = ACTIONS(5039),
    [anon_sym_orderby] = ACTIONS(5039),
    [anon_sym_group] = ACTIONS(5039),
    [anon_sym_by] = ACTIONS(5039),
    [anon_sym_select] = ACTIONS(5039),
    [anon_sym_as] = ACTIONS(5039),
    [anon_sym_is] = ACTIONS(5039),
    [anon_sym_DASH_GT] = ACTIONS(5039),
    [anon_sym_with] = ACTIONS(5039),
    [aux_sym_preproc_if_token3] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3023] = {
    [sym_preproc_region] = STATE(3023),
    [sym_preproc_endregion] = STATE(3023),
    [sym_preproc_line] = STATE(3023),
    [sym_preproc_pragma] = STATE(3023),
    [sym_preproc_nullable] = STATE(3023),
    [sym_preproc_error] = STATE(3023),
    [sym_preproc_warning] = STATE(3023),
    [sym_preproc_define] = STATE(3023),
    [sym_preproc_undef] = STATE(3023),
    [anon_sym_SEMI] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_COLON] = ACTIONS(5043),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_RBRACK] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5043),
    [anon_sym_RPAREN] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_in] = ACTIONS(5045),
    [anon_sym_where] = ACTIONS(5043),
    [anon_sym_QMARK] = ACTIONS(5045),
    [anon_sym_BANG] = ACTIONS(5045),
    [anon_sym_PLUS_PLUS] = ACTIONS(5043),
    [anon_sym_DASH_DASH] = ACTIONS(5043),
    [anon_sym_PLUS] = ACTIONS(5045),
    [anon_sym_DASH] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5043),
    [anon_sym_SLASH] = ACTIONS(5045),
    [anon_sym_PERCENT] = ACTIONS(5043),
    [anon_sym_CARET] = ACTIONS(5043),
    [anon_sym_PIPE] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5045),
    [anon_sym_LT_LT] = ACTIONS(5043),
    [anon_sym_GT_GT] = ACTIONS(5045),
    [anon_sym_GT_GT_GT] = ACTIONS(5043),
    [anon_sym_EQ_EQ] = ACTIONS(5043),
    [anon_sym_BANG_EQ] = ACTIONS(5043),
    [anon_sym_GT_EQ] = ACTIONS(5043),
    [anon_sym_LT_EQ] = ACTIONS(5043),
    [anon_sym_DOT] = ACTIONS(5045),
    [anon_sym_EQ_GT] = ACTIONS(5043),
    [anon_sym_switch] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5043),
    [anon_sym_and] = ACTIONS(5043),
    [anon_sym_or] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_QMARK_QMARK] = ACTIONS(5043),
    [anon_sym_from] = ACTIONS(5043),
    [anon_sym_into] = ACTIONS(5043),
    [anon_sym_join] = ACTIONS(5043),
    [anon_sym_on] = ACTIONS(5043),
    [anon_sym_equals] = ACTIONS(5043),
    [anon_sym_let] = ACTIONS(5043),
    [anon_sym_orderby] = ACTIONS(5043),
    [anon_sym_group] = ACTIONS(5043),
    [anon_sym_by] = ACTIONS(5043),
    [anon_sym_select] = ACTIONS(5043),
    [anon_sym_as] = ACTIONS(5043),
    [anon_sym_is] = ACTIONS(5043),
    [anon_sym_DASH_GT] = ACTIONS(5043),
    [anon_sym_with] = ACTIONS(5043),
    [aux_sym_preproc_if_token3] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3024] = {
    [sym_preproc_region] = STATE(3024),
    [sym_preproc_endregion] = STATE(3024),
    [sym_preproc_line] = STATE(3024),
    [sym_preproc_pragma] = STATE(3024),
    [sym_preproc_nullable] = STATE(3024),
    [sym_preproc_error] = STATE(3024),
    [sym_preproc_warning] = STATE(3024),
    [sym_preproc_define] = STATE(3024),
    [sym_preproc_undef] = STATE(3024),
    [anon_sym_SEMI] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_COLON] = ACTIONS(5047),
    [anon_sym_COMMA] = ACTIONS(5047),
    [anon_sym_RBRACK] = ACTIONS(5047),
    [anon_sym_LPAREN] = ACTIONS(5047),
    [anon_sym_RPAREN] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_in] = ACTIONS(5049),
    [anon_sym_where] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_BANG] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5049),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_PIPE] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5049),
    [anon_sym_GT_GT_GT] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5047),
    [anon_sym_BANG_EQ] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_DOT] = ACTIONS(5049),
    [anon_sym_EQ_GT] = ACTIONS(5047),
    [anon_sym_switch] = ACTIONS(5047),
    [anon_sym_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_or] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_QMARK_QMARK] = ACTIONS(5047),
    [anon_sym_from] = ACTIONS(5047),
    [anon_sym_into] = ACTIONS(5047),
    [anon_sym_join] = ACTIONS(5047),
    [anon_sym_on] = ACTIONS(5047),
    [anon_sym_equals] = ACTIONS(5047),
    [anon_sym_let] = ACTIONS(5047),
    [anon_sym_orderby] = ACTIONS(5047),
    [anon_sym_group] = ACTIONS(5047),
    [anon_sym_by] = ACTIONS(5047),
    [anon_sym_select] = ACTIONS(5047),
    [anon_sym_as] = ACTIONS(5047),
    [anon_sym_is] = ACTIONS(5047),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [anon_sym_with] = ACTIONS(5047),
    [aux_sym_preproc_if_token3] = ACTIONS(5047),
    [aux_sym_preproc_else_token1] = ACTIONS(5047),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3025] = {
    [sym_preproc_region] = STATE(3025),
    [sym_preproc_endregion] = STATE(3025),
    [sym_preproc_line] = STATE(3025),
    [sym_preproc_pragma] = STATE(3025),
    [sym_preproc_nullable] = STATE(3025),
    [sym_preproc_error] = STATE(3025),
    [sym_preproc_warning] = STATE(3025),
    [sym_preproc_define] = STATE(3025),
    [sym_preproc_undef] = STATE(3025),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4036),
    [anon_sym_where] = ACTIONS(4036),
    [anon_sym_QMARK] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [anon_sym_switch] = ACTIONS(4036),
    [anon_sym_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_or] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_QMARK_QMARK] = ACTIONS(4036),
    [anon_sym_from] = ACTIONS(4036),
    [anon_sym_join] = ACTIONS(4036),
    [anon_sym_on] = ACTIONS(4036),
    [anon_sym_equals] = ACTIONS(4036),
    [anon_sym_let] = ACTIONS(4036),
    [anon_sym_orderby] = ACTIONS(4036),
    [anon_sym_group] = ACTIONS(4036),
    [anon_sym_by] = ACTIONS(4036),
    [anon_sym_select] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4036),
    [anon_sym_is] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4036),
    [aux_sym_preproc_if_token3] = ACTIONS(4036),
    [aux_sym_preproc_else_token1] = ACTIONS(4036),
    [aux_sym_preproc_elif_token1] = ACTIONS(4036),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3026] = {
    [sym_preproc_region] = STATE(3026),
    [sym_preproc_endregion] = STATE(3026),
    [sym_preproc_line] = STATE(3026),
    [sym_preproc_pragma] = STATE(3026),
    [sym_preproc_nullable] = STATE(3026),
    [sym_preproc_error] = STATE(3026),
    [sym_preproc_warning] = STATE(3026),
    [sym_preproc_define] = STATE(3026),
    [sym_preproc_undef] = STATE(3026),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_GT_GT_GT] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_switch] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4040),
    [anon_sym_or] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_QMARK_QMARK] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(4040),
    [anon_sym_is] = ACTIONS(4040),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_with] = ACTIONS(4040),
    [aux_sym_preproc_if_token3] = ACTIONS(4040),
    [aux_sym_preproc_else_token1] = ACTIONS(4040),
    [aux_sym_preproc_elif_token1] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3027] = {
    [sym_preproc_region] = STATE(3027),
    [sym_preproc_endregion] = STATE(3027),
    [sym_preproc_line] = STATE(3027),
    [sym_preproc_pragma] = STATE(3027),
    [sym_preproc_nullable] = STATE(3027),
    [sym_preproc_error] = STATE(3027),
    [sym_preproc_warning] = STATE(3027),
    [sym_preproc_define] = STATE(3027),
    [sym_preproc_undef] = STATE(3027),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3668),
    [anon_sym_where] = ACTIONS(3668),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3668),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3668),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3666),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3668),
    [anon_sym_from] = ACTIONS(3668),
    [anon_sym_join] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_let] = ACTIONS(3668),
    [anon_sym_orderby] = ACTIONS(3668),
    [anon_sym_group] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_select] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3028] = {
    [sym_preproc_region] = STATE(3028),
    [sym_preproc_endregion] = STATE(3028),
    [sym_preproc_line] = STATE(3028),
    [sym_preproc_pragma] = STATE(3028),
    [sym_preproc_nullable] = STATE(3028),
    [sym_preproc_error] = STATE(3028),
    [sym_preproc_warning] = STATE(3028),
    [sym_preproc_define] = STATE(3028),
    [sym_preproc_undef] = STATE(3028),
    [anon_sym_SEMI] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_COLON] = ACTIONS(5051),
    [anon_sym_COMMA] = ACTIONS(5051),
    [anon_sym_RBRACK] = ACTIONS(5051),
    [anon_sym_LPAREN] = ACTIONS(5051),
    [anon_sym_RPAREN] = ACTIONS(5051),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_LT] = ACTIONS(5053),
    [anon_sym_GT] = ACTIONS(5053),
    [anon_sym_in] = ACTIONS(5053),
    [anon_sym_where] = ACTIONS(5051),
    [anon_sym_QMARK] = ACTIONS(5053),
    [anon_sym_BANG] = ACTIONS(5053),
    [anon_sym_PLUS_PLUS] = ACTIONS(5051),
    [anon_sym_DASH_DASH] = ACTIONS(5051),
    [anon_sym_PLUS] = ACTIONS(5053),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5051),
    [anon_sym_SLASH] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5051),
    [anon_sym_CARET] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5053),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5053),
    [anon_sym_GT_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5051),
    [anon_sym_BANG_EQ] = ACTIONS(5051),
    [anon_sym_GT_EQ] = ACTIONS(5051),
    [anon_sym_LT_EQ] = ACTIONS(5051),
    [anon_sym_DOT] = ACTIONS(5053),
    [anon_sym_EQ_GT] = ACTIONS(5051),
    [anon_sym_switch] = ACTIONS(5051),
    [anon_sym_DOT_DOT] = ACTIONS(5051),
    [anon_sym_and] = ACTIONS(5051),
    [anon_sym_or] = ACTIONS(5053),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5051),
    [anon_sym_QMARK_QMARK] = ACTIONS(5051),
    [anon_sym_from] = ACTIONS(5051),
    [anon_sym_into] = ACTIONS(5051),
    [anon_sym_join] = ACTIONS(5051),
    [anon_sym_on] = ACTIONS(5051),
    [anon_sym_equals] = ACTIONS(5051),
    [anon_sym_let] = ACTIONS(5051),
    [anon_sym_orderby] = ACTIONS(5051),
    [anon_sym_group] = ACTIONS(5051),
    [anon_sym_by] = ACTIONS(5051),
    [anon_sym_select] = ACTIONS(5051),
    [anon_sym_as] = ACTIONS(5051),
    [anon_sym_is] = ACTIONS(5051),
    [anon_sym_DASH_GT] = ACTIONS(5051),
    [anon_sym_with] = ACTIONS(5051),
    [aux_sym_preproc_if_token3] = ACTIONS(5051),
    [aux_sym_preproc_else_token1] = ACTIONS(5051),
    [aux_sym_preproc_elif_token1] = ACTIONS(5051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3029] = {
    [sym_preproc_region] = STATE(3029),
    [sym_preproc_endregion] = STATE(3029),
    [sym_preproc_line] = STATE(3029),
    [sym_preproc_pragma] = STATE(3029),
    [sym_preproc_nullable] = STATE(3029),
    [sym_preproc_error] = STATE(3029),
    [sym_preproc_warning] = STATE(3029),
    [sym_preproc_define] = STATE(3029),
    [sym_preproc_undef] = STATE(3029),
    [sym__identifier_token] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym_alias] = ACTIONS(5055),
    [anon_sym_global] = ACTIONS(5055),
    [anon_sym_unsafe] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5057),
    [anon_sym_LPAREN] = ACTIONS(5057),
    [anon_sym_event] = ACTIONS(5055),
    [anon_sym_class] = ACTIONS(5055),
    [anon_sym_ref] = ACTIONS(5055),
    [anon_sym_struct] = ACTIONS(5055),
    [anon_sym_enum] = ACTIONS(5055),
    [anon_sym_interface] = ACTIONS(5055),
    [anon_sym_delegate] = ACTIONS(5055),
    [anon_sym_record] = ACTIONS(5055),
    [anon_sym_abstract] = ACTIONS(5055),
    [anon_sym_async] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_file] = ACTIONS(5055),
    [anon_sym_fixed] = ACTIONS(5055),
    [anon_sym_internal] = ACTIONS(5055),
    [anon_sym_new] = ACTIONS(5055),
    [anon_sym_override] = ACTIONS(5055),
    [anon_sym_partial] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_readonly] = ACTIONS(5055),
    [anon_sym_required] = ACTIONS(5055),
    [anon_sym_sealed] = ACTIONS(5055),
    [anon_sym_virtual] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_where] = ACTIONS(5055),
    [anon_sym_notnull] = ACTIONS(5055),
    [anon_sym_unmanaged] = ACTIONS(5055),
    [anon_sym_TILDE] = ACTIONS(5057),
    [anon_sym_implicit] = ACTIONS(5055),
    [anon_sym_explicit] = ACTIONS(5055),
    [anon_sym_scoped] = ACTIONS(5055),
    [anon_sym_var] = ACTIONS(5055),
    [sym_predefined_type] = ACTIONS(5055),
    [anon_sym_yield] = ACTIONS(5055),
    [anon_sym_when] = ACTIONS(5055),
    [anon_sym_from] = ACTIONS(5055),
    [anon_sym_into] = ACTIONS(5055),
    [anon_sym_join] = ACTIONS(5055),
    [anon_sym_on] = ACTIONS(5055),
    [anon_sym_equals] = ACTIONS(5055),
    [anon_sym_let] = ACTIONS(5055),
    [anon_sym_orderby] = ACTIONS(5055),
    [anon_sym_ascending] = ACTIONS(5055),
    [anon_sym_descending] = ACTIONS(5055),
    [anon_sym_group] = ACTIONS(5055),
    [anon_sym_by] = ACTIONS(5055),
    [anon_sym_select] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3030] = {
    [sym_preproc_region] = STATE(3030),
    [sym_preproc_endregion] = STATE(3030),
    [sym_preproc_line] = STATE(3030),
    [sym_preproc_pragma] = STATE(3030),
    [sym_preproc_nullable] = STATE(3030),
    [sym_preproc_error] = STATE(3030),
    [sym_preproc_warning] = STATE(3030),
    [sym_preproc_define] = STATE(3030),
    [sym_preproc_undef] = STATE(3030),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3031] = {
    [sym_preproc_region] = STATE(3031),
    [sym_preproc_endregion] = STATE(3031),
    [sym_preproc_line] = STATE(3031),
    [sym_preproc_pragma] = STATE(3031),
    [sym_preproc_nullable] = STATE(3031),
    [sym_preproc_error] = STATE(3031),
    [sym_preproc_warning] = STATE(3031),
    [sym_preproc_define] = STATE(3031),
    [sym_preproc_undef] = STATE(3031),
    [sym__identifier_token] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym_alias] = ACTIONS(5059),
    [anon_sym_global] = ACTIONS(5059),
    [anon_sym_unsafe] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5061),
    [anon_sym_LPAREN] = ACTIONS(5061),
    [anon_sym_event] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_ref] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_interface] = ACTIONS(5059),
    [anon_sym_delegate] = ACTIONS(5059),
    [anon_sym_record] = ACTIONS(5059),
    [anon_sym_abstract] = ACTIONS(5059),
    [anon_sym_async] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_file] = ACTIONS(5059),
    [anon_sym_fixed] = ACTIONS(5059),
    [anon_sym_internal] = ACTIONS(5059),
    [anon_sym_new] = ACTIONS(5059),
    [anon_sym_override] = ACTIONS(5059),
    [anon_sym_partial] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_readonly] = ACTIONS(5059),
    [anon_sym_required] = ACTIONS(5059),
    [anon_sym_sealed] = ACTIONS(5059),
    [anon_sym_virtual] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_where] = ACTIONS(5059),
    [anon_sym_notnull] = ACTIONS(5059),
    [anon_sym_unmanaged] = ACTIONS(5059),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_implicit] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_scoped] = ACTIONS(5059),
    [anon_sym_var] = ACTIONS(5059),
    [sym_predefined_type] = ACTIONS(5059),
    [anon_sym_yield] = ACTIONS(5059),
    [anon_sym_when] = ACTIONS(5059),
    [anon_sym_from] = ACTIONS(5059),
    [anon_sym_into] = ACTIONS(5059),
    [anon_sym_join] = ACTIONS(5059),
    [anon_sym_on] = ACTIONS(5059),
    [anon_sym_equals] = ACTIONS(5059),
    [anon_sym_let] = ACTIONS(5059),
    [anon_sym_orderby] = ACTIONS(5059),
    [anon_sym_ascending] = ACTIONS(5059),
    [anon_sym_descending] = ACTIONS(5059),
    [anon_sym_group] = ACTIONS(5059),
    [anon_sym_by] = ACTIONS(5059),
    [anon_sym_select] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3032] = {
    [sym_preproc_region] = STATE(3032),
    [sym_preproc_endregion] = STATE(3032),
    [sym_preproc_line] = STATE(3032),
    [sym_preproc_pragma] = STATE(3032),
    [sym_preproc_nullable] = STATE(3032),
    [sym_preproc_error] = STATE(3032),
    [sym_preproc_warning] = STATE(3032),
    [sym_preproc_define] = STATE(3032),
    [sym_preproc_undef] = STATE(3032),
    [anon_sym_SEMI] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_COLON] = ACTIONS(5063),
    [anon_sym_COMMA] = ACTIONS(5063),
    [anon_sym_RBRACK] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5063),
    [anon_sym_RPAREN] = ACTIONS(5063),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(5065),
    [anon_sym_GT] = ACTIONS(5065),
    [anon_sym_in] = ACTIONS(5065),
    [anon_sym_where] = ACTIONS(5063),
    [anon_sym_QMARK] = ACTIONS(5065),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS_PLUS] = ACTIONS(5063),
    [anon_sym_DASH_DASH] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5063),
    [anon_sym_SLASH] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_CARET] = ACTIONS(5063),
    [anon_sym_PIPE] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5065),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5065),
    [anon_sym_GT_GT_GT] = ACTIONS(5063),
    [anon_sym_EQ_EQ] = ACTIONS(5063),
    [anon_sym_BANG_EQ] = ACTIONS(5063),
    [anon_sym_GT_EQ] = ACTIONS(5063),
    [anon_sym_LT_EQ] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [anon_sym_EQ_GT] = ACTIONS(5063),
    [anon_sym_switch] = ACTIONS(5063),
    [anon_sym_DOT_DOT] = ACTIONS(5063),
    [anon_sym_and] = ACTIONS(5063),
    [anon_sym_or] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5063),
    [anon_sym_PIPE_PIPE] = ACTIONS(5063),
    [anon_sym_QMARK_QMARK] = ACTIONS(5063),
    [anon_sym_from] = ACTIONS(5063),
    [anon_sym_into] = ACTIONS(5063),
    [anon_sym_join] = ACTIONS(5063),
    [anon_sym_on] = ACTIONS(5063),
    [anon_sym_equals] = ACTIONS(5063),
    [anon_sym_let] = ACTIONS(5063),
    [anon_sym_orderby] = ACTIONS(5063),
    [anon_sym_group] = ACTIONS(5063),
    [anon_sym_by] = ACTIONS(5063),
    [anon_sym_select] = ACTIONS(5063),
    [anon_sym_as] = ACTIONS(5063),
    [anon_sym_is] = ACTIONS(5063),
    [anon_sym_DASH_GT] = ACTIONS(5063),
    [anon_sym_with] = ACTIONS(5063),
    [aux_sym_preproc_if_token3] = ACTIONS(5063),
    [aux_sym_preproc_else_token1] = ACTIONS(5063),
    [aux_sym_preproc_elif_token1] = ACTIONS(5063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3033] = {
    [sym_preproc_region] = STATE(3033),
    [sym_preproc_endregion] = STATE(3033),
    [sym_preproc_line] = STATE(3033),
    [sym_preproc_pragma] = STATE(3033),
    [sym_preproc_nullable] = STATE(3033),
    [sym_preproc_error] = STATE(3033),
    [sym_preproc_warning] = STATE(3033),
    [sym_preproc_define] = STATE(3033),
    [sym_preproc_undef] = STATE(3033),
    [anon_sym_SEMI] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_COLON] = ACTIONS(5067),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_RBRACK] = ACTIONS(5067),
    [anon_sym_LPAREN] = ACTIONS(5067),
    [anon_sym_RPAREN] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5067),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_in] = ACTIONS(5069),
    [anon_sym_where] = ACTIONS(5067),
    [anon_sym_QMARK] = ACTIONS(5069),
    [anon_sym_BANG] = ACTIONS(5069),
    [anon_sym_PLUS_PLUS] = ACTIONS(5067),
    [anon_sym_DASH_DASH] = ACTIONS(5067),
    [anon_sym_PLUS] = ACTIONS(5069),
    [anon_sym_DASH] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5067),
    [anon_sym_SLASH] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5067),
    [anon_sym_CARET] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5067),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_GT_GT_GT] = ACTIONS(5067),
    [anon_sym_EQ_EQ] = ACTIONS(5067),
    [anon_sym_BANG_EQ] = ACTIONS(5067),
    [anon_sym_GT_EQ] = ACTIONS(5067),
    [anon_sym_LT_EQ] = ACTIONS(5067),
    [anon_sym_DOT] = ACTIONS(5069),
    [anon_sym_EQ_GT] = ACTIONS(5067),
    [anon_sym_switch] = ACTIONS(5067),
    [anon_sym_DOT_DOT] = ACTIONS(5067),
    [anon_sym_and] = ACTIONS(5067),
    [anon_sym_or] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5067),
    [anon_sym_PIPE_PIPE] = ACTIONS(5067),
    [anon_sym_QMARK_QMARK] = ACTIONS(5067),
    [anon_sym_from] = ACTIONS(5067),
    [anon_sym_into] = ACTIONS(5067),
    [anon_sym_join] = ACTIONS(5067),
    [anon_sym_on] = ACTIONS(5067),
    [anon_sym_equals] = ACTIONS(5067),
    [anon_sym_let] = ACTIONS(5067),
    [anon_sym_orderby] = ACTIONS(5067),
    [anon_sym_group] = ACTIONS(5067),
    [anon_sym_by] = ACTIONS(5067),
    [anon_sym_select] = ACTIONS(5067),
    [anon_sym_as] = ACTIONS(5067),
    [anon_sym_is] = ACTIONS(5067),
    [anon_sym_DASH_GT] = ACTIONS(5067),
    [anon_sym_with] = ACTIONS(5067),
    [aux_sym_preproc_if_token3] = ACTIONS(5067),
    [aux_sym_preproc_else_token1] = ACTIONS(5067),
    [aux_sym_preproc_elif_token1] = ACTIONS(5067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3034] = {
    [sym_preproc_region] = STATE(3034),
    [sym_preproc_endregion] = STATE(3034),
    [sym_preproc_line] = STATE(3034),
    [sym_preproc_pragma] = STATE(3034),
    [sym_preproc_nullable] = STATE(3034),
    [sym_preproc_error] = STATE(3034),
    [sym_preproc_warning] = STATE(3034),
    [sym_preproc_define] = STATE(3034),
    [sym_preproc_undef] = STATE(3034),
    [sym__identifier_token] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym_alias] = ACTIONS(5071),
    [anon_sym_global] = ACTIONS(5071),
    [anon_sym_unsafe] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5073),
    [anon_sym_event] = ACTIONS(5071),
    [anon_sym_class] = ACTIONS(5071),
    [anon_sym_ref] = ACTIONS(5071),
    [anon_sym_struct] = ACTIONS(5071),
    [anon_sym_enum] = ACTIONS(5071),
    [anon_sym_interface] = ACTIONS(5071),
    [anon_sym_delegate] = ACTIONS(5071),
    [anon_sym_record] = ACTIONS(5071),
    [anon_sym_abstract] = ACTIONS(5071),
    [anon_sym_async] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_file] = ACTIONS(5071),
    [anon_sym_fixed] = ACTIONS(5071),
    [anon_sym_internal] = ACTIONS(5071),
    [anon_sym_new] = ACTIONS(5071),
    [anon_sym_override] = ACTIONS(5071),
    [anon_sym_partial] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_readonly] = ACTIONS(5071),
    [anon_sym_required] = ACTIONS(5071),
    [anon_sym_sealed] = ACTIONS(5071),
    [anon_sym_virtual] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_where] = ACTIONS(5071),
    [anon_sym_notnull] = ACTIONS(5071),
    [anon_sym_unmanaged] = ACTIONS(5071),
    [anon_sym_TILDE] = ACTIONS(5073),
    [anon_sym_implicit] = ACTIONS(5071),
    [anon_sym_explicit] = ACTIONS(5071),
    [anon_sym_scoped] = ACTIONS(5071),
    [anon_sym_var] = ACTIONS(5071),
    [sym_predefined_type] = ACTIONS(5071),
    [anon_sym_yield] = ACTIONS(5071),
    [anon_sym_when] = ACTIONS(5071),
    [anon_sym_from] = ACTIONS(5071),
    [anon_sym_into] = ACTIONS(5071),
    [anon_sym_join] = ACTIONS(5071),
    [anon_sym_on] = ACTIONS(5071),
    [anon_sym_equals] = ACTIONS(5071),
    [anon_sym_let] = ACTIONS(5071),
    [anon_sym_orderby] = ACTIONS(5071),
    [anon_sym_ascending] = ACTIONS(5071),
    [anon_sym_descending] = ACTIONS(5071),
    [anon_sym_group] = ACTIONS(5071),
    [anon_sym_by] = ACTIONS(5071),
    [anon_sym_select] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3035] = {
    [sym_preproc_region] = STATE(3035),
    [sym_preproc_endregion] = STATE(3035),
    [sym_preproc_line] = STATE(3035),
    [sym_preproc_pragma] = STATE(3035),
    [sym_preproc_nullable] = STATE(3035),
    [sym_preproc_error] = STATE(3035),
    [sym_preproc_warning] = STATE(3035),
    [sym_preproc_define] = STATE(3035),
    [sym_preproc_undef] = STATE(3035),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3686),
    [anon_sym_where] = ACTIONS(3686),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3686),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3686),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3684),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3686),
    [anon_sym_from] = ACTIONS(3686),
    [anon_sym_join] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_let] = ACTIONS(3686),
    [anon_sym_orderby] = ACTIONS(3686),
    [anon_sym_group] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_select] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3036] = {
    [sym_preproc_region] = STATE(3036),
    [sym_preproc_endregion] = STATE(3036),
    [sym_preproc_line] = STATE(3036),
    [sym_preproc_pragma] = STATE(3036),
    [sym_preproc_nullable] = STATE(3036),
    [sym_preproc_error] = STATE(3036),
    [sym_preproc_warning] = STATE(3036),
    [sym_preproc_define] = STATE(3036),
    [sym_preproc_undef] = STATE(3036),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3037] = {
    [sym_preproc_region] = STATE(3037),
    [sym_preproc_endregion] = STATE(3037),
    [sym_preproc_line] = STATE(3037),
    [sym_preproc_pragma] = STATE(3037),
    [sym_preproc_nullable] = STATE(3037),
    [sym_preproc_error] = STATE(3037),
    [sym_preproc_warning] = STATE(3037),
    [sym_preproc_define] = STATE(3037),
    [sym_preproc_undef] = STATE(3037),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(3167),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_RBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3167),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3167),
    [anon_sym_GT_EQ] = ACTIONS(3167),
    [anon_sym_LT_EQ] = ACTIONS(3167),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_and] = ACTIONS(3167),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3167),
    [anon_sym_QMARK_QMARK] = ACTIONS(3167),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_into] = ACTIONS(3167),
    [anon_sym_join] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_orderby] = ACTIONS(3167),
    [anon_sym_group] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_select] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3167),
    [anon_sym_is] = ACTIONS(3167),
    [anon_sym_DASH_GT] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [aux_sym_preproc_if_token3] = ACTIONS(3167),
    [aux_sym_preproc_else_token1] = ACTIONS(3167),
    [aux_sym_preproc_elif_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3038] = {
    [sym_preproc_region] = STATE(3038),
    [sym_preproc_endregion] = STATE(3038),
    [sym_preproc_line] = STATE(3038),
    [sym_preproc_pragma] = STATE(3038),
    [sym_preproc_nullable] = STATE(3038),
    [sym_preproc_error] = STATE(3038),
    [sym_preproc_warning] = STATE(3038),
    [sym_preproc_define] = STATE(3038),
    [sym_preproc_undef] = STATE(3038),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_event] = ACTIONS(4743),
    [anon_sym_class] = ACTIONS(4743),
    [anon_sym_ref] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_interface] = ACTIONS(4743),
    [anon_sym_delegate] = ACTIONS(4743),
    [anon_sym_record] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4745),
    [anon_sym_implicit] = ACTIONS(4743),
    [anon_sym_explicit] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [sym_predefined_type] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3039] = {
    [sym_preproc_region] = STATE(3039),
    [sym_preproc_endregion] = STATE(3039),
    [sym_preproc_line] = STATE(3039),
    [sym_preproc_pragma] = STATE(3039),
    [sym_preproc_nullable] = STATE(3039),
    [sym_preproc_error] = STATE(3039),
    [sym_preproc_warning] = STATE(3039),
    [sym_preproc_define] = STATE(3039),
    [sym_preproc_undef] = STATE(3039),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(4156),
    [anon_sym_where] = ACTIONS(4156),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_GT_GT_GT] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4156),
    [anon_sym_BANG_EQ] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4156),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_EQ_GT] = ACTIONS(4156),
    [anon_sym_switch] = ACTIONS(4156),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4156),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4156),
    [anon_sym_QMARK_QMARK] = ACTIONS(4156),
    [anon_sym_from] = ACTIONS(4156),
    [anon_sym_join] = ACTIONS(4156),
    [anon_sym_on] = ACTIONS(4156),
    [anon_sym_equals] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_orderby] = ACTIONS(4156),
    [anon_sym_group] = ACTIONS(4156),
    [anon_sym_by] = ACTIONS(4156),
    [anon_sym_select] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4156),
    [anon_sym_is] = ACTIONS(4156),
    [anon_sym_DASH_GT] = ACTIONS(4156),
    [anon_sym_with] = ACTIONS(4156),
    [aux_sym_preproc_if_token3] = ACTIONS(4156),
    [aux_sym_preproc_else_token1] = ACTIONS(4156),
    [aux_sym_preproc_elif_token1] = ACTIONS(4156),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3040] = {
    [sym_attribute_list] = STATE(5983),
    [sym__attribute_list] = STATE(5984),
    [sym_type_parameter] = STATE(7101),
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(6356),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5983),
    [sym_preproc_region] = STATE(3040),
    [sym_preproc_endregion] = STATE(3040),
    [sym_preproc_line] = STATE(3040),
    [sym_preproc_pragma] = STATE(3040),
    [sym_preproc_nullable] = STATE(3040),
    [sym_preproc_error] = STATE(3040),
    [sym_preproc_warning] = STATE(3040),
    [sym_preproc_define] = STATE(3040),
    [sym_preproc_undef] = STATE(3040),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(5799),
    [aux_sym_type_argument_list_repeat1] = STATE(6956),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5083),
    [anon_sym_in] = ACTIONS(5085),
    [anon_sym_out] = ACTIONS(5085),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(5091),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3041] = {
    [sym_preproc_region] = STATE(3041),
    [sym_preproc_endregion] = STATE(3041),
    [sym_preproc_line] = STATE(3041),
    [sym_preproc_pragma] = STATE(3041),
    [sym_preproc_nullable] = STATE(3041),
    [sym_preproc_error] = STATE(3041),
    [sym_preproc_warning] = STATE(3041),
    [sym_preproc_define] = STATE(3041),
    [sym_preproc_undef] = STATE(3041),
    [anon_sym_SEMI] = ACTIONS(5093),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_COLON] = ACTIONS(5093),
    [anon_sym_COMMA] = ACTIONS(5093),
    [anon_sym_RBRACK] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_RPAREN] = ACTIONS(5093),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_in] = ACTIONS(5095),
    [anon_sym_where] = ACTIONS(5093),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_BANG] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5095),
    [anon_sym_PERCENT] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5093),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5093),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_GT_GT_GT] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_DOT] = ACTIONS(5095),
    [anon_sym_EQ_GT] = ACTIONS(5093),
    [anon_sym_switch] = ACTIONS(5093),
    [anon_sym_DOT_DOT] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_or] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_PIPE_PIPE] = ACTIONS(5093),
    [anon_sym_QMARK_QMARK] = ACTIONS(5093),
    [anon_sym_from] = ACTIONS(5093),
    [anon_sym_into] = ACTIONS(5093),
    [anon_sym_join] = ACTIONS(5093),
    [anon_sym_on] = ACTIONS(5093),
    [anon_sym_equals] = ACTIONS(5093),
    [anon_sym_let] = ACTIONS(5093),
    [anon_sym_orderby] = ACTIONS(5093),
    [anon_sym_group] = ACTIONS(5093),
    [anon_sym_by] = ACTIONS(5093),
    [anon_sym_select] = ACTIONS(5093),
    [anon_sym_as] = ACTIONS(5093),
    [anon_sym_is] = ACTIONS(5093),
    [anon_sym_DASH_GT] = ACTIONS(5093),
    [anon_sym_with] = ACTIONS(5093),
    [aux_sym_preproc_if_token3] = ACTIONS(5093),
    [aux_sym_preproc_else_token1] = ACTIONS(5093),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3042] = {
    [sym_preproc_region] = STATE(3042),
    [sym_preproc_endregion] = STATE(3042),
    [sym_preproc_line] = STATE(3042),
    [sym_preproc_pragma] = STATE(3042),
    [sym_preproc_nullable] = STATE(3042),
    [sym_preproc_error] = STATE(3042),
    [sym_preproc_warning] = STATE(3042),
    [sym_preproc_define] = STATE(3042),
    [sym_preproc_undef] = STATE(3042),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_where] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3949),
    [anon_sym_or] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3949),
    [anon_sym_join] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_orderby] = ACTIONS(3949),
    [anon_sym_group] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_select] = ACTIONS(3949),
    [anon_sym_as] = ACTIONS(3949),
    [anon_sym_is] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3949),
    [aux_sym_preproc_if_token3] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3043] = {
    [sym_preproc_region] = STATE(3043),
    [sym_preproc_endregion] = STATE(3043),
    [sym_preproc_line] = STATE(3043),
    [sym_preproc_pragma] = STATE(3043),
    [sym_preproc_nullable] = STATE(3043),
    [sym_preproc_error] = STATE(3043),
    [sym_preproc_warning] = STATE(3043),
    [sym_preproc_define] = STATE(3043),
    [sym_preproc_undef] = STATE(3043),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(5097),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_RBRACK] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5099),
    [anon_sym_in] = ACTIONS(5099),
    [anon_sym_where] = ACTIONS(5097),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_BANG] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_SLASH] = ACTIONS(5099),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5097),
    [anon_sym_PIPE] = ACTIONS(5099),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym_LT_LT] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5099),
    [anon_sym_GT_GT_GT] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_DOT] = ACTIONS(5099),
    [anon_sym_EQ_GT] = ACTIONS(5097),
    [anon_sym_switch] = ACTIONS(5097),
    [anon_sym_DOT_DOT] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_or] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_QMARK_QMARK] = ACTIONS(5097),
    [anon_sym_from] = ACTIONS(5097),
    [anon_sym_into] = ACTIONS(5097),
    [anon_sym_join] = ACTIONS(5097),
    [anon_sym_on] = ACTIONS(5097),
    [anon_sym_equals] = ACTIONS(5097),
    [anon_sym_let] = ACTIONS(5097),
    [anon_sym_orderby] = ACTIONS(5097),
    [anon_sym_group] = ACTIONS(5097),
    [anon_sym_by] = ACTIONS(5097),
    [anon_sym_select] = ACTIONS(5097),
    [anon_sym_as] = ACTIONS(5097),
    [anon_sym_is] = ACTIONS(5097),
    [anon_sym_DASH_GT] = ACTIONS(5097),
    [anon_sym_with] = ACTIONS(5097),
    [aux_sym_preproc_if_token3] = ACTIONS(5097),
    [aux_sym_preproc_else_token1] = ACTIONS(5097),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3044] = {
    [sym_preproc_region] = STATE(3044),
    [sym_preproc_endregion] = STATE(3044),
    [sym_preproc_line] = STATE(3044),
    [sym_preproc_pragma] = STATE(3044),
    [sym_preproc_nullable] = STATE(3044),
    [sym_preproc_error] = STATE(3044),
    [sym_preproc_warning] = STATE(3044),
    [sym_preproc_define] = STATE(3044),
    [sym_preproc_undef] = STATE(3044),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3672),
    [anon_sym_where] = ACTIONS(3672),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3672),
    [anon_sym_from] = ACTIONS(3672),
    [anon_sym_join] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_let] = ACTIONS(3672),
    [anon_sym_orderby] = ACTIONS(3672),
    [anon_sym_group] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_select] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3045] = {
    [sym_preproc_region] = STATE(3045),
    [sym_preproc_endregion] = STATE(3045),
    [sym_preproc_line] = STATE(3045),
    [sym_preproc_pragma] = STATE(3045),
    [sym_preproc_nullable] = STATE(3045),
    [sym_preproc_error] = STATE(3045),
    [sym_preproc_warning] = STATE(3045),
    [sym_preproc_define] = STATE(3045),
    [sym_preproc_undef] = STATE(3045),
    [sym__identifier_token] = ACTIONS(5101),
    [anon_sym_extern] = ACTIONS(5101),
    [anon_sym_alias] = ACTIONS(5101),
    [anon_sym_global] = ACTIONS(5101),
    [anon_sym_unsafe] = ACTIONS(5101),
    [anon_sym_static] = ACTIONS(5101),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_event] = ACTIONS(5101),
    [anon_sym_class] = ACTIONS(5101),
    [anon_sym_ref] = ACTIONS(5101),
    [anon_sym_struct] = ACTIONS(5101),
    [anon_sym_enum] = ACTIONS(5101),
    [anon_sym_interface] = ACTIONS(5101),
    [anon_sym_delegate] = ACTIONS(5101),
    [anon_sym_record] = ACTIONS(5101),
    [anon_sym_abstract] = ACTIONS(5101),
    [anon_sym_async] = ACTIONS(5101),
    [anon_sym_const] = ACTIONS(5101),
    [anon_sym_file] = ACTIONS(5101),
    [anon_sym_fixed] = ACTIONS(5101),
    [anon_sym_internal] = ACTIONS(5101),
    [anon_sym_new] = ACTIONS(5101),
    [anon_sym_override] = ACTIONS(5101),
    [anon_sym_partial] = ACTIONS(5101),
    [anon_sym_private] = ACTIONS(5101),
    [anon_sym_protected] = ACTIONS(5101),
    [anon_sym_public] = ACTIONS(5101),
    [anon_sym_readonly] = ACTIONS(5101),
    [anon_sym_required] = ACTIONS(5101),
    [anon_sym_sealed] = ACTIONS(5101),
    [anon_sym_virtual] = ACTIONS(5101),
    [anon_sym_volatile] = ACTIONS(5101),
    [anon_sym_where] = ACTIONS(5101),
    [anon_sym_notnull] = ACTIONS(5101),
    [anon_sym_unmanaged] = ACTIONS(5101),
    [anon_sym_TILDE] = ACTIONS(5103),
    [anon_sym_implicit] = ACTIONS(5101),
    [anon_sym_explicit] = ACTIONS(5101),
    [anon_sym_scoped] = ACTIONS(5101),
    [anon_sym_var] = ACTIONS(5101),
    [sym_predefined_type] = ACTIONS(5101),
    [anon_sym_yield] = ACTIONS(5101),
    [anon_sym_when] = ACTIONS(5101),
    [anon_sym_from] = ACTIONS(5101),
    [anon_sym_into] = ACTIONS(5101),
    [anon_sym_join] = ACTIONS(5101),
    [anon_sym_on] = ACTIONS(5101),
    [anon_sym_equals] = ACTIONS(5101),
    [anon_sym_let] = ACTIONS(5101),
    [anon_sym_orderby] = ACTIONS(5101),
    [anon_sym_ascending] = ACTIONS(5101),
    [anon_sym_descending] = ACTIONS(5101),
    [anon_sym_group] = ACTIONS(5101),
    [anon_sym_by] = ACTIONS(5101),
    [anon_sym_select] = ACTIONS(5101),
    [aux_sym_preproc_if_token1] = ACTIONS(5103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3046] = {
    [sym_preproc_region] = STATE(3046),
    [sym_preproc_endregion] = STATE(3046),
    [sym_preproc_line] = STATE(3046),
    [sym_preproc_pragma] = STATE(3046),
    [sym_preproc_nullable] = STATE(3046),
    [sym_preproc_error] = STATE(3046),
    [sym_preproc_warning] = STATE(3046),
    [sym_preproc_define] = STATE(3046),
    [sym_preproc_undef] = STATE(3046),
    [anon_sym_SEMI] = ACTIONS(5105),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_COLON] = ACTIONS(5105),
    [anon_sym_COMMA] = ACTIONS(5105),
    [anon_sym_RBRACK] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_RPAREN] = ACTIONS(5105),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5107),
    [anon_sym_in] = ACTIONS(5107),
    [anon_sym_where] = ACTIONS(5105),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_BANG] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5107),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_PIPE] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_GT_GT_GT] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5105),
    [anon_sym_BANG_EQ] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5105),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_DOT] = ACTIONS(5107),
    [anon_sym_EQ_GT] = ACTIONS(5105),
    [anon_sym_switch] = ACTIONS(5105),
    [anon_sym_DOT_DOT] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_or] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5105),
    [anon_sym_QMARK_QMARK] = ACTIONS(5105),
    [anon_sym_from] = ACTIONS(5105),
    [anon_sym_into] = ACTIONS(5105),
    [anon_sym_join] = ACTIONS(5105),
    [anon_sym_on] = ACTIONS(5105),
    [anon_sym_equals] = ACTIONS(5105),
    [anon_sym_let] = ACTIONS(5105),
    [anon_sym_orderby] = ACTIONS(5105),
    [anon_sym_group] = ACTIONS(5105),
    [anon_sym_by] = ACTIONS(5105),
    [anon_sym_select] = ACTIONS(5105),
    [anon_sym_as] = ACTIONS(5105),
    [anon_sym_is] = ACTIONS(5105),
    [anon_sym_DASH_GT] = ACTIONS(5105),
    [anon_sym_with] = ACTIONS(5105),
    [aux_sym_preproc_if_token3] = ACTIONS(5105),
    [aux_sym_preproc_else_token1] = ACTIONS(5105),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3047] = {
    [sym_preproc_region] = STATE(3047),
    [sym_preproc_endregion] = STATE(3047),
    [sym_preproc_line] = STATE(3047),
    [sym_preproc_pragma] = STATE(3047),
    [sym_preproc_nullable] = STATE(3047),
    [sym_preproc_error] = STATE(3047),
    [sym_preproc_warning] = STATE(3047),
    [sym_preproc_define] = STATE(3047),
    [sym_preproc_undef] = STATE(3047),
    [anon_sym_SEMI] = ACTIONS(5109),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_COMMA] = ACTIONS(5109),
    [anon_sym_RBRACK] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5109),
    [anon_sym_RPAREN] = ACTIONS(5109),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5111),
    [anon_sym_in] = ACTIONS(5111),
    [anon_sym_where] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_BANG] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5111),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5111),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_PIPE] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5111),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5111),
    [anon_sym_GT_GT_GT] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5109),
    [anon_sym_BANG_EQ] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5109),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_DOT] = ACTIONS(5111),
    [anon_sym_EQ_GT] = ACTIONS(5109),
    [anon_sym_switch] = ACTIONS(5109),
    [anon_sym_DOT_DOT] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_or] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5109),
    [anon_sym_QMARK_QMARK] = ACTIONS(5109),
    [anon_sym_from] = ACTIONS(5109),
    [anon_sym_into] = ACTIONS(5109),
    [anon_sym_join] = ACTIONS(5109),
    [anon_sym_on] = ACTIONS(5109),
    [anon_sym_equals] = ACTIONS(5109),
    [anon_sym_let] = ACTIONS(5109),
    [anon_sym_orderby] = ACTIONS(5109),
    [anon_sym_group] = ACTIONS(5109),
    [anon_sym_by] = ACTIONS(5109),
    [anon_sym_select] = ACTIONS(5109),
    [anon_sym_as] = ACTIONS(5109),
    [anon_sym_is] = ACTIONS(5109),
    [anon_sym_DASH_GT] = ACTIONS(5109),
    [anon_sym_with] = ACTIONS(5109),
    [aux_sym_preproc_if_token3] = ACTIONS(5109),
    [aux_sym_preproc_else_token1] = ACTIONS(5109),
    [aux_sym_preproc_elif_token1] = ACTIONS(5109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3048] = {
    [sym_preproc_region] = STATE(3048),
    [sym_preproc_endregion] = STATE(3048),
    [sym_preproc_line] = STATE(3048),
    [sym_preproc_pragma] = STATE(3048),
    [sym_preproc_nullable] = STATE(3048),
    [sym_preproc_error] = STATE(3048),
    [sym_preproc_warning] = STATE(3048),
    [sym_preproc_define] = STATE(3048),
    [sym_preproc_undef] = STATE(3048),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACK] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_RPAREN] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5115),
    [anon_sym_in] = ACTIONS(5115),
    [anon_sym_where] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5115),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_PIPE] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_GT_GT_GT] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5113),
    [anon_sym_BANG_EQ] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5113),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_DOT] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5113),
    [anon_sym_switch] = ACTIONS(5113),
    [anon_sym_DOT_DOT] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5113),
    [anon_sym_QMARK_QMARK] = ACTIONS(5113),
    [anon_sym_from] = ACTIONS(5113),
    [anon_sym_into] = ACTIONS(5113),
    [anon_sym_join] = ACTIONS(5113),
    [anon_sym_on] = ACTIONS(5113),
    [anon_sym_equals] = ACTIONS(5113),
    [anon_sym_let] = ACTIONS(5113),
    [anon_sym_orderby] = ACTIONS(5113),
    [anon_sym_group] = ACTIONS(5113),
    [anon_sym_by] = ACTIONS(5113),
    [anon_sym_select] = ACTIONS(5113),
    [anon_sym_as] = ACTIONS(5113),
    [anon_sym_is] = ACTIONS(5113),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [anon_sym_with] = ACTIONS(5113),
    [aux_sym_preproc_if_token3] = ACTIONS(5113),
    [aux_sym_preproc_else_token1] = ACTIONS(5113),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3049] = {
    [sym_preproc_region] = STATE(3049),
    [sym_preproc_endregion] = STATE(3049),
    [sym_preproc_line] = STATE(3049),
    [sym_preproc_pragma] = STATE(3049),
    [sym_preproc_nullable] = STATE(3049),
    [sym_preproc_error] = STATE(3049),
    [sym_preproc_warning] = STATE(3049),
    [sym_preproc_define] = STATE(3049),
    [sym_preproc_undef] = STATE(3049),
    [anon_sym_SEMI] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_COMMA] = ACTIONS(5117),
    [anon_sym_RBRACK] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_RPAREN] = ACTIONS(5117),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5119),
    [anon_sym_in] = ACTIONS(5119),
    [anon_sym_where] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_BANG] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_PIPE] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_GT_GT_GT] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5117),
    [anon_sym_BANG_EQ] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5117),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_DOT] = ACTIONS(5119),
    [anon_sym_EQ_GT] = ACTIONS(5117),
    [anon_sym_switch] = ACTIONS(5117),
    [anon_sym_DOT_DOT] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_or] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5117),
    [anon_sym_QMARK_QMARK] = ACTIONS(5117),
    [anon_sym_from] = ACTIONS(5117),
    [anon_sym_into] = ACTIONS(5117),
    [anon_sym_join] = ACTIONS(5117),
    [anon_sym_on] = ACTIONS(5117),
    [anon_sym_equals] = ACTIONS(5117),
    [anon_sym_let] = ACTIONS(5117),
    [anon_sym_orderby] = ACTIONS(5117),
    [anon_sym_group] = ACTIONS(5117),
    [anon_sym_by] = ACTIONS(5117),
    [anon_sym_select] = ACTIONS(5117),
    [anon_sym_as] = ACTIONS(5117),
    [anon_sym_is] = ACTIONS(5117),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [anon_sym_with] = ACTIONS(5117),
    [aux_sym_preproc_if_token3] = ACTIONS(5117),
    [aux_sym_preproc_else_token1] = ACTIONS(5117),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3050] = {
    [sym_preproc_region] = STATE(3050),
    [sym_preproc_endregion] = STATE(3050),
    [sym_preproc_line] = STATE(3050),
    [sym_preproc_pragma] = STATE(3050),
    [sym_preproc_nullable] = STATE(3050),
    [sym_preproc_error] = STATE(3050),
    [sym_preproc_warning] = STATE(3050),
    [sym_preproc_define] = STATE(3050),
    [sym_preproc_undef] = STATE(3050),
    [anon_sym_SEMI] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5121),
    [anon_sym_RBRACK] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_RPAREN] = ACTIONS(5121),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5123),
    [anon_sym_in] = ACTIONS(5123),
    [anon_sym_where] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5123),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5123),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_PIPE] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_GT_GT_GT] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5121),
    [anon_sym_BANG_EQ] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5121),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_DOT] = ACTIONS(5123),
    [anon_sym_EQ_GT] = ACTIONS(5121),
    [anon_sym_switch] = ACTIONS(5121),
    [anon_sym_DOT_DOT] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_or] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5121),
    [anon_sym_QMARK_QMARK] = ACTIONS(5121),
    [anon_sym_from] = ACTIONS(5121),
    [anon_sym_into] = ACTIONS(5121),
    [anon_sym_join] = ACTIONS(5121),
    [anon_sym_on] = ACTIONS(5121),
    [anon_sym_equals] = ACTIONS(5121),
    [anon_sym_let] = ACTIONS(5121),
    [anon_sym_orderby] = ACTIONS(5121),
    [anon_sym_group] = ACTIONS(5121),
    [anon_sym_by] = ACTIONS(5121),
    [anon_sym_select] = ACTIONS(5121),
    [anon_sym_as] = ACTIONS(5121),
    [anon_sym_is] = ACTIONS(5121),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [anon_sym_with] = ACTIONS(5121),
    [aux_sym_preproc_if_token3] = ACTIONS(5121),
    [aux_sym_preproc_else_token1] = ACTIONS(5121),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3051] = {
    [sym_preproc_region] = STATE(3051),
    [sym_preproc_endregion] = STATE(3051),
    [sym_preproc_line] = STATE(3051),
    [sym_preproc_pragma] = STATE(3051),
    [sym_preproc_nullable] = STATE(3051),
    [sym_preproc_error] = STATE(3051),
    [sym_preproc_warning] = STATE(3051),
    [sym_preproc_define] = STATE(3051),
    [sym_preproc_undef] = STATE(3051),
    [anon_sym_SEMI] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_COMMA] = ACTIONS(5125),
    [anon_sym_RBRACK] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_RPAREN] = ACTIONS(5125),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5127),
    [anon_sym_in] = ACTIONS(5127),
    [anon_sym_where] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_BANG] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5127),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_PIPE] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_GT_GT_GT] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5125),
    [anon_sym_BANG_EQ] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5125),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5127),
    [anon_sym_EQ_GT] = ACTIONS(5125),
    [anon_sym_switch] = ACTIONS(5125),
    [anon_sym_DOT_DOT] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_or] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_QMARK_QMARK] = ACTIONS(5125),
    [anon_sym_from] = ACTIONS(5125),
    [anon_sym_into] = ACTIONS(5125),
    [anon_sym_join] = ACTIONS(5125),
    [anon_sym_on] = ACTIONS(5125),
    [anon_sym_equals] = ACTIONS(5125),
    [anon_sym_let] = ACTIONS(5125),
    [anon_sym_orderby] = ACTIONS(5125),
    [anon_sym_group] = ACTIONS(5125),
    [anon_sym_by] = ACTIONS(5125),
    [anon_sym_select] = ACTIONS(5125),
    [anon_sym_as] = ACTIONS(5125),
    [anon_sym_is] = ACTIONS(5125),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [anon_sym_with] = ACTIONS(5125),
    [aux_sym_preproc_if_token3] = ACTIONS(5125),
    [aux_sym_preproc_else_token1] = ACTIONS(5125),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3052] = {
    [sym_preproc_region] = STATE(3052),
    [sym_preproc_endregion] = STATE(3052),
    [sym_preproc_line] = STATE(3052),
    [sym_preproc_pragma] = STATE(3052),
    [sym_preproc_nullable] = STATE(3052),
    [sym_preproc_error] = STATE(3052),
    [sym_preproc_warning] = STATE(3052),
    [sym_preproc_define] = STATE(3052),
    [sym_preproc_undef] = STATE(3052),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5129),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_in] = ACTIONS(5131),
    [anon_sym_where] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_BANG] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5131),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_GT_GT_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_BANG_EQ] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5129),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_DOT] = ACTIONS(5131),
    [anon_sym_EQ_GT] = ACTIONS(5129),
    [anon_sym_switch] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_or] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_QMARK_QMARK] = ACTIONS(5129),
    [anon_sym_from] = ACTIONS(5129),
    [anon_sym_into] = ACTIONS(5129),
    [anon_sym_join] = ACTIONS(5129),
    [anon_sym_on] = ACTIONS(5129),
    [anon_sym_equals] = ACTIONS(5129),
    [anon_sym_let] = ACTIONS(5129),
    [anon_sym_orderby] = ACTIONS(5129),
    [anon_sym_group] = ACTIONS(5129),
    [anon_sym_by] = ACTIONS(5129),
    [anon_sym_select] = ACTIONS(5129),
    [anon_sym_as] = ACTIONS(5129),
    [anon_sym_is] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_with] = ACTIONS(5129),
    [aux_sym_preproc_if_token3] = ACTIONS(5129),
    [aux_sym_preproc_else_token1] = ACTIONS(5129),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3053] = {
    [sym_attribute_list] = STATE(3570),
    [sym__attribute_list] = STATE(3569),
    [sym_modifier] = STATE(3734),
    [sym_identifier] = STATE(6453),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_if_in_attribute_list] = STATE(3570),
    [sym_preproc_region] = STATE(3053),
    [sym_preproc_endregion] = STATE(3053),
    [sym_preproc_line] = STATE(3053),
    [sym_preproc_pragma] = STATE(3053),
    [sym_preproc_nullable] = STATE(3053),
    [sym_preproc_error] = STATE(3053),
    [sym_preproc_warning] = STATE(3053),
    [sym_preproc_define] = STATE(3053),
    [sym_preproc_undef] = STATE(3053),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3170),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3348),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(4787),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(4787),
    [anon_sym_static] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4789),
    [anon_sym_abstract] = ACTIONS(4787),
    [anon_sym_async] = ACTIONS(4787),
    [anon_sym_const] = ACTIONS(4787),
    [anon_sym_file] = ACTIONS(4793),
    [anon_sym_fixed] = ACTIONS(4787),
    [anon_sym_internal] = ACTIONS(4787),
    [anon_sym_new] = ACTIONS(4787),
    [anon_sym_override] = ACTIONS(4787),
    [anon_sym_partial] = ACTIONS(4787),
    [anon_sym_private] = ACTIONS(4787),
    [anon_sym_protected] = ACTIONS(4787),
    [anon_sym_public] = ACTIONS(4787),
    [anon_sym_readonly] = ACTIONS(4787),
    [anon_sym_required] = ACTIONS(4787),
    [anon_sym_sealed] = ACTIONS(4787),
    [anon_sym_virtual] = ACTIONS(4787),
    [anon_sym_volatile] = ACTIONS(4787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_get] = ACTIONS(5133),
    [anon_sym_set] = ACTIONS(5133),
    [anon_sym_add] = ACTIONS(5133),
    [anon_sym_remove] = ACTIONS(5133),
    [anon_sym_init] = ACTIONS(5133),
    [anon_sym_scoped] = ACTIONS(29),
    [anon_sym_var] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_from] = ACTIONS(29),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [aux_sym_preproc_if_token1] = ACTIONS(4797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3054] = {
    [sym_preproc_region] = STATE(3054),
    [sym_preproc_endregion] = STATE(3054),
    [sym_preproc_line] = STATE(3054),
    [sym_preproc_pragma] = STATE(3054),
    [sym_preproc_nullable] = STATE(3054),
    [sym_preproc_error] = STATE(3054),
    [sym_preproc_warning] = STATE(3054),
    [sym_preproc_define] = STATE(3054),
    [sym_preproc_undef] = STATE(3054),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_LPAREN] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_in] = ACTIONS(4121),
    [anon_sym_where] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4121),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4119),
    [anon_sym_EQ_GT] = ACTIONS(4121),
    [anon_sym_switch] = ACTIONS(4121),
    [anon_sym_DOT_DOT] = ACTIONS(4121),
    [anon_sym_and] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_QMARK_QMARK] = ACTIONS(4121),
    [anon_sym_from] = ACTIONS(4121),
    [anon_sym_join] = ACTIONS(4121),
    [anon_sym_on] = ACTIONS(4121),
    [anon_sym_equals] = ACTIONS(4121),
    [anon_sym_let] = ACTIONS(4121),
    [anon_sym_orderby] = ACTIONS(4121),
    [anon_sym_group] = ACTIONS(4121),
    [anon_sym_by] = ACTIONS(4121),
    [anon_sym_select] = ACTIONS(4121),
    [anon_sym_as] = ACTIONS(4121),
    [anon_sym_is] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [anon_sym_with] = ACTIONS(4121),
    [aux_sym_preproc_if_token3] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3055] = {
    [sym_preproc_region] = STATE(3055),
    [sym_preproc_endregion] = STATE(3055),
    [sym_preproc_line] = STATE(3055),
    [sym_preproc_pragma] = STATE(3055),
    [sym_preproc_nullable] = STATE(3055),
    [sym_preproc_error] = STATE(3055),
    [sym_preproc_warning] = STATE(3055),
    [sym_preproc_define] = STATE(3055),
    [sym_preproc_undef] = STATE(3055),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_RBRACK] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4152),
    [anon_sym_where] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_CARET] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4152),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4152),
    [anon_sym_switch] = ACTIONS(4152),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_and] = ACTIONS(4152),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_QMARK_QMARK] = ACTIONS(4152),
    [anon_sym_from] = ACTIONS(4152),
    [anon_sym_join] = ACTIONS(4152),
    [anon_sym_on] = ACTIONS(4152),
    [anon_sym_equals] = ACTIONS(4152),
    [anon_sym_let] = ACTIONS(4152),
    [anon_sym_orderby] = ACTIONS(4152),
    [anon_sym_group] = ACTIONS(4152),
    [anon_sym_by] = ACTIONS(4152),
    [anon_sym_select] = ACTIONS(4152),
    [anon_sym_as] = ACTIONS(4152),
    [anon_sym_is] = ACTIONS(4152),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [anon_sym_with] = ACTIONS(4152),
    [aux_sym_preproc_if_token3] = ACTIONS(4152),
    [aux_sym_preproc_else_token1] = ACTIONS(4152),
    [aux_sym_preproc_elif_token1] = ACTIONS(4152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3056] = {
    [sym_preproc_region] = STATE(3056),
    [sym_preproc_endregion] = STATE(3056),
    [sym_preproc_line] = STATE(3056),
    [sym_preproc_pragma] = STATE(3056),
    [sym_preproc_nullable] = STATE(3056),
    [sym_preproc_error] = STATE(3056),
    [sym_preproc_warning] = STATE(3056),
    [sym_preproc_define] = STATE(3056),
    [sym_preproc_undef] = STATE(3056),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_in] = ACTIONS(4050),
    [anon_sym_where] = ACTIONS(4050),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_DOT] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4050),
    [anon_sym_switch] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4050),
    [anon_sym_and] = ACTIONS(4050),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_QMARK_QMARK] = ACTIONS(4050),
    [anon_sym_from] = ACTIONS(4050),
    [anon_sym_join] = ACTIONS(4050),
    [anon_sym_on] = ACTIONS(4050),
    [anon_sym_equals] = ACTIONS(4050),
    [anon_sym_let] = ACTIONS(4050),
    [anon_sym_orderby] = ACTIONS(4050),
    [anon_sym_group] = ACTIONS(4050),
    [anon_sym_by] = ACTIONS(4050),
    [anon_sym_select] = ACTIONS(4050),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_is] = ACTIONS(4050),
    [anon_sym_DASH_GT] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4050),
    [aux_sym_preproc_if_token3] = ACTIONS(4050),
    [aux_sym_preproc_else_token1] = ACTIONS(4050),
    [aux_sym_preproc_elif_token1] = ACTIONS(4050),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3057] = {
    [sym_preproc_region] = STATE(3057),
    [sym_preproc_endregion] = STATE(3057),
    [sym_preproc_line] = STATE(3057),
    [sym_preproc_pragma] = STATE(3057),
    [sym_preproc_nullable] = STATE(3057),
    [sym_preproc_error] = STATE(3057),
    [sym_preproc_warning] = STATE(3057),
    [sym_preproc_define] = STATE(3057),
    [sym_preproc_undef] = STATE(3057),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3676),
    [anon_sym_where] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_CARET] = ACTIONS(3676),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3676),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3676),
    [anon_sym_from] = ACTIONS(3676),
    [anon_sym_join] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_orderby] = ACTIONS(3676),
    [anon_sym_group] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_select] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3058] = {
    [sym_preproc_region] = STATE(3058),
    [sym_preproc_endregion] = STATE(3058),
    [sym_preproc_line] = STATE(3058),
    [sym_preproc_pragma] = STATE(3058),
    [sym_preproc_nullable] = STATE(3058),
    [sym_preproc_error] = STATE(3058),
    [sym_preproc_warning] = STATE(3058),
    [sym_preproc_define] = STATE(3058),
    [sym_preproc_undef] = STATE(3058),
    [anon_sym_SEMI] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5135),
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_RBRACK] = ACTIONS(5135),
    [anon_sym_LPAREN] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_in] = ACTIONS(5137),
    [anon_sym_where] = ACTIONS(5135),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_BANG] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5137),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5137),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5137),
    [anon_sym_AMP] = ACTIONS(5137),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_GT_GT_GT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_DOT] = ACTIONS(5137),
    [anon_sym_EQ_GT] = ACTIONS(5135),
    [anon_sym_switch] = ACTIONS(5135),
    [anon_sym_DOT_DOT] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_or] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_QMARK_QMARK] = ACTIONS(5135),
    [anon_sym_from] = ACTIONS(5135),
    [anon_sym_into] = ACTIONS(5135),
    [anon_sym_join] = ACTIONS(5135),
    [anon_sym_on] = ACTIONS(5135),
    [anon_sym_equals] = ACTIONS(5135),
    [anon_sym_let] = ACTIONS(5135),
    [anon_sym_orderby] = ACTIONS(5135),
    [anon_sym_group] = ACTIONS(5135),
    [anon_sym_by] = ACTIONS(5135),
    [anon_sym_select] = ACTIONS(5135),
    [anon_sym_as] = ACTIONS(5135),
    [anon_sym_is] = ACTIONS(5135),
    [anon_sym_DASH_GT] = ACTIONS(5135),
    [anon_sym_with] = ACTIONS(5135),
    [aux_sym_preproc_if_token3] = ACTIONS(5135),
    [aux_sym_preproc_else_token1] = ACTIONS(5135),
    [aux_sym_preproc_elif_token1] = ACTIONS(5135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3059] = {
    [sym_preproc_region] = STATE(3059),
    [sym_preproc_endregion] = STATE(3059),
    [sym_preproc_line] = STATE(3059),
    [sym_preproc_pragma] = STATE(3059),
    [sym_preproc_nullable] = STATE(3059),
    [sym_preproc_error] = STATE(3059),
    [sym_preproc_warning] = STATE(3059),
    [sym_preproc_define] = STATE(3059),
    [sym_preproc_undef] = STATE(3059),
    [anon_sym_SEMI] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RBRACK] = ACTIONS(5139),
    [anon_sym_LPAREN] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_in] = ACTIONS(5141),
    [anon_sym_where] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(5141),
    [anon_sym_BANG] = ACTIONS(5141),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5141),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5141),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5141),
    [anon_sym_AMP] = ACTIONS(5141),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5141),
    [anon_sym_GT_GT_GT] = ACTIONS(5139),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5141),
    [anon_sym_EQ_GT] = ACTIONS(5139),
    [anon_sym_switch] = ACTIONS(5139),
    [anon_sym_DOT_DOT] = ACTIONS(5139),
    [anon_sym_and] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5141),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_QMARK_QMARK] = ACTIONS(5139),
    [anon_sym_from] = ACTIONS(5139),
    [anon_sym_into] = ACTIONS(5139),
    [anon_sym_join] = ACTIONS(5139),
    [anon_sym_on] = ACTIONS(5139),
    [anon_sym_equals] = ACTIONS(5139),
    [anon_sym_let] = ACTIONS(5139),
    [anon_sym_orderby] = ACTIONS(5139),
    [anon_sym_group] = ACTIONS(5139),
    [anon_sym_by] = ACTIONS(5139),
    [anon_sym_select] = ACTIONS(5139),
    [anon_sym_as] = ACTIONS(5139),
    [anon_sym_is] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [anon_sym_with] = ACTIONS(5139),
    [aux_sym_preproc_if_token3] = ACTIONS(5139),
    [aux_sym_preproc_else_token1] = ACTIONS(5139),
    [aux_sym_preproc_elif_token1] = ACTIONS(5139),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3060] = {
    [sym_preproc_region] = STATE(3060),
    [sym_preproc_endregion] = STATE(3060),
    [sym_preproc_line] = STATE(3060),
    [sym_preproc_pragma] = STATE(3060),
    [sym_preproc_nullable] = STATE(3060),
    [sym_preproc_error] = STATE(3060),
    [sym_preproc_warning] = STATE(3060),
    [sym_preproc_define] = STATE(3060),
    [sym_preproc_undef] = STATE(3060),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3061] = {
    [sym_preproc_region] = STATE(3061),
    [sym_preproc_endregion] = STATE(3061),
    [sym_preproc_line] = STATE(3061),
    [sym_preproc_pragma] = STATE(3061),
    [sym_preproc_nullable] = STATE(3061),
    [sym_preproc_error] = STATE(3061),
    [sym_preproc_warning] = STATE(3061),
    [sym_preproc_define] = STATE(3061),
    [sym_preproc_undef] = STATE(3061),
    [anon_sym_SEMI] = ACTIONS(5145),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5145),
    [anon_sym_COMMA] = ACTIONS(5145),
    [anon_sym_RBRACK] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5145),
    [anon_sym_RBRACE] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5147),
    [anon_sym_in] = ACTIONS(5147),
    [anon_sym_where] = ACTIONS(5145),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_BANG] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5145),
    [anon_sym_PIPE] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5147),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5147),
    [anon_sym_GT_GT_GT] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5145),
    [anon_sym_BANG_EQ] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5145),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_DOT] = ACTIONS(5147),
    [anon_sym_EQ_GT] = ACTIONS(5145),
    [anon_sym_switch] = ACTIONS(5145),
    [anon_sym_DOT_DOT] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_or] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5145),
    [anon_sym_PIPE_PIPE] = ACTIONS(5145),
    [anon_sym_QMARK_QMARK] = ACTIONS(5145),
    [anon_sym_from] = ACTIONS(5145),
    [anon_sym_into] = ACTIONS(5145),
    [anon_sym_join] = ACTIONS(5145),
    [anon_sym_on] = ACTIONS(5145),
    [anon_sym_equals] = ACTIONS(5145),
    [anon_sym_let] = ACTIONS(5145),
    [anon_sym_orderby] = ACTIONS(5145),
    [anon_sym_group] = ACTIONS(5145),
    [anon_sym_by] = ACTIONS(5145),
    [anon_sym_select] = ACTIONS(5145),
    [anon_sym_as] = ACTIONS(5145),
    [anon_sym_is] = ACTIONS(5145),
    [anon_sym_DASH_GT] = ACTIONS(5145),
    [anon_sym_with] = ACTIONS(5145),
    [aux_sym_preproc_if_token3] = ACTIONS(5145),
    [aux_sym_preproc_else_token1] = ACTIONS(5145),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3062] = {
    [sym_preproc_region] = STATE(3062),
    [sym_preproc_endregion] = STATE(3062),
    [sym_preproc_line] = STATE(3062),
    [sym_preproc_pragma] = STATE(3062),
    [sym_preproc_nullable] = STATE(3062),
    [sym_preproc_error] = STATE(3062),
    [sym_preproc_warning] = STATE(3062),
    [sym_preproc_define] = STATE(3062),
    [sym_preproc_undef] = STATE(3062),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_in] = ACTIONS(4044),
    [anon_sym_where] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4044),
    [anon_sym_or] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_QMARK_QMARK] = ACTIONS(4044),
    [anon_sym_from] = ACTIONS(4044),
    [anon_sym_join] = ACTIONS(4044),
    [anon_sym_on] = ACTIONS(4044),
    [anon_sym_equals] = ACTIONS(4044),
    [anon_sym_let] = ACTIONS(4044),
    [anon_sym_orderby] = ACTIONS(4044),
    [anon_sym_group] = ACTIONS(4044),
    [anon_sym_by] = ACTIONS(4044),
    [anon_sym_select] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4044),
    [anon_sym_is] = ACTIONS(4044),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_with] = ACTIONS(4044),
    [aux_sym_preproc_if_token3] = ACTIONS(4044),
    [aux_sym_preproc_else_token1] = ACTIONS(4044),
    [aux_sym_preproc_elif_token1] = ACTIONS(4044),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3063] = {
    [sym_preproc_region] = STATE(3063),
    [sym_preproc_endregion] = STATE(3063),
    [sym_preproc_line] = STATE(3063),
    [sym_preproc_pragma] = STATE(3063),
    [sym_preproc_nullable] = STATE(3063),
    [sym_preproc_error] = STATE(3063),
    [sym_preproc_warning] = STATE(3063),
    [sym_preproc_define] = STATE(3063),
    [sym_preproc_undef] = STATE(3063),
    [anon_sym_SEMI] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_COMMA] = ACTIONS(5149),
    [anon_sym_RBRACK] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_RPAREN] = ACTIONS(5149),
    [anon_sym_RBRACE] = ACTIONS(5149),
    [anon_sym_LT] = ACTIONS(5151),
    [anon_sym_GT] = ACTIONS(5151),
    [anon_sym_in] = ACTIONS(5151),
    [anon_sym_where] = ACTIONS(5149),
    [anon_sym_QMARK] = ACTIONS(5151),
    [anon_sym_BANG] = ACTIONS(5151),
    [anon_sym_PLUS_PLUS] = ACTIONS(5149),
    [anon_sym_DASH_DASH] = ACTIONS(5149),
    [anon_sym_PLUS] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5149),
    [anon_sym_SLASH] = ACTIONS(5151),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [anon_sym_PIPE] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5151),
    [anon_sym_LT_LT] = ACTIONS(5149),
    [anon_sym_GT_GT] = ACTIONS(5151),
    [anon_sym_GT_GT_GT] = ACTIONS(5149),
    [anon_sym_EQ_EQ] = ACTIONS(5149),
    [anon_sym_BANG_EQ] = ACTIONS(5149),
    [anon_sym_GT_EQ] = ACTIONS(5149),
    [anon_sym_LT_EQ] = ACTIONS(5149),
    [anon_sym_DOT] = ACTIONS(5151),
    [anon_sym_EQ_GT] = ACTIONS(5149),
    [anon_sym_switch] = ACTIONS(5149),
    [anon_sym_DOT_DOT] = ACTIONS(5149),
    [anon_sym_and] = ACTIONS(5149),
    [anon_sym_or] = ACTIONS(5151),
    [anon_sym_AMP_AMP] = ACTIONS(5149),
    [anon_sym_PIPE_PIPE] = ACTIONS(5149),
    [anon_sym_QMARK_QMARK] = ACTIONS(5149),
    [anon_sym_from] = ACTIONS(5149),
    [anon_sym_into] = ACTIONS(5149),
    [anon_sym_join] = ACTIONS(5149),
    [anon_sym_on] = ACTIONS(5149),
    [anon_sym_equals] = ACTIONS(5149),
    [anon_sym_let] = ACTIONS(5149),
    [anon_sym_orderby] = ACTIONS(5149),
    [anon_sym_group] = ACTIONS(5149),
    [anon_sym_by] = ACTIONS(5149),
    [anon_sym_select] = ACTIONS(5149),
    [anon_sym_as] = ACTIONS(5149),
    [anon_sym_is] = ACTIONS(5149),
    [anon_sym_DASH_GT] = ACTIONS(5149),
    [anon_sym_with] = ACTIONS(5149),
    [aux_sym_preproc_if_token3] = ACTIONS(5149),
    [aux_sym_preproc_else_token1] = ACTIONS(5149),
    [aux_sym_preproc_elif_token1] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3064] = {
    [sym_preproc_region] = STATE(3064),
    [sym_preproc_endregion] = STATE(3064),
    [sym_preproc_line] = STATE(3064),
    [sym_preproc_pragma] = STATE(3064),
    [sym_preproc_nullable] = STATE(3064),
    [sym_preproc_error] = STATE(3064),
    [sym_preproc_warning] = STATE(3064),
    [sym_preproc_define] = STATE(3064),
    [sym_preproc_undef] = STATE(3064),
    [anon_sym_SEMI] = ACTIONS(5153),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_COMMA] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_RPAREN] = ACTIONS(5153),
    [anon_sym_RBRACE] = ACTIONS(5153),
    [anon_sym_LT] = ACTIONS(5155),
    [anon_sym_GT] = ACTIONS(5155),
    [anon_sym_in] = ACTIONS(5155),
    [anon_sym_where] = ACTIONS(5153),
    [anon_sym_QMARK] = ACTIONS(5155),
    [anon_sym_BANG] = ACTIONS(5155),
    [anon_sym_PLUS_PLUS] = ACTIONS(5153),
    [anon_sym_DASH_DASH] = ACTIONS(5153),
    [anon_sym_PLUS] = ACTIONS(5155),
    [anon_sym_DASH] = ACTIONS(5155),
    [anon_sym_STAR] = ACTIONS(5153),
    [anon_sym_SLASH] = ACTIONS(5155),
    [anon_sym_PERCENT] = ACTIONS(5153),
    [anon_sym_CARET] = ACTIONS(5153),
    [anon_sym_PIPE] = ACTIONS(5155),
    [anon_sym_AMP] = ACTIONS(5155),
    [anon_sym_LT_LT] = ACTIONS(5153),
    [anon_sym_GT_GT] = ACTIONS(5155),
    [anon_sym_GT_GT_GT] = ACTIONS(5153),
    [anon_sym_EQ_EQ] = ACTIONS(5153),
    [anon_sym_BANG_EQ] = ACTIONS(5153),
    [anon_sym_GT_EQ] = ACTIONS(5153),
    [anon_sym_LT_EQ] = ACTIONS(5153),
    [anon_sym_DOT] = ACTIONS(5155),
    [anon_sym_EQ_GT] = ACTIONS(5153),
    [anon_sym_switch] = ACTIONS(5153),
    [anon_sym_DOT_DOT] = ACTIONS(5153),
    [anon_sym_and] = ACTIONS(5153),
    [anon_sym_or] = ACTIONS(5155),
    [anon_sym_AMP_AMP] = ACTIONS(5153),
    [anon_sym_PIPE_PIPE] = ACTIONS(5153),
    [anon_sym_QMARK_QMARK] = ACTIONS(5153),
    [anon_sym_from] = ACTIONS(5153),
    [anon_sym_into] = ACTIONS(5153),
    [anon_sym_join] = ACTIONS(5153),
    [anon_sym_on] = ACTIONS(5153),
    [anon_sym_equals] = ACTIONS(5153),
    [anon_sym_let] = ACTIONS(5153),
    [anon_sym_orderby] = ACTIONS(5153),
    [anon_sym_group] = ACTIONS(5153),
    [anon_sym_by] = ACTIONS(5153),
    [anon_sym_select] = ACTIONS(5153),
    [anon_sym_as] = ACTIONS(5153),
    [anon_sym_is] = ACTIONS(5153),
    [anon_sym_DASH_GT] = ACTIONS(5153),
    [anon_sym_with] = ACTIONS(5153),
    [aux_sym_preproc_if_token3] = ACTIONS(5153),
    [aux_sym_preproc_else_token1] = ACTIONS(5153),
    [aux_sym_preproc_elif_token1] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3065] = {
    [sym_preproc_region] = STATE(3065),
    [sym_preproc_endregion] = STATE(3065),
    [sym_preproc_line] = STATE(3065),
    [sym_preproc_pragma] = STATE(3065),
    [sym_preproc_nullable] = STATE(3065),
    [sym_preproc_error] = STATE(3065),
    [sym_preproc_warning] = STATE(3065),
    [sym_preproc_define] = STATE(3065),
    [sym_preproc_undef] = STATE(3065),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_in] = ACTIONS(2063),
    [anon_sym_where] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(2063),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_EQ_GT] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_DOT_DOT] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_QMARK_QMARK] = ACTIONS(2061),
    [anon_sym_from] = ACTIONS(2061),
    [anon_sym_into] = ACTIONS(2061),
    [anon_sym_join] = ACTIONS(2061),
    [anon_sym_on] = ACTIONS(2061),
    [anon_sym_equals] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2061),
    [anon_sym_orderby] = ACTIONS(2061),
    [anon_sym_group] = ACTIONS(2061),
    [anon_sym_by] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_DASH_GT] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [aux_sym_preproc_if_token3] = ACTIONS(2061),
    [aux_sym_preproc_else_token1] = ACTIONS(2061),
    [aux_sym_preproc_elif_token1] = ACTIONS(2061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3066] = {
    [sym_preproc_region] = STATE(3066),
    [sym_preproc_endregion] = STATE(3066),
    [sym_preproc_line] = STATE(3066),
    [sym_preproc_pragma] = STATE(3066),
    [sym_preproc_nullable] = STATE(3066),
    [sym_preproc_error] = STATE(3066),
    [sym_preproc_warning] = STATE(3066),
    [sym_preproc_define] = STATE(3066),
    [sym_preproc_undef] = STATE(3066),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_RBRACK] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(5157),
    [anon_sym_RPAREN] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_where] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_EQ_GT] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_from] = ACTIONS(1997),
    [anon_sym_into] = ACTIONS(1997),
    [anon_sym_join] = ACTIONS(1997),
    [anon_sym_on] = ACTIONS(1997),
    [anon_sym_equals] = ACTIONS(1997),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_orderby] = ACTIONS(1997),
    [anon_sym_group] = ACTIONS(1997),
    [anon_sym_by] = ACTIONS(1997),
    [anon_sym_select] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1997),
    [anon_sym_is] = ACTIONS(1997),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_with] = ACTIONS(1997),
    [aux_sym_preproc_if_token3] = ACTIONS(1997),
    [aux_sym_preproc_else_token1] = ACTIONS(1997),
    [aux_sym_preproc_elif_token1] = ACTIONS(1997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3067] = {
    [sym_preproc_region] = STATE(3067),
    [sym_preproc_endregion] = STATE(3067),
    [sym_preproc_line] = STATE(3067),
    [sym_preproc_pragma] = STATE(3067),
    [sym_preproc_nullable] = STATE(3067),
    [sym_preproc_error] = STATE(3067),
    [sym_preproc_warning] = STATE(3067),
    [sym_preproc_define] = STATE(3067),
    [sym_preproc_undef] = STATE(3067),
    [anon_sym_SEMI] = ACTIONS(5159),
    [anon_sym_LBRACK] = ACTIONS(5159),
    [anon_sym_COLON] = ACTIONS(5159),
    [anon_sym_COMMA] = ACTIONS(5159),
    [anon_sym_RBRACK] = ACTIONS(5159),
    [anon_sym_LPAREN] = ACTIONS(5159),
    [anon_sym_RPAREN] = ACTIONS(5159),
    [anon_sym_RBRACE] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_in] = ACTIONS(5161),
    [anon_sym_where] = ACTIONS(5159),
    [anon_sym_QMARK] = ACTIONS(5161),
    [anon_sym_BANG] = ACTIONS(5161),
    [anon_sym_PLUS_PLUS] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(5161),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_AMP] = ACTIONS(5161),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5161),
    [anon_sym_GT_GT_GT] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5159),
    [anon_sym_BANG_EQ] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5159),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_DOT] = ACTIONS(5161),
    [anon_sym_EQ_GT] = ACTIONS(5159),
    [anon_sym_switch] = ACTIONS(5159),
    [anon_sym_DOT_DOT] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_or] = ACTIONS(5161),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_QMARK_QMARK] = ACTIONS(5159),
    [anon_sym_from] = ACTIONS(5159),
    [anon_sym_into] = ACTIONS(5159),
    [anon_sym_join] = ACTIONS(5159),
    [anon_sym_on] = ACTIONS(5159),
    [anon_sym_equals] = ACTIONS(5159),
    [anon_sym_let] = ACTIONS(5159),
    [anon_sym_orderby] = ACTIONS(5159),
    [anon_sym_group] = ACTIONS(5159),
    [anon_sym_by] = ACTIONS(5159),
    [anon_sym_select] = ACTIONS(5159),
    [anon_sym_as] = ACTIONS(5159),
    [anon_sym_is] = ACTIONS(5159),
    [anon_sym_DASH_GT] = ACTIONS(5159),
    [anon_sym_with] = ACTIONS(5159),
    [aux_sym_preproc_if_token3] = ACTIONS(5159),
    [aux_sym_preproc_else_token1] = ACTIONS(5159),
    [aux_sym_preproc_elif_token1] = ACTIONS(5159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3068] = {
    [sym_preproc_region] = STATE(3068),
    [sym_preproc_endregion] = STATE(3068),
    [sym_preproc_line] = STATE(3068),
    [sym_preproc_pragma] = STATE(3068),
    [sym_preproc_nullable] = STATE(3068),
    [sym_preproc_error] = STATE(3068),
    [sym_preproc_warning] = STATE(3068),
    [sym_preproc_define] = STATE(3068),
    [sym_preproc_undef] = STATE(3068),
    [anon_sym_SEMI] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(5163),
    [anon_sym_COLON] = ACTIONS(5163),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACK] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(5163),
    [anon_sym_RPAREN] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_in] = ACTIONS(5165),
    [anon_sym_where] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_PLUS_PLUS] = ACTIONS(5163),
    [anon_sym_DASH_DASH] = ACTIONS(5163),
    [anon_sym_PLUS] = ACTIONS(5165),
    [anon_sym_DASH] = ACTIONS(5165),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_SLASH] = ACTIONS(5165),
    [anon_sym_PERCENT] = ACTIONS(5163),
    [anon_sym_CARET] = ACTIONS(5163),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_LT_LT] = ACTIONS(5163),
    [anon_sym_GT_GT] = ACTIONS(5165),
    [anon_sym_GT_GT_GT] = ACTIONS(5163),
    [anon_sym_EQ_EQ] = ACTIONS(5163),
    [anon_sym_BANG_EQ] = ACTIONS(5163),
    [anon_sym_GT_EQ] = ACTIONS(5163),
    [anon_sym_LT_EQ] = ACTIONS(5163),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_EQ_GT] = ACTIONS(5163),
    [anon_sym_switch] = ACTIONS(5163),
    [anon_sym_DOT_DOT] = ACTIONS(5163),
    [anon_sym_and] = ACTIONS(5163),
    [anon_sym_or] = ACTIONS(5165),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_QMARK_QMARK] = ACTIONS(5163),
    [anon_sym_from] = ACTIONS(5163),
    [anon_sym_into] = ACTIONS(5163),
    [anon_sym_join] = ACTIONS(5163),
    [anon_sym_on] = ACTIONS(5163),
    [anon_sym_equals] = ACTIONS(5163),
    [anon_sym_let] = ACTIONS(5163),
    [anon_sym_orderby] = ACTIONS(5163),
    [anon_sym_group] = ACTIONS(5163),
    [anon_sym_by] = ACTIONS(5163),
    [anon_sym_select] = ACTIONS(5163),
    [anon_sym_as] = ACTIONS(5163),
    [anon_sym_is] = ACTIONS(5163),
    [anon_sym_DASH_GT] = ACTIONS(5163),
    [anon_sym_with] = ACTIONS(5163),
    [aux_sym_preproc_if_token3] = ACTIONS(5163),
    [aux_sym_preproc_else_token1] = ACTIONS(5163),
    [aux_sym_preproc_elif_token1] = ACTIONS(5163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3069] = {
    [sym_preproc_region] = STATE(3069),
    [sym_preproc_endregion] = STATE(3069),
    [sym_preproc_line] = STATE(3069),
    [sym_preproc_pragma] = STATE(3069),
    [sym_preproc_nullable] = STATE(3069),
    [sym_preproc_error] = STATE(3069),
    [sym_preproc_warning] = STATE(3069),
    [sym_preproc_define] = STATE(3069),
    [sym_preproc_undef] = STATE(3069),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5167),
    [anon_sym_COLON] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RBRACK] = ACTIONS(5167),
    [anon_sym_LPAREN] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_in] = ACTIONS(5169),
    [anon_sym_where] = ACTIONS(5167),
    [anon_sym_QMARK] = ACTIONS(5169),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS_PLUS] = ACTIONS(5167),
    [anon_sym_DASH_DASH] = ACTIONS(5167),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5167),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5167),
    [anon_sym_CARET] = ACTIONS(5167),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5167),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_GT_GT_GT] = ACTIONS(5167),
    [anon_sym_EQ_EQ] = ACTIONS(5167),
    [anon_sym_BANG_EQ] = ACTIONS(5167),
    [anon_sym_GT_EQ] = ACTIONS(5167),
    [anon_sym_LT_EQ] = ACTIONS(5167),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_EQ_GT] = ACTIONS(5167),
    [anon_sym_switch] = ACTIONS(5167),
    [anon_sym_DOT_DOT] = ACTIONS(5167),
    [anon_sym_and] = ACTIONS(5167),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_QMARK_QMARK] = ACTIONS(5167),
    [anon_sym_from] = ACTIONS(5167),
    [anon_sym_into] = ACTIONS(5167),
    [anon_sym_join] = ACTIONS(5167),
    [anon_sym_on] = ACTIONS(5167),
    [anon_sym_equals] = ACTIONS(5167),
    [anon_sym_let] = ACTIONS(5167),
    [anon_sym_orderby] = ACTIONS(5167),
    [anon_sym_group] = ACTIONS(5167),
    [anon_sym_by] = ACTIONS(5167),
    [anon_sym_select] = ACTIONS(5167),
    [anon_sym_as] = ACTIONS(5167),
    [anon_sym_is] = ACTIONS(5167),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5167),
    [aux_sym_preproc_if_token3] = ACTIONS(5167),
    [aux_sym_preproc_else_token1] = ACTIONS(5167),
    [aux_sym_preproc_elif_token1] = ACTIONS(5167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3070] = {
    [sym_preproc_region] = STATE(3070),
    [sym_preproc_endregion] = STATE(3070),
    [sym_preproc_line] = STATE(3070),
    [sym_preproc_pragma] = STATE(3070),
    [sym_preproc_nullable] = STATE(3070),
    [sym_preproc_error] = STATE(3070),
    [sym_preproc_warning] = STATE(3070),
    [sym_preproc_define] = STATE(3070),
    [sym_preproc_undef] = STATE(3070),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4898),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4898),
    [anon_sym_CARET] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4898),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3071] = {
    [sym_preproc_region] = STATE(3071),
    [sym_preproc_endregion] = STATE(3071),
    [sym_preproc_line] = STATE(3071),
    [sym_preproc_pragma] = STATE(3071),
    [sym_preproc_nullable] = STATE(3071),
    [sym_preproc_error] = STATE(3071),
    [sym_preproc_warning] = STATE(3071),
    [sym_preproc_define] = STATE(3071),
    [sym_preproc_undef] = STATE(3071),
    [anon_sym_SEMI] = ACTIONS(5171),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5171),
    [anon_sym_COMMA] = ACTIONS(5171),
    [anon_sym_RBRACK] = ACTIONS(5171),
    [anon_sym_LPAREN] = ACTIONS(5171),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5173),
    [anon_sym_in] = ACTIONS(5173),
    [anon_sym_where] = ACTIONS(5171),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5173),
    [anon_sym_PERCENT] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5173),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5173),
    [anon_sym_GT_GT_GT] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5171),
    [anon_sym_BANG_EQ] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5171),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_DOT] = ACTIONS(5173),
    [anon_sym_EQ_GT] = ACTIONS(5171),
    [anon_sym_switch] = ACTIONS(5171),
    [anon_sym_DOT_DOT] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_or] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5171),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_QMARK_QMARK] = ACTIONS(5171),
    [anon_sym_from] = ACTIONS(5171),
    [anon_sym_into] = ACTIONS(5171),
    [anon_sym_join] = ACTIONS(5171),
    [anon_sym_on] = ACTIONS(5171),
    [anon_sym_equals] = ACTIONS(5171),
    [anon_sym_let] = ACTIONS(5171),
    [anon_sym_orderby] = ACTIONS(5171),
    [anon_sym_group] = ACTIONS(5171),
    [anon_sym_by] = ACTIONS(5171),
    [anon_sym_select] = ACTIONS(5171),
    [anon_sym_as] = ACTIONS(5171),
    [anon_sym_is] = ACTIONS(5171),
    [anon_sym_DASH_GT] = ACTIONS(5171),
    [anon_sym_with] = ACTIONS(5171),
    [aux_sym_preproc_if_token3] = ACTIONS(5171),
    [aux_sym_preproc_else_token1] = ACTIONS(5171),
    [aux_sym_preproc_elif_token1] = ACTIONS(5171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3072] = {
    [sym_preproc_region] = STATE(3072),
    [sym_preproc_endregion] = STATE(3072),
    [sym_preproc_line] = STATE(3072),
    [sym_preproc_pragma] = STATE(3072),
    [sym_preproc_nullable] = STATE(3072),
    [sym_preproc_error] = STATE(3072),
    [sym_preproc_warning] = STATE(3072),
    [sym_preproc_define] = STATE(3072),
    [sym_preproc_undef] = STATE(3072),
    [anon_sym_SEMI] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3722),
    [anon_sym_where] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3722),
    [anon_sym_DASH_DASH] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_GT_GT_GT] = ACTIONS(3722),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_GT_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_switch] = ACTIONS(3722),
    [anon_sym_DOT_DOT] = ACTIONS(3722),
    [anon_sym_and] = ACTIONS(3722),
    [anon_sym_or] = ACTIONS(3711),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_QMARK_QMARK] = ACTIONS(3722),
    [anon_sym_from] = ACTIONS(3722),
    [anon_sym_join] = ACTIONS(3722),
    [anon_sym_on] = ACTIONS(3722),
    [anon_sym_equals] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_orderby] = ACTIONS(3722),
    [anon_sym_group] = ACTIONS(3722),
    [anon_sym_by] = ACTIONS(3722),
    [anon_sym_select] = ACTIONS(3722),
    [anon_sym_as] = ACTIONS(3722),
    [anon_sym_is] = ACTIONS(3722),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_with] = ACTIONS(3722),
    [aux_sym_preproc_if_token3] = ACTIONS(3722),
    [aux_sym_preproc_else_token1] = ACTIONS(3722),
    [aux_sym_preproc_elif_token1] = ACTIONS(3722),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3073] = {
    [sym_preproc_region] = STATE(3073),
    [sym_preproc_endregion] = STATE(3073),
    [sym_preproc_line] = STATE(3073),
    [sym_preproc_pragma] = STATE(3073),
    [sym_preproc_nullable] = STATE(3073),
    [sym_preproc_error] = STATE(3073),
    [sym_preproc_warning] = STATE(3073),
    [sym_preproc_define] = STATE(3073),
    [sym_preproc_undef] = STATE(3073),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_in] = ACTIONS(4054),
    [anon_sym_where] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4052),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [anon_sym_switch] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_QMARK_QMARK] = ACTIONS(4054),
    [anon_sym_from] = ACTIONS(4054),
    [anon_sym_join] = ACTIONS(4054),
    [anon_sym_on] = ACTIONS(4054),
    [anon_sym_equals] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_orderby] = ACTIONS(4054),
    [anon_sym_group] = ACTIONS(4054),
    [anon_sym_by] = ACTIONS(4054),
    [anon_sym_select] = ACTIONS(4054),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_is] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [aux_sym_preproc_if_token3] = ACTIONS(4054),
    [aux_sym_preproc_else_token1] = ACTIONS(4054),
    [aux_sym_preproc_elif_token1] = ACTIONS(4054),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3074] = {
    [sym_preproc_region] = STATE(3074),
    [sym_preproc_endregion] = STATE(3074),
    [sym_preproc_line] = STATE(3074),
    [sym_preproc_pragma] = STATE(3074),
    [sym_preproc_nullable] = STATE(3074),
    [sym_preproc_error] = STATE(3074),
    [sym_preproc_warning] = STATE(3074),
    [sym_preproc_define] = STATE(3074),
    [sym_preproc_undef] = STATE(3074),
    [anon_sym_SEMI] = ACTIONS(5175),
    [anon_sym_LBRACK] = ACTIONS(5175),
    [anon_sym_COLON] = ACTIONS(5175),
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_RBRACK] = ACTIONS(5175),
    [anon_sym_LPAREN] = ACTIONS(5175),
    [anon_sym_RPAREN] = ACTIONS(5175),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_LT] = ACTIONS(5177),
    [anon_sym_GT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5177),
    [anon_sym_where] = ACTIONS(5175),
    [anon_sym_QMARK] = ACTIONS(5177),
    [anon_sym_BANG] = ACTIONS(5177),
    [anon_sym_PLUS_PLUS] = ACTIONS(5175),
    [anon_sym_DASH_DASH] = ACTIONS(5175),
    [anon_sym_PLUS] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5175),
    [anon_sym_SLASH] = ACTIONS(5177),
    [anon_sym_PERCENT] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5175),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5175),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_GT_GT_GT] = ACTIONS(5175),
    [anon_sym_EQ_EQ] = ACTIONS(5175),
    [anon_sym_BANG_EQ] = ACTIONS(5175),
    [anon_sym_GT_EQ] = ACTIONS(5175),
    [anon_sym_LT_EQ] = ACTIONS(5175),
    [anon_sym_DOT] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5175),
    [anon_sym_switch] = ACTIONS(5175),
    [anon_sym_DOT_DOT] = ACTIONS(5175),
    [anon_sym_and] = ACTIONS(5175),
    [anon_sym_or] = ACTIONS(5177),
    [anon_sym_AMP_AMP] = ACTIONS(5175),
    [anon_sym_PIPE_PIPE] = ACTIONS(5175),
    [anon_sym_QMARK_QMARK] = ACTIONS(5175),
    [anon_sym_from] = ACTIONS(5175),
    [anon_sym_into] = ACTIONS(5175),
    [anon_sym_join] = ACTIONS(5175),
    [anon_sym_on] = ACTIONS(5175),
    [anon_sym_equals] = ACTIONS(5175),
    [anon_sym_let] = ACTIONS(5175),
    [anon_sym_orderby] = ACTIONS(5175),
    [anon_sym_group] = ACTIONS(5175),
    [anon_sym_by] = ACTIONS(5175),
    [anon_sym_select] = ACTIONS(5175),
    [anon_sym_as] = ACTIONS(5175),
    [anon_sym_is] = ACTIONS(5175),
    [anon_sym_DASH_GT] = ACTIONS(5175),
    [anon_sym_with] = ACTIONS(5175),
    [aux_sym_preproc_if_token3] = ACTIONS(5175),
    [aux_sym_preproc_else_token1] = ACTIONS(5175),
    [aux_sym_preproc_elif_token1] = ACTIONS(5175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3075] = {
    [sym_preproc_region] = STATE(3075),
    [sym_preproc_endregion] = STATE(3075),
    [sym_preproc_line] = STATE(3075),
    [sym_preproc_pragma] = STATE(3075),
    [sym_preproc_nullable] = STATE(3075),
    [sym_preproc_error] = STATE(3075),
    [sym_preproc_warning] = STATE(3075),
    [sym_preproc_define] = STATE(3075),
    [sym_preproc_undef] = STATE(3075),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_RBRACK] = ACTIONS(5179),
    [anon_sym_LPAREN] = ACTIONS(5179),
    [anon_sym_RPAREN] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_in] = ACTIONS(5181),
    [anon_sym_where] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_BANG] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5181),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5181),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_GT_GT_GT] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_DOT] = ACTIONS(5181),
    [anon_sym_EQ_GT] = ACTIONS(5179),
    [anon_sym_switch] = ACTIONS(5179),
    [anon_sym_DOT_DOT] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5179),
    [anon_sym_QMARK_QMARK] = ACTIONS(5179),
    [anon_sym_from] = ACTIONS(5179),
    [anon_sym_into] = ACTIONS(5179),
    [anon_sym_join] = ACTIONS(5179),
    [anon_sym_on] = ACTIONS(5179),
    [anon_sym_equals] = ACTIONS(5179),
    [anon_sym_let] = ACTIONS(5179),
    [anon_sym_orderby] = ACTIONS(5179),
    [anon_sym_group] = ACTIONS(5179),
    [anon_sym_by] = ACTIONS(5179),
    [anon_sym_select] = ACTIONS(5179),
    [anon_sym_as] = ACTIONS(5179),
    [anon_sym_is] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5179),
    [anon_sym_with] = ACTIONS(5179),
    [aux_sym_preproc_if_token3] = ACTIONS(5179),
    [aux_sym_preproc_else_token1] = ACTIONS(5179),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3076] = {
    [sym_preproc_region] = STATE(3076),
    [sym_preproc_endregion] = STATE(3076),
    [sym_preproc_line] = STATE(3076),
    [sym_preproc_pragma] = STATE(3076),
    [sym_preproc_nullable] = STATE(3076),
    [sym_preproc_error] = STATE(3076),
    [sym_preproc_warning] = STATE(3076),
    [sym_preproc_define] = STATE(3076),
    [sym_preproc_undef] = STATE(3076),
    [anon_sym_SEMI] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(5183),
    [anon_sym_COLON] = ACTIONS(5183),
    [anon_sym_COMMA] = ACTIONS(5183),
    [anon_sym_RBRACK] = ACTIONS(5183),
    [anon_sym_LPAREN] = ACTIONS(5183),
    [anon_sym_RPAREN] = ACTIONS(5183),
    [anon_sym_RBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_where] = ACTIONS(5183),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_BANG] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5183),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_GT_GT_GT] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5183),
    [anon_sym_BANG_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_EQ_GT] = ACTIONS(5183),
    [anon_sym_switch] = ACTIONS(5183),
    [anon_sym_DOT_DOT] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE] = ACTIONS(5183),
    [anon_sym_QMARK_QMARK] = ACTIONS(5183),
    [anon_sym_from] = ACTIONS(5183),
    [anon_sym_into] = ACTIONS(5183),
    [anon_sym_join] = ACTIONS(5183),
    [anon_sym_on] = ACTIONS(5183),
    [anon_sym_equals] = ACTIONS(5183),
    [anon_sym_let] = ACTIONS(5183),
    [anon_sym_orderby] = ACTIONS(5183),
    [anon_sym_group] = ACTIONS(5183),
    [anon_sym_by] = ACTIONS(5183),
    [anon_sym_select] = ACTIONS(5183),
    [anon_sym_as] = ACTIONS(5183),
    [anon_sym_is] = ACTIONS(5183),
    [anon_sym_DASH_GT] = ACTIONS(5183),
    [anon_sym_with] = ACTIONS(5183),
    [aux_sym_preproc_if_token3] = ACTIONS(5183),
    [aux_sym_preproc_else_token1] = ACTIONS(5183),
    [aux_sym_preproc_elif_token1] = ACTIONS(5183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3077] = {
    [sym_preproc_region] = STATE(3077),
    [sym_preproc_endregion] = STATE(3077),
    [sym_preproc_line] = STATE(3077),
    [sym_preproc_pragma] = STATE(3077),
    [sym_preproc_nullable] = STATE(3077),
    [sym_preproc_error] = STATE(3077),
    [sym_preproc_warning] = STATE(3077),
    [sym_preproc_define] = STATE(3077),
    [sym_preproc_undef] = STATE(3077),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_in] = ACTIONS(4108),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4106),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4106),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4108),
    [aux_sym_preproc_else_token1] = ACTIONS(4108),
    [aux_sym_preproc_elif_token1] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3078] = {
    [sym_preproc_region] = STATE(3078),
    [sym_preproc_endregion] = STATE(3078),
    [sym_preproc_line] = STATE(3078),
    [sym_preproc_pragma] = STATE(3078),
    [sym_preproc_nullable] = STATE(3078),
    [sym_preproc_error] = STATE(3078),
    [sym_preproc_warning] = STATE(3078),
    [sym_preproc_define] = STATE(3078),
    [sym_preproc_undef] = STATE(3078),
    [anon_sym_SEMI] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_COLON] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RBRACK] = ACTIONS(5187),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5189),
    [anon_sym_where] = ACTIONS(5187),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5187),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5187),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT_EQ] = ACTIONS(5187),
    [anon_sym_LT_EQ] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5187),
    [anon_sym_switch] = ACTIONS(5187),
    [anon_sym_DOT_DOT] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_QMARK_QMARK] = ACTIONS(5187),
    [anon_sym_from] = ACTIONS(5187),
    [anon_sym_into] = ACTIONS(5187),
    [anon_sym_join] = ACTIONS(5187),
    [anon_sym_on] = ACTIONS(5187),
    [anon_sym_equals] = ACTIONS(5187),
    [anon_sym_let] = ACTIONS(5187),
    [anon_sym_orderby] = ACTIONS(5187),
    [anon_sym_group] = ACTIONS(5187),
    [anon_sym_by] = ACTIONS(5187),
    [anon_sym_select] = ACTIONS(5187),
    [anon_sym_as] = ACTIONS(5187),
    [anon_sym_is] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [anon_sym_with] = ACTIONS(5187),
    [aux_sym_preproc_if_token3] = ACTIONS(5187),
    [aux_sym_preproc_else_token1] = ACTIONS(5187),
    [aux_sym_preproc_elif_token1] = ACTIONS(5187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3079] = {
    [sym_preproc_region] = STATE(3079),
    [sym_preproc_endregion] = STATE(3079),
    [sym_preproc_line] = STATE(3079),
    [sym_preproc_pragma] = STATE(3079),
    [sym_preproc_nullable] = STATE(3079),
    [sym_preproc_error] = STATE(3079),
    [sym_preproc_warning] = STATE(3079),
    [sym_preproc_define] = STATE(3079),
    [sym_preproc_undef] = STATE(3079),
    [anon_sym_SEMI] = ACTIONS(5191),
    [anon_sym_LBRACK] = ACTIONS(5191),
    [anon_sym_COLON] = ACTIONS(5191),
    [anon_sym_COMMA] = ACTIONS(5191),
    [anon_sym_RBRACK] = ACTIONS(5191),
    [anon_sym_LPAREN] = ACTIONS(5191),
    [anon_sym_RPAREN] = ACTIONS(5191),
    [anon_sym_RBRACE] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_in] = ACTIONS(5193),
    [anon_sym_where] = ACTIONS(5191),
    [anon_sym_QMARK] = ACTIONS(5193),
    [anon_sym_BANG] = ACTIONS(5193),
    [anon_sym_PLUS_PLUS] = ACTIONS(5191),
    [anon_sym_DASH_DASH] = ACTIONS(5191),
    [anon_sym_PLUS] = ACTIONS(5193),
    [anon_sym_DASH] = ACTIONS(5193),
    [anon_sym_STAR] = ACTIONS(5191),
    [anon_sym_SLASH] = ACTIONS(5193),
    [anon_sym_PERCENT] = ACTIONS(5191),
    [anon_sym_CARET] = ACTIONS(5191),
    [anon_sym_PIPE] = ACTIONS(5193),
    [anon_sym_AMP] = ACTIONS(5193),
    [anon_sym_LT_LT] = ACTIONS(5191),
    [anon_sym_GT_GT] = ACTIONS(5193),
    [anon_sym_GT_GT_GT] = ACTIONS(5191),
    [anon_sym_EQ_EQ] = ACTIONS(5191),
    [anon_sym_BANG_EQ] = ACTIONS(5191),
    [anon_sym_GT_EQ] = ACTIONS(5191),
    [anon_sym_LT_EQ] = ACTIONS(5191),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_EQ_GT] = ACTIONS(5191),
    [anon_sym_switch] = ACTIONS(5191),
    [anon_sym_DOT_DOT] = ACTIONS(5191),
    [anon_sym_and] = ACTIONS(5191),
    [anon_sym_or] = ACTIONS(5193),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_PIPE_PIPE] = ACTIONS(5191),
    [anon_sym_QMARK_QMARK] = ACTIONS(5191),
    [anon_sym_from] = ACTIONS(5191),
    [anon_sym_into] = ACTIONS(5191),
    [anon_sym_join] = ACTIONS(5191),
    [anon_sym_on] = ACTIONS(5191),
    [anon_sym_equals] = ACTIONS(5191),
    [anon_sym_let] = ACTIONS(5191),
    [anon_sym_orderby] = ACTIONS(5191),
    [anon_sym_group] = ACTIONS(5191),
    [anon_sym_by] = ACTIONS(5191),
    [anon_sym_select] = ACTIONS(5191),
    [anon_sym_as] = ACTIONS(5191),
    [anon_sym_is] = ACTIONS(5191),
    [anon_sym_DASH_GT] = ACTIONS(5191),
    [anon_sym_with] = ACTIONS(5191),
    [aux_sym_preproc_if_token3] = ACTIONS(5191),
    [aux_sym_preproc_else_token1] = ACTIONS(5191),
    [aux_sym_preproc_elif_token1] = ACTIONS(5191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3080] = {
    [sym_preproc_region] = STATE(3080),
    [sym_preproc_endregion] = STATE(3080),
    [sym_preproc_line] = STATE(3080),
    [sym_preproc_pragma] = STATE(3080),
    [sym_preproc_nullable] = STATE(3080),
    [sym_preproc_error] = STATE(3080),
    [sym_preproc_warning] = STATE(3080),
    [sym_preproc_define] = STATE(3080),
    [sym_preproc_undef] = STATE(3080),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_extern] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_unsafe] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(3787),
    [anon_sym_event] = ACTIONS(3785),
    [anon_sym_class] = ACTIONS(3785),
    [anon_sym_ref] = ACTIONS(3785),
    [anon_sym_struct] = ACTIONS(3785),
    [anon_sym_enum] = ACTIONS(3785),
    [anon_sym_interface] = ACTIONS(3785),
    [anon_sym_delegate] = ACTIONS(3785),
    [anon_sym_record] = ACTIONS(3785),
    [anon_sym_abstract] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_const] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_fixed] = ACTIONS(3785),
    [anon_sym_internal] = ACTIONS(3785),
    [anon_sym_new] = ACTIONS(3785),
    [anon_sym_override] = ACTIONS(3785),
    [anon_sym_partial] = ACTIONS(3785),
    [anon_sym_private] = ACTIONS(3785),
    [anon_sym_protected] = ACTIONS(3785),
    [anon_sym_public] = ACTIONS(3785),
    [anon_sym_readonly] = ACTIONS(3785),
    [anon_sym_required] = ACTIONS(3785),
    [anon_sym_sealed] = ACTIONS(3785),
    [anon_sym_virtual] = ACTIONS(3785),
    [anon_sym_volatile] = ACTIONS(3785),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3787),
    [anon_sym_implicit] = ACTIONS(3785),
    [anon_sym_explicit] = ACTIONS(3785),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_var] = ACTIONS(3785),
    [sym_predefined_type] = ACTIONS(3785),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3081] = {
    [sym_preproc_region] = STATE(3081),
    [sym_preproc_endregion] = STATE(3081),
    [sym_preproc_line] = STATE(3081),
    [sym_preproc_pragma] = STATE(3081),
    [sym_preproc_nullable] = STATE(3081),
    [sym_preproc_error] = STATE(3081),
    [sym_preproc_warning] = STATE(3081),
    [sym_preproc_define] = STATE(3081),
    [sym_preproc_undef] = STATE(3081),
    [anon_sym_SEMI] = ACTIONS(5195),
    [anon_sym_LBRACK] = ACTIONS(5195),
    [anon_sym_COLON] = ACTIONS(5195),
    [anon_sym_COMMA] = ACTIONS(5195),
    [anon_sym_RBRACK] = ACTIONS(5195),
    [anon_sym_LPAREN] = ACTIONS(5195),
    [anon_sym_RPAREN] = ACTIONS(5195),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_in] = ACTIONS(5197),
    [anon_sym_where] = ACTIONS(5195),
    [anon_sym_QMARK] = ACTIONS(5197),
    [anon_sym_BANG] = ACTIONS(5197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5195),
    [anon_sym_DASH_DASH] = ACTIONS(5195),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5195),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5195),
    [anon_sym_CARET] = ACTIONS(5195),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5195),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_GT_GT_GT] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_EQ_GT] = ACTIONS(5195),
    [anon_sym_switch] = ACTIONS(5195),
    [anon_sym_DOT_DOT] = ACTIONS(5195),
    [anon_sym_and] = ACTIONS(5195),
    [anon_sym_or] = ACTIONS(5197),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_QMARK_QMARK] = ACTIONS(5195),
    [anon_sym_from] = ACTIONS(5195),
    [anon_sym_into] = ACTIONS(5195),
    [anon_sym_join] = ACTIONS(5195),
    [anon_sym_on] = ACTIONS(5195),
    [anon_sym_equals] = ACTIONS(5195),
    [anon_sym_let] = ACTIONS(5195),
    [anon_sym_orderby] = ACTIONS(5195),
    [anon_sym_group] = ACTIONS(5195),
    [anon_sym_by] = ACTIONS(5195),
    [anon_sym_select] = ACTIONS(5195),
    [anon_sym_as] = ACTIONS(5195),
    [anon_sym_is] = ACTIONS(5195),
    [anon_sym_DASH_GT] = ACTIONS(5195),
    [anon_sym_with] = ACTIONS(5195),
    [aux_sym_preproc_if_token3] = ACTIONS(5195),
    [aux_sym_preproc_else_token1] = ACTIONS(5195),
    [aux_sym_preproc_elif_token1] = ACTIONS(5195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3082] = {
    [sym_preproc_region] = STATE(3082),
    [sym_preproc_endregion] = STATE(3082),
    [sym_preproc_line] = STATE(3082),
    [sym_preproc_pragma] = STATE(3082),
    [sym_preproc_nullable] = STATE(3082),
    [sym_preproc_error] = STATE(3082),
    [sym_preproc_warning] = STATE(3082),
    [sym_preproc_define] = STATE(3082),
    [sym_preproc_undef] = STATE(3082),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3083] = {
    [sym_preproc_region] = STATE(3083),
    [sym_preproc_endregion] = STATE(3083),
    [sym_preproc_line] = STATE(3083),
    [sym_preproc_pragma] = STATE(3083),
    [sym_preproc_nullable] = STATE(3083),
    [sym_preproc_error] = STATE(3083),
    [sym_preproc_warning] = STATE(3083),
    [sym_preproc_define] = STATE(3083),
    [sym_preproc_undef] = STATE(3083),
    [anon_sym_SEMI] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_COLON] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RBRACK] = ACTIONS(5199),
    [anon_sym_LPAREN] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_LT] = ACTIONS(5201),
    [anon_sym_GT] = ACTIONS(5201),
    [anon_sym_in] = ACTIONS(5201),
    [anon_sym_where] = ACTIONS(5199),
    [anon_sym_QMARK] = ACTIONS(5201),
    [anon_sym_BANG] = ACTIONS(5201),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_STAR] = ACTIONS(5199),
    [anon_sym_SLASH] = ACTIONS(5201),
    [anon_sym_PERCENT] = ACTIONS(5199),
    [anon_sym_CARET] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5201),
    [anon_sym_AMP] = ACTIONS(5201),
    [anon_sym_LT_LT] = ACTIONS(5199),
    [anon_sym_GT_GT] = ACTIONS(5201),
    [anon_sym_GT_GT_GT] = ACTIONS(5199),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5201),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_switch] = ACTIONS(5199),
    [anon_sym_DOT_DOT] = ACTIONS(5199),
    [anon_sym_and] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5201),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_QMARK_QMARK] = ACTIONS(5199),
    [anon_sym_from] = ACTIONS(5199),
    [anon_sym_into] = ACTIONS(5199),
    [anon_sym_join] = ACTIONS(5199),
    [anon_sym_on] = ACTIONS(5199),
    [anon_sym_equals] = ACTIONS(5199),
    [anon_sym_let] = ACTIONS(5199),
    [anon_sym_orderby] = ACTIONS(5199),
    [anon_sym_group] = ACTIONS(5199),
    [anon_sym_by] = ACTIONS(5199),
    [anon_sym_select] = ACTIONS(5199),
    [anon_sym_as] = ACTIONS(5199),
    [anon_sym_is] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_with] = ACTIONS(5199),
    [aux_sym_preproc_if_token3] = ACTIONS(5199),
    [aux_sym_preproc_else_token1] = ACTIONS(5199),
    [aux_sym_preproc_elif_token1] = ACTIONS(5199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3084] = {
    [sym_preproc_region] = STATE(3084),
    [sym_preproc_endregion] = STATE(3084),
    [sym_preproc_line] = STATE(3084),
    [sym_preproc_pragma] = STATE(3084),
    [sym_preproc_nullable] = STATE(3084),
    [sym_preproc_error] = STATE(3084),
    [sym_preproc_warning] = STATE(3084),
    [sym_preproc_define] = STATE(3084),
    [sym_preproc_undef] = STATE(3084),
    [anon_sym_SEMI] = ACTIONS(5203),
    [anon_sym_LBRACK] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_COMMA] = ACTIONS(5203),
    [anon_sym_RBRACK] = ACTIONS(5203),
    [anon_sym_LPAREN] = ACTIONS(5203),
    [anon_sym_RPAREN] = ACTIONS(5203),
    [anon_sym_RBRACE] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5205),
    [anon_sym_in] = ACTIONS(5205),
    [anon_sym_where] = ACTIONS(5203),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_BANG] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5203),
    [anon_sym_DASH_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5205),
    [anon_sym_STAR] = ACTIONS(5203),
    [anon_sym_SLASH] = ACTIONS(5205),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5203),
    [anon_sym_PIPE] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5205),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5205),
    [anon_sym_GT_GT_GT] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5203),
    [anon_sym_BANG_EQ] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5203),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_DOT] = ACTIONS(5205),
    [anon_sym_EQ_GT] = ACTIONS(5203),
    [anon_sym_switch] = ACTIONS(5203),
    [anon_sym_DOT_DOT] = ACTIONS(5203),
    [anon_sym_and] = ACTIONS(5203),
    [anon_sym_or] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5203),
    [anon_sym_PIPE_PIPE] = ACTIONS(5203),
    [anon_sym_QMARK_QMARK] = ACTIONS(5203),
    [anon_sym_from] = ACTIONS(5203),
    [anon_sym_into] = ACTIONS(5203),
    [anon_sym_join] = ACTIONS(5203),
    [anon_sym_on] = ACTIONS(5203),
    [anon_sym_equals] = ACTIONS(5203),
    [anon_sym_let] = ACTIONS(5203),
    [anon_sym_orderby] = ACTIONS(5203),
    [anon_sym_group] = ACTIONS(5203),
    [anon_sym_by] = ACTIONS(5203),
    [anon_sym_select] = ACTIONS(5203),
    [anon_sym_as] = ACTIONS(5203),
    [anon_sym_is] = ACTIONS(5203),
    [anon_sym_DASH_GT] = ACTIONS(5203),
    [anon_sym_with] = ACTIONS(5203),
    [aux_sym_preproc_if_token3] = ACTIONS(5203),
    [aux_sym_preproc_else_token1] = ACTIONS(5203),
    [aux_sym_preproc_elif_token1] = ACTIONS(5203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3085] = {
    [sym_preproc_region] = STATE(3085),
    [sym_preproc_endregion] = STATE(3085),
    [sym_preproc_line] = STATE(3085),
    [sym_preproc_pragma] = STATE(3085),
    [sym_preproc_nullable] = STATE(3085),
    [sym_preproc_error] = STATE(3085),
    [sym_preproc_warning] = STATE(3085),
    [sym_preproc_define] = STATE(3085),
    [sym_preproc_undef] = STATE(3085),
    [anon_sym_SEMI] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5207),
    [anon_sym_COLON] = ACTIONS(5207),
    [anon_sym_COMMA] = ACTIONS(5207),
    [anon_sym_RBRACK] = ACTIONS(5207),
    [anon_sym_LPAREN] = ACTIONS(5207),
    [anon_sym_RPAREN] = ACTIONS(5207),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_GT] = ACTIONS(5209),
    [anon_sym_in] = ACTIONS(5209),
    [anon_sym_where] = ACTIONS(5207),
    [anon_sym_QMARK] = ACTIONS(5209),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_PLUS_PLUS] = ACTIONS(5207),
    [anon_sym_DASH_DASH] = ACTIONS(5207),
    [anon_sym_PLUS] = ACTIONS(5209),
    [anon_sym_DASH] = ACTIONS(5209),
    [anon_sym_STAR] = ACTIONS(5207),
    [anon_sym_SLASH] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5207),
    [anon_sym_CARET] = ACTIONS(5207),
    [anon_sym_PIPE] = ACTIONS(5209),
    [anon_sym_AMP] = ACTIONS(5209),
    [anon_sym_LT_LT] = ACTIONS(5207),
    [anon_sym_GT_GT] = ACTIONS(5209),
    [anon_sym_GT_GT_GT] = ACTIONS(5207),
    [anon_sym_EQ_EQ] = ACTIONS(5207),
    [anon_sym_BANG_EQ] = ACTIONS(5207),
    [anon_sym_GT_EQ] = ACTIONS(5207),
    [anon_sym_LT_EQ] = ACTIONS(5207),
    [anon_sym_DOT] = ACTIONS(5209),
    [anon_sym_EQ_GT] = ACTIONS(5207),
    [anon_sym_switch] = ACTIONS(5207),
    [anon_sym_DOT_DOT] = ACTIONS(5207),
    [anon_sym_and] = ACTIONS(5207),
    [anon_sym_or] = ACTIONS(5209),
    [anon_sym_AMP_AMP] = ACTIONS(5207),
    [anon_sym_PIPE_PIPE] = ACTIONS(5207),
    [anon_sym_QMARK_QMARK] = ACTIONS(5207),
    [anon_sym_from] = ACTIONS(5207),
    [anon_sym_into] = ACTIONS(5207),
    [anon_sym_join] = ACTIONS(5207),
    [anon_sym_on] = ACTIONS(5207),
    [anon_sym_equals] = ACTIONS(5207),
    [anon_sym_let] = ACTIONS(5207),
    [anon_sym_orderby] = ACTIONS(5207),
    [anon_sym_group] = ACTIONS(5207),
    [anon_sym_by] = ACTIONS(5207),
    [anon_sym_select] = ACTIONS(5207),
    [anon_sym_as] = ACTIONS(5207),
    [anon_sym_is] = ACTIONS(5207),
    [anon_sym_DASH_GT] = ACTIONS(5207),
    [anon_sym_with] = ACTIONS(5207),
    [aux_sym_preproc_if_token3] = ACTIONS(5207),
    [aux_sym_preproc_else_token1] = ACTIONS(5207),
    [aux_sym_preproc_elif_token1] = ACTIONS(5207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3086] = {
    [sym_preproc_region] = STATE(3086),
    [sym_preproc_endregion] = STATE(3086),
    [sym_preproc_line] = STATE(3086),
    [sym_preproc_pragma] = STATE(3086),
    [sym_preproc_nullable] = STATE(3086),
    [sym_preproc_error] = STATE(3086),
    [sym_preproc_warning] = STATE(3086),
    [sym_preproc_define] = STATE(3086),
    [sym_preproc_undef] = STATE(3086),
    [anon_sym_SEMI] = ACTIONS(5211),
    [anon_sym_LBRACK] = ACTIONS(5211),
    [anon_sym_COLON] = ACTIONS(5211),
    [anon_sym_COMMA] = ACTIONS(5211),
    [anon_sym_RBRACK] = ACTIONS(5211),
    [anon_sym_LPAREN] = ACTIONS(5211),
    [anon_sym_RPAREN] = ACTIONS(5211),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [anon_sym_LT] = ACTIONS(5213),
    [anon_sym_GT] = ACTIONS(5213),
    [anon_sym_in] = ACTIONS(5213),
    [anon_sym_where] = ACTIONS(5211),
    [anon_sym_QMARK] = ACTIONS(5213),
    [anon_sym_BANG] = ACTIONS(5213),
    [anon_sym_PLUS_PLUS] = ACTIONS(5211),
    [anon_sym_DASH_DASH] = ACTIONS(5211),
    [anon_sym_PLUS] = ACTIONS(5213),
    [anon_sym_DASH] = ACTIONS(5213),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_SLASH] = ACTIONS(5213),
    [anon_sym_PERCENT] = ACTIONS(5211),
    [anon_sym_CARET] = ACTIONS(5211),
    [anon_sym_PIPE] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5211),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_GT_GT_GT] = ACTIONS(5211),
    [anon_sym_EQ_EQ] = ACTIONS(5211),
    [anon_sym_BANG_EQ] = ACTIONS(5211),
    [anon_sym_GT_EQ] = ACTIONS(5211),
    [anon_sym_LT_EQ] = ACTIONS(5211),
    [anon_sym_DOT] = ACTIONS(5213),
    [anon_sym_EQ_GT] = ACTIONS(5211),
    [anon_sym_switch] = ACTIONS(5211),
    [anon_sym_DOT_DOT] = ACTIONS(5211),
    [anon_sym_and] = ACTIONS(5211),
    [anon_sym_or] = ACTIONS(5213),
    [anon_sym_AMP_AMP] = ACTIONS(5211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5211),
    [anon_sym_QMARK_QMARK] = ACTIONS(5211),
    [anon_sym_from] = ACTIONS(5211),
    [anon_sym_into] = ACTIONS(5211),
    [anon_sym_join] = ACTIONS(5211),
    [anon_sym_on] = ACTIONS(5211),
    [anon_sym_equals] = ACTIONS(5211),
    [anon_sym_let] = ACTIONS(5211),
    [anon_sym_orderby] = ACTIONS(5211),
    [anon_sym_group] = ACTIONS(5211),
    [anon_sym_by] = ACTIONS(5211),
    [anon_sym_select] = ACTIONS(5211),
    [anon_sym_as] = ACTIONS(5211),
    [anon_sym_is] = ACTIONS(5211),
    [anon_sym_DASH_GT] = ACTIONS(5211),
    [anon_sym_with] = ACTIONS(5211),
    [aux_sym_preproc_if_token3] = ACTIONS(5211),
    [aux_sym_preproc_else_token1] = ACTIONS(5211),
    [aux_sym_preproc_elif_token1] = ACTIONS(5211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3087] = {
    [sym_preproc_region] = STATE(3087),
    [sym_preproc_endregion] = STATE(3087),
    [sym_preproc_line] = STATE(3087),
    [sym_preproc_pragma] = STATE(3087),
    [sym_preproc_nullable] = STATE(3087),
    [sym_preproc_error] = STATE(3087),
    [sym_preproc_warning] = STATE(3087),
    [sym_preproc_define] = STATE(3087),
    [sym_preproc_undef] = STATE(3087),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(2983),
    [anon_sym_into] = ACTIONS(2983),
    [anon_sym_join] = ACTIONS(2983),
    [anon_sym_on] = ACTIONS(2983),
    [anon_sym_equals] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_orderby] = ACTIONS(2983),
    [anon_sym_group] = ACTIONS(2983),
    [anon_sym_by] = ACTIONS(2983),
    [anon_sym_select] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_is] = ACTIONS(2983),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [aux_sym_preproc_if_token3] = ACTIONS(2983),
    [aux_sym_preproc_else_token1] = ACTIONS(2983),
    [aux_sym_preproc_elif_token1] = ACTIONS(2983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3088] = {
    [sym_preproc_region] = STATE(3088),
    [sym_preproc_endregion] = STATE(3088),
    [sym_preproc_line] = STATE(3088),
    [sym_preproc_pragma] = STATE(3088),
    [sym_preproc_nullable] = STATE(3088),
    [sym_preproc_error] = STATE(3088),
    [sym_preproc_warning] = STATE(3088),
    [sym_preproc_define] = STATE(3088),
    [sym_preproc_undef] = STATE(3088),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(5215),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3089] = {
    [sym_preproc_region] = STATE(3089),
    [sym_preproc_endregion] = STATE(3089),
    [sym_preproc_line] = STATE(3089),
    [sym_preproc_pragma] = STATE(3089),
    [sym_preproc_nullable] = STATE(3089),
    [sym_preproc_error] = STATE(3089),
    [sym_preproc_warning] = STATE(3089),
    [sym_preproc_define] = STATE(3089),
    [sym_preproc_undef] = STATE(3089),
    [anon_sym_SEMI] = ACTIONS(5218),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [anon_sym_COLON] = ACTIONS(5218),
    [anon_sym_COMMA] = ACTIONS(5218),
    [anon_sym_RBRACK] = ACTIONS(5218),
    [anon_sym_LPAREN] = ACTIONS(5218),
    [anon_sym_RPAREN] = ACTIONS(5218),
    [anon_sym_RBRACE] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5220),
    [anon_sym_in] = ACTIONS(5220),
    [anon_sym_where] = ACTIONS(5218),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_BANG] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5218),
    [anon_sym_DASH_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5220),
    [anon_sym_STAR] = ACTIONS(5218),
    [anon_sym_SLASH] = ACTIONS(5220),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5218),
    [anon_sym_PIPE] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_GT_GT_GT] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5218),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_DOT] = ACTIONS(5220),
    [anon_sym_EQ_GT] = ACTIONS(5218),
    [anon_sym_switch] = ACTIONS(5218),
    [anon_sym_DOT_DOT] = ACTIONS(5218),
    [anon_sym_and] = ACTIONS(5218),
    [anon_sym_or] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_QMARK_QMARK] = ACTIONS(5218),
    [anon_sym_from] = ACTIONS(5218),
    [anon_sym_into] = ACTIONS(5218),
    [anon_sym_join] = ACTIONS(5218),
    [anon_sym_on] = ACTIONS(5218),
    [anon_sym_equals] = ACTIONS(5218),
    [anon_sym_let] = ACTIONS(5218),
    [anon_sym_orderby] = ACTIONS(5218),
    [anon_sym_group] = ACTIONS(5218),
    [anon_sym_by] = ACTIONS(5218),
    [anon_sym_select] = ACTIONS(5218),
    [anon_sym_as] = ACTIONS(5218),
    [anon_sym_is] = ACTIONS(5218),
    [anon_sym_DASH_GT] = ACTIONS(5218),
    [anon_sym_with] = ACTIONS(5218),
    [aux_sym_preproc_if_token3] = ACTIONS(5218),
    [aux_sym_preproc_else_token1] = ACTIONS(5218),
    [aux_sym_preproc_elif_token1] = ACTIONS(5218),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3090] = {
    [sym_preproc_region] = STATE(3090),
    [sym_preproc_endregion] = STATE(3090),
    [sym_preproc_line] = STATE(3090),
    [sym_preproc_pragma] = STATE(3090),
    [sym_preproc_nullable] = STATE(3090),
    [sym_preproc_error] = STATE(3090),
    [sym_preproc_warning] = STATE(3090),
    [sym_preproc_define] = STATE(3090),
    [sym_preproc_undef] = STATE(3090),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3091] = {
    [sym_preproc_region] = STATE(3091),
    [sym_preproc_endregion] = STATE(3091),
    [sym_preproc_line] = STATE(3091),
    [sym_preproc_pragma] = STATE(3091),
    [sym_preproc_nullable] = STATE(3091),
    [sym_preproc_error] = STATE(3091),
    [sym_preproc_warning] = STATE(3091),
    [sym_preproc_define] = STATE(3091),
    [sym_preproc_undef] = STATE(3091),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACK] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [anon_sym_LPAREN] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_in] = ACTIONS(5224),
    [anon_sym_where] = ACTIONS(5222),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_BANG] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_PIPE] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5224),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5224),
    [anon_sym_GT_GT_GT] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5222),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_DOT] = ACTIONS(5224),
    [anon_sym_EQ_GT] = ACTIONS(5222),
    [anon_sym_switch] = ACTIONS(5222),
    [anon_sym_DOT_DOT] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_or] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5222),
    [anon_sym_QMARK_QMARK] = ACTIONS(5222),
    [anon_sym_from] = ACTIONS(5222),
    [anon_sym_into] = ACTIONS(5222),
    [anon_sym_join] = ACTIONS(5222),
    [anon_sym_on] = ACTIONS(5222),
    [anon_sym_equals] = ACTIONS(5222),
    [anon_sym_let] = ACTIONS(5222),
    [anon_sym_orderby] = ACTIONS(5222),
    [anon_sym_group] = ACTIONS(5222),
    [anon_sym_by] = ACTIONS(5222),
    [anon_sym_select] = ACTIONS(5222),
    [anon_sym_as] = ACTIONS(5222),
    [anon_sym_is] = ACTIONS(5222),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [anon_sym_with] = ACTIONS(5222),
    [aux_sym_preproc_if_token3] = ACTIONS(5222),
    [aux_sym_preproc_else_token1] = ACTIONS(5222),
    [aux_sym_preproc_elif_token1] = ACTIONS(5222),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3092] = {
    [sym_preproc_region] = STATE(3092),
    [sym_preproc_endregion] = STATE(3092),
    [sym_preproc_line] = STATE(3092),
    [sym_preproc_pragma] = STATE(3092),
    [sym_preproc_nullable] = STATE(3092),
    [sym_preproc_error] = STATE(3092),
    [sym_preproc_warning] = STATE(3092),
    [sym_preproc_define] = STATE(3092),
    [sym_preproc_undef] = STATE(3092),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5228),
    [anon_sym_in] = ACTIONS(5228),
    [anon_sym_where] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_BANG] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5228),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5228),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_from] = ACTIONS(5226),
    [anon_sym_into] = ACTIONS(5226),
    [anon_sym_join] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_let] = ACTIONS(5226),
    [anon_sym_orderby] = ACTIONS(5226),
    [anon_sym_group] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_select] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3093] = {
    [sym_preproc_region] = STATE(3093),
    [sym_preproc_endregion] = STATE(3093),
    [sym_preproc_line] = STATE(3093),
    [sym_preproc_pragma] = STATE(3093),
    [sym_preproc_nullable] = STATE(3093),
    [sym_preproc_error] = STATE(3093),
    [sym_preproc_warning] = STATE(3093),
    [sym_preproc_define] = STATE(3093),
    [sym_preproc_undef] = STATE(3093),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(5215),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3094] = {
    [sym_preproc_region] = STATE(3094),
    [sym_preproc_endregion] = STATE(3094),
    [sym_preproc_line] = STATE(3094),
    [sym_preproc_pragma] = STATE(3094),
    [sym_preproc_nullable] = STATE(3094),
    [sym_preproc_error] = STATE(3094),
    [sym_preproc_warning] = STATE(3094),
    [sym_preproc_define] = STATE(3094),
    [sym_preproc_undef] = STATE(3094),
    [anon_sym_EQ] = ACTIONS(5230),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5232),
    [anon_sym_DASH_EQ] = ACTIONS(5232),
    [anon_sym_STAR_EQ] = ACTIONS(5232),
    [anon_sym_SLASH_EQ] = ACTIONS(5232),
    [anon_sym_PERCENT_EQ] = ACTIONS(5232),
    [anon_sym_AMP_EQ] = ACTIONS(5232),
    [anon_sym_CARET_EQ] = ACTIONS(5232),
    [anon_sym_PIPE_EQ] = ACTIONS(5232),
    [anon_sym_LT_LT_EQ] = ACTIONS(5232),
    [anon_sym_GT_GT_EQ] = ACTIONS(5232),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5232),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5232),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_ascending] = ACTIONS(4898),
    [anon_sym_descending] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3095] = {
    [sym_preproc_region] = STATE(3095),
    [sym_preproc_endregion] = STATE(3095),
    [sym_preproc_line] = STATE(3095),
    [sym_preproc_pragma] = STATE(3095),
    [sym_preproc_nullable] = STATE(3095),
    [sym_preproc_error] = STATE(3095),
    [sym_preproc_warning] = STATE(3095),
    [sym_preproc_define] = STATE(3095),
    [sym_preproc_undef] = STATE(3095),
    [anon_sym_SEMI] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_RBRACK] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_in] = ACTIONS(4293),
    [anon_sym_where] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_EQ_GT] = ACTIONS(4291),
    [anon_sym_switch] = ACTIONS(4291),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4291),
    [anon_sym_or] = ACTIONS(4293),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_from] = ACTIONS(4291),
    [anon_sym_into] = ACTIONS(4291),
    [anon_sym_join] = ACTIONS(4291),
    [anon_sym_on] = ACTIONS(4291),
    [anon_sym_equals] = ACTIONS(4291),
    [anon_sym_let] = ACTIONS(4291),
    [anon_sym_orderby] = ACTIONS(4291),
    [anon_sym_group] = ACTIONS(4291),
    [anon_sym_by] = ACTIONS(4291),
    [anon_sym_select] = ACTIONS(4291),
    [anon_sym_as] = ACTIONS(4291),
    [anon_sym_is] = ACTIONS(4291),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4291),
    [aux_sym_preproc_if_token3] = ACTIONS(4291),
    [aux_sym_preproc_else_token1] = ACTIONS(4291),
    [aux_sym_preproc_elif_token1] = ACTIONS(4291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3096] = {
    [sym_preproc_region] = STATE(3096),
    [sym_preproc_endregion] = STATE(3096),
    [sym_preproc_line] = STATE(3096),
    [sym_preproc_pragma] = STATE(3096),
    [sym_preproc_nullable] = STATE(3096),
    [sym_preproc_error] = STATE(3096),
    [sym_preproc_warning] = STATE(3096),
    [sym_preproc_define] = STATE(3096),
    [sym_preproc_undef] = STATE(3096),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5234),
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_RBRACK] = ACTIONS(5234),
    [anon_sym_LPAREN] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5234),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5236),
    [anon_sym_where] = ACTIONS(5234),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_GT_GT_GT] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5234),
    [anon_sym_BANG_EQ] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5234),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_GT] = ACTIONS(5234),
    [anon_sym_switch] = ACTIONS(5234),
    [anon_sym_DOT_DOT] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_or] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5234),
    [anon_sym_QMARK_QMARK] = ACTIONS(5234),
    [anon_sym_from] = ACTIONS(5234),
    [anon_sym_into] = ACTIONS(5234),
    [anon_sym_join] = ACTIONS(5234),
    [anon_sym_on] = ACTIONS(5234),
    [anon_sym_equals] = ACTIONS(5234),
    [anon_sym_let] = ACTIONS(5234),
    [anon_sym_orderby] = ACTIONS(5234),
    [anon_sym_group] = ACTIONS(5234),
    [anon_sym_by] = ACTIONS(5234),
    [anon_sym_select] = ACTIONS(5234),
    [anon_sym_as] = ACTIONS(5234),
    [anon_sym_is] = ACTIONS(5234),
    [anon_sym_DASH_GT] = ACTIONS(5234),
    [anon_sym_with] = ACTIONS(5234),
    [aux_sym_preproc_if_token3] = ACTIONS(5234),
    [aux_sym_preproc_else_token1] = ACTIONS(5234),
    [aux_sym_preproc_elif_token1] = ACTIONS(5234),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3097] = {
    [sym_preproc_region] = STATE(3097),
    [sym_preproc_endregion] = STATE(3097),
    [sym_preproc_line] = STATE(3097),
    [sym_preproc_pragma] = STATE(3097),
    [sym_preproc_nullable] = STATE(3097),
    [sym_preproc_error] = STATE(3097),
    [sym_preproc_warning] = STATE(3097),
    [sym_preproc_define] = STATE(3097),
    [sym_preproc_undef] = STATE(3097),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5240),
    [anon_sym_in] = ACTIONS(5240),
    [anon_sym_where] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(5240),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5240),
    [anon_sym_GT_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_switch] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_QMARK_QMARK] = ACTIONS(5238),
    [anon_sym_from] = ACTIONS(5238),
    [anon_sym_into] = ACTIONS(5238),
    [anon_sym_join] = ACTIONS(5238),
    [anon_sym_on] = ACTIONS(5238),
    [anon_sym_equals] = ACTIONS(5238),
    [anon_sym_let] = ACTIONS(5238),
    [anon_sym_orderby] = ACTIONS(5238),
    [anon_sym_group] = ACTIONS(5238),
    [anon_sym_by] = ACTIONS(5238),
    [anon_sym_select] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5238),
    [anon_sym_is] = ACTIONS(5238),
    [anon_sym_DASH_GT] = ACTIONS(5238),
    [anon_sym_with] = ACTIONS(5238),
    [aux_sym_preproc_if_token3] = ACTIONS(5238),
    [aux_sym_preproc_else_token1] = ACTIONS(5238),
    [aux_sym_preproc_elif_token1] = ACTIONS(5238),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3098] = {
    [sym_preproc_region] = STATE(3098),
    [sym_preproc_endregion] = STATE(3098),
    [sym_preproc_line] = STATE(3098),
    [sym_preproc_pragma] = STATE(3098),
    [sym_preproc_nullable] = STATE(3098),
    [sym_preproc_error] = STATE(3098),
    [sym_preproc_warning] = STATE(3098),
    [sym_preproc_define] = STATE(3098),
    [sym_preproc_undef] = STATE(3098),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5242),
    [anon_sym_RBRACK] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5242),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5244),
    [anon_sym_in] = ACTIONS(5244),
    [anon_sym_where] = ACTIONS(5242),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_PIPE] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5244),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5244),
    [anon_sym_GT_GT_GT] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_DOT] = ACTIONS(5244),
    [anon_sym_EQ_GT] = ACTIONS(5242),
    [anon_sym_switch] = ACTIONS(5242),
    [anon_sym_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5242),
    [anon_sym_QMARK_QMARK] = ACTIONS(5242),
    [anon_sym_from] = ACTIONS(5242),
    [anon_sym_into] = ACTIONS(5242),
    [anon_sym_join] = ACTIONS(5242),
    [anon_sym_on] = ACTIONS(5242),
    [anon_sym_equals] = ACTIONS(5242),
    [anon_sym_let] = ACTIONS(5242),
    [anon_sym_orderby] = ACTIONS(5242),
    [anon_sym_group] = ACTIONS(5242),
    [anon_sym_by] = ACTIONS(5242),
    [anon_sym_select] = ACTIONS(5242),
    [anon_sym_as] = ACTIONS(5242),
    [anon_sym_is] = ACTIONS(5242),
    [anon_sym_DASH_GT] = ACTIONS(5242),
    [anon_sym_with] = ACTIONS(5242),
    [aux_sym_preproc_if_token3] = ACTIONS(5242),
    [aux_sym_preproc_else_token1] = ACTIONS(5242),
    [aux_sym_preproc_elif_token1] = ACTIONS(5242),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3099] = {
    [sym_preproc_region] = STATE(3099),
    [sym_preproc_endregion] = STATE(3099),
    [sym_preproc_line] = STATE(3099),
    [sym_preproc_pragma] = STATE(3099),
    [sym_preproc_nullable] = STATE(3099),
    [sym_preproc_error] = STATE(3099),
    [sym_preproc_warning] = STATE(3099),
    [sym_preproc_define] = STATE(3099),
    [sym_preproc_undef] = STATE(3099),
    [anon_sym_SEMI] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_RBRACK] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_in] = ACTIONS(5248),
    [anon_sym_where] = ACTIONS(5246),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5246),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_DOT] = ACTIONS(5248),
    [anon_sym_EQ_GT] = ACTIONS(5246),
    [anon_sym_switch] = ACTIONS(5246),
    [anon_sym_DOT_DOT] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_or] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_QMARK_QMARK] = ACTIONS(5246),
    [anon_sym_from] = ACTIONS(5246),
    [anon_sym_into] = ACTIONS(5246),
    [anon_sym_join] = ACTIONS(5246),
    [anon_sym_on] = ACTIONS(5246),
    [anon_sym_equals] = ACTIONS(5246),
    [anon_sym_let] = ACTIONS(5246),
    [anon_sym_orderby] = ACTIONS(5246),
    [anon_sym_group] = ACTIONS(5246),
    [anon_sym_by] = ACTIONS(5246),
    [anon_sym_select] = ACTIONS(5246),
    [anon_sym_as] = ACTIONS(5246),
    [anon_sym_is] = ACTIONS(5246),
    [anon_sym_DASH_GT] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5246),
    [aux_sym_preproc_if_token3] = ACTIONS(5246),
    [aux_sym_preproc_else_token1] = ACTIONS(5246),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3100] = {
    [sym_preproc_region] = STATE(3100),
    [sym_preproc_endregion] = STATE(3100),
    [sym_preproc_line] = STATE(3100),
    [sym_preproc_pragma] = STATE(3100),
    [sym_preproc_nullable] = STATE(3100),
    [sym_preproc_error] = STATE(3100),
    [sym_preproc_warning] = STATE(3100),
    [sym_preproc_define] = STATE(3100),
    [sym_preproc_undef] = STATE(3100),
    [anon_sym_SEMI] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5250),
    [anon_sym_COLON] = ACTIONS(5250),
    [anon_sym_COMMA] = ACTIONS(5250),
    [anon_sym_RBRACK] = ACTIONS(5250),
    [anon_sym_LPAREN] = ACTIONS(5250),
    [anon_sym_RPAREN] = ACTIONS(5250),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_in] = ACTIONS(5252),
    [anon_sym_where] = ACTIONS(5250),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_BANG] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5252),
    [anon_sym_STAR] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5250),
    [anon_sym_PIPE] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5252),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5252),
    [anon_sym_GT_GT_GT] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_DOT] = ACTIONS(5252),
    [anon_sym_EQ_GT] = ACTIONS(5250),
    [anon_sym_switch] = ACTIONS(5250),
    [anon_sym_DOT_DOT] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_or] = ACTIONS(5252),
    [anon_sym_AMP_AMP] = ACTIONS(5250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5250),
    [anon_sym_QMARK_QMARK] = ACTIONS(5250),
    [anon_sym_from] = ACTIONS(5250),
    [anon_sym_into] = ACTIONS(5250),
    [anon_sym_join] = ACTIONS(5250),
    [anon_sym_on] = ACTIONS(5250),
    [anon_sym_equals] = ACTIONS(5250),
    [anon_sym_let] = ACTIONS(5250),
    [anon_sym_orderby] = ACTIONS(5250),
    [anon_sym_group] = ACTIONS(5250),
    [anon_sym_by] = ACTIONS(5250),
    [anon_sym_select] = ACTIONS(5250),
    [anon_sym_as] = ACTIONS(5250),
    [anon_sym_is] = ACTIONS(5250),
    [anon_sym_DASH_GT] = ACTIONS(5250),
    [anon_sym_with] = ACTIONS(5250),
    [aux_sym_preproc_if_token3] = ACTIONS(5250),
    [aux_sym_preproc_else_token1] = ACTIONS(5250),
    [aux_sym_preproc_elif_token1] = ACTIONS(5250),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3101] = {
    [sym_preproc_region] = STATE(3101),
    [sym_preproc_endregion] = STATE(3101),
    [sym_preproc_line] = STATE(3101),
    [sym_preproc_pragma] = STATE(3101),
    [sym_preproc_nullable] = STATE(3101),
    [sym_preproc_error] = STATE(3101),
    [sym_preproc_warning] = STATE(3101),
    [sym_preproc_define] = STATE(3101),
    [sym_preproc_undef] = STATE(3101),
    [anon_sym_SEMI] = ACTIONS(5254),
    [anon_sym_LBRACK] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(5254),
    [anon_sym_COMMA] = ACTIONS(5254),
    [anon_sym_RBRACK] = ACTIONS(5254),
    [anon_sym_LPAREN] = ACTIONS(5254),
    [anon_sym_RPAREN] = ACTIONS(5254),
    [anon_sym_RBRACE] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5256),
    [anon_sym_in] = ACTIONS(5256),
    [anon_sym_where] = ACTIONS(5254),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_BANG] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5256),
    [anon_sym_STAR] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(5256),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PIPE] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5256),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5256),
    [anon_sym_GT_GT_GT] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5254),
    [anon_sym_BANG_EQ] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5254),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_DOT] = ACTIONS(5256),
    [anon_sym_EQ_GT] = ACTIONS(5254),
    [anon_sym_switch] = ACTIONS(5254),
    [anon_sym_DOT_DOT] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_or] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5254),
    [anon_sym_PIPE_PIPE] = ACTIONS(5254),
    [anon_sym_QMARK_QMARK] = ACTIONS(5254),
    [anon_sym_from] = ACTIONS(5254),
    [anon_sym_into] = ACTIONS(5254),
    [anon_sym_join] = ACTIONS(5254),
    [anon_sym_on] = ACTIONS(5254),
    [anon_sym_equals] = ACTIONS(5254),
    [anon_sym_let] = ACTIONS(5254),
    [anon_sym_orderby] = ACTIONS(5254),
    [anon_sym_group] = ACTIONS(5254),
    [anon_sym_by] = ACTIONS(5254),
    [anon_sym_select] = ACTIONS(5254),
    [anon_sym_as] = ACTIONS(5254),
    [anon_sym_is] = ACTIONS(5254),
    [anon_sym_DASH_GT] = ACTIONS(5254),
    [anon_sym_with] = ACTIONS(5254),
    [aux_sym_preproc_if_token3] = ACTIONS(5254),
    [aux_sym_preproc_else_token1] = ACTIONS(5254),
    [aux_sym_preproc_elif_token1] = ACTIONS(5254),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3102] = {
    [sym_preproc_region] = STATE(3102),
    [sym_preproc_endregion] = STATE(3102),
    [sym_preproc_line] = STATE(3102),
    [sym_preproc_pragma] = STATE(3102),
    [sym_preproc_nullable] = STATE(3102),
    [sym_preproc_error] = STATE(3102),
    [sym_preproc_warning] = STATE(3102),
    [sym_preproc_define] = STATE(3102),
    [sym_preproc_undef] = STATE(3102),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3103] = {
    [sym_preproc_region] = STATE(3103),
    [sym_preproc_endregion] = STATE(3103),
    [sym_preproc_line] = STATE(3103),
    [sym_preproc_pragma] = STATE(3103),
    [sym_preproc_nullable] = STATE(3103),
    [sym_preproc_error] = STATE(3103),
    [sym_preproc_warning] = STATE(3103),
    [sym_preproc_define] = STATE(3103),
    [sym_preproc_undef] = STATE(3103),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(5258),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5260),
    [anon_sym_DASH_EQ] = ACTIONS(5260),
    [anon_sym_STAR_EQ] = ACTIONS(5260),
    [anon_sym_SLASH_EQ] = ACTIONS(5260),
    [anon_sym_PERCENT_EQ] = ACTIONS(5260),
    [anon_sym_AMP_EQ] = ACTIONS(5260),
    [anon_sym_CARET_EQ] = ACTIONS(5260),
    [anon_sym_PIPE_EQ] = ACTIONS(5260),
    [anon_sym_LT_LT_EQ] = ACTIONS(5260),
    [anon_sym_GT_GT_EQ] = ACTIONS(5260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5260),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5260),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3104] = {
    [sym_preproc_region] = STATE(3104),
    [sym_preproc_endregion] = STATE(3104),
    [sym_preproc_line] = STATE(3104),
    [sym_preproc_pragma] = STATE(3104),
    [sym_preproc_nullable] = STATE(3104),
    [sym_preproc_error] = STATE(3104),
    [sym_preproc_warning] = STATE(3104),
    [sym_preproc_define] = STATE(3104),
    [sym_preproc_undef] = STATE(3104),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5240),
    [anon_sym_in] = ACTIONS(5238),
    [anon_sym_where] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(5240),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5240),
    [anon_sym_GT_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_switch] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_QMARK_QMARK] = ACTIONS(5238),
    [anon_sym_from] = ACTIONS(5238),
    [anon_sym_join] = ACTIONS(5238),
    [anon_sym_on] = ACTIONS(5238),
    [anon_sym_equals] = ACTIONS(5238),
    [anon_sym_let] = ACTIONS(5238),
    [anon_sym_orderby] = ACTIONS(5238),
    [anon_sym_group] = ACTIONS(5238),
    [anon_sym_by] = ACTIONS(5238),
    [anon_sym_select] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5238),
    [anon_sym_is] = ACTIONS(5238),
    [anon_sym_DASH_GT] = ACTIONS(5238),
    [anon_sym_with] = ACTIONS(5238),
    [aux_sym_preproc_if_token3] = ACTIONS(5238),
    [aux_sym_preproc_else_token1] = ACTIONS(5238),
    [aux_sym_preproc_elif_token1] = ACTIONS(5238),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3105] = {
    [sym_preproc_region] = STATE(3105),
    [sym_preproc_endregion] = STATE(3105),
    [sym_preproc_line] = STATE(3105),
    [sym_preproc_pragma] = STATE(3105),
    [sym_preproc_nullable] = STATE(3105),
    [sym_preproc_error] = STATE(3105),
    [sym_preproc_warning] = STATE(3105),
    [sym_preproc_define] = STATE(3105),
    [sym_preproc_undef] = STATE(3105),
    [anon_sym_SEMI] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_RBRACK] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_in] = ACTIONS(5246),
    [anon_sym_where] = ACTIONS(5246),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5246),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_DOT] = ACTIONS(5248),
    [anon_sym_EQ_GT] = ACTIONS(5246),
    [anon_sym_switch] = ACTIONS(5246),
    [anon_sym_DOT_DOT] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_or] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_QMARK_QMARK] = ACTIONS(5246),
    [anon_sym_from] = ACTIONS(5246),
    [anon_sym_join] = ACTIONS(5246),
    [anon_sym_on] = ACTIONS(5246),
    [anon_sym_equals] = ACTIONS(5246),
    [anon_sym_let] = ACTIONS(5246),
    [anon_sym_orderby] = ACTIONS(5246),
    [anon_sym_group] = ACTIONS(5246),
    [anon_sym_by] = ACTIONS(5246),
    [anon_sym_select] = ACTIONS(5246),
    [anon_sym_as] = ACTIONS(5246),
    [anon_sym_is] = ACTIONS(5246),
    [anon_sym_DASH_GT] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5246),
    [aux_sym_preproc_if_token3] = ACTIONS(5246),
    [aux_sym_preproc_else_token1] = ACTIONS(5246),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3106] = {
    [sym_preproc_region] = STATE(3106),
    [sym_preproc_endregion] = STATE(3106),
    [sym_preproc_line] = STATE(3106),
    [sym_preproc_pragma] = STATE(3106),
    [sym_preproc_nullable] = STATE(3106),
    [sym_preproc_error] = STATE(3106),
    [sym_preproc_warning] = STATE(3106),
    [sym_preproc_define] = STATE(3106),
    [sym_preproc_undef] = STATE(3106),
    [anon_sym_SEMI] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5250),
    [anon_sym_COLON] = ACTIONS(5250),
    [anon_sym_COMMA] = ACTIONS(5250),
    [anon_sym_RBRACK] = ACTIONS(5250),
    [anon_sym_LPAREN] = ACTIONS(5250),
    [anon_sym_RPAREN] = ACTIONS(5250),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_in] = ACTIONS(5250),
    [anon_sym_where] = ACTIONS(5250),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_BANG] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5252),
    [anon_sym_STAR] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5250),
    [anon_sym_PIPE] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5252),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5252),
    [anon_sym_GT_GT_GT] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_DOT] = ACTIONS(5252),
    [anon_sym_EQ_GT] = ACTIONS(5250),
    [anon_sym_switch] = ACTIONS(5250),
    [anon_sym_DOT_DOT] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_or] = ACTIONS(5252),
    [anon_sym_AMP_AMP] = ACTIONS(5250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5250),
    [anon_sym_QMARK_QMARK] = ACTIONS(5250),
    [anon_sym_from] = ACTIONS(5250),
    [anon_sym_join] = ACTIONS(5250),
    [anon_sym_on] = ACTIONS(5250),
    [anon_sym_equals] = ACTIONS(5250),
    [anon_sym_let] = ACTIONS(5250),
    [anon_sym_orderby] = ACTIONS(5250),
    [anon_sym_group] = ACTIONS(5250),
    [anon_sym_by] = ACTIONS(5250),
    [anon_sym_select] = ACTIONS(5250),
    [anon_sym_as] = ACTIONS(5250),
    [anon_sym_is] = ACTIONS(5250),
    [anon_sym_DASH_GT] = ACTIONS(5250),
    [anon_sym_with] = ACTIONS(5250),
    [aux_sym_preproc_if_token3] = ACTIONS(5250),
    [aux_sym_preproc_else_token1] = ACTIONS(5250),
    [aux_sym_preproc_elif_token1] = ACTIONS(5250),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3107] = {
    [sym_preproc_region] = STATE(3107),
    [sym_preproc_endregion] = STATE(3107),
    [sym_preproc_line] = STATE(3107),
    [sym_preproc_pragma] = STATE(3107),
    [sym_preproc_nullable] = STATE(3107),
    [sym_preproc_error] = STATE(3107),
    [sym_preproc_warning] = STATE(3107),
    [sym_preproc_define] = STATE(3107),
    [sym_preproc_undef] = STATE(3107),
    [anon_sym_SEMI] = ACTIONS(5254),
    [anon_sym_LBRACK] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(5254),
    [anon_sym_COMMA] = ACTIONS(5254),
    [anon_sym_RBRACK] = ACTIONS(5254),
    [anon_sym_LPAREN] = ACTIONS(5254),
    [anon_sym_RPAREN] = ACTIONS(5254),
    [anon_sym_RBRACE] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5256),
    [anon_sym_in] = ACTIONS(5254),
    [anon_sym_where] = ACTIONS(5254),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_BANG] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5256),
    [anon_sym_STAR] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(5256),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PIPE] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5256),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5256),
    [anon_sym_GT_GT_GT] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5254),
    [anon_sym_BANG_EQ] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5254),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_DOT] = ACTIONS(5256),
    [anon_sym_EQ_GT] = ACTIONS(5254),
    [anon_sym_switch] = ACTIONS(5254),
    [anon_sym_DOT_DOT] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_or] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5254),
    [anon_sym_PIPE_PIPE] = ACTIONS(5254),
    [anon_sym_QMARK_QMARK] = ACTIONS(5254),
    [anon_sym_from] = ACTIONS(5254),
    [anon_sym_join] = ACTIONS(5254),
    [anon_sym_on] = ACTIONS(5254),
    [anon_sym_equals] = ACTIONS(5254),
    [anon_sym_let] = ACTIONS(5254),
    [anon_sym_orderby] = ACTIONS(5254),
    [anon_sym_group] = ACTIONS(5254),
    [anon_sym_by] = ACTIONS(5254),
    [anon_sym_select] = ACTIONS(5254),
    [anon_sym_as] = ACTIONS(5254),
    [anon_sym_is] = ACTIONS(5254),
    [anon_sym_DASH_GT] = ACTIONS(5254),
    [anon_sym_with] = ACTIONS(5254),
    [aux_sym_preproc_if_token3] = ACTIONS(5254),
    [aux_sym_preproc_else_token1] = ACTIONS(5254),
    [aux_sym_preproc_elif_token1] = ACTIONS(5254),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3108] = {
    [sym_preproc_region] = STATE(3108),
    [sym_preproc_endregion] = STATE(3108),
    [sym_preproc_line] = STATE(3108),
    [sym_preproc_pragma] = STATE(3108),
    [sym_preproc_nullable] = STATE(3108),
    [sym_preproc_error] = STATE(3108),
    [sym_preproc_warning] = STATE(3108),
    [sym_preproc_define] = STATE(3108),
    [sym_preproc_undef] = STATE(3108),
    [anon_sym_SEMI] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_COLON] = ACTIONS(5051),
    [anon_sym_COMMA] = ACTIONS(5051),
    [anon_sym_RBRACK] = ACTIONS(5051),
    [anon_sym_LPAREN] = ACTIONS(5051),
    [anon_sym_RPAREN] = ACTIONS(5051),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_LT] = ACTIONS(5053),
    [anon_sym_GT] = ACTIONS(5053),
    [anon_sym_in] = ACTIONS(5051),
    [anon_sym_where] = ACTIONS(5051),
    [anon_sym_QMARK] = ACTIONS(5053),
    [anon_sym_BANG] = ACTIONS(5053),
    [anon_sym_PLUS_PLUS] = ACTIONS(5051),
    [anon_sym_DASH_DASH] = ACTIONS(5051),
    [anon_sym_PLUS] = ACTIONS(5053),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5051),
    [anon_sym_SLASH] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5051),
    [anon_sym_CARET] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5053),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5053),
    [anon_sym_GT_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5051),
    [anon_sym_BANG_EQ] = ACTIONS(5051),
    [anon_sym_GT_EQ] = ACTIONS(5051),
    [anon_sym_LT_EQ] = ACTIONS(5051),
    [anon_sym_DOT] = ACTIONS(5053),
    [anon_sym_EQ_GT] = ACTIONS(5051),
    [anon_sym_switch] = ACTIONS(5051),
    [anon_sym_DOT_DOT] = ACTIONS(5051),
    [anon_sym_and] = ACTIONS(5051),
    [anon_sym_or] = ACTIONS(5053),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5051),
    [anon_sym_QMARK_QMARK] = ACTIONS(5051),
    [anon_sym_from] = ACTIONS(5051),
    [anon_sym_join] = ACTIONS(5051),
    [anon_sym_on] = ACTIONS(5051),
    [anon_sym_equals] = ACTIONS(5051),
    [anon_sym_let] = ACTIONS(5051),
    [anon_sym_orderby] = ACTIONS(5051),
    [anon_sym_group] = ACTIONS(5051),
    [anon_sym_by] = ACTIONS(5051),
    [anon_sym_select] = ACTIONS(5051),
    [anon_sym_as] = ACTIONS(5051),
    [anon_sym_is] = ACTIONS(5051),
    [anon_sym_DASH_GT] = ACTIONS(5051),
    [anon_sym_with] = ACTIONS(5051),
    [aux_sym_preproc_if_token3] = ACTIONS(5051),
    [aux_sym_preproc_else_token1] = ACTIONS(5051),
    [aux_sym_preproc_elif_token1] = ACTIONS(5051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3109] = {
    [sym_preproc_region] = STATE(3109),
    [sym_preproc_endregion] = STATE(3109),
    [sym_preproc_line] = STATE(3109),
    [sym_preproc_pragma] = STATE(3109),
    [sym_preproc_nullable] = STATE(3109),
    [sym_preproc_error] = STATE(3109),
    [sym_preproc_warning] = STATE(3109),
    [sym_preproc_define] = STATE(3109),
    [sym_preproc_undef] = STATE(3109),
    [anon_sym_SEMI] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5121),
    [anon_sym_RBRACK] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_RPAREN] = ACTIONS(5121),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5123),
    [anon_sym_in] = ACTIONS(5121),
    [anon_sym_where] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5123),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5123),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_PIPE] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_GT_GT_GT] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5121),
    [anon_sym_BANG_EQ] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5121),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_DOT] = ACTIONS(5123),
    [anon_sym_EQ_GT] = ACTIONS(5121),
    [anon_sym_switch] = ACTIONS(5121),
    [anon_sym_DOT_DOT] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_or] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5121),
    [anon_sym_QMARK_QMARK] = ACTIONS(5121),
    [anon_sym_from] = ACTIONS(5121),
    [anon_sym_join] = ACTIONS(5121),
    [anon_sym_on] = ACTIONS(5121),
    [anon_sym_equals] = ACTIONS(5121),
    [anon_sym_let] = ACTIONS(5121),
    [anon_sym_orderby] = ACTIONS(5121),
    [anon_sym_group] = ACTIONS(5121),
    [anon_sym_by] = ACTIONS(5121),
    [anon_sym_select] = ACTIONS(5121),
    [anon_sym_as] = ACTIONS(5121),
    [anon_sym_is] = ACTIONS(5121),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [anon_sym_with] = ACTIONS(5121),
    [aux_sym_preproc_if_token3] = ACTIONS(5121),
    [aux_sym_preproc_else_token1] = ACTIONS(5121),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3110] = {
    [sym_preproc_region] = STATE(3110),
    [sym_preproc_endregion] = STATE(3110),
    [sym_preproc_line] = STATE(3110),
    [sym_preproc_pragma] = STATE(3110),
    [sym_preproc_nullable] = STATE(3110),
    [sym_preproc_error] = STATE(3110),
    [sym_preproc_warning] = STATE(3110),
    [sym_preproc_define] = STATE(3110),
    [sym_preproc_undef] = STATE(3110),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_COLON] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RBRACK] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_in] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_CARET] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5003),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_GT_GT_GT] = ACTIONS(5003),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_EQ_GT] = ACTIONS(5003),
    [anon_sym_switch] = ACTIONS(5003),
    [anon_sym_DOT_DOT] = ACTIONS(5003),
    [anon_sym_and] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_QMARK_QMARK] = ACTIONS(5003),
    [anon_sym_from] = ACTIONS(5003),
    [anon_sym_join] = ACTIONS(5003),
    [anon_sym_on] = ACTIONS(5003),
    [anon_sym_equals] = ACTIONS(5003),
    [anon_sym_let] = ACTIONS(5003),
    [anon_sym_orderby] = ACTIONS(5003),
    [anon_sym_group] = ACTIONS(5003),
    [anon_sym_by] = ACTIONS(5003),
    [anon_sym_select] = ACTIONS(5003),
    [anon_sym_as] = ACTIONS(5003),
    [anon_sym_is] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [anon_sym_with] = ACTIONS(5003),
    [aux_sym_preproc_if_token3] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3111] = {
    [sym_preproc_region] = STATE(3111),
    [sym_preproc_endregion] = STATE(3111),
    [sym_preproc_line] = STATE(3111),
    [sym_preproc_pragma] = STATE(3111),
    [sym_preproc_nullable] = STATE(3111),
    [sym_preproc_error] = STATE(3111),
    [sym_preproc_warning] = STATE(3111),
    [sym_preproc_define] = STATE(3111),
    [sym_preproc_undef] = STATE(3111),
    [anon_sym_SEMI] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_COLON] = ACTIONS(5035),
    [anon_sym_COMMA] = ACTIONS(5035),
    [anon_sym_RBRACK] = ACTIONS(5035),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_RPAREN] = ACTIONS(5035),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_GT] = ACTIONS(5037),
    [anon_sym_in] = ACTIONS(5035),
    [anon_sym_where] = ACTIONS(5035),
    [anon_sym_QMARK] = ACTIONS(5037),
    [anon_sym_BANG] = ACTIONS(5037),
    [anon_sym_PLUS_PLUS] = ACTIONS(5035),
    [anon_sym_DASH_DASH] = ACTIONS(5035),
    [anon_sym_PLUS] = ACTIONS(5037),
    [anon_sym_DASH] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5035),
    [anon_sym_SLASH] = ACTIONS(5037),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [anon_sym_CARET] = ACTIONS(5035),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(5035),
    [anon_sym_GT_GT] = ACTIONS(5037),
    [anon_sym_GT_GT_GT] = ACTIONS(5035),
    [anon_sym_EQ_EQ] = ACTIONS(5035),
    [anon_sym_BANG_EQ] = ACTIONS(5035),
    [anon_sym_GT_EQ] = ACTIONS(5035),
    [anon_sym_LT_EQ] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5037),
    [anon_sym_EQ_GT] = ACTIONS(5035),
    [anon_sym_switch] = ACTIONS(5035),
    [anon_sym_DOT_DOT] = ACTIONS(5035),
    [anon_sym_and] = ACTIONS(5035),
    [anon_sym_or] = ACTIONS(5037),
    [anon_sym_AMP_AMP] = ACTIONS(5035),
    [anon_sym_PIPE_PIPE] = ACTIONS(5035),
    [anon_sym_QMARK_QMARK] = ACTIONS(5035),
    [anon_sym_from] = ACTIONS(5035),
    [anon_sym_join] = ACTIONS(5035),
    [anon_sym_on] = ACTIONS(5035),
    [anon_sym_equals] = ACTIONS(5035),
    [anon_sym_let] = ACTIONS(5035),
    [anon_sym_orderby] = ACTIONS(5035),
    [anon_sym_group] = ACTIONS(5035),
    [anon_sym_by] = ACTIONS(5035),
    [anon_sym_select] = ACTIONS(5035),
    [anon_sym_as] = ACTIONS(5035),
    [anon_sym_is] = ACTIONS(5035),
    [anon_sym_DASH_GT] = ACTIONS(5035),
    [anon_sym_with] = ACTIONS(5035),
    [aux_sym_preproc_if_token3] = ACTIONS(5035),
    [aux_sym_preproc_else_token1] = ACTIONS(5035),
    [aux_sym_preproc_elif_token1] = ACTIONS(5035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3112] = {
    [sym_preproc_region] = STATE(3112),
    [sym_preproc_endregion] = STATE(3112),
    [sym_preproc_line] = STATE(3112),
    [sym_preproc_pragma] = STATE(3112),
    [sym_preproc_nullable] = STATE(3112),
    [sym_preproc_error] = STATE(3112),
    [sym_preproc_warning] = STATE(3112),
    [sym_preproc_define] = STATE(3112),
    [sym_preproc_undef] = STATE(3112),
    [anon_sym_SEMI] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(5163),
    [anon_sym_COLON] = ACTIONS(5163),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACK] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(5163),
    [anon_sym_RPAREN] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_in] = ACTIONS(5163),
    [anon_sym_where] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_PLUS_PLUS] = ACTIONS(5163),
    [anon_sym_DASH_DASH] = ACTIONS(5163),
    [anon_sym_PLUS] = ACTIONS(5165),
    [anon_sym_DASH] = ACTIONS(5165),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_SLASH] = ACTIONS(5165),
    [anon_sym_PERCENT] = ACTIONS(5163),
    [anon_sym_CARET] = ACTIONS(5163),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_LT_LT] = ACTIONS(5163),
    [anon_sym_GT_GT] = ACTIONS(5165),
    [anon_sym_GT_GT_GT] = ACTIONS(5163),
    [anon_sym_EQ_EQ] = ACTIONS(5163),
    [anon_sym_BANG_EQ] = ACTIONS(5163),
    [anon_sym_GT_EQ] = ACTIONS(5163),
    [anon_sym_LT_EQ] = ACTIONS(5163),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_EQ_GT] = ACTIONS(5163),
    [anon_sym_switch] = ACTIONS(5163),
    [anon_sym_DOT_DOT] = ACTIONS(5163),
    [anon_sym_and] = ACTIONS(5163),
    [anon_sym_or] = ACTIONS(5165),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_QMARK_QMARK] = ACTIONS(5163),
    [anon_sym_from] = ACTIONS(5163),
    [anon_sym_join] = ACTIONS(5163),
    [anon_sym_on] = ACTIONS(5163),
    [anon_sym_equals] = ACTIONS(5163),
    [anon_sym_let] = ACTIONS(5163),
    [anon_sym_orderby] = ACTIONS(5163),
    [anon_sym_group] = ACTIONS(5163),
    [anon_sym_by] = ACTIONS(5163),
    [anon_sym_select] = ACTIONS(5163),
    [anon_sym_as] = ACTIONS(5163),
    [anon_sym_is] = ACTIONS(5163),
    [anon_sym_DASH_GT] = ACTIONS(5163),
    [anon_sym_with] = ACTIONS(5163),
    [aux_sym_preproc_if_token3] = ACTIONS(5163),
    [aux_sym_preproc_else_token1] = ACTIONS(5163),
    [aux_sym_preproc_elif_token1] = ACTIONS(5163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3113] = {
    [sym_preproc_region] = STATE(3113),
    [sym_preproc_endregion] = STATE(3113),
    [sym_preproc_line] = STATE(3113),
    [sym_preproc_pragma] = STATE(3113),
    [sym_preproc_nullable] = STATE(3113),
    [sym_preproc_error] = STATE(3113),
    [sym_preproc_warning] = STATE(3113),
    [sym_preproc_define] = STATE(3113),
    [sym_preproc_undef] = STATE(3113),
    [anon_sym_SEMI] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(5183),
    [anon_sym_COLON] = ACTIONS(5183),
    [anon_sym_COMMA] = ACTIONS(5183),
    [anon_sym_RBRACK] = ACTIONS(5183),
    [anon_sym_LPAREN] = ACTIONS(5183),
    [anon_sym_RPAREN] = ACTIONS(5183),
    [anon_sym_RBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_in] = ACTIONS(5183),
    [anon_sym_where] = ACTIONS(5183),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_BANG] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5183),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_GT_GT_GT] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5183),
    [anon_sym_BANG_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_EQ_GT] = ACTIONS(5183),
    [anon_sym_switch] = ACTIONS(5183),
    [anon_sym_DOT_DOT] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE] = ACTIONS(5183),
    [anon_sym_QMARK_QMARK] = ACTIONS(5183),
    [anon_sym_from] = ACTIONS(5183),
    [anon_sym_join] = ACTIONS(5183),
    [anon_sym_on] = ACTIONS(5183),
    [anon_sym_equals] = ACTIONS(5183),
    [anon_sym_let] = ACTIONS(5183),
    [anon_sym_orderby] = ACTIONS(5183),
    [anon_sym_group] = ACTIONS(5183),
    [anon_sym_by] = ACTIONS(5183),
    [anon_sym_select] = ACTIONS(5183),
    [anon_sym_as] = ACTIONS(5183),
    [anon_sym_is] = ACTIONS(5183),
    [anon_sym_DASH_GT] = ACTIONS(5183),
    [anon_sym_with] = ACTIONS(5183),
    [aux_sym_preproc_if_token3] = ACTIONS(5183),
    [aux_sym_preproc_else_token1] = ACTIONS(5183),
    [aux_sym_preproc_elif_token1] = ACTIONS(5183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3114] = {
    [sym_preproc_region] = STATE(3114),
    [sym_preproc_endregion] = STATE(3114),
    [sym_preproc_line] = STATE(3114),
    [sym_preproc_pragma] = STATE(3114),
    [sym_preproc_nullable] = STATE(3114),
    [sym_preproc_error] = STATE(3114),
    [sym_preproc_warning] = STATE(3114),
    [sym_preproc_define] = STATE(3114),
    [sym_preproc_undef] = STATE(3114),
    [anon_sym_SEMI] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_COLON] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(4975),
    [anon_sym_RBRACK] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_RPAREN] = ACTIONS(4975),
    [anon_sym_RBRACE] = ACTIONS(4975),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_GT] = ACTIONS(4977),
    [anon_sym_in] = ACTIONS(4975),
    [anon_sym_where] = ACTIONS(4975),
    [anon_sym_QMARK] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_PLUS_PLUS] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4975),
    [anon_sym_SLASH] = ACTIONS(4977),
    [anon_sym_PERCENT] = ACTIONS(4975),
    [anon_sym_CARET] = ACTIONS(4975),
    [anon_sym_PIPE] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4975),
    [anon_sym_GT_GT] = ACTIONS(4977),
    [anon_sym_GT_GT_GT] = ACTIONS(4975),
    [anon_sym_EQ_EQ] = ACTIONS(4975),
    [anon_sym_BANG_EQ] = ACTIONS(4975),
    [anon_sym_GT_EQ] = ACTIONS(4975),
    [anon_sym_LT_EQ] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_EQ_GT] = ACTIONS(4975),
    [anon_sym_switch] = ACTIONS(4975),
    [anon_sym_DOT_DOT] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_or] = ACTIONS(4977),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_PIPE_PIPE] = ACTIONS(4975),
    [anon_sym_QMARK_QMARK] = ACTIONS(4975),
    [anon_sym_from] = ACTIONS(4975),
    [anon_sym_join] = ACTIONS(4975),
    [anon_sym_on] = ACTIONS(4975),
    [anon_sym_equals] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_orderby] = ACTIONS(4975),
    [anon_sym_group] = ACTIONS(4975),
    [anon_sym_by] = ACTIONS(4975),
    [anon_sym_select] = ACTIONS(4975),
    [anon_sym_as] = ACTIONS(4975),
    [anon_sym_is] = ACTIONS(4975),
    [anon_sym_DASH_GT] = ACTIONS(4975),
    [anon_sym_with] = ACTIONS(4975),
    [aux_sym_preproc_if_token3] = ACTIONS(4975),
    [aux_sym_preproc_else_token1] = ACTIONS(4975),
    [aux_sym_preproc_elif_token1] = ACTIONS(4975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3115] = {
    [sym_preproc_region] = STATE(3115),
    [sym_preproc_endregion] = STATE(3115),
    [sym_preproc_line] = STATE(3115),
    [sym_preproc_pragma] = STATE(3115),
    [sym_preproc_nullable] = STATE(3115),
    [sym_preproc_error] = STATE(3115),
    [sym_preproc_warning] = STATE(3115),
    [sym_preproc_define] = STATE(3115),
    [sym_preproc_undef] = STATE(3115),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_COLON] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5039),
    [anon_sym_RBRACK] = ACTIONS(5039),
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_RPAREN] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_in] = ACTIONS(5039),
    [anon_sym_where] = ACTIONS(5039),
    [anon_sym_QMARK] = ACTIONS(5041),
    [anon_sym_BANG] = ACTIONS(5041),
    [anon_sym_PLUS_PLUS] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(5039),
    [anon_sym_PLUS] = ACTIONS(5041),
    [anon_sym_DASH] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_SLASH] = ACTIONS(5041),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_CARET] = ACTIONS(5039),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5041),
    [anon_sym_LT_LT] = ACTIONS(5039),
    [anon_sym_GT_GT] = ACTIONS(5041),
    [anon_sym_GT_GT_GT] = ACTIONS(5039),
    [anon_sym_EQ_EQ] = ACTIONS(5039),
    [anon_sym_BANG_EQ] = ACTIONS(5039),
    [anon_sym_GT_EQ] = ACTIONS(5039),
    [anon_sym_LT_EQ] = ACTIONS(5039),
    [anon_sym_DOT] = ACTIONS(5041),
    [anon_sym_EQ_GT] = ACTIONS(5039),
    [anon_sym_switch] = ACTIONS(5039),
    [anon_sym_DOT_DOT] = ACTIONS(5039),
    [anon_sym_and] = ACTIONS(5039),
    [anon_sym_or] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5039),
    [anon_sym_PIPE_PIPE] = ACTIONS(5039),
    [anon_sym_QMARK_QMARK] = ACTIONS(5039),
    [anon_sym_from] = ACTIONS(5039),
    [anon_sym_join] = ACTIONS(5039),
    [anon_sym_on] = ACTIONS(5039),
    [anon_sym_equals] = ACTIONS(5039),
    [anon_sym_let] = ACTIONS(5039),
    [anon_sym_orderby] = ACTIONS(5039),
    [anon_sym_group] = ACTIONS(5039),
    [anon_sym_by] = ACTIONS(5039),
    [anon_sym_select] = ACTIONS(5039),
    [anon_sym_as] = ACTIONS(5039),
    [anon_sym_is] = ACTIONS(5039),
    [anon_sym_DASH_GT] = ACTIONS(5039),
    [anon_sym_with] = ACTIONS(5039),
    [aux_sym_preproc_if_token3] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3116] = {
    [sym_preproc_region] = STATE(3116),
    [sym_preproc_endregion] = STATE(3116),
    [sym_preproc_line] = STATE(3116),
    [sym_preproc_pragma] = STATE(3116),
    [sym_preproc_nullable] = STATE(3116),
    [sym_preproc_error] = STATE(3116),
    [sym_preproc_warning] = STATE(3116),
    [sym_preproc_define] = STATE(3116),
    [sym_preproc_undef] = STATE(3116),
    [anon_sym_SEMI] = ACTIONS(5171),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5171),
    [anon_sym_COMMA] = ACTIONS(5171),
    [anon_sym_RBRACK] = ACTIONS(5171),
    [anon_sym_LPAREN] = ACTIONS(5171),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5173),
    [anon_sym_in] = ACTIONS(5171),
    [anon_sym_where] = ACTIONS(5171),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5173),
    [anon_sym_PERCENT] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5173),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5173),
    [anon_sym_GT_GT_GT] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5171),
    [anon_sym_BANG_EQ] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5171),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_DOT] = ACTIONS(5173),
    [anon_sym_EQ_GT] = ACTIONS(5171),
    [anon_sym_switch] = ACTIONS(5171),
    [anon_sym_DOT_DOT] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_or] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5171),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_QMARK_QMARK] = ACTIONS(5171),
    [anon_sym_from] = ACTIONS(5171),
    [anon_sym_join] = ACTIONS(5171),
    [anon_sym_on] = ACTIONS(5171),
    [anon_sym_equals] = ACTIONS(5171),
    [anon_sym_let] = ACTIONS(5171),
    [anon_sym_orderby] = ACTIONS(5171),
    [anon_sym_group] = ACTIONS(5171),
    [anon_sym_by] = ACTIONS(5171),
    [anon_sym_select] = ACTIONS(5171),
    [anon_sym_as] = ACTIONS(5171),
    [anon_sym_is] = ACTIONS(5171),
    [anon_sym_DASH_GT] = ACTIONS(5171),
    [anon_sym_with] = ACTIONS(5171),
    [aux_sym_preproc_if_token3] = ACTIONS(5171),
    [aux_sym_preproc_else_token1] = ACTIONS(5171),
    [aux_sym_preproc_elif_token1] = ACTIONS(5171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3117] = {
    [sym_preproc_region] = STATE(3117),
    [sym_preproc_endregion] = STATE(3117),
    [sym_preproc_line] = STATE(3117),
    [sym_preproc_pragma] = STATE(3117),
    [sym_preproc_nullable] = STATE(3117),
    [sym_preproc_error] = STATE(3117),
    [sym_preproc_warning] = STATE(3117),
    [sym_preproc_define] = STATE(3117),
    [sym_preproc_undef] = STATE(3117),
    [anon_sym_SEMI] = ACTIONS(5153),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_COMMA] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_RPAREN] = ACTIONS(5153),
    [anon_sym_RBRACE] = ACTIONS(5153),
    [anon_sym_LT] = ACTIONS(5155),
    [anon_sym_GT] = ACTIONS(5155),
    [anon_sym_in] = ACTIONS(5153),
    [anon_sym_where] = ACTIONS(5153),
    [anon_sym_QMARK] = ACTIONS(5155),
    [anon_sym_BANG] = ACTIONS(5155),
    [anon_sym_PLUS_PLUS] = ACTIONS(5153),
    [anon_sym_DASH_DASH] = ACTIONS(5153),
    [anon_sym_PLUS] = ACTIONS(5155),
    [anon_sym_DASH] = ACTIONS(5155),
    [anon_sym_STAR] = ACTIONS(5153),
    [anon_sym_SLASH] = ACTIONS(5155),
    [anon_sym_PERCENT] = ACTIONS(5153),
    [anon_sym_CARET] = ACTIONS(5153),
    [anon_sym_PIPE] = ACTIONS(5155),
    [anon_sym_AMP] = ACTIONS(5155),
    [anon_sym_LT_LT] = ACTIONS(5153),
    [anon_sym_GT_GT] = ACTIONS(5155),
    [anon_sym_GT_GT_GT] = ACTIONS(5153),
    [anon_sym_EQ_EQ] = ACTIONS(5153),
    [anon_sym_BANG_EQ] = ACTIONS(5153),
    [anon_sym_GT_EQ] = ACTIONS(5153),
    [anon_sym_LT_EQ] = ACTIONS(5153),
    [anon_sym_DOT] = ACTIONS(5155),
    [anon_sym_EQ_GT] = ACTIONS(5153),
    [anon_sym_switch] = ACTIONS(5153),
    [anon_sym_DOT_DOT] = ACTIONS(5153),
    [anon_sym_and] = ACTIONS(5153),
    [anon_sym_or] = ACTIONS(5155),
    [anon_sym_AMP_AMP] = ACTIONS(5153),
    [anon_sym_PIPE_PIPE] = ACTIONS(5153),
    [anon_sym_QMARK_QMARK] = ACTIONS(5153),
    [anon_sym_from] = ACTIONS(5153),
    [anon_sym_join] = ACTIONS(5153),
    [anon_sym_on] = ACTIONS(5153),
    [anon_sym_equals] = ACTIONS(5153),
    [anon_sym_let] = ACTIONS(5153),
    [anon_sym_orderby] = ACTIONS(5153),
    [anon_sym_group] = ACTIONS(5153),
    [anon_sym_by] = ACTIONS(5153),
    [anon_sym_select] = ACTIONS(5153),
    [anon_sym_as] = ACTIONS(5153),
    [anon_sym_is] = ACTIONS(5153),
    [anon_sym_DASH_GT] = ACTIONS(5153),
    [anon_sym_with] = ACTIONS(5153),
    [aux_sym_preproc_if_token3] = ACTIONS(5153),
    [aux_sym_preproc_else_token1] = ACTIONS(5153),
    [aux_sym_preproc_elif_token1] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3118] = {
    [sym_preproc_region] = STATE(3118),
    [sym_preproc_endregion] = STATE(3118),
    [sym_preproc_line] = STATE(3118),
    [sym_preproc_pragma] = STATE(3118),
    [sym_preproc_nullable] = STATE(3118),
    [sym_preproc_error] = STATE(3118),
    [sym_preproc_warning] = STATE(3118),
    [sym_preproc_define] = STATE(3118),
    [sym_preproc_undef] = STATE(3118),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4297),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(4300),
    [anon_sym_where] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_BANG] = ACTIONS(4300),
    [anon_sym_PLUS_PLUS] = ACTIONS(4297),
    [anon_sym_DASH_DASH] = ACTIONS(4297),
    [anon_sym_PLUS] = ACTIONS(4300),
    [anon_sym_DASH] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_SLASH] = ACTIONS(4300),
    [anon_sym_PERCENT] = ACTIONS(4300),
    [anon_sym_CARET] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4300),
    [anon_sym_GT_GT] = ACTIONS(4300),
    [anon_sym_GT_GT_GT] = ACTIONS(4300),
    [anon_sym_EQ_EQ] = ACTIONS(4297),
    [anon_sym_BANG_EQ] = ACTIONS(4297),
    [anon_sym_GT_EQ] = ACTIONS(4297),
    [anon_sym_LT_EQ] = ACTIONS(4297),
    [anon_sym_DOT] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(4297),
    [anon_sym_DOT_DOT] = ACTIONS(4297),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4303),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4297),
    [anon_sym_QMARK_QMARK] = ACTIONS(4300),
    [anon_sym_from] = ACTIONS(4295),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_join] = ACTIONS(4295),
    [anon_sym_let] = ACTIONS(4295),
    [anon_sym_orderby] = ACTIONS(4295),
    [anon_sym_group] = ACTIONS(4295),
    [anon_sym_select] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(4297),
    [anon_sym_is] = ACTIONS(4297),
    [anon_sym_DASH_GT] = ACTIONS(4297),
    [anon_sym_with] = ACTIONS(4297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3119] = {
    [sym_preproc_region] = STATE(3119),
    [sym_preproc_endregion] = STATE(3119),
    [sym_preproc_line] = STATE(3119),
    [sym_preproc_pragma] = STATE(3119),
    [sym_preproc_nullable] = STATE(3119),
    [sym_preproc_error] = STATE(3119),
    [sym_preproc_warning] = STATE(3119),
    [sym_preproc_define] = STATE(3119),
    [sym_preproc_undef] = STATE(3119),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_COLON] = ACTIONS(5027),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_RBRACK] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_in] = ACTIONS(5027),
    [anon_sym_where] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5029),
    [anon_sym_BANG] = ACTIONS(5029),
    [anon_sym_PLUS_PLUS] = ACTIONS(5027),
    [anon_sym_DASH_DASH] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_PERCENT] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_GT] = ACTIONS(5027),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_EQ_GT] = ACTIONS(5027),
    [anon_sym_switch] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5027),
    [anon_sym_and] = ACTIONS(5027),
    [anon_sym_or] = ACTIONS(5029),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK_QMARK] = ACTIONS(5027),
    [anon_sym_from] = ACTIONS(5027),
    [anon_sym_join] = ACTIONS(5027),
    [anon_sym_on] = ACTIONS(5027),
    [anon_sym_equals] = ACTIONS(5027),
    [anon_sym_let] = ACTIONS(5027),
    [anon_sym_orderby] = ACTIONS(5027),
    [anon_sym_group] = ACTIONS(5027),
    [anon_sym_by] = ACTIONS(5027),
    [anon_sym_select] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5027),
    [anon_sym_is] = ACTIONS(5027),
    [anon_sym_DASH_GT] = ACTIONS(5027),
    [anon_sym_with] = ACTIONS(5027),
    [aux_sym_preproc_if_token3] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3120] = {
    [sym_preproc_region] = STATE(3120),
    [sym_preproc_endregion] = STATE(3120),
    [sym_preproc_line] = STATE(3120),
    [sym_preproc_pragma] = STATE(3120),
    [sym_preproc_nullable] = STATE(3120),
    [sym_preproc_error] = STATE(3120),
    [sym_preproc_warning] = STATE(3120),
    [sym_preproc_define] = STATE(3120),
    [sym_preproc_undef] = STATE(3120),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4898),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4898),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4898),
    [anon_sym_CARET] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4898),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3121] = {
    [sym_preproc_region] = STATE(3121),
    [sym_preproc_endregion] = STATE(3121),
    [sym_preproc_line] = STATE(3121),
    [sym_preproc_pragma] = STATE(3121),
    [sym_preproc_nullable] = STATE(3121),
    [sym_preproc_error] = STATE(3121),
    [sym_preproc_warning] = STATE(3121),
    [sym_preproc_define] = STATE(3121),
    [sym_preproc_undef] = STATE(3121),
    [anon_sym_SEMI] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_COMMA] = ACTIONS(5117),
    [anon_sym_RBRACK] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_RPAREN] = ACTIONS(5117),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5119),
    [anon_sym_in] = ACTIONS(5117),
    [anon_sym_where] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_BANG] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_PIPE] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_GT_GT_GT] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5117),
    [anon_sym_BANG_EQ] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5117),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_DOT] = ACTIONS(5119),
    [anon_sym_EQ_GT] = ACTIONS(5117),
    [anon_sym_switch] = ACTIONS(5117),
    [anon_sym_DOT_DOT] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_or] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5117),
    [anon_sym_QMARK_QMARK] = ACTIONS(5117),
    [anon_sym_from] = ACTIONS(5117),
    [anon_sym_join] = ACTIONS(5117),
    [anon_sym_on] = ACTIONS(5117),
    [anon_sym_equals] = ACTIONS(5117),
    [anon_sym_let] = ACTIONS(5117),
    [anon_sym_orderby] = ACTIONS(5117),
    [anon_sym_group] = ACTIONS(5117),
    [anon_sym_by] = ACTIONS(5117),
    [anon_sym_select] = ACTIONS(5117),
    [anon_sym_as] = ACTIONS(5117),
    [anon_sym_is] = ACTIONS(5117),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [anon_sym_with] = ACTIONS(5117),
    [aux_sym_preproc_if_token3] = ACTIONS(5117),
    [aux_sym_preproc_else_token1] = ACTIONS(5117),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3122] = {
    [sym_preproc_region] = STATE(3122),
    [sym_preproc_endregion] = STATE(3122),
    [sym_preproc_line] = STATE(3122),
    [sym_preproc_pragma] = STATE(3122),
    [sym_preproc_nullable] = STATE(3122),
    [sym_preproc_error] = STATE(3122),
    [sym_preproc_warning] = STATE(3122),
    [sym_preproc_define] = STATE(3122),
    [sym_preproc_undef] = STATE(3122),
    [anon_sym_SEMI] = ACTIONS(5007),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5007),
    [anon_sym_COMMA] = ACTIONS(5007),
    [anon_sym_RBRACK] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_LT] = ACTIONS(5009),
    [anon_sym_GT] = ACTIONS(5009),
    [anon_sym_in] = ACTIONS(5007),
    [anon_sym_where] = ACTIONS(5007),
    [anon_sym_QMARK] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_PLUS_PLUS] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5007),
    [anon_sym_PLUS] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5009),
    [anon_sym_PERCENT] = ACTIONS(5007),
    [anon_sym_CARET] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_LT_LT] = ACTIONS(5007),
    [anon_sym_GT_GT] = ACTIONS(5009),
    [anon_sym_GT_GT_GT] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(5007),
    [anon_sym_BANG_EQ] = ACTIONS(5007),
    [anon_sym_GT_EQ] = ACTIONS(5007),
    [anon_sym_LT_EQ] = ACTIONS(5007),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_EQ_GT] = ACTIONS(5007),
    [anon_sym_switch] = ACTIONS(5007),
    [anon_sym_DOT_DOT] = ACTIONS(5007),
    [anon_sym_and] = ACTIONS(5007),
    [anon_sym_or] = ACTIONS(5009),
    [anon_sym_AMP_AMP] = ACTIONS(5007),
    [anon_sym_PIPE_PIPE] = ACTIONS(5007),
    [anon_sym_QMARK_QMARK] = ACTIONS(5007),
    [anon_sym_from] = ACTIONS(5007),
    [anon_sym_join] = ACTIONS(5007),
    [anon_sym_on] = ACTIONS(5007),
    [anon_sym_equals] = ACTIONS(5007),
    [anon_sym_let] = ACTIONS(5007),
    [anon_sym_orderby] = ACTIONS(5007),
    [anon_sym_group] = ACTIONS(5007),
    [anon_sym_by] = ACTIONS(5007),
    [anon_sym_select] = ACTIONS(5007),
    [anon_sym_as] = ACTIONS(5007),
    [anon_sym_is] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5007),
    [anon_sym_with] = ACTIONS(5007),
    [aux_sym_preproc_if_token3] = ACTIONS(5007),
    [aux_sym_preproc_else_token1] = ACTIONS(5007),
    [aux_sym_preproc_elif_token1] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3123] = {
    [sym_preproc_region] = STATE(3123),
    [sym_preproc_endregion] = STATE(3123),
    [sym_preproc_line] = STATE(3123),
    [sym_preproc_pragma] = STATE(3123),
    [sym_preproc_nullable] = STATE(3123),
    [sym_preproc_error] = STATE(3123),
    [sym_preproc_warning] = STATE(3123),
    [sym_preproc_define] = STATE(3123),
    [sym_preproc_undef] = STATE(3123),
    [anon_sym_SEMI] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_COLON] = ACTIONS(5047),
    [anon_sym_COMMA] = ACTIONS(5047),
    [anon_sym_RBRACK] = ACTIONS(5047),
    [anon_sym_LPAREN] = ACTIONS(5047),
    [anon_sym_RPAREN] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_in] = ACTIONS(5047),
    [anon_sym_where] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_BANG] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5049),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_PIPE] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5049),
    [anon_sym_GT_GT_GT] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5047),
    [anon_sym_BANG_EQ] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_DOT] = ACTIONS(5049),
    [anon_sym_EQ_GT] = ACTIONS(5047),
    [anon_sym_switch] = ACTIONS(5047),
    [anon_sym_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_or] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_QMARK_QMARK] = ACTIONS(5047),
    [anon_sym_from] = ACTIONS(5047),
    [anon_sym_join] = ACTIONS(5047),
    [anon_sym_on] = ACTIONS(5047),
    [anon_sym_equals] = ACTIONS(5047),
    [anon_sym_let] = ACTIONS(5047),
    [anon_sym_orderby] = ACTIONS(5047),
    [anon_sym_group] = ACTIONS(5047),
    [anon_sym_by] = ACTIONS(5047),
    [anon_sym_select] = ACTIONS(5047),
    [anon_sym_as] = ACTIONS(5047),
    [anon_sym_is] = ACTIONS(5047),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [anon_sym_with] = ACTIONS(5047),
    [aux_sym_preproc_if_token3] = ACTIONS(5047),
    [aux_sym_preproc_else_token1] = ACTIONS(5047),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3124] = {
    [sym_preproc_region] = STATE(3124),
    [sym_preproc_endregion] = STATE(3124),
    [sym_preproc_line] = STATE(3124),
    [sym_preproc_pragma] = STATE(3124),
    [sym_preproc_nullable] = STATE(3124),
    [sym_preproc_error] = STATE(3124),
    [sym_preproc_warning] = STATE(3124),
    [sym_preproc_define] = STATE(3124),
    [sym_preproc_undef] = STATE(3124),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_RBRACK] = ACTIONS(5179),
    [anon_sym_LPAREN] = ACTIONS(5179),
    [anon_sym_RPAREN] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_in] = ACTIONS(5179),
    [anon_sym_where] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_BANG] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5181),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5181),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_GT_GT_GT] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_DOT] = ACTIONS(5181),
    [anon_sym_EQ_GT] = ACTIONS(5179),
    [anon_sym_switch] = ACTIONS(5179),
    [anon_sym_DOT_DOT] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5179),
    [anon_sym_QMARK_QMARK] = ACTIONS(5179),
    [anon_sym_from] = ACTIONS(5179),
    [anon_sym_join] = ACTIONS(5179),
    [anon_sym_on] = ACTIONS(5179),
    [anon_sym_equals] = ACTIONS(5179),
    [anon_sym_let] = ACTIONS(5179),
    [anon_sym_orderby] = ACTIONS(5179),
    [anon_sym_group] = ACTIONS(5179),
    [anon_sym_by] = ACTIONS(5179),
    [anon_sym_select] = ACTIONS(5179),
    [anon_sym_as] = ACTIONS(5179),
    [anon_sym_is] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5179),
    [anon_sym_with] = ACTIONS(5179),
    [aux_sym_preproc_if_token3] = ACTIONS(5179),
    [aux_sym_preproc_else_token1] = ACTIONS(5179),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3125] = {
    [sym_preproc_region] = STATE(3125),
    [sym_preproc_endregion] = STATE(3125),
    [sym_preproc_line] = STATE(3125),
    [sym_preproc_pragma] = STATE(3125),
    [sym_preproc_nullable] = STATE(3125),
    [sym_preproc_error] = STATE(3125),
    [sym_preproc_warning] = STATE(3125),
    [sym_preproc_define] = STATE(3125),
    [sym_preproc_undef] = STATE(3125),
    [anon_sym_SEMI] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_COMMA] = ACTIONS(5125),
    [anon_sym_RBRACK] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_RPAREN] = ACTIONS(5125),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5127),
    [anon_sym_in] = ACTIONS(5125),
    [anon_sym_where] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_BANG] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5127),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_PIPE] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_GT_GT_GT] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5125),
    [anon_sym_BANG_EQ] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5125),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5127),
    [anon_sym_EQ_GT] = ACTIONS(5125),
    [anon_sym_switch] = ACTIONS(5125),
    [anon_sym_DOT_DOT] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_or] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_QMARK_QMARK] = ACTIONS(5125),
    [anon_sym_from] = ACTIONS(5125),
    [anon_sym_join] = ACTIONS(5125),
    [anon_sym_on] = ACTIONS(5125),
    [anon_sym_equals] = ACTIONS(5125),
    [anon_sym_let] = ACTIONS(5125),
    [anon_sym_orderby] = ACTIONS(5125),
    [anon_sym_group] = ACTIONS(5125),
    [anon_sym_by] = ACTIONS(5125),
    [anon_sym_select] = ACTIONS(5125),
    [anon_sym_as] = ACTIONS(5125),
    [anon_sym_is] = ACTIONS(5125),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [anon_sym_with] = ACTIONS(5125),
    [aux_sym_preproc_if_token3] = ACTIONS(5125),
    [aux_sym_preproc_else_token1] = ACTIONS(5125),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3126] = {
    [sym_preproc_region] = STATE(3126),
    [sym_preproc_endregion] = STATE(3126),
    [sym_preproc_line] = STATE(3126),
    [sym_preproc_pragma] = STATE(3126),
    [sym_preproc_nullable] = STATE(3126),
    [sym_preproc_error] = STATE(3126),
    [sym_preproc_warning] = STATE(3126),
    [sym_preproc_define] = STATE(3126),
    [sym_preproc_undef] = STATE(3126),
    [anon_sym_SEMI] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_COMMA] = ACTIONS(5149),
    [anon_sym_RBRACK] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_RPAREN] = ACTIONS(5149),
    [anon_sym_RBRACE] = ACTIONS(5149),
    [anon_sym_LT] = ACTIONS(5151),
    [anon_sym_GT] = ACTIONS(5151),
    [anon_sym_in] = ACTIONS(5149),
    [anon_sym_where] = ACTIONS(5149),
    [anon_sym_QMARK] = ACTIONS(5151),
    [anon_sym_BANG] = ACTIONS(5151),
    [anon_sym_PLUS_PLUS] = ACTIONS(5149),
    [anon_sym_DASH_DASH] = ACTIONS(5149),
    [anon_sym_PLUS] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5149),
    [anon_sym_SLASH] = ACTIONS(5151),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [anon_sym_PIPE] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5151),
    [anon_sym_LT_LT] = ACTIONS(5149),
    [anon_sym_GT_GT] = ACTIONS(5151),
    [anon_sym_GT_GT_GT] = ACTIONS(5149),
    [anon_sym_EQ_EQ] = ACTIONS(5149),
    [anon_sym_BANG_EQ] = ACTIONS(5149),
    [anon_sym_GT_EQ] = ACTIONS(5149),
    [anon_sym_LT_EQ] = ACTIONS(5149),
    [anon_sym_DOT] = ACTIONS(5151),
    [anon_sym_EQ_GT] = ACTIONS(5149),
    [anon_sym_switch] = ACTIONS(5149),
    [anon_sym_DOT_DOT] = ACTIONS(5149),
    [anon_sym_and] = ACTIONS(5149),
    [anon_sym_or] = ACTIONS(5151),
    [anon_sym_AMP_AMP] = ACTIONS(5149),
    [anon_sym_PIPE_PIPE] = ACTIONS(5149),
    [anon_sym_QMARK_QMARK] = ACTIONS(5149),
    [anon_sym_from] = ACTIONS(5149),
    [anon_sym_join] = ACTIONS(5149),
    [anon_sym_on] = ACTIONS(5149),
    [anon_sym_equals] = ACTIONS(5149),
    [anon_sym_let] = ACTIONS(5149),
    [anon_sym_orderby] = ACTIONS(5149),
    [anon_sym_group] = ACTIONS(5149),
    [anon_sym_by] = ACTIONS(5149),
    [anon_sym_select] = ACTIONS(5149),
    [anon_sym_as] = ACTIONS(5149),
    [anon_sym_is] = ACTIONS(5149),
    [anon_sym_DASH_GT] = ACTIONS(5149),
    [anon_sym_with] = ACTIONS(5149),
    [aux_sym_preproc_if_token3] = ACTIONS(5149),
    [aux_sym_preproc_else_token1] = ACTIONS(5149),
    [aux_sym_preproc_elif_token1] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3127] = {
    [sym_preproc_region] = STATE(3127),
    [sym_preproc_endregion] = STATE(3127),
    [sym_preproc_line] = STATE(3127),
    [sym_preproc_pragma] = STATE(3127),
    [sym_preproc_nullable] = STATE(3127),
    [sym_preproc_error] = STATE(3127),
    [sym_preproc_warning] = STATE(3127),
    [sym_preproc_define] = STATE(3127),
    [sym_preproc_undef] = STATE(3127),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4028),
    [anon_sym_where] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(5262),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_from] = ACTIONS(4028),
    [anon_sym_join] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_let] = ACTIONS(4028),
    [anon_sym_orderby] = ACTIONS(4028),
    [anon_sym_group] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_select] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3128] = {
    [sym_modifier] = STATE(3166),
    [sym_preproc_region] = STATE(3128),
    [sym_preproc_endregion] = STATE(3128),
    [sym_preproc_line] = STATE(3128),
    [sym_preproc_pragma] = STATE(3128),
    [sym_preproc_nullable] = STATE(3128),
    [sym_preproc_error] = STATE(3128),
    [sym_preproc_warning] = STATE(3128),
    [sym_preproc_define] = STATE(3128),
    [sym_preproc_undef] = STATE(3128),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3128),
    [sym__identifier_token] = ACTIONS(5264),
    [anon_sym_extern] = ACTIONS(5266),
    [anon_sym_alias] = ACTIONS(5264),
    [anon_sym_global] = ACTIONS(5264),
    [anon_sym_unsafe] = ACTIONS(5266),
    [anon_sym_static] = ACTIONS(5266),
    [anon_sym_LPAREN] = ACTIONS(5269),
    [anon_sym_event] = ACTIONS(5264),
    [anon_sym_class] = ACTIONS(5264),
    [anon_sym_ref] = ACTIONS(5264),
    [anon_sym_struct] = ACTIONS(5264),
    [anon_sym_enum] = ACTIONS(5264),
    [anon_sym_interface] = ACTIONS(5264),
    [anon_sym_delegate] = ACTIONS(5264),
    [anon_sym_record] = ACTIONS(5264),
    [anon_sym_abstract] = ACTIONS(5266),
    [anon_sym_async] = ACTIONS(5266),
    [anon_sym_const] = ACTIONS(5266),
    [anon_sym_file] = ACTIONS(5266),
    [anon_sym_fixed] = ACTIONS(5266),
    [anon_sym_internal] = ACTIONS(5266),
    [anon_sym_new] = ACTIONS(5266),
    [anon_sym_override] = ACTIONS(5266),
    [anon_sym_partial] = ACTIONS(5266),
    [anon_sym_private] = ACTIONS(5266),
    [anon_sym_protected] = ACTIONS(5266),
    [anon_sym_public] = ACTIONS(5266),
    [anon_sym_readonly] = ACTIONS(5266),
    [anon_sym_required] = ACTIONS(5266),
    [anon_sym_sealed] = ACTIONS(5266),
    [anon_sym_virtual] = ACTIONS(5266),
    [anon_sym_volatile] = ACTIONS(5266),
    [anon_sym_where] = ACTIONS(5264),
    [anon_sym_notnull] = ACTIONS(5264),
    [anon_sym_unmanaged] = ACTIONS(5264),
    [anon_sym_implicit] = ACTIONS(5264),
    [anon_sym_explicit] = ACTIONS(5264),
    [anon_sym_scoped] = ACTIONS(5264),
    [anon_sym_var] = ACTIONS(5264),
    [sym_predefined_type] = ACTIONS(5264),
    [anon_sym_yield] = ACTIONS(5264),
    [anon_sym_when] = ACTIONS(5264),
    [anon_sym_from] = ACTIONS(5264),
    [anon_sym_into] = ACTIONS(5264),
    [anon_sym_join] = ACTIONS(5264),
    [anon_sym_on] = ACTIONS(5264),
    [anon_sym_equals] = ACTIONS(5264),
    [anon_sym_let] = ACTIONS(5264),
    [anon_sym_orderby] = ACTIONS(5264),
    [anon_sym_ascending] = ACTIONS(5264),
    [anon_sym_descending] = ACTIONS(5264),
    [anon_sym_group] = ACTIONS(5264),
    [anon_sym_by] = ACTIONS(5264),
    [anon_sym_select] = ACTIONS(5264),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3129] = {
    [sym_preproc_region] = STATE(3129),
    [sym_preproc_endregion] = STATE(3129),
    [sym_preproc_line] = STATE(3129),
    [sym_preproc_pragma] = STATE(3129),
    [sym_preproc_nullable] = STATE(3129),
    [sym_preproc_error] = STATE(3129),
    [sym_preproc_warning] = STATE(3129),
    [sym_preproc_define] = STATE(3129),
    [sym_preproc_undef] = STATE(3129),
    [anon_sym_SEMI] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_COLON] = ACTIONS(5023),
    [anon_sym_COMMA] = ACTIONS(5023),
    [anon_sym_RBRACK] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_RPAREN] = ACTIONS(5023),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_LT] = ACTIONS(5025),
    [anon_sym_GT] = ACTIONS(5025),
    [anon_sym_in] = ACTIONS(5023),
    [anon_sym_where] = ACTIONS(5023),
    [anon_sym_QMARK] = ACTIONS(5025),
    [anon_sym_BANG] = ACTIONS(5025),
    [anon_sym_PLUS_PLUS] = ACTIONS(5023),
    [anon_sym_DASH_DASH] = ACTIONS(5023),
    [anon_sym_PLUS] = ACTIONS(5025),
    [anon_sym_DASH] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5023),
    [anon_sym_SLASH] = ACTIONS(5025),
    [anon_sym_PERCENT] = ACTIONS(5023),
    [anon_sym_CARET] = ACTIONS(5023),
    [anon_sym_PIPE] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5025),
    [anon_sym_LT_LT] = ACTIONS(5023),
    [anon_sym_GT_GT] = ACTIONS(5025),
    [anon_sym_GT_GT_GT] = ACTIONS(5023),
    [anon_sym_EQ_EQ] = ACTIONS(5023),
    [anon_sym_BANG_EQ] = ACTIONS(5023),
    [anon_sym_GT_EQ] = ACTIONS(5023),
    [anon_sym_LT_EQ] = ACTIONS(5023),
    [anon_sym_DOT] = ACTIONS(5025),
    [anon_sym_EQ_GT] = ACTIONS(5023),
    [anon_sym_switch] = ACTIONS(5023),
    [anon_sym_DOT_DOT] = ACTIONS(5023),
    [anon_sym_and] = ACTIONS(5023),
    [anon_sym_or] = ACTIONS(5025),
    [anon_sym_AMP_AMP] = ACTIONS(5023),
    [anon_sym_PIPE_PIPE] = ACTIONS(5023),
    [anon_sym_QMARK_QMARK] = ACTIONS(5023),
    [anon_sym_from] = ACTIONS(5023),
    [anon_sym_join] = ACTIONS(5023),
    [anon_sym_on] = ACTIONS(5023),
    [anon_sym_equals] = ACTIONS(5023),
    [anon_sym_let] = ACTIONS(5023),
    [anon_sym_orderby] = ACTIONS(5023),
    [anon_sym_group] = ACTIONS(5023),
    [anon_sym_by] = ACTIONS(5023),
    [anon_sym_select] = ACTIONS(5023),
    [anon_sym_as] = ACTIONS(5023),
    [anon_sym_is] = ACTIONS(5023),
    [anon_sym_DASH_GT] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5023),
    [aux_sym_preproc_if_token3] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3130] = {
    [sym_preproc_region] = STATE(3130),
    [sym_preproc_endregion] = STATE(3130),
    [sym_preproc_line] = STATE(3130),
    [sym_preproc_pragma] = STATE(3130),
    [sym_preproc_nullable] = STATE(3130),
    [sym_preproc_error] = STATE(3130),
    [sym_preproc_warning] = STATE(3130),
    [sym_preproc_define] = STATE(3130),
    [sym_preproc_undef] = STATE(3130),
    [anon_sym_SEMI] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_COLON] = ACTIONS(5063),
    [anon_sym_COMMA] = ACTIONS(5063),
    [anon_sym_RBRACK] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5063),
    [anon_sym_RPAREN] = ACTIONS(5063),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(5065),
    [anon_sym_GT] = ACTIONS(5065),
    [anon_sym_in] = ACTIONS(5063),
    [anon_sym_where] = ACTIONS(5063),
    [anon_sym_QMARK] = ACTIONS(5065),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS_PLUS] = ACTIONS(5063),
    [anon_sym_DASH_DASH] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5063),
    [anon_sym_SLASH] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_CARET] = ACTIONS(5063),
    [anon_sym_PIPE] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5065),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5065),
    [anon_sym_GT_GT_GT] = ACTIONS(5063),
    [anon_sym_EQ_EQ] = ACTIONS(5063),
    [anon_sym_BANG_EQ] = ACTIONS(5063),
    [anon_sym_GT_EQ] = ACTIONS(5063),
    [anon_sym_LT_EQ] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [anon_sym_EQ_GT] = ACTIONS(5063),
    [anon_sym_switch] = ACTIONS(5063),
    [anon_sym_DOT_DOT] = ACTIONS(5063),
    [anon_sym_and] = ACTIONS(5063),
    [anon_sym_or] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5063),
    [anon_sym_PIPE_PIPE] = ACTIONS(5063),
    [anon_sym_QMARK_QMARK] = ACTIONS(5063),
    [anon_sym_from] = ACTIONS(5063),
    [anon_sym_join] = ACTIONS(5063),
    [anon_sym_on] = ACTIONS(5063),
    [anon_sym_equals] = ACTIONS(5063),
    [anon_sym_let] = ACTIONS(5063),
    [anon_sym_orderby] = ACTIONS(5063),
    [anon_sym_group] = ACTIONS(5063),
    [anon_sym_by] = ACTIONS(5063),
    [anon_sym_select] = ACTIONS(5063),
    [anon_sym_as] = ACTIONS(5063),
    [anon_sym_is] = ACTIONS(5063),
    [anon_sym_DASH_GT] = ACTIONS(5063),
    [anon_sym_with] = ACTIONS(5063),
    [aux_sym_preproc_if_token3] = ACTIONS(5063),
    [aux_sym_preproc_else_token1] = ACTIONS(5063),
    [aux_sym_preproc_elif_token1] = ACTIONS(5063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3131] = {
    [sym_preproc_region] = STATE(3131),
    [sym_preproc_endregion] = STATE(3131),
    [sym_preproc_line] = STATE(3131),
    [sym_preproc_pragma] = STATE(3131),
    [sym_preproc_nullable] = STATE(3131),
    [sym_preproc_error] = STATE(3131),
    [sym_preproc_warning] = STATE(3131),
    [sym_preproc_define] = STATE(3131),
    [sym_preproc_undef] = STATE(3131),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(5215),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(5262),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3132] = {
    [sym_preproc_region] = STATE(3132),
    [sym_preproc_endregion] = STATE(3132),
    [sym_preproc_line] = STATE(3132),
    [sym_preproc_pragma] = STATE(3132),
    [sym_preproc_nullable] = STATE(3132),
    [sym_preproc_error] = STATE(3132),
    [sym_preproc_warning] = STATE(3132),
    [sym_preproc_define] = STATE(3132),
    [sym_preproc_undef] = STATE(3132),
    [anon_sym_SEMI] = ACTIONS(5105),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_COLON] = ACTIONS(5105),
    [anon_sym_COMMA] = ACTIONS(5105),
    [anon_sym_RBRACK] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_RPAREN] = ACTIONS(5105),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5107),
    [anon_sym_in] = ACTIONS(5105),
    [anon_sym_where] = ACTIONS(5105),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_BANG] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5107),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_PIPE] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_GT_GT_GT] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5105),
    [anon_sym_BANG_EQ] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5105),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_DOT] = ACTIONS(5107),
    [anon_sym_EQ_GT] = ACTIONS(5105),
    [anon_sym_switch] = ACTIONS(5105),
    [anon_sym_DOT_DOT] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_or] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5105),
    [anon_sym_QMARK_QMARK] = ACTIONS(5105),
    [anon_sym_from] = ACTIONS(5105),
    [anon_sym_join] = ACTIONS(5105),
    [anon_sym_on] = ACTIONS(5105),
    [anon_sym_equals] = ACTIONS(5105),
    [anon_sym_let] = ACTIONS(5105),
    [anon_sym_orderby] = ACTIONS(5105),
    [anon_sym_group] = ACTIONS(5105),
    [anon_sym_by] = ACTIONS(5105),
    [anon_sym_select] = ACTIONS(5105),
    [anon_sym_as] = ACTIONS(5105),
    [anon_sym_is] = ACTIONS(5105),
    [anon_sym_DASH_GT] = ACTIONS(5105),
    [anon_sym_with] = ACTIONS(5105),
    [aux_sym_preproc_if_token3] = ACTIONS(5105),
    [aux_sym_preproc_else_token1] = ACTIONS(5105),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3133] = {
    [sym_preproc_region] = STATE(3133),
    [sym_preproc_endregion] = STATE(3133),
    [sym_preproc_line] = STATE(3133),
    [sym_preproc_pragma] = STATE(3133),
    [sym_preproc_nullable] = STATE(3133),
    [sym_preproc_error] = STATE(3133),
    [sym_preproc_warning] = STATE(3133),
    [sym_preproc_define] = STATE(3133),
    [sym_preproc_undef] = STATE(3133),
    [anon_sym_SEMI] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5135),
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_RBRACK] = ACTIONS(5135),
    [anon_sym_LPAREN] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_in] = ACTIONS(5135),
    [anon_sym_where] = ACTIONS(5135),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_BANG] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5137),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5137),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5137),
    [anon_sym_AMP] = ACTIONS(5137),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_GT_GT_GT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_DOT] = ACTIONS(5137),
    [anon_sym_EQ_GT] = ACTIONS(5135),
    [anon_sym_switch] = ACTIONS(5135),
    [anon_sym_DOT_DOT] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_or] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_QMARK_QMARK] = ACTIONS(5135),
    [anon_sym_from] = ACTIONS(5135),
    [anon_sym_join] = ACTIONS(5135),
    [anon_sym_on] = ACTIONS(5135),
    [anon_sym_equals] = ACTIONS(5135),
    [anon_sym_let] = ACTIONS(5135),
    [anon_sym_orderby] = ACTIONS(5135),
    [anon_sym_group] = ACTIONS(5135),
    [anon_sym_by] = ACTIONS(5135),
    [anon_sym_select] = ACTIONS(5135),
    [anon_sym_as] = ACTIONS(5135),
    [anon_sym_is] = ACTIONS(5135),
    [anon_sym_DASH_GT] = ACTIONS(5135),
    [anon_sym_with] = ACTIONS(5135),
    [aux_sym_preproc_if_token3] = ACTIONS(5135),
    [aux_sym_preproc_else_token1] = ACTIONS(5135),
    [aux_sym_preproc_elif_token1] = ACTIONS(5135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3134] = {
    [sym_preproc_region] = STATE(3134),
    [sym_preproc_endregion] = STATE(3134),
    [sym_preproc_line] = STATE(3134),
    [sym_preproc_pragma] = STATE(3134),
    [sym_preproc_nullable] = STATE(3134),
    [sym_preproc_error] = STATE(3134),
    [sym_preproc_warning] = STATE(3134),
    [sym_preproc_define] = STATE(3134),
    [sym_preproc_undef] = STATE(3134),
    [anon_sym_SEMI] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_COLON] = ACTIONS(5031),
    [anon_sym_COMMA] = ACTIONS(5031),
    [anon_sym_RBRACK] = ACTIONS(5031),
    [anon_sym_LPAREN] = ACTIONS(5031),
    [anon_sym_RPAREN] = ACTIONS(5031),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_GT] = ACTIONS(5033),
    [anon_sym_in] = ACTIONS(5031),
    [anon_sym_where] = ACTIONS(5031),
    [anon_sym_QMARK] = ACTIONS(5033),
    [anon_sym_BANG] = ACTIONS(5033),
    [anon_sym_PLUS_PLUS] = ACTIONS(5031),
    [anon_sym_DASH_DASH] = ACTIONS(5031),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5031),
    [anon_sym_SLASH] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5031),
    [anon_sym_CARET] = ACTIONS(5031),
    [anon_sym_PIPE] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(5031),
    [anon_sym_GT_GT] = ACTIONS(5033),
    [anon_sym_GT_GT_GT] = ACTIONS(5031),
    [anon_sym_EQ_EQ] = ACTIONS(5031),
    [anon_sym_BANG_EQ] = ACTIONS(5031),
    [anon_sym_GT_EQ] = ACTIONS(5031),
    [anon_sym_LT_EQ] = ACTIONS(5031),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_EQ_GT] = ACTIONS(5031),
    [anon_sym_switch] = ACTIONS(5031),
    [anon_sym_DOT_DOT] = ACTIONS(5031),
    [anon_sym_and] = ACTIONS(5031),
    [anon_sym_or] = ACTIONS(5033),
    [anon_sym_AMP_AMP] = ACTIONS(5031),
    [anon_sym_PIPE_PIPE] = ACTIONS(5031),
    [anon_sym_QMARK_QMARK] = ACTIONS(5031),
    [anon_sym_from] = ACTIONS(5031),
    [anon_sym_join] = ACTIONS(5031),
    [anon_sym_on] = ACTIONS(5031),
    [anon_sym_equals] = ACTIONS(5031),
    [anon_sym_let] = ACTIONS(5031),
    [anon_sym_orderby] = ACTIONS(5031),
    [anon_sym_group] = ACTIONS(5031),
    [anon_sym_by] = ACTIONS(5031),
    [anon_sym_select] = ACTIONS(5031),
    [anon_sym_as] = ACTIONS(5031),
    [anon_sym_is] = ACTIONS(5031),
    [anon_sym_DASH_GT] = ACTIONS(5031),
    [anon_sym_with] = ACTIONS(5031),
    [aux_sym_preproc_if_token3] = ACTIONS(5031),
    [aux_sym_preproc_else_token1] = ACTIONS(5031),
    [aux_sym_preproc_elif_token1] = ACTIONS(5031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3135] = {
    [sym_preproc_region] = STATE(3135),
    [sym_preproc_endregion] = STATE(3135),
    [sym_preproc_line] = STATE(3135),
    [sym_preproc_pragma] = STATE(3135),
    [sym_preproc_nullable] = STATE(3135),
    [sym_preproc_error] = STATE(3135),
    [sym_preproc_warning] = STATE(3135),
    [sym_preproc_define] = STATE(3135),
    [sym_preproc_undef] = STATE(3135),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5228),
    [anon_sym_in] = ACTIONS(5226),
    [anon_sym_where] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_BANG] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5228),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5228),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_from] = ACTIONS(5226),
    [anon_sym_join] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_let] = ACTIONS(5226),
    [anon_sym_orderby] = ACTIONS(5226),
    [anon_sym_group] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_select] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3136] = {
    [sym_attribute_list] = STATE(5405),
    [sym__attribute_list] = STATE(5406),
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_if_in_attribute_list] = STATE(5405),
    [sym_preproc_region] = STATE(3136),
    [sym_preproc_endregion] = STATE(3136),
    [sym_preproc_line] = STATE(3136),
    [sym_preproc_pragma] = STATE(3136),
    [sym_preproc_nullable] = STATE(3136),
    [sym_preproc_error] = STATE(3136),
    [sym_preproc_warning] = STATE(3136),
    [sym_preproc_define] = STATE(3136),
    [sym_preproc_undef] = STATE(3136),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(4439),
    [aux_sym__lambda_expression_init_repeat1] = STATE(3463),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_if_token1] = ACTIONS(4741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3137] = {
    [sym_preproc_region] = STATE(3137),
    [sym_preproc_endregion] = STATE(3137),
    [sym_preproc_line] = STATE(3137),
    [sym_preproc_pragma] = STATE(3137),
    [sym_preproc_nullable] = STATE(3137),
    [sym_preproc_error] = STATE(3137),
    [sym_preproc_warning] = STATE(3137),
    [sym_preproc_define] = STATE(3137),
    [sym_preproc_undef] = STATE(3137),
    [anon_sym_SEMI] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_COLON] = ACTIONS(4991),
    [anon_sym_COMMA] = ACTIONS(4991),
    [anon_sym_RBRACK] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_RPAREN] = ACTIONS(4991),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_LT] = ACTIONS(4993),
    [anon_sym_GT] = ACTIONS(4993),
    [anon_sym_in] = ACTIONS(4991),
    [anon_sym_where] = ACTIONS(4991),
    [anon_sym_QMARK] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4991),
    [anon_sym_PLUS] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4991),
    [anon_sym_SLASH] = ACTIONS(4993),
    [anon_sym_PERCENT] = ACTIONS(4991),
    [anon_sym_CARET] = ACTIONS(4991),
    [anon_sym_PIPE] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_LT_LT] = ACTIONS(4991),
    [anon_sym_GT_GT] = ACTIONS(4993),
    [anon_sym_GT_GT_GT] = ACTIONS(4991),
    [anon_sym_EQ_EQ] = ACTIONS(4991),
    [anon_sym_BANG_EQ] = ACTIONS(4991),
    [anon_sym_GT_EQ] = ACTIONS(4991),
    [anon_sym_LT_EQ] = ACTIONS(4991),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_EQ_GT] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_DOT_DOT] = ACTIONS(4991),
    [anon_sym_and] = ACTIONS(4991),
    [anon_sym_or] = ACTIONS(4993),
    [anon_sym_AMP_AMP] = ACTIONS(4991),
    [anon_sym_PIPE_PIPE] = ACTIONS(4991),
    [anon_sym_QMARK_QMARK] = ACTIONS(4991),
    [anon_sym_from] = ACTIONS(4991),
    [anon_sym_join] = ACTIONS(4991),
    [anon_sym_on] = ACTIONS(4991),
    [anon_sym_equals] = ACTIONS(4991),
    [anon_sym_let] = ACTIONS(4991),
    [anon_sym_orderby] = ACTIONS(4991),
    [anon_sym_group] = ACTIONS(4991),
    [anon_sym_by] = ACTIONS(4991),
    [anon_sym_select] = ACTIONS(4991),
    [anon_sym_as] = ACTIONS(4991),
    [anon_sym_is] = ACTIONS(4991),
    [anon_sym_DASH_GT] = ACTIONS(4991),
    [anon_sym_with] = ACTIONS(4991),
    [aux_sym_preproc_if_token3] = ACTIONS(4991),
    [aux_sym_preproc_else_token1] = ACTIONS(4991),
    [aux_sym_preproc_elif_token1] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3138] = {
    [sym_preproc_region] = STATE(3138),
    [sym_preproc_endregion] = STATE(3138),
    [sym_preproc_line] = STATE(3138),
    [sym_preproc_pragma] = STATE(3138),
    [sym_preproc_nullable] = STATE(3138),
    [sym_preproc_error] = STATE(3138),
    [sym_preproc_warning] = STATE(3138),
    [sym_preproc_define] = STATE(3138),
    [sym_preproc_undef] = STATE(3138),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3139] = {
    [sym_preproc_region] = STATE(3139),
    [sym_preproc_endregion] = STATE(3139),
    [sym_preproc_line] = STATE(3139),
    [sym_preproc_pragma] = STATE(3139),
    [sym_preproc_nullable] = STATE(3139),
    [sym_preproc_error] = STATE(3139),
    [sym_preproc_warning] = STATE(3139),
    [sym_preproc_define] = STATE(3139),
    [sym_preproc_undef] = STATE(3139),
    [anon_sym_SEMI] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_RBRACK] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_in] = ACTIONS(4291),
    [anon_sym_where] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_EQ_GT] = ACTIONS(4291),
    [anon_sym_switch] = ACTIONS(4291),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4291),
    [anon_sym_or] = ACTIONS(4293),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_from] = ACTIONS(4291),
    [anon_sym_join] = ACTIONS(4291),
    [anon_sym_on] = ACTIONS(4291),
    [anon_sym_equals] = ACTIONS(4291),
    [anon_sym_let] = ACTIONS(4291),
    [anon_sym_orderby] = ACTIONS(4291),
    [anon_sym_group] = ACTIONS(4291),
    [anon_sym_by] = ACTIONS(4291),
    [anon_sym_select] = ACTIONS(4291),
    [anon_sym_as] = ACTIONS(4291),
    [anon_sym_is] = ACTIONS(4291),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4291),
    [aux_sym_preproc_if_token3] = ACTIONS(4291),
    [aux_sym_preproc_else_token1] = ACTIONS(4291),
    [aux_sym_preproc_elif_token1] = ACTIONS(4291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3140] = {
    [sym_preproc_region] = STATE(3140),
    [sym_preproc_endregion] = STATE(3140),
    [sym_preproc_line] = STATE(3140),
    [sym_preproc_pragma] = STATE(3140),
    [sym_preproc_nullable] = STATE(3140),
    [sym_preproc_error] = STATE(3140),
    [sym_preproc_warning] = STATE(3140),
    [sym_preproc_define] = STATE(3140),
    [sym_preproc_undef] = STATE(3140),
    [anon_sym_EQ] = ACTIONS(5271),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5273),
    [anon_sym_DASH_EQ] = ACTIONS(5273),
    [anon_sym_STAR_EQ] = ACTIONS(5273),
    [anon_sym_SLASH_EQ] = ACTIONS(5273),
    [anon_sym_PERCENT_EQ] = ACTIONS(5273),
    [anon_sym_AMP_EQ] = ACTIONS(5273),
    [anon_sym_CARET_EQ] = ACTIONS(5273),
    [anon_sym_PIPE_EQ] = ACTIONS(5273),
    [anon_sym_LT_LT_EQ] = ACTIONS(5273),
    [anon_sym_GT_GT_EQ] = ACTIONS(5273),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5273),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5273),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_ascending] = ACTIONS(4898),
    [anon_sym_descending] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3141] = {
    [sym_preproc_region] = STATE(3141),
    [sym_preproc_endregion] = STATE(3141),
    [sym_preproc_line] = STATE(3141),
    [sym_preproc_pragma] = STATE(3141),
    [sym_preproc_nullable] = STATE(3141),
    [sym_preproc_error] = STATE(3141),
    [sym_preproc_warning] = STATE(3141),
    [sym_preproc_define] = STATE(3141),
    [sym_preproc_undef] = STATE(3141),
    [anon_sym_EQ] = ACTIONS(5275),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_PLUS_EQ] = ACTIONS(5277),
    [anon_sym_DASH_EQ] = ACTIONS(5277),
    [anon_sym_STAR_EQ] = ACTIONS(5277),
    [anon_sym_SLASH_EQ] = ACTIONS(5277),
    [anon_sym_PERCENT_EQ] = ACTIONS(5277),
    [anon_sym_AMP_EQ] = ACTIONS(5277),
    [anon_sym_CARET_EQ] = ACTIONS(5277),
    [anon_sym_PIPE_EQ] = ACTIONS(5277),
    [anon_sym_LT_LT_EQ] = ACTIONS(5277),
    [anon_sym_GT_GT_EQ] = ACTIONS(5277),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5277),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5277),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3142] = {
    [sym_preproc_region] = STATE(3142),
    [sym_preproc_endregion] = STATE(3142),
    [sym_preproc_line] = STATE(3142),
    [sym_preproc_pragma] = STATE(3142),
    [sym_preproc_nullable] = STATE(3142),
    [sym_preproc_error] = STATE(3142),
    [sym_preproc_warning] = STATE(3142),
    [sym_preproc_define] = STATE(3142),
    [sym_preproc_undef] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_COLON] = ACTIONS(5067),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_RBRACK] = ACTIONS(5067),
    [anon_sym_LPAREN] = ACTIONS(5067),
    [anon_sym_RPAREN] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5067),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_in] = ACTIONS(5067),
    [anon_sym_where] = ACTIONS(5067),
    [anon_sym_QMARK] = ACTIONS(5069),
    [anon_sym_BANG] = ACTIONS(5069),
    [anon_sym_PLUS_PLUS] = ACTIONS(5067),
    [anon_sym_DASH_DASH] = ACTIONS(5067),
    [anon_sym_PLUS] = ACTIONS(5069),
    [anon_sym_DASH] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5067),
    [anon_sym_SLASH] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5067),
    [anon_sym_CARET] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5067),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_GT_GT_GT] = ACTIONS(5067),
    [anon_sym_EQ_EQ] = ACTIONS(5067),
    [anon_sym_BANG_EQ] = ACTIONS(5067),
    [anon_sym_GT_EQ] = ACTIONS(5067),
    [anon_sym_LT_EQ] = ACTIONS(5067),
    [anon_sym_DOT] = ACTIONS(5069),
    [anon_sym_EQ_GT] = ACTIONS(5067),
    [anon_sym_switch] = ACTIONS(5067),
    [anon_sym_DOT_DOT] = ACTIONS(5067),
    [anon_sym_and] = ACTIONS(5067),
    [anon_sym_or] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5067),
    [anon_sym_PIPE_PIPE] = ACTIONS(5067),
    [anon_sym_QMARK_QMARK] = ACTIONS(5067),
    [anon_sym_from] = ACTIONS(5067),
    [anon_sym_join] = ACTIONS(5067),
    [anon_sym_on] = ACTIONS(5067),
    [anon_sym_equals] = ACTIONS(5067),
    [anon_sym_let] = ACTIONS(5067),
    [anon_sym_orderby] = ACTIONS(5067),
    [anon_sym_group] = ACTIONS(5067),
    [anon_sym_by] = ACTIONS(5067),
    [anon_sym_select] = ACTIONS(5067),
    [anon_sym_as] = ACTIONS(5067),
    [anon_sym_is] = ACTIONS(5067),
    [anon_sym_DASH_GT] = ACTIONS(5067),
    [anon_sym_with] = ACTIONS(5067),
    [aux_sym_preproc_if_token3] = ACTIONS(5067),
    [aux_sym_preproc_else_token1] = ACTIONS(5067),
    [aux_sym_preproc_elif_token1] = ACTIONS(5067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3143] = {
    [sym_preproc_region] = STATE(3143),
    [sym_preproc_endregion] = STATE(3143),
    [sym_preproc_line] = STATE(3143),
    [sym_preproc_pragma] = STATE(3143),
    [sym_preproc_nullable] = STATE(3143),
    [sym_preproc_error] = STATE(3143),
    [sym_preproc_warning] = STATE(3143),
    [sym_preproc_define] = STATE(3143),
    [sym_preproc_undef] = STATE(3143),
    [anon_sym_SEMI] = ACTIONS(4987),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_COLON] = ACTIONS(4987),
    [anon_sym_COMMA] = ACTIONS(4987),
    [anon_sym_RBRACK] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_LT] = ACTIONS(4989),
    [anon_sym_GT] = ACTIONS(4989),
    [anon_sym_in] = ACTIONS(4987),
    [anon_sym_where] = ACTIONS(4987),
    [anon_sym_QMARK] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4987),
    [anon_sym_PLUS] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4987),
    [anon_sym_SLASH] = ACTIONS(4989),
    [anon_sym_PERCENT] = ACTIONS(4987),
    [anon_sym_CARET] = ACTIONS(4987),
    [anon_sym_PIPE] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_LT_LT] = ACTIONS(4987),
    [anon_sym_GT_GT] = ACTIONS(4989),
    [anon_sym_GT_GT_GT] = ACTIONS(4987),
    [anon_sym_EQ_EQ] = ACTIONS(4987),
    [anon_sym_BANG_EQ] = ACTIONS(4987),
    [anon_sym_GT_EQ] = ACTIONS(4987),
    [anon_sym_LT_EQ] = ACTIONS(4987),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_EQ_GT] = ACTIONS(4987),
    [anon_sym_switch] = ACTIONS(4987),
    [anon_sym_DOT_DOT] = ACTIONS(4987),
    [anon_sym_and] = ACTIONS(4987),
    [anon_sym_or] = ACTIONS(4989),
    [anon_sym_AMP_AMP] = ACTIONS(4987),
    [anon_sym_PIPE_PIPE] = ACTIONS(4987),
    [anon_sym_QMARK_QMARK] = ACTIONS(4987),
    [anon_sym_from] = ACTIONS(4987),
    [anon_sym_join] = ACTIONS(4987),
    [anon_sym_on] = ACTIONS(4987),
    [anon_sym_equals] = ACTIONS(4987),
    [anon_sym_let] = ACTIONS(4987),
    [anon_sym_orderby] = ACTIONS(4987),
    [anon_sym_group] = ACTIONS(4987),
    [anon_sym_by] = ACTIONS(4987),
    [anon_sym_select] = ACTIONS(4987),
    [anon_sym_as] = ACTIONS(4987),
    [anon_sym_is] = ACTIONS(4987),
    [anon_sym_DASH_GT] = ACTIONS(4987),
    [anon_sym_with] = ACTIONS(4987),
    [aux_sym_preproc_if_token3] = ACTIONS(4987),
    [aux_sym_preproc_else_token1] = ACTIONS(4987),
    [aux_sym_preproc_elif_token1] = ACTIONS(4987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3144] = {
    [sym_preproc_region] = STATE(3144),
    [sym_preproc_endregion] = STATE(3144),
    [sym_preproc_line] = STATE(3144),
    [sym_preproc_pragma] = STATE(3144),
    [sym_preproc_nullable] = STATE(3144),
    [sym_preproc_error] = STATE(3144),
    [sym_preproc_warning] = STATE(3144),
    [sym_preproc_define] = STATE(3144),
    [sym_preproc_undef] = STATE(3144),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_COLON] = ACTIONS(4983),
    [anon_sym_COMMA] = ACTIONS(4983),
    [anon_sym_RBRACK] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_LT] = ACTIONS(4985),
    [anon_sym_GT] = ACTIONS(4985),
    [anon_sym_in] = ACTIONS(4983),
    [anon_sym_where] = ACTIONS(4983),
    [anon_sym_QMARK] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4985),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4985),
    [anon_sym_DASH] = ACTIONS(4985),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_SLASH] = ACTIONS(4985),
    [anon_sym_PERCENT] = ACTIONS(4983),
    [anon_sym_CARET] = ACTIONS(4983),
    [anon_sym_PIPE] = ACTIONS(4985),
    [anon_sym_AMP] = ACTIONS(4985),
    [anon_sym_LT_LT] = ACTIONS(4983),
    [anon_sym_GT_GT] = ACTIONS(4985),
    [anon_sym_GT_GT_GT] = ACTIONS(4983),
    [anon_sym_EQ_EQ] = ACTIONS(4983),
    [anon_sym_BANG_EQ] = ACTIONS(4983),
    [anon_sym_GT_EQ] = ACTIONS(4983),
    [anon_sym_LT_EQ] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4985),
    [anon_sym_EQ_GT] = ACTIONS(4983),
    [anon_sym_switch] = ACTIONS(4983),
    [anon_sym_DOT_DOT] = ACTIONS(4983),
    [anon_sym_and] = ACTIONS(4983),
    [anon_sym_or] = ACTIONS(4985),
    [anon_sym_AMP_AMP] = ACTIONS(4983),
    [anon_sym_PIPE_PIPE] = ACTIONS(4983),
    [anon_sym_QMARK_QMARK] = ACTIONS(4983),
    [anon_sym_from] = ACTIONS(4983),
    [anon_sym_join] = ACTIONS(4983),
    [anon_sym_on] = ACTIONS(4983),
    [anon_sym_equals] = ACTIONS(4983),
    [anon_sym_let] = ACTIONS(4983),
    [anon_sym_orderby] = ACTIONS(4983),
    [anon_sym_group] = ACTIONS(4983),
    [anon_sym_by] = ACTIONS(4983),
    [anon_sym_select] = ACTIONS(4983),
    [anon_sym_as] = ACTIONS(4983),
    [anon_sym_is] = ACTIONS(4983),
    [anon_sym_DASH_GT] = ACTIONS(4983),
    [anon_sym_with] = ACTIONS(4983),
    [aux_sym_preproc_if_token3] = ACTIONS(4983),
    [aux_sym_preproc_else_token1] = ACTIONS(4983),
    [aux_sym_preproc_elif_token1] = ACTIONS(4983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3145] = {
    [sym_preproc_region] = STATE(3145),
    [sym_preproc_endregion] = STATE(3145),
    [sym_preproc_line] = STATE(3145),
    [sym_preproc_pragma] = STATE(3145),
    [sym_preproc_nullable] = STATE(3145),
    [sym_preproc_error] = STATE(3145),
    [sym_preproc_warning] = STATE(3145),
    [sym_preproc_define] = STATE(3145),
    [sym_preproc_undef] = STATE(3145),
    [anon_sym_SEMI] = ACTIONS(5211),
    [anon_sym_LBRACK] = ACTIONS(5211),
    [anon_sym_COLON] = ACTIONS(5211),
    [anon_sym_COMMA] = ACTIONS(5211),
    [anon_sym_RBRACK] = ACTIONS(5211),
    [anon_sym_LPAREN] = ACTIONS(5211),
    [anon_sym_RPAREN] = ACTIONS(5211),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [anon_sym_LT] = ACTIONS(5213),
    [anon_sym_GT] = ACTIONS(5213),
    [anon_sym_in] = ACTIONS(5211),
    [anon_sym_where] = ACTIONS(5211),
    [anon_sym_QMARK] = ACTIONS(5213),
    [anon_sym_BANG] = ACTIONS(5213),
    [anon_sym_PLUS_PLUS] = ACTIONS(5211),
    [anon_sym_DASH_DASH] = ACTIONS(5211),
    [anon_sym_PLUS] = ACTIONS(5213),
    [anon_sym_DASH] = ACTIONS(5213),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_SLASH] = ACTIONS(5213),
    [anon_sym_PERCENT] = ACTIONS(5211),
    [anon_sym_CARET] = ACTIONS(5211),
    [anon_sym_PIPE] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5211),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_GT_GT_GT] = ACTIONS(5211),
    [anon_sym_EQ_EQ] = ACTIONS(5211),
    [anon_sym_BANG_EQ] = ACTIONS(5211),
    [anon_sym_GT_EQ] = ACTIONS(5211),
    [anon_sym_LT_EQ] = ACTIONS(5211),
    [anon_sym_DOT] = ACTIONS(5213),
    [anon_sym_EQ_GT] = ACTIONS(5211),
    [anon_sym_switch] = ACTIONS(5211),
    [anon_sym_DOT_DOT] = ACTIONS(5211),
    [anon_sym_and] = ACTIONS(5211),
    [anon_sym_or] = ACTIONS(5213),
    [anon_sym_AMP_AMP] = ACTIONS(5211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5211),
    [anon_sym_QMARK_QMARK] = ACTIONS(5211),
    [anon_sym_from] = ACTIONS(5211),
    [anon_sym_join] = ACTIONS(5211),
    [anon_sym_on] = ACTIONS(5211),
    [anon_sym_equals] = ACTIONS(5211),
    [anon_sym_let] = ACTIONS(5211),
    [anon_sym_orderby] = ACTIONS(5211),
    [anon_sym_group] = ACTIONS(5211),
    [anon_sym_by] = ACTIONS(5211),
    [anon_sym_select] = ACTIONS(5211),
    [anon_sym_as] = ACTIONS(5211),
    [anon_sym_is] = ACTIONS(5211),
    [anon_sym_DASH_GT] = ACTIONS(5211),
    [anon_sym_with] = ACTIONS(5211),
    [aux_sym_preproc_if_token3] = ACTIONS(5211),
    [aux_sym_preproc_else_token1] = ACTIONS(5211),
    [aux_sym_preproc_elif_token1] = ACTIONS(5211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3146] = {
    [sym_preproc_region] = STATE(3146),
    [sym_preproc_endregion] = STATE(3146),
    [sym_preproc_line] = STATE(3146),
    [sym_preproc_pragma] = STATE(3146),
    [sym_preproc_nullable] = STATE(3146),
    [sym_preproc_error] = STATE(3146),
    [sym_preproc_warning] = STATE(3146),
    [sym_preproc_define] = STATE(3146),
    [sym_preproc_undef] = STATE(3146),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACK] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_RPAREN] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5115),
    [anon_sym_in] = ACTIONS(5113),
    [anon_sym_where] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5115),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_PIPE] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_GT_GT_GT] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5113),
    [anon_sym_BANG_EQ] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5113),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_DOT] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5113),
    [anon_sym_switch] = ACTIONS(5113),
    [anon_sym_DOT_DOT] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5113),
    [anon_sym_QMARK_QMARK] = ACTIONS(5113),
    [anon_sym_from] = ACTIONS(5113),
    [anon_sym_join] = ACTIONS(5113),
    [anon_sym_on] = ACTIONS(5113),
    [anon_sym_equals] = ACTIONS(5113),
    [anon_sym_let] = ACTIONS(5113),
    [anon_sym_orderby] = ACTIONS(5113),
    [anon_sym_group] = ACTIONS(5113),
    [anon_sym_by] = ACTIONS(5113),
    [anon_sym_select] = ACTIONS(5113),
    [anon_sym_as] = ACTIONS(5113),
    [anon_sym_is] = ACTIONS(5113),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [anon_sym_with] = ACTIONS(5113),
    [aux_sym_preproc_if_token3] = ACTIONS(5113),
    [aux_sym_preproc_else_token1] = ACTIONS(5113),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3147] = {
    [sym_preproc_region] = STATE(3147),
    [sym_preproc_endregion] = STATE(3147),
    [sym_preproc_line] = STATE(3147),
    [sym_preproc_pragma] = STATE(3147),
    [sym_preproc_nullable] = STATE(3147),
    [sym_preproc_error] = STATE(3147),
    [sym_preproc_warning] = STATE(3147),
    [sym_preproc_define] = STATE(3147),
    [sym_preproc_undef] = STATE(3147),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACK] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [anon_sym_LPAREN] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_in] = ACTIONS(5222),
    [anon_sym_where] = ACTIONS(5222),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_BANG] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_PIPE] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5224),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5224),
    [anon_sym_GT_GT_GT] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5222),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_DOT] = ACTIONS(5224),
    [anon_sym_EQ_GT] = ACTIONS(5222),
    [anon_sym_switch] = ACTIONS(5222),
    [anon_sym_DOT_DOT] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_or] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5222),
    [anon_sym_QMARK_QMARK] = ACTIONS(5222),
    [anon_sym_from] = ACTIONS(5222),
    [anon_sym_join] = ACTIONS(5222),
    [anon_sym_on] = ACTIONS(5222),
    [anon_sym_equals] = ACTIONS(5222),
    [anon_sym_let] = ACTIONS(5222),
    [anon_sym_orderby] = ACTIONS(5222),
    [anon_sym_group] = ACTIONS(5222),
    [anon_sym_by] = ACTIONS(5222),
    [anon_sym_select] = ACTIONS(5222),
    [anon_sym_as] = ACTIONS(5222),
    [anon_sym_is] = ACTIONS(5222),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [anon_sym_with] = ACTIONS(5222),
    [aux_sym_preproc_if_token3] = ACTIONS(5222),
    [aux_sym_preproc_else_token1] = ACTIONS(5222),
    [aux_sym_preproc_elif_token1] = ACTIONS(5222),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3148] = {
    [sym_preproc_region] = STATE(3148),
    [sym_preproc_endregion] = STATE(3148),
    [sym_preproc_line] = STATE(3148),
    [sym_preproc_pragma] = STATE(3148),
    [sym_preproc_nullable] = STATE(3148),
    [sym_preproc_error] = STATE(3148),
    [sym_preproc_warning] = STATE(3148),
    [sym_preproc_define] = STATE(3148),
    [sym_preproc_undef] = STATE(3148),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(5097),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_RBRACK] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5099),
    [anon_sym_in] = ACTIONS(5097),
    [anon_sym_where] = ACTIONS(5097),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_BANG] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_SLASH] = ACTIONS(5099),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5097),
    [anon_sym_PIPE] = ACTIONS(5099),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym_LT_LT] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5099),
    [anon_sym_GT_GT_GT] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_DOT] = ACTIONS(5099),
    [anon_sym_EQ_GT] = ACTIONS(5097),
    [anon_sym_switch] = ACTIONS(5097),
    [anon_sym_DOT_DOT] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_or] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_QMARK_QMARK] = ACTIONS(5097),
    [anon_sym_from] = ACTIONS(5097),
    [anon_sym_join] = ACTIONS(5097),
    [anon_sym_on] = ACTIONS(5097),
    [anon_sym_equals] = ACTIONS(5097),
    [anon_sym_let] = ACTIONS(5097),
    [anon_sym_orderby] = ACTIONS(5097),
    [anon_sym_group] = ACTIONS(5097),
    [anon_sym_by] = ACTIONS(5097),
    [anon_sym_select] = ACTIONS(5097),
    [anon_sym_as] = ACTIONS(5097),
    [anon_sym_is] = ACTIONS(5097),
    [anon_sym_DASH_GT] = ACTIONS(5097),
    [anon_sym_with] = ACTIONS(5097),
    [aux_sym_preproc_if_token3] = ACTIONS(5097),
    [aux_sym_preproc_else_token1] = ACTIONS(5097),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3149] = {
    [sym_preproc_region] = STATE(3149),
    [sym_preproc_endregion] = STATE(3149),
    [sym_preproc_line] = STATE(3149),
    [sym_preproc_pragma] = STATE(3149),
    [sym_preproc_nullable] = STATE(3149),
    [sym_preproc_error] = STATE(3149),
    [sym_preproc_warning] = STATE(3149),
    [sym_preproc_define] = STATE(3149),
    [sym_preproc_undef] = STATE(3149),
    [anon_sym_SEMI] = ACTIONS(5093),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_COLON] = ACTIONS(5093),
    [anon_sym_COMMA] = ACTIONS(5093),
    [anon_sym_RBRACK] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_RPAREN] = ACTIONS(5093),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_in] = ACTIONS(5093),
    [anon_sym_where] = ACTIONS(5093),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_BANG] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5095),
    [anon_sym_PERCENT] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5093),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5093),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_GT_GT_GT] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_DOT] = ACTIONS(5095),
    [anon_sym_EQ_GT] = ACTIONS(5093),
    [anon_sym_switch] = ACTIONS(5093),
    [anon_sym_DOT_DOT] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_or] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_PIPE_PIPE] = ACTIONS(5093),
    [anon_sym_QMARK_QMARK] = ACTIONS(5093),
    [anon_sym_from] = ACTIONS(5093),
    [anon_sym_join] = ACTIONS(5093),
    [anon_sym_on] = ACTIONS(5093),
    [anon_sym_equals] = ACTIONS(5093),
    [anon_sym_let] = ACTIONS(5093),
    [anon_sym_orderby] = ACTIONS(5093),
    [anon_sym_group] = ACTIONS(5093),
    [anon_sym_by] = ACTIONS(5093),
    [anon_sym_select] = ACTIONS(5093),
    [anon_sym_as] = ACTIONS(5093),
    [anon_sym_is] = ACTIONS(5093),
    [anon_sym_DASH_GT] = ACTIONS(5093),
    [anon_sym_with] = ACTIONS(5093),
    [aux_sym_preproc_if_token3] = ACTIONS(5093),
    [aux_sym_preproc_else_token1] = ACTIONS(5093),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3150] = {
    [sym_preproc_region] = STATE(3150),
    [sym_preproc_endregion] = STATE(3150),
    [sym_preproc_line] = STATE(3150),
    [sym_preproc_pragma] = STATE(3150),
    [sym_preproc_nullable] = STATE(3150),
    [sym_preproc_error] = STATE(3150),
    [sym_preproc_warning] = STATE(3150),
    [sym_preproc_define] = STATE(3150),
    [sym_preproc_undef] = STATE(3150),
    [anon_sym_SEMI] = ACTIONS(5019),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_COLON] = ACTIONS(5019),
    [anon_sym_COMMA] = ACTIONS(5019),
    [anon_sym_RBRACK] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_RPAREN] = ACTIONS(5019),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_LT] = ACTIONS(5021),
    [anon_sym_GT] = ACTIONS(5021),
    [anon_sym_in] = ACTIONS(5019),
    [anon_sym_where] = ACTIONS(5019),
    [anon_sym_QMARK] = ACTIONS(5021),
    [anon_sym_BANG] = ACTIONS(5021),
    [anon_sym_PLUS_PLUS] = ACTIONS(5019),
    [anon_sym_DASH_DASH] = ACTIONS(5019),
    [anon_sym_PLUS] = ACTIONS(5021),
    [anon_sym_DASH] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(5019),
    [anon_sym_SLASH] = ACTIONS(5021),
    [anon_sym_PERCENT] = ACTIONS(5019),
    [anon_sym_CARET] = ACTIONS(5019),
    [anon_sym_PIPE] = ACTIONS(5021),
    [anon_sym_AMP] = ACTIONS(5021),
    [anon_sym_LT_LT] = ACTIONS(5019),
    [anon_sym_GT_GT] = ACTIONS(5021),
    [anon_sym_GT_GT_GT] = ACTIONS(5019),
    [anon_sym_EQ_EQ] = ACTIONS(5019),
    [anon_sym_BANG_EQ] = ACTIONS(5019),
    [anon_sym_GT_EQ] = ACTIONS(5019),
    [anon_sym_LT_EQ] = ACTIONS(5019),
    [anon_sym_DOT] = ACTIONS(5021),
    [anon_sym_EQ_GT] = ACTIONS(5019),
    [anon_sym_switch] = ACTIONS(5019),
    [anon_sym_DOT_DOT] = ACTIONS(5019),
    [anon_sym_and] = ACTIONS(5019),
    [anon_sym_or] = ACTIONS(5021),
    [anon_sym_AMP_AMP] = ACTIONS(5019),
    [anon_sym_PIPE_PIPE] = ACTIONS(5019),
    [anon_sym_QMARK_QMARK] = ACTIONS(5019),
    [anon_sym_from] = ACTIONS(5019),
    [anon_sym_join] = ACTIONS(5019),
    [anon_sym_on] = ACTIONS(5019),
    [anon_sym_equals] = ACTIONS(5019),
    [anon_sym_let] = ACTIONS(5019),
    [anon_sym_orderby] = ACTIONS(5019),
    [anon_sym_group] = ACTIONS(5019),
    [anon_sym_by] = ACTIONS(5019),
    [anon_sym_select] = ACTIONS(5019),
    [anon_sym_as] = ACTIONS(5019),
    [anon_sym_is] = ACTIONS(5019),
    [anon_sym_DASH_GT] = ACTIONS(5019),
    [anon_sym_with] = ACTIONS(5019),
    [aux_sym_preproc_if_token3] = ACTIONS(5019),
    [aux_sym_preproc_else_token1] = ACTIONS(5019),
    [aux_sym_preproc_elif_token1] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3151] = {
    [sym_preproc_region] = STATE(3151),
    [sym_preproc_endregion] = STATE(3151),
    [sym_preproc_line] = STATE(3151),
    [sym_preproc_pragma] = STATE(3151),
    [sym_preproc_nullable] = STATE(3151),
    [sym_preproc_error] = STATE(3151),
    [sym_preproc_warning] = STATE(3151),
    [sym_preproc_define] = STATE(3151),
    [sym_preproc_undef] = STATE(3151),
    [anon_sym_SEMI] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RBRACK] = ACTIONS(5139),
    [anon_sym_LPAREN] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_in] = ACTIONS(5139),
    [anon_sym_where] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(5141),
    [anon_sym_BANG] = ACTIONS(5141),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5141),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5141),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5141),
    [anon_sym_AMP] = ACTIONS(5141),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5141),
    [anon_sym_GT_GT_GT] = ACTIONS(5139),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5141),
    [anon_sym_EQ_GT] = ACTIONS(5139),
    [anon_sym_switch] = ACTIONS(5139),
    [anon_sym_DOT_DOT] = ACTIONS(5139),
    [anon_sym_and] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5141),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_QMARK_QMARK] = ACTIONS(5139),
    [anon_sym_from] = ACTIONS(5139),
    [anon_sym_join] = ACTIONS(5139),
    [anon_sym_on] = ACTIONS(5139),
    [anon_sym_equals] = ACTIONS(5139),
    [anon_sym_let] = ACTIONS(5139),
    [anon_sym_orderby] = ACTIONS(5139),
    [anon_sym_group] = ACTIONS(5139),
    [anon_sym_by] = ACTIONS(5139),
    [anon_sym_select] = ACTIONS(5139),
    [anon_sym_as] = ACTIONS(5139),
    [anon_sym_is] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [anon_sym_with] = ACTIONS(5139),
    [aux_sym_preproc_if_token3] = ACTIONS(5139),
    [aux_sym_preproc_else_token1] = ACTIONS(5139),
    [aux_sym_preproc_elif_token1] = ACTIONS(5139),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3152] = {
    [sym_preproc_region] = STATE(3152),
    [sym_preproc_endregion] = STATE(3152),
    [sym_preproc_line] = STATE(3152),
    [sym_preproc_pragma] = STATE(3152),
    [sym_preproc_nullable] = STATE(3152),
    [sym_preproc_error] = STATE(3152),
    [sym_preproc_warning] = STATE(3152),
    [sym_preproc_define] = STATE(3152),
    [sym_preproc_undef] = STATE(3152),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5234),
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_RBRACK] = ACTIONS(5234),
    [anon_sym_LPAREN] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5234),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5234),
    [anon_sym_where] = ACTIONS(5234),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_GT_GT_GT] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5234),
    [anon_sym_BANG_EQ] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5234),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_GT] = ACTIONS(5234),
    [anon_sym_switch] = ACTIONS(5234),
    [anon_sym_DOT_DOT] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_or] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5234),
    [anon_sym_QMARK_QMARK] = ACTIONS(5234),
    [anon_sym_from] = ACTIONS(5234),
    [anon_sym_join] = ACTIONS(5234),
    [anon_sym_on] = ACTIONS(5234),
    [anon_sym_equals] = ACTIONS(5234),
    [anon_sym_let] = ACTIONS(5234),
    [anon_sym_orderby] = ACTIONS(5234),
    [anon_sym_group] = ACTIONS(5234),
    [anon_sym_by] = ACTIONS(5234),
    [anon_sym_select] = ACTIONS(5234),
    [anon_sym_as] = ACTIONS(5234),
    [anon_sym_is] = ACTIONS(5234),
    [anon_sym_DASH_GT] = ACTIONS(5234),
    [anon_sym_with] = ACTIONS(5234),
    [aux_sym_preproc_if_token3] = ACTIONS(5234),
    [aux_sym_preproc_else_token1] = ACTIONS(5234),
    [aux_sym_preproc_elif_token1] = ACTIONS(5234),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3153] = {
    [sym_preproc_region] = STATE(3153),
    [sym_preproc_endregion] = STATE(3153),
    [sym_preproc_line] = STATE(3153),
    [sym_preproc_pragma] = STATE(3153),
    [sym_preproc_nullable] = STATE(3153),
    [sym_preproc_error] = STATE(3153),
    [sym_preproc_warning] = STATE(3153),
    [sym_preproc_define] = STATE(3153),
    [sym_preproc_undef] = STATE(3153),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5242),
    [anon_sym_RBRACK] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5242),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5244),
    [anon_sym_in] = ACTIONS(5242),
    [anon_sym_where] = ACTIONS(5242),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_PIPE] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5244),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5244),
    [anon_sym_GT_GT_GT] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_DOT] = ACTIONS(5244),
    [anon_sym_EQ_GT] = ACTIONS(5242),
    [anon_sym_switch] = ACTIONS(5242),
    [anon_sym_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5242),
    [anon_sym_QMARK_QMARK] = ACTIONS(5242),
    [anon_sym_from] = ACTIONS(5242),
    [anon_sym_join] = ACTIONS(5242),
    [anon_sym_on] = ACTIONS(5242),
    [anon_sym_equals] = ACTIONS(5242),
    [anon_sym_let] = ACTIONS(5242),
    [anon_sym_orderby] = ACTIONS(5242),
    [anon_sym_group] = ACTIONS(5242),
    [anon_sym_by] = ACTIONS(5242),
    [anon_sym_select] = ACTIONS(5242),
    [anon_sym_as] = ACTIONS(5242),
    [anon_sym_is] = ACTIONS(5242),
    [anon_sym_DASH_GT] = ACTIONS(5242),
    [anon_sym_with] = ACTIONS(5242),
    [aux_sym_preproc_if_token3] = ACTIONS(5242),
    [aux_sym_preproc_else_token1] = ACTIONS(5242),
    [aux_sym_preproc_elif_token1] = ACTIONS(5242),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3154] = {
    [sym_preproc_region] = STATE(3154),
    [sym_preproc_endregion] = STATE(3154),
    [sym_preproc_line] = STATE(3154),
    [sym_preproc_pragma] = STATE(3154),
    [sym_preproc_nullable] = STATE(3154),
    [sym_preproc_error] = STATE(3154),
    [sym_preproc_warning] = STATE(3154),
    [sym_preproc_define] = STATE(3154),
    [sym_preproc_undef] = STATE(3154),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5129),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_in] = ACTIONS(5129),
    [anon_sym_where] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_BANG] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5131),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_GT_GT_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_BANG_EQ] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5129),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_DOT] = ACTIONS(5131),
    [anon_sym_EQ_GT] = ACTIONS(5129),
    [anon_sym_switch] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_or] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_QMARK_QMARK] = ACTIONS(5129),
    [anon_sym_from] = ACTIONS(5129),
    [anon_sym_join] = ACTIONS(5129),
    [anon_sym_on] = ACTIONS(5129),
    [anon_sym_equals] = ACTIONS(5129),
    [anon_sym_let] = ACTIONS(5129),
    [anon_sym_orderby] = ACTIONS(5129),
    [anon_sym_group] = ACTIONS(5129),
    [anon_sym_by] = ACTIONS(5129),
    [anon_sym_select] = ACTIONS(5129),
    [anon_sym_as] = ACTIONS(5129),
    [anon_sym_is] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_with] = ACTIONS(5129),
    [aux_sym_preproc_if_token3] = ACTIONS(5129),
    [aux_sym_preproc_else_token1] = ACTIONS(5129),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3155] = {
    [sym_preproc_region] = STATE(3155),
    [sym_preproc_endregion] = STATE(3155),
    [sym_preproc_line] = STATE(3155),
    [sym_preproc_pragma] = STATE(3155),
    [sym_preproc_nullable] = STATE(3155),
    [sym_preproc_error] = STATE(3155),
    [sym_preproc_warning] = STATE(3155),
    [sym_preproc_define] = STATE(3155),
    [sym_preproc_undef] = STATE(3155),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_where] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(2983),
    [anon_sym_join] = ACTIONS(2983),
    [anon_sym_on] = ACTIONS(2983),
    [anon_sym_equals] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_orderby] = ACTIONS(2983),
    [anon_sym_group] = ACTIONS(2983),
    [anon_sym_by] = ACTIONS(2983),
    [anon_sym_select] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_is] = ACTIONS(2983),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [aux_sym_preproc_if_token3] = ACTIONS(2983),
    [aux_sym_preproc_else_token1] = ACTIONS(2983),
    [aux_sym_preproc_elif_token1] = ACTIONS(2983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3156] = {
    [sym_preproc_region] = STATE(3156),
    [sym_preproc_endregion] = STATE(3156),
    [sym_preproc_line] = STATE(3156),
    [sym_preproc_pragma] = STATE(3156),
    [sym_preproc_nullable] = STATE(3156),
    [sym_preproc_error] = STATE(3156),
    [sym_preproc_warning] = STATE(3156),
    [sym_preproc_define] = STATE(3156),
    [sym_preproc_undef] = STATE(3156),
    [anon_sym_SEMI] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_COLON] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RBRACK] = ACTIONS(5199),
    [anon_sym_LPAREN] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_LT] = ACTIONS(5201),
    [anon_sym_GT] = ACTIONS(5201),
    [anon_sym_in] = ACTIONS(5199),
    [anon_sym_where] = ACTIONS(5199),
    [anon_sym_QMARK] = ACTIONS(5201),
    [anon_sym_BANG] = ACTIONS(5201),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_STAR] = ACTIONS(5199),
    [anon_sym_SLASH] = ACTIONS(5201),
    [anon_sym_PERCENT] = ACTIONS(5199),
    [anon_sym_CARET] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5201),
    [anon_sym_AMP] = ACTIONS(5201),
    [anon_sym_LT_LT] = ACTIONS(5199),
    [anon_sym_GT_GT] = ACTIONS(5201),
    [anon_sym_GT_GT_GT] = ACTIONS(5199),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5201),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_switch] = ACTIONS(5199),
    [anon_sym_DOT_DOT] = ACTIONS(5199),
    [anon_sym_and] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5201),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_QMARK_QMARK] = ACTIONS(5199),
    [anon_sym_from] = ACTIONS(5199),
    [anon_sym_join] = ACTIONS(5199),
    [anon_sym_on] = ACTIONS(5199),
    [anon_sym_equals] = ACTIONS(5199),
    [anon_sym_let] = ACTIONS(5199),
    [anon_sym_orderby] = ACTIONS(5199),
    [anon_sym_group] = ACTIONS(5199),
    [anon_sym_by] = ACTIONS(5199),
    [anon_sym_select] = ACTIONS(5199),
    [anon_sym_as] = ACTIONS(5199),
    [anon_sym_is] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_with] = ACTIONS(5199),
    [aux_sym_preproc_if_token3] = ACTIONS(5199),
    [aux_sym_preproc_else_token1] = ACTIONS(5199),
    [aux_sym_preproc_elif_token1] = ACTIONS(5199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3157] = {
    [sym_preproc_region] = STATE(3157),
    [sym_preproc_endregion] = STATE(3157),
    [sym_preproc_line] = STATE(3157),
    [sym_preproc_pragma] = STATE(3157),
    [sym_preproc_nullable] = STATE(3157),
    [sym_preproc_error] = STATE(3157),
    [sym_preproc_warning] = STATE(3157),
    [sym_preproc_define] = STATE(3157),
    [sym_preproc_undef] = STATE(3157),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_event] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(5279),
    [anon_sym_implicit] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3158] = {
    [sym_preproc_region] = STATE(3158),
    [sym_preproc_endregion] = STATE(3158),
    [sym_preproc_line] = STATE(3158),
    [sym_preproc_pragma] = STATE(3158),
    [sym_preproc_nullable] = STATE(3158),
    [sym_preproc_error] = STATE(3158),
    [sym_preproc_warning] = STATE(3158),
    [sym_preproc_define] = STATE(3158),
    [sym_preproc_undef] = STATE(3158),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(5281),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5283),
    [anon_sym_DASH_EQ] = ACTIONS(5283),
    [anon_sym_STAR_EQ] = ACTIONS(5283),
    [anon_sym_SLASH_EQ] = ACTIONS(5283),
    [anon_sym_PERCENT_EQ] = ACTIONS(5283),
    [anon_sym_AMP_EQ] = ACTIONS(5283),
    [anon_sym_CARET_EQ] = ACTIONS(5283),
    [anon_sym_PIPE_EQ] = ACTIONS(5283),
    [anon_sym_LT_LT_EQ] = ACTIONS(5283),
    [anon_sym_GT_GT_EQ] = ACTIONS(5283),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5283),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3159] = {
    [sym_preproc_region] = STATE(3159),
    [sym_preproc_endregion] = STATE(3159),
    [sym_preproc_line] = STATE(3159),
    [sym_preproc_pragma] = STATE(3159),
    [sym_preproc_nullable] = STATE(3159),
    [sym_preproc_error] = STATE(3159),
    [sym_preproc_warning] = STATE(3159),
    [sym_preproc_define] = STATE(3159),
    [sym_preproc_undef] = STATE(3159),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3496),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3160] = {
    [sym_preproc_region] = STATE(3160),
    [sym_preproc_endregion] = STATE(3160),
    [sym_preproc_line] = STATE(3160),
    [sym_preproc_pragma] = STATE(3160),
    [sym_preproc_nullable] = STATE(3160),
    [sym_preproc_error] = STATE(3160),
    [sym_preproc_warning] = STATE(3160),
    [sym_preproc_define] = STATE(3160),
    [sym_preproc_undef] = STATE(3160),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_event] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3763),
    [anon_sym_implicit] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3161] = {
    [sym_preproc_region] = STATE(3161),
    [sym_preproc_endregion] = STATE(3161),
    [sym_preproc_line] = STATE(3161),
    [sym_preproc_pragma] = STATE(3161),
    [sym_preproc_nullable] = STATE(3161),
    [sym_preproc_error] = STATE(3161),
    [sym_preproc_warning] = STATE(3161),
    [sym_preproc_define] = STATE(3161),
    [sym_preproc_undef] = STATE(3161),
    [anon_sym_EQ] = ACTIONS(5285),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_PLUS_EQ] = ACTIONS(5287),
    [anon_sym_DASH_EQ] = ACTIONS(5287),
    [anon_sym_STAR_EQ] = ACTIONS(5287),
    [anon_sym_SLASH_EQ] = ACTIONS(5287),
    [anon_sym_PERCENT_EQ] = ACTIONS(5287),
    [anon_sym_AMP_EQ] = ACTIONS(5287),
    [anon_sym_CARET_EQ] = ACTIONS(5287),
    [anon_sym_PIPE_EQ] = ACTIONS(5287),
    [anon_sym_LT_LT_EQ] = ACTIONS(5287),
    [anon_sym_GT_GT_EQ] = ACTIONS(5287),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5287),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3162] = {
    [sym_preproc_region] = STATE(3162),
    [sym_preproc_endregion] = STATE(3162),
    [sym_preproc_line] = STATE(3162),
    [sym_preproc_pragma] = STATE(3162),
    [sym_preproc_nullable] = STATE(3162),
    [sym_preproc_error] = STATE(3162),
    [sym_preproc_warning] = STATE(3162),
    [sym_preproc_define] = STATE(3162),
    [sym_preproc_undef] = STATE(3162),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(4297),
    [anon_sym_RBRACK] = ACTIONS(4297),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(4297),
    [anon_sym_RBRACE] = ACTIONS(4297),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3163] = {
    [sym_preproc_region] = STATE(3163),
    [sym_preproc_endregion] = STATE(3163),
    [sym_preproc_line] = STATE(3163),
    [sym_preproc_pragma] = STATE(3163),
    [sym_preproc_nullable] = STATE(3163),
    [sym_preproc_error] = STATE(3163),
    [sym_preproc_warning] = STATE(3163),
    [sym_preproc_define] = STATE(3163),
    [sym_preproc_undef] = STATE(3163),
    [anon_sym_EQ] = ACTIONS(5289),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5291),
    [anon_sym_DASH_EQ] = ACTIONS(5291),
    [anon_sym_STAR_EQ] = ACTIONS(5291),
    [anon_sym_SLASH_EQ] = ACTIONS(5291),
    [anon_sym_PERCENT_EQ] = ACTIONS(5291),
    [anon_sym_AMP_EQ] = ACTIONS(5291),
    [anon_sym_CARET_EQ] = ACTIONS(5291),
    [anon_sym_PIPE_EQ] = ACTIONS(5291),
    [anon_sym_LT_LT_EQ] = ACTIONS(5291),
    [anon_sym_GT_GT_EQ] = ACTIONS(5291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5291),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5291),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3164] = {
    [sym_preproc_region] = STATE(3164),
    [sym_preproc_endregion] = STATE(3164),
    [sym_preproc_line] = STATE(3164),
    [sym_preproc_pragma] = STATE(3164),
    [sym_preproc_nullable] = STATE(3164),
    [sym_preproc_error] = STATE(3164),
    [sym_preproc_warning] = STATE(3164),
    [sym_preproc_define] = STATE(3164),
    [sym_preproc_undef] = STATE(3164),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_when] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_into] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3165] = {
    [sym_type_argument_list] = STATE(3206),
    [sym_preproc_region] = STATE(3165),
    [sym_preproc_endregion] = STATE(3165),
    [sym_preproc_line] = STATE(3165),
    [sym_preproc_pragma] = STATE(3165),
    [sym_preproc_nullable] = STATE(3165),
    [sym_preproc_error] = STATE(3165),
    [sym_preproc_warning] = STATE(3165),
    [sym_preproc_define] = STATE(3165),
    [sym_preproc_undef] = STATE(3165),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(5293),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3166] = {
    [sym_preproc_region] = STATE(3166),
    [sym_preproc_endregion] = STATE(3166),
    [sym_preproc_line] = STATE(3166),
    [sym_preproc_pragma] = STATE(3166),
    [sym_preproc_nullable] = STATE(3166),
    [sym_preproc_error] = STATE(3166),
    [sym_preproc_warning] = STATE(3166),
    [sym_preproc_define] = STATE(3166),
    [sym_preproc_undef] = STATE(3166),
    [sym__identifier_token] = ACTIONS(5298),
    [anon_sym_extern] = ACTIONS(5298),
    [anon_sym_alias] = ACTIONS(5298),
    [anon_sym_global] = ACTIONS(5298),
    [anon_sym_unsafe] = ACTIONS(5298),
    [anon_sym_static] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(5300),
    [anon_sym_event] = ACTIONS(5298),
    [anon_sym_class] = ACTIONS(5298),
    [anon_sym_ref] = ACTIONS(5298),
    [anon_sym_struct] = ACTIONS(5298),
    [anon_sym_enum] = ACTIONS(5298),
    [anon_sym_interface] = ACTIONS(5298),
    [anon_sym_delegate] = ACTIONS(5298),
    [anon_sym_record] = ACTIONS(5298),
    [anon_sym_abstract] = ACTIONS(5298),
    [anon_sym_async] = ACTIONS(5298),
    [anon_sym_const] = ACTIONS(5298),
    [anon_sym_file] = ACTIONS(5298),
    [anon_sym_fixed] = ACTIONS(5298),
    [anon_sym_internal] = ACTIONS(5298),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_override] = ACTIONS(5298),
    [anon_sym_partial] = ACTIONS(5298),
    [anon_sym_private] = ACTIONS(5298),
    [anon_sym_protected] = ACTIONS(5298),
    [anon_sym_public] = ACTIONS(5298),
    [anon_sym_readonly] = ACTIONS(5298),
    [anon_sym_required] = ACTIONS(5298),
    [anon_sym_sealed] = ACTIONS(5298),
    [anon_sym_virtual] = ACTIONS(5298),
    [anon_sym_volatile] = ACTIONS(5298),
    [anon_sym_where] = ACTIONS(5298),
    [anon_sym_notnull] = ACTIONS(5298),
    [anon_sym_unmanaged] = ACTIONS(5298),
    [anon_sym_implicit] = ACTIONS(5298),
    [anon_sym_explicit] = ACTIONS(5298),
    [anon_sym_scoped] = ACTIONS(5298),
    [anon_sym_var] = ACTIONS(5298),
    [sym_predefined_type] = ACTIONS(5298),
    [anon_sym_yield] = ACTIONS(5298),
    [anon_sym_when] = ACTIONS(5298),
    [anon_sym_from] = ACTIONS(5298),
    [anon_sym_into] = ACTIONS(5298),
    [anon_sym_join] = ACTIONS(5298),
    [anon_sym_on] = ACTIONS(5298),
    [anon_sym_equals] = ACTIONS(5298),
    [anon_sym_let] = ACTIONS(5298),
    [anon_sym_orderby] = ACTIONS(5298),
    [anon_sym_ascending] = ACTIONS(5298),
    [anon_sym_descending] = ACTIONS(5298),
    [anon_sym_group] = ACTIONS(5298),
    [anon_sym_by] = ACTIONS(5298),
    [anon_sym_select] = ACTIONS(5298),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3167] = {
    [sym_preproc_region] = STATE(3167),
    [sym_preproc_endregion] = STATE(3167),
    [sym_preproc_line] = STATE(3167),
    [sym_preproc_pragma] = STATE(3167),
    [sym_preproc_nullable] = STATE(3167),
    [sym_preproc_error] = STATE(3167),
    [sym_preproc_warning] = STATE(3167),
    [sym_preproc_define] = STATE(3167),
    [sym_preproc_undef] = STATE(3167),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_event] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_implicit] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3168] = {
    [sym_argument_list] = STATE(3179),
    [sym_initializer_expression] = STATE(3326),
    [sym_preproc_region] = STATE(3168),
    [sym_preproc_endregion] = STATE(3168),
    [sym_preproc_line] = STATE(3168),
    [sym_preproc_pragma] = STATE(3168),
    [sym_preproc_nullable] = STATE(3168),
    [sym_preproc_error] = STATE(3168),
    [sym_preproc_warning] = STATE(3168),
    [sym_preproc_define] = STATE(3168),
    [sym_preproc_undef] = STATE(3168),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_COLON] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(4811),
    [anon_sym_RBRACK] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LT] = ACTIONS(4815),
    [anon_sym_GT] = ACTIONS(4815),
    [anon_sym_in] = ACTIONS(4815),
    [anon_sym_QMARK] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4815),
    [anon_sym_PERCENT] = ACTIONS(4811),
    [anon_sym_CARET] = ACTIONS(4811),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_LT_LT] = ACTIONS(4811),
    [anon_sym_GT_GT] = ACTIONS(4815),
    [anon_sym_GT_GT_GT] = ACTIONS(4811),
    [anon_sym_EQ_EQ] = ACTIONS(4811),
    [anon_sym_BANG_EQ] = ACTIONS(4811),
    [anon_sym_GT_EQ] = ACTIONS(4811),
    [anon_sym_LT_EQ] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_EQ_GT] = ACTIONS(4811),
    [anon_sym_switch] = ACTIONS(4811),
    [anon_sym_when] = ACTIONS(4811),
    [anon_sym_DOT_DOT] = ACTIONS(4811),
    [anon_sym_and] = ACTIONS(4811),
    [anon_sym_or] = ACTIONS(4811),
    [anon_sym_AMP_AMP] = ACTIONS(4811),
    [anon_sym_PIPE_PIPE] = ACTIONS(4811),
    [anon_sym_QMARK_QMARK] = ACTIONS(4811),
    [anon_sym_into] = ACTIONS(4811),
    [anon_sym_on] = ACTIONS(4811),
    [anon_sym_equals] = ACTIONS(4811),
    [anon_sym_by] = ACTIONS(4811),
    [anon_sym_as] = ACTIONS(4811),
    [anon_sym_is] = ACTIONS(4811),
    [anon_sym_DASH_GT] = ACTIONS(4811),
    [anon_sym_with] = ACTIONS(4811),
    [aux_sym_preproc_if_token3] = ACTIONS(4811),
    [aux_sym_preproc_else_token1] = ACTIONS(4811),
    [aux_sym_preproc_elif_token1] = ACTIONS(4811),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3169] = {
    [sym_initializer_expression] = STATE(3330),
    [sym_preproc_region] = STATE(3169),
    [sym_preproc_endregion] = STATE(3169),
    [sym_preproc_line] = STATE(3169),
    [sym_preproc_pragma] = STATE(3169),
    [sym_preproc_nullable] = STATE(3169),
    [sym_preproc_error] = STATE(3169),
    [sym_preproc_warning] = STATE(3169),
    [sym_preproc_define] = STATE(3169),
    [sym_preproc_undef] = STATE(3169),
    [anon_sym_SEMI] = ACTIONS(4889),
    [anon_sym_LBRACK] = ACTIONS(4891),
    [anon_sym_COLON] = ACTIONS(4889),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RBRACK] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_in] = ACTIONS(4894),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_BANG] = ACTIONS(4894),
    [anon_sym_PLUS_PLUS] = ACTIONS(4889),
    [anon_sym_DASH_DASH] = ACTIONS(4889),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_SLASH] = ACTIONS(4894),
    [anon_sym_PERCENT] = ACTIONS(4889),
    [anon_sym_CARET] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4889),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_GT_GT_GT] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [anon_sym_GT_EQ] = ACTIONS(4889),
    [anon_sym_LT_EQ] = ACTIONS(4889),
    [anon_sym_DOT] = ACTIONS(4894),
    [anon_sym_EQ_GT] = ACTIONS(4889),
    [anon_sym_switch] = ACTIONS(4889),
    [anon_sym_when] = ACTIONS(4889),
    [anon_sym_DOT_DOT] = ACTIONS(4889),
    [anon_sym_and] = ACTIONS(4889),
    [anon_sym_or] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_QMARK_QMARK] = ACTIONS(4889),
    [anon_sym_into] = ACTIONS(4889),
    [anon_sym_on] = ACTIONS(4889),
    [anon_sym_equals] = ACTIONS(4889),
    [anon_sym_by] = ACTIONS(4889),
    [anon_sym_as] = ACTIONS(4889),
    [anon_sym_is] = ACTIONS(4889),
    [anon_sym_DASH_GT] = ACTIONS(4889),
    [anon_sym_with] = ACTIONS(4889),
    [aux_sym_preproc_if_token3] = ACTIONS(4889),
    [aux_sym_preproc_else_token1] = ACTIONS(4889),
    [aux_sym_preproc_elif_token1] = ACTIONS(4889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3170] = {
    [sym_attribute_list] = STATE(3570),
    [sym__attribute_list] = STATE(3569),
    [sym_preproc_if_in_attribute_list] = STATE(3570),
    [sym_preproc_region] = STATE(3170),
    [sym_preproc_endregion] = STATE(3170),
    [sym_preproc_line] = STATE(3170),
    [sym_preproc_pragma] = STATE(3170),
    [sym_preproc_nullable] = STATE(3170),
    [sym_preproc_error] = STATE(3170),
    [sym_preproc_warning] = STATE(3170),
    [sym_preproc_define] = STATE(3170),
    [sym_preproc_undef] = STATE(3170),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3170),
    [sym__identifier_token] = ACTIONS(4771),
    [anon_sym_extern] = ACTIONS(4771),
    [anon_sym_alias] = ACTIONS(4771),
    [anon_sym_global] = ACTIONS(4771),
    [anon_sym_unsafe] = ACTIONS(4771),
    [anon_sym_static] = ACTIONS(4771),
    [anon_sym_LBRACK] = ACTIONS(5304),
    [anon_sym_abstract] = ACTIONS(4771),
    [anon_sym_async] = ACTIONS(4771),
    [anon_sym_const] = ACTIONS(4771),
    [anon_sym_file] = ACTIONS(4771),
    [anon_sym_fixed] = ACTIONS(4771),
    [anon_sym_internal] = ACTIONS(4771),
    [anon_sym_new] = ACTIONS(4771),
    [anon_sym_override] = ACTIONS(4771),
    [anon_sym_partial] = ACTIONS(4771),
    [anon_sym_private] = ACTIONS(4771),
    [anon_sym_protected] = ACTIONS(4771),
    [anon_sym_public] = ACTIONS(4771),
    [anon_sym_readonly] = ACTIONS(4771),
    [anon_sym_required] = ACTIONS(4771),
    [anon_sym_sealed] = ACTIONS(4771),
    [anon_sym_virtual] = ACTIONS(4771),
    [anon_sym_volatile] = ACTIONS(4771),
    [anon_sym_where] = ACTIONS(4771),
    [anon_sym_notnull] = ACTIONS(4771),
    [anon_sym_unmanaged] = ACTIONS(4771),
    [anon_sym_get] = ACTIONS(4771),
    [anon_sym_set] = ACTIONS(4771),
    [anon_sym_add] = ACTIONS(4771),
    [anon_sym_remove] = ACTIONS(4771),
    [anon_sym_init] = ACTIONS(4771),
    [anon_sym_scoped] = ACTIONS(4771),
    [anon_sym_var] = ACTIONS(4771),
    [anon_sym_yield] = ACTIONS(4771),
    [anon_sym_when] = ACTIONS(4771),
    [anon_sym_from] = ACTIONS(4771),
    [anon_sym_into] = ACTIONS(4771),
    [anon_sym_join] = ACTIONS(4771),
    [anon_sym_on] = ACTIONS(4771),
    [anon_sym_equals] = ACTIONS(4771),
    [anon_sym_let] = ACTIONS(4771),
    [anon_sym_orderby] = ACTIONS(4771),
    [anon_sym_ascending] = ACTIONS(4771),
    [anon_sym_descending] = ACTIONS(4771),
    [anon_sym_group] = ACTIONS(4771),
    [anon_sym_by] = ACTIONS(4771),
    [anon_sym_select] = ACTIONS(4771),
    [aux_sym_preproc_if_token1] = ACTIONS(5307),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3171] = {
    [sym_preproc_region] = STATE(3171),
    [sym_preproc_endregion] = STATE(3171),
    [sym_preproc_line] = STATE(3171),
    [sym_preproc_pragma] = STATE(3171),
    [sym_preproc_nullable] = STATE(3171),
    [sym_preproc_error] = STATE(3171),
    [sym_preproc_warning] = STATE(3171),
    [sym_preproc_define] = STATE(3171),
    [sym_preproc_undef] = STATE(3171),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_when] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3172] = {
    [sym_initializer_expression] = STATE(3321),
    [sym_preproc_region] = STATE(3172),
    [sym_preproc_endregion] = STATE(3172),
    [sym_preproc_line] = STATE(3172),
    [sym_preproc_pragma] = STATE(3172),
    [sym_preproc_nullable] = STATE(3172),
    [sym_preproc_error] = STATE(3172),
    [sym_preproc_warning] = STATE(3172),
    [sym_preproc_define] = STATE(3172),
    [sym_preproc_undef] = STATE(3172),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_RBRACK] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_LT] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4873),
    [anon_sym_in] = ACTIONS(4873),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_BANG] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4873),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_SLASH] = ACTIONS(4873),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4873),
    [anon_sym_AMP] = ACTIONS(4873),
    [anon_sym_LT_LT] = ACTIONS(4871),
    [anon_sym_GT_GT] = ACTIONS(4873),
    [anon_sym_GT_GT_GT] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4871),
    [anon_sym_BANG_EQ] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4871),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4873),
    [anon_sym_EQ_GT] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(4871),
    [anon_sym_when] = ACTIONS(4871),
    [anon_sym_DOT_DOT] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_or] = ACTIONS(4871),
    [anon_sym_AMP_AMP] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE] = ACTIONS(4871),
    [anon_sym_QMARK_QMARK] = ACTIONS(4871),
    [anon_sym_into] = ACTIONS(4871),
    [anon_sym_on] = ACTIONS(4871),
    [anon_sym_equals] = ACTIONS(4871),
    [anon_sym_by] = ACTIONS(4871),
    [anon_sym_as] = ACTIONS(4871),
    [anon_sym_is] = ACTIONS(4871),
    [anon_sym_DASH_GT] = ACTIONS(4871),
    [anon_sym_with] = ACTIONS(4871),
    [aux_sym_preproc_if_token3] = ACTIONS(4871),
    [aux_sym_preproc_else_token1] = ACTIONS(4871),
    [aux_sym_preproc_elif_token1] = ACTIONS(4871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3173] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3173),
    [sym_preproc_endregion] = STATE(3173),
    [sym_preproc_line] = STATE(3173),
    [sym_preproc_pragma] = STATE(3173),
    [sym_preproc_nullable] = STATE(3173),
    [sym_preproc_error] = STATE(3173),
    [sym_preproc_warning] = STATE(3173),
    [sym_preproc_define] = STATE(3173),
    [sym_preproc_undef] = STATE(3173),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COLON] = ACTIONS(4885),
    [anon_sym_COMMA] = ACTIONS(4885),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_in] = ACTIONS(4887),
    [anon_sym_QMARK] = ACTIONS(4887),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(4887),
    [anon_sym_DASH] = ACTIONS(4887),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4887),
    [anon_sym_PERCENT] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_AMP] = ACTIONS(4887),
    [anon_sym_LT_LT] = ACTIONS(4885),
    [anon_sym_GT_GT] = ACTIONS(4887),
    [anon_sym_GT_GT_GT] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [anon_sym_GT_EQ] = ACTIONS(4885),
    [anon_sym_LT_EQ] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_EQ_GT] = ACTIONS(4885),
    [anon_sym_switch] = ACTIONS(4885),
    [anon_sym_when] = ACTIONS(4885),
    [anon_sym_DOT_DOT] = ACTIONS(4885),
    [anon_sym_and] = ACTIONS(4885),
    [anon_sym_or] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_QMARK_QMARK] = ACTIONS(4885),
    [anon_sym_into] = ACTIONS(4885),
    [anon_sym_on] = ACTIONS(4885),
    [anon_sym_equals] = ACTIONS(4885),
    [anon_sym_by] = ACTIONS(4885),
    [anon_sym_as] = ACTIONS(4885),
    [anon_sym_is] = ACTIONS(4885),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4885),
    [aux_sym_preproc_if_token3] = ACTIONS(4885),
    [aux_sym_preproc_else_token1] = ACTIONS(4885),
    [aux_sym_preproc_elif_token1] = ACTIONS(4885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3174] = {
    [sym_preproc_region] = STATE(3174),
    [sym_preproc_endregion] = STATE(3174),
    [sym_preproc_line] = STATE(3174),
    [sym_preproc_pragma] = STATE(3174),
    [sym_preproc_nullable] = STATE(3174),
    [sym_preproc_error] = STATE(3174),
    [sym_preproc_warning] = STATE(3174),
    [sym_preproc_define] = STATE(3174),
    [sym_preproc_undef] = STATE(3174),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3633),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3630),
    [anon_sym_when] = ACTIONS(3630),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3630),
    [anon_sym_or] = ACTIONS(3630),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3630),
    [anon_sym_into] = ACTIONS(3630),
    [anon_sym_on] = ACTIONS(3630),
    [anon_sym_equals] = ACTIONS(3630),
    [anon_sym_by] = ACTIONS(3630),
    [anon_sym_as] = ACTIONS(3630),
    [anon_sym_is] = ACTIONS(3630),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3630),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3175] = {
    [sym_preproc_region] = STATE(3175),
    [sym_preproc_endregion] = STATE(3175),
    [sym_preproc_line] = STATE(3175),
    [sym_preproc_pragma] = STATE(3175),
    [sym_preproc_nullable] = STATE(3175),
    [sym_preproc_error] = STATE(3175),
    [sym_preproc_warning] = STATE(3175),
    [sym_preproc_define] = STATE(3175),
    [sym_preproc_undef] = STATE(3175),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3176] = {
    [sym_argument_list] = STATE(3259),
    [sym_initializer_expression] = STATE(3422),
    [sym_preproc_region] = STATE(3176),
    [sym_preproc_endregion] = STATE(3176),
    [sym_preproc_line] = STATE(3176),
    [sym_preproc_pragma] = STATE(3176),
    [sym_preproc_nullable] = STATE(3176),
    [sym_preproc_error] = STATE(3176),
    [sym_preproc_warning] = STATE(3176),
    [sym_preproc_define] = STATE(3176),
    [sym_preproc_undef] = STATE(3176),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_COLON] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(4811),
    [anon_sym_RBRACK] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LT] = ACTIONS(4815),
    [anon_sym_GT] = ACTIONS(4815),
    [anon_sym_in] = ACTIONS(4811),
    [anon_sym_QMARK] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4815),
    [anon_sym_PERCENT] = ACTIONS(4811),
    [anon_sym_CARET] = ACTIONS(4811),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_LT_LT] = ACTIONS(4811),
    [anon_sym_GT_GT] = ACTIONS(4815),
    [anon_sym_GT_GT_GT] = ACTIONS(4811),
    [anon_sym_EQ_EQ] = ACTIONS(4811),
    [anon_sym_BANG_EQ] = ACTIONS(4811),
    [anon_sym_GT_EQ] = ACTIONS(4811),
    [anon_sym_LT_EQ] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_EQ_GT] = ACTIONS(4811),
    [anon_sym_switch] = ACTIONS(4811),
    [anon_sym_when] = ACTIONS(4811),
    [anon_sym_DOT_DOT] = ACTIONS(4811),
    [anon_sym_and] = ACTIONS(4811),
    [anon_sym_or] = ACTIONS(4811),
    [anon_sym_AMP_AMP] = ACTIONS(4811),
    [anon_sym_PIPE_PIPE] = ACTIONS(4811),
    [anon_sym_QMARK_QMARK] = ACTIONS(4811),
    [anon_sym_on] = ACTIONS(4811),
    [anon_sym_equals] = ACTIONS(4811),
    [anon_sym_by] = ACTIONS(4811),
    [anon_sym_as] = ACTIONS(4811),
    [anon_sym_is] = ACTIONS(4811),
    [anon_sym_DASH_GT] = ACTIONS(4811),
    [anon_sym_with] = ACTIONS(4811),
    [aux_sym_preproc_if_token3] = ACTIONS(4811),
    [aux_sym_preproc_else_token1] = ACTIONS(4811),
    [aux_sym_preproc_elif_token1] = ACTIONS(4811),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3177] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3177),
    [sym_preproc_endregion] = STATE(3177),
    [sym_preproc_line] = STATE(3177),
    [sym_preproc_pragma] = STATE(3177),
    [sym_preproc_nullable] = STATE(3177),
    [sym_preproc_error] = STATE(3177),
    [sym_preproc_warning] = STATE(3177),
    [sym_preproc_define] = STATE(3177),
    [sym_preproc_undef] = STATE(3177),
    [anon_sym_SEMI] = ACTIONS(4875),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_RBRACK] = ACTIONS(4875),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [anon_sym_LT] = ACTIONS(4879),
    [anon_sym_GT] = ACTIONS(4879),
    [anon_sym_in] = ACTIONS(4879),
    [anon_sym_QMARK] = ACTIONS(4879),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4875),
    [anon_sym_SLASH] = ACTIONS(4879),
    [anon_sym_PERCENT] = ACTIONS(4875),
    [anon_sym_CARET] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4879),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_LT_LT] = ACTIONS(4875),
    [anon_sym_GT_GT] = ACTIONS(4879),
    [anon_sym_GT_GT_GT] = ACTIONS(4875),
    [anon_sym_EQ_EQ] = ACTIONS(4875),
    [anon_sym_BANG_EQ] = ACTIONS(4875),
    [anon_sym_GT_EQ] = ACTIONS(4875),
    [anon_sym_LT_EQ] = ACTIONS(4875),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_EQ_GT] = ACTIONS(4875),
    [anon_sym_switch] = ACTIONS(4875),
    [anon_sym_when] = ACTIONS(4875),
    [anon_sym_DOT_DOT] = ACTIONS(4875),
    [anon_sym_and] = ACTIONS(4875),
    [anon_sym_or] = ACTIONS(4875),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_PIPE_PIPE] = ACTIONS(4875),
    [anon_sym_QMARK_QMARK] = ACTIONS(4875),
    [anon_sym_into] = ACTIONS(4875),
    [anon_sym_on] = ACTIONS(4875),
    [anon_sym_equals] = ACTIONS(4875),
    [anon_sym_by] = ACTIONS(4875),
    [anon_sym_as] = ACTIONS(4875),
    [anon_sym_is] = ACTIONS(4875),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4875),
    [aux_sym_preproc_if_token3] = ACTIONS(4875),
    [aux_sym_preproc_else_token1] = ACTIONS(4875),
    [aux_sym_preproc_elif_token1] = ACTIONS(4875),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3178] = {
    [sym_preproc_region] = STATE(3178),
    [sym_preproc_endregion] = STATE(3178),
    [sym_preproc_line] = STATE(3178),
    [sym_preproc_pragma] = STATE(3178),
    [sym_preproc_nullable] = STATE(3178),
    [sym_preproc_error] = STATE(3178),
    [sym_preproc_warning] = STATE(3178),
    [sym_preproc_define] = STATE(3178),
    [sym_preproc_undef] = STATE(3178),
    [anon_sym_EQ] = ACTIONS(5318),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5320),
    [anon_sym_DASH_EQ] = ACTIONS(5320),
    [anon_sym_STAR_EQ] = ACTIONS(5320),
    [anon_sym_SLASH_EQ] = ACTIONS(5320),
    [anon_sym_PERCENT_EQ] = ACTIONS(5320),
    [anon_sym_AMP_EQ] = ACTIONS(5320),
    [anon_sym_CARET_EQ] = ACTIONS(5320),
    [anon_sym_PIPE_EQ] = ACTIONS(5320),
    [anon_sym_LT_LT_EQ] = ACTIONS(5320),
    [anon_sym_GT_GT_EQ] = ACTIONS(5320),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5320),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5320),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3179] = {
    [sym_initializer_expression] = STATE(3278),
    [sym_preproc_region] = STATE(3179),
    [sym_preproc_endregion] = STATE(3179),
    [sym_preproc_line] = STATE(3179),
    [sym_preproc_pragma] = STATE(3179),
    [sym_preproc_nullable] = STATE(3179),
    [sym_preproc_error] = STATE(3179),
    [sym_preproc_warning] = STATE(3179),
    [sym_preproc_define] = STATE(3179),
    [sym_preproc_undef] = STATE(3179),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_COLON] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_RBRACK] = ACTIONS(4904),
    [anon_sym_LPAREN] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_in] = ACTIONS(4906),
    [anon_sym_QMARK] = ACTIONS(4906),
    [anon_sym_BANG] = ACTIONS(4906),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_CARET] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_GT_GT_GT] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_EQ_GT] = ACTIONS(4904),
    [anon_sym_switch] = ACTIONS(4904),
    [anon_sym_when] = ACTIONS(4904),
    [anon_sym_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_QMARK_QMARK] = ACTIONS(4904),
    [anon_sym_into] = ACTIONS(4904),
    [anon_sym_on] = ACTIONS(4904),
    [anon_sym_equals] = ACTIONS(4904),
    [anon_sym_by] = ACTIONS(4904),
    [anon_sym_as] = ACTIONS(4904),
    [anon_sym_is] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [anon_sym_with] = ACTIONS(4904),
    [aux_sym_preproc_if_token3] = ACTIONS(4904),
    [aux_sym_preproc_else_token1] = ACTIONS(4904),
    [aux_sym_preproc_elif_token1] = ACTIONS(4904),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3180] = {
    [sym_block] = STATE(2031),
    [sym_preproc_region] = STATE(3180),
    [sym_preproc_endregion] = STATE(3180),
    [sym_preproc_line] = STATE(3180),
    [sym_preproc_pragma] = STATE(3180),
    [sym_preproc_nullable] = STATE(3180),
    [sym_preproc_error] = STATE(3180),
    [sym_preproc_warning] = STATE(3180),
    [sym_preproc_define] = STATE(3180),
    [sym_preproc_undef] = STATE(3180),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3181] = {
    [sym_type_argument_list] = STATE(3260),
    [sym_preproc_region] = STATE(3181),
    [sym_preproc_endregion] = STATE(3181),
    [sym_preproc_line] = STATE(3181),
    [sym_preproc_pragma] = STATE(3181),
    [sym_preproc_nullable] = STATE(3181),
    [sym_preproc_error] = STATE(3181),
    [sym_preproc_warning] = STATE(3181),
    [sym_preproc_define] = STATE(3181),
    [sym_preproc_undef] = STATE(3181),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(5324),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [3182] = {
    [sym_type_argument_list] = STATE(3206),
    [sym_preproc_region] = STATE(3182),
    [sym_preproc_endregion] = STATE(3182),
    [sym_preproc_line] = STATE(3182),
    [sym_preproc_pragma] = STATE(3182),
    [sym_preproc_nullable] = STATE(3182),
    [sym_preproc_error] = STATE(3182),
    [sym_preproc_warning] = STATE(3182),
    [sym_preproc_define] = STATE(3182),
    [sym_preproc_undef] = STATE(3182),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(5293),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3183] = {
    [sym_block] = STATE(1986),
    [sym_preproc_region] = STATE(3183),
    [sym_preproc_endregion] = STATE(3183),
    [sym_preproc_line] = STATE(3183),
    [sym_preproc_pragma] = STATE(3183),
    [sym_preproc_nullable] = STATE(3183),
    [sym_preproc_error] = STATE(3183),
    [sym_preproc_warning] = STATE(3183),
    [sym_preproc_define] = STATE(3183),
    [sym_preproc_undef] = STATE(3183),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(5327),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3184] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3184),
    [sym_preproc_endregion] = STATE(3184),
    [sym_preproc_line] = STATE(3184),
    [sym_preproc_pragma] = STATE(3184),
    [sym_preproc_nullable] = STATE(3184),
    [sym_preproc_error] = STATE(3184),
    [sym_preproc_warning] = STATE(3184),
    [sym_preproc_define] = STATE(3184),
    [sym_preproc_undef] = STATE(3184),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_in] = ACTIONS(4910),
    [anon_sym_QMARK] = ACTIONS(4910),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_EQ_GT] = ACTIONS(4908),
    [anon_sym_switch] = ACTIONS(4908),
    [anon_sym_when] = ACTIONS(4908),
    [anon_sym_DOT_DOT] = ACTIONS(4908),
    [anon_sym_and] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_QMARK_QMARK] = ACTIONS(4908),
    [anon_sym_into] = ACTIONS(4908),
    [anon_sym_on] = ACTIONS(4908),
    [anon_sym_equals] = ACTIONS(4908),
    [anon_sym_by] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4908),
    [anon_sym_is] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(4908),
    [aux_sym_preproc_if_token3] = ACTIONS(4908),
    [aux_sym_preproc_else_token1] = ACTIONS(4908),
    [aux_sym_preproc_elif_token1] = ACTIONS(4908),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3185] = {
    [sym_preproc_region] = STATE(3185),
    [sym_preproc_endregion] = STATE(3185),
    [sym_preproc_line] = STATE(3185),
    [sym_preproc_pragma] = STATE(3185),
    [sym_preproc_nullable] = STATE(3185),
    [sym_preproc_error] = STATE(3185),
    [sym_preproc_warning] = STATE(3185),
    [sym_preproc_define] = STATE(3185),
    [sym_preproc_undef] = STATE(3185),
    [anon_sym_EQ] = ACTIONS(5329),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5331),
    [anon_sym_DASH_EQ] = ACTIONS(5331),
    [anon_sym_STAR_EQ] = ACTIONS(5331),
    [anon_sym_SLASH_EQ] = ACTIONS(5331),
    [anon_sym_PERCENT_EQ] = ACTIONS(5331),
    [anon_sym_AMP_EQ] = ACTIONS(5331),
    [anon_sym_CARET_EQ] = ACTIONS(5331),
    [anon_sym_PIPE_EQ] = ACTIONS(5331),
    [anon_sym_LT_LT_EQ] = ACTIONS(5331),
    [anon_sym_GT_GT_EQ] = ACTIONS(5331),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5331),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3186] = {
    [sym_preproc_region] = STATE(3186),
    [sym_preproc_endregion] = STATE(3186),
    [sym_preproc_line] = STATE(3186),
    [sym_preproc_pragma] = STATE(3186),
    [sym_preproc_nullable] = STATE(3186),
    [sym_preproc_error] = STATE(3186),
    [sym_preproc_warning] = STATE(3186),
    [sym_preproc_define] = STATE(3186),
    [sym_preproc_undef] = STATE(3186),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3187] = {
    [sym_initializer_expression] = STATE(3328),
    [sym_preproc_region] = STATE(3187),
    [sym_preproc_endregion] = STATE(3187),
    [sym_preproc_line] = STATE(3187),
    [sym_preproc_pragma] = STATE(3187),
    [sym_preproc_nullable] = STATE(3187),
    [sym_preproc_error] = STATE(3187),
    [sym_preproc_warning] = STATE(3187),
    [sym_preproc_define] = STATE(3187),
    [sym_preproc_undef] = STATE(3187),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4916),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4926),
    [anon_sym_in] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(5336),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4926),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4926),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_GT_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4926),
    [anon_sym_EQ_GT] = ACTIONS(4920),
    [anon_sym_switch] = ACTIONS(4920),
    [anon_sym_when] = ACTIONS(4920),
    [anon_sym_DOT_DOT] = ACTIONS(4920),
    [anon_sym_and] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_QMARK_QMARK] = ACTIONS(4920),
    [anon_sym_into] = ACTIONS(4920),
    [anon_sym_on] = ACTIONS(4920),
    [anon_sym_equals] = ACTIONS(4920),
    [anon_sym_by] = ACTIONS(4920),
    [anon_sym_as] = ACTIONS(4920),
    [anon_sym_is] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_with] = ACTIONS(4920),
    [aux_sym_preproc_if_token3] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4920),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3188] = {
    [sym_preproc_region] = STATE(3188),
    [sym_preproc_endregion] = STATE(3188),
    [sym_preproc_line] = STATE(3188),
    [sym_preproc_pragma] = STATE(3188),
    [sym_preproc_nullable] = STATE(3188),
    [sym_preproc_error] = STATE(3188),
    [sym_preproc_warning] = STATE(3188),
    [sym_preproc_define] = STATE(3188),
    [sym_preproc_undef] = STATE(3188),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(5340),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5342),
    [anon_sym_DASH_EQ] = ACTIONS(5342),
    [anon_sym_STAR_EQ] = ACTIONS(5342),
    [anon_sym_SLASH_EQ] = ACTIONS(5342),
    [anon_sym_PERCENT_EQ] = ACTIONS(5342),
    [anon_sym_AMP_EQ] = ACTIONS(5342),
    [anon_sym_CARET_EQ] = ACTIONS(5342),
    [anon_sym_PIPE_EQ] = ACTIONS(5342),
    [anon_sym_LT_LT_EQ] = ACTIONS(5342),
    [anon_sym_GT_GT_EQ] = ACTIONS(5342),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5342),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3189] = {
    [sym_preproc_region] = STATE(3189),
    [sym_preproc_endregion] = STATE(3189),
    [sym_preproc_line] = STATE(3189),
    [sym_preproc_pragma] = STATE(3189),
    [sym_preproc_nullable] = STATE(3189),
    [sym_preproc_error] = STATE(3189),
    [sym_preproc_warning] = STATE(3189),
    [sym_preproc_define] = STATE(3189),
    [sym_preproc_undef] = STATE(3189),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3697),
    [anon_sym_GT_GT_GT] = ACTIONS(3699),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_GT_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_when] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_and] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3699),
    [anon_sym_AMP_AMP] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(3699),
    [anon_sym_QMARK_QMARK] = ACTIONS(3699),
    [anon_sym_into] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_as] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(3699),
    [anon_sym_DASH_GT] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3699),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3190] = {
    [sym_preproc_region] = STATE(3190),
    [sym_preproc_endregion] = STATE(3190),
    [sym_preproc_line] = STATE(3190),
    [sym_preproc_pragma] = STATE(3190),
    [sym_preproc_nullable] = STATE(3190),
    [sym_preproc_error] = STATE(3190),
    [sym_preproc_warning] = STATE(3190),
    [sym_preproc_define] = STATE(3190),
    [sym_preproc_undef] = STATE(3190),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(5344),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3191] = {
    [sym_preproc_region] = STATE(3191),
    [sym_preproc_endregion] = STATE(3191),
    [sym_preproc_line] = STATE(3191),
    [sym_preproc_pragma] = STATE(3191),
    [sym_preproc_nullable] = STATE(3191),
    [sym_preproc_error] = STATE(3191),
    [sym_preproc_warning] = STATE(3191),
    [sym_preproc_define] = STATE(3191),
    [sym_preproc_undef] = STATE(3191),
    [anon_sym_EQ] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_QMARK] = ACTIONS(4241),
    [anon_sym_BANG] = ACTIONS(4241),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_STAR] = ACTIONS(4241),
    [anon_sym_SLASH] = ACTIONS(4241),
    [anon_sym_PERCENT] = ACTIONS(4241),
    [anon_sym_CARET] = ACTIONS(4241),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_AMP] = ACTIONS(4241),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(4241),
    [anon_sym_GT_GT_GT] = ACTIONS(4241),
    [anon_sym_EQ_EQ] = ACTIONS(4239),
    [anon_sym_BANG_EQ] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4241),
    [anon_sym_switch] = ACTIONS(4239),
    [anon_sym_DOT_DOT] = ACTIONS(4239),
    [anon_sym_and] = ACTIONS(4239),
    [anon_sym_or] = ACTIONS(4239),
    [anon_sym_PLUS_EQ] = ACTIONS(4239),
    [anon_sym_DASH_EQ] = ACTIONS(4239),
    [anon_sym_STAR_EQ] = ACTIONS(4239),
    [anon_sym_SLASH_EQ] = ACTIONS(4239),
    [anon_sym_PERCENT_EQ] = ACTIONS(4239),
    [anon_sym_AMP_EQ] = ACTIONS(4239),
    [anon_sym_CARET_EQ] = ACTIONS(4239),
    [anon_sym_PIPE_EQ] = ACTIONS(4239),
    [anon_sym_LT_LT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_QMARK_QMARK] = ACTIONS(4241),
    [anon_sym_into] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_is] = ACTIONS(4239),
    [anon_sym_DASH_GT] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4239),
  },
  [3192] = {
    [sym_preproc_region] = STATE(3192),
    [sym_preproc_endregion] = STATE(3192),
    [sym_preproc_line] = STATE(3192),
    [sym_preproc_pragma] = STATE(3192),
    [sym_preproc_nullable] = STATE(3192),
    [sym_preproc_error] = STATE(3192),
    [sym_preproc_warning] = STATE(3192),
    [sym_preproc_define] = STATE(3192),
    [sym_preproc_undef] = STATE(3192),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3664),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_when] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3193] = {
    [sym_preproc_region] = STATE(3193),
    [sym_preproc_endregion] = STATE(3193),
    [sym_preproc_line] = STATE(3193),
    [sym_preproc_pragma] = STATE(3193),
    [sym_preproc_nullable] = STATE(3193),
    [sym_preproc_error] = STATE(3193),
    [sym_preproc_warning] = STATE(3193),
    [sym_preproc_define] = STATE(3193),
    [sym_preproc_undef] = STATE(3193),
    [anon_sym_SEMI] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_COLON] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(4952),
    [anon_sym_RBRACK] = ACTIONS(4952),
    [anon_sym_LPAREN] = ACTIONS(4952),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_RBRACE] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4954),
    [anon_sym_in] = ACTIONS(4954),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4954),
    [anon_sym_DASH] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4954),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_PIPE] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4954),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_GT_GT_GT] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4952),
    [anon_sym_BANG_EQ] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4952),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_DOT] = ACTIONS(4954),
    [anon_sym_EQ_GT] = ACTIONS(4952),
    [anon_sym_switch] = ACTIONS(4952),
    [anon_sym_when] = ACTIONS(4952),
    [anon_sym_DOT_DOT] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_AMP_AMP] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4952),
    [anon_sym_QMARK_QMARK] = ACTIONS(4952),
    [anon_sym_into] = ACTIONS(4952),
    [anon_sym_on] = ACTIONS(4952),
    [anon_sym_equals] = ACTIONS(4952),
    [anon_sym_by] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_DASH_GT] = ACTIONS(4952),
    [anon_sym_with] = ACTIONS(4952),
    [sym_string_literal_encoding] = ACTIONS(5349),
    [aux_sym_preproc_if_token3] = ACTIONS(4952),
    [aux_sym_preproc_else_token1] = ACTIONS(4952),
    [aux_sym_preproc_elif_token1] = ACTIONS(4952),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3194] = {
    [sym_type_argument_list] = STATE(3349),
    [sym_preproc_region] = STATE(3194),
    [sym_preproc_endregion] = STATE(3194),
    [sym_preproc_line] = STATE(3194),
    [sym_preproc_pragma] = STATE(3194),
    [sym_preproc_nullable] = STATE(3194),
    [sym_preproc_error] = STATE(3194),
    [sym_preproc_warning] = STATE(3194),
    [sym_preproc_define] = STATE(3194),
    [sym_preproc_undef] = STATE(3194),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(5354),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3195] = {
    [sym_preproc_region] = STATE(3195),
    [sym_preproc_endregion] = STATE(3195),
    [sym_preproc_line] = STATE(3195),
    [sym_preproc_pragma] = STATE(3195),
    [sym_preproc_nullable] = STATE(3195),
    [sym_preproc_error] = STATE(3195),
    [sym_preproc_warning] = STATE(3195),
    [sym_preproc_define] = STATE(3195),
    [sym_preproc_undef] = STATE(3195),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_in] = ACTIONS(4042),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_when] = ACTIONS(4044),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4044),
    [anon_sym_or] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_QMARK_QMARK] = ACTIONS(4044),
    [anon_sym_into] = ACTIONS(4044),
    [anon_sym_on] = ACTIONS(4044),
    [anon_sym_equals] = ACTIONS(4044),
    [anon_sym_by] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4044),
    [anon_sym_is] = ACTIONS(4044),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_with] = ACTIONS(4044),
    [aux_sym_preproc_if_token3] = ACTIONS(4044),
    [aux_sym_preproc_else_token1] = ACTIONS(4044),
    [aux_sym_preproc_elif_token1] = ACTIONS(4044),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3196] = {
    [sym_preproc_region] = STATE(3196),
    [sym_preproc_endregion] = STATE(3196),
    [sym_preproc_line] = STATE(3196),
    [sym_preproc_pragma] = STATE(3196),
    [sym_preproc_nullable] = STATE(3196),
    [sym_preproc_error] = STATE(3196),
    [sym_preproc_warning] = STATE(3196),
    [sym_preproc_define] = STATE(3196),
    [sym_preproc_undef] = STATE(3196),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_in] = ACTIONS(4106),
    [anon_sym_QMARK] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4106),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4106),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4108),
    [aux_sym_preproc_else_token1] = ACTIONS(4108),
    [aux_sym_preproc_elif_token1] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3197] = {
    [sym_preproc_region] = STATE(3197),
    [sym_preproc_endregion] = STATE(3197),
    [sym_preproc_line] = STATE(3197),
    [sym_preproc_pragma] = STATE(3197),
    [sym_preproc_nullable] = STATE(3197),
    [sym_preproc_error] = STATE(3197),
    [sym_preproc_warning] = STATE(3197),
    [sym_preproc_define] = STATE(3197),
    [sym_preproc_undef] = STATE(3197),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4213),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_BANG] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_GT_GT_GT] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4213),
    [anon_sym_BANG_EQ] = ACTIONS(4213),
    [anon_sym_GT_EQ] = ACTIONS(4213),
    [anon_sym_LT_EQ] = ACTIONS(4213),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_switch] = ACTIONS(4213),
    [anon_sym_DOT_DOT] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(4213),
    [anon_sym_or] = ACTIONS(4213),
    [anon_sym_PLUS_EQ] = ACTIONS(4213),
    [anon_sym_DASH_EQ] = ACTIONS(4213),
    [anon_sym_STAR_EQ] = ACTIONS(4213),
    [anon_sym_SLASH_EQ] = ACTIONS(4213),
    [anon_sym_PERCENT_EQ] = ACTIONS(4213),
    [anon_sym_AMP_EQ] = ACTIONS(4213),
    [anon_sym_CARET_EQ] = ACTIONS(4213),
    [anon_sym_PIPE_EQ] = ACTIONS(4213),
    [anon_sym_LT_LT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4213),
    [anon_sym_AMP_AMP] = ACTIONS(4213),
    [anon_sym_PIPE_PIPE] = ACTIONS(4213),
    [anon_sym_QMARK_QMARK] = ACTIONS(4215),
    [anon_sym_into] = ACTIONS(4213),
    [anon_sym_as] = ACTIONS(4213),
    [anon_sym_is] = ACTIONS(4213),
    [anon_sym_DASH_GT] = ACTIONS(4213),
    [anon_sym_with] = ACTIONS(4213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4213),
  },
  [3198] = {
    [sym_preproc_region] = STATE(3198),
    [sym_preproc_endregion] = STATE(3198),
    [sym_preproc_line] = STATE(3198),
    [sym_preproc_pragma] = STATE(3198),
    [sym_preproc_nullable] = STATE(3198),
    [sym_preproc_error] = STATE(3198),
    [sym_preproc_warning] = STATE(3198),
    [sym_preproc_define] = STATE(3198),
    [sym_preproc_undef] = STATE(3198),
    [anon_sym_SEMI] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_RBRACK] = ACTIONS(4933),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_RPAREN] = ACTIONS(4933),
    [anon_sym_LBRACE] = ACTIONS(4933),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_LT] = ACTIONS(4935),
    [anon_sym_GT] = ACTIONS(4935),
    [anon_sym_in] = ACTIONS(4935),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_PLUS_PLUS] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4933),
    [anon_sym_PLUS] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4933),
    [anon_sym_SLASH] = ACTIONS(4935),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_CARET] = ACTIONS(4933),
    [anon_sym_PIPE] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_LT_LT] = ACTIONS(4933),
    [anon_sym_GT_GT] = ACTIONS(4935),
    [anon_sym_GT_GT_GT] = ACTIONS(4933),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4933),
    [anon_sym_GT_EQ] = ACTIONS(4933),
    [anon_sym_LT_EQ] = ACTIONS(4933),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_EQ_GT] = ACTIONS(4933),
    [anon_sym_switch] = ACTIONS(4933),
    [anon_sym_when] = ACTIONS(4933),
    [anon_sym_DOT_DOT] = ACTIONS(4933),
    [anon_sym_and] = ACTIONS(4933),
    [anon_sym_or] = ACTIONS(4933),
    [anon_sym_AMP_AMP] = ACTIONS(4933),
    [anon_sym_PIPE_PIPE] = ACTIONS(4933),
    [anon_sym_QMARK_QMARK] = ACTIONS(4933),
    [anon_sym_into] = ACTIONS(4933),
    [anon_sym_on] = ACTIONS(4933),
    [anon_sym_equals] = ACTIONS(4933),
    [anon_sym_by] = ACTIONS(4933),
    [anon_sym_as] = ACTIONS(4933),
    [anon_sym_is] = ACTIONS(4933),
    [anon_sym_DASH_GT] = ACTIONS(4933),
    [anon_sym_with] = ACTIONS(4933),
    [aux_sym_preproc_if_token3] = ACTIONS(4933),
    [aux_sym_preproc_else_token1] = ACTIONS(4933),
    [aux_sym_preproc_elif_token1] = ACTIONS(4933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3199] = {
    [sym_preproc_region] = STATE(3199),
    [sym_preproc_endregion] = STATE(3199),
    [sym_preproc_line] = STATE(3199),
    [sym_preproc_pragma] = STATE(3199),
    [sym_preproc_nullable] = STATE(3199),
    [sym_preproc_error] = STATE(3199),
    [sym_preproc_warning] = STATE(3199),
    [sym_preproc_define] = STATE(3199),
    [sym_preproc_undef] = STATE(3199),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_COLON] = ACTIONS(4939),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_RBRACK] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4941),
    [anon_sym_in] = ACTIONS(4939),
    [anon_sym_where] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_BANG] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4941),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4941),
    [anon_sym_GT_GT_GT] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4939),
    [anon_sym_BANG_EQ] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4939),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4941),
    [anon_sym_EQ_GT] = ACTIONS(4939),
    [anon_sym_switch] = ACTIONS(4939),
    [anon_sym_when] = ACTIONS(4939),
    [anon_sym_DOT_DOT] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_AMP_AMP] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4939),
    [anon_sym_QMARK_QMARK] = ACTIONS(4939),
    [anon_sym_on] = ACTIONS(4939),
    [anon_sym_equals] = ACTIONS(4939),
    [anon_sym_by] = ACTIONS(4939),
    [anon_sym_as] = ACTIONS(4939),
    [anon_sym_is] = ACTIONS(4939),
    [anon_sym_DASH_GT] = ACTIONS(4939),
    [anon_sym_with] = ACTIONS(4939),
    [aux_sym_preproc_if_token3] = ACTIONS(4939),
    [aux_sym_preproc_else_token1] = ACTIONS(4939),
    [aux_sym_preproc_elif_token1] = ACTIONS(4939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3200] = {
    [sym_preproc_region] = STATE(3200),
    [sym_preproc_endregion] = STATE(3200),
    [sym_preproc_line] = STATE(3200),
    [sym_preproc_pragma] = STATE(3200),
    [sym_preproc_nullable] = STATE(3200),
    [sym_preproc_error] = STATE(3200),
    [sym_preproc_warning] = STATE(3200),
    [sym_preproc_define] = STATE(3200),
    [sym_preproc_undef] = STATE(3200),
    [anon_sym_EQ] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3201] = {
    [sym_preproc_region] = STATE(3201),
    [sym_preproc_endregion] = STATE(3201),
    [sym_preproc_line] = STATE(3201),
    [sym_preproc_pragma] = STATE(3201),
    [sym_preproc_nullable] = STATE(3201),
    [sym_preproc_error] = STATE(3201),
    [sym_preproc_warning] = STATE(3201),
    [sym_preproc_define] = STATE(3201),
    [sym_preproc_undef] = STATE(3201),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_SLASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LT_LT] = ACTIONS(3701),
    [anon_sym_GT_GT] = ACTIONS(3701),
    [anon_sym_GT_GT_GT] = ACTIONS(3701),
    [anon_sym_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_switch] = ACTIONS(3709),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_and] = ACTIONS(3709),
    [anon_sym_or] = ACTIONS(3709),
    [anon_sym_PLUS_EQ] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3709),
    [anon_sym_STAR_EQ] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3709),
    [anon_sym_AMP_EQ] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_QMARK_QMARK] = ACTIONS(3701),
    [anon_sym_into] = ACTIONS(3709),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_is] = ACTIONS(3709),
    [anon_sym_DASH_GT] = ACTIONS(3709),
    [anon_sym_with] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3709),
  },
  [3202] = {
    [sym_preproc_region] = STATE(3202),
    [sym_preproc_endregion] = STATE(3202),
    [sym_preproc_line] = STATE(3202),
    [sym_preproc_pragma] = STATE(3202),
    [sym_preproc_nullable] = STATE(3202),
    [sym_preproc_error] = STATE(3202),
    [sym_preproc_warning] = STATE(3202),
    [sym_preproc_define] = STATE(3202),
    [sym_preproc_undef] = STATE(3202),
    [anon_sym_SEMI] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_COLON] = ACTIONS(4958),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_RBRACK] = ACTIONS(4958),
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_RPAREN] = ACTIONS(4958),
    [anon_sym_LBRACE] = ACTIONS(4958),
    [anon_sym_RBRACE] = ACTIONS(4958),
    [anon_sym_LT] = ACTIONS(4960),
    [anon_sym_GT] = ACTIONS(4960),
    [anon_sym_in] = ACTIONS(4960),
    [anon_sym_QMARK] = ACTIONS(4960),
    [anon_sym_BANG] = ACTIONS(4960),
    [anon_sym_PLUS_PLUS] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(4958),
    [anon_sym_PLUS] = ACTIONS(4960),
    [anon_sym_DASH] = ACTIONS(4960),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_SLASH] = ACTIONS(4960),
    [anon_sym_PERCENT] = ACTIONS(4958),
    [anon_sym_CARET] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym_LT_LT] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(4960),
    [anon_sym_GT_GT_GT] = ACTIONS(4958),
    [anon_sym_EQ_EQ] = ACTIONS(4958),
    [anon_sym_BANG_EQ] = ACTIONS(4958),
    [anon_sym_GT_EQ] = ACTIONS(4958),
    [anon_sym_LT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(4960),
    [anon_sym_EQ_GT] = ACTIONS(4958),
    [anon_sym_switch] = ACTIONS(4958),
    [anon_sym_when] = ACTIONS(4958),
    [anon_sym_DOT_DOT] = ACTIONS(4958),
    [anon_sym_and] = ACTIONS(4958),
    [anon_sym_or] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_PIPE_PIPE] = ACTIONS(4958),
    [anon_sym_QMARK_QMARK] = ACTIONS(4958),
    [anon_sym_into] = ACTIONS(4958),
    [anon_sym_on] = ACTIONS(4958),
    [anon_sym_equals] = ACTIONS(4958),
    [anon_sym_by] = ACTIONS(4958),
    [anon_sym_as] = ACTIONS(4958),
    [anon_sym_is] = ACTIONS(4958),
    [anon_sym_DASH_GT] = ACTIONS(4958),
    [anon_sym_with] = ACTIONS(4958),
    [aux_sym_preproc_if_token3] = ACTIONS(4958),
    [aux_sym_preproc_else_token1] = ACTIONS(4958),
    [aux_sym_preproc_elif_token1] = ACTIONS(4958),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3203] = {
    [sym_attribute_list] = STATE(3637),
    [sym__attribute_list] = STATE(3645),
    [sym_preproc_if_in_attribute_list] = STATE(3637),
    [sym_preproc_region] = STATE(3203),
    [sym_preproc_endregion] = STATE(3203),
    [sym_preproc_line] = STATE(3203),
    [sym_preproc_pragma] = STATE(3203),
    [sym_preproc_nullable] = STATE(3203),
    [sym_preproc_error] = STATE(3203),
    [sym_preproc_warning] = STATE(3203),
    [sym_preproc_define] = STATE(3203),
    [sym_preproc_undef] = STATE(3203),
    [aux_sym__class_declaration_initializer_repeat1] = STATE(3203),
    [sym__identifier_token] = ACTIONS(4771),
    [anon_sym_extern] = ACTIONS(4771),
    [anon_sym_alias] = ACTIONS(4771),
    [anon_sym_global] = ACTIONS(4771),
    [anon_sym_unsafe] = ACTIONS(4771),
    [anon_sym_static] = ACTIONS(4771),
    [anon_sym_LBRACK] = ACTIONS(5360),
    [anon_sym_LPAREN] = ACTIONS(4776),
    [anon_sym_ref] = ACTIONS(4771),
    [anon_sym_delegate] = ACTIONS(4771),
    [anon_sym_abstract] = ACTIONS(4771),
    [anon_sym_async] = ACTIONS(4771),
    [anon_sym_const] = ACTIONS(4771),
    [anon_sym_file] = ACTIONS(4771),
    [anon_sym_fixed] = ACTIONS(4771),
    [anon_sym_internal] = ACTIONS(4771),
    [anon_sym_new] = ACTIONS(4771),
    [anon_sym_override] = ACTIONS(4771),
    [anon_sym_partial] = ACTIONS(4771),
    [anon_sym_private] = ACTIONS(4771),
    [anon_sym_protected] = ACTIONS(4771),
    [anon_sym_public] = ACTIONS(4771),
    [anon_sym_readonly] = ACTIONS(4771),
    [anon_sym_required] = ACTIONS(4771),
    [anon_sym_sealed] = ACTIONS(4771),
    [anon_sym_virtual] = ACTIONS(4771),
    [anon_sym_volatile] = ACTIONS(4771),
    [anon_sym_where] = ACTIONS(4771),
    [anon_sym_notnull] = ACTIONS(4771),
    [anon_sym_unmanaged] = ACTIONS(4771),
    [anon_sym_scoped] = ACTIONS(4771),
    [anon_sym_var] = ACTIONS(4771),
    [sym_predefined_type] = ACTIONS(4771),
    [anon_sym_yield] = ACTIONS(4771),
    [anon_sym_when] = ACTIONS(4771),
    [anon_sym_from] = ACTIONS(4771),
    [anon_sym_into] = ACTIONS(4771),
    [anon_sym_join] = ACTIONS(4771),
    [anon_sym_on] = ACTIONS(4771),
    [anon_sym_equals] = ACTIONS(4771),
    [anon_sym_let] = ACTIONS(4771),
    [anon_sym_orderby] = ACTIONS(4771),
    [anon_sym_ascending] = ACTIONS(4771),
    [anon_sym_descending] = ACTIONS(4771),
    [anon_sym_group] = ACTIONS(4771),
    [anon_sym_by] = ACTIONS(4771),
    [anon_sym_select] = ACTIONS(4771),
    [aux_sym_preproc_if_token1] = ACTIONS(5363),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3204] = {
    [sym_preproc_region] = STATE(3204),
    [sym_preproc_endregion] = STATE(3204),
    [sym_preproc_line] = STATE(3204),
    [sym_preproc_pragma] = STATE(3204),
    [sym_preproc_nullable] = STATE(3204),
    [sym_preproc_error] = STATE(3204),
    [sym_preproc_warning] = STATE(3204),
    [sym_preproc_define] = STATE(3204),
    [sym_preproc_undef] = STATE(3204),
    [anon_sym_SEMI] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3722),
    [anon_sym_DASH_DASH] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_GT_GT_GT] = ACTIONS(3722),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_GT_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_switch] = ACTIONS(3722),
    [anon_sym_when] = ACTIONS(3722),
    [anon_sym_DOT_DOT] = ACTIONS(3722),
    [anon_sym_and] = ACTIONS(3722),
    [anon_sym_or] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_QMARK_QMARK] = ACTIONS(3722),
    [anon_sym_into] = ACTIONS(3722),
    [anon_sym_on] = ACTIONS(3722),
    [anon_sym_equals] = ACTIONS(3722),
    [anon_sym_by] = ACTIONS(3722),
    [anon_sym_as] = ACTIONS(3722),
    [anon_sym_is] = ACTIONS(3722),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_with] = ACTIONS(3722),
    [aux_sym_preproc_if_token3] = ACTIONS(3722),
    [aux_sym_preproc_else_token1] = ACTIONS(3722),
    [aux_sym_preproc_elif_token1] = ACTIONS(3722),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3205] = {
    [sym_preproc_region] = STATE(3205),
    [sym_preproc_endregion] = STATE(3205),
    [sym_preproc_line] = STATE(3205),
    [sym_preproc_pragma] = STATE(3205),
    [sym_preproc_nullable] = STATE(3205),
    [sym_preproc_error] = STATE(3205),
    [sym_preproc_warning] = STATE(3205),
    [sym_preproc_define] = STATE(3205),
    [sym_preproc_undef] = STATE(3205),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3206] = {
    [sym_preproc_region] = STATE(3206),
    [sym_preproc_endregion] = STATE(3206),
    [sym_preproc_line] = STATE(3206),
    [sym_preproc_pragma] = STATE(3206),
    [sym_preproc_nullable] = STATE(3206),
    [sym_preproc_error] = STATE(3206),
    [sym_preproc_warning] = STATE(3206),
    [sym_preproc_define] = STATE(3206),
    [sym_preproc_undef] = STATE(3206),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3668),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3668),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_when] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3668),
    [anon_sym_into] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3207] = {
    [sym_type_argument_list] = STATE(3349),
    [sym_preproc_region] = STATE(3207),
    [sym_preproc_endregion] = STATE(3207),
    [sym_preproc_line] = STATE(3207),
    [sym_preproc_pragma] = STATE(3207),
    [sym_preproc_nullable] = STATE(3207),
    [sym_preproc_error] = STATE(3207),
    [sym_preproc_warning] = STATE(3207),
    [sym_preproc_define] = STATE(3207),
    [sym_preproc_undef] = STATE(3207),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(5351),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3208] = {
    [sym_preproc_region] = STATE(3208),
    [sym_preproc_endregion] = STATE(3208),
    [sym_preproc_line] = STATE(3208),
    [sym_preproc_pragma] = STATE(3208),
    [sym_preproc_nullable] = STATE(3208),
    [sym_preproc_error] = STATE(3208),
    [sym_preproc_warning] = STATE(3208),
    [sym_preproc_define] = STATE(3208),
    [sym_preproc_undef] = STATE(3208),
    [anon_sym_EQ] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3678),
    [anon_sym_CARET] = ACTIONS(3678),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3678),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3678),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_PLUS_EQ] = ACTIONS(3680),
    [anon_sym_DASH_EQ] = ACTIONS(3680),
    [anon_sym_STAR_EQ] = ACTIONS(3680),
    [anon_sym_SLASH_EQ] = ACTIONS(3680),
    [anon_sym_PERCENT_EQ] = ACTIONS(3680),
    [anon_sym_AMP_EQ] = ACTIONS(3680),
    [anon_sym_CARET_EQ] = ACTIONS(3680),
    [anon_sym_PIPE_EQ] = ACTIONS(3680),
    [anon_sym_LT_LT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3678),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3680),
  },
  [3209] = {
    [sym_preproc_region] = STATE(3209),
    [sym_preproc_endregion] = STATE(3209),
    [sym_preproc_line] = STATE(3209),
    [sym_preproc_pragma] = STATE(3209),
    [sym_preproc_nullable] = STATE(3209),
    [sym_preproc_error] = STATE(3209),
    [sym_preproc_warning] = STATE(3209),
    [sym_preproc_define] = STATE(3209),
    [sym_preproc_undef] = STATE(3209),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RBRACK] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_EQ_GT] = ACTIONS(4967),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_when] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4967),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [anon_sym_DQUOTE] = ACTIONS(4967),
    [sym_string_literal_encoding] = ACTIONS(5366),
    [aux_sym_preproc_if_token3] = ACTIONS(4967),
    [aux_sym_preproc_else_token1] = ACTIONS(4967),
    [aux_sym_preproc_elif_token1] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3210] = {
    [sym_preproc_region] = STATE(3210),
    [sym_preproc_endregion] = STATE(3210),
    [sym_preproc_line] = STATE(3210),
    [sym_preproc_pragma] = STATE(3210),
    [sym_preproc_nullable] = STATE(3210),
    [sym_preproc_error] = STATE(3210),
    [sym_preproc_warning] = STATE(3210),
    [sym_preproc_define] = STATE(3210),
    [sym_preproc_undef] = STATE(3210),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3686),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3686),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_when] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3686),
    [anon_sym_into] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3211] = {
    [sym_preproc_region] = STATE(3211),
    [sym_preproc_endregion] = STATE(3211),
    [sym_preproc_line] = STATE(3211),
    [sym_preproc_pragma] = STATE(3211),
    [sym_preproc_nullable] = STATE(3211),
    [sym_preproc_error] = STATE(3211),
    [sym_preproc_warning] = STATE(3211),
    [sym_preproc_define] = STATE(3211),
    [sym_preproc_undef] = STATE(3211),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3212] = {
    [sym_preproc_region] = STATE(3212),
    [sym_preproc_endregion] = STATE(3212),
    [sym_preproc_line] = STATE(3212),
    [sym_preproc_pragma] = STATE(3212),
    [sym_preproc_nullable] = STATE(3212),
    [sym_preproc_error] = STATE(3212),
    [sym_preproc_warning] = STATE(3212),
    [sym_preproc_define] = STATE(3212),
    [sym_preproc_undef] = STATE(3212),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(4297),
    [anon_sym_COMMA] = ACTIONS(4297),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3213] = {
    [sym_preproc_region] = STATE(3213),
    [sym_preproc_endregion] = STATE(3213),
    [sym_preproc_line] = STATE(3213),
    [sym_preproc_pragma] = STATE(3213),
    [sym_preproc_nullable] = STATE(3213),
    [sym_preproc_error] = STATE(3213),
    [sym_preproc_warning] = STATE(3213),
    [sym_preproc_define] = STATE(3213),
    [sym_preproc_undef] = STATE(3213),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_when] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3672),
    [anon_sym_into] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3214] = {
    [sym_preproc_region] = STATE(3214),
    [sym_preproc_endregion] = STATE(3214),
    [sym_preproc_line] = STATE(3214),
    [sym_preproc_pragma] = STATE(3214),
    [sym_preproc_nullable] = STATE(3214),
    [sym_preproc_error] = STATE(3214),
    [sym_preproc_warning] = STATE(3214),
    [sym_preproc_define] = STATE(3214),
    [sym_preproc_undef] = STATE(3214),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3686),
    [anon_sym_PLUS_EQ] = ACTIONS(3686),
    [anon_sym_DASH_EQ] = ACTIONS(3686),
    [anon_sym_STAR_EQ] = ACTIONS(3686),
    [anon_sym_SLASH_EQ] = ACTIONS(3686),
    [anon_sym_PERCENT_EQ] = ACTIONS(3686),
    [anon_sym_AMP_EQ] = ACTIONS(3686),
    [anon_sym_CARET_EQ] = ACTIONS(3686),
    [anon_sym_PIPE_EQ] = ACTIONS(3686),
    [anon_sym_LT_LT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3684),
    [anon_sym_into] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3686),
  },
  [3215] = {
    [sym_preproc_region] = STATE(3215),
    [sym_preproc_endregion] = STATE(3215),
    [sym_preproc_line] = STATE(3215),
    [sym_preproc_pragma] = STATE(3215),
    [sym_preproc_nullable] = STATE(3215),
    [sym_preproc_error] = STATE(3215),
    [sym_preproc_warning] = STATE(3215),
    [sym_preproc_define] = STATE(3215),
    [sym_preproc_undef] = STATE(3215),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_CARET] = ACTIONS(3676),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3676),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_when] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3676),
    [anon_sym_into] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3216] = {
    [sym_initializer_expression] = STATE(3421),
    [sym_preproc_region] = STATE(3216),
    [sym_preproc_endregion] = STATE(3216),
    [sym_preproc_line] = STATE(3216),
    [sym_preproc_pragma] = STATE(3216),
    [sym_preproc_nullable] = STATE(3216),
    [sym_preproc_error] = STATE(3216),
    [sym_preproc_warning] = STATE(3216),
    [sym_preproc_define] = STATE(3216),
    [sym_preproc_undef] = STATE(3216),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_RBRACK] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_LT] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4873),
    [anon_sym_in] = ACTIONS(4871),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_BANG] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4873),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_SLASH] = ACTIONS(4873),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4873),
    [anon_sym_AMP] = ACTIONS(4873),
    [anon_sym_LT_LT] = ACTIONS(4871),
    [anon_sym_GT_GT] = ACTIONS(4873),
    [anon_sym_GT_GT_GT] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4871),
    [anon_sym_BANG_EQ] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4871),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4873),
    [anon_sym_EQ_GT] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(4871),
    [anon_sym_when] = ACTIONS(4871),
    [anon_sym_DOT_DOT] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_or] = ACTIONS(4871),
    [anon_sym_AMP_AMP] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE] = ACTIONS(4871),
    [anon_sym_QMARK_QMARK] = ACTIONS(4871),
    [anon_sym_on] = ACTIONS(4871),
    [anon_sym_equals] = ACTIONS(4871),
    [anon_sym_by] = ACTIONS(4871),
    [anon_sym_as] = ACTIONS(4871),
    [anon_sym_is] = ACTIONS(4871),
    [anon_sym_DASH_GT] = ACTIONS(4871),
    [anon_sym_with] = ACTIONS(4871),
    [aux_sym_preproc_if_token3] = ACTIONS(4871),
    [aux_sym_preproc_else_token1] = ACTIONS(4871),
    [aux_sym_preproc_elif_token1] = ACTIONS(4871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3217] = {
    [sym_preproc_region] = STATE(3217),
    [sym_preproc_endregion] = STATE(3217),
    [sym_preproc_line] = STATE(3217),
    [sym_preproc_pragma] = STATE(3217),
    [sym_preproc_nullable] = STATE(3217),
    [sym_preproc_error] = STATE(3217),
    [sym_preproc_warning] = STATE(3217),
    [sym_preproc_define] = STATE(3217),
    [sym_preproc_undef] = STATE(3217),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_LPAREN] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_in] = ACTIONS(4119),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4121),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4119),
    [anon_sym_EQ_GT] = ACTIONS(4121),
    [anon_sym_switch] = ACTIONS(4121),
    [anon_sym_when] = ACTIONS(4121),
    [anon_sym_DOT_DOT] = ACTIONS(4121),
    [anon_sym_and] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_QMARK_QMARK] = ACTIONS(4121),
    [anon_sym_into] = ACTIONS(4121),
    [anon_sym_on] = ACTIONS(4121),
    [anon_sym_equals] = ACTIONS(4121),
    [anon_sym_by] = ACTIONS(4121),
    [anon_sym_as] = ACTIONS(4121),
    [anon_sym_is] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [anon_sym_with] = ACTIONS(4121),
    [aux_sym_preproc_if_token3] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3218] = {
    [sym_preproc_region] = STATE(3218),
    [sym_preproc_endregion] = STATE(3218),
    [sym_preproc_line] = STATE(3218),
    [sym_preproc_pragma] = STATE(3218),
    [sym_preproc_nullable] = STATE(3218),
    [sym_preproc_error] = STATE(3218),
    [sym_preproc_warning] = STATE(3218),
    [sym_preproc_define] = STATE(3218),
    [sym_preproc_undef] = STATE(3218),
    [anon_sym_SEMI] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_COLON] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(4952),
    [anon_sym_RBRACK] = ACTIONS(4952),
    [anon_sym_LPAREN] = ACTIONS(4952),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_RBRACE] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4954),
    [anon_sym_in] = ACTIONS(4952),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4954),
    [anon_sym_DASH] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4954),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_PIPE] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4954),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_GT_GT_GT] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4952),
    [anon_sym_BANG_EQ] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4952),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_DOT] = ACTIONS(4954),
    [anon_sym_EQ_GT] = ACTIONS(4952),
    [anon_sym_switch] = ACTIONS(4952),
    [anon_sym_when] = ACTIONS(4952),
    [anon_sym_DOT_DOT] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_AMP_AMP] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4952),
    [anon_sym_QMARK_QMARK] = ACTIONS(4952),
    [anon_sym_on] = ACTIONS(4952),
    [anon_sym_equals] = ACTIONS(4952),
    [anon_sym_by] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_DASH_GT] = ACTIONS(4952),
    [anon_sym_with] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(4952),
    [sym_string_literal_encoding] = ACTIONS(5368),
    [aux_sym_preproc_if_token3] = ACTIONS(4952),
    [aux_sym_preproc_else_token1] = ACTIONS(4952),
    [aux_sym_preproc_elif_token1] = ACTIONS(4952),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3219] = {
    [sym_preproc_region] = STATE(3219),
    [sym_preproc_endregion] = STATE(3219),
    [sym_preproc_line] = STATE(3219),
    [sym_preproc_pragma] = STATE(3219),
    [sym_preproc_nullable] = STATE(3219),
    [sym_preproc_error] = STATE(3219),
    [sym_preproc_warning] = STATE(3219),
    [sym_preproc_define] = STATE(3219),
    [sym_preproc_undef] = STATE(3219),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_PLUS_PLUS] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_DOT_DOT] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_PLUS_EQ] = ACTIONS(4225),
    [anon_sym_DASH_EQ] = ACTIONS(4225),
    [anon_sym_STAR_EQ] = ACTIONS(4225),
    [anon_sym_SLASH_EQ] = ACTIONS(4225),
    [anon_sym_PERCENT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4225),
    [anon_sym_CARET_EQ] = ACTIONS(4225),
    [anon_sym_PIPE_EQ] = ACTIONS(4225),
    [anon_sym_LT_LT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4225),
    [anon_sym_AMP_AMP] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4225),
    [anon_sym_QMARK_QMARK] = ACTIONS(4227),
    [anon_sym_into] = ACTIONS(4225),
    [anon_sym_as] = ACTIONS(4225),
    [anon_sym_is] = ACTIONS(4225),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_with] = ACTIONS(4225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4225),
  },
  [3220] = {
    [sym_preproc_region] = STATE(3220),
    [sym_preproc_endregion] = STATE(3220),
    [sym_preproc_line] = STATE(3220),
    [sym_preproc_pragma] = STATE(3220),
    [sym_preproc_nullable] = STATE(3220),
    [sym_preproc_error] = STATE(3220),
    [sym_preproc_warning] = STATE(3220),
    [sym_preproc_define] = STATE(3220),
    [sym_preproc_undef] = STATE(3220),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_when] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_into] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3221] = {
    [sym_preproc_region] = STATE(3221),
    [sym_preproc_endregion] = STATE(3221),
    [sym_preproc_line] = STATE(3221),
    [sym_preproc_pragma] = STATE(3221),
    [sym_preproc_nullable] = STATE(3221),
    [sym_preproc_error] = STATE(3221),
    [sym_preproc_warning] = STATE(3221),
    [sym_preproc_define] = STATE(3221),
    [sym_preproc_undef] = STATE(3221),
    [anon_sym_SEMI] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_RBRACK] = ACTIONS(4933),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_RPAREN] = ACTIONS(4933),
    [anon_sym_LBRACE] = ACTIONS(4933),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_LT] = ACTIONS(4935),
    [anon_sym_GT] = ACTIONS(4935),
    [anon_sym_in] = ACTIONS(4933),
    [anon_sym_where] = ACTIONS(4933),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_PLUS_PLUS] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4933),
    [anon_sym_PLUS] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4933),
    [anon_sym_SLASH] = ACTIONS(4935),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_CARET] = ACTIONS(4933),
    [anon_sym_PIPE] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_LT_LT] = ACTIONS(4933),
    [anon_sym_GT_GT] = ACTIONS(4935),
    [anon_sym_GT_GT_GT] = ACTIONS(4933),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4933),
    [anon_sym_GT_EQ] = ACTIONS(4933),
    [anon_sym_LT_EQ] = ACTIONS(4933),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_EQ_GT] = ACTIONS(4933),
    [anon_sym_switch] = ACTIONS(4933),
    [anon_sym_when] = ACTIONS(4933),
    [anon_sym_DOT_DOT] = ACTIONS(4933),
    [anon_sym_and] = ACTIONS(4933),
    [anon_sym_or] = ACTIONS(4933),
    [anon_sym_AMP_AMP] = ACTIONS(4933),
    [anon_sym_PIPE_PIPE] = ACTIONS(4933),
    [anon_sym_QMARK_QMARK] = ACTIONS(4933),
    [anon_sym_on] = ACTIONS(4933),
    [anon_sym_equals] = ACTIONS(4933),
    [anon_sym_by] = ACTIONS(4933),
    [anon_sym_as] = ACTIONS(4933),
    [anon_sym_is] = ACTIONS(4933),
    [anon_sym_DASH_GT] = ACTIONS(4933),
    [anon_sym_with] = ACTIONS(4933),
    [aux_sym_preproc_if_token3] = ACTIONS(4933),
    [aux_sym_preproc_else_token1] = ACTIONS(4933),
    [aux_sym_preproc_elif_token1] = ACTIONS(4933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3222] = {
    [sym_argument_list] = STATE(3488),
    [sym_bracketed_argument_list] = STATE(2724),
    [sym_preproc_region] = STATE(3222),
    [sym_preproc_endregion] = STATE(3222),
    [sym_preproc_line] = STATE(3222),
    [sym_preproc_pragma] = STATE(3222),
    [sym_preproc_nullable] = STATE(3222),
    [sym_preproc_error] = STATE(3222),
    [sym_preproc_warning] = STATE(3222),
    [sym_preproc_define] = STATE(3222),
    [sym_preproc_undef] = STATE(3222),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(4885),
    [anon_sym_COMMA] = ACTIONS(4885),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_in] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(4887),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(4887),
    [anon_sym_DASH] = ACTIONS(4887),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4887),
    [anon_sym_PERCENT] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_AMP] = ACTIONS(4887),
    [anon_sym_LT_LT] = ACTIONS(4885),
    [anon_sym_GT_GT] = ACTIONS(4887),
    [anon_sym_GT_GT_GT] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [anon_sym_GT_EQ] = ACTIONS(4885),
    [anon_sym_LT_EQ] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4885),
    [anon_sym_switch] = ACTIONS(4885),
    [anon_sym_when] = ACTIONS(4885),
    [anon_sym_DOT_DOT] = ACTIONS(4885),
    [anon_sym_and] = ACTIONS(4885),
    [anon_sym_or] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_QMARK_QMARK] = ACTIONS(4885),
    [anon_sym_on] = ACTIONS(4885),
    [anon_sym_equals] = ACTIONS(4885),
    [anon_sym_by] = ACTIONS(4885),
    [anon_sym_as] = ACTIONS(4885),
    [anon_sym_is] = ACTIONS(4885),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4885),
    [aux_sym_preproc_if_token3] = ACTIONS(4885),
    [aux_sym_preproc_else_token1] = ACTIONS(4885),
    [aux_sym_preproc_elif_token1] = ACTIONS(4885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3223] = {
    [sym_preproc_region] = STATE(3223),
    [sym_preproc_endregion] = STATE(3223),
    [sym_preproc_line] = STATE(3223),
    [sym_preproc_pragma] = STATE(3223),
    [sym_preproc_nullable] = STATE(3223),
    [sym_preproc_error] = STATE(3223),
    [sym_preproc_warning] = STATE(3223),
    [sym_preproc_define] = STATE(3223),
    [sym_preproc_undef] = STATE(3223),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_when] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_into] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3224] = {
    [sym_preproc_region] = STATE(3224),
    [sym_preproc_endregion] = STATE(3224),
    [sym_preproc_line] = STATE(3224),
    [sym_preproc_pragma] = STATE(3224),
    [sym_preproc_nullable] = STATE(3224),
    [sym_preproc_error] = STATE(3224),
    [sym_preproc_warning] = STATE(3224),
    [sym_preproc_define] = STATE(3224),
    [sym_preproc_undef] = STATE(3224),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_GT_GT_GT] = ACTIONS(4174),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_switch] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4172),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_QMARK_QMARK] = ACTIONS(4174),
    [anon_sym_into] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4172),
    [anon_sym_is] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [anon_sym_with] = ACTIONS(4172),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4172),
  },
  [3225] = {
    [sym_preproc_region] = STATE(3225),
    [sym_preproc_endregion] = STATE(3225),
    [sym_preproc_line] = STATE(3225),
    [sym_preproc_pragma] = STATE(3225),
    [sym_preproc_nullable] = STATE(3225),
    [sym_preproc_error] = STATE(3225),
    [sym_preproc_warning] = STATE(3225),
    [sym_preproc_define] = STATE(3225),
    [sym_preproc_undef] = STATE(3225),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4146),
    [anon_sym_in] = ACTIONS(4146),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_BANG] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4146),
    [anon_sym_AMP] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4146),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_switch] = ACTIONS(4148),
    [anon_sym_when] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_QMARK_QMARK] = ACTIONS(4148),
    [anon_sym_into] = ACTIONS(4148),
    [anon_sym_on] = ACTIONS(4148),
    [anon_sym_equals] = ACTIONS(4148),
    [anon_sym_by] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4148),
    [anon_sym_is] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_with] = ACTIONS(4148),
    [aux_sym_preproc_if_token3] = ACTIONS(4148),
    [aux_sym_preproc_else_token1] = ACTIONS(4148),
    [aux_sym_preproc_elif_token1] = ACTIONS(4148),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3226] = {
    [sym_preproc_region] = STATE(3226),
    [sym_preproc_endregion] = STATE(3226),
    [sym_preproc_line] = STATE(3226),
    [sym_preproc_pragma] = STATE(3226),
    [sym_preproc_nullable] = STATE(3226),
    [sym_preproc_error] = STATE(3226),
    [sym_preproc_warning] = STATE(3226),
    [sym_preproc_define] = STATE(3226),
    [sym_preproc_undef] = STATE(3226),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(3731),
    [anon_sym_or] = ACTIONS(3731),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_into] = ACTIONS(3731),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3731),
  },
  [3227] = {
    [sym_initializer_expression] = STATE(3424),
    [sym_preproc_region] = STATE(3227),
    [sym_preproc_endregion] = STATE(3227),
    [sym_preproc_line] = STATE(3227),
    [sym_preproc_pragma] = STATE(3227),
    [sym_preproc_nullable] = STATE(3227),
    [sym_preproc_error] = STATE(3227),
    [sym_preproc_warning] = STATE(3227),
    [sym_preproc_define] = STATE(3227),
    [sym_preproc_undef] = STATE(3227),
    [anon_sym_SEMI] = ACTIONS(4889),
    [anon_sym_LBRACK] = ACTIONS(4891),
    [anon_sym_COLON] = ACTIONS(4889),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_RBRACK] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(4889),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_in] = ACTIONS(4889),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_BANG] = ACTIONS(4894),
    [anon_sym_PLUS_PLUS] = ACTIONS(4889),
    [anon_sym_DASH_DASH] = ACTIONS(4889),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_SLASH] = ACTIONS(4894),
    [anon_sym_PERCENT] = ACTIONS(4889),
    [anon_sym_CARET] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4889),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_GT_GT_GT] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [anon_sym_GT_EQ] = ACTIONS(4889),
    [anon_sym_LT_EQ] = ACTIONS(4889),
    [anon_sym_DOT] = ACTIONS(4894),
    [anon_sym_EQ_GT] = ACTIONS(4889),
    [anon_sym_switch] = ACTIONS(4889),
    [anon_sym_when] = ACTIONS(4889),
    [anon_sym_DOT_DOT] = ACTIONS(4889),
    [anon_sym_and] = ACTIONS(4889),
    [anon_sym_or] = ACTIONS(4889),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_QMARK_QMARK] = ACTIONS(4889),
    [anon_sym_on] = ACTIONS(4889),
    [anon_sym_equals] = ACTIONS(4889),
    [anon_sym_by] = ACTIONS(4889),
    [anon_sym_as] = ACTIONS(4889),
    [anon_sym_is] = ACTIONS(4889),
    [anon_sym_DASH_GT] = ACTIONS(4889),
    [anon_sym_with] = ACTIONS(4889),
    [aux_sym_preproc_if_token3] = ACTIONS(4889),
    [aux_sym_preproc_else_token1] = ACTIONS(4889),
    [aux_sym_preproc_elif_token1] = ACTIONS(4889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3228] = {
    [sym_preproc_region] = STATE(3228),
    [sym_preproc_endregion] = STATE(3228),
    [sym_preproc_line] = STATE(3228),
    [sym_preproc_pragma] = STATE(3228),
    [sym_preproc_nullable] = STATE(3228),
    [sym_preproc_error] = STATE(3228),
    [sym_preproc_warning] = STATE(3228),
    [sym_preproc_define] = STATE(3228),
    [sym_preproc_undef] = STATE(3228),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_QMARK] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [anon_sym_switch] = ACTIONS(4036),
    [anon_sym_when] = ACTIONS(4036),
    [anon_sym_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_QMARK_QMARK] = ACTIONS(4036),
    [anon_sym_into] = ACTIONS(4036),
    [anon_sym_on] = ACTIONS(4036),
    [anon_sym_equals] = ACTIONS(4036),
    [anon_sym_by] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4036),
    [anon_sym_is] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4036),
    [aux_sym_preproc_if_token3] = ACTIONS(4036),
    [aux_sym_preproc_else_token1] = ACTIONS(4036),
    [aux_sym_preproc_elif_token1] = ACTIONS(4036),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3229] = {
    [sym_preproc_region] = STATE(3229),
    [sym_preproc_endregion] = STATE(3229),
    [sym_preproc_line] = STATE(3229),
    [sym_preproc_pragma] = STATE(3229),
    [sym_preproc_nullable] = STATE(3229),
    [sym_preproc_error] = STATE(3229),
    [sym_preproc_warning] = STATE(3229),
    [sym_preproc_define] = STATE(3229),
    [sym_preproc_undef] = STATE(3229),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4166),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4166),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_GT_GT_GT] = ACTIONS(4166),
    [anon_sym_EQ_EQ] = ACTIONS(4164),
    [anon_sym_BANG_EQ] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4164),
    [anon_sym_QMARK_QMARK] = ACTIONS(4166),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4164),
  },
  [3230] = {
    [sym_preproc_region] = STATE(3230),
    [sym_preproc_endregion] = STATE(3230),
    [sym_preproc_line] = STATE(3230),
    [sym_preproc_pragma] = STATE(3230),
    [sym_preproc_nullable] = STATE(3230),
    [sym_preproc_error] = STATE(3230),
    [sym_preproc_warning] = STATE(3230),
    [sym_preproc_define] = STATE(3230),
    [sym_preproc_undef] = STATE(3230),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4297),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(4297),
    [anon_sym_LT] = ACTIONS(4300),
    [anon_sym_GT] = ACTIONS(4300),
    [anon_sym_QMARK] = ACTIONS(4300),
    [anon_sym_BANG] = ACTIONS(4300),
    [anon_sym_PLUS_PLUS] = ACTIONS(4297),
    [anon_sym_DASH_DASH] = ACTIONS(4297),
    [anon_sym_PLUS] = ACTIONS(4300),
    [anon_sym_DASH] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_SLASH] = ACTIONS(4300),
    [anon_sym_PERCENT] = ACTIONS(4300),
    [anon_sym_CARET] = ACTIONS(4300),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(4300),
    [anon_sym_LT_LT] = ACTIONS(4300),
    [anon_sym_GT_GT] = ACTIONS(4300),
    [anon_sym_GT_GT_GT] = ACTIONS(4300),
    [anon_sym_EQ_EQ] = ACTIONS(4297),
    [anon_sym_BANG_EQ] = ACTIONS(4297),
    [anon_sym_GT_EQ] = ACTIONS(4297),
    [anon_sym_LT_EQ] = ACTIONS(4297),
    [anon_sym_DOT] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(4297),
    [anon_sym_DOT_DOT] = ACTIONS(4297),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_PIPE_PIPE] = ACTIONS(4297),
    [anon_sym_QMARK_QMARK] = ACTIONS(4300),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(4297),
    [anon_sym_is] = ACTIONS(4297),
    [anon_sym_DASH_GT] = ACTIONS(4297),
    [anon_sym_with] = ACTIONS(4297),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4295),
  },
  [3231] = {
    [sym_preproc_region] = STATE(3231),
    [sym_preproc_endregion] = STATE(3231),
    [sym_preproc_line] = STATE(3231),
    [sym_preproc_pragma] = STATE(3231),
    [sym_preproc_nullable] = STATE(3231),
    [sym_preproc_error] = STATE(3231),
    [sym_preproc_warning] = STATE(3231),
    [sym_preproc_define] = STATE(3231),
    [sym_preproc_undef] = STATE(3231),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3232] = {
    [sym_preproc_region] = STATE(3232),
    [sym_preproc_endregion] = STATE(3232),
    [sym_preproc_line] = STATE(3232),
    [sym_preproc_pragma] = STATE(3232),
    [sym_preproc_nullable] = STATE(3232),
    [sym_preproc_error] = STATE(3232),
    [sym_preproc_warning] = STATE(3232),
    [sym_preproc_define] = STATE(3232),
    [sym_preproc_undef] = STATE(3232),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_RBRACK] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_CARET] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4152),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4152),
    [anon_sym_switch] = ACTIONS(4152),
    [anon_sym_when] = ACTIONS(4152),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_and] = ACTIONS(4152),
    [anon_sym_or] = ACTIONS(4152),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_QMARK_QMARK] = ACTIONS(4152),
    [anon_sym_into] = ACTIONS(4152),
    [anon_sym_on] = ACTIONS(4152),
    [anon_sym_equals] = ACTIONS(4152),
    [anon_sym_by] = ACTIONS(4152),
    [anon_sym_as] = ACTIONS(4152),
    [anon_sym_is] = ACTIONS(4152),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [anon_sym_with] = ACTIONS(4152),
    [aux_sym_preproc_if_token3] = ACTIONS(4152),
    [aux_sym_preproc_else_token1] = ACTIONS(4152),
    [aux_sym_preproc_elif_token1] = ACTIONS(4152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3233] = {
    [sym_preproc_region] = STATE(3233),
    [sym_preproc_endregion] = STATE(3233),
    [sym_preproc_line] = STATE(3233),
    [sym_preproc_pragma] = STATE(3233),
    [sym_preproc_nullable] = STATE(3233),
    [sym_preproc_error] = STATE(3233),
    [sym_preproc_warning] = STATE(3233),
    [sym_preproc_define] = STATE(3233),
    [sym_preproc_undef] = STATE(3233),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3234] = {
    [sym_preproc_region] = STATE(3234),
    [sym_preproc_endregion] = STATE(3234),
    [sym_preproc_line] = STATE(3234),
    [sym_preproc_pragma] = STATE(3234),
    [sym_preproc_nullable] = STATE(3234),
    [sym_preproc_error] = STATE(3234),
    [sym_preproc_warning] = STATE(3234),
    [sym_preproc_define] = STATE(3234),
    [sym_preproc_undef] = STATE(3234),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(5344),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3235] = {
    [sym_preproc_region] = STATE(3235),
    [sym_preproc_endregion] = STATE(3235),
    [sym_preproc_line] = STATE(3235),
    [sym_preproc_pragma] = STATE(3235),
    [sym_preproc_nullable] = STATE(3235),
    [sym_preproc_error] = STATE(3235),
    [sym_preproc_warning] = STATE(3235),
    [sym_preproc_define] = STATE(3235),
    [sym_preproc_undef] = STATE(3235),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RBRACK] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(4969),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_EQ_GT] = ACTIONS(4967),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_when] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4967),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [sym_string_literal_encoding] = ACTIONS(5376),
    [aux_sym_preproc_if_token3] = ACTIONS(4967),
    [aux_sym_preproc_else_token1] = ACTIONS(4967),
    [aux_sym_preproc_elif_token1] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3236] = {
    [sym_preproc_region] = STATE(3236),
    [sym_preproc_endregion] = STATE(3236),
    [sym_preproc_line] = STATE(3236),
    [sym_preproc_pragma] = STATE(3236),
    [sym_preproc_nullable] = STATE(3236),
    [sym_preproc_error] = STATE(3236),
    [sym_preproc_warning] = STATE(3236),
    [sym_preproc_define] = STATE(3236),
    [sym_preproc_undef] = STATE(3236),
    [anon_sym_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3672),
    [anon_sym_PLUS_EQ] = ACTIONS(3672),
    [anon_sym_DASH_EQ] = ACTIONS(3672),
    [anon_sym_STAR_EQ] = ACTIONS(3672),
    [anon_sym_SLASH_EQ] = ACTIONS(3672),
    [anon_sym_PERCENT_EQ] = ACTIONS(3672),
    [anon_sym_AMP_EQ] = ACTIONS(3672),
    [anon_sym_CARET_EQ] = ACTIONS(3672),
    [anon_sym_PIPE_EQ] = ACTIONS(3672),
    [anon_sym_LT_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3672),
  },
  [3237] = {
    [sym_preproc_region] = STATE(3237),
    [sym_preproc_endregion] = STATE(3237),
    [sym_preproc_line] = STATE(3237),
    [sym_preproc_pragma] = STATE(3237),
    [sym_preproc_nullable] = STATE(3237),
    [sym_preproc_error] = STATE(3237),
    [sym_preproc_warning] = STATE(3237),
    [sym_preproc_define] = STATE(3237),
    [sym_preproc_undef] = STATE(3237),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_in] = ACTIONS(4030),
    [anon_sym_QMARK] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [anon_sym_switch] = ACTIONS(4032),
    [anon_sym_when] = ACTIONS(4032),
    [anon_sym_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4032),
    [anon_sym_or] = ACTIONS(4032),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_QMARK_QMARK] = ACTIONS(4032),
    [anon_sym_into] = ACTIONS(4032),
    [anon_sym_on] = ACTIONS(4032),
    [anon_sym_equals] = ACTIONS(4032),
    [anon_sym_by] = ACTIONS(4032),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_is] = ACTIONS(4032),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4032),
    [aux_sym_preproc_if_token3] = ACTIONS(4032),
    [aux_sym_preproc_else_token1] = ACTIONS(4032),
    [aux_sym_preproc_elif_token1] = ACTIONS(4032),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3238] = {
    [sym_preproc_region] = STATE(3238),
    [sym_preproc_endregion] = STATE(3238),
    [sym_preproc_line] = STATE(3238),
    [sym_preproc_pragma] = STATE(3238),
    [sym_preproc_nullable] = STATE(3238),
    [sym_preproc_error] = STATE(3238),
    [sym_preproc_warning] = STATE(3238),
    [sym_preproc_define] = STATE(3238),
    [sym_preproc_undef] = STATE(3238),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3239] = {
    [sym_preproc_region] = STATE(3239),
    [sym_preproc_endregion] = STATE(3239),
    [sym_preproc_line] = STATE(3239),
    [sym_preproc_pragma] = STATE(3239),
    [sym_preproc_nullable] = STATE(3239),
    [sym_preproc_error] = STATE(3239),
    [sym_preproc_warning] = STATE(3239),
    [sym_preproc_define] = STATE(3239),
    [sym_preproc_undef] = STATE(3239),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3240] = {
    [sym_preproc_region] = STATE(3240),
    [sym_preproc_endregion] = STATE(3240),
    [sym_preproc_line] = STATE(3240),
    [sym_preproc_pragma] = STATE(3240),
    [sym_preproc_nullable] = STATE(3240),
    [sym_preproc_error] = STATE(3240),
    [sym_preproc_warning] = STATE(3240),
    [sym_preproc_define] = STATE(3240),
    [sym_preproc_undef] = STATE(3240),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_GT_GT_GT] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4156),
    [anon_sym_BANG_EQ] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4156),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_EQ_GT] = ACTIONS(4156),
    [anon_sym_switch] = ACTIONS(4156),
    [anon_sym_when] = ACTIONS(4156),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4156),
    [anon_sym_or] = ACTIONS(4156),
    [anon_sym_AMP_AMP] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4156),
    [anon_sym_QMARK_QMARK] = ACTIONS(4156),
    [anon_sym_into] = ACTIONS(4156),
    [anon_sym_on] = ACTIONS(4156),
    [anon_sym_equals] = ACTIONS(4156),
    [anon_sym_by] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4156),
    [anon_sym_is] = ACTIONS(4156),
    [anon_sym_DASH_GT] = ACTIONS(4156),
    [anon_sym_with] = ACTIONS(4156),
    [aux_sym_preproc_if_token3] = ACTIONS(4156),
    [aux_sym_preproc_else_token1] = ACTIONS(4156),
    [aux_sym_preproc_elif_token1] = ACTIONS(4156),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3241] = {
    [sym_preproc_region] = STATE(3241),
    [sym_preproc_endregion] = STATE(3241),
    [sym_preproc_line] = STATE(3241),
    [sym_preproc_pragma] = STATE(3241),
    [sym_preproc_nullable] = STATE(3241),
    [sym_preproc_error] = STATE(3241),
    [sym_preproc_warning] = STATE(3241),
    [sym_preproc_define] = STATE(3241),
    [sym_preproc_undef] = STATE(3241),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(3664),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3664),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_when] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3664),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_if_token3] = ACTIONS(3664),
    [aux_sym_preproc_else_token1] = ACTIONS(3664),
    [aux_sym_preproc_elif_token1] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3242] = {
    [sym_preproc_region] = STATE(3242),
    [sym_preproc_endregion] = STATE(3242),
    [sym_preproc_line] = STATE(3242),
    [sym_preproc_pragma] = STATE(3242),
    [sym_preproc_nullable] = STATE(3242),
    [sym_preproc_error] = STATE(3242),
    [sym_preproc_warning] = STATE(3242),
    [sym_preproc_define] = STATE(3242),
    [sym_preproc_undef] = STATE(3242),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(5344),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3243] = {
    [sym_preproc_region] = STATE(3243),
    [sym_preproc_endregion] = STATE(3243),
    [sym_preproc_line] = STATE(3243),
    [sym_preproc_pragma] = STATE(3243),
    [sym_preproc_nullable] = STATE(3243),
    [sym_preproc_error] = STATE(3243),
    [sym_preproc_warning] = STATE(3243),
    [sym_preproc_define] = STATE(3243),
    [sym_preproc_undef] = STATE(3243),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3674),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_CARET] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_PLUS_EQ] = ACTIONS(3676),
    [anon_sym_DASH_EQ] = ACTIONS(3676),
    [anon_sym_STAR_EQ] = ACTIONS(3676),
    [anon_sym_SLASH_EQ] = ACTIONS(3676),
    [anon_sym_PERCENT_EQ] = ACTIONS(3676),
    [anon_sym_AMP_EQ] = ACTIONS(3676),
    [anon_sym_CARET_EQ] = ACTIONS(3676),
    [anon_sym_PIPE_EQ] = ACTIONS(3676),
    [anon_sym_LT_LT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3674),
    [anon_sym_into] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3676),
  },
  [3244] = {
    [sym_preproc_region] = STATE(3244),
    [sym_preproc_endregion] = STATE(3244),
    [sym_preproc_line] = STATE(3244),
    [sym_preproc_pragma] = STATE(3244),
    [sym_preproc_nullable] = STATE(3244),
    [sym_preproc_error] = STATE(3244),
    [sym_preproc_warning] = STATE(3244),
    [sym_preproc_define] = STATE(3244),
    [sym_preproc_undef] = STATE(3244),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_in] = ACTIONS(4048),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_DOT] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4050),
    [anon_sym_switch] = ACTIONS(4050),
    [anon_sym_when] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4050),
    [anon_sym_and] = ACTIONS(4050),
    [anon_sym_or] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_QMARK_QMARK] = ACTIONS(4050),
    [anon_sym_into] = ACTIONS(4050),
    [anon_sym_on] = ACTIONS(4050),
    [anon_sym_equals] = ACTIONS(4050),
    [anon_sym_by] = ACTIONS(4050),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_is] = ACTIONS(4050),
    [anon_sym_DASH_GT] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4050),
    [aux_sym_preproc_if_token3] = ACTIONS(4050),
    [aux_sym_preproc_else_token1] = ACTIONS(4050),
    [aux_sym_preproc_elif_token1] = ACTIONS(4050),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3245] = {
    [sym_preproc_region] = STATE(3245),
    [sym_preproc_endregion] = STATE(3245),
    [sym_preproc_line] = STATE(3245),
    [sym_preproc_pragma] = STATE(3245),
    [sym_preproc_nullable] = STATE(3245),
    [sym_preproc_error] = STATE(3245),
    [sym_preproc_warning] = STATE(3245),
    [sym_preproc_define] = STATE(3245),
    [sym_preproc_undef] = STATE(3245),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_QMARK] = ACTIONS(4052),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [anon_sym_switch] = ACTIONS(4054),
    [anon_sym_when] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_QMARK_QMARK] = ACTIONS(4054),
    [anon_sym_into] = ACTIONS(4054),
    [anon_sym_on] = ACTIONS(4054),
    [anon_sym_equals] = ACTIONS(4054),
    [anon_sym_by] = ACTIONS(4054),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_is] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [aux_sym_preproc_if_token3] = ACTIONS(4054),
    [aux_sym_preproc_else_token1] = ACTIONS(4054),
    [aux_sym_preproc_elif_token1] = ACTIONS(4054),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3246] = {
    [sym_preproc_region] = STATE(3246),
    [sym_preproc_endregion] = STATE(3246),
    [sym_preproc_line] = STATE(3246),
    [sym_preproc_pragma] = STATE(3246),
    [sym_preproc_nullable] = STATE(3246),
    [sym_preproc_error] = STATE(3246),
    [sym_preproc_warning] = STATE(3246),
    [sym_preproc_define] = STATE(3246),
    [sym_preproc_undef] = STATE(3246),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4168),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_SLASH] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_CARET] = ACTIONS(4170),
    [anon_sym_PIPE] = ACTIONS(4170),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_GT] = ACTIONS(4170),
    [anon_sym_GT_GT_GT] = ACTIONS(4170),
    [anon_sym_EQ_EQ] = ACTIONS(4168),
    [anon_sym_BANG_EQ] = ACTIONS(4168),
    [anon_sym_GT_EQ] = ACTIONS(4168),
    [anon_sym_LT_EQ] = ACTIONS(4168),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_and] = ACTIONS(4168),
    [anon_sym_or] = ACTIONS(4168),
    [anon_sym_PLUS_EQ] = ACTIONS(4168),
    [anon_sym_DASH_EQ] = ACTIONS(4168),
    [anon_sym_STAR_EQ] = ACTIONS(4168),
    [anon_sym_SLASH_EQ] = ACTIONS(4168),
    [anon_sym_PERCENT_EQ] = ACTIONS(4168),
    [anon_sym_AMP_EQ] = ACTIONS(4168),
    [anon_sym_CARET_EQ] = ACTIONS(4168),
    [anon_sym_PIPE_EQ] = ACTIONS(4168),
    [anon_sym_LT_LT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_QMARK_QMARK] = ACTIONS(4170),
    [anon_sym_into] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4168),
    [anon_sym_is] = ACTIONS(4168),
    [anon_sym_DASH_GT] = ACTIONS(4168),
    [anon_sym_with] = ACTIONS(4168),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4168),
  },
  [3247] = {
    [sym_preproc_region] = STATE(3247),
    [sym_preproc_endregion] = STATE(3247),
    [sym_preproc_line] = STATE(3247),
    [sym_preproc_pragma] = STATE(3247),
    [sym_preproc_nullable] = STATE(3247),
    [sym_preproc_error] = STATE(3247),
    [sym_preproc_warning] = STATE(3247),
    [sym_preproc_define] = STATE(3247),
    [sym_preproc_undef] = STATE(3247),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3459),
    [anon_sym_PLUS_EQ] = ACTIONS(3459),
    [anon_sym_DASH_EQ] = ACTIONS(3459),
    [anon_sym_STAR_EQ] = ACTIONS(3459),
    [anon_sym_SLASH_EQ] = ACTIONS(3459),
    [anon_sym_PERCENT_EQ] = ACTIONS(3459),
    [anon_sym_AMP_EQ] = ACTIONS(3459),
    [anon_sym_CARET_EQ] = ACTIONS(3459),
    [anon_sym_PIPE_EQ] = ACTIONS(3459),
    [anon_sym_LT_LT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3459),
  },
  [3248] = {
    [sym_argument_list] = STATE(3488),
    [sym_bracketed_argument_list] = STATE(2724),
    [sym_preproc_region] = STATE(3248),
    [sym_preproc_endregion] = STATE(3248),
    [sym_preproc_line] = STATE(3248),
    [sym_preproc_pragma] = STATE(3248),
    [sym_preproc_nullable] = STATE(3248),
    [sym_preproc_error] = STATE(3248),
    [sym_preproc_warning] = STATE(3248),
    [sym_preproc_define] = STATE(3248),
    [sym_preproc_undef] = STATE(3248),
    [anon_sym_SEMI] = ACTIONS(4875),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_RBRACK] = ACTIONS(4875),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [anon_sym_LT] = ACTIONS(4879),
    [anon_sym_GT] = ACTIONS(4879),
    [anon_sym_in] = ACTIONS(4875),
    [anon_sym_QMARK] = ACTIONS(4879),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4875),
    [anon_sym_SLASH] = ACTIONS(4879),
    [anon_sym_PERCENT] = ACTIONS(4875),
    [anon_sym_CARET] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4879),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_LT_LT] = ACTIONS(4875),
    [anon_sym_GT_GT] = ACTIONS(4879),
    [anon_sym_GT_GT_GT] = ACTIONS(4875),
    [anon_sym_EQ_EQ] = ACTIONS(4875),
    [anon_sym_BANG_EQ] = ACTIONS(4875),
    [anon_sym_GT_EQ] = ACTIONS(4875),
    [anon_sym_LT_EQ] = ACTIONS(4875),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4875),
    [anon_sym_switch] = ACTIONS(4875),
    [anon_sym_when] = ACTIONS(4875),
    [anon_sym_DOT_DOT] = ACTIONS(4875),
    [anon_sym_and] = ACTIONS(4875),
    [anon_sym_or] = ACTIONS(4875),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_PIPE_PIPE] = ACTIONS(4875),
    [anon_sym_QMARK_QMARK] = ACTIONS(4875),
    [anon_sym_on] = ACTIONS(4875),
    [anon_sym_equals] = ACTIONS(4875),
    [anon_sym_by] = ACTIONS(4875),
    [anon_sym_as] = ACTIONS(4875),
    [anon_sym_is] = ACTIONS(4875),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4875),
    [aux_sym_preproc_if_token3] = ACTIONS(4875),
    [aux_sym_preproc_else_token1] = ACTIONS(4875),
    [aux_sym_preproc_elif_token1] = ACTIONS(4875),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3249] = {
    [sym_preproc_region] = STATE(3249),
    [sym_preproc_endregion] = STATE(3249),
    [sym_preproc_line] = STATE(3249),
    [sym_preproc_pragma] = STATE(3249),
    [sym_preproc_nullable] = STATE(3249),
    [sym_preproc_error] = STATE(3249),
    [sym_preproc_warning] = STATE(3249),
    [sym_preproc_define] = STATE(3249),
    [sym_preproc_undef] = STATE(3249),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(4192),
    [anon_sym_QMARK] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_SLASH] = ACTIONS(4192),
    [anon_sym_PERCENT] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4192),
    [anon_sym_PIPE] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_LT_LT] = ACTIONS(4192),
    [anon_sym_GT_GT] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(4192),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_switch] = ACTIONS(4186),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4192),
    [anon_sym_into] = ACTIONS(4186),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_is] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4186),
  },
  [3250] = {
    [sym_preproc_region] = STATE(3250),
    [sym_preproc_endregion] = STATE(3250),
    [sym_preproc_line] = STATE(3250),
    [sym_preproc_pragma] = STATE(3250),
    [sym_preproc_nullable] = STATE(3250),
    [sym_preproc_error] = STATE(3250),
    [sym_preproc_warning] = STATE(3250),
    [sym_preproc_define] = STATE(3250),
    [sym_preproc_undef] = STATE(3250),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(5378),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5380),
    [anon_sym_DASH_EQ] = ACTIONS(5380),
    [anon_sym_STAR_EQ] = ACTIONS(5380),
    [anon_sym_SLASH_EQ] = ACTIONS(5380),
    [anon_sym_PERCENT_EQ] = ACTIONS(5380),
    [anon_sym_AMP_EQ] = ACTIONS(5380),
    [anon_sym_CARET_EQ] = ACTIONS(5380),
    [anon_sym_PIPE_EQ] = ACTIONS(5380),
    [anon_sym_LT_LT_EQ] = ACTIONS(5380),
    [anon_sym_GT_GT_EQ] = ACTIONS(5380),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5380),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5380),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3251] = {
    [sym_preproc_region] = STATE(3251),
    [sym_preproc_endregion] = STATE(3251),
    [sym_preproc_line] = STATE(3251),
    [sym_preproc_pragma] = STATE(3251),
    [sym_preproc_nullable] = STATE(3251),
    [sym_preproc_error] = STATE(3251),
    [sym_preproc_warning] = STATE(3251),
    [sym_preproc_define] = STATE(3251),
    [sym_preproc_undef] = STATE(3251),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3664),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3662),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(3664),
    [anon_sym_LT_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_switch] = ACTIONS(3664),
    [anon_sym_DOT_DOT] = ACTIONS(3664),
    [anon_sym_and] = ACTIONS(3664),
    [anon_sym_or] = ACTIONS(3664),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3664),
    [anon_sym_AMP_AMP] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE] = ACTIONS(3664),
    [anon_sym_QMARK_QMARK] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_as] = ACTIONS(3664),
    [anon_sym_is] = ACTIONS(3664),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_with] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3664),
  },
  [3252] = {
    [sym_preproc_region] = STATE(3252),
    [sym_preproc_endregion] = STATE(3252),
    [sym_preproc_line] = STATE(3252),
    [sym_preproc_pragma] = STATE(3252),
    [sym_preproc_nullable] = STATE(3252),
    [sym_preproc_error] = STATE(3252),
    [sym_preproc_warning] = STATE(3252),
    [sym_preproc_define] = STATE(3252),
    [sym_preproc_undef] = STATE(3252),
    [anon_sym_EQ] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5384),
    [anon_sym_DASH_EQ] = ACTIONS(5384),
    [anon_sym_STAR_EQ] = ACTIONS(5384),
    [anon_sym_SLASH_EQ] = ACTIONS(5384),
    [anon_sym_PERCENT_EQ] = ACTIONS(5384),
    [anon_sym_AMP_EQ] = ACTIONS(5384),
    [anon_sym_CARET_EQ] = ACTIONS(5384),
    [anon_sym_PIPE_EQ] = ACTIONS(5384),
    [anon_sym_LT_LT_EQ] = ACTIONS(5384),
    [anon_sym_GT_GT_EQ] = ACTIONS(5384),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5384),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4898),
  },
  [3253] = {
    [sym_preproc_region] = STATE(3253),
    [sym_preproc_endregion] = STATE(3253),
    [sym_preproc_line] = STATE(3253),
    [sym_preproc_pragma] = STATE(3253),
    [sym_preproc_nullable] = STATE(3253),
    [sym_preproc_error] = STATE(3253),
    [sym_preproc_warning] = STATE(3253),
    [sym_preproc_define] = STATE(3253),
    [sym_preproc_undef] = STATE(3253),
    [anon_sym_EQ] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4190),
    [anon_sym_COMMA] = ACTIONS(4190),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_LT] = ACTIONS(4188),
    [anon_sym_GT] = ACTIONS(4188),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_BANG] = ACTIONS(4188),
    [anon_sym_PLUS_PLUS] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4190),
    [anon_sym_PLUS] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_SLASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PIPE] = ACTIONS(4188),
    [anon_sym_AMP] = ACTIONS(4188),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_GT_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4190),
    [anon_sym_GT_EQ] = ACTIONS(4190),
    [anon_sym_LT_EQ] = ACTIONS(4190),
    [anon_sym_DOT] = ACTIONS(4188),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_DOT_DOT] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(4190),
    [anon_sym_or] = ACTIONS(4190),
    [anon_sym_PLUS_EQ] = ACTIONS(4190),
    [anon_sym_DASH_EQ] = ACTIONS(4190),
    [anon_sym_STAR_EQ] = ACTIONS(4190),
    [anon_sym_SLASH_EQ] = ACTIONS(4190),
    [anon_sym_PERCENT_EQ] = ACTIONS(4190),
    [anon_sym_AMP_EQ] = ACTIONS(4190),
    [anon_sym_CARET_EQ] = ACTIONS(4190),
    [anon_sym_PIPE_EQ] = ACTIONS(4190),
    [anon_sym_LT_LT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4190),
    [anon_sym_AMP_AMP] = ACTIONS(4190),
    [anon_sym_PIPE_PIPE] = ACTIONS(4190),
    [anon_sym_QMARK_QMARK] = ACTIONS(4188),
    [anon_sym_into] = ACTIONS(4190),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4190),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4190),
  },
  [3254] = {
    [sym_preproc_region] = STATE(3254),
    [sym_preproc_endregion] = STATE(3254),
    [sym_preproc_line] = STATE(3254),
    [sym_preproc_pragma] = STATE(3254),
    [sym_preproc_nullable] = STATE(3254),
    [sym_preproc_error] = STATE(3254),
    [sym_preproc_warning] = STATE(3254),
    [sym_preproc_define] = STATE(3254),
    [sym_preproc_undef] = STATE(3254),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_COLON] = ACTIONS(4939),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_RBRACK] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4941),
    [anon_sym_in] = ACTIONS(4941),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_BANG] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4941),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4941),
    [anon_sym_GT_GT_GT] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4939),
    [anon_sym_BANG_EQ] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4939),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4941),
    [anon_sym_EQ_GT] = ACTIONS(4939),
    [anon_sym_switch] = ACTIONS(4939),
    [anon_sym_when] = ACTIONS(4939),
    [anon_sym_DOT_DOT] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_AMP_AMP] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4939),
    [anon_sym_QMARK_QMARK] = ACTIONS(4939),
    [anon_sym_into] = ACTIONS(4939),
    [anon_sym_on] = ACTIONS(4939),
    [anon_sym_equals] = ACTIONS(4939),
    [anon_sym_by] = ACTIONS(4939),
    [anon_sym_as] = ACTIONS(4939),
    [anon_sym_is] = ACTIONS(4939),
    [anon_sym_DASH_GT] = ACTIONS(4939),
    [anon_sym_with] = ACTIONS(4939),
    [aux_sym_preproc_if_token3] = ACTIONS(4939),
    [aux_sym_preproc_else_token1] = ACTIONS(4939),
    [aux_sym_preproc_elif_token1] = ACTIONS(4939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3255] = {
    [sym_preproc_region] = STATE(3255),
    [sym_preproc_endregion] = STATE(3255),
    [sym_preproc_line] = STATE(3255),
    [sym_preproc_pragma] = STATE(3255),
    [sym_preproc_nullable] = STATE(3255),
    [sym_preproc_error] = STATE(3255),
    [sym_preproc_warning] = STATE(3255),
    [sym_preproc_define] = STATE(3255),
    [sym_preproc_undef] = STATE(3255),
    [anon_sym_EQ] = ACTIONS(4235),
    [anon_sym_LBRACK] = ACTIONS(4233),
    [anon_sym_COLON] = ACTIONS(4233),
    [anon_sym_COMMA] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4233),
    [anon_sym_LT] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4235),
    [anon_sym_QMARK] = ACTIONS(4235),
    [anon_sym_BANG] = ACTIONS(4235),
    [anon_sym_PLUS_PLUS] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4235),
    [anon_sym_DASH] = ACTIONS(4235),
    [anon_sym_STAR] = ACTIONS(4235),
    [anon_sym_SLASH] = ACTIONS(4235),
    [anon_sym_PERCENT] = ACTIONS(4235),
    [anon_sym_CARET] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4235),
    [anon_sym_LT_LT] = ACTIONS(4235),
    [anon_sym_GT_GT] = ACTIONS(4235),
    [anon_sym_GT_GT_GT] = ACTIONS(4235),
    [anon_sym_EQ_EQ] = ACTIONS(4233),
    [anon_sym_BANG_EQ] = ACTIONS(4233),
    [anon_sym_GT_EQ] = ACTIONS(4233),
    [anon_sym_LT_EQ] = ACTIONS(4233),
    [anon_sym_DOT] = ACTIONS(4235),
    [anon_sym_switch] = ACTIONS(4233),
    [anon_sym_DOT_DOT] = ACTIONS(4233),
    [anon_sym_and] = ACTIONS(4233),
    [anon_sym_or] = ACTIONS(4233),
    [anon_sym_PLUS_EQ] = ACTIONS(4233),
    [anon_sym_DASH_EQ] = ACTIONS(4233),
    [anon_sym_STAR_EQ] = ACTIONS(4233),
    [anon_sym_SLASH_EQ] = ACTIONS(4233),
    [anon_sym_PERCENT_EQ] = ACTIONS(4233),
    [anon_sym_AMP_EQ] = ACTIONS(4233),
    [anon_sym_CARET_EQ] = ACTIONS(4233),
    [anon_sym_PIPE_EQ] = ACTIONS(4233),
    [anon_sym_LT_LT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4233),
    [anon_sym_AMP_AMP] = ACTIONS(4233),
    [anon_sym_PIPE_PIPE] = ACTIONS(4233),
    [anon_sym_QMARK_QMARK] = ACTIONS(4235),
    [anon_sym_into] = ACTIONS(4233),
    [anon_sym_as] = ACTIONS(4233),
    [anon_sym_is] = ACTIONS(4233),
    [anon_sym_DASH_GT] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4233),
  },
  [3256] = {
    [sym_preproc_region] = STATE(3256),
    [sym_preproc_endregion] = STATE(3256),
    [sym_preproc_line] = STATE(3256),
    [sym_preproc_pragma] = STATE(3256),
    [sym_preproc_nullable] = STATE(3256),
    [sym_preproc_error] = STATE(3256),
    [sym_preproc_warning] = STATE(3256),
    [sym_preproc_define] = STATE(3256),
    [sym_preproc_undef] = STATE(3256),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_LT] = ACTIONS(3633),
    [anon_sym_GT] = ACTIONS(3633),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3633),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(3630),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3630),
    [anon_sym_when] = ACTIONS(3630),
    [anon_sym_DOT_DOT] = ACTIONS(3630),
    [anon_sym_and] = ACTIONS(3630),
    [anon_sym_or] = ACTIONS(3630),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_QMARK_QMARK] = ACTIONS(3630),
    [anon_sym_on] = ACTIONS(3630),
    [anon_sym_equals] = ACTIONS(3630),
    [anon_sym_by] = ACTIONS(3630),
    [anon_sym_as] = ACTIONS(3630),
    [anon_sym_is] = ACTIONS(3630),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3630),
    [aux_sym_preproc_if_token3] = ACTIONS(3630),
    [aux_sym_preproc_else_token1] = ACTIONS(3630),
    [aux_sym_preproc_elif_token1] = ACTIONS(3630),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3257] = {
    [sym_preproc_region] = STATE(3257),
    [sym_preproc_endregion] = STATE(3257),
    [sym_preproc_line] = STATE(3257),
    [sym_preproc_pragma] = STATE(3257),
    [sym_preproc_nullable] = STATE(3257),
    [sym_preproc_error] = STATE(3257),
    [sym_preproc_warning] = STATE(3257),
    [sym_preproc_define] = STATE(3257),
    [sym_preproc_undef] = STATE(3257),
    [anon_sym_SEMI] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_COLON] = ACTIONS(4958),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_RBRACK] = ACTIONS(4958),
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_RPAREN] = ACTIONS(4958),
    [anon_sym_LBRACE] = ACTIONS(4958),
    [anon_sym_RBRACE] = ACTIONS(4958),
    [anon_sym_LT] = ACTIONS(4960),
    [anon_sym_GT] = ACTIONS(4960),
    [anon_sym_in] = ACTIONS(4958),
    [anon_sym_where] = ACTIONS(4958),
    [anon_sym_QMARK] = ACTIONS(4960),
    [anon_sym_BANG] = ACTIONS(4960),
    [anon_sym_PLUS_PLUS] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(4958),
    [anon_sym_PLUS] = ACTIONS(4960),
    [anon_sym_DASH] = ACTIONS(4960),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_SLASH] = ACTIONS(4960),
    [anon_sym_PERCENT] = ACTIONS(4958),
    [anon_sym_CARET] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym_LT_LT] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(4960),
    [anon_sym_GT_GT_GT] = ACTIONS(4958),
    [anon_sym_EQ_EQ] = ACTIONS(4958),
    [anon_sym_BANG_EQ] = ACTIONS(4958),
    [anon_sym_GT_EQ] = ACTIONS(4958),
    [anon_sym_LT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(4960),
    [anon_sym_EQ_GT] = ACTIONS(4958),
    [anon_sym_switch] = ACTIONS(4958),
    [anon_sym_when] = ACTIONS(4958),
    [anon_sym_DOT_DOT] = ACTIONS(4958),
    [anon_sym_and] = ACTIONS(4958),
    [anon_sym_or] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_PIPE_PIPE] = ACTIONS(4958),
    [anon_sym_QMARK_QMARK] = ACTIONS(4958),
    [anon_sym_on] = ACTIONS(4958),
    [anon_sym_equals] = ACTIONS(4958),
    [anon_sym_by] = ACTIONS(4958),
    [anon_sym_as] = ACTIONS(4958),
    [anon_sym_is] = ACTIONS(4958),
    [anon_sym_DASH_GT] = ACTIONS(4958),
    [anon_sym_with] = ACTIONS(4958),
    [aux_sym_preproc_if_token3] = ACTIONS(4958),
    [aux_sym_preproc_else_token1] = ACTIONS(4958),
    [aux_sym_preproc_elif_token1] = ACTIONS(4958),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3258] = {
    [sym_preproc_region] = STATE(3258),
    [sym_preproc_endregion] = STATE(3258),
    [sym_preproc_line] = STATE(3258),
    [sym_preproc_pragma] = STATE(3258),
    [sym_preproc_nullable] = STATE(3258),
    [sym_preproc_error] = STATE(3258),
    [sym_preproc_warning] = STATE(3258),
    [sym_preproc_define] = STATE(3258),
    [sym_preproc_undef] = STATE(3258),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_in] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4020),
    [anon_sym_when] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4020),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_QMARK_QMARK] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4020),
    [anon_sym_is] = ACTIONS(4020),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_with] = ACTIONS(4020),
    [aux_sym_preproc_if_token3] = ACTIONS(4020),
    [aux_sym_preproc_else_token1] = ACTIONS(4020),
    [aux_sym_preproc_elif_token1] = ACTIONS(4020),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3259] = {
    [sym_initializer_expression] = STATE(3437),
    [sym_preproc_region] = STATE(3259),
    [sym_preproc_endregion] = STATE(3259),
    [sym_preproc_line] = STATE(3259),
    [sym_preproc_pragma] = STATE(3259),
    [sym_preproc_nullable] = STATE(3259),
    [sym_preproc_error] = STATE(3259),
    [sym_preproc_warning] = STATE(3259),
    [sym_preproc_define] = STATE(3259),
    [sym_preproc_undef] = STATE(3259),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_COLON] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_RBRACK] = ACTIONS(4904),
    [anon_sym_LPAREN] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_in] = ACTIONS(4904),
    [anon_sym_QMARK] = ACTIONS(4906),
    [anon_sym_BANG] = ACTIONS(4906),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_CARET] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_GT_GT_GT] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_EQ_GT] = ACTIONS(4904),
    [anon_sym_switch] = ACTIONS(4904),
    [anon_sym_when] = ACTIONS(4904),
    [anon_sym_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_QMARK_QMARK] = ACTIONS(4904),
    [anon_sym_on] = ACTIONS(4904),
    [anon_sym_equals] = ACTIONS(4904),
    [anon_sym_by] = ACTIONS(4904),
    [anon_sym_as] = ACTIONS(4904),
    [anon_sym_is] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [anon_sym_with] = ACTIONS(4904),
    [aux_sym_preproc_if_token3] = ACTIONS(4904),
    [aux_sym_preproc_else_token1] = ACTIONS(4904),
    [aux_sym_preproc_elif_token1] = ACTIONS(4904),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3260] = {
    [sym_preproc_region] = STATE(3260),
    [sym_preproc_endregion] = STATE(3260),
    [sym_preproc_line] = STATE(3260),
    [sym_preproc_pragma] = STATE(3260),
    [sym_preproc_nullable] = STATE(3260),
    [sym_preproc_error] = STATE(3260),
    [sym_preproc_warning] = STATE(3260),
    [sym_preproc_define] = STATE(3260),
    [sym_preproc_undef] = STATE(3260),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3666),
    [anon_sym_CARET] = ACTIONS(3666),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3666),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3666),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3668),
    [anon_sym_PLUS_EQ] = ACTIONS(3668),
    [anon_sym_DASH_EQ] = ACTIONS(3668),
    [anon_sym_STAR_EQ] = ACTIONS(3668),
    [anon_sym_SLASH_EQ] = ACTIONS(3668),
    [anon_sym_PERCENT_EQ] = ACTIONS(3668),
    [anon_sym_AMP_EQ] = ACTIONS(3668),
    [anon_sym_CARET_EQ] = ACTIONS(3668),
    [anon_sym_PIPE_EQ] = ACTIONS(3668),
    [anon_sym_LT_LT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3666),
    [anon_sym_into] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(3668),
  },
  [3261] = {
    [sym_preproc_region] = STATE(3261),
    [sym_preproc_endregion] = STATE(3261),
    [sym_preproc_line] = STATE(3261),
    [sym_preproc_pragma] = STATE(3261),
    [sym_preproc_nullable] = STATE(3261),
    [sym_preproc_error] = STATE(3261),
    [sym_preproc_warning] = STATE(3261),
    [sym_preproc_define] = STATE(3261),
    [sym_preproc_undef] = STATE(3261),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_COLON] = ACTIONS(4943),
    [anon_sym_COMMA] = ACTIONS(4943),
    [anon_sym_RBRACK] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_LT] = ACTIONS(4945),
    [anon_sym_GT] = ACTIONS(4945),
    [anon_sym_in] = ACTIONS(4945),
    [anon_sym_QMARK] = ACTIONS(4945),
    [anon_sym_BANG] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_SLASH] = ACTIONS(4945),
    [anon_sym_PERCENT] = ACTIONS(4943),
    [anon_sym_CARET] = ACTIONS(4943),
    [anon_sym_PIPE] = ACTIONS(4945),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_LT_LT] = ACTIONS(4943),
    [anon_sym_GT_GT] = ACTIONS(4945),
    [anon_sym_GT_GT_GT] = ACTIONS(4943),
    [anon_sym_EQ_EQ] = ACTIONS(4943),
    [anon_sym_BANG_EQ] = ACTIONS(4943),
    [anon_sym_GT_EQ] = ACTIONS(4943),
    [anon_sym_LT_EQ] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4945),
    [anon_sym_EQ_GT] = ACTIONS(4943),
    [anon_sym_switch] = ACTIONS(4943),
    [anon_sym_when] = ACTIONS(4943),
    [anon_sym_DOT_DOT] = ACTIONS(4943),
    [anon_sym_and] = ACTIONS(4943),
    [anon_sym_or] = ACTIONS(4943),
    [anon_sym_AMP_AMP] = ACTIONS(4943),
    [anon_sym_PIPE_PIPE] = ACTIONS(4943),
    [anon_sym_QMARK_QMARK] = ACTIONS(4943),
    [anon_sym_into] = ACTIONS(4943),
    [anon_sym_on] = ACTIONS(4943),
    [anon_sym_equals] = ACTIONS(4943),
    [anon_sym_by] = ACTIONS(4943),
    [anon_sym_as] = ACTIONS(4943),
    [anon_sym_is] = ACTIONS(4943),
    [anon_sym_DASH_GT] = ACTIONS(4943),
    [anon_sym_with] = ACTIONS(4943),
    [aux_sym_raw_string_literal_token1] = ACTIONS(5386),
    [aux_sym_preproc_if_token3] = ACTIONS(4943),
    [aux_sym_preproc_else_token1] = ACTIONS(4943),
    [aux_sym_preproc_elif_token1] = ACTIONS(4943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3262] = {
    [sym_argument_list] = STATE(3488),
    [sym_bracketed_argument_list] = STATE(2724),
    [sym_preproc_region] = STATE(3262),
    [sym_preproc_endregion] = STATE(3262),
    [sym_preproc_line] = STATE(3262),
    [sym_preproc_pragma] = STATE(3262),
    [sym_preproc_nullable] = STATE(3262),
    [sym_preproc_error] = STATE(3262),
    [sym_preproc_warning] = STATE(3262),
    [sym_preproc_define] = STATE(3262),
    [sym_preproc_undef] = STATE(3262),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_in] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4910),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4908),
    [anon_sym_switch] = ACTIONS(4908),
    [anon_sym_when] = ACTIONS(4908),
    [anon_sym_DOT_DOT] = ACTIONS(4908),
    [anon_sym_and] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_QMARK_QMARK] = ACTIONS(4908),
    [anon_sym_on] = ACTIONS(4908),
    [anon_sym_equals] = ACTIONS(4908),
    [anon_sym_by] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4908),
    [anon_sym_is] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4908),
    [aux_sym_preproc_if_token3] = ACTIONS(4908),
    [aux_sym_preproc_else_token1] = ACTIONS(4908),
    [aux_sym_preproc_elif_token1] = ACTIONS(4908),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3263] = {
    [sym_preproc_region] = STATE(3263),
    [sym_preproc_endregion] = STATE(3263),
    [sym_preproc_line] = STATE(3263),
    [sym_preproc_pragma] = STATE(3263),
    [sym_preproc_nullable] = STATE(3263),
    [sym_preproc_error] = STATE(3263),
    [sym_preproc_warning] = STATE(3263),
    [sym_preproc_define] = STATE(3263),
    [sym_preproc_undef] = STATE(3263),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3947),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_when] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3949),
    [anon_sym_or] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_into] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_as] = ACTIONS(3949),
    [anon_sym_is] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3949),
    [aux_sym_preproc_if_token3] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3264] = {
    [sym_preproc_region] = STATE(3264),
    [sym_preproc_endregion] = STATE(3264),
    [sym_preproc_line] = STATE(3264),
    [sym_preproc_pragma] = STATE(3264),
    [sym_preproc_nullable] = STATE(3264),
    [sym_preproc_error] = STATE(3264),
    [sym_preproc_warning] = STATE(3264),
    [sym_preproc_define] = STATE(3264),
    [sym_preproc_undef] = STATE(3264),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_in] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3459),
    [anon_sym_and] = ACTIONS(3459),
    [anon_sym_or] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3459),
    [anon_sym_is] = ACTIONS(3459),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [aux_sym_preproc_if_token3] = ACTIONS(3459),
    [aux_sym_preproc_else_token1] = ACTIONS(3459),
    [aux_sym_preproc_elif_token1] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3265] = {
    [sym_preproc_region] = STATE(3265),
    [sym_preproc_endregion] = STATE(3265),
    [sym_preproc_line] = STATE(3265),
    [sym_preproc_pragma] = STATE(3265),
    [sym_preproc_nullable] = STATE(3265),
    [sym_preproc_error] = STATE(3265),
    [sym_preproc_warning] = STATE(3265),
    [sym_preproc_define] = STATE(3265),
    [sym_preproc_undef] = STATE(3265),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_GT_GT_GT] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_switch] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4040),
    [anon_sym_or] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_QMARK_QMARK] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(4040),
    [anon_sym_is] = ACTIONS(4040),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_with] = ACTIONS(4040),
    [aux_sym_preproc_if_token3] = ACTIONS(4040),
    [aux_sym_preproc_else_token1] = ACTIONS(4040),
    [aux_sym_preproc_elif_token1] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3266] = {
    [sym_preproc_region] = STATE(3266),
    [sym_preproc_endregion] = STATE(3266),
    [sym_preproc_line] = STATE(3266),
    [sym_preproc_pragma] = STATE(3266),
    [sym_preproc_nullable] = STATE(3266),
    [sym_preproc_error] = STATE(3266),
    [sym_preproc_warning] = STATE(3266),
    [sym_preproc_define] = STATE(3266),
    [sym_preproc_undef] = STATE(3266),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3672),
    [anon_sym_RBRACK] = ACTIONS(3672),
    [anon_sym_LPAREN] = ACTIONS(3672),
    [anon_sym_RPAREN] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3672),
    [anon_sym_RBRACE] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3672),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_PLUS_PLUS] = ACTIONS(3672),
    [anon_sym_DASH_DASH] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_DASH] = ACTIONS(3670),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_GT_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3672),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3672),
    [anon_sym_switch] = ACTIONS(3672),
    [anon_sym_when] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_and] = ACTIONS(3672),
    [anon_sym_or] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_QMARK_QMARK] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_equals] = ACTIONS(3672),
    [anon_sym_by] = ACTIONS(3672),
    [anon_sym_as] = ACTIONS(3672),
    [anon_sym_is] = ACTIONS(3672),
    [anon_sym_DASH_GT] = ACTIONS(3672),
    [anon_sym_with] = ACTIONS(3672),
    [aux_sym_preproc_if_token3] = ACTIONS(3672),
    [aux_sym_preproc_else_token1] = ACTIONS(3672),
    [aux_sym_preproc_elif_token1] = ACTIONS(3672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3267] = {
    [sym_preproc_region] = STATE(3267),
    [sym_preproc_endregion] = STATE(3267),
    [sym_preproc_line] = STATE(3267),
    [sym_preproc_pragma] = STATE(3267),
    [sym_preproc_nullable] = STATE(3267),
    [sym_preproc_error] = STATE(3267),
    [sym_preproc_warning] = STATE(3267),
    [sym_preproc_define] = STATE(3267),
    [sym_preproc_undef] = STATE(3267),
    [anon_sym_SEMI] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_COLON] = ACTIONS(5035),
    [anon_sym_COMMA] = ACTIONS(5035),
    [anon_sym_RBRACK] = ACTIONS(5035),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_RPAREN] = ACTIONS(5035),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_GT] = ACTIONS(5037),
    [anon_sym_in] = ACTIONS(5037),
    [anon_sym_QMARK] = ACTIONS(5037),
    [anon_sym_BANG] = ACTIONS(5037),
    [anon_sym_PLUS_PLUS] = ACTIONS(5035),
    [anon_sym_DASH_DASH] = ACTIONS(5035),
    [anon_sym_PLUS] = ACTIONS(5037),
    [anon_sym_DASH] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5035),
    [anon_sym_SLASH] = ACTIONS(5037),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [anon_sym_CARET] = ACTIONS(5035),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(5035),
    [anon_sym_GT_GT] = ACTIONS(5037),
    [anon_sym_GT_GT_GT] = ACTIONS(5035),
    [anon_sym_EQ_EQ] = ACTIONS(5035),
    [anon_sym_BANG_EQ] = ACTIONS(5035),
    [anon_sym_GT_EQ] = ACTIONS(5035),
    [anon_sym_LT_EQ] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5037),
    [anon_sym_EQ_GT] = ACTIONS(5035),
    [anon_sym_switch] = ACTIONS(5035),
    [anon_sym_when] = ACTIONS(5035),
    [anon_sym_DOT_DOT] = ACTIONS(5035),
    [anon_sym_and] = ACTIONS(5035),
    [anon_sym_or] = ACTIONS(5035),
    [anon_sym_AMP_AMP] = ACTIONS(5035),
    [anon_sym_PIPE_PIPE] = ACTIONS(5035),
    [anon_sym_QMARK_QMARK] = ACTIONS(5035),
    [anon_sym_into] = ACTIONS(5035),
    [anon_sym_on] = ACTIONS(5035),
    [anon_sym_equals] = ACTIONS(5035),
    [anon_sym_by] = ACTIONS(5035),
    [anon_sym_as] = ACTIONS(5035),
    [anon_sym_is] = ACTIONS(5035),
    [anon_sym_DASH_GT] = ACTIONS(5035),
    [anon_sym_with] = ACTIONS(5035),
    [aux_sym_preproc_if_token3] = ACTIONS(5035),
    [aux_sym_preproc_else_token1] = ACTIONS(5035),
    [aux_sym_preproc_elif_token1] = ACTIONS(5035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3268] = {
    [sym_preproc_region] = STATE(3268),
    [sym_preproc_endregion] = STATE(3268),
    [sym_preproc_line] = STATE(3268),
    [sym_preproc_pragma] = STATE(3268),
    [sym_preproc_nullable] = STATE(3268),
    [sym_preproc_error] = STATE(3268),
    [sym_preproc_warning] = STATE(3268),
    [sym_preproc_define] = STATE(3268),
    [sym_preproc_undef] = STATE(3268),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_in] = ACTIONS(5390),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_BANG] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5388),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_GT_GT_GT] = ACTIONS(5388),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_EQ_GT] = ACTIONS(5388),
    [anon_sym_switch] = ACTIONS(5388),
    [anon_sym_when] = ACTIONS(5388),
    [anon_sym_DOT_DOT] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_QMARK_QMARK] = ACTIONS(5388),
    [anon_sym_into] = ACTIONS(5388),
    [anon_sym_on] = ACTIONS(5388),
    [anon_sym_equals] = ACTIONS(5388),
    [anon_sym_by] = ACTIONS(5388),
    [anon_sym_as] = ACTIONS(5388),
    [anon_sym_is] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [anon_sym_with] = ACTIONS(5388),
    [aux_sym_preproc_if_token3] = ACTIONS(5388),
    [aux_sym_preproc_else_token1] = ACTIONS(5388),
    [aux_sym_preproc_elif_token1] = ACTIONS(5388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3269] = {
    [sym_initializer_expression] = STATE(3423),
    [sym_preproc_region] = STATE(3269),
    [sym_preproc_endregion] = STATE(3269),
    [sym_preproc_line] = STATE(3269),
    [sym_preproc_pragma] = STATE(3269),
    [sym_preproc_nullable] = STATE(3269),
    [sym_preproc_error] = STATE(3269),
    [sym_preproc_warning] = STATE(3269),
    [sym_preproc_define] = STATE(3269),
    [sym_preproc_undef] = STATE(3269),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4916),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(5395),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4926),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4926),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_GT_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4926),
    [anon_sym_EQ_GT] = ACTIONS(4920),
    [anon_sym_switch] = ACTIONS(4920),
    [anon_sym_when] = ACTIONS(4920),
    [anon_sym_DOT_DOT] = ACTIONS(4920),
    [anon_sym_and] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_QMARK_QMARK] = ACTIONS(4920),
    [anon_sym_on] = ACTIONS(4920),
    [anon_sym_equals] = ACTIONS(4920),
    [anon_sym_by] = ACTIONS(4920),
    [anon_sym_as] = ACTIONS(4920),
    [anon_sym_is] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_with] = ACTIONS(4920),
    [aux_sym_preproc_if_token3] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4920),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3270] = {
    [sym_type_argument_list] = STATE(2991),
    [sym_preproc_region] = STATE(3270),
    [sym_preproc_endregion] = STATE(3270),
    [sym_preproc_line] = STATE(3270),
    [sym_preproc_pragma] = STATE(3270),
    [sym_preproc_nullable] = STATE(3270),
    [sym_preproc_error] = STATE(3270),
    [sym_preproc_warning] = STATE(3270),
    [sym_preproc_define] = STATE(3270),
    [sym_preproc_undef] = STATE(3270),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4868),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_COLON_COLON] = ACTIONS(5399),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3271] = {
    [sym_preproc_region] = STATE(3271),
    [sym_preproc_endregion] = STATE(3271),
    [sym_preproc_line] = STATE(3271),
    [sym_preproc_pragma] = STATE(3271),
    [sym_preproc_nullable] = STATE(3271),
    [sym_preproc_error] = STATE(3271),
    [sym_preproc_warning] = STATE(3271),
    [sym_preproc_define] = STATE(3271),
    [sym_preproc_undef] = STATE(3271),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4028),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_when] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3272] = {
    [sym_modifier] = STATE(3734),
    [sym_identifier] = STATE(6453),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3272),
    [sym_preproc_endregion] = STATE(3272),
    [sym_preproc_line] = STATE(3272),
    [sym_preproc_pragma] = STATE(3272),
    [sym_preproc_nullable] = STATE(3272),
    [sym_preproc_error] = STATE(3272),
    [sym_preproc_warning] = STATE(3272),
    [sym_preproc_define] = STATE(3272),
    [sym_preproc_undef] = STATE(3272),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3558),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(4787),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(4787),
    [anon_sym_static] = ACTIONS(4787),
    [anon_sym_abstract] = ACTIONS(4787),
    [anon_sym_async] = ACTIONS(4787),
    [anon_sym_const] = ACTIONS(4787),
    [anon_sym_file] = ACTIONS(4793),
    [anon_sym_fixed] = ACTIONS(4787),
    [anon_sym_internal] = ACTIONS(4787),
    [anon_sym_new] = ACTIONS(4787),
    [anon_sym_override] = ACTIONS(4787),
    [anon_sym_partial] = ACTIONS(4787),
    [anon_sym_private] = ACTIONS(4787),
    [anon_sym_protected] = ACTIONS(4787),
    [anon_sym_public] = ACTIONS(4787),
    [anon_sym_readonly] = ACTIONS(4787),
    [anon_sym_required] = ACTIONS(4787),
    [anon_sym_sealed] = ACTIONS(4787),
    [anon_sym_virtual] = ACTIONS(4787),
    [anon_sym_volatile] = ACTIONS(4787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_get] = ACTIONS(5133),
    [anon_sym_set] = ACTIONS(5133),
    [anon_sym_add] = ACTIONS(5133),
    [anon_sym_remove] = ACTIONS(5133),
    [anon_sym_init] = ACTIONS(5133),
    [anon_sym_scoped] = ACTIONS(29),
    [anon_sym_var] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_from] = ACTIONS(29),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3273] = {
    [sym_preproc_region] = STATE(3273),
    [sym_preproc_endregion] = STATE(3273),
    [sym_preproc_line] = STATE(3273),
    [sym_preproc_pragma] = STATE(3273),
    [sym_preproc_nullable] = STATE(3273),
    [sym_preproc_error] = STATE(3273),
    [sym_preproc_warning] = STATE(3273),
    [sym_preproc_define] = STATE(3273),
    [sym_preproc_undef] = STATE(3273),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4036),
    [anon_sym_QMARK] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_CARET] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_GT_GT_GT] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_EQ_GT] = ACTIONS(4036),
    [anon_sym_switch] = ACTIONS(4036),
    [anon_sym_when] = ACTIONS(4036),
    [anon_sym_DOT_DOT] = ACTIONS(4036),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_QMARK_QMARK] = ACTIONS(4036),
    [anon_sym_on] = ACTIONS(4036),
    [anon_sym_equals] = ACTIONS(4036),
    [anon_sym_by] = ACTIONS(4036),
    [anon_sym_as] = ACTIONS(4036),
    [anon_sym_is] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4036),
    [aux_sym_preproc_if_token3] = ACTIONS(4036),
    [aux_sym_preproc_else_token1] = ACTIONS(4036),
    [aux_sym_preproc_elif_token1] = ACTIONS(4036),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3274] = {
    [sym_preproc_region] = STATE(3274),
    [sym_preproc_endregion] = STATE(3274),
    [sym_preproc_line] = STATE(3274),
    [sym_preproc_pragma] = STATE(3274),
    [sym_preproc_nullable] = STATE(3274),
    [sym_preproc_error] = STATE(3274),
    [sym_preproc_warning] = STATE(3274),
    [sym_preproc_define] = STATE(3274),
    [sym_preproc_undef] = STATE(3274),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_RBRACK] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(5401),
    [anon_sym_RPAREN] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_EQ_GT] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_when] = ACTIONS(1997),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [anon_sym_or] = ACTIONS(1997),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_into] = ACTIONS(1997),
    [anon_sym_on] = ACTIONS(1997),
    [anon_sym_equals] = ACTIONS(1997),
    [anon_sym_by] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1997),
    [anon_sym_is] = ACTIONS(1997),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_with] = ACTIONS(1997),
    [aux_sym_preproc_if_token3] = ACTIONS(1997),
    [aux_sym_preproc_else_token1] = ACTIONS(1997),
    [aux_sym_preproc_elif_token1] = ACTIONS(1997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3275] = {
    [sym_preproc_region] = STATE(3275),
    [sym_preproc_endregion] = STATE(3275),
    [sym_preproc_line] = STATE(3275),
    [sym_preproc_pragma] = STATE(3275),
    [sym_preproc_nullable] = STATE(3275),
    [sym_preproc_error] = STATE(3275),
    [sym_preproc_warning] = STATE(3275),
    [sym_preproc_define] = STATE(3275),
    [sym_preproc_undef] = STATE(3275),
    [anon_sym_SEMI] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(5163),
    [anon_sym_COLON] = ACTIONS(5163),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACK] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(5163),
    [anon_sym_RPAREN] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_in] = ACTIONS(5165),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_PLUS_PLUS] = ACTIONS(5163),
    [anon_sym_DASH_DASH] = ACTIONS(5163),
    [anon_sym_PLUS] = ACTIONS(5165),
    [anon_sym_DASH] = ACTIONS(5165),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_SLASH] = ACTIONS(5165),
    [anon_sym_PERCENT] = ACTIONS(5163),
    [anon_sym_CARET] = ACTIONS(5163),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_LT_LT] = ACTIONS(5163),
    [anon_sym_GT_GT] = ACTIONS(5165),
    [anon_sym_GT_GT_GT] = ACTIONS(5163),
    [anon_sym_EQ_EQ] = ACTIONS(5163),
    [anon_sym_BANG_EQ] = ACTIONS(5163),
    [anon_sym_GT_EQ] = ACTIONS(5163),
    [anon_sym_LT_EQ] = ACTIONS(5163),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_EQ_GT] = ACTIONS(5163),
    [anon_sym_switch] = ACTIONS(5163),
    [anon_sym_when] = ACTIONS(5163),
    [anon_sym_DOT_DOT] = ACTIONS(5163),
    [anon_sym_and] = ACTIONS(5163),
    [anon_sym_or] = ACTIONS(5163),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_QMARK_QMARK] = ACTIONS(5163),
    [anon_sym_into] = ACTIONS(5163),
    [anon_sym_on] = ACTIONS(5163),
    [anon_sym_equals] = ACTIONS(5163),
    [anon_sym_by] = ACTIONS(5163),
    [anon_sym_as] = ACTIONS(5163),
    [anon_sym_is] = ACTIONS(5163),
    [anon_sym_DASH_GT] = ACTIONS(5163),
    [anon_sym_with] = ACTIONS(5163),
    [aux_sym_preproc_if_token3] = ACTIONS(5163),
    [aux_sym_preproc_else_token1] = ACTIONS(5163),
    [aux_sym_preproc_elif_token1] = ACTIONS(5163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3276] = {
    [sym_preproc_region] = STATE(3276),
    [sym_preproc_endregion] = STATE(3276),
    [sym_preproc_line] = STATE(3276),
    [sym_preproc_pragma] = STATE(3276),
    [sym_preproc_nullable] = STATE(3276),
    [sym_preproc_error] = STATE(3276),
    [sym_preproc_warning] = STATE(3276),
    [sym_preproc_define] = STATE(3276),
    [sym_preproc_undef] = STATE(3276),
    [anon_sym_SEMI] = ACTIONS(5159),
    [anon_sym_LBRACK] = ACTIONS(5159),
    [anon_sym_COLON] = ACTIONS(5159),
    [anon_sym_COMMA] = ACTIONS(5159),
    [anon_sym_RBRACK] = ACTIONS(5159),
    [anon_sym_LPAREN] = ACTIONS(5159),
    [anon_sym_RPAREN] = ACTIONS(5159),
    [anon_sym_RBRACE] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_in] = ACTIONS(5161),
    [anon_sym_QMARK] = ACTIONS(5161),
    [anon_sym_BANG] = ACTIONS(5161),
    [anon_sym_PLUS_PLUS] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(5161),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_AMP] = ACTIONS(5161),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5161),
    [anon_sym_GT_GT_GT] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5159),
    [anon_sym_BANG_EQ] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5159),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_DOT] = ACTIONS(5161),
    [anon_sym_EQ_GT] = ACTIONS(5159),
    [anon_sym_switch] = ACTIONS(5159),
    [anon_sym_when] = ACTIONS(5159),
    [anon_sym_DOT_DOT] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_QMARK_QMARK] = ACTIONS(5159),
    [anon_sym_into] = ACTIONS(5159),
    [anon_sym_on] = ACTIONS(5159),
    [anon_sym_equals] = ACTIONS(5159),
    [anon_sym_by] = ACTIONS(5159),
    [anon_sym_as] = ACTIONS(5159),
    [anon_sym_is] = ACTIONS(5159),
    [anon_sym_DASH_GT] = ACTIONS(5159),
    [anon_sym_with] = ACTIONS(5159),
    [aux_sym_preproc_if_token3] = ACTIONS(5159),
    [aux_sym_preproc_else_token1] = ACTIONS(5159),
    [aux_sym_preproc_elif_token1] = ACTIONS(5159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3277] = {
    [sym_preproc_region] = STATE(3277),
    [sym_preproc_endregion] = STATE(3277),
    [sym_preproc_line] = STATE(3277),
    [sym_preproc_pragma] = STATE(3277),
    [sym_preproc_nullable] = STATE(3277),
    [sym_preproc_error] = STATE(3277),
    [sym_preproc_warning] = STATE(3277),
    [sym_preproc_define] = STATE(3277),
    [sym_preproc_undef] = STATE(3277),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACK] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [anon_sym_LPAREN] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_in] = ACTIONS(5224),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_BANG] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_PIPE] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5224),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5224),
    [anon_sym_GT_GT_GT] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5222),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_DOT] = ACTIONS(5224),
    [anon_sym_EQ_GT] = ACTIONS(5222),
    [anon_sym_switch] = ACTIONS(5222),
    [anon_sym_when] = ACTIONS(5222),
    [anon_sym_DOT_DOT] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_or] = ACTIONS(5222),
    [anon_sym_AMP_AMP] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5222),
    [anon_sym_QMARK_QMARK] = ACTIONS(5222),
    [anon_sym_into] = ACTIONS(5222),
    [anon_sym_on] = ACTIONS(5222),
    [anon_sym_equals] = ACTIONS(5222),
    [anon_sym_by] = ACTIONS(5222),
    [anon_sym_as] = ACTIONS(5222),
    [anon_sym_is] = ACTIONS(5222),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [anon_sym_with] = ACTIONS(5222),
    [aux_sym_preproc_if_token3] = ACTIONS(5222),
    [aux_sym_preproc_else_token1] = ACTIONS(5222),
    [aux_sym_preproc_elif_token1] = ACTIONS(5222),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3278] = {
    [sym_preproc_region] = STATE(3278),
    [sym_preproc_endregion] = STATE(3278),
    [sym_preproc_line] = STATE(3278),
    [sym_preproc_pragma] = STATE(3278),
    [sym_preproc_nullable] = STATE(3278),
    [sym_preproc_error] = STATE(3278),
    [sym_preproc_warning] = STATE(3278),
    [sym_preproc_define] = STATE(3278),
    [sym_preproc_undef] = STATE(3278),
    [anon_sym_SEMI] = ACTIONS(5105),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_COLON] = ACTIONS(5105),
    [anon_sym_COMMA] = ACTIONS(5105),
    [anon_sym_RBRACK] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_RPAREN] = ACTIONS(5105),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5107),
    [anon_sym_in] = ACTIONS(5107),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_BANG] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5107),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_PIPE] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_GT_GT_GT] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5105),
    [anon_sym_BANG_EQ] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5105),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_DOT] = ACTIONS(5107),
    [anon_sym_EQ_GT] = ACTIONS(5105),
    [anon_sym_switch] = ACTIONS(5105),
    [anon_sym_when] = ACTIONS(5105),
    [anon_sym_DOT_DOT] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_or] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5105),
    [anon_sym_QMARK_QMARK] = ACTIONS(5105),
    [anon_sym_into] = ACTIONS(5105),
    [anon_sym_on] = ACTIONS(5105),
    [anon_sym_equals] = ACTIONS(5105),
    [anon_sym_by] = ACTIONS(5105),
    [anon_sym_as] = ACTIONS(5105),
    [anon_sym_is] = ACTIONS(5105),
    [anon_sym_DASH_GT] = ACTIONS(5105),
    [anon_sym_with] = ACTIONS(5105),
    [aux_sym_preproc_if_token3] = ACTIONS(5105),
    [aux_sym_preproc_else_token1] = ACTIONS(5105),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3279] = {
    [sym_preproc_region] = STATE(3279),
    [sym_preproc_endregion] = STATE(3279),
    [sym_preproc_line] = STATE(3279),
    [sym_preproc_pragma] = STATE(3279),
    [sym_preproc_nullable] = STATE(3279),
    [sym_preproc_error] = STATE(3279),
    [sym_preproc_warning] = STATE(3279),
    [sym_preproc_define] = STATE(3279),
    [sym_preproc_undef] = STATE(3279),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4048),
    [anon_sym_GT] = ACTIONS(4048),
    [anon_sym_in] = ACTIONS(4050),
    [anon_sym_QMARK] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4050),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4048),
    [anon_sym_GT_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_DOT] = ACTIONS(4048),
    [anon_sym_EQ_GT] = ACTIONS(4050),
    [anon_sym_switch] = ACTIONS(4050),
    [anon_sym_when] = ACTIONS(4050),
    [anon_sym_DOT_DOT] = ACTIONS(4050),
    [anon_sym_and] = ACTIONS(4050),
    [anon_sym_or] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_QMARK_QMARK] = ACTIONS(4050),
    [anon_sym_on] = ACTIONS(4050),
    [anon_sym_equals] = ACTIONS(4050),
    [anon_sym_by] = ACTIONS(4050),
    [anon_sym_as] = ACTIONS(4050),
    [anon_sym_is] = ACTIONS(4050),
    [anon_sym_DASH_GT] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4050),
    [aux_sym_preproc_if_token3] = ACTIONS(4050),
    [aux_sym_preproc_else_token1] = ACTIONS(4050),
    [aux_sym_preproc_elif_token1] = ACTIONS(4050),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3280] = {
    [sym_preproc_region] = STATE(3280),
    [sym_preproc_endregion] = STATE(3280),
    [sym_preproc_line] = STATE(3280),
    [sym_preproc_pragma] = STATE(3280),
    [sym_preproc_nullable] = STATE(3280),
    [sym_preproc_error] = STATE(3280),
    [sym_preproc_warning] = STATE(3280),
    [sym_preproc_define] = STATE(3280),
    [sym_preproc_undef] = STATE(3280),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_in] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_when] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_into] = ACTIONS(5403),
    [anon_sym_on] = ACTIONS(5403),
    [anon_sym_equals] = ACTIONS(5403),
    [anon_sym_by] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5403),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_if_token3] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3281] = {
    [sym_preproc_region] = STATE(3281),
    [sym_preproc_endregion] = STATE(3281),
    [sym_preproc_line] = STATE(3281),
    [sym_preproc_pragma] = STATE(3281),
    [sym_preproc_nullable] = STATE(3281),
    [sym_preproc_error] = STATE(3281),
    [sym_preproc_warning] = STATE(3281),
    [sym_preproc_define] = STATE(3281),
    [sym_preproc_undef] = STATE(3281),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_in] = ACTIONS(5409),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_into] = ACTIONS(5407),
    [anon_sym_on] = ACTIONS(5407),
    [anon_sym_equals] = ACTIONS(5407),
    [anon_sym_by] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5407),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_if_token3] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3282] = {
    [sym_preproc_region] = STATE(3282),
    [sym_preproc_endregion] = STATE(3282),
    [sym_preproc_line] = STATE(3282),
    [sym_preproc_pragma] = STATE(3282),
    [sym_preproc_nullable] = STATE(3282),
    [sym_preproc_error] = STATE(3282),
    [sym_preproc_warning] = STATE(3282),
    [sym_preproc_define] = STATE(3282),
    [sym_preproc_undef] = STATE(3282),
    [anon_sym_SEMI] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COMMA] = ACTIONS(5411),
    [anon_sym_RBRACK] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5411),
    [anon_sym_RPAREN] = ACTIONS(5411),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5413),
    [anon_sym_in] = ACTIONS(5413),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5413),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_PIPE] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5413),
    [anon_sym_GT_GT_GT] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5411),
    [anon_sym_BANG_EQ] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_DOT] = ACTIONS(5413),
    [anon_sym_EQ_GT] = ACTIONS(5411),
    [anon_sym_switch] = ACTIONS(5411),
    [anon_sym_when] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_AMP_AMP] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_into] = ACTIONS(5411),
    [anon_sym_on] = ACTIONS(5411),
    [anon_sym_equals] = ACTIONS(5411),
    [anon_sym_by] = ACTIONS(5411),
    [anon_sym_as] = ACTIONS(5411),
    [anon_sym_is] = ACTIONS(5411),
    [anon_sym_DASH_GT] = ACTIONS(5411),
    [anon_sym_with] = ACTIONS(5411),
    [aux_sym_preproc_if_token3] = ACTIONS(5411),
    [aux_sym_preproc_else_token1] = ACTIONS(5411),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3283] = {
    [sym_preproc_region] = STATE(3283),
    [sym_preproc_endregion] = STATE(3283),
    [sym_preproc_line] = STATE(3283),
    [sym_preproc_pragma] = STATE(3283),
    [sym_preproc_nullable] = STATE(3283),
    [sym_preproc_error] = STATE(3283),
    [sym_preproc_warning] = STATE(3283),
    [sym_preproc_define] = STATE(3283),
    [sym_preproc_undef] = STATE(3283),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(5097),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_RBRACK] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5099),
    [anon_sym_in] = ACTIONS(5099),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_BANG] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_SLASH] = ACTIONS(5099),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5097),
    [anon_sym_PIPE] = ACTIONS(5099),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym_LT_LT] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5099),
    [anon_sym_GT_GT_GT] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_DOT] = ACTIONS(5099),
    [anon_sym_EQ_GT] = ACTIONS(5097),
    [anon_sym_switch] = ACTIONS(5097),
    [anon_sym_when] = ACTIONS(5097),
    [anon_sym_DOT_DOT] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_or] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_QMARK_QMARK] = ACTIONS(5097),
    [anon_sym_into] = ACTIONS(5097),
    [anon_sym_on] = ACTIONS(5097),
    [anon_sym_equals] = ACTIONS(5097),
    [anon_sym_by] = ACTIONS(5097),
    [anon_sym_as] = ACTIONS(5097),
    [anon_sym_is] = ACTIONS(5097),
    [anon_sym_DASH_GT] = ACTIONS(5097),
    [anon_sym_with] = ACTIONS(5097),
    [aux_sym_preproc_if_token3] = ACTIONS(5097),
    [aux_sym_preproc_else_token1] = ACTIONS(5097),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3284] = {
    [sym_preproc_region] = STATE(3284),
    [sym_preproc_endregion] = STATE(3284),
    [sym_preproc_line] = STATE(3284),
    [sym_preproc_pragma] = STATE(3284),
    [sym_preproc_nullable] = STATE(3284),
    [sym_preproc_error] = STATE(3284),
    [sym_preproc_warning] = STATE(3284),
    [sym_preproc_define] = STATE(3284),
    [sym_preproc_undef] = STATE(3284),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(5415),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3285] = {
    [sym_preproc_region] = STATE(3285),
    [sym_preproc_endregion] = STATE(3285),
    [sym_preproc_line] = STATE(3285),
    [sym_preproc_pragma] = STATE(3285),
    [sym_preproc_nullable] = STATE(3285),
    [sym_preproc_error] = STATE(3285),
    [sym_preproc_warning] = STATE(3285),
    [sym_preproc_define] = STATE(3285),
    [sym_preproc_undef] = STATE(3285),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COMMA] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4040),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4040),
    [anon_sym_SLASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_CARET] = ACTIONS(4040),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_GT_GT_GT] = ACTIONS(4040),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_switch] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4040),
    [anon_sym_and] = ACTIONS(4040),
    [anon_sym_or] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_QMARK_QMARK] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_as] = ACTIONS(4040),
    [anon_sym_is] = ACTIONS(4040),
    [anon_sym_DASH_GT] = ACTIONS(4040),
    [anon_sym_with] = ACTIONS(4040),
    [aux_sym_preproc_if_token3] = ACTIONS(4040),
    [aux_sym_preproc_else_token1] = ACTIONS(4040),
    [aux_sym_preproc_elif_token1] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3286] = {
    [sym_preproc_region] = STATE(3286),
    [sym_preproc_endregion] = STATE(3286),
    [sym_preproc_line] = STATE(3286),
    [sym_preproc_pragma] = STATE(3286),
    [sym_preproc_nullable] = STATE(3286),
    [sym_preproc_error] = STATE(3286),
    [sym_preproc_warning] = STATE(3286),
    [sym_preproc_define] = STATE(3286),
    [sym_preproc_undef] = STATE(3286),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [anon_sym_COLON] = ACTIONS(5417),
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_RBRACK] = ACTIONS(5417),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_RPAREN] = ACTIONS(5417),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5419),
    [anon_sym_in] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_PIPE] = ACTIONS(5419),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5419),
    [anon_sym_GT_GT_GT] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5417),
    [anon_sym_BANG_EQ] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_DOT] = ACTIONS(5419),
    [anon_sym_EQ_GT] = ACTIONS(5417),
    [anon_sym_switch] = ACTIONS(5417),
    [anon_sym_when] = ACTIONS(5417),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5417),
    [anon_sym_QMARK_QMARK] = ACTIONS(5417),
    [anon_sym_into] = ACTIONS(5417),
    [anon_sym_on] = ACTIONS(5417),
    [anon_sym_equals] = ACTIONS(5417),
    [anon_sym_by] = ACTIONS(5417),
    [anon_sym_as] = ACTIONS(5417),
    [anon_sym_is] = ACTIONS(5417),
    [anon_sym_DASH_GT] = ACTIONS(5417),
    [anon_sym_with] = ACTIONS(5417),
    [aux_sym_preproc_if_token3] = ACTIONS(5417),
    [aux_sym_preproc_else_token1] = ACTIONS(5417),
    [aux_sym_preproc_elif_token1] = ACTIONS(5417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3287] = {
    [sym_preproc_region] = STATE(3287),
    [sym_preproc_endregion] = STATE(3287),
    [sym_preproc_line] = STATE(3287),
    [sym_preproc_pragma] = STATE(3287),
    [sym_preproc_nullable] = STATE(3287),
    [sym_preproc_error] = STATE(3287),
    [sym_preproc_warning] = STATE(3287),
    [sym_preproc_define] = STATE(3287),
    [sym_preproc_undef] = STATE(3287),
    [anon_sym_SEMI] = ACTIONS(5019),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_COLON] = ACTIONS(5019),
    [anon_sym_COMMA] = ACTIONS(5019),
    [anon_sym_RBRACK] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_RPAREN] = ACTIONS(5019),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_LT] = ACTIONS(5021),
    [anon_sym_GT] = ACTIONS(5021),
    [anon_sym_in] = ACTIONS(5021),
    [anon_sym_QMARK] = ACTIONS(5021),
    [anon_sym_BANG] = ACTIONS(5021),
    [anon_sym_PLUS_PLUS] = ACTIONS(5019),
    [anon_sym_DASH_DASH] = ACTIONS(5019),
    [anon_sym_PLUS] = ACTIONS(5021),
    [anon_sym_DASH] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(5019),
    [anon_sym_SLASH] = ACTIONS(5021),
    [anon_sym_PERCENT] = ACTIONS(5019),
    [anon_sym_CARET] = ACTIONS(5019),
    [anon_sym_PIPE] = ACTIONS(5021),
    [anon_sym_AMP] = ACTIONS(5021),
    [anon_sym_LT_LT] = ACTIONS(5019),
    [anon_sym_GT_GT] = ACTIONS(5021),
    [anon_sym_GT_GT_GT] = ACTIONS(5019),
    [anon_sym_EQ_EQ] = ACTIONS(5019),
    [anon_sym_BANG_EQ] = ACTIONS(5019),
    [anon_sym_GT_EQ] = ACTIONS(5019),
    [anon_sym_LT_EQ] = ACTIONS(5019),
    [anon_sym_DOT] = ACTIONS(5021),
    [anon_sym_EQ_GT] = ACTIONS(5019),
    [anon_sym_switch] = ACTIONS(5019),
    [anon_sym_when] = ACTIONS(5019),
    [anon_sym_DOT_DOT] = ACTIONS(5019),
    [anon_sym_and] = ACTIONS(5019),
    [anon_sym_or] = ACTIONS(5019),
    [anon_sym_AMP_AMP] = ACTIONS(5019),
    [anon_sym_PIPE_PIPE] = ACTIONS(5019),
    [anon_sym_QMARK_QMARK] = ACTIONS(5019),
    [anon_sym_into] = ACTIONS(5019),
    [anon_sym_on] = ACTIONS(5019),
    [anon_sym_equals] = ACTIONS(5019),
    [anon_sym_by] = ACTIONS(5019),
    [anon_sym_as] = ACTIONS(5019),
    [anon_sym_is] = ACTIONS(5019),
    [anon_sym_DASH_GT] = ACTIONS(5019),
    [anon_sym_with] = ACTIONS(5019),
    [aux_sym_preproc_if_token3] = ACTIONS(5019),
    [aux_sym_preproc_else_token1] = ACTIONS(5019),
    [aux_sym_preproc_elif_token1] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3288] = {
    [sym_preproc_region] = STATE(3288),
    [sym_preproc_endregion] = STATE(3288),
    [sym_preproc_line] = STATE(3288),
    [sym_preproc_pragma] = STATE(3288),
    [sym_preproc_nullable] = STATE(3288),
    [sym_preproc_error] = STATE(3288),
    [sym_preproc_warning] = STATE(3288),
    [sym_preproc_define] = STATE(3288),
    [sym_preproc_undef] = STATE(3288),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3289] = {
    [sym_preproc_region] = STATE(3289),
    [sym_preproc_endregion] = STATE(3289),
    [sym_preproc_line] = STATE(3289),
    [sym_preproc_pragma] = STATE(3289),
    [sym_preproc_nullable] = STATE(3289),
    [sym_preproc_error] = STATE(3289),
    [sym_preproc_warning] = STATE(3289),
    [sym_preproc_define] = STATE(3289),
    [sym_preproc_undef] = STATE(3289),
    [anon_sym_SEMI] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_COLON] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RBRACK] = ACTIONS(5199),
    [anon_sym_LPAREN] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_LT] = ACTIONS(5201),
    [anon_sym_GT] = ACTIONS(5201),
    [anon_sym_in] = ACTIONS(5201),
    [anon_sym_QMARK] = ACTIONS(5201),
    [anon_sym_BANG] = ACTIONS(5201),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_STAR] = ACTIONS(5199),
    [anon_sym_SLASH] = ACTIONS(5201),
    [anon_sym_PERCENT] = ACTIONS(5199),
    [anon_sym_CARET] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5201),
    [anon_sym_AMP] = ACTIONS(5201),
    [anon_sym_LT_LT] = ACTIONS(5199),
    [anon_sym_GT_GT] = ACTIONS(5201),
    [anon_sym_GT_GT_GT] = ACTIONS(5199),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5201),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_switch] = ACTIONS(5199),
    [anon_sym_when] = ACTIONS(5199),
    [anon_sym_DOT_DOT] = ACTIONS(5199),
    [anon_sym_and] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_QMARK_QMARK] = ACTIONS(5199),
    [anon_sym_into] = ACTIONS(5199),
    [anon_sym_on] = ACTIONS(5199),
    [anon_sym_equals] = ACTIONS(5199),
    [anon_sym_by] = ACTIONS(5199),
    [anon_sym_as] = ACTIONS(5199),
    [anon_sym_is] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_with] = ACTIONS(5199),
    [aux_sym_preproc_if_token3] = ACTIONS(5199),
    [aux_sym_preproc_else_token1] = ACTIONS(5199),
    [aux_sym_preproc_elif_token1] = ACTIONS(5199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3290] = {
    [sym_preproc_region] = STATE(3290),
    [sym_preproc_endregion] = STATE(3290),
    [sym_preproc_line] = STATE(3290),
    [sym_preproc_pragma] = STATE(3290),
    [sym_preproc_nullable] = STATE(3290),
    [sym_preproc_error] = STATE(3290),
    [sym_preproc_warning] = STATE(3290),
    [sym_preproc_define] = STATE(3290),
    [sym_preproc_undef] = STATE(3290),
    [anon_sym_SEMI] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_COLON] = ACTIONS(5043),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_RBRACK] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5043),
    [anon_sym_RPAREN] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_in] = ACTIONS(5043),
    [anon_sym_QMARK] = ACTIONS(5045),
    [anon_sym_BANG] = ACTIONS(5045),
    [anon_sym_PLUS_PLUS] = ACTIONS(5043),
    [anon_sym_DASH_DASH] = ACTIONS(5043),
    [anon_sym_PLUS] = ACTIONS(5045),
    [anon_sym_DASH] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5043),
    [anon_sym_SLASH] = ACTIONS(5045),
    [anon_sym_PERCENT] = ACTIONS(5043),
    [anon_sym_CARET] = ACTIONS(5043),
    [anon_sym_PIPE] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5045),
    [anon_sym_LT_LT] = ACTIONS(5043),
    [anon_sym_GT_GT] = ACTIONS(5045),
    [anon_sym_GT_GT_GT] = ACTIONS(5043),
    [anon_sym_EQ_EQ] = ACTIONS(5043),
    [anon_sym_BANG_EQ] = ACTIONS(5043),
    [anon_sym_GT_EQ] = ACTIONS(5043),
    [anon_sym_LT_EQ] = ACTIONS(5043),
    [anon_sym_DOT] = ACTIONS(5045),
    [anon_sym_EQ_GT] = ACTIONS(5043),
    [anon_sym_switch] = ACTIONS(5043),
    [anon_sym_when] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5043),
    [anon_sym_and] = ACTIONS(5043),
    [anon_sym_or] = ACTIONS(5043),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_QMARK_QMARK] = ACTIONS(5043),
    [anon_sym_on] = ACTIONS(5043),
    [anon_sym_equals] = ACTIONS(5043),
    [anon_sym_by] = ACTIONS(5043),
    [anon_sym_as] = ACTIONS(5043),
    [anon_sym_is] = ACTIONS(5043),
    [anon_sym_DASH_GT] = ACTIONS(5043),
    [anon_sym_with] = ACTIONS(5043),
    [anon_sym_DQUOTE] = ACTIONS(5043),
    [aux_sym_preproc_if_token3] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3291] = {
    [sym_preproc_region] = STATE(3291),
    [sym_preproc_endregion] = STATE(3291),
    [sym_preproc_line] = STATE(3291),
    [sym_preproc_pragma] = STATE(3291),
    [sym_preproc_nullable] = STATE(3291),
    [sym_preproc_error] = STATE(3291),
    [sym_preproc_warning] = STATE(3291),
    [sym_preproc_define] = STATE(3291),
    [sym_preproc_undef] = STATE(3291),
    [anon_sym_SEMI] = ACTIONS(5191),
    [anon_sym_LBRACK] = ACTIONS(5191),
    [anon_sym_COLON] = ACTIONS(5191),
    [anon_sym_COMMA] = ACTIONS(5191),
    [anon_sym_RBRACK] = ACTIONS(5191),
    [anon_sym_LPAREN] = ACTIONS(5191),
    [anon_sym_RPAREN] = ACTIONS(5191),
    [anon_sym_RBRACE] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_in] = ACTIONS(5193),
    [anon_sym_QMARK] = ACTIONS(5193),
    [anon_sym_BANG] = ACTIONS(5193),
    [anon_sym_PLUS_PLUS] = ACTIONS(5191),
    [anon_sym_DASH_DASH] = ACTIONS(5191),
    [anon_sym_PLUS] = ACTIONS(5193),
    [anon_sym_DASH] = ACTIONS(5193),
    [anon_sym_STAR] = ACTIONS(5191),
    [anon_sym_SLASH] = ACTIONS(5193),
    [anon_sym_PERCENT] = ACTIONS(5191),
    [anon_sym_CARET] = ACTIONS(5191),
    [anon_sym_PIPE] = ACTIONS(5193),
    [anon_sym_AMP] = ACTIONS(5193),
    [anon_sym_LT_LT] = ACTIONS(5191),
    [anon_sym_GT_GT] = ACTIONS(5193),
    [anon_sym_GT_GT_GT] = ACTIONS(5191),
    [anon_sym_EQ_EQ] = ACTIONS(5191),
    [anon_sym_BANG_EQ] = ACTIONS(5191),
    [anon_sym_GT_EQ] = ACTIONS(5191),
    [anon_sym_LT_EQ] = ACTIONS(5191),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_EQ_GT] = ACTIONS(5191),
    [anon_sym_switch] = ACTIONS(5191),
    [anon_sym_when] = ACTIONS(5191),
    [anon_sym_DOT_DOT] = ACTIONS(5191),
    [anon_sym_and] = ACTIONS(5191),
    [anon_sym_or] = ACTIONS(5191),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_PIPE_PIPE] = ACTIONS(5191),
    [anon_sym_QMARK_QMARK] = ACTIONS(5191),
    [anon_sym_into] = ACTIONS(5191),
    [anon_sym_on] = ACTIONS(5191),
    [anon_sym_equals] = ACTIONS(5191),
    [anon_sym_by] = ACTIONS(5191),
    [anon_sym_as] = ACTIONS(5191),
    [anon_sym_is] = ACTIONS(5191),
    [anon_sym_DASH_GT] = ACTIONS(5191),
    [anon_sym_with] = ACTIONS(5191),
    [aux_sym_preproc_if_token3] = ACTIONS(5191),
    [aux_sym_preproc_else_token1] = ACTIONS(5191),
    [aux_sym_preproc_elif_token1] = ACTIONS(5191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3292] = {
    [sym_preproc_region] = STATE(3292),
    [sym_preproc_endregion] = STATE(3292),
    [sym_preproc_line] = STATE(3292),
    [sym_preproc_pragma] = STATE(3292),
    [sym_preproc_nullable] = STATE(3292),
    [sym_preproc_error] = STATE(3292),
    [sym_preproc_warning] = STATE(3292),
    [sym_preproc_define] = STATE(3292),
    [sym_preproc_undef] = STATE(3292),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_when] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_into] = ACTIONS(2983),
    [anon_sym_on] = ACTIONS(2983),
    [anon_sym_equals] = ACTIONS(2983),
    [anon_sym_by] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_is] = ACTIONS(2983),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [aux_sym_preproc_if_token3] = ACTIONS(2983),
    [aux_sym_preproc_else_token1] = ACTIONS(2983),
    [aux_sym_preproc_elif_token1] = ACTIONS(2983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3293] = {
    [sym_preproc_region] = STATE(3293),
    [sym_preproc_endregion] = STATE(3293),
    [sym_preproc_line] = STATE(3293),
    [sym_preproc_pragma] = STATE(3293),
    [sym_preproc_nullable] = STATE(3293),
    [sym_preproc_error] = STATE(3293),
    [sym_preproc_warning] = STATE(3293),
    [sym_preproc_define] = STATE(3293),
    [sym_preproc_undef] = STATE(3293),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5421),
    [anon_sym_COLON] = ACTIONS(5421),
    [anon_sym_COMMA] = ACTIONS(5421),
    [anon_sym_RBRACK] = ACTIONS(5421),
    [anon_sym_LPAREN] = ACTIONS(5421),
    [anon_sym_RPAREN] = ACTIONS(5421),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_LT] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5423),
    [anon_sym_in] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5423),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_SLASH] = ACTIONS(5423),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_CARET] = ACTIONS(5421),
    [anon_sym_PIPE] = ACTIONS(5423),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_LT_LT] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5423),
    [anon_sym_GT_GT_GT] = ACTIONS(5421),
    [anon_sym_EQ_EQ] = ACTIONS(5421),
    [anon_sym_BANG_EQ] = ACTIONS(5421),
    [anon_sym_GT_EQ] = ACTIONS(5421),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_DOT] = ACTIONS(5423),
    [anon_sym_EQ_GT] = ACTIONS(5421),
    [anon_sym_switch] = ACTIONS(5421),
    [anon_sym_when] = ACTIONS(5421),
    [anon_sym_DOT_DOT] = ACTIONS(5421),
    [anon_sym_and] = ACTIONS(5421),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5421),
    [anon_sym_QMARK_QMARK] = ACTIONS(5421),
    [anon_sym_into] = ACTIONS(5421),
    [anon_sym_on] = ACTIONS(5421),
    [anon_sym_equals] = ACTIONS(5421),
    [anon_sym_by] = ACTIONS(5421),
    [anon_sym_as] = ACTIONS(5421),
    [anon_sym_is] = ACTIONS(5421),
    [anon_sym_DASH_GT] = ACTIONS(5421),
    [anon_sym_with] = ACTIONS(5421),
    [aux_sym_preproc_if_token3] = ACTIONS(5421),
    [aux_sym_preproc_else_token1] = ACTIONS(5421),
    [aux_sym_preproc_elif_token1] = ACTIONS(5421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3294] = {
    [sym_preproc_region] = STATE(3294),
    [sym_preproc_endregion] = STATE(3294),
    [sym_preproc_line] = STATE(3294),
    [sym_preproc_pragma] = STATE(3294),
    [sym_preproc_nullable] = STATE(3294),
    [sym_preproc_error] = STATE(3294),
    [sym_preproc_warning] = STATE(3294),
    [sym_preproc_define] = STATE(3294),
    [sym_preproc_undef] = STATE(3294),
    [anon_sym_SEMI] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_COMMA] = ACTIONS(5125),
    [anon_sym_RBRACK] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_RPAREN] = ACTIONS(5125),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5127),
    [anon_sym_in] = ACTIONS(5127),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_BANG] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5127),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_PIPE] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_GT_GT_GT] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5125),
    [anon_sym_BANG_EQ] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5125),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5127),
    [anon_sym_EQ_GT] = ACTIONS(5125),
    [anon_sym_switch] = ACTIONS(5125),
    [anon_sym_when] = ACTIONS(5125),
    [anon_sym_DOT_DOT] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_QMARK_QMARK] = ACTIONS(5125),
    [anon_sym_into] = ACTIONS(5125),
    [anon_sym_on] = ACTIONS(5125),
    [anon_sym_equals] = ACTIONS(5125),
    [anon_sym_by] = ACTIONS(5125),
    [anon_sym_as] = ACTIONS(5125),
    [anon_sym_is] = ACTIONS(5125),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [anon_sym_with] = ACTIONS(5125),
    [aux_sym_preproc_if_token3] = ACTIONS(5125),
    [aux_sym_preproc_else_token1] = ACTIONS(5125),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3295] = {
    [sym_preproc_region] = STATE(3295),
    [sym_preproc_endregion] = STATE(3295),
    [sym_preproc_line] = STATE(3295),
    [sym_preproc_pragma] = STATE(3295),
    [sym_preproc_nullable] = STATE(3295),
    [sym_preproc_error] = STATE(3295),
    [sym_preproc_warning] = STATE(3295),
    [sym_preproc_define] = STATE(3295),
    [sym_preproc_undef] = STATE(3295),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_COLON] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(5427),
    [anon_sym_GT] = ACTIONS(5427),
    [anon_sym_in] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(5427),
    [anon_sym_DASH] = ACTIONS(5427),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(5427),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(5427),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_GT_GT] = ACTIONS(5427),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_DOT] = ACTIONS(5427),
    [anon_sym_EQ_GT] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(5425),
    [anon_sym_when] = ACTIONS(5425),
    [anon_sym_DOT_DOT] = ACTIONS(5425),
    [anon_sym_and] = ACTIONS(5425),
    [anon_sym_or] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_QMARK_QMARK] = ACTIONS(5425),
    [anon_sym_into] = ACTIONS(5425),
    [anon_sym_on] = ACTIONS(5425),
    [anon_sym_equals] = ACTIONS(5425),
    [anon_sym_by] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_is] = ACTIONS(5425),
    [anon_sym_DASH_GT] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(5425),
    [aux_sym_preproc_if_token3] = ACTIONS(5425),
    [aux_sym_preproc_else_token1] = ACTIONS(5425),
    [aux_sym_preproc_elif_token1] = ACTIONS(5425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3296] = {
    [sym_preproc_region] = STATE(3296),
    [sym_preproc_endregion] = STATE(3296),
    [sym_preproc_line] = STATE(3296),
    [sym_preproc_pragma] = STATE(3296),
    [sym_preproc_nullable] = STATE(3296),
    [sym_preproc_error] = STATE(3296),
    [sym_preproc_warning] = STATE(3296),
    [sym_preproc_define] = STATE(3296),
    [sym_preproc_undef] = STATE(3296),
    [anon_sym_SEMI] = ACTIONS(5093),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_COLON] = ACTIONS(5093),
    [anon_sym_COMMA] = ACTIONS(5093),
    [anon_sym_RBRACK] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_RPAREN] = ACTIONS(5093),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_in] = ACTIONS(5095),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_BANG] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5095),
    [anon_sym_PERCENT] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5093),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5093),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_GT_GT_GT] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_DOT] = ACTIONS(5095),
    [anon_sym_EQ_GT] = ACTIONS(5093),
    [anon_sym_switch] = ACTIONS(5093),
    [anon_sym_when] = ACTIONS(5093),
    [anon_sym_DOT_DOT] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_or] = ACTIONS(5093),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_PIPE_PIPE] = ACTIONS(5093),
    [anon_sym_QMARK_QMARK] = ACTIONS(5093),
    [anon_sym_into] = ACTIONS(5093),
    [anon_sym_on] = ACTIONS(5093),
    [anon_sym_equals] = ACTIONS(5093),
    [anon_sym_by] = ACTIONS(5093),
    [anon_sym_as] = ACTIONS(5093),
    [anon_sym_is] = ACTIONS(5093),
    [anon_sym_DASH_GT] = ACTIONS(5093),
    [anon_sym_with] = ACTIONS(5093),
    [aux_sym_preproc_if_token3] = ACTIONS(5093),
    [aux_sym_preproc_else_token1] = ACTIONS(5093),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3297] = {
    [sym_preproc_region] = STATE(3297),
    [sym_preproc_endregion] = STATE(3297),
    [sym_preproc_line] = STATE(3297),
    [sym_preproc_pragma] = STATE(3297),
    [sym_preproc_nullable] = STATE(3297),
    [sym_preproc_error] = STATE(3297),
    [sym_preproc_warning] = STATE(3297),
    [sym_preproc_define] = STATE(3297),
    [sym_preproc_undef] = STATE(3297),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym_LBRACK] = ACTIONS(5429),
    [anon_sym_COLON] = ACTIONS(5429),
    [anon_sym_COMMA] = ACTIONS(5429),
    [anon_sym_RBRACK] = ACTIONS(5429),
    [anon_sym_LPAREN] = ACTIONS(5429),
    [anon_sym_RPAREN] = ACTIONS(5429),
    [anon_sym_RBRACE] = ACTIONS(5429),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_in] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5431),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS_PLUS] = ACTIONS(5429),
    [anon_sym_DASH_DASH] = ACTIONS(5429),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_CARET] = ACTIONS(5429),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5429),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_GT_GT_GT] = ACTIONS(5429),
    [anon_sym_EQ_EQ] = ACTIONS(5429),
    [anon_sym_BANG_EQ] = ACTIONS(5429),
    [anon_sym_GT_EQ] = ACTIONS(5429),
    [anon_sym_LT_EQ] = ACTIONS(5429),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_EQ_GT] = ACTIONS(5429),
    [anon_sym_switch] = ACTIONS(5429),
    [anon_sym_when] = ACTIONS(5429),
    [anon_sym_DOT_DOT] = ACTIONS(5429),
    [anon_sym_and] = ACTIONS(5429),
    [anon_sym_or] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_PIPE_PIPE] = ACTIONS(5429),
    [anon_sym_QMARK_QMARK] = ACTIONS(5429),
    [anon_sym_into] = ACTIONS(5429),
    [anon_sym_on] = ACTIONS(5429),
    [anon_sym_equals] = ACTIONS(5429),
    [anon_sym_by] = ACTIONS(5429),
    [anon_sym_as] = ACTIONS(5429),
    [anon_sym_is] = ACTIONS(5429),
    [anon_sym_DASH_GT] = ACTIONS(5429),
    [anon_sym_with] = ACTIONS(5429),
    [aux_sym_preproc_if_token3] = ACTIONS(5429),
    [aux_sym_preproc_else_token1] = ACTIONS(5429),
    [aux_sym_preproc_elif_token1] = ACTIONS(5429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3298] = {
    [sym_preproc_region] = STATE(3298),
    [sym_preproc_endregion] = STATE(3298),
    [sym_preproc_line] = STATE(3298),
    [sym_preproc_pragma] = STATE(3298),
    [sym_preproc_nullable] = STATE(3298),
    [sym_preproc_error] = STATE(3298),
    [sym_preproc_warning] = STATE(3298),
    [sym_preproc_define] = STATE(3298),
    [sym_preproc_undef] = STATE(3298),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_LPAREN] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_LT] = ACTIONS(5435),
    [anon_sym_GT] = ACTIONS(5435),
    [anon_sym_in] = ACTIONS(5435),
    [anon_sym_QMARK] = ACTIONS(5435),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(5435),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5435),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5435),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5435),
    [anon_sym_GT_GT_GT] = ACTIONS(5433),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5435),
    [anon_sym_EQ_GT] = ACTIONS(5433),
    [anon_sym_switch] = ACTIONS(5433),
    [anon_sym_when] = ACTIONS(5433),
    [anon_sym_DOT_DOT] = ACTIONS(5433),
    [anon_sym_and] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_QMARK_QMARK] = ACTIONS(5433),
    [anon_sym_into] = ACTIONS(5433),
    [anon_sym_on] = ACTIONS(5433),
    [anon_sym_equals] = ACTIONS(5433),
    [anon_sym_by] = ACTIONS(5433),
    [anon_sym_as] = ACTIONS(5433),
    [anon_sym_is] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [anon_sym_with] = ACTIONS(5433),
    [aux_sym_preproc_if_token3] = ACTIONS(5433),
    [aux_sym_preproc_else_token1] = ACTIONS(5433),
    [aux_sym_preproc_elif_token1] = ACTIONS(5433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3299] = {
    [sym_preproc_region] = STATE(3299),
    [sym_preproc_endregion] = STATE(3299),
    [sym_preproc_line] = STATE(3299),
    [sym_preproc_pragma] = STATE(3299),
    [sym_preproc_nullable] = STATE(3299),
    [sym_preproc_error] = STATE(3299),
    [sym_preproc_warning] = STATE(3299),
    [sym_preproc_define] = STATE(3299),
    [sym_preproc_undef] = STATE(3299),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RBRACK] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_EQ_GT] = ACTIONS(4967),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_when] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4967),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [anon_sym_DQUOTE] = ACTIONS(4967),
    [aux_sym_preproc_if_token3] = ACTIONS(4967),
    [aux_sym_preproc_else_token1] = ACTIONS(4967),
    [aux_sym_preproc_elif_token1] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3300] = {
    [sym_preproc_region] = STATE(3300),
    [sym_preproc_endregion] = STATE(3300),
    [sym_preproc_line] = STATE(3300),
    [sym_preproc_pragma] = STATE(3300),
    [sym_preproc_nullable] = STATE(3300),
    [sym_preproc_error] = STATE(3300),
    [sym_preproc_warning] = STATE(3300),
    [sym_preproc_define] = STATE(3300),
    [sym_preproc_undef] = STATE(3300),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym_LBRACK] = ACTIONS(5437),
    [anon_sym_COLON] = ACTIONS(5437),
    [anon_sym_COMMA] = ACTIONS(5437),
    [anon_sym_RBRACK] = ACTIONS(5437),
    [anon_sym_LPAREN] = ACTIONS(5437),
    [anon_sym_RPAREN] = ACTIONS(5437),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_in] = ACTIONS(5439),
    [anon_sym_QMARK] = ACTIONS(5439),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS_PLUS] = ACTIONS(5437),
    [anon_sym_DASH_DASH] = ACTIONS(5437),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5437),
    [anon_sym_CARET] = ACTIONS(5437),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5437),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_GT_GT_GT] = ACTIONS(5437),
    [anon_sym_EQ_EQ] = ACTIONS(5437),
    [anon_sym_BANG_EQ] = ACTIONS(5437),
    [anon_sym_GT_EQ] = ACTIONS(5437),
    [anon_sym_LT_EQ] = ACTIONS(5437),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_EQ_GT] = ACTIONS(5437),
    [anon_sym_switch] = ACTIONS(5437),
    [anon_sym_when] = ACTIONS(5437),
    [anon_sym_DOT_DOT] = ACTIONS(5437),
    [anon_sym_and] = ACTIONS(5437),
    [anon_sym_or] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_PIPE_PIPE] = ACTIONS(5437),
    [anon_sym_QMARK_QMARK] = ACTIONS(5437),
    [anon_sym_into] = ACTIONS(5437),
    [anon_sym_on] = ACTIONS(5437),
    [anon_sym_equals] = ACTIONS(5437),
    [anon_sym_by] = ACTIONS(5437),
    [anon_sym_as] = ACTIONS(5437),
    [anon_sym_is] = ACTIONS(5437),
    [anon_sym_DASH_GT] = ACTIONS(5437),
    [anon_sym_with] = ACTIONS(5437),
    [aux_sym_preproc_if_token3] = ACTIONS(5437),
    [aux_sym_preproc_else_token1] = ACTIONS(5437),
    [aux_sym_preproc_elif_token1] = ACTIONS(5437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3301] = {
    [sym_preproc_region] = STATE(3301),
    [sym_preproc_endregion] = STATE(3301),
    [sym_preproc_line] = STATE(3301),
    [sym_preproc_pragma] = STATE(3301),
    [sym_preproc_nullable] = STATE(3301),
    [sym_preproc_error] = STATE(3301),
    [sym_preproc_warning] = STATE(3301),
    [sym_preproc_define] = STATE(3301),
    [sym_preproc_undef] = STATE(3301),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [anon_sym_COLON] = ACTIONS(5441),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RBRACK] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(5441),
    [anon_sym_RPAREN] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_LT] = ACTIONS(5443),
    [anon_sym_GT] = ACTIONS(5443),
    [anon_sym_in] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5443),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS_PLUS] = ACTIONS(5441),
    [anon_sym_DASH_DASH] = ACTIONS(5441),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_SLASH] = ACTIONS(5443),
    [anon_sym_PERCENT] = ACTIONS(5441),
    [anon_sym_CARET] = ACTIONS(5441),
    [anon_sym_PIPE] = ACTIONS(5443),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym_LT_LT] = ACTIONS(5441),
    [anon_sym_GT_GT] = ACTIONS(5443),
    [anon_sym_GT_GT_GT] = ACTIONS(5441),
    [anon_sym_EQ_EQ] = ACTIONS(5441),
    [anon_sym_BANG_EQ] = ACTIONS(5441),
    [anon_sym_GT_EQ] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5441),
    [anon_sym_DOT] = ACTIONS(5443),
    [anon_sym_EQ_GT] = ACTIONS(5441),
    [anon_sym_switch] = ACTIONS(5441),
    [anon_sym_when] = ACTIONS(5441),
    [anon_sym_DOT_DOT] = ACTIONS(5441),
    [anon_sym_and] = ACTIONS(5441),
    [anon_sym_or] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_PIPE_PIPE] = ACTIONS(5441),
    [anon_sym_QMARK_QMARK] = ACTIONS(5441),
    [anon_sym_into] = ACTIONS(5441),
    [anon_sym_on] = ACTIONS(5441),
    [anon_sym_equals] = ACTIONS(5441),
    [anon_sym_by] = ACTIONS(5441),
    [anon_sym_as] = ACTIONS(5441),
    [anon_sym_is] = ACTIONS(5441),
    [anon_sym_DASH_GT] = ACTIONS(5441),
    [anon_sym_with] = ACTIONS(5441),
    [aux_sym_preproc_if_token3] = ACTIONS(5441),
    [aux_sym_preproc_else_token1] = ACTIONS(5441),
    [aux_sym_preproc_elif_token1] = ACTIONS(5441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3302] = {
    [sym_preproc_region] = STATE(3302),
    [sym_preproc_endregion] = STATE(3302),
    [sym_preproc_line] = STATE(3302),
    [sym_preproc_pragma] = STATE(3302),
    [sym_preproc_nullable] = STATE(3302),
    [sym_preproc_error] = STATE(3302),
    [sym_preproc_warning] = STATE(3302),
    [sym_preproc_define] = STATE(3302),
    [sym_preproc_undef] = STATE(3302),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACK] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_RPAREN] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5115),
    [anon_sym_in] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5115),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_PIPE] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_GT_GT_GT] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5113),
    [anon_sym_BANG_EQ] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5113),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_DOT] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5113),
    [anon_sym_switch] = ACTIONS(5113),
    [anon_sym_when] = ACTIONS(5113),
    [anon_sym_DOT_DOT] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5113),
    [anon_sym_QMARK_QMARK] = ACTIONS(5113),
    [anon_sym_into] = ACTIONS(5113),
    [anon_sym_on] = ACTIONS(5113),
    [anon_sym_equals] = ACTIONS(5113),
    [anon_sym_by] = ACTIONS(5113),
    [anon_sym_as] = ACTIONS(5113),
    [anon_sym_is] = ACTIONS(5113),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [anon_sym_with] = ACTIONS(5113),
    [aux_sym_preproc_if_token3] = ACTIONS(5113),
    [aux_sym_preproc_else_token1] = ACTIONS(5113),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3303] = {
    [sym_preproc_region] = STATE(3303),
    [sym_preproc_endregion] = STATE(3303),
    [sym_preproc_line] = STATE(3303),
    [sym_preproc_pragma] = STATE(3303),
    [sym_preproc_nullable] = STATE(3303),
    [sym_preproc_error] = STATE(3303),
    [sym_preproc_warning] = STATE(3303),
    [sym_preproc_define] = STATE(3303),
    [sym_preproc_undef] = STATE(3303),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [anon_sym_COLON] = ACTIONS(5445),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RBRACK] = ACTIONS(5445),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_in] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5447),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5445),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5445),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_GT_GT_GT] = ACTIONS(5445),
    [anon_sym_EQ_EQ] = ACTIONS(5445),
    [anon_sym_BANG_EQ] = ACTIONS(5445),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [anon_sym_LT_EQ] = ACTIONS(5445),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_EQ_GT] = ACTIONS(5445),
    [anon_sym_switch] = ACTIONS(5445),
    [anon_sym_when] = ACTIONS(5445),
    [anon_sym_DOT_DOT] = ACTIONS(5445),
    [anon_sym_and] = ACTIONS(5445),
    [anon_sym_or] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_QMARK_QMARK] = ACTIONS(5445),
    [anon_sym_into] = ACTIONS(5445),
    [anon_sym_on] = ACTIONS(5445),
    [anon_sym_equals] = ACTIONS(5445),
    [anon_sym_by] = ACTIONS(5445),
    [anon_sym_as] = ACTIONS(5445),
    [anon_sym_is] = ACTIONS(5445),
    [anon_sym_DASH_GT] = ACTIONS(5445),
    [anon_sym_with] = ACTIONS(5445),
    [aux_sym_preproc_if_token3] = ACTIONS(5445),
    [aux_sym_preproc_else_token1] = ACTIONS(5445),
    [aux_sym_preproc_elif_token1] = ACTIONS(5445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3304] = {
    [sym_preproc_region] = STATE(3304),
    [sym_preproc_endregion] = STATE(3304),
    [sym_preproc_line] = STATE(3304),
    [sym_preproc_pragma] = STATE(3304),
    [sym_preproc_nullable] = STATE(3304),
    [sym_preproc_error] = STATE(3304),
    [sym_preproc_warning] = STATE(3304),
    [sym_preproc_define] = STATE(3304),
    [sym_preproc_undef] = STATE(3304),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_in] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4020),
    [anon_sym_when] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_and] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4020),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_QMARK_QMARK] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4020),
    [anon_sym_is] = ACTIONS(4020),
    [anon_sym_DASH_GT] = ACTIONS(4020),
    [anon_sym_with] = ACTIONS(4020),
    [aux_sym_preproc_if_token3] = ACTIONS(4020),
    [aux_sym_preproc_else_token1] = ACTIONS(4020),
    [aux_sym_preproc_elif_token1] = ACTIONS(4020),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3305] = {
    [sym_preproc_region] = STATE(3305),
    [sym_preproc_endregion] = STATE(3305),
    [sym_preproc_line] = STATE(3305),
    [sym_preproc_pragma] = STATE(3305),
    [sym_preproc_nullable] = STATE(3305),
    [sym_preproc_error] = STATE(3305),
    [sym_preproc_warning] = STATE(3305),
    [sym_preproc_define] = STATE(3305),
    [sym_preproc_undef] = STATE(3305),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_COLON] = ACTIONS(4943),
    [anon_sym_COMMA] = ACTIONS(4943),
    [anon_sym_RBRACK] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_LT] = ACTIONS(4945),
    [anon_sym_GT] = ACTIONS(4945),
    [anon_sym_in] = ACTIONS(4943),
    [anon_sym_QMARK] = ACTIONS(4945),
    [anon_sym_BANG] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_SLASH] = ACTIONS(4945),
    [anon_sym_PERCENT] = ACTIONS(4943),
    [anon_sym_CARET] = ACTIONS(4943),
    [anon_sym_PIPE] = ACTIONS(4945),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_LT_LT] = ACTIONS(4943),
    [anon_sym_GT_GT] = ACTIONS(4945),
    [anon_sym_GT_GT_GT] = ACTIONS(4943),
    [anon_sym_EQ_EQ] = ACTIONS(4943),
    [anon_sym_BANG_EQ] = ACTIONS(4943),
    [anon_sym_GT_EQ] = ACTIONS(4943),
    [anon_sym_LT_EQ] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4945),
    [anon_sym_EQ_GT] = ACTIONS(4943),
    [anon_sym_switch] = ACTIONS(4943),
    [anon_sym_when] = ACTIONS(4943),
    [anon_sym_DOT_DOT] = ACTIONS(4943),
    [anon_sym_and] = ACTIONS(4943),
    [anon_sym_or] = ACTIONS(4943),
    [anon_sym_AMP_AMP] = ACTIONS(4943),
    [anon_sym_PIPE_PIPE] = ACTIONS(4943),
    [anon_sym_QMARK_QMARK] = ACTIONS(4943),
    [anon_sym_on] = ACTIONS(4943),
    [anon_sym_equals] = ACTIONS(4943),
    [anon_sym_by] = ACTIONS(4943),
    [anon_sym_as] = ACTIONS(4943),
    [anon_sym_is] = ACTIONS(4943),
    [anon_sym_DASH_GT] = ACTIONS(4943),
    [anon_sym_with] = ACTIONS(4943),
    [aux_sym_raw_string_literal_token1] = ACTIONS(5449),
    [aux_sym_preproc_if_token3] = ACTIONS(4943),
    [aux_sym_preproc_else_token1] = ACTIONS(4943),
    [aux_sym_preproc_elif_token1] = ACTIONS(4943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3306] = {
    [sym_preproc_region] = STATE(3306),
    [sym_preproc_endregion] = STATE(3306),
    [sym_preproc_line] = STATE(3306),
    [sym_preproc_pragma] = STATE(3306),
    [sym_preproc_nullable] = STATE(3306),
    [sym_preproc_error] = STATE(3306),
    [sym_preproc_warning] = STATE(3306),
    [sym_preproc_define] = STATE(3306),
    [sym_preproc_undef] = STATE(3306),
    [anon_sym_SEMI] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_in] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4052),
    [anon_sym_BANG] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_GT_GT_GT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4052),
    [anon_sym_EQ_GT] = ACTIONS(4054),
    [anon_sym_switch] = ACTIONS(4054),
    [anon_sym_when] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_QMARK_QMARK] = ACTIONS(4054),
    [anon_sym_on] = ACTIONS(4054),
    [anon_sym_equals] = ACTIONS(4054),
    [anon_sym_by] = ACTIONS(4054),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_is] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [aux_sym_preproc_if_token3] = ACTIONS(4054),
    [aux_sym_preproc_else_token1] = ACTIONS(4054),
    [aux_sym_preproc_elif_token1] = ACTIONS(4054),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3307] = {
    [sym_preproc_region] = STATE(3307),
    [sym_preproc_endregion] = STATE(3307),
    [sym_preproc_line] = STATE(3307),
    [sym_preproc_pragma] = STATE(3307),
    [sym_preproc_nullable] = STATE(3307),
    [sym_preproc_error] = STATE(3307),
    [sym_preproc_warning] = STATE(3307),
    [sym_preproc_define] = STATE(3307),
    [sym_preproc_undef] = STATE(3307),
    [anon_sym_SEMI] = ACTIONS(5451),
    [anon_sym_LBRACK] = ACTIONS(5451),
    [anon_sym_COLON] = ACTIONS(5451),
    [anon_sym_COMMA] = ACTIONS(5451),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_LPAREN] = ACTIONS(5451),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_LT] = ACTIONS(5453),
    [anon_sym_GT] = ACTIONS(5453),
    [anon_sym_in] = ACTIONS(5453),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_BANG] = ACTIONS(5453),
    [anon_sym_PLUS_PLUS] = ACTIONS(5451),
    [anon_sym_DASH_DASH] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5453),
    [anon_sym_DASH] = ACTIONS(5453),
    [anon_sym_STAR] = ACTIONS(5451),
    [anon_sym_SLASH] = ACTIONS(5453),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_CARET] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5453),
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_LT_LT] = ACTIONS(5451),
    [anon_sym_GT_GT] = ACTIONS(5453),
    [anon_sym_GT_GT_GT] = ACTIONS(5451),
    [anon_sym_EQ_EQ] = ACTIONS(5451),
    [anon_sym_BANG_EQ] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5451),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_DOT] = ACTIONS(5453),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_switch] = ACTIONS(5451),
    [anon_sym_when] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_and] = ACTIONS(5451),
    [anon_sym_or] = ACTIONS(5451),
    [anon_sym_AMP_AMP] = ACTIONS(5451),
    [anon_sym_PIPE_PIPE] = ACTIONS(5451),
    [anon_sym_QMARK_QMARK] = ACTIONS(5451),
    [anon_sym_into] = ACTIONS(5451),
    [anon_sym_on] = ACTIONS(5451),
    [anon_sym_equals] = ACTIONS(5451),
    [anon_sym_by] = ACTIONS(5451),
    [anon_sym_as] = ACTIONS(5451),
    [anon_sym_is] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_with] = ACTIONS(5451),
    [aux_sym_preproc_if_token3] = ACTIONS(5451),
    [aux_sym_preproc_else_token1] = ACTIONS(5451),
    [aux_sym_preproc_elif_token1] = ACTIONS(5451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3308] = {
    [sym_preproc_region] = STATE(3308),
    [sym_preproc_endregion] = STATE(3308),
    [sym_preproc_line] = STATE(3308),
    [sym_preproc_pragma] = STATE(3308),
    [sym_preproc_nullable] = STATE(3308),
    [sym_preproc_error] = STATE(3308),
    [sym_preproc_warning] = STATE(3308),
    [sym_preproc_define] = STATE(3308),
    [sym_preproc_undef] = STATE(3308),
    [anon_sym_SEMI] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_COMMA] = ACTIONS(5117),
    [anon_sym_RBRACK] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_RPAREN] = ACTIONS(5117),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5119),
    [anon_sym_in] = ACTIONS(5119),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_BANG] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_PIPE] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_GT_GT_GT] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5117),
    [anon_sym_BANG_EQ] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5117),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_DOT] = ACTIONS(5119),
    [anon_sym_EQ_GT] = ACTIONS(5117),
    [anon_sym_switch] = ACTIONS(5117),
    [anon_sym_when] = ACTIONS(5117),
    [anon_sym_DOT_DOT] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5117),
    [anon_sym_QMARK_QMARK] = ACTIONS(5117),
    [anon_sym_into] = ACTIONS(5117),
    [anon_sym_on] = ACTIONS(5117),
    [anon_sym_equals] = ACTIONS(5117),
    [anon_sym_by] = ACTIONS(5117),
    [anon_sym_as] = ACTIONS(5117),
    [anon_sym_is] = ACTIONS(5117),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [anon_sym_with] = ACTIONS(5117),
    [aux_sym_preproc_if_token3] = ACTIONS(5117),
    [aux_sym_preproc_else_token1] = ACTIONS(5117),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3309] = {
    [sym_preproc_region] = STATE(3309),
    [sym_preproc_endregion] = STATE(3309),
    [sym_preproc_line] = STATE(3309),
    [sym_preproc_pragma] = STATE(3309),
    [sym_preproc_nullable] = STATE(3309),
    [sym_preproc_error] = STATE(3309),
    [sym_preproc_warning] = STATE(3309),
    [sym_preproc_define] = STATE(3309),
    [sym_preproc_undef] = STATE(3309),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(5455),
    [anon_sym_GT] = ACTIONS(5455),
    [anon_sym_in] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5455),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(5455),
    [anon_sym_AMP] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(5455),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(5455),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_when] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_QMARK_QMARK] = ACTIONS(3881),
    [anon_sym_into] = ACTIONS(3881),
    [anon_sym_on] = ACTIONS(3881),
    [anon_sym_equals] = ACTIONS(3881),
    [anon_sym_by] = ACTIONS(3881),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_is] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [aux_sym_preproc_if_token3] = ACTIONS(3881),
    [aux_sym_preproc_else_token1] = ACTIONS(3881),
    [aux_sym_preproc_elif_token1] = ACTIONS(3881),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3310] = {
    [sym_preproc_region] = STATE(3310),
    [sym_preproc_endregion] = STATE(3310),
    [sym_preproc_line] = STATE(3310),
    [sym_preproc_pragma] = STATE(3310),
    [sym_preproc_nullable] = STATE(3310),
    [sym_preproc_error] = STATE(3310),
    [sym_preproc_warning] = STATE(3310),
    [sym_preproc_define] = STATE(3310),
    [sym_preproc_undef] = STATE(3310),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(5457),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3311] = {
    [sym_preproc_region] = STATE(3311),
    [sym_preproc_endregion] = STATE(3311),
    [sym_preproc_line] = STATE(3311),
    [sym_preproc_pragma] = STATE(3311),
    [sym_preproc_nullable] = STATE(3311),
    [sym_preproc_error] = STATE(3311),
    [sym_preproc_warning] = STATE(3311),
    [sym_preproc_define] = STATE(3311),
    [sym_preproc_undef] = STATE(3311),
    [anon_sym_SEMI] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5121),
    [anon_sym_RBRACK] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_RPAREN] = ACTIONS(5121),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5123),
    [anon_sym_in] = ACTIONS(5123),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5123),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5123),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_PIPE] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_GT_GT_GT] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5121),
    [anon_sym_BANG_EQ] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5121),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_DOT] = ACTIONS(5123),
    [anon_sym_EQ_GT] = ACTIONS(5121),
    [anon_sym_switch] = ACTIONS(5121),
    [anon_sym_when] = ACTIONS(5121),
    [anon_sym_DOT_DOT] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5121),
    [anon_sym_QMARK_QMARK] = ACTIONS(5121),
    [anon_sym_into] = ACTIONS(5121),
    [anon_sym_on] = ACTIONS(5121),
    [anon_sym_equals] = ACTIONS(5121),
    [anon_sym_by] = ACTIONS(5121),
    [anon_sym_as] = ACTIONS(5121),
    [anon_sym_is] = ACTIONS(5121),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [anon_sym_with] = ACTIONS(5121),
    [aux_sym_preproc_if_token3] = ACTIONS(5121),
    [aux_sym_preproc_else_token1] = ACTIONS(5121),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3312] = {
    [sym_preproc_region] = STATE(3312),
    [sym_preproc_endregion] = STATE(3312),
    [sym_preproc_line] = STATE(3312),
    [sym_preproc_pragma] = STATE(3312),
    [sym_preproc_nullable] = STATE(3312),
    [sym_preproc_error] = STATE(3312),
    [sym_preproc_warning] = STATE(3312),
    [sym_preproc_define] = STATE(3312),
    [sym_preproc_undef] = STATE(3312),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5459),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3313] = {
    [sym_preproc_region] = STATE(3313),
    [sym_preproc_endregion] = STATE(3313),
    [sym_preproc_line] = STATE(3313),
    [sym_preproc_pragma] = STATE(3313),
    [sym_preproc_nullable] = STATE(3313),
    [sym_preproc_error] = STATE(3313),
    [sym_preproc_warning] = STATE(3313),
    [sym_preproc_define] = STATE(3313),
    [sym_preproc_undef] = STATE(3313),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5461),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3314] = {
    [sym_preproc_region] = STATE(3314),
    [sym_preproc_endregion] = STATE(3314),
    [sym_preproc_line] = STATE(3314),
    [sym_preproc_pragma] = STATE(3314),
    [sym_preproc_nullable] = STATE(3314),
    [sym_preproc_error] = STATE(3314),
    [sym_preproc_warning] = STATE(3314),
    [sym_preproc_define] = STATE(3314),
    [sym_preproc_undef] = STATE(3314),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3315] = {
    [sym_preproc_region] = STATE(3315),
    [sym_preproc_endregion] = STATE(3315),
    [sym_preproc_line] = STATE(3315),
    [sym_preproc_pragma] = STATE(3315),
    [sym_preproc_nullable] = STATE(3315),
    [sym_preproc_error] = STATE(3315),
    [sym_preproc_warning] = STATE(3315),
    [sym_preproc_define] = STATE(3315),
    [sym_preproc_undef] = STATE(3315),
    [anon_sym_SEMI] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_RBRACK] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_in] = ACTIONS(4293),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_EQ_GT] = ACTIONS(4291),
    [anon_sym_switch] = ACTIONS(4291),
    [anon_sym_when] = ACTIONS(4291),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4291),
    [anon_sym_or] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_into] = ACTIONS(4291),
    [anon_sym_on] = ACTIONS(4291),
    [anon_sym_equals] = ACTIONS(4291),
    [anon_sym_by] = ACTIONS(4291),
    [anon_sym_as] = ACTIONS(4291),
    [anon_sym_is] = ACTIONS(4291),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4291),
    [aux_sym_preproc_if_token3] = ACTIONS(4291),
    [aux_sym_preproc_else_token1] = ACTIONS(4291),
    [aux_sym_preproc_elif_token1] = ACTIONS(4291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3316] = {
    [sym_preproc_region] = STATE(3316),
    [sym_preproc_endregion] = STATE(3316),
    [sym_preproc_line] = STATE(3316),
    [sym_preproc_pragma] = STATE(3316),
    [sym_preproc_nullable] = STATE(3316),
    [sym_preproc_error] = STATE(3316),
    [sym_preproc_warning] = STATE(3316),
    [sym_preproc_define] = STATE(3316),
    [sym_preproc_undef] = STATE(3316),
    [anon_sym_SEMI] = ACTIONS(5145),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5145),
    [anon_sym_COMMA] = ACTIONS(5145),
    [anon_sym_RBRACK] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5145),
    [anon_sym_RBRACE] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5147),
    [anon_sym_in] = ACTIONS(5147),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_BANG] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5145),
    [anon_sym_PIPE] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5147),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5147),
    [anon_sym_GT_GT_GT] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5145),
    [anon_sym_BANG_EQ] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5145),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_DOT] = ACTIONS(5147),
    [anon_sym_EQ_GT] = ACTIONS(5145),
    [anon_sym_switch] = ACTIONS(5145),
    [anon_sym_when] = ACTIONS(5145),
    [anon_sym_DOT_DOT] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_or] = ACTIONS(5145),
    [anon_sym_AMP_AMP] = ACTIONS(5145),
    [anon_sym_PIPE_PIPE] = ACTIONS(5145),
    [anon_sym_QMARK_QMARK] = ACTIONS(5145),
    [anon_sym_into] = ACTIONS(5145),
    [anon_sym_on] = ACTIONS(5145),
    [anon_sym_equals] = ACTIONS(5145),
    [anon_sym_by] = ACTIONS(5145),
    [anon_sym_as] = ACTIONS(5145),
    [anon_sym_is] = ACTIONS(5145),
    [anon_sym_DASH_GT] = ACTIONS(5145),
    [anon_sym_with] = ACTIONS(5145),
    [aux_sym_preproc_if_token3] = ACTIONS(5145),
    [aux_sym_preproc_else_token1] = ACTIONS(5145),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3317] = {
    [sym_preproc_region] = STATE(3317),
    [sym_preproc_endregion] = STATE(3317),
    [sym_preproc_line] = STATE(3317),
    [sym_preproc_pragma] = STATE(3317),
    [sym_preproc_nullable] = STATE(3317),
    [sym_preproc_error] = STATE(3317),
    [sym_preproc_warning] = STATE(3317),
    [sym_preproc_define] = STATE(3317),
    [sym_preproc_undef] = STATE(3317),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5234),
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_RBRACK] = ACTIONS(5234),
    [anon_sym_LPAREN] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5234),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_GT_GT_GT] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5234),
    [anon_sym_BANG_EQ] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5234),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_GT] = ACTIONS(5234),
    [anon_sym_switch] = ACTIONS(5234),
    [anon_sym_when] = ACTIONS(5234),
    [anon_sym_DOT_DOT] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_or] = ACTIONS(5234),
    [anon_sym_AMP_AMP] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5234),
    [anon_sym_QMARK_QMARK] = ACTIONS(5234),
    [anon_sym_into] = ACTIONS(5234),
    [anon_sym_on] = ACTIONS(5234),
    [anon_sym_equals] = ACTIONS(5234),
    [anon_sym_by] = ACTIONS(5234),
    [anon_sym_as] = ACTIONS(5234),
    [anon_sym_is] = ACTIONS(5234),
    [anon_sym_DASH_GT] = ACTIONS(5234),
    [anon_sym_with] = ACTIONS(5234),
    [aux_sym_preproc_if_token3] = ACTIONS(5234),
    [aux_sym_preproc_else_token1] = ACTIONS(5234),
    [aux_sym_preproc_elif_token1] = ACTIONS(5234),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3318] = {
    [sym_preproc_region] = STATE(3318),
    [sym_preproc_endregion] = STATE(3318),
    [sym_preproc_line] = STATE(3318),
    [sym_preproc_pragma] = STATE(3318),
    [sym_preproc_nullable] = STATE(3318),
    [sym_preproc_error] = STATE(3318),
    [sym_preproc_warning] = STATE(3318),
    [sym_preproc_define] = STATE(3318),
    [sym_preproc_undef] = STATE(3318),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5129),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_in] = ACTIONS(5131),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_BANG] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5131),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_GT_GT_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_BANG_EQ] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5129),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_DOT] = ACTIONS(5131),
    [anon_sym_EQ_GT] = ACTIONS(5129),
    [anon_sym_switch] = ACTIONS(5129),
    [anon_sym_when] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_or] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_QMARK_QMARK] = ACTIONS(5129),
    [anon_sym_into] = ACTIONS(5129),
    [anon_sym_on] = ACTIONS(5129),
    [anon_sym_equals] = ACTIONS(5129),
    [anon_sym_by] = ACTIONS(5129),
    [anon_sym_as] = ACTIONS(5129),
    [anon_sym_is] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_with] = ACTIONS(5129),
    [aux_sym_preproc_if_token3] = ACTIONS(5129),
    [aux_sym_preproc_else_token1] = ACTIONS(5129),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3319] = {
    [sym_preproc_region] = STATE(3319),
    [sym_preproc_endregion] = STATE(3319),
    [sym_preproc_line] = STATE(3319),
    [sym_preproc_pragma] = STATE(3319),
    [sym_preproc_nullable] = STATE(3319),
    [sym_preproc_error] = STATE(3319),
    [sym_preproc_warning] = STATE(3319),
    [sym_preproc_define] = STATE(3319),
    [sym_preproc_undef] = STATE(3319),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5242),
    [anon_sym_RBRACK] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5242),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5244),
    [anon_sym_in] = ACTIONS(5244),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_PIPE] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5244),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5244),
    [anon_sym_GT_GT_GT] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_DOT] = ACTIONS(5244),
    [anon_sym_EQ_GT] = ACTIONS(5242),
    [anon_sym_switch] = ACTIONS(5242),
    [anon_sym_when] = ACTIONS(5242),
    [anon_sym_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_or] = ACTIONS(5242),
    [anon_sym_AMP_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5242),
    [anon_sym_QMARK_QMARK] = ACTIONS(5242),
    [anon_sym_into] = ACTIONS(5242),
    [anon_sym_on] = ACTIONS(5242),
    [anon_sym_equals] = ACTIONS(5242),
    [anon_sym_by] = ACTIONS(5242),
    [anon_sym_as] = ACTIONS(5242),
    [anon_sym_is] = ACTIONS(5242),
    [anon_sym_DASH_GT] = ACTIONS(5242),
    [anon_sym_with] = ACTIONS(5242),
    [aux_sym_preproc_if_token3] = ACTIONS(5242),
    [aux_sym_preproc_else_token1] = ACTIONS(5242),
    [aux_sym_preproc_elif_token1] = ACTIONS(5242),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3320] = {
    [sym_preproc_region] = STATE(3320),
    [sym_preproc_endregion] = STATE(3320),
    [sym_preproc_line] = STATE(3320),
    [sym_preproc_pragma] = STATE(3320),
    [sym_preproc_nullable] = STATE(3320),
    [sym_preproc_error] = STATE(3320),
    [sym_preproc_warning] = STATE(3320),
    [sym_preproc_define] = STATE(3320),
    [sym_preproc_undef] = STATE(3320),
    [anon_sym_SEMI] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_COLON] = ACTIONS(5067),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_RBRACK] = ACTIONS(5067),
    [anon_sym_LPAREN] = ACTIONS(5067),
    [anon_sym_RPAREN] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5067),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_in] = ACTIONS(5069),
    [anon_sym_QMARK] = ACTIONS(5069),
    [anon_sym_BANG] = ACTIONS(5069),
    [anon_sym_PLUS_PLUS] = ACTIONS(5067),
    [anon_sym_DASH_DASH] = ACTIONS(5067),
    [anon_sym_PLUS] = ACTIONS(5069),
    [anon_sym_DASH] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5067),
    [anon_sym_SLASH] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5067),
    [anon_sym_CARET] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5067),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_GT_GT_GT] = ACTIONS(5067),
    [anon_sym_EQ_EQ] = ACTIONS(5067),
    [anon_sym_BANG_EQ] = ACTIONS(5067),
    [anon_sym_GT_EQ] = ACTIONS(5067),
    [anon_sym_LT_EQ] = ACTIONS(5067),
    [anon_sym_DOT] = ACTIONS(5069),
    [anon_sym_EQ_GT] = ACTIONS(5067),
    [anon_sym_switch] = ACTIONS(5067),
    [anon_sym_when] = ACTIONS(5067),
    [anon_sym_DOT_DOT] = ACTIONS(5067),
    [anon_sym_and] = ACTIONS(5067),
    [anon_sym_or] = ACTIONS(5067),
    [anon_sym_AMP_AMP] = ACTIONS(5067),
    [anon_sym_PIPE_PIPE] = ACTIONS(5067),
    [anon_sym_QMARK_QMARK] = ACTIONS(5067),
    [anon_sym_into] = ACTIONS(5067),
    [anon_sym_on] = ACTIONS(5067),
    [anon_sym_equals] = ACTIONS(5067),
    [anon_sym_by] = ACTIONS(5067),
    [anon_sym_as] = ACTIONS(5067),
    [anon_sym_is] = ACTIONS(5067),
    [anon_sym_DASH_GT] = ACTIONS(5067),
    [anon_sym_with] = ACTIONS(5067),
    [aux_sym_preproc_if_token3] = ACTIONS(5067),
    [aux_sym_preproc_else_token1] = ACTIONS(5067),
    [aux_sym_preproc_elif_token1] = ACTIONS(5067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3321] = {
    [sym_preproc_region] = STATE(3321),
    [sym_preproc_endregion] = STATE(3321),
    [sym_preproc_line] = STATE(3321),
    [sym_preproc_pragma] = STATE(3321),
    [sym_preproc_nullable] = STATE(3321),
    [sym_preproc_error] = STATE(3321),
    [sym_preproc_warning] = STATE(3321),
    [sym_preproc_define] = STATE(3321),
    [sym_preproc_undef] = STATE(3321),
    [anon_sym_SEMI] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_RBRACK] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_in] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5246),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_DOT] = ACTIONS(5248),
    [anon_sym_EQ_GT] = ACTIONS(5246),
    [anon_sym_switch] = ACTIONS(5246),
    [anon_sym_when] = ACTIONS(5246),
    [anon_sym_DOT_DOT] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_QMARK_QMARK] = ACTIONS(5246),
    [anon_sym_into] = ACTIONS(5246),
    [anon_sym_on] = ACTIONS(5246),
    [anon_sym_equals] = ACTIONS(5246),
    [anon_sym_by] = ACTIONS(5246),
    [anon_sym_as] = ACTIONS(5246),
    [anon_sym_is] = ACTIONS(5246),
    [anon_sym_DASH_GT] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5246),
    [aux_sym_preproc_if_token3] = ACTIONS(5246),
    [aux_sym_preproc_else_token1] = ACTIONS(5246),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3322] = {
    [sym_preproc_region] = STATE(3322),
    [sym_preproc_endregion] = STATE(3322),
    [sym_preproc_line] = STATE(3322),
    [sym_preproc_pragma] = STATE(3322),
    [sym_preproc_nullable] = STATE(3322),
    [sym_preproc_error] = STATE(3322),
    [sym_preproc_warning] = STATE(3322),
    [sym_preproc_define] = STATE(3322),
    [sym_preproc_undef] = STATE(3322),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACK] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [anon_sym_RPAREN] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_LT] = ACTIONS(4030),
    [anon_sym_GT] = ACTIONS(4030),
    [anon_sym_in] = ACTIONS(4032),
    [anon_sym_QMARK] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_STAR] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_CARET] = ACTIONS(4032),
    [anon_sym_PIPE] = ACTIONS(4030),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_GT_GT] = ACTIONS(4030),
    [anon_sym_GT_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_EQ] = ACTIONS(4032),
    [anon_sym_BANG_EQ] = ACTIONS(4032),
    [anon_sym_GT_EQ] = ACTIONS(4032),
    [anon_sym_LT_EQ] = ACTIONS(4032),
    [anon_sym_DOT] = ACTIONS(4030),
    [anon_sym_EQ_GT] = ACTIONS(4032),
    [anon_sym_switch] = ACTIONS(4032),
    [anon_sym_when] = ACTIONS(4032),
    [anon_sym_DOT_DOT] = ACTIONS(4032),
    [anon_sym_and] = ACTIONS(4032),
    [anon_sym_or] = ACTIONS(4032),
    [anon_sym_AMP_AMP] = ACTIONS(4032),
    [anon_sym_PIPE_PIPE] = ACTIONS(4032),
    [anon_sym_QMARK_QMARK] = ACTIONS(4032),
    [anon_sym_on] = ACTIONS(4032),
    [anon_sym_equals] = ACTIONS(4032),
    [anon_sym_by] = ACTIONS(4032),
    [anon_sym_as] = ACTIONS(4032),
    [anon_sym_is] = ACTIONS(4032),
    [anon_sym_DASH_GT] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4032),
    [aux_sym_preproc_if_token3] = ACTIONS(4032),
    [aux_sym_preproc_else_token1] = ACTIONS(4032),
    [aux_sym_preproc_elif_token1] = ACTIONS(4032),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3323] = {
    [sym_preproc_region] = STATE(3323),
    [sym_preproc_endregion] = STATE(3323),
    [sym_preproc_line] = STATE(3323),
    [sym_preproc_pragma] = STATE(3323),
    [sym_preproc_nullable] = STATE(3323),
    [sym_preproc_error] = STATE(3323),
    [sym_preproc_warning] = STATE(3323),
    [sym_preproc_define] = STATE(3323),
    [sym_preproc_undef] = STATE(3323),
    [anon_sym_SEMI] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_COLON] = ACTIONS(5047),
    [anon_sym_COMMA] = ACTIONS(5047),
    [anon_sym_RBRACK] = ACTIONS(5047),
    [anon_sym_LPAREN] = ACTIONS(5047),
    [anon_sym_RPAREN] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_in] = ACTIONS(5049),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_BANG] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5049),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_PIPE] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5049),
    [anon_sym_GT_GT_GT] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5047),
    [anon_sym_BANG_EQ] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_DOT] = ACTIONS(5049),
    [anon_sym_EQ_GT] = ACTIONS(5047),
    [anon_sym_switch] = ACTIONS(5047),
    [anon_sym_when] = ACTIONS(5047),
    [anon_sym_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_QMARK_QMARK] = ACTIONS(5047),
    [anon_sym_into] = ACTIONS(5047),
    [anon_sym_on] = ACTIONS(5047),
    [anon_sym_equals] = ACTIONS(5047),
    [anon_sym_by] = ACTIONS(5047),
    [anon_sym_as] = ACTIONS(5047),
    [anon_sym_is] = ACTIONS(5047),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [anon_sym_with] = ACTIONS(5047),
    [aux_sym_preproc_if_token3] = ACTIONS(5047),
    [aux_sym_preproc_else_token1] = ACTIONS(5047),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3324] = {
    [sym_preproc_region] = STATE(3324),
    [sym_preproc_endregion] = STATE(3324),
    [sym_preproc_line] = STATE(3324),
    [sym_preproc_pragma] = STATE(3324),
    [sym_preproc_nullable] = STATE(3324),
    [sym_preproc_error] = STATE(3324),
    [sym_preproc_warning] = STATE(3324),
    [sym_preproc_define] = STATE(3324),
    [sym_preproc_undef] = STATE(3324),
    [anon_sym_SEMI] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5135),
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_RBRACK] = ACTIONS(5135),
    [anon_sym_LPAREN] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_in] = ACTIONS(5137),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_BANG] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5137),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5137),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5137),
    [anon_sym_AMP] = ACTIONS(5137),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_GT_GT_GT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_DOT] = ACTIONS(5137),
    [anon_sym_EQ_GT] = ACTIONS(5135),
    [anon_sym_switch] = ACTIONS(5135),
    [anon_sym_when] = ACTIONS(5135),
    [anon_sym_DOT_DOT] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_or] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_QMARK_QMARK] = ACTIONS(5135),
    [anon_sym_into] = ACTIONS(5135),
    [anon_sym_on] = ACTIONS(5135),
    [anon_sym_equals] = ACTIONS(5135),
    [anon_sym_by] = ACTIONS(5135),
    [anon_sym_as] = ACTIONS(5135),
    [anon_sym_is] = ACTIONS(5135),
    [anon_sym_DASH_GT] = ACTIONS(5135),
    [anon_sym_with] = ACTIONS(5135),
    [aux_sym_preproc_if_token3] = ACTIONS(5135),
    [aux_sym_preproc_else_token1] = ACTIONS(5135),
    [aux_sym_preproc_elif_token1] = ACTIONS(5135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3325] = {
    [sym_preproc_region] = STATE(3325),
    [sym_preproc_endregion] = STATE(3325),
    [sym_preproc_line] = STATE(3325),
    [sym_preproc_pragma] = STATE(3325),
    [sym_preproc_nullable] = STATE(3325),
    [sym_preproc_error] = STATE(3325),
    [sym_preproc_warning] = STATE(3325),
    [sym_preproc_define] = STATE(3325),
    [sym_preproc_undef] = STATE(3325),
    [anon_sym_SEMI] = ACTIONS(5153),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_COMMA] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_RPAREN] = ACTIONS(5153),
    [anon_sym_RBRACE] = ACTIONS(5153),
    [anon_sym_LT] = ACTIONS(5155),
    [anon_sym_GT] = ACTIONS(5155),
    [anon_sym_in] = ACTIONS(5155),
    [anon_sym_QMARK] = ACTIONS(5155),
    [anon_sym_BANG] = ACTIONS(5155),
    [anon_sym_PLUS_PLUS] = ACTIONS(5153),
    [anon_sym_DASH_DASH] = ACTIONS(5153),
    [anon_sym_PLUS] = ACTIONS(5155),
    [anon_sym_DASH] = ACTIONS(5155),
    [anon_sym_STAR] = ACTIONS(5153),
    [anon_sym_SLASH] = ACTIONS(5155),
    [anon_sym_PERCENT] = ACTIONS(5153),
    [anon_sym_CARET] = ACTIONS(5153),
    [anon_sym_PIPE] = ACTIONS(5155),
    [anon_sym_AMP] = ACTIONS(5155),
    [anon_sym_LT_LT] = ACTIONS(5153),
    [anon_sym_GT_GT] = ACTIONS(5155),
    [anon_sym_GT_GT_GT] = ACTIONS(5153),
    [anon_sym_EQ_EQ] = ACTIONS(5153),
    [anon_sym_BANG_EQ] = ACTIONS(5153),
    [anon_sym_GT_EQ] = ACTIONS(5153),
    [anon_sym_LT_EQ] = ACTIONS(5153),
    [anon_sym_DOT] = ACTIONS(5155),
    [anon_sym_EQ_GT] = ACTIONS(5153),
    [anon_sym_switch] = ACTIONS(5153),
    [anon_sym_when] = ACTIONS(5153),
    [anon_sym_DOT_DOT] = ACTIONS(5153),
    [anon_sym_and] = ACTIONS(5153),
    [anon_sym_or] = ACTIONS(5153),
    [anon_sym_AMP_AMP] = ACTIONS(5153),
    [anon_sym_PIPE_PIPE] = ACTIONS(5153),
    [anon_sym_QMARK_QMARK] = ACTIONS(5153),
    [anon_sym_into] = ACTIONS(5153),
    [anon_sym_on] = ACTIONS(5153),
    [anon_sym_equals] = ACTIONS(5153),
    [anon_sym_by] = ACTIONS(5153),
    [anon_sym_as] = ACTIONS(5153),
    [anon_sym_is] = ACTIONS(5153),
    [anon_sym_DASH_GT] = ACTIONS(5153),
    [anon_sym_with] = ACTIONS(5153),
    [aux_sym_preproc_if_token3] = ACTIONS(5153),
    [aux_sym_preproc_else_token1] = ACTIONS(5153),
    [aux_sym_preproc_elif_token1] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3326] = {
    [sym_preproc_region] = STATE(3326),
    [sym_preproc_endregion] = STATE(3326),
    [sym_preproc_line] = STATE(3326),
    [sym_preproc_pragma] = STATE(3326),
    [sym_preproc_nullable] = STATE(3326),
    [sym_preproc_error] = STATE(3326),
    [sym_preproc_warning] = STATE(3326),
    [sym_preproc_define] = STATE(3326),
    [sym_preproc_undef] = STATE(3326),
    [anon_sym_SEMI] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5250),
    [anon_sym_COLON] = ACTIONS(5250),
    [anon_sym_COMMA] = ACTIONS(5250),
    [anon_sym_RBRACK] = ACTIONS(5250),
    [anon_sym_LPAREN] = ACTIONS(5250),
    [anon_sym_RPAREN] = ACTIONS(5250),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_in] = ACTIONS(5252),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_BANG] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5252),
    [anon_sym_STAR] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5250),
    [anon_sym_PIPE] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5252),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5252),
    [anon_sym_GT_GT_GT] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_DOT] = ACTIONS(5252),
    [anon_sym_EQ_GT] = ACTIONS(5250),
    [anon_sym_switch] = ACTIONS(5250),
    [anon_sym_when] = ACTIONS(5250),
    [anon_sym_DOT_DOT] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_or] = ACTIONS(5250),
    [anon_sym_AMP_AMP] = ACTIONS(5250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5250),
    [anon_sym_QMARK_QMARK] = ACTIONS(5250),
    [anon_sym_into] = ACTIONS(5250),
    [anon_sym_on] = ACTIONS(5250),
    [anon_sym_equals] = ACTIONS(5250),
    [anon_sym_by] = ACTIONS(5250),
    [anon_sym_as] = ACTIONS(5250),
    [anon_sym_is] = ACTIONS(5250),
    [anon_sym_DASH_GT] = ACTIONS(5250),
    [anon_sym_with] = ACTIONS(5250),
    [aux_sym_preproc_if_token3] = ACTIONS(5250),
    [aux_sym_preproc_else_token1] = ACTIONS(5250),
    [aux_sym_preproc_elif_token1] = ACTIONS(5250),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3327] = {
    [sym_preproc_region] = STATE(3327),
    [sym_preproc_endregion] = STATE(3327),
    [sym_preproc_line] = STATE(3327),
    [sym_preproc_pragma] = STATE(3327),
    [sym_preproc_nullable] = STATE(3327),
    [sym_preproc_error] = STATE(3327),
    [sym_preproc_warning] = STATE(3327),
    [sym_preproc_define] = STATE(3327),
    [sym_preproc_undef] = STATE(3327),
    [anon_sym_SEMI] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RBRACK] = ACTIONS(5139),
    [anon_sym_LPAREN] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_in] = ACTIONS(5141),
    [anon_sym_QMARK] = ACTIONS(5141),
    [anon_sym_BANG] = ACTIONS(5141),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5141),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5141),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5141),
    [anon_sym_AMP] = ACTIONS(5141),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5141),
    [anon_sym_GT_GT_GT] = ACTIONS(5139),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5141),
    [anon_sym_EQ_GT] = ACTIONS(5139),
    [anon_sym_switch] = ACTIONS(5139),
    [anon_sym_when] = ACTIONS(5139),
    [anon_sym_DOT_DOT] = ACTIONS(5139),
    [anon_sym_and] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_QMARK_QMARK] = ACTIONS(5139),
    [anon_sym_into] = ACTIONS(5139),
    [anon_sym_on] = ACTIONS(5139),
    [anon_sym_equals] = ACTIONS(5139),
    [anon_sym_by] = ACTIONS(5139),
    [anon_sym_as] = ACTIONS(5139),
    [anon_sym_is] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [anon_sym_with] = ACTIONS(5139),
    [aux_sym_preproc_if_token3] = ACTIONS(5139),
    [aux_sym_preproc_else_token1] = ACTIONS(5139),
    [aux_sym_preproc_elif_token1] = ACTIONS(5139),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3328] = {
    [sym_preproc_region] = STATE(3328),
    [sym_preproc_endregion] = STATE(3328),
    [sym_preproc_line] = STATE(3328),
    [sym_preproc_pragma] = STATE(3328),
    [sym_preproc_nullable] = STATE(3328),
    [sym_preproc_error] = STATE(3328),
    [sym_preproc_warning] = STATE(3328),
    [sym_preproc_define] = STATE(3328),
    [sym_preproc_undef] = STATE(3328),
    [anon_sym_SEMI] = ACTIONS(5254),
    [anon_sym_LBRACK] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(5254),
    [anon_sym_COMMA] = ACTIONS(5254),
    [anon_sym_RBRACK] = ACTIONS(5254),
    [anon_sym_LPAREN] = ACTIONS(5254),
    [anon_sym_RPAREN] = ACTIONS(5254),
    [anon_sym_RBRACE] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5256),
    [anon_sym_in] = ACTIONS(5256),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_BANG] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5256),
    [anon_sym_STAR] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(5256),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PIPE] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5256),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5256),
    [anon_sym_GT_GT_GT] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5254),
    [anon_sym_BANG_EQ] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5254),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_DOT] = ACTIONS(5256),
    [anon_sym_EQ_GT] = ACTIONS(5254),
    [anon_sym_switch] = ACTIONS(5254),
    [anon_sym_when] = ACTIONS(5254),
    [anon_sym_DOT_DOT] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_or] = ACTIONS(5254),
    [anon_sym_AMP_AMP] = ACTIONS(5254),
    [anon_sym_PIPE_PIPE] = ACTIONS(5254),
    [anon_sym_QMARK_QMARK] = ACTIONS(5254),
    [anon_sym_into] = ACTIONS(5254),
    [anon_sym_on] = ACTIONS(5254),
    [anon_sym_equals] = ACTIONS(5254),
    [anon_sym_by] = ACTIONS(5254),
    [anon_sym_as] = ACTIONS(5254),
    [anon_sym_is] = ACTIONS(5254),
    [anon_sym_DASH_GT] = ACTIONS(5254),
    [anon_sym_with] = ACTIONS(5254),
    [aux_sym_preproc_if_token3] = ACTIONS(5254),
    [aux_sym_preproc_else_token1] = ACTIONS(5254),
    [aux_sym_preproc_elif_token1] = ACTIONS(5254),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3329] = {
    [sym_preproc_region] = STATE(3329),
    [sym_preproc_endregion] = STATE(3329),
    [sym_preproc_line] = STATE(3329),
    [sym_preproc_pragma] = STATE(3329),
    [sym_preproc_nullable] = STATE(3329),
    [sym_preproc_error] = STATE(3329),
    [sym_preproc_warning] = STATE(3329),
    [sym_preproc_define] = STATE(3329),
    [sym_preproc_undef] = STATE(3329),
    [anon_sym_EQ] = ACTIONS(5463),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5465),
    [anon_sym_DASH_EQ] = ACTIONS(5465),
    [anon_sym_STAR_EQ] = ACTIONS(5465),
    [anon_sym_SLASH_EQ] = ACTIONS(5465),
    [anon_sym_PERCENT_EQ] = ACTIONS(5465),
    [anon_sym_AMP_EQ] = ACTIONS(5465),
    [anon_sym_CARET_EQ] = ACTIONS(5465),
    [anon_sym_PIPE_EQ] = ACTIONS(5465),
    [anon_sym_LT_LT_EQ] = ACTIONS(5465),
    [anon_sym_GT_GT_EQ] = ACTIONS(5465),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5465),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5465),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3330] = {
    [sym_preproc_region] = STATE(3330),
    [sym_preproc_endregion] = STATE(3330),
    [sym_preproc_line] = STATE(3330),
    [sym_preproc_pragma] = STATE(3330),
    [sym_preproc_nullable] = STATE(3330),
    [sym_preproc_error] = STATE(3330),
    [sym_preproc_warning] = STATE(3330),
    [sym_preproc_define] = STATE(3330),
    [sym_preproc_undef] = STATE(3330),
    [anon_sym_SEMI] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_COMMA] = ACTIONS(5149),
    [anon_sym_RBRACK] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_RPAREN] = ACTIONS(5149),
    [anon_sym_RBRACE] = ACTIONS(5149),
    [anon_sym_LT] = ACTIONS(5151),
    [anon_sym_GT] = ACTIONS(5151),
    [anon_sym_in] = ACTIONS(5151),
    [anon_sym_QMARK] = ACTIONS(5151),
    [anon_sym_BANG] = ACTIONS(5151),
    [anon_sym_PLUS_PLUS] = ACTIONS(5149),
    [anon_sym_DASH_DASH] = ACTIONS(5149),
    [anon_sym_PLUS] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5149),
    [anon_sym_SLASH] = ACTIONS(5151),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [anon_sym_PIPE] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5151),
    [anon_sym_LT_LT] = ACTIONS(5149),
    [anon_sym_GT_GT] = ACTIONS(5151),
    [anon_sym_GT_GT_GT] = ACTIONS(5149),
    [anon_sym_EQ_EQ] = ACTIONS(5149),
    [anon_sym_BANG_EQ] = ACTIONS(5149),
    [anon_sym_GT_EQ] = ACTIONS(5149),
    [anon_sym_LT_EQ] = ACTIONS(5149),
    [anon_sym_DOT] = ACTIONS(5151),
    [anon_sym_EQ_GT] = ACTIONS(5149),
    [anon_sym_switch] = ACTIONS(5149),
    [anon_sym_when] = ACTIONS(5149),
    [anon_sym_DOT_DOT] = ACTIONS(5149),
    [anon_sym_and] = ACTIONS(5149),
    [anon_sym_or] = ACTIONS(5149),
    [anon_sym_AMP_AMP] = ACTIONS(5149),
    [anon_sym_PIPE_PIPE] = ACTIONS(5149),
    [anon_sym_QMARK_QMARK] = ACTIONS(5149),
    [anon_sym_into] = ACTIONS(5149),
    [anon_sym_on] = ACTIONS(5149),
    [anon_sym_equals] = ACTIONS(5149),
    [anon_sym_by] = ACTIONS(5149),
    [anon_sym_as] = ACTIONS(5149),
    [anon_sym_is] = ACTIONS(5149),
    [anon_sym_DASH_GT] = ACTIONS(5149),
    [anon_sym_with] = ACTIONS(5149),
    [aux_sym_preproc_if_token3] = ACTIONS(5149),
    [aux_sym_preproc_else_token1] = ACTIONS(5149),
    [aux_sym_preproc_elif_token1] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3331] = {
    [sym_preproc_region] = STATE(3331),
    [sym_preproc_endregion] = STATE(3331),
    [sym_preproc_line] = STATE(3331),
    [sym_preproc_pragma] = STATE(3331),
    [sym_preproc_nullable] = STATE(3331),
    [sym_preproc_error] = STATE(3331),
    [sym_preproc_warning] = STATE(3331),
    [sym_preproc_define] = STATE(3331),
    [sym_preproc_undef] = STATE(3331),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [anon_sym_COLON] = ACTIONS(5417),
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_RBRACK] = ACTIONS(5417),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_RPAREN] = ACTIONS(5417),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5419),
    [anon_sym_in] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_PIPE] = ACTIONS(5419),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5419),
    [anon_sym_GT_GT_GT] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5417),
    [anon_sym_BANG_EQ] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_DOT] = ACTIONS(5419),
    [anon_sym_EQ_GT] = ACTIONS(5417),
    [anon_sym_switch] = ACTIONS(5417),
    [anon_sym_when] = ACTIONS(5417),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5417),
    [anon_sym_QMARK_QMARK] = ACTIONS(5417),
    [anon_sym_into] = ACTIONS(5417),
    [anon_sym_on] = ACTIONS(5417),
    [anon_sym_equals] = ACTIONS(5417),
    [anon_sym_by] = ACTIONS(5417),
    [anon_sym_as] = ACTIONS(5417),
    [anon_sym_is] = ACTIONS(5417),
    [anon_sym_DASH_GT] = ACTIONS(5417),
    [anon_sym_with] = ACTIONS(5417),
    [aux_sym_preproc_if_token3] = ACTIONS(5417),
    [aux_sym_preproc_else_token1] = ACTIONS(5417),
    [aux_sym_preproc_elif_token1] = ACTIONS(5417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3332] = {
    [sym_preproc_region] = STATE(3332),
    [sym_preproc_endregion] = STATE(3332),
    [sym_preproc_line] = STATE(3332),
    [sym_preproc_pragma] = STATE(3332),
    [sym_preproc_nullable] = STATE(3332),
    [sym_preproc_error] = STATE(3332),
    [sym_preproc_warning] = STATE(3332),
    [sym_preproc_define] = STATE(3332),
    [sym_preproc_undef] = STATE(3332),
    [anon_sym_SEMI] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(5183),
    [anon_sym_COLON] = ACTIONS(5183),
    [anon_sym_COMMA] = ACTIONS(5183),
    [anon_sym_RBRACK] = ACTIONS(5183),
    [anon_sym_LPAREN] = ACTIONS(5183),
    [anon_sym_RPAREN] = ACTIONS(5183),
    [anon_sym_RBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_BANG] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5183),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_GT_GT_GT] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5183),
    [anon_sym_BANG_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_EQ_GT] = ACTIONS(5183),
    [anon_sym_switch] = ACTIONS(5183),
    [anon_sym_when] = ACTIONS(5183),
    [anon_sym_DOT_DOT] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_or] = ACTIONS(5183),
    [anon_sym_AMP_AMP] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE] = ACTIONS(5183),
    [anon_sym_QMARK_QMARK] = ACTIONS(5183),
    [anon_sym_into] = ACTIONS(5183),
    [anon_sym_on] = ACTIONS(5183),
    [anon_sym_equals] = ACTIONS(5183),
    [anon_sym_by] = ACTIONS(5183),
    [anon_sym_as] = ACTIONS(5183),
    [anon_sym_is] = ACTIONS(5183),
    [anon_sym_DASH_GT] = ACTIONS(5183),
    [anon_sym_with] = ACTIONS(5183),
    [aux_sym_preproc_if_token3] = ACTIONS(5183),
    [aux_sym_preproc_else_token1] = ACTIONS(5183),
    [aux_sym_preproc_elif_token1] = ACTIONS(5183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3333] = {
    [sym_preproc_region] = STATE(3333),
    [sym_preproc_endregion] = STATE(3333),
    [sym_preproc_line] = STATE(3333),
    [sym_preproc_pragma] = STATE(3333),
    [sym_preproc_nullable] = STATE(3333),
    [sym_preproc_error] = STATE(3333),
    [sym_preproc_warning] = STATE(3333),
    [sym_preproc_define] = STATE(3333),
    [sym_preproc_undef] = STATE(3333),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_record] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3334] = {
    [sym_preproc_region] = STATE(3334),
    [sym_preproc_endregion] = STATE(3334),
    [sym_preproc_line] = STATE(3334),
    [sym_preproc_pragma] = STATE(3334),
    [sym_preproc_nullable] = STATE(3334),
    [sym_preproc_error] = STATE(3334),
    [sym_preproc_warning] = STATE(3334),
    [sym_preproc_define] = STATE(3334),
    [sym_preproc_undef] = STATE(3334),
    [anon_sym_SEMI] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_COLON] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(4975),
    [anon_sym_RBRACK] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_RPAREN] = ACTIONS(4975),
    [anon_sym_RBRACE] = ACTIONS(4975),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_GT] = ACTIONS(4977),
    [anon_sym_in] = ACTIONS(4977),
    [anon_sym_QMARK] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_PLUS_PLUS] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4975),
    [anon_sym_SLASH] = ACTIONS(4977),
    [anon_sym_PERCENT] = ACTIONS(4975),
    [anon_sym_CARET] = ACTIONS(4975),
    [anon_sym_PIPE] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4975),
    [anon_sym_GT_GT] = ACTIONS(4977),
    [anon_sym_GT_GT_GT] = ACTIONS(4975),
    [anon_sym_EQ_EQ] = ACTIONS(4975),
    [anon_sym_BANG_EQ] = ACTIONS(4975),
    [anon_sym_GT_EQ] = ACTIONS(4975),
    [anon_sym_LT_EQ] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_EQ_GT] = ACTIONS(4975),
    [anon_sym_switch] = ACTIONS(4975),
    [anon_sym_when] = ACTIONS(4975),
    [anon_sym_DOT_DOT] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_or] = ACTIONS(4975),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_PIPE_PIPE] = ACTIONS(4975),
    [anon_sym_QMARK_QMARK] = ACTIONS(4975),
    [anon_sym_into] = ACTIONS(4975),
    [anon_sym_on] = ACTIONS(4975),
    [anon_sym_equals] = ACTIONS(4975),
    [anon_sym_by] = ACTIONS(4975),
    [anon_sym_as] = ACTIONS(4975),
    [anon_sym_is] = ACTIONS(4975),
    [anon_sym_DASH_GT] = ACTIONS(4975),
    [anon_sym_with] = ACTIONS(4975),
    [aux_sym_preproc_if_token3] = ACTIONS(4975),
    [aux_sym_preproc_else_token1] = ACTIONS(4975),
    [aux_sym_preproc_elif_token1] = ACTIONS(4975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3335] = {
    [sym_preproc_region] = STATE(3335),
    [sym_preproc_endregion] = STATE(3335),
    [sym_preproc_line] = STATE(3335),
    [sym_preproc_pragma] = STATE(3335),
    [sym_preproc_nullable] = STATE(3335),
    [sym_preproc_error] = STATE(3335),
    [sym_preproc_warning] = STATE(3335),
    [sym_preproc_define] = STATE(3335),
    [sym_preproc_undef] = STATE(3335),
    [anon_sym_SEMI] = ACTIONS(4999),
    [anon_sym_LBRACK] = ACTIONS(4999),
    [anon_sym_COLON] = ACTIONS(4999),
    [anon_sym_COMMA] = ACTIONS(4999),
    [anon_sym_RBRACK] = ACTIONS(4999),
    [anon_sym_LPAREN] = ACTIONS(4999),
    [anon_sym_RPAREN] = ACTIONS(4999),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym_LT] = ACTIONS(5001),
    [anon_sym_GT] = ACTIONS(5001),
    [anon_sym_in] = ACTIONS(5001),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(4999),
    [anon_sym_PLUS] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(4999),
    [anon_sym_SLASH] = ACTIONS(5001),
    [anon_sym_PERCENT] = ACTIONS(4999),
    [anon_sym_CARET] = ACTIONS(4999),
    [anon_sym_PIPE] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_LT_LT] = ACTIONS(4999),
    [anon_sym_GT_GT] = ACTIONS(5001),
    [anon_sym_GT_GT_GT] = ACTIONS(4999),
    [anon_sym_EQ_EQ] = ACTIONS(4999),
    [anon_sym_BANG_EQ] = ACTIONS(4999),
    [anon_sym_GT_EQ] = ACTIONS(4999),
    [anon_sym_LT_EQ] = ACTIONS(4999),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_EQ_GT] = ACTIONS(4999),
    [anon_sym_switch] = ACTIONS(4999),
    [anon_sym_when] = ACTIONS(4999),
    [anon_sym_DOT_DOT] = ACTIONS(4999),
    [anon_sym_and] = ACTIONS(4999),
    [anon_sym_or] = ACTIONS(4999),
    [anon_sym_AMP_AMP] = ACTIONS(4999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4999),
    [anon_sym_QMARK_QMARK] = ACTIONS(4999),
    [anon_sym_into] = ACTIONS(4999),
    [anon_sym_on] = ACTIONS(4999),
    [anon_sym_equals] = ACTIONS(4999),
    [anon_sym_by] = ACTIONS(4999),
    [anon_sym_as] = ACTIONS(4999),
    [anon_sym_is] = ACTIONS(4999),
    [anon_sym_DASH_GT] = ACTIONS(4999),
    [anon_sym_with] = ACTIONS(4999),
    [aux_sym_preproc_if_token3] = ACTIONS(4999),
    [aux_sym_preproc_else_token1] = ACTIONS(4999),
    [aux_sym_preproc_elif_token1] = ACTIONS(4999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3336] = {
    [sym_preproc_region] = STATE(3336),
    [sym_preproc_endregion] = STATE(3336),
    [sym_preproc_line] = STATE(3336),
    [sym_preproc_pragma] = STATE(3336),
    [sym_preproc_nullable] = STATE(3336),
    [sym_preproc_error] = STATE(3336),
    [sym_preproc_warning] = STATE(3336),
    [sym_preproc_define] = STATE(3336),
    [sym_preproc_undef] = STATE(3336),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RBRACK] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(4969),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_EQ_GT] = ACTIONS(4967),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_when] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4967),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4967),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [aux_sym_preproc_if_token3] = ACTIONS(4967),
    [aux_sym_preproc_else_token1] = ACTIONS(4967),
    [aux_sym_preproc_elif_token1] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3337] = {
    [sym_preproc_region] = STATE(3337),
    [sym_preproc_endregion] = STATE(3337),
    [sym_preproc_line] = STATE(3337),
    [sym_preproc_pragma] = STATE(3337),
    [sym_preproc_nullable] = STATE(3337),
    [sym_preproc_error] = STATE(3337),
    [sym_preproc_warning] = STATE(3337),
    [sym_preproc_define] = STATE(3337),
    [sym_preproc_undef] = STATE(3337),
    [anon_sym_SEMI] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_COLON] = ACTIONS(5043),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_RBRACK] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5043),
    [anon_sym_RPAREN] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_in] = ACTIONS(5045),
    [anon_sym_QMARK] = ACTIONS(5045),
    [anon_sym_BANG] = ACTIONS(5045),
    [anon_sym_PLUS_PLUS] = ACTIONS(5043),
    [anon_sym_DASH_DASH] = ACTIONS(5043),
    [anon_sym_PLUS] = ACTIONS(5045),
    [anon_sym_DASH] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5043),
    [anon_sym_SLASH] = ACTIONS(5045),
    [anon_sym_PERCENT] = ACTIONS(5043),
    [anon_sym_CARET] = ACTIONS(5043),
    [anon_sym_PIPE] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5045),
    [anon_sym_LT_LT] = ACTIONS(5043),
    [anon_sym_GT_GT] = ACTIONS(5045),
    [anon_sym_GT_GT_GT] = ACTIONS(5043),
    [anon_sym_EQ_EQ] = ACTIONS(5043),
    [anon_sym_BANG_EQ] = ACTIONS(5043),
    [anon_sym_GT_EQ] = ACTIONS(5043),
    [anon_sym_LT_EQ] = ACTIONS(5043),
    [anon_sym_DOT] = ACTIONS(5045),
    [anon_sym_EQ_GT] = ACTIONS(5043),
    [anon_sym_switch] = ACTIONS(5043),
    [anon_sym_when] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5043),
    [anon_sym_and] = ACTIONS(5043),
    [anon_sym_or] = ACTIONS(5043),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_QMARK_QMARK] = ACTIONS(5043),
    [anon_sym_into] = ACTIONS(5043),
    [anon_sym_on] = ACTIONS(5043),
    [anon_sym_equals] = ACTIONS(5043),
    [anon_sym_by] = ACTIONS(5043),
    [anon_sym_as] = ACTIONS(5043),
    [anon_sym_is] = ACTIONS(5043),
    [anon_sym_DASH_GT] = ACTIONS(5043),
    [anon_sym_with] = ACTIONS(5043),
    [aux_sym_preproc_if_token3] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3338] = {
    [sym_preproc_region] = STATE(3338),
    [sym_preproc_endregion] = STATE(3338),
    [sym_preproc_line] = STATE(3338),
    [sym_preproc_pragma] = STATE(3338),
    [sym_preproc_nullable] = STATE(3338),
    [sym_preproc_error] = STATE(3338),
    [sym_preproc_warning] = STATE(3338),
    [sym_preproc_define] = STATE(3338),
    [sym_preproc_undef] = STATE(3338),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_RBRACK] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_CARET] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4152),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4152),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4152),
    [anon_sym_switch] = ACTIONS(4152),
    [anon_sym_when] = ACTIONS(4152),
    [anon_sym_DOT_DOT] = ACTIONS(4152),
    [anon_sym_and] = ACTIONS(4152),
    [anon_sym_or] = ACTIONS(4152),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_QMARK_QMARK] = ACTIONS(4152),
    [anon_sym_on] = ACTIONS(4152),
    [anon_sym_equals] = ACTIONS(4152),
    [anon_sym_by] = ACTIONS(4152),
    [anon_sym_as] = ACTIONS(4152),
    [anon_sym_is] = ACTIONS(4152),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [anon_sym_with] = ACTIONS(4152),
    [aux_sym_preproc_if_token3] = ACTIONS(4152),
    [aux_sym_preproc_else_token1] = ACTIONS(4152),
    [aux_sym_preproc_elif_token1] = ACTIONS(4152),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3339] = {
    [sym_preproc_region] = STATE(3339),
    [sym_preproc_endregion] = STATE(3339),
    [sym_preproc_line] = STATE(3339),
    [sym_preproc_pragma] = STATE(3339),
    [sym_preproc_nullable] = STATE(3339),
    [sym_preproc_error] = STATE(3339),
    [sym_preproc_warning] = STATE(3339),
    [sym_preproc_define] = STATE(3339),
    [sym_preproc_undef] = STATE(3339),
    [anon_sym_SEMI] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_LT] = ACTIONS(3711),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_PLUS_PLUS] = ACTIONS(3722),
    [anon_sym_DASH_DASH] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(3711),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3711),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_LT_LT] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3711),
    [anon_sym_GT_GT_GT] = ACTIONS(3722),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_GT_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3711),
    [anon_sym_EQ_GT] = ACTIONS(3722),
    [anon_sym_switch] = ACTIONS(3722),
    [anon_sym_when] = ACTIONS(3722),
    [anon_sym_DOT_DOT] = ACTIONS(3722),
    [anon_sym_and] = ACTIONS(3722),
    [anon_sym_or] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_QMARK_QMARK] = ACTIONS(3722),
    [anon_sym_on] = ACTIONS(3722),
    [anon_sym_equals] = ACTIONS(3722),
    [anon_sym_by] = ACTIONS(3722),
    [anon_sym_as] = ACTIONS(3722),
    [anon_sym_is] = ACTIONS(3722),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_with] = ACTIONS(3722),
    [aux_sym_preproc_if_token3] = ACTIONS(3722),
    [aux_sym_preproc_else_token1] = ACTIONS(3722),
    [aux_sym_preproc_elif_token1] = ACTIONS(3722),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3340] = {
    [sym_preproc_region] = STATE(3340),
    [sym_preproc_endregion] = STATE(3340),
    [sym_preproc_line] = STATE(3340),
    [sym_preproc_pragma] = STATE(3340),
    [sym_preproc_nullable] = STATE(3340),
    [sym_preproc_error] = STATE(3340),
    [sym_preproc_warning] = STATE(3340),
    [sym_preproc_define] = STATE(3340),
    [sym_preproc_undef] = STATE(3340),
    [anon_sym_SEMI] = ACTIONS(5109),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5109),
    [anon_sym_COMMA] = ACTIONS(5109),
    [anon_sym_RBRACK] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5109),
    [anon_sym_RPAREN] = ACTIONS(5109),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5111),
    [anon_sym_in] = ACTIONS(5111),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_BANG] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5111),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5111),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_PIPE] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5111),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5111),
    [anon_sym_GT_GT_GT] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5109),
    [anon_sym_BANG_EQ] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5109),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_DOT] = ACTIONS(5111),
    [anon_sym_EQ_GT] = ACTIONS(5109),
    [anon_sym_switch] = ACTIONS(5109),
    [anon_sym_when] = ACTIONS(5109),
    [anon_sym_DOT_DOT] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5109),
    [anon_sym_QMARK_QMARK] = ACTIONS(5109),
    [anon_sym_into] = ACTIONS(5109),
    [anon_sym_on] = ACTIONS(5109),
    [anon_sym_equals] = ACTIONS(5109),
    [anon_sym_by] = ACTIONS(5109),
    [anon_sym_as] = ACTIONS(5109),
    [anon_sym_is] = ACTIONS(5109),
    [anon_sym_DASH_GT] = ACTIONS(5109),
    [anon_sym_with] = ACTIONS(5109),
    [aux_sym_preproc_if_token3] = ACTIONS(5109),
    [aux_sym_preproc_else_token1] = ACTIONS(5109),
    [aux_sym_preproc_elif_token1] = ACTIONS(5109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3341] = {
    [sym_preproc_region] = STATE(3341),
    [sym_preproc_endregion] = STATE(3341),
    [sym_preproc_line] = STATE(3341),
    [sym_preproc_pragma] = STATE(3341),
    [sym_preproc_nullable] = STATE(3341),
    [sym_preproc_error] = STATE(3341),
    [sym_preproc_warning] = STATE(3341),
    [sym_preproc_define] = STATE(3341),
    [sym_preproc_undef] = STATE(3341),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(5455),
    [anon_sym_GT] = ACTIONS(5455),
    [anon_sym_in] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5455),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(5455),
    [anon_sym_AMP] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(5455),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(5455),
    [anon_sym_EQ_GT] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_when] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_QMARK_QMARK] = ACTIONS(3881),
    [anon_sym_into] = ACTIONS(3881),
    [anon_sym_on] = ACTIONS(3881),
    [anon_sym_equals] = ACTIONS(3881),
    [anon_sym_by] = ACTIONS(3881),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_is] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [aux_sym_preproc_if_token3] = ACTIONS(3881),
    [aux_sym_preproc_else_token1] = ACTIONS(3881),
    [aux_sym_preproc_elif_token1] = ACTIONS(3881),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3342] = {
    [sym_preproc_region] = STATE(3342),
    [sym_preproc_endregion] = STATE(3342),
    [sym_preproc_line] = STATE(3342),
    [sym_preproc_pragma] = STATE(3342),
    [sym_preproc_nullable] = STATE(3342),
    [sym_preproc_error] = STATE(3342),
    [sym_preproc_warning] = STATE(3342),
    [sym_preproc_define] = STATE(3342),
    [sym_preproc_undef] = STATE(3342),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_LBRACK] = ACTIONS(4995),
    [anon_sym_COLON] = ACTIONS(4995),
    [anon_sym_COMMA] = ACTIONS(4995),
    [anon_sym_RBRACK] = ACTIONS(4995),
    [anon_sym_LPAREN] = ACTIONS(4995),
    [anon_sym_RPAREN] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_in] = ACTIONS(4997),
    [anon_sym_QMARK] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_PLUS_PLUS] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4995),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4995),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4995),
    [anon_sym_CARET] = ACTIONS(4995),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4995),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_GT_GT_GT] = ACTIONS(4995),
    [anon_sym_EQ_EQ] = ACTIONS(4995),
    [anon_sym_BANG_EQ] = ACTIONS(4995),
    [anon_sym_GT_EQ] = ACTIONS(4995),
    [anon_sym_LT_EQ] = ACTIONS(4995),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_EQ_GT] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_when] = ACTIONS(4995),
    [anon_sym_DOT_DOT] = ACTIONS(4995),
    [anon_sym_and] = ACTIONS(4995),
    [anon_sym_or] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4995),
    [anon_sym_PIPE_PIPE] = ACTIONS(4995),
    [anon_sym_QMARK_QMARK] = ACTIONS(4995),
    [anon_sym_into] = ACTIONS(4995),
    [anon_sym_on] = ACTIONS(4995),
    [anon_sym_equals] = ACTIONS(4995),
    [anon_sym_by] = ACTIONS(4995),
    [anon_sym_as] = ACTIONS(4995),
    [anon_sym_is] = ACTIONS(4995),
    [anon_sym_DASH_GT] = ACTIONS(4995),
    [anon_sym_with] = ACTIONS(4995),
    [aux_sym_preproc_if_token3] = ACTIONS(4995),
    [aux_sym_preproc_else_token1] = ACTIONS(4995),
    [aux_sym_preproc_elif_token1] = ACTIONS(4995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3343] = {
    [sym_preproc_region] = STATE(3343),
    [sym_preproc_endregion] = STATE(3343),
    [sym_preproc_line] = STATE(3343),
    [sym_preproc_pragma] = STATE(3343),
    [sym_preproc_nullable] = STATE(3343),
    [sym_preproc_error] = STATE(3343),
    [sym_preproc_warning] = STATE(3343),
    [sym_preproc_define] = STATE(3343),
    [sym_preproc_undef] = STATE(3343),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4898),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4898),
    [anon_sym_CARET] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3344] = {
    [sym_preproc_region] = STATE(3344),
    [sym_preproc_endregion] = STATE(3344),
    [sym_preproc_line] = STATE(3344),
    [sym_preproc_pragma] = STATE(3344),
    [sym_preproc_nullable] = STATE(3344),
    [sym_preproc_error] = STATE(3344),
    [sym_preproc_warning] = STATE(3344),
    [sym_preproc_define] = STATE(3344),
    [sym_preproc_undef] = STATE(3344),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3345] = {
    [sym_preproc_region] = STATE(3345),
    [sym_preproc_endregion] = STATE(3345),
    [sym_preproc_line] = STATE(3345),
    [sym_preproc_pragma] = STATE(3345),
    [sym_preproc_nullable] = STATE(3345),
    [sym_preproc_error] = STATE(3345),
    [sym_preproc_warning] = STATE(3345),
    [sym_preproc_define] = STATE(3345),
    [sym_preproc_undef] = STATE(3345),
    [anon_sym_SEMI] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_COLON] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RBRACK] = ACTIONS(5187),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5189),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5187),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5187),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT_EQ] = ACTIONS(5187),
    [anon_sym_LT_EQ] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5187),
    [anon_sym_switch] = ACTIONS(5187),
    [anon_sym_when] = ACTIONS(5187),
    [anon_sym_DOT_DOT] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_QMARK_QMARK] = ACTIONS(5187),
    [anon_sym_into] = ACTIONS(5187),
    [anon_sym_on] = ACTIONS(5187),
    [anon_sym_equals] = ACTIONS(5187),
    [anon_sym_by] = ACTIONS(5187),
    [anon_sym_as] = ACTIONS(5187),
    [anon_sym_is] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [anon_sym_with] = ACTIONS(5187),
    [aux_sym_preproc_if_token3] = ACTIONS(5187),
    [aux_sym_preproc_else_token1] = ACTIONS(5187),
    [aux_sym_preproc_elif_token1] = ACTIONS(5187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3346] = {
    [sym_preproc_region] = STATE(3346),
    [sym_preproc_endregion] = STATE(3346),
    [sym_preproc_line] = STATE(3346),
    [sym_preproc_pragma] = STATE(3346),
    [sym_preproc_nullable] = STATE(3346),
    [sym_preproc_error] = STATE(3346),
    [sym_preproc_warning] = STATE(3346),
    [sym_preproc_define] = STATE(3346),
    [sym_preproc_undef] = STATE(3346),
    [anon_sym_SEMI] = ACTIONS(5171),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5171),
    [anon_sym_COMMA] = ACTIONS(5171),
    [anon_sym_RBRACK] = ACTIONS(5171),
    [anon_sym_LPAREN] = ACTIONS(5171),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5173),
    [anon_sym_in] = ACTIONS(5173),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5173),
    [anon_sym_PERCENT] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5173),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5173),
    [anon_sym_GT_GT_GT] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5171),
    [anon_sym_BANG_EQ] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5171),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_DOT] = ACTIONS(5173),
    [anon_sym_EQ_GT] = ACTIONS(5171),
    [anon_sym_switch] = ACTIONS(5171),
    [anon_sym_when] = ACTIONS(5171),
    [anon_sym_DOT_DOT] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_or] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5171),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_QMARK_QMARK] = ACTIONS(5171),
    [anon_sym_into] = ACTIONS(5171),
    [anon_sym_on] = ACTIONS(5171),
    [anon_sym_equals] = ACTIONS(5171),
    [anon_sym_by] = ACTIONS(5171),
    [anon_sym_as] = ACTIONS(5171),
    [anon_sym_is] = ACTIONS(5171),
    [anon_sym_DASH_GT] = ACTIONS(5171),
    [anon_sym_with] = ACTIONS(5171),
    [aux_sym_preproc_if_token3] = ACTIONS(5171),
    [aux_sym_preproc_else_token1] = ACTIONS(5171),
    [aux_sym_preproc_elif_token1] = ACTIONS(5171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3347] = {
    [sym_preproc_region] = STATE(3347),
    [sym_preproc_endregion] = STATE(3347),
    [sym_preproc_line] = STATE(3347),
    [sym_preproc_pragma] = STATE(3347),
    [sym_preproc_nullable] = STATE(3347),
    [sym_preproc_error] = STATE(3347),
    [sym_preproc_warning] = STATE(3347),
    [sym_preproc_define] = STATE(3347),
    [sym_preproc_undef] = STATE(3347),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COMMA] = ACTIONS(3680),
    [anon_sym_RBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_RPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_in] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_when] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3680),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_on] = ACTIONS(3680),
    [anon_sym_equals] = ACTIONS(3680),
    [anon_sym_by] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_if_token3] = ACTIONS(3680),
    [aux_sym_preproc_else_token1] = ACTIONS(3680),
    [aux_sym_preproc_elif_token1] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3348] = {
    [sym_modifier] = STATE(3734),
    [sym_identifier] = STATE(6459),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3348),
    [sym_preproc_endregion] = STATE(3348),
    [sym_preproc_line] = STATE(3348),
    [sym_preproc_pragma] = STATE(3348),
    [sym_preproc_nullable] = STATE(3348),
    [sym_preproc_error] = STATE(3348),
    [sym_preproc_warning] = STATE(3348),
    [sym_preproc_define] = STATE(3348),
    [sym_preproc_undef] = STATE(3348),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3558),
    [sym__identifier_token] = ACTIONS(25),
    [anon_sym_extern] = ACTIONS(4787),
    [anon_sym_alias] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(4787),
    [anon_sym_static] = ACTIONS(4787),
    [anon_sym_abstract] = ACTIONS(4787),
    [anon_sym_async] = ACTIONS(4787),
    [anon_sym_const] = ACTIONS(4787),
    [anon_sym_file] = ACTIONS(4793),
    [anon_sym_fixed] = ACTIONS(4787),
    [anon_sym_internal] = ACTIONS(4787),
    [anon_sym_new] = ACTIONS(4787),
    [anon_sym_override] = ACTIONS(4787),
    [anon_sym_partial] = ACTIONS(4787),
    [anon_sym_private] = ACTIONS(4787),
    [anon_sym_protected] = ACTIONS(4787),
    [anon_sym_public] = ACTIONS(4787),
    [anon_sym_readonly] = ACTIONS(4787),
    [anon_sym_required] = ACTIONS(4787),
    [anon_sym_sealed] = ACTIONS(4787),
    [anon_sym_virtual] = ACTIONS(4787),
    [anon_sym_volatile] = ACTIONS(4787),
    [anon_sym_where] = ACTIONS(29),
    [anon_sym_notnull] = ACTIONS(29),
    [anon_sym_unmanaged] = ACTIONS(29),
    [anon_sym_get] = ACTIONS(5467),
    [anon_sym_set] = ACTIONS(5467),
    [anon_sym_add] = ACTIONS(5467),
    [anon_sym_remove] = ACTIONS(5467),
    [anon_sym_init] = ACTIONS(5467),
    [anon_sym_scoped] = ACTIONS(29),
    [anon_sym_var] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_when] = ACTIONS(29),
    [anon_sym_from] = ACTIONS(29),
    [anon_sym_into] = ACTIONS(29),
    [anon_sym_join] = ACTIONS(29),
    [anon_sym_on] = ACTIONS(29),
    [anon_sym_equals] = ACTIONS(29),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_orderby] = ACTIONS(29),
    [anon_sym_ascending] = ACTIONS(29),
    [anon_sym_descending] = ACTIONS(29),
    [anon_sym_group] = ACTIONS(29),
    [anon_sym_by] = ACTIONS(29),
    [anon_sym_select] = ACTIONS(29),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3349] = {
    [sym_preproc_region] = STATE(3349),
    [sym_preproc_endregion] = STATE(3349),
    [sym_preproc_line] = STATE(3349),
    [sym_preproc_pragma] = STATE(3349),
    [sym_preproc_nullable] = STATE(3349),
    [sym_preproc_error] = STATE(3349),
    [sym_preproc_warning] = STATE(3349),
    [sym_preproc_define] = STATE(3349),
    [sym_preproc_undef] = STATE(3349),
    [anon_sym_SEMI] = ACTIONS(3668),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACK] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_RPAREN] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3666),
    [anon_sym_GT] = ACTIONS(3666),
    [anon_sym_in] = ACTIONS(3668),
    [anon_sym_QMARK] = ACTIONS(3666),
    [anon_sym_BANG] = ACTIONS(3666),
    [anon_sym_PLUS_PLUS] = ACTIONS(3668),
    [anon_sym_DASH_DASH] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3666),
    [anon_sym_DASH] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3666),
    [anon_sym_PERCENT] = ACTIONS(3668),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3666),
    [anon_sym_LT_LT] = ACTIONS(3668),
    [anon_sym_GT_GT] = ACTIONS(3666),
    [anon_sym_GT_GT_GT] = ACTIONS(3668),
    [anon_sym_EQ_EQ] = ACTIONS(3668),
    [anon_sym_BANG_EQ] = ACTIONS(3668),
    [anon_sym_GT_EQ] = ACTIONS(3668),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_DOT] = ACTIONS(3666),
    [anon_sym_EQ_GT] = ACTIONS(3668),
    [anon_sym_switch] = ACTIONS(3668),
    [anon_sym_when] = ACTIONS(3668),
    [anon_sym_DOT_DOT] = ACTIONS(3668),
    [anon_sym_and] = ACTIONS(3668),
    [anon_sym_or] = ACTIONS(3668),
    [anon_sym_AMP_AMP] = ACTIONS(3668),
    [anon_sym_PIPE_PIPE] = ACTIONS(3668),
    [anon_sym_QMARK_QMARK] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_equals] = ACTIONS(3668),
    [anon_sym_by] = ACTIONS(3668),
    [anon_sym_as] = ACTIONS(3668),
    [anon_sym_is] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [anon_sym_with] = ACTIONS(3668),
    [aux_sym_preproc_if_token3] = ACTIONS(3668),
    [aux_sym_preproc_else_token1] = ACTIONS(3668),
    [aux_sym_preproc_elif_token1] = ACTIONS(3668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3350] = {
    [sym_preproc_region] = STATE(3350),
    [sym_preproc_endregion] = STATE(3350),
    [sym_preproc_line] = STATE(3350),
    [sym_preproc_pragma] = STATE(3350),
    [sym_preproc_nullable] = STATE(3350),
    [sym_preproc_error] = STATE(3350),
    [sym_preproc_warning] = STATE(3350),
    [sym_preproc_define] = STATE(3350),
    [sym_preproc_undef] = STATE(3350),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3351] = {
    [sym_preproc_region] = STATE(3351),
    [sym_preproc_endregion] = STATE(3351),
    [sym_preproc_line] = STATE(3351),
    [sym_preproc_pragma] = STATE(3351),
    [sym_preproc_nullable] = STATE(3351),
    [sym_preproc_error] = STATE(3351),
    [sym_preproc_warning] = STATE(3351),
    [sym_preproc_define] = STATE(3351),
    [sym_preproc_undef] = STATE(3351),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(3167),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_RBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3167),
    [anon_sym_GT_EQ] = ACTIONS(3167),
    [anon_sym_LT_EQ] = ACTIONS(3167),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_when] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_and] = ACTIONS(3167),
    [anon_sym_or] = ACTIONS(3167),
    [anon_sym_AMP_AMP] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3167),
    [anon_sym_QMARK_QMARK] = ACTIONS(3167),
    [anon_sym_into] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3167),
    [anon_sym_is] = ACTIONS(3167),
    [anon_sym_DASH_GT] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [aux_sym_preproc_if_token3] = ACTIONS(3167),
    [aux_sym_preproc_else_token1] = ACTIONS(3167),
    [aux_sym_preproc_elif_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3352] = {
    [sym_preproc_region] = STATE(3352),
    [sym_preproc_endregion] = STATE(3352),
    [sym_preproc_line] = STATE(3352),
    [sym_preproc_pragma] = STATE(3352),
    [sym_preproc_nullable] = STATE(3352),
    [sym_preproc_error] = STATE(3352),
    [sym_preproc_warning] = STATE(3352),
    [sym_preproc_define] = STATE(3352),
    [sym_preproc_undef] = STATE(3352),
    [anon_sym_SEMI] = ACTIONS(5011),
    [anon_sym_LBRACK] = ACTIONS(5011),
    [anon_sym_COLON] = ACTIONS(5011),
    [anon_sym_COMMA] = ACTIONS(5011),
    [anon_sym_RBRACK] = ACTIONS(5011),
    [anon_sym_LPAREN] = ACTIONS(5011),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [anon_sym_LT] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5013),
    [anon_sym_in] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_BANG] = ACTIONS(5013),
    [anon_sym_PLUS_PLUS] = ACTIONS(5011),
    [anon_sym_DASH_DASH] = ACTIONS(5011),
    [anon_sym_PLUS] = ACTIONS(5013),
    [anon_sym_DASH] = ACTIONS(5013),
    [anon_sym_STAR] = ACTIONS(5011),
    [anon_sym_SLASH] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5011),
    [anon_sym_CARET] = ACTIONS(5011),
    [anon_sym_PIPE] = ACTIONS(5013),
    [anon_sym_AMP] = ACTIONS(5013),
    [anon_sym_LT_LT] = ACTIONS(5011),
    [anon_sym_GT_GT] = ACTIONS(5013),
    [anon_sym_GT_GT_GT] = ACTIONS(5011),
    [anon_sym_EQ_EQ] = ACTIONS(5011),
    [anon_sym_BANG_EQ] = ACTIONS(5011),
    [anon_sym_GT_EQ] = ACTIONS(5011),
    [anon_sym_LT_EQ] = ACTIONS(5011),
    [anon_sym_DOT] = ACTIONS(5013),
    [anon_sym_EQ_GT] = ACTIONS(5011),
    [anon_sym_switch] = ACTIONS(5011),
    [anon_sym_when] = ACTIONS(5011),
    [anon_sym_DOT_DOT] = ACTIONS(5011),
    [anon_sym_and] = ACTIONS(5011),
    [anon_sym_or] = ACTIONS(5011),
    [anon_sym_AMP_AMP] = ACTIONS(5011),
    [anon_sym_PIPE_PIPE] = ACTIONS(5011),
    [anon_sym_QMARK_QMARK] = ACTIONS(5011),
    [anon_sym_into] = ACTIONS(5011),
    [anon_sym_on] = ACTIONS(5011),
    [anon_sym_equals] = ACTIONS(5011),
    [anon_sym_by] = ACTIONS(5011),
    [anon_sym_as] = ACTIONS(5011),
    [anon_sym_is] = ACTIONS(5011),
    [anon_sym_DASH_GT] = ACTIONS(5011),
    [anon_sym_with] = ACTIONS(5011),
    [aux_sym_preproc_if_token3] = ACTIONS(5011),
    [aux_sym_preproc_else_token1] = ACTIONS(5011),
    [aux_sym_preproc_elif_token1] = ACTIONS(5011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3353] = {
    [sym_preproc_region] = STATE(3353),
    [sym_preproc_endregion] = STATE(3353),
    [sym_preproc_line] = STATE(3353),
    [sym_preproc_pragma] = STATE(3353),
    [sym_preproc_nullable] = STATE(3353),
    [sym_preproc_error] = STATE(3353),
    [sym_preproc_warning] = STATE(3353),
    [sym_preproc_define] = STATE(3353),
    [sym_preproc_undef] = STATE(3353),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5471),
    [anon_sym_DASH_EQ] = ACTIONS(5471),
    [anon_sym_STAR_EQ] = ACTIONS(5471),
    [anon_sym_SLASH_EQ] = ACTIONS(5471),
    [anon_sym_PERCENT_EQ] = ACTIONS(5471),
    [anon_sym_AMP_EQ] = ACTIONS(5471),
    [anon_sym_CARET_EQ] = ACTIONS(5471),
    [anon_sym_PIPE_EQ] = ACTIONS(5471),
    [anon_sym_LT_LT_EQ] = ACTIONS(5471),
    [anon_sym_GT_GT_EQ] = ACTIONS(5471),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5471),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5471),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4898),
  },
  [3354] = {
    [sym_preproc_region] = STATE(3354),
    [sym_preproc_endregion] = STATE(3354),
    [sym_preproc_line] = STATE(3354),
    [sym_preproc_pragma] = STATE(3354),
    [sym_preproc_nullable] = STATE(3354),
    [sym_preproc_error] = STATE(3354),
    [sym_preproc_warning] = STATE(3354),
    [sym_preproc_define] = STATE(3354),
    [sym_preproc_undef] = STATE(3354),
    [anon_sym_SEMI] = ACTIONS(5015),
    [anon_sym_LBRACK] = ACTIONS(5015),
    [anon_sym_COLON] = ACTIONS(5015),
    [anon_sym_COMMA] = ACTIONS(5015),
    [anon_sym_RBRACK] = ACTIONS(5015),
    [anon_sym_LPAREN] = ACTIONS(5015),
    [anon_sym_RPAREN] = ACTIONS(5015),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_LT] = ACTIONS(5017),
    [anon_sym_GT] = ACTIONS(5017),
    [anon_sym_in] = ACTIONS(5017),
    [anon_sym_QMARK] = ACTIONS(5017),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_PLUS_PLUS] = ACTIONS(5015),
    [anon_sym_DASH_DASH] = ACTIONS(5015),
    [anon_sym_PLUS] = ACTIONS(5017),
    [anon_sym_DASH] = ACTIONS(5017),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_SLASH] = ACTIONS(5017),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_PIPE] = ACTIONS(5017),
    [anon_sym_AMP] = ACTIONS(5017),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_GT_GT] = ACTIONS(5017),
    [anon_sym_GT_GT_GT] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5015),
    [anon_sym_BANG_EQ] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5015),
    [anon_sym_LT_EQ] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5017),
    [anon_sym_EQ_GT] = ACTIONS(5015),
    [anon_sym_switch] = ACTIONS(5015),
    [anon_sym_when] = ACTIONS(5015),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_and] = ACTIONS(5015),
    [anon_sym_or] = ACTIONS(5015),
    [anon_sym_AMP_AMP] = ACTIONS(5015),
    [anon_sym_PIPE_PIPE] = ACTIONS(5015),
    [anon_sym_QMARK_QMARK] = ACTIONS(5015),
    [anon_sym_into] = ACTIONS(5015),
    [anon_sym_on] = ACTIONS(5015),
    [anon_sym_equals] = ACTIONS(5015),
    [anon_sym_by] = ACTIONS(5015),
    [anon_sym_as] = ACTIONS(5015),
    [anon_sym_is] = ACTIONS(5015),
    [anon_sym_DASH_GT] = ACTIONS(5015),
    [anon_sym_with] = ACTIONS(5015),
    [aux_sym_preproc_if_token3] = ACTIONS(5015),
    [aux_sym_preproc_else_token1] = ACTIONS(5015),
    [aux_sym_preproc_elif_token1] = ACTIONS(5015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3355] = {
    [sym_preproc_region] = STATE(3355),
    [sym_preproc_endregion] = STATE(3355),
    [sym_preproc_line] = STATE(3355),
    [sym_preproc_pragma] = STATE(3355),
    [sym_preproc_nullable] = STATE(3355),
    [sym_preproc_error] = STATE(3355),
    [sym_preproc_warning] = STATE(3355),
    [sym_preproc_define] = STATE(3355),
    [sym_preproc_undef] = STATE(3355),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(5473),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3356] = {
    [sym_preproc_region] = STATE(3356),
    [sym_preproc_endregion] = STATE(3356),
    [sym_preproc_line] = STATE(3356),
    [sym_preproc_pragma] = STATE(3356),
    [sym_preproc_nullable] = STATE(3356),
    [sym_preproc_error] = STATE(3356),
    [sym_preproc_warning] = STATE(3356),
    [sym_preproc_define] = STATE(3356),
    [sym_preproc_undef] = STATE(3356),
    [anon_sym_SEMI] = ACTIONS(4979),
    [anon_sym_LBRACK] = ACTIONS(4979),
    [anon_sym_COLON] = ACTIONS(4979),
    [anon_sym_COMMA] = ACTIONS(4979),
    [anon_sym_RBRACK] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4979),
    [anon_sym_RPAREN] = ACTIONS(4979),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_LT] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4981),
    [anon_sym_in] = ACTIONS(4981),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_BANG] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4979),
    [anon_sym_DASH_DASH] = ACTIONS(4979),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4981),
    [anon_sym_STAR] = ACTIONS(4979),
    [anon_sym_SLASH] = ACTIONS(4981),
    [anon_sym_PERCENT] = ACTIONS(4979),
    [anon_sym_CARET] = ACTIONS(4979),
    [anon_sym_PIPE] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4981),
    [anon_sym_LT_LT] = ACTIONS(4979),
    [anon_sym_GT_GT] = ACTIONS(4981),
    [anon_sym_GT_GT_GT] = ACTIONS(4979),
    [anon_sym_EQ_EQ] = ACTIONS(4979),
    [anon_sym_BANG_EQ] = ACTIONS(4979),
    [anon_sym_GT_EQ] = ACTIONS(4979),
    [anon_sym_LT_EQ] = ACTIONS(4979),
    [anon_sym_DOT] = ACTIONS(4981),
    [anon_sym_EQ_GT] = ACTIONS(4979),
    [anon_sym_switch] = ACTIONS(4979),
    [anon_sym_when] = ACTIONS(4979),
    [anon_sym_DOT_DOT] = ACTIONS(4979),
    [anon_sym_and] = ACTIONS(4979),
    [anon_sym_or] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4979),
    [anon_sym_PIPE_PIPE] = ACTIONS(4979),
    [anon_sym_QMARK_QMARK] = ACTIONS(4979),
    [anon_sym_into] = ACTIONS(4979),
    [anon_sym_on] = ACTIONS(4979),
    [anon_sym_equals] = ACTIONS(4979),
    [anon_sym_by] = ACTIONS(4979),
    [anon_sym_as] = ACTIONS(4979),
    [anon_sym_is] = ACTIONS(4979),
    [anon_sym_DASH_GT] = ACTIONS(4979),
    [anon_sym_with] = ACTIONS(4979),
    [aux_sym_preproc_if_token3] = ACTIONS(4979),
    [aux_sym_preproc_else_token1] = ACTIONS(4979),
    [aux_sym_preproc_elif_token1] = ACTIONS(4979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3357] = {
    [sym_preproc_region] = STATE(3357),
    [sym_preproc_endregion] = STATE(3357),
    [sym_preproc_line] = STATE(3357),
    [sym_preproc_pragma] = STATE(3357),
    [sym_preproc_nullable] = STATE(3357),
    [sym_preproc_error] = STATE(3357),
    [sym_preproc_warning] = STATE(3357),
    [sym_preproc_define] = STATE(3357),
    [sym_preproc_undef] = STATE(3357),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_COLON] = ACTIONS(4983),
    [anon_sym_COMMA] = ACTIONS(4983),
    [anon_sym_RBRACK] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_LT] = ACTIONS(4985),
    [anon_sym_GT] = ACTIONS(4985),
    [anon_sym_in] = ACTIONS(4985),
    [anon_sym_QMARK] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4985),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4985),
    [anon_sym_DASH] = ACTIONS(4985),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_SLASH] = ACTIONS(4985),
    [anon_sym_PERCENT] = ACTIONS(4983),
    [anon_sym_CARET] = ACTIONS(4983),
    [anon_sym_PIPE] = ACTIONS(4985),
    [anon_sym_AMP] = ACTIONS(4985),
    [anon_sym_LT_LT] = ACTIONS(4983),
    [anon_sym_GT_GT] = ACTIONS(4985),
    [anon_sym_GT_GT_GT] = ACTIONS(4983),
    [anon_sym_EQ_EQ] = ACTIONS(4983),
    [anon_sym_BANG_EQ] = ACTIONS(4983),
    [anon_sym_GT_EQ] = ACTIONS(4983),
    [anon_sym_LT_EQ] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4985),
    [anon_sym_EQ_GT] = ACTIONS(4983),
    [anon_sym_switch] = ACTIONS(4983),
    [anon_sym_when] = ACTIONS(4983),
    [anon_sym_DOT_DOT] = ACTIONS(4983),
    [anon_sym_and] = ACTIONS(4983),
    [anon_sym_or] = ACTIONS(4983),
    [anon_sym_AMP_AMP] = ACTIONS(4983),
    [anon_sym_PIPE_PIPE] = ACTIONS(4983),
    [anon_sym_QMARK_QMARK] = ACTIONS(4983),
    [anon_sym_into] = ACTIONS(4983),
    [anon_sym_on] = ACTIONS(4983),
    [anon_sym_equals] = ACTIONS(4983),
    [anon_sym_by] = ACTIONS(4983),
    [anon_sym_as] = ACTIONS(4983),
    [anon_sym_is] = ACTIONS(4983),
    [anon_sym_DASH_GT] = ACTIONS(4983),
    [anon_sym_with] = ACTIONS(4983),
    [aux_sym_preproc_if_token3] = ACTIONS(4983),
    [aux_sym_preproc_else_token1] = ACTIONS(4983),
    [aux_sym_preproc_elif_token1] = ACTIONS(4983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3358] = {
    [sym_preproc_region] = STATE(3358),
    [sym_preproc_endregion] = STATE(3358),
    [sym_preproc_line] = STATE(3358),
    [sym_preproc_pragma] = STATE(3358),
    [sym_preproc_nullable] = STATE(3358),
    [sym_preproc_error] = STATE(3358),
    [sym_preproc_warning] = STATE(3358),
    [sym_preproc_define] = STATE(3358),
    [sym_preproc_undef] = STATE(3358),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_COLON] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RBRACK] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_in] = ACTIONS(5005),
    [anon_sym_QMARK] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_CARET] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5003),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_GT_GT_GT] = ACTIONS(5003),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_EQ_GT] = ACTIONS(5003),
    [anon_sym_switch] = ACTIONS(5003),
    [anon_sym_when] = ACTIONS(5003),
    [anon_sym_DOT_DOT] = ACTIONS(5003),
    [anon_sym_and] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(5003),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_QMARK_QMARK] = ACTIONS(5003),
    [anon_sym_into] = ACTIONS(5003),
    [anon_sym_on] = ACTIONS(5003),
    [anon_sym_equals] = ACTIONS(5003),
    [anon_sym_by] = ACTIONS(5003),
    [anon_sym_as] = ACTIONS(5003),
    [anon_sym_is] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [anon_sym_with] = ACTIONS(5003),
    [aux_sym_preproc_if_token3] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3359] = {
    [sym_preproc_region] = STATE(3359),
    [sym_preproc_endregion] = STATE(3359),
    [sym_preproc_line] = STATE(3359),
    [sym_preproc_pragma] = STATE(3359),
    [sym_preproc_nullable] = STATE(3359),
    [sym_preproc_error] = STATE(3359),
    [sym_preproc_warning] = STATE(3359),
    [sym_preproc_define] = STATE(3359),
    [sym_preproc_undef] = STATE(3359),
    [anon_sym_EQ] = ACTIONS(5476),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5478),
    [anon_sym_DASH_EQ] = ACTIONS(5478),
    [anon_sym_STAR_EQ] = ACTIONS(5478),
    [anon_sym_SLASH_EQ] = ACTIONS(5478),
    [anon_sym_PERCENT_EQ] = ACTIONS(5478),
    [anon_sym_AMP_EQ] = ACTIONS(5478),
    [anon_sym_CARET_EQ] = ACTIONS(5478),
    [anon_sym_PIPE_EQ] = ACTIONS(5478),
    [anon_sym_LT_LT_EQ] = ACTIONS(5478),
    [anon_sym_GT_GT_EQ] = ACTIONS(5478),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5478),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3360] = {
    [sym_preproc_region] = STATE(3360),
    [sym_preproc_endregion] = STATE(3360),
    [sym_preproc_line] = STATE(3360),
    [sym_preproc_pragma] = STATE(3360),
    [sym_preproc_nullable] = STATE(3360),
    [sym_preproc_error] = STATE(3360),
    [sym_preproc_warning] = STATE(3360),
    [sym_preproc_define] = STATE(3360),
    [sym_preproc_undef] = STATE(3360),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_GT] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_EQ_GT] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_when] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3949),
    [anon_sym_and] = ACTIONS(3949),
    [anon_sym_or] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_QMARK_QMARK] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_as] = ACTIONS(3949),
    [anon_sym_is] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_with] = ACTIONS(3949),
    [aux_sym_preproc_if_token3] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3361] = {
    [sym_preproc_region] = STATE(3361),
    [sym_preproc_endregion] = STATE(3361),
    [sym_preproc_line] = STATE(3361),
    [sym_preproc_pragma] = STATE(3361),
    [sym_preproc_nullable] = STATE(3361),
    [sym_preproc_error] = STATE(3361),
    [sym_preproc_warning] = STATE(3361),
    [sym_preproc_define] = STATE(3361),
    [sym_preproc_undef] = STATE(3361),
    [anon_sym_SEMI] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_COLON] = ACTIONS(5023),
    [anon_sym_COMMA] = ACTIONS(5023),
    [anon_sym_RBRACK] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_RPAREN] = ACTIONS(5023),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_LT] = ACTIONS(5025),
    [anon_sym_GT] = ACTIONS(5025),
    [anon_sym_in] = ACTIONS(5025),
    [anon_sym_QMARK] = ACTIONS(5025),
    [anon_sym_BANG] = ACTIONS(5025),
    [anon_sym_PLUS_PLUS] = ACTIONS(5023),
    [anon_sym_DASH_DASH] = ACTIONS(5023),
    [anon_sym_PLUS] = ACTIONS(5025),
    [anon_sym_DASH] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5023),
    [anon_sym_SLASH] = ACTIONS(5025),
    [anon_sym_PERCENT] = ACTIONS(5023),
    [anon_sym_CARET] = ACTIONS(5023),
    [anon_sym_PIPE] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5025),
    [anon_sym_LT_LT] = ACTIONS(5023),
    [anon_sym_GT_GT] = ACTIONS(5025),
    [anon_sym_GT_GT_GT] = ACTIONS(5023),
    [anon_sym_EQ_EQ] = ACTIONS(5023),
    [anon_sym_BANG_EQ] = ACTIONS(5023),
    [anon_sym_GT_EQ] = ACTIONS(5023),
    [anon_sym_LT_EQ] = ACTIONS(5023),
    [anon_sym_DOT] = ACTIONS(5025),
    [anon_sym_EQ_GT] = ACTIONS(5023),
    [anon_sym_switch] = ACTIONS(5023),
    [anon_sym_when] = ACTIONS(5023),
    [anon_sym_DOT_DOT] = ACTIONS(5023),
    [anon_sym_and] = ACTIONS(5023),
    [anon_sym_or] = ACTIONS(5023),
    [anon_sym_AMP_AMP] = ACTIONS(5023),
    [anon_sym_PIPE_PIPE] = ACTIONS(5023),
    [anon_sym_QMARK_QMARK] = ACTIONS(5023),
    [anon_sym_into] = ACTIONS(5023),
    [anon_sym_on] = ACTIONS(5023),
    [anon_sym_equals] = ACTIONS(5023),
    [anon_sym_by] = ACTIONS(5023),
    [anon_sym_as] = ACTIONS(5023),
    [anon_sym_is] = ACTIONS(5023),
    [anon_sym_DASH_GT] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5023),
    [aux_sym_preproc_if_token3] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3362] = {
    [sym_preproc_region] = STATE(3362),
    [sym_preproc_endregion] = STATE(3362),
    [sym_preproc_line] = STATE(3362),
    [sym_preproc_pragma] = STATE(3362),
    [sym_preproc_nullable] = STATE(3362),
    [sym_preproc_error] = STATE(3362),
    [sym_preproc_warning] = STATE(3362),
    [sym_preproc_define] = STATE(3362),
    [sym_preproc_undef] = STATE(3362),
    [anon_sym_SEMI] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_COLON] = ACTIONS(5031),
    [anon_sym_COMMA] = ACTIONS(5031),
    [anon_sym_RBRACK] = ACTIONS(5031),
    [anon_sym_LPAREN] = ACTIONS(5031),
    [anon_sym_RPAREN] = ACTIONS(5031),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_GT] = ACTIONS(5033),
    [anon_sym_in] = ACTIONS(5033),
    [anon_sym_QMARK] = ACTIONS(5033),
    [anon_sym_BANG] = ACTIONS(5033),
    [anon_sym_PLUS_PLUS] = ACTIONS(5031),
    [anon_sym_DASH_DASH] = ACTIONS(5031),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5031),
    [anon_sym_SLASH] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5031),
    [anon_sym_CARET] = ACTIONS(5031),
    [anon_sym_PIPE] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(5031),
    [anon_sym_GT_GT] = ACTIONS(5033),
    [anon_sym_GT_GT_GT] = ACTIONS(5031),
    [anon_sym_EQ_EQ] = ACTIONS(5031),
    [anon_sym_BANG_EQ] = ACTIONS(5031),
    [anon_sym_GT_EQ] = ACTIONS(5031),
    [anon_sym_LT_EQ] = ACTIONS(5031),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_EQ_GT] = ACTIONS(5031),
    [anon_sym_switch] = ACTIONS(5031),
    [anon_sym_when] = ACTIONS(5031),
    [anon_sym_DOT_DOT] = ACTIONS(5031),
    [anon_sym_and] = ACTIONS(5031),
    [anon_sym_or] = ACTIONS(5031),
    [anon_sym_AMP_AMP] = ACTIONS(5031),
    [anon_sym_PIPE_PIPE] = ACTIONS(5031),
    [anon_sym_QMARK_QMARK] = ACTIONS(5031),
    [anon_sym_into] = ACTIONS(5031),
    [anon_sym_on] = ACTIONS(5031),
    [anon_sym_equals] = ACTIONS(5031),
    [anon_sym_by] = ACTIONS(5031),
    [anon_sym_as] = ACTIONS(5031),
    [anon_sym_is] = ACTIONS(5031),
    [anon_sym_DASH_GT] = ACTIONS(5031),
    [anon_sym_with] = ACTIONS(5031),
    [aux_sym_preproc_if_token3] = ACTIONS(5031),
    [aux_sym_preproc_else_token1] = ACTIONS(5031),
    [aux_sym_preproc_elif_token1] = ACTIONS(5031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3363] = {
    [sym_preproc_region] = STATE(3363),
    [sym_preproc_endregion] = STATE(3363),
    [sym_preproc_line] = STATE(3363),
    [sym_preproc_pragma] = STATE(3363),
    [sym_preproc_nullable] = STATE(3363),
    [sym_preproc_error] = STATE(3363),
    [sym_preproc_warning] = STATE(3363),
    [sym_preproc_define] = STATE(3363),
    [sym_preproc_undef] = STATE(3363),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3364] = {
    [sym_preproc_region] = STATE(3364),
    [sym_preproc_endregion] = STATE(3364),
    [sym_preproc_line] = STATE(3364),
    [sym_preproc_pragma] = STATE(3364),
    [sym_preproc_nullable] = STATE(3364),
    [sym_preproc_error] = STATE(3364),
    [sym_preproc_warning] = STATE(3364),
    [sym_preproc_define] = STATE(3364),
    [sym_preproc_undef] = STATE(3364),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_RBRACK] = ACTIONS(5179),
    [anon_sym_LPAREN] = ACTIONS(5179),
    [anon_sym_RPAREN] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_in] = ACTIONS(5181),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_BANG] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5181),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5181),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_GT_GT_GT] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_DOT] = ACTIONS(5181),
    [anon_sym_EQ_GT] = ACTIONS(5179),
    [anon_sym_switch] = ACTIONS(5179),
    [anon_sym_when] = ACTIONS(5179),
    [anon_sym_DOT_DOT] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_AMP_AMP] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5179),
    [anon_sym_QMARK_QMARK] = ACTIONS(5179),
    [anon_sym_into] = ACTIONS(5179),
    [anon_sym_on] = ACTIONS(5179),
    [anon_sym_equals] = ACTIONS(5179),
    [anon_sym_by] = ACTIONS(5179),
    [anon_sym_as] = ACTIONS(5179),
    [anon_sym_is] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5179),
    [anon_sym_with] = ACTIONS(5179),
    [aux_sym_preproc_if_token3] = ACTIONS(5179),
    [aux_sym_preproc_else_token1] = ACTIONS(5179),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3365] = {
    [sym_preproc_region] = STATE(3365),
    [sym_preproc_endregion] = STATE(3365),
    [sym_preproc_line] = STATE(3365),
    [sym_preproc_pragma] = STATE(3365),
    [sym_preproc_nullable] = STATE(3365),
    [sym_preproc_error] = STATE(3365),
    [sym_preproc_warning] = STATE(3365),
    [sym_preproc_define] = STATE(3365),
    [sym_preproc_undef] = STATE(3365),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COMMA] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4042),
    [anon_sym_in] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_PLUS_PLUS] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_GT_GT_GT] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4042),
    [anon_sym_EQ_GT] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_when] = ACTIONS(4044),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4044),
    [anon_sym_or] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_QMARK_QMARK] = ACTIONS(4044),
    [anon_sym_on] = ACTIONS(4044),
    [anon_sym_equals] = ACTIONS(4044),
    [anon_sym_by] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4044),
    [anon_sym_is] = ACTIONS(4044),
    [anon_sym_DASH_GT] = ACTIONS(4044),
    [anon_sym_with] = ACTIONS(4044),
    [aux_sym_preproc_if_token3] = ACTIONS(4044),
    [aux_sym_preproc_else_token1] = ACTIONS(4044),
    [aux_sym_preproc_elif_token1] = ACTIONS(4044),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3366] = {
    [sym_preproc_region] = STATE(3366),
    [sym_preproc_endregion] = STATE(3366),
    [sym_preproc_line] = STATE(3366),
    [sym_preproc_pragma] = STATE(3366),
    [sym_preproc_nullable] = STATE(3366),
    [sym_preproc_error] = STATE(3366),
    [sym_preproc_warning] = STATE(3366),
    [sym_preproc_define] = STATE(3366),
    [sym_preproc_undef] = STATE(3366),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(5473),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3367] = {
    [sym_preproc_region] = STATE(3367),
    [sym_preproc_endregion] = STATE(3367),
    [sym_preproc_line] = STATE(3367),
    [sym_preproc_pragma] = STATE(3367),
    [sym_preproc_nullable] = STATE(3367),
    [sym_preproc_error] = STATE(3367),
    [sym_preproc_warning] = STATE(3367),
    [sym_preproc_define] = STATE(3367),
    [sym_preproc_undef] = STATE(3367),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_COLON] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_RBRACK] = ACTIONS(5480),
    [anon_sym_LPAREN] = ACTIONS(5480),
    [anon_sym_RPAREN] = ACTIONS(5480),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_in] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5482),
    [anon_sym_BANG] = ACTIONS(5482),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5480),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5480),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_GT_GT_GT] = ACTIONS(5480),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_EQ_GT] = ACTIONS(5480),
    [anon_sym_switch] = ACTIONS(5480),
    [anon_sym_when] = ACTIONS(5480),
    [anon_sym_DOT_DOT] = ACTIONS(5480),
    [anon_sym_and] = ACTIONS(5480),
    [anon_sym_or] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_QMARK_QMARK] = ACTIONS(5480),
    [anon_sym_into] = ACTIONS(5480),
    [anon_sym_on] = ACTIONS(5480),
    [anon_sym_equals] = ACTIONS(5480),
    [anon_sym_by] = ACTIONS(5480),
    [anon_sym_as] = ACTIONS(5480),
    [anon_sym_is] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_with] = ACTIONS(5480),
    [aux_sym_preproc_if_token3] = ACTIONS(5480),
    [aux_sym_preproc_else_token1] = ACTIONS(5480),
    [aux_sym_preproc_elif_token1] = ACTIONS(5480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3368] = {
    [sym_preproc_region] = STATE(3368),
    [sym_preproc_endregion] = STATE(3368),
    [sym_preproc_line] = STATE(3368),
    [sym_preproc_pragma] = STATE(3368),
    [sym_preproc_nullable] = STATE(3368),
    [sym_preproc_error] = STATE(3368),
    [sym_preproc_warning] = STATE(3368),
    [sym_preproc_define] = STATE(3368),
    [sym_preproc_undef] = STATE(3368),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_COLON] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5039),
    [anon_sym_RBRACK] = ACTIONS(5039),
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_RPAREN] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_in] = ACTIONS(5041),
    [anon_sym_QMARK] = ACTIONS(5041),
    [anon_sym_BANG] = ACTIONS(5041),
    [anon_sym_PLUS_PLUS] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(5039),
    [anon_sym_PLUS] = ACTIONS(5041),
    [anon_sym_DASH] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_SLASH] = ACTIONS(5041),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_CARET] = ACTIONS(5039),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5041),
    [anon_sym_LT_LT] = ACTIONS(5039),
    [anon_sym_GT_GT] = ACTIONS(5041),
    [anon_sym_GT_GT_GT] = ACTIONS(5039),
    [anon_sym_EQ_EQ] = ACTIONS(5039),
    [anon_sym_BANG_EQ] = ACTIONS(5039),
    [anon_sym_GT_EQ] = ACTIONS(5039),
    [anon_sym_LT_EQ] = ACTIONS(5039),
    [anon_sym_DOT] = ACTIONS(5041),
    [anon_sym_EQ_GT] = ACTIONS(5039),
    [anon_sym_switch] = ACTIONS(5039),
    [anon_sym_when] = ACTIONS(5039),
    [anon_sym_DOT_DOT] = ACTIONS(5039),
    [anon_sym_and] = ACTIONS(5039),
    [anon_sym_or] = ACTIONS(5039),
    [anon_sym_AMP_AMP] = ACTIONS(5039),
    [anon_sym_PIPE_PIPE] = ACTIONS(5039),
    [anon_sym_QMARK_QMARK] = ACTIONS(5039),
    [anon_sym_into] = ACTIONS(5039),
    [anon_sym_on] = ACTIONS(5039),
    [anon_sym_equals] = ACTIONS(5039),
    [anon_sym_by] = ACTIONS(5039),
    [anon_sym_as] = ACTIONS(5039),
    [anon_sym_is] = ACTIONS(5039),
    [anon_sym_DASH_GT] = ACTIONS(5039),
    [anon_sym_with] = ACTIONS(5039),
    [aux_sym_preproc_if_token3] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3369] = {
    [sym_preproc_region] = STATE(3369),
    [sym_preproc_endregion] = STATE(3369),
    [sym_preproc_line] = STATE(3369),
    [sym_preproc_pragma] = STATE(3369),
    [sym_preproc_nullable] = STATE(3369),
    [sym_preproc_error] = STATE(3369),
    [sym_preproc_warning] = STATE(3369),
    [sym_preproc_define] = STATE(3369),
    [sym_preproc_undef] = STATE(3369),
    [anon_sym_SEMI] = ACTIONS(5218),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [anon_sym_COLON] = ACTIONS(5218),
    [anon_sym_COMMA] = ACTIONS(5218),
    [anon_sym_RBRACK] = ACTIONS(5218),
    [anon_sym_LPAREN] = ACTIONS(5218),
    [anon_sym_RPAREN] = ACTIONS(5218),
    [anon_sym_RBRACE] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5220),
    [anon_sym_in] = ACTIONS(5220),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_BANG] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5218),
    [anon_sym_DASH_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5220),
    [anon_sym_STAR] = ACTIONS(5218),
    [anon_sym_SLASH] = ACTIONS(5220),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5218),
    [anon_sym_PIPE] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_GT_GT_GT] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5218),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_DOT] = ACTIONS(5220),
    [anon_sym_EQ_GT] = ACTIONS(5218),
    [anon_sym_switch] = ACTIONS(5218),
    [anon_sym_when] = ACTIONS(5218),
    [anon_sym_DOT_DOT] = ACTIONS(5218),
    [anon_sym_and] = ACTIONS(5218),
    [anon_sym_or] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_QMARK_QMARK] = ACTIONS(5218),
    [anon_sym_into] = ACTIONS(5218),
    [anon_sym_on] = ACTIONS(5218),
    [anon_sym_equals] = ACTIONS(5218),
    [anon_sym_by] = ACTIONS(5218),
    [anon_sym_as] = ACTIONS(5218),
    [anon_sym_is] = ACTIONS(5218),
    [anon_sym_DASH_GT] = ACTIONS(5218),
    [anon_sym_with] = ACTIONS(5218),
    [aux_sym_preproc_if_token3] = ACTIONS(5218),
    [aux_sym_preproc_else_token1] = ACTIONS(5218),
    [aux_sym_preproc_elif_token1] = ACTIONS(5218),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3370] = {
    [sym_preproc_region] = STATE(3370),
    [sym_preproc_endregion] = STATE(3370),
    [sym_preproc_line] = STATE(3370),
    [sym_preproc_pragma] = STATE(3370),
    [sym_preproc_nullable] = STATE(3370),
    [sym_preproc_error] = STATE(3370),
    [sym_preproc_warning] = STATE(3370),
    [sym_preproc_define] = STATE(3370),
    [sym_preproc_undef] = STATE(3370),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_COLON] = ACTIONS(5027),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_RBRACK] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_in] = ACTIONS(5029),
    [anon_sym_QMARK] = ACTIONS(5029),
    [anon_sym_BANG] = ACTIONS(5029),
    [anon_sym_PLUS_PLUS] = ACTIONS(5027),
    [anon_sym_DASH_DASH] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_PERCENT] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_GT] = ACTIONS(5027),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_EQ_GT] = ACTIONS(5027),
    [anon_sym_switch] = ACTIONS(5027),
    [anon_sym_when] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5027),
    [anon_sym_and] = ACTIONS(5027),
    [anon_sym_or] = ACTIONS(5027),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK_QMARK] = ACTIONS(5027),
    [anon_sym_into] = ACTIONS(5027),
    [anon_sym_on] = ACTIONS(5027),
    [anon_sym_equals] = ACTIONS(5027),
    [anon_sym_by] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5027),
    [anon_sym_is] = ACTIONS(5027),
    [anon_sym_DASH_GT] = ACTIONS(5027),
    [anon_sym_with] = ACTIONS(5027),
    [aux_sym_preproc_if_token3] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3371] = {
    [sym_preproc_region] = STATE(3371),
    [sym_preproc_endregion] = STATE(3371),
    [sym_preproc_line] = STATE(3371),
    [sym_preproc_pragma] = STATE(3371),
    [sym_preproc_nullable] = STATE(3371),
    [sym_preproc_error] = STATE(3371),
    [sym_preproc_warning] = STATE(3371),
    [sym_preproc_define] = STATE(3371),
    [sym_preproc_undef] = STATE(3371),
    [anon_sym_SEMI] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4108),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_in] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4106),
    [anon_sym_PLUS_PLUS] = ACTIONS(4108),
    [anon_sym_DASH_DASH] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_STAR] = ACTIONS(4108),
    [anon_sym_SLASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_CARET] = ACTIONS(4108),
    [anon_sym_PIPE] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4106),
    [anon_sym_LT_LT] = ACTIONS(4108),
    [anon_sym_GT_GT] = ACTIONS(4106),
    [anon_sym_GT_GT_GT] = ACTIONS(4108),
    [anon_sym_EQ_EQ] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_EQ] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4106),
    [anon_sym_EQ_GT] = ACTIONS(4108),
    [anon_sym_switch] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4108),
    [anon_sym_DOT_DOT] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_QMARK_QMARK] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_is] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [aux_sym_preproc_if_token3] = ACTIONS(4108),
    [aux_sym_preproc_else_token1] = ACTIONS(4108),
    [aux_sym_preproc_elif_token1] = ACTIONS(4108),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3372] = {
    [sym_preproc_region] = STATE(3372),
    [sym_preproc_endregion] = STATE(3372),
    [sym_preproc_line] = STATE(3372),
    [sym_preproc_pragma] = STATE(3372),
    [sym_preproc_nullable] = STATE(3372),
    [sym_preproc_error] = STATE(3372),
    [sym_preproc_warning] = STATE(3372),
    [sym_preproc_define] = STATE(3372),
    [sym_preproc_undef] = STATE(3372),
    [anon_sym_SEMI] = ACTIONS(5195),
    [anon_sym_LBRACK] = ACTIONS(5195),
    [anon_sym_COLON] = ACTIONS(5195),
    [anon_sym_COMMA] = ACTIONS(5195),
    [anon_sym_RBRACK] = ACTIONS(5195),
    [anon_sym_LPAREN] = ACTIONS(5195),
    [anon_sym_RPAREN] = ACTIONS(5195),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_in] = ACTIONS(5197),
    [anon_sym_QMARK] = ACTIONS(5197),
    [anon_sym_BANG] = ACTIONS(5197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5195),
    [anon_sym_DASH_DASH] = ACTIONS(5195),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5195),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5195),
    [anon_sym_CARET] = ACTIONS(5195),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5195),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_GT_GT_GT] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_EQ_GT] = ACTIONS(5195),
    [anon_sym_switch] = ACTIONS(5195),
    [anon_sym_when] = ACTIONS(5195),
    [anon_sym_DOT_DOT] = ACTIONS(5195),
    [anon_sym_and] = ACTIONS(5195),
    [anon_sym_or] = ACTIONS(5195),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_QMARK_QMARK] = ACTIONS(5195),
    [anon_sym_into] = ACTIONS(5195),
    [anon_sym_on] = ACTIONS(5195),
    [anon_sym_equals] = ACTIONS(5195),
    [anon_sym_by] = ACTIONS(5195),
    [anon_sym_as] = ACTIONS(5195),
    [anon_sym_is] = ACTIONS(5195),
    [anon_sym_DASH_GT] = ACTIONS(5195),
    [anon_sym_with] = ACTIONS(5195),
    [aux_sym_preproc_if_token3] = ACTIONS(5195),
    [aux_sym_preproc_else_token1] = ACTIONS(5195),
    [aux_sym_preproc_elif_token1] = ACTIONS(5195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3373] = {
    [sym_preproc_region] = STATE(3373),
    [sym_preproc_endregion] = STATE(3373),
    [sym_preproc_line] = STATE(3373),
    [sym_preproc_pragma] = STATE(3373),
    [sym_preproc_nullable] = STATE(3373),
    [sym_preproc_error] = STATE(3373),
    [sym_preproc_warning] = STATE(3373),
    [sym_preproc_define] = STATE(3373),
    [sym_preproc_undef] = STATE(3373),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_COLON] = ACTIONS(3686),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_RPAREN] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3686),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_in] = ACTIONS(3686),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_PLUS_PLUS] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(3686),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3686),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_LT_LT] = ACTIONS(3686),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3686),
    [anon_sym_EQ_EQ] = ACTIONS(3686),
    [anon_sym_BANG_EQ] = ACTIONS(3686),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LT_EQ] = ACTIONS(3686),
    [anon_sym_DOT] = ACTIONS(3684),
    [anon_sym_EQ_GT] = ACTIONS(3686),
    [anon_sym_switch] = ACTIONS(3686),
    [anon_sym_when] = ACTIONS(3686),
    [anon_sym_DOT_DOT] = ACTIONS(3686),
    [anon_sym_and] = ACTIONS(3686),
    [anon_sym_or] = ACTIONS(3686),
    [anon_sym_AMP_AMP] = ACTIONS(3686),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_QMARK_QMARK] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_equals] = ACTIONS(3686),
    [anon_sym_by] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3686),
    [anon_sym_is] = ACTIONS(3686),
    [anon_sym_DASH_GT] = ACTIONS(3686),
    [anon_sym_with] = ACTIONS(3686),
    [aux_sym_preproc_if_token3] = ACTIONS(3686),
    [aux_sym_preproc_else_token1] = ACTIONS(3686),
    [aux_sym_preproc_elif_token1] = ACTIONS(3686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3374] = {
    [sym_preproc_region] = STATE(3374),
    [sym_preproc_endregion] = STATE(3374),
    [sym_preproc_line] = STATE(3374),
    [sym_preproc_pragma] = STATE(3374),
    [sym_preproc_nullable] = STATE(3374),
    [sym_preproc_error] = STATE(3374),
    [sym_preproc_warning] = STATE(3374),
    [sym_preproc_define] = STATE(3374),
    [sym_preproc_undef] = STATE(3374),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_in] = ACTIONS(2063),
    [anon_sym_QMARK] = ACTIONS(2063),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_EQ_GT] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(2061),
    [anon_sym_DOT_DOT] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_QMARK_QMARK] = ACTIONS(2061),
    [anon_sym_into] = ACTIONS(2061),
    [anon_sym_on] = ACTIONS(2061),
    [anon_sym_equals] = ACTIONS(2061),
    [anon_sym_by] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_DASH_GT] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [aux_sym_preproc_if_token3] = ACTIONS(2061),
    [aux_sym_preproc_else_token1] = ACTIONS(2061),
    [aux_sym_preproc_elif_token1] = ACTIONS(2061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3375] = {
    [sym_preproc_region] = STATE(3375),
    [sym_preproc_endregion] = STATE(3375),
    [sym_preproc_line] = STATE(3375),
    [sym_preproc_pragma] = STATE(3375),
    [sym_preproc_nullable] = STATE(3375),
    [sym_preproc_error] = STATE(3375),
    [sym_preproc_warning] = STATE(3375),
    [sym_preproc_define] = STATE(3375),
    [sym_preproc_undef] = STATE(3375),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5167),
    [anon_sym_COLON] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RBRACK] = ACTIONS(5167),
    [anon_sym_LPAREN] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_in] = ACTIONS(5169),
    [anon_sym_QMARK] = ACTIONS(5169),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS_PLUS] = ACTIONS(5167),
    [anon_sym_DASH_DASH] = ACTIONS(5167),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5167),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5167),
    [anon_sym_CARET] = ACTIONS(5167),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5167),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_GT_GT_GT] = ACTIONS(5167),
    [anon_sym_EQ_EQ] = ACTIONS(5167),
    [anon_sym_BANG_EQ] = ACTIONS(5167),
    [anon_sym_GT_EQ] = ACTIONS(5167),
    [anon_sym_LT_EQ] = ACTIONS(5167),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_EQ_GT] = ACTIONS(5167),
    [anon_sym_switch] = ACTIONS(5167),
    [anon_sym_when] = ACTIONS(5167),
    [anon_sym_DOT_DOT] = ACTIONS(5167),
    [anon_sym_and] = ACTIONS(5167),
    [anon_sym_or] = ACTIONS(5167),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_QMARK_QMARK] = ACTIONS(5167),
    [anon_sym_into] = ACTIONS(5167),
    [anon_sym_on] = ACTIONS(5167),
    [anon_sym_equals] = ACTIONS(5167),
    [anon_sym_by] = ACTIONS(5167),
    [anon_sym_as] = ACTIONS(5167),
    [anon_sym_is] = ACTIONS(5167),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5167),
    [aux_sym_preproc_if_token3] = ACTIONS(5167),
    [aux_sym_preproc_else_token1] = ACTIONS(5167),
    [aux_sym_preproc_elif_token1] = ACTIONS(5167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3376] = {
    [sym_preproc_region] = STATE(3376),
    [sym_preproc_endregion] = STATE(3376),
    [sym_preproc_line] = STATE(3376),
    [sym_preproc_pragma] = STATE(3376),
    [sym_preproc_nullable] = STATE(3376),
    [sym_preproc_error] = STATE(3376),
    [sym_preproc_warning] = STATE(3376),
    [sym_preproc_define] = STATE(3376),
    [sym_preproc_undef] = STATE(3376),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_RBRACK] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(5484),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_LT] = ACTIONS(5486),
    [anon_sym_GT] = ACTIONS(5486),
    [anon_sym_in] = ACTIONS(5486),
    [anon_sym_QMARK] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(5486),
    [anon_sym_PLUS_PLUS] = ACTIONS(5484),
    [anon_sym_DASH_DASH] = ACTIONS(5484),
    [anon_sym_PLUS] = ACTIONS(5486),
    [anon_sym_DASH] = ACTIONS(5486),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_SLASH] = ACTIONS(5486),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5486),
    [anon_sym_AMP] = ACTIONS(5486),
    [anon_sym_LT_LT] = ACTIONS(5484),
    [anon_sym_GT_GT] = ACTIONS(5486),
    [anon_sym_GT_GT_GT] = ACTIONS(5484),
    [anon_sym_EQ_EQ] = ACTIONS(5484),
    [anon_sym_BANG_EQ] = ACTIONS(5484),
    [anon_sym_GT_EQ] = ACTIONS(5484),
    [anon_sym_LT_EQ] = ACTIONS(5484),
    [anon_sym_DOT] = ACTIONS(5486),
    [anon_sym_EQ_GT] = ACTIONS(5484),
    [anon_sym_switch] = ACTIONS(5484),
    [anon_sym_when] = ACTIONS(5484),
    [anon_sym_DOT_DOT] = ACTIONS(5484),
    [anon_sym_and] = ACTIONS(5484),
    [anon_sym_or] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_QMARK_QMARK] = ACTIONS(5484),
    [anon_sym_into] = ACTIONS(5484),
    [anon_sym_on] = ACTIONS(5484),
    [anon_sym_equals] = ACTIONS(5484),
    [anon_sym_by] = ACTIONS(5484),
    [anon_sym_as] = ACTIONS(5484),
    [anon_sym_is] = ACTIONS(5484),
    [anon_sym_DASH_GT] = ACTIONS(5484),
    [anon_sym_with] = ACTIONS(5484),
    [aux_sym_preproc_if_token3] = ACTIONS(5484),
    [aux_sym_preproc_else_token1] = ACTIONS(5484),
    [aux_sym_preproc_elif_token1] = ACTIONS(5484),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3377] = {
    [sym_preproc_region] = STATE(3377),
    [sym_preproc_endregion] = STATE(3377),
    [sym_preproc_line] = STATE(3377),
    [sym_preproc_pragma] = STATE(3377),
    [sym_preproc_nullable] = STATE(3377),
    [sym_preproc_error] = STATE(3377),
    [sym_preproc_warning] = STATE(3377),
    [sym_preproc_define] = STATE(3377),
    [sym_preproc_undef] = STATE(3377),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_COLON] = ACTIONS(5488),
    [anon_sym_COMMA] = ACTIONS(5488),
    [anon_sym_RBRACK] = ACTIONS(5488),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_RPAREN] = ACTIONS(5488),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_LT] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5490),
    [anon_sym_in] = ACTIONS(5490),
    [anon_sym_QMARK] = ACTIONS(5490),
    [anon_sym_BANG] = ACTIONS(5490),
    [anon_sym_PLUS_PLUS] = ACTIONS(5488),
    [anon_sym_DASH_DASH] = ACTIONS(5488),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_DASH] = ACTIONS(5490),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_SLASH] = ACTIONS(5490),
    [anon_sym_PERCENT] = ACTIONS(5488),
    [anon_sym_CARET] = ACTIONS(5488),
    [anon_sym_PIPE] = ACTIONS(5490),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_LT_LT] = ACTIONS(5488),
    [anon_sym_GT_GT] = ACTIONS(5490),
    [anon_sym_GT_GT_GT] = ACTIONS(5488),
    [anon_sym_EQ_EQ] = ACTIONS(5488),
    [anon_sym_BANG_EQ] = ACTIONS(5488),
    [anon_sym_GT_EQ] = ACTIONS(5488),
    [anon_sym_LT_EQ] = ACTIONS(5488),
    [anon_sym_DOT] = ACTIONS(5490),
    [anon_sym_EQ_GT] = ACTIONS(5488),
    [anon_sym_switch] = ACTIONS(5488),
    [anon_sym_when] = ACTIONS(5488),
    [anon_sym_DOT_DOT] = ACTIONS(5488),
    [anon_sym_and] = ACTIONS(5488),
    [anon_sym_or] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_PIPE_PIPE] = ACTIONS(5488),
    [anon_sym_QMARK_QMARK] = ACTIONS(5488),
    [anon_sym_into] = ACTIONS(5488),
    [anon_sym_on] = ACTIONS(5488),
    [anon_sym_equals] = ACTIONS(5488),
    [anon_sym_by] = ACTIONS(5488),
    [anon_sym_as] = ACTIONS(5488),
    [anon_sym_is] = ACTIONS(5488),
    [anon_sym_DASH_GT] = ACTIONS(5488),
    [anon_sym_with] = ACTIONS(5488),
    [aux_sym_preproc_if_token3] = ACTIONS(5488),
    [aux_sym_preproc_else_token1] = ACTIONS(5488),
    [aux_sym_preproc_elif_token1] = ACTIONS(5488),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3378] = {
    [sym_preproc_region] = STATE(3378),
    [sym_preproc_endregion] = STATE(3378),
    [sym_preproc_line] = STATE(3378),
    [sym_preproc_pragma] = STATE(3378),
    [sym_preproc_nullable] = STATE(3378),
    [sym_preproc_error] = STATE(3378),
    [sym_preproc_warning] = STATE(3378),
    [sym_preproc_define] = STATE(3378),
    [sym_preproc_undef] = STATE(3378),
    [anon_sym_SEMI] = ACTIONS(5175),
    [anon_sym_LBRACK] = ACTIONS(5175),
    [anon_sym_COLON] = ACTIONS(5175),
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_RBRACK] = ACTIONS(5175),
    [anon_sym_LPAREN] = ACTIONS(5175),
    [anon_sym_RPAREN] = ACTIONS(5175),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_LT] = ACTIONS(5177),
    [anon_sym_GT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5177),
    [anon_sym_QMARK] = ACTIONS(5177),
    [anon_sym_BANG] = ACTIONS(5177),
    [anon_sym_PLUS_PLUS] = ACTIONS(5175),
    [anon_sym_DASH_DASH] = ACTIONS(5175),
    [anon_sym_PLUS] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5175),
    [anon_sym_SLASH] = ACTIONS(5177),
    [anon_sym_PERCENT] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5175),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5175),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_GT_GT_GT] = ACTIONS(5175),
    [anon_sym_EQ_EQ] = ACTIONS(5175),
    [anon_sym_BANG_EQ] = ACTIONS(5175),
    [anon_sym_GT_EQ] = ACTIONS(5175),
    [anon_sym_LT_EQ] = ACTIONS(5175),
    [anon_sym_DOT] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5175),
    [anon_sym_switch] = ACTIONS(5175),
    [anon_sym_when] = ACTIONS(5175),
    [anon_sym_DOT_DOT] = ACTIONS(5175),
    [anon_sym_and] = ACTIONS(5175),
    [anon_sym_or] = ACTIONS(5175),
    [anon_sym_AMP_AMP] = ACTIONS(5175),
    [anon_sym_PIPE_PIPE] = ACTIONS(5175),
    [anon_sym_QMARK_QMARK] = ACTIONS(5175),
    [anon_sym_into] = ACTIONS(5175),
    [anon_sym_on] = ACTIONS(5175),
    [anon_sym_equals] = ACTIONS(5175),
    [anon_sym_by] = ACTIONS(5175),
    [anon_sym_as] = ACTIONS(5175),
    [anon_sym_is] = ACTIONS(5175),
    [anon_sym_DASH_GT] = ACTIONS(5175),
    [anon_sym_with] = ACTIONS(5175),
    [aux_sym_preproc_if_token3] = ACTIONS(5175),
    [aux_sym_preproc_else_token1] = ACTIONS(5175),
    [aux_sym_preproc_elif_token1] = ACTIONS(5175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3379] = {
    [sym_preproc_region] = STATE(3379),
    [sym_preproc_endregion] = STATE(3379),
    [sym_preproc_line] = STATE(3379),
    [sym_preproc_pragma] = STATE(3379),
    [sym_preproc_nullable] = STATE(3379),
    [sym_preproc_error] = STATE(3379),
    [sym_preproc_warning] = STATE(3379),
    [sym_preproc_define] = STATE(3379),
    [sym_preproc_undef] = STATE(3379),
    [anon_sym_EQ] = ACTIONS(5492),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5494),
    [anon_sym_DASH_EQ] = ACTIONS(5494),
    [anon_sym_STAR_EQ] = ACTIONS(5494),
    [anon_sym_SLASH_EQ] = ACTIONS(5494),
    [anon_sym_PERCENT_EQ] = ACTIONS(5494),
    [anon_sym_AMP_EQ] = ACTIONS(5494),
    [anon_sym_CARET_EQ] = ACTIONS(5494),
    [anon_sym_PIPE_EQ] = ACTIONS(5494),
    [anon_sym_LT_LT_EQ] = ACTIONS(5494),
    [anon_sym_GT_GT_EQ] = ACTIONS(5494),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5494),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5494),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3380] = {
    [sym_preproc_region] = STATE(3380),
    [sym_preproc_endregion] = STATE(3380),
    [sym_preproc_line] = STATE(3380),
    [sym_preproc_pragma] = STATE(3380),
    [sym_preproc_nullable] = STATE(3380),
    [sym_preproc_error] = STATE(3380),
    [sym_preproc_warning] = STATE(3380),
    [sym_preproc_define] = STATE(3380),
    [sym_preproc_undef] = STATE(3380),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_in] = ACTIONS(4156),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_GT_GT_GT] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4156),
    [anon_sym_BANG_EQ] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4156),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_EQ_GT] = ACTIONS(4156),
    [anon_sym_switch] = ACTIONS(4156),
    [anon_sym_when] = ACTIONS(4156),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4156),
    [anon_sym_or] = ACTIONS(4156),
    [anon_sym_AMP_AMP] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4156),
    [anon_sym_QMARK_QMARK] = ACTIONS(4156),
    [anon_sym_on] = ACTIONS(4156),
    [anon_sym_equals] = ACTIONS(4156),
    [anon_sym_by] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4156),
    [anon_sym_is] = ACTIONS(4156),
    [anon_sym_DASH_GT] = ACTIONS(4156),
    [anon_sym_with] = ACTIONS(4156),
    [aux_sym_preproc_if_token3] = ACTIONS(4156),
    [aux_sym_preproc_else_token1] = ACTIONS(4156),
    [aux_sym_preproc_elif_token1] = ACTIONS(4156),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3381] = {
    [sym_preproc_region] = STATE(3381),
    [sym_preproc_endregion] = STATE(3381),
    [sym_preproc_line] = STATE(3381),
    [sym_preproc_pragma] = STATE(3381),
    [sym_preproc_nullable] = STATE(3381),
    [sym_preproc_error] = STATE(3381),
    [sym_preproc_warning] = STATE(3381),
    [sym_preproc_define] = STATE(3381),
    [sym_preproc_undef] = STATE(3381),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_COLON] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_in] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_BANG] = ACTIONS(5498),
    [anon_sym_PLUS_PLUS] = ACTIONS(5496),
    [anon_sym_DASH_DASH] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_CARET] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5496),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_GT_GT_GT] = ACTIONS(5496),
    [anon_sym_EQ_EQ] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(5496),
    [anon_sym_GT_EQ] = ACTIONS(5496),
    [anon_sym_LT_EQ] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_switch] = ACTIONS(5496),
    [anon_sym_when] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_and] = ACTIONS(5496),
    [anon_sym_or] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5496),
    [anon_sym_PIPE_PIPE] = ACTIONS(5496),
    [anon_sym_QMARK_QMARK] = ACTIONS(5496),
    [anon_sym_into] = ACTIONS(5496),
    [anon_sym_on] = ACTIONS(5496),
    [anon_sym_equals] = ACTIONS(5496),
    [anon_sym_by] = ACTIONS(5496),
    [anon_sym_as] = ACTIONS(5496),
    [anon_sym_is] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_with] = ACTIONS(5496),
    [aux_sym_preproc_if_token3] = ACTIONS(5496),
    [aux_sym_preproc_else_token1] = ACTIONS(5496),
    [aux_sym_preproc_elif_token1] = ACTIONS(5496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3382] = {
    [sym_preproc_region] = STATE(3382),
    [sym_preproc_endregion] = STATE(3382),
    [sym_preproc_line] = STATE(3382),
    [sym_preproc_pragma] = STATE(3382),
    [sym_preproc_nullable] = STATE(3382),
    [sym_preproc_error] = STATE(3382),
    [sym_preproc_warning] = STATE(3382),
    [sym_preproc_define] = STATE(3382),
    [sym_preproc_undef] = STATE(3382),
    [anon_sym_SEMI] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(5503),
    [anon_sym_GT] = ACTIONS(5503),
    [anon_sym_in] = ACTIONS(4303),
    [anon_sym_QMARK] = ACTIONS(5503),
    [anon_sym_BANG] = ACTIONS(5503),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5503),
    [anon_sym_DASH] = ACTIONS(5503),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5503),
    [anon_sym_AMP] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5503),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_on] = ACTIONS(4295),
    [anon_sym_equals] = ACTIONS(4295),
    [anon_sym_by] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(5500),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_if_token3] = ACTIONS(4295),
    [aux_sym_preproc_else_token1] = ACTIONS(4295),
    [aux_sym_preproc_elif_token1] = ACTIONS(4295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3383] = {
    [sym_preproc_region] = STATE(3383),
    [sym_preproc_endregion] = STATE(3383),
    [sym_preproc_line] = STATE(3383),
    [sym_preproc_pragma] = STATE(3383),
    [sym_preproc_nullable] = STATE(3383),
    [sym_preproc_error] = STATE(3383),
    [sym_preproc_warning] = STATE(3383),
    [sym_preproc_define] = STATE(3383),
    [sym_preproc_undef] = STATE(3383),
    [anon_sym_SEMI] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(5509),
    [anon_sym_GT] = ACTIONS(5509),
    [anon_sym_in] = ACTIONS(4303),
    [anon_sym_QMARK] = ACTIONS(5509),
    [anon_sym_BANG] = ACTIONS(5509),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5509),
    [anon_sym_DASH] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5509),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5509),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5509),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5509),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_on] = ACTIONS(4295),
    [anon_sym_equals] = ACTIONS(4295),
    [anon_sym_by] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(4295),
    [aux_sym_preproc_else_token1] = ACTIONS(4295),
    [aux_sym_preproc_elif_token1] = ACTIONS(4295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3384] = {
    [sym_preproc_region] = STATE(3384),
    [sym_preproc_endregion] = STATE(3384),
    [sym_preproc_line] = STATE(3384),
    [sym_preproc_pragma] = STATE(3384),
    [sym_preproc_nullable] = STATE(3384),
    [sym_preproc_error] = STATE(3384),
    [sym_preproc_warning] = STATE(3384),
    [sym_preproc_define] = STATE(3384),
    [sym_preproc_undef] = STATE(3384),
    [anon_sym_SEMI] = ACTIONS(5007),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5007),
    [anon_sym_COMMA] = ACTIONS(5007),
    [anon_sym_RBRACK] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_LT] = ACTIONS(5009),
    [anon_sym_GT] = ACTIONS(5009),
    [anon_sym_in] = ACTIONS(5009),
    [anon_sym_QMARK] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_PLUS_PLUS] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5007),
    [anon_sym_PLUS] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5009),
    [anon_sym_PERCENT] = ACTIONS(5007),
    [anon_sym_CARET] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_LT_LT] = ACTIONS(5007),
    [anon_sym_GT_GT] = ACTIONS(5009),
    [anon_sym_GT_GT_GT] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(5007),
    [anon_sym_BANG_EQ] = ACTIONS(5007),
    [anon_sym_GT_EQ] = ACTIONS(5007),
    [anon_sym_LT_EQ] = ACTIONS(5007),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_EQ_GT] = ACTIONS(5007),
    [anon_sym_switch] = ACTIONS(5007),
    [anon_sym_when] = ACTIONS(5007),
    [anon_sym_DOT_DOT] = ACTIONS(5007),
    [anon_sym_and] = ACTIONS(5007),
    [anon_sym_or] = ACTIONS(5007),
    [anon_sym_AMP_AMP] = ACTIONS(5007),
    [anon_sym_PIPE_PIPE] = ACTIONS(5007),
    [anon_sym_QMARK_QMARK] = ACTIONS(5007),
    [anon_sym_into] = ACTIONS(5007),
    [anon_sym_on] = ACTIONS(5007),
    [anon_sym_equals] = ACTIONS(5007),
    [anon_sym_by] = ACTIONS(5007),
    [anon_sym_as] = ACTIONS(5007),
    [anon_sym_is] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5007),
    [anon_sym_with] = ACTIONS(5007),
    [aux_sym_preproc_if_token3] = ACTIONS(5007),
    [aux_sym_preproc_else_token1] = ACTIONS(5007),
    [aux_sym_preproc_elif_token1] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3385] = {
    [sym_preproc_region] = STATE(3385),
    [sym_preproc_endregion] = STATE(3385),
    [sym_preproc_line] = STATE(3385),
    [sym_preproc_pragma] = STATE(3385),
    [sym_preproc_nullable] = STATE(3385),
    [sym_preproc_error] = STATE(3385),
    [sym_preproc_warning] = STATE(3385),
    [sym_preproc_define] = STATE(3385),
    [sym_preproc_undef] = STATE(3385),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_LPAREN] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_LT] = ACTIONS(4119),
    [anon_sym_GT] = ACTIONS(4119),
    [anon_sym_in] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_BANG] = ACTIONS(4119),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS] = ACTIONS(4119),
    [anon_sym_DASH] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4119),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4119),
    [anon_sym_AMP] = ACTIONS(4119),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4119),
    [anon_sym_GT_GT_GT] = ACTIONS(4121),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4119),
    [anon_sym_EQ_GT] = ACTIONS(4121),
    [anon_sym_switch] = ACTIONS(4121),
    [anon_sym_when] = ACTIONS(4121),
    [anon_sym_DOT_DOT] = ACTIONS(4121),
    [anon_sym_and] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_QMARK_QMARK] = ACTIONS(4121),
    [anon_sym_on] = ACTIONS(4121),
    [anon_sym_equals] = ACTIONS(4121),
    [anon_sym_by] = ACTIONS(4121),
    [anon_sym_as] = ACTIONS(4121),
    [anon_sym_is] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [anon_sym_with] = ACTIONS(4121),
    [aux_sym_preproc_if_token3] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3386] = {
    [sym_preproc_region] = STATE(3386),
    [sym_preproc_endregion] = STATE(3386),
    [sym_preproc_line] = STATE(3386),
    [sym_preproc_pragma] = STATE(3386),
    [sym_preproc_nullable] = STATE(3386),
    [sym_preproc_error] = STATE(3386),
    [sym_preproc_warning] = STATE(3386),
    [sym_preproc_define] = STATE(3386),
    [sym_preproc_undef] = STATE(3386),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3699),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3697),
    [anon_sym_GT_GT_GT] = ACTIONS(3699),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_GT_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_EQ_GT] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_when] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_and] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3699),
    [anon_sym_AMP_AMP] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(3699),
    [anon_sym_QMARK_QMARK] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_as] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(3699),
    [anon_sym_DASH_GT] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3699),
    [aux_sym_preproc_if_token3] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3387] = {
    [sym_preproc_region] = STATE(3387),
    [sym_preproc_endregion] = STATE(3387),
    [sym_preproc_line] = STATE(3387),
    [sym_preproc_pragma] = STATE(3387),
    [sym_preproc_nullable] = STATE(3387),
    [sym_preproc_error] = STATE(3387),
    [sym_preproc_warning] = STATE(3387),
    [sym_preproc_define] = STATE(3387),
    [sym_preproc_undef] = STATE(3387),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5228),
    [anon_sym_in] = ACTIONS(5228),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_BANG] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5228),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5228),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_when] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_into] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3388] = {
    [sym_preproc_region] = STATE(3388),
    [sym_preproc_endregion] = STATE(3388),
    [sym_preproc_line] = STATE(3388),
    [sym_preproc_pragma] = STATE(3388),
    [sym_preproc_nullable] = STATE(3388),
    [sym_preproc_error] = STATE(3388),
    [sym_preproc_warning] = STATE(3388),
    [sym_preproc_define] = STATE(3388),
    [sym_preproc_undef] = STATE(3388),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5240),
    [anon_sym_in] = ACTIONS(5240),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(5240),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5240),
    [anon_sym_GT_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_switch] = ACTIONS(5238),
    [anon_sym_when] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_QMARK_QMARK] = ACTIONS(5238),
    [anon_sym_into] = ACTIONS(5238),
    [anon_sym_on] = ACTIONS(5238),
    [anon_sym_equals] = ACTIONS(5238),
    [anon_sym_by] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5238),
    [anon_sym_is] = ACTIONS(5238),
    [anon_sym_DASH_GT] = ACTIONS(5238),
    [anon_sym_with] = ACTIONS(5238),
    [aux_sym_preproc_if_token3] = ACTIONS(5238),
    [aux_sym_preproc_else_token1] = ACTIONS(5238),
    [aux_sym_preproc_elif_token1] = ACTIONS(5238),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3389] = {
    [sym_preproc_region] = STATE(3389),
    [sym_preproc_endregion] = STATE(3389),
    [sym_preproc_line] = STATE(3389),
    [sym_preproc_pragma] = STATE(3389),
    [sym_preproc_nullable] = STATE(3389),
    [sym_preproc_error] = STATE(3389),
    [sym_preproc_warning] = STATE(3389),
    [sym_preproc_define] = STATE(3389),
    [sym_preproc_undef] = STATE(3389),
    [anon_sym_SEMI] = ACTIONS(5211),
    [anon_sym_LBRACK] = ACTIONS(5211),
    [anon_sym_COLON] = ACTIONS(5211),
    [anon_sym_COMMA] = ACTIONS(5211),
    [anon_sym_RBRACK] = ACTIONS(5211),
    [anon_sym_LPAREN] = ACTIONS(5211),
    [anon_sym_RPAREN] = ACTIONS(5211),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [anon_sym_LT] = ACTIONS(5213),
    [anon_sym_GT] = ACTIONS(5213),
    [anon_sym_in] = ACTIONS(5213),
    [anon_sym_QMARK] = ACTIONS(5213),
    [anon_sym_BANG] = ACTIONS(5213),
    [anon_sym_PLUS_PLUS] = ACTIONS(5211),
    [anon_sym_DASH_DASH] = ACTIONS(5211),
    [anon_sym_PLUS] = ACTIONS(5213),
    [anon_sym_DASH] = ACTIONS(5213),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_SLASH] = ACTIONS(5213),
    [anon_sym_PERCENT] = ACTIONS(5211),
    [anon_sym_CARET] = ACTIONS(5211),
    [anon_sym_PIPE] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5211),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_GT_GT_GT] = ACTIONS(5211),
    [anon_sym_EQ_EQ] = ACTIONS(5211),
    [anon_sym_BANG_EQ] = ACTIONS(5211),
    [anon_sym_GT_EQ] = ACTIONS(5211),
    [anon_sym_LT_EQ] = ACTIONS(5211),
    [anon_sym_DOT] = ACTIONS(5213),
    [anon_sym_EQ_GT] = ACTIONS(5211),
    [anon_sym_switch] = ACTIONS(5211),
    [anon_sym_when] = ACTIONS(5211),
    [anon_sym_DOT_DOT] = ACTIONS(5211),
    [anon_sym_and] = ACTIONS(5211),
    [anon_sym_or] = ACTIONS(5211),
    [anon_sym_AMP_AMP] = ACTIONS(5211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5211),
    [anon_sym_QMARK_QMARK] = ACTIONS(5211),
    [anon_sym_into] = ACTIONS(5211),
    [anon_sym_on] = ACTIONS(5211),
    [anon_sym_equals] = ACTIONS(5211),
    [anon_sym_by] = ACTIONS(5211),
    [anon_sym_as] = ACTIONS(5211),
    [anon_sym_is] = ACTIONS(5211),
    [anon_sym_DASH_GT] = ACTIONS(5211),
    [anon_sym_with] = ACTIONS(5211),
    [aux_sym_preproc_if_token3] = ACTIONS(5211),
    [aux_sym_preproc_else_token1] = ACTIONS(5211),
    [aux_sym_preproc_elif_token1] = ACTIONS(5211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3390] = {
    [sym_preproc_region] = STATE(3390),
    [sym_preproc_endregion] = STATE(3390),
    [sym_preproc_line] = STATE(3390),
    [sym_preproc_pragma] = STATE(3390),
    [sym_preproc_nullable] = STATE(3390),
    [sym_preproc_error] = STATE(3390),
    [sym_preproc_warning] = STATE(3390),
    [sym_preproc_define] = STATE(3390),
    [sym_preproc_undef] = STATE(3390),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4146),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_BANG] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4146),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4146),
    [anon_sym_AMP] = ACTIONS(4146),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4146),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_switch] = ACTIONS(4148),
    [anon_sym_when] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_QMARK_QMARK] = ACTIONS(4148),
    [anon_sym_on] = ACTIONS(4148),
    [anon_sym_equals] = ACTIONS(4148),
    [anon_sym_by] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4148),
    [anon_sym_is] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_with] = ACTIONS(4148),
    [aux_sym_preproc_if_token3] = ACTIONS(4148),
    [aux_sym_preproc_else_token1] = ACTIONS(4148),
    [aux_sym_preproc_elif_token1] = ACTIONS(4148),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3391] = {
    [sym_preproc_region] = STATE(3391),
    [sym_preproc_endregion] = STATE(3391),
    [sym_preproc_line] = STATE(3391),
    [sym_preproc_pragma] = STATE(3391),
    [sym_preproc_nullable] = STATE(3391),
    [sym_preproc_error] = STATE(3391),
    [sym_preproc_warning] = STATE(3391),
    [sym_preproc_define] = STATE(3391),
    [sym_preproc_undef] = STATE(3391),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_in] = ACTIONS(5390),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_BANG] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5388),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_GT_GT_GT] = ACTIONS(5388),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_EQ_GT] = ACTIONS(5388),
    [anon_sym_switch] = ACTIONS(5388),
    [anon_sym_when] = ACTIONS(5388),
    [anon_sym_DOT_DOT] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_QMARK_QMARK] = ACTIONS(5388),
    [anon_sym_into] = ACTIONS(5388),
    [anon_sym_on] = ACTIONS(5388),
    [anon_sym_equals] = ACTIONS(5388),
    [anon_sym_by] = ACTIONS(5388),
    [anon_sym_as] = ACTIONS(5388),
    [anon_sym_is] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [anon_sym_with] = ACTIONS(5388),
    [aux_sym_preproc_if_token3] = ACTIONS(5388),
    [aux_sym_preproc_else_token1] = ACTIONS(5388),
    [aux_sym_preproc_elif_token1] = ACTIONS(5388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3392] = {
    [sym_preproc_region] = STATE(3392),
    [sym_preproc_endregion] = STATE(3392),
    [sym_preproc_line] = STATE(3392),
    [sym_preproc_pragma] = STATE(3392),
    [sym_preproc_nullable] = STATE(3392),
    [sym_preproc_error] = STATE(3392),
    [sym_preproc_warning] = STATE(3392),
    [sym_preproc_define] = STATE(3392),
    [sym_preproc_undef] = STATE(3392),
    [anon_sym_SEMI] = ACTIONS(4987),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_COLON] = ACTIONS(4987),
    [anon_sym_COMMA] = ACTIONS(4987),
    [anon_sym_RBRACK] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_LT] = ACTIONS(4989),
    [anon_sym_GT] = ACTIONS(4989),
    [anon_sym_in] = ACTIONS(4989),
    [anon_sym_QMARK] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4987),
    [anon_sym_PLUS] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4987),
    [anon_sym_SLASH] = ACTIONS(4989),
    [anon_sym_PERCENT] = ACTIONS(4987),
    [anon_sym_CARET] = ACTIONS(4987),
    [anon_sym_PIPE] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_LT_LT] = ACTIONS(4987),
    [anon_sym_GT_GT] = ACTIONS(4989),
    [anon_sym_GT_GT_GT] = ACTIONS(4987),
    [anon_sym_EQ_EQ] = ACTIONS(4987),
    [anon_sym_BANG_EQ] = ACTIONS(4987),
    [anon_sym_GT_EQ] = ACTIONS(4987),
    [anon_sym_LT_EQ] = ACTIONS(4987),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_EQ_GT] = ACTIONS(4987),
    [anon_sym_switch] = ACTIONS(4987),
    [anon_sym_when] = ACTIONS(4987),
    [anon_sym_DOT_DOT] = ACTIONS(4987),
    [anon_sym_and] = ACTIONS(4987),
    [anon_sym_or] = ACTIONS(4987),
    [anon_sym_AMP_AMP] = ACTIONS(4987),
    [anon_sym_PIPE_PIPE] = ACTIONS(4987),
    [anon_sym_QMARK_QMARK] = ACTIONS(4987),
    [anon_sym_into] = ACTIONS(4987),
    [anon_sym_on] = ACTIONS(4987),
    [anon_sym_equals] = ACTIONS(4987),
    [anon_sym_by] = ACTIONS(4987),
    [anon_sym_as] = ACTIONS(4987),
    [anon_sym_is] = ACTIONS(4987),
    [anon_sym_DASH_GT] = ACTIONS(4987),
    [anon_sym_with] = ACTIONS(4987),
    [aux_sym_preproc_if_token3] = ACTIONS(4987),
    [aux_sym_preproc_else_token1] = ACTIONS(4987),
    [aux_sym_preproc_elif_token1] = ACTIONS(4987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3393] = {
    [sym_preproc_region] = STATE(3393),
    [sym_preproc_endregion] = STATE(3393),
    [sym_preproc_line] = STATE(3393),
    [sym_preproc_pragma] = STATE(3393),
    [sym_preproc_nullable] = STATE(3393),
    [sym_preproc_error] = STATE(3393),
    [sym_preproc_warning] = STATE(3393),
    [sym_preproc_define] = STATE(3393),
    [sym_preproc_undef] = STATE(3393),
    [anon_sym_SEMI] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_COLON] = ACTIONS(5063),
    [anon_sym_COMMA] = ACTIONS(5063),
    [anon_sym_RBRACK] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5063),
    [anon_sym_RPAREN] = ACTIONS(5063),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(5065),
    [anon_sym_GT] = ACTIONS(5065),
    [anon_sym_in] = ACTIONS(5065),
    [anon_sym_QMARK] = ACTIONS(5065),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS_PLUS] = ACTIONS(5063),
    [anon_sym_DASH_DASH] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5063),
    [anon_sym_SLASH] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_CARET] = ACTIONS(5063),
    [anon_sym_PIPE] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5065),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5065),
    [anon_sym_GT_GT_GT] = ACTIONS(5063),
    [anon_sym_EQ_EQ] = ACTIONS(5063),
    [anon_sym_BANG_EQ] = ACTIONS(5063),
    [anon_sym_GT_EQ] = ACTIONS(5063),
    [anon_sym_LT_EQ] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [anon_sym_EQ_GT] = ACTIONS(5063),
    [anon_sym_switch] = ACTIONS(5063),
    [anon_sym_when] = ACTIONS(5063),
    [anon_sym_DOT_DOT] = ACTIONS(5063),
    [anon_sym_and] = ACTIONS(5063),
    [anon_sym_or] = ACTIONS(5063),
    [anon_sym_AMP_AMP] = ACTIONS(5063),
    [anon_sym_PIPE_PIPE] = ACTIONS(5063),
    [anon_sym_QMARK_QMARK] = ACTIONS(5063),
    [anon_sym_into] = ACTIONS(5063),
    [anon_sym_on] = ACTIONS(5063),
    [anon_sym_equals] = ACTIONS(5063),
    [anon_sym_by] = ACTIONS(5063),
    [anon_sym_as] = ACTIONS(5063),
    [anon_sym_is] = ACTIONS(5063),
    [anon_sym_DASH_GT] = ACTIONS(5063),
    [anon_sym_with] = ACTIONS(5063),
    [aux_sym_preproc_if_token3] = ACTIONS(5063),
    [aux_sym_preproc_else_token1] = ACTIONS(5063),
    [aux_sym_preproc_elif_token1] = ACTIONS(5063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3394] = {
    [sym_preproc_region] = STATE(3394),
    [sym_preproc_endregion] = STATE(3394),
    [sym_preproc_line] = STATE(3394),
    [sym_preproc_pragma] = STATE(3394),
    [sym_preproc_nullable] = STATE(3394),
    [sym_preproc_error] = STATE(3394),
    [sym_preproc_warning] = STATE(3394),
    [sym_preproc_define] = STATE(3394),
    [sym_preproc_undef] = STATE(3394),
    [anon_sym_SEMI] = ACTIONS(5203),
    [anon_sym_LBRACK] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_COMMA] = ACTIONS(5203),
    [anon_sym_RBRACK] = ACTIONS(5203),
    [anon_sym_LPAREN] = ACTIONS(5203),
    [anon_sym_RPAREN] = ACTIONS(5203),
    [anon_sym_RBRACE] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5205),
    [anon_sym_in] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_BANG] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5203),
    [anon_sym_DASH_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5205),
    [anon_sym_STAR] = ACTIONS(5203),
    [anon_sym_SLASH] = ACTIONS(5205),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5203),
    [anon_sym_PIPE] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5205),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5205),
    [anon_sym_GT_GT_GT] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5203),
    [anon_sym_BANG_EQ] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5203),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_DOT] = ACTIONS(5205),
    [anon_sym_EQ_GT] = ACTIONS(5203),
    [anon_sym_switch] = ACTIONS(5203),
    [anon_sym_when] = ACTIONS(5203),
    [anon_sym_DOT_DOT] = ACTIONS(5203),
    [anon_sym_and] = ACTIONS(5203),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_AMP_AMP] = ACTIONS(5203),
    [anon_sym_PIPE_PIPE] = ACTIONS(5203),
    [anon_sym_QMARK_QMARK] = ACTIONS(5203),
    [anon_sym_into] = ACTIONS(5203),
    [anon_sym_on] = ACTIONS(5203),
    [anon_sym_equals] = ACTIONS(5203),
    [anon_sym_by] = ACTIONS(5203),
    [anon_sym_as] = ACTIONS(5203),
    [anon_sym_is] = ACTIONS(5203),
    [anon_sym_DASH_GT] = ACTIONS(5203),
    [anon_sym_with] = ACTIONS(5203),
    [aux_sym_preproc_if_token3] = ACTIONS(5203),
    [aux_sym_preproc_else_token1] = ACTIONS(5203),
    [aux_sym_preproc_elif_token1] = ACTIONS(5203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3395] = {
    [sym_preproc_region] = STATE(3395),
    [sym_preproc_endregion] = STATE(3395),
    [sym_preproc_line] = STATE(3395),
    [sym_preproc_pragma] = STATE(3395),
    [sym_preproc_nullable] = STATE(3395),
    [sym_preproc_error] = STATE(3395),
    [sym_preproc_warning] = STATE(3395),
    [sym_preproc_define] = STATE(3395),
    [sym_preproc_undef] = STATE(3395),
    [anon_sym_SEMI] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5207),
    [anon_sym_COLON] = ACTIONS(5207),
    [anon_sym_COMMA] = ACTIONS(5207),
    [anon_sym_RBRACK] = ACTIONS(5207),
    [anon_sym_LPAREN] = ACTIONS(5207),
    [anon_sym_RPAREN] = ACTIONS(5207),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_GT] = ACTIONS(5209),
    [anon_sym_in] = ACTIONS(5209),
    [anon_sym_QMARK] = ACTIONS(5209),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_PLUS_PLUS] = ACTIONS(5207),
    [anon_sym_DASH_DASH] = ACTIONS(5207),
    [anon_sym_PLUS] = ACTIONS(5209),
    [anon_sym_DASH] = ACTIONS(5209),
    [anon_sym_STAR] = ACTIONS(5207),
    [anon_sym_SLASH] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5207),
    [anon_sym_CARET] = ACTIONS(5207),
    [anon_sym_PIPE] = ACTIONS(5209),
    [anon_sym_AMP] = ACTIONS(5209),
    [anon_sym_LT_LT] = ACTIONS(5207),
    [anon_sym_GT_GT] = ACTIONS(5209),
    [anon_sym_GT_GT_GT] = ACTIONS(5207),
    [anon_sym_EQ_EQ] = ACTIONS(5207),
    [anon_sym_BANG_EQ] = ACTIONS(5207),
    [anon_sym_GT_EQ] = ACTIONS(5207),
    [anon_sym_LT_EQ] = ACTIONS(5207),
    [anon_sym_DOT] = ACTIONS(5209),
    [anon_sym_EQ_GT] = ACTIONS(5207),
    [anon_sym_switch] = ACTIONS(5207),
    [anon_sym_when] = ACTIONS(5207),
    [anon_sym_DOT_DOT] = ACTIONS(5207),
    [anon_sym_and] = ACTIONS(5207),
    [anon_sym_or] = ACTIONS(5207),
    [anon_sym_AMP_AMP] = ACTIONS(5207),
    [anon_sym_PIPE_PIPE] = ACTIONS(5207),
    [anon_sym_QMARK_QMARK] = ACTIONS(5207),
    [anon_sym_into] = ACTIONS(5207),
    [anon_sym_on] = ACTIONS(5207),
    [anon_sym_equals] = ACTIONS(5207),
    [anon_sym_by] = ACTIONS(5207),
    [anon_sym_as] = ACTIONS(5207),
    [anon_sym_is] = ACTIONS(5207),
    [anon_sym_DASH_GT] = ACTIONS(5207),
    [anon_sym_with] = ACTIONS(5207),
    [aux_sym_preproc_if_token3] = ACTIONS(5207),
    [aux_sym_preproc_else_token1] = ACTIONS(5207),
    [aux_sym_preproc_elif_token1] = ACTIONS(5207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3396] = {
    [sym_preproc_region] = STATE(3396),
    [sym_preproc_endregion] = STATE(3396),
    [sym_preproc_line] = STATE(3396),
    [sym_preproc_pragma] = STATE(3396),
    [sym_preproc_nullable] = STATE(3396),
    [sym_preproc_error] = STATE(3396),
    [sym_preproc_warning] = STATE(3396),
    [sym_preproc_define] = STATE(3396),
    [sym_preproc_undef] = STATE(3396),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_COLON] = ACTIONS(5512),
    [anon_sym_COMMA] = ACTIONS(5512),
    [anon_sym_RBRACK] = ACTIONS(5512),
    [anon_sym_LPAREN] = ACTIONS(5512),
    [anon_sym_RPAREN] = ACTIONS(5512),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_LT] = ACTIONS(5514),
    [anon_sym_GT] = ACTIONS(5514),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5514),
    [anon_sym_BANG] = ACTIONS(5514),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_SLASH] = ACTIONS(5514),
    [anon_sym_PERCENT] = ACTIONS(5512),
    [anon_sym_CARET] = ACTIONS(5512),
    [anon_sym_PIPE] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym_LT_LT] = ACTIONS(5512),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_GT_GT_GT] = ACTIONS(5512),
    [anon_sym_EQ_EQ] = ACTIONS(5512),
    [anon_sym_BANG_EQ] = ACTIONS(5512),
    [anon_sym_GT_EQ] = ACTIONS(5512),
    [anon_sym_LT_EQ] = ACTIONS(5512),
    [anon_sym_DOT] = ACTIONS(5514),
    [anon_sym_EQ_GT] = ACTIONS(5512),
    [anon_sym_switch] = ACTIONS(5512),
    [anon_sym_when] = ACTIONS(5512),
    [anon_sym_DOT_DOT] = ACTIONS(5512),
    [anon_sym_and] = ACTIONS(5512),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_PIPE_PIPE] = ACTIONS(5512),
    [anon_sym_QMARK_QMARK] = ACTIONS(5512),
    [anon_sym_into] = ACTIONS(5512),
    [anon_sym_on] = ACTIONS(5512),
    [anon_sym_equals] = ACTIONS(5512),
    [anon_sym_by] = ACTIONS(5512),
    [anon_sym_as] = ACTIONS(5512),
    [anon_sym_is] = ACTIONS(5512),
    [anon_sym_DASH_GT] = ACTIONS(5512),
    [anon_sym_with] = ACTIONS(5512),
    [aux_sym_preproc_if_token3] = ACTIONS(5512),
    [aux_sym_preproc_else_token1] = ACTIONS(5512),
    [aux_sym_preproc_elif_token1] = ACTIONS(5512),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3397] = {
    [sym_preproc_region] = STATE(3397),
    [sym_preproc_endregion] = STATE(3397),
    [sym_preproc_line] = STATE(3397),
    [sym_preproc_pragma] = STATE(3397),
    [sym_preproc_nullable] = STATE(3397),
    [sym_preproc_error] = STATE(3397),
    [sym_preproc_warning] = STATE(3397),
    [sym_preproc_define] = STATE(3397),
    [sym_preproc_undef] = STATE(3397),
    [anon_sym_SEMI] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_COLON] = ACTIONS(5051),
    [anon_sym_COMMA] = ACTIONS(5051),
    [anon_sym_RBRACK] = ACTIONS(5051),
    [anon_sym_LPAREN] = ACTIONS(5051),
    [anon_sym_RPAREN] = ACTIONS(5051),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_LT] = ACTIONS(5053),
    [anon_sym_GT] = ACTIONS(5053),
    [anon_sym_in] = ACTIONS(5053),
    [anon_sym_QMARK] = ACTIONS(5053),
    [anon_sym_BANG] = ACTIONS(5053),
    [anon_sym_PLUS_PLUS] = ACTIONS(5051),
    [anon_sym_DASH_DASH] = ACTIONS(5051),
    [anon_sym_PLUS] = ACTIONS(5053),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5051),
    [anon_sym_SLASH] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5051),
    [anon_sym_CARET] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5053),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5053),
    [anon_sym_GT_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5051),
    [anon_sym_BANG_EQ] = ACTIONS(5051),
    [anon_sym_GT_EQ] = ACTIONS(5051),
    [anon_sym_LT_EQ] = ACTIONS(5051),
    [anon_sym_DOT] = ACTIONS(5053),
    [anon_sym_EQ_GT] = ACTIONS(5051),
    [anon_sym_switch] = ACTIONS(5051),
    [anon_sym_when] = ACTIONS(5051),
    [anon_sym_DOT_DOT] = ACTIONS(5051),
    [anon_sym_and] = ACTIONS(5051),
    [anon_sym_or] = ACTIONS(5051),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5051),
    [anon_sym_QMARK_QMARK] = ACTIONS(5051),
    [anon_sym_into] = ACTIONS(5051),
    [anon_sym_on] = ACTIONS(5051),
    [anon_sym_equals] = ACTIONS(5051),
    [anon_sym_by] = ACTIONS(5051),
    [anon_sym_as] = ACTIONS(5051),
    [anon_sym_is] = ACTIONS(5051),
    [anon_sym_DASH_GT] = ACTIONS(5051),
    [anon_sym_with] = ACTIONS(5051),
    [aux_sym_preproc_if_token3] = ACTIONS(5051),
    [aux_sym_preproc_else_token1] = ACTIONS(5051),
    [aux_sym_preproc_elif_token1] = ACTIONS(5051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3398] = {
    [sym_preproc_region] = STATE(3398),
    [sym_preproc_endregion] = STATE(3398),
    [sym_preproc_line] = STATE(3398),
    [sym_preproc_pragma] = STATE(3398),
    [sym_preproc_nullable] = STATE(3398),
    [sym_preproc_error] = STATE(3398),
    [sym_preproc_warning] = STATE(3398),
    [sym_preproc_define] = STATE(3398),
    [sym_preproc_undef] = STATE(3398),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_RPAREN] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3676),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3674),
    [anon_sym_in] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3674),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_PLUS_PLUS] = ACTIONS(3676),
    [anon_sym_DASH_DASH] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3674),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_SLASH] = ACTIONS(3674),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_CARET] = ACTIONS(3676),
    [anon_sym_PIPE] = ACTIONS(3674),
    [anon_sym_AMP] = ACTIONS(3674),
    [anon_sym_LT_LT] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_GT_GT_GT] = ACTIONS(3676),
    [anon_sym_EQ_EQ] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_GT_EQ] = ACTIONS(3676),
    [anon_sym_LT_EQ] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3674),
    [anon_sym_EQ_GT] = ACTIONS(3676),
    [anon_sym_switch] = ACTIONS(3676),
    [anon_sym_when] = ACTIONS(3676),
    [anon_sym_DOT_DOT] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_QMARK_QMARK] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_is] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [aux_sym_preproc_if_token3] = ACTIONS(3676),
    [aux_sym_preproc_else_token1] = ACTIONS(3676),
    [aux_sym_preproc_elif_token1] = ACTIONS(3676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3399] = {
    [sym_preproc_region] = STATE(3399),
    [sym_preproc_endregion] = STATE(3399),
    [sym_preproc_line] = STATE(3399),
    [sym_preproc_pragma] = STATE(3399),
    [sym_preproc_nullable] = STATE(3399),
    [sym_preproc_error] = STATE(3399),
    [sym_preproc_warning] = STATE(3399),
    [sym_preproc_define] = STATE(3399),
    [sym_preproc_undef] = STATE(3399),
    [anon_sym_SEMI] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_COLON] = ACTIONS(4991),
    [anon_sym_COMMA] = ACTIONS(4991),
    [anon_sym_RBRACK] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_RPAREN] = ACTIONS(4991),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_LT] = ACTIONS(4993),
    [anon_sym_GT] = ACTIONS(4993),
    [anon_sym_in] = ACTIONS(4993),
    [anon_sym_QMARK] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4991),
    [anon_sym_PLUS] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4991),
    [anon_sym_SLASH] = ACTIONS(4993),
    [anon_sym_PERCENT] = ACTIONS(4991),
    [anon_sym_CARET] = ACTIONS(4991),
    [anon_sym_PIPE] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_LT_LT] = ACTIONS(4991),
    [anon_sym_GT_GT] = ACTIONS(4993),
    [anon_sym_GT_GT_GT] = ACTIONS(4991),
    [anon_sym_EQ_EQ] = ACTIONS(4991),
    [anon_sym_BANG_EQ] = ACTIONS(4991),
    [anon_sym_GT_EQ] = ACTIONS(4991),
    [anon_sym_LT_EQ] = ACTIONS(4991),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_EQ_GT] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_when] = ACTIONS(4991),
    [anon_sym_DOT_DOT] = ACTIONS(4991),
    [anon_sym_and] = ACTIONS(4991),
    [anon_sym_or] = ACTIONS(4991),
    [anon_sym_AMP_AMP] = ACTIONS(4991),
    [anon_sym_PIPE_PIPE] = ACTIONS(4991),
    [anon_sym_QMARK_QMARK] = ACTIONS(4991),
    [anon_sym_into] = ACTIONS(4991),
    [anon_sym_on] = ACTIONS(4991),
    [anon_sym_equals] = ACTIONS(4991),
    [anon_sym_by] = ACTIONS(4991),
    [anon_sym_as] = ACTIONS(4991),
    [anon_sym_is] = ACTIONS(4991),
    [anon_sym_DASH_GT] = ACTIONS(4991),
    [anon_sym_with] = ACTIONS(4991),
    [aux_sym_preproc_if_token3] = ACTIONS(4991),
    [aux_sym_preproc_else_token1] = ACTIONS(4991),
    [aux_sym_preproc_elif_token1] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3400] = {
    [sym_preproc_region] = STATE(3400),
    [sym_preproc_endregion] = STATE(3400),
    [sym_preproc_line] = STATE(3400),
    [sym_preproc_pragma] = STATE(3400),
    [sym_preproc_nullable] = STATE(3400),
    [sym_preproc_error] = STATE(3400),
    [sym_preproc_warning] = STATE(3400),
    [sym_preproc_define] = STATE(3400),
    [sym_preproc_undef] = STATE(3400),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACK] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_RPAREN] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5115),
    [anon_sym_in] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5115),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_PIPE] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_GT_GT_GT] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5113),
    [anon_sym_BANG_EQ] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5113),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_DOT] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5113),
    [anon_sym_switch] = ACTIONS(5113),
    [anon_sym_when] = ACTIONS(5113),
    [anon_sym_DOT_DOT] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5113),
    [anon_sym_QMARK_QMARK] = ACTIONS(5113),
    [anon_sym_on] = ACTIONS(5113),
    [anon_sym_equals] = ACTIONS(5113),
    [anon_sym_by] = ACTIONS(5113),
    [anon_sym_as] = ACTIONS(5113),
    [anon_sym_is] = ACTIONS(5113),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [anon_sym_with] = ACTIONS(5113),
    [aux_sym_preproc_if_token3] = ACTIONS(5113),
    [aux_sym_preproc_else_token1] = ACTIONS(5113),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3401] = {
    [sym_preproc_region] = STATE(3401),
    [sym_preproc_endregion] = STATE(3401),
    [sym_preproc_line] = STATE(3401),
    [sym_preproc_pragma] = STATE(3401),
    [sym_preproc_nullable] = STATE(3401),
    [sym_preproc_error] = STATE(3401),
    [sym_preproc_warning] = STATE(3401),
    [sym_preproc_define] = STATE(3401),
    [sym_preproc_undef] = STATE(3401),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_LPAREN] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_LT] = ACTIONS(5435),
    [anon_sym_GT] = ACTIONS(5435),
    [anon_sym_in] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5435),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(5435),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5435),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5435),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5435),
    [anon_sym_GT_GT_GT] = ACTIONS(5433),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5435),
    [anon_sym_EQ_GT] = ACTIONS(5433),
    [anon_sym_switch] = ACTIONS(5433),
    [anon_sym_when] = ACTIONS(5433),
    [anon_sym_DOT_DOT] = ACTIONS(5433),
    [anon_sym_and] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_QMARK_QMARK] = ACTIONS(5433),
    [anon_sym_on] = ACTIONS(5433),
    [anon_sym_equals] = ACTIONS(5433),
    [anon_sym_by] = ACTIONS(5433),
    [anon_sym_as] = ACTIONS(5433),
    [anon_sym_is] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [anon_sym_with] = ACTIONS(5433),
    [aux_sym_preproc_if_token3] = ACTIONS(5433),
    [aux_sym_preproc_else_token1] = ACTIONS(5433),
    [aux_sym_preproc_elif_token1] = ACTIONS(5433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3402] = {
    [sym_preproc_region] = STATE(3402),
    [sym_preproc_endregion] = STATE(3402),
    [sym_preproc_line] = STATE(3402),
    [sym_preproc_pragma] = STATE(3402),
    [sym_preproc_nullable] = STATE(3402),
    [sym_preproc_error] = STATE(3402),
    [sym_preproc_warning] = STATE(3402),
    [sym_preproc_define] = STATE(3402),
    [sym_preproc_undef] = STATE(3402),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_COLON] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_RBRACK] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_RPAREN] = ACTIONS(5425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(5427),
    [anon_sym_GT] = ACTIONS(5427),
    [anon_sym_in] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(5427),
    [anon_sym_DASH] = ACTIONS(5427),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(5427),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(5427),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_GT_GT] = ACTIONS(5427),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_DOT] = ACTIONS(5427),
    [anon_sym_EQ_GT] = ACTIONS(5425),
    [anon_sym_switch] = ACTIONS(5425),
    [anon_sym_when] = ACTIONS(5425),
    [anon_sym_DOT_DOT] = ACTIONS(5425),
    [anon_sym_and] = ACTIONS(5425),
    [anon_sym_or] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_QMARK_QMARK] = ACTIONS(5425),
    [anon_sym_on] = ACTIONS(5425),
    [anon_sym_equals] = ACTIONS(5425),
    [anon_sym_by] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5425),
    [anon_sym_is] = ACTIONS(5425),
    [anon_sym_DASH_GT] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(5425),
    [aux_sym_preproc_if_token3] = ACTIONS(5425),
    [aux_sym_preproc_else_token1] = ACTIONS(5425),
    [aux_sym_preproc_elif_token1] = ACTIONS(5425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3403] = {
    [sym_preproc_region] = STATE(3403),
    [sym_preproc_endregion] = STATE(3403),
    [sym_preproc_line] = STATE(3403),
    [sym_preproc_pragma] = STATE(3403),
    [sym_preproc_nullable] = STATE(3403),
    [sym_preproc_error] = STATE(3403),
    [sym_preproc_warning] = STATE(3403),
    [sym_preproc_define] = STATE(3403),
    [sym_preproc_undef] = STATE(3403),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym_LBRACK] = ACTIONS(5429),
    [anon_sym_COLON] = ACTIONS(5429),
    [anon_sym_COMMA] = ACTIONS(5429),
    [anon_sym_RBRACK] = ACTIONS(5429),
    [anon_sym_LPAREN] = ACTIONS(5429),
    [anon_sym_RPAREN] = ACTIONS(5429),
    [anon_sym_RBRACE] = ACTIONS(5429),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_in] = ACTIONS(5429),
    [anon_sym_QMARK] = ACTIONS(5431),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS_PLUS] = ACTIONS(5429),
    [anon_sym_DASH_DASH] = ACTIONS(5429),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_CARET] = ACTIONS(5429),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5429),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_GT_GT_GT] = ACTIONS(5429),
    [anon_sym_EQ_EQ] = ACTIONS(5429),
    [anon_sym_BANG_EQ] = ACTIONS(5429),
    [anon_sym_GT_EQ] = ACTIONS(5429),
    [anon_sym_LT_EQ] = ACTIONS(5429),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_EQ_GT] = ACTIONS(5429),
    [anon_sym_switch] = ACTIONS(5429),
    [anon_sym_when] = ACTIONS(5429),
    [anon_sym_DOT_DOT] = ACTIONS(5429),
    [anon_sym_and] = ACTIONS(5429),
    [anon_sym_or] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_PIPE_PIPE] = ACTIONS(5429),
    [anon_sym_QMARK_QMARK] = ACTIONS(5429),
    [anon_sym_on] = ACTIONS(5429),
    [anon_sym_equals] = ACTIONS(5429),
    [anon_sym_by] = ACTIONS(5429),
    [anon_sym_as] = ACTIONS(5429),
    [anon_sym_is] = ACTIONS(5429),
    [anon_sym_DASH_GT] = ACTIONS(5429),
    [anon_sym_with] = ACTIONS(5429),
    [aux_sym_preproc_if_token3] = ACTIONS(5429),
    [aux_sym_preproc_else_token1] = ACTIONS(5429),
    [aux_sym_preproc_elif_token1] = ACTIONS(5429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3404] = {
    [sym_preproc_region] = STATE(3404),
    [sym_preproc_endregion] = STATE(3404),
    [sym_preproc_line] = STATE(3404),
    [sym_preproc_pragma] = STATE(3404),
    [sym_preproc_nullable] = STATE(3404),
    [sym_preproc_error] = STATE(3404),
    [sym_preproc_warning] = STATE(3404),
    [sym_preproc_define] = STATE(3404),
    [sym_preproc_undef] = STATE(3404),
    [anon_sym_SEMI] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_COLON] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RBRACK] = ACTIONS(5187),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_in] = ACTIONS(5187),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5187),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5187),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT_EQ] = ACTIONS(5187),
    [anon_sym_LT_EQ] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_EQ_GT] = ACTIONS(5187),
    [anon_sym_switch] = ACTIONS(5187),
    [anon_sym_when] = ACTIONS(5187),
    [anon_sym_DOT_DOT] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_QMARK_QMARK] = ACTIONS(5187),
    [anon_sym_on] = ACTIONS(5187),
    [anon_sym_equals] = ACTIONS(5187),
    [anon_sym_by] = ACTIONS(5187),
    [anon_sym_as] = ACTIONS(5187),
    [anon_sym_is] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [anon_sym_with] = ACTIONS(5187),
    [aux_sym_preproc_if_token3] = ACTIONS(5187),
    [aux_sym_preproc_else_token1] = ACTIONS(5187),
    [aux_sym_preproc_elif_token1] = ACTIONS(5187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3405] = {
    [sym_preproc_region] = STATE(3405),
    [sym_preproc_endregion] = STATE(3405),
    [sym_preproc_line] = STATE(3405),
    [sym_preproc_pragma] = STATE(3405),
    [sym_preproc_nullable] = STATE(3405),
    [sym_preproc_error] = STATE(3405),
    [sym_preproc_warning] = STATE(3405),
    [sym_preproc_define] = STATE(3405),
    [sym_preproc_undef] = STATE(3405),
    [anon_sym_SEMI] = ACTIONS(5218),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [anon_sym_COLON] = ACTIONS(5218),
    [anon_sym_COMMA] = ACTIONS(5218),
    [anon_sym_RBRACK] = ACTIONS(5218),
    [anon_sym_LPAREN] = ACTIONS(5218),
    [anon_sym_RPAREN] = ACTIONS(5218),
    [anon_sym_RBRACE] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5220),
    [anon_sym_in] = ACTIONS(5218),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_BANG] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5218),
    [anon_sym_DASH_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5220),
    [anon_sym_STAR] = ACTIONS(5218),
    [anon_sym_SLASH] = ACTIONS(5220),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5218),
    [anon_sym_PIPE] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_GT_GT_GT] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5218),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_DOT] = ACTIONS(5220),
    [anon_sym_EQ_GT] = ACTIONS(5218),
    [anon_sym_switch] = ACTIONS(5218),
    [anon_sym_when] = ACTIONS(5218),
    [anon_sym_DOT_DOT] = ACTIONS(5218),
    [anon_sym_and] = ACTIONS(5218),
    [anon_sym_or] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_QMARK_QMARK] = ACTIONS(5218),
    [anon_sym_on] = ACTIONS(5218),
    [anon_sym_equals] = ACTIONS(5218),
    [anon_sym_by] = ACTIONS(5218),
    [anon_sym_as] = ACTIONS(5218),
    [anon_sym_is] = ACTIONS(5218),
    [anon_sym_DASH_GT] = ACTIONS(5218),
    [anon_sym_with] = ACTIONS(5218),
    [aux_sym_preproc_if_token3] = ACTIONS(5218),
    [aux_sym_preproc_else_token1] = ACTIONS(5218),
    [aux_sym_preproc_elif_token1] = ACTIONS(5218),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3406] = {
    [sym_preproc_region] = STATE(3406),
    [sym_preproc_endregion] = STATE(3406),
    [sym_preproc_line] = STATE(3406),
    [sym_preproc_pragma] = STATE(3406),
    [sym_preproc_nullable] = STATE(3406),
    [sym_preproc_error] = STATE(3406),
    [sym_preproc_warning] = STATE(3406),
    [sym_preproc_define] = STATE(3406),
    [sym_preproc_undef] = STATE(3406),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5167),
    [anon_sym_COLON] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RBRACK] = ACTIONS(5167),
    [anon_sym_LPAREN] = ACTIONS(5167),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_in] = ACTIONS(5167),
    [anon_sym_QMARK] = ACTIONS(5169),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS_PLUS] = ACTIONS(5167),
    [anon_sym_DASH_DASH] = ACTIONS(5167),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5167),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5167),
    [anon_sym_CARET] = ACTIONS(5167),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5167),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_GT_GT_GT] = ACTIONS(5167),
    [anon_sym_EQ_EQ] = ACTIONS(5167),
    [anon_sym_BANG_EQ] = ACTIONS(5167),
    [anon_sym_GT_EQ] = ACTIONS(5167),
    [anon_sym_LT_EQ] = ACTIONS(5167),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_EQ_GT] = ACTIONS(5167),
    [anon_sym_switch] = ACTIONS(5167),
    [anon_sym_when] = ACTIONS(5167),
    [anon_sym_DOT_DOT] = ACTIONS(5167),
    [anon_sym_and] = ACTIONS(5167),
    [anon_sym_or] = ACTIONS(5167),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_QMARK_QMARK] = ACTIONS(5167),
    [anon_sym_on] = ACTIONS(5167),
    [anon_sym_equals] = ACTIONS(5167),
    [anon_sym_by] = ACTIONS(5167),
    [anon_sym_as] = ACTIONS(5167),
    [anon_sym_is] = ACTIONS(5167),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5167),
    [aux_sym_preproc_if_token3] = ACTIONS(5167),
    [aux_sym_preproc_else_token1] = ACTIONS(5167),
    [aux_sym_preproc_elif_token1] = ACTIONS(5167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3407] = {
    [sym_preproc_region] = STATE(3407),
    [sym_preproc_endregion] = STATE(3407),
    [sym_preproc_line] = STATE(3407),
    [sym_preproc_pragma] = STATE(3407),
    [sym_preproc_nullable] = STATE(3407),
    [sym_preproc_error] = STATE(3407),
    [sym_preproc_warning] = STATE(3407),
    [sym_preproc_define] = STATE(3407),
    [sym_preproc_undef] = STATE(3407),
    [anon_sym_SEMI] = ACTIONS(5153),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_COLON] = ACTIONS(5153),
    [anon_sym_COMMA] = ACTIONS(5153),
    [anon_sym_RBRACK] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_RPAREN] = ACTIONS(5153),
    [anon_sym_RBRACE] = ACTIONS(5153),
    [anon_sym_LT] = ACTIONS(5155),
    [anon_sym_GT] = ACTIONS(5155),
    [anon_sym_in] = ACTIONS(5153),
    [anon_sym_QMARK] = ACTIONS(5155),
    [anon_sym_BANG] = ACTIONS(5155),
    [anon_sym_PLUS_PLUS] = ACTIONS(5153),
    [anon_sym_DASH_DASH] = ACTIONS(5153),
    [anon_sym_PLUS] = ACTIONS(5155),
    [anon_sym_DASH] = ACTIONS(5155),
    [anon_sym_STAR] = ACTIONS(5153),
    [anon_sym_SLASH] = ACTIONS(5155),
    [anon_sym_PERCENT] = ACTIONS(5153),
    [anon_sym_CARET] = ACTIONS(5153),
    [anon_sym_PIPE] = ACTIONS(5155),
    [anon_sym_AMP] = ACTIONS(5155),
    [anon_sym_LT_LT] = ACTIONS(5153),
    [anon_sym_GT_GT] = ACTIONS(5155),
    [anon_sym_GT_GT_GT] = ACTIONS(5153),
    [anon_sym_EQ_EQ] = ACTIONS(5153),
    [anon_sym_BANG_EQ] = ACTIONS(5153),
    [anon_sym_GT_EQ] = ACTIONS(5153),
    [anon_sym_LT_EQ] = ACTIONS(5153),
    [anon_sym_DOT] = ACTIONS(5155),
    [anon_sym_EQ_GT] = ACTIONS(5153),
    [anon_sym_switch] = ACTIONS(5153),
    [anon_sym_when] = ACTIONS(5153),
    [anon_sym_DOT_DOT] = ACTIONS(5153),
    [anon_sym_and] = ACTIONS(5153),
    [anon_sym_or] = ACTIONS(5153),
    [anon_sym_AMP_AMP] = ACTIONS(5153),
    [anon_sym_PIPE_PIPE] = ACTIONS(5153),
    [anon_sym_QMARK_QMARK] = ACTIONS(5153),
    [anon_sym_on] = ACTIONS(5153),
    [anon_sym_equals] = ACTIONS(5153),
    [anon_sym_by] = ACTIONS(5153),
    [anon_sym_as] = ACTIONS(5153),
    [anon_sym_is] = ACTIONS(5153),
    [anon_sym_DASH_GT] = ACTIONS(5153),
    [anon_sym_with] = ACTIONS(5153),
    [aux_sym_preproc_if_token3] = ACTIONS(5153),
    [aux_sym_preproc_else_token1] = ACTIONS(5153),
    [aux_sym_preproc_elif_token1] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3408] = {
    [sym_preproc_region] = STATE(3408),
    [sym_preproc_endregion] = STATE(3408),
    [sym_preproc_line] = STATE(3408),
    [sym_preproc_pragma] = STATE(3408),
    [sym_preproc_nullable] = STATE(3408),
    [sym_preproc_error] = STATE(3408),
    [sym_preproc_warning] = STATE(3408),
    [sym_preproc_define] = STATE(3408),
    [sym_preproc_undef] = STATE(3408),
    [anon_sym_SEMI] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(5503),
    [anon_sym_GT] = ACTIONS(5503),
    [anon_sym_in] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(5503),
    [anon_sym_BANG] = ACTIONS(5503),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5503),
    [anon_sym_DASH] = ACTIONS(5503),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5503),
    [anon_sym_AMP] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5503),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_on] = ACTIONS(4295),
    [anon_sym_equals] = ACTIONS(4295),
    [anon_sym_by] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(5500),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_if_token3] = ACTIONS(4295),
    [aux_sym_preproc_else_token1] = ACTIONS(4295),
    [aux_sym_preproc_elif_token1] = ACTIONS(4295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3409] = {
    [sym_preproc_region] = STATE(3409),
    [sym_preproc_endregion] = STATE(3409),
    [sym_preproc_line] = STATE(3409),
    [sym_preproc_pragma] = STATE(3409),
    [sym_preproc_nullable] = STATE(3409),
    [sym_preproc_error] = STATE(3409),
    [sym_preproc_warning] = STATE(3409),
    [sym_preproc_define] = STATE(3409),
    [sym_preproc_undef] = STATE(3409),
    [anon_sym_SEMI] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(5509),
    [anon_sym_GT] = ACTIONS(5509),
    [anon_sym_in] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(5509),
    [anon_sym_BANG] = ACTIONS(5509),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5509),
    [anon_sym_DASH] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5509),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5509),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5509),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5509),
    [anon_sym_EQ_GT] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(4295),
    [anon_sym_equals] = ACTIONS(4295),
    [anon_sym_by] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(4295),
    [aux_sym_preproc_else_token1] = ACTIONS(4295),
    [aux_sym_preproc_elif_token1] = ACTIONS(4295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3410] = {
    [sym_preproc_region] = STATE(3410),
    [sym_preproc_endregion] = STATE(3410),
    [sym_preproc_line] = STATE(3410),
    [sym_preproc_pragma] = STATE(3410),
    [sym_preproc_nullable] = STATE(3410),
    [sym_preproc_error] = STATE(3410),
    [sym_preproc_warning] = STATE(3410),
    [sym_preproc_define] = STATE(3410),
    [sym_preproc_undef] = STATE(3410),
    [anon_sym_SEMI] = ACTIONS(5175),
    [anon_sym_LBRACK] = ACTIONS(5175),
    [anon_sym_COLON] = ACTIONS(5175),
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_RBRACK] = ACTIONS(5175),
    [anon_sym_LPAREN] = ACTIONS(5175),
    [anon_sym_RPAREN] = ACTIONS(5175),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_LT] = ACTIONS(5177),
    [anon_sym_GT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5175),
    [anon_sym_QMARK] = ACTIONS(5177),
    [anon_sym_BANG] = ACTIONS(5177),
    [anon_sym_PLUS_PLUS] = ACTIONS(5175),
    [anon_sym_DASH_DASH] = ACTIONS(5175),
    [anon_sym_PLUS] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5175),
    [anon_sym_SLASH] = ACTIONS(5177),
    [anon_sym_PERCENT] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5175),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5175),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_GT_GT_GT] = ACTIONS(5175),
    [anon_sym_EQ_EQ] = ACTIONS(5175),
    [anon_sym_BANG_EQ] = ACTIONS(5175),
    [anon_sym_GT_EQ] = ACTIONS(5175),
    [anon_sym_LT_EQ] = ACTIONS(5175),
    [anon_sym_DOT] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5175),
    [anon_sym_switch] = ACTIONS(5175),
    [anon_sym_when] = ACTIONS(5175),
    [anon_sym_DOT_DOT] = ACTIONS(5175),
    [anon_sym_and] = ACTIONS(5175),
    [anon_sym_or] = ACTIONS(5175),
    [anon_sym_AMP_AMP] = ACTIONS(5175),
    [anon_sym_PIPE_PIPE] = ACTIONS(5175),
    [anon_sym_QMARK_QMARK] = ACTIONS(5175),
    [anon_sym_on] = ACTIONS(5175),
    [anon_sym_equals] = ACTIONS(5175),
    [anon_sym_by] = ACTIONS(5175),
    [anon_sym_as] = ACTIONS(5175),
    [anon_sym_is] = ACTIONS(5175),
    [anon_sym_DASH_GT] = ACTIONS(5175),
    [anon_sym_with] = ACTIONS(5175),
    [aux_sym_preproc_if_token3] = ACTIONS(5175),
    [aux_sym_preproc_else_token1] = ACTIONS(5175),
    [aux_sym_preproc_elif_token1] = ACTIONS(5175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3411] = {
    [sym_preproc_region] = STATE(3411),
    [sym_preproc_endregion] = STATE(3411),
    [sym_preproc_line] = STATE(3411),
    [sym_preproc_pragma] = STATE(3411),
    [sym_preproc_nullable] = STATE(3411),
    [sym_preproc_error] = STATE(3411),
    [sym_preproc_warning] = STATE(3411),
    [sym_preproc_define] = STATE(3411),
    [sym_preproc_undef] = STATE(3411),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4898),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4898),
    [anon_sym_CARET] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3412] = {
    [sym_preproc_region] = STATE(3412),
    [sym_preproc_endregion] = STATE(3412),
    [sym_preproc_line] = STATE(3412),
    [sym_preproc_pragma] = STATE(3412),
    [sym_preproc_nullable] = STATE(3412),
    [sym_preproc_error] = STATE(3412),
    [sym_preproc_warning] = STATE(3412),
    [sym_preproc_define] = STATE(3412),
    [sym_preproc_undef] = STATE(3412),
    [anon_sym_SEMI] = ACTIONS(5171),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5171),
    [anon_sym_COMMA] = ACTIONS(5171),
    [anon_sym_RBRACK] = ACTIONS(5171),
    [anon_sym_LPAREN] = ACTIONS(5171),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5173),
    [anon_sym_in] = ACTIONS(5171),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5173),
    [anon_sym_PERCENT] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5173),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5173),
    [anon_sym_GT_GT_GT] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5171),
    [anon_sym_BANG_EQ] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5171),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_DOT] = ACTIONS(5173),
    [anon_sym_EQ_GT] = ACTIONS(5171),
    [anon_sym_switch] = ACTIONS(5171),
    [anon_sym_when] = ACTIONS(5171),
    [anon_sym_DOT_DOT] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_or] = ACTIONS(5171),
    [anon_sym_AMP_AMP] = ACTIONS(5171),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_QMARK_QMARK] = ACTIONS(5171),
    [anon_sym_on] = ACTIONS(5171),
    [anon_sym_equals] = ACTIONS(5171),
    [anon_sym_by] = ACTIONS(5171),
    [anon_sym_as] = ACTIONS(5171),
    [anon_sym_is] = ACTIONS(5171),
    [anon_sym_DASH_GT] = ACTIONS(5171),
    [anon_sym_with] = ACTIONS(5171),
    [aux_sym_preproc_if_token3] = ACTIONS(5171),
    [aux_sym_preproc_else_token1] = ACTIONS(5171),
    [aux_sym_preproc_elif_token1] = ACTIONS(5171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3413] = {
    [sym_preproc_region] = STATE(3413),
    [sym_preproc_endregion] = STATE(3413),
    [sym_preproc_line] = STATE(3413),
    [sym_preproc_pragma] = STATE(3413),
    [sym_preproc_nullable] = STATE(3413),
    [sym_preproc_error] = STATE(3413),
    [sym_preproc_warning] = STATE(3413),
    [sym_preproc_define] = STATE(3413),
    [sym_preproc_undef] = STATE(3413),
    [anon_sym_SEMI] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_RBRACK] = ACTIONS(5179),
    [anon_sym_LPAREN] = ACTIONS(5179),
    [anon_sym_RPAREN] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_in] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_BANG] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5181),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5181),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_GT_GT_GT] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_DOT] = ACTIONS(5181),
    [anon_sym_EQ_GT] = ACTIONS(5179),
    [anon_sym_switch] = ACTIONS(5179),
    [anon_sym_when] = ACTIONS(5179),
    [anon_sym_DOT_DOT] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_AMP_AMP] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5179),
    [anon_sym_QMARK_QMARK] = ACTIONS(5179),
    [anon_sym_on] = ACTIONS(5179),
    [anon_sym_equals] = ACTIONS(5179),
    [anon_sym_by] = ACTIONS(5179),
    [anon_sym_as] = ACTIONS(5179),
    [anon_sym_is] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5179),
    [anon_sym_with] = ACTIONS(5179),
    [aux_sym_preproc_if_token3] = ACTIONS(5179),
    [aux_sym_preproc_else_token1] = ACTIONS(5179),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3414] = {
    [sym_preproc_region] = STATE(3414),
    [sym_preproc_endregion] = STATE(3414),
    [sym_preproc_line] = STATE(3414),
    [sym_preproc_pragma] = STATE(3414),
    [sym_preproc_nullable] = STATE(3414),
    [sym_preproc_error] = STATE(3414),
    [sym_preproc_warning] = STATE(3414),
    [sym_preproc_define] = STATE(3414),
    [sym_preproc_undef] = STATE(3414),
    [sym__identifier_token] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3251),
    [anon_sym_alias] = ACTIONS(3251),
    [anon_sym_global] = ACTIONS(3251),
    [anon_sym_unsafe] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3253),
    [anon_sym_RBRACE] = ACTIONS(3253),
    [anon_sym_abstract] = ACTIONS(3251),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3251),
    [anon_sym_file] = ACTIONS(3251),
    [anon_sym_fixed] = ACTIONS(3251),
    [anon_sym_internal] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3251),
    [anon_sym_override] = ACTIONS(3251),
    [anon_sym_partial] = ACTIONS(3251),
    [anon_sym_private] = ACTIONS(3251),
    [anon_sym_protected] = ACTIONS(3251),
    [anon_sym_public] = ACTIONS(3251),
    [anon_sym_readonly] = ACTIONS(3251),
    [anon_sym_required] = ACTIONS(3251),
    [anon_sym_sealed] = ACTIONS(3251),
    [anon_sym_virtual] = ACTIONS(3251),
    [anon_sym_volatile] = ACTIONS(3251),
    [anon_sym_where] = ACTIONS(3251),
    [anon_sym_notnull] = ACTIONS(3251),
    [anon_sym_unmanaged] = ACTIONS(3251),
    [anon_sym_get] = ACTIONS(3251),
    [anon_sym_set] = ACTIONS(3251),
    [anon_sym_add] = ACTIONS(3251),
    [anon_sym_remove] = ACTIONS(3251),
    [anon_sym_init] = ACTIONS(3251),
    [anon_sym_scoped] = ACTIONS(3251),
    [anon_sym_var] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3251),
    [anon_sym_when] = ACTIONS(3251),
    [anon_sym_from] = ACTIONS(3251),
    [anon_sym_into] = ACTIONS(3251),
    [anon_sym_join] = ACTIONS(3251),
    [anon_sym_on] = ACTIONS(3251),
    [anon_sym_equals] = ACTIONS(3251),
    [anon_sym_let] = ACTIONS(3251),
    [anon_sym_orderby] = ACTIONS(3251),
    [anon_sym_ascending] = ACTIONS(3251),
    [anon_sym_descending] = ACTIONS(3251),
    [anon_sym_group] = ACTIONS(3251),
    [anon_sym_by] = ACTIONS(3251),
    [anon_sym_select] = ACTIONS(3251),
    [aux_sym_preproc_if_token1] = ACTIONS(3253),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3415] = {
    [sym_preproc_region] = STATE(3415),
    [sym_preproc_endregion] = STATE(3415),
    [sym_preproc_line] = STATE(3415),
    [sym_preproc_pragma] = STATE(3415),
    [sym_preproc_nullable] = STATE(3415),
    [sym_preproc_error] = STATE(3415),
    [sym_preproc_warning] = STATE(3415),
    [sym_preproc_define] = STATE(3415),
    [sym_preproc_undef] = STATE(3415),
    [sym__identifier_token] = ACTIONS(3255),
    [anon_sym_extern] = ACTIONS(3255),
    [anon_sym_alias] = ACTIONS(3255),
    [anon_sym_global] = ACTIONS(3255),
    [anon_sym_unsafe] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_RBRACE] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_file] = ACTIONS(3255),
    [anon_sym_fixed] = ACTIONS(3255),
    [anon_sym_internal] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_partial] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_required] = ACTIONS(3255),
    [anon_sym_sealed] = ACTIONS(3255),
    [anon_sym_virtual] = ACTIONS(3255),
    [anon_sym_volatile] = ACTIONS(3255),
    [anon_sym_where] = ACTIONS(3255),
    [anon_sym_notnull] = ACTIONS(3255),
    [anon_sym_unmanaged] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_add] = ACTIONS(3255),
    [anon_sym_remove] = ACTIONS(3255),
    [anon_sym_init] = ACTIONS(3255),
    [anon_sym_scoped] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_when] = ACTIONS(3255),
    [anon_sym_from] = ACTIONS(3255),
    [anon_sym_into] = ACTIONS(3255),
    [anon_sym_join] = ACTIONS(3255),
    [anon_sym_on] = ACTIONS(3255),
    [anon_sym_equals] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_orderby] = ACTIONS(3255),
    [anon_sym_ascending] = ACTIONS(3255),
    [anon_sym_descending] = ACTIONS(3255),
    [anon_sym_group] = ACTIONS(3255),
    [anon_sym_by] = ACTIONS(3255),
    [anon_sym_select] = ACTIONS(3255),
    [aux_sym_preproc_if_token1] = ACTIONS(3257),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3416] = {
    [sym_preproc_region] = STATE(3416),
    [sym_preproc_endregion] = STATE(3416),
    [sym_preproc_line] = STATE(3416),
    [sym_preproc_pragma] = STATE(3416),
    [sym_preproc_nullable] = STATE(3416),
    [sym_preproc_error] = STATE(3416),
    [sym_preproc_warning] = STATE(3416),
    [sym_preproc_define] = STATE(3416),
    [sym_preproc_undef] = STATE(3416),
    [anon_sym_SEMI] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_COLON] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RBRACK] = ACTIONS(5199),
    [anon_sym_LPAREN] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_LT] = ACTIONS(5201),
    [anon_sym_GT] = ACTIONS(5201),
    [anon_sym_in] = ACTIONS(5199),
    [anon_sym_QMARK] = ACTIONS(5201),
    [anon_sym_BANG] = ACTIONS(5201),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_STAR] = ACTIONS(5199),
    [anon_sym_SLASH] = ACTIONS(5201),
    [anon_sym_PERCENT] = ACTIONS(5199),
    [anon_sym_CARET] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5201),
    [anon_sym_AMP] = ACTIONS(5201),
    [anon_sym_LT_LT] = ACTIONS(5199),
    [anon_sym_GT_GT] = ACTIONS(5201),
    [anon_sym_GT_GT_GT] = ACTIONS(5199),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5201),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_switch] = ACTIONS(5199),
    [anon_sym_when] = ACTIONS(5199),
    [anon_sym_DOT_DOT] = ACTIONS(5199),
    [anon_sym_and] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_QMARK_QMARK] = ACTIONS(5199),
    [anon_sym_on] = ACTIONS(5199),
    [anon_sym_equals] = ACTIONS(5199),
    [anon_sym_by] = ACTIONS(5199),
    [anon_sym_as] = ACTIONS(5199),
    [anon_sym_is] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_with] = ACTIONS(5199),
    [aux_sym_preproc_if_token3] = ACTIONS(5199),
    [aux_sym_preproc_else_token1] = ACTIONS(5199),
    [aux_sym_preproc_elif_token1] = ACTIONS(5199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3417] = {
    [sym_preproc_region] = STATE(3417),
    [sym_preproc_endregion] = STATE(3417),
    [sym_preproc_line] = STATE(3417),
    [sym_preproc_pragma] = STATE(3417),
    [sym_preproc_nullable] = STATE(3417),
    [sym_preproc_error] = STATE(3417),
    [sym_preproc_warning] = STATE(3417),
    [sym_preproc_define] = STATE(3417),
    [sym_preproc_undef] = STATE(3417),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_when] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_on] = ACTIONS(2983),
    [anon_sym_equals] = ACTIONS(2983),
    [anon_sym_by] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_is] = ACTIONS(2983),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [aux_sym_preproc_if_token3] = ACTIONS(2983),
    [aux_sym_preproc_else_token1] = ACTIONS(2983),
    [aux_sym_preproc_elif_token1] = ACTIONS(2983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3418] = {
    [sym_preproc_region] = STATE(3418),
    [sym_preproc_endregion] = STATE(3418),
    [sym_preproc_line] = STATE(3418),
    [sym_preproc_pragma] = STATE(3418),
    [sym_preproc_nullable] = STATE(3418),
    [sym_preproc_error] = STATE(3418),
    [sym_preproc_warning] = STATE(3418),
    [sym_preproc_define] = STATE(3418),
    [sym_preproc_undef] = STATE(3418),
    [anon_sym_SEMI] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_RBRACK] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_in] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_EQ_GT] = ACTIONS(4291),
    [anon_sym_switch] = ACTIONS(4291),
    [anon_sym_when] = ACTIONS(4291),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4291),
    [anon_sym_or] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_on] = ACTIONS(4291),
    [anon_sym_equals] = ACTIONS(4291),
    [anon_sym_by] = ACTIONS(4291),
    [anon_sym_as] = ACTIONS(4291),
    [anon_sym_is] = ACTIONS(4291),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4291),
    [aux_sym_preproc_if_token3] = ACTIONS(4291),
    [aux_sym_preproc_else_token1] = ACTIONS(4291),
    [aux_sym_preproc_elif_token1] = ACTIONS(4291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3419] = {
    [sym_preproc_region] = STATE(3419),
    [sym_preproc_endregion] = STATE(3419),
    [sym_preproc_line] = STATE(3419),
    [sym_preproc_pragma] = STATE(3419),
    [sym_preproc_nullable] = STATE(3419),
    [sym_preproc_error] = STATE(3419),
    [sym_preproc_warning] = STATE(3419),
    [sym_preproc_define] = STATE(3419),
    [sym_preproc_undef] = STATE(3419),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5234),
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_RBRACK] = ACTIONS(5234),
    [anon_sym_LPAREN] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5234),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5234),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_GT_GT_GT] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5234),
    [anon_sym_BANG_EQ] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5234),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_GT] = ACTIONS(5234),
    [anon_sym_switch] = ACTIONS(5234),
    [anon_sym_when] = ACTIONS(5234),
    [anon_sym_DOT_DOT] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_or] = ACTIONS(5234),
    [anon_sym_AMP_AMP] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5234),
    [anon_sym_QMARK_QMARK] = ACTIONS(5234),
    [anon_sym_on] = ACTIONS(5234),
    [anon_sym_equals] = ACTIONS(5234),
    [anon_sym_by] = ACTIONS(5234),
    [anon_sym_as] = ACTIONS(5234),
    [anon_sym_is] = ACTIONS(5234),
    [anon_sym_DASH_GT] = ACTIONS(5234),
    [anon_sym_with] = ACTIONS(5234),
    [aux_sym_preproc_if_token3] = ACTIONS(5234),
    [aux_sym_preproc_else_token1] = ACTIONS(5234),
    [aux_sym_preproc_elif_token1] = ACTIONS(5234),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3420] = {
    [sym_preproc_region] = STATE(3420),
    [sym_preproc_endregion] = STATE(3420),
    [sym_preproc_line] = STATE(3420),
    [sym_preproc_pragma] = STATE(3420),
    [sym_preproc_nullable] = STATE(3420),
    [sym_preproc_error] = STATE(3420),
    [sym_preproc_warning] = STATE(3420),
    [sym_preproc_define] = STATE(3420),
    [sym_preproc_undef] = STATE(3420),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5242),
    [anon_sym_RBRACK] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5242),
    [anon_sym_RBRACE] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5244),
    [anon_sym_in] = ACTIONS(5242),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_PIPE] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5244),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5244),
    [anon_sym_GT_GT_GT] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_DOT] = ACTIONS(5244),
    [anon_sym_EQ_GT] = ACTIONS(5242),
    [anon_sym_switch] = ACTIONS(5242),
    [anon_sym_when] = ACTIONS(5242),
    [anon_sym_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_or] = ACTIONS(5242),
    [anon_sym_AMP_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5242),
    [anon_sym_QMARK_QMARK] = ACTIONS(5242),
    [anon_sym_on] = ACTIONS(5242),
    [anon_sym_equals] = ACTIONS(5242),
    [anon_sym_by] = ACTIONS(5242),
    [anon_sym_as] = ACTIONS(5242),
    [anon_sym_is] = ACTIONS(5242),
    [anon_sym_DASH_GT] = ACTIONS(5242),
    [anon_sym_with] = ACTIONS(5242),
    [aux_sym_preproc_if_token3] = ACTIONS(5242),
    [aux_sym_preproc_else_token1] = ACTIONS(5242),
    [aux_sym_preproc_elif_token1] = ACTIONS(5242),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3421] = {
    [sym_preproc_region] = STATE(3421),
    [sym_preproc_endregion] = STATE(3421),
    [sym_preproc_line] = STATE(3421),
    [sym_preproc_pragma] = STATE(3421),
    [sym_preproc_nullable] = STATE(3421),
    [sym_preproc_error] = STATE(3421),
    [sym_preproc_warning] = STATE(3421),
    [sym_preproc_define] = STATE(3421),
    [sym_preproc_undef] = STATE(3421),
    [anon_sym_SEMI] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_RBRACK] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_in] = ACTIONS(5246),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5246),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_DOT] = ACTIONS(5248),
    [anon_sym_EQ_GT] = ACTIONS(5246),
    [anon_sym_switch] = ACTIONS(5246),
    [anon_sym_when] = ACTIONS(5246),
    [anon_sym_DOT_DOT] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_QMARK_QMARK] = ACTIONS(5246),
    [anon_sym_on] = ACTIONS(5246),
    [anon_sym_equals] = ACTIONS(5246),
    [anon_sym_by] = ACTIONS(5246),
    [anon_sym_as] = ACTIONS(5246),
    [anon_sym_is] = ACTIONS(5246),
    [anon_sym_DASH_GT] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5246),
    [aux_sym_preproc_if_token3] = ACTIONS(5246),
    [aux_sym_preproc_else_token1] = ACTIONS(5246),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3422] = {
    [sym_preproc_region] = STATE(3422),
    [sym_preproc_endregion] = STATE(3422),
    [sym_preproc_line] = STATE(3422),
    [sym_preproc_pragma] = STATE(3422),
    [sym_preproc_nullable] = STATE(3422),
    [sym_preproc_error] = STATE(3422),
    [sym_preproc_warning] = STATE(3422),
    [sym_preproc_define] = STATE(3422),
    [sym_preproc_undef] = STATE(3422),
    [anon_sym_SEMI] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5250),
    [anon_sym_COLON] = ACTIONS(5250),
    [anon_sym_COMMA] = ACTIONS(5250),
    [anon_sym_RBRACK] = ACTIONS(5250),
    [anon_sym_LPAREN] = ACTIONS(5250),
    [anon_sym_RPAREN] = ACTIONS(5250),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_in] = ACTIONS(5250),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_BANG] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5252),
    [anon_sym_STAR] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5250),
    [anon_sym_PIPE] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5252),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5252),
    [anon_sym_GT_GT_GT] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_DOT] = ACTIONS(5252),
    [anon_sym_EQ_GT] = ACTIONS(5250),
    [anon_sym_switch] = ACTIONS(5250),
    [anon_sym_when] = ACTIONS(5250),
    [anon_sym_DOT_DOT] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_or] = ACTIONS(5250),
    [anon_sym_AMP_AMP] = ACTIONS(5250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5250),
    [anon_sym_QMARK_QMARK] = ACTIONS(5250),
    [anon_sym_on] = ACTIONS(5250),
    [anon_sym_equals] = ACTIONS(5250),
    [anon_sym_by] = ACTIONS(5250),
    [anon_sym_as] = ACTIONS(5250),
    [anon_sym_is] = ACTIONS(5250),
    [anon_sym_DASH_GT] = ACTIONS(5250),
    [anon_sym_with] = ACTIONS(5250),
    [aux_sym_preproc_if_token3] = ACTIONS(5250),
    [aux_sym_preproc_else_token1] = ACTIONS(5250),
    [aux_sym_preproc_elif_token1] = ACTIONS(5250),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3423] = {
    [sym_preproc_region] = STATE(3423),
    [sym_preproc_endregion] = STATE(3423),
    [sym_preproc_line] = STATE(3423),
    [sym_preproc_pragma] = STATE(3423),
    [sym_preproc_nullable] = STATE(3423),
    [sym_preproc_error] = STATE(3423),
    [sym_preproc_warning] = STATE(3423),
    [sym_preproc_define] = STATE(3423),
    [sym_preproc_undef] = STATE(3423),
    [anon_sym_SEMI] = ACTIONS(5254),
    [anon_sym_LBRACK] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(5254),
    [anon_sym_COMMA] = ACTIONS(5254),
    [anon_sym_RBRACK] = ACTIONS(5254),
    [anon_sym_LPAREN] = ACTIONS(5254),
    [anon_sym_RPAREN] = ACTIONS(5254),
    [anon_sym_RBRACE] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5256),
    [anon_sym_in] = ACTIONS(5254),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_BANG] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5256),
    [anon_sym_STAR] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(5256),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PIPE] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5256),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5256),
    [anon_sym_GT_GT_GT] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5254),
    [anon_sym_BANG_EQ] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5254),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_DOT] = ACTIONS(5256),
    [anon_sym_EQ_GT] = ACTIONS(5254),
    [anon_sym_switch] = ACTIONS(5254),
    [anon_sym_when] = ACTIONS(5254),
    [anon_sym_DOT_DOT] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_or] = ACTIONS(5254),
    [anon_sym_AMP_AMP] = ACTIONS(5254),
    [anon_sym_PIPE_PIPE] = ACTIONS(5254),
    [anon_sym_QMARK_QMARK] = ACTIONS(5254),
    [anon_sym_on] = ACTIONS(5254),
    [anon_sym_equals] = ACTIONS(5254),
    [anon_sym_by] = ACTIONS(5254),
    [anon_sym_as] = ACTIONS(5254),
    [anon_sym_is] = ACTIONS(5254),
    [anon_sym_DASH_GT] = ACTIONS(5254),
    [anon_sym_with] = ACTIONS(5254),
    [aux_sym_preproc_if_token3] = ACTIONS(5254),
    [aux_sym_preproc_else_token1] = ACTIONS(5254),
    [aux_sym_preproc_elif_token1] = ACTIONS(5254),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3424] = {
    [sym_preproc_region] = STATE(3424),
    [sym_preproc_endregion] = STATE(3424),
    [sym_preproc_line] = STATE(3424),
    [sym_preproc_pragma] = STATE(3424),
    [sym_preproc_nullable] = STATE(3424),
    [sym_preproc_error] = STATE(3424),
    [sym_preproc_warning] = STATE(3424),
    [sym_preproc_define] = STATE(3424),
    [sym_preproc_undef] = STATE(3424),
    [anon_sym_SEMI] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_COMMA] = ACTIONS(5149),
    [anon_sym_RBRACK] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_RPAREN] = ACTIONS(5149),
    [anon_sym_RBRACE] = ACTIONS(5149),
    [anon_sym_LT] = ACTIONS(5151),
    [anon_sym_GT] = ACTIONS(5151),
    [anon_sym_in] = ACTIONS(5149),
    [anon_sym_QMARK] = ACTIONS(5151),
    [anon_sym_BANG] = ACTIONS(5151),
    [anon_sym_PLUS_PLUS] = ACTIONS(5149),
    [anon_sym_DASH_DASH] = ACTIONS(5149),
    [anon_sym_PLUS] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5149),
    [anon_sym_SLASH] = ACTIONS(5151),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [anon_sym_PIPE] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5151),
    [anon_sym_LT_LT] = ACTIONS(5149),
    [anon_sym_GT_GT] = ACTIONS(5151),
    [anon_sym_GT_GT_GT] = ACTIONS(5149),
    [anon_sym_EQ_EQ] = ACTIONS(5149),
    [anon_sym_BANG_EQ] = ACTIONS(5149),
    [anon_sym_GT_EQ] = ACTIONS(5149),
    [anon_sym_LT_EQ] = ACTIONS(5149),
    [anon_sym_DOT] = ACTIONS(5151),
    [anon_sym_EQ_GT] = ACTIONS(5149),
    [anon_sym_switch] = ACTIONS(5149),
    [anon_sym_when] = ACTIONS(5149),
    [anon_sym_DOT_DOT] = ACTIONS(5149),
    [anon_sym_and] = ACTIONS(5149),
    [anon_sym_or] = ACTIONS(5149),
    [anon_sym_AMP_AMP] = ACTIONS(5149),
    [anon_sym_PIPE_PIPE] = ACTIONS(5149),
    [anon_sym_QMARK_QMARK] = ACTIONS(5149),
    [anon_sym_on] = ACTIONS(5149),
    [anon_sym_equals] = ACTIONS(5149),
    [anon_sym_by] = ACTIONS(5149),
    [anon_sym_as] = ACTIONS(5149),
    [anon_sym_is] = ACTIONS(5149),
    [anon_sym_DASH_GT] = ACTIONS(5149),
    [anon_sym_with] = ACTIONS(5149),
    [aux_sym_preproc_if_token3] = ACTIONS(5149),
    [aux_sym_preproc_else_token1] = ACTIONS(5149),
    [aux_sym_preproc_elif_token1] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3425] = {
    [sym_preproc_region] = STATE(3425),
    [sym_preproc_endregion] = STATE(3425),
    [sym_preproc_line] = STATE(3425),
    [sym_preproc_pragma] = STATE(3425),
    [sym_preproc_nullable] = STATE(3425),
    [sym_preproc_error] = STATE(3425),
    [sym_preproc_warning] = STATE(3425),
    [sym_preproc_define] = STATE(3425),
    [sym_preproc_undef] = STATE(3425),
    [sym__identifier_token] = ACTIONS(3263),
    [anon_sym_extern] = ACTIONS(3263),
    [anon_sym_alias] = ACTIONS(3263),
    [anon_sym_global] = ACTIONS(3263),
    [anon_sym_unsafe] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3265),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_abstract] = ACTIONS(3263),
    [anon_sym_async] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3263),
    [anon_sym_file] = ACTIONS(3263),
    [anon_sym_fixed] = ACTIONS(3263),
    [anon_sym_internal] = ACTIONS(3263),
    [anon_sym_new] = ACTIONS(3263),
    [anon_sym_override] = ACTIONS(3263),
    [anon_sym_partial] = ACTIONS(3263),
    [anon_sym_private] = ACTIONS(3263),
    [anon_sym_protected] = ACTIONS(3263),
    [anon_sym_public] = ACTIONS(3263),
    [anon_sym_readonly] = ACTIONS(3263),
    [anon_sym_required] = ACTIONS(3263),
    [anon_sym_sealed] = ACTIONS(3263),
    [anon_sym_virtual] = ACTIONS(3263),
    [anon_sym_volatile] = ACTIONS(3263),
    [anon_sym_where] = ACTIONS(3263),
    [anon_sym_notnull] = ACTIONS(3263),
    [anon_sym_unmanaged] = ACTIONS(3263),
    [anon_sym_get] = ACTIONS(3263),
    [anon_sym_set] = ACTIONS(3263),
    [anon_sym_add] = ACTIONS(3263),
    [anon_sym_remove] = ACTIONS(3263),
    [anon_sym_init] = ACTIONS(3263),
    [anon_sym_scoped] = ACTIONS(3263),
    [anon_sym_var] = ACTIONS(3263),
    [anon_sym_yield] = ACTIONS(3263),
    [anon_sym_when] = ACTIONS(3263),
    [anon_sym_from] = ACTIONS(3263),
    [anon_sym_into] = ACTIONS(3263),
    [anon_sym_join] = ACTIONS(3263),
    [anon_sym_on] = ACTIONS(3263),
    [anon_sym_equals] = ACTIONS(3263),
    [anon_sym_let] = ACTIONS(3263),
    [anon_sym_orderby] = ACTIONS(3263),
    [anon_sym_ascending] = ACTIONS(3263),
    [anon_sym_descending] = ACTIONS(3263),
    [anon_sym_group] = ACTIONS(3263),
    [anon_sym_by] = ACTIONS(3263),
    [anon_sym_select] = ACTIONS(3263),
    [aux_sym_preproc_if_token1] = ACTIONS(3265),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3426] = {
    [sym_preproc_region] = STATE(3426),
    [sym_preproc_endregion] = STATE(3426),
    [sym_preproc_line] = STATE(3426),
    [sym_preproc_pragma] = STATE(3426),
    [sym_preproc_nullable] = STATE(3426),
    [sym_preproc_error] = STATE(3426),
    [sym_preproc_warning] = STATE(3426),
    [sym_preproc_define] = STATE(3426),
    [sym_preproc_undef] = STATE(3426),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_COLON] = ACTIONS(4983),
    [anon_sym_COMMA] = ACTIONS(4983),
    [anon_sym_RBRACK] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_LT] = ACTIONS(4985),
    [anon_sym_GT] = ACTIONS(4985),
    [anon_sym_in] = ACTIONS(4983),
    [anon_sym_QMARK] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4985),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4985),
    [anon_sym_DASH] = ACTIONS(4985),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_SLASH] = ACTIONS(4985),
    [anon_sym_PERCENT] = ACTIONS(4983),
    [anon_sym_CARET] = ACTIONS(4983),
    [anon_sym_PIPE] = ACTIONS(4985),
    [anon_sym_AMP] = ACTIONS(4985),
    [anon_sym_LT_LT] = ACTIONS(4983),
    [anon_sym_GT_GT] = ACTIONS(4985),
    [anon_sym_GT_GT_GT] = ACTIONS(4983),
    [anon_sym_EQ_EQ] = ACTIONS(4983),
    [anon_sym_BANG_EQ] = ACTIONS(4983),
    [anon_sym_GT_EQ] = ACTIONS(4983),
    [anon_sym_LT_EQ] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4985),
    [anon_sym_EQ_GT] = ACTIONS(4983),
    [anon_sym_switch] = ACTIONS(4983),
    [anon_sym_when] = ACTIONS(4983),
    [anon_sym_DOT_DOT] = ACTIONS(4983),
    [anon_sym_and] = ACTIONS(4983),
    [anon_sym_or] = ACTIONS(4983),
    [anon_sym_AMP_AMP] = ACTIONS(4983),
    [anon_sym_PIPE_PIPE] = ACTIONS(4983),
    [anon_sym_QMARK_QMARK] = ACTIONS(4983),
    [anon_sym_on] = ACTIONS(4983),
    [anon_sym_equals] = ACTIONS(4983),
    [anon_sym_by] = ACTIONS(4983),
    [anon_sym_as] = ACTIONS(4983),
    [anon_sym_is] = ACTIONS(4983),
    [anon_sym_DASH_GT] = ACTIONS(4983),
    [anon_sym_with] = ACTIONS(4983),
    [aux_sym_preproc_if_token3] = ACTIONS(4983),
    [aux_sym_preproc_else_token1] = ACTIONS(4983),
    [aux_sym_preproc_elif_token1] = ACTIONS(4983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3427] = {
    [sym_preproc_region] = STATE(3427),
    [sym_preproc_endregion] = STATE(3427),
    [sym_preproc_line] = STATE(3427),
    [sym_preproc_pragma] = STATE(3427),
    [sym_preproc_nullable] = STATE(3427),
    [sym_preproc_error] = STATE(3427),
    [sym_preproc_warning] = STATE(3427),
    [sym_preproc_define] = STATE(3427),
    [sym_preproc_undef] = STATE(3427),
    [anon_sym_SEMI] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_COLON] = ACTIONS(5023),
    [anon_sym_COMMA] = ACTIONS(5023),
    [anon_sym_RBRACK] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_RPAREN] = ACTIONS(5023),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_LT] = ACTIONS(5025),
    [anon_sym_GT] = ACTIONS(5025),
    [anon_sym_in] = ACTIONS(5023),
    [anon_sym_QMARK] = ACTIONS(5025),
    [anon_sym_BANG] = ACTIONS(5025),
    [anon_sym_PLUS_PLUS] = ACTIONS(5023),
    [anon_sym_DASH_DASH] = ACTIONS(5023),
    [anon_sym_PLUS] = ACTIONS(5025),
    [anon_sym_DASH] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5023),
    [anon_sym_SLASH] = ACTIONS(5025),
    [anon_sym_PERCENT] = ACTIONS(5023),
    [anon_sym_CARET] = ACTIONS(5023),
    [anon_sym_PIPE] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5025),
    [anon_sym_LT_LT] = ACTIONS(5023),
    [anon_sym_GT_GT] = ACTIONS(5025),
    [anon_sym_GT_GT_GT] = ACTIONS(5023),
    [anon_sym_EQ_EQ] = ACTIONS(5023),
    [anon_sym_BANG_EQ] = ACTIONS(5023),
    [anon_sym_GT_EQ] = ACTIONS(5023),
    [anon_sym_LT_EQ] = ACTIONS(5023),
    [anon_sym_DOT] = ACTIONS(5025),
    [anon_sym_EQ_GT] = ACTIONS(5023),
    [anon_sym_switch] = ACTIONS(5023),
    [anon_sym_when] = ACTIONS(5023),
    [anon_sym_DOT_DOT] = ACTIONS(5023),
    [anon_sym_and] = ACTIONS(5023),
    [anon_sym_or] = ACTIONS(5023),
    [anon_sym_AMP_AMP] = ACTIONS(5023),
    [anon_sym_PIPE_PIPE] = ACTIONS(5023),
    [anon_sym_QMARK_QMARK] = ACTIONS(5023),
    [anon_sym_on] = ACTIONS(5023),
    [anon_sym_equals] = ACTIONS(5023),
    [anon_sym_by] = ACTIONS(5023),
    [anon_sym_as] = ACTIONS(5023),
    [anon_sym_is] = ACTIONS(5023),
    [anon_sym_DASH_GT] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5023),
    [aux_sym_preproc_if_token3] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3428] = {
    [sym_preproc_region] = STATE(3428),
    [sym_preproc_endregion] = STATE(3428),
    [sym_preproc_line] = STATE(3428),
    [sym_preproc_pragma] = STATE(3428),
    [sym_preproc_nullable] = STATE(3428),
    [sym_preproc_error] = STATE(3428),
    [sym_preproc_warning] = STATE(3428),
    [sym_preproc_define] = STATE(3428),
    [sym_preproc_undef] = STATE(3428),
    [anon_sym_SEMI] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_COLON] = ACTIONS(5031),
    [anon_sym_COMMA] = ACTIONS(5031),
    [anon_sym_RBRACK] = ACTIONS(5031),
    [anon_sym_LPAREN] = ACTIONS(5031),
    [anon_sym_RPAREN] = ACTIONS(5031),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_GT] = ACTIONS(5033),
    [anon_sym_in] = ACTIONS(5031),
    [anon_sym_QMARK] = ACTIONS(5033),
    [anon_sym_BANG] = ACTIONS(5033),
    [anon_sym_PLUS_PLUS] = ACTIONS(5031),
    [anon_sym_DASH_DASH] = ACTIONS(5031),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5031),
    [anon_sym_SLASH] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5031),
    [anon_sym_CARET] = ACTIONS(5031),
    [anon_sym_PIPE] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(5031),
    [anon_sym_GT_GT] = ACTIONS(5033),
    [anon_sym_GT_GT_GT] = ACTIONS(5031),
    [anon_sym_EQ_EQ] = ACTIONS(5031),
    [anon_sym_BANG_EQ] = ACTIONS(5031),
    [anon_sym_GT_EQ] = ACTIONS(5031),
    [anon_sym_LT_EQ] = ACTIONS(5031),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_EQ_GT] = ACTIONS(5031),
    [anon_sym_switch] = ACTIONS(5031),
    [anon_sym_when] = ACTIONS(5031),
    [anon_sym_DOT_DOT] = ACTIONS(5031),
    [anon_sym_and] = ACTIONS(5031),
    [anon_sym_or] = ACTIONS(5031),
    [anon_sym_AMP_AMP] = ACTIONS(5031),
    [anon_sym_PIPE_PIPE] = ACTIONS(5031),
    [anon_sym_QMARK_QMARK] = ACTIONS(5031),
    [anon_sym_on] = ACTIONS(5031),
    [anon_sym_equals] = ACTIONS(5031),
    [anon_sym_by] = ACTIONS(5031),
    [anon_sym_as] = ACTIONS(5031),
    [anon_sym_is] = ACTIONS(5031),
    [anon_sym_DASH_GT] = ACTIONS(5031),
    [anon_sym_with] = ACTIONS(5031),
    [aux_sym_preproc_if_token3] = ACTIONS(5031),
    [aux_sym_preproc_else_token1] = ACTIONS(5031),
    [aux_sym_preproc_elif_token1] = ACTIONS(5031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3429] = {
    [sym_preproc_region] = STATE(3429),
    [sym_preproc_endregion] = STATE(3429),
    [sym_preproc_line] = STATE(3429),
    [sym_preproc_pragma] = STATE(3429),
    [sym_preproc_nullable] = STATE(3429),
    [sym_preproc_error] = STATE(3429),
    [sym_preproc_warning] = STATE(3429),
    [sym_preproc_define] = STATE(3429),
    [sym_preproc_undef] = STATE(3429),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_COLON] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_RBRACK] = ACTIONS(5480),
    [anon_sym_LPAREN] = ACTIONS(5480),
    [anon_sym_RPAREN] = ACTIONS(5480),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_in] = ACTIONS(5480),
    [anon_sym_QMARK] = ACTIONS(5482),
    [anon_sym_BANG] = ACTIONS(5482),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5480),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5480),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_GT_GT_GT] = ACTIONS(5480),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_EQ_GT] = ACTIONS(5480),
    [anon_sym_switch] = ACTIONS(5480),
    [anon_sym_when] = ACTIONS(5480),
    [anon_sym_DOT_DOT] = ACTIONS(5480),
    [anon_sym_and] = ACTIONS(5480),
    [anon_sym_or] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_QMARK_QMARK] = ACTIONS(5480),
    [anon_sym_on] = ACTIONS(5480),
    [anon_sym_equals] = ACTIONS(5480),
    [anon_sym_by] = ACTIONS(5480),
    [anon_sym_as] = ACTIONS(5480),
    [anon_sym_is] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_with] = ACTIONS(5480),
    [aux_sym_preproc_if_token3] = ACTIONS(5480),
    [aux_sym_preproc_else_token1] = ACTIONS(5480),
    [aux_sym_preproc_elif_token1] = ACTIONS(5480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3430] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6135),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3430),
    [sym_preproc_endregion] = STATE(3430),
    [sym_preproc_line] = STATE(3430),
    [sym_preproc_pragma] = STATE(3430),
    [sym_preproc_nullable] = STATE(3430),
    [sym_preproc_error] = STATE(3430),
    [sym_preproc_warning] = STATE(3430),
    [sym_preproc_define] = STATE(3430),
    [sym_preproc_undef] = STATE(3430),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(5827),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3431] = {
    [sym_preproc_region] = STATE(3431),
    [sym_preproc_endregion] = STATE(3431),
    [sym_preproc_line] = STATE(3431),
    [sym_preproc_pragma] = STATE(3431),
    [sym_preproc_nullable] = STATE(3431),
    [sym_preproc_error] = STATE(3431),
    [sym_preproc_warning] = STATE(3431),
    [sym_preproc_define] = STATE(3431),
    [sym_preproc_undef] = STATE(3431),
    [anon_sym_SEMI] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RBRACK] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5226),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5228),
    [anon_sym_in] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_BANG] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5228),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5228),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_EQ_GT] = ACTIONS(5226),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_when] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_on] = ACTIONS(5226),
    [anon_sym_equals] = ACTIONS(5226),
    [anon_sym_by] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5226),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_if_token3] = ACTIONS(5226),
    [aux_sym_preproc_else_token1] = ACTIONS(5226),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3432] = {
    [sym_preproc_region] = STATE(3432),
    [sym_preproc_endregion] = STATE(3432),
    [sym_preproc_line] = STATE(3432),
    [sym_preproc_pragma] = STATE(3432),
    [sym_preproc_nullable] = STATE(3432),
    [sym_preproc_error] = STATE(3432),
    [sym_preproc_warning] = STATE(3432),
    [sym_preproc_define] = STATE(3432),
    [sym_preproc_undef] = STATE(3432),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5240),
    [anon_sym_in] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(5240),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5240),
    [anon_sym_GT_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_switch] = ACTIONS(5238),
    [anon_sym_when] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_QMARK_QMARK] = ACTIONS(5238),
    [anon_sym_on] = ACTIONS(5238),
    [anon_sym_equals] = ACTIONS(5238),
    [anon_sym_by] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5238),
    [anon_sym_is] = ACTIONS(5238),
    [anon_sym_DASH_GT] = ACTIONS(5238),
    [anon_sym_with] = ACTIONS(5238),
    [aux_sym_preproc_if_token3] = ACTIONS(5238),
    [aux_sym_preproc_else_token1] = ACTIONS(5238),
    [aux_sym_preproc_elif_token1] = ACTIONS(5238),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3433] = {
    [sym_preproc_region] = STATE(3433),
    [sym_preproc_endregion] = STATE(3433),
    [sym_preproc_line] = STATE(3433),
    [sym_preproc_pragma] = STATE(3433),
    [sym_preproc_nullable] = STATE(3433),
    [sym_preproc_error] = STATE(3433),
    [sym_preproc_warning] = STATE(3433),
    [sym_preproc_define] = STATE(3433),
    [sym_preproc_undef] = STATE(3433),
    [anon_sym_SEMI] = ACTIONS(4987),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_COLON] = ACTIONS(4987),
    [anon_sym_COMMA] = ACTIONS(4987),
    [anon_sym_RBRACK] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_LT] = ACTIONS(4989),
    [anon_sym_GT] = ACTIONS(4989),
    [anon_sym_in] = ACTIONS(4987),
    [anon_sym_QMARK] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4987),
    [anon_sym_PLUS] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4987),
    [anon_sym_SLASH] = ACTIONS(4989),
    [anon_sym_PERCENT] = ACTIONS(4987),
    [anon_sym_CARET] = ACTIONS(4987),
    [anon_sym_PIPE] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_LT_LT] = ACTIONS(4987),
    [anon_sym_GT_GT] = ACTIONS(4989),
    [anon_sym_GT_GT_GT] = ACTIONS(4987),
    [anon_sym_EQ_EQ] = ACTIONS(4987),
    [anon_sym_BANG_EQ] = ACTIONS(4987),
    [anon_sym_GT_EQ] = ACTIONS(4987),
    [anon_sym_LT_EQ] = ACTIONS(4987),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_EQ_GT] = ACTIONS(4987),
    [anon_sym_switch] = ACTIONS(4987),
    [anon_sym_when] = ACTIONS(4987),
    [anon_sym_DOT_DOT] = ACTIONS(4987),
    [anon_sym_and] = ACTIONS(4987),
    [anon_sym_or] = ACTIONS(4987),
    [anon_sym_AMP_AMP] = ACTIONS(4987),
    [anon_sym_PIPE_PIPE] = ACTIONS(4987),
    [anon_sym_QMARK_QMARK] = ACTIONS(4987),
    [anon_sym_on] = ACTIONS(4987),
    [anon_sym_equals] = ACTIONS(4987),
    [anon_sym_by] = ACTIONS(4987),
    [anon_sym_as] = ACTIONS(4987),
    [anon_sym_is] = ACTIONS(4987),
    [anon_sym_DASH_GT] = ACTIONS(4987),
    [anon_sym_with] = ACTIONS(4987),
    [aux_sym_preproc_if_token3] = ACTIONS(4987),
    [aux_sym_preproc_else_token1] = ACTIONS(4987),
    [aux_sym_preproc_elif_token1] = ACTIONS(4987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3434] = {
    [sym_preproc_region] = STATE(3434),
    [sym_preproc_endregion] = STATE(3434),
    [sym_preproc_line] = STATE(3434),
    [sym_preproc_pragma] = STATE(3434),
    [sym_preproc_nullable] = STATE(3434),
    [sym_preproc_error] = STATE(3434),
    [sym_preproc_warning] = STATE(3434),
    [sym_preproc_define] = STATE(3434),
    [sym_preproc_undef] = STATE(3434),
    [anon_sym_SEMI] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_COLON] = ACTIONS(5051),
    [anon_sym_COMMA] = ACTIONS(5051),
    [anon_sym_RBRACK] = ACTIONS(5051),
    [anon_sym_LPAREN] = ACTIONS(5051),
    [anon_sym_RPAREN] = ACTIONS(5051),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_LT] = ACTIONS(5053),
    [anon_sym_GT] = ACTIONS(5053),
    [anon_sym_in] = ACTIONS(5051),
    [anon_sym_QMARK] = ACTIONS(5053),
    [anon_sym_BANG] = ACTIONS(5053),
    [anon_sym_PLUS_PLUS] = ACTIONS(5051),
    [anon_sym_DASH_DASH] = ACTIONS(5051),
    [anon_sym_PLUS] = ACTIONS(5053),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5051),
    [anon_sym_SLASH] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5051),
    [anon_sym_CARET] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5053),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5053),
    [anon_sym_GT_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5051),
    [anon_sym_BANG_EQ] = ACTIONS(5051),
    [anon_sym_GT_EQ] = ACTIONS(5051),
    [anon_sym_LT_EQ] = ACTIONS(5051),
    [anon_sym_DOT] = ACTIONS(5053),
    [anon_sym_EQ_GT] = ACTIONS(5051),
    [anon_sym_switch] = ACTIONS(5051),
    [anon_sym_when] = ACTIONS(5051),
    [anon_sym_DOT_DOT] = ACTIONS(5051),
    [anon_sym_and] = ACTIONS(5051),
    [anon_sym_or] = ACTIONS(5051),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5051),
    [anon_sym_QMARK_QMARK] = ACTIONS(5051),
    [anon_sym_on] = ACTIONS(5051),
    [anon_sym_equals] = ACTIONS(5051),
    [anon_sym_by] = ACTIONS(5051),
    [anon_sym_as] = ACTIONS(5051),
    [anon_sym_is] = ACTIONS(5051),
    [anon_sym_DASH_GT] = ACTIONS(5051),
    [anon_sym_with] = ACTIONS(5051),
    [aux_sym_preproc_if_token3] = ACTIONS(5051),
    [aux_sym_preproc_else_token1] = ACTIONS(5051),
    [aux_sym_preproc_elif_token1] = ACTIONS(5051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3435] = {
    [sym_preproc_region] = STATE(3435),
    [sym_preproc_endregion] = STATE(3435),
    [sym_preproc_line] = STATE(3435),
    [sym_preproc_pragma] = STATE(3435),
    [sym_preproc_nullable] = STATE(3435),
    [sym_preproc_error] = STATE(3435),
    [sym_preproc_warning] = STATE(3435),
    [sym_preproc_define] = STATE(3435),
    [sym_preproc_undef] = STATE(3435),
    [anon_sym_SEMI] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_COLON] = ACTIONS(5063),
    [anon_sym_COMMA] = ACTIONS(5063),
    [anon_sym_RBRACK] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5063),
    [anon_sym_RPAREN] = ACTIONS(5063),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(5065),
    [anon_sym_GT] = ACTIONS(5065),
    [anon_sym_in] = ACTIONS(5063),
    [anon_sym_QMARK] = ACTIONS(5065),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS_PLUS] = ACTIONS(5063),
    [anon_sym_DASH_DASH] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5063),
    [anon_sym_SLASH] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_CARET] = ACTIONS(5063),
    [anon_sym_PIPE] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5065),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5065),
    [anon_sym_GT_GT_GT] = ACTIONS(5063),
    [anon_sym_EQ_EQ] = ACTIONS(5063),
    [anon_sym_BANG_EQ] = ACTIONS(5063),
    [anon_sym_GT_EQ] = ACTIONS(5063),
    [anon_sym_LT_EQ] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [anon_sym_EQ_GT] = ACTIONS(5063),
    [anon_sym_switch] = ACTIONS(5063),
    [anon_sym_when] = ACTIONS(5063),
    [anon_sym_DOT_DOT] = ACTIONS(5063),
    [anon_sym_and] = ACTIONS(5063),
    [anon_sym_or] = ACTIONS(5063),
    [anon_sym_AMP_AMP] = ACTIONS(5063),
    [anon_sym_PIPE_PIPE] = ACTIONS(5063),
    [anon_sym_QMARK_QMARK] = ACTIONS(5063),
    [anon_sym_on] = ACTIONS(5063),
    [anon_sym_equals] = ACTIONS(5063),
    [anon_sym_by] = ACTIONS(5063),
    [anon_sym_as] = ACTIONS(5063),
    [anon_sym_is] = ACTIONS(5063),
    [anon_sym_DASH_GT] = ACTIONS(5063),
    [anon_sym_with] = ACTIONS(5063),
    [aux_sym_preproc_if_token3] = ACTIONS(5063),
    [aux_sym_preproc_else_token1] = ACTIONS(5063),
    [aux_sym_preproc_elif_token1] = ACTIONS(5063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3436] = {
    [sym_preproc_region] = STATE(3436),
    [sym_preproc_endregion] = STATE(3436),
    [sym_preproc_line] = STATE(3436),
    [sym_preproc_pragma] = STATE(3436),
    [sym_preproc_nullable] = STATE(3436),
    [sym_preproc_error] = STATE(3436),
    [sym_preproc_warning] = STATE(3436),
    [sym_preproc_define] = STATE(3436),
    [sym_preproc_undef] = STATE(3436),
    [anon_sym_SEMI] = ACTIONS(5093),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_COLON] = ACTIONS(5093),
    [anon_sym_COMMA] = ACTIONS(5093),
    [anon_sym_RBRACK] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_RPAREN] = ACTIONS(5093),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_in] = ACTIONS(5093),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_BANG] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5095),
    [anon_sym_PERCENT] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5093),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5093),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_GT_GT_GT] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_DOT] = ACTIONS(5095),
    [anon_sym_EQ_GT] = ACTIONS(5093),
    [anon_sym_switch] = ACTIONS(5093),
    [anon_sym_when] = ACTIONS(5093),
    [anon_sym_DOT_DOT] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_or] = ACTIONS(5093),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_PIPE_PIPE] = ACTIONS(5093),
    [anon_sym_QMARK_QMARK] = ACTIONS(5093),
    [anon_sym_on] = ACTIONS(5093),
    [anon_sym_equals] = ACTIONS(5093),
    [anon_sym_by] = ACTIONS(5093),
    [anon_sym_as] = ACTIONS(5093),
    [anon_sym_is] = ACTIONS(5093),
    [anon_sym_DASH_GT] = ACTIONS(5093),
    [anon_sym_with] = ACTIONS(5093),
    [aux_sym_preproc_if_token3] = ACTIONS(5093),
    [aux_sym_preproc_else_token1] = ACTIONS(5093),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3437] = {
    [sym_preproc_region] = STATE(3437),
    [sym_preproc_endregion] = STATE(3437),
    [sym_preproc_line] = STATE(3437),
    [sym_preproc_pragma] = STATE(3437),
    [sym_preproc_nullable] = STATE(3437),
    [sym_preproc_error] = STATE(3437),
    [sym_preproc_warning] = STATE(3437),
    [sym_preproc_define] = STATE(3437),
    [sym_preproc_undef] = STATE(3437),
    [anon_sym_SEMI] = ACTIONS(5105),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_COLON] = ACTIONS(5105),
    [anon_sym_COMMA] = ACTIONS(5105),
    [anon_sym_RBRACK] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_RPAREN] = ACTIONS(5105),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5107),
    [anon_sym_in] = ACTIONS(5105),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_BANG] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5107),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_PIPE] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_GT_GT_GT] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5105),
    [anon_sym_BANG_EQ] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5105),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_DOT] = ACTIONS(5107),
    [anon_sym_EQ_GT] = ACTIONS(5105),
    [anon_sym_switch] = ACTIONS(5105),
    [anon_sym_when] = ACTIONS(5105),
    [anon_sym_DOT_DOT] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_or] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5105),
    [anon_sym_QMARK_QMARK] = ACTIONS(5105),
    [anon_sym_on] = ACTIONS(5105),
    [anon_sym_equals] = ACTIONS(5105),
    [anon_sym_by] = ACTIONS(5105),
    [anon_sym_as] = ACTIONS(5105),
    [anon_sym_is] = ACTIONS(5105),
    [anon_sym_DASH_GT] = ACTIONS(5105),
    [anon_sym_with] = ACTIONS(5105),
    [aux_sym_preproc_if_token3] = ACTIONS(5105),
    [aux_sym_preproc_else_token1] = ACTIONS(5105),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3438] = {
    [sym_preproc_region] = STATE(3438),
    [sym_preproc_endregion] = STATE(3438),
    [sym_preproc_line] = STATE(3438),
    [sym_preproc_pragma] = STATE(3438),
    [sym_preproc_nullable] = STATE(3438),
    [sym_preproc_error] = STATE(3438),
    [sym_preproc_warning] = STATE(3438),
    [sym_preproc_define] = STATE(3438),
    [sym_preproc_undef] = STATE(3438),
    [anon_sym_SEMI] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_COMMA] = ACTIONS(5125),
    [anon_sym_RBRACK] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_RPAREN] = ACTIONS(5125),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5127),
    [anon_sym_in] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_BANG] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5127),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_PIPE] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_GT_GT_GT] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5125),
    [anon_sym_BANG_EQ] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5125),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5127),
    [anon_sym_EQ_GT] = ACTIONS(5125),
    [anon_sym_switch] = ACTIONS(5125),
    [anon_sym_when] = ACTIONS(5125),
    [anon_sym_DOT_DOT] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_QMARK_QMARK] = ACTIONS(5125),
    [anon_sym_on] = ACTIONS(5125),
    [anon_sym_equals] = ACTIONS(5125),
    [anon_sym_by] = ACTIONS(5125),
    [anon_sym_as] = ACTIONS(5125),
    [anon_sym_is] = ACTIONS(5125),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [anon_sym_with] = ACTIONS(5125),
    [aux_sym_preproc_if_token3] = ACTIONS(5125),
    [aux_sym_preproc_else_token1] = ACTIONS(5125),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3439] = {
    [sym_preproc_region] = STATE(3439),
    [sym_preproc_endregion] = STATE(3439),
    [sym_preproc_line] = STATE(3439),
    [sym_preproc_pragma] = STATE(3439),
    [sym_preproc_nullable] = STATE(3439),
    [sym_preproc_error] = STATE(3439),
    [sym_preproc_warning] = STATE(3439),
    [sym_preproc_define] = STATE(3439),
    [sym_preproc_undef] = STATE(3439),
    [anon_sym_SEMI] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(5163),
    [anon_sym_COLON] = ACTIONS(5163),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACK] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(5163),
    [anon_sym_RPAREN] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_in] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_PLUS_PLUS] = ACTIONS(5163),
    [anon_sym_DASH_DASH] = ACTIONS(5163),
    [anon_sym_PLUS] = ACTIONS(5165),
    [anon_sym_DASH] = ACTIONS(5165),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_SLASH] = ACTIONS(5165),
    [anon_sym_PERCENT] = ACTIONS(5163),
    [anon_sym_CARET] = ACTIONS(5163),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_LT_LT] = ACTIONS(5163),
    [anon_sym_GT_GT] = ACTIONS(5165),
    [anon_sym_GT_GT_GT] = ACTIONS(5163),
    [anon_sym_EQ_EQ] = ACTIONS(5163),
    [anon_sym_BANG_EQ] = ACTIONS(5163),
    [anon_sym_GT_EQ] = ACTIONS(5163),
    [anon_sym_LT_EQ] = ACTIONS(5163),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_EQ_GT] = ACTIONS(5163),
    [anon_sym_switch] = ACTIONS(5163),
    [anon_sym_when] = ACTIONS(5163),
    [anon_sym_DOT_DOT] = ACTIONS(5163),
    [anon_sym_and] = ACTIONS(5163),
    [anon_sym_or] = ACTIONS(5163),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_QMARK_QMARK] = ACTIONS(5163),
    [anon_sym_on] = ACTIONS(5163),
    [anon_sym_equals] = ACTIONS(5163),
    [anon_sym_by] = ACTIONS(5163),
    [anon_sym_as] = ACTIONS(5163),
    [anon_sym_is] = ACTIONS(5163),
    [anon_sym_DASH_GT] = ACTIONS(5163),
    [anon_sym_with] = ACTIONS(5163),
    [aux_sym_preproc_if_token3] = ACTIONS(5163),
    [aux_sym_preproc_else_token1] = ACTIONS(5163),
    [aux_sym_preproc_elif_token1] = ACTIONS(5163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3440] = {
    [sym_preproc_region] = STATE(3440),
    [sym_preproc_endregion] = STATE(3440),
    [sym_preproc_line] = STATE(3440),
    [sym_preproc_pragma] = STATE(3440),
    [sym_preproc_nullable] = STATE(3440),
    [sym_preproc_error] = STATE(3440),
    [sym_preproc_warning] = STATE(3440),
    [sym_preproc_define] = STATE(3440),
    [sym_preproc_undef] = STATE(3440),
    [anon_sym_SEMI] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(5183),
    [anon_sym_COLON] = ACTIONS(5183),
    [anon_sym_COMMA] = ACTIONS(5183),
    [anon_sym_RBRACK] = ACTIONS(5183),
    [anon_sym_LPAREN] = ACTIONS(5183),
    [anon_sym_RPAREN] = ACTIONS(5183),
    [anon_sym_RBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_in] = ACTIONS(5183),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_BANG] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5183),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_GT_GT_GT] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5183),
    [anon_sym_BANG_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_EQ_GT] = ACTIONS(5183),
    [anon_sym_switch] = ACTIONS(5183),
    [anon_sym_when] = ACTIONS(5183),
    [anon_sym_DOT_DOT] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_or] = ACTIONS(5183),
    [anon_sym_AMP_AMP] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE] = ACTIONS(5183),
    [anon_sym_QMARK_QMARK] = ACTIONS(5183),
    [anon_sym_on] = ACTIONS(5183),
    [anon_sym_equals] = ACTIONS(5183),
    [anon_sym_by] = ACTIONS(5183),
    [anon_sym_as] = ACTIONS(5183),
    [anon_sym_is] = ACTIONS(5183),
    [anon_sym_DASH_GT] = ACTIONS(5183),
    [anon_sym_with] = ACTIONS(5183),
    [aux_sym_preproc_if_token3] = ACTIONS(5183),
    [aux_sym_preproc_else_token1] = ACTIONS(5183),
    [aux_sym_preproc_elif_token1] = ACTIONS(5183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3441] = {
    [sym_preproc_region] = STATE(3441),
    [sym_preproc_endregion] = STATE(3441),
    [sym_preproc_line] = STATE(3441),
    [sym_preproc_pragma] = STATE(3441),
    [sym_preproc_nullable] = STATE(3441),
    [sym_preproc_error] = STATE(3441),
    [sym_preproc_warning] = STATE(3441),
    [sym_preproc_define] = STATE(3441),
    [sym_preproc_undef] = STATE(3441),
    [anon_sym_SEMI] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_COLON] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(4975),
    [anon_sym_RBRACK] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_RPAREN] = ACTIONS(4975),
    [anon_sym_RBRACE] = ACTIONS(4975),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_GT] = ACTIONS(4977),
    [anon_sym_in] = ACTIONS(4975),
    [anon_sym_QMARK] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_PLUS_PLUS] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4975),
    [anon_sym_SLASH] = ACTIONS(4977),
    [anon_sym_PERCENT] = ACTIONS(4975),
    [anon_sym_CARET] = ACTIONS(4975),
    [anon_sym_PIPE] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4975),
    [anon_sym_GT_GT] = ACTIONS(4977),
    [anon_sym_GT_GT_GT] = ACTIONS(4975),
    [anon_sym_EQ_EQ] = ACTIONS(4975),
    [anon_sym_BANG_EQ] = ACTIONS(4975),
    [anon_sym_GT_EQ] = ACTIONS(4975),
    [anon_sym_LT_EQ] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_EQ_GT] = ACTIONS(4975),
    [anon_sym_switch] = ACTIONS(4975),
    [anon_sym_when] = ACTIONS(4975),
    [anon_sym_DOT_DOT] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_or] = ACTIONS(4975),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_PIPE_PIPE] = ACTIONS(4975),
    [anon_sym_QMARK_QMARK] = ACTIONS(4975),
    [anon_sym_on] = ACTIONS(4975),
    [anon_sym_equals] = ACTIONS(4975),
    [anon_sym_by] = ACTIONS(4975),
    [anon_sym_as] = ACTIONS(4975),
    [anon_sym_is] = ACTIONS(4975),
    [anon_sym_DASH_GT] = ACTIONS(4975),
    [anon_sym_with] = ACTIONS(4975),
    [aux_sym_preproc_if_token3] = ACTIONS(4975),
    [aux_sym_preproc_else_token1] = ACTIONS(4975),
    [aux_sym_preproc_elif_token1] = ACTIONS(4975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3442] = {
    [sym_preproc_region] = STATE(3442),
    [sym_preproc_endregion] = STATE(3442),
    [sym_preproc_line] = STATE(3442),
    [sym_preproc_pragma] = STATE(3442),
    [sym_preproc_nullable] = STATE(3442),
    [sym_preproc_error] = STATE(3442),
    [sym_preproc_warning] = STATE(3442),
    [sym_preproc_define] = STATE(3442),
    [sym_preproc_undef] = STATE(3442),
    [anon_sym_SEMI] = ACTIONS(5211),
    [anon_sym_LBRACK] = ACTIONS(5211),
    [anon_sym_COLON] = ACTIONS(5211),
    [anon_sym_COMMA] = ACTIONS(5211),
    [anon_sym_RBRACK] = ACTIONS(5211),
    [anon_sym_LPAREN] = ACTIONS(5211),
    [anon_sym_RPAREN] = ACTIONS(5211),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [anon_sym_LT] = ACTIONS(5213),
    [anon_sym_GT] = ACTIONS(5213),
    [anon_sym_in] = ACTIONS(5211),
    [anon_sym_QMARK] = ACTIONS(5213),
    [anon_sym_BANG] = ACTIONS(5213),
    [anon_sym_PLUS_PLUS] = ACTIONS(5211),
    [anon_sym_DASH_DASH] = ACTIONS(5211),
    [anon_sym_PLUS] = ACTIONS(5213),
    [anon_sym_DASH] = ACTIONS(5213),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_SLASH] = ACTIONS(5213),
    [anon_sym_PERCENT] = ACTIONS(5211),
    [anon_sym_CARET] = ACTIONS(5211),
    [anon_sym_PIPE] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5211),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_GT_GT_GT] = ACTIONS(5211),
    [anon_sym_EQ_EQ] = ACTIONS(5211),
    [anon_sym_BANG_EQ] = ACTIONS(5211),
    [anon_sym_GT_EQ] = ACTIONS(5211),
    [anon_sym_LT_EQ] = ACTIONS(5211),
    [anon_sym_DOT] = ACTIONS(5213),
    [anon_sym_EQ_GT] = ACTIONS(5211),
    [anon_sym_switch] = ACTIONS(5211),
    [anon_sym_when] = ACTIONS(5211),
    [anon_sym_DOT_DOT] = ACTIONS(5211),
    [anon_sym_and] = ACTIONS(5211),
    [anon_sym_or] = ACTIONS(5211),
    [anon_sym_AMP_AMP] = ACTIONS(5211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5211),
    [anon_sym_QMARK_QMARK] = ACTIONS(5211),
    [anon_sym_on] = ACTIONS(5211),
    [anon_sym_equals] = ACTIONS(5211),
    [anon_sym_by] = ACTIONS(5211),
    [anon_sym_as] = ACTIONS(5211),
    [anon_sym_is] = ACTIONS(5211),
    [anon_sym_DASH_GT] = ACTIONS(5211),
    [anon_sym_with] = ACTIONS(5211),
    [aux_sym_preproc_if_token3] = ACTIONS(5211),
    [aux_sym_preproc_else_token1] = ACTIONS(5211),
    [aux_sym_preproc_elif_token1] = ACTIONS(5211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3443] = {
    [sym_preproc_region] = STATE(3443),
    [sym_preproc_endregion] = STATE(3443),
    [sym_preproc_line] = STATE(3443),
    [sym_preproc_pragma] = STATE(3443),
    [sym_preproc_nullable] = STATE(3443),
    [sym_preproc_error] = STATE(3443),
    [sym_preproc_warning] = STATE(3443),
    [sym_preproc_define] = STATE(3443),
    [sym_preproc_undef] = STATE(3443),
    [anon_sym_SEMI] = ACTIONS(5222),
    [anon_sym_LBRACK] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [anon_sym_LPAREN] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_in] = ACTIONS(5222),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_BANG] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_PIPE] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5224),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5224),
    [anon_sym_GT_GT_GT] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5222),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_DOT] = ACTIONS(5224),
    [anon_sym_EQ_GT] = ACTIONS(5222),
    [anon_sym_switch] = ACTIONS(5222),
    [anon_sym_when] = ACTIONS(5222),
    [anon_sym_DOT_DOT] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_or] = ACTIONS(5222),
    [anon_sym_AMP_AMP] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5222),
    [anon_sym_QMARK_QMARK] = ACTIONS(5222),
    [anon_sym_on] = ACTIONS(5222),
    [anon_sym_equals] = ACTIONS(5222),
    [anon_sym_by] = ACTIONS(5222),
    [anon_sym_as] = ACTIONS(5222),
    [anon_sym_is] = ACTIONS(5222),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [anon_sym_with] = ACTIONS(5222),
    [aux_sym_preproc_if_token3] = ACTIONS(5222),
    [aux_sym_preproc_else_token1] = ACTIONS(5222),
    [aux_sym_preproc_elif_token1] = ACTIONS(5222),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3444] = {
    [sym_preproc_region] = STATE(3444),
    [sym_preproc_endregion] = STATE(3444),
    [sym_preproc_line] = STATE(3444),
    [sym_preproc_pragma] = STATE(3444),
    [sym_preproc_nullable] = STATE(3444),
    [sym_preproc_error] = STATE(3444),
    [sym_preproc_warning] = STATE(3444),
    [sym_preproc_define] = STATE(3444),
    [sym_preproc_undef] = STATE(3444),
    [anon_sym_SEMI] = ACTIONS(4995),
    [anon_sym_LBRACK] = ACTIONS(4995),
    [anon_sym_COLON] = ACTIONS(4995),
    [anon_sym_COMMA] = ACTIONS(4995),
    [anon_sym_RBRACK] = ACTIONS(4995),
    [anon_sym_LPAREN] = ACTIONS(4995),
    [anon_sym_RPAREN] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_in] = ACTIONS(4995),
    [anon_sym_QMARK] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_PLUS_PLUS] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4995),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4995),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4995),
    [anon_sym_CARET] = ACTIONS(4995),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4995),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_GT_GT_GT] = ACTIONS(4995),
    [anon_sym_EQ_EQ] = ACTIONS(4995),
    [anon_sym_BANG_EQ] = ACTIONS(4995),
    [anon_sym_GT_EQ] = ACTIONS(4995),
    [anon_sym_LT_EQ] = ACTIONS(4995),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_EQ_GT] = ACTIONS(4995),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_when] = ACTIONS(4995),
    [anon_sym_DOT_DOT] = ACTIONS(4995),
    [anon_sym_and] = ACTIONS(4995),
    [anon_sym_or] = ACTIONS(4995),
    [anon_sym_AMP_AMP] = ACTIONS(4995),
    [anon_sym_PIPE_PIPE] = ACTIONS(4995),
    [anon_sym_QMARK_QMARK] = ACTIONS(4995),
    [anon_sym_on] = ACTIONS(4995),
    [anon_sym_equals] = ACTIONS(4995),
    [anon_sym_by] = ACTIONS(4995),
    [anon_sym_as] = ACTIONS(4995),
    [anon_sym_is] = ACTIONS(4995),
    [anon_sym_DASH_GT] = ACTIONS(4995),
    [anon_sym_with] = ACTIONS(4995),
    [aux_sym_preproc_if_token3] = ACTIONS(4995),
    [aux_sym_preproc_else_token1] = ACTIONS(4995),
    [aux_sym_preproc_elif_token1] = ACTIONS(4995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3445] = {
    [sym_preproc_region] = STATE(3445),
    [sym_preproc_endregion] = STATE(3445),
    [sym_preproc_line] = STATE(3445),
    [sym_preproc_pragma] = STATE(3445),
    [sym_preproc_nullable] = STATE(3445),
    [sym_preproc_error] = STATE(3445),
    [sym_preproc_warning] = STATE(3445),
    [sym_preproc_define] = STATE(3445),
    [sym_preproc_undef] = STATE(3445),
    [anon_sym_SEMI] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_COLON] = ACTIONS(4991),
    [anon_sym_COMMA] = ACTIONS(4991),
    [anon_sym_RBRACK] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_RPAREN] = ACTIONS(4991),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_LT] = ACTIONS(4993),
    [anon_sym_GT] = ACTIONS(4993),
    [anon_sym_in] = ACTIONS(4991),
    [anon_sym_QMARK] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4991),
    [anon_sym_PLUS] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4991),
    [anon_sym_SLASH] = ACTIONS(4993),
    [anon_sym_PERCENT] = ACTIONS(4991),
    [anon_sym_CARET] = ACTIONS(4991),
    [anon_sym_PIPE] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_LT_LT] = ACTIONS(4991),
    [anon_sym_GT_GT] = ACTIONS(4993),
    [anon_sym_GT_GT_GT] = ACTIONS(4991),
    [anon_sym_EQ_EQ] = ACTIONS(4991),
    [anon_sym_BANG_EQ] = ACTIONS(4991),
    [anon_sym_GT_EQ] = ACTIONS(4991),
    [anon_sym_LT_EQ] = ACTIONS(4991),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_EQ_GT] = ACTIONS(4991),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_when] = ACTIONS(4991),
    [anon_sym_DOT_DOT] = ACTIONS(4991),
    [anon_sym_and] = ACTIONS(4991),
    [anon_sym_or] = ACTIONS(4991),
    [anon_sym_AMP_AMP] = ACTIONS(4991),
    [anon_sym_PIPE_PIPE] = ACTIONS(4991),
    [anon_sym_QMARK_QMARK] = ACTIONS(4991),
    [anon_sym_on] = ACTIONS(4991),
    [anon_sym_equals] = ACTIONS(4991),
    [anon_sym_by] = ACTIONS(4991),
    [anon_sym_as] = ACTIONS(4991),
    [anon_sym_is] = ACTIONS(4991),
    [anon_sym_DASH_GT] = ACTIONS(4991),
    [anon_sym_with] = ACTIONS(4991),
    [aux_sym_preproc_if_token3] = ACTIONS(4991),
    [aux_sym_preproc_else_token1] = ACTIONS(4991),
    [aux_sym_preproc_elif_token1] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3446] = {
    [sym_preproc_region] = STATE(3446),
    [sym_preproc_endregion] = STATE(3446),
    [sym_preproc_line] = STATE(3446),
    [sym_preproc_pragma] = STATE(3446),
    [sym_preproc_nullable] = STATE(3446),
    [sym_preproc_error] = STATE(3446),
    [sym_preproc_warning] = STATE(3446),
    [sym_preproc_define] = STATE(3446),
    [sym_preproc_undef] = STATE(3446),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_COLON] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RBRACK] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_in] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_CARET] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5003),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_GT_GT_GT] = ACTIONS(5003),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_EQ_GT] = ACTIONS(5003),
    [anon_sym_switch] = ACTIONS(5003),
    [anon_sym_when] = ACTIONS(5003),
    [anon_sym_DOT_DOT] = ACTIONS(5003),
    [anon_sym_and] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(5003),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_QMARK_QMARK] = ACTIONS(5003),
    [anon_sym_on] = ACTIONS(5003),
    [anon_sym_equals] = ACTIONS(5003),
    [anon_sym_by] = ACTIONS(5003),
    [anon_sym_as] = ACTIONS(5003),
    [anon_sym_is] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [anon_sym_with] = ACTIONS(5003),
    [aux_sym_preproc_if_token3] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3447] = {
    [sym_preproc_region] = STATE(3447),
    [sym_preproc_endregion] = STATE(3447),
    [sym_preproc_line] = STATE(3447),
    [sym_preproc_pragma] = STATE(3447),
    [sym_preproc_nullable] = STATE(3447),
    [sym_preproc_error] = STATE(3447),
    [sym_preproc_warning] = STATE(3447),
    [sym_preproc_define] = STATE(3447),
    [sym_preproc_undef] = STATE(3447),
    [anon_sym_SEMI] = ACTIONS(5007),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_COLON] = ACTIONS(5007),
    [anon_sym_COMMA] = ACTIONS(5007),
    [anon_sym_RBRACK] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_LT] = ACTIONS(5009),
    [anon_sym_GT] = ACTIONS(5009),
    [anon_sym_in] = ACTIONS(5007),
    [anon_sym_QMARK] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_PLUS_PLUS] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5007),
    [anon_sym_PLUS] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5009),
    [anon_sym_PERCENT] = ACTIONS(5007),
    [anon_sym_CARET] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_LT_LT] = ACTIONS(5007),
    [anon_sym_GT_GT] = ACTIONS(5009),
    [anon_sym_GT_GT_GT] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(5007),
    [anon_sym_BANG_EQ] = ACTIONS(5007),
    [anon_sym_GT_EQ] = ACTIONS(5007),
    [anon_sym_LT_EQ] = ACTIONS(5007),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_EQ_GT] = ACTIONS(5007),
    [anon_sym_switch] = ACTIONS(5007),
    [anon_sym_when] = ACTIONS(5007),
    [anon_sym_DOT_DOT] = ACTIONS(5007),
    [anon_sym_and] = ACTIONS(5007),
    [anon_sym_or] = ACTIONS(5007),
    [anon_sym_AMP_AMP] = ACTIONS(5007),
    [anon_sym_PIPE_PIPE] = ACTIONS(5007),
    [anon_sym_QMARK_QMARK] = ACTIONS(5007),
    [anon_sym_on] = ACTIONS(5007),
    [anon_sym_equals] = ACTIONS(5007),
    [anon_sym_by] = ACTIONS(5007),
    [anon_sym_as] = ACTIONS(5007),
    [anon_sym_is] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5007),
    [anon_sym_with] = ACTIONS(5007),
    [aux_sym_preproc_if_token3] = ACTIONS(5007),
    [aux_sym_preproc_else_token1] = ACTIONS(5007),
    [aux_sym_preproc_elif_token1] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3448] = {
    [sym_preproc_region] = STATE(3448),
    [sym_preproc_endregion] = STATE(3448),
    [sym_preproc_line] = STATE(3448),
    [sym_preproc_pragma] = STATE(3448),
    [sym_preproc_nullable] = STATE(3448),
    [sym_preproc_error] = STATE(3448),
    [sym_preproc_warning] = STATE(3448),
    [sym_preproc_define] = STATE(3448),
    [sym_preproc_undef] = STATE(3448),
    [anon_sym_SEMI] = ACTIONS(5019),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_COLON] = ACTIONS(5019),
    [anon_sym_COMMA] = ACTIONS(5019),
    [anon_sym_RBRACK] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_RPAREN] = ACTIONS(5019),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_LT] = ACTIONS(5021),
    [anon_sym_GT] = ACTIONS(5021),
    [anon_sym_in] = ACTIONS(5019),
    [anon_sym_QMARK] = ACTIONS(5021),
    [anon_sym_BANG] = ACTIONS(5021),
    [anon_sym_PLUS_PLUS] = ACTIONS(5019),
    [anon_sym_DASH_DASH] = ACTIONS(5019),
    [anon_sym_PLUS] = ACTIONS(5021),
    [anon_sym_DASH] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(5019),
    [anon_sym_SLASH] = ACTIONS(5021),
    [anon_sym_PERCENT] = ACTIONS(5019),
    [anon_sym_CARET] = ACTIONS(5019),
    [anon_sym_PIPE] = ACTIONS(5021),
    [anon_sym_AMP] = ACTIONS(5021),
    [anon_sym_LT_LT] = ACTIONS(5019),
    [anon_sym_GT_GT] = ACTIONS(5021),
    [anon_sym_GT_GT_GT] = ACTIONS(5019),
    [anon_sym_EQ_EQ] = ACTIONS(5019),
    [anon_sym_BANG_EQ] = ACTIONS(5019),
    [anon_sym_GT_EQ] = ACTIONS(5019),
    [anon_sym_LT_EQ] = ACTIONS(5019),
    [anon_sym_DOT] = ACTIONS(5021),
    [anon_sym_EQ_GT] = ACTIONS(5019),
    [anon_sym_switch] = ACTIONS(5019),
    [anon_sym_when] = ACTIONS(5019),
    [anon_sym_DOT_DOT] = ACTIONS(5019),
    [anon_sym_and] = ACTIONS(5019),
    [anon_sym_or] = ACTIONS(5019),
    [anon_sym_AMP_AMP] = ACTIONS(5019),
    [anon_sym_PIPE_PIPE] = ACTIONS(5019),
    [anon_sym_QMARK_QMARK] = ACTIONS(5019),
    [anon_sym_on] = ACTIONS(5019),
    [anon_sym_equals] = ACTIONS(5019),
    [anon_sym_by] = ACTIONS(5019),
    [anon_sym_as] = ACTIONS(5019),
    [anon_sym_is] = ACTIONS(5019),
    [anon_sym_DASH_GT] = ACTIONS(5019),
    [anon_sym_with] = ACTIONS(5019),
    [aux_sym_preproc_if_token3] = ACTIONS(5019),
    [aux_sym_preproc_else_token1] = ACTIONS(5019),
    [aux_sym_preproc_elif_token1] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3449] = {
    [sym_preproc_region] = STATE(3449),
    [sym_preproc_endregion] = STATE(3449),
    [sym_preproc_line] = STATE(3449),
    [sym_preproc_pragma] = STATE(3449),
    [sym_preproc_nullable] = STATE(3449),
    [sym_preproc_error] = STATE(3449),
    [sym_preproc_warning] = STATE(3449),
    [sym_preproc_define] = STATE(3449),
    [sym_preproc_undef] = STATE(3449),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_COLON] = ACTIONS(5027),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_RBRACK] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_in] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5029),
    [anon_sym_BANG] = ACTIONS(5029),
    [anon_sym_PLUS_PLUS] = ACTIONS(5027),
    [anon_sym_DASH_DASH] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_PERCENT] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_GT] = ACTIONS(5027),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_EQ_GT] = ACTIONS(5027),
    [anon_sym_switch] = ACTIONS(5027),
    [anon_sym_when] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5027),
    [anon_sym_and] = ACTIONS(5027),
    [anon_sym_or] = ACTIONS(5027),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK_QMARK] = ACTIONS(5027),
    [anon_sym_on] = ACTIONS(5027),
    [anon_sym_equals] = ACTIONS(5027),
    [anon_sym_by] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5027),
    [anon_sym_is] = ACTIONS(5027),
    [anon_sym_DASH_GT] = ACTIONS(5027),
    [anon_sym_with] = ACTIONS(5027),
    [aux_sym_preproc_if_token3] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3450] = {
    [sym_preproc_region] = STATE(3450),
    [sym_preproc_endregion] = STATE(3450),
    [sym_preproc_line] = STATE(3450),
    [sym_preproc_pragma] = STATE(3450),
    [sym_preproc_nullable] = STATE(3450),
    [sym_preproc_error] = STATE(3450),
    [sym_preproc_warning] = STATE(3450),
    [sym_preproc_define] = STATE(3450),
    [sym_preproc_undef] = STATE(3450),
    [anon_sym_SEMI] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_COLON] = ACTIONS(5035),
    [anon_sym_COMMA] = ACTIONS(5035),
    [anon_sym_RBRACK] = ACTIONS(5035),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_RPAREN] = ACTIONS(5035),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_GT] = ACTIONS(5037),
    [anon_sym_in] = ACTIONS(5035),
    [anon_sym_QMARK] = ACTIONS(5037),
    [anon_sym_BANG] = ACTIONS(5037),
    [anon_sym_PLUS_PLUS] = ACTIONS(5035),
    [anon_sym_DASH_DASH] = ACTIONS(5035),
    [anon_sym_PLUS] = ACTIONS(5037),
    [anon_sym_DASH] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5035),
    [anon_sym_SLASH] = ACTIONS(5037),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [anon_sym_CARET] = ACTIONS(5035),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(5035),
    [anon_sym_GT_GT] = ACTIONS(5037),
    [anon_sym_GT_GT_GT] = ACTIONS(5035),
    [anon_sym_EQ_EQ] = ACTIONS(5035),
    [anon_sym_BANG_EQ] = ACTIONS(5035),
    [anon_sym_GT_EQ] = ACTIONS(5035),
    [anon_sym_LT_EQ] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5037),
    [anon_sym_EQ_GT] = ACTIONS(5035),
    [anon_sym_switch] = ACTIONS(5035),
    [anon_sym_when] = ACTIONS(5035),
    [anon_sym_DOT_DOT] = ACTIONS(5035),
    [anon_sym_and] = ACTIONS(5035),
    [anon_sym_or] = ACTIONS(5035),
    [anon_sym_AMP_AMP] = ACTIONS(5035),
    [anon_sym_PIPE_PIPE] = ACTIONS(5035),
    [anon_sym_QMARK_QMARK] = ACTIONS(5035),
    [anon_sym_on] = ACTIONS(5035),
    [anon_sym_equals] = ACTIONS(5035),
    [anon_sym_by] = ACTIONS(5035),
    [anon_sym_as] = ACTIONS(5035),
    [anon_sym_is] = ACTIONS(5035),
    [anon_sym_DASH_GT] = ACTIONS(5035),
    [anon_sym_with] = ACTIONS(5035),
    [aux_sym_preproc_if_token3] = ACTIONS(5035),
    [aux_sym_preproc_else_token1] = ACTIONS(5035),
    [aux_sym_preproc_elif_token1] = ACTIONS(5035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3451] = {
    [sym_preproc_region] = STATE(3451),
    [sym_preproc_endregion] = STATE(3451),
    [sym_preproc_line] = STATE(3451),
    [sym_preproc_pragma] = STATE(3451),
    [sym_preproc_nullable] = STATE(3451),
    [sym_preproc_error] = STATE(3451),
    [sym_preproc_warning] = STATE(3451),
    [sym_preproc_define] = STATE(3451),
    [sym_preproc_undef] = STATE(3451),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_COLON] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5039),
    [anon_sym_RBRACK] = ACTIONS(5039),
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_RPAREN] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_in] = ACTIONS(5039),
    [anon_sym_QMARK] = ACTIONS(5041),
    [anon_sym_BANG] = ACTIONS(5041),
    [anon_sym_PLUS_PLUS] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(5039),
    [anon_sym_PLUS] = ACTIONS(5041),
    [anon_sym_DASH] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_SLASH] = ACTIONS(5041),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_CARET] = ACTIONS(5039),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5041),
    [anon_sym_LT_LT] = ACTIONS(5039),
    [anon_sym_GT_GT] = ACTIONS(5041),
    [anon_sym_GT_GT_GT] = ACTIONS(5039),
    [anon_sym_EQ_EQ] = ACTIONS(5039),
    [anon_sym_BANG_EQ] = ACTIONS(5039),
    [anon_sym_GT_EQ] = ACTIONS(5039),
    [anon_sym_LT_EQ] = ACTIONS(5039),
    [anon_sym_DOT] = ACTIONS(5041),
    [anon_sym_EQ_GT] = ACTIONS(5039),
    [anon_sym_switch] = ACTIONS(5039),
    [anon_sym_when] = ACTIONS(5039),
    [anon_sym_DOT_DOT] = ACTIONS(5039),
    [anon_sym_and] = ACTIONS(5039),
    [anon_sym_or] = ACTIONS(5039),
    [anon_sym_AMP_AMP] = ACTIONS(5039),
    [anon_sym_PIPE_PIPE] = ACTIONS(5039),
    [anon_sym_QMARK_QMARK] = ACTIONS(5039),
    [anon_sym_on] = ACTIONS(5039),
    [anon_sym_equals] = ACTIONS(5039),
    [anon_sym_by] = ACTIONS(5039),
    [anon_sym_as] = ACTIONS(5039),
    [anon_sym_is] = ACTIONS(5039),
    [anon_sym_DASH_GT] = ACTIONS(5039),
    [anon_sym_with] = ACTIONS(5039),
    [aux_sym_preproc_if_token3] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3452] = {
    [sym_preproc_region] = STATE(3452),
    [sym_preproc_endregion] = STATE(3452),
    [sym_preproc_line] = STATE(3452),
    [sym_preproc_pragma] = STATE(3452),
    [sym_preproc_nullable] = STATE(3452),
    [sym_preproc_error] = STATE(3452),
    [sym_preproc_warning] = STATE(3452),
    [sym_preproc_define] = STATE(3452),
    [sym_preproc_undef] = STATE(3452),
    [anon_sym_SEMI] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_COLON] = ACTIONS(5047),
    [anon_sym_COMMA] = ACTIONS(5047),
    [anon_sym_RBRACK] = ACTIONS(5047),
    [anon_sym_LPAREN] = ACTIONS(5047),
    [anon_sym_RPAREN] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_in] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_BANG] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5049),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_PIPE] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5049),
    [anon_sym_GT_GT_GT] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5047),
    [anon_sym_BANG_EQ] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_DOT] = ACTIONS(5049),
    [anon_sym_EQ_GT] = ACTIONS(5047),
    [anon_sym_switch] = ACTIONS(5047),
    [anon_sym_when] = ACTIONS(5047),
    [anon_sym_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_QMARK_QMARK] = ACTIONS(5047),
    [anon_sym_on] = ACTIONS(5047),
    [anon_sym_equals] = ACTIONS(5047),
    [anon_sym_by] = ACTIONS(5047),
    [anon_sym_as] = ACTIONS(5047),
    [anon_sym_is] = ACTIONS(5047),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [anon_sym_with] = ACTIONS(5047),
    [aux_sym_preproc_if_token3] = ACTIONS(5047),
    [aux_sym_preproc_else_token1] = ACTIONS(5047),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3453] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7499),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3453),
    [sym_preproc_endregion] = STATE(3453),
    [sym_preproc_line] = STATE(3453),
    [sym_preproc_pragma] = STATE(3453),
    [sym_preproc_nullable] = STATE(3453),
    [sym_preproc_error] = STATE(3453),
    [sym_preproc_warning] = STATE(3453),
    [sym_preproc_define] = STATE(3453),
    [sym_preproc_undef] = STATE(3453),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3454] = {
    [sym_preproc_region] = STATE(3454),
    [sym_preproc_endregion] = STATE(3454),
    [sym_preproc_line] = STATE(3454),
    [sym_preproc_pragma] = STATE(3454),
    [sym_preproc_nullable] = STATE(3454),
    [sym_preproc_error] = STATE(3454),
    [sym_preproc_warning] = STATE(3454),
    [sym_preproc_define] = STATE(3454),
    [sym_preproc_undef] = STATE(3454),
    [anon_sym_SEMI] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_COLON] = ACTIONS(5067),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_RBRACK] = ACTIONS(5067),
    [anon_sym_LPAREN] = ACTIONS(5067),
    [anon_sym_RPAREN] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5067),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_in] = ACTIONS(5067),
    [anon_sym_QMARK] = ACTIONS(5069),
    [anon_sym_BANG] = ACTIONS(5069),
    [anon_sym_PLUS_PLUS] = ACTIONS(5067),
    [anon_sym_DASH_DASH] = ACTIONS(5067),
    [anon_sym_PLUS] = ACTIONS(5069),
    [anon_sym_DASH] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5067),
    [anon_sym_SLASH] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5067),
    [anon_sym_CARET] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5067),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_GT_GT_GT] = ACTIONS(5067),
    [anon_sym_EQ_EQ] = ACTIONS(5067),
    [anon_sym_BANG_EQ] = ACTIONS(5067),
    [anon_sym_GT_EQ] = ACTIONS(5067),
    [anon_sym_LT_EQ] = ACTIONS(5067),
    [anon_sym_DOT] = ACTIONS(5069),
    [anon_sym_EQ_GT] = ACTIONS(5067),
    [anon_sym_switch] = ACTIONS(5067),
    [anon_sym_when] = ACTIONS(5067),
    [anon_sym_DOT_DOT] = ACTIONS(5067),
    [anon_sym_and] = ACTIONS(5067),
    [anon_sym_or] = ACTIONS(5067),
    [anon_sym_AMP_AMP] = ACTIONS(5067),
    [anon_sym_PIPE_PIPE] = ACTIONS(5067),
    [anon_sym_QMARK_QMARK] = ACTIONS(5067),
    [anon_sym_on] = ACTIONS(5067),
    [anon_sym_equals] = ACTIONS(5067),
    [anon_sym_by] = ACTIONS(5067),
    [anon_sym_as] = ACTIONS(5067),
    [anon_sym_is] = ACTIONS(5067),
    [anon_sym_DASH_GT] = ACTIONS(5067),
    [anon_sym_with] = ACTIONS(5067),
    [aux_sym_preproc_if_token3] = ACTIONS(5067),
    [aux_sym_preproc_else_token1] = ACTIONS(5067),
    [aux_sym_preproc_elif_token1] = ACTIONS(5067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3455] = {
    [sym_preproc_region] = STATE(3455),
    [sym_preproc_endregion] = STATE(3455),
    [sym_preproc_line] = STATE(3455),
    [sym_preproc_pragma] = STATE(3455),
    [sym_preproc_nullable] = STATE(3455),
    [sym_preproc_error] = STATE(3455),
    [sym_preproc_warning] = STATE(3455),
    [sym_preproc_define] = STATE(3455),
    [sym_preproc_undef] = STATE(3455),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(5097),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_RBRACK] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5099),
    [anon_sym_in] = ACTIONS(5097),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_BANG] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_SLASH] = ACTIONS(5099),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5097),
    [anon_sym_PIPE] = ACTIONS(5099),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym_LT_LT] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5099),
    [anon_sym_GT_GT_GT] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_DOT] = ACTIONS(5099),
    [anon_sym_EQ_GT] = ACTIONS(5097),
    [anon_sym_switch] = ACTIONS(5097),
    [anon_sym_when] = ACTIONS(5097),
    [anon_sym_DOT_DOT] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_or] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_QMARK_QMARK] = ACTIONS(5097),
    [anon_sym_on] = ACTIONS(5097),
    [anon_sym_equals] = ACTIONS(5097),
    [anon_sym_by] = ACTIONS(5097),
    [anon_sym_as] = ACTIONS(5097),
    [anon_sym_is] = ACTIONS(5097),
    [anon_sym_DASH_GT] = ACTIONS(5097),
    [anon_sym_with] = ACTIONS(5097),
    [aux_sym_preproc_if_token3] = ACTIONS(5097),
    [aux_sym_preproc_else_token1] = ACTIONS(5097),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3456] = {
    [sym_preproc_region] = STATE(3456),
    [sym_preproc_endregion] = STATE(3456),
    [sym_preproc_line] = STATE(3456),
    [sym_preproc_pragma] = STATE(3456),
    [sym_preproc_nullable] = STATE(3456),
    [sym_preproc_error] = STATE(3456),
    [sym_preproc_warning] = STATE(3456),
    [sym_preproc_define] = STATE(3456),
    [sym_preproc_undef] = STATE(3456),
    [anon_sym_SEMI] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5117),
    [anon_sym_COMMA] = ACTIONS(5117),
    [anon_sym_RBRACK] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_RPAREN] = ACTIONS(5117),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5119),
    [anon_sym_in] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_BANG] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_PIPE] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_GT_GT_GT] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5117),
    [anon_sym_BANG_EQ] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5117),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_DOT] = ACTIONS(5119),
    [anon_sym_EQ_GT] = ACTIONS(5117),
    [anon_sym_switch] = ACTIONS(5117),
    [anon_sym_when] = ACTIONS(5117),
    [anon_sym_DOT_DOT] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5117),
    [anon_sym_QMARK_QMARK] = ACTIONS(5117),
    [anon_sym_on] = ACTIONS(5117),
    [anon_sym_equals] = ACTIONS(5117),
    [anon_sym_by] = ACTIONS(5117),
    [anon_sym_as] = ACTIONS(5117),
    [anon_sym_is] = ACTIONS(5117),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [anon_sym_with] = ACTIONS(5117),
    [aux_sym_preproc_if_token3] = ACTIONS(5117),
    [aux_sym_preproc_else_token1] = ACTIONS(5117),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3457] = {
    [sym_preproc_region] = STATE(3457),
    [sym_preproc_endregion] = STATE(3457),
    [sym_preproc_line] = STATE(3457),
    [sym_preproc_pragma] = STATE(3457),
    [sym_preproc_nullable] = STATE(3457),
    [sym_preproc_error] = STATE(3457),
    [sym_preproc_warning] = STATE(3457),
    [sym_preproc_define] = STATE(3457),
    [sym_preproc_undef] = STATE(3457),
    [anon_sym_SEMI] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5121),
    [anon_sym_RBRACK] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_RPAREN] = ACTIONS(5121),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5123),
    [anon_sym_in] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5123),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5123),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_PIPE] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_GT_GT_GT] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5121),
    [anon_sym_BANG_EQ] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5121),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_DOT] = ACTIONS(5123),
    [anon_sym_EQ_GT] = ACTIONS(5121),
    [anon_sym_switch] = ACTIONS(5121),
    [anon_sym_when] = ACTIONS(5121),
    [anon_sym_DOT_DOT] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5121),
    [anon_sym_QMARK_QMARK] = ACTIONS(5121),
    [anon_sym_on] = ACTIONS(5121),
    [anon_sym_equals] = ACTIONS(5121),
    [anon_sym_by] = ACTIONS(5121),
    [anon_sym_as] = ACTIONS(5121),
    [anon_sym_is] = ACTIONS(5121),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [anon_sym_with] = ACTIONS(5121),
    [aux_sym_preproc_if_token3] = ACTIONS(5121),
    [aux_sym_preproc_else_token1] = ACTIONS(5121),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3458] = {
    [sym_preproc_region] = STATE(3458),
    [sym_preproc_endregion] = STATE(3458),
    [sym_preproc_line] = STATE(3458),
    [sym_preproc_pragma] = STATE(3458),
    [sym_preproc_nullable] = STATE(3458),
    [sym_preproc_error] = STATE(3458),
    [sym_preproc_warning] = STATE(3458),
    [sym_preproc_define] = STATE(3458),
    [sym_preproc_undef] = STATE(3458),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5129),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_in] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_BANG] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5131),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_GT_GT_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_BANG_EQ] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5129),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_DOT] = ACTIONS(5131),
    [anon_sym_EQ_GT] = ACTIONS(5129),
    [anon_sym_switch] = ACTIONS(5129),
    [anon_sym_when] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_or] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_QMARK_QMARK] = ACTIONS(5129),
    [anon_sym_on] = ACTIONS(5129),
    [anon_sym_equals] = ACTIONS(5129),
    [anon_sym_by] = ACTIONS(5129),
    [anon_sym_as] = ACTIONS(5129),
    [anon_sym_is] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_with] = ACTIONS(5129),
    [aux_sym_preproc_if_token3] = ACTIONS(5129),
    [aux_sym_preproc_else_token1] = ACTIONS(5129),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3459] = {
    [sym_preproc_region] = STATE(3459),
    [sym_preproc_endregion] = STATE(3459),
    [sym_preproc_line] = STATE(3459),
    [sym_preproc_pragma] = STATE(3459),
    [sym_preproc_nullable] = STATE(3459),
    [sym_preproc_error] = STATE(3459),
    [sym_preproc_warning] = STATE(3459),
    [sym_preproc_define] = STATE(3459),
    [sym_preproc_undef] = STATE(3459),
    [anon_sym_SEMI] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5135),
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_RBRACK] = ACTIONS(5135),
    [anon_sym_LPAREN] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_in] = ACTIONS(5135),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_BANG] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5137),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5137),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5137),
    [anon_sym_AMP] = ACTIONS(5137),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_GT_GT_GT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_DOT] = ACTIONS(5137),
    [anon_sym_EQ_GT] = ACTIONS(5135),
    [anon_sym_switch] = ACTIONS(5135),
    [anon_sym_when] = ACTIONS(5135),
    [anon_sym_DOT_DOT] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_or] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_QMARK_QMARK] = ACTIONS(5135),
    [anon_sym_on] = ACTIONS(5135),
    [anon_sym_equals] = ACTIONS(5135),
    [anon_sym_by] = ACTIONS(5135),
    [anon_sym_as] = ACTIONS(5135),
    [anon_sym_is] = ACTIONS(5135),
    [anon_sym_DASH_GT] = ACTIONS(5135),
    [anon_sym_with] = ACTIONS(5135),
    [aux_sym_preproc_if_token3] = ACTIONS(5135),
    [aux_sym_preproc_else_token1] = ACTIONS(5135),
    [aux_sym_preproc_elif_token1] = ACTIONS(5135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3460] = {
    [sym_preproc_region] = STATE(3460),
    [sym_preproc_endregion] = STATE(3460),
    [sym_preproc_line] = STATE(3460),
    [sym_preproc_pragma] = STATE(3460),
    [sym_preproc_nullable] = STATE(3460),
    [sym_preproc_error] = STATE(3460),
    [sym_preproc_warning] = STATE(3460),
    [sym_preproc_define] = STATE(3460),
    [sym_preproc_undef] = STATE(3460),
    [anon_sym_SEMI] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RBRACK] = ACTIONS(5139),
    [anon_sym_LPAREN] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_in] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(5141),
    [anon_sym_BANG] = ACTIONS(5141),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5141),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5141),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5141),
    [anon_sym_AMP] = ACTIONS(5141),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5141),
    [anon_sym_GT_GT_GT] = ACTIONS(5139),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5141),
    [anon_sym_EQ_GT] = ACTIONS(5139),
    [anon_sym_switch] = ACTIONS(5139),
    [anon_sym_when] = ACTIONS(5139),
    [anon_sym_DOT_DOT] = ACTIONS(5139),
    [anon_sym_and] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_QMARK_QMARK] = ACTIONS(5139),
    [anon_sym_on] = ACTIONS(5139),
    [anon_sym_equals] = ACTIONS(5139),
    [anon_sym_by] = ACTIONS(5139),
    [anon_sym_as] = ACTIONS(5139),
    [anon_sym_is] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [anon_sym_with] = ACTIONS(5139),
    [aux_sym_preproc_if_token3] = ACTIONS(5139),
    [aux_sym_preproc_else_token1] = ACTIONS(5139),
    [aux_sym_preproc_elif_token1] = ACTIONS(5139),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3461] = {
    [sym_preproc_region] = STATE(3461),
    [sym_preproc_endregion] = STATE(3461),
    [sym_preproc_line] = STATE(3461),
    [sym_preproc_pragma] = STATE(3461),
    [sym_preproc_nullable] = STATE(3461),
    [sym_preproc_error] = STATE(3461),
    [sym_preproc_warning] = STATE(3461),
    [sym_preproc_define] = STATE(3461),
    [sym_preproc_undef] = STATE(3461),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(5524),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5526),
    [anon_sym_DASH_EQ] = ACTIONS(5526),
    [anon_sym_STAR_EQ] = ACTIONS(5526),
    [anon_sym_SLASH_EQ] = ACTIONS(5526),
    [anon_sym_PERCENT_EQ] = ACTIONS(5526),
    [anon_sym_AMP_EQ] = ACTIONS(5526),
    [anon_sym_CARET_EQ] = ACTIONS(5526),
    [anon_sym_PIPE_EQ] = ACTIONS(5526),
    [anon_sym_LT_LT_EQ] = ACTIONS(5526),
    [anon_sym_GT_GT_EQ] = ACTIONS(5526),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3462] = {
    [sym_preproc_region] = STATE(3462),
    [sym_preproc_endregion] = STATE(3462),
    [sym_preproc_line] = STATE(3462),
    [sym_preproc_pragma] = STATE(3462),
    [sym_preproc_nullable] = STATE(3462),
    [sym_preproc_error] = STATE(3462),
    [sym_preproc_warning] = STATE(3462),
    [sym_preproc_define] = STATE(3462),
    [sym_preproc_undef] = STATE(3462),
    [sym__identifier_token] = ACTIONS(5528),
    [anon_sym_extern] = ACTIONS(5528),
    [anon_sym_alias] = ACTIONS(5528),
    [anon_sym_global] = ACTIONS(5528),
    [anon_sym_unsafe] = ACTIONS(5528),
    [anon_sym_static] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_abstract] = ACTIONS(5528),
    [anon_sym_async] = ACTIONS(5528),
    [anon_sym_const] = ACTIONS(5528),
    [anon_sym_file] = ACTIONS(5528),
    [anon_sym_fixed] = ACTIONS(5528),
    [anon_sym_internal] = ACTIONS(5528),
    [anon_sym_new] = ACTIONS(5528),
    [anon_sym_override] = ACTIONS(5528),
    [anon_sym_partial] = ACTIONS(5528),
    [anon_sym_private] = ACTIONS(5528),
    [anon_sym_protected] = ACTIONS(5528),
    [anon_sym_public] = ACTIONS(5528),
    [anon_sym_readonly] = ACTIONS(5528),
    [anon_sym_required] = ACTIONS(5528),
    [anon_sym_sealed] = ACTIONS(5528),
    [anon_sym_virtual] = ACTIONS(5528),
    [anon_sym_volatile] = ACTIONS(5528),
    [anon_sym_where] = ACTIONS(5528),
    [anon_sym_notnull] = ACTIONS(5528),
    [anon_sym_unmanaged] = ACTIONS(5528),
    [anon_sym_get] = ACTIONS(5528),
    [anon_sym_set] = ACTIONS(5528),
    [anon_sym_add] = ACTIONS(5528),
    [anon_sym_remove] = ACTIONS(5528),
    [anon_sym_init] = ACTIONS(5528),
    [anon_sym_scoped] = ACTIONS(5528),
    [anon_sym_var] = ACTIONS(5528),
    [anon_sym_yield] = ACTIONS(5528),
    [anon_sym_when] = ACTIONS(5528),
    [anon_sym_from] = ACTIONS(5528),
    [anon_sym_into] = ACTIONS(5528),
    [anon_sym_join] = ACTIONS(5528),
    [anon_sym_on] = ACTIONS(5528),
    [anon_sym_equals] = ACTIONS(5528),
    [anon_sym_let] = ACTIONS(5528),
    [anon_sym_orderby] = ACTIONS(5528),
    [anon_sym_ascending] = ACTIONS(5528),
    [anon_sym_descending] = ACTIONS(5528),
    [anon_sym_group] = ACTIONS(5528),
    [anon_sym_by] = ACTIONS(5528),
    [anon_sym_select] = ACTIONS(5528),
    [aux_sym_preproc_if_token1] = ACTIONS(5530),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3463] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5960),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7542),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3463),
    [sym_preproc_endregion] = STATE(3463),
    [sym_preproc_line] = STATE(3463),
    [sym_preproc_pragma] = STATE(3463),
    [sym_preproc_nullable] = STATE(3463),
    [sym_preproc_error] = STATE(3463),
    [sym_preproc_warning] = STATE(3463),
    [sym_preproc_define] = STATE(3463),
    [sym_preproc_undef] = STATE(3463),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3464] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3464),
    [sym_preproc_endregion] = STATE(3464),
    [sym_preproc_line] = STATE(3464),
    [sym_preproc_pragma] = STATE(3464),
    [sym_preproc_nullable] = STATE(3464),
    [sym_preproc_error] = STATE(3464),
    [sym_preproc_warning] = STATE(3464),
    [sym_preproc_define] = STATE(3464),
    [sym_preproc_undef] = STATE(3464),
    [sym__identifier_token] = ACTIONS(3601),
    [anon_sym_alias] = ACTIONS(3605),
    [anon_sym_global] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(2719),
    [anon_sym_delegate] = ACTIONS(2719),
    [anon_sym_file] = ACTIONS(3605),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3605),
    [anon_sym_unmanaged] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(2719),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3605),
    [sym_predefined_type] = ACTIONS(2719),
    [anon_sym_yield] = ACTIONS(3605),
    [anon_sym_when] = ACTIONS(3605),
    [anon_sym_from] = ACTIONS(3605),
    [anon_sym_into] = ACTIONS(3605),
    [anon_sym_join] = ACTIONS(3605),
    [anon_sym_on] = ACTIONS(3605),
    [anon_sym_equals] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_orderby] = ACTIONS(3605),
    [anon_sym_ascending] = ACTIONS(3605),
    [anon_sym_descending] = ACTIONS(3605),
    [anon_sym_group] = ACTIONS(3605),
    [anon_sym_by] = ACTIONS(3605),
    [anon_sym_select] = ACTIONS(3605),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3465] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7426),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3465),
    [sym_preproc_endregion] = STATE(3465),
    [sym_preproc_line] = STATE(3465),
    [sym_preproc_pragma] = STATE(3465),
    [sym_preproc_nullable] = STATE(3465),
    [sym_preproc_error] = STATE(3465),
    [sym_preproc_warning] = STATE(3465),
    [sym_preproc_define] = STATE(3465),
    [sym_preproc_undef] = STATE(3465),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3466] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7499),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3466),
    [sym_preproc_endregion] = STATE(3466),
    [sym_preproc_line] = STATE(3466),
    [sym_preproc_pragma] = STATE(3466),
    [sym_preproc_nullable] = STATE(3466),
    [sym_preproc_error] = STATE(3466),
    [sym_preproc_warning] = STATE(3466),
    [sym_preproc_define] = STATE(3466),
    [sym_preproc_undef] = STATE(3466),
    [aux_sym_function_pointer_type_repeat1] = STATE(3465),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3467] = {
    [sym_preproc_region] = STATE(3467),
    [sym_preproc_endregion] = STATE(3467),
    [sym_preproc_line] = STATE(3467),
    [sym_preproc_pragma] = STATE(3467),
    [sym_preproc_nullable] = STATE(3467),
    [sym_preproc_error] = STATE(3467),
    [sym_preproc_warning] = STATE(3467),
    [sym_preproc_define] = STATE(3467),
    [sym_preproc_undef] = STATE(3467),
    [anon_sym_SEMI] = ACTIONS(5011),
    [anon_sym_LBRACK] = ACTIONS(5011),
    [anon_sym_COLON] = ACTIONS(5011),
    [anon_sym_COMMA] = ACTIONS(5011),
    [anon_sym_RBRACK] = ACTIONS(5011),
    [anon_sym_LPAREN] = ACTIONS(5011),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [anon_sym_LT] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5013),
    [anon_sym_in] = ACTIONS(5011),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_BANG] = ACTIONS(5013),
    [anon_sym_PLUS_PLUS] = ACTIONS(5011),
    [anon_sym_DASH_DASH] = ACTIONS(5011),
    [anon_sym_PLUS] = ACTIONS(5013),
    [anon_sym_DASH] = ACTIONS(5013),
    [anon_sym_STAR] = ACTIONS(5011),
    [anon_sym_SLASH] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5011),
    [anon_sym_CARET] = ACTIONS(5011),
    [anon_sym_PIPE] = ACTIONS(5013),
    [anon_sym_AMP] = ACTIONS(5013),
    [anon_sym_LT_LT] = ACTIONS(5011),
    [anon_sym_GT_GT] = ACTIONS(5013),
    [anon_sym_GT_GT_GT] = ACTIONS(5011),
    [anon_sym_EQ_EQ] = ACTIONS(5011),
    [anon_sym_BANG_EQ] = ACTIONS(5011),
    [anon_sym_GT_EQ] = ACTIONS(5011),
    [anon_sym_LT_EQ] = ACTIONS(5011),
    [anon_sym_DOT] = ACTIONS(5013),
    [anon_sym_EQ_GT] = ACTIONS(5011),
    [anon_sym_switch] = ACTIONS(5011),
    [anon_sym_when] = ACTIONS(5011),
    [anon_sym_DOT_DOT] = ACTIONS(5011),
    [anon_sym_and] = ACTIONS(5011),
    [anon_sym_or] = ACTIONS(5011),
    [anon_sym_AMP_AMP] = ACTIONS(5011),
    [anon_sym_PIPE_PIPE] = ACTIONS(5011),
    [anon_sym_QMARK_QMARK] = ACTIONS(5011),
    [anon_sym_on] = ACTIONS(5011),
    [anon_sym_equals] = ACTIONS(5011),
    [anon_sym_by] = ACTIONS(5011),
    [anon_sym_as] = ACTIONS(5011),
    [anon_sym_is] = ACTIONS(5011),
    [anon_sym_DASH_GT] = ACTIONS(5011),
    [anon_sym_with] = ACTIONS(5011),
    [aux_sym_preproc_if_token3] = ACTIONS(5011),
    [aux_sym_preproc_else_token1] = ACTIONS(5011),
    [aux_sym_preproc_elif_token1] = ACTIONS(5011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3468] = {
    [sym_preproc_region] = STATE(3468),
    [sym_preproc_endregion] = STATE(3468),
    [sym_preproc_line] = STATE(3468),
    [sym_preproc_pragma] = STATE(3468),
    [sym_preproc_nullable] = STATE(3468),
    [sym_preproc_error] = STATE(3468),
    [sym_preproc_warning] = STATE(3468),
    [sym_preproc_define] = STATE(3468),
    [sym_preproc_undef] = STATE(3468),
    [anon_sym_SEMI] = ACTIONS(5159),
    [anon_sym_LBRACK] = ACTIONS(5159),
    [anon_sym_COLON] = ACTIONS(5159),
    [anon_sym_COMMA] = ACTIONS(5159),
    [anon_sym_RBRACK] = ACTIONS(5159),
    [anon_sym_LPAREN] = ACTIONS(5159),
    [anon_sym_RPAREN] = ACTIONS(5159),
    [anon_sym_RBRACE] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_in] = ACTIONS(5159),
    [anon_sym_QMARK] = ACTIONS(5161),
    [anon_sym_BANG] = ACTIONS(5161),
    [anon_sym_PLUS_PLUS] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(5161),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_AMP] = ACTIONS(5161),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5161),
    [anon_sym_GT_GT_GT] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5159),
    [anon_sym_BANG_EQ] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5159),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_DOT] = ACTIONS(5161),
    [anon_sym_EQ_GT] = ACTIONS(5159),
    [anon_sym_switch] = ACTIONS(5159),
    [anon_sym_when] = ACTIONS(5159),
    [anon_sym_DOT_DOT] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_QMARK_QMARK] = ACTIONS(5159),
    [anon_sym_on] = ACTIONS(5159),
    [anon_sym_equals] = ACTIONS(5159),
    [anon_sym_by] = ACTIONS(5159),
    [anon_sym_as] = ACTIONS(5159),
    [anon_sym_is] = ACTIONS(5159),
    [anon_sym_DASH_GT] = ACTIONS(5159),
    [anon_sym_with] = ACTIONS(5159),
    [aux_sym_preproc_if_token3] = ACTIONS(5159),
    [aux_sym_preproc_else_token1] = ACTIONS(5159),
    [aux_sym_preproc_elif_token1] = ACTIONS(5159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3469] = {
    [sym_preproc_region] = STATE(3469),
    [sym_preproc_endregion] = STATE(3469),
    [sym_preproc_line] = STATE(3469),
    [sym_preproc_pragma] = STATE(3469),
    [sym_preproc_nullable] = STATE(3469),
    [sym_preproc_error] = STATE(3469),
    [sym_preproc_warning] = STATE(3469),
    [sym_preproc_define] = STATE(3469),
    [sym_preproc_undef] = STATE(3469),
    [anon_sym_SEMI] = ACTIONS(5015),
    [anon_sym_LBRACK] = ACTIONS(5015),
    [anon_sym_COLON] = ACTIONS(5015),
    [anon_sym_COMMA] = ACTIONS(5015),
    [anon_sym_RBRACK] = ACTIONS(5015),
    [anon_sym_LPAREN] = ACTIONS(5015),
    [anon_sym_RPAREN] = ACTIONS(5015),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_LT] = ACTIONS(5017),
    [anon_sym_GT] = ACTIONS(5017),
    [anon_sym_in] = ACTIONS(5015),
    [anon_sym_QMARK] = ACTIONS(5017),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_PLUS_PLUS] = ACTIONS(5015),
    [anon_sym_DASH_DASH] = ACTIONS(5015),
    [anon_sym_PLUS] = ACTIONS(5017),
    [anon_sym_DASH] = ACTIONS(5017),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_SLASH] = ACTIONS(5017),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_PIPE] = ACTIONS(5017),
    [anon_sym_AMP] = ACTIONS(5017),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_GT_GT] = ACTIONS(5017),
    [anon_sym_GT_GT_GT] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5015),
    [anon_sym_BANG_EQ] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5015),
    [anon_sym_LT_EQ] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5017),
    [anon_sym_EQ_GT] = ACTIONS(5015),
    [anon_sym_switch] = ACTIONS(5015),
    [anon_sym_when] = ACTIONS(5015),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_and] = ACTIONS(5015),
    [anon_sym_or] = ACTIONS(5015),
    [anon_sym_AMP_AMP] = ACTIONS(5015),
    [anon_sym_PIPE_PIPE] = ACTIONS(5015),
    [anon_sym_QMARK_QMARK] = ACTIONS(5015),
    [anon_sym_on] = ACTIONS(5015),
    [anon_sym_equals] = ACTIONS(5015),
    [anon_sym_by] = ACTIONS(5015),
    [anon_sym_as] = ACTIONS(5015),
    [anon_sym_is] = ACTIONS(5015),
    [anon_sym_DASH_GT] = ACTIONS(5015),
    [anon_sym_with] = ACTIONS(5015),
    [aux_sym_preproc_if_token3] = ACTIONS(5015),
    [aux_sym_preproc_else_token1] = ACTIONS(5015),
    [aux_sym_preproc_elif_token1] = ACTIONS(5015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3470] = {
    [sym_preproc_region] = STATE(3470),
    [sym_preproc_endregion] = STATE(3470),
    [sym_preproc_line] = STATE(3470),
    [sym_preproc_pragma] = STATE(3470),
    [sym_preproc_nullable] = STATE(3470),
    [sym_preproc_error] = STATE(3470),
    [sym_preproc_warning] = STATE(3470),
    [sym_preproc_define] = STATE(3470),
    [sym_preproc_undef] = STATE(3470),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym_LBRACK] = ACTIONS(5437),
    [anon_sym_COLON] = ACTIONS(5437),
    [anon_sym_COMMA] = ACTIONS(5437),
    [anon_sym_RBRACK] = ACTIONS(5437),
    [anon_sym_LPAREN] = ACTIONS(5437),
    [anon_sym_RPAREN] = ACTIONS(5437),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_in] = ACTIONS(5437),
    [anon_sym_QMARK] = ACTIONS(5439),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS_PLUS] = ACTIONS(5437),
    [anon_sym_DASH_DASH] = ACTIONS(5437),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5437),
    [anon_sym_CARET] = ACTIONS(5437),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5437),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_GT_GT_GT] = ACTIONS(5437),
    [anon_sym_EQ_EQ] = ACTIONS(5437),
    [anon_sym_BANG_EQ] = ACTIONS(5437),
    [anon_sym_GT_EQ] = ACTIONS(5437),
    [anon_sym_LT_EQ] = ACTIONS(5437),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_EQ_GT] = ACTIONS(5437),
    [anon_sym_switch] = ACTIONS(5437),
    [anon_sym_when] = ACTIONS(5437),
    [anon_sym_DOT_DOT] = ACTIONS(5437),
    [anon_sym_and] = ACTIONS(5437),
    [anon_sym_or] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_PIPE_PIPE] = ACTIONS(5437),
    [anon_sym_QMARK_QMARK] = ACTIONS(5437),
    [anon_sym_on] = ACTIONS(5437),
    [anon_sym_equals] = ACTIONS(5437),
    [anon_sym_by] = ACTIONS(5437),
    [anon_sym_as] = ACTIONS(5437),
    [anon_sym_is] = ACTIONS(5437),
    [anon_sym_DASH_GT] = ACTIONS(5437),
    [anon_sym_with] = ACTIONS(5437),
    [aux_sym_preproc_if_token3] = ACTIONS(5437),
    [aux_sym_preproc_else_token1] = ACTIONS(5437),
    [aux_sym_preproc_elif_token1] = ACTIONS(5437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3471] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7387),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3471),
    [sym_preproc_endregion] = STATE(3471),
    [sym_preproc_line] = STATE(3471),
    [sym_preproc_pragma] = STATE(3471),
    [sym_preproc_nullable] = STATE(3471),
    [sym_preproc_error] = STATE(3471),
    [sym_preproc_warning] = STATE(3471),
    [sym_preproc_define] = STATE(3471),
    [sym_preproc_undef] = STATE(3471),
    [aux_sym_function_pointer_type_repeat1] = STATE(3453),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3472] = {
    [sym_preproc_region] = STATE(3472),
    [sym_preproc_endregion] = STATE(3472),
    [sym_preproc_line] = STATE(3472),
    [sym_preproc_pragma] = STATE(3472),
    [sym_preproc_nullable] = STATE(3472),
    [sym_preproc_error] = STATE(3472),
    [sym_preproc_warning] = STATE(3472),
    [sym_preproc_define] = STATE(3472),
    [sym_preproc_undef] = STATE(3472),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3473] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3473),
    [sym_preproc_endregion] = STATE(3473),
    [sym_preproc_line] = STATE(3473),
    [sym_preproc_pragma] = STATE(3473),
    [sym_preproc_nullable] = STATE(3473),
    [sym_preproc_error] = STATE(3473),
    [sym_preproc_warning] = STATE(3473),
    [sym_preproc_define] = STATE(3473),
    [sym_preproc_undef] = STATE(3473),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(5536),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3474] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7442),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3474),
    [sym_preproc_endregion] = STATE(3474),
    [sym_preproc_line] = STATE(3474),
    [sym_preproc_pragma] = STATE(3474),
    [sym_preproc_nullable] = STATE(3474),
    [sym_preproc_error] = STATE(3474),
    [sym_preproc_warning] = STATE(3474),
    [sym_preproc_define] = STATE(3474),
    [sym_preproc_undef] = STATE(3474),
    [aux_sym_function_pointer_type_repeat1] = STATE(3476),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3475] = {
    [sym_preproc_region] = STATE(3475),
    [sym_preproc_endregion] = STATE(3475),
    [sym_preproc_line] = STATE(3475),
    [sym_preproc_pragma] = STATE(3475),
    [sym_preproc_nullable] = STATE(3475),
    [sym_preproc_error] = STATE(3475),
    [sym_preproc_warning] = STATE(3475),
    [sym_preproc_define] = STATE(3475),
    [sym_preproc_undef] = STATE(3475),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [anon_sym_COLON] = ACTIONS(5445),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RBRACK] = ACTIONS(5445),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_in] = ACTIONS(5445),
    [anon_sym_QMARK] = ACTIONS(5447),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5445),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5445),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_GT_GT_GT] = ACTIONS(5445),
    [anon_sym_EQ_EQ] = ACTIONS(5445),
    [anon_sym_BANG_EQ] = ACTIONS(5445),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [anon_sym_LT_EQ] = ACTIONS(5445),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_EQ_GT] = ACTIONS(5445),
    [anon_sym_switch] = ACTIONS(5445),
    [anon_sym_when] = ACTIONS(5445),
    [anon_sym_DOT_DOT] = ACTIONS(5445),
    [anon_sym_and] = ACTIONS(5445),
    [anon_sym_or] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_QMARK_QMARK] = ACTIONS(5445),
    [anon_sym_on] = ACTIONS(5445),
    [anon_sym_equals] = ACTIONS(5445),
    [anon_sym_by] = ACTIONS(5445),
    [anon_sym_as] = ACTIONS(5445),
    [anon_sym_is] = ACTIONS(5445),
    [anon_sym_DASH_GT] = ACTIONS(5445),
    [anon_sym_with] = ACTIONS(5445),
    [aux_sym_preproc_if_token3] = ACTIONS(5445),
    [aux_sym_preproc_else_token1] = ACTIONS(5445),
    [aux_sym_preproc_elif_token1] = ACTIONS(5445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3476] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7518),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3476),
    [sym_preproc_endregion] = STATE(3476),
    [sym_preproc_line] = STATE(3476),
    [sym_preproc_pragma] = STATE(3476),
    [sym_preproc_nullable] = STATE(3476),
    [sym_preproc_error] = STATE(3476),
    [sym_preproc_warning] = STATE(3476),
    [sym_preproc_define] = STATE(3476),
    [sym_preproc_undef] = STATE(3476),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3477] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7518),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3477),
    [sym_preproc_endregion] = STATE(3477),
    [sym_preproc_line] = STATE(3477),
    [sym_preproc_pragma] = STATE(3477),
    [sym_preproc_nullable] = STATE(3477),
    [sym_preproc_error] = STATE(3477),
    [sym_preproc_warning] = STATE(3477),
    [sym_preproc_define] = STATE(3477),
    [sym_preproc_undef] = STATE(3477),
    [aux_sym_function_pointer_type_repeat1] = STATE(3478),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3478] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7715),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3478),
    [sym_preproc_endregion] = STATE(3478),
    [sym_preproc_line] = STATE(3478),
    [sym_preproc_pragma] = STATE(3478),
    [sym_preproc_nullable] = STATE(3478),
    [sym_preproc_error] = STATE(3478),
    [sym_preproc_warning] = STATE(3478),
    [sym_preproc_define] = STATE(3478),
    [sym_preproc_undef] = STATE(3478),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3479] = {
    [sym_preproc_region] = STATE(3479),
    [sym_preproc_endregion] = STATE(3479),
    [sym_preproc_line] = STATE(3479),
    [sym_preproc_pragma] = STATE(3479),
    [sym_preproc_nullable] = STATE(3479),
    [sym_preproc_error] = STATE(3479),
    [sym_preproc_warning] = STATE(3479),
    [sym_preproc_define] = STATE(3479),
    [sym_preproc_undef] = STATE(3479),
    [anon_sym_SEMI] = ACTIONS(5203),
    [anon_sym_LBRACK] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_COMMA] = ACTIONS(5203),
    [anon_sym_RBRACK] = ACTIONS(5203),
    [anon_sym_LPAREN] = ACTIONS(5203),
    [anon_sym_RPAREN] = ACTIONS(5203),
    [anon_sym_RBRACE] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5205),
    [anon_sym_in] = ACTIONS(5203),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_BANG] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5203),
    [anon_sym_DASH_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5205),
    [anon_sym_STAR] = ACTIONS(5203),
    [anon_sym_SLASH] = ACTIONS(5205),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5203),
    [anon_sym_PIPE] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5205),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5205),
    [anon_sym_GT_GT_GT] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5203),
    [anon_sym_BANG_EQ] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5203),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_DOT] = ACTIONS(5205),
    [anon_sym_EQ_GT] = ACTIONS(5203),
    [anon_sym_switch] = ACTIONS(5203),
    [anon_sym_when] = ACTIONS(5203),
    [anon_sym_DOT_DOT] = ACTIONS(5203),
    [anon_sym_and] = ACTIONS(5203),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_AMP_AMP] = ACTIONS(5203),
    [anon_sym_PIPE_PIPE] = ACTIONS(5203),
    [anon_sym_QMARK_QMARK] = ACTIONS(5203),
    [anon_sym_on] = ACTIONS(5203),
    [anon_sym_equals] = ACTIONS(5203),
    [anon_sym_by] = ACTIONS(5203),
    [anon_sym_as] = ACTIONS(5203),
    [anon_sym_is] = ACTIONS(5203),
    [anon_sym_DASH_GT] = ACTIONS(5203),
    [anon_sym_with] = ACTIONS(5203),
    [aux_sym_preproc_if_token3] = ACTIONS(5203),
    [aux_sym_preproc_else_token1] = ACTIONS(5203),
    [aux_sym_preproc_elif_token1] = ACTIONS(5203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3480] = {
    [sym_preproc_region] = STATE(3480),
    [sym_preproc_endregion] = STATE(3480),
    [sym_preproc_line] = STATE(3480),
    [sym_preproc_pragma] = STATE(3480),
    [sym_preproc_nullable] = STATE(3480),
    [sym_preproc_error] = STATE(3480),
    [sym_preproc_warning] = STATE(3480),
    [sym_preproc_define] = STATE(3480),
    [sym_preproc_undef] = STATE(3480),
    [anon_sym_EQ] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5540),
    [anon_sym_DASH_EQ] = ACTIONS(5540),
    [anon_sym_STAR_EQ] = ACTIONS(5540),
    [anon_sym_SLASH_EQ] = ACTIONS(5540),
    [anon_sym_PERCENT_EQ] = ACTIONS(5540),
    [anon_sym_AMP_EQ] = ACTIONS(5540),
    [anon_sym_CARET_EQ] = ACTIONS(5540),
    [anon_sym_PIPE_EQ] = ACTIONS(5540),
    [anon_sym_LT_LT_EQ] = ACTIONS(5540),
    [anon_sym_GT_GT_EQ] = ACTIONS(5540),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5540),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4898),
  },
  [3481] = {
    [sym_preproc_region] = STATE(3481),
    [sym_preproc_endregion] = STATE(3481),
    [sym_preproc_line] = STATE(3481),
    [sym_preproc_pragma] = STATE(3481),
    [sym_preproc_nullable] = STATE(3481),
    [sym_preproc_error] = STATE(3481),
    [sym_preproc_warning] = STATE(3481),
    [sym_preproc_define] = STATE(3481),
    [sym_preproc_undef] = STATE(3481),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_get] = ACTIONS(3494),
    [anon_sym_set] = ACTIONS(3494),
    [anon_sym_add] = ACTIONS(3494),
    [anon_sym_remove] = ACTIONS(3494),
    [anon_sym_init] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3482] = {
    [sym_preproc_region] = STATE(3482),
    [sym_preproc_endregion] = STATE(3482),
    [sym_preproc_line] = STATE(3482),
    [sym_preproc_pragma] = STATE(3482),
    [sym_preproc_nullable] = STATE(3482),
    [sym_preproc_error] = STATE(3482),
    [sym_preproc_warning] = STATE(3482),
    [sym_preproc_define] = STATE(3482),
    [sym_preproc_undef] = STATE(3482),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(5473),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(5542),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_and] = ACTIONS(4024),
    [anon_sym_or] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3483] = {
    [sym_preproc_region] = STATE(3483),
    [sym_preproc_endregion] = STATE(3483),
    [sym_preproc_line] = STATE(3483),
    [sym_preproc_pragma] = STATE(3483),
    [sym_preproc_nullable] = STATE(3483),
    [sym_preproc_error] = STATE(3483),
    [sym_preproc_warning] = STATE(3483),
    [sym_preproc_define] = STATE(3483),
    [sym_preproc_undef] = STATE(3483),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(5542),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_when] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_and] = ACTIONS(4028),
    [anon_sym_or] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3484] = {
    [sym_preproc_region] = STATE(3484),
    [sym_preproc_endregion] = STATE(3484),
    [sym_preproc_line] = STATE(3484),
    [sym_preproc_pragma] = STATE(3484),
    [sym_preproc_nullable] = STATE(3484),
    [sym_preproc_error] = STATE(3484),
    [sym_preproc_warning] = STATE(3484),
    [sym_preproc_define] = STATE(3484),
    [sym_preproc_undef] = STATE(3484),
    [sym__identifier_token] = ACTIONS(5544),
    [anon_sym_extern] = ACTIONS(5544),
    [anon_sym_alias] = ACTIONS(5544),
    [anon_sym_global] = ACTIONS(5544),
    [anon_sym_unsafe] = ACTIONS(5544),
    [anon_sym_static] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(5546),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_abstract] = ACTIONS(5544),
    [anon_sym_async] = ACTIONS(5544),
    [anon_sym_const] = ACTIONS(5544),
    [anon_sym_file] = ACTIONS(5544),
    [anon_sym_fixed] = ACTIONS(5544),
    [anon_sym_internal] = ACTIONS(5544),
    [anon_sym_new] = ACTIONS(5544),
    [anon_sym_override] = ACTIONS(5544),
    [anon_sym_partial] = ACTIONS(5544),
    [anon_sym_private] = ACTIONS(5544),
    [anon_sym_protected] = ACTIONS(5544),
    [anon_sym_public] = ACTIONS(5544),
    [anon_sym_readonly] = ACTIONS(5544),
    [anon_sym_required] = ACTIONS(5544),
    [anon_sym_sealed] = ACTIONS(5544),
    [anon_sym_virtual] = ACTIONS(5544),
    [anon_sym_volatile] = ACTIONS(5544),
    [anon_sym_where] = ACTIONS(5544),
    [anon_sym_notnull] = ACTIONS(5544),
    [anon_sym_unmanaged] = ACTIONS(5544),
    [anon_sym_get] = ACTIONS(5544),
    [anon_sym_set] = ACTIONS(5544),
    [anon_sym_add] = ACTIONS(5544),
    [anon_sym_remove] = ACTIONS(5544),
    [anon_sym_init] = ACTIONS(5544),
    [anon_sym_scoped] = ACTIONS(5544),
    [anon_sym_var] = ACTIONS(5544),
    [anon_sym_yield] = ACTIONS(5544),
    [anon_sym_when] = ACTIONS(5544),
    [anon_sym_from] = ACTIONS(5544),
    [anon_sym_into] = ACTIONS(5544),
    [anon_sym_join] = ACTIONS(5544),
    [anon_sym_on] = ACTIONS(5544),
    [anon_sym_equals] = ACTIONS(5544),
    [anon_sym_let] = ACTIONS(5544),
    [anon_sym_orderby] = ACTIONS(5544),
    [anon_sym_ascending] = ACTIONS(5544),
    [anon_sym_descending] = ACTIONS(5544),
    [anon_sym_group] = ACTIONS(5544),
    [anon_sym_by] = ACTIONS(5544),
    [anon_sym_select] = ACTIONS(5544),
    [aux_sym_preproc_if_token1] = ACTIONS(5546),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3485] = {
    [sym_preproc_region] = STATE(3485),
    [sym_preproc_endregion] = STATE(3485),
    [sym_preproc_line] = STATE(3485),
    [sym_preproc_pragma] = STATE(3485),
    [sym_preproc_nullable] = STATE(3485),
    [sym_preproc_error] = STATE(3485),
    [sym_preproc_warning] = STATE(3485),
    [sym_preproc_define] = STATE(3485),
    [sym_preproc_undef] = STATE(3485),
    [anon_sym_SEMI] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5207),
    [anon_sym_COLON] = ACTIONS(5207),
    [anon_sym_COMMA] = ACTIONS(5207),
    [anon_sym_RBRACK] = ACTIONS(5207),
    [anon_sym_LPAREN] = ACTIONS(5207),
    [anon_sym_RPAREN] = ACTIONS(5207),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_GT] = ACTIONS(5209),
    [anon_sym_in] = ACTIONS(5207),
    [anon_sym_QMARK] = ACTIONS(5209),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_PLUS_PLUS] = ACTIONS(5207),
    [anon_sym_DASH_DASH] = ACTIONS(5207),
    [anon_sym_PLUS] = ACTIONS(5209),
    [anon_sym_DASH] = ACTIONS(5209),
    [anon_sym_STAR] = ACTIONS(5207),
    [anon_sym_SLASH] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5207),
    [anon_sym_CARET] = ACTIONS(5207),
    [anon_sym_PIPE] = ACTIONS(5209),
    [anon_sym_AMP] = ACTIONS(5209),
    [anon_sym_LT_LT] = ACTIONS(5207),
    [anon_sym_GT_GT] = ACTIONS(5209),
    [anon_sym_GT_GT_GT] = ACTIONS(5207),
    [anon_sym_EQ_EQ] = ACTIONS(5207),
    [anon_sym_BANG_EQ] = ACTIONS(5207),
    [anon_sym_GT_EQ] = ACTIONS(5207),
    [anon_sym_LT_EQ] = ACTIONS(5207),
    [anon_sym_DOT] = ACTIONS(5209),
    [anon_sym_EQ_GT] = ACTIONS(5207),
    [anon_sym_switch] = ACTIONS(5207),
    [anon_sym_when] = ACTIONS(5207),
    [anon_sym_DOT_DOT] = ACTIONS(5207),
    [anon_sym_and] = ACTIONS(5207),
    [anon_sym_or] = ACTIONS(5207),
    [anon_sym_AMP_AMP] = ACTIONS(5207),
    [anon_sym_PIPE_PIPE] = ACTIONS(5207),
    [anon_sym_QMARK_QMARK] = ACTIONS(5207),
    [anon_sym_on] = ACTIONS(5207),
    [anon_sym_equals] = ACTIONS(5207),
    [anon_sym_by] = ACTIONS(5207),
    [anon_sym_as] = ACTIONS(5207),
    [anon_sym_is] = ACTIONS(5207),
    [anon_sym_DASH_GT] = ACTIONS(5207),
    [anon_sym_with] = ACTIONS(5207),
    [aux_sym_preproc_if_token3] = ACTIONS(5207),
    [aux_sym_preproc_else_token1] = ACTIONS(5207),
    [aux_sym_preproc_elif_token1] = ACTIONS(5207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3486] = {
    [sym_type_parameter_constraint] = STATE(6516),
    [sym_constructor_constraint] = STATE(6678),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6523),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3486),
    [sym_preproc_endregion] = STATE(3486),
    [sym_preproc_line] = STATE(3486),
    [sym_preproc_pragma] = STATE(3486),
    [sym_preproc_nullable] = STATE(3486),
    [sym_preproc_error] = STATE(3486),
    [sym_preproc_warning] = STATE(3486),
    [sym_preproc_define] = STATE(3486),
    [sym_preproc_undef] = STATE(3486),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_class] = ACTIONS(5548),
    [anon_sym_ref] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5552),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_new] = ACTIONS(5554),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(5556),
    [anon_sym_unmanaged] = ACTIONS(5556),
    [anon_sym_scoped] = ACTIONS(5558),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3487] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3487),
    [sym_preproc_endregion] = STATE(3487),
    [sym_preproc_line] = STATE(3487),
    [sym_preproc_pragma] = STATE(3487),
    [sym_preproc_nullable] = STATE(3487),
    [sym_preproc_error] = STATE(3487),
    [sym_preproc_warning] = STATE(3487),
    [sym_preproc_define] = STATE(3487),
    [sym_preproc_undef] = STATE(3487),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(5560),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3488] = {
    [sym_preproc_region] = STATE(3488),
    [sym_preproc_endregion] = STATE(3488),
    [sym_preproc_line] = STATE(3488),
    [sym_preproc_pragma] = STATE(3488),
    [sym_preproc_nullable] = STATE(3488),
    [sym_preproc_error] = STATE(3488),
    [sym_preproc_warning] = STATE(3488),
    [sym_preproc_define] = STATE(3488),
    [sym_preproc_undef] = STATE(3488),
    [anon_sym_SEMI] = ACTIONS(5195),
    [anon_sym_LBRACK] = ACTIONS(5195),
    [anon_sym_COLON] = ACTIONS(5195),
    [anon_sym_COMMA] = ACTIONS(5195),
    [anon_sym_RBRACK] = ACTIONS(5195),
    [anon_sym_LPAREN] = ACTIONS(5195),
    [anon_sym_RPAREN] = ACTIONS(5195),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_in] = ACTIONS(5195),
    [anon_sym_QMARK] = ACTIONS(5197),
    [anon_sym_BANG] = ACTIONS(5197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5195),
    [anon_sym_DASH_DASH] = ACTIONS(5195),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5195),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5195),
    [anon_sym_CARET] = ACTIONS(5195),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5195),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_GT_GT_GT] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_EQ_GT] = ACTIONS(5195),
    [anon_sym_switch] = ACTIONS(5195),
    [anon_sym_when] = ACTIONS(5195),
    [anon_sym_DOT_DOT] = ACTIONS(5195),
    [anon_sym_and] = ACTIONS(5195),
    [anon_sym_or] = ACTIONS(5195),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_QMARK_QMARK] = ACTIONS(5195),
    [anon_sym_on] = ACTIONS(5195),
    [anon_sym_equals] = ACTIONS(5195),
    [anon_sym_by] = ACTIONS(5195),
    [anon_sym_as] = ACTIONS(5195),
    [anon_sym_is] = ACTIONS(5195),
    [anon_sym_DASH_GT] = ACTIONS(5195),
    [anon_sym_with] = ACTIONS(5195),
    [aux_sym_preproc_if_token3] = ACTIONS(5195),
    [aux_sym_preproc_else_token1] = ACTIONS(5195),
    [aux_sym_preproc_elif_token1] = ACTIONS(5195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3489] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7517),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3489),
    [sym_preproc_endregion] = STATE(3489),
    [sym_preproc_line] = STATE(3489),
    [sym_preproc_pragma] = STATE(3489),
    [sym_preproc_nullable] = STATE(3489),
    [sym_preproc_error] = STATE(3489),
    [sym_preproc_warning] = STATE(3489),
    [sym_preproc_define] = STATE(3489),
    [sym_preproc_undef] = STATE(3489),
    [aux_sym_function_pointer_type_repeat1] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3490] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7582),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3490),
    [sym_preproc_endregion] = STATE(3490),
    [sym_preproc_line] = STATE(3490),
    [sym_preproc_pragma] = STATE(3490),
    [sym_preproc_nullable] = STATE(3490),
    [sym_preproc_error] = STATE(3490),
    [sym_preproc_warning] = STATE(3490),
    [sym_preproc_define] = STATE(3490),
    [sym_preproc_undef] = STATE(3490),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3491] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7582),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3491),
    [sym_preproc_endregion] = STATE(3491),
    [sym_preproc_line] = STATE(3491),
    [sym_preproc_pragma] = STATE(3491),
    [sym_preproc_nullable] = STATE(3491),
    [sym_preproc_error] = STATE(3491),
    [sym_preproc_warning] = STATE(3491),
    [sym_preproc_define] = STATE(3491),
    [sym_preproc_undef] = STATE(3491),
    [aux_sym_function_pointer_type_repeat1] = STATE(3492),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3492] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7632),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3492),
    [sym_preproc_endregion] = STATE(3492),
    [sym_preproc_line] = STATE(3492),
    [sym_preproc_pragma] = STATE(3492),
    [sym_preproc_nullable] = STATE(3492),
    [sym_preproc_error] = STATE(3492),
    [sym_preproc_warning] = STATE(3492),
    [sym_preproc_define] = STATE(3492),
    [sym_preproc_undef] = STATE(3492),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3493] = {
    [sym_preproc_region] = STATE(3493),
    [sym_preproc_endregion] = STATE(3493),
    [sym_preproc_line] = STATE(3493),
    [sym_preproc_pragma] = STATE(3493),
    [sym_preproc_nullable] = STATE(3493),
    [sym_preproc_error] = STATE(3493),
    [sym_preproc_warning] = STATE(3493),
    [sym_preproc_define] = STATE(3493),
    [sym_preproc_undef] = STATE(3493),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_RBRACK] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(5484),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_LT] = ACTIONS(5486),
    [anon_sym_GT] = ACTIONS(5486),
    [anon_sym_in] = ACTIONS(5484),
    [anon_sym_QMARK] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(5486),
    [anon_sym_PLUS_PLUS] = ACTIONS(5484),
    [anon_sym_DASH_DASH] = ACTIONS(5484),
    [anon_sym_PLUS] = ACTIONS(5486),
    [anon_sym_DASH] = ACTIONS(5486),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_SLASH] = ACTIONS(5486),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5486),
    [anon_sym_AMP] = ACTIONS(5486),
    [anon_sym_LT_LT] = ACTIONS(5484),
    [anon_sym_GT_GT] = ACTIONS(5486),
    [anon_sym_GT_GT_GT] = ACTIONS(5484),
    [anon_sym_EQ_EQ] = ACTIONS(5484),
    [anon_sym_BANG_EQ] = ACTIONS(5484),
    [anon_sym_GT_EQ] = ACTIONS(5484),
    [anon_sym_LT_EQ] = ACTIONS(5484),
    [anon_sym_DOT] = ACTIONS(5486),
    [anon_sym_EQ_GT] = ACTIONS(5484),
    [anon_sym_switch] = ACTIONS(5484),
    [anon_sym_when] = ACTIONS(5484),
    [anon_sym_DOT_DOT] = ACTIONS(5484),
    [anon_sym_and] = ACTIONS(5484),
    [anon_sym_or] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_QMARK_QMARK] = ACTIONS(5484),
    [anon_sym_on] = ACTIONS(5484),
    [anon_sym_equals] = ACTIONS(5484),
    [anon_sym_by] = ACTIONS(5484),
    [anon_sym_as] = ACTIONS(5484),
    [anon_sym_is] = ACTIONS(5484),
    [anon_sym_DASH_GT] = ACTIONS(5484),
    [anon_sym_with] = ACTIONS(5484),
    [aux_sym_preproc_if_token3] = ACTIONS(5484),
    [aux_sym_preproc_else_token1] = ACTIONS(5484),
    [aux_sym_preproc_elif_token1] = ACTIONS(5484),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3494] = {
    [sym_preproc_region] = STATE(3494),
    [sym_preproc_endregion] = STATE(3494),
    [sym_preproc_line] = STATE(3494),
    [sym_preproc_pragma] = STATE(3494),
    [sym_preproc_nullable] = STATE(3494),
    [sym_preproc_error] = STATE(3494),
    [sym_preproc_warning] = STATE(3494),
    [sym_preproc_define] = STATE(3494),
    [sym_preproc_undef] = STATE(3494),
    [anon_sym_EQ] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_STAR_EQ] = ACTIONS(5564),
    [anon_sym_SLASH_EQ] = ACTIONS(5564),
    [anon_sym_PERCENT_EQ] = ACTIONS(5564),
    [anon_sym_AMP_EQ] = ACTIONS(5564),
    [anon_sym_CARET_EQ] = ACTIONS(5564),
    [anon_sym_PIPE_EQ] = ACTIONS(5564),
    [anon_sym_LT_LT_EQ] = ACTIONS(5564),
    [anon_sym_GT_GT_EQ] = ACTIONS(5564),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5564),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3495] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3495),
    [sym_preproc_endregion] = STATE(3495),
    [sym_preproc_line] = STATE(3495),
    [sym_preproc_pragma] = STATE(3495),
    [sym_preproc_nullable] = STATE(3495),
    [sym_preproc_error] = STATE(3495),
    [sym_preproc_warning] = STATE(3495),
    [sym_preproc_define] = STATE(3495),
    [sym_preproc_undef] = STATE(3495),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(5566),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3496] = {
    [sym_preproc_region] = STATE(3496),
    [sym_preproc_endregion] = STATE(3496),
    [sym_preproc_line] = STATE(3496),
    [sym_preproc_pragma] = STATE(3496),
    [sym_preproc_nullable] = STATE(3496),
    [sym_preproc_error] = STATE(3496),
    [sym_preproc_warning] = STATE(3496),
    [sym_preproc_define] = STATE(3496),
    [sym_preproc_undef] = STATE(3496),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_extern] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_unsafe] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_file] = ACTIONS(2977),
    [anon_sym_fixed] = ACTIONS(2977),
    [anon_sym_internal] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_partial] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_sealed] = ACTIONS(2977),
    [anon_sym_virtual] = ACTIONS(2977),
    [anon_sym_volatile] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_add] = ACTIONS(2977),
    [anon_sym_remove] = ACTIONS(2977),
    [anon_sym_init] = ACTIONS(2977),
    [anon_sym_scoped] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3497] = {
    [sym_preproc_region] = STATE(3497),
    [sym_preproc_endregion] = STATE(3497),
    [sym_preproc_line] = STATE(3497),
    [sym_preproc_pragma] = STATE(3497),
    [sym_preproc_nullable] = STATE(3497),
    [sym_preproc_error] = STATE(3497),
    [sym_preproc_warning] = STATE(3497),
    [sym_preproc_define] = STATE(3497),
    [sym_preproc_undef] = STATE(3497),
    [sym__identifier_token] = ACTIONS(3165),
    [anon_sym_extern] = ACTIONS(3165),
    [anon_sym_alias] = ACTIONS(3165),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_unsafe] = ACTIONS(3165),
    [anon_sym_static] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_const] = ACTIONS(3165),
    [anon_sym_file] = ACTIONS(3165),
    [anon_sym_fixed] = ACTIONS(3165),
    [anon_sym_internal] = ACTIONS(3165),
    [anon_sym_new] = ACTIONS(3165),
    [anon_sym_override] = ACTIONS(3165),
    [anon_sym_partial] = ACTIONS(3165),
    [anon_sym_private] = ACTIONS(3165),
    [anon_sym_protected] = ACTIONS(3165),
    [anon_sym_public] = ACTIONS(3165),
    [anon_sym_readonly] = ACTIONS(3165),
    [anon_sym_required] = ACTIONS(3165),
    [anon_sym_sealed] = ACTIONS(3165),
    [anon_sym_virtual] = ACTIONS(3165),
    [anon_sym_volatile] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3165),
    [anon_sym_notnull] = ACTIONS(3165),
    [anon_sym_unmanaged] = ACTIONS(3165),
    [anon_sym_get] = ACTIONS(3165),
    [anon_sym_set] = ACTIONS(3165),
    [anon_sym_add] = ACTIONS(3165),
    [anon_sym_remove] = ACTIONS(3165),
    [anon_sym_init] = ACTIONS(3165),
    [anon_sym_scoped] = ACTIONS(3165),
    [anon_sym_var] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_into] = ACTIONS(3165),
    [anon_sym_join] = ACTIONS(3165),
    [anon_sym_on] = ACTIONS(3165),
    [anon_sym_equals] = ACTIONS(3165),
    [anon_sym_let] = ACTIONS(3165),
    [anon_sym_orderby] = ACTIONS(3165),
    [anon_sym_ascending] = ACTIONS(3165),
    [anon_sym_descending] = ACTIONS(3165),
    [anon_sym_group] = ACTIONS(3165),
    [anon_sym_by] = ACTIONS(3165),
    [anon_sym_select] = ACTIONS(3165),
    [aux_sym_preproc_if_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3498] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7494),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3498),
    [sym_preproc_endregion] = STATE(3498),
    [sym_preproc_line] = STATE(3498),
    [sym_preproc_pragma] = STATE(3498),
    [sym_preproc_nullable] = STATE(3498),
    [sym_preproc_error] = STATE(3498),
    [sym_preproc_warning] = STATE(3498),
    [sym_preproc_define] = STATE(3498),
    [sym_preproc_undef] = STATE(3498),
    [aux_sym_function_pointer_type_repeat1] = STATE(3499),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3499] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7421),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3499),
    [sym_preproc_endregion] = STATE(3499),
    [sym_preproc_line] = STATE(3499),
    [sym_preproc_pragma] = STATE(3499),
    [sym_preproc_nullable] = STATE(3499),
    [sym_preproc_error] = STATE(3499),
    [sym_preproc_warning] = STATE(3499),
    [sym_preproc_define] = STATE(3499),
    [sym_preproc_undef] = STATE(3499),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3500] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7421),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3500),
    [sym_preproc_endregion] = STATE(3500),
    [sym_preproc_line] = STATE(3500),
    [sym_preproc_pragma] = STATE(3500),
    [sym_preproc_nullable] = STATE(3500),
    [sym_preproc_error] = STATE(3500),
    [sym_preproc_warning] = STATE(3500),
    [sym_preproc_define] = STATE(3500),
    [sym_preproc_undef] = STATE(3500),
    [aux_sym_function_pointer_type_repeat1] = STATE(3501),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3501] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7552),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3501),
    [sym_preproc_endregion] = STATE(3501),
    [sym_preproc_line] = STATE(3501),
    [sym_preproc_pragma] = STATE(3501),
    [sym_preproc_nullable] = STATE(3501),
    [sym_preproc_error] = STATE(3501),
    [sym_preproc_warning] = STATE(3501),
    [sym_preproc_define] = STATE(3501),
    [sym_preproc_undef] = STATE(3501),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3502] = {
    [sym_preproc_region] = STATE(3502),
    [sym_preproc_endregion] = STATE(3502),
    [sym_preproc_line] = STATE(3502),
    [sym_preproc_pragma] = STATE(3502),
    [sym_preproc_nullable] = STATE(3502),
    [sym_preproc_error] = STATE(3502),
    [sym_preproc_warning] = STATE(3502),
    [sym_preproc_define] = STATE(3502),
    [sym_preproc_undef] = STATE(3502),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_in] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_on] = ACTIONS(5407),
    [anon_sym_equals] = ACTIONS(5407),
    [anon_sym_by] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5407),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_if_token3] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3503] = {
    [sym_preproc_region] = STATE(3503),
    [sym_preproc_endregion] = STATE(3503),
    [sym_preproc_line] = STATE(3503),
    [sym_preproc_pragma] = STATE(3503),
    [sym_preproc_nullable] = STATE(3503),
    [sym_preproc_error] = STATE(3503),
    [sym_preproc_warning] = STATE(3503),
    [sym_preproc_define] = STATE(3503),
    [sym_preproc_undef] = STATE(3503),
    [anon_sym_SEMI] = ACTIONS(5451),
    [anon_sym_LBRACK] = ACTIONS(5451),
    [anon_sym_COLON] = ACTIONS(5451),
    [anon_sym_COMMA] = ACTIONS(5451),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_LPAREN] = ACTIONS(5451),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_LT] = ACTIONS(5453),
    [anon_sym_GT] = ACTIONS(5453),
    [anon_sym_in] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_BANG] = ACTIONS(5453),
    [anon_sym_PLUS_PLUS] = ACTIONS(5451),
    [anon_sym_DASH_DASH] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5453),
    [anon_sym_DASH] = ACTIONS(5453),
    [anon_sym_STAR] = ACTIONS(5451),
    [anon_sym_SLASH] = ACTIONS(5453),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_CARET] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5453),
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_LT_LT] = ACTIONS(5451),
    [anon_sym_GT_GT] = ACTIONS(5453),
    [anon_sym_GT_GT_GT] = ACTIONS(5451),
    [anon_sym_EQ_EQ] = ACTIONS(5451),
    [anon_sym_BANG_EQ] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5451),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_DOT] = ACTIONS(5453),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_switch] = ACTIONS(5451),
    [anon_sym_when] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_and] = ACTIONS(5451),
    [anon_sym_or] = ACTIONS(5451),
    [anon_sym_AMP_AMP] = ACTIONS(5451),
    [anon_sym_PIPE_PIPE] = ACTIONS(5451),
    [anon_sym_QMARK_QMARK] = ACTIONS(5451),
    [anon_sym_on] = ACTIONS(5451),
    [anon_sym_equals] = ACTIONS(5451),
    [anon_sym_by] = ACTIONS(5451),
    [anon_sym_as] = ACTIONS(5451),
    [anon_sym_is] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_with] = ACTIONS(5451),
    [aux_sym_preproc_if_token3] = ACTIONS(5451),
    [aux_sym_preproc_else_token1] = ACTIONS(5451),
    [aux_sym_preproc_elif_token1] = ACTIONS(5451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3504] = {
    [sym_preproc_region] = STATE(3504),
    [sym_preproc_endregion] = STATE(3504),
    [sym_preproc_line] = STATE(3504),
    [sym_preproc_pragma] = STATE(3504),
    [sym_preproc_nullable] = STATE(3504),
    [sym_preproc_error] = STATE(3504),
    [sym_preproc_warning] = STATE(3504),
    [sym_preproc_define] = STATE(3504),
    [sym_preproc_undef] = STATE(3504),
    [anon_sym_SEMI] = ACTIONS(4999),
    [anon_sym_LBRACK] = ACTIONS(4999),
    [anon_sym_COLON] = ACTIONS(4999),
    [anon_sym_COMMA] = ACTIONS(4999),
    [anon_sym_RBRACK] = ACTIONS(4999),
    [anon_sym_LPAREN] = ACTIONS(4999),
    [anon_sym_RPAREN] = ACTIONS(4999),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym_LT] = ACTIONS(5001),
    [anon_sym_GT] = ACTIONS(5001),
    [anon_sym_in] = ACTIONS(4999),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(4999),
    [anon_sym_PLUS] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(4999),
    [anon_sym_SLASH] = ACTIONS(5001),
    [anon_sym_PERCENT] = ACTIONS(4999),
    [anon_sym_CARET] = ACTIONS(4999),
    [anon_sym_PIPE] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_LT_LT] = ACTIONS(4999),
    [anon_sym_GT_GT] = ACTIONS(5001),
    [anon_sym_GT_GT_GT] = ACTIONS(4999),
    [anon_sym_EQ_EQ] = ACTIONS(4999),
    [anon_sym_BANG_EQ] = ACTIONS(4999),
    [anon_sym_GT_EQ] = ACTIONS(4999),
    [anon_sym_LT_EQ] = ACTIONS(4999),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_EQ_GT] = ACTIONS(4999),
    [anon_sym_switch] = ACTIONS(4999),
    [anon_sym_when] = ACTIONS(4999),
    [anon_sym_DOT_DOT] = ACTIONS(4999),
    [anon_sym_and] = ACTIONS(4999),
    [anon_sym_or] = ACTIONS(4999),
    [anon_sym_AMP_AMP] = ACTIONS(4999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4999),
    [anon_sym_QMARK_QMARK] = ACTIONS(4999),
    [anon_sym_on] = ACTIONS(4999),
    [anon_sym_equals] = ACTIONS(4999),
    [anon_sym_by] = ACTIONS(4999),
    [anon_sym_as] = ACTIONS(4999),
    [anon_sym_is] = ACTIONS(4999),
    [anon_sym_DASH_GT] = ACTIONS(4999),
    [anon_sym_with] = ACTIONS(4999),
    [aux_sym_preproc_if_token3] = ACTIONS(4999),
    [aux_sym_preproc_else_token1] = ACTIONS(4999),
    [aux_sym_preproc_elif_token1] = ACTIONS(4999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3505] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3505),
    [sym_preproc_endregion] = STATE(3505),
    [sym_preproc_line] = STATE(3505),
    [sym_preproc_pragma] = STATE(3505),
    [sym_preproc_nullable] = STATE(3505),
    [sym_preproc_error] = STATE(3505),
    [sym_preproc_warning] = STATE(3505),
    [sym_preproc_define] = STATE(3505),
    [sym_preproc_undef] = STATE(3505),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(5568),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3506] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7448),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3506),
    [sym_preproc_endregion] = STATE(3506),
    [sym_preproc_line] = STATE(3506),
    [sym_preproc_pragma] = STATE(3506),
    [sym_preproc_nullable] = STATE(3506),
    [sym_preproc_error] = STATE(3506),
    [sym_preproc_warning] = STATE(3506),
    [sym_preproc_define] = STATE(3506),
    [sym_preproc_undef] = STATE(3506),
    [aux_sym_function_pointer_type_repeat1] = STATE(3507),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3507] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7381),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3507),
    [sym_preproc_endregion] = STATE(3507),
    [sym_preproc_line] = STATE(3507),
    [sym_preproc_pragma] = STATE(3507),
    [sym_preproc_nullable] = STATE(3507),
    [sym_preproc_error] = STATE(3507),
    [sym_preproc_warning] = STATE(3507),
    [sym_preproc_define] = STATE(3507),
    [sym_preproc_undef] = STATE(3507),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3508] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7381),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3508),
    [sym_preproc_endregion] = STATE(3508),
    [sym_preproc_line] = STATE(3508),
    [sym_preproc_pragma] = STATE(3508),
    [sym_preproc_nullable] = STATE(3508),
    [sym_preproc_error] = STATE(3508),
    [sym_preproc_warning] = STATE(3508),
    [sym_preproc_define] = STATE(3508),
    [sym_preproc_undef] = STATE(3508),
    [aux_sym_function_pointer_type_repeat1] = STATE(3509),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3509] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7607),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3509),
    [sym_preproc_endregion] = STATE(3509),
    [sym_preproc_line] = STATE(3509),
    [sym_preproc_pragma] = STATE(3509),
    [sym_preproc_nullable] = STATE(3509),
    [sym_preproc_error] = STATE(3509),
    [sym_preproc_warning] = STATE(3509),
    [sym_preproc_define] = STATE(3509),
    [sym_preproc_undef] = STATE(3509),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3510] = {
    [sym_preproc_region] = STATE(3510),
    [sym_preproc_endregion] = STATE(3510),
    [sym_preproc_line] = STATE(3510),
    [sym_preproc_pragma] = STATE(3510),
    [sym_preproc_nullable] = STATE(3510),
    [sym_preproc_error] = STATE(3510),
    [sym_preproc_warning] = STATE(3510),
    [sym_preproc_define] = STATE(3510),
    [sym_preproc_undef] = STATE(3510),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5572),
    [anon_sym_DASH_EQ] = ACTIONS(5572),
    [anon_sym_STAR_EQ] = ACTIONS(5572),
    [anon_sym_SLASH_EQ] = ACTIONS(5572),
    [anon_sym_PERCENT_EQ] = ACTIONS(5572),
    [anon_sym_AMP_EQ] = ACTIONS(5572),
    [anon_sym_CARET_EQ] = ACTIONS(5572),
    [anon_sym_PIPE_EQ] = ACTIONS(5572),
    [anon_sym_LT_LT_EQ] = ACTIONS(5572),
    [anon_sym_GT_GT_EQ] = ACTIONS(5572),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5572),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3511] = {
    [sym_preproc_region] = STATE(3511),
    [sym_preproc_endregion] = STATE(3511),
    [sym_preproc_line] = STATE(3511),
    [sym_preproc_pragma] = STATE(3511),
    [sym_preproc_nullable] = STATE(3511),
    [sym_preproc_error] = STATE(3511),
    [sym_preproc_warning] = STATE(3511),
    [sym_preproc_define] = STATE(3511),
    [sym_preproc_undef] = STATE(3511),
    [anon_sym_EQ] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5576),
    [anon_sym_DASH_EQ] = ACTIONS(5576),
    [anon_sym_STAR_EQ] = ACTIONS(5576),
    [anon_sym_SLASH_EQ] = ACTIONS(5576),
    [anon_sym_PERCENT_EQ] = ACTIONS(5576),
    [anon_sym_AMP_EQ] = ACTIONS(5576),
    [anon_sym_CARET_EQ] = ACTIONS(5576),
    [anon_sym_PIPE_EQ] = ACTIONS(5576),
    [anon_sym_LT_LT_EQ] = ACTIONS(5576),
    [anon_sym_GT_GT_EQ] = ACTIONS(5576),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5576),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3512] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3512),
    [sym_preproc_endregion] = STATE(3512),
    [sym_preproc_line] = STATE(3512),
    [sym_preproc_pragma] = STATE(3512),
    [sym_preproc_nullable] = STATE(3512),
    [sym_preproc_error] = STATE(3512),
    [sym_preproc_warning] = STATE(3512),
    [sym_preproc_define] = STATE(3512),
    [sym_preproc_undef] = STATE(3512),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(5578),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3513] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7495),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3513),
    [sym_preproc_endregion] = STATE(3513),
    [sym_preproc_line] = STATE(3513),
    [sym_preproc_pragma] = STATE(3513),
    [sym_preproc_nullable] = STATE(3513),
    [sym_preproc_error] = STATE(3513),
    [sym_preproc_warning] = STATE(3513),
    [sym_preproc_define] = STATE(3513),
    [sym_preproc_undef] = STATE(3513),
    [aux_sym_function_pointer_type_repeat1] = STATE(3514),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3514] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7558),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3514),
    [sym_preproc_endregion] = STATE(3514),
    [sym_preproc_line] = STATE(3514),
    [sym_preproc_pragma] = STATE(3514),
    [sym_preproc_nullable] = STATE(3514),
    [sym_preproc_error] = STATE(3514),
    [sym_preproc_warning] = STATE(3514),
    [sym_preproc_define] = STATE(3514),
    [sym_preproc_undef] = STATE(3514),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3515] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7558),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3515),
    [sym_preproc_endregion] = STATE(3515),
    [sym_preproc_line] = STATE(3515),
    [sym_preproc_pragma] = STATE(3515),
    [sym_preproc_nullable] = STATE(3515),
    [sym_preproc_error] = STATE(3515),
    [sym_preproc_warning] = STATE(3515),
    [sym_preproc_define] = STATE(3515),
    [sym_preproc_undef] = STATE(3515),
    [aux_sym_function_pointer_type_repeat1] = STATE(3516),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3516] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7594),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3516),
    [sym_preproc_endregion] = STATE(3516),
    [sym_preproc_line] = STATE(3516),
    [sym_preproc_pragma] = STATE(3516),
    [sym_preproc_nullable] = STATE(3516),
    [sym_preproc_error] = STATE(3516),
    [sym_preproc_warning] = STATE(3516),
    [sym_preproc_define] = STATE(3516),
    [sym_preproc_undef] = STATE(3516),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3517] = {
    [sym_preproc_region] = STATE(3517),
    [sym_preproc_endregion] = STATE(3517),
    [sym_preproc_line] = STATE(3517),
    [sym_preproc_pragma] = STATE(3517),
    [sym_preproc_nullable] = STATE(3517),
    [sym_preproc_error] = STATE(3517),
    [sym_preproc_warning] = STATE(3517),
    [sym_preproc_define] = STATE(3517),
    [sym_preproc_undef] = STATE(3517),
    [anon_sym_EQ] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5582),
    [anon_sym_DASH_EQ] = ACTIONS(5582),
    [anon_sym_STAR_EQ] = ACTIONS(5582),
    [anon_sym_SLASH_EQ] = ACTIONS(5582),
    [anon_sym_PERCENT_EQ] = ACTIONS(5582),
    [anon_sym_AMP_EQ] = ACTIONS(5582),
    [anon_sym_CARET_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_LT_LT_EQ] = ACTIONS(5582),
    [anon_sym_GT_GT_EQ] = ACTIONS(5582),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3518] = {
    [sym_preproc_region] = STATE(3518),
    [sym_preproc_endregion] = STATE(3518),
    [sym_preproc_line] = STATE(3518),
    [sym_preproc_pragma] = STATE(3518),
    [sym_preproc_nullable] = STATE(3518),
    [sym_preproc_error] = STATE(3518),
    [sym_preproc_warning] = STATE(3518),
    [sym_preproc_define] = STATE(3518),
    [sym_preproc_undef] = STATE(3518),
    [anon_sym_SEMI] = ACTIONS(5145),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5145),
    [anon_sym_COMMA] = ACTIONS(5145),
    [anon_sym_RBRACK] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5145),
    [anon_sym_RBRACE] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5147),
    [anon_sym_in] = ACTIONS(5145),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_BANG] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5145),
    [anon_sym_PIPE] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5147),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5147),
    [anon_sym_GT_GT_GT] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5145),
    [anon_sym_BANG_EQ] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5145),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_DOT] = ACTIONS(5147),
    [anon_sym_EQ_GT] = ACTIONS(5145),
    [anon_sym_switch] = ACTIONS(5145),
    [anon_sym_when] = ACTIONS(5145),
    [anon_sym_DOT_DOT] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_or] = ACTIONS(5145),
    [anon_sym_AMP_AMP] = ACTIONS(5145),
    [anon_sym_PIPE_PIPE] = ACTIONS(5145),
    [anon_sym_QMARK_QMARK] = ACTIONS(5145),
    [anon_sym_on] = ACTIONS(5145),
    [anon_sym_equals] = ACTIONS(5145),
    [anon_sym_by] = ACTIONS(5145),
    [anon_sym_as] = ACTIONS(5145),
    [anon_sym_is] = ACTIONS(5145),
    [anon_sym_DASH_GT] = ACTIONS(5145),
    [anon_sym_with] = ACTIONS(5145),
    [aux_sym_preproc_if_token3] = ACTIONS(5145),
    [aux_sym_preproc_else_token1] = ACTIONS(5145),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3519] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7578),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3519),
    [sym_preproc_endregion] = STATE(3519),
    [sym_preproc_line] = STATE(3519),
    [sym_preproc_pragma] = STATE(3519),
    [sym_preproc_nullable] = STATE(3519),
    [sym_preproc_error] = STATE(3519),
    [sym_preproc_warning] = STATE(3519),
    [sym_preproc_define] = STATE(3519),
    [sym_preproc_undef] = STATE(3519),
    [aux_sym_function_pointer_type_repeat1] = STATE(3520),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3520] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7411),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3520),
    [sym_preproc_endregion] = STATE(3520),
    [sym_preproc_line] = STATE(3520),
    [sym_preproc_pragma] = STATE(3520),
    [sym_preproc_nullable] = STATE(3520),
    [sym_preproc_error] = STATE(3520),
    [sym_preproc_warning] = STATE(3520),
    [sym_preproc_define] = STATE(3520),
    [sym_preproc_undef] = STATE(3520),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3521] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7411),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3521),
    [sym_preproc_endregion] = STATE(3521),
    [sym_preproc_line] = STATE(3521),
    [sym_preproc_pragma] = STATE(3521),
    [sym_preproc_nullable] = STATE(3521),
    [sym_preproc_error] = STATE(3521),
    [sym_preproc_warning] = STATE(3521),
    [sym_preproc_define] = STATE(3521),
    [sym_preproc_undef] = STATE(3521),
    [aux_sym_function_pointer_type_repeat1] = STATE(3522),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3522] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7458),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3522),
    [sym_preproc_endregion] = STATE(3522),
    [sym_preproc_line] = STATE(3522),
    [sym_preproc_pragma] = STATE(3522),
    [sym_preproc_nullable] = STATE(3522),
    [sym_preproc_error] = STATE(3522),
    [sym_preproc_warning] = STATE(3522),
    [sym_preproc_define] = STATE(3522),
    [sym_preproc_undef] = STATE(3522),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3523] = {
    [sym_preproc_region] = STATE(3523),
    [sym_preproc_endregion] = STATE(3523),
    [sym_preproc_line] = STATE(3523),
    [sym_preproc_pragma] = STATE(3523),
    [sym_preproc_nullable] = STATE(3523),
    [sym_preproc_error] = STATE(3523),
    [sym_preproc_warning] = STATE(3523),
    [sym_preproc_define] = STATE(3523),
    [sym_preproc_undef] = STATE(3523),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5586),
    [anon_sym_DASH_EQ] = ACTIONS(5586),
    [anon_sym_STAR_EQ] = ACTIONS(5586),
    [anon_sym_SLASH_EQ] = ACTIONS(5586),
    [anon_sym_PERCENT_EQ] = ACTIONS(5586),
    [anon_sym_AMP_EQ] = ACTIONS(5586),
    [anon_sym_CARET_EQ] = ACTIONS(5586),
    [anon_sym_PIPE_EQ] = ACTIONS(5586),
    [anon_sym_LT_LT_EQ] = ACTIONS(5586),
    [anon_sym_GT_GT_EQ] = ACTIONS(5586),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5586),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3524] = {
    [sym_preproc_region] = STATE(3524),
    [sym_preproc_endregion] = STATE(3524),
    [sym_preproc_line] = STATE(3524),
    [sym_preproc_pragma] = STATE(3524),
    [sym_preproc_nullable] = STATE(3524),
    [sym_preproc_error] = STATE(3524),
    [sym_preproc_warning] = STATE(3524),
    [sym_preproc_define] = STATE(3524),
    [sym_preproc_undef] = STATE(3524),
    [anon_sym_EQ] = ACTIONS(5588),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5590),
    [anon_sym_DASH_EQ] = ACTIONS(5590),
    [anon_sym_STAR_EQ] = ACTIONS(5590),
    [anon_sym_SLASH_EQ] = ACTIONS(5590),
    [anon_sym_PERCENT_EQ] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5590),
    [anon_sym_CARET_EQ] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5590),
    [anon_sym_LT_LT_EQ] = ACTIONS(5590),
    [anon_sym_GT_GT_EQ] = ACTIONS(5590),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5590),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3525] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7359),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3525),
    [sym_preproc_endregion] = STATE(3525),
    [sym_preproc_line] = STATE(3525),
    [sym_preproc_pragma] = STATE(3525),
    [sym_preproc_nullable] = STATE(3525),
    [sym_preproc_error] = STATE(3525),
    [sym_preproc_warning] = STATE(3525),
    [sym_preproc_define] = STATE(3525),
    [sym_preproc_undef] = STATE(3525),
    [aux_sym_function_pointer_type_repeat1] = STATE(3526),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3526] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7513),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3526),
    [sym_preproc_endregion] = STATE(3526),
    [sym_preproc_line] = STATE(3526),
    [sym_preproc_pragma] = STATE(3526),
    [sym_preproc_nullable] = STATE(3526),
    [sym_preproc_error] = STATE(3526),
    [sym_preproc_warning] = STATE(3526),
    [sym_preproc_define] = STATE(3526),
    [sym_preproc_undef] = STATE(3526),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3527] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7513),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3527),
    [sym_preproc_endregion] = STATE(3527),
    [sym_preproc_line] = STATE(3527),
    [sym_preproc_pragma] = STATE(3527),
    [sym_preproc_nullable] = STATE(3527),
    [sym_preproc_error] = STATE(3527),
    [sym_preproc_warning] = STATE(3527),
    [sym_preproc_define] = STATE(3527),
    [sym_preproc_undef] = STATE(3527),
    [aux_sym_function_pointer_type_repeat1] = STATE(3528),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3528] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7575),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7407),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3528),
    [sym_preproc_endregion] = STATE(3528),
    [sym_preproc_line] = STATE(3528),
    [sym_preproc_pragma] = STATE(3528),
    [sym_preproc_nullable] = STATE(3528),
    [sym_preproc_error] = STATE(3528),
    [sym_preproc_warning] = STATE(3528),
    [sym_preproc_define] = STATE(3528),
    [sym_preproc_undef] = STATE(3528),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5516),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_out] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3529] = {
    [sym_preproc_region] = STATE(3529),
    [sym_preproc_endregion] = STATE(3529),
    [sym_preproc_line] = STATE(3529),
    [sym_preproc_pragma] = STATE(3529),
    [sym_preproc_nullable] = STATE(3529),
    [sym_preproc_error] = STATE(3529),
    [sym_preproc_warning] = STATE(3529),
    [sym_preproc_define] = STATE(3529),
    [sym_preproc_undef] = STATE(3529),
    [anon_sym_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3530] = {
    [sym_preproc_region] = STATE(3530),
    [sym_preproc_endregion] = STATE(3530),
    [sym_preproc_line] = STATE(3530),
    [sym_preproc_pragma] = STATE(3530),
    [sym_preproc_nullable] = STATE(3530),
    [sym_preproc_error] = STATE(3530),
    [sym_preproc_warning] = STATE(3530),
    [sym_preproc_define] = STATE(3530),
    [sym_preproc_undef] = STATE(3530),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [anon_sym_COLON] = ACTIONS(5441),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RBRACK] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(5441),
    [anon_sym_RPAREN] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_LT] = ACTIONS(5443),
    [anon_sym_GT] = ACTIONS(5443),
    [anon_sym_in] = ACTIONS(5441),
    [anon_sym_QMARK] = ACTIONS(5443),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS_PLUS] = ACTIONS(5441),
    [anon_sym_DASH_DASH] = ACTIONS(5441),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_SLASH] = ACTIONS(5443),
    [anon_sym_PERCENT] = ACTIONS(5441),
    [anon_sym_CARET] = ACTIONS(5441),
    [anon_sym_PIPE] = ACTIONS(5443),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym_LT_LT] = ACTIONS(5441),
    [anon_sym_GT_GT] = ACTIONS(5443),
    [anon_sym_GT_GT_GT] = ACTIONS(5441),
    [anon_sym_EQ_EQ] = ACTIONS(5441),
    [anon_sym_BANG_EQ] = ACTIONS(5441),
    [anon_sym_GT_EQ] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5441),
    [anon_sym_DOT] = ACTIONS(5443),
    [anon_sym_EQ_GT] = ACTIONS(5441),
    [anon_sym_switch] = ACTIONS(5441),
    [anon_sym_when] = ACTIONS(5441),
    [anon_sym_DOT_DOT] = ACTIONS(5441),
    [anon_sym_and] = ACTIONS(5441),
    [anon_sym_or] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_PIPE_PIPE] = ACTIONS(5441),
    [anon_sym_QMARK_QMARK] = ACTIONS(5441),
    [anon_sym_on] = ACTIONS(5441),
    [anon_sym_equals] = ACTIONS(5441),
    [anon_sym_by] = ACTIONS(5441),
    [anon_sym_as] = ACTIONS(5441),
    [anon_sym_is] = ACTIONS(5441),
    [anon_sym_DASH_GT] = ACTIONS(5441),
    [anon_sym_with] = ACTIONS(5441),
    [aux_sym_preproc_if_token3] = ACTIONS(5441),
    [aux_sym_preproc_else_token1] = ACTIONS(5441),
    [aux_sym_preproc_elif_token1] = ACTIONS(5441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3531] = {
    [sym_preproc_region] = STATE(3531),
    [sym_preproc_endregion] = STATE(3531),
    [sym_preproc_line] = STATE(3531),
    [sym_preproc_pragma] = STATE(3531),
    [sym_preproc_nullable] = STATE(3531),
    [sym_preproc_error] = STATE(3531),
    [sym_preproc_warning] = STATE(3531),
    [sym_preproc_define] = STATE(3531),
    [sym_preproc_undef] = STATE(3531),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3532] = {
    [sym_preproc_region] = STATE(3532),
    [sym_preproc_endregion] = STATE(3532),
    [sym_preproc_line] = STATE(3532),
    [sym_preproc_pragma] = STATE(3532),
    [sym_preproc_nullable] = STATE(3532),
    [sym_preproc_error] = STATE(3532),
    [sym_preproc_warning] = STATE(3532),
    [sym_preproc_define] = STATE(3532),
    [sym_preproc_undef] = STATE(3532),
    [anon_sym_EQ] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3716),
    [anon_sym_DASH] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(3716),
    [anon_sym_SLASH] = ACTIONS(3716),
    [anon_sym_PERCENT] = ACTIONS(3716),
    [anon_sym_CARET] = ACTIONS(3716),
    [anon_sym_PIPE] = ACTIONS(3716),
    [anon_sym_AMP] = ACTIONS(3716),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_GT_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_DOT] = ACTIONS(3716),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(4295),
    [anon_sym_DOT_DOT] = ACTIONS(3731),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4295),
    [anon_sym_PLUS_EQ] = ACTIONS(3731),
    [anon_sym_DASH_EQ] = ACTIONS(3731),
    [anon_sym_STAR_EQ] = ACTIONS(3731),
    [anon_sym_SLASH_EQ] = ACTIONS(3731),
    [anon_sym_PERCENT_EQ] = ACTIONS(3731),
    [anon_sym_AMP_EQ] = ACTIONS(3731),
    [anon_sym_CARET_EQ] = ACTIONS(3731),
    [anon_sym_PIPE_EQ] = ACTIONS(3731),
    [anon_sym_LT_LT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_QMARK_QMARK] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_is] = ACTIONS(3731),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [anon_sym_with] = ACTIONS(3731),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3533] = {
    [sym_preproc_region] = STATE(3533),
    [sym_preproc_endregion] = STATE(3533),
    [sym_preproc_line] = STATE(3533),
    [sym_preproc_pragma] = STATE(3533),
    [sym_preproc_nullable] = STATE(3533),
    [sym_preproc_error] = STATE(3533),
    [sym_preproc_warning] = STATE(3533),
    [sym_preproc_define] = STATE(3533),
    [sym_preproc_undef] = STATE(3533),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_in] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_BANG] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5388),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_GT_GT_GT] = ACTIONS(5388),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_EQ_GT] = ACTIONS(5388),
    [anon_sym_switch] = ACTIONS(5388),
    [anon_sym_when] = ACTIONS(5388),
    [anon_sym_DOT_DOT] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_QMARK_QMARK] = ACTIONS(5388),
    [anon_sym_on] = ACTIONS(5388),
    [anon_sym_equals] = ACTIONS(5388),
    [anon_sym_by] = ACTIONS(5388),
    [anon_sym_as] = ACTIONS(5388),
    [anon_sym_is] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [anon_sym_with] = ACTIONS(5388),
    [aux_sym_preproc_if_token3] = ACTIONS(5388),
    [aux_sym_preproc_else_token1] = ACTIONS(5388),
    [aux_sym_preproc_elif_token1] = ACTIONS(5388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3534] = {
    [sym_preproc_region] = STATE(3534),
    [sym_preproc_endregion] = STATE(3534),
    [sym_preproc_line] = STATE(3534),
    [sym_preproc_pragma] = STATE(3534),
    [sym_preproc_nullable] = STATE(3534),
    [sym_preproc_error] = STATE(3534),
    [sym_preproc_warning] = STATE(3534),
    [sym_preproc_define] = STATE(3534),
    [sym_preproc_undef] = STATE(3534),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_in] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_BANG] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5388),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_GT_GT_GT] = ACTIONS(5388),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_EQ_GT] = ACTIONS(5388),
    [anon_sym_switch] = ACTIONS(5388),
    [anon_sym_when] = ACTIONS(5388),
    [anon_sym_DOT_DOT] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_QMARK_QMARK] = ACTIONS(5388),
    [anon_sym_on] = ACTIONS(5388),
    [anon_sym_equals] = ACTIONS(5388),
    [anon_sym_by] = ACTIONS(5388),
    [anon_sym_as] = ACTIONS(5388),
    [anon_sym_is] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [anon_sym_with] = ACTIONS(5388),
    [aux_sym_preproc_if_token3] = ACTIONS(5388),
    [aux_sym_preproc_else_token1] = ACTIONS(5388),
    [aux_sym_preproc_elif_token1] = ACTIONS(5388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3535] = {
    [sym_preproc_region] = STATE(3535),
    [sym_preproc_endregion] = STATE(3535),
    [sym_preproc_line] = STATE(3535),
    [sym_preproc_pragma] = STATE(3535),
    [sym_preproc_nullable] = STATE(3535),
    [sym_preproc_error] = STATE(3535),
    [sym_preproc_warning] = STATE(3535),
    [sym_preproc_define] = STATE(3535),
    [sym_preproc_undef] = STATE(3535),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_in] = ACTIONS(5403),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_when] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_on] = ACTIONS(5403),
    [anon_sym_equals] = ACTIONS(5403),
    [anon_sym_by] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5403),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_if_token3] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3536] = {
    [sym_preproc_region] = STATE(3536),
    [sym_preproc_endregion] = STATE(3536),
    [sym_preproc_line] = STATE(3536),
    [sym_preproc_pragma] = STATE(3536),
    [sym_preproc_nullable] = STATE(3536),
    [sym_preproc_error] = STATE(3536),
    [sym_preproc_warning] = STATE(3536),
    [sym_preproc_define] = STATE(3536),
    [sym_preproc_undef] = STATE(3536),
    [anon_sym_SEMI] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COMMA] = ACTIONS(5411),
    [anon_sym_RBRACK] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5411),
    [anon_sym_RPAREN] = ACTIONS(5411),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5413),
    [anon_sym_in] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5413),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_PIPE] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5413),
    [anon_sym_GT_GT_GT] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5411),
    [anon_sym_BANG_EQ] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_DOT] = ACTIONS(5413),
    [anon_sym_EQ_GT] = ACTIONS(5411),
    [anon_sym_switch] = ACTIONS(5411),
    [anon_sym_when] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_AMP_AMP] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_on] = ACTIONS(5411),
    [anon_sym_equals] = ACTIONS(5411),
    [anon_sym_by] = ACTIONS(5411),
    [anon_sym_as] = ACTIONS(5411),
    [anon_sym_is] = ACTIONS(5411),
    [anon_sym_DASH_GT] = ACTIONS(5411),
    [anon_sym_with] = ACTIONS(5411),
    [aux_sym_preproc_if_token3] = ACTIONS(5411),
    [aux_sym_preproc_else_token1] = ACTIONS(5411),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3537] = {
    [sym_preproc_region] = STATE(3537),
    [sym_preproc_endregion] = STATE(3537),
    [sym_preproc_line] = STATE(3537),
    [sym_preproc_pragma] = STATE(3537),
    [sym_preproc_nullable] = STATE(3537),
    [sym_preproc_error] = STATE(3537),
    [sym_preproc_warning] = STATE(3537),
    [sym_preproc_define] = STATE(3537),
    [sym_preproc_undef] = STATE(3537),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_when] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_on] = ACTIONS(2979),
    [anon_sym_equals] = ACTIONS(2979),
    [anon_sym_by] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_if_token3] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3538] = {
    [sym_preproc_region] = STATE(3538),
    [sym_preproc_endregion] = STATE(3538),
    [sym_preproc_line] = STATE(3538),
    [sym_preproc_pragma] = STATE(3538),
    [sym_preproc_nullable] = STATE(3538),
    [sym_preproc_error] = STATE(3538),
    [sym_preproc_warning] = STATE(3538),
    [sym_preproc_define] = STATE(3538),
    [sym_preproc_undef] = STATE(3538),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(3167),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_RBRACK] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3167),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3167),
    [anon_sym_GT_EQ] = ACTIONS(3167),
    [anon_sym_LT_EQ] = ACTIONS(3167),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_when] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_and] = ACTIONS(3167),
    [anon_sym_or] = ACTIONS(3167),
    [anon_sym_AMP_AMP] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3167),
    [anon_sym_QMARK_QMARK] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3167),
    [anon_sym_is] = ACTIONS(3167),
    [anon_sym_DASH_GT] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [aux_sym_preproc_if_token3] = ACTIONS(3167),
    [aux_sym_preproc_else_token1] = ACTIONS(3167),
    [aux_sym_preproc_elif_token1] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3539] = {
    [sym_preproc_region] = STATE(3539),
    [sym_preproc_endregion] = STATE(3539),
    [sym_preproc_line] = STATE(3539),
    [sym_preproc_pragma] = STATE(3539),
    [sym_preproc_nullable] = STATE(3539),
    [sym_preproc_error] = STATE(3539),
    [sym_preproc_warning] = STATE(3539),
    [sym_preproc_define] = STATE(3539),
    [sym_preproc_undef] = STATE(3539),
    [sym__identifier_token] = ACTIONS(5596),
    [anon_sym_extern] = ACTIONS(5596),
    [anon_sym_alias] = ACTIONS(5596),
    [anon_sym_global] = ACTIONS(5596),
    [anon_sym_unsafe] = ACTIONS(5596),
    [anon_sym_static] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_abstract] = ACTIONS(5596),
    [anon_sym_async] = ACTIONS(5596),
    [anon_sym_const] = ACTIONS(5596),
    [anon_sym_file] = ACTIONS(5596),
    [anon_sym_fixed] = ACTIONS(5596),
    [anon_sym_internal] = ACTIONS(5596),
    [anon_sym_new] = ACTIONS(5596),
    [anon_sym_override] = ACTIONS(5596),
    [anon_sym_partial] = ACTIONS(5596),
    [anon_sym_private] = ACTIONS(5596),
    [anon_sym_protected] = ACTIONS(5596),
    [anon_sym_public] = ACTIONS(5596),
    [anon_sym_readonly] = ACTIONS(5596),
    [anon_sym_required] = ACTIONS(5596),
    [anon_sym_sealed] = ACTIONS(5596),
    [anon_sym_virtual] = ACTIONS(5596),
    [anon_sym_volatile] = ACTIONS(5596),
    [anon_sym_where] = ACTIONS(5596),
    [anon_sym_notnull] = ACTIONS(5596),
    [anon_sym_unmanaged] = ACTIONS(5596),
    [anon_sym_get] = ACTIONS(5596),
    [anon_sym_set] = ACTIONS(5596),
    [anon_sym_add] = ACTIONS(5596),
    [anon_sym_remove] = ACTIONS(5596),
    [anon_sym_init] = ACTIONS(5596),
    [anon_sym_scoped] = ACTIONS(5596),
    [anon_sym_var] = ACTIONS(5596),
    [anon_sym_yield] = ACTIONS(5596),
    [anon_sym_when] = ACTIONS(5596),
    [anon_sym_from] = ACTIONS(5596),
    [anon_sym_into] = ACTIONS(5596),
    [anon_sym_join] = ACTIONS(5596),
    [anon_sym_on] = ACTIONS(5596),
    [anon_sym_equals] = ACTIONS(5596),
    [anon_sym_let] = ACTIONS(5596),
    [anon_sym_orderby] = ACTIONS(5596),
    [anon_sym_ascending] = ACTIONS(5596),
    [anon_sym_descending] = ACTIONS(5596),
    [anon_sym_group] = ACTIONS(5596),
    [anon_sym_by] = ACTIONS(5596),
    [anon_sym_select] = ACTIONS(5596),
    [aux_sym_preproc_if_token1] = ACTIONS(5598),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3540] = {
    [sym_initializer_expression] = STATE(3101),
    [sym_preproc_region] = STATE(3540),
    [sym_preproc_endregion] = STATE(3540),
    [sym_preproc_line] = STATE(3540),
    [sym_preproc_pragma] = STATE(3540),
    [sym_preproc_nullable] = STATE(3540),
    [sym_preproc_error] = STATE(3540),
    [sym_preproc_warning] = STATE(3540),
    [sym_preproc_define] = STATE(3540),
    [sym_preproc_undef] = STATE(3540),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4916),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(5600),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4926),
    [anon_sym_in] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(5603),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4926),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4926),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_GT_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4926),
    [anon_sym_EQ_GT] = ACTIONS(4920),
    [anon_sym_switch] = ACTIONS(4920),
    [anon_sym_DOT_DOT] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_QMARK_QMARK] = ACTIONS(4920),
    [anon_sym_into] = ACTIONS(4920),
    [anon_sym_on] = ACTIONS(4920),
    [anon_sym_equals] = ACTIONS(4920),
    [anon_sym_by] = ACTIONS(4920),
    [anon_sym_as] = ACTIONS(4920),
    [anon_sym_is] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_with] = ACTIONS(4920),
    [aux_sym_preproc_if_token3] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4920),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3541] = {
    [sym_argument_list] = STATE(2969),
    [sym_initializer_expression] = STATE(3106),
    [sym_preproc_region] = STATE(3541),
    [sym_preproc_endregion] = STATE(3541),
    [sym_preproc_line] = STATE(3541),
    [sym_preproc_pragma] = STATE(3541),
    [sym_preproc_nullable] = STATE(3541),
    [sym_preproc_error] = STATE(3541),
    [sym_preproc_warning] = STATE(3541),
    [sym_preproc_define] = STATE(3541),
    [sym_preproc_undef] = STATE(3541),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_COLON] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(4811),
    [anon_sym_RBRACK] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LT] = ACTIONS(4815),
    [anon_sym_GT] = ACTIONS(4815),
    [anon_sym_in] = ACTIONS(4811),
    [anon_sym_QMARK] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4815),
    [anon_sym_PERCENT] = ACTIONS(4811),
    [anon_sym_CARET] = ACTIONS(4811),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_LT_LT] = ACTIONS(4811),
    [anon_sym_GT_GT] = ACTIONS(4815),
    [anon_sym_GT_GT_GT] = ACTIONS(4811),
    [anon_sym_EQ_EQ] = ACTIONS(4811),
    [anon_sym_BANG_EQ] = ACTIONS(4811),
    [anon_sym_GT_EQ] = ACTIONS(4811),
    [anon_sym_LT_EQ] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_EQ_GT] = ACTIONS(4811),
    [anon_sym_switch] = ACTIONS(4811),
    [anon_sym_DOT_DOT] = ACTIONS(4811),
    [anon_sym_AMP_AMP] = ACTIONS(4811),
    [anon_sym_PIPE_PIPE] = ACTIONS(4811),
    [anon_sym_QMARK_QMARK] = ACTIONS(4811),
    [anon_sym_on] = ACTIONS(4811),
    [anon_sym_equals] = ACTIONS(4811),
    [anon_sym_by] = ACTIONS(4811),
    [anon_sym_as] = ACTIONS(4811),
    [anon_sym_is] = ACTIONS(4811),
    [anon_sym_DASH_GT] = ACTIONS(4811),
    [anon_sym_with] = ACTIONS(4811),
    [aux_sym_preproc_if_token3] = ACTIONS(4811),
    [aux_sym_preproc_else_token1] = ACTIONS(4811),
    [aux_sym_preproc_elif_token1] = ACTIONS(4811),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3542] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3542),
    [sym_preproc_endregion] = STATE(3542),
    [sym_preproc_line] = STATE(3542),
    [sym_preproc_pragma] = STATE(3542),
    [sym_preproc_nullable] = STATE(3542),
    [sym_preproc_error] = STATE(3542),
    [sym_preproc_warning] = STATE(3542),
    [sym_preproc_define] = STATE(3542),
    [sym_preproc_undef] = STATE(3542),
    [sym__identifier_token] = ACTIONS(3601),
    [anon_sym_alias] = ACTIONS(3605),
    [anon_sym_global] = ACTIONS(3605),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(2719),
    [anon_sym_delegate] = ACTIONS(2719),
    [anon_sym_file] = ACTIONS(3605),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3605),
    [anon_sym_unmanaged] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(2719),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3605),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3605),
    [sym_predefined_type] = ACTIONS(2719),
    [anon_sym_yield] = ACTIONS(3605),
    [anon_sym_when] = ACTIONS(3605),
    [anon_sym_from] = ACTIONS(3605),
    [anon_sym_into] = ACTIONS(3605),
    [anon_sym_join] = ACTIONS(3605),
    [anon_sym_on] = ACTIONS(3605),
    [anon_sym_equals] = ACTIONS(3605),
    [anon_sym_let] = ACTIONS(3605),
    [anon_sym_orderby] = ACTIONS(3605),
    [anon_sym_ascending] = ACTIONS(3605),
    [anon_sym_descending] = ACTIONS(3605),
    [anon_sym_group] = ACTIONS(3605),
    [anon_sym_by] = ACTIONS(3605),
    [anon_sym_select] = ACTIONS(3605),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3543] = {
    [sym_preproc_region] = STATE(3543),
    [sym_preproc_endregion] = STATE(3543),
    [sym_preproc_line] = STATE(3543),
    [sym_preproc_pragma] = STATE(3543),
    [sym_preproc_nullable] = STATE(3543),
    [sym_preproc_error] = STATE(3543),
    [sym_preproc_warning] = STATE(3543),
    [sym_preproc_define] = STATE(3543),
    [sym_preproc_undef] = STATE(3543),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(2063),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_EQ_GT] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(2061),
    [anon_sym_DOT_DOT] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_QMARK_QMARK] = ACTIONS(2061),
    [anon_sym_on] = ACTIONS(2061),
    [anon_sym_equals] = ACTIONS(2061),
    [anon_sym_by] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_DASH_GT] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [aux_sym_preproc_if_token3] = ACTIONS(2061),
    [aux_sym_preproc_else_token1] = ACTIONS(2061),
    [aux_sym_preproc_elif_token1] = ACTIONS(2061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3544] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6128),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3544),
    [sym_preproc_endregion] = STATE(3544),
    [sym_preproc_line] = STATE(3544),
    [sym_preproc_pragma] = STATE(3544),
    [sym_preproc_nullable] = STATE(3544),
    [sym_preproc_error] = STATE(3544),
    [sym_preproc_warning] = STATE(3544),
    [sym_preproc_define] = STATE(3544),
    [sym_preproc_undef] = STATE(3544),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(5827),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(4735),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_out] = ACTIONS(1125),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_this] = ACTIONS(1125),
    [anon_sym_scoped] = ACTIONS(4737),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3545] = {
    [sym_preproc_region] = STATE(3545),
    [sym_preproc_endregion] = STATE(3545),
    [sym_preproc_line] = STATE(3545),
    [sym_preproc_pragma] = STATE(3545),
    [sym_preproc_nullable] = STATE(3545),
    [sym_preproc_error] = STATE(3545),
    [sym_preproc_warning] = STATE(3545),
    [sym_preproc_define] = STATE(3545),
    [sym_preproc_undef] = STATE(3545),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_COLON] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_in] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_BANG] = ACTIONS(5498),
    [anon_sym_PLUS_PLUS] = ACTIONS(5496),
    [anon_sym_DASH_DASH] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_CARET] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5496),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_GT_GT_GT] = ACTIONS(5496),
    [anon_sym_EQ_EQ] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(5496),
    [anon_sym_GT_EQ] = ACTIONS(5496),
    [anon_sym_LT_EQ] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_switch] = ACTIONS(5496),
    [anon_sym_when] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_and] = ACTIONS(5496),
    [anon_sym_or] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5496),
    [anon_sym_PIPE_PIPE] = ACTIONS(5496),
    [anon_sym_QMARK_QMARK] = ACTIONS(5496),
    [anon_sym_on] = ACTIONS(5496),
    [anon_sym_equals] = ACTIONS(5496),
    [anon_sym_by] = ACTIONS(5496),
    [anon_sym_as] = ACTIONS(5496),
    [anon_sym_is] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_with] = ACTIONS(5496),
    [aux_sym_preproc_if_token3] = ACTIONS(5496),
    [aux_sym_preproc_else_token1] = ACTIONS(5496),
    [aux_sym_preproc_elif_token1] = ACTIONS(5496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3546] = {
    [sym_preproc_region] = STATE(3546),
    [sym_preproc_endregion] = STATE(3546),
    [sym_preproc_line] = STATE(3546),
    [sym_preproc_pragma] = STATE(3546),
    [sym_preproc_nullable] = STATE(3546),
    [sym_preproc_error] = STATE(3546),
    [sym_preproc_warning] = STATE(3546),
    [sym_preproc_define] = STATE(3546),
    [sym_preproc_undef] = STATE(3546),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_COLON] = ACTIONS(5512),
    [anon_sym_COMMA] = ACTIONS(5512),
    [anon_sym_RBRACK] = ACTIONS(5512),
    [anon_sym_LPAREN] = ACTIONS(5512),
    [anon_sym_RPAREN] = ACTIONS(5512),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_LT] = ACTIONS(5514),
    [anon_sym_GT] = ACTIONS(5514),
    [anon_sym_in] = ACTIONS(5512),
    [anon_sym_QMARK] = ACTIONS(5514),
    [anon_sym_BANG] = ACTIONS(5514),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_SLASH] = ACTIONS(5514),
    [anon_sym_PERCENT] = ACTIONS(5512),
    [anon_sym_CARET] = ACTIONS(5512),
    [anon_sym_PIPE] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym_LT_LT] = ACTIONS(5512),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_GT_GT_GT] = ACTIONS(5512),
    [anon_sym_EQ_EQ] = ACTIONS(5512),
    [anon_sym_BANG_EQ] = ACTIONS(5512),
    [anon_sym_GT_EQ] = ACTIONS(5512),
    [anon_sym_LT_EQ] = ACTIONS(5512),
    [anon_sym_DOT] = ACTIONS(5514),
    [anon_sym_EQ_GT] = ACTIONS(5512),
    [anon_sym_switch] = ACTIONS(5512),
    [anon_sym_when] = ACTIONS(5512),
    [anon_sym_DOT_DOT] = ACTIONS(5512),
    [anon_sym_and] = ACTIONS(5512),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_PIPE_PIPE] = ACTIONS(5512),
    [anon_sym_QMARK_QMARK] = ACTIONS(5512),
    [anon_sym_on] = ACTIONS(5512),
    [anon_sym_equals] = ACTIONS(5512),
    [anon_sym_by] = ACTIONS(5512),
    [anon_sym_as] = ACTIONS(5512),
    [anon_sym_is] = ACTIONS(5512),
    [anon_sym_DASH_GT] = ACTIONS(5512),
    [anon_sym_with] = ACTIONS(5512),
    [aux_sym_preproc_if_token3] = ACTIONS(5512),
    [aux_sym_preproc_else_token1] = ACTIONS(5512),
    [aux_sym_preproc_elif_token1] = ACTIONS(5512),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3547] = {
    [sym_preproc_region] = STATE(3547),
    [sym_preproc_endregion] = STATE(3547),
    [sym_preproc_line] = STATE(3547),
    [sym_preproc_pragma] = STATE(3547),
    [sym_preproc_nullable] = STATE(3547),
    [sym_preproc_error] = STATE(3547),
    [sym_preproc_warning] = STATE(3547),
    [sym_preproc_define] = STATE(3547),
    [sym_preproc_undef] = STATE(3547),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(5455),
    [anon_sym_GT] = ACTIONS(5455),
    [anon_sym_in] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(5455),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(5455),
    [anon_sym_AMP] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(5455),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(5455),
    [anon_sym_EQ_GT] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_when] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_QMARK_QMARK] = ACTIONS(3881),
    [anon_sym_on] = ACTIONS(3881),
    [anon_sym_equals] = ACTIONS(3881),
    [anon_sym_by] = ACTIONS(3881),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_is] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [aux_sym_preproc_if_token3] = ACTIONS(3881),
    [aux_sym_preproc_else_token1] = ACTIONS(3881),
    [aux_sym_preproc_elif_token1] = ACTIONS(3881),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3548] = {
    [sym_preproc_region] = STATE(3548),
    [sym_preproc_endregion] = STATE(3548),
    [sym_preproc_line] = STATE(3548),
    [sym_preproc_pragma] = STATE(3548),
    [sym_preproc_nullable] = STATE(3548),
    [sym_preproc_error] = STATE(3548),
    [sym_preproc_warning] = STATE(3548),
    [sym_preproc_define] = STATE(3548),
    [sym_preproc_undef] = STATE(3548),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_COLON] = ACTIONS(5488),
    [anon_sym_COMMA] = ACTIONS(5488),
    [anon_sym_RBRACK] = ACTIONS(5488),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_RPAREN] = ACTIONS(5488),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_LT] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5490),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(5490),
    [anon_sym_BANG] = ACTIONS(5490),
    [anon_sym_PLUS_PLUS] = ACTIONS(5488),
    [anon_sym_DASH_DASH] = ACTIONS(5488),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_DASH] = ACTIONS(5490),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_SLASH] = ACTIONS(5490),
    [anon_sym_PERCENT] = ACTIONS(5488),
    [anon_sym_CARET] = ACTIONS(5488),
    [anon_sym_PIPE] = ACTIONS(5490),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_LT_LT] = ACTIONS(5488),
    [anon_sym_GT_GT] = ACTIONS(5490),
    [anon_sym_GT_GT_GT] = ACTIONS(5488),
    [anon_sym_EQ_EQ] = ACTIONS(5488),
    [anon_sym_BANG_EQ] = ACTIONS(5488),
    [anon_sym_GT_EQ] = ACTIONS(5488),
    [anon_sym_LT_EQ] = ACTIONS(5488),
    [anon_sym_DOT] = ACTIONS(5490),
    [anon_sym_EQ_GT] = ACTIONS(5488),
    [anon_sym_switch] = ACTIONS(5488),
    [anon_sym_when] = ACTIONS(5488),
    [anon_sym_DOT_DOT] = ACTIONS(5488),
    [anon_sym_and] = ACTIONS(5488),
    [anon_sym_or] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_PIPE_PIPE] = ACTIONS(5488),
    [anon_sym_QMARK_QMARK] = ACTIONS(5488),
    [anon_sym_on] = ACTIONS(5488),
    [anon_sym_equals] = ACTIONS(5488),
    [anon_sym_by] = ACTIONS(5488),
    [anon_sym_as] = ACTIONS(5488),
    [anon_sym_is] = ACTIONS(5488),
    [anon_sym_DASH_GT] = ACTIONS(5488),
    [anon_sym_with] = ACTIONS(5488),
    [aux_sym_preproc_if_token3] = ACTIONS(5488),
    [aux_sym_preproc_else_token1] = ACTIONS(5488),
    [aux_sym_preproc_elif_token1] = ACTIONS(5488),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3549] = {
    [sym_preproc_region] = STATE(3549),
    [sym_preproc_endregion] = STATE(3549),
    [sym_preproc_line] = STATE(3549),
    [sym_preproc_pragma] = STATE(3549),
    [sym_preproc_nullable] = STATE(3549),
    [sym_preproc_error] = STATE(3549),
    [sym_preproc_warning] = STATE(3549),
    [sym_preproc_define] = STATE(3549),
    [sym_preproc_undef] = STATE(3549),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(5455),
    [anon_sym_GT] = ACTIONS(5455),
    [anon_sym_in] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(5455),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(5455),
    [anon_sym_AMP] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(5455),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(5455),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_when] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_QMARK_QMARK] = ACTIONS(3881),
    [anon_sym_on] = ACTIONS(3881),
    [anon_sym_equals] = ACTIONS(3881),
    [anon_sym_by] = ACTIONS(3881),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_is] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [aux_sym_preproc_if_token3] = ACTIONS(3881),
    [aux_sym_preproc_else_token1] = ACTIONS(3881),
    [aux_sym_preproc_elif_token1] = ACTIONS(3881),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3550] = {
    [sym_parameter_list] = STATE(7385),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5964),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__lambda_parameters] = STATE(7534),
    [sym_identifier] = STATE(5821),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3550),
    [sym_preproc_endregion] = STATE(3550),
    [sym_preproc_line] = STATE(3550),
    [sym_preproc_pragma] = STATE(3550),
    [sym_preproc_nullable] = STATE(3550),
    [sym_preproc_error] = STATE(3550),
    [sym_preproc_warning] = STATE(3550),
    [sym_preproc_define] = STATE(3550),
    [sym_preproc_undef] = STATE(3550),
    [aux_sym__lambda_expression_init_repeat1] = STATE(5891),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(5607),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3551] = {
    [sym_preproc_region] = STATE(3551),
    [sym_preproc_endregion] = STATE(3551),
    [sym_preproc_line] = STATE(3551),
    [sym_preproc_pragma] = STATE(3551),
    [sym_preproc_nullable] = STATE(3551),
    [sym_preproc_error] = STATE(3551),
    [sym_preproc_warning] = STATE(3551),
    [sym_preproc_define] = STATE(3551),
    [sym_preproc_undef] = STATE(3551),
    [sym__identifier_token] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym_alias] = ACTIONS(5609),
    [anon_sym_global] = ACTIONS(5609),
    [anon_sym_unsafe] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_RBRACE] = ACTIONS(5611),
    [anon_sym_abstract] = ACTIONS(5609),
    [anon_sym_async] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_file] = ACTIONS(5609),
    [anon_sym_fixed] = ACTIONS(5609),
    [anon_sym_internal] = ACTIONS(5609),
    [anon_sym_new] = ACTIONS(5609),
    [anon_sym_override] = ACTIONS(5609),
    [anon_sym_partial] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_readonly] = ACTIONS(5609),
    [anon_sym_required] = ACTIONS(5609),
    [anon_sym_sealed] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_where] = ACTIONS(5609),
    [anon_sym_notnull] = ACTIONS(5609),
    [anon_sym_unmanaged] = ACTIONS(5609),
    [anon_sym_get] = ACTIONS(5609),
    [anon_sym_set] = ACTIONS(5609),
    [anon_sym_add] = ACTIONS(5609),
    [anon_sym_remove] = ACTIONS(5609),
    [anon_sym_init] = ACTIONS(5609),
    [anon_sym_scoped] = ACTIONS(5609),
    [anon_sym_var] = ACTIONS(5609),
    [anon_sym_yield] = ACTIONS(5609),
    [anon_sym_when] = ACTIONS(5609),
    [anon_sym_from] = ACTIONS(5609),
    [anon_sym_into] = ACTIONS(5609),
    [anon_sym_join] = ACTIONS(5609),
    [anon_sym_on] = ACTIONS(5609),
    [anon_sym_equals] = ACTIONS(5609),
    [anon_sym_let] = ACTIONS(5609),
    [anon_sym_orderby] = ACTIONS(5609),
    [anon_sym_ascending] = ACTIONS(5609),
    [anon_sym_descending] = ACTIONS(5609),
    [anon_sym_group] = ACTIONS(5609),
    [anon_sym_by] = ACTIONS(5609),
    [anon_sym_select] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5611),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3552] = {
    [sym_preproc_region] = STATE(3552),
    [sym_preproc_endregion] = STATE(3552),
    [sym_preproc_line] = STATE(3552),
    [sym_preproc_pragma] = STATE(3552),
    [sym_preproc_nullable] = STATE(3552),
    [sym_preproc_error] = STATE(3552),
    [sym_preproc_warning] = STATE(3552),
    [sym_preproc_define] = STATE(3552),
    [sym_preproc_undef] = STATE(3552),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5421),
    [anon_sym_COLON] = ACTIONS(5421),
    [anon_sym_COMMA] = ACTIONS(5421),
    [anon_sym_RBRACK] = ACTIONS(5421),
    [anon_sym_LPAREN] = ACTIONS(5421),
    [anon_sym_RPAREN] = ACTIONS(5421),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_LT] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5423),
    [anon_sym_in] = ACTIONS(5421),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5423),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_SLASH] = ACTIONS(5423),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_CARET] = ACTIONS(5421),
    [anon_sym_PIPE] = ACTIONS(5423),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_LT_LT] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5423),
    [anon_sym_GT_GT_GT] = ACTIONS(5421),
    [anon_sym_EQ_EQ] = ACTIONS(5421),
    [anon_sym_BANG_EQ] = ACTIONS(5421),
    [anon_sym_GT_EQ] = ACTIONS(5421),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_DOT] = ACTIONS(5423),
    [anon_sym_EQ_GT] = ACTIONS(5421),
    [anon_sym_switch] = ACTIONS(5421),
    [anon_sym_when] = ACTIONS(5421),
    [anon_sym_DOT_DOT] = ACTIONS(5421),
    [anon_sym_and] = ACTIONS(5421),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5421),
    [anon_sym_QMARK_QMARK] = ACTIONS(5421),
    [anon_sym_on] = ACTIONS(5421),
    [anon_sym_equals] = ACTIONS(5421),
    [anon_sym_by] = ACTIONS(5421),
    [anon_sym_as] = ACTIONS(5421),
    [anon_sym_is] = ACTIONS(5421),
    [anon_sym_DASH_GT] = ACTIONS(5421),
    [anon_sym_with] = ACTIONS(5421),
    [aux_sym_preproc_if_token3] = ACTIONS(5421),
    [aux_sym_preproc_else_token1] = ACTIONS(5421),
    [aux_sym_preproc_elif_token1] = ACTIONS(5421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3553] = {
    [sym_preproc_region] = STATE(3553),
    [sym_preproc_endregion] = STATE(3553),
    [sym_preproc_line] = STATE(3553),
    [sym_preproc_pragma] = STATE(3553),
    [sym_preproc_nullable] = STATE(3553),
    [sym_preproc_error] = STATE(3553),
    [sym_preproc_warning] = STATE(3553),
    [sym_preproc_define] = STATE(3553),
    [sym_preproc_undef] = STATE(3553),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_RBRACK] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(5613),
    [anon_sym_RPAREN] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_EQ_GT] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_when] = ACTIONS(1997),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [anon_sym_or] = ACTIONS(1997),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_on] = ACTIONS(1997),
    [anon_sym_equals] = ACTIONS(1997),
    [anon_sym_by] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1997),
    [anon_sym_is] = ACTIONS(1997),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_with] = ACTIONS(1997),
    [aux_sym_preproc_if_token3] = ACTIONS(1997),
    [aux_sym_preproc_else_token1] = ACTIONS(1997),
    [aux_sym_preproc_elif_token1] = ACTIONS(1997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3554] = {
    [sym_preproc_region] = STATE(3554),
    [sym_preproc_endregion] = STATE(3554),
    [sym_preproc_line] = STATE(3554),
    [sym_preproc_pragma] = STATE(3554),
    [sym_preproc_nullable] = STATE(3554),
    [sym_preproc_error] = STATE(3554),
    [sym_preproc_warning] = STATE(3554),
    [sym_preproc_define] = STATE(3554),
    [sym_preproc_undef] = STATE(3554),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [anon_sym_COLON] = ACTIONS(5417),
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_RBRACK] = ACTIONS(5417),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_RPAREN] = ACTIONS(5417),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5419),
    [anon_sym_in] = ACTIONS(5417),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_PIPE] = ACTIONS(5419),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5419),
    [anon_sym_GT_GT_GT] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5417),
    [anon_sym_BANG_EQ] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_DOT] = ACTIONS(5419),
    [anon_sym_EQ_GT] = ACTIONS(5417),
    [anon_sym_switch] = ACTIONS(5417),
    [anon_sym_when] = ACTIONS(5417),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5417),
    [anon_sym_QMARK_QMARK] = ACTIONS(5417),
    [anon_sym_on] = ACTIONS(5417),
    [anon_sym_equals] = ACTIONS(5417),
    [anon_sym_by] = ACTIONS(5417),
    [anon_sym_as] = ACTIONS(5417),
    [anon_sym_is] = ACTIONS(5417),
    [anon_sym_DASH_GT] = ACTIONS(5417),
    [anon_sym_with] = ACTIONS(5417),
    [aux_sym_preproc_if_token3] = ACTIONS(5417),
    [aux_sym_preproc_else_token1] = ACTIONS(5417),
    [aux_sym_preproc_elif_token1] = ACTIONS(5417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3555] = {
    [sym_preproc_region] = STATE(3555),
    [sym_preproc_endregion] = STATE(3555),
    [sym_preproc_line] = STATE(3555),
    [sym_preproc_pragma] = STATE(3555),
    [sym_preproc_nullable] = STATE(3555),
    [sym_preproc_error] = STATE(3555),
    [sym_preproc_warning] = STATE(3555),
    [sym_preproc_define] = STATE(3555),
    [sym_preproc_undef] = STATE(3555),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [anon_sym_COLON] = ACTIONS(5417),
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_RBRACK] = ACTIONS(5417),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_RPAREN] = ACTIONS(5417),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5419),
    [anon_sym_in] = ACTIONS(5417),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_PIPE] = ACTIONS(5419),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5419),
    [anon_sym_GT_GT_GT] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5417),
    [anon_sym_BANG_EQ] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_DOT] = ACTIONS(5419),
    [anon_sym_EQ_GT] = ACTIONS(5417),
    [anon_sym_switch] = ACTIONS(5417),
    [anon_sym_when] = ACTIONS(5417),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5417),
    [anon_sym_QMARK_QMARK] = ACTIONS(5417),
    [anon_sym_on] = ACTIONS(5417),
    [anon_sym_equals] = ACTIONS(5417),
    [anon_sym_by] = ACTIONS(5417),
    [anon_sym_as] = ACTIONS(5417),
    [anon_sym_is] = ACTIONS(5417),
    [anon_sym_DASH_GT] = ACTIONS(5417),
    [anon_sym_with] = ACTIONS(5417),
    [aux_sym_preproc_if_token3] = ACTIONS(5417),
    [aux_sym_preproc_else_token1] = ACTIONS(5417),
    [aux_sym_preproc_elif_token1] = ACTIONS(5417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3556] = {
    [sym_type_parameter_constraint] = STATE(6579),
    [sym_constructor_constraint] = STATE(6678),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6523),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3556),
    [sym_preproc_endregion] = STATE(3556),
    [sym_preproc_line] = STATE(3556),
    [sym_preproc_pragma] = STATE(3556),
    [sym_preproc_nullable] = STATE(3556),
    [sym_preproc_error] = STATE(3556),
    [sym_preproc_warning] = STATE(3556),
    [sym_preproc_define] = STATE(3556),
    [sym_preproc_undef] = STATE(3556),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_class] = ACTIONS(5548),
    [anon_sym_ref] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5552),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_new] = ACTIONS(5554),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(5556),
    [anon_sym_unmanaged] = ACTIONS(5556),
    [anon_sym_scoped] = ACTIONS(5558),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3557] = {
    [sym_preproc_region] = STATE(3557),
    [sym_preproc_endregion] = STATE(3557),
    [sym_preproc_line] = STATE(3557),
    [sym_preproc_pragma] = STATE(3557),
    [sym_preproc_nullable] = STATE(3557),
    [sym_preproc_error] = STATE(3557),
    [sym_preproc_warning] = STATE(3557),
    [sym_preproc_define] = STATE(3557),
    [sym_preproc_undef] = STATE(3557),
    [anon_sym_EQ] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5617),
    [anon_sym_DASH_EQ] = ACTIONS(5617),
    [anon_sym_STAR_EQ] = ACTIONS(5617),
    [anon_sym_SLASH_EQ] = ACTIONS(5617),
    [anon_sym_PERCENT_EQ] = ACTIONS(5617),
    [anon_sym_AMP_EQ] = ACTIONS(5617),
    [anon_sym_CARET_EQ] = ACTIONS(5617),
    [anon_sym_PIPE_EQ] = ACTIONS(5617),
    [anon_sym_LT_LT_EQ] = ACTIONS(5617),
    [anon_sym_GT_GT_EQ] = ACTIONS(5617),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5617),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3558] = {
    [sym_modifier] = STATE(3734),
    [sym_preproc_region] = STATE(3558),
    [sym_preproc_endregion] = STATE(3558),
    [sym_preproc_line] = STATE(3558),
    [sym_preproc_pragma] = STATE(3558),
    [sym_preproc_nullable] = STATE(3558),
    [sym_preproc_error] = STATE(3558),
    [sym_preproc_warning] = STATE(3558),
    [sym_preproc_define] = STATE(3558),
    [sym_preproc_undef] = STATE(3558),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3558),
    [sym__identifier_token] = ACTIONS(5264),
    [anon_sym_extern] = ACTIONS(5619),
    [anon_sym_alias] = ACTIONS(5264),
    [anon_sym_global] = ACTIONS(5264),
    [anon_sym_unsafe] = ACTIONS(5619),
    [anon_sym_static] = ACTIONS(5619),
    [anon_sym_abstract] = ACTIONS(5619),
    [anon_sym_async] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5619),
    [anon_sym_file] = ACTIONS(5619),
    [anon_sym_fixed] = ACTIONS(5619),
    [anon_sym_internal] = ACTIONS(5619),
    [anon_sym_new] = ACTIONS(5619),
    [anon_sym_override] = ACTIONS(5619),
    [anon_sym_partial] = ACTIONS(5619),
    [anon_sym_private] = ACTIONS(5619),
    [anon_sym_protected] = ACTIONS(5619),
    [anon_sym_public] = ACTIONS(5619),
    [anon_sym_readonly] = ACTIONS(5619),
    [anon_sym_required] = ACTIONS(5619),
    [anon_sym_sealed] = ACTIONS(5619),
    [anon_sym_virtual] = ACTIONS(5619),
    [anon_sym_volatile] = ACTIONS(5619),
    [anon_sym_where] = ACTIONS(5264),
    [anon_sym_notnull] = ACTIONS(5264),
    [anon_sym_unmanaged] = ACTIONS(5264),
    [anon_sym_get] = ACTIONS(5264),
    [anon_sym_set] = ACTIONS(5264),
    [anon_sym_add] = ACTIONS(5264),
    [anon_sym_remove] = ACTIONS(5264),
    [anon_sym_init] = ACTIONS(5264),
    [anon_sym_scoped] = ACTIONS(5264),
    [anon_sym_var] = ACTIONS(5264),
    [anon_sym_yield] = ACTIONS(5264),
    [anon_sym_when] = ACTIONS(5264),
    [anon_sym_from] = ACTIONS(5264),
    [anon_sym_into] = ACTIONS(5264),
    [anon_sym_join] = ACTIONS(5264),
    [anon_sym_on] = ACTIONS(5264),
    [anon_sym_equals] = ACTIONS(5264),
    [anon_sym_let] = ACTIONS(5264),
    [anon_sym_orderby] = ACTIONS(5264),
    [anon_sym_ascending] = ACTIONS(5264),
    [anon_sym_descending] = ACTIONS(5264),
    [anon_sym_group] = ACTIONS(5264),
    [anon_sym_by] = ACTIONS(5264),
    [anon_sym_select] = ACTIONS(5264),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3559] = {
    [sym_preproc_region] = STATE(3559),
    [sym_preproc_endregion] = STATE(3559),
    [sym_preproc_line] = STATE(3559),
    [sym_preproc_pragma] = STATE(3559),
    [sym_preproc_nullable] = STATE(3559),
    [sym_preproc_error] = STATE(3559),
    [sym_preproc_warning] = STATE(3559),
    [sym_preproc_define] = STATE(3559),
    [sym_preproc_undef] = STATE(3559),
    [anon_sym_EQ] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5624),
    [anon_sym_DASH_EQ] = ACTIONS(5624),
    [anon_sym_STAR_EQ] = ACTIONS(5624),
    [anon_sym_SLASH_EQ] = ACTIONS(5624),
    [anon_sym_PERCENT_EQ] = ACTIONS(5624),
    [anon_sym_AMP_EQ] = ACTIONS(5624),
    [anon_sym_CARET_EQ] = ACTIONS(5624),
    [anon_sym_PIPE_EQ] = ACTIONS(5624),
    [anon_sym_LT_LT_EQ] = ACTIONS(5624),
    [anon_sym_GT_GT_EQ] = ACTIONS(5624),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5624),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3560] = {
    [sym_preproc_region] = STATE(3560),
    [sym_preproc_endregion] = STATE(3560),
    [sym_preproc_line] = STATE(3560),
    [sym_preproc_pragma] = STATE(3560),
    [sym_preproc_nullable] = STATE(3560),
    [sym_preproc_error] = STATE(3560),
    [sym_preproc_warning] = STATE(3560),
    [sym_preproc_define] = STATE(3560),
    [sym_preproc_undef] = STATE(3560),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3561] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3561),
    [sym_preproc_endregion] = STATE(3561),
    [sym_preproc_line] = STATE(3561),
    [sym_preproc_pragma] = STATE(3561),
    [sym_preproc_nullable] = STATE(3561),
    [sym_preproc_error] = STATE(3561),
    [sym_preproc_warning] = STATE(3561),
    [sym_preproc_define] = STATE(3561),
    [sym_preproc_undef] = STATE(3561),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_when] = ACTIONS(3615),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3562] = {
    [sym_explicit_interface_specifier] = STATE(5951),
    [sym__name] = STATE(6589),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7244),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3562),
    [sym_preproc_endregion] = STATE(3562),
    [sym_preproc_line] = STATE(3562),
    [sym_preproc_pragma] = STATE(3562),
    [sym_preproc_nullable] = STATE(3562),
    [sym_preproc_error] = STATE(3562),
    [sym_preproc_warning] = STATE(3562),
    [sym_preproc_define] = STATE(3562),
    [sym_preproc_undef] = STATE(3562),
    [aux_sym_conversion_operator_declaration_repeat1] = STATE(4904),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5630),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_operator] = ACTIONS(5632),
    [anon_sym_checked] = ACTIONS(5632),
    [anon_sym_scoped] = ACTIONS(5634),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3563] = {
    [sym_argument_list] = STATE(3488),
    [sym_bracketed_argument_list] = STATE(2500),
    [sym_preproc_region] = STATE(3563),
    [sym_preproc_endregion] = STATE(3563),
    [sym_preproc_line] = STATE(3563),
    [sym_preproc_pragma] = STATE(3563),
    [sym_preproc_nullable] = STATE(3563),
    [sym_preproc_error] = STATE(3563),
    [sym_preproc_warning] = STATE(3563),
    [sym_preproc_define] = STATE(3563),
    [sym_preproc_undef] = STATE(3563),
    [anon_sym_SEMI] = ACTIONS(4875),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_RBRACK] = ACTIONS(4875),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [anon_sym_LT] = ACTIONS(4879),
    [anon_sym_GT] = ACTIONS(4879),
    [anon_sym_in] = ACTIONS(4875),
    [anon_sym_QMARK] = ACTIONS(4879),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4875),
    [anon_sym_SLASH] = ACTIONS(4879),
    [anon_sym_PERCENT] = ACTIONS(4875),
    [anon_sym_CARET] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4879),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_LT_LT] = ACTIONS(4875),
    [anon_sym_GT_GT] = ACTIONS(4879),
    [anon_sym_GT_GT_GT] = ACTIONS(4875),
    [anon_sym_EQ_EQ] = ACTIONS(4875),
    [anon_sym_BANG_EQ] = ACTIONS(4875),
    [anon_sym_GT_EQ] = ACTIONS(4875),
    [anon_sym_LT_EQ] = ACTIONS(4875),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4875),
    [anon_sym_switch] = ACTIONS(4875),
    [anon_sym_DOT_DOT] = ACTIONS(4875),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_PIPE_PIPE] = ACTIONS(4875),
    [anon_sym_QMARK_QMARK] = ACTIONS(4875),
    [anon_sym_on] = ACTIONS(4875),
    [anon_sym_equals] = ACTIONS(4875),
    [anon_sym_by] = ACTIONS(4875),
    [anon_sym_as] = ACTIONS(4875),
    [anon_sym_is] = ACTIONS(4875),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4875),
    [aux_sym_preproc_if_token3] = ACTIONS(4875),
    [aux_sym_preproc_else_token1] = ACTIONS(4875),
    [aux_sym_preproc_elif_token1] = ACTIONS(4875),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3564] = {
    [sym_argument_list] = STATE(3488),
    [sym_bracketed_argument_list] = STATE(2500),
    [sym_preproc_region] = STATE(3564),
    [sym_preproc_endregion] = STATE(3564),
    [sym_preproc_line] = STATE(3564),
    [sym_preproc_pragma] = STATE(3564),
    [sym_preproc_nullable] = STATE(3564),
    [sym_preproc_error] = STATE(3564),
    [sym_preproc_warning] = STATE(3564),
    [sym_preproc_define] = STATE(3564),
    [sym_preproc_undef] = STATE(3564),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_in] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4910),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4908),
    [anon_sym_switch] = ACTIONS(4908),
    [anon_sym_DOT_DOT] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_QMARK_QMARK] = ACTIONS(4908),
    [anon_sym_on] = ACTIONS(4908),
    [anon_sym_equals] = ACTIONS(4908),
    [anon_sym_by] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4908),
    [anon_sym_is] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4908),
    [aux_sym_preproc_if_token3] = ACTIONS(4908),
    [aux_sym_preproc_else_token1] = ACTIONS(4908),
    [aux_sym_preproc_elif_token1] = ACTIONS(4908),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3565] = {
    [sym_preproc_region] = STATE(3565),
    [sym_preproc_endregion] = STATE(3565),
    [sym_preproc_line] = STATE(3565),
    [sym_preproc_pragma] = STATE(3565),
    [sym_preproc_nullable] = STATE(3565),
    [sym_preproc_error] = STATE(3565),
    [sym_preproc_warning] = STATE(3565),
    [sym_preproc_define] = STATE(3565),
    [sym_preproc_undef] = STATE(3565),
    [sym__identifier_token] = ACTIONS(4807),
    [anon_sym_extern] = ACTIONS(4807),
    [anon_sym_alias] = ACTIONS(4807),
    [anon_sym_global] = ACTIONS(4807),
    [anon_sym_unsafe] = ACTIONS(4807),
    [anon_sym_static] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4809),
    [anon_sym_abstract] = ACTIONS(4807),
    [anon_sym_async] = ACTIONS(4807),
    [anon_sym_const] = ACTIONS(4807),
    [anon_sym_file] = ACTIONS(4807),
    [anon_sym_fixed] = ACTIONS(4807),
    [anon_sym_internal] = ACTIONS(4807),
    [anon_sym_new] = ACTIONS(4807),
    [anon_sym_override] = ACTIONS(4807),
    [anon_sym_partial] = ACTIONS(4807),
    [anon_sym_private] = ACTIONS(4807),
    [anon_sym_protected] = ACTIONS(4807),
    [anon_sym_public] = ACTIONS(4807),
    [anon_sym_readonly] = ACTIONS(4807),
    [anon_sym_required] = ACTIONS(4807),
    [anon_sym_sealed] = ACTIONS(4807),
    [anon_sym_virtual] = ACTIONS(4807),
    [anon_sym_volatile] = ACTIONS(4807),
    [anon_sym_where] = ACTIONS(4807),
    [anon_sym_notnull] = ACTIONS(4807),
    [anon_sym_unmanaged] = ACTIONS(4807),
    [anon_sym_get] = ACTIONS(4807),
    [anon_sym_set] = ACTIONS(4807),
    [anon_sym_add] = ACTIONS(4807),
    [anon_sym_remove] = ACTIONS(4807),
    [anon_sym_init] = ACTIONS(4807),
    [anon_sym_scoped] = ACTIONS(4807),
    [anon_sym_var] = ACTIONS(4807),
    [anon_sym_yield] = ACTIONS(4807),
    [anon_sym_when] = ACTIONS(4807),
    [anon_sym_from] = ACTIONS(4807),
    [anon_sym_into] = ACTIONS(4807),
    [anon_sym_join] = ACTIONS(4807),
    [anon_sym_on] = ACTIONS(4807),
    [anon_sym_equals] = ACTIONS(4807),
    [anon_sym_let] = ACTIONS(4807),
    [anon_sym_orderby] = ACTIONS(4807),
    [anon_sym_ascending] = ACTIONS(4807),
    [anon_sym_descending] = ACTIONS(4807),
    [anon_sym_group] = ACTIONS(4807),
    [anon_sym_by] = ACTIONS(4807),
    [anon_sym_select] = ACTIONS(4807),
    [aux_sym_preproc_if_token1] = ACTIONS(4809),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3566] = {
    [sym_preproc_region] = STATE(3566),
    [sym_preproc_endregion] = STATE(3566),
    [sym_preproc_line] = STATE(3566),
    [sym_preproc_pragma] = STATE(3566),
    [sym_preproc_nullable] = STATE(3566),
    [sym_preproc_error] = STATE(3566),
    [sym_preproc_warning] = STATE(3566),
    [sym_preproc_define] = STATE(3566),
    [sym_preproc_undef] = STATE(3566),
    [sym__identifier_token] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym_alias] = ACTIONS(5055),
    [anon_sym_global] = ACTIONS(5055),
    [anon_sym_unsafe] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5057),
    [anon_sym_abstract] = ACTIONS(5055),
    [anon_sym_async] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_file] = ACTIONS(5055),
    [anon_sym_fixed] = ACTIONS(5055),
    [anon_sym_internal] = ACTIONS(5055),
    [anon_sym_new] = ACTIONS(5055),
    [anon_sym_override] = ACTIONS(5055),
    [anon_sym_partial] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_readonly] = ACTIONS(5055),
    [anon_sym_required] = ACTIONS(5055),
    [anon_sym_sealed] = ACTIONS(5055),
    [anon_sym_virtual] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_where] = ACTIONS(5055),
    [anon_sym_notnull] = ACTIONS(5055),
    [anon_sym_unmanaged] = ACTIONS(5055),
    [anon_sym_get] = ACTIONS(5055),
    [anon_sym_set] = ACTIONS(5055),
    [anon_sym_add] = ACTIONS(5055),
    [anon_sym_remove] = ACTIONS(5055),
    [anon_sym_init] = ACTIONS(5055),
    [anon_sym_scoped] = ACTIONS(5055),
    [anon_sym_var] = ACTIONS(5055),
    [anon_sym_yield] = ACTIONS(5055),
    [anon_sym_when] = ACTIONS(5055),
    [anon_sym_from] = ACTIONS(5055),
    [anon_sym_into] = ACTIONS(5055),
    [anon_sym_join] = ACTIONS(5055),
    [anon_sym_on] = ACTIONS(5055),
    [anon_sym_equals] = ACTIONS(5055),
    [anon_sym_let] = ACTIONS(5055),
    [anon_sym_orderby] = ACTIONS(5055),
    [anon_sym_ascending] = ACTIONS(5055),
    [anon_sym_descending] = ACTIONS(5055),
    [anon_sym_group] = ACTIONS(5055),
    [anon_sym_by] = ACTIONS(5055),
    [anon_sym_select] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3567] = {
    [sym_parameter_list] = STATE(7307),
    [sym_block] = STATE(3124),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6184),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3567),
    [sym_preproc_endregion] = STATE(3567),
    [sym_preproc_line] = STATE(3567),
    [sym_preproc_pragma] = STATE(3567),
    [sym_preproc_nullable] = STATE(3567),
    [sym_preproc_error] = STATE(3567),
    [sym_preproc_warning] = STATE(3567),
    [sym_preproc_define] = STATE(3567),
    [sym_preproc_undef] = STATE(3567),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(5638),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3568] = {
    [sym_preproc_region] = STATE(3568),
    [sym_preproc_endregion] = STATE(3568),
    [sym_preproc_line] = STATE(3568),
    [sym_preproc_pragma] = STATE(3568),
    [sym_preproc_nullable] = STATE(3568),
    [sym_preproc_error] = STATE(3568),
    [sym_preproc_warning] = STATE(3568),
    [sym_preproc_define] = STATE(3568),
    [sym_preproc_undef] = STATE(3568),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5644),
    [anon_sym_DASH_EQ] = ACTIONS(5644),
    [anon_sym_STAR_EQ] = ACTIONS(5644),
    [anon_sym_SLASH_EQ] = ACTIONS(5644),
    [anon_sym_PERCENT_EQ] = ACTIONS(5644),
    [anon_sym_AMP_EQ] = ACTIONS(5644),
    [anon_sym_CARET_EQ] = ACTIONS(5644),
    [anon_sym_PIPE_EQ] = ACTIONS(5644),
    [anon_sym_LT_LT_EQ] = ACTIONS(5644),
    [anon_sym_GT_GT_EQ] = ACTIONS(5644),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5644),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_if_token3] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3569] = {
    [sym_preproc_region] = STATE(3569),
    [sym_preproc_endregion] = STATE(3569),
    [sym_preproc_line] = STATE(3569),
    [sym_preproc_pragma] = STATE(3569),
    [sym_preproc_nullable] = STATE(3569),
    [sym_preproc_error] = STATE(3569),
    [sym_preproc_warning] = STATE(3569),
    [sym_preproc_define] = STATE(3569),
    [sym_preproc_undef] = STATE(3569),
    [sym__identifier_token] = ACTIONS(5101),
    [anon_sym_extern] = ACTIONS(5101),
    [anon_sym_alias] = ACTIONS(5101),
    [anon_sym_global] = ACTIONS(5101),
    [anon_sym_unsafe] = ACTIONS(5101),
    [anon_sym_static] = ACTIONS(5101),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_abstract] = ACTIONS(5101),
    [anon_sym_async] = ACTIONS(5101),
    [anon_sym_const] = ACTIONS(5101),
    [anon_sym_file] = ACTIONS(5101),
    [anon_sym_fixed] = ACTIONS(5101),
    [anon_sym_internal] = ACTIONS(5101),
    [anon_sym_new] = ACTIONS(5101),
    [anon_sym_override] = ACTIONS(5101),
    [anon_sym_partial] = ACTIONS(5101),
    [anon_sym_private] = ACTIONS(5101),
    [anon_sym_protected] = ACTIONS(5101),
    [anon_sym_public] = ACTIONS(5101),
    [anon_sym_readonly] = ACTIONS(5101),
    [anon_sym_required] = ACTIONS(5101),
    [anon_sym_sealed] = ACTIONS(5101),
    [anon_sym_virtual] = ACTIONS(5101),
    [anon_sym_volatile] = ACTIONS(5101),
    [anon_sym_where] = ACTIONS(5101),
    [anon_sym_notnull] = ACTIONS(5101),
    [anon_sym_unmanaged] = ACTIONS(5101),
    [anon_sym_get] = ACTIONS(5101),
    [anon_sym_set] = ACTIONS(5101),
    [anon_sym_add] = ACTIONS(5101),
    [anon_sym_remove] = ACTIONS(5101),
    [anon_sym_init] = ACTIONS(5101),
    [anon_sym_scoped] = ACTIONS(5101),
    [anon_sym_var] = ACTIONS(5101),
    [anon_sym_yield] = ACTIONS(5101),
    [anon_sym_when] = ACTIONS(5101),
    [anon_sym_from] = ACTIONS(5101),
    [anon_sym_into] = ACTIONS(5101),
    [anon_sym_join] = ACTIONS(5101),
    [anon_sym_on] = ACTIONS(5101),
    [anon_sym_equals] = ACTIONS(5101),
    [anon_sym_let] = ACTIONS(5101),
    [anon_sym_orderby] = ACTIONS(5101),
    [anon_sym_ascending] = ACTIONS(5101),
    [anon_sym_descending] = ACTIONS(5101),
    [anon_sym_group] = ACTIONS(5101),
    [anon_sym_by] = ACTIONS(5101),
    [anon_sym_select] = ACTIONS(5101),
    [aux_sym_preproc_if_token1] = ACTIONS(5103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3570] = {
    [sym_preproc_region] = STATE(3570),
    [sym_preproc_endregion] = STATE(3570),
    [sym_preproc_line] = STATE(3570),
    [sym_preproc_pragma] = STATE(3570),
    [sym_preproc_nullable] = STATE(3570),
    [sym_preproc_error] = STATE(3570),
    [sym_preproc_warning] = STATE(3570),
    [sym_preproc_define] = STATE(3570),
    [sym_preproc_undef] = STATE(3570),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_get] = ACTIONS(4743),
    [anon_sym_set] = ACTIONS(4743),
    [anon_sym_add] = ACTIONS(4743),
    [anon_sym_remove] = ACTIONS(4743),
    [anon_sym_init] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3571] = {
    [sym_preproc_region] = STATE(3571),
    [sym_preproc_endregion] = STATE(3571),
    [sym_preproc_line] = STATE(3571),
    [sym_preproc_pragma] = STATE(3571),
    [sym_preproc_nullable] = STATE(3571),
    [sym_preproc_error] = STATE(3571),
    [sym_preproc_warning] = STATE(3571),
    [sym_preproc_define] = STATE(3571),
    [sym_preproc_undef] = STATE(3571),
    [sym__identifier_token] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym_alias] = ACTIONS(5059),
    [anon_sym_global] = ACTIONS(5059),
    [anon_sym_unsafe] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5061),
    [anon_sym_abstract] = ACTIONS(5059),
    [anon_sym_async] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_file] = ACTIONS(5059),
    [anon_sym_fixed] = ACTIONS(5059),
    [anon_sym_internal] = ACTIONS(5059),
    [anon_sym_new] = ACTIONS(5059),
    [anon_sym_override] = ACTIONS(5059),
    [anon_sym_partial] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_readonly] = ACTIONS(5059),
    [anon_sym_required] = ACTIONS(5059),
    [anon_sym_sealed] = ACTIONS(5059),
    [anon_sym_virtual] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_where] = ACTIONS(5059),
    [anon_sym_notnull] = ACTIONS(5059),
    [anon_sym_unmanaged] = ACTIONS(5059),
    [anon_sym_get] = ACTIONS(5059),
    [anon_sym_set] = ACTIONS(5059),
    [anon_sym_add] = ACTIONS(5059),
    [anon_sym_remove] = ACTIONS(5059),
    [anon_sym_init] = ACTIONS(5059),
    [anon_sym_scoped] = ACTIONS(5059),
    [anon_sym_var] = ACTIONS(5059),
    [anon_sym_yield] = ACTIONS(5059),
    [anon_sym_when] = ACTIONS(5059),
    [anon_sym_from] = ACTIONS(5059),
    [anon_sym_into] = ACTIONS(5059),
    [anon_sym_join] = ACTIONS(5059),
    [anon_sym_on] = ACTIONS(5059),
    [anon_sym_equals] = ACTIONS(5059),
    [anon_sym_let] = ACTIONS(5059),
    [anon_sym_orderby] = ACTIONS(5059),
    [anon_sym_ascending] = ACTIONS(5059),
    [anon_sym_descending] = ACTIONS(5059),
    [anon_sym_group] = ACTIONS(5059),
    [anon_sym_by] = ACTIONS(5059),
    [anon_sym_select] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3572] = {
    [sym_preproc_region] = STATE(3572),
    [sym_preproc_endregion] = STATE(3572),
    [sym_preproc_line] = STATE(3572),
    [sym_preproc_pragma] = STATE(3572),
    [sym_preproc_nullable] = STATE(3572),
    [sym_preproc_error] = STATE(3572),
    [sym_preproc_warning] = STATE(3572),
    [sym_preproc_define] = STATE(3572),
    [sym_preproc_undef] = STATE(3572),
    [anon_sym_EQ] = ACTIONS(5646),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5648),
    [anon_sym_DASH_EQ] = ACTIONS(5648),
    [anon_sym_STAR_EQ] = ACTIONS(5648),
    [anon_sym_SLASH_EQ] = ACTIONS(5648),
    [anon_sym_PERCENT_EQ] = ACTIONS(5648),
    [anon_sym_AMP_EQ] = ACTIONS(5648),
    [anon_sym_CARET_EQ] = ACTIONS(5648),
    [anon_sym_PIPE_EQ] = ACTIONS(5648),
    [anon_sym_LT_LT_EQ] = ACTIONS(5648),
    [anon_sym_GT_GT_EQ] = ACTIONS(5648),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5648),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3573] = {
    [sym_preproc_region] = STATE(3573),
    [sym_preproc_endregion] = STATE(3573),
    [sym_preproc_line] = STATE(3573),
    [sym_preproc_pragma] = STATE(3573),
    [sym_preproc_nullable] = STATE(3573),
    [sym_preproc_error] = STATE(3573),
    [sym_preproc_warning] = STATE(3573),
    [sym_preproc_define] = STATE(3573),
    [sym_preproc_undef] = STATE(3573),
    [anon_sym_EQ] = ACTIONS(5588),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5650),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5590),
    [anon_sym_DASH_EQ] = ACTIONS(5590),
    [anon_sym_STAR_EQ] = ACTIONS(5590),
    [anon_sym_SLASH_EQ] = ACTIONS(5590),
    [anon_sym_PERCENT_EQ] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5590),
    [anon_sym_CARET_EQ] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5590),
    [anon_sym_LT_LT_EQ] = ACTIONS(5590),
    [anon_sym_GT_GT_EQ] = ACTIONS(5590),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5590),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3574] = {
    [sym_preproc_region] = STATE(3574),
    [sym_preproc_endregion] = STATE(3574),
    [sym_preproc_line] = STATE(3574),
    [sym_preproc_pragma] = STATE(3574),
    [sym_preproc_nullable] = STATE(3574),
    [sym_preproc_error] = STATE(3574),
    [sym_preproc_warning] = STATE(3574),
    [sym_preproc_define] = STATE(3574),
    [sym_preproc_undef] = STATE(3574),
    [sym__identifier_token] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_alias] = ACTIONS(4823),
    [anon_sym_global] = ACTIONS(4823),
    [anon_sym_unsafe] = ACTIONS(4823),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4825),
    [anon_sym_abstract] = ACTIONS(4823),
    [anon_sym_async] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_file] = ACTIONS(4823),
    [anon_sym_fixed] = ACTIONS(4823),
    [anon_sym_internal] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_override] = ACTIONS(4823),
    [anon_sym_partial] = ACTIONS(4823),
    [anon_sym_private] = ACTIONS(4823),
    [anon_sym_protected] = ACTIONS(4823),
    [anon_sym_public] = ACTIONS(4823),
    [anon_sym_readonly] = ACTIONS(4823),
    [anon_sym_required] = ACTIONS(4823),
    [anon_sym_sealed] = ACTIONS(4823),
    [anon_sym_virtual] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym_where] = ACTIONS(4823),
    [anon_sym_notnull] = ACTIONS(4823),
    [anon_sym_unmanaged] = ACTIONS(4823),
    [anon_sym_get] = ACTIONS(4823),
    [anon_sym_set] = ACTIONS(4823),
    [anon_sym_add] = ACTIONS(4823),
    [anon_sym_remove] = ACTIONS(4823),
    [anon_sym_init] = ACTIONS(4823),
    [anon_sym_scoped] = ACTIONS(4823),
    [anon_sym_var] = ACTIONS(4823),
    [anon_sym_yield] = ACTIONS(4823),
    [anon_sym_when] = ACTIONS(4823),
    [anon_sym_from] = ACTIONS(4823),
    [anon_sym_into] = ACTIONS(4823),
    [anon_sym_join] = ACTIONS(4823),
    [anon_sym_on] = ACTIONS(4823),
    [anon_sym_equals] = ACTIONS(4823),
    [anon_sym_let] = ACTIONS(4823),
    [anon_sym_orderby] = ACTIONS(4823),
    [anon_sym_ascending] = ACTIONS(4823),
    [anon_sym_descending] = ACTIONS(4823),
    [anon_sym_group] = ACTIONS(4823),
    [anon_sym_by] = ACTIONS(4823),
    [anon_sym_select] = ACTIONS(4823),
    [aux_sym_preproc_if_token1] = ACTIONS(4825),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3575] = {
    [sym_preproc_region] = STATE(3575),
    [sym_preproc_endregion] = STATE(3575),
    [sym_preproc_line] = STATE(3575),
    [sym_preproc_pragma] = STATE(3575),
    [sym_preproc_nullable] = STATE(3575),
    [sym_preproc_error] = STATE(3575),
    [sym_preproc_warning] = STATE(3575),
    [sym_preproc_define] = STATE(3575),
    [sym_preproc_undef] = STATE(3575),
    [anon_sym_EQ] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5654),
    [anon_sym_DASH_EQ] = ACTIONS(5654),
    [anon_sym_STAR_EQ] = ACTIONS(5654),
    [anon_sym_SLASH_EQ] = ACTIONS(5654),
    [anon_sym_PERCENT_EQ] = ACTIONS(5654),
    [anon_sym_AMP_EQ] = ACTIONS(5654),
    [anon_sym_CARET_EQ] = ACTIONS(5654),
    [anon_sym_PIPE_EQ] = ACTIONS(5654),
    [anon_sym_LT_LT_EQ] = ACTIONS(5654),
    [anon_sym_GT_GT_EQ] = ACTIONS(5654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5654),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3576] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3576),
    [sym_preproc_endregion] = STATE(3576),
    [sym_preproc_line] = STATE(3576),
    [sym_preproc_pragma] = STATE(3576),
    [sym_preproc_nullable] = STATE(3576),
    [sym_preproc_error] = STATE(3576),
    [sym_preproc_warning] = STATE(3576),
    [sym_preproc_define] = STATE(3576),
    [sym_preproc_undef] = STATE(3576),
    [sym__identifier_token] = ACTIONS(2719),
    [anon_sym_alias] = ACTIONS(2719),
    [anon_sym_global] = ACTIONS(2719),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_ref] = ACTIONS(2719),
    [anon_sym_delegate] = ACTIONS(2719),
    [anon_sym_file] = ACTIONS(2719),
    [anon_sym_readonly] = ACTIONS(2719),
    [anon_sym_in] = ACTIONS(2719),
    [anon_sym_out] = ACTIONS(2719),
    [anon_sym_where] = ACTIONS(2719),
    [anon_sym_notnull] = ACTIONS(2719),
    [anon_sym_unmanaged] = ACTIONS(2719),
    [anon_sym_this] = ACTIONS(2719),
    [anon_sym_scoped] = ACTIONS(2719),
    [anon_sym_var] = ACTIONS(2719),
    [sym_predefined_type] = ACTIONS(2719),
    [anon_sym_yield] = ACTIONS(2719),
    [anon_sym_when] = ACTIONS(2719),
    [anon_sym_from] = ACTIONS(2719),
    [anon_sym_into] = ACTIONS(2719),
    [anon_sym_join] = ACTIONS(2719),
    [anon_sym_on] = ACTIONS(2719),
    [anon_sym_equals] = ACTIONS(2719),
    [anon_sym_let] = ACTIONS(2719),
    [anon_sym_orderby] = ACTIONS(2719),
    [anon_sym_ascending] = ACTIONS(2719),
    [anon_sym_descending] = ACTIONS(2719),
    [anon_sym_group] = ACTIONS(2719),
    [anon_sym_by] = ACTIONS(2719),
    [anon_sym_select] = ACTIONS(2719),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3577] = {
    [sym_preproc_region] = STATE(3577),
    [sym_preproc_endregion] = STATE(3577),
    [sym_preproc_line] = STATE(3577),
    [sym_preproc_pragma] = STATE(3577),
    [sym_preproc_nullable] = STATE(3577),
    [sym_preproc_error] = STATE(3577),
    [sym_preproc_warning] = STATE(3577),
    [sym_preproc_define] = STATE(3577),
    [sym_preproc_undef] = STATE(3577),
    [sym__identifier_token] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym_alias] = ACTIONS(5071),
    [anon_sym_global] = ACTIONS(5071),
    [anon_sym_unsafe] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5073),
    [anon_sym_abstract] = ACTIONS(5071),
    [anon_sym_async] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_file] = ACTIONS(5071),
    [anon_sym_fixed] = ACTIONS(5071),
    [anon_sym_internal] = ACTIONS(5071),
    [anon_sym_new] = ACTIONS(5071),
    [anon_sym_override] = ACTIONS(5071),
    [anon_sym_partial] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_readonly] = ACTIONS(5071),
    [anon_sym_required] = ACTIONS(5071),
    [anon_sym_sealed] = ACTIONS(5071),
    [anon_sym_virtual] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_where] = ACTIONS(5071),
    [anon_sym_notnull] = ACTIONS(5071),
    [anon_sym_unmanaged] = ACTIONS(5071),
    [anon_sym_get] = ACTIONS(5071),
    [anon_sym_set] = ACTIONS(5071),
    [anon_sym_add] = ACTIONS(5071),
    [anon_sym_remove] = ACTIONS(5071),
    [anon_sym_init] = ACTIONS(5071),
    [anon_sym_scoped] = ACTIONS(5071),
    [anon_sym_var] = ACTIONS(5071),
    [anon_sym_yield] = ACTIONS(5071),
    [anon_sym_when] = ACTIONS(5071),
    [anon_sym_from] = ACTIONS(5071),
    [anon_sym_into] = ACTIONS(5071),
    [anon_sym_join] = ACTIONS(5071),
    [anon_sym_on] = ACTIONS(5071),
    [anon_sym_equals] = ACTIONS(5071),
    [anon_sym_let] = ACTIONS(5071),
    [anon_sym_orderby] = ACTIONS(5071),
    [anon_sym_ascending] = ACTIONS(5071),
    [anon_sym_descending] = ACTIONS(5071),
    [anon_sym_group] = ACTIONS(5071),
    [anon_sym_by] = ACTIONS(5071),
    [anon_sym_select] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3578] = {
    [sym_preproc_region] = STATE(3578),
    [sym_preproc_endregion] = STATE(3578),
    [sym_preproc_line] = STATE(3578),
    [sym_preproc_pragma] = STATE(3578),
    [sym_preproc_nullable] = STATE(3578),
    [sym_preproc_error] = STATE(3578),
    [sym_preproc_warning] = STATE(3578),
    [sym_preproc_define] = STATE(3578),
    [sym_preproc_undef] = STATE(3578),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_STAR_EQ] = ACTIONS(5658),
    [anon_sym_SLASH_EQ] = ACTIONS(5658),
    [anon_sym_PERCENT_EQ] = ACTIONS(5658),
    [anon_sym_AMP_EQ] = ACTIONS(5658),
    [anon_sym_CARET_EQ] = ACTIONS(5658),
    [anon_sym_PIPE_EQ] = ACTIONS(5658),
    [anon_sym_LT_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_GT_EQ] = ACTIONS(5658),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5658),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3579] = {
    [sym_argument_list] = STATE(3488),
    [sym_bracketed_argument_list] = STATE(2500),
    [sym_preproc_region] = STATE(3579),
    [sym_preproc_endregion] = STATE(3579),
    [sym_preproc_line] = STATE(3579),
    [sym_preproc_pragma] = STATE(3579),
    [sym_preproc_nullable] = STATE(3579),
    [sym_preproc_error] = STATE(3579),
    [sym_preproc_warning] = STATE(3579),
    [sym_preproc_define] = STATE(3579),
    [sym_preproc_undef] = STATE(3579),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(4885),
    [anon_sym_COMMA] = ACTIONS(4885),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(5316),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_in] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(4887),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(4887),
    [anon_sym_DASH] = ACTIONS(4887),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4887),
    [anon_sym_PERCENT] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_AMP] = ACTIONS(4887),
    [anon_sym_LT_LT] = ACTIONS(4885),
    [anon_sym_GT_GT] = ACTIONS(4887),
    [anon_sym_GT_GT_GT] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [anon_sym_GT_EQ] = ACTIONS(4885),
    [anon_sym_LT_EQ] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4885),
    [anon_sym_switch] = ACTIONS(4885),
    [anon_sym_DOT_DOT] = ACTIONS(4885),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_QMARK_QMARK] = ACTIONS(4885),
    [anon_sym_on] = ACTIONS(4885),
    [anon_sym_equals] = ACTIONS(4885),
    [anon_sym_by] = ACTIONS(4885),
    [anon_sym_as] = ACTIONS(4885),
    [anon_sym_is] = ACTIONS(4885),
    [anon_sym_DASH_GT] = ACTIONS(4160),
    [anon_sym_with] = ACTIONS(4885),
    [aux_sym_preproc_if_token3] = ACTIONS(4885),
    [aux_sym_preproc_else_token1] = ACTIONS(4885),
    [aux_sym_preproc_elif_token1] = ACTIONS(4885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3580] = {
    [sym_preproc_region] = STATE(3580),
    [sym_preproc_endregion] = STATE(3580),
    [sym_preproc_line] = STATE(3580),
    [sym_preproc_pragma] = STATE(3580),
    [sym_preproc_nullable] = STATE(3580),
    [sym_preproc_error] = STATE(3580),
    [sym_preproc_warning] = STATE(3580),
    [sym_preproc_define] = STATE(3580),
    [sym_preproc_undef] = STATE(3580),
    [sym__identifier_token] = ACTIONS(4833),
    [anon_sym_extern] = ACTIONS(4833),
    [anon_sym_alias] = ACTIONS(4833),
    [anon_sym_global] = ACTIONS(4833),
    [anon_sym_unsafe] = ACTIONS(4833),
    [anon_sym_static] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4835),
    [anon_sym_abstract] = ACTIONS(4833),
    [anon_sym_async] = ACTIONS(4833),
    [anon_sym_const] = ACTIONS(4833),
    [anon_sym_file] = ACTIONS(4833),
    [anon_sym_fixed] = ACTIONS(4833),
    [anon_sym_internal] = ACTIONS(4833),
    [anon_sym_new] = ACTIONS(4833),
    [anon_sym_override] = ACTIONS(4833),
    [anon_sym_partial] = ACTIONS(4833),
    [anon_sym_private] = ACTIONS(4833),
    [anon_sym_protected] = ACTIONS(4833),
    [anon_sym_public] = ACTIONS(4833),
    [anon_sym_readonly] = ACTIONS(4833),
    [anon_sym_required] = ACTIONS(4833),
    [anon_sym_sealed] = ACTIONS(4833),
    [anon_sym_virtual] = ACTIONS(4833),
    [anon_sym_volatile] = ACTIONS(4833),
    [anon_sym_where] = ACTIONS(4833),
    [anon_sym_notnull] = ACTIONS(4833),
    [anon_sym_unmanaged] = ACTIONS(4833),
    [anon_sym_get] = ACTIONS(4833),
    [anon_sym_set] = ACTIONS(4833),
    [anon_sym_add] = ACTIONS(4833),
    [anon_sym_remove] = ACTIONS(4833),
    [anon_sym_init] = ACTIONS(4833),
    [anon_sym_scoped] = ACTIONS(4833),
    [anon_sym_var] = ACTIONS(4833),
    [anon_sym_yield] = ACTIONS(4833),
    [anon_sym_when] = ACTIONS(4833),
    [anon_sym_from] = ACTIONS(4833),
    [anon_sym_into] = ACTIONS(4833),
    [anon_sym_join] = ACTIONS(4833),
    [anon_sym_on] = ACTIONS(4833),
    [anon_sym_equals] = ACTIONS(4833),
    [anon_sym_let] = ACTIONS(4833),
    [anon_sym_orderby] = ACTIONS(4833),
    [anon_sym_ascending] = ACTIONS(4833),
    [anon_sym_descending] = ACTIONS(4833),
    [anon_sym_group] = ACTIONS(4833),
    [anon_sym_by] = ACTIONS(4833),
    [anon_sym_select] = ACTIONS(4833),
    [aux_sym_preproc_if_token1] = ACTIONS(4835),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3581] = {
    [sym_preproc_region] = STATE(3581),
    [sym_preproc_endregion] = STATE(3581),
    [sym_preproc_line] = STATE(3581),
    [sym_preproc_pragma] = STATE(3581),
    [sym_preproc_nullable] = STATE(3581),
    [sym_preproc_error] = STATE(3581),
    [sym_preproc_warning] = STATE(3581),
    [sym_preproc_define] = STATE(3581),
    [sym_preproc_undef] = STATE(3581),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5662),
    [anon_sym_DASH_EQ] = ACTIONS(5662),
    [anon_sym_STAR_EQ] = ACTIONS(5662),
    [anon_sym_SLASH_EQ] = ACTIONS(5662),
    [anon_sym_PERCENT_EQ] = ACTIONS(5662),
    [anon_sym_AMP_EQ] = ACTIONS(5662),
    [anon_sym_CARET_EQ] = ACTIONS(5662),
    [anon_sym_PIPE_EQ] = ACTIONS(5662),
    [anon_sym_LT_LT_EQ] = ACTIONS(5662),
    [anon_sym_GT_GT_EQ] = ACTIONS(5662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5662),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
    [sym_interpolation_close_brace] = ACTIONS(4898),
  },
  [3582] = {
    [sym_preproc_region] = STATE(3582),
    [sym_preproc_endregion] = STATE(3582),
    [sym_preproc_line] = STATE(3582),
    [sym_preproc_pragma] = STATE(3582),
    [sym_preproc_nullable] = STATE(3582),
    [sym_preproc_error] = STATE(3582),
    [sym_preproc_warning] = STATE(3582),
    [sym_preproc_define] = STATE(3582),
    [sym_preproc_undef] = STATE(3582),
    [anon_sym_EQ] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3583] = {
    [sym_argument_list] = STATE(3673),
    [sym_initializer_expression] = STATE(3782),
    [sym_preproc_region] = STATE(3583),
    [sym_preproc_endregion] = STATE(3583),
    [sym_preproc_line] = STATE(3583),
    [sym_preproc_pragma] = STATE(3583),
    [sym_preproc_nullable] = STATE(3583),
    [sym_preproc_error] = STATE(3583),
    [sym_preproc_warning] = STATE(3583),
    [sym_preproc_define] = STATE(3583),
    [sym_preproc_undef] = STATE(3583),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(4815),
    [anon_sym_GT] = ACTIONS(4815),
    [anon_sym_where] = ACTIONS(4811),
    [anon_sym_QMARK] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_SLASH] = ACTIONS(4815),
    [anon_sym_PERCENT] = ACTIONS(4811),
    [anon_sym_CARET] = ACTIONS(4811),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_LT_LT] = ACTIONS(4811),
    [anon_sym_GT_GT] = ACTIONS(4815),
    [anon_sym_GT_GT_GT] = ACTIONS(4811),
    [anon_sym_EQ_EQ] = ACTIONS(4811),
    [anon_sym_BANG_EQ] = ACTIONS(4811),
    [anon_sym_GT_EQ] = ACTIONS(4811),
    [anon_sym_LT_EQ] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_switch] = ACTIONS(4811),
    [anon_sym_DOT_DOT] = ACTIONS(4811),
    [anon_sym_and] = ACTIONS(4811),
    [anon_sym_or] = ACTIONS(4815),
    [anon_sym_AMP_AMP] = ACTIONS(4811),
    [anon_sym_PIPE_PIPE] = ACTIONS(4811),
    [anon_sym_QMARK_QMARK] = ACTIONS(4811),
    [anon_sym_from] = ACTIONS(4811),
    [anon_sym_into] = ACTIONS(4811),
    [anon_sym_join] = ACTIONS(4811),
    [anon_sym_let] = ACTIONS(4811),
    [anon_sym_orderby] = ACTIONS(4811),
    [anon_sym_ascending] = ACTIONS(4811),
    [anon_sym_descending] = ACTIONS(4811),
    [anon_sym_group] = ACTIONS(4811),
    [anon_sym_select] = ACTIONS(4811),
    [anon_sym_as] = ACTIONS(4815),
    [anon_sym_is] = ACTIONS(4811),
    [anon_sym_DASH_GT] = ACTIONS(4811),
    [anon_sym_with] = ACTIONS(4811),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3584] = {
    [sym_preproc_region] = STATE(3584),
    [sym_preproc_endregion] = STATE(3584),
    [sym_preproc_line] = STATE(3584),
    [sym_preproc_pragma] = STATE(3584),
    [sym_preproc_nullable] = STATE(3584),
    [sym_preproc_error] = STATE(3584),
    [sym_preproc_warning] = STATE(3584),
    [sym_preproc_define] = STATE(3584),
    [sym_preproc_undef] = STATE(3584),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4949),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_QMARK_QMARK] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_is] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4024),
    [anon_sym_with] = ACTIONS(4024),
    [aux_sym_preproc_if_token3] = ACTIONS(4024),
    [aux_sym_preproc_else_token1] = ACTIONS(4024),
    [aux_sym_preproc_elif_token1] = ACTIONS(4024),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3585] = {
    [sym_explicit_interface_specifier] = STATE(5951),
    [sym__name] = STATE(6589),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7308),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3585),
    [sym_preproc_endregion] = STATE(3585),
    [sym_preproc_line] = STATE(3585),
    [sym_preproc_pragma] = STATE(3585),
    [sym_preproc_nullable] = STATE(3585),
    [sym_preproc_error] = STATE(3585),
    [sym_preproc_warning] = STATE(3585),
    [sym_preproc_define] = STATE(3585),
    [sym_preproc_undef] = STATE(3585),
    [aux_sym_conversion_operator_declaration_repeat1] = STATE(4904),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5630),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_operator] = ACTIONS(5632),
    [anon_sym_checked] = ACTIONS(5632),
    [anon_sym_scoped] = ACTIONS(5634),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3586] = {
    [sym_preproc_region] = STATE(3586),
    [sym_preproc_endregion] = STATE(3586),
    [sym_preproc_line] = STATE(3586),
    [sym_preproc_pragma] = STATE(3586),
    [sym_preproc_nullable] = STATE(3586),
    [sym_preproc_error] = STATE(3586),
    [sym_preproc_warning] = STATE(3586),
    [sym_preproc_define] = STATE(3586),
    [sym_preproc_undef] = STATE(3586),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_CARET] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_BANG_EQ] = ACTIONS(4028),
    [anon_sym_GT_EQ] = ACTIONS(4028),
    [anon_sym_LT_EQ] = ACTIONS(4028),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_DOT_DOT] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_QMARK_QMARK] = ACTIONS(4028),
    [anon_sym_into] = ACTIONS(4028),
    [anon_sym_on] = ACTIONS(4028),
    [anon_sym_equals] = ACTIONS(4028),
    [anon_sym_by] = ACTIONS(4028),
    [anon_sym_as] = ACTIONS(4028),
    [anon_sym_is] = ACTIONS(4028),
    [anon_sym_DASH_GT] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4028),
    [aux_sym_preproc_if_token3] = ACTIONS(4028),
    [aux_sym_preproc_else_token1] = ACTIONS(4028),
    [aux_sym_preproc_elif_token1] = ACTIONS(4028),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3587] = {
    [sym_explicit_interface_specifier] = STATE(5951),
    [sym__name] = STATE(6589),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7283),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3587),
    [sym_preproc_endregion] = STATE(3587),
    [sym_preproc_line] = STATE(3587),
    [sym_preproc_pragma] = STATE(3587),
    [sym_preproc_nullable] = STATE(3587),
    [sym_preproc_error] = STATE(3587),
    [sym_preproc_warning] = STATE(3587),
    [sym_preproc_define] = STATE(3587),
    [sym_preproc_undef] = STATE(3587),
    [aux_sym_conversion_operator_declaration_repeat1] = STATE(4904),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5630),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_operator] = ACTIONS(5632),
    [anon_sym_checked] = ACTIONS(5632),
    [anon_sym_scoped] = ACTIONS(5634),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3588] = {
    [sym_preproc_region] = STATE(3588),
    [sym_preproc_endregion] = STATE(3588),
    [sym_preproc_line] = STATE(3588),
    [sym_preproc_pragma] = STATE(3588),
    [sym_preproc_nullable] = STATE(3588),
    [sym_preproc_error] = STATE(3588),
    [sym_preproc_warning] = STATE(3588),
    [sym_preproc_define] = STATE(3588),
    [sym_preproc_undef] = STATE(3588),
    [sym__identifier_token] = ACTIONS(4817),
    [anon_sym_extern] = ACTIONS(4817),
    [anon_sym_alias] = ACTIONS(4817),
    [anon_sym_global] = ACTIONS(4817),
    [anon_sym_unsafe] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_abstract] = ACTIONS(4817),
    [anon_sym_async] = ACTIONS(4817),
    [anon_sym_const] = ACTIONS(4817),
    [anon_sym_file] = ACTIONS(4817),
    [anon_sym_fixed] = ACTIONS(4817),
    [anon_sym_internal] = ACTIONS(4817),
    [anon_sym_new] = ACTIONS(4817),
    [anon_sym_override] = ACTIONS(4817),
    [anon_sym_partial] = ACTIONS(4817),
    [anon_sym_private] = ACTIONS(4817),
    [anon_sym_protected] = ACTIONS(4817),
    [anon_sym_public] = ACTIONS(4817),
    [anon_sym_readonly] = ACTIONS(4817),
    [anon_sym_required] = ACTIONS(4817),
    [anon_sym_sealed] = ACTIONS(4817),
    [anon_sym_virtual] = ACTIONS(4817),
    [anon_sym_volatile] = ACTIONS(4817),
    [anon_sym_where] = ACTIONS(4817),
    [anon_sym_notnull] = ACTIONS(4817),
    [anon_sym_unmanaged] = ACTIONS(4817),
    [anon_sym_get] = ACTIONS(4817),
    [anon_sym_set] = ACTIONS(4817),
    [anon_sym_add] = ACTIONS(4817),
    [anon_sym_remove] = ACTIONS(4817),
    [anon_sym_init] = ACTIONS(4817),
    [anon_sym_scoped] = ACTIONS(4817),
    [anon_sym_var] = ACTIONS(4817),
    [anon_sym_yield] = ACTIONS(4817),
    [anon_sym_when] = ACTIONS(4817),
    [anon_sym_from] = ACTIONS(4817),
    [anon_sym_into] = ACTIONS(4817),
    [anon_sym_join] = ACTIONS(4817),
    [anon_sym_on] = ACTIONS(4817),
    [anon_sym_equals] = ACTIONS(4817),
    [anon_sym_let] = ACTIONS(4817),
    [anon_sym_orderby] = ACTIONS(4817),
    [anon_sym_ascending] = ACTIONS(4817),
    [anon_sym_descending] = ACTIONS(4817),
    [anon_sym_group] = ACTIONS(4817),
    [anon_sym_by] = ACTIONS(4817),
    [anon_sym_select] = ACTIONS(4817),
    [aux_sym_preproc_if_token1] = ACTIONS(4819),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3589] = {
    [sym_preproc_region] = STATE(3589),
    [sym_preproc_endregion] = STATE(3589),
    [sym_preproc_line] = STATE(3589),
    [sym_preproc_pragma] = STATE(3589),
    [sym_preproc_nullable] = STATE(3589),
    [sym_preproc_error] = STATE(3589),
    [sym_preproc_warning] = STATE(3589),
    [sym_preproc_define] = STATE(3589),
    [sym_preproc_undef] = STATE(3589),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_extern] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_unsafe] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_abstract] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_const] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_fixed] = ACTIONS(3785),
    [anon_sym_internal] = ACTIONS(3785),
    [anon_sym_new] = ACTIONS(3785),
    [anon_sym_override] = ACTIONS(3785),
    [anon_sym_partial] = ACTIONS(3785),
    [anon_sym_private] = ACTIONS(3785),
    [anon_sym_protected] = ACTIONS(3785),
    [anon_sym_public] = ACTIONS(3785),
    [anon_sym_readonly] = ACTIONS(3785),
    [anon_sym_required] = ACTIONS(3785),
    [anon_sym_sealed] = ACTIONS(3785),
    [anon_sym_virtual] = ACTIONS(3785),
    [anon_sym_volatile] = ACTIONS(3785),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_get] = ACTIONS(3785),
    [anon_sym_set] = ACTIONS(3785),
    [anon_sym_add] = ACTIONS(3785),
    [anon_sym_remove] = ACTIONS(3785),
    [anon_sym_init] = ACTIONS(3785),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_var] = ACTIONS(3785),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3590] = {
    [sym_preproc_region] = STATE(3590),
    [sym_preproc_endregion] = STATE(3590),
    [sym_preproc_line] = STATE(3590),
    [sym_preproc_pragma] = STATE(3590),
    [sym_preproc_nullable] = STATE(3590),
    [sym_preproc_error] = STATE(3590),
    [sym_preproc_warning] = STATE(3590),
    [sym_preproc_define] = STATE(3590),
    [sym_preproc_undef] = STATE(3590),
    [anon_sym_EQ] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_STAR_EQ] = ACTIONS(5674),
    [anon_sym_SLASH_EQ] = ACTIONS(5674),
    [anon_sym_PERCENT_EQ] = ACTIONS(5674),
    [anon_sym_AMP_EQ] = ACTIONS(5674),
    [anon_sym_CARET_EQ] = ACTIONS(5674),
    [anon_sym_PIPE_EQ] = ACTIONS(5674),
    [anon_sym_LT_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_GT_EQ] = ACTIONS(5674),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5674),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3591] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7026),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3591),
    [sym_preproc_endregion] = STATE(3591),
    [sym_preproc_line] = STATE(3591),
    [sym_preproc_pragma] = STATE(3591),
    [sym_preproc_nullable] = STATE(3591),
    [sym_preproc_error] = STATE(3591),
    [sym_preproc_warning] = STATE(3591),
    [sym_preproc_define] = STATE(3591),
    [sym_preproc_undef] = STATE(3591),
    [aux_sym_type_argument_list_repeat1] = STATE(7027),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3592] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3592),
    [sym_preproc_endregion] = STATE(3592),
    [sym_preproc_line] = STATE(3592),
    [sym_preproc_pragma] = STATE(3592),
    [sym_preproc_nullable] = STATE(3592),
    [sym_preproc_error] = STATE(3592),
    [sym_preproc_warning] = STATE(3592),
    [sym_preproc_define] = STATE(3592),
    [sym_preproc_undef] = STATE(3592),
    [aux_sym_type_argument_list_repeat1] = STATE(7023),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5678),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3593] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3593),
    [sym_preproc_endregion] = STATE(3593),
    [sym_preproc_line] = STATE(3593),
    [sym_preproc_pragma] = STATE(3593),
    [sym_preproc_nullable] = STATE(3593),
    [sym_preproc_error] = STATE(3593),
    [sym_preproc_warning] = STATE(3593),
    [sym_preproc_define] = STATE(3593),
    [sym_preproc_undef] = STATE(3593),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3594] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3594),
    [sym_preproc_endregion] = STATE(3594),
    [sym_preproc_line] = STATE(3594),
    [sym_preproc_pragma] = STATE(3594),
    [sym_preproc_nullable] = STATE(3594),
    [sym_preproc_error] = STATE(3594),
    [sym_preproc_warning] = STATE(3594),
    [sym_preproc_define] = STATE(3594),
    [sym_preproc_undef] = STATE(3594),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3595] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3595),
    [sym_preproc_endregion] = STATE(3595),
    [sym_preproc_line] = STATE(3595),
    [sym_preproc_pragma] = STATE(3595),
    [sym_preproc_nullable] = STATE(3595),
    [sym_preproc_error] = STATE(3595),
    [sym_preproc_warning] = STATE(3595),
    [sym_preproc_define] = STATE(3595),
    [sym_preproc_undef] = STATE(3595),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3596] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3596),
    [sym_preproc_endregion] = STATE(3596),
    [sym_preproc_line] = STATE(3596),
    [sym_preproc_pragma] = STATE(3596),
    [sym_preproc_nullable] = STATE(3596),
    [sym_preproc_error] = STATE(3596),
    [sym_preproc_warning] = STATE(3596),
    [sym_preproc_define] = STATE(3596),
    [sym_preproc_undef] = STATE(3596),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3597] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3597),
    [sym_preproc_endregion] = STATE(3597),
    [sym_preproc_line] = STATE(3597),
    [sym_preproc_pragma] = STATE(3597),
    [sym_preproc_nullable] = STATE(3597),
    [sym_preproc_error] = STATE(3597),
    [sym_preproc_warning] = STATE(3597),
    [sym_preproc_define] = STATE(3597),
    [sym_preproc_undef] = STATE(3597),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(4887),
    [anon_sym_GT] = ACTIONS(4887),
    [anon_sym_where] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(4887),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(4887),
    [anon_sym_DASH] = ACTIONS(4887),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4887),
    [anon_sym_PERCENT] = ACTIONS(4885),
    [anon_sym_CARET] = ACTIONS(4885),
    [anon_sym_PIPE] = ACTIONS(4887),
    [anon_sym_AMP] = ACTIONS(4887),
    [anon_sym_LT_LT] = ACTIONS(4885),
    [anon_sym_GT_GT] = ACTIONS(4887),
    [anon_sym_GT_GT_GT] = ACTIONS(4885),
    [anon_sym_EQ_EQ] = ACTIONS(4885),
    [anon_sym_BANG_EQ] = ACTIONS(4885),
    [anon_sym_GT_EQ] = ACTIONS(4885),
    [anon_sym_LT_EQ] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(4885),
    [anon_sym_DOT_DOT] = ACTIONS(4885),
    [anon_sym_and] = ACTIONS(4885),
    [anon_sym_or] = ACTIONS(4887),
    [anon_sym_AMP_AMP] = ACTIONS(4885),
    [anon_sym_PIPE_PIPE] = ACTIONS(4885),
    [anon_sym_QMARK_QMARK] = ACTIONS(4885),
    [anon_sym_from] = ACTIONS(4885),
    [anon_sym_into] = ACTIONS(4885),
    [anon_sym_join] = ACTIONS(4885),
    [anon_sym_let] = ACTIONS(4885),
    [anon_sym_orderby] = ACTIONS(4885),
    [anon_sym_ascending] = ACTIONS(4885),
    [anon_sym_descending] = ACTIONS(4885),
    [anon_sym_group] = ACTIONS(4885),
    [anon_sym_select] = ACTIONS(4885),
    [anon_sym_as] = ACTIONS(4887),
    [anon_sym_is] = ACTIONS(4885),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3598] = {
    [sym_argument_list] = STATE(3216),
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3176),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3269),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3598),
    [sym_preproc_endregion] = STATE(3598),
    [sym_preproc_line] = STATE(3598),
    [sym_preproc_pragma] = STATE(3598),
    [sym_preproc_nullable] = STATE(3598),
    [sym_preproc_error] = STATE(3598),
    [sym_preproc_warning] = STATE(3598),
    [sym_preproc_define] = STATE(3598),
    [sym_preproc_undef] = STATE(3598),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_ref] = ACTIONS(3802),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5714),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3599] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3599),
    [sym_preproc_endregion] = STATE(3599),
    [sym_preproc_line] = STATE(3599),
    [sym_preproc_pragma] = STATE(3599),
    [sym_preproc_nullable] = STATE(3599),
    [sym_preproc_error] = STATE(3599),
    [sym_preproc_warning] = STATE(3599),
    [sym_preproc_define] = STATE(3599),
    [sym_preproc_undef] = STATE(3599),
    [aux_sym_type_argument_list_repeat1] = STATE(6829),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5720),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3600] = {
    [sym_block] = STATE(2117),
    [sym_preproc_region] = STATE(3600),
    [sym_preproc_endregion] = STATE(3600),
    [sym_preproc_line] = STATE(3600),
    [sym_preproc_pragma] = STATE(3600),
    [sym_preproc_nullable] = STATE(3600),
    [sym_preproc_error] = STATE(3600),
    [sym_preproc_warning] = STATE(3600),
    [sym_preproc_define] = STATE(3600),
    [sym_preproc_undef] = STATE(3600),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(5722),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3601] = {
    [sym_preproc_region] = STATE(3601),
    [sym_preproc_endregion] = STATE(3601),
    [sym_preproc_line] = STATE(3601),
    [sym_preproc_pragma] = STATE(3601),
    [sym_preproc_nullable] = STATE(3601),
    [sym_preproc_error] = STATE(3601),
    [sym_preproc_warning] = STATE(3601),
    [sym_preproc_define] = STATE(3601),
    [sym_preproc_undef] = STATE(3601),
    [sym__identifier_token] = ACTIONS(4817),
    [anon_sym_extern] = ACTIONS(4817),
    [anon_sym_alias] = ACTIONS(4817),
    [anon_sym_global] = ACTIONS(4817),
    [anon_sym_unsafe] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4817),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym_ref] = ACTIONS(4817),
    [anon_sym_delegate] = ACTIONS(4817),
    [anon_sym_abstract] = ACTIONS(4817),
    [anon_sym_async] = ACTIONS(4817),
    [anon_sym_const] = ACTIONS(4817),
    [anon_sym_file] = ACTIONS(4817),
    [anon_sym_fixed] = ACTIONS(4817),
    [anon_sym_internal] = ACTIONS(4817),
    [anon_sym_new] = ACTIONS(4817),
    [anon_sym_override] = ACTIONS(4817),
    [anon_sym_partial] = ACTIONS(4817),
    [anon_sym_private] = ACTIONS(4817),
    [anon_sym_protected] = ACTIONS(4817),
    [anon_sym_public] = ACTIONS(4817),
    [anon_sym_readonly] = ACTIONS(4817),
    [anon_sym_required] = ACTIONS(4817),
    [anon_sym_sealed] = ACTIONS(4817),
    [anon_sym_virtual] = ACTIONS(4817),
    [anon_sym_volatile] = ACTIONS(4817),
    [anon_sym_where] = ACTIONS(4817),
    [anon_sym_notnull] = ACTIONS(4817),
    [anon_sym_unmanaged] = ACTIONS(4817),
    [anon_sym_scoped] = ACTIONS(4817),
    [anon_sym_var] = ACTIONS(4817),
    [sym_predefined_type] = ACTIONS(4817),
    [anon_sym_yield] = ACTIONS(4817),
    [anon_sym_when] = ACTIONS(4817),
    [anon_sym_from] = ACTIONS(4817),
    [anon_sym_into] = ACTIONS(4817),
    [anon_sym_join] = ACTIONS(4817),
    [anon_sym_on] = ACTIONS(4817),
    [anon_sym_equals] = ACTIONS(4817),
    [anon_sym_let] = ACTIONS(4817),
    [anon_sym_orderby] = ACTIONS(4817),
    [anon_sym_ascending] = ACTIONS(4817),
    [anon_sym_descending] = ACTIONS(4817),
    [anon_sym_group] = ACTIONS(4817),
    [anon_sym_by] = ACTIONS(4817),
    [anon_sym_select] = ACTIONS(4817),
    [aux_sym_preproc_if_token1] = ACTIONS(4819),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3602] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6800),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3602),
    [sym_preproc_endregion] = STATE(3602),
    [sym_preproc_line] = STATE(3602),
    [sym_preproc_pragma] = STATE(3602),
    [sym_preproc_nullable] = STATE(3602),
    [sym_preproc_error] = STATE(3602),
    [sym_preproc_warning] = STATE(3602),
    [sym_preproc_define] = STATE(3602),
    [sym_preproc_undef] = STATE(3602),
    [aux_sym_type_argument_list_repeat1] = STATE(6801),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5724),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3603] = {
    [sym_argument_list] = STATE(4353),
    [sym__name] = STATE(4497),
    [sym_alias_qualified_name] = STATE(4398),
    [sym__simple_name] = STATE(4398),
    [sym_qualified_name] = STATE(4398),
    [sym_generic_name] = STATE(4419),
    [sym_type] = STATE(4249),
    [sym_implicit_type] = STATE(4407),
    [sym_array_type] = STATE(4378),
    [sym__array_base_type] = STATE(7286),
    [sym_nullable_type] = STATE(4519),
    [sym_pointer_type] = STATE(4519),
    [sym__pointer_base_type] = STATE(7680),
    [sym_function_pointer_type] = STATE(4519),
    [sym_ref_type] = STATE(4407),
    [sym_scoped_type] = STATE(4407),
    [sym_tuple_type] = STATE(4520),
    [sym_identifier] = STATE(4293),
    [sym__reserved_identifier] = STATE(4388),
    [sym_preproc_region] = STATE(3603),
    [sym_preproc_endregion] = STATE(3603),
    [sym_preproc_line] = STATE(3603),
    [sym_preproc_pragma] = STATE(3603),
    [sym_preproc_nullable] = STATE(3603),
    [sym_preproc_error] = STATE(3603),
    [sym_preproc_warning] = STATE(3603),
    [sym_preproc_define] = STATE(3603),
    [sym_preproc_undef] = STATE(3603),
    [sym__identifier_token] = ACTIONS(4009),
    [anon_sym_alias] = ACTIONS(4011),
    [anon_sym_global] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_LPAREN] = ACTIONS(5728),
    [anon_sym_ref] = ACTIONS(4013),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_delegate] = ACTIONS(5732),
    [anon_sym_file] = ACTIONS(4011),
    [anon_sym_where] = ACTIONS(4011),
    [anon_sym_notnull] = ACTIONS(4011),
    [anon_sym_unmanaged] = ACTIONS(4011),
    [anon_sym_scoped] = ACTIONS(5734),
    [anon_sym_var] = ACTIONS(5736),
    [sym_predefined_type] = ACTIONS(5738),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_when] = ACTIONS(4011),
    [anon_sym_from] = ACTIONS(4011),
    [anon_sym_into] = ACTIONS(4011),
    [anon_sym_join] = ACTIONS(4011),
    [anon_sym_on] = ACTIONS(4011),
    [anon_sym_equals] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_orderby] = ACTIONS(4011),
    [anon_sym_ascending] = ACTIONS(4011),
    [anon_sym_descending] = ACTIONS(4011),
    [anon_sym_group] = ACTIONS(4011),
    [anon_sym_by] = ACTIONS(4011),
    [anon_sym_select] = ACTIONS(4011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3604] = {
    [sym_preproc_region] = STATE(3604),
    [sym_preproc_endregion] = STATE(3604),
    [sym_preproc_line] = STATE(3604),
    [sym_preproc_pragma] = STATE(3604),
    [sym_preproc_nullable] = STATE(3604),
    [sym_preproc_error] = STATE(3604),
    [sym_preproc_warning] = STATE(3604),
    [sym_preproc_define] = STATE(3604),
    [sym_preproc_undef] = STATE(3604),
    [sym__identifier_token] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym_alias] = ACTIONS(5059),
    [anon_sym_global] = ACTIONS(5059),
    [anon_sym_unsafe] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5061),
    [anon_sym_LPAREN] = ACTIONS(5061),
    [anon_sym_ref] = ACTIONS(5059),
    [anon_sym_delegate] = ACTIONS(5059),
    [anon_sym_abstract] = ACTIONS(5059),
    [anon_sym_async] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_file] = ACTIONS(5059),
    [anon_sym_fixed] = ACTIONS(5059),
    [anon_sym_internal] = ACTIONS(5059),
    [anon_sym_new] = ACTIONS(5059),
    [anon_sym_override] = ACTIONS(5059),
    [anon_sym_partial] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_readonly] = ACTIONS(5059),
    [anon_sym_required] = ACTIONS(5059),
    [anon_sym_sealed] = ACTIONS(5059),
    [anon_sym_virtual] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_where] = ACTIONS(5059),
    [anon_sym_notnull] = ACTIONS(5059),
    [anon_sym_unmanaged] = ACTIONS(5059),
    [anon_sym_scoped] = ACTIONS(5059),
    [anon_sym_var] = ACTIONS(5059),
    [sym_predefined_type] = ACTIONS(5059),
    [anon_sym_yield] = ACTIONS(5059),
    [anon_sym_when] = ACTIONS(5059),
    [anon_sym_from] = ACTIONS(5059),
    [anon_sym_into] = ACTIONS(5059),
    [anon_sym_join] = ACTIONS(5059),
    [anon_sym_on] = ACTIONS(5059),
    [anon_sym_equals] = ACTIONS(5059),
    [anon_sym_let] = ACTIONS(5059),
    [anon_sym_orderby] = ACTIONS(5059),
    [anon_sym_ascending] = ACTIONS(5059),
    [anon_sym_descending] = ACTIONS(5059),
    [anon_sym_group] = ACTIONS(5059),
    [anon_sym_by] = ACTIONS(5059),
    [anon_sym_select] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3605] = {
    [sym_modifier] = STATE(3740),
    [sym_preproc_region] = STATE(3605),
    [sym_preproc_endregion] = STATE(3605),
    [sym_preproc_line] = STATE(3605),
    [sym_preproc_pragma] = STATE(3605),
    [sym_preproc_nullable] = STATE(3605),
    [sym_preproc_error] = STATE(3605),
    [sym_preproc_warning] = STATE(3605),
    [sym_preproc_define] = STATE(3605),
    [sym_preproc_undef] = STATE(3605),
    [aux_sym__class_declaration_initializer_repeat2] = STATE(3605),
    [sym__identifier_token] = ACTIONS(5264),
    [anon_sym_extern] = ACTIONS(5740),
    [anon_sym_alias] = ACTIONS(5264),
    [anon_sym_global] = ACTIONS(5264),
    [anon_sym_unsafe] = ACTIONS(5740),
    [anon_sym_static] = ACTIONS(5740),
    [anon_sym_LPAREN] = ACTIONS(5269),
    [anon_sym_ref] = ACTIONS(5264),
    [anon_sym_delegate] = ACTIONS(5264),
    [anon_sym_abstract] = ACTIONS(5740),
    [anon_sym_async] = ACTIONS(5740),
    [anon_sym_const] = ACTIONS(5740),
    [anon_sym_file] = ACTIONS(5740),
    [anon_sym_fixed] = ACTIONS(5740),
    [anon_sym_internal] = ACTIONS(5740),
    [anon_sym_new] = ACTIONS(5740),
    [anon_sym_override] = ACTIONS(5740),
    [anon_sym_partial] = ACTIONS(5740),
    [anon_sym_private] = ACTIONS(5740),
    [anon_sym_protected] = ACTIONS(5740),
    [anon_sym_public] = ACTIONS(5740),
    [anon_sym_readonly] = ACTIONS(5740),
    [anon_sym_required] = ACTIONS(5740),
    [anon_sym_sealed] = ACTIONS(5740),
    [anon_sym_virtual] = ACTIONS(5740),
    [anon_sym_volatile] = ACTIONS(5740),
    [anon_sym_where] = ACTIONS(5264),
    [anon_sym_notnull] = ACTIONS(5264),
    [anon_sym_unmanaged] = ACTIONS(5264),
    [anon_sym_scoped] = ACTIONS(5264),
    [anon_sym_var] = ACTIONS(5264),
    [sym_predefined_type] = ACTIONS(5264),
    [anon_sym_yield] = ACTIONS(5264),
    [anon_sym_when] = ACTIONS(5264),
    [anon_sym_from] = ACTIONS(5264),
    [anon_sym_into] = ACTIONS(5264),
    [anon_sym_join] = ACTIONS(5264),
    [anon_sym_on] = ACTIONS(5264),
    [anon_sym_equals] = ACTIONS(5264),
    [anon_sym_let] = ACTIONS(5264),
    [anon_sym_orderby] = ACTIONS(5264),
    [anon_sym_ascending] = ACTIONS(5264),
    [anon_sym_descending] = ACTIONS(5264),
    [anon_sym_group] = ACTIONS(5264),
    [anon_sym_by] = ACTIONS(5264),
    [anon_sym_select] = ACTIONS(5264),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3606] = {
    [sym_preproc_region] = STATE(3606),
    [sym_preproc_endregion] = STATE(3606),
    [sym_preproc_line] = STATE(3606),
    [sym_preproc_pragma] = STATE(3606),
    [sym_preproc_nullable] = STATE(3606),
    [sym_preproc_error] = STATE(3606),
    [sym_preproc_warning] = STATE(3606),
    [sym_preproc_define] = STATE(3606),
    [sym_preproc_undef] = STATE(3606),
    [sym__identifier_token] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym_alias] = ACTIONS(5071),
    [anon_sym_global] = ACTIONS(5071),
    [anon_sym_unsafe] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5073),
    [anon_sym_ref] = ACTIONS(5071),
    [anon_sym_delegate] = ACTIONS(5071),
    [anon_sym_abstract] = ACTIONS(5071),
    [anon_sym_async] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_file] = ACTIONS(5071),
    [anon_sym_fixed] = ACTIONS(5071),
    [anon_sym_internal] = ACTIONS(5071),
    [anon_sym_new] = ACTIONS(5071),
    [anon_sym_override] = ACTIONS(5071),
    [anon_sym_partial] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_readonly] = ACTIONS(5071),
    [anon_sym_required] = ACTIONS(5071),
    [anon_sym_sealed] = ACTIONS(5071),
    [anon_sym_virtual] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_where] = ACTIONS(5071),
    [anon_sym_notnull] = ACTIONS(5071),
    [anon_sym_unmanaged] = ACTIONS(5071),
    [anon_sym_scoped] = ACTIONS(5071),
    [anon_sym_var] = ACTIONS(5071),
    [sym_predefined_type] = ACTIONS(5071),
    [anon_sym_yield] = ACTIONS(5071),
    [anon_sym_when] = ACTIONS(5071),
    [anon_sym_from] = ACTIONS(5071),
    [anon_sym_into] = ACTIONS(5071),
    [anon_sym_join] = ACTIONS(5071),
    [anon_sym_on] = ACTIONS(5071),
    [anon_sym_equals] = ACTIONS(5071),
    [anon_sym_let] = ACTIONS(5071),
    [anon_sym_orderby] = ACTIONS(5071),
    [anon_sym_ascending] = ACTIONS(5071),
    [anon_sym_descending] = ACTIONS(5071),
    [anon_sym_group] = ACTIONS(5071),
    [anon_sym_by] = ACTIONS(5071),
    [anon_sym_select] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3607] = {
    [sym_initializer_expression] = STATE(3824),
    [sym_preproc_region] = STATE(3607),
    [sym_preproc_endregion] = STATE(3607),
    [sym_preproc_line] = STATE(3607),
    [sym_preproc_pragma] = STATE(3607),
    [sym_preproc_nullable] = STATE(3607),
    [sym_preproc_error] = STATE(3607),
    [sym_preproc_warning] = STATE(3607),
    [sym_preproc_define] = STATE(3607),
    [sym_preproc_undef] = STATE(3607),
    [anon_sym_LBRACK] = ACTIONS(4891),
    [anon_sym_COMMA] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(4889),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_where] = ACTIONS(4889),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_BANG] = ACTIONS(4894),
    [anon_sym_PLUS_PLUS] = ACTIONS(4889),
    [anon_sym_DASH_DASH] = ACTIONS(4889),
    [anon_sym_PLUS] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_SLASH] = ACTIONS(4894),
    [anon_sym_PERCENT] = ACTIONS(4889),
    [anon_sym_CARET] = ACTIONS(4889),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4889),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_GT_GT_GT] = ACTIONS(4889),
    [anon_sym_EQ_EQ] = ACTIONS(4889),
    [anon_sym_BANG_EQ] = ACTIONS(4889),
    [anon_sym_GT_EQ] = ACTIONS(4889),
    [anon_sym_LT_EQ] = ACTIONS(4889),
    [anon_sym_DOT] = ACTIONS(4894),
    [anon_sym_switch] = ACTIONS(4889),
    [anon_sym_DOT_DOT] = ACTIONS(4889),
    [anon_sym_and] = ACTIONS(4889),
    [anon_sym_or] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4889),
    [anon_sym_PIPE_PIPE] = ACTIONS(4889),
    [anon_sym_QMARK_QMARK] = ACTIONS(4889),
    [anon_sym_from] = ACTIONS(4889),
    [anon_sym_into] = ACTIONS(4889),
    [anon_sym_join] = ACTIONS(4889),
    [anon_sym_let] = ACTIONS(4889),
    [anon_sym_orderby] = ACTIONS(4889),
    [anon_sym_ascending] = ACTIONS(4889),
    [anon_sym_descending] = ACTIONS(4889),
    [anon_sym_group] = ACTIONS(4889),
    [anon_sym_select] = ACTIONS(4889),
    [anon_sym_as] = ACTIONS(4894),
    [anon_sym_is] = ACTIONS(4889),
    [anon_sym_DASH_GT] = ACTIONS(4889),
    [anon_sym_with] = ACTIONS(4889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3608] = {
    [sym_argument_list] = STATE(3216),
    [sym__name] = STATE(5187),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3176),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(4944),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(4595),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3608),
    [sym_preproc_endregion] = STATE(3608),
    [sym_preproc_line] = STATE(3608),
    [sym_preproc_pragma] = STATE(3608),
    [sym_preproc_nullable] = STATE(3608),
    [sym_preproc_error] = STATE(3608),
    [sym_preproc_warning] = STATE(3608),
    [sym_preproc_define] = STATE(3608),
    [sym_preproc_undef] = STATE(3608),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_ref] = ACTIONS(4162),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5743),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3609] = {
    [sym_block] = STATE(7163),
    [sym_preproc_region] = STATE(3609),
    [sym_preproc_endregion] = STATE(3609),
    [sym_preproc_line] = STATE(3609),
    [sym_preproc_pragma] = STATE(3609),
    [sym_preproc_nullable] = STATE(3609),
    [sym_preproc_error] = STATE(3609),
    [sym_preproc_warning] = STATE(3609),
    [sym_preproc_define] = STATE(3609),
    [sym_preproc_undef] = STATE(3609),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(5638),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3610] = {
    [sym_initializer_expression] = STATE(3784),
    [sym_preproc_region] = STATE(3610),
    [sym_preproc_endregion] = STATE(3610),
    [sym_preproc_line] = STATE(3610),
    [sym_preproc_pragma] = STATE(3610),
    [sym_preproc_nullable] = STATE(3610),
    [sym_preproc_error] = STATE(3610),
    [sym_preproc_warning] = STATE(3610),
    [sym_preproc_define] = STATE(3610),
    [sym_preproc_undef] = STATE(3610),
    [anon_sym_LBRACK] = ACTIONS(4916),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_LT] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4926),
    [anon_sym_where] = ACTIONS(4920),
    [anon_sym_QMARK] = ACTIONS(5748),
    [anon_sym_BANG] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4926),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4926),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_GT_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4926),
    [anon_sym_switch] = ACTIONS(4920),
    [anon_sym_DOT_DOT] = ACTIONS(4920),
    [anon_sym_and] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_QMARK_QMARK] = ACTIONS(4920),
    [anon_sym_from] = ACTIONS(4920),
    [anon_sym_into] = ACTIONS(4920),
    [anon_sym_join] = ACTIONS(4920),
    [anon_sym_let] = ACTIONS(4920),
    [anon_sym_orderby] = ACTIONS(4920),
    [anon_sym_ascending] = ACTIONS(4920),
    [anon_sym_descending] = ACTIONS(4920),
    [anon_sym_group] = ACTIONS(4920),
    [anon_sym_select] = ACTIONS(4920),
    [anon_sym_as] = ACTIONS(4926),
    [anon_sym_is] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_with] = ACTIONS(4920),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3611] = {
    [sym_argument_list] = STATE(3172),
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3168),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3187),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3611),
    [sym_preproc_endregion] = STATE(3611),
    [sym_preproc_line] = STATE(3611),
    [sym_preproc_pragma] = STATE(3611),
    [sym_preproc_nullable] = STATE(3611),
    [sym_preproc_error] = STATE(3611),
    [sym_preproc_warning] = STATE(3611),
    [sym_preproc_define] = STATE(3611),
    [sym_preproc_undef] = STATE(3611),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5754),
    [anon_sym_ref] = ACTIONS(3793),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5760),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3612] = {
    [sym_preproc_region] = STATE(3612),
    [sym_preproc_endregion] = STATE(3612),
    [sym_preproc_line] = STATE(3612),
    [sym_preproc_pragma] = STATE(3612),
    [sym_preproc_nullable] = STATE(3612),
    [sym_preproc_error] = STATE(3612),
    [sym_preproc_warning] = STATE(3612),
    [sym_preproc_define] = STATE(3612),
    [sym_preproc_undef] = STATE(3612),
    [sym__identifier_token] = ACTIONS(3785),
    [anon_sym_extern] = ACTIONS(3785),
    [anon_sym_alias] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3785),
    [anon_sym_unsafe] = ACTIONS(3785),
    [anon_sym_static] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3785),
    [anon_sym_delegate] = ACTIONS(3785),
    [anon_sym_abstract] = ACTIONS(3785),
    [anon_sym_async] = ACTIONS(3785),
    [anon_sym_const] = ACTIONS(3785),
    [anon_sym_file] = ACTIONS(3785),
    [anon_sym_fixed] = ACTIONS(3785),
    [anon_sym_internal] = ACTIONS(3785),
    [anon_sym_new] = ACTIONS(3785),
    [anon_sym_override] = ACTIONS(3785),
    [anon_sym_partial] = ACTIONS(3785),
    [anon_sym_private] = ACTIONS(3785),
    [anon_sym_protected] = ACTIONS(3785),
    [anon_sym_public] = ACTIONS(3785),
    [anon_sym_readonly] = ACTIONS(3785),
    [anon_sym_required] = ACTIONS(3785),
    [anon_sym_sealed] = ACTIONS(3785),
    [anon_sym_virtual] = ACTIONS(3785),
    [anon_sym_volatile] = ACTIONS(3785),
    [anon_sym_where] = ACTIONS(3785),
    [anon_sym_notnull] = ACTIONS(3785),
    [anon_sym_unmanaged] = ACTIONS(3785),
    [anon_sym_scoped] = ACTIONS(3785),
    [anon_sym_var] = ACTIONS(3785),
    [sym_predefined_type] = ACTIONS(3785),
    [anon_sym_yield] = ACTIONS(3785),
    [anon_sym_when] = ACTIONS(3785),
    [anon_sym_from] = ACTIONS(3785),
    [anon_sym_into] = ACTIONS(3785),
    [anon_sym_join] = ACTIONS(3785),
    [anon_sym_on] = ACTIONS(3785),
    [anon_sym_equals] = ACTIONS(3785),
    [anon_sym_let] = ACTIONS(3785),
    [anon_sym_orderby] = ACTIONS(3785),
    [anon_sym_ascending] = ACTIONS(3785),
    [anon_sym_descending] = ACTIONS(3785),
    [anon_sym_group] = ACTIONS(3785),
    [anon_sym_by] = ACTIONS(3785),
    [anon_sym_select] = ACTIONS(3785),
    [aux_sym_preproc_if_token1] = ACTIONS(3787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3613] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6865),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3613),
    [sym_preproc_endregion] = STATE(3613),
    [sym_preproc_line] = STATE(3613),
    [sym_preproc_pragma] = STATE(3613),
    [sym_preproc_nullable] = STATE(3613),
    [sym_preproc_error] = STATE(3613),
    [sym_preproc_warning] = STATE(3613),
    [sym_preproc_define] = STATE(3613),
    [sym_preproc_undef] = STATE(3613),
    [aux_sym_type_argument_list_repeat1] = STATE(6867),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3614] = {
    [sym_preproc_region] = STATE(3614),
    [sym_preproc_endregion] = STATE(3614),
    [sym_preproc_line] = STATE(3614),
    [sym_preproc_pragma] = STATE(3614),
    [sym_preproc_nullable] = STATE(3614),
    [sym_preproc_error] = STATE(3614),
    [sym_preproc_warning] = STATE(3614),
    [sym_preproc_define] = STATE(3614),
    [sym_preproc_undef] = STATE(3614),
    [sym__identifier_token] = ACTIONS(4823),
    [anon_sym_extern] = ACTIONS(4823),
    [anon_sym_alias] = ACTIONS(4823),
    [anon_sym_global] = ACTIONS(4823),
    [anon_sym_unsafe] = ACTIONS(4823),
    [anon_sym_static] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4825),
    [anon_sym_LPAREN] = ACTIONS(4825),
    [anon_sym_ref] = ACTIONS(4823),
    [anon_sym_delegate] = ACTIONS(4823),
    [anon_sym_abstract] = ACTIONS(4823),
    [anon_sym_async] = ACTIONS(4823),
    [anon_sym_const] = ACTIONS(4823),
    [anon_sym_file] = ACTIONS(4823),
    [anon_sym_fixed] = ACTIONS(4823),
    [anon_sym_internal] = ACTIONS(4823),
    [anon_sym_new] = ACTIONS(4823),
    [anon_sym_override] = ACTIONS(4823),
    [anon_sym_partial] = ACTIONS(4823),
    [anon_sym_private] = ACTIONS(4823),
    [anon_sym_protected] = ACTIONS(4823),
    [anon_sym_public] = ACTIONS(4823),
    [anon_sym_readonly] = ACTIONS(4823),
    [anon_sym_required] = ACTIONS(4823),
    [anon_sym_sealed] = ACTIONS(4823),
    [anon_sym_virtual] = ACTIONS(4823),
    [anon_sym_volatile] = ACTIONS(4823),
    [anon_sym_where] = ACTIONS(4823),
    [anon_sym_notnull] = ACTIONS(4823),
    [anon_sym_unmanaged] = ACTIONS(4823),
    [anon_sym_scoped] = ACTIONS(4823),
    [anon_sym_var] = ACTIONS(4823),
    [sym_predefined_type] = ACTIONS(4823),
    [anon_sym_yield] = ACTIONS(4823),
    [anon_sym_when] = ACTIONS(4823),
    [anon_sym_from] = ACTIONS(4823),
    [anon_sym_into] = ACTIONS(4823),
    [anon_sym_join] = ACTIONS(4823),
    [anon_sym_on] = ACTIONS(4823),
    [anon_sym_equals] = ACTIONS(4823),
    [anon_sym_let] = ACTIONS(4823),
    [anon_sym_orderby] = ACTIONS(4823),
    [anon_sym_ascending] = ACTIONS(4823),
    [anon_sym_descending] = ACTIONS(4823),
    [anon_sym_group] = ACTIONS(4823),
    [anon_sym_by] = ACTIONS(4823),
    [anon_sym_select] = ACTIONS(4823),
    [aux_sym_preproc_if_token1] = ACTIONS(4825),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3615] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3615),
    [sym_preproc_endregion] = STATE(3615),
    [sym_preproc_line] = STATE(3615),
    [sym_preproc_pragma] = STATE(3615),
    [sym_preproc_nullable] = STATE(3615),
    [sym_preproc_error] = STATE(3615),
    [sym_preproc_warning] = STATE(3615),
    [sym_preproc_define] = STATE(3615),
    [sym_preproc_undef] = STATE(3615),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(1229),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_into] = ACTIONS(1229),
    [anon_sym_join] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_orderby] = ACTIONS(1229),
    [anon_sym_ascending] = ACTIONS(1229),
    [anon_sym_descending] = ACTIONS(1229),
    [anon_sym_group] = ACTIONS(1229),
    [anon_sym_select] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1229),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3616] = {
    [sym_initializer_expression] = STATE(3777),
    [sym_preproc_region] = STATE(3616),
    [sym_preproc_endregion] = STATE(3616),
    [sym_preproc_line] = STATE(3616),
    [sym_preproc_pragma] = STATE(3616),
    [sym_preproc_nullable] = STATE(3616),
    [sym_preproc_error] = STATE(3616),
    [sym_preproc_warning] = STATE(3616),
    [sym_preproc_define] = STATE(3616),
    [sym_preproc_undef] = STATE(3616),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4873),
    [anon_sym_where] = ACTIONS(4871),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_BANG] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4873),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_SLASH] = ACTIONS(4873),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4873),
    [anon_sym_AMP] = ACTIONS(4873),
    [anon_sym_LT_LT] = ACTIONS(4871),
    [anon_sym_GT_GT] = ACTIONS(4873),
    [anon_sym_GT_GT_GT] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4871),
    [anon_sym_BANG_EQ] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4871),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4873),
    [anon_sym_switch] = ACTIONS(4871),
    [anon_sym_DOT_DOT] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_or] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE] = ACTIONS(4871),
    [anon_sym_QMARK_QMARK] = ACTIONS(4871),
    [anon_sym_from] = ACTIONS(4871),
    [anon_sym_into] = ACTIONS(4871),
    [anon_sym_join] = ACTIONS(4871),
    [anon_sym_let] = ACTIONS(4871),
    [anon_sym_orderby] = ACTIONS(4871),
    [anon_sym_ascending] = ACTIONS(4871),
    [anon_sym_descending] = ACTIONS(4871),
    [anon_sym_group] = ACTIONS(4871),
    [anon_sym_select] = ACTIONS(4871),
    [anon_sym_as] = ACTIONS(4873),
    [anon_sym_is] = ACTIONS(4871),
    [anon_sym_DASH_GT] = ACTIONS(4871),
    [anon_sym_with] = ACTIONS(4871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3617] = {
    [sym_preproc_region] = STATE(3617),
    [sym_preproc_endregion] = STATE(3617),
    [sym_preproc_line] = STATE(3617),
    [sym_preproc_pragma] = STATE(3617),
    [sym_preproc_nullable] = STATE(3617),
    [sym_preproc_error] = STATE(3617),
    [sym_preproc_warning] = STATE(3617),
    [sym_preproc_define] = STATE(3617),
    [sym_preproc_undef] = STATE(3617),
    [sym__identifier_token] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym_alias] = ACTIONS(5055),
    [anon_sym_global] = ACTIONS(5055),
    [anon_sym_unsafe] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5057),
    [anon_sym_LPAREN] = ACTIONS(5057),
    [anon_sym_ref] = ACTIONS(5055),
    [anon_sym_delegate] = ACTIONS(5055),
    [anon_sym_abstract] = ACTIONS(5055),
    [anon_sym_async] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_file] = ACTIONS(5055),
    [anon_sym_fixed] = ACTIONS(5055),
    [anon_sym_internal] = ACTIONS(5055),
    [anon_sym_new] = ACTIONS(5055),
    [anon_sym_override] = ACTIONS(5055),
    [anon_sym_partial] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_readonly] = ACTIONS(5055),
    [anon_sym_required] = ACTIONS(5055),
    [anon_sym_sealed] = ACTIONS(5055),
    [anon_sym_virtual] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_where] = ACTIONS(5055),
    [anon_sym_notnull] = ACTIONS(5055),
    [anon_sym_unmanaged] = ACTIONS(5055),
    [anon_sym_scoped] = ACTIONS(5055),
    [anon_sym_var] = ACTIONS(5055),
    [sym_predefined_type] = ACTIONS(5055),
    [anon_sym_yield] = ACTIONS(5055),
    [anon_sym_when] = ACTIONS(5055),
    [anon_sym_from] = ACTIONS(5055),
    [anon_sym_into] = ACTIONS(5055),
    [anon_sym_join] = ACTIONS(5055),
    [anon_sym_on] = ACTIONS(5055),
    [anon_sym_equals] = ACTIONS(5055),
    [anon_sym_let] = ACTIONS(5055),
    [anon_sym_orderby] = ACTIONS(5055),
    [anon_sym_ascending] = ACTIONS(5055),
    [anon_sym_descending] = ACTIONS(5055),
    [anon_sym_group] = ACTIONS(5055),
    [anon_sym_by] = ACTIONS(5055),
    [anon_sym_select] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3618] = {
    [sym_argument_list] = STATE(3216),
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3176),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3269),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3618),
    [sym_preproc_endregion] = STATE(3618),
    [sym_preproc_line] = STATE(3618),
    [sym_preproc_pragma] = STATE(3618),
    [sym_preproc_nullable] = STATE(3618),
    [sym_preproc_error] = STATE(3618),
    [sym_preproc_warning] = STATE(3618),
    [sym_preproc_define] = STATE(3618),
    [sym_preproc_undef] = STATE(3618),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_ref] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5768),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3619] = {
    [sym_argument_list] = STATE(3172),
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3168),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3187),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3619),
    [sym_preproc_endregion] = STATE(3619),
    [sym_preproc_line] = STATE(3619),
    [sym_preproc_pragma] = STATE(3619),
    [sym_preproc_nullable] = STATE(3619),
    [sym_preproc_error] = STATE(3619),
    [sym_preproc_warning] = STATE(3619),
    [sym_preproc_define] = STATE(3619),
    [sym_preproc_undef] = STATE(3619),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5754),
    [anon_sym_ref] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5770),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3620] = {
    [sym_argument_list] = STATE(2939),
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2915),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(3540),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3620),
    [sym_preproc_endregion] = STATE(3620),
    [sym_preproc_line] = STATE(3620),
    [sym_preproc_pragma] = STATE(3620),
    [sym_preproc_nullable] = STATE(3620),
    [sym_preproc_error] = STATE(3620),
    [sym_preproc_warning] = STATE(3620),
    [sym_preproc_define] = STATE(3620),
    [sym_preproc_undef] = STATE(3620),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_ref] = ACTIONS(4257),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5780),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3621] = {
    [sym_argument_list] = STATE(2939),
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2915),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(3540),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3621),
    [sym_preproc_endregion] = STATE(3621),
    [sym_preproc_line] = STATE(3621),
    [sym_preproc_pragma] = STATE(3621),
    [sym_preproc_nullable] = STATE(3621),
    [sym_preproc_error] = STATE(3621),
    [sym_preproc_warning] = STATE(3621),
    [sym_preproc_define] = STATE(3621),
    [sym_preproc_undef] = STATE(3621),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_ref] = ACTIONS(4253),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5786),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3622] = {
    [sym_argument_list] = STATE(3216),
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3176),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3269),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3622),
    [sym_preproc_endregion] = STATE(3622),
    [sym_preproc_line] = STATE(3622),
    [sym_preproc_pragma] = STATE(3622),
    [sym_preproc_nullable] = STATE(3622),
    [sym_preproc_error] = STATE(3622),
    [sym_preproc_warning] = STATE(3622),
    [sym_preproc_define] = STATE(3622),
    [sym_preproc_undef] = STATE(3622),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_ref] = ACTIONS(4217),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5788),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3623] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6874),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3623),
    [sym_preproc_endregion] = STATE(3623),
    [sym_preproc_line] = STATE(3623),
    [sym_preproc_pragma] = STATE(3623),
    [sym_preproc_nullable] = STATE(3623),
    [sym_preproc_error] = STATE(3623),
    [sym_preproc_warning] = STATE(3623),
    [sym_preproc_define] = STATE(3623),
    [sym_preproc_undef] = STATE(3623),
    [aux_sym_type_argument_list_repeat1] = STATE(6877),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5790),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3624] = {
    [sym_argument_list] = STATE(3216),
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3176),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3269),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3624),
    [sym_preproc_endregion] = STATE(3624),
    [sym_preproc_line] = STATE(3624),
    [sym_preproc_pragma] = STATE(3624),
    [sym_preproc_nullable] = STATE(3624),
    [sym_preproc_error] = STATE(3624),
    [sym_preproc_warning] = STATE(3624),
    [sym_preproc_define] = STATE(3624),
    [sym_preproc_undef] = STATE(3624),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_ref] = ACTIONS(4223),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5792),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3625] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3625),
    [sym_preproc_endregion] = STATE(3625),
    [sym_preproc_line] = STATE(3625),
    [sym_preproc_pragma] = STATE(3625),
    [sym_preproc_nullable] = STATE(3625),
    [sym_preproc_error] = STATE(3625),
    [sym_preproc_warning] = STATE(3625),
    [sym_preproc_define] = STATE(3625),
    [sym_preproc_undef] = STATE(3625),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5794),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5794),
    [anon_sym_or] = ACTIONS(5810),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5794),
    [anon_sym_into] = ACTIONS(5794),
    [anon_sym_join] = ACTIONS(5794),
    [anon_sym_let] = ACTIONS(5794),
    [anon_sym_orderby] = ACTIONS(5794),
    [anon_sym_ascending] = ACTIONS(5794),
    [anon_sym_descending] = ACTIONS(5794),
    [anon_sym_group] = ACTIONS(5794),
    [anon_sym_select] = ACTIONS(5794),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3626] = {
    [sym_preproc_region] = STATE(3626),
    [sym_preproc_endregion] = STATE(3626),
    [sym_preproc_line] = STATE(3626),
    [sym_preproc_pragma] = STATE(3626),
    [sym_preproc_nullable] = STATE(3626),
    [sym_preproc_error] = STATE(3626),
    [sym_preproc_warning] = STATE(3626),
    [sym_preproc_define] = STATE(3626),
    [sym_preproc_undef] = STATE(3626),
    [anon_sym_EQ] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5824),
    [anon_sym_DASH_EQ] = ACTIONS(5824),
    [anon_sym_STAR_EQ] = ACTIONS(5824),
    [anon_sym_SLASH_EQ] = ACTIONS(5824),
    [anon_sym_PERCENT_EQ] = ACTIONS(5824),
    [anon_sym_AMP_EQ] = ACTIONS(5824),
    [anon_sym_CARET_EQ] = ACTIONS(5824),
    [anon_sym_PIPE_EQ] = ACTIONS(5824),
    [anon_sym_LT_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT_GT_EQ] = ACTIONS(5824),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5824),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3627] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3627),
    [sym_preproc_endregion] = STATE(3627),
    [sym_preproc_line] = STATE(3627),
    [sym_preproc_pragma] = STATE(3627),
    [sym_preproc_nullable] = STATE(3627),
    [sym_preproc_error] = STATE(3627),
    [sym_preproc_warning] = STATE(3627),
    [sym_preproc_define] = STATE(3627),
    [sym_preproc_undef] = STATE(3627),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(4265),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5826),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3628] = {
    [sym_argument_list] = STATE(3172),
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3168),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3187),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3628),
    [sym_preproc_endregion] = STATE(3628),
    [sym_preproc_line] = STATE(3628),
    [sym_preproc_pragma] = STATE(3628),
    [sym_preproc_nullable] = STATE(3628),
    [sym_preproc_error] = STATE(3628),
    [sym_preproc_warning] = STATE(3628),
    [sym_preproc_define] = STATE(3628),
    [sym_preproc_undef] = STATE(3628),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5754),
    [anon_sym_ref] = ACTIONS(4237),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5828),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3629] = {
    [sym_argument_list] = STATE(3172),
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3168),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3187),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3629),
    [sym_preproc_endregion] = STATE(3629),
    [sym_preproc_line] = STATE(3629),
    [sym_preproc_pragma] = STATE(3629),
    [sym_preproc_nullable] = STATE(3629),
    [sym_preproc_error] = STATE(3629),
    [sym_preproc_warning] = STATE(3629),
    [sym_preproc_define] = STATE(3629),
    [sym_preproc_undef] = STATE(3629),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5754),
    [anon_sym_ref] = ACTIONS(4229),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5830),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3630] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3630),
    [sym_preproc_endregion] = STATE(3630),
    [sym_preproc_line] = STATE(3630),
    [sym_preproc_pragma] = STATE(3630),
    [sym_preproc_nullable] = STATE(3630),
    [sym_preproc_error] = STATE(3630),
    [sym_preproc_warning] = STATE(3630),
    [sym_preproc_define] = STATE(3630),
    [sym_preproc_undef] = STATE(3630),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(4879),
    [anon_sym_GT] = ACTIONS(4879),
    [anon_sym_where] = ACTIONS(4875),
    [anon_sym_QMARK] = ACTIONS(4879),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4875),
    [anon_sym_SLASH] = ACTIONS(4879),
    [anon_sym_PERCENT] = ACTIONS(4875),
    [anon_sym_CARET] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4879),
    [anon_sym_AMP] = ACTIONS(4879),
    [anon_sym_LT_LT] = ACTIONS(4875),
    [anon_sym_GT_GT] = ACTIONS(4879),
    [anon_sym_GT_GT_GT] = ACTIONS(4875),
    [anon_sym_EQ_EQ] = ACTIONS(4875),
    [anon_sym_BANG_EQ] = ACTIONS(4875),
    [anon_sym_GT_EQ] = ACTIONS(4875),
    [anon_sym_LT_EQ] = ACTIONS(4875),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(4875),
    [anon_sym_DOT_DOT] = ACTIONS(4875),
    [anon_sym_and] = ACTIONS(4875),
    [anon_sym_or] = ACTIONS(4879),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_PIPE_PIPE] = ACTIONS(4875),
    [anon_sym_QMARK_QMARK] = ACTIONS(4875),
    [anon_sym_from] = ACTIONS(4875),
    [anon_sym_into] = ACTIONS(4875),
    [anon_sym_join] = ACTIONS(4875),
    [anon_sym_let] = ACTIONS(4875),
    [anon_sym_orderby] = ACTIONS(4875),
    [anon_sym_ascending] = ACTIONS(4875),
    [anon_sym_descending] = ACTIONS(4875),
    [anon_sym_group] = ACTIONS(4875),
    [anon_sym_select] = ACTIONS(4875),
    [anon_sym_as] = ACTIONS(4879),
    [anon_sym_is] = ACTIONS(4875),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4875),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3631] = {
    [sym_argument_list] = STATE(3172),
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3168),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3187),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3631),
    [sym_preproc_endregion] = STATE(3631),
    [sym_preproc_line] = STATE(3631),
    [sym_preproc_pragma] = STATE(3631),
    [sym_preproc_nullable] = STATE(3631),
    [sym_preproc_error] = STATE(3631),
    [sym_preproc_warning] = STATE(3631),
    [sym_preproc_define] = STATE(3631),
    [sym_preproc_undef] = STATE(3631),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5754),
    [anon_sym_ref] = ACTIONS(4180),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5832),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3632] = {
    [sym_argument_list] = STATE(3216),
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3176),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3269),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3632),
    [sym_preproc_endregion] = STATE(3632),
    [sym_preproc_line] = STATE(3632),
    [sym_preproc_pragma] = STATE(3632),
    [sym_preproc_nullable] = STATE(3632),
    [sym_preproc_error] = STATE(3632),
    [sym_preproc_warning] = STATE(3632),
    [sym_preproc_define] = STATE(3632),
    [sym_preproc_undef] = STATE(3632),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_ref] = ACTIONS(4081),
    [anon_sym_LBRACE] = ACTIONS(5710),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5834),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3633] = {
    [sym_preproc_region] = STATE(3633),
    [sym_preproc_endregion] = STATE(3633),
    [sym_preproc_line] = STATE(3633),
    [sym_preproc_pragma] = STATE(3633),
    [sym_preproc_nullable] = STATE(3633),
    [sym_preproc_error] = STATE(3633),
    [sym_preproc_warning] = STATE(3633),
    [sym_preproc_define] = STATE(3633),
    [sym_preproc_undef] = STATE(3633),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5836),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3634] = {
    [sym_preproc_region] = STATE(3634),
    [sym_preproc_endregion] = STATE(3634),
    [sym_preproc_line] = STATE(3634),
    [sym_preproc_pragma] = STATE(3634),
    [sym_preproc_nullable] = STATE(3634),
    [sym_preproc_error] = STATE(3634),
    [sym_preproc_warning] = STATE(3634),
    [sym_preproc_define] = STATE(3634),
    [sym_preproc_undef] = STATE(3634),
    [anon_sym_EQ] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5840),
    [anon_sym_DASH_EQ] = ACTIONS(5840),
    [anon_sym_STAR_EQ] = ACTIONS(5840),
    [anon_sym_SLASH_EQ] = ACTIONS(5840),
    [anon_sym_PERCENT_EQ] = ACTIONS(5840),
    [anon_sym_AMP_EQ] = ACTIONS(5840),
    [anon_sym_CARET_EQ] = ACTIONS(5840),
    [anon_sym_PIPE_EQ] = ACTIONS(5840),
    [anon_sym_LT_LT_EQ] = ACTIONS(5840),
    [anon_sym_GT_GT_EQ] = ACTIONS(5840),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5840),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5840),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3635] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6948),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3635),
    [sym_preproc_endregion] = STATE(3635),
    [sym_preproc_line] = STATE(3635),
    [sym_preproc_pragma] = STATE(3635),
    [sym_preproc_nullable] = STATE(3635),
    [sym_preproc_error] = STATE(3635),
    [sym_preproc_warning] = STATE(3635),
    [sym_preproc_define] = STATE(3635),
    [sym_preproc_undef] = STATE(3635),
    [aux_sym_type_argument_list_repeat1] = STATE(6949),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3636] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3636),
    [sym_preproc_endregion] = STATE(3636),
    [sym_preproc_line] = STATE(3636),
    [sym_preproc_pragma] = STATE(3636),
    [sym_preproc_nullable] = STATE(3636),
    [sym_preproc_error] = STATE(3636),
    [sym_preproc_warning] = STATE(3636),
    [sym_preproc_define] = STATE(3636),
    [sym_preproc_undef] = STATE(3636),
    [aux_sym_type_argument_list_repeat1] = STATE(6980),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5844),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3637] = {
    [sym_preproc_region] = STATE(3637),
    [sym_preproc_endregion] = STATE(3637),
    [sym_preproc_line] = STATE(3637),
    [sym_preproc_pragma] = STATE(3637),
    [sym_preproc_nullable] = STATE(3637),
    [sym_preproc_error] = STATE(3637),
    [sym_preproc_warning] = STATE(3637),
    [sym_preproc_define] = STATE(3637),
    [sym_preproc_undef] = STATE(3637),
    [sym__identifier_token] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_alias] = ACTIONS(4743),
    [anon_sym_global] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4745),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_ref] = ACTIONS(4743),
    [anon_sym_delegate] = ACTIONS(4743),
    [anon_sym_abstract] = ACTIONS(4743),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_file] = ACTIONS(4743),
    [anon_sym_fixed] = ACTIONS(4743),
    [anon_sym_internal] = ACTIONS(4743),
    [anon_sym_new] = ACTIONS(4743),
    [anon_sym_override] = ACTIONS(4743),
    [anon_sym_partial] = ACTIONS(4743),
    [anon_sym_private] = ACTIONS(4743),
    [anon_sym_protected] = ACTIONS(4743),
    [anon_sym_public] = ACTIONS(4743),
    [anon_sym_readonly] = ACTIONS(4743),
    [anon_sym_required] = ACTIONS(4743),
    [anon_sym_sealed] = ACTIONS(4743),
    [anon_sym_virtual] = ACTIONS(4743),
    [anon_sym_volatile] = ACTIONS(4743),
    [anon_sym_where] = ACTIONS(4743),
    [anon_sym_notnull] = ACTIONS(4743),
    [anon_sym_unmanaged] = ACTIONS(4743),
    [anon_sym_scoped] = ACTIONS(4743),
    [anon_sym_var] = ACTIONS(4743),
    [sym_predefined_type] = ACTIONS(4743),
    [anon_sym_yield] = ACTIONS(4743),
    [anon_sym_when] = ACTIONS(4743),
    [anon_sym_from] = ACTIONS(4743),
    [anon_sym_into] = ACTIONS(4743),
    [anon_sym_join] = ACTIONS(4743),
    [anon_sym_on] = ACTIONS(4743),
    [anon_sym_equals] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_orderby] = ACTIONS(4743),
    [anon_sym_ascending] = ACTIONS(4743),
    [anon_sym_descending] = ACTIONS(4743),
    [anon_sym_group] = ACTIONS(4743),
    [anon_sym_by] = ACTIONS(4743),
    [anon_sym_select] = ACTIONS(4743),
    [aux_sym_preproc_if_token1] = ACTIONS(4745),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3638] = {
    [sym_preproc_region] = STATE(3638),
    [sym_preproc_endregion] = STATE(3638),
    [sym_preproc_line] = STATE(3638),
    [sym_preproc_pragma] = STATE(3638),
    [sym_preproc_nullable] = STATE(3638),
    [sym_preproc_error] = STATE(3638),
    [sym_preproc_warning] = STATE(3638),
    [sym_preproc_define] = STATE(3638),
    [sym_preproc_undef] = STATE(3638),
    [anon_sym_EQ] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5848),
    [anon_sym_DASH_EQ] = ACTIONS(5848),
    [anon_sym_STAR_EQ] = ACTIONS(5848),
    [anon_sym_SLASH_EQ] = ACTIONS(5848),
    [anon_sym_PERCENT_EQ] = ACTIONS(5848),
    [anon_sym_AMP_EQ] = ACTIONS(5848),
    [anon_sym_CARET_EQ] = ACTIONS(5848),
    [anon_sym_PIPE_EQ] = ACTIONS(5848),
    [anon_sym_LT_LT_EQ] = ACTIONS(5848),
    [anon_sym_GT_GT_EQ] = ACTIONS(5848),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5848),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5848),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3639] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3639),
    [sym_preproc_endregion] = STATE(3639),
    [sym_preproc_line] = STATE(3639),
    [sym_preproc_pragma] = STATE(3639),
    [sym_preproc_nullable] = STATE(3639),
    [sym_preproc_error] = STATE(3639),
    [sym_preproc_warning] = STATE(3639),
    [sym_preproc_define] = STATE(3639),
    [sym_preproc_undef] = STATE(3639),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5850),
    [anon_sym_into] = ACTIONS(5850),
    [anon_sym_join] = ACTIONS(5850),
    [anon_sym_let] = ACTIONS(5850),
    [anon_sym_orderby] = ACTIONS(5850),
    [anon_sym_ascending] = ACTIONS(5850),
    [anon_sym_descending] = ACTIONS(5850),
    [anon_sym_group] = ACTIONS(5850),
    [anon_sym_select] = ACTIONS(5850),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3640] = {
    [sym_block] = STATE(1986),
    [sym_preproc_region] = STATE(3640),
    [sym_preproc_endregion] = STATE(3640),
    [sym_preproc_line] = STATE(3640),
    [sym_preproc_pragma] = STATE(3640),
    [sym_preproc_nullable] = STATE(3640),
    [sym_preproc_error] = STATE(3640),
    [sym_preproc_warning] = STATE(3640),
    [sym_preproc_define] = STATE(3640),
    [sym_preproc_undef] = STATE(3640),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(5327),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3641] = {
    [sym_preproc_region] = STATE(3641),
    [sym_preproc_endregion] = STATE(3641),
    [sym_preproc_line] = STATE(3641),
    [sym_preproc_pragma] = STATE(3641),
    [sym_preproc_nullable] = STATE(3641),
    [sym_preproc_error] = STATE(3641),
    [sym_preproc_warning] = STATE(3641),
    [sym_preproc_define] = STATE(3641),
    [sym_preproc_undef] = STATE(3641),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3642] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3642),
    [sym_preproc_endregion] = STATE(3642),
    [sym_preproc_line] = STATE(3642),
    [sym_preproc_pragma] = STATE(3642),
    [sym_preproc_nullable] = STATE(3642),
    [sym_preproc_error] = STATE(3642),
    [sym_preproc_warning] = STATE(3642),
    [sym_preproc_define] = STATE(3642),
    [sym_preproc_undef] = STATE(3642),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5858),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3643] = {
    [sym_preproc_region] = STATE(3643),
    [sym_preproc_endregion] = STATE(3643),
    [sym_preproc_line] = STATE(3643),
    [sym_preproc_pragma] = STATE(3643),
    [sym_preproc_nullable] = STATE(3643),
    [sym_preproc_error] = STATE(3643),
    [sym_preproc_warning] = STATE(3643),
    [sym_preproc_define] = STATE(3643),
    [sym_preproc_undef] = STATE(3643),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3644] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7004),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3644),
    [sym_preproc_endregion] = STATE(3644),
    [sym_preproc_line] = STATE(3644),
    [sym_preproc_pragma] = STATE(3644),
    [sym_preproc_nullable] = STATE(3644),
    [sym_preproc_error] = STATE(3644),
    [sym_preproc_warning] = STATE(3644),
    [sym_preproc_define] = STATE(3644),
    [sym_preproc_undef] = STATE(3644),
    [aux_sym_type_argument_list_repeat1] = STATE(7005),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3645] = {
    [sym_preproc_region] = STATE(3645),
    [sym_preproc_endregion] = STATE(3645),
    [sym_preproc_line] = STATE(3645),
    [sym_preproc_pragma] = STATE(3645),
    [sym_preproc_nullable] = STATE(3645),
    [sym_preproc_error] = STATE(3645),
    [sym_preproc_warning] = STATE(3645),
    [sym_preproc_define] = STATE(3645),
    [sym_preproc_undef] = STATE(3645),
    [sym__identifier_token] = ACTIONS(5101),
    [anon_sym_extern] = ACTIONS(5101),
    [anon_sym_alias] = ACTIONS(5101),
    [anon_sym_global] = ACTIONS(5101),
    [anon_sym_unsafe] = ACTIONS(5101),
    [anon_sym_static] = ACTIONS(5101),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_ref] = ACTIONS(5101),
    [anon_sym_delegate] = ACTIONS(5101),
    [anon_sym_abstract] = ACTIONS(5101),
    [anon_sym_async] = ACTIONS(5101),
    [anon_sym_const] = ACTIONS(5101),
    [anon_sym_file] = ACTIONS(5101),
    [anon_sym_fixed] = ACTIONS(5101),
    [anon_sym_internal] = ACTIONS(5101),
    [anon_sym_new] = ACTIONS(5101),
    [anon_sym_override] = ACTIONS(5101),
    [anon_sym_partial] = ACTIONS(5101),
    [anon_sym_private] = ACTIONS(5101),
    [anon_sym_protected] = ACTIONS(5101),
    [anon_sym_public] = ACTIONS(5101),
    [anon_sym_readonly] = ACTIONS(5101),
    [anon_sym_required] = ACTIONS(5101),
    [anon_sym_sealed] = ACTIONS(5101),
    [anon_sym_virtual] = ACTIONS(5101),
    [anon_sym_volatile] = ACTIONS(5101),
    [anon_sym_where] = ACTIONS(5101),
    [anon_sym_notnull] = ACTIONS(5101),
    [anon_sym_unmanaged] = ACTIONS(5101),
    [anon_sym_scoped] = ACTIONS(5101),
    [anon_sym_var] = ACTIONS(5101),
    [sym_predefined_type] = ACTIONS(5101),
    [anon_sym_yield] = ACTIONS(5101),
    [anon_sym_when] = ACTIONS(5101),
    [anon_sym_from] = ACTIONS(5101),
    [anon_sym_into] = ACTIONS(5101),
    [anon_sym_join] = ACTIONS(5101),
    [anon_sym_on] = ACTIONS(5101),
    [anon_sym_equals] = ACTIONS(5101),
    [anon_sym_let] = ACTIONS(5101),
    [anon_sym_orderby] = ACTIONS(5101),
    [anon_sym_ascending] = ACTIONS(5101),
    [anon_sym_descending] = ACTIONS(5101),
    [anon_sym_group] = ACTIONS(5101),
    [anon_sym_by] = ACTIONS(5101),
    [anon_sym_select] = ACTIONS(5101),
    [aux_sym_preproc_if_token1] = ACTIONS(5103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3646] = {
    [sym_argument_list] = STATE(2939),
    [sym__name] = STATE(4107),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2915),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(4094),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3646),
    [sym_preproc_endregion] = STATE(3646),
    [sym_preproc_line] = STATE(3646),
    [sym_preproc_pragma] = STATE(3646),
    [sym_preproc_nullable] = STATE(3646),
    [sym_preproc_error] = STATE(3646),
    [sym_preproc_warning] = STATE(3646),
    [sym_preproc_define] = STATE(3646),
    [sym_preproc_undef] = STATE(3646),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_ref] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5864),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3647] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3647),
    [sym_preproc_endregion] = STATE(3647),
    [sym_preproc_line] = STATE(3647),
    [sym_preproc_pragma] = STATE(3647),
    [sym_preproc_nullable] = STATE(3647),
    [sym_preproc_error] = STATE(3647),
    [sym_preproc_warning] = STATE(3647),
    [sym_preproc_define] = STATE(3647),
    [sym_preproc_undef] = STATE(3647),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5866),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5866),
    [anon_sym_or] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5866),
    [anon_sym_into] = ACTIONS(5866),
    [anon_sym_join] = ACTIONS(5866),
    [anon_sym_let] = ACTIONS(5866),
    [anon_sym_orderby] = ACTIONS(5866),
    [anon_sym_ascending] = ACTIONS(5866),
    [anon_sym_descending] = ACTIONS(5866),
    [anon_sym_group] = ACTIONS(5866),
    [anon_sym_select] = ACTIONS(5866),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3648] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3648),
    [sym_preproc_endregion] = STATE(3648),
    [sym_preproc_line] = STATE(3648),
    [sym_preproc_pragma] = STATE(3648),
    [sym_preproc_nullable] = STATE(3648),
    [sym_preproc_error] = STATE(3648),
    [sym_preproc_warning] = STATE(3648),
    [sym_preproc_define] = STATE(3648),
    [sym_preproc_undef] = STATE(3648),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5870),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5870),
    [anon_sym_into] = ACTIONS(5870),
    [anon_sym_join] = ACTIONS(5870),
    [anon_sym_let] = ACTIONS(5870),
    [anon_sym_orderby] = ACTIONS(5870),
    [anon_sym_ascending] = ACTIONS(5870),
    [anon_sym_descending] = ACTIONS(5870),
    [anon_sym_group] = ACTIONS(5870),
    [anon_sym_select] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3649] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3649),
    [sym_preproc_endregion] = STATE(3649),
    [sym_preproc_line] = STATE(3649),
    [sym_preproc_pragma] = STATE(3649),
    [sym_preproc_nullable] = STATE(3649),
    [sym_preproc_error] = STATE(3649),
    [sym_preproc_warning] = STATE(3649),
    [sym_preproc_define] = STATE(3649),
    [sym_preproc_undef] = STATE(3649),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5238),
    [anon_sym_into] = ACTIONS(5238),
    [anon_sym_join] = ACTIONS(5238),
    [anon_sym_let] = ACTIONS(5238),
    [anon_sym_orderby] = ACTIONS(5238),
    [anon_sym_ascending] = ACTIONS(5238),
    [anon_sym_descending] = ACTIONS(5238),
    [anon_sym_group] = ACTIONS(5238),
    [anon_sym_select] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3650] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3650),
    [sym_preproc_endregion] = STATE(3650),
    [sym_preproc_line] = STATE(3650),
    [sym_preproc_pragma] = STATE(3650),
    [sym_preproc_nullable] = STATE(3650),
    [sym_preproc_error] = STATE(3650),
    [sym_preproc_warning] = STATE(3650),
    [sym_preproc_define] = STATE(3650),
    [sym_preproc_undef] = STATE(3650),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5874),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5874),
    [anon_sym_or] = ACTIONS(5876),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5874),
    [anon_sym_into] = ACTIONS(5874),
    [anon_sym_join] = ACTIONS(5874),
    [anon_sym_let] = ACTIONS(5874),
    [anon_sym_orderby] = ACTIONS(5874),
    [anon_sym_ascending] = ACTIONS(5874),
    [anon_sym_descending] = ACTIONS(5874),
    [anon_sym_group] = ACTIONS(5874),
    [anon_sym_select] = ACTIONS(5874),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3651] = {
    [sym_preproc_region] = STATE(3651),
    [sym_preproc_endregion] = STATE(3651),
    [sym_preproc_line] = STATE(3651),
    [sym_preproc_pragma] = STATE(3651),
    [sym_preproc_nullable] = STATE(3651),
    [sym_preproc_error] = STATE(3651),
    [sym_preproc_warning] = STATE(3651),
    [sym_preproc_define] = STATE(3651),
    [sym_preproc_undef] = STATE(3651),
    [sym__identifier_token] = ACTIONS(4807),
    [anon_sym_extern] = ACTIONS(4807),
    [anon_sym_alias] = ACTIONS(4807),
    [anon_sym_global] = ACTIONS(4807),
    [anon_sym_unsafe] = ACTIONS(4807),
    [anon_sym_static] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4809),
    [anon_sym_LPAREN] = ACTIONS(4809),
    [anon_sym_ref] = ACTIONS(4807),
    [anon_sym_delegate] = ACTIONS(4807),
    [anon_sym_abstract] = ACTIONS(4807),
    [anon_sym_async] = ACTIONS(4807),
    [anon_sym_const] = ACTIONS(4807),
    [anon_sym_file] = ACTIONS(4807),
    [anon_sym_fixed] = ACTIONS(4807),
    [anon_sym_internal] = ACTIONS(4807),
    [anon_sym_new] = ACTIONS(4807),
    [anon_sym_override] = ACTIONS(4807),
    [anon_sym_partial] = ACTIONS(4807),
    [anon_sym_private] = ACTIONS(4807),
    [anon_sym_protected] = ACTIONS(4807),
    [anon_sym_public] = ACTIONS(4807),
    [anon_sym_readonly] = ACTIONS(4807),
    [anon_sym_required] = ACTIONS(4807),
    [anon_sym_sealed] = ACTIONS(4807),
    [anon_sym_virtual] = ACTIONS(4807),
    [anon_sym_volatile] = ACTIONS(4807),
    [anon_sym_where] = ACTIONS(4807),
    [anon_sym_notnull] = ACTIONS(4807),
    [anon_sym_unmanaged] = ACTIONS(4807),
    [anon_sym_scoped] = ACTIONS(4807),
    [anon_sym_var] = ACTIONS(4807),
    [sym_predefined_type] = ACTIONS(4807),
    [anon_sym_yield] = ACTIONS(4807),
    [anon_sym_when] = ACTIONS(4807),
    [anon_sym_from] = ACTIONS(4807),
    [anon_sym_into] = ACTIONS(4807),
    [anon_sym_join] = ACTIONS(4807),
    [anon_sym_on] = ACTIONS(4807),
    [anon_sym_equals] = ACTIONS(4807),
    [anon_sym_let] = ACTIONS(4807),
    [anon_sym_orderby] = ACTIONS(4807),
    [anon_sym_ascending] = ACTIONS(4807),
    [anon_sym_descending] = ACTIONS(4807),
    [anon_sym_group] = ACTIONS(4807),
    [anon_sym_by] = ACTIONS(4807),
    [anon_sym_select] = ACTIONS(4807),
    [aux_sym_preproc_if_token1] = ACTIONS(4809),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3652] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(4377),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3652),
    [sym_preproc_endregion] = STATE(3652),
    [sym_preproc_line] = STATE(3652),
    [sym_preproc_pragma] = STATE(3652),
    [sym_preproc_nullable] = STATE(3652),
    [sym_preproc_error] = STATE(3652),
    [sym_preproc_warning] = STATE(3652),
    [sym_preproc_define] = STATE(3652),
    [sym_preproc_undef] = STATE(3652),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3653] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3653),
    [sym_preproc_endregion] = STATE(3653),
    [sym_preproc_line] = STATE(3653),
    [sym_preproc_pragma] = STATE(3653),
    [sym_preproc_nullable] = STATE(3653),
    [sym_preproc_error] = STATE(3653),
    [sym_preproc_warning] = STATE(3653),
    [sym_preproc_define] = STATE(3653),
    [sym_preproc_undef] = STATE(3653),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3654] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3654),
    [sym_preproc_endregion] = STATE(3654),
    [sym_preproc_line] = STATE(3654),
    [sym_preproc_pragma] = STATE(3654),
    [sym_preproc_nullable] = STATE(3654),
    [sym_preproc_error] = STATE(3654),
    [sym_preproc_warning] = STATE(3654),
    [sym_preproc_define] = STATE(3654),
    [sym_preproc_undef] = STATE(3654),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3655] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3655),
    [sym_preproc_endregion] = STATE(3655),
    [sym_preproc_line] = STATE(3655),
    [sym_preproc_pragma] = STATE(3655),
    [sym_preproc_nullable] = STATE(3655),
    [sym_preproc_error] = STATE(3655),
    [sym_preproc_warning] = STATE(3655),
    [sym_preproc_define] = STATE(3655),
    [sym_preproc_undef] = STATE(3655),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5878),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5878),
    [anon_sym_or] = ACTIONS(5880),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5878),
    [anon_sym_into] = ACTIONS(5878),
    [anon_sym_join] = ACTIONS(5878),
    [anon_sym_let] = ACTIONS(5878),
    [anon_sym_orderby] = ACTIONS(5878),
    [anon_sym_ascending] = ACTIONS(5878),
    [anon_sym_descending] = ACTIONS(5878),
    [anon_sym_group] = ACTIONS(5878),
    [anon_sym_select] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3656] = {
    [sym_argument_list] = STATE(2939),
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2915),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(3540),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3656),
    [sym_preproc_endregion] = STATE(3656),
    [sym_preproc_line] = STATE(3656),
    [sym_preproc_pragma] = STATE(3656),
    [sym_preproc_nullable] = STATE(3656),
    [sym_preproc_error] = STATE(3656),
    [sym_preproc_warning] = STATE(3656),
    [sym_preproc_define] = STATE(3656),
    [sym_preproc_undef] = STATE(3656),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_ref] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5882),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3657] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3657),
    [sym_preproc_endregion] = STATE(3657),
    [sym_preproc_line] = STATE(3657),
    [sym_preproc_pragma] = STATE(3657),
    [sym_preproc_nullable] = STATE(3657),
    [sym_preproc_error] = STATE(3657),
    [sym_preproc_warning] = STATE(3657),
    [sym_preproc_define] = STATE(3657),
    [sym_preproc_undef] = STATE(3657),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3658] = {
    [sym_preproc_region] = STATE(3658),
    [sym_preproc_endregion] = STATE(3658),
    [sym_preproc_line] = STATE(3658),
    [sym_preproc_pragma] = STATE(3658),
    [sym_preproc_nullable] = STATE(3658),
    [sym_preproc_error] = STATE(3658),
    [sym_preproc_warning] = STATE(3658),
    [sym_preproc_define] = STATE(3658),
    [sym_preproc_undef] = STATE(3658),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3659] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3659),
    [sym_preproc_endregion] = STATE(3659),
    [sym_preproc_line] = STATE(3659),
    [sym_preproc_pragma] = STATE(3659),
    [sym_preproc_nullable] = STATE(3659),
    [sym_preproc_error] = STATE(3659),
    [sym_preproc_warning] = STATE(3659),
    [sym_preproc_define] = STATE(3659),
    [sym_preproc_undef] = STATE(3659),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5886),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5888),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5886),
    [anon_sym_into] = ACTIONS(5886),
    [anon_sym_join] = ACTIONS(5886),
    [anon_sym_let] = ACTIONS(5886),
    [anon_sym_orderby] = ACTIONS(5886),
    [anon_sym_ascending] = ACTIONS(5886),
    [anon_sym_descending] = ACTIONS(5886),
    [anon_sym_group] = ACTIONS(5886),
    [anon_sym_select] = ACTIONS(5886),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3660] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(4951),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(4435),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3660),
    [sym_preproc_endregion] = STATE(3660),
    [sym_preproc_line] = STATE(3660),
    [sym_preproc_pragma] = STATE(3660),
    [sym_preproc_nullable] = STATE(3660),
    [sym_preproc_error] = STATE(3660),
    [sym_preproc_warning] = STATE(3660),
    [sym_preproc_define] = STATE(3660),
    [sym_preproc_undef] = STATE(3660),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(4060),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5890),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3661] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3661),
    [sym_preproc_endregion] = STATE(3661),
    [sym_preproc_line] = STATE(3661),
    [sym_preproc_pragma] = STATE(3661),
    [sym_preproc_nullable] = STATE(3661),
    [sym_preproc_error] = STATE(3661),
    [sym_preproc_warning] = STATE(3661),
    [sym_preproc_define] = STATE(3661),
    [sym_preproc_undef] = STATE(3661),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3662] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3662),
    [sym_preproc_endregion] = STATE(3662),
    [sym_preproc_line] = STATE(3662),
    [sym_preproc_pragma] = STATE(3662),
    [sym_preproc_nullable] = STATE(3662),
    [sym_preproc_error] = STATE(3662),
    [sym_preproc_warning] = STATE(3662),
    [sym_preproc_define] = STATE(3662),
    [sym_preproc_undef] = STATE(3662),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3663] = {
    [sym_argument_list] = STATE(3616),
    [sym__name] = STATE(2450),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_type] = STATE(3583),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(3610),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(3663),
    [sym_preproc_endregion] = STATE(3663),
    [sym_preproc_line] = STATE(3663),
    [sym_preproc_pragma] = STATE(3663),
    [sym_preproc_nullable] = STATE(3663),
    [sym_preproc_error] = STATE(3663),
    [sym_preproc_warning] = STATE(3663),
    [sym_preproc_define] = STATE(3663),
    [sym_preproc_undef] = STATE(3663),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(5894),
    [anon_sym_ref] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_scoped] = ACTIONS(5898),
    [anon_sym_var] = ACTIONS(5900),
    [sym_predefined_type] = ACTIONS(5902),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3664] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3664),
    [sym_preproc_endregion] = STATE(3664),
    [sym_preproc_line] = STATE(3664),
    [sym_preproc_pragma] = STATE(3664),
    [sym_preproc_nullable] = STATE(3664),
    [sym_preproc_error] = STATE(3664),
    [sym_preproc_warning] = STATE(3664),
    [sym_preproc_define] = STATE(3664),
    [sym_preproc_undef] = STATE(3664),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3665] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7018),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3665),
    [sym_preproc_endregion] = STATE(3665),
    [sym_preproc_line] = STATE(3665),
    [sym_preproc_pragma] = STATE(3665),
    [sym_preproc_nullable] = STATE(3665),
    [sym_preproc_error] = STATE(3665),
    [sym_preproc_warning] = STATE(3665),
    [sym_preproc_define] = STATE(3665),
    [sym_preproc_undef] = STATE(3665),
    [aux_sym_type_argument_list_repeat1] = STATE(7019),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5904),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3666] = {
    [sym_preproc_region] = STATE(3666),
    [sym_preproc_endregion] = STATE(3666),
    [sym_preproc_line] = STATE(3666),
    [sym_preproc_pragma] = STATE(3666),
    [sym_preproc_nullable] = STATE(3666),
    [sym_preproc_error] = STATE(3666),
    [sym_preproc_warning] = STATE(3666),
    [sym_preproc_define] = STATE(3666),
    [sym_preproc_undef] = STATE(3666),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5650),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3667] = {
    [sym_tuple_pattern] = STATE(7084),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_identifier] = STATE(5794),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3667),
    [sym_preproc_endregion] = STATE(3667),
    [sym_preproc_line] = STATE(3667),
    [sym_preproc_pragma] = STATE(3667),
    [sym_preproc_nullable] = STATE(3667),
    [sym_preproc_error] = STATE(3667),
    [sym_preproc_warning] = STATE(3667),
    [sym_preproc_define] = STATE(3667),
    [sym_preproc_undef] = STATE(3667),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(4733),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [sym_discard] = ACTIONS(4739),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3668] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3668),
    [sym_preproc_endregion] = STATE(3668),
    [sym_preproc_line] = STATE(3668),
    [sym_preproc_pragma] = STATE(3668),
    [sym_preproc_nullable] = STATE(3668),
    [sym_preproc_error] = STATE(3668),
    [sym_preproc_warning] = STATE(3668),
    [sym_preproc_define] = STATE(3668),
    [sym_preproc_undef] = STATE(3668),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5796),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_GT_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5816),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3669] = {
    [sym_argument_list] = STATE(3616),
    [sym__name] = STATE(2450),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_type] = STATE(3583),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(3610),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(3669),
    [sym_preproc_endregion] = STATE(3669),
    [sym_preproc_line] = STATE(3669),
    [sym_preproc_pragma] = STATE(3669),
    [sym_preproc_nullable] = STATE(3669),
    [sym_preproc_error] = STATE(3669),
    [sym_preproc_warning] = STATE(3669),
    [sym_preproc_define] = STATE(3669),
    [sym_preproc_undef] = STATE(3669),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(5894),
    [anon_sym_ref] = ACTIONS(4100),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_scoped] = ACTIONS(5908),
    [anon_sym_var] = ACTIONS(5900),
    [sym_predefined_type] = ACTIONS(5902),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3670] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3670),
    [sym_preproc_endregion] = STATE(3670),
    [sym_preproc_line] = STATE(3670),
    [sym_preproc_pragma] = STATE(3670),
    [sym_preproc_nullable] = STATE(3670),
    [sym_preproc_error] = STATE(3670),
    [sym_preproc_warning] = STATE(3670),
    [sym_preproc_define] = STATE(3670),
    [sym_preproc_undef] = STATE(3670),
    [aux_sym_type_argument_list_repeat1] = STATE(6956),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5083),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3671] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(4086),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3671),
    [sym_preproc_endregion] = STATE(3671),
    [sym_preproc_line] = STATE(3671),
    [sym_preproc_pragma] = STATE(3671),
    [sym_preproc_nullable] = STATE(3671),
    [sym_preproc_error] = STATE(3671),
    [sym_preproc_warning] = STATE(3671),
    [sym_preproc_define] = STATE(3671),
    [sym_preproc_undef] = STATE(3671),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(5910),
    [anon_sym_ref] = ACTIONS(4208),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5912),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3672] = {
    [sym_preproc_region] = STATE(3672),
    [sym_preproc_endregion] = STATE(3672),
    [sym_preproc_line] = STATE(3672),
    [sym_preproc_pragma] = STATE(3672),
    [sym_preproc_nullable] = STATE(3672),
    [sym_preproc_error] = STATE(3672),
    [sym_preproc_warning] = STATE(3672),
    [sym_preproc_define] = STATE(3672),
    [sym_preproc_undef] = STATE(3672),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5914),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3673] = {
    [sym_initializer_expression] = STATE(3916),
    [sym_preproc_region] = STATE(3673),
    [sym_preproc_endregion] = STATE(3673),
    [sym_preproc_line] = STATE(3673),
    [sym_preproc_pragma] = STATE(3673),
    [sym_preproc_nullable] = STATE(3673),
    [sym_preproc_error] = STATE(3673),
    [sym_preproc_warning] = STATE(3673),
    [sym_preproc_define] = STATE(3673),
    [sym_preproc_undef] = STATE(3673),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_LPAREN] = ACTIONS(4904),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_where] = ACTIONS(4904),
    [anon_sym_QMARK] = ACTIONS(4906),
    [anon_sym_BANG] = ACTIONS(4906),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_CARET] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_GT_GT_GT] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_switch] = ACTIONS(4904),
    [anon_sym_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_QMARK_QMARK] = ACTIONS(4904),
    [anon_sym_from] = ACTIONS(4904),
    [anon_sym_into] = ACTIONS(4904),
    [anon_sym_join] = ACTIONS(4904),
    [anon_sym_let] = ACTIONS(4904),
    [anon_sym_orderby] = ACTIONS(4904),
    [anon_sym_ascending] = ACTIONS(4904),
    [anon_sym_descending] = ACTIONS(4904),
    [anon_sym_group] = ACTIONS(4904),
    [anon_sym_select] = ACTIONS(4904),
    [anon_sym_as] = ACTIONS(4906),
    [anon_sym_is] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [anon_sym_with] = ACTIONS(4904),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3674] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(7014),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3674),
    [sym_preproc_endregion] = STATE(3674),
    [sym_preproc_line] = STATE(3674),
    [sym_preproc_pragma] = STATE(3674),
    [sym_preproc_nullable] = STATE(3674),
    [sym_preproc_error] = STATE(3674),
    [sym_preproc_warning] = STATE(3674),
    [sym_preproc_define] = STATE(3674),
    [sym_preproc_undef] = STATE(3674),
    [aux_sym_type_argument_list_repeat1] = STATE(7015),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5916),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3675] = {
    [sym_argument_list] = STATE(4353),
    [sym__name] = STATE(4497),
    [sym_alias_qualified_name] = STATE(4398),
    [sym__simple_name] = STATE(4398),
    [sym_qualified_name] = STATE(4398),
    [sym_generic_name] = STATE(4419),
    [sym_type] = STATE(4249),
    [sym_implicit_type] = STATE(4407),
    [sym_array_type] = STATE(4378),
    [sym__array_base_type] = STATE(7286),
    [sym_nullable_type] = STATE(4519),
    [sym_pointer_type] = STATE(4519),
    [sym__pointer_base_type] = STATE(7680),
    [sym_function_pointer_type] = STATE(4519),
    [sym_ref_type] = STATE(4407),
    [sym_scoped_type] = STATE(4407),
    [sym_tuple_type] = STATE(4520),
    [sym_identifier] = STATE(4293),
    [sym__reserved_identifier] = STATE(4388),
    [sym_preproc_region] = STATE(3675),
    [sym_preproc_endregion] = STATE(3675),
    [sym_preproc_line] = STATE(3675),
    [sym_preproc_pragma] = STATE(3675),
    [sym_preproc_nullable] = STATE(3675),
    [sym_preproc_error] = STATE(3675),
    [sym_preproc_warning] = STATE(3675),
    [sym_preproc_define] = STATE(3675),
    [sym_preproc_undef] = STATE(3675),
    [sym__identifier_token] = ACTIONS(4009),
    [anon_sym_alias] = ACTIONS(4011),
    [anon_sym_global] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_LPAREN] = ACTIONS(5728),
    [anon_sym_ref] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_delegate] = ACTIONS(5732),
    [anon_sym_file] = ACTIONS(4011),
    [anon_sym_where] = ACTIONS(4011),
    [anon_sym_notnull] = ACTIONS(4011),
    [anon_sym_unmanaged] = ACTIONS(4011),
    [anon_sym_scoped] = ACTIONS(5918),
    [anon_sym_var] = ACTIONS(5736),
    [sym_predefined_type] = ACTIONS(5738),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_when] = ACTIONS(4011),
    [anon_sym_from] = ACTIONS(4011),
    [anon_sym_into] = ACTIONS(4011),
    [anon_sym_join] = ACTIONS(4011),
    [anon_sym_on] = ACTIONS(4011),
    [anon_sym_equals] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_orderby] = ACTIONS(4011),
    [anon_sym_ascending] = ACTIONS(4011),
    [anon_sym_descending] = ACTIONS(4011),
    [anon_sym_group] = ACTIONS(4011),
    [anon_sym_by] = ACTIONS(4011),
    [anon_sym_select] = ACTIONS(4011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3676] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3676),
    [sym_preproc_endregion] = STATE(3676),
    [sym_preproc_line] = STATE(3676),
    [sym_preproc_pragma] = STATE(3676),
    [sym_preproc_nullable] = STATE(3676),
    [sym_preproc_error] = STATE(3676),
    [sym_preproc_warning] = STATE(3676),
    [sym_preproc_define] = STATE(3676),
    [sym_preproc_undef] = STATE(3676),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3677] = {
    [sym_block] = STATE(2031),
    [sym_preproc_region] = STATE(3677),
    [sym_preproc_endregion] = STATE(3677),
    [sym_preproc_line] = STATE(3677),
    [sym_preproc_pragma] = STATE(3677),
    [sym_preproc_nullable] = STATE(3677),
    [sym_preproc_error] = STATE(3677),
    [sym_preproc_warning] = STATE(3677),
    [sym_preproc_define] = STATE(3677),
    [sym_preproc_undef] = STATE(3677),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3678] = {
    [sym_preproc_region] = STATE(3678),
    [sym_preproc_endregion] = STATE(3678),
    [sym_preproc_line] = STATE(3678),
    [sym_preproc_pragma] = STATE(3678),
    [sym_preproc_nullable] = STATE(3678),
    [sym_preproc_error] = STATE(3678),
    [sym_preproc_warning] = STATE(3678),
    [sym_preproc_define] = STATE(3678),
    [sym_preproc_undef] = STATE(3678),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3679] = {
    [sym_preproc_region] = STATE(3679),
    [sym_preproc_endregion] = STATE(3679),
    [sym_preproc_line] = STATE(3679),
    [sym_preproc_pragma] = STATE(3679),
    [sym_preproc_nullable] = STATE(3679),
    [sym_preproc_error] = STATE(3679),
    [sym_preproc_warning] = STATE(3679),
    [sym_preproc_define] = STATE(3679),
    [sym_preproc_undef] = STATE(3679),
    [sym__identifier_token] = ACTIONS(4833),
    [anon_sym_extern] = ACTIONS(4833),
    [anon_sym_alias] = ACTIONS(4833),
    [anon_sym_global] = ACTIONS(4833),
    [anon_sym_unsafe] = ACTIONS(4833),
    [anon_sym_static] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4835),
    [anon_sym_LPAREN] = ACTIONS(4835),
    [anon_sym_ref] = ACTIONS(4833),
    [anon_sym_delegate] = ACTIONS(4833),
    [anon_sym_abstract] = ACTIONS(4833),
    [anon_sym_async] = ACTIONS(4833),
    [anon_sym_const] = ACTIONS(4833),
    [anon_sym_file] = ACTIONS(4833),
    [anon_sym_fixed] = ACTIONS(4833),
    [anon_sym_internal] = ACTIONS(4833),
    [anon_sym_new] = ACTIONS(4833),
    [anon_sym_override] = ACTIONS(4833),
    [anon_sym_partial] = ACTIONS(4833),
    [anon_sym_private] = ACTIONS(4833),
    [anon_sym_protected] = ACTIONS(4833),
    [anon_sym_public] = ACTIONS(4833),
    [anon_sym_readonly] = ACTIONS(4833),
    [anon_sym_required] = ACTIONS(4833),
    [anon_sym_sealed] = ACTIONS(4833),
    [anon_sym_virtual] = ACTIONS(4833),
    [anon_sym_volatile] = ACTIONS(4833),
    [anon_sym_where] = ACTIONS(4833),
    [anon_sym_notnull] = ACTIONS(4833),
    [anon_sym_unmanaged] = ACTIONS(4833),
    [anon_sym_scoped] = ACTIONS(4833),
    [anon_sym_var] = ACTIONS(4833),
    [sym_predefined_type] = ACTIONS(4833),
    [anon_sym_yield] = ACTIONS(4833),
    [anon_sym_when] = ACTIONS(4833),
    [anon_sym_from] = ACTIONS(4833),
    [anon_sym_into] = ACTIONS(4833),
    [anon_sym_join] = ACTIONS(4833),
    [anon_sym_on] = ACTIONS(4833),
    [anon_sym_equals] = ACTIONS(4833),
    [anon_sym_let] = ACTIONS(4833),
    [anon_sym_orderby] = ACTIONS(4833),
    [anon_sym_ascending] = ACTIONS(4833),
    [anon_sym_descending] = ACTIONS(4833),
    [anon_sym_group] = ACTIONS(4833),
    [anon_sym_by] = ACTIONS(4833),
    [anon_sym_select] = ACTIONS(4833),
    [aux_sym_preproc_if_token1] = ACTIONS(4835),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3680] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3680),
    [sym_preproc_endregion] = STATE(3680),
    [sym_preproc_line] = STATE(3680),
    [sym_preproc_pragma] = STATE(3680),
    [sym_preproc_nullable] = STATE(3680),
    [sym_preproc_error] = STATE(3680),
    [sym_preproc_warning] = STATE(3680),
    [sym_preproc_define] = STATE(3680),
    [sym_preproc_undef] = STATE(3680),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_where] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4910),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_GT_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(4908),
    [anon_sym_DOT_DOT] = ACTIONS(4908),
    [anon_sym_and] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_QMARK_QMARK] = ACTIONS(4908),
    [anon_sym_from] = ACTIONS(4908),
    [anon_sym_into] = ACTIONS(4908),
    [anon_sym_join] = ACTIONS(4908),
    [anon_sym_let] = ACTIONS(4908),
    [anon_sym_orderby] = ACTIONS(4908),
    [anon_sym_ascending] = ACTIONS(4908),
    [anon_sym_descending] = ACTIONS(4908),
    [anon_sym_group] = ACTIONS(4908),
    [anon_sym_select] = ACTIONS(4908),
    [anon_sym_as] = ACTIONS(4910),
    [anon_sym_is] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4908),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3681] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6835),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3681),
    [sym_preproc_endregion] = STATE(3681),
    [sym_preproc_line] = STATE(3681),
    [sym_preproc_pragma] = STATE(3681),
    [sym_preproc_nullable] = STATE(3681),
    [sym_preproc_error] = STATE(3681),
    [sym_preproc_warning] = STATE(3681),
    [sym_preproc_define] = STATE(3681),
    [sym_preproc_undef] = STATE(3681),
    [aux_sym_type_argument_list_repeat1] = STATE(6837),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5922),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3682] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3682),
    [sym_preproc_endregion] = STATE(3682),
    [sym_preproc_line] = STATE(3682),
    [sym_preproc_pragma] = STATE(3682),
    [sym_preproc_nullable] = STATE(3682),
    [sym_preproc_error] = STATE(3682),
    [sym_preproc_warning] = STATE(3682),
    [sym_preproc_define] = STATE(3682),
    [sym_preproc_undef] = STATE(3682),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5924),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5926),
    [anon_sym_where] = ACTIONS(5924),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_SLASH] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_PIPE] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_GT_GT] = ACTIONS(5926),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5924),
    [anon_sym_BANG_EQ] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5924),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_and] = ACTIONS(5924),
    [anon_sym_or] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5924),
    [anon_sym_QMARK_QMARK] = ACTIONS(5924),
    [anon_sym_from] = ACTIONS(5924),
    [anon_sym_into] = ACTIONS(5924),
    [anon_sym_join] = ACTIONS(5924),
    [anon_sym_let] = ACTIONS(5924),
    [anon_sym_orderby] = ACTIONS(5924),
    [anon_sym_ascending] = ACTIONS(5924),
    [anon_sym_descending] = ACTIONS(5924),
    [anon_sym_group] = ACTIONS(5924),
    [anon_sym_select] = ACTIONS(5924),
    [anon_sym_as] = ACTIONS(5926),
    [anon_sym_is] = ACTIONS(5924),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5924),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3683] = {
    [sym_argument_list] = STATE(2939),
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2915),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(3540),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3683),
    [sym_preproc_endregion] = STATE(3683),
    [sym_preproc_line] = STATE(3683),
    [sym_preproc_pragma] = STATE(3683),
    [sym_preproc_nullable] = STATE(3683),
    [sym_preproc_error] = STATE(3683),
    [sym_preproc_warning] = STATE(3683),
    [sym_preproc_define] = STATE(3683),
    [sym_preproc_undef] = STATE(3683),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_ref] = ACTIONS(4255),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5928),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3684] = {
    [sym_identifier] = STATE(7601),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3684),
    [sym_preproc_endregion] = STATE(3684),
    [sym_preproc_line] = STATE(3684),
    [sym_preproc_pragma] = STATE(3684),
    [sym_preproc_nullable] = STATE(3684),
    [sym_preproc_error] = STATE(3684),
    [sym_preproc_warning] = STATE(3684),
    [sym_preproc_define] = STATE(3684),
    [sym_preproc_undef] = STATE(3684),
    [sym__identifier_token] = ACTIONS(5930),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(5934),
    [anon_sym_global] = ACTIONS(5934),
    [anon_sym_unsafe] = ACTIONS(5938),
    [anon_sym_static] = ACTIONS(5938),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(5934),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(5934),
    [anon_sym_notnull] = ACTIONS(5934),
    [anon_sym_unmanaged] = ACTIONS(5934),
    [anon_sym_scoped] = ACTIONS(5934),
    [anon_sym_var] = ACTIONS(5934),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(5934),
    [anon_sym_when] = ACTIONS(5934),
    [anon_sym_from] = ACTIONS(5934),
    [anon_sym_into] = ACTIONS(5934),
    [anon_sym_join] = ACTIONS(5934),
    [anon_sym_on] = ACTIONS(5934),
    [anon_sym_equals] = ACTIONS(5934),
    [anon_sym_let] = ACTIONS(5934),
    [anon_sym_orderby] = ACTIONS(5934),
    [anon_sym_ascending] = ACTIONS(5934),
    [anon_sym_descending] = ACTIONS(5934),
    [anon_sym_group] = ACTIONS(5934),
    [anon_sym_by] = ACTIONS(5934),
    [anon_sym_select] = ACTIONS(5934),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3685] = {
    [sym_identifier] = STATE(7705),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3685),
    [sym_preproc_endregion] = STATE(3685),
    [sym_preproc_line] = STATE(3685),
    [sym_preproc_pragma] = STATE(3685),
    [sym_preproc_nullable] = STATE(3685),
    [sym_preproc_error] = STATE(3685),
    [sym_preproc_warning] = STATE(3685),
    [sym_preproc_define] = STATE(3685),
    [sym_preproc_undef] = STATE(3685),
    [sym__identifier_token] = ACTIONS(5930),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(5934),
    [anon_sym_global] = ACTIONS(5934),
    [anon_sym_unsafe] = ACTIONS(5938),
    [anon_sym_static] = ACTIONS(5938),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(5934),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(5934),
    [anon_sym_notnull] = ACTIONS(5934),
    [anon_sym_unmanaged] = ACTIONS(5934),
    [anon_sym_scoped] = ACTIONS(5934),
    [anon_sym_var] = ACTIONS(5934),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(5934),
    [anon_sym_when] = ACTIONS(5934),
    [anon_sym_from] = ACTIONS(5934),
    [anon_sym_into] = ACTIONS(5934),
    [anon_sym_join] = ACTIONS(5934),
    [anon_sym_on] = ACTIONS(5934),
    [anon_sym_equals] = ACTIONS(5934),
    [anon_sym_let] = ACTIONS(5934),
    [anon_sym_orderby] = ACTIONS(5934),
    [anon_sym_ascending] = ACTIONS(5934),
    [anon_sym_descending] = ACTIONS(5934),
    [anon_sym_group] = ACTIONS(5934),
    [anon_sym_by] = ACTIONS(5934),
    [anon_sym_select] = ACTIONS(5934),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3686] = {
    [sym_preproc_region] = STATE(3686),
    [sym_preproc_endregion] = STATE(3686),
    [sym_preproc_line] = STATE(3686),
    [sym_preproc_pragma] = STATE(3686),
    [sym_preproc_nullable] = STATE(3686),
    [sym_preproc_error] = STATE(3686),
    [sym_preproc_warning] = STATE(3686),
    [sym_preproc_define] = STATE(3686),
    [sym_preproc_undef] = STATE(3686),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(5943),
    [anon_sym_DASH_EQ] = ACTIONS(5943),
    [anon_sym_STAR_EQ] = ACTIONS(5943),
    [anon_sym_SLASH_EQ] = ACTIONS(5943),
    [anon_sym_PERCENT_EQ] = ACTIONS(5943),
    [anon_sym_AMP_EQ] = ACTIONS(5943),
    [anon_sym_CARET_EQ] = ACTIONS(5943),
    [anon_sym_PIPE_EQ] = ACTIONS(5943),
    [anon_sym_LT_LT_EQ] = ACTIONS(5943),
    [anon_sym_GT_GT_EQ] = ACTIONS(5943),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5943),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5943),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3687] = {
    [sym_argument_list] = STATE(2970),
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3541),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(2956),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3687),
    [sym_preproc_endregion] = STATE(3687),
    [sym_preproc_line] = STATE(3687),
    [sym_preproc_pragma] = STATE(3687),
    [sym_preproc_nullable] = STATE(3687),
    [sym_preproc_error] = STATE(3687),
    [sym_preproc_warning] = STATE(3687),
    [sym_preproc_define] = STATE(3687),
    [sym_preproc_undef] = STATE(3687),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_ref] = ACTIONS(4259),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5945),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3688] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6899),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3688),
    [sym_preproc_endregion] = STATE(3688),
    [sym_preproc_line] = STATE(3688),
    [sym_preproc_pragma] = STATE(3688),
    [sym_preproc_nullable] = STATE(3688),
    [sym_preproc_error] = STATE(3688),
    [sym_preproc_warning] = STATE(3688),
    [sym_preproc_define] = STATE(3688),
    [sym_preproc_undef] = STATE(3688),
    [aux_sym_type_argument_list_repeat1] = STATE(6900),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3689] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3689),
    [sym_preproc_endregion] = STATE(3689),
    [sym_preproc_line] = STATE(3689),
    [sym_preproc_pragma] = STATE(3689),
    [sym_preproc_nullable] = STATE(3689),
    [sym_preproc_error] = STATE(3689),
    [sym_preproc_warning] = STATE(3689),
    [sym_preproc_define] = STATE(3689),
    [sym_preproc_undef] = STATE(3689),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3690] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3690),
    [sym_preproc_endregion] = STATE(3690),
    [sym_preproc_line] = STATE(3690),
    [sym_preproc_pragma] = STATE(3690),
    [sym_preproc_nullable] = STATE(3690),
    [sym_preproc_error] = STATE(3690),
    [sym_preproc_warning] = STATE(3690),
    [sym_preproc_define] = STATE(3690),
    [sym_preproc_undef] = STATE(3690),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3691] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3691),
    [sym_preproc_endregion] = STATE(3691),
    [sym_preproc_line] = STATE(3691),
    [sym_preproc_pragma] = STATE(3691),
    [sym_preproc_nullable] = STATE(3691),
    [sym_preproc_error] = STATE(3691),
    [sym_preproc_warning] = STATE(3691),
    [sym_preproc_define] = STATE(3691),
    [sym_preproc_undef] = STATE(3691),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3692] = {
    [sym_preproc_region] = STATE(3692),
    [sym_preproc_endregion] = STATE(3692),
    [sym_preproc_line] = STATE(3692),
    [sym_preproc_pragma] = STATE(3692),
    [sym_preproc_nullable] = STATE(3692),
    [sym_preproc_error] = STATE(3692),
    [sym_preproc_warning] = STATE(3692),
    [sym_preproc_define] = STATE(3692),
    [sym_preproc_undef] = STATE(3692),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(4952),
    [anon_sym_LPAREN] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4954),
    [anon_sym_where] = ACTIONS(4952),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4954),
    [anon_sym_DASH] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4954),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_PIPE] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4954),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_GT_GT_GT] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4952),
    [anon_sym_BANG_EQ] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4952),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_DOT] = ACTIONS(4954),
    [anon_sym_switch] = ACTIONS(4952),
    [anon_sym_DOT_DOT] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_or] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4952),
    [anon_sym_QMARK_QMARK] = ACTIONS(4952),
    [anon_sym_from] = ACTIONS(4952),
    [anon_sym_into] = ACTIONS(4952),
    [anon_sym_join] = ACTIONS(4952),
    [anon_sym_let] = ACTIONS(4952),
    [anon_sym_orderby] = ACTIONS(4952),
    [anon_sym_ascending] = ACTIONS(4952),
    [anon_sym_descending] = ACTIONS(4952),
    [anon_sym_group] = ACTIONS(4952),
    [anon_sym_select] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4954),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_DASH_GT] = ACTIONS(4952),
    [anon_sym_with] = ACTIONS(4952),
    [sym_string_literal_encoding] = ACTIONS(5983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3693] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3693),
    [sym_preproc_endregion] = STATE(3693),
    [sym_preproc_line] = STATE(3693),
    [sym_preproc_pragma] = STATE(3693),
    [sym_preproc_nullable] = STATE(3693),
    [sym_preproc_error] = STATE(3693),
    [sym_preproc_warning] = STATE(3693),
    [sym_preproc_define] = STATE(3693),
    [sym_preproc_undef] = STATE(3693),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5238),
    [anon_sym_join] = ACTIONS(5238),
    [anon_sym_let] = ACTIONS(5238),
    [anon_sym_orderby] = ACTIONS(5238),
    [anon_sym_ascending] = ACTIONS(5238),
    [anon_sym_descending] = ACTIONS(5238),
    [anon_sym_group] = ACTIONS(5238),
    [anon_sym_select] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3694] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3694),
    [sym_preproc_endregion] = STATE(3694),
    [sym_preproc_line] = STATE(3694),
    [sym_preproc_pragma] = STATE(3694),
    [sym_preproc_nullable] = STATE(3694),
    [sym_preproc_error] = STATE(3694),
    [sym_preproc_warning] = STATE(3694),
    [sym_preproc_define] = STATE(3694),
    [sym_preproc_undef] = STATE(3694),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5794),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5794),
    [anon_sym_or] = ACTIONS(5810),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5794),
    [anon_sym_join] = ACTIONS(5794),
    [anon_sym_let] = ACTIONS(5794),
    [anon_sym_orderby] = ACTIONS(5794),
    [anon_sym_ascending] = ACTIONS(5794),
    [anon_sym_descending] = ACTIONS(5794),
    [anon_sym_group] = ACTIONS(5794),
    [anon_sym_select] = ACTIONS(5794),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3695] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3695),
    [sym_preproc_endregion] = STATE(3695),
    [sym_preproc_line] = STATE(3695),
    [sym_preproc_pragma] = STATE(3695),
    [sym_preproc_nullable] = STATE(3695),
    [sym_preproc_error] = STATE(3695),
    [sym_preproc_warning] = STATE(3695),
    [sym_preproc_define] = STATE(3695),
    [sym_preproc_undef] = STATE(3695),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5874),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5874),
    [anon_sym_or] = ACTIONS(5876),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5874),
    [anon_sym_join] = ACTIONS(5874),
    [anon_sym_let] = ACTIONS(5874),
    [anon_sym_orderby] = ACTIONS(5874),
    [anon_sym_ascending] = ACTIONS(5874),
    [anon_sym_descending] = ACTIONS(5874),
    [anon_sym_group] = ACTIONS(5874),
    [anon_sym_select] = ACTIONS(5874),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3696] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3696),
    [sym_preproc_endregion] = STATE(3696),
    [sym_preproc_line] = STATE(3696),
    [sym_preproc_pragma] = STATE(3696),
    [sym_preproc_nullable] = STATE(3696),
    [sym_preproc_error] = STATE(3696),
    [sym_preproc_warning] = STATE(3696),
    [sym_preproc_define] = STATE(3696),
    [sym_preproc_undef] = STATE(3696),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(1229),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_join] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_orderby] = ACTIONS(1229),
    [anon_sym_ascending] = ACTIONS(1229),
    [anon_sym_descending] = ACTIONS(1229),
    [anon_sym_group] = ACTIONS(1229),
    [anon_sym_select] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1229),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3697] = {
    [sym__name] = STATE(6683),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_implicit_type] = STATE(7424),
    [sym_array_type] = STATE(6850),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6851),
    [sym_pointer_type] = STATE(6851),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(6851),
    [sym_function_pointer_parameter] = STATE(7405),
    [sym__ref_base_type] = STATE(7407),
    [sym_tuple_type] = STATE(6783),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3697),
    [sym_preproc_endregion] = STATE(3697),
    [sym_preproc_line] = STATE(3697),
    [sym_preproc_pragma] = STATE(3697),
    [sym_preproc_nullable] = STATE(3697),
    [sym_preproc_error] = STATE(3697),
    [sym_preproc_warning] = STATE(3697),
    [sym_preproc_define] = STATE(3697),
    [sym_preproc_undef] = STATE(3697),
    [aux_sym_function_pointer_type_repeat1] = STATE(3697),
    [sym__identifier_token] = ACTIONS(5987),
    [anon_sym_alias] = ACTIONS(5990),
    [anon_sym_global] = ACTIONS(5990),
    [anon_sym_LPAREN] = ACTIONS(5993),
    [anon_sym_ref] = ACTIONS(5996),
    [anon_sym_delegate] = ACTIONS(5999),
    [anon_sym_file] = ACTIONS(5990),
    [anon_sym_in] = ACTIONS(5996),
    [anon_sym_out] = ACTIONS(5996),
    [anon_sym_where] = ACTIONS(5990),
    [anon_sym_notnull] = ACTIONS(5990),
    [anon_sym_unmanaged] = ACTIONS(5990),
    [anon_sym_scoped] = ACTIONS(5990),
    [anon_sym_var] = ACTIONS(6002),
    [sym_predefined_type] = ACTIONS(6005),
    [anon_sym_yield] = ACTIONS(5990),
    [anon_sym_when] = ACTIONS(5990),
    [anon_sym_from] = ACTIONS(5990),
    [anon_sym_into] = ACTIONS(5990),
    [anon_sym_join] = ACTIONS(5990),
    [anon_sym_on] = ACTIONS(5990),
    [anon_sym_equals] = ACTIONS(5990),
    [anon_sym_let] = ACTIONS(5990),
    [anon_sym_orderby] = ACTIONS(5990),
    [anon_sym_ascending] = ACTIONS(5990),
    [anon_sym_descending] = ACTIONS(5990),
    [anon_sym_group] = ACTIONS(5990),
    [anon_sym_by] = ACTIONS(5990),
    [anon_sym_select] = ACTIONS(5990),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3698] = {
    [sym_preproc_region] = STATE(3698),
    [sym_preproc_endregion] = STATE(3698),
    [sym_preproc_line] = STATE(3698),
    [sym_preproc_pragma] = STATE(3698),
    [sym_preproc_nullable] = STATE(3698),
    [sym_preproc_error] = STATE(3698),
    [sym_preproc_warning] = STATE(3698),
    [sym_preproc_define] = STATE(3698),
    [sym_preproc_undef] = STATE(3698),
    [aux_sym__query_body_repeat2] = STATE(3699),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [anon_sym_COMMA] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(6010),
    [anon_sym_where] = ACTIONS(6008),
    [anon_sym_QMARK] = ACTIONS(6010),
    [anon_sym_BANG] = ACTIONS(6010),
    [anon_sym_PLUS_PLUS] = ACTIONS(6008),
    [anon_sym_DASH_DASH] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(6010),
    [anon_sym_DASH] = ACTIONS(6010),
    [anon_sym_STAR] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(6010),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_CARET] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(6010),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_LT_LT] = ACTIONS(6008),
    [anon_sym_GT_GT] = ACTIONS(6010),
    [anon_sym_GT_GT_GT] = ACTIONS(6008),
    [anon_sym_EQ_EQ] = ACTIONS(6008),
    [anon_sym_BANG_EQ] = ACTIONS(6008),
    [anon_sym_GT_EQ] = ACTIONS(6008),
    [anon_sym_LT_EQ] = ACTIONS(6008),
    [anon_sym_DOT] = ACTIONS(6010),
    [anon_sym_switch] = ACTIONS(6008),
    [anon_sym_DOT_DOT] = ACTIONS(6008),
    [anon_sym_and] = ACTIONS(6008),
    [anon_sym_or] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6008),
    [anon_sym_QMARK_QMARK] = ACTIONS(6008),
    [anon_sym_from] = ACTIONS(6008),
    [anon_sym_into] = ACTIONS(6012),
    [anon_sym_join] = ACTIONS(6008),
    [anon_sym_let] = ACTIONS(6008),
    [anon_sym_orderby] = ACTIONS(6008),
    [anon_sym_ascending] = ACTIONS(6008),
    [anon_sym_descending] = ACTIONS(6008),
    [anon_sym_group] = ACTIONS(6008),
    [anon_sym_select] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6010),
    [anon_sym_is] = ACTIONS(6008),
    [anon_sym_DASH_GT] = ACTIONS(6008),
    [anon_sym_with] = ACTIONS(6008),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3699] = {
    [sym_preproc_region] = STATE(3699),
    [sym_preproc_endregion] = STATE(3699),
    [sym_preproc_line] = STATE(3699),
    [sym_preproc_pragma] = STATE(3699),
    [sym_preproc_nullable] = STATE(3699),
    [sym_preproc_error] = STATE(3699),
    [sym_preproc_warning] = STATE(3699),
    [sym_preproc_define] = STATE(3699),
    [sym_preproc_undef] = STATE(3699),
    [aux_sym__query_body_repeat2] = STATE(3701),
    [anon_sym_LBRACK] = ACTIONS(6014),
    [anon_sym_COMMA] = ACTIONS(6014),
    [anon_sym_LPAREN] = ACTIONS(6014),
    [anon_sym_LT] = ACTIONS(6016),
    [anon_sym_GT] = ACTIONS(6016),
    [anon_sym_where] = ACTIONS(6014),
    [anon_sym_QMARK] = ACTIONS(6016),
    [anon_sym_BANG] = ACTIONS(6016),
    [anon_sym_PLUS_PLUS] = ACTIONS(6014),
    [anon_sym_DASH_DASH] = ACTIONS(6014),
    [anon_sym_PLUS] = ACTIONS(6016),
    [anon_sym_DASH] = ACTIONS(6016),
    [anon_sym_STAR] = ACTIONS(6014),
    [anon_sym_SLASH] = ACTIONS(6016),
    [anon_sym_PERCENT] = ACTIONS(6014),
    [anon_sym_CARET] = ACTIONS(6014),
    [anon_sym_PIPE] = ACTIONS(6016),
    [anon_sym_AMP] = ACTIONS(6016),
    [anon_sym_LT_LT] = ACTIONS(6014),
    [anon_sym_GT_GT] = ACTIONS(6016),
    [anon_sym_GT_GT_GT] = ACTIONS(6014),
    [anon_sym_EQ_EQ] = ACTIONS(6014),
    [anon_sym_BANG_EQ] = ACTIONS(6014),
    [anon_sym_GT_EQ] = ACTIONS(6014),
    [anon_sym_LT_EQ] = ACTIONS(6014),
    [anon_sym_DOT] = ACTIONS(6016),
    [anon_sym_switch] = ACTIONS(6014),
    [anon_sym_DOT_DOT] = ACTIONS(6014),
    [anon_sym_and] = ACTIONS(6014),
    [anon_sym_or] = ACTIONS(6016),
    [anon_sym_AMP_AMP] = ACTIONS(6014),
    [anon_sym_PIPE_PIPE] = ACTIONS(6014),
    [anon_sym_QMARK_QMARK] = ACTIONS(6014),
    [anon_sym_from] = ACTIONS(6014),
    [anon_sym_into] = ACTIONS(6012),
    [anon_sym_join] = ACTIONS(6014),
    [anon_sym_let] = ACTIONS(6014),
    [anon_sym_orderby] = ACTIONS(6014),
    [anon_sym_ascending] = ACTIONS(6014),
    [anon_sym_descending] = ACTIONS(6014),
    [anon_sym_group] = ACTIONS(6014),
    [anon_sym_select] = ACTIONS(6014),
    [anon_sym_as] = ACTIONS(6016),
    [anon_sym_is] = ACTIONS(6014),
    [anon_sym_DASH_GT] = ACTIONS(6014),
    [anon_sym_with] = ACTIONS(6014),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3700] = {
    [sym_preproc_region] = STATE(3700),
    [sym_preproc_endregion] = STATE(3700),
    [sym_preproc_line] = STATE(3700),
    [sym_preproc_pragma] = STATE(3700),
    [sym_preproc_nullable] = STATE(3700),
    [sym_preproc_error] = STATE(3700),
    [sym_preproc_warning] = STATE(3700),
    [sym_preproc_define] = STATE(3700),
    [sym_preproc_undef] = STATE(3700),
    [aux_sym__query_body_repeat2] = STATE(3702),
    [anon_sym_LBRACK] = ACTIONS(6014),
    [anon_sym_COMMA] = ACTIONS(6014),
    [anon_sym_LPAREN] = ACTIONS(6014),
    [anon_sym_LT] = ACTIONS(6016),
    [anon_sym_GT] = ACTIONS(6016),
    [anon_sym_where] = ACTIONS(6014),
    [anon_sym_QMARK] = ACTIONS(6016),
    [anon_sym_BANG] = ACTIONS(6016),
    [anon_sym_PLUS_PLUS] = ACTIONS(6014),
    [anon_sym_DASH_DASH] = ACTIONS(6014),
    [anon_sym_PLUS] = ACTIONS(6016),
    [anon_sym_DASH] = ACTIONS(6016),
    [anon_sym_STAR] = ACTIONS(6014),
    [anon_sym_SLASH] = ACTIONS(6016),
    [anon_sym_PERCENT] = ACTIONS(6014),
    [anon_sym_CARET] = ACTIONS(6014),
    [anon_sym_PIPE] = ACTIONS(6016),
    [anon_sym_AMP] = ACTIONS(6016),
    [anon_sym_LT_LT] = ACTIONS(6014),
    [anon_sym_GT_GT] = ACTIONS(6016),
    [anon_sym_GT_GT_GT] = ACTIONS(6014),
    [anon_sym_EQ_EQ] = ACTIONS(6014),
    [anon_sym_BANG_EQ] = ACTIONS(6014),
    [anon_sym_GT_EQ] = ACTIONS(6014),
    [anon_sym_LT_EQ] = ACTIONS(6014),
    [anon_sym_DOT] = ACTIONS(6016),
    [anon_sym_switch] = ACTIONS(6014),
    [anon_sym_DOT_DOT] = ACTIONS(6014),
    [anon_sym_and] = ACTIONS(6014),
    [anon_sym_or] = ACTIONS(6016),
    [anon_sym_AMP_AMP] = ACTIONS(6014),
    [anon_sym_PIPE_PIPE] = ACTIONS(6014),
    [anon_sym_QMARK_QMARK] = ACTIONS(6014),
    [anon_sym_from] = ACTIONS(6014),
    [anon_sym_into] = ACTIONS(6012),
    [anon_sym_join] = ACTIONS(6014),
    [anon_sym_let] = ACTIONS(6014),
    [anon_sym_orderby] = ACTIONS(6014),
    [anon_sym_ascending] = ACTIONS(6014),
    [anon_sym_descending] = ACTIONS(6014),
    [anon_sym_group] = ACTIONS(6014),
    [anon_sym_select] = ACTIONS(6014),
    [anon_sym_as] = ACTIONS(6016),
    [anon_sym_is] = ACTIONS(6014),
    [anon_sym_DASH_GT] = ACTIONS(6014),
    [anon_sym_with] = ACTIONS(6014),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3701] = {
    [sym_preproc_region] = STATE(3701),
    [sym_preproc_endregion] = STATE(3701),
    [sym_preproc_line] = STATE(3701),
    [sym_preproc_pragma] = STATE(3701),
    [sym_preproc_nullable] = STATE(3701),
    [sym_preproc_error] = STATE(3701),
    [sym_preproc_warning] = STATE(3701),
    [sym_preproc_define] = STATE(3701),
    [sym_preproc_undef] = STATE(3701),
    [aux_sym__query_body_repeat2] = STATE(3701),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_COMMA] = ACTIONS(6018),
    [anon_sym_LPAREN] = ACTIONS(6018),
    [anon_sym_LT] = ACTIONS(6020),
    [anon_sym_GT] = ACTIONS(6020),
    [anon_sym_where] = ACTIONS(6018),
    [anon_sym_QMARK] = ACTIONS(6020),
    [anon_sym_BANG] = ACTIONS(6020),
    [anon_sym_PLUS_PLUS] = ACTIONS(6018),
    [anon_sym_DASH_DASH] = ACTIONS(6018),
    [anon_sym_PLUS] = ACTIONS(6020),
    [anon_sym_DASH] = ACTIONS(6020),
    [anon_sym_STAR] = ACTIONS(6018),
    [anon_sym_SLASH] = ACTIONS(6020),
    [anon_sym_PERCENT] = ACTIONS(6018),
    [anon_sym_CARET] = ACTIONS(6018),
    [anon_sym_PIPE] = ACTIONS(6020),
    [anon_sym_AMP] = ACTIONS(6020),
    [anon_sym_LT_LT] = ACTIONS(6018),
    [anon_sym_GT_GT] = ACTIONS(6020),
    [anon_sym_GT_GT_GT] = ACTIONS(6018),
    [anon_sym_EQ_EQ] = ACTIONS(6018),
    [anon_sym_BANG_EQ] = ACTIONS(6018),
    [anon_sym_GT_EQ] = ACTIONS(6018),
    [anon_sym_LT_EQ] = ACTIONS(6018),
    [anon_sym_DOT] = ACTIONS(6020),
    [anon_sym_switch] = ACTIONS(6018),
    [anon_sym_DOT_DOT] = ACTIONS(6018),
    [anon_sym_and] = ACTIONS(6018),
    [anon_sym_or] = ACTIONS(6020),
    [anon_sym_AMP_AMP] = ACTIONS(6018),
    [anon_sym_PIPE_PIPE] = ACTIONS(6018),
    [anon_sym_QMARK_QMARK] = ACTIONS(6018),
    [anon_sym_from] = ACTIONS(6018),
    [anon_sym_into] = ACTIONS(6022),
    [anon_sym_join] = ACTIONS(6018),
    [anon_sym_let] = ACTIONS(6018),
    [anon_sym_orderby] = ACTIONS(6018),
    [anon_sym_ascending] = ACTIONS(6018),
    [anon_sym_descending] = ACTIONS(6018),
    [anon_sym_group] = ACTIONS(6018),
    [anon_sym_select] = ACTIONS(6018),
    [anon_sym_as] = ACTIONS(6020),
    [anon_sym_is] = ACTIONS(6018),
    [anon_sym_DASH_GT] = ACTIONS(6018),
    [anon_sym_with] = ACTIONS(6018),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3702] = {
    [sym_preproc_region] = STATE(3702),
    [sym_preproc_endregion] = STATE(3702),
    [sym_preproc_line] = STATE(3702),
    [sym_preproc_pragma] = STATE(3702),
    [sym_preproc_nullable] = STATE(3702),
    [sym_preproc_error] = STATE(3702),
    [sym_preproc_warning] = STATE(3702),
    [sym_preproc_define] = STATE(3702),
    [sym_preproc_undef] = STATE(3702),
    [aux_sym__query_body_repeat2] = STATE(3701),
    [anon_sym_LBRACK] = ACTIONS(6025),
    [anon_sym_COMMA] = ACTIONS(6025),
    [anon_sym_LPAREN] = ACTIONS(6025),
    [anon_sym_LT] = ACTIONS(6027),
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_where] = ACTIONS(6025),
    [anon_sym_QMARK] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PLUS_PLUS] = ACTIONS(6025),
    [anon_sym_DASH_DASH] = ACTIONS(6025),
    [anon_sym_PLUS] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6027),
    [anon_sym_STAR] = ACTIONS(6025),
    [anon_sym_SLASH] = ACTIONS(6027),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [anon_sym_CARET] = ACTIONS(6025),
    [anon_sym_PIPE] = ACTIONS(6027),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_LT_LT] = ACTIONS(6025),
    [anon_sym_GT_GT] = ACTIONS(6027),
    [anon_sym_GT_GT_GT] = ACTIONS(6025),
    [anon_sym_EQ_EQ] = ACTIONS(6025),
    [anon_sym_BANG_EQ] = ACTIONS(6025),
    [anon_sym_GT_EQ] = ACTIONS(6025),
    [anon_sym_LT_EQ] = ACTIONS(6025),
    [anon_sym_DOT] = ACTIONS(6027),
    [anon_sym_switch] = ACTIONS(6025),
    [anon_sym_DOT_DOT] = ACTIONS(6025),
    [anon_sym_and] = ACTIONS(6025),
    [anon_sym_or] = ACTIONS(6027),
    [anon_sym_AMP_AMP] = ACTIONS(6025),
    [anon_sym_PIPE_PIPE] = ACTIONS(6025),
    [anon_sym_QMARK_QMARK] = ACTIONS(6025),
    [anon_sym_from] = ACTIONS(6025),
    [anon_sym_into] = ACTIONS(6012),
    [anon_sym_join] = ACTIONS(6025),
    [anon_sym_let] = ACTIONS(6025),
    [anon_sym_orderby] = ACTIONS(6025),
    [anon_sym_ascending] = ACTIONS(6025),
    [anon_sym_descending] = ACTIONS(6025),
    [anon_sym_group] = ACTIONS(6025),
    [anon_sym_select] = ACTIONS(6025),
    [anon_sym_as] = ACTIONS(6027),
    [anon_sym_is] = ACTIONS(6025),
    [anon_sym_DASH_GT] = ACTIONS(6025),
    [anon_sym_with] = ACTIONS(6025),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3703] = {
    [sym_preproc_region] = STATE(3703),
    [sym_preproc_endregion] = STATE(3703),
    [sym_preproc_line] = STATE(3703),
    [sym_preproc_pragma] = STATE(3703),
    [sym_preproc_nullable] = STATE(3703),
    [sym_preproc_error] = STATE(3703),
    [sym_preproc_warning] = STATE(3703),
    [sym_preproc_define] = STATE(3703),
    [sym_preproc_undef] = STATE(3703),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_LBRACE] = ACTIONS(4933),
    [anon_sym_LT] = ACTIONS(4935),
    [anon_sym_GT] = ACTIONS(4935),
    [anon_sym_where] = ACTIONS(4933),
    [anon_sym_QMARK] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_PLUS_PLUS] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4933),
    [anon_sym_PLUS] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4933),
    [anon_sym_SLASH] = ACTIONS(4935),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_CARET] = ACTIONS(4933),
    [anon_sym_PIPE] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_LT_LT] = ACTIONS(4933),
    [anon_sym_GT_GT] = ACTIONS(4935),
    [anon_sym_GT_GT_GT] = ACTIONS(4933),
    [anon_sym_EQ_EQ] = ACTIONS(4933),
    [anon_sym_BANG_EQ] = ACTIONS(4933),
    [anon_sym_GT_EQ] = ACTIONS(4933),
    [anon_sym_LT_EQ] = ACTIONS(4933),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_switch] = ACTIONS(4933),
    [anon_sym_DOT_DOT] = ACTIONS(4933),
    [anon_sym_and] = ACTIONS(4933),
    [anon_sym_or] = ACTIONS(4935),
    [anon_sym_AMP_AMP] = ACTIONS(4933),
    [anon_sym_PIPE_PIPE] = ACTIONS(4933),
    [anon_sym_QMARK_QMARK] = ACTIONS(4933),
    [anon_sym_from] = ACTIONS(4933),
    [anon_sym_into] = ACTIONS(4933),
    [anon_sym_join] = ACTIONS(4933),
    [anon_sym_let] = ACTIONS(4933),
    [anon_sym_orderby] = ACTIONS(4933),
    [anon_sym_ascending] = ACTIONS(4933),
    [anon_sym_descending] = ACTIONS(4933),
    [anon_sym_group] = ACTIONS(4933),
    [anon_sym_select] = ACTIONS(4933),
    [anon_sym_as] = ACTIONS(4935),
    [anon_sym_is] = ACTIONS(4933),
    [anon_sym_DASH_GT] = ACTIONS(4933),
    [anon_sym_with] = ACTIONS(4933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3704] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3704),
    [sym_preproc_endregion] = STATE(3704),
    [sym_preproc_line] = STATE(3704),
    [sym_preproc_pragma] = STATE(3704),
    [sym_preproc_nullable] = STATE(3704),
    [sym_preproc_error] = STATE(3704),
    [sym_preproc_warning] = STATE(3704),
    [sym_preproc_define] = STATE(3704),
    [sym_preproc_undef] = STATE(3704),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5850),
    [anon_sym_join] = ACTIONS(5850),
    [anon_sym_let] = ACTIONS(5850),
    [anon_sym_orderby] = ACTIONS(5850),
    [anon_sym_ascending] = ACTIONS(5850),
    [anon_sym_descending] = ACTIONS(5850),
    [anon_sym_group] = ACTIONS(5850),
    [anon_sym_select] = ACTIONS(5850),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3705] = {
    [sym_preproc_region] = STATE(3705),
    [sym_preproc_endregion] = STATE(3705),
    [sym_preproc_line] = STATE(3705),
    [sym_preproc_pragma] = STATE(3705),
    [sym_preproc_nullable] = STATE(3705),
    [sym_preproc_error] = STATE(3705),
    [sym_preproc_warning] = STATE(3705),
    [sym_preproc_define] = STATE(3705),
    [sym_preproc_undef] = STATE(3705),
    [sym__identifier_token] = ACTIONS(3461),
    [anon_sym_alias] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3461),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_RBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_GT] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3461),
    [anon_sym_unmanaged] = ACTIONS(3461),
    [anon_sym_operator] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(3461),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3461),
    [anon_sym_when] = ACTIONS(3461),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3461),
    [anon_sym_into] = ACTIONS(3461),
    [anon_sym_join] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [anon_sym_equals] = ACTIONS(3461),
    [anon_sym_let] = ACTIONS(3461),
    [anon_sym_orderby] = ACTIONS(3461),
    [anon_sym_ascending] = ACTIONS(3461),
    [anon_sym_descending] = ACTIONS(3461),
    [anon_sym_group] = ACTIONS(3461),
    [anon_sym_by] = ACTIONS(3461),
    [anon_sym_select] = ACTIONS(3461),
    [anon_sym_DASH_GT] = ACTIONS(3459),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3706] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3706),
    [sym_preproc_endregion] = STATE(3706),
    [sym_preproc_line] = STATE(3706),
    [sym_preproc_pragma] = STATE(3706),
    [sym_preproc_nullable] = STATE(3706),
    [sym_preproc_error] = STATE(3706),
    [sym_preproc_warning] = STATE(3706),
    [sym_preproc_define] = STATE(3706),
    [sym_preproc_undef] = STATE(3706),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5870),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5870),
    [anon_sym_join] = ACTIONS(5870),
    [anon_sym_let] = ACTIONS(5870),
    [anon_sym_orderby] = ACTIONS(5870),
    [anon_sym_ascending] = ACTIONS(5870),
    [anon_sym_descending] = ACTIONS(5870),
    [anon_sym_group] = ACTIONS(5870),
    [anon_sym_select] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3707] = {
    [sym_preproc_region] = STATE(3707),
    [sym_preproc_endregion] = STATE(3707),
    [sym_preproc_line] = STATE(3707),
    [sym_preproc_pragma] = STATE(3707),
    [sym_preproc_nullable] = STATE(3707),
    [sym_preproc_error] = STATE(3707),
    [sym_preproc_warning] = STATE(3707),
    [sym_preproc_define] = STATE(3707),
    [sym_preproc_undef] = STATE(3707),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_where] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4969),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_from] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_join] = ACTIONS(4967),
    [anon_sym_let] = ACTIONS(4967),
    [anon_sym_orderby] = ACTIONS(4967),
    [anon_sym_ascending] = ACTIONS(4967),
    [anon_sym_descending] = ACTIONS(4967),
    [anon_sym_group] = ACTIONS(4967),
    [anon_sym_select] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4969),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [sym_string_literal_encoding] = ACTIONS(6029),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3708] = {
    [sym_preproc_region] = STATE(3708),
    [sym_preproc_endregion] = STATE(3708),
    [sym_preproc_line] = STATE(3708),
    [sym_preproc_pragma] = STATE(3708),
    [sym_preproc_nullable] = STATE(3708),
    [sym_preproc_error] = STATE(3708),
    [sym_preproc_warning] = STATE(3708),
    [sym_preproc_define] = STATE(3708),
    [sym_preproc_undef] = STATE(3708),
    [anon_sym_LBRACK] = ACTIONS(4958),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_LPAREN] = ACTIONS(4958),
    [anon_sym_LBRACE] = ACTIONS(4958),
    [anon_sym_LT] = ACTIONS(4960),
    [anon_sym_GT] = ACTIONS(4960),
    [anon_sym_where] = ACTIONS(4958),
    [anon_sym_QMARK] = ACTIONS(4960),
    [anon_sym_BANG] = ACTIONS(4960),
    [anon_sym_PLUS_PLUS] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(4958),
    [anon_sym_PLUS] = ACTIONS(4960),
    [anon_sym_DASH] = ACTIONS(4960),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_SLASH] = ACTIONS(4960),
    [anon_sym_PERCENT] = ACTIONS(4958),
    [anon_sym_CARET] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym_LT_LT] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(4960),
    [anon_sym_GT_GT_GT] = ACTIONS(4958),
    [anon_sym_EQ_EQ] = ACTIONS(4958),
    [anon_sym_BANG_EQ] = ACTIONS(4958),
    [anon_sym_GT_EQ] = ACTIONS(4958),
    [anon_sym_LT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(4960),
    [anon_sym_switch] = ACTIONS(4958),
    [anon_sym_DOT_DOT] = ACTIONS(4958),
    [anon_sym_and] = ACTIONS(4958),
    [anon_sym_or] = ACTIONS(4960),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_PIPE_PIPE] = ACTIONS(4958),
    [anon_sym_QMARK_QMARK] = ACTIONS(4958),
    [anon_sym_from] = ACTIONS(4958),
    [anon_sym_into] = ACTIONS(4958),
    [anon_sym_join] = ACTIONS(4958),
    [anon_sym_let] = ACTIONS(4958),
    [anon_sym_orderby] = ACTIONS(4958),
    [anon_sym_ascending] = ACTIONS(4958),
    [anon_sym_descending] = ACTIONS(4958),
    [anon_sym_group] = ACTIONS(4958),
    [anon_sym_select] = ACTIONS(4958),
    [anon_sym_as] = ACTIONS(4960),
    [anon_sym_is] = ACTIONS(4958),
    [anon_sym_DASH_GT] = ACTIONS(4958),
    [anon_sym_with] = ACTIONS(4958),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3709] = {
    [sym_preproc_region] = STATE(3709),
    [sym_preproc_endregion] = STATE(3709),
    [sym_preproc_line] = STATE(3709),
    [sym_preproc_pragma] = STATE(3709),
    [sym_preproc_nullable] = STATE(3709),
    [sym_preproc_error] = STATE(3709),
    [sym_preproc_warning] = STATE(3709),
    [sym_preproc_define] = STATE(3709),
    [sym_preproc_undef] = STATE(3709),
    [anon_sym_EQ] = ACTIONS(6031),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(6033),
    [anon_sym_DASH_EQ] = ACTIONS(6033),
    [anon_sym_STAR_EQ] = ACTIONS(6033),
    [anon_sym_SLASH_EQ] = ACTIONS(6033),
    [anon_sym_PERCENT_EQ] = ACTIONS(6033),
    [anon_sym_AMP_EQ] = ACTIONS(6033),
    [anon_sym_CARET_EQ] = ACTIONS(6033),
    [anon_sym_PIPE_EQ] = ACTIONS(6033),
    [anon_sym_LT_LT_EQ] = ACTIONS(6033),
    [anon_sym_GT_GT_EQ] = ACTIONS(6033),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6033),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6033),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3710] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3710),
    [sym_preproc_endregion] = STATE(3710),
    [sym_preproc_line] = STATE(3710),
    [sym_preproc_pragma] = STATE(3710),
    [sym_preproc_nullable] = STATE(3710),
    [sym_preproc_error] = STATE(3710),
    [sym_preproc_warning] = STATE(3710),
    [sym_preproc_define] = STATE(3710),
    [sym_preproc_undef] = STATE(3710),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5924),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5926),
    [anon_sym_where] = ACTIONS(5924),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_SLASH] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_PIPE] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_GT_GT] = ACTIONS(5926),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5924),
    [anon_sym_BANG_EQ] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5924),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5924),
    [anon_sym_or] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5924),
    [anon_sym_QMARK_QMARK] = ACTIONS(5924),
    [anon_sym_from] = ACTIONS(5924),
    [anon_sym_join] = ACTIONS(5924),
    [anon_sym_let] = ACTIONS(5924),
    [anon_sym_orderby] = ACTIONS(5924),
    [anon_sym_ascending] = ACTIONS(5924),
    [anon_sym_descending] = ACTIONS(5924),
    [anon_sym_group] = ACTIONS(5924),
    [anon_sym_select] = ACTIONS(5924),
    [anon_sym_as] = ACTIONS(5926),
    [anon_sym_is] = ACTIONS(5924),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5924),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3711] = {
    [sym_preproc_region] = STATE(3711),
    [sym_preproc_endregion] = STATE(3711),
    [sym_preproc_line] = STATE(3711),
    [sym_preproc_pragma] = STATE(3711),
    [sym_preproc_nullable] = STATE(3711),
    [sym_preproc_error] = STATE(3711),
    [sym_preproc_warning] = STATE(3711),
    [sym_preproc_define] = STATE(3711),
    [sym_preproc_undef] = STATE(3711),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4941),
    [anon_sym_where] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_BANG] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4941),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_PIPE] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4941),
    [anon_sym_GT_GT_GT] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4939),
    [anon_sym_BANG_EQ] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4939),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4941),
    [anon_sym_switch] = ACTIONS(4939),
    [anon_sym_DOT_DOT] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_or] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4939),
    [anon_sym_QMARK_QMARK] = ACTIONS(4939),
    [anon_sym_from] = ACTIONS(4939),
    [anon_sym_into] = ACTIONS(4939),
    [anon_sym_join] = ACTIONS(4939),
    [anon_sym_let] = ACTIONS(4939),
    [anon_sym_orderby] = ACTIONS(4939),
    [anon_sym_ascending] = ACTIONS(4939),
    [anon_sym_descending] = ACTIONS(4939),
    [anon_sym_group] = ACTIONS(4939),
    [anon_sym_select] = ACTIONS(4939),
    [anon_sym_as] = ACTIONS(4941),
    [anon_sym_is] = ACTIONS(4939),
    [anon_sym_DASH_GT] = ACTIONS(4939),
    [anon_sym_with] = ACTIONS(4939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3712] = {
    [sym_preproc_region] = STATE(3712),
    [sym_preproc_endregion] = STATE(3712),
    [sym_preproc_line] = STATE(3712),
    [sym_preproc_pragma] = STATE(3712),
    [sym_preproc_nullable] = STATE(3712),
    [sym_preproc_error] = STATE(3712),
    [sym_preproc_warning] = STATE(3712),
    [sym_preproc_define] = STATE(3712),
    [sym_preproc_undef] = STATE(3712),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_COMMA] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_LT] = ACTIONS(4945),
    [anon_sym_GT] = ACTIONS(4945),
    [anon_sym_where] = ACTIONS(4943),
    [anon_sym_QMARK] = ACTIONS(4945),
    [anon_sym_BANG] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_SLASH] = ACTIONS(4945),
    [anon_sym_PERCENT] = ACTIONS(4943),
    [anon_sym_CARET] = ACTIONS(4943),
    [anon_sym_PIPE] = ACTIONS(4945),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_LT_LT] = ACTIONS(4943),
    [anon_sym_GT_GT] = ACTIONS(4945),
    [anon_sym_GT_GT_GT] = ACTIONS(4943),
    [anon_sym_EQ_EQ] = ACTIONS(4943),
    [anon_sym_BANG_EQ] = ACTIONS(4943),
    [anon_sym_GT_EQ] = ACTIONS(4943),
    [anon_sym_LT_EQ] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4945),
    [anon_sym_switch] = ACTIONS(4943),
    [anon_sym_DOT_DOT] = ACTIONS(4943),
    [anon_sym_and] = ACTIONS(4943),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_AMP_AMP] = ACTIONS(4943),
    [anon_sym_PIPE_PIPE] = ACTIONS(4943),
    [anon_sym_QMARK_QMARK] = ACTIONS(4943),
    [anon_sym_from] = ACTIONS(4943),
    [anon_sym_into] = ACTIONS(4943),
    [anon_sym_join] = ACTIONS(4943),
    [anon_sym_let] = ACTIONS(4943),
    [anon_sym_orderby] = ACTIONS(4943),
    [anon_sym_ascending] = ACTIONS(4943),
    [anon_sym_descending] = ACTIONS(4943),
    [anon_sym_group] = ACTIONS(4943),
    [anon_sym_select] = ACTIONS(4943),
    [anon_sym_as] = ACTIONS(4945),
    [anon_sym_is] = ACTIONS(4943),
    [anon_sym_DASH_GT] = ACTIONS(4943),
    [anon_sym_with] = ACTIONS(4943),
    [aux_sym_raw_string_literal_token1] = ACTIONS(6035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3713] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3713),
    [sym_preproc_endregion] = STATE(3713),
    [sym_preproc_line] = STATE(3713),
    [sym_preproc_pragma] = STATE(3713),
    [sym_preproc_nullable] = STATE(3713),
    [sym_preproc_error] = STATE(3713),
    [sym_preproc_warning] = STATE(3713),
    [sym_preproc_define] = STATE(3713),
    [sym_preproc_undef] = STATE(3713),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5866),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5866),
    [anon_sym_or] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_QMARK_QMARK] = ACTIONS(5981),
    [anon_sym_from] = ACTIONS(5866),
    [anon_sym_join] = ACTIONS(5866),
    [anon_sym_let] = ACTIONS(5866),
    [anon_sym_orderby] = ACTIONS(5866),
    [anon_sym_ascending] = ACTIONS(5866),
    [anon_sym_descending] = ACTIONS(5866),
    [anon_sym_group] = ACTIONS(5866),
    [anon_sym_select] = ACTIONS(5866),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3714] = {
    [sym_preproc_region] = STATE(3714),
    [sym_preproc_endregion] = STATE(3714),
    [sym_preproc_line] = STATE(3714),
    [sym_preproc_pragma] = STATE(3714),
    [sym_preproc_nullable] = STATE(3714),
    [sym_preproc_error] = STATE(3714),
    [sym_preproc_warning] = STATE(3714),
    [sym_preproc_define] = STATE(3714),
    [sym_preproc_undef] = STATE(3714),
    [anon_sym_EQ] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(6039),
    [anon_sym_DASH_EQ] = ACTIONS(6039),
    [anon_sym_STAR_EQ] = ACTIONS(6039),
    [anon_sym_SLASH_EQ] = ACTIONS(6039),
    [anon_sym_PERCENT_EQ] = ACTIONS(6039),
    [anon_sym_AMP_EQ] = ACTIONS(6039),
    [anon_sym_CARET_EQ] = ACTIONS(6039),
    [anon_sym_PIPE_EQ] = ACTIONS(6039),
    [anon_sym_LT_LT_EQ] = ACTIONS(6039),
    [anon_sym_GT_GT_EQ] = ACTIONS(6039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6039),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6039),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3715] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3715),
    [sym_preproc_endregion] = STATE(3715),
    [sym_preproc_line] = STATE(3715),
    [sym_preproc_pragma] = STATE(3715),
    [sym_preproc_nullable] = STATE(3715),
    [sym_preproc_error] = STATE(3715),
    [sym_preproc_warning] = STATE(3715),
    [sym_preproc_define] = STATE(3715),
    [sym_preproc_undef] = STATE(3715),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3716] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3716),
    [sym_preproc_endregion] = STATE(3716),
    [sym_preproc_line] = STATE(3716),
    [sym_preproc_pragma] = STATE(3716),
    [sym_preproc_nullable] = STATE(3716),
    [sym_preproc_error] = STATE(3716),
    [sym_preproc_warning] = STATE(3716),
    [sym_preproc_define] = STATE(3716),
    [sym_preproc_undef] = STATE(3716),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3717] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3717),
    [sym_preproc_endregion] = STATE(3717),
    [sym_preproc_line] = STATE(3717),
    [sym_preproc_pragma] = STATE(3717),
    [sym_preproc_nullable] = STATE(3717),
    [sym_preproc_error] = STATE(3717),
    [sym_preproc_warning] = STATE(3717),
    [sym_preproc_define] = STATE(3717),
    [sym_preproc_undef] = STATE(3717),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3718] = {
    [sym__name] = STATE(6463),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(7226),
    [sym_array_type] = STATE(6726),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(6760),
    [sym_pointer_type] = STATE(6760),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(6760),
    [sym_ref_type] = STATE(7331),
    [sym__ref_base_type] = STATE(7413),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6542),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3718),
    [sym_preproc_endregion] = STATE(3718),
    [sym_preproc_line] = STATE(3718),
    [sym_preproc_pragma] = STATE(3718),
    [sym_preproc_nullable] = STATE(3718),
    [sym_preproc_error] = STATE(3718),
    [sym_preproc_warning] = STATE(3718),
    [sym_preproc_define] = STATE(3718),
    [sym_preproc_undef] = STATE(3718),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(6041),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6043),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5522),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3719] = {
    [sym_preproc_region] = STATE(3719),
    [sym_preproc_endregion] = STATE(3719),
    [sym_preproc_line] = STATE(3719),
    [sym_preproc_pragma] = STATE(3719),
    [sym_preproc_nullable] = STATE(3719),
    [sym_preproc_error] = STATE(3719),
    [sym_preproc_warning] = STATE(3719),
    [sym_preproc_define] = STATE(3719),
    [sym_preproc_undef] = STATE(3719),
    [anon_sym_EQ] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(6047),
    [anon_sym_DASH_EQ] = ACTIONS(6047),
    [anon_sym_STAR_EQ] = ACTIONS(6047),
    [anon_sym_SLASH_EQ] = ACTIONS(6047),
    [anon_sym_PERCENT_EQ] = ACTIONS(6047),
    [anon_sym_AMP_EQ] = ACTIONS(6047),
    [anon_sym_CARET_EQ] = ACTIONS(6047),
    [anon_sym_PIPE_EQ] = ACTIONS(6047),
    [anon_sym_LT_LT_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6047),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3720] = {
    [sym_preproc_region] = STATE(3720),
    [sym_preproc_endregion] = STATE(3720),
    [sym_preproc_line] = STATE(3720),
    [sym_preproc_pragma] = STATE(3720),
    [sym_preproc_nullable] = STATE(3720),
    [sym_preproc_error] = STATE(3720),
    [sym_preproc_warning] = STATE(3720),
    [sym_preproc_define] = STATE(3720),
    [sym_preproc_undef] = STATE(3720),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(6051),
    [anon_sym_DASH_EQ] = ACTIONS(6051),
    [anon_sym_STAR_EQ] = ACTIONS(6051),
    [anon_sym_SLASH_EQ] = ACTIONS(6051),
    [anon_sym_PERCENT_EQ] = ACTIONS(6051),
    [anon_sym_AMP_EQ] = ACTIONS(6051),
    [anon_sym_CARET_EQ] = ACTIONS(6051),
    [anon_sym_PIPE_EQ] = ACTIONS(6051),
    [anon_sym_LT_LT_EQ] = ACTIONS(6051),
    [anon_sym_GT_GT_EQ] = ACTIONS(6051),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6051),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3721] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3721),
    [sym_preproc_endregion] = STATE(3721),
    [sym_preproc_line] = STATE(3721),
    [sym_preproc_pragma] = STATE(3721),
    [sym_preproc_nullable] = STATE(3721),
    [sym_preproc_error] = STATE(3721),
    [sym_preproc_warning] = STATE(3721),
    [sym_preproc_define] = STATE(3721),
    [sym_preproc_undef] = STATE(3721),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(3957),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3722] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3722),
    [sym_preproc_endregion] = STATE(3722),
    [sym_preproc_line] = STATE(3722),
    [sym_preproc_pragma] = STATE(3722),
    [sym_preproc_nullable] = STATE(3722),
    [sym_preproc_error] = STATE(3722),
    [sym_preproc_warning] = STATE(3722),
    [sym_preproc_define] = STATE(3722),
    [sym_preproc_undef] = STATE(3722),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3723] = {
    [sym_preproc_region] = STATE(3723),
    [sym_preproc_endregion] = STATE(3723),
    [sym_preproc_line] = STATE(3723),
    [sym_preproc_pragma] = STATE(3723),
    [sym_preproc_nullable] = STATE(3723),
    [sym_preproc_error] = STATE(3723),
    [sym_preproc_warning] = STATE(3723),
    [sym_preproc_define] = STATE(3723),
    [sym_preproc_undef] = STATE(3723),
    [anon_sym_EQ] = ACTIONS(6053),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_EQ_GT] = ACTIONS(4898),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(6055),
    [anon_sym_DASH_EQ] = ACTIONS(6055),
    [anon_sym_STAR_EQ] = ACTIONS(6055),
    [anon_sym_SLASH_EQ] = ACTIONS(6055),
    [anon_sym_PERCENT_EQ] = ACTIONS(6055),
    [anon_sym_AMP_EQ] = ACTIONS(6055),
    [anon_sym_CARET_EQ] = ACTIONS(6055),
    [anon_sym_PIPE_EQ] = ACTIONS(6055),
    [anon_sym_LT_LT_EQ] = ACTIONS(6055),
    [anon_sym_GT_GT_EQ] = ACTIONS(6055),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6055),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3724] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3724),
    [sym_preproc_endregion] = STATE(3724),
    [sym_preproc_line] = STATE(3724),
    [sym_preproc_pragma] = STATE(3724),
    [sym_preproc_nullable] = STATE(3724),
    [sym_preproc_error] = STATE(3724),
    [sym_preproc_warning] = STATE(3724),
    [sym_preproc_define] = STATE(3724),
    [sym_preproc_undef] = STATE(3724),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(6057),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3725] = {
    [sym_preproc_region] = STATE(3725),
    [sym_preproc_endregion] = STATE(3725),
    [sym_preproc_line] = STATE(3725),
    [sym_preproc_pragma] = STATE(3725),
    [sym_preproc_nullable] = STATE(3725),
    [sym_preproc_error] = STATE(3725),
    [sym_preproc_warning] = STATE(3725),
    [sym_preproc_define] = STATE(3725),
    [sym_preproc_undef] = STATE(3725),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_get] = ACTIONS(3494),
    [anon_sym_set] = ACTIONS(3494),
    [anon_sym_add] = ACTIONS(3494),
    [anon_sym_remove] = ACTIONS(3494),
    [anon_sym_init] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3726] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3726),
    [sym_preproc_endregion] = STATE(3726),
    [sym_preproc_line] = STATE(3726),
    [sym_preproc_pragma] = STATE(3726),
    [sym_preproc_nullable] = STATE(3726),
    [sym_preproc_error] = STATE(3726),
    [sym_preproc_warning] = STATE(3726),
    [sym_preproc_define] = STATE(3726),
    [sym_preproc_undef] = STATE(3726),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3727] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3727),
    [sym_preproc_endregion] = STATE(3727),
    [sym_preproc_line] = STATE(3727),
    [sym_preproc_pragma] = STATE(3727),
    [sym_preproc_nullable] = STATE(3727),
    [sym_preproc_error] = STATE(3727),
    [sym_preproc_warning] = STATE(3727),
    [sym_preproc_define] = STATE(3727),
    [sym_preproc_undef] = STATE(3727),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3728] = {
    [sym_preproc_region] = STATE(3728),
    [sym_preproc_endregion] = STATE(3728),
    [sym_preproc_line] = STATE(3728),
    [sym_preproc_pragma] = STATE(3728),
    [sym_preproc_nullable] = STATE(3728),
    [sym_preproc_error] = STATE(3728),
    [sym_preproc_warning] = STATE(3728),
    [sym_preproc_define] = STATE(3728),
    [sym_preproc_undef] = STATE(3728),
    [sym__identifier_token] = ACTIONS(3662),
    [anon_sym_alias] = ACTIONS(3662),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym_global] = ACTIONS(3662),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_file] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(3664),
    [anon_sym_in] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3664),
    [anon_sym_notnull] = ACTIONS(3662),
    [anon_sym_unmanaged] = ACTIONS(3662),
    [anon_sym_operator] = ACTIONS(3662),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_this] = ACTIONS(3662),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_scoped] = ACTIONS(3662),
    [anon_sym_EQ_GT] = ACTIONS(3664),
    [anon_sym_COLON_COLON] = ACTIONS(3664),
    [anon_sym_var] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_when] = ACTIONS(3662),
    [sym_discard] = ACTIONS(3662),
    [anon_sym_and] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_into] = ACTIONS(3662),
    [anon_sym_join] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_equals] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_orderby] = ACTIONS(3662),
    [anon_sym_ascending] = ACTIONS(3662),
    [anon_sym_descending] = ACTIONS(3662),
    [anon_sym_group] = ACTIONS(3662),
    [anon_sym_by] = ACTIONS(3662),
    [anon_sym_select] = ACTIONS(3662),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3729] = {
    [sym_preproc_region] = STATE(3729),
    [sym_preproc_endregion] = STATE(3729),
    [sym_preproc_line] = STATE(3729),
    [sym_preproc_pragma] = STATE(3729),
    [sym_preproc_nullable] = STATE(3729),
    [sym_preproc_error] = STATE(3729),
    [sym_preproc_warning] = STATE(3729),
    [sym_preproc_define] = STATE(3729),
    [sym_preproc_undef] = STATE(3729),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(5455),
    [anon_sym_GT] = ACTIONS(5455),
    [anon_sym_where] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(5455),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(5455),
    [anon_sym_AMP] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(5455),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(5455),
    [anon_sym_EQ_GT] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(5455),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_QMARK_QMARK] = ACTIONS(3881),
    [anon_sym_from] = ACTIONS(3881),
    [anon_sym_into] = ACTIONS(3881),
    [anon_sym_join] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_orderby] = ACTIONS(3881),
    [anon_sym_ascending] = ACTIONS(3881),
    [anon_sym_descending] = ACTIONS(3881),
    [anon_sym_group] = ACTIONS(3881),
    [anon_sym_select] = ACTIONS(3881),
    [anon_sym_as] = ACTIONS(5455),
    [anon_sym_is] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3730] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3730),
    [sym_preproc_endregion] = STATE(3730),
    [sym_preproc_line] = STATE(3730),
    [sym_preproc_pragma] = STATE(3730),
    [sym_preproc_nullable] = STATE(3730),
    [sym_preproc_error] = STATE(3730),
    [sym_preproc_warning] = STATE(3730),
    [sym_preproc_define] = STATE(3730),
    [sym_preproc_undef] = STATE(3730),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3731] = {
    [sym_preproc_region] = STATE(3731),
    [sym_preproc_endregion] = STATE(3731),
    [sym_preproc_line] = STATE(3731),
    [sym_preproc_pragma] = STATE(3731),
    [sym_preproc_nullable] = STATE(3731),
    [sym_preproc_error] = STATE(3731),
    [sym_preproc_warning] = STATE(3731),
    [sym_preproc_define] = STATE(3731),
    [sym_preproc_undef] = STATE(3731),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4900),
    [anon_sym_CARET] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4900),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4900),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_PLUS_EQ] = ACTIONS(6061),
    [anon_sym_DASH_EQ] = ACTIONS(6061),
    [anon_sym_STAR_EQ] = ACTIONS(6061),
    [anon_sym_SLASH_EQ] = ACTIONS(6061),
    [anon_sym_PERCENT_EQ] = ACTIONS(6061),
    [anon_sym_AMP_EQ] = ACTIONS(6061),
    [anon_sym_CARET_EQ] = ACTIONS(6061),
    [anon_sym_PIPE_EQ] = ACTIONS(6061),
    [anon_sym_LT_LT_EQ] = ACTIONS(6061),
    [anon_sym_GT_GT_EQ] = ACTIONS(6061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6061),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6061),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4900),
    [anon_sym_as] = ACTIONS(4898),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3732] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3732),
    [sym_preproc_endregion] = STATE(3732),
    [sym_preproc_line] = STATE(3732),
    [sym_preproc_pragma] = STATE(3732),
    [sym_preproc_nullable] = STATE(3732),
    [sym_preproc_error] = STATE(3732),
    [sym_preproc_warning] = STATE(3732),
    [sym_preproc_define] = STATE(3732),
    [sym_preproc_undef] = STATE(3732),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3733] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3733),
    [sym_preproc_endregion] = STATE(3733),
    [sym_preproc_line] = STATE(3733),
    [sym_preproc_pragma] = STATE(3733),
    [sym_preproc_nullable] = STATE(3733),
    [sym_preproc_error] = STATE(3733),
    [sym_preproc_warning] = STATE(3733),
    [sym_preproc_define] = STATE(3733),
    [sym_preproc_undef] = STATE(3733),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_AMP] = ACTIONS(5963),
    [anon_sym_LT_LT] = ACTIONS(5965),
    [anon_sym_GT_GT] = ACTIONS(5967),
    [anon_sym_GT_GT_GT] = ACTIONS(5965),
    [anon_sym_EQ_EQ] = ACTIONS(5969),
    [anon_sym_BANG_EQ] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5955),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5975),
    [anon_sym_is] = ACTIONS(5977),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3734] = {
    [sym_preproc_region] = STATE(3734),
    [sym_preproc_endregion] = STATE(3734),
    [sym_preproc_line] = STATE(3734),
    [sym_preproc_pragma] = STATE(3734),
    [sym_preproc_nullable] = STATE(3734),
    [sym_preproc_error] = STATE(3734),
    [sym_preproc_warning] = STATE(3734),
    [sym_preproc_define] = STATE(3734),
    [sym_preproc_undef] = STATE(3734),
    [sym__identifier_token] = ACTIONS(5298),
    [anon_sym_extern] = ACTIONS(5298),
    [anon_sym_alias] = ACTIONS(5298),
    [anon_sym_global] = ACTIONS(5298),
    [anon_sym_unsafe] = ACTIONS(5298),
    [anon_sym_static] = ACTIONS(5298),
    [anon_sym_abstract] = ACTIONS(5298),
    [anon_sym_async] = ACTIONS(5298),
    [anon_sym_const] = ACTIONS(5298),
    [anon_sym_file] = ACTIONS(5298),
    [anon_sym_fixed] = ACTIONS(5298),
    [anon_sym_internal] = ACTIONS(5298),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_override] = ACTIONS(5298),
    [anon_sym_partial] = ACTIONS(5298),
    [anon_sym_private] = ACTIONS(5298),
    [anon_sym_protected] = ACTIONS(5298),
    [anon_sym_public] = ACTIONS(5298),
    [anon_sym_readonly] = ACTIONS(5298),
    [anon_sym_required] = ACTIONS(5298),
    [anon_sym_sealed] = ACTIONS(5298),
    [anon_sym_virtual] = ACTIONS(5298),
    [anon_sym_volatile] = ACTIONS(5298),
    [anon_sym_where] = ACTIONS(5298),
    [anon_sym_notnull] = ACTIONS(5298),
    [anon_sym_unmanaged] = ACTIONS(5298),
    [anon_sym_get] = ACTIONS(5298),
    [anon_sym_set] = ACTIONS(5298),
    [anon_sym_add] = ACTIONS(5298),
    [anon_sym_remove] = ACTIONS(5298),
    [anon_sym_init] = ACTIONS(5298),
    [anon_sym_scoped] = ACTIONS(5298),
    [anon_sym_var] = ACTIONS(5298),
    [anon_sym_yield] = ACTIONS(5298),
    [anon_sym_when] = ACTIONS(5298),
    [anon_sym_from] = ACTIONS(5298),
    [anon_sym_into] = ACTIONS(5298),
    [anon_sym_join] = ACTIONS(5298),
    [anon_sym_on] = ACTIONS(5298),
    [anon_sym_equals] = ACTIONS(5298),
    [anon_sym_let] = ACTIONS(5298),
    [anon_sym_orderby] = ACTIONS(5298),
    [anon_sym_ascending] = ACTIONS(5298),
    [anon_sym_descending] = ACTIONS(5298),
    [anon_sym_group] = ACTIONS(5298),
    [anon_sym_by] = ACTIONS(5298),
    [anon_sym_select] = ACTIONS(5298),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3735] = {
    [sym_preproc_region] = STATE(3735),
    [sym_preproc_endregion] = STATE(3735),
    [sym_preproc_line] = STATE(3735),
    [sym_preproc_pragma] = STATE(3735),
    [sym_preproc_nullable] = STATE(3735),
    [sym_preproc_error] = STATE(3735),
    [sym_preproc_warning] = STATE(3735),
    [sym_preproc_define] = STATE(3735),
    [sym_preproc_undef] = STATE(3735),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_GT] = ACTIONS(4977),
    [anon_sym_where] = ACTIONS(4975),
    [anon_sym_QMARK] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_PLUS_PLUS] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4975),
    [anon_sym_SLASH] = ACTIONS(4977),
    [anon_sym_PERCENT] = ACTIONS(4975),
    [anon_sym_CARET] = ACTIONS(4975),
    [anon_sym_PIPE] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4975),
    [anon_sym_GT_GT] = ACTIONS(4977),
    [anon_sym_GT_GT_GT] = ACTIONS(4975),
    [anon_sym_EQ_EQ] = ACTIONS(4975),
    [anon_sym_BANG_EQ] = ACTIONS(4975),
    [anon_sym_GT_EQ] = ACTIONS(4975),
    [anon_sym_LT_EQ] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_switch] = ACTIONS(4975),
    [anon_sym_DOT_DOT] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_or] = ACTIONS(4977),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_PIPE_PIPE] = ACTIONS(4975),
    [anon_sym_QMARK_QMARK] = ACTIONS(4975),
    [anon_sym_from] = ACTIONS(4975),
    [anon_sym_into] = ACTIONS(4975),
    [anon_sym_join] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_orderby] = ACTIONS(4975),
    [anon_sym_ascending] = ACTIONS(4975),
    [anon_sym_descending] = ACTIONS(4975),
    [anon_sym_group] = ACTIONS(4975),
    [anon_sym_select] = ACTIONS(4975),
    [anon_sym_as] = ACTIONS(4977),
    [anon_sym_is] = ACTIONS(4975),
    [anon_sym_DASH_GT] = ACTIONS(4975),
    [anon_sym_with] = ACTIONS(4975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3736] = {
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3042),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(3088),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3736),
    [sym_preproc_endregion] = STATE(3736),
    [sym_preproc_line] = STATE(3736),
    [sym_preproc_pragma] = STATE(3736),
    [sym_preproc_nullable] = STATE(3736),
    [sym_preproc_error] = STATE(3736),
    [sym_preproc_warning] = STATE(3736),
    [sym_preproc_define] = STATE(3736),
    [sym_preproc_undef] = STATE(3736),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_ref] = ACTIONS(4259),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_readonly] = ACTIONS(6065),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5945),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3737] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3737),
    [sym_preproc_endregion] = STATE(3737),
    [sym_preproc_line] = STATE(3737),
    [sym_preproc_pragma] = STATE(3737),
    [sym_preproc_nullable] = STATE(3737),
    [sym_preproc_error] = STATE(3737),
    [sym_preproc_warning] = STATE(3737),
    [sym_preproc_define] = STATE(3737),
    [sym_preproc_undef] = STATE(3737),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(1229),
    [anon_sym_or] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_into] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1229),
    [anon_sym_is] = ACTIONS(1229),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(1229),
    [aux_sym_preproc_if_token3] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3738] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3738),
    [sym_preproc_endregion] = STATE(3738),
    [sym_preproc_line] = STATE(3738),
    [sym_preproc_pragma] = STATE(3738),
    [sym_preproc_nullable] = STATE(3738),
    [sym_preproc_error] = STATE(3738),
    [sym_preproc_warning] = STATE(3738),
    [sym_preproc_define] = STATE(3738),
    [sym_preproc_undef] = STATE(3738),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(6041),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6043),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5520),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3739] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3739),
    [sym_preproc_endregion] = STATE(3739),
    [sym_preproc_line] = STATE(3739),
    [sym_preproc_pragma] = STATE(3739),
    [sym_preproc_nullable] = STATE(3739),
    [sym_preproc_error] = STATE(3739),
    [sym_preproc_warning] = STATE(3739),
    [sym_preproc_define] = STATE(3739),
    [sym_preproc_undef] = STATE(3739),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3660),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_when] = ACTIONS(3615),
    [sym_discard] = ACTIONS(3461),
    [anon_sym_and] = ACTIONS(3461),
    [anon_sym_or] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3740] = {
    [sym_preproc_region] = STATE(3740),
    [sym_preproc_endregion] = STATE(3740),
    [sym_preproc_line] = STATE(3740),
    [sym_preproc_pragma] = STATE(3740),
    [sym_preproc_nullable] = STATE(3740),
    [sym_preproc_error] = STATE(3740),
    [sym_preproc_warning] = STATE(3740),
    [sym_preproc_define] = STATE(3740),
    [sym_preproc_undef] = STATE(3740),
    [sym__identifier_token] = ACTIONS(5298),
    [anon_sym_extern] = ACTIONS(5298),
    [anon_sym_alias] = ACTIONS(5298),
    [anon_sym_global] = ACTIONS(5298),
    [anon_sym_unsafe] = ACTIONS(5298),
    [anon_sym_static] = ACTIONS(5298),
    [anon_sym_LPAREN] = ACTIONS(5300),
    [anon_sym_ref] = ACTIONS(5298),
    [anon_sym_delegate] = ACTIONS(5298),
    [anon_sym_abstract] = ACTIONS(5298),
    [anon_sym_async] = ACTIONS(5298),
    [anon_sym_const] = ACTIONS(5298),
    [anon_sym_file] = ACTIONS(5298),
    [anon_sym_fixed] = ACTIONS(5298),
    [anon_sym_internal] = ACTIONS(5298),
    [anon_sym_new] = ACTIONS(5298),
    [anon_sym_override] = ACTIONS(5298),
    [anon_sym_partial] = ACTIONS(5298),
    [anon_sym_private] = ACTIONS(5298),
    [anon_sym_protected] = ACTIONS(5298),
    [anon_sym_public] = ACTIONS(5298),
    [anon_sym_readonly] = ACTIONS(5298),
    [anon_sym_required] = ACTIONS(5298),
    [anon_sym_sealed] = ACTIONS(5298),
    [anon_sym_virtual] = ACTIONS(5298),
    [anon_sym_volatile] = ACTIONS(5298),
    [anon_sym_where] = ACTIONS(5298),
    [anon_sym_notnull] = ACTIONS(5298),
    [anon_sym_unmanaged] = ACTIONS(5298),
    [anon_sym_scoped] = ACTIONS(5298),
    [anon_sym_var] = ACTIONS(5298),
    [sym_predefined_type] = ACTIONS(5298),
    [anon_sym_yield] = ACTIONS(5298),
    [anon_sym_when] = ACTIONS(5298),
    [anon_sym_from] = ACTIONS(5298),
    [anon_sym_into] = ACTIONS(5298),
    [anon_sym_join] = ACTIONS(5298),
    [anon_sym_on] = ACTIONS(5298),
    [anon_sym_equals] = ACTIONS(5298),
    [anon_sym_let] = ACTIONS(5298),
    [anon_sym_orderby] = ACTIONS(5298),
    [anon_sym_ascending] = ACTIONS(5298),
    [anon_sym_descending] = ACTIONS(5298),
    [anon_sym_group] = ACTIONS(5298),
    [anon_sym_by] = ACTIONS(5298),
    [anon_sym_select] = ACTIONS(5298),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3741] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3741),
    [sym_preproc_endregion] = STATE(3741),
    [sym_preproc_line] = STATE(3741),
    [sym_preproc_pragma] = STATE(3741),
    [sym_preproc_nullable] = STATE(3741),
    [sym_preproc_error] = STATE(3741),
    [sym_preproc_warning] = STATE(3741),
    [sym_preproc_define] = STATE(3741),
    [sym_preproc_undef] = STATE(3741),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3742] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3742),
    [sym_preproc_endregion] = STATE(3742),
    [sym_preproc_line] = STATE(3742),
    [sym_preproc_pragma] = STATE(3742),
    [sym_preproc_nullable] = STATE(3742),
    [sym_preproc_error] = STATE(3742),
    [sym_preproc_warning] = STATE(3742),
    [sym_preproc_define] = STATE(3742),
    [sym_preproc_undef] = STATE(3742),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3743] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3743),
    [sym_preproc_endregion] = STATE(3743),
    [sym_preproc_line] = STATE(3743),
    [sym_preproc_pragma] = STATE(3743),
    [sym_preproc_nullable] = STATE(3743),
    [sym_preproc_error] = STATE(3743),
    [sym_preproc_warning] = STATE(3743),
    [sym_preproc_define] = STATE(3743),
    [sym_preproc_undef] = STATE(3743),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3744] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6167),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3744),
    [sym_preproc_endregion] = STATE(3744),
    [sym_preproc_line] = STATE(3744),
    [sym_preproc_pragma] = STATE(3744),
    [sym_preproc_nullable] = STATE(3744),
    [sym_preproc_error] = STATE(3744),
    [sym_preproc_warning] = STATE(3744),
    [sym_preproc_define] = STATE(3744),
    [sym_preproc_undef] = STATE(3744),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3745] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3745),
    [sym_preproc_endregion] = STATE(3745),
    [sym_preproc_line] = STATE(3745),
    [sym_preproc_pragma] = STATE(3745),
    [sym_preproc_nullable] = STATE(3745),
    [sym_preproc_error] = STATE(3745),
    [sym_preproc_warning] = STATE(3745),
    [sym_preproc_define] = STATE(3745),
    [sym_preproc_undef] = STATE(3745),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5684),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3746] = {
    [sym_preproc_region] = STATE(3746),
    [sym_preproc_endregion] = STATE(3746),
    [sym_preproc_line] = STATE(3746),
    [sym_preproc_pragma] = STATE(3746),
    [sym_preproc_nullable] = STATE(3746),
    [sym_preproc_error] = STATE(3746),
    [sym_preproc_warning] = STATE(3746),
    [sym_preproc_define] = STATE(3746),
    [sym_preproc_undef] = STATE(3746),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2981),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_QMARK_QMARK] = ACTIONS(2983),
    [anon_sym_from] = ACTIONS(2983),
    [anon_sym_into] = ACTIONS(2983),
    [anon_sym_join] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_orderby] = ACTIONS(2983),
    [anon_sym_ascending] = ACTIONS(2983),
    [anon_sym_descending] = ACTIONS(2983),
    [anon_sym_group] = ACTIONS(2983),
    [anon_sym_select] = ACTIONS(2983),
    [anon_sym_as] = ACTIONS(2981),
    [anon_sym_is] = ACTIONS(2983),
    [anon_sym_DASH_GT] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3747] = {
    [sym_preproc_region] = STATE(3747),
    [sym_preproc_endregion] = STATE(3747),
    [sym_preproc_line] = STATE(3747),
    [sym_preproc_pragma] = STATE(3747),
    [sym_preproc_nullable] = STATE(3747),
    [sym_preproc_error] = STATE(3747),
    [sym_preproc_warning] = STATE(3747),
    [sym_preproc_define] = STATE(3747),
    [sym_preproc_undef] = STATE(3747),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_where] = ACTIONS(3167),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3167),
    [anon_sym_CARET] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3167),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3167),
    [anon_sym_EQ_EQ] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3167),
    [anon_sym_GT_EQ] = ACTIONS(3167),
    [anon_sym_LT_EQ] = ACTIONS(3167),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3167),
    [anon_sym_and] = ACTIONS(3167),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3167),
    [anon_sym_QMARK_QMARK] = ACTIONS(3167),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_into] = ACTIONS(3167),
    [anon_sym_join] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_orderby] = ACTIONS(3167),
    [anon_sym_ascending] = ACTIONS(3167),
    [anon_sym_descending] = ACTIONS(3167),
    [anon_sym_group] = ACTIONS(3167),
    [anon_sym_select] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3165),
    [anon_sym_is] = ACTIONS(3167),
    [anon_sym_DASH_GT] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3748] = {
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3042),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(3088),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3748),
    [sym_preproc_endregion] = STATE(3748),
    [sym_preproc_line] = STATE(3748),
    [sym_preproc_pragma] = STATE(3748),
    [sym_preproc_nullable] = STATE(3748),
    [sym_preproc_error] = STATE(3748),
    [sym_preproc_warning] = STATE(3748),
    [sym_preproc_define] = STATE(3748),
    [sym_preproc_undef] = STATE(3748),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_ref] = ACTIONS(4265),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_readonly] = ACTIONS(6081),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5826),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3749] = {
    [sym__name] = STATE(5785),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(5462),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3749),
    [sym_preproc_endregion] = STATE(3749),
    [sym_preproc_line] = STATE(3749),
    [sym_preproc_pragma] = STATE(3749),
    [sym_preproc_nullable] = STATE(3749),
    [sym_preproc_error] = STATE(3749),
    [sym_preproc_warning] = STATE(3749),
    [sym_preproc_define] = STATE(3749),
    [sym_preproc_undef] = STATE(3749),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3682),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2891),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(6083),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3750] = {
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3360),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3355),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3750),
    [sym_preproc_endregion] = STATE(3750),
    [sym_preproc_line] = STATE(3750),
    [sym_preproc_pragma] = STATE(3750),
    [sym_preproc_nullable] = STATE(3750),
    [sym_preproc_error] = STATE(3750),
    [sym_preproc_warning] = STATE(3750),
    [sym_preproc_define] = STATE(3750),
    [sym_preproc_undef] = STATE(3750),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_ref] = ACTIONS(4081),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(6087),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5834),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3751] = {
    [sym_variable_declaration] = STATE(7374),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5969),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3751),
    [sym_preproc_endregion] = STATE(3751),
    [sym_preproc_line] = STATE(3751),
    [sym_preproc_pragma] = STATE(3751),
    [sym_preproc_nullable] = STATE(3751),
    [sym_preproc_error] = STATE(3751),
    [sym_preproc_warning] = STATE(3751),
    [sym_preproc_define] = STATE(3751),
    [sym_preproc_undef] = STATE(3751),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3752] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3752),
    [sym_preproc_endregion] = STATE(3752),
    [sym_preproc_line] = STATE(3752),
    [sym_preproc_pragma] = STATE(3752),
    [sym_preproc_nullable] = STATE(3752),
    [sym_preproc_error] = STATE(3752),
    [sym_preproc_warning] = STATE(3752),
    [sym_preproc_define] = STATE(3752),
    [sym_preproc_undef] = STATE(3752),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3660),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(6089),
    [anon_sym_var] = ACTIONS(6091),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3753] = {
    [sym__name] = STATE(4497),
    [sym_alias_qualified_name] = STATE(4398),
    [sym__simple_name] = STATE(4398),
    [sym_qualified_name] = STATE(4398),
    [sym_generic_name] = STATE(4419),
    [sym_type] = STATE(4498),
    [sym_implicit_type] = STATE(4407),
    [sym_array_type] = STATE(4484),
    [sym__array_base_type] = STATE(7286),
    [sym_nullable_type] = STATE(4519),
    [sym_pointer_type] = STATE(4519),
    [sym__pointer_base_type] = STATE(7680),
    [sym_function_pointer_type] = STATE(4519),
    [sym_ref_type] = STATE(4407),
    [sym_scoped_type] = STATE(4407),
    [sym_tuple_type] = STATE(4520),
    [sym_identifier] = STATE(4293),
    [sym__reserved_identifier] = STATE(4388),
    [sym_preproc_region] = STATE(3753),
    [sym_preproc_endregion] = STATE(3753),
    [sym_preproc_line] = STATE(3753),
    [sym_preproc_pragma] = STATE(3753),
    [sym_preproc_nullable] = STATE(3753),
    [sym_preproc_error] = STATE(3753),
    [sym_preproc_warning] = STATE(3753),
    [sym_preproc_define] = STATE(3753),
    [sym_preproc_undef] = STATE(3753),
    [sym__identifier_token] = ACTIONS(4009),
    [anon_sym_alias] = ACTIONS(4011),
    [anon_sym_global] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(6093),
    [anon_sym_ref] = ACTIONS(4013),
    [anon_sym_delegate] = ACTIONS(5732),
    [anon_sym_file] = ACTIONS(4011),
    [anon_sym_readonly] = ACTIONS(6095),
    [anon_sym_where] = ACTIONS(4011),
    [anon_sym_notnull] = ACTIONS(4011),
    [anon_sym_unmanaged] = ACTIONS(4011),
    [anon_sym_scoped] = ACTIONS(5734),
    [anon_sym_var] = ACTIONS(5736),
    [sym_predefined_type] = ACTIONS(5738),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_when] = ACTIONS(4011),
    [anon_sym_from] = ACTIONS(4011),
    [anon_sym_into] = ACTIONS(4011),
    [anon_sym_join] = ACTIONS(4011),
    [anon_sym_on] = ACTIONS(4011),
    [anon_sym_equals] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_orderby] = ACTIONS(4011),
    [anon_sym_ascending] = ACTIONS(4011),
    [anon_sym_descending] = ACTIONS(4011),
    [anon_sym_group] = ACTIONS(4011),
    [anon_sym_by] = ACTIONS(4011),
    [anon_sym_select] = ACTIONS(4011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3754] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7232),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3754),
    [sym_preproc_endregion] = STATE(3754),
    [sym_preproc_line] = STATE(3754),
    [sym_preproc_pragma] = STATE(3754),
    [sym_preproc_nullable] = STATE(3754),
    [sym_preproc_error] = STATE(3754),
    [sym_preproc_warning] = STATE(3754),
    [sym_preproc_define] = STATE(3754),
    [sym_preproc_undef] = STATE(3754),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3755] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7154),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3755),
    [sym_preproc_endregion] = STATE(3755),
    [sym_preproc_line] = STATE(3755),
    [sym_preproc_pragma] = STATE(3755),
    [sym_preproc_nullable] = STATE(3755),
    [sym_preproc_error] = STATE(3755),
    [sym_preproc_warning] = STATE(3755),
    [sym_preproc_define] = STATE(3755),
    [sym_preproc_undef] = STATE(3755),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3756] = {
    [sym_preproc_region] = STATE(3756),
    [sym_preproc_endregion] = STATE(3756),
    [sym_preproc_line] = STATE(3756),
    [sym_preproc_pragma] = STATE(3756),
    [sym_preproc_nullable] = STATE(3756),
    [sym_preproc_error] = STATE(3756),
    [sym_preproc_warning] = STATE(3756),
    [sym_preproc_define] = STATE(3756),
    [sym_preproc_undef] = STATE(3756),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [anon_sym_COMMA] = ACTIONS(5218),
    [anon_sym_LPAREN] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5220),
    [anon_sym_where] = ACTIONS(5218),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_BANG] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5218),
    [anon_sym_DASH_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5220),
    [anon_sym_STAR] = ACTIONS(5218),
    [anon_sym_SLASH] = ACTIONS(5220),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5218),
    [anon_sym_PIPE] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_GT_GT_GT] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5218),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_DOT] = ACTIONS(5220),
    [anon_sym_switch] = ACTIONS(5218),
    [anon_sym_DOT_DOT] = ACTIONS(5218),
    [anon_sym_and] = ACTIONS(5218),
    [anon_sym_or] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_QMARK_QMARK] = ACTIONS(5218),
    [anon_sym_from] = ACTIONS(5218),
    [anon_sym_into] = ACTIONS(5218),
    [anon_sym_join] = ACTIONS(5218),
    [anon_sym_let] = ACTIONS(5218),
    [anon_sym_orderby] = ACTIONS(5218),
    [anon_sym_ascending] = ACTIONS(5218),
    [anon_sym_descending] = ACTIONS(5218),
    [anon_sym_group] = ACTIONS(5218),
    [anon_sym_select] = ACTIONS(5218),
    [anon_sym_as] = ACTIONS(5220),
    [anon_sym_is] = ACTIONS(5218),
    [anon_sym_DASH_GT] = ACTIONS(5218),
    [anon_sym_with] = ACTIONS(5218),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3757] = {
    [sym_preproc_region] = STATE(3757),
    [sym_preproc_endregion] = STATE(3757),
    [sym_preproc_line] = STATE(3757),
    [sym_preproc_pragma] = STATE(3757),
    [sym_preproc_nullable] = STATE(3757),
    [sym_preproc_error] = STATE(3757),
    [sym_preproc_warning] = STATE(3757),
    [sym_preproc_define] = STATE(3757),
    [sym_preproc_undef] = STATE(3757),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_COMMA] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_LT] = ACTIONS(5021),
    [anon_sym_GT] = ACTIONS(5021),
    [anon_sym_where] = ACTIONS(5019),
    [anon_sym_QMARK] = ACTIONS(5021),
    [anon_sym_BANG] = ACTIONS(5021),
    [anon_sym_PLUS_PLUS] = ACTIONS(5019),
    [anon_sym_DASH_DASH] = ACTIONS(5019),
    [anon_sym_PLUS] = ACTIONS(5021),
    [anon_sym_DASH] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(5019),
    [anon_sym_SLASH] = ACTIONS(5021),
    [anon_sym_PERCENT] = ACTIONS(5019),
    [anon_sym_CARET] = ACTIONS(5019),
    [anon_sym_PIPE] = ACTIONS(5021),
    [anon_sym_AMP] = ACTIONS(5021),
    [anon_sym_LT_LT] = ACTIONS(5019),
    [anon_sym_GT_GT] = ACTIONS(5021),
    [anon_sym_GT_GT_GT] = ACTIONS(5019),
    [anon_sym_EQ_EQ] = ACTIONS(5019),
    [anon_sym_BANG_EQ] = ACTIONS(5019),
    [anon_sym_GT_EQ] = ACTIONS(5019),
    [anon_sym_LT_EQ] = ACTIONS(5019),
    [anon_sym_DOT] = ACTIONS(5021),
    [anon_sym_switch] = ACTIONS(5019),
    [anon_sym_DOT_DOT] = ACTIONS(5019),
    [anon_sym_and] = ACTIONS(5019),
    [anon_sym_or] = ACTIONS(5021),
    [anon_sym_AMP_AMP] = ACTIONS(5019),
    [anon_sym_PIPE_PIPE] = ACTIONS(5019),
    [anon_sym_QMARK_QMARK] = ACTIONS(5019),
    [anon_sym_from] = ACTIONS(5019),
    [anon_sym_into] = ACTIONS(5019),
    [anon_sym_join] = ACTIONS(5019),
    [anon_sym_let] = ACTIONS(5019),
    [anon_sym_orderby] = ACTIONS(5019),
    [anon_sym_ascending] = ACTIONS(5019),
    [anon_sym_descending] = ACTIONS(5019),
    [anon_sym_group] = ACTIONS(5019),
    [anon_sym_select] = ACTIONS(5019),
    [anon_sym_as] = ACTIONS(5021),
    [anon_sym_is] = ACTIONS(5019),
    [anon_sym_DASH_GT] = ACTIONS(5019),
    [anon_sym_with] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3758] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3758),
    [sym_preproc_endregion] = STATE(3758),
    [sym_preproc_line] = STATE(3758),
    [sym_preproc_pragma] = STATE(3758),
    [sym_preproc_nullable] = STATE(3758),
    [sym_preproc_error] = STATE(3758),
    [sym_preproc_warning] = STATE(3758),
    [sym_preproc_define] = STATE(3758),
    [sym_preproc_undef] = STATE(3758),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5550),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6097),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5558),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3759] = {
    [sym_preproc_region] = STATE(3759),
    [sym_preproc_endregion] = STATE(3759),
    [sym_preproc_line] = STATE(3759),
    [sym_preproc_pragma] = STATE(3759),
    [sym_preproc_nullable] = STATE(3759),
    [sym_preproc_error] = STATE(3759),
    [sym_preproc_warning] = STATE(3759),
    [sym_preproc_define] = STATE(3759),
    [sym_preproc_undef] = STATE(3759),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5459),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3760] = {
    [sym_preproc_region] = STATE(3760),
    [sym_preproc_endregion] = STATE(3760),
    [sym_preproc_line] = STATE(3760),
    [sym_preproc_pragma] = STATE(3760),
    [sym_preproc_nullable] = STATE(3760),
    [sym_preproc_error] = STATE(3760),
    [sym_preproc_warning] = STATE(3760),
    [sym_preproc_define] = STATE(3760),
    [sym_preproc_undef] = STATE(3760),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5099),
    [anon_sym_where] = ACTIONS(5097),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_BANG] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_SLASH] = ACTIONS(5099),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5097),
    [anon_sym_PIPE] = ACTIONS(5099),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym_LT_LT] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5099),
    [anon_sym_GT_GT_GT] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_DOT] = ACTIONS(5099),
    [anon_sym_switch] = ACTIONS(5097),
    [anon_sym_DOT_DOT] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_or] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_QMARK_QMARK] = ACTIONS(5097),
    [anon_sym_from] = ACTIONS(5097),
    [anon_sym_into] = ACTIONS(5097),
    [anon_sym_join] = ACTIONS(5097),
    [anon_sym_let] = ACTIONS(5097),
    [anon_sym_orderby] = ACTIONS(5097),
    [anon_sym_ascending] = ACTIONS(5097),
    [anon_sym_descending] = ACTIONS(5097),
    [anon_sym_group] = ACTIONS(5097),
    [anon_sym_select] = ACTIONS(5097),
    [anon_sym_as] = ACTIONS(5099),
    [anon_sym_is] = ACTIONS(5097),
    [anon_sym_DASH_GT] = ACTIONS(5097),
    [anon_sym_with] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3761] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3761),
    [sym_preproc_endregion] = STATE(3761),
    [sym_preproc_line] = STATE(3761),
    [sym_preproc_pragma] = STATE(3761),
    [sym_preproc_nullable] = STATE(3761),
    [sym_preproc_error] = STATE(3761),
    [sym_preproc_warning] = STATE(3761),
    [sym_preproc_define] = STATE(3761),
    [sym_preproc_undef] = STATE(3761),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5794),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5794),
    [anon_sym_into] = ACTIONS(5794),
    [anon_sym_join] = ACTIONS(5794),
    [anon_sym_let] = ACTIONS(5794),
    [anon_sym_orderby] = ACTIONS(5794),
    [anon_sym_ascending] = ACTIONS(5794),
    [anon_sym_descending] = ACTIONS(5794),
    [anon_sym_group] = ACTIONS(5794),
    [anon_sym_select] = ACTIONS(5794),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3762] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3762),
    [sym_preproc_endregion] = STATE(3762),
    [sym_preproc_line] = STATE(3762),
    [sym_preproc_pragma] = STATE(3762),
    [sym_preproc_nullable] = STATE(3762),
    [sym_preproc_error] = STATE(3762),
    [sym_preproc_warning] = STATE(3762),
    [sym_preproc_define] = STATE(3762),
    [sym_preproc_undef] = STATE(3762),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_into] = ACTIONS(1229),
    [anon_sym_join] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_orderby] = ACTIONS(1229),
    [anon_sym_ascending] = ACTIONS(1229),
    [anon_sym_descending] = ACTIONS(1229),
    [anon_sym_group] = ACTIONS(1229),
    [anon_sym_select] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_is] = ACTIONS(1229),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(1229),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3763] = {
    [sym__name] = STATE(4107),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2961),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(2979),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3787),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3763),
    [sym_preproc_endregion] = STATE(3763),
    [sym_preproc_line] = STATE(3763),
    [sym_preproc_pragma] = STATE(3763),
    [sym_preproc_nullable] = STATE(3763),
    [sym_preproc_error] = STATE(3763),
    [sym_preproc_warning] = STATE(3763),
    [sym_preproc_define] = STATE(3763),
    [sym_preproc_undef] = STATE(3763),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_ref] = ACTIONS(4231),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_readonly] = ACTIONS(6123),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5864),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3764] = {
    [sym_preproc_region] = STATE(3764),
    [sym_preproc_endregion] = STATE(3764),
    [sym_preproc_line] = STATE(3764),
    [sym_preproc_pragma] = STATE(3764),
    [sym_preproc_nullable] = STATE(3764),
    [sym_preproc_error] = STATE(3764),
    [sym_preproc_warning] = STATE(3764),
    [sym_preproc_define] = STATE(3764),
    [sym_preproc_undef] = STATE(3764),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5115),
    [anon_sym_where] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5115),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_PIPE] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_GT_GT_GT] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5113),
    [anon_sym_BANG_EQ] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5113),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_DOT] = ACTIONS(5115),
    [anon_sym_switch] = ACTIONS(5113),
    [anon_sym_DOT_DOT] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_or] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5113),
    [anon_sym_QMARK_QMARK] = ACTIONS(5113),
    [anon_sym_from] = ACTIONS(5113),
    [anon_sym_into] = ACTIONS(5113),
    [anon_sym_join] = ACTIONS(5113),
    [anon_sym_let] = ACTIONS(5113),
    [anon_sym_orderby] = ACTIONS(5113),
    [anon_sym_ascending] = ACTIONS(5113),
    [anon_sym_descending] = ACTIONS(5113),
    [anon_sym_group] = ACTIONS(5113),
    [anon_sym_select] = ACTIONS(5113),
    [anon_sym_as] = ACTIONS(5115),
    [anon_sym_is] = ACTIONS(5113),
    [anon_sym_DASH_GT] = ACTIONS(5113),
    [anon_sym_with] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3765] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3765),
    [sym_preproc_endregion] = STATE(3765),
    [sym_preproc_line] = STATE(3765),
    [sym_preproc_pragma] = STATE(3765),
    [sym_preproc_nullable] = STATE(3765),
    [sym_preproc_error] = STATE(3765),
    [sym_preproc_warning] = STATE(3765),
    [sym_preproc_define] = STATE(3765),
    [sym_preproc_undef] = STATE(3765),
    [anon_sym_SEMI] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_RBRACK] = ACTIONS(5886),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5886),
    [anon_sym_RBRACE] = ACTIONS(5886),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5886),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5886),
    [aux_sym_preproc_else_token1] = ACTIONS(5886),
    [aux_sym_preproc_elif_token1] = ACTIONS(5886),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3766] = {
    [sym_preproc_region] = STATE(3766),
    [sym_preproc_endregion] = STATE(3766),
    [sym_preproc_line] = STATE(3766),
    [sym_preproc_pragma] = STATE(3766),
    [sym_preproc_nullable] = STATE(3766),
    [sym_preproc_error] = STATE(3766),
    [sym_preproc_warning] = STATE(3766),
    [sym_preproc_define] = STATE(3766),
    [sym_preproc_undef] = STATE(3766),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4293),
    [anon_sym_GT] = ACTIONS(4293),
    [anon_sym_where] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4293),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4293),
    [anon_sym_STAR] = ACTIONS(4291),
    [anon_sym_SLASH] = ACTIONS(4293),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4293),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4293),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_DOT] = ACTIONS(4293),
    [anon_sym_switch] = ACTIONS(4291),
    [anon_sym_DOT_DOT] = ACTIONS(4291),
    [anon_sym_and] = ACTIONS(4291),
    [anon_sym_or] = ACTIONS(4293),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_QMARK_QMARK] = ACTIONS(4291),
    [anon_sym_from] = ACTIONS(4291),
    [anon_sym_into] = ACTIONS(4291),
    [anon_sym_join] = ACTIONS(4291),
    [anon_sym_let] = ACTIONS(4291),
    [anon_sym_orderby] = ACTIONS(4291),
    [anon_sym_ascending] = ACTIONS(4291),
    [anon_sym_descending] = ACTIONS(4291),
    [anon_sym_group] = ACTIONS(4291),
    [anon_sym_select] = ACTIONS(4291),
    [anon_sym_as] = ACTIONS(4293),
    [anon_sym_is] = ACTIONS(4291),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_with] = ACTIONS(4291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3767] = {
    [sym_preproc_region] = STATE(3767),
    [sym_preproc_endregion] = STATE(3767),
    [sym_preproc_line] = STATE(3767),
    [sym_preproc_pragma] = STATE(3767),
    [sym_preproc_nullable] = STATE(3767),
    [sym_preproc_error] = STATE(3767),
    [sym_preproc_warning] = STATE(3767),
    [sym_preproc_define] = STATE(3767),
    [sym_preproc_undef] = STATE(3767),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_COMMA] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5119),
    [anon_sym_where] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_BANG] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_PIPE] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_GT_GT_GT] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5117),
    [anon_sym_BANG_EQ] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5117),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_DOT] = ACTIONS(5119),
    [anon_sym_switch] = ACTIONS(5117),
    [anon_sym_DOT_DOT] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_or] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5117),
    [anon_sym_QMARK_QMARK] = ACTIONS(5117),
    [anon_sym_from] = ACTIONS(5117),
    [anon_sym_into] = ACTIONS(5117),
    [anon_sym_join] = ACTIONS(5117),
    [anon_sym_let] = ACTIONS(5117),
    [anon_sym_orderby] = ACTIONS(5117),
    [anon_sym_ascending] = ACTIONS(5117),
    [anon_sym_descending] = ACTIONS(5117),
    [anon_sym_group] = ACTIONS(5117),
    [anon_sym_select] = ACTIONS(5117),
    [anon_sym_as] = ACTIONS(5119),
    [anon_sym_is] = ACTIONS(5117),
    [anon_sym_DASH_GT] = ACTIONS(5117),
    [anon_sym_with] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3768] = {
    [sym_preproc_region] = STATE(3768),
    [sym_preproc_endregion] = STATE(3768),
    [sym_preproc_line] = STATE(3768),
    [sym_preproc_pragma] = STATE(3768),
    [sym_preproc_nullable] = STATE(3768),
    [sym_preproc_error] = STATE(3768),
    [sym_preproc_warning] = STATE(3768),
    [sym_preproc_define] = STATE(3768),
    [sym_preproc_undef] = STATE(3768),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5123),
    [anon_sym_where] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5123),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5123),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_PIPE] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_GT_GT_GT] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5121),
    [anon_sym_BANG_EQ] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5121),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_DOT] = ACTIONS(5123),
    [anon_sym_switch] = ACTIONS(5121),
    [anon_sym_DOT_DOT] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_or] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5121),
    [anon_sym_QMARK_QMARK] = ACTIONS(5121),
    [anon_sym_from] = ACTIONS(5121),
    [anon_sym_into] = ACTIONS(5121),
    [anon_sym_join] = ACTIONS(5121),
    [anon_sym_let] = ACTIONS(5121),
    [anon_sym_orderby] = ACTIONS(5121),
    [anon_sym_ascending] = ACTIONS(5121),
    [anon_sym_descending] = ACTIONS(5121),
    [anon_sym_group] = ACTIONS(5121),
    [anon_sym_select] = ACTIONS(5121),
    [anon_sym_as] = ACTIONS(5123),
    [anon_sym_is] = ACTIONS(5121),
    [anon_sym_DASH_GT] = ACTIONS(5121),
    [anon_sym_with] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3769] = {
    [sym_preproc_region] = STATE(3769),
    [sym_preproc_endregion] = STATE(3769),
    [sym_preproc_line] = STATE(3769),
    [sym_preproc_pragma] = STATE(3769),
    [sym_preproc_nullable] = STATE(3769),
    [sym_preproc_error] = STATE(3769),
    [sym_preproc_warning] = STATE(3769),
    [sym_preproc_define] = STATE(3769),
    [sym_preproc_undef] = STATE(3769),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_where] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5029),
    [anon_sym_BANG] = ACTIONS(5029),
    [anon_sym_PLUS_PLUS] = ACTIONS(5027),
    [anon_sym_DASH_DASH] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_PERCENT] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_GT] = ACTIONS(5027),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_switch] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5027),
    [anon_sym_and] = ACTIONS(5027),
    [anon_sym_or] = ACTIONS(5029),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK_QMARK] = ACTIONS(5027),
    [anon_sym_from] = ACTIONS(5027),
    [anon_sym_into] = ACTIONS(5027),
    [anon_sym_join] = ACTIONS(5027),
    [anon_sym_let] = ACTIONS(5027),
    [anon_sym_orderby] = ACTIONS(5027),
    [anon_sym_ascending] = ACTIONS(5027),
    [anon_sym_descending] = ACTIONS(5027),
    [anon_sym_group] = ACTIONS(5027),
    [anon_sym_select] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5029),
    [anon_sym_is] = ACTIONS(5027),
    [anon_sym_DASH_GT] = ACTIONS(5027),
    [anon_sym_with] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3770] = {
    [sym_preproc_region] = STATE(3770),
    [sym_preproc_endregion] = STATE(3770),
    [sym_preproc_line] = STATE(3770),
    [sym_preproc_pragma] = STATE(3770),
    [sym_preproc_nullable] = STATE(3770),
    [sym_preproc_error] = STATE(3770),
    [sym_preproc_warning] = STATE(3770),
    [sym_preproc_define] = STATE(3770),
    [sym_preproc_undef] = STATE(3770),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_COMMA] = ACTIONS(5047),
    [anon_sym_LPAREN] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_where] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_BANG] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5049),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_PIPE] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5049),
    [anon_sym_GT_GT_GT] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5047),
    [anon_sym_BANG_EQ] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_DOT] = ACTIONS(5049),
    [anon_sym_switch] = ACTIONS(5047),
    [anon_sym_DOT_DOT] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_or] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_QMARK_QMARK] = ACTIONS(5047),
    [anon_sym_from] = ACTIONS(5047),
    [anon_sym_into] = ACTIONS(5047),
    [anon_sym_join] = ACTIONS(5047),
    [anon_sym_let] = ACTIONS(5047),
    [anon_sym_orderby] = ACTIONS(5047),
    [anon_sym_ascending] = ACTIONS(5047),
    [anon_sym_descending] = ACTIONS(5047),
    [anon_sym_group] = ACTIONS(5047),
    [anon_sym_select] = ACTIONS(5047),
    [anon_sym_as] = ACTIONS(5049),
    [anon_sym_is] = ACTIONS(5047),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [anon_sym_with] = ACTIONS(5047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3771] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3771),
    [sym_preproc_endregion] = STATE(3771),
    [sym_preproc_line] = STATE(3771),
    [sym_preproc_pragma] = STATE(3771),
    [sym_preproc_nullable] = STATE(3771),
    [sym_preproc_error] = STATE(3771),
    [sym_preproc_warning] = STATE(3771),
    [sym_preproc_define] = STATE(3771),
    [sym_preproc_undef] = STATE(3771),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5924),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5926),
    [anon_sym_where] = ACTIONS(5924),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_SLASH] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_PIPE] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_GT_GT] = ACTIONS(5926),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5924),
    [anon_sym_BANG_EQ] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5924),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5924),
    [anon_sym_QMARK_QMARK] = ACTIONS(5924),
    [anon_sym_from] = ACTIONS(5924),
    [anon_sym_into] = ACTIONS(5924),
    [anon_sym_join] = ACTIONS(5924),
    [anon_sym_let] = ACTIONS(5924),
    [anon_sym_orderby] = ACTIONS(5924),
    [anon_sym_ascending] = ACTIONS(5924),
    [anon_sym_descending] = ACTIONS(5924),
    [anon_sym_group] = ACTIONS(5924),
    [anon_sym_select] = ACTIONS(5924),
    [anon_sym_as] = ACTIONS(5926),
    [anon_sym_is] = ACTIONS(5924),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5924),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3772] = {
    [sym_preproc_region] = STATE(3772),
    [sym_preproc_endregion] = STATE(3772),
    [sym_preproc_line] = STATE(3772),
    [sym_preproc_pragma] = STATE(3772),
    [sym_preproc_nullable] = STATE(3772),
    [sym_preproc_error] = STATE(3772),
    [sym_preproc_warning] = STATE(3772),
    [sym_preproc_define] = STATE(3772),
    [sym_preproc_undef] = STATE(3772),
    [anon_sym_LBRACK] = ACTIONS(4999),
    [anon_sym_COMMA] = ACTIONS(4999),
    [anon_sym_LPAREN] = ACTIONS(4999),
    [anon_sym_LT] = ACTIONS(5001),
    [anon_sym_GT] = ACTIONS(5001),
    [anon_sym_where] = ACTIONS(4999),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(4999),
    [anon_sym_PLUS] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(4999),
    [anon_sym_SLASH] = ACTIONS(5001),
    [anon_sym_PERCENT] = ACTIONS(4999),
    [anon_sym_CARET] = ACTIONS(4999),
    [anon_sym_PIPE] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_LT_LT] = ACTIONS(4999),
    [anon_sym_GT_GT] = ACTIONS(5001),
    [anon_sym_GT_GT_GT] = ACTIONS(4999),
    [anon_sym_EQ_EQ] = ACTIONS(4999),
    [anon_sym_BANG_EQ] = ACTIONS(4999),
    [anon_sym_GT_EQ] = ACTIONS(4999),
    [anon_sym_LT_EQ] = ACTIONS(4999),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_switch] = ACTIONS(4999),
    [anon_sym_DOT_DOT] = ACTIONS(4999),
    [anon_sym_and] = ACTIONS(4999),
    [anon_sym_or] = ACTIONS(5001),
    [anon_sym_AMP_AMP] = ACTIONS(4999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4999),
    [anon_sym_QMARK_QMARK] = ACTIONS(4999),
    [anon_sym_from] = ACTIONS(4999),
    [anon_sym_into] = ACTIONS(4999),
    [anon_sym_join] = ACTIONS(4999),
    [anon_sym_let] = ACTIONS(4999),
    [anon_sym_orderby] = ACTIONS(4999),
    [anon_sym_ascending] = ACTIONS(4999),
    [anon_sym_descending] = ACTIONS(4999),
    [anon_sym_group] = ACTIONS(4999),
    [anon_sym_select] = ACTIONS(4999),
    [anon_sym_as] = ACTIONS(5001),
    [anon_sym_is] = ACTIONS(4999),
    [anon_sym_DASH_GT] = ACTIONS(4999),
    [anon_sym_with] = ACTIONS(4999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3773] = {
    [sym_preproc_region] = STATE(3773),
    [sym_preproc_endregion] = STATE(3773),
    [sym_preproc_line] = STATE(3773),
    [sym_preproc_pragma] = STATE(3773),
    [sym_preproc_nullable] = STATE(3773),
    [sym_preproc_error] = STATE(3773),
    [sym_preproc_warning] = STATE(3773),
    [sym_preproc_define] = STATE(3773),
    [sym_preproc_undef] = STATE(3773),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_LPAREN] = ACTIONS(4967),
    [anon_sym_LT] = ACTIONS(4969),
    [anon_sym_GT] = ACTIONS(4969),
    [anon_sym_where] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4969),
    [anon_sym_BANG] = ACTIONS(4969),
    [anon_sym_PLUS_PLUS] = ACTIONS(4967),
    [anon_sym_DASH_DASH] = ACTIONS(4967),
    [anon_sym_PLUS] = ACTIONS(4969),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4967),
    [anon_sym_SLASH] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_CARET] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4969),
    [anon_sym_LT_LT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4969),
    [anon_sym_GT_GT_GT] = ACTIONS(4967),
    [anon_sym_EQ_EQ] = ACTIONS(4967),
    [anon_sym_BANG_EQ] = ACTIONS(4967),
    [anon_sym_GT_EQ] = ACTIONS(4967),
    [anon_sym_LT_EQ] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_switch] = ACTIONS(4967),
    [anon_sym_DOT_DOT] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4969),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE_PIPE] = ACTIONS(4967),
    [anon_sym_QMARK_QMARK] = ACTIONS(4967),
    [anon_sym_from] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_join] = ACTIONS(4967),
    [anon_sym_let] = ACTIONS(4967),
    [anon_sym_orderby] = ACTIONS(4967),
    [anon_sym_ascending] = ACTIONS(4967),
    [anon_sym_descending] = ACTIONS(4967),
    [anon_sym_group] = ACTIONS(4967),
    [anon_sym_select] = ACTIONS(4967),
    [anon_sym_as] = ACTIONS(4969),
    [anon_sym_is] = ACTIONS(4967),
    [anon_sym_DASH_GT] = ACTIONS(4967),
    [anon_sym_with] = ACTIONS(4967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3774] = {
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3263),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3234),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3774),
    [sym_preproc_endregion] = STATE(3774),
    [sym_preproc_line] = STATE(3774),
    [sym_preproc_pragma] = STATE(3774),
    [sym_preproc_nullable] = STATE(3774),
    [sym_preproc_error] = STATE(3774),
    [sym_preproc_warning] = STATE(3774),
    [sym_preproc_define] = STATE(3774),
    [sym_preproc_undef] = STATE(3774),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(6163),
    [anon_sym_ref] = ACTIONS(4062),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(6165),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5770),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3775] = {
    [sym_preproc_region] = STATE(3775),
    [sym_preproc_endregion] = STATE(3775),
    [sym_preproc_line] = STATE(3775),
    [sym_preproc_pragma] = STATE(3775),
    [sym_preproc_nullable] = STATE(3775),
    [sym_preproc_error] = STATE(3775),
    [sym_preproc_warning] = STATE(3775),
    [sym_preproc_define] = STATE(3775),
    [sym_preproc_undef] = STATE(3775),
    [anon_sym_LBRACK] = ACTIONS(5234),
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_LPAREN] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_where] = ACTIONS(5234),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_GT_GT_GT] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5234),
    [anon_sym_BANG_EQ] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5234),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_switch] = ACTIONS(5234),
    [anon_sym_DOT_DOT] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_or] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5234),
    [anon_sym_QMARK_QMARK] = ACTIONS(5234),
    [anon_sym_from] = ACTIONS(5234),
    [anon_sym_into] = ACTIONS(5234),
    [anon_sym_join] = ACTIONS(5234),
    [anon_sym_let] = ACTIONS(5234),
    [anon_sym_orderby] = ACTIONS(5234),
    [anon_sym_ascending] = ACTIONS(5234),
    [anon_sym_descending] = ACTIONS(5234),
    [anon_sym_group] = ACTIONS(5234),
    [anon_sym_select] = ACTIONS(5234),
    [anon_sym_as] = ACTIONS(5236),
    [anon_sym_is] = ACTIONS(5234),
    [anon_sym_DASH_GT] = ACTIONS(5234),
    [anon_sym_with] = ACTIONS(5234),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3776] = {
    [sym_preproc_region] = STATE(3776),
    [sym_preproc_endregion] = STATE(3776),
    [sym_preproc_line] = STATE(3776),
    [sym_preproc_pragma] = STATE(3776),
    [sym_preproc_nullable] = STATE(3776),
    [sym_preproc_error] = STATE(3776),
    [sym_preproc_warning] = STATE(3776),
    [sym_preproc_define] = STATE(3776),
    [sym_preproc_undef] = STATE(3776),
    [anon_sym_LBRACK] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5242),
    [anon_sym_LPAREN] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5244),
    [anon_sym_where] = ACTIONS(5242),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_PIPE] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5244),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5244),
    [anon_sym_GT_GT_GT] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_DOT] = ACTIONS(5244),
    [anon_sym_switch] = ACTIONS(5242),
    [anon_sym_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5242),
    [anon_sym_QMARK_QMARK] = ACTIONS(5242),
    [anon_sym_from] = ACTIONS(5242),
    [anon_sym_into] = ACTIONS(5242),
    [anon_sym_join] = ACTIONS(5242),
    [anon_sym_let] = ACTIONS(5242),
    [anon_sym_orderby] = ACTIONS(5242),
    [anon_sym_ascending] = ACTIONS(5242),
    [anon_sym_descending] = ACTIONS(5242),
    [anon_sym_group] = ACTIONS(5242),
    [anon_sym_select] = ACTIONS(5242),
    [anon_sym_as] = ACTIONS(5244),
    [anon_sym_is] = ACTIONS(5242),
    [anon_sym_DASH_GT] = ACTIONS(5242),
    [anon_sym_with] = ACTIONS(5242),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3777] = {
    [sym_preproc_region] = STATE(3777),
    [sym_preproc_endregion] = STATE(3777),
    [sym_preproc_line] = STATE(3777),
    [sym_preproc_pragma] = STATE(3777),
    [sym_preproc_nullable] = STATE(3777),
    [sym_preproc_error] = STATE(3777),
    [sym_preproc_warning] = STATE(3777),
    [sym_preproc_define] = STATE(3777),
    [sym_preproc_undef] = STATE(3777),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_where] = ACTIONS(5246),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5246),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_DOT] = ACTIONS(5248),
    [anon_sym_switch] = ACTIONS(5246),
    [anon_sym_DOT_DOT] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_or] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_QMARK_QMARK] = ACTIONS(5246),
    [anon_sym_from] = ACTIONS(5246),
    [anon_sym_into] = ACTIONS(5246),
    [anon_sym_join] = ACTIONS(5246),
    [anon_sym_let] = ACTIONS(5246),
    [anon_sym_orderby] = ACTIONS(5246),
    [anon_sym_ascending] = ACTIONS(5246),
    [anon_sym_descending] = ACTIONS(5246),
    [anon_sym_group] = ACTIONS(5246),
    [anon_sym_select] = ACTIONS(5246),
    [anon_sym_as] = ACTIONS(5248),
    [anon_sym_is] = ACTIONS(5246),
    [anon_sym_DASH_GT] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5246),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3778] = {
    [sym_preproc_region] = STATE(3778),
    [sym_preproc_endregion] = STATE(3778),
    [sym_preproc_line] = STATE(3778),
    [sym_preproc_pragma] = STATE(3778),
    [sym_preproc_nullable] = STATE(3778),
    [sym_preproc_error] = STATE(3778),
    [sym_preproc_warning] = STATE(3778),
    [sym_preproc_define] = STATE(3778),
    [sym_preproc_undef] = STATE(3778),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_LPAREN] = ACTIONS(5480),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_where] = ACTIONS(5480),
    [anon_sym_QMARK] = ACTIONS(5482),
    [anon_sym_BANG] = ACTIONS(5482),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5480),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5480),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_GT_GT_GT] = ACTIONS(5480),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5480),
    [anon_sym_DOT_DOT] = ACTIONS(5480),
    [anon_sym_and] = ACTIONS(6167),
    [anon_sym_or] = ACTIONS(6169),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_QMARK_QMARK] = ACTIONS(5480),
    [anon_sym_from] = ACTIONS(5480),
    [anon_sym_into] = ACTIONS(5480),
    [anon_sym_join] = ACTIONS(5480),
    [anon_sym_let] = ACTIONS(5480),
    [anon_sym_orderby] = ACTIONS(5480),
    [anon_sym_ascending] = ACTIONS(5480),
    [anon_sym_descending] = ACTIONS(5480),
    [anon_sym_group] = ACTIONS(5480),
    [anon_sym_select] = ACTIONS(5480),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_with] = ACTIONS(5480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3779] = {
    [sym_preproc_region] = STATE(3779),
    [sym_preproc_endregion] = STATE(3779),
    [sym_preproc_line] = STATE(3779),
    [sym_preproc_pragma] = STATE(3779),
    [sym_preproc_nullable] = STATE(3779),
    [sym_preproc_error] = STATE(3779),
    [sym_preproc_warning] = STATE(3779),
    [sym_preproc_define] = STATE(3779),
    [sym_preproc_undef] = STATE(3779),
    [anon_sym_LBRACK] = ACTIONS(6171),
    [anon_sym_COMMA] = ACTIONS(6171),
    [anon_sym_LPAREN] = ACTIONS(6171),
    [anon_sym_LT] = ACTIONS(6173),
    [anon_sym_GT] = ACTIONS(6173),
    [anon_sym_where] = ACTIONS(6171),
    [anon_sym_QMARK] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(6173),
    [anon_sym_PLUS_PLUS] = ACTIONS(6171),
    [anon_sym_DASH_DASH] = ACTIONS(6171),
    [anon_sym_PLUS] = ACTIONS(6173),
    [anon_sym_DASH] = ACTIONS(6173),
    [anon_sym_STAR] = ACTIONS(6171),
    [anon_sym_SLASH] = ACTIONS(6173),
    [anon_sym_PERCENT] = ACTIONS(6171),
    [anon_sym_CARET] = ACTIONS(6171),
    [anon_sym_PIPE] = ACTIONS(6173),
    [anon_sym_AMP] = ACTIONS(6173),
    [anon_sym_LT_LT] = ACTIONS(6171),
    [anon_sym_GT_GT] = ACTIONS(6173),
    [anon_sym_GT_GT_GT] = ACTIONS(6171),
    [anon_sym_EQ_EQ] = ACTIONS(6171),
    [anon_sym_BANG_EQ] = ACTIONS(6171),
    [anon_sym_GT_EQ] = ACTIONS(6171),
    [anon_sym_LT_EQ] = ACTIONS(6171),
    [anon_sym_DOT] = ACTIONS(6173),
    [anon_sym_switch] = ACTIONS(6171),
    [anon_sym_DOT_DOT] = ACTIONS(6171),
    [anon_sym_and] = ACTIONS(6167),
    [anon_sym_or] = ACTIONS(6169),
    [anon_sym_AMP_AMP] = ACTIONS(6171),
    [anon_sym_PIPE_PIPE] = ACTIONS(6171),
    [anon_sym_QMARK_QMARK] = ACTIONS(6171),
    [anon_sym_from] = ACTIONS(6171),
    [anon_sym_into] = ACTIONS(6171),
    [anon_sym_join] = ACTIONS(6171),
    [anon_sym_let] = ACTIONS(6171),
    [anon_sym_orderby] = ACTIONS(6171),
    [anon_sym_ascending] = ACTIONS(6171),
    [anon_sym_descending] = ACTIONS(6171),
    [anon_sym_group] = ACTIONS(6171),
    [anon_sym_select] = ACTIONS(6171),
    [anon_sym_as] = ACTIONS(6173),
    [anon_sym_is] = ACTIONS(6171),
    [anon_sym_DASH_GT] = ACTIONS(6171),
    [anon_sym_with] = ACTIONS(6171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3780] = {
    [sym_preproc_region] = STATE(3780),
    [sym_preproc_endregion] = STATE(3780),
    [sym_preproc_line] = STATE(3780),
    [sym_preproc_pragma] = STATE(3780),
    [sym_preproc_nullable] = STATE(3780),
    [sym_preproc_error] = STATE(3780),
    [sym_preproc_warning] = STATE(3780),
    [sym_preproc_define] = STATE(3780),
    [sym_preproc_undef] = STATE(3780),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_where] = ACTIONS(5129),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_BANG] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5131),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_GT_GT_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_BANG_EQ] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5129),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_DOT] = ACTIONS(5131),
    [anon_sym_switch] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_or] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_QMARK_QMARK] = ACTIONS(5129),
    [anon_sym_from] = ACTIONS(5129),
    [anon_sym_into] = ACTIONS(5129),
    [anon_sym_join] = ACTIONS(5129),
    [anon_sym_let] = ACTIONS(5129),
    [anon_sym_orderby] = ACTIONS(5129),
    [anon_sym_ascending] = ACTIONS(5129),
    [anon_sym_descending] = ACTIONS(5129),
    [anon_sym_group] = ACTIONS(5129),
    [anon_sym_select] = ACTIONS(5129),
    [anon_sym_as] = ACTIONS(5131),
    [anon_sym_is] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_with] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3781] = {
    [sym_preproc_region] = STATE(3781),
    [sym_preproc_endregion] = STATE(3781),
    [sym_preproc_line] = STATE(3781),
    [sym_preproc_pragma] = STATE(3781),
    [sym_preproc_nullable] = STATE(3781),
    [sym_preproc_error] = STATE(3781),
    [sym_preproc_warning] = STATE(3781),
    [sym_preproc_define] = STATE(3781),
    [sym_preproc_undef] = STATE(3781),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_COMMA] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5111),
    [anon_sym_where] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_BANG] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5111),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5111),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_PIPE] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5111),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5111),
    [anon_sym_GT_GT_GT] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5109),
    [anon_sym_BANG_EQ] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5109),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_DOT] = ACTIONS(5111),
    [anon_sym_switch] = ACTIONS(5109),
    [anon_sym_DOT_DOT] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_or] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5109),
    [anon_sym_QMARK_QMARK] = ACTIONS(5109),
    [anon_sym_from] = ACTIONS(5109),
    [anon_sym_into] = ACTIONS(5109),
    [anon_sym_join] = ACTIONS(5109),
    [anon_sym_let] = ACTIONS(5109),
    [anon_sym_orderby] = ACTIONS(5109),
    [anon_sym_ascending] = ACTIONS(5109),
    [anon_sym_descending] = ACTIONS(5109),
    [anon_sym_group] = ACTIONS(5109),
    [anon_sym_select] = ACTIONS(5109),
    [anon_sym_as] = ACTIONS(5111),
    [anon_sym_is] = ACTIONS(5109),
    [anon_sym_DASH_GT] = ACTIONS(5109),
    [anon_sym_with] = ACTIONS(5109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3782] = {
    [sym_preproc_region] = STATE(3782),
    [sym_preproc_endregion] = STATE(3782),
    [sym_preproc_line] = STATE(3782),
    [sym_preproc_pragma] = STATE(3782),
    [sym_preproc_nullable] = STATE(3782),
    [sym_preproc_error] = STATE(3782),
    [sym_preproc_warning] = STATE(3782),
    [sym_preproc_define] = STATE(3782),
    [sym_preproc_undef] = STATE(3782),
    [anon_sym_LBRACK] = ACTIONS(5250),
    [anon_sym_COMMA] = ACTIONS(5250),
    [anon_sym_LPAREN] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_where] = ACTIONS(5250),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_BANG] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5252),
    [anon_sym_STAR] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5250),
    [anon_sym_PIPE] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5252),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5252),
    [anon_sym_GT_GT_GT] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_DOT] = ACTIONS(5252),
    [anon_sym_switch] = ACTIONS(5250),
    [anon_sym_DOT_DOT] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_or] = ACTIONS(5252),
    [anon_sym_AMP_AMP] = ACTIONS(5250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5250),
    [anon_sym_QMARK_QMARK] = ACTIONS(5250),
    [anon_sym_from] = ACTIONS(5250),
    [anon_sym_into] = ACTIONS(5250),
    [anon_sym_join] = ACTIONS(5250),
    [anon_sym_let] = ACTIONS(5250),
    [anon_sym_orderby] = ACTIONS(5250),
    [anon_sym_ascending] = ACTIONS(5250),
    [anon_sym_descending] = ACTIONS(5250),
    [anon_sym_group] = ACTIONS(5250),
    [anon_sym_select] = ACTIONS(5250),
    [anon_sym_as] = ACTIONS(5252),
    [anon_sym_is] = ACTIONS(5250),
    [anon_sym_DASH_GT] = ACTIONS(5250),
    [anon_sym_with] = ACTIONS(5250),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3783] = {
    [sym_preproc_region] = STATE(3783),
    [sym_preproc_endregion] = STATE(3783),
    [sym_preproc_line] = STATE(3783),
    [sym_preproc_pragma] = STATE(3783),
    [sym_preproc_nullable] = STATE(3783),
    [sym_preproc_error] = STATE(3783),
    [sym_preproc_warning] = STATE(3783),
    [sym_preproc_define] = STATE(3783),
    [sym_preproc_undef] = STATE(3783),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_LPAREN] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5181),
    [anon_sym_where] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_BANG] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5181),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_PIPE] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5181),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_GT_GT_GT] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5179),
    [anon_sym_BANG_EQ] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_DOT] = ACTIONS(5181),
    [anon_sym_switch] = ACTIONS(5179),
    [anon_sym_DOT_DOT] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5179),
    [anon_sym_QMARK_QMARK] = ACTIONS(5179),
    [anon_sym_from] = ACTIONS(5179),
    [anon_sym_into] = ACTIONS(5179),
    [anon_sym_join] = ACTIONS(5179),
    [anon_sym_let] = ACTIONS(5179),
    [anon_sym_orderby] = ACTIONS(5179),
    [anon_sym_ascending] = ACTIONS(5179),
    [anon_sym_descending] = ACTIONS(5179),
    [anon_sym_group] = ACTIONS(5179),
    [anon_sym_select] = ACTIONS(5179),
    [anon_sym_as] = ACTIONS(5181),
    [anon_sym_is] = ACTIONS(5179),
    [anon_sym_DASH_GT] = ACTIONS(5179),
    [anon_sym_with] = ACTIONS(5179),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3784] = {
    [sym_preproc_region] = STATE(3784),
    [sym_preproc_endregion] = STATE(3784),
    [sym_preproc_line] = STATE(3784),
    [sym_preproc_pragma] = STATE(3784),
    [sym_preproc_nullable] = STATE(3784),
    [sym_preproc_error] = STATE(3784),
    [sym_preproc_warning] = STATE(3784),
    [sym_preproc_define] = STATE(3784),
    [sym_preproc_undef] = STATE(3784),
    [anon_sym_LBRACK] = ACTIONS(5254),
    [anon_sym_COMMA] = ACTIONS(5254),
    [anon_sym_LPAREN] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5256),
    [anon_sym_where] = ACTIONS(5254),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_BANG] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5256),
    [anon_sym_STAR] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(5256),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PIPE] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5256),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5256),
    [anon_sym_GT_GT_GT] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5254),
    [anon_sym_BANG_EQ] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5254),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_DOT] = ACTIONS(5256),
    [anon_sym_switch] = ACTIONS(5254),
    [anon_sym_DOT_DOT] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_or] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5254),
    [anon_sym_PIPE_PIPE] = ACTIONS(5254),
    [anon_sym_QMARK_QMARK] = ACTIONS(5254),
    [anon_sym_from] = ACTIONS(5254),
    [anon_sym_into] = ACTIONS(5254),
    [anon_sym_join] = ACTIONS(5254),
    [anon_sym_let] = ACTIONS(5254),
    [anon_sym_orderby] = ACTIONS(5254),
    [anon_sym_ascending] = ACTIONS(5254),
    [anon_sym_descending] = ACTIONS(5254),
    [anon_sym_group] = ACTIONS(5254),
    [anon_sym_select] = ACTIONS(5254),
    [anon_sym_as] = ACTIONS(5256),
    [anon_sym_is] = ACTIONS(5254),
    [anon_sym_DASH_GT] = ACTIONS(5254),
    [anon_sym_with] = ACTIONS(5254),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3785] = {
    [sym_preproc_region] = STATE(3785),
    [sym_preproc_endregion] = STATE(3785),
    [sym_preproc_line] = STATE(3785),
    [sym_preproc_pragma] = STATE(3785),
    [sym_preproc_nullable] = STATE(3785),
    [sym_preproc_error] = STATE(3785),
    [sym_preproc_warning] = STATE(3785),
    [sym_preproc_define] = STATE(3785),
    [sym_preproc_undef] = STATE(3785),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_LPAREN] = ACTIONS(5433),
    [anon_sym_LT] = ACTIONS(5435),
    [anon_sym_GT] = ACTIONS(5435),
    [anon_sym_where] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5435),
    [anon_sym_BANG] = ACTIONS(5435),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(5435),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5435),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5435),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5435),
    [anon_sym_GT_GT_GT] = ACTIONS(5433),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5435),
    [anon_sym_switch] = ACTIONS(5433),
    [anon_sym_DOT_DOT] = ACTIONS(5433),
    [anon_sym_and] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5435),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_QMARK_QMARK] = ACTIONS(5433),
    [anon_sym_from] = ACTIONS(5433),
    [anon_sym_into] = ACTIONS(5433),
    [anon_sym_join] = ACTIONS(5433),
    [anon_sym_let] = ACTIONS(5433),
    [anon_sym_orderby] = ACTIONS(5433),
    [anon_sym_ascending] = ACTIONS(5433),
    [anon_sym_descending] = ACTIONS(5433),
    [anon_sym_group] = ACTIONS(5433),
    [anon_sym_select] = ACTIONS(5433),
    [anon_sym_as] = ACTIONS(5435),
    [anon_sym_is] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [anon_sym_with] = ACTIONS(5433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3786] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6177),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym__join_header] = STATE(7327),
    [sym_identifier] = STATE(5843),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3786),
    [sym_preproc_endregion] = STATE(3786),
    [sym_preproc_line] = STATE(3786),
    [sym_preproc_pragma] = STATE(3786),
    [sym_preproc_nullable] = STATE(3786),
    [sym_preproc_error] = STATE(3786),
    [sym_preproc_warning] = STATE(3786),
    [sym_preproc_define] = STATE(3786),
    [sym_preproc_undef] = STATE(3786),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3787] = {
    [sym_type_argument_list] = STATE(2991),
    [sym_preproc_region] = STATE(3787),
    [sym_preproc_endregion] = STATE(3787),
    [sym_preproc_line] = STATE(3787),
    [sym_preproc_pragma] = STATE(3787),
    [sym_preproc_nullable] = STATE(3787),
    [sym_preproc_error] = STATE(3787),
    [sym_preproc_warning] = STATE(3787),
    [sym_preproc_define] = STATE(3787),
    [sym_preproc_undef] = STATE(3787),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_LT] = ACTIONS(4868),
    [anon_sym_GT] = ACTIONS(3678),
    [anon_sym_where] = ACTIONS(3680),
    [anon_sym_QMARK] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_CARET] = ACTIONS(3680),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3678),
    [anon_sym_LT_LT] = ACTIONS(3680),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3680),
    [anon_sym_EQ_EQ] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3680),
    [anon_sym_GT_EQ] = ACTIONS(3680),
    [anon_sym_LT_EQ] = ACTIONS(3680),
    [anon_sym_DOT] = ACTIONS(3678),
    [anon_sym_COLON_COLON] = ACTIONS(6175),
    [anon_sym_switch] = ACTIONS(3680),
    [anon_sym_DOT_DOT] = ACTIONS(3680),
    [anon_sym_and] = ACTIONS(3680),
    [anon_sym_or] = ACTIONS(3678),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_PIPE_PIPE] = ACTIONS(3680),
    [anon_sym_QMARK_QMARK] = ACTIONS(3680),
    [anon_sym_from] = ACTIONS(3680),
    [anon_sym_into] = ACTIONS(3680),
    [anon_sym_join] = ACTIONS(3680),
    [anon_sym_let] = ACTIONS(3680),
    [anon_sym_orderby] = ACTIONS(3680),
    [anon_sym_group] = ACTIONS(3680),
    [anon_sym_select] = ACTIONS(3680),
    [anon_sym_as] = ACTIONS(3680),
    [anon_sym_is] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [anon_sym_with] = ACTIONS(3680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3788] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3788),
    [sym_preproc_endregion] = STATE(3788),
    [sym_preproc_line] = STATE(3788),
    [sym_preproc_pragma] = STATE(3788),
    [sym_preproc_nullable] = STATE(3788),
    [sym_preproc_error] = STATE(3788),
    [sym_preproc_warning] = STATE(3788),
    [sym_preproc_define] = STATE(3788),
    [sym_preproc_undef] = STATE(3788),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5870),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5870),
    [anon_sym_into] = ACTIONS(5870),
    [anon_sym_join] = ACTIONS(5870),
    [anon_sym_let] = ACTIONS(5870),
    [anon_sym_orderby] = ACTIONS(5870),
    [anon_sym_ascending] = ACTIONS(5870),
    [anon_sym_descending] = ACTIONS(5870),
    [anon_sym_group] = ACTIONS(5870),
    [anon_sym_select] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3789] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3789),
    [sym_preproc_endregion] = STATE(3789),
    [sym_preproc_line] = STATE(3789),
    [sym_preproc_pragma] = STATE(3789),
    [sym_preproc_nullable] = STATE(3789),
    [sym_preproc_error] = STATE(3789),
    [sym_preproc_warning] = STATE(3789),
    [sym_preproc_define] = STATE(3789),
    [sym_preproc_undef] = STATE(3789),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5630),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6177),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5634),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3790] = {
    [sym__name] = STATE(6505),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(7331),
    [sym_array_type] = STATE(6698),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7522),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(7331),
    [sym_scoped_type] = STATE(7331),
    [sym_tuple_type] = STATE(6632),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3790),
    [sym_preproc_endregion] = STATE(3790),
    [sym_preproc_line] = STATE(3790),
    [sym_preproc_pragma] = STATE(3790),
    [sym_preproc_nullable] = STATE(3790),
    [sym_preproc_error] = STATE(3790),
    [sym_preproc_warning] = STATE(3790),
    [sym_preproc_define] = STATE(3790),
    [sym_preproc_undef] = STATE(3790),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5081),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6179),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3791] = {
    [sym_preproc_region] = STATE(3791),
    [sym_preproc_endregion] = STATE(3791),
    [sym_preproc_line] = STATE(3791),
    [sym_preproc_pragma] = STATE(3791),
    [sym_preproc_nullable] = STATE(3791),
    [sym_preproc_error] = STATE(3791),
    [sym_preproc_warning] = STATE(3791),
    [sym_preproc_define] = STATE(3791),
    [sym_preproc_undef] = STATE(3791),
    [anon_sym_LBRACK] = ACTIONS(5159),
    [anon_sym_COMMA] = ACTIONS(5159),
    [anon_sym_LPAREN] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_where] = ACTIONS(5159),
    [anon_sym_QMARK] = ACTIONS(5161),
    [anon_sym_BANG] = ACTIONS(5161),
    [anon_sym_PLUS_PLUS] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(5161),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5161),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_AMP] = ACTIONS(5161),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5161),
    [anon_sym_GT_GT_GT] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5159),
    [anon_sym_BANG_EQ] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5159),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_DOT] = ACTIONS(5161),
    [anon_sym_switch] = ACTIONS(5159),
    [anon_sym_DOT_DOT] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_or] = ACTIONS(5161),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_QMARK_QMARK] = ACTIONS(5159),
    [anon_sym_from] = ACTIONS(5159),
    [anon_sym_into] = ACTIONS(5159),
    [anon_sym_join] = ACTIONS(5159),
    [anon_sym_let] = ACTIONS(5159),
    [anon_sym_orderby] = ACTIONS(5159),
    [anon_sym_ascending] = ACTIONS(5159),
    [anon_sym_descending] = ACTIONS(5159),
    [anon_sym_group] = ACTIONS(5159),
    [anon_sym_select] = ACTIONS(5159),
    [anon_sym_as] = ACTIONS(5161),
    [anon_sym_is] = ACTIONS(5159),
    [anon_sym_DASH_GT] = ACTIONS(5159),
    [anon_sym_with] = ACTIONS(5159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3792] = {
    [sym__name] = STATE(5187),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3360),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3355),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(4595),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3792),
    [sym_preproc_endregion] = STATE(3792),
    [sym_preproc_line] = STATE(3792),
    [sym_preproc_pragma] = STATE(3792),
    [sym_preproc_nullable] = STATE(3792),
    [sym_preproc_error] = STATE(3792),
    [sym_preproc_warning] = STATE(3792),
    [sym_preproc_define] = STATE(3792),
    [sym_preproc_undef] = STATE(3792),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_ref] = ACTIONS(4162),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(6181),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5743),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3793] = {
    [sym_variable_declaration] = STATE(7368),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5775),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3793),
    [sym_preproc_endregion] = STATE(3793),
    [sym_preproc_line] = STATE(3793),
    [sym_preproc_pragma] = STATE(3793),
    [sym_preproc_nullable] = STATE(3793),
    [sym_preproc_error] = STATE(3793),
    [sym_preproc_warning] = STATE(3793),
    [sym_preproc_define] = STATE(3793),
    [sym_preproc_undef] = STATE(3793),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3794] = {
    [sym_preproc_region] = STATE(3794),
    [sym_preproc_endregion] = STATE(3794),
    [sym_preproc_line] = STATE(3794),
    [sym_preproc_pragma] = STATE(3794),
    [sym_preproc_nullable] = STATE(3794),
    [sym_preproc_error] = STATE(3794),
    [sym_preproc_warning] = STATE(3794),
    [sym_preproc_define] = STATE(3794),
    [sym_preproc_undef] = STATE(3794),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5043),
    [anon_sym_LT] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [anon_sym_where] = ACTIONS(5043),
    [anon_sym_QMARK] = ACTIONS(5045),
    [anon_sym_BANG] = ACTIONS(5045),
    [anon_sym_PLUS_PLUS] = ACTIONS(5043),
    [anon_sym_DASH_DASH] = ACTIONS(5043),
    [anon_sym_PLUS] = ACTIONS(5045),
    [anon_sym_DASH] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5043),
    [anon_sym_SLASH] = ACTIONS(5045),
    [anon_sym_PERCENT] = ACTIONS(5043),
    [anon_sym_CARET] = ACTIONS(5043),
    [anon_sym_PIPE] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5045),
    [anon_sym_LT_LT] = ACTIONS(5043),
    [anon_sym_GT_GT] = ACTIONS(5045),
    [anon_sym_GT_GT_GT] = ACTIONS(5043),
    [anon_sym_EQ_EQ] = ACTIONS(5043),
    [anon_sym_BANG_EQ] = ACTIONS(5043),
    [anon_sym_GT_EQ] = ACTIONS(5043),
    [anon_sym_LT_EQ] = ACTIONS(5043),
    [anon_sym_DOT] = ACTIONS(5045),
    [anon_sym_switch] = ACTIONS(5043),
    [anon_sym_DOT_DOT] = ACTIONS(5043),
    [anon_sym_and] = ACTIONS(5043),
    [anon_sym_or] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5043),
    [anon_sym_QMARK_QMARK] = ACTIONS(5043),
    [anon_sym_from] = ACTIONS(5043),
    [anon_sym_into] = ACTIONS(5043),
    [anon_sym_join] = ACTIONS(5043),
    [anon_sym_let] = ACTIONS(5043),
    [anon_sym_orderby] = ACTIONS(5043),
    [anon_sym_ascending] = ACTIONS(5043),
    [anon_sym_descending] = ACTIONS(5043),
    [anon_sym_group] = ACTIONS(5043),
    [anon_sym_select] = ACTIONS(5043),
    [anon_sym_as] = ACTIONS(5045),
    [anon_sym_is] = ACTIONS(5043),
    [anon_sym_DASH_GT] = ACTIONS(5043),
    [anon_sym_with] = ACTIONS(5043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3795] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3795),
    [sym_preproc_endregion] = STATE(3795),
    [sym_preproc_line] = STATE(3795),
    [sym_preproc_pragma] = STATE(3795),
    [sym_preproc_nullable] = STATE(3795),
    [sym_preproc_error] = STATE(3795),
    [sym_preproc_warning] = STATE(3795),
    [sym_preproc_define] = STATE(3795),
    [sym_preproc_undef] = STATE(3795),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5238),
    [anon_sym_into] = ACTIONS(5238),
    [anon_sym_join] = ACTIONS(5238),
    [anon_sym_let] = ACTIONS(5238),
    [anon_sym_orderby] = ACTIONS(5238),
    [anon_sym_ascending] = ACTIONS(5238),
    [anon_sym_descending] = ACTIONS(5238),
    [anon_sym_group] = ACTIONS(5238),
    [anon_sym_select] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3796] = {
    [sym_variable_declaration] = STATE(7602),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5771),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3796),
    [sym_preproc_endregion] = STATE(3796),
    [sym_preproc_line] = STATE(3796),
    [sym_preproc_pragma] = STATE(3796),
    [sym_preproc_nullable] = STATE(3796),
    [sym_preproc_error] = STATE(3796),
    [sym_preproc_warning] = STATE(3796),
    [sym_preproc_define] = STATE(3796),
    [sym_preproc_undef] = STATE(3796),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3797] = {
    [sym_preproc_region] = STATE(3797),
    [sym_preproc_endregion] = STATE(3797),
    [sym_preproc_line] = STATE(3797),
    [sym_preproc_pragma] = STATE(3797),
    [sym_preproc_nullable] = STATE(3797),
    [sym_preproc_error] = STATE(3797),
    [sym_preproc_warning] = STATE(3797),
    [sym_preproc_define] = STATE(3797),
    [sym_preproc_undef] = STATE(3797),
    [anon_sym_LBRACK] = ACTIONS(5135),
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_LPAREN] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_where] = ACTIONS(5135),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_BANG] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5137),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5137),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5137),
    [anon_sym_AMP] = ACTIONS(5137),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_GT_GT_GT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_DOT] = ACTIONS(5137),
    [anon_sym_switch] = ACTIONS(5135),
    [anon_sym_DOT_DOT] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_or] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_QMARK_QMARK] = ACTIONS(5135),
    [anon_sym_from] = ACTIONS(5135),
    [anon_sym_into] = ACTIONS(5135),
    [anon_sym_join] = ACTIONS(5135),
    [anon_sym_let] = ACTIONS(5135),
    [anon_sym_orderby] = ACTIONS(5135),
    [anon_sym_ascending] = ACTIONS(5135),
    [anon_sym_descending] = ACTIONS(5135),
    [anon_sym_group] = ACTIONS(5135),
    [anon_sym_select] = ACTIONS(5135),
    [anon_sym_as] = ACTIONS(5137),
    [anon_sym_is] = ACTIONS(5135),
    [anon_sym_DASH_GT] = ACTIONS(5135),
    [anon_sym_with] = ACTIONS(5135),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3798] = {
    [sym__name] = STATE(4497),
    [sym_alias_qualified_name] = STATE(4398),
    [sym__simple_name] = STATE(4398),
    [sym_qualified_name] = STATE(4398),
    [sym_generic_name] = STATE(4419),
    [sym_type] = STATE(4498),
    [sym_implicit_type] = STATE(4407),
    [sym_array_type] = STATE(4484),
    [sym__array_base_type] = STATE(7286),
    [sym_nullable_type] = STATE(4519),
    [sym_pointer_type] = STATE(4519),
    [sym__pointer_base_type] = STATE(7680),
    [sym_function_pointer_type] = STATE(4519),
    [sym_ref_type] = STATE(4407),
    [sym_scoped_type] = STATE(4407),
    [sym_tuple_type] = STATE(4520),
    [sym_identifier] = STATE(4293),
    [sym__reserved_identifier] = STATE(4388),
    [sym_preproc_region] = STATE(3798),
    [sym_preproc_endregion] = STATE(3798),
    [sym_preproc_line] = STATE(3798),
    [sym_preproc_pragma] = STATE(3798),
    [sym_preproc_nullable] = STATE(3798),
    [sym_preproc_error] = STATE(3798),
    [sym_preproc_warning] = STATE(3798),
    [sym_preproc_define] = STATE(3798),
    [sym_preproc_undef] = STATE(3798),
    [sym__identifier_token] = ACTIONS(4009),
    [anon_sym_alias] = ACTIONS(4011),
    [anon_sym_global] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(6093),
    [anon_sym_ref] = ACTIONS(4046),
    [anon_sym_delegate] = ACTIONS(5732),
    [anon_sym_file] = ACTIONS(4011),
    [anon_sym_readonly] = ACTIONS(6183),
    [anon_sym_where] = ACTIONS(4011),
    [anon_sym_notnull] = ACTIONS(4011),
    [anon_sym_unmanaged] = ACTIONS(4011),
    [anon_sym_scoped] = ACTIONS(5918),
    [anon_sym_var] = ACTIONS(5736),
    [sym_predefined_type] = ACTIONS(5738),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_when] = ACTIONS(4011),
    [anon_sym_from] = ACTIONS(4011),
    [anon_sym_into] = ACTIONS(4011),
    [anon_sym_join] = ACTIONS(4011),
    [anon_sym_on] = ACTIONS(4011),
    [anon_sym_equals] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_orderby] = ACTIONS(4011),
    [anon_sym_ascending] = ACTIONS(4011),
    [anon_sym_descending] = ACTIONS(4011),
    [anon_sym_group] = ACTIONS(4011),
    [anon_sym_by] = ACTIONS(4011),
    [anon_sym_select] = ACTIONS(4011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3799] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3799),
    [sym_preproc_endregion] = STATE(3799),
    [sym_preproc_line] = STATE(3799),
    [sym_preproc_pragma] = STATE(3799),
    [sym_preproc_nullable] = STATE(3799),
    [sym_preproc_error] = STATE(3799),
    [sym_preproc_warning] = STATE(3799),
    [sym_preproc_define] = STATE(3799),
    [sym_preproc_undef] = STATE(3799),
    [anon_sym_SEMI] = ACTIONS(5866),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5866),
    [anon_sym_RBRACK] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5866),
    [anon_sym_RBRACE] = ACTIONS(5866),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5866),
    [anon_sym_or] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5866),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5866),
    [aux_sym_preproc_else_token1] = ACTIONS(5866),
    [aux_sym_preproc_elif_token1] = ACTIONS(5866),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3800] = {
    [sym_preproc_region] = STATE(3800),
    [sym_preproc_endregion] = STATE(3800),
    [sym_preproc_line] = STATE(3800),
    [sym_preproc_pragma] = STATE(3800),
    [sym_preproc_nullable] = STATE(3800),
    [sym_preproc_error] = STATE(3800),
    [sym_preproc_warning] = STATE(3800),
    [sym_preproc_define] = STATE(3800),
    [sym_preproc_undef] = STATE(3800),
    [anon_sym_LBRACK] = ACTIONS(5195),
    [anon_sym_COMMA] = ACTIONS(5195),
    [anon_sym_LPAREN] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_where] = ACTIONS(5195),
    [anon_sym_QMARK] = ACTIONS(5197),
    [anon_sym_BANG] = ACTIONS(5197),
    [anon_sym_PLUS_PLUS] = ACTIONS(5195),
    [anon_sym_DASH_DASH] = ACTIONS(5195),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5195),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5195),
    [anon_sym_CARET] = ACTIONS(5195),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5195),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_GT_GT_GT] = ACTIONS(5195),
    [anon_sym_EQ_EQ] = ACTIONS(5195),
    [anon_sym_BANG_EQ] = ACTIONS(5195),
    [anon_sym_GT_EQ] = ACTIONS(5195),
    [anon_sym_LT_EQ] = ACTIONS(5195),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_switch] = ACTIONS(5195),
    [anon_sym_DOT_DOT] = ACTIONS(5195),
    [anon_sym_and] = ACTIONS(5195),
    [anon_sym_or] = ACTIONS(5197),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_QMARK_QMARK] = ACTIONS(5195),
    [anon_sym_from] = ACTIONS(5195),
    [anon_sym_into] = ACTIONS(5195),
    [anon_sym_join] = ACTIONS(5195),
    [anon_sym_let] = ACTIONS(5195),
    [anon_sym_orderby] = ACTIONS(5195),
    [anon_sym_ascending] = ACTIONS(5195),
    [anon_sym_descending] = ACTIONS(5195),
    [anon_sym_group] = ACTIONS(5195),
    [anon_sym_select] = ACTIONS(5195),
    [anon_sym_as] = ACTIONS(5197),
    [anon_sym_is] = ACTIONS(5195),
    [anon_sym_DASH_GT] = ACTIONS(5195),
    [anon_sym_with] = ACTIONS(5195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3801] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3801),
    [sym_preproc_endregion] = STATE(3801),
    [sym_preproc_line] = STATE(3801),
    [sym_preproc_pragma] = STATE(3801),
    [sym_preproc_nullable] = STATE(3801),
    [sym_preproc_error] = STATE(3801),
    [sym_preproc_warning] = STATE(3801),
    [sym_preproc_define] = STATE(3801),
    [sym_preproc_undef] = STATE(3801),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3802] = {
    [sym_preproc_region] = STATE(3802),
    [sym_preproc_endregion] = STATE(3802),
    [sym_preproc_line] = STATE(3802),
    [sym_preproc_pragma] = STATE(3802),
    [sym_preproc_nullable] = STATE(3802),
    [sym_preproc_error] = STATE(3802),
    [sym_preproc_warning] = STATE(3802),
    [sym_preproc_define] = STATE(3802),
    [sym_preproc_undef] = STATE(3802),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_where] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_BANG] = ACTIONS(5498),
    [anon_sym_PLUS_PLUS] = ACTIONS(5496),
    [anon_sym_DASH_DASH] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_CARET] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5496),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_GT_GT_GT] = ACTIONS(5496),
    [anon_sym_EQ_EQ] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(5496),
    [anon_sym_GT_EQ] = ACTIONS(5496),
    [anon_sym_LT_EQ] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_switch] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_and] = ACTIONS(5496),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5496),
    [anon_sym_PIPE_PIPE] = ACTIONS(5496),
    [anon_sym_QMARK_QMARK] = ACTIONS(5496),
    [anon_sym_from] = ACTIONS(5496),
    [anon_sym_into] = ACTIONS(5496),
    [anon_sym_join] = ACTIONS(5496),
    [anon_sym_let] = ACTIONS(5496),
    [anon_sym_orderby] = ACTIONS(5496),
    [anon_sym_ascending] = ACTIONS(5496),
    [anon_sym_descending] = ACTIONS(5496),
    [anon_sym_group] = ACTIONS(5496),
    [anon_sym_select] = ACTIONS(5496),
    [anon_sym_as] = ACTIONS(5498),
    [anon_sym_is] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_with] = ACTIONS(5496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3803] = {
    [sym_preproc_region] = STATE(3803),
    [sym_preproc_endregion] = STATE(3803),
    [sym_preproc_line] = STATE(3803),
    [sym_preproc_pragma] = STATE(3803),
    [sym_preproc_nullable] = STATE(3803),
    [sym_preproc_error] = STATE(3803),
    [sym_preproc_warning] = STATE(3803),
    [sym_preproc_define] = STATE(3803),
    [sym_preproc_undef] = STATE(3803),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_COMMA] = ACTIONS(5512),
    [anon_sym_LPAREN] = ACTIONS(5512),
    [anon_sym_LT] = ACTIONS(5514),
    [anon_sym_GT] = ACTIONS(5514),
    [anon_sym_where] = ACTIONS(5512),
    [anon_sym_QMARK] = ACTIONS(5514),
    [anon_sym_BANG] = ACTIONS(5514),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_SLASH] = ACTIONS(5514),
    [anon_sym_PERCENT] = ACTIONS(5512),
    [anon_sym_CARET] = ACTIONS(5512),
    [anon_sym_PIPE] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym_LT_LT] = ACTIONS(5512),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_GT_GT_GT] = ACTIONS(5512),
    [anon_sym_EQ_EQ] = ACTIONS(5512),
    [anon_sym_BANG_EQ] = ACTIONS(5512),
    [anon_sym_GT_EQ] = ACTIONS(5512),
    [anon_sym_LT_EQ] = ACTIONS(5512),
    [anon_sym_DOT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5512),
    [anon_sym_DOT_DOT] = ACTIONS(5512),
    [anon_sym_and] = ACTIONS(5512),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_PIPE_PIPE] = ACTIONS(5512),
    [anon_sym_QMARK_QMARK] = ACTIONS(5512),
    [anon_sym_from] = ACTIONS(5512),
    [anon_sym_into] = ACTIONS(5512),
    [anon_sym_join] = ACTIONS(5512),
    [anon_sym_let] = ACTIONS(5512),
    [anon_sym_orderby] = ACTIONS(5512),
    [anon_sym_ascending] = ACTIONS(5512),
    [anon_sym_descending] = ACTIONS(5512),
    [anon_sym_group] = ACTIONS(5512),
    [anon_sym_select] = ACTIONS(5512),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5512),
    [anon_sym_DASH_GT] = ACTIONS(5512),
    [anon_sym_with] = ACTIONS(5512),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3804] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3804),
    [sym_preproc_endregion] = STATE(3804),
    [sym_preproc_line] = STATE(3804),
    [sym_preproc_pragma] = STATE(3804),
    [sym_preproc_nullable] = STATE(3804),
    [sym_preproc_error] = STATE(3804),
    [sym_preproc_warning] = STATE(3804),
    [sym_preproc_define] = STATE(3804),
    [sym_preproc_undef] = STATE(3804),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5682),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3805] = {
    [sym_preproc_region] = STATE(3805),
    [sym_preproc_endregion] = STATE(3805),
    [sym_preproc_line] = STATE(3805),
    [sym_preproc_pragma] = STATE(3805),
    [sym_preproc_nullable] = STATE(3805),
    [sym_preproc_error] = STATE(3805),
    [sym_preproc_warning] = STATE(3805),
    [sym_preproc_define] = STATE(3805),
    [sym_preproc_undef] = STATE(3805),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(5455),
    [anon_sym_GT] = ACTIONS(5455),
    [anon_sym_where] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(5455),
    [anon_sym_BANG] = ACTIONS(5455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_CARET] = ACTIONS(3881),
    [anon_sym_PIPE] = ACTIONS(5455),
    [anon_sym_AMP] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(5455),
    [anon_sym_GT_GT_GT] = ACTIONS(3881),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(5455),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_DOT_DOT] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(5455),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_QMARK_QMARK] = ACTIONS(3881),
    [anon_sym_from] = ACTIONS(3881),
    [anon_sym_into] = ACTIONS(3881),
    [anon_sym_join] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_orderby] = ACTIONS(3881),
    [anon_sym_ascending] = ACTIONS(3881),
    [anon_sym_descending] = ACTIONS(3881),
    [anon_sym_group] = ACTIONS(3881),
    [anon_sym_select] = ACTIONS(3881),
    [anon_sym_as] = ACTIONS(5455),
    [anon_sym_is] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3806] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3806),
    [sym_preproc_endregion] = STATE(3806),
    [sym_preproc_line] = STATE(3806),
    [sym_preproc_pragma] = STATE(3806),
    [sym_preproc_nullable] = STATE(3806),
    [sym_preproc_error] = STATE(3806),
    [sym_preproc_warning] = STATE(3806),
    [sym_preproc_define] = STATE(3806),
    [sym_preproc_undef] = STATE(3806),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5682),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3807] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3807),
    [sym_preproc_endregion] = STATE(3807),
    [sym_preproc_line] = STATE(3807),
    [sym_preproc_pragma] = STATE(3807),
    [sym_preproc_nullable] = STATE(3807),
    [sym_preproc_error] = STATE(3807),
    [sym_preproc_warning] = STATE(3807),
    [sym_preproc_define] = STATE(3807),
    [sym_preproc_undef] = STATE(3807),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5682),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3808] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3808),
    [sym_preproc_endregion] = STATE(3808),
    [sym_preproc_line] = STATE(3808),
    [sym_preproc_pragma] = STATE(3808),
    [sym_preproc_nullable] = STATE(3808),
    [sym_preproc_error] = STATE(3808),
    [sym_preproc_warning] = STATE(3808),
    [sym_preproc_define] = STATE(3808),
    [sym_preproc_undef] = STATE(3808),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3809] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3809),
    [sym_preproc_endregion] = STATE(3809),
    [sym_preproc_line] = STATE(3809),
    [sym_preproc_pragma] = STATE(3809),
    [sym_preproc_nullable] = STATE(3809),
    [sym_preproc_error] = STATE(3809),
    [sym_preproc_warning] = STATE(3809),
    [sym_preproc_define] = STATE(3809),
    [sym_preproc_undef] = STATE(3809),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3810] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3810),
    [sym_preproc_endregion] = STATE(3810),
    [sym_preproc_line] = STATE(3810),
    [sym_preproc_pragma] = STATE(3810),
    [sym_preproc_nullable] = STATE(3810),
    [sym_preproc_error] = STATE(3810),
    [sym_preproc_warning] = STATE(3810),
    [sym_preproc_define] = STATE(3810),
    [sym_preproc_undef] = STATE(3810),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3811] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3811),
    [sym_preproc_endregion] = STATE(3811),
    [sym_preproc_line] = STATE(3811),
    [sym_preproc_pragma] = STATE(3811),
    [sym_preproc_nullable] = STATE(3811),
    [sym_preproc_error] = STATE(3811),
    [sym_preproc_warning] = STATE(3811),
    [sym_preproc_define] = STATE(3811),
    [sym_preproc_undef] = STATE(3811),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_GT_GT_GT] = ACTIONS(5682),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5682),
    [anon_sym_is] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3812] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3812),
    [sym_preproc_endregion] = STATE(3812),
    [sym_preproc_line] = STATE(3812),
    [sym_preproc_pragma] = STATE(3812),
    [sym_preproc_nullable] = STATE(3812),
    [sym_preproc_error] = STATE(3812),
    [sym_preproc_warning] = STATE(3812),
    [sym_preproc_define] = STATE(3812),
    [sym_preproc_undef] = STATE(3812),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3813] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3813),
    [sym_preproc_endregion] = STATE(3813),
    [sym_preproc_line] = STATE(3813),
    [sym_preproc_pragma] = STATE(3813),
    [sym_preproc_nullable] = STATE(3813),
    [sym_preproc_error] = STATE(3813),
    [sym_preproc_warning] = STATE(3813),
    [sym_preproc_define] = STATE(3813),
    [sym_preproc_undef] = STATE(3813),
    [anon_sym_SEMI] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5924),
    [anon_sym_RBRACK] = ACTIONS(5924),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5924),
    [anon_sym_RBRACE] = ACTIONS(5924),
    [anon_sym_LT] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_SLASH] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_PIPE] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_GT_GT] = ACTIONS(5926),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5924),
    [anon_sym_BANG_EQ] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(5924),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5924),
    [anon_sym_or] = ACTIONS(5924),
    [anon_sym_AMP_AMP] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5924),
    [anon_sym_QMARK_QMARK] = ACTIONS(5924),
    [anon_sym_into] = ACTIONS(5924),
    [anon_sym_as] = ACTIONS(5924),
    [anon_sym_is] = ACTIONS(5924),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(5924),
    [aux_sym_preproc_if_token3] = ACTIONS(5924),
    [aux_sym_preproc_else_token1] = ACTIONS(5924),
    [aux_sym_preproc_elif_token1] = ACTIONS(5924),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3814] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3814),
    [sym_preproc_endregion] = STATE(3814),
    [sym_preproc_line] = STATE(3814),
    [sym_preproc_pragma] = STATE(3814),
    [sym_preproc_nullable] = STATE(3814),
    [sym_preproc_error] = STATE(3814),
    [sym_preproc_warning] = STATE(3814),
    [sym_preproc_define] = STATE(3814),
    [sym_preproc_undef] = STATE(3814),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3815] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3815),
    [sym_preproc_endregion] = STATE(3815),
    [sym_preproc_line] = STATE(3815),
    [sym_preproc_pragma] = STATE(3815),
    [sym_preproc_nullable] = STATE(3815),
    [sym_preproc_error] = STATE(3815),
    [sym_preproc_warning] = STATE(3815),
    [sym_preproc_define] = STATE(3815),
    [sym_preproc_undef] = STATE(3815),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3816] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3816),
    [sym_preproc_endregion] = STATE(3816),
    [sym_preproc_line] = STATE(3816),
    [sym_preproc_pragma] = STATE(3816),
    [sym_preproc_nullable] = STATE(3816),
    [sym_preproc_error] = STATE(3816),
    [sym_preproc_warning] = STATE(3816),
    [sym_preproc_define] = STATE(3816),
    [sym_preproc_undef] = STATE(3816),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5682),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3817] = {
    [sym_preproc_region] = STATE(3817),
    [sym_preproc_endregion] = STATE(3817),
    [sym_preproc_line] = STATE(3817),
    [sym_preproc_pragma] = STATE(3817),
    [sym_preproc_nullable] = STATE(3817),
    [sym_preproc_error] = STATE(3817),
    [sym_preproc_warning] = STATE(3817),
    [sym_preproc_define] = STATE(3817),
    [sym_preproc_undef] = STATE(3817),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_COMMA] = ACTIONS(5488),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_LT] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(5490),
    [anon_sym_BANG] = ACTIONS(5490),
    [anon_sym_PLUS_PLUS] = ACTIONS(5488),
    [anon_sym_DASH_DASH] = ACTIONS(5488),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_DASH] = ACTIONS(5490),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_SLASH] = ACTIONS(5490),
    [anon_sym_PERCENT] = ACTIONS(5488),
    [anon_sym_CARET] = ACTIONS(5488),
    [anon_sym_PIPE] = ACTIONS(5490),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_LT_LT] = ACTIONS(5488),
    [anon_sym_GT_GT] = ACTIONS(5490),
    [anon_sym_GT_GT_GT] = ACTIONS(5488),
    [anon_sym_EQ_EQ] = ACTIONS(5488),
    [anon_sym_BANG_EQ] = ACTIONS(5488),
    [anon_sym_GT_EQ] = ACTIONS(5488),
    [anon_sym_LT_EQ] = ACTIONS(5488),
    [anon_sym_DOT] = ACTIONS(5490),
    [anon_sym_switch] = ACTIONS(5488),
    [anon_sym_DOT_DOT] = ACTIONS(5488),
    [anon_sym_and] = ACTIONS(5488),
    [anon_sym_or] = ACTIONS(5490),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_PIPE_PIPE] = ACTIONS(5488),
    [anon_sym_QMARK_QMARK] = ACTIONS(5488),
    [anon_sym_from] = ACTIONS(5488),
    [anon_sym_into] = ACTIONS(5488),
    [anon_sym_join] = ACTIONS(5488),
    [anon_sym_let] = ACTIONS(5488),
    [anon_sym_orderby] = ACTIONS(5488),
    [anon_sym_ascending] = ACTIONS(5488),
    [anon_sym_descending] = ACTIONS(5488),
    [anon_sym_group] = ACTIONS(5488),
    [anon_sym_select] = ACTIONS(5488),
    [anon_sym_as] = ACTIONS(5490),
    [anon_sym_is] = ACTIONS(5488),
    [anon_sym_DASH_GT] = ACTIONS(5488),
    [anon_sym_with] = ACTIONS(5488),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3818] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3818),
    [sym_preproc_endregion] = STATE(3818),
    [sym_preproc_line] = STATE(3818),
    [sym_preproc_pragma] = STATE(3818),
    [sym_preproc_nullable] = STATE(3818),
    [sym_preproc_error] = STATE(3818),
    [sym_preproc_warning] = STATE(3818),
    [sym_preproc_define] = STATE(3818),
    [sym_preproc_undef] = STATE(3818),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3819] = {
    [sym_preproc_region] = STATE(3819),
    [sym_preproc_endregion] = STATE(3819),
    [sym_preproc_line] = STATE(3819),
    [sym_preproc_pragma] = STATE(3819),
    [sym_preproc_nullable] = STATE(3819),
    [sym_preproc_error] = STATE(3819),
    [sym_preproc_warning] = STATE(3819),
    [sym_preproc_define] = STATE(3819),
    [sym_preproc_undef] = STATE(3819),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_LPAREN] = ACTIONS(5480),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_where] = ACTIONS(5480),
    [anon_sym_QMARK] = ACTIONS(5482),
    [anon_sym_BANG] = ACTIONS(5482),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5480),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5480),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_GT_GT_GT] = ACTIONS(5480),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5480),
    [anon_sym_DOT_DOT] = ACTIONS(5480),
    [anon_sym_and] = ACTIONS(5480),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_QMARK_QMARK] = ACTIONS(5480),
    [anon_sym_from] = ACTIONS(5480),
    [anon_sym_into] = ACTIONS(5480),
    [anon_sym_join] = ACTIONS(5480),
    [anon_sym_let] = ACTIONS(5480),
    [anon_sym_orderby] = ACTIONS(5480),
    [anon_sym_ascending] = ACTIONS(5480),
    [anon_sym_descending] = ACTIONS(5480),
    [anon_sym_group] = ACTIONS(5480),
    [anon_sym_select] = ACTIONS(5480),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_with] = ACTIONS(5480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3820] = {
    [sym_preproc_region] = STATE(3820),
    [sym_preproc_endregion] = STATE(3820),
    [sym_preproc_line] = STATE(3820),
    [sym_preproc_pragma] = STATE(3820),
    [sym_preproc_nullable] = STATE(3820),
    [sym_preproc_error] = STATE(3820),
    [sym_preproc_warning] = STATE(3820),
    [sym_preproc_define] = STATE(3820),
    [sym_preproc_undef] = STATE(3820),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5419),
    [anon_sym_where] = ACTIONS(5417),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_PIPE] = ACTIONS(5419),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5419),
    [anon_sym_GT_GT_GT] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5417),
    [anon_sym_BANG_EQ] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_DOT] = ACTIONS(5419),
    [anon_sym_switch] = ACTIONS(5417),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_or] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5417),
    [anon_sym_QMARK_QMARK] = ACTIONS(5417),
    [anon_sym_from] = ACTIONS(5417),
    [anon_sym_into] = ACTIONS(5417),
    [anon_sym_join] = ACTIONS(5417),
    [anon_sym_let] = ACTIONS(5417),
    [anon_sym_orderby] = ACTIONS(5417),
    [anon_sym_ascending] = ACTIONS(5417),
    [anon_sym_descending] = ACTIONS(5417),
    [anon_sym_group] = ACTIONS(5417),
    [anon_sym_select] = ACTIONS(5417),
    [anon_sym_as] = ACTIONS(5419),
    [anon_sym_is] = ACTIONS(5417),
    [anon_sym_DASH_GT] = ACTIONS(5417),
    [anon_sym_with] = ACTIONS(5417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3821] = {
    [sym_preproc_region] = STATE(3821),
    [sym_preproc_endregion] = STATE(3821),
    [sym_preproc_line] = STATE(3821),
    [sym_preproc_pragma] = STATE(3821),
    [sym_preproc_nullable] = STATE(3821),
    [sym_preproc_error] = STATE(3821),
    [sym_preproc_warning] = STATE(3821),
    [sym_preproc_define] = STATE(3821),
    [sym_preproc_undef] = STATE(3821),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [anon_sym_COMMA] = ACTIONS(5417),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_LT] = ACTIONS(5419),
    [anon_sym_GT] = ACTIONS(5419),
    [anon_sym_where] = ACTIONS(5417),
    [anon_sym_QMARK] = ACTIONS(5419),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_PLUS_PLUS] = ACTIONS(5417),
    [anon_sym_DASH_DASH] = ACTIONS(5417),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_SLASH] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5417),
    [anon_sym_CARET] = ACTIONS(5417),
    [anon_sym_PIPE] = ACTIONS(5419),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5417),
    [anon_sym_GT_GT] = ACTIONS(5419),
    [anon_sym_GT_GT_GT] = ACTIONS(5417),
    [anon_sym_EQ_EQ] = ACTIONS(5417),
    [anon_sym_BANG_EQ] = ACTIONS(5417),
    [anon_sym_GT_EQ] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_DOT] = ACTIONS(5419),
    [anon_sym_switch] = ACTIONS(5417),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_and] = ACTIONS(5417),
    [anon_sym_or] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5417),
    [anon_sym_QMARK_QMARK] = ACTIONS(5417),
    [anon_sym_from] = ACTIONS(5417),
    [anon_sym_into] = ACTIONS(5417),
    [anon_sym_join] = ACTIONS(5417),
    [anon_sym_let] = ACTIONS(5417),
    [anon_sym_orderby] = ACTIONS(5417),
    [anon_sym_ascending] = ACTIONS(5417),
    [anon_sym_descending] = ACTIONS(5417),
    [anon_sym_group] = ACTIONS(5417),
    [anon_sym_select] = ACTIONS(5417),
    [anon_sym_as] = ACTIONS(5419),
    [anon_sym_is] = ACTIONS(5417),
    [anon_sym_DASH_GT] = ACTIONS(5417),
    [anon_sym_with] = ACTIONS(5417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3822] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3822),
    [sym_preproc_endregion] = STATE(3822),
    [sym_preproc_line] = STATE(3822),
    [sym_preproc_pragma] = STATE(3822),
    [sym_preproc_nullable] = STATE(3822),
    [sym_preproc_error] = STATE(3822),
    [sym_preproc_warning] = STATE(3822),
    [sym_preproc_define] = STATE(3822),
    [sym_preproc_undef] = STATE(3822),
    [anon_sym_SEMI] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5870),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5870),
    [aux_sym_preproc_else_token1] = ACTIONS(5870),
    [aux_sym_preproc_elif_token1] = ACTIONS(5870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3823] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3823),
    [sym_preproc_endregion] = STATE(3823),
    [sym_preproc_line] = STATE(3823),
    [sym_preproc_pragma] = STATE(3823),
    [sym_preproc_nullable] = STATE(3823),
    [sym_preproc_error] = STATE(3823),
    [sym_preproc_warning] = STATE(3823),
    [sym_preproc_define] = STATE(3823),
    [sym_preproc_undef] = STATE(3823),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5238),
    [aux_sym_preproc_else_token1] = ACTIONS(5238),
    [aux_sym_preproc_elif_token1] = ACTIONS(5238),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3824] = {
    [sym_preproc_region] = STATE(3824),
    [sym_preproc_endregion] = STATE(3824),
    [sym_preproc_line] = STATE(3824),
    [sym_preproc_pragma] = STATE(3824),
    [sym_preproc_nullable] = STATE(3824),
    [sym_preproc_error] = STATE(3824),
    [sym_preproc_warning] = STATE(3824),
    [sym_preproc_define] = STATE(3824),
    [sym_preproc_undef] = STATE(3824),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_COMMA] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_LT] = ACTIONS(5151),
    [anon_sym_GT] = ACTIONS(5151),
    [anon_sym_where] = ACTIONS(5149),
    [anon_sym_QMARK] = ACTIONS(5151),
    [anon_sym_BANG] = ACTIONS(5151),
    [anon_sym_PLUS_PLUS] = ACTIONS(5149),
    [anon_sym_DASH_DASH] = ACTIONS(5149),
    [anon_sym_PLUS] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5149),
    [anon_sym_SLASH] = ACTIONS(5151),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_CARET] = ACTIONS(5149),
    [anon_sym_PIPE] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5151),
    [anon_sym_LT_LT] = ACTIONS(5149),
    [anon_sym_GT_GT] = ACTIONS(5151),
    [anon_sym_GT_GT_GT] = ACTIONS(5149),
    [anon_sym_EQ_EQ] = ACTIONS(5149),
    [anon_sym_BANG_EQ] = ACTIONS(5149),
    [anon_sym_GT_EQ] = ACTIONS(5149),
    [anon_sym_LT_EQ] = ACTIONS(5149),
    [anon_sym_DOT] = ACTIONS(5151),
    [anon_sym_switch] = ACTIONS(5149),
    [anon_sym_DOT_DOT] = ACTIONS(5149),
    [anon_sym_and] = ACTIONS(5149),
    [anon_sym_or] = ACTIONS(5151),
    [anon_sym_AMP_AMP] = ACTIONS(5149),
    [anon_sym_PIPE_PIPE] = ACTIONS(5149),
    [anon_sym_QMARK_QMARK] = ACTIONS(5149),
    [anon_sym_from] = ACTIONS(5149),
    [anon_sym_into] = ACTIONS(5149),
    [anon_sym_join] = ACTIONS(5149),
    [anon_sym_let] = ACTIONS(5149),
    [anon_sym_orderby] = ACTIONS(5149),
    [anon_sym_ascending] = ACTIONS(5149),
    [anon_sym_descending] = ACTIONS(5149),
    [anon_sym_group] = ACTIONS(5149),
    [anon_sym_select] = ACTIONS(5149),
    [anon_sym_as] = ACTIONS(5151),
    [anon_sym_is] = ACTIONS(5149),
    [anon_sym_DASH_GT] = ACTIONS(5149),
    [anon_sym_with] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3825] = {
    [sym_preproc_region] = STATE(3825),
    [sym_preproc_endregion] = STATE(3825),
    [sym_preproc_line] = STATE(3825),
    [sym_preproc_pragma] = STATE(3825),
    [sym_preproc_nullable] = STATE(3825),
    [sym_preproc_error] = STATE(3825),
    [sym_preproc_warning] = STATE(3825),
    [sym_preproc_define] = STATE(3825),
    [sym_preproc_undef] = STATE(3825),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3826] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3826),
    [sym_preproc_endregion] = STATE(3826),
    [sym_preproc_line] = STATE(3826),
    [sym_preproc_pragma] = STATE(3826),
    [sym_preproc_nullable] = STATE(3826),
    [sym_preproc_error] = STATE(3826),
    [sym_preproc_warning] = STATE(3826),
    [sym_preproc_define] = STATE(3826),
    [sym_preproc_undef] = STATE(3826),
    [anon_sym_SEMI] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_RBRACK] = ACTIONS(5874),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5874),
    [anon_sym_RBRACE] = ACTIONS(5874),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5874),
    [anon_sym_or] = ACTIONS(5874),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5874),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5874),
    [aux_sym_preproc_else_token1] = ACTIONS(5874),
    [aux_sym_preproc_elif_token1] = ACTIONS(5874),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3827] = {
    [sym_preproc_region] = STATE(3827),
    [sym_preproc_endregion] = STATE(3827),
    [sym_preproc_line] = STATE(3827),
    [sym_preproc_pragma] = STATE(3827),
    [sym_preproc_nullable] = STATE(3827),
    [sym_preproc_error] = STATE(3827),
    [sym_preproc_warning] = STATE(3827),
    [sym_preproc_define] = STATE(3827),
    [sym_preproc_undef] = STATE(3827),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_LPAREN] = ACTIONS(5484),
    [anon_sym_LT] = ACTIONS(5486),
    [anon_sym_GT] = ACTIONS(5486),
    [anon_sym_where] = ACTIONS(5484),
    [anon_sym_QMARK] = ACTIONS(5486),
    [anon_sym_BANG] = ACTIONS(5486),
    [anon_sym_PLUS_PLUS] = ACTIONS(5484),
    [anon_sym_DASH_DASH] = ACTIONS(5484),
    [anon_sym_PLUS] = ACTIONS(5486),
    [anon_sym_DASH] = ACTIONS(5486),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_SLASH] = ACTIONS(5486),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_CARET] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5486),
    [anon_sym_AMP] = ACTIONS(5486),
    [anon_sym_LT_LT] = ACTIONS(5484),
    [anon_sym_GT_GT] = ACTIONS(5486),
    [anon_sym_GT_GT_GT] = ACTIONS(5484),
    [anon_sym_EQ_EQ] = ACTIONS(5484),
    [anon_sym_BANG_EQ] = ACTIONS(5484),
    [anon_sym_GT_EQ] = ACTIONS(5484),
    [anon_sym_LT_EQ] = ACTIONS(5484),
    [anon_sym_DOT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5484),
    [anon_sym_DOT_DOT] = ACTIONS(5484),
    [anon_sym_and] = ACTIONS(5484),
    [anon_sym_or] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_QMARK_QMARK] = ACTIONS(5484),
    [anon_sym_from] = ACTIONS(5484),
    [anon_sym_into] = ACTIONS(5484),
    [anon_sym_join] = ACTIONS(5484),
    [anon_sym_let] = ACTIONS(5484),
    [anon_sym_orderby] = ACTIONS(5484),
    [anon_sym_ascending] = ACTIONS(5484),
    [anon_sym_descending] = ACTIONS(5484),
    [anon_sym_group] = ACTIONS(5484),
    [anon_sym_select] = ACTIONS(5484),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5484),
    [anon_sym_DASH_GT] = ACTIONS(5484),
    [anon_sym_with] = ACTIONS(5484),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3828] = {
    [sym_variable_declaration] = STATE(7419),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5969),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3828),
    [sym_preproc_endregion] = STATE(3828),
    [sym_preproc_line] = STATE(3828),
    [sym_preproc_pragma] = STATE(3828),
    [sym_preproc_nullable] = STATE(3828),
    [sym_preproc_error] = STATE(3828),
    [sym_preproc_warning] = STATE(3828),
    [sym_preproc_define] = STATE(3828),
    [sym_preproc_undef] = STATE(3828),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3829] = {
    [sym_preproc_region] = STATE(3829),
    [sym_preproc_endregion] = STATE(3829),
    [sym_preproc_line] = STATE(3829),
    [sym_preproc_pragma] = STATE(3829),
    [sym_preproc_nullable] = STATE(3829),
    [sym_preproc_error] = STATE(3829),
    [sym_preproc_warning] = STATE(3829),
    [sym_preproc_define] = STATE(3829),
    [sym_preproc_undef] = STATE(3829),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_where] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_from] = ACTIONS(5407),
    [anon_sym_into] = ACTIONS(5407),
    [anon_sym_join] = ACTIONS(5407),
    [anon_sym_let] = ACTIONS(5407),
    [anon_sym_orderby] = ACTIONS(5407),
    [anon_sym_ascending] = ACTIONS(5407),
    [anon_sym_descending] = ACTIONS(5407),
    [anon_sym_group] = ACTIONS(5407),
    [anon_sym_select] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5409),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3830] = {
    [sym_preproc_region] = STATE(3830),
    [sym_preproc_endregion] = STATE(3830),
    [sym_preproc_line] = STATE(3830),
    [sym_preproc_pragma] = STATE(3830),
    [sym_preproc_nullable] = STATE(3830),
    [sym_preproc_error] = STATE(3830),
    [sym_preproc_warning] = STATE(3830),
    [sym_preproc_define] = STATE(3830),
    [sym_preproc_undef] = STATE(3830),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_LPAREN] = ACTIONS(5441),
    [anon_sym_LT] = ACTIONS(5443),
    [anon_sym_GT] = ACTIONS(5443),
    [anon_sym_where] = ACTIONS(5441),
    [anon_sym_QMARK] = ACTIONS(5443),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_PLUS_PLUS] = ACTIONS(5441),
    [anon_sym_DASH_DASH] = ACTIONS(5441),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_SLASH] = ACTIONS(5443),
    [anon_sym_PERCENT] = ACTIONS(5441),
    [anon_sym_CARET] = ACTIONS(5441),
    [anon_sym_PIPE] = ACTIONS(5443),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym_LT_LT] = ACTIONS(5441),
    [anon_sym_GT_GT] = ACTIONS(5443),
    [anon_sym_GT_GT_GT] = ACTIONS(5441),
    [anon_sym_EQ_EQ] = ACTIONS(5441),
    [anon_sym_BANG_EQ] = ACTIONS(5441),
    [anon_sym_GT_EQ] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5441),
    [anon_sym_DOT] = ACTIONS(5443),
    [anon_sym_switch] = ACTIONS(5441),
    [anon_sym_DOT_DOT] = ACTIONS(5441),
    [anon_sym_and] = ACTIONS(5441),
    [anon_sym_or] = ACTIONS(5443),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_PIPE_PIPE] = ACTIONS(5441),
    [anon_sym_QMARK_QMARK] = ACTIONS(5441),
    [anon_sym_from] = ACTIONS(5441),
    [anon_sym_into] = ACTIONS(5441),
    [anon_sym_join] = ACTIONS(5441),
    [anon_sym_let] = ACTIONS(5441),
    [anon_sym_orderby] = ACTIONS(5441),
    [anon_sym_ascending] = ACTIONS(5441),
    [anon_sym_descending] = ACTIONS(5441),
    [anon_sym_group] = ACTIONS(5441),
    [anon_sym_select] = ACTIONS(5441),
    [anon_sym_as] = ACTIONS(5443),
    [anon_sym_is] = ACTIONS(5441),
    [anon_sym_DASH_GT] = ACTIONS(5441),
    [anon_sym_with] = ACTIONS(5441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3831] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7289),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3831),
    [sym_preproc_endregion] = STATE(3831),
    [sym_preproc_line] = STATE(3831),
    [sym_preproc_pragma] = STATE(3831),
    [sym_preproc_nullable] = STATE(3831),
    [sym_preproc_error] = STATE(3831),
    [sym_preproc_warning] = STATE(3831),
    [sym_preproc_define] = STATE(3831),
    [sym_preproc_undef] = STATE(3831),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3832] = {
    [sym_preproc_region] = STATE(3832),
    [sym_preproc_endregion] = STATE(3832),
    [sym_preproc_line] = STATE(3832),
    [sym_preproc_pragma] = STATE(3832),
    [sym_preproc_nullable] = STATE(3832),
    [sym_preproc_error] = STATE(3832),
    [sym_preproc_warning] = STATE(3832),
    [sym_preproc_define] = STATE(3832),
    [sym_preproc_undef] = STATE(3832),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(5388),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_where] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_BANG] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5388),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_GT_GT_GT] = ACTIONS(5388),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_switch] = ACTIONS(5388),
    [anon_sym_DOT_DOT] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_QMARK_QMARK] = ACTIONS(5388),
    [anon_sym_from] = ACTIONS(5388),
    [anon_sym_into] = ACTIONS(5388),
    [anon_sym_join] = ACTIONS(5388),
    [anon_sym_let] = ACTIONS(5388),
    [anon_sym_orderby] = ACTIONS(5388),
    [anon_sym_ascending] = ACTIONS(5388),
    [anon_sym_descending] = ACTIONS(5388),
    [anon_sym_group] = ACTIONS(5388),
    [anon_sym_select] = ACTIONS(5388),
    [anon_sym_as] = ACTIONS(5390),
    [anon_sym_is] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [anon_sym_with] = ACTIONS(5388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3833] = {
    [sym_preproc_region] = STATE(3833),
    [sym_preproc_endregion] = STATE(3833),
    [sym_preproc_line] = STATE(3833),
    [sym_preproc_pragma] = STATE(3833),
    [sym_preproc_nullable] = STATE(3833),
    [sym_preproc_error] = STATE(3833),
    [sym_preproc_warning] = STATE(3833),
    [sym_preproc_define] = STATE(3833),
    [sym_preproc_undef] = STATE(3833),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(5388),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_where] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_BANG] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5388),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_GT_GT_GT] = ACTIONS(5388),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_switch] = ACTIONS(5388),
    [anon_sym_DOT_DOT] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_QMARK_QMARK] = ACTIONS(5388),
    [anon_sym_from] = ACTIONS(5388),
    [anon_sym_into] = ACTIONS(5388),
    [anon_sym_join] = ACTIONS(5388),
    [anon_sym_let] = ACTIONS(5388),
    [anon_sym_orderby] = ACTIONS(5388),
    [anon_sym_ascending] = ACTIONS(5388),
    [anon_sym_descending] = ACTIONS(5388),
    [anon_sym_group] = ACTIONS(5388),
    [anon_sym_select] = ACTIONS(5388),
    [anon_sym_as] = ACTIONS(5390),
    [anon_sym_is] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [anon_sym_with] = ACTIONS(5388),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3834] = {
    [sym_preproc_region] = STATE(3834),
    [sym_preproc_endregion] = STATE(3834),
    [sym_preproc_line] = STATE(3834),
    [sym_preproc_pragma] = STATE(3834),
    [sym_preproc_nullable] = STATE(3834),
    [sym_preproc_error] = STATE(3834),
    [sym_preproc_warning] = STATE(3834),
    [sym_preproc_define] = STATE(3834),
    [sym_preproc_undef] = STATE(3834),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_where] = ACTIONS(5403),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_from] = ACTIONS(5403),
    [anon_sym_into] = ACTIONS(5403),
    [anon_sym_join] = ACTIONS(5403),
    [anon_sym_let] = ACTIONS(5403),
    [anon_sym_orderby] = ACTIONS(5403),
    [anon_sym_ascending] = ACTIONS(5403),
    [anon_sym_descending] = ACTIONS(5403),
    [anon_sym_group] = ACTIONS(5403),
    [anon_sym_select] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5405),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3835] = {
    [sym_preproc_region] = STATE(3835),
    [sym_preproc_endregion] = STATE(3835),
    [sym_preproc_line] = STATE(3835),
    [sym_preproc_pragma] = STATE(3835),
    [sym_preproc_nullable] = STATE(3835),
    [sym_preproc_error] = STATE(3835),
    [sym_preproc_warning] = STATE(3835),
    [sym_preproc_define] = STATE(3835),
    [sym_preproc_undef] = STATE(3835),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_LPAREN] = ACTIONS(5139),
    [anon_sym_LT] = ACTIONS(5141),
    [anon_sym_GT] = ACTIONS(5141),
    [anon_sym_where] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(5141),
    [anon_sym_BANG] = ACTIONS(5141),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5141),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5141),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5141),
    [anon_sym_AMP] = ACTIONS(5141),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5141),
    [anon_sym_GT_GT_GT] = ACTIONS(5139),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5141),
    [anon_sym_switch] = ACTIONS(5139),
    [anon_sym_DOT_DOT] = ACTIONS(5139),
    [anon_sym_and] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5141),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_QMARK_QMARK] = ACTIONS(5139),
    [anon_sym_from] = ACTIONS(5139),
    [anon_sym_into] = ACTIONS(5139),
    [anon_sym_join] = ACTIONS(5139),
    [anon_sym_let] = ACTIONS(5139),
    [anon_sym_orderby] = ACTIONS(5139),
    [anon_sym_ascending] = ACTIONS(5139),
    [anon_sym_descending] = ACTIONS(5139),
    [anon_sym_group] = ACTIONS(5139),
    [anon_sym_select] = ACTIONS(5139),
    [anon_sym_as] = ACTIONS(5141),
    [anon_sym_is] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [anon_sym_with] = ACTIONS(5139),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3836] = {
    [sym_preproc_region] = STATE(3836),
    [sym_preproc_endregion] = STATE(3836),
    [sym_preproc_line] = STATE(3836),
    [sym_preproc_pragma] = STATE(3836),
    [sym_preproc_nullable] = STATE(3836),
    [sym_preproc_error] = STATE(3836),
    [sym_preproc_warning] = STATE(3836),
    [sym_preproc_define] = STATE(3836),
    [sym_preproc_undef] = STATE(3836),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_COMMA] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5413),
    [anon_sym_where] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5413),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_PIPE] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5413),
    [anon_sym_GT_GT_GT] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5411),
    [anon_sym_BANG_EQ] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_DOT] = ACTIONS(5413),
    [anon_sym_switch] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_or] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_from] = ACTIONS(5411),
    [anon_sym_into] = ACTIONS(5411),
    [anon_sym_join] = ACTIONS(5411),
    [anon_sym_let] = ACTIONS(5411),
    [anon_sym_orderby] = ACTIONS(5411),
    [anon_sym_ascending] = ACTIONS(5411),
    [anon_sym_descending] = ACTIONS(5411),
    [anon_sym_group] = ACTIONS(5411),
    [anon_sym_select] = ACTIONS(5411),
    [anon_sym_as] = ACTIONS(5413),
    [anon_sym_is] = ACTIONS(5411),
    [anon_sym_DASH_GT] = ACTIONS(5411),
    [anon_sym_with] = ACTIONS(5411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3837] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7146),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3837),
    [sym_preproc_endregion] = STATE(3837),
    [sym_preproc_line] = STATE(3837),
    [sym_preproc_pragma] = STATE(3837),
    [sym_preproc_nullable] = STATE(3837),
    [sym_preproc_error] = STATE(3837),
    [sym_preproc_warning] = STATE(3837),
    [sym_preproc_define] = STATE(3837),
    [sym_preproc_undef] = STATE(3837),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3660),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(6089),
    [anon_sym_var] = ACTIONS(6091),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3838] = {
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3042),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(3088),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3838),
    [sym_preproc_endregion] = STATE(3838),
    [sym_preproc_line] = STATE(3838),
    [sym_preproc_pragma] = STATE(3838),
    [sym_preproc_nullable] = STATE(3838),
    [sym_preproc_error] = STATE(3838),
    [sym_preproc_warning] = STATE(3838),
    [sym_preproc_define] = STATE(3838),
    [sym_preproc_undef] = STATE(3838),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_ref] = ACTIONS(4267),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_readonly] = ACTIONS(6185),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5858),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3839] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3839),
    [sym_preproc_endregion] = STATE(3839),
    [sym_preproc_line] = STATE(3839),
    [sym_preproc_pragma] = STATE(3839),
    [sym_preproc_nullable] = STATE(3839),
    [sym_preproc_error] = STATE(3839),
    [sym_preproc_warning] = STATE(3839),
    [sym_preproc_define] = STATE(3839),
    [sym_preproc_undef] = STATE(3839),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5874),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5874),
    [anon_sym_into] = ACTIONS(5874),
    [anon_sym_join] = ACTIONS(5874),
    [anon_sym_let] = ACTIONS(5874),
    [anon_sym_orderby] = ACTIONS(5874),
    [anon_sym_ascending] = ACTIONS(5874),
    [anon_sym_descending] = ACTIONS(5874),
    [anon_sym_group] = ACTIONS(5874),
    [anon_sym_select] = ACTIONS(5874),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3840] = {
    [sym__name] = STATE(2450),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_type] = STATE(2399),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(3840),
    [sym_preproc_endregion] = STATE(3840),
    [sym_preproc_line] = STATE(3840),
    [sym_preproc_pragma] = STATE(3840),
    [sym_preproc_nullable] = STATE(3840),
    [sym_preproc_error] = STATE(3840),
    [sym_preproc_warning] = STATE(3840),
    [sym_preproc_define] = STATE(3840),
    [sym_preproc_undef] = STATE(3840),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(6187),
    [anon_sym_ref] = ACTIONS(4100),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_readonly] = ACTIONS(6189),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_scoped] = ACTIONS(5908),
    [anon_sym_var] = ACTIONS(5900),
    [sym_predefined_type] = ACTIONS(5902),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3841] = {
    [sym_preproc_region] = STATE(3841),
    [sym_preproc_endregion] = STATE(3841),
    [sym_preproc_line] = STATE(3841),
    [sym_preproc_pragma] = STATE(3841),
    [sym_preproc_nullable] = STATE(3841),
    [sym_preproc_error] = STATE(3841),
    [sym_preproc_warning] = STATE(3841),
    [sym_preproc_define] = STATE(3841),
    [sym_preproc_undef] = STATE(3841),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_COMMA] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_LT] = ACTIONS(4985),
    [anon_sym_GT] = ACTIONS(4985),
    [anon_sym_where] = ACTIONS(4983),
    [anon_sym_QMARK] = ACTIONS(4985),
    [anon_sym_BANG] = ACTIONS(4985),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4985),
    [anon_sym_DASH] = ACTIONS(4985),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_SLASH] = ACTIONS(4985),
    [anon_sym_PERCENT] = ACTIONS(4983),
    [anon_sym_CARET] = ACTIONS(4983),
    [anon_sym_PIPE] = ACTIONS(4985),
    [anon_sym_AMP] = ACTIONS(4985),
    [anon_sym_LT_LT] = ACTIONS(4983),
    [anon_sym_GT_GT] = ACTIONS(4985),
    [anon_sym_GT_GT_GT] = ACTIONS(4983),
    [anon_sym_EQ_EQ] = ACTIONS(4983),
    [anon_sym_BANG_EQ] = ACTIONS(4983),
    [anon_sym_GT_EQ] = ACTIONS(4983),
    [anon_sym_LT_EQ] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4985),
    [anon_sym_switch] = ACTIONS(4983),
    [anon_sym_DOT_DOT] = ACTIONS(4983),
    [anon_sym_and] = ACTIONS(4983),
    [anon_sym_or] = ACTIONS(4985),
    [anon_sym_AMP_AMP] = ACTIONS(4983),
    [anon_sym_PIPE_PIPE] = ACTIONS(4983),
    [anon_sym_QMARK_QMARK] = ACTIONS(4983),
    [anon_sym_from] = ACTIONS(4983),
    [anon_sym_into] = ACTIONS(4983),
    [anon_sym_join] = ACTIONS(4983),
    [anon_sym_let] = ACTIONS(4983),
    [anon_sym_orderby] = ACTIONS(4983),
    [anon_sym_ascending] = ACTIONS(4983),
    [anon_sym_descending] = ACTIONS(4983),
    [anon_sym_group] = ACTIONS(4983),
    [anon_sym_select] = ACTIONS(4983),
    [anon_sym_as] = ACTIONS(4985),
    [anon_sym_is] = ACTIONS(4983),
    [anon_sym_DASH_GT] = ACTIONS(4983),
    [anon_sym_with] = ACTIONS(4983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3842] = {
    [sym_preproc_region] = STATE(3842),
    [sym_preproc_endregion] = STATE(3842),
    [sym_preproc_line] = STATE(3842),
    [sym_preproc_pragma] = STATE(3842),
    [sym_preproc_nullable] = STATE(3842),
    [sym_preproc_error] = STATE(3842),
    [sym_preproc_warning] = STATE(3842),
    [sym_preproc_define] = STATE(3842),
    [sym_preproc_undef] = STATE(3842),
    [anon_sym_LBRACK] = ACTIONS(5421),
    [anon_sym_COMMA] = ACTIONS(5421),
    [anon_sym_LPAREN] = ACTIONS(5421),
    [anon_sym_LT] = ACTIONS(5423),
    [anon_sym_GT] = ACTIONS(5423),
    [anon_sym_where] = ACTIONS(5421),
    [anon_sym_QMARK] = ACTIONS(5423),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5423),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_SLASH] = ACTIONS(5423),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_CARET] = ACTIONS(5421),
    [anon_sym_PIPE] = ACTIONS(5423),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_LT_LT] = ACTIONS(5421),
    [anon_sym_GT_GT] = ACTIONS(5423),
    [anon_sym_GT_GT_GT] = ACTIONS(5421),
    [anon_sym_EQ_EQ] = ACTIONS(5421),
    [anon_sym_BANG_EQ] = ACTIONS(5421),
    [anon_sym_GT_EQ] = ACTIONS(5421),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_DOT] = ACTIONS(5423),
    [anon_sym_switch] = ACTIONS(5421),
    [anon_sym_DOT_DOT] = ACTIONS(5421),
    [anon_sym_and] = ACTIONS(5421),
    [anon_sym_or] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5421),
    [anon_sym_QMARK_QMARK] = ACTIONS(5421),
    [anon_sym_from] = ACTIONS(5421),
    [anon_sym_into] = ACTIONS(5421),
    [anon_sym_join] = ACTIONS(5421),
    [anon_sym_let] = ACTIONS(5421),
    [anon_sym_orderby] = ACTIONS(5421),
    [anon_sym_ascending] = ACTIONS(5421),
    [anon_sym_descending] = ACTIONS(5421),
    [anon_sym_group] = ACTIONS(5421),
    [anon_sym_select] = ACTIONS(5421),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_is] = ACTIONS(5421),
    [anon_sym_DASH_GT] = ACTIONS(5421),
    [anon_sym_with] = ACTIONS(5421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3843] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3843),
    [sym_preproc_endregion] = STATE(3843),
    [sym_preproc_line] = STATE(3843),
    [sym_preproc_pragma] = STATE(3843),
    [sym_preproc_nullable] = STATE(3843),
    [sym_preproc_error] = STATE(3843),
    [sym_preproc_warning] = STATE(3843),
    [sym_preproc_define] = STATE(3843),
    [sym_preproc_undef] = STATE(3843),
    [anon_sym_SEMI] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_RBRACK] = ACTIONS(5794),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5794),
    [anon_sym_RBRACE] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5794),
    [anon_sym_or] = ACTIONS(5794),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5794),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5794),
    [aux_sym_preproc_else_token1] = ACTIONS(5794),
    [aux_sym_preproc_elif_token1] = ACTIONS(5794),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3844] = {
    [sym_preproc_region] = STATE(3844),
    [sym_preproc_endregion] = STATE(3844),
    [sym_preproc_line] = STATE(3844),
    [sym_preproc_pragma] = STATE(3844),
    [sym_preproc_nullable] = STATE(3844),
    [sym_preproc_error] = STATE(3844),
    [sym_preproc_warning] = STATE(3844),
    [sym_preproc_define] = STATE(3844),
    [sym_preproc_undef] = STATE(3844),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [anon_sym_COMMA] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(5427),
    [anon_sym_GT] = ACTIONS(5427),
    [anon_sym_where] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5427),
    [anon_sym_BANG] = ACTIONS(5427),
    [anon_sym_PLUS_PLUS] = ACTIONS(5425),
    [anon_sym_DASH_DASH] = ACTIONS(5425),
    [anon_sym_PLUS] = ACTIONS(5427),
    [anon_sym_DASH] = ACTIONS(5427),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_SLASH] = ACTIONS(5427),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_CARET] = ACTIONS(5425),
    [anon_sym_PIPE] = ACTIONS(5427),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_LT_LT] = ACTIONS(5425),
    [anon_sym_GT_GT] = ACTIONS(5427),
    [anon_sym_GT_GT_GT] = ACTIONS(5425),
    [anon_sym_EQ_EQ] = ACTIONS(5425),
    [anon_sym_BANG_EQ] = ACTIONS(5425),
    [anon_sym_GT_EQ] = ACTIONS(5425),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_DOT] = ACTIONS(5427),
    [anon_sym_switch] = ACTIONS(5425),
    [anon_sym_DOT_DOT] = ACTIONS(5425),
    [anon_sym_and] = ACTIONS(5425),
    [anon_sym_or] = ACTIONS(5427),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5425),
    [anon_sym_QMARK_QMARK] = ACTIONS(5425),
    [anon_sym_from] = ACTIONS(5425),
    [anon_sym_into] = ACTIONS(5425),
    [anon_sym_join] = ACTIONS(5425),
    [anon_sym_let] = ACTIONS(5425),
    [anon_sym_orderby] = ACTIONS(5425),
    [anon_sym_ascending] = ACTIONS(5425),
    [anon_sym_descending] = ACTIONS(5425),
    [anon_sym_group] = ACTIONS(5425),
    [anon_sym_select] = ACTIONS(5425),
    [anon_sym_as] = ACTIONS(5427),
    [anon_sym_is] = ACTIONS(5425),
    [anon_sym_DASH_GT] = ACTIONS(5425),
    [anon_sym_with] = ACTIONS(5425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3845] = {
    [sym_preproc_region] = STATE(3845),
    [sym_preproc_endregion] = STATE(3845),
    [sym_preproc_line] = STATE(3845),
    [sym_preproc_pragma] = STATE(3845),
    [sym_preproc_nullable] = STATE(3845),
    [sym_preproc_error] = STATE(3845),
    [sym_preproc_warning] = STATE(3845),
    [sym_preproc_define] = STATE(3845),
    [sym_preproc_undef] = STATE(3845),
    [anon_sym_LBRACK] = ACTIONS(5429),
    [anon_sym_COMMA] = ACTIONS(5429),
    [anon_sym_LPAREN] = ACTIONS(5429),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_where] = ACTIONS(5429),
    [anon_sym_QMARK] = ACTIONS(5431),
    [anon_sym_BANG] = ACTIONS(5431),
    [anon_sym_PLUS_PLUS] = ACTIONS(5429),
    [anon_sym_DASH_DASH] = ACTIONS(5429),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_CARET] = ACTIONS(5429),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5429),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_GT_GT_GT] = ACTIONS(5429),
    [anon_sym_EQ_EQ] = ACTIONS(5429),
    [anon_sym_BANG_EQ] = ACTIONS(5429),
    [anon_sym_GT_EQ] = ACTIONS(5429),
    [anon_sym_LT_EQ] = ACTIONS(5429),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_switch] = ACTIONS(5429),
    [anon_sym_DOT_DOT] = ACTIONS(5429),
    [anon_sym_and] = ACTIONS(5429),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_PIPE_PIPE] = ACTIONS(5429),
    [anon_sym_QMARK_QMARK] = ACTIONS(5429),
    [anon_sym_from] = ACTIONS(5429),
    [anon_sym_into] = ACTIONS(5429),
    [anon_sym_join] = ACTIONS(5429),
    [anon_sym_let] = ACTIONS(5429),
    [anon_sym_orderby] = ACTIONS(5429),
    [anon_sym_ascending] = ACTIONS(5429),
    [anon_sym_descending] = ACTIONS(5429),
    [anon_sym_group] = ACTIONS(5429),
    [anon_sym_select] = ACTIONS(5429),
    [anon_sym_as] = ACTIONS(5431),
    [anon_sym_is] = ACTIONS(5429),
    [anon_sym_DASH_GT] = ACTIONS(5429),
    [anon_sym_with] = ACTIONS(5429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3846] = {
    [sym_preproc_region] = STATE(3846),
    [sym_preproc_endregion] = STATE(3846),
    [sym_preproc_line] = STATE(3846),
    [sym_preproc_pragma] = STATE(3846),
    [sym_preproc_nullable] = STATE(3846),
    [sym_preproc_error] = STATE(3846),
    [sym_preproc_warning] = STATE(3846),
    [sym_preproc_define] = STATE(3846),
    [sym_preproc_undef] = STATE(3846),
    [anon_sym_LBRACK] = ACTIONS(5437),
    [anon_sym_COMMA] = ACTIONS(5437),
    [anon_sym_LPAREN] = ACTIONS(5437),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_where] = ACTIONS(5437),
    [anon_sym_QMARK] = ACTIONS(5439),
    [anon_sym_BANG] = ACTIONS(5439),
    [anon_sym_PLUS_PLUS] = ACTIONS(5437),
    [anon_sym_DASH_DASH] = ACTIONS(5437),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5437),
    [anon_sym_CARET] = ACTIONS(5437),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5437),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_GT_GT_GT] = ACTIONS(5437),
    [anon_sym_EQ_EQ] = ACTIONS(5437),
    [anon_sym_BANG_EQ] = ACTIONS(5437),
    [anon_sym_GT_EQ] = ACTIONS(5437),
    [anon_sym_LT_EQ] = ACTIONS(5437),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_switch] = ACTIONS(5437),
    [anon_sym_DOT_DOT] = ACTIONS(5437),
    [anon_sym_and] = ACTIONS(5437),
    [anon_sym_or] = ACTIONS(5439),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_PIPE_PIPE] = ACTIONS(5437),
    [anon_sym_QMARK_QMARK] = ACTIONS(5437),
    [anon_sym_from] = ACTIONS(5437),
    [anon_sym_into] = ACTIONS(5437),
    [anon_sym_join] = ACTIONS(5437),
    [anon_sym_let] = ACTIONS(5437),
    [anon_sym_orderby] = ACTIONS(5437),
    [anon_sym_ascending] = ACTIONS(5437),
    [anon_sym_descending] = ACTIONS(5437),
    [anon_sym_group] = ACTIONS(5437),
    [anon_sym_select] = ACTIONS(5437),
    [anon_sym_as] = ACTIONS(5439),
    [anon_sym_is] = ACTIONS(5437),
    [anon_sym_DASH_GT] = ACTIONS(5437),
    [anon_sym_with] = ACTIONS(5437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3847] = {
    [sym_preproc_region] = STATE(3847),
    [sym_preproc_endregion] = STATE(3847),
    [sym_preproc_line] = STATE(3847),
    [sym_preproc_pragma] = STATE(3847),
    [sym_preproc_nullable] = STATE(3847),
    [sym_preproc_error] = STATE(3847),
    [sym_preproc_warning] = STATE(3847),
    [sym_preproc_define] = STATE(3847),
    [sym_preproc_undef] = STATE(3847),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(6191),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_where] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_GT_GT_GT] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1997),
    [anon_sym_QMARK_QMARK] = ACTIONS(1997),
    [anon_sym_from] = ACTIONS(1997),
    [anon_sym_into] = ACTIONS(1997),
    [anon_sym_join] = ACTIONS(1997),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_orderby] = ACTIONS(1997),
    [anon_sym_ascending] = ACTIONS(1997),
    [anon_sym_descending] = ACTIONS(1997),
    [anon_sym_group] = ACTIONS(1997),
    [anon_sym_select] = ACTIONS(1997),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1997),
    [anon_sym_DASH_GT] = ACTIONS(1997),
    [anon_sym_with] = ACTIONS(1997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3848] = {
    [sym_preproc_region] = STATE(3848),
    [sym_preproc_endregion] = STATE(3848),
    [sym_preproc_line] = STATE(3848),
    [sym_preproc_pragma] = STATE(3848),
    [sym_preproc_nullable] = STATE(3848),
    [sym_preproc_error] = STATE(3848),
    [sym_preproc_warning] = STATE(3848),
    [sym_preproc_define] = STATE(3848),
    [sym_preproc_undef] = STATE(3848),
    [anon_sym_LBRACK] = ACTIONS(5451),
    [anon_sym_COMMA] = ACTIONS(5451),
    [anon_sym_LPAREN] = ACTIONS(5451),
    [anon_sym_LT] = ACTIONS(5453),
    [anon_sym_GT] = ACTIONS(5453),
    [anon_sym_where] = ACTIONS(5451),
    [anon_sym_QMARK] = ACTIONS(5453),
    [anon_sym_BANG] = ACTIONS(5453),
    [anon_sym_PLUS_PLUS] = ACTIONS(5451),
    [anon_sym_DASH_DASH] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5453),
    [anon_sym_DASH] = ACTIONS(5453),
    [anon_sym_STAR] = ACTIONS(5451),
    [anon_sym_SLASH] = ACTIONS(5453),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_CARET] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5453),
    [anon_sym_AMP] = ACTIONS(5453),
    [anon_sym_LT_LT] = ACTIONS(5451),
    [anon_sym_GT_GT] = ACTIONS(5453),
    [anon_sym_GT_GT_GT] = ACTIONS(5451),
    [anon_sym_EQ_EQ] = ACTIONS(5451),
    [anon_sym_BANG_EQ] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5451),
    [anon_sym_LT_EQ] = ACTIONS(5451),
    [anon_sym_DOT] = ACTIONS(5453),
    [anon_sym_switch] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_and] = ACTIONS(5451),
    [anon_sym_or] = ACTIONS(5453),
    [anon_sym_AMP_AMP] = ACTIONS(5451),
    [anon_sym_PIPE_PIPE] = ACTIONS(5451),
    [anon_sym_QMARK_QMARK] = ACTIONS(5451),
    [anon_sym_from] = ACTIONS(5451),
    [anon_sym_into] = ACTIONS(5451),
    [anon_sym_join] = ACTIONS(5451),
    [anon_sym_let] = ACTIONS(5451),
    [anon_sym_orderby] = ACTIONS(5451),
    [anon_sym_ascending] = ACTIONS(5451),
    [anon_sym_descending] = ACTIONS(5451),
    [anon_sym_group] = ACTIONS(5451),
    [anon_sym_select] = ACTIONS(5451),
    [anon_sym_as] = ACTIONS(5453),
    [anon_sym_is] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_with] = ACTIONS(5451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3849] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3849),
    [sym_preproc_endregion] = STATE(3849),
    [sym_preproc_line] = STATE(3849),
    [sym_preproc_pragma] = STATE(3849),
    [sym_preproc_nullable] = STATE(3849),
    [sym_preproc_error] = STATE(3849),
    [sym_preproc_warning] = STATE(3849),
    [sym_preproc_define] = STATE(3849),
    [sym_preproc_undef] = STATE(3849),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3850] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3850),
    [sym_preproc_endregion] = STATE(3850),
    [sym_preproc_line] = STATE(3850),
    [sym_preproc_pragma] = STATE(3850),
    [sym_preproc_nullable] = STATE(3850),
    [sym_preproc_error] = STATE(3850),
    [sym_preproc_warning] = STATE(3850),
    [sym_preproc_define] = STATE(3850),
    [sym_preproc_undef] = STATE(3850),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3851] = {
    [sym_variable_declaration] = STATE(7356),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5969),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3851),
    [sym_preproc_endregion] = STATE(3851),
    [sym_preproc_line] = STATE(3851),
    [sym_preproc_pragma] = STATE(3851),
    [sym_preproc_nullable] = STATE(3851),
    [sym_preproc_error] = STATE(3851),
    [sym_preproc_warning] = STATE(3851),
    [sym_preproc_define] = STATE(3851),
    [sym_preproc_undef] = STATE(3851),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3852] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3852),
    [sym_preproc_endregion] = STATE(3852),
    [sym_preproc_line] = STATE(3852),
    [sym_preproc_pragma] = STATE(3852),
    [sym_preproc_nullable] = STATE(3852),
    [sym_preproc_error] = STATE(3852),
    [sym_preproc_warning] = STATE(3852),
    [sym_preproc_define] = STATE(3852),
    [sym_preproc_undef] = STATE(3852),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3853] = {
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2961),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(2979),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3853),
    [sym_preproc_endregion] = STATE(3853),
    [sym_preproc_line] = STATE(3853),
    [sym_preproc_pragma] = STATE(3853),
    [sym_preproc_nullable] = STATE(3853),
    [sym_preproc_error] = STATE(3853),
    [sym_preproc_warning] = STATE(3853),
    [sym_preproc_define] = STATE(3853),
    [sym_preproc_undef] = STATE(3853),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_ref] = ACTIONS(4255),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_readonly] = ACTIONS(6193),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5928),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3854] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7137),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3854),
    [sym_preproc_endregion] = STATE(3854),
    [sym_preproc_line] = STATE(3854),
    [sym_preproc_pragma] = STATE(3854),
    [sym_preproc_nullable] = STATE(3854),
    [sym_preproc_error] = STATE(3854),
    [sym_preproc_warning] = STATE(3854),
    [sym_preproc_define] = STATE(3854),
    [sym_preproc_undef] = STATE(3854),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3855] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3855),
    [sym_preproc_endregion] = STATE(3855),
    [sym_preproc_line] = STATE(3855),
    [sym_preproc_pragma] = STATE(3855),
    [sym_preproc_nullable] = STATE(3855),
    [sym_preproc_error] = STATE(3855),
    [sym_preproc_warning] = STATE(3855),
    [sym_preproc_define] = STATE(3855),
    [sym_preproc_undef] = STATE(3855),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_QMARK_QMARK] = ACTIONS(5682),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3856] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3856),
    [sym_preproc_endregion] = STATE(3856),
    [sym_preproc_line] = STATE(3856),
    [sym_preproc_pragma] = STATE(3856),
    [sym_preproc_nullable] = STATE(3856),
    [sym_preproc_error] = STATE(3856),
    [sym_preproc_warning] = STATE(3856),
    [sym_preproc_define] = STATE(3856),
    [sym_preproc_undef] = STATE(3856),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5684),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5682),
    [anon_sym_into] = ACTIONS(5682),
    [anon_sym_join] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_orderby] = ACTIONS(5682),
    [anon_sym_ascending] = ACTIONS(5682),
    [anon_sym_descending] = ACTIONS(5682),
    [anon_sym_group] = ACTIONS(5682),
    [anon_sym_select] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3857] = {
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2961),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(2979),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3857),
    [sym_preproc_endregion] = STATE(3857),
    [sym_preproc_line] = STATE(3857),
    [sym_preproc_pragma] = STATE(3857),
    [sym_preproc_nullable] = STATE(3857),
    [sym_preproc_error] = STATE(3857),
    [sym_preproc_warning] = STATE(3857),
    [sym_preproc_define] = STATE(3857),
    [sym_preproc_undef] = STATE(3857),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_ref] = ACTIONS(4257),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_readonly] = ACTIONS(6195),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5780),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3858] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3858),
    [sym_preproc_endregion] = STATE(3858),
    [sym_preproc_line] = STATE(3858),
    [sym_preproc_pragma] = STATE(3858),
    [sym_preproc_nullable] = STATE(3858),
    [sym_preproc_error] = STATE(3858),
    [sym_preproc_warning] = STATE(3858),
    [sym_preproc_define] = STATE(3858),
    [sym_preproc_undef] = STATE(3858),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5866),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5866),
    [anon_sym_into] = ACTIONS(5866),
    [anon_sym_join] = ACTIONS(5866),
    [anon_sym_let] = ACTIONS(5866),
    [anon_sym_orderby] = ACTIONS(5866),
    [anon_sym_ascending] = ACTIONS(5866),
    [anon_sym_descending] = ACTIONS(5866),
    [anon_sym_group] = ACTIONS(5866),
    [anon_sym_select] = ACTIONS(5866),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3859] = {
    [sym_preproc_region] = STATE(3859),
    [sym_preproc_endregion] = STATE(3859),
    [sym_preproc_line] = STATE(3859),
    [sym_preproc_pragma] = STATE(3859),
    [sym_preproc_nullable] = STATE(3859),
    [sym_preproc_error] = STATE(3859),
    [sym_preproc_warning] = STATE(3859),
    [sym_preproc_define] = STATE(3859),
    [sym_preproc_undef] = STATE(3859),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_COMMA] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5147),
    [anon_sym_where] = ACTIONS(5145),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_BANG] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5147),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5145),
    [anon_sym_PIPE] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5147),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5147),
    [anon_sym_GT_GT_GT] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5145),
    [anon_sym_BANG_EQ] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5145),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_DOT] = ACTIONS(5147),
    [anon_sym_switch] = ACTIONS(5145),
    [anon_sym_DOT_DOT] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_or] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5145),
    [anon_sym_PIPE_PIPE] = ACTIONS(5145),
    [anon_sym_QMARK_QMARK] = ACTIONS(5145),
    [anon_sym_from] = ACTIONS(5145),
    [anon_sym_into] = ACTIONS(5145),
    [anon_sym_join] = ACTIONS(5145),
    [anon_sym_let] = ACTIONS(5145),
    [anon_sym_orderby] = ACTIONS(5145),
    [anon_sym_ascending] = ACTIONS(5145),
    [anon_sym_descending] = ACTIONS(5145),
    [anon_sym_group] = ACTIONS(5145),
    [anon_sym_select] = ACTIONS(5145),
    [anon_sym_as] = ACTIONS(5147),
    [anon_sym_is] = ACTIONS(5145),
    [anon_sym_DASH_GT] = ACTIONS(5145),
    [anon_sym_with] = ACTIONS(5145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3860] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7234),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3860),
    [sym_preproc_endregion] = STATE(3860),
    [sym_preproc_line] = STATE(3860),
    [sym_preproc_pragma] = STATE(3860),
    [sym_preproc_nullable] = STATE(3860),
    [sym_preproc_error] = STATE(3860),
    [sym_preproc_warning] = STATE(3860),
    [sym_preproc_define] = STATE(3860),
    [sym_preproc_undef] = STATE(3860),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3861] = {
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3360),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3355),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3861),
    [sym_preproc_endregion] = STATE(3861),
    [sym_preproc_line] = STATE(3861),
    [sym_preproc_pragma] = STATE(3861),
    [sym_preproc_nullable] = STATE(3861),
    [sym_preproc_error] = STATE(3861),
    [sym_preproc_warning] = STATE(3861),
    [sym_preproc_define] = STATE(3861),
    [sym_preproc_undef] = STATE(3861),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_ref] = ACTIONS(3802),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(6197),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5714),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3862] = {
    [sym_preproc_region] = STATE(3862),
    [sym_preproc_endregion] = STATE(3862),
    [sym_preproc_line] = STATE(3862),
    [sym_preproc_pragma] = STATE(3862),
    [sym_preproc_nullable] = STATE(3862),
    [sym_preproc_error] = STATE(3862),
    [sym_preproc_warning] = STATE(3862),
    [sym_preproc_define] = STATE(3862),
    [sym_preproc_undef] = STATE(3862),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_COMMA] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_LT] = ACTIONS(5025),
    [anon_sym_GT] = ACTIONS(5025),
    [anon_sym_where] = ACTIONS(5023),
    [anon_sym_QMARK] = ACTIONS(5025),
    [anon_sym_BANG] = ACTIONS(5025),
    [anon_sym_PLUS_PLUS] = ACTIONS(5023),
    [anon_sym_DASH_DASH] = ACTIONS(5023),
    [anon_sym_PLUS] = ACTIONS(5025),
    [anon_sym_DASH] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5023),
    [anon_sym_SLASH] = ACTIONS(5025),
    [anon_sym_PERCENT] = ACTIONS(5023),
    [anon_sym_CARET] = ACTIONS(5023),
    [anon_sym_PIPE] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5025),
    [anon_sym_LT_LT] = ACTIONS(5023),
    [anon_sym_GT_GT] = ACTIONS(5025),
    [anon_sym_GT_GT_GT] = ACTIONS(5023),
    [anon_sym_EQ_EQ] = ACTIONS(5023),
    [anon_sym_BANG_EQ] = ACTIONS(5023),
    [anon_sym_GT_EQ] = ACTIONS(5023),
    [anon_sym_LT_EQ] = ACTIONS(5023),
    [anon_sym_DOT] = ACTIONS(5025),
    [anon_sym_switch] = ACTIONS(5023),
    [anon_sym_DOT_DOT] = ACTIONS(5023),
    [anon_sym_and] = ACTIONS(5023),
    [anon_sym_or] = ACTIONS(5025),
    [anon_sym_AMP_AMP] = ACTIONS(5023),
    [anon_sym_PIPE_PIPE] = ACTIONS(5023),
    [anon_sym_QMARK_QMARK] = ACTIONS(5023),
    [anon_sym_from] = ACTIONS(5023),
    [anon_sym_into] = ACTIONS(5023),
    [anon_sym_join] = ACTIONS(5023),
    [anon_sym_let] = ACTIONS(5023),
    [anon_sym_orderby] = ACTIONS(5023),
    [anon_sym_ascending] = ACTIONS(5023),
    [anon_sym_descending] = ACTIONS(5023),
    [anon_sym_group] = ACTIONS(5023),
    [anon_sym_select] = ACTIONS(5023),
    [anon_sym_as] = ACTIONS(5025),
    [anon_sym_is] = ACTIONS(5023),
    [anon_sym_DASH_GT] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3863] = {
    [sym_preproc_region] = STATE(3863),
    [sym_preproc_endregion] = STATE(3863),
    [sym_preproc_line] = STATE(3863),
    [sym_preproc_pragma] = STATE(3863),
    [sym_preproc_nullable] = STATE(3863),
    [sym_preproc_error] = STATE(3863),
    [sym_preproc_warning] = STATE(3863),
    [sym_preproc_define] = STATE(3863),
    [sym_preproc_undef] = STATE(3863),
    [anon_sym_LBRACK] = ACTIONS(6199),
    [anon_sym_COMMA] = ACTIONS(6199),
    [anon_sym_LPAREN] = ACTIONS(6199),
    [anon_sym_LT] = ACTIONS(6201),
    [anon_sym_GT] = ACTIONS(6201),
    [anon_sym_where] = ACTIONS(6199),
    [anon_sym_QMARK] = ACTIONS(6201),
    [anon_sym_BANG] = ACTIONS(6201),
    [anon_sym_PLUS_PLUS] = ACTIONS(6199),
    [anon_sym_DASH_DASH] = ACTIONS(6199),
    [anon_sym_PLUS] = ACTIONS(6201),
    [anon_sym_DASH] = ACTIONS(6201),
    [anon_sym_STAR] = ACTIONS(6199),
    [anon_sym_SLASH] = ACTIONS(6201),
    [anon_sym_PERCENT] = ACTIONS(6199),
    [anon_sym_CARET] = ACTIONS(6199),
    [anon_sym_PIPE] = ACTIONS(6201),
    [anon_sym_AMP] = ACTIONS(6201),
    [anon_sym_LT_LT] = ACTIONS(6199),
    [anon_sym_GT_GT] = ACTIONS(6201),
    [anon_sym_GT_GT_GT] = ACTIONS(6199),
    [anon_sym_EQ_EQ] = ACTIONS(6199),
    [anon_sym_BANG_EQ] = ACTIONS(6199),
    [anon_sym_GT_EQ] = ACTIONS(6199),
    [anon_sym_LT_EQ] = ACTIONS(6199),
    [anon_sym_DOT] = ACTIONS(6201),
    [anon_sym_switch] = ACTIONS(6199),
    [anon_sym_DOT_DOT] = ACTIONS(6199),
    [anon_sym_and] = ACTIONS(6167),
    [anon_sym_or] = ACTIONS(6201),
    [anon_sym_AMP_AMP] = ACTIONS(6199),
    [anon_sym_PIPE_PIPE] = ACTIONS(6199),
    [anon_sym_QMARK_QMARK] = ACTIONS(6199),
    [anon_sym_from] = ACTIONS(6199),
    [anon_sym_into] = ACTIONS(6199),
    [anon_sym_join] = ACTIONS(6199),
    [anon_sym_let] = ACTIONS(6199),
    [anon_sym_orderby] = ACTIONS(6199),
    [anon_sym_ascending] = ACTIONS(6199),
    [anon_sym_descending] = ACTIONS(6199),
    [anon_sym_group] = ACTIONS(6199),
    [anon_sym_select] = ACTIONS(6199),
    [anon_sym_as] = ACTIONS(6201),
    [anon_sym_is] = ACTIONS(6199),
    [anon_sym_DASH_GT] = ACTIONS(6199),
    [anon_sym_with] = ACTIONS(6199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3864] = {
    [sym_variable_declaration] = STATE(7386),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5969),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3864),
    [sym_preproc_endregion] = STATE(3864),
    [sym_preproc_line] = STATE(3864),
    [sym_preproc_pragma] = STATE(3864),
    [sym_preproc_nullable] = STATE(3864),
    [sym_preproc_error] = STATE(3864),
    [sym_preproc_warning] = STATE(3864),
    [sym_preproc_define] = STATE(3864),
    [sym_preproc_undef] = STATE(3864),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3865] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7167),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3865),
    [sym_preproc_endregion] = STATE(3865),
    [sym_preproc_line] = STATE(3865),
    [sym_preproc_pragma] = STATE(3865),
    [sym_preproc_nullable] = STATE(3865),
    [sym_preproc_error] = STATE(3865),
    [sym_preproc_warning] = STATE(3865),
    [sym_preproc_define] = STATE(3865),
    [sym_preproc_undef] = STATE(3865),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3866] = {
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2961),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(2979),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3866),
    [sym_preproc_endregion] = STATE(3866),
    [sym_preproc_line] = STATE(3866),
    [sym_preproc_pragma] = STATE(3866),
    [sym_preproc_nullable] = STATE(3866),
    [sym_preproc_error] = STATE(3866),
    [sym_preproc_warning] = STATE(3866),
    [sym_preproc_define] = STATE(3866),
    [sym_preproc_undef] = STATE(3866),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_ref] = ACTIONS(3873),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_readonly] = ACTIONS(6203),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5882),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3867] = {
    [sym__name] = STATE(3584),
    [sym_alias_qualified_name] = STATE(2992),
    [sym__simple_name] = STATE(2992),
    [sym_qualified_name] = STATE(2992),
    [sym_generic_name] = STATE(2964),
    [sym_type] = STATE(2961),
    [sym_implicit_type] = STATE(2966),
    [sym_array_type] = STATE(2979),
    [sym__array_base_type] = STATE(7132),
    [sym_nullable_type] = STATE(2983),
    [sym_pointer_type] = STATE(2983),
    [sym__pointer_base_type] = STATE(7662),
    [sym_function_pointer_type] = STATE(2983),
    [sym_ref_type] = STATE(2966),
    [sym_scoped_type] = STATE(2966),
    [sym_tuple_type] = STATE(2987),
    [sym_identifier] = STATE(3270),
    [sym__reserved_identifier] = STATE(2952),
    [sym_preproc_region] = STATE(3867),
    [sym_preproc_endregion] = STATE(3867),
    [sym_preproc_line] = STATE(3867),
    [sym_preproc_pragma] = STATE(3867),
    [sym_preproc_nullable] = STATE(3867),
    [sym_preproc_error] = STATE(3867),
    [sym_preproc_warning] = STATE(3867),
    [sym_preproc_define] = STATE(3867),
    [sym_preproc_undef] = STATE(3867),
    [sym__identifier_token] = ACTIONS(3869),
    [anon_sym_alias] = ACTIONS(3871),
    [anon_sym_global] = ACTIONS(3871),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_ref] = ACTIONS(4253),
    [anon_sym_delegate] = ACTIONS(5778),
    [anon_sym_file] = ACTIONS(3871),
    [anon_sym_readonly] = ACTIONS(6205),
    [anon_sym_where] = ACTIONS(3871),
    [anon_sym_notnull] = ACTIONS(3871),
    [anon_sym_unmanaged] = ACTIONS(3871),
    [anon_sym_scoped] = ACTIONS(5786),
    [anon_sym_var] = ACTIONS(5782),
    [sym_predefined_type] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(3871),
    [anon_sym_when] = ACTIONS(3871),
    [anon_sym_from] = ACTIONS(3871),
    [anon_sym_into] = ACTIONS(3871),
    [anon_sym_join] = ACTIONS(3871),
    [anon_sym_on] = ACTIONS(3871),
    [anon_sym_equals] = ACTIONS(3871),
    [anon_sym_let] = ACTIONS(3871),
    [anon_sym_orderby] = ACTIONS(3871),
    [anon_sym_ascending] = ACTIONS(3871),
    [anon_sym_descending] = ACTIONS(3871),
    [anon_sym_group] = ACTIONS(3871),
    [anon_sym_by] = ACTIONS(3871),
    [anon_sym_select] = ACTIONS(3871),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3868] = {
    [sym_preproc_region] = STATE(3868),
    [sym_preproc_endregion] = STATE(3868),
    [sym_preproc_line] = STATE(3868),
    [sym_preproc_pragma] = STATE(3868),
    [sym_preproc_nullable] = STATE(3868),
    [sym_preproc_error] = STATE(3868),
    [sym_preproc_warning] = STATE(3868),
    [sym_preproc_define] = STATE(3868),
    [sym_preproc_undef] = STATE(3868),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_COMMA] = ACTIONS(5031),
    [anon_sym_LPAREN] = ACTIONS(5031),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_GT] = ACTIONS(5033),
    [anon_sym_where] = ACTIONS(5031),
    [anon_sym_QMARK] = ACTIONS(5033),
    [anon_sym_BANG] = ACTIONS(5033),
    [anon_sym_PLUS_PLUS] = ACTIONS(5031),
    [anon_sym_DASH_DASH] = ACTIONS(5031),
    [anon_sym_PLUS] = ACTIONS(5033),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5031),
    [anon_sym_SLASH] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5031),
    [anon_sym_CARET] = ACTIONS(5031),
    [anon_sym_PIPE] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(5031),
    [anon_sym_GT_GT] = ACTIONS(5033),
    [anon_sym_GT_GT_GT] = ACTIONS(5031),
    [anon_sym_EQ_EQ] = ACTIONS(5031),
    [anon_sym_BANG_EQ] = ACTIONS(5031),
    [anon_sym_GT_EQ] = ACTIONS(5031),
    [anon_sym_LT_EQ] = ACTIONS(5031),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_switch] = ACTIONS(5031),
    [anon_sym_DOT_DOT] = ACTIONS(5031),
    [anon_sym_and] = ACTIONS(5031),
    [anon_sym_or] = ACTIONS(5033),
    [anon_sym_AMP_AMP] = ACTIONS(5031),
    [anon_sym_PIPE_PIPE] = ACTIONS(5031),
    [anon_sym_QMARK_QMARK] = ACTIONS(5031),
    [anon_sym_from] = ACTIONS(5031),
    [anon_sym_into] = ACTIONS(5031),
    [anon_sym_join] = ACTIONS(5031),
    [anon_sym_let] = ACTIONS(5031),
    [anon_sym_orderby] = ACTIONS(5031),
    [anon_sym_ascending] = ACTIONS(5031),
    [anon_sym_descending] = ACTIONS(5031),
    [anon_sym_group] = ACTIONS(5031),
    [anon_sym_select] = ACTIONS(5031),
    [anon_sym_as] = ACTIONS(5033),
    [anon_sym_is] = ACTIONS(5031),
    [anon_sym_DASH_GT] = ACTIONS(5031),
    [anon_sym_with] = ACTIONS(5031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3869] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7211),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3869),
    [sym_preproc_endregion] = STATE(3869),
    [sym_preproc_line] = STATE(3869),
    [sym_preproc_pragma] = STATE(3869),
    [sym_preproc_nullable] = STATE(3869),
    [sym_preproc_error] = STATE(3869),
    [sym_preproc_warning] = STATE(3869),
    [sym_preproc_define] = STATE(3869),
    [sym_preproc_undef] = STATE(3869),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3870] = {
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3360),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3355),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3870),
    [sym_preproc_endregion] = STATE(3870),
    [sym_preproc_line] = STATE(3870),
    [sym_preproc_pragma] = STATE(3870),
    [sym_preproc_nullable] = STATE(3870),
    [sym_preproc_error] = STATE(3870),
    [sym_preproc_warning] = STATE(3870),
    [sym_preproc_define] = STATE(3870),
    [sym_preproc_undef] = STATE(3870),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_ref] = ACTIONS(4194),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(6207),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5768),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3871] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3871),
    [sym_preproc_endregion] = STATE(3871),
    [sym_preproc_line] = STATE(3871),
    [sym_preproc_pragma] = STATE(3871),
    [sym_preproc_nullable] = STATE(3871),
    [sym_preproc_error] = STATE(3871),
    [sym_preproc_warning] = STATE(3871),
    [sym_preproc_define] = STATE(3871),
    [sym_preproc_undef] = STATE(3871),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3872] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6064),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_tuple_element] = STATE(7239),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3872),
    [sym_preproc_endregion] = STATE(3872),
    [sym_preproc_line] = STATE(3872),
    [sym_preproc_pragma] = STATE(3872),
    [sym_preproc_nullable] = STATE(3872),
    [sym_preproc_error] = STATE(3872),
    [sym_preproc_warning] = STATE(3872),
    [sym_preproc_define] = STATE(3872),
    [sym_preproc_undef] = STATE(3872),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3618),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(5906),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3873] = {
    [sym_preproc_region] = STATE(3873),
    [sym_preproc_endregion] = STATE(3873),
    [sym_preproc_line] = STATE(3873),
    [sym_preproc_pragma] = STATE(3873),
    [sym_preproc_nullable] = STATE(3873),
    [sym_preproc_error] = STATE(3873),
    [sym_preproc_warning] = STATE(3873),
    [sym_preproc_define] = STATE(3873),
    [sym_preproc_undef] = STATE(3873),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_COMMA] = ACTIONS(5035),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_LT] = ACTIONS(5037),
    [anon_sym_GT] = ACTIONS(5037),
    [anon_sym_where] = ACTIONS(5035),
    [anon_sym_QMARK] = ACTIONS(5037),
    [anon_sym_BANG] = ACTIONS(5037),
    [anon_sym_PLUS_PLUS] = ACTIONS(5035),
    [anon_sym_DASH_DASH] = ACTIONS(5035),
    [anon_sym_PLUS] = ACTIONS(5037),
    [anon_sym_DASH] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5035),
    [anon_sym_SLASH] = ACTIONS(5037),
    [anon_sym_PERCENT] = ACTIONS(5035),
    [anon_sym_CARET] = ACTIONS(5035),
    [anon_sym_PIPE] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5037),
    [anon_sym_LT_LT] = ACTIONS(5035),
    [anon_sym_GT_GT] = ACTIONS(5037),
    [anon_sym_GT_GT_GT] = ACTIONS(5035),
    [anon_sym_EQ_EQ] = ACTIONS(5035),
    [anon_sym_BANG_EQ] = ACTIONS(5035),
    [anon_sym_GT_EQ] = ACTIONS(5035),
    [anon_sym_LT_EQ] = ACTIONS(5035),
    [anon_sym_DOT] = ACTIONS(5037),
    [anon_sym_switch] = ACTIONS(5035),
    [anon_sym_DOT_DOT] = ACTIONS(5035),
    [anon_sym_and] = ACTIONS(5035),
    [anon_sym_or] = ACTIONS(5037),
    [anon_sym_AMP_AMP] = ACTIONS(5035),
    [anon_sym_PIPE_PIPE] = ACTIONS(5035),
    [anon_sym_QMARK_QMARK] = ACTIONS(5035),
    [anon_sym_from] = ACTIONS(5035),
    [anon_sym_into] = ACTIONS(5035),
    [anon_sym_join] = ACTIONS(5035),
    [anon_sym_let] = ACTIONS(5035),
    [anon_sym_orderby] = ACTIONS(5035),
    [anon_sym_ascending] = ACTIONS(5035),
    [anon_sym_descending] = ACTIONS(5035),
    [anon_sym_group] = ACTIONS(5035),
    [anon_sym_select] = ACTIONS(5035),
    [anon_sym_as] = ACTIONS(5037),
    [anon_sym_is] = ACTIONS(5035),
    [anon_sym_DASH_GT] = ACTIONS(5035),
    [anon_sym_with] = ACTIONS(5035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3874] = {
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3360),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3355),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3874),
    [sym_preproc_endregion] = STATE(3874),
    [sym_preproc_line] = STATE(3874),
    [sym_preproc_pragma] = STATE(3874),
    [sym_preproc_nullable] = STATE(3874),
    [sym_preproc_error] = STATE(3874),
    [sym_preproc_warning] = STATE(3874),
    [sym_preproc_define] = STATE(3874),
    [sym_preproc_undef] = STATE(3874),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_ref] = ACTIONS(4217),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(6209),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5788),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3875] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6161),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3875),
    [sym_preproc_endregion] = STATE(3875),
    [sym_preproc_line] = STATE(3875),
    [sym_preproc_pragma] = STATE(3875),
    [sym_preproc_nullable] = STATE(3875),
    [sym_preproc_error] = STATE(3875),
    [sym_preproc_warning] = STATE(3875),
    [sym_preproc_define] = STATE(3875),
    [sym_preproc_undef] = STATE(3875),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3876] = {
    [sym_preproc_region] = STATE(3876),
    [sym_preproc_endregion] = STATE(3876),
    [sym_preproc_line] = STATE(3876),
    [sym_preproc_pragma] = STATE(3876),
    [sym_preproc_nullable] = STATE(3876),
    [sym_preproc_error] = STATE(3876),
    [sym_preproc_warning] = STATE(3876),
    [sym_preproc_define] = STATE(3876),
    [sym_preproc_undef] = STATE(3876),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4900),
    [anon_sym_GT] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_BANG] = ACTIONS(4900),
    [anon_sym_PLUS_PLUS] = ACTIONS(4898),
    [anon_sym_DASH_DASH] = ACTIONS(4898),
    [anon_sym_PLUS] = ACTIONS(4900),
    [anon_sym_DASH] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4898),
    [anon_sym_SLASH] = ACTIONS(4900),
    [anon_sym_PERCENT] = ACTIONS(4898),
    [anon_sym_CARET] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_GT_GT_GT] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_BANG_EQ] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4898),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_switch] = ACTIONS(4898),
    [anon_sym_DOT_DOT] = ACTIONS(4898),
    [anon_sym_and] = ACTIONS(4898),
    [anon_sym_or] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_QMARK_QMARK] = ACTIONS(4898),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_ascending] = ACTIONS(4898),
    [anon_sym_descending] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [anon_sym_as] = ACTIONS(4900),
    [anon_sym_is] = ACTIONS(4898),
    [anon_sym_DASH_GT] = ACTIONS(4898),
    [anon_sym_with] = ACTIONS(4898),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3877] = {
    [sym_preproc_region] = STATE(3877),
    [sym_preproc_endregion] = STATE(3877),
    [sym_preproc_line] = STATE(3877),
    [sym_preproc_pragma] = STATE(3877),
    [sym_preproc_nullable] = STATE(3877),
    [sym_preproc_error] = STATE(3877),
    [sym_preproc_warning] = STATE(3877),
    [sym_preproc_define] = STATE(3877),
    [sym_preproc_undef] = STATE(3877),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_LPAREN] = ACTIONS(5199),
    [anon_sym_LT] = ACTIONS(5201),
    [anon_sym_GT] = ACTIONS(5201),
    [anon_sym_where] = ACTIONS(5199),
    [anon_sym_QMARK] = ACTIONS(5201),
    [anon_sym_BANG] = ACTIONS(5201),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_STAR] = ACTIONS(5199),
    [anon_sym_SLASH] = ACTIONS(5201),
    [anon_sym_PERCENT] = ACTIONS(5199),
    [anon_sym_CARET] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5201),
    [anon_sym_AMP] = ACTIONS(5201),
    [anon_sym_LT_LT] = ACTIONS(5199),
    [anon_sym_GT_GT] = ACTIONS(5201),
    [anon_sym_GT_GT_GT] = ACTIONS(5199),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5201),
    [anon_sym_switch] = ACTIONS(5199),
    [anon_sym_DOT_DOT] = ACTIONS(5199),
    [anon_sym_and] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5201),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_QMARK_QMARK] = ACTIONS(5199),
    [anon_sym_from] = ACTIONS(5199),
    [anon_sym_into] = ACTIONS(5199),
    [anon_sym_join] = ACTIONS(5199),
    [anon_sym_let] = ACTIONS(5199),
    [anon_sym_orderby] = ACTIONS(5199),
    [anon_sym_ascending] = ACTIONS(5199),
    [anon_sym_descending] = ACTIONS(5199),
    [anon_sym_group] = ACTIONS(5199),
    [anon_sym_select] = ACTIONS(5199),
    [anon_sym_as] = ACTIONS(5201),
    [anon_sym_is] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_with] = ACTIONS(5199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3878] = {
    [sym__name] = STATE(3482),
    [sym_alias_qualified_name] = STATE(3339),
    [sym__simple_name] = STATE(3339),
    [sym_qualified_name] = STATE(3339),
    [sym_generic_name] = STATE(3347),
    [sym_type] = STATE(3360),
    [sym_implicit_type] = STATE(3344),
    [sym_array_type] = STATE(3355),
    [sym__array_base_type] = STATE(7263),
    [sym_nullable_type] = STATE(3363),
    [sym_pointer_type] = STATE(3363),
    [sym__pointer_base_type] = STATE(7576),
    [sym_function_pointer_type] = STATE(3363),
    [sym_ref_type] = STATE(3344),
    [sym_scoped_type] = STATE(3344),
    [sym_tuple_type] = STATE(3366),
    [sym_identifier] = STATE(3194),
    [sym__reserved_identifier] = STATE(3192),
    [sym_preproc_region] = STATE(3878),
    [sym_preproc_endregion] = STATE(3878),
    [sym_preproc_line] = STATE(3878),
    [sym_preproc_pragma] = STATE(3878),
    [sym_preproc_nullable] = STATE(3878),
    [sym_preproc_error] = STATE(3878),
    [sym_preproc_warning] = STATE(3878),
    [sym_preproc_define] = STATE(3878),
    [sym_preproc_undef] = STATE(3878),
    [sym__identifier_token] = ACTIONS(3798),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_ref] = ACTIONS(4223),
    [anon_sym_delegate] = ACTIONS(5712),
    [anon_sym_file] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(6211),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_scoped] = ACTIONS(5792),
    [anon_sym_var] = ACTIONS(5716),
    [sym_predefined_type] = ACTIONS(5718),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3879] = {
    [sym_preproc_region] = STATE(3879),
    [sym_preproc_endregion] = STATE(3879),
    [sym_preproc_line] = STATE(3879),
    [sym_preproc_pragma] = STATE(3879),
    [sym_preproc_nullable] = STATE(3879),
    [sym_preproc_error] = STATE(3879),
    [sym_preproc_warning] = STATE(3879),
    [sym_preproc_define] = STATE(3879),
    [sym_preproc_undef] = STATE(3879),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_COMMA] = ACTIONS(5171),
    [anon_sym_LPAREN] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5173),
    [anon_sym_where] = ACTIONS(5171),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_BANG] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5173),
    [anon_sym_PERCENT] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5173),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5173),
    [anon_sym_GT_GT_GT] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5171),
    [anon_sym_BANG_EQ] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5171),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_DOT] = ACTIONS(5173),
    [anon_sym_switch] = ACTIONS(5171),
    [anon_sym_DOT_DOT] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_or] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5171),
    [anon_sym_PIPE_PIPE] = ACTIONS(5171),
    [anon_sym_QMARK_QMARK] = ACTIONS(5171),
    [anon_sym_from] = ACTIONS(5171),
    [anon_sym_into] = ACTIONS(5171),
    [anon_sym_join] = ACTIONS(5171),
    [anon_sym_let] = ACTIONS(5171),
    [anon_sym_orderby] = ACTIONS(5171),
    [anon_sym_ascending] = ACTIONS(5171),
    [anon_sym_descending] = ACTIONS(5171),
    [anon_sym_group] = ACTIONS(5171),
    [anon_sym_select] = ACTIONS(5171),
    [anon_sym_as] = ACTIONS(5173),
    [anon_sym_is] = ACTIONS(5171),
    [anon_sym_DASH_GT] = ACTIONS(5171),
    [anon_sym_with] = ACTIONS(5171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3880] = {
    [sym_preproc_region] = STATE(3880),
    [sym_preproc_endregion] = STATE(3880),
    [sym_preproc_line] = STATE(3880),
    [sym_preproc_pragma] = STATE(3880),
    [sym_preproc_nullable] = STATE(3880),
    [sym_preproc_error] = STATE(3880),
    [sym_preproc_warning] = STATE(3880),
    [sym_preproc_define] = STATE(3880),
    [sym_preproc_undef] = STATE(3880),
    [anon_sym_LBRACK] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_LPAREN] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5228),
    [anon_sym_where] = ACTIONS(5226),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_BANG] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5228),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PIPE] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5228),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5228),
    [anon_sym_GT_GT_GT] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5226),
    [anon_sym_BANG_EQ] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5226),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_DOT] = ACTIONS(5228),
    [anon_sym_switch] = ACTIONS(5226),
    [anon_sym_DOT_DOT] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_or] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5226),
    [anon_sym_QMARK_QMARK] = ACTIONS(5226),
    [anon_sym_from] = ACTIONS(5226),
    [anon_sym_into] = ACTIONS(5226),
    [anon_sym_join] = ACTIONS(5226),
    [anon_sym_let] = ACTIONS(5226),
    [anon_sym_orderby] = ACTIONS(5226),
    [anon_sym_ascending] = ACTIONS(5226),
    [anon_sym_descending] = ACTIONS(5226),
    [anon_sym_group] = ACTIONS(5226),
    [anon_sym_select] = ACTIONS(5226),
    [anon_sym_as] = ACTIONS(5228),
    [anon_sym_is] = ACTIONS(5226),
    [anon_sym_DASH_GT] = ACTIONS(5226),
    [anon_sym_with] = ACTIONS(5226),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3881] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3881),
    [sym_preproc_endregion] = STATE(3881),
    [sym_preproc_line] = STATE(3881),
    [sym_preproc_pragma] = STATE(3881),
    [sym_preproc_nullable] = STATE(3881),
    [sym_preproc_error] = STATE(3881),
    [sym_preproc_warning] = STATE(3881),
    [sym_preproc_define] = STATE(3881),
    [sym_preproc_undef] = STATE(3881),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5878),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5878),
    [anon_sym_into] = ACTIONS(5878),
    [anon_sym_join] = ACTIONS(5878),
    [anon_sym_let] = ACTIONS(5878),
    [anon_sym_orderby] = ACTIONS(5878),
    [anon_sym_ascending] = ACTIONS(5878),
    [anon_sym_descending] = ACTIONS(5878),
    [anon_sym_group] = ACTIONS(5878),
    [anon_sym_select] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3882] = {
    [sym_variable_declaration] = STATE(7538),
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(5773),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3882),
    [sym_preproc_endregion] = STATE(3882),
    [sym_preproc_line] = STATE(3882),
    [sym_preproc_pragma] = STATE(3882),
    [sym_preproc_nullable] = STATE(3882),
    [sym_preproc_error] = STATE(3882),
    [sym_preproc_warning] = STATE(3882),
    [sym_preproc_define] = STATE(3882),
    [sym_preproc_undef] = STATE(3882),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3883] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3883),
    [sym_preproc_endregion] = STATE(3883),
    [sym_preproc_line] = STATE(3883),
    [sym_preproc_pragma] = STATE(3883),
    [sym_preproc_nullable] = STATE(3883),
    [sym_preproc_error] = STATE(3883),
    [sym_preproc_warning] = STATE(3883),
    [sym_preproc_define] = STATE(3883),
    [sym_preproc_undef] = STATE(3883),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(6213),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6215),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(6217),
    [anon_sym_var] = ACTIONS(4767),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3884] = {
    [sym_preproc_region] = STATE(3884),
    [sym_preproc_endregion] = STATE(3884),
    [sym_preproc_line] = STATE(3884),
    [sym_preproc_pragma] = STATE(3884),
    [sym_preproc_nullable] = STATE(3884),
    [sym_preproc_error] = STATE(3884),
    [sym_preproc_warning] = STATE(3884),
    [sym_preproc_define] = STATE(3884),
    [sym_preproc_undef] = STATE(3884),
    [anon_sym_LBRACK] = ACTIONS(4979),
    [anon_sym_COMMA] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4979),
    [anon_sym_LT] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4981),
    [anon_sym_where] = ACTIONS(4979),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_BANG] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4979),
    [anon_sym_DASH_DASH] = ACTIONS(4979),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4981),
    [anon_sym_STAR] = ACTIONS(4979),
    [anon_sym_SLASH] = ACTIONS(4981),
    [anon_sym_PERCENT] = ACTIONS(4979),
    [anon_sym_CARET] = ACTIONS(4979),
    [anon_sym_PIPE] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4981),
    [anon_sym_LT_LT] = ACTIONS(4979),
    [anon_sym_GT_GT] = ACTIONS(4981),
    [anon_sym_GT_GT_GT] = ACTIONS(4979),
    [anon_sym_EQ_EQ] = ACTIONS(4979),
    [anon_sym_BANG_EQ] = ACTIONS(4979),
    [anon_sym_GT_EQ] = ACTIONS(4979),
    [anon_sym_LT_EQ] = ACTIONS(4979),
    [anon_sym_DOT] = ACTIONS(4981),
    [anon_sym_switch] = ACTIONS(4979),
    [anon_sym_DOT_DOT] = ACTIONS(4979),
    [anon_sym_and] = ACTIONS(4979),
    [anon_sym_or] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4979),
    [anon_sym_PIPE_PIPE] = ACTIONS(4979),
    [anon_sym_QMARK_QMARK] = ACTIONS(4979),
    [anon_sym_from] = ACTIONS(4979),
    [anon_sym_into] = ACTIONS(4979),
    [anon_sym_join] = ACTIONS(4979),
    [anon_sym_let] = ACTIONS(4979),
    [anon_sym_orderby] = ACTIONS(4979),
    [anon_sym_ascending] = ACTIONS(4979),
    [anon_sym_descending] = ACTIONS(4979),
    [anon_sym_group] = ACTIONS(4979),
    [anon_sym_select] = ACTIONS(4979),
    [anon_sym_as] = ACTIONS(4981),
    [anon_sym_is] = ACTIONS(4979),
    [anon_sym_DASH_GT] = ACTIONS(4979),
    [anon_sym_with] = ACTIONS(4979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3885] = {
    [sym_preproc_region] = STATE(3885),
    [sym_preproc_endregion] = STATE(3885),
    [sym_preproc_line] = STATE(3885),
    [sym_preproc_pragma] = STATE(3885),
    [sym_preproc_nullable] = STATE(3885),
    [sym_preproc_error] = STATE(3885),
    [sym_preproc_warning] = STATE(3885),
    [sym_preproc_define] = STATE(3885),
    [sym_preproc_undef] = STATE(3885),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_COMMA] = ACTIONS(5067),
    [anon_sym_LPAREN] = ACTIONS(5067),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_where] = ACTIONS(5067),
    [anon_sym_QMARK] = ACTIONS(5069),
    [anon_sym_BANG] = ACTIONS(5069),
    [anon_sym_PLUS_PLUS] = ACTIONS(5067),
    [anon_sym_DASH_DASH] = ACTIONS(5067),
    [anon_sym_PLUS] = ACTIONS(5069),
    [anon_sym_DASH] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5067),
    [anon_sym_SLASH] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5067),
    [anon_sym_CARET] = ACTIONS(5067),
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5067),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_GT_GT_GT] = ACTIONS(5067),
    [anon_sym_EQ_EQ] = ACTIONS(5067),
    [anon_sym_BANG_EQ] = ACTIONS(5067),
    [anon_sym_GT_EQ] = ACTIONS(5067),
    [anon_sym_LT_EQ] = ACTIONS(5067),
    [anon_sym_DOT] = ACTIONS(5069),
    [anon_sym_switch] = ACTIONS(5067),
    [anon_sym_DOT_DOT] = ACTIONS(5067),
    [anon_sym_and] = ACTIONS(5067),
    [anon_sym_or] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5067),
    [anon_sym_PIPE_PIPE] = ACTIONS(5067),
    [anon_sym_QMARK_QMARK] = ACTIONS(5067),
    [anon_sym_from] = ACTIONS(5067),
    [anon_sym_into] = ACTIONS(5067),
    [anon_sym_join] = ACTIONS(5067),
    [anon_sym_let] = ACTIONS(5067),
    [anon_sym_orderby] = ACTIONS(5067),
    [anon_sym_ascending] = ACTIONS(5067),
    [anon_sym_descending] = ACTIONS(5067),
    [anon_sym_group] = ACTIONS(5067),
    [anon_sym_select] = ACTIONS(5067),
    [anon_sym_as] = ACTIONS(5069),
    [anon_sym_is] = ACTIONS(5067),
    [anon_sym_DASH_GT] = ACTIONS(5067),
    [anon_sym_with] = ACTIONS(5067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3886] = {
    [sym_argument_list] = STATE(3800),
    [sym_bracketed_argument_list] = STATE(2934),
    [sym_preproc_region] = STATE(3886),
    [sym_preproc_endregion] = STATE(3886),
    [sym_preproc_line] = STATE(3886),
    [sym_preproc_pragma] = STATE(3886),
    [sym_preproc_nullable] = STATE(3886),
    [sym_preproc_error] = STATE(3886),
    [sym_preproc_warning] = STATE(3886),
    [sym_preproc_define] = STATE(3886),
    [sym_preproc_undef] = STATE(3886),
    [anon_sym_LBRACK] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(6099),
    [anon_sym_GT] = ACTIONS(6099),
    [anon_sym_where] = ACTIONS(5886),
    [anon_sym_QMARK] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_GT_GT_GT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT_EQ] = ACTIONS(6111),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_DOT] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(6079),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6115),
    [anon_sym_QMARK_QMARK] = ACTIONS(6117),
    [anon_sym_from] = ACTIONS(5886),
    [anon_sym_into] = ACTIONS(5886),
    [anon_sym_join] = ACTIONS(5886),
    [anon_sym_let] = ACTIONS(5886),
    [anon_sym_orderby] = ACTIONS(5886),
    [anon_sym_ascending] = ACTIONS(5886),
    [anon_sym_descending] = ACTIONS(5886),
    [anon_sym_group] = ACTIONS(5886),
    [anon_sym_select] = ACTIONS(5886),
    [anon_sym_as] = ACTIONS(5818),
    [anon_sym_is] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(5704),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3887] = {
    [sym_preproc_region] = STATE(3887),
    [sym_preproc_endregion] = STATE(3887),
    [sym_preproc_line] = STATE(3887),
    [sym_preproc_pragma] = STATE(3887),
    [sym_preproc_nullable] = STATE(3887),
    [sym_preproc_error] = STATE(3887),
    [sym_preproc_warning] = STATE(3887),
    [sym_preproc_define] = STATE(3887),
    [sym_preproc_undef] = STATE(3887),
    [anon_sym_LBRACK] = ACTIONS(5191),
    [anon_sym_COMMA] = ACTIONS(5191),
    [anon_sym_LPAREN] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(5193),
    [anon_sym_GT] = ACTIONS(5193),
    [anon_sym_where] = ACTIONS(5191),
    [anon_sym_QMARK] = ACTIONS(5193),
    [anon_sym_BANG] = ACTIONS(5193),
    [anon_sym_PLUS_PLUS] = ACTIONS(5191),
    [anon_sym_DASH_DASH] = ACTIONS(5191),
    [anon_sym_PLUS] = ACTIONS(5193),
    [anon_sym_DASH] = ACTIONS(5193),
    [anon_sym_STAR] = ACTIONS(5191),
    [anon_sym_SLASH] = ACTIONS(5193),
    [anon_sym_PERCENT] = ACTIONS(5191),
    [anon_sym_CARET] = ACTIONS(5191),
    [anon_sym_PIPE] = ACTIONS(5193),
    [anon_sym_AMP] = ACTIONS(5193),
    [anon_sym_LT_LT] = ACTIONS(5191),
    [anon_sym_GT_GT] = ACTIONS(5193),
    [anon_sym_GT_GT_GT] = ACTIONS(5191),
    [anon_sym_EQ_EQ] = ACTIONS(5191),
    [anon_sym_BANG_EQ] = ACTIONS(5191),
    [anon_sym_GT_EQ] = ACTIONS(5191),
    [anon_sym_LT_EQ] = ACTIONS(5191),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_switch] = ACTIONS(5191),
    [anon_sym_DOT_DOT] = ACTIONS(5191),
    [anon_sym_and] = ACTIONS(5191),
    [anon_sym_or] = ACTIONS(5193),
    [anon_sym_AMP_AMP] = ACTIONS(5191),
    [anon_sym_PIPE_PIPE] = ACTIONS(5191),
    [anon_sym_QMARK_QMARK] = ACTIONS(5191),
    [anon_sym_from] = ACTIONS(5191),
    [anon_sym_into] = ACTIONS(5191),
    [anon_sym_join] = ACTIONS(5191),
    [anon_sym_let] = ACTIONS(5191),
    [anon_sym_orderby] = ACTIONS(5191),
    [anon_sym_ascending] = ACTIONS(5191),
    [anon_sym_descending] = ACTIONS(5191),
    [anon_sym_group] = ACTIONS(5191),
    [anon_sym_select] = ACTIONS(5191),
    [anon_sym_as] = ACTIONS(5193),
    [anon_sym_is] = ACTIONS(5191),
    [anon_sym_DASH_GT] = ACTIONS(5191),
    [anon_sym_with] = ACTIONS(5191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3888] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(6184),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3888),
    [sym_preproc_endregion] = STATE(3888),
    [sym_preproc_line] = STATE(3888),
    [sym_preproc_pragma] = STATE(3888),
    [sym_preproc_nullable] = STATE(3888),
    [sym_preproc_error] = STATE(3888),
    [sym_preproc_warning] = STATE(3888),
    [sym_preproc_define] = STATE(3888),
    [sym_preproc_undef] = STATE(3888),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3889] = {
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3263),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3234),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3889),
    [sym_preproc_endregion] = STATE(3889),
    [sym_preproc_line] = STATE(3889),
    [sym_preproc_pragma] = STATE(3889),
    [sym_preproc_nullable] = STATE(3889),
    [sym_preproc_error] = STATE(3889),
    [sym_preproc_warning] = STATE(3889),
    [sym_preproc_define] = STATE(3889),
    [sym_preproc_undef] = STATE(3889),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(6163),
    [anon_sym_ref] = ACTIONS(4237),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(6219),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5828),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3890] = {
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3042),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(3088),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3890),
    [sym_preproc_endregion] = STATE(3890),
    [sym_preproc_line] = STATE(3890),
    [sym_preproc_pragma] = STATE(3890),
    [sym_preproc_nullable] = STATE(3890),
    [sym_preproc_error] = STATE(3890),
    [sym_preproc_warning] = STATE(3890),
    [sym_preproc_define] = STATE(3890),
    [sym_preproc_undef] = STATE(3890),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_ref] = ACTIONS(4208),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_readonly] = ACTIONS(6221),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5912),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3891] = {
    [sym_preproc_region] = STATE(3891),
    [sym_preproc_endregion] = STATE(3891),
    [sym_preproc_line] = STATE(3891),
    [sym_preproc_pragma] = STATE(3891),
    [sym_preproc_nullable] = STATE(3891),
    [sym_preproc_error] = STATE(3891),
    [sym_preproc_warning] = STATE(3891),
    [sym_preproc_define] = STATE(3891),
    [sym_preproc_undef] = STATE(3891),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5240),
    [anon_sym_where] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(5240),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5240),
    [anon_sym_GT_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_switch] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_QMARK_QMARK] = ACTIONS(5238),
    [anon_sym_from] = ACTIONS(5238),
    [anon_sym_into] = ACTIONS(5238),
    [anon_sym_join] = ACTIONS(5238),
    [anon_sym_let] = ACTIONS(5238),
    [anon_sym_orderby] = ACTIONS(5238),
    [anon_sym_ascending] = ACTIONS(5238),
    [anon_sym_descending] = ACTIONS(5238),
    [anon_sym_group] = ACTIONS(5238),
    [anon_sym_select] = ACTIONS(5238),
    [anon_sym_as] = ACTIONS(5240),
    [anon_sym_is] = ACTIONS(5238),
    [anon_sym_DASH_GT] = ACTIONS(5238),
    [anon_sym_with] = ACTIONS(5238),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3892] = {
    [sym_preproc_region] = STATE(3892),
    [sym_preproc_endregion] = STATE(3892),
    [sym_preproc_line] = STATE(3892),
    [sym_preproc_pragma] = STATE(3892),
    [sym_preproc_nullable] = STATE(3892),
    [sym_preproc_error] = STATE(3892),
    [sym_preproc_warning] = STATE(3892),
    [sym_preproc_define] = STATE(3892),
    [sym_preproc_undef] = STATE(3892),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(6223),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3893] = {
    [sym__name] = STATE(4951),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3042),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(3088),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(4435),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3893),
    [sym_preproc_endregion] = STATE(3893),
    [sym_preproc_line] = STATE(3893),
    [sym_preproc_pragma] = STATE(3893),
    [sym_preproc_nullable] = STATE(3893),
    [sym_preproc_error] = STATE(3893),
    [sym_preproc_warning] = STATE(3893),
    [sym_preproc_define] = STATE(3893),
    [sym_preproc_undef] = STATE(3893),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_ref] = ACTIONS(4060),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_readonly] = ACTIONS(6225),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(5890),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3894] = {
    [sym__name] = STATE(2635),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_type] = STATE(2399),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_identifier] = STATE(2576),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(3894),
    [sym_preproc_endregion] = STATE(3894),
    [sym_preproc_line] = STATE(3894),
    [sym_preproc_pragma] = STATE(3894),
    [sym_preproc_nullable] = STATE(3894),
    [sym_preproc_error] = STATE(3894),
    [sym_preproc_warning] = STATE(3894),
    [sym_preproc_define] = STATE(3894),
    [sym_preproc_undef] = STATE(3894),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(6187),
    [anon_sym_ref] = ACTIONS(3620),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_scoped] = ACTIONS(6227),
    [anon_sym_var] = ACTIONS(5900),
    [sym_predefined_type] = ACTIONS(5902),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3895] = {
    [sym__name] = STATE(2450),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_type] = STATE(2399),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(3895),
    [sym_preproc_endregion] = STATE(3895),
    [sym_preproc_line] = STATE(3895),
    [sym_preproc_pragma] = STATE(3895),
    [sym_preproc_nullable] = STATE(3895),
    [sym_preproc_error] = STATE(3895),
    [sym_preproc_warning] = STATE(3895),
    [sym_preproc_define] = STATE(3895),
    [sym_preproc_undef] = STATE(3895),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(6187),
    [anon_sym_ref] = ACTIONS(3599),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_readonly] = ACTIONS(2947),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_scoped] = ACTIONS(6229),
    [anon_sym_var] = ACTIONS(5900),
    [sym_predefined_type] = ACTIONS(5902),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3896] = {
    [sym__name] = STATE(3131),
    [sym_alias_qualified_name] = STATE(3072),
    [sym__simple_name] = STATE(3072),
    [sym_qualified_name] = STATE(3072),
    [sym_generic_name] = STATE(3102),
    [sym_type] = STATE(3042),
    [sym_implicit_type] = STATE(3082),
    [sym_array_type] = STATE(3088),
    [sym__array_base_type] = STATE(7190),
    [sym_nullable_type] = STATE(3090),
    [sym_pointer_type] = STATE(3090),
    [sym__pointer_base_type] = STATE(7463),
    [sym_function_pointer_type] = STATE(3090),
    [sym_ref_type] = STATE(3082),
    [sym_scoped_type] = STATE(3082),
    [sym_tuple_type] = STATE(3093),
    [sym_identifier] = STATE(2988),
    [sym__reserved_identifier] = STATE(2980),
    [sym_preproc_region] = STATE(3896),
    [sym_preproc_endregion] = STATE(3896),
    [sym_preproc_line] = STATE(3896),
    [sym_preproc_pragma] = STATE(3896),
    [sym_preproc_nullable] = STATE(3896),
    [sym_preproc_error] = STATE(3896),
    [sym_preproc_warning] = STATE(3896),
    [sym_preproc_define] = STATE(3896),
    [sym_preproc_undef] = STATE(3896),
    [sym__identifier_token] = ACTIONS(3891),
    [anon_sym_alias] = ACTIONS(3893),
    [anon_sym_global] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_ref] = ACTIONS(3895),
    [anon_sym_delegate] = ACTIONS(4070),
    [anon_sym_file] = ACTIONS(3893),
    [anon_sym_readonly] = ACTIONS(6231),
    [anon_sym_where] = ACTIONS(3893),
    [anon_sym_notnull] = ACTIONS(3893),
    [anon_sym_unmanaged] = ACTIONS(3893),
    [anon_sym_scoped] = ACTIONS(4072),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_when] = ACTIONS(3893),
    [anon_sym_from] = ACTIONS(3893),
    [anon_sym_into] = ACTIONS(3893),
    [anon_sym_join] = ACTIONS(3893),
    [anon_sym_on] = ACTIONS(3893),
    [anon_sym_equals] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_orderby] = ACTIONS(3893),
    [anon_sym_ascending] = ACTIONS(3893),
    [anon_sym_descending] = ACTIONS(3893),
    [anon_sym_group] = ACTIONS(3893),
    [anon_sym_by] = ACTIONS(3893),
    [anon_sym_select] = ACTIONS(3893),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3897] = {
    [sym_preproc_region] = STATE(3897),
    [sym_preproc_endregion] = STATE(3897),
    [sym_preproc_line] = STATE(3897),
    [sym_preproc_pragma] = STATE(3897),
    [sym_preproc_nullable] = STATE(3897),
    [sym_preproc_error] = STATE(3897),
    [sym_preproc_warning] = STATE(3897),
    [sym_preproc_define] = STATE(3897),
    [sym_preproc_undef] = STATE(3897),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_COMMA] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_LT] = ACTIONS(4989),
    [anon_sym_GT] = ACTIONS(4989),
    [anon_sym_where] = ACTIONS(4987),
    [anon_sym_QMARK] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_PLUS_PLUS] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4987),
    [anon_sym_PLUS] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4987),
    [anon_sym_SLASH] = ACTIONS(4989),
    [anon_sym_PERCENT] = ACTIONS(4987),
    [anon_sym_CARET] = ACTIONS(4987),
    [anon_sym_PIPE] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_LT_LT] = ACTIONS(4987),
    [anon_sym_GT_GT] = ACTIONS(4989),
    [anon_sym_GT_GT_GT] = ACTIONS(4987),
    [anon_sym_EQ_EQ] = ACTIONS(4987),
    [anon_sym_BANG_EQ] = ACTIONS(4987),
    [anon_sym_GT_EQ] = ACTIONS(4987),
    [anon_sym_LT_EQ] = ACTIONS(4987),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_switch] = ACTIONS(4987),
    [anon_sym_DOT_DOT] = ACTIONS(4987),
    [anon_sym_and] = ACTIONS(4987),
    [anon_sym_or] = ACTIONS(4989),
    [anon_sym_AMP_AMP] = ACTIONS(4987),
    [anon_sym_PIPE_PIPE] = ACTIONS(4987),
    [anon_sym_QMARK_QMARK] = ACTIONS(4987),
    [anon_sym_from] = ACTIONS(4987),
    [anon_sym_into] = ACTIONS(4987),
    [anon_sym_join] = ACTIONS(4987),
    [anon_sym_let] = ACTIONS(4987),
    [anon_sym_orderby] = ACTIONS(4987),
    [anon_sym_ascending] = ACTIONS(4987),
    [anon_sym_descending] = ACTIONS(4987),
    [anon_sym_group] = ACTIONS(4987),
    [anon_sym_select] = ACTIONS(4987),
    [anon_sym_as] = ACTIONS(4989),
    [anon_sym_is] = ACTIONS(4987),
    [anon_sym_DASH_GT] = ACTIONS(4987),
    [anon_sym_with] = ACTIONS(4987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3898] = {
    [sym_preproc_region] = STATE(3898),
    [sym_preproc_endregion] = STATE(3898),
    [sym_preproc_line] = STATE(3898),
    [sym_preproc_pragma] = STATE(3898),
    [sym_preproc_nullable] = STATE(3898),
    [sym_preproc_error] = STATE(3898),
    [sym_preproc_warning] = STATE(3898),
    [sym_preproc_define] = STATE(3898),
    [sym_preproc_undef] = STATE(3898),
    [anon_sym_LBRACK] = ACTIONS(4995),
    [anon_sym_COMMA] = ACTIONS(4995),
    [anon_sym_LPAREN] = ACTIONS(4995),
    [anon_sym_LT] = ACTIONS(4997),
    [anon_sym_GT] = ACTIONS(4997),
    [anon_sym_where] = ACTIONS(4995),
    [anon_sym_QMARK] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_PLUS_PLUS] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4995),
    [anon_sym_PLUS] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4995),
    [anon_sym_SLASH] = ACTIONS(4997),
    [anon_sym_PERCENT] = ACTIONS(4995),
    [anon_sym_CARET] = ACTIONS(4995),
    [anon_sym_PIPE] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_LT_LT] = ACTIONS(4995),
    [anon_sym_GT_GT] = ACTIONS(4997),
    [anon_sym_GT_GT_GT] = ACTIONS(4995),
    [anon_sym_EQ_EQ] = ACTIONS(4995),
    [anon_sym_BANG_EQ] = ACTIONS(4995),
    [anon_sym_GT_EQ] = ACTIONS(4995),
    [anon_sym_LT_EQ] = ACTIONS(4995),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_switch] = ACTIONS(4995),
    [anon_sym_DOT_DOT] = ACTIONS(4995),
    [anon_sym_and] = ACTIONS(4995),
    [anon_sym_or] = ACTIONS(4997),
    [anon_sym_AMP_AMP] = ACTIONS(4995),
    [anon_sym_PIPE_PIPE] = ACTIONS(4995),
    [anon_sym_QMARK_QMARK] = ACTIONS(4995),
    [anon_sym_from] = ACTIONS(4995),
    [anon_sym_into] = ACTIONS(4995),
    [anon_sym_join] = ACTIONS(4995),
    [anon_sym_let] = ACTIONS(4995),
    [anon_sym_orderby] = ACTIONS(4995),
    [anon_sym_ascending] = ACTIONS(4995),
    [anon_sym_descending] = ACTIONS(4995),
    [anon_sym_group] = ACTIONS(4995),
    [anon_sym_select] = ACTIONS(4995),
    [anon_sym_as] = ACTIONS(4997),
    [anon_sym_is] = ACTIONS(4995),
    [anon_sym_DASH_GT] = ACTIONS(4995),
    [anon_sym_with] = ACTIONS(4995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3899] = {
    [sym_preproc_region] = STATE(3899),
    [sym_preproc_endregion] = STATE(3899),
    [sym_preproc_line] = STATE(3899),
    [sym_preproc_pragma] = STATE(3899),
    [sym_preproc_nullable] = STATE(3899),
    [sym_preproc_error] = STATE(3899),
    [sym_preproc_warning] = STATE(3899),
    [sym_preproc_define] = STATE(3899),
    [sym_preproc_undef] = STATE(3899),
    [anon_sym_LBRACK] = ACTIONS(5011),
    [anon_sym_COMMA] = ACTIONS(5011),
    [anon_sym_LPAREN] = ACTIONS(5011),
    [anon_sym_LT] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5013),
    [anon_sym_where] = ACTIONS(5011),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_BANG] = ACTIONS(5013),
    [anon_sym_PLUS_PLUS] = ACTIONS(5011),
    [anon_sym_DASH_DASH] = ACTIONS(5011),
    [anon_sym_PLUS] = ACTIONS(5013),
    [anon_sym_DASH] = ACTIONS(5013),
    [anon_sym_STAR] = ACTIONS(5011),
    [anon_sym_SLASH] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5011),
    [anon_sym_CARET] = ACTIONS(5011),
    [anon_sym_PIPE] = ACTIONS(5013),
    [anon_sym_AMP] = ACTIONS(5013),
    [anon_sym_LT_LT] = ACTIONS(5011),
    [anon_sym_GT_GT] = ACTIONS(5013),
    [anon_sym_GT_GT_GT] = ACTIONS(5011),
    [anon_sym_EQ_EQ] = ACTIONS(5011),
    [anon_sym_BANG_EQ] = ACTIONS(5011),
    [anon_sym_GT_EQ] = ACTIONS(5011),
    [anon_sym_LT_EQ] = ACTIONS(5011),
    [anon_sym_DOT] = ACTIONS(5013),
    [anon_sym_switch] = ACTIONS(5011),
    [anon_sym_DOT_DOT] = ACTIONS(5011),
    [anon_sym_and] = ACTIONS(5011),
    [anon_sym_or] = ACTIONS(5013),
    [anon_sym_AMP_AMP] = ACTIONS(5011),
    [anon_sym_PIPE_PIPE] = ACTIONS(5011),
    [anon_sym_QMARK_QMARK] = ACTIONS(5011),
    [anon_sym_from] = ACTIONS(5011),
    [anon_sym_into] = ACTIONS(5011),
    [anon_sym_join] = ACTIONS(5011),
    [anon_sym_let] = ACTIONS(5011),
    [anon_sym_orderby] = ACTIONS(5011),
    [anon_sym_ascending] = ACTIONS(5011),
    [anon_sym_descending] = ACTIONS(5011),
    [anon_sym_group] = ACTIONS(5011),
    [anon_sym_select] = ACTIONS(5011),
    [anon_sym_as] = ACTIONS(5013),
    [anon_sym_is] = ACTIONS(5011),
    [anon_sym_DASH_GT] = ACTIONS(5011),
    [anon_sym_with] = ACTIONS(5011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3900] = {
    [sym_preproc_region] = STATE(3900),
    [sym_preproc_endregion] = STATE(3900),
    [sym_preproc_line] = STATE(3900),
    [sym_preproc_pragma] = STATE(3900),
    [sym_preproc_nullable] = STATE(3900),
    [sym_preproc_error] = STATE(3900),
    [sym_preproc_warning] = STATE(3900),
    [sym_preproc_define] = STATE(3900),
    [sym_preproc_undef] = STATE(3900),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_ascending] = ACTIONS(2979),
    [anon_sym_descending] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3901] = {
    [sym_preproc_region] = STATE(3901),
    [sym_preproc_endregion] = STATE(3901),
    [sym_preproc_line] = STATE(3901),
    [sym_preproc_pragma] = STATE(3901),
    [sym_preproc_nullable] = STATE(3901),
    [sym_preproc_error] = STATE(3901),
    [sym_preproc_warning] = STATE(3901),
    [sym_preproc_define] = STATE(3901),
    [sym_preproc_undef] = STATE(3901),
    [anon_sym_LBRACK] = ACTIONS(5015),
    [anon_sym_COMMA] = ACTIONS(5015),
    [anon_sym_LPAREN] = ACTIONS(5015),
    [anon_sym_LT] = ACTIONS(5017),
    [anon_sym_GT] = ACTIONS(5017),
    [anon_sym_where] = ACTIONS(5015),
    [anon_sym_QMARK] = ACTIONS(5017),
    [anon_sym_BANG] = ACTIONS(5017),
    [anon_sym_PLUS_PLUS] = ACTIONS(5015),
    [anon_sym_DASH_DASH] = ACTIONS(5015),
    [anon_sym_PLUS] = ACTIONS(5017),
    [anon_sym_DASH] = ACTIONS(5017),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_SLASH] = ACTIONS(5017),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_PIPE] = ACTIONS(5017),
    [anon_sym_AMP] = ACTIONS(5017),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_GT_GT] = ACTIONS(5017),
    [anon_sym_GT_GT_GT] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5015),
    [anon_sym_BANG_EQ] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5015),
    [anon_sym_LT_EQ] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5017),
    [anon_sym_switch] = ACTIONS(5015),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_and] = ACTIONS(5015),
    [anon_sym_or] = ACTIONS(5017),
    [anon_sym_AMP_AMP] = ACTIONS(5015),
    [anon_sym_PIPE_PIPE] = ACTIONS(5015),
    [anon_sym_QMARK_QMARK] = ACTIONS(5015),
    [anon_sym_from] = ACTIONS(5015),
    [anon_sym_into] = ACTIONS(5015),
    [anon_sym_join] = ACTIONS(5015),
    [anon_sym_let] = ACTIONS(5015),
    [anon_sym_orderby] = ACTIONS(5015),
    [anon_sym_ascending] = ACTIONS(5015),
    [anon_sym_descending] = ACTIONS(5015),
    [anon_sym_group] = ACTIONS(5015),
    [anon_sym_select] = ACTIONS(5015),
    [anon_sym_as] = ACTIONS(5017),
    [anon_sym_is] = ACTIONS(5015),
    [anon_sym_DASH_GT] = ACTIONS(5015),
    [anon_sym_with] = ACTIONS(5015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3902] = {
    [sym_preproc_region] = STATE(3902),
    [sym_preproc_endregion] = STATE(3902),
    [sym_preproc_line] = STATE(3902),
    [sym_preproc_pragma] = STATE(3902),
    [sym_preproc_nullable] = STATE(3902),
    [sym_preproc_error] = STATE(3902),
    [sym_preproc_warning] = STATE(3902),
    [sym_preproc_define] = STATE(3902),
    [sym_preproc_undef] = STATE(3902),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3903] = {
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3263),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3234),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3903),
    [sym_preproc_endregion] = STATE(3903),
    [sym_preproc_line] = STATE(3903),
    [sym_preproc_pragma] = STATE(3903),
    [sym_preproc_nullable] = STATE(3903),
    [sym_preproc_error] = STATE(3903),
    [sym_preproc_warning] = STATE(3903),
    [sym_preproc_define] = STATE(3903),
    [sym_preproc_undef] = STATE(3903),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(6163),
    [anon_sym_ref] = ACTIONS(4229),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(6233),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5830),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3904] = {
    [sym__name] = STATE(2450),
    [sym_alias_qualified_name] = STATE(2428),
    [sym__simple_name] = STATE(2428),
    [sym_qualified_name] = STATE(2428),
    [sym_generic_name] = STATE(2418),
    [sym_type] = STATE(2399),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(2398),
    [sym__array_base_type] = STATE(7243),
    [sym_nullable_type] = STATE(2411),
    [sym_pointer_type] = STATE(2411),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(2411),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(2413),
    [sym_identifier] = STATE(2382),
    [sym__reserved_identifier] = STATE(2374),
    [sym_preproc_region] = STATE(3904),
    [sym_preproc_endregion] = STATE(3904),
    [sym_preproc_line] = STATE(3904),
    [sym_preproc_pragma] = STATE(3904),
    [sym_preproc_nullable] = STATE(3904),
    [sym_preproc_error] = STATE(3904),
    [sym_preproc_warning] = STATE(3904),
    [sym_preproc_define] = STATE(3904),
    [sym_preproc_undef] = STATE(3904),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(6187),
    [anon_sym_ref] = ACTIONS(4140),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(4098),
    [anon_sym_readonly] = ACTIONS(6235),
    [anon_sym_where] = ACTIONS(4098),
    [anon_sym_notnull] = ACTIONS(4098),
    [anon_sym_unmanaged] = ACTIONS(4098),
    [anon_sym_scoped] = ACTIONS(5898),
    [anon_sym_var] = ACTIONS(5900),
    [sym_predefined_type] = ACTIONS(5902),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_when] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_into] = ACTIONS(4098),
    [anon_sym_join] = ACTIONS(4098),
    [anon_sym_on] = ACTIONS(4098),
    [anon_sym_equals] = ACTIONS(4098),
    [anon_sym_let] = ACTIONS(4098),
    [anon_sym_orderby] = ACTIONS(4098),
    [anon_sym_ascending] = ACTIONS(4098),
    [anon_sym_descending] = ACTIONS(4098),
    [anon_sym_group] = ACTIONS(4098),
    [anon_sym_by] = ACTIONS(4098),
    [anon_sym_select] = ACTIONS(4098),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3905] = {
    [sym__name] = STATE(5169),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(2187),
    [sym_ref_type] = STATE(2340),
    [sym__scoped_base_type] = STATE(2342),
    [sym_identifier] = STATE(4540),
    [sym__reserved_identifier] = STATE(2182),
    [sym_preproc_region] = STATE(3905),
    [sym_preproc_endregion] = STATE(3905),
    [sym_preproc_line] = STATE(3905),
    [sym_preproc_pragma] = STATE(3905),
    [sym_preproc_nullable] = STATE(3905),
    [sym_preproc_error] = STATE(3905),
    [sym_preproc_warning] = STATE(3905),
    [sym_preproc_define] = STATE(3905),
    [sym_preproc_undef] = STATE(3905),
    [sym__identifier_token] = ACTIONS(3612),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_QMARK] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_operator] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3459),
    [anon_sym_this] = ACTIONS(3461),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_EQ_GT] = ACTIONS(3459),
    [anon_sym_COLON_COLON] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_when] = ACTIONS(3615),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3906] = {
    [sym_preproc_region] = STATE(3906),
    [sym_preproc_endregion] = STATE(3906),
    [sym_preproc_line] = STATE(3906),
    [sym_preproc_pragma] = STATE(3906),
    [sym_preproc_nullable] = STATE(3906),
    [sym_preproc_error] = STATE(3906),
    [sym_preproc_warning] = STATE(3906),
    [sym_preproc_define] = STATE(3906),
    [sym_preproc_undef] = STATE(3906),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_COMMA] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_LT] = ACTIONS(5155),
    [anon_sym_GT] = ACTIONS(5155),
    [anon_sym_where] = ACTIONS(5153),
    [anon_sym_QMARK] = ACTIONS(5155),
    [anon_sym_BANG] = ACTIONS(5155),
    [anon_sym_PLUS_PLUS] = ACTIONS(5153),
    [anon_sym_DASH_DASH] = ACTIONS(5153),
    [anon_sym_PLUS] = ACTIONS(5155),
    [anon_sym_DASH] = ACTIONS(5155),
    [anon_sym_STAR] = ACTIONS(5153),
    [anon_sym_SLASH] = ACTIONS(5155),
    [anon_sym_PERCENT] = ACTIONS(5153),
    [anon_sym_CARET] = ACTIONS(5153),
    [anon_sym_PIPE] = ACTIONS(5155),
    [anon_sym_AMP] = ACTIONS(5155),
    [anon_sym_LT_LT] = ACTIONS(5153),
    [anon_sym_GT_GT] = ACTIONS(5155),
    [anon_sym_GT_GT_GT] = ACTIONS(5153),
    [anon_sym_EQ_EQ] = ACTIONS(5153),
    [anon_sym_BANG_EQ] = ACTIONS(5153),
    [anon_sym_GT_EQ] = ACTIONS(5153),
    [anon_sym_LT_EQ] = ACTIONS(5153),
    [anon_sym_DOT] = ACTIONS(5155),
    [anon_sym_switch] = ACTIONS(5153),
    [anon_sym_DOT_DOT] = ACTIONS(5153),
    [anon_sym_and] = ACTIONS(5153),
    [anon_sym_or] = ACTIONS(5155),
    [anon_sym_AMP_AMP] = ACTIONS(5153),
    [anon_sym_PIPE_PIPE] = ACTIONS(5153),
    [anon_sym_QMARK_QMARK] = ACTIONS(5153),
    [anon_sym_from] = ACTIONS(5153),
    [anon_sym_into] = ACTIONS(5153),
    [anon_sym_join] = ACTIONS(5153),
    [anon_sym_let] = ACTIONS(5153),
    [anon_sym_orderby] = ACTIONS(5153),
    [anon_sym_ascending] = ACTIONS(5153),
    [anon_sym_descending] = ACTIONS(5153),
    [anon_sym_group] = ACTIONS(5153),
    [anon_sym_select] = ACTIONS(5153),
    [anon_sym_as] = ACTIONS(5155),
    [anon_sym_is] = ACTIONS(5153),
    [anon_sym_DASH_GT] = ACTIONS(5153),
    [anon_sym_with] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3907] = {
    [sym_preproc_region] = STATE(3907),
    [sym_preproc_endregion] = STATE(3907),
    [sym_preproc_line] = STATE(3907),
    [sym_preproc_pragma] = STATE(3907),
    [sym_preproc_nullable] = STATE(3907),
    [sym_preproc_error] = STATE(3907),
    [sym_preproc_warning] = STATE(3907),
    [sym_preproc_define] = STATE(3907),
    [sym_preproc_undef] = STATE(3907),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_LPAREN] = ACTIONS(5187),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_GT] = ACTIONS(5189),
    [anon_sym_where] = ACTIONS(5187),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_BANG] = ACTIONS(5189),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(5189),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5189),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5189),
    [anon_sym_AMP] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5187),
    [anon_sym_GT_GT] = ACTIONS(5189),
    [anon_sym_GT_GT_GT] = ACTIONS(5187),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT_EQ] = ACTIONS(5187),
    [anon_sym_LT_EQ] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5189),
    [anon_sym_switch] = ACTIONS(5187),
    [anon_sym_DOT_DOT] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5189),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_QMARK_QMARK] = ACTIONS(5187),
    [anon_sym_from] = ACTIONS(5187),
    [anon_sym_into] = ACTIONS(5187),
    [anon_sym_join] = ACTIONS(5187),
    [anon_sym_let] = ACTIONS(5187),
    [anon_sym_orderby] = ACTIONS(5187),
    [anon_sym_ascending] = ACTIONS(5187),
    [anon_sym_descending] = ACTIONS(5187),
    [anon_sym_group] = ACTIONS(5187),
    [anon_sym_select] = ACTIONS(5187),
    [anon_sym_as] = ACTIONS(5189),
    [anon_sym_is] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [anon_sym_with] = ACTIONS(5187),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3908] = {
    [sym_preproc_region] = STATE(3908),
    [sym_preproc_endregion] = STATE(3908),
    [sym_preproc_line] = STATE(3908),
    [sym_preproc_pragma] = STATE(3908),
    [sym_preproc_nullable] = STATE(3908),
    [sym_preproc_error] = STATE(3908),
    [sym_preproc_warning] = STATE(3908),
    [sym_preproc_define] = STATE(3908),
    [sym_preproc_undef] = STATE(3908),
    [anon_sym_LBRACK] = ACTIONS(5203),
    [anon_sym_COMMA] = ACTIONS(5203),
    [anon_sym_LPAREN] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5205),
    [anon_sym_where] = ACTIONS(5203),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_BANG] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5203),
    [anon_sym_DASH_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5205),
    [anon_sym_STAR] = ACTIONS(5203),
    [anon_sym_SLASH] = ACTIONS(5205),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5203),
    [anon_sym_PIPE] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5205),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5205),
    [anon_sym_GT_GT_GT] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5203),
    [anon_sym_BANG_EQ] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5203),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_DOT] = ACTIONS(5205),
    [anon_sym_switch] = ACTIONS(5203),
    [anon_sym_DOT_DOT] = ACTIONS(5203),
    [anon_sym_and] = ACTIONS(5203),
    [anon_sym_or] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5203),
    [anon_sym_PIPE_PIPE] = ACTIONS(5203),
    [anon_sym_QMARK_QMARK] = ACTIONS(5203),
    [anon_sym_from] = ACTIONS(5203),
    [anon_sym_into] = ACTIONS(5203),
    [anon_sym_join] = ACTIONS(5203),
    [anon_sym_let] = ACTIONS(5203),
    [anon_sym_orderby] = ACTIONS(5203),
    [anon_sym_ascending] = ACTIONS(5203),
    [anon_sym_descending] = ACTIONS(5203),
    [anon_sym_group] = ACTIONS(5203),
    [anon_sym_select] = ACTIONS(5203),
    [anon_sym_as] = ACTIONS(5205),
    [anon_sym_is] = ACTIONS(5203),
    [anon_sym_DASH_GT] = ACTIONS(5203),
    [anon_sym_with] = ACTIONS(5203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3909] = {
    [sym_preproc_region] = STATE(3909),
    [sym_preproc_endregion] = STATE(3909),
    [sym_preproc_line] = STATE(3909),
    [sym_preproc_pragma] = STATE(3909),
    [sym_preproc_nullable] = STATE(3909),
    [sym_preproc_error] = STATE(3909),
    [sym_preproc_warning] = STATE(3909),
    [sym_preproc_define] = STATE(3909),
    [sym_preproc_undef] = STATE(3909),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_COMMA] = ACTIONS(5051),
    [anon_sym_LPAREN] = ACTIONS(5051),
    [anon_sym_LT] = ACTIONS(5053),
    [anon_sym_GT] = ACTIONS(5053),
    [anon_sym_where] = ACTIONS(5051),
    [anon_sym_QMARK] = ACTIONS(5053),
    [anon_sym_BANG] = ACTIONS(5053),
    [anon_sym_PLUS_PLUS] = ACTIONS(5051),
    [anon_sym_DASH_DASH] = ACTIONS(5051),
    [anon_sym_PLUS] = ACTIONS(5053),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5051),
    [anon_sym_SLASH] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5051),
    [anon_sym_CARET] = ACTIONS(5051),
    [anon_sym_PIPE] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5053),
    [anon_sym_LT_LT] = ACTIONS(5051),
    [anon_sym_GT_GT] = ACTIONS(5053),
    [anon_sym_GT_GT_GT] = ACTIONS(5051),
    [anon_sym_EQ_EQ] = ACTIONS(5051),
    [anon_sym_BANG_EQ] = ACTIONS(5051),
    [anon_sym_GT_EQ] = ACTIONS(5051),
    [anon_sym_LT_EQ] = ACTIONS(5051),
    [anon_sym_DOT] = ACTIONS(5053),
    [anon_sym_switch] = ACTIONS(5051),
    [anon_sym_DOT_DOT] = ACTIONS(5051),
    [anon_sym_and] = ACTIONS(5051),
    [anon_sym_or] = ACTIONS(5053),
    [anon_sym_AMP_AMP] = ACTIONS(5051),
    [anon_sym_PIPE_PIPE] = ACTIONS(5051),
    [anon_sym_QMARK_QMARK] = ACTIONS(5051),
    [anon_sym_from] = ACTIONS(5051),
    [anon_sym_into] = ACTIONS(5051),
    [anon_sym_join] = ACTIONS(5051),
    [anon_sym_let] = ACTIONS(5051),
    [anon_sym_orderby] = ACTIONS(5051),
    [anon_sym_ascending] = ACTIONS(5051),
    [anon_sym_descending] = ACTIONS(5051),
    [anon_sym_group] = ACTIONS(5051),
    [anon_sym_select] = ACTIONS(5051),
    [anon_sym_as] = ACTIONS(5053),
    [anon_sym_is] = ACTIONS(5051),
    [anon_sym_DASH_GT] = ACTIONS(5051),
    [anon_sym_with] = ACTIONS(5051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3910] = {
    [sym__name] = STATE(2719),
    [sym_alias_qualified_name] = STATE(2714),
    [sym__simple_name] = STATE(2714),
    [sym_qualified_name] = STATE(2714),
    [sym_generic_name] = STATE(2809),
    [sym_type] = STATE(2871),
    [sym_implicit_type] = STATE(2848),
    [sym_array_type] = STATE(2715),
    [sym__array_base_type] = STATE(7195),
    [sym_nullable_type] = STATE(2716),
    [sym_pointer_type] = STATE(2716),
    [sym__pointer_base_type] = STATE(7404),
    [sym_function_pointer_type] = STATE(2716),
    [sym_ref_type] = STATE(2848),
    [sym_scoped_type] = STATE(2848),
    [sym_tuple_type] = STATE(2717),
    [sym_identifier] = STATE(2602),
    [sym__reserved_identifier] = STATE(2652),
    [sym_preproc_region] = STATE(3910),
    [sym_preproc_endregion] = STATE(3910),
    [sym_preproc_line] = STATE(3910),
    [sym_preproc_pragma] = STATE(3910),
    [sym_preproc_nullable] = STATE(3910),
    [sym_preproc_error] = STATE(3910),
    [sym_preproc_warning] = STATE(3910),
    [sym_preproc_define] = STATE(3910),
    [sym_preproc_undef] = STATE(3910),
    [sym__identifier_token] = ACTIONS(6237),
    [anon_sym_alias] = ACTIONS(6239),
    [anon_sym_global] = ACTIONS(6239),
    [anon_sym_LPAREN] = ACTIONS(6241),
    [anon_sym_ref] = ACTIONS(3650),
    [anon_sym_delegate] = ACTIONS(6243),
    [anon_sym_file] = ACTIONS(6239),
    [anon_sym_readonly] = ACTIONS(2907),
    [anon_sym_where] = ACTIONS(6239),
    [anon_sym_notnull] = ACTIONS(6239),
    [anon_sym_unmanaged] = ACTIONS(6239),
    [anon_sym_scoped] = ACTIONS(6245),
    [anon_sym_var] = ACTIONS(6247),
    [sym_predefined_type] = ACTIONS(6249),
    [anon_sym_yield] = ACTIONS(6239),
    [anon_sym_when] = ACTIONS(6239),
    [anon_sym_from] = ACTIONS(6239),
    [anon_sym_into] = ACTIONS(6239),
    [anon_sym_join] = ACTIONS(6239),
    [anon_sym_on] = ACTIONS(6239),
    [anon_sym_equals] = ACTIONS(6239),
    [anon_sym_let] = ACTIONS(6239),
    [anon_sym_orderby] = ACTIONS(6239),
    [anon_sym_ascending] = ACTIONS(6239),
    [anon_sym_descending] = ACTIONS(6239),
    [anon_sym_group] = ACTIONS(6239),
    [anon_sym_by] = ACTIONS(6239),
    [anon_sym_select] = ACTIONS(6239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3911] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3911),
    [sym_preproc_endregion] = STATE(3911),
    [sym_preproc_line] = STATE(3911),
    [sym_preproc_pragma] = STATE(3911),
    [sym_preproc_nullable] = STATE(3911),
    [sym_preproc_error] = STATE(3911),
    [sym_preproc_warning] = STATE(3911),
    [sym_preproc_define] = STATE(3911),
    [sym_preproc_undef] = STATE(3911),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(6251),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6253),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(6255),
    [anon_sym_var] = ACTIONS(6091),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3912] = {
    [sym_preproc_region] = STATE(3912),
    [sym_preproc_endregion] = STATE(3912),
    [sym_preproc_line] = STATE(3912),
    [sym_preproc_pragma] = STATE(3912),
    [sym_preproc_nullable] = STATE(3912),
    [sym_preproc_error] = STATE(3912),
    [sym_preproc_warning] = STATE(3912),
    [sym_preproc_define] = STATE(3912),
    [sym_preproc_undef] = STATE(3912),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_COMMA] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(5065),
    [anon_sym_GT] = ACTIONS(5065),
    [anon_sym_where] = ACTIONS(5063),
    [anon_sym_QMARK] = ACTIONS(5065),
    [anon_sym_BANG] = ACTIONS(5065),
    [anon_sym_PLUS_PLUS] = ACTIONS(5063),
    [anon_sym_DASH_DASH] = ACTIONS(5063),
    [anon_sym_PLUS] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5063),
    [anon_sym_SLASH] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_CARET] = ACTIONS(5063),
    [anon_sym_PIPE] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5065),
    [anon_sym_LT_LT] = ACTIONS(5063),
    [anon_sym_GT_GT] = ACTIONS(5065),
    [anon_sym_GT_GT_GT] = ACTIONS(5063),
    [anon_sym_EQ_EQ] = ACTIONS(5063),
    [anon_sym_BANG_EQ] = ACTIONS(5063),
    [anon_sym_GT_EQ] = ACTIONS(5063),
    [anon_sym_LT_EQ] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [anon_sym_switch] = ACTIONS(5063),
    [anon_sym_DOT_DOT] = ACTIONS(5063),
    [anon_sym_and] = ACTIONS(5063),
    [anon_sym_or] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5063),
    [anon_sym_PIPE_PIPE] = ACTIONS(5063),
    [anon_sym_QMARK_QMARK] = ACTIONS(5063),
    [anon_sym_from] = ACTIONS(5063),
    [anon_sym_into] = ACTIONS(5063),
    [anon_sym_join] = ACTIONS(5063),
    [anon_sym_let] = ACTIONS(5063),
    [anon_sym_orderby] = ACTIONS(5063),
    [anon_sym_ascending] = ACTIONS(5063),
    [anon_sym_descending] = ACTIONS(5063),
    [anon_sym_group] = ACTIONS(5063),
    [anon_sym_select] = ACTIONS(5063),
    [anon_sym_as] = ACTIONS(5065),
    [anon_sym_is] = ACTIONS(5063),
    [anon_sym_DASH_GT] = ACTIONS(5063),
    [anon_sym_with] = ACTIONS(5063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3913] = {
    [sym_preproc_region] = STATE(3913),
    [sym_preproc_endregion] = STATE(3913),
    [sym_preproc_line] = STATE(3913),
    [sym_preproc_pragma] = STATE(3913),
    [sym_preproc_nullable] = STATE(3913),
    [sym_preproc_error] = STATE(3913),
    [sym_preproc_warning] = STATE(3913),
    [sym_preproc_define] = STATE(3913),
    [sym_preproc_undef] = STATE(3913),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5039),
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(5041),
    [anon_sym_where] = ACTIONS(5039),
    [anon_sym_QMARK] = ACTIONS(5041),
    [anon_sym_BANG] = ACTIONS(5041),
    [anon_sym_PLUS_PLUS] = ACTIONS(5039),
    [anon_sym_DASH_DASH] = ACTIONS(5039),
    [anon_sym_PLUS] = ACTIONS(5041),
    [anon_sym_DASH] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5039),
    [anon_sym_SLASH] = ACTIONS(5041),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_CARET] = ACTIONS(5039),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5041),
    [anon_sym_LT_LT] = ACTIONS(5039),
    [anon_sym_GT_GT] = ACTIONS(5041),
    [anon_sym_GT_GT_GT] = ACTIONS(5039),
    [anon_sym_EQ_EQ] = ACTIONS(5039),
    [anon_sym_BANG_EQ] = ACTIONS(5039),
    [anon_sym_GT_EQ] = ACTIONS(5039),
    [anon_sym_LT_EQ] = ACTIONS(5039),
    [anon_sym_DOT] = ACTIONS(5041),
    [anon_sym_switch] = ACTIONS(5039),
    [anon_sym_DOT_DOT] = ACTIONS(5039),
    [anon_sym_and] = ACTIONS(5039),
    [anon_sym_or] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5039),
    [anon_sym_PIPE_PIPE] = ACTIONS(5039),
    [anon_sym_QMARK_QMARK] = ACTIONS(5039),
    [anon_sym_from] = ACTIONS(5039),
    [anon_sym_into] = ACTIONS(5039),
    [anon_sym_join] = ACTIONS(5039),
    [anon_sym_let] = ACTIONS(5039),
    [anon_sym_orderby] = ACTIONS(5039),
    [anon_sym_ascending] = ACTIONS(5039),
    [anon_sym_descending] = ACTIONS(5039),
    [anon_sym_group] = ACTIONS(5039),
    [anon_sym_select] = ACTIONS(5039),
    [anon_sym_as] = ACTIONS(5041),
    [anon_sym_is] = ACTIONS(5039),
    [anon_sym_DASH_GT] = ACTIONS(5039),
    [anon_sym_with] = ACTIONS(5039),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3914] = {
    [sym__name] = STATE(4414),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(4144),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3914),
    [sym_preproc_endregion] = STATE(3914),
    [sym_preproc_line] = STATE(3914),
    [sym_preproc_pragma] = STATE(3914),
    [sym_preproc_nullable] = STATE(3914),
    [sym_preproc_error] = STATE(3914),
    [sym_preproc_warning] = STATE(3914),
    [sym_preproc_define] = STATE(3914),
    [sym_preproc_undef] = STATE(3914),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(3466),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3023),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3915] = {
    [sym_preproc_region] = STATE(3915),
    [sym_preproc_endregion] = STATE(3915),
    [sym_preproc_line] = STATE(3915),
    [sym_preproc_pragma] = STATE(3915),
    [sym_preproc_nullable] = STATE(3915),
    [sym_preproc_error] = STATE(3915),
    [sym_preproc_warning] = STATE(3915),
    [sym_preproc_define] = STATE(3915),
    [sym_preproc_undef] = STATE(3915),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_COMMA] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_where] = ACTIONS(5093),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_BANG] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5095),
    [anon_sym_PERCENT] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5093),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5093),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_GT_GT_GT] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5093),
    [anon_sym_BANG_EQ] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5093),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_DOT] = ACTIONS(5095),
    [anon_sym_switch] = ACTIONS(5093),
    [anon_sym_DOT_DOT] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_or] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_PIPE_PIPE] = ACTIONS(5093),
    [anon_sym_QMARK_QMARK] = ACTIONS(5093),
    [anon_sym_from] = ACTIONS(5093),
    [anon_sym_into] = ACTIONS(5093),
    [anon_sym_join] = ACTIONS(5093),
    [anon_sym_let] = ACTIONS(5093),
    [anon_sym_orderby] = ACTIONS(5093),
    [anon_sym_ascending] = ACTIONS(5093),
    [anon_sym_descending] = ACTIONS(5093),
    [anon_sym_group] = ACTIONS(5093),
    [anon_sym_select] = ACTIONS(5093),
    [anon_sym_as] = ACTIONS(5095),
    [anon_sym_is] = ACTIONS(5093),
    [anon_sym_DASH_GT] = ACTIONS(5093),
    [anon_sym_with] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3916] = {
    [sym_preproc_region] = STATE(3916),
    [sym_preproc_endregion] = STATE(3916),
    [sym_preproc_line] = STATE(3916),
    [sym_preproc_pragma] = STATE(3916),
    [sym_preproc_nullable] = STATE(3916),
    [sym_preproc_error] = STATE(3916),
    [sym_preproc_warning] = STATE(3916),
    [sym_preproc_define] = STATE(3916),
    [sym_preproc_undef] = STATE(3916),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_COMMA] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5107),
    [anon_sym_where] = ACTIONS(5105),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_BANG] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5107),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_PIPE] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_GT_GT_GT] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5105),
    [anon_sym_BANG_EQ] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5105),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_DOT] = ACTIONS(5107),
    [anon_sym_switch] = ACTIONS(5105),
    [anon_sym_DOT_DOT] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_or] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5105),
    [anon_sym_QMARK_QMARK] = ACTIONS(5105),
    [anon_sym_from] = ACTIONS(5105),
    [anon_sym_into] = ACTIONS(5105),
    [anon_sym_join] = ACTIONS(5105),
    [anon_sym_let] = ACTIONS(5105),
    [anon_sym_orderby] = ACTIONS(5105),
    [anon_sym_ascending] = ACTIONS(5105),
    [anon_sym_descending] = ACTIONS(5105),
    [anon_sym_group] = ACTIONS(5105),
    [anon_sym_select] = ACTIONS(5105),
    [anon_sym_as] = ACTIONS(5107),
    [anon_sym_is] = ACTIONS(5105),
    [anon_sym_DASH_GT] = ACTIONS(5105),
    [anon_sym_with] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3917] = {
    [sym_preproc_region] = STATE(3917),
    [sym_preproc_endregion] = STATE(3917),
    [sym_preproc_line] = STATE(3917),
    [sym_preproc_pragma] = STATE(3917),
    [sym_preproc_nullable] = STATE(3917),
    [sym_preproc_error] = STATE(3917),
    [sym_preproc_warning] = STATE(3917),
    [sym_preproc_define] = STATE(3917),
    [sym_preproc_undef] = STATE(3917),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_COMMA] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5127),
    [anon_sym_where] = ACTIONS(5125),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_BANG] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5127),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_PIPE] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_GT_GT_GT] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5125),
    [anon_sym_BANG_EQ] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5125),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5127),
    [anon_sym_switch] = ACTIONS(5125),
    [anon_sym_DOT_DOT] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_or] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_QMARK_QMARK] = ACTIONS(5125),
    [anon_sym_from] = ACTIONS(5125),
    [anon_sym_into] = ACTIONS(5125),
    [anon_sym_join] = ACTIONS(5125),
    [anon_sym_let] = ACTIONS(5125),
    [anon_sym_orderby] = ACTIONS(5125),
    [anon_sym_ascending] = ACTIONS(5125),
    [anon_sym_descending] = ACTIONS(5125),
    [anon_sym_group] = ACTIONS(5125),
    [anon_sym_select] = ACTIONS(5125),
    [anon_sym_as] = ACTIONS(5127),
    [anon_sym_is] = ACTIONS(5125),
    [anon_sym_DASH_GT] = ACTIONS(5125),
    [anon_sym_with] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3918] = {
    [sym_preproc_region] = STATE(3918),
    [sym_preproc_endregion] = STATE(3918),
    [sym_preproc_line] = STATE(3918),
    [sym_preproc_pragma] = STATE(3918),
    [sym_preproc_nullable] = STATE(3918),
    [sym_preproc_error] = STATE(3918),
    [sym_preproc_warning] = STATE(3918),
    [sym_preproc_define] = STATE(3918),
    [sym_preproc_undef] = STATE(3918),
    [anon_sym_LBRACK] = ACTIONS(5207),
    [anon_sym_COMMA] = ACTIONS(5207),
    [anon_sym_LPAREN] = ACTIONS(5207),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_GT] = ACTIONS(5209),
    [anon_sym_where] = ACTIONS(5207),
    [anon_sym_QMARK] = ACTIONS(5209),
    [anon_sym_BANG] = ACTIONS(5209),
    [anon_sym_PLUS_PLUS] = ACTIONS(5207),
    [anon_sym_DASH_DASH] = ACTIONS(5207),
    [anon_sym_PLUS] = ACTIONS(5209),
    [anon_sym_DASH] = ACTIONS(5209),
    [anon_sym_STAR] = ACTIONS(5207),
    [anon_sym_SLASH] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5207),
    [anon_sym_CARET] = ACTIONS(5207),
    [anon_sym_PIPE] = ACTIONS(5209),
    [anon_sym_AMP] = ACTIONS(5209),
    [anon_sym_LT_LT] = ACTIONS(5207),
    [anon_sym_GT_GT] = ACTIONS(5209),
    [anon_sym_GT_GT_GT] = ACTIONS(5207),
    [anon_sym_EQ_EQ] = ACTIONS(5207),
    [anon_sym_BANG_EQ] = ACTIONS(5207),
    [anon_sym_GT_EQ] = ACTIONS(5207),
    [anon_sym_LT_EQ] = ACTIONS(5207),
    [anon_sym_DOT] = ACTIONS(5209),
    [anon_sym_switch] = ACTIONS(5207),
    [anon_sym_DOT_DOT] = ACTIONS(5207),
    [anon_sym_and] = ACTIONS(5207),
    [anon_sym_or] = ACTIONS(5209),
    [anon_sym_AMP_AMP] = ACTIONS(5207),
    [anon_sym_PIPE_PIPE] = ACTIONS(5207),
    [anon_sym_QMARK_QMARK] = ACTIONS(5207),
    [anon_sym_from] = ACTIONS(5207),
    [anon_sym_into] = ACTIONS(5207),
    [anon_sym_join] = ACTIONS(5207),
    [anon_sym_let] = ACTIONS(5207),
    [anon_sym_orderby] = ACTIONS(5207),
    [anon_sym_ascending] = ACTIONS(5207),
    [anon_sym_descending] = ACTIONS(5207),
    [anon_sym_group] = ACTIONS(5207),
    [anon_sym_select] = ACTIONS(5207),
    [anon_sym_as] = ACTIONS(5209),
    [anon_sym_is] = ACTIONS(5207),
    [anon_sym_DASH_GT] = ACTIONS(5207),
    [anon_sym_with] = ACTIONS(5207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3919] = {
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3263),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3234),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3919),
    [sym_preproc_endregion] = STATE(3919),
    [sym_preproc_line] = STATE(3919),
    [sym_preproc_pragma] = STATE(3919),
    [sym_preproc_nullable] = STATE(3919),
    [sym_preproc_error] = STATE(3919),
    [sym_preproc_warning] = STATE(3919),
    [sym_preproc_define] = STATE(3919),
    [sym_preproc_undef] = STATE(3919),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(6163),
    [anon_sym_ref] = ACTIONS(4180),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(6257),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5832),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3920] = {
    [sym_preproc_region] = STATE(3920),
    [sym_preproc_endregion] = STATE(3920),
    [sym_preproc_line] = STATE(3920),
    [sym_preproc_pragma] = STATE(3920),
    [sym_preproc_nullable] = STATE(3920),
    [sym_preproc_error] = STATE(3920),
    [sym_preproc_warning] = STATE(3920),
    [sym_preproc_define] = STATE(3920),
    [sym_preproc_undef] = STATE(3920),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5503),
    [anon_sym_GT] = ACTIONS(5503),
    [anon_sym_where] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(5503),
    [anon_sym_BANG] = ACTIONS(5503),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5503),
    [anon_sym_DASH] = ACTIONS(5503),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5503),
    [anon_sym_AMP] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5503),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4303),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_from] = ACTIONS(4295),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_join] = ACTIONS(4295),
    [anon_sym_let] = ACTIONS(4295),
    [anon_sym_orderby] = ACTIONS(4295),
    [anon_sym_ascending] = ACTIONS(4295),
    [anon_sym_descending] = ACTIONS(4295),
    [anon_sym_group] = ACTIONS(4295),
    [anon_sym_select] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(5503),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3921] = {
    [sym_preproc_region] = STATE(3921),
    [sym_preproc_endregion] = STATE(3921),
    [sym_preproc_line] = STATE(3921),
    [sym_preproc_pragma] = STATE(3921),
    [sym_preproc_nullable] = STATE(3921),
    [sym_preproc_error] = STATE(3921),
    [sym_preproc_warning] = STATE(3921),
    [sym_preproc_define] = STATE(3921),
    [sym_preproc_undef] = STATE(3921),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(4295),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5509),
    [anon_sym_GT] = ACTIONS(5509),
    [anon_sym_where] = ACTIONS(4295),
    [anon_sym_QMARK] = ACTIONS(5509),
    [anon_sym_BANG] = ACTIONS(5509),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5509),
    [anon_sym_DASH] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5509),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5509),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5509),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5509),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(4295),
    [anon_sym_or] = ACTIONS(4303),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_from] = ACTIONS(4295),
    [anon_sym_into] = ACTIONS(4295),
    [anon_sym_join] = ACTIONS(4295),
    [anon_sym_let] = ACTIONS(4295),
    [anon_sym_orderby] = ACTIONS(4295),
    [anon_sym_ascending] = ACTIONS(4295),
    [anon_sym_descending] = ACTIONS(4295),
    [anon_sym_group] = ACTIONS(4295),
    [anon_sym_select] = ACTIONS(4295),
    [anon_sym_as] = ACTIONS(5509),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3922] = {
    [sym_preproc_region] = STATE(3922),
    [sym_preproc_endregion] = STATE(3922),
    [sym_preproc_line] = STATE(3922),
    [sym_preproc_pragma] = STATE(3922),
    [sym_preproc_nullable] = STATE(3922),
    [sym_preproc_error] = STATE(3922),
    [sym_preproc_warning] = STATE(3922),
    [sym_preproc_define] = STATE(3922),
    [sym_preproc_undef] = STATE(3922),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_GT] = ACTIONS(2063),
    [anon_sym_where] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(2063),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_GT_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_DOT_DOT] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_QMARK_QMARK] = ACTIONS(2061),
    [anon_sym_from] = ACTIONS(2061),
    [anon_sym_into] = ACTIONS(2061),
    [anon_sym_join] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2061),
    [anon_sym_orderby] = ACTIONS(2061),
    [anon_sym_ascending] = ACTIONS(2061),
    [anon_sym_descending] = ACTIONS(2061),
    [anon_sym_group] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2063),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_DASH_GT] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3923] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3923),
    [sym_preproc_endregion] = STATE(3923),
    [sym_preproc_line] = STATE(3923),
    [sym_preproc_pragma] = STATE(3923),
    [sym_preproc_nullable] = STATE(3923),
    [sym_preproc_error] = STATE(3923),
    [sym_preproc_warning] = STATE(3923),
    [sym_preproc_define] = STATE(3923),
    [sym_preproc_undef] = STATE(3923),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_RBRACK] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5878),
    [anon_sym_or] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5878),
    [aux_sym_preproc_else_token1] = ACTIONS(5878),
    [aux_sym_preproc_elif_token1] = ACTIONS(5878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3924] = {
    [sym_preproc_region] = STATE(3924),
    [sym_preproc_endregion] = STATE(3924),
    [sym_preproc_line] = STATE(3924),
    [sym_preproc_pragma] = STATE(3924),
    [sym_preproc_nullable] = STATE(3924),
    [sym_preproc_error] = STATE(3924),
    [sym_preproc_warning] = STATE(3924),
    [sym_preproc_define] = STATE(3924),
    [sym_preproc_undef] = STATE(3924),
    [anon_sym_LBRACK] = ACTIONS(5163),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(5163),
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_where] = ACTIONS(5163),
    [anon_sym_QMARK] = ACTIONS(5165),
    [anon_sym_BANG] = ACTIONS(5165),
    [anon_sym_PLUS_PLUS] = ACTIONS(5163),
    [anon_sym_DASH_DASH] = ACTIONS(5163),
    [anon_sym_PLUS] = ACTIONS(5165),
    [anon_sym_DASH] = ACTIONS(5165),
    [anon_sym_STAR] = ACTIONS(5163),
    [anon_sym_SLASH] = ACTIONS(5165),
    [anon_sym_PERCENT] = ACTIONS(5163),
    [anon_sym_CARET] = ACTIONS(5163),
    [anon_sym_PIPE] = ACTIONS(5165),
    [anon_sym_AMP] = ACTIONS(5165),
    [anon_sym_LT_LT] = ACTIONS(5163),
    [anon_sym_GT_GT] = ACTIONS(5165),
    [anon_sym_GT_GT_GT] = ACTIONS(5163),
    [anon_sym_EQ_EQ] = ACTIONS(5163),
    [anon_sym_BANG_EQ] = ACTIONS(5163),
    [anon_sym_GT_EQ] = ACTIONS(5163),
    [anon_sym_LT_EQ] = ACTIONS(5163),
    [anon_sym_DOT] = ACTIONS(5165),
    [anon_sym_switch] = ACTIONS(5163),
    [anon_sym_DOT_DOT] = ACTIONS(5163),
    [anon_sym_and] = ACTIONS(5163),
    [anon_sym_or] = ACTIONS(5165),
    [anon_sym_AMP_AMP] = ACTIONS(5163),
    [anon_sym_PIPE_PIPE] = ACTIONS(5163),
    [anon_sym_QMARK_QMARK] = ACTIONS(5163),
    [anon_sym_from] = ACTIONS(5163),
    [anon_sym_into] = ACTIONS(5163),
    [anon_sym_join] = ACTIONS(5163),
    [anon_sym_let] = ACTIONS(5163),
    [anon_sym_orderby] = ACTIONS(5163),
    [anon_sym_ascending] = ACTIONS(5163),
    [anon_sym_descending] = ACTIONS(5163),
    [anon_sym_group] = ACTIONS(5163),
    [anon_sym_select] = ACTIONS(5163),
    [anon_sym_as] = ACTIONS(5165),
    [anon_sym_is] = ACTIONS(5163),
    [anon_sym_DASH_GT] = ACTIONS(5163),
    [anon_sym_with] = ACTIONS(5163),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3925] = {
    [sym_preproc_region] = STATE(3925),
    [sym_preproc_endregion] = STATE(3925),
    [sym_preproc_line] = STATE(3925),
    [sym_preproc_pragma] = STATE(3925),
    [sym_preproc_nullable] = STATE(3925),
    [sym_preproc_error] = STATE(3925),
    [sym_preproc_warning] = STATE(3925),
    [sym_preproc_define] = STATE(3925),
    [sym_preproc_undef] = STATE(3925),
    [anon_sym_LBRACK] = ACTIONS(5167),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_LPAREN] = ACTIONS(5167),
    [anon_sym_LT] = ACTIONS(5169),
    [anon_sym_GT] = ACTIONS(5169),
    [anon_sym_where] = ACTIONS(5167),
    [anon_sym_QMARK] = ACTIONS(5169),
    [anon_sym_BANG] = ACTIONS(5169),
    [anon_sym_PLUS_PLUS] = ACTIONS(5167),
    [anon_sym_DASH_DASH] = ACTIONS(5167),
    [anon_sym_PLUS] = ACTIONS(5169),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_STAR] = ACTIONS(5167),
    [anon_sym_SLASH] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5167),
    [anon_sym_CARET] = ACTIONS(5167),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(5169),
    [anon_sym_LT_LT] = ACTIONS(5167),
    [anon_sym_GT_GT] = ACTIONS(5169),
    [anon_sym_GT_GT_GT] = ACTIONS(5167),
    [anon_sym_EQ_EQ] = ACTIONS(5167),
    [anon_sym_BANG_EQ] = ACTIONS(5167),
    [anon_sym_GT_EQ] = ACTIONS(5167),
    [anon_sym_LT_EQ] = ACTIONS(5167),
    [anon_sym_DOT] = ACTIONS(5169),
    [anon_sym_switch] = ACTIONS(5167),
    [anon_sym_DOT_DOT] = ACTIONS(5167),
    [anon_sym_and] = ACTIONS(5167),
    [anon_sym_or] = ACTIONS(5169),
    [anon_sym_AMP_AMP] = ACTIONS(5167),
    [anon_sym_PIPE_PIPE] = ACTIONS(5167),
    [anon_sym_QMARK_QMARK] = ACTIONS(5167),
    [anon_sym_from] = ACTIONS(5167),
    [anon_sym_into] = ACTIONS(5167),
    [anon_sym_join] = ACTIONS(5167),
    [anon_sym_let] = ACTIONS(5167),
    [anon_sym_orderby] = ACTIONS(5167),
    [anon_sym_ascending] = ACTIONS(5167),
    [anon_sym_descending] = ACTIONS(5167),
    [anon_sym_group] = ACTIONS(5167),
    [anon_sym_select] = ACTIONS(5167),
    [anon_sym_as] = ACTIONS(5169),
    [anon_sym_is] = ACTIONS(5167),
    [anon_sym_DASH_GT] = ACTIONS(5167),
    [anon_sym_with] = ACTIONS(5167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3926] = {
    [sym_preproc_region] = STATE(3926),
    [sym_preproc_endregion] = STATE(3926),
    [sym_preproc_line] = STATE(3926),
    [sym_preproc_pragma] = STATE(3926),
    [sym_preproc_nullable] = STATE(3926),
    [sym_preproc_error] = STATE(3926),
    [sym_preproc_warning] = STATE(3926),
    [sym_preproc_define] = STATE(3926),
    [sym_preproc_undef] = STATE(3926),
    [anon_sym_LBRACK] = ACTIONS(5175),
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_LPAREN] = ACTIONS(5175),
    [anon_sym_LT] = ACTIONS(5177),
    [anon_sym_GT] = ACTIONS(5177),
    [anon_sym_where] = ACTIONS(5175),
    [anon_sym_QMARK] = ACTIONS(5177),
    [anon_sym_BANG] = ACTIONS(5177),
    [anon_sym_PLUS_PLUS] = ACTIONS(5175),
    [anon_sym_DASH_DASH] = ACTIONS(5175),
    [anon_sym_PLUS] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5175),
    [anon_sym_SLASH] = ACTIONS(5177),
    [anon_sym_PERCENT] = ACTIONS(5175),
    [anon_sym_CARET] = ACTIONS(5175),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_LT_LT] = ACTIONS(5175),
    [anon_sym_GT_GT] = ACTIONS(5177),
    [anon_sym_GT_GT_GT] = ACTIONS(5175),
    [anon_sym_EQ_EQ] = ACTIONS(5175),
    [anon_sym_BANG_EQ] = ACTIONS(5175),
    [anon_sym_GT_EQ] = ACTIONS(5175),
    [anon_sym_LT_EQ] = ACTIONS(5175),
    [anon_sym_DOT] = ACTIONS(5177),
    [anon_sym_switch] = ACTIONS(5175),
    [anon_sym_DOT_DOT] = ACTIONS(5175),
    [anon_sym_and] = ACTIONS(5175),
    [anon_sym_or] = ACTIONS(5177),
    [anon_sym_AMP_AMP] = ACTIONS(5175),
    [anon_sym_PIPE_PIPE] = ACTIONS(5175),
    [anon_sym_QMARK_QMARK] = ACTIONS(5175),
    [anon_sym_from] = ACTIONS(5175),
    [anon_sym_into] = ACTIONS(5175),
    [anon_sym_join] = ACTIONS(5175),
    [anon_sym_let] = ACTIONS(5175),
    [anon_sym_orderby] = ACTIONS(5175),
    [anon_sym_ascending] = ACTIONS(5175),
    [anon_sym_descending] = ACTIONS(5175),
    [anon_sym_group] = ACTIONS(5175),
    [anon_sym_select] = ACTIONS(5175),
    [anon_sym_as] = ACTIONS(5177),
    [anon_sym_is] = ACTIONS(5175),
    [anon_sym_DASH_GT] = ACTIONS(5175),
    [anon_sym_with] = ACTIONS(5175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3927] = {
    [sym_preproc_region] = STATE(3927),
    [sym_preproc_endregion] = STATE(3927),
    [sym_preproc_line] = STATE(3927),
    [sym_preproc_pragma] = STATE(3927),
    [sym_preproc_nullable] = STATE(3927),
    [sym_preproc_error] = STATE(3927),
    [sym_preproc_warning] = STATE(3927),
    [sym_preproc_define] = STATE(3927),
    [sym_preproc_undef] = STATE(3927),
    [anon_sym_LBRACK] = ACTIONS(5183),
    [anon_sym_COMMA] = ACTIONS(5183),
    [anon_sym_LPAREN] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_where] = ACTIONS(5183),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_BANG] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5183),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5183),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_GT_GT_GT] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5183),
    [anon_sym_BANG_EQ] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5183),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_switch] = ACTIONS(5183),
    [anon_sym_DOT_DOT] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE] = ACTIONS(5183),
    [anon_sym_QMARK_QMARK] = ACTIONS(5183),
    [anon_sym_from] = ACTIONS(5183),
    [anon_sym_into] = ACTIONS(5183),
    [anon_sym_join] = ACTIONS(5183),
    [anon_sym_let] = ACTIONS(5183),
    [anon_sym_orderby] = ACTIONS(5183),
    [anon_sym_ascending] = ACTIONS(5183),
    [anon_sym_descending] = ACTIONS(5183),
    [anon_sym_group] = ACTIONS(5183),
    [anon_sym_select] = ACTIONS(5183),
    [anon_sym_as] = ACTIONS(5185),
    [anon_sym_is] = ACTIONS(5183),
    [anon_sym_DASH_GT] = ACTIONS(5183),
    [anon_sym_with] = ACTIONS(5183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3928] = {
    [sym__name] = STATE(6336),
    [sym_alias_qualified_name] = STATE(4123),
    [sym__simple_name] = STATE(4123),
    [sym_qualified_name] = STATE(4123),
    [sym_generic_name] = STATE(4135),
    [sym_type] = STATE(4607),
    [sym_implicit_type] = STATE(2337),
    [sym_array_type] = STATE(4530),
    [sym__array_base_type] = STATE(7210),
    [sym_nullable_type] = STATE(4355),
    [sym_pointer_type] = STATE(4355),
    [sym__pointer_base_type] = STATE(7752),
    [sym_function_pointer_type] = STATE(4355),
    [sym_ref_type] = STATE(2337),
    [sym_scoped_type] = STATE(2337),
    [sym_tuple_type] = STATE(4360),
    [sym_identifier] = STATE(6309),
    [sym__reserved_identifier] = STATE(3728),
    [sym_preproc_region] = STATE(3928),
    [sym_preproc_endregion] = STATE(3928),
    [sym_preproc_line] = STATE(3928),
    [sym_preproc_pragma] = STATE(3928),
    [sym_preproc_nullable] = STATE(3928),
    [sym_preproc_error] = STATE(3928),
    [sym_preproc_warning] = STATE(3928),
    [sym_preproc_define] = STATE(3928),
    [sym_preproc_undef] = STATE(3928),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2997),
    [anon_sym_global] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_ref] = ACTIONS(6259),
    [anon_sym_delegate] = ACTIONS(3468),
    [anon_sym_file] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(6261),
    [anon_sym_where] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2997),
    [anon_sym_unmanaged] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(6263),
    [anon_sym_var] = ACTIONS(6265),
    [sym_predefined_type] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_when] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_into] = ACTIONS(2997),
    [anon_sym_join] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_equals] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_orderby] = ACTIONS(2997),
    [anon_sym_ascending] = ACTIONS(2997),
    [anon_sym_descending] = ACTIONS(2997),
    [anon_sym_group] = ACTIONS(2997),
    [anon_sym_by] = ACTIONS(2997),
    [anon_sym_select] = ACTIONS(2997),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3929] = {
    [sym_preproc_region] = STATE(3929),
    [sym_preproc_endregion] = STATE(3929),
    [sym_preproc_line] = STATE(3929),
    [sym_preproc_pragma] = STATE(3929),
    [sym_preproc_nullable] = STATE(3929),
    [sym_preproc_error] = STATE(3929),
    [sym_preproc_warning] = STATE(3929),
    [sym_preproc_define] = STATE(3929),
    [sym_preproc_undef] = STATE(3929),
    [anon_sym_LBRACK] = ACTIONS(5211),
    [anon_sym_COMMA] = ACTIONS(5211),
    [anon_sym_LPAREN] = ACTIONS(5211),
    [anon_sym_LT] = ACTIONS(5213),
    [anon_sym_GT] = ACTIONS(5213),
    [anon_sym_where] = ACTIONS(5211),
    [anon_sym_QMARK] = ACTIONS(5213),
    [anon_sym_BANG] = ACTIONS(5213),
    [anon_sym_PLUS_PLUS] = ACTIONS(5211),
    [anon_sym_DASH_DASH] = ACTIONS(5211),
    [anon_sym_PLUS] = ACTIONS(5213),
    [anon_sym_DASH] = ACTIONS(5213),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_SLASH] = ACTIONS(5213),
    [anon_sym_PERCENT] = ACTIONS(5211),
    [anon_sym_CARET] = ACTIONS(5211),
    [anon_sym_PIPE] = ACTIONS(5213),
    [anon_sym_AMP] = ACTIONS(5213),
    [anon_sym_LT_LT] = ACTIONS(5211),
    [anon_sym_GT_GT] = ACTIONS(5213),
    [anon_sym_GT_GT_GT] = ACTIONS(5211),
    [anon_sym_EQ_EQ] = ACTIONS(5211),
    [anon_sym_BANG_EQ] = ACTIONS(5211),
    [anon_sym_GT_EQ] = ACTIONS(5211),
    [anon_sym_LT_EQ] = ACTIONS(5211),
    [anon_sym_DOT] = ACTIONS(5213),
    [anon_sym_switch] = ACTIONS(5211),
    [anon_sym_DOT_DOT] = ACTIONS(5211),
    [anon_sym_and] = ACTIONS(5211),
    [anon_sym_or] = ACTIONS(5213),
    [anon_sym_AMP_AMP] = ACTIONS(5211),
    [anon_sym_PIPE_PIPE] = ACTIONS(5211),
    [anon_sym_QMARK_QMARK] = ACTIONS(5211),
    [anon_sym_from] = ACTIONS(5211),
    [anon_sym_into] = ACTIONS(5211),
    [anon_sym_join] = ACTIONS(5211),
    [anon_sym_let] = ACTIONS(5211),
    [anon_sym_orderby] = ACTIONS(5211),
    [anon_sym_ascending] = ACTIONS(5211),
    [anon_sym_descending] = ACTIONS(5211),
    [anon_sym_group] = ACTIONS(5211),
    [anon_sym_select] = ACTIONS(5211),
    [anon_sym_as] = ACTIONS(5213),
    [anon_sym_is] = ACTIONS(5211),
    [anon_sym_DASH_GT] = ACTIONS(5211),
    [anon_sym_with] = ACTIONS(5211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3930] = {
    [sym_preproc_region] = STATE(3930),
    [sym_preproc_endregion] = STATE(3930),
    [sym_preproc_line] = STATE(3930),
    [sym_preproc_pragma] = STATE(3930),
    [sym_preproc_nullable] = STATE(3930),
    [sym_preproc_error] = STATE(3930),
    [sym_preproc_warning] = STATE(3930),
    [sym_preproc_define] = STATE(3930),
    [sym_preproc_undef] = STATE(3930),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(5461),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3931] = {
    [sym_preproc_region] = STATE(3931),
    [sym_preproc_endregion] = STATE(3931),
    [sym_preproc_line] = STATE(3931),
    [sym_preproc_pragma] = STATE(3931),
    [sym_preproc_nullable] = STATE(3931),
    [sym_preproc_error] = STATE(3931),
    [sym_preproc_warning] = STATE(3931),
    [sym_preproc_define] = STATE(3931),
    [sym_preproc_undef] = STATE(3931),
    [anon_sym_LBRACK] = ACTIONS(5222),
    [anon_sym_COMMA] = ACTIONS(5222),
    [anon_sym_LPAREN] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_where] = ACTIONS(5222),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_BANG] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_PIPE] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5224),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5224),
    [anon_sym_GT_GT_GT] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5222),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_DOT] = ACTIONS(5224),
    [anon_sym_switch] = ACTIONS(5222),
    [anon_sym_DOT_DOT] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_or] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5222),
    [anon_sym_QMARK_QMARK] = ACTIONS(5222),
    [anon_sym_from] = ACTIONS(5222),
    [anon_sym_into] = ACTIONS(5222),
    [anon_sym_join] = ACTIONS(5222),
    [anon_sym_let] = ACTIONS(5222),
    [anon_sym_orderby] = ACTIONS(5222),
    [anon_sym_ascending] = ACTIONS(5222),
    [anon_sym_descending] = ACTIONS(5222),
    [anon_sym_group] = ACTIONS(5222),
    [anon_sym_select] = ACTIONS(5222),
    [anon_sym_as] = ACTIONS(5224),
    [anon_sym_is] = ACTIONS(5222),
    [anon_sym_DASH_GT] = ACTIONS(5222),
    [anon_sym_with] = ACTIONS(5222),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3932] = {
    [sym_preproc_region] = STATE(3932),
    [sym_preproc_endregion] = STATE(3932),
    [sym_preproc_line] = STATE(3932),
    [sym_preproc_pragma] = STATE(3932),
    [sym_preproc_nullable] = STATE(3932),
    [sym_preproc_error] = STATE(3932),
    [sym_preproc_warning] = STATE(3932),
    [sym_preproc_define] = STATE(3932),
    [sym_preproc_undef] = STATE(3932),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_where] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2979),
    [anon_sym_CARET] = ACTIONS(2979),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_and] = ACTIONS(2979),
    [anon_sym_or] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2979),
    [anon_sym_into] = ACTIONS(2979),
    [anon_sym_join] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_orderby] = ACTIONS(2979),
    [anon_sym_ascending] = ACTIONS(2979),
    [anon_sym_descending] = ACTIONS(2979),
    [anon_sym_group] = ACTIONS(2979),
    [anon_sym_select] = ACTIONS(2979),
    [anon_sym_as] = ACTIONS(2977),
    [anon_sym_is] = ACTIONS(2979),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3933] = {
    [sym_preproc_region] = STATE(3933),
    [sym_preproc_endregion] = STATE(3933),
    [sym_preproc_line] = STATE(3933),
    [sym_preproc_pragma] = STATE(3933),
    [sym_preproc_nullable] = STATE(3933),
    [sym_preproc_error] = STATE(3933),
    [sym_preproc_warning] = STATE(3933),
    [sym_preproc_define] = STATE(3933),
    [sym_preproc_undef] = STATE(3933),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_COMMA] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_LT] = ACTIONS(4993),
    [anon_sym_GT] = ACTIONS(4993),
    [anon_sym_where] = ACTIONS(4991),
    [anon_sym_QMARK] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_PLUS_PLUS] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4991),
    [anon_sym_PLUS] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4991),
    [anon_sym_SLASH] = ACTIONS(4993),
    [anon_sym_PERCENT] = ACTIONS(4991),
    [anon_sym_CARET] = ACTIONS(4991),
    [anon_sym_PIPE] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_LT_LT] = ACTIONS(4991),
    [anon_sym_GT_GT] = ACTIONS(4993),
    [anon_sym_GT_GT_GT] = ACTIONS(4991),
    [anon_sym_EQ_EQ] = ACTIONS(4991),
    [anon_sym_BANG_EQ] = ACTIONS(4991),
    [anon_sym_GT_EQ] = ACTIONS(4991),
    [anon_sym_LT_EQ] = ACTIONS(4991),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_switch] = ACTIONS(4991),
    [anon_sym_DOT_DOT] = ACTIONS(4991),
    [anon_sym_and] = ACTIONS(4991),
    [anon_sym_or] = ACTIONS(4993),
    [anon_sym_AMP_AMP] = ACTIONS(4991),
    [anon_sym_PIPE_PIPE] = ACTIONS(4991),
    [anon_sym_QMARK_QMARK] = ACTIONS(4991),
    [anon_sym_from] = ACTIONS(4991),
    [anon_sym_into] = ACTIONS(4991),
    [anon_sym_join] = ACTIONS(4991),
    [anon_sym_let] = ACTIONS(4991),
    [anon_sym_orderby] = ACTIONS(4991),
    [anon_sym_ascending] = ACTIONS(4991),
    [anon_sym_descending] = ACTIONS(4991),
    [anon_sym_group] = ACTIONS(4991),
    [anon_sym_select] = ACTIONS(4991),
    [anon_sym_as] = ACTIONS(4993),
    [anon_sym_is] = ACTIONS(4991),
    [anon_sym_DASH_GT] = ACTIONS(4991),
    [anon_sym_with] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3934] = {
    [sym_argument_list] = STATE(3372),
    [sym_bracketed_argument_list] = STATE(2655),
    [sym_preproc_region] = STATE(3934),
    [sym_preproc_endregion] = STATE(3934),
    [sym_preproc_line] = STATE(3934),
    [sym_preproc_pragma] = STATE(3934),
    [sym_preproc_nullable] = STATE(3934),
    [sym_preproc_error] = STATE(3934),
    [sym_preproc_warning] = STATE(3934),
    [sym_preproc_define] = STATE(3934),
    [sym_preproc_undef] = STATE(3934),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5310),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5302),
    [anon_sym_RPAREN] = ACTIONS(5850),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(5312),
    [anon_sym_PLUS_PLUS] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5314),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6139),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_GT_GT_GT] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6145),
    [anon_sym_BANG_EQ] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(6149),
    [anon_sym_DOT_DOT] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_QMARK_QMARK] = ACTIONS(6155),
    [anon_sym_into] = ACTIONS(5850),
    [anon_sym_as] = ACTIONS(6157),
    [anon_sym_is] = ACTIONS(6159),
    [anon_sym_DASH_GT] = ACTIONS(4138),
    [anon_sym_with] = ACTIONS(6161),
    [aux_sym_preproc_if_token3] = ACTIONS(5850),
    [aux_sym_preproc_else_token1] = ACTIONS(5850),
    [aux_sym_preproc_elif_token1] = ACTIONS(5850),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3935] = {
    [sym_preproc_region] = STATE(3935),
    [sym_preproc_endregion] = STATE(3935),
    [sym_preproc_line] = STATE(3935),
    [sym_preproc_pragma] = STATE(3935),
    [sym_preproc_nullable] = STATE(3935),
    [sym_preproc_error] = STATE(3935),
    [sym_preproc_warning] = STATE(3935),
    [sym_preproc_define] = STATE(3935),
    [sym_preproc_undef] = STATE(3935),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_where] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_CARET] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5003),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_GT_GT_GT] = ACTIONS(5003),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_switch] = ACTIONS(5003),
    [anon_sym_DOT_DOT] = ACTIONS(5003),
    [anon_sym_and] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_QMARK_QMARK] = ACTIONS(5003),
    [anon_sym_from] = ACTIONS(5003),
    [anon_sym_into] = ACTIONS(5003),
    [anon_sym_join] = ACTIONS(5003),
    [anon_sym_let] = ACTIONS(5003),
    [anon_sym_orderby] = ACTIONS(5003),
    [anon_sym_ascending] = ACTIONS(5003),
    [anon_sym_descending] = ACTIONS(5003),
    [anon_sym_group] = ACTIONS(5003),
    [anon_sym_select] = ACTIONS(5003),
    [anon_sym_as] = ACTIONS(5005),
    [anon_sym_is] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [anon_sym_with] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3936] = {
    [sym_preproc_region] = STATE(3936),
    [sym_preproc_endregion] = STATE(3936),
    [sym_preproc_line] = STATE(3936),
    [sym_preproc_pragma] = STATE(3936),
    [sym_preproc_nullable] = STATE(3936),
    [sym_preproc_error] = STATE(3936),
    [sym_preproc_warning] = STATE(3936),
    [sym_preproc_define] = STATE(3936),
    [sym_preproc_undef] = STATE(3936),
    [sym__identifier_token] = ACTIONS(5938),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(5938),
    [anon_sym_global] = ACTIONS(5938),
    [anon_sym_unsafe] = ACTIONS(5938),
    [anon_sym_static] = ACTIONS(5938),
    [anon_sym_LPAREN] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(5938),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(5938),
    [anon_sym_notnull] = ACTIONS(5938),
    [anon_sym_unmanaged] = ACTIONS(5938),
    [anon_sym_scoped] = ACTIONS(5938),
    [anon_sym_var] = ACTIONS(5938),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(5938),
    [anon_sym_when] = ACTIONS(5938),
    [anon_sym_from] = ACTIONS(5938),
    [anon_sym_into] = ACTIONS(5938),
    [anon_sym_join] = ACTIONS(5938),
    [anon_sym_on] = ACTIONS(5938),
    [anon_sym_equals] = ACTIONS(5938),
    [anon_sym_let] = ACTIONS(5938),
    [anon_sym_orderby] = ACTIONS(5938),
    [anon_sym_ascending] = ACTIONS(5938),
    [anon_sym_descending] = ACTIONS(5938),
    [anon_sym_group] = ACTIONS(5938),
    [anon_sym_by] = ACTIONS(5938),
    [anon_sym_select] = ACTIONS(5938),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3937] = {
    [sym__name] = STATE(3190),
    [sym_alias_qualified_name] = STATE(3204),
    [sym__simple_name] = STATE(3204),
    [sym_qualified_name] = STATE(3204),
    [sym_generic_name] = STATE(3205),
    [sym_type] = STATE(3263),
    [sym_implicit_type] = STATE(3233),
    [sym_array_type] = STATE(3234),
    [sym__array_base_type] = STATE(7245),
    [sym_nullable_type] = STATE(3238),
    [sym_pointer_type] = STATE(3238),
    [sym__pointer_base_type] = STATE(7595),
    [sym_function_pointer_type] = STATE(3238),
    [sym_ref_type] = STATE(3233),
    [sym_scoped_type] = STATE(3233),
    [sym_tuple_type] = STATE(3242),
    [sym_identifier] = STATE(3165),
    [sym__reserved_identifier] = STATE(3171),
    [sym_preproc_region] = STATE(3937),
    [sym_preproc_endregion] = STATE(3937),
    [sym_preproc_line] = STATE(3937),
    [sym_preproc_pragma] = STATE(3937),
    [sym_preproc_nullable] = STATE(3937),
    [sym_preproc_error] = STATE(3937),
    [sym_preproc_warning] = STATE(3937),
    [sym_preproc_define] = STATE(3937),
    [sym_preproc_undef] = STATE(3937),
    [sym__identifier_token] = ACTIONS(3789),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(6163),
    [anon_sym_ref] = ACTIONS(3793),
    [anon_sym_delegate] = ACTIONS(5758),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(6267),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(5760),
    [anon_sym_var] = ACTIONS(5762),
    [sym_predefined_type] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3938] = {
    [sym_preproc_region] = STATE(3938),
    [sym_preproc_endregion] = STATE(3938),
    [sym_preproc_line] = STATE(3938),
    [sym_preproc_pragma] = STATE(3938),
    [sym_preproc_nullable] = STATE(3938),
    [sym_preproc_error] = STATE(3938),
    [sym_preproc_warning] = STATE(3938),
    [sym_preproc_define] = STATE(3938),
    [sym_preproc_undef] = STATE(3938),
    [sym__identifier_token] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym_alias] = ACTIONS(3494),
    [anon_sym_global] = ACTIONS(3494),
    [anon_sym_unsafe] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(6269),
    [anon_sym_ref] = ACTIONS(3494),
    [anon_sym_delegate] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_async] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_file] = ACTIONS(3494),
    [anon_sym_fixed] = ACTIONS(3494),
    [anon_sym_internal] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_partial] = ACTIONS(3494),
    [anon_sym_private] = ACTIONS(3494),
    [anon_sym_protected] = ACTIONS(3494),
    [anon_sym_public] = ACTIONS(3494),
    [anon_sym_readonly] = ACTIONS(3494),
    [anon_sym_required] = ACTIONS(3494),
    [anon_sym_sealed] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_notnull] = ACTIONS(3494),
    [anon_sym_unmanaged] = ACTIONS(3494),
    [anon_sym_scoped] = ACTIONS(3494),
    [anon_sym_var] = ACTIONS(3494),
    [sym_predefined_type] = ACTIONS(3494),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_when] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_ascending] = ACTIONS(3494),
    [anon_sym_descending] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3939] = {
    [sym_preproc_region] = STATE(3939),
    [sym_preproc_endregion] = STATE(3939),
    [sym_preproc_line] = STATE(3939),
    [sym_preproc_pragma] = STATE(3939),
    [sym_preproc_nullable] = STATE(3939),
    [sym_preproc_error] = STATE(3939),
    [sym_preproc_warning] = STATE(3939),
    [sym_preproc_define] = STATE(3939),
    [sym_preproc_undef] = STATE(3939),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_COMMA] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_LT] = ACTIONS(5009),
    [anon_sym_GT] = ACTIONS(5009),
    [anon_sym_where] = ACTIONS(5007),
    [anon_sym_QMARK] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_PLUS_PLUS] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5007),
    [anon_sym_PLUS] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5009),
    [anon_sym_PERCENT] = ACTIONS(5007),
    [anon_sym_CARET] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_LT_LT] = ACTIONS(5007),
    [anon_sym_GT_GT] = ACTIONS(5009),
    [anon_sym_GT_GT_GT] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(5007),
    [anon_sym_BANG_EQ] = ACTIONS(5007),
    [anon_sym_GT_EQ] = ACTIONS(5007),
    [anon_sym_LT_EQ] = ACTIONS(5007),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_switch] = ACTIONS(5007),
    [anon_sym_DOT_DOT] = ACTIONS(5007),
    [anon_sym_and] = ACTIONS(5007),
    [anon_sym_or] = ACTIONS(5009),
    [anon_sym_AMP_AMP] = ACTIONS(5007),
    [anon_sym_PIPE_PIPE] = ACTIONS(5007),
    [anon_sym_QMARK_QMARK] = ACTIONS(5007),
    [anon_sym_from] = ACTIONS(5007),
    [anon_sym_into] = ACTIONS(5007),
    [anon_sym_join] = ACTIONS(5007),
    [anon_sym_let] = ACTIONS(5007),
    [anon_sym_orderby] = ACTIONS(5007),
    [anon_sym_ascending] = ACTIONS(5007),
    [anon_sym_descending] = ACTIONS(5007),
    [anon_sym_group] = ACTIONS(5007),
    [anon_sym_select] = ACTIONS(5007),
    [anon_sym_as] = ACTIONS(5009),
    [anon_sym_is] = ACTIONS(5007),
    [anon_sym_DASH_GT] = ACTIONS(5007),
    [anon_sym_with] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
  [3940] = {
    [sym_preproc_region] = STATE(3940),
    [sym_preproc_endregion] = STATE(3940),
    [sym_preproc_line] = STATE(3940),
    [sym_preproc_pragma] = STATE(3940),
    [sym_preproc_nullable] = STATE(3940),
    [sym_preproc_error] = STATE(3940),
    [sym_preproc_warning] = STATE(3940),
    [sym_preproc_define] = STATE(3940),
    [sym_preproc_undef] = STATE(3940),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_where] = ACTIONS(5445),
    [anon_sym_QMARK] = ACTIONS(5447),
    [anon_sym_BANG] = ACTIONS(5447),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5445),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5445),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_GT_GT_GT] = ACTIONS(5445),
    [anon_sym_EQ_EQ] = ACTIONS(5445),
    [anon_sym_BANG_EQ] = ACTIONS(5445),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [anon_sym_LT_EQ] = ACTIONS(5445),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_switch] = ACTIONS(5445),
    [anon_sym_DOT_DOT] = ACTIONS(5445),
    [anon_sym_and] = ACTIONS(5445),
    [anon_sym_or] = ACTIONS(5447),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_QMARK_QMARK] = ACTIONS(5445),
    [anon_sym_from] = ACTIONS(5445),
    [anon_sym_into] = ACTIONS(5445),
    [anon_sym_join] = ACTIONS(5445),
    [anon_sym_let] = ACTIONS(5445),
    [anon_sym_orderby] = ACTIONS(5445),
    [anon_sym_ascending] = ACTIONS(5445),
    [anon_sym_descending] = ACTIONS(5445),
    [anon_sym_group] = ACTIONS(5445),
    [anon_sym_select] = ACTIONS(5445),
    [anon_sym_as] = ACTIONS(5447),
    [anon_sym_is] = ACTIONS(5445),
    [anon_sym_DASH_GT] = ACTIONS(5445),
    [anon_sym_with] = ACTIONS(5445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_warning_token1] = ACTIONS(15),
    [aux_sym_preproc_define_token1] = ACTIONS(17),
    [aux_sym_preproc_undef_token1] = ACTIONS(19),
    [sym_comment] = ACTIONS(21),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7561), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3941), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [127] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7417), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3942), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [254] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6259), 1,
      anon_sym_ref,
    ACTIONS(6263), 1,
      anon_sym_scoped,
    ACTIONS(6265), 1,
      anon_sym_var,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4530), 1,
      sym_array_type,
    STATE(6309), 1,
      sym_identifier,
    STATE(6336), 1,
      sym__name,
    STATE(6345), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3943), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [381] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_and,
    ACTIONS(6273), 1,
      anon_sym_or,
    STATE(3944), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6171), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [476] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7380), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3945), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [603] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7394), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3946), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [730] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3612), 1,
      sym__identifier_token,
    ACTIONS(3682), 1,
      anon_sym_ref,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2340), 1,
      sym_ref_type,
    STATE(2342), 1,
      sym__scoped_base_type,
    STATE(5781), 1,
      sym_identifier,
    STATE(5907), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3461), 4,
      anon_sym_COLON,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3459), 8,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(3947), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3615), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [841] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4267), 1,
      anon_sym_ref,
    ACTIONS(5858), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(3134), 1,
      sym_type,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3948), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [968] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3466), 1,
      anon_sym_ref,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3949), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [1095] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4231), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5864), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3020), 1,
      sym_type,
    STATE(3787), 1,
      sym_identifier,
    STATE(4107), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3950), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [1222] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_scoped,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3466), 1,
      anon_sym_ref,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(5841), 1,
      sym_identifier,
    STATE(6180), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3951), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [1349] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5868), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3952), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [1496] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5872), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3953), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [1643] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4217), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5788), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3428), 1,
      sym_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3954), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [1770] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5240), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3955), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [1917] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5876), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3956), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [2064] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4253), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5786), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2968), 1,
      sym_type,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3957), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2191] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(3873), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5882), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2968), 1,
      sym_type,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3958), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2318] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(3959), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [2453] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5880), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3960), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [2600] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4096), 1,
      sym__identifier_token,
    ACTIONS(4140), 1,
      anon_sym_ref,
    ACTIONS(5898), 1,
      anon_sym_scoped,
    ACTIONS(5900), 1,
      anon_sym_var,
    ACTIONS(5902), 1,
      sym_predefined_type,
    ACTIONS(6187), 1,
      anon_sym_LPAREN,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2382), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_array_type,
    STATE(2413), 1,
      sym_tuple_type,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2450), 1,
      sym__name,
    STATE(3868), 1,
      sym_type,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2411), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2428), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3961), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2727] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5888), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3962), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [2874] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5810), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3963), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [3021] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(3964), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [3158] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(3802), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5714), 1,
      anon_sym_scoped,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3365), 1,
      sym_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3965), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [3285] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(3966), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [3418] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(3967), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [3549] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4194), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5768), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3365), 1,
      sym_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3968), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [3676] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(3969), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [3815] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(3970), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [3956] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4217), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5788), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3365), 1,
      sym_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3971), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4083] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(3972), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [4228] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4255), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5928), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3020), 1,
      sym_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3973), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4355] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(6440), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3974), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4482] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(7771), 1,
      sym_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3975), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4609] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_and,
    ACTIONS(6273), 1,
      anon_sym_or,
    STATE(3976), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5480), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [4704] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4081), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5834), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3365), 1,
      sym_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3977), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4831] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6317), 1,
      anon_sym_QMARK,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(3978), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5870), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [4976] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6317), 1,
      anon_sym_QMARK,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(3979), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5238), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [5121] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4223), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5792), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3365), 1,
      sym_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3980), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5248] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(3873), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5882), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3020), 1,
      sym_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3981), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5375] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4208), 1,
      anon_sym_ref,
    ACTIONS(5912), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(3134), 1,
      sym_type,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3982), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5502] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3983), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5629] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_into,
    STATE(4085), 1,
      aux_sym__query_body_repeat2,
    STATE(3984), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6014), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [5724] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4162), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5743), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3428), 1,
      sym_type,
    STATE(4595), 1,
      sym_identifier,
    STATE(5187), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3985), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [5851] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_into,
    STATE(3984), 1,
      aux_sym__query_body_repeat2,
    STATE(3986), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6008), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [5946] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4009), 1,
      sym__identifier_token,
    ACTIONS(4013), 1,
      anon_sym_ref,
    ACTIONS(5732), 1,
      anon_sym_delegate,
    ACTIONS(5734), 1,
      anon_sym_scoped,
    ACTIONS(5736), 1,
      anon_sym_var,
    ACTIONS(5738), 1,
      sym_predefined_type,
    ACTIONS(6093), 1,
      anon_sym_LPAREN,
    STATE(4293), 1,
      sym_identifier,
    STATE(4388), 1,
      sym__reserved_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4484), 1,
      sym_array_type,
    STATE(4497), 1,
      sym__name,
    STATE(4520), 1,
      sym_tuple_type,
    STATE(4656), 1,
      sym_type,
    STATE(7286), 1,
      sym__array_base_type,
    STATE(7680), 1,
      sym__pointer_base_type,
    STATE(4398), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4407), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4519), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3987), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4011), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [6073] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4265), 1,
      anon_sym_ref,
    ACTIONS(5826), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(3134), 1,
      sym_type,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3988), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [6200] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3989), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [6327] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3990), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1231), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(1229), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [6436] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6317), 1,
      anon_sym_QMARK,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(3991), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5874), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [6581] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7712), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3992), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [6708] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7345), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3993), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [6835] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4259), 1,
      anon_sym_ref,
    ACTIONS(5945), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3062), 1,
      sym_type,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3994), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [6962] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4060), 1,
      anon_sym_ref,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(5890), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3134), 1,
      sym_type,
    STATE(4435), 1,
      sym_identifier,
    STATE(4951), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3995), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7089] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_into,
    STATE(4087), 1,
      aux_sym__query_body_repeat2,
    STATE(3996), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6014), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [7184] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7435), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3997), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7311] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4009), 1,
      sym__identifier_token,
    ACTIONS(4046), 1,
      anon_sym_ref,
    ACTIONS(5732), 1,
      anon_sym_delegate,
    ACTIONS(5736), 1,
      anon_sym_var,
    ACTIONS(5738), 1,
      sym_predefined_type,
    ACTIONS(5918), 1,
      anon_sym_scoped,
    ACTIONS(6093), 1,
      anon_sym_LPAREN,
    STATE(4293), 1,
      sym_identifier,
    STATE(4388), 1,
      sym__reserved_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4484), 1,
      sym_array_type,
    STATE(4497), 1,
      sym__name,
    STATE(4520), 1,
      sym_tuple_type,
    STATE(4656), 1,
      sym_type,
    STATE(7286), 1,
      sym__array_base_type,
    STATE(7680), 1,
      sym__pointer_base_type,
    STATE(4398), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4407), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4519), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3998), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4011), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7438] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7440), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3999), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7565] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6317), 1,
      anon_sym_QMARK,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4000), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5794), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [7710] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(6521), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4001), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7837] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7439), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4002), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7964] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4237), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5828), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3195), 1,
      sym_type,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4003), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8091] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(3793), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5760), 1,
      anon_sym_scoped,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(3362), 1,
      sym_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4004), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8218] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_into,
    STATE(4062), 1,
      aux_sym__query_body_repeat2,
    STATE(4005), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [8313] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7565), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4006), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8440] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7445), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4007), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8567] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(3620), 1,
      anon_sym_ref,
    ACTIONS(4096), 1,
      sym__identifier_token,
    ACTIONS(5900), 1,
      anon_sym_var,
    ACTIONS(5902), 1,
      sym_predefined_type,
    ACTIONS(6187), 1,
      anon_sym_LPAREN,
    ACTIONS(6227), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2398), 1,
      sym_array_type,
    STATE(2413), 1,
      sym_tuple_type,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2576), 1,
      sym_identifier,
    STATE(2635), 1,
      sym__name,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2411), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2428), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4008), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8694] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7446), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4009), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8821] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6259), 1,
      anon_sym_ref,
    ACTIONS(6263), 1,
      anon_sym_scoped,
    ACTIONS(6265), 1,
      anon_sym_var,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4530), 1,
      sym_array_type,
    STATE(6309), 1,
      sym_identifier,
    STATE(6336), 1,
      sym__name,
    STATE(6393), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4010), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8948] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4237), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5828), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(3362), 1,
      sym_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4011), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9075] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4208), 1,
      anon_sym_ref,
    ACTIONS(5912), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3062), 1,
      sym_type,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4012), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9202] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7509), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4013), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9329] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4162), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5743), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3365), 1,
      sym_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(4595), 1,
      sym_identifier,
    STATE(5187), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4014), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9456] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7572), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9583] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(3660), 1,
      anon_sym_ref,
    ACTIONS(6089), 1,
      anon_sym_scoped,
    ACTIONS(6091), 1,
      anon_sym_var,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4016), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9710] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7713), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4017), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9837] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4081), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5834), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3428), 1,
      sym_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4018), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [9964] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7584), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4019), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10091] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4229), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5830), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3195), 1,
      sym_type,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4020), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10218] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(5079), 1,
      anon_sym_ref,
    ACTIONS(5081), 1,
      anon_sym_delegate,
    ACTIONS(5087), 1,
      anon_sym_scoped,
    ACTIONS(5089), 1,
      sym_predefined_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6505), 1,
      sym__name,
    STATE(6632), 1,
      sym_tuple_type,
    STATE(6698), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7265), 1,
      sym_type,
    STATE(7522), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(7331), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4021), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10345] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(3660), 1,
      anon_sym_ref,
    ACTIONS(6089), 1,
      anon_sym_scoped,
    ACTIONS(6091), 1,
      anon_sym_var,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(6119), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4022), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10472] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7618), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4023), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10599] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4009), 1,
      sym__identifier_token,
    ACTIONS(4046), 1,
      anon_sym_ref,
    ACTIONS(5732), 1,
      anon_sym_delegate,
    ACTIONS(5736), 1,
      anon_sym_var,
    ACTIONS(5738), 1,
      sym_predefined_type,
    ACTIONS(5918), 1,
      anon_sym_scoped,
    ACTIONS(6093), 1,
      anon_sym_LPAREN,
    STATE(4293), 1,
      sym_identifier,
    STATE(4388), 1,
      sym__reserved_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4484), 1,
      sym_array_type,
    STATE(4497), 1,
      sym__name,
    STATE(4520), 1,
      sym_tuple_type,
    STATE(4538), 1,
      sym_type,
    STATE(7286), 1,
      sym__array_base_type,
    STATE(7680), 1,
      sym__pointer_base_type,
    STATE(4398), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4407), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4519), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4024), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4011), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10726] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6317), 1,
      anon_sym_QMARK,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6355), 2,
      anon_sym_ascending,
      anon_sym_descending,
    ACTIONS(6353), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4025), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [10873] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(5630), 1,
      anon_sym_ref,
    ACTIONS(5634), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4026), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11000] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(5550), 1,
      anon_sym_ref,
    ACTIONS(5558), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4027), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11127] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6357), 1,
      anon_sym_LT,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(4028), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3680), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3678), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [11222] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4223), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5792), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3428), 1,
      sym_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4029), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11349] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7472), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4030), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11476] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4267), 1,
      anon_sym_ref,
    ACTIONS(5858), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3062), 1,
      sym_type,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4031), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11603] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(5079), 1,
      anon_sym_ref,
    ACTIONS(5081), 1,
      anon_sym_delegate,
    ACTIONS(5087), 1,
      anon_sym_scoped,
    ACTIONS(5089), 1,
      sym_predefined_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6505), 1,
      sym__name,
    STATE(6632), 1,
      sym_tuple_type,
    STATE(6698), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7250), 1,
      sym_type,
    STATE(7522), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(7331), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4032), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11730] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(4194), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(5768), 1,
      anon_sym_scoped,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3428), 1,
      sym_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4033), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11857] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
    STATE(4034), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [11980] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4265), 1,
      anon_sym_ref,
    ACTIONS(5826), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3062), 1,
      sym_type,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4035), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12107] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(5081), 1,
      anon_sym_delegate,
    ACTIONS(5089), 1,
      sym_predefined_type,
    ACTIONS(5520), 1,
      anon_sym_scoped,
    ACTIONS(6041), 1,
      anon_sym_ref,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6505), 1,
      sym__name,
    STATE(6632), 1,
      sym_tuple_type,
    STATE(6698), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7265), 1,
      sym_type,
    STATE(7522), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(7331), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4036), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12234] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    STATE(4037), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [12351] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4038), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5684), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(5682), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [12464] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4039), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [12599] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4040), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [12736] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4041), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [12869] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    STATE(4042), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [12988] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4043), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13119] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7526), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4044), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [13246] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4045), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13385] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4046), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13526] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4047), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13671] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(3599), 1,
      anon_sym_ref,
    ACTIONS(4096), 1,
      sym__identifier_token,
    ACTIONS(5900), 1,
      anon_sym_var,
    ACTIONS(5902), 1,
      sym_predefined_type,
    ACTIONS(6187), 1,
      anon_sym_LPAREN,
    ACTIONS(6229), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2382), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_array_type,
    STATE(2413), 1,
      sym_tuple_type,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2450), 1,
      sym__name,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2411), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2428), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4048), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [13798] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4049), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5924), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [13907] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5852), 1,
      anon_sym_or,
    ACTIONS(6277), 1,
      anon_sym_QMARK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6311), 1,
      anon_sym_is,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4050), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [14054] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(3618), 1,
      anon_sym_ref,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(5906), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4051), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14181] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7482), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4052), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14308] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7484), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4053), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14435] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4062), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5770), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3195), 1,
      sym_type,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4054), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14562] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7698), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4055), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14689] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6213), 1,
      anon_sym_ref,
    ACTIONS(6217), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7635), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4056), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14816] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      anon_sym_var,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(3682), 1,
      anon_sym_ref,
    ACTIONS(6083), 1,
      anon_sym_scoped,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4530), 1,
      sym_array_type,
    STATE(5462), 1,
      sym_identifier,
    STATE(5785), 1,
      sym__name,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4057), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14943] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4058), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [15066] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4059), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [15183] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4060), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5684), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5682), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [15296] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6313), 1,
      anon_sym_with,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4061), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [15415] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_into,
    STATE(4091), 1,
      aux_sym__query_body_repeat2,
    STATE(4062), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [15510] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_into,
    STATE(4093), 1,
      aux_sym__query_body_repeat2,
    STATE(4063), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [15605] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4180), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5832), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3195), 1,
      sym_type,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4064), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15732] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4009), 1,
      sym__identifier_token,
    ACTIONS(4013), 1,
      anon_sym_ref,
    ACTIONS(5732), 1,
      anon_sym_delegate,
    ACTIONS(5734), 1,
      anon_sym_scoped,
    ACTIONS(5736), 1,
      anon_sym_var,
    ACTIONS(5738), 1,
      sym_predefined_type,
    ACTIONS(6093), 1,
      anon_sym_LPAREN,
    STATE(4293), 1,
      sym_identifier,
    STATE(4388), 1,
      sym__reserved_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4484), 1,
      sym_array_type,
    STATE(4497), 1,
      sym__name,
    STATE(4520), 1,
      sym_tuple_type,
    STATE(4538), 1,
      sym_type,
    STATE(7286), 1,
      sym__array_base_type,
    STATE(7680), 1,
      sym__pointer_base_type,
    STATE(4398), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4407), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4519), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4065), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4011), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15859] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4180), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5832), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(3362), 1,
      sym_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4066), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15986] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7566), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4067), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16113] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6301), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4068), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1231), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(1229), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [16222] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_and,
    STATE(4069), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6199), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16315] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(3895), 1,
      anon_sym_ref,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4072), 1,
      anon_sym_scoped,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(3134), 1,
      sym_type,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4070), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16442] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7674), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4071), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16569] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7688), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4072), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16696] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_ref,
    ACTIONS(6237), 1,
      sym__identifier_token,
    ACTIONS(6241), 1,
      anon_sym_LPAREN,
    ACTIONS(6243), 1,
      anon_sym_delegate,
    ACTIONS(6245), 1,
      anon_sym_scoped,
    ACTIONS(6247), 1,
      anon_sym_var,
    ACTIONS(6249), 1,
      sym_predefined_type,
    STATE(2602), 1,
      sym_identifier,
    STATE(2652), 1,
      sym__reserved_identifier,
    STATE(2715), 1,
      sym_array_type,
    STATE(2717), 1,
      sym_tuple_type,
    STATE(2719), 1,
      sym__name,
    STATE(2809), 1,
      sym_generic_name,
    STATE(2877), 1,
      sym_type,
    STATE(7195), 1,
      sym__array_base_type,
    STATE(7404), 1,
      sym__pointer_base_type,
    STATE(2714), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2716), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2848), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4073), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6239), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16823] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6259), 1,
      anon_sym_ref,
    ACTIONS(6263), 1,
      anon_sym_scoped,
    ACTIONS(6265), 1,
      anon_sym_var,
    STATE(2349), 1,
      sym_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4530), 1,
      sym_array_type,
    STATE(6309), 1,
      sym_identifier,
    STATE(6336), 1,
      sym__name,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4074), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16950] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4231), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5864), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2968), 1,
      sym_type,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3787), 1,
      sym_identifier,
    STATE(4107), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4075), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17077] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4096), 1,
      sym__identifier_token,
    ACTIONS(4100), 1,
      anon_sym_ref,
    ACTIONS(5900), 1,
      anon_sym_var,
    ACTIONS(5902), 1,
      sym_predefined_type,
    ACTIONS(5908), 1,
      anon_sym_scoped,
    ACTIONS(6187), 1,
      anon_sym_LPAREN,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2382), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_array_type,
    STATE(2413), 1,
      sym_tuple_type,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2450), 1,
      sym__name,
    STATE(3868), 1,
      sym_type,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2411), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2428), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4076), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17204] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4062), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5770), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(3362), 1,
      sym_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4077), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17331] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4060), 1,
      anon_sym_ref,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(5890), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(3062), 1,
      sym_type,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(4435), 1,
      sym_identifier,
    STATE(4951), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4078), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17458] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(5550), 1,
      anon_sym_ref,
    ACTIONS(5558), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(6415), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4079), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17585] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    ACTIONS(3802), 1,
      anon_sym_ref,
    ACTIONS(5712), 1,
      anon_sym_delegate,
    ACTIONS(5714), 1,
      anon_sym_scoped,
    ACTIONS(5716), 1,
      anon_sym_var,
    ACTIONS(5718), 1,
      sym_predefined_type,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3194), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3355), 1,
      sym_array_type,
    STATE(3366), 1,
      sym_tuple_type,
    STATE(3428), 1,
      sym_type,
    STATE(3482), 1,
      sym__name,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7576), 1,
      sym__pointer_base_type,
    STATE(3339), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3344), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3363), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4080), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17712] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4096), 1,
      sym__identifier_token,
    ACTIONS(4140), 1,
      anon_sym_ref,
    ACTIONS(5898), 1,
      anon_sym_scoped,
    ACTIONS(5900), 1,
      anon_sym_var,
    ACTIONS(5902), 1,
      sym_predefined_type,
    ACTIONS(6187), 1,
      anon_sym_LPAREN,
    STATE(2349), 1,
      sym_type,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2382), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_array_type,
    STATE(2413), 1,
      sym_tuple_type,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2450), 1,
      sym__name,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2411), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2428), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4081), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17839] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4257), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5780), 1,
      anon_sym_scoped,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3020), 1,
      sym_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4082), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17966] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(4259), 1,
      anon_sym_ref,
    ACTIONS(5945), 1,
      anon_sym_scoped,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(3134), 1,
      sym_type,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4083), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18093] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7436), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4084), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18220] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6359), 1,
      anon_sym_into,
    STATE(4085), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6018), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18313] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1507), 1,
      anon_sym_LBRACE,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    STATE(2969), 1,
      sym_argument_list,
    STATE(3106), 1,
      sym_initializer_expression,
    STATE(4086), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4815), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4811), 29,
      anon_sym_LBRACK,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18412] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_into,
    STATE(4085), 1,
      aux_sym__query_body_repeat2,
    STATE(4087), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6025), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18507] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4096), 1,
      sym__identifier_token,
    ACTIONS(4100), 1,
      anon_sym_ref,
    ACTIONS(5900), 1,
      anon_sym_var,
    ACTIONS(5902), 1,
      sym_predefined_type,
    ACTIONS(5908), 1,
      anon_sym_scoped,
    ACTIONS(6187), 1,
      anon_sym_LPAREN,
    STATE(2349), 1,
      sym_type,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2382), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_array_type,
    STATE(2413), 1,
      sym_tuple_type,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2450), 1,
      sym__name,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2411), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2428), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4088), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18634] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4257), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5780), 1,
      anon_sym_scoped,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2968), 1,
      sym_type,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4089), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18761] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    ACTIONS(3895), 1,
      anon_sym_ref,
    ACTIONS(4070), 1,
      anon_sym_delegate,
    ACTIONS(4072), 1,
      anon_sym_scoped,
    ACTIONS(4074), 1,
      anon_sym_var,
    ACTIONS(4076), 1,
      sym_predefined_type,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2988), 1,
      sym_identifier,
    STATE(3062), 1,
      sym_type,
    STATE(3088), 1,
      sym_array_type,
    STATE(3093), 1,
      sym_tuple_type,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3131), 1,
      sym__name,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7463), 1,
      sym__pointer_base_type,
    STATE(3072), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3082), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3090), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4090), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18888] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_into,
    STATE(4091), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [18981] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4253), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5786), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3020), 1,
      sym_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4092), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19108] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_into,
    STATE(4091), 1,
      aux_sym__query_body_repeat2,
    STATE(4093), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [19203] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4916), 1,
      anon_sym_LBRACK,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_QMARK,
    STATE(3101), 1,
      sym_initializer_expression,
    STATE(4094), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4926), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4920), 30,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19302] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(5550), 1,
      anon_sym_ref,
    ACTIONS(5558), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(6440), 1,
      sym_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4095), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19429] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4096), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(5924), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [19538] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(4229), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(5830), 1,
      anon_sym_scoped,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(3362), 1,
      sym_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4097), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19665] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3461), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(3630), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_GT,
    STATE(4098), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3459), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(3633), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [19760] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3789), 1,
      sym__identifier_token,
    ACTIONS(3793), 1,
      anon_sym_ref,
    ACTIONS(5758), 1,
      anon_sym_delegate,
    ACTIONS(5760), 1,
      anon_sym_scoped,
    ACTIONS(5762), 1,
      anon_sym_var,
    ACTIONS(5764), 1,
      sym_predefined_type,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_identifier,
    STATE(3171), 1,
      sym__reserved_identifier,
    STATE(3190), 1,
      sym__name,
    STATE(3195), 1,
      sym_type,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3234), 1,
      sym_array_type,
    STATE(3242), 1,
      sym_tuple_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7595), 1,
      sym__pointer_base_type,
    STATE(3204), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3233), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3238), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4099), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3791), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19887] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7389), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4100), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20014] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5700), 1,
      anon_sym_switch,
    ACTIONS(5704), 1,
      anon_sym_with,
    ACTIONS(5975), 1,
      anon_sym_as,
    ACTIONS(6317), 1,
      anon_sym_QMARK,
    ACTIONS(6323), 1,
      anon_sym_SLASH,
    ACTIONS(6325), 1,
      anon_sym_CARET,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_AMP,
    ACTIONS(6333), 1,
      anon_sym_GT_GT,
    ACTIONS(6339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6345), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6347), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6319), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6321), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6335), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6337), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4101), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5866), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [20159] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3025), 1,
      sym_predefined_type,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6091), 1,
      anon_sym_var,
    ACTIONS(6251), 1,
      anon_sym_ref,
    ACTIONS(6255), 1,
      anon_sym_scoped,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4360), 1,
      sym_tuple_type,
    STATE(4414), 1,
      sym__name,
    STATE(4530), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7400), 1,
      sym_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(2337), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4355), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4102), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20286] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    ACTIONS(4255), 1,
      anon_sym_ref,
    ACTIONS(5778), 1,
      anon_sym_delegate,
    ACTIONS(5782), 1,
      anon_sym_var,
    ACTIONS(5784), 1,
      sym_predefined_type,
    ACTIONS(5928), 1,
      anon_sym_scoped,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2968), 1,
      sym_type,
    STATE(2979), 1,
      sym_array_type,
    STATE(2987), 1,
      sym_tuple_type,
    STATE(3270), 1,
      sym_identifier,
    STATE(3584), 1,
      sym__name,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7662), 1,
      sym__pointer_base_type,
    STATE(2966), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2983), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2992), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4103), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20413] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4104), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [20557] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4105), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [20697] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4106), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [20841] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_STAR,
    ACTIONS(4949), 1,
      anon_sym_QMARK,
    ACTIONS(6439), 1,
      anon_sym_DOT,
    STATE(4107), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4024), 30,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20939] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6439), 1,
      anon_sym_DOT,
    STATE(4108), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4028), 32,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21031] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4109), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [21147] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4110), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [21291] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4111), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [21435] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4112), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4121), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4119), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [21525] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4113), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [21637] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4114), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [21771] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4115), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [21907] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4116), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4879), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4875), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [22013] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4117), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1231), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(1229), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [22121] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6441), 1,
      anon_sym_and,
    ACTIONS(6443), 1,
      anon_sym_or,
    STATE(4118), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 31,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [22215] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4119), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [22323] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4120), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [22453] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4121), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [22597] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4122), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [22731] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4123), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3722), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3711), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [22821] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4124), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [22957] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4125), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [23089] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4126), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3676), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3674), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [23179] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4127), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3668), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3666), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [23269] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4128), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [23401] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3615), 1,
      anon_sym_where,
    ACTIONS(5550), 1,
      anon_sym_ref,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2340), 1,
      sym_ref_type,
    STATE(2342), 1,
      sym__scoped_base_type,
    STATE(4540), 1,
      sym_identifier,
    STATE(5169), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4129), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3459), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(29), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [23511] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4130), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3686), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3684), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [23601] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4131), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [23719] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3461), 1,
      anon_sym_COLON,
    ACTIONS(3615), 1,
      anon_sym_where,
    ACTIONS(6259), 1,
      anon_sym_ref,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2340), 1,
      sym_ref_type,
    STATE(2342), 1,
      sym__scoped_base_type,
    STATE(6340), 1,
      sym_identifier,
    STATE(6389), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4132), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3459), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(29), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [23831] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4133), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [23961] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4134), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4887), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4885), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [24067] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4135), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3680), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3678), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [24157] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4136), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4910), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4908), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [24263] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_or,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6445), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4137), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [24409] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4138), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5924), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [24517] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    STATE(4139), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5455), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(3881), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24609] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4140), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [24747] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4141), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [24855] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4142), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [24995] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5810), 1,
      anon_sym_or,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6445), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4143), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [25141] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(4144), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3680), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(3678), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [25237] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4145), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [25381] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4146), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [25525] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6447), 1,
      anon_sym_into,
    STATE(4149), 1,
      aux_sym__query_body_repeat2,
    STATE(4147), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6014), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25619] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6447), 1,
      anon_sym_into,
    STATE(4150), 1,
      aux_sym__query_body_repeat2,
    STATE(4148), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6014), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25713] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6449), 1,
      anon_sym_into,
    STATE(4149), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6018), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25805] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6447), 1,
      anon_sym_into,
    STATE(4149), 1,
      aux_sym__query_body_repeat2,
    STATE(4150), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6025), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25899] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5852), 1,
      anon_sym_or,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6445), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4151), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [26045] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6441), 1,
      anon_sym_and,
    ACTIONS(6443), 1,
      anon_sym_or,
    STATE(4152), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 31,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [26139] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4153), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [26283] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4154), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [26405] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6447), 1,
      anon_sym_into,
    STATE(4147), 1,
      aux_sym__query_body_repeat2,
    STATE(4155), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6008), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [26499] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4156), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [26621] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4157), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [26737] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5872), 1,
      anon_sym_or,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6445), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4158), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [26883] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4159), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5684), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5682), 22,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [26995] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6437), 1,
      anon_sym_with,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4160), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [27113] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6441), 1,
      anon_sym_and,
    STATE(4161), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [27205] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4162), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3672), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(3670), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [27295] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5240), 1,
      anon_sym_or,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6445), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4163), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [27441] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4164), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [27579] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5876), 1,
      anon_sym_or,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6435), 1,
      anon_sym_is,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6445), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4165), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [27725] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6367), 1,
      anon_sym_QMARK,
    ACTIONS(6373), 1,
      anon_sym_SLASH,
    ACTIONS(6375), 1,
      anon_sym_CARET,
    ACTIONS(6377), 1,
      anon_sym_PIPE,
    ACTIONS(6379), 1,
      anon_sym_AMP,
    ACTIONS(6383), 1,
      anon_sym_GT_GT,
    ACTIONS(6389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6399), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4166), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [27869] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6452), 1,
      anon_sym_and,
    ACTIONS(6454), 1,
      anon_sym_or,
    STATE(4167), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [27962] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4168), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5405), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5403), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28051] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4169), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [28194] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4170), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5413), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5411), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28283] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4171), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5409), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5407), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28372] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4172), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [28479] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4173), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [28622] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4174), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5480), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28711] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6490), 1,
      anon_sym_into,
    STATE(4175), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [28802] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_into,
    STATE(4175), 1,
      aux_sym__query_body_repeat2,
    STATE(4176), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [28895] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6452), 1,
      anon_sym_and,
    STATE(4177), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6199), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28986] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4178), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [29093] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4179), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5439), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5437), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [29182] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4180), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [29311] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_into,
    STATE(4196), 1,
      aux_sym__query_body_repeat2,
    STATE(4181), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [29404] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4182), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [29547] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4183), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [29684] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4184), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [29823] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4185), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [29966] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4186), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5421), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [30055] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4187), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [30198] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(6213), 1,
      anon_sym_ref,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2340), 1,
      sym_ref_type,
    STATE(2342), 1,
      sym__scoped_base_type,
    STATE(4540), 1,
      sym_identifier,
    STATE(5169), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4188), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3459), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30305] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4189), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5431), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5429), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [30394] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6495), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4190), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [30537] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4191), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3699), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(3697), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [30626] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4192), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [30743] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4193), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5486), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5484), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [30832] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4194), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [30963] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4195), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [31084] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_into,
    STATE(4175), 1,
      aux_sym__query_body_repeat2,
    STATE(4196), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [31177] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_into,
    STATE(4176), 1,
      aux_sym__query_body_repeat2,
    STATE(4197), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [31270] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4198), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [31413] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4199), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [31528] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4200), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5447), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5445), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [31617] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4201), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5498), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5496), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [31706] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4303), 1,
      anon_sym_or,
    ACTIONS(4295), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4202), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5503), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5500), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [31799] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4203), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5514), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5512), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [31888] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4204), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 22,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [31999] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4205), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5455), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(3881), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32088] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4206), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5490), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5488), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32177] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4303), 1,
      anon_sym_or,
    ACTIONS(4295), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4207), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5509), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5506), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32270] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4208), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [32403] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4209), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5419), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5417), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32492] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4210), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5419), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5417), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32581] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6452), 1,
      anon_sym_and,
    ACTIONS(6454), 1,
      anon_sym_or,
    STATE(4211), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32674] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4212), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5443), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5441), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32763] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4213), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5435), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5433), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [32852] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4214), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [32995] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4215), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5453), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5451), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [33084] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4216), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5427), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5425), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [33173] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4217), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5390), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5388), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [33262] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4218), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [33397] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4219), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5390), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5388), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [33486] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6309), 1,
      anon_sym_as,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
    ACTIONS(6464), 1,
      anon_sym_SLASH,
    ACTIONS(6466), 1,
      anon_sym_CARET,
    ACTIONS(6468), 1,
      anon_sym_PIPE,
    ACTIONS(6470), 1,
      anon_sym_AMP,
    ACTIONS(6474), 1,
      anon_sym_GT_GT,
    ACTIONS(6480), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6484), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6488), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6460), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6462), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6472), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6476), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6478), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4220), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [33629] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4221), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [33745] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(4767), 1,
      anon_sym_var,
    ACTIONS(6509), 1,
      sym_predefined_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6683), 1,
      sym__name,
    STATE(6783), 1,
      sym_tuple_type,
    STATE(6850), 1,
      sym_array_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7413), 1,
      sym__ref_base_type,
    STATE(7424), 1,
      sym_implicit_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6851), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4222), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33865] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4223), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [34007] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4224), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [34139] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4225), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [34281] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4226), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [34423] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4227), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [34529] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4228), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [34639] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6569), 1,
      anon_sym_QMARK,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4229), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [34781] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6569), 1,
      anon_sym_QMARK,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4230), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [34923] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4231), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [35065] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4232), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [35199] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4233), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [35329] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6597), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4234), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [35471] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4235), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [35577] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_and,
    STATE(4236), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6199), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [35667] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6601), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4237), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [35809] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4238), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [35929] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6569), 1,
      anon_sym_QMARK,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4239), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [36071] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4240), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [36187] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4241), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [36301] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4242), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [36429] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6603), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4243), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [36571] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4244), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [36707] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4245), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [36839] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4246), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [36977] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4247), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [37111] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4248), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [37253] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    STATE(4389), 1,
      sym_argument_list,
    STATE(4651), 1,
      sym_initializer_expression,
    STATE(4249), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4815), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4811), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [37349] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4250), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [37491] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4251), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4148), 14,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_EQ_GT,
    ACTIONS(4146), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [37579] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6617), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4252), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [37721] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4253), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [37827] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4254), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [37947] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4255), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [38089] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_and,
    ACTIONS(6619), 1,
      anon_sym_or,
    STATE(4256), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [38181] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4257), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [38311] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4258), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [38453] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_into,
    STATE(4267), 1,
      aux_sym__query_body_repeat2,
    STATE(4259), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [38545] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4260), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [38683] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4261), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [38799] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4262), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [38927] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4263), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [39063] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4264), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [39201] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4265), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [39343] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6569), 1,
      anon_sym_QMARK,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4266), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [39485] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_into,
    STATE(4280), 1,
      aux_sym__query_body_repeat2,
    STATE(4267), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [39577] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_into,
    STATE(4283), 1,
      aux_sym__query_body_repeat2,
    STATE(4268), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [39669] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4269), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [39811] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6569), 1,
      anon_sym_QMARK,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4270), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [39953] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4271), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [40067] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_and,
    ACTIONS(6619), 1,
      anon_sym_or,
    STATE(4272), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [40159] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4273), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [40301] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4274), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [40443] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4275), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [40557] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4276), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [40667] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6513), 1,
      anon_sym_QMARK,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6541), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4277), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [40809] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5500), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4278), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [40901] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4279), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [41011] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_into,
    STATE(4280), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [41101] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4281), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [41243] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4282), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [41385] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_into,
    STATE(4280), 1,
      aux_sym__query_body_repeat2,
    STATE(4283), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [41477] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4284), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [41605] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6565), 1,
      anon_sym_is,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6609), 1,
      anon_sym_QMARK,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4285), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [41747] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6569), 1,
      anon_sym_QMARK,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6593), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4286), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [41889] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4287), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [41995] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4288), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [42127] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6563), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4289), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [42233] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6523), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4290), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [42369] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6505), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4291), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [42475] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4292), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [42605] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym_LT,
    ACTIONS(6629), 1,
      anon_sym_COLON_COLON,
    STATE(4401), 1,
      sym_type_argument_list,
    STATE(4293), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 11,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3680), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [42699] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4294), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [42819] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6433), 1,
      anon_sym_as,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6519), 1,
      anon_sym_SLASH,
    ACTIONS(6521), 1,
      anon_sym_CARET,
    ACTIONS(6525), 1,
      anon_sym_AMP,
    ACTIONS(6529), 1,
      anon_sym_GT_GT,
    ACTIONS(6535), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6543), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6511), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6517), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6527), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6531), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6533), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4295), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [42953] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5506), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4296), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5171), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [43045] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_EQ,
    ACTIONS(3459), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(3630), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    STATE(4297), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3633), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [43137] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4298), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [43264] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5870), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4299), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [43405] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6677), 1,
      anon_sym_LBRACK,
    ACTIONS(6679), 1,
      sym_predefined_type,
    STATE(3227), 1,
      sym_array_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7263), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(7207), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4300), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43520] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4301), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [43639] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4302), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 22,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [43744] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    ACTIONS(6693), 1,
      anon_sym_LBRACK,
    STATE(3169), 1,
      sym_array_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7245), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(7207), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4303), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43859] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_QMARK,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4304), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [44000] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4305), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [44119] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(5079), 1,
      anon_sym_ref,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6914), 1,
      sym__name,
    STATE(7191), 1,
      sym_ref_type,
    STATE(7343), 1,
      sym__scoped_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3459), 8,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(4306), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44224] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4307), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [44351] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4308), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [44486] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5874), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4309), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [44627] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4310), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [44736] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5794), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4311), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [44877] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4312), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [44982] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4313), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [45119] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_QMARK,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4314), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [45260] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4315), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [45389] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4316), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3461), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3459), 30,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [45476] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4317), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [45617] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4318), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3662), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3664), 30,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [45704] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(6041), 1,
      anon_sym_ref,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6914), 1,
      sym__name,
    STATE(7191), 1,
      sym_ref_type,
    STATE(7343), 1,
      sym__scoped_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3459), 8,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(4319), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45809] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_QMARK,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4320), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [45950] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(4321), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [46081] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4322), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [46194] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    ACTIONS(4891), 1,
      anon_sym_LBRACK,
    STATE(4653), 1,
      sym_initializer_expression,
    STATE(4323), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4894), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4889), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [46287] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5850), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4324), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [46428] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4325), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [46559] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6737), 1,
      anon_sym_QMARK,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4326), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [46700] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4327), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [46833] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4328), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [46948] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4329), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 22,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [47053] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4330), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [47182] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6737), 1,
      anon_sym_QMARK,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4331), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [47323] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6737), 1,
      anon_sym_QMARK,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4332), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [47464] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    ACTIONS(6751), 1,
      anon_sym_LBRACK,
    STATE(3607), 1,
      sym_array_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7243), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(7207), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4333), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47579] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4334), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4144), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4142), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [47666] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4335), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [47793] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4336), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 22,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [47898] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4337), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4108), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4106), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [47985] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4338), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [48098] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4339), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [48231] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6659), 1,
      anon_sym_with,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4340), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [48350] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6659), 1,
      anon_sym_with,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4341), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [48463] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6737), 1,
      anon_sym_QMARK,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4342), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [48604] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    ACTIONS(6753), 1,
      anon_sym_LBRACK,
    STATE(2943), 1,
      sym_array_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7132), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(7207), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4343), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48719] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6659), 1,
      anon_sym_with,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4344), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [48828] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4345), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48957] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6659), 1,
      anon_sym_with,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4346), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [49072] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4347), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [49177] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4348), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4156), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4154), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [49264] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4349), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [49399] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4350), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [49508] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5238), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4351), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [49649] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4352), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [49786] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    STATE(4650), 1,
      sym_initializer_expression,
    STATE(4353), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4873), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4871), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [49877] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4354), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [50018] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    STATE(4355), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4024), 11,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
    ACTIONS(4022), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [50109] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4356), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [50240] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5886), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4357), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [50381] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    ACTIONS(6759), 1,
      anon_sym_LBRACK,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(4323), 1,
      sym_array_type,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7286), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(7207), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4358), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50496] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4359), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [50629] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    STATE(4360), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4024), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_EQ_GT,
    ACTIONS(4022), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [50722] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6737), 1,
      anon_sym_QMARK,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4361), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [50863] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4887), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4362), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4885), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [50966] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4910), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4363), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4908), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [51069] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_into,
    STATE(4365), 1,
      aux_sym__query_body_repeat2,
    STATE(4364), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [51160] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_into,
    STATE(4367), 1,
      aux_sym__query_body_repeat2,
    STATE(4365), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [51251] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_into,
    STATE(4368), 1,
      aux_sym__query_body_repeat2,
    STATE(4366), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [51342] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6765), 1,
      anon_sym_into,
    STATE(4367), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [51431] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_into,
    STATE(4367), 1,
      aux_sym__query_body_repeat2,
    STATE(4368), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [51522] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6691), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6735), 1,
      anon_sym_is,
    ACTIONS(6737), 1,
      anon_sym_QMARK,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4369), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [51663] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4879), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4370), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4875), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [51766] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4371), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [51881] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_QMARK,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4372), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [52022] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4373), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 22,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [52127] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3459), 1,
      anon_sym_COLON_COLON,
    STATE(4374), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3633), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3630), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [52216] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4375), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [52351] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4376), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [52488] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4916), 1,
      anon_sym_LBRACK,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    STATE(3107), 1,
      sym_initializer_expression,
    STATE(4377), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4920), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [52583] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4916), 1,
      anon_sym_LBRACK,
    ACTIONS(6768), 1,
      anon_sym_LBRACE,
    ACTIONS(6771), 1,
      anon_sym_QMARK,
    STATE(4652), 1,
      sym_initializer_expression,
    STATE(4378), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4920), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [52678] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4379), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [52819] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    ACTIONS(6775), 1,
      anon_sym_LBRACK,
    STATE(2977), 1,
      sym_array_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7190), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(7207), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4380), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52934] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_QMARK,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4381), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [53075] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym_LT,
    STATE(4401), 1,
      sym_type_argument_list,
    STATE(4382), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 10,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3680), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [53166] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(6697), 1,
      anon_sym_QMARK,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6727), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4383), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [53307] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5866), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4384), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [53448] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4385), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4152), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4150), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [53535] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6653), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6657), 1,
      anon_sym_is,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6661), 1,
      anon_sym_QMARK,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5878), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4386), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [53676] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4387), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3461), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3459), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [53763] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4388), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3662), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3664), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [53850] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    STATE(4668), 1,
      sym_initializer_expression,
    STATE(4389), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4906), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4904), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [53941] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4390), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [54067] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4391), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [54207] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4392), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [54347] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4393), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [54487] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4394), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [54627] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4395), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4941), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4939), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [54713] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4396), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [54841] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4397), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [54975] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4398), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3711), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3722), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55061] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6913), 1,
      sym_string_literal_encoding,
    STATE(4399), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4954), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4952), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55149] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4400), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [55283] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4401), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3666), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3668), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55369] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6915), 1,
      anon_sym_and,
    ACTIONS(6917), 1,
      anon_sym_or,
    STATE(4402), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55459] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6919), 1,
      sym_string_literal_encoding,
    STATE(4403), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4969), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4967), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55547] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4404), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4052), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4054), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55633] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4405), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4106), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4108), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55719] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6921), 1,
      anon_sym_and,
    ACTIONS(6923), 1,
      anon_sym_or,
    STATE(4406), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55809] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4407), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4024), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [55895] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4408), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [56035] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4409), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4038), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4040), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [56121] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4410), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [56261] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4411), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [56401] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4412), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [56541] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4413), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [56681] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(4024), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(4414), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [56775] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(4415), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3680), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(3678), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [56865] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4416), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [56969] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4417), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4960), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4958), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [57055] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4418), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [57195] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4419), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3680), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [57281] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4420), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [57421] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6931), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5870), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4421), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [57561] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(5836), 1,
      sym_attribute_target_specifier,
    STATE(6529), 1,
      sym__name,
    STATE(7003), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1053), 8,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
      anon_sym_typevar,
    STATE(4422), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [57663] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4423), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [57793] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4424), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [57925] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4425), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [58053] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4426), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [58179] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6931), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5874), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4427), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [58319] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4428), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [58453] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4429), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [58589] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4430), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [58725] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4431), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [58865] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4432), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [59005] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4433), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [59145] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4434), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [59285] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4962), 1,
      anon_sym_LT,
    ACTIONS(6933), 1,
      anon_sym_COLON_COLON,
    STATE(3027), 1,
      sym_type_argument_list,
    STATE(4435), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 11,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3680), 26,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [59377] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4436), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [59517] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4437), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [59605] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(4438), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5171), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [59693] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4776), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym_LBRACK,
    ACTIONS(6938), 1,
      aux_sym_preproc_if_token1,
    STATE(5406), 1,
      sym__attribute_list,
    STATE(5405), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(4439), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__class_declaration_initializer_repeat1,
    ACTIONS(4771), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [59787] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4440), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [59927] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4441), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4018), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4020), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60013] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4442), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3684), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3686), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60099] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4443), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [60239] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6931), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5866), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4444), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [60379] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    STATE(4445), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5455), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3881), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60467] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4446), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [60575] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4447), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4048), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4050), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60661] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4448), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4119), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4121), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60747] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6040), 1,
      sym_array_type,
    STATE(6045), 1,
      sym_nullable_type,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(7207), 2,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4449), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [60861] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4450), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4142), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4144), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60947] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4451), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [61087] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4452), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [61227] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(6977), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7468), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4453), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [61373] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(6979), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7461), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4454), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [61519] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4455), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [61659] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4456), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 21,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [61763] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(6981), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7367), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4457), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [61909] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4458), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [62027] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4459), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3697), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3699), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62113] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6931), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5850), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4460), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [62253] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6921), 1,
      anon_sym_and,
    STATE(4461), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 28,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62341] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    ACTIONS(6925), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4462), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [62481] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4463), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [62585] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4464), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [62725] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4465), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4030), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4032), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62811] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4466), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4146), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4148), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62897] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4467), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [63015] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4468), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [63127] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4469), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [63235] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(5831), 1,
      sym_attribute_target_specifier,
    STATE(6529), 1,
      sym__name,
    STATE(7041), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1053), 8,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
      anon_sym_typevar,
    STATE(4470), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [63337] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4471), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [63467] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(5833), 1,
      sym_attribute_target_specifier,
    STATE(6529), 1,
      sym__name,
    STATE(6815), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1053), 8,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
      anon_sym_typevar,
    STATE(4472), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [63569] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4473), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [63695] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6881), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6891), 1,
      anon_sym_PIPE,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6907), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6909), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(4474), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [63835] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4475), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [63971] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4476), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [64111] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(6983), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7541), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4477), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [64257] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4478), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4935), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4933), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64343] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4479), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [64461] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4480), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [64573] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(3549), 1,
      sym_identifier,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3911), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4481), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [64685] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4482), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [64799] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4483), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3670), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3672), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64885] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(6991), 1,
      anon_sym_QMARK,
    STATE(4484), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4024), 28,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64975] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4485), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 21,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [65079] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6931), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5238), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4486), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [65219] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(5832), 1,
      sym_attribute_target_specifier,
    STATE(6529), 1,
      sym__name,
    STATE(6961), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1053), 8,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
      anon_sym_typevar,
    STATE(4487), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [65321] = 44,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6994), 1,
      anon_sym_COLON,
    ACTIONS(6996), 1,
      anon_sym_COMMA,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    ACTIONS(7032), 1,
      sym_interpolation_close_brace,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    STATE(7038), 1,
      sym_interpolation_alignment_clause,
    STATE(7544), 1,
      sym_interpolation_format_clause,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4488), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [65469] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6931), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5794), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(4489), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [65609] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7034), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7562), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4490), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [65755] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(3005), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_delegate,
    ACTIONS(6679), 1,
      sym_predefined_type,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4144), 1,
      sym_identifier,
    STATE(6020), 1,
      sym_array_type,
    STATE(6027), 1,
      sym_nullable_type,
    STATE(6706), 1,
      sym__name,
    STATE(6892), 1,
      sym_tuple_type,
    STATE(7210), 1,
      sym__array_base_type,
    STATE(7752), 1,
      sym__pointer_base_type,
    STATE(7207), 2,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4491), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [65869] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4492), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 21,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [65973] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4493), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [66085] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4494), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [66193] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(6251), 1,
      anon_sym_ref,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2340), 1,
      sym_ref_type,
    STATE(2342), 1,
      sym__scoped_base_type,
    STATE(4540), 1,
      sym_identifier,
    STATE(5169), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3459), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(4495), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [66297] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4496), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 21,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [66401] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_STAR,
    ACTIONS(6991), 1,
      anon_sym_QMARK,
    ACTIONS(7036), 1,
      anon_sym_DOT,
    ACTIONS(4022), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4497), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4024), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [66495] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4498), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3947), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3949), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [66581] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4499), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [66689] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4500), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [66819] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4501), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [66951] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4502), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [67081] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4503), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4150), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4152), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [67167] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4504), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 21,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [67271] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6915), 1,
      anon_sym_and,
    ACTIONS(6917), 1,
      anon_sym_or,
    STATE(4505), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [67361] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4506), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4028), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [67447] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4507), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [67581] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4508), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4034), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4036), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [67667] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4509), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [67781] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6889), 1,
      anon_sym_CARET,
    ACTIONS(6893), 1,
      anon_sym_AMP,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4510), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [67913] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6791), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(6795), 1,
      anon_sym_is,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5682), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4511), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [68049] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7038), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7597), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4512), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [68195] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4513), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [68327] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4514), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [68467] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4515), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3674), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3676), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [68553] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4516), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [68681] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(5840), 1,
      sym_attribute_target_specifier,
    STATE(6529), 1,
      sym__name,
    STATE(7092), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1053), 8,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
      anon_sym_typevar,
    STATE(4517), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [68783] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6897), 1,
      anon_sym_GT_GT,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6911), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6879), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6895), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6901), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4518), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [68911] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_STAR,
    STATE(4519), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4024), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69001] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_STAR,
    ACTIONS(6991), 1,
      anon_sym_QMARK,
    STATE(4520), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4024), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69093] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6921), 1,
      anon_sym_and,
    ACTIONS(6923), 1,
      anon_sym_or,
    STATE(4521), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69183] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7040), 1,
      anon_sym_into,
    STATE(4523), 1,
      aux_sym__query_body_repeat2,
    STATE(4522), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69273] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7040), 1,
      anon_sym_into,
    STATE(4525), 1,
      aux_sym__query_body_repeat2,
    STATE(4523), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69363] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7040), 1,
      anon_sym_into,
    STATE(4526), 1,
      aux_sym__query_body_repeat2,
    STATE(4524), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69453] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_into,
    STATE(4525), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69541] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7040), 1,
      anon_sym_into,
    STATE(4525), 1,
      aux_sym__query_body_repeat2,
    STATE(4526), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69631] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7036), 1,
      anon_sym_DOT,
    STATE(4527), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4028), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69719] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6843), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4528), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [69845] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4529), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [69963] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    STATE(4530), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4024), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_EQ_GT,
    ACTIONS(4022), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [70053] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6841), 1,
      anon_sym_as,
    ACTIONS(6847), 1,
      anon_sym_QMARK,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6877), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4531), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [70193] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4532), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [70305] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6833), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4533), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 21,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [70409] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6887), 1,
      anon_sym_SLASH,
    ACTIONS(6903), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6883), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4534), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [70523] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6869), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4535), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [70637] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7045), 1,
      aux_sym_raw_string_literal_token1,
    STATE(4536), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4945), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4943), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [70725] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4537), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4154), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4156), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [70811] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4538), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4042), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4044), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [70897] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5630), 1,
      anon_sym_ref,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2340), 1,
      sym_ref_type,
    STATE(2342), 1,
      sym__scoped_base_type,
    STATE(4540), 1,
      sym_identifier,
    STATE(5169), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3459), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(4539), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [71001] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    STATE(4540), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [71093] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2699), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2701), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7049), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(7402), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(4541), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [71239] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6915), 1,
      anon_sym_and,
    STATE(4542), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [71327] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4543), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [71434] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_QMARK,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4544), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [71573] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4545), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [71702] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4546), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [71833] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4547), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [71960] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4548), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [72085] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4549), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [72188] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4550), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [72321] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4551), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [72456] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4552), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [72595] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_QMARK,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4553), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [72734] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_QMARK,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4554), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [72873] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_QMARK,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4555), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73012] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_QMARK,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4556), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73151] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(4557), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73280] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(4558), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73411] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(4559), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73538] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4560), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
  [73663] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(4561), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73796] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(4562), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [73931] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4563), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [74070] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7153), 1,
      anon_sym_SEMI,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4564), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [74211] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_and,
    ACTIONS(7189), 1,
      anon_sym_or,
    STATE(4565), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 26,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [74300] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4566), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5503), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5500), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [74387] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4567), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5509), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5506), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [74474] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4568), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [74613] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(7191), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(7193), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(7195), 1,
      aux_sym_preproc_elif_token1,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5844), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5878), 1,
      sym_attribute_list,
    STATE(5983), 1,
      sym_preproc_if_in_attribute_list,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(6681), 1,
      sym_enum_member_declaration,
    STATE(6773), 1,
      sym_identifier,
    STATE(7737), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(7770), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(4569), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [74726] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4570), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [74843] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4571), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [74954] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4572), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [75067] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4573), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2977), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2979), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75152] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4574), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [75269] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4575), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [75380] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4576), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [75509] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4577), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [75640] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7217), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4578), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [75767] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4579), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [75880] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7217), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4580), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [76005] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4581), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [76138] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4582), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [76273] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4583), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [76412] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4584), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [76551] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4585), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [76654] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4586), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [76793] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4587), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [76932] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4588), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [77071] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4589), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [77210] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4590), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [77313] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4591), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2977), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2979), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [77398] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4809), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4592), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4807), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [77483] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(4160), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4024), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(4593), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [77576] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4594), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3165), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3167), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [77661] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_LT,
    ACTIONS(7231), 1,
      anon_sym_COLON_COLON,
    STATE(3349), 1,
      sym_type_argument_list,
    STATE(4595), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 10,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3680), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [77752] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4835), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4596), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4833), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [77837] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6481), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3911), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(4597), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [77948] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4598), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [78033] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5500), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(4295), 4,
      anon_sym_RPAREN,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4599), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [78122] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4600), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [78239] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4601), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [78350] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4602), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [78463] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4603), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [78566] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5506), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(4295), 4,
      anon_sym_RPAREN,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4604), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5171), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [78655] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7245), 1,
      anon_sym_COLON,
    ACTIONS(7247), 1,
      anon_sym_COMMA,
    ACTIONS(7249), 1,
      anon_sym_RBRACE,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6930), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4605), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [78800] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_and,
    ACTIONS(7189), 1,
      anon_sym_or,
    STATE(4606), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 26,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [78889] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4607), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3949), 11,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
    ACTIONS(3947), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [78974] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4608), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [79091] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4609), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [79202] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4610), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [79309] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4611), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [79438] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4612), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [79569] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4613), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [79696] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4614), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [79809] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4615), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [79934] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4616), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [80037] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4617), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [80170] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4618), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [80305] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4619), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [80444] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4620), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [80583] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4621), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [80722] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4819), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4622), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4817), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [80807] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4623), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [80946] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4624), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [81063] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4625), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [81174] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4626), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [81287] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4627), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [81390] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4825), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4628), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4823), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [81475] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4629), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81560] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(4630), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1995), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1997), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81647] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4631), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5161), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5159), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81732] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4632), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4900), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4898), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81817] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4633), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5171), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [81902] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4634), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [82019] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4635), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [82130] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4636), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [82243] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4637), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [82346] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4638), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5181), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5179), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82431] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4639), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5189), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5187), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82516] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4640), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5197), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5195), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82601] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4641), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5199), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82686] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4642), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4981), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4979), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82771] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4643), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5205), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5203), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82856] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4644), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5209), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5207), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [82941] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4645), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2981), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2983), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83026] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4646), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5220), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5218), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83111] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4647), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4293), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4291), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83196] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4648), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5236), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5234), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83281] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4649), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5244), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5242), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83366] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4650), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5248), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5246), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83451] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4651), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5252), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5250), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83536] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4652), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5256), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5254), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83621] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4653), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5151), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5149), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83706] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4654), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4985), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4983), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83791] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4655), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5025), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5023), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83876] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4656), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5033), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5031), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [83961] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4657), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5228), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5226), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84046] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4658), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [84185] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4659), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5240), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5238), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84270] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4660), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4989), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4987), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84355] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4661), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4997), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4995), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84440] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4662), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5013), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5011), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84525] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4663), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5017), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5015), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84610] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(7193), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(7195), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(7349), 1,
      aux_sym_preproc_if_token3,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5844), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5881), 1,
      sym_attribute_list,
    STATE(5983), 1,
      sym_preproc_if_in_attribute_list,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(6563), 1,
      sym_enum_member_declaration,
    STATE(6773), 1,
      sym_identifier,
    STATE(7353), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(7758), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(4664), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [84723] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4665), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5053), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5051), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84808] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4666), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5065), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5063), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84893] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4667), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5095), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5093), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84978] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4668), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5107), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5105), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85063] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4669), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5127), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5125), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85148] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4670), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2063), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2061), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85233] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4671), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5165), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5163), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85318] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4672), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5169), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5167), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85403] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4673), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5177), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5175), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85488] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4674), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5185), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5183), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85573] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4675), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4977), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4975), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85658] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4676), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [85797] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4677), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [85900] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4678), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [86039] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4679), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5213), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5211), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [86124] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4680), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5224), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5222), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [86209] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4681), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [86326] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4682), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [86465] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_into,
    STATE(4692), 1,
      aux_sym__query_body_repeat2,
    STATE(4683), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [86554] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_into,
    STATE(4693), 1,
      aux_sym__query_body_repeat2,
    STATE(4684), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [86643] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4685), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [86754] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4686), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [86861] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4687), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [86990] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4688), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [87121] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4689), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [87248] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4690), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [87361] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4691), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [87486] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7353), 1,
      anon_sym_into,
    STATE(4692), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [87573] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_into,
    STATE(4692), 1,
      aux_sym__query_body_repeat2,
    STATE(4693), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [87662] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4694), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [87765] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4695), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [87898] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4696), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [88033] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4697), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [88172] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4698), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [88311] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4699), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [88450] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4700), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [88553] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4701), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4993), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4991), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88638] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4702), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5005), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5003), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88723] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4703), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5009), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5007), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88808] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4704), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5021), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5019), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88893] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7356), 1,
      anon_sym_and,
    ACTIONS(7358), 1,
      anon_sym_or,
    STATE(4705), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88982] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7356), 1,
      anon_sym_and,
    ACTIONS(7358), 1,
      anon_sym_or,
    STATE(4706), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89071] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4707), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5029), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5027), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89156] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4708), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [89295] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4709), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [89434] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4710), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5037), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5035), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89519] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4711), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5041), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5039), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89604] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4712), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5049), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5047), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89689] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4713), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5069), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5067), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89774] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4714), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [89913] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4715), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5193), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5191), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89998] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4716), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5099), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5097), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90083] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_and,
    STATE(4717), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [90170] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4718), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5115), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5113), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90255] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4719), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5119), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5117), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90340] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4720), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5123), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5121), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90425] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4721), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5131), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5129), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90510] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4722), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5111), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5109), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90595] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4723), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5137), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5135), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90680] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4724), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5141), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5139), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90765] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4725), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5147), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5145), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90850] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4726), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [90957] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4727), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91096] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4728), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91235] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4729), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91374] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4730), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91513] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4731), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91652] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4732), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91791] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4733), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [91930] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7384), 1,
      anon_sym_and,
    STATE(4734), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [92017] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4735), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5453), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5451), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [92102] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4736), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [92205] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4737), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [92344] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4738), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [92447] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7055), 1,
      anon_sym_QMARK,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4739), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [92586] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4740), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [92725] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4741), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [92864] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4742), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93003] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6655), 1,
      anon_sym_as,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7107), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_CARET,
    ACTIONS(7111), 1,
      anon_sym_PIPE,
    ACTIONS(7113), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_QMARK,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7101), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(4743), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93142] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4744), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93281] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4745), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93420] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4746), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [93523] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4747), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93662] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(4748), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93791] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(4749), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [93922] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(4750), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94049] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4751), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
  [94174] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(4752), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94307] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(4753), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94442] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4754), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94581] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4755), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94720] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4756), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94859] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4757), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [94998] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4758), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [95137] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7099), 1,
      anon_sym_GT_GT,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7097), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4759), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [95254] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4760), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [95365] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4761), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [95472] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7093), 1,
      anon_sym_SLASH,
    ACTIONS(7105), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7089), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7091), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4762), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [95585] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4763), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5001), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4999), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95670] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4764), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4969), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4967), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95755] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7217), 1,
      anon_sym_is,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4765), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [95894] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4766), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5435), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5433), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95979] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4767), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [96118] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4768), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [96257] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7139), 1,
      anon_sym_as,
    ACTIONS(7141), 1,
      anon_sym_is,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7382), 1,
      anon_sym_QMARK,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(4769), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [96396] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4770), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [96503] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4771), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [96642] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(4772), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [96771] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(4773), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [96902] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(4774), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97029] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4775), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
  [97154] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(4776), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97287] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(4777), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97422] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4778), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97561] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4779), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97700] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4780), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97839] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4781), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [97978] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4782), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [98117] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4783), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [98256] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4784), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [98395] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4785), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [98524] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4786), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [98655] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4787), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [98782] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4788), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [98889] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4789), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [99014] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4790), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [99153] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4791), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [99292] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7406), 1,
      anon_sym_as,
    ACTIONS(7408), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(4792), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [99431] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4793), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [99564] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7207), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4794), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [99667] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4795), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [99802] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7137), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4796), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [99905] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4797), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [100012] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4798), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [100151] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4799), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [100290] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4800), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [100429] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7380), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4801), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [100568] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7356), 1,
      anon_sym_and,
    STATE(4802), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100655] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7384), 1,
      anon_sym_and,
    ACTIONS(7434), 1,
      anon_sym_or,
    STATE(4803), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100744] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7384), 1,
      anon_sym_and,
    ACTIONS(7434), 1,
      anon_sym_or,
    STATE(4804), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100833] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4805), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [100972] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7430), 1,
      anon_sym_as,
    ACTIONS(7432), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(4806), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [101111] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7243), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4807), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [101214] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4808), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [101321] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4809), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [101460] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4810), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [101563] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7331), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4811), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [101666] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7345), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4812), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [101769] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4813), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5045), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5043), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [101854] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4814), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5498), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5496), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [101939] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4815), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5514), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5512), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102024] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4816), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5455), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3881), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102109] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4817), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5490), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5488), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102194] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4818), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5419), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5417), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102279] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4819), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5419), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5417), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102364] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_into,
    STATE(4683), 1,
      aux_sym__query_body_repeat2,
    STATE(4820), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102453] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7436), 1,
      anon_sym_into,
    STATE(4822), 1,
      aux_sym__query_body_repeat2,
    STATE(4821), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102542] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7436), 1,
      anon_sym_into,
    STATE(4824), 1,
      aux_sym__query_body_repeat2,
    STATE(4822), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102631] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7436), 1,
      anon_sym_into,
    STATE(4825), 1,
      aux_sym__query_body_repeat2,
    STATE(4823), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102720] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7438), 1,
      anon_sym_into,
    STATE(4824), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102807] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7436), 1,
      anon_sym_into,
    STATE(4824), 1,
      aux_sym__query_body_repeat2,
    STATE(4825), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102896] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4826), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [103013] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4827), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [103124] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4828), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 18,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [103231] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4829), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [103360] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4830), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [103491] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4831), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [103618] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4832), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [103731] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4833), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [103856] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4834), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [103959] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4835), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [104092] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4836), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [104227] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4837), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [104366] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5868), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4838), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [104507] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4839), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [104624] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4840), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [104735] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4841), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5684), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5682), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [104842] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4842), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [104971] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4843), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [105102] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4844), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [105229] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4845), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [105342] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4846), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [105467] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4847), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5924), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [105570] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4848), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [105703] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(4849), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [105838] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4850), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [105977] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5872), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4851), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [106118] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5240), 1,
      anon_sym_in,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4852), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [106259] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5876), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4853), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [106400] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5810), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4854), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [106541] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4855), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [106680] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4856), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5484), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106765] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4857), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5409), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5407), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106850] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4858), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5443), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5441), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106935] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4859), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [107074] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4860), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5390), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5388), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107159] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4861), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5390), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5388), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107244] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4862), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5405), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5403), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107329] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7475), 1,
      anon_sym_into,
    STATE(4864), 1,
      aux_sym__query_body_repeat2,
    STATE(4863), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107418] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7475), 1,
      anon_sym_into,
    STATE(4866), 1,
      aux_sym__query_body_repeat2,
    STATE(4864), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107507] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7475), 1,
      anon_sym_into,
    STATE(4867), 1,
      aux_sym__query_body_repeat2,
    STATE(4865), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107596] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7477), 1,
      anon_sym_into,
    STATE(4866), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107683] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7475), 1,
      anon_sym_into,
    STATE(4866), 1,
      aux_sym__query_body_repeat2,
    STATE(4867), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107772] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4868), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5413), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5411), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107857] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4869), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5421), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107942] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4870), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5427), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5425), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108027] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4871), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5431), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5429), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108112] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4872), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [108229] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4873), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [108340] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4874), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [108469] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4875), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [108600] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4876), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [108727] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4877), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [108840] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4878), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [108965] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4879), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [109098] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4880), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [109233] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7051), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7083), 1,
      anon_sym_as,
    ACTIONS(7085), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(4881), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [109372] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4882), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5439), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5437), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109457] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(4883), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5447), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5445), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [109542] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5880), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5878), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4884), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [109683] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5852), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4885), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [109824] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5888), 1,
      anon_sym_in,
    ACTIONS(6149), 1,
      anon_sym_switch,
    ACTIONS(6157), 1,
      anon_sym_as,
    ACTIONS(6161), 1,
      anon_sym_with,
    ACTIONS(7443), 1,
      anon_sym_QMARK,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5886), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(4886), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [109965] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(7465), 1,
      anon_sym_DOT_DOT,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4887), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1231), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1229), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [110068] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4888), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [110207] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4889), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [110319] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(4890), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [110457] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7524), 1,
      anon_sym_COMMA,
    ACTIONS(7526), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6981), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4891), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [110599] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7528), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(4892), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [110737] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4893), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [110853] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4894), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [110963] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4895), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [111069] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4896), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [111197] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4897), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [111327] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4898), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [111453] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4899), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [111565] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4900), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [111689] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7530), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6822), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4901), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [111831] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7535), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4902), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [111943] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4903), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [112075] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7537), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(5951), 1,
      sym_explicit_interface_specifier,
    STATE(7567), 1,
      sym__name,
    ACTIONS(7547), 2,
      anon_sym_operator,
      anon_sym_checked,
    ACTIONS(7545), 3,
      anon_sym_ref,
      anon_sym_delegate,
      sym_predefined_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4904), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_conversion_operator_declaration_repeat1,
    ACTIONS(7540), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [112177] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4905), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [112293] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4906), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [112403] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4907), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [112531] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4908), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [112661] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4909), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [112787] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4910), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [112899] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4911), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113023] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4912), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113155] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4913), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113289] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(4914), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113427] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4915), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113561] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7582), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(4916), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113699] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4917), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [113801] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7582), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(4918), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [113939] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7582), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(4919), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [114077] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7582), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(4920), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [114215] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7582), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(4921), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [114353] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(4922), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [114491] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7584), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4923), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [114603] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7586), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4924), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [114715] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7588), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4925), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [114827] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7590), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4926), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [114939] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7592), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4927), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [115051] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7594), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4928), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [115189] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7596), 1,
      anon_sym_into,
    STATE(4965), 1,
      aux_sym__query_body_repeat2,
    STATE(4929), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [115277] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7596), 1,
      anon_sym_into,
    STATE(4966), 1,
      aux_sym__query_body_repeat2,
    STATE(4930), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [115365] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7598), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4931), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [115477] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4932), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [115607] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4933), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [115733] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(7602), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6911), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4934), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [115875] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4935), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [115987] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4936), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [116111] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7604), 1,
      anon_sym_SEMI,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4937), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [116251] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7263), 1,
      anon_sym_SLASH,
    ACTIONS(7267), 1,
      anon_sym_GT_GT,
    ACTIONS(7271), 1,
      anon_sym_AMP,
    ACTIONS(7277), 1,
      anon_sym_CARET,
    ACTIONS(7279), 1,
      anon_sym_PIPE,
    ACTIONS(7281), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7283), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7285), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7638), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5794), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(7259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7261), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7265), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7269), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7273), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7275), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4938), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [116391] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4939), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [116529] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7640), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6898), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4940), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [116671] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7642), 1,
      anon_sym_COMMA,
    ACTIONS(7644), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6970), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4941), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [116813] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4942), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [116915] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4943), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [117031] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4916), 1,
      anon_sym_LBRACK,
    ACTIONS(5392), 1,
      anon_sym_LBRACE,
    ACTIONS(5395), 1,
      anon_sym_QMARK,
    STATE(3423), 1,
      sym_initializer_expression,
    STATE(4944), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4920), 24,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [117123] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7646), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4945), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [117235] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7650), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7012), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4946), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [117377] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4947), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [117487] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4948), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [117589] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(4949), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [117727] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4950), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [117865] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_STAR,
    ACTIONS(5215), 1,
      anon_sym_QMARK,
    ACTIONS(7652), 1,
      anon_sym_DOT,
    ACTIONS(4022), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4951), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4024), 25,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [117957] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7652), 1,
      anon_sym_DOT,
    STATE(4952), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4028), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [118043] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4953), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [118181] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4954), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [118297] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4955), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [118407] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4956), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [118535] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4957), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [118665] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4958), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [118791] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7672), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7099), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4959), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [118933] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4960), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [119057] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4961), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [119189] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4962), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [119323] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(4963), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [119461] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(4964), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [119599] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_into,
    STATE(4965), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [119685] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7596), 1,
      anon_sym_into,
    STATE(4965), 1,
      aux_sym__query_body_repeat2,
    STATE(4966), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [119773] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4967), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [119905] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7685), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4968), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [120017] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7687), 1,
      anon_sym_COMMA,
    ACTIONS(7689), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6995), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4969), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120159] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4970), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120297] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7691), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6905), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4971), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120439] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7693), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4972), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120577] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7695), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(4973), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120715] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7697), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(4974), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120853] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7699), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7029), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4975), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [120995] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7701), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(4976), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [121107] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4977), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [121209] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7697), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(4978), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [121347] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7697), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(4979), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [121485] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7697), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(4980), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [121623] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7697), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(4981), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [121761] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4982), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [121877] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6490), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3911), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4983), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [121987] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4984), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [122097] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4985), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [122225] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4986), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [122355] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7723), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4987), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [122481] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4988), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [122593] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7723), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4989), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [122717] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4990), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [122849] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(4991), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [122983] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(4992), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [123121] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7735), 1,
      anon_sym_SEMI,
    ACTIONS(7737), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6920), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4993), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [123263] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4994), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [123379] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7739), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(4995), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [123517] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4996), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [123655] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7741), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7068), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4997), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [123797] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7743), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7073), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4998), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [123939] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4999), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [124077] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7745), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5000), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [124189] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5001), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [124299] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_and,
    ACTIONS(7749), 1,
      anon_sym_or,
    STATE(5002), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124387] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5003), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [124525] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5004), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [124627] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5005), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [124765] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5006), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [124903] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5007), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [125041] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5008), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [125179] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5009), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [125285] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5010), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [125413] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7753), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5011), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [125525] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5012), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [125655] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5013), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [125781] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5014), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [125893] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5015), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [126017] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5016), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [126119] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5017), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [126251] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5018), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [126353] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_and,
    STATE(5019), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [126439] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5020), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [126573] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_and,
    STATE(5021), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [126659] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5022), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [126797] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5023), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [126935] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5024), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [127073] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5025), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [127175] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7759), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5026), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [127287] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7247), 1,
      anon_sym_COMMA,
    ACTIONS(7249), 1,
      anon_sym_RBRACE,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6930), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5027), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [127429] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(5028), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5455), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3881), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127513] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7761), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6841), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5029), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [127655] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_and,
    ACTIONS(7763), 1,
      anon_sym_or,
    STATE(5030), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127743] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5031), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [127881] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5032), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [128019] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5033), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [128153] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5034), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [128291] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7765), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5035), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [128403] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_as,
    ACTIONS(7668), 1,
      anon_sym_is,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7697), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5036), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [128541] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7767), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5037), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [128653] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_RPAREN,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7638), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5038), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [128793] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5039), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [128909] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5040), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [129019] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5041), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [129147] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5042), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [129277] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5043), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [129403] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5044), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [129515] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5045), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [129639] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5046), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [129771] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7797), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5047), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [129883] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7723), 1,
      anon_sym_is,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5048), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [130021] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5049), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [130155] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5050), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [130261] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5051), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [130399] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7713), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5052), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [130501] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_and,
    ACTIONS(7805), 1,
      anon_sym_or,
    STATE(5053), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [130589] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7638), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5054), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [130727] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7807), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5055), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [130839] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5056), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [130977] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5057), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [131083] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5058), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [131185] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7811), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5059), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [131297] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5060), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [131403] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5061), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [131505] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7815), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5062), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [131617] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7819), 1,
      anon_sym_QMARK,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5063), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [131755] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5064), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [131861] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5065), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [131963] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7851), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5066), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [132075] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5067), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [132213] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5068), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [132319] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5069), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [132421] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(6591), 1,
      anon_sym_as,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7560), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7570), 1,
      anon_sym_is,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7582), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5850), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5070), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [132559] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7853), 1,
      anon_sym_COMMA,
    ACTIONS(7855), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6999), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5071), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [132701] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_and,
    ACTIONS(7763), 1,
      anon_sym_or,
    STATE(5072), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [132789] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5073), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [132927] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5074), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [133029] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5075), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [133167] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5076), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [133305] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7857), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5077), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [133417] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5078), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [133523] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5079), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [133661] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_as,
    ACTIONS(7791), 1,
      anon_sym_is,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5080), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [133799] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7486), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5081), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [133901] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7859), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7033), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5082), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [134043] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_and,
    STATE(5083), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [134129] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7861), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5084), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [134267] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7863), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6830), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5085), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [134409] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7861), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5086), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [134547] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7865), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5087), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [134685] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7867), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5088), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [134797] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7869), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5089), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [134935] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5090), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [135051] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5091), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [135161] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5092), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [135289] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5093), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [135419] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5094), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [135545] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5095), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [135657] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5096), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [135781] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5097), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [135913] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5098), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136047] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5099), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136185] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7819), 1,
      anon_sym_QMARK,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5100), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136323] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5101), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [136425] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7819), 1,
      anon_sym_QMARK,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5102), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136563] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7819), 1,
      anon_sym_QMARK,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5103), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136701] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7819), 1,
      anon_sym_QMARK,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5104), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136839] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7819), 1,
      anon_sym_QMARK,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7847), 1,
      anon_sym_as,
    ACTIONS(7849), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5105), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [136977] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7871), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5106), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [137115] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7873), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5107), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [137227] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7875), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5108), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [137339] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7877), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5109), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [137477] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5110), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [137615] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5111), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [137753] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5112), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [137859] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5794), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5113), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [137997] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7879), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(6821), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5114), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [138139] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5115), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [138241] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7881), 1,
      anon_sym_into,
    STATE(5117), 1,
      aux_sym__query_body_repeat2,
    STATE(5116), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138329] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7881), 1,
      anon_sym_into,
    STATE(5119), 1,
      aux_sym__query_body_repeat2,
    STATE(5117), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138417] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7881), 1,
      anon_sym_into,
    STATE(5120), 1,
      aux_sym__query_body_repeat2,
    STATE(5118), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138505] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7883), 1,
      anon_sym_into,
    STATE(5119), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138591] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7881), 1,
      anon_sym_into,
    STATE(5119), 1,
      aux_sym__query_body_repeat2,
    STATE(5120), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138679] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7886), 1,
      anon_sym_into,
    STATE(5122), 1,
      aux_sym__query_body_repeat2,
    STATE(5121), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138767] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7886), 1,
      anon_sym_into,
    STATE(5124), 1,
      aux_sym__query_body_repeat2,
    STATE(5122), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138855] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7886), 1,
      anon_sym_into,
    STATE(5125), 1,
      aux_sym__query_body_repeat2,
    STATE(5123), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138943] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7888), 1,
      anon_sym_into,
    STATE(5124), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139029] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7886), 1,
      anon_sym_into,
    STATE(5124), 1,
      aux_sym__query_body_repeat2,
    STATE(5125), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139117] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_into,
    STATE(5127), 1,
      aux_sym__query_body_repeat2,
    STATE(5126), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139205] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_into,
    STATE(5129), 1,
      aux_sym__query_body_repeat2,
    STATE(5127), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139293] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_into,
    STATE(5130), 1,
      aux_sym__query_body_repeat2,
    STATE(5128), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139381] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7893), 1,
      anon_sym_into,
    STATE(5129), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139467] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_into,
    STATE(5129), 1,
      aux_sym__query_body_repeat2,
    STATE(5130), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139555] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7896), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7093), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5131), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [139697] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(7898), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    STATE(7098), 1,
      aux_sym__for_statement_conditions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5132), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [139839] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_into,
    STATE(5134), 1,
      aux_sym__query_body_repeat2,
    STATE(5133), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139927] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_into,
    STATE(5136), 1,
      aux_sym__query_body_repeat2,
    STATE(5134), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140015] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_into,
    STATE(5137), 1,
      aux_sym__query_body_repeat2,
    STATE(5135), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140103] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7902), 1,
      anon_sym_into,
    STATE(5136), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140189] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_into,
    STATE(5136), 1,
      aux_sym__query_body_repeat2,
    STATE(5137), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [140277] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7905), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5138), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [140389] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5139), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [140505] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5140), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [140615] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5141), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [140743] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5142), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [140873] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5143), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [140999] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5144), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [141111] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5145), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [141235] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5146), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [141367] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5147), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [141501] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5148), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [141639] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7907), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5149), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [141777] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5150), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [141905] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5866), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5151), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [142043] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_into,
    STATE(5154), 1,
      aux_sym__query_body_repeat2,
    STATE(5152), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142131] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5153), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [142233] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_into,
    STATE(5157), 1,
      aux_sym__query_body_repeat2,
    STATE(5154), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142321] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_into,
    STATE(5158), 1,
      aux_sym__query_body_repeat2,
    STATE(5155), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142409] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5870), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5156), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [142547] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7911), 1,
      anon_sym_into,
    STATE(5157), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142633] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_into,
    STATE(5157), 1,
      aux_sym__query_body_repeat2,
    STATE(5158), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142721] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5238), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5159), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [142859] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7596), 1,
      anon_sym_into,
    STATE(4929), 1,
      aux_sym__query_body_repeat2,
    STATE(5160), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142947] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6503), 1,
      anon_sym_switch,
    ACTIONS(6507), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7520), 1,
      anon_sym_as,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5874), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(5161), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [143085] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    ACTIONS(7914), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5228), 1,
      sym_positional_pattern_clause,
    STATE(5741), 1,
      sym_property_pattern_clause,
    STATE(6493), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5162), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [143197] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(7916), 1,
      anon_sym_LPAREN,
    ACTIONS(7918), 1,
      anon_sym_BANG,
    ACTIONS(7920), 1,
      sym_integer_literal,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6663), 1,
      sym__preproc_expression,
    ACTIONS(77), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6548), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5163), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [143296] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6672), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5164), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [143395] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7936), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5165), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [143532] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7938), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5166), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [143669] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(3554), 1,
      sym__variable_designation,
    STATE(5745), 1,
      sym_property_pattern_clause,
    ACTIONS(3929), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3927), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5167), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [143772] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6568), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5168), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [143871] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(4028), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5169), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [143956] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7942), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5170), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [144093] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(7916), 1,
      anon_sym_LPAREN,
    ACTIONS(7918), 1,
      anon_sym_BANG,
    ACTIONS(7920), 1,
      sym_integer_literal,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6613), 1,
      sym__preproc_expression,
    ACTIONS(77), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6548), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5171), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [144192] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7693), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5172), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [144329] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7695), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5173), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [144466] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6627), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5174), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [144565] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5878), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5175), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [144702] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7980), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5176), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [144839] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_and,
    STATE(5177), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144924] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6625), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5178), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [145023] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7984), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5179), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [145160] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5886), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5180), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [145297] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_and,
    STATE(5181), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [145382] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7988), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5182), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [145519] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5794), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5183), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [145656] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5184), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [145757] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7990), 1,
      anon_sym_and,
    STATE(5185), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [145842] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5186), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [145969] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_STAR,
    ACTIONS(5473), 1,
      anon_sym_QMARK,
    ACTIONS(8016), 1,
      anon_sym_DOT,
    ACTIONS(4022), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5187), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4024), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146060] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7990), 1,
      anon_sym_and,
    ACTIONS(8018), 1,
      anon_sym_or,
    STATE(5188), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146147] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5874), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5189), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [146284] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8054), 1,
      anon_sym_and,
    STATE(5190), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146369] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5191), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [146470] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5866), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5192), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [146607] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6655), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5193), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [146706] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5194), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [146807] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5870), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5195), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [146944] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7984), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(5196), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [147081] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5197), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [147182] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5238), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5198), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [147319] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5199), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [147448] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7946), 1,
      anon_sym_QMARK,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5874), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5200), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [147585] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7988), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(5201), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [147722] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7936), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(5202), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [147859] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5203), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [147974] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5204), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [148089] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5205), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [148198] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8058), 1,
      anon_sym_and,
    ACTIONS(8060), 1,
      anon_sym_or,
    STATE(5206), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148285] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5207), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [148390] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5208), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [148517] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5209), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [148646] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6651), 1,
      anon_sym_switch,
    ACTIONS(6659), 1,
      anon_sym_with,
    ACTIONS(6793), 1,
      anon_sym_as,
    ACTIONS(7000), 1,
      anon_sym_QMARK,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_CARET,
    ACTIONS(7010), 1,
      anon_sym_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP,
    ACTIONS(7016), 1,
      anon_sym_GT_GT,
    ACTIONS(7022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7024), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7026), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7028), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7030), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6998), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7002), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7004), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7014), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7018), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7020), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8062), 2,
      sym_interpolation_close_brace,
      anon_sym_COLON,
    STATE(5210), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [148783] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5211), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [148908] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8064), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5212), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [149045] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    ACTIONS(8066), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5213), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [149184] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5214), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [149293] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8068), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5215), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [149430] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5216), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [149535] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5217), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [149646] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_and,
    ACTIONS(8070), 1,
      anon_sym_or,
    STATE(5218), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149733] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_and,
    ACTIONS(8072), 1,
      anon_sym_or,
    STATE(5219), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149820] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6687), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5220), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [149919] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6639), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5221), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [150018] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8074), 1,
      anon_sym_DOT,
    ACTIONS(4024), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5222), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [150111] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8076), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5223), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [150248] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5224), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [150359] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5225), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [150482] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5226), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [150613] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6621), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5227), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [150712] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3533), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(5719), 1,
      sym_property_pattern_clause,
    ACTIONS(3933), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3931), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5228), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [150815] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    ACTIONS(8078), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5229), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [150954] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8080), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5230), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [151091] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5866), 1,
      anon_sym_into,
    ACTIONS(5868), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5231), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [151230] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5232), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5926), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5924), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [151331] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5870), 1,
      anon_sym_into,
    ACTIONS(5872), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5233), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [151470] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_SEMI,
    STATE(5234), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [151555] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5235), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [151680] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5238), 1,
      anon_sym_into,
    ACTIONS(5240), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5236), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [151819] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5237), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [151930] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5238), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [152053] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5874), 1,
      anon_sym_into,
    ACTIONS(5876), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5239), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [152192] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5866), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5240), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [152329] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5241), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [152444] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5242), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [152553] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5243), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5684), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5682), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [152658] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5244), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [152785] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5245), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [152914] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5246), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153039] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5247), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [153150] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5248), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153273] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5249), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153404] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5250), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153537] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5682), 1,
      anon_sym_into,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5251), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153674] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5252), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153807] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5253), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [153938] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5254), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [154071] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5878), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5255), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [154208] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6576), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5256), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [154307] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7952), 1,
      anon_sym_SLASH,
    ACTIONS(7954), 1,
      anon_sym_CARET,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
    ACTIONS(7958), 1,
      anon_sym_AMP,
    ACTIONS(7962), 1,
      anon_sym_GT_GT,
    ACTIONS(7968), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7974), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7976), 1,
      anon_sym_as,
    ACTIONS(7978), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5682), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(7944), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7948), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7950), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7960), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7964), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7966), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5257), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [154444] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8016), 1,
      anon_sym_DOT,
    STATE(5258), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4028), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [154529] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7938), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(5259), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [154666] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8158), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5260), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [154803] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5261), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [154904] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5870), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5262), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [155041] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8058), 1,
      anon_sym_and,
    STATE(5263), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [155126] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5682), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5264), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [155263] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(7191), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(8164), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(8166), 1,
      aux_sym_preproc_elif_token1,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5844), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(6681), 1,
      sym_enum_member_declaration,
    STATE(6773), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(7737), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(5265), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [155370] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6635), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5266), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [155469] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5238), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5267), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [155606] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5874), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5268), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [155743] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6674), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5269), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [155842] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_and,
    ACTIONS(8072), 1,
      anon_sym_or,
    STATE(5270), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [155929] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7877), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5271), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [156066] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5272), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [156181] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3911), 1,
      anon_sym_EQ_GT,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(8168), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(5028), 1,
      sym_identifier,
    STATE(5744), 1,
      sym_positional_pattern_clause,
    STATE(5793), 1,
      sym_property_pattern_clause,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5273), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [156290] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5274), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [156399] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7990), 1,
      anon_sym_and,
    ACTIONS(8018), 1,
      anon_sym_or,
    STATE(5275), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [156486] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5276), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [156591] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7638), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5277), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [156728] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5238), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5278), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [156865] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8170), 1,
      anon_sym_DOT,
    ACTIONS(4024), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(5279), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [156958] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5280), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [157085] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_and,
    STATE(5281), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [157170] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    ACTIONS(8174), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5282), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [157309] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_and,
    ACTIONS(8176), 1,
      anon_sym_or,
    STATE(5283), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [157396] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5284), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [157525] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3911), 1,
      anon_sym_COLON,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(6989), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3548), 1,
      sym__variable_designation,
    STATE(3549), 1,
      sym_identifier,
    STATE(5744), 1,
      sym_positional_pattern_clause,
    STATE(5793), 1,
      sym_property_pattern_clause,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3909), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5285), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [157634] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5794), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5286), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [157771] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7251), 1,
      anon_sym_QMARK,
    ACTIONS(7253), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(7257), 1,
      anon_sym_is,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    ACTIONS(8178), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5287), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [157910] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3493), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3979), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3975), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5288), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158009] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6670), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5289), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158108] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5290), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [158233] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(5291), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3459), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3461), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [158316] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6600), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5292), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158415] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6615), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5293), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158514] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(5294), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3664), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3662), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [158597] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6637), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5295), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158696] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6545), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5296), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158795] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6676), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5297), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [158894] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5298), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [159005] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6530), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5299), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [159104] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6531), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5300), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [159203] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6539), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5301), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [159302] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8180), 1,
      anon_sym_and,
    STATE(5302), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [159387] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5303), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [159510] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8180), 1,
      anon_sym_and,
    ACTIONS(8182), 1,
      anon_sym_or,
    STATE(5304), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [159597] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8184), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5305), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [159734] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6570), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5306), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [159833] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5307), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [159964] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6553), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5308), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160063] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6554), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5309), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160162] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6555), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5310), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160261] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    ACTIONS(8186), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5311), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [160400] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5878), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5312), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [160537] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6601), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5313), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160636] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6602), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5314), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160735] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(7916), 1,
      anon_sym_LPAREN,
    ACTIONS(7918), 1,
      anon_sym_BANG,
    ACTIONS(7920), 1,
      sym_integer_literal,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6596), 1,
      sym__preproc_expression,
    ACTIONS(77), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6548), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5315), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160834] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6566), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5316), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160933] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(7916), 1,
      anon_sym_LPAREN,
    ACTIONS(7918), 1,
      anon_sym_BANG,
    ACTIONS(7920), 1,
      sym_integer_literal,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6618), 1,
      sym__preproc_expression,
    ACTIONS(77), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6548), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5317), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161032] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5886), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5318), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [161169] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6603), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5319), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161268] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(7916), 1,
      anon_sym_LPAREN,
    ACTIONS(7918), 1,
      anon_sym_BANG,
    ACTIONS(7920), 1,
      sym_integer_literal,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6634), 1,
      sym__preproc_expression,
    ACTIONS(77), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6548), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5320), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161367] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5794), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5321), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [161504] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5322), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [161605] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5866), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5323), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [161742] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(3552), 1,
      sym__variable_designation,
    ACTIONS(3983), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3981), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5324), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161841] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6662), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5325), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [161940] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8180), 1,
      anon_sym_and,
    ACTIONS(8182), 1,
      anon_sym_or,
    STATE(5326), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [162027] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5886), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5327), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [162164] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5328), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [162297] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3470), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3987), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3985), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5329), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [162396] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3503), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3991), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3989), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5330), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [162495] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5682), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5331), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [162632] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6538), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5332), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [162731] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5866), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5333), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [162868] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5334), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [162969] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8190), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5335), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [163106] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5870), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5336), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [163243] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5238), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5337), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [163380] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8000), 1,
      anon_sym_AMP,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8012), 1,
      anon_sym_as,
    ACTIONS(8014), 1,
      anon_sym_is,
    ACTIONS(8056), 1,
      anon_sym_CARET,
    ACTIONS(8154), 1,
      anon_sym_PIPE,
    ACTIONS(8156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8160), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5874), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(7992), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8006), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8008), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5338), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [163517] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8004), 1,
      anon_sym_GT_GT,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7994), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5339), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [163632] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5340), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [163759] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5341), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [163888] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 6,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5342), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [164013] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5878), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5343), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [164150] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6604), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5344), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164249] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(7998), 1,
      anon_sym_SLASH,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7996), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5345), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [164358] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6612), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5346), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164457] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5347), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [164580] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7608), 1,
      anon_sym_QMARK,
    ACTIONS(7614), 1,
      anon_sym_SLASH,
    ACTIONS(7616), 1,
      anon_sym_CARET,
    ACTIONS(7618), 1,
      anon_sym_PIPE,
    ACTIONS(7620), 1,
      anon_sym_AMP,
    ACTIONS(7624), 1,
      anon_sym_GT_GT,
    ACTIONS(7630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7634), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7636), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7594), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7612), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7622), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7626), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7628), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5348), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [164717] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5878), 1,
      anon_sym_into,
    ACTIONS(5880), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5349), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [164856] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5886), 1,
      anon_sym_into,
    ACTIONS(5888), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5350), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [164995] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8054), 1,
      anon_sym_and,
    ACTIONS(8192), 1,
      anon_sym_or,
    STATE(5351), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [165082] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5352), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [165213] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5794), 1,
      anon_sym_into,
    ACTIONS(5810), 1,
      anon_sym_in,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8084), 1,
      anon_sym_QMARK,
    ACTIONS(8090), 1,
      anon_sym_SLASH,
    ACTIONS(8092), 1,
      anon_sym_CARET,
    ACTIONS(8094), 1,
      anon_sym_PIPE,
    ACTIONS(8096), 1,
      anon_sym_AMP,
    ACTIONS(8100), 1,
      anon_sym_GT_GT,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8110), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8112), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8114), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8082), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8086), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8088), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8098), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8102), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8104), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5353), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [165352] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8106), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5354), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1231), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1229), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [165453] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5886), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5355), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [165590] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7986), 1,
      anon_sym_and,
    ACTIONS(8070), 1,
      anon_sym_or,
    STATE(5356), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [165677] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5357), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [165810] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5682), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5358), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [165947] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8120), 1,
      anon_sym_QMARK,
    ACTIONS(8126), 1,
      anon_sym_SLASH,
    ACTIONS(8128), 1,
      anon_sym_CARET,
    ACTIONS(8130), 1,
      anon_sym_PIPE,
    ACTIONS(8132), 1,
      anon_sym_AMP,
    ACTIONS(8136), 1,
      anon_sym_GT_GT,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8146), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8148), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8150), 1,
      anon_sym_as,
    ACTIONS(8152), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5794), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8118), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8134), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8138), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8140), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5359), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [166084] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(8142), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5360), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [166185] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(8010), 1,
      anon_sym_DOT_DOT,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5361), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [166290] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5362), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [166375] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_and,
    ACTIONS(8176), 1,
      anon_sym_or,
    STATE(5363), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [166462] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4295), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5364), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5171), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [166547] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(6299), 1,
      anon_sym_switch,
    ACTIONS(6313), 1,
      anon_sym_with,
    ACTIONS(6397), 1,
      anon_sym_as,
    ACTIONS(8022), 1,
      anon_sym_QMARK,
    ACTIONS(8028), 1,
      anon_sym_SLASH,
    ACTIONS(8030), 1,
      anon_sym_CARET,
    ACTIONS(8032), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_AMP,
    ACTIONS(8038), 1,
      anon_sym_GT_GT,
    ACTIONS(8044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8050), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8052), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5870), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8020), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8024), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8026), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8042), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5365), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [166684] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6657), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5366), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [166783] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6661), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5367), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [166882] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6665), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5368), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [166981] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(7916), 1,
      anon_sym_LPAREN,
    ACTIONS(7918), 1,
      anon_sym_BANG,
    ACTIONS(7920), 1,
      sym_integer_literal,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6533), 1,
      sym__preproc_expression,
    ACTIONS(77), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6548), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5369), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [167080] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(7926), 1,
      anon_sym_LPAREN,
    ACTIONS(7928), 1,
      anon_sym_BANG,
    ACTIONS(7932), 1,
      anon_sym_SQUOTE,
    ACTIONS(7934), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(6541), 1,
      sym__preproc_expression,
    ACTIONS(7930), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6648), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(5370), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [167179] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8194), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5371), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [167315] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    ACTIONS(8198), 1,
      anon_sym_operator,
    ACTIONS(8200), 1,
      anon_sym_this,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(6078), 1,
      sym_explicit_interface_specifier,
    STATE(6305), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7677), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5372), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [167419] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_SEMI,
    STATE(5373), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 24,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [167503] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8204), 1,
      anon_sym_COLON,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5374), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [167639] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8240), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5375), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [167775] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8242), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5376), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [167911] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8244), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5377), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [168047] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8246), 1,
      anon_sym_RPAREN,
    STATE(5378), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4900), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4898), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [168131] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8248), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5379), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [168267] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    ACTIONS(8250), 1,
      anon_sym_operator,
    ACTIONS(8252), 1,
      anon_sym_this,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(6055), 1,
      sym_explicit_interface_specifier,
    STATE(6306), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7677), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5380), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [168371] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8254), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5381), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [168507] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8256), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5382), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [168643] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8258), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5383), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [168779] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8260), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5384), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [168915] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8262), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5385), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169051] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8264), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5386), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169187] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8266), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5387), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169323] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8268), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5388), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169459] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8270), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5389), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169595] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_SEMI,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5390), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169731] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8272), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5391), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [169867] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8274), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5392), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170003] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8276), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5393), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170139] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8278), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5394), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170275] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8280), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5395), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170411] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8282), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5396), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170547] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8284), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5397), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170683] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8286), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5398), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170819] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8288), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5399), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [170955] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8290), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5400), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [171091] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8292), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5401), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [171227] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8294), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5402), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [171363] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8296), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5403), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [171499] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8298), 1,
      anon_sym_RPAREN,
    STATE(5404), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4900), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4898), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [171583] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4745), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5405), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [171665] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5103), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5406), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5101), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [171747] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8300), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5407), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [171883] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8302), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5408), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172019] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8304), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5409), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172155] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8306), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5410), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172291] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8308), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5411), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172427] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8310), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5412), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172563] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8312), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5413), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172699] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8314), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5414), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172835] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8316), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5415), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [172971] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5416), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173097] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5417), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173225] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5418), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173349] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5419), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173471] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5420), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173601] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_in,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5421), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173733] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5682), 1,
      anon_sym_in,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5422), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [173869] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(7907), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5423), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174005] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8350), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5424), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174141] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8384), 1,
      anon_sym_by,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5425), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174277] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5238), 1,
      anon_sym_in,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5426), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174413] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8392), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5427), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174549] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5866), 1,
      anon_sym_equals,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8396), 1,
      anon_sym_QMARK,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5428), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174685] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5429), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174821] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8432), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5430), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [174957] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8434), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5431), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [175093] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8436), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5432), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [175229] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8170), 1,
      anon_sym_DOT,
    ACTIONS(8441), 1,
      anon_sym_LPAREN,
    STATE(7315), 1,
      sym_attribute_argument_list,
    ACTIONS(8438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5433), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [175327] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5874), 1,
      anon_sym_in,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5434), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [175463] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8444), 1,
      anon_sym_RPAREN,
    STATE(5435), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4900), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4898), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [175547] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5436), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [175661] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7245), 1,
      anon_sym_COLON,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5437), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [175797] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8446), 1,
      anon_sym_and,
    ACTIONS(8448), 1,
      anon_sym_or,
    STATE(5438), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [175883] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(8450), 1,
      aux_sym_preproc_if_token3,
    STATE(7537), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    ACTIONS(4745), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5439), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [175973] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8452), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5440), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [176109] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8454), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5441), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [176245] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8456), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5442), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [176381] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5443), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [176489] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5444), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [176593] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5445), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [176719] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5446), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [176847] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8458), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5447), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [176983] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5448), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [177107] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5449), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [177217] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8460), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5450), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [177353] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5451), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [177475] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8462), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5452), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [177611] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5453), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [177711] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5454), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [177841] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5455), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [177973] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5682), 1,
      anon_sym_COLON,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5456), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [178109] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8464), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5457), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [178245] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8466), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5458), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [178381] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_equals,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8396), 1,
      anon_sym_QMARK,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5459), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [178517] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5238), 1,
      anon_sym_COLON,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5460), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [178653] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_by,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5461), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [178789] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3915), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5462), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [178877] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7604), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5463), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179013] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5866), 1,
      anon_sym_in,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5464), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179149] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8468), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5465), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179285] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_in,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5466), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179421] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8178), 1,
      anon_sym_COLON,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5467), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179557] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8470), 1,
      anon_sym_and,
    STATE(5468), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [179641] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8472), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5469), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179777] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5874), 1,
      anon_sym_COLON,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5470), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [179913] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8474), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5471), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180049] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_and,
    STATE(5472), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [180133] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8396), 1,
      anon_sym_QMARK,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    ACTIONS(8478), 1,
      anon_sym_equals,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5473), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180269] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8512), 1,
      anon_sym_on,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5474), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180405] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8518), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5475), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180541] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8520), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5476), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180677] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8522), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5477), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180813] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8524), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5478), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [180949] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5479), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181085] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5866), 1,
      anon_sym_on,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5480), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181221] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8528), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5481), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181357] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_on,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5482), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181493] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8530), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5483), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181629] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8532), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5484), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181765] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8534), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5485), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [181901] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8536), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5486), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [182037] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8538), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5487), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [182173] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8540), 1,
      anon_sym_RPAREN,
    STATE(5488), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4900), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4898), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182257] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_and,
    ACTIONS(8544), 1,
      anon_sym_or,
    STATE(5489), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182343] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8546), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5490), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [182479] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8548), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5491), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [182615] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5061), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5492), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5059), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [182697] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_and,
    ACTIONS(8544), 1,
      anon_sym_or,
    STATE(5493), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182783] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8550), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5494), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [182919] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5073), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5495), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5071), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [183001] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_and,
    STATE(5496), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [183085] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8554), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5497), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [183221] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8556), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5498), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [183357] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8558), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5499), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [183493] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    ACTIONS(8560), 1,
      anon_sym_in,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5500), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [183629] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8562), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5501), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [183765] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_SEMI,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5502), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [183901] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8564), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5503), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [184037] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8566), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5504), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [184173] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3787), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5505), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3785), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [184255] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8568), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5506), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [184391] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8570), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5507), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [184527] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5057), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5508), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5055), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [184609] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8572), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5509), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [184745] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8574), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5510), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [184881] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_and,
    ACTIONS(8576), 1,
      anon_sym_or,
    STATE(5511), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [184967] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8578), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5512), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [185103] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_into,
    STATE(5517), 1,
      aux_sym__query_body_repeat2,
    STATE(5513), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185189] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_into,
    STATE(5518), 1,
      aux_sym__query_body_repeat2,
    STATE(5514), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185275] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym_SEMI,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5515), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [185411] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_and,
    ACTIONS(8576), 1,
      anon_sym_or,
    STATE(5516), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185497] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8582), 1,
      anon_sym_into,
    STATE(5517), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185581] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_into,
    STATE(5517), 1,
      aux_sym__query_body_repeat2,
    STATE(5518), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [185667] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8585), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5519), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [185803] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4753), 1,
      aux_sym_preproc_if_token3,
    STATE(7655), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    ACTIONS(4745), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5520), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [185893] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5521), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [186007] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8587), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5522), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [186143] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5523), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [186251] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5524), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [186355] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5525), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [186481] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5526), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [186609] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5527), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [186733] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5528), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [186843] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5529), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [186965] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5530), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [187065] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5531), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [187195] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5532), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [187327] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5682), 1,
      anon_sym_equals,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5533), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [187463] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5238), 1,
      anon_sym_equals,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8396), 1,
      anon_sym_QMARK,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5534), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [187599] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_COLON,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5535), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [187735] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5536), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [187835] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8589), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5537), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [187971] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_and,
    ACTIONS(8591), 1,
      anon_sym_or,
    STATE(5538), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [188057] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8593), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5539), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [188193] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5874), 1,
      anon_sym_equals,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8396), 1,
      anon_sym_QMARK,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5540), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [188329] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_and,
    ACTIONS(8591), 1,
      anon_sym_or,
    STATE(5541), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [188415] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8595), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5542), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [188551] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8597), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5543), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [188687] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8599), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5544), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [188823] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_by,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5545), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [188959] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5546), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [189059] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8601), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5547), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [189195] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8603), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5548), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [189331] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8446), 1,
      anon_sym_and,
    STATE(5549), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [189415] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8466), 1,
      anon_sym_EQ_GT,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5550), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [189551] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8639), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5551), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [189687] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8641), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5552), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [189823] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8643), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5553), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [189959] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_into,
    STATE(5702), 1,
      aux_sym__query_body_repeat2,
    STATE(5554), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [190045] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8647), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5555), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [190181] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_and,
    ACTIONS(8651), 1,
      anon_sym_or,
    STATE(5556), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [190267] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8653), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5557), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [190403] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8655), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5558), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [190539] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8657), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5559), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [190675] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    ACTIONS(8659), 1,
      anon_sym_in,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5560), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [190811] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8661), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5561), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [190947] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_equals,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8396), 1,
      anon_sym_QMARK,
    ACTIONS(8402), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_CARET,
    ACTIONS(8406), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8412), 1,
      anon_sym_GT_GT,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8420), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8422), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8426), 1,
      anon_sym_as,
    ACTIONS(8428), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8394), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8398), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8400), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8414), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8416), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5562), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [191083] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8418), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5563), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [191183] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8663), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5564), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [191319] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8470), 1,
      anon_sym_and,
    ACTIONS(8665), 1,
      anon_sym_or,
    STATE(5565), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5482), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5480), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [191405] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8667), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5566), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [191541] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8470), 1,
      anon_sym_and,
    ACTIONS(8665), 1,
      anon_sym_or,
    STATE(5567), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [191627] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8669), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5568), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [191763] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_on,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5569), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [191899] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5570), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [191999] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8671), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5571), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [192135] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8673), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5572), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [192271] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_EQ_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5573), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [192407] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5574), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [192507] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8675), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5575), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [192643] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8677), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5576), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [192779] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5577), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [192893] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8679), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5578), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [193029] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5579), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [193137] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8681), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5580), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [193273] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5581), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [193377] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8683), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5582), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [193513] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8685), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5583), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [193649] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5584), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [193775] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8687), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5585), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [193911] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8689), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5586), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [194047] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8691), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5587), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [194183] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8693), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5588), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [194319] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_RPAREN,
    STATE(5589), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4900), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4898), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [194403] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8697), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5590), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [194539] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    ACTIONS(8699), 1,
      anon_sym_operator,
    ACTIONS(8701), 1,
      anon_sym_this,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(6093), 1,
      sym_explicit_interface_specifier,
    STATE(6307), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7677), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5591), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [194643] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5592), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [194771] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8703), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5593), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [194907] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5594), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [195031] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5595), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [195141] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5596), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [195277] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5597), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [195399] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5598), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [195499] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5599), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [195629] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(5600), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [195761] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5794), 1,
      anon_sym_in,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8326), 1,
      anon_sym_AMP,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8338), 1,
      anon_sym_is,
    ACTIONS(8340), 1,
      anon_sym_CARET,
    ACTIONS(8342), 1,
      anon_sym_PIPE,
    ACTIONS(8344), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8346), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8348), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8332), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5601), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [195897] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5682), 1,
      anon_sym_on,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5602), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [196033] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    ACTIONS(8705), 1,
      anon_sym_on,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5603), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [196169] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5238), 1,
      anon_sym_on,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5604), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [196305] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5605), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [196441] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8330), 1,
      anon_sym_GT_GT,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5606), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [196555] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5607), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [196663] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5608), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [196767] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8324), 1,
      anon_sym_SLASH,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8320), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8322), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5609), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [196877] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5610), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [196977] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5874), 1,
      anon_sym_on,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8482), 1,
      anon_sym_QMARK,
    ACTIONS(8488), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_CARET,
    ACTIONS(8492), 1,
      anon_sym_PIPE,
    ACTIONS(8494), 1,
      anon_sym_AMP,
    ACTIONS(8498), 1,
      anon_sym_GT_GT,
    ACTIONS(8504), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8510), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8514), 1,
      anon_sym_as,
    ACTIONS(8516), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8480), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8484), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8486), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8496), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8500), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8502), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5611), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197113] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8709), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5612), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197249] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5866), 1,
      anon_sym_COLON,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5613), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197385] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8711), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5614), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197521] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8713), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5615), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197657] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8715), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5616), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197793] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8717), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5617), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [197929] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8719), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5618), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198065] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8721), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5619), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198201] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8723), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5620), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198337] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8725), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5621), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198473] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8727), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5622), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198609] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8729), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5623), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198745] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(8731), 1,
      aux_sym_preproc_if_token3,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5624), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [198881] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3630), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(3459), 6,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5625), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3633), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [198965] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5866), 1,
      anon_sym_by,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5626), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199101] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8733), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5627), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199237] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5866), 1,
      anon_sym_EQ_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5628), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199373] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7157), 1,
      anon_sym_QMARK,
    ACTIONS(7163), 1,
      anon_sym_SLASH,
    ACTIONS(7165), 1,
      anon_sym_CARET,
    ACTIONS(7167), 1,
      anon_sym_PIPE,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    ACTIONS(7173), 1,
      anon_sym_GT_GT,
    ACTIONS(7179), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7183), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7185), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8735), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7161), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7171), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7175), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7177), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5629), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199509] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8737), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5630), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199645] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8739), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5631), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199781] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8741), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5632), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [199917] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8743), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5633), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [200053] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5634), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [200167] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8745), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5635), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [200303] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5636), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [200411] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5637), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [200515] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5638), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [200641] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5639), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [200769] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5640), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [200893] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5641), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [201003] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5642), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [201125] = 29,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5684), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5643), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [201239] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_COLON,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5644), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [201375] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8747), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5645), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [201511] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8749), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5646), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [201647] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5647), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [201755] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8751), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5648), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [201891] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5649), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [201995] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8753), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5650), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [202131] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5651), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [202257] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5684), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5652), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [202385] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8755), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5653), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [202521] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 5,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5654), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [202645] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8757), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5655), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [202781] = 27,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5684), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5656), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5682), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [202891] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8759), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5657), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [203027] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5684), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5682), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5658), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [203149] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_into,
    STATE(5661), 1,
      aux_sym__query_body_repeat2,
    STATE(5659), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [203235] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_into,
    STATE(5662), 1,
      aux_sym__query_body_repeat2,
    STATE(5660), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [203321] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8763), 1,
      anon_sym_into,
    STATE(5661), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [203405] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_into,
    STATE(5661), 1,
      aux_sym__query_body_repeat2,
    STATE(5662), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [203491] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8766), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5663), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [203627] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5664), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [203727] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5665), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [203857] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5666), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [203989] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5682), 1,
      anon_sym_EQ_GT,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5667), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [204125] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8768), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5668), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [204261] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5238), 1,
      anon_sym_EQ_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5669), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [204397] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5926), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5670), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5924), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [204497] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_and,
    STATE(5671), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204581] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8770), 1,
      anon_sym_into,
    STATE(5674), 1,
      aux_sym__query_body_repeat2,
    STATE(5672), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204667] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8770), 1,
      anon_sym_into,
    STATE(5675), 1,
      aux_sym__query_body_repeat2,
    STATE(5673), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204753] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8772), 1,
      anon_sym_into,
    STATE(5674), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204837] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8770), 1,
      anon_sym_into,
    STATE(5674), 1,
      aux_sym__query_body_repeat2,
    STATE(5675), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [204923] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5874), 1,
      anon_sym_EQ_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5676), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [205059] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_into,
    STATE(5513), 1,
      aux_sym__query_body_repeat2,
    STATE(5677), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205145] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8775), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5678), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [205281] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5679), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [205411] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5682), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5680), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [205543] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_into,
    STATE(5683), 1,
      aux_sym__query_body_repeat2,
    STATE(5681), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205629] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_into,
    STATE(5684), 1,
      aux_sym__query_body_repeat2,
    STATE(5682), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205715] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8779), 1,
      anon_sym_into,
    STATE(5683), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205799] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_into,
    STATE(5683), 1,
      aux_sym__query_body_repeat2,
    STATE(5684), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205885] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5682), 1,
      anon_sym_by,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5685), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [206021] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_EQ_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    ACTIONS(8613), 1,
      anon_sym_SLASH,
    ACTIONS(8615), 1,
      anon_sym_CARET,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP,
    ACTIONS(8623), 1,
      anon_sym_GT_GT,
    ACTIONS(8629), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8631), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8633), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8635), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8637), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8605), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8609), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8611), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8625), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8627), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5686), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [206157] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_into,
    STATE(5659), 1,
      aux_sym__query_body_repeat2,
    STATE(5687), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [206243] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5238), 1,
      anon_sym_by,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5688), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [206379] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8782), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5689), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [206515] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5690), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [206651] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8446), 1,
      anon_sym_and,
    ACTIONS(8448), 1,
      anon_sym_or,
    STATE(5691), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [206737] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8770), 1,
      anon_sym_into,
    STATE(5672), 1,
      aux_sym__query_body_repeat2,
    STATE(5692), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [206823] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8786), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5693), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [206959] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5874), 1,
      anon_sym_by,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5694), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [207095] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_and,
    STATE(5695), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6201), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6199), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207179] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8777), 1,
      anon_sym_into,
    STATE(5681), 1,
      aux_sym__query_body_repeat2,
    STATE(5696), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6010), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6008), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207265] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_QMARK,
    ACTIONS(7295), 1,
      anon_sym_SLASH,
    ACTIONS(7297), 1,
      anon_sym_CARET,
    ACTIONS(7299), 1,
      anon_sym_PIPE,
    ACTIONS(7301), 1,
      anon_sym_AMP,
    ACTIONS(7305), 1,
      anon_sym_GT_GT,
    ACTIONS(7311), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7317), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7319), 1,
      anon_sym_is,
    ACTIONS(8788), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7287), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7291), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7293), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7303), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7307), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7309), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5697), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [207401] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8790), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5698), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [207537] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8336), 1,
      anon_sym_DOT_DOT,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1231), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5699), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1229), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [207637] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8792), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5700), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [207773] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(8354), 1,
      anon_sym_QMARK,
    ACTIONS(8360), 1,
      anon_sym_SLASH,
    ACTIONS(8362), 1,
      anon_sym_CARET,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8366), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_GT_GT,
    ACTIONS(8376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8378), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8380), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8382), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8386), 1,
      anon_sym_as,
    ACTIONS(8388), 1,
      anon_sym_is,
    ACTIONS(8794), 1,
      anon_sym_by,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8356), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8358), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8368), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8372), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8374), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5701), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [207909] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_into,
    STATE(5704), 1,
      aux_sym__query_body_repeat2,
    STATE(5702), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207995] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_into,
    STATE(5705), 1,
      aux_sym__query_body_repeat2,
    STATE(5703), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6016), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [208081] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8796), 1,
      anon_sym_into,
    STATE(5704), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6020), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6018), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [208165] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_into,
    STATE(5704), 1,
      aux_sym__query_body_repeat2,
    STATE(5705), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6027), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6025), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [208251] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(7255), 1,
      anon_sym_as,
    ACTIONS(8208), 1,
      anon_sym_QMARK,
    ACTIONS(8214), 1,
      anon_sym_SLASH,
    ACTIONS(8216), 1,
      anon_sym_CARET,
    ACTIONS(8218), 1,
      anon_sym_PIPE,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8224), 1,
      anon_sym_GT_GT,
    ACTIONS(8230), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8236), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8238), 1,
      anon_sym_is,
    ACTIONS(8799), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8222), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8226), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8228), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5706), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [208387] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8801), 1,
      anon_sym_DOT,
    ACTIONS(4024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(5707), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [208479] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_and,
    ACTIONS(8651), 1,
      anon_sym_or,
    STATE(5708), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6173), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6171), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [208565] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_LBRACK,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2724), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5709), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [208698] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5694), 1,
      anon_sym_SLASH,
    ACTIONS(5698), 1,
      anon_sym_GT_GT,
    ACTIONS(5800), 1,
      anon_sym_CARET,
    ACTIONS(5802), 1,
      anon_sym_PIPE,
    ACTIONS(5804), 1,
      anon_sym_AMP,
    ACTIONS(5812), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5816), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5690), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5692), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5796), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5806), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5808), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5710), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [208831] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7125), 1,
      anon_sym_SLASH,
    ACTIONS(7127), 1,
      anon_sym_AMP,
    ACTIONS(7131), 1,
      anon_sym_GT_GT,
    ACTIONS(7143), 1,
      anon_sym_CARET,
    ACTIONS(7145), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7149), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7151), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7119), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7123), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7129), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7133), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7135), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5711), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [208964] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    ACTIONS(6787), 1,
      anon_sym_GT_GT,
    ACTIONS(6797), 1,
      anon_sym_CARET,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_AMP,
    ACTIONS(6805), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6809), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6777), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6779), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6781), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(5712), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [209097] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6615), 1,
      anon_sym_LPAREN,
    ACTIONS(6635), 1,
      anon_sym_BANG,
    ACTIONS(6643), 1,
      anon_sym_SLASH,
    ACTIONS(6647), 1,
      anon_sym_GT_GT,
    ACTIONS(6663), 1,
      anon_sym_CARET,
    ACTIONS(6665), 1,
      anon_sym_PIPE,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6671), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6673), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6675), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(4640), 1,
      sym_argument_list,
    ACTIONS(6633), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6637), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6641), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6645), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6649), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6669), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(5713), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [209230] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6685), 1,
      anon_sym_SLASH,
    ACTIONS(6689), 1,
      anon_sym_GT_GT,
    ACTIONS(6739), 1,
      anon_sym_CARET,
    ACTIONS(6741), 1,
      anon_sym_PIPE,
    ACTIONS(6743), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6747), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6749), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6681), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6683), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6687), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6729), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6731), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6733), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5714), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [209363] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7656), 1,
      anon_sym_GT_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7670), 1,
      anon_sym_CARET,
    ACTIONS(7674), 1,
      anon_sym_PIPE,
    ACTIONS(7676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7680), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7482), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7654), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7662), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7664), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5715), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [209496] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7554), 1,
      anon_sym_SLASH,
    ACTIONS(7558), 1,
      anon_sym_GT_GT,
    ACTIONS(7564), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_CARET,
    ACTIONS(7574), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7580), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7550), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7556), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7568), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5716), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [209629] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(3554), 1,
      sym__variable_designation,
    STATE(5796), 1,
      sym_property_pattern_clause,
    ACTIONS(3927), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3929), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5717), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [209730] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5680), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2934), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5718), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [209863] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3403), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(4003), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4001), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5719), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [209960] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_SLASH,
    ACTIONS(7063), 1,
      anon_sym_CARET,
    ACTIONS(7065), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_GT_GT,
    ACTIONS(7077), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7079), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7081), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7057), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7069), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7073), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5720), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [210093] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6817), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_CARET,
    ACTIONS(6821), 1,
      anon_sym_PIPE,
    ACTIONS(6823), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_GT_GT,
    ACTIONS(6835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6839), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6811), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6813), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6825), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6829), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6831), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5721), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [210226] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8803), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(5722), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [210317] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7237), 1,
      anon_sym_SLASH,
    ACTIONS(7241), 1,
      anon_sym_GT_GT,
    ACTIONS(7390), 1,
      anon_sym_CARET,
    ACTIONS(7392), 1,
      anon_sym_PIPE,
    ACTIONS(7394), 1,
      anon_sym_AMP,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7404), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7233), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7235), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7396), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7398), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5723), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [210450] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6407), 1,
      anon_sym_SLASH,
    ACTIONS(6409), 1,
      anon_sym_CARET,
    ACTIONS(6411), 1,
      anon_sym_PIPE,
    ACTIONS(6413), 1,
      anon_sym_AMP,
    ACTIONS(6417), 1,
      anon_sym_GT_GT,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6427), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6431), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6401), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6403), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6405), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6415), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6419), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6421), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5724), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [210583] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6551), 1,
      anon_sym_SLASH,
    ACTIONS(6553), 1,
      anon_sym_AMP,
    ACTIONS(6557), 1,
      anon_sym_GT_GT,
    ACTIONS(6595), 1,
      anon_sym_CARET,
    ACTIONS(6605), 1,
      anon_sym_PIPE,
    ACTIONS(6607), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6611), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6613), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6545), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6549), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6555), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6559), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6561), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5725), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [210716] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7325), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_GT_GT,
    ACTIONS(7414), 1,
      anon_sym_CARET,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7426), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7428), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7321), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7323), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7327), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7410), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7420), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7422), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5726), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [210849] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6714), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    ACTIONS(3949), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(5727), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3947), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [210938] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6853), 1,
      anon_sym_SLASH,
    ACTIONS(6855), 1,
      anon_sym_CARET,
    ACTIONS(6857), 1,
      anon_sym_PIPE,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6863), 1,
      anon_sym_GT_GT,
    ACTIONS(6871), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6873), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6875), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6851), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6861), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6865), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6867), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5728), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [211071] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7339), 1,
      anon_sym_SLASH,
    ACTIONS(7343), 1,
      anon_sym_GT_GT,
    ACTIONS(7364), 1,
      anon_sym_CARET,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_AMP,
    ACTIONS(7374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7378), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7341), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7360), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7370), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7372), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5729), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [211204] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2655), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5730), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [211337] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(8805), 1,
      anon_sym_COMMA,
    ACTIONS(8807), 1,
      anon_sym_RBRACE,
    ACTIONS(8809), 1,
      aux_sym_preproc_if_token1,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5835), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7066), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(7053), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(5731), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211438] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(5732), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [211529] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6133), 1,
      anon_sym_SLASH,
    ACTIONS(6135), 1,
      anon_sym_CARET,
    ACTIONS(6137), 1,
      anon_sym_PIPE,
    ACTIONS(6139), 1,
      anon_sym_AMP,
    ACTIONS(6143), 1,
      anon_sym_GT_GT,
    ACTIONS(6151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6153), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6155), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6131), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6145), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6147), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5733), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [211662] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2979), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(5734), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2981), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2983), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [211745] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2469), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5735), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [211878] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_DOT,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5302), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7449), 1,
      anon_sym_SLASH,
    ACTIONS(7451), 1,
      anon_sym_CARET,
    ACTIONS(7453), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_AMP,
    ACTIONS(7459), 1,
      anon_sym_GT_GT,
    ACTIONS(7467), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7471), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3372), 1,
      sym_argument_list,
    ACTIONS(5314), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7441), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7445), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7447), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7457), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7461), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7463), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5736), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [212011] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8813), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(5737), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [212102] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(4677), 1,
      anon_sym_DOT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(3255), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5738), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [212235] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5739), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [212368] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6501), 1,
      anon_sym_SLASH,
    ACTIONS(6571), 1,
      anon_sym_CARET,
    ACTIONS(6573), 1,
      anon_sym_PIPE,
    ACTIONS(6575), 1,
      anon_sym_AMP,
    ACTIONS(6579), 1,
      anon_sym_GT_GT,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6589), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6567), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6577), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6581), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6583), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5740), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [212501] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3534), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3933), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3931), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5741), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212598] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8815), 1,
      anon_sym_EQ,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(8817), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3680), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5742), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [212691] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6949), 1,
      anon_sym_SLASH,
    ACTIONS(6951), 1,
      anon_sym_CARET,
    ACTIONS(6953), 1,
      anon_sym_PIPE,
    ACTIONS(6955), 1,
      anon_sym_AMP,
    ACTIONS(6959), 1,
      anon_sym_GT_GT,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6969), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6971), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6945), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6947), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6961), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6963), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5743), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [212824] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_LBRACE,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3533), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(5798), 1,
      sym_property_pattern_clause,
    ACTIONS(3931), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3933), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5744), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212925] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3536), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3999), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3997), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5745), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [213022] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6703), 1,
      anon_sym_SLASH,
    ACTIONS(6705), 1,
      anon_sym_CARET,
    ACTIONS(6707), 1,
      anon_sym_PIPE,
    ACTIONS(6709), 1,
      anon_sym_AMP,
    ACTIONS(6713), 1,
      anon_sym_GT_GT,
    ACTIONS(6721), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6723), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6725), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6695), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6699), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6711), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6715), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6717), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5746), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [213155] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7825), 1,
      anon_sym_SLASH,
    ACTIONS(7827), 1,
      anon_sym_CARET,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_AMP,
    ACTIONS(7835), 1,
      anon_sym_GT_GT,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7845), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7821), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7823), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7837), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7839), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5747), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [213288] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7201), 1,
      anon_sym_SLASH,
    ACTIONS(7205), 1,
      anon_sym_GT_GT,
    ACTIONS(7211), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_CARET,
    ACTIONS(7221), 1,
      anon_sym_PIPE,
    ACTIONS(7223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7225), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7227), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7197), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7199), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7203), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7213), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5748), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [213421] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8819), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(5749), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [213512] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7707), 1,
      anon_sym_SLASH,
    ACTIONS(7711), 1,
      anon_sym_GT_GT,
    ACTIONS(7717), 1,
      anon_sym_AMP,
    ACTIONS(7725), 1,
      anon_sym_CARET,
    ACTIONS(7727), 1,
      anon_sym_PIPE,
    ACTIONS(7729), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7731), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7733), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7703), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7705), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7709), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7715), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7719), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7721), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5750), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [213645] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DOT,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(5668), 1,
      anon_sym_LPAREN,
    ACTIONS(5686), 1,
      anon_sym_BANG,
    ACTIONS(5953), 1,
      anon_sym_SLASH,
    ACTIONS(5959), 1,
      anon_sym_CARET,
    ACTIONS(5961), 1,
      anon_sym_PIPE,
    ACTIONS(5963), 1,
      anon_sym_AMP,
    ACTIONS(5967), 1,
      anon_sym_GT_GT,
    ACTIONS(5973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3800), 1,
      sym_argument_list,
    ACTIONS(5688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5957), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5965), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(5969), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5751), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [213778] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8821), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(5752), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [213869] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8823), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(5753), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [213960] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8825), 1,
      anon_sym_DOT,
    ACTIONS(4024), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(5754), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [214051] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7773), 1,
      anon_sym_SLASH,
    ACTIONS(7777), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_CARET,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7803), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7771), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7775), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7781), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7785), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7787), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5755), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [214184] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(5372), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    ACTIONS(7496), 1,
      anon_sym_SLASH,
    ACTIONS(7498), 1,
      anon_sym_CARET,
    ACTIONS(7500), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      anon_sym_AMP,
    ACTIONS(7506), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7516), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7518), 1,
      anon_sym_QMARK_QMARK,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym_argument_list,
    ACTIONS(5374), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7488), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7492), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7494), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7508), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7510), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5756), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [214317] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(3555), 1,
      sym__variable_designation,
    ACTIONS(3929), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3927), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5757), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [214414] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(4813), 1,
      anon_sym_LPAREN,
    ACTIONS(4829), 1,
      anon_sym_DOT,
    ACTIONS(4881), 1,
      anon_sym_BANG,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6283), 1,
      anon_sym_SLASH,
    ACTIONS(6285), 1,
      anon_sym_CARET,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    ACTIONS(6289), 1,
      anon_sym_AMP,
    ACTIONS(6293), 1,
      anon_sym_GT_GT,
    ACTIONS(6303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6305), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6307), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6423), 1,
      anon_sym_switch,
    ACTIONS(6437), 1,
      anon_sym_with,
    ACTIONS(6943), 1,
      anon_sym_QMARK,
    ACTIONS(6965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6973), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_is,
    STATE(2500), 1,
      sym_bracketed_argument_list,
    STATE(3081), 1,
      sym_argument_list,
    ACTIONS(4883), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6275), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6281), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6291), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6295), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6297), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5758), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [214547] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8827), 1,
      anon_sym_DOT,
    ACTIONS(4024), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(5759), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [214637] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8829), 1,
      anon_sym_EQ,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(8817), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5760), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [214727] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8831), 1,
      anon_sym_DOT,
    ACTIONS(4024), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(5761), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [214817] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(3587), 1,
      aux_sym_conversion_operator_declaration_repeat1,
    STATE(4540), 1,
      sym_identifier,
    STATE(5951), 1,
      sym_explicit_interface_specifier,
    STATE(7567), 1,
      sym__name,
    ACTIONS(5632), 2,
      anon_sym_operator,
      anon_sym_checked,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5762), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [214913] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8833), 1,
      anon_sym_SEMI,
    STATE(5763), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [214995] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(5799), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7101), 1,
      sym_type_parameter,
    STATE(7336), 1,
      sym_identifier,
    ACTIONS(5085), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5764), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [215093] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8835), 1,
      anon_sym_EQ,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(8837), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5765), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [215183] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(3585), 1,
      aux_sym_conversion_operator_declaration_repeat1,
    STATE(4540), 1,
      sym_identifier,
    STATE(5951), 1,
      sym_explicit_interface_specifier,
    STATE(7567), 1,
      sym__name,
    ACTIONS(5632), 2,
      anon_sym_operator,
      anon_sym_checked,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5766), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [215279] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_DOT,
    ACTIONS(4024), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(5767), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [215369] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8841), 1,
      anon_sym_SEMI,
    STATE(5768), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5153), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [215451] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8843), 1,
      anon_sym_LPAREN,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(6556), 1,
      sym_parameter_list,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5769), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [215541] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(8809), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(8846), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5835), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7066), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(7274), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(5770), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [215639] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(6179), 1,
      sym_explicit_interface_specifier,
    STATE(6338), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7677), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5771), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [215737] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8843), 1,
      anon_sym_LPAREN,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(6640), 1,
      sym_parameter_list,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5772), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [215827] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(6154), 1,
      sym_explicit_interface_specifier,
    STATE(6334), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7677), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5773), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [215925] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8848), 1,
      anon_sym_DOT,
    ACTIONS(4024), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(5774), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [216015] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(6171), 1,
      sym_explicit_interface_specifier,
    STATE(6337), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7677), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5775), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216113] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(5799), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7180), 1,
      sym_type_parameter,
    STATE(7336), 1,
      sym_identifier,
    ACTIONS(5085), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5776), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216211] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8843), 1,
      anon_sym_LPAREN,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(6658), 1,
      sym_parameter_list,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5777), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [216301] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8835), 1,
      anon_sym_EQ,
    ACTIONS(8850), 1,
      anon_sym_COMMA,
    ACTIONS(8853), 1,
      anon_sym_RPAREN,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(7086), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5778), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [216395] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(3562), 1,
      aux_sym_conversion_operator_declaration_repeat1,
    STATE(4540), 1,
      sym_identifier,
    STATE(5951), 1,
      sym_explicit_interface_specifier,
    STATE(7567), 1,
      sym__name,
    ACTIONS(5632), 2,
      anon_sym_operator,
      anon_sym_checked,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5779), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216491] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(8809), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(8856), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5835), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7066), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(7274), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(5780), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216589] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(8858), 1,
      anon_sym_COLON_COLON,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT,
    STATE(5781), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [216674] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8860), 1,
      anon_sym_EQ,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5782), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [216761] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8862), 1,
      anon_sym_unsafe,
    ACTIONS(8864), 1,
      anon_sym_static,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(5786), 1,
      aux_sym_using_directive_repeat1,
    STATE(6503), 1,
      sym_identifier,
    STATE(7152), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5783), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216856] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6120), 1,
      aux_sym_using_directive_repeat1,
    STATE(7152), 1,
      sym__name,
    ACTIONS(8864), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5784), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216949] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_DOT,
    ACTIONS(4024), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(5785), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [217036] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6120), 1,
      aux_sym_using_directive_repeat1,
    STATE(7213), 1,
      sym__name,
    ACTIONS(8864), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5786), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217129] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6120), 1,
      aux_sym_using_directive_repeat1,
    STATE(7325), 1,
      sym__name,
    ACTIONS(8864), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5787), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217222] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8868), 1,
      anon_sym_EQ,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5788), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [217309] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(8870), 1,
      aux_sym_preproc_if_token3,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5844), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(6773), 1,
      sym_identifier,
    STATE(7714), 1,
      sym_enum_member_declaration,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5789), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217406] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8864), 1,
      anon_sym_static,
    ACTIONS(8872), 1,
      anon_sym_unsafe,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(5805), 1,
      aux_sym_using_directive_repeat1,
    STATE(6492), 1,
      sym_identifier,
    STATE(7301), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5790), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217501] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8874), 1,
      sym__identifier_token,
    ACTIONS(8880), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    STATE(4415), 1,
      sym_identifier,
    ACTIONS(8882), 5,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_operator,
      anon_sym_checked,
      sym_predefined_type,
    STATE(5791), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8877), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217592] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6120), 1,
      aux_sym_using_directive_repeat1,
    STATE(7301), 1,
      sym__name,
    ACTIONS(8864), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5792), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217685] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3534), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3931), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3933), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5793), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217780] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8884), 1,
      anon_sym_COMMA,
    ACTIONS(8887), 1,
      anon_sym_RPAREN,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(7086), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5794), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [217871] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(3555), 1,
      sym__variable_designation,
    ACTIONS(3927), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3929), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5795), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [217966] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3536), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(3997), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3999), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5796), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218061] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8864), 1,
      anon_sym_static,
    ACTIONS(8889), 1,
      anon_sym_unsafe,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(5792), 1,
      aux_sym_using_directive_repeat1,
    STATE(6502), 1,
      sym_identifier,
    STATE(7216), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5797), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218156] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(3403), 1,
      sym__variable_designation,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    ACTIONS(4001), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4003), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5798), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218251] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(5842), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7147), 1,
      sym_identifier,
    ACTIONS(8891), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5799), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218346] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3839), 1,
      anon_sym_COMMA,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8835), 1,
      anon_sym_EQ,
    ACTIONS(8837), 1,
      anon_sym_RPAREN,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5800), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [218437] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6120), 1,
      aux_sym_using_directive_repeat1,
    STATE(7206), 1,
      sym__name,
    ACTIONS(8864), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5801), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218530] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(8809), 1,
      aux_sym_preproc_if_token1,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5835), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7066), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(7274), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(5802), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218625] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(8870), 1,
      aux_sym_preproc_if_token3,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5844), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5983), 1,
      sym_preproc_if_in_attribute_list,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(6118), 1,
      sym_attribute_list,
    STATE(6773), 1,
      sym_identifier,
    STATE(7714), 1,
      sym_enum_member_declaration,
    STATE(5803), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218724] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8893), 1,
      anon_sym_using,
    ACTIONS(3459), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5804), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3461), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [218805] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6120), 1,
      aux_sym_using_directive_repeat1,
    STATE(7173), 1,
      sym__name,
    ACTIONS(8864), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5805), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218898] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8864), 1,
      anon_sym_static,
    ACTIONS(8895), 1,
      anon_sym_unsafe,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(5787), 1,
      aux_sym_using_directive_repeat1,
    STATE(6467), 1,
      sym_identifier,
    STATE(7206), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5806), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [218993] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8880), 1,
      anon_sym_LPAREN,
    ACTIONS(8897), 1,
      sym__identifier_token,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4028), 1,
      sym_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    ACTIONS(8882), 5,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_operator,
      anon_sym_checked,
      sym_predefined_type,
    STATE(5807), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8900), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219084] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8903), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5808), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219176] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8905), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5809), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219268] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4973), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(4745), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_preproc_if_token1,
    STATE(5810), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [219348] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8907), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5811), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219440] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8909), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5812), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219532] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8911), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5813), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219624] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8913), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5814), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219716] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8915), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5815), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219808] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8917), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5816), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219900] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8919), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5817), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219992] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8921), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5818), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220084] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8923), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5819), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220176] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8925), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5820), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220268] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5821), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [220354] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8927), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5822), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220446] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8929), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5823), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220538] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8931), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5824), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220630] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8933), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5825), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220722] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(8170), 1,
      anon_sym_DOT,
    ACTIONS(8441), 1,
      anon_sym_LPAREN,
    STATE(7315), 1,
      sym_attribute_argument_list,
    ACTIONS(8935), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5826), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [220814] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8939), 1,
      anon_sym_LPAREN,
    ACTIONS(8941), 6,
      anon_sym_ref,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_this,
      anon_sym_scoped,
    STATE(5827), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__parameter_type_with_modifiers_repeat1,
    ACTIONS(8937), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [220894] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8944), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5828), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [220986] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8946), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5829), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221078] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8948), 1,
      anon_sym_RBRACK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5830), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221170] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(6847), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5831), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221259] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(6994), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5832), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221348] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(6969), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5833), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221437] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7294), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5834), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221526] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5842), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(7075), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5835), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221617] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(6910), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5836), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221706] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(6869), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5837), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221795] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6388), 1,
      sym__name,
    STATE(6701), 1,
      sym_primary_constructor_base_type,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5838), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221884] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7076), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5839), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [221973] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6529), 1,
      sym__name,
    STATE(7043), 1,
      sym_attribute,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5840), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222062] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8950), 1,
      anon_sym_in,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5841), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [222147] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8952), 1,
      anon_sym_LBRACK,
    ACTIONS(8955), 1,
      aux_sym_preproc_if_token1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5842), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__class_declaration_initializer_repeat1,
    ACTIONS(4771), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [222230] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    ACTIONS(8958), 1,
      anon_sym_in,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(5843), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3678), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [222315] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(5075), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 1,
      aux_sym_preproc_if_token1,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(5842), 1,
      aux_sym__class_declaration_initializer_repeat1,
    STATE(5984), 1,
      sym__attribute_list,
    STATE(6761), 1,
      sym_identifier,
    STATE(5983), 2,
      sym_attribute_list,
      sym_preproc_if_in_attribute_list,
    STATE(5844), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222406] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN,
    STATE(5845), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2719), 30,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [222483] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6717), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5846), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222569] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7646), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5847), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222659] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8964), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5848), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222749] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(8966), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(6986), 1,
      sym__variable_designation,
    STATE(5849), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222839] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7811), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5850), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [222929] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6753), 1,
      sym_identifier,
    STATE(7100), 1,
      sym_using_variable_declarator,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5851), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223019] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8968), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6341), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5852), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223109] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8970), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5853), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223199] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7815), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5854), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223289] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7905), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5855), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223379] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7851), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5856), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223469] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4835), 5,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5857), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4833), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [223545] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8972), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5858), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223635] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(8974), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(6955), 1,
      sym__variable_designation,
    STATE(5859), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223725] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6446), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5860), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223811] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6592), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5861), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223897] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7588), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5862), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [223987] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(7040), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5863), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224073] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7590), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5864), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224163] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8976), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5865), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224253] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7745), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5866), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224343] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7598), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5867), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224433] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8978), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5868), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224523] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(8980), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(6855), 1,
      sym__variable_designation,
    STATE(5869), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224613] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8982), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5870), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224703] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7914), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5871), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224793] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7685), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5872), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224883] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8984), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5873), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [224973] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym_identifier,
    STATE(6731), 1,
      sym__name,
    STATE(4123), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5874), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225059] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8986), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5875), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225149] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7765), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5876), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225239] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8988), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5877), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225329] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4753), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(4745), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(7655), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(5878), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [225413] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7807), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5879), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225503] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8990), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5880), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225593] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(8992), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(4745), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(7437), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(5881), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [225677] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8994), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5882), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225767] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7797), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5883), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225857] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7875), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5884), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [225947] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4819), 5,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5885), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4817), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [226023] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7753), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5886), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226113] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(8996), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5887), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226203] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7584), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5888), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226293] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7586), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5889), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226383] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7857), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5890), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226473] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9003), 1,
      anon_sym_LPAREN,
    ACTIONS(9000), 2,
      anon_sym_static,
      anon_sym_async,
    STATE(5891), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__lambda_expression_init_repeat1,
    ACTIONS(8998), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [226551] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7867), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5892), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226641] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7535), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5893), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226731] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(9005), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(6940), 1,
      sym__variable_designation,
    STATE(5894), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226821] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7759), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5895), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [226911] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9007), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5896), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227001] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9009), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5897), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227091] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7701), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5898), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227181] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8968), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6448), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5899), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227271] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9011), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5900), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227361] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    ACTIONS(9013), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(7059), 1,
      sym__variable_designation,
    STATE(5901), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227451] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7767), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5902), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227541] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9015), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5903), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227631] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7873), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5904), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227721] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9017), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5905), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227811] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4809), 5,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5906), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4807), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [227887] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9019), 1,
      anon_sym_DOT,
    ACTIONS(4028), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(5907), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4026), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [227965] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9021), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5908), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228055] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4825), 5,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5909), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4823), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [228131] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9023), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5910), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228221] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9025), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5911), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228311] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9027), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5912), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228401] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9029), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5913), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228491] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9031), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5914), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228581] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9033), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5915), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228671] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(7592), 1,
      anon_sym_RPAREN,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5916), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228761] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9035), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6758), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5917), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [228851] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9037), 1,
      anon_sym_DOT,
    STATE(5918), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [228936] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(8968), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(7157), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7766), 1,
      sym_tuple_pattern,
    STATE(5919), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [229023] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4763), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9039), 1,
      anon_sym_DOT,
    STATE(5920), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229108] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6903), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5921), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [229195] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9041), 1,
      anon_sym_DOT,
    STATE(5922), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229280] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9043), 1,
      anon_sym_DOT,
    STATE(5923), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229365] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9045), 1,
      anon_sym_DOT,
    STATE(5924), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229450] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(4801), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(5925), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229533] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    STATE(5926), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229618] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9049), 1,
      anon_sym_DOT,
    STATE(5927), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229703] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9051), 1,
      anon_sym_DOT,
    STATE(5928), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229788] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9053), 1,
      anon_sym_DOT,
    STATE(5929), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [229873] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(3913), 1,
      sym_discard,
    ACTIONS(4007), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(3545), 1,
      sym_parenthesized_variable_designation,
    STATE(3547), 1,
      sym_identifier,
    STATE(7314), 1,
      sym__variable_designation,
    STATE(5930), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [229960] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9055), 1,
      anon_sym_DOT,
    STATE(5931), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230045] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_DOT,
    STATE(5932), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230130] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9059), 1,
      anon_sym_DOT,
    STATE(5933), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230215] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9061), 1,
      anon_sym_DOT,
    STATE(5934), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230300] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9053), 1,
      anon_sym_DOT,
    STATE(5935), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230385] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9059), 1,
      anon_sym_DOT,
    STATE(5936), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230470] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9061), 1,
      anon_sym_DOT,
    STATE(5937), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230555] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6857), 1,
      sym_identifier,
    ACTIONS(9063), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    STATE(5938), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [230636] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9067), 1,
      anon_sym_LPAREN,
    STATE(5939), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9065), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230711] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9069), 1,
      anon_sym_DOT,
    STATE(5940), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230796] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9071), 1,
      anon_sym_DOT,
    STATE(5941), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230881] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(4421), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(5942), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [230964] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9073), 1,
      anon_sym_DOT,
    STATE(5943), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231049] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7224), 1,
      sym_identifier,
    ACTIONS(9075), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    STATE(5944), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [231130] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(9077), 1,
      anon_sym_SEMI,
    STATE(5945), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231215] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4421), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9079), 1,
      anon_sym_DOT,
    STATE(5946), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231300] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    ACTIONS(8968), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(7304), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7612), 1,
      sym_tuple_pattern,
    STATE(5947), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [231387] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8874), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    STATE(4415), 1,
      sym_identifier,
    ACTIONS(8882), 2,
      anon_sym_operator,
      anon_sym_this,
    STATE(5948), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8877), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [231472] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9081), 1,
      anon_sym_DOT,
    STATE(5949), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231557] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9083), 1,
      anon_sym_DOT,
    STATE(5950), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231642] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9087), 1,
      anon_sym_LPAREN,
    STATE(5951), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9085), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_checked,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231717] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(4138), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(5952), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231800] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(9089), 1,
      anon_sym_SEMI,
    STATE(5953), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231885] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9055), 1,
      anon_sym_DOT,
    STATE(5954), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [231970] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(4763), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(5955), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [232053] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9083), 1,
      anon_sym_DOT,
    STATE(5956), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [232138] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DASH_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_DOT,
    STATE(5957), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4022), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [232223] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9095), 1,
      anon_sym_LPAREN,
    STATE(5958), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9093), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [232298] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6714), 1,
      sym_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(5959), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232382] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7438), 1,
      sym__lambda_parameters,
    STATE(7710), 1,
      sym_identifier,
    STATE(5960), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232466] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9097), 1,
      anon_sym_COMMA,
    ACTIONS(9099), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6863), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5961), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232550] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6677), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(7088), 1,
      sym_variable_declarator,
    STATE(5962), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232634] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6378), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(5963), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232718] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7454), 1,
      sym__lambda_parameters,
    STATE(7710), 1,
      sym_identifier,
    STATE(5964), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232802] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9101), 1,
      anon_sym_COMMA,
    ACTIONS(9103), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7042), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5965), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232886] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9105), 1,
      anon_sym_COMMA,
    ACTIONS(9107), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6916), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5966), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [232970] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7347), 1,
      sym__lambda_parameters,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7710), 1,
      sym_identifier,
    STATE(5967), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233054] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6630), 1,
      sym_identifier,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7454), 1,
      sym__lambda_parameters,
    STATE(5968), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233138] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6536), 1,
      sym_tuple_pattern,
    STATE(6587), 1,
      sym_identifier,
    STATE(6974), 1,
      sym_variable_declarator,
    STATE(5969), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233222] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6751), 1,
      sym_identifier,
    STATE(7385), 1,
      sym_parameter_list,
    STATE(7454), 1,
      sym__lambda_parameters,
    STATE(5970), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233306] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9109), 1,
      anon_sym_COMMA,
    ACTIONS(9111), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6919), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5971), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233390] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6536), 1,
      sym_tuple_pattern,
    STATE(6587), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_variable_declarator,
    STATE(5972), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233474] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    ACTIONS(9113), 1,
      sym_discard,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7229), 1,
      sym_tuple_pattern,
    STATE(7334), 1,
      sym_identifier,
    STATE(5973), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233558] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(4739), 1,
      sym_discard,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6933), 1,
      sym_identifier,
    STATE(7084), 1,
      sym_tuple_pattern,
    STATE(5974), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233642] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8196), 1,
      anon_sym_LPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6677), 1,
      sym_identifier,
    STATE(6685), 1,
      sym_tuple_pattern,
    STATE(6966), 1,
      sym_variable_declarator,
    STATE(5975), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233726] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9115), 1,
      anon_sym_COMMA,
    ACTIONS(9117), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6844), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5976), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233810] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9119), 1,
      anon_sym_COMMA,
    ACTIONS(9121), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7046), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5977), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233894] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9123), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7384), 1,
      sym_identifier,
    ACTIONS(9129), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(5978), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9126), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [233973] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9131), 1,
      sym__identifier_token,
    STATE(2673), 1,
      sym_identifier,
    STATE(2738), 1,
      sym__simple_name,
    STATE(2809), 1,
      sym_generic_name,
    STATE(2849), 1,
      sym__reserved_identifier,
    STATE(5979), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9133), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234054] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9135), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(5980), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234135] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6330), 1,
      sym_identifier,
    ACTIONS(9137), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5981), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234214] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4028), 1,
      sym_identifier,
    STATE(4112), 1,
      sym__simple_name,
    STATE(4135), 1,
      sym_generic_name,
    STATE(5982), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234295] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4745), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(5983), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [234368] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5103), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(5984), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5101), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [234441] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4086), 1,
      sym__identifier_token,
    STATE(4318), 1,
      sym__reserved_identifier,
    STATE(4382), 1,
      sym_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4448), 1,
      sym__simple_name,
    STATE(5985), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4088), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234522] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4086), 1,
      sym__identifier_token,
    STATE(4318), 1,
      sym__reserved_identifier,
    STATE(4382), 1,
      sym_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4459), 1,
      sym__simple_name,
    STATE(5986), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4088), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234603] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2206), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(5987), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234684] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9143), 1,
      sym__identifier_token,
    STATE(2402), 1,
      sym_identifier,
    STATE(2436), 1,
      sym__reserved_identifier,
    STATE(2465), 1,
      sym__simple_name,
    STATE(2472), 1,
      sym_generic_name,
    STATE(5988), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9145), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234765] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2953), 1,
      sym__simple_name,
    STATE(5989), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234846] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4096), 1,
      sym__identifier_token,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2380), 1,
      sym_identifier,
    STATE(2403), 1,
      sym__simple_name,
    STATE(2418), 1,
      sym_generic_name,
    STATE(5990), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [234927] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2414), 1,
      sym__simple_name,
    STATE(5991), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235008] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9147), 1,
      sym__identifier_token,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    STATE(5294), 1,
      sym__reserved_identifier,
    STATE(6325), 1,
      sym_identifier,
    STATE(5992), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9149), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235089] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2995), 1,
      sym_identifier,
    STATE(3019), 1,
      sym__simple_name,
    STATE(3102), 1,
      sym_generic_name,
    STATE(5993), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235170] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9151), 1,
      sym__identifier_token,
    STATE(2258), 1,
      sym_identifier,
    STATE(2272), 1,
      sym_generic_name,
    STATE(2282), 1,
      sym__reserved_identifier,
    STATE(2285), 1,
      sym__simple_name,
    STATE(5994), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9153), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235251] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2995), 1,
      sym_identifier,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3145), 1,
      sym__simple_name,
    STATE(5995), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235332] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2200), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(5996), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235413] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6315), 1,
      sym_identifier,
    ACTIONS(9155), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5997), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235492] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4112), 1,
      sym__simple_name,
    STATE(4415), 1,
      sym_identifier,
    STATE(5998), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235573] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9147), 1,
      sym__identifier_token,
    STATE(4112), 1,
      sym__simple_name,
    STATE(4135), 1,
      sym_generic_name,
    STATE(5294), 1,
      sym__reserved_identifier,
    STATE(6325), 1,
      sym_identifier,
    STATE(5999), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9149), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235654] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2336), 1,
      sym__simple_name,
    STATE(6000), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235735] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2196), 1,
      sym__simple_name,
    STATE(6001), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235816] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6320), 1,
      sym_identifier,
    ACTIONS(9157), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6002), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235895] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(3182), 1,
      sym_identifier,
    STATE(3189), 1,
      sym__simple_name,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6003), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [235976] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2387), 1,
      sym__simple_name,
    STATE(6004), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236057] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2197), 1,
      sym__simple_name,
    STATE(6005), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236138] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2328), 1,
      sym__simple_name,
    STATE(6006), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236219] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2265), 1,
      sym__simple_name,
    STATE(6007), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236300] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(2995), 1,
      sym_identifier,
    STATE(3019), 1,
      sym__simple_name,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6008), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236381] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2329), 1,
      sym__simple_name,
    STATE(6009), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236462] = 17,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(9159), 1,
      sym_integer_literal,
    ACTIONS(9161), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(7060), 1,
      sym_identifier,
    STATE(6010), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236543] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4096), 1,
      sym__identifier_token,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2380), 1,
      sym_identifier,
    STATE(2418), 1,
      sym_generic_name,
    STATE(3929), 1,
      sym__simple_name,
    STATE(6011), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236624] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3207), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3385), 1,
      sym__simple_name,
    STATE(6012), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236705] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(2935), 1,
      sym_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2990), 1,
      sym__simple_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6013), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236786] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(2935), 1,
      sym_identifier,
    STATE(2957), 1,
      sym__simple_name,
    STATE(2964), 1,
      sym_generic_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6014), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236867] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(3182), 1,
      sym_identifier,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(3389), 1,
      sym__simple_name,
    STATE(6015), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [236948] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2195), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(6016), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237029] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3207), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3386), 1,
      sym__simple_name,
    STATE(6017), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237110] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3891), 1,
      sym__identifier_token,
    STATE(2980), 1,
      sym__reserved_identifier,
    STATE(2995), 1,
      sym_identifier,
    STATE(3054), 1,
      sym__simple_name,
    STATE(3102), 1,
      sym_generic_name,
    STATE(6018), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3893), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237191] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2345), 1,
      sym__simple_name,
    STATE(6019), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237272] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6826), 1,
      sym_identifier,
    STATE(6020), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237353] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(4028), 1,
      sym_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    STATE(6021), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237434] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2288), 1,
      sym__simple_name,
    STATE(6022), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237515] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2375), 1,
      sym__simple_name,
    STATE(6023), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237596] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2294), 1,
      sym__simple_name,
    STATE(6024), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237677] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(3207), 1,
      sym_identifier,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3442), 1,
      sym__simple_name,
    STATE(6025), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237758] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9151), 1,
      sym__identifier_token,
    STATE(2258), 1,
      sym_identifier,
    STATE(2264), 1,
      sym__simple_name,
    STATE(2272), 1,
      sym_generic_name,
    STATE(2282), 1,
      sym__reserved_identifier,
    STATE(6026), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9153), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237839] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6826), 1,
      sym_identifier,
    STATE(6027), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [237920] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2346), 1,
      sym__simple_name,
    STATE(6028), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238001] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2400), 1,
      sym__simple_name,
    STATE(6029), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238082] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5061), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(6030), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5059), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [238155] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2204), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(6031), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238236] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9183), 1,
      sym__identifier_token,
    STATE(2380), 1,
      sym_identifier,
    STATE(2403), 1,
      sym__simple_name,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2662), 1,
      sym__reserved_identifier,
    STATE(6032), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9185), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238317] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(4191), 1,
      sym__simple_name,
    STATE(4415), 1,
      sym_identifier,
    STATE(6033), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238398] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(2935), 1,
      sym_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(3086), 1,
      sym__simple_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6034), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238479] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2406), 1,
      sym__simple_name,
    STATE(6035), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238560] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9187), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6036), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238641] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    STATE(4415), 1,
      sym_identifier,
    STATE(6037), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238722] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9151), 1,
      sym__identifier_token,
    STATE(2258), 1,
      sym_identifier,
    STATE(2272), 1,
      sym_generic_name,
    STATE(2282), 1,
      sym__reserved_identifier,
    STATE(2320), 1,
      sym__simple_name,
    STATE(6038), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9153), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238803] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5073), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(6039), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5071), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [238876] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6823), 1,
      sym_identifier,
    STATE(6040), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [238957] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2386), 1,
      sym__simple_name,
    STATE(6041), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239038] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    STATE(2935), 1,
      sym_identifier,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(3086), 1,
      sym__simple_name,
    STATE(6042), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239119] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2303), 1,
      sym__simple_name,
    STATE(6043), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239200] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2317), 1,
      sym__simple_name,
    STATE(6044), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239281] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6823), 1,
      sym_identifier,
    STATE(6045), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239362] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4086), 1,
      sym__identifier_token,
    STATE(4318), 1,
      sym__reserved_identifier,
    STATE(4382), 1,
      sym_identifier,
    STATE(4419), 1,
      sym_generic_name,
    STATE(4679), 1,
      sym__simple_name,
    STATE(6046), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4088), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239443] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2362), 1,
      sym__simple_name,
    STATE(6047), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239524] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9189), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6048), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239605] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9191), 1,
      sym__identifier_token,
    STATE(2599), 1,
      sym_identifier,
    STATE(2626), 1,
      sym_generic_name,
    STATE(2645), 1,
      sym__simple_name,
    STATE(2665), 1,
      sym__reserved_identifier,
    STATE(6049), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9193), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239686] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2200), 1,
      sym__simple_name,
    STATE(6050), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239767] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2223), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(6051), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239848] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2362), 1,
      sym__simple_name,
    STATE(6052), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [239929] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(2995), 1,
      sym_identifier,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3145), 1,
      sym__simple_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6053), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240010] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9195), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6054), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240091] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9197), 1,
      anon_sym_operator,
    ACTIONS(9199), 1,
      anon_sym_this,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6390), 1,
      sym_identifier,
    STATE(6055), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240172] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(4112), 1,
      sym__simple_name,
    STATE(6342), 1,
      sym_identifier,
    STATE(6056), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240253] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2360), 1,
      sym__simple_name,
    STATE(6057), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240334] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2204), 1,
      sym__simple_name,
    STATE(6058), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240415] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2366), 1,
      sym__simple_name,
    STATE(6059), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240496] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9201), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6060), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240577] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9151), 1,
      sym__identifier_token,
    STATE(2258), 1,
      sym_identifier,
    STATE(2261), 1,
      sym__simple_name,
    STATE(2272), 1,
      sym_generic_name,
    STATE(2282), 1,
      sym__reserved_identifier,
    STATE(6061), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9153), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240658] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(2995), 1,
      sym_identifier,
    STATE(3054), 1,
      sym__simple_name,
    STATE(3102), 1,
      sym_generic_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6062), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240739] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9203), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6063), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240820] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7321), 1,
      sym_identifier,
    ACTIONS(8960), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6064), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240899] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9151), 1,
      sym__identifier_token,
    STATE(2258), 1,
      sym_identifier,
    STATE(2272), 1,
      sym_generic_name,
    STATE(2282), 1,
      sym__reserved_identifier,
    STATE(2311), 1,
      sym__simple_name,
    STATE(6065), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9153), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [240980] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2266), 1,
      sym__simple_name,
    STATE(6066), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241061] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9123), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7743), 1,
      sym_identifier,
    ACTIONS(9129), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(6067), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9126), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241140] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2196), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(6068), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241221] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2308), 1,
      sym__simple_name,
    STATE(6069), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241302] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4096), 1,
      sym__identifier_token,
    STATE(2374), 1,
      sym__reserved_identifier,
    STATE(2380), 1,
      sym_identifier,
    STATE(2407), 1,
      sym__simple_name,
    STATE(2418), 1,
      sym_generic_name,
    STATE(6070), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4098), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241383] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9205), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6071), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241464] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9123), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7372), 1,
      sym_identifier,
    ACTIONS(9129), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(6072), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9126), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241543] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(4191), 1,
      sym__simple_name,
    STATE(6342), 1,
      sym_identifier,
    STATE(6073), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241624] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2265), 1,
      sym__simple_name,
    STATE(6074), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241705] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9147), 1,
      sym__identifier_token,
    STATE(4028), 1,
      sym_identifier,
    STATE(4112), 1,
      sym__simple_name,
    STATE(4135), 1,
      sym_generic_name,
    STATE(5294), 1,
      sym__reserved_identifier,
    STATE(6075), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9149), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241786] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3787), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(6076), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3785), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [241859] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2435), 1,
      sym__simple_name,
    STATE(6077), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [241940] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9207), 1,
      anon_sym_operator,
    ACTIONS(9209), 1,
      anon_sym_this,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6387), 1,
      sym_identifier,
    STATE(6078), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242021] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(3207), 1,
      sym_identifier,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3386), 1,
      sym__simple_name,
    STATE(6079), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242102] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9211), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6080), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242183] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9213), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6081), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242264] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2404), 1,
      sym__simple_name,
    STATE(6082), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242345] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2294), 1,
      sym__simple_name,
    STATE(6083), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242426] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(2634), 1,
      sym_identifier,
    STATE(2805), 1,
      sym__simple_name,
    STATE(2847), 1,
      sym_generic_name,
    STATE(6084), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242507] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5057), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(6085), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5055), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [242580] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9215), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6086), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242661] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2267), 1,
      sym__simple_name,
    STATE(6087), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242742] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2388), 1,
      sym__simple_name,
    STATE(6088), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242823] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2195), 1,
      sym__simple_name,
    STATE(6089), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242904] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(3207), 1,
      sym_identifier,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3385), 1,
      sym__simple_name,
    STATE(6090), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [242985] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9183), 1,
      sym__identifier_token,
    STATE(2380), 1,
      sym_identifier,
    STATE(2407), 1,
      sym__simple_name,
    STATE(2418), 1,
      sym_generic_name,
    STATE(2662), 1,
      sym__reserved_identifier,
    STATE(6091), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9185), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243066] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9217), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6092), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243147] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9219), 1,
      anon_sym_operator,
    ACTIONS(9221), 1,
      anon_sym_this,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6392), 1,
      sym_identifier,
    STATE(6093), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243228] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3798), 1,
      sym__identifier_token,
    STATE(3192), 1,
      sym__reserved_identifier,
    STATE(3207), 1,
      sym_identifier,
    STATE(3347), 1,
      sym_generic_name,
    STATE(3442), 1,
      sym__simple_name,
    STATE(6094), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3800), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243309] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2266), 1,
      sym__simple_name,
    STATE(6095), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243390] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(4112), 1,
      sym__simple_name,
    STATE(4415), 1,
      sym_identifier,
    STATE(6096), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243471] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3897), 1,
      sym__identifier_token,
    STATE(3182), 1,
      sym_identifier,
    STATE(3205), 1,
      sym_generic_name,
    STATE(3217), 1,
      sym__simple_name,
    STATE(3241), 1,
      sym__reserved_identifier,
    STATE(6097), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3899), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243552] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2350), 1,
      sym__simple_name,
    STATE(6098), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243633] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9223), 1,
      sym__identifier_token,
    STATE(3181), 1,
      sym_identifier,
    STATE(3201), 1,
      sym__simple_name,
    STATE(3208), 1,
      sym_generic_name,
    STATE(3251), 1,
      sym__reserved_identifier,
    STATE(6099), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9225), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243714] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3787), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    ACTIONS(9227), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6100), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3785), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [243789] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2288), 1,
      sym__simple_name,
    STATE(6101), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243870] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    STATE(2935), 1,
      sym_identifier,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2964), 1,
      sym_generic_name,
    STATE(2990), 1,
      sym__simple_name,
    STATE(6102), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [243951] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9229), 1,
      anon_sym_RBRACE,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6103), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244032] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2247), 1,
      sym__simple_name,
    STATE(6104), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244113] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2352), 1,
      sym__simple_name,
    STATE(6105), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244194] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9131), 1,
      sym__identifier_token,
    STATE(2673), 1,
      sym_identifier,
    STATE(2737), 1,
      sym__simple_name,
    STATE(2809), 1,
      sym_generic_name,
    STATE(2849), 1,
      sym__reserved_identifier,
    STATE(6106), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9133), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244275] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym__identifier_token,
    STATE(2935), 1,
      sym_identifier,
    STATE(2952), 1,
      sym__reserved_identifier,
    STATE(2957), 1,
      sym__simple_name,
    STATE(2964), 1,
      sym_generic_name,
    STATE(6107), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3871), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244356] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2223), 1,
      sym__simple_name,
    STATE(6108), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244437] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2303), 1,
      sym__simple_name,
    STATE(6109), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244518] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9147), 1,
      sym__identifier_token,
    STATE(4028), 1,
      sym_identifier,
    STATE(4135), 1,
      sym_generic_name,
    STATE(4191), 1,
      sym__simple_name,
    STATE(5294), 1,
      sym__reserved_identifier,
    STATE(6110), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9149), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244599] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(2352), 1,
      sym__simple_name,
    STATE(6111), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244680] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2247), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(6112), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244761] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9123), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7606), 1,
      sym_identifier,
    ACTIONS(9129), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(6113), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9126), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244840] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2206), 1,
      sym__simple_name,
    STATE(6114), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [244921] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2383), 1,
      sym__simple_name,
    STATE(6115), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245002] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2353), 1,
      sym__simple_name,
    STATE(6116), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245083] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9139), 1,
      sym__identifier_token,
    STATE(2187), 1,
      sym_generic_name,
    STATE(2193), 1,
      sym_identifier,
    STATE(2197), 1,
      sym__simple_name,
    STATE(2254), 1,
      sym__reserved_identifier,
    STATE(6117), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9141), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245164] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4973), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(4745), 2,
      anon_sym_LBRACK,
      aux_sym_preproc_if_token1,
    STATE(6118), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4743), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [245238] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(9231), 1,
      anon_sym_RPAREN,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7500), 1,
      sym_identifier,
    STATE(6119), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245316] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9235), 2,
      anon_sym_unsafe,
      anon_sym_static,
    STATE(6120), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_using_directive_repeat1,
    ACTIONS(9233), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [245388] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6866), 1,
      sym_identifier,
    STATE(6121), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245466] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6797), 1,
      sym_identifier,
    STATE(7113), 1,
      sym_using_variable_declarator,
    STATE(6122), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245544] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7342), 1,
      sym_with_initializer,
    STATE(7747), 1,
      sym_identifier,
    STATE(6123), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245622] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7922), 1,
      sym__identifier_token,
    ACTIONS(9238), 1,
      sym_integer_literal,
    STATE(6483), 1,
      sym__reserved_identifier,
    STATE(7310), 1,
      sym_identifier,
    STATE(6124), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7924), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245700] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6348), 1,
      sym_identifier,
    STATE(6125), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245775] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6241), 1,
      sym_identifier,
    STATE(6126), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245850] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6263), 1,
      sym_identifier,
    STATE(6127), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [245925] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6742), 1,
      sym_identifier,
    STATE(6128), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246000] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6332), 1,
      sym_identifier,
    STATE(6129), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246075] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6255), 1,
      sym_identifier,
    STATE(6130), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246150] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6347), 1,
      sym_identifier,
    STATE(6131), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246225] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6300), 1,
      sym_identifier,
    STATE(6132), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246300] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6775), 1,
      sym_identifier,
    STATE(6133), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246375] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6304), 1,
      sym_identifier,
    STATE(6134), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246450] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6702), 1,
      sym_identifier,
    STATE(6135), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246525] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6296), 1,
      sym_identifier,
    STATE(6136), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246600] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6326), 1,
      sym_identifier,
    STATE(6137), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246675] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6295), 1,
      sym_identifier,
    STATE(6138), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246750] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6320), 1,
      sym_identifier,
    STATE(6139), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246825] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6283), 1,
      sym_identifier,
    STATE(6140), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246900] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6275), 1,
      sym_identifier,
    STATE(6141), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [246975] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(7122), 1,
      sym_identifier,
    STATE(6142), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247050] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6290), 1,
      sym_identifier,
    STATE(6143), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247125] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6767), 1,
      sym_identifier,
    STATE(6144), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247200] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6288), 1,
      sym_identifier,
    STATE(6145), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247275] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6256), 1,
      sym_identifier,
    STATE(6146), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247350] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6259), 1,
      sym_identifier,
    STATE(6147), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247425] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6276), 1,
      sym_identifier,
    STATE(6148), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247500] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7708), 1,
      sym_identifier,
    STATE(6149), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247575] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7236), 1,
      sym_identifier,
    STATE(6150), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247650] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6252), 1,
      sym_identifier,
    STATE(6151), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247725] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6298), 1,
      sym_identifier,
    STATE(6152), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247800] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6285), 1,
      sym_identifier,
    STATE(6153), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247875] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6848), 1,
      sym_identifier,
    STATE(6154), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [247950] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7349), 1,
      sym_identifier,
    STATE(6155), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248025] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6413), 1,
      sym_identifier,
    STATE(6156), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248100] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6311), 1,
      sym_identifier,
    STATE(6157), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248175] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6328), 1,
      sym_identifier,
    STATE(6158), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248250] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6260), 1,
      sym_identifier,
    STATE(6159), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248325] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6270), 1,
      sym_identifier,
    STATE(6160), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248400] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6785), 1,
      sym_identifier,
    STATE(6161), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248475] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6319), 1,
      sym_identifier,
    STATE(6162), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248550] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6733), 1,
      sym_identifier,
    STATE(6163), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248625] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6329), 1,
      sym_identifier,
    STATE(6164), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248700] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7246), 1,
      sym_identifier,
    STATE(6165), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248775] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6372), 1,
      sym_identifier,
    STATE(6166), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248850] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6750), 1,
      sym_identifier,
    STATE(6167), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [248925] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(6168), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9129), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [248994] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7583), 1,
      sym_identifier,
    STATE(6169), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249069] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6310), 1,
      sym_identifier,
    STATE(6170), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249144] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6820), 1,
      sym_identifier,
    STATE(6171), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249219] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6737), 1,
      sym_identifier,
    STATE(6172), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249294] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(7231), 1,
      sym_identifier,
    STATE(6173), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249369] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6277), 1,
      sym_identifier,
    STATE(6174), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249444] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6330), 1,
      sym_identifier,
    STATE(6175), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249519] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym__identifier_token,
    STATE(3728), 1,
      sym__reserved_identifier,
    STATE(7147), 1,
      sym_identifier,
    STATE(6176), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249594] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(7351), 1,
      sym_identifier,
    STATE(6177), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249669] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6271), 1,
      sym_identifier,
    STATE(6178), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249744] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6959), 1,
      sym_identifier,
    STATE(6179), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249819] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(7348), 1,
      sym_identifier,
    STATE(6180), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249894] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6772), 1,
      sym_identifier,
    STATE(6181), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [249969] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(6317), 1,
      sym_identifier,
    STATE(6182), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [250044] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6273), 1,
      sym_identifier,
    STATE(6183), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [250119] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(25), 1,
      sym__identifier_token,
    STATE(2182), 1,
      sym__reserved_identifier,
    STATE(6713), 1,
      sym_identifier,
    STATE(6184), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(29), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [250194] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6985), 1,
      sym__identifier_token,
    STATE(2616), 1,
      sym__reserved_identifier,
    STATE(7692), 1,
      sym_identifier,
    STATE(6185), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6987), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [250269] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9242), 1,
      anon_sym_checked,
    ACTIONS(9240), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6186), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9244), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250341] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9248), 1,
      anon_sym_checked,
    ACTIONS(9246), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6187), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9250), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250413] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9254), 1,
      anon_sym_checked,
    ACTIONS(9252), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6188), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9256), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250485] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9260), 1,
      anon_sym_checked,
    ACTIONS(9258), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6189), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9262), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250557] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9266), 1,
      anon_sym_checked,
    ACTIONS(9264), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6190), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9268), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250629] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9272), 1,
      anon_sym_checked,
    ACTIONS(9270), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6191), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9274), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250701] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9276), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6192), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9278), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250770] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9280), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6193), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9282), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250839] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9270), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6194), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9274), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250908] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9284), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6195), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9286), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250977] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    STATE(6196), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9288), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [251044] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9240), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6197), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9244), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [251113] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9246), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(6198), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9250), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [251182] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9300), 1,
      anon_sym_group,
    ACTIONS(9302), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(5133), 1,
      sym__select_or_group_clause,
    STATE(6265), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6199), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251268] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9304), 1,
      anon_sym_group,
    ACTIONS(9306), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(4820), 1,
      sym__select_or_group_clause,
    STATE(6246), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6200), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251354] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9308), 1,
      anon_sym_group,
    ACTIONS(9310), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(4821), 1,
      sym__select_or_group_clause,
    STATE(6289), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6201), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251440] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9312), 1,
      anon_sym_group,
    ACTIONS(9314), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(4155), 1,
      sym__select_or_group_clause,
    STATE(6268), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6202), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251526] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9316), 1,
      anon_sym_group,
    ACTIONS(9318), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(5121), 1,
      sym__select_or_group_clause,
    STATE(6282), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6203), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251612] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9320), 1,
      anon_sym_group,
    ACTIONS(9322), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(4181), 1,
      sym__select_or_group_clause,
    STATE(6266), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6204), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251698] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9324), 1,
      anon_sym_group,
    ACTIONS(9326), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(5696), 1,
      sym__select_or_group_clause,
    STATE(6293), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6205), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251784] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9328), 1,
      anon_sym_group,
    ACTIONS(9330), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(5687), 1,
      sym__select_or_group_clause,
    STATE(6253), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6206), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251870] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9332), 1,
      anon_sym_group,
    ACTIONS(9334), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(4005), 1,
      sym__select_or_group_clause,
    STATE(6247), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6207), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [251956] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9336), 1,
      anon_sym_group,
    ACTIONS(9338), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(5126), 1,
      sym__select_or_group_clause,
    STATE(6262), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6208), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252042] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9340), 1,
      anon_sym_group,
    ACTIONS(9342), 1,
      anon_sym_select,
    STATE(4641), 1,
      sym__query_body,
    STATE(5160), 1,
      sym__select_or_group_clause,
    STATE(6250), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6209), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252128] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9344), 1,
      anon_sym_group,
    ACTIONS(9346), 1,
      anon_sym_select,
    STATE(3877), 1,
      sym__query_body,
    STATE(3986), 1,
      sym__select_or_group_clause,
    STATE(6258), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6210), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252214] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9348), 1,
      anon_sym_group,
    ACTIONS(9350), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(4259), 1,
      sym__select_or_group_clause,
    STATE(6264), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6211), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252300] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9304), 1,
      anon_sym_group,
    ACTIONS(9306), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(4820), 1,
      sym__select_or_group_clause,
    STATE(6246), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6212), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252386] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9332), 1,
      anon_sym_group,
    ACTIONS(9334), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(4005), 1,
      sym__select_or_group_clause,
    STATE(6247), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6213), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252472] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9324), 1,
      anon_sym_group,
    ACTIONS(9326), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(5696), 1,
      sym__select_or_group_clause,
    STATE(6293), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6214), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252558] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9352), 1,
      anon_sym_group,
    ACTIONS(9354), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(5152), 1,
      sym__select_or_group_clause,
    STATE(6292), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6215), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252644] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9356), 1,
      anon_sym_group,
    ACTIONS(9358), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(4364), 1,
      sym__select_or_group_clause,
    STATE(6242), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6216), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252730] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9360), 1,
      anon_sym_group,
    ACTIONS(9362), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(5677), 1,
      sym__select_or_group_clause,
    STATE(6254), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6217), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252816] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9336), 1,
      anon_sym_group,
    ACTIONS(9338), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(5126), 1,
      sym__select_or_group_clause,
    STATE(6262), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6218), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252902] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9316), 1,
      anon_sym_group,
    ACTIONS(9318), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(5121), 1,
      sym__select_or_group_clause,
    STATE(6282), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6219), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [252988] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9364), 1,
      anon_sym_group,
    ACTIONS(9366), 1,
      anon_sym_select,
    STATE(3698), 1,
      sym__select_or_group_clause,
    STATE(3877), 1,
      sym__query_body,
    STATE(6291), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6220), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253074] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9368), 1,
      anon_sym_group,
    ACTIONS(9370), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(5554), 1,
      sym__select_or_group_clause,
    STATE(6239), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6221), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253160] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9372), 1,
      anon_sym_group,
    ACTIONS(9374), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(5116), 1,
      sym__select_or_group_clause,
    STATE(6245), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6222), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253246] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9356), 1,
      anon_sym_group,
    ACTIONS(9358), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(4364), 1,
      sym__select_or_group_clause,
    STATE(6242), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6223), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253332] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9360), 1,
      anon_sym_group,
    ACTIONS(9362), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(5677), 1,
      sym__select_or_group_clause,
    STATE(6254), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6224), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253418] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9368), 1,
      anon_sym_group,
    ACTIONS(9370), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(5554), 1,
      sym__select_or_group_clause,
    STATE(6239), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6225), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253504] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9376), 1,
      anon_sym_group,
    ACTIONS(9378), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(4863), 1,
      sym__select_or_group_clause,
    STATE(6269), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6226), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253590] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9380), 1,
      anon_sym_group,
    ACTIONS(9382), 1,
      anon_sym_select,
    STATE(4522), 1,
      sym__select_or_group_clause,
    STATE(4641), 1,
      sym__query_body,
    STATE(6278), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6227), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253676] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9328), 1,
      anon_sym_group,
    ACTIONS(9330), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(5687), 1,
      sym__select_or_group_clause,
    STATE(6253), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6228), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253762] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9376), 1,
      anon_sym_group,
    ACTIONS(9378), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(4863), 1,
      sym__select_or_group_clause,
    STATE(6269), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6229), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253848] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9384), 1,
      anon_sym_group,
    ACTIONS(9386), 1,
      anon_sym_select,
    STATE(3156), 1,
      sym__query_body,
    STATE(5692), 1,
      sym__select_or_group_clause,
    STATE(6243), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6230), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [253934] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9320), 1,
      anon_sym_group,
    ACTIONS(9322), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(4181), 1,
      sym__select_or_group_clause,
    STATE(6266), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6231), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254020] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9372), 1,
      anon_sym_group,
    ACTIONS(9374), 1,
      anon_sym_select,
    STATE(3289), 1,
      sym__query_body,
    STATE(5116), 1,
      sym__select_or_group_clause,
    STATE(6245), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6232), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254106] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9352), 1,
      anon_sym_group,
    ACTIONS(9354), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(5152), 1,
      sym__select_or_group_clause,
    STATE(6292), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6233), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254192] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9384), 1,
      anon_sym_group,
    ACTIONS(9386), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(5692), 1,
      sym__select_or_group_clause,
    STATE(6243), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6234), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254278] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9308), 1,
      anon_sym_group,
    ACTIONS(9310), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(4821), 1,
      sym__select_or_group_clause,
    STATE(6289), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6235), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254364] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9300), 1,
      anon_sym_group,
    ACTIONS(9302), 1,
      anon_sym_select,
    STATE(3416), 1,
      sym__query_body,
    STATE(5133), 1,
      sym__select_or_group_clause,
    STATE(6265), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6236), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254450] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9312), 1,
      anon_sym_group,
    ACTIONS(9314), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(4155), 1,
      sym__select_or_group_clause,
    STATE(6268), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6237), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254536] = 24,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9348), 1,
      anon_sym_group,
    ACTIONS(9350), 1,
      anon_sym_select,
    STATE(3083), 1,
      sym__query_body,
    STATE(4259), 1,
      sym__select_or_group_clause,
    STATE(6264), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6238), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254622] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9368), 1,
      anon_sym_group,
    ACTIONS(9370), 1,
      anon_sym_select,
    STATE(5703), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6239), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254705] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9336), 1,
      anon_sym_group,
    ACTIONS(9338), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6240), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254788] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9360), 1,
      anon_sym_group,
    ACTIONS(9362), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6302), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6241), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254871] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9356), 1,
      anon_sym_group,
    ACTIONS(9358), 1,
      anon_sym_select,
    STATE(4366), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6242), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [254954] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9384), 1,
      anon_sym_group,
    ACTIONS(9386), 1,
      anon_sym_select,
    STATE(5673), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6243), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255037] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9320), 1,
      anon_sym_group,
    ACTIONS(9322), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6244), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255120] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9372), 1,
      anon_sym_group,
    ACTIONS(9374), 1,
      anon_sym_select,
    STATE(5118), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6245), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255203] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9304), 1,
      anon_sym_group,
    ACTIONS(9306), 1,
      anon_sym_select,
    STATE(4684), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6246), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255286] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9332), 1,
      anon_sym_group,
    ACTIONS(9334), 1,
      anon_sym_select,
    STATE(4063), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6247), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255369] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9316), 1,
      anon_sym_group,
    ACTIONS(9318), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6248), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255452] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9340), 1,
      anon_sym_group,
    ACTIONS(9342), 1,
      anon_sym_select,
    STATE(4722), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6249), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255535] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9340), 1,
      anon_sym_group,
    ACTIONS(9342), 1,
      anon_sym_select,
    STATE(4930), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6250), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255618] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9308), 1,
      anon_sym_group,
    ACTIONS(9310), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6251), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255701] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9304), 1,
      anon_sym_group,
    ACTIONS(9306), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6287), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6252), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255784] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9328), 1,
      anon_sym_group,
    ACTIONS(9330), 1,
      anon_sym_select,
    STATE(5660), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6253), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255867] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9360), 1,
      anon_sym_group,
    ACTIONS(9362), 1,
      anon_sym_select,
    STATE(5514), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6254), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [255950] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9332), 1,
      anon_sym_group,
    ACTIONS(9334), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6261), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6255), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256033] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9348), 1,
      anon_sym_group,
    ACTIONS(9350), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6294), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6256), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256116] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9344), 1,
      anon_sym_group,
    ACTIONS(9346), 1,
      anon_sym_select,
    STATE(3781), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6257), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256199] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9344), 1,
      anon_sym_group,
    ACTIONS(9346), 1,
      anon_sym_select,
    STATE(3996), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6258), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256282] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9300), 1,
      anon_sym_group,
    ACTIONS(9302), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6286), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6259), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256365] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9308), 1,
      anon_sym_group,
    ACTIONS(9310), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6251), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6260), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256448] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9332), 1,
      anon_sym_group,
    ACTIONS(9334), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6261), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256531] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9336), 1,
      anon_sym_group,
    ACTIONS(9338), 1,
      anon_sym_select,
    STATE(5128), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6262), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256614] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9328), 1,
      anon_sym_group,
    ACTIONS(9330), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6280), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6263), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256697] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9348), 1,
      anon_sym_group,
    ACTIONS(9350), 1,
      anon_sym_select,
    STATE(4268), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6264), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256780] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9300), 1,
      anon_sym_group,
    ACTIONS(9302), 1,
      anon_sym_select,
    STATE(5135), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6265), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256863] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9320), 1,
      anon_sym_group,
    ACTIONS(9322), 1,
      anon_sym_select,
    STATE(4197), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6266), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [256946] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9356), 1,
      anon_sym_group,
    ACTIONS(9358), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6267), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257029] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9312), 1,
      anon_sym_group,
    ACTIONS(9314), 1,
      anon_sym_select,
    STATE(4148), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6268), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257112] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9376), 1,
      anon_sym_group,
    ACTIONS(9378), 1,
      anon_sym_select,
    STATE(4865), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6269), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257195] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9344), 1,
      anon_sym_group,
    ACTIONS(9346), 1,
      anon_sym_select,
    STATE(3887), 1,
      sym__select_or_group_clause,
    STATE(6257), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6270), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257278] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9368), 1,
      anon_sym_group,
    ACTIONS(9370), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6272), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6271), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257361] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9368), 1,
      anon_sym_group,
    ACTIONS(9370), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6272), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257444] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9320), 1,
      anon_sym_group,
    ACTIONS(9322), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6244), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6273), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257527] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9376), 1,
      anon_sym_group,
    ACTIONS(9378), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6274), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257610] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9372), 1,
      anon_sym_group,
    ACTIONS(9374), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6281), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6275), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257693] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9312), 1,
      anon_sym_group,
    ACTIONS(9314), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6279), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6276), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257776] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9356), 1,
      anon_sym_group,
    ACTIONS(9358), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6267), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6277), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257859] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9380), 1,
      anon_sym_group,
    ACTIONS(9382), 1,
      anon_sym_select,
    STATE(4524), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6278), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [257942] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9312), 1,
      anon_sym_group,
    ACTIONS(9314), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6279), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258025] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9328), 1,
      anon_sym_group,
    ACTIONS(9330), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6280), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258108] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9372), 1,
      anon_sym_group,
    ACTIONS(9374), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6281), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258191] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9316), 1,
      anon_sym_group,
    ACTIONS(9318), 1,
      anon_sym_select,
    STATE(5123), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6282), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258274] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9380), 1,
      anon_sym_group,
    ACTIONS(9382), 1,
      anon_sym_select,
    STATE(4715), 1,
      sym__select_or_group_clause,
    STATE(6284), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6283), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258357] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9380), 1,
      anon_sym_group,
    ACTIONS(9382), 1,
      anon_sym_select,
    STATE(4722), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6284), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258440] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9340), 1,
      anon_sym_group,
    ACTIONS(9342), 1,
      anon_sym_select,
    STATE(4715), 1,
      sym__select_or_group_clause,
    STATE(6249), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(4642), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6285), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258523] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9300), 1,
      anon_sym_group,
    ACTIONS(9302), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6286), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258606] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9304), 1,
      anon_sym_group,
    ACTIONS(9306), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6287), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258689] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9336), 1,
      anon_sym_group,
    ACTIONS(9338), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6240), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6288), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258772] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9308), 1,
      anon_sym_group,
    ACTIONS(9310), 1,
      anon_sym_select,
    STATE(4823), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6289), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258855] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9316), 1,
      anon_sym_group,
    ACTIONS(9318), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6248), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6290), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [258938] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9364), 1,
      anon_sym_group,
    ACTIONS(9366), 1,
      anon_sym_select,
    STATE(3700), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6291), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259021] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9352), 1,
      anon_sym_group,
    ACTIONS(9354), 1,
      anon_sym_select,
    STATE(5155), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6292), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259104] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9324), 1,
      anon_sym_group,
    ACTIONS(9326), 1,
      anon_sym_select,
    STATE(5682), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6293), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259187] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9348), 1,
      anon_sym_group,
    ACTIONS(9350), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6294), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259270] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9364), 1,
      anon_sym_group,
    ACTIONS(9366), 1,
      anon_sym_select,
    STATE(3887), 1,
      sym__select_or_group_clause,
    STATE(6301), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6295), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259353] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9324), 1,
      anon_sym_group,
    ACTIONS(9326), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6297), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6296), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259436] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9324), 1,
      anon_sym_group,
    ACTIONS(9326), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6297), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259519] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9352), 1,
      anon_sym_group,
    ACTIONS(9354), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6299), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6298), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259602] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9352), 1,
      anon_sym_group,
    ACTIONS(9354), 1,
      anon_sym_select,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6299), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259685] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9384), 1,
      anon_sym_group,
    ACTIONS(9386), 1,
      anon_sym_select,
    STATE(3079), 1,
      sym__select_or_group_clause,
    STATE(6303), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6300), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259768] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9364), 1,
      anon_sym_group,
    ACTIONS(9366), 1,
      anon_sym_select,
    STATE(3781), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3884), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6301), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259851] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9360), 1,
      anon_sym_group,
    ACTIONS(9362), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6302), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [259934] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9384), 1,
      anon_sym_group,
    ACTIONS(9386), 1,
      anon_sym_select,
    STATE(3047), 1,
      sym__select_or_group_clause,
    STATE(6308), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3001), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6303), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260017] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_where,
    ACTIONS(9292), 1,
      anon_sym_from,
    ACTIONS(9294), 1,
      anon_sym_join,
    ACTIONS(9296), 1,
      anon_sym_let,
    ACTIONS(9298), 1,
      anon_sym_orderby,
    ACTIONS(9376), 1,
      anon_sym_group,
    ACTIONS(9378), 1,
      anon_sym_select,
    STATE(3291), 1,
      sym__select_or_group_clause,
    STATE(6274), 1,
      aux_sym__query_body_repeat1,
    STATE(6399), 1,
      sym__query_clause,
    STATE(3356), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6304), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260100] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9390), 1,
      anon_sym_EQ,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9394), 1,
      anon_sym_LT,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(2669), 1,
      sym_accessor_list,
    STATE(6360), 1,
      sym_parameter_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(7309), 1,
      sym_type_parameter_list,
    STATE(7571), 1,
      sym_arrow_expression_clause,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6305), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260188] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9390), 1,
      anon_sym_EQ,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9394), 1,
      anon_sym_LT,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(2684), 1,
      sym_accessor_list,
    STATE(6350), 1,
      sym_parameter_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(7278), 1,
      sym_type_parameter_list,
    STATE(7641), 1,
      sym_arrow_expression_clause,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6306), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260276] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9390), 1,
      anon_sym_EQ,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9394), 1,
      anon_sym_LT,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(2651), 1,
      sym_accessor_list,
    STATE(6369), 1,
      sym_parameter_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(7107), 1,
      sym_type_parameter_list,
    STATE(7797), 1,
      sym_arrow_expression_clause,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6307), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260364] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9398), 1,
      anon_sym_where,
    ACTIONS(9401), 1,
      anon_sym_from,
    ACTIONS(9404), 1,
      anon_sym_join,
    ACTIONS(9407), 1,
      anon_sym_let,
    ACTIONS(9410), 1,
      anon_sym_orderby,
    STATE(6399), 1,
      sym__query_clause,
    ACTIONS(9413), 2,
      anon_sym_group,
      anon_sym_select,
    STATE(6427), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(6308), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat1,
  [260436] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_COLON,
    ACTIONS(9415), 1,
      anon_sym_LT,
    ACTIONS(9418), 1,
      anon_sym_COLON_COLON,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(3680), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6309), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260501] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6321), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6611), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9420), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6310), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260573] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6313), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6643), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9428), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6311), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260645] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6361), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6557), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6558), 1,
      sym_record_base,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9430), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6312), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260719] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6684), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9434), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6313), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260791] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6622), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9436), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6314), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260863] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6312), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6559), 1,
      sym_record_base,
    STATE(6569), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9438), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6315), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [260937] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6636), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9440), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6316), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261009] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6314), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6571), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9442), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6317), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261081] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6361), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6524), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6526), 1,
      sym_record_base,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9444), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6318), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261155] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6331), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6624), 1,
      sym_record_base,
    STATE(6631), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9446), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6319), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261229] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6318), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6551), 1,
      sym_record_base,
    STATE(6552), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9448), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6320), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261303] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6668), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9450), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6321), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261375] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6582), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9452), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6322), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261447] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6610), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9454), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6323), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261519] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6339), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6606), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9456), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6324), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261591] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9415), 1,
      anon_sym_LT,
    STATE(4127), 1,
      sym_type_argument_list,
    STATE(6325), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3680), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
  [261651] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6322), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6564), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9458), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6326), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261723] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6361), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6608), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6609), 1,
      sym_record_base,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9460), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6327), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261797] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6316), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6616), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9462), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6328), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261869] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6324), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6688), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9464), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6329), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [261941] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6327), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6540), 1,
      sym_record_base,
    STATE(6543), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9466), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6330), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262015] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9432), 1,
      anon_sym_COLON,
    STATE(6361), 1,
      aux_sym__record_declaration_initializer_repeat1,
    STATE(6666), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6667), 1,
      sym_record_base,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9468), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    STATE(6331), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262089] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6323), 1,
      aux_sym__class_declaration_initializer_repeat3,
    STATE(6546), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9470), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6332), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262161] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_COLON,
    ACTIONS(3459), 5,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(3630), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6333), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262221] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      anon_sym_COMMA,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9472), 1,
      anon_sym_SEMI,
    ACTIONS(9475), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(2687), 1,
      sym_accessor_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(6334), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262296] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9477), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    ACTIONS(3459), 6,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(6335), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262353] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    ACTIONS(4024), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6336), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262416] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      anon_sym_COMMA,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9475), 1,
      anon_sym_EQ,
    ACTIONS(9482), 1,
      anon_sym_SEMI,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(2757), 1,
      sym_accessor_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(6337), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262491] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_DOT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      anon_sym_COMMA,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9475), 1,
      anon_sym_EQ,
    ACTIONS(9485), 1,
      anon_sym_SEMI,
    STATE(2184), 1,
      sym_type_argument_list,
    STATE(2803), 1,
      sym_accessor_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(6338), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262566] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9490), 1,
      anon_sym_COLON,
    ACTIONS(9493), 1,
      anon_sym_LPAREN,
    ACTIONS(9496), 1,
      anon_sym_LT,
    ACTIONS(9488), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6470), 3,
      sym_type_parameter_list,
      sym_base_list,
      sym_parameter_list,
    STATE(6339), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__class_declaration_initializer_repeat3,
  [262628] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_COLON,
    ACTIONS(9499), 1,
      anon_sym_LT,
    ACTIONS(9502), 1,
      anon_sym_COLON_COLON,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_DOT,
    STATE(6340), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262690] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9390), 1,
      anon_sym_EQ,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(6792), 1,
      sym_parameter_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(7339), 1,
      sym_type_parameter_list,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6341), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262760] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9499), 1,
      anon_sym_LT,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_DOT,
    STATE(6342), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262817] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2736), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6343), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262886] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9510), 1,
      anon_sym_into,
    STATE(6404), 1,
      sym_join_into_clause,
    ACTIONS(9508), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6344), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [262943] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_COMMA,
    ACTIONS(9516), 1,
      anon_sym_LPAREN,
    STATE(6396), 1,
      sym_argument_list,
    STATE(6397), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9512), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6345), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263004] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9519), 1,
      anon_sym_COMMA,
    STATE(6351), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(9521), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6346), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263061] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9525), 1,
      anon_sym_COLON,
    STATE(6414), 1,
      sym_type_parameter_list,
    STATE(6561), 1,
      sym_base_list,
    STATE(6562), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9523), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6347), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263128] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9525), 1,
      anon_sym_COLON,
    STATE(6406), 1,
      sym_type_parameter_list,
    STATE(6590), 1,
      sym_base_list,
    STATE(6594), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9527), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6348), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263195] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2785), 1,
      sym__function_body,
    STATE(6354), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6349), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263264] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2807), 1,
      sym__function_body,
    STATE(6373), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6350), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263333] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    ACTIONS(9532), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6351), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_order_by_clause_repeat1,
  [263388] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2786), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6352), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263457] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9534), 1,
      anon_sym_SEMI,
    STATE(1968), 1,
      sym_block,
    STATE(1971), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7731), 1,
      sym_arrow_expression_clause,
    STATE(6353), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263526] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2815), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6354), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263595] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2749), 1,
      sym__function_body,
    STATE(6352), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6355), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263664] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6357), 1,
      anon_sym_LT,
    STATE(4127), 1,
      sym_type_argument_list,
    ACTIONS(9536), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3680), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6356), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263725] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2754), 1,
      sym__function_body,
    STATE(6382), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6357), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263794] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2755), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6358), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263863] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9539), 1,
      anon_sym_SEMI,
    STATE(2027), 1,
      sym__function_body,
    STATE(2066), 1,
      sym_block,
    STATE(6375), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7675), 1,
      sym_arrow_expression_clause,
    STATE(6359), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [263932] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2760), 1,
      sym__function_body,
    STATE(6381), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6360), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264001] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9543), 1,
      anon_sym_LPAREN,
    ACTIONS(9546), 1,
      anon_sym_LT,
    STATE(6469), 2,
      sym_type_parameter_list,
      sym_parameter_list,
    ACTIONS(9541), 4,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6361), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__record_declaration_initializer_repeat1,
  [264060] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9549), 1,
      anon_sym_SEMI,
    STATE(2120), 1,
      sym__function_body,
    STATE(2139), 1,
      sym_block,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7723), 1,
      sym_arrow_expression_clause,
    STATE(6362), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264129] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    STATE(2605), 1,
      sym_block,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7332), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6363), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264198] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9534), 1,
      anon_sym_SEMI,
    STATE(1968), 1,
      sym_block,
    STATE(1974), 1,
      sym__function_body,
    STATE(6353), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7731), 1,
      sym_arrow_expression_clause,
    STATE(6364), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264267] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2827), 1,
      sym__function_body,
    STATE(6379), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6365), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264336] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    STATE(2605), 1,
      sym_block,
    STATE(6363), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7148), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6366), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264405] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2828), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6367), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264474] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2832), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6368), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264543] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2694), 1,
      sym__function_body,
    STATE(6358), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6369), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264612] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2866), 1,
      sym__function_body,
    STATE(6383), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6370), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264681] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2882), 1,
      sym__function_body,
    STATE(6384), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6371), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264750] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9525), 1,
      anon_sym_COLON,
    STATE(6420), 1,
      sym_type_parameter_list,
    STATE(6650), 1,
      sym_base_list,
    STATE(6664), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9551), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6372), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264817] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2883), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6373), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264886] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9549), 1,
      anon_sym_SEMI,
    STATE(2139), 1,
      sym_block,
    STATE(2142), 1,
      sym__function_body,
    STATE(6362), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7723), 1,
      sym_arrow_expression_clause,
    STATE(6374), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [264955] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9539), 1,
      anon_sym_SEMI,
    STATE(2037), 1,
      sym__function_body,
    STATE(2066), 1,
      sym_block,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7675), 1,
      sym_arrow_expression_clause,
    STATE(6375), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265024] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2796), 1,
      sym__function_body,
    STATE(6367), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6376), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265093] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2799), 1,
      sym__function_body,
    STATE(6368), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6377), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265162] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    ACTIONS(9475), 1,
      anon_sym_EQ,
    STATE(6764), 1,
      sym_parameter_list,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    STATE(7133), 1,
      sym_type_parameter_list,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6378), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265229] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2685), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6379), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265298] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2884), 1,
      sym__function_body,
    STATE(6343), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6380), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265367] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2800), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6381), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265436] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2787), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6382), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265505] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2703), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6383), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265574] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2704), 1,
      sym__function_body,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6384), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265643] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9519), 1,
      anon_sym_COMMA,
    STATE(6346), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(9553), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6385), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265700] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9555), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6386), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265752] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(2649), 1,
      sym_accessor_list,
    STATE(6376), 1,
      sym_parameter_list,
    STATE(7174), 1,
      sym_type_parameter_list,
    STATE(7478), 1,
      sym_arrow_expression_clause,
    STATE(6387), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265818] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(9559), 1,
      anon_sym_COMMA,
    STATE(6534), 1,
      aux_sym_record_base_repeat1,
    STATE(6790), 1,
      sym_argument_list,
    ACTIONS(9557), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6388), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265880] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9561), 1,
      anon_sym_DOT,
    ACTIONS(4028), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6389), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [265934] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(2678), 1,
      sym_accessor_list,
    STATE(6370), 1,
      sym_parameter_list,
    STATE(7116), 1,
      sym_type_parameter_list,
    STATE(7379), 1,
      sym_arrow_expression_clause,
    STATE(6390), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266000] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9532), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6391), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266052] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(2674), 1,
      sym_accessor_list,
    STATE(6355), 1,
      sym_parameter_list,
    STATE(7159), 1,
      sym_type_parameter_list,
    STATE(7689), 1,
      sym_arrow_expression_clause,
    STATE(6392), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266118] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9565), 1,
      anon_sym_LPAREN,
    STATE(6424), 1,
      sym_argument_list,
    ACTIONS(9563), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6393), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266174] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_COMMA,
    STATE(6395), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9568), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6394), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266230] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9570), 1,
      anon_sym_COMMA,
    ACTIONS(9563), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6395), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [266284] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_COMMA,
    STATE(6394), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9573), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6396), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266340] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_COMMA,
    STATE(6395), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9573), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6397), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266396] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(2097), 1,
      sym_block,
    STATE(6421), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6398), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266457] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9579), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6399), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266508] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9581), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6400), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266559] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9583), 1,
      aux_sym_preproc_if_token3,
    STATE(6671), 1,
      sym_attribute_list,
    STATE(7758), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6401), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266620] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9585), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6402), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266671] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(1956), 1,
      sym_block,
    STATE(6468), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6403), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266732] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9587), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6404), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266783] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9591), 1,
      sym_interpolation_end_quote,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    STATE(6435), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6405), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266844] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9525), 1,
      anon_sym_COLON,
    STATE(6682), 1,
      sym_base_list,
    STATE(6686), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9595), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6406), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266905] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9597), 1,
      sym_interpolation_end_quote,
    STATE(6417), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6407), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [266966] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9599), 1,
      sym_interpolation_end_quote,
    STATE(6434), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6408), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267027] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9601), 1,
      sym_interpolation_end_quote,
    STATE(6434), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6409), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267088] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9603), 1,
      anon_sym_catch,
    ACTIONS(9605), 1,
      anon_sym_finally,
    STATE(6520), 1,
      aux_sym_try_statement_repeat1,
    STATE(6791), 1,
      sym_catch_clause,
    STATE(7330), 1,
      sym_finally_clause,
    ACTIONS(3135), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(6410), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267149] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9607), 1,
      aux_sym_preproc_if_token3,
    STATE(6544), 1,
      sym_attribute_list,
    STATE(7493), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6411), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267210] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(1940), 1,
      sym_block,
    STATE(6416), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6412), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267271] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9609), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6413), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267322] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9525), 1,
      anon_sym_COLON,
    STATE(6617), 1,
      sym_base_list,
    STATE(6619), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9611), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6414), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267383] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(9613), 1,
      anon_sym_COMMA,
    STATE(6653), 1,
      sym_argument_list,
    STATE(6654), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9512), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6415), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267442] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(1938), 1,
      sym_block,
    STATE(6468), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6416), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267503] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9615), 1,
      sym_interpolation_end_quote,
    STATE(6434), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6417), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267564] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9617), 1,
      aux_sym_preproc_if_token3,
    STATE(6528), 1,
      sym_attribute_list,
    STATE(7663), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6418), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267625] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(6425), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6786), 1,
      sym_block,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6419), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267686] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(9525), 1,
      anon_sym_COLON,
    STATE(6532), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6689), 1,
      sym_base_list,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9619), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6420), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267747] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(2096), 1,
      sym_block,
    STATE(6468), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6421), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267808] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(1984), 1,
      sym_block,
    STATE(6403), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6422), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267869] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9621), 1,
      sym_interpolation_end_quote,
    STATE(6409), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6423), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267930] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9623), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6424), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [267981] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_when,
    STATE(6468), 1,
      aux_sym_catch_clause_repeat1,
    STATE(6716), 1,
      sym_block,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6425), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268042] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9625), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6426), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268093] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9627), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(6427), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268144] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2659), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    STATE(6573), 1,
      sym_attribute_list,
    STATE(7770), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6428), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268205] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9629), 1,
      aux_sym_preproc_if_token3,
    STATE(6580), 1,
      sym_attribute_list,
    STATE(7531), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6429), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268266] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9631), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6430), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268317] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9633), 1,
      aux_sym_preproc_if_token3,
    STATE(6641), 1,
      sym_attribute_list,
    STATE(7485), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6431), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268378] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9635), 1,
      sym_interpolation_end_quote,
    STATE(6408), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6432), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268439] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9637), 1,
      sym_interpolation_end_quote,
    STATE(6434), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6433), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268500] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9642), 1,
      sym_interpolation_end_quote,
    ACTIONS(9644), 1,
      sym_interpolation_open_brace,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9639), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6434), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat1,
  [268559] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9647), 1,
      sym_interpolation_end_quote,
    STATE(6434), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6435), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268620] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9649), 1,
      sym_interpolation_end_quote,
    STATE(6433), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6738), 1,
      sym_interpolation,
    STATE(6754), 1,
      sym__interpolated_string_content,
    ACTIONS(9589), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6436), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268681] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4131), 7,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6437), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268732] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9603), 1,
      anon_sym_catch,
    ACTIONS(9605), 1,
      anon_sym_finally,
    STATE(6410), 1,
      aux_sym_try_statement_repeat1,
    STATE(6791), 1,
      sym_catch_clause,
    STATE(7298), 1,
      sym_finally_clause,
    ACTIONS(3123), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(6438), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268793] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9651), 1,
      sym_interpolation_end_quote,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    STATE(6466), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6439), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268853] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    STATE(6424), 1,
      sym_argument_list,
    ACTIONS(9563), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6440), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268907] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9655), 1,
      anon_sym_DQUOTE,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    STATE(6462), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6441), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [268967] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2789), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6442), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269027] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9635), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6497), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6443), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269087] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9665), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6444), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269137] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9667), 1,
      sym_interpolation_end_quote,
    STATE(6498), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6445), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269197] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(9559), 1,
      anon_sym_COMMA,
    STATE(6651), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(9669), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6446), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269253] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9673), 1,
      anon_sym_COMMA,
    ACTIONS(9671), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6447), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_parameter_constraints_clause_repeat1,
  [269305] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(9390), 1,
      anon_sym_EQ,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6448), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269363] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9676), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6449), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269413] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9678), 1,
      sym_interpolation_end_quote,
    STATE(6515), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6450), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269473] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2722), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6451), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269533] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2726), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6452), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269593] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9680), 1,
      anon_sym_SEMI,
    ACTIONS(9682), 1,
      anon_sym_LBRACE,
    STATE(3415), 1,
      sym_block,
    STATE(3484), 1,
      sym__function_body,
    STATE(7393), 1,
      sym_arrow_expression_clause,
    STATE(6453), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269653] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2735), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6454), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269713] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9684), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(6455), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269763] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9680), 1,
      anon_sym_SEMI,
    ACTIONS(9682), 1,
      anon_sym_LBRACE,
    STATE(3415), 1,
      sym_block,
    STATE(3462), 1,
      sym__function_body,
    STATE(7393), 1,
      sym_arrow_expression_clause,
    STATE(6456), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269823] = 16,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9686), 1,
      anon_sym_DQUOTE,
    ACTIONS(9688), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9691), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9694), 1,
      sym_escape_sequence,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6457), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_string_literal_repeat1,
  [269881] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9601), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6509), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6458), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [269941] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9680), 1,
      anon_sym_SEMI,
    ACTIONS(9682), 1,
      anon_sym_LBRACE,
    STATE(3415), 1,
      sym_block,
    STATE(3539), 1,
      sym__function_body,
    STATE(7393), 1,
      sym_arrow_expression_clause,
    STATE(6459), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270001] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2783), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6460), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270061] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9697), 1,
      sym_interpolation_end_quote,
    STATE(6515), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6461), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270121] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9699), 1,
      anon_sym_DQUOTE,
    STATE(6457), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6462), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270181] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    ACTIONS(9703), 1,
      anon_sym_QMARK,
    STATE(6463), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270241] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9705), 1,
      anon_sym_DQUOTE,
    STATE(6507), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6464), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270301] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9647), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6509), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6465), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270361] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9707), 1,
      sym_interpolation_end_quote,
    STATE(6515), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6466), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270421] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9709), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(6467), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270479] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9711), 1,
      anon_sym_LPAREN,
    ACTIONS(9714), 1,
      anon_sym_LBRACE,
    ACTIONS(9716), 1,
      anon_sym_when,
    STATE(6936), 2,
      sym_catch_declaration,
      sym_catch_filter_clause,
    STATE(6468), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_catch_clause_repeat1,
  [270535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9719), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6469), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270585] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9721), 6,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_where,
    STATE(6470), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270635] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2822), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6471), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270695] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9725), 1,
      anon_sym_COMMA,
    STATE(6447), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(9723), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6472), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270749] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9727), 1,
      anon_sym_DQUOTE,
    STATE(6517), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6473), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270809] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9649), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6514), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6474), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270869] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9729), 1,
      anon_sym_DQUOTE,
    STATE(6491), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6475), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270929] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9591), 1,
      sym_interpolation_end_quote,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6465), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6476), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [270989] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2792), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6477), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271049] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9731), 1,
      sym_interpolation_end_quote,
    STATE(6450), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6478), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271109] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2793), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6479), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271169] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9597), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6494), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6480), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271229] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(3881), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    STATE(6481), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271281] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9733), 1,
      anon_sym_DQUOTE,
    STATE(6489), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6482), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271341] = 13,
    ACTIONS(3664), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(3662), 5,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6483), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271393] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9735), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(6484), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271443] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2839), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6485), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271503] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2688), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6486), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271563] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2851), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6487), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271623] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2852), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6488), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271683] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9737), 1,
      anon_sym_DQUOTE,
    STATE(6457), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6489), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271743] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(9739), 1,
      anon_sym_EQ,
    ACTIONS(3881), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    STATE(6490), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271797] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9741), 1,
      anon_sym_DQUOTE,
    STATE(6457), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6491), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271857] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9743), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(6492), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271915] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(9739), 1,
      anon_sym_EQ,
    ACTIONS(3881), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    STATE(6493), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [271969] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9615), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6509), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6494), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272029] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9745), 1,
      sym_interpolation_end_quote,
    STATE(6515), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6495), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272089] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9747), 1,
      anon_sym_DQUOTE,
    STATE(6508), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6496), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272149] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9599), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6509), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6497), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272209] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9749), 1,
      sym_interpolation_end_quote,
    STATE(6515), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6498), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272269] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9621), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6458), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6499), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272329] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9751), 1,
      sym_interpolation_end_quote,
    STATE(6461), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6500), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272389] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2779), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6501), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272449] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9753), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(6502), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272507] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_LT,
    ACTIONS(7047), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9755), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_type_argument_list,
    ACTIONS(3680), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(6503), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272565] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2776), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6504), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272625] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(9703), 1,
      anon_sym_QMARK,
    ACTIONS(4024), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6505), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272683] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2814), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6506), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272743] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9757), 1,
      anon_sym_DQUOTE,
    STATE(6457), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6507), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272803] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9759), 1,
      anon_sym_DQUOTE,
    STATE(6457), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6508), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272863] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9761), 1,
      sym_interpolation_end_quote,
    ACTIONS(9763), 1,
      sym_interpolation_open_brace,
    ACTIONS(9766), 1,
      sym_interpolation_string_content,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6509), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat2,
  [272921] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9769), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(6510), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [272971] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9773), 1,
      anon_sym_where,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9771), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6511), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__class_declaration_initializer_repeat4,
  [273025] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9778), 1,
      anon_sym_QMARK,
    ACTIONS(9776), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6512), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273077] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9780), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(6513), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273127] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9637), 1,
      sym_interpolation_end_quote,
    ACTIONS(9663), 1,
      sym_interpolation_string_content,
    STATE(6509), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(7071), 1,
      sym_interpolation,
    STATE(7077), 1,
      sym__interpolated_verbatim_string_content,
    STATE(6514), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273187] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9782), 1,
      sym_interpolation_end_quote,
    ACTIONS(9784), 1,
      sym_interpolation_open_brace,
    ACTIONS(9787), 1,
      sym_interpolation_string_content,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6515), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat3,
  [273245] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9725), 1,
      anon_sym_COMMA,
    STATE(6472), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(9790), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6516), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273299] = 17,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9657), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9659), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9661), 1,
      sym_escape_sequence,
    ACTIONS(9792), 1,
      anon_sym_DQUOTE,
    STATE(6457), 1,
      aux_sym_string_literal_repeat1,
    STATE(6770), 1,
      sym_string_literal_content,
    STATE(6517), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273359] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    ACTIONS(9504), 1,
      anon_sym_SEMI,
    ACTIONS(9506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_block,
    STATE(2709), 1,
      sym__function_body,
    STATE(7760), 1,
      sym_arrow_expression_clause,
    STATE(6518), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273419] = 13,
    ACTIONS(3459), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(3461), 5,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6519), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273471] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9794), 1,
      anon_sym_catch,
    STATE(6791), 1,
      sym_catch_clause,
    ACTIONS(3141), 3,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_else,
    STATE(6520), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_try_statement_repeat1,
  [273525] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(9797), 1,
      anon_sym_COMMA,
    STATE(6780), 1,
      sym_argument_list,
    STATE(6793), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9512), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6521), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273583] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym_interpolation_open_brace,
    ACTIONS(9653), 1,
      sym_interpolation_string_content,
    ACTIONS(9799), 1,
      sym_interpolation_end_quote,
    STATE(6495), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(7047), 1,
      sym__interpolated_raw_string_content,
    STATE(7097), 1,
      sym_interpolation,
    STATE(6522), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273643] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9801), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6523), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273692] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9803), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6524), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273747] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9805), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6525), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273802] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6588), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9803), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6526), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273857] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9807), 1,
      anon_sym_LBRACE,
    STATE(4660), 1,
      sym_block,
    STATE(7241), 1,
      sym_parameter_list,
    STATE(6527), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273914] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(8450), 1,
      aux_sym_preproc_if_token3,
    STATE(7537), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6528), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [273969] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(9809), 1,
      anon_sym_LPAREN,
    STATE(7315), 1,
      sym_attribute_argument_list,
    ACTIONS(8935), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6529), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274024] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9817), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6530), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274079] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9819), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6531), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274134] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9821), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6532), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274189] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9823), 1,
      anon_sym_RPAREN,
    ACTIONS(9827), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9829), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9825), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6533), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274244] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9559), 1,
      anon_sym_COMMA,
    STATE(6593), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(9831), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6534), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274297] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9833), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6535), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274352] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(9835), 1,
      anon_sym_EQ,
    STATE(7062), 1,
      sym_bracketed_argument_list,
    ACTIONS(9837), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6536), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274407] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9839), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6537), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274462] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9841), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6538), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274517] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9843), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6539), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274572] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6608), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9460), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6540), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274627] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9847), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9845), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6541), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274678] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    ACTIONS(9703), 1,
      anon_sym_QMARK,
    STATE(6542), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274735] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9460), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6543), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274790] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4747), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    STATE(7433), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6544), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274845] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9849), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6545), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274900] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9454), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6546), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [274955] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8669), 1,
      anon_sym_COLON,
    ACTIONS(9851), 1,
      anon_sym_when,
    ACTIONS(9853), 1,
      anon_sym_and,
    ACTIONS(9855), 1,
      anon_sym_or,
    STATE(7443), 1,
      sym_when_clause,
    STATE(6547), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275012] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9857), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6548), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275061] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9859), 1,
      anon_sym_RBRACE,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    STATE(6550), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6549), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275118] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9865), 1,
      anon_sym_RBRACE,
    ACTIONS(9867), 1,
      anon_sym_case,
    ACTIONS(9870), 1,
      anon_sym_default,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6550), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_switch_body_repeat1,
  [275173] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6524), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9444), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6551), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275228] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9444), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6552), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275283] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9873), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6553), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275338] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9875), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6554), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275393] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9877), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6555), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275448] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9881), 1,
      anon_sym_COLON,
    STATE(7079), 1,
      sym_constructor_initializer,
    ACTIONS(9879), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6556), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275501] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9883), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6557), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275556] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6537), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9883), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6558), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275611] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6557), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9430), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6559), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275666] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(6199), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_or,
    STATE(6560), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275717] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6623), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9887), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6561), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275772] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9887), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6562), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275827] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8164), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(8166), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9889), 1,
      aux_sym_preproc_if_token3,
    STATE(7604), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(6563), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275882] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9452), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6564), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275937] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9891), 1,
      anon_sym_COMMA,
    ACTIONS(9893), 1,
      anon_sym_RBRACK,
    ACTIONS(9895), 1,
      anon_sym_or,
    STATE(6939), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6565), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [275994] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9897), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6566), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276049] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9899), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6567), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276098] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9901), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6568), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276153] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9430), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6569), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276208] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9903), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6570), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276263] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9436), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6571), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276318] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(9905), 1,
      anon_sym_RBRACE,
    STATE(6550), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6572), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276375] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4753), 1,
      aux_sym_preproc_if_token3,
    STATE(7655), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6573), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276430] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(9907), 1,
      anon_sym_RBRACE,
    STATE(6550), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6574), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276487] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9909), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6575), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276536] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9911), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6576), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276591] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(9913), 1,
      anon_sym_RBRACE,
    STATE(6572), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6577), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276648] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9915), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6578), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276697] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9671), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6579), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276746] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4937), 1,
      aux_sym_preproc_if_token3,
    STATE(7596), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6580), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276801] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(9917), 1,
      anon_sym_COMMA,
    ACTIONS(9919), 1,
      anon_sym_RBRACK,
    STATE(6896), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6581), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276858] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9921), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6582), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276913] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(3124), 1,
      sym_block,
    STATE(7307), 1,
      sym_parameter_list,
    STATE(6583), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [276970] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACE,
    STATE(3364), 1,
      sym_block,
    STATE(7326), 1,
      sym_parameter_list,
    STATE(6584), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277027] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(9925), 1,
      anon_sym_COMMA,
    ACTIONS(9927), 1,
      anon_sym_RBRACK,
    STATE(6952), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6585), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277084] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9929), 1,
      anon_sym_LBRACE,
    STATE(3075), 1,
      sym_block,
    STATE(7341), 1,
      sym_parameter_list,
    STATE(6586), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277141] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(9931), 1,
      anon_sym_EQ,
    STATE(7064), 1,
      sym_bracketed_argument_list,
    ACTIONS(9388), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6587), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277196] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9933), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6588), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277251] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LPAREN,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9935), 1,
      anon_sym_DOT,
    STATE(6589), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277308] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6525), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9937), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6590), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277363] = 13,
    ACTIONS(5145), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(5147), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6591), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277414] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(9939), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6592), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277465] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9941), 1,
      anon_sym_COMMA,
    ACTIONS(9939), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6593), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_record_base_repeat1,
  [277516] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9937), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6594), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277571] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9807), 1,
      anon_sym_LBRACE,
    STATE(4638), 1,
      sym_block,
    STATE(7247), 1,
      sym_parameter_list,
    STATE(6595), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277628] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9944), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6596), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277677] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(3143), 1,
      sym_block,
    STATE(7252), 1,
      sym_parameter_list,
    STATE(6597), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277734] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9946), 1,
      anon_sym_LBRACE,
    STATE(3897), 1,
      sym_block,
    STATE(7172), 1,
      sym_parameter_list,
    STATE(6598), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277791] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9909), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9948), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6599), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277842] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9950), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6600), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277897] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9944), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9952), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6601), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [277948] = 14,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9944), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9952), 2,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6602), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278001] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9944), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9952), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6603), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278056] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9954), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6604), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278111] = 13,
    ACTIONS(4999), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(5001), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6605), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278162] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9956), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6606), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278217] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9958), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6607), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278272] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9960), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6608), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278327] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6633), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9960), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6609), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278382] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9962), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6610), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278437] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9450), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6611), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278492] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9964), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6612), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278547] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9847), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6613), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278596] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACE,
    STATE(3392), 1,
      sym_block,
    STATE(7202), 1,
      sym_parameter_list,
    STATE(6614), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278653] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9966), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6615), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278708] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9440), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6616), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278763] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6652), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9968), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6617), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278818] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9825), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9944), 3,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6618), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278869] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9968), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6619), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278924] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(3433), 1,
      sym_block,
    STATE(7201), 1,
      sym_parameter_list,
    STATE(6620), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [278981] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9972), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6621), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279036] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9974), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6622), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279091] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9976), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6623), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279146] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6666), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9468), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6624), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279201] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9978), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6625), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279256] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(9980), 1,
      anon_sym_COMMA,
    ACTIONS(9982), 1,
      anon_sym_RBRACK,
    STATE(6854), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6626), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279313] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9984), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6627), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279368] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(9986), 1,
      anon_sym_RBRACE,
    STATE(6644), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6628), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279425] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9988), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6629), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279480] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(6764), 1,
      sym_parameter_list,
    STATE(7133), 1,
      sym_type_parameter_list,
    STATE(6630), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279537] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9468), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6631), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279592] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(9703), 1,
      anon_sym_QMARK,
    ACTIONS(4024), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6632), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279647] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9990), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6633), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279702] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9827), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9944), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
    STATE(6634), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279755] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9992), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6635), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279810] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9994), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6636), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279865] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9996), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6637), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279920] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(9998), 1,
      anon_sym_COMMA,
    ACTIONS(10000), 1,
      anon_sym_RBRACK,
    STATE(6839), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6638), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [279977] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10002), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6639), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280032] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9881), 1,
      anon_sym_COLON,
    STATE(6890), 1,
      sym_constructor_initializer,
    ACTIONS(10004), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6640), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280085] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10006), 1,
      aux_sym_preproc_if_token3,
    STATE(7397), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6641), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280140] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(3413), 1,
      sym_block,
    STATE(7262), 1,
      sym_parameter_list,
    STATE(6642), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280197] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9434), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6643), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280252] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(10008), 1,
      anon_sym_RBRACE,
    STATE(6550), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6644), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280309] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9946), 1,
      anon_sym_LBRACE,
    STATE(3783), 1,
      sym_block,
    STATE(7268), 1,
      sym_parameter_list,
    STATE(6645), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280366] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(10010), 1,
      anon_sym_COMMA,
    ACTIONS(10012), 1,
      anon_sym_RBRACK,
    STATE(7051), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6646), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280423] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(10014), 1,
      anon_sym_COMMA,
    ACTIONS(10016), 1,
      anon_sym_RBRACK,
    STATE(7058), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6647), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280480] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9857), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10018), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(6648), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280531] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(6171), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(6649), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280584] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6535), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10020), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6650), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280639] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9559), 1,
      anon_sym_COMMA,
    STATE(6593), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(10022), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6651), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280692] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10024), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6652), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280747] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_COMMA,
    STATE(6659), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9573), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6653), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280800] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_COMMA,
    STATE(6660), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9573), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6654), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280853] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10026), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6655), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280908] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(10028), 1,
      anon_sym_RBRACE,
    STATE(6549), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6656), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [280965] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10030), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6657), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281020] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9881), 1,
      anon_sym_COLON,
    STATE(6975), 1,
      sym_constructor_initializer,
    ACTIONS(10032), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6658), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281073] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_COMMA,
    STATE(6660), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9568), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6659), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281126] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10034), 1,
      anon_sym_COMMA,
    ACTIONS(9563), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6660), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [281177] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10037), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6661), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281232] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10039), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6662), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281287] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9827), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9829), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10041), 1,
      anon_sym_RPAREN,
    ACTIONS(9825), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6663), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281342] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10020), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6664), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281397] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10043), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6665), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281452] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10045), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6666), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281507] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6629), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10045), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6667), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281562] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10047), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6668), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281617] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym_case,
    ACTIONS(9863), 1,
      anon_sym_default,
    ACTIONS(10049), 1,
      anon_sym_RBRACE,
    STATE(6574), 1,
      aux_sym_switch_body_repeat1,
    STATE(6925), 1,
      sym_switch_section,
    STATE(6669), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281674] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10051), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6670), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281729] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4749), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4751), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(8992), 1,
      aux_sym_preproc_if_token3,
    STATE(7437), 2,
      sym_preproc_else_in_attribute_list,
      sym_preproc_elif_in_attribute_list,
    STATE(6671), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281784] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10053), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6672), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281839] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_EQ_GT,
    ACTIONS(10057), 1,
      anon_sym_when,
    ACTIONS(10059), 1,
      anon_sym_and,
    ACTIONS(10061), 1,
      anon_sym_or,
    STATE(7741), 1,
      sym_when_clause,
    STATE(6673), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281896] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10063), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6674), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [281951] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10065), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6675), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282006] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10067), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6676), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282061] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(9475), 1,
      anon_sym_EQ,
    STATE(7104), 1,
      sym_bracketed_argument_list,
    ACTIONS(9388), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6677), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282116] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9776), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6678), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282165] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(10069), 1,
      anon_sym_STAR,
    STATE(3124), 1,
      sym_block,
    STATE(7307), 1,
      sym_parameter_list,
    STATE(6679), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282222] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(10071), 1,
      anon_sym_COMMA,
    ACTIONS(10073), 1,
      anon_sym_RBRACK,
    STATE(6840), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6680), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282279] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8164), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(8166), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10075), 1,
      aux_sym_preproc_if_token3,
    STATE(7725), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(6681), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282334] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6675), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10077), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6682), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282389] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(6683), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282446] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10079), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6684), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282501] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5636), 1,
      anon_sym_LBRACK,
    ACTIONS(10081), 1,
      anon_sym_EQ,
    STATE(7094), 1,
      sym_bracketed_argument_list,
    ACTIONS(9837), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6685), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282556] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10077), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6686), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282611] = 15,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9815), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10083), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9811), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6687), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282666] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9456), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6688), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282721] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    STATE(6607), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(9821), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6689), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282776] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9929), 1,
      anon_sym_LBRACE,
    STATE(3003), 1,
      sym_block,
    STATE(7212), 1,
      sym_parameter_list,
    STATE(6690), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282833] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10059), 1,
      anon_sym_and,
    ACTIONS(10061), 1,
      anon_sym_or,
    ACTIONS(6171), 2,
      anon_sym_EQ_GT,
      anon_sym_when,
    STATE(6691), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282885] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(10085), 1,
      anon_sym_SEMI,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(6771), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6692), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282939] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10087), 1,
      anon_sym_SEMI,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    STATE(2773), 1,
      sym__declaration_list_body,
    STATE(7704), 1,
      sym_declaration_list,
    STATE(6693), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [282993] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10091), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6694), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283041] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2744), 1,
      sym_accessor_list,
    STATE(7360), 1,
      sym_arrow_expression_clause,
    STATE(6695), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283095] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4040), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(6696), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283143] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(10093), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6697), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283195] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(9703), 1,
      anon_sym_QMARK,
    ACTIONS(4024), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6698), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283247] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10093), 1,
      anon_sym_COMMA,
    ACTIONS(10095), 1,
      anon_sym_RPAREN,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    STATE(6699), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283301] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    STATE(2092), 1,
      sym__declaration_list_body,
    STATE(7464), 1,
      sym_declaration_list,
    STATE(6700), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283355] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10103), 1,
      anon_sym_COMMA,
    ACTIONS(9557), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6701), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283405] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10105), 1,
      anon_sym_EQ,
    ACTIONS(10107), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6702), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283455] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10109), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6703), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283503] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10111), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6704), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283551] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    STATE(2073), 1,
      sym__declaration_list_body,
    STATE(7464), 1,
      sym_declaration_list,
    STATE(6705), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283605] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    STATE(6706), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283659] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    STATE(2094), 1,
      sym__declaration_list_body,
    STATE(7464), 1,
      sym_declaration_list,
    STATE(6707), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283713] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9853), 1,
      anon_sym_and,
    ACTIONS(9855), 1,
      anon_sym_or,
    ACTIONS(6171), 2,
      anon_sym_COLON,
      anon_sym_when,
    STATE(6708), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283765] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10113), 4,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6709), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283813] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2693), 1,
      sym_accessor_list,
    STATE(7611), 1,
      sym_arrow_expression_clause,
    STATE(6710), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283867] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10093), 1,
      anon_sym_COMMA,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(10115), 1,
      anon_sym_RPAREN,
    STATE(6711), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283921] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10117), 4,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6712), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [283969] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(7114), 1,
      sym_type_parameter_list,
    STATE(7115), 1,
      sym_parameter_list,
    STATE(6713), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284023] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(10119), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6714), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284073] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10121), 1,
      anon_sym_COMMA,
    ACTIONS(10124), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6715), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_bracketed_parameter_list_repeat1,
  [284123] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3152), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(6716), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284171] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10126), 1,
      anon_sym_SEMI,
    STATE(7759), 1,
      sym_declaration_list,
    STATE(6717), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284225] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2864), 1,
      sym_accessor_list,
    STATE(7646), 1,
      sym_arrow_expression_clause,
    STATE(6718), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284279] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(1899), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6719), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284331] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(10128), 1,
      anon_sym_SEMI,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(6720), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284385] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10093), 1,
      anon_sym_COMMA,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(10130), 1,
      anon_sym_RPAREN,
    STATE(6721), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284439] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4050), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(6722), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284487] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(6171), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6723), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284539] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10093), 1,
      anon_sym_COMMA,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(10132), 1,
      anon_sym_RPAREN,
    STATE(6724), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284593] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9797), 1,
      anon_sym_COMMA,
    STATE(6728), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9568), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6725), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284645] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    ACTIONS(9703), 1,
      anon_sym_QMARK,
    STATE(6726), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284699] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10093), 1,
      anon_sym_COMMA,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(10134), 1,
      anon_sym_RPAREN,
    STATE(6727), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284753] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10136), 1,
      anon_sym_COMMA,
    ACTIONS(9563), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6728), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [284803] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10139), 1,
      anon_sym_LT,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    STATE(7375), 1,
      sym_calling_convention,
    STATE(6729), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284857] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10145), 1,
      anon_sym_SEMI,
    STATE(2013), 1,
      sym__declaration_list_body,
    STATE(7751), 1,
      sym_declaration_list,
    STATE(6730), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284911] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10147), 1,
      anon_sym_SEMI,
    STATE(7415), 1,
      sym_declaration_list,
    STATE(6731), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [284965] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10149), 1,
      anon_sym_LT,
    STATE(7603), 1,
      sym_calling_convention,
    STATE(6732), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285019] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10153), 1,
      anon_sym_COLON,
    STATE(7319), 1,
      sym_base_list,
    ACTIONS(10151), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6733), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285071] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(6199), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
    STATE(6734), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285121] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10145), 1,
      anon_sym_SEMI,
    STATE(2000), 1,
      sym__declaration_list_body,
    STATE(7751), 1,
      sym_declaration_list,
    STATE(6735), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285175] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10145), 1,
      anon_sym_SEMI,
    STATE(2005), 1,
      sym__declaration_list_body,
    STATE(7751), 1,
      sym_declaration_list,
    STATE(6736), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285229] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10153), 1,
      anon_sym_COLON,
    STATE(7217), 1,
      sym_base_list,
    ACTIONS(10155), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6737), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285281] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10157), 4,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6738), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285329] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10159), 1,
      anon_sym_LT,
    STATE(7636), 1,
      sym_calling_convention,
    STATE(6739), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285383] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(10161), 1,
      anon_sym_SEMI,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(6720), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6740), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285437] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10145), 1,
      anon_sym_SEMI,
    STATE(2018), 1,
      sym__declaration_list_body,
    STATE(7751), 1,
      sym_declaration_list,
    STATE(6741), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285491] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10163), 1,
      anon_sym_EQ,
    ACTIONS(10165), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6742), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285541] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4054), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(6743), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285589] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9853), 1,
      anon_sym_and,
    ACTIONS(6199), 3,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_or,
    STATE(6744), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285639] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    STATE(2086), 1,
      sym__declaration_list_body,
    STATE(7464), 1,
      sym_declaration_list,
    STATE(6745), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285693] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10087), 1,
      anon_sym_SEMI,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    STATE(2768), 1,
      sym__declaration_list_body,
    STATE(7704), 1,
      sym_declaration_list,
    STATE(6746), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285747] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10087), 1,
      anon_sym_SEMI,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    STATE(2770), 1,
      sym__declaration_list_body,
    STATE(7704), 1,
      sym_declaration_list,
    STATE(6747), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285801] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10167), 1,
      anon_sym_LT,
    STATE(7661), 1,
      sym_calling_convention,
    STATE(6748), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285855] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10169), 1,
      anon_sym_LT,
    STATE(7694), 1,
      sym_calling_convention,
    STATE(6749), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285909] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(7280), 1,
      sym_type_parameter_list,
    STATE(7281), 1,
      sym_parameter_list,
    STATE(6750), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [285963] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(10171), 1,
      anon_sym_EQ,
    ACTIONS(10165), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6751), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286015] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10173), 1,
      anon_sym_COMMA,
    ACTIONS(10176), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
    STATE(6752), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_argument_list_repeat1,
  [286065] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(10178), 1,
      anon_sym_EQ,
    ACTIONS(10180), 1,
      anon_sym_COMMA,
    ACTIONS(10183), 1,
      anon_sym_RPAREN,
    STATE(6753), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286119] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10185), 4,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6754), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286167] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10187), 1,
      anon_sym_LT,
    STATE(7678), 1,
      sym_calling_convention,
    STATE(6755), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286221] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4032), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(6756), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286269] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(10189), 1,
      anon_sym_SEMI,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(6779), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6757), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286323] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(9739), 1,
      anon_sym_EQ,
    ACTIONS(10191), 1,
      anon_sym_COMMA,
    ACTIONS(10195), 1,
      anon_sym_RPAREN,
    STATE(6758), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286377] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10197), 1,
      anon_sym_LT,
    STATE(7691), 1,
      sym_calling_convention,
    STATE(6759), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286431] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_GT,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(6760), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286485] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10199), 1,
      anon_sym_EQ,
    ACTIONS(10201), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6761), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286535] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_unmanaged,
    ACTIONS(10143), 1,
      anon_sym_managed,
    ACTIONS(10203), 1,
      anon_sym_LT,
    STATE(7703), 1,
      sym_calling_convention,
    STATE(6762), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286589] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10207), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10205), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(6763), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286639] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10209), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6764), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286687] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10211), 1,
      anon_sym_LPAREN,
    ACTIONS(10215), 1,
      sym_integer_literal,
    ACTIONS(10213), 2,
      anon_sym_default,
      anon_sym_hidden,
    STATE(6765), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286739] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(10093), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6766), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286791] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(6694), 1,
      sym_parameter_list,
    STATE(7300), 1,
      sym_type_parameter_list,
    STATE(6767), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286845] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10217), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6768), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286893] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10207), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10205), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(6769), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286943] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10221), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10219), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(6770), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [286993] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(10223), 1,
      anon_sym_SEMI,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(6771), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287047] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10225), 1,
      anon_sym_EQ,
    ACTIONS(10195), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6772), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287097] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10227), 1,
      anon_sym_EQ,
    ACTIONS(10229), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6773), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287147] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9885), 1,
      anon_sym_and,
    ACTIONS(9895), 1,
      anon_sym_or,
    ACTIONS(10231), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6774), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287199] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10153), 1,
      anon_sym_COLON,
    STATE(7295), 1,
      sym_base_list,
    ACTIONS(10233), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6775), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287251] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10235), 1,
      anon_sym_COMMA,
    ACTIONS(7594), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6776), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__for_statement_conditions_repeat1,
  [287301] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10238), 4,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(6777), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287349] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2795), 1,
      sym_accessor_list,
    STATE(7429), 1,
      sym_arrow_expression_clause,
    STATE(6778), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287403] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9426), 1,
      anon_sym_where,
    ACTIONS(10240), 1,
      anon_sym_SEMI,
    STATE(6511), 1,
      aux_sym__class_declaration_initializer_repeat4,
    STATE(6703), 1,
      sym_type_parameter_constraints_clause,
    STATE(6779), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287457] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9797), 1,
      anon_sym_COMMA,
    STATE(6725), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9573), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6780), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287509] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4020), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(6781), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287557] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2758), 1,
      sym_accessor_list,
    STATE(7396), 1,
      sym_arrow_expression_clause,
    STATE(6782), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287611] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(6783), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287665] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10242), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6784), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287713] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_LT,
    STATE(7164), 1,
      sym_type_parameter_list,
    STATE(7166), 1,
      sym_parameter_list,
    STATE(6785), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287767] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3159), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(6786), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287815] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5433), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5496), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6787), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287865] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10059), 1,
      anon_sym_and,
    ACTIONS(6199), 3,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_or,
    STATE(6788), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287915] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10097), 1,
      anon_sym_and,
    ACTIONS(10099), 1,
      anon_sym_or,
    ACTIONS(10231), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6789), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [287967] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10244), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(6790), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288015] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3163), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(6791), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288063] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10246), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(6792), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288111] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9797), 1,
      anon_sym_COMMA,
    STATE(6728), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(9573), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6793), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288163] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10087), 1,
      anon_sym_SEMI,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    STATE(2766), 1,
      sym__declaration_list_body,
    STATE(7704), 1,
      sym_declaration_list,
    STATE(6794), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288217] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9396), 1,
      anon_sym_EQ_GT,
    STATE(2804), 1,
      sym_accessor_list,
    STATE(7719), 1,
      sym_arrow_expression_clause,
    STATE(6795), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288271] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10248), 1,
      anon_sym_COMMA,
    ACTIONS(10251), 1,
      anon_sym_RBRACE,
    STATE(6796), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_positional_pattern_clause_repeat1,
  [288320] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10253), 1,
      anon_sym_EQ,
    ACTIONS(10183), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6797), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288369] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10255), 1,
      anon_sym_COMMA,
    ACTIONS(10258), 1,
      anon_sym_RPAREN,
    STATE(6798), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_using_variable_declaration_repeat1,
  [288418] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7761), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6799), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288469] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10262), 1,
      anon_sym_GT,
    STATE(6845), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6800), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288520] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10262), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6801), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288571] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10266), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6802), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288622] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7863), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6803), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288673] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10268), 1,
      anon_sym_COMMA,
    ACTIONS(10271), 1,
      anon_sym_RPAREN,
    STATE(6804), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_attribute_argument_list_repeat1,
  [288722] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8925), 1,
      anon_sym_RBRACK,
    ACTIONS(10273), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6805), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288773] = 14,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10275), 1,
      anon_sym_DQUOTE,
    ACTIONS(10277), 1,
      aux_sym_preproc_if_token2,
    STATE(7789), 1,
      sym_string_literal,
    STATE(6806), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288824] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7594), 1,
      anon_sym_SEMI,
    ACTIONS(10279), 1,
      anon_sym_COMMA,
    STATE(6807), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__for_statement_conditions_repeat1,
  [288873] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10284), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6808), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288924] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7907), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6809), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [288971] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2855), 1,
      anon_sym_RBRACE,
    ACTIONS(10286), 1,
      anon_sym_COMMA,
    STATE(6881), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6810), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289022] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_COMMA,
    ACTIONS(10291), 1,
      anon_sym_GT,
    STATE(6811), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_parameter_list_repeat1,
  [289071] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    ACTIONS(10293), 1,
      anon_sym_LPAREN,
    STATE(1951), 1,
      sym_block,
    STATE(6812), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289122] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10295), 1,
      anon_sym_RBRACK,
    STATE(6825), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6813), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289173] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10297), 1,
      anon_sym_COMMA,
    ACTIONS(10299), 1,
      anon_sym_RBRACK,
    STATE(7034), 1,
      aux_sym_calling_convention_repeat1,
    STATE(6814), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289224] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10301), 1,
      anon_sym_COMMA,
    ACTIONS(10303), 1,
      anon_sym_RBRACK,
    STATE(6967), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6815), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289275] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10305), 1,
      anon_sym_COMMA,
    ACTIONS(10308), 1,
      anon_sym_RPAREN,
    STATE(6816), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_variable_declaration_repeat1,
  [289324] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10310), 1,
      anon_sym_COMMA,
    ACTIONS(10312), 1,
      anon_sym_RBRACK,
    STATE(6973), 1,
      aux_sym_argument_list_repeat1,
    STATE(6817), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289375] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_COMMA,
    ACTIONS(10316), 1,
      anon_sym_RPAREN,
    STATE(6918), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6818), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289426] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7877), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6819), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289473] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(10318), 1,
      anon_sym_SEMI,
    STATE(2791), 1,
      sym_accessor_list,
    STATE(6820), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289524] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(10320), 1,
      anon_sym_RPAREN,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6821), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289575] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10322), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6822), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289626] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10324), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6823), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289673] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7672), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6824), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289724] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10326), 1,
      anon_sym_RBRACK,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6825), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289775] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10328), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6826), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289822] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10330), 1,
      anon_sym_COMMA,
    ACTIONS(10332), 1,
      anon_sym_RBRACE,
    STATE(6853), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6827), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289873] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10334), 1,
      anon_sym_GT,
    STATE(6836), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6828), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289924] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10334), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6829), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [289975] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10336), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6830), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290026] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10338), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10340), 2,
      anon_sym_annotations,
      anon_sym_warnings,
    STATE(6831), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290075] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10342), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6832), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290122] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10346), 1,
      anon_sym_RPAREN,
    STATE(6715), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(6833), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290173] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10348), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(6834), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290220] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10350), 1,
      anon_sym_GT,
    STATE(6849), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6835), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290271] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10352), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6836), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290322] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10350), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6837), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290373] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10354), 1,
      anon_sym_RPAREN,
    STATE(6852), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(6838), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290424] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_RBRACK,
    ACTIONS(10356), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6839), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290475] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_RBRACK,
    ACTIONS(10358), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6840), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290526] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10360), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6841), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290577] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10362), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6842), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290624] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10364), 1,
      anon_sym_COMMA,
    ACTIONS(10366), 1,
      anon_sym_GT,
    STATE(6811), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(6843), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290675] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10368), 1,
      anon_sym_COMMA,
    ACTIONS(10370), 1,
      anon_sym_RBRACE,
    STATE(6856), 1,
      aux_sym__with_body_repeat1,
    STATE(6844), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290726] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10372), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6845), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290777] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8923), 1,
      anon_sym_RBRACK,
    ACTIONS(10374), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6846), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290828] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8923), 1,
      anon_sym_RBRACK,
    ACTIONS(10374), 1,
      anon_sym_COMMA,
    STATE(6871), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6847), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290879] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(10376), 1,
      anon_sym_SEMI,
    STATE(2725), 1,
      sym_accessor_list,
    STATE(6848), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290930] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10378), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6849), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [290981] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(6850), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291032] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(6851), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291083] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10380), 1,
      anon_sym_RPAREN,
    STATE(6715), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(6852), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291134] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_RBRACE,
    ACTIONS(10382), 1,
      anon_sym_COMMA,
    STATE(6922), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6853), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291185] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2311), 1,
      anon_sym_RBRACK,
    ACTIONS(10384), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6854), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291236] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10388), 1,
      anon_sym_RPAREN,
    STATE(6868), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6855), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291287] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_RBRACE,
    ACTIONS(10390), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      aux_sym__with_body_repeat1,
    STATE(6856), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291338] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10297), 1,
      anon_sym_COMMA,
    ACTIONS(10392), 1,
      anon_sym_RBRACK,
    STATE(6814), 1,
      aux_sym_calling_convention_repeat1,
    STATE(6857), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291389] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10394), 1,
      anon_sym_COMMA,
    ACTIONS(10396), 1,
      anon_sym_RBRACE,
    STATE(6983), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6858), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291440] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10398), 1,
      anon_sym_RBRACK,
    STATE(7056), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(6859), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291491] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10400), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6860), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291542] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10402), 1,
      anon_sym_RBRACK,
    STATE(7074), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(6861), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291593] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10404), 1,
      anon_sym_RBRACK,
    STATE(6870), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6862), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291644] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10406), 1,
      anon_sym_COMMA,
    ACTIONS(10408), 1,
      anon_sym_RBRACE,
    STATE(7021), 1,
      aux_sym__with_body_repeat1,
    STATE(6863), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291695] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10410), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6864), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291742] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10412), 1,
      anon_sym_GT,
    STATE(6924), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6865), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291793] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10195), 1,
      anon_sym_RPAREN,
    ACTIONS(10225), 1,
      anon_sym_EQ,
    ACTIONS(10414), 1,
      anon_sym_COMMA,
    STATE(6866), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291844] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10412), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6867), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291895] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10417), 1,
      anon_sym_RPAREN,
    STATE(6965), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6868), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291946] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10419), 1,
      anon_sym_COMMA,
    ACTIONS(10421), 1,
      anon_sym_RBRACK,
    STATE(6929), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6869), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [291997] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10423), 1,
      anon_sym_RBRACK,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6870), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292048] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8927), 1,
      anon_sym_RBRACK,
    ACTIONS(10425), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6871), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292099] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10427), 1,
      anon_sym_COMMA,
    ACTIONS(10430), 1,
      anon_sym_RPAREN,
    STATE(6872), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_tuple_type_repeat1,
  [292148] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10432), 1,
      anon_sym_COMMA,
    ACTIONS(10435), 1,
      anon_sym_RPAREN,
    STATE(6873), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_argument_list_repeat1,
  [292197] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10437), 1,
      anon_sym_GT,
    STATE(6917), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6874), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292248] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_RBRACK,
    ACTIONS(10439), 1,
      anon_sym_COMMA,
    STATE(7050), 1,
      aux_sym_argument_list_repeat1,
    STATE(6875), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292299] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2177), 1,
      anon_sym_RBRACE,
    ACTIONS(10441), 1,
      anon_sym_COMMA,
    STATE(6922), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6876), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292350] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10437), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6877), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292401] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7638), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6878), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292448] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10443), 1,
      anon_sym_SEMI,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    STATE(7355), 1,
      sym_enum_member_declaration_list,
    STATE(6879), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292499] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10447), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6880), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292550] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10449), 1,
      anon_sym_COMMA,
    ACTIONS(10452), 1,
      anon_sym_RBRACE,
    STATE(6881), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [292599] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10454), 1,
      anon_sym_RBRACK,
    STATE(6938), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6882), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292650] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8909), 1,
      anon_sym_RBRACK,
    ACTIONS(10456), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6883), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292701] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10458), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6884), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292752] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2811), 1,
      anon_sym_RBRACE,
    ACTIONS(10460), 1,
      anon_sym_COMMA,
    STATE(6881), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6885), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292803] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10462), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6886), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292854] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10464), 1,
      anon_sym_COMMA,
    ACTIONS(10466), 1,
      anon_sym_RBRACE,
    STATE(6876), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6887), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292905] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_RBRACE,
    ACTIONS(10468), 1,
      anon_sym_COMMA,
    STATE(6881), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6888), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [292956] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10470), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6889), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293007] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10472), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6890), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293054] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10474), 1,
      anon_sym_RBRACK,
    STATE(6895), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6891), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293105] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    STATE(6892), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293156] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10476), 1,
      anon_sym_RPAREN,
    STATE(6833), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(6893), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293207] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10478), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6894), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293258] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10480), 1,
      anon_sym_RBRACK,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6895), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293309] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_RBRACK,
    ACTIONS(10482), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6896), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293360] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8913), 1,
      anon_sym_RBRACK,
    ACTIONS(10484), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6897), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293411] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10486), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6898), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293462] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10488), 1,
      anon_sym_GT,
    STATE(6901), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6899), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293513] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10488), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6900), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293564] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10490), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6901), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293615] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10492), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6902), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293666] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(10119), 1,
      anon_sym_RPAREN,
    ACTIONS(10494), 1,
      anon_sym_COMMA,
    STATE(6903), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293717] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10497), 1,
      anon_sym_COMMA,
    ACTIONS(10499), 1,
      anon_sym_RBRACE,
    STATE(6946), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6904), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293768] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10501), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6905), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293819] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_COMMA,
    ACTIONS(10503), 1,
      anon_sym_RPAREN,
    STATE(6953), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6906), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293870] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10505), 1,
      anon_sym_COMMA,
    ACTIONS(10507), 1,
      anon_sym_RBRACE,
    STATE(6937), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6907), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293921] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10509), 1,
      anon_sym_RBRACK,
    STATE(6912), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6908), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [293972] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10511), 1,
      anon_sym_COMMA,
    ACTIONS(10513), 1,
      anon_sym_RBRACE,
    STATE(6954), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6909), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294023] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8913), 1,
      anon_sym_RBRACK,
    ACTIONS(10484), 1,
      anon_sym_COMMA,
    STATE(6883), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6910), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294074] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2895), 1,
      anon_sym_RBRACE,
    ACTIONS(10515), 1,
      anon_sym_COMMA,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6911), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294125] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10517), 1,
      anon_sym_RBRACK,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6912), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294176] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2831), 1,
      anon_sym_RBRACE,
    ACTIONS(10519), 1,
      anon_sym_COMMA,
    STATE(6881), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6913), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294227] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6927), 1,
      anon_sym_DOT,
    ACTIONS(4028), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6914), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10521), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
    STATE(6915), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294323] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10523), 1,
      anon_sym_COMMA,
    ACTIONS(10525), 1,
      anon_sym_RBRACE,
    STATE(6941), 1,
      aux_sym__with_body_repeat1,
    STATE(6916), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294374] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10527), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6917), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294425] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_COMMA,
    ACTIONS(10529), 1,
      anon_sym_RPAREN,
    STATE(6947), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6918), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294476] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10531), 1,
      anon_sym_COMMA,
    ACTIONS(10533), 1,
      anon_sym_RBRACE,
    STATE(6960), 1,
      aux_sym__with_body_repeat1,
    STATE(6919), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294527] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7737), 1,
      anon_sym_COMMA,
    ACTIONS(10535), 1,
      anon_sym_SEMI,
    STATE(6807), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6920), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294578] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2921), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(3003), 1,
      anon_sym_LBRACK,
    STATE(7699), 1,
      sym_attribute_list,
    STATE(6921), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294629] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10537), 1,
      anon_sym_COMMA,
    ACTIONS(10540), 1,
      anon_sym_RBRACE,
    STATE(6922), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__switch_expression_body_repeat1,
  [294678] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    ACTIONS(10293), 1,
      anon_sym_LPAREN,
    STATE(7237), 1,
      sym_block,
    STATE(6923), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294729] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10542), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6924), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294780] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10544), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(6925), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294827] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_RBRACK,
    ACTIONS(10546), 1,
      anon_sym_COMMA,
    STATE(6926), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_list_pattern_repeat1,
  [294876] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10251), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6927), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294923] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_RBRACK,
    ACTIONS(10549), 1,
      anon_sym_COMMA,
    STATE(7050), 1,
      aux_sym_argument_list_repeat1,
    STATE(6928), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [294974] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8919), 1,
      anon_sym_RBRACK,
    ACTIONS(10551), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6929), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295025] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_RBRACE,
    ACTIONS(10553), 1,
      anon_sym_COMMA,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6930), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295076] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    ACTIONS(10555), 1,
      anon_sym_SEMI,
    STATE(7754), 1,
      sym_enum_member_declaration_list,
    STATE(6931), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295127] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10557), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6932), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295178] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8887), 1,
      anon_sym_RPAREN,
    ACTIONS(10559), 1,
      anon_sym_COMMA,
    STATE(7086), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(6933), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295229] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10561), 1,
      anon_sym_RPAREN,
    STATE(6884), 1,
      aux_sym_argument_list_repeat1,
    STATE(6934), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295280] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10563), 1,
      anon_sym_RBRACK,
    STATE(7039), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6935), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10565), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(6936), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295378] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_RBRACE,
    ACTIONS(10567), 1,
      anon_sym_COMMA,
    STATE(6922), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6937), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295429] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10569), 1,
      anon_sym_RBRACK,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6938), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295480] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_RBRACK,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6939), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295531] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_RPAREN,
    STATE(6945), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6940), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295582] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9195), 1,
      anon_sym_RBRACE,
    ACTIONS(10575), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      aux_sym__with_body_repeat1,
    STATE(6941), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295633] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10577), 1,
      anon_sym_COMMA,
    ACTIONS(10579), 1,
      anon_sym_RBRACE,
    STATE(6885), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6942), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295684] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_RBRACK,
    ACTIONS(10581), 1,
      anon_sym_COMMA,
    STATE(6943), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_array_rank_specifier_repeat1,
  [295733] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10584), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6944), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295784] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10586), 1,
      anon_sym_RPAREN,
    STATE(6965), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6945), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295835] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_RBRACE,
    ACTIONS(10588), 1,
      anon_sym_COMMA,
    STATE(6922), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(6946), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295886] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10251), 1,
      anon_sym_RPAREN,
    ACTIONS(10590), 1,
      anon_sym_COMMA,
    STATE(6947), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_positional_pattern_clause_repeat1,
  [295935] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10593), 1,
      anon_sym_GT,
    STATE(6951), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6948), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [295986] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10593), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6949), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296037] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10595), 1,
      anon_sym_GT,
    STATE(6944), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6950), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296088] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10597), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6951), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296139] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2345), 1,
      anon_sym_RBRACK,
    ACTIONS(10599), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(6952), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296190] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_COMMA,
    ACTIONS(10601), 1,
      anon_sym_RPAREN,
    STATE(6947), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6953), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296241] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_RBRACE,
    ACTIONS(10603), 1,
      anon_sym_COMMA,
    STATE(6796), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6954), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296292] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10605), 1,
      anon_sym_RPAREN,
    STATE(6968), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6955), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296343] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10595), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6956), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296394] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10607), 1,
      anon_sym_COMMA,
    ACTIONS(10609), 1,
      anon_sym_RBRACK,
    STATE(6991), 1,
      aux_sym_argument_list_repeat1,
    STATE(6957), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296445] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10611), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6958), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296496] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(10613), 1,
      anon_sym_SEMI,
    STATE(2837), 1,
      sym_accessor_list,
    STATE(6959), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296547] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9217), 1,
      anon_sym_RBRACE,
    ACTIONS(10615), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      aux_sym__with_body_repeat1,
    STATE(6960), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296598] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10617), 1,
      anon_sym_COMMA,
    ACTIONS(10619), 1,
      anon_sym_RBRACK,
    STATE(6993), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6961), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296649] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10621), 1,
      anon_sym_COMMA,
    ACTIONS(10623), 1,
      anon_sym_RBRACK,
    STATE(6996), 1,
      aux_sym_argument_list_repeat1,
    STATE(6962), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296700] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10625), 1,
      anon_sym_COMMA,
    ACTIONS(10628), 1,
      anon_sym_RBRACK,
    STATE(6963), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_global_attribute_repeat1,
  [296749] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10630), 1,
      anon_sym_RPAREN,
    STATE(6965), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6964), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296800] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10632), 1,
      anon_sym_COMMA,
    ACTIONS(10635), 1,
      anon_sym_RPAREN,
    STATE(6965), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_parenthesized_variable_designation_repeat1,
  [296849] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10637), 1,
      anon_sym_SEMI,
    ACTIONS(10639), 1,
      anon_sym_COMMA,
    STATE(7102), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(6966), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296900] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8929), 1,
      anon_sym_RBRACK,
    ACTIONS(10641), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6967), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [296951] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10643), 1,
      anon_sym_RPAREN,
    STATE(6965), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6968), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297002] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8929), 1,
      anon_sym_RBRACK,
    ACTIONS(10641), 1,
      anon_sym_COMMA,
    STATE(6805), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6969), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297053] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym_RBRACE,
    ACTIONS(10645), 1,
      anon_sym_COMMA,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6970), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297104] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10647), 1,
      anon_sym_RPAREN,
    STATE(6902), 1,
      aux_sym_argument_list_repeat1,
    STATE(6971), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297155] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10649), 1,
      anon_sym_COMMA,
    ACTIONS(10652), 1,
      anon_sym_RBRACE,
    STATE(6972), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__with_body_repeat1,
  [297204] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_RBRACK,
    ACTIONS(10654), 1,
      anon_sym_COMMA,
    STATE(7050), 1,
      aux_sym_argument_list_repeat1,
    STATE(6973), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297255] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10637), 1,
      anon_sym_RPAREN,
    ACTIONS(10656), 1,
      anon_sym_COMMA,
    STATE(7063), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(6974), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297306] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10658), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6975), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297353] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10660), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6976), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297404] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10662), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6977), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297455] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8905), 1,
      anon_sym_RBRACK,
    ACTIONS(10664), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6978), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297506] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10666), 1,
      anon_sym_GT,
    STATE(6984), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6979), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297557] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10666), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6980), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297608] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_RBRACE,
    ACTIONS(10668), 1,
      anon_sym_COMMA,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6981), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297659] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    ACTIONS(10293), 1,
      anon_sym_LPAREN,
    STATE(2114), 1,
      sym_block,
    STATE(6982), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297710] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2269), 1,
      anon_sym_RBRACE,
    ACTIONS(10670), 1,
      anon_sym_COMMA,
    STATE(6796), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6983), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297761] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10672), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6984), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297812] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10674), 1,
      anon_sym_RPAREN,
    STATE(6808), 1,
      aux_sym_argument_list_repeat1,
    STATE(6985), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297863] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10676), 1,
      anon_sym_RPAREN,
    STATE(6964), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6986), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297914] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10678), 1,
      anon_sym_COMMA,
    ACTIONS(10680), 1,
      anon_sym_RBRACE,
    STATE(6810), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6987), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [297965] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10682), 1,
      anon_sym_RPAREN,
    STATE(6886), 1,
      aux_sym_argument_list_repeat1,
    STATE(6988), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298016] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10684), 1,
      anon_sym_COMMA,
    ACTIONS(10686), 1,
      anon_sym_RBRACE,
    STATE(6913), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6989), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298067] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10688), 1,
      sym_integer_literal,
    ACTIONS(10690), 1,
      anon_sym_DQUOTE,
    STATE(7457), 1,
      sym_string_literal,
    STATE(6990), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298118] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_RBRACK,
    ACTIONS(10692), 1,
      anon_sym_COMMA,
    STATE(7050), 1,
      aux_sym_argument_list_repeat1,
    STATE(6991), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298169] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10694), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6992), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298220] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8903), 1,
      anon_sym_RBRACK,
    ACTIONS(10696), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6993), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298271] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8903), 1,
      anon_sym_RBRACK,
    ACTIONS(10696), 1,
      anon_sym_COMMA,
    STATE(7030), 1,
      aux_sym_global_attribute_repeat1,
    STATE(6994), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298322] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_RBRACE,
    ACTIONS(10698), 1,
      anon_sym_COMMA,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6995), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298373] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_RBRACK,
    ACTIONS(10700), 1,
      anon_sym_COMMA,
    STATE(7050), 1,
      aux_sym_argument_list_repeat1,
    STATE(6996), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298424] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10702), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(6997), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298475] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10704), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6998), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298526] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2913), 1,
      anon_sym_RBRACE,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(6999), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298577] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10708), 1,
      anon_sym_RPAREN,
    STATE(7031), 1,
      aux_sym_argument_list_repeat1,
    STATE(7000), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298628] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10710), 1,
      anon_sym_COMMA,
    ACTIONS(10712), 1,
      anon_sym_RBRACE,
    STATE(7032), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(7001), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298679] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10714), 1,
      anon_sym_COMMA,
    ACTIONS(10716), 1,
      anon_sym_RBRACE,
    STATE(7025), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(7002), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298730] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10718), 1,
      anon_sym_COMMA,
    ACTIONS(10720), 1,
      anon_sym_RBRACK,
    STATE(6897), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7003), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298781] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10722), 1,
      anon_sym_GT,
    STATE(7007), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7004), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298832] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10722), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(7005), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298883] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7699), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7006), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298934] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10724), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7007), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [298985] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10726), 3,
      anon_sym_disable,
      anon_sym_restore,
      anon_sym_enable,
    STATE(7008), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299032] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10728), 1,
      anon_sym_COMMA,
    ACTIONS(10730), 1,
      anon_sym_RBRACK,
    STATE(6928), 1,
      aux_sym_argument_list_repeat1,
    STATE(7009), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299083] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_LBRACE,
    ACTIONS(10732), 1,
      anon_sym_SEMI,
    STATE(7707), 1,
      sym_enum_member_declaration_list,
    STATE(7010), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299134] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10734), 1,
      anon_sym_COMMA,
    ACTIONS(10736), 1,
      anon_sym_RBRACE,
    STATE(6888), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(7011), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299185] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(10738), 1,
      anon_sym_RPAREN,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(7012), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299236] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7859), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7013), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299287] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10740), 1,
      anon_sym_GT,
    STATE(7017), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7014), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299338] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10740), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(7015), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299389] = 14,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10742), 1,
      anon_sym_COMMA,
    ACTIONS(10744), 1,
      aux_sym_preproc_if_token2,
    STATE(7089), 1,
      aux_sym_preproc_pragma_repeat1,
    STATE(7016), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299440] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10746), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7017), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299491] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10748), 1,
      anon_sym_GT,
    STATE(7045), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7018), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299542] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10748), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(7019), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299593] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10435), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(7020), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299640] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_RBRACE,
    ACTIONS(10750), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      aux_sym__with_body_repeat1,
    STATE(7021), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299691] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10752), 1,
      anon_sym_GT,
    STATE(7028), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7022), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299742] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10752), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(7023), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299793] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7530), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7024), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299844] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2783), 1,
      anon_sym_RBRACE,
    ACTIONS(10754), 1,
      anon_sym_COMMA,
    STATE(6881), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(7025), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299895] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10756), 1,
      anon_sym_GT,
    STATE(7049), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7026), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299946] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10756), 1,
      anon_sym_GT,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(7027), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [299997] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10758), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7028), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300048] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10760), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7029), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300099] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8921), 1,
      anon_sym_RBRACK,
    ACTIONS(10762), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7030), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300150] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10764), 1,
      anon_sym_RPAREN,
    STATE(6873), 1,
      aux_sym_argument_list_repeat1,
    STATE(7031), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300201] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2849), 1,
      anon_sym_RBRACE,
    ACTIONS(10766), 1,
      anon_sym_COMMA,
    STATE(6881), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(7032), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300252] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10768), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7033), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300303] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10770), 1,
      anon_sym_COMMA,
    ACTIONS(10773), 1,
      anon_sym_RBRACK,
    STATE(7034), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_calling_convention_repeat1,
  [300352] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10775), 1,
      anon_sym_COMMA,
    ACTIONS(10777), 1,
      anon_sym_RBRACE,
    STATE(7057), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(7035), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300403] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10779), 1,
      anon_sym_COMMA,
    ACTIONS(10781), 1,
      anon_sym_RBRACE,
    STATE(7048), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(7036), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300454] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8933), 1,
      anon_sym_RBRACK,
    ACTIONS(10783), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7037), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300505] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6994), 1,
      anon_sym_COLON,
    ACTIONS(10785), 1,
      sym_interpolation_close_brace,
    STATE(7753), 1,
      sym_interpolation_format_clause,
    STATE(7038), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300556] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(10787), 1,
      anon_sym_RBRACK,
    STATE(6752), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(7039), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300607] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(10089), 1,
      anon_sym_LBRACE,
    STATE(7665), 1,
      sym_declaration_list,
    STATE(7040), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300658] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10789), 1,
      anon_sym_COMMA,
    ACTIONS(10791), 1,
      anon_sym_RBRACK,
    STATE(6846), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7041), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300709] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10793), 1,
      anon_sym_COMMA,
    ACTIONS(10795), 1,
      anon_sym_RBRACE,
    STATE(7052), 1,
      aux_sym__with_body_repeat1,
    STATE(7042), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300760] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8933), 1,
      anon_sym_RBRACK,
    ACTIONS(10783), 1,
      anon_sym_COMMA,
    STATE(6978), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7043), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300811] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10797), 1,
      anon_sym_COMMA,
    ACTIONS(10799), 1,
      anon_sym_RBRACK,
    STATE(6875), 1,
      aux_sym_argument_list_repeat1,
    STATE(7044), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300862] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10801), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7045), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300913] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10803), 1,
      anon_sym_COMMA,
    ACTIONS(10805), 1,
      anon_sym_RBRACE,
    STATE(7061), 1,
      aux_sym__with_body_repeat1,
    STATE(7046), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [300964] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10807), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(7047), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301011] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_RBRACE,
    ACTIONS(10809), 1,
      anon_sym_COMMA,
    STATE(6922), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(7048), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301062] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_COMMA,
    ACTIONS(10811), 1,
      anon_sym_GT,
    STATE(7054), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(7049), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301113] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10435), 1,
      anon_sym_RBRACK,
    ACTIONS(10813), 1,
      anon_sym_COMMA,
    STATE(7050), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_argument_list_repeat1,
  [301162] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_RBRACK,
    ACTIONS(10816), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(7051), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301213] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym_RBRACE,
    ACTIONS(10818), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      aux_sym__with_body_repeat1,
    STATE(7052), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301264] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10820), 1,
      anon_sym_COMMA,
    ACTIONS(10822), 1,
      anon_sym_RBRACE,
    STATE(7070), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(7053), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301315] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10824), 1,
      anon_sym_COMMA,
    ACTIONS(10827), 1,
      anon_sym_GT,
    STATE(7054), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_argument_list_repeat2,
  [301364] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10829), 1,
      anon_sym_COMMA,
    ACTIONS(10832), 1,
      anon_sym_RPAREN,
    STATE(7055), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_tuple_pattern_repeat1,
  [301413] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10834), 1,
      anon_sym_RBRACK,
    STATE(6715), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(7056), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301464] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2297), 1,
      anon_sym_RBRACE,
    ACTIONS(10836), 1,
      anon_sym_COMMA,
    STATE(6922), 1,
      aux_sym__switch_expression_body_repeat1,
    STATE(7057), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301515] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2341), 1,
      anon_sym_RBRACK,
    ACTIONS(10838), 1,
      anon_sym_COMMA,
    STATE(6926), 1,
      aux_sym_list_pattern_repeat1,
    STATE(7058), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301566] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10840), 1,
      anon_sym_RPAREN,
    STATE(7067), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(7059), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301617] = 14,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10742), 1,
      anon_sym_COMMA,
    ACTIONS(10842), 1,
      aux_sym_preproc_if_token2,
    STATE(7016), 1,
      aux_sym_preproc_pragma_repeat1,
    STATE(7060), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301668] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9201), 1,
      anon_sym_RBRACE,
    ACTIONS(10844), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      aux_sym__with_body_repeat1,
    STATE(7061), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301719] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10846), 1,
      anon_sym_EQ,
    ACTIONS(10848), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7062), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301768] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10656), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      anon_sym_RPAREN,
    STATE(6816), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(7063), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301819] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10852), 1,
      anon_sym_EQ,
    ACTIONS(10854), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7064), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301868] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10856), 1,
      anon_sym_COMMA,
    ACTIONS(10858), 1,
      anon_sym_RPAREN,
    STATE(7103), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(7065), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301919] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10860), 1,
      anon_sym_EQ,
    ACTIONS(10229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7066), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [301968] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym_COMMA,
    ACTIONS(10862), 1,
      anon_sym_RPAREN,
    STATE(6965), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(7067), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302019] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(10864), 1,
      anon_sym_RPAREN,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(7068), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302070] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10866), 1,
      anon_sym_COMMA,
    ACTIONS(10869), 1,
      anon_sym_RBRACE,
    STATE(7069), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_enum_member_declaration_list_repeat1,
  [302119] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8856), 1,
      anon_sym_RBRACE,
    ACTIONS(10871), 1,
      anon_sym_COMMA,
    STATE(7069), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(7070), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302170] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10873), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(7071), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302217] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10875), 1,
      anon_sym_COMMA,
    ACTIONS(10877), 1,
      anon_sym_RPAREN,
    STATE(6798), 1,
      aux_sym_using_variable_declaration_repeat1,
    STATE(7072), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302268] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(10879), 1,
      anon_sym_RPAREN,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(7073), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302319] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10881), 1,
      anon_sym_RBRACK,
    STATE(6715), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(7074), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302370] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10883), 1,
      anon_sym_EQ,
    ACTIONS(10201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7075), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302419] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10885), 1,
      anon_sym_COMMA,
    ACTIONS(10887), 1,
      anon_sym_RBRACK,
    STATE(7087), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7076), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302470] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10889), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(7077), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302517] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7640), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7078), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302568] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10891), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7079), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302615] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2715), 1,
      anon_sym_RBRACK,
    ACTIONS(10893), 1,
      anon_sym_COMMA,
    STATE(7050), 1,
      aux_sym_argument_list_repeat1,
    STATE(7080), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302666] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10895), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(7081), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302713] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10559), 1,
      anon_sym_COMMA,
    ACTIONS(10897), 1,
      anon_sym_RPAREN,
    STATE(7055), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(7082), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302764] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10899), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(7083), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302811] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10559), 1,
      anon_sym_COMMA,
    ACTIONS(10901), 1,
      anon_sym_RPAREN,
    STATE(7082), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(7084), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302862] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    ACTIONS(10293), 1,
      anon_sym_LPAREN,
    STATE(2044), 1,
      sym_block,
    STATE(7085), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302913] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10559), 1,
      anon_sym_COMMA,
    ACTIONS(10903), 1,
      anon_sym_RPAREN,
    STATE(7055), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(7086), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [302964] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8944), 1,
      anon_sym_RBRACK,
    ACTIONS(10905), 1,
      anon_sym_COMMA,
    STATE(6963), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7087), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303015] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10308), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7088), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303062] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10907), 1,
      anon_sym_COMMA,
    ACTIONS(10910), 1,
      aux_sym_preproc_if_token2,
    STATE(7089), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_preproc_pragma_repeat1,
  [303111] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10308), 1,
      anon_sym_SEMI,
    ACTIONS(10912), 1,
      anon_sym_COMMA,
    STATE(7090), 10,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_variable_declaration_repeat1,
  [303160] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    ACTIONS(10915), 1,
      anon_sym_RPAREN,
    STATE(6872), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7091), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303211] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10917), 1,
      anon_sym_COMMA,
    ACTIONS(10919), 1,
      anon_sym_RBRACK,
    STATE(7037), 1,
      aux_sym_global_attribute_repeat1,
    STATE(7092), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303262] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(10921), 1,
      anon_sym_RPAREN,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(7093), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303313] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10923), 1,
      anon_sym_EQ,
    ACTIONS(10848), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7094), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303362] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10925), 1,
      anon_sym_COMMA,
    ACTIONS(10927), 1,
      anon_sym_RBRACK,
    STATE(7080), 1,
      aux_sym_argument_list_repeat1,
    STATE(7095), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303413] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(7691), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7096), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303464] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10929), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(7097), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303511] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7648), 1,
      anon_sym_COMMA,
    ACTIONS(10931), 1,
      anon_sym_RPAREN,
    STATE(6776), 1,
      aux_sym__for_statement_conditions_repeat1,
    STATE(7098), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303562] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_COMMA,
    ACTIONS(10933), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(7099), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303613] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10875), 1,
      anon_sym_COMMA,
    ACTIONS(10935), 1,
      anon_sym_RPAREN,
    STATE(7072), 1,
      aux_sym_using_variable_declaration_repeat1,
    STATE(7100), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303664] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10364), 1,
      anon_sym_COMMA,
    ACTIONS(10937), 1,
      anon_sym_GT,
    STATE(6843), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(7101), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303715] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10639), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      anon_sym_SEMI,
    STATE(7090), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(7102), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303766] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10856), 1,
      anon_sym_COMMA,
    ACTIONS(10939), 1,
      anon_sym_RPAREN,
    STATE(6804), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(7103), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303817] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10941), 1,
      anon_sym_EQ,
    ACTIONS(10854), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7104), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303866] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7861), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(7105), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303913] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    STATE(6997), 1,
      aux_sym_argument_list_repeat1,
    STATE(7106), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [303961] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6357), 1,
      sym_parameter_list,
    STATE(7107), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304009] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3191), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7108), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304055] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    STATE(2106), 1,
      sym_block,
    STATE(7109), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304103] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3195), 1,
      anon_sym_while,
    ACTIONS(10943), 1,
      anon_sym_else,
    STATE(7110), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304151] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3225), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7111), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304197] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10945), 1,
      anon_sym_LBRACE,
    STATE(3361), 1,
      sym__switch_expression_body,
    STATE(7112), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304245] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10258), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7113), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304291] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(7141), 1,
      sym_parameter_list,
    STATE(7114), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304339] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10947), 2,
      anon_sym_SEMI,
      anon_sym_where,
    STATE(7115), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304385] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6380), 1,
      sym_parameter_list,
    STATE(7116), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304433] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6460), 1,
      sym_parameter_list,
    STATE(7117), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304481] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10949), 1,
      anon_sym_LBRACE,
    STATE(3129), 1,
      sym__switch_expression_body,
    STATE(7118), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304529] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10951), 2,
      anon_sym_this,
      anon_sym_base,
    STATE(7119), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304575] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10953), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7120), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304621] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(6795), 1,
      sym_bracketed_parameter_list,
    STATE(7121), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304669] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10957), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7122), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304715] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10959), 1,
      anon_sym_LBRACE,
    STATE(3431), 1,
      sym__with_body,
    STATE(7123), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304763] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_DQUOTE,
    STATE(7266), 1,
      sym_string_literal,
    STATE(7124), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304811] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3201), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7125), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304857] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10961), 1,
      anon_sym_LBRACE,
    STATE(3387), 1,
      sym__with_body,
    STATE(7126), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304905] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10963), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10965), 1,
      sym_preproc_arg,
    STATE(7127), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [304953] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10967), 1,
      anon_sym_LBRACE,
    STATE(3015), 1,
      sym__switch_expression_body,
    STATE(7128), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305001] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10969), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(7129), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305047] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3233), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7130), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305093] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10971), 2,
      anon_sym_SEMI,
      anon_sym_where,
    STATE(7131), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305139] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10973), 1,
      anon_sym_LBRACK,
    STATE(2972), 1,
      sym_array_rank_specifier,
    STATE(7132), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305187] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6768), 1,
      sym_parameter_list,
    STATE(7133), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305235] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10975), 1,
      anon_sym_LBRACE,
    STATE(3092), 1,
      sym__with_body,
    STATE(7134), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305283] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    STATE(4666), 1,
      sym_initializer_expression,
    STATE(7135), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305331] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    STATE(6932), 1,
      aux_sym_argument_list_repeat1,
    STATE(7136), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305379] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6958), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7137), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305427] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3229), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7138), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305473] = 13,
    ACTIONS(4967), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10977), 1,
      sym_string_literal_encoding,
    STATE(7139), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305521] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3293), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7140), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305567] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10979), 2,
      anon_sym_SEMI,
      anon_sym_where,
    STATE(7141), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305613] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10271), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7142), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305659] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_LBRACE,
    STATE(3435), 1,
      sym_initializer_expression,
    STATE(7143), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305707] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1507), 1,
      anon_sym_LBRACE,
    STATE(3150), 1,
      sym_initializer_expression,
    STATE(7144), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305755] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    STATE(6889), 1,
      aux_sym_argument_list_repeat1,
    STATE(7145), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305803] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10430), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7146), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10981), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7147), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305895] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3281), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7148), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305941] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10983), 1,
      anon_sym_LPAREN,
    STATE(92), 1,
      sym__for_statement_conditions,
    STATE(7149), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [305989] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_LBRACE,
    STATE(3439), 1,
      sym_initializer_expression,
    STATE(7150), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306037] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10985), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7151), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306083] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(10987), 1,
      anon_sym_SEMI,
    STATE(7152), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306131] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_LBRACE,
    STATE(3448), 1,
      sym_initializer_expression,
    STATE(7153), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306179] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6894), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7154), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306227] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10989), 1,
      anon_sym_LBRACK,
    ACTIONS(10991), 1,
      anon_sym_LT,
    STATE(7155), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306275] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10690), 1,
      anon_sym_DQUOTE,
    STATE(7503), 1,
      sym_string_literal,
    STATE(7156), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306323] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(10993), 1,
      anon_sym_in,
    STATE(7157), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306371] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_block,
    STATE(7158), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306419] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6349), 1,
      sym_parameter_list,
    STATE(7159), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306467] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_LBRACE,
    STATE(3924), 1,
      sym_initializer_expression,
    STATE(7160), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306515] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10995), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(7161), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306561] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_LBRACE,
    STATE(2034), 1,
      sym_block,
    STATE(7162), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306609] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3321), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7163), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306655] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(7248), 1,
      sym_parameter_list,
    STATE(7164), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306703] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(6718), 1,
      sym_bracketed_parameter_list,
    STATE(7165), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306751] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10997), 2,
      anon_sym_SEMI,
      anon_sym_where,
    STATE(7166), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306797] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6992), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7167), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306845] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_LBRACE,
    STATE(3032), 1,
      sym_initializer_expression,
    STATE(7168), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306893] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    STATE(6860), 1,
      aux_sym_argument_list_repeat1,
    STATE(7169), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306941] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_LBRACE,
    STATE(3393), 1,
      sym_initializer_expression,
    STATE(7170), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [306989] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(6782), 1,
      sym_bracketed_parameter_list,
    STATE(7171), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307037] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9946), 1,
      anon_sym_LBRACE,
    STATE(3935), 1,
      sym_block,
    STATE(7172), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307085] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(10999), 1,
      anon_sym_SEMI,
    STATE(7173), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307133] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6365), 1,
      sym_parameter_list,
    STATE(7174), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307181] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_LBRACE,
    STATE(3275), 1,
      sym_initializer_expression,
    STATE(7175), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307229] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11001), 1,
      anon_sym_LBRACE,
    STATE(3880), 1,
      sym__with_body,
    STATE(7176), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307277] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3333), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7177), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307323] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11003), 1,
      anon_sym_LPAREN,
    STATE(7282), 1,
      sym_tuple_expression,
    STATE(7178), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307371] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11005), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7179), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307417] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10291), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7180), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307463] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3345), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7181), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307509] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    STATE(7329), 1,
      sym_block,
    STATE(7182), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307557] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6488), 1,
      sym_parameter_list,
    STATE(7183), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307605] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1507), 1,
      anon_sym_LBRACE,
    STATE(3130), 1,
      sym_initializer_expression,
    STATE(7184), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307653] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_LBRACE,
    STATE(3068), 1,
      sym_initializer_expression,
    STATE(7185), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307701] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3213), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7186), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307747] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6501), 1,
      sym_parameter_list,
    STATE(7187), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307795] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11007), 1,
      anon_sym_LBRACE,
    STATE(4655), 1,
      sym__switch_expression_body,
    STATE(7188), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307843] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11009), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7189), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307889] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11011), 1,
      anon_sym_LBRACK,
    STATE(2999), 1,
      sym_array_rank_specifier,
    STATE(7190), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307937] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4028), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7191), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [307983] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_DQUOTE,
    STATE(7124), 1,
      sym_string_literal,
    STATE(7192), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308031] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6471), 1,
      sym_parameter_list,
    STATE(7193), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308079] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3349), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7194), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308125] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11013), 1,
      anon_sym_LBRACK,
    STATE(2721), 1,
      sym_array_rank_specifier,
    STATE(7195), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308173] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10540), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7196), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308219] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11015), 1,
      anon_sym_LBRACE,
    STATE(2023), 1,
      sym_switch_body,
    STATE(7197), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308267] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6506), 1,
      sym_parameter_list,
    STATE(7198), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308315] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10983), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym__for_statement_conditions,
    STATE(7199), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308363] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3273), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7200), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308409] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(3446), 1,
      sym_block,
    STATE(7201), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308457] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9923), 1,
      anon_sym_LBRACE,
    STATE(3358), 1,
      sym_block,
    STATE(7202), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308505] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1507), 1,
      anon_sym_LBRACE,
    STATE(3112), 1,
      sym_initializer_expression,
    STATE(7203), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308553] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3341), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7204), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308599] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_LBRACE,
    STATE(3287), 1,
      sym_initializer_expression,
    STATE(7205), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308647] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(11017), 1,
      anon_sym_SEMI,
    STATE(7206), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308695] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_LBRACK,
    ACTIONS(6757), 1,
      anon_sym_STAR,
    STATE(7207), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308743] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11019), 1,
      anon_sym_LBRACE,
    STATE(3427), 1,
      sym__switch_expression_body,
    STATE(7208), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308791] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11015), 1,
      anon_sym_LBRACE,
    STATE(2058), 1,
      sym_switch_body,
    STATE(7209), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308839] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11021), 1,
      anon_sym_LBRACK,
    STATE(4334), 1,
      sym_array_rank_specifier,
    STATE(7210), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308887] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(7091), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7211), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308935] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9929), 1,
      anon_sym_LBRACE,
    STATE(3008), 1,
      sym_block,
    STATE(7212), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [308983] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(11023), 1,
      anon_sym_SEMI,
    STATE(7213), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309031] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10983), 1,
      anon_sym_LPAREN,
    STATE(69), 1,
      sym__for_statement_conditions,
    STATE(7214), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309079] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11025), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(7215), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309125] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(11027), 1,
      anon_sym_SEMI,
    STATE(7216), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309173] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11029), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7217), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309219] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_LBRACE,
    STATE(3014), 1,
      sym_initializer_expression,
    STATE(7218), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309267] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3217), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7219), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309313] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    STATE(6438), 1,
      sym_block,
    STATE(7220), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309361] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11031), 1,
      anon_sym_LBRACE,
    STATE(7292), 1,
      sym_switch_body,
    STATE(7221), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309409] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3277), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7222), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309455] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3337), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7223), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309501] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10773), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7224), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309547] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3317), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7225), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309593] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_GT,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(7226), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309641] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_LBRACE,
    STATE(3912), 1,
      sym_initializer_expression,
    STATE(7227), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309689] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11033), 2,
      anon_sym_disable,
      anon_sym_restore,
    STATE(7228), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309735] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11035), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7229), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309781] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    STATE(6864), 1,
      sym_argument_list,
    STATE(7230), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309829] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6442), 1,
      sym_parameter_list,
    STATE(7231), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309877] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6880), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7232), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309925] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11031), 1,
      anon_sym_LBRACE,
    STATE(7288), 1,
      sym_switch_body,
    STATE(7233), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [309973] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6977), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7234), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310021] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10452), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7235), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310067] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6486), 1,
      sym_parameter_list,
    STATE(7236), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310115] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3205), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7237), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310161] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3221), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7238), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310207] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6802), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7239), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310255] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11037), 1,
      anon_sym_LBRACE,
    STATE(3135), 1,
      sym__with_body,
    STATE(7240), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310303] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9807), 1,
      anon_sym_LBRACE,
    STATE(4702), 1,
      sym_block,
    STATE(7241), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310351] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3285), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7242), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310397] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11039), 1,
      anon_sym_LBRACK,
    STATE(2421), 1,
      sym_array_rank_specifier,
    STATE(7243), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310445] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6477), 1,
      sym_parameter_list,
    STATE(7244), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310493] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11041), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_array_rank_specifier,
    STATE(7245), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310541] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6451), 1,
      sym_parameter_list,
    STATE(7246), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310589] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9807), 1,
      anon_sym_LBRACE,
    STATE(4648), 1,
      sym_block,
    STATE(7247), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310637] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11043), 2,
      anon_sym_SEMI,
      anon_sym_where,
    STATE(7248), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310683] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6479), 1,
      sym_parameter_list,
    STATE(7249), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310731] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10827), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7250), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310777] = 13,
    ACTIONS(4952), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11045), 1,
      sym_string_literal_encoding,
    STATE(7251), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310825] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    STATE(3110), 1,
      sym_block,
    STATE(7252), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310873] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11047), 1,
      anon_sym_LPAREN,
    STATE(7233), 1,
      sym_tuple_expression,
    STATE(7253), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310921] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_LBRACE,
    STATE(3757), 1,
      sym_initializer_expression,
    STATE(7254), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [310969] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(1981), 1,
      sym_block,
    STATE(7255), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311017] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11049), 1,
      anon_sym_LPAREN,
    STATE(7197), 1,
      sym_tuple_expression,
    STATE(7256), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311065] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11051), 1,
      anon_sym_warning,
    ACTIONS(11053), 1,
      anon_sym_checksum,
    STATE(7257), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311113] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3179), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7258), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311159] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3183), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7259), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311205] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3325), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7260), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311251] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(6710), 1,
      sym_bracketed_parameter_list,
    STATE(7261), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311299] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(3419), 1,
      sym_block,
    STATE(7262), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311347] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11055), 1,
      anon_sym_LBRACK,
    STATE(3288), 1,
      sym_array_rank_specifier,
    STATE(7263), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311395] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3245), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7264), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311441] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4044), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7265), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311487] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10690), 1,
      anon_sym_DQUOTE,
    STATE(7473), 1,
      sym_string_literal,
    STATE(7266), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11057), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7267), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311581] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9946), 1,
      anon_sym_LBRACE,
    STATE(3775), 1,
      sym_block,
    STATE(7268), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311629] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3187), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7269), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311675] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3237), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7270), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311721] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11059), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7271), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311767] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6518), 1,
      sym_parameter_list,
    STATE(7272), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311815] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3289), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7273), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311861] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10869), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7274), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311907] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11061), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7275), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [311953] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    STATE(4671), 1,
      sym_initializer_expression,
    STATE(7276), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312001] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2063), 1,
      sym_block,
    STATE(7277), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312049] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6371), 1,
      sym_parameter_list,
    STATE(7278), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312097] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11063), 1,
      anon_sym_LBRACE,
    STATE(1943), 1,
      sym_switch_body,
    STATE(7279), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312145] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(7131), 1,
      sym_parameter_list,
    STATE(7280), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312193] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11065), 2,
      anon_sym_SEMI,
      anon_sym_where,
    STATE(7281), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312239] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11067), 1,
      anon_sym_LBRACE,
    STATE(2105), 1,
      sym_switch_body,
    STATE(7282), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312287] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6487), 1,
      sym_parameter_list,
    STATE(7283), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312335] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10983), 1,
      anon_sym_LPAREN,
    STATE(68), 1,
      sym__for_statement_conditions,
    STATE(7284), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312383] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3209), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7285), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312429] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11069), 1,
      anon_sym_LBRACK,
    STATE(4450), 1,
      sym_array_rank_specifier,
    STATE(7286), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312477] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3241), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7287), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312523] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3171), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7288), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312569] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_COMMA,
    STATE(6998), 1,
      aux_sym_tuple_type_repeat1,
    STATE(7289), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312617] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11071), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7290), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312663] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11073), 1,
      anon_sym_LBRACE,
    STATE(4657), 1,
      sym__with_body,
    STATE(7291), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312711] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3175), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7292), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312757] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3249), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7293), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312803] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10628), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7294), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11075), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7295), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312895] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_LBRACE,
    STATE(4704), 1,
      sym_initializer_expression,
    STATE(7296), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312943] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11077), 1,
      anon_sym_LPAREN,
    STATE(7279), 1,
      sym_tuple_expression,
    STATE(7297), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [312991] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3135), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7298), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313037] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3329), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7299), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313083] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6704), 1,
      sym_parameter_list,
    STATE(7300), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313131] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(11079), 1,
      anon_sym_SEMI,
    STATE(7301), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313179] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(6778), 1,
      sym_bracketed_parameter_list,
    STATE(7302), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313227] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3261), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7303), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313273] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    ACTIONS(11081), 1,
      anon_sym_in,
    STATE(7304), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313321] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11083), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(7305), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313367] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11085), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(7306), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313413] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LBRACE,
    STATE(3152), 1,
      sym_block,
    STATE(7307), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313461] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6452), 1,
      sym_parameter_list,
    STATE(7308), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313509] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6377), 1,
      sym_parameter_list,
    STATE(7309), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313557] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10910), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11087), 1,
      anon_sym_COMMA,
    STATE(7310), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313605] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11067), 1,
      anon_sym_LBRACE,
    STATE(2132), 1,
      sym_switch_body,
    STATE(7311), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313653] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6454), 1,
      sym_parameter_list,
    STATE(7312), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313701] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11089), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(7313), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313747] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11091), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7314), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313793] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11093), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7315), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313839] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACE,
    STATE(1928), 1,
      sym_block,
    STATE(7316), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313887] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11095), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7317), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313933] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3297), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7318), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [313979] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11097), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7319), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314025] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11099), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7320), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314071] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11101), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7321), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314117] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3301), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7322), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314163] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11063), 1,
      anon_sym_LBRACE,
    STATE(1944), 1,
      sym_switch_body,
    STATE(7323), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314211] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11103), 1,
      anon_sym_LBRACE,
    STATE(3862), 1,
      sym__switch_expression_body,
    STATE(7324), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314259] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(11105), 1,
      anon_sym_SEMI,
    STATE(7325), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314307] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9923), 1,
      anon_sym_LBRACE,
    STATE(3317), 1,
      sym_block,
    STATE(7326), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314355] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11107), 1,
      anon_sym_on,
    STATE(6344), 1,
      sym__join_body,
    STATE(7327), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314403] = 13,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11109), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11111), 1,
      sym_preproc_arg,
    STATE(7328), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314451] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3305), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7329), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314497] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3309), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7330), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314543] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4024), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7331), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314589] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3269), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7332), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314635] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6504), 1,
      sym_parameter_list,
    STATE(7333), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314683] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11113), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7334), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314729] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10955), 1,
      anon_sym_LBRACK,
    STATE(6695), 1,
      sym_bracketed_parameter_list,
    STATE(7335), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314777] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11115), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7336), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314823] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    STATE(6976), 1,
      aux_sym_argument_list_repeat1,
    STATE(7337), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314871] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3313), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7338), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314917] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_LPAREN,
    STATE(6784), 1,
      sym_parameter_list,
    STATE(7339), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [314965] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11117), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7340), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315011] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9929), 1,
      anon_sym_LBRACE,
    STATE(3096), 1,
      sym_block,
    STATE(7341), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315059] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10652), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(7342), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315105] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4036), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7343), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315151] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11119), 1,
      anon_sym_STAR,
    STATE(7344), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315196] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11121), 1,
      anon_sym_RPAREN,
    STATE(7345), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315241] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11123), 1,
      anon_sym_COLON,
    STATE(7346), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315286] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11125), 1,
      anon_sym_EQ_GT,
    STATE(7347), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11127), 1,
      anon_sym_in,
    STATE(7348), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315376] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11129), 1,
      anon_sym_SEMI,
    STATE(7349), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315421] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11131), 1,
      anon_sym_COLON,
    STATE(7350), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315466] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11133), 1,
      anon_sym_in,
    STATE(7351), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315511] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11135), 1,
      anon_sym_EQ_GT,
    STATE(7352), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315556] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11137), 1,
      aux_sym_preproc_if_token3,
    STATE(7353), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315601] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10507), 1,
      anon_sym_RBRACE,
    STATE(7354), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315646] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11139), 1,
      sym__optional_semi,
    STATE(7355), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315691] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11141), 1,
      anon_sym_RPAREN,
    STATE(7356), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315736] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8729), 1,
      anon_sym_RPAREN,
    STATE(7357), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315781] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11143), 1,
      anon_sym_RBRACE,
    STATE(7358), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315826] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11145), 1,
      anon_sym_GT,
    STATE(7359), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315871] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11147), 1,
      anon_sym_SEMI,
    STATE(7360), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315916] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11149), 1,
      anon_sym_EQ_GT,
    STATE(7361), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [315961] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11151), 1,
      sym__optional_semi,
    STATE(7362), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316006] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11153), 1,
      anon_sym_RBRACK,
    STATE(7363), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316051] = 12,
    ACTIONS(4967), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    STATE(7364), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316096] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11155), 1,
      aux_sym_preproc_if_token3,
    STATE(7365), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316141] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11157), 1,
      anon_sym_RBRACE,
    STATE(7366), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316186] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11159), 1,
      aux_sym_preproc_if_token3,
    STATE(7367), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316231] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11161), 1,
      anon_sym_SEMI,
    STATE(7368), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11163), 1,
      anon_sym_RPAREN,
    STATE(7369), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316321] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11165), 1,
      sym_raw_string_content,
    STATE(7370), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316366] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11167), 1,
      aux_sym_preproc_if_token2,
    STATE(7371), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316411] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9743), 1,
      anon_sym_EQ,
    STATE(7372), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316456] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10686), 1,
      anon_sym_RBRACE,
    STATE(7373), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316501] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11169), 1,
      anon_sym_RPAREN,
    STATE(7374), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316546] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11171), 1,
      anon_sym_LT,
    STATE(7375), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316591] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11173), 1,
      anon_sym_RPAREN,
    STATE(7376), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316636] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7526), 1,
      anon_sym_RBRACE,
    STATE(7377), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316681] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11175), 1,
      sym_preproc_arg,
    STATE(7378), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316726] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11177), 1,
      anon_sym_SEMI,
    STATE(7379), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316771] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11179), 1,
      anon_sym_RPAREN,
    STATE(7380), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316816] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11181), 1,
      anon_sym_GT,
    STATE(7381), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316861] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10680), 1,
      anon_sym_RBRACE,
    STATE(7382), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316906] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11183), 1,
      sym_raw_string_content,
    STATE(7383), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316951] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11185), 1,
      anon_sym_EQ,
    STATE(7384), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [316996] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11187), 1,
      anon_sym_EQ_GT,
    STATE(7385), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317041] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11189), 1,
      anon_sym_RPAREN,
    STATE(7386), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317086] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11191), 1,
      anon_sym_GT,
    STATE(7387), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11193), 1,
      anon_sym_SEMI,
    STATE(7388), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317176] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11195), 1,
      anon_sym_RPAREN,
    STATE(7389), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317221] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11197), 1,
      sym_interpolation_start_quote,
    STATE(7390), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317266] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11199), 1,
      anon_sym_EQ_GT,
    STATE(7391), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317311] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11201), 1,
      anon_sym_SEMI,
    STATE(7392), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317356] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11203), 1,
      anon_sym_SEMI,
    STATE(7393), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317401] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11205), 1,
      anon_sym_RPAREN,
    STATE(7394), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317446] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8454), 1,
      anon_sym_RPAREN,
    STATE(7395), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317491] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11207), 1,
      anon_sym_SEMI,
    STATE(7396), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317536] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11209), 1,
      aux_sym_preproc_if_token3,
    STATE(7397), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317581] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8709), 1,
      anon_sym_RPAREN,
    STATE(7398), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317626] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10525), 1,
      anon_sym_RBRACE,
    STATE(7399), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317671] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11211), 1,
      anon_sym_RPAREN,
    STATE(7400), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317716] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11213), 1,
      anon_sym_SEMI,
    STATE(7401), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317761] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11215), 1,
      aux_sym_preproc_if_token3,
    STATE(7402), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317806] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11217), 1,
      anon_sym_EQ_GT,
    STATE(7403), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317851] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11219), 1,
      anon_sym_STAR,
    STATE(7404), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317896] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11221), 1,
      anon_sym_COMMA,
    STATE(7405), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317941] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11223), 1,
      anon_sym_LT,
    STATE(7406), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [317986] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11225), 1,
      anon_sym_COMMA,
    STATE(7407), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318031] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11227), 1,
      anon_sym_SEMI,
    STATE(7408), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318076] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10533), 1,
      anon_sym_RBRACE,
    STATE(7409), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318121] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11229), 1,
      anon_sym_EQ_GT,
    STATE(7410), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318166] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11231), 1,
      anon_sym_GT,
    STATE(7411), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318211] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11233), 1,
      anon_sym_EQ_GT,
    STATE(7412), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318256] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11235), 1,
      anon_sym_COMMA,
    STATE(7413), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318301] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11237), 1,
      sym__optional_semi,
    STATE(7414), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318346] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11239), 1,
      sym__optional_semi,
    STATE(7415), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318391] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11241), 1,
      anon_sym_SEMI,
    STATE(7416), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318436] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11243), 1,
      anon_sym_RPAREN,
    STATE(7417), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318481] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11245), 1,
      sym_preproc_arg,
    STATE(7418), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318526] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11247), 1,
      anon_sym_RPAREN,
    STATE(7419), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318571] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11249), 1,
      sym_interpolation_start_quote,
    STATE(7420), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318616] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11251), 1,
      anon_sym_GT,
    STATE(7421), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318661] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11253), 1,
      anon_sym_EQ_GT,
    STATE(7422), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318706] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10712), 1,
      anon_sym_RBRACE,
    STATE(7423), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318751] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9701), 1,
      anon_sym_COMMA,
    STATE(7424), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318796] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10716), 1,
      anon_sym_RBRACE,
    STATE(7425), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318841] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11255), 1,
      anon_sym_GT,
    STATE(7426), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318886] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11257), 1,
      anon_sym_EQ_GT,
    STATE(7427), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318931] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11259), 1,
      sym_interpolation_start_quote,
    STATE(7428), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [318976] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11261), 1,
      anon_sym_SEMI,
    STATE(7429), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319021] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11263), 1,
      anon_sym_EQ_GT,
    STATE(7430), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319066] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10736), 1,
      anon_sym_RBRACE,
    STATE(7431), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319111] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11265), 1,
      anon_sym_SEMI,
    STATE(7432), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319156] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token3,
    STATE(7433), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319201] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11269), 1,
      aux_sym_preproc_if_token2,
    STATE(7434), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319246] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11271), 1,
      anon_sym_RPAREN,
    STATE(7435), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319291] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11273), 1,
      anon_sym_RPAREN,
    STATE(7436), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319336] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11275), 1,
      aux_sym_preproc_if_token3,
    STATE(7437), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319381] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_EQ_GT,
    STATE(7438), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319426] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11279), 1,
      anon_sym_RPAREN,
    STATE(7439), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319471] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11281), 1,
      anon_sym_RPAREN,
    STATE(7440), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319516] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11283), 1,
      anon_sym_SEMI,
    STATE(7441), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319561] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11285), 1,
      anon_sym_GT,
    STATE(7442), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319606] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11287), 1,
      anon_sym_COLON,
    STATE(7443), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319651] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11289), 1,
      anon_sym_COLON,
    STATE(7444), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319696] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11291), 1,
      anon_sym_RPAREN,
    STATE(7445), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319741] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11293), 1,
      anon_sym_RPAREN,
    STATE(7446), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319786] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10396), 1,
      anon_sym_RBRACE,
    STATE(7447), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319831] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11295), 1,
      anon_sym_GT,
    STATE(7448), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319876] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11297), 1,
      anon_sym_RPAREN,
    STATE(7449), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319921] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11299), 1,
      anon_sym_SEMI,
    STATE(7450), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [319966] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10513), 1,
      anon_sym_RBRACE,
    STATE(7451), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320011] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11301), 1,
      aux_sym_preproc_if_token2,
    STATE(7452), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320056] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11303), 1,
      anon_sym_COMMA,
    STATE(7453), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320101] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11305), 1,
      anon_sym_EQ_GT,
    STATE(7454), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320146] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11307), 1,
      anon_sym_EQ_GT,
    STATE(7455), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320191] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11309), 1,
      anon_sym_SEMI,
    STATE(7456), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320236] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11311), 1,
      aux_sym_preproc_if_token2,
    STATE(7457), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320281] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11313), 1,
      anon_sym_GT,
    STATE(7458), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320326] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11315), 1,
      anon_sym_SEMI,
    STATE(7459), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320371] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11317), 1,
      aux_sym_preproc_if_token2,
    STATE(7460), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320416] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11319), 1,
      aux_sym_preproc_if_token3,
    STATE(7461), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320461] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11321), 1,
      aux_sym_preproc_if_token3,
    STATE(7462), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320506] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11323), 1,
      anon_sym_STAR,
    STATE(7463), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320551] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11325), 1,
      sym__optional_semi,
    STATE(7464), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320596] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11327), 1,
      anon_sym_LPAREN,
    STATE(7465), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320641] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11329), 1,
      aux_sym_preproc_if_token2,
    STATE(7466), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320686] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11331), 1,
      sym_interpolation_start_quote,
    STATE(7467), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320731] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11333), 1,
      aux_sym_preproc_if_token3,
    STATE(7468), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320776] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11335), 1,
      sym_interpolation_start_quote,
    STATE(7469), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320821] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11337), 1,
      anon_sym_EQ_GT,
    STATE(7470), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320866] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11339), 1,
      sym_interpolation_start_quote,
    STATE(7471), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320911] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11341), 1,
      anon_sym_SEMI,
    STATE(7472), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [320956] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10744), 1,
      aux_sym_preproc_if_token2,
    STATE(7473), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321001] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11343), 1,
      aux_sym_preproc_if_token2,
    STATE(7474), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321046] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11345), 1,
      aux_sym_preproc_if_token3,
    STATE(7475), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321091] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11347), 1,
      aux_sym_preproc_if_token3,
    STATE(7476), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321136] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11349), 1,
      aux_sym_preproc_if_token3,
    STATE(7477), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321181] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11351), 1,
      anon_sym_SEMI,
    STATE(7478), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321226] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11353), 1,
      anon_sym_EQ_GT,
    STATE(7479), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321271] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11355), 1,
      sym_raw_string_content,
    STATE(7480), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321316] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7644), 1,
      anon_sym_RBRACE,
    STATE(7481), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321361] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11357), 1,
      anon_sym_RPAREN,
    STATE(7482), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321406] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11359), 1,
      anon_sym_EQ_GT,
    STATE(7483), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321451] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11361), 1,
      anon_sym_RPAREN,
    STATE(7484), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321496] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11363), 1,
      aux_sym_preproc_if_token3,
    STATE(7485), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321541] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11365), 1,
      anon_sym_EQ_GT,
    STATE(7486), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321586] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10408), 1,
      anon_sym_RBRACE,
    STATE(7487), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321631] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11367), 1,
      anon_sym_LPAREN,
    STATE(7488), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321676] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11369), 1,
      anon_sym_LPAREN,
    STATE(7489), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321721] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11371), 1,
      sym_raw_string_end,
    STATE(7490), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321766] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11373), 1,
      anon_sym_SEMI,
    STATE(7491), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321811] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11375), 1,
      anon_sym_SQUOTE,
    STATE(7492), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321856] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11377), 1,
      aux_sym_preproc_if_token3,
    STATE(7493), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321901] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11379), 1,
      anon_sym_GT,
    STATE(7494), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321946] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11381), 1,
      anon_sym_GT,
    STATE(7495), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [321991] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11383), 1,
      sym_interpolation_start_quote,
    STATE(7496), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322036] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10822), 1,
      anon_sym_RBRACE,
    STATE(7497), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322081] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11385), 1,
      anon_sym_SEMI,
    STATE(7498), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322126] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11387), 1,
      anon_sym_GT,
    STATE(7499), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322171] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11389), 1,
      anon_sym_RPAREN,
    STATE(7500), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322216] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11391), 1,
      aux_sym_preproc_if_token3,
    STATE(7501), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322261] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11393), 1,
      anon_sym_SEMI,
    STATE(7502), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322306] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11395), 1,
      aux_sym_preproc_if_token2,
    STATE(7503), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322351] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11397), 1,
      anon_sym_EQ_GT,
    STATE(7504), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322396] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11399), 1,
      anon_sym_LPAREN,
    STATE(7505), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322441] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11401), 1,
      sym_raw_string_content,
    STATE(7506), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322486] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11403), 1,
      anon_sym_RBRACK,
    STATE(7507), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322531] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11405), 1,
      aux_sym_preproc_if_token3,
    STATE(7508), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322576] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11407), 1,
      anon_sym_SEMI,
    STATE(7509), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322621] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11409), 1,
      sym__optional_semi,
    STATE(7510), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322666] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11411), 1,
      aux_sym_preproc_if_token3,
    STATE(7511), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322711] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11413), 1,
      sym_interpolation_start_quote,
    STATE(7512), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322756] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11415), 1,
      anon_sym_GT,
    STATE(7513), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322801] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11417), 1,
      anon_sym_LPAREN,
    STATE(7514), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322846] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10991), 1,
      anon_sym_LT,
    STATE(7515), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322891] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10781), 1,
      anon_sym_RBRACE,
    STATE(7516), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322936] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11419), 1,
      anon_sym_GT,
    STATE(7517), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [322981] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11421), 1,
      anon_sym_GT,
    STATE(7518), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323026] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11423), 1,
      sym_interpolation_start_quote,
    STATE(7519), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323071] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11425), 1,
      sym_integer_literal,
    STATE(7520), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323116] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11427), 1,
      sym_interpolation_start_quote,
    STATE(7521), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323161] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11429), 1,
      anon_sym_STAR,
    STATE(7522), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323206] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11431), 1,
      aux_sym_interpolation_format_clause_token1,
    STATE(7523), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323251] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11433), 1,
      sym_interpolation_start_quote,
    STATE(7524), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323296] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_RPAREN,
    STATE(7525), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323341] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11435), 1,
      anon_sym_RPAREN,
    STATE(7526), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323386] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11437), 1,
      anon_sym_SEMI,
    STATE(7527), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323431] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11439), 1,
      sym_raw_string_content,
    STATE(7528), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323476] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11441), 1,
      aux_sym_preproc_if_token3,
    STATE(7529), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323521] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11443), 1,
      aux_sym_preproc_if_token3,
    STATE(7530), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323566] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11445), 1,
      aux_sym_preproc_if_token3,
    STATE(7531), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323611] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11447), 1,
      anon_sym_LT,
    STATE(7532), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323656] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11449), 1,
      anon_sym_RBRACK,
    STATE(7533), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323701] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11451), 1,
      anon_sym_EQ_GT,
    STATE(7534), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323746] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10777), 1,
      anon_sym_RBRACE,
    STATE(7535), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323791] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10579), 1,
      anon_sym_RBRACE,
    STATE(7536), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323836] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11453), 1,
      aux_sym_preproc_if_token3,
    STATE(7537), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323881] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11455), 1,
      anon_sym_SEMI,
    STATE(7538), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323926] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11457), 1,
      anon_sym_EQ_GT,
    STATE(7539), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [323971] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11459), 1,
      anon_sym_EQ_GT,
    STATE(7540), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324016] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11461), 1,
      aux_sym_preproc_if_token3,
    STATE(7541), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324061] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11463), 1,
      anon_sym_EQ_GT,
    STATE(7542), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324106] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11465), 1,
      anon_sym_EQ_GT,
    STATE(7543), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324151] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10785), 1,
      sym_interpolation_close_brace,
    STATE(7544), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324196] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11467), 1,
      sym_preproc_arg,
    STATE(7545), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324241] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11469), 1,
      anon_sym_EQ_GT,
    STATE(7546), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324286] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11471), 1,
      anon_sym_RBRACE,
    STATE(7547), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11473), 1,
      sym_raw_string_end,
    STATE(7548), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324376] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11475), 1,
      anon_sym_LPAREN,
    STATE(7549), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324421] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10795), 1,
      anon_sym_RBRACE,
    STATE(7550), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324466] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11477), 1,
      aux_sym_preproc_if_token3,
    STATE(7551), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324511] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11479), 1,
      anon_sym_GT,
    STATE(7552), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324556] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11481), 1,
      anon_sym_EQ_GT,
    STATE(7553), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324601] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11483), 1,
      anon_sym_EQ_GT,
    STATE(7554), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324646] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_SEMI,
    STATE(7555), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324691] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11485), 1,
      anon_sym_EQ_GT,
    STATE(7556), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324736] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11487), 1,
      anon_sym_SEMI,
    STATE(7557), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324781] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11489), 1,
      anon_sym_GT,
    STATE(7558), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324826] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11491), 1,
      anon_sym_EQ_GT,
    STATE(7559), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324871] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11493), 1,
      anon_sym_SEMI,
    STATE(7560), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324916] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11495), 1,
      anon_sym_RPAREN,
    STATE(7561), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [324961] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11497), 1,
      aux_sym_preproc_if_token3,
    STATE(7562), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325006] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10805), 1,
      anon_sym_RBRACE,
    STATE(7563), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325051] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8643), 1,
      anon_sym_RPAREN,
    STATE(7564), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325096] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11499), 1,
      anon_sym_SEMI,
    STATE(7565), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325141] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11501), 1,
      anon_sym_RPAREN,
    STATE(7566), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325186] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11503), 1,
      anon_sym_DOT,
    STATE(7567), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325231] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(5640), 1,
      anon_sym_STAR,
    STATE(7568), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11505), 1,
      anon_sym_SEMI,
    STATE(7569), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325321] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11507), 1,
      anon_sym_EQ_GT,
    STATE(7570), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325366] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11509), 1,
      anon_sym_SEMI,
    STATE(7571), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325411] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11511), 1,
      anon_sym_SEMI,
    STATE(7572), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325456] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11513), 1,
      anon_sym_LPAREN,
    STATE(7573), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325501] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(10277), 1,
      aux_sym_preproc_if_token2,
    STATE(7574), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325546] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11515), 1,
      anon_sym_GT,
    STATE(7575), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325591] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11517), 1,
      anon_sym_STAR,
    STATE(7576), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325636] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11519), 1,
      anon_sym_EQ_GT,
    STATE(7577), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325681] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11521), 1,
      anon_sym_GT,
    STATE(7578), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325726] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11523), 1,
      anon_sym_SEMI,
    STATE(7579), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325771] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11525), 1,
      anon_sym_SEMI,
    STATE(7580), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325816] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11527), 1,
      sym_raw_string_end,
    STATE(7581), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325861] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11529), 1,
      anon_sym_GT,
    STATE(7582), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325906] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11531), 1,
      anon_sym_EQ,
    STATE(7583), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325951] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11533), 1,
      anon_sym_RPAREN,
    STATE(7584), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [325996] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11535), 1,
      anon_sym_LPAREN,
    STATE(7585), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326041] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11537), 1,
      anon_sym_LPAREN,
    STATE(7586), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326086] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11539), 1,
      anon_sym_LPAREN,
    STATE(7587), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11541), 1,
      anon_sym_LPAREN,
    STATE(7588), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326176] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7589), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326221] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11545), 1,
      anon_sym_LPAREN,
    STATE(7590), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326266] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11547), 1,
      anon_sym_LPAREN,
    STATE(7591), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326311] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11549), 1,
      aux_sym_preproc_if_token3,
    STATE(7592), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326356] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11551), 1,
      anon_sym_LPAREN,
    STATE(7593), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326401] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11553), 1,
      anon_sym_GT,
    STATE(7594), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326446] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11555), 1,
      anon_sym_STAR,
    STATE(7595), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326491] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11557), 1,
      aux_sym_preproc_if_token3,
    STATE(7596), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326536] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11559), 1,
      aux_sym_preproc_if_token3,
    STATE(7597), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326581] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11561), 1,
      aux_sym_preproc_if_token3,
    STATE(7598), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326626] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11563), 1,
      anon_sym_EQ_GT,
    STATE(7599), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326671] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11565), 1,
      anon_sym_EQ_GT,
    STATE(7600), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326716] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9755), 1,
      anon_sym_EQ,
    STATE(7601), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326761] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11567), 1,
      anon_sym_SEMI,
    STATE(7602), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326806] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11569), 1,
      anon_sym_LT,
    STATE(7603), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326851] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11571), 1,
      aux_sym_preproc_if_token3,
    STATE(7604), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326896] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11573), 1,
      anon_sym_EQ_GT,
    STATE(7605), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326941] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11575), 1,
      anon_sym_EQ,
    STATE(7606), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [326986] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11577), 1,
      anon_sym_GT,
    STATE(7607), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327031] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11579), 1,
      sym_integer_literal,
    STATE(7608), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327076] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8296), 1,
      anon_sym_RPAREN,
    STATE(7609), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327121] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11581), 1,
      anon_sym_RBRACK,
    STATE(7610), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327166] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11583), 1,
      anon_sym_SEMI,
    STATE(7611), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327211] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11081), 1,
      anon_sym_in,
    STATE(7612), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327256] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11585), 1,
      anon_sym_SEMI,
    STATE(7613), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327301] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7602), 1,
      anon_sym_RBRACE,
    STATE(7614), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327346] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11587), 1,
      anon_sym_EQ_GT,
    STATE(7615), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327391] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8458), 1,
      anon_sym_RPAREN,
    STATE(7616), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327436] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11589), 1,
      sym_interpolation_start_quote,
    STATE(7617), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327481] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_SEMI,
    STATE(7618), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327526] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    STATE(7619), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327571] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11595), 1,
      anon_sym_LPAREN,
    STATE(7620), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327616] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11597), 1,
      anon_sym_LPAREN,
    STATE(7621), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327661] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11599), 1,
      anon_sym_LPAREN,
    STATE(7622), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327706] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11601), 1,
      anon_sym_LPAREN,
    STATE(7623), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327751] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11603), 1,
      anon_sym_LPAREN,
    STATE(7624), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327796] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11605), 1,
      anon_sym_LPAREN,
    STATE(7625), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327841] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11607), 1,
      anon_sym_SEMI,
    STATE(7626), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327886] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11609), 1,
      anon_sym_LPAREN,
    STATE(7627), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327931] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11611), 1,
      anon_sym_SEMI,
    STATE(7628), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [327976] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11613), 1,
      anon_sym_EQ_GT,
    STATE(7629), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328021] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11615), 1,
      anon_sym_EQ_GT,
    STATE(7630), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328066] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11617), 1,
      sym_raw_string_end,
    STATE(7631), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328111] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11619), 1,
      anon_sym_GT,
    STATE(7632), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328156] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11621), 1,
      anon_sym_EQ_GT,
    STATE(7633), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11623), 1,
      anon_sym_SEMI,
    STATE(7634), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328246] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11625), 1,
      anon_sym_SEMI,
    STATE(7635), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328291] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11627), 1,
      anon_sym_LT,
    STATE(7636), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328336] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10332), 1,
      anon_sym_RBRACE,
    STATE(7637), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328381] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11629), 1,
      anon_sym_SEMI,
    STATE(7638), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328426] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11631), 1,
      sym_interpolation_start_quote,
    STATE(7639), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328471] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym_RBRACE,
    STATE(7640), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328516] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11633), 1,
      anon_sym_SEMI,
    STATE(7641), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328561] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11635), 1,
      aux_sym_preproc_if_token3,
    STATE(7642), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328606] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10293), 1,
      anon_sym_LPAREN,
    STATE(7643), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328651] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11637), 1,
      sym__optional_semi,
    STATE(7644), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328696] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    STATE(7645), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328741] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11639), 1,
      anon_sym_SEMI,
    STATE(7646), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328786] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11641), 1,
      anon_sym_EQ_GT,
    STATE(7647), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328831] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11643), 1,
      anon_sym_LPAREN,
    STATE(7648), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328876] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_LPAREN,
    STATE(7649), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328921] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11647), 1,
      anon_sym_LPAREN,
    STATE(7650), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [328966] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11649), 1,
      anon_sym_LPAREN,
    STATE(7651), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329011] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11651), 1,
      anon_sym_SEMI,
    STATE(7652), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329056] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11653), 1,
      anon_sym_LPAREN,
    STATE(7653), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329101] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11655), 1,
      aux_sym_preproc_if_token2,
    STATE(7654), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329146] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11657), 1,
      aux_sym_preproc_if_token3,
    STATE(7655), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329191] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11659), 1,
      aux_sym_preproc_if_token3,
    STATE(7656), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329236] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11661), 1,
      anon_sym_while,
    STATE(7657), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329281] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11663), 1,
      anon_sym_SEMI,
    STATE(7658), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329326] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11665), 1,
      anon_sym_SEMI,
    STATE(7659), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329371] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11667), 1,
      aux_sym_preproc_if_token3,
    STATE(7660), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329416] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11669), 1,
      anon_sym_LT,
    STATE(7661), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329461] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11671), 1,
      anon_sym_STAR,
    STATE(7662), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329506] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11673), 1,
      aux_sym_preproc_if_token3,
    STATE(7663), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329551] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11675), 1,
      anon_sym_SEMI,
    STATE(7664), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329596] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11677), 1,
      sym__optional_semi,
    STATE(7665), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329641] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11679), 1,
      aux_sym_preproc_if_token3,
    STATE(7666), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329686] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10466), 1,
      anon_sym_RBRACE,
    STATE(7667), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329731] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11681), 1,
      anon_sym_EQ_GT,
    STATE(7668), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329776] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11683), 1,
      aux_sym_preproc_if_token3,
    STATE(7669), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329821] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11685), 1,
      anon_sym_LPAREN,
    STATE(7670), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329866] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11687), 1,
      anon_sym_LPAREN,
    STATE(7671), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329911] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11689), 1,
      anon_sym_LPAREN,
    STATE(7672), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [329956] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11691), 1,
      sym__optional_semi,
    STATE(7673), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330001] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11693), 1,
      anon_sym_RPAREN,
    STATE(7674), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330046] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11695), 1,
      anon_sym_SEMI,
    STATE(7675), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330091] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11697), 1,
      anon_sym_LPAREN,
    STATE(7676), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330136] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11699), 1,
      anon_sym_DOT,
    STATE(7677), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330181] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_LT,
    STATE(7678), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330226] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11703), 1,
      sym__optional_semi,
    STATE(7679), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330271] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11705), 1,
      anon_sym_STAR,
    STATE(7680), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330316] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11707), 1,
      anon_sym_SQUOTE,
    STATE(7681), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330361] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11709), 1,
      anon_sym_EQ_GT,
    STATE(7682), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330406] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7689), 1,
      anon_sym_RBRACE,
    STATE(7683), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330451] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11711), 1,
      anon_sym_LPAREN,
    STATE(7684), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330496] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11713), 1,
      anon_sym_EQ_GT,
    STATE(7685), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330541] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11715), 1,
      anon_sym_RBRACE,
    STATE(7686), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330586] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11717), 1,
      anon_sym_RBRACK,
    STATE(7687), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330631] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11719), 1,
      anon_sym_RPAREN,
    STATE(7688), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330676] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11721), 1,
      anon_sym_SEMI,
    STATE(7689), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330721] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11723), 1,
      sym_interpolation_start_quote,
    STATE(7690), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330766] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11725), 1,
      anon_sym_LT,
    STATE(7691), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330811] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11727), 1,
      anon_sym_COLON,
    STATE(7692), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330856] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11729), 1,
      anon_sym_SQUOTE,
    STATE(7693), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330901] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11731), 1,
      anon_sym_LT,
    STATE(7694), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330946] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11733), 1,
      sym_integer_literal,
    STATE(7695), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [330991] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11735), 1,
      ts_builtin_sym_end,
    STATE(7696), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331036] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11737), 1,
      anon_sym_SQUOTE,
    STATE(7697), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331081] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11739), 1,
      anon_sym_SEMI,
    STATE(7698), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331126] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(4973), 1,
      aux_sym_preproc_if_token3,
    STATE(7699), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331171] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11741), 1,
      anon_sym_EQ_GT,
    STATE(7700), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331216] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11743), 1,
      anon_sym_SEMI,
    STATE(7701), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331261] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11745), 1,
      anon_sym_EQ_GT,
    STATE(7702), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331306] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11747), 1,
      anon_sym_LT,
    STATE(7703), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331351] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11749), 1,
      sym__optional_semi,
    STATE(7704), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331396] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(9709), 1,
      anon_sym_EQ,
    STATE(7705), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331441] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11751), 1,
      anon_sym_EQ_GT,
    STATE(7706), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331486] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11753), 1,
      sym__optional_semi,
    STATE(7707), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331531] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11755), 1,
      anon_sym_SEMI,
    STATE(7708), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331576] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11757), 1,
      anon_sym_SEMI,
    STATE(7709), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331621] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_EQ_GT,
    STATE(7710), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331666] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11759), 1,
      anon_sym_SQUOTE,
    STATE(7711), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331711] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11761), 1,
      anon_sym_RPAREN,
    STATE(7712), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331756] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11763), 1,
      anon_sym_SEMI,
    STATE(7713), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331801] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11765), 1,
      aux_sym_preproc_if_token3,
    STATE(7714), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331846] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11767), 1,
      anon_sym_GT,
    STATE(7715), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331891] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7249), 1,
      anon_sym_RBRACE,
    STATE(7716), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331936] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11769), 1,
      anon_sym_SEMI,
    STATE(7717), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [331981] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11771), 1,
      anon_sym_EQ_GT,
    STATE(7718), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332026] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11773), 1,
      anon_sym_SEMI,
    STATE(7719), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332071] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11775), 1,
      anon_sym_RBRACK,
    STATE(7720), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332116] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(7855), 1,
      anon_sym_RBRACE,
    STATE(7721), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332161] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11777), 1,
      anon_sym_DASH,
    STATE(7722), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332206] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11779), 1,
      anon_sym_SEMI,
    STATE(7723), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332251] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10499), 1,
      anon_sym_RBRACE,
    STATE(7724), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332296] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11781), 1,
      aux_sym_preproc_if_token3,
    STATE(7725), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332341] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11783), 1,
      anon_sym_EQ_GT,
    STATE(7726), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332386] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11785), 1,
      anon_sym_EQ_GT,
    STATE(7727), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332431] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11787), 1,
      anon_sym_STAR,
    STATE(7728), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332476] = 12,
    ACTIONS(5043), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    STATE(7729), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332521] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    STATE(7730), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332566] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11791), 1,
      anon_sym_SEMI,
    STATE(7731), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332611] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11793), 1,
      anon_sym_LPAREN,
    STATE(7732), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332656] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11795), 1,
      anon_sym_LPAREN,
    STATE(7733), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332701] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11797), 1,
      sym_interpolation_close_brace,
    STATE(7734), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332746] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11799), 1,
      anon_sym_LPAREN,
    STATE(7735), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332791] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11801), 1,
      anon_sym_SEMI,
    STATE(7736), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332836] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11803), 1,
      aux_sym_preproc_if_token3,
    STATE(7737), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332881] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11805), 1,
      anon_sym_LPAREN,
    STATE(7738), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332926] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11807), 1,
      anon_sym_EQ_GT,
    STATE(7739), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [332971] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11809), 1,
      sym_integer_literal,
    STATE(7740), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333016] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11811), 1,
      anon_sym_EQ_GT,
    STATE(7741), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333061] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11813), 1,
      aux_sym_preproc_if_token3,
    STATE(7742), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333106] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11815), 1,
      anon_sym_EQ,
    STATE(7743), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333151] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11817), 1,
      sym_raw_string_end,
    STATE(7744), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333196] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11819), 1,
      sym_preproc_arg,
    STATE(7745), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333241] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11821), 1,
      anon_sym_SEMI,
    STATE(7746), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333286] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11823), 1,
      anon_sym_EQ,
    STATE(7747), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11825), 1,
      anon_sym_EQ_GT,
    STATE(7748), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333376] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11827), 1,
      anon_sym_SQUOTE,
    STATE(7749), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333421] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11829), 1,
      anon_sym_LPAREN,
    STATE(7750), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333466] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11831), 1,
      sym__optional_semi,
    STATE(7751), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333511] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11833), 1,
      anon_sym_STAR,
    STATE(7752), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333556] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11835), 1,
      sym_interpolation_close_brace,
    STATE(7753), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333601] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11837), 1,
      sym__optional_semi,
    STATE(7754), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333646] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11839), 1,
      anon_sym_SEMI,
    STATE(7755), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333691] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11841), 1,
      anon_sym_LPAREN,
    STATE(7756), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333736] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11843), 1,
      anon_sym_EQ_GT,
    STATE(7757), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333781] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11845), 1,
      aux_sym_preproc_if_token3,
    STATE(7758), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333826] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym__optional_semi,
    STATE(7759), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333871] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11849), 1,
      anon_sym_SEMI,
    STATE(7760), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333916] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11851), 1,
      anon_sym_EQ_GT,
    STATE(7761), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [333961] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11853), 1,
      aux_sym_preproc_if_token3,
    STATE(7762), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334006] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11855), 1,
      anon_sym_LPAREN,
    STATE(7763), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334051] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11857), 1,
      anon_sym_LPAREN,
    STATE(7764), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334096] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    STATE(7765), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334141] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10993), 1,
      anon_sym_in,
    STATE(7766), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334186] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11861), 1,
      aux_sym_preproc_if_token3,
    STATE(7767), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334231] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11863), 1,
      anon_sym_STAR,
    STATE(7768), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11865), 1,
      anon_sym_EQ_GT,
    STATE(7769), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334321] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11867), 1,
      aux_sym_preproc_if_token3,
    STATE(7770), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334366] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11869), 1,
      anon_sym_SEMI,
    STATE(7771), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334411] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11871), 1,
      anon_sym_LPAREN,
    STATE(7772), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334456] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11873), 1,
      anon_sym_STAR,
    STATE(7773), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334501] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11875), 1,
      anon_sym_LPAREN,
    STATE(7774), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334546] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11877), 1,
      anon_sym_LPAREN,
    STATE(7775), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334591] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN,
    STATE(7776), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334636] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11881), 1,
      anon_sym_EQ_GT,
    STATE(7777), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334681] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11883), 1,
      anon_sym_LPAREN,
    STATE(7778), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334726] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11885), 1,
      anon_sym_LPAREN,
    STATE(7779), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334771] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11887), 1,
      anon_sym_STAR,
    STATE(7780), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334816] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11889), 1,
      anon_sym_EQ_GT,
    STATE(7781), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334861] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11891), 1,
      anon_sym_STAR,
    STATE(7782), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334906] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(10069), 1,
      anon_sym_STAR,
    STATE(7783), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334951] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11893), 1,
      sym_interpolation_start_quote,
    STATE(7784), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [334996] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11895), 1,
      anon_sym_LPAREN,
    STATE(7785), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335041] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11897), 1,
      anon_sym_while,
    STATE(7786), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335086] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11899), 1,
      anon_sym_EQ_GT,
    STATE(7787), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11901), 1,
      anon_sym_COLON,
    STATE(7788), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335176] = 12,
    ACTIONS(9163), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9165), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9167), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9169), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9171), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9173), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9175), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(9177), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9179), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9181), 1,
      sym_comment,
    ACTIONS(11903), 1,
      aux_sym_preproc_if_token2,
    STATE(7789), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335221] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11905), 1,
      anon_sym_LPAREN,
    STATE(7790), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335266] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_while,
    STATE(7791), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335311] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11909), 1,
      anon_sym_LPAREN,
    STATE(7792), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335356] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_while,
    STATE(7793), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335401] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11913), 1,
      anon_sym_LPAREN,
    STATE(7794), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335446] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11915), 1,
      anon_sym_LPAREN,
    STATE(7795), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335491] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11917), 1,
      anon_sym_LPAREN,
    STATE(7796), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335536] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SEMI,
    STATE(7797), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335581] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11921), 1,
      anon_sym_EQ_GT,
    STATE(7798), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335626] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_warning_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(19), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(21), 1,
      sym_comment,
    ACTIONS(11923), 1,
      anon_sym_SEMI,
    STATE(7799), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_warning,
      sym_preproc_define,
      sym_preproc_undef,
  [335671] = 1,
    ACTIONS(11925), 1,
      ts_builtin_sym_end,
  [335675] = 1,
    ACTIONS(11927), 1,
      ts_builtin_sym_end,
  [335679] = 1,
    ACTIONS(11929), 1,
      ts_builtin_sym_end,
  [335683] = 1,
    ACTIONS(11931), 1,
      ts_builtin_sym_end,
  [335687] = 1,
    ACTIONS(11933), 1,
      ts_builtin_sym_end,
  [335691] = 1,
    ACTIONS(11935), 1,
      ts_builtin_sym_end,
  [335695] = 1,
    ACTIONS(11937), 1,
      ts_builtin_sym_end,
  [335699] = 1,
    ACTIONS(11939), 1,
      ts_builtin_sym_end,
  [335703] = 1,
    ACTIONS(11941), 1,
      ts_builtin_sym_end,
  [335707] = 1,
    ACTIONS(11943), 1,
      ts_builtin_sym_end,
  [335711] = 1,
    ACTIONS(11945), 1,
      ts_builtin_sym_end,
  [335715] = 1,
    ACTIONS(11947), 1,
      ts_builtin_sym_end,
  [335719] = 1,
    ACTIONS(11949), 1,
      ts_builtin_sym_end,
  [335723] = 1,
    ACTIONS(11951), 1,
      ts_builtin_sym_end,
  [335727] = 1,
    ACTIONS(11953), 1,
      ts_builtin_sym_end,
  [335731] = 1,
    ACTIONS(11955), 1,
      ts_builtin_sym_end,
  [335735] = 1,
    ACTIONS(11957), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3941)] = 0,
  [SMALL_STATE(3942)] = 127,
  [SMALL_STATE(3943)] = 254,
  [SMALL_STATE(3944)] = 381,
  [SMALL_STATE(3945)] = 476,
  [SMALL_STATE(3946)] = 603,
  [SMALL_STATE(3947)] = 730,
  [SMALL_STATE(3948)] = 841,
  [SMALL_STATE(3949)] = 968,
  [SMALL_STATE(3950)] = 1095,
  [SMALL_STATE(3951)] = 1222,
  [SMALL_STATE(3952)] = 1349,
  [SMALL_STATE(3953)] = 1496,
  [SMALL_STATE(3954)] = 1643,
  [SMALL_STATE(3955)] = 1770,
  [SMALL_STATE(3956)] = 1917,
  [SMALL_STATE(3957)] = 2064,
  [SMALL_STATE(3958)] = 2191,
  [SMALL_STATE(3959)] = 2318,
  [SMALL_STATE(3960)] = 2453,
  [SMALL_STATE(3961)] = 2600,
  [SMALL_STATE(3962)] = 2727,
  [SMALL_STATE(3963)] = 2874,
  [SMALL_STATE(3964)] = 3021,
  [SMALL_STATE(3965)] = 3158,
  [SMALL_STATE(3966)] = 3285,
  [SMALL_STATE(3967)] = 3418,
  [SMALL_STATE(3968)] = 3549,
  [SMALL_STATE(3969)] = 3676,
  [SMALL_STATE(3970)] = 3815,
  [SMALL_STATE(3971)] = 3956,
  [SMALL_STATE(3972)] = 4083,
  [SMALL_STATE(3973)] = 4228,
  [SMALL_STATE(3974)] = 4355,
  [SMALL_STATE(3975)] = 4482,
  [SMALL_STATE(3976)] = 4609,
  [SMALL_STATE(3977)] = 4704,
  [SMALL_STATE(3978)] = 4831,
  [SMALL_STATE(3979)] = 4976,
  [SMALL_STATE(3980)] = 5121,
  [SMALL_STATE(3981)] = 5248,
  [SMALL_STATE(3982)] = 5375,
  [SMALL_STATE(3983)] = 5502,
  [SMALL_STATE(3984)] = 5629,
  [SMALL_STATE(3985)] = 5724,
  [SMALL_STATE(3986)] = 5851,
  [SMALL_STATE(3987)] = 5946,
  [SMALL_STATE(3988)] = 6073,
  [SMALL_STATE(3989)] = 6200,
  [SMALL_STATE(3990)] = 6327,
  [SMALL_STATE(3991)] = 6436,
  [SMALL_STATE(3992)] = 6581,
  [SMALL_STATE(3993)] = 6708,
  [SMALL_STATE(3994)] = 6835,
  [SMALL_STATE(3995)] = 6962,
  [SMALL_STATE(3996)] = 7089,
  [SMALL_STATE(3997)] = 7184,
  [SMALL_STATE(3998)] = 7311,
  [SMALL_STATE(3999)] = 7438,
  [SMALL_STATE(4000)] = 7565,
  [SMALL_STATE(4001)] = 7710,
  [SMALL_STATE(4002)] = 7837,
  [SMALL_STATE(4003)] = 7964,
  [SMALL_STATE(4004)] = 8091,
  [SMALL_STATE(4005)] = 8218,
  [SMALL_STATE(4006)] = 8313,
  [SMALL_STATE(4007)] = 8440,
  [SMALL_STATE(4008)] = 8567,
  [SMALL_STATE(4009)] = 8694,
  [SMALL_STATE(4010)] = 8821,
  [SMALL_STATE(4011)] = 8948,
  [SMALL_STATE(4012)] = 9075,
  [SMALL_STATE(4013)] = 9202,
  [SMALL_STATE(4014)] = 9329,
  [SMALL_STATE(4015)] = 9456,
  [SMALL_STATE(4016)] = 9583,
  [SMALL_STATE(4017)] = 9710,
  [SMALL_STATE(4018)] = 9837,
  [SMALL_STATE(4019)] = 9964,
  [SMALL_STATE(4020)] = 10091,
  [SMALL_STATE(4021)] = 10218,
  [SMALL_STATE(4022)] = 10345,
  [SMALL_STATE(4023)] = 10472,
  [SMALL_STATE(4024)] = 10599,
  [SMALL_STATE(4025)] = 10726,
  [SMALL_STATE(4026)] = 10873,
  [SMALL_STATE(4027)] = 11000,
  [SMALL_STATE(4028)] = 11127,
  [SMALL_STATE(4029)] = 11222,
  [SMALL_STATE(4030)] = 11349,
  [SMALL_STATE(4031)] = 11476,
  [SMALL_STATE(4032)] = 11603,
  [SMALL_STATE(4033)] = 11730,
  [SMALL_STATE(4034)] = 11857,
  [SMALL_STATE(4035)] = 11980,
  [SMALL_STATE(4036)] = 12107,
  [SMALL_STATE(4037)] = 12234,
  [SMALL_STATE(4038)] = 12351,
  [SMALL_STATE(4039)] = 12464,
  [SMALL_STATE(4040)] = 12599,
  [SMALL_STATE(4041)] = 12736,
  [SMALL_STATE(4042)] = 12869,
  [SMALL_STATE(4043)] = 12988,
  [SMALL_STATE(4044)] = 13119,
  [SMALL_STATE(4045)] = 13246,
  [SMALL_STATE(4046)] = 13385,
  [SMALL_STATE(4047)] = 13526,
  [SMALL_STATE(4048)] = 13671,
  [SMALL_STATE(4049)] = 13798,
  [SMALL_STATE(4050)] = 13907,
  [SMALL_STATE(4051)] = 14054,
  [SMALL_STATE(4052)] = 14181,
  [SMALL_STATE(4053)] = 14308,
  [SMALL_STATE(4054)] = 14435,
  [SMALL_STATE(4055)] = 14562,
  [SMALL_STATE(4056)] = 14689,
  [SMALL_STATE(4057)] = 14816,
  [SMALL_STATE(4058)] = 14943,
  [SMALL_STATE(4059)] = 15066,
  [SMALL_STATE(4060)] = 15183,
  [SMALL_STATE(4061)] = 15296,
  [SMALL_STATE(4062)] = 15415,
  [SMALL_STATE(4063)] = 15510,
  [SMALL_STATE(4064)] = 15605,
  [SMALL_STATE(4065)] = 15732,
  [SMALL_STATE(4066)] = 15859,
  [SMALL_STATE(4067)] = 15986,
  [SMALL_STATE(4068)] = 16113,
  [SMALL_STATE(4069)] = 16222,
  [SMALL_STATE(4070)] = 16315,
  [SMALL_STATE(4071)] = 16442,
  [SMALL_STATE(4072)] = 16569,
  [SMALL_STATE(4073)] = 16696,
  [SMALL_STATE(4074)] = 16823,
  [SMALL_STATE(4075)] = 16950,
  [SMALL_STATE(4076)] = 17077,
  [SMALL_STATE(4077)] = 17204,
  [SMALL_STATE(4078)] = 17331,
  [SMALL_STATE(4079)] = 17458,
  [SMALL_STATE(4080)] = 17585,
  [SMALL_STATE(4081)] = 17712,
  [SMALL_STATE(4082)] = 17839,
  [SMALL_STATE(4083)] = 17966,
  [SMALL_STATE(4084)] = 18093,
  [SMALL_STATE(4085)] = 18220,
  [SMALL_STATE(4086)] = 18313,
  [SMALL_STATE(4087)] = 18412,
  [SMALL_STATE(4088)] = 18507,
  [SMALL_STATE(4089)] = 18634,
  [SMALL_STATE(4090)] = 18761,
  [SMALL_STATE(4091)] = 18888,
  [SMALL_STATE(4092)] = 18981,
  [SMALL_STATE(4093)] = 19108,
  [SMALL_STATE(4094)] = 19203,
  [SMALL_STATE(4095)] = 19302,
  [SMALL_STATE(4096)] = 19429,
  [SMALL_STATE(4097)] = 19538,
  [SMALL_STATE(4098)] = 19665,
  [SMALL_STATE(4099)] = 19760,
  [SMALL_STATE(4100)] = 19887,
  [SMALL_STATE(4101)] = 20014,
  [SMALL_STATE(4102)] = 20159,
  [SMALL_STATE(4103)] = 20286,
  [SMALL_STATE(4104)] = 20413,
  [SMALL_STATE(4105)] = 20557,
  [SMALL_STATE(4106)] = 20697,
  [SMALL_STATE(4107)] = 20841,
  [SMALL_STATE(4108)] = 20939,
  [SMALL_STATE(4109)] = 21031,
  [SMALL_STATE(4110)] = 21147,
  [SMALL_STATE(4111)] = 21291,
  [SMALL_STATE(4112)] = 21435,
  [SMALL_STATE(4113)] = 21525,
  [SMALL_STATE(4114)] = 21637,
  [SMALL_STATE(4115)] = 21771,
  [SMALL_STATE(4116)] = 21907,
  [SMALL_STATE(4117)] = 22013,
  [SMALL_STATE(4118)] = 22121,
  [SMALL_STATE(4119)] = 22215,
  [SMALL_STATE(4120)] = 22323,
  [SMALL_STATE(4121)] = 22453,
  [SMALL_STATE(4122)] = 22597,
  [SMALL_STATE(4123)] = 22731,
  [SMALL_STATE(4124)] = 22821,
  [SMALL_STATE(4125)] = 22957,
  [SMALL_STATE(4126)] = 23089,
  [SMALL_STATE(4127)] = 23179,
  [SMALL_STATE(4128)] = 23269,
  [SMALL_STATE(4129)] = 23401,
  [SMALL_STATE(4130)] = 23511,
  [SMALL_STATE(4131)] = 23601,
  [SMALL_STATE(4132)] = 23719,
  [SMALL_STATE(4133)] = 23831,
  [SMALL_STATE(4134)] = 23961,
  [SMALL_STATE(4135)] = 24067,
  [SMALL_STATE(4136)] = 24157,
  [SMALL_STATE(4137)] = 24263,
  [SMALL_STATE(4138)] = 24409,
  [SMALL_STATE(4139)] = 24517,
  [SMALL_STATE(4140)] = 24609,
  [SMALL_STATE(4141)] = 24747,
  [SMALL_STATE(4142)] = 24855,
  [SMALL_STATE(4143)] = 24995,
  [SMALL_STATE(4144)] = 25141,
  [SMALL_STATE(4145)] = 25237,
  [SMALL_STATE(4146)] = 25381,
  [SMALL_STATE(4147)] = 25525,
  [SMALL_STATE(4148)] = 25619,
  [SMALL_STATE(4149)] = 25713,
  [SMALL_STATE(4150)] = 25805,
  [SMALL_STATE(4151)] = 25899,
  [SMALL_STATE(4152)] = 26045,
  [SMALL_STATE(4153)] = 26139,
  [SMALL_STATE(4154)] = 26283,
  [SMALL_STATE(4155)] = 26405,
  [SMALL_STATE(4156)] = 26499,
  [SMALL_STATE(4157)] = 26621,
  [SMALL_STATE(4158)] = 26737,
  [SMALL_STATE(4159)] = 26883,
  [SMALL_STATE(4160)] = 26995,
  [SMALL_STATE(4161)] = 27113,
  [SMALL_STATE(4162)] = 27205,
  [SMALL_STATE(4163)] = 27295,
  [SMALL_STATE(4164)] = 27441,
  [SMALL_STATE(4165)] = 27579,
  [SMALL_STATE(4166)] = 27725,
  [SMALL_STATE(4167)] = 27869,
  [SMALL_STATE(4168)] = 27962,
  [SMALL_STATE(4169)] = 28051,
  [SMALL_STATE(4170)] = 28194,
  [SMALL_STATE(4171)] = 28283,
  [SMALL_STATE(4172)] = 28372,
  [SMALL_STATE(4173)] = 28479,
  [SMALL_STATE(4174)] = 28622,
  [SMALL_STATE(4175)] = 28711,
  [SMALL_STATE(4176)] = 28802,
  [SMALL_STATE(4177)] = 28895,
  [SMALL_STATE(4178)] = 28986,
  [SMALL_STATE(4179)] = 29093,
  [SMALL_STATE(4180)] = 29182,
  [SMALL_STATE(4181)] = 29311,
  [SMALL_STATE(4182)] = 29404,
  [SMALL_STATE(4183)] = 29547,
  [SMALL_STATE(4184)] = 29684,
  [SMALL_STATE(4185)] = 29823,
  [SMALL_STATE(4186)] = 29966,
  [SMALL_STATE(4187)] = 30055,
  [SMALL_STATE(4188)] = 30198,
  [SMALL_STATE(4189)] = 30305,
  [SMALL_STATE(4190)] = 30394,
  [SMALL_STATE(4191)] = 30537,
  [SMALL_STATE(4192)] = 30626,
  [SMALL_STATE(4193)] = 30743,
  [SMALL_STATE(4194)] = 30832,
  [SMALL_STATE(4195)] = 30963,
  [SMALL_STATE(4196)] = 31084,
  [SMALL_STATE(4197)] = 31177,
  [SMALL_STATE(4198)] = 31270,
  [SMALL_STATE(4199)] = 31413,
  [SMALL_STATE(4200)] = 31528,
  [SMALL_STATE(4201)] = 31617,
  [SMALL_STATE(4202)] = 31706,
  [SMALL_STATE(4203)] = 31799,
  [SMALL_STATE(4204)] = 31888,
  [SMALL_STATE(4205)] = 31999,
  [SMALL_STATE(4206)] = 32088,
  [SMALL_STATE(4207)] = 32177,
  [SMALL_STATE(4208)] = 32270,
  [SMALL_STATE(4209)] = 32403,
  [SMALL_STATE(4210)] = 32492,
  [SMALL_STATE(4211)] = 32581,
  [SMALL_STATE(4212)] = 32674,
  [SMALL_STATE(4213)] = 32763,
  [SMALL_STATE(4214)] = 32852,
  [SMALL_STATE(4215)] = 32995,
  [SMALL_STATE(4216)] = 33084,
  [SMALL_STATE(4217)] = 33173,
  [SMALL_STATE(4218)] = 33262,
  [SMALL_STATE(4219)] = 33397,
  [SMALL_STATE(4220)] = 33486,
  [SMALL_STATE(4221)] = 33629,
  [SMALL_STATE(4222)] = 33745,
  [SMALL_STATE(4223)] = 33865,
  [SMALL_STATE(4224)] = 34007,
  [SMALL_STATE(4225)] = 34139,
  [SMALL_STATE(4226)] = 34281,
  [SMALL_STATE(4227)] = 34423,
  [SMALL_STATE(4228)] = 34529,
  [SMALL_STATE(4229)] = 34639,
  [SMALL_STATE(4230)] = 34781,
  [SMALL_STATE(4231)] = 34923,
  [SMALL_STATE(4232)] = 35065,
  [SMALL_STATE(4233)] = 35199,
  [SMALL_STATE(4234)] = 35329,
  [SMALL_STATE(4235)] = 35471,
  [SMALL_STATE(4236)] = 35577,
  [SMALL_STATE(4237)] = 35667,
  [SMALL_STATE(4238)] = 35809,
  [SMALL_STATE(4239)] = 35929,
  [SMALL_STATE(4240)] = 36071,
  [SMALL_STATE(4241)] = 36187,
  [SMALL_STATE(4242)] = 36301,
  [SMALL_STATE(4243)] = 36429,
  [SMALL_STATE(4244)] = 36571,
  [SMALL_STATE(4245)] = 36707,
  [SMALL_STATE(4246)] = 36839,
  [SMALL_STATE(4247)] = 36977,
  [SMALL_STATE(4248)] = 37111,
  [SMALL_STATE(4249)] = 37253,
  [SMALL_STATE(4250)] = 37349,
  [SMALL_STATE(4251)] = 37491,
  [SMALL_STATE(4252)] = 37579,
  [SMALL_STATE(4253)] = 37721,
  [SMALL_STATE(4254)] = 37827,
  [SMALL_STATE(4255)] = 37947,
  [SMALL_STATE(4256)] = 38089,
  [SMALL_STATE(4257)] = 38181,
  [SMALL_STATE(4258)] = 38311,
  [SMALL_STATE(4259)] = 38453,
  [SMALL_STATE(4260)] = 38545,
  [SMALL_STATE(4261)] = 38683,
  [SMALL_STATE(4262)] = 38799,
  [SMALL_STATE(4263)] = 38927,
  [SMALL_STATE(4264)] = 39063,
  [SMALL_STATE(4265)] = 39201,
  [SMALL_STATE(4266)] = 39343,
  [SMALL_STATE(4267)] = 39485,
  [SMALL_STATE(4268)] = 39577,
  [SMALL_STATE(4269)] = 39669,
  [SMALL_STATE(4270)] = 39811,
  [SMALL_STATE(4271)] = 39953,
  [SMALL_STATE(4272)] = 40067,
  [SMALL_STATE(4273)] = 40159,
  [SMALL_STATE(4274)] = 40301,
  [SMALL_STATE(4275)] = 40443,
  [SMALL_STATE(4276)] = 40557,
  [SMALL_STATE(4277)] = 40667,
  [SMALL_STATE(4278)] = 40809,
  [SMALL_STATE(4279)] = 40901,
  [SMALL_STATE(4280)] = 41011,
  [SMALL_STATE(4281)] = 41101,
  [SMALL_STATE(4282)] = 41243,
  [SMALL_STATE(4283)] = 41385,
  [SMALL_STATE(4284)] = 41477,
  [SMALL_STATE(4285)] = 41605,
  [SMALL_STATE(4286)] = 41747,
  [SMALL_STATE(4287)] = 41889,
  [SMALL_STATE(4288)] = 41995,
  [SMALL_STATE(4289)] = 42127,
  [SMALL_STATE(4290)] = 42233,
  [SMALL_STATE(4291)] = 42369,
  [SMALL_STATE(4292)] = 42475,
  [SMALL_STATE(4293)] = 42605,
  [SMALL_STATE(4294)] = 42699,
  [SMALL_STATE(4295)] = 42819,
  [SMALL_STATE(4296)] = 42953,
  [SMALL_STATE(4297)] = 43045,
  [SMALL_STATE(4298)] = 43137,
  [SMALL_STATE(4299)] = 43264,
  [SMALL_STATE(4300)] = 43405,
  [SMALL_STATE(4301)] = 43520,
  [SMALL_STATE(4302)] = 43639,
  [SMALL_STATE(4303)] = 43744,
  [SMALL_STATE(4304)] = 43859,
  [SMALL_STATE(4305)] = 44000,
  [SMALL_STATE(4306)] = 44119,
  [SMALL_STATE(4307)] = 44224,
  [SMALL_STATE(4308)] = 44351,
  [SMALL_STATE(4309)] = 44486,
  [SMALL_STATE(4310)] = 44627,
  [SMALL_STATE(4311)] = 44736,
  [SMALL_STATE(4312)] = 44877,
  [SMALL_STATE(4313)] = 44982,
  [SMALL_STATE(4314)] = 45119,
  [SMALL_STATE(4315)] = 45260,
  [SMALL_STATE(4316)] = 45389,
  [SMALL_STATE(4317)] = 45476,
  [SMALL_STATE(4318)] = 45617,
  [SMALL_STATE(4319)] = 45704,
  [SMALL_STATE(4320)] = 45809,
  [SMALL_STATE(4321)] = 45950,
  [SMALL_STATE(4322)] = 46081,
  [SMALL_STATE(4323)] = 46194,
  [SMALL_STATE(4324)] = 46287,
  [SMALL_STATE(4325)] = 46428,
  [SMALL_STATE(4326)] = 46559,
  [SMALL_STATE(4327)] = 46700,
  [SMALL_STATE(4328)] = 46833,
  [SMALL_STATE(4329)] = 46948,
  [SMALL_STATE(4330)] = 47053,
  [SMALL_STATE(4331)] = 47182,
  [SMALL_STATE(4332)] = 47323,
  [SMALL_STATE(4333)] = 47464,
  [SMALL_STATE(4334)] = 47579,
  [SMALL_STATE(4335)] = 47666,
  [SMALL_STATE(4336)] = 47793,
  [SMALL_STATE(4337)] = 47898,
  [SMALL_STATE(4338)] = 47985,
  [SMALL_STATE(4339)] = 48098,
  [SMALL_STATE(4340)] = 48231,
  [SMALL_STATE(4341)] = 48350,
  [SMALL_STATE(4342)] = 48463,
  [SMALL_STATE(4343)] = 48604,
  [SMALL_STATE(4344)] = 48719,
  [SMALL_STATE(4345)] = 48828,
  [SMALL_STATE(4346)] = 48957,
  [SMALL_STATE(4347)] = 49072,
  [SMALL_STATE(4348)] = 49177,
  [SMALL_STATE(4349)] = 49264,
  [SMALL_STATE(4350)] = 49399,
  [SMALL_STATE(4351)] = 49508,
  [SMALL_STATE(4352)] = 49649,
  [SMALL_STATE(4353)] = 49786,
  [SMALL_STATE(4354)] = 49877,
  [SMALL_STATE(4355)] = 50018,
  [SMALL_STATE(4356)] = 50109,
  [SMALL_STATE(4357)] = 50240,
  [SMALL_STATE(4358)] = 50381,
  [SMALL_STATE(4359)] = 50496,
  [SMALL_STATE(4360)] = 50629,
  [SMALL_STATE(4361)] = 50722,
  [SMALL_STATE(4362)] = 50863,
  [SMALL_STATE(4363)] = 50966,
  [SMALL_STATE(4364)] = 51069,
  [SMALL_STATE(4365)] = 51160,
  [SMALL_STATE(4366)] = 51251,
  [SMALL_STATE(4367)] = 51342,
  [SMALL_STATE(4368)] = 51431,
  [SMALL_STATE(4369)] = 51522,
  [SMALL_STATE(4370)] = 51663,
  [SMALL_STATE(4371)] = 51766,
  [SMALL_STATE(4372)] = 51881,
  [SMALL_STATE(4373)] = 52022,
  [SMALL_STATE(4374)] = 52127,
  [SMALL_STATE(4375)] = 52216,
  [SMALL_STATE(4376)] = 52351,
  [SMALL_STATE(4377)] = 52488,
  [SMALL_STATE(4378)] = 52583,
  [SMALL_STATE(4379)] = 52678,
  [SMALL_STATE(4380)] = 52819,
  [SMALL_STATE(4381)] = 52934,
  [SMALL_STATE(4382)] = 53075,
  [SMALL_STATE(4383)] = 53166,
  [SMALL_STATE(4384)] = 53307,
  [SMALL_STATE(4385)] = 53448,
  [SMALL_STATE(4386)] = 53535,
  [SMALL_STATE(4387)] = 53676,
  [SMALL_STATE(4388)] = 53763,
  [SMALL_STATE(4389)] = 53850,
  [SMALL_STATE(4390)] = 53941,
  [SMALL_STATE(4391)] = 54067,
  [SMALL_STATE(4392)] = 54207,
  [SMALL_STATE(4393)] = 54347,
  [SMALL_STATE(4394)] = 54487,
  [SMALL_STATE(4395)] = 54627,
  [SMALL_STATE(4396)] = 54713,
  [SMALL_STATE(4397)] = 54841,
  [SMALL_STATE(4398)] = 54975,
  [SMALL_STATE(4399)] = 55061,
  [SMALL_STATE(4400)] = 55149,
  [SMALL_STATE(4401)] = 55283,
  [SMALL_STATE(4402)] = 55369,
  [SMALL_STATE(4403)] = 55459,
  [SMALL_STATE(4404)] = 55547,
  [SMALL_STATE(4405)] = 55633,
  [SMALL_STATE(4406)] = 55719,
  [SMALL_STATE(4407)] = 55809,
  [SMALL_STATE(4408)] = 55895,
  [SMALL_STATE(4409)] = 56035,
  [SMALL_STATE(4410)] = 56121,
  [SMALL_STATE(4411)] = 56261,
  [SMALL_STATE(4412)] = 56401,
  [SMALL_STATE(4413)] = 56541,
  [SMALL_STATE(4414)] = 56681,
  [SMALL_STATE(4415)] = 56775,
  [SMALL_STATE(4416)] = 56865,
  [SMALL_STATE(4417)] = 56969,
  [SMALL_STATE(4418)] = 57055,
  [SMALL_STATE(4419)] = 57195,
  [SMALL_STATE(4420)] = 57281,
  [SMALL_STATE(4421)] = 57421,
  [SMALL_STATE(4422)] = 57561,
  [SMALL_STATE(4423)] = 57663,
  [SMALL_STATE(4424)] = 57793,
  [SMALL_STATE(4425)] = 57925,
  [SMALL_STATE(4426)] = 58053,
  [SMALL_STATE(4427)] = 58179,
  [SMALL_STATE(4428)] = 58319,
  [SMALL_STATE(4429)] = 58453,
  [SMALL_STATE(4430)] = 58589,
  [SMALL_STATE(4431)] = 58725,
  [SMALL_STATE(4432)] = 58865,
  [SMALL_STATE(4433)] = 59005,
  [SMALL_STATE(4434)] = 59145,
  [SMALL_STATE(4435)] = 59285,
  [SMALL_STATE(4436)] = 59377,
  [SMALL_STATE(4437)] = 59517,
  [SMALL_STATE(4438)] = 59605,
  [SMALL_STATE(4439)] = 59693,
  [SMALL_STATE(4440)] = 59787,
  [SMALL_STATE(4441)] = 59927,
  [SMALL_STATE(4442)] = 60013,
  [SMALL_STATE(4443)] = 60099,
  [SMALL_STATE(4444)] = 60239,
  [SMALL_STATE(4445)] = 60379,
  [SMALL_STATE(4446)] = 60467,
  [SMALL_STATE(4447)] = 60575,
  [SMALL_STATE(4448)] = 60661,
  [SMALL_STATE(4449)] = 60747,
  [SMALL_STATE(4450)] = 60861,
  [SMALL_STATE(4451)] = 60947,
  [SMALL_STATE(4452)] = 61087,
  [SMALL_STATE(4453)] = 61227,
  [SMALL_STATE(4454)] = 61373,
  [SMALL_STATE(4455)] = 61519,
  [SMALL_STATE(4456)] = 61659,
  [SMALL_STATE(4457)] = 61763,
  [SMALL_STATE(4458)] = 61909,
  [SMALL_STATE(4459)] = 62027,
  [SMALL_STATE(4460)] = 62113,
  [SMALL_STATE(4461)] = 62253,
  [SMALL_STATE(4462)] = 62341,
  [SMALL_STATE(4463)] = 62481,
  [SMALL_STATE(4464)] = 62585,
  [SMALL_STATE(4465)] = 62725,
  [SMALL_STATE(4466)] = 62811,
  [SMALL_STATE(4467)] = 62897,
  [SMALL_STATE(4468)] = 63015,
  [SMALL_STATE(4469)] = 63127,
  [SMALL_STATE(4470)] = 63235,
  [SMALL_STATE(4471)] = 63337,
  [SMALL_STATE(4472)] = 63467,
  [SMALL_STATE(4473)] = 63569,
  [SMALL_STATE(4474)] = 63695,
  [SMALL_STATE(4475)] = 63835,
  [SMALL_STATE(4476)] = 63971,
  [SMALL_STATE(4477)] = 64111,
  [SMALL_STATE(4478)] = 64257,
  [SMALL_STATE(4479)] = 64343,
  [SMALL_STATE(4480)] = 64461,
  [SMALL_STATE(4481)] = 64573,
  [SMALL_STATE(4482)] = 64685,
  [SMALL_STATE(4483)] = 64799,
  [SMALL_STATE(4484)] = 64885,
  [SMALL_STATE(4485)] = 64975,
  [SMALL_STATE(4486)] = 65079,
  [SMALL_STATE(4487)] = 65219,
  [SMALL_STATE(4488)] = 65321,
  [SMALL_STATE(4489)] = 65469,
  [SMALL_STATE(4490)] = 65609,
  [SMALL_STATE(4491)] = 65755,
  [SMALL_STATE(4492)] = 65869,
  [SMALL_STATE(4493)] = 65973,
  [SMALL_STATE(4494)] = 66085,
  [SMALL_STATE(4495)] = 66193,
  [SMALL_STATE(4496)] = 66297,
  [SMALL_STATE(4497)] = 66401,
  [SMALL_STATE(4498)] = 66495,
  [SMALL_STATE(4499)] = 66581,
  [SMALL_STATE(4500)] = 66689,
  [SMALL_STATE(4501)] = 66819,
  [SMALL_STATE(4502)] = 66951,
  [SMALL_STATE(4503)] = 67081,
  [SMALL_STATE(4504)] = 67167,
  [SMALL_STATE(4505)] = 67271,
  [SMALL_STATE(4506)] = 67361,
  [SMALL_STATE(4507)] = 67447,
  [SMALL_STATE(4508)] = 67581,
  [SMALL_STATE(4509)] = 67667,
  [SMALL_STATE(4510)] = 67781,
  [SMALL_STATE(4511)] = 67913,
  [SMALL_STATE(4512)] = 68049,
  [SMALL_STATE(4513)] = 68195,
  [SMALL_STATE(4514)] = 68327,
  [SMALL_STATE(4515)] = 68467,
  [SMALL_STATE(4516)] = 68553,
  [SMALL_STATE(4517)] = 68681,
  [SMALL_STATE(4518)] = 68783,
  [SMALL_STATE(4519)] = 68911,
  [SMALL_STATE(4520)] = 69001,
  [SMALL_STATE(4521)] = 69093,
  [SMALL_STATE(4522)] = 69183,
  [SMALL_STATE(4523)] = 69273,
  [SMALL_STATE(4524)] = 69363,
  [SMALL_STATE(4525)] = 69453,
  [SMALL_STATE(4526)] = 69541,
  [SMALL_STATE(4527)] = 69631,
  [SMALL_STATE(4528)] = 69719,
  [SMALL_STATE(4529)] = 69845,
  [SMALL_STATE(4530)] = 69963,
  [SMALL_STATE(4531)] = 70053,
  [SMALL_STATE(4532)] = 70193,
  [SMALL_STATE(4533)] = 70305,
  [SMALL_STATE(4534)] = 70409,
  [SMALL_STATE(4535)] = 70523,
  [SMALL_STATE(4536)] = 70637,
  [SMALL_STATE(4537)] = 70725,
  [SMALL_STATE(4538)] = 70811,
  [SMALL_STATE(4539)] = 70897,
  [SMALL_STATE(4540)] = 71001,
  [SMALL_STATE(4541)] = 71093,
  [SMALL_STATE(4542)] = 71239,
  [SMALL_STATE(4543)] = 71327,
  [SMALL_STATE(4544)] = 71434,
  [SMALL_STATE(4545)] = 71573,
  [SMALL_STATE(4546)] = 71702,
  [SMALL_STATE(4547)] = 71833,
  [SMALL_STATE(4548)] = 71960,
  [SMALL_STATE(4549)] = 72085,
  [SMALL_STATE(4550)] = 72188,
  [SMALL_STATE(4551)] = 72321,
  [SMALL_STATE(4552)] = 72456,
  [SMALL_STATE(4553)] = 72595,
  [SMALL_STATE(4554)] = 72734,
  [SMALL_STATE(4555)] = 72873,
  [SMALL_STATE(4556)] = 73012,
  [SMALL_STATE(4557)] = 73151,
  [SMALL_STATE(4558)] = 73280,
  [SMALL_STATE(4559)] = 73411,
  [SMALL_STATE(4560)] = 73538,
  [SMALL_STATE(4561)] = 73663,
  [SMALL_STATE(4562)] = 73796,
  [SMALL_STATE(4563)] = 73931,
  [SMALL_STATE(4564)] = 74070,
  [SMALL_STATE(4565)] = 74211,
  [SMALL_STATE(4566)] = 74300,
  [SMALL_STATE(4567)] = 74387,
  [SMALL_STATE(4568)] = 74474,
  [SMALL_STATE(4569)] = 74613,
  [SMALL_STATE(4570)] = 74726,
  [SMALL_STATE(4571)] = 74843,
  [SMALL_STATE(4572)] = 74954,
  [SMALL_STATE(4573)] = 75067,
  [SMALL_STATE(4574)] = 75152,
  [SMALL_STATE(4575)] = 75269,
  [SMALL_STATE(4576)] = 75380,
  [SMALL_STATE(4577)] = 75509,
  [SMALL_STATE(4578)] = 75640,
  [SMALL_STATE(4579)] = 75767,
  [SMALL_STATE(4580)] = 75880,
  [SMALL_STATE(4581)] = 76005,
  [SMALL_STATE(4582)] = 76138,
  [SMALL_STATE(4583)] = 76273,
  [SMALL_STATE(4584)] = 76412,
  [SMALL_STATE(4585)] = 76551,
  [SMALL_STATE(4586)] = 76654,
  [SMALL_STATE(4587)] = 76793,
  [SMALL_STATE(4588)] = 76932,
  [SMALL_STATE(4589)] = 77071,
  [SMALL_STATE(4590)] = 77210,
  [SMALL_STATE(4591)] = 77313,
  [SMALL_STATE(4592)] = 77398,
  [SMALL_STATE(4593)] = 77483,
  [SMALL_STATE(4594)] = 77576,
  [SMALL_STATE(4595)] = 77661,
  [SMALL_STATE(4596)] = 77752,
  [SMALL_STATE(4597)] = 77837,
  [SMALL_STATE(4598)] = 77948,
  [SMALL_STATE(4599)] = 78033,
  [SMALL_STATE(4600)] = 78122,
  [SMALL_STATE(4601)] = 78239,
  [SMALL_STATE(4602)] = 78350,
  [SMALL_STATE(4603)] = 78463,
  [SMALL_STATE(4604)] = 78566,
  [SMALL_STATE(4605)] = 78655,
  [SMALL_STATE(4606)] = 78800,
  [SMALL_STATE(4607)] = 78889,
  [SMALL_STATE(4608)] = 78974,
  [SMALL_STATE(4609)] = 79091,
  [SMALL_STATE(4610)] = 79202,
  [SMALL_STATE(4611)] = 79309,
  [SMALL_STATE(4612)] = 79438,
  [SMALL_STATE(4613)] = 79569,
  [SMALL_STATE(4614)] = 79696,
  [SMALL_STATE(4615)] = 79809,
  [SMALL_STATE(4616)] = 79934,
  [SMALL_STATE(4617)] = 80037,
  [SMALL_STATE(4618)] = 80170,
  [SMALL_STATE(4619)] = 80305,
  [SMALL_STATE(4620)] = 80444,
  [SMALL_STATE(4621)] = 80583,
  [SMALL_STATE(4622)] = 80722,
  [SMALL_STATE(4623)] = 80807,
  [SMALL_STATE(4624)] = 80946,
  [SMALL_STATE(4625)] = 81063,
  [SMALL_STATE(4626)] = 81174,
  [SMALL_STATE(4627)] = 81287,
  [SMALL_STATE(4628)] = 81390,
  [SMALL_STATE(4629)] = 81475,
  [SMALL_STATE(4630)] = 81560,
  [SMALL_STATE(4631)] = 81647,
  [SMALL_STATE(4632)] = 81732,
  [SMALL_STATE(4633)] = 81817,
  [SMALL_STATE(4634)] = 81902,
  [SMALL_STATE(4635)] = 82019,
  [SMALL_STATE(4636)] = 82130,
  [SMALL_STATE(4637)] = 82243,
  [SMALL_STATE(4638)] = 82346,
  [SMALL_STATE(4639)] = 82431,
  [SMALL_STATE(4640)] = 82516,
  [SMALL_STATE(4641)] = 82601,
  [SMALL_STATE(4642)] = 82686,
  [SMALL_STATE(4643)] = 82771,
  [SMALL_STATE(4644)] = 82856,
  [SMALL_STATE(4645)] = 82941,
  [SMALL_STATE(4646)] = 83026,
  [SMALL_STATE(4647)] = 83111,
  [SMALL_STATE(4648)] = 83196,
  [SMALL_STATE(4649)] = 83281,
  [SMALL_STATE(4650)] = 83366,
  [SMALL_STATE(4651)] = 83451,
  [SMALL_STATE(4652)] = 83536,
  [SMALL_STATE(4653)] = 83621,
  [SMALL_STATE(4654)] = 83706,
  [SMALL_STATE(4655)] = 83791,
  [SMALL_STATE(4656)] = 83876,
  [SMALL_STATE(4657)] = 83961,
  [SMALL_STATE(4658)] = 84046,
  [SMALL_STATE(4659)] = 84185,
  [SMALL_STATE(4660)] = 84270,
  [SMALL_STATE(4661)] = 84355,
  [SMALL_STATE(4662)] = 84440,
  [SMALL_STATE(4663)] = 84525,
  [SMALL_STATE(4664)] = 84610,
  [SMALL_STATE(4665)] = 84723,
  [SMALL_STATE(4666)] = 84808,
  [SMALL_STATE(4667)] = 84893,
  [SMALL_STATE(4668)] = 84978,
  [SMALL_STATE(4669)] = 85063,
  [SMALL_STATE(4670)] = 85148,
  [SMALL_STATE(4671)] = 85233,
  [SMALL_STATE(4672)] = 85318,
  [SMALL_STATE(4673)] = 85403,
  [SMALL_STATE(4674)] = 85488,
  [SMALL_STATE(4675)] = 85573,
  [SMALL_STATE(4676)] = 85658,
  [SMALL_STATE(4677)] = 85797,
  [SMALL_STATE(4678)] = 85900,
  [SMALL_STATE(4679)] = 86039,
  [SMALL_STATE(4680)] = 86124,
  [SMALL_STATE(4681)] = 86209,
  [SMALL_STATE(4682)] = 86326,
  [SMALL_STATE(4683)] = 86465,
  [SMALL_STATE(4684)] = 86554,
  [SMALL_STATE(4685)] = 86643,
  [SMALL_STATE(4686)] = 86754,
  [SMALL_STATE(4687)] = 86861,
  [SMALL_STATE(4688)] = 86990,
  [SMALL_STATE(4689)] = 87121,
  [SMALL_STATE(4690)] = 87248,
  [SMALL_STATE(4691)] = 87361,
  [SMALL_STATE(4692)] = 87486,
  [SMALL_STATE(4693)] = 87573,
  [SMALL_STATE(4694)] = 87662,
  [SMALL_STATE(4695)] = 87765,
  [SMALL_STATE(4696)] = 87898,
  [SMALL_STATE(4697)] = 88033,
  [SMALL_STATE(4698)] = 88172,
  [SMALL_STATE(4699)] = 88311,
  [SMALL_STATE(4700)] = 88450,
  [SMALL_STATE(4701)] = 88553,
  [SMALL_STATE(4702)] = 88638,
  [SMALL_STATE(4703)] = 88723,
  [SMALL_STATE(4704)] = 88808,
  [SMALL_STATE(4705)] = 88893,
  [SMALL_STATE(4706)] = 88982,
  [SMALL_STATE(4707)] = 89071,
  [SMALL_STATE(4708)] = 89156,
  [SMALL_STATE(4709)] = 89295,
  [SMALL_STATE(4710)] = 89434,
  [SMALL_STATE(4711)] = 89519,
  [SMALL_STATE(4712)] = 89604,
  [SMALL_STATE(4713)] = 89689,
  [SMALL_STATE(4714)] = 89774,
  [SMALL_STATE(4715)] = 89913,
  [SMALL_STATE(4716)] = 89998,
  [SMALL_STATE(4717)] = 90083,
  [SMALL_STATE(4718)] = 90170,
  [SMALL_STATE(4719)] = 90255,
  [SMALL_STATE(4720)] = 90340,
  [SMALL_STATE(4721)] = 90425,
  [SMALL_STATE(4722)] = 90510,
  [SMALL_STATE(4723)] = 90595,
  [SMALL_STATE(4724)] = 90680,
  [SMALL_STATE(4725)] = 90765,
  [SMALL_STATE(4726)] = 90850,
  [SMALL_STATE(4727)] = 90957,
  [SMALL_STATE(4728)] = 91096,
  [SMALL_STATE(4729)] = 91235,
  [SMALL_STATE(4730)] = 91374,
  [SMALL_STATE(4731)] = 91513,
  [SMALL_STATE(4732)] = 91652,
  [SMALL_STATE(4733)] = 91791,
  [SMALL_STATE(4734)] = 91930,
  [SMALL_STATE(4735)] = 92017,
  [SMALL_STATE(4736)] = 92102,
  [SMALL_STATE(4737)] = 92205,
  [SMALL_STATE(4738)] = 92344,
  [SMALL_STATE(4739)] = 92447,
  [SMALL_STATE(4740)] = 92586,
  [SMALL_STATE(4741)] = 92725,
  [SMALL_STATE(4742)] = 92864,
  [SMALL_STATE(4743)] = 93003,
  [SMALL_STATE(4744)] = 93142,
  [SMALL_STATE(4745)] = 93281,
  [SMALL_STATE(4746)] = 93420,
  [SMALL_STATE(4747)] = 93523,
  [SMALL_STATE(4748)] = 93662,
  [SMALL_STATE(4749)] = 93791,
  [SMALL_STATE(4750)] = 93922,
  [SMALL_STATE(4751)] = 94049,
  [SMALL_STATE(4752)] = 94174,
  [SMALL_STATE(4753)] = 94307,
  [SMALL_STATE(4754)] = 94442,
  [SMALL_STATE(4755)] = 94581,
  [SMALL_STATE(4756)] = 94720,
  [SMALL_STATE(4757)] = 94859,
  [SMALL_STATE(4758)] = 94998,
  [SMALL_STATE(4759)] = 95137,
  [SMALL_STATE(4760)] = 95254,
  [SMALL_STATE(4761)] = 95365,
  [SMALL_STATE(4762)] = 95472,
  [SMALL_STATE(4763)] = 95585,
  [SMALL_STATE(4764)] = 95670,
  [SMALL_STATE(4765)] = 95755,
  [SMALL_STATE(4766)] = 95894,
  [SMALL_STATE(4767)] = 95979,
  [SMALL_STATE(4768)] = 96118,
  [SMALL_STATE(4769)] = 96257,
  [SMALL_STATE(4770)] = 96396,
  [SMALL_STATE(4771)] = 96503,
  [SMALL_STATE(4772)] = 96642,
  [SMALL_STATE(4773)] = 96771,
  [SMALL_STATE(4774)] = 96902,
  [SMALL_STATE(4775)] = 97029,
  [SMALL_STATE(4776)] = 97154,
  [SMALL_STATE(4777)] = 97287,
  [SMALL_STATE(4778)] = 97422,
  [SMALL_STATE(4779)] = 97561,
  [SMALL_STATE(4780)] = 97700,
  [SMALL_STATE(4781)] = 97839,
  [SMALL_STATE(4782)] = 97978,
  [SMALL_STATE(4783)] = 98117,
  [SMALL_STATE(4784)] = 98256,
  [SMALL_STATE(4785)] = 98395,
  [SMALL_STATE(4786)] = 98524,
  [SMALL_STATE(4787)] = 98655,
  [SMALL_STATE(4788)] = 98782,
  [SMALL_STATE(4789)] = 98889,
  [SMALL_STATE(4790)] = 99014,
  [SMALL_STATE(4791)] = 99153,
  [SMALL_STATE(4792)] = 99292,
  [SMALL_STATE(4793)] = 99431,
  [SMALL_STATE(4794)] = 99564,
  [SMALL_STATE(4795)] = 99667,
  [SMALL_STATE(4796)] = 99802,
  [SMALL_STATE(4797)] = 99905,
  [SMALL_STATE(4798)] = 100012,
  [SMALL_STATE(4799)] = 100151,
  [SMALL_STATE(4800)] = 100290,
  [SMALL_STATE(4801)] = 100429,
  [SMALL_STATE(4802)] = 100568,
  [SMALL_STATE(4803)] = 100655,
  [SMALL_STATE(4804)] = 100744,
  [SMALL_STATE(4805)] = 100833,
  [SMALL_STATE(4806)] = 100972,
  [SMALL_STATE(4807)] = 101111,
  [SMALL_STATE(4808)] = 101214,
  [SMALL_STATE(4809)] = 101321,
  [SMALL_STATE(4810)] = 101460,
  [SMALL_STATE(4811)] = 101563,
  [SMALL_STATE(4812)] = 101666,
  [SMALL_STATE(4813)] = 101769,
  [SMALL_STATE(4814)] = 101854,
  [SMALL_STATE(4815)] = 101939,
  [SMALL_STATE(4816)] = 102024,
  [SMALL_STATE(4817)] = 102109,
  [SMALL_STATE(4818)] = 102194,
  [SMALL_STATE(4819)] = 102279,
  [SMALL_STATE(4820)] = 102364,
  [SMALL_STATE(4821)] = 102453,
  [SMALL_STATE(4822)] = 102542,
  [SMALL_STATE(4823)] = 102631,
  [SMALL_STATE(4824)] = 102720,
  [SMALL_STATE(4825)] = 102807,
  [SMALL_STATE(4826)] = 102896,
  [SMALL_STATE(4827)] = 103013,
  [SMALL_STATE(4828)] = 103124,
  [SMALL_STATE(4829)] = 103231,
  [SMALL_STATE(4830)] = 103360,
  [SMALL_STATE(4831)] = 103491,
  [SMALL_STATE(4832)] = 103618,
  [SMALL_STATE(4833)] = 103731,
  [SMALL_STATE(4834)] = 103856,
  [SMALL_STATE(4835)] = 103959,
  [SMALL_STATE(4836)] = 104092,
  [SMALL_STATE(4837)] = 104227,
  [SMALL_STATE(4838)] = 104366,
  [SMALL_STATE(4839)] = 104507,
  [SMALL_STATE(4840)] = 104624,
  [SMALL_STATE(4841)] = 104735,
  [SMALL_STATE(4842)] = 104842,
  [SMALL_STATE(4843)] = 104971,
  [SMALL_STATE(4844)] = 105102,
  [SMALL_STATE(4845)] = 105229,
  [SMALL_STATE(4846)] = 105342,
  [SMALL_STATE(4847)] = 105467,
  [SMALL_STATE(4848)] = 105570,
  [SMALL_STATE(4849)] = 105703,
  [SMALL_STATE(4850)] = 105838,
  [SMALL_STATE(4851)] = 105977,
  [SMALL_STATE(4852)] = 106118,
  [SMALL_STATE(4853)] = 106259,
  [SMALL_STATE(4854)] = 106400,
  [SMALL_STATE(4855)] = 106541,
  [SMALL_STATE(4856)] = 106680,
  [SMALL_STATE(4857)] = 106765,
  [SMALL_STATE(4858)] = 106850,
  [SMALL_STATE(4859)] = 106935,
  [SMALL_STATE(4860)] = 107074,
  [SMALL_STATE(4861)] = 107159,
  [SMALL_STATE(4862)] = 107244,
  [SMALL_STATE(4863)] = 107329,
  [SMALL_STATE(4864)] = 107418,
  [SMALL_STATE(4865)] = 107507,
  [SMALL_STATE(4866)] = 107596,
  [SMALL_STATE(4867)] = 107683,
  [SMALL_STATE(4868)] = 107772,
  [SMALL_STATE(4869)] = 107857,
  [SMALL_STATE(4870)] = 107942,
  [SMALL_STATE(4871)] = 108027,
  [SMALL_STATE(4872)] = 108112,
  [SMALL_STATE(4873)] = 108229,
  [SMALL_STATE(4874)] = 108340,
  [SMALL_STATE(4875)] = 108469,
  [SMALL_STATE(4876)] = 108600,
  [SMALL_STATE(4877)] = 108727,
  [SMALL_STATE(4878)] = 108840,
  [SMALL_STATE(4879)] = 108965,
  [SMALL_STATE(4880)] = 109098,
  [SMALL_STATE(4881)] = 109233,
  [SMALL_STATE(4882)] = 109372,
  [SMALL_STATE(4883)] = 109457,
  [SMALL_STATE(4884)] = 109542,
  [SMALL_STATE(4885)] = 109683,
  [SMALL_STATE(4886)] = 109824,
  [SMALL_STATE(4887)] = 109965,
  [SMALL_STATE(4888)] = 110068,
  [SMALL_STATE(4889)] = 110207,
  [SMALL_STATE(4890)] = 110319,
  [SMALL_STATE(4891)] = 110457,
  [SMALL_STATE(4892)] = 110599,
  [SMALL_STATE(4893)] = 110737,
  [SMALL_STATE(4894)] = 110853,
  [SMALL_STATE(4895)] = 110963,
  [SMALL_STATE(4896)] = 111069,
  [SMALL_STATE(4897)] = 111197,
  [SMALL_STATE(4898)] = 111327,
  [SMALL_STATE(4899)] = 111453,
  [SMALL_STATE(4900)] = 111565,
  [SMALL_STATE(4901)] = 111689,
  [SMALL_STATE(4902)] = 111831,
  [SMALL_STATE(4903)] = 111943,
  [SMALL_STATE(4904)] = 112075,
  [SMALL_STATE(4905)] = 112177,
  [SMALL_STATE(4906)] = 112293,
  [SMALL_STATE(4907)] = 112403,
  [SMALL_STATE(4908)] = 112531,
  [SMALL_STATE(4909)] = 112661,
  [SMALL_STATE(4910)] = 112787,
  [SMALL_STATE(4911)] = 112899,
  [SMALL_STATE(4912)] = 113023,
  [SMALL_STATE(4913)] = 113155,
  [SMALL_STATE(4914)] = 113289,
  [SMALL_STATE(4915)] = 113427,
  [SMALL_STATE(4916)] = 113561,
  [SMALL_STATE(4917)] = 113699,
  [SMALL_STATE(4918)] = 113801,
  [SMALL_STATE(4919)] = 113939,
  [SMALL_STATE(4920)] = 114077,
  [SMALL_STATE(4921)] = 114215,
  [SMALL_STATE(4922)] = 114353,
  [SMALL_STATE(4923)] = 114491,
  [SMALL_STATE(4924)] = 114603,
  [SMALL_STATE(4925)] = 114715,
  [SMALL_STATE(4926)] = 114827,
  [SMALL_STATE(4927)] = 114939,
  [SMALL_STATE(4928)] = 115051,
  [SMALL_STATE(4929)] = 115189,
  [SMALL_STATE(4930)] = 115277,
  [SMALL_STATE(4931)] = 115365,
  [SMALL_STATE(4932)] = 115477,
  [SMALL_STATE(4933)] = 115607,
  [SMALL_STATE(4934)] = 115733,
  [SMALL_STATE(4935)] = 115875,
  [SMALL_STATE(4936)] = 115987,
  [SMALL_STATE(4937)] = 116111,
  [SMALL_STATE(4938)] = 116251,
  [SMALL_STATE(4939)] = 116391,
  [SMALL_STATE(4940)] = 116529,
  [SMALL_STATE(4941)] = 116671,
  [SMALL_STATE(4942)] = 116813,
  [SMALL_STATE(4943)] = 116915,
  [SMALL_STATE(4944)] = 117031,
  [SMALL_STATE(4945)] = 117123,
  [SMALL_STATE(4946)] = 117235,
  [SMALL_STATE(4947)] = 117377,
  [SMALL_STATE(4948)] = 117487,
  [SMALL_STATE(4949)] = 117589,
  [SMALL_STATE(4950)] = 117727,
  [SMALL_STATE(4951)] = 117865,
  [SMALL_STATE(4952)] = 117957,
  [SMALL_STATE(4953)] = 118043,
  [SMALL_STATE(4954)] = 118181,
  [SMALL_STATE(4955)] = 118297,
  [SMALL_STATE(4956)] = 118407,
  [SMALL_STATE(4957)] = 118535,
  [SMALL_STATE(4958)] = 118665,
  [SMALL_STATE(4959)] = 118791,
  [SMALL_STATE(4960)] = 118933,
  [SMALL_STATE(4961)] = 119057,
  [SMALL_STATE(4962)] = 119189,
  [SMALL_STATE(4963)] = 119323,
  [SMALL_STATE(4964)] = 119461,
  [SMALL_STATE(4965)] = 119599,
  [SMALL_STATE(4966)] = 119685,
  [SMALL_STATE(4967)] = 119773,
  [SMALL_STATE(4968)] = 119905,
  [SMALL_STATE(4969)] = 120017,
  [SMALL_STATE(4970)] = 120159,
  [SMALL_STATE(4971)] = 120297,
  [SMALL_STATE(4972)] = 120439,
  [SMALL_STATE(4973)] = 120577,
  [SMALL_STATE(4974)] = 120715,
  [SMALL_STATE(4975)] = 120853,
  [SMALL_STATE(4976)] = 120995,
  [SMALL_STATE(4977)] = 121107,
  [SMALL_STATE(4978)] = 121209,
  [SMALL_STATE(4979)] = 121347,
  [SMALL_STATE(4980)] = 121485,
  [SMALL_STATE(4981)] = 121623,
  [SMALL_STATE(4982)] = 121761,
  [SMALL_STATE(4983)] = 121877,
  [SMALL_STATE(4984)] = 121987,
  [SMALL_STATE(4985)] = 122097,
  [SMALL_STATE(4986)] = 122225,
  [SMALL_STATE(4987)] = 122355,
  [SMALL_STATE(4988)] = 122481,
  [SMALL_STATE(4989)] = 122593,
  [SMALL_STATE(4990)] = 122717,
  [SMALL_STATE(4991)] = 122849,
  [SMALL_STATE(4992)] = 122983,
  [SMALL_STATE(4993)] = 123121,
  [SMALL_STATE(4994)] = 123263,
  [SMALL_STATE(4995)] = 123379,
  [SMALL_STATE(4996)] = 123517,
  [SMALL_STATE(4997)] = 123655,
  [SMALL_STATE(4998)] = 123797,
  [SMALL_STATE(4999)] = 123939,
  [SMALL_STATE(5000)] = 124077,
  [SMALL_STATE(5001)] = 124189,
  [SMALL_STATE(5002)] = 124299,
  [SMALL_STATE(5003)] = 124387,
  [SMALL_STATE(5004)] = 124525,
  [SMALL_STATE(5005)] = 124627,
  [SMALL_STATE(5006)] = 124765,
  [SMALL_STATE(5007)] = 124903,
  [SMALL_STATE(5008)] = 125041,
  [SMALL_STATE(5009)] = 125179,
  [SMALL_STATE(5010)] = 125285,
  [SMALL_STATE(5011)] = 125413,
  [SMALL_STATE(5012)] = 125525,
  [SMALL_STATE(5013)] = 125655,
  [SMALL_STATE(5014)] = 125781,
  [SMALL_STATE(5015)] = 125893,
  [SMALL_STATE(5016)] = 126017,
  [SMALL_STATE(5017)] = 126119,
  [SMALL_STATE(5018)] = 126251,
  [SMALL_STATE(5019)] = 126353,
  [SMALL_STATE(5020)] = 126439,
  [SMALL_STATE(5021)] = 126573,
  [SMALL_STATE(5022)] = 126659,
  [SMALL_STATE(5023)] = 126797,
  [SMALL_STATE(5024)] = 126935,
  [SMALL_STATE(5025)] = 127073,
  [SMALL_STATE(5026)] = 127175,
  [SMALL_STATE(5027)] = 127287,
  [SMALL_STATE(5028)] = 127429,
  [SMALL_STATE(5029)] = 127513,
  [SMALL_STATE(5030)] = 127655,
  [SMALL_STATE(5031)] = 127743,
  [SMALL_STATE(5032)] = 127881,
  [SMALL_STATE(5033)] = 128019,
  [SMALL_STATE(5034)] = 128153,
  [SMALL_STATE(5035)] = 128291,
  [SMALL_STATE(5036)] = 128403,
  [SMALL_STATE(5037)] = 128541,
  [SMALL_STATE(5038)] = 128653,
  [SMALL_STATE(5039)] = 128793,
  [SMALL_STATE(5040)] = 128909,
  [SMALL_STATE(5041)] = 129019,
  [SMALL_STATE(5042)] = 129147,
  [SMALL_STATE(5043)] = 129277,
  [SMALL_STATE(5044)] = 129403,
  [SMALL_STATE(5045)] = 129515,
  [SMALL_STATE(5046)] = 129639,
  [SMALL_STATE(5047)] = 129771,
  [SMALL_STATE(5048)] = 129883,
  [SMALL_STATE(5049)] = 130021,
  [SMALL_STATE(5050)] = 130155,
  [SMALL_STATE(5051)] = 130261,
  [SMALL_STATE(5052)] = 130399,
  [SMALL_STATE(5053)] = 130501,
  [SMALL_STATE(5054)] = 130589,
  [SMALL_STATE(5055)] = 130727,
  [SMALL_STATE(5056)] = 130839,
  [SMALL_STATE(5057)] = 130977,
  [SMALL_STATE(5058)] = 131083,
  [SMALL_STATE(5059)] = 131185,
  [SMALL_STATE(5060)] = 131297,
  [SMALL_STATE(5061)] = 131403,
  [SMALL_STATE(5062)] = 131505,
  [SMALL_STATE(5063)] = 131617,
  [SMALL_STATE(5064)] = 131755,
  [SMALL_STATE(5065)] = 131861,
  [SMALL_STATE(5066)] = 131963,
  [SMALL_STATE(5067)] = 132075,
  [SMALL_STATE(5068)] = 132213,
  [SMALL_STATE(5069)] = 132319,
  [SMALL_STATE(5070)] = 132421,
  [SMALL_STATE(5071)] = 132559,
  [SMALL_STATE(5072)] = 132701,
  [SMALL_STATE(5073)] = 132789,
  [SMALL_STATE(5074)] = 132927,
  [SMALL_STATE(5075)] = 133029,
  [SMALL_STATE(5076)] = 133167,
  [SMALL_STATE(5077)] = 133305,
  [SMALL_STATE(5078)] = 133417,
  [SMALL_STATE(5079)] = 133523,
  [SMALL_STATE(5080)] = 133661,
  [SMALL_STATE(5081)] = 133799,
  [SMALL_STATE(5082)] = 133901,
  [SMALL_STATE(5083)] = 134043,
  [SMALL_STATE(5084)] = 134129,
  [SMALL_STATE(5085)] = 134267,
  [SMALL_STATE(5086)] = 134409,
  [SMALL_STATE(5087)] = 134547,
  [SMALL_STATE(5088)] = 134685,
  [SMALL_STATE(5089)] = 134797,
  [SMALL_STATE(5090)] = 134935,
  [SMALL_STATE(5091)] = 135051,
  [SMALL_STATE(5092)] = 135161,
  [SMALL_STATE(5093)] = 135289,
  [SMALL_STATE(5094)] = 135419,
  [SMALL_STATE(5095)] = 135545,
  [SMALL_STATE(5096)] = 135657,
  [SMALL_STATE(5097)] = 135781,
  [SMALL_STATE(5098)] = 135913,
  [SMALL_STATE(5099)] = 136047,
  [SMALL_STATE(5100)] = 136185,
  [SMALL_STATE(5101)] = 136323,
  [SMALL_STATE(5102)] = 136425,
  [SMALL_STATE(5103)] = 136563,
  [SMALL_STATE(5104)] = 136701,
  [SMALL_STATE(5105)] = 136839,
  [SMALL_STATE(5106)] = 136977,
  [SMALL_STATE(5107)] = 137115,
  [SMALL_STATE(5108)] = 137227,
  [SMALL_STATE(5109)] = 137339,
  [SMALL_STATE(5110)] = 137477,
  [SMALL_STATE(5111)] = 137615,
  [SMALL_STATE(5112)] = 137753,
  [SMALL_STATE(5113)] = 137859,
  [SMALL_STATE(5114)] = 137997,
  [SMALL_STATE(5115)] = 138139,
  [SMALL_STATE(5116)] = 138241,
  [SMALL_STATE(5117)] = 138329,
  [SMALL_STATE(5118)] = 138417,
  [SMALL_STATE(5119)] = 138505,
  [SMALL_STATE(5120)] = 138591,
  [SMALL_STATE(5121)] = 138679,
  [SMALL_STATE(5122)] = 138767,
  [SMALL_STATE(5123)] = 138855,
  [SMALL_STATE(5124)] = 138943,
  [SMALL_STATE(5125)] = 139029,
  [SMALL_STATE(5126)] = 139117,
  [SMALL_STATE(5127)] = 139205,
  [SMALL_STATE(5128)] = 139293,
  [SMALL_STATE(5129)] = 139381,
  [SMALL_STATE(5130)] = 139467,
  [SMALL_STATE(5131)] = 139555,
  [SMALL_STATE(5132)] = 139697,
  [SMALL_STATE(5133)] = 139839,
  [SMALL_STATE(5134)] = 139927,
  [SMALL_STATE(5135)] = 140015,
  [SMALL_STATE(5136)] = 140103,
  [SMALL_STATE(5137)] = 140189,
  [SMALL_STATE(5138)] = 140277,
  [SMALL_STATE(5139)] = 140389,
  [SMALL_STATE(5140)] = 140505,
  [SMALL_STATE(5141)] = 140615,
  [SMALL_STATE(5142)] = 140743,
  [SMALL_STATE(5143)] = 140873,
  [SMALL_STATE(5144)] = 140999,
  [SMALL_STATE(5145)] = 141111,
  [SMALL_STATE(5146)] = 141235,
  [SMALL_STATE(5147)] = 141367,
  [SMALL_STATE(5148)] = 141501,
  [SMALL_STATE(5149)] = 141639,
  [SMALL_STATE(5150)] = 141777,
  [SMALL_STATE(5151)] = 141905,
  [SMALL_STATE(5152)] = 142043,
  [SMALL_STATE(5153)] = 142131,
  [SMALL_STATE(5154)] = 142233,
  [SMALL_STATE(5155)] = 142321,
  [SMALL_STATE(5156)] = 142409,
  [SMALL_STATE(5157)] = 142547,
  [SMALL_STATE(5158)] = 142633,
  [SMALL_STATE(5159)] = 142721,
  [SMALL_STATE(5160)] = 142859,
  [SMALL_STATE(5161)] = 142947,
  [SMALL_STATE(5162)] = 143085,
  [SMALL_STATE(5163)] = 143197,
  [SMALL_STATE(5164)] = 143296,
  [SMALL_STATE(5165)] = 143395,
  [SMALL_STATE(5166)] = 143532,
  [SMALL_STATE(5167)] = 143669,
  [SMALL_STATE(5168)] = 143772,
  [SMALL_STATE(5169)] = 143871,
  [SMALL_STATE(5170)] = 143956,
  [SMALL_STATE(5171)] = 144093,
  [SMALL_STATE(5172)] = 144192,
  [SMALL_STATE(5173)] = 144329,
  [SMALL_STATE(5174)] = 144466,
  [SMALL_STATE(5175)] = 144565,
  [SMALL_STATE(5176)] = 144702,
  [SMALL_STATE(5177)] = 144839,
  [SMALL_STATE(5178)] = 144924,
  [SMALL_STATE(5179)] = 145023,
  [SMALL_STATE(5180)] = 145160,
  [SMALL_STATE(5181)] = 145297,
  [SMALL_STATE(5182)] = 145382,
  [SMALL_STATE(5183)] = 145519,
  [SMALL_STATE(5184)] = 145656,
  [SMALL_STATE(5185)] = 145757,
  [SMALL_STATE(5186)] = 145842,
  [SMALL_STATE(5187)] = 145969,
  [SMALL_STATE(5188)] = 146060,
  [SMALL_STATE(5189)] = 146147,
  [SMALL_STATE(5190)] = 146284,
  [SMALL_STATE(5191)] = 146369,
  [SMALL_STATE(5192)] = 146470,
  [SMALL_STATE(5193)] = 146607,
  [SMALL_STATE(5194)] = 146706,
  [SMALL_STATE(5195)] = 146807,
  [SMALL_STATE(5196)] = 146944,
  [SMALL_STATE(5197)] = 147081,
  [SMALL_STATE(5198)] = 147182,
  [SMALL_STATE(5199)] = 147319,
  [SMALL_STATE(5200)] = 147448,
  [SMALL_STATE(5201)] = 147585,
  [SMALL_STATE(5202)] = 147722,
  [SMALL_STATE(5203)] = 147859,
  [SMALL_STATE(5204)] = 147974,
  [SMALL_STATE(5205)] = 148089,
  [SMALL_STATE(5206)] = 148198,
  [SMALL_STATE(5207)] = 148285,
  [SMALL_STATE(5208)] = 148390,
  [SMALL_STATE(5209)] = 148517,
  [SMALL_STATE(5210)] = 148646,
  [SMALL_STATE(5211)] = 148783,
  [SMALL_STATE(5212)] = 148908,
  [SMALL_STATE(5213)] = 149045,
  [SMALL_STATE(5214)] = 149184,
  [SMALL_STATE(5215)] = 149293,
  [SMALL_STATE(5216)] = 149430,
  [SMALL_STATE(5217)] = 149535,
  [SMALL_STATE(5218)] = 149646,
  [SMALL_STATE(5219)] = 149733,
  [SMALL_STATE(5220)] = 149820,
  [SMALL_STATE(5221)] = 149919,
  [SMALL_STATE(5222)] = 150018,
  [SMALL_STATE(5223)] = 150111,
  [SMALL_STATE(5224)] = 150248,
  [SMALL_STATE(5225)] = 150359,
  [SMALL_STATE(5226)] = 150482,
  [SMALL_STATE(5227)] = 150613,
  [SMALL_STATE(5228)] = 150712,
  [SMALL_STATE(5229)] = 150815,
  [SMALL_STATE(5230)] = 150954,
  [SMALL_STATE(5231)] = 151091,
  [SMALL_STATE(5232)] = 151230,
  [SMALL_STATE(5233)] = 151331,
  [SMALL_STATE(5234)] = 151470,
  [SMALL_STATE(5235)] = 151555,
  [SMALL_STATE(5236)] = 151680,
  [SMALL_STATE(5237)] = 151819,
  [SMALL_STATE(5238)] = 151930,
  [SMALL_STATE(5239)] = 152053,
  [SMALL_STATE(5240)] = 152192,
  [SMALL_STATE(5241)] = 152329,
  [SMALL_STATE(5242)] = 152444,
  [SMALL_STATE(5243)] = 152553,
  [SMALL_STATE(5244)] = 152658,
  [SMALL_STATE(5245)] = 152785,
  [SMALL_STATE(5246)] = 152914,
  [SMALL_STATE(5247)] = 153039,
  [SMALL_STATE(5248)] = 153150,
  [SMALL_STATE(5249)] = 153273,
  [SMALL_STATE(5250)] = 153404,
  [SMALL_STATE(5251)] = 153537,
  [SMALL_STATE(5252)] = 153674,
  [SMALL_STATE(5253)] = 153807,
  [SMALL_STATE(5254)] = 153938,
  [SMALL_STATE(5255)] = 154071,
  [SMALL_STATE(5256)] = 154208,
  [SMALL_STATE(5257)] = 154307,
  [SMALL_STATE(5258)] = 154444,
  [SMALL_STATE(5259)] = 154529,
  [SMALL_STATE(5260)] = 154666,
  [SMALL_STATE(5261)] = 154803,
  [SMALL_STATE(5262)] = 154904,
  [SMALL_STATE(5263)] = 155041,
  [SMALL_STATE(5264)] = 155126,
  [SMALL_STATE(5265)] = 155263,
  [SMALL_STATE(5266)] = 155370,
  [SMALL_STATE(5267)] = 155469,
  [SMALL_STATE(5268)] = 155606,
  [SMALL_STATE(5269)] = 155743,
  [SMALL_STATE(5270)] = 155842,
  [SMALL_STATE(5271)] = 155929,
  [SMALL_STATE(5272)] = 156066,
  [SMALL_STATE(5273)] = 156181,
  [SMALL_STATE(5274)] = 156290,
  [SMALL_STATE(5275)] = 156399,
  [SMALL_STATE(5276)] = 156486,
  [SMALL_STATE(5277)] = 156591,
  [SMALL_STATE(5278)] = 156728,
  [SMALL_STATE(5279)] = 156865,
  [SMALL_STATE(5280)] = 156958,
  [SMALL_STATE(5281)] = 157085,
  [SMALL_STATE(5282)] = 157170,
  [SMALL_STATE(5283)] = 157309,
  [SMALL_STATE(5284)] = 157396,
  [SMALL_STATE(5285)] = 157525,
  [SMALL_STATE(5286)] = 157634,
  [SMALL_STATE(5287)] = 157771,
  [SMALL_STATE(5288)] = 157910,
  [SMALL_STATE(5289)] = 158009,
  [SMALL_STATE(5290)] = 158108,
  [SMALL_STATE(5291)] = 158233,
  [SMALL_STATE(5292)] = 158316,
  [SMALL_STATE(5293)] = 158415,
  [SMALL_STATE(5294)] = 158514,
  [SMALL_STATE(5295)] = 158597,
  [SMALL_STATE(5296)] = 158696,
  [SMALL_STATE(5297)] = 158795,
  [SMALL_STATE(5298)] = 158894,
  [SMALL_STATE(5299)] = 159005,
  [SMALL_STATE(5300)] = 159104,
  [SMALL_STATE(5301)] = 159203,
  [SMALL_STATE(5302)] = 159302,
  [SMALL_STATE(5303)] = 159387,
  [SMALL_STATE(5304)] = 159510,
  [SMALL_STATE(5305)] = 159597,
  [SMALL_STATE(5306)] = 159734,
  [SMALL_STATE(5307)] = 159833,
  [SMALL_STATE(5308)] = 159964,
  [SMALL_STATE(5309)] = 160063,
  [SMALL_STATE(5310)] = 160162,
  [SMALL_STATE(5311)] = 160261,
  [SMALL_STATE(5312)] = 160400,
  [SMALL_STATE(5313)] = 160537,
  [SMALL_STATE(5314)] = 160636,
  [SMALL_STATE(5315)] = 160735,
  [SMALL_STATE(5316)] = 160834,
  [SMALL_STATE(5317)] = 160933,
  [SMALL_STATE(5318)] = 161032,
  [SMALL_STATE(5319)] = 161169,
  [SMALL_STATE(5320)] = 161268,
  [SMALL_STATE(5321)] = 161367,
  [SMALL_STATE(5322)] = 161504,
  [SMALL_STATE(5323)] = 161605,
  [SMALL_STATE(5324)] = 161742,
  [SMALL_STATE(5325)] = 161841,
  [SMALL_STATE(5326)] = 161940,
  [SMALL_STATE(5327)] = 162027,
  [SMALL_STATE(5328)] = 162164,
  [SMALL_STATE(5329)] = 162297,
  [SMALL_STATE(5330)] = 162396,
  [SMALL_STATE(5331)] = 162495,
  [SMALL_STATE(5332)] = 162632,
  [SMALL_STATE(5333)] = 162731,
  [SMALL_STATE(5334)] = 162868,
  [SMALL_STATE(5335)] = 162969,
  [SMALL_STATE(5336)] = 163106,
  [SMALL_STATE(5337)] = 163243,
  [SMALL_STATE(5338)] = 163380,
  [SMALL_STATE(5339)] = 163517,
  [SMALL_STATE(5340)] = 163632,
  [SMALL_STATE(5341)] = 163759,
  [SMALL_STATE(5342)] = 163888,
  [SMALL_STATE(5343)] = 164013,
  [SMALL_STATE(5344)] = 164150,
  [SMALL_STATE(5345)] = 164249,
  [SMALL_STATE(5346)] = 164358,
  [SMALL_STATE(5347)] = 164457,
  [SMALL_STATE(5348)] = 164580,
  [SMALL_STATE(5349)] = 164717,
  [SMALL_STATE(5350)] = 164856,
  [SMALL_STATE(5351)] = 164995,
  [SMALL_STATE(5352)] = 165082,
  [SMALL_STATE(5353)] = 165213,
  [SMALL_STATE(5354)] = 165352,
  [SMALL_STATE(5355)] = 165453,
  [SMALL_STATE(5356)] = 165590,
  [SMALL_STATE(5357)] = 165677,
  [SMALL_STATE(5358)] = 165810,
  [SMALL_STATE(5359)] = 165947,
  [SMALL_STATE(5360)] = 166084,
  [SMALL_STATE(5361)] = 166185,
  [SMALL_STATE(5362)] = 166290,
  [SMALL_STATE(5363)] = 166375,
  [SMALL_STATE(5364)] = 166462,
  [SMALL_STATE(5365)] = 166547,
  [SMALL_STATE(5366)] = 166684,
  [SMALL_STATE(5367)] = 166783,
  [SMALL_STATE(5368)] = 166882,
  [SMALL_STATE(5369)] = 166981,
  [SMALL_STATE(5370)] = 167080,
  [SMALL_STATE(5371)] = 167179,
  [SMALL_STATE(5372)] = 167315,
  [SMALL_STATE(5373)] = 167419,
  [SMALL_STATE(5374)] = 167503,
  [SMALL_STATE(5375)] = 167639,
  [SMALL_STATE(5376)] = 167775,
  [SMALL_STATE(5377)] = 167911,
  [SMALL_STATE(5378)] = 168047,
  [SMALL_STATE(5379)] = 168131,
  [SMALL_STATE(5380)] = 168267,
  [SMALL_STATE(5381)] = 168371,
  [SMALL_STATE(5382)] = 168507,
  [SMALL_STATE(5383)] = 168643,
  [SMALL_STATE(5384)] = 168779,
  [SMALL_STATE(5385)] = 168915,
  [SMALL_STATE(5386)] = 169051,
  [SMALL_STATE(5387)] = 169187,
  [SMALL_STATE(5388)] = 169323,
  [SMALL_STATE(5389)] = 169459,
  [SMALL_STATE(5390)] = 169595,
  [SMALL_STATE(5391)] = 169731,
  [SMALL_STATE(5392)] = 169867,
  [SMALL_STATE(5393)] = 170003,
  [SMALL_STATE(5394)] = 170139,
  [SMALL_STATE(5395)] = 170275,
  [SMALL_STATE(5396)] = 170411,
  [SMALL_STATE(5397)] = 170547,
  [SMALL_STATE(5398)] = 170683,
  [SMALL_STATE(5399)] = 170819,
  [SMALL_STATE(5400)] = 170955,
  [SMALL_STATE(5401)] = 171091,
  [SMALL_STATE(5402)] = 171227,
  [SMALL_STATE(5403)] = 171363,
  [SMALL_STATE(5404)] = 171499,
  [SMALL_STATE(5405)] = 171583,
  [SMALL_STATE(5406)] = 171665,
  [SMALL_STATE(5407)] = 171747,
  [SMALL_STATE(5408)] = 171883,
  [SMALL_STATE(5409)] = 172019,
  [SMALL_STATE(5410)] = 172155,
  [SMALL_STATE(5411)] = 172291,
  [SMALL_STATE(5412)] = 172427,
  [SMALL_STATE(5413)] = 172563,
  [SMALL_STATE(5414)] = 172699,
  [SMALL_STATE(5415)] = 172835,
  [SMALL_STATE(5416)] = 172971,
  [SMALL_STATE(5417)] = 173097,
  [SMALL_STATE(5418)] = 173225,
  [SMALL_STATE(5419)] = 173349,
  [SMALL_STATE(5420)] = 173471,
  [SMALL_STATE(5421)] = 173601,
  [SMALL_STATE(5422)] = 173733,
  [SMALL_STATE(5423)] = 173869,
  [SMALL_STATE(5424)] = 174005,
  [SMALL_STATE(5425)] = 174141,
  [SMALL_STATE(5426)] = 174277,
  [SMALL_STATE(5427)] = 174413,
  [SMALL_STATE(5428)] = 174549,
  [SMALL_STATE(5429)] = 174685,
  [SMALL_STATE(5430)] = 174821,
  [SMALL_STATE(5431)] = 174957,
  [SMALL_STATE(5432)] = 175093,
  [SMALL_STATE(5433)] = 175229,
  [SMALL_STATE(5434)] = 175327,
  [SMALL_STATE(5435)] = 175463,
  [SMALL_STATE(5436)] = 175547,
  [SMALL_STATE(5437)] = 175661,
  [SMALL_STATE(5438)] = 175797,
  [SMALL_STATE(5439)] = 175883,
  [SMALL_STATE(5440)] = 175973,
  [SMALL_STATE(5441)] = 176109,
  [SMALL_STATE(5442)] = 176245,
  [SMALL_STATE(5443)] = 176381,
  [SMALL_STATE(5444)] = 176489,
  [SMALL_STATE(5445)] = 176593,
  [SMALL_STATE(5446)] = 176719,
  [SMALL_STATE(5447)] = 176847,
  [SMALL_STATE(5448)] = 176983,
  [SMALL_STATE(5449)] = 177107,
  [SMALL_STATE(5450)] = 177217,
  [SMALL_STATE(5451)] = 177353,
  [SMALL_STATE(5452)] = 177475,
  [SMALL_STATE(5453)] = 177611,
  [SMALL_STATE(5454)] = 177711,
  [SMALL_STATE(5455)] = 177841,
  [SMALL_STATE(5456)] = 177973,
  [SMALL_STATE(5457)] = 178109,
  [SMALL_STATE(5458)] = 178245,
  [SMALL_STATE(5459)] = 178381,
  [SMALL_STATE(5460)] = 178517,
  [SMALL_STATE(5461)] = 178653,
  [SMALL_STATE(5462)] = 178789,
  [SMALL_STATE(5463)] = 178877,
  [SMALL_STATE(5464)] = 179013,
  [SMALL_STATE(5465)] = 179149,
  [SMALL_STATE(5466)] = 179285,
  [SMALL_STATE(5467)] = 179421,
  [SMALL_STATE(5468)] = 179557,
  [SMALL_STATE(5469)] = 179641,
  [SMALL_STATE(5470)] = 179777,
  [SMALL_STATE(5471)] = 179913,
  [SMALL_STATE(5472)] = 180049,
  [SMALL_STATE(5473)] = 180133,
  [SMALL_STATE(5474)] = 180269,
  [SMALL_STATE(5475)] = 180405,
  [SMALL_STATE(5476)] = 180541,
  [SMALL_STATE(5477)] = 180677,
  [SMALL_STATE(5478)] = 180813,
  [SMALL_STATE(5479)] = 180949,
  [SMALL_STATE(5480)] = 181085,
  [SMALL_STATE(5481)] = 181221,
  [SMALL_STATE(5482)] = 181357,
  [SMALL_STATE(5483)] = 181493,
  [SMALL_STATE(5484)] = 181629,
  [SMALL_STATE(5485)] = 181765,
  [SMALL_STATE(5486)] = 181901,
  [SMALL_STATE(5487)] = 182037,
  [SMALL_STATE(5488)] = 182173,
  [SMALL_STATE(5489)] = 182257,
  [SMALL_STATE(5490)] = 182343,
  [SMALL_STATE(5491)] = 182479,
  [SMALL_STATE(5492)] = 182615,
  [SMALL_STATE(5493)] = 182697,
  [SMALL_STATE(5494)] = 182783,
  [SMALL_STATE(5495)] = 182919,
  [SMALL_STATE(5496)] = 183001,
  [SMALL_STATE(5497)] = 183085,
  [SMALL_STATE(5498)] = 183221,
  [SMALL_STATE(5499)] = 183357,
  [SMALL_STATE(5500)] = 183493,
  [SMALL_STATE(5501)] = 183629,
  [SMALL_STATE(5502)] = 183765,
  [SMALL_STATE(5503)] = 183901,
  [SMALL_STATE(5504)] = 184037,
  [SMALL_STATE(5505)] = 184173,
  [SMALL_STATE(5506)] = 184255,
  [SMALL_STATE(5507)] = 184391,
  [SMALL_STATE(5508)] = 184527,
  [SMALL_STATE(5509)] = 184609,
  [SMALL_STATE(5510)] = 184745,
  [SMALL_STATE(5511)] = 184881,
  [SMALL_STATE(5512)] = 184967,
  [SMALL_STATE(5513)] = 185103,
  [SMALL_STATE(5514)] = 185189,
  [SMALL_STATE(5515)] = 185275,
  [SMALL_STATE(5516)] = 185411,
  [SMALL_STATE(5517)] = 185497,
  [SMALL_STATE(5518)] = 185581,
  [SMALL_STATE(5519)] = 185667,
  [SMALL_STATE(5520)] = 185803,
  [SMALL_STATE(5521)] = 185893,
  [SMALL_STATE(5522)] = 186007,
  [SMALL_STATE(5523)] = 186143,
  [SMALL_STATE(5524)] = 186251,
  [SMALL_STATE(5525)] = 186355,
  [SMALL_STATE(5526)] = 186481,
  [SMALL_STATE(5527)] = 186609,
  [SMALL_STATE(5528)] = 186733,
  [SMALL_STATE(5529)] = 186843,
  [SMALL_STATE(5530)] = 186965,
  [SMALL_STATE(5531)] = 187065,
  [SMALL_STATE(5532)] = 187195,
  [SMALL_STATE(5533)] = 187327,
  [SMALL_STATE(5534)] = 187463,
  [SMALL_STATE(5535)] = 187599,
  [SMALL_STATE(5536)] = 187735,
  [SMALL_STATE(5537)] = 187835,
  [SMALL_STATE(5538)] = 187971,
  [SMALL_STATE(5539)] = 188057,
  [SMALL_STATE(5540)] = 188193,
  [SMALL_STATE(5541)] = 188329,
  [SMALL_STATE(5542)] = 188415,
  [SMALL_STATE(5543)] = 188551,
  [SMALL_STATE(5544)] = 188687,
  [SMALL_STATE(5545)] = 188823,
  [SMALL_STATE(5546)] = 188959,
  [SMALL_STATE(5547)] = 189059,
  [SMALL_STATE(5548)] = 189195,
  [SMALL_STATE(5549)] = 189331,
  [SMALL_STATE(5550)] = 189415,
  [SMALL_STATE(5551)] = 189551,
  [SMALL_STATE(5552)] = 189687,
  [SMALL_STATE(5553)] = 189823,
  [SMALL_STATE(5554)] = 189959,
  [SMALL_STATE(5555)] = 190045,
  [SMALL_STATE(5556)] = 190181,
  [SMALL_STATE(5557)] = 190267,
  [SMALL_STATE(5558)] = 190403,
  [SMALL_STATE(5559)] = 190539,
  [SMALL_STATE(5560)] = 190675,
  [SMALL_STATE(5561)] = 190811,
  [SMALL_STATE(5562)] = 190947,
  [SMALL_STATE(5563)] = 191083,
  [SMALL_STATE(5564)] = 191183,
  [SMALL_STATE(5565)] = 191319,
  [SMALL_STATE(5566)] = 191405,
  [SMALL_STATE(5567)] = 191541,
  [SMALL_STATE(5568)] = 191627,
  [SMALL_STATE(5569)] = 191763,
  [SMALL_STATE(5570)] = 191899,
  [SMALL_STATE(5571)] = 191999,
  [SMALL_STATE(5572)] = 192135,
  [SMALL_STATE(5573)] = 192271,
  [SMALL_STATE(5574)] = 192407,
  [SMALL_STATE(5575)] = 192507,
  [SMALL_STATE(5576)] = 192643,
  [SMALL_STATE(5577)] = 192779,
  [SMALL_STATE(5578)] = 192893,
  [SMALL_STATE(5579)] = 193029,
  [SMALL_STATE(5580)] = 193137,
  [SMALL_STATE(5581)] = 193273,
  [SMALL_STATE(5582)] = 193377,
  [SMALL_STATE(5583)] = 193513,
  [SMALL_STATE(5584)] = 193649,
  [SMALL_STATE(5585)] = 193775,
  [SMALL_STATE(5586)] = 193911,
  [SMALL_STATE(5587)] = 194047,
  [SMALL_STATE(5588)] = 194183,
  [SMALL_STATE(5589)] = 194319,
  [SMALL_STATE(5590)] = 194403,
  [SMALL_STATE(5591)] = 194539,
  [SMALL_STATE(5592)] = 194643,
  [SMALL_STATE(5593)] = 194771,
  [SMALL_STATE(5594)] = 194907,
  [SMALL_STATE(5595)] = 195031,
  [SMALL_STATE(5596)] = 195141,
  [SMALL_STATE(5597)] = 195277,
  [SMALL_STATE(5598)] = 195399,
  [SMALL_STATE(5599)] = 195499,
  [SMALL_STATE(5600)] = 195629,
  [SMALL_STATE(5601)] = 195761,
  [SMALL_STATE(5602)] = 195897,
  [SMALL_STATE(5603)] = 196033,
  [SMALL_STATE(5604)] = 196169,
  [SMALL_STATE(5605)] = 196305,
  [SMALL_STATE(5606)] = 196441,
  [SMALL_STATE(5607)] = 196555,
  [SMALL_STATE(5608)] = 196663,
  [SMALL_STATE(5609)] = 196767,
  [SMALL_STATE(5610)] = 196877,
  [SMALL_STATE(5611)] = 196977,
  [SMALL_STATE(5612)] = 197113,
  [SMALL_STATE(5613)] = 197249,
  [SMALL_STATE(5614)] = 197385,
  [SMALL_STATE(5615)] = 197521,
  [SMALL_STATE(5616)] = 197657,
  [SMALL_STATE(5617)] = 197793,
  [SMALL_STATE(5618)] = 197929,
  [SMALL_STATE(5619)] = 198065,
  [SMALL_STATE(5620)] = 198201,
  [SMALL_STATE(5621)] = 198337,
  [SMALL_STATE(5622)] = 198473,
  [SMALL_STATE(5623)] = 198609,
  [SMALL_STATE(5624)] = 198745,
  [SMALL_STATE(5625)] = 198881,
  [SMALL_STATE(5626)] = 198965,
  [SMALL_STATE(5627)] = 199101,
  [SMALL_STATE(5628)] = 199237,
  [SMALL_STATE(5629)] = 199373,
  [SMALL_STATE(5630)] = 199509,
  [SMALL_STATE(5631)] = 199645,
  [SMALL_STATE(5632)] = 199781,
  [SMALL_STATE(5633)] = 199917,
  [SMALL_STATE(5634)] = 200053,
  [SMALL_STATE(5635)] = 200167,
  [SMALL_STATE(5636)] = 200303,
  [SMALL_STATE(5637)] = 200411,
  [SMALL_STATE(5638)] = 200515,
  [SMALL_STATE(5639)] = 200641,
  [SMALL_STATE(5640)] = 200769,
  [SMALL_STATE(5641)] = 200893,
  [SMALL_STATE(5642)] = 201003,
  [SMALL_STATE(5643)] = 201125,
  [SMALL_STATE(5644)] = 201239,
  [SMALL_STATE(5645)] = 201375,
  [SMALL_STATE(5646)] = 201511,
  [SMALL_STATE(5647)] = 201647,
  [SMALL_STATE(5648)] = 201755,
  [SMALL_STATE(5649)] = 201891,
  [SMALL_STATE(5650)] = 201995,
  [SMALL_STATE(5651)] = 202131,
  [SMALL_STATE(5652)] = 202257,
  [SMALL_STATE(5653)] = 202385,
  [SMALL_STATE(5654)] = 202521,
  [SMALL_STATE(5655)] = 202645,
  [SMALL_STATE(5656)] = 202781,
  [SMALL_STATE(5657)] = 202891,
  [SMALL_STATE(5658)] = 203027,
  [SMALL_STATE(5659)] = 203149,
  [SMALL_STATE(5660)] = 203235,
  [SMALL_STATE(5661)] = 203321,
  [SMALL_STATE(5662)] = 203405,
  [SMALL_STATE(5663)] = 203491,
  [SMALL_STATE(5664)] = 203627,
  [SMALL_STATE(5665)] = 203727,
  [SMALL_STATE(5666)] = 203857,
  [SMALL_STATE(5667)] = 203989,
  [SMALL_STATE(5668)] = 204125,
  [SMALL_STATE(5669)] = 204261,
  [SMALL_STATE(5670)] = 204397,
  [SMALL_STATE(5671)] = 204497,
  [SMALL_STATE(5672)] = 204581,
  [SMALL_STATE(5673)] = 204667,
  [SMALL_STATE(5674)] = 204753,
  [SMALL_STATE(5675)] = 204837,
  [SMALL_STATE(5676)] = 204923,
  [SMALL_STATE(5677)] = 205059,
  [SMALL_STATE(5678)] = 205145,
  [SMALL_STATE(5679)] = 205281,
  [SMALL_STATE(5680)] = 205411,
  [SMALL_STATE(5681)] = 205543,
  [SMALL_STATE(5682)] = 205629,
  [SMALL_STATE(5683)] = 205715,
  [SMALL_STATE(5684)] = 205799,
  [SMALL_STATE(5685)] = 205885,
  [SMALL_STATE(5686)] = 206021,
  [SMALL_STATE(5687)] = 206157,
  [SMALL_STATE(5688)] = 206243,
  [SMALL_STATE(5689)] = 206379,
  [SMALL_STATE(5690)] = 206515,
  [SMALL_STATE(5691)] = 206651,
  [SMALL_STATE(5692)] = 206737,
  [SMALL_STATE(5693)] = 206823,
  [SMALL_STATE(5694)] = 206959,
  [SMALL_STATE(5695)] = 207095,
  [SMALL_STATE(5696)] = 207179,
  [SMALL_STATE(5697)] = 207265,
  [SMALL_STATE(5698)] = 207401,
  [SMALL_STATE(5699)] = 207537,
  [SMALL_STATE(5700)] = 207637,
  [SMALL_STATE(5701)] = 207773,
  [SMALL_STATE(5702)] = 207909,
  [SMALL_STATE(5703)] = 207995,
  [SMALL_STATE(5704)] = 208081,
  [SMALL_STATE(5705)] = 208165,
  [SMALL_STATE(5706)] = 208251,
  [SMALL_STATE(5707)] = 208387,
  [SMALL_STATE(5708)] = 208479,
  [SMALL_STATE(5709)] = 208565,
  [SMALL_STATE(5710)] = 208698,
  [SMALL_STATE(5711)] = 208831,
  [SMALL_STATE(5712)] = 208964,
  [SMALL_STATE(5713)] = 209097,
  [SMALL_STATE(5714)] = 209230,
  [SMALL_STATE(5715)] = 209363,
  [SMALL_STATE(5716)] = 209496,
  [SMALL_STATE(5717)] = 209629,
  [SMALL_STATE(5718)] = 209730,
  [SMALL_STATE(5719)] = 209863,
  [SMALL_STATE(5720)] = 209960,
  [SMALL_STATE(5721)] = 210093,
  [SMALL_STATE(5722)] = 210226,
  [SMALL_STATE(5723)] = 210317,
  [SMALL_STATE(5724)] = 210450,
  [SMALL_STATE(5725)] = 210583,
  [SMALL_STATE(5726)] = 210716,
  [SMALL_STATE(5727)] = 210849,
  [SMALL_STATE(5728)] = 210938,
  [SMALL_STATE(5729)] = 211071,
  [SMALL_STATE(5730)] = 211204,
  [SMALL_STATE(5731)] = 211337,
  [SMALL_STATE(5732)] = 211438,
  [SMALL_STATE(5733)] = 211529,
  [SMALL_STATE(5734)] = 211662,
  [SMALL_STATE(5735)] = 211745,
  [SMALL_STATE(5736)] = 211878,
  [SMALL_STATE(5737)] = 212011,
  [SMALL_STATE(5738)] = 212102,
  [SMALL_STATE(5739)] = 212235,
  [SMALL_STATE(5740)] = 212368,
  [SMALL_STATE(5741)] = 212501,
  [SMALL_STATE(5742)] = 212598,
  [SMALL_STATE(5743)] = 212691,
  [SMALL_STATE(5744)] = 212824,
  [SMALL_STATE(5745)] = 212925,
  [SMALL_STATE(5746)] = 213022,
  [SMALL_STATE(5747)] = 213155,
  [SMALL_STATE(5748)] = 213288,
  [SMALL_STATE(5749)] = 213421,
  [SMALL_STATE(5750)] = 213512,
  [SMALL_STATE(5751)] = 213645,
  [SMALL_STATE(5752)] = 213778,
  [SMALL_STATE(5753)] = 213869,
  [SMALL_STATE(5754)] = 213960,
  [SMALL_STATE(5755)] = 214051,
  [SMALL_STATE(5756)] = 214184,
  [SMALL_STATE(5757)] = 214317,
  [SMALL_STATE(5758)] = 214414,
  [SMALL_STATE(5759)] = 214547,
  [SMALL_STATE(5760)] = 214637,
  [SMALL_STATE(5761)] = 214727,
  [SMALL_STATE(5762)] = 214817,
  [SMALL_STATE(5763)] = 214913,
  [SMALL_STATE(5764)] = 214995,
  [SMALL_STATE(5765)] = 215093,
  [SMALL_STATE(5766)] = 215183,
  [SMALL_STATE(5767)] = 215279,
  [SMALL_STATE(5768)] = 215369,
  [SMALL_STATE(5769)] = 215451,
  [SMALL_STATE(5770)] = 215541,
  [SMALL_STATE(5771)] = 215639,
  [SMALL_STATE(5772)] = 215737,
  [SMALL_STATE(5773)] = 215827,
  [SMALL_STATE(5774)] = 215925,
  [SMALL_STATE(5775)] = 216015,
  [SMALL_STATE(5776)] = 216113,
  [SMALL_STATE(5777)] = 216211,
  [SMALL_STATE(5778)] = 216301,
  [SMALL_STATE(5779)] = 216395,
  [SMALL_STATE(5780)] = 216491,
  [SMALL_STATE(5781)] = 216589,
  [SMALL_STATE(5782)] = 216674,
  [SMALL_STATE(5783)] = 216761,
  [SMALL_STATE(5784)] = 216856,
  [SMALL_STATE(5785)] = 216949,
  [SMALL_STATE(5786)] = 217036,
  [SMALL_STATE(5787)] = 217129,
  [SMALL_STATE(5788)] = 217222,
  [SMALL_STATE(5789)] = 217309,
  [SMALL_STATE(5790)] = 217406,
  [SMALL_STATE(5791)] = 217501,
  [SMALL_STATE(5792)] = 217592,
  [SMALL_STATE(5793)] = 217685,
  [SMALL_STATE(5794)] = 217780,
  [SMALL_STATE(5795)] = 217871,
  [SMALL_STATE(5796)] = 217966,
  [SMALL_STATE(5797)] = 218061,
  [SMALL_STATE(5798)] = 218156,
  [SMALL_STATE(5799)] = 218251,
  [SMALL_STATE(5800)] = 218346,
  [SMALL_STATE(5801)] = 218437,
  [SMALL_STATE(5802)] = 218530,
  [SMALL_STATE(5803)] = 218625,
  [SMALL_STATE(5804)] = 218724,
  [SMALL_STATE(5805)] = 218805,
  [SMALL_STATE(5806)] = 218898,
  [SMALL_STATE(5807)] = 218993,
  [SMALL_STATE(5808)] = 219084,
  [SMALL_STATE(5809)] = 219176,
  [SMALL_STATE(5810)] = 219268,
  [SMALL_STATE(5811)] = 219348,
  [SMALL_STATE(5812)] = 219440,
  [SMALL_STATE(5813)] = 219532,
  [SMALL_STATE(5814)] = 219624,
  [SMALL_STATE(5815)] = 219716,
  [SMALL_STATE(5816)] = 219808,
  [SMALL_STATE(5817)] = 219900,
  [SMALL_STATE(5818)] = 219992,
  [SMALL_STATE(5819)] = 220084,
  [SMALL_STATE(5820)] = 220176,
  [SMALL_STATE(5821)] = 220268,
  [SMALL_STATE(5822)] = 220354,
  [SMALL_STATE(5823)] = 220446,
  [SMALL_STATE(5824)] = 220538,
  [SMALL_STATE(5825)] = 220630,
  [SMALL_STATE(5826)] = 220722,
  [SMALL_STATE(5827)] = 220814,
  [SMALL_STATE(5828)] = 220894,
  [SMALL_STATE(5829)] = 220986,
  [SMALL_STATE(5830)] = 221078,
  [SMALL_STATE(5831)] = 221170,
  [SMALL_STATE(5832)] = 221259,
  [SMALL_STATE(5833)] = 221348,
  [SMALL_STATE(5834)] = 221437,
  [SMALL_STATE(5835)] = 221526,
  [SMALL_STATE(5836)] = 221617,
  [SMALL_STATE(5837)] = 221706,
  [SMALL_STATE(5838)] = 221795,
  [SMALL_STATE(5839)] = 221884,
  [SMALL_STATE(5840)] = 221973,
  [SMALL_STATE(5841)] = 222062,
  [SMALL_STATE(5842)] = 222147,
  [SMALL_STATE(5843)] = 222230,
  [SMALL_STATE(5844)] = 222315,
  [SMALL_STATE(5845)] = 222406,
  [SMALL_STATE(5846)] = 222483,
  [SMALL_STATE(5847)] = 222569,
  [SMALL_STATE(5848)] = 222659,
  [SMALL_STATE(5849)] = 222749,
  [SMALL_STATE(5850)] = 222839,
  [SMALL_STATE(5851)] = 222929,
  [SMALL_STATE(5852)] = 223019,
  [SMALL_STATE(5853)] = 223109,
  [SMALL_STATE(5854)] = 223199,
  [SMALL_STATE(5855)] = 223289,
  [SMALL_STATE(5856)] = 223379,
  [SMALL_STATE(5857)] = 223469,
  [SMALL_STATE(5858)] = 223545,
  [SMALL_STATE(5859)] = 223635,
  [SMALL_STATE(5860)] = 223725,
  [SMALL_STATE(5861)] = 223811,
  [SMALL_STATE(5862)] = 223897,
  [SMALL_STATE(5863)] = 223987,
  [SMALL_STATE(5864)] = 224073,
  [SMALL_STATE(5865)] = 224163,
  [SMALL_STATE(5866)] = 224253,
  [SMALL_STATE(5867)] = 224343,
  [SMALL_STATE(5868)] = 224433,
  [SMALL_STATE(5869)] = 224523,
  [SMALL_STATE(5870)] = 224613,
  [SMALL_STATE(5871)] = 224703,
  [SMALL_STATE(5872)] = 224793,
  [SMALL_STATE(5873)] = 224883,
  [SMALL_STATE(5874)] = 224973,
  [SMALL_STATE(5875)] = 225059,
  [SMALL_STATE(5876)] = 225149,
  [SMALL_STATE(5877)] = 225239,
  [SMALL_STATE(5878)] = 225329,
  [SMALL_STATE(5879)] = 225413,
  [SMALL_STATE(5880)] = 225503,
  [SMALL_STATE(5881)] = 225593,
  [SMALL_STATE(5882)] = 225677,
  [SMALL_STATE(5883)] = 225767,
  [SMALL_STATE(5884)] = 225857,
  [SMALL_STATE(5885)] = 225947,
  [SMALL_STATE(5886)] = 226023,
  [SMALL_STATE(5887)] = 226113,
  [SMALL_STATE(5888)] = 226203,
  [SMALL_STATE(5889)] = 226293,
  [SMALL_STATE(5890)] = 226383,
  [SMALL_STATE(5891)] = 226473,
  [SMALL_STATE(5892)] = 226551,
  [SMALL_STATE(5893)] = 226641,
  [SMALL_STATE(5894)] = 226731,
  [SMALL_STATE(5895)] = 226821,
  [SMALL_STATE(5896)] = 226911,
  [SMALL_STATE(5897)] = 227001,
  [SMALL_STATE(5898)] = 227091,
  [SMALL_STATE(5899)] = 227181,
  [SMALL_STATE(5900)] = 227271,
  [SMALL_STATE(5901)] = 227361,
  [SMALL_STATE(5902)] = 227451,
  [SMALL_STATE(5903)] = 227541,
  [SMALL_STATE(5904)] = 227631,
  [SMALL_STATE(5905)] = 227721,
  [SMALL_STATE(5906)] = 227811,
  [SMALL_STATE(5907)] = 227887,
  [SMALL_STATE(5908)] = 227965,
  [SMALL_STATE(5909)] = 228055,
  [SMALL_STATE(5910)] = 228131,
  [SMALL_STATE(5911)] = 228221,
  [SMALL_STATE(5912)] = 228311,
  [SMALL_STATE(5913)] = 228401,
  [SMALL_STATE(5914)] = 228491,
  [SMALL_STATE(5915)] = 228581,
  [SMALL_STATE(5916)] = 228671,
  [SMALL_STATE(5917)] = 228761,
  [SMALL_STATE(5918)] = 228851,
  [SMALL_STATE(5919)] = 228936,
  [SMALL_STATE(5920)] = 229023,
  [SMALL_STATE(5921)] = 229108,
  [SMALL_STATE(5922)] = 229195,
  [SMALL_STATE(5923)] = 229280,
  [SMALL_STATE(5924)] = 229365,
  [SMALL_STATE(5925)] = 229450,
  [SMALL_STATE(5926)] = 229533,
  [SMALL_STATE(5927)] = 229618,
  [SMALL_STATE(5928)] = 229703,
  [SMALL_STATE(5929)] = 229788,
  [SMALL_STATE(5930)] = 229873,
  [SMALL_STATE(5931)] = 229960,
  [SMALL_STATE(5932)] = 230045,
  [SMALL_STATE(5933)] = 230130,
  [SMALL_STATE(5934)] = 230215,
  [SMALL_STATE(5935)] = 230300,
  [SMALL_STATE(5936)] = 230385,
  [SMALL_STATE(5937)] = 230470,
  [SMALL_STATE(5938)] = 230555,
  [SMALL_STATE(5939)] = 230636,
  [SMALL_STATE(5940)] = 230711,
  [SMALL_STATE(5941)] = 230796,
  [SMALL_STATE(5942)] = 230881,
  [SMALL_STATE(5943)] = 230964,
  [SMALL_STATE(5944)] = 231049,
  [SMALL_STATE(5945)] = 231130,
  [SMALL_STATE(5946)] = 231215,
  [SMALL_STATE(5947)] = 231300,
  [SMALL_STATE(5948)] = 231387,
  [SMALL_STATE(5949)] = 231472,
  [SMALL_STATE(5950)] = 231557,
  [SMALL_STATE(5951)] = 231642,
  [SMALL_STATE(5952)] = 231717,
  [SMALL_STATE(5953)] = 231800,
  [SMALL_STATE(5954)] = 231885,
  [SMALL_STATE(5955)] = 231970,
  [SMALL_STATE(5956)] = 232053,
  [SMALL_STATE(5957)] = 232138,
  [SMALL_STATE(5958)] = 232223,
  [SMALL_STATE(5959)] = 232298,
  [SMALL_STATE(5960)] = 232382,
  [SMALL_STATE(5961)] = 232466,
  [SMALL_STATE(5962)] = 232550,
  [SMALL_STATE(5963)] = 232634,
  [SMALL_STATE(5964)] = 232718,
  [SMALL_STATE(5965)] = 232802,
  [SMALL_STATE(5966)] = 232886,
  [SMALL_STATE(5967)] = 232970,
  [SMALL_STATE(5968)] = 233054,
  [SMALL_STATE(5969)] = 233138,
  [SMALL_STATE(5970)] = 233222,
  [SMALL_STATE(5971)] = 233306,
  [SMALL_STATE(5972)] = 233390,
  [SMALL_STATE(5973)] = 233474,
  [SMALL_STATE(5974)] = 233558,
  [SMALL_STATE(5975)] = 233642,
  [SMALL_STATE(5976)] = 233726,
  [SMALL_STATE(5977)] = 233810,
  [SMALL_STATE(5978)] = 233894,
  [SMALL_STATE(5979)] = 233973,
  [SMALL_STATE(5980)] = 234054,
  [SMALL_STATE(5981)] = 234135,
  [SMALL_STATE(5982)] = 234214,
  [SMALL_STATE(5983)] = 234295,
  [SMALL_STATE(5984)] = 234368,
  [SMALL_STATE(5985)] = 234441,
  [SMALL_STATE(5986)] = 234522,
  [SMALL_STATE(5987)] = 234603,
  [SMALL_STATE(5988)] = 234684,
  [SMALL_STATE(5989)] = 234765,
  [SMALL_STATE(5990)] = 234846,
  [SMALL_STATE(5991)] = 234927,
  [SMALL_STATE(5992)] = 235008,
  [SMALL_STATE(5993)] = 235089,
  [SMALL_STATE(5994)] = 235170,
  [SMALL_STATE(5995)] = 235251,
  [SMALL_STATE(5996)] = 235332,
  [SMALL_STATE(5997)] = 235413,
  [SMALL_STATE(5998)] = 235492,
  [SMALL_STATE(5999)] = 235573,
  [SMALL_STATE(6000)] = 235654,
  [SMALL_STATE(6001)] = 235735,
  [SMALL_STATE(6002)] = 235816,
  [SMALL_STATE(6003)] = 235895,
  [SMALL_STATE(6004)] = 235976,
  [SMALL_STATE(6005)] = 236057,
  [SMALL_STATE(6006)] = 236138,
  [SMALL_STATE(6007)] = 236219,
  [SMALL_STATE(6008)] = 236300,
  [SMALL_STATE(6009)] = 236381,
  [SMALL_STATE(6010)] = 236462,
  [SMALL_STATE(6011)] = 236543,
  [SMALL_STATE(6012)] = 236624,
  [SMALL_STATE(6013)] = 236705,
  [SMALL_STATE(6014)] = 236786,
  [SMALL_STATE(6015)] = 236867,
  [SMALL_STATE(6016)] = 236948,
  [SMALL_STATE(6017)] = 237029,
  [SMALL_STATE(6018)] = 237110,
  [SMALL_STATE(6019)] = 237191,
  [SMALL_STATE(6020)] = 237272,
  [SMALL_STATE(6021)] = 237353,
  [SMALL_STATE(6022)] = 237434,
  [SMALL_STATE(6023)] = 237515,
  [SMALL_STATE(6024)] = 237596,
  [SMALL_STATE(6025)] = 237677,
  [SMALL_STATE(6026)] = 237758,
  [SMALL_STATE(6027)] = 237839,
  [SMALL_STATE(6028)] = 237920,
  [SMALL_STATE(6029)] = 238001,
  [SMALL_STATE(6030)] = 238082,
  [SMALL_STATE(6031)] = 238155,
  [SMALL_STATE(6032)] = 238236,
  [SMALL_STATE(6033)] = 238317,
  [SMALL_STATE(6034)] = 238398,
  [SMALL_STATE(6035)] = 238479,
  [SMALL_STATE(6036)] = 238560,
  [SMALL_STATE(6037)] = 238641,
  [SMALL_STATE(6038)] = 238722,
  [SMALL_STATE(6039)] = 238803,
  [SMALL_STATE(6040)] = 238876,
  [SMALL_STATE(6041)] = 238957,
  [SMALL_STATE(6042)] = 239038,
  [SMALL_STATE(6043)] = 239119,
  [SMALL_STATE(6044)] = 239200,
  [SMALL_STATE(6045)] = 239281,
  [SMALL_STATE(6046)] = 239362,
  [SMALL_STATE(6047)] = 239443,
  [SMALL_STATE(6048)] = 239524,
  [SMALL_STATE(6049)] = 239605,
  [SMALL_STATE(6050)] = 239686,
  [SMALL_STATE(6051)] = 239767,
  [SMALL_STATE(6052)] = 239848,
  [SMALL_STATE(6053)] = 239929,
  [SMALL_STATE(6054)] = 240010,
  [SMALL_STATE(6055)] = 240091,
  [SMALL_STATE(6056)] = 240172,
  [SMALL_STATE(6057)] = 240253,
  [SMALL_STATE(6058)] = 240334,
  [SMALL_STATE(6059)] = 240415,
  [SMALL_STATE(6060)] = 240496,
  [SMALL_STATE(6061)] = 240577,
  [SMALL_STATE(6062)] = 240658,
  [SMALL_STATE(6063)] = 240739,
  [SMALL_STATE(6064)] = 240820,
  [SMALL_STATE(6065)] = 240899,
  [SMALL_STATE(6066)] = 240980,
  [SMALL_STATE(6067)] = 241061,
  [SMALL_STATE(6068)] = 241140,
  [SMALL_STATE(6069)] = 241221,
  [SMALL_STATE(6070)] = 241302,
  [SMALL_STATE(6071)] = 241383,
  [SMALL_STATE(6072)] = 241464,
  [SMALL_STATE(6073)] = 241543,
  [SMALL_STATE(6074)] = 241624,
  [SMALL_STATE(6075)] = 241705,
  [SMALL_STATE(6076)] = 241786,
  [SMALL_STATE(6077)] = 241859,
  [SMALL_STATE(6078)] = 241940,
  [SMALL_STATE(6079)] = 242021,
  [SMALL_STATE(6080)] = 242102,
  [SMALL_STATE(6081)] = 242183,
  [SMALL_STATE(6082)] = 242264,
  [SMALL_STATE(6083)] = 242345,
  [SMALL_STATE(6084)] = 242426,
  [SMALL_STATE(6085)] = 242507,
  [SMALL_STATE(6086)] = 242580,
  [SMALL_STATE(6087)] = 242661,
  [SMALL_STATE(6088)] = 242742,
  [SMALL_STATE(6089)] = 242823,
  [SMALL_STATE(6090)] = 242904,
  [SMALL_STATE(6091)] = 242985,
  [SMALL_STATE(6092)] = 243066,
  [SMALL_STATE(6093)] = 243147,
  [SMALL_STATE(6094)] = 243228,
  [SMALL_STATE(6095)] = 243309,
  [SMALL_STATE(6096)] = 243390,
  [SMALL_STATE(6097)] = 243471,
  [SMALL_STATE(6098)] = 243552,
  [SMALL_STATE(6099)] = 243633,
  [SMALL_STATE(6100)] = 243714,
  [SMALL_STATE(6101)] = 243789,
  [SMALL_STATE(6102)] = 243870,
  [SMALL_STATE(6103)] = 243951,
  [SMALL_STATE(6104)] = 244032,
  [SMALL_STATE(6105)] = 244113,
  [SMALL_STATE(6106)] = 244194,
  [SMALL_STATE(6107)] = 244275,
  [SMALL_STATE(6108)] = 244356,
  [SMALL_STATE(6109)] = 244437,
  [SMALL_STATE(6110)] = 244518,
  [SMALL_STATE(6111)] = 244599,
  [SMALL_STATE(6112)] = 244680,
  [SMALL_STATE(6113)] = 244761,
  [SMALL_STATE(6114)] = 244840,
  [SMALL_STATE(6115)] = 244921,
  [SMALL_STATE(6116)] = 245002,
  [SMALL_STATE(6117)] = 245083,
  [SMALL_STATE(6118)] = 245164,
  [SMALL_STATE(6119)] = 245238,
  [SMALL_STATE(6120)] = 245316,
  [SMALL_STATE(6121)] = 245388,
  [SMALL_STATE(6122)] = 245466,
  [SMALL_STATE(6123)] = 245544,
  [SMALL_STATE(6124)] = 245622,
  [SMALL_STATE(6125)] = 245700,
  [SMALL_STATE(6126)] = 245775,
  [SMALL_STATE(6127)] = 245850,
  [SMALL_STATE(6128)] = 245925,
  [SMALL_STATE(6129)] = 246000,
  [SMALL_STATE(6130)] = 246075,
  [SMALL_STATE(6131)] = 246150,
  [SMALL_STATE(6132)] = 246225,
  [SMALL_STATE(6133)] = 246300,
  [SMALL_STATE(6134)] = 246375,
  [SMALL_STATE(6135)] = 246450,
  [SMALL_STATE(6136)] = 246525,
  [SMALL_STATE(6137)] = 246600,
  [SMALL_STATE(6138)] = 246675,
  [SMALL_STATE(6139)] = 246750,
  [SMALL_STATE(6140)] = 246825,
  [SMALL_STATE(6141)] = 246900,
  [SMALL_STATE(6142)] = 246975,
  [SMALL_STATE(6143)] = 247050,
  [SMALL_STATE(6144)] = 247125,
  [SMALL_STATE(6145)] = 247200,
  [SMALL_STATE(6146)] = 247275,
  [SMALL_STATE(6147)] = 247350,
  [SMALL_STATE(6148)] = 247425,
  [SMALL_STATE(6149)] = 247500,
  [SMALL_STATE(6150)] = 247575,
  [SMALL_STATE(6151)] = 247650,
  [SMALL_STATE(6152)] = 247725,
  [SMALL_STATE(6153)] = 247800,
  [SMALL_STATE(6154)] = 247875,
  [SMALL_STATE(6155)] = 247950,
  [SMALL_STATE(6156)] = 248025,
  [SMALL_STATE(6157)] = 248100,
  [SMALL_STATE(6158)] = 248175,
  [SMALL_STATE(6159)] = 248250,
  [SMALL_STATE(6160)] = 248325,
  [SMALL_STATE(6161)] = 248400,
  [SMALL_STATE(6162)] = 248475,
  [SMALL_STATE(6163)] = 248550,
  [SMALL_STATE(6164)] = 248625,
  [SMALL_STATE(6165)] = 248700,
  [SMALL_STATE(6166)] = 248775,
  [SMALL_STATE(6167)] = 248850,
  [SMALL_STATE(6168)] = 248925,
  [SMALL_STATE(6169)] = 248994,
  [SMALL_STATE(6170)] = 249069,
  [SMALL_STATE(6171)] = 249144,
  [SMALL_STATE(6172)] = 249219,
  [SMALL_STATE(6173)] = 249294,
  [SMALL_STATE(6174)] = 249369,
  [SMALL_STATE(6175)] = 249444,
  [SMALL_STATE(6176)] = 249519,
  [SMALL_STATE(6177)] = 249594,
  [SMALL_STATE(6178)] = 249669,
  [SMALL_STATE(6179)] = 249744,
  [SMALL_STATE(6180)] = 249819,
  [SMALL_STATE(6181)] = 249894,
  [SMALL_STATE(6182)] = 249969,
  [SMALL_STATE(6183)] = 250044,
  [SMALL_STATE(6184)] = 250119,
  [SMALL_STATE(6185)] = 250194,
  [SMALL_STATE(6186)] = 250269,
  [SMALL_STATE(6187)] = 250341,
  [SMALL_STATE(6188)] = 250413,
  [SMALL_STATE(6189)] = 250485,
  [SMALL_STATE(6190)] = 250557,
  [SMALL_STATE(6191)] = 250629,
  [SMALL_STATE(6192)] = 250701,
  [SMALL_STATE(6193)] = 250770,
  [SMALL_STATE(6194)] = 250839,
  [SMALL_STATE(6195)] = 250908,
  [SMALL_STATE(6196)] = 250977,
  [SMALL_STATE(6197)] = 251044,
  [SMALL_STATE(6198)] = 251113,
  [SMALL_STATE(6199)] = 251182,
  [SMALL_STATE(6200)] = 251268,
  [SMALL_STATE(6201)] = 251354,
  [SMALL_STATE(6202)] = 251440,
  [SMALL_STATE(6203)] = 251526,
  [SMALL_STATE(6204)] = 251612,
  [SMALL_STATE(6205)] = 251698,
  [SMALL_STATE(6206)] = 251784,
  [SMALL_STATE(6207)] = 251870,
  [SMALL_STATE(6208)] = 251956,
  [SMALL_STATE(6209)] = 252042,
  [SMALL_STATE(6210)] = 252128,
  [SMALL_STATE(6211)] = 252214,
  [SMALL_STATE(6212)] = 252300,
  [SMALL_STATE(6213)] = 252386,
  [SMALL_STATE(6214)] = 252472,
  [SMALL_STATE(6215)] = 252558,
  [SMALL_STATE(6216)] = 252644,
  [SMALL_STATE(6217)] = 252730,
  [SMALL_STATE(6218)] = 252816,
  [SMALL_STATE(6219)] = 252902,
  [SMALL_STATE(6220)] = 252988,
  [SMALL_STATE(6221)] = 253074,
  [SMALL_STATE(6222)] = 253160,
  [SMALL_STATE(6223)] = 253246,
  [SMALL_STATE(6224)] = 253332,
  [SMALL_STATE(6225)] = 253418,
  [SMALL_STATE(6226)] = 253504,
  [SMALL_STATE(6227)] = 253590,
  [SMALL_STATE(6228)] = 253676,
  [SMALL_STATE(6229)] = 253762,
  [SMALL_STATE(6230)] = 253848,
  [SMALL_STATE(6231)] = 253934,
  [SMALL_STATE(6232)] = 254020,
  [SMALL_STATE(6233)] = 254106,
  [SMALL_STATE(6234)] = 254192,
  [SMALL_STATE(6235)] = 254278,
  [SMALL_STATE(6236)] = 254364,
  [SMALL_STATE(6237)] = 254450,
  [SMALL_STATE(6238)] = 254536,
  [SMALL_STATE(6239)] = 254622,
  [SMALL_STATE(6240)] = 254705,
  [SMALL_STATE(6241)] = 254788,
  [SMALL_STATE(6242)] = 254871,
  [SMALL_STATE(6243)] = 254954,
  [SMALL_STATE(6244)] = 255037,
  [SMALL_STATE(6245)] = 255120,
  [SMALL_STATE(6246)] = 255203,
  [SMALL_STATE(6247)] = 255286,
  [SMALL_STATE(6248)] = 255369,
  [SMALL_STATE(6249)] = 255452,
  [SMALL_STATE(6250)] = 255535,
  [SMALL_STATE(6251)] = 255618,
  [SMALL_STATE(6252)] = 255701,
  [SMALL_STATE(6253)] = 255784,
  [SMALL_STATE(6254)] = 255867,
  [SMALL_STATE(6255)] = 255950,
  [SMALL_STATE(6256)] = 256033,
  [SMALL_STATE(6257)] = 256116,
  [SMALL_STATE(6258)] = 256199,
  [SMALL_STATE(6259)] = 256282,
  [SMALL_STATE(6260)] = 256365,
  [SMALL_STATE(6261)] = 256448,
  [SMALL_STATE(6262)] = 256531,
  [SMALL_STATE(6263)] = 256614,
  [SMALL_STATE(6264)] = 256697,
  [SMALL_STATE(6265)] = 256780,
  [SMALL_STATE(6266)] = 256863,
  [SMALL_STATE(6267)] = 256946,
  [SMALL_STATE(6268)] = 257029,
  [SMALL_STATE(6269)] = 257112,
  [SMALL_STATE(6270)] = 257195,
  [SMALL_STATE(6271)] = 257278,
  [SMALL_STATE(6272)] = 257361,
  [SMALL_STATE(6273)] = 257444,
  [SMALL_STATE(6274)] = 257527,
  [SMALL_STATE(6275)] = 257610,
  [SMALL_STATE(6276)] = 257693,
  [SMALL_STATE(6277)] = 257776,
  [SMALL_STATE(6278)] = 257859,
  [SMALL_STATE(6279)] = 257942,
  [SMALL_STATE(6280)] = 258025,
  [SMALL_STATE(6281)] = 258108,
  [SMALL_STATE(6282)] = 258191,
  [SMALL_STATE(6283)] = 258274,
  [SMALL_STATE(6284)] = 258357,
  [SMALL_STATE(6285)] = 258440,
  [SMALL_STATE(6286)] = 258523,
  [SMALL_STATE(6287)] = 258606,
  [SMALL_STATE(6288)] = 258689,
  [SMALL_STATE(6289)] = 258772,
  [SMALL_STATE(6290)] = 258855,
  [SMALL_STATE(6291)] = 258938,
  [SMALL_STATE(6292)] = 259021,
  [SMALL_STATE(6293)] = 259104,
  [SMALL_STATE(6294)] = 259187,
  [SMALL_STATE(6295)] = 259270,
  [SMALL_STATE(6296)] = 259353,
  [SMALL_STATE(6297)] = 259436,
  [SMALL_STATE(6298)] = 259519,
  [SMALL_STATE(6299)] = 259602,
  [SMALL_STATE(6300)] = 259685,
  [SMALL_STATE(6301)] = 259768,
  [SMALL_STATE(6302)] = 259851,
  [SMALL_STATE(6303)] = 259934,
  [SMALL_STATE(6304)] = 260017,
  [SMALL_STATE(6305)] = 260100,
  [SMALL_STATE(6306)] = 260188,
  [SMALL_STATE(6307)] = 260276,
  [SMALL_STATE(6308)] = 260364,
  [SMALL_STATE(6309)] = 260436,
  [SMALL_STATE(6310)] = 260501,
  [SMALL_STATE(6311)] = 260573,
  [SMALL_STATE(6312)] = 260645,
  [SMALL_STATE(6313)] = 260719,
  [SMALL_STATE(6314)] = 260791,
  [SMALL_STATE(6315)] = 260863,
  [SMALL_STATE(6316)] = 260937,
  [SMALL_STATE(6317)] = 261009,
  [SMALL_STATE(6318)] = 261081,
  [SMALL_STATE(6319)] = 261155,
  [SMALL_STATE(6320)] = 261229,
  [SMALL_STATE(6321)] = 261303,
  [SMALL_STATE(6322)] = 261375,
  [SMALL_STATE(6323)] = 261447,
  [SMALL_STATE(6324)] = 261519,
  [SMALL_STATE(6325)] = 261591,
  [SMALL_STATE(6326)] = 261651,
  [SMALL_STATE(6327)] = 261723,
  [SMALL_STATE(6328)] = 261797,
  [SMALL_STATE(6329)] = 261869,
  [SMALL_STATE(6330)] = 261941,
  [SMALL_STATE(6331)] = 262015,
  [SMALL_STATE(6332)] = 262089,
  [SMALL_STATE(6333)] = 262161,
  [SMALL_STATE(6334)] = 262221,
  [SMALL_STATE(6335)] = 262296,
  [SMALL_STATE(6336)] = 262353,
  [SMALL_STATE(6337)] = 262416,
  [SMALL_STATE(6338)] = 262491,
  [SMALL_STATE(6339)] = 262566,
  [SMALL_STATE(6340)] = 262628,
  [SMALL_STATE(6341)] = 262690,
  [SMALL_STATE(6342)] = 262760,
  [SMALL_STATE(6343)] = 262817,
  [SMALL_STATE(6344)] = 262886,
  [SMALL_STATE(6345)] = 262943,
  [SMALL_STATE(6346)] = 263004,
  [SMALL_STATE(6347)] = 263061,
  [SMALL_STATE(6348)] = 263128,
  [SMALL_STATE(6349)] = 263195,
  [SMALL_STATE(6350)] = 263264,
  [SMALL_STATE(6351)] = 263333,
  [SMALL_STATE(6352)] = 263388,
  [SMALL_STATE(6353)] = 263457,
  [SMALL_STATE(6354)] = 263526,
  [SMALL_STATE(6355)] = 263595,
  [SMALL_STATE(6356)] = 263664,
  [SMALL_STATE(6357)] = 263725,
  [SMALL_STATE(6358)] = 263794,
  [SMALL_STATE(6359)] = 263863,
  [SMALL_STATE(6360)] = 263932,
  [SMALL_STATE(6361)] = 264001,
  [SMALL_STATE(6362)] = 264060,
  [SMALL_STATE(6363)] = 264129,
  [SMALL_STATE(6364)] = 264198,
  [SMALL_STATE(6365)] = 264267,
  [SMALL_STATE(6366)] = 264336,
  [SMALL_STATE(6367)] = 264405,
  [SMALL_STATE(6368)] = 264474,
  [SMALL_STATE(6369)] = 264543,
  [SMALL_STATE(6370)] = 264612,
  [SMALL_STATE(6371)] = 264681,
  [SMALL_STATE(6372)] = 264750,
  [SMALL_STATE(6373)] = 264817,
  [SMALL_STATE(6374)] = 264886,
  [SMALL_STATE(6375)] = 264955,
  [SMALL_STATE(6376)] = 265024,
  [SMALL_STATE(6377)] = 265093,
  [SMALL_STATE(6378)] = 265162,
  [SMALL_STATE(6379)] = 265229,
  [SMALL_STATE(6380)] = 265298,
  [SMALL_STATE(6381)] = 265367,
  [SMALL_STATE(6382)] = 265436,
  [SMALL_STATE(6383)] = 265505,
  [SMALL_STATE(6384)] = 265574,
  [SMALL_STATE(6385)] = 265643,
  [SMALL_STATE(6386)] = 265700,
  [SMALL_STATE(6387)] = 265752,
  [SMALL_STATE(6388)] = 265818,
  [SMALL_STATE(6389)] = 265880,
  [SMALL_STATE(6390)] = 265934,
  [SMALL_STATE(6391)] = 266000,
  [SMALL_STATE(6392)] = 266052,
  [SMALL_STATE(6393)] = 266118,
  [SMALL_STATE(6394)] = 266174,
  [SMALL_STATE(6395)] = 266230,
  [SMALL_STATE(6396)] = 266284,
  [SMALL_STATE(6397)] = 266340,
  [SMALL_STATE(6398)] = 266396,
  [SMALL_STATE(6399)] = 266457,
  [SMALL_STATE(6400)] = 266508,
  [SMALL_STATE(6401)] = 266559,
  [SMALL_STATE(6402)] = 266620,
  [SMALL_STATE(6403)] = 266671,
  [SMALL_STATE(6404)] = 266732,
  [SMALL_STATE(6405)] = 266783,
  [SMALL_STATE(6406)] = 266844,
  [SMALL_STATE(6407)] = 266905,
  [SMALL_STATE(6408)] = 266966,
  [SMALL_STATE(6409)] = 267027,
  [SMALL_STATE(6410)] = 267088,
  [SMALL_STATE(6411)] = 267149,
  [SMALL_STATE(6412)] = 267210,
  [SMALL_STATE(6413)] = 267271,
  [SMALL_STATE(6414)] = 267322,
  [SMALL_STATE(6415)] = 267383,
  [SMALL_STATE(6416)] = 267442,
  [SMALL_STATE(6417)] = 267503,
  [SMALL_STATE(6418)] = 267564,
  [SMALL_STATE(6419)] = 267625,
  [SMALL_STATE(6420)] = 267686,
  [SMALL_STATE(6421)] = 267747,
  [SMALL_STATE(6422)] = 267808,
  [SMALL_STATE(6423)] = 267869,
  [SMALL_STATE(6424)] = 267930,
  [SMALL_STATE(6425)] = 267981,
  [SMALL_STATE(6426)] = 268042,
  [SMALL_STATE(6427)] = 268093,
  [SMALL_STATE(6428)] = 268144,
  [SMALL_STATE(6429)] = 268205,
  [SMALL_STATE(6430)] = 268266,
  [SMALL_STATE(6431)] = 268317,
  [SMALL_STATE(6432)] = 268378,
  [SMALL_STATE(6433)] = 268439,
  [SMALL_STATE(6434)] = 268500,
  [SMALL_STATE(6435)] = 268559,
  [SMALL_STATE(6436)] = 268620,
  [SMALL_STATE(6437)] = 268681,
  [SMALL_STATE(6438)] = 268732,
  [SMALL_STATE(6439)] = 268793,
  [SMALL_STATE(6440)] = 268853,
  [SMALL_STATE(6441)] = 268907,
  [SMALL_STATE(6442)] = 268967,
  [SMALL_STATE(6443)] = 269027,
  [SMALL_STATE(6444)] = 269087,
  [SMALL_STATE(6445)] = 269137,
  [SMALL_STATE(6446)] = 269197,
  [SMALL_STATE(6447)] = 269253,
  [SMALL_STATE(6448)] = 269305,
  [SMALL_STATE(6449)] = 269363,
  [SMALL_STATE(6450)] = 269413,
  [SMALL_STATE(6451)] = 269473,
  [SMALL_STATE(6452)] = 269533,
  [SMALL_STATE(6453)] = 269593,
  [SMALL_STATE(6454)] = 269653,
  [SMALL_STATE(6455)] = 269713,
  [SMALL_STATE(6456)] = 269763,
  [SMALL_STATE(6457)] = 269823,
  [SMALL_STATE(6458)] = 269881,
  [SMALL_STATE(6459)] = 269941,
  [SMALL_STATE(6460)] = 270001,
  [SMALL_STATE(6461)] = 270061,
  [SMALL_STATE(6462)] = 270121,
  [SMALL_STATE(6463)] = 270181,
  [SMALL_STATE(6464)] = 270241,
  [SMALL_STATE(6465)] = 270301,
  [SMALL_STATE(6466)] = 270361,
  [SMALL_STATE(6467)] = 270421,
  [SMALL_STATE(6468)] = 270479,
  [SMALL_STATE(6469)] = 270535,
  [SMALL_STATE(6470)] = 270585,
  [SMALL_STATE(6471)] = 270635,
  [SMALL_STATE(6472)] = 270695,
  [SMALL_STATE(6473)] = 270749,
  [SMALL_STATE(6474)] = 270809,
  [SMALL_STATE(6475)] = 270869,
  [SMALL_STATE(6476)] = 270929,
  [SMALL_STATE(6477)] = 270989,
  [SMALL_STATE(6478)] = 271049,
  [SMALL_STATE(6479)] = 271109,
  [SMALL_STATE(6480)] = 271169,
  [SMALL_STATE(6481)] = 271229,
  [SMALL_STATE(6482)] = 271281,
  [SMALL_STATE(6483)] = 271341,
  [SMALL_STATE(6484)] = 271393,
  [SMALL_STATE(6485)] = 271443,
  [SMALL_STATE(6486)] = 271503,
  [SMALL_STATE(6487)] = 271563,
  [SMALL_STATE(6488)] = 271623,
  [SMALL_STATE(6489)] = 271683,
  [SMALL_STATE(6490)] = 271743,
  [SMALL_STATE(6491)] = 271797,
  [SMALL_STATE(6492)] = 271857,
  [SMALL_STATE(6493)] = 271915,
  [SMALL_STATE(6494)] = 271969,
  [SMALL_STATE(6495)] = 272029,
  [SMALL_STATE(6496)] = 272089,
  [SMALL_STATE(6497)] = 272149,
  [SMALL_STATE(6498)] = 272209,
  [SMALL_STATE(6499)] = 272269,
  [SMALL_STATE(6500)] = 272329,
  [SMALL_STATE(6501)] = 272389,
  [SMALL_STATE(6502)] = 272449,
  [SMALL_STATE(6503)] = 272507,
  [SMALL_STATE(6504)] = 272565,
  [SMALL_STATE(6505)] = 272625,
  [SMALL_STATE(6506)] = 272683,
  [SMALL_STATE(6507)] = 272743,
  [SMALL_STATE(6508)] = 272803,
  [SMALL_STATE(6509)] = 272863,
  [SMALL_STATE(6510)] = 272921,
  [SMALL_STATE(6511)] = 272971,
  [SMALL_STATE(6512)] = 273025,
  [SMALL_STATE(6513)] = 273077,
  [SMALL_STATE(6514)] = 273127,
  [SMALL_STATE(6515)] = 273187,
  [SMALL_STATE(6516)] = 273245,
  [SMALL_STATE(6517)] = 273299,
  [SMALL_STATE(6518)] = 273359,
  [SMALL_STATE(6519)] = 273419,
  [SMALL_STATE(6520)] = 273471,
  [SMALL_STATE(6521)] = 273525,
  [SMALL_STATE(6522)] = 273583,
  [SMALL_STATE(6523)] = 273643,
  [SMALL_STATE(6524)] = 273692,
  [SMALL_STATE(6525)] = 273747,
  [SMALL_STATE(6526)] = 273802,
  [SMALL_STATE(6527)] = 273857,
  [SMALL_STATE(6528)] = 273914,
  [SMALL_STATE(6529)] = 273969,
  [SMALL_STATE(6530)] = 274024,
  [SMALL_STATE(6531)] = 274079,
  [SMALL_STATE(6532)] = 274134,
  [SMALL_STATE(6533)] = 274189,
  [SMALL_STATE(6534)] = 274244,
  [SMALL_STATE(6535)] = 274297,
  [SMALL_STATE(6536)] = 274352,
  [SMALL_STATE(6537)] = 274407,
  [SMALL_STATE(6538)] = 274462,
  [SMALL_STATE(6539)] = 274517,
  [SMALL_STATE(6540)] = 274572,
  [SMALL_STATE(6541)] = 274627,
  [SMALL_STATE(6542)] = 274678,
  [SMALL_STATE(6543)] = 274735,
  [SMALL_STATE(6544)] = 274790,
  [SMALL_STATE(6545)] = 274845,
  [SMALL_STATE(6546)] = 274900,
  [SMALL_STATE(6547)] = 274955,
  [SMALL_STATE(6548)] = 275012,
  [SMALL_STATE(6549)] = 275061,
  [SMALL_STATE(6550)] = 275118,
  [SMALL_STATE(6551)] = 275173,
  [SMALL_STATE(6552)] = 275228,
  [SMALL_STATE(6553)] = 275283,
  [SMALL_STATE(6554)] = 275338,
  [SMALL_STATE(6555)] = 275393,
  [SMALL_STATE(6556)] = 275448,
  [SMALL_STATE(6557)] = 275501,
  [SMALL_STATE(6558)] = 275556,
  [SMALL_STATE(6559)] = 275611,
  [SMALL_STATE(6560)] = 275666,
  [SMALL_STATE(6561)] = 275717,
  [SMALL_STATE(6562)] = 275772,
  [SMALL_STATE(6563)] = 275827,
  [SMALL_STATE(6564)] = 275882,
  [SMALL_STATE(6565)] = 275937,
  [SMALL_STATE(6566)] = 275994,
  [SMALL_STATE(6567)] = 276049,
  [SMALL_STATE(6568)] = 276098,
  [SMALL_STATE(6569)] = 276153,
  [SMALL_STATE(6570)] = 276208,
  [SMALL_STATE(6571)] = 276263,
  [SMALL_STATE(6572)] = 276318,
  [SMALL_STATE(6573)] = 276375,
  [SMALL_STATE(6574)] = 276430,
  [SMALL_STATE(6575)] = 276487,
  [SMALL_STATE(6576)] = 276536,
  [SMALL_STATE(6577)] = 276591,
  [SMALL_STATE(6578)] = 276648,
  [SMALL_STATE(6579)] = 276697,
  [SMALL_STATE(6580)] = 276746,
  [SMALL_STATE(6581)] = 276801,
  [SMALL_STATE(6582)] = 276858,
  [SMALL_STATE(6583)] = 276913,
  [SMALL_STATE(6584)] = 276970,
  [SMALL_STATE(6585)] = 277027,
  [SMALL_STATE(6586)] = 277084,
  [SMALL_STATE(6587)] = 277141,
  [SMALL_STATE(6588)] = 277196,
  [SMALL_STATE(6589)] = 277251,
  [SMALL_STATE(6590)] = 277308,
  [SMALL_STATE(6591)] = 277363,
  [SMALL_STATE(6592)] = 277414,
  [SMALL_STATE(6593)] = 277465,
  [SMALL_STATE(6594)] = 277516,
  [SMALL_STATE(6595)] = 277571,
  [SMALL_STATE(6596)] = 277628,
  [SMALL_STATE(6597)] = 277677,
  [SMALL_STATE(6598)] = 277734,
  [SMALL_STATE(6599)] = 277791,
  [SMALL_STATE(6600)] = 277842,
  [SMALL_STATE(6601)] = 277897,
  [SMALL_STATE(6602)] = 277948,
  [SMALL_STATE(6603)] = 278001,
  [SMALL_STATE(6604)] = 278056,
  [SMALL_STATE(6605)] = 278111,
  [SMALL_STATE(6606)] = 278162,
  [SMALL_STATE(6607)] = 278217,
  [SMALL_STATE(6608)] = 278272,
  [SMALL_STATE(6609)] = 278327,
  [SMALL_STATE(6610)] = 278382,
  [SMALL_STATE(6611)] = 278437,
  [SMALL_STATE(6612)] = 278492,
  [SMALL_STATE(6613)] = 278547,
  [SMALL_STATE(6614)] = 278596,
  [SMALL_STATE(6615)] = 278653,
  [SMALL_STATE(6616)] = 278708,
  [SMALL_STATE(6617)] = 278763,
  [SMALL_STATE(6618)] = 278818,
  [SMALL_STATE(6619)] = 278869,
  [SMALL_STATE(6620)] = 278924,
  [SMALL_STATE(6621)] = 278981,
  [SMALL_STATE(6622)] = 279036,
  [SMALL_STATE(6623)] = 279091,
  [SMALL_STATE(6624)] = 279146,
  [SMALL_STATE(6625)] = 279201,
  [SMALL_STATE(6626)] = 279256,
  [SMALL_STATE(6627)] = 279313,
  [SMALL_STATE(6628)] = 279368,
  [SMALL_STATE(6629)] = 279425,
  [SMALL_STATE(6630)] = 279480,
  [SMALL_STATE(6631)] = 279537,
  [SMALL_STATE(6632)] = 279592,
  [SMALL_STATE(6633)] = 279647,
  [SMALL_STATE(6634)] = 279702,
  [SMALL_STATE(6635)] = 279755,
  [SMALL_STATE(6636)] = 279810,
  [SMALL_STATE(6637)] = 279865,
  [SMALL_STATE(6638)] = 279920,
  [SMALL_STATE(6639)] = 279977,
  [SMALL_STATE(6640)] = 280032,
  [SMALL_STATE(6641)] = 280085,
  [SMALL_STATE(6642)] = 280140,
  [SMALL_STATE(6643)] = 280197,
  [SMALL_STATE(6644)] = 280252,
  [SMALL_STATE(6645)] = 280309,
  [SMALL_STATE(6646)] = 280366,
  [SMALL_STATE(6647)] = 280423,
  [SMALL_STATE(6648)] = 280480,
  [SMALL_STATE(6649)] = 280531,
  [SMALL_STATE(6650)] = 280584,
  [SMALL_STATE(6651)] = 280639,
  [SMALL_STATE(6652)] = 280692,
  [SMALL_STATE(6653)] = 280747,
  [SMALL_STATE(6654)] = 280800,
  [SMALL_STATE(6655)] = 280853,
  [SMALL_STATE(6656)] = 280908,
  [SMALL_STATE(6657)] = 280965,
  [SMALL_STATE(6658)] = 281020,
  [SMALL_STATE(6659)] = 281073,
  [SMALL_STATE(6660)] = 281126,
  [SMALL_STATE(6661)] = 281177,
  [SMALL_STATE(6662)] = 281232,
  [SMALL_STATE(6663)] = 281287,
  [SMALL_STATE(6664)] = 281342,
  [SMALL_STATE(6665)] = 281397,
  [SMALL_STATE(6666)] = 281452,
  [SMALL_STATE(6667)] = 281507,
  [SMALL_STATE(6668)] = 281562,
  [SMALL_STATE(6669)] = 281617,
  [SMALL_STATE(6670)] = 281674,
  [SMALL_STATE(6671)] = 281729,
  [SMALL_STATE(6672)] = 281784,
  [SMALL_STATE(6673)] = 281839,
  [SMALL_STATE(6674)] = 281896,
  [SMALL_STATE(6675)] = 281951,
  [SMALL_STATE(6676)] = 282006,
  [SMALL_STATE(6677)] = 282061,
  [SMALL_STATE(6678)] = 282116,
  [SMALL_STATE(6679)] = 282165,
  [SMALL_STATE(6680)] = 282222,
  [SMALL_STATE(6681)] = 282279,
  [SMALL_STATE(6682)] = 282334,
  [SMALL_STATE(6683)] = 282389,
  [SMALL_STATE(6684)] = 282446,
  [SMALL_STATE(6685)] = 282501,
  [SMALL_STATE(6686)] = 282556,
  [SMALL_STATE(6687)] = 282611,
  [SMALL_STATE(6688)] = 282666,
  [SMALL_STATE(6689)] = 282721,
  [SMALL_STATE(6690)] = 282776,
  [SMALL_STATE(6691)] = 282833,
  [SMALL_STATE(6692)] = 282885,
  [SMALL_STATE(6693)] = 282939,
  [SMALL_STATE(6694)] = 282993,
  [SMALL_STATE(6695)] = 283041,
  [SMALL_STATE(6696)] = 283095,
  [SMALL_STATE(6697)] = 283143,
  [SMALL_STATE(6698)] = 283195,
  [SMALL_STATE(6699)] = 283247,
  [SMALL_STATE(6700)] = 283301,
  [SMALL_STATE(6701)] = 283355,
  [SMALL_STATE(6702)] = 283405,
  [SMALL_STATE(6703)] = 283455,
  [SMALL_STATE(6704)] = 283503,
  [SMALL_STATE(6705)] = 283551,
  [SMALL_STATE(6706)] = 283605,
  [SMALL_STATE(6707)] = 283659,
  [SMALL_STATE(6708)] = 283713,
  [SMALL_STATE(6709)] = 283765,
  [SMALL_STATE(6710)] = 283813,
  [SMALL_STATE(6711)] = 283867,
  [SMALL_STATE(6712)] = 283921,
  [SMALL_STATE(6713)] = 283969,
  [SMALL_STATE(6714)] = 284023,
  [SMALL_STATE(6715)] = 284073,
  [SMALL_STATE(6716)] = 284123,
  [SMALL_STATE(6717)] = 284171,
  [SMALL_STATE(6718)] = 284225,
  [SMALL_STATE(6719)] = 284279,
  [SMALL_STATE(6720)] = 284331,
  [SMALL_STATE(6721)] = 284385,
  [SMALL_STATE(6722)] = 284439,
  [SMALL_STATE(6723)] = 284487,
  [SMALL_STATE(6724)] = 284539,
  [SMALL_STATE(6725)] = 284593,
  [SMALL_STATE(6726)] = 284645,
  [SMALL_STATE(6727)] = 284699,
  [SMALL_STATE(6728)] = 284753,
  [SMALL_STATE(6729)] = 284803,
  [SMALL_STATE(6730)] = 284857,
  [SMALL_STATE(6731)] = 284911,
  [SMALL_STATE(6732)] = 284965,
  [SMALL_STATE(6733)] = 285019,
  [SMALL_STATE(6734)] = 285071,
  [SMALL_STATE(6735)] = 285121,
  [SMALL_STATE(6736)] = 285175,
  [SMALL_STATE(6737)] = 285229,
  [SMALL_STATE(6738)] = 285281,
  [SMALL_STATE(6739)] = 285329,
  [SMALL_STATE(6740)] = 285383,
  [SMALL_STATE(6741)] = 285437,
  [SMALL_STATE(6742)] = 285491,
  [SMALL_STATE(6743)] = 285541,
  [SMALL_STATE(6744)] = 285589,
  [SMALL_STATE(6745)] = 285639,
  [SMALL_STATE(6746)] = 285693,
  [SMALL_STATE(6747)] = 285747,
  [SMALL_STATE(6748)] = 285801,
  [SMALL_STATE(6749)] = 285855,
  [SMALL_STATE(6750)] = 285909,
  [SMALL_STATE(6751)] = 285963,
  [SMALL_STATE(6752)] = 286015,
  [SMALL_STATE(6753)] = 286065,
  [SMALL_STATE(6754)] = 286119,
  [SMALL_STATE(6755)] = 286167,
  [SMALL_STATE(6756)] = 286221,
  [SMALL_STATE(6757)] = 286269,
  [SMALL_STATE(6758)] = 286323,
  [SMALL_STATE(6759)] = 286377,
  [SMALL_STATE(6760)] = 286431,
  [SMALL_STATE(6761)] = 286485,
  [SMALL_STATE(6762)] = 286535,
  [SMALL_STATE(6763)] = 286589,
  [SMALL_STATE(6764)] = 286639,
  [SMALL_STATE(6765)] = 286687,
  [SMALL_STATE(6766)] = 286739,
  [SMALL_STATE(6767)] = 286791,
  [SMALL_STATE(6768)] = 286845,
  [SMALL_STATE(6769)] = 286893,
  [SMALL_STATE(6770)] = 286943,
  [SMALL_STATE(6771)] = 286993,
  [SMALL_STATE(6772)] = 287047,
  [SMALL_STATE(6773)] = 287097,
  [SMALL_STATE(6774)] = 287147,
  [SMALL_STATE(6775)] = 287199,
  [SMALL_STATE(6776)] = 287251,
  [SMALL_STATE(6777)] = 287301,
  [SMALL_STATE(6778)] = 287349,
  [SMALL_STATE(6779)] = 287403,
  [SMALL_STATE(6780)] = 287457,
  [SMALL_STATE(6781)] = 287509,
  [SMALL_STATE(6782)] = 287557,
  [SMALL_STATE(6783)] = 287611,
  [SMALL_STATE(6784)] = 287665,
  [SMALL_STATE(6785)] = 287713,
  [SMALL_STATE(6786)] = 287767,
  [SMALL_STATE(6787)] = 287815,
  [SMALL_STATE(6788)] = 287865,
  [SMALL_STATE(6789)] = 287915,
  [SMALL_STATE(6790)] = 287967,
  [SMALL_STATE(6791)] = 288015,
  [SMALL_STATE(6792)] = 288063,
  [SMALL_STATE(6793)] = 288111,
  [SMALL_STATE(6794)] = 288163,
  [SMALL_STATE(6795)] = 288217,
  [SMALL_STATE(6796)] = 288271,
  [SMALL_STATE(6797)] = 288320,
  [SMALL_STATE(6798)] = 288369,
  [SMALL_STATE(6799)] = 288418,
  [SMALL_STATE(6800)] = 288469,
  [SMALL_STATE(6801)] = 288520,
  [SMALL_STATE(6802)] = 288571,
  [SMALL_STATE(6803)] = 288622,
  [SMALL_STATE(6804)] = 288673,
  [SMALL_STATE(6805)] = 288722,
  [SMALL_STATE(6806)] = 288773,
  [SMALL_STATE(6807)] = 288824,
  [SMALL_STATE(6808)] = 288873,
  [SMALL_STATE(6809)] = 288924,
  [SMALL_STATE(6810)] = 288971,
  [SMALL_STATE(6811)] = 289022,
  [SMALL_STATE(6812)] = 289071,
  [SMALL_STATE(6813)] = 289122,
  [SMALL_STATE(6814)] = 289173,
  [SMALL_STATE(6815)] = 289224,
  [SMALL_STATE(6816)] = 289275,
  [SMALL_STATE(6817)] = 289324,
  [SMALL_STATE(6818)] = 289375,
  [SMALL_STATE(6819)] = 289426,
  [SMALL_STATE(6820)] = 289473,
  [SMALL_STATE(6821)] = 289524,
  [SMALL_STATE(6822)] = 289575,
  [SMALL_STATE(6823)] = 289626,
  [SMALL_STATE(6824)] = 289673,
  [SMALL_STATE(6825)] = 289724,
  [SMALL_STATE(6826)] = 289775,
  [SMALL_STATE(6827)] = 289822,
  [SMALL_STATE(6828)] = 289873,
  [SMALL_STATE(6829)] = 289924,
  [SMALL_STATE(6830)] = 289975,
  [SMALL_STATE(6831)] = 290026,
  [SMALL_STATE(6832)] = 290075,
  [SMALL_STATE(6833)] = 290122,
  [SMALL_STATE(6834)] = 290173,
  [SMALL_STATE(6835)] = 290220,
  [SMALL_STATE(6836)] = 290271,
  [SMALL_STATE(6837)] = 290322,
  [SMALL_STATE(6838)] = 290373,
  [SMALL_STATE(6839)] = 290424,
  [SMALL_STATE(6840)] = 290475,
  [SMALL_STATE(6841)] = 290526,
  [SMALL_STATE(6842)] = 290577,
  [SMALL_STATE(6843)] = 290624,
  [SMALL_STATE(6844)] = 290675,
  [SMALL_STATE(6845)] = 290726,
  [SMALL_STATE(6846)] = 290777,
  [SMALL_STATE(6847)] = 290828,
  [SMALL_STATE(6848)] = 290879,
  [SMALL_STATE(6849)] = 290930,
  [SMALL_STATE(6850)] = 290981,
  [SMALL_STATE(6851)] = 291032,
  [SMALL_STATE(6852)] = 291083,
  [SMALL_STATE(6853)] = 291134,
  [SMALL_STATE(6854)] = 291185,
  [SMALL_STATE(6855)] = 291236,
  [SMALL_STATE(6856)] = 291287,
  [SMALL_STATE(6857)] = 291338,
  [SMALL_STATE(6858)] = 291389,
  [SMALL_STATE(6859)] = 291440,
  [SMALL_STATE(6860)] = 291491,
  [SMALL_STATE(6861)] = 291542,
  [SMALL_STATE(6862)] = 291593,
  [SMALL_STATE(6863)] = 291644,
  [SMALL_STATE(6864)] = 291695,
  [SMALL_STATE(6865)] = 291742,
  [SMALL_STATE(6866)] = 291793,
  [SMALL_STATE(6867)] = 291844,
  [SMALL_STATE(6868)] = 291895,
  [SMALL_STATE(6869)] = 291946,
  [SMALL_STATE(6870)] = 291997,
  [SMALL_STATE(6871)] = 292048,
  [SMALL_STATE(6872)] = 292099,
  [SMALL_STATE(6873)] = 292148,
  [SMALL_STATE(6874)] = 292197,
  [SMALL_STATE(6875)] = 292248,
  [SMALL_STATE(6876)] = 292299,
  [SMALL_STATE(6877)] = 292350,
  [SMALL_STATE(6878)] = 292401,
  [SMALL_STATE(6879)] = 292448,
  [SMALL_STATE(6880)] = 292499,
  [SMALL_STATE(6881)] = 292550,
  [SMALL_STATE(6882)] = 292599,
  [SMALL_STATE(6883)] = 292650,
  [SMALL_STATE(6884)] = 292701,
  [SMALL_STATE(6885)] = 292752,
  [SMALL_STATE(6886)] = 292803,
  [SMALL_STATE(6887)] = 292854,
  [SMALL_STATE(6888)] = 292905,
  [SMALL_STATE(6889)] = 292956,
  [SMALL_STATE(6890)] = 293007,
  [SMALL_STATE(6891)] = 293054,
  [SMALL_STATE(6892)] = 293105,
  [SMALL_STATE(6893)] = 293156,
  [SMALL_STATE(6894)] = 293207,
  [SMALL_STATE(6895)] = 293258,
  [SMALL_STATE(6896)] = 293309,
  [SMALL_STATE(6897)] = 293360,
  [SMALL_STATE(6898)] = 293411,
  [SMALL_STATE(6899)] = 293462,
  [SMALL_STATE(6900)] = 293513,
  [SMALL_STATE(6901)] = 293564,
  [SMALL_STATE(6902)] = 293615,
  [SMALL_STATE(6903)] = 293666,
  [SMALL_STATE(6904)] = 293717,
  [SMALL_STATE(6905)] = 293768,
  [SMALL_STATE(6906)] = 293819,
  [SMALL_STATE(6907)] = 293870,
  [SMALL_STATE(6908)] = 293921,
  [SMALL_STATE(6909)] = 293972,
  [SMALL_STATE(6910)] = 294023,
  [SMALL_STATE(6911)] = 294074,
  [SMALL_STATE(6912)] = 294125,
  [SMALL_STATE(6913)] = 294176,
  [SMALL_STATE(6914)] = 294227,
  [SMALL_STATE(6915)] = 294276,
  [SMALL_STATE(6916)] = 294323,
  [SMALL_STATE(6917)] = 294374,
  [SMALL_STATE(6918)] = 294425,
  [SMALL_STATE(6919)] = 294476,
  [SMALL_STATE(6920)] = 294527,
  [SMALL_STATE(6921)] = 294578,
  [SMALL_STATE(6922)] = 294629,
  [SMALL_STATE(6923)] = 294678,
  [SMALL_STATE(6924)] = 294729,
  [SMALL_STATE(6925)] = 294780,
  [SMALL_STATE(6926)] = 294827,
  [SMALL_STATE(6927)] = 294876,
  [SMALL_STATE(6928)] = 294923,
  [SMALL_STATE(6929)] = 294974,
  [SMALL_STATE(6930)] = 295025,
  [SMALL_STATE(6931)] = 295076,
  [SMALL_STATE(6932)] = 295127,
  [SMALL_STATE(6933)] = 295178,
  [SMALL_STATE(6934)] = 295229,
  [SMALL_STATE(6935)] = 295280,
  [SMALL_STATE(6936)] = 295331,
  [SMALL_STATE(6937)] = 295378,
  [SMALL_STATE(6938)] = 295429,
  [SMALL_STATE(6939)] = 295480,
  [SMALL_STATE(6940)] = 295531,
  [SMALL_STATE(6941)] = 295582,
  [SMALL_STATE(6942)] = 295633,
  [SMALL_STATE(6943)] = 295684,
  [SMALL_STATE(6944)] = 295733,
  [SMALL_STATE(6945)] = 295784,
  [SMALL_STATE(6946)] = 295835,
  [SMALL_STATE(6947)] = 295886,
  [SMALL_STATE(6948)] = 295935,
  [SMALL_STATE(6949)] = 295986,
  [SMALL_STATE(6950)] = 296037,
  [SMALL_STATE(6951)] = 296088,
  [SMALL_STATE(6952)] = 296139,
  [SMALL_STATE(6953)] = 296190,
  [SMALL_STATE(6954)] = 296241,
  [SMALL_STATE(6955)] = 296292,
  [SMALL_STATE(6956)] = 296343,
  [SMALL_STATE(6957)] = 296394,
  [SMALL_STATE(6958)] = 296445,
  [SMALL_STATE(6959)] = 296496,
  [SMALL_STATE(6960)] = 296547,
  [SMALL_STATE(6961)] = 296598,
  [SMALL_STATE(6962)] = 296649,
  [SMALL_STATE(6963)] = 296700,
  [SMALL_STATE(6964)] = 296749,
  [SMALL_STATE(6965)] = 296800,
  [SMALL_STATE(6966)] = 296849,
  [SMALL_STATE(6967)] = 296900,
  [SMALL_STATE(6968)] = 296951,
  [SMALL_STATE(6969)] = 297002,
  [SMALL_STATE(6970)] = 297053,
  [SMALL_STATE(6971)] = 297104,
  [SMALL_STATE(6972)] = 297155,
  [SMALL_STATE(6973)] = 297204,
  [SMALL_STATE(6974)] = 297255,
  [SMALL_STATE(6975)] = 297306,
  [SMALL_STATE(6976)] = 297353,
  [SMALL_STATE(6977)] = 297404,
  [SMALL_STATE(6978)] = 297455,
  [SMALL_STATE(6979)] = 297506,
  [SMALL_STATE(6980)] = 297557,
  [SMALL_STATE(6981)] = 297608,
  [SMALL_STATE(6982)] = 297659,
  [SMALL_STATE(6983)] = 297710,
  [SMALL_STATE(6984)] = 297761,
  [SMALL_STATE(6985)] = 297812,
  [SMALL_STATE(6986)] = 297863,
  [SMALL_STATE(6987)] = 297914,
  [SMALL_STATE(6988)] = 297965,
  [SMALL_STATE(6989)] = 298016,
  [SMALL_STATE(6990)] = 298067,
  [SMALL_STATE(6991)] = 298118,
  [SMALL_STATE(6992)] = 298169,
  [SMALL_STATE(6993)] = 298220,
  [SMALL_STATE(6994)] = 298271,
  [SMALL_STATE(6995)] = 298322,
  [SMALL_STATE(6996)] = 298373,
  [SMALL_STATE(6997)] = 298424,
  [SMALL_STATE(6998)] = 298475,
  [SMALL_STATE(6999)] = 298526,
  [SMALL_STATE(7000)] = 298577,
  [SMALL_STATE(7001)] = 298628,
  [SMALL_STATE(7002)] = 298679,
  [SMALL_STATE(7003)] = 298730,
  [SMALL_STATE(7004)] = 298781,
  [SMALL_STATE(7005)] = 298832,
  [SMALL_STATE(7006)] = 298883,
  [SMALL_STATE(7007)] = 298934,
  [SMALL_STATE(7008)] = 298985,
  [SMALL_STATE(7009)] = 299032,
  [SMALL_STATE(7010)] = 299083,
  [SMALL_STATE(7011)] = 299134,
  [SMALL_STATE(7012)] = 299185,
  [SMALL_STATE(7013)] = 299236,
  [SMALL_STATE(7014)] = 299287,
  [SMALL_STATE(7015)] = 299338,
  [SMALL_STATE(7016)] = 299389,
  [SMALL_STATE(7017)] = 299440,
  [SMALL_STATE(7018)] = 299491,
  [SMALL_STATE(7019)] = 299542,
  [SMALL_STATE(7020)] = 299593,
  [SMALL_STATE(7021)] = 299640,
  [SMALL_STATE(7022)] = 299691,
  [SMALL_STATE(7023)] = 299742,
  [SMALL_STATE(7024)] = 299793,
  [SMALL_STATE(7025)] = 299844,
  [SMALL_STATE(7026)] = 299895,
  [SMALL_STATE(7027)] = 299946,
  [SMALL_STATE(7028)] = 299997,
  [SMALL_STATE(7029)] = 300048,
  [SMALL_STATE(7030)] = 300099,
  [SMALL_STATE(7031)] = 300150,
  [SMALL_STATE(7032)] = 300201,
  [SMALL_STATE(7033)] = 300252,
  [SMALL_STATE(7034)] = 300303,
  [SMALL_STATE(7035)] = 300352,
  [SMALL_STATE(7036)] = 300403,
  [SMALL_STATE(7037)] = 300454,
  [SMALL_STATE(7038)] = 300505,
  [SMALL_STATE(7039)] = 300556,
  [SMALL_STATE(7040)] = 300607,
  [SMALL_STATE(7041)] = 300658,
  [SMALL_STATE(7042)] = 300709,
  [SMALL_STATE(7043)] = 300760,
  [SMALL_STATE(7044)] = 300811,
  [SMALL_STATE(7045)] = 300862,
  [SMALL_STATE(7046)] = 300913,
  [SMALL_STATE(7047)] = 300964,
  [SMALL_STATE(7048)] = 301011,
  [SMALL_STATE(7049)] = 301062,
  [SMALL_STATE(7050)] = 301113,
  [SMALL_STATE(7051)] = 301162,
  [SMALL_STATE(7052)] = 301213,
  [SMALL_STATE(7053)] = 301264,
  [SMALL_STATE(7054)] = 301315,
  [SMALL_STATE(7055)] = 301364,
  [SMALL_STATE(7056)] = 301413,
  [SMALL_STATE(7057)] = 301464,
  [SMALL_STATE(7058)] = 301515,
  [SMALL_STATE(7059)] = 301566,
  [SMALL_STATE(7060)] = 301617,
  [SMALL_STATE(7061)] = 301668,
  [SMALL_STATE(7062)] = 301719,
  [SMALL_STATE(7063)] = 301768,
  [SMALL_STATE(7064)] = 301819,
  [SMALL_STATE(7065)] = 301868,
  [SMALL_STATE(7066)] = 301919,
  [SMALL_STATE(7067)] = 301968,
  [SMALL_STATE(7068)] = 302019,
  [SMALL_STATE(7069)] = 302070,
  [SMALL_STATE(7070)] = 302119,
  [SMALL_STATE(7071)] = 302170,
  [SMALL_STATE(7072)] = 302217,
  [SMALL_STATE(7073)] = 302268,
  [SMALL_STATE(7074)] = 302319,
  [SMALL_STATE(7075)] = 302370,
  [SMALL_STATE(7076)] = 302419,
  [SMALL_STATE(7077)] = 302470,
  [SMALL_STATE(7078)] = 302517,
  [SMALL_STATE(7079)] = 302568,
  [SMALL_STATE(7080)] = 302615,
  [SMALL_STATE(7081)] = 302666,
  [SMALL_STATE(7082)] = 302713,
  [SMALL_STATE(7083)] = 302764,
  [SMALL_STATE(7084)] = 302811,
  [SMALL_STATE(7085)] = 302862,
  [SMALL_STATE(7086)] = 302913,
  [SMALL_STATE(7087)] = 302964,
  [SMALL_STATE(7088)] = 303015,
  [SMALL_STATE(7089)] = 303062,
  [SMALL_STATE(7090)] = 303111,
  [SMALL_STATE(7091)] = 303160,
  [SMALL_STATE(7092)] = 303211,
  [SMALL_STATE(7093)] = 303262,
  [SMALL_STATE(7094)] = 303313,
  [SMALL_STATE(7095)] = 303362,
  [SMALL_STATE(7096)] = 303413,
  [SMALL_STATE(7097)] = 303464,
  [SMALL_STATE(7098)] = 303511,
  [SMALL_STATE(7099)] = 303562,
  [SMALL_STATE(7100)] = 303613,
  [SMALL_STATE(7101)] = 303664,
  [SMALL_STATE(7102)] = 303715,
  [SMALL_STATE(7103)] = 303766,
  [SMALL_STATE(7104)] = 303817,
  [SMALL_STATE(7105)] = 303866,
  [SMALL_STATE(7106)] = 303913,
  [SMALL_STATE(7107)] = 303961,
  [SMALL_STATE(7108)] = 304009,
  [SMALL_STATE(7109)] = 304055,
  [SMALL_STATE(7110)] = 304103,
  [SMALL_STATE(7111)] = 304151,
  [SMALL_STATE(7112)] = 304197,
  [SMALL_STATE(7113)] = 304245,
  [SMALL_STATE(7114)] = 304291,
  [SMALL_STATE(7115)] = 304339,
  [SMALL_STATE(7116)] = 304385,
  [SMALL_STATE(7117)] = 304433,
  [SMALL_STATE(7118)] = 304481,
  [SMALL_STATE(7119)] = 304529,
  [SMALL_STATE(7120)] = 304575,
  [SMALL_STATE(7121)] = 304621,
  [SMALL_STATE(7122)] = 304669,
  [SMALL_STATE(7123)] = 304715,
  [SMALL_STATE(7124)] = 304763,
  [SMALL_STATE(7125)] = 304811,
  [SMALL_STATE(7126)] = 304857,
  [SMALL_STATE(7127)] = 304905,
  [SMALL_STATE(7128)] = 304953,
  [SMALL_STATE(7129)] = 305001,
  [SMALL_STATE(7130)] = 305047,
  [SMALL_STATE(7131)] = 305093,
  [SMALL_STATE(7132)] = 305139,
  [SMALL_STATE(7133)] = 305187,
  [SMALL_STATE(7134)] = 305235,
  [SMALL_STATE(7135)] = 305283,
  [SMALL_STATE(7136)] = 305331,
  [SMALL_STATE(7137)] = 305379,
  [SMALL_STATE(7138)] = 305427,
  [SMALL_STATE(7139)] = 305473,
  [SMALL_STATE(7140)] = 305521,
  [SMALL_STATE(7141)] = 305567,
  [SMALL_STATE(7142)] = 305613,
  [SMALL_STATE(7143)] = 305659,
  [SMALL_STATE(7144)] = 305707,
  [SMALL_STATE(7145)] = 305755,
  [SMALL_STATE(7146)] = 305803,
  [SMALL_STATE(7147)] = 305849,
  [SMALL_STATE(7148)] = 305895,
  [SMALL_STATE(7149)] = 305941,
  [SMALL_STATE(7150)] = 305989,
  [SMALL_STATE(7151)] = 306037,
  [SMALL_STATE(7152)] = 306083,
  [SMALL_STATE(7153)] = 306131,
  [SMALL_STATE(7154)] = 306179,
  [SMALL_STATE(7155)] = 306227,
  [SMALL_STATE(7156)] = 306275,
  [SMALL_STATE(7157)] = 306323,
  [SMALL_STATE(7158)] = 306371,
  [SMALL_STATE(7159)] = 306419,
  [SMALL_STATE(7160)] = 306467,
  [SMALL_STATE(7161)] = 306515,
  [SMALL_STATE(7162)] = 306561,
  [SMALL_STATE(7163)] = 306609,
  [SMALL_STATE(7164)] = 306655,
  [SMALL_STATE(7165)] = 306703,
  [SMALL_STATE(7166)] = 306751,
  [SMALL_STATE(7167)] = 306797,
  [SMALL_STATE(7168)] = 306845,
  [SMALL_STATE(7169)] = 306893,
  [SMALL_STATE(7170)] = 306941,
  [SMALL_STATE(7171)] = 306989,
  [SMALL_STATE(7172)] = 307037,
  [SMALL_STATE(7173)] = 307085,
  [SMALL_STATE(7174)] = 307133,
  [SMALL_STATE(7175)] = 307181,
  [SMALL_STATE(7176)] = 307229,
  [SMALL_STATE(7177)] = 307277,
  [SMALL_STATE(7178)] = 307323,
  [SMALL_STATE(7179)] = 307371,
  [SMALL_STATE(7180)] = 307417,
  [SMALL_STATE(7181)] = 307463,
  [SMALL_STATE(7182)] = 307509,
  [SMALL_STATE(7183)] = 307557,
  [SMALL_STATE(7184)] = 307605,
  [SMALL_STATE(7185)] = 307653,
  [SMALL_STATE(7186)] = 307701,
  [SMALL_STATE(7187)] = 307747,
  [SMALL_STATE(7188)] = 307795,
  [SMALL_STATE(7189)] = 307843,
  [SMALL_STATE(7190)] = 307889,
  [SMALL_STATE(7191)] = 307937,
  [SMALL_STATE(7192)] = 307983,
  [SMALL_STATE(7193)] = 308031,
  [SMALL_STATE(7194)] = 308079,
  [SMALL_STATE(7195)] = 308125,
  [SMALL_STATE(7196)] = 308173,
  [SMALL_STATE(7197)] = 308219,
  [SMALL_STATE(7198)] = 308267,
  [SMALL_STATE(7199)] = 308315,
  [SMALL_STATE(7200)] = 308363,
  [SMALL_STATE(7201)] = 308409,
  [SMALL_STATE(7202)] = 308457,
  [SMALL_STATE(7203)] = 308505,
  [SMALL_STATE(7204)] = 308553,
  [SMALL_STATE(7205)] = 308599,
  [SMALL_STATE(7206)] = 308647,
  [SMALL_STATE(7207)] = 308695,
  [SMALL_STATE(7208)] = 308743,
  [SMALL_STATE(7209)] = 308791,
  [SMALL_STATE(7210)] = 308839,
  [SMALL_STATE(7211)] = 308887,
  [SMALL_STATE(7212)] = 308935,
  [SMALL_STATE(7213)] = 308983,
  [SMALL_STATE(7214)] = 309031,
  [SMALL_STATE(7215)] = 309079,
  [SMALL_STATE(7216)] = 309125,
  [SMALL_STATE(7217)] = 309173,
  [SMALL_STATE(7218)] = 309219,
  [SMALL_STATE(7219)] = 309267,
  [SMALL_STATE(7220)] = 309313,
  [SMALL_STATE(7221)] = 309361,
  [SMALL_STATE(7222)] = 309409,
  [SMALL_STATE(7223)] = 309455,
  [SMALL_STATE(7224)] = 309501,
  [SMALL_STATE(7225)] = 309547,
  [SMALL_STATE(7226)] = 309593,
  [SMALL_STATE(7227)] = 309641,
  [SMALL_STATE(7228)] = 309689,
  [SMALL_STATE(7229)] = 309735,
  [SMALL_STATE(7230)] = 309781,
  [SMALL_STATE(7231)] = 309829,
  [SMALL_STATE(7232)] = 309877,
  [SMALL_STATE(7233)] = 309925,
  [SMALL_STATE(7234)] = 309973,
  [SMALL_STATE(7235)] = 310021,
  [SMALL_STATE(7236)] = 310067,
  [SMALL_STATE(7237)] = 310115,
  [SMALL_STATE(7238)] = 310161,
  [SMALL_STATE(7239)] = 310207,
  [SMALL_STATE(7240)] = 310255,
  [SMALL_STATE(7241)] = 310303,
  [SMALL_STATE(7242)] = 310351,
  [SMALL_STATE(7243)] = 310397,
  [SMALL_STATE(7244)] = 310445,
  [SMALL_STATE(7245)] = 310493,
  [SMALL_STATE(7246)] = 310541,
  [SMALL_STATE(7247)] = 310589,
  [SMALL_STATE(7248)] = 310637,
  [SMALL_STATE(7249)] = 310683,
  [SMALL_STATE(7250)] = 310731,
  [SMALL_STATE(7251)] = 310777,
  [SMALL_STATE(7252)] = 310825,
  [SMALL_STATE(7253)] = 310873,
  [SMALL_STATE(7254)] = 310921,
  [SMALL_STATE(7255)] = 310969,
  [SMALL_STATE(7256)] = 311017,
  [SMALL_STATE(7257)] = 311065,
  [SMALL_STATE(7258)] = 311113,
  [SMALL_STATE(7259)] = 311159,
  [SMALL_STATE(7260)] = 311205,
  [SMALL_STATE(7261)] = 311251,
  [SMALL_STATE(7262)] = 311299,
  [SMALL_STATE(7263)] = 311347,
  [SMALL_STATE(7264)] = 311395,
  [SMALL_STATE(7265)] = 311441,
  [SMALL_STATE(7266)] = 311487,
  [SMALL_STATE(7267)] = 311535,
  [SMALL_STATE(7268)] = 311581,
  [SMALL_STATE(7269)] = 311629,
  [SMALL_STATE(7270)] = 311675,
  [SMALL_STATE(7271)] = 311721,
  [SMALL_STATE(7272)] = 311767,
  [SMALL_STATE(7273)] = 311815,
  [SMALL_STATE(7274)] = 311861,
  [SMALL_STATE(7275)] = 311907,
  [SMALL_STATE(7276)] = 311953,
  [SMALL_STATE(7277)] = 312001,
  [SMALL_STATE(7278)] = 312049,
  [SMALL_STATE(7279)] = 312097,
  [SMALL_STATE(7280)] = 312145,
  [SMALL_STATE(7281)] = 312193,
  [SMALL_STATE(7282)] = 312239,
  [SMALL_STATE(7283)] = 312287,
  [SMALL_STATE(7284)] = 312335,
  [SMALL_STATE(7285)] = 312383,
  [SMALL_STATE(7286)] = 312429,
  [SMALL_STATE(7287)] = 312477,
  [SMALL_STATE(7288)] = 312523,
  [SMALL_STATE(7289)] = 312569,
  [SMALL_STATE(7290)] = 312617,
  [SMALL_STATE(7291)] = 312663,
  [SMALL_STATE(7292)] = 312711,
  [SMALL_STATE(7293)] = 312757,
  [SMALL_STATE(7294)] = 312803,
  [SMALL_STATE(7295)] = 312849,
  [SMALL_STATE(7296)] = 312895,
  [SMALL_STATE(7297)] = 312943,
  [SMALL_STATE(7298)] = 312991,
  [SMALL_STATE(7299)] = 313037,
  [SMALL_STATE(7300)] = 313083,
  [SMALL_STATE(7301)] = 313131,
  [SMALL_STATE(7302)] = 313179,
  [SMALL_STATE(7303)] = 313227,
  [SMALL_STATE(7304)] = 313273,
  [SMALL_STATE(7305)] = 313321,
  [SMALL_STATE(7306)] = 313367,
  [SMALL_STATE(7307)] = 313413,
  [SMALL_STATE(7308)] = 313461,
  [SMALL_STATE(7309)] = 313509,
  [SMALL_STATE(7310)] = 313557,
  [SMALL_STATE(7311)] = 313605,
  [SMALL_STATE(7312)] = 313653,
  [SMALL_STATE(7313)] = 313701,
  [SMALL_STATE(7314)] = 313747,
  [SMALL_STATE(7315)] = 313793,
  [SMALL_STATE(7316)] = 313839,
  [SMALL_STATE(7317)] = 313887,
  [SMALL_STATE(7318)] = 313933,
  [SMALL_STATE(7319)] = 313979,
  [SMALL_STATE(7320)] = 314025,
  [SMALL_STATE(7321)] = 314071,
  [SMALL_STATE(7322)] = 314117,
  [SMALL_STATE(7323)] = 314163,
  [SMALL_STATE(7324)] = 314211,
  [SMALL_STATE(7325)] = 314259,
  [SMALL_STATE(7326)] = 314307,
  [SMALL_STATE(7327)] = 314355,
  [SMALL_STATE(7328)] = 314403,
  [SMALL_STATE(7329)] = 314451,
  [SMALL_STATE(7330)] = 314497,
  [SMALL_STATE(7331)] = 314543,
  [SMALL_STATE(7332)] = 314589,
  [SMALL_STATE(7333)] = 314635,
  [SMALL_STATE(7334)] = 314683,
  [SMALL_STATE(7335)] = 314729,
  [SMALL_STATE(7336)] = 314777,
  [SMALL_STATE(7337)] = 314823,
  [SMALL_STATE(7338)] = 314871,
  [SMALL_STATE(7339)] = 314917,
  [SMALL_STATE(7340)] = 314965,
  [SMALL_STATE(7341)] = 315011,
  [SMALL_STATE(7342)] = 315059,
  [SMALL_STATE(7343)] = 315105,
  [SMALL_STATE(7344)] = 315151,
  [SMALL_STATE(7345)] = 315196,
  [SMALL_STATE(7346)] = 315241,
  [SMALL_STATE(7347)] = 315286,
  [SMALL_STATE(7348)] = 315331,
  [SMALL_STATE(7349)] = 315376,
  [SMALL_STATE(7350)] = 315421,
  [SMALL_STATE(7351)] = 315466,
  [SMALL_STATE(7352)] = 315511,
  [SMALL_STATE(7353)] = 315556,
  [SMALL_STATE(7354)] = 315601,
  [SMALL_STATE(7355)] = 315646,
  [SMALL_STATE(7356)] = 315691,
  [SMALL_STATE(7357)] = 315736,
  [SMALL_STATE(7358)] = 315781,
  [SMALL_STATE(7359)] = 315826,
  [SMALL_STATE(7360)] = 315871,
  [SMALL_STATE(7361)] = 315916,
  [SMALL_STATE(7362)] = 315961,
  [SMALL_STATE(7363)] = 316006,
  [SMALL_STATE(7364)] = 316051,
  [SMALL_STATE(7365)] = 316096,
  [SMALL_STATE(7366)] = 316141,
  [SMALL_STATE(7367)] = 316186,
  [SMALL_STATE(7368)] = 316231,
  [SMALL_STATE(7369)] = 316276,
  [SMALL_STATE(7370)] = 316321,
  [SMALL_STATE(7371)] = 316366,
  [SMALL_STATE(7372)] = 316411,
  [SMALL_STATE(7373)] = 316456,
  [SMALL_STATE(7374)] = 316501,
  [SMALL_STATE(7375)] = 316546,
  [SMALL_STATE(7376)] = 316591,
  [SMALL_STATE(7377)] = 316636,
  [SMALL_STATE(7378)] = 316681,
  [SMALL_STATE(7379)] = 316726,
  [SMALL_STATE(7380)] = 316771,
  [SMALL_STATE(7381)] = 316816,
  [SMALL_STATE(7382)] = 316861,
  [SMALL_STATE(7383)] = 316906,
  [SMALL_STATE(7384)] = 316951,
  [SMALL_STATE(7385)] = 316996,
  [SMALL_STATE(7386)] = 317041,
  [SMALL_STATE(7387)] = 317086,
  [SMALL_STATE(7388)] = 317131,
  [SMALL_STATE(7389)] = 317176,
  [SMALL_STATE(7390)] = 317221,
  [SMALL_STATE(7391)] = 317266,
  [SMALL_STATE(7392)] = 317311,
  [SMALL_STATE(7393)] = 317356,
  [SMALL_STATE(7394)] = 317401,
  [SMALL_STATE(7395)] = 317446,
  [SMALL_STATE(7396)] = 317491,
  [SMALL_STATE(7397)] = 317536,
  [SMALL_STATE(7398)] = 317581,
  [SMALL_STATE(7399)] = 317626,
  [SMALL_STATE(7400)] = 317671,
  [SMALL_STATE(7401)] = 317716,
  [SMALL_STATE(7402)] = 317761,
  [SMALL_STATE(7403)] = 317806,
  [SMALL_STATE(7404)] = 317851,
  [SMALL_STATE(7405)] = 317896,
  [SMALL_STATE(7406)] = 317941,
  [SMALL_STATE(7407)] = 317986,
  [SMALL_STATE(7408)] = 318031,
  [SMALL_STATE(7409)] = 318076,
  [SMALL_STATE(7410)] = 318121,
  [SMALL_STATE(7411)] = 318166,
  [SMALL_STATE(7412)] = 318211,
  [SMALL_STATE(7413)] = 318256,
  [SMALL_STATE(7414)] = 318301,
  [SMALL_STATE(7415)] = 318346,
  [SMALL_STATE(7416)] = 318391,
  [SMALL_STATE(7417)] = 318436,
  [SMALL_STATE(7418)] = 318481,
  [SMALL_STATE(7419)] = 318526,
  [SMALL_STATE(7420)] = 318571,
  [SMALL_STATE(7421)] = 318616,
  [SMALL_STATE(7422)] = 318661,
  [SMALL_STATE(7423)] = 318706,
  [SMALL_STATE(7424)] = 318751,
  [SMALL_STATE(7425)] = 318796,
  [SMALL_STATE(7426)] = 318841,
  [SMALL_STATE(7427)] = 318886,
  [SMALL_STATE(7428)] = 318931,
  [SMALL_STATE(7429)] = 318976,
  [SMALL_STATE(7430)] = 319021,
  [SMALL_STATE(7431)] = 319066,
  [SMALL_STATE(7432)] = 319111,
  [SMALL_STATE(7433)] = 319156,
  [SMALL_STATE(7434)] = 319201,
  [SMALL_STATE(7435)] = 319246,
  [SMALL_STATE(7436)] = 319291,
  [SMALL_STATE(7437)] = 319336,
  [SMALL_STATE(7438)] = 319381,
  [SMALL_STATE(7439)] = 319426,
  [SMALL_STATE(7440)] = 319471,
  [SMALL_STATE(7441)] = 319516,
  [SMALL_STATE(7442)] = 319561,
  [SMALL_STATE(7443)] = 319606,
  [SMALL_STATE(7444)] = 319651,
  [SMALL_STATE(7445)] = 319696,
  [SMALL_STATE(7446)] = 319741,
  [SMALL_STATE(7447)] = 319786,
  [SMALL_STATE(7448)] = 319831,
  [SMALL_STATE(7449)] = 319876,
  [SMALL_STATE(7450)] = 319921,
  [SMALL_STATE(7451)] = 319966,
  [SMALL_STATE(7452)] = 320011,
  [SMALL_STATE(7453)] = 320056,
  [SMALL_STATE(7454)] = 320101,
  [SMALL_STATE(7455)] = 320146,
  [SMALL_STATE(7456)] = 320191,
  [SMALL_STATE(7457)] = 320236,
  [SMALL_STATE(7458)] = 320281,
  [SMALL_STATE(7459)] = 320326,
  [SMALL_STATE(7460)] = 320371,
  [SMALL_STATE(7461)] = 320416,
  [SMALL_STATE(7462)] = 320461,
  [SMALL_STATE(7463)] = 320506,
  [SMALL_STATE(7464)] = 320551,
  [SMALL_STATE(7465)] = 320596,
  [SMALL_STATE(7466)] = 320641,
  [SMALL_STATE(7467)] = 320686,
  [SMALL_STATE(7468)] = 320731,
  [SMALL_STATE(7469)] = 320776,
  [SMALL_STATE(7470)] = 320821,
  [SMALL_STATE(7471)] = 320866,
  [SMALL_STATE(7472)] = 320911,
  [SMALL_STATE(7473)] = 320956,
  [SMALL_STATE(7474)] = 321001,
  [SMALL_STATE(7475)] = 321046,
  [SMALL_STATE(7476)] = 321091,
  [SMALL_STATE(7477)] = 321136,
  [SMALL_STATE(7478)] = 321181,
  [SMALL_STATE(7479)] = 321226,
  [SMALL_STATE(7480)] = 321271,
  [SMALL_STATE(7481)] = 321316,
  [SMALL_STATE(7482)] = 321361,
  [SMALL_STATE(7483)] = 321406,
  [SMALL_STATE(7484)] = 321451,
  [SMALL_STATE(7485)] = 321496,
  [SMALL_STATE(7486)] = 321541,
  [SMALL_STATE(7487)] = 321586,
  [SMALL_STATE(7488)] = 321631,
  [SMALL_STATE(7489)] = 321676,
  [SMALL_STATE(7490)] = 321721,
  [SMALL_STATE(7491)] = 321766,
  [SMALL_STATE(7492)] = 321811,
  [SMALL_STATE(7493)] = 321856,
  [SMALL_STATE(7494)] = 321901,
  [SMALL_STATE(7495)] = 321946,
  [SMALL_STATE(7496)] = 321991,
  [SMALL_STATE(7497)] = 322036,
  [SMALL_STATE(7498)] = 322081,
  [SMALL_STATE(7499)] = 322126,
  [SMALL_STATE(7500)] = 322171,
  [SMALL_STATE(7501)] = 322216,
  [SMALL_STATE(7502)] = 322261,
  [SMALL_STATE(7503)] = 322306,
  [SMALL_STATE(7504)] = 322351,
  [SMALL_STATE(7505)] = 322396,
  [SMALL_STATE(7506)] = 322441,
  [SMALL_STATE(7507)] = 322486,
  [SMALL_STATE(7508)] = 322531,
  [SMALL_STATE(7509)] = 322576,
  [SMALL_STATE(7510)] = 322621,
  [SMALL_STATE(7511)] = 322666,
  [SMALL_STATE(7512)] = 322711,
  [SMALL_STATE(7513)] = 322756,
  [SMALL_STATE(7514)] = 322801,
  [SMALL_STATE(7515)] = 322846,
  [SMALL_STATE(7516)] = 322891,
  [SMALL_STATE(7517)] = 322936,
  [SMALL_STATE(7518)] = 322981,
  [SMALL_STATE(7519)] = 323026,
  [SMALL_STATE(7520)] = 323071,
  [SMALL_STATE(7521)] = 323116,
  [SMALL_STATE(7522)] = 323161,
  [SMALL_STATE(7523)] = 323206,
  [SMALL_STATE(7524)] = 323251,
  [SMALL_STATE(7525)] = 323296,
  [SMALL_STATE(7526)] = 323341,
  [SMALL_STATE(7527)] = 323386,
  [SMALL_STATE(7528)] = 323431,
  [SMALL_STATE(7529)] = 323476,
  [SMALL_STATE(7530)] = 323521,
  [SMALL_STATE(7531)] = 323566,
  [SMALL_STATE(7532)] = 323611,
  [SMALL_STATE(7533)] = 323656,
  [SMALL_STATE(7534)] = 323701,
  [SMALL_STATE(7535)] = 323746,
  [SMALL_STATE(7536)] = 323791,
  [SMALL_STATE(7537)] = 323836,
  [SMALL_STATE(7538)] = 323881,
  [SMALL_STATE(7539)] = 323926,
  [SMALL_STATE(7540)] = 323971,
  [SMALL_STATE(7541)] = 324016,
  [SMALL_STATE(7542)] = 324061,
  [SMALL_STATE(7543)] = 324106,
  [SMALL_STATE(7544)] = 324151,
  [SMALL_STATE(7545)] = 324196,
  [SMALL_STATE(7546)] = 324241,
  [SMALL_STATE(7547)] = 324286,
  [SMALL_STATE(7548)] = 324331,
  [SMALL_STATE(7549)] = 324376,
  [SMALL_STATE(7550)] = 324421,
  [SMALL_STATE(7551)] = 324466,
  [SMALL_STATE(7552)] = 324511,
  [SMALL_STATE(7553)] = 324556,
  [SMALL_STATE(7554)] = 324601,
  [SMALL_STATE(7555)] = 324646,
  [SMALL_STATE(7556)] = 324691,
  [SMALL_STATE(7557)] = 324736,
  [SMALL_STATE(7558)] = 324781,
  [SMALL_STATE(7559)] = 324826,
  [SMALL_STATE(7560)] = 324871,
  [SMALL_STATE(7561)] = 324916,
  [SMALL_STATE(7562)] = 324961,
  [SMALL_STATE(7563)] = 325006,
  [SMALL_STATE(7564)] = 325051,
  [SMALL_STATE(7565)] = 325096,
  [SMALL_STATE(7566)] = 325141,
  [SMALL_STATE(7567)] = 325186,
  [SMALL_STATE(7568)] = 325231,
  [SMALL_STATE(7569)] = 325276,
  [SMALL_STATE(7570)] = 325321,
  [SMALL_STATE(7571)] = 325366,
  [SMALL_STATE(7572)] = 325411,
  [SMALL_STATE(7573)] = 325456,
  [SMALL_STATE(7574)] = 325501,
  [SMALL_STATE(7575)] = 325546,
  [SMALL_STATE(7576)] = 325591,
  [SMALL_STATE(7577)] = 325636,
  [SMALL_STATE(7578)] = 325681,
  [SMALL_STATE(7579)] = 325726,
  [SMALL_STATE(7580)] = 325771,
  [SMALL_STATE(7581)] = 325816,
  [SMALL_STATE(7582)] = 325861,
  [SMALL_STATE(7583)] = 325906,
  [SMALL_STATE(7584)] = 325951,
  [SMALL_STATE(7585)] = 325996,
  [SMALL_STATE(7586)] = 326041,
  [SMALL_STATE(7587)] = 326086,
  [SMALL_STATE(7588)] = 326131,
  [SMALL_STATE(7589)] = 326176,
  [SMALL_STATE(7590)] = 326221,
  [SMALL_STATE(7591)] = 326266,
  [SMALL_STATE(7592)] = 326311,
  [SMALL_STATE(7593)] = 326356,
  [SMALL_STATE(7594)] = 326401,
  [SMALL_STATE(7595)] = 326446,
  [SMALL_STATE(7596)] = 326491,
  [SMALL_STATE(7597)] = 326536,
  [SMALL_STATE(7598)] = 326581,
  [SMALL_STATE(7599)] = 326626,
  [SMALL_STATE(7600)] = 326671,
  [SMALL_STATE(7601)] = 326716,
  [SMALL_STATE(7602)] = 326761,
  [SMALL_STATE(7603)] = 326806,
  [SMALL_STATE(7604)] = 326851,
  [SMALL_STATE(7605)] = 326896,
  [SMALL_STATE(7606)] = 326941,
  [SMALL_STATE(7607)] = 326986,
  [SMALL_STATE(7608)] = 327031,
  [SMALL_STATE(7609)] = 327076,
  [SMALL_STATE(7610)] = 327121,
  [SMALL_STATE(7611)] = 327166,
  [SMALL_STATE(7612)] = 327211,
  [SMALL_STATE(7613)] = 327256,
  [SMALL_STATE(7614)] = 327301,
  [SMALL_STATE(7615)] = 327346,
  [SMALL_STATE(7616)] = 327391,
  [SMALL_STATE(7617)] = 327436,
  [SMALL_STATE(7618)] = 327481,
  [SMALL_STATE(7619)] = 327526,
  [SMALL_STATE(7620)] = 327571,
  [SMALL_STATE(7621)] = 327616,
  [SMALL_STATE(7622)] = 327661,
  [SMALL_STATE(7623)] = 327706,
  [SMALL_STATE(7624)] = 327751,
  [SMALL_STATE(7625)] = 327796,
  [SMALL_STATE(7626)] = 327841,
  [SMALL_STATE(7627)] = 327886,
  [SMALL_STATE(7628)] = 327931,
  [SMALL_STATE(7629)] = 327976,
  [SMALL_STATE(7630)] = 328021,
  [SMALL_STATE(7631)] = 328066,
  [SMALL_STATE(7632)] = 328111,
  [SMALL_STATE(7633)] = 328156,
  [SMALL_STATE(7634)] = 328201,
  [SMALL_STATE(7635)] = 328246,
  [SMALL_STATE(7636)] = 328291,
  [SMALL_STATE(7637)] = 328336,
  [SMALL_STATE(7638)] = 328381,
  [SMALL_STATE(7639)] = 328426,
  [SMALL_STATE(7640)] = 328471,
  [SMALL_STATE(7641)] = 328516,
  [SMALL_STATE(7642)] = 328561,
  [SMALL_STATE(7643)] = 328606,
  [SMALL_STATE(7644)] = 328651,
  [SMALL_STATE(7645)] = 328696,
  [SMALL_STATE(7646)] = 328741,
  [SMALL_STATE(7647)] = 328786,
  [SMALL_STATE(7648)] = 328831,
  [SMALL_STATE(7649)] = 328876,
  [SMALL_STATE(7650)] = 328921,
  [SMALL_STATE(7651)] = 328966,
  [SMALL_STATE(7652)] = 329011,
  [SMALL_STATE(7653)] = 329056,
  [SMALL_STATE(7654)] = 329101,
  [SMALL_STATE(7655)] = 329146,
  [SMALL_STATE(7656)] = 329191,
  [SMALL_STATE(7657)] = 329236,
  [SMALL_STATE(7658)] = 329281,
  [SMALL_STATE(7659)] = 329326,
  [SMALL_STATE(7660)] = 329371,
  [SMALL_STATE(7661)] = 329416,
  [SMALL_STATE(7662)] = 329461,
  [SMALL_STATE(7663)] = 329506,
  [SMALL_STATE(7664)] = 329551,
  [SMALL_STATE(7665)] = 329596,
  [SMALL_STATE(7666)] = 329641,
  [SMALL_STATE(7667)] = 329686,
  [SMALL_STATE(7668)] = 329731,
  [SMALL_STATE(7669)] = 329776,
  [SMALL_STATE(7670)] = 329821,
  [SMALL_STATE(7671)] = 329866,
  [SMALL_STATE(7672)] = 329911,
  [SMALL_STATE(7673)] = 329956,
  [SMALL_STATE(7674)] = 330001,
  [SMALL_STATE(7675)] = 330046,
  [SMALL_STATE(7676)] = 330091,
  [SMALL_STATE(7677)] = 330136,
  [SMALL_STATE(7678)] = 330181,
  [SMALL_STATE(7679)] = 330226,
  [SMALL_STATE(7680)] = 330271,
  [SMALL_STATE(7681)] = 330316,
  [SMALL_STATE(7682)] = 330361,
  [SMALL_STATE(7683)] = 330406,
  [SMALL_STATE(7684)] = 330451,
  [SMALL_STATE(7685)] = 330496,
  [SMALL_STATE(7686)] = 330541,
  [SMALL_STATE(7687)] = 330586,
  [SMALL_STATE(7688)] = 330631,
  [SMALL_STATE(7689)] = 330676,
  [SMALL_STATE(7690)] = 330721,
  [SMALL_STATE(7691)] = 330766,
  [SMALL_STATE(7692)] = 330811,
  [SMALL_STATE(7693)] = 330856,
  [SMALL_STATE(7694)] = 330901,
  [SMALL_STATE(7695)] = 330946,
  [SMALL_STATE(7696)] = 330991,
  [SMALL_STATE(7697)] = 331036,
  [SMALL_STATE(7698)] = 331081,
  [SMALL_STATE(7699)] = 331126,
  [SMALL_STATE(7700)] = 331171,
  [SMALL_STATE(7701)] = 331216,
  [SMALL_STATE(7702)] = 331261,
  [SMALL_STATE(7703)] = 331306,
  [SMALL_STATE(7704)] = 331351,
  [SMALL_STATE(7705)] = 331396,
  [SMALL_STATE(7706)] = 331441,
  [SMALL_STATE(7707)] = 331486,
  [SMALL_STATE(7708)] = 331531,
  [SMALL_STATE(7709)] = 331576,
  [SMALL_STATE(7710)] = 331621,
  [SMALL_STATE(7711)] = 331666,
  [SMALL_STATE(7712)] = 331711,
  [SMALL_STATE(7713)] = 331756,
  [SMALL_STATE(7714)] = 331801,
  [SMALL_STATE(7715)] = 331846,
  [SMALL_STATE(7716)] = 331891,
  [SMALL_STATE(7717)] = 331936,
  [SMALL_STATE(7718)] = 331981,
  [SMALL_STATE(7719)] = 332026,
  [SMALL_STATE(7720)] = 332071,
  [SMALL_STATE(7721)] = 332116,
  [SMALL_STATE(7722)] = 332161,
  [SMALL_STATE(7723)] = 332206,
  [SMALL_STATE(7724)] = 332251,
  [SMALL_STATE(7725)] = 332296,
  [SMALL_STATE(7726)] = 332341,
  [SMALL_STATE(7727)] = 332386,
  [SMALL_STATE(7728)] = 332431,
  [SMALL_STATE(7729)] = 332476,
  [SMALL_STATE(7730)] = 332521,
  [SMALL_STATE(7731)] = 332566,
  [SMALL_STATE(7732)] = 332611,
  [SMALL_STATE(7733)] = 332656,
  [SMALL_STATE(7734)] = 332701,
  [SMALL_STATE(7735)] = 332746,
  [SMALL_STATE(7736)] = 332791,
  [SMALL_STATE(7737)] = 332836,
  [SMALL_STATE(7738)] = 332881,
  [SMALL_STATE(7739)] = 332926,
  [SMALL_STATE(7740)] = 332971,
  [SMALL_STATE(7741)] = 333016,
  [SMALL_STATE(7742)] = 333061,
  [SMALL_STATE(7743)] = 333106,
  [SMALL_STATE(7744)] = 333151,
  [SMALL_STATE(7745)] = 333196,
  [SMALL_STATE(7746)] = 333241,
  [SMALL_STATE(7747)] = 333286,
  [SMALL_STATE(7748)] = 333331,
  [SMALL_STATE(7749)] = 333376,
  [SMALL_STATE(7750)] = 333421,
  [SMALL_STATE(7751)] = 333466,
  [SMALL_STATE(7752)] = 333511,
  [SMALL_STATE(7753)] = 333556,
  [SMALL_STATE(7754)] = 333601,
  [SMALL_STATE(7755)] = 333646,
  [SMALL_STATE(7756)] = 333691,
  [SMALL_STATE(7757)] = 333736,
  [SMALL_STATE(7758)] = 333781,
  [SMALL_STATE(7759)] = 333826,
  [SMALL_STATE(7760)] = 333871,
  [SMALL_STATE(7761)] = 333916,
  [SMALL_STATE(7762)] = 333961,
  [SMALL_STATE(7763)] = 334006,
  [SMALL_STATE(7764)] = 334051,
  [SMALL_STATE(7765)] = 334096,
  [SMALL_STATE(7766)] = 334141,
  [SMALL_STATE(7767)] = 334186,
  [SMALL_STATE(7768)] = 334231,
  [SMALL_STATE(7769)] = 334276,
  [SMALL_STATE(7770)] = 334321,
  [SMALL_STATE(7771)] = 334366,
  [SMALL_STATE(7772)] = 334411,
  [SMALL_STATE(7773)] = 334456,
  [SMALL_STATE(7774)] = 334501,
  [SMALL_STATE(7775)] = 334546,
  [SMALL_STATE(7776)] = 334591,
  [SMALL_STATE(7777)] = 334636,
  [SMALL_STATE(7778)] = 334681,
  [SMALL_STATE(7779)] = 334726,
  [SMALL_STATE(7780)] = 334771,
  [SMALL_STATE(7781)] = 334816,
  [SMALL_STATE(7782)] = 334861,
  [SMALL_STATE(7783)] = 334906,
  [SMALL_STATE(7784)] = 334951,
  [SMALL_STATE(7785)] = 334996,
  [SMALL_STATE(7786)] = 335041,
  [SMALL_STATE(7787)] = 335086,
  [SMALL_STATE(7788)] = 335131,
  [SMALL_STATE(7789)] = 335176,
  [SMALL_STATE(7790)] = 335221,
  [SMALL_STATE(7791)] = 335266,
  [SMALL_STATE(7792)] = 335311,
  [SMALL_STATE(7793)] = 335356,
  [SMALL_STATE(7794)] = 335401,
  [SMALL_STATE(7795)] = 335446,
  [SMALL_STATE(7796)] = 335491,
  [SMALL_STATE(7797)] = 335536,
  [SMALL_STATE(7798)] = 335581,
  [SMALL_STATE(7799)] = 335626,
  [SMALL_STATE(7800)] = 335671,
  [SMALL_STATE(7801)] = 335675,
  [SMALL_STATE(7802)] = 335679,
  [SMALL_STATE(7803)] = 335683,
  [SMALL_STATE(7804)] = 335687,
  [SMALL_STATE(7805)] = 335691,
  [SMALL_STATE(7806)] = 335695,
  [SMALL_STATE(7807)] = 335699,
  [SMALL_STATE(7808)] = 335703,
  [SMALL_STATE(7809)] = 335707,
  [SMALL_STATE(7810)] = 335711,
  [SMALL_STATE(7811)] = 335715,
  [SMALL_STATE(7812)] = 335719,
  [SMALL_STATE(7813)] = 335723,
  [SMALL_STATE(7814)] = 335727,
  [SMALL_STATE(7815)] = 335731,
  [SMALL_STATE(7816)] = 335735,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [23] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 0, 0, 0),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6137),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6182),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6172),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6125),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7085),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4593),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7755),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7560),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7750),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7284),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7573),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7158),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7514),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7756),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7676),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7732),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7549),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7465),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7738),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7420),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5874),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6812),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7626),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7746),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7619),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7620),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7297),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7316),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7621),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 3, 0, 56),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 4, 0, 56),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 1, 0, 0),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 2, 0, 0),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2182),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3284),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2051),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2510),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3180),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3333),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(456),
  [270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(466),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(779),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5846),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6137),
  [282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(603),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6182),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6172),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6125),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3567),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5997),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3167),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2101),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3312),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2379),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7085),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3518),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2175),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3117),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2203),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4593),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7755),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7560),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7750),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7284),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7573),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2309),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7256),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3553),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7158),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7514),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(651),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7756),
  [390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(189),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4380),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7676),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7732),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7549),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7465),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7738),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7305),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6473),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5332),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7390),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7420),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7496),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7383),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2182),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3310),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1978),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2283),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2532),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3183),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3333),
  [465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(457),
  [468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(466),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(714),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5874),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6137),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(603),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6182),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6172),
  [489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(30),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6125),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3567),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5997),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3167),
  [504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2101),
  [507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3313),
  [510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2379),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6812),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3518),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2175),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3117),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2203),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4593),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7626),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7746),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7619),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7199),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7620),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2257),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7297),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3553),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(711),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7316),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7514),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(592),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7621),
  [588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(189),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4380),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7676),
  [600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7732),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7549),
  [606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7465),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7738),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7305),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6473),
  [624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5299),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0),
  [629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7390),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7420),
  [635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7496),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7383),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_top_level, 2, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_top_level, 1, 0, 0),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 5, 0, 0),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6583),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7388),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7392),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7763),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7149),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7764),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 5, 0, 0),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7162),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7765),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 2, 0, 0),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 2, 0, 0),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 3, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 3, 0, 0),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2182),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3902),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2110),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2542),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3600),
  [757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3825),
  [760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(466),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(782),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6583),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2148),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3938),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2562),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6982),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3518),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2175),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3117),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2203),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4593),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7388),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7392),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(104),
  [828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7763),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7149),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7764),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2277),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7178),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3553),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(725),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7162),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(296),
  [857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7514),
  [860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(667),
  [863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7765),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(189),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4380),
  [875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7676),
  [878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7732),
  [881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7549),
  [884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7465),
  [887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7738),
  [890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7305),
  [896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6473),
  [902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5220),
  [905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7390),
  [908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7420),
  [911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7496),
  [914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7383),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7614),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 4, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 4, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6923),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7432),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7441),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7585),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7214),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7586),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7253),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7220),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7587),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3677),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5939),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7350),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7643),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5845),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4449),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1, 0, 0),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7672),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5952),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4303),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7648),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7649),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7670),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7671),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7795),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2, 0, 0),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2, 0, 0),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7593),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5925),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7774),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7775),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7590),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7591),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7790),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6642),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7653),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4300),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7650),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7651),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7794),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7627),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4629),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4358),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7622),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7623),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7624),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7625),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7792),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4631),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7471),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3675),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3619),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6645),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7796),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4333),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7588),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7589),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7778),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7779),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7785),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7690),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7784),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3629),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7303),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 1, 0, 0),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 1, 0, 0),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7686),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7535),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7547),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 4, 0, 27),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 4, 0, 27),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7451),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [2201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [2285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [2321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7684),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3785),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7346),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7788),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_attribute_list, 3, 0, 56),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 3, 0, 56),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6034),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6053),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6170),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6042),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6046),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6015),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7285),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6094),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 1, 0, 0),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 1, 0, 0),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_attribute_list, 1, 0, 0),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 2, 0, 0),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 2, 0, 0),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 4, 0, 56),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 4, 0, 56),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 56),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 56),
  [2993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3728),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5804),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5797),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5766),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4360),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 3, 0, 56),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 56),
  [3045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3728),
  [3048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3160),
  [3051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3705),
  [3054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5804),
  [3057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5797),
  [3060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3167),
  [3063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4517),
  [3066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3754),
  [3069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3882),
  [3072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5863),
  [3075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6137),
  [3078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3730),
  [3081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6182),
  [3084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6172),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [3089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6125),
  [3092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3888),
  [3095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5997),
  [3098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2838),
  [3101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6150),
  [3104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5766),
  [3107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3905),
  [3110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4098),
  [3113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4360),
  [3116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5193),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [3121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 9),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 9),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6412),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7255),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7673),
  [3139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [3141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [3143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6412),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6422),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7277),
  [3150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 72),
  [3152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 72),
  [3154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6422),
  [3157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 9),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 9),
  [3161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [3165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [3167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [3169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 33),
  [3171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 33),
  [3173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, 0, 71),
  [3175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 71),
  [3177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 5, 0, 0),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 5, 0, 0),
  [3193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 73),
  [3195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 73),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [3199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 74),
  [3201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 74),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_statement, 2, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_statement, 2, 0, 0),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 3, 0, 0),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 3, 0, 0),
  [3219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 2, 0, 0),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 2, 0, 0),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 2, 0, 16),
  [3229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 2, 0, 16),
  [3231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 56),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 56),
  [3235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 32),
  [3237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 32),
  [3239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [3243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock_statement, 5, 0, 0),
  [3245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock_statement, 5, 0, 0),
  [3247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, 0, 0),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, 0, 0),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, 0, 17),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, 0, 17),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 0),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 0),
  [3263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, 0, 17),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, 0, 17),
  [3267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 3, 0, 38),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 3, 0, 38),
  [3271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 6, 0, 93),
  [3273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 6, 0, 93),
  [3275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 7, 0, 107),
  [3277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 7, 0, 107),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 2, 0, 18),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 2, 0, 18),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 0),
  [3287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 4, 0, 0),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 4, 0, 0),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 4, 0, 0),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 4, 0, 0),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [3305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [3307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 9),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 9),
  [3311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 4, 0, 0),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 4, 0, 0),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_statement, 2, 0, 0),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_statement, 2, 0, 0),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 70),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 70),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 5, 0, 66),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 5, 0, 66),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 115),
  [3337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 115),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_statement, 5, 0, 0),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_statement, 5, 0, 0),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 6, 0, 90),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 6, 0, 90),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 5, 0, 0),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 5, 0, 0),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 6, 0, 26),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 6, 0, 26),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 7, 0, 63),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 7, 0, 63),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [3365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [3367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_list_body, 1, 0, 0),
  [3369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_list_body, 1, 0, 0),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 3, 0, 0),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 3, 0, 0),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 2, 0, 10),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 2, 0, 10),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 4, 0, 0),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 4, 0, 0),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_list_body, 2, 0, 17),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_list_body, 2, 0, 17),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 2, 0, 11),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 2, 0, 11),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 4, 0, 53),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 4, 0, 53),
  [3395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 2, 0, 12),
  [3397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 2, 0, 12),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 2, 0, 13),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 2, 0, 13),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 35),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 35),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 6, 0, 0),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 6, 0, 0),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_alias_directive, 4, 0, 26),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_alias_directive, 4, 0, 26),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 3, 0, 13),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 3, 0, 13),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 7, 0, 0),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 7, 0, 0),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 2, 0, 10),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 2, 0, 10),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 0),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 0),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 7),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 7),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_file_scoped_namespace_declaration, 3, 0, 7),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 3, 0, 7),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 1, 0, 0),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 1, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 2, 0, 10),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 2, 0, 10),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6398),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7109),
  [3453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3728),
  [3456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3705),
  [3459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3754),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7568),
  [3470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3905),
  [3473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4098),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 1, 0, 0),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 1, 0, 0),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 1, 0, 0),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_statement, 1, 0, 0),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0),
  [3486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0),
  [3488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6398),
  [3491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0),
  [3496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 6, 0, 110),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 6, 0, 110),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 6, 0, 112),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 6, 0, 112),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__foreach_statement_initializer, 6, 0, 91),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreach_statement_initializer, 6, 0, 91),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 9, 0, 188),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 9, 0, 188),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__foreach_statement_initializer, 8, 0, 140),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreach_statement_initializer, 8, 0, 140),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 6, 0, 108),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 6, 0, 108),
  [3529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 8, 0, 165),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 8, 0, 165),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 6, 0, 109),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 6, 0, 109),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 7, 0, 135),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 7, 0, 135),
  [3541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 8, 0, 166),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 8, 0, 166),
  [3545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 7, 0, 136),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 7, 0, 136),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 5, 0, 87),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 5, 0, 87),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 7, 0, 137),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 7, 0, 137),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 4, 0, 0),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 4, 0, 0),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__foreach_statement_initializer, 7, 0, 114),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreach_statement_initializer, 7, 0, 114),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__foreach_statement_initializer, 7, 0, 113),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreach_statement_initializer, 7, 0, 113),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 8, 0, 167),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 8, 0, 167),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 5, 0, 89),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 5, 0, 89),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 6, 0, 111),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 6, 0, 111),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 7, 0, 138),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 7, 0, 138),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 7, 0, 139),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 7, 0, 139),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_statement_conditions, 5, 0, 88),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_conditions, 5, 0, 88),
  [3593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2374),
  [3596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2373),
  [3599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [3601] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1), SHIFT(2182),
  [3605] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1), SHIFT(2183),
  [3609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [3612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2182),
  [3615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2183),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [3622] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3241),
  [3626] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3239),
  [3630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3636] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5894),
  [3640] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3381),
  [3644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2652),
  [3647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2647),
  [3650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3910),
  [3652] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5849),
  [3656] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3545),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [3662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [3664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [3666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_name, 2, 0, 0),
  [3668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_name, 2, 0, 0),
  [3670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 3, 0, 0),
  [3672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 3, 0, 0),
  [3674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 4, 0, 0),
  [3676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 4, 0, 0),
  [3678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0),
  [3680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [3684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 2, 0, 0),
  [3686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 2, 0, 0),
  [3688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3670),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_parameters, 1, 0, 4),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 3, 0, 36),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 3, 0, 36),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, 0, 31),
  [3703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_name, 3, 0, 36), REDUCE(sym_member_access_expression, 3, 0, 31),
  [3706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_name, 3, 0, 36), REDUCE(sym_member_access_expression, 3, 0, 31),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, 0, 31),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1, 0, 0),
  [3713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lvalue_expression, 1, 0, 0),
  [3718] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [3722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1, 0, 0),
  [3724] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [3728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [3731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 0),
  [3733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [3736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [3739] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2616),
  [3743] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2604),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3793),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6157),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6166),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [3765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5779),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [3769] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4318),
  [3773] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4316),
  [3777] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5869),
  [3781] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4814),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_attribute_list, 4, 0, 56),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_attribute_list, 4, 0, 56),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [3795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3175),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [3800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [3804] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3192),
  [3808] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3264),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [3818] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2374),
  [3822] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2373),
  [3826] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5901),
  [3830] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3802),
  [3834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(954),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [3839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 5), REDUCE(sym__simple_name, 1, 0, 0),
  [3842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(389),
  [3845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [3848] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2952),
  [3852] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2951),
  [3856] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5859),
  [3860] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4201),
  [3864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3602),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [3875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2951),
  [3878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(402),
  [3881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1, 0, 5),
  [3883] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2980),
  [3887] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2989),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 3, 0, 39),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 3, 0, 39),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [3909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_pattern, 1, 0, 6),
  [3911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_pattern, 1, 0, 6),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7658),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7664),
  [3927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 1, 0, 0),
  [3929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 1, 0, 0),
  [3931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 6),
  [3933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 6),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5783),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 2, 0, 8),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 2, 0, 8),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6129),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6133),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6131),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [3965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5762),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7459),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [3979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [3981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [3983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [3987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [3989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [3991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [3993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7736),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 0),
  [3999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 0),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 6),
  [4003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 6),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5806),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4387),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [4015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4387),
  [4018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 6),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 6),
  [4022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [4024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [4026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scoped_base_type, 1, 0, 0),
  [4028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scoped_base_type, 1, 0, 0),
  [4030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 5, 0, 68),
  [4032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 5, 0, 68),
  [4034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type, 2, 0, 8),
  [4036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type, 2, 0, 8),
  [4038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullable_type, 2, 0, 6),
  [4040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_type, 2, 0, 6),
  [4042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 3, 0, 27),
  [4044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 3, 0, 27),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3798),
  [4048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 6, 0, 86),
  [4050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 6, 0, 86),
  [4052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 7, 0, 106),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 7, 0, 106),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3893),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3774),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7728),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [4078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3665),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [4083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3264),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4318),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4814),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [4102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 3, 0, 0),
  [4104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 3, 0, 0),
  [4106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 2, 0, 0),
  [4108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 2, 0, 0),
  [4110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__array_base_type, 1, 0, 0),
  [4113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(2344),
  [4116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3635),
  [4119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_qualified_name, 3, 0, 44),
  [4121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_qualified_name, 3, 0, 44),
  [4123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 4, 0, 0),
  [4125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 4, 0, 0),
  [4127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 2, 0, 0),
  [4129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 2, 0, 0),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [4133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__pointer_base_type, 1, 0, 0),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6049),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3904),
  [4142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 15),
  [4144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 15),
  [4146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [4148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [4150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 3, 0, 0),
  [4152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 3, 0, 0),
  [4154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 4, 0, 0),
  [4156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 4, 0, 0),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6084),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3792),
  [4164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 4, 0, 0),
  [4166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 4, 0, 0),
  [4168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [4170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [4172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 5, 0, 0),
  [4174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 5, 0, 0),
  [4176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 4, 0, 0),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 4, 0, 0),
  [4180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3919),
  [4182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 2, 0, 0),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 2, 0, 0),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, 0, 40),
  [4188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lvalue_expression, 1, 0, 2),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 2),
  [4192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, 0, 40),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6050),
  [4198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 5, 0, 0),
  [4200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 5, 0, 0),
  [4202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6089),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6001),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [4210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2989),
  [4213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parenthesized_lvalue_expression, 3, 0, 0),
  [4215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parenthesized_lvalue_expression, 3, 0, 0),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [4219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 3, 0, 0),
  [4221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 3, 0, 0),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [4225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_indirection_expression, 2, 0, 0),
  [4227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_indirection_expression, 2, 0, 0),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [4233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_access_expression, 2, 0, 20),
  [4235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_access_expression, 2, 0, 20),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [4239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 3, 0, 0),
  [4241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 3, 0, 0),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4201),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [4267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [4283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [4285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3592),
  [4288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3644),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 3, 0, 0),
  [4293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 3, 0, 0),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3623),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6091),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [4312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 3, 0, 0),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 3, 0, 0),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [4318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 118),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 118),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5996),
  [4326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 3, 0, 75),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3, 0, 75),
  [4332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 2, 0, 0),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 2, 0, 0),
  [4336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 94),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 94),
  [4342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 97),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 97),
  [4348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 150),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 150),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6016),
  [4356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 128),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 128),
  [4362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 190),
  [4364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 190),
  [4366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, 0, 48),
  [4368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, 0, 48),
  [4370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, 0, 94),
  [4372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, 0, 94),
  [4374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 4, 0, 95),
  [4376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 4, 0, 95),
  [4378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 56),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 56),
  [4382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 4, 0, 96),
  [4384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 4, 0, 96),
  [4386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, 0, 98),
  [4388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, 0, 98),
  [4390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 99),
  [4392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 99),
  [4394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 0),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 0),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5859),
  [4400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 195),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 195),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 196),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 196),
  [4408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, 0, 197),
  [4410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, 0, 197),
  [4412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 9, 0, 198),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 9, 0, 198),
  [4416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(2859),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5994),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5979),
  [4425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 5, 0, 116),
  [4427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 5, 0, 116),
  [4429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 117),
  [4431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 117),
  [4433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 118),
  [4435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 118),
  [4437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 5, 0, 119),
  [4439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 5, 0, 119),
  [4441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 74),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 74),
  [4445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 56),
  [4447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 56),
  [4449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 5, 0, 120),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, 0, 120),
  [4453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 9, 0, 199),
  [4455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 9, 0, 199),
  [4457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 9, 0, 200),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 9, 0, 200),
  [4461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 121),
  [4463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 121),
  [4465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 122),
  [4467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 122),
  [4469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 123),
  [4471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 123),
  [4473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, 0, 191),
  [4475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, 0, 191),
  [4477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 124),
  [4479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 124),
  [4481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 126),
  [4483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 126),
  [4485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 127),
  [4487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 127),
  [4489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 67),
  [4491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 67),
  [4493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 128),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 128),
  [4497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 129),
  [4499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 129),
  [4501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 130),
  [4503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 130),
  [4505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 131),
  [4507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 131),
  [4509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 5, 1, 0),
  [4511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 5, 1, 0),
  [4513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 8, 0, 192),
  [4515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 8, 0, 192),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6026),
  [4519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 8, 0, 189),
  [4521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 8, 0, 189),
  [4523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 8, 0, 193),
  [4525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 8, 0, 193),
  [4527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 93),
  [4529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 93),
  [4531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, 0, 141),
  [4533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, 0, 141),
  [4535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 142),
  [4537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 142),
  [4539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 143),
  [4541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 143),
  [4543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 144),
  [4545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 144),
  [4547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 146),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 146),
  [4551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 147),
  [4553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 147),
  [4555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 6, 0, 148),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 6, 0, 148),
  [4559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 149),
  [4561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 149),
  [4563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 150),
  [4565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 150),
  [4567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 6, 0, 151),
  [4569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 6, 0, 151),
  [4571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, 0, 152),
  [4573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, 0, 152),
  [4575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 153),
  [4577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 153),
  [4579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 154),
  [4581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 154),
  [4583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 155),
  [4585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 155),
  [4587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 156),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 156),
  [4591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 157),
  [4593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 157),
  [4595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 158),
  [4597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 158),
  [4599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 159),
  [4601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 159),
  [4603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 160),
  [4605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 160),
  [4607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 161),
  [4609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 161),
  [4611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 162),
  [4613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 162),
  [4615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 163),
  [4617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 163),
  [4619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 3, 1, 0),
  [4621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 3, 1, 0),
  [4623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 168),
  [4625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 168),
  [4627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 169),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 169),
  [4631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 0),
  [4633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 0),
  [4635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 170),
  [4637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 170),
  [4639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 172),
  [4641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 172),
  [4643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 173),
  [4645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 173),
  [4647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 174),
  [4649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 174),
  [4651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 175),
  [4653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 175),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6061),
  [4657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 176),
  [4659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 176),
  [4661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 177),
  [4663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 177),
  [4665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, 0, 178),
  [4667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, 0, 178),
  [4669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, 0, 179),
  [4671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, 0, 179),
  [4673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 2, 0, 57),
  [4675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 2, 0, 57),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6099),
  [4679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 0),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 0),
  [4683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 7, 0, 180),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 7, 0, 180),
  [4687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 181),
  [4689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 181),
  [4691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 182),
  [4693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 182),
  [4695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 183),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 183),
  [4699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 184),
  [4701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 184),
  [4703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [4705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [4707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [4709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [4711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 185),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 185),
  [4715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 186),
  [4717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 186),
  [4719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 187),
  [4721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 187),
  [4723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 194),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 194),
  [4727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 4, 1, 0),
  [4729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 4, 1, 0),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [4735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7084),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [4743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_list, 1, 0, 0),
  [4745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_list, 1, 0, 0),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [4753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_attribute_list, 4, 0, 56),
  [4755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [4757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6101),
  [4761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5989),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6069),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4297),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6006),
  [4771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0),
  [4773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4517),
  [4776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0),
  [4778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5174),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6043),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6022),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6456),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6116),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [4803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6000),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6059),
  [4807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 3, 0, 0),
  [4809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 3, 0, 0),
  [4811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2, 0, 8),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [4815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2, 0, 8),
  [4817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 5, 0, 0),
  [4819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 5, 0, 0),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6019),
  [4823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 6, 0, 0),
  [4825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 6, 0, 0),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6009),
  [4829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5988),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [4833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 4, 0, 0),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 4, 0, 0),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [4841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2182),
  [4844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3725),
  [4847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [4850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4472),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0),
  [4855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3481),
  [4858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6456),
  [4861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5310),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6098),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6057),
  [4868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3681),
  [4871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 2, 0, 0),
  [4873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 2, 0, 0),
  [4875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_unary_expression, 2, 0, 0),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_unary_expression, 2, 0, 0),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [4885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [4887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [4889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stackalloc_expression, 2, 0, 8),
  [4891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_base_type, 1, 0, 0), REDUCE(sym_stackalloc_expression, 2, 0, 8),
  [4894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stackalloc_expression, 2, 0, 8),
  [4896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [4900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, 0, 29),
  [4906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, 0, 29),
  [4908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 1, 52),
  [4910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 1, 52),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [4916] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__array_base_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8),
  [4920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8),
  [4923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(593),
  [4926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8),
  [4929] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8), SHIFT(3026),
  [4933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [4935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [4939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [4941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [4943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [4945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [4949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(2967),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [4954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [4958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [4960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [4962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3591),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [4967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [4969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [4973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_attribute_list, 2, 0, 0),
  [4975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reftype_expression, 4, 0, 0),
  [4977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reftype_expression, 4, 0, 0),
  [4979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_or_group_clause, 1, 0, 0),
  [4981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__select_or_group_clause, 1, 0, 0),
  [4983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, 0, 41),
  [4985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, 0, 41),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 0),
  [4989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 0),
  [4991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_body, 2, 0, 0),
  [4993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_body, 2, 0, 0),
  [4995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 4, 0, 0),
  [4997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 4, 0, 0),
  [4999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_literal, 3, 0, 0),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_literal, 3, 0, 0),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 4, 0, 46),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 4, 0, 46),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 5, 0, 0),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 5, 0, 0),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 4, 0, 47),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 4, 0, 47),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 4, 0, 0),
  [5017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 4, 0, 0),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 5, 0, 0),
  [5021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 5, 0, 0),
  [5023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 3, 0, 0),
  [5025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 3, 0, 0),
  [5027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 5, 0, 0),
  [5029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 5, 0, 0),
  [5031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, 0, 39),
  [5033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, 0, 39),
  [5035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 56),
  [5037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 56),
  [5039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 74),
  [5041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 74),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 4, 0, 0),
  [5045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 4, 0, 0),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_expression_body, 3, 0, 0),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__switch_expression_body, 3, 0, 0),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 4, 0, 0),
  [5053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 4, 0, 0),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_attribute_list, 6, 0, 93),
  [5057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_attribute_list, 6, 0, 93),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_attribute_list, 5, 0, 56),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_attribute_list, 5, 0, 56),
  [5063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 4, 0, 0),
  [5065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 4, 0, 0),
  [5067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_body, 3, 0, 0),
  [5069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_body, 3, 0, 0),
  [5071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_attribute_list, 5, 0, 74),
  [5073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_attribute_list, 5, 0, 74),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6915),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7768),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [5089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [5093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 4, 0, 0),
  [5095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 4, 0, 0),
  [5097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 6, 0, 0),
  [5099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 6, 0, 0),
  [5101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 1, 0, 0),
  [5103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 1, 0, 0),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, 0, 55),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, 0, 55),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 4, 0, 0),
  [5111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 4, 0, 0),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_refvalue_expression, 6, 0, 92),
  [5115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_refvalue_expression, 6, 0, 92),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 93),
  [5119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 93),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_expression_body, 4, 0, 0),
  [5123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__switch_expression_body, 4, 0, 0),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_expression, 4, 0, 0),
  [5127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_expression, 4, 0, 0),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_body, 4, 0, 0),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_body, 4, 0, 0),
  [5133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6453),
  [5135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_expression_body, 5, 0, 0),
  [5137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__switch_expression_body, 5, 0, 0),
  [5139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_body, 5, 0, 0),
  [5141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_body, 5, 0, 0),
  [5143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 1, 0, 0),
  [5145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [5147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [5149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stackalloc_expression, 3, 0, 8),
  [5151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stackalloc_expression, 3, 0, 8),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [5159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [5161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [5163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_stackalloc_expression, 4, 0, 0),
  [5165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_stackalloc_expression, 4, 0, 0),
  [5167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 27),
  [5169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 27),
  [5171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeof_expression, 4, 0, 27),
  [5177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeof_expression, 4, 0, 27),
  [5179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 2, 0, 0),
  [5181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 2, 0, 0),
  [5183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_makeref_expression, 4, 0, 0),
  [5185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_makeref_expression, 4, 0, 0),
  [5187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_unary_expression, 2, 0, 0),
  [5189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_unary_expression, 2, 0, 0),
  [5191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 3, 0, 0),
  [5193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 3, 0, 0),
  [5195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation_expression, 2, 0, 19),
  [5197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation_expression, 2, 0, 19),
  [5199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_query_expression, 2, 0, 0),
  [5201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_query_expression, 2, 0, 0),
  [5203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 3, 0, 0),
  [5205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 3, 0, 0),
  [5207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 3, 0, 23),
  [5209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 3, 0, 23),
  [5211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_binding_expression, 2, 0, 7),
  [5213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_binding_expression, 2, 0, 7),
  [5215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3026),
  [5218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_expression_body, 2, 0, 0),
  [5224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__switch_expression_body, 2, 0, 0),
  [5226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 3, 0, 0),
  [5228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 3, 0, 0),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 21),
  [5236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 21),
  [5238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 43),
  [5240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 43),
  [5242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 3, 0, 0),
  [5244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 3, 0, 0),
  [5246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 3, 0, 0),
  [5248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 3, 0, 0),
  [5250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, 0, 30),
  [5252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, 0, 30),
  [5254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, 17, 8),
  [5256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, 17, 8),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [5264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 2, 0, 0),
  [5266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 2, 0, 0), SHIFT_REPEAT(3167),
  [5269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 2, 0, 0),
  [5271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [5293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3674),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [5298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 1, 0, 0),
  [5300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 1, 0, 0),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [5304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4472),
  [5307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5310),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [5324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3636),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [5333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(642),
  [5336] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8), SHIFT(3265),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [5344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3265),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [5351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3688),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [5356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [5360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4487),
  [5363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5295),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [5378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [5382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [5388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 82),
  [5390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 82),
  [5392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(638),
  [5395] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8), SHIFT(3285),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [5403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_and_pattern, 3, 0, 39),
  [5405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_and_pattern, 3, 0, 39),
  [5407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [5409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 78),
  [5413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 78),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6155),
  [5417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 60),
  [5419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 60),
  [5421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, 0, 102),
  [5423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 4, 0, 102),
  [5425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 3, 0, 60),
  [5427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 3, 0, 60),
  [5429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 4, 0, 103),
  [5431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 4, 0, 103),
  [5433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [5435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [5437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, 0, 132),
  [5439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 5, 0, 132),
  [5441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 2, 0, 0),
  [5443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 2, 0, 0),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 4, 0, 133),
  [5447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 4, 0, 133),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [5451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 6, 0, 164),
  [5453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 6, 0, 164),
  [5455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1, 0, 5),
  [5457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6149),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [5463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [5467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6459),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [5473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3285),
  [5476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_pattern_expression, 3, 0, 42),
  [5482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_pattern_expression, 3, 0, 42),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 78),
  [5486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 78),
  [5488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_pattern, 2, 0, 61),
  [5490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_pattern, 2, 0, 61),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1, 0, 0),
  [5498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1, 0, 0),
  [5500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_pattern, 2, 0, 60),
  [5514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_pattern, 2, 0, 60),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4222),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6542),
  [5524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 2, 0, 125),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 2, 0, 125),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [5536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6598),
  [5538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6079),
  [5544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 3, 0, 145),
  [5546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 3, 0, 145),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6512),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6678),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7733),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [5558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6690),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6527),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6620),
  [5570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [5574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6614),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [5596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 4, 0, 171),
  [5598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 4, 0, 171),
  [5600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(620),
  [5603] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8), SHIFT(2967),
  [5607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [5609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 1, 0, 0),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 1, 0, 0),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [5619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 2, 0, 0), SHIFT_REPEAT(3725),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3789),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5951),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4539),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [5642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6014),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 39),
  [5684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 39),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [5698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7780),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [5716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7344),
  [5734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [5740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_initializer_repeat2, 2, 0, 0), SHIFT_REPEAT(3902),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [5745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(676),
  [5748] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8), SHIFT(2344),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [5758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7782),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [5762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7773),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [5794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_expression, 2, 0, 0),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [5810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_expression, 2, 0, 0),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [5818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [5822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [5830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [5832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [5834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [5850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_pattern, 2, 0, 0),
  [5852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_pattern, 2, 0, 0),
  [5854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [5866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [5868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [5870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 39),
  [5872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 39),
  [5874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 81),
  [5876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 81),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_clause, 2, 0, 0),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_clause, 2, 0, 0),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [5886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_clause, 4, 0, 0),
  [5888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group_clause, 4, 0, 0),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [5902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [5908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [5924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [5926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [5930] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(aux_sym_using_directive_repeat1, 1, 0, 0), SHIFT(2182),
  [5934] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(aux_sym_using_directive_repeat1, 1, 0, 0), SHIFT(2183),
  [5938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(aux_sym_using_directive_repeat1, 1, 0, 0),
  [5941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [5949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [5953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [5975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [5985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [5987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3728),
  [5990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3705),
  [5993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3754),
  [5996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4222),
  [5999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(7568),
  [6002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4297),
  [6005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6783),
  [6008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 1, 0, 0),
  [6010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 1, 0, 0),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [6014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 2, 0, 0),
  [6016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 2, 0, 0),
  [6018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0),
  [6020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0),
  [6022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6138),
  [6025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 3, 0, 0),
  [6027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 3, 0, 0),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [6037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [6041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [6053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [6057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6158),
  [6059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [6065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [6069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [6073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [6087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [6089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [6091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5625),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [6095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4065),
  [6097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [6099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [6105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [6107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [6123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [6125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [6127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [6129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [6133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [6139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [6143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7112),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4054),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [6169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [6171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_pattern, 2, 0, 0),
  [6173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_pattern, 2, 0, 0),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [6177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4026),
  [6179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [6181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [6183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [6189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4088),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [6193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4089),
  [6197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [6199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3, 0, 39),
  [6201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_pattern, 3, 0, 39),
  [6203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [6209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3971),
  [6211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [6213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [6215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [6217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [6219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [6221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [6229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [6231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [6233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [6235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [6243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7783),
  [6245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [6247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [6249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3911),
  [6253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4495),
  [6257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4064),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3928),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [6263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6333),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [6273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [6275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [6277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [6287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [6289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [6293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [6315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [6327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [6329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [6333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [6353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 1, 0, 0),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [6359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6160),
  [6362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6130),
  [6365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [6367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [6373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [6377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [6379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [6383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [6401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [6403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [6407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [6411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [6413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [6417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [6439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6107),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [6445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [6449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6148),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [6456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [6458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [6460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [6464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [6468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [6470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [6474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [6490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6183),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6183),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_body, 4, 0, 0),
  [6497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [6503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [6509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6783),
  [6511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [6525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [6529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [6545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [6547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [6551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [6557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [6567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [6569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [6573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [6575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [6597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 4, 0, 0),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [6601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 4, 0, 7),
  [6603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [6605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [6609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [6617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 5, 0, 48),
  [6619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [6623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6146),
  [6626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3599),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [6635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4639),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [6689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [6697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [6699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [6703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [6709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [6713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [6729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [6741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [6743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7720),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [6755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_base_type, 1, 0, 0),
  [6757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_base_type, 1, 0, 0),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7687),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [6765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6174),
  [6768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(594),
  [6771] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 8), SHIFT(4409),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [6777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [6779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [6783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [6787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [6801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [6817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [6821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [6823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [6827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [6845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [6847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [6849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [6853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [6879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [6883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [6893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [6897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [6931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [6935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4470),
  [6938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5227),
  [6941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [6945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [6949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [6955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [6959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [6981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 4, 0, 56),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [6985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [6987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [6991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(4409),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [7002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [7006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [7016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [7036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5986),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [7042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6140),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [7057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [7061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [7099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [7111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [7119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [7121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [7125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [7127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [7131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [7145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [7155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [7157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [7159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [7163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [7167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [7169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [7173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [7191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 3, 0, 56),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [7197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [7201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [7209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [7211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [7221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [7229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [7233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [7237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [7251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [7259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [7263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [7267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [7269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [7271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [7287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [7289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [7301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [7305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [7321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [7325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [7329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [7335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [7343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [7353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6151),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [7360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [7368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [7388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [7392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [7394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [7418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [7438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6159),
  [7441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [7443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [7445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [7449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [7455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [7459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [7477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6134),
  [7480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [7484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [7488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [7492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [7496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [7500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [7502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [7506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [7528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 5),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [7532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 1, 0, 6), REDUCE(sym_type_pattern, 1, 0, 6),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [7537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(2182),
  [7540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [7543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 2, 0, 0),
  [7545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 2, 0, 0),
  [7547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5951),
  [7550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [7554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [7558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [7564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [7574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [7594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_statement_conditions_repeat1, 2, 0, 0),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [7606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [7608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [7610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [7618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [7620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [7624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [7638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, 0, 0),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [7656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [7658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [7660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [7682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6153),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [7693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 3, 0, 77),
  [7695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 4, 0, 101),
  [7697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [7703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [7707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [7711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [7715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [7717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [7727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [7739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 48),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [7751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [7769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [7773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [7777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [7781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [7783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [7795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [7809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [7817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [7819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [7821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [7829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [7831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [7835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [7861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 4, 0, 5),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [7865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 24),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [7869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 7),
  [7871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 6, 0, 67),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [7877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 0),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [7883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6141),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [7888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6143),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [7893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6145),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [7902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6147),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [7907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, 0, 5),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [7911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6152),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [7922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6591),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6648),
  [7936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 0),
  [7938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 5),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [7942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 1, 0, 0),
  [7944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [7946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [7948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [7952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [7958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [7962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [7980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 3, 0, 0),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [7984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 4, 0, 0),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [7988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 4, 0, 5),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [7992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [7994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [7998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [8000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [8004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [8016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6017),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [8020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [8022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [8024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [8028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [8032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [8034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [8038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [8062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_alignment_clause, 2, 0, 0),
  [8064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declarator, 3, 0, 5),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [8068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 3, 0, 0),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [8076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_initializer, 3, 0, 0),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [8080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 4, 0, 0),
  [8082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [8084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [8086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [8090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [8094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [8096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [8100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [8118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [8120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [8122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [8126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [8130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [8132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [8136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [8154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [8158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2, 0, 0),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [8184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 3, 0, 0),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [8188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [8190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 1, 0, 0),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [8198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6188),
  [8200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7171),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [8206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [8208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [8210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [8214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [8218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [8220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [8224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [8250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [8252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [8318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [8320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [8324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [8326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [8330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [8342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [8352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [8354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [8356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [8370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [8396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [8398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [8402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [8406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [8408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [8438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 5), REDUCE(sym_type, 1, 0, 0),
  [8441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(606),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [8466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 2, 0, 0),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [8480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [8482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [8484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [8488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [8492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [8494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [8498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [8512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_header, 3, 0, 0),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [8582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6126),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [8605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [8607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [8609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [8613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [8617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [8619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [8623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [8639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [8641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_expression_clause, 2, 0, 0),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7579),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [8699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6189),
  [8701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [8705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_header, 4, 0, 6),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [8731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 2, 0, 0),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [8763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6127),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [8772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6132),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [8779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6136),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [8796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(6178),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6112),
  [8815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [8817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 7),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [8837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 5),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [8843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(2921),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7362),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6095),
  [8850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 5), SHIFT(5973),
  [8853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 5), SHIFT(6513),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [8862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [8864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6168),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [8870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enum_member_declaration, 1, 0, 0),
  [8872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5978),
  [8874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(2182),
  [8877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(2183),
  [8880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0),
  [8882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0),
  [8884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(5973),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [8889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6072),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [8893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5790),
  [8895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6067),
  [8897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(3728),
  [8900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(3705),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 5),
  [8937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0),
  [8939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0),
  [8941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(5845),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [8950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [8952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4422),
  [8955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5301),
  [8958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [8960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 1, 0, 6),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [8998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__lambda_expression_init_repeat1, 2, 0, 0),
  [9000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_expression_init_repeat1, 2, 0, 0), SHIFT_REPEAT(5939),
  [9003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__lambda_expression_init_repeat1, 2, 0, 0),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [9047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6077),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [9063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [9065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__lambda_expression_init_repeat1, 1, 0, 1),
  [9067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__lambda_expression_init_repeat1, 1, 0, 1),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [9075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7224),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [9085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 1, 0, 0),
  [9087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conversion_operator_declaration_repeat1, 1, 0, 0),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [9093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0),
  [9095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [9103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [9111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [9113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [9123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_using_directive_repeat1, 1, 0, 0), SHIFT(2182),
  [9126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_using_directive_repeat1, 1, 0, 0), SHIFT(2183),
  [9129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_using_directive_repeat1, 1, 0, 0),
  [9131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [9133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [9137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6162),
  [9139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [9141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [9143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [9145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [9147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5294),
  [9149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5291),
  [9151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [9153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [9155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6139),
  [9157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6175),
  [9159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7060),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [9163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7127),
  [9165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7328),
  [9167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6765),
  [9169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7257),
  [9171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7008),
  [9173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7545),
  [9175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7745),
  [9177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7418),
  [9179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7378),
  [9181] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [9185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [9191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [9193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [9197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [9199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7165),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [9207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6191),
  [9209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [9219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [9221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7335),
  [9223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [9225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [9227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 4, 0, 56),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [9233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_using_directive_repeat1, 2, 0, 0),
  [9235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_using_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(6168),
  [9238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [9240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7117),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [9246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7333),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6194),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [9258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7312),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [9264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6198),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7193),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [9276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7187),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [9280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7198),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7272),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [9288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_target_specifier, 2, 0, 0),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6169),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [9332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [9356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [9388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 5),
  [9390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [9398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(886),
  [9401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(3951),
  [9404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(3786),
  [9407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(6169),
  [9410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(752),
  [9413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0),
  [9415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3613),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [9420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 3, 0, 26),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [9428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 3, 0, 26),
  [9430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 3, 0, 7),
  [9432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [9434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 4, 0, 26),
  [9436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 3, 0, 7),
  [9438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 2, 0, 7),
  [9440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 6, 0, 84),
  [9442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 2, 0, 7),
  [9444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 4, 0, 26),
  [9446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 5, 0, 84),
  [9448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 3, 0, 26),
  [9450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 4, 0, 26),
  [9452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 3, 0, 7),
  [9454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 5, 0, 63),
  [9456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 5, 0, 63),
  [9458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 2, 0, 7),
  [9460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 5, 0, 63),
  [9462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 5, 0, 84),
  [9464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 4, 0, 63),
  [9466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 4, 0, 63),
  [9468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 6, 0, 84),
  [9470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 4, 0, 63),
  [9472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 5), SHIFT(2686),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [9477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [9482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 5), SHIFT(2756),
  [9485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 5), SHIFT(2801),
  [9488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat3, 2, 0, 0),
  [9490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat3, 2, 0, 0), SHIFT_REPEAT(3943),
  [9493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat3, 2, 0, 0), SHIFT_REPEAT(2921),
  [9496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat3, 2, 0, 0), SHIFT_REPEAT(5764),
  [9499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3670),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [9508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 3, 0, 62),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [9512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 2, 0, 0),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [9516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_base_list, 2, 0, 0), SHIFT(542),
  [9519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [9521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 3, 0, 0),
  [9523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 4, 0, 63),
  [9525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [9527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 2, 0, 7),
  [9529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(761),
  [9532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2, 0, 0),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [9536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 5), REDUCE(sym__simple_name, 1, 0, 0),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [9541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_declaration_initializer_repeat1, 2, 0, 0),
  [9543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(2921),
  [9546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_declaration_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5764),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [9551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 3, 0, 26),
  [9553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 2, 0, 0),
  [9555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 2, 0, 0),
  [9557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 2, 0, 0),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [9563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0),
  [9565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(542),
  [9568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 4, 0, 0),
  [9570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4010),
  [9573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 3, 0, 0),
  [9575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [9579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 1, 0, 0),
  [9581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 49),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [9585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 51),
  [9587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 4, 0, 62),
  [9589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [9595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 3, 0, 28),
  [9597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [9599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [9603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [9607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [9609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_into_clause, 2, 0, 0),
  [9611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 5, 0, 85),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [9619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 4, 0, 64),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [9623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 3, 0, 0),
  [9625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [9627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_clause, 1, 0, 0),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [9631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 25),
  [9633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [9639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6738),
  [9642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0),
  [9644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(912),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [9651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [9653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [9655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [9659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6769),
  [9661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6770),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [9665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [9669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 4, 0, 0),
  [9671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2, 0, 0),
  [9673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3556),
  [9676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [9684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 80),
  [9686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [9688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(6763),
  [9691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(6769),
  [9694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(6770),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [9699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [9701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_base_type, 1, 0, 0),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6696),
  [9705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [9711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4022),
  [9714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_clause_repeat1, 2, 0, 0),
  [9716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(7505),
  [9719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_declaration_initializer_repeat1, 1, 0, 0),
  [9721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat3, 1, 0, 0),
  [9723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 5, 0, 0),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [9727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [9729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [9733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [9735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 78),
  [9737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3235),
  [9739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [9741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [9747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7251),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [9757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [9759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7139),
  [9761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0),
  [9763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0), SHIFT_REPEAT(912),
  [9766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0), SHIFT_REPEAT(7071),
  [9769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [9771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat4, 2, 0, 0),
  [9773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat4, 2, 0, 0), SHIFT_REPEAT(6185),
  [9776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 0),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [9780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 7),
  [9782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0),
  [9784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0), SHIFT_REPEAT(912),
  [9787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0), SHIFT_REPEAT(7097),
  [9790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 4, 0, 0),
  [9792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [9794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6419),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [9801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 6),
  [9803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 5, 0, 26),
  [9805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 4, 0, 7),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [9811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [9813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [9815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [9821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 5, 0, 64),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [9831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 3, 0, 0),
  [9833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 5, 0, 26),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [9837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 0),
  [9839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 5, 0, 7),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6401),
  [9845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 34),
  [9847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 34),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [9857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [9861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [9865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0),
  [9867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(425),
  [9870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7444),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [9879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declaration_initializer, 4, 0, 100),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [9883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 4, 0, 7),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [9887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 5, 0, 63),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [9899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 2, 0, 0),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [9909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [9915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_constraint, 3, 0, 0),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [9921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 4, 0, 7),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [9933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 6, 0, 26),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [9937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 3, 0, 7),
  [9939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2, 0, 0),
  [9941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2, 0, 0), SHIFT_REPEAT(5861),
  [9944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 39),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [9948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [9952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 39),
  [9954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [9956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 6, 0, 63),
  [9958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 6, 0, 64),
  [9960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 6, 0, 63),
  [9962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 6, 0, 63),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [9968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 6, 0, 85),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [9974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 4, 0, 7),
  [9976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 6, 0, 63),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [9980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [9982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [9988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 8, 0, 84),
  [9990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 7, 0, 63),
  [9992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [9994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 7, 0, 84),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [10002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [10004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declaration_initializer, 3, 0, 76),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [10018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 4, 0, 26),
  [10022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 5, 0, 0),
  [10024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 7, 0, 85),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [10030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [10032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declaration_initializer, 2, 0, 58),
  [10034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4095),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6575),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [10045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_declaration_initializer, 7, 0, 84),
  [10047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_initializer, 5, 0, 26),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [10065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 5, 0, 28),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [10075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 4, 0, 56),
  [10077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_declaration_initializer, 4, 0, 28),
  [10079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_initializer, 5, 0, 26),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [10091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 5, 0, 83),
  [10093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 1, 0, 0),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [10107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 67),
  [10109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_initializer_repeat4, 1, 0, 0),
  [10111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 6, 0, 104),
  [10113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 0),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [10117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 0),
  [10119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, 1, 24),
  [10121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 50), SHIFT_REPEAT(2941),
  [10124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 50),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [10136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3974),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [10151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_declaration_initializer, 3, 0, 26),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [10155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_declaration_initializer, 2, 0, 7),
  [10157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string_content, 1, 0, 0),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [10165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 48),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [10171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [10173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6915),
  [10176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2, 0, 0),
  [10178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [10180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_using_variable_declarator, 1, 0, 5), REDUCE(sym_tuple_element, 2, 0, 24),
  [10183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declarator, 1, 0, 5),
  [10185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 1, 0, 0),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [10191] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 24), REDUCE(sym_tuple_element, 2, 0, 24), REDUCE(sym_declaration_expression, 2, 1, 24),
  [10195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 24),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [10201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 2, 0, 7),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [10205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal_content, 1, 0, 0),
  [10207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal_content, 1, 0, 0),
  [10209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, 0, 54),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [10217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 5, 0, 69),
  [10219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [10221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [10229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 1, 0, 5),
  [10231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 3, 0, 0),
  [10233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_declaration_initializer, 4, 0, 63),
  [10235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_statement_conditions_repeat1, 2, 0, 0), SHIFT_REPEAT(1807),
  [10238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [10242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, 0, 59),
  [10244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constructor_base_type, 2, 0, 6),
  [10246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 3, 0, 37),
  [10248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(306),
  [10251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [10255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_using_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(6122),
  [10258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_using_variable_declaration_repeat1, 2, 0, 0),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [10268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(763),
  [10271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2, 0, 0),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [10275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [10279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_statement_conditions_repeat1, 2, 0, 0), SHIFT_REPEAT(1545),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [10288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5776),
  [10291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [10295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [10305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5972),
  [10308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [10314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [10316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [10322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [10324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 3, 0, 48),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [10328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 4, 0, 67),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [10332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [10336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [10338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [10340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7474),
  [10342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 0),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6400),
  [10348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 3, 0, 8),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [10362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 25),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [10368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [10372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6402),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [10410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_initializer, 3, 0, 0),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [10414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 24), REDUCE(sym_tuple_element, 2, 0, 24),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7296),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [10427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3837),
  [10430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [10432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(571),
  [10435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [10449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(697),
  [10452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2, 0, 0),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [10472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declaration_initializer, 4, 0, 76),
  [10474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [10494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 2, 0, 24), REDUCE(sym_declaration_expression, 2, 1, 24),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7170),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [10521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 1, 0, 0),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6092),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [10537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__switch_expression_body_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [10540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__switch_expression_body_repeat1, 2, 0, 0),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [10544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1, 0, 0),
  [10546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(332),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [10565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_clause_repeat1, 1, 0, 0),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6063),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [10581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(637),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [10590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(294),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [10605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [10609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [10625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(5834),
  [10628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_attribute_repeat1, 2, 0, 0),
  [10630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [10632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 79), SHIFT_REPEAT(5930),
  [10635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 79),
  [10637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 6),
  [10639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [10641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [10643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [10649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__with_body_repeat1, 2, 0, 0), SHIFT_REPEAT(6123),
  [10652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__with_body_repeat1, 2, 0, 0),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [10658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declaration_initializer, 3, 0, 58),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6496),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [10696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5906),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [10740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [10742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6124),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [10748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5830),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [10770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_calling_convention_repeat1, 2, 0, 0), SHIFT_REPEAT(5944),
  [10773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_calling_convention_repeat1, 2, 0, 0),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [10787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [10803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [10807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 1, 0, 0),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [10813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(565),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [10824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat2, 2, 0, 0), SHIFT_REPEAT(4032),
  [10827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat2, 2, 0, 0),
  [10829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 79), SHIFT_REPEAT(5973),
  [10832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 79),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [10848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 0),
  [10850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 6),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [10854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 5),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [10866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5802),
  [10869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2, 0, 0),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [10873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_verbatim_string_content, 1, 0, 0),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [10877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declaration, 3, 0, 6),
  [10879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [10881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [10883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [10889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 1, 0, 0),
  [10891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declaration_initializer, 5, 0, 100),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [10895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 4, 0, 48),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [10899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_filter_clause, 4, 0, 0),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [10903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [10907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0), SHIFT_REPEAT(6124),
  [10910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0),
  [10912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5962),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [10917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [10927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [10929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_raw_string_content, 1, 0, 0),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [10935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declaration, 2, 0, 6),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [10943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [10945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [10947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delegate_declaration_initializer, 4, 0, 54),
  [10949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [10953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 2, 0, 0),
  [10955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [10957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 26),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [10961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [10963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7815),
  [10965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [10969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7749),
  [10971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delegate_declaration_initializer, 6, 0, 104),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [10979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delegate_declaration_initializer, 5, 0, 69),
  [10981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 7),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [10985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 4, 0, 0),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [10991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 1, 0, 0),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [10995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7693),
  [10997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delegate_declaration_initializer, 6, 0, 105),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [11005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 6, 0, 93),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [11009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 4, 0, 49),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [11019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7697),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [11029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_declaration_initializer, 3, 0, 7),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6010),
  [11035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [11039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [11043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delegate_declaration_initializer, 7, 0, 134),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [11057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 2, 0, 0),
  [11059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 4, 0, 51),
  [11061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3, 0, 25),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [11065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delegate_declaration_initializer, 5, 0, 83),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [11071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3, 0, 0),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [11075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_declaration_initializer, 5, 0, 63),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [11083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7492),
  [11085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7681),
  [11087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0),
  [11089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7711),
  [11091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 60),
  [11093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 5),
  [11095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 5, 0, 74),
  [11097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_declaration_initializer, 4, 0, 26),
  [11099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 5, 0, 56),
  [11101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 2, 0, 24),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [11109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [11111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7466),
  [11113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 7),
  [11115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 5),
  [11117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 3, 0, 0),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [11125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_expression_init, 2, 0, 14),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [11151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 5, 0, 0),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [11159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 5, 0, 93),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7813),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [11175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7371),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [11187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_parameters, 1, 0, 0),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [11193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [11201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [11223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 4, 0, 0),
  [11225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 1, 0, 6),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [11229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [11235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 2, 0, 8),
  [11237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [11245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7654),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [11263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [11269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [11273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [11277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_expression_init, 4, 0, 65),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [11295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7722),
  [11299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [11301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7806),
  [11303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7740),
  [11305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_expression_init, 3, 0, 45),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [11319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [11321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 74),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7809),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [11365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_expression_init, 1, 0, 3),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7805),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [11409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 2, 0, 0),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6432),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [11431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7734),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7744),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [11447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 5, 0, 0),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [11451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_expression_init, 2, 0, 21),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [11463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_expression_init, 3, 0, 46),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [11467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [11507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [11549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [11637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 4, 0, 0),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7808),
  [11657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_attribute_list, 5, 0, 93),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [11667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 5, 0, 93),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [11691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [11703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 3, 0, 0),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [11735] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6605),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [11765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enum_member_declaration, 2, 0, 0),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7160),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [11781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 5, 0, 93),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [11797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_format_clause, 2, 0, 0),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [11803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 4, 0, 74),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [11813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 93),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [11819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7460),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [11845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [11853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 4, 0, 74),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [11861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 4, 0, 74),
  [11863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [11867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_attribute_list, 4, 0, 74),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7772),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7776),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [11925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_nullable, 3, 0, 0),
  [11927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 5, 0, 0),
  [11929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_endregion, 2, 0, 0),
  [11931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_error, 3, 0, 0),
  [11933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 4, 0, 0),
  [11935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 15, 0, 0),
  [11937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_region, 3, 0, 22),
  [11939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 6, 0, 0),
  [11941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_define, 3, 0, 0),
  [11943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_endregion, 3, 0, 22),
  [11945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_warning, 3, 0, 0),
  [11947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 3, 0, 0),
  [11949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 14, 0, 0),
  [11951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_undef, 3, 0, 0),
  [11953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 0),
  [11955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_region, 2, 0, 0),
  [11957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_nullable, 4, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__optional_semi = 0,
  ts_external_token_interpolation_regular_start = 1,
  ts_external_token_interpolation_verbatim_start = 2,
  ts_external_token_interpolation_raw_start = 3,
  ts_external_token_interpolation_start_quote = 4,
  ts_external_token_interpolation_end_quote = 5,
  ts_external_token_interpolation_open_brace = 6,
  ts_external_token_interpolation_close_brace = 7,
  ts_external_token_interpolation_string_content = 8,
  ts_external_token_raw_string_start = 9,
  ts_external_token_raw_string_end = 10,
  ts_external_token_raw_string_content = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__optional_semi] = sym__optional_semi,
  [ts_external_token_interpolation_regular_start] = sym_interpolation_regular_start,
  [ts_external_token_interpolation_verbatim_start] = sym_interpolation_verbatim_start,
  [ts_external_token_interpolation_raw_start] = sym_interpolation_raw_start,
  [ts_external_token_interpolation_start_quote] = sym_interpolation_start_quote,
  [ts_external_token_interpolation_end_quote] = sym_interpolation_end_quote,
  [ts_external_token_interpolation_open_brace] = sym_interpolation_open_brace,
  [ts_external_token_interpolation_close_brace] = sym_interpolation_close_brace,
  [ts_external_token_interpolation_string_content] = sym_interpolation_string_content,
  [ts_external_token_raw_string_start] = sym_raw_string_start,
  [ts_external_token_raw_string_end] = sym_raw_string_end,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[10][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__optional_semi] = true,
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_interpolation_start_quote] = true,
    [ts_external_token_interpolation_end_quote] = true,
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_close_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
    [ts_external_token_raw_string_start] = true,
    [ts_external_token_raw_string_end] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_raw_string_start] = true,
  },
  [3] = {
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_interpolation_close_brace] = true,
    [ts_external_token_raw_string_start] = true,
  },
  [4] = {
    [ts_external_token_interpolation_close_brace] = true,
  },
  [5] = {
    [ts_external_token_interpolation_end_quote] = true,
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
  },
  [6] = {
    [ts_external_token__optional_semi] = true,
  },
  [7] = {
    [ts_external_token_raw_string_content] = true,
  },
  [8] = {
    [ts_external_token_interpolation_start_quote] = true,
  },
  [9] = {
    [ts_external_token_raw_string_end] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_c_sharp_external_scanner_create(void);
void tree_sitter_c_sharp_external_scanner_destroy(void *);
bool tree_sitter_c_sharp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_c_sharp_external_scanner_serialize(void *, char *);
void tree_sitter_c_sharp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_c_sharp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier_token,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_c_sharp_external_scanner_create,
      tree_sitter_c_sharp_external_scanner_destroy,
      tree_sitter_c_sharp_external_scanner_scan,
      tree_sitter_c_sharp_external_scanner_serialize,
      tree_sitter_c_sharp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
